#include <stdio.h>
#include "helpbp.h"




/* ***********************************************************************
 *
 * ***********************************************************************
 */
static const char helpdata1[]="\
This is the help file for the fedit tool.\n\
Klaus Koepernik December 2001 \n\
\n\
M<MAIN MENU> \n\
 \n\
B<BAND-PLOT MENU> \n\
 \n\
This menu serves to plot the band structure. \n\
 \n\
=H1 General remarks \n\
 \n\
The U<fplo> program can create bandstructure data in the file U<+band>\n\
and the band weights in U<+bweights>. This data can be used in any\n\
external ploting program. However, some programs have problems with\n\
large number of data. Thus, we implemented a simple tool for plotting \n\
the band structure: U<bandplot>.\n\
The first call of this program creates an input file U<=.bp> \n\
(if not yet existing).\n\
U<Fedit> allows to edit a small number of options \n\
in U<=.bp>, determining the final picture. \n\
A subsequent call to U<bandplot> hopefully creates a postscript\n\
file containing the picture.\n\
U<bandplot> needs a second file called U<+points>, which is created\n\
by U<fplo>. If multiple band structures should be plotted in the same\n\
picture, it is nesseccary, that all band structures are calculated along \n\
the same symmetry lines, of course. U<bandplot> will use the file\n\
U<+points>, which is located in the directory of the first band structure\n\
data file (usually U<+band>) given in the file list \n\
(see section B<BAND STRUCTURE> below).\n\
\n\
=H1 Problems \n\
 \n\
Any bugs which may be done by human beings.\n\
 \n\
 \n\
=H1 Menu bar \n\
 \n\
The menu bar contains the following entries \n\
 \n\
=H2 [] \n\
Invoked by the space bar, it supplies  functions. \n\
B<Recreate:> will recreate the default data. \n\
B<Restore :> will restore the original data (on U<fedit> startup). \n\
=H2 Extern edit (expert mode)\n\
It calls an external editor to edit the U<=.bp> file directly (in \n\
temporary directory). \n\
The external editor may be set by a command line option \n\
=H2 Quit/save \n\
Quit with saving, you will be asked to save the U<=.bp> file. \n\
This leaves the program. \n\
=H2 Exit/discard (expert mode)\n\
Exit without saving. All changes will be lost! \n\
(When calling B<plot> the file is saved temporarily.) \n\
=H2 Plot \n\
This runs the U<bandplot> program to create the postscript files. \n\
The output may be shown in a viewer. \n\
=H2 Gv \n\
Calls a postscript viewer (default U<gv>), if the viewer is a valid \n\
executable.\n\
\n\
Hint: If you use U<gv>, you can set an option in U<gv>,\n\
which redisplays the picture if it is changed. \n\
(This should be B<watch file>)\n\
=H2 Help \n\
This screen. \n\
 \n\
=H1 GENERAL \n\
 \n\
This section gives the switches for the general layout of the \n\
picture. \n\
 \n\
=H2 Plot type \n\
This calls a select box, where you select the bandplot type:\n\
band structure or bandweights.\n\
=H2 Lower energy bound \n\
Gives the world coordinates of the energy axis.\n\
If lower bound is larger than upper bound autoscaling takes place.\n\
=H2 Upper energy bound \n\
See above\n\
=H2 Title \n\
Gives the title of the picture.\n\
The String can contain  special characters.\n\
=H+ $~: next character is Greek (Symbol font)\n\
 $_: go to next subscript level\n\
 $^: go to next superscript level\n\
 $.: go to normal level\n\
=H2 yaxis title\n\
The string defines the title of the energy axis.\n\
=H2 Auto x-labels \n\
The boolean switch decides, weither the x-axis labels (special \n\
k-points) should be plotted. The labels are in file U<+points> \n\
created by U<fplo>.\n\
=H2 Display legend\n\
Display legend or not.\n\
=H2  Relativ position X and Y\n\
Says where the upper left corner of the legend is placed.\n\
The numbers are measured relative to the frame (in percent).\n\
\n\
=H1 POSTSCRIPT\n\
\n\
=H2 Out file prefix\n\
The names of the created postscript files start with this string.\n\
A plot type specific string is appended to the prefix to create the \n\
full file name.\n\
=H+ B<plot type bands:> PREFIX.ps\n\
    B<plot type bandweights:> PREFIX_w.ps\n\
=H2 Viewer\n";
static const char helpdata2[]="\
Give here a valid path to a postscript viewer.\n\
This functionality is fragil. U<Fedit> will not check if the viewer could\n\
be executed properly.\n\
\n\
=H1 BAND STRUCTURE \n\
 \n\
=H2 number of files to load\n\
The program U<bandplot> allows to plot more than one bandstructure\n\
in one picture. (But only one bandweights-plot per picture.)\n\
You specify the number of files and give the file-path to the different\n\
data files additionally the string for the legend.\n\
U<bandplot> can read the files from different directories.\n\
Usually the data are stored in U<+band> . \n\
\n\
B<Example:>\n\
If the calculations are in different directories (which is \n\
strongly recommended) than the file list would look like\n\
\n\
  file                         legend\n\
------------------------------------------\n\
(1):  ./a0=3.10/+band        a$_0$.=3.10\n\
(2):  ./a0=3.20/+band        a$_0$.=3.20\n\
\n\
B<CAUTION:> \n\
If plot type is B<bandweights>, the file U<+bweights> in the current\n\
directory is used. The file settings are only for plot type B<bands>!\n\
\n\
=H1 BANDWEIGHTS\n\
\n\
=H2 max weights-radius \n\
The band weights are net weights. Each data point in the picture\n\
represents a point of the bandstructure. The addmixture of a special\n\
orbital to this wavefunction is a number between 0. and 1.\n\
and is marked by a filled circle of a certain radius.\n\
This entry here gives the radius corresponding to 100% addmixture.\n\
The radius of the circle in the legend displayes 100%.\n\
=H2 State to plot\n\
This is a number  of the state to be plotted.\n\
The counting is in the order \n\
=H+ number of sorts\n\
 l-quantum numbers(including main quantum numbers 1s2s2p3s3p...)\n\
 m-quantum-nunbers (-l,-l+1,..0,l-1,l)\n\
=H- The head of the file U<+bweights> contains a description of the\n\
orbital order.\n\
B<Example:>\n\
An Al(3s3p3d) basis would give number 6 for the Al3d-1 state!\n\
\n\
\n\
";

void helpbp(void)
{
  FILE *FH;
  FH=fopen(DEFAULTHELPFILE,"w");
  
  
  (void)fprintf(FH,"%s",helpdata1);
  (void)fprintf(FH,"%s",helpdata2);

  (void)fclose(FH);
}

