/************************************************************************
 *
 * graphic package for FPLO
 * (C) Klaus Koepernik April '98
 *
 * **********************************************************************
 */
#ifndef _PLINE_H_
#define _PLINE_H_

#include <stdio.h>
#include "main.h"

extern void pline(FILE *FH,long x0,long y0,long x1,long y1
      ,double width,char *dash,double grayscale);
extern void wctovc(const VIEWPORT *vp,const WORLD *w,double x,double y,long *a,long *b
       ,long typ);
extern void drawxyr(FILE *FH,VIEWPORT *vp,WORLD *w,double *x,double *f
		    ,double *r,long n,const double color[3],long typ,long filled);

extern long inclip(long a,long b,VIEWPORT *vp);
extern void txtlen(const char *txt,long *i0,long *i1);
extern char *strposprotect(const char *src,const char delimit); 
extern void split10(double d,double *m,long *e);
extern void autotics(FILE *FH,VIEWPORT *vp,WORLD *world,char *xaxis,long typ
		     ,double ticmark_scale
		     ,double ticmark_subscript_scale
		     ,double title_scale
		     ,double title_subscript_scale
		     ,double ticlinewidth
		     ,long display_yticmarks,long yticmarkdigits
		     ,double yaxis_offsetx,double yaxis_offsety
		     ,double ylabel_offsetx);
extern void legend(FILE *FH,VIEWPORT *vp,long x0,long y0,long nleg,char **leg
		   ,const double color[][3],long colmax,long mspin
		   ,double leg_scale
		   ,double subscript_scale
		   ,double framelinewidth,long display_legendframe
		   ,double vertspacing);
/* extern long ReadQStringProtected(char **dest,char **txt); */
/* extern long checkversion(const char *version,const char *actual); */
extern void hess(double x0,double y0,double x1,double y1,double *n);
extern long clipline(const VIEWPORT *vp,long a0,long b0,long a1,long b1,long *p0x,long *p0y
	     ,long *p1x,long *p1y);
extern void drawxy(FILE *FH,const VIEWPORT *vp,const WORLD *w
		   ,const double *x,const double *f,long n,const double *color
		   ,long linetyp,long linewidth,long typ);

extern void drawxyd(FILE *FH,VIEWPORT *vp,WORLD *w,double *x,double *y
		    ,long *f,long nk,long ne,const double color[3],long typ);
extern void formtext(FILE *FH,long x,long y,char *txt,long angle,long fontsize
		     ,long just,char *command,double factor) ;

extern void bwlegend(FILE *FH,VIEWPORT *vp,long x0,long y0,long nleg,char **leg
		     ,const double color[][3],const long *coltyp
		     ,const long *orb_fill,double dr
		     ,double leg_scale,double subscript_scale
		     ,double framelinewidth
		     ,long display_legendframe,double vertspacing);

#endif /* _PLINE_H_ */
/* EOF */
