/* @(#)CalcParseInternal.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _CALCPARSEINTERNAL_H
#define _CALCPARSEINTERNAL_H 1

namespace Functions{
  enum Names{Sqrt=0,Cos=1,Sin=2,Tan=3,Cot=4,Acos=5,Asin=6,Atan=7,
	     Abs=8,Exp=9,Log=10,
	     Atan2=11,Min=12,Max=13,Sign=14,Theta=15};
  
  typedef double(*tfFUNC_DeqD)(double) ;
  typedef double(*tfFUNC_DeqD_D)(double,double) ;
  
  double pow2(double a, double b);
  double cot(double a);
  double dmax2(double a, double b);
  double dmin2(double a, double b);
  double sign2(double a, double b);
  double theta(double a);
  
  struct tsfuncdef{
    long type;
    Names name;
    tfFUNC_DeqD fp1;
    tfFUNC_DeqD_D fp2;
  };
  
  extern const struct tsfuncdef funcs[];
  extern const int MAXFUNS;

}


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _CALCPARSEINTERNAL_H */

