/* @(#)SpaceGroupData.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SPACEGROUPDATA_HH
#define _SPACEGROUPDATA_HH 1

class FMatrix;

namespace SpaceGroup{

  
  class Data{
  public:
    enum CrystalSystem{None=0,Triclinic=1,Monoclinic=2,Orthorhombic=3,
		       Tetragonal=4,Trigonal=5,Rhombohedral=6,Hexagonal=7,Cubic=8};
    enum BravaisLattice{Unkown=0,Simple=1,BodyCentered=2,FaceCentered=3,
			CBaseCentered=4,ABaseCentered=5,BBaseCentered=6,
			BRhombohedral=7};
    
    static String HallFromIT(const String &it);
    static String defaultSetting(const String num);
    static const long *deltaToDefaultT8(const String it);
    static String HMFromIT(const String it);
    static String settingByIndex(const String it,long settingnumber);

    
    static const char *crystalSystemName(CrystalSystem c){return pcrystalsystemname[c];}
    static const char *bravaisLatticeName(BravaisLattice b){return pbravaislatticename[b];}

    static FMatrix bravaisMatrix(BravaisLattice b);

  private:
    typedef struct tsithmhall{
      const char *IT;
      bool  defaultsetting;
      long  deltatodefaultt8[3];
      const char *HM;
      const char *Hall;
    }tsITHMHall;
    static tsITHMHall ITHMHall[];
    static long noOfITHMHall;
    static const char *pcrystalsystemname[];
    static const char *pbravaislatticename[];
    
  };
}

#endif /* _SPACEGROUPDATA_HH */
