/* @(#)Assorted.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ASSORTED_H
#define _ASSORTED_H 1


#include <sys/types.h>
#include <stdio.h>
#include "FString.hh"
#include "Except.hh"


enum FileExistence{DoesNotExist=0,RegularFile=1,Directory=2,SomethingElse=3
		   ,SymLink=4};


// #ifdef	__cplusplus
// extern "C" {
// #endif
  
  extern void die(const String &msg="",int exitcode=1);
  extern void die(const Except &ex,int exitcode=1);
  extern int mktmpFileName(String &templat);
  extern FILE *openforread(String const &fname);
  extern FILE *openforwrite(String const &fname,const char *mode="");
  extern FILE *opentempfile(String &tempname,const char *mode);
  extern void backUp(String const &file1,String const &file2);
  extern void createDirectory(String const &dirname,long prot);
  extern void removeDirectoryNonRecursive(String const &dirname,long prot);
  extern FileExistence pathExistence(String const &pathname);
  extern bool getLine(FILE *FH,String &line);
  extern void removeFile(String const &fname);
  extern void chDir(String const &fname);
  extern int saveCurrentDir();
  extern void restoreCurrentDir(int fd);
  extern int systemCall(String const &command);
  extern time_t modificationDate(String const &pathname);
  extern void splitPath(String &dir,String &file,String const &path);
  extern int mySystem(const String &cmd,const StringList &args,
		       String &sstdout,String &ssterr);
  extern void expandFileName(String &fname);
  extern String expandAndCreatePath(const String &which);


// #ifdef	__cplusplus
// }
// #endif


#endif /* _ASSORTED_H */

