/* @(#)App.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _APPXX_H
#define _APPXX_H 1


//#include "debugxx.h"
#include "FString.hh"
#include "Screen.hh"
#include "Except.hh"


class Screen;
class SObject;
class App;



enum ExecStatus{ Discard=0,Accept=1,Abort=2};


/* ***********************************************************************
 *
 * ***********************************************************************
 */

class SObject
{
 public:
  SObject(App *,SObject*,String const &cn="SObject");
  virtual ~SObject();
  //
  //
  virtual void aboutToShow(){};
  virtual ExecStatus exec(){return Accept;};
  virtual long notify(SObject *caller,String action,String data1
		      ,String data2=""){return 1;};
  //
  virtual void onResize(){};
  App *application()const {return app;};
  //
  String const &className() const {return classname;};
  //
  SObject *parent()const {return pparent;};
  //
  virtual void show()=0;
  //
 protected:
  virtual void paint()=0;
  //
 protected:
  String const classname;
  App *app;
  SObject *pparent;
};






/* ***********************************************************************
 *
 * ***********************************************************************
 */

class App
{
 public:
  App(int argc=0,char *argv[]=0);
  virtual ~App();
  //
  long exec();
  void quit(TerminateExcept:: ExitStatus st=TerminateExcept::ExitNormal);
  Event getKey();
  String const & helpFile()const {return helpfile;};
  //
  //
  //----------------------------------------------------
 protected:
  //
  virtual void usage();
  virtual long onArgument(String const &opt,StringList const &sl);
  void scanopts(int argc,char *argv[]);
  //
  virtual void abort(TerminateExcept::ExitStatus rv=
		     TerminateExcept::ExitEmergencyAbort);
  //
  void setMainWidget(SObject *);
  //
  //----------------------------------------------------
 public:
  //
  //
  //----------------------------------------------------
 public:
  Screen *s;
 protected:
  String appname;
  String apppath;
  String helpfile;
 public://todo revert to protected
  long colorlayout;
  long colorscheme;
  long acs;
  long reverse;
  long screendebug;
  long dumpmode;
  long ppipein;
  String cwdir;
  //----------------------------------------------------
 private:
  //
  const char *classname;
  //SOArray objects;
  SObject *mainwidget;
  
  
  
  //
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _APPXX_H */

