/* @(#)BaseItemDef.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _BASEITEMDEF_H
#define _BASEITEMDEF_H 1



#include "debugxx.h"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class BaseItemDef
{
public:
  BaseItemDef(){HIER("BaseItemDef()");};
  BaseItemDef(String const &s){ps=s;HIER("BaseItemDef(String const&)");};
  //
  virtual String text()const {return ps;};
  //
protected:
  String ps;
};
  


/* ***********************************************************************
 *
 * ***********************************************************************
 */
class SingleItemDef:public BaseItemDef
{
public:
  SingleItemDef(String const &s):BaseItemDef(s){HIER("SingleItemDef()");};
  //
  String text()const {return "SingleItemDef::text()"+ps;};
  //
private:
};
  

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class BaseItemDefArray
{
public:
  BaseItemDefArray():array(0),internalsize(0),psize(0){};
  //
  ~BaseItemDefArray(){ clear();  };
  //
  BaseItemDefArray const& operator=(BaseItemDefArray const &other){
    
    clear();
    

    grow(other.psize);
    for(long i=0;i<other.psize;i++){
      array[i]=other.array[i];
      //*(array[i])=*(other.array[i]);
    }
    psize=other.psize;
    
    return *this;
  };
  //
  void clear(){
    for(long i=0;i<psize;i++){
      if(array[i]) delete array[i];
    }
    delete [] array;array=0;
    psize=0;
    internalsize=0;
  };
  //
  BaseItemDef *operator[](long i){return array[i];};
  long size() const {return psize;}
  //
  BaseItemDefArray &append(BaseItemDef *);
  //
private:
  void grow(long size);
  //
private:
  BaseItemDef **array;
  long internalsize;
  long psize;
};





#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _BASEITEMDEF_H */

