/* @(#)Dump.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _DUMPXX_H
#define _DUMPXX_H 1

#include "FString.hh"

class Dump
{
public:
  Dump(long dumpmode,long color_scheme,long colored,long llines,long ccolumns);
  ~Dump();
  //
  long screendumpOn()const ;
  void dumpScreen();
  String lastScreendumpFile()const;
  void initDumpBuffer(long liness,long columnss);
  //
  void dump_move(int xx,int yy);
  void dump_addstr(String const &str);
  void dump_addch(char  ch);
  void dump_clrtoeol();
  void dump_attron(int at);
  void dump_attroff(int at);
  void dump_attrset(int at);
  void dump_scrollUpDn(long top,long bottom,long n);
  //
  void startBuffering(){pbuffering=1;};
  void stopBuffering(){pbuffering=0;};
  //
  char charAt(long x,long y)const {return buffer[x+y*rows];};
  long attrAt(long x,long y)const {return attr[x+y*rows];};
  long colored()const{return pcolored;};
  //
private:
  //
  void dumpSetColors(long color_scheme);
  void setDumpFile();
  void dumpPSHeader(FILE *FH,double scale,double pheight)const;
  void dumpPSFooter(FILE *FH) const;
  String escapePSChar(char ch) const;
  //
private:
  long pdumpmode;		/* NO_DUMP, ASCII_DUMP, ... */
  String file;			/* current dump file name */
  long filenr;			/* a running file number, to avoid 
				   overwriting of previous dumps */
  
  char *buffer;			/* the buffer reflecting the screen */
  long *attr;			/* the attributes reflecting the screen */
  long rows,cols;		/* buffer dimensions */
  long x,y;			/* current coordinates */
  long cattr;			/* current attributes */
  long pcolored;		/* colored layout ? */

  //
  double const *dump_fgn ;
  double const *dump_bgn ;
  double const *dump_fgmh;
  double const *dump_bgmh;
  double const *dump_fges;
  double const *dump_bges;
  double const *dump_fgeh;
  double const *dump_bgeh;
  double const *dump_fgehi;
  double const *dump_bgehi;
  //
  double rimfactor;
  //
  long pbuffering;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _DUMPXX_H */

