/* @(#)Fedit.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _FEDITXX_H
#define _FEDITXX_H 1

#include  "App.hh"
#include  "Parser.hh"
#include  "ParseTable.hh" 
#include  "ScreenDefs.hh"



class Form;

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class Fedit: public App
{
 public:

  enum UpdateStatus{UpdateStatusReady=1,UpdateStatusChanged=2};
  enum IOWorkMode{IOOriginal=0,IOTmp=1,IOBak=2};
  enum VersionStatus{VCheckOK=1,VCheckWrongVersion=2};

  Fedit(int argc,char *argv[]);
  ~Fedit();

  void setupParseTables();
  long readFiles(IOWorkMode ioflag,long stoponvcheck=1);
  void writeFiles(Form *form,IOWorkMode ioflag);
  void readScreenDefs();
  String runProgram(String const &program,IOWorkMode ioflag,long report
		    ,long &exitcode);
  VersionStatus VersionCheck(Parser &par,String const &fname,String &mesg);

  String workPath(String const &path,IOWorkMode ioflag,long inclcwd=1) const;

  static void setFileStatus(Parser &parser,UpdateStatus status,String const &flag);


 protected:
  long onArgument(String const &opt,StringList const &sl);
 private:
  //
  void usage();
  //
  void loadFeditParseTable();
  //
  void readFieldScreenDefs(FieldItemDef *fid,Dobj &de,long &ie0
			   ,String const &fname);
  void readCompoundScreenDefs(CompoundItemDef *cid,Dobj &de,long &ie0
			      ,String const &fname);
  //
  //
  // private: todo: revert private
 public:


  long expertmode;
  long newfeditfile;
  String editor;
  String feditfile;
  String pprogram;
  String mainversion;
  String subversion;
  String release;
  String platform;
  String fullexecname;
  String tmpdir;
  ScreenDefs screens;
  Parser fedit_pc; 
  ParseTables parsetables; 
};



#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _FEDITXX_H */

