/* @(#)Form.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _FORMXX_H
#define _FORMXX_H 1



#include "Page.hh"
#include "Fedit.hh"





/* ***********************************************************************
 *
 * ***********************************************************************
 */



class Form:public Page
{
public:
  
  
  Form(App *a,String const &title="Form",SObject*p=0
       ,String const &cn="Form"):Page(a,title,p,cn),pcontentchanged(0)
    ,bid(0),biddata(0){};
  //
  friend class SelectGroupEditItem;
  friend class CounterEditItem;
  friend class EditItem;
  friend class CompoundElementEditItem;
  //
  void resetContentChanged(){pcontentchanged=0;};
  virtual long contentChanged();
  long testContent(long globaltest=0);
  //
  void setCompoundItemDef(CompoundItemDef *b,Dobj *d){bid=b;biddata=d;};
  void loadCompoundItems(String const &screenname);
  
protected:
  void errorScreen(String const &title,String const &msg,long stop=1);
  virtual long onKeyEvent(Event e);
  virtual void exitAction();
  
  long searchObjectOnHotkey(String const &keysequence,long latestmatch);
  
  
  long editObjects(String const &keysequence);
  
  virtual void onSearchSelect(long selctedobject);

  void execRegisteredHooks();

  virtual long notify(SObject *caller,
		      String action,String data1
		      ,String data2="");
  
protected:
  long pcontentchanged;
  StringList pregisteredhooks;
  CompoundItemDef *bid;
  Dobj *biddata;
};




/* ***********************************************************************
 *
 * ***********************************************************************
 */

class SubMenuForm:public Form
{
public:
  SubMenuForm(App *a,String const &title="Sub Menu Form",SObject*p=0
	      ,String const &cn="SubMenuForm");
  
protected:
  //
  void runProgram(String const &program,Fedit::IOWorkMode ioflag,long report=0);
  //
  virtual void aboutToShow();
  virtual void loadItems(String const &screenname);
  //
  virtual long notify(SObject *caller,
		      String action,String data1
		      ,String data2="");
  //
protected:
  virtual void quitAction();
  virtual void exitSymmetryAction();
  virtual void viewerAction(String const &filename);
  virtual void externEditAction();
  virtual void restoreAction();
  virtual void rebuildAction(String const &filename);
  virtual void fploRunAction(String const &update="");
  virtual void runAction(String const &options);
  virtual void submenuAction(String const &);
  
  //
  long globalTestContent();
  //
private:
  Fedit *feditApp()const;
  
protected:
  Fedit *fapp;
  
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */

class MainForm:public SubMenuForm
{
public:
  MainForm(App *a,String const &title="Main Form",SObject*p=0
	   ,String const &cn="MainForm")
    :SubMenuForm(a,title,p,cn){};
  //
protected:
  virtual void onExec();
  //
};





#ifdef	__cplusplus
extern "C" {
#endif
  
#ifdef	__cplusplus
}
#endif


#endif /* _FORMXX_H */

