/* @(#)LineEdit.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _LINEEDIT_H
#define _LINEEDIT_H 1


#include "App.hh"


class String;




/* ***********************************************************************
 *
 * ***********************************************************************
 */

class LineEdit: public SObject
{
 public:
  LineEdit(App *a,long x,long y,long bl,SObject *p
	   ,String const &cn="LineEdit");
  ~LineEdit();
  //
  void setText(String const &t){buffer=t;save=t;};
  String const& text()const {return buffer;};
  //
  virtual void show(){paint();};
  virtual ExecStatus exec();
  //
 protected:
  virtual void paint();
  virtual void backAction(Event&){};
  long yPos();
 private:
  long onKeyEvent(Event );
  void paintBuffer();

 protected:
  long xpos;
  long ypos;
  long boxlength;
  String buffer;
  String save;
  String emptybuffer;
  long first;
  long stringpos;
  long cursorpos;
};



/* ***********************************************************************
 *
 * ***********************************************************************
 */

class PageSearchLineEdit: public LineEdit
{
 public:
  PageSearchLineEdit(App *a,long x,long y,long bl,SObject *p
		     ,String const &cn="PageSearchLineEdit")
  :LineEdit(a,x,y,bl,p,cn)   {};

 protected:
  virtual void backAction(Event&);
  
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _LINEEDIT_H */

