/* @(#)Menu.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _MENUXX_H
#define _MENUXX_H 1



#include "FString.hh"
#include "PtrArray.hh"
#include "Screen.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */

class Page;
class Menu;
class Screen;


class MenuItem
{
 public:
  MenuItem(String const &s,String const &a,String const &d); 
  MenuItem(Menu *p,String const &s,String const &a,String const &d); 
  //
  //
  friend class Menu;
  friend class AltMenu;
  //
private:
  //
  void init(String const &c);
  //
private:
  String classname;
  Menu *parent;
  String hotkey;
  String screenrep;
  String markuprep;
  String pdata;
  long separator;
  String paction;
  friend MyDebug operator<<(MyDebug dbg, const MenuItem &m);
};


/* ***********************************************************************
 *
 * ***********************************************************************
 */

class Menu
{
 public:
  Menu(Page *p=0):page(p){};
  virtual ~Menu(){  clear();};
  //
  //
  virtual void paint(Screen *s); 
  virtual long onKeyEvent(Event e);
  //
  //
  void addMenuItem(MenuItem *mi){menuitems.append(mi);};
  //
  //
  void clear();
  //
protected:
  PtrArray<MenuItem> menuitems;
  Page *page;
  friend MyDebug operator<<(MyDebug dbg, const Menu &m);
};


/* ***********************************************************************
 *
 * ***********************************************************************
 */
class AltMenu : public Menu
{
public:
  AltMenu(Page *p=0):Menu(p){};
  //
  virtual void exec();
  //
private:
  virtual void paint(Screen *s); 
  //
private:
  long amenuloop;
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
inline MyDebug operator<<(MyDebug dbg, const MenuItem &m)
{
  dbg<<m.classname<<m.hotkey<<m.screenrep<<m.markuprep<<m.pdata
     <<m.separator<<m.paction;
  return dbg;

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
inline MyDebug operator<<(MyDebug dbg, const Menu &m)
{
  dbg<<m.menuitems;
  return dbg;

}



#ifdef	__cplusplus
extern "C" {
#endif
  
#ifdef	__cplusplus
}
#endif


#endif /* _MENUXX_H */

