/* @(#)ParseTable.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _PARSETABLEXX_H
#define _PARSETABLEXX_H 1

#include <sys/types.h>


#include "FString.hh"
#include "Parser.hh"


/* ***********************************************************************
 * keep severals files under control
 * ***********************************************************************
 */

class ParseTables
{
  public:
  ParseTables();
  ~ParseTables();
  //
  //
  String const &fileName(long)const;
  Parser  &parser(long)const;
  time_t modificationDate(long)const;
  void setModificationDate(long,time_t);
  //
  //
  long size() const{return psize;};
  long readIn() const{return preadin;};
  //
  void setup(StringList const &);
  //
  void cleanupTables();
  //
  //
  long findTable(String const &)const;
  //
 private:
  String classname;
  long psize;
  long preadin;

  //
  class table
  {
  public:
    table():lastmod(0){};
      //
      String  filename;
      Parser parser;
      time_t lastmod;
  };
  //
  table *array;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _PARSETABLEXX_H */

