/* @(#)Screen.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SCREENXX_H
#define _SCREENXX_H 1


#include "FString.hh"
#include "Piper.hh"




class Dump;


/* ***********************************************************************
 *
 * ***********************************************************************
 */

class Event
{
 public:
  Event(int k=0,int e=0){key=k;esc=e;};
  //private:
  int key;
  int esc;
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */


class Screen
{
public:
  //
  static const long NO_DUMP;
  static const long ASCII_DUMP;
  static const long PS_DUMP;
  //
  static const long CLASSIC_BLACK;
  static const long RED_DEVIL;
  static const long GREEN_LEAVES;
  static const long SILVER_MINE;
  static const long HOT_DOG;
  //

  enum Styles{StyleNormal=1,StyleMenuHigh=2,StyleEntryHigh=3,StyleEntrySearch=4};

  //----------------------------------------
 public:
  Screen(long lo=1
	 ,long cs=SILVER_MINE
	 ,long acs=1
	 ,long rev=1
	 ,long dump=0
	 ,long pip=0
	 ,long screendebug=0
	 );
  ~Screen();
  //
  Event getKey() ;
  //  long sColumns() const{return COLS;};
  void deleteLine(long);
  void addString(String const &format,String const &c,long cx,long cy);
  void addCh(char c);
  void addHLIN();
  void scrollUpDn(long top,long bottom,long n);
  void addStr(String const &s);
  //  
  enum AttributeManipulation{AttOn=0,AttOff=1,AttSet=2};
  //
  void setAttribute(long a,AttributeManipulation m);
  //
  void boldOn();
  void boldOff();
  //
  void reverseOn();
  void reverseOff();
  //
  void underlineOn();
  void underlineOff();
  //
  void setStyle(Styles s,AttributeManipulation m);
  //
  void flush(long cx,long cy);
  void moveTo(long y,long x);
  void clrToEOL();
  void clrscr(long a,long e);
  long rows()const ;
  long cols()const ;
  void initialize();
  void prtToken(String str,Styles HIGH,Styles NORMAL);
  void prtMarkUpLine(String const & line);
  //
  Piper *piper()const{return ppiper;};
  void shellOut();
  void shellIn();
  //
  long screenDebug()const {return screendebug;};
  //----------------------------------------
 private:
  //
  int translateFunctionKey(int)const;
  void copyFromDump(long x,long y,long wx,long wy);
  void makeScreenDump();
  //
  //----------------------------------------
 public:
  static const StringList colorSchemes;
  //----------------------------------------
 private:
  bool COLORED;
  char HLIN;
  long ACS;
  long REVERSE;
  long pipein;
  long screendebug;
  Piper *ppiper; 
  Dump *pdump;
};



#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _SCREENXX_H */

