/*************************************************************************
 * @(#)Tools.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   29 Oct 2008
 *************************************************************************
 */

#include "Tools.hh"
#include "Except.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */

void extractMarkup(String const &text,String &hotkey
		   ,String &screenrep
		   ,String &markuprep
		   ,String &barerep
		   )
{
  
  String s=text; s.stripBlanks();
  
  StringList slt=s.breakup("\\t");
  
  if(slt.size()==1){
    StringList sl=slt[0].breakup("@(");
    if(sl.size()==1){
      screenrep=sl[0];
      markuprep=sl[0];
      barerep=sl[0];
      hotkey="";
    }else if(sl.size()==2){
      screenrep=sl[0]+"(";
      markuprep=sl[0]+"@(";
      barerep=sl[0];
      StringList slp=sl[1].breakup(")");
      if(slp.size()>1){
	screenrep+=slp[0].upperCase()+")";
	markuprep+=slp[0].upperCase()+")";
	barerep+=slp[0];
	hotkey=slp[0].lowerCase();
	slp.remove(0);
	String r=slp.join(")");
	screenrep+=r;
	markuprep+=r;
	barerep+=r;
      }else
	throw Except("extractMarkup:: missing closing  ')' in fieldname '"
		     +text+"'!");
    }else
      throw
 	Except("extractMarkup:: more than one '@(' in fieldname '"+text+"'!");
  }else if(slt.size()==2){
    barerep=slt[1];
    StringList sl=slt[0].breakup("@(");
    if(sl.size()==2){
      screenrep=sl[0]+"(";
      markuprep=sl[0]+"@(";
      StringList slp=sl[1].breakup(")");
      if(slp.size()>1){
	screenrep+=slp[0].upperCase()+")";
	markuprep+=slp[0].upperCase()+")";
	hotkey=slp[0].lowerCase();
	slp.remove(0);
	String r=slp.join(")");
	screenrep+=r;
	markuprep+=r;
      }else
	throw Except("extractMarkup:: missing closing  ')' befor '\\t'"
		     " in fieldname '"+text+"'!");
    }else
      throw
	Except("extractMarkup:: need  one '@(' before '\\t' in fieldname '"
	       +text+"'!");
    screenrep+=" "+slt[1];
    markuprep+=" "+slt[1];
    
  }else
    throw
      Except("extractMarkup:: more than one '\\t' in fieldname '"+text+"'!");
  
  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */

long screenRepLength(String const &text)
{
  long ret=text.length();
  
  //  if(text.find("\\t")>=0) ret--;
  
  if(text.find("@(")>=0) ret--;
  
  return ret;
  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
String prependHotkey(String const &markuprep,String const &hotkey)
{
  String s;
  
  StringList sl=markuprep.breakup("@(");
  
  if(sl.size()==1){
    s="@("+hotkey+")"+markuprep;
  }else if(sl.size()==2){
    s=sl[0]+"@("+hotkey;
    StringList slp=sl[1].breakup(")");
    if(slp.size()>1){
      s+=slp[0].upperCase()+")";
      slp.remove(0);
      String r=slp.join(")");
      s+=r;
    }else
      throw Except("prependHotkey:: missing closing  ')' in string '"
		   +markuprep+"'!");
  }else
    throw
      Except("prependHotkey:: more than one '@(' in string '"+markuprep+"'!");
  

  return s;
}



/*EOF*/ 
