/* @(#)Viewer.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _VIEWER_H
#define _VIEWER_H 1

#include "Page.hh"
#include "Item.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */

class Viewer: public Page
{
 public:
  Viewer(App *,String const &title="Viewer",SObject*p=0
	 ,String const &cn="Viewer");
  virtual ~Viewer();
  //
  virtual void setText(String const &t){buffer=t;};
  //
  //

 protected:
  virtual void onLayout();

 protected:
  String buffer;
};


/* ***********************************************************************
 *
 * ***********************************************************************
 */

class FileViewer: public Viewer
{
 public:
  FileViewer(App *,String const &title="File Viewer"
	     ,String const &fname="",SObject*p=0,String const &cn="FileViewer");
  virtual ~FileViewer(){};
  
};


/* ***********************************************************************
 *
 * ***********************************************************************
 */

class HelpViewer: public Viewer
{
 public:
  HelpViewer(App *,String const &title="Help",String const &topic=""
	     ,SObject*p=0,String const &cn="HelpViewer");
  virtual ~HelpViewer(){};

 protected:
  virtual void onLayout();


 private:
  static long isSectionMarker(String const &str,String const &topic);

  
};




#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _VIEWER_H */

