
/* @(#)debugxx.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _DEBUGXX_H
#define _DEBUGXX_H 1


#include <stdio.h>
#include "Except.hh"

#define PNC "%s::%s: "
#define PNS ,classname(),nsubfunc
#define THR(x) throw Except(classname+"::"+nsubfunc+": "+x)
#define THR2(x1,x2) throw Except(Sprintf(PNC x1 PNS ,x2))
#define THR3(x1,x2,x3) throw Except(Sprintf(PNC x1 PNS ,x2,x3))
#define THR4(x1,x2,x3,x4) throw Except(Sprintf(PNC x1 PNS ,x2,x3,x4))

class Here{
 public:
  Here(){
    printf("Here \n");
    fprintf(stderr,"Here \n");
    fflush(stderr);
    fflush(stdout);
  }
  Here(const char *s,int l){
    printf("Here %s<%d>\n",s,l);
    fprintf(stderr,"Here %s<%d>\n",s,l);
    fflush(stderr);
    fflush(stdout);
  }
  Here(const char *s,long l){
    printf("Here %s<%ld>\n",s,l);
    fprintf(stderr,"Here %s<%ld>\n",s,l);
    fflush(stderr);
    fflush(stdout);
  }
  Here(const char *s,const char *l){
    printf("Here %s<%s>\n",s,l);
    fprintf(stderr,"Here %s<%s>\n",s,l);
    fflush(stderr);
    fflush(stdout);
  }
  Here(const char *s,const String &l){
    printf("Here %s<%s>\n",s,l());
    fprintf(stderr,"Here %s<%s>\n",s,l());
    fflush(stderr);
    fflush(stdout);
  }
  Here(const char *s,double l){
    printf("Here %s<%g>\n",s,l);
    fprintf(stderr,"Here %s<%g>\n",s,l);
    fflush(stderr);
    fflush(stdout);
  }
  Here(const char *s,void *l){
    printf("Here %s<%p>\n",s,l);
    fprintf(stderr,"Here %s<%p>\n",s,l);
    fflush(stderr);
    fflush(stdout);
  }
};

#define HERE(x) Here(#x,x);





#define Assert(what,name) if(!assert(what,nsubfunc,name)) \
    throw Except(String(errorbuffer))

#define CLASSNAME String const &className()const {return classname;};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _DEBUGXX_H */

