/* @(#)sizetest.c
 */


#include <stdlib.h>
#include <stdio.h>
#include "fortrantypes.h" 
#include "cio.h" 
/* #include "helper.h"  */



#define LOCAL_DEBUG
#undef LOCAL_DEBUG

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void CFUNC(cmympisizetest)(char *itest1,char *itest4,FPLOINTEGER *isize)
{
  *isize=(itest4-itest1)/3;
}
/* ***********************************************************************
 * test the size of F90 and C-types
 * ***********************************************************************
 */
void CFUNC(csizetest)(char *ltest1 ,char *ltest4
		      ,char *itest1 ,char *itest4
		      ,char *dtest1,char *dtest4
		      ,char *ctest1,char *ctest4
		      ,char *lotest1,char *lotest4
		      ,char *t  ,char *f)
{
  long abort=0;
  if((ltest4-ltest1)/3 != sizeof(FPLOINTEGER)){
    (void)printf("F90 integer(t_int) has size=%ld, but C INTEGER has size %ld\n"
		 "You have to manipulate t_int in module precisiondefs.f90\n"
		 "to get an integer type of the same size!\n"
		 "Or you manipulate the types in fortrantypes.h\n"
		 "Normally the config process will do this for you.\n"
		 ,(long)(ltest4-ltest1)/3
		 ,(long)sizeof(FPLOINTEGER));
    abort=1;
  }
  if((itest4-itest1)/3 != sizeof(INTERNAL_INTEGER)){
    (void)printf("F90 standard integer has size=%ld, but C INTERNAL_INTEGER has size %ld\n"
		 "You have to manipulate INTERNAL_INTEGER in fortrantypes.h\n"
		 "to get an integer type of the same size!\n"
		 "Normally the config process will do this for you.\n"
		 ,(long)(itest4-itest1)/3
		 ,(long)sizeof(INTERNAL_INTEGER));
    abort=1;
    
  }
  /* (void)printf("%c %c\n",*((char*)ctest1),*((char*)ctest4)); */
  if((ctest4-ctest1)/3 != sizeof(char)){
    (void)printf("F90 charater(1) has size=%ld, but C char has size %ld\n"
		 "You have to report this behaviour to the FPLO programmers!\n"
		 ,(long)(ctest4-ctest1)/3
		 ,(long)sizeof(char));
    abort=1;
    
  }
  if((lotest4-lotest1)/3 != sizeof(FPLOLOGICAL)){
    (void)printf("F90 Logical has size=%ld, but C LOGICAL has size %ld\n"
		 "You have to manipulate t_log in module precisiondefs.f90\n"
		 "to get an logical type of the same size!\n"
		 "You have to manipulate LOGICAL in fortrantypes.h\n"
		 "to get an logical of the same size!\n"
		 "Normally the config process will do this for you.\n"
		 ,(long)(lotest4-lotest1)/3
		 ,(long)sizeof(FPLOLOGICAL));
    abort=1;
    
  }
  if((dtest4-dtest1)/3 != sizeof(FPLODOUBLEPRECISION)){
    (void)printf("F90 real(t_real) has size=%ld, but C DOUBLEPRECISION has size %ld\n"
		 "You have to manipulate t_real in module precisiondefs.f90\n"
		 "to get a real type of the same size!\n"
		 "Or you manipulate the types in fortrantypes.h\n"
		 "Normally the config process will do this for you.\n"
		 ,(long)(dtest4-dtest1)/3
		 ,(long)sizeof(FPLODOUBLEPRECISION));
    abort=1;
    
  }
#ifdef LOCAL_DEBUG
  (void)printf("F90 .true.="FPLOLOGICALFORMAT"\n",*((FPLOLOGICAL*)t));
  (void)printf("F90 .false.="FPLOLOGICALFORMAT"\n",*((FPLOLOGICAL*)f));
#endif
  L_TRUE=*((FPLOLOGICAL*)t);
  L_FALSE=*((FPLOLOGICAL*)f);
#ifdef LOCAL_DEBUG
  (void)printf("F90 .true.="FPLOLOGICALFORMAT"\n",L_TRUE);
  (void)printf("F90 .false.="FPLOLOGICALFORMAT"\n",L_FALSE);
#endif
  if(abort)exit(2);
}


/* ***********************************************************************
 * return size of types in byte
 * ***********************************************************************
 */
void CFUNC(cgettypesizes)( FPLOINTEGER *t_int_size
			   ,FPLOINTEGER *internal_int_size
			   ,FPLOINTEGER *t_real_size
			   ,FPLOINTEGER *t_log_size )
{
  *t_int_size=(FPLOINTEGER)sizeof(FPLOINTEGER);
  *internal_int_size=(FPLOINTEGER)sizeof(INTERNAL_INTEGER);
  *t_real_size=(FPLOINTEGER)sizeof(FPLODOUBLEPRECISION);
  *t_log_size=(FPLOINTEGER)sizeof(FPLOLOGICAL);

  return ;
  
}

/* ***********************************************************************
 * print the address of a pointer p
 * ***********************************************************************
 */


static void cmemaddress(void *p,FPLOINTEGER * trunk)
{
  *trunk=(FPLOINTEGER)p;
  /*  (void)printf("address: %p %ld\n",p,(long)p); */
}

/* interfaces */

void CFUNC(cintmemaddress)(FPLOINTEGER *p,FPLOINTEGER * trunk)
{
  cmemaddress(p,trunk);
}


void CFUNC(crealmemaddress)(FPLODOUBLEPRECISION *p,FPLOINTEGER * trunk)
{
  cmemaddress(p,trunk);
}


void CFUNC(clogmemaddress)(FPLOLOGICAL *p,FPLOINTEGER * trunk)
{
  cmemaddress(p,trunk);
}

void CFUNC(ccharmemaddress)(char *p,FPLOINTEGER * trunk)
{
  cmemaddress(p,trunk);
}



void CFUNC(ccmplxmemaddress)(FPLODOUBLEPRECISION *p,FPLOINTEGER * trunk)
{
  cmemaddress(p,trunk);
}



/* ***********************************************************************
 * print the address of a pointer p
 * ***********************************************************************
 */

void CFUNC(memmap)(void *p,FPLOINTEGER * trunk)
{
/* #ifdef __hpux
  memorymap();
#endif
*/


}
