/* @(#)iolexinternal_inc.c
 */
/* ***********************************************************************
 * this file is included by io.lex and contains functions used
 * internally by lex or which must be defined in io.lex, due to lex
 * specific type declaration
 * ***********************************************************************
 */
#ifndef _IOLEXINTERNAL_INC_H
#define _IOLEXINTERNAL_INC_H 1


/* ***********************************************************************
 * to be called at the parsers end, to free used memory
 * ***********************************************************************
 */
void lexcleanup(void)
{
  if(YY_CURRENT_BUFFER!=NULL) 
    yy_delete_buffer(YY_CURRENT_BUFFER);
  YY_CURRENT_BUFFER=NULL;
}
/* ***********************************************************************
 * reset lex buffers for multiple scanning (its a hack)
 * ***********************************************************************
 */
void lexreset(void)
{
  yy_flush_buffer(YY_CURRENT_BUFFER);
}

/* ***********************************************************************
 * translate escape character sequences from escaped form into
 * raw form 
 * ***********************************************************************
 */
static char deescape(char c)
{
  switch (c){
  case ('\''): return '\'';
  case ('\"'): return '\"';
  case ('\\'): return '\\';
  case ('0'): return '\0';
  case ('a'): return '\a';
  case ('b'): return '\b';
  case ('f'): return '\f';
  case ('n'): return '\n';
  case ('r'): return '\r';
  case ('t'): return '\t';
  case ('v'): return '\v';
  }
  return ' ';
}


#endif /* _IOLEXINTERNAL_INC_H */

