/* @(#)JobInterface.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _JOBINTERFACE_H
#define _JOBINTERFACE_H 1

#include <stdio.h>
#include "FString.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */

class JobInterface{
  // this provides information for running a calculation
  // via e.g. a job queue system or interactivly
  // 
  
 public:


  // Constructor, with default initializtion
  JobInterface(){    
    setDefault();};
  
  ~JobInterface(){};

  // Write job interface section to file FH, which must be opend
  // for writing. FH can be stderr or stdout.
  void writeToFile(FILE *FH);


  void setDefault();
  

  void runFeditPipe()const;
  
  // clear input settings
  void clear(){};
  

  void submitFplo(const String &dir);

  void killFplo(const String &dir)const;


  void transferFiles(const String &dir)const;

 private:
  void makePBSFile()const;
  void makeCondorFile()const;



 private:
  String pfplo; 
  String prunfplo;
  String pfedit;
  String pallotedtime;
  String pallotedmemory;
  String pjobname;
  String pmethod;
  bool pforce_initial_spin_split;
  bool pforce_convergence;
  bool pcopy;
  bool pdeleteonnode;

  static const char *pbs_sh_default;
  static void writePBS_SH_default();


  friend class MethodControl;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _JOBINTERFACE_H */

