//todo: make sure that the wyckofs for forces get not overwritten
//todo: make interuption possible, it should be completely
//      reentrant
//todo: use minner to extract info from directories
//todo: when creating a new template ask for the method
//      and create the varibles accordingly
//========================================================================

/* @(#)MethodControl.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _METHODCONTROL_H
#define _METHODCONTROL_H 1

#include "FString.hh"
#include "JobInterface.hh"
#include "Variables.hh"
#include "Calculations.hh"
#include "MinEnums.hh"
#include "MACROS.hh"



/* ***********************************************************************
 *
 * ***********************************************************************
 */
class MethodControl{
 public:


  MethodControl();
  ~MethodControl();


  void setDefault(MinEnums::Method whichmethod);
  void readControlFile();
  void writeControlFile(const String &fname);

  
  void doCalculations();

  static bool getFromKey(const String &line,const String &key,String &value,
			 char enddelim=':');
  static bool getFromKey(const String &line,const String &key,long &value,
			 char enddelim=':');
  static bool getTag(const String &line,const String &tag);

 private:


 private:
  // file name of control file
  CPROPERTY(controlfile,controlFile,ControlFile,String)
  // which method will be performed
  MinEnums::Method pmethod;
  // the job running interface
  CMODPROPERTY(jobinterface,jobInterface,JobInterface,JobInterface)
  // per job certain shell commands get executed
  ROCPROPERTY(perjobshellcommands,perJobShellCommands,StringList);
  // the section for crunching numbers to setup the input
  // according to the current variables of the method
  ROCPROPERTY(crunchcontent,crunchContent,String);
  // The information piped into fedit, containing varaible references.
  // Variables references are $varname in the pipe section, while 
  // they are varname in the crunch section
  ROCPROPERTY(pipecontent,pipeContent,StringList);
  // the list of output information to be extracted at the end
  ROCPROPERTY(report,report,StringList);
  // the list of variables
  CMODPROPERTY(variables,variables,Variables,Variables);
  // use long names for directories
  ROPROPERTY(longnames,useLongNames,bool);
  // time to sleep before checking the calcs again
  PROPERTY(sleeptime,sleepTime,SleepTime,unsigned int);
  Calculations *pcalculations;  
  PROPERTY(stoprunning,stopRunning,StopRunning,bool);
  PROPERTY(dontrun,dontRun,DontRun,bool);
  PROPERTY(restartunfinished,restartUnfinished,RestartUnfinished,bool);
  PROPERTY(restart,restart,Restart,bool);
  PROPERTY(refreshinput,refreshInput,RefreshInput,bool);
  PROPERTY(deleteunused,deleteUnused,DeleteUnused,bool);
  PROPERTY(newsimplex,newSimplex,NewSimplex,bool);
  PROPERTY(permanentsimplex,permanentSimplex,PermanentSimplex,bool);
  PROPERTY(forcefiletransfer,forceFileTransfer,ForceFileTransfer,bool);
  PROPERTY(minimizer_xtol,minimizerXTol,MinimizerXTol,double);
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _METHODCONTROL_H */

