/*************************************************************************
 * @(#)MinEnums.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   02 Dec 2011
 *************************************************************************
 */

#include "MinEnums.hh"
#include "Except.hh"

// known methods
const MinEnums::tsMethod MinEnums::pmethods[]={
  {MinEnums::None,"none"},
  {MinEnums::Minimize,"minimize"},
  {MinEnums::Curve,"curve"}
};
const long MinEnums::pmaxmethods=sizeof(MinEnums::pmethods)/
  sizeof(MinEnums::tsMethod);


/* ***********************************************************************
 *
 * ***********************************************************************
 */
MinEnums::Method MinEnums::methodFromString(const String &m)
{
  String mm=m.lowerCase();
  for(int i=0;i<pmaxmethods;i++){
    //printf("%d:%d:%s\n",i,pmethods[i].type,pmethods[i].guiname);
    if(mm==pmethods[i].guiname){
      return pmethods[i].type;
    }
  }
  throw Except(Sprintf("Unkown method: %s\n",mm())());
  return None;
}




/*EOF*/ 
