/*************************************************************************
 * @(#)Pbs_sh.cpp
 * author: magru@unas
 * date:   19 Apr 2014
 *************************************************************************
 */

#include "JobInterface.hh"

const char *JobInterface::pbs_sh_default="\
#!/bin/sh\n\
\n\
### Job name\n\
#PBS -N %job%\n\
\n\
### Output files\n\
#PBS -e pbs.err\n\
#PBS -o pbs.log\n\
\n\
### Number of requested memory\n\
#PBS -l select=1:mem=%mem%:vmem=%mem%\n\
#PBS -l cput=%cputime%\n\
#PBS -l walltime=%cputime%\n\
\n\
\n\
### Mail me when the job is aborted or ended\n\
###  PBS -m n\n\
\n\
\n\
# This job's working directory\n\
echo Working directory is $PBS_O_WORKDIR\n\
\n\
echo Running on host `hostname`\n\
echo Time is `date`\n\
echo Directory is `pwd`\n\
echo This jobs runs on the following processors:\n\
echo `cat $PBS_NODEFILE`\n\
# Define number of processors\n\
NPROCS=`wc -l < $PBS_NODEFILE`\n\
echo This job has allocated $NPROCS nodes\n\
\n\
PBS_O_EXEDIR=/home/magru/bin\n\
EXEC=%executable%\n\
init_split=\"%initialspinsplit%\"\n\
copy=%copydata%\n\
\n\
#[ -d $PBS_O_EXEDIR ] || mkdir -p $PBS_O_EXEDIR\n\
#rsync -Cavz --rsh=/usr/local/bin/ssh digedag:$PBS_O_EXEDIR `dirname $PBS_O_EXEDIR`\n\
\n\
if [ \"x%copydata%\" = \"x1\" ] ; then\n\
   if [ \"x$(hostname)\" = \"x$PBS_O_HOST\" ] ; then\n\
      echo \"on same node\"\n\
   else\n\
      echo \"on foreign node\"\n\
      echo \"copying data\"\n\
      [ -d $PBS_O_WORKDIR ] || mkdir -p $PBS_O_WORKDIR\n\
      rsync -Cavz  $PBS_O_HOST:$PBS_O_WORKDIR `dirname $PBS_O_WORKDIR`\n\
   fi\n\
fi\n\
\n\
cd $PBS_O_WORKDIR\n\
\n\
[ -f ./+term ] && rm -f ./+term\n\
[ -f ./+kill ] && rm -f ./+kill\n\
[ -f ./+done ] && rm -f ./+done\n\
\n\
\n\
# Run the executable fplo\n\
\n\
echo pwd=/home/magru/RES/F9/pbstest/ooo\n\
\n\
\n\
\n\
jobout()\n\
{\n\
  echo \"job cleanup $(date)\"\n\
\n\
  if [ \"x$cleaning\" = \"x1\" ] ; then\n\
    echo \"already cleaning\"\n\
    return\n\
  fi\n\
\n\
  cleaning=1  \n\
\n\
  touch ./+term\n\
  touch ./+done\n\
\n\
  if [ \"x%copydata%\" = \"x1\" ] ; then\n\
    if [ \"x$(hostname)\" = \"x$PBS_O_HOST\" ] ; then\n\
       echo \"on same node\"\n\
    else\n\
       echo \"on foreign node\"\n\
       echo \"copy data back\"\n\
       rsync -Cavz  $PBS_O_WORKDIR $PBS_O_HOST:`dirname $PBS_O_WORKDIR` && [ \"x%deleteonnode%\" = \"x1\" ] &&/bin/rm -rf $PBS_O_WORKDIR\n\
    fi\n\
  fi\n\
\n\
}\n\
\n\
\n\
echo \"doing...\"\n\
\n\
cleaning=0\n\
\n\
\n\
trap 'jobout' 2 9 15\n\
\n\
\n\
if [ x$init_split = x0 ] ; then\n\
  # if fplo is asking  questions like \"Have 2 spin sorts, want to skip\n\
  #                                   do initial spinplit?\" \n\
  # we assume that the answer yes is what we want, in most cases its \n\
  # correct. If not, redo i.e. the splitting be hand in every subdirectory\n\
  # and proceed with this script afterwards\n\
\n\
echo \"y\" > ./+yes\n\
echo \"y\" >> ./+yes\n\
echo \"y\" >> ./+yes\n\
echo \"y\" >> ./+yes\n\
\n\
$EXEC <  ./+yes > out\n\
\n\
else\n\
\n\
echo \"n\" > ./+no\n\
echo \"n\" >> ./+no\n\
echo \"n\" >> ./+no\n\
echo \"n\" >> ./+no\n\
\n\
$EXEC <  ./+no > out\n\
\n\
fi\n\
\n\
\n\
jobout\n\
\n\
\n\
";


/*EOF*/ 
