!!todo: remove ccvk,ccck
!!TODO: check k-integration dependence for hcp Co, after solving the main 
!!      problem
!!TODO: make core-overlap test before orthogonalization
!!TODO: find lower symmetric cases to check symemtries
!!TODO: find symemtrizer for SREL stuff

!!TODO: speedup, optimize
!!TODO: test more atoms -> symmetry
!!TODO: NREL
!!TODO: project valence onto orbitals somehow
!!TODO: collect all contribs for later display
!!TODO: basis test -> all valence
Module BHF
  !!
  Use precisiondefs
  Use errors
  Use clock
  Use file_iounits
  Use atomdefs
  Use memory
  Use tmesh
  Use optionstest
  Use diagonalize
  Use mesh
  Use constants
  Use trelativistic
  Use tsymmetry
  Use tpotentialdensity
  Use tkohnsham
  Use torbitalbasis
  Use tnumerics
  Use tloi
  Use loiaux
  Use finuc
  Use matserv
!  Use prnt!!todo remove
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="BHF"  
  !!
  Public :: calc_hyperfineFields&
       &,dyadeMatEl_bhf,redMatEl_bhf
  !!***********************************************************************
Contains
  !!***********************************************************************
  Subroutine calc_hyperfineFields(mspin,nspin,symmetry,structure&
       &,basis,potential,nkp,kohnsham,nband,ncdim,nvdim,ccck,ccvk&
       &,numerics,relativistic)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry), Intent(in)     :: symmetry
    Type(T_Structure), Intent(in)    :: structure
    Type(T_Potential), Intent(in)    :: potential
    Type(T_Kohnsham),Intent(in)      :: kohnsham
    Type(T_Basis),Intent(in)         :: basis
    Type(T_Numerics), Intent(in)     :: numerics
    Integer(t_int),Intent(in)    :: mspin,nspin,nkp,relativistic
    Integer(t_int),Intent(in)    :: nband,ncdim,nvdim
    Complex(t_real),Intent(in)  :: ccck(nband,nkp,ncdim,nspin)
    Complex(t_real),Intent(in)  :: ccvk(nband,nkp,nvdim,nspin)
    !!LOCAL
    Character(*),Parameter::nsubfunc="calc_hyperfineFields"
    Integer(t_int) :: isa,issa,q,lenc,lenv,ica,nmain,kap,l,deg,m,lmax
    Integer(t_int) :: kapa,kapb,ja,jb,ma,mb,mua,mub,ik,i,j
    Integer(t_int) :: la,lb,ms,istc,istv,ic,ivr,nv,iband
    Integer(t_int) :: nsite
    Real(t_real)   :: rnuca,units,d,bb(3),fspin,ror(3,3),re
    Logical(t_log) :: detailed,rel,khsrel,srel
    Complex(t_real):: cz
    Real(t_real),Pointer:: p_bhfval(:,:)
    Real(t_real),Pointer:: p_bhfcval(:,:)
    Real(t_real),Pointer:: p_bhfcvc(:,:)
    Real(t_real),Pointer:: p_bhftot(:,:)
    Real(t_real),Pointer:: p_bhfcore(:,:,:)
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: c1=(1.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    Real(t_real),Pointer   :: p_bhfmat(:,:,:)
    Real(t_real),Pointer :: p_MatElBhf(:,:,:,:,:)
    Character(*),Parameter  :: cpumesg_dens='Bhf: hyper fine field'
    !!
    Nullify(p_bhfmat,p_MatElBhf)
    Nullify(p_bhfval,p_bhfcval,p_bhfcvc,p_bhftot)
    Nullify(p_bhfcore)
    !!
    detailed=.True.
    !!
return
    If(structure% str_type==STR_TYPE_MOLECULE)Then
       Write(errbuf,"('''Molecules have no hyperfine field, do they? ;-)''')")
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
       !!TODO: molecule
       Return
    Endif
    !!
    units=hatoj/mubtojot/speed_of_light*0.5_t_real
    !!
    If(mspin==1)Then
       Write(outfile,2)
       Return
    Endif
    !!
    Call watch(cpumesg_dens,cpu_start,reset=.True.)            
    !!
    rel=(relativistic==FULL_RELATIVISTIC)
    khsrel=(relativistic==SCALAR_RELATIVISTIC_KH)
    srel=(relativistic==SCALAR_RELATIVISTIC)
    !!
    If(.Not.(rel.Or.khsrel.Or.srel))Then
       Write(errbuf,22)Trim(relat_name(relativistic))
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    Endif
    !!
    !!prepare 
    !!
    nsite=structure% nsite
    !!
    !!
    Call palloc('p_bhfval',p_bhfval,1_t_int,3_t_int&
         &,1_t_int,nsite,nmodule,nsubfunc)
    Call palloc('p_bhfcval',p_bhfcval,1_t_int,3_t_int&
         &,1_t_int,nsite,nmodule,nsubfunc)
    Call palloc('p_bhfcvc',p_bhfcvc,1_t_int,3_t_int&
         &,1_t_int,nsite,nmodule,nsubfunc)
    Call palloc('p_bhfcore',p_bhfcore,1_t_int,3_t_int,1_t_int,basis% nRchimx&
         &,1_t_int,nsite,nmodule,nsubfunc)
    Call palloc('p_bhftot',p_bhftot,1_t_int,3_t_int,1_t_int,nsite&
         &,nmodule,nsubfunc)
    !!
    lmax=basis% lmx
    If(rel)Then
       Call palloc('p_MatElBhf',p_MatElBhf&
            &,-(lmax+1),lmax,-(2*lmax+1),(2*lmax+1)&
            &,-(lmax+1),lmax,-(2*lmax+1),(2*lmax+1)&
            &,1_t_int,3_t_int&
            &,nmodule,nsubfunc)
       !!
       Do kapa=-lmax-1,lmax
          ja=2*Abs(kapa)-1
          Do ma=1,ja+1
             mua=-ja+2*(ma-1)
             Do kapb=-lmax-1,lmax
                jb=2*Abs(kapb)-1
                Do mb=1,jb+1
                   mub=-jb+2*(mb-1)
                   d=(-1.0_t_real)**((ja-mua)/2)*redMatEl_bhf(kapa,kapb)
                   !! x-component
                   p_MatElBhf(kapa,mua,kapb,mub,1)=&
                        &(wigner3j_1(ja,-mua,jb,mub,-1_t_int)&
                        &-wigner3j_1(ja,-mua,jb,mub,1_t_int))*d*sq2o2
                   !! y-component WITHOUT factor i
                   p_MatElBhf(kapa,mua,kapb,mub,2)=&
                        &(wigner3j_1(ja,-mua,jb,mub,-1_t_int)&
                        &+wigner3j_1(ja,-mua,jb,mub,1_t_int))*d*sq2o2
                   !! z-component
                   p_MatElBhf(kapa,mua,kapb,mub,3)=&
                        &wigner3j_1(ja,-mua,jb,mub,0_t_int)*d
                Enddo
             Enddo
          Enddo
       Enddo
    Else If(srel.Or.khsrel) Then
       !!
       Call palloc('p_MatElBhf',p_MatElBhf&
            &,0_t_int,lmax,-lmax,lmax&
            &,0_t_int,lmax,-lmax,lmax&
            &,1_t_int,3_t_int&
            &,nmodule,nsubfunc)
       !!
       Do la=0,lmax
          Do ma=-la,la
             Do lb=0,lmax
                Do mb=-lb,lb
                   Call dyadeMatEl_bhf(la,ma,lb,mb,ror)
                   Do q=1,3
                      p_MatElBhf(la,ma,lb,mb,q)=ror(q,3)
                   Enddo
                   If(la==lb.And.ma==mb)Then
                      p_MatElBhf(la,ma,lb,mb,3)&
                           &=p_MatElBhf(la,ma,lb,mb,3)-1.0_t_real
                   Endif
                Enddo
             Enddo
          Enddo
       Enddo
    Endif
    !!
    !!
    !!
    !!
    !!
    !!
    !!
    
    isaloop: Do isa=1,nsite
       issa=structure% p_isrt(isa)
       !!
       p_bhfval(1:3,isa)=0.0_t_real
       p_bhfcval(1:3,isa)=0.0_t_real
       p_bhfcvc(1:3,isa)=0.0_t_real
       p_bhftot(1:3,isa)=0.0_t_real
       p_bhfcore(1:3,:,isa)=0.0_t_real
       !!
       lenc=kohnsham% p_cblocklength(isa)
       lenv=kohnsham% p_vblocklength(isa)
       istc=kohnsham% p_cblockstart(isa)-1
       istv=kohnsham% p_vblockstart(isa)-1
       !!
       !!
       !!
       nv=0
       Do ivr=1,basis% p_nRv(issa)
          If(basis% p_kapRv(ivr,issa)<0) nv=nv+1
       Enddo
       !!
       !!
       rnuca=nuc_max_rad(potential% nuc_type,potential% p_natom(issa))
       !!
       !!
       coreif: If(lenc>0)Then
          !! core contribution
          !!
          !!
          !!
          Call palloc('p_bhfmat',p_bhfmat ,1_t_int,lenc,1_t_int,lenc&
               &,1_t_int,3_t_int,nmodule,nsubfunc)
          !!
          If(rel)Then
             Call rel_calcbhfMatrix(p_bhfmat,numerics% oci_nr&
                  &,basis% p_basmeshs(issa),basis% nrb,numerics% degree&
                  &,basis% nRcmx,basis% nRcmx&
                  &,basis% p_nRc(issa),basis% p_kapRc(:,issa)&
                  &,basis% p_degRc(:,issa)&
                  &,basis% p_nRc(issa),basis% p_kapRc(:,issa)&
                  &,basis% p_degRc(:,issa)&
                  &,basis% p_fc(:,:,:,issa)&
                  &,basis% p_fc(:,:,:,issa)&
                  &,basis% p_fgam(issa)&
                  &,lmax,p_MatElBhf&
                  &,rnuca,potential% nuc_type)
          Else
             Call srel_calcbhfMatrix(p_bhfmat,numerics% oci_nr&
                  &,basis% p_basmeshs(issa),basis% nrb,numerics% degree&
                  &,basis% ncomp,basis% nRcmx,basis% nRcmx&
                  &,basis% p_nRc(issa),basis% p_lRc(:,issa)&
                  &,basis% p_nRc(issa),basis% p_lRc(:,issa)&
                  &,basis% p_fc(:,:,:,issa)& 
                  &,basis% p_fc(:,:,:,issa)& 
                  &,basis% p_fgam(issa)&
                  &,lmax,p_MatElBhf&
                  &,rnuca,potential% nuc_type)
          Endif
          !!
          !!
          iband=1
          ic=0
          Do ica=1,basis% p_nRchi(issa)
             kap=basis% p_kapRc(ica,issa)
             l=(Abs(2*kap+1)-1)/2
             If(kap>0) Cycle
             ic=ic+1
             deg=(2*l+1)
             If(rel)deg=deg*2
             bb(1:3)=0.0_t_real

             !Write(outfile,"(i1,a1)")basis% p_nnRc(ica,issa),lqnchar(l)

             Do m=1,deg
                Do ms=1,nspin
                   fspin=3-2*ms
                   Do q=1,3
                      If(rel)Then
                         cz=c1
                         If(q==2)cz=ci
                         bb(q)=bb(q)&
                              &+Real(&
                              &Dot_product(kohnsham% p_coccu(iband,isa,ms)&
                              &*kohnsham% p_rczz(1:lenc,iband,isa),&
                              &cz*Matmul(p_bhfmat(1:lenc,1:lenc,q)&
                              &,kohnsham% p_rczz(1:lenc,iband,isa))),t_real)

                         !If(q==3.And.basis% p_nnRc(ica,issa)==3.And.l==1)Then
                         !Endif


                      Else
                         bb(q)=bb(q)&
                              &+Dot_product(kohnsham% p_coccu(iband,isa,ms)&
                              &*kohnsham% p_nczz(1:lenc,iband,isa,ms)&
                              &,Matmul(p_bhfmat(1:lenc,1:lenc,q)&
                              &,kohnsham% p_nczz(1:lenc,iband,isa,ms)))*fspin
                      Endif
                   Enddo
                Enddo !! ms
                iband=iband+1
             Enddo
             p_bhfcore(1:3,ic,isa)=bb(1:3)
             p_bhftot(1:3,isa)=p_bhftot(1:3,isa)+bb(1:3)
          Enddo !! ica
          !!
          !!
          !! core core from orthogonalization
          !!
          If(lenv>0)Then
             bb=0.0_t_real
             Do ms=1,nspin
                fspin=3-2*ms
                
                Do i=1,lenc
                   Do j=1,lenc
                      cz=c0
                      Do ik=1,nkp
                         Do iband=1,nband
                            cz=cz+Conjg(ccck(iband,ik,istc+i,ms))&
                                 &*ccck(iband,ik,istc+j,ms)&
                                 &*kohnsham% p_bweitk(iband,ik,ms)
                         Enddo
                      Enddo
                      re=Real(cz,t_real)*fspin
                      bb(1)=bb(1)+p_bhfmat(i,j,1)*re
                      bb(2)=bb(2)-p_bhfmat(i,j,2)*Aimag(cz)*fspin
                      bb(3)=bb(3)+p_bhfmat(i,j,3)*re
                   Enddo
                Enddo
             Enddo
             !!
             p_bhfcvc(1:3,isa)=p_bhfcvc(1:3,isa)+bb(1:3)
             p_bhftot(1:3,isa)=p_bhftot(1:3,isa)+bb(1:3)
             !!
             !!
             !!
          Endif
          !!
          !!
          Call pfree(p_bhfmat)
          !!
       Endif coreif
       !!
       !!
       valenceif: If(lenv>0)Then
          !! valence valence
          !!
          Call palloc('p_bhfmat',p_bhfmat ,1_t_int,lenv,1_t_int,lenv&
               &,1_t_int,3_t_int,nmodule,nsubfunc)
          !!
          If(rel)Then
             Call rel_calcbhfMatrix(p_bhfmat,numerics% oci_nr&
                  &,basis% p_basmeshs(issa),basis% nrb,numerics% degree&
                  &,basis% nRvmx,basis% nRvmx&
                  &,basis% p_nRv(issa),basis% p_kapRv(:,issa)&
                  &,basis% p_degRv(:,issa)&
                  &,basis% p_nRv(issa),basis% p_kapRv(:,issa)&
                  &,basis% p_degRv(:,issa)&
                  &,basis% p_fv(:,:,:,issa)&
                  &,basis% p_fv(:,:,:,issa)&
                  &,basis% p_fgam(issa)&
                  &,lmax,p_MatElBhf&
                  &,rnuca,potential% nuc_type)
          Else
             Call srel_calcbhfMatrix(p_bhfmat,numerics% oci_nr&
                  &,basis% p_basmeshs(issa),basis% nrb,numerics% degree&
                  &,basis% ncomp,basis% nRvmx,basis% nRvmx&
                  &,basis% p_nRv(issa),basis% p_lRv(:,issa)&
                  &,basis% p_nRv(issa),basis% p_lRv(:,issa)&
                  &,basis% p_fv(:,:,:,issa)& 
                  &,basis% p_fv(:,:,:,issa)& 
                  &,basis% p_fgam(issa)&
                  &,lmax,p_MatElBhf&
                  &,rnuca,potential% nuc_type)
          Endif
          !!
          !!
          !Call printmat1('Re bhf_x',"(f12.5,' ')","('     0       ')"&
          !     &,p_bhfmat(:,:,1),lenv,lenv,1.0e-6_t_real)
          !!
          bb=0.0_t_real
          Do ms=1,nspin
             fspin=3-2*ms
                   
             Do i=1,lenv
                Do j=1,lenv
                   cz=c0
                   Do ik=1,nkp
                      Do iband=1,nband
                         cz=cz+Conjg(ccvk(iband,ik,istv+i,ms))&
                              &*ccvk(iband,ik,istv+j,ms)&
                              &*kohnsham% p_bweitk(iband,ik,ms)
                      Enddo
                   Enddo
                   re=Real(cz,t_real)*fspin
                   bb(1)=bb(1)+p_bhfmat(i,j,1)*re
                   bb(2)=bb(2)-p_bhfmat(i,j,2)*Aimag(cz)*fspin
                   bb(3)=bb(3)+p_bhfmat(i,j,3)*re
                Enddo
             Enddo
          Enddo
          !!
          p_bhfval(1:3,isa)=p_bhfval(1:3,isa)+bb(1:3)
          p_bhftot(1:3,isa)=p_bhftot(1:3,isa)+bb(1:3)
          !!
          !!
          !!
          !!
          Call pfree(p_bhfmat)
          !!
       End If valenceif
       !!
       !!
       corevalenceif: If(lenc>0.And.lenv>0)Then
          !! core valence
          !!
          Call palloc('p_bhfmat',p_bhfmat ,1_t_int,lenc,1_t_int,lenv&
               &,1_t_int,3_t_int,nmodule,nsubfunc)
          !!
          If(rel)Then
             Call rel_calcbhfMatrix(p_bhfmat,numerics% oci_nr&
                  &,basis% p_basmeshs(issa),basis% nrb,numerics% degree&
                  &,basis% nRcmx,basis% nRvmx&
                  &,basis% p_nRc(issa),basis% p_kapRc(:,issa)&
                  &,basis% p_degRc(:,issa)&
                  &,basis% p_nRv(issa),basis% p_kapRv(:,issa)&
                  &,basis% p_degRv(:,issa)&
                  &,basis% p_fc(:,:,:,issa)&
                  &,basis% p_fv(:,:,:,issa)&
                  &,basis% p_fgam(issa)&
                  &,lmax,p_MatElBhf&
                  &,rnuca,potential% nuc_type)
          Else
             Call srel_calcbhfMatrix(p_bhfmat,numerics% oci_nr&
                  &,basis% p_basmeshs(issa),basis% nrb,numerics% degree&
                  &,basis% ncomp,basis% nRcmx,basis% nRvmx&
                  &,basis% p_nRc(issa),basis% p_lRc(:,issa)&
                  &,basis% p_nRv(issa),basis% p_lRv(:,issa)&
                  &,basis% p_fc(:,:,:,issa)& 
                  &,basis% p_fv(:,:,:,issa)& 
                  &,basis% p_fgam(issa)&
                  &,lmax,p_MatElBhf&
                  &,rnuca,potential% nuc_type)
          Endif
          !!
          bb=0.0_t_real
          Do ms=1,nspin
             fspin=3-2*ms
                   
             Do i=1,lenc
                Do j=1,lenv
                   cz=c0
                   Do ik=1,nkp
                      Do iband=1,nband
                         cz=cz+Conjg(ccck(iband,ik,istc+i,ms))&
                              &*ccvk(iband,ik,istv+j,ms)&
                              &*kohnsham% p_bweitk(iband,ik,ms)
                      Enddo
                   Enddo
                   re=Real(cz,t_real)*fspin
                   bb(1)=bb(1)+p_bhfmat(i,j,1)*re
                   bb(2)=bb(2)-p_bhfmat(i,j,2)*Aimag(cz)*fspin
                   bb(3)=bb(3)+p_bhfmat(i,j,3)*re
                Enddo
             Enddo
          Enddo
          !!
          bb=bb*2.0_t_real
          p_bhfcval(1:3,isa)=p_bhfcval(1:3,isa)+bb(1:3)
          p_bhftot(1:3,isa)=p_bhftot(1:3,isa)+bb(1:3)
          !!
          !!
          !!
          !!
          !!
          Call pfree(p_bhfmat)
          !!
       End If corevalenceif
       !!
       !!
       !!
    Enddo isaloop
    !!
    !!
    Call pfree(p_MatElBhf)
    !!
    If(.Not.isoption('FULLBZ'))Then
       If(rel)Then
          Call symmetrize_vector(symmetry,structure,p_bhfval)
          Call symmetrize_vector(symmetry,structure,p_bhfcval)
          Call symmetrize_vector(symmetry,structure,p_bhfcvc)
          Call symmetrize_vector(symmetry,structure,p_bhftot)
       Else
          Call nsrel_symmetrize_vector(symmetry,structure,p_bhfval)
          Call nsrel_symmetrize_vector(symmetry,structure,p_bhfcval)
          Call nsrel_symmetrize_vector(symmetry,structure,p_bhfcvc)
          Call nsrel_symmetrize_vector(symmetry,structure,p_bhftot)
       Endif
    Endif
    !!
    Write(outfile,3)

    Do isa=1,nsite
       issa=structure% p_isrt(isa)
       Write(outfile,5) structure% p_elements(issa),isa
       bb=0.0_t_real
       ic=0
       Do ica=1,basis% p_nRchi(issa)
          nmain=basis% p_nnRc(ica,issa)
          kap=basis% p_kapRc(ica,issa)
          l=(Abs(2*kap+1)-1)/2
          If(kap>0) Cycle
          ic=ic+1
          Write(outfile,6) nmain,lqnchar(l),p_bhfcore(:,ic,isa)*units&
               &,Sqrt(Sum(p_bhfcore(:,ic,isa)**2))*units
          bb(1:3)=bb(1:3)+p_bhfcore(1:3,ic,isa)
       Enddo
       Write(outfile,7)bb(:)*units,Sqrt(Sum(bb**2))*units
       !!
       If(detailed.And.lenc>0)Then
          bb=0.0_t_real
          !iv=0 !! nl-orbital index
          !Do ivr=1,basis% p_nRv(issa)
          !   nmain=basis% p_nnRv(ivr,issa)
          !   kap=basis% p_kapRv(ivr,issa)
          !   l=(Abs(2*kap+1)-1)/2
          !   If(kap>0)Cycle
          !   iv=iv+1
          !   Write(outfile,6) nmain,lqnchar(l),p_bhfval(:,iv,isa)*units&
          !        &,Sqrt(Sum(p_bhfval(:,iv,isa)**2))*units
          !   bb(1:3)=bb(1:3)+p_bhfval(1:3,iv,isa)
          !Enddo
          bb(1:3)=p_bhfval(1:3,isa)
          Write(outfile,8)bb(:)*units,Sqrt(Sum(bb(1:3)**2))*units
          !!
          bb=0.0_t_real
          !iv=0 !! nl-orbital index
          !Do ivr=1,basis% p_nRv(issa)
          !   nmain=basis% p_nnRv(ivr,issa)
          !   kap=basis% p_kapRv(ivr,issa)
          !   l=(Abs(2*kap+1)-1)/2
          !   If(kap>0)Cycle
          !   iv=iv+1
          !   Write(outfile,6) nmain,lqnchar(l),p_bhfcval(:,iv,isa)*units&
          !        &,Sqrt(Sum(p_bhfcval(:,iv,isa)**2))*units
          !   bb(1:3)=bb(1:3)+p_bhfcval(1:3,iv,isa)
          !Enddo
          bb=p_bhfcval(:,isa)
          Write(outfile,81)bb(:)*units,Sqrt(Sum(bb**2))*units
          !!
          bb=0.0_t_real
          !iv=0 !! nl-orbital index
          !Do ivr=1,basis% p_nRv(issa)
          !   nmain=basis% p_nnRv(ivr,issa)
          !   kap=basis% p_kapRv(ivr,issa)
          !   l=(Abs(2*kap+1)-1)/2
          !   If(kap>0)Cycle
          !   iv=iv+1
          !   Write(outfile,6) nmain,lqnchar(l),p_bhfcvc(:,iv,isa)*units&
          !        &,Sqrt(Sum(p_bhfcvc(:,iv,isa)**2))*units
          !   bb(1:3)=bb(1:3)+p_bhfcvc(1:3,iv,isa)
          !Enddo
          bb=p_bhfcvc(:,isa)
          Write(outfile,82)bb(:)*units,Sqrt(Sum(bb**2))*units
       endif
       !!
       bb=0.0_t_real
       !iv=0 !! nl-orbital index
       !Do ivr=1,basis% p_nRv(issa)
       !   nmain=basis% p_nnRv(ivr,issa)
       !   kap=basis% p_kapRv(ivr,issa)
       !   l=(Abs(2*kap+1)-1)/2
       !   If(kap>0)Cycle
       !   iv=iv+1
       !   bv(:)=()
       !   Write(outfile,6) nmain,lqnchar(l),bv*units&
       !        &,Sqrt(Sum(bv**2))*units
       !   bb(1:3)=bb(1:3)+bv(1:3)
       !Enddo
       bb(1:3)=bb(1:3)+p_bhfval(1:3,isa)+p_bhfcval(:,isa)+p_bhfcvc(:,isa)
       Write(outfile,67)bb(:)*units,Sqrt(Sum(bb**2))*units
       !!
       !!
       Write(outfile,9)p_bhftot(:,isa)*units&
            &,Sqrt(Sum(p_bhftot(:,isa)**2))*units
    Enddo

    !!
    Write(outfile,4)
    !!
    Call pfree(p_bhfval)
    Call pfree(p_bhfcval)
    Call pfree(p_bhfcvc)
    Call pfree(p_bhftot)
    Call pfree(p_bhfcore)
    !!
    Call watch(cpumesg_dens,cpu_stop,delete=.True.,Print=.True.)
    !!
    Return
    !!
2   Format('Bhf: non spin polarized calculation: &
         &no hyper fine fields to be calculated!')
22  Format('''Bhf: ',a,' hyper fine fields not implemented!''')
3   Format('Bhf: ===================== Hyper Fine Fields ==================='&
         &,/,'Bhf:  The field is given as a vector. '&
         &,/,'Bhf:  (Compare it to the direction of the exchange field.)'&
         &,/,'Bhf:  The units are Tesla. '&
         &,/,'Bhf: ')
4   Format('Bhf: ===========================================================')
5   Format('Bhf: ',a2,'(',i3,')  ',15x,'Bx',14x,'By',14x,'Bz',14x,'|B|')
6   Format('Bhf: ',i1,a1,'          : ',4(f15.5,1x))
7   Format('Bhf: ',75('-'),/&
         &,'Bhf: core total  : ',4(f15.5,1x),/&
         &,'Bhf: ',75('-'))
8   Format('Bhf: ',75('-'),/&
         &,'Bhf: vv   total  : ',4(f15.5,1x),/&
         &,'Bhf: ',75('-'))
81  Format('Bhf: ',75('-'),/&
         &,'Bhf: cv   total  : ',4(f15.5,1x),/&
         &,'Bhf: ',75('-'))
82  Format('Bhf: ',75('-'),/&
         &,'Bhf: cvc  total  : ',4(f15.5,1x),/&
         &,'Bhf: ',75('-'))
67  Format('Bhf: ',75('-'),/&
         &,'Bhf: val  total  : ',4(f15.5,1x),/&
         &,'Bhf: ',75('-'))
9   Format('Bhf: total       : ',4(f15.5,1x),/&
         &,'Bhf: ',75('-'),/&
         &,'Bhf: ')
    !!
  End Subroutine calc_hyperfineFields
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine symmetrize_vector_orb(symmetry,structure,nsite,bhf,nRmx)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry), Intent(in) :: symmetry
    Type(T_Structure), Intent(in):: structure
    Integer(t_int),Intent(in)    :: nRmx,nsite
    Real(t_real),Intent(inout)   :: bhf(1:3,nRmx,1:nsite)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="symmetrize_vector_orb"
    Integer(t_int) :: isa,jops,isga,iv
    Real(t_real)   :: s
    Real(t_real)   :: lbhf(1:3,1:nsite)
    !!
    !!
    !! and symmetrize again
    Do iv=1,nRmx
       Do isa=1,nsite
          lbhf(:,isa)=0.0_t_real
          Do jops=1,symmetry% Rnumops
             isga=structure% p_equivsites(jops,isa)
             s=1.0_t_real
             If(symmetry% Roptimerev(jops)==1) s=-s
             If(symmetry% opeulerinv(symmetry% Ropind(jops))/=0)s=-s
             lbhf(:,isa)=lbhf(:,isa)&
                  &+s*Matmul(symmetry% Ropmat(:,:,jops),bhf(:,iv,isga))&
                  &/symmetry% Rnumops
          Enddo
       Enddo
       bhf(1:3,iv,1:nsite)=lbhf(1:3,1:nsite)
    Enddo
    !!
    !!
    Return
    !!
  End Subroutine symmetrize_vector_orb
#endif
  !!***********************************************************************
  Subroutine symmetrize_vector(symmetry,structure,bhf)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry), Intent(in) :: symmetry
    Type(T_Structure), Intent(in):: structure
    Real(t_real),Intent(inout)   :: bhf(1:3,1:structure% nsite)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="symmetrize_vector"
    Integer(t_int) :: isa,jops,isga
    Real(t_real)   :: s
    Real(t_real)   :: lbhf(1:3,1:structure% nsite)
    !!
    !!
    !! and symmetrize again
    Do isa=1,structure% nsite

       lbhf(:,isa)=0.0_t_real
       Do jops=1,symmetry% Rnumops
          isga=structure% p_equivsites(jops,isa)
          s=1.0_t_real
          If(symmetry% Roptimerev(jops)==1) s=-s
          If(symmetry% opeulerinv(symmetry% Ropind(jops))/=0)s=-s
          lbhf(:,isa)=lbhf(:,isa)&
               &+s*Matmul(symmetry% Ropmat(:,:,jops),bhf(:,isga))&
               &/symmetry% Rnumops
       Enddo
    Enddo
    !!
    bhf=lbhf
    !!
    Return
    !!
  End Subroutine symmetrize_vector
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine nsrel_symmetrize_vector_orb(symmetry,structure,nsite,bhf,nRmx)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry), Intent(in) :: symmetry
    Type(T_Structure), Intent(in):: structure
    Integer(t_int),Intent(in)    :: nRmx,nsite
    Real(t_real),Intent(inout)   :: bhf(1:3,nRmx,1:nsite)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="nsrel_symmetrize_vector_orb"
    Integer(t_int) :: isa,jops,isga,iv
    Real(t_real)   :: lbhf(1:3,1:nsite)
    !!
    !!
    !! and symmetrize again
    Do iv=1,nRmx
       Do isa=1,nsite
          lbhf(:,isa)=0.0_t_real
          Do jops=1,symmetry% Rnumops
             isga=structure% p_equivsites(jops,isa)
             lbhf(:,isa)=lbhf(:,isa)+bhf(:,iv,isga)/symmetry% Rnumops
          Enddo
       Enddo
       bhf(1:3,iv,1:nsite)=lbhf(1:3,1:nsite)
    Enddo
    !!
    !!
    Return
    !!
  End Subroutine nsrel_symmetrize_vector_orb
#endif
  !!***********************************************************************
  Subroutine nsrel_symmetrize_vector(symmetry,structure,bhf)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry), Intent(in) :: symmetry
    Type(T_Structure), Intent(in):: structure
    Real(t_real),Intent(inout)   :: bhf(1:3,1:structure% nsite)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="nsrel_symmetrize_vector"
    Integer(t_int) :: isa,jops,isga
    Real(t_real)   :: lbhf(1:3,1:structure% nsite)
    !!
    !!
    !! and symmetrize again
    Do isa=1,structure% nsite

       lbhf(:,isa)=0.0_t_real
       Do jops=1,symmetry% Rnumops
          isga=structure% p_equivsites(jops,isa)
          lbhf(:,isa)=lbhf(:,isa)+bhf(:,isga)/symmetry% Rnumops
       Enddo
    Enddo
    !!
    bhf=lbhf
    !!
    Return
    !!
  End Subroutine nsrel_symmetrize_vector
  !!***********************************************************************
  Real(t_real) Function wigner3j_1(ja,mua,jb,mub,q)
    !! 
    !! / ja 1 jb \
    !! |         |
    !! \ ma q mb /
    !! 
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: ja,jb !! 2*Ja, 2*Jb
    Integer(t_int),Intent(in)    :: mua,mub !! 2*mua, 2*mub
    Integer(t_int),Intent(in)    :: q  !! -1,0,1
    !!LOCAL
    !Character(*),Parameter::nsubfunc="wigner3j_1"
    Real(t_real)   :: d
    !!
    wigner3j_1=0.0_t_real
    !!
    If(mua+mub+2*q/=0)Return
    If(Abs(mua)>ja .Or. Abs(mub)>jb)Return
    !!
    If(ja == jb)Then
       If(q==0)Then
          wigner3j_1=0.5_t_real*mub*Sqrt(4.0_t_real/((jb+2)*jb*(jb+1)))&
               &*(-1)**((jb-mub)/2)
       Else
          wigner3j_1=sq2o2*q*Sqrt(1.0_t_real/((jb+2)*jb*(jb+1)))&
               &*Sqrt(jb*(jb+2.0_t_real)-mub*(mub+2*q))*(-1)**((jb-mub)/2)

       Endif
    Else If(ja==jb-2)Then
       d=Sqrt(2.0_t_real/((jb+1)*jb*(jb-1)))*(-1)**((jb-mub)/2)
       If(q==0)Then
          wigner3j_1=d*Sqrt(1.0_t_real*jb**2-mub**2)*0.5_t_real
       Else
          wigner3j_1=d*Sqrt(0.5_t_real*(jb-q*mub)*(jb-q*mub-2))*0.5_t_real
       Endif
    Else If(ja==jb+2)Then
       d=-Sqrt(2.0_t_real/((ja+1)*ja*(ja-1)))*(-1)**((ja-mua)/2)
       If(q==0)Then
          wigner3j_1=d*Sqrt(1.0_t_real*ja**2-mua**2)*0.5_t_real
       Else
          wigner3j_1=d*Sqrt(0.5_t_real*(ja-q*mua)*(ja-q*mua-2))*0.5_t_real
       Endif
    Endif
    !!
    !!
    Return
    !!
  End Function wigner3j_1
  !!***********************************************************************
  Real(t_real) Function redMatEl_bhf(kapa,kapb)
    !!
    !! reduced matrix element <kapa|| t^b ||kapb>
    !! for Wigner Eckart theorem
    !!
    !! t^b_q=z t^r_q sigma_r-t^sigma_q
    !!
    !! sigma_r=\vec{sigma}*\vec{r}/r
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: kapa,kapb
    !!LOCAL
    !Character(*),Parameter::nsubfunc="redMatEl_bhf"
    !!
    !!
    redMatEl_bhf=0.0_t_real
    !!
    If(kapa*kapb==0)Return
    !!
    If(kapa==kapb)Then
       redMatEl_bhf=Sqrt(2.0_t_real*Abs(kapb)/(4*kapb**2-1))&
            &*2.0_t_real*kapb
    Else If(kapa==-kapb-1)Then
       redMatEl_bhf=Sqrt(-2.0_t_real*Abs(kapb)*kapa/(2*kapb+1))&
            &*kapb/Abs(kapb)
    Else If(kapa==-kapb+1)Then
       redMatEl_bhf=Sqrt(-2.0_t_real*Abs(kapb)*kapa/(2*kapb-1))&
                              &*kapb/Abs(kapb)
    Endif
    !!
    !!
    Return
    !!
  End Function redMatEl_bhf
  !!***********************************************************************
  Subroutine dyadeMatEl_bhf(la,ma,lb,mb,rr)
    !! matrix elements of the dyade \hat{r}\circ\hat{r} between
    !! real harmonics
    Implicit None  
    !!IO
    Integer(t_int),Intent(in)    :: la,ma,lb,mb
    Real(t_real),Intent(out)     :: rr(3,3)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="dyadeMatEl_bhf"
    Real(t_real),Parameter :: prefac=0.91529123286376899334_t_real
    Integer(t_int) :: mma,sa,mmb,sb
    Real(t_real)   :: g,g22,g20
    !!
    mma=Abs(ma)
    sa=Sign(1_t_int,ma)
    mmb=Abs(mb)
    sb=Sign(1_t_int,mb)
    !!
    !!
    !!
    g=prefac*rgaunt(la,mma,sa,lb,mmb,sb,2_t_int,1_t_int,1_t_int)
    rr(1,3)=g
    rr(3,1)=g
    g=prefac*rgaunt(la,mma,sa,lb,mmb,sb,2_t_int,1_t_int,-1_t_int)
    rr(2,3)=g
    rr(3,2)=g
    g=prefac*rgaunt(la,mma,sa,lb,mmb,sb,2_t_int,2_t_int,-1_t_int)
    rr(1,2)=g
    rr(2,1)=g
    !!
    g22=prefac*rgaunt(la,mma,sa,lb,mmb,sb,2_t_int,2_t_int,1_t_int)
    g20=prefac*rgaunt(la,mma,sa,lb,mmb,sb,2_t_int,0_t_int,1_t_int)*sq3o3
    g=0.0_t_real
    If(la==lb.And.ma==mb)Then
       g=c1o3
    Endif
    rr(1,1)=g22-g20+g
    rr(2,2)=-g22-g20+g
    rr(3,3)=g20*2.0_t_real+g
    !!
    Return
    !!
  End Subroutine dyadeMatEl_bhf
  !!***********************************************************************
  Subroutine rel_calcbhfMatrix(p_bhf,oci_nr&
       &,bmesh,nrbmax,degree&
       &,nRmxa,nRmxb,nRa,kapRa,degRa,nRb,kapRb,degRb&
       &,fna,fnb&
       &,fgam&
       &,lmax,MatElBhf&
       &,rnuc,nuc_type)
    !!
    Implicit None
    !!IO
    Type(T_Mesh),Intent(in)      :: bmesh
    Integer(t_int),Intent(in)    :: nuc_type
    Real(t_real),Intent(in)      :: rnuc
    Integer(t_int),Intent(in)    :: oci_nr,degree
    Integer(t_int),Intent(in)    :: nrbmax,lmax
    Integer(t_int),Intent(in)    :: nRmxa,nRmxb
    Integer(t_int),Intent(in)    :: nRa,kapRa(nRmxa),degRa(nRmxa)
    Integer(t_int),Intent(in)    :: nRb,kapRb(nRmxb),degRb(nRmxb)
    Real(t_real),Intent(in)      :: fgam
    Real(t_real),Intent(in)      :: MatElBhf(&
         &-lmax-1:lmax&
         &,-(2*lmax+1):(2*lmax+1)&
         &,-lmax-1:lmax&
         &,-(2*lmax+1):(2*lmax+1)&
         &,1:3)
    Real(t_real),Intent(in)      :: fna (nrbmax,nRmxa,2)
    Real(t_real),Intent(in)      :: fnb (nrbmax,nRmxb,2)
    Real(t_real),Intent(out)      :: p_bhf(:,:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="rel_calcbhfMatrix"
    Integer(t_int) :: ia,ib,icomp,ir,nr,i,j,kapa,kapb,ja,jb,ma,mb,mua,mub,q
    Real(t_real)   :: rp,xp,wp,texp,d,fa(2),fb(2)
    Real(t_real)   :: ffa(nRa,2)
    Real(t_real)   :: ffb(nRb,2)
    Real(t_real),Pointer :: p_xx(:),p_rr(:),p_ww(:)
    !!
    Call prep_oci_int_mesh(oci_nr,rnuc,bmesh% rmax,nuc_type,p_xx,p_rr,p_ww,nr)
    !!
    !!
    p_bhf(:,:,:)=0.0_t_real
    Do ir=1,nr
       !!
       xp=p_xx(ir)
       rp=p_rr(ir)
       wp=p_ww(ir)
       !!
       Do ia=1,nRa
          !! basis orbital
          texp=rp**fgam
          Do icomp=1,2
             ffa(ia,icomp)= minterpol(bmesh,degree&
                  &,fna (1_t_int,ia,icomp),rp)*texp
          Enddo
       Enddo
       Do ib=1,nRb
          !! basis orbital
          texp=rp**fgam
          Do icomp=1,2
             ffb(ib,icomp)= minterpol(bmesh,degree&
                  &,fnb (1_t_int,ib,icomp),rp)*texp
          Enddo
       Enddo
       !!
       i=0
       Do ia=1_t_int,nRa
          kapa=kapRa(ia)
          ja=2*Abs(kapa)-1
          fa(1:2)=ffa(ia,1:2)
          Do ma=1,degRa(ia)
             mua=-ja+2*(ma-1)
             i=i+1
             j=0
             Do ib=1_t_int,nRb
                kapb=kapRb(ib)
                jb=2*Abs(kapb)-1
                fb(1:2)=ffb(ib,1:2)
                mbloop: Do mb=1,degRb(ib)
                   mub=-jb+2*(mb-1)
                   j=j+1
                   !!
                   d=(fa(1)*fb(2)+fa(2)*fb(1))/rp**2*wp
                   !!
                   Do q=1,3
                      p_bhf(i,j,q)=p_bhf(i,j,q)+MatElBhf(kapa,mua,kapb,mub,q)*d
                   Enddo
                   !!
                Enddo mbloop
             Enddo               ! ib
          Enddo                 ! ma
       Enddo                   ! ia
    Enddo                     ! ir
    !!
    Call pfree(p_xx)
    Call pfree(p_rr)
    Call pfree(p_ww)
    !!
    Return
    !!
  End Subroutine rel_calcbhfMatrix
  !!***********************************************************************
  Subroutine srel_calcbhfMatrix(p_bhf,oci_nr&
       &,bmesh,nrbmax,degree&
       &,ncomp,nRmxa,nRmxb,nRa,lRa,nRb,lRb&
       &,fna,fnb&
       &,fgam&
       &,lmax&
       &,MatElBhf&
       &,rnuc,nuc_type)
    !!
    !! SREL Fermi contact term (only ss contrib)
    !!
    !! equivalent of spin-dipole nuclear-dipole term 
    !! make no sense in a framework without spinorbit coupling -> omitted
    !!
    !! the orbital term will be zero in almost all cases without SO coupling
    !! ->omitted
    !!
    Implicit None
    !!IO
    Type(T_Mesh),Intent(in)      :: bmesh
    Integer(t_int),Intent(in)    :: nuc_type,ncomp
    Real(t_real),Intent(in)      :: rnuc
    Integer(t_int),Intent(in)    :: oci_nr,degree
    Integer(t_int),Intent(in)    :: nrbmax,lmax
    Integer(t_int),Intent(in)    :: nRmxa,nRmxb
    Integer(t_int),Intent(in)    :: nRa,lRa(nRmxa)
    Integer(t_int),Intent(in)    :: nRb,lRb(nRmxb)
    Real(t_real),Intent(in)      :: fgam
    Real(t_real),Intent(in)      :: MatElBhf(0:lmax,-lmax:lmax&
         &,0:lmax,-lmax:lmax,1:3)
    Real(t_real),Intent(in)      :: fna (nrbmax,nRmxa,ncomp)
    Real(t_real),Intent(in)      :: fnb (nrbmax,nRmxb,ncomp)
    Real(t_real),Intent(out)      :: p_bhf(:,:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="srel_calcbhfMatrix"
    Integer(t_int) :: ia,ib,icomp,ir,nr,i,j,la,lb,ma,mb,q
    Real(t_real)   :: rp,xp,wp,texp,d,fa(4),fb(4),c
    Real(t_real)   :: ffa(nRa,ncomp)
    Real(t_real)   :: ffb(nRb,ncomp)
    Real(t_real),Pointer :: p_xx(:),p_rr(:),p_ww(:)
    !!
    Call prep_oci_int_mesh(oci_nr,rnuc,bmesh% rmax,nuc_type,p_xx,p_rr,p_ww,nr)
    !!
    !!
    !!
    p_bhf(:,:,:)=0.0_t_real
    Do ir=1,nr
       !!
       xp=p_xx(ir)
       rp=p_rr(ir)
       wp=p_ww(ir)
       !!
       Do ia=1,nRa
          !! basis orbital
          texp=rp**fgam
          Do icomp=1,ncomp
             ffa(ia,icomp)= minterpol(bmesh,degree,fna(1,ia,icomp),rp)*texp
          Enddo
       Enddo
       Do ib=1,nRb
          !! basis orbital
          texp=rp**fgam
          Do icomp=1,ncomp
             ffb(ib,icomp)= minterpol(bmesh,degree,fnb(1,ib,icomp),rp)*texp
          Enddo
       Enddo
       !!
       i=0
       Do ia=1,nRa
          la=lRa(ia)
          fa(1:ncomp)=ffa(ia,1:ncomp)
          Do ma=1,2*la+1
             i=i+1
             j=0
             Do ib=1,nRb
                lb=lRb(ib)
                fb(1:ncomp)=ffb(ib,1:ncomp)
                mbloop: Do mb=1,2*lb+1
                   j=j+1
                   !!
                   !! equivalent of Fermi contact term
                   d=(fa(1)*fb(2)+fa(2)*fb(1))/rp**2*wp
                   !!
                   !Do q=1,3
                   q=3
                   c=MatElBhf(la,ma-la-1,lb,mb-lb-1,q)
                   If(.Not.(la==lb.And.la==0)) c=0.0_t_real !! only ss for now
                   p_bhf(i,j,q)=p_bhf(i,j,q)+c*d
                   !Enddo
                   !!
                   !!
                   !!
                Enddo mbloop
             Enddo               ! ib
          Enddo                 ! ma
       Enddo                   ! ia
    Enddo                     ! ir
    !!
    Call pfree(p_xx)
    Call pfree(p_rr)
    Call pfree(p_ww)
    !!
    Return
    !!
  End Subroutine srel_calcbhfMatrix
  !!***********************************************************************
End Module BHF
