!!***********************************************************************
Module densmatint
  !!
  Use precisiondefs
  Use file_iounits
  Use errors
  Use matserv
  Use memory
  Use constants
  Use ioaux
  Use diagonalize
  !!
  Implicit None
  !!
  Private
  !!
  Character(*),Parameter::nmodule="densmatint"    
  !!
  Public :: rotate_Ylm
  !!***********************************************************************
Contains
  !!***********************************************************************
  Subroutine  rotate_Ylm()
    !!
    Implicit None  
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="rotate_Ylm"    
    Character(1000)   :: str
    Logical(t_log) :: cx
    Integer(t_int) :: i,j,ll,m,n,deg
    Real(t_real)   :: d,eu(3)
    Real(t_real)   :: newx(3),newy(3),newz(3),RR(3,3),MM(3,3)
    Real(t_real),Pointer  :: p_wu(:,:)
    Real(t_real),Pointer  :: p_fac(:)
    !!
    Nullify(p_wu)
    Nullify(p_fac)
    !!
    Write(outfile,1)Trim(nsubfunc)
    !!
    !!
    !!
    !!
    Write(outfile,10,advance='no')
10  Format(' New x-axis: ')
    Read(*,*)newx(:)
    Write(outfile,11,advance='no')
11  Format(' New z-axis: ')
    Read(*,*)newz(:)
    Write(outfile,*)
    !!
    !!
    !!
    d=Dot_product(newx,newx)
    If(d<=0.0_t_real) Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg='"new x-axis has zero lenght?!"')
    Endif
    newx=newx/Sqrt(d)
    d=Dot_product(newz,newz)
    If(d<=0.0_t_real) Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg='"new z-axis has zero lenght?!"')
    Endif
    newz=newz/Sqrt(d)
    !!
    !Print *,'x=',newx
    !!Print *,'z=',newz
    !!
    !! scalar product of x and z
    d=Dot_product(newx,newz)
    !Print *,'x*z=',d
    !!
    If(Abs(d-0.0_t_real)>=1.0e-6_t_real) Then
       Call errmsg(nmodule,nsubfunc,E_warning&
            &,msg='/,"new x- and z-axis are not orthogonal?!",/&
            &," will correct x-axis accordingly -> check data!",/')
    Endif
    !!
    !!
    !! make newx ortho to new z
    newx=newx-newz*d
    !!
    d=Dot_product(newx,newx)
    If(d<=1.0e-12_t_real) Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg='"corrected new x-axis has zero lenght?!"')
    Endif
    newx=newx/Sqrt(d)
    !!
    !!
    !!
    Call cross(newz,newx,newy)
    !!
    Write(outfile,12) newx(:)
12  Format('new x: ',3(f12.7,2x))
    Write(outfile,13) newy(:)
13  Format('new y: ',3(f12.7,2x))
    Write(outfile,14) newz(:)
14  Format('new z: ',3(f12.7,2x))
    !!
    Write(outfile,*)
    !!
    RR(:,1)=newx
    RR(:,2)=newy
    RR(:,3)=newz
    !!
    Write(outfile,"(' E^T = (e_x,e_y,e_z) ')")
    Write(outfile,"(' E''^T=E^T R ')")
    Write(outfile,15) RR(1,:)
    Write(outfile,15) RR(2,:)
    Write(outfile,15) RR(3,:)
15  Format('R: ',3(f12.7,2x))
    Write(outfile,*)
    !!
    !!
    !!
    !!
    Call reuler2(newz,newx,eu)
    Write(outfile,*)
    Write(outfile,17)eu/Pi*180_t_real
17  Format('Euler angles of this transformation: ',/&
         &,'al: ',f12.7,/&
         &,'be: ',f12.7,/&
         &,'ga: ',f12.7,/)
    !!
    Call m_euler(MM,eu)
    !!
    If(Any(Abs(MM-RR)>1.0e-7_t_real))Then
       Write(outfile,*)
       Do i=1,3
          Write(outfile,16)MM(i,:)
16        Format('R from euler anlges: ',3(f12.7,2x))
       Enddo
       Write(outfile,*)
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg='"Transformation matrix wrong?!"')
    Endif
    !!
    !!
    !!
    Write(outfile,20,advance='no')
20  Format(' Which l: ')
    Read(*,*) ll
    Write(outfile,*)
    !!
    deg=2*ll+1
    !!
    Write(outfile,21) ll
21  Format(' selected l=',i2)
    Write(outfile,*)
    !!
    !!
    Call palloc('p_fac',p_fac,0_t_int,deg,nmodule,nsubfunc)
    Call palloc('p_wu',p_wu,1_t_int,(deg),1_t_int,(deg)&
         &,nmodule,nsubfunc)
    !!
    Call make_factorials(p_fac,deg)
    !!
    Call ytr(eu,0_t_int,p_fac,ll,p_wu,.True.)
    !!
    !!
    !!
    !!
    !!
    !!
    Write(outfile,29)
29  Format('Y''_{lm}=\sum_{n} Y_{ln} D^l_{nm}',/)
    !!
    Write(outfile,33,advance='no')
33  Format(7(' '))
    Do j=1,deg
       Write(outfile,32,advance='no')ll,j-ll-1
    Enddo
    Write(outfile,*)
32  Format(('     Y',i1,spi2,'    '))
    Do i=1,deg
       Write(outfile,30,advance='no') ll,i-ll-1
       Do j=1,deg
          d=p_wu(j,i)
          Call double_to_string_as_sq_ratio(d,str,10000_t_int,1.0e-10_t_real&
               &,"(f15.9)")
          Write(outfile,31,advance='no')str
       Enddo
       Write(outfile,*)
    Enddo
    !!
30  Format('Y''',i1,spi2,': ')
31  Format(a15,' ')
    !!
    !!
    !!
    !!
    !! transform local into global occupation matrix
    !! Y'=YD
    Write(outfile,*)
    Write(outfile,"('Y''=YD')")
    !!
    !! Y n Y^{+} = Y' D^{+} n D Y'^{+}
    Write(outfile,*)
    Write(outfile,"('Y n Y^{+} = Y'' D^{+} n D Y''^{+}')")
    !!
    !!  n'  =  D^{+} n  D 
    !!  n   =  D     n' D^{+}   
    Write(outfile,*)
    Write(outfile,"('n''  =  D^{+} n  D ')")
    Write(outfile,"('n   =  D     n'' D^{+}   ')")
    Write(outfile,*)
    !!

    !!
    Write(outfile,120,advance='no')
120 Format(' Complex density matrix input (2 times 5x5)? : ')
    Read(*,*) cx
    Write(outfile,*)
    If(cx) Then
       Write(outfile,121) 
121    Format(' Complex density matrix input (2 times 5x5) ',l2)
    Else
       Write(outfile,221) 
221    Format(' Real density matrix input (1 times 5x5, only real part) ',l2)
    Endif
    Write(outfile,*)

    !!
    !!
    !!
    If(.Not.cx) Then
       Call real_case(deg,p_wu)
    Else
       Call complex_case(deg,p_wu)
    Endif
    !!
    !!
    Call pfree(p_fac)
    Call pfree(p_wu)
    !!
    Write(outfile,2)Trim(nsubfunc)
    !!
    !!
    Return
    !!
1   Format('START: ',a)
2   Format('END:   ',a)
    !!
  End Subroutine rotate_Ylm
  !!*********************************************************************** 
  Subroutine complex_case(deg,p_wu)
    !!
    Implicit none  
    !!IO
    Integer(t_int),Intent(in)    :: deg
    Real(t_real),Intent(in)      :: p_wu(:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="complex_case"    
    Logical(t_log) :: localtoglobal,cxinp
    Integer(t_int) :: i,j,l
    Real(t_real)   :: dum(deg)
    Complex(t_real),Pointer  :: p_cni(:,:)
    Complex(t_real),Pointer  :: p_cnr(:,:)
    Complex(t_real),Pointer  :: p_cn(:,:)
    Complex(t_real),Pointer  :: p_Uylm(:,:,:)
    Real(t_real),Pointer  :: p_e(:)
    !!
    l=(deg-1)/2
    !!
    Nullify(p_cn)
    Nullify(p_e)
    Nullify(p_cni)
    Nullify(p_cnr)
    Nullify(p_Uylm)
    !!
    Call palloc('p_cn'  ,p_cn  ,1_t_int,deg,1_t_int,deg,nmodule,nsubfunc)
    Call palloc('p_cni' ,p_cni ,1_t_int,deg,1_t_int,deg,nmodule,nsubfunc)
    Call palloc('p_cnr' ,p_cnr ,1_t_int,deg,1_t_int,deg,nmodule,nsubfunc)
    Call palloc('p_Uylm',p_Uylm,1_t_int,deg,1_t_int,deg,0_t_int,l&
         &,nmodule,nsubfunc)

    !!
    Call  make_ylm_U_matrix(l,p_Uylm)
    !!


    !!
    Write(outfile,120,advance='no')
120 Format(' input in complex harmonics? : ')
    Read(*,*) cxinp
    Write(outfile,*)
    Write(outfile,121) cxinp
121 Format(' input in complex harmonics ',l2)
    Write(outfile,*)
    !!
    !! read data
    Write(outfile,40,advance='no')
40  Format(' occupation matrix real part: ')
    Do i=1,deg
       Read(*,*)dum(1:deg)
       Do j=1,deg
          p_cni(i,j)=Cmplx(dum(j),0.0_t_real,t_real)
       Enddo
    Enddo
    !!
    Write(outfile,140,advance='no')
140 Format(' occupation matrix imaginary part: ')
    Do i=1,deg
       Read(*,*)dum(1:deg)
       Do j=1,deg
          p_cni(i,j)=Cmplx(Real(p_cni(i,j),t_real),dum(j),t_real)
       Enddo
    Enddo
    !!
    If(cxinp) Then
       !! transform into real input
       p_cni=Matmul(p_Uylm(1:deg,1:deg,l)&
            &,Matmul(p_cni(1:deg,1:deg)&
            &,Transpose(Conjg(p_Uylm(1:deg,1:deg,l)))))
    Endif
    !!
45  Format(' input occupation matrix in ',a,' harmonics: ')
    Write(outfile,*)
    Write(outfile,45)'real'
    Call cprint_dmat(deg,p_cni)
    !!
    !! \cal{y} = Y U
    !! Y nr Y^{+} = \cal{Y} U^{+} nr U \cal{Y}^{+}
    !! nc=U^{+} nr U
    p_cn=Matmul(Transpose(Conjg(p_Uylm(1:deg,1:deg,l)))&
         &,Matmul(p_cni(1:deg,1:deg),p_Uylm(1:deg,1:deg,l)))
    !!
    Write(outfile,*)
    Write(outfile,45)'complex'
    Call cprint_dmat(deg,p_cn)

    !!
    Write(outfile,50,advance='no')
50  Format(' transform local to global?: ')
    Read(*,*)localtoglobal
    Write(outfile,*)
    !!
    !!
    Write(outfile,*)
    If(localtoglobal)Then
       Write(outfile,"('local to global')")
    Else
       Write(outfile,"('global to local')")
    Endif
    Write(outfile,*)
    !!
    If(localtoglobal)Then
       p_cnr=Matmul(p_wu,Matmul(p_cni,Transpose(p_wu)))
    Else
       p_cnr=Matmul(Transpose(p_wu),Matmul(p_cni,p_wu))
    Endif
    !!
    !!
    If(localtoglobal)Then
       Write(outfile,48) 'global','real'
    Else
       Write(outfile,48) 'local','real'
    Endif
48  Format(' resulting ',a,' occupation matrix in ',a,' harmonics: ')
    Call cprint_dmat(deg,p_cnr)
    !!
    !!
    p_cn=Matmul(Transpose(Conjg(p_Uylm(1:deg,1:deg,l)))&
         &,Matmul(p_cnr(1:deg,1:deg),p_Uylm(1:deg,1:deg,l)))
    !!
    If(localtoglobal)Then
       Write(outfile,48)'global','complex'
    Else
       Write(outfile,48)'local','complex'
    Endif
    Call cprint_dmat(deg,p_cn)
    !!
    !! diagonalization of the matrix in the current (transformed rep)
    !!
    Call palloc('p_e',p_e,1_t_int,deg,nmodule,nsubfunc)
    !!
    !!
    p_cn(:,:)=p_cnr(:,:)
    Call cdiagno_noO(deg,p_cn,p_e)
    !!
    !!
    Write(outfile,*)
    Write(outfile,145) 'real'
145 Format(' diagonalization transformation of transformed matrix in ',a&
         &,' harmonics  : n C = C d ')
    Write(outfile,146)
146 Format(' C= ')
    Call cprint_dmat(deg,p_cn)
    Write(outfile,*)
    Write(outfile,*)
    Write(outfile,147,advance='no')
147 Format(' d= ')
    Do j=1,deg
       Write(outfile,141,advance='no')p_e(j)
141    Format(f12.7,' ')
    Enddo
    Write(outfile,*)
    Write(outfile,*)
    !!
    !! now diagonalize the complex representation
    p_cn=Matmul(Transpose(Conjg(p_Uylm(1:deg,1:deg,l)))&
         &,Matmul(p_cnr(1:deg,1:deg),p_Uylm(1:deg,1:deg,l)))
    Call cdiagno_noO(deg,p_cn,p_e)
    !!
    !!
    Write(outfile,*)
    Write(outfile,145) 'complex'
    Write(outfile,146)
    Call cprint_dmat(deg,p_cn)
    Write(outfile,*)
    Write(outfile,*)
    Write(outfile,147,advance='no')
    Do j=1,deg
       Write(outfile,141,advance='no')p_e(j)
    Enddo
    Write(outfile,*)
    Write(outfile,*)
    !!
    Call pfree(p_Uylm)
    Call pfree(p_cnr)
    Call pfree(p_cni)
    Call pfree(p_e)
    Call pfree(p_cn)
    !!
    Return
    !!
  End Subroutine complex_case
  !!***********************************************************************
  Subroutine cprint_dmat(deg,dmat)
    !!
    Implicit None  
    !!IO
    Integer(t_int),Intent(in)    :: deg
    Complex(t_real),Intent(in)   :: dmat(deg,deg)
    !!LOCAL
    Integer(t_int) :: i,j
    !!
    !!
    Write(outfile,65)'real'
    !!
    Do i=1,deg
       Write(outfile,42,advance='no') i
       Do j=1,deg
          Write(outfile,41,advance='no')Real(dmat(i,j),t_real)
       Enddo
       Write(outfile,*)
    Enddo
    Write(outfile,*)
    !!
    Write(outfile,65)'imaginary'
    Do i=1,deg
       Write(outfile,42,advance='no') i
       Do j=1,deg
          Write(outfile,41,advance='no')Aimag(dmat(i,j))
       Enddo
       Write(outfile,*)
    Enddo
    !!
    Return
    !!
41  Format(f12.7,' ')
42  Format('n',spi2,': ')
65  Format(a,' part: ')
    !!
  End Subroutine cprint_dmat
  !!*********************************************************************** 
  Subroutine real_case(deg,p_wu)
    !!
    Implicit none  
    !!IO
    Integer(t_int),Intent(in)    :: deg
    Real(t_real),Intent(in)      :: p_wu(:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="real_case"    
    Logical(t_log) :: localtoglobal
    Integer(t_int) :: i,j
    Real(t_real)   :: dum(deg)
    Real(t_real),Pointer  :: p_ni(:,:)
    Real(t_real),Pointer  :: p_nr(:,:)
    Real(t_real),Pointer  :: p_n(:,:)
    Real(t_real),Pointer  :: p_e(:)
    !!
    Nullify(p_n)
    Nullify(p_e)
    Nullify(p_ni)
    Nullify(p_nr)
    !!
    Call palloc('p_ni',p_ni,1_t_int,deg,1_t_int,deg,nmodule,nsubfunc)
    Call palloc('p_nr',p_nr,1_t_int,deg,1_t_int,deg,nmodule,nsubfunc)
    !!
    Write(outfile,40,advance='no')
40  Format(' occupation matrix: ')
    Do i=1,deg
       Read(*,*)dum(1:deg)
       p_ni(i,1:deg)=dum(1:deg)
    Enddo
    !!
    Write(outfile,*)
    Write(outfile,45)
45  Format(' input occupation matrix: ')
    Do i=1,deg
       Write(outfile,42,advance='no') i
42     Format('n',spi2,': ')
       Do j=1,deg
          Write(outfile,41,advance='no')p_ni(i,j)
41        Format(f12.7,' ')
       Enddo
       Write(outfile,*)
    Enddo
    !!
    !!
    Write(outfile,50,advance='no')
50  Format(' transform local to global?: ')
    Read(*,*)localtoglobal
    Write(outfile,*)
    !!
    !!
    Write(outfile,*)
    If(localtoglobal)Then
       Write(outfile,"('local to global')")
    Else
       Write(outfile,"('global to local')")
    Endif
    Write(outfile,*)
    !!
    If(localtoglobal)Then
       p_nr=Matmul(p_wu,Matmul(p_ni,Transpose(p_wu)))
       Write(outfile,47)
47     Format(' resulting global occupation matrix: ')
    Else
       p_nr=Matmul(Transpose(p_wu),Matmul(p_ni,p_wu))
       Write(outfile,48)
48     Format(' resulting local occupation matrix: ')
    Endif
    !!
    !!
    Do i=1,deg
       Write(outfile,42,advance='no') i
       Do j=1,deg
          Write(outfile,41,advance='no')p_nr(i,j)
       Enddo
       Write(outfile,*)
    Enddo
    !!
    !!
    !!
    !! diagonalization of the matrix in the current (transformed rep)
    !!
    Call palloc('p_n',p_n,1_t_int,deg,1_t_int,deg,nmodule,nsubfunc)
    Call palloc('p_e',p_e,1_t_int,deg,nmodule,nsubfunc)
    p_n(:,:)=p_nr(:,:)
    !!
    !!
    Call rdiagno_noO(deg,p_n,p_e)
    !!
    !!
    Write(outfile,*)
    Write(outfile,145)
145 Format(' diagonalization transformation of transformed matrix  : n C = C d ')
    Write(outfile,146)
146 Format(' C= ')
    Do i=1,deg
       Write(outfile,42,advance='no') i
       Do j=1,deg
          Write(outfile,41,advance='no')p_n(i,j)
       Enddo
       Write(outfile,*)
    Enddo
    Write(outfile,*)
    Write(outfile,*)
    Write(outfile,147,advance='no')
147 Format(' d= ')
    Do j=1,deg
       Write(outfile,41,advance='no')p_e(j)
    Enddo
    Write(outfile,*)
    Write(outfile,*)
    !!
    Call pfree(p_nr)
    Call pfree(p_ni)
    Call pfree(p_e)
    Call pfree(p_n)
    !!
    Return
    !!
  End Subroutine real_case
  !!*********************************************************************** 
  Subroutine double_to_string_as_sq_ratio(d,str,maxn,tol,fmt)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: maxn
    Real(t_real),Intent(in)     :: d,tol
    Character(*),Intent(in)     :: fmt
    Character(*),Intent(out)    :: str
    !!LOCAL
    Character(2000)  :: mstr,nstr
    Integer(t_int)    :: m,n
    Real(t_real)   :: d2,s
    !!
    Call make_ratio(d,m,n,maxn,tol)
    If(n==0_t_int)Then
       !Print *,'n==0'
       d2=d*d
       s=Sign(1.0_t_real,d)
       !Print *,'d=',d,' d2=',d2
       Call make_ratio(d2,m,n,maxn,tol)
       !Print *,'n=',n,' m=',m
       If(n==0_t_int)Then
          Write(mstr,fmt)d
          Write(str,1) Trim(Adjustl(mstr))
       Else If(n==1_t_int) Then
          Write(mstr,2)m
          If(s<0)Then
             Write(str,22) Trim(Adjustl(mstr))
          Else
             Write(str,23) Trim(Adjustl(mstr))
          Endif
       Else
          Write(mstr,2)m
          Write(nstr,2)n
          If(s<0)Then
             Write(str,32) Trim(Adjustl(mstr)),Trim(Adjustl(nstr))
          Else
             Write(str,33) Trim(Adjustl(mstr)),Trim(Adjustl(nstr))
          Endif
       Endif
    Else If(n==1_t_int)Then
       Write(mstr,2)m
       Write(str,1) Trim(Adjustl(mstr))
    Else
       Write(mstr,2)m
       Write(nstr,2)n
       Write(str,3) Trim(Adjustl(mstr)),Trim(Adjustl(nstr))
    Endif
1   Format(a)
2   Format(i15)
22  Format('-sqrt(',a,')')
23  Format(' sqrt(',a,')')
3   Format(a,'/',a)
32  Format('-sqrt(',a,'/',a,')')
33  Format(' sqrt(',a,'/',a,')')
  End Subroutine double_to_string_as_sq_ratio
  !!***********************************************************************
End Module densmatint

