!!info
!!info  RELATIVISTIC ATOM PROGRAM WITH simple SIC correction
!!info
!!info             by Klaus Koepernik
!!info
!!info  Okt 2001
!! ---------------------------------------------------------------------------
Program dirac
  !!
  Use precisiondefs
  Use file_iounits
  Use tatom
  Use tio
  Use memory
  Use ioadapter
  Use diracdriver
  Use iteration
  Use fedit
  Use optionstest
  Use errors
  Use versioncontrol
  Use diracdata
  Use diracio
  Use helpdirac
  !!
  Implicit None
  !!
  !!     
  !Character(*),Parameter::nmodule="PROGRAM"
  !Character(*),Parameter::nsubfunc="main"
  !!***********************************************************************
  !!
  Include '../mainversion.h'
  Include '../subversion.h'
  Include '../release.h'
  !!
  APPLICATIONNAME="dirac"
  !!
  g_debug=.True.
  !!
  Open(errfile,file=f_error,status='unknown')
  Close(errfile,status='delete')
  !!
  !!ONLY FOR TESTS: speed_of_light=speed_of_light*1.0e10_t_real
  !!
  Call sizetest
  Call init_mem_stat(.False.)
  !!
  Call init_options
  !!
  !!
  Call setoutlevel(Int(L_many,t_int))

  Call create_helpfile_dirac
  call create_atomfedit
  !!
  Call init_tatom(g_atomat)
  !! default init input data
  Call diracinit(g_atomat)

  !! input data
  Call iodirac(g_atomat)
  !!
  !! setup allocatable arrays
  Call diracsetup(g_atomat)
  !! do calculation
  Call iterate(sccatom,"atom",.False.,.True.)
  !! cleanup
  Call clean_tatom(g_atomat)
  !! ready 
  Call terminate(TERM_FINISH,'SCF calculation')
  !!
End Program dirac
!!***********************************************************************
