Module diracio
  !!
  Use precisiondefs
  Use file_iounits
  Use memory
  Use versioncontrol
  Use constants
  Use ioadapter
  Use errors
  Use tio
  Use atomdefs
  Use finuc
  Use tatom
  Use tmesh
  Use titeration
  Use trelativistic
  Use optionstest
  Use xc
  Use ioaux
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="DIRACIO"  
  !!
  Public :: create_atominfile,header,iodirac,diracinit&
       &,set_def_atom_basis_and_occus,updateRawOccus
  !!***********************************************************************
  !!***********************************************************************
  Character(59),Private   :: default_config(0:MAX_ELEMENT)
  Data default_config(0:10)/ &
       & 'E :  0: 1s                                                 '&
       !1s
       &,'H :  1: 1s                                                 '&
       &,'He:  2: 1s                                                 '&
       !2s
       &,'Li:  3: 1s2s                                               '&
       &,'Be:  4: 1s2s                                               '&
       !2p
       &,'B :  5: 1s2s2p                                             '&
       &,'C :  6: 1s2s2p                                             '&
       &,'N :  7: 1s2s2p                                             '&
       &,'O :  8: 1s2s2p                                             '&
       &,'F :  9: 1s2s2p                                             '&
       &,'Ne: 10: 1s2s2p                                             '&
       &/
  Data default_config(11:20)/ &
       !3s
       & 'Na: 11: 1s2s2p3s                                           '&
       &,'Mg: 12: 1s2s2p3s                                           '&
       !3p
       &,'Al: 13: 1s2s2p3s3p                                         '&
       &,'Si: 14: 1s2s2p3s3p                                         '&
       &,'P : 15: 1s2s2p3s3p                                         '&
       &,'S : 16: 1s2s2p3s3p                                         '&
       &,'Cl: 17: 1s2s2p3s3p                                         '&
       &,'Ar: 18: 1s2s2p3s3p                                         '&
       !4s
       &,'K : 19: 1s2s2p3s3p4s                                       '&
       &,'Ca: 20: 1s2s2p3s3p4s                                       '/
  Data default_config(21:40)/ &
       !3d
       & 'Sc: 21: 1s2s2p3s3p3d4s                                     '&
       &,'Ti: 22: 1s2s2p3s3p3d4s                                     '&
       &,'V : 23: 1s2s2p3s3p3d4s                                     '&
       &,'Cr: 24: 1s2s2p3s3p3d4s                                     '&
       &,'Mn: 25: 1s2s2p3s3p3d4s                                     '&
       &,'Fe: 26: 1s2s2p3s3p3d4s                                     '&
       &,'Co: 27: 1s2s2p3s3p3d4s                                     '&
       &,'Ni: 28: 1s2s2p3s3p3d4s                                     '&
       &,'Cu: 29: 1s2s2p3s3p3d4s                                     '&
       &,'Zn: 30: 1s2s2p3s3p3d4s                                     '&
       !4p 
       &,'Ga: 31: 1s2s2p3s3p3d4s4p                                   '&
       &,'Ge: 32: 1s2s2p3s3p3d4s4p                                   '&
       &,'As: 33: 1s2s2p3s3p3d4s4p                                   '&
       &,'Se: 34: 1s2s2p3s3p3d4s4p                                   '&
       &,'Br: 35: 1s2s2p3s3p3d4s4p                                   '&
       &,'Kr: 36: 1s2s2p3s3p3d4s4p                                   '&
       !5s
       &,'Rb: 37: 1s2s2p3s3p3d4s4p5s                                 '&
       &,'Sr: 38: 1s2s2p3s3p3d4s4p5s                                 '&
       !4d
       &,'Y : 39: 1s2s2p3s3p3d4s4p4d5s                               '&
       &,'Zr: 40: 1s2s2p3s3p3d4s4p4d5s                               '/
  Data default_config(41:60)/ &
       & 'Nb: 41: 1s2s2p3s3p3d4s4p4d5s                               '&
       &,'Mo: 42: 1s2s2p3s3p3d4s4p4d5s                               '&
       &,'Tc: 43: 1s2s2p3s3p3d4s4p4d5s                               '&
       &,'Ru: 44: 1s2s2p3s3p3d4s4p4d5s                               '&
       &,'Rh: 45: 1s2s2p3s3p3d4s4p4d5s                               '&
       &,'Pd: 46: 1s2s2p3s3p3d4s4p4d5s                               '&
       &,'Ag: 47: 1s2s2p3s3p3d4s4p4d5s                               '&
       &,'Cd: 48: 1s2s2p3s3p3d4s4p4d5s                               '&
       !5p 
       &,'In: 49: 1s2s2p3s3p3d4s4p4d5s5p                             '&
       &,'Sn: 50: 1s2s2p3s3p3d4s4p4d5s5p                             '&
       &,'Sb: 51: 1s2s2p3s3p3d4s4p4d5s5p                             '&
       &,'Te: 52: 1s2s2p3s3p3d4s4p4d5s5p                             '&
       &,'I : 53: 1s2s2p3s3p3d4s4p4d5s5p                             '&
       &,'Xe: 54: 1s2s2p3s3p3d4s4p4d5s5p                             '&
       !6s
       &,'Cs: 55: 1s2s2p3s3p3d4s4p4d5s5p6s                           '&
       &,'Ba: 56: 1s2s2p3s3p3d4s4p4d5s5p6s                           '&
       !5d
       &,'La: 57: 1s2s2p3s3p3d4s4p4d5s5p5d6s                         '&
       !4f
       &,'Ce: 58: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Pr: 59: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Nd: 60: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '/
  Data default_config(61:80)/ &
       & 'Pm: 61: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Sm: 62: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Eu: 63: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Gd: 64: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Tb: 65: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Dy: 66: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Ho: 67: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Er: 68: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Tm: 69: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Yb: 70: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Lu: 71: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       !5d
       &,'Hf: 72: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Ta: 73: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'W : 74: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Re: 75: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Os: 76: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Ir: 77: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Pt: 78: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Au: 79: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '&
       &,'Hg: 80: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s                       '/
  Data default_config(81:99)/ &
       !6p 
       & 'Tl: 81: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p                     '&
       &,'Pb: 82: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p                     '&
       &,'Bi: 83: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p                     '&
       &,'Po: 84: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p                     '&
       &,'At: 85: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p                     '&
       &,'Rn: 86: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p                     '&
       !7s 
       &,'Fr: 87: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p7s                   '&
       &,'Ra: 88: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p7s                   '&
       !6d
       &,'Ac: 89: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p6d7s                 '&
       !5f
       &,'Th: 90: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'Pa: 91: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'U : 92: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'Np: 93: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'Pu: 94: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'Am: 95: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'Cm: 96: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'Bk: 97: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'Cf: 98: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'Es: 99: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '/
  Data default_config(100:103)/ &
       & 'Fm:100: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'Md:101: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'No:102: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &,'Lr:103: 1s2s2p3s3p3d4s4p4d4f5s5p5d6s6p5f6d7s               '&
       &/
  !!
  Character(59),Private   :: occu_config(0:MAX_ELEMENT)
  Data occu_config(0:10)/ &
       & 'E :  0: 00                                                 '&
       !1s
       &,'H :  1: 10                                                 '&
       &,'He:  2: 11                                                 '&
       !2s
       &,'Li:  3: 1110                                               '&
       &,'Be:  4: 1111                                               '&
       !2p
       &,'B :  5: 111110                                             '&
       &,'C :  6: 111120                                             '&
       &,'N :  7: 111130                                             '&
       &,'O :  8: 111131                                             '&
       &,'F :  9: 111132                                             '&
       &,'Ne: 10: 111133                                             '&
       &/
  Data occu_config(11:20)/ &
       !3s
       & 'Na: 11: 11113310                                           '&
       &,'Mg: 12: 11113311                                           '&
       !3p
       &,'Al: 13: 1111331110                                         '&
       &,'Si: 14: 1111331120                                         '&
       &,'P : 15: 1111331130                                         '&
       &,'S : 16: 1111331131                                         '&
       &,'Cl: 17: 1111331132                                         '&
       &,'Ar: 18: 1111331133                                         '&
       !4s
       &,'K : 19: 111133113310                                       '&
       &,'Ca: 20: 111133113311                                       '/
  Data occu_config(21:40)/ &
       !3d
       & 'Sc: 21: 11113311331011                                     '&
       &,'Ti: 22: 11113311332011                                     '&
       &,'V : 23: 11113311333011                                     '&
       &,'Cr: 24: 11113311335010                                     '&
       &,'Mn: 25: 11113311335011                                     '&
       &,'Fe: 26: 11113311335111                                     '&
       &,'Co: 27: 11113311335211                                     '&
       &,'Ni: 28: 11113311335311                                     '&
       &,'Cu: 29: 11113311335510                                     '&
       &,'Zn: 30: 11113311335511                                     '&
       !4p 
       &,'Ga: 31: 1111331133551110                                   '&
       &,'Ge: 32: 1111331133551120                                   '&
       &,'As: 33: 1111331133551130                                   '&
       &,'Se: 34: 1111331133551131                                   '&
       &,'Br: 35: 1111331133551132                                   '&
       &,'Kr: 36: 1111331133551133                                   '&
       !5s
       &,'Rb: 37: 111133113355113310                                 '&
       &,'Sr: 38: 111133113355113311                                 '&
       !4d
       &,'Y : 39: 11113311335511331011                               '&
       &,'Zr: 40: 11113311335511332011                               '/
  Data occu_config(41:60)/ &
       & 'Nb: 41: 11113311335511334010                               '&
       &,'Mo: 42: 11113311335511335010                               '&
       &,'Tc: 43: 11113311335511335110                               '&
       &,'Ru: 44: 11113311335511335210                               '&
       &,'Rh: 45: 11113311335511335310                               '&
       &,'Pd: 46: 11113311335511335500                               '&
       &,'Ag: 47: 11113311335511335510                               '&
       &,'Cd: 48: 11113311335511335511                               '&
       !5p 
       &,'In: 49: 1111331133551133551110                             '&
       &,'Sn: 50: 1111331133551133551120                             '&
       &,'Sb: 51: 1111331133551133551130                             '&
       &,'Te: 52: 1111331133551133551131                             '&
       &,'I : 53: 1111331133551133551132                             '&
       &,'Xe: 54: 1111331133551133551133                             '&
       !6s
       &,'Cs: 55: 111133113355113355113310                           '&
       &,'Ba: 56: 111133113355113355113311                           '&
       !5d
       &,'La: 57: 11113311335511335511331011                         '&
       !4f
       &,'Ce: 58: 1111331133551133551011331011                       '&
       &,'Pr: 59: 1111331133551133553011330011                       '&
       &,'Nd: 60: 1111331133551133554011330011                       '/
  Data occu_config(61:80)/ &
       & 'Pm: 61: 1111331133551133555011330011                       '&
       &,'Sm: 62: 1111331133551133556011330011                       '&
       &,'Eu: 63: 1111331133551133557011330011                       '&
       &,'Gd: 64: 1111331133551133557011331011                       '&
       &,'Tb: 65: 1111331133551133557211330011                       '&
       &,'Dy: 66: 1111331133551133557311330011                       '&
       &,'Ho: 67: 1111331133551133557411330011                       '&
       &,'Er: 68: 1111331133551133557511330011                       '&
       &,'Tm: 69: 1111331133551133557611330011                       '&
       &,'Yb: 70: 1111331133551133557711330011                       '&
       &,'Lu: 71: 1111331133551133557711331011                       '&
       !5d
       &,'Hf: 72: 1111331133551133557711332011                       '&
       &,'Ta: 73: 1111331133551133557711333011                       '&
       &,'W : 74: 1111331133551133557711334011                       '&
       &,'Re: 75: 1111331133551133557711335011                       '&
       &,'Os: 76: 1111331133551133557711335111                       '&
       &,'Ir: 77: 1111331133551133557711335211                       '&
       &,'Pt: 78: 1111331133551133557711335410                       '&
       &,'Au: 79: 1111331133551133557711335510                       '&
       &,'Hg: 80: 1111331133551133557711335511                       '/
  Data occu_config(81:99)/ &
       !6p 
       & 'Tl: 81: 111133113355113355771133551110                     '&
       &,'Pb: 82: 111133113355113355771133551120                     '&
       &,'Bi: 83: 111133113355113355771133551130                     '&
       &,'Po: 84: 111133113355113355771133551131                     '&
       &,'At: 85: 111133113355113355771133551132                     '&
       &,'Rn: 86: 111133113355113355771133551133                     '&
       !7s 
       &,'Fr: 87: 11113311335511335577113355113310                   '&
       &,'Ra: 88: 11113311335511335577113355113311                   '&
       !6d
       &,'Ac: 89: 1111331133551133557711335511331011                 '&
       !5f
       &,'Th: 90: 111133113355113355771133551133002011               '&
       &,'Pa: 91: 111133113355113355771133551133201011               '&
       &,'U : 92: 111133113355113355771133551133301011               '&
       &,'Np: 93: 111133113355113355771133551133401011               '&
       &,'Pu: 94: 111133113355113355771133551133600011               '&
       &,'Am: 95: 111133113355113355771133551133700011               '&
       &,'Cm: 96: 111133113355113355771133551133701011               '&
       &,'Bk: 97: 111133113355113355771133551133720011               '&
       &,'Cf: 98: 111133113355113355771133551133730011               '&
       &,'Es: 99: 111133113355113355771133551133740011               '/
  Data occu_config(100:103)/ &
       & 'Fm:100: 111133113355113355771133551133750011               '&
       &,'Md:101: 111133113355113355771133551133760011               '&
       &,'No:102: 111133113355113355771133551133770011               '&
       &,'Lr:103: 111133113355113355771133551133771011               '&
       &/
  Character(59),Private   :: magorder_config(0:MAX_ELEMENT)
  Data magorder_config(0:10)/ &
       & 'E :  0:  1                                                 '&
       !1s
       &,'H :  1:  1                                                 '&
       &,'He:  2:  1                                                 '&
       !2s
       &,'Li:  3:  1 2                                               '&
       &,'Be:  4:  1 2                                               '&
       !2p
       &,'B :  5:  1 2 3                                             '&
       &,'C :  6:  1 2 3                                             '&
       &,'N :  7:  1 2 3                                             '&
       &,'O :  8:  1 2 3                                             '&
       &,'F :  9:  1 2 3                                             '&
       &,'Ne: 10:  1 2 3                                             '&
       &/
  Data magorder_config(11:20)/ &
       !3s
       & 'Na: 11:  1 2 3 4                                           '&
       &,'Mg: 12:  1 2 3 4                                           '&
       !3p
       &,'Al: 13:  1 2 3 4 5                                         '&
       &,'Si: 14:  1 2 3 4 5                                         '&
       &,'P : 15:  1 2 3 4 5                                         '&
       &,'S : 16:  1 2 3 4 5                                         '&
       &,'Cl: 17:  1 2 3 4 5                                         '&
       &,'Ar: 18:  1 2 3 4 5                                         '&
       !4s
       &,'K : 19:  1 2 3 4 5 6                                       '&
       &,'Ca: 20:  1 2 3 4 5 6                                       '/
  Data magorder_config(21:40)/ &
       !3d
       & 'Sc: 21:  1 2 3 4 5 7 6                                     '&
       &,'Ti: 22:  1 2 3 4 5 7 6                                     '&
       &,'V : 23:  1 2 3 4 5 7 6                                     '&
       &,'Cr: 24:  1 2 3 4 5 7 6                                     '&
       &,'Mn: 25:  1 2 3 4 5 7 6                                     '&
       &,'Fe: 26:  1 2 3 4 5 7 6                                     '&
       &,'Co: 27:  1 2 3 4 5 7 6                                     '&
       &,'Ni: 28:  1 2 3 4 5 7 6                                     '&
       &,'Cu: 29:  1 2 3 4 5 7 6                                     '&
       &,'Zn: 30:  1 2 3 4 5 7 6                                     '&
       !4p 
       &,'Ga: 31:  1 2 3 4 5 7 6 8                                   '&
       &,'Ge: 32:  1 2 3 4 5 7 6 8                                   '&
       &,'As: 33:  1 2 3 4 5 7 6 8                                   '&
       &,'Se: 34:  1 2 3 4 5 7 6 8                                   '&
       &,'Br: 35:  1 2 3 4 5 7 6 8                                   '&
       &,'Kr: 36:  1 2 3 4 5 7 6 8                                   '&
       !5s
       &,'Rb: 37:  1 2 3 4 5 7 6 8 9                                 '&
       &,'Sr: 38:  1 2 3 4 5 7 6 8 9                                 '&
       !4d
       &,'Y : 39:  1 2 3 4 5 7 6 810 9                               '&
       &,'Zr: 40:  1 2 3 4 5 7 6 810 9                               '/
  Data magorder_config(41:60)/ &
       & 'Nb: 41:  1 2 3 4 5 7 6 810 9                               '&
       &,'Mo: 42:  1 2 3 4 5 7 6 810 9                               '&
       &,'Tc: 43:  1 2 3 4 5 7 6 810 9                               '&
       &,'Ru: 44:  1 2 3 4 5 7 6 810 9                               '&
       &,'Rh: 45:  1 2 3 4 5 7 6 810 9                               '&
       &,'Pd: 46:  1 2 3 4 5 7 6 810 9                               '&
       &,'Ag: 47:  1 2 3 4 5 7 6 810 9                               '&
       &,'Cd: 48:  1 2 3 4 5 7 6 810 9                               '&
       !5p 
       &,'In: 49:  1 2 3 4 5 7 6 810 911                             '&
       &,'Sn: 50:  1 2 3 4 5 7 6 810 911                             '&
       &,'Sb: 51:  1 2 3 4 5 7 6 810 911                             '&
       &,'Te: 52:  1 2 3 4 5 7 6 810 911                             '&
       &,'I : 53:  1 2 3 4 5 7 6 810 911                             '&
       &,'Xe: 54:  1 2 3 4 5 7 6 810 911                             '&
       !6s
       &,'Cs: 55:  1 2 3 4 5 7 6 810 91112                           '&
       &,'Ba: 56:  1 2 3 4 5 7 6 810 91112                           '&
       !5d
       &,'La: 57:  1 2 3 4 5 7 6 810 9111312                         '&
       !4f
       &,'Ce: 58:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Pr: 59:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Nd: 60:  1 2 3 4 5 7 6 81014 9111312                       '/
  Data magorder_config(61:80)/ &
       & 'Pm: 61:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Sm: 62:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Eu: 63:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Gd: 64:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Tb: 65:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Dy: 66:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Ho: 67:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Er: 68:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Tm: 69:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Yb: 70:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Lu: 71:  1 2 3 4 5 7 6 81014 9111312                       '&
       !5d
       &,'Hf: 72:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Ta: 73:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'W : 74:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Re: 75:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Os: 76:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Ir: 77:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Pt: 78:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Au: 79:  1 2 3 4 5 7 6 81014 9111312                       '&
       &,'Hg: 80:  1 2 3 4 5 7 6 81014 9111312                       '/
  Data magorder_config(81:99)/ &
       !6p 
       & 'Tl: 81:  1 2 3 4 5 7 6 81014 911131215                     '&
       &,'Pb: 82:  1 2 3 4 5 7 6 81014 911131215                     '&
       &,'Bi: 83:  1 2 3 4 5 7 6 81014 911131215                     '&
       &,'Po: 84:  1 2 3 4 5 7 6 81014 911131215                     '&
       &,'At: 85:  1 2 3 4 5 7 6 81014 911131215                     '&
       &,'Rn: 86:  1 2 3 4 5 7 6 81014 911131215                     '&
       !7s 
       &,'Fr: 87:  1 2 3 4 5 7 6 81014 91113121516                   '&
       &,'Ra: 88:  1 2 3 4 5 7 6 81014 91113121516                   '&
       !6d
       &,'Ac: 89:  1 2 3 4 5 7 6 81014 9111312151716                 '&
       !5f
       &,'Th: 90:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'Pa: 91:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'U : 92:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'Np: 93:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'Pu: 94:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'Am: 95:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'Cm: 96:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'Bk: 97:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'Cf: 98:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'Es: 99:  1 2 3 4 5 7 6 81014 911131215181716               '/
  Data magorder_config(100:103)/ &
       & 'Fm:100:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'Md:101:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'No:102:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &,'Lr:103:  1 2 3 4 5 7 6 81014 911131215181716               '&
       &/




  !!
  !!***********************************************************************
Contains 

  !!***********************************************************************
  ! create_atominfile
  ! {{{ 
  
  Subroutine create_atominfile(status,atom,title&
       &,radialmesh_rmin,radialmesh_rmax&
       &,wftol_S,xcrelat,loptions&
       &,r0_S,exn0_S&
       &,iteration_tolerance_S,iteration_mixing_S &
       &,iteration_progress_S,ionicity_S)
    Implicit None 
    !!IO
    Type(T_Atom),Intent(in)      :: atom
    Type(T_Options),Intent(in)   :: loptions
    Character(*),Intent(in)      :: title
    Character(*),Intent(in)      :: status
    Logical(t_log),Intent(in)    :: xcrelat
    Character(*),Intent(in)      :: radialmesh_rmin,radialmesh_rmax
    Character(*),Intent(in)      :: wftol_S
    Character(*),Intent(in)      :: r0_S,exn0_S,ionicity_S
    Character(*),Intent(in)      :: iteration_tolerance_S,iteration_mixing_S
    Character(*),Intent(in)      :: iteration_progress_S
    !!LOCAL
    Integer(t_int),Parameter ::lunit=12_t_int
    Integer(t_int) :: i,rel
    !!
    Open(lunit,file=f_atom_in)
    Write(lunit,"(a)")&
         & "########################################################################"&
         &,"# this file is part of the FPLO bandstructure package"&
         &,"# it was created automatically"&
         &,"# please dont delete this file nor"&
         &,"# edit it directly, unless you really know what you are doing"&
         &,"# Use FEDIT to change its content"&
         &,"#"&
         &,"########################################################################"
    Write(lunit,"(/,/)")
    !! SECTION header
    Write(lunit,"(a)")  'section header{'
    Call write_version(lunit)
    Call write_changed(12_t_int)
1   Format('    char[*] status="',a,'";')
    Write(lunit,1) Trim(status)
    Write(lunit,"(2x,a,a,a)") 'char[*] title="',Trim(title),'";'
    !! end header
    Write(lunit,"('};',2/)") 
    
    Write(lunit,"(a)")  'section data{'

    Write(lunit,"(2x,'char[2] atom=""',a,'"";')")Trim(atom% element)    

    Write(lunit,"(2x,'real ionicity=',a,';')")Trim(ionicity_S)

    Write(lunit,"(2x,a)")'struct {int type;char[*] description;} '&
         &//'nuclear_model'
    Write(lunit,"(2x,'={',i3,',""',a,'""};')") atom% nuc_type &
         &,Trim(FINUC_TYPE(atom% nuc_type))
    
    Write(lunit,"(2x,a,'={',/,i5,',',1(a,','),a,'};')")&
         &'struct {int nr;real rmin;real rmax;} radial_mesh'&
         &,atom% mesh% nr,Trim(radialmesh_rmin) ,Trim(radialmesh_rmax)

    Write(lunit,"(2x,a)")'struct {int type;char[*] description;} '&
         &//'radial_meshtype'
    
    Write(lunit,"(2x,'={',i3,',""',a,'""};')") atom% mesh% type &
         &,Trim(MESH_TYPE(atom% mesh% Type))

    
    Write(lunit,"(2x,a)")'struct {int type;char[*] description;} relativistic'
    rel=atom% relativistic
    If(atom% relativistic==SCALAR_RELATIVISTIC) rel=SCALAR_RELATIVISTIC_KH
    Write(lunit,"(2x,'={',i3,',""',a,'""};')") rel &
         &,Trim(relat_name(atom% relativistic))

    Call getXCVersionIndex(i)
    Write(lunit,"(2x,a)")'struct {int type;char[*] description;} xc_potential'
    Write(lunit,"(2x,'={',i3,',""',a,'""};')") getxcversion() &
         &,Trim(XC_VERSIONS(i))

    Write(lunit,"(2x,a)")'struct {real wf;} tolerances'
    Write(lunit,"(2x,'={',a,'};')") wftol_S

    Write(lunit,"(2x,a)")'struct {logical compression;real r0;real exponent;} conf_potential'
    Write(lunit,"(2x,'={',l1,',',a,',',a,'};')") &
         &atom% compr,Trim(r0_S),Trim(exn0_S)

    Write(lunit,"(2x,a)")'struct {logical orbitals;logical density;&
         & logical potential;logical overwrite;} output'
    Write(lunit,"(2x,'={',3(l1,','),l1,'};')") atom% basout,atom% rhoout&
         &,atom% potout,atom% overwriteout


    Write(lunit,"(2x,'struct {int mspin;} spin={',i2,'};')")atom% mspin

    Write(lunit,"(2x,'logical xcrelat=',l1,';')")xcrelat


    Write(lunit,"(2x,a)")'flag options[*]={'
    Write(lunit,"(4(' '))",advance='no')
    
    Do i=1_t_int,loptions % noptions
       Write(lunit,"(a,'(',a1,')')",advance='no')&
            &Trim(loptions % p_options(i)(2_t_int:)) &
            &, loptions % p_options(i)(1_t_int:1_t_int)
       If(i < loptions % noptions) Write(lunit,"(',')",advance='no') 
       If(Mod(i,4_t_int)==0_t_int)Write(lunit,"(/,4(' '))",advance='no')
    Enddo
    Write(lunit,"(2x,a)") "};"


    Write(lunit,"(2x,a)")'struct {int steps;real tolerance;&
         &real mixing;int maxdim;real progress;} iteration_control' 
    

    Write(lunit,"(2x,'={',i4,',',2(a,','),i4,',',a,'};')")&
         & atom% iteration_control% steps &
         &,Trim(iteration_tolerance_S) &
         &,Trim(iteration_mixing_S) &
         &,atom% iteration_control% maxdim &
         &,Trim(iteration_progress_S) 

    Write(lunit,"(2x,a)") 'struct {int scheme;char[*] description;} &
         &iteration_version'
    Write(lunit,"(2x,'={',i4,',""',a,'""};')") atom% iteration_control% scheme&
         &,Trim(ITERATION_SCHEMES(atom% iteration_control% scheme))


    Write(lunit,"(2x,a)") 'struct {char[*] element;int Z;char[*] states&
         &;char[*] noccus;} basis'
    Write(lunit,"(2x,'={""',a,'"",',a,',""',a,'"",""',a,'""};')")&
         & Trim(atom%  basis_def(1:2))&
         &,Trim(atom%  basis_def(4:6))&
         &,Trim(atom%  basis_def(9:))&
         &,Trim(atom% noccus_def(9:))

    
    Write(lunit,"(a,/)") "};"
    close(lunit)
  End Subroutine create_atominfile
  
  !!***********************************************************************
  Subroutine header(title)
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)  :: title
    !!LOCAL
    Character(*),Parameter::nsubfunc="header"

    Character(40)  :: str
    logical(t_log) :: err
    External cgetdate

    Write(outfile,100)
    Write(outfile,1110)
    Write(outfile,1120)
    Write(outfile,100)
    !!
    !!
    Write(outfile,110)
    Write(outfile,200)Trim(FPLOMAINVERSION)
    Write(outfile,201)Trim(FPLOSUBVERSION)
    Write(outfile,204)Trim(FPLORELEASE)
    Write(outfile,110)
    Write(outfile,100)
#ifdef __GFORTRAN__
    Write(outfile,"('| compiled with gfortran ',a,'.',a,'.',a,t72,'|')") &
         & Trim(intToChar10(Int(__GNUC__,t_int)))&
         &,Trim(intToChar10(Int(__GNUC_MINOR__,t_int)))&
         &,Trim(intToChar10(Int(__GNUC_PATCHLEVEL__,t_int)))
#endif
#ifdef  __INTEL_COMPILER
    Write(outfile,"('| compiled with ifort ',a,t72,'|')") Trim(intToChar10(__INTEL_COMPILER))
#endif
#if defined (USE_MKL_LAPACK) || defined (USE_MKL_LAPACK_64)
    Write(outfile,"('| compiled with external LAPACK libraries',t72,'|')")
#endif
    Write(outfile,100)
    Write(outfile,110)
    Write(outfile,100)
    
    Call cgetdate(str,err,errbuf)
    If(err)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg='"'//Trim(errbuf)//'"')
    End If
    Write(outfile,202)Trim(str)

    Write(outfile,100)
    Write(outfile,122)Trim(title)
    Write(outfile,100)

100 Format(72("-"))
110 Format("|",t72,"|")
200 Format('| main version: ',a,t72,'|')
201 Format('| sub  version: ',a,t72,'|')
204 Format('| release     : ',a,t72,'|')
202 Format('| date        : ',a,t72,'|')
122 Format("| calculation : ",a,t72,"|")
1110 Format('|',t72,'|'/&
          & ,'|',t25,'FULL-RELATIVISTIC ATOM PROGRAM'&
          & ,t72,'|')
1120 Format('|',t29,'by K. Koepernik (2001)',t72,'|')
    Return
  End Subroutine header
  !!***********************************************************************

  !!***********************************************************************
  Subroutine iodirac(atom)
    !!
    Implicit None
    !!IO
    Type(T_Atom),Intent(inout)      :: atom
    !!LOCAL
    Character(*),Parameter::nsubfunc="iodirac"
    Type(T_Options):: loptions
    Integer(t_int)  :: xcvers,lun,i,ver,rel,iat
    Logical(t_log)  :: exist,xcrelat,xcr,updated,defbas
    Character(2)   :: ele
    Character(200) :: title
    character(200) :: radialmesh_rmin
    character(200) :: radialmesh_rmax
    Character(200) :: wftol_S
    Character(200) :: r0_S,exn0_S
    Character(200) :: iteration_progress_S,ionicity_S
    Character(200) :: iteration_tolerance_S,iteration_mixing_S
    character(200) :: mainversion
    character(200) :: subversion
    Character(1000) :: basstr
    Character(1000) :: nocstr
    Character(200)  ::  status
    Integer(t_int)  :: rank,asize(8)
    Integer :: iostat
    !!
    !!***********************************************************************
    !!
    !!     create input file
    lun =14_t_int
    
    Call init_options(loptions)

    Inquire(file=f_atom_in,exist=exist)
    If(.Not.exist) Then

       title='Al atom nonrelativistic'
       
       atom% mesh% type=LOGZERO_MESH
       atom% mesh% nr=2000_t_int
       atom% mesh% rmin=1.e-7_t_real
       atom% mesh% rmax=30.0_t_real
       atom% mesh% with_zero=.True.
       radialmesh_rmin='1.e-7'
       radialmesh_rmax='30.0'


       atom% relativistic = NON_RELATIVISTIC
       atom% nuc_type = FINUC_NONE

       !! set global xcversion, check it
       Call setxcversion(Int(XCVER_PERDEWWANG92,t_int)) 

       atom% wftol=1.e-12_t_real
       wftol_S='1.e-12'
       
       atom% mspin=1_t_int
       xcrelat=.False.
       
       loptions % noptions = Size(atom_opt)

       Call palloc('loptions% p_options',loptions% p_options&
            &,1_t_int,Max(1_t_int,loptions % noptions)&
            &,nmodule,nsubfunc)

       loptions % p_options(:)=atom_opt(:)
           
       atom% compr=.false.
       r0_S='1.0'
       exn0_S='4.0'

       atom% basout=.False.
       atom% rhoout=.False.
       atom% potout=.True.
       atom% overwriteout=.true.
       atom% gam_factor=.False.

       atom% iteration_control% scheme   =IT_SCHEME_LCITERAT
       atom% iteration_control% maxdim   =5_t_int
       atom% iteration_control% tolerance=1.e-6_t_real
       atom% iteration_control% mixing   = 0.4_t_real
       atom% iteration_control% progress = 0.1_t_real
       atom% iteration_control% steps    = 40_t_int
       iteration_tolerance_S ='1.e-6'
       iteration_mixing_S = '0.2'
       iteration_progress_S = '0.2'
       
       atom% element='Al'
       atom% ionicity=0.0_t_real
       ionicity_S='0.0'

       !!
       Call set_def_atom_basis_and_occus(atom)
       !!
       Call create_atominfile("ready",atom,title&
            &,radialmesh_rmin,radialmesh_rmax &
            &,wftol_S,xcrelat,loptions&
            &,r0_S,exn0_S&
            &,iteration_tolerance_S,iteration_mixing_S&
            &,iteration_progress_S,ionicity_S)

       Write(errbuf,"('File ',a,' created')")Trim(f_atom_in)
       !Write(outfile,"('edit this file, and run dirac')")

       Call pfree(loptions% p_options)
       Call terminate(TERM_NORMAL,errbuf)
    Else

       updated=.False.

       Call initparser
       Call readfile(f_atom_in)
       !! read version

       Call getstring("version.mainversion",mainversion)
       Call getstring("version.subversion",subversion)
       
       ver=checkversion(mainversion,subversion,f_atom_in)


       If( variable_exists('status'))Then
          Call getstring("status",status)
       Else
          status="trigger update 1"
       Endif

       !! read title
       Call getstring("title",title)
       Call header(title)
      
       !!       mesh
       
       If( variable_exists('radial_meshtype.type'))Then
          Call getinteger('radial_meshtype.type',atom% mesh% Type)
          If(atom% mesh% Type==LOG_MESH.Or.atom% mesh% Type==LIN_MESH)Then
             Write(errbuf,"('''Mesh type ''''',a,''''' no longer supported !''')")&
                  &Trim(MESH_TYPE(atom% mesh% Type))
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
          Endif
       Else
          atom% mesh% Type=LOGZERO_MESH
       Endif
       Call getinteger('radial_mesh.nr',atom% mesh% nr)
       Call getreal('radial_mesh.rmin',atom% mesh% rmin)
       Call getrealasstring('radial_mesh.rmin',radialmesh_rmin)
       Call getreal('radial_mesh.rmax',atom% mesh% rmax)
       Call getrealasstring('radial_mesh.rmax',radialmesh_rmax)

       

       !!       relativistic
       Call getinteger('relativistic.type',rel)
       atom% relativistic=rel
       if(rel==SCALAR_RELATIVISTIC)atom% relativistic=SCALAR_RELATIVISTIC_KH
       

       !! check xc-version
       Call getinteger("xc_potential.type",xcvers)
       Call setxcversion(xcvers) !! set global xcversion, check it

       
       

       Call getreal("tolerances.wf",atom% wftol)
       Call getrealasstring("tolerances.wf",wftol_S)
       

       Call getinteger("spin.mspin",atom% mspin)


       Call getlogical("xcrelat",xcr)
       xcrelat=xcr
       xcrelat=xcrelat.And. atom% relativistic /= NON_RELATIVISTIC
       xcrelat=xcrelat.And.(speed_of_light<139.0_t_real)
       Call setxcrelat(xcrelat) !! set globals



       !! options
       Call  getrankandsize("options",rank,asize)
       loptions % noptions=asize(1_t_int)

       Call palloc('loptions% p_options',loptions% p_options&
            &,1_t_int,Max(1_t_int,loptions % noptions)&
            &,nmodule,nsubfunc)

       Call  getflag('options',loptions % p_options)
       
       !! sic
       atom% sic=isoption('SIC_ALL',loptions)
       atom% sic4f=isoption('SIC_4F',loptions)
       
       If(atom% sic4f)atom% sic=.True.

       If((atom% sic) .And. atom% relativistic == FULL_RELATIVISTIC)Then
          Write(errbuf,"('relativistic SIC not yet implemented, sorry!')")
          Call terminate(TERM_ERROR,errbuf)

       Endif


       atom% noUnOccupied=isoption('CALC_ONLY_OCCUPIED',loptions)
       atom% force_pos_spin=isoption('FORCE_POSITIVE_SPIN',loptions)

       
       Call getlogical("conf_potential.compression",atom% compr)
       Call getreal("conf_potential.r0",atom% r0)
       Call getrealasstring("conf_potential.r0",r0_S)
       Call getreal("conf_potential.exponent",atom% exn0)
       Call getrealasstring("conf_potential.exponent",exn0_S)

       !!       output control
       Call getlogical('output.orbitals',atom% basout)
       Call getlogical('output.density',atom% rhoout)
       Call getlogical('output.potential',atom% potout)
       Call getlogical('output.overwrite',atom% overwriteout)



       Call getinteger('iteration_control.steps'&
            &,atom% iteration_control% steps)
       Call getreal('iteration_control.tolerance'&
            &,atom% iteration_control% tolerance)
       Call getrealasstring('iteration_control.tolerance'&
            &,iteration_tolerance_S)
       Call getreal('iteration_control.mixing'&
            &,atom% iteration_control% mixing)
       Call getrealasstring('iteration_control.mixing'&
            &,iteration_mixing_S)
       Call getinteger('iteration_control.maxdim'&
            &,atom% iteration_control% maxdim)
       Call getreal('iteration_control.progress'&
            &,atom% iteration_control% progress)
       Call getrealasstring('iteration_control.progress'&
            &,iteration_progress_S)
       Call getinteger('iteration_version.scheme'&
            &,atom% iteration_control% scheme)
       
       Call getstring('atom',atom% element)
       iat=getelementnumber(atom% element)
       !!TODO: if vacuum type, adjust to zero here
       atom% Z=Real(iat,t_real)
       
       If( variable_exists('ionicity'))Then
          Call getreal('ionicity',atom% ionicity)
          Call getrealasstring('ionicity',ionicity_S)
       Else
          atom% ionicity=0.0_t_real
          ionicity_S="0.0"
       Endif
       !!
       !!
       If( variable_exists('nuclear_model.type'))Then
          Call getinteger('nuclear_model.type',atom% nuc_type)
          If(atom% nuc_type< FINUC_NONE.Or.atom% nuc_type > FINUC_HUMP5)Then
             Write(errbuf,"('''nuclear model type ''''',i2,''''' unknown !''')")&
                  &atom% nuc_type
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
          Endif
       Else
          atom% nuc_type=FINUC_NONE
       Endif

       !!
       !!
       defbas=.False.
       If( variable_exists('basis.element'))Then
          Call getstring('basis.element',ele)
       Else
          defbas=.True.
       Endif
       If( variable_exists('basis.states'))Then
          Call getstring('basis.states',basstr)
       Else
          defbas=.True.
       Endif
       If( variable_exists('basis.noccus'))Then
          Call getstring('basis.noccus',nocstr)
       Else
          defbas=.True.
       Endif
       !!
       If(atom% element /= ele)Then
          defbas=.True.
       Endif
       !!

       If(defbas)Then
          Call set_def_atom_basis_and_occus(atom)
          updated=.true.
       else
          Write(atom% basis_def,"(a2,':',i3,': ',a)")&
               &ele,iat,Trim(basstr)
          Write(atom% noccus_def,"(a2,':',i3,': ',a)")&
               &ele,iat,Trim(nocstr)
       Endif
       !!
       Call updateRawOccus(atom)
       !!
       !!
       Call cleanreadfile


       !Print *,Trim(status)
       If(Trim(status)/='ready')Then
          !! this is given anyway ... just for general logics
          updated=.True.
       Endif

       If(ver/=VERSION_OK .Or. updated)Then
          Call create_atominfile("ready",atom,title&
               &,radialmesh_rmin,radialmesh_rmax &
               &,wftol_S,xcr,loptions&
               &,r0_S,exn0_S&
               &,iteration_tolerance_S&
               &,iteration_mixing_S,iteration_progress_S,ionicity_S)
          !Write(outfile,"('Version update of ',a,':')")Trim(f_atom_in)
          Write(errbuf,"('File ',a,' updated!')")Trim(f_atom_in)

          Call terminate(TERM_NORMAL,errbuf)
          
       Endif

       
       !!     
       !! read atomic charges from file
       If(atom% standalone) Then
          Inquire(file=f_atcharge_in,exist=exist)
          If(exist)Then
             Open(lun,file=f_atcharge_in)
             Read(lun,fmt=*,iostat=iostat)i,atom% Z
             i=i
             If(iostat/=0)Then
                Write(errbuf,"('''Format of file ''''',a,''''' incorrect !''')")&
                     &Trim(f_atcharge_in)
                Call errmsg(nmodule,nsubfunc,E_fatalerror&
                     &,msg=Trim(errbuf))
             End If
             Close(lun)
          End If
       Endif
       
       Write(outfile,"('atom: ',a2,1x,g30.17e2)")atom% element,atom% Z
       
       Call pfree(loptions% p_options)
       !!
    Endif
    !!
  End Subroutine iodirac
  !!***********************************************************************
  !!***********************************************************************
  !! initialize dirac data
  Subroutine diracinit(atom)
    !!
    Implicit None
    !!IO
    Type(T_Atom),Intent(inout)      :: atom
    !!LOCAL
    !Character(*),Parameter::nsubfunc="diracinit"
    !!
    !!***********************************************************************
    !!
    !!     
    atom% standalone=.True.
    atom% gam_factor=.False.
    atom% gam_factor=.True.
    atom% nonspheredens=.True.
    atom% nonspheredens=.False.
    !!
    atom% mesh% type=LOGZERO_MESH
    atom% mesh% nr=2000_t_int
    atom% mesh% rmin=1.e-7_t_real
    atom% mesh% rmax=30.0_t_real
    atom% mesh% with_zero=.True.

    atom% relativistic = NON_RELATIVISTIC
    
    
    atom% wftol=1.e-12_t_real

       
    atom% mspin=1_t_int

    Call setxcrelat(.False.) !! set global
    
    atom% compr=.False.
    atom% r0=1.0_t_real
    atom% exn0=4.0_t_real
    
    atom% basout=.False.
    atom% rhoout=.False.
    atom% potout=.True.
    atom% overwriteout=.True.
    
    atom% iteration_control% scheme   =IT_SCHEME_LCITERAT
    atom% iteration_control% maxdim   =5_t_int
    atom% iteration_control% tolerance=1.e-6_t_real
    atom% iteration_control% mixing   = 0.4_t_real
    atom% iteration_control% progress = 0.1_t_real
    atom% iteration_control% steps    = 40_t_int

    atom% element='Al'
    atom% ionicity=0.0_t_real
    atom% vca=.False.
       
    atom% sic=.False.
    atom% sic4f=.False.
    If(atom% sic4f)atom% sic=.True.
    !!TODO: if vacuum type, adjust to zero here
    atom% Z=Real(getelementnumber(atom% element),t_real)
    atom% nuc_type=FINUC_NONE
    atom% noUnOccupied=.True.

    atom% force_pos_spin=.True.
    !!
    !!
    Call set_def_atom_basis_and_occus(atom)
    Call updateRawOccus(atom)
    !!
  End Subroutine diracinit
  !!***********************************************************************
  Subroutine set_def_atom_basis_and_occus(atom)
    !!
    Implicit None  
    !!IO
    Type(T_Atom),Intent(inout)   :: atom
    !!LOCAL
    !Character(*),Parameter:: nsubfunc="set_def_atom_basis_and_occus"
    Integer(t_int) :: iat
    !!
    iat=getelementnumber(atom% element)
    !!
    atom% basis_def=default_config(iat)
    atom% noccus_def=occu_config(iat)
    atom% magorder_def=magorder_config(iat)
    !!
    Return
    !!
  End Subroutine set_def_atom_basis_and_occus
  !!***********************************************************************
  !! make the states and occus from default definition string
  !! unless it is VCA, in which case we have to interpolate the two
  !! neighbouring definitions
  Subroutine updateRawOccus(atom)
    !!
    Implicit None
    !!IO
    Type(T_Atom),Intent(inout)   :: atom
    !!LOCAL
    Character(*),Parameter::nsubfunc="updateRawOccus"
    Integer(t_int) :: iat,nv1,jv,iv,nmain,n1,n2,l
    Real(t_real)   :: ion,vcadQ,d1,d2,ddum
    Character(1)   :: ch
    Character(200)   :: basis_defm
    Character(200)   :: noccus_defm
    Character(200)   :: magorder_defm
    !!
    !!
    If(atom% vca)Then
       If(atom% standalone)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'VCA in standalone mode ? How could this happen?'")
       Endif
       iat=getelementnumber(atom% element)
       ion=atom% Z-Real(iat,t_real)
       If(Abs(ion)<1.0e-5_t_real) Goto 99
       !!
       iat=Ceiling(atom% Z)
       If(iat>MAX_ELEMENT) Then
          Write(errbuf,"('''Element number ',i5,' not implemented!''')")&
               &iat
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg=Trim(errbuf))
       Endif
       !!
       !! correct for vca charges
       vcadQ=iat-atom% Z
       If( vcadQ<0.0_t_real) Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'VCA: charge correction must be positive&
               &, please report !'")
       Endif
       !!
       !! TODO: need special treatment for Z=1-delta
       !!
       !Print *,'iat:',iat-1,atom% Z,iat
       !Print *,Trim(default_config(iat))
       !!
       Call  make_nrel_occus(atom,default_config(iat),occu_config(iat)&
            &,magorder_config(iat))
       !!
       !!
       basis_defm=default_config(iat-1)
       noccus_defm=occu_config(iat-1)
       magorder_defm=magorder_config(iat-1)
       If(iat>1) Then
          !Print *,Trim(basis_defm)
          !!
          nv1=Len_trim(basis_defm(9:))
          If(Mod( nv1,2_t_int)/=0) nv1= nv1-1
          nv1= nv1/2
       Else
          nv1=0
       Endif
       !!
       jv=1
       Do iv=1,nv1
          Read(basis_defm (8+2*iv-1:8+2*iv),34)nmain,ch
          Read(noccus_defm(8+2*iv-1:8+2*iv),35) n1,n2
          d1=Real(n1,t_real)
          d2=Real(n2,t_real)
          
          If(atom% mspin==1)Then
             d1=d1+d2
             d2=0.0_t_real
          Endif
          l=lcharqn(ch)
          !!
          Do While( ( atom% p_nnv(jv)/=nmain .Or. atom% p_lv(jv)/=l) )
             if(jv>atom% nv) goto 5000
             atom% p_nroccu(jv,1)=&
                  &(1.0_t_real-vcadQ)*atom% p_nroccu(jv,1)
             atom% p_nroccu(jv,2)=&
                  &(1.0_t_real-vcadQ)*atom% p_nroccu(jv,2)
             !Print *,' new ',atom% p_nnv(jv),lqnchar(atom% p_lv(jv))&
             !     &,atom% p_nroccu(jv,1:2)
             jv=jv+1
             
          Enddo
          
          If(jv>atom% nv) Goto 5000
          atom% p_nroccu(jv,1)=&
               &vcadQ*d1+(1.0_t_real-vcadQ)*atom% p_nroccu(jv,1)
          atom% p_nroccu(jv,2)=&
               &vcadQ*d2+(1.0_t_real-vcadQ)*atom% p_nroccu(jv,2)
          !Print *,' Z_i-1',nmain,lqnchar(l),d1,d2
          jv=jv+1
          
       Enddo
       Do iv=jv,atom% nv
          atom% p_nroccu(iv,1)=&
               &(1.0_t_real-vcadQ)*atom% p_nroccu(iv,1)
          atom% p_nroccu(iv,2)=&
               &(1.0_t_real-vcadQ)*atom% p_nroccu(iv,2)
          !Print *,' new ',atom% p_nnv(iv),lqnchar(atom% p_lv(iv))&
          !     &,atom% p_nroccu(iv,1:2)
       Enddo
       !Print *

       ddum=0.0_t_real
       Do iv=1,atom% nv
          !Print "(a2,1x,i1,a1,2f10.5,1x,'mo=',i3)"&
          !     &,atom% element,atom% p_nnv(iv),lqnchar(atom% p_lv(iv))&
          !     &,atom% p_nroccu(iv,1:2),atom% p_magorder(iv)
          ddum=ddum+Sum(atom% p_nroccu(iv,1:2))
       Enddo
       
       !Print *,ddum

       If(Abs(ddum-atom% Z)>1.0e-5_t_real)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="('VCA: charges of averaged atom do not add up, &
               &please report!')")
       Endif
       
       !!
       !! maximum orbital momentum
       !!
       atom% lmax=Maxval(atom% p_lv(1:atom% nv))
       !!
       Return
       !!
    Endif
    !!
99  Continue
    !!
    !!
    Call  make_nrel_occus(atom,atom% basis_def,atom% noccus_def&
         &,atom% magorder_def)
    !!
    !!
    !! maximum orbital momentum
    !!
    atom% lmax=Maxval(atom% p_lv(1:atom% nv))
    !!
    Return
    !!
    !!
5000 Continue
    Call errmsg(nmodule,nsubfunc,E_fatalerror&
         &,msg="('VCA: state ordering for atom does not behave &
         &smoothly, please report!')")
    !!
34  Format(i1,a1)
35  Format(i1,i1) 
    !!
  End Subroutine updateRawOccus
  !!***********************************************************************
  !! make nrel states and occus form description-string
  Subroutine make_nrel_occus(atom,basis_def,noccus_def,magorder_def)
    !!
    Implicit None
    !!IO
    Type(T_Atom),Intent(inout)   :: atom
    Character(*),Intent(in)      :: basis_def
    Character(*),Intent(in)      :: noccus_def
    Character(*),Intent(in)      :: magorder_def
    !!LOCAL
    Character(*),Parameter::nsubfunc="make_nrel_occus"
    Integer(t_int) :: iv,nmain,l,n1,n2,ndef,idef,mo
    Real(t_real)   :: d1,d2,x1,x2
    Character(1)   :: ch
    Character(100) :: state
    Logical(t_log) :: exists
    !!
    !!
    atom% nv=Len_trim(basis_def(9:))
    If(Mod( atom% nv,2_t_int)/=0) atom% nv= atom% nv-1
    atom% nv= atom% nv/2
    !!
    Call palloc("atom% p_nnv",atom% p_nnv,1_t_int,atom% nv,nmodule,nsubfunc)
    Call palloc("atom% p_lv" ,atom% p_lv ,1_t_int,atom% nv,nmodule,nsubfunc)
    Call palloc("atom% p_magorder" ,atom% p_magorder&
         &,1_t_int,atom% nv,nmodule,nsubfunc)
    Call palloc("atom% p_nroccu" ,atom% p_nroccu,1_t_int,atom% nv&
         &,1_t_int,2_t_int,nmodule,nsubfunc)
    !!
    atom% p_nroccu(:,:)=0.0_t_real
    !!
    !! define shell occupation
    !!
    !Print *,Trim(magorder_def)
    Do iv=1,atom% nv
       Read(basis_def (8+2*iv-1:8+2*iv),34)nmain,ch
       l=lcharqn(ch)
       atom% p_nnv(iv)=nmain
       atom% p_lv(iv)=l

       Read(magorder_def (8+2*iv-1:8+2*iv),36)mo
       atom% p_magorder(iv)=mo
!       Print "('iv=',i3,1x,i1,a1,2x,i3)",iv,nmain,lqnchar(l),atom% p_magorder(iv)

       Read(noccus_def(8+2*iv-1:8+2*iv),35) n1,n2
       d1=Real(n1,t_real)
       d2=Real(n2,t_real)

       If(atom% standalone)Then
          Inquire(file='=.atoccu',exist=exists)
          If(exists)Then
             Open(12,file='=.atoccu')
             Read(12,*)ndef
             Do idef=1,ndef
                Read(12,*) state,x1,x2
                state=Adjustl(state)
                Read(state,"(i1)")nmain
                l=lcharqn(state(2:2))
                If( l==atom% p_lv(iv) .And. nmain == atom% p_nnv(iv)) Then
                   d1=x1
                   d2=x2
                Endif
             Enddo
             Close(12)
          Endif
       Endif
       
       
       If(atom% mspin==1)Then
          d1=d1+d2
          d2=0.0_t_real
       Endif
       atom% p_nroccu(iv,1)=d1
       atom% p_nroccu(iv,2)=d2
       
       !Print *,' Z_i ',nmain,lqnchar(l),atom% p_nroccu(iv,1:2)
    Enddo
    !Print *
    
    !!
    Return
    !!
34  Format(i1,a1)
35  Format(i1,i1) 
36  Format(i2)
    !!
  End Subroutine make_nrel_occus
  !!***********************************************************************



End Module diracio
