Module dump
  !!
  Use precisiondefs
  Use file_iounits
  Use errors
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="DUMP"
  Public :: T_Dump,gdump,init_dumps,setup_dump_states,dumpread,dumpwrite&
       &,DUMP_MOLPOT,DUMP_MOLINIT,DUMP_VATOM,DUMP_KS,DUMP_TI
  !!***********************************************************************
  Type T_Dump
     Logical(t_log) :: active
     Logical(t_log) :: doread
     Character(100) :: fname
  End Type T_Dump
  !!
  Integer(t_int),Parameter :: DUMP_MOLINIT   =1_t_int
  Integer(t_int),Parameter :: DUMP_MOLPOT    =2_t_int
  Integer(t_int),Parameter :: DUMP_VATOM     =3_t_int
  Integer(t_int),Parameter :: DUMP_KS        =4_t_int
  Integer(t_int),Parameter :: DUMP_TI        =5_t_int
  Integer(t_int),Parameter :: DUMP_LAST=DUMP_TI
  !!***********************************************************************
  Type(T_Dump),Target :: gdump(DUMP_LAST)
  !!***********************************************************************
Contains
  !!***********************************************************************
  Subroutine init_dumps()
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="init_dumps"
    Type(T_Dump),Pointer :: d
    !!
    !!
    d => gdump(DUMP_MOLPOT)
    d% active=.False.
    d% doread=.False.
    d% fname="+dumpmolpot"
    !!
    d => gdump(DUMP_MOLINIT)
    d% active=.False.
    d% doread=.False.
    d% fname="+dumpmolinit"
    !!
    d => gdump(DUMP_VATOM)
    d% active=.False.
    d% doread=.False.
    d% fname="+dumpvatom"
    !!
    d => gdump(DUMP_KS)
    d% active=.False.
    d% doread=.False.
    d% fname="+dumpks"
    !!
    d => gdump(DUMP_TI)
    d% active=.False.
    d% doread=.False.
    d% fname="+dumpti"
    !!
    !!
    Return
    !!
  End Subroutine init_dumps
  !!***********************************************************************
  Subroutine setup_dump_states()
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="setup_dump_states"
    Integer(t_int) :: idump
    Integer :: eof
    Character(100)   :: fname
    Logical(t_log) :: exists,active
    !!
    !! todo: pout the data into fedit
    Inquire(file='=.dump',exist=exists)
    If(exists)Then
       Open(12,file='=.dump')
       Do
          Read(12,fmt=*,iostat=eof) fname,active
          If(eof/=0) Exit
          If(Trim(fname)=='molpot')Then
             gdump(DUMP_MOLPOT)% active=active
          Elseif(Trim(fname)=='molinit')Then
             gdump(DUMP_MOLINIT)% active=active
          Else If(Trim(fname)=='vatom')Then
             gdump(DUMP_VATOM)% active=active
          Else If(Trim(fname)=='ks')Then
             gdump(DUMP_KS)% active=active
          Else If(Trim(fname)=='ti')Then
             gdump(DUMP_TI)% active=active
          Else
             Write(errbuf,100)fname
100          Format("'unknown dump mode: ",a,"'")
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
          Endif
       Enddo
    Endif
    !!
    Do idump=1,DUMP_LAST
       Call setup_dump_state(gdump(idump))
    Enddo
    !!
    Return
    !!
  End Subroutine setup_dump_states
  !!***********************************************************************
  Subroutine setup_dump_state(du)
    !!
    Implicit None
    !!IO
    Type(T_Dump),Intent(inout)   :: du
    !!LOCAL
    !Character(*),Parameter::nsubfunc="setup_dump_state"
    Logical(t_log) :: exists
    !!
    !!
    !!
    If(du% active)Then
       Inquire(file=du% fname,exist=exists)
       If(exists)Then
          du% doread=.True.
       Else

          du% doread=.False.
       Endif
       If(du% doread)Then
          Write(outfile,"('Found file ''',a,''', &
               &will use dump in first step')") Trim(du% fname)
       Else
          Write(outfile,"('Did not find file ''',a,''', &
               &will dump in each step')") Trim(du% fname)
       Endif
    Endif
    !!
    Return
    !!
  End Subroutine setup_dump_state
  !!***********************************************************************
  !!***********************************************************************
  Logical(t_log) Function dumpread(idump)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: idump
    !!LOCAL
    !Character(*),Parameter::nsubfunc="dumpread"
    !!
    !!
    dumpread=(gdump(idump)% active .And. gdump(idump)% doread)
    If(dumpread)Then
       Write(outfile,"('Will read data from ''',a,''' ')") &
            &Trim(gdump(idump)% fname)
    Endif
    !!
    Return
    !!
  End Function dumpread
  !!***********************************************************************
  Logical(t_log) Function dumpwrite(idump)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: idump
    !!LOCAL
    !Character(*),Parameter::nsubfunc="dumpwrite"
    !!
    !!
    dumpwrite=(gdump(idump)% active .And. .Not. gdump(idump)% doread)
    If(dumpwrite)Then
       Write(outfile,"('Will dump data on ''',a,''' ')") &
            &Trim(gdump(idump)% fname)
    Endif
    !!
    Return
    !!
  End Function dumpwrite
  !!***********************************************************************

End Module dump
