Module fatband
  Use precisiondefs
  Use file_iounits
  Use constants
  Use errors
  Use ioaux
  Use memory
  Use atomdefs
  Use tfatband
  Use tdiracdefs
  Use trelativistic
  Use tsymmetry
  Use prnt
  Use diracdefs
  Use tkohnsham
  Use torbitalbasis
  Use matserv
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="FATBAND"  
  !!
  Public :: read_fatband_definitions,cfatbandweightlabel&
       &,cfatbandnumweights,cfatbandnumbw,cfatbandissimple,cfatbandsite&
       &,cfatbandorbtype,cfatbandnv,cfatbandlv,cfatbandjv,cfatbandmv&
       &,cfatbandaxes,cfatbandisactive
  !!**********************************************************************
  Interface
     Character(17) Function cfatbandweightlabel(iw)
       Use precisiondefs
       Implicit None  
       Integer(t_int),Intent(in) :: iw
     End Function cfatbandweightlabel
  End Interface
  !!
  Interface
     Integer(t_int) Function cfatbandnumweights()
       Use precisiondefs
       Implicit None  
     End Function cfatbandnumweights
  End Interface
  !!
  Interface
     Integer(t_int) Function cfatbandnumbw()
       Use precisiondefs
       Implicit None  
     End Function cfatbandnumbw
  End Interface
  !!
  Interface
     Logical(t_log) Function cfatbandissimple(ibwd)
       Use precisiondefs
       Implicit None  
       Integer(t_int),Intent(in)    :: ibwd
     End Function cfatbandissimple
  End Interface
  !!
  !!
  Interface
     Logical(t_log) Function cfatbandisactive(ibwd)
       Use precisiondefs
       Implicit None  
       Integer(t_int),Intent(in)    :: ibwd
     End Function cfatbandisactive
  End Interface
  !!
  Interface
     Integer(t_int) Function cfatbandsite(icn,ibwd)
       Use precisiondefs
       Implicit None  
       Integer(t_int),Intent(in)    :: icn,ibwd
     End Function cfatbandsite
  End Interface
  !!
  Interface
     Integer(t_int) Function cfatbandorbtype(icn,ibwd)
       Use precisiondefs
       Implicit None  
       Integer(t_int),Intent(in)    :: icn,ibwd
     End Function cfatbandorbtype
  End Interface
  !!
  Interface
     Integer(t_int) Function cfatbandnv(icn,ibwd)
       Use precisiondefs
       Implicit None  
       Integer(t_int),Intent(in)    :: icn,ibwd
     End Function cfatbandnv
  End Interface
  !!
  Interface
     Integer(t_int) Function cfatbandlv(icn,ibwd)
       Use precisiondefs
       Implicit None  
       Integer(t_int),Intent(in)    :: icn,ibwd
     End Function cfatbandlv
  End Interface
  !!
  Interface
     Integer(t_int) Function cfatbandjv(icn,ibwd)
       Use precisiondefs
       Implicit None  
       Integer(t_int),Intent(in)    :: icn,ibwd
     End Function cfatbandjv
  End Interface
  !!
  Interface
     Integer(t_int) Function cfatbandmv(icn,ibwd)
       Use precisiondefs
       Implicit None  
       Integer(t_int),Intent(in)    :: icn,ibwd
     End Function cfatbandmv
  End Interface
  !!
  Interface
     Character(200) Function cfatbandaxes(icn,ibwd)
       Use precisiondefs
       Implicit None  
       Integer(t_int),Intent(in)    :: icn,ibwd
     End Function cfatbandaxes
  End Interface
  !!**********************************************************************
Contains
  Subroutine read_fatband_definitions(structure,basis,kohnsham&
       &,bwdef,quant,relativistic)
    !!
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(inout) :: structure
    Type(T_Basis),Intent(inout)  :: basis
    Type(T_Kohnsham),Intent(inout):: kohnsham
    Type(T_BWDefs),Intent(inout) :: bwdef
    Type(T_Quant),Intent(inout)  :: quant
    Integer(t_int),Intent(in)    :: relativistic
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_fatband_definitions"
    Logical(t_log) :: exists,rel,err
    Integer(t_int) :: j
    Integer(t_int) :: nw
    Character(5000):: buf,errm
    !Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Character(2)   :: updn(2)
    Data updn(1)/'up'/
    Data updn(2)/'dn'/
    Character(*),Parameter :: mesg="FATBANDS"
    External csetcoeffbasisinfo
    External cfatbandload,cgetoutputsize,cgetoutput
    External cfatbandsetGlobalSpinZaxis
    !!
    !!
    rel=(relativistic==FULL_RELATIVISTIC)
    !!
    bwdef% active=.False.
    If(Len_trim(bwdef% bwdfilename)==0) Return
    bwdef% active=.True.
    !!
    Inquire(file=Trim(bwdef% bwdfilename),exist=exists)
    If(.Not.exists) Then
       bwdef% active=.False.
       Write(outfile,4) mesg,'File '//Trim(bwdef% bwdfilename)&
            &//' does not exist, resume normal operation'
       Return
    Endif
    !!
    !!
    Call copy_file_to_output(outfile,Trim(bwdef% bwdfilename))
    !!
    !! new code
    Write(outfile,1)mesg
    Write(outfile,102)mesg,Trim(bwdef% bwdfilename)
    Write(outfile,31)mesg
    Write(outfile,31)mesg
    !!
    !!
    Call csetcoeffbasisinfo(structure% nsite&
         &,structure% p_isrt,structure% p_elements&
         &,basis% nRvmx,basis% p_nRv,basis% p_nnRv,basis% p_lRv,basis% p_degRv&
         &,kohnsham% p_vblockstart,kohnsham% p_vblocklength,rel)
    !!
    bwdef% bwfile='+bweights_bwdef'
    Call cfatbandload(bwdef% bwdfilename,bwdef% bwfile,err,errm)
    If(err)Then
       Write(errbuf,"('''',a,': while reading ',a,': ',a,'''')")&
            &mesg,Trim(bwdef% bwdfilename),Trim(errm)
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    Endif
    !!
    Call cfatbandsetGlobalSpinZaxis(quant% axis)
    !!
    !!
    !!
    Call cgetoutputsize(nw)
    Do j=1,nw
       Call cgetoutput(j,buf)
       Write(outfile,"(a,': ',a)")mesg,Trim(buf)
    Enddo
    !!
    !!
    !!
    Return
    !!
1   Format(a,': ',72('='))
102 Format(a,': Found file ''',a,''', will use fatband definitions.')
31  Format(a,':')
4   Format(a,': ',a20)
    !!
  End Subroutine read_fatband_definitions
  !!***********************************************************************

End Module fatband
