Module fedit
  !!
  Use precisiondefs
  Use constants
  Use file_iounits
  Use errors
  Use tio
  Use ioaux
  Use xc
  Use tsymmetry
  Use symmetry
  Use terg
  Use tgrid
  Use finuc
  Use tbandplot
  Use trelativistic
  Use atomdefs
  Use titeration
  Use tcpa
  Use tbzone
  Use tpotentialdensity
  Use tlsdau
  Use tforces
  Use topc
  Use tdiracdefs
  Use tmesh
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="FEDIT"  
  !!
  Public :: create_fedit,create_atomfedit
  !!***********************************************************************
contains
  !!***********************************************************************
  ! create_fedit
  ! {{{ 

  Subroutine create_fedit

    !!
    Implicit None 
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="create_fedit"
    Logical(t_log) :: exist
    Integer(t_int) :: i,j,n,j0,l,lunit
    Character(2)  :: el
    Logical(t_log),Parameter :: notyetcpa=.False.
    !!
    Inquire(file=f_fedit_in ,exist=exist)
    If(exist)Then
       !!Write(outfile,"('File ',a,' exists, not recreated!')")Trim(f_fedit_in)
       Return
    Endif
    lunit=12
    Open(lunit,file=f_fedit_in)
    Write(lunit,"(a)")&
         &"########################################################################"&
         &,"# this file is part of the FPLO bandstructure package"&
         &,"# it was created automatically"&
         &,"# please dont delete this file nor"&
         &,"# edit it, unless you really know what you are doing"&
         &,"# any changes added by you may be lost if this file is recreated"&
         &,"# by FPLO (which is the normal behaviour )"&
         &,"# so keep duplicates of your changes somewhere else"&
         &,"#"&
         &,"########################################################################"
    Write(lunit,"(/,/)")
    !! header with version  numbers
    Write(lunit,"('section header{')")
    Call write_version(lunit)
    Write(lunit,"('};',/)")  
    Write(lunit,"('section Data{',/)")
    Write(lunit,"(a)")&
         & '  struct{'&
         &,'     char[*] screenname;'&
         &,'     char[*] filename;'&
         &,'     struct {'&
         &,'        char[*] action;'&
         &,'        char[*] menubarentry;'&
         &,'        char[*] actionname;'&
         &,'        }menus[*];'&
         &,'     struct{'&
         &,'        char[*] action;'&
         &,'        char[*] variablename;'&
         &,'        char[*] defaultvalue;'&
         &,'        char[*] fieldname;'&
         &,'        int namepos;'&
         &,'        int fieldoffset;'&
         &,'        int fieldwidth;'&
         &,'        char[*] testflags;'&
         &,'        char[*] testset[*];'&
         &,'        real intervalleft;'&
         &,'        real intervalright;'&
         &,'        }entries[*];'&
         &,'     }screens[*]='
    Write(lunit,"('  {')") 
    !!***********************************************************************
    !! main menu
    Write(lunit,'(''     {"MAIN MENU"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    !! main menu: menu entries
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)")&
         & ' {"MAIN | MAINQUIT","@(q)uit/save",""}'&
         &,',{"MAIN | MAINEXIT","e@(x)it/discard",""}'&
         &,',{"MAIN | EXTERNEDIT","@(e)xtern edit",""}'&
         &,',{"MAIN | SUBMENU","@(+) Symmetry","SYMMETRY MENU"}'&
!         &,',{"MAIN | SUBMENU","@(b)asis","BASIS DEFINITION"}'&
         &,',{"MAIN | SEPARATOR","",""}'&
         &,',{"MAIN | HELP","@(H)elp",""}'&
         &,',{"ALT  | SUBMENU","@(B)andplot","BANDPLOT"}'&
!         &,',{"ALT  | SUBMENU","@(C)pa","CPA"}'&
         &,',{"ALT  | SUBMENU","@(l)SDA+U","LSDA+U"}'&
         &,',{"ALT  | SUBMENU","O@(p)C","OPC"}'&
         &,',{"ALT  | SUBMENU","@(F)orces","FORCES"}'&
         &,',{"ALT  | SUBMENU","@(m)esh","MESH DEFINITION"}'&
         &,',{"ALT  | RESTORE","@(R)estore",""}'&
         &,',{"ALT  | REBUILD","R@(e)create","'//Trim(f_fplo_in)//'"}'&
         !!&,',{"MAIN | EOL","",""}'&
         &,',{"ALT  | EOL","",""}'&
         &,',{"ALT  | SUBMENU","@(I)nitial spinsplit","INITIAL SPINSPLIT"}'&
         &,',{"ALT  | SUBMENU","I@(t)eration","ITERATION CONTROL"}' &
         &,',{"ALT  | EOL","",""}'&
         &,',{"ALT  | SUBMENU","Brillouin-@(z)one","BRILLOUIN ZONE INTEGRATION"}'&
         &,',{"ALT  | SUBMENU","@(N)umerics","NUMERICS"}'&
         &,',{"ALT  | SUBMENU","@(G)rid-output","GRID OUTPUT"}'&
         &,',{"ALT  | SUBMENU","Core-@(o)ccupation","CORE OCCUPATION"}'&
         &,',{"ALT  | SUBMENU","Topological-Ins@(u)lators","TOPOLOGICAL INSULATORS"}'&
         &,',{"ALT  | SUBMENU","Opti@(c)s","OPTICS"}'&
         &,',{"ALT  | SUBMENU","C@(h)arges","CHARGES"}'!&
!         &,',{"ALT  | SUBMENU","@(D)evelop","DEVELOP"}'
    Write(lunit,"(a)") '           }'
    !! main menu: screen items
    Write(lunit,"('          ,{')")
    Write(lunit,'(14x,'' {"TITLE|EOL","","","GENERAL DATA",1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM","spin.mspin","1","@(s)pin sorts",1,20,13&
         &,"TOGGLE",{"1","2"},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL","spin.initial_spin_split","f","@(i)nitial polarization",40,23,10&
         &,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST " ,"bzone_integration.nkxyz","12"&
         &,"@(k)-mesh subdivision",1,20,13,"",{},1,+INF}'')')

    Write(lunit,'(14x,'',{"ITEM|EOL","nband","-1","@(o)ccupied bands",40,23,10&
         &,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM   ","iteration_control.steps","40"&
         &,"@(n)umber of iterat.",1,20,13 ,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","iteration_control.tolerance","1.e-6"&
         &,"@(A)ccuracy of density",40,23,10 ,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,'(14x,'',{"ITEM   ","calc_etot","t"&
         &,"@(t)otal energy calc.",1,20,13 ,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","etot_tolerance","1.e-5"&
         &,"A@(c)curacy of Etot",40,23,10 ,"LEFT_OPEN",{},0,+INF}'')')

    Call write_sb_convcond(lunit,1_t_int,20_t_int,40_t_int)
    Write(lunit,'(14x,'',{"CHECKBOX | TWO_COLUMN | AUTO_WIDTH | EOL ","options"&
         &,"","@(-)\tOptions",40,23,10,"",{},0,0}'')')

!    Write(lunit,'(14x,'',{"ITEM|EOL","nfft_ewp_per_site","500"&
!         &,"@(F)ourier-comp of Ewald",40,23,10,"",{},-INF,+INF}'')')

    Call write_relat(lunit,1_t_int,20_t_int,40_t_int,.False.)




    Call write_sb_xcversion(lunit,1_t_int,20_t_int,40_t_int)

    Call write_nuc_type_dirac(lunit,1_t_int,20_t_int,40_t_int)

    Write(lunit,'(14x,'',{"ITEM|EOL","ex_field_strength","1.0","xc-field str@(e)ngth"&
         &,1,20,13,"",{},0,+INF}'')')

    Write(lunit,'(14x,'',{"ITEM","fsmoment.fsm","f","@(w) fixed spin mom."&
         &,1,20,13,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL","fsmoment.moment","0.","@(y) spin moment"&
         &,40,23,10,"",{},-INF,+INF}'')')




    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","RELATIVISTIC SETTINGS",1,-1,0,"",{},0,0}'')')
    Write(lunit,100)

    !Call write_spin_pop(lunit,1_t_int,26_t_int,40_t_int)
    !! quantization-axis for relativistic case
    Write(lunit,'(14x,'',{"ITEMLIST|EOL " ,"quantization_axis","0"&
         &,"Q@(u)antization-axis",1,20,40,"",{},-INF,+INF}'')')


    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","OTHERS",1,-1,0,"",{},0,0}'')')
    Write(lunit,100)


    Call  write_sb_verbositylevel(lunit)

    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! grid output menu
    Write(lunit,'(''    ,{"GRID OUTPUT"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")
    Write(lunit,101)
    Write(lunit,'(14x,'',{"ITEM|EOL" ,"grids_active","f","@(a)ctive",1,26,17,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL" ,"grids_stop_after","f","@(S)top after writing data",1,26,17,"",{},-INF,+INF}'')')
    Write(lunit,100)

    Write(lunit,'(14x,'',{"COMPOUND|EOL","grids","","GRID DEFINITIONS",1,-1,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"COUNTER" ,"","","@(N)umber of grid definitions",1,27,13,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"BODY" ,"","","",0,0,0,"",{},0,0}'')')
!!!GRID    Write(lunit,555)
    Call write_grid_basis(lunit)
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEMLIST|EOL" ,"direction1","1 0 0","@(1)st direction",1,26,17,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST|EOL" ,"direction2","0 1 0","@(2)nd direction",1,26,17,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST|EOL" ,"direction3","0 0 1","@(3)rd direction",1,26,17,"",{},-INF,+INF}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEMLIST|EOL" ,"origin","0","@(O)rigin",1,26,17,"",{},-INF,+INF}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEMLIST" ,"subdivision","30 30 30","@(S)ubdivisions",1,26,10,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL" ,"file","","@(U)ser file",47,11,15,"WORD",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL" ,"InclPeriodicPoints","t","@(I)nclude periodic points",1,26,17,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL" ,"createOpenDX","t","@(C)reate openDX files",1,26,17,"",{},0,+INF}'')')
    Write(lunit,100)
    Call write_grid_quantity(lunit)
    Write(lunit,100)
    Call write_grid_ouputdata(lunit)
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEMLIST|EOL" ,"scfwavefnctwindow","1 -1","SCF @(W)avefnct energy window",1,36,17,"",{},-INF,+INF}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"COMPOUND|EOL","energywindows","","@(r)\tEnergy resolved densities",1,-1,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL" ,"name","ewdens","N@(a)me",1,26,13,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"COUNTER" ,"","","@(N)umber of energy resolved densities",1,36,13,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"BODY" ,"","","",2,0,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"FIELD","sections","","",1,26,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"COUNTER|EOL" ,"","","@(N)umber of sections"&
         &,1,26,13,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"TITLE" ,"","","Emin             Emax             De        Spin"&
         &,11,-1,0,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"DASHLINE","","","",3,-1,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"emin","-1","",3,5,14,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"emax","0","",25,0,14,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"de","0.1","",42,0,7,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM|SELECTOR" ,"spin","0","",52,0,8,"",{"0\nboth","1\nup","2\ndown"},0,2}'')')
    Write(lunit,'(14x,'',{"ENDFIELD","","","",1,25,8,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"ENDCOMPOUND","","","",1,25,8,"",{},0,0}'')')
    Write(lunit,100)

    Write(lunit,'(14x,'',{"COMPOUND|EOL","kresolved","","@(k)-resolved densities/wave functions",1,-1,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"COUNTER" ,"","","Nu@(m)ber of k-resolved densit./Wave fu.",1,36,13,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"BODY" ,"","","",2,0,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL" ,"name","kdens","@(N)ame",3,24,14,"",{},-INF,0}'')')
    Write(lunit,'(14x,'',{"ITEMLIST|EOL" ,"kpoint","0 0 0","@(k)-point",3,24,-1,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST|EOL" ,"bandindices","1","@(b)ands",3,24,-1,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST|EOL" ,"energywindow","0","@(e)nergy window",3,24,24,"",{},-INF,+INF}'')')


    Write(lunit,'(14x,'',{"ENDCOMPOUND","","","",1,25,8,"",{},0,0}'')')

    Write(lunit,'(14x,'',{"ENDCOMPOUND","","","",1,25,8,"",{},0,0}'')')
    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! basis menu
!!$    Write(lunit,'(''    ,{"BASIS DEFINITION"'')')
!!$    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_basis)
!!$    Write(lunit,"('          ,{')")
!!$    Write(lunit,"('             ',a)") &
!!$         &'{"MAIN | EXIT ","e@(x)it",""}' &
!!$         &,',{"MAIN | EXTERNEDIT","@(e)xtern edit",""}'&
!!$         &,',{"MAIN | SEPARATOR","",""}' &
!!$         &,',{"MAIN | HELP","@(H)elp",""}'
!!$
!!$    Write(lunit,"('           }')")
!!$    Write(lunit,"('          ,{')")
!!$    Write(lunit,101)
!!$
!!$666 Format(14x,',{"BASIS| COM_BASIS_GROUP_EDIT |EOL","basis","'&
!!$         &,i2,'","BASIS and COMPRESSION",1,20,-1,"",{},0,0}')
!!$    Write(lunit,666) ORBITAL_MAX_L
!!$
!!$
!!$    Write(lunit,"('           }')")
!!$    Write(lunit,"('     }')")
    !!***********************************************************************
    !! iteration menu
    Write(lunit,'(''    ,{"ITERATION CONTROL"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")
    Write(lunit,101)
    Call write_iterationscheme(lunit)
    Write(lunit,'(14x,'',{"ITEM |EOL  ","iteration_control.mixing","0.2"&
         &,"M@(i)xing",1,22,13 ,"LEFT_OPEN",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","iteration_control.maxdim","5"&
         &,"@(M)ax subspace dim",1,22,13 ,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","iteration_control.progress","0.2"&
         &,"@(P)rogress",1,22,13 ,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","ITERATION VECTOR RATIO"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL  ","iterationvector_ratio.U","1.0"&
         &,"@(2)\toccu mat / density",1,22,13 ,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! mesh menu
    Write(lunit,'(''    ,{"MESH DEFINITION"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")
    !!Write(lunit,101)

    Write(lunit,'(14x,'' {"TITLE|EOL","","","RADIAL FUNCTION MESH"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)

    Write(lunit,'(14x,'',{"ITEM " ,"radial_mesh.nr","200"&
         &,"@(1)\tnumber of mesh points",1,25,8,"",{},2,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL " ,"radial_mesh.rmin","1.e-4"&
         &,"@(2) minimal radius",40,25,8,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,'(14x,'',{"ITEM " ,"radial_mesh.rmax","0"&
         &,"@(3)\tmaximal radius",1,25,8,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL " ,"radial_mesh.rmax_factor","1.0"&
         &,"@(4) factor for rmax",40,25,8,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","ATOM MESH"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)

    Write(lunit,'(14x,'',{"ITEM " ,"atom_radial_mesh.nr","200"&
         &,"@(5)\tnumber of mesh points",1,25,8,"",{},2,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL " ,"atom_radial_mesh.rmin","1.e-7"&
         &,"@(6) minimal radius",40,25,8,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,'(14x,'',{"ITEM|EOL " ,"atom_radial_mesh.rmax","0"&
         &,"@(7)\tmaximal radius",1,25,8,"",{},0,+INF}'')')


    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! bzone menu
    Write(lunit,'(''    ,{"BRILLOUIN ZONE INTEGRATION"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")

    Write(lunit,101)

    Write(lunit,'(14x,'',{"ITEM|EOL " ,"bzone_kT","1000"&
         &,"@(T)emperature",1,25,8,"",{},0,+INF}'')')


    Write(lunit,555)

    Write(lunit,'(14x,'',{"TITLE|EOL","","","WARNING: METAL SWITCH AND &
         &METHFESSEL PAXTON ARE NOT TESTED !!!"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)



    Call write_bz_method(lunit)

    Write(lunit,'(14x,'',{"ITEM|EOL " ,"bzone_integration.metal","t"&
         &,"@(s)uppose its a metal",1,25,8,"",{},0,+INF}'')')


    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","METHFESSEL-PAXTON METHOD"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    
    !Write(lunit,'(14x,'',{"ITEM " ,"mp_bzone_integration.ne","1001"&
    !     &,"@(n)umber of energy points",1,25,8,"",{},2,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM " ,"mp_bzone_integration.width","0.005"&
         &,"@(w)idth parameter",1,25,8,"LEFT_OPEN",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL " ,"mp_bzone_integration.norder","0"&
         &,"@(o)rder parameter",40,25,8,"",{},0,+INF}'')')
    !Write(lunit,'(14x,'',{"ITEM |EOL " ,"mp_bzone_integration.range","5."&
    !     &,"@(r)ange parameter",40,25,8,"LEFT_OPEN",{},0,+INF}'')')


    



    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! bandplot menu
    Write(lunit,'(''    ,{"BANDPLOT"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")
    Write(lunit,101)
    
    Write(lunit,'(14x,'',{"ITEM |EOL  ","bandplot_control.bandplot","f"&
         &,"@(B)andstructure plot",1,27,13 ,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","bandplot_control.read_sympoints","t"&
         &,"@(R)ead sym-points",1,27,13 ,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","bandplot_control.ndivisions","50"&
         &,"@(s)teps between sym-points",1,27,13 ,"",{},1,+INF}'')')

    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","DOS/AKBL/BANDS"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM  ","bandplot_control.nptdos","1000"&
         &,"Number of e@(-)pts (non-CPA)",1,27,13 ,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","bandplot_control.plot_idos","f"&
         &,"@(p)lot IDOS",50,16,8 ,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","bandplot_control.plot_ndos","f"&
         &,"plot n@(e)t DOS",50,16,8 ,"",{},-INF,+INF}'')')

    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM|EOL  ","bandplot_control.emin","-10.0"&
         &,"@(l)ower energy bound [eV] relative to E_f",1,41,13 ,"",{},-INF,+INF}'')')

    !!Call write_sb_energy_units(lunit,50_t_int,16_t_int,8_t_int)

    Write(lunit,'(14x,'',{"ITEM|EOL  ","bandplot_control.emax","10.0"&
         &,"@(u)pper energy bound [eV] relative to E_f",1,41,13 ,"",{},-INF,+INF}'')')

    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL  ","bandplot_control.restrict_bands_to_window"&
         &,"t","Restr@(i)ct bands to window",1,27,13 ,"",{},0,+INF}'')')

    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEMLIST|EOL " ,"ldossites","1"&
         &,"Local @(D)OS sites",1,20,40,"",{},1,+INF}'')')

    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEMLIST|EOL " ,"bandplot_control.coeffout","f"&
         &,"Output +@(c)oeff file",1,20,40,"",{},1,+INF}'')')
    
    Write(lunit,100)
    !Call write_frelprojection(lunit,1,20,40)


    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","BAND WEIGHTS/FAT BANDS"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)

    Write(lunit,'(14x,'',{"ITEM |EOL  ","bandweight_control.bwdfilename"&
         &,""&
         &,"Weights def @(f)ile",1,27,13 ,"",{},0,+INF}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL  ","bandweight_control.bandweights","f"&
         &,"@(w)eights",1,27,13 ,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","bandweight_control.bweight_rot","f"&
         &,"@(t)ransform quant. axis",1,27,13 ,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST |EOL  ","bandweight_control.x_axis","0."&
         &,"X-@(a)xis",1,27,43 ,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST |EOL  ","bandweight_control.z_axis","0."&
         &,"@(z)-axis",1,27,43 ,"",{},-INF,+INF}'')')

    Write(lunit,100)    
    Write(lunit,100)    

    Write(lunit,'(14x,'',{"FIELD","special_sympoints","","",1,27,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"COUNTER" ,"","","@(N)umber of sym-points"&
         &,1,27,13,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"DASHLINE","","","",1,-1,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"TITLE" ,"",""," No.    Label                 k-point"&
         &,1,-1,0,"",{},0,+INF}'')')
    Write(lunit,555)
    Write(lunit,'(14x,'',{"ITEM" ,"label","$~G","",1,5,17,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST" ,"kpoint","0.","",27,1,43,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ENDFIELD","","","",1,25,8,"",{},0,0}'')')


    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! forces menu
    Write(lunit,'(''    ,{"FORCES"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")
    Write(lunit,101)

    Call write_force_mode(lunit)
    Write(lunit,555)

    Write(lunit,'(14x,'',{"TITLE|EOL","","","SITE GEOMETRY OPTIMIZATION"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)

    Write(lunit,'(14x,'',{"ITEM  ","force_iteration_control&
         &.tolerance","1.e-3"&
         &,"@(A)ccuracy [eV/Ang]",1,20,13 ,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,'(14x,'',{"ITEM |EOL  ","force_iteration_control.maxdim"&
         &,"-1"&
         &,"@(M)ax subspace dim",40,22,13 ,"",{},-1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL   ","force_iteration_control.steps","100"&
         &,"@(n)umber of iterat.",1,20,13 ,"",{},1,+INF}'')')


    Call write_force_iterationscheme(lunit)
    Write(lunit,100)

    Write(lunit,'(14x,'',{"ITEMLIST|EOL " ,"geomopt_sites","1"&
         &,"@(W)yckoffs to vary",1,20,-1,"",{},1,+INF}'')')
    

    Write(lunit,555)

    Write(lunit,'(14x,'',{"TITLE|EOL","","","OPTIONS"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)

    Write(lunit,'(14x,'',{"ITEM|EOL","force_in_each_step","f"&
         &,"@(C)alculate force in each step.",1,30,13 ,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM   ","approx_nodndL_ewald","f"&
         &,"Not potential @(e)wald correction",1,30,13 ,"",{},1,+INF}'')')


!!$    Write(lunit,'(14x,'',{"FIELD | EOL","core_occupation","","",1,23,0,"",{},0,0}'')')
!!$    Write(lunit,'(14x,'',{"COUNTER" ,"","","@(N)umber of definitions",1,23,13,"",{},0,+INF}'')')
!!$    Write(lunit,'(14x,'',{"DASHLINE","","","",1,-1,0,"",{},0,0}'')')
!!$    Write(lunit,'(14x,'',{"TITLE" ,"",""," No.    Wy-pos. state          &
!!$         &spinup                     spindown",1,-1,0,"",{},0,+INF}'')')
!!$    Write(lunit,555)
!!$    Write(lunit,'(14x,'',{"ITEM" ,"sort","1","",1,5,4,"",{},1,+INF}'')')
!!$    Write(lunit,'(14x,'',{"ITEM" ,"state","1s","",14,0,3,"STATE",{},0,+INF}'')')
!!$    Write(lunit,'(14x,'',{"ITEMLIST" ,"spinup","0.","",23,0,22,"",{},0,+INF}'')')
!!$    Write(lunit,'(14x,'',{"ITEMLIST" ,"spindn","0.","",50,0,22,"",{},0,+INF}'')')
!!$    Write(lunit,'(14x,'',{"ENDFIELD","","","",1,25,8,"",{},0,0}'')')
    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! core occupation menu
    Write(lunit,'(''    ,{"CORE OCCUPATION"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")
    Write(lunit,101)

    Write(lunit,'(14x,'',{"FIELD | EOL","core_occupation","","",1,23,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"COUNTER" ,"","","@(N)umber of definitions",1,23,13,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"DASHLINE","","","",1,-1,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"TITLE" ,"",""," No.    Wy-pos. state          &
         &spinup                     spindown",1,-1,0,"",{},0,+INF}'')')
    Write(lunit,555)
    Write(lunit,'(14x,'',{"ITEM" ,"sort","1","",1,5,4,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"state","1s","",14,0,3,"STATE",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST" ,"spinup","0.","",23,0,22,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST" ,"spindn","0.","",50,0,22,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ENDFIELD","","","",1,25,8,"",{},0,0}'')')
    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! LSDA+U menu
    Write(lunit,'(''    ,{"LSDA+U"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")

    Write(lunit,'(14x,''{"TITLE|EOL","","","GENERAL CONTROL"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"make_lsdau","f","@(m)ake LSDA+U",1,22,11,"",{},1,+INF}'')')
    Write(lunit,100)
    Call write_lsdaufunctional(lunit)
    Call write_lsdauprojection(lunit)


    Write(lunit,100)
    Write(lunit,555)

    Write(lunit,'(14x,'',{"FIELD | EOL","lsdau_defs","","CORRELATED STATES",1,23,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"COUNTER" ,"","","@(N)umber of definitions",1,23,13,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"DASHLINE","","","",1,40,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"TITLE" ,"",""," No.    Wy-pos. state    F0 F2 F4 F6 (eV)",1,-1,0,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"DASHLINE|EOL","","","",1,40,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"sort","1","",1,5,4,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"state","1s","",14,0,3,"STATE",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEMLIST" ,"f_slater","0.","",23,0,-1,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ENDFIELD","","","",1,25,8,"",{},0,0}'')')


    Write(lunit,100)
    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","ITERATION CONTROL"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL  ","lsdau_dmat_deviation","1.e-2"&
         &,"@(O)ccu. matrix tolerance",1,22,10 ,"LEFT_OPEN",{},0,+INF}'')')

    Call write_lsdaudmatmodes(lunit)


    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !!***********************************************************************
    !! OPC menu
    Write(lunit,'(''    ,{"OPC"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")

    Write(lunit,'(14x,''{"TITLE|EOL","","","GENERAL CONTROL"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"make_opc","f","@(m)ake OPC",1,22,11,"",{},1,+INF}'')')
    Write(lunit,100)
    Call write_opcfunctional(lunit)
    !Call write_opcprojection(lunit)

    Write(lunit,100)
    Write(lunit,555)

    Write(lunit,'(14x,'',{"FIELD | EOL","opc_defs","","OPC STATES",1,23,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"COUNTER" ,"","","@(N)umber of definitions",1,23,13,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"DASHLINE","","","",1,40,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"TITLE" ,"",""," No.    Wy-pos. state   ",1,-1,0,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"DASHLINE|EOL","","","",1,40,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"sort","1","",1,5,4,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"state","1s","",14,0,3,"STATE",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ENDFIELD","","","",1,25,8,"",{},0,0}'')')


    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! initial_spin_split menu
    Write(lunit,'(''    ,{"INITIAL SPINSPLIT"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")
    Write(lunit,101)
    Write(lunit,'(14x,'',{"FIELD | EOL","initial_spin_split",""&
         &,"",1,23,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"TITLE" ,"","","Wy-pos. element initial spin",1,-1,0,"",{},0,+INF}'')')
    Write(lunit,555)
    Write(lunit,'(14x,'',{"ITEM|FIXED" ,"element","E ","",1,5,4,"",{},1,&
         &+INF}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"split","0.5","",14,0,15,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ENDFIELD","","","",1,25,8,"",{},0,0}'')')
    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! CPA menu
    Write(lunit,'(''    ,{"CPA"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")
    If(notyetcpa)Then
       Write(lunit,101)
       Write(lunit,'(14x,'',{"TITLE|EOL","","","IMPLEMENTATION NOT YET READY"&
            &,1,-1,0,"",{},0,0}'')')
    Else

       Write(lunit,'(14x,'' {"FIELD | EOL","concentrations",""&
            &,"CONCENTRATION",1,23,0,"",{},0,0}'')')
       Write(lunit,'(14x,'',{"TITLE" ,"","","_________________________________"&
            &,1,-1,0,"",{},0,+INF}'')')
       Write(lunit,'(14x,'',{"TITLE" ,"","","Wy-pos. element concentration"&
            &,1,-1,0,"",{},0,+INF}'')')
       Write(lunit,'(14x,'',{"TITLE" ,"","","_________________________________"&
            &,1,-1,0,"",{},0,+INF}'')')
       Write(lunit,'(14x,'',{"ITEM|FIXED" ,"atom","E ","",1,5,4,"",{},1,&
            &+INF}'')')
       Write(lunit,'(14x,'',{"ITEM" ,"concentration","1.0",""&
            &,14,0,15,"LEFT_OPEN",{},0,1.0}'')')
       Write(lunit,'(14x,'',{"ENDFIELD","","","",1,25,8,"",{},0,0}'')')
       Write(lunit,'(14x,'',{"TITLE" ,"","","_________________________________"&
            &,1,-1,0,"",{},0,+INF}'')')
       Write(lunit,100)

       
       Write(lunit,555)
!CPA:       Write(lunit,'(14x,'',{"TITLE|EOL","","","DENSITY OF STATES&
!CPA:            &, BLOCH SPECTRAL DENSITY",1,-1,0,"",{},0,0}'')')
       Write(lunit,'(14x,'',{"TITLE|EOL","","","DENSITY OF STATES"&
            &,1,-1,0,"",{},0,0}'')')
       Write(lunit,100)
       Write(lunit,'(14x,'',{"ITEM " ,"cpa_dos.ne","1000"&
            &,"@(dn)\tnumber of e-points",1,25,8,"",{},2,+INF}'')')
       Write(lunit,'(14x,'',{"ITEM |EOL " ,"cpa_dos.eimag","1.e-3"&
            &,"@(di)\timag(e)",40,25,8,"LEFT_OPEN",{},0,+INF}'')')
       
!       Write(lunit,555)
!       Write(lunit,'(14x,'',{"TITLE|EOL","","","BLOCH SPECTRAL DENSITY"&
!            &,1,-1,0,"",{},0,0}'')')
!       Write(lunit,100)
!       Write(lunit,'(14x,'',{"ITEM " ,"cpa_bloch_spectral_density.ne","100"&
!            &,"@(bn)\tnumber of e-points",1,25,8,"",{},2,+INF}'')')
!       Write(lunit,'(14x,'',{"ITEM |EOL " ,"cpa_bloch_spectral_density.eimag"&
!            &,"1.e-3","@(bi)\timag(e)",40,25,8,"LEFT_OPEN",{},0,+INF}'')')
       
       
       Write(lunit,555)
       Write(lunit,'(14x,'',{"TITLE|EOL","","","SELF ENERGY ITERATION"&
            &,1,-1,0,"",{},0,0}'')')
       Write(lunit,100)
       
       Write(lunit,'(14x,'',{"ITEM " ,"cpa_control.emin0","-1.60"&
            &,"@(l)ower energy bound",1,25,8,"",{},-INF,+INF}'')')
       Write(lunit,'(14x,'',{"ITEM |EOL " ,"cpa_control.emax0","0.4"&
            &,"@(u)pper energy bound",40,25,8,"",{},-INF,+INF}'')')
       Write(lunit,'(14x,'',{"ITEM |EOL " ,"cpa_control.eimag","1.e-5"&
            &,"@(im)aginary part at e_F",1,25,8,"LEFT_OPEN",{},0,+INF}'')')

       Write(lunit,'(14x,'',{"ITEM " ,"cpa_control.nec","16"&
            &,"@(n)umber of e-points",1,25,8,"",{},2,+INF}'')')
       Write(lunit,'(14x,'',{"ITEM |EOL " ,"cpa_control.max_se_loops","10"&
            &,"@(c)pa loops maximum",40,25,8,"",{},1,+INF}'')')
       
       
       
       
       Write(lunit,555)
       Write(lunit,'(14x,'',{"TITLE|EOL","","","FERMI ENERGY ITERATION"&
            &,1,-1,0,"",{},0,0}'')')
       Write(lunit,100)
       
       Write(lunit,'(14x,'',{"ITEM " ,"cpa_fermi_control.efermi0","0.08"&
            &,"@(g)uess of fermi energy",1,25,8,"",{},-INF,+INF}'')')
       Write(lunit,'(14x,'',{"ITEM |EOL " ,"cpa_fermi_control.max_ef_loops","10"&
            &,"@(m)ax e-fermi loop",40,25,8,"",{},1,+INF}'')')
       
       Write(lunit,'(14x,'',{"ITEM " ,"cpa_fermi_control.slop_0","30."&
            &,"@(f)irst slope",1,25,8,"LEFT_OPEN",{},0,+INF}'')')
       Write(lunit,'(14x,'',{"ITEM |EOL " ,"cpa_fermi_control.slop_min","0.3"&
            &,"@(s)mallest slope",40,25,8,"LEFT_OPEN",{},0,+INF}'')')
       
       Call write_cpa_fermi_method(lunit)
    Endif


    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! numerics menu
    Write(lunit,'(''    ,{"NUMERICS"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'
    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")



    Write(lunit,'(14x,'' {"TITLE|EOL","","","POTENTIAL REPRESENTATION"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)

    Write(lunit,'(14x,'',{"ITEM | EOL","max_L","4","@(M)aximum L",1&
         &,25,8,"",{},0,12}'')')
    Write(lunit,555)


    Write(lunit,'(14x,'',{"TITLE|EOL","","","ONE CENTER INTEGRALS"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM | EOL" ,"one_center_integrals.nr","200"&
         &,"@(f)\tradial-mesh points",1,25,8,"",{},2,+INF}'')')


    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","COULOMB ENERGY CALCULATION"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM" ,"coulomb_energy_calc.nxi","26"&
         &,"@(i)\txi-mesh points",1,25,8,"",{},2,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"coulomb_energy_calc.neta","46"&
         &,"@(j)\teta-mesh points",40,25,8,"",{},2,+INF}'')')




    Write(lunit,555)

    Write(lunit,'(14x,'',{"TITLE|EOL","","","OVERLAP DENSITY CALCULATION"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM" ,"overlap_density_calc.nr","50"&
         &,"@(o)\tradial mesh points",1,25,8,"",{},2,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"overlap_density_calc.neta","20"&
         &,"@(p)\tazimutal mesh points",40,25,8,"",{},2,+INF}'')')



    Write(lunit,555)

    Write(lunit,'(14x,'',{"TITLE|EOL","","","CUT-OFF TOLERANCES"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM" ,"cutoff_tolerances.dens","1.e-7"&
         &,"@(q)\tdensity",1,25,8,"LEFT_OPEN",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"cutoff_tolerances.pot","50"&
         &,"@(r)\tpotential",40,25,8,"LEFT_OPEN",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL" ,"cutoff_tolerances.orbital","1.e-7"&
         &,"@(s)\torbitals",1,25,8,"LEFT_OPEN",{},0,+INF}'')')


    Write(lunit,555)

    Write(lunit,'(14x,'',{"TITLE|EOL","","","SYMMETRY TEST"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL" ,"symtest.tol","5.0e-13"&
         &,"@(t)\ttolerance",1,25,8,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","INTERPOLATION OF RADIAL FUNCTIONS"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL " ,"interpolation.degree","8"&
         &,"@(u)\tdegree",1,25,8,"",{},1,8}'')')


!!$    Write(lunit,555)
!!$    Write(lunit,'(14x,'',{"TITLE|EOL","","","CONFINING POTENTIAL"&
!!$         &,1,-1,0,"",{},0,0}'')')
!!$    Write(lunit,100)
!!$    Write(lunit,'(14x,'',{"ITEM|EOL","confining_potential.exponent","4.0"&
!!$         &,"@(v) Exponent"&
!!$         &,1,25,13,"LEFT_OPEN",{},0,+INF}'')')


!!$    Write(lunit,555)
!!$    Write(lunit,'(14x,'',{"TITLE|EOL","","","RELATIVISTIC BASIS MAPPING"&
!!$         &,1,-1,0,"",{},0,0}'')')
!!$    Write(lunit,100)


!!$    Write(lunit,555)
!!$    Write(lunit,'(14x,'',{"TITLE|EOL","","","EWALD CONTROL SETTINGS FIXED MODE"&
!!$         &,1,-1,0,"",{},0,0}'')')
!!$    Write(lunit,100)
!!$    Write(lunit,'(14x,'',{"ITEM|EOL" ,"ewald_parameter.cutoff","2.0"&
!!$         &,"@(y1)\tCutoff factor",1,25,8,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","EWALD CONTROL SETTINGS AUTOMATIC MODE"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)

    Write(lunit,'(14x,'',{"ITEM" ,"ewald_parameter.eps_r","1.0e-5"&
         &,"@(y2)\tReal space tolerance",1,25,8,"LEFT_OPEN",{},0.,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL" ,"ewald_parameter.eps_g","1.0e-5"&
         &,"@(y3)\tRec. space tolerance",40,25,8,"LEFT_OPEN",{},0.,+INF}'')')


    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    Write(lunit,'(''    ,{"TOPOLOGICAL INSULATORS"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")

    Write(lunit,'(14x,''{"TITLE|EOL","","","GENERAL CONTROL"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"topological_insulator.active","f"&
         &,"@(c)alculate Z2-invariant",1,22,11,"",{},1,+INF}'')')

    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    Write(lunit,'(''    ,{"OPTICS"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")

    Write(lunit,'(14x,''{"TITLE|EOL","","","GENERAL CONTROL"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"optics.active","f"&
         &,"@(m)ake optics",1,23,11,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"optics.jointdos","f"&
         &,"use @(j)oint dos",1,23,11,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"optics.stopafter","f"&
         &,"use @(s)top after optics",1,23,11,"",{},1,+INF}'')')
    Write(lunit,100)
    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","ENERGY WINDOW"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"optics.energy.ne","1000"&
         &,"@(n)umber of points",1,23,22,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"optics.energy.emin","0"&
         &,"@(l)ower energy [eV]",1,23,22,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"optics.energy.emax","10"&
         &,"@(u)pper energy [eV]",1,23,22,"",{},0,+INF}'')')

    

    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    Write(lunit,'(''    ,{"CHARGES"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")

    Write(lunit,'(14x,''{"TITLE|EOL","","","VCA"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM | EOL " ,"charges.make_vca","f"&
         &,"@(m)ake VCA",1,23,11,"",{},1,+INF}'')')
    Write(lunit,100)

    Write(lunit,'(14x,'',{"FIELD | EOL","charges.vca",""&
         &,"VCA DEFINITIONS",1,23,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"COUNTER" ,"","","@(N)umber of definitions"&
         &,1,23,13,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"DASHLINE","","","",1,40,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"TITLE" ,"",""," No.    Wy-pos. Z",1,-1,0,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"DASHLINE|EOL","","","",1,40,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"sort","1","",1,5,4,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM" ,"Z","0.","",14,0,22,"LEFT_OPEN",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ENDFIELD","","","",1,25,8,"",{},0,0}'')')

    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","GLOBAL CHARGES"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)

    Call write_charges_type(lunit,1_t_int,23_t_int,40_t_int)

    Write(lunit,'(14x,'',{"ITEM | EOL " ,"charges.ionicity","0.0"&
         &,"@(i)onicity",1,23,22,"",{},-INF,+INF}'')')

    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
!!$    !! develop menu
!!$    Write(lunit,'(''    ,{"DEVELOP"'')')
!!$    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_devel)
!!$    Write(lunit,"('          ,{')")
!!$    Write(lunit,"('             ',a)") &
!!$         &'{"MAIN | EXIT ","e@(x)it",""}' &
!!$         &,',{"MAIN | EXTERNEDIT","@(e)xtern edit",""}'&
!!$         &,',{"MAIN | SEPARATOR","",""}' &
!!$         &,',{"MAIN | HELP","@(H)elp",""}'
!!$
!!$    Write(lunit,"('           }')")
!!$    Write(lunit,"('          ,{')")
!!$    Write(lunit,101)
!!$
!!$    Call fedit_develop_menu(lunit)
!!$
!!$    Write(lunit,"('           }')")
!!$    Write(lunit,"('     }')")
    !!***********************************************************************
    !! symmetry menu
    Write(lunit,'(''    ,{"SYMMETRY MENU"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_fplo_sym)
    !! symmetry menu: screen items
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)")&
         & ' {"MAIN | EXIT | SPECIAL_SYMMETRY ","e@(x)it",""}'&
         !! TODO: to be removed eventually
         &,',{"MAIN | EXTERNEDIT","@(e)xtern edit",""}'&
         &,',{"MAIN | FPLORUN  ","@(+) Update",""}'&
         &,',{"MAIN | SEPARATOR","",""}'&
         &,',{"MAIN | HELP","@(H)elp",""}'&
         &,',{"ALT  | VIEWER","Symmetry @(i)nformation","$tmp/+symminfo"}'!!&
         !! TODO: to be removed eventually
         !!&,',{"ALT  | RESTORE","@(R)estore",""}'
                
    Write(lunit,"('           }')")
    !! screen menu: screen items
    Write(lunit,"('          ,{')")
    Write(lunit,101)

    Write(lunit,'(14x,'',{"ITEM|EOL","compound","","@(C)ompound",1,21,50&
         &,"",{},0,0}'')')


    !! ----------------------   structure type -------------------
    Write(lunit,"(13x,a,i2,a)")',{"SELECTBOX|  AUTO_WIDTH|EOL","structure_type","'&
         &,STR_TYPE_CRYSTAL,'","s@(t)ructure type",1,21,40,"",{'
    l=Size(STR_TYPES)
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,l
       Write(lunit,"('""',i6,'\n@(',a,')',a,'""')") i &
            &,STR_TYPES(i)(1_t_int:1_t_int) &
            &,Trim(STR_TYPES(i)(2_t_int:)) 
       If(i<l)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(13x,'},0,0}',/)")
    !! ----------------------------------------------------------


    Write(lunit,"(13x,a,/,a)") &
         &',{"SELECTBOX |PRINT_VALUE| VALUE_AS_HOTKEY |THREE_COLUMN | AUTO_WIDTH|EOL"'&
         &,',"spacegroup","225","@(S)pacegroup",1,21,40,"" ,{'
    !! Print spacegroup selection set 
    j=getCrystallSystem(1_t_int)
    n=1_t_int;
    write(lunit,"(16x,'""Note that only one choice of axis/origin is &
         &implemented, see help.""')")
                
    Write(lunit,"(16x,',""',a,'""',/,'                ')",advance='no')&
         &Trim(getCrystallSystemName(j))
    Do i=1_t_int,230_t_int
       j0=getCrystallSystem(i)
       If(j0/=j) Then
          j=j0;
          Write(lunit,"(/,16x,',""',a,'""',/,'                ')",advance='no')&
               &Trim(getCrystallSystemName(j))
          n=1_t_int;
       Endif
       Write(lunit,"(',')",advance='no')       
       Write(lunit,"('""',i3,'\n',a,'""')",advance='no') &
            &i,Trim(getSpacegroupName(i))
       If(Mod(n,4_t_int)==0_t_int)Write(lunit,"(/,'                ')",advance='no')
       n=n+1_t_int;
       
    Enddo
    Write(lunit,"()")
    Write(lunit,"(13x,'},0,0}',/)")


    Write(lunit,"(13x,a)")',{"SELECTBOX|  AUTO_WIDTH|EOL","lengthunit","1"&
         &,"@(U)nit of length",1,21,40,"",{'
    l=Size(SYM_LENGTH_UNITS)
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,l
       Write(lunit,"('""',i6,'\n@(',a,')',a,'""')") i &
            &,SYM_LENGTH_UNITS(i)(1_t_int:1_t_int) &
            &,Trim(SYM_LENGTH_UNITS(i)(2_t_int:)) 
       If(i<l)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(13x,'},0,0}',/)")



    Write(lunit,'(13x,'',{"ITEMLIST | EOL","lattice_constants","5.4"&
         &,"@(L)attice constants",1,21,50,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,'(13x,'',{"ITEMLIST | EOL","axis_angles","90"&
         &,"@(A)xis angles",1,21,50,"LEFT_OPEN",{},0,+INF}'')')

    Write(lunit,100)
    Write(lunit,'(13x,'',{"ITEMLIST | EOL","subgroupgenerators","0"&
         &,"Subgroup @(G)enerators",1,21,50,"LEFT_OPEN",{},0,64}'')')



!    Write(lunit,'(13x,'',{"ITEM | EOL","max_L","4","@(M)aximum L",1&
!         &,21,50,"",{},0,12}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM|EOL","nsort","1","@(n)umber of atoms",1&
         &,21,40,"",{},1,+INF}'')')
    Write(lunit,100)
    Write(lunit,'(13x,'',{"FIELD|EOL","wyckoff_positions",""&
         &,"Wyckoff positions",1,21,40,"",{},0,0}'')')
    Write(lunit,'(13x,'',{"ITEM" ,"element","Al","-th atom sort",1,21,5,"",{'')')
    Write(lunit,"(15(' '))",advance='no')
    Do i=0_t_int,MAX_ELEMENT
       el=getelementnname(i)
       Write(lunit,"('""',a,'""')",advance='no')el
       If(i< MAX_ELEMENT)Write(lunit,"(',')",advance='no')
       If(Mod(i+1_t_int,10_t_int)==0_t_int)Write(lunit,"(/,15(' '))",advance='no')
    Enddo
    Write(lunit,"(13x,'},0,+INF}')")
    Write(lunit,'(13x,'',{"ITEMLIST " ,"tau","0.","tau",30&
         &,0,40,"",{},-INF,+INF}'')')
    Write(lunit,'(13x,'',{"ENDFIELD","","","",1,21,40,"",{},0,0}'')')

    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    Write(lunit,"('  };')")
    ! end section data
    Write(lunit,"('};')") 
    Close (lunit)
    Write(errbuf,"('File ',a,' created!')")Trim(f_fedit_in)
    Call terminate(TERM_NORMAL,errbuf)
    !!
100 Format(14x,',{"EOL","","","",0,0,0,"",{},0,0}')
101 Format(14x,'{"EOL","","","",0,0,0,"",{},0,0}')
555 Format(14x,',{"DASHLINE|EOL","","","",1,-1,0,"",{},0,0}')
  End Subroutine create_fedit

  ! }}}
  !!***********************************************************************
  ! write_sb_verbositylevel
  ! {{{ 

  Subroutine write_grid_basis(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n,l
    Character(10) :: ch
    !!
    Write(lunit,'(14x,'',{"SELECTBOX| SHOW_CONTENT | EOL","basis","''&
         &,i3,''","@(B)asis",1,26,17,"",{'')')&
         & GRID_BASIS_CONVENTIONAL
    n=Size(MAP_GRID_BASIS_TYPES)
    Do i=1_t_int,n
       l=MAP_GRID_BASIS_TYPES(i)
       Write(ch,"(i5)")l
       Write(lunit,"(14x,'""',i6,'\n',a,'""')",advance='no') l &
            &,Trim(GRID_BASIS_TYPES_HKEY(l))
       If(i<n) Write(lunit,"(',')")
    Enddo
    Write(lunit,"(14x,'},0,0}')")
  End Subroutine write_grid_basis
  !!***********************************************************************
  Subroutine write_grid_quantity(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    !!
10  Format(14x,',{"MSELECTBOX | SHOW_CONTENT | TWO_COLUMN| EOL","quantities","'&
         & ,i3,'","@(Q)uantities",1,26,17,"",{')
    Write(lunit,10)&
         & GRID_QUANTITY_TOTAL_DENSITY
    !!
    n=Size(GRID_QUANTITIES_HKEY,1)
    Do i=1_t_int,n
       Write(ch,"(i5)")i
       Write(lunit,"(14x,'""',i6,'\n',a,'""')",advance='no') i &
            &,Trim(GRID_QUANTITIES_HKEY(i))
       If(i<n) Write(lunit,"(',')")
    Enddo
    Write(lunit,"(14x,'},0,0}')")
  End Subroutine write_grid_quantity
  !!***********************************************************************
  Subroutine write_grid_ouputdata(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n
    !Character(10) :: ch
    !!
10  Format(14x,',{"MSELECTBOX | SHOW_CONTENT | TWO_COLUMN| EOL","outputdata","'&
         &,i3,' ',i3,' ',i3,'","Output @(D)ata",1,26,17,"",{')
    Write(lunit,10)&
         & GRID_OUTPUTDATA_POINTS&
         &,GRID_OUTPUTDATA_TOTAL&
         &,GRID_OUTPUTDATA_SPIN
    !!
    n=Size(GRID_OUTPUTDATA_HKEY,1)
    Do i=1_t_int,n
       Write(lunit,"(14x,'""',i6,'\n',a,'""')",advance='no') i &
            &,Trim(GRID_OUTPUTDATA_HKEY(i))
       If(i<n) Write(lunit,"(',')")
    Enddo
    Write(lunit,"(14x,'},0,0}')")
  End Subroutine write_grid_ouputdata
  !!***********************************************************************
  ! write_sb_verbositylevel
  ! {{{ 

  Subroutine write_sb_verbositylevel(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i
    Character(10) :: ch
    !!
    Write(lunit,'(14x,'',{"SELECTBOX| AUTO_WIDTH |EOL","verbosity_level","''&
         &,i3,''","@(>)\tverbosity level",1,20,40,"",{'')')L_more
    Do i=1_t_int,Size(MAP_VERBOSITY_LEVELS)
       Write(ch,"(i5)")i
       Write(lunit,"(14x,'""',i6,'\n@(',a,')\t',a,'""')",advance='no') &
            & MAP_VERBOSITY_LEVELS(i) &
            &,Trim(Adjustl(ch)) & ! no whitespace in hotkeys !!!
            &,Trim(VERBOSITY_LEVELS(MAP_VERBOSITY_LEVELS(i)))
       If(i<Size(MAP_VERBOSITY_LEVELS)) Write(lunit,"(',')")
    Enddo
    Write(lunit,"(14x,'},0,0}')")
  End Subroutine write_sb_verbositylevel

  ! }}}
  !!***********************************************************************
  Subroutine write_sb_convcond(lunit,pos,fwidth,foffset)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit,pos,fwidth,foffset
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    !!
    Write(lunit,'(14x,'',{"SELECTBOX| AUTO_WIDTH |EOL","iteration_convergence_condition","1"&
         &,"Conver@(g)ence condition",'',i5,'','',i5,'','',i5,'',"",{'')')&
         &pos,fwidth,foffset
    n=Size(ITERATION_CONVCONDITIONS)
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,n
       Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(ITERATION_CONVCONDITIONS(i)) 
       If(i<n)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_sb_convcond
  !!***********************************************************************
  ! write_sb_xcversion
  ! {{{ 

  Subroutine write_sb_xcversion(lunit,pos,fwidth,foffset)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit,pos,fwidth,foffset
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    !!
    Write(lunit,'(14x,'',{"SELECTBOX| AUTO_WIDTH |EOL","xc_potential","9"&
         &,"@(V)xc-version",'',i5,'','',i5,'','',i5,'',"",{'')')&
         &pos,fwidth,foffset
    n=Size(MAP_XC_VERSIONS)
    Do i=1_t_int,n
       Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       Write(lunit,"(14x,'""',i6,'\n@(',a,')\t',a,'""')",advance='no') &
            & MAP_XC_VERSIONS(i) ,Trim(Adjustl(ch)),Trim(XC_VERSIONS(i))
       If(i<n) Write(lunit,"(',')")
    Enddo
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_sb_xcversion
  !!***********************************************************************
  ! write_sb_energy_units
  ! {{{ 
!!$
!!$  Subroutine write_sb_energy_units(lunit,pos,fwidth,foffset)
!!$    !!
!!$    Implicit None 
!!$    !!IO
!!$    Integer(t_int),Intent(in) :: lunit,pos,fwidth,foffset
!!$    !!LOCAL
!!$    Integer(t_int) :: i,n
!!$    Character(10) :: ch
!!$    !!
!!$    Write(lunit,'(14x,'',{"SELECTBOX| AUTO_WIDTH |EOL","dos_energy_unit",""&
!!$         &,"@(e)nergy units",'',i5,'','',i5,'','',i5,'',"",{'')')&
!!$         &pos,fwidth,foffset
!!$    n=Size(ERG_UNITS)
!!$    Do i=1_t_int,n
!!$       !ch=ERG_UNITS(i)(1_t_int:1_t_int)
!!$       Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
!!$       Write(lunit,"(14x,'""',i6,'\n@(',a,')\t',a,'""')",advance='no') &
!!$            & i,Trim(Adjustl(ch)),Trim(ERG_UNITS(i))
!!$       If(i<n) Write(lunit,"(',')")
!!$    Enddo
!!$    Write(lunit,"(14x,'},0,0}')")
!!$
!!$  End Subroutine write_sb_energy_units

  ! }}}
  !!***********************************************************************
  ! write_relat
  ! {{{ 

  Subroutine write_relat(lunit,pos,fwidth,foffset,isatomcalc)
    !!
    Implicit None 
    !!IO
    Logical(t_log),Intent(in) :: isatomcalc
    Integer(t_int),Intent(in) :: lunit,pos,fwidth,foffset
    !!LOCAL
    Integer(t_int) :: i,n,n0,j,k
    Character(10) :: ch
    Character(100):: txt
    !!
    Write(lunit,'(13x,'',{"SELECTBOX|  AUTO_WIDTH |EOL ","relativistic","1"&
         &,"@(R)elativistic",'',i5,'','',i5,'','',i5,'',"",{'')') &
         &pos,fwidth,foffset
    n=Size(MAP_RELAT_TYPES)
    n0=n
    If(isatomcalc)n0=n-1
    !!
    Write(lunit,"(14(' '))",advance='no')
    j=0_t_int
    Do i=1_t_int,n
       k=MAP_RELAT_TYPES(i)
       !Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       If(isatomcalc .And. k==SCALAR_RELATIVISTIC) Cycle
       j=j+1
       txt=relat_name(k)
       ch=txt(1_t_int:1_t_int)
       Write(lunit,"('""',i6,'\n@(',a,')',a,'""')") k,Trim(Adjustl(ch))&
            &,Trim(txt(2_t_int:)) 
       If(j<n0)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_relat

  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine write_frelprojection(lunit,pos,fwidth,foffset)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit,pos,fwidth,foffset
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    Character(100):: txt
    !!
    Write(lunit,'(13x,'',{"SELECTBOX|  AUTO_WIDTH |EOL "&
         &,"bandweight_control.frelprojection","1"&
         &,"FREL pro@(j)ection",'',i5,'','',i5,'','',i5,'',"",{'')') &
         &pos,fwidth,foffset
    n=Size(FRELPROJECTION_TYPES)
    !!
    Write(lunit,"(14(' '))",advance='no')
    Do i=1,n
       txt=FRELPROJECTION_TYPES(i)
       Write(ch,"(i5)")i
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(txt) 
       If(i<n)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_frelprojection
#endif
  ! }}}
  !!***********************************************************************
  Subroutine write_lsdaudmatmodes(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    !!
    Write(lunit,"(13x,a)")',{"SELECTBOX|  AUTO_WIDTH |EOL ","lsdau_dmat_mode","1"&
         &,"O@(c)cupation matrix mode",1,22,40,"",{'
    n=Size(LSDAU_DMAT_MODES)
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,n
       Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       !!ch=LSDAU_DMAT_MODES(i)(1_t_int:1_t_int)
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(LSDAU_DMAT_MODES(i)) 
       If(i<n)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_lsdaudmatmodes
  !!***********************************************************************
  Subroutine write_lsdaufunctional(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    !!
    Write(lunit,"(13x,a)")',{"SELECTBOX|  AUTO_WIDTH |EOL ","lsdau_functional","1"&
         &,"@(F)unctional",1,22,40,"",{'
    n=Size(LSDAU_FUNCTIONALS)!!2
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,n
       Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       !!ch=LSDAU_FUNCTIONALS(i)(1_t_int:1_t_int)
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(LSDAU_FUNCTIONALS(i)) 
       If(i<n)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_lsdaufunctional
  !!***********************************************************************
  Subroutine write_opcfunctional(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    !!
    Write(lunit,"(13x,a)")',{"SELECTBOX|  AUTO_WIDTH |EOL ","opc_functional","1"&
         &,"@(F)unctional",1,22,40,"",{'
    n=Size(OPC_FUNCTIONALS)
    n=2 !!TODO: switch back
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,n
       Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       !!ch=OPC_FUNCTIONALS(i)(1_t_int:1_t_int)
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(OPC_FUNCTIONALS(i)) 
       If(i<n)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_opcfunctional
  !!***********************************************************************
  Subroutine write_lsdauprojection(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    !!
    Write(lunit,1)
    n=Size(LSDAU_PROJECTIONS)
    Write(lunit,2,advance='no')
    Do i=1_t_int,n
       If(i==LSDAU_HYBRIDIZED_CORE) Cycle
       If(i==LSDAU_HYBRIDIZED_NO_CORE) Cycle
       Write(ch,3)i ! no whitespace in hotkeys !!!
       !!ch=LSDAU_PROJECTIONS(i)(1_t_int:1_t_int)
       Write(lunit,4) i,Trim(Adjustl(ch)),Trim(LSDAU_PROJECTIONS(i)) 
       If(i<n)Write(lunit,5,advance='no')
    End Do
    Write(lunit,6)
    !!
1   Format(13x,',{"SELECTBOX|  AUTO_WIDTH |EOL ","lsdau_projection","1"&
         &,"@(P)rojection",1,22,40,"",{')
2   Format(14(' '))
3   Format(i5)
4   Format('"',i6,'\n@(',a,')\t',a,'"')
5   Format(14x,',')    
6   Format(14x,'},0,0}')
  End Subroutine write_lsdauprojection
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine write_opcprojection(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    !!
    Write(lunit,1)
    n=Size(OPC_PROJECTIONS)
    Write(lunit,2,advance='no')
    Do i=1_t_int,n

       Write(ch,3)i ! no whitespace in hotkeys !!!
       !!ch=OPC_PROJECTIONS(i)(1_t_int:1_t_int)
       Write(lunit,4) i,Trim(Adjustl(ch)),Trim(OPC_PROJECTIONS(i)) 
       If(i<n)Write(lunit,5,advance='no')
    End Do
    Write(lunit,6)
    !!
1   Format(13x,',{"SELECTBOX|  AUTO_WIDTH |EOL ","opc_projection","1"&
         &,"@(P)rojection",1,22,40,"",{')
2   Format(14(' '))
3   Format(i5)
4   Format('"',i6,'\n@(',a,')\t',a,'"')
5   Format(14x,',')    
6   Format(14x,'},0,0}')
  End Subroutine write_opcprojection
#endif
  !!***********************************************************************
  ! write_iterationscheme
  ! {{{ 

  Subroutine write_iterationscheme(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n,j
    Character(10) :: ch
    !!
    Write(lunit,"(13x,a)")',{"SELECTBOX|  AUTO_WIDTH |EOL ","iteration_version","1"&
         &,"@(V)ersion",1,22,40,"",{'
    n=Size(IT_SCHEME_MAPPING)
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,n
       j=IT_SCHEME_MAPPING(i)
       Write(ch,"(i5)")j ! no whitespace in hotkeys !!!
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") j&
            &,Trim(Adjustl(ch))&
            &,Trim(ITERATION_SCHEMES(j)) 
       If(i<n)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")
    
  End Subroutine write_iterationscheme
  !!***********************************************************************
  ! write_iterationscheme
  ! {{{ 

  Subroutine write_force_iterationscheme(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n,j
    Character(10) :: ch
    !!
    Write(lunit,"(13x,a)")',{"SELECTBOX|  AUTO_WIDTH |EOL "&
         &,"force_iteration_version","1"&
         &,"@(V)ersion",1,20,40,"",{'
    n=Size(FORCE_IT_SCHEME_MAPPING)
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,n
       j=FORCE_IT_SCHEME_MAPPING(i)
       Write(ch,"(i5)")j ! no whitespace in hotkeys !!!
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") j&
            &,Trim(Adjustl(ch))&
            &,Trim(ITERATION_SCHEMES(j)) 
       If(i<n)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")
    
  End Subroutine write_force_iterationscheme
  !!***********************************************************************
  ! write_force_mode
  ! {{{ 

  Subroutine write_force_mode(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n,j
    Character(10) :: ch
    !!
    Write(lunit,"(13x,a)")',{"SELECTBOX|  AUTO_WIDTH |EOL ","force_mode","1"&
         &,"@(F)orce Mode",1,22,40,"",{'
    n=Size(FORCE_MODE_MAPPING)
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,n
       j=FORCE_MODE_MAPPING(i)
       Write(ch,"(i5)")j ! no whitespace in hotkeys !!!
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") j&
            &,Trim(Adjustl(ch))&
            &,Trim(FORCE_MODES(j)) 
       If(i<n)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")
    
  End Subroutine write_force_mode

  ! }}}
  !!***********************************************************************
  ! create_fedit
  ! {{{ 

  Subroutine create_atomfedit

    !!
    Implicit None 
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="create_atomfedit"
    Logical(t_log) :: exist
    Integer(t_int) :: i,lunit
    Character(2)  :: el
    !!
    lunit=12
    !!
    Inquire(file=f_fedit_in ,exist=exist)
    If(exist)Then
       !Write(outfile,"('File ',a,' exists, not recreated!')")Trim(f_fedit_in)
       Return
    Endif
    
    Open(lunit,file=f_fedit_in)
    Write(lunit,"(a)")&
         &"########################################################################"&
         &,"# this file is part of the FPLO bandstructure package"&
         &,"# it was created automatically"&
         &,"# please dont delete this file nor"&
         &,"# edit it, unless you really know what you are doing"&
         &,"# any changes added by you may be lost if this file is recreated"&
         &,"# by FPLO (which is the normal behaviour )"&
         &,"# so keep duplicates of your changes somewhere else"&
         &,"#"&
         &,"########################################################################"
    Write(lunit,"(/,/)")
    !! header with version  numbers
    Write(lunit,"('section header{')")
    Call write_version(lunit)
    Write(lunit,"('};',/)")  
    Write(lunit,"('section Data{',/)")
    Write(lunit,"(a)")&
         & '  struct{'&
         &,'     char[*] screenname;'&
         &,'     char[*] filename;'&
         &,'     struct {'&
         &,'        char[*] action;'&
         &,'        char[*] menubarentry;'&
         &,'        char[*] actionname;'&
         &,'        }menus[*];'&
         &,'     struct{'&
         &,'        char[*] action;'&
         &,'        char[*] variablename;'&
         &,'        char[*] defaultvalue;'&
         &,'        char[*] fieldname;'&
         &,'        int namepos;'&
         &,'        int fieldoffset;'&
         &,'        int fieldwidth;'&
         &,'        char[*] testflags;'&
         &,'        char[*] testset[*];'&
         &,'        real intervalleft;'&
         &,'        real intervalright;'&
         &,'        }entries[*];'&
         &,'     }screens[*]='
    Write(lunit,"('  {')") 
    !!***********************************************************************
    !! main menu
    Write(lunit,'(''     {"MAIN MENU"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_atom_in)
    !! main menu: menu entries
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)")&
         & ' {"MAIN | MAINQUIT","@(q)uit/save",""}'&
         &,',{"MAIN | MAINEXIT","e@(x)it/discard",""}'&
         &,',{"MAIN | EXTERNEDIT","@(e)xtern edit",""}'&
         &,',{"MAIN | SEPARATOR","",""}'&
         &,',{"MAIN | HELP","@(H)elp",""}'&
         &,',{"ALT  | SUBMENU","@(O)utput","OUTPUT"}'&
         &,',{"ALT  | SUBMENU","@(I)teration","ITERATION"}'&
         &,',{"ALT  | RESTORE","@(R)estore",""}' &
         &,',{"ALT  | REBUILD","R@(e)create","'//Trim(f_atom_in)//'"}'
    Write(lunit,"(a)") '           }'
    !! main menu: screen items
    Write(lunit,"('          ,{')")
    Write(lunit,'(14x,'' {"TITLE|EOL","","","GENERAL",1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM | EOL","title","1","@(t)itle",1,22,40&
         &,"",{},0,+INF}'')')
    Write(lunit,'(13x,'',{"ITEM |EOL | TRIGGER_UPDATE" ,"atom","Al"&
         &,"@(A)tom",1,22,40,"",{'')')
    Write(lunit,"(15(' '))",advance='no')
    Do i=1_t_int,MAX_ELEMENT
       el=getelementnname(i)
       Write(lunit,"('""',a,'""')",advance='no')el
       If(i< MAX_ELEMENT)Write(lunit,"(',')",advance='no')
       If(Mod(i+1_t_int,10_t_int)==0_t_int)Write(lunit,"(/,15(' '))",advance='no')
    Enddo
    Write(lunit,"(13x,'},0,+INF}')")

    Write(lunit,'(14x,'',{"ITEM |EOL  ","basis.states","0.0"&
         &,"@(b)asis",1,22,-1,"",{},-INF,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","basis.noccus","0.0"&
         &,"@(O)ccupation no.",1,22,-1,"",{},-INF,+INF}'')')

    Write(lunit,'(14x,'',{"ITEM |EOL ","spin.mspin","1","@(s)pin sorts",1,22,13&
         &,"TOGGLE",{"1","2"},0,+INF}'')')
    Call write_sb_xcversion(lunit,1_t_int,22_t_int,40_t_int)
    Call write_relat(lunit,1_t_int,22_t_int,40_t_int,.True.)
    Write(lunit,'(14x,'',{"ITEM |EOL ","xcrelat","f","@(1) rel. xc-correction"&
         &,1,22,13&
         &,"",{},0,+INF}'')')
    Call write_nuc_type_dirac(lunit,1_t_int,22_t_int,50_t_int)

    Write(lunit,'(14x,'',{"CHECKBOX  | EOL ","options"&
         &,"","@(-)\toptions",1,22,10,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","ionicity","0.0"&
         &,"@(i)onicity",1,22,10,"",{},-INF,+INF}'')')

    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","CONFINING POTENTIAL ww*r^n0",1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL ","conf_potential.compression","f"&
         &,"@(c)ompression",1,22,13&
         &,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM  ","conf_potential.r0","1.0"&
         &,"r@(0)",1,22,10&
         &,"LEFT_OPEN",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL  ","conf_potential.exponent","4.0"&
         &,"@(n)0",40,22,10&
         &,"LEFT_OPEN",{},0,+INF}'')')
    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","MESH OF RADIAL FUNCTIONS",1,-1,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"ITEM  ","radial_mesh.nr","500"&
         &,"@(Nu)mber of points",1,22,8&
         &,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM  ","radial_mesh.rmin","1.d-6"&
         &,"r@(mi)n",37,6,9&
         &,"LEFT_OPEN",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL ","radial_mesh.rmax","1.d-6"&
         &,"r@(ma)n",58,6,9&
         &,"LEFT_OPEN",{},0,+INF}'')')
    Call write_mesh_type_dirac(lunit,1_t_int,26_t_int,40_t_int)
    Write(lunit,555)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","TOLERANCE",1,-1,0,"",{},0,0}'')')
    Write(lunit,'(14x,'',{"ITEM|EOL ","tolerances.wf","1.e-12"&
         &,"@(w)ave function match",1,22,10&
         &,"LEFT_OPEN",{},0,+INF}'')')



    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! output menu
    Write(lunit,'(''    ,{"OUTPUT"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_atom_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")
    Write(lunit,101)
    Write(lunit,'(14x,'',{"TITLE|EOL","","","CREATE OUTPUT FILES FOR"&
         &,1,-1,0,"",{},0,0}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL  ","output.orbitals","f"&
         &,"@(o)rbitals",1,22,8 ,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL ","output.density","f"&
         &,"@(D)ensity",1,22,8 ,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL ","output.potential","f"&
         &,"@(p)otential",1,22,8 ,"",{},0,+INF}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL ","output.overwrite","f"&
         &,"o@(v)erwrite",1,22,8 ,"",{},0,+INF}'')')

    Write(lunit,"('           }')")
    Write(lunit,"('     }')")
    !!***********************************************************************
    !! iteration menu
    Write(lunit,'(''    ,{"ITERATION"'')')
    Write(lunit,'(''     ,"'',a,''"'')')Trim(f_atom_in)
    Write(lunit,"('          ,{')")
    Write(lunit,"('             ',a)") &
         &'{"MAIN | EXIT ","e@(x)it",""}' &
         &,',{"MAIN | SEPARATOR","",""}' &
         &,',{"MAIN | HELP","@(H)elp",""}'

    Write(lunit,"('           }')")
    Write(lunit,"('          ,{')")
    Write(lunit,101)
    Write(lunit,'(14x,'',{"ITEM |EOL  ","iteration_control.steps","40"&
         &,"@(n)umber of iterations",1,22,13 ,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","iteration_control.tolerance","1.e-6"&
         &,"@(t)olerance",1,22,13 ,"LEFT_OPEN",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","iteration_control.mixing","0.2"&
         &,"M@(i)xing",1,22,13 ,"LEFT_OPEN",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","iteration_control.maxdim","5"&
         &,"@(M)ax subspace dim",1,22,13 ,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  ","iteration_control.progress","0.2"&
         &,"@(P)rogress",1,22,13 ,"LEFT_OPEN",{},0,+INF}'')')

    Call write_iterationscheme(lunit)

    Write(lunit,"('           }')")
    Write(lunit,"('     }')")

    ! end section data
    Write(lunit,"(' };')")
    ! file end 
    Write(lunit,"('};')") 
    Close (lunit)
    Write(errbuf,"('File ',a,' created!')")Trim(f_fedit_in)
    Call terminate(TERM_NORMAL,errbuf)
    !!
100 Format(14x,',{"EOL","","","",0,0,0,"",{},0,0}')
101 Format(14x,'{"EOL","","","",0,0,0,"",{},0,0}')
555 Format(14x,',{"DASHLINE|EOL","","","",1,-1,0,"",{},0,0}')
    !!
  End Subroutine create_atomfedit

  ! }}}
  !!***********************************************************************
  !!***********************************************************************
  ! write_cpa_fermi_method
  ! {{{ 
  Subroutine write_cpa_fermi_method(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    !!
    Write(lunit,"(13x,a)")',{"SELECTBOX|  AUTO_WIDTH |EOL ","cpa_fermi_method"&
         &,"1","@(i)teration method",1,25,40,"",{'
    n=Size(CPA_FERMI_METHODS)
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,n
       !Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       ch=CPA_FERMI_METHODS(i)(1_t_int:1_t_int)
       Write(lunit,"('""',i6,'\n@(',a,')',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(CPA_FERMI_METHODS(i)(2_t_int:)) 
       If(i<n)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_cpa_fermi_method

  ! }}}
  !!***********************************************************************
  ! write_bz_method
  ! {{{ 
  Subroutine write_bz_method(lunit)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit
    !!LOCAL
    Integer(t_int) :: i,n
    Character(10) :: ch
    !!
    Write(lunit,"(13x,a)")',{"SELECTBOX|  AUTO_WIDTH |EOL ","bzone_method"&
         &,"1","@(i)ntegration method",1,25,40,"",{'
    n=Size(BZ_METHODS)
    Write(lunit,"(14(' '))",advance='no')
    Do i=1_t_int,n
       !Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       ch=BZ_METHODS(i)(1_t_int:1_t_int)
       Write(lunit,"('""',i6,'\n@(',a,')',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(BZ_METHODS(i)(2_t_int:)) 
       If(i<n)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_bz_method

  ! }}}
  !!***********************************************************************
!!$  Subroutine write_spin_pop(lunit,pos,fwidth,foffset)
!!$    !!
!!$    Implicit None 
!!$    !!IO
!!$    Integer(t_int),Intent(in) :: lunit,pos,fwidth,foffset
!!$    !!LOCAL
!!$    Integer(t_int) :: i,n,n0,j
!!$    Character(10) :: ch
!!$    !!
!!$    Write(lunit,'(13x,'',{"SELECTBOX|  AUTO_WIDTH |EOL ","spin_pop_type","1"&
!!$         &,"Spin @(p)opulation analysis",'',i5,'','',i5,'','',i5,'',"",{'')') &
!!$         &pos,fwidth,foffset
!!$    n=Size(SPIN_POP_TYPES)
!!$    n0=n
!!$    !!
!!$    Write(lunit,"(14(' '))",advance='no')
!!$    j=0_t_int
!!$    Do i=1_t_int,n
!!$       !Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
!!$       j=j+1
!!$       ch=SPIN_POP_TYPES(i)(1_t_int:1_t_int)
!!$       Write(lunit,"('""',i6,'\n@(',a,')',a,'""')") i,Trim(Adjustl(ch))&
!!$            &,Trim(SPIN_POP_TYPES(i)(2_t_int:)) 
!!$       If(j<n0)Write(lunit,"(14x,',')",advance='no')
!!$    End Do
!!$    Write(lunit,"(14x,'},0,0}')")
!!$
!!$  End Subroutine write_spin_pop
  !!***********************************************************************
  Subroutine write_charges_type(lunit,pos,fwidth,foffset)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit,pos,fwidth,foffset
    !!LOCAL
    Integer(t_int) :: i,n,n0,j
    Character(10) :: ch
    !!
    Write(lunit,'(13x,'',{"SELECTBOX|  AUTO_WIDTH |EOL ","charges.chargemode","0"&
         &,"@(C)harge mode",'',i5,'','',i5,'','',i5,'',"",{'')') &
         &pos,fwidth,foffset
    n=Size(CHARGEMODE_TYPE)
    n0=n
    !!
    Write(lunit,"(14(' '))",advance='no')
    j=0_t_int
    Do i=1_t_int,n
       !If(i==FINUC_GAUSS  ) Cycle
       Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       j=j+1
       !!ch=FINUC_TYPE(i)(1_t_int:1_t_int)
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(CHARGEMODE_TYPE(i)(1_t_int:)) 
       If(j<n0)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_charges_type
  !!***********************************************************************
  Subroutine write_nuc_type_dirac(lunit,pos,fwidth,foffset)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit,pos,fwidth,foffset
    !!LOCAL
    Integer(t_int) :: i,n,n0,j
    Character(10) :: ch
    !!
    Write(lunit,'(13x,'',{"SELECTBOX|  AUTO_WIDTH |EOL ","nuclear_model","1"&
         &,"@(F)inite nucleus",'',i5,'','',i5,'','',i5,'',"",{'')') &
         &pos,fwidth,foffset
    n=Size(FINUC_TYPE)
    n0=n-1
    !!
    Write(lunit,"(14(' '))",advance='no')
    j=0_t_int
    Do i=1_t_int,n
       If(i==FINUC_GAUSS  ) Cycle
       Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       j=j+1
       !!ch=FINUC_TYPE(i)(1_t_int:1_t_int)
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(FINUC_TYPE(i)(1_t_int:)) 
       If(j<n0)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_nuc_type_dirac
  !!***********************************************************************
  Subroutine write_mesh_type_dirac(lunit,pos,fwidth,foffset)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit,pos,fwidth,foffset
    !!LOCAL
    Integer(t_int) :: i,n,n0,j
    Character(10) :: ch
    !!
    Write(lunit,'(13x,'',{"SELECTBOX|  AUTO_WIDTH |EOL ","radial_meshtype","1"&
         &,"Mesh ty@(p)e",'',i5,'','',i5,'','',i5,'',"",{'')') &
         &pos,fwidth,foffset
    n=Size(MESH_TYPE)
    n0=n-2
    !!
    Write(lunit,"(14(' '))",advance='no')
    j=0_t_int
    Do i=1_t_int,n
       If(i==LOG_MESH .Or. i==LIN_MESH ) Cycle
       Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       j=j+1
       !!ch=MESH_TYPE(i)(1_t_int:1_t_int)
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(MESH_TYPE(i)(1_t_int:)) 
       If(j<n0)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_mesh_type_dirac
    !!***********************************************************************
#ifdef my_compile_unused
  Subroutine write_mesh_type_mol(lunit,pos,fwidth,foffset)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: lunit,pos,fwidth,foffset
    !!LOCAL
    Integer(t_int) :: i,n,n0,j
    Character(10) :: ch
    !!
    Write(lunit,'(13x,'',{"SELECTBOX|  AUTO_WIDTH |EOL ","radial_meshtype","1"&
         &,"@(m2)\tMesh type",'',i5,'','',i5,'','',i5,'',"",{'')') &
         &pos,fwidth,foffset
    n=Size(MESH_TYPE)
    n0=n-2
    !!
    Write(lunit,"(14(' '))",advance='no')
    j=0_t_int
    Do i=1_t_int,n
       If(i==LOG_MESH .Or. i==LIN_MESH ) Cycle
       Write(ch,"(i5)")i ! no whitespace in hotkeys !!!
       j=j+1
       !!ch=MESH_TYPE(i)(1_t_int:1_t_int)
       Write(lunit,"('""',i6,'\n@(',a,')\t',a,'""')") i,Trim(Adjustl(ch))&
            &,Trim(MESH_TYPE(i)(1_t_int:)) 
       If(j<n0)Write(lunit,"(14x,',')",advance='no')
    End Do
    Write(lunit,"(14x,'},0,0}')")

  End Subroutine write_mesh_type_mol
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine fedit_develop_menu(lunit)
    !!
    Implicit None  
    !!IO
    Integer(t_int),Intent(in)    :: lunit
    !!LOCAL
    !!
    !!
    Write(lunit,200)'MOL'
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL  " ,"make_vatom","f"&
         &,"@(m)ake_vatom",1,22,11,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  " ,"irredmesh","f"&
         &,"@(i)rredmesh",1,22,11,"",{},1,+INF}'')')
    Write(lunit,100)
    Write(lunit,555)
    !!
    Write(lunit,'(14x,'',{"ITEM |EOL  " ,"erg_nv0_separate","f"&
         &,"@(c1)\terg_nv0_separate",1,22,11,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  " ,"erg_kin0_separate","f"&
         &,"@(c2)\terg_kin0_separate",1,22,11,"",{},1,+INF}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL  " ,"compressed_vatom","f"&
         &,"@(c4)\tcompressed_vatom",1,22,11,"",{},1,+INF}'')')
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM |EOL  " ,"rad_nr","80"&
         &,"@(m1)\trad_nr",1,22,11,"",{},1,+INF}'')')
    Call write_mesh_type_mol(lunit,1_t_int,22_t_int,11_t_int)
    !!
    Write(lunit,100)
    Write(lunit,'(14x,'',{"ITEM   " ,"angmesh.r1","0.05"&
         &,"@(a1)\tr_angmesh_1",1,22,11,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  " ,"angmesh.t1","1"&
         &,"@(a2)\tt_angmesh_1",40,22,11,"",{},1,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM   " ,"angmesh.rmax","0.05"&
         &,"@(a3)\tr_angmesh_max",1,22,11,"",{},0,+INF}'')')
    Write(lunit,'(14x,'',{"ITEM |EOL  " ,"angmesh.tmax","1"&
         &,"@(a4)\tt_angmesh_max",40,22,11,"",{},1,+INF}'')')
    !!
    !!
    !!
!!$    Write(lunit,100)
!!$    Write(lunit,555)
!!$    Write(lunit,'(14x,'',{"FIELD | EOL","rx0",""&
!!$         &,"RX0",1,23,0,"",{},0,0}'')')
!!$    Write(lunit,'(14x,'',{"TITLE" ,"","","_________________________________"&
!!$         &,1,-1,0,"",{},0,+INF}'')')
!!$    Write(lunit,'(14x,'',{"TITLE" ,"","","Wy-pos. element rx0"&
!!$         &,1,-1,0,"",{},0,+INF}'')')
!!$    Write(lunit,'(14x,'',{"TITLE" ,"","","_________________________________"&
!!$         &,1,-1,0,"",{},0,+INF}'')')
!!$    Write(lunit,'(14x,'',{"ITEM|FIXED" ,"atom","E ","",1,5,4,"",{},1,&
!!$         &+INF}'')')
!!$    Write(lunit,'(14x,'',{"ITEM" ,"rx0","0.0",""&
!!$         &,14,0,15,"",{},-INF,+INF}'')')
!!$    Write(lunit,'(14x,'',{"ENDFIELD","","","",1,25,8,"",{},0,0}'')')
!!$    Write(lunit,'(14x,'',{"TITLE" ,"","","_________________________________"&
!!$         &,1,-1,0,"",{},0,+INF}'')')
!!$    Write(lunit,100)

    !!
    Return
    !!
555 Format(14x,',{"DASHLINE|EOL","","","",1,-1,0,"",{},0,0}')
100 Format(14x,',{"EOL","","","",0,0,0,"",{},0,0}')
200 Format(14x,',{"TITLE|EOL","","","',a,'",1,-1,0,"",{},0,0}')
  End Subroutine fedit_develop_menu
#endif
  !!***********************************************************************  
End Module fedit
