!!----------------------------------!
!! FORCES:dndV_forces:no_doxc       |
!! FORCES:dndV_forces:no_doew       |
!! FORCES:dndV_forces:no_dovc       |
!!----------------------------------!
Module forces
  !!
  Use precisiondefs
  Use errors
  Use file_iounits
  Use memory
  Use clock
  Use constants
  Use matserv
  Use tsymmetry
  Use tmol
  Use tmesh
  Use torbitalbasis
  Use diagonalize
  Use trelativistic
  Use ioaux
  Use xc
  Use occu
  Use vecharm
  Use tforces
  Use pot
  Use interpolation
  Use loisym
  Use mesh
  Use tpotentialdensity
  Use diracdefs
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="FORCES"  
  !!
  Public :: dndV_forces,log_site_history&
       &,symanalyse_sites,analys_symtrans
  !!
  !!***********************************************************************
Contains
  !!***********************************************************************
  Subroutine dndV_forces(mspin,symmetry,structure,lattice,basis,potential&
       &,mol,forces,degree,relativistic,lcdnet,onc,onv)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Potential),Intent(inout) :: potential
    Type(T_Mol),Intent(in)       :: mol
    Type(T_Forces),Intent(inout) :: forces
    Integer(t_int),Intent(in)    :: relativistic
    Integer(t_int),Intent(in)    :: mspin
    Integer(t_int),Intent(in)    :: degree
    Real(t_real),Intent(in)      :: lcdnet(:,:,:,:)
    Real(t_real),Intent(in)      :: onc(:,:,:,:,:,:)
    Real(t_real),Intent(in)      :: onv(:,:,:,:,:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="dndV_forces"
    Logical(t_log) :: alert,gga
    Integer(t_int) :: isp,issp,im,issb,isb,irs0,irs,indexb,ms,j,jops,isga
    Integer(t_int) :: isa,issa,nva,lmxa,indexa,l,i,k,il,m,nca,ig
    Integer(t_int) :: lvmx(structure% nsort),blocklenv(structure% nsite)
    Integer(t_int) :: lcmx(structure% nsort),blocklenc(structure% nsite)
    Integer(t_int) :: mxblsizev,iblv,inblv,nblv,inblb,iblb,lenb,irbp,ibla
    Integer(t_int) :: lena,irap,irba,iblc,inblc,mxblsizec,nblc,ilm
    Integer(t_int) :: inbla,ns,jj,ii,nn
    Real(t_real)   :: tt(3),rsh(3),ww,d,r(3),p(3),rb2,rb,dd,ra2,ra,tol
    Real(t_real)   :: error,ff,f,df,fdp,doxc,dovc,doew,ap,am,afdp,trho
    Real(t_real)   :: fpmpm,a,adlap,glap(3),afpmpm0,afp30,gfdp0(3)
    Real(t_real)   :: gafpmpm0(3),qfdp(5),qq(3,3)
    Real(t_real)   :: oorb,oorb2,tgrad(3),ggrho(3,3,2),afpmpm,gfdp(3),d2f
    Real(t_real)   :: texp,rra(3),ff1,novl(2),d1,drho(2),drhot,g,qfn(5)
    Real(t_real)   :: rhot(2),rhonett(2),gfn(3),vex(2),dvex(2,2),epsxc,d3f
    Real(t_real)   :: gradrhos(2),gradrho,laprhos(2),mixrhos(2),mixrho
    Real(t_real)   :: dvexdabsgrads(2,2),dvexdlaprho(2,2)
    Real(t_real)   :: dvexdmixrhos(2,2),dvexdabsgrad(2),dvexdmixrho
    Complex(t_real):: cex
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    Real(t_real)   :: coefa(0:degree)
    Real(t_real)   :: coefb(0:degree)
    Real(t_real)   :: grho(3,2),gabsgrad(3),gabsgrads(3,2)
    Real(t_real)   :: gvcsite(3,structure% nsite)
    Real(t_real),Pointer :: p_yl(:)
    Real(t_real),Pointer :: p_yb(:)
    Real(t_real),Pointer :: p_rvylm(:,:)
    Real(t_real),Pointer :: p_qvylm(:,:)
    Real(t_real),Pointer :: p_fvbl(:)
    Real(t_real),Pointer :: p_fcbl(:)
    Real(t_real),Pointer :: p_dvc(:,:,:,:)
    Complex(t_real),Pointer :: p_vft(:,:)
    Complex(t_real),Pointer :: p_dnft(:,:)
    Real(t_real),Pointer :: for(:,:)
    Real(t_real),Pointer :: p_dlcd(:,:,:,:)
    Real(t_real),Pointer :: p_d2lcd(:,:,:,:)
    Real(t_real),Pointer :: p_d3lcd(:,:,:,:)
    Real(t_real),Pointer :: p_gabsgradsite(:,:)
    Real(t_real),Pointer :: p_gabsgradssite(:,:,:)
    Real(t_real),Pointer :: p_glaprhosite(:,:,:)
    Real(t_real),Pointer :: p_gmixrhosite(:,:)
    Real(t_real),Pointer :: p_gmixrhossite(:,:,:)
    Real(t_real),Pointer :: p_grhosite(:,:,:)
    Real(t_real),Pointer :: p_ggrhosite(:,:,:,:)
    Real(t_real),Pointer :: p_gggrhossite(:,:,:,:,:)
    Integer(t_int),Pointer :: p_isiteblv(:)
    Integer(t_int),Pointer :: p_isiteblc(:)
    Integer(t_int),Pointer :: p_ipairblv(:)
    Integer(t_int),Pointer :: p_ipairblc(:)
    Integer(t_int),Pointer :: p_pairdif(:,:,:,:)
    Type(T_Mesh),Pointer :: pmeshb
    Type(T_Mesh),Pointer :: bmesha
    !!
    doxc=1.0_t_real
    doew=1.0_t_real
    dovc=1.0_t_real
    If(debugfun(nmodule,nsubfunc,'no_doxc')) doxc=0.0_t_real
    If(debugfun(nmodule,nsubfunc,'no_doew')) doew=0.0_t_real
    If(debugfun(nmodule,nsubfunc,'no_dovc')) dovc=0.0_t_real
    !!
    gga=(getxcversion() == XCVER_PBE96 )
    !!
    Nullify(p_yb,p_fvbl,p_fcbl,p_isiteblv,p_isiteblc,p_ipairblv,p_ipairblc)
    Nullify(p_pairdif,p_yl,p_dvc,p_rvylm,p_qvylm,for,p_dlcd,p_d2lcd,p_d3lcd)
    Nullify(p_vft,p_dnft)
    Nullify(p_gabsgradssite,p_gabsgradsite,p_grhosite,p_ggrhosite)
    Nullify(p_glaprhosite,p_gmixrhosite,p_gmixrhossite,p_gggrhossite)
    !!
#if defined (TIME_DNDV)
    Call watch('DNDV-dfspline',cpu_start,reset=.True.)
    Call watch('DNDV-dfspline',cpu_stop)
    Call watch('DNDV-dvcoulomb',cpu_start,reset=.True.)
    Call watch('DNDV-dvcoulomb',cpu_stop)
    Call watch('DNDV-prep',cpu_start,reset=.True.)
    Call watch('DNDV-prep',cpu_stop)
    Call watch('DNDV-novl-prep',cpu_start,reset=.True.)
    Call watch('DNDV-novl-prep',cpu_stop)
    Call watch('DNDV-novl',cpu_start,reset=.True.)
    Call watch('DNDV-novl',cpu_stop)
    Call watch('DNDV-derivxcrho',cpu_start,reset=.True.)
    Call watch('DNDV-derivxcrho',cpu_stop)
    Call watch('DNDV-gradrho',cpu_start,reset=.True.)
    Call watch('DNDV-gradrho',cpu_stop)
    Call watch('DNDV-collect-vc',cpu_start,reset=.True.)
    Call watch('DNDV-collect-vc',cpu_stop)
    Call watch('DNDV-collect-xc',cpu_start,reset=.True.)
    Call watch('DNDV-collect-xc',cpu_stop)
    Call watch('DNDV-ewaldft',cpu_start,reset=.True.)
    Call watch('DNDV-ewaldft',cpu_stop)
#endif
    !!
    !!
    Call palloc('for',for,1_t_int,3_t_int&
         &,1_t_int,structure% nsite,nmodule,nsubfunc)

    Call palloc('p_gabsgradsite',p_gabsgradsite,1_t_int,3_t_int&
         &,1_t_int,structure% nsite,nmodule,nsubfunc)
    Call palloc('p_gabsgradssite',p_gabsgradssite,1_t_int,3_t_int&
         &,1_t_int,2_t_int,1_t_int,structure% nsite,nmodule,nsubfunc)
    Call palloc('p_glaprhosite',p_glaprhosite,1_t_int,3_t_int&
         &,1_t_int,2_t_int,1_t_int,structure% nsite,nmodule,nsubfunc)
    Call palloc('p_grhosite',p_grhosite,1_t_int,3_t_int&
         &,1_t_int,2_t_int,1_t_int,structure% nsite,nmodule,nsubfunc)
    Call palloc('p_ggrhosite',p_ggrhosite,1_t_int,3_t_int,1_t_int,3_t_int&
         &,1_t_int,2_t_int,1_t_int,structure% nsite,nmodule,nsubfunc)
    Call palloc('p_gmixrhosite',p_gmixrhosite,1_t_int,3_t_int&
         &,1_t_int,structure% nsite,nmodule,nsubfunc)
    Call palloc('p_gmixrhossite',p_gmixrhossite,1_t_int,3_t_int&
         &,1_t_int,2_t_int,1_t_int,structure% nsite,nmodule,nsubfunc)
    Call palloc('p_gggrhossite',p_gggrhossite,1_t_int,3_t_int&
         &,1_t_int,3_t_int,1_t_int,3_t_int,1_t_int,2_t_int&
         &,1_t_int,structure% nsite,nmodule,nsubfunc)
    !!
    Call palloc('potential% p_Nl',potential% p_Nl&
         &,0_t_int,potential% max_L,nmodule,nsubfunc)
    Call palloc('potential% p_ac',potential% p_ac&
         &,1_t_int,potential% mlmp&
         &,1_t_int,structure% nsite,nmodule,nsubfunc)
    Call palloc('p_vft',p_vft&
         &,1_t_int,lattice% nlattg,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc('p_dnft',p_dnft,1_t_int,3_t_int&
         &,1_t_int,lattice% nlattg,nmodule,nsubfunc)
    Call palloc('p_dvc', p_dvc,1_t_int,potential% nrp&
         &,1_t_int,2_t_int,1_t_int,potential% mlmp&
         &,1_t_int,structure% nsite,nmodule,nsubfunc)
    !!
    Call palloc('p_dlcd',p_dlcd,1_t_int,potential% nrp&
         &,1_t_int,potential% mlmp,1_t_int,structure% nsite&
         &,1_t_int,mspin,nmodule,nsubfunc)
    If(gga)Then
       Call palloc('p_d2lcd',p_d2lcd,1_t_int,potential% nrp&
            &,1_t_int,potential% mlmp,1_t_int,structure% nsite&
            &,1_t_int,mspin,nmodule,nsubfunc)
       Call palloc('p_d3lcd',p_d3lcd,1_t_int,potential% nrp&
            &,1_t_int,potential% mlmp,1_t_int,structure% nsite&
            &,1_t_int,mspin,nmodule,nsubfunc)
    Endif
    !!
#if defined (TIME_DNDV)
    Call watch('DNDV-dfspline',cpu_start)
#endif
    !!
    Do isa=1,structure% nsite
       issa=structure% p_isrt(isa)
       pmeshb => potential% p_pmeshs(issa)
       Do j=1,potential% p_nlmp(isa)
          !l=llilm(potential% p_lmp(j,isa))

          Do ms=1,mspin
             If(gga)Then
                Call dfspline3(5_t_int,pmeshb% nr,pmeshb% p_rmesh&
                     &,potential% p_lcd(:,j,isa,ms)&
                     &,p_dlcd(:,j,isa,ms),p_d2lcd(:,j,isa,ms)&
                     &,p_d3lcd(:,j,isa,ms))
             Else
                Call dfspline1(3_t_int,pmeshb% nr,pmeshb% p_rmesh&
                     &,potential% p_lcd(:,j,isa,ms),p_dlcd(:,j,isa,ms))
             Endif

          Enddo
       Enddo
    Enddo
    !!
#if defined (TIME_DNDV)
    Call watch('DNDV-dfspline',cpu_read,Stop=.True.)
#endif
    !!
    If (relativistic == FULL_RELATIVISTIC ) Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'full relativistic correction not yet implemented!'")
    Endif
    !!
#if defined (TIME_DNDV)
    Call watch('DNDV-dvcoulomb',cpu_start)
#endif
    !!
    Call dvcoulomb(structure% nsite,structure% p_tau,structure% vuc&
         &,structure% p_isrt,structure% p_conao&
         &,lattice% nlattg,lattice% p_glat&
         &,mspin,degree,basis% p_fgam,potential% max_L&
         &,potential% mlmp,potential% p_nlmp,potential% p_lmp&
         &,potential% p_pmeshs,potential% nrp,potential% p_natom&
         &,potential% p_lcd,potential% ew_p_r,p_dvc&
         &,p_vft&
         &,potential% p_ac,potential% p_Nl&
         &,(structure% str_type == STR_TYPE_CRYSTAL))
    !!
#if defined (TIME_DNDV)
    Call watch('DNDV-dvcoulomb',cpu_read,stop=.true.)
#endif
    !!
    !!
    !! no GGA -> need less stuff
    Call palloc('p_yb',p_yb,1_t_int,(potential% max_L+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('p_rvylm',p_rvylm,1_t_int,3_t_int&
         &,1_t_int,(potential% max_L+1)**2,nmodule,nsubfunc)
    If(gga)Then
       Call palloc('p_qvylm',p_qvylm,1_t_int,5_t_int&
            &,1_t_int,(potential% max_L+1)**2,nmodule,nsubfunc)
    Endif
    !!
    Call palloc('p_pairdif',p_pairdif,0_t_int,lattice% npairsmax&
         &,1_t_int,structure% nsite,0_t_int,lattice% npairsmax&
         &,1_t_int,structure% nsite,nmodule,nsubfunc)
    !!
#if defined (TIME_DNDV)
    Call watch('DNDV-prep',cpu_start)
#endif
    !!
    Call prep_dndV_forces(structure% nsort,structure% nsite&
         &,structure% p_isrt,lattice% p_npairs,lattice% npairsmax&
         &,basis% nRvmx,basis% p_nRv,basis% p_lRv&
         &,lvmx,blocklenv,mxblsizev,p_fvbl,p_isiteblv,p_ipairblv)
    !!
    Call prep_dndV_forces(structure% nsort,structure% nsite&
         &,structure% p_isrt,lattice% p_npairs,lattice% npairsmax&
         &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
         &,lcmx,blocklenc,mxblsizec,p_fcbl,p_isiteblc,p_ipairblc)
    !!
    Call palloc('p_yl',p_yl,1_t_int,(basis% lmx+1)**2,nmodule,nsubfunc)
    !!
#if defined (TIME_DNDV)
    Call watch('DNDV-prep',cpu_read,stop=.true.)
#endif

    alert=.False.
    error=0.0_t_real
    tol=1.e-6_t_real
    ff=1.0_t_real

    !!
    d=0.0_t_real
    d1=0.0_t_real

    p_dnft(:,:)=c0
    for(:,:)=0.0_t_real
    
    isploop: Do isp=1,structure% nsite
       issp=structure% p_isrt(isp)
       tt(:)=structure % p_tau(:,isp)
       !!
       Call vecdifn1(structure% nsite,isp,p_pairdif,lattice% p_npairs&
            &,lattice% npairsmax,lattice% p_pairs)
       !!
       !!
       imloop: Do im=1,mol% p_nm(isp)
          rsh(:)=mol% p_rm(:,im,isp)
          ww=mol% p_wm(im,isp)
          !ir=mol% p_rindxm(im,isp)

          rhot(1:2)=0.0_t_real
          rhonett(1:2)=0.0_t_real
          p_grhosite(1:3,1:2,1:structure% nsite)=0.0_t_real
          p_glaprhosite(1:3,1:2,1:structure% nsite)=0.0_t_real
          p_gmixrhosite(1:3,1:structure% nsite)=0.0_t_real
          p_gmixrhossite(1:3,1:2,1:structure% nsite)=0.0_t_real
          p_ggrhosite(1:3,1:3,1:2,1:structure% nsite)=0.0_t_real
          p_gggrhossite(1:3,1:3,1:3,1:2,1:structure% nsite)=0.0_t_real
          gvcsite(1:3,1:structure% nsite)=0.0_t_real
          laprhos(1:2)=0.0_t_real
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-gradrho',cpu_start)
#endif
          !!
          isbloop: Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             pmeshb    => potential% p_pmeshs(issb)


             irs0=1
             If(isb==isp)Then
                irs0=0
             Endif
             irloop: Do irs=irs0,lattice% p_npairs(isb,isp)
                If(irs==0)Then
                   p(:)=0.0_t_real
                Else
                   p(:)=lattice% p_pairs(:,irs,isb,isp)
                Endif
                r(:)=rsh(:)-p(:)
                rb2=Dot_product(r,r)
                rb=Sqrt(rb2)
                !!
                If(rb > pmeshb% rmax) Cycle irloop
                !!
                If(rb==0.0_t_real)Then
                   !! whenever rb==0 the resulting divergence
                   !! is screened in the relevant integrals
                   !! at the next neighbours the shape function
                   !! is zero and at the origin the jacobian
                   !! Thus, we may ignore the case rb==0
                   oorb=0.0_t_real
                Else
                   oorb=1.0_t_real/rb
                Endif
                oorb2=oorb*oorb
                !!
                Call ylms12(p_yb,r(1),r(2),r(3),potential% max_L)
                !!
                If(gga )Then
                   Call calc_real_quad_harmonics_opt(potential% max_L&
                        &,p_yb,p_rvylm,p_qvylm)
                Else
                   Call calc_real_vec_Ylm_opt(potential% max_L,p_yb,p_rvylm)
                Endif
                !!
                indexb=mintpl_coefs(degree,pmeshb,rb,coefb)
                !!
                !!
                !! start: coulomb potential gradient
                afdp=0.0_t_real
                gfn(:)=0.0_t_real
                Do j=1,potential% p_nlmp(isb)
                   ilm=potential% p_lmp(j,isb)
                   l=llilm(ilm)
                   ap=Dot_product(p_dvc(indexb:indexb+degree,2,j,isb)&
                        &,coefb(0:degree))
                   am=Dot_product(p_dvc(indexb:indexb+degree,1,j,isb)&
                        &,coefb(0:degree))
                   !!
                   afdp=afdp+ap*p_yb(ilm)
                   gfn(:)=gfn(:)&
                        &+(am-ap)/(2.0_t_real*l+1.0_t_real)*p_rvylm(:,ilm)
                   !!
                Enddo
                !!
                gvcsite(:,isb)=gvcsite(:,isb)+(gfn(:)+afdp*r(:)*oorb)*oorb2
                !!
                !! end:   coulomb potential gradient
                !!
                msloop: Do ms=1_t_int,mspin
                   !!
                   dd=0.0_t_real
                   Do j=1_t_int,potential% p_nlmp(isb)
                      dd=dd+Dot_product(&
                           &potential% p_lcd(indexb:indexb+degree,j,isb,ms)&
                           &,coefb(0:degree))*p_yb(potential% p_lmp(j,isb))
                   Enddo
                   rhot(ms)=rhot(ms)+dd*oorb2

                   !!
                   dd=0.0_t_real
                   Do j=1_t_int,potential% p_nlmp(isb)
                      dd=dd+Dot_product(&
                           &lcdnet(indexb:indexb+degree,j,isb,ms)&
                           &,coefb(0:degree))*p_yb(potential% p_lmp(j,isb))
                   Enddo
                   rhonett(ms)=rhonett(ms)+dd*oorb2
                   !!
                   ggaif: If(gga )Then
                      !!
                      afdp=0.0_t_real
                      afpmpm=0.0_t_real
                      afpmpm0=0.0_t_real
                      gfdp(:)=0.0_t_real
                      gfdp0(:)=0.0_t_real
                      qfn(:)=0.0_t_real
                      gfn(:)=0.0_t_real
                      adlap=0.0_t_real
                      glap(:)=0.0_t_real
                      afp30=0.0_t_real
                      gafpmpm0(:)=0.0_t_real
                      qfdp(:)=0.0_t_real
                      !!
                      Do j=1,potential% p_nlmp(isb)
                         ilm=potential% p_lmp(j,isb)
                         l=llilm(ilm)
                         f=Dot_product(&
                              &potential% p_lcd(indexb:indexb+degree,j,isb,ms)&
                              &,coefb(0:degree))*oorb2
                         df=Dot_product(&
                              & p_dlcd(indexb:indexb+degree,j,isb,ms)&
                              &,coefb(0:degree))*oorb
                         d2f=Dot_product(&
                              & p_d2lcd(indexb:indexb+degree,j,isb,ms)&
                              &,coefb(0:degree))
                         d3f=Dot_product(&
                              & p_d3lcd(indexb:indexb+degree,j,isb,ms)&
                              &,coefb(0:degree))*rb

                         
                         adlap=adlap+(d3f-(l+4.0_t_real)*d2f&
                              &-(l**2-l-8.0_t_real)*df&
                              &+(l+2)*(l+4)*(l-1)*f)*p_yb(ilm)
                         
                         glap(:)=glap(:)&
                              &+(d2f-2.0_t_real*df-(l+2)*(l-1)*f)&
                              & *p_rvylm(:,ilm)
                         
                         
                         !! gradient of density
                         fdp=df-(2.0_t_real+l)*f
                         !!
                         fpmpm=d2f-(2.0_t_real*l+5.0_t_real)*df&
                              &+(l+4.0_t_real)*(l+2.0_t_real)*f
                         !!
                         !!
                         afdp   =afdp   +fdp  *p_yb(ilm)
                         afpmpm =afpmpm +fpmpm*p_yb(ilm)
                         gfn(:) =gfn(:) +f    *p_rvylm(:,ilm)
                         gfdp(:)=gfdp(:)+fdp  *p_rvylm(:,ilm)
                         qfn(:) =qfn(:) +f    *p_qvylm(:,ilm)
                         !!
                         If(l<=2)Then
                            afpmpm0 =afpmpm0 +fpmpm*p_yb(ilm)
                            afp30=afp30&
                                 &+(d3f&
                                 & -(3.0_t_real*l+9.0_t_real)*d2f&
                                 & +(3.0_t_real*l**2+21.0_t_real*l&
                                 &   +33.0_t_real)*df&
                                 &-(l+2.0_t_real)*(l+4.0_t_real)&
                                 & *(l+6.0_t_real)*f&
                                 &)*p_yb(ilm)
                            gfdp0(:)=gfdp0(:)+fdp  *p_rvylm(:,ilm)
                            gafpmpm0(:) =gafpmpm0(:) +fpmpm*p_rvylm(:,ilm)
                         Endif
                         If(l==2)Then
                            qfdp(:)= qfdp(:)+fdp*p_qvylm(:,ilm)
                         Endif
                      Enddo
                      !! collect the separate sums
                      p_grhosite(:,ms,isb)=p_grhosite(:,ms,isb)&
                           &+gfn(:)*oorb+afdp*r(:)*oorb2
                      !!
                      p_glaprhosite(:,ms,isb)=p_glaprhosite(:,ms,isb)&
                           &+(glap*oorb+adlap*r(:)*oorb2)*oorb2
                      !!
                      Do jj=1,3
                         p_ggrhosite(jj,jj,ms,isb)=p_ggrhosite(jj,jj,ms,isb)&
                              &+afdp*oorb2
                         Do ii=1,3
                            p_ggrhosite(ii,jj,ms,isb)=&
                                 &p_ggrhosite(ii,jj,ms,isb)&
                                 &+afpmpm*r(ii)*r(jj)*oorb2*oorb2&
                                 &+(gfdp(ii)*r(jj) +gfdp(jj)*r(ii))&
                                 & *oorb*oorb2
                         Enddo
                      Enddo
                      !!
                      !!
                      nn=0
                      Do jj=1,3
                         Do ii=jj,3
                            nn=nn+1
                            If(nn==6) Then
                               a=(-qfn(1)-qfn(4))*oorb2
                            Else
                               a=qfn(nn)*oorb2
                            Endif
                            p_ggrhosite(ii,jj,ms,isb)=&
                                 &p_ggrhosite(ii,jj,ms,isb)+a
                            If(ii /= jj) &
                                 &p_ggrhosite(jj,ii,ms,isb)=&
                                 &p_ggrhosite(jj,ii,ms,isb)+a
                         Enddo
                      Enddo
                      !!
                      qq(:,:)=0.0_t_real
                      nn=0
                      Do jj=1,2
                         Do ii=jj,3
                            nn=nn+1
                            qq(ii,jj)=qfdp(nn)*oorb2*oorb2
                            If(ii /= jj) qq(jj,ii)=qq(jj,ii)
                         Enddo
                      Enddo
                      qq(3,3)=-qq(1,1)-qq(2,2)
                      !!
                      Do ii=1,3
                         Do jj=1,3
                            Do nn=1,3
                               If(jj==nn)Then
                                  p_gggrhossite(ii,jj,nn,ms,isb)=&
                                       &p_gggrhossite(ii,jj,nn,ms,isb)&
                                       &+(gfdp0(ii)*oorb+afpmpm0*r(ii)*oorb2&
                                       &)*oorb2
                               Endif
                               If(ii==jj)Then
                                  p_gggrhossite(ii,jj,nn,ms,isb)=&
                                       &p_gggrhossite(ii,jj,nn,ms,isb)&
                                       &+(gfdp0(nn)*oorb+afpmpm0*r(nn)*oorb2&
                                       &)*oorb2
                               Endif
                               If(ii==nn)Then
                                  p_gggrhossite(ii,jj,nn,ms,isb)=&
                                       &p_gggrhossite(ii,jj,nn,ms,isb)&
                                       &+(gfdp0(jj)*oorb+afpmpm0*r(jj)*oorb2&
                                       &)*oorb2
                               Endif
                               p_gggrhossite(ii,jj,nn,ms,isb)=&
                                    &p_gggrhossite(ii,jj,nn,ms,isb)&
                                    &+afp30*r(ii)*r(jj)*r(nn)&
                                    &*oorb2*oorb2*oorb2&
                                    &+(gafpmpm0(ii)*r(jj)*r(nn)&
                                    &+gafpmpm0(jj)*r(ii)*r(nn)&
                                    &+gafpmpm0(nn)*r(jj)*r(ii)&
                                    &)*oorb2*oorb2*oorb&
                                    &+qq(ii,jj)*r(nn)&
                                    &+qq(jj,nn)*r(ii)&
                                    &+qq(nn,ii)*r(jj)
                                    

                               
                            Enddo
                         Enddo
                      Enddo
                      !!

                   Else
                      gfn(:)=0.0_t_real
                      afdp=0.0_t_real
                      Do j=1,potential% p_nlmp(isb)
                         ilm=potential% p_lmp(j,isb)
                         l=llilm(ilm)
                         f=Dot_product(&
                              &potential% p_lcd(indexb:indexb+degree,j,isb,ms)&
                              &,coefb(0:degree))
                         df=Dot_product(&
                              & p_dlcd(indexb:indexb+degree,j,isb,ms)&
                              &,coefb(0:degree))
                         
                         !! gradient of density
                         fdp=(df-( 2.0_t_real+l)*oorb*f)
                         !!
                         afdp=afdp+fdp*p_yb(ilm)
                         gfn=gfn+f*p_rvylm(:,ilm)
                         !!
                      Enddo
                      p_grhosite(:,ms,isb)=p_grhosite(:,ms,isb)&
                           &+(gfn(:)+afdp*r(:))*oorb2*oorb
                   Endif ggaif
                   !!
                End Do msloop
                
             End Do irloop
             !!
             !!
          End Do isbloop
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-gradrho',cpu_read,Stop=.True.)
#endif
          !!
!!$          If(ir==1)Then
!!$             !! we are at the origin, the density is not well defined in relat
!!$             !! but this point gives zero anyway for all relevant integrals,
!!$             !! thus we can set the density to zero and avoid the adjustrho
!!$             !! error message, which has no meaning.
!!$             !!
!!$             rhot(1:2)=0.0_t_real
!!$             p_grhosite(1:3,1:2,1:structure% nsite)=0.0_t_real
!!$             p_ggrhosite(1:3,1:3,1:2,1:structure% nsite)=0.0_t_real
!!$          Endif
          !!
          trho=rhot(1)+rhot(2)
          ggaif2: If (gga )Then

             grho=0.0_t_real
             ggrho=0.0_t_real
             Do isb=1,structure% nsite
                grho(:,:)=grho(:,:)+p_grhosite(:,:,isb)
                ggrho(:,:,:)=ggrho(:,:,:)+p_ggrhosite(:,:,:,isb)
             Enddo
             
             tgrad(1:3)=grho(1:3,1)+grho(1:3,2)
             gradrhos(1)=Sqrt(Sum(grho(1:3,1)**2))
             gradrhos(2)=Sqrt(Sum(grho(1:3,2)**2))
             gradrho=Sqrt(Sum(tgrad(1:3)**2))

             Do ms=1,mspin
                Do nn=1,3
                   laprhos(ms)=laprhos(ms)+ggrho(nn,nn,ms)
                Enddo
             Enddo

             p_gabsgradsite(1:3,1:structure% nsite)=0.0_t_real
             p_gabsgradssite(1:3,1:2,1:structure% nsite)=0.0_t_real
             gabsgrad(1:3)=0.0_t_real
             gabsgrads(1:3,1:2)=0.0_t_real
             Do isb=1,structure% nsite
                p_gabsgradsite(1:3,isb)=Matmul(&
                     &p_ggrhosite(1:3,1:3,1,isb)+p_ggrhosite(1:3,1:3,2,isb)&
                     &,tgrad)
                Do ms =1,mspin
                   p_gabsgradssite(1:3,ms,isb)=Matmul(&
                        &p_ggrhosite(1:3,1:3,ms,isb),grho(1:3,ms))
                Enddo
                gabsgrad(1:3)=gabsgrad(1:3)+p_gabsgradsite(1:3,isb)
                gabsgrads(1:3,1:2)=gabsgrads(1:3,1:2)&
                     &+p_gabsgradssite(1:3,1:2,isb)
             Enddo
             !!
             !!
             Do isb=1,structure% nsite
                p_gmixrhosite(1:3,isb)=2.0_t_real*Matmul(gabsgrad(1:3)&
                     &,p_ggrhosite(1:3,1:3,1,isb)&
                     &+p_ggrhosite(1:3,1:3,2,isb))
                Do nn=1,3
                   p_gmixrhosite(nn,isb)=p_gmixrhosite(nn,isb)&
                        &+Dot_product(tgrad,Matmul(&
                        & p_gggrhossite(1:3,1:3,nn,1,isb)&
                        &+p_gggrhossite(1:3,1:3,nn,2,isb),tgrad))
                Enddo
                Do ms=1,mspin
                   p_gmixrhossite(1:3,ms,isb)=2.0_t_real&
                        &*Matmul(gabsgrads(1:3,ms)&
                        &,p_ggrhosite(1:3,1:3,ms,isb))
                   Do nn=1,3
                      p_gmixrhossite(nn,ms,isb)=&
                           &p_gmixrhossite(nn,ms,isb)&
                           &+Dot_product(grho(1:3,ms),Matmul(&
                           & p_gggrhossite(1:3,1:3,nn,ms,isb),grho(1:3,ms)))
                   Enddo
                Enddo
             Enddo
             !!
             mixrhos(1)=Dot_product(grho(1:3,1),gabsgrads(1:3,1)) 
             mixrhos(2)=Dot_product(grho(1:3,2),gabsgrads(1:3,2)) 
             mixrho=Dot_product(tgrad(1:3),gabsgrad(1:3))
          Else ggaif2
             p_gabsgradsite (:,:)  =0.0_t_real
             p_gabsgradssite(:,:,:)=0.0_t_real
             p_glaprhosite  (:,:,:)=0.0_t_real
             p_gmixrhosite  (:,:)  =0.0_t_real
             p_gmixrhossite (:,:,:)=0.0_t_real
          Endif ggaif2
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-derivxcrho',cpu_start)
#endif
          !!
          Call adjustrho(rhot,ff,error,mspin,tol,alert)
          Call derivxcrho(mspin,rhot,gradrhos,gradrho,laprhos,mixrhos,mixrho&
               &,dvex,dvexdabsgrads,dvexdabsgrad,dvexdlaprho&
               &,dvexdmixrhos,dvexdmixrho&
               &,vex,epsxc,potential% xreduce)
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-derivxcrho',cpu_read,Stop=.True.)
#endif
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-novl-prep',cpu_start)
#endif
          !!
          !! collect the full overlap density
          !!
          iblv=0
          inblv=0
          p_fvbl(:)=0.0_t_real
          iblc=0
          inblc=0
          p_fcbl(:)=0.0_t_real
          isaloop: Do isa=1,structure% nsite 
             issa=structure% p_isrt(isa)
             bmesha    => basis% p_basmeshs(issa)
             !!
             nva=basis% p_nRv(issa)
             nca=basis% p_nRc(issa)
             !!
             if(nva==0 .and. nca==0) cycle isaloop
             !!
             lmxa=Max(lvmx(issa),lcmx(issa))
             !!
             irs0=1
             If(isa==isp)Then
                !! include on-site terms, which are excluded in
                !! definition of pairs(...)
                irs0=0
             Endif
             !!             

             irAloop: Do irs=irs0,lattice% p_npairs(isa,isp)
                If(irs==0)Then
                   rra(:)=rsh(:)
                Else
                   rra(:)=rsh(:)-lattice% p_pairs(:,irs,isa,isp)
                Endif
                ra2=Sum(rra**2)
                ra=Sqrt(ra2)


                If(ra > bmesha% rmax) Cycle irAloop
                If(ra ==0.0_t_real) Cycle irAloop
                !!
                !!
                If(ra > Max(basis% p_rtfcmax(1,issa)&
                     &,basis% p_rtfvmax(1,issa))) Cycle irAloop
                !!
                texp=ra**basis% p_fgam(issa)/ra
                !!
                !!
                indexa=mintpl_coefs(degree,bmesha,ra,coefa)
                Call ylms12(p_yl,rra(1),rra(2),rra(3),lmxa)
                !!
                !! valence functions
                !!
                If(ra > basis% p_rtfvmax(1,issa)) goto 999
                !!
                k=0
                nvaloop: Do i=1,nva
                   l=basis% p_lRv(i,issa)
                   
                   ff1=0.0_t_real
                   If(ra <= basis% p_rfvmax(i,1,issa) )Then
                      ff1=Dot_product(basis% p_fv(indexa:indexa+degree&
                           &,i,1,issa),coefa(0:degree))*texp
                   End If

                   il=l*l
                   Do m=1,l+l+1
                      il=il+1
                      k=k+1
                      p_fvbl(inblv+k)=ff1*p_yl(il)
                   Enddo       ! m
                Enddo nvaloop
                iblv=iblv+1
                p_isiteblv(iblv)=isa
                p_ipairblv(iblv)=irs
                inblv=inblv+blocklenv(isa)
                !!
999             Continue
                !!
                !! Core functions
                !!
                !!
                !! valence functions
                !!
                If(ra > basis% p_rtfcmax(1,issa)) Cycle irAloop
                !!
                k=0
                ncaloop: Do i=1,nca
                   l=basis% p_lRc(i,issa)
                   
                   ff1=0.0_t_real
                   If(ra <= basis% p_rfcmax(i,1,issa) )Then
                      ff1=Dot_product(basis% p_fc(indexa:indexa+degree&
                           &,i,1,issa),coefa(0:degree))*texp
                   End If

                   il=l*l
                   Do m=1,l+l+1
                      il=il+1
                      k=k+1
                      p_fcbl(inblc+k)=ff1*p_yl(il)
                   Enddo       ! m
                Enddo ncaloop
                iblc=iblc+1
                p_isiteblc(iblc)=isa
                p_ipairblc(iblc)=irs
                inblc=inblc+blocklenc(isa)
                !!

             Enddo irAloop
             !!
          Enddo isaloop
          nblv=iblv
          nblc=iblc
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-novl-prep',cpu_read,Stop=.True.)
#endif
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-novl',cpu_start)
#endif

          novl(1:2)=0.0_t_real
          !!
          inblb=0
          iblbloop: Do iblb=1,nblv
             isb=p_isiteblv(iblb)
             lenb=blocklenv(isb)
             irbp=p_ipairblv(iblb)

             inbla=0
             iblaloop: Do ibla=1,nblv
                isa=p_isiteblv(ibla)
                lena=blocklenv(isa)
                irap=p_ipairblv(ibla)
                !!
                irba=p_pairdif(irap,isa,irbp,isb)
                If((irba == 0_t_int) )Goto 500
                Do ms=1,mspin
                   novl(ms)=novl(ms)+Dot_product(&
                        &     Matmul(p_fvbl(inbla+1:inbla+lena)&
                        &           ,onv(1:lena,1:lenb,isa,isb,ms,irba))&
                        &     ,p_fvbl(inblb+1:inblb+lenb))
                Enddo
                !!
500             Continue 
                inbla=inbla+lena
             End Do iblaloop
             
             inbla=0
             iblacloop: Do ibla=1,nblc
                isa=p_isiteblc(ibla)
                lena=blocklenc(isa)
                irap=p_ipairblc(ibla)
                !!
                irba=p_pairdif(irap,isa,irbp,isb)
                If((irba == 0_t_int) )Goto 501
                Do ms=1,mspin
                   novl(ms)=novl(ms)+Dot_product(&
                        &     Matmul(p_fcbl(inbla+1:inbla+lena)&
                        &           ,onc(1:lena,1:lenb,isa,isb,ms,irba))&
                        &     ,p_fvbl(inblb+1:inblb+lenb))*2.0_t_real
                Enddo
                !!
501             Continue 
                inbla=inbla+lena
             End Do iblacloop
             inblb=inblb+lenb
          End Do iblbloop
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-novl',cpu_read,Stop=.True.)
#endif
          !!
          d=d+(trho-Sum(rhonett(1:mspin)))*ww
          !!
          Do ms=1,mspin
             drho(ms)=novl(ms)-(rhot(ms)-rhonett(ms))
          Enddo
          drhot=Sum(drho(1:mspin))

          d1=d1+drhot*ww

          !!
          !! collect Coulomb corrections
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-collect-vc',cpu_start)
#endif
          !!
          isvcloop: Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             pmeshb    => potential% p_pmeshs(issb)

             !!
             !!
             !! local coulomb potential gradient
             !!
             for(:,isb)=for(:,isb)+gvcsite(:,isb)*drhot*ww*dovc
             
             !! 
             !! ewald potential gradient
             !! 
             If(structure% str_type == STR_TYPE_MOLECULE) Then
                !!
                r(:)=rsh(:)+tt(:)-structure% p_tau(:,isb)
                rb2=Dot_product(r,r)
                rb=Sqrt(rb2)
                !!
                !!
                rltrhoif: If(rb > pmeshb% rmax)Then
                   !! add up the multipole tails 
                   Call ylms12(p_yb,r(1),r(2),r(3),potential% max_L)
                   Call calc_real_vec_Ylm_opt(potential% max_L,p_yb,p_rvylm)
                   !!
                   gfn(:)=0.0_t_real
                   afdp=0.0_t_real
                   !!
                   Do j=1,potential% p_nlmp(isb)
                      ilm=potential% p_lmp(j,isb)
                      l=llilm(ilm)
                      ap=-(potential% p_ac(j,isb)*fourpi/rb**l)
                      afdp=afdp+ap*p_yb(ilm)
                      gfn(:)=gfn(:)&
                           &-ap*p_rvylm(:,ilm)/(2.0_t_real*l+1.0_t_real)
                   Enddo
                   !!
                   for(:,isb)=for(:,isb)&
                        &+(gfn(:)+afdp*r(:)/rb)/rb2*drhot*ww*doew
                Endif rltrhoif
                !!
                !!
                !!
             Endif
             !!
          End Do isvcloop
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-collect-vc',cpu_read,Stop=.True.)
#endif
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-ewaldft',cpu_start)
#endif
          !!
          If((.Not.forces% approx_nodndL_ewald) .And. &
               &structure% str_type == STR_TYPE_CRYSTAL) Then
             !!
             r(:)=rsh(:)+tt(:)
             !!
             cex=drhot*ww*ci*doew
             !!
             Do ig=2_t_int,lattice% nlattg
                g=Dot_product(lattice% p_glat(:,ig),r(:))
                p_dnft(:,ig)=p_dnft(:,ig)&
                     &+(Exp(ci*g)*cex)*lattice% p_glat(:,ig)
             Enddo                     ! ig
             !!
          Endif
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-ewaldft',cpu_read,Stop=.True.)
#endif
          !!
          !! collect xc-contribs
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-collect-xc',cpu_start)
#endif
!          Print "('PQK=',i5,4(e30.15e3))",im,dvex(1:2,1:2)
          Do isb=1,structure% nsite
             If(mspin==1)Then
                for(:,isb)=for(:,isb)&
                     &+drho(1)*ww*(&
                     &dvex(1,1)*p_grhosite(:,1,isb)&
                     &+dvexdabsgrad(1)*p_gabsgradsite(:,isb)&
                     &+dvexdlaprho(1,1)*p_glaprhosite(:,1,isb)&
                     &+dvexdmixrho*p_gmixrhosite(:,isb)&
                     &)*doxc
             Else
                Do ms=1,mspin
                   Do ns=1,mspin
                      for(:,isb)=for(:,isb)&
                           &+drho(ms)*ww*(&
                           &dvex(ms,ns)*p_grhosite(:,ns,isb)&
                           &+dvexdabsgrads(ms,ns)*p_gabsgradssite(:,ns,isb)&
                           &+dvexdlaprho(ms,ns)*p_glaprhosite(:,ns,isb)&
                           &+dvexdmixrhos(ms,ns)*p_gmixrhossite(:,ns,isb)&
                           &)*doxc
                   Enddo
                   for(:,isb)=for(:,isb)+drho(ms)*ww&
                        &*dvexdabsgrad(ms)*p_gabsgradsite(:,isb)*doxc
                   for(:,isb)=for(:,isb)+drho(ms)*ww&
                        &*dvexdmixrho*p_gmixrhosite(:,isb)*doxc
                Enddo
             Endif
          Enddo
          !!
#if defined (TIME_DNDV)
          Call watch('DNDV-collect-xc',cpu_read,Stop=.True.)
#endif
          !!
       End Do imloop
    End Do isploop
    !!
    If((.Not.forces% approx_nodndL_ewald).And.&
         &structure% str_type == STR_TYPE_CRYSTAL) Then
       !!
#if defined (TIME_DNDV)
       Call watch('DNDV-ewaldft',cpu_start)
#endif
       Do isb=1,structure% nsite
          Do ig=2_t_int,lattice% nlattg
             for(:,isb)=for(:,isb)&
                  &+Real(p_vft(ig,isb)*p_dnft(:,ig),t_real)
          Enddo
       Enddo                     ! isa
#if defined (TIME_DNDV)
       Call watch('DNDV-ewaldft',cpu_read,Stop=.True.)
#endif
       !!
    Endif
    !!
    Write(outfile,"('integral rho-rhonet=',f30.15)")d
    Write(outfile,"('integral Drhoovl   =',f30.15)")d1
    !!
    Call pfree(p_pairdif)
    Call pfree(p_isiteblv)
    Call pfree(p_isiteblc)
    Call pfree(p_ipairblv)
    Call pfree(p_ipairblc)
    Call pfree(p_fvbl)
    Call pfree(p_fcbl)
    Call pfree(p_yb)
    Call pfree(p_yl)
    Call pfree(p_rvylm)
    Call pfree(p_qvylm)
    Call pfree(p_dvc)
    !!
    !! and symmetrize again
    Do isa=1,structure% nsite
       forces% p_dndVforces(:,isa)=0.0_t_real
       Do jops=1,symmetry% Rnumops
          isga=structure% p_equivsites(jops,isa)
          forces% p_dndVforces(:,isa)=forces% p_dndVforces(:,isa)&
               &+Matmul(symmetry% Ropmat(:,:,jops),for(:,isga))&
               &/symmetry% Rnumops
       Enddo
    Enddo
    !!
    !!
    !!
    If(alert)Then
      
3      Format('''Numerical inaccuracy in vxc/exc &
            &calculation! '',/,'' maxerror=',e12.4e3,'''')
       Write(errbuf,3) error
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
    Endif
    !!
#if defined (TIME_DNDV)
    Call watch('DNDV-dfspline',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('DNDV-dvcoulomb',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('DNDV-prep',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('DNDV-gradrho',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('DNDV-derivxcrho',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('DNDV-novl-prep',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('DNDV-novl',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('DNDV-ewaldft',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('DNDV-collect-vc',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('DNDV-collect-xc',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
#endif
    !!
    Call pfree(for)
    Call pfree(potential% p_ac)
    Call pfree(potential% p_Nl)
    Call pfree(p_vft)
    Call pfree(p_dnft)
    Call pfree(p_dlcd)
    Call pfree(p_d2lcd)
    Call pfree(p_d3lcd)
    Call pfree(p_gabsgradsite)
    Call pfree(p_gabsgradssite)
    Call pfree(p_glaprhosite)
    Call pfree(p_grhosite)
    Call pfree(p_ggrhosite)
    Call pfree(p_gmixrhosite)
    Call pfree(p_gmixrhossite)
    Call pfree(p_gggrhossite)
    !!
    !!
    Return
    !!
  End Subroutine dndV_forces
  !!***********************************************************************
  Subroutine vecdifn1(nsite,isp,pairdif,npairs,npairsmax,pairs)
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nsite,isp,npairsmax
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(out)   :: pairdif(0:npairsmax,nsite,0:npairsmax,nsite)
    Real(t_real),Intent(in)      :: pairs(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: isb,isa,irbp,irap,irba,m,irb0,ira0
    Real(t_real)  :: rbp(3),aa(3)
    !!
    pairdif=0_t_int
    !Write(outfile,"('isp=',5i5)")isp
    Do isb=1,nsite
       irb0=1
       If(isb==isp)Then
          irb0=0
       Endif
       Do irbp=irb0,npairs(isb,isp)
          If(irbp==0)Then
             rbp(:)=0.0_t_real
          Else
             rbp(:)=pairs(:,irbp,isb,isp)
          Endif
          Do isa=1,nsite
             ira0=1
             If(isa==isp)Then
                ira0=0
             Endif
             Do irap=ira0,npairs(isa,isp)
                If(irap==0)Then
                   aa(:)=rbp(:)
                Else
                   aa(:)=rbp(:)-pairs(:,irap,isa,isp)
                Endif
                irba=0_t_int
                mloop:Do m=1_t_int,npairs(isb,isa)
                   If(All(Abs(pairs(:,m,isb,isa)-aa(:)) < 1.e-3_t_real)) Then
                      irba=m
                      Exit mloop
                   Endif
                Enddo mloop
                !Write(outfile,"('irap,isa,irbp,isb,irba=',5i5)")&
                !     & irap,isa,irbp,isb,irba
                pairdif(irap,isa,irbp,isb)=irba
             Enddo
          Enddo
       Enddo
    Enddo
    Return
  End Subroutine vecdifn1
  !!***********************************************************************
  !! make auxillary arrays for the thci-integration
  !! p_fabl, p_isitebl,p_ipairbl and p_vloc has to be nullified 
  !! on calling and has to be freed
  !! after final usage
  Subroutine prep_dndV_forces(nsort,nsite,isrt,npairs,npairsmax&
       &,nm,nR,lR&
       &,lmx,blocklen&
       &,mxblsize,p_fabl,p_isitebl,p_ipairbl)
    !!
    Implicit none  
    !!IO
    Integer(t_int),Intent(in)    :: nsort,nsite,isrt(nsite),npairsmax
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: nm,nR(*),lR(nm,*)
    Integer(t_int),Intent(out)   :: mxblsize
    Integer(t_int),Intent(out)   :: lmx(nsort),blocklen(nsite)
    Integer(t_int),Pointer       :: p_isitebl(:)
    Integer(t_int),Pointer,Optional :: p_ipairbl(:)
    Real(t_real),Pointer         :: p_fabl(:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="prep_dndV_forces"
    Integer(t_int) :: isa,issa,na,isp,inbl
    !!
    !! determine max valence-l and blocklenght
    !!
    lmx(1:nsort)=0_t_int
    blocklen(1:nsite)=0_t_int
    !!
    Do isa=1,nsite
       issa=isrt(isa)
       na=nR(issa)
       If(na /= 0_t_int)Then
          lmx(issa)=Maxval(lR(1:na,issa))
          blocklen(isa)=Sum(2*lR(1:na,issa)+1)
       End If
    Enddo
    !!
    !! determine maximal blocksize=max aux array length
    !!
    mxblsize=0_t_int
    Do isp=1,nsite
       inbl=0_t_int
       Do isa=1,nsite
          inbl=inbl+blocklen(isa)*(npairs(isa,isp)+1)
       Enddo
       If(outlevel >= L_many) Write(outfile,20) isp,inbl
       mxblsize=Max(mxblsize,inbl)
    Enddo
    If(outlevel >= L_many)Write(outfile,21) mxblsize
20  Format('isp=',i5,' inbl=',i7)
21  Format('mxblsize=',i7)
    !!
    Call palloc('p_fabl',p_fabl,1_t_int,mxblsize,nsubfunc,nmodule)
    Call palloc('p_isitebl',p_isitebl,1_t_int,nsite*Max(1_t_int,npairsmax)&
         &,nsubfunc,nmodule)
    If(Present(p_ipairbl))Then
       Call palloc('p_ipairbl',p_ipairbl,1_t_int,nsite*Max(1_t_int,npairsmax)&
            &,nsubfunc,nmodule)
    Endif
    !!
    Return
    !!
  End Subroutine prep_dndV_forces
  !!***********************************************************************
  Subroutine log_site_history(symmetry,structure,forces)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Forces),Intent(inout) :: forces
    !!LOCAL
    Character(*),Parameter::nsubfunc="log_site_history"
    Logical(t_log) :: realloc,assoc
    Integer(t_int) :: nalloc
    Character(200) :: nw
    Integer(t_int) :: issaIO,ih,isb,isa,k
    Real(t_real)   :: t(3)
    Real(t_real),Pointer :: tmp(:,:,:)
    !!
    Nullify(tmp)
    !!
    !!
    assoc=(Associated(forces% p_sitehistory))
    realloc=.False.
    nalloc=1
    If(.Not.assoc) Then
       realloc=.True.
    Else If(Size(forces% p_sitehistory,3)<forces% nsitehistory+1) Then
       realloc=.True.
    Endif
    nalloc=forces% nsitehistory+10
    !!
    If(realloc)Then
       If(assoc)Then
          Call palloc('tmp',tmp&
               &,1_t_int,3_t_int&
               &,1_t_int,structure% nsite&
               &,1_t_int,forces% nsitehistory&
            &,nmodule,nsubfunc)

          tmp(1:3,1:structure% nsite,1:forces% nsitehistory)&
               &=forces% p_sitehistory(1:3,1:structure% nsite&
               &                   ,1:forces% nsitehistory)
       Endif
       
       Call palloc('forces% p_sitehistory',forces% p_sitehistory&
            &,1_t_int,3_t_int&
            &,1_t_int,structure% nsite&
            &,1_t_int,nalloc&
            &,nmodule,nsubfunc)

       If(assoc)Then
          forces% p_sitehistory(1:3,1:structure% nsite,1:forces% nsitehistory)&
               &=tmp(1:3,1:structure% nsite,1:forces% nsitehistory)
       Endif


       
    Endif
    !!
    forces% nsitehistory=forces% nsitehistory+1
    forces% p_sitehistory(1:3,1:structure% nsite,forces% nsitehistory)&
         &=structure% p_tau(1:3,1:structure% nsite)
    !!
    Open(12,file='=.site_history')
    Write(12,8)structure% IOnsort
    Do ih=1,forces% nsitehistory
       Write(12,28)
28     Format('{{')
       Do issaIO=1,structure% IOnsort
          isa=0
          Do isb=1,structure% nsite
             If(structure% p_IOisrt(isb) == issaIO )Then
                isa=isb
                Exit
             Endif
          Enddo
          !!
          If(isa<1)&
               &Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Oops, cannot find input sort?!'")
          !!
          t=forces% p_sitehistory(:,isa,ih)
          !!
          If(structure% str_type == STR_TYPE_MOLECULE) Then
             If(structure % lengthunit==SYM_LENGTH_ANGSTROEM) Then
                t=t*brtoan
             Endif
          Else
             t=Matmul(t&
                  &,symmetry% convreciprocial_lattice_vectors(:,:))/twopi
          Endif
          !!
          Write(12,10,advance='no') Trim(structure% p_IOelements(issaIO))
          Do k=1,3
             Call double_to_string_as_ratio(t(k)&
                  &,nw,12_t_int,1.0e-12_t_real,"(f30.10)")
             Write(12,110,advance='no') Trim(nw)
             If(k<3)Write(12,229,advance='no')
          Enddo
          If(issaIO< structure% IOnsort)Then
             Write(12,1119)
          Else
             Write(12,111)
          Endif

          !!
       Enddo! issaIO
       Write(12,29)
29     Format('}}')
229    Format(',')
       If(ih< forces% nsitehistory)Write(12,229)
    Enddo
    Write(12,18)

    Close(12)
    !!
    Call pfree(tmp)
    !!
    Return
    !!
8   Format('struct{struct{char[2] el;real tau[3];}atoms[',i10,'];}wyck_history[*]={')
10  Format('{"',a,'",{')
110  Format(a)
111  Format('}}')
1119 Format('}},')
18  Format('};')
  End Subroutine log_site_history
  !!***********************************************************************
  Subroutine analys_symtrans(symmetry,structure,forces,mesg)
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)      :: mesg
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Forces),Intent(inout),Target  :: forces
    !!LOCAL
    Character(*),Parameter::nsubfunc="analys_symtrans"
    Logical(t_log) :: debc
    Real(t_real)   :: tmp(3,3),E(3)
    Integer(t_int) :: jops,i,isashift
    Type(T_SymTrans),Pointer :: st
    !!
    debc=debugfun('FORCEDRIVER','checkinout','')
    !!
    st => forces% symtrans
    !!
    !! find non-essential translations
    !!
    st% issashift=1
    isashift=structure% p_isst(st% issashift)
    !!
    st% Pop=0.0_t_real
    Do jops=1,symmetry% Rnumops
       st% Pop(:,:)=st% Pop(:,:)&
            &+symmetry% Ropmat(:,:,jops)/symmetry% Rnumops
    Enddo
    !!
    !!
    !st% Pop=0.0_t_real
    st% Qop=0.0_t_real
    Do i=1,3
       st% Qop(i,i)=1.0_t_real
    Enddo
    st% Qop=st% Qop-st% Pop

    !!
    If(debc)Then
       Write(outfile,"(a,' Pop=')")Trim(mesg)
       Do i=1,3
          Write(outfile,"(a,' ',3(g12.5))")Trim(mesg),st% Pop(i,1:3)
       Enddo
       Write(outfile,2)Trim(mesg)
       Write(outfile,"(a,' Qop=')")Trim(mesg)
       Do i=1,3
          Write(outfile,"(a,' ',3(g12.5))")Trim(mesg),st% Qop(i,1:3)
       Enddo
       Write(outfile,2)Trim(mesg)
    Endif
    !!
    tmp=st% Pop
    Call rdiagno_noO(3_t_int,tmp,E)
    !!
    !!
    If(debc) Then
       !!
       Write(outfile,"(a,' E(Pop)=',(3g12.5,1x))")Trim(mesg),E
       Write(outfile,2)Trim(mesg)
       !!
    Endif
    !!
    st% nperp=0
    st% nparal=0
    Do i=1,3
       If(Abs(E(i))< 1.0e-10_t_real)Then
          !! perp directions
          st% nperp=st% nperp+1
          st% perp(:,st% nperp)=tmp(:,i)
       Else If(Abs(E(i)-1.0_t_real)< 1.0e-10_t_real)Then
          st% nparal=st% nparal+1
          st% paral(:,st% nparal)=tmp(:,i)
       Else
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Oops: What happend to the eigenvalues&
               & of the projector?!'")
       Endif
    Enddo
    !!
    If(debc) Then
       !!
       Write(outfile,"(a,' Allowed shift directions=')")Trim(mesg)
       Do i=1,st% nparal
          Write(outfile,"(a,' ',i2,': ',(3g12.5,1x))")&
               &Trim(mesg),i,st% paral(:,i)
       Enddo
       Write(outfile,2)Trim(mesg)
       Write(outfile,"(a,' Forbidden shift directions=')")Trim(mesg)
       Do i=1,st% nperp
          Write(outfile,"(a,' ',i2,': ',(3g12.5,1x))")&
               &Trim(mesg),i,st% perp(:,i)
       Enddo
       Write(outfile,2)Trim(mesg)
       !!
    Endif
    !!
    !!
    st% Pshift(:)=Matmul(st% Pop&
         &       ,structure% p_tau(1:3,isashift))
    !!
    !!
    !!
    Write(outfile,"(a,' ',72('-'))")Trim(mesg)
    Write(outfile,"(a,' Translational degrees of freedom')")Trim(mesg)
    Write(outfile,"(a,' ')")Trim(mesg)
    Write(outfile,"(a,' Allowed shift directions=')")Trim(mesg)
    Do i=1,st% nparal
       Write(outfile,"(a,' ',i2,': ',(3g12.5,1x))")&
            &Trim(mesg),i,st% paral(:,i)
    Enddo
    Write(outfile,2)Trim(mesg)
    Write(outfile,"(a,' ',72('-'))")Trim(mesg)
    
    !!
    !!
    !!
    !!
    Return
    !!
2   Format(a,' ')
    !!
  End Subroutine analys_symtrans
  !!***********************************************************************
  Subroutine symanalyse_sites(symmetry,structure,forces,mesg)
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)      :: mesg
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Forces),Intent(inout),Target :: forces
    !!LOCAL
    Character(*),Parameter::nsubfunc="symanalyse_sites"
    Logical(t_log) :: debc,partial_vary
    Integer(t_int) :: issa,isa,isga,jops,i,j,n,isashift
    Real(t_real)   :: tol,paral(3,3)
    Real(t_real)   :: tmp(3,3),Ep(3),tau(3),tt(3),a(3)
    Type(T_SymTrans),Pointer :: sp
    Type(T_SymTrans),Pointer :: st
    !!
    partial_vary=.False.
    !!
    Call palloc_symtrans('forces% p_sitefreeparam'&
         &,forces% p_sitefreeparam&
         &,structure% nsort,nmodule,nsubfunc)
    !!
    st => forces% symtrans
    !!
    !!
    debc=debugfun('FORCEDRIVER','checkinout','')

    !!
    tol=1.0e-10_t_real
    !!
    forces% Ndegfree=0
    issaloop: Do issa=1,structure% nsort
       sp => forces% p_sitefreeparam(issa)
       isa=structure% p_isst(issa)
       tau=structure% p_tau(:,isa)
       sp% do_vary=.False.
       !!
       !!
       Do i=1,forces% ngeomopt_sites
          If(forces% p_geomopt_sites(i)==issa) sp% do_vary=.True.
       Enddo
       If(forces% ngeomopt_sites==0)Then
          sp% do_vary=.True.
       Endif
       !!
       If(.Not. sp% do_vary) Then
          partial_vary=.True.
          Cycle
       Endif
       !!
       If(debc) Write(outfile,"(a,' issa ',i3,':')")Trim(mesg),issa
       !!
       a=0.0_t_real
       sp% Pop=0.0_t_real
       !!
       j=0
       Do jops=1,symmetry% Rnumops
          !!
          If(debc)Write(outfile,"(a,' jops ',i3,':')")Trim(mesg),jops
          !!
          isga=structure% p_equivsites(jops,isa)
          !!
          If(isga/=isa)Cycle
          !!
          If(debc)Write(outfile,"(a,' ',a,':isga ',i3,':')")Trim(mesg)&
               &,Trim(symmetry% Ropsymbol(jops)),isga
          j=j+1
          !!
          a=a+Matmul(tau,symmetry% Ropmat(:,:,jops))-tau
          sp% Pop=sp% Pop+Transpose(symmetry% Ropmat(:,:,jops))
          !!
          If(debc)Then
             Write(outfile,"(a,' S =',3(g12.5))")Trim(mesg),tau
             Write(outfile,"(a,' RS=',3(g12.5))")Trim(mesg)&
                  &,Matmul(tau,symmetry% Ropmat(:,:,jops))
             Write(outfile,"(a,' a=',3(g12.5))")Trim(mesg)&
                  &,Matmul(tau,symmetry% Ropmat(:,:,jops))-tau
          Endif
          !!
       Enddo
       sp% Pop=sp% Pop*structure% p_mult(issa)/symmetry% Rnumops
       !!
       sp% Qop=0.0_t_real
       Do i=1,3
          sp% Qop(i,i)=1.0_t_real
       Enddo
       sp% Qop=sp% Qop-sp% Pop
       !!
       If(structure% str_type==STR_TYPE_MOLECULE)Then
          a=0.0_t_real
       Else
          a=a*structure% p_mult(issa)/symmetry% Rnumops
       Endif
       If(debc)Write(outfile,"(a,' Order ',a,':')")Trim(mesg)&
            &,Trim(intToChar10(symmetry% Rnumops&
            &                 /structure% p_mult(issa)))
       If(debc)Then
          Write(outfile,"(a,' Wyckoff ',a,':')")Trim(mesg)&
               &,Trim(intToChar10(issa))
          Write(outfile,"(a,' Pop=')")Trim(mesg)
          Do i=1,3
             Write(outfile,"(a,' ',3(g12.5))")Trim(mesg)&
                  &,sp% Pop(i,1:3)
          Enddo
          Write(outfile,"(a,' Qop=')")Trim(mesg)
          Do i=1,3
             Write(outfile,"(a,' ',3(g12.5))")Trim(mesg)&
                  &,sp% Qop(i,1:3)
          Enddo
          Write(outfile,2)Trim(mesg)
          Write(outfile,"(a,' a=',3(g12.5))")Trim(mesg)&
               &,a(1:3)
          Write(outfile,2)Trim(mesg)
       Endif
       !!

       tmp=sp% Pop
       Call rdiagno_noO(3_t_int,tmp,Ep)
       !!
       If(debc) Then
          !!
          Write(outfile,"(a,' E(Pop)=',(3g12.5,1x))")Trim(mesg),Ep
          Write(outfile,2)Trim(mesg)
          !!
       Endif
       !!
       sp% nperp=0
       sp% nparal=0
       Do i=1,3
          If(Abs(Ep(i))< 1.0e-10_t_real)Then
             !! perp directions
             sp% nperp=sp% nperp+1
             sp% perp(:,sp% nperp)=tmp(:,i)
          Else If(Abs(Ep(i)-1.0_t_real)< 1.0e-10_t_real)Then
             sp% nparal=sp% nparal+1
             sp% paral(:,sp% nparal)=tmp(:,i)
          Else
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="'Oops: What happend to the eigenvalues&
                  & of the projector?!'")
          Endif
       Enddo
       !!
       !! check Pt*n_parallel=n_parallel, where n_parallel comes
       !! from the translational freedom symtrans
       Do j=1,st% nparal
          tt=0.0_t_real
          Do i=1,sp% nparal
             tt=tt+sp% paral(:,i)&
                  &*Dot_product(sp% paral(:,i),st% paral(:,j))
          Enddo
          !!
          If(Any(Abs(tt-st% paral(:,j))>tol))Then
             Write(outfile,"(a,' paral= ',3(e30.15e3,1x))")Trim(mesg)&
                  &,st% paral(:,j)
             Write(outfile,"(a,' tt   = ',3(e30.15e3,1x))")Trim(mesg)&
                  &,tt
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="'Pt*P /= P !?'")
          Endif
          !!
       Enddo
       !!
       If(st% nparal> sp% nparal)Then
          Write(outfile,"(a,' P-nparal = ',3(e30.15e3,1x))")Trim(mesg)&
               &,Trim(intToChar10(st% nparal))
          Write(outfile,"(a,' Pt-nparal= ',3(e30.15e3,1x))")Trim(mesg)&
               &,Trim(intToChar10(sp% nparal))
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Pt and P incompatible !?'")
       Endif
       !!
       !! decompose Pt=P+pt
       !!
       !!
       tmp=Matmul(Matmul(st% Qop,sp% Pop),st% Qop)
       Call rdiagno_noO(3_t_int,tmp,Ep)
       !!
       Do i=1,st% nparal
          paral(:,i)=st% paral(:,i)
       Enddo
       !!
       n=st% nparal
       Do i=1,3
          If(Abs(Ep(i))< 1.0e-10_t_real)Then
          Else If(Abs(Ep(i)-1.0_t_real)< 1.0e-10_t_real)Then
             n=n+1
             paral(:,n)=tmp(:,i)
          Else
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="'Oops: What happend to the eigenvalues&
                  & of the projector Q?!'")
          Endif
       Enddo
       If(n /= sp% nparal)Then
          Write(outfile,"(a,' npt      = ',3(e30.15e3,1x))")Trim(mesg)&
               &,Trim(intToChar10(n))
          Write(outfile,"(a,' P-nparal = ',3(e30.15e3,1x))")Trim(mesg)&
               &,Trim(intToChar10(st% nparal))
          Write(outfile,"(a,' Pt-nparal= ',3(e30.15e3,1x))")Trim(mesg)&
               &,Trim(intToChar10(sp% nparal))
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'subspace dimension problem !?'")
       Endif
       !!
       !!
       !! todo test that Pt_new * Qt =0 and P_t_new*P=P
       !!
       If(debc) Then 
          !!
          Write(outfile,"(a,' Projector directions=')")Trim(mesg)
          Do i=1,sp% nparal
             Write(outfile,"(a,' ',i2,': ',(3g12.5,1x))")&
                  &Trim(mesg),i,sp% paral(:,i)
          Enddo
          Write(outfile,2)Trim(mesg)
          Write(outfile,"(a,' Forbidden directions=')")Trim(mesg)
          Do i=1,sp% nperp
             Write(outfile,"(a,' ',i2,': ',(3g12.5,1x))")&
                  &Trim(mesg),i,sp% perp(:,i)
          Enddo
          Write(outfile,2)Trim(mesg)
          !!
          !!
          Write(outfile,"(a,' New Projector directions=')")Trim(mesg)
          Do i=1,sp% nparal
             Write(outfile,"(a,' ',i2,': ',(3g12.5,1x))")&
                  &Trim(mesg),i,paral(:,i)
          Enddo
       Endif
       !!
       Do i=1,sp% nparal
          !! is Qt*nparal_new==0?
          If(Any(Abs(Matmul(sp% Qop,paral(:,i)))>tol))Then
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="'Qop*Pt_new /=0 !?'")
          Endif
       Enddo
       Do i=st% nparal+1,sp% nparal
          !! is pt*P=0
          If(Any(Abs(Matmul(st% Pop,paral(:,i)))>tol))Then
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="'Pop*pt_new /=0 !?'")
          Endif
       Enddo
       Do i=1,st% nparal
          !! is pt*Pt=pt
          If(Any(Abs(Matmul(sp% Pop,paral(:,i))-paral(:,i))>tol))Then
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="'pt_new*Pop /= pt_new!?'")
          Endif
       Enddo
       !!
       sp% paral=paral
       !!
       !!
       forces% Ndegfree=forces% Ndegfree+sp% nparal
       !!
       !!
       Do i=1,sp% nparal
          If(Abs(Dot_product(a,sp% paral(:,i)))&
               &>tol)Then
             
             Write(outfile,"(a,' a= ',3(e30.15e3,1x))")Trim(mesg)&
                  &,a
             Write(outfile,"(a,' n= ',3(e30.15e3,1x))")Trim(mesg)&
                  &,sp% paral(:,i)
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="'Parallel component of a /= 0 !?'")
          Endif
       Enddo
       !!
       !!
       sp% Qtau=0.0_t_real
       Do i=1,sp% nperp
          sp% Qtau=sp% Qtau+sp% perp(:,i)*Dot_product(tau,sp% perp(:,i))
       Enddo
       !!
       !!
       !!
    Enddo issaloop
    !!
    Write(outfile,"(a,' ',72('-'))")Trim(mesg)
    Write(outfile,"(a,' Wyckoff position symmetry analysis ')")Trim(mesg)
    Write(outfile,"(a,' ')")Trim(mesg)
    Write(outfile,"(a,' Fixed by symmetry/user')")Trim(mesg)
    Write(outfile,"(a,' ')")Trim(mesg)
    Do issa=1,structure% nsort
       isa=structure% p_isst(issa)
       sp => forces% p_sitefreeparam(issa)
       If( sp% do_vary) Then 
          Write(outfile,"(a,' Q*Wyckoff(',a,',',a2,')=(',3(f12.5,1x),')')") &
               &Trim(mesg),Trim(intToChar10(issa))&
               &,structure% p_elements(issa)&
               &,sp% Qtau
       Else
          Write(outfile,"(a,' Q*Wyckoff(',a,',',a2,')=(',3(f12.5,1x),')')") &
               &Trim(mesg),Trim(intToChar10(issa))&
               &,structure% p_elements(issa)&
               &,structure% p_tau(:,isa)
       Endif
    Enddo
    Write(outfile,"(a,' ')")Trim(mesg)
    Write(outfile,"(a,' ')")Trim(mesg)
    Write(outfile,"(a,' Degrees of freedom=',a)")Trim(mesg)&
         &,Trim(intToChar10(forces% Ndegfree))
    Write(outfile,"(a,' ')")Trim(mesg)
    !!
    j=0
    Do issa=1,structure% nsort
       sp => forces% p_sitefreeparam(issa)
       If( .Not. sp% do_vary) Cycle
       Do i=1,sp% nparal
          j=j+1
          Write(outfile,"(a,' P(',a,')=Wyckoff(',a,',',a2,')&
               &*(',3(f12.5,1x),')')") &
               &Trim(mesg),Trim(intToChar10(j)),Trim(intToChar10(issa))&
               &,structure% p_elements(issa)&
               &,sp% paral(:,i)

       Enddo
    Enddo
    Write(outfile,"(a,' ',72('-'))")Trim(mesg)
    !!
    !!
    !!paranoia
    Do issa=1,structure% nsort
       sp => forces% p_sitefreeparam(issa)
       If(.Not. sp% do_vary) Cycle
       isa=structure% p_isst(issa)
       tau=structure% p_tau(:,isa)
       !!
       tt=sp% Qtau
       Do i=1,sp% nparal
          tt=tt+sp% paral(:,i)*Dot_product(sp% paral(:,i),tau)
       Enddo
       !!
       If(Any(Abs(tau-tt)>tol))Then
          Write(outfile,"(a,' tau= ',3(e30.15e3,1x))")Trim(mesg)&
               &,tau
          Write(outfile,"(a,' t  = ',3(e30.15e3,1x))")Trim(mesg)&
               &,tt
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Decomposition is faulty !?'")
       Endif
       !!
    Enddo
    !!
    If(partial_vary)Then
       !!
       Do issa=1,structure% nsort
          sp => forces% p_sitefreeparam(issa)
          If(.Not. sp% do_vary)Then
             st% issashift=issa
             Exit
          Endif
       Enddo
       isashift=structure% p_isst(st% issashift)
       !!
       !!
    Else
       forces% Ndegfree=forces% Ndegfree-st% nparal
    Endif
    !Stop
    !!
    Return
    !!
2   Format(a,' ')
    !!
  End Subroutine symanalyse_sites

  !!***********************************************************************
  
End Module forces
  
