!! TODO: check if checkin and checkout form unity operation !!! with a full dens!!
Module fplodriver
  !!
  Use precisiondefs
  Use file_iounits
  Use errors
  Use titeration
  Use fplodata
  Use clock
  Use atomdefs
  Use trelativistic
  Use tio
  Use terg
  Use tforces
  Use ioaux
  Use memory
  Use tpotentialdensity
  Use tmesh
  Use orbitalbasis
  Use densio
  Use fplostep
  Use optionstest
  Use io
  Use lsdau
  Use tlsdau
  Use tdiracdefs
  Use tsymmetry
  Use tmol
  Use topc
  Use opcorrection
  Use torbitalbasis
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="FPLODRIVER"  
  !!
  Public :: sccfplo
  !!***********************************************************************
  !!
  !! global data for scfplo, must be retained in subsequent calls
  Logical(t_log) :: addU=.False.
  Logical(t_log) :: addOPC=.False.
  Logical(t_log) :: single=.False.
  Logical(t_log) :: addBfsm=.False.
  Integer(t_int) :: nU !! number of lsda+u parameter
  Integer(t_int) :: nOPC !! number of OPC parameter
  Integer(t_int) :: restart
  Real(t_real),Parameter :: Bfsmfactor=1.0e0_t_real
  !!***********************************************************************
  Integer(t_int),Parameter ::it_checkin =1_t_int
  Integer(t_int),Parameter ::it_checkout=0_t_int
  !!***********************************************************************
  
Contains
  !!***********************************************************************
  !! iteration control handler
  Subroutine sccfplo(Data,Entry)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)       ::Entry
    Type(T_iteration),Intent(inout) :: Data
    !!LOCAL
    Character(*),Parameter  :: nsubfunc="sccfplo"
    Character(*),parameter  :: cpumesg1='total fplo calculation'
    Character(*),parameter  :: cpumesg2='fplo cycle'
    Integer(t_int) :: sumnlmpnrp,isa
    Logical(t_log) :: calc_forces
!!    Logical(t_log) :: stopit
!!$    Character(100) :: mode
!!$    Logical(t_log) :: exists

    data% erg=0.0_t_real

    calc_forces=(g_forces% force_mode /= FORCE_MODE_NONE)

    !!------------------------------------------------------
1   Format(72('='),/,15('-'),' START ',a,'(',a,')',a)
    If(outlevel>L_many)&
         &Write(outfile,1)nsubfunc&
         &,Trim(iteration_entries(Entry))&
         &,Repeat('-',72_t_int-15_t_int-9_t_int-Len(nsubfunc)&
         &-Len(Trim(iteration_entries(Entry))))
    
    If(Entry==it_entry_init)Then
       !!------------------------------------------------------
       !! put initialization of iteration scheme here 
       !! make what ever you want to do first
       !!------------------------------------------------------
       
       !! initialize 


       Call watch(cpumesg1,cpu_start,reset=.True.)     

       !! START LSDA+U
       addU=g_lsdau% lsdau
       nU=g_lsdau% n_u_it
       !! END LSDA+U
       !! START OPC
       addOPC=g_opc% make_opc
       nOPC=2_t_int * (g_opc% nodef) * 2_t_int
       !! END OPC
       !! START FREL FSM
       addBfsm=((g_relativistic==FULL_RELATIVISTIC).And.(g_kohnsham% fsm))
       !! END FREL FSM
       !!
       !! total iteration step counter, for output 
       
       data%scheme=g_iteration_control % scheme
       
       !! return and let iteration module make default settings
    Elseif(Entry==it_entry_prepare)Then
       !!------------------------------------------------------
       !! put initialization of iteration control settings here 
       !! make what ever you want to do before checkin of initial data
       !!------------------------------------------------------
       
       !! dimension of vector


       sumnlmpnrp=0
       Do isa=1,g_structure% nsite
          sumnlmpnrp=sumnlmpnrp&
               &+g_potential% p_nlmp(isa)&
               &*g_potential% p_pmeshs(g_structure% p_isrt(isa))% nr
       Enddo ! isa
       
 
       data%vecdim= sumnlmpnrp * g_mspin 
 
       !!START LSDA+U
       If(addU)Then
          data%vecdim=data%vecdim + nU 
       End If
       !!END LSDA+U
       !!START OPC
       If(addOPC)Then
          data%vecdim=data%vecdim + nOPC 
       End If
       !!END OPC
       !!START FREL FSM
       If(addBfsm)Then
          data%vecdim=data%vecdim + 1 
       End If
       !!END FREL FSM
       
       data%tolerance=g_iteration_control % tolerance
       data%maxdim=g_iteration_control % maxdim
       data%mixing=g_iteration_control % mixing
       data%progress=g_iteration_control % progress
       data%steps   =g_iteration_control % steps
       data%convcond =g_iteration_control % convcond

       single=.False.
       If(data%steps==1_t_int)single=.True.
       
       !! return and let iterate initialize arrays
    Elseif(Entry==it_entry_startdata)Then
       !!------------------------------------------------------
       !! initialize iteration vector
       !!------------------------------------------------------

       !! put density into vector
       Call checkinout(it_checkin,Data,data% vector,g_mspin&
            &,g_structure&
            &,g_potential% p_pmeshs,g_potential% nrp,g_potential% mlmp&
            &,g_potential% p_nlmp,g_potential% p_lcd&
            &,addU,g_lsdau,g_relativistic&
            &,addOPC,g_opc&
            &,g_symmetry,g_Ufactor,g_OPCfactor,addBfsm,g_kohnsham% Bfsm&
            &)

       data%reset=.False.
       restart=0_t_int


       !! return and let iteration module start the scheme
    Elseif(Entry==it_entry_loop)Then
       !!------------------------------------------------------
       !! this is one step of iteration loop which transforms
       !! old vector into new vector
       !!------------------------------------------------------
       data%reset=.False.       
       
       Call watch(cpumesg2,cpu_start,reset=.True.)            
       !!
       !! get density from vector
       Call checkinout(it_checkout,data,data% vector,g_mspin&
            &,g_structure&
            &,g_potential% p_pmeshs,g_potential% nrp,g_potential% mlmp&
            &,g_potential% p_nlmp,g_potential% p_lcd&
            &,addU,g_lsdau,g_relativistic&
            &,addOPC,g_opc&
            &,g_symmetry,g_Ufactor,g_OPCfactor,addBfsm,g_kohnsham% Bfsm&
            &)
       
       If(.Not.single)Then
          Call denswrite(g_compound,g_structure,g_mspin&
               &,g_potential% p_pmeshs,g_potential% nrp,g_kohnsham% efermi&
               &,g_kohnsham% Bfsm&
               &,g_potential % mlmp,g_potential % p_nlmp,g_potential % p_lmp&
               &,g_potential % p_lcd,g_opc,g_lsdau,g_relativistic,.False.&
               !&,g_bzone&
               &)
          
          
       End If
       


       !! one cycle of iteration       

       Call fplo_step(g_symmetry,g_structure,g_lattice&
            &,g_potential,g_mspin,g_numerics&
            &,data%step,g_basis&
            !&,g_sic&
            &,g_relativistic,g_quant&
            &,g_kohnsham,g_bzone,g_bandplot,g_ldos,g_BEB&
            !&,g_cpacontrol,g_trace&
            &,g_etotstack,g_etot,g_forces,g_lsdau&
            &,g_opc,g_mol,g_loi,g_wannier,g_unfold,g_bwdefs&
            &,g_gridplot,data%deviation&
            &,restart,g_forces% force_in_each_step .And. calc_forces&
            &,g_stm,g_optics,g_topoins)

       data%letsstop =g_etotstack% etotconv

       If(.Not.single)Then
          Call denswrite(g_compound,g_structure,g_mspin&
               &,g_potential% p_pmeshs,g_potential% nrp,g_kohnsham% efermi&
               &,g_kohnsham% Bfsm&
               &,g_potential % mlmp,g_potential % p_nlmp,g_potential % p_lmp&
               &,g_potential % p_lcd,g_opc,g_lsdau,g_relativistic,.False.&
               !&,g_bzone&
               &)
       Else
!!$          Inquire(file='=.delta_n',exist=exists)
!!$          If(exists)Then
!!$             Open(12,file='=.delta_n')
!!$             Read(12,*)
!!$             Read(12,*) mode
!!$             Close(12)
!!$          Else
!!$             mode='none'
!!$          Endif
!!$          
!!$          If(Trim(mode)=='prep') Then
!!$             Call denswrite(g_compound,g_structure,g_mspin&
!!$                  &,g_potential% p_pmeshs,g_potential% nrp,g_efermi&
!!$                  &,g_kohnsham% Bfsm&
!!$                  &,g_potential % mlmp&
!!$                  &,g_potential % p_nlmp,g_potential % p_lmp&
!!$                  &,g_potential % p_lcd,g_opc,g_lsdau,g_relativistic,.False.&
!!$                       !&,g_bzone&
!!$                       &)
!!$             Print *,'wrote =.dens'
!!$          Endif
          Call terminate(TERM_FINISH,'single step calculation')
       End If
       
      
       !! put density into vector
       Call checkinout(it_checkin,data,data% vector,g_mspin&
            &,g_structure&
            &,g_potential% p_pmeshs,g_potential% nrp,g_potential% mlmp&
            &,g_potential% p_nlmp,g_potential% p_lcd&
            &,addU,g_lsdau,g_relativistic&
            &,addOPC,g_opc&
            &,g_symmetry,g_Ufactor,g_OPCfactor,addBfsm,g_kohnsham% Bfsm&
            &)

       Call watch(cpumesg2,cpu_stop,delete=.True.,print=.True.)         

       !!     check possible convergence problems, restart 'ITERAT'

       If(restart==1)Then
          Call errmsg(nmodule,nsubfunc,E_warning&
               &,msg="/,'Restart required: restart iteration!'")
          restart=0_t_int
          data%reset=.True.          
       Endif

       !! return and let iteration module proceed
    Elseif(Entry==it_entry_exit)Then
       !!------------------------------------------------------
       !! this is called before vector is destroyed
       !! make cleanup work
       !!------------------------------------------------------

       !! here the last dens should be present

       !! but this is not the most succesfull, which is the input dens
       !! of the previous step
       !! get density from vector
       Call checkinout(it_checkout,data,data% vector,g_mspin&
            &,g_structure&
            &,g_potential% p_pmeshs,g_potential% nrp,g_potential% mlmp&
            &,g_potential% p_nlmp,g_potential% p_lcd&
            &,addU,g_lsdau,g_relativistic&
            &,addOPC,g_opc&
            &,g_symmetry,g_Ufactor,g_OPCfactor,addBfsm,g_kohnsham% Bfsm&
            &)

       If(.Not.single)Then
          Call denswrite(g_compound,g_structure,g_mspin&
               &,g_potential% p_pmeshs,g_potential% nrp,g_kohnsham% efermi&
               &,g_kohnsham% Bfsm&
               &,g_potential % mlmp,g_potential % p_nlmp,g_potential % p_lmp&
               &,g_potential % p_lcd,g_opc,g_lsdau,g_relativistic,.False.&
               !&,g_bzone&
               &)
          
          
       End If
       
       !! calc forces
       If(calc_forces) Then
          Call fplo_step(g_symmetry,g_structure,g_lattice&
               &,g_potential,g_mspin,g_numerics&
               &,data%step,g_basis&
               !&,g_sic&
               &,g_relativistic,g_quant&
               &,g_kohnsham,g_bzone,g_bandplot,g_ldos&
               &,g_BEB&
               !&,g_cpacontrol,g_trace&
               &,g_etotstack,g_etot,g_forces,g_lsdau&
               &,g_opc,g_mol,g_loi,g_wannier,g_unfold,g_bwdefs,g_gridplot&
               &,data%deviation,restart,.True.,g_stm,g_optics&
               &,g_topoins)
       Endif
       
       Call watch(cpumesg1,cpu_stop,delete=.True.,Print=.True.)
       
       
       !! return and let iteration module cleanup
    Elseif(Entry==it_entry_best)Then
       !!------------------------------------------------------
       !! this is called if a new better iteration vector was found
       !! but only in LCITERAT method
       !!------------------------------------------------------
    Else
       !!------------------------------------------------------
       !! some new action was implemented in moedule iteration
       !!------------------------------------------------------
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'unknown iteration entry!'")
       
    Endif
    !! Ciao
2   format(15('-'),' END   ',a,'(',a,')',a,/,72('='))
    If(outlevel>L_many)&
         &Write(outfile,2)nsubfunc&
         &,Trim(iteration_entries(Entry))&
         &,Repeat('-',72_t_int-15_t_int-9_t_int-Len(nsubfunc)&
         &-Len(Trim(iteration_entries(Entry))))
    !!
    !!
  End Subroutine sccfplo
  !!***********************************************************************
  
  !!***********************************************************************
  !! put/get density into/from iteration vector
  !!***********************************************************************
  Subroutine checkinout(in,ic,vit,mspin,structure&
       &,pmeshs,nrp,mlmp,nlmp,lcd&
       &,addU,lsdau,relativistic,addOPC,opc&
       &,symmetry,Ufactor,OPCfactor,addBfsm,Bfsm&
       &)
    !!
    Implicit None
    !!IO
    Type(T_Lsdau),Intent(inout) :: lsdau
    Type(T_OPC),Intent(inout)   :: opc
    Type(T_Symmetry),Intent(in) :: symmetry
    Type(T_Structure),Intent(in):: structure
    Type(T_Mesh),Pointer        :: pmeshs(:)
    Type(T_iteration),Intent(inout) :: ic
    Integer(t_int),Intent(in)   :: in,mspin,mlmp,nlmp(*),nrp
    Logical(t_log),Intent(in)   :: addU,addOPC,addBfsm
    Integer(t_int),Intent(in)   :: relativistic
    Real(t_real),Intent(inout)  :: lcd(nrp,mlmp,structure% nsite,mspin)
    Real(t_real),Intent(inout)  :: vit(:)
    Real(t_real),Intent(in)     :: Ufactor,OPCfactor
    Real(t_real),Intent(inout)  :: Bfsm
    !!LOCAL
    Character(*),Parameter::nsubfunc="checkinout"
    Integer(t_int) :: isa,n,j,nr
    Logical(t_log) :: rel
    Type(T_Mesh),Pointer :: pmesh
    Real(t_real),Pointer :: p_rfac(:)
!!!    Integer(t_int) :: nsave
    !!
    Nullify(p_rfac)
    !!
    n=ic% vecdim!! avoid warning
    rel=(relativistic==FULL_RELATIVISTIC)
    !!
    !!
    Call palloc('p_rfac',p_rfac,1_t_int,nrp,nmodule,nsubfunc)
    
    checkif: If (in==it_checkout) Then
       lcd=0.0_t_real
       n=1
       spinif1: If(mspin ==  1) Then
          Do isa=1,structure% nsite
             pmesh => pmeshs(structure% p_isrt(isa))
             nr=pmesh% nr
             p_rfac(2:nr)=Sqrt(pmesh% p_jmesh(2:nr)/pmesh% p_rmesh(2:nr)**2/structure% vuc)
             Do j=1,nlmp(isa)
                lcd(2:nr,j,isa,1)=vit(n+1:n+nr-1)/p_rfac(2:nr)
                n=n+nr
             Enddo
          Enddo ! isa
       Else
          Do isa=1,structure% nsite
             pmesh => pmeshs(structure% p_isrt(isa))
             nr=pmesh% nr
             p_rfac(2:nr)=Sqrt(pmesh% p_jmesh(2:nr)/pmesh% p_rmesh(2:nr)**2/structure% vuc)
             Do j=1,nlmp(isa)
                lcd(2:nr,j,isa,1)=vit(n+1:n+nr-1)/p_rfac(2:nr)*0.5_t_real
                lcd(1:nr,j,isa,2)=lcd(1:nr,j,isa,1)
                n=n+nr
             Enddo
          Enddo                   ! isa
          Do isa=1,structure% nsite
             pmesh => pmeshs(structure% p_isrt(isa))
             nr=pmesh% nr
             p_rfac(2:nr)=Sqrt(pmesh% p_jmesh(2:nr)/pmesh% p_rmesh(2:nr)**2/structure% vuc)
             Do j=1,nlmp(isa)
                lcd(2:nr,j,isa,1)=lcd(2:nr,j,isa,1)+vit(n+1:n+nr-1)&
                     &/p_rfac(2:nr)*0.5_t_real
                lcd(2:nr,j,isa,2)=lcd(2:nr,j,isa,2)-vit(n+1:n+nr-1)&
                     &/p_rfac(2:nr)*0.5_t_real
                n=n+nr
             Enddo                 !
          Enddo                   ! isa
       Endif spinif1 ! mspin .eq. 2
       !!
       !!
       !!
       !!START LSDA+U
       addUif1: If(addU)Then
5         Format('U-checkout: ')
          If(outlevel>=L_many) Write(outfile,5)
          !!
          Call lsda_scmp (lsdau,symmetry,structure,rel &
               &,mspin,vit,n,Ufactor/structure% vuc)
          !!
          !!
          !!       
       Endif addUif1
       !!END LSDA+U

       !!START OPC
       addOPCif1: If(addOPC)Then
15         Format('OPC-checkout: ')
          If(outlevel>=L_many) Write(outfile,15)
          !!
          Call opc_checkout (opc,vit,n,OPCfactor/structure% vuc)
          !!
          !!       
       Endif addOPCif1
       !!END OPC
 
       !!START FREL FSM
       addBfsmif1: If(addBfsm)Then
25        Format('Bfsm-checkout: ')
          If(outlevel>=L_many) Write(outfile,25)
          !!
          Bfsm=vit(n)/Bfsmfactor
          !!
          n=n+1
          !!       
       Endif addBfsmif1
       !!END FREL FSM
      
    Else! checkin: vector=dens
       
       n=1
       If(mspin == 1) Then
          Do isa=1,structure% nsite
             pmesh => pmeshs(structure% p_isrt(isa))
             nr=pmesh% nr
             p_rfac(2:nr)=Sqrt(pmesh% p_jmesh(2:nr)/pmesh% p_rmesh(2:nr)**2/structure% vuc)
             p_rfac(1)=0.0_t_real
             Do j=1,nlmp(isa)
                vit(n:n+nr-1)=lcd(1:nr,j,isa,1)*p_rfac(1:nr)
                n=n+nr
             Enddo !
          Enddo ! isa
       Else ! mspin ==2 
          Do isa=1,structure% nsite
             pmesh => pmeshs(structure% p_isrt(isa))
             nr=pmesh% nr
             p_rfac(2:nr)=Sqrt(pmesh% p_jmesh(2:nr)/pmesh% p_rmesh(2:nr)**2/structure% vuc)
             p_rfac(1)=0.0_t_real
             Do j=1,nlmp(isa)
                vit(n:n+nr-1)=(lcd(1:nr,j,isa,1)+lcd(1:nr,j,isa,2))&
                     &*p_rfac(1:nr)
                n=n+nr
             Enddo !
          Enddo ! is
          Do isa=1,structure% nsite
             pmesh => pmeshs(structure% p_isrt(isa))
             nr=pmesh% nr
             p_rfac(2:nr)=Sqrt(pmesh% p_jmesh(2:nr)/pmesh% p_rmesh(2:nr)**2/structure% vuc)
             p_rfac(1)=0.0_t_real
             Do j=1,nlmp(isa)
                vit(n:n+nr-1)=(lcd(1:nr,j,isa,1)-lcd(1:nr,j,isa,2))&
                     &*p_rfac(1:nr)
                n=n+nr
             Enddo !
          Enddo ! is
       Endif
       !!
       !!START LSDA+U
       !! add U density matrix to x vector
       addUif2: If(addU)Then


9         format('U-checkin: ')
          If(outlevel>=L_many) Write(outfile,9)

          Call lsda_sdcmp(lsdau,rel,mspin,vit,n,Ufactor/structure% vuc)

       Endif addUif2
       !!END LSDA+U
       !!
       !!START OPC
       !! add OPC parameter to x vector
       addOPCif2: If(addOPC)Then
19        Format('OPC-checkin: ')
          If(outlevel>=L_many) Write(outfile,19)
          !!
          Call opc_checkin (opc,vit,n,OPCfactor/structure% vuc)
          !!
          !!
       Endif addOPCif2
       !!END OPC
       !!START FREL FSM
       addBfsmif2: If(addBfsm)Then
35        Format('Bfsm-checkin: ')
          If(outlevel>=L_many) Write(outfile,35)
          !!
          vit(n)=Bfsm*Bfsmfactor
          !!
          n=n+1
          !!       
       Endif addBfsmif2
       !!END FREL FSM
    Endif checkif
    !!
    Call pfree(p_rfac)
    !!
!PROT: 134 Format('sort ',i5,1x,a2,1x,i1,a1,f10.5)
!PROT: 135 Format('checkin sort ',i5,1x,a2,1x,i1,a1,f10.5)
!PROT: 136 Format('checkout  sort ',i5,1x,a2,1x,i1,a1,f10.5)
!PROT: 137 Format(' also set sort ',i5,1x,a2,1x,i1,a1)
    !!
  End Subroutine checkinout
  !!***********************************************************************
  
End Module fplodriver
