Module fploiointernal
  !!
  Use precisiondefs
  Use file_iounits
  Use errors
  Use atomdefs
  Use tio
  Use ioaux
  Use ioadapter
  Use versioncontrol
  Use xc
  Use ttopoins
  Use terg
  Use tforces
  Use tgrid
  Use tfatband
  Use tmol
  Use tdiracdefs
  Use tsymmetry
  Use toptics
  Use symmetry
  Use tnumerics
  Use titeration
  Use trelativistic
  Use tpotentialdensity
  Use tbzone
  Use tbandplot
  Use finuc
  Use torbitalbasis
  Use tkohnsham
  Use tmesh
  Use optionstest
  Use tcpa
  Use tlsdau
  Use topc
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="FPLOIOINTERNAL"  
  !!
  Public :: create_infile,fploheader,create_symfile,write_pid&
       &,makeNegativeString,makePositiveString,create_develfile
  !!***********************************************************************
contains
  !!***********************************************************************
  ! create_infile
  ! {{{ 

  Subroutine create_infile(compound &
    &,spgrpnum&
    &,nugen,iugen&
    
         &,structure&
         &,lattice_constants_S&
         &,axis_angles_S&
         &,IOwtau_S&
         &,max_L&
         
    &,structure_conao&
         &,mspin,initial_spin_split&
         &,radialmesh_nr,radialmesh_rmin,radialmesh_rmax,radialmesh_rmaxfactor&
         &,atommesh_nr,atommesh_rmin,atommesh_rmax&
         &,nuc_type&
         &,numerics&
         &,numerics_cuttol_dens,numerics_cuttol_pot,numerics_cuttol_orbital&
         &,numerics_eweps_r,numerics_eweps_g&
         &,relativistic&
         !&,quant&
         &,quant_axis_S&
         !&,diracdefs&
         &,options,outlevel &
         &,cpacontrol,cpacontrol_eimagdos,cpacontrol_eimagscf&
         &,cpacontrol_efermi0,cpacontrol_slop_0,cpacontrol_slop_min&
         &,cpacontrol_emin0,cpacontrol_emax0&
         &,fsm_moment,fsm,bzone&
         &,bzone_mp_range,bzone_mp_width,bzone_kT&
!         &,basis_exn0&
         &,spin_split,bandplotcontrol,bandplot_emin,bandplot_emax&
         &,bandplot_z_axis,bandplot_x_axis&
         &,bandplot_npoints,bandplot_labels,bandplot_points,ldos&
         &,core_occupation_count&
         &,core_occupation_sort,core_occupation_state&
         &,core_occupation_spinup,core_occupation_spindn&
         !
         &,iteration_control,iteration_control_tolerance_S&
         &, iteration_control_mixing_S&
         &, iteration_control_progres_S  &
         !
         &,forces,force_iteration_control_tol_S&
         !
         &,etotstack_etot_tolerance,etot&
         &,symtesttol_S,kohnsham,opc,lsdau,lsdau_omat_dev_S,lsdau_u_f&
         &,xcvers,Ufactor_S&
         &,gridplot,bwdefs,direction1_S,direction2_S,direction3_S,origin_S&
         &,kpoint_S,eminmax_S,topoins,potential,potential_xreduce_S&
         &,potential_molecule_ionicity_S,vcaZ_S&
         &,optics,optics_emin_S,optics_emax_S)
    !!
    Implicit None 
    !!IO
    !! symmetry 
    Integer(t_int),Intent(in) :: spgrpnum,nugen,iugen(:)
    Integer(t_int),Intent(in)    :: radialmesh_nr,xcvers
    Character(*),Intent(in)     :: radialmesh_rmin,radialmesh_rmax
    Character(*),Intent(in)     :: radialmesh_rmaxfactor
    Integer(t_int),Intent(in)    :: atommesh_nr
    Character(*),Intent(in)     :: atommesh_rmin,atommesh_rmax
    Character(*),Intent(in)     :: lsdau_omat_dev_S,Ufactor_S
    Character(*),Intent(in)     :: lsdau_u_f(:,:)
    Character(*),Intent(in)   :: lattice_constants_S(3)
    Character(*),Intent(in)   :: axis_angles_S(3),quant_axis_S(3)
    Character(*),Intent(in)   :: symtesttol_S,iteration_control_tolerance_S
    Character(*),Intent(in)   :: force_iteration_control_tol_S
    Character(*),Intent(in)   :: iteration_control_mixing_S
    Character(*),Intent(in)   :: iteration_control_progres_S  
    Character(*),Intent(in)   :: bandplot_emin,bandplot_emax
    Character(*),Intent(in)   :: bandplot_z_axis(3),bandplot_x_axis(3)
    Character(*),Intent(in)   :: numerics_cuttol_dens,numerics_cuttol_pot
    Character(*),Intent(in)   :: numerics_cuttol_orbital
    Character(*),Intent(in)   :: numerics_eweps_r
    Character(*),Intent(in)   :: numerics_eweps_g
    Integer(t_int),Intent(in) ::  nuc_type
!    Character(*),Intent(in)   :: basis_exn0
    Character(*),Intent(in)   :: cpacontrol_eimagdos,cpacontrol_eimagscf
    Character(*),Intent(in)   :: cpacontrol_efermi0,cpacontrol_slop_0
    Character(*),Intent(in)   :: cpacontrol_slop_min
    Character(*),Intent(in)   :: cpacontrol_emin0,cpacontrol_emax0
    Character(*),Intent(in)   :: bzone_mp_range,bzone_mp_width,bzone_kT
    Character(*),Intent(in)   :: bandplot_points(:,:)
    Character(*),Intent(in)   :: bandplot_labels(:)
    Character(*),Intent(in)   :: core_occupation_spinup(:,:)
    Character(*),Intent(in)   :: core_occupation_spindn(:,:)
    Character(*),Intent(in)   :: vcaZ_S(:)
    Integer(t_int),Intent(in)  :: core_occupation_sort(:)
    Integer(t_int),Intent(in)  :: core_occupation_count
    Character(*),Intent(in)   :: core_occupation_state(:)
    Character(*),Intent(in)    :: potential_xreduce_S
    Character(*),Intent(in)    :: potential_molecule_ionicity_S
    Character(*),Intent(in)    :: optics_emin_S
    Character(*),Intent(in)    :: optics_emax_S
    Integer(t_int),Intent(in)  :: bandplot_npoints
    !! structure
    Type(T_Structure),Intent(in)  ::structure
    Character(*),Intent(in)     :: IOwtau_S(:,:)
    Type(T_Numerics),Intent(in)  :: numerics
    Type(T_Etot),Intent(in)  :: etot
    Type(T_Forces),Intent(in)  :: forces
    Type(T_TopoIns),Intent(in)  :: topoins
    !Type(T_Quant),Intent(in)    :: quant
    !Type(T_Diracdefs),Intent(in):: diracdefs
    Type(T_Potential),Intent(in) :: potential
    Type(T_Options),Intent(in)  :: options
    Type(T_Cpacontrol),Intent(in)  :: cpacontrol
    Type(T_Bzone),Intent(in)  :: bzone  
    Type(T_Bandplot),Intent(in):: bandplotcontrol
    Type(T_LDOS),Intent(in)     :: ldos
    Integer(t_int),Intent(in)    :: max_L
    Type(T_iteration),Intent(in):: iteration_control
    Type(T_Kohnsham),Intent(in) :: kohnsham
    Type(T_Lsdau),Intent(in)    :: lsdau
    Type(T_OPC),Intent(in)      :: opc
    Type(T_GridPlot),Intent(in) :: gridplot
    Type(T_BWDefs),Intent(in)   :: bwdefs
    Type(T_Optics),Intent(in)   :: optics
    Character(*),Pointer        :: direction1_S(:,:)
    Character(*),Pointer        :: direction2_S(:,:)
    Character(*),Pointer        :: direction3_S(:,:)
    Character(*),Pointer        :: origin_S(:,:)
    Character(*),Pointer        :: kpoint_S(:,:,:)
    Character(*),Pointer        :: eminmax_S(:,:,:)

    Character(*),Intent(in)     :: etotstack_etot_tolerance
    Character(*),Intent(in)  :: compound
    Integer(t_int),Intent(in)  :: relativistic,outlevel
    Integer(t_int),Intent(in)  :: mspin
    Logical(t_log),Intent(in) :: initial_spin_split
    Character(*),Intent(in)   :: fsm_moment
    Logical(t_log),Intent(in)        :: fsm
    Character(*),Intent(in)   :: spin_split(:)
    Character(*),Intent(in)   :: structure_conao(:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="create_infile"
    Integer(t_int) ::  lunit
    !!
    lunit=12_t_int
    !!
    Open(lunit,file=f_fplo_in)
    Write(lunit,"(a)")&
         &"########################################################################"&
         &,"# this file is part of the FPLO bandstructure package"&
         &,"# it was created automatically"&
         &,"# please dont delete this file nor"&
         &,"# edit it directly, unless you really know what you are doing"&
         &,"# Use FEDIT to change its content"&
         &,"#"&
         &,"########################################################################"
    Write(lunit,"(/,/)")
    !! SECTION header
    Write(lunit,"('section header{')")  
    Call write_version(lunit)
    Call write_changed(lunit)
    Write(lunit,"('  char[*] compound=""',a,'"";')") Trim(compound)
    Write(lunit,"('};',/)") 


    Call write_structure_information(lunit&
         &,spgrpnum,nugen,iugen&
         &,structure,IOwtau_S &
         &,lattice_constants_S,axis_angles_S,max_L)

    Call write_structure_dependend(lunit,structure,structure_conao&
         &,spin_split,core_occupation_count&
         &,core_occupation_sort,core_occupation_state&
         &,core_occupation_spinup,core_occupation_spindn&
         &,bandplot_npoints,bandplot_labels,bandplot_points)

    Call write_mesh(lunit&
         &,radialmesh_nr,radialmesh_rmin,radialmesh_rmax,radialmesh_rmaxfactor&
         &,atommesh_nr,atommesh_rmin,atommesh_rmax&
         &)

    Call write_brillouin(lunit,bzone&
         &,bzone_mp_range,bzone_mp_width,bzone_kT&
         &,kohnsham% io_nband)
    Call write_bandstructure_plot(lunit,bandplotcontrol,bandplot_emin&
         &,bandplot_emax,bandplot_z_axis,bandplot_x_axis,bwdefs)
    Call write_iteration_control(lunit,iteration_control&
         &,etotstack_etot_tolerance&
         &,iteration_control_tolerance_S&
         &,iteration_control_mixing_S&
         &,iteration_control_progres_S&
         &,Ufactor_S )
    Call write_force_iteration_control(lunit,forces&
         &,force_iteration_control_tol_S)
    Call write_options(lunit,mspin,initial_spin_split,relativistic&
         !&,quant&
         &,quant_axis_S,options&
         &,outlevel,fsm_moment,fsm,etot% etot_calc,xcvers,nuc_type&
         &,potential,potential_xreduce_S,potential_molecule_ionicity_S,vcaZ_S)

    Call write_cpa(lunit,cpacontrol&
         &,cpacontrol_eimagdos,cpacontrol_eimagscf&
         &,cpacontrol_efermi0,cpacontrol_slop_0,cpacontrol_slop_min&
         &,cpacontrol_emin0,cpacontrol_emax0&
         &)
    Call write_numerics(lunit,numerics&
         &,numerics_cuttol_dens,numerics_cuttol_pot,numerics_cuttol_orbital&
         &,symtesttol_S&
         !&,basis_exn0&
         &,numerics_eweps_r,numerics_eweps_g)
    Call write_lsdau(lunit,lsdau,lsdau_omat_dev_S,lsdau_u_f)
    Call write_opc(lunit,opc)
    Call write_advancedoutput(lunit,ldos,gridplot,direction1_S,direction2_S&
         &,direction3_S,origin_S,kpoint_S,eminmax_S,topoins&
         &,optics,optics_emin_S,optics_emax_S)
    Close (lunit)
  End Subroutine create_infile

  ! }}}


  !!***********************************************************************
  !!***********************************************************************
  Subroutine create_symfile(status,compound&
       &,spgrpnum&
       &,nugen,iugen&
       &,structure&
       &,lattice_constants_S&
       &,axis_angles_S&
       &,IOwtau_S&
       )
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)  :: spgrpnum
    Integer(t_int),Intent(in)    :: nugen,iugen(:)
    Character(*),Intent(in)   :: lattice_constants_S(3)
    Character(*),Intent(in)   :: axis_angles_S(3)
    Type(T_Structure),Intent(in)  :: structure
    Character(*),Intent(in)     :: IOwtau_S(:,:)
    Character(*),Intent(in)  :: status
    Character(*),Intent(in)  :: compound
    !!LOCAL
    !Character(*),Parameter::nsubfunc="create_symfile"
    Integer(t_int) :: lunit
    !!
    lunit=12_t_int
    !!
    Open(lunit,file=f_fplo_sym)
    Write(lunit,"(a)")&
         &"########################################################################"&
         &,"# this file is part of the FPLO bandstructure package"&
         &,"# it was created automatically"&
         &,"# please dont delete this file nor"&
         &,"# edit it directly, unless you really know what you are doing"&
         &,"# Use FEDIT to change its content"&
         &,"#"&
         &,"########################################################################"
    Write(lunit,"(/,/)")
    !! SECTION header
    Write(lunit,"('section header{')")  
    Call write_version(lunit)
    Call write_changed(lunit)
    Call write_status(lunit,Trim(status))
    Write(lunit,"('  char[*] compound=""',a,'"";')") Trim(compound)
    Write(lunit,"('};',/)") 

    Call write_structure_definition(lunit,spgrpnum,nugen,iugen(:)&
         &,structure,IOwtau_S &
         &,lattice_constants_S,axis_angles_S)


    Close (lunit)
  End Subroutine create_symfile
!!$  !!***********************************************************************
!!$  ! create_infile
!!$  Subroutine create_basisfile(IOnsort,IOelements,basis,basis_x0)
!!$    !!
!!$    Implicit None 
!!$    !!IO
!!$    !! symmetry 
!!$    Integer(t_int),Intent(in)  :: IOnsort
!!$    Character(2),Intent(in)   :: IOelements(IOnsort)
!!$    Character(*),Intent(in)   :: basis_x0(:,:)
!!$    Type(T_Basis),Intent(in)  :: basis
!!$    !!LOCAL
!!$    Logical(t_log) :: err
!!$    Character(*),Parameter::nsubfunc="create_basisfile"
!!$    Integer(t_int) :: lunit
!!$    !!
!!$    lunit=12_t_int
!!$    !!
!!$    err=.False.
!!$1   Format(/,72('-'),/,'Writing ',a,' ...!')
!!$    Write(outfile,1)Trim(f_fplo_basis)
!!$    Open(lunit,file=f_fplo_basis)
!!$2   Format(a)
!!$    Write(lunit,2)&
!!$         "########################################################################"&
!!$         ,"# this file is part of the FPLO bandstructure package"&
!!$         ,"# it was created automatically"&
!!$         ,"# please dont delete this file nor"&
!!$         ,"# edit it directly, unless you really know what you are doing"&
!!$         ,"# Use FEDIT to change its content"&
!!$         ,"#"&
!!$         ,"########################################################################"
!!$    !3   Format(/,/)
!!$    !Write(lunit,3)
!!$    !! SECTION header
!!$    Write(lunit,2)'section header{'
!!$    Call write_version(lunit)
!!$    Call write_changed(lunit)
!!$4   Format('};',/) 
!!$    Write(lunit,4) 
!!$
!!$
!!$    Call write_basis(lunit,IOnsort,IOelements,basis,basis_x0,err)
!!$
!!$    Close (lunit)
!!$5   Format('End Writing ',a,'!',/,72('-'),/)
!!$    Write(outfile,5)Trim(f_fplo_basis)
!!$!    If(err)Then
!!$!       Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$!            &,msg='"Valence class array is corrupted, please report to FPLO team??!"')
!!$!    Endif
!!$  End Subroutine create_basisfile
  !!***********************************************************************
  ! write_iteration_control
  ! {{{ 

  Subroutine write_iteration_control(lunit,iteration_control&
       &,etotstack_etot_tolerance,iteration_control_tolerance_S&
       &,iteration_control_mixing_S&
       &,iteration_control_progres_S  &
       &,Ufactor_S)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)   :: lunit
    Type(T_iteration),Intent(in):: iteration_control
    Character(*),Intent(in)     :: etotstack_etot_tolerance
    Character(*),Intent(in)     :: iteration_control_tolerance_S
    Character(*),Intent(in)     :: iteration_control_mixing_S
    Character(*),Intent(in)     :: iteration_control_progres_S  
    Character(*),Intent(in)     :: Ufactor_S
    !!LOCAL
    !Character(*),Parameter::nsubfunc="write_iteration_control"
    Write(lunit,"(//)") 
    Write(lunit,"('section iteration_control{')")  



    Write(lunit,"('  struct {int steps;real tolerance;&
         &real mixing;int maxdim;real progress;} iteration_control')")


    Write(lunit,"('  ={',i4,',',2(a,','),i4,',',a,'};')")&
         & iteration_control % steps &
         &,Trim(iteration_control_tolerance_S) &
         &,Trim(iteration_control_mixing_S) &
         &,iteration_control % maxdim &
         &,Trim(iteration_control_progres_S)

    Write(lunit,"('  struct {int scheme;char[*] description;} &
         &iteration_version')") 
    Write(lunit,"('  ={',i4,',""',a,'""};')") iteration_control % scheme&
         &,Trim(ITERATION_SCHEMES(iteration_control % scheme))

    Write(lunit,"('  struct {int type;char[*] description;} &
         &iteration_convergence_condition')") 
    Write(lunit,"('  ={',i4,',""',a,'""};')") iteration_control % convcond&
         &,Trim(ITERATION_CONVCONDITIONS(iteration_control % convcond))


    Write(lunit,"('  real etot_tolerance=',a,';')")&
         & Trim(etotstack_etot_tolerance  )

    Write(lunit,"('# ratio of things put into iteration vector compared ')")
    Write(lunit,"('# to density ')")
    Write(lunit,"('  struct{real U;} iterationvector_ratio={',a,'};')")&
         & Trim(Ufactor_S  )

    Write(lunit,"('};',/)") 
  End Subroutine write_iteration_control
  !!***********************************************************************
  Subroutine write_force_iteration_control(lunit,forces&
       &,force_iteration_control_tol_S)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: lunit
    Type(T_Forces),Intent(in)    :: forces
    Character(*),Intent(in)      :: force_iteration_control_tol_S
    !!LOCAL
    !Character(*),Parameter::nsubfunc="write_force_iteration_control"
    Integer(t_int) :: n,i
    !!
    Write(lunit,"(//)") 
    Write(lunit,"('section forces{')")  



    Write(lunit,"('  struct {int steps;real tolerance;int maxdim;}',/&
         &,'     force_iteration_control={',i4,',',a,',',i4,'};',/)")&
         & forces% forceiteration_control % steps &
         &,Trim(force_iteration_control_tol_S) &
         &,forces% forceiteration_control % maxdim 

    Write(lunit,"('  struct {int scheme;char[*] description;}&
         &force_iteration_version',/,'  ={',i4,',""',a,'""};',/)")&
         & forces% forceiteration_control% scheme&
         &,Trim(ITERATION_SCHEMES(forces% forceiteration_control% scheme))

    Write(lunit,"(/,'  logical force_in_each_step=',l1,';',/)")&
         &forces% force_in_each_step

    Write(lunit,"(/,'  logical approx_nodndL_ewald=',l1,';',/)")&
         &forces% approx_nodndL_ewald



    Write(lunit,"(/,'  struct {int mode;char[*] description;}&
         &force_mode',/,'  ={',i4,',""',a,'""};',/)")&
         &forces% force_mode&
         &,Trim(FORCE_MODES(forces% force_mode))

    Write(lunit,"('    int geomopt_sites[*]={')",advance='no')
    n=0
    Do i=1,forces% ngeomopt_sites
       n=n+1
       Write(lunit,"(a)",advance='no')&
            &Trim(intToChar20(forces% p_geomopt_sites(i)))
       If(n>=20)Then
          Write(lunit,"(/,'    ')",advance='no')
          n=0
       Endif
       if(i<forces% ngeomopt_sites) Write(lunit,"(',')",advance='no')
    Enddo
    If(n/=0) Write(lunit,"(/,'    ')",advance='no')
    Write(lunit,"('};')") 
    !!

    Write(lunit,"('};',/)") 
  End Subroutine write_force_iteration_control

  ! }}}
  !!***********************************************************************
  !!***********************************************************************
  ! write_bandstructure_plot
  ! {{{ 

  Subroutine write_bandstructure_plot(lunit,bandplotcontrol,bandplot_emin&
       &,bandplot_emax,bandplot_z_axis,bandplot_x_axis,bwdefs)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)   :: lunit
    Type(T_Bandplot),Intent(in):: bandplotcontrol
    Type(T_BWDefs),Intent(in):: bwdefs
    Character(*),Intent(in)    :: bandplot_emin,bandplot_emax
    Character(*),Intent(in)    :: bandplot_z_axis(3),bandplot_x_axis(3)
    !!LOCAL

    !Character(*),Parameter::nsubfunc="write_bandstructure_plot"
    Write(lunit,"(//)") 
    Write(lunit,"('section bandstructure_plot{')")  



    Write(lunit,"('  struct {logical bandplot;logical read_sympoints;&
         &int ndivisions;real emin;real emax;int nptdos;logical plot_idos;&
         &logical plot_ndos;logical restrict_bands_to_window;&
         &logical coeffout;}&
         & bandplot_control')")


    Write(lunit,"('  ={',2(l2,','),i4,',',a,',',a,',',i8,',',l2,',',l2,','&
         &,l2,',',l2,'};')")&
         & bandplotcontrol % plotbands &
         &,bandplotcontrol % read_sympoints &
         &,bandplotcontrol % ndiv &
         &,Trim(bandplot_emin) &
         &,Trim(bandplot_emax) &
         &,bandplotcontrol% nptdos&
         &,bandplotcontrol% plotidos&
         &,bandplotcontrol% plotndos&
         &,bandplotcontrol% output_bands_in_window&
         &,bandplotcontrol% coeffout




    Write(lunit,"('  struct {logical bandweights;logical bweight_rot;&
         &real z_axis[3];real x_axis[3];char[*] bwdfilename;&
         &struct{int type;char[*] description;}frelprojection;} &
         &bandweight_control')")


    Write(lunit,"('  ={',l2,',',l2,2(',{',2(a,','),a,'}'),',""',a&
         &,'"",{',i1,',""',a,'""}};')")&
         & bandplotcontrol % bandweights &
         &,bandplotcontrol % bweight_rot &
         &,Trim(bandplot_z_axis(1_t_int)) &
         &,Trim(bandplot_z_axis(2_t_int)) &
         &,Trim(bandplot_z_axis(3_t_int)) &
         &,Trim(bandplot_x_axis(1_t_int)) &
         &,Trim(bandplot_x_axis(2_t_int)) & 
         &,Trim(bandplot_x_axis(3_t_int))  &
         &,Trim(bwdefs% bwdfilename)  &
         &,FRELPROJECTION_JMU&
         &,Trim(FRELPROJECTION_TYPES(FRELPROJECTION_JMU))




    Write(lunit,"('};',/)") 
  End Subroutine write_bandstructure_plot

  ! }}}
  !!***********************************************************************
  !!***********************************************************************
  ! write_brillouin
  ! {{{ 

  Subroutine write_brillouin(lunit,bzone&
       &,bzone_mp_range,bzone_mp_width,bzone_kT&
       &,nband)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: lunit,nband
    Type(T_Bzone),Intent(in)    :: bzone
    Character(*),Intent(in)     :: bzone_mp_range,bzone_mp_width,bzone_kT
    !!LOCAL

    !Character(*),Parameter::nsubfunc="write_brillouin"
    Write(lunit,"(//)") 
    Write(lunit,"('section brillouin{')")  


    Write(lunit,"('  struct {logical metal;int nkxyz[3];} &
         &bzone_integration')")

    Write(lunit,"('  ={',l2,',{',2(i5,','),i5,'}};')") &
         &bzone % metal,bzone % nkxyz


    Write(lunit,"('  struct {int ne;real range;real width;int norder;}&
         &  mp_bzone_integration')")

    Write(lunit,"('  ={',i4,',',2(a,','),i4,'};')")&
         & 1001&
         &,bzone_mp_range&
         &,bzone_mp_width&
         &,bzone % mp_norder


    Write(lunit,"('  struct {int type;char[*] description;} bzone_method')")
    Write(lunit,"('  ={',i3,',""',a,'""};')") bzone % method &
         &,Trim(BZ_METHODS(bzone % method))



    Write(lunit,"('  real bzone_kT=',a,';')") bzone_kT
    
    Write(lunit,"('  int nband=',i6,';')") nband
    




    Write(lunit,"('};',/)") 
  End Subroutine write_brillouin

  ! }}}
  !!***********************************************************************
  ! write_structure_definition
  ! {{{ 

  Subroutine write_structure_definition(lunit,spgrpnum,nugen,iugen&
       &,structure,IOwtau_S &
       &,lattice_constants_S,axis_angles_S)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in) :: spgrpnum,nugen,iugen(:)
    Type(T_Structure),Intent(in) ::structure
    Character(*),Intent(in)      ::IOwtau_S(:,:)
    Integer(t_int),Intent(in)  :: lunit
    Character(*),Intent(in)   :: lattice_constants_S(3)
    Character(*),Intent(in)   :: axis_angles_S(3)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="write_structure_definition"
    Integer(t_int) :: issaIO,i
    !!
    Write(lunit,"('section structure_definition{')")  
    !! structure type
    Write(lunit,"(' struct {int type;char[*] description;} structure_type')") 
    Write(lunit,"('  ={',i4,',""',a,'""};')") structure % str_type&
         &,Trim(STR_TYPES(structure % str_type))
    !! spacegroup
    Write(lunit,"('  struct {int number;char[*] symbol;} spacegroup')") 
    Write(lunit,"('  ={',i4,',""',a,'""};')") spgrpnum &
         &,Trim(getSpacegroupName( spgrpnum))


    Write(lunit,"('  int subgroupgenerators[*]')") 
    Write(lunit,"('  ={')") 
    Do i=1,nugen
       Write(lunit,"(a)") intToChar20(iugen(i))
       If(i < nugen) Write(lunit,"(',')",advance='no') 
    End Do
    Write(lunit,"('  };')")


    Write(lunit,"(' struct {int type;char[*] description;} lengthunit')") 
    Write(lunit,"('  ={',i4,',""',a,'""};')") structure % lengthunit&
         &,Trim(SYM_LENGTH_UNITS(structure % lengthunit))
    Write(lunit,"('  real lattice_constants[3]={')",advance='no') 
    Write(lunit,"(2(a,','),a)",advance='no')&
         &trim(lattice_constants_S(1_t_int))&
         &,trim(lattice_constants_S(2_t_int))&
         &,trim(lattice_constants_S(3_t_int))
    Write(lunit,"('  };')") 
    Write(lunit,"('  real axis_angles[3]={')",advance='no') 
    Write(lunit,"(2(a,','),a)",advance='no')&
         &Trim(axis_angles_S(1_t_int))&
         &,trim(axis_angles_S(2_t_int))&
         &,trim(axis_angles_S(3_t_int))
    Write(lunit,"('  };')") 
    Write(lunit,"('  # WARNING: max_L is obsolete now, since moved into =.in')")
    Write(lunit,"('  int max_L=',i3,';')") 4_t_int
    Write(lunit,"('  int nsort=',i7,';')")structure % IOnsort


    Write(lunit,"('  struct {char[2] element;real tau[3];} &
         &wyckoff_positions[nsort]')") 
    Write(lunit,"('  ={')") 
    Do issaIO=1_t_int,structure % IOnsort
       Write(lunit,"('    {')",advance='no') 
       Write(lunit,"('  ""',a,'"",{')",advance='no') &
            &Trim(structure % p_IOelements(issaIO))
       Write(lunit,"(2x,2(a,','),a)",advance='no')    &
            &Trim(IOwtau_S(1_t_int,issaIO))&
            &,Trim(IOwtau_S(2_t_int,issaIO))&
            &,Trim(IOwtau_S(3_t_int,issaIO))

       Write(lunit,"('  }}')") 
       If(issaIO < structure % IOnsort) Write(lunit,"('  ,')",advance='no') 
    End Do

    Write(lunit,"('  };')")

    Write(lunit,"('};',/)") 

  End Subroutine write_structure_definition

  ! }}}
  !!***********************************************************************
  ! write_structure_information
  ! {{{ 

  Subroutine write_structure_information(lunit&
       &,spgrpnum,nugen,iugen&
       &,structure,IOwtau_S &
       &,lattice_constants_S,axis_angles_S,max_L)
    !!
    Implicit None 
    !!IO
    !! symmetry 
    Integer(t_int),Intent(in) :: spgrpnum,nugen,iugen(:)
    Type(T_Structure),Intent(in) ::structure
    Character(*),Intent(in)  ::IOwtau_S(:,:)
    Integer(t_int),Intent(in)    :: max_L
    Integer(t_int),Intent(in)  :: lunit
    Character(*),Intent(in)   :: lattice_constants_S(3)
    Character(*),Intent(in)   :: axis_angles_S(3)
    !!LOCAL
    Integer(t_int) ::issaIO,i
    !Character(*),Parameter::nsubfunc="write_structure_information"
    !!
    Write(lunit,"('section structure_information{')")  
    !! structure type
    Write(lunit,"(' struct {int type;char[*] description;} structure_type')") 
    Write(lunit,"('  ={',i4,',""',a,'""};')") structure % str_type&
         &,Trim(STR_TYPES(structure % str_type))

    !! spacegroup
    Write(lunit,"('  struct {int number;char[*] symbol;} spacegroup')") 
    Write(lunit,"('  ={',i4,',""',a,'""};')")  spgrpnum&
         &,Trim(getSpacegroupName(spgrpnum))

    Write(lunit,"('  int subgroupgenerators[*]')") 
    Write(lunit,"('  ={')") 
    Do i=1,nugen
       Write(lunit,"(a)") intToChar20(iugen(i))
       If(i < nugen) Write(lunit,"(',')",advance='no') 
    End Do
    Write(lunit,"('  };')")


    !! unit of length
    Write(lunit,"('  struct {int type;char[*] description;} lengthunit')") 

    Write(lunit,"('={',i4,',""',a,'""};')") structure % lengthunit&
         &,Trim(SYM_LENGTH_UNITS(structure % lengthunit))
    
    Write(lunit,"('  real lattice_constants[3]={')",advance='no') 
    Write(lunit,"(2(a,','),a)",advance='no') &
         &Trim(lattice_constants_S(1_t_int))&
         &,Trim(lattice_constants_S(2_t_int))&
         &,Trim(lattice_constants_S(3_t_int))
    Write(lunit,"('  };')") 

    Write(lunit,"('  real axis_angles[3]={')",advance='no') 
    Write(lunit,"(2(a,','),a)",advance='no') &
         &Trim(axis_angles_S(1_t_int))&
         &,Trim(axis_angles_S(2_t_int))&
         &,Trim(axis_angles_S(3_t_int))
    Write(lunit,"('  };')") 
    Write(lunit,"('  int max_L=',i3,';')") max_L
    Write(lunit,"('  int nsort=',i7,';')")structure % IOnsort



    Write(lunit,"('  struct {char[2] element;real tau[3];} &
         &wyckoff_positions[nsort]'    )") 
    Write(lunit,"('  ={')") 
    Do issaIO=1_t_int,structure % IOnsort
       Write(lunit,"('    {')",advance='no') 
       Write(lunit,"('  ""',a,'"",{')",advance='no') &
            &Trim(structure % p_IOelements(issaIO))
       Write(lunit,"(2(a,','),a)",advance='no')    &
            & Trim( IOwtau_S(1_t_int,issaIO))&
            &,Trim( IOwtau_S(2_t_int,issaIO))&
            &,Trim( IOwtau_S(3_t_int,issaIO))

       Write(lunit,"('  }}')") 
       If(issaIO <structure % IOnsort) Write(lunit,"('  ,')",advance='no') 
    End Do
    Write(lunit,"('  };')")


    ! section end
    Write(lunit,"('};',/)") 

  End Subroutine write_structure_information

  ! }}}
  !!***********************************************************************
  ! write_structure_dependend
  ! {{{ 

  Subroutine write_structure_dependend(lunit,structure,structure_conao&
       &,spin_split,core_occupation_count&
       &,core_occupation_sort,core_occupation_state&
       &,core_occupation_spinup,core_occupation_spindn&
       &,bandplot_npoints,bandplot_labels,bandplot_points)
    !!
    Implicit None 
    !!IO
    Type(T_Structure),Intent(in)  :: structure
    Integer(t_int),Intent(in)       :: lunit
    Character(*),Intent(in)        :: spin_split(:)
    Character(*),Intent(in)        :: structure_conao(:)
    Character(*),Intent(in)        :: bandplot_points(:,:)
    Character(*),Intent(in)        :: bandplot_labels(:)
    Integer(t_int),Intent(in)       :: bandplot_npoints
    Character(*),Intent(in)        :: core_occupation_spinup(:,:)
    Character(*),Intent(in)        :: core_occupation_spindn(:,:)
    Integer(t_int),Intent(in)       :: core_occupation_sort(:)
    Integer(t_int),Intent(in)       :: core_occupation_count
    Character(*),Intent(in)        :: core_occupation_state(:)
    !!LOCAL
    Integer(t_int) ::issaIO,ico,i,j
    !Character(*),Parameter::nsubfunc="write_structure_dependend"
    Write(lunit,"(//)") 
    Write(lunit,"('section structure_dependend{')")  


    Write(lunit,"('  struct {char[2] atom;real concentration;} &
         &concentrations[nsort]={')")
    Write(lunit,"('    ')",advance='no')
    Do issaIO=1_t_int,structure % IOnsort
       Write(lunit,"('{')",advance='no') 
       Write(lunit,"('  ""',a,'"",')",advance='no')&
            & Trim(structure % p_IOelements(issaIO))
       Write(lunit,"(a,'}',/)",advance='no') Trim(structure_conao(issaIO))
       If(issaIO < structure % IOnsort) Write(lunit,"('   ,')",advance='no') 
    End Do

    Write(lunit,"('  };')")



    Write(lunit,"('  struct {char[2] element;real split;}&
         &initial_spin_split[nsort]={')")
    Do issaIO=1_t_int,structure % IOnsort
       Write(lunit,"('{""',a,'"",',a,'}')",advance='no')&
            &Trim(structure % p_IOelements(issaIO)),Trim(spin_split(issaIO))

       If(issaIO < structure % IOnsort) Write(lunit,"('  ,')",advance='no')
    Enddo
    Write(lunit,"('  };')")

    Write(lunit,"('  struct {int sort;char[2] state;&
         &real spinup[7];real spindn[7];} core_occupation[*]={')")
    Write(lunit,"('    ')",advance='no')
    Do ico=1_t_int,core_occupation_count
       Write(lunit,"('{')",advance='no')
       Write(lunit,"(i5,',""',a,'"",{',6(a,',')&
            &,a,'},{',6(a,','),a,'}')",advance='no')&
            & core_occupation_sort(ico) &
            &,Trim(core_occupation_state(ico))&
            &, (Trim(core_occupation_spinup(j,ico)),j=1_t_int,7_t_int)&
            &, (Trim(core_occupation_spindn(j,ico)),j=1_t_int,7_t_int)
       Write(lunit,"('}',/)",advance='no')
       If(ico < core_occupation_count) Write(lunit,"('  ,')",advance='no')
    End Do

    Write(lunit,"('  };')")




    Write(lunit,"('  struct {char[20] label;real kpoint[3];&
         &} special_sympoints[*]={')")
    Write(lunit,"('    ')",advance='no')
    Do i=1_t_int,bandplot_npoints
       Write(lunit,"(a)",advance='no') '{'
       Write(lunit,"(2x,'""',a,'"",{')",advance='no') Trim(bandplot_labels(i))
       Write(lunit,"(2(a,','),a,'}}',/)",advance='no') &
            & (Trim(bandplot_points(j,i)),j=1_t_int,3_t_int)
       If(i< bandplot_npoints) Write(lunit,"('   ,')",advance='no') 
    End Do

    Write(lunit,"('  };')")


    Write(lunit,"('};',/)") 
  End Subroutine write_structure_dependend

  ! }}}

  !!***********************************************************************
  ! write_basis
  ! {{{ 

!!$  Subroutine write_basis(lunit,IOnsort,IOelements,basis,basis_x0,err)
!!$    !!
!!$    Implicit None 
!!$    !!IO
!!$    Logical(t_log),Intent(inout) :: err
!!$    Integer(t_int),Intent(in)    :: IOnsort,lunit
!!$    Character(2),Intent(in)     :: IOelements(IOnsort)
!!$    Type(T_Basis),Intent(in)   :: basis
!!$    Character(*),Intent(in)     :: basis_x0(:,:)
!!$    !!LOCAL
!!$    Integer(t_int) ::ic,iicl,issaIO,iscl,j,br
!!$    Character(*),Parameter::nsubfunc="write_basis"
!!$    Character(500)   ::  str
!!$    
!!$    
!!$    
!!$    !! start output
!!$92  Format(/,a)
!!$2   Format(a)
!!$    Write(lunit,92)  'section structure{'
!!$3   Format(4x,'int nsort=',a,';')
!!$31  Format(i10)
!!$    Write(str,31) IOnsort
!!$    Write(lunit,3) Trim(Adjustl(str))
!!$
!!$    br=4_t_int
!!$    Write(lunit,2,advance='no')'    char[2] elements[nsort]={'
!!$    Do issaIO=1_t_int,IOnsort
!!$13     Format('"',a,'"')
!!$       Write(lunit,13,advance='no')Trim(IOelements(issaIO))
!!$14     Format(/,'    ')
!!$       If(Mod(issaIO,br) == 0_t_int .And. issaIO < IOnsort) &
!!$            &Write(lunit,14,advance='no')
!!$33     Format(',')
!!$       If(issaIO < IOnsort) Write(lunit,33,advance='no')
!!$    End Do
!!$144 Format()
!!$    Write(lunit,144)
!!$    Write(lunit,2)'    };'
!!$
!!$
!!$
!!$5   Format('};',/) 
!!$    Write(lunit,5) 
!!$    
!!$    Write(lunit,92)  'section basis{'
!!$    
!!$    
!!$    Write(lunit,92)'    struct {char[2] atom;int sorts[*];&
!!$         &struct {char[2] state;} corestates[*];&
!!$         &struct {char[2] states[*];real compression;} semicorestates[*];&
!!$         &struct {char[2] states[*];real compression;} valencestates[*];&
!!$         &struct {char[2] states[*];real compression;} polarizationstates[*];&
!!$         &} basis[*]'
!!$    
!!$    Write(lunit,2,advance='no')'    ={'
!!$    
!!$    
!!$    Do iscl=1_t_int,basis% IOnsrtcl
!!$
!!$       issaIO=basis% p_IOsrtcl(1_t_int,iscl)
!!$
!!$6      Format('{"',a,'"')
!!$       Write(lunit,6,advance='no')Trim(IOelements(issaIO))
!!$       Write(lunit,2,advance='no')',{'
!!$       br=20_t_int
!!$       Do j=1,basis% p_IOninsrtcl(iscl)
!!$          Write(str,*)basis% p_IOsrtcl(j,iscl)
!!$          Write(lunit,2,advance='no')Trim(Adjustl(str)) 
!!$          If(Mod(j,br) == 0_t_int .And. j < basis% p_IOninsrtcl(iscl)) &
!!$            &Write(lunit,14,advance='no')
!!$          If(j < basis% p_IOninsrtcl(iscl)) Write(lunit,2,advance='no')','
!!$       Enddo
!!$       Write(lunit,2,advance='no')'}'
!!$       !! continue with core states
!!$       Write(lunit,2,advance='no')',{'
!!$       Do ic=1_t_int,basis % p_IOnc(issaIO)
!!$7         Format('{"',i1,a1,'"}')
!!$          Write(lunit,7)basis % p_IOnnc(ic,issaIO)&
!!$               &,lqnchar(basis % p_IOlc(ic,issaIO))
!!$          Write(lunit,2,advance='no')'    '
!!$          If(ic < basis % p_IOnc(issaIO)) Write(lunit,2,advance='no')','
!!$       Enddo
!!$       Write(lunit,2,advance='no')'},{'
!!$       
!!$       
!!$       !! count various valence orbital types and write
!!$
!!$       iicl=0_t_int
!!$       Call write_valence_basis(lunit,basis,basis_x0,basis% IOnvm,issaIO,iicl&
!!$            &,ORB_TYPE_SEMICORE,err)
!!$       Write(lunit,2,advance='no')'},{' !! end of semicores
!!$       Call write_valence_basis(lunit,basis,basis_x0,basis% IOnvm,issaIO,iicl&
!!$            &,ORB_TYPE_VALENCE,err)
!!$       Write(lunit,2,advance='no')'},{' !! end of valence
!!$       Call write_valence_basis(lunit,basis,basis_x0,basis% IOnvm,issaIO,iicl&
!!$            &,ORB_TYPE_POLARIZATION,err)
!!$       Write(lunit,2,advance='no')'}' !! end of polarizationstates
!!$       
!!$       If(iscl < basis% IOnsrtcl)Then
!!$          Write(lunit,2)'}'
!!$          Write(lunit,2,advance='no')'    ,'
!!$       Else
!!$          Write(lunit,2)'}'
!!$       Endif
!!$    Enddo
!!$    Write(lunit,2)'    };'
!!$    
!!$    
!!$    Write(lunit,51) 
!!$51  Format(/,'};',//) 
!!$
!!$  End Subroutine write_basis
  !!***********************************************************************
!!$  Subroutine  write_valence_basis(lunit,basis,basis_x0,IOnvm,issaIO,iicl&
!!$       &,cty,err)
!!$    !!IO
!!$    Type(T_Basis),Intent(in)     :: basis
!!$    Character(*),Intent(in)      :: basis_x0(:,:)
!!$    Integer(t_int),Intent(in)    :: cty,IOnvm,issaIO,lunit
!!$    Integer(t_int),Intent(inout) :: iicl
!!$    Logical(t_log),Intent(inout) :: err
!!$    !!LOCAL
!!$    Character(*),Parameter::nsubfunc="write_valence_basis"
!!$    Integer(t_int) :: ncl,incl,iv,icl,br
!!$    Integer(t_int) :: nncl(IOnvm)
!!$    Integer(t_int) :: nincl(IOnvm,IOnvm)
!!$    !!
!!$    ncl=0_t_int
!!$    incl=0_t_int
!!$    !Print *,'cty=',cty
!!$    Do iv=1_t_int,basis % p_IOnv(issaIO)
!!$       !Print *,'iv=',iv,basis% p_IOnnv(iv,issaIO),lqnchar(basis% p_IOlv(iv,issaIO))
!!$       If(basis% p_IOtv(iv,issaIO) == cty)Then
!!$          If(iicl /= basis% p_IOnvcl(iv,issaIO))Then
!!$             !Print *,'iv=',iv,' p_nvcl=',basis% p_IOnvcl(iv,issaIO)&
!!$             !     &,' iicl=',iicl
!!$
!!$             If(basis% p_IOnvcl(iv,issaIO) /= iicl+1_t_int)Then
!!$                !Print *,'error'
!!$                err=.True.
!!$             Endif
!!$             If(ncl>0_t_int)Then
!!$                nncl(ncl)=incl
!!$             Endif
!!$             ncl=ncl+1_t_int
!!$             incl=0_t_int
!!$          Endif
!!$          
!!$          incl=incl+1_t_int
!!$          nincl(incl,ncl)=iv
!!$          iicl=basis% p_IOnvcl(iv,issaIO)
!!$       Endif
!!$    Enddo
!!$    If(ncl>0_t_int)Then
!!$       nncl(ncl)=incl
!!$    Endif
!!$    
!!$    !!
!!$    Do icl=1_t_int,ncl
!!$       Write(lunit,2,advance='no')'{{'
!!$       br=4_t_int
!!$       Do incl=1_t_int,nncl(icl)
!!$          iv=nincl(incl,icl)
!!$          Write(lunit,82,advance='no')basis % p_IOnnv(iv,issaIO)&
!!$               &,lqnchar(basis % p_IOlv(iv,issaIO))
!!$          If(Mod(incl,br) == 0_t_int .And. &
!!$               &incl < nncl(icl)) Write(lunit,14,advance='no')
!!$14        Format(/,'    ')
!!$          If(incl<nncl(icl))Then
!!$             Write(lunit,2,advance='no')','
!!$          Endif
!!$       Enddo
!!$       Write(lunit,83,advance='no') Trim(basis_x0(iv,issaIO))
!!$       If(icl < ncl) Then
!!$          Write(lunit,2,advance='no')','
!!$       Endif
!!$    Enddo
!!$    !!
!!$    Return
!!$    !!
!!$82  Format('"',i1,a1,'"')
!!$83  Format('},',a,'}',/,'    ')
!!$2   Format(a)
!!$    !!
!!$  End Subroutine write_valence_basis
  !!***********************************************************************
  ! write_mesh
  ! {{{ 

  Subroutine write_mesh(lunit&
       &,radialmesh_nr,radialmesh_rmin,radialmesh_rmax,radialmesh_rmaxfactor&
       &,atommesh_nr,atommesh_rmin,atommesh_rmax&
       &)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: lunit
    Integer(t_int),Intent(in)    :: radialmesh_nr
    Character(*),Intent(in)     :: radialmesh_rmin,radialmesh_rmax
    Character(*),Intent(in)     :: radialmesh_rmaxfactor
    Integer(t_int),Intent(in)    :: atommesh_nr
    Character(*),Intent(in)     :: atommesh_rmin,atommesh_rmax
    !!LOCAL
    !Character(*),Parameter::nsubfunc="write_mesh"
    !!
    Write(lunit,"(//)") 
    Write(lunit,"('section mesh{')")  


    Write(lunit,"('  struct {int nr;real rmin;real rmax;real rmax_factor;} &
         &radial_mesh={',/,i5,',',2(a,','),a,'};')")&
         & radialmesh_nr,Trim(radialmesh_rmin) ,Trim(radialmesh_rmax) &
         &,Trim(radialmesh_rmaxfactor) 

    Write(lunit,"('  struct {int nr;real rmin;real rmax;} &
         &atom_radial_mesh={',/,i5,',',1(a,','),a,'};')")&
         & atommesh_nr ,Trim(atommesh_rmin) ,Trim(atommesh_rmax) 

    
    Write(lunit,"('};',/)") 
  End Subroutine write_mesh
  !!***********************************************************************
  Subroutine write_options(lunit,mspin,initial_spin_split,relativistic&
       !&,quant&
       &,quant_axis_S&
       !&,diracdefs&
       &,options&
       &,outlevel,fsm_moment,fsm,etot_calc,xcvers,nuc_type,potential&
       &,potential_xreduce_S,potential_molecule_ionicity_S,vcaZ_S)
    !!
    Implicit None 
    !!IO
    Type(T_Potential),Intent(in) :: potential
    Logical(t_log),Intent(in)  :: etot_calc
    Integer(t_int),Intent(in)  :: lunit
    Integer(t_int),Intent(in)  :: outlevel,xcvers,nuc_type
    Integer(t_int),Intent(in)  :: mspin,relativistic
    Type(T_Options),Intent(in) :: options
    !Type(T_Quant),Intent(in)   :: quant
    !Type(T_Diracdefs),Intent(in):: diracdefs
    Logical(t_log),Intent(in)  :: initial_spin_split
    Character(*),Intent(in)    :: fsm_moment
    Character(*),Intent(in)    :: quant_axis_S(3)
    Character(*),Intent(in)    :: vcaZ_S(:)
    Character(*),Intent(in)    :: potential_xreduce_S,potential_molecule_ionicity_S
    Logical(t_log),Intent(in)  :: fsm
    !!LOCAL
    Integer(t_int) ::i
    !Character(*),Parameter::nsubfunc="write_options"
    Write(lunit,"(//)") 
    Write(lunit,"('section options{')")  


    Write(lunit,"('  struct {int mspin;logical initial_spin_split;} &
         &spin={',i2,',',l2,'};')")mspin,initial_spin_split


    Call getXCVersionIndex(i,xcvers)
    Write(lunit,"('  struct {int type;char[*] description;} xc_potential')")
    Write(lunit,"('  ={',i3,',""',a,'""};')") xcvers &
         &,Trim(XC_VERSIONS(i))

    Write(lunit,"('  real ex_field_strength=',a,';')")Trim(potential_xreduce_S)


    Write(lunit,"('  struct {int type;char[*] description;} relativistic')")
    Write(lunit,"('  ={',i3,',""',a,'""};')") relativistic &
         &,Trim(relat_name(relativistic))

    Write(lunit,"(2x,a)")'struct {int type;char[*] description;} nuclear_model'
    Write(lunit,"(2x,'={',i3,',""',a,'""};')") nuc_type&
         &,Trim(FINUC_TYPE(nuc_type))

    Write(lunit,"(2x,a)")&
         &'struct {struct {int type;char[*] description;} chargemode;'
    Write(lunit,"(2x,a)")&
         &'         real ionicity;logical make_vca;'
    Write(lunit,"(2x,a)")&
         &'         struct{int sort;real Z;}vca[*];'
    Write(lunit,"(2x,a)")&
         &'        } charges'
    Write(lunit,"(2x,'={{',i3,',""',a,'""},',a,',',l1,',{')") potential% chargemode&
         &,Trim(CHARGEMODE_TYPE(potential% chargemode))&
         &,Trim(potential_molecule_ionicity_S),potential% make_vca
    Do i=1,potential% nvca
       If(i<potential% nvca)Then
          Write(lunit,"('{',i6,',',a,'},')")potential% p_vcasorts(i),Trim(vcaZ_S(i))
       Else
          Write(lunit,"('{',i6,',',a,'}')")potential% p_vcasorts(i),Trim(vcaZ_S(i))
       Endif
    Enddo
    Write(lunit,"('}};')")



    Write(lunit,"('  struct {int type;char[*] description;} spin_pop_type')")
    Write(lunit,"('  ={',i3,',""',a,'""};')") 3_t_int&
         &,Trim('exact expression (expensive)')
!         &diracdefs% spin_pop_type &
!         &,Trim(SPIN_POP_TYPES(diracdefs% spin_pop_type))

    Write(lunit,"('  real quantization_axis[3]')")
    Write(lunit,"('  ={',2(a,','),a,'};')")  &
         & Trim(quant_axis_S(1))&
         &,Trim(quant_axis_S(2))&
         &,Trim(quant_axis_S(3))

    Write(lunit,"('  flag options[*]={')")
    Write(lunit,"('    ')",advance='no')
    Do i=1_t_int,options % noptions
       Write(lunit,"(a,'(',a1,')')",advance='no')&
            &Trim(options % p_options(i)(2_t_int:)) &
            &, options % p_options(i)(1_t_int:1_t_int)
       If(i < options % noptions) Write(lunit,"(',')",advance='no') 
       If(Mod(i,4_t_int)==0_t_int)Write(lunit,"(/,'     ')",advance='no')
    Enddo
    Write(lunit,"('  };')") 

    Write(lunit,"('  struct {int type;char[*] description;} verbosity_level')")
    Write(lunit,"('  ={',i5,',""',a,'""};')") outlevel &
         &,Trim(VERBOSITY_LEVELS(outlevel))

    Write(lunit,"('  struct {real moment;logical fsm;} fsmoment')")
    Write(lunit,"('  ={',a,',',l2,'};')") Trim(fsm_moment),fsm 


    Write(lunit,"('  logical calc_etot=',l2,';')")etot_calc

    Write(lunit,"('};',/)") 
  End Subroutine write_options

  ! }}}

  !!***********************************************************************
  ! write_numerics
  ! {{{ 

  Subroutine write_numerics(lunit,numerics&
       &,numerics_cuttol_dens,numerics_cuttol_pot,numerics_cuttol_orbital&
       &,symtesttol_S&
       !&,basis_exn0&
       &,numerics_eweps_r,numerics_eweps_g)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)  :: lunit
    Type(T_Numerics),Intent(in) ::numerics
    Character(*),Intent(in)   :: symtesttol_S
!    Character(*),Intent(in)   :: basis_exn0
    Character(*),Intent(in)   :: numerics_cuttol_dens,numerics_cuttol_pot
    Character(*),Intent(in)   :: numerics_cuttol_orbital
    Character(*),Intent(in)   :: numerics_eweps_r,numerics_eweps_g
    !!LOCAL

    !Character(*),Parameter::nsubfunc="write_numerics"
    Write(lunit,"(//)") 
    Write(lunit,"('section numerics{')")  

!!$    Write(lunit,"('  struct {real exponent;} confining_potential={',a,'};')")&
!!$         &Trim(basis_exn0)
    
    Write(lunit,"('  struct {int degree;} interpolation={',i2,'};')")&
         &numerics % degree





    Write(lunit,"('  struct {int nr;} one_center_integrals')")
    Write(lunit,"('  ={',i5,'};')")numerics % oci_nr 


    Write(lunit,"('  struct {int nxi;int neta;} coulomb_energy_calc')")
    Write(lunit,"('  ={',i5,',',i5,'};')")numerics % coulerg_nxi &
         &,numerics % coulerg_neta



    Write(lunit,"('  struct {int nr;int neta;} overlap_density_calc')")
    Write(lunit,"('  ={',i5,',',i5,'};')")numerics % ovldns_nr &
         &,numerics % ovldns_neta

    Write(lunit,"('  struct {real dens;real pot;real orbital;} cutoff_tolerances')")
    Write(lunit,"('  ={',2(a,','),a,'};')")&
         & Trim(numerics_cuttol_dens) &
         &,trim(numerics_cuttol_pot) &
         &,trim(numerics_cuttol_orbital) 


    Write(lunit,"('  #WARNING: cutoff is obsolete now')")
    Write(lunit,"('  struct {real cutoff;real eps_r;real eps_g;} ewald_parameter')")
    Write(lunit,"('  ={',2(a,','),a,'};')")&
         & Trim('2.0') &
         &,trim(numerics_eweps_r) &
         &,trim(numerics_eweps_g) 

    Write(lunit,"('  struct {real tol;} symtest')")
    Write(lunit,"('  ={',a,'};')")Trim(symtesttol_S)


    Write(lunit,"('  # WARNING: nfft_ewp_per_site is obsolete now  ')")
    Write(lunit,"('  int nfft_ewp_per_site=',i10,';')")&
         & -500_t_int !numerics % nfft_ewp_per_site



    Write(lunit,"('};',/)") 
  End Subroutine write_numerics

  ! }}}
  !!***********************************************************************
  Subroutine  write_lsdau(lunit,lsdau,lsdau_omat_dev_S,lsdau_u_f)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)  :: lunit
    Type(T_Lsdau),Intent(in):: lsdau
    Character(*),Intent(in)  :: lsdau_omat_dev_S
    Character(*),Intent(in)  :: lsdau_u_f(:,:)
    !!LOCAL
    Integer(t_int) ::iudef,j
    !Character(*),Parameter::nsubfunc="write_lsdau"
    !!
    Write(lunit,"(//)") 
    Write(lunit,"('section LSDA_U{')")  
    Write(lunit,"('    logical make_lsdau=',l1,';')")lsdau% lsdau

    Write(lunit,"('  struct {int type;char[*] description;} lsdau_projection')")
    Write(lunit,"('  ={',i3,',""',a,'""};')") lsdau% projection &
         &,Trim(LSDAU_PROJECTIONS(lsdau% projection))


    Write(lunit,"('  struct {int type;char[*] description;} lsdau_functional')")
    Write(lunit,"('  ={',i3,',""',a,'""};')") lsdau% functional &
         &,Trim(LSDAU_FUNCTIONALS(lsdau% functional))


    Write(lunit,"('  struct {int type;char[*] description;} lsdau_dmat_mode')")
    Write(lunit,"('  ={',i3,',""',a,'""};')") lsdau% dmat_mode &
         &,Trim(LSDAU_DMAT_MODES(lsdau% dmat_mode))

    Write(lunit,"('    real lsdau_dmat_deviation=',a,';')")&
         &Trim(lsdau_omat_dev_S)

    Write(lunit,"('    struct {int sort;char[2] state;real f_slater[4];}&
         &lsdau_defs[*]={')")

    Do iudef=1_t_int,lsdau% nudef
       Write(lunit,"('      {',i6,',""',a2,'"",{',3(a,','),a,'}}')",advance='no') &
            &lsdau% p_isrtu(iudef) ,lsdau% p_state(iudef) &
            &, (Trim(lsdau_u_f(j,iudef)),j=1_t_int,4_t_int)

       If(iudef<lsdau% nudef) Write(lunit,"(',')");
    Enddo
    Write(lunit,"('    };')") 
    

    Write(lunit,"('};',/)") 
  End Subroutine write_lsdau
  !!***********************************************************************
  Subroutine  write_opc(lunit,opc)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: lunit
    Type(T_OPC),Intent(in)       :: opc
    !!LOCAL
    Integer(t_int) :: IOiodef
    !Character(*),Parameter::nsubfunc="write_opc"
    !!
    Write(lunit,"(//)") 
    Write(lunit,"('section OPC{')")  
    Write(lunit,"('    logical make_opc=',l1,';')")opc% make_opc

    Write(lunit,"('  struct {int type;char[*] description;} opc_projection')")
    Write(lunit,"('  ={',i3,',""',a,'""};')") opc% projection &
         &,Trim(OPC_PROJECTIONS(opc% projection))


    Write(lunit,"('  struct {int type;char[*] description;} opc_functional')")
    Write(lunit,"('  ={',i3,',""',a,'""};')") opc% functional &
         &,Trim(OPC_FUNCTIONALS(opc% functional))


    Write(lunit,"('    struct {int sort;char[2] state;}&
         &opc_defs[*]={')")

10  Format('      {',i6,',"',a2,'"}')
    
    Do IOiodef=1,opc% IOnodef
       Write(lunit,10,advance='no') &
            &opc% p_IOisrto(IOiodef) ,opc% p_IOstate(IOiodef)

       If(IOiodef<opc% IOnodef) Write(lunit,"(',')");
    Enddo
    Write(lunit,"('    };')") 
    

    Write(lunit,"('};',/)") 
  End Subroutine write_opc
  !!***********************************************************************
  Subroutine  write_advancedoutput(lunit,ldos,gridplot,direction1_S&
       &,direction2_S,direction3_S,origin_S,kpoint_S,eminmax_S,topoins&
       &,optics,optics_emin_S,optics_emax_S)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)  :: lunit
    Type(T_LDOS),Intent(in)    :: ldos
    Type(T_GridPlot),Intent(in):: gridplot
    Type(T_TopoIns),Intent(in)  :: topoins
    Type(T_Optics),Intent(in)  :: optics
    Character(*),Pointer       :: direction1_S(:,:)
    Character(*),Pointer       :: direction2_S(:,:)
    Character(*),Pointer       :: direction3_S(:,:)
    Character(*),Pointer       :: origin_S(:,:)
    Character(*),Pointer       :: kpoint_S(:,:,:)
    Character(*),Pointer       :: eminmax_S(:,:,:)
    Character(*),Intent(in)    :: optics_emin_S
    Character(*),Intent(in)    :: optics_emax_S

    !!LOCAL
    Integer(t_int) :: i,j,k,n,c,c2
    Character(1000) :: buf
    !Character(*),Parameter::nsubfunc="write_advancedoutput"
    Type(T_Grid),Pointer :: gr
    Character(4)   :: spinname(0:2)=(/'both','up  ','down'/)
    !!
    Write(lunit,"(//)") 
    Write(lunit,"('section Advanced_output{')")  

    !!
    Write(lunit,"('    int ldossites[*]={')",advance='no')
    n=0
    Do i=1,ldos% nldos
       n=n+1
       Write(buf,"(i10)")ldos% p_ldsites(i)
       Write(lunit,"(a)",advance='no')Trim(Adjustl(buf))
       If(n>=20)Then
          Write(lunit,"(/,'    ')",advance='no')
          n=0
       Endif
       if(i<ldos% nldos) Write(lunit,"(',')",advance='no')
    Enddo
    If(n/=0) Write(lunit,"(/,'    ')",advance='no')
    Write(lunit,"('};')") 
    !!
    !!
    !! the grid definitions
    !!
    Write(lunit,"('logical grids_active=',l1,';')")gridplot% active
    Write(lunit,"('logical grids_stop_after=',l1,';')")gridplot% stopafter
    !!
    Write(lunit,101,advance='no')
101 Format('    struct{',/&
         &,'        struct {int type;char[*] description;}basis;',/&
         &,'        real direction1[3];',/&
         &,'        real direction2[3];',/&
         &,'        real direction3[3];',/&
         &,'        real origin[3];',/&
         &,'        int  subdivision[3];',/&
         &,'        char[*] file;',/&
         &,'        logical InclPeriodicPoints;',/&
         &,'        logical createOpenDX;',/&
         &,'        struct {int type; char[*] description;}quantities[*];',/&
         &,'        struct {int type; char[*] description;}outputdata[*];',/&
         &,'        real scfwavefnctwindow[2];',/&
         &,'        struct {char[*] name;',/&
         &,'            struct {real emin;real emax;real de;',/&
         &,'                struct {int type;char[*] description;} spin;',/&
         &,'            } sections[*];',/&
         &,'        } energywindows[*];',/&
         &,'        struct {char[*] name;real kpoint[3];int bandindices[*];',/&
         &,'          real energywindow[2];',/&
         &,'        } kresolved[*];',/&
         &,'    } grids[*]={')
    Do i=1,gridplot% ngrids
       gr => gridplot% p_grids(i)
       If(i>1)  Then
          Write(lunit,"(',{')")
       Else
          Write(lunit,"('{')")
       Endif
       !!
       Write(lunit,"('{',i10,',""',a,'""}')")gr% basis&
            &,Trim(GRID_BASIS_TYPES(gr% basis))
       !!
       Write(lunit,"(',{',a,',',a,',',a,'}')")(Trim(direction1_S(j,i)),j=1,3)
       Write(lunit,"(',{',a,',',a,',',a,'}')")(Trim(direction2_S(j,i)),j=1,3)
       Write(lunit,"(',{',a,',',a,',',a,'}')")(Trim(direction3_S(j,i)),j=1,3)
       Write(lunit,"(',{',a,',',a,',',a,'}')")(Trim(origin_S(j,i)),j=1,3)
       Write(lunit,"(',{',a,',',a,',',a,'}')")&
            &(Trim(intToChar20(gr% subdivisions(j))),j=1,3)
       Write(lunit,"(',""',a,'""')")Trim(gr% pointfile)
       Write(lunit,"(',',l1,'')")gr% InclPeriodicPoints
       Write(lunit,"(',',l1,'')")gr% createopendx
       Write(lunit,"(',{')",advance='no') 
       c=0
       Do j=1,Size(gr% quantities ,1)
          buf=gridquantities(gr% quantities(j))
          If( buf(1:7)/="unknown")Then
             If(c>0) Write(lunit,"(',')",advance='no') 
             Write(lunit,"('{')",advance='no') 
             Write(lunit,"(a,',""',a,'""')")&
                  & Trim(intToChar20(gr% quantities(j)))&
                  &,Trim( gridquantities(gr% quantities(j)) )
             Write(lunit,"('}')") 
             c=c+1
          Endif
       Enddo
       Write(lunit,"('}')") 
       !!
       Write(lunit,"(',{')",advance='no') 
       !!
       c=0
       Do j=1,Size(gr% outputdata ,1)
          buf=gridoutputdata(gr% outputdata(j))
          If( buf(1:7)/="unknown")Then
             If(c>0) Write(lunit,"(',')",advance='no') 
             Write(lunit,"('{')",advance='no') 
             Write(lunit,"(a,',""',a,'""')") &
                  &Trim(intToChar20(gr% outputdata(j)))&
                  &,Trim( gridoutputdata(gr% outputdata(j)) )
             Write(lunit,"('}')") 
             c=c+1
          Endif
       Enddo
       Write(lunit,"('}')") 
       !!
       Write(lunit,"(',{',a,',',a,'}')")(&
            &Trim(stringify_double100(gr% scfergwindow(j)))&
            &,j=1,2)
       !!
       Write(lunit,"(',{')") 
       c=0
       Do j=1,gr% nenergywindowresolved
          If(c>0) Write(lunit,"(',')",advance='no') 
          Write(lunit,"('{""',a,'""')",advance='no') &
               &Trim(gr% p_energywindowresolved(j)% name)
          Write(lunit,"(',{')") 
          c2=0
          Do k=1,gr% p_energywindowresolved(j)% nsections
             If(c2>0) Write(lunit,"(',')",advance='no') 
             
             
             Write(lunit,"('{',a,',',a,',',a,',{',a,',""',a,'""}}')",advance='no') &
                  &Trim(stringify_double100(gr% p_energywindowresolved(j)% p_emin(k)))&
                  &,Trim(stringify_double100(gr% p_energywindowresolved(j)% p_emax(k)))&
                  &,Trim(stringify_double100(gr% p_energywindowresolved(j)% p_de(k)))&
                  &,intToChar10(gr% p_energywindowresolved(j)% p_spin(k))&
                  &,Trim(spinname(gr% p_energywindowresolved(j)% p_spin(k)))
                  
             c2=c2+1
          Enddo
          Write(lunit,"('}')") 
          Write(lunit,"('}')") 
          c=c+1
       Enddo
       Write(lunit,"('}')") 

       !!
       Write(lunit,"(',{')") 
       c=0
       Do j=1,gr% nkresolved
          If(c>0) Write(lunit,"(',')",advance='no') 
          Write(lunit,"('{""',a,'""')",advance='no') &
               &Trim(gr% p_kresolved(j)% name)
          Write(lunit,"(',{',a,',',a,',',a,'}')",advance='no') &
               &(Trim(kpoint_S(k,j,i)),k=1,3)
          !!
          c2=0
          Write(lunit,"(',{')",advance='no') 
          Do k=1,gr% p_kresolved(j)% nbandindices
             If(c2>0) Write(lunit,"(',')",advance='no') 
             Write(lunit,"(a)",advance='no') &
                  &intToChar10(gr% p_kresolved(j)% p_bandindices(k))
             c2=1
          Enddo
          Write(lunit,"('}')",advance='no') 
          Write(lunit,"(',{',a,',',a,'}')",advance='no') &
               &(Trim(eminmax_S(k,j,i)),k=1,2)
          Write(lunit,"('}')") 
          c=c+1
       Enddo
       Write(lunit,"('}')") 
       !!

       Write(lunit,"('}')")
    Enddo
    Write(lunit,"('};')") !! end of grids data

    !! TI
    Write(lunit,"('    struct {logical active;}topological_insulator')")
    Write(lunit,"('    ={')")
    Write(lunit,"('    ',l1,'')") topoins% active
    Write(lunit,"('    };')")
    !!end TI

    !! Optics
    Write(lunit,"('    struct {logical active;logical jointdos;logical bandoutput;',/&
         &,       '            logical stopafter;',/&
         &,       '            struct{int ne;real emin;real emax;}energy;}optics',/&
         &,       '    ={',l1,',',l1,',',l1,',',l1,',',/,'    {',i5,',',a,',',a,'}',/&
         &,       '    };')")&
         &optics% active,optics% jointdos,optics% bandoutput,optics% stopafter&
         &,optics% Ne,Trim(optics_emin_S),Trim(optics_emax_S)
    !!end Optics

    Write(lunit,"('};',/)") 
  End Subroutine write_advancedoutput

  !!***********************************************************************
  ! write_cpa
  ! {{{ 

  Subroutine write_cpa(lunit,cpacontrol&
       &,cpacontrol_eimagdos,cpacontrol_eimagscf&
       &,cpacontrol_efermi0,cpacontrol_slop_0,cpacontrol_slop_min&
       &,cpacontrol_emin0,cpacontrol_emax0&
       &)
    !!
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)  :: lunit
    Type(T_Cpacontrol),Intent(in):: cpacontrol
    Character(*),Intent(in)     :: cpacontrol_eimagdos,cpacontrol_eimagscf
    Character(*),Intent(in)     :: cpacontrol_efermi0,cpacontrol_slop_0
    Character(*),Intent(in)     :: cpacontrol_slop_min
    Character(*),Intent(in)     :: cpacontrol_emin0,cpacontrol_emax0
    !!LOCAL

    !Character(*),Parameter::nsubfunc="write_cpa"
    Write(lunit,"(//)") 
    Write(lunit,"('section cpa{')")  


    Write(lunit,"('    struct {real emin0;real emax0;&
         &int nec;int max_se_loops;real eimag;} cpa_control')")
    Write(lunit,"('  ={',2(a,','),1(i4,','),i4,',',a,'};')")&
         & cpacontrol_emin0,cpacontrol_emax0&
         &,cpacontrol % nec, cpacontrol % max_se_loops&
         &,Trim(cpacontrol_eimagscf)

    Write(lunit,"('    struct {real efermi0;real slop_0;&
         &real slop_min;int max_ef_loops;} cpa_fermi_control')")
    Write(lunit,"('  ={',3(a,','),i4,'};')")&
         & Trim(cpacontrol_efermi0),Trim(cpacontrol_slop_0)&
         &,Trim(cpacontrol_slop_min),cpacontrol % max_ef_loops


    Write(lunit,"('  struct {int type;char[*] description;} &
         &cpa_fermi_method')")
    Write(lunit,"('  ={',i3,',""',a,'""};')") cpacontrol % fermi_method &
         &,Trim(CPA_FERMI_METHODS(cpacontrol % fermi_method ))



    Write(lunit,"('  struct {int ne;real eimag;} cpa_dos')")
    Write(lunit,"('  ={',i6,',',a,'};')")&
         & cpacontrol % nedos&
         &,Trim(cpacontrol_eimagdos )



    Write(lunit,"('  struct {int ne;real eimag;} cpa_bloch_spectral_density')")
    Write(lunit,"('  ={',i6,',',a,'};')")100,"1.e-3"!&
         !& cpacontrol % neakbl &
         !&,Trim(cpacontrol_eimagakbl)

    Write(lunit,"('};',/)") 
  End Subroutine write_cpa

  ! }}}
  !!***********************************************************************
  ! fploheader
  Subroutine write_pid
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="write_pid"
    Character(400) :: host
!    Character(5000):: buffer
    Logical(t_log) :: err
    Integer(t_int) :: pid,lunit
    External cgethostname,cgetpid
    !!
    lunit=12_t_int
    !!
    Call cgetpid(pid)
    Call cgethostname(host,err,errbuf)
    If(err)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg='"'//Trim(errbuf)//'"')
    End If
    Open(lunit,file=f_run)
    Write(lunit,"('host:',a)") Trim(host)
    Write(lunit,"('pid:',i12)") pid
    Close(lunit)
    !!
!    Write(outfile,1)nsubfunc//": writing file '"//Trim(f_run)//"'"
!    Open(lunit,file=f_run)
!    Read(lunit,1) buffer
!    Write(outfile,*)Trim(buffer)
!    Close(lunit)
!    Write(outfile,1)nsubfunc//": end writing file '"//Trim(f_run)//"'"
!1   Format(a)
    !!
  end Subroutine write_pid
  !!*******************************************************************

  Subroutine fploheader
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="fploheader"
    Character(400) :: str,host
    Logical(t_log) :: err
    External cgetdate,cgethostname
    !!
    !!
    Write(outfile,100)
    Write(outfile,110)
    Write(outfile,111)
    Write(outfile,110)
    Write(outfile,120)
    Write(outfile,110)
    Write(outfile,100)
    Write(outfile,110)
    Write(outfile,130)
    Write(outfile,110)
    Write(outfile,1130)
    Write(outfile,110)
    Write(outfile,110)
    Write(outfile,100)
    Write(outfile,110)
    Write(outfile,200)Trim(FPLOMAINVERSION)
    Write(outfile,201)Trim(FPLOSUBVERSION)
    Write(outfile,204)Trim(FPLORELEASE)
    Write(outfile,110)
    Write(outfile,100)
#ifdef __GFORTRAN__
    Write(outfile,"('| compiled with gfortran ',a,'.',a,'.',a,t72,'|')") &
         & Trim(intToChar10(Int(__GNUC__,t_int)))&
         &,Trim(intToChar10(Int(__GNUC_MINOR__,t_int)))&
         &,Trim(intToChar10(Int(__GNUC_PATCHLEVEL__,t_int)))
#endif
#ifdef  __INTEL_COMPILER
    Write(outfile,"('| compiled with ifort ',a,t72,'|')") Trim(intToChar10(__INTEL_COMPILER))
#endif
#if defined (USE_MKL_LAPACK) || defined (USE_MKL_LAPACK_64)
    Write(outfile,"('| compiled with external LAPACK libraries',t72,'|')")
#endif
    Write(outfile,100)
    Write(outfile,110)
    Write(outfile,100)
    Call cgetdate(str,err,errbuf)
    If(err)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg='"'//Trim(errbuf)//'"')
    End If
    Write(outfile,202)Trim(str)
    Call cgethostname(host,err,errbuf)
    If(err)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg='"'//Trim(errbuf)//'"')
    End If
    Write(outfile,203)Trim(host)

    Write(outfile,100)

100 Format(72('-'))
110 Format('|',t72,'|')
111 Format('|',t5,' FULL-POTENTIAL LOCAL-ORBITAL &
         &MINIMUM BASIS BANDSTRUCTURE CODE'&
         & ,t72,'|',/,'|',t24,'FULL RELATIVISTIC VERSION',t72,'|')
120 Format('|',t15,'by K. Koepernik, A.Ernst and ' &
         & ,'H.Eschrig (2003)',t72,'|'/ &
         & ,'|',t19,' relativistic version by Ingo Opahle'&
         & ,t72,'|',/&
         & ,'|',t24,' LSDA+U by Igor Chaplygin'&
         & ,t72,'|')
130 Format('|',t5,'Any publication of results obtained by this program'&
         &,t72,'|'/ &
         & ,'|',t5,'has to include the citation:',t72,'|'/,'|',t72,'|'/ &
         & ,'|',t10,'K.Koepernik and H.Eschrig, Phys. Rev. B 59' &
         & ,', 1743 (1999)',t72,'|' )
1130 Format('|',t5,'Any publication of CPA results obtained by this program'&
         &,t72,'|'/ &
         &,'|',t5,'additionally has to include the citation:',t72,'|',/&
         &,'|',t72,'|',/ &
         &,'|',t10,'K. Koepernik, B. Velicky, R. Hayn and H. Eschrig,',t72&
         &,'|',/ &
         &,'|',t10,'Phys. Rev. B 55, 5717 (1997)',t72,'|' )

200 Format('| main version: ',a,t72,'|')
201 Format('| sub  version: ',a,t72,'|')
204 Format('| release     : ',a,t72,'|')
202 Format('| date        : ',a,t72,'|')
203 Format('| host        : ',a,t72,'|')
    Return
  End Subroutine fploheader




  !!***********************************************************************
  Logical(t_log) Function isdigit(c) 
    !!
    Implicit none  
    !!IO
    Character(1),Intent(in)      :: c
    !!LOCAL
    isdigit=.False.
    If(   c(1:1)=='0' .Or.&
         &c(1:1)=='1' .Or.&
         &c(1:1)=='2' .Or.&
         &c(1:1)=='3' .Or.&
         &c(1:1)=='4' .Or.&
         &c(1:1)=='5' .Or.&
         &c(1:1)=='6' .Or.&
         &c(1:1)=='7' .Or.&
         &c(1:1)=='8' .Or.&
         &c(1:1)=='9' )Then
       isdigit=.True.
       Return
    Endif
    !!
    Return
    !!
  End Function isdigit
    !!***********************************************************************
    Subroutine makeNegativeString(rstr)
    !!
      Implicit None  
    !!IO
    Character(*),Intent(inout) :: rstr !! a string containing a real number
    !!LOCAL
    Character(1000)   :: buf
    Integer(t_int) :: i,j
    !!
    Do i=1,Len_trim(rstr)
       If(rstr(i:i) /= ' ' .And. rstr(i:i) /= Achar(9))Then
          j=i
          Exit
       Endif
    Enddo
    buf=""
    Do i=j,Len_trim(rstr)
       buf(i-j+2:i-j+2)=rstr(i:i)
    Enddo
    !!
    j=2
    If(buf(2:2) == '+') Then
       buf(2:2)='-';
    Else If(isdigit(buf(2:2)) .Or. buf(2:2)=='.' )Then
       buf(1:1)='-';
       j=1
    Endif
    !!
    rstr=buf(j:)
    !!
    Return
    !!
  End Subroutine makeNegativeString
  !!***********************************************************************
  Subroutine makePositiveString(rstr)
    !!
    !!IO
    Character(*),Intent(inout) :: rstr !! a string containing a real number
    !!LOCAL
    Character(1000)   :: buf
    Integer(t_int) :: i,j
    !!
    Do i=1,Len_trim(rstr)
       If(rstr(i:i) /= ' ' .And. rstr(i:i) /= Achar(9))Then
          j=i
          Exit
       Endif
    Enddo
    buf=""
    Do i=j,Len_trim(rstr)
       buf(i-j+1:i-j+1)=rstr(i:i)
    Enddo
    !!
    j=1
    If(buf(1:1) == '-' .Or. buf(1:1) == '+')Then
       j=2
    Endif
    !!
    rstr=buf(j:)
    !!
    Return
    !!
  End Subroutine makePositiveString
  !!***********************************************************************
  !!***********************************************************************
  Subroutine create_develfile(mol,r_angmesh_1_S,r_angmesh_max_S)
    !!
    Implicit None 
    !!IO
    Type(T_Mol),Intent(inout)    :: mol
    Character(*),Intent(in)      :: r_angmesh_1_S,r_angmesh_max_S
    !!LOCAL
    !Character(*),Parameter::nsubfunc="create_develfile"
    Integer(t_int) :: lunit
    !!
    !!Print *,nsubfunc
    lunit=12_t_int
    !!
    Open(lunit,file=f_fplo_devel)
    Write(lunit,"(a)")&
         &"########################################################################"&
         &,"# this file is part of the FPLO bandstructure package"&
         &,"# it was created automatically"&
         &,"# please dont delete this file nor"&
         &,"# edit it directly, unless you really know what you are doing"&
         &,"# Use FEDIT to change its content"&
         &,"#"&
         &,"########################################################################"
    Write(lunit,"(/,/)")
    !! SECTION header
    Write(lunit,"('section header{')")  
    Call write_version(lunit)
    Call write_changed(lunit)
    Write(lunit,"('};',/)") 

    Call write_mol(lunit,mol,r_angmesh_1_S,r_angmesh_max_S)
    

    Close (lunit)
    !!
    Return
    !!
  End Subroutine create_develfile
  !!***********************************************************************
  Subroutine write_mol(lunit,mol,r_angmesh_1_S,r_angmesh_max_S)
    !!
    Implicit None 
    !!IO
    Type(T_Mol),Intent(inout)    :: mol
    Integer(t_int),Intent(in)    :: lunit
    Character(*),Intent(in)      :: r_angmesh_1_S,r_angmesh_max_S
    !!LOCAL
    !Character(*),Parameter::nsubfunc="write_mol"
    !!
    !!Print *,nsubfunc
    !!
    Write(lunit,"('section mol_definition{')")  

    Write(lunit,"('  logical do_mol =',l1,';')") .True.
    Write(lunit,"('  logical irredmesh =',l1,';')") mol% irredmesh


    Write(lunit,"('  logical compressed_vatom =',l1,';')") &
         &mol% compressed_vatom

    Write(lunit,"('  int rad_nr=',i7,';')")mol% rad_nr

!    Write(lunit,"(2x,a)")'struct {int type;char[*] description;} '&
!         &//'radial_meshtype'
    
!    Write(lunit,"(2x,'={',i3,',""',a,'""};')") mol% rad_mesh_type &
!         &,Trim(MESH_TYPE(mol% rad_mesh_type))

    !!
    Write(lunit,"('    struct {real r1;int t1; real rmax;int tmax;}&
         &angmesh={')")
    !!
    Write(lunit,10) Trim(r_angmesh_1_S),mol% t_angmesh_1&
         &,Trim(r_angmesh_max_S),mol% t_angmesh_max
    !!
10  Format('    ',a,',',i5,',',a,',',i5,'};')
    !!
    !!
    !!
    !!
    !! section end
    Write(lunit,"('};',/)") 
    !!
    !!
    !!
    !!
    !!
    !!
    !!
    Return
    !!
  End Subroutine write_mol
  !!***********************************************************************
End Module fploiointernal


