!!----------------------------------------!!
!!FPLOSTARTUP:init:noOVO                  !!
!!----------------------------------------!!
!!TODO: test all reinter + init_spin_split with 'E' !!
!!TODO:  escape sequences for string data
Module fplostartup
  !!
  Use precisiondefs
  Use memory
  Use file_iounits
  Use versioncontrol
  Use tcoreoccupation
  Use clock
  Use constants
  Use tfatband
  Use fatband
  Use tests
  Use forces
  Use basdef
  Use tmol
  Use mol
  Use vatom
  Use ioadapter
  Use errors
  Use ttopoins
  Use topoins
  Use tstm
  Use toptics
  Use optics
  Use stm
  Use dump
  Use tio
  Use io
  Use tunfold
  Use unfold
  Use ioaux
  Use finuc
  Use twannier
  Use wannier
  Use atomdefs
  Use tloi
  Use tsymmetry
  Use pot
  Use symmetry
  Use tnumerics
  Use molpot
  Use terg
  Use tforces
  Use tdiracdefs
  Use diracdefs
  Use topc
  Use opcorrection
  Use helpfplo
  Use torbitalbasis
  Use orbitalbasis
  Use titeration
  Use optionstest
  Use tpotentialdensity
  Use tlsdau
  Use lsdau
  Use tmesh
  Use mesh
  Use tbandplot
  Use bandplot
  Use tcpa
  Use matserv
  Use densio
  Use tbzone
  Use bzone
  Use xc
  Use fploiointernal
  Use fplodata
  Use fedit
  Use trelativistic
  Use tkohnsham
  Use kohnsham
  Use loiorg
  Use loi0
  !!
  Implicit None
  !!
  
  !!
  Private
  !!
  Public :: fplo_init,fplo_init_fixed

  !!
  !!***********************************************************************
  Character(*),Parameter::nmodule="FPLOSTARTUP"  
  Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
Contains
  !!***********************************************************************
  ! fplo_init
  ! {{{ 

  Subroutine fplo_init
    !!
    Implicit None 
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="fplo_init"
    Logical(t_log) :: exist_in,exist_sym!,exist_devel!,exist_basis
    Character(200)  ::  mainversion,subversion
    Type(T_Structure) :: newstructure
    Type(T_Symmetry) :: newsymmetry
    Character(200)  ::  status
    Character(200)  ::  newlattice_constants_S(3)
    Character(200)  ::  newaxis_angles_s(3)
    Character(200),Pointer  ::  IOnewwtau_S(:,:)
    Integer(t_int) :: xcvers,ver
    Logical(t_log) :: stopsym,verstop,adapt_max_L,xcr_required
    !!
    !! set up user strings for the iteration conditions, overwrite
    !! intrinsic defaults
    ITERATION_CONVCONDITIONS(CONVCOND_ANY)="Density OR energy"
    ITERATION_CONVCONDITIONS(CONVCOND_BOTH)="Density AND energy"
    ITERATION_CONVCONDITIONS(CONVCOND_ITERAT)="Density"
    ITERATION_CONVCONDITIONS(CONVCOND_LETSSTOP)="Energy"
    !!
    adapt_max_L=.False.
    Call init_structure(newstructure)
    Call init_symmetry(newsymmetry)
    Nullify(IOnewwtau_S)
    !!
    Call fploheader
    !! 
    Call create_helpfile_fplo()
    Call create_fedit()
    !!version check to avoid unnessecary output
    verstop=.False.
    !Inquire(file=f_fplo_basis ,exist=exist_basis)
    !Inquire(file=f_fplo_devel ,exist=exist_devel)
    Inquire(file=f_fplo_sym ,exist=exist_sym)
    Inquire(file=f_fplo_in ,exist=exist_in)
!!$    If(exist_basis)Then
!!$       Call initparser
!!$       !! read header information
!!$       Call setparsestop("header")
!!$       Call readfile(f_fplo_basis)
!!$       Call getstring("version.mainversion",mainversion)
!!$       Call getstring("version.subversion",subversion)
!!$       Call cleanreadfile
!!$          
!!$       ver=checkversion(mainversion,subversion,f_fplo_basis)
!!$       If(ver/=VERSION_OK)Then
!!$          verstop=.True.
!!$       Endif
!!$
!!$    Endif
!!$    If(exist_devel)Then
!!$       Call initparser
!!$       !! read header information
!!$       Call setparsestop("header")
!!$       Call readfile(f_fplo_devel)
!!$       Call getstring("version.mainversion",mainversion)
!!$       Call getstring("version.subversion",subversion)
!!$       Call cleanreadfile
!!$          
!!$       ver=checkversion(mainversion,subversion,f_fplo_devel)
!!$       If(ver/=VERSION_OK)Then
!!$          verstop=.True.
!!$       Endif
!!$
!!$    Endif
    If(exist_sym)Then
       Call initparser
       !! read header information
       Call setparsestop("header")
       Call readfile(f_fplo_sym)
       Call getstring("version.mainversion",mainversion)
       Call getstring("version.subversion",subversion)
       Call cleanreadfile
          
       ver=checkversion(mainversion,subversion,f_fplo_sym)
       If(ver/=VERSION_OK)Then
          verstop=.True.
          If( ver <  VERSION_5_20)Then
             adapt_max_L=.True.
          Endif
       Endif
       !stop
    Endif
    If(exist_in)Then
       Call initparser
       !! read header information
       Call setparsestop("header")
       Call readfile(f_fplo_in)
       Call getstring("version.mainversion",mainversion)
       Call getstring("version.subversion",subversion)
       Call cleanreadfile
          
       ver=checkversion(mainversion,subversion,f_fplo_in)
       If(ver/=VERSION_OK)Then
          verstop=.True.
          If( ver <  VERSION_5_20)Then
             adapt_max_L=.True.
          Endif
       Endif

    Endif
    !Print *,'ver=',ver,adapt_max_L


    !!
    stopsym=.False.
    If(.Not.exist_sym)Then
       stopsym=.True.

       If(exist_in)Then
          Write(outfile,"('File ',a,' does not exist, will create it &
               &from existing ',a,'!')")&
               &Trim(f_fplo_sym),Trim(f_fplo_in)

          Call fplo_io(IO_ACTION_RECREATE_SYM_FILE&
               &,g_compound,newsymmetry,newstructure&
               &,newlattice_constants_S,newaxis_angles_s,IOnewwtau_S&
               &,g_symmetry,g_structure&
               &,g_mspin,g_initial_spin_split&
               &,gp_spin_split&
               &,g_relativistic,g_quant&
               !&,g_diracdefs&
               &,g_potential,g_iteration_control,g_bzone&
               &,g_pmeshio,g_radialmesh_rmaxfactor&
               &,g_atommeshio,g_numerics&
               &,g_coreoccu&
               !&,g_basis&
               &,g_kohnsham,g_cpacontrol,g_etotstack,g_options&
               &,g_bandplot,g_ldos&
               &,outlevel,xcvers,g_etot,g_forces&
               &,g_opc,g_lsdau,g_Ufactor,stopsym,verstop&
               &,adapt_max_L&
               !&,g_mol&
               &,g_gridplot,g_bwdefs,g_topoins,g_optics)
          Write(outfile,"('File ',a,' created!')")Trim(f_fplo_sym)
          !!
          Call sym_io(IO_ACTION_RUN,g_compound,newsymmetry,newstructure&
               &,newlattice_constants_S,newaxis_angles_s,IOnewwtau_S&
               !&,verstop&
               &)

          
       Else
          Write(outfile,"('File ',a,' does not exist, will create it!')")&
               &Trim(f_fplo_sym)
          !!
          Call sym_io(IO_ACTION_NEW_FILE,g_compound,newsymmetry,newstructure&
               &,newlattice_constants_S,newaxis_angles_s,IOnewwtau_S&
               !&,verstop&
               &)
          !!
          Write(outfile,"('File ',a,' created!')")Trim(f_fplo_sym)

       Endif

    Else
       
       Write(outfile,"('File ',a,' exists!')") Trim(f_fplo_sym)
       !!
       Call sym_io(IO_ACTION_RUN,g_compound,newsymmetry,newstructure&
            &,newlattice_constants_S,newaxis_angles_s,IOnewwtau_S&
            !&,verstop&
            &)
       !!
    Endif
    !!
    Call initparser
    !! read status from header information
    Call setparsestop("header")
    Call readfile(f_fplo_sym)
    Call getstring("status",status)
    Call cleanreadfile
    
    xcr_required=.False.
    If(Trim(status)=='output_xcr')Then
       xcr_required=.True.
       status='ready'
    Endif

    !!

    
    !!
    If(.Not.exist_in)Then
       Write(outfile,"('File ',a,' does not exist, will create it!')")&
            &Trim(f_fplo_in)
       !!
       Call fplo_io(IO_ACTION_NEW_FILE&
            &,g_compound,newsymmetry,newstructure&
            &,newlattice_constants_S,newaxis_angles_s,IOnewwtau_S&
            &,g_symmetry,g_structure&
            &,g_mspin,g_initial_spin_split&
            &,gp_spin_split&
            &,g_relativistic,g_quant&
            !&,g_diracdefs&
            &,g_potential,g_iteration_control,g_bzone&
            &,g_pmeshio,g_radialmesh_rmaxfactor,g_atommeshio,g_numerics&
            &,g_coreoccu&
            !&,g_basis&
            &,g_kohnsham,g_cpacontrol,g_etotstack,g_options&
            &,g_bandplot,g_ldos&
            &,outlevel,xcvers,g_etot,g_forces&
            &,g_opc,g_lsdau,g_Ufactor,stopsym,verstop,adapt_max_L&
            !&,g_mol&
            &,g_gridplot,g_bwdefs,g_topoins,g_optics)
       !!
       Write(errbuf,"('File ',a,' created!')")Trim(f_fplo_in)
       Call terminate(TERM_NORMAL,errbuf)
    Else
       
       Write(outfile,"('File ',a,' exists!')") Trim(f_fplo_in)
       
       
       !! check sym status
       If(Trim(status)=='ready')Then
          !!
          !!read infile
          Call fplo_io(IO_ACTION_RUN&
               &,g_compound,newsymmetry,newstructure&
               &,newlattice_constants_S,newaxis_angles_s,IOnewwtau_S&
               &,g_symmetry,g_structure&
               &,g_mspin,g_initial_spin_split&
               &,gp_spin_split&
               &,g_relativistic,g_quant&
               !&,g_diracdefs&
               &,g_potential,g_iteration_control,g_bzone&
               &,g_pmeshio,g_radialmesh_rmaxfactor,g_atommeshio&
               &,g_numerics&
               &,g_coreoccu&
               !&,g_basis&
               &,g_kohnsham,g_cpacontrol,g_etotstack,g_options&
               &,g_bandplot,g_ldos&
               &,outlevel,xcvers,g_etot,g_forces&
               &,g_opc,g_lsdau,g_Ufactor,stopsym,verstop&
               &,adapt_max_L&
               !&,g_mol&
               &,g_gridplot,g_bwdefs,g_topoins,g_optics)
          
          If(stopsym.Or.verstop) Then
             Call terminate(TERM_NORMAL,' files updated')
          Endif

          Call init(g_compound,g_symmetry,g_structure,g_basis,g_lattice&
               &,g_potential,g_etotstack,g_forces&
               &,g_BEB,g_cpacontrol,g_mspin&
               &,g_initial_spin_split,g_pmeshio&
               &,g_radialmesh_rmaxfactor&
               &,g_numerics&
               &,g_relativistic,g_quant,g_bzone&
               &,g_atommeshio,g_kohnsham&
               &,g_trace,g_bandplot,g_ldos&
               &,g_coreoccu&
               &,g_sic,xcvers,g_lsdau,g_opc,g_mol&
               &,xcr_required,g_unfold,g_bwdefs,g_stm,g_optics&
               &,g_topoins)
          
       Else If(Trim(status)=='symmetry changed')Then
          !!
          Write(outfile,"('Symmetry changed in ',a,' !')")Trim(f_fplo_sym)
          Write(outfile,"('Will update file ',a,' !')")Trim(f_fplo_in)
          Call fplo_io(IO_ACTION_STRUCTURE_UPDATE&
               &,g_compound,newsymmetry,newstructure&
               &,newlattice_constants_S,newaxis_angles_s,IOnewwtau_S&
               &,g_symmetry,g_structure&
               &,g_mspin,g_initial_spin_split&
               &,gp_spin_split&
               &,g_relativistic,g_quant&
               !&,g_diracdefs&
               &,g_potential,g_iteration_control,g_bzone&
               &,g_pmeshio,g_radialmesh_rmaxfactor,g_atommeshio&
               &,g_numerics&
               &,g_coreoccu&
               !&,g_basis&
               &,g_kohnsham,g_cpacontrol,g_etotstack,g_options&
               &,g_bandplot,g_ldos&
               &,outlevel,xcvers,g_etot,g_forces&
               &,g_opc,g_lsdau,g_Ufactor,stopsym,verstop&
               &,adapt_max_L&
               !&,g_mol&
               &,g_gridplot,g_bwdefs,g_topoins,g_optics)
          
          Write(outfile,"('File ',a,' updated!')")Trim(f_fplo_in)
          Write(errbuf,"('File ',a,' updated!')")Trim(f_fplo_in)

          !! clear 'symmetry changed' flag
          status='ready'
          Call create_symfile(status,g_compound &
               &,newsymmetry % spgrpnum&
               &,newsymmetry% nugen&
               &,newsymmetry% iugen&
               &,newstructure&
               &,newlattice_constants_S&
               &,newaxis_angles_S&
               &,IOnewwtau_S&
               )
          Call terminate(TERM_NORMAL,errbuf)
       Else 
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg='"File status ('//Trim(status)//') unknown!"')
          
       Endif
       
    End If
    Call pfree(newstructure% p_IOelements)
    Call pfree(newstructure% p_IOwtau)
    Call pfree(newstructure% p_tau)
    Call pfree(newstructure% p_IOisrt)
    Call pfree(newstructure% p_kaps)
    Call pfree(newstructure% p_IOconao)
    Call pfree(IOnewwtau_S)
    !!
    !!
    Call write_pid
    !!
    Return
    !!
  End Subroutine fplo_init
  !!***********************************************************************
  Subroutine init(compound,symmetry,structure,basis,lattice,potential&
       &,etotstack,forces,BEB,cpacontrol,mspin,initial_spin_split&
       &,pmesh,radialmesh_rmaxfactor&
       &,numerics,relativistic,quant,bzone&
       &,atommesh,kohnsham,trace,bandplot,ldos,coreoccu&
       &,sic,xcvers,lsdau,opc,mol,xcr_required,unfold,bwdefs&
       &,stm,optics,topoins)
    !!
    Implicit None 
    !!IO
    Type(T_Mol),Intent(inout)        :: mol
    Type(T_Symmetry),Intent(inout)   :: symmetry
    Type(T_Basis),Intent(inout)      :: basis
    Type(T_Mesh),Intent(in)          :: pmesh
    Type(T_Unfold),Intent(inout)     :: unfold
    Type(T_Mesh),Intent(in)          :: atommesh
    Type(T_SIC),Intent(inout)        :: sic
    Type(T_BWDefs),Intent(inout)     :: bwdefs
    Type(T_Quant),Intent(inout)      :: quant
    Type(T_Coreoccu),Intent(inout)   :: coreoccu
    Type(T_Structure),Intent(inout)  :: structure
    Type(T_Lattice),Intent(inout)    :: lattice
    Type(T_Potential),Intent(inout)  :: potential
    Type(T_Etotstack),Intent(inout)  :: etotstack
    Type(T_Forces),Intent(inout)     :: forces
    Type(T_Bzone),Intent(inout)      :: bzone
    Type(T_Cpacontrol),Intent(inout) :: cpacontrol
    Type(T_Numerics),Intent(inout)   :: numerics
    Type(T_Kohnsham),Intent(inout)   :: kohnsham
    Type(T_Trace),Intent(inout)      :: trace
    Type(T_Bandplot),Intent(inout)   :: bandplot
    Type(T_LDOS),Intent(inout)       :: ldos
    Type(T_Lsdau),Intent(inout)      :: lsdau
    Type(T_OPC),Intent(inout)        :: opc
    Type(T_STM),Intent(inout)        :: stm
    Type(T_Optics),Intent(inout)     :: optics
    Type(T_TopoIns),Intent(inout)    :: topoins
    Character(*),Intent(in)          :: compound
    Logical(t_log),Intent(in)        :: xcr_required
    Integer(t_int),Intent(in)        :: mspin
    Integer(t_int),Intent(in)        :: relativistic
    logical(t_log),Intent(inout)     :: initial_spin_split
    Logical(t_log),Intent(out)       :: BEB 
    Integer(t_int),Intent(in)        :: xcvers
    Real(t_real),Intent(in)          :: radialmesh_rmaxfactor
    !!LOCAL
    Character(*),Parameter::nsubfunc="init"
    Integer(t_int) :: i,issa,nspin
    Real(t_real) :: Gmax,rmin
    Logical(t_log)       :: exists,calc_forces
    Logical(t_log)       :: direction_invariant
    !!
    !Call analyse_irreps(symmetry% Rnumops,symmetry% Ropmat,symmetry% Ropsymbol)
    !!
    Call setup_dump_states()
    !!
    !Stop 'fedit version'
    !!
    !! define potential and density angular momentum expansion 
    If(potential % max_LIO>12_t_int)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'variable ''max_L'': maximum angular momentum for &
            &potential and ',/,' density is 12 in the moment !'")
    End If
    !!
    use_OVO=.True.
    If(debugfun(nmodule,nsubfunc,'noOVO')) use_OVO=.False.
    !!
    !Print *,'START: ',nsubfunc
    !! prep non relativistic symmetry equivalences
    !! and Wigner D- functions for the crystal group
    Call prep_equivsites(symmetry,structure)
    !!
    !Print *,'AFTER: ',nsubfunc,' : prep_equivsites'
    !!
    !! setup relativistic symmetry reduction
    direction_invariant=.True.
    direction_invariant=.False.
    Call relsymreduce(symmetry,structure,mspin,quant% axis,relativistic&
         &,direction_invariant)
    !!
    !!
    numerics% coulerg_nxi=numerics% coulerg_nxi*2
    !!
    !!

    !Print *,'AFTER: ',nsubfunc,' : relsymreduce'
    !!
    !numerics % cuttol_pot=Min(numerics % cuttol_pot,1.0e-12_t_real)
    !!
    !!
    !!
    !! initialize etot stack
    etotstack % nmax  = 5_t_int
    etotstack % icur  = 0_t_int
    
    Call palloc('etotstack % p_stack',etotstack % p_stack &
         &,1_t_int,etotstack% nmax,nmodule,nsubfunc)
       


    !! process input data

    Call setxcversion(xcvers) !! set global xcversion, check it
    !!
    Call read_old_xreduce_file(potential,protect=.True.)
    !!
    If(.False..And.potential% xreduce>1.0_t_real+1.0e-6_t_real)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'XC-reduction factor cannot be larger than 1.0!'")
    Endif
    If(Abs(potential% xreduce-1.0_t_real)>1.0e-6_t_real)Then
       Write(outfile,2865)potential% xreduce
2865   Format('exchange-reduction factor=',f12.7)

       If(xcvers/=xcver_perdewwang92 .And. xcvers/=XCVER_PBE96)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'XC-reduction only available in LSDA PW92 and PBE96!'")
       Endif
       
    Endif

    !!
    Call palloc('structure% p_rcompsup',structure% p_rcompsup &
         &,1_t_int,structure% nsort ,nmodule,nsubfunc)
    Call palloc('structure% p_rcut',structure% p_rcut &
         &,1_t_int,structure% nsort ,nmodule,nsubfunc)
    
    Call setup_natom(structure,potential)
    Call surrounding(symmetry,structure,potential)

    
    !!
    !! analyse symmetry
!!!    Call sym_analysis(symmetry,structure,relativistic)

    !Print *,'AFTER: ',nsubfunc,' : sym_analysis'

    !!
    
    If(xcr_required) Then
       Call export_xcr_structure_data(compound,structure,symmetry)
    Endif
    
    
    !! cpa
    BEB=isoption('BEB')
    If(structure % nsite >  structure % naps) BEB=.True.

    cpacontrol% istart=0_t_int
    !!
    Call def_cpa_indexarrays(symmetry,structure,cpacontrol % invprt&
         &,relativistic)
    If(cpacontrol % invprt) Then
       Write(outfile,"('non-random blocks detected: will use &
            &partial inversion!')")
    Endif



    initial_spin_split=initial_spin_split.And.(mspin == 2_t_int)


    !!
    !!
    !!
    !!
    Call clean_mol(mol)

    !!
    Call make_meshes(structure,basis,mol,potential&
         &,pmesh% nr,pmesh% rmin,pmesh% rmax&
         &,atommesh% nr,atommesh% rmin&
         &,radialmesh_rmaxfactor)
    !!
    !!
    !!
    !!
    numerics% ovldns_meshtype=ROOT_MESH
    numerics% ovldns_rmin=1.0e-5_t_real
    
    !!
    !!
    
    !!
    Call setup_natomCPA(structure,potential)
    Call setup_relat_basis(structure,basis,relativistic&
         &,potential% make_vca,potential% p_natom)
    !Call read_core_confinement(structure,basis)
    Call print_basis(structure,potential% p_natom,basis,relativistic)


    If(relativistic ==FULL_RELATIVISTIC)Then
       potential% max_L=Max(potential% max_LIO,(basis% lmx+0)*2)
    Else
       potential% max_L=Max(potential% max_LIO,basis% lmx*2)
    Endif
    
    Call det_pot_l_components(symmetry,structure,potential,basis% p_maxl&
         &,relativistic)

    !!
    Call dirty_potential(structure,potential)
    !!



    Call setup_sic(structure,sic)


    !!
    !!
    Call read_old_mol_charge_file(potential,protect=.True.)
    Call read_old_charging_file(potential,protect=.True.)
    !!
    If(  (structure% str_type == STR_TYPE_MOLECULE))Then
       If(potential% chargemode==CHARGEMODE_MOL_ION)Then
          Write(outfile,867)potential% molecule_ionicity
867       Format('Molecule charge: ionicity=',f12.5,/&
               &,'(positive means less electrons than neutral)') 
       Else If(potential% chargemode==CHARGEMODE_JELLIUM)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Jellium model for molecules makes no sense.'")
       Endif
    Else If(  (structure% str_type == STR_TYPE_CRYSTAL))Then
       If(Abs(potential% chargemode)==CHARGEMODE_MOL_ION)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Molecular ionicity for solids makes no sense. &
               &(Did you want jellium?)'")
       Else If(Abs(potential% chargemode)==CHARGEMODE_JELLIUM)Then
          If(((potential% molecule_ionicity)> 1.0e-8_t_real))Then
             Write(outfile,8671)potential% molecule_ionicity
8671         Format('Jellium: removed=',f12.5,' electrons',/) 
          Else If(((-potential% molecule_ionicity)> 1.0e-8_t_real))Then
             Write(outfile,1867)-potential% molecule_ionicity
1867         Format('Jellium: added=',f12.5,' electrons',/) 
          Endif
       Endif
    Endif
    !!
    Call setup_potential_restrictions(structure,basis,potential)
    !!
    Call make_core_occupation(structure,potential,basis,mspin&
         &,kohnsham % czval,coreoccu,relativistic)
    

    Call cpalmptst(structure % naps,potential % p_nlmp &
         &,potential % p_lmp,structure % p_nqAtPos , structure % p_qposToSite)

    

    !!BZ-mesh und weights
    bzone% gammapoint=.False.
    If(structure% str_type == STR_TYPE_MOLECULE) bzone% gammapoint=.True.
    !!
    if(All(bzone% nkxyz(1:3) == 1_t_int))then
       bzone% gammapoint=.True.
    endif
    !!
    If(bzone% gammapoint .And. kohnsham% io_nband >0)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'Number-of-bands option used in gamma-point temperature"&
               &//" broadening! -> Not yet savely implemented!'")
    Endif
    !!
    bzone% kTcur=bzone% kTmax
    bzone% kTmin=bzone% kTmax
    bzone% dkT=0.70_t_real
!!$    Inquire(file='=.kTcntrl',exist=exists)
!!$    If(exists)Then
!!$       Open(12,file='=.kTcntrl')!!TODO
!!$       Read(12,*)
!!$       Read(12,*)bzone% kTmin,bzone% dkT
!!$       Close(12)
!!$       !Print *,'read kT=',bzone% kTcur
!!$    Endif
!!$    Inquire(file='=.kT',exist=exists)
!!$    If(exists)Then
!!$       Open(12,file='=.kT')!!TODO
!!$       Read(12,*)
!!$       Read(12,*)bzone% kTcur
!!$       Close(12)
!!$       !Print *,'read kT=',bzone% kTcur
!!$    Endif
    !!
    Inquire(file='=.negk',exist=exists)
    If(exists)Then
       Open(12,file='=.negk')
       Read(12,*)bzone% ensure_negkpoint
       Close(12)
    Endif
    !!
    bzone% kTcur=Max(bzone% kTcur,bzone% kTmin)
    Call def_bzone(symmetry,symmetry % Rnumops,symmetry % Ropmat&
         &,symmetry % Roptimerev,bzone)
    !! end of BZ
    
    Write(outfile,"(72('-'),/)")


    
    calc_forces=(forces% force_mode /= FORCE_MODE_NONE)
    
    

    If( calc_forces .And. potential% nuc_type /= FINUC_NONE) Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'forces with finite nucleus are not yet implemented!'")
    Endif

    
    If( calc_forces .And. basis% nRcmx /= basis% nRchimx) Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'forces for extended core basis are not yet implemented!'")
    Endif

    If( calc_forces .And. relativistic==FULL_RELATIVISTIC) Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'forces for full relativistic version are not yet implemented!'")
    Endif

    !!
    !!
    !!
    !!    
    Call optics_setup(symmetry,optics,.True.)
    !!
    !!

    Call allocate_basis(structure,basis,calc_forces .Or. optics% active)

    


    !! make automatic default
    !!reciprocal space lattice for ewald potential and screening lengths

    rmin=potential% p_pmeshs(1)% rmax
    Do issa=1,structure% nsort
       rmin=Min(rmin,potential% p_pmeshs(issa)% rmax)
    Enddo


    potential% ew_p_r=ewcutfun(2*(potential% max_L+1),numerics% eweps_r)/rmin
    potential% ewxc_g=ewcutfun(Max(potential% max_L-2,0_t_int)&
         &,numerics% eweps_g)
    Gmax=potential%ewxc_g*2.0_t_real*potential% ew_p_r
    !!
    !!
    If(structure% str_type == STR_TYPE_MOLECULE)Then
       Gmax=0.0_t_real
    Endif
    !!
    Call make_lattice(symmetry % reciprocial_lattice_vectors &
         &,Gmax,lattice % nlattg,lattice % p_glat)
    
    
    Write(outfile,"()")
    If(potential % mlmp == 1_t_int) Write(outfile,603)
603 Format(' LOCAL-SITE POTENTIAL IS SPHERICAL')
    If(potential % mlmp /= 1_t_int) Write(outfile,604)
604 Format(' LOCAL SITE POTENTIAL IS NONSPHERICAL')
    Write(outfile,"()")

    Write(outfile,701)
    Write(outfile,702) numerics% eweps_r
    Write(outfile,703) numerics% eweps_g
    Write(outfile,704) potential% ew_p_r
    Write(outfile,705) Gmax
    Write(outfile,612)lattice % nlattg
    Write(outfile,"()")
701 Format(&
         &'AUTOMATIC MODE: TOLERANCE DETERMINED NUMBER OF FOURIER COMPONENTS')
702 Format('TOLERANCE FOR REAL    SPACE CUTOFF: ', e10.2e3)
703 Format('TOLERANCE FOR FOURIER SPACE CUTOFF: ', e10.2e3)
704 Format('EWALD PARAMETER                   : ', f10.5)
705 Format('MAXIMUM RECIPROCIAL VECTOR NORM   : ', f10.5)
612 Format(' NUMBER OF FT. COMPONENTS FOR EWALD POTENIAL:',i7)


    !!
    !!
    Call setupUnfold(structure,potential,basis,unfold)
    !!
    !!
    kohnsham% DOS_savememory_onstep=debugfun(nmodule,nsubfunc&
         &,'DOS_SAVE_MEMORY')

    Call coefdef(structure,mspin,bzone % nkp,basis,BEB,kohnsham,relativistic)



    !!CPA    Call defmymy(structure,basis,kohnsham,cpacontrol,relativistic)



    !! band structure plotting

    If(.Not.bandplot% read_sympoints) Then
       Call define_special_bz_points(symmetry,bandplot)
    Endif
    

    Call calc_bandplot_mesh(bandplot,'+points')

    
    Call read_bandplot_mesh(bandplot)    


    If(optics% active)Then
       If(relativistic == FULL_RELATIVISTIC )Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Sorry optics for full relativistic case"&
               &//"  not implemented!'")
       Endif
    Endif

    !!
    Inquire(file="=.ndos",exist=exists)
    If(exists)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'''=.ndos'' found, this is old style, use bandplot &
            &menu instead!'")
       bandplot% plotndos=.True.
    Endif
    !!
    Call setup_ldos(structure% nsite,ldos,bandplot% plotbands)
    !!
    Call read_old_coeff_file(bandplot,.True.)
    !!
    Write(outfile,"(a,' calculation!',/)") Trim(relat_name(relativistic))
    !!
    Inquire(file='=.kspintextures',exist=exists)
    If(exists)Then
       Write(outfile,"(/,'''=.kspintextures'' found&
            &, will output spin textures in k-space!',/)")
       If(.Not.(relativistic==FULL_RELATIVISTIC)) Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Sorry, k-space spin textures require full relativistic mode!'")
       Endif
       bandplot% plotkspintextures=.True.
    Endif
    !!
    Call setup_quant(quant,relativistic,basis% lmx)
    
    !! never use relativistic xc correction, its old stuff
    Call setxcrelat(.False.)


    If(BEB) Then
       If(relativistic==FULL_RELATIVISTIC)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Sorry, CPA and full relativistic not yet implemented!'")
       Endif
       Write(outfile,"(72('-'),3(/))")
       Write(outfile,"(a,/,a)")' CPA input detected, '&
            &,'Generalized BEB-treatment used!'
       Write(outfile,"(72('-'),3(/))")
       
    End If




    
    
    Call palloc('trace % p_ning',trace % p_ning &
         &,1_t_int,structure% naps&
         &,1_t_int,structure% naps&
         &,nmodule,nsubfunc)

    If(BEB)Then
       Call palloc('trace % p_trace',trace % p_trace &
            &,1_t_int,structure % naps&
            &,1_t_int,structure % naps&
            &,1_t_int,structure % maxq**2_t_int&
            &,1_t_int,kohnsham % nvsmx&
            &,1_t_int,ORBITAL_MAX_MAT_DIM&
            &,1_t_int,kohnsham % nvsmx&
            &,1_t_int,ORBITAL_MAX_MAT_DIM&
            &,nmodule,nsubfunc)

       Call terminate(TERM_CRASH,'oops, CPA input detected ... not ready!')
!!$       Call tracesym(structure % naps,structure % nsite,structure % p_isrt&
!!$            &,structure % p_tau,structure % p_qposToSite&
!!$            &,structure % p_posToSiteRep&
!!$            &,structure % p_nqAtPos,structure % maxq &
!!$            &,basis % p_nRv,basis % p_lRv &
!!$            &,symmetry % Rnumops,symmetry % Ropmat,symmetry % Roptau&
!!$            &,symmetry % Ropind,symmetry % opeulerinv,symmetry % opeuler&
!!$            &,lattice % p_rlat1,lattice % nlattr1&
!!$            &,kohnsham % nvsmx &
!!$            &,kohnsham% p_vblocklindex&
!!$            &,trace % p_ning,trace % p_trace,relativistic)
    Endif

    Call getXCVersionIndex(i) !! get index into xc strings (global xcversion)
    Write(outfile,"(/,'XC version : ',i4,' - ',a,/)")getxcversion()&
         &,XC_VERSIONS(i)


    !!
    !!
    

    If( calc_forces)Then
       Call palloc('forces% p_hfforces',forces% p_hfforces,1_t_int,3_t_int&
            &,1_t_int,structure% nsite,nmodule,nsubfunc)
       Call palloc('forces% p_plforces',forces% p_plforces,1_t_int,3_t_int&
            &,1_t_int,structure% nsite,nmodule,nsubfunc)
       Call palloc('forces% p_dndVforces',forces% p_dndVforces,1_t_int,3_t_int&
            &,1_t_int,structure% nsite,nmodule,nsubfunc)
       Call palloc('forces% p_cplforces',forces% p_cplforces,1_t_int,3_t_int&
            &,1_t_int,structure% nsite,nmodule,nsubfunc)
       Call palloc('forces% p_forces',forces% p_forces,1_t_int,3_t_int&
            &,1_t_int,structure% nsite,nmodule,nsubfunc)
       forces% p_plforces(:,:)=0.0_t_real
       forces% p_dndVforces(:,:)=0.0_t_real
       forces% p_cplforces(:,:)=0.0_t_real
       forces% p_hfforces(:,:)=0.0_t_real
       forces% p_forces(:,:)=0.0_t_real
       !!
       Call analys_symtrans(symmetry,structure,forces,'FORCES:')
       Call symanalyse_sites(symmetry,structure,forces,'FORCES:')
       !!
    Endif
    !!
    Call alloc_tpotential(mspin,structure,potential)
    !!
    !!
    Call build_map_trans(basis,quant,relativistic)
    !!
    !!
    !!START IOC
    Call io_init_opc(structure,basis,opc,BEB,relativistic)
    !!END IOC

    If(  calc_forces .And. opc% make_opc) Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'forces for OPC are not yet implemented!'")
    Endif

    
    nspin=mspin
    if(relativistic==FULL_RELATIVISTIC) nspin=1

    !!START LSDA+U
    Call io_init_lsdau(structure,basis,lsdau,quant,nspin,BEB,relativistic)
    !!END   LSDA+U


    If(kohnsham% fsm .And. mspin == 1_t_int) Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'Fixed spin moment methods needs mspin=2 !'")
    Endif

    If(kohnsham% fsm .And. relativistic == FULL_RELATIVISTIC) Then
       Call errmsg(nmodule,nsubfunc,E_warning&
            &,msg="'Fixed spin moment methods for relativistic&
            & case is iterative.',/&
            &,' please always use converged calculations !'")
    Endif
    !!
    !!
    mol% rad_nr=80_t_int
    !mol% rad_nr=200_t_int
    !mol% t_angmesh_1=1_t_int
    mol% t_angmesh_1=3_t_int
    !!mol% t_angmesh_max=20_t_int
    !mol% irredmesh=.False.
    !!
    Inquire(file='=.mol',exist=exists)
    If(exists)Then
       Call copy_file_to_output(outfile,"=.mol")
       Open(12,file='=.mol')
       Read(12,*)
       Read(12,*)mol% rad_nr, mol% t_angmesh_1, mol% t_angmesh_max
       Close(12)
    Endif
    !!
    !!
    !!
    numerics% coulerg_nr=400
    !!
    Call read_fatband_definitions(structure,basis,kohnsham,bwdefs,quant,relativistic)
    !!
    If(unfold% active.And.bwdefs% active)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="' Handmade/molecular fatbands and unfold together not implemented yet!'")

    Endif
    !!
    Call setup_stm(symmetry,structure,potential,stm,relativistic)
    !!
    !!
    !Call symmetryAnalysisTools(mspin,symmetry,relativistic)
    !!
    Call setup_topoins(symmetry,topoins,mspin,relativistic)
    !!
    kohnsham% Bfield=0.0_t_real
    kohnsham% haveBfield=.False.
    !!
    Inquire(file='=.Bfield',exist=exists)
    If(exists)Then
       If(kohnsham% fsm)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Fixed spin moment methods and external Bfield&
               & make no sense!'")
       Endif
       Call copy_file_to_output(outfile,"=.Bfield")
       Open(12,file='=.Bfield')
       Read(12,*)
       Read(12,*)kohnsham% Bfield
       Close(12)
       kohnsham% haveBfield=.True.
    Endif
    !!
    !!
    !!
    !!
    Return
    !!
  End Subroutine init
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine symmetryAnalysisTools(mspin,symmetry,relativistic)
    !!
    Use prnt
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Integer(t_int),Intent(in)    :: mspin,relativistic
    !!LOCAL
    !Character(*),Parameter::nsubfunc="symmetryAnalysisTools"
    Logical(t_log) :: rel,relmag
    Integer(t_int) :: jops,l,j,deg,degj,kap
    Real(t_real)   :: Al2(5,5)
    Complex(t_real):: Al2j3(4,4)
    !!
    rel=(relativistic==FULL_RELATIVISTIC)
    relmag=(rel.And.(mspin==2))
    !!
       

    l=2
    j=3
    Print *,'rel=',rel
    If(.Not.rel)Then
       deg=2*l+1
       Do jops=1,symmetry% Rnumops
          Write(outfile,"('symop: ',i2,'=',a)") jops&
               &,Trim(symmetry% Ropsymbol(jops))
          
          Al2(1:deg,1:deg)=symmetry% Rwu_ks(1:deg,1:deg,l,jops)
          Call printmat('wu',"(f12.5)","('      0     ')"&
               &,Al2,deg,deg,1.0e-10_t_real)
          Write(outfile,"('character: ',f30.15)") trace(Al2)
          
       Enddo
    Else
       kap=-(j+1)/2*(j-2*l)
       !Print *,'kap=',kap
       !stop
       degj=j+1
       Do jops=1,symmetry% Rnumops
          
          Al2j3(1:degj,1:degj)=symmetry% Rwu_tj_ks(1:degj,1:degj,kap,jops)
!!$          Call cprintmat1('wu',"('(',f12.5,',',f12.5,')')","('               0&
!!$               &           ')"&
!!$               &,Al2j3,degj,degj,1.0e-10_t_real)
          Write(outfile,"('symop: ',i2,'=',a20,' trace=',f30.15,f30.15&
               &,' eulang=',3(f12.5))")&
               & jops,Trim(symmetry% Ropsymbol(jops)),trace(Al2j3)&
               &,symmetry% opeuler(1:3,jops)
          
       Enddo
       
    Endif
    !!
    Stop
    !!
    Return
    !!
  End Subroutine symmetryAnalysisTools
#endif
  !!***********************************************************************
  Subroutine dirty_potential(structure,potential)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(inout):: structure
    Type(T_Potential),Intent(in)   :: potential
    !!LOCAL
    Character(*),Parameter::nsubfunc="dirty_potential"
    Logical(t_log) :: exists
    Integer(t_int) :: lmax,nline,issa,isa,n,ilm,ii
    Integer :: eof,err
    Character(5000):: buf,word
    Character(*),Parameter :: fname='=.dirty_potential'
    !!
    !!
    Inquire(file=fname,exist=exists)
    If(.Not.exists) Return
    !!
    Write(outfile,"(/,'File ''',a,''' found, you know what you do?',/)")&
         &Trim(fname)
    !!
    !!
    Open(12,file=fname,status='old')
    !!
    nline=0
    readloop: Do 
       !!
       Read(12,12,iostat=eof) buf
       If(eof < 0 ) Exit readloop
       nline=nline+1
       If( Len_trim(buf)==0) Cycle readloop
       word=Adjustl(buf)
       If( word(1:1)=='#') Cycle readloop
       Read(buf,*,iostat=err) issa,lmax
       !!
       If(err/=0)Then
          Write(errbuf,100)Trim(fname),nline,Trim(buf)
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
       Endif
       !!
       If(issa<1 .Or. issa> structure% nsort) Then
          Write(errbuf,101)Trim(fname),nline,Trim(buf)
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
       Endif
       !!
       If(lmax> potential% max_L) Then
          Write(errbuf,102)Trim(fname),nline,Trim(buf)
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
       Endif
       !!
       Do isa=1,structure% nsite
          n=0
          Do ilm=1,potential% p_nlmp(isa)
             If(llilm(potential % p_lmp(ilm,isa))<=lmax)&
                  &n=n+1
          Enddo
          potential% p_nlmp(isa)=n
       Enddo
       !!
       Write(outfile,"('Setting lmax=',i3,' for sort ',a2,'(',i3,')')")&
            &lmax,structure% p_elements(issa),issa
       !!
    End Do readloop
    Close(12)
    !!
    Write(outfile,*)
    Write(errbuf,103)
    Call errmsg(nmodule,nsubfunc,E_warning,msg=Trim(errbuf))
    !!
10  Format(/,'Angular momentum components of potential and density',/)
    Open(14,file='+lpot')
    Write(outfile,10)
    Write(14,10)
    Write(outfile,11)potential % mlmp
    Write(14,11)potential % mlmp
    Do isa=1_t_int,structure% nsite
21      Format(i4)
       Write(outfile,21,advance='no')potential % p_nlmp(isa)
       Write(14,21,advance='no')potential % p_nlmp(isa)
       Do ii=1_t_int,potential % p_nlmp(isa)
          Write(outfile,21,advance='no')potential % p_lmp(ii,isa)
          Write(14,21,advance='no')potential % p_lmp(ii,isa)
       Enddo
3      Format()
       Write(outfile,3)
       Write(14,3)
    Enddo
    Write(outfile,15)
    Write(14,15)
    Close(14)
    !!
    !Stop
    Return
    !!
12  Format(a)
100 Format('"File ''',a,''', line ',i5,' : Incorrect input (''',a&
         &,'''), expected ''sort-number lmax'' !?"')
101 Format('"File ''',a,''', line ',i5,' : Incorrect input (''',a&
         &,'''), invalid sort number !?"')
102 Format('"File ''',a,''', line ',i5,' : Correct input (''',a&
         &,'''), BUT! lmax> max_L!",/&
         &," To increase max_L use fedit->numerics->maximum L."')
103 Format('"You tweaked the potential and density, beware of consequences!"')
11  Format(' - mlmp -',/,i5,/ ,' - nlmp -   - lmp -')
15  Format(/,'#1-1 2-4 5-9 10-16 17-25 26-36 37-49 50-64 65-81 '&
         & ,'82-100 101-121 122-144 145-169',/'#0    1   2    3     4     '&
         & ,'5     6     7     8     9       10      11      12',/)
    !!
  End Subroutine dirty_potential
  !!***********************************************************************
  Subroutine export_xcr_structure_data(compound,structure,symmetry)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(inout)   :: symmetry
    Type(T_Structure),Intent(inout)  :: structure
    Character(*),Intent(in)      :: compound
    !!LOCAL
    !Character(*),Parameter::nsubfunc="export_xcr_structure_data"
    Integer(t_int) :: igroup,isa,issa
    Real(t_real)   :: prim(3,3),conv(3,3),fac,det,iprim(3,3),xp(3)
    Real(t_real)   :: bmat_fcc(3,3),bmat_bcc(3,3),bmat_rtg(3,3)
    Real(t_real)   :: bmat_rtg_inv(3,3),bmat_cfc(3,3)
    !!
    Data bmat_fcc(1,1:3) / 0.0_t_real , 0.5_t_real , 0.5_t_real /
    Data bmat_fcc(2,1:3) / 0.5_t_real , 0.0_t_real , 0.5_t_real /
    Data bmat_fcc(3,1:3) / 0.5_t_real , 0.5_t_real , 0.0_t_real /
    !!
    Data bmat_bcc(1,1:3) /-0.5_t_real , 0.5_t_real , 0.5_t_real /
    Data bmat_bcc(2,1:3) / 0.5_t_real ,-0.5_t_real , 0.5_t_real /
    Data bmat_bcc(3,1:3) / 0.5_t_real , 0.5_t_real ,-0.5_t_real /
    !!
    Data bmat_cfc(1,1:3) / 0.5_t_real , 0.5_t_real , 0.0_t_real /
    Data bmat_cfc(2,1:3) /-0.5_t_real , 0.5_t_real , 0.0_t_real /
    Data bmat_cfc(3,1:3) / 0.0_t_real , 0.0_t_real , 1.0_t_real /
    !!
    Data bmat_rtg(1,1:3) / 2.0_t_real , 1.0_t_real , 1.0_t_real /
    Data bmat_rtg(2,1:3) /-1.0_t_real , 1.0_t_real , 1.0_t_real /
    Data bmat_rtg(3,1:3) /-1.0_t_real ,-2.0_t_real , 1.0_t_real /
    !!
    Data bmat_rtg_inv(1,1:3) / 1.0_t_real ,-1.0_t_real , 0.0_t_real /
    Data bmat_rtg_inv(2,1:3) / 0.0_t_real , 1.0_t_real ,-1.0_t_real /
    Data bmat_rtg_inv(3,1:3) / 1.0_t_real , 1.0_t_real , 1.0_t_real /
    !!
    !!
    !Write(1,*) symmetry% lattice
    !!
    !! latvec in angstroem
    fac=1.0_t_real
    !If(structure % lengthunit==SYM_LENGTH_ANGSTROEM) Then
    !   fac=brtoan
    !Endif
    prim(:,:)=symmetry% lattice_vectors(:,:)*fac
    !!
    !! convert into conventional cell
    If(symmetry% lattice(1:1) =='S')Then
       conv=prim
       igroup=1
    Else If(symmetry% lattice(1:2) =='FC')Then
       conv=2.0_t_real*Matmul(prim,Transpose(bmat_bcc))
       igroup=5
    Else If(symmetry% lattice(1:2) =='BC')Then
       conv=2.0_t_real*Matmul(prim,Transpose(bmat_fcc))
       igroup=6
    Else If(symmetry% lattice(1:1) =='R')Then
       conv=Matmul(prim,Transpose(bmat_rtg_inv))
       igroup=7
    Else If(symmetry% lattice(1:2) =='SH')Then
       conv=prim
       igroup=8
    Else If(symmetry% lattice(1:3) =='CFC')Then
       conv=2.0_t_real*Matmul(prim,(bmat_cfc))
       igroup=4
    Else
       Call terminate(TERM_ERROR,'oops, convcell not yet prepared!')
    Endif
    !!

    Open(12,file='strdata.xcr')
    Write(12,2)'INFO'
    Write(12,2)Trim(compound)
    Write(12,2)'END_INFO'
    Write(12,2)'CRYSTAL'
    Write(12,2) 'DIM-GROUP'
    Write(12,3) 3,igroup
    Write(12,2)'PRIMVEC'
    Write(12,10) prim(:,1)
    Write(12,10) prim(:,2)
    Write(12,10) prim(:,3)
    Write(12,2)'CONVVEC'
    Write(12,10) conv(:,1)
    Write(12,10) conv(:,2)
    Write(12,10) conv(:,3)
    Write(12,2) 'SYMMOP'
    Write(12,2) '1'
    Write(12,2) '1.0,0.0,0.0'
    Write(12,2) '0.0,1.0,0.0'
    Write(12,2) '0.0,0.0,1.0'
    Write(12,2) '0.0,0.0,0.0'
    Write(12,2)'PRIMCOORD'
    Write(12,11) structure% nsite,1
    
    Call dinv33(prim,0_t_int,iprim,det)
    
    Do isa=1,structure% nsite
       !!     primitive fractional coordinates must be 
       !!     between [-0.5,0.5);
       !!     we must get the corresponding Cartesin coordinates
       !!  s^T=xc^T*C  =xp^T*A
       !!  now our A and C are transposed since we store vectors in columns
       !! but in the above notation vectors are stored in the rows of A 
       !! and C
       !! thus    xp=A^T^(-1) s
       xp=Matmul(iprim,structure% p_tau(1:3,isa))
       xp(1)=xp(1)-Nint(xp(1))
       xp(2)=xp(2)-Nint(xp(2))
       xp(3)=xp(3)-Nint(xp(3))
       !! now    s=A^T xp
       xp=Matmul(prim,xp)
       !!TODO: treat rhombohedral lattice correctly
       

       issa=structure% p_isrt(isa)
       Write(12,13) getelementnumber(structure% p_elements(issa))&
            &,xp(1:3)*fac
    Enddo
    Close(12)
    !!
    Call terminate(TERM_FINISH,"xcrysden structure file created")
    !!
    !!
    Return
    !!
2   Format(a)
3   Format(i3,1x,i3)
10  Format(3(f30.15,2x))
11  Format(2(i6,2x))
13 Format(i6,2x,3(f30.15,2x))
    !!
  End Subroutine export_xcr_structure_data
  !!***********************************************************************
  Subroutine surrounding(symmetry,structure,potential)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)     :: symmetry
    Type(T_Structure),Intent(inout) :: structure
    Type(T_Potential),Intent(in)    :: potential
    !!LOCAL
    Character(*),Parameter::nsubfunc="surrounding"
    Integer(t_int) :: isa,isb,nRsum,j,NRp(3),NRm(3),i1,i2,i3,iused,issa,iZ,issb
    Integer(t_int) :: nline
    Character(5000):: buf
    Character(*),Parameter:: fname="=.rmax"
    Integer :: eof,err,issaIO
    Real(t_real)   :: taua(3),a(3),g(3),rg,ag,rho,p(3),atrmax,pabs,ecut
    Real(t_real)   :: eps,x,xmax,NN,fwsinf,fws
    Real(t_real)   :: pc,rconf0,rws0,exn,ex,exi,ZZ
    Real(t_real),Pointer :: rmaxfac(:)
    Logical(t_log) :: exists
    !!
    Nullify(rmaxfac)
    Call palloc('rmaxfac',rmaxfac,1_t_int,structure% nsort,nmodule,nsubfunc)
    Do issa=1,structure% nsort
       rmaxfac(issa)=1.0_t_real
    Enddo
    !!
    Inquire(file=fname,exist=exists)
    If(exists)Then
       Open(12,file=Trim(fname))
       nline=0
          readloop: Do 
             Read(12,10,iostat=eof) buf
             If(eof < 0 ) Exit readloop
             If( Len_trim(buf)==0) Cycle readloop
             nline=nline+1
             Read(buf,*,iostat=err) issaIO,x
             If(err/=0)Then
                Write(errbuf,100)Trim(fname),nline,Trim(buf)
                Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
             Endif
             If(issaIO < 1_t_int .Or. issaIO > structure% IOnsort)Then
                Write(errbuf,"('''in file ',a,': input atom of sort '&
                     &,i4,' does not exist!''')")Trim(fname),issaIO
                Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
             Endif
             Do issa=1,structure% nsort
                If(issaIO == structure% p_isrtTOIOisrt(issa)) Then
                   rmaxfac(issa)=x
                Endif
             Enddo
             
10           Format(a)
100          Format('"File ''',a,''', line ',i5&
                  &,' : Incorrect input (''',a,''')!?"')
          End Do readloop
          
          Close(12)
       Endif
    !!
    !!
    eps=1.0e-12_t_real
    !!
    xmax=Sqrt(-Log(eps)) !! TODO: adjust to better estimate
    !!
    !!
#if defined (BASCREATE)
    Open(17,file='+at_rmax')
    Do iZ=0,MAX_ELEMENT
       !Do i1=1,9
       !x=Real(i1-1,t_real)/9.0_t_real+iZ
       !pc=get_atrmax(iZ,1.0e-2_t_real,.False.,x)
       !pc=get_def_pex(iZ,.false.,x)
       !pc=get_def_exn2(iZ,.True.,x)
       !Write(17,"(3(f30.15,2x))") x,pc
       !Call get_conf_fit_param(iZ,rws0,rconf0,.True.,x)
       !Write(17,"(3(f30.15,2x))") x,rws0,rconf0
       Write(17,"(i4,3(f30.15,2x))") iZ&
            &,get_atrmax(iZ,1.0e-0_t_real,.False.,x)&
            &,get_atrmax(iZ,1.0e-1_t_real,.False.,x)&
            &,get_atrmax(iZ,1.0e-2_t_real,.False.,x)
       !Enddo
    Enddo
    Close(17)
#endif
    !!
    !!
    !!
    fwsinf=1.0_t_real/smoother_gauss(0.0_t_real)**c1o3
    !!
    isaloop: Do isa=1,structure% nsite
       issa=structure% p_isrt(isa)
       taua=structure% p_tau(:,isa)
       !!
       iZ=getelementnumber(structure % p_elements(issa))
       ZZ=potential% p_natom(issa)
       ecut=1.0e-2_t_real
       atrmax=get_atrmax(iZ,ecut,potential% make_vca,ZZ)
       !!

       
       !!
       pc=get_def_pex(iZ,potential% make_vca,ZZ)
       exn=get_def_exn2(iZ,potential% make_vca,ZZ)
       Call get_conf_fit_param(iZ,rws0,rconf0,potential% make_vca,ZZ)
       !!
       ex=(exn+2.0_t_real)/exn
       exi=1.0_t_real/ex
       !!
       rho=(atrmax*pc/rconf0)**exi*(rws0/fwsinf)
       !!
#if defined (BASCREATE)
       Print *,'TODO: database'
       Print *,'pc=',pc
       Print *,'real rws=',structure% arws
       Print *,'rws0=',rws0
       Print *,'rconf0=',rconf0
       Print *,'atrmax=',atrmax
       Print *,'rwsfac=',(rconf0/pc)**exi/rws0
       Write(outfile,215) issa,rho
215    Format('rho(',i5,')=',f30.15)
#endif

       !!
       NN=0.0_t_real
       isbloop: Do isb=1,structure% nsite
          issb=structure% p_isrt(isb)
          a=structure% p_tau(:,isb)-taua
          !!
          If((potential% p_natom(issa)>1.0e-6_t_real).And.&
               &(potential% p_natom(issb)<1.0e-6_t_real)) Cycle isbloop
          !!
          nRsum=1
          Do j=1,3
             g=symmetry% reciprocial_lattice_vectors(:,j)
             rg=xmax*rho*Sqrt(Dot_product(g,g))/twopi
             ag=Dot_product(a,g)/twopi
             NRm(j)=Floor  (Min(-ag-rg,-ag+rg))-1
             NRp(j)=Ceiling(Max(-ag-rg,-ag+rg))+1
             nRsum=nRsum*(NRp(j)-NRm(j))
          Enddo
          If(structure% str_type == STR_TYPE_MOLECULE)Then
             NRm(:)=0_t_int
             NRp(:)=0_t_int
          Endif
          Do j=1,3
             !Write(outfile,10) j,NRm(j),NRp(j)
             !10           Format('iR',i1,' in [',i5,',',i5,']')
          Enddo
          !Write(outfile,11) nRsum
          !11        Format('number of lattice vectors needed=',i5)


          iused=0
          Do i1=NRm(1),NRp(1)
             Do i2=NRm(2),NRp(2)
                Do i3=NRm(3),NRp(3)

                   p=   a &
                        &+symmetry% lattice_vectors(:,1)*i1&
                        &+symmetry% lattice_vectors(:,2)*i2&
                        &+symmetry% lattice_vectors(:,3)*i3
                   !!
                   pabs=Sqrt(Dot_product(p,p))
                   x=pabs/rho
                   
                   

                   If(x> xmax ) Cycle
                   iused=iused+1

                   !Print *,'p=',p,x

                   
                   NN=NN+smoother_gauss(x)
                   


                Enddo
             Enddo
          Enddo
          !Write(outfile,*)'used   ',iused,' not ',nRsum-iused
       Enddo isbloop
       fws=1.0_t_real/NN**c1o3
       !fws(issa)=1.0_t_real/NN**c1o3
       structure% p_rcut(issa)=atrmax*(fws/fwsinf)**ex*rmaxfac(issa)
       !! 
#if defined (BASCREATE)
       Write(outfile,"('rho*fws=',f12.5,'actual rws=',f12.5)") &
            &rho*fws,structure % arws !!TODO:remove
#endif
       !!

       
    Enddo isaloop
    !!
    !Write(18,*) 
    !!
    Inquire(file='=.rcut',exist=exists)
    If (exists) Then
       Open(12,file='=.rcut')
       Do issa=1,structure% nsort
          Read(12,*) i1,structure% p_rcut(issa)
       Enddo
       Close(12)
    Endif
    !!
#if defined (BASCREATE)
    Do issa=1,structure% nsort
       Write(outfile,15) issa,structure% p_rcut(issa)
15     Format('rcut(',i5,')=',1(f30.15,2x))
    Enddo
#endif
    !!
    !!
    Call pfree(rmaxfac)
    !!
    !Stop
    !!
    !!
    Return
    !!
    !!
  Contains
    !!***********************************************************************
    Real(t_real) Function smoother_gauss(x)
      !!
      Implicit None
      !!IO
      Real(t_real),Intent(in)      :: x
      !!LOCAL
      !Character(*),Parameter::nsubfunc="smoother_gauss"
      !!
      !!
      smoother_gauss=Exp(-x**2)/(0.75*sqpi)
      !!
      Return
      !!
    End Function smoother_gauss
    !!***********************************************************************
  End Subroutine surrounding
  !!***********************************************************************
  Subroutine make_meshes(structure,basis,mol,potential&
       &,binputnr,rmin0,rmax0&
       &,ainputnr,armin0&
       &,radialmesh_rmaxfactor)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(inout) :: structure
    Type(T_BASIS),Intent(inout)  :: basis
    Type(T_Potential),Intent(inout) :: potential
    Type(T_MOL),Intent(inout)    :: mol
    Integer(t_int),Intent(in)    :: binputnr,ainputnr
    Real(t_real),Intent(in)      :: armin0,rmin0,rmax0,radialmesh_rmaxfactor
    !!LOCAL
    Character(*),Parameter::nsubfunc="make_meshes"
    Logical(t_log) :: radial_rmax_tied
    Integer(t_int) :: bmtype,amtype,pmtype,issa,nr
    Real(t_real)   :: brmin,radialmesh_rmax_default,rmax
    !!
    !!
    Call palloc_meshs('basis% p_basmeshs',basis% p_basmeshs,structure% nsort&
         &,nmodule,nsubfunc)
    !!
    Call palloc_meshs('mol% p_atommeshs',mol% p_atommeshs,structure% nsort&
         &,nmodule,nsubfunc)
    !!
    Call palloc_meshs('potential% p_pmeshs',potential% p_pmeshs&
         &,structure% nsort,nmodule,nsubfunc)
    !!
    pmtype=LOGZERO_MESH
    bmtype=ROOT_MESH
    amtype=LOGZERO_MESH
    !!
    brmin=1.0e-6_t_real
    !!
    !!
    Write(outfile,1600) Trim(MESH_TYPE(bmtype))
    !!
1600 Format(/,72('='),/,t21,' RADIAL BASIS FUNCTION MESH',/,72('-'),/&
          &,'  Mesh type        =',a,/,60('-'),/&
          &,' El. sort',t15,'   nr',t21,'     rmin',t35,'default_rmax'&
          &,t50,'factor',t61,'rmax ')
    !!
    Do issa=1,structure% nsort
       
       basis% p_basmeshs(issa)% Type=bmtype
       basis% p_basmeshs(issa)% with_zero=.True.

       mol% p_atommeshs(issa)% Type=amtype
       mol% p_atommeshs(issa)% with_zero=.True.

       potential% p_pmeshs(issa)% Type=pmtype
       potential% p_pmeshs(issa)% with_zero=.True.
       
       
       basis% p_basmeshs(issa)% nr=binputnr
       If( potential% nuc_type == FINUC_NONE ) Then
          basis% p_basmeshs(issa)% rmin=brmin
       Else
          basis% p_basmeshs(issa)% rmin=brmin*1.0e-3_t_real
       Endif
       potential% p_pmeshs(issa)% nr=binputnr
       potential% p_pmeshs(issa)% rmin=rmin0

       mol% p_atommeshs(issa)% nr=ainputnr+Mod(ainputnr,2_t_int)-1
       mol% p_atommeshs(issa)% rmin=armin0
       
       !!TODO: element wise fixed definition must be given as external input
       radialmesh_rmax_default = structure% p_rcut(issa) 

       !Print *,'radialmesh_rmax_default=',radialmesh_rmax_default
       
       rmax=rmax0
       !Print *,'rmax0=',rmax
       radial_rmax_tied=.False.
       If(rmax<=0.0_t_real)Then
          radial_rmax_tied=.True.
          rmax=radialmesh_rmax_default*radialmesh_rmaxfactor
       Endif


       
       basis% p_basmeshs(issa)% rmax=rmax
       mol% p_atommeshs(issa)% rmax=rmax
       potential% p_pmeshs(issa)% rmax=rmax

       !! save, since it is used in the shape construction
       structure% p_rcompsup(issa) =rmax

       If(radial_rmax_tied) Then
          Write(outfile,1602) &
               & structure% p_elements(issa),issa&
               &,basis% p_basmeshs(issa)% nr&
               &,basis% p_basmeshs(issa)% rmin&
               &,radialmesh_rmax_default&
               &,radialmesh_rmaxfactor&
               &,basis% p_basmeshs(issa)% rmax
       Else
          Write(outfile,1601) &
               & structure% p_elements(issa),issa&
               &,basis% p_basmeshs(issa)% nr&
               &,basis% p_basmeshs(issa)% rmin&
               &,basis% p_basmeshs(issa)% rmax
       Endif
       
1602   Format(1x,a2,1x,i5,t15,i5,1x,e12.3e2,t35,f10.6,t46,f10.6,t57,f10.6)
1601   Format(1x,a2,1x,i5,t15,i5,1x,e12.3e2,t35                ,t57,f10.6)
       

       !print *,'hier1'
       Call setup_mesh(basis% p_basmeshs(issa))
       !print *,'hier2'
       Call setup_mesh(mol% p_atommeshs(issa))
       Call setup_mesh(potential% p_pmeshs(issa))
    Enddo

    !!
    !!
    Write(outfile,1603) 
    !!
1603 Format(/,72('='),/)


    !!
    !!
    nr=1
    Do issa=1,structure% nsort
       nr=Max(nr,basis% p_basmeshs(issa)% nr)
    Enddo
    !!
    basis% nrb=nr
    !!
    nr=1
    Do issa=1,structure% nsort
       nr=Max(nr,mol% p_atommeshs(issa)% nr)
    Enddo
    !!
    mol% nra=nr
    !!
    nr=1
    Do issa=1,structure% nsort
       nr=Max(nr,potential% p_pmeshs(issa)% nr)
    Enddo
    !!
    potential% nrp=nr
    !!
    Return
    !!
  End Subroutine make_meshes
  !!***********************************************************************
  Subroutine fplo_init_fixed(compound,mspin,atommesh,pmesh,radialmesh_rmaxfactor&
       &,symmetry,structure,lattice,sic&
       &,numerics,potential,basis,kohnsham,bandplot,bzone&
       &,loi,mol,quant,wannier,forces,etotstack&
       &,relativistic,initial_spin_split,spin_split,opc,lsdau,stm,optics)
    !!
    Implicit None  
    !!IO
    Character(*),Intent(in)          :: compound
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(inout):: structure
    Type(T_Mesh),Intent(in)      :: atommesh
    Type(T_Mesh),Intent(in)      :: pmesh
    Type(T_Lattice),Intent(inout):: lattice
    Type(T_SIC),Intent(inout)    :: sic
    Type(T_STM),Intent(inout)    :: stm
    Type(T_Optics),Intent(in)    :: optics
    Type(T_Forces),Intent(inout) :: forces
    Type(T_Etotstack),Intent(inout):: etotstack
    Type(T_Numerics),Intent(in)  :: numerics
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_Potential),Intent(inout) :: potential
    Type(T_Basis),Intent(inout)  :: basis
    Type(T_Kohnsham),Intent(inout) :: kohnsham
    Type(T_MOL),Intent(inout)    :: mol
    Type(T_Quant),Intent(in)     :: quant
    Type(T_LOI),Intent(inout)    :: loi
    Type(T_Opc),Intent(inout)    :: opc
    Type(T_Lsdau),Intent(inout)    :: lsdau
    Type(T_Wannier),Intent(inout):: wannier
    Real(t_real),Intent(in)      :: radialmesh_rmaxfactor
    Real(t_real),Intent(in)      :: spin_split(:)
    Integer(t_int),Intent(in)    :: mspin,relativistic
    Logical(t_log),Intent(inout) :: initial_spin_split

    !!LOCAL
    !Character(*),Parameter::nsubfunc="fplo_init_fixed"
    Character(*),Parameter  :: cpumesg_atom='radial equation'
    Logical(t_log) :: calc_forces
    Integer(t_int) :: issa
    !!
    !!
    !!-----------------------------------------------------------------------
    !!-----------------------------------------------------------------------
    !! stuff, which is fixed once and forever before an SCF 
    !!-----------------------------------------------------------------------
    !!-----------------------------------------------------------------------
    !!
    calc_forces=(forces% force_mode /= FORCE_MODE_NONE)
    etotstack % icur  = 0_t_int
    !!
    !!
    Call surrounding(symmetry,structure,potential)
    !!
    Call make_meshes(structure,basis,mol,potential&
         &,pmesh% nr,pmesh% rmin,pmesh% rmax&
         &,atommesh% nr,atommesh% rmin&
         &,radialmesh_rmaxfactor)
    !!
    Call init_dens(compound,structure&
         &,potential,initial_spin_split,opc,lsdau,relativistic&
         !&,bzone&
         &,potential% make_vca,.False.)
    !!
    Call densload(compound,symmetry,structure,potential,numerics&
         &,mspin,initial_spin_split,spin_split,kohnsham% efermi&
         &,kohnsham% Bfsm&
         & ,opc,lsdau&
         !&,bzone&
         &,relativistic)

    lattice% rcut=0.0_t_real
    Do issa=1,structure% nsort
       lattice% rcut=Max(lattice% rcut,potential% p_pmeshs(issa)% rmax)
    Enddo
    
    !! need pairs for integral, overlapp density and stuff
    !! TODO:
    lattice% rcut=lattice% rcut*2.0_t_real

    !!
    Write(outfile,98) lattice% rcut*0.5_t_real
    Write(outfile,99)  lattice% rcut
98  Format('Maximum radial mesh radius : ',f30.15)
99  Format('Maximum LOI Cut-off radius : ',f30.15)

    !!
    Call def_pairs(symmetry,structure,lattice)    
    !!
    !!
    If(.Not.g_symtested)Then
       !! paranoid check of some things
       Call dotests(symmetry,structure,lattice,potential,basis&
            &,numerics% symtesttol,relativistic)
       g_symtested=.True.
    Endif
    !!
    !! mark fixed pulay-force integrals as not-yet calculated
    loi% gloi0_calced=.False.
    !!
    If(calc_forces)Then
       forces% p_plforces(:,:)=0.0_t_real
       forces% p_dndVforces(:,:)=0.0_t_real
       forces% p_cplforces(:,:)=0.0_t_real
       forces% p_hfforces(:,:)=0.0_t_real
       forces% p_forces(:,:)=0.0_t_real
    Endif
    !!
    !!
    !!
    Call molinit(mspin,symmetry,structure,lattice,basis% p_basmeshs,mol)
    Call prep_vatom(structure,basis,potential,mol,relativistic)
    !!
    !!-----------------------------------------------------------------------
    !! Radial equation
    !!-----------------------------------------------------------------------
    !!
    !!
    Call watch(cpumesg_atom,cpu_start,reset=.True.)
    !!
    !! SIC ---------------
    !! 9876 continue
    !!      if(sic4f)then
    !!        call loadsic(w(oorb),nra,r0,r1,nsort,mspin,scfloop)
    !!      endif
    !! END SIC ---------------
    !!
    !!

    Call calc_basis(structure% nsort,structure% p_elements&
         &,structure% p_rcut,lattice% p_rsite,sic% p_esic&
         &,relativistic,numerics% degree,potential% p_natom&
         &,potential% nuc_type,basis,mol,calc_forces .Or. optics% active)
    !!
    !!
    !! SIC ---------------
    !!SIC      if(sic4f)then
    !!SIC        call savesic(w(oorb),w(or),nra,r0,r1,nsort,mspin)
    !!SIC      endif
    !!SIC
    !!SICc     here we are at least one times through basis (for SIC4f)
    !!SIC      if(sic4f.and.scfloop.eq.1)then
    !!SIC        scfloop=2
    !!SIC        goto 9876
    !!SIC      endif
    !! END SIC ---------------
    !!
    !!
    !! maximum radii of the basis functions
    !!
    Call funcmin(structure,numerics,basis,relativistic)
    !!
    !!
    Call do_wanniers(mspin,symmetry,structure,lattice,basis,kohnsham&
         &,bzone,bandplot,wannier,numerics% degree,relativistic,quant)
    !!
    !!
    !Stop
    !!
    !!TODO: mesh
    !!
    !!
    Call tip_mat_analyse(symmetry,structure,basis,kohnsham&
         &,potential,mol,stm,numerics)
    !!
    !!
    Call watch(cpumesg_atom,cpu_stop,delete=.True.,Print=.True.)
    !!-----------------------------------------------------------------------
    !! END of Radial equation
    !!-----------------------------------------------------------------------
    !!
    !!-----------------------------------------------------------------------
    !!----- LO block -----------------------------------
    !!-----------------------------------------------------------------------
    !!
    !Print *,' before setup_loint'
    Call setup_loint(mspin,structure,lattice&
         &,kohnsham% p_cblocklength,kohnsham% p_vblocklength&
         &,loi,relativistic)
    !Print *,' after setup_loint'

    !!
    Call alloc_loi0(loi,mspin,structure% nsite,relativistic&
         &,kohnsham% ncsmx,kohnsham% nvsmx&
         &,need_sigma=bandplot% plotkspintextures)
    !!
    Call loi_int0(structure,lattice,basis,mol,numerics,loi&
         &,kohnsham% p_cblocklength,kohnsham% p_vblocklength&
         &,kohnsham% ncsmx,kohnsham% nvsmx&
         &,relativistic,mspin,quant,potential% p_natom,potential% nuc_type&
         &,need_sigma=bandplot% plotkspintextures)
    !!
    Call stm_loi_int0(structure,basis,mol,numerics&
         &,potential% p_natom,potential% nuc_type,stm&
         &,kohnsham% p_vblocklength,kohnsham% p_cblocklength)
    !!
    !!-----------------------------------------------------------------------
    !!----- END LO block -----------------------------------
    !!-----------------------------------------------------------------------
    !!
    Return
    !!
  End Subroutine fplo_init_fixed
  !!***********************************************************************
  
!!$  !!***********************************************************************
!!$  !!TODO: this should finaly end up in fedit somehow
!!$  Subroutine  read_core_confinement(structure,basis)
!!$    !!
!!$    Implicit None  
!!$    !!IO
!!$    Type(T_Structure),Intent(in) :: structure
!!$    Type(T_Basis),Intent(inout)  :: basis
!!$    !!LOCAL
!!$    Character(*),Parameter::nsubfunc="read_core_confinement"
!!$
!!$    Logical(t_log) :: exists
!!$    Character(5000):: buf
!!$    Character(2)   :: ch
!!$    Integer(t_int) :: nline,issaIO,nnc,lc,jc,ic
!!$    Real(t_real)   :: rcinf
!!$    Integer        :: eof,err
!!$    !!
!!$    Inquire(file=f_core_conf,exist=exists)
!!$    If(.Not. exists)Return
!!$    !!
!!$    Write(errbuf,"('''File ',a,' found, will read core confinement!'',/')")&
!!$         &Trim(f_core_conf)
!!$    Call errmsg(nmodule,nsubfunc,E_information,msg=Trim(errbuf))
!!$
!!$    !!
!!$    Write(errbuf,"(''' Core confinement not yet implemented!'',/')")
!!$    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
!!$    !!
!!$
!!$    Open(12,file=f_core_conf)
!!$    nline=0
!!$    readloop: Do 
!!$       Read(12,10,iostat=eof) buf
!!$       If(eof < 0 ) Exit readloop
!!$       If( Len_trim(buf)==0) cycle readloop
!!$       nline=nline+1
!!$       Read(buf,*,iostat=err) issaIO,ch,rcinf
!!$       !Print *,issaIO,ch,rcinf
!!$       If(err/=0)Then
!!$          Write(errbuf,100)Trim(f_core_conf),nline,Trim(buf)
!!$          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
!!$       Endif
!!$
!!$       If(issaIO < 1_t_int .Or. issaIO > structure% IOnsort)Then
!!$          Write(errbuf,"('''in file ',a,': input atom of sort '&
!!$               &,i4,' does not exist!''')")Trim(f_core_conf),issaIO
!!$          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
!!$       Endif
!!$       
!!$       Read(ch(1:1),12,iostat=err)nnc
!!$       If(err/=0)Then
!!$          Write(errbuf,101)Trim(f_core_conf),nline,Trim(ch)
!!$          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
!!$       Endif
!!$       lc=lcharqn(ch(2:2))
!!$       !Print *,'nnc,lc=',nnc,lc
!!$       
!!$       jc=-1_t_int
!!$       icloop: Do ic=1,basis% p_IOnc1(issaIO)
!!$          If(lc == basis% p_IOlc1(ic,issaIO) .And. &
!!$               & nnc==basis% p_IOnnc1(ic,issaIO))Then
!!$             jc=ic
!!$             Exit icloop
!!$          Endif
!!$       Enddo icloop
!!$       If(jc == -1_t_int) Then
!!$          Write(errbuf,102)Trim(f_core_conf),nline,Trim(ch),issaIO
!!$          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
!!$       Endif
!!$       !!
!!$       basis% p_IOcnfc(jc,issaIO)=CORE_CONF_INF
!!$       basis% p_IOrcinf(jc,issaIO)=rcinf
!!$       !!
!!$    End Do readloop
!!$    Close(12)
!!$10  Format(a)
!!$12  Format(i1)
!!$100 Format('"File ''',a,''', line ',i5,' : Incorrect input (''',a,''')!?"')
!!$101 Format('"File ''',a,''', line ',i5,' : Incorrect orbital label (''',a&
!!$         &,''')!?"')
!!$102 Format('"File ''',a,''', line ',i5,' : Orbital (''',a,''') not in '&
!!$         &,'basis definition",/," of atom sort ',i5,' !?"')
!!$    !!
!!$    !!
!!$    Return
!!$    !!
!!$  End Subroutine read_core_confinement


  ! }}}
  !!***********************************************************************
  !! setup_sic
  ! {{{ 

  Subroutine setup_sic(structure,sic)
    !!
    Implicit None 
    !!IO
    Type(T_Structure),Intent(in)     :: structure
    Type(T_SIC),Intent(inout)        :: sic
    !!LOCAL
    Character(*),Parameter::nsubfunc="setup_sic"
    !!
    !! setup sic stuff
    Call palloc('sic% p_esic',sic% p_esic &
         &,1_t_int,structure% nsort&
         &,1_t_int,2_t_int&
         &,nmodule,nsubfunc)

    !!
    Return
      

  End Subroutine setup_sic

  ! }}}

  !!***********************************************************************
  !! setup_natom
  ! {{{ 

  Subroutine setup_natom(structure,potential)
    !!
    Implicit None 
    !!IO
    Type(T_Structure),Intent(in)     :: structure
    Type(T_Potential),Intent(inout)  :: potential
    !!LOCAL
    Character(*),Parameter::nsubfunc="setup_natom"
    Integer(t_int) :: issa,i,issaIO
    Real(t_real)  :: Z
    !!
    Call palloc('potential% p_natom',potential% p_natom &
         &,1_t_int,structure% nsort&
         &,nmodule,nsubfunc)

    !!TODO: if negtive vacuum type implemented, need to adjust this
    Do issa=1_t_int,structure % nsort
       potential % p_natom(issa)=Real(getelementnumber(&
            &structure % p_elements(issa)),t_real)
    End Do


    !! START VCA
    !! 
    !!
    Call read_old_atcharge(potential,protect=.True.)

    If(potential% make_vca)Then
       Write(outfile,"(/,35('-'),/,'VCA is active',/&
            &,' IOsort                  Z',/&
            &,35('-'))")
       Do i=1,potential% nvca
          issaIO=potential% p_vcasorts(i)
          Z=potential% p_vcaZ(i)
          Write(outfile,"(i5,2x,f30.15)")issaIO,Z
          If(issaIO < 1_t_int .Or. issaIO > structure% IOnsort)Then
             Write(errbuf,"('''VCA: input atom of sort '&
                  &,i4,' does not exist!''')")issaIO
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
          Endif
          If(Z <= 0.0_t_real )Then
             Write(errbuf,"('''VCA: Z<0 for input atom of sort '&
                  &,i4,' !''')")issaIO
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
          Endif
          Do issa=1,structure% nsort
             If(issaIO == structure% p_isrtTOIOisrt(issa)) Then
                If( (Z < potential% p_natom(issa) -1.0_t_real ).Or. &
                     & (Z > potential% p_natom(issa) +1.0_t_real ))Then
                   Write(errbuf,"('''VCA nuclear charge deviates from nominal&
                        & nuclear charge by more than +/-1!''')")
                   Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
                   
                Endif
                potential% p_natom(issa)=Abs(Z)
             Endif
          Enddo
       End Do
       Write(outfile,"(35('-'),/)")
    Endif
    !! End VCA
    !!
    !!
    !!
    Return
    !!
  End Subroutine setup_natom
  !!***********************************************************************
  !! setup_natom
  ! {{{ 

  Subroutine setup_natomCPA(structure,potential)
    !!
    Implicit None 
    !!IO
    Type(T_Structure),Intent(in)     :: structure
    Type(T_Potential),Intent(inout)  :: potential
    !!LOCAL
    Character(*),Parameter::nsubfunc="setup_natomCPA"
    Integer(t_int) :: isa,issa,isap,iq
    Real(t_real)  :: z,con
    !!


    Call palloc('potential% p_natomav',potential% p_natomav &
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)

    potential % tot_nuc_charge=0.0_t_real
    
    Do isap=1_t_int,structure % naps
       z=0.0_t_real
       Do iq=1_t_int,structure % p_nqAtPos(isap)
          isa=structure % p_qposToSite(isap,iq)
          issa=structure % p_isrt(isa)
          con=structure % p_conao(issa)
          z=z+potential % p_natom(issa)*con
       Enddo                   ! iq
       potential % p_natomav(isap)=z
       potential % tot_nuc_charge=potential % tot_nuc_charge+z
    Enddo                     ! isap
    
    
    
    Write(outfile,12)
    Write(outfile,13)(isa,structure % p_isrt(isa),structure% p_siteToPos(isa)&
         &,structure % p_elements(structure % p_isrt(isa))&
         & ,potential % p_natom(structure % p_isrt(isa))&
         & ,potential % p_natomav(structure % p_siteToPos(isa))&
         &,isa=1_t_int,structure % nsite)

    !!
12  Format('Nuclear charges',/&
         &,'site sort real-site El  nuclear-charge averaged-charge')
13  Format(i4,1x,i4,1x,i4,6x,a2,3x,f11.5,1x,f11.5)
    !!
    Return
    !!
  End Subroutine setup_natomCPA
  !!***********************************************************************


End Module fplostartup

