Module helpdirac
  !!
  Use precisiondefs
  Use tio
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="HELPDIRAC"  
  !!
  Public :: create_helpfile_dirac
  !!***********************************************************************
  
Contains
    !!***********************************************************************
  Subroutine create_helpfile_dirac
    !!
    Implicit None 
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="create_helpfile_dirac"
    Integer(t_int),Parameter :: lun=13_t_int
    Character(*),Parameter :: fmt="(a)"
    !!
    Open(lun,file=f_fedit_help,status='unknown')
    Close(lun,status='delete')
    !!
    Open(lun,file=f_fedit_help,status='unknown')
    !!
    Write(lun,fmt)& 
         & 'This is the help file for the fedit tool.'&
         &,'Klaus Koepernik April 2004 '&
         &,'M<MAIN MENU> '&
         &,''&
         &,'B<MAIN MENU> '&
         &,''&
         &,'This help screen may be scrolled by  KEY_UP (CONTROL-K), KEY_DOWN '&
         &,'(CONTROL-N), PAGE_UP (CONTROL-P) and PAGE_DOWN (CONTORL-V). '&
         &,''&
         &,'This is an interactive tool to edit the input files used by the '&
         &,'B<FPLO>-package. It opens a quick way for changing values and '&
         &,'options. '&
         &,''&
         &,'For command line options type U<fedit -h>'&
         &,''&
         &,'=H1 Contents '&
         &,' '&
         &,'=H2 General remarks '&
         &,'=H2 Known problems '&
         &,'=H2 Keys '&
         &,'=H2 Usage '&
         &,'=H2 Menu bar '&
         &,'=H2 Status line '&
         &,'=H2 Alternative menu bar '&
         &,'=H2 GENERAL'&
         &,'=H2 CONFINING POTENTIAL '&
         &,'=H2 MESH OF RADIAL FUNCTIONS '&
         &,'=H2 TOLERANCE'&
         &,'=H2 Error messages '&
         &,'=H2 Authors'&
         &,' ' 
    Write(lun,fmt)& 
         & '=H1 General remarks '&
         &,' '&
         &,'B<Fedit> is designed with the help of the UNIX specific library '&
         &,'U<curses> (or U<ncurses> on Linux systmes). This gives a certain amount of '&
         &,'portability to various terminals. It works best with U<xterm>, U<hpterm>, '&
         &,'U<dtterm>, U<linux>. It also works on U<vt100> and U<vt220>. If you have a '&
         &,'terminal which is not supported by U<curses> (error message: can not '&
         &,'open terminal (or similar)) set the environment variable to some of '&
         &,'the above mentioned terminals, i.e. U<vt220> and try again. May be then'&
         &,'some function keys, like LEFT, RIGHT and PAGE_UP ...  are not well '&
         &,'defined.  Use control keys instead.'&
         &,''&
         &,'This tool knows about the B<dirac>-version, it is designed for.'&
         &,'If you apply this tool to an older version of the input files,'&
         &,'some data may be missing. Therefore, B<fedit> will try to run B<dirac>'&
         &,'in order to update the input files. This should work if the installation'&
         &,'is correct. It is not possible to downgrad input files in this way,'&
         &,'due to the possibility of data loss. If you really want to use old'&
         &,'B<dirac> versions with newer files, you should backup the calculation'&
         &,'and downgrad the input files by hand (edit the version number) or'&
         &,'use B<fdowngrad.pl>.'&
         &,' '&
         &,'=H1 Problems '&
         &,' '&
         &,'The communication of B<fedit> with the input files is managed via '&
         &,'screen definitions (in the file U<+fedit>). This file is deleted'&
         &,'and recreated on each start of B<fedit>.'&
         &,'Most of the work is done in a temporary directory (U<+tmp>) which is created '&
         &,'when B<fedit> starts. In case the directory creation fails make sure '&
         &,'that the file permissions are appropriate.'&
         &,'B<fedit> calls B<dirac> to perform various input file updates. If the' 
    Write(lun,fmt)& 
         & 'executable (the default B<dirac> or the one, specified via '&
         &,'command line option U<fedit -p EXECUTABLE> ) is not in the PATH'&
         &,'or does not run correctly, B<fedit> may come back with an error '&
         &,'message, stating that U<+fedit> is not found. In such cases, please '&
         &,'check if the B<dirac>-executable is running correctly!'&
         &,' '&
         &,'=H1 Keys '&
         &,' '&
         &,'This is the list of all keys and their functionality.'&
         &,' '&
         &,'=H2 CONTROL-C'&
         &,'Abort B<fedit>, discarding all changes. '&
         &,'=H2 CONTROL-R '&
         &,'Refresh screen '&
         &,'=H2 CONTROL-W or /'&
         &,'Search content (and start data editing). see B<Usage>'&
         &,'=H2 SPACE '&
         &,'Activate the alternative menus at the bottom of the screen. '&
         &,'If the alternative menu contains the entry U<[...]> the next part of'&
         &,'the menu is shown on subsequent SPACE key press.'&
         &,'While editing data, SPACE is simply a character. '&
         &,'=H2 ALPHANUMERIC KEYS AND (+), (-) '&
         &,'Acting as hotkeys, or while editing data, as simple characters.'&
         &,'=H2 COMMA (,) '&
         &,'is a repetition indicator, when  editing data. '&
         &,'The comma is expanded to the string just before it: '&
         &,'1.3,,  or 1.3 , , means 1.3 1.3 1.3 '&
         &,'1.1,1.2 means 1.1 1.1 1.2 '&
         &,'=H1 '&
         &,'The following function keys may work differently at different '&
         &,'terminals. For that reason  U<emacs>-style control-keys are supplied. ' 
    Write(lun,fmt)& 
         & 'At least these should work in some way. '&
         &,' '&
         &,'=H2 KEY_LEFT or CONTROL-B, KEY_RIGHT or CONTROL-F '&
         &,'move the cursor in the fields while editing '&
         &,'=H2 KEY_UP or CONTROL-K, KEY_DOWN or CONTROL-N '&
         &,'scroll the screen a line up or down '&
         &,'=H2 DELETE or CONTROL-D, BACKSPACE or CONTROL-H '&
         &,'delete the character at or before the cursor position. '&
         &,'=H2 KEY_HOME or CONTROL-A '&
         &,'move to beginning of the field '&
         &,'=H2 KEY_END or CONTROL-E '&
         &,'move to the end of the field '&
         &,'=H2 PAGE_UP or CONTROL-P '&
         &,'scroll up screen'&
         &,'=H2 PAGE_DOWN or CONTROL-V '&
         &,'scroll down screen'&
         &,'=H2 ESC ESC (two times pressed) '&
         &,'exit edit or search actions, discarding all changes '&
         &,'=H2 ENTER '&
         &,'accept and finish editing'&
         &,'or select a data item for editing, when in search mode'&
         &,' '&
         &,'=H1 Usage '&
         &,' '&
         &,'B<fedit> is a collection of screens/forms with editable fields. '&
         &,'The screens are scrollable. Scrolling is done with KEY_UP, '&
         &,'KEY_DOWN, PAGE-UP, PAGE_DOWN. If there is an invisible part of the '&
         &,'forms it is marked by B<[...]> above or below the forms. '&
         &,'Each field can be activated by a hotkey. Each active key is marked '&
         &,'by (X), X being an ordinary key. If a colored terminal is available'&
         &,'the hotkeys are colored. Typing a hotkey, will start a data edit action,' 
    Write(lun,fmt)& 
         & ',execute a function, switch to a submenu or show the alternative menu bar.'&
         &,'If the screen position of the data field is not currently visible,'&
         &,'the screen is scrolled to make it visible.'&
         &,''&
         &,'There are two kinds of hotkeys: '&
         &,'=H+ simple keys like ''B<e>'', ''B<3>'' or SPACE '&
         &,'    and compound keys '&
         &,'=H-'&
         &,'The compound keys occur if i.e. some fields have automatic numbering '&
         &,'as hotkeys. All numbers greater than 9 consist of at least two digits. '&
         &,'The hotkey will be the sequence of these digits. '&
         &,'There may be other compound hotkeys.'&
         &,''&
         &,'If the first key is typed the first data item below the current (internal) '&
         &,'screen position is selected, which has a compound hotkey starting with '&
         &,'the typed key. '&
         &,'Now, you may continue to type the next key. After each key press '&
         &,'the current position jumps to the next item having a hotkey starting '&
         &,'with the sequence typed allready. If the key sequence, allready typed, '&
         &,'is uniqe among all screen items, the editing starts. If not, the next '&
         &,'key may be typed, or the TAB key may be used to cycle through all '&
         &,'items fiting into the current key sequence.'&
         &,'If the current sequence does not uniqely identify a single item, you'&
         &,'have to select the item, typing ENTER. '&
         &,'Again: TAB cycles through the set of possible items, ENTER starts editing.'&
         &,'As soon as the typed key sequence does not correspond any more to'&
         &,'a possible compound hotkey on the screen, the hotkey selection process'&
         &,'will abort. Another possibility to abort the hotkey selection is ESC-ESC'&
         &,'or any function key except ENTER.'&
         &,'Example: try to select the spacegroups 2,22,27,223! Its easy.'&
         &,'' 
    Write(lun,fmt)& 
         & 'SPACE has a special meaning. It is active if the symbol B<[]> '&
         &,'appears in the left corner of the menu bar. SPACE opens the alternative '&
         &,'menu, which adds additional submenus and functions. '&
         &,''&
         &,' '&
         &,'There are some classes of editable fields: '&
         &,'=H2 boolean switches (t,f) '&
         &,'are simply toggled by typing the hotkey. '&
         &,'=H2 binary switches  (1,2) '&
         &,'are simply toggled by typing the hotkey. '&
         &,'=H2 select boxes '&
         &,'the hotkeys change the selected data, marked by [*]. '&
         &,'=H2 check boxes '&
         &,'the hotkeys toggle the options '&
         &,'=H2 editable fields '&
         &,'these fields may be edited with the function keys explaind above. '&
         &,'A field may freely be edited until B<ENTER> or B<ESC-ESC> is '&
         &,'pressed. '&
         &,'If the first key stroke is an insert character, the string is '&
         &,'deleted and the field contains only this character: continue editing. '&
         &,'If any cursor movement or delete action is done, the editing starts'&
         &,'with the current string. '&
         &,'B<ENTER>: leave edit-mode and take changes. '&
         &,'If the new data value is invalid, an error message is shown in the '&
         &,'status-line and the edit-mode is reactivated, until the value is valid'&
         &,'or B<ESC-ESC> is pressed. '&
         &,'B<ESC-ESC>: leave edit-mode and restore old value '&
         &,'=H2 BASIS edit fields '&
         &,'these fields are explaind if needed, here the action of the keys is '&
         &,'restricted, to enforce valid data values. '&
         &,'=H2 connected fields ' 
    Write(lun,fmt)& 
         & 'These are editable fields, which are activated by the same hotkey. '&
         &,'After leaving the first field the editing continues with the next data '&
         &,'field.'&
         &,''&
         &,'=H2 Searching'&
         &,'When CONTROL-W or / is press the search utility is called and an '&
         &,'editable field appears in the status line. Enter the search string.'&
         &,'While you type, the screen will scroll to the next position matching '&
         &,'the current search string. If no more lines below the current position'&
         &,'match the string, the search may be continued at the top of the screen, '&
         &,'typing TAB or CONTROL-W. These keys cycle through occurances of the '&
         &,'search string.'&
         &,'As long as the search is active you may complete or edit the search '&
         &,'string using BACKSPACE or cursor keys. ESC-ESC and all function keys '&
         &,'which have no meaning in lineediting will cancel the search.'&
         &,'If the search is used in screens with data items, you may press ENTER'&
         &,'if the desired data item is selected. This will start the data editing'&
         &,'or just toggle the data value (if the data item is binary). To cancel '&
         &,'search without edit effects use ESC-ESC or other function keys.'&
         &,'The next time you press CONTROL-W or / the previous search string is '&
         &,'default. If you want to take it, just press CONTROL-W or TAB again. '&
         &,'Otherwise, type a new string or edit the current one. '&
         &,''&
         &,' '&
         &,'=H1 Menu bar '&
         &,' '&
         &,'The menu bar contains the following entries '&
         &,' '&
         &,'=H2 [] '&
         &,'SPACE will call the alternative menu.'&
         &,'=H2 extern edit (Expert mode)' 
    Write(lun,fmt)& 
         & 'Call the external editor.  This is strongly discouraged.'&
         &,'=H2 Quit/save '&
         &,'This leaves the tool. The files U<=.in>, U<=.basis> and U<=.sym> are saved.'&
         &,'You will be prompted for saving the files. '&
         &,'If you type ''y'' the files are saved.'&
         &,'If you type ''n'' all changes are discarded.'&
         &,'If you type ESC-ESC B<fedit> continues.'&
         &,'=H2 Exit/discard (Expert mode) '&
         &,'Exit B<fedit> without saving. '&
         &,'=H2 Help '&
         &,'In the help screens the scrolling is possible with keys explaind above. '&
         &,'Additionally a search function is available via CONTROL-W. '&
         &,' '&
         &,'=H1 Status line '&
         &,' '&
         &,'At the bottom of the screen a status line is visible. It provides '&
         &,'information about the success of the operations done. Non-critical '&
         &,'error messages are displayed there. '&
         &,'Have an eye on it!'&
         &,' '&
         &,'=H1 Alternative menu '&
         &,' '&
         &,'The alternative menu is activated with SPACE. The next key after space '&
         &,'may be one of the menu entry hotkeys or again SPACE, if the menu '&
         &,'continous (symbol U<[...]>)  or any other key (which closes the '&
         &,'menu).'&
         &,''&
         &,''&
         &,'=H2 Output'&
         &,'This submenu contains the control for the creation of output files. '&
         &,'=H2 Iteration' 
    Write(lun,fmt)& 
         & 'Control version and settings for the iteration process.'&
         &,'=H2 Restore '&
         &,'This function reloads all data from the files. '&
         &,'(All previous editing discarded.)  '&
         &,'=H2 Recreate '&
         &,'This function recreates U<=.in> (all data except symmetry definition and '&
         &,'basis) and thus the default data. (All previous editing discarded.)  '&
         &,'It is usefull for automatic input creation via U<fedit -pipe>.'&
         &,'To avoid unwanted input file states, the first action in pipemode'&
         &,'may be B<Recreate> to get the default settings.'&
         &,''&
         &,''&
         &,'=H1 GENERAL DATA '&
         &,''&
         &,'=H2 Title'&
         &,'Give the calculation a name, which appears in the output.'&
         &,'=H2 Atom'&
         &,'Specify the atom for which to calculate.'&
         &,'=H2 Spin sorts '&
         &,'B<2>= spin polarized calculation, B<1>= unpolarized '&
         &,'=H2 Vxc-potential '&
         &,'Activates a select box for the typ of the exchange and correlation '&
         &,'potential. '&
         &,'=H2 Relativistic '&
         &,'Select  box: non relativistic LSDA or full relativistic LSDA. '&
         &,'=H2 rel. xc-correction'&
         &,'If this is true, a relativistic correction to the LSDA will be used'&
         &,'for the Perdew and Zunger xc-potential.'&
         &,'B<IMPORTANT> The correction is numerically instable for large radii.'&
         &,'So, better do not use it. It is ment for tests only.'&
         &,'=H2 options ' 
    Write(lun,fmt)& 
         & 'Activates the B<OPTIONS> menu. '&
         &,''&
         &,'=H1 CONFINING POTENTIAL'&
         &,''&
         &,'=H2 Compression'&
         &,'If this is true, the confining potential will be switched on.'&
         &,'The resulting calculation has nothing to do with true physics,'&
         &,'it is for test purposes only, and may be suited to force convergence'&
         &,'in an initial run.'&
         &,'=H2 r0'&
         &,'The compression radius in Bohr radii.'&
         &,'=H2 N0'&
         &,'The exponent of the potential V(r)=(r/r0)^n0.'&
         &,''&
         &,'=H1  MESH OF RADIAL FUNCTIONS'&
         &,''&
         &,'=H2 Number of points'&
         &,'Number of radial mesh points.'&
         &,'=H2 rmin'&
         &,'Minimal mesh point'&
         &,'=H2 rmax'&
         &,'Maximal mesh point'&
         &,''&
         &,'=H1 TOLERANCE'&
         &,''&
         &,'=H2 Wave function match'&
         &,'The matching of the wave functions in the solver is controled'&
         &,'by this tolerance.'&
         &,''&
         &,'=H1 Files '&
         &,'' 
    Write(lun,fmt)& 
         & 'B<dirac>/B<fedit> needs several input files. '&
         &,'The main idea behind B<fedit> is, that B<dirac> is the master and'&
         &,'knows everything about its files and about their content and '&
         &,'semantics.'&
         &,'B<fedit> is the slave of B<dirac>. It is telled how to work by '&
         &,'B<dirac>, using communication files.'&
         &,' '&
         &,'=H2 Control files '&
         &,''&
         &,'U<+tmp/> temporary directory for B<fedit>. '&
         &,''&
         &,'U<+fedit,+tmp/+fedit> contains the screen control for fedit.'&
         &,'It must be present in both directories.'&
         &,'This file is allways deleted on B<fedit> startup. Then B<dirac> '&
         &,'is called by B<fedit>, to create U<+fedit>. If B<dirac> failes, '&
         &,'B<fedit> will not find U<+fedit> and will abort with error message. '&
         &,'In such cases U<+fedit> may be visible before B<fedit> was called. '&
         &,'The recreation process will delete it under assumption that B<dirac>'&
         &,'will successfully run. Please check the PATH variable to the B<dirac>'&
         &,'executable or just call B<dirac> from command line, to see if it runs.'&
         &,''&
         &,'U<+fedithelp> contains the help screens. It is allways recreated on'&
         &,'every invocation of B<fedit> (by a call to B<dirac>).'&
         &,''&
         &,'Both files may be deleted at any time, they just control the '&
         &,'comunication between B<fedit> and B<dirac>.'&
         &,''&
         &,'=H2 Data files'&
         &,''&
         &,'U<=.dirac> contains all informations for the B<dirac> calculation,'&
         &,'' 
    Write(lun,fmt)& 
         & 'Important:'&
         &,'If a default U<=.dirac> shall be created, the file has to be deleted '&
         &,'first. Or use submenu U<Recreate>'&
         &,''&
         &,'U<=.atpot> is a simple data file which contains the potential and field.'&
         &,'If an old potential shall be used as the start potential for the'&
         &,'next B<dirac> run then this file must exist. If the file does not fit to the'&
         &,'actual settings, its content is discarded.'&
         &,''&
         &,'If a bad potential is in =.atpot the calculation might hang.'&
         &,'Then delete U<=.atpot> and try again.'&
         &,''&
         &,'For creation of U<=.atpot> see submenu B<output>'&
         &,''&
         &,''&
         &,''&
         &,'=H2 Internals '&
         &,'The input files are organized using a C-like code. The data are '&
         &,'structured with the help of syntactical rules.'&
         &,''&
         &,'B<fedit> and B<dirac> call a parser to read the data. This makes'&
         &,'the data handling between both programms easier. However, if the user'&
         &,'wants to change the files by hand, he has to observe the syntax,'&
         &,'otherwise the parser will return with an error. The syntax is'&
         &,'not to complicated, so the user will understand it soon.'&
         &,'Nevertheless, hand made changes on the files are strongly discouraged'&
         &,'as well as changes performed by shell scripts. For automatization'&
         &,'there is a special B<fedit> mode called pipe-mode. It interprets'&
         &,'simple input files containing hotkey-data pairs. With the help of'&
         &,'this  tool one can write shell scripts which automatically '&
         &,'create B<dirac> input whithout messing around with the syntax/parser.' 
    Write(lun,fmt)& 
         & ''&
         &,'There are examples of such scripts in the distribution.'&
         &,''&
         &,''&
         &,'=H2 Saving and backup-files '&
         &,'The input file may be edited by B<fedit>. The changes are '&
         &,'saved on exit from B<MAIN MENU>. All file handling in between'&
         &,'are performed in the temporay directory U<+tmp>.'&
         &,'Exception: '&
         &,'A B<fedit> start in an empty directory (no input files) will call '&
         &,'B<dirac> in the current working directory to create a default set'&
         &,'of input files.'&
         &,'On every B<fedit> start all files are copied onto backup files.'&
         &,''&
         &,'If the function B<Restore> is used, the content of the files is reloaded'&
         &,'into the screens.'&
         &,''&
         &,''&
         &,'=H1 Error messages '&
         &,' '&
         &,'=H2 Status line errors. '&
         &,'If the editing of a field is not correct, a message is displayed. '&
         &,'Than the editing goes on. Correct the value or use ESC-ESC,  to'&
         &,'discard changes.'&
         &,''&
         &,'=H2 Tests '&
         &,'Before some action takes place, various data validity tests are '&
         &,'performed. '&
         &,'If errors occur, they will be displayed in a separate screen. Please '&
         &,'correct the  data and go on. You cannot save invalid data!'&
         &,'' 
    Write(lun,fmt)& 
         & '=H2 Parser errors.'&
         &,'If the syntax in U<+fedit> or in the input files is corrupted,'&
         &,'a error message is diplayed before B<fedit> will abort. The message'&
         &,'will say where the error occured. Depending on the nature of the error'&
         &,'you will find the file name in the page header or in the error message'&
         &,'itself. Normally there should be no parser errors. '&
         &,'Possible reason:'&
         &,'The file version changed as well as the file content.'&
         &,'If one now uses old files with hand made version number updates, the'&
         &,'parser will not find the new data. Please use the converter tools'&
         &,'for version updates.'&
         &,''&
         &,'=H2 Serious errors '&
         &,'If some serious errors occur, which the author hopes not to be the '&
         &,'case, the program will abort. For instance a file (temorary file) '&
         &,'is not found. Recompile and reinstall the tool or clean the U</tmp>. '&
         &,'In cases of internal errors please send a report.'&
         &,''&
         &,'=H1 Author '&
         &,' '&
         &,'(C) Klaus Koepernik December 2001 '&
         &,'e-mail:k.koepernik@ifw-dresden.de '&
         &,' '&
         &,''&
         &,''&
         &,'M<OUTPUT> '&
         &,' '&
         &,'B<OUTPUT> '&
         &,''&
         &,'This menu contains output settings, which control the file creation. '&
         &,'' 
    Write(lun,fmt)& 
         & ''&
         &,'=H1 Menu bar '&
         &,' '&
         &,'The menu bar contains the following entries '&
         &,' '&
         &,'=H2 exit '&
         &,'Exit to the B<MAIN MENU>. '&
         &,'=H2 help '&
         &,'this page '&
         &,''&
         &,''&
         &,'=H1 CREATE OUTPUT FILES FOR'&
         &,''&
         &,'=H2 Orbitals'&
         &,'If this is true, the orbitals will be saved in the files'&
         &,'U<+bas.large>: large component (or scalar wave function for non '&
         &,'relativistic calculation)'&
         &,'U<+bas.small>  small component (or derivative of scalar wave function in'&
         &,'non relativistic calculation)'&
         &,'The files U<+bas.largeq> and U<+bas.smallq> contain the second radial'&
         &,'functions for magnetic relativistic orbtials.'&
         &,'=H2 Denisty'&
         &,'If this is true, the file U<+atrho> will be written, containing the density'&
         &,'and spin density.'&
         &,'=H2 Potential'&
         &,'If this is true, the file U<=.atpot> will be written, containing the '&
         &,'potential and the magnetic field. '&
         &,'=H2 Overwrite'&
         &,'If this is false then the output files (written in every SC-cycle)'&
         &,'will be saved in a separate file with the cycle number as suffix.'&
         &,'This is a debug option.' 
    Write(lun,fmt)& 
         & ''&
         &,''&
         &,''&
         &,'M<options> '&
         &,''&
         &,'=H2 SIC_ALL'&
         &,'B<EXPERIMENTAL OPTION>'&
         &,'=H2 SIC_4F'&
         &,'B<EXPERIMENTAL OPTION>'&
         &,'=H2 CALC_ONLY_OCCUPIED'&
         &,'Avoid calculation of unoccupied states. This may help if'&
         &,'the unoccupied orbitals, resulting from the internal occupation'&
         &,'scheme are not bound properly. Since they are unpccupied, we'&
         &,'may just ignore them.'&
         &,'Without this option, the code will check, if the aufbau-principle'&
         &,'in the relativistic magnetic nl-shell is fulfilled.'&
         &,'This may give a hint, wether the calculation was correct.'&
         &,'The resulting error message/warning, when the aufbau-principle is'&
         &,'violated, may be ignored, if it occurs in an intermediate'&
         &,'iteration cycle. Only the last cycle is important (convergence'&
         &,'assumed).'&
         &,'If problems occur see option B<FORCE_POSITIVE_SPIN>.'&
         &,'=H2 FORCE_POSITIVE_SPIN'&
         &,'For magnetic relativistic calculations it may easily happen that'&
         &,'the aufbau-principle is violated since the iteration process produces'&
         &,'an inversed field, just by chance.'&
         &,'This option assures, that the resulting total spin is positive'&
         &,'and thus the occupation numbers used in the code will be correct'&
         &,'for normal situations.'&
         &,''&
         &,'' 
    Write(lun,fmt)& 
         & ''&
         &,''&
         &,'M<ITERATION> '&
         &,' '&
         &,'B<ITERATION> '&
         &,' '&
         &,'This submenu contains the details to control the iteration procedure.'&
         &,' '&
         &,'=H1 General remarks '&
         &,' '&
         &,'There are three possibilities to perform the iteration, '&
         &,'"Simple mix", "Iterat" and "Iterat with linear progress control".'&
         &,'Simple mix is the simplest scheme, where some percent of the new'&
         &,'solution are mixed into the old solution to get a new start potential.'&
         &,'Usually it is stable, but very slow.'&
         &,''&
         &,'Iterat is a heuristic scheme, which uses the iteration history'&
         &,'to predict the "best" new density. This scheme is very fast.'&
         &,'In some cases it may run into troubles, then a random step is'&
         &,'made, to get out of a closed cycle.'&
         &,''&
         &,'Normaly, one would use Iterat.'&
         &,''&
         &,'The Iterat with linear progress control is a newer idea, '&
         &,'which may fail in some cases. It is not yet tested enough. However, '&
         &,'the main idea behind it, is to force the iteration progress in some '&
         &,'circumstances where iterat will make a bad choice. So, if iterat does'&
         &,'jump around to long time try this one.'&
         &,'The initial bad iterations may be quite a lot. Sometimes it is '&
         &,'a good idea to start with a non relativistic calculation to'&
         &,'get a good start potentials for relativistic calculations.' 
    Write(lun,fmt)& 
         & ''&
         &,''&
         &,'=H1 Menu bar '&
         &,' '&
         &,'The menu bar contains the following entries '&
         &,' '&
         &,'=H2 exit '&
         &,'Exit to the B<MAIN MENU>. '&
         &,'=H2 help '&
         &,'this page '&
         &,' '&
         &,'=H1 Iteration control '&
         &,' '&
         &,''&
         &,'=H2 Number of iterations'&
         &,'The maximal allowed number of iteration cucles.'&
         &,'=H2 Version '&
         &,'A select box for the version choice.'&
         &,' '&
         &,'=H2 Mixing '&
         &,'"Simple mix": gives the amount of mixing of the new solution '&
         &,'vector into the previous solution vector.'&
         &,'"Iterat ...": gives the amount by which the subspace interpolation '&
         &,'is used, this is only the starting and maximum value of mixing, '&
         &,'the internally used value is calculated from interpolation history. '&
         &,'=H2 Max subspace dim'&
         &,'Only "Iterat ..."'&
         &,'The new solution vector is calculated using a linear '&
         &,'interpolation within the subspace spanned by the last '&
         &,'solution vectors. This number limits the maximal allowed '&
         &,'dimension of this space.' 
    Write(lun,fmt)& 
         & '=H2 Progress control'&
         &,'This number controls the nonlinearities of the interpolation.'&
         &,'The smaller this value the longer the dimensionalty of'&
         &,'the present subspace will be retained. '&
         &,''&
         &,''&
         &,''&
         &,''&
         &,''
    !!
    Close(lun)
    !!
  End Subroutine create_helpfile_dirac

End Module helpdirac

