!make sure the sym loginc subgroupgenerators is correct With updates and stuff

!Read in subgroupgenerators from =.in

!!----DEBUG options-----------------|
!! SUBFUNC    | MODES               |
!!----------------------------------|
!!----------------------------------|
Module io
  !!
  Use precisiondefs
  Use memory
  Use file_iounits
  Use errors
  Use atomdefs
  Use finuc
  Use tsymmetry
  Use symmetry
  Use tnumerics
  Use tbandplot
  Use ttopoins
  Use topoins
  Use constants
  Use tforces
  Use tgrid
  Use tdiracdefs
  Use versioncontrol
  Use tpotentialdensity
  Use titeration
  Use tcoreoccupation
  Use terg
  Use tbzone
  Use topc
  Use tfatband
  Use tmol
  Use tmesh
  Use torbitalbasis
  Use sort
  Use orbitalbasis
  Use tkohnsham
  Use tio
  Use ioaux
  Use bandplot
  Use fploiointernal
  Use tcpa
  Use toptics
  Use optics
  Use xc
  Use trelativistic
  Use optionstest
  Use ioadapter
  Use tlsdau
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="IO"  
  !!
  Public :: fplo_io,sym_io,lYN&
       &,IO_ACTION_NEW_FILE,IO_ACTION_RUN,IO_ACTION_STRUCTURE_UPDATE&
       &,IO_ACTION_WRITE_FILE,IO_ACTION_RECREATE_SYM_FILE&
       &,write_in_sym_file,read_old_xreduce_file,read_old_mol_charge_file&
       &,read_old_charging_file,read_old_atcharge,read_old_coeff_file

  !!***********************************************************************
  Integer(t_int),Parameter  :: IO_ACTION_NEW_FILE         =1_t_int
  Integer(t_int),parameter  :: IO_ACTION_RUN              =2_t_int
  Integer(t_int),parameter  :: IO_ACTION_STRUCTURE_UPDATE =3_t_int
  Integer(t_int),parameter  :: IO_ACTION_WRITE_FILE       =4_t_int
  Integer(t_int),parameter  :: IO_ACTION_RECREATE_SYM_FILE=5_t_int
  !!***********************************************************************
  
Contains
  
  !!***********************************************************************
  !!
  Logical(t_log) Function lYN()
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(10) :: YN
    !!
    Read(*,"(a10)") YN
    
    lYN=(Index(YN,'y') /= 0_t_int) .Or. (Index(YN,'Y') /= 0_t_int)
    !!     
  End Function lYN
  !!***********************************************************************
  

  !!***********************************************************************
  Subroutine fplo_io(action&
       &,compound,newsymmetry,newstructure&
       &,newlattice_constants_S,newaxis_angles_s,IOnewwtau_S&
       
       &,symmetry,structure&
       &,mspin,initial_spin_split&
       &,spin_split&
       &,relativistic,quant&
       !&,diracdefs&
       &,potential,iteration,bzone&
       &,radialmesh,radialmesh_rmaxfactor,atommesh,numerics,coreoccu&
       !&,basis&
       &,kohnsham,cpacontrol,etotstack,loptions,bandplot,ldos&
       &,out_level,xcvers,etot,forces&
       &,opc,lsdau,Ufactor,stopsym,verstop,adapt_max_L&
       !&,mol&
       &,gridplot,bwdefs,topoins,optics&
       &)
    Implicit None 
    !!IO
    Type(T_Symmetry),Intent(in),Target :: newsymmetry
    Type(T_Structure),Intent(in),Target:: newstructure
    Logical(t_log),Intent(in)   :: stopsym
    Logical(t_log),Intent(in)   :: verstop,adapt_max_L
    Character(200),Intent(in),Target   :: IOnewwtau_S(:,:)
    Character(200),Intent(in),Target   :: newlattice_constants_S(3)
    Character(200),Intent(in),Target   :: newaxis_angles_s(3)
    Character(*),Intent(inout)  :: compound
    Integer(t_int),Intent(in)   :: action

    Logical(t_log),Intent(out)  :: initial_spin_split
    Integer(t_int),Intent(out)  :: out_level,xcvers,relativistic
    Integer(t_int),Intent(out)  :: mspin
    Real(t_real),Intent(out)    :: radialmesh_rmaxfactor
    Real(t_real),Intent(out)    :: Ufactor
    Real(t_real),Pointer        :: spin_split(:) !! intent(out)

    Type(T_Symmetry),Intent(out),Target  :: symmetry
    Type(T_Structure),Intent(out),Target :: structure
    Type(T_Etot),Intent(out)      :: etot
    Type(T_Forces),Intent(out)    :: forces
    Type(T_Etotstack),Intent(out) :: etotstack
    Type(T_Bandplot),Intent(out)  :: bandplot
    Type(T_LDOS),Intent(out)      :: ldos
    Type(T_Potential),Intent(inout) :: potential
    Type(T_Optics),Intent(inout) ::  optics
    Type(T_Iteration),Intent(out) :: iteration
    Type(T_Options),Intent(out)   :: loptions
    Type(T_Coreoccu),Intent(out)  :: coreoccu
    Type(T_Bzone),Intent(out)     :: bzone
    Type(T_Mesh),Intent(out)      :: radialmesh,atommesh
    Type(T_Numerics),Intent(out)  :: numerics
!    Type(T_Basis),Intent(out)     :: basis
    Type(T_Kohnsham),Intent(out)  :: kohnsham
    Type(T_Cpacontrol),Intent(out):: cpacontrol
    Type(T_Lsdau),Intent(out)     :: lsdau
    Type(T_OPC),Intent(out)       :: opc
    !Type(T_Mol),Intent(inout)     :: mol
    Type(T_GridPlot),Intent(inout):: gridplot
    Type(T_BWDefs),Intent(inout)  :: bwdefs
    Type(T_TopoIns),Intent(inout) :: topoins
    Type(T_Quant),Intent(out)     :: quant
!    Type(T_Diracdefs),Intent(out) :: diracdefs
!    Type(T_Diracdefs),Intent(inout) :: diracdefs
    !!LOCAL
    Character(*),Parameter::nsubfunc="fplo_io"
    Type(T_Options),Target     :: newoptions
    Type(T_Grid),Pointer     :: gr
    Integer :: icheck
    Integer(t_int)       :: rank,asize(8),no
    Character(200)      :: iteration_control_tolerance_S
    Character(200)      :: force_iteration_control_tol_S
    Character(200)      ::  mainversion,subversion
    Character(200)      :: iteration_control_mixing_S
    Character(200)      :: iteration_control_progres_S
    Character(200)      :: lsdau_omat_dev_S,Ufactor_S
    Character(200)      :: bzone_mp_range_S,bzone_mp_width_S,bzone_kT
    Character(200),Allocatable  :: lsdau_u_f(:,:)
    Character(200),Allocatable,Target  :: IOwtau_S(:,:)
    Character(200),Allocatable  :: spin_split_S(:)
    Character(2),Allocatable    :: spin_split_ele_S(:)
    Character(200),Allocatable  :: structure_conao_S(:)
    Character(2),Allocatable    :: structure_conao_ele_S(:)
    Character(200),Allocatable  :: bandplot_points_S(:,:)
    Character(200),Allocatable  :: coreoccu_spinup_S(:,:)
    Character(200),Allocatable  :: coreoccu_spindn_S(:,:)
    Character(200)      :: radialmesh_rmin_S,radialmesh_rmax_S
    Character(200)      :: radialmesh_rmaxfactor_S
    Character(200)      :: atommesh_rmin_S,atommesh_rmax_S
    Character(200)      :: numerics_cuttol_dens_S,numerics_cuttol_pot_S
    Character(200)      :: numerics_cuttol_orbital_S
    Character(200)      :: numerics_symtesttol_S
    Character(200)      :: numerics_eweps_r_S
    Character(200)      :: numerics_eweps_g_S
!    Character(200)      :: basis_exn0_S
    Character(200)      :: fsm_moment_S
    Character(200)      :: cpacontrol_eimagdos_S,cpacontrol_eimagscf_S    
    Character(200)      :: cpacontrol_efermi0_S,cpacontrol_slop_0_S
    Character(200)      :: cpacontrol_slop_min_S
    Character(200)      :: cpacontrol_emin0_S,cpacontrol_emax0_S
    Character(200),Target      :: lattice_constants_S(3)
    Character(200),Target      :: axis_angles_s(3)
    Character(200)      :: etotstack_etot_tolerance_S
    Character(200)      :: bandplot_emin_S,bandplot_emax_S
    Character(200)      :: bandplot_x_axis_S(3),bandplot_z_axis_S(3)
    Character(200)      :: quant_axis_S(3)
    Character(200)      :: potential_xreduce_S
    Character(200)      :: potential_molecule_ionicity_S
    Character(200)      :: optics_emin_S,optics_emax_S
    Logical(t_log)      :: warn,stopit,complain_subgroups!,exist_devel!,exist_basis
    Integer(t_int)      :: issaIO,i,j,k,ver,n,idum
    Real(t_real)   :: dum
    Integer(t_int),Pointer :: iugen(:)
    logical(t_log),Pointer :: ltmp(:)
    Integer(t_int),Pointer :: itmp(:)
    Character(200),Pointer :: ctmp(:)
    Character(200),Pointer :: vcaZ_S(:)
    Character(200),Pointer :: ctmp2(:,:)
    Integer(t_int),Pointer :: itmp2(:,:)
    Integer(t_int),Pointer :: itmp3(:,:,:)
    Real(t_real),Pointer   :: dtmp2(:,:)
    Real(t_real),Pointer   :: dtmpemin(:,:,:)
    Real(t_real),Pointer   :: dtmpemax(:,:,:)
    Real(t_real),Pointer   :: dtmpde(:,:,:)
    Real(t_real),Pointer   :: dtmpkpoint(:,:,:)
    Real(t_real),Pointer   :: dtmpeminmax(:,:,:)
    Character(200),Pointer :: direction1_S(:,:)
    Character(200),Pointer :: direction2_S(:,:)
    Character(200),Pointer :: direction3_S(:,:)
    Character(200),Pointer :: origin_S(:,:)
    Character(200),Pointer :: kpoint_S(:,:,:)
    Character(200),Pointer :: eminmax_S(:,:,:)
    Character(200)      :: status
    Type(T_Symmetry),Pointer :: sym
    Type(T_Structure),Pointer:: str
    Character(200),Pointer:: lat(:)
    Character(200),Pointer:: ang(:)
    Character(200),Pointer:: wtau(:,:)
    Nullify(iugen)
    Nullify(ltmp,vcaZ_S)
    Nullify(itmp)
    Nullify(ctmp)
    Nullify(ctmp2)
    Nullify(itmp2)
    Nullify(itmp3)
    Nullify(dtmp2)
    Nullify(dtmpemin)
    Nullify(dtmpemax)
    Nullify(dtmpde)
    Nullify(dtmpkpoint)
    Nullify(dtmpeminmax)
    Nullify(direction1_S)
    Nullify(direction2_S)
    Nullify(direction3_S)
    Nullify(kpoint_S)
    Nullify(eminmax_S)
    Nullify(origin_S)
    !!
    Call init_options(newoptions)
    !!
    !!
    Call palloc('kpoint_S',kpoint_S,1_t_int,1_t_int,1_t_int,1_t_int&
         &,1_t_int,1_t_int,nmodule,nsubfunc)
    Call palloc('eminmax_S',kpoint_S,1_t_int,1_t_int,1_t_int,1_t_int&
         &,1_t_int,1_t_int,nmodule,nsubfunc)

!!$    Inquire(file=f_fplo_basis ,exist=exist_basis)
!!$    Inquire(file=f_fplo_devel ,exist=exist_devel)

    ver=VERSION_OK
    
    runif1:If(action /= IO_ACTION_NEW_FILE )Then
       
       Call initparser
       Call readfile(f_fplo_in)
       
       If(action == IO_ACTION_RUN .Or. &
            &action == IO_ACTION_RECREATE_SYM_FILE .Or.&
            &action == IO_ACTION_STRUCTURE_UPDATE )Then
          Call getstring("version.mainversion",mainversion)
          Call getstring("version.subversion",subversion)
          ver=checkversion(mainversion,subversion,f_fplo_in)

          !!Call getstring("compound",compound)
       Endif
       If(action == IO_ACTION_RUN .Or. &
            &action == IO_ACTION_RECREATE_SYM_FILE)Then
          Call getstring("compound",compound)
       Endif
       If(action == IO_ACTION_RUN .And. .Not. stopsym .And. .Not. verstop)then!&
          !&.And. exist_basis)Then

          Write(outfile,"(72('-'),/,'Compound: ',a,/,72('-'))")Trim(compound)
          Call copy_file_to_output(outfile,f_fplo_in)
       Endif

       !! symmetry,structure
       Call getinteger("lengthunit.type",structure % lengthunit)
       Call getinteger("spacegroup.number",symmetry % spgrpnum )

       If( variable_exists('subgroupgenerators'))Then
          Call getrankandsize("subgroupgenerators",rank,asize)
          symmetry% nugen=asize(1)
          Call palloc('iugen',iugen,1_t_int,symmetry% nugen,nmodule,nsubfunc)
          Call getinteger('subgroupgenerators',iugen)
          symmetry% iugen(1:symmetry% nugen)=iugen(1:symmetry% nugen)
          Call pfree(iugen)
       Else
          symmetry% nugen=0_t_int 
          symmetry% iugen(:)=0_t_int
       Endif


       Call getreal("lattice_constants",symmetry % lattice_constants )
       Call getrealasstring('lattice_constants',lattice_constants_S)
       Call getreal("axis_angles",symmetry % axis_angles )
       Call getrealasstring("axis_angles",axis_angles_S )

       !! read wyckoff positions       
       Call getinteger("nsort",structure % IOnsort )

       Call palloc('structure % p_IOelements',structure % p_IOelements &
            &,1_t_int,structure% IOnsort&
            &,nmodule,nsubfunc)

       Call palloc('structure % p_IOwtau',structure % p_IOwtau &
            &,1_t_int,3_t_int&
            &,1_t_int,structure% IOnsort&
            &,nmodule,nsubfunc)

       Allocate(IOwtau_S(3_t_int,structure % IOnsort),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for IOwtau_S !'")
       Endif

       Call getstring("wyckoff_positions.element",structure % p_IOelements)
       Call getreal("wyckoff_positions.tau",structure % p_IOwtau)
       Call getrealasstring("wyckoff_positions.tau",IOwtau_S)


       If( variable_exists('structure_type.type'))Then
          Call getinteger('structure_type.type',structure% str_type)
       Else
          structure% str_type=STR_TYPE_CRYSTAL
       Endif
       
       !complain_subgroups=.False.
       complain_subgroups=.True. !! not clear if needed, let's be tight about it

       If(action == IO_ACTION_RUN) complain_subgroups=.True.

       !! setup symmetry and structure
       If(action == IO_ACTION_STRUCTURE_UPDATE .Or.&
            & action == IO_ACTION_RECREATE_SYM_FILE .Or.&
            & stopsym.Or.verstop )then!.Or. .Not.exist_basis)Then
          Call crystal_structure_setup(symmetry,structure,complain_subgroups&
               &,save_syminfo=.False.)
       Else
          Call crystal_structure_setup(symmetry,structure,complain_subgroups&
               &,save_syminfo=.False.)
       Endif

       !!
       Call getinteger("max_L",potential % max_LIO )
       If(adapt_max_L) potential % max_LIO=Min(4_t_int,potential% max_LIO)
       !!

       !! new-version-data which also belong to f_fplo_sym
       !! to be managed before this line!!!

       recreateif1: If(action == IO_ACTION_RECREATE_SYM_FILE)Then
          status='ready'
          Call create_symfile(status,compound &
               &,symmetry% spgrpnum&
               &,symmetry% nugen&
               &,symmetry% iugen&
               &,structure&
               &,lattice_constants_S&
               &,axis_angles_S&
               &,IOwtau_S&
               )
          
          !!cleanup
          Call cleanreadfile
          Call pfree(structure% p_IOelements)
          Call pfree(structure% p_IOwtau)
          Call pfree(structure% p_tau)
          Call pfree(structure% p_IOisrt)
          Call pfree(structure% p_IOmult)
          Call pfree(structure% p_kaps)
          Call pfree(structure% p_IOconao)
          If(Allocated(IOwtau_S)) Deallocate(IOwtau_S)
          
          Return
       Endif recreateif1
       
       Allocate(structure_conao_S(structure % IOnsort),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for structure_conao_S !'")
       Endif
       Allocate(structure_conao_ele_S(structure% IOnsort),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for structure_conao_ele_S !'")
       Endif
       

       Call getreal('concentrations.concentration',structure % p_IOconao)
       Call getstring('concentrations.atom',structure_conao_ele_S)
       Call getrealasstring('concentrations.concentration',structure_conao_S)


       !!

       Call getinteger("xc_potential.type",xcvers)
       !! outlevel
       Call getinteger("verbosity_level.type",out_level) 


       Call getinteger('relativistic.type',relativistic)
       !!
       If( variable_exists('nuclear_model.type'))Then
          Call getinteger('nuclear_model.type',potential% nuc_type)
       Else
          potential% nuc_type=FINUC_NONE
       Endif

       If( variable_exists('ex_field_strength'))Then
          Call getrealasstring('ex_field_strength',potential_xreduce_S)
          Call getreal('ex_field_strength',potential% xreduce)
       Else
          Call read_old_xreduce_file(potential,protect=.False.)
          Write(potential_xreduce_S,"(a)")stringify_double100(potential% xreduce)
       Endif

       If( variable_exists('charges.ionicity'))Then
          Call getrealasstring('charges.ionicity',potential_molecule_ionicity_S)
          Call getreal('charges.ionicity',potential% molecule_ionicity)
          Call getinteger("charges.chargemode.type",potential% chargemode) 
          Call getlogical("charges.make_vca",potential% make_vca) 
          
          Call getrankandsize("charges.vca",rank,asize)
          potential% nvca=asize(1)
          Call palloc('potential% p_vcasort',potential% p_vcasorts&
               &,1_t_int,potential% nvca,nmodule,nsubfunc)
          Call palloc('potential% p_vcaZ',potential% p_vcaZ&
               &,1_t_int,potential% nvca,nmodule,nsubfunc)
          Call palloc('vcaZ_S',vcaZ_S,1_t_int,potential% nvca,nmodule,nsubfunc)
          Call getinteger('charges.vca.sort',potential% p_vcasorts)
          Call getreal('charges.vca.Z',potential% p_vcaZ)
          Call getrealasstring('charges.vca.Z',vcaZ_S)
       Else
          potential% chargemode=CHARGEMODE_NONE
          Call read_old_mol_charge_file(potential,protect=.False.)
          Call read_old_charging_file(potential,protect=.False.)
          Write(potential_molecule_ionicity_S,"(a)")&
               &stringify_double100(potential% molecule_ionicity)
          Call read_old_atcharge(potential,protect=.False.)
          Call palloc('vcaZ_S',vcaZ_S,1_t_int,potential% nvca,nmodule,nsubfunc)
          Do i=1,potential% nvca
             vcaZ_S(i)=stringify_double100(potential% p_vcaZ(i))
          Enddo
       Endif
       Call getinteger('spin.mspin',mspin)
       Call getlogical('spin.initial_spin_split',initial_spin_split)
       Call getlogical('fsmoment.fsm',kohnsham% fsm)
       Call getreal('fsmoment.moment',kohnsham% fsm_moment)
       Call getrealasstring('fsmoment.moment',fsm_moment_S)


       If( variable_exists('quantization_axis'))Then
          Call getreal('quantization_axis',quant% axis)
          Call getrealasstring('quantization_axis', quant_axis_S)
       Else
          quant% axis(1:2)=0.0_t_real
          quant% axis(3)=1.0_t_real
          quant_axis_S(1:2)="0"
          quant_axis_S(3)="1"
       Endif



!!$       If( variable_exists('spin_pop_type.type'))Then
!!$          Call getinteger('spin_pop_type.type',diracdefs% spin_pop_type)
!!$       Else
!!$          diracdefs% spin_pop_type=REL_SPIN_CHAR_CSCV
!!$       Endif




       !! initial spin split
       Call palloc('spin_split',spin_split &
            &,1_t_int,structure% IOnsort&
            &,nmodule,nsubfunc)

       Allocate(spin_split_S(structure% IOnsort),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for spin_split_S !'")
       Endif
       Allocate(spin_split_ele_S(structure% IOnsort),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for spin_split_ele_S !'")
       Endif

       Call getstring('initial_spin_split.element',spin_split_ele_S)        
       Call getreal('initial_spin_split.split',spin_split)
       Call getrealasstring('initial_spin_split.split',spin_split_S)



       Call getinteger('nband',kohnsham% io_nband)




!!$       !! basis
!!$
!!$       Call getreal('confining_potential.exponent',basis% exn0)
!!$       Call getrealasstring('confining_potential.exponent',basis_exn0_S)

       !! CPA 

       Call getinteger('cpa_fermi_control.max_ef_loops'&
            &,cpacontrol% max_ef_loops)
       Call getinteger('cpa_control.nec',cpacontrol% nec)
       Call getinteger('cpa_control.max_se_loops',cpacontrol% max_se_loops)
       Call getreal('cpa_control.emin0',cpacontrol% emin0)
       Call getrealasstring('cpa_control.emin0',cpacontrol_emin0_S)
       Call getreal('cpa_control.emax0',cpacontrol% emax0)
       Call getrealasstring('cpa_control.emax0',cpacontrol_emax0_S)

       If( variable_exists('cpa_control.eimag'))Then
          Call getreal('cpa_control.eimag',cpacontrol% eimagscf)
          Call getrealasstring('cpa_control.eimag',cpacontrol_eimagscf_S)
       Else
          cpacontrol% eimagscf=1.0e-5_t_real
          cpacontrol_eimagscf_S="1.0e-5"
       Endif

       Call getreal('cpa_fermi_control.efermi0',cpacontrol% efermi0)
       Call getrealasstring('cpa_fermi_control.efermi0',cpacontrol_efermi0_S)
       Call getreal('cpa_fermi_control.slop_0',cpacontrol% slop_0)
       Call getrealasstring('cpa_fermi_control.slop_0',cpacontrol_slop_0_S)
       Call getreal('cpa_fermi_control.slop_min',cpacontrol% slop_min)
       Call getrealasstring('cpa_fermi_control.slop_min',cpacontrol_slop_min_S)
       Call getinteger('cpa_fermi_method.type',cpacontrol% fermi_method)

       Call getinteger('cpa_dos.ne',cpacontrol% nedos)
       Call getreal('cpa_dos.eimag',cpacontrol% eimagdos)
       Call getrealasstring('cpa_dos.eimag',cpacontrol_eimagdos_S)
       !Call getinteger('cpa_bloch_spectral_density.ne',cpacontrol% neakbl)
       !Call getreal('cpa_bloch_spectral_density.eimag',cpacontrol% eimagakbl)
       !Call getrealasstring('cpa_bloch_spectral_density.eimag'&
       !     &,cpacontrol_eimagakbl_S)

       !! radial mesh
       Call getinteger('radial_mesh.nr',radialmesh % nr)
       Call getreal('radial_mesh.rmin',radialmesh % rmin)
       Call getrealasstring('radial_mesh.rmin',radialmesh_rmin_S)
       Call getreal('radial_mesh.rmax',radialmesh % rmax)
       Call getrealasstring('radial_mesh.rmax',radialmesh_rmax_S)
       Call getreal('radial_mesh.rmax_factor',radialmesh_rmaxfactor)
       Call getrealasstring('radial_mesh.rmax_factor',radialmesh_rmaxfactor_S)

       !! atomic mesh
       Call getinteger('atom_radial_mesh.nr',atommesh % nr)
       Call getreal('atom_radial_mesh.rmin',atommesh % rmin)
       Call getrealasstring('atom_radial_mesh.rmin',atommesh_rmin_S)
       Call getreal('atom_radial_mesh.rmax',atommesh % rmax)
       Call getrealasstring('atom_radial_mesh.rmax',atommesh_rmax_S)

       !! numerics

!!$       If( variable_exists('ewald_parameter.cutoff'))Then
!!$          Call getreal('ewald_parameter.cutoff',numerics% ewcutoff)
!!$          Call getrealasstring('ewald_parameter.cutoff',numerics_ewcutoff_S)
!!$       Else
!!$          numerics% ewcutoff=2.0
!!$          numerics_ewcutoff_S="2.0"
!!$       Endif
       If( variable_exists('ewald_parameter.eps_r'))Then
          Call getreal('ewald_parameter.eps_r',numerics% eweps_r)
          Call getrealasstring('ewald_parameter.eps_r',numerics_eweps_r_S)
       Else
          numerics% eweps_r=1.0e-5
          numerics_eweps_r_S="1.0e-5"
       Endif
       If( variable_exists('ewald_parameter.eps_g'))Then
          Call getreal('ewald_parameter.eps_g',numerics% eweps_g)
          Call getrealasstring('ewald_parameter.eps_g',numerics_eweps_g_S)
       Else
          numerics% eweps_g=1.0e-5
          numerics_eweps_g_S="1.0e-5"
       Endif
       
       Call getlogical('calc_etot',etot% etot_calc)
       Call getreal('etot_tolerance',etotstack% etot_tolerance)
       Call getrealasstring('etot_tolerance',etotstack_etot_tolerance_S)


       Call getinteger('interpolation.degree',numerics % degree)

       !Call getreal('cutoff_tolerances.dens',numerics % cuttol_dens)
       numerics_cuttol_dens_S='1.e-9'
       numerics_cuttol_pot_S='1.e-12'
       !Call getrealasstring('cutoff_tolerances.dens',numerics_cuttol_dens_S)
       !Call getreal('cutoff_tolerances.pot',numerics % cuttol_pot)
       !Call getrealasstring('cutoff_tolerances.pot',numerics_cuttol_pot_S)
       Call getreal('cutoff_tolerances.orbital',numerics % cuttol_orbital)
       Call getrealasstring('cutoff_tolerances.orbital'&
            &,numerics_cuttol_orbital_S)

       !Call getinteger('nfft_ewp_per_site',numerics % nfft_ewp_per_site)




       Call getinteger('one_center_integrals.nr',numerics % oci_nr)

       Call getinteger('overlap_density_calc.nr',numerics % ovldns_nr)
       Call getinteger('overlap_density_calc.neta',numerics % ovldns_neta)



       Call getinteger('coulomb_energy_calc.nxi',numerics% coulerg_nxi)
       Call getinteger('coulomb_energy_calc.neta',numerics% coulerg_neta)


       Call getreal('symtest.tol',numerics% symtesttol)
       Call getrealasstring('symtest.tol',numerics_symtesttol_S)

       !! iteration controll
       Call getinteger('iteration_control.steps',  iteration% steps)
       Call getinteger('iteration_control.maxdim', iteration% maxdim)
       Call getinteger('iteration_version.scheme', iteration% scheme)
       Call getreal('iteration_control.tolerance', iteration% tolerance)
       Call getreal('iteration_control.mixing',    iteration% mixing)
       Call getreal('iteration_control.progress',  iteration% progress)

       If( variable_exists('iteration_convergence_condition.type'))Then
          Call getinteger('iteration_convergence_condition.type'&
               &, iteration% convcond)
       Else
          iteration% convcond=CONVCOND_ITERAT
       Endif

       Call getrealasstring('iteration_control.tolerance'&
            &, iteration_control_tolerance_S)
       Call getrealasstring('iteration_control.mixing'&
            &, iteration_control_mixing_S)
       Call getrealasstring('iteration_control.progress'&
            &, iteration_control_progres_S)


       !! force iteration controll
       If(variable_exists('force_iteration_control'))Then
          Call getinteger('force_iteration_control.steps'&
               &,forces% forceiteration_control% steps)
          Call getinteger('force_iteration_control.maxdim'&
               &,forces% forceiteration_control% maxdim)
          Call getreal('force_iteration_control.tolerance'&
               &,forces% forceiteration_control% tolerance)
          Call getrealasstring('force_iteration_control.tolerance'&
               &, force_iteration_control_tol_S)
          Call getinteger('force_iteration_version.scheme'&
               &,forces% forceiteration_control% scheme)
       Else
          forces% forceiteration_control% steps=100
          forces% forceiteration_control% maxdim=0
          forces% forceiteration_control% scheme=IT_SCHEME_MINITERAT
          forces% forceiteration_control% tolerance=1.0e-3_t_real
          force_iteration_control_tol_S='1.0e-3'
       Endif
       If(variable_exists('force_in_each_step'))Then
          Call getlogical('force_in_each_step'&
               &, forces% force_in_each_step)
          
       Else
          forces% force_in_each_step=.False.
       Endif
       If(variable_exists('approx_nodndL_ewald'))Then
          Call getlogical('approx_nodndL_ewald'&
               &, forces% approx_nodndL_ewald)
          
       Else
          forces% approx_nodndL_ewald=.False.
       Endif
       If(variable_exists('force_mode.mode'))Then
          Call getinteger('force_mode.mode'&
               &, forces% force_mode)
          
       Else
          forces% force_mode=FORCE_MODE_NONE
       Endif
       If( variable_exists('geomopt_sites'))Then
          Call getrankandsize('geomopt_sites',rank,asize)
          forces% ngeomopt_sites=asize(1_t_int)
          Call palloc('forces% p_geomopt_sites',forces% p_geomopt_sites &
               &,1_t_int,Max(1_t_int,forces% ngeomopt_sites)&
               &,nmodule,nsubfunc)
          Call getinteger('geomopt_sites',forces% p_geomopt_sites)
       Else
          forces% ngeomopt_sites=0
          Call palloc('forces% p_geomopt_sites',forces% p_geomopt_sites&
               &,1_t_int,Max(1_t_int,forces% ngeomopt_sites),nmodule,nsubfunc)
       Endif


       !! bzone integration
       Call getinteger('bzone_method.type',bzone % method)
       Call getlogical('bzone_integration.metal',bzone % metal)
       Call getinteger('bzone_integration.nkxyz',bzone % nkxyz)
       Call getinteger('mp_bzone_integration.ne',idum)
       Call getinteger('mp_bzone_integration.norder',bzone % mp_norder)
       Call getreal('mp_bzone_integration.range',dum)
       Call getreal('mp_bzone_integration.width',bzone % mp_width)
       Call getrealasstring('mp_bzone_integration.range',bzone_mp_range_S)
       Call getrealasstring('mp_bzone_integration.width',bzone_mp_width_S)


       If( variable_exists('bzone_kT'))Then
          Call getreal('bzone_kT', bzone% kTmax)
          Call getrealasstring('bzone_kT', bzone_kT)
       Else
          bzone% kTmax=100.0_t_real
          bzone_kT='100.0'
       Endif


       !! options
       Call  getrankandsize("options",rank,asize)
       loptions% noptions=asize(1_t_int)

      
       Call palloc('loptions% p_options',loptions% p_options &
            &,1_t_int,Max(1_t_int,loptions% noptions)&
            &,nmodule,nsubfunc)

       Call  getflag('options',loptions% p_options)

       
       Call getlogical('bandplot_control.bandplot',bandplot % plotbands)
       Call getlogical('bandplot_control.read_sympoints'&
            &,bandplot% read_sympoints)
       Call getinteger('bandplot_control.ndivisions',bandplot% ndiv)
       Call getreal('bandplot_control.emin',bandplot% emin)
       Call getrealasstring('bandplot_control.emin', bandplot_emin_S)
       Call getreal('bandplot_control.emax',bandplot% emax)
       Call getrealasstring('bandplot_control.emax', bandplot_emax_S)
       !!
       !!
       If( variable_exists('bandplot_control.plot_idos'))Then
          Call getlogical('bandplot_control.plot_idos',bandplot% plotidos)
       Else
          bandplot% plotidos=.True.
       Endif
       If( variable_exists('bandplot_control.plot_ndos'))Then
          Call getlogical('bandplot_control.plot_ndos',bandplot% plotndos)
       Else
          bandplot% plotndos=.false.
       Endif
       If( variable_exists('bandplot_control.coeffout'))Then
          Call getlogical('bandplot_control.coeffout',bandplot% coeffout)
       Else
          bandplot% coeffout=.False.
          Call read_old_coeff_file(bandplot,.False.)
       Endif
       !!
       If( variable_exists('bandplot_control.restrict_bands_to_window'))Then
          Call getlogical('bandplot_control.restrict_bands_to_window'&
               &,bandplot% output_bands_in_window)
       Else
          bandplot% output_bands_in_window=.False.
       Endif
       !!
       !!
       If(ver /= VERSION_OK .And. ver < VERSION_4_01) Then
          bandplot% emin=bandplot% emin*hatoev
          bandplot% emax=bandplot% emax*hatoev
          Call double_to_string_as_ratio(bandplot% emin&
               &,bandplot_emin_S,1_t_int,1.0e-12_t_real,"(f30.5)")
          Call double_to_string_as_ratio(bandplot% emax&
               &,bandplot_emax_S,1_t_int,1.0e-12_t_real,"(f30.5)")
       Endif
       !!
       If( variable_exists('bandplot_control.nptdos'))Then
          Call getinteger('bandplot_control.nptdos',bandplot% nptdos)
       Else
          bandplot% nptdos=1000_t_int
       Endif
       !!
       Call getlogical('bandweight_control.bandweights',bandplot % bandweights)
       Call getlogical('bandweight_control.bweight_rot',bandplot % bweight_rot)
       Call getreal('bandweight_control.z_axis',bandplot % z_axis)
       Call getrealasstring('bandweight_control.z_axis', bandplot_z_axis_S)
       Call getreal('bandweight_control.x_axis',bandplot % x_axis)
       Call getrealasstring('bandweight_control.x_axis', bandplot_x_axis_S)
       If( variable_exists('bandweight_control.bwdfilename'))Then
          Call getstring('bandweight_control.bwdfilename',bwdefs% bwdfilename)
       Else
          bwdefs% bwdfilename=''
       Endif
       !If( variable_exists('bandweight_control.frelprojection'))Then
       !   Call getinteger('bandweight_control.frelprojection.type'&
       !        &,bandplot% frelprojection)
       !Else
       !   bandplot% frelprojection=FRELPROJECTION_JMU
       !Endif


       Call getrankandsize('special_sympoints',rank,asize)
       bandplot% npoints=asize(1_t_int)

       Call palloc('bandplot% p_labels',bandplot% p_labels &
            &,1_t_int,Max(1_t_int,bandplot% npoints)&
            &,nmodule,nsubfunc)

       Call palloc('bandplot% p_points',bandplot% p_points &
            &,1_t_int,3_t_int&
            &,1_t_int,Max(1_t_int,bandplot% npoints)&
            &,nmodule,nsubfunc)


       Allocate(bandplot_points_S(3_t_int,Max(1_t_int,bandplot% npoints))&
            &,STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for bandplot_points_S !'")
       Endif

       Call getstring('special_sympoints.label',bandplot% p_labels)
       Call getreal('special_sympoints.kpoint',bandplot% p_points)
       Call getrealasstring('special_sympoints.kpoint',bandplot_points_S)



       !!
       If( variable_exists('ldossites'))Then
          Call getrankandsize('ldossites',rank,asize)
          ldos% nldos=asize(1_t_int)
          !!
          Call palloc('ldos% p_ldsites',ldos% p_ldsites &
               &,1_t_int,Max(1_t_int,ldos% nldos)&
               &,nmodule,nsubfunc)
          !!
          Call getinteger('ldossites',ldos% p_ldsites)          
          !!
          !!
       Else
          !!
          Call read_old_ldos_file(ldos)
          !!
       Endif
       !!
       If( variable_exists('optics.active'))Then
          Call getlogical('optics.active',optics% active)
          Call getlogical('optics.jointdos',optics% jointdos)
          Call getlogical('optics.bandoutput',optics% bandoutput)
          If( variable_exists('optics.stopafter'))Then
             Call getlogical('optics.stopafter',optics% stopafter)
          Else
             optics% stopafter=.False.
          Endif
          Call getinteger('optics.energy.ne',optics% Ne)
          Call getreal('optics.energy.emin',optics% emin)
          Call getrealasstring('optics.energy.emin',optics_emin_S)
          Call getreal('optics.energy.emax',optics% emax)
          Call getrealasstring('optics.energy.emax',optics_emax_S)
       Else
          optics% active=.False.
          optics% jointdos=.False.
          optics% bandoutput=.False.
          optics% stopafter=.False.
          optics% Ne=1000
          optics% emin=0.0_t_real
          optics% emax=10.0_t_real
          optics_emin_S="0"
          optics_emax_S="10"
          Call read_old_optics_file(optics,protect=.False.)
          Write(optics_emin_S,"(a)")stringify_double100(optics% emin)
          Write(optics_emax_S,"(a)")stringify_double100(optics% emax)
       Endif
       !!
       If( variable_exists('topological_insulator.active'))Then
          Call getlogical('topological_insulator.active',topoins% active)
       Else
          Call read_old_topoins_file(topoins,protect=.False.)
       Endif
       
       Call getrankandsize('core_occupation',rank,asize)
       coreoccu% count=asize(1_t_int)
       !!If(coreoccu% count >0_t_int) Then
          
       Call palloc('coreoccu% p_sort',coreoccu% p_sort &
            &,1_t_int,Max(1_t_int,coreoccu% count)&
            &,nmodule,nsubfunc)
       
       Call palloc('coreoccu% p_state',coreoccu% p_state &
            &,1_t_int,Max(1_t_int,coreoccu% count)&
            &,nmodule,nsubfunc)
       
       Call palloc('coreoccu% p_spinup',coreoccu% p_spinup &
            &,1_t_int,7_t_int&
            &,1_t_int,Max(1_t_int,coreoccu% count)&
            &,nmodule,nsubfunc)
       
       Allocate(coreoccu_spinup_S(7_t_int,Max(1_t_int,coreoccu% count))&
            &,STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for coreoccu_spinup_S!'")
       Endif
       
       Call palloc('coreoccu% p_spindn',coreoccu% p_spindn &
            &,1_t_int,7_t_int&
            &,1_t_int,Max(1_t_int,coreoccu% count)&
            &,nmodule,nsubfunc)
       
       Allocate(coreoccu_spindn_S(7_t_int,Max(1_t_int,coreoccu% count))&
            &,STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for coreoccu_spindn_S!'")
       Endif
       !!Endif
       If(coreoccu% count >0_t_int) Then       
          Call getinteger('core_occupation.sort',coreoccu% p_sort)
          Call getstring('core_occupation.state',coreoccu% p_state)
          Call getreal('core_occupation.spinup',coreoccu% p_spinup)
          Call getrealasstring('core_occupation.spinup',coreoccu_spinup_S)
          Call getreal('core_occupation.spindn',coreoccu% p_spindn)
          Call getrealasstring('core_occupation.spindn',coreoccu_spindn_S)
       Endif

       !!START LSDA+U
       If( variable_exists('make_lsdau'))Then
          Call getlogical('make_lsdau',lsdau% lsdau)
       Else
          lsdau% lsdau=.False.
       Endif
       If( variable_exists('lsdau_projection.type'))Then
          Call getinteger('lsdau_projection.type',lsdau% projection)
       Else
          lsdau% projection=LSDAU_ORTHOGONAL
       Endif
       If( variable_exists('lsdau_functional.type'))Then
          Call getinteger('lsdau_functional.type',lsdau% functional)
       Else
          lsdau% functional=LSDAU_AMF
       Endif
       If( variable_exists('lsdau_dmat_deviation'))Then
          Call getreal('lsdau_dmat_deviation',lsdau% omat_dev)
          Call getrealasstring('lsdau_dmat_deviation',lsdau_omat_dev_S)
       Else
          lsdau% omat_dev=1.e-2
          lsdau_omat_dev_S='1.e-2'
       Endif
       If( variable_exists('lsdau_dmat_mode.type'))Then
          Call getinteger('lsdau_dmat_mode.type',lsdau% dmat_mode)
       Else
          lsdau% dmat_mode=LSDAU_DMAT_MODE_SC
       Endif

       If( variable_exists('lsdau_defs'))Then
          Call getrankandsize('lsdau_defs',rank,asize)
          lsdau% nudef=asize(1_t_int)
       Else
          lsdau% nudef=0_t_int
       Endif
       Call palloc('lsdau% p_isrtu',lsdau% p_isrtu &
            &,1_t_int,Max(1_t_int,lsdau% nudef) &
            &,nmodule,nsubfunc)
       Call palloc('lsdau% p_state',lsdau% p_state &
            &,1_t_int,Max(1_t_int,lsdau% nudef) &
            &,nmodule,nsubfunc)

       Call palloc('lsdau% p_u_f',lsdau% p_u_f &
            &,0_t_int,3_t_int &
            &,1_t_int,Max(1_t_int,lsdau% nudef) &
            &,nmodule,nsubfunc)
       Allocate(lsdau_u_f  (1_t_int:4_t_int,Max(1_t_int,lsdau% nudef))&
            &,STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for lsdau_u_f !'")
       Endif

       If( variable_exists('lsdau_defs').and.lsdau% nudef >0_t_int)Then
          Call getinteger('lsdau_defs.sort',lsdau% p_isrtu)
          Call getstring('lsdau_defs.state',lsdau% p_state)
          Call getreal('lsdau_defs.f_slater'&
               &,lsdau% p_u_f(0_t_int:3_t_int&
               &,1_t_int:Max(1_t_int,lsdau% nudef)))
          Call getrealasstring('lsdau_defs.f_slater'&
               &,lsdau_u_f(1_t_int:4_t_int&
               &,1_t_int:Max(1_t_int,lsdau% nudef)))
       Endif

       If( variable_exists('iterationvector_ratio.U'))Then
          Call getreal("iterationvector_ratio.U",Ufactor)
          Call getrealasstring("iterationvector_ratio.U",Ufactor_S)
       else
          Ufactor=1.0_t_real
          Ufactor_S="1.0"
       end If
       

       !!END   LSDA+U




       !!START OPC
       If( variable_exists('make_opc'))Then
          Call getlogical('make_opc',opc% make_opc)
       Else
          opc% make_opc=.False.
       Endif
       If( variable_exists('opc_projection.type'))Then
          Call getinteger('opc_projection.type',opc% projection)
       Else
          opc% projection=OPC_ORTHOGONAL
       Endif
       If( variable_exists('opc_functional.type'))Then
          Call getinteger('opc_functional.type',opc% functional)
       Else
          opc% functional=OPC_FUNC_DEFAULT
       Endif

       If( variable_exists('opc_defs'))Then
          Call getrankandsize('opc_defs',rank,asize)
          opc% IOnodef=asize(1_t_int)
       Else
          opc% IOnodef=0_t_int
       Endif
       Call palloc('opc% p_IOisrto',opc% p_IOisrto &
            &,1_t_int,Max(1_t_int,opc% IOnodef) &
            &,nmodule,nsubfunc)
       Call palloc('opc% p_IOstate',opc% p_IOstate &
            &,1_t_int,Max(1_t_int,opc% IOnodef) &
            &,nmodule,nsubfunc)

       If( variable_exists('opc_defs').And.opc% IOnodef >0_t_int)Then
          Call getinteger('opc_defs.sort',opc% p_IOisrto)
          Call getstring('opc_defs.state',opc% p_IOstate)
       Endif


       !!END   OPC

       !! START GRID OUTPUT
       !!
       If( variable_exists('grids_active'))Then
          Call getlogical('grids_active',gridplot% active)
       Endif
       If( variable_exists('grids_stop_after'))Then
          Call getlogical('grids_stop_after',gridplot% stopafter)
       Endif
       gridsif: If( variable_exists('grids'))Then
          !!
          Call getrankandsize('grids',rank,asize)
          n=asize(1)
          gridplot% ngrids=n
          !$ If (n==0) Goto 1919
          Call palloc_grids("grids",gridplot% p_grids,n,nmodule,nsubfunc)
          !!
          Call palloc('itmp',itmp,1_t_int,n,nmodule,nsubfunc)
          Call palloc('ctmp',ctmp,1_t_int,n,nmodule,nsubfunc)
          Call palloc('ltmp',ltmp,1_t_int,n,nmodule,nsubfunc)
          Call palloc('itmp2',itmp2,1_t_int,3_t_int,1_t_int,n,nmodule,nsubfunc)
          Call palloc('dtmp2',dtmp2,1_t_int,3_t_int,1_t_int,n,nmodule,nsubfunc)
          Call palloc('direction1_S',direction1_S,1_t_int,3_t_int,1_t_int,n&
               &,nmodule,nsubfunc)
          Call palloc('direction2_S',direction2_S,1_t_int,3_t_int,1_t_int,n&
               &,nmodule,nsubfunc)
          Call palloc('direction3_S',direction3_S,1_t_int,3_t_int,1_t_int,n&
               &,nmodule,nsubfunc)

          Call palloc('origin_S',origin_S,1_t_int,3_t_int,1_t_int,n&
               &,nmodule,nsubfunc)
          !!
          !! 
          Call getinteger('grids.basis.type',itmp)
          Do i=1,n
             gridplot% p_grids(i)% basis=itmp(i)
          End Do
          !!
          Call getreal('grids.direction1',dtmp2)
          Do i=1,n
             gridplot% p_grids(i)% directions(1:3,1)=dtmp2(1:3,i)
          End Do
          Call getreal('grids.direction2',dtmp2)
          Do i=1,n
             gridplot% p_grids(i)% directions(1:3,2)=dtmp2(1:3,i)
          End Do
          Call getreal('grids.direction3',dtmp2)
          Do i=1,n
             gridplot% p_grids(i)% directions(1:3,3)=dtmp2(1:3,i)
          End Do
          Call getrealasstring('grids.direction1',direction1_S)
          Call getrealasstring('grids.direction2',direction2_S)
          Call getrealasstring('grids.direction3',direction3_S)
          !!
          Call getreal('grids.origin',dtmp2)
          Do i=1,n
             gridplot% p_grids(i)% origin(1:3)=dtmp2(1:3,i)
          End Do
          Call getrealasstring('grids.origin',origin_S)
          !!
          Call getinteger('grids.subdivision',itmp2)
          Do i=1,n
             gridplot% p_grids(i)% subdivisions(1:3)=itmp2(1:3,i)
          End Do
          !!
          Call getlogical('grids.InclPeriodicPoints',ltmp)
          Do i=1,n
             gridplot% p_grids(i)% InclPeriodicPoints=ltmp(i)
          End Do
          !!
          Call getlogical('grids.createOpenDX',ltmp)
          Do i=1,n
             gridplot% p_grids(i)% createopendx=ltmp(i)
          End Do
          !!
          !!
          Call getsizearray('grids.quantities.type',itmp) 
          If(Any(itmp(:)>0))Then
             Call palloc('itmp2',itmp2,1_t_int,Maxval(itmp),1_t_int,n&
                  &,nmodule,nsubfunc)
             !!
             Call getinteger('grids.quantities.type',itmp2)
             Do i=1,n
                gridplot% p_grids(i)% nq=itmp(i)
                If(itmp(i)>0)Then
                   Call palloc('grids(i)% quantities'&
                        &,gridplot% p_grids(i)% quantities&
                        &,1_t_int,itmp(i),nmodule,nsubfunc)
                   Do j=1,itmp(i)
                      gridplot% p_grids(i)% quantities(j)=itmp2(j,i)
                   End Do
                Else
                   Call palloc('grids(i)% quantities'&
                        &,gridplot% p_grids(i)% quantities&
                        &,1_t_int,1_t_int,nmodule,nsubfunc)
                   gridplot% p_grids(i)% quantities(1)=GRID_QUANTITY_NONE
                End If
             End Do
          Else
             Do i=1,n
                Call palloc('grids(i)% quantities'&
                     &,gridplot% p_grids(i)% quantities&
                     &,1_t_int,1_t_int,nmodule,nsubfunc)
                gridplot% p_grids(i)% quantities(1)=GRID_QUANTITY_NONE
                !Print *,gridplot% p_grids(i)% quantities
             Enddo
          End If
          !!
          !!
          Call getsizearray('grids.outputdata.type',itmp) 
          If(Any(itmp(:)>0))Then
             Call palloc('itmp2',itmp2,1_t_int,Maxval(itmp),1_t_int,n&
                  &,nmodule,nsubfunc)
             Call palloc('ctmp2',ctmp2,1_t_int,Maxval(itmp),1_t_int,n&
                  &,nmodule,nsubfunc)
             !!todo: remove old unused output data
             Call getinteger('grids.outputdata.type',itmp2)
             Call getstring('grids.outputdata.description',ctmp2)
             Do i=1,n
                gridplot% p_grids(i)% no=itmp(i)
                If(itmp(i)>0)Then
                   no=0_t_int
                   Do j=1,itmp(i)
                      If (outputdataIsValid(itmp2(j,i))) Then
                         !Print *,itmp2(j,i),Trim(ctmp2(j,i)),no
                         no=no+1_t_int
                      Endif
                   Enddo
                Endif
                !Print *,'no=',no
                If(no>0)Then
                   Call palloc('grids(i)% outputdata'&
                        &,gridplot% p_grids(i)% outputdata&
                        &,1_t_int,no,nmodule,nsubfunc)
                   no=0_t_int
                   Do j=1,itmp(i)
                      If (outputdataIsValid(itmp2(j,i))) Then
                         no=no+1_t_int
                         !Print *,itmp2(no,i),Trim(ctmp2(no,i))
                         gridplot% p_grids(i)% outputdata(no)=itmp2(no,i)
                      Endif
                   End Do
                Else
                   Call palloc('grids(i)% outputdata'&
                        &,gridplot% p_grids(i)% outputdata&
                        &,1_t_int,1_t_int,nmodule,nsubfunc)
                   gridplot% p_grids(i)% outputdata(1)=GRID_OUTPUTDATA_NONE
                End If
             End Do
          Else
             Do i=1,n
                Call palloc('grids(i)% outputdata'&
                     &,gridplot% p_grids(i)% outputdata&
                     &,1_t_int,1_t_int,nmodule,nsubfunc)
                gridplot% p_grids(i)% outputdata(1)=GRID_OUTPUTDATA_NONE
             Enddo
          End If
          !!
          If(variable_exists('grids.scfwavefnctwindow'))Then
             Call palloc('dtmp2',dtmp2,1_t_int,2_t_int,1_t_int,n&
                  &,nmodule,nsubfunc)
             Call getreal('grids.scfwavefnctwindow',dtmp2)
             Do i=1,n
                gridplot% p_grids(i)% scfergwindow(1:2)=dtmp2(1:2,i)
             End Do
          Endif
          !!
          Call getstring('grids.file',ctmp)
          Do i=1,n
             gridplot% p_grids(i)% pointfile=ctmp(i)
          End Do
          !!
          gridsewinif:If( variable_exists('grids.energywindows'))Then
             Call getrankandsize('grids.energywindows',rank,asize)
             Call palloc('ctmp2',ctmp2,1_t_int,asize(1),1_t_int,n&
                  &,nmodule,nsubfunc)
             !Write(outfile,"(a,10i3)")'grids.energywindows',rank,asize(1:rank)

             Call getsizearray('grids.energywindows.name',itmp) 
             Call getrankandsize('grids.energywindows.sections',rank,asize)
             !Write(outfile,"(a,10i3)")'grids.energywindows.sections',rank,asize(1:rank)

             Call palloc('itmp2',itmp2,1_t_int,asize(2),1_t_int,n&
                  &,nmodule,nsubfunc)
             !Print *,Size(itmp2,1),Size(itmp2,2)
             
             Call getsizearray('grids.energywindows.sections',itmp2) 

             Call palloc('dtmpemin',dtmpemin,1_t_int,asize(1),1_t_int,asize(2)&
                  &,1_t_int,n,nmodule,nsubfunc)
             Call palloc('dtmpemax',dtmpemax,1_t_int,asize(1),1_t_int,asize(2)&
                  &,1_t_int,n,nmodule,nsubfunc)
             Call palloc('dtmpde',dtmpde,1_t_int,asize(1),1_t_int,asize(2)&
                  &,1_t_int,n,nmodule,nsubfunc)
             Call palloc('itmp3',itmp3,1_t_int,asize(1),1_t_int,asize(2)&
                  &,1_t_int,n,nmodule,nsubfunc)
             
             Call getreal('grids.energywindows.sections.emin',dtmpemin)
             Call getreal('grids.energywindows.sections.emax',dtmpemax)
             Call getreal('grids.energywindows.sections.de',dtmpde)
             Call getinteger('grids.energywindows.sections.spin.type',itmp3)


             Do i=1,n
                gr=> gridplot% p_grids(i)
                gr% nenergywindowresolved=itmp(i)
                If(gr% nenergywindowresolved>0)&
                     &Call palloc_energywindowresolved(&
                     &'gr% p_energywindowresolved'&
                     &,gr% p_energywindowresolved,gr% nenergywindowresolved&
                     &,nmodule,nsubfunc)
             Enddo
             Call getstring('grids.energywindows.name',ctmp2)
             Do i=1,n
                gr=> gridplot% p_grids(i)
                Do j=1,gr% nenergywindowresolved
                   gr% p_energywindowresolved(j)% name=Trim(ctmp2(j,i))
                   gr% p_energywindowresolved(j)% nsections=itmp2(j,i)
                   If(gr% p_energywindowresolved(j)% nsections>0)Then
                      Call palloc('gr% p_energywindowresolved(j)% p_emin'&
                           &,gr% p_energywindowresolved(j)% p_emin&
                           &,1_t_int,gr% p_energywindowresolved(j)% nsections&
                           &,nmodule,nsubfunc)
                      Call palloc('gr% p_energywindowresolved(j)% p_emax'&
                           &,gr% p_energywindowresolved(j)% p_emax&
                           &,1_t_int,gr% p_energywindowresolved(j)% nsections&
                           &,nmodule,nsubfunc)
                      Call palloc('gr% p_energywindowresolved(j)% p_de'&
                           &,gr% p_energywindowresolved(j)% p_de&
                           &,1_t_int,gr% p_energywindowresolved(j)% nsections&
                           &,nmodule,nsubfunc)
                      Call palloc('gr% p_energywindowresolved(j)% p_spin'&
                           &,gr% p_energywindowresolved(j)% p_spin&
                           &,1_t_int,gr% p_energywindowresolved(j)% nsections&
                           &,nmodule,nsubfunc)
                      Do k=1,gr% p_energywindowresolved(j)% nsections
                         gr% p_energywindowresolved(j)% p_emin(k)=&
                              &dtmpemin(k,j,i)
                         gr% p_energywindowresolved(j)% p_emax(k)=&
                              &dtmpemax(k,j,i)
                         gr% p_energywindowresolved(j)% p_de(k)=&
                              &dtmpde(k,j,i)
                         gr% p_energywindowresolved(j)% p_spin(k)=&
                              &itmp3(k,j,i)
                      Enddo
                      
                   Endif
                Enddo
             End Do
          Endif gridsewinif
          !!
          gridskresif:If( variable_exists('grids.kresolved'))Then
             Call getrankandsize('grids.kresolved',rank,asize)
             !Write(outfile,"(a,10i3)")'grids.kresolved',rank,asize(1:rank)
             Call palloc('ctmp2',ctmp2,1_t_int,asize(1),1_t_int,n&
                  &,nmodule,nsubfunc)
             Call palloc('kpoint_S',kpoint_S,1_t_int,3_t_int,1_t_int,asize(1)&
                  &,1_t_int,n,nmodule,nsubfunc)
             Call palloc('eminmax_S',eminmax_S,1_t_int,2_t_int,1_t_int,asize(1)&
                  &,1_t_int,n,nmodule,nsubfunc)
             Call palloc('dtmpkpoint',dtmpkpoint,1_t_int,3_t_int&
                  &,1_t_int,asize(1),1_t_int,n,nmodule,nsubfunc)
             Call palloc('dtmpeminmax',dtmpeminmax,1_t_int,2_t_int&
                  &,1_t_int,asize(1),1_t_int,n,nmodule,nsubfunc)
             Call getrankandsize('grids.kresolved.bandindices',rank,asize)
             !Write(outfile,"(a,10i3)")'grids.kresolved.bandindices'&
             !     &,rank,asize(1:rank)
             Call palloc('itmp2',itmp2&
                  &,1_t_int,asize(2),1_t_int,n,nmodule,nsubfunc)
             Call palloc('itmp3',itmp3,1_t_int,asize(1)&
                  &,1_t_int,asize(2),1_t_int,n,nmodule,nsubfunc)

             Call getsizearray('grids.kresolved.name',itmp) 
             Call getsizearray('grids.kresolved.bandindices',itmp2)
             Do i=1,n
                gr=> gridplot% p_grids(i)
                gr% nkresolved=itmp(i)
                If(gr% nkresolved>0)&
                     &Call palloc_kresolved('gr% p_kresolved'&
                     &,gr% p_kresolved,gr% nkresolved,nmodule,nsubfunc)
             Enddo
             !!
             Call getstring('grids.kresolved.name',ctmp2)
             Call getrealasstring('grids.kresolved.kpoint',kpoint_S)
             Call getreal('grids.kresolved.kpoint',dtmpkpoint)
             Call getrealasstring('grids.kresolved.energywindow',eminmax_S)
             Call getreal('grids.kresolved.energywindow',dtmpeminmax)
             Call getinteger('grids.kresolved.bandindices',itmp3)
             !!Write(outfile,"('bandindices sizearray',100i)")itmp2(:,1:n)
             Do i=1,n
                gr=> gridplot% p_grids(i)
                Do j=1,gr% nkresolved
                   gr% p_kresolved(j)% nbandindices=itmp2(j,i)
                   !Print *,'gr% p_kresolved(j)% nbandindices='&
                   !     &,gr% p_kresolved(j)% nbandindices
                   Call palloc("gr% p_kresolved(j)% p_bandindices"&
                        &,gr% p_kresolved(j)% p_bandindices&
                        &,1_t_int,Max(1_t_int,itmp2(j,i))&
                        &,nmodule,nsubfunc)
                   !Print *,'size=',Size(gr% p_kresolved(j)% p_bandindices)
                   !Write(outfile,"('bandindices allocsize=',i)")&
                   !     &Size(gr% p_kresolved(j)% p_bandindices)
                   !Write(outfile,"('bandindices',100i)")itmp3(:,j,i)
                   gr% p_kresolved(j)% name=Trim(ctmp2(j,i))
                   gr% p_kresolved(j)% kpoint=dtmpkpoint(:,j,i)
                   gr% p_kresolved(j)% emin=dtmpeminmax(1,j,i)
                   gr% p_kresolved(j)% emax=dtmpeminmax(2,j,i)
                   Do k=1,itmp2(j,i)
                      gr% p_kresolved(j)% p_bandindices(k)=itmp3(k,j,i)
                   Enddo
                Enddo
             Enddo
          End If gridskresif
          !!
          Call pfree(dtmp2)
          Call pfree(dtmpemin)
          Call pfree(dtmpemax)
          Call pfree(dtmpde)
          Call pfree(dtmpkpoint)
          Call pfree(dtmpeminmax)
          Call pfree(itmp2)
          Call pfree(itmp3)
          Call pfree(itmp)
          Call pfree(ctmp)
          Call pfree(ctmp2)
          Call pfree(ltmp)
          !!
!!$1919      Continue
!!$          Do i=1,Size(gridplot% p_grids,1)
!!$             Write(outfile,"('grid ',i4)") i
!!$             gr=> gridplot% p_grids(i)
!!$             Do j=1,gr% nenergywindowresolved
!!$                Write(outfile,"(t10,'ewin ',i4,' name=',a)") j&
!!$                     &,Trim(gr% p_energywindowresolved(j)% name)
!!$                Write(outfile,"(t20,'sections=',i5)") &
!!$                     & gr% p_energywindowresolved(j)% nsections
!!$                Do k=1,gr% p_energywindowresolved(j)% nsections
!!$                   Write(outfile,"(t25,'emin ',f8.3,'emax ',f8.3,'de ',f8.3,'spin ',i2)") &
!!$                     & gr% p_energywindowresolved(j)% p_emin(k)&
!!$                     &,gr% p_energywindowresolved(j)% p_emax(k)&
!!$                     &,gr% p_energywindowresolved(j)% p_de(k)&
!!$                     &,gr% p_energywindowresolved(j)% p_spin(k)
!!$                Enddo
!!$             Enddo
!!$          Enddo
          !Stop
       Endif gridsif
       !!END GRID OUTPUT


       !! FURTHER ACTIONS DEPENDING ON action
       updateif1:If(action==IO_ACTION_STRUCTURE_UPDATE )Then
          
          
          
          !! take default bandpoints
          If(Trim(newsymmetry% lattice) /= Trim(symmetry% lattice)&
               &.Or. Any( Abs(&
               &newsymmetry% lattice_constants(:)&
               &-symmetry% lattice_constants(:))>1.e-10_t_real)&
               &.Or. Any( Abs(&
               &newsymmetry% axis_angles(:)&
               &-symmetry% axis_angles(:))>1.e-10_t_real)) Then
             
             Call errmsg(nmodule,nsubfunc,E_warning&
                  &,msg="'lattice type or lattice constants changed!',/&
                  &,' Will take default values for special bandplot &
                  &symmetry points!'")
             
             !Call pfree(bandplot% p_labels)
             !Call pfree(bandplot% p_points)
             If(Allocated(bandplot_points_S))Deallocate(bandplot_points_S)
             
             Call define_special_bz_points(newsymmetry,bandplot)
             
             Allocate(bandplot_points_S(3_t_int,Max(1_t_int,bandplot% npoints))&
                  &,STAT=icheck)
             If(icheck/=0)Then
                Call errmsg(nmodule,nsubfunc,E_fatalerror&
                     &,msg="'Could not allocate memory for &
                     &bandplot_points_S !'")
             Endif
             Do i=1_t_int,bandplot% npoints
                Do j=1_t_int,3_t_int
                   Call double_to_string_as_ratio(bandplot% p_points(j,i)&
                        &,bandplot_points_S(j,i),10_t_int,1.0e-12_t_real,"(f30.15)")
                Enddo
             Enddo
             
          Endif
          
          !! take old options, but only those known to fplo
          
          Call  getrankandsize("options",rank,asize)
          
          newoptions% noptions=asize(1_t_int)
          
          Call palloc('newoptions% p_options',newoptions% p_options &
               &,1_t_int,Max(1_t_int,newoptions% noptions) &
               &,nmodule,nsubfunc)
          
          
          Call  getflag('options',newoptions% p_options)
          
          !! default options
          loptions % noptions = Size(fplo_opt)
          
          Call palloc('loptions% p_options',loptions% p_options &
               &,1_t_int,Max(1_t_int,loptions% noptions) &
               &,nmodule,nsubfunc)
          
          loptions % p_options(:)=fplo_opt(:)
          
          
          Do i=1_t_int,loptions% noptions
             If(isoption(loptions% p_options(i)(2_t_int:),newoptions))Then
                loptions% p_options(i)(1_t_int:1_t_int)='+'
             Endif
             If(.not.isoption(loptions% p_options(i)(2_t_int:),newoptions))Then
                loptions% p_options(i)(1_t_int:1_t_int)='-'
             Endif
          Enddo
          
          
          
          !! take old concentrations
          
          If(structure% IOnsort == newstructure% IOnsort)Then
             warn=.False.
             Do issaIO=1_t_int,newstructure% IOnsort
                If(Trim(structure_conao_ele_S(issaIO)) &
                     &/= Trim(newstructure% p_IOelements(issaIO)))Then
                   warn=.True.
                   structure_conao_S(issaIO)='1.0'
                Endif
             End Do
             If(warn)Then
                Call errmsg(nmodule,nsubfunc,E_warning&
                     &,msg="'Element at some Wyckoff position changed!',/&
                     &,' Will take default concentration!'")
             End If
             
          Else
             Call errmsg(nmodule,nsubfunc,E_warning&
                  &,msg="'number of Wyckoff positions changed!',/&
                  &,' Will take default concentrations!'")
             If(Allocated(structure_conao_S))Deallocate(structure_conao_S)
             Allocate(structure_conao_S(newstructure % IOnsort),STAT=icheck)
             If(icheck/=0)Then
                Call errmsg(nmodule,nsubfunc,E_fatalerror&
                     ,msg="'Could not allocate memory for structure_conao_S !'")
             Endif
             structure_conao_S(:)='1.0'
          Endif
          
          
          
          !! take initial_spin_split settings
          If(structure% IOnsort == newstructure% IOnsort)Then
             warn=.False.
             Do issaIO=1_t_int,newstructure% IOnsort
                If(Trim(spin_split_ele_S(issaIO)) &
                     &/= Trim(newstructure% p_IOelements(issaIO)))Then
                   warn=.True.
                   spin_split_S(issaIO)='2.0'
                Endif
             End Do
             If(warn)Then
                Call errmsg(nmodule,nsubfunc,E_warning&
                     &,msg="'Element at some Wyckoff position changed!',/&
                     &,' Will take default initial_spin_split!'")
             End If
             
          Else
             Call errmsg(nmodule,nsubfunc,E_warning&
                  &,msg="'number of Wyckoff positions changed!',/&
                  &,' Will take default initial_spin_split!'")
             If(Allocated(spin_split_S))Deallocate(spin_split_S)
             
             Call palloc('spin_split',spin_split &
                  &,1_t_int,newstructure% IOnsort&
                  &,nmodule,nsubfunc)
             
             Allocate(spin_split_S(newstructure % IOnsort),STAT=icheck)
             If(icheck/=0)Then
                Call errmsg(nmodule,nsubfunc,E_fatalerror&
                     &,msg="'Could not allocate memory for spin_split_S!'")
             Endif
             spin_split(:)=2.0_t_real
             spin_split_S(:)='2.0'
          Endif
          
       Endif updateif1
       
       !Print *,'cleanreadfile'
       Call cleanreadfile
       !!--------- NO ACCESS TO INFILE PARSER AFTER THIS LINE PLEASE !! ----       
       
       
    Else If(action==IO_ACTION_NEW_FILE)Then
       
       
       Allocate(structure_conao_S(newstructure % IOnsort),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for structure_conao_S !'")
       Endif
       structure_conao_S(:)='1.0'




       relativistic=SCALAR_RELATIVISTIC
       potential% nuc_type=FINUC_NONE

       mspin=1_t_int
       initial_spin_split=.False.       
       fsm_moment_S(:)="1.0"
       kohnsham% fsm=.False.
       quant_axis_S(1:2)="0"
       quant_axis_S(3)="1"
       quant% axis(1:2)=0.0_t_real
       quant% axis(3)=1.0_t_real


!!$       diracdefs% spin_pop_type=REL_SPIN_CHAR_CSCV

       Allocate(spin_split_S(newstructure % IOnsort),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for spin_split_S !'")
       Endif

       Do issaIO=1_t_int,newstructure% IOnsort
          spin_split_S(issaIO)='2.0'
       Enddo



       kohnsham% io_nband=-1_t_int

!!$       basis_exn0_S='4.0' 






       cpacontrol % max_ef_loops=10_t_int
       cpacontrol % nec=30_t_int
       cpacontrol % max_se_loops=10_t_int
       cpacontrol_emin0_S='-1.60'
       cpacontrol_emax0_S='0.4'
       cpacontrol_eimagscf_S='1.0e-5'
       cpacontrol_efermi0_S='0.08'
       cpacontrol_slop_0_S='30.0'
       cpacontrol_slop_min_S='0.3'
       cpacontrol % fermi_method=CPA_FERMI_METHOD_SECANT
       cpacontrol % nedos=1000_t_int
       cpacontrol_eimagdos_S='1.e-3'
       !cpacontrol % neakbl=100_t_int
       !cpacontrol_eimagakbl_S='1.e-3'

       potential% max_LIO=4_t_int

!!$       numerics% ewcutoff=2.0
!!$       numerics_ewcutoff_S="2.0"
       numerics% eweps_r=1.0e-5_t_real
       numerics_eweps_r_S='1.0e-5'
       numerics% eweps_g=1.0e-5_t_real
       numerics_eweps_g_S='1.0e-5'


       numerics_symtesttol_S='5.0e-13'

       numerics % degree=8_t_int
       !numerics % nfft_ewp_per_site=-500_t_int
       numerics % oci_nr=200_t_int
       numerics % coulerg_nxi=26_t_int
       numerics % coulerg_neta=46_t_int
       numerics % ovldns_nr=50_t_int
       numerics % ovldns_neta=20_t_int
       numerics_cuttol_dens_S='1.e-9'
       numerics_cuttol_pot_S='1.e-12'
       numerics_cuttol_orbital_S='1.e-8' 

       xcvers=XCVER_PERDEWWANG92
       out_level=L_more

       radialmesh% nr = 200_t_int
       radialmesh_rmin_S = '1.0e-5'
       radialmesh_rmax_S = '0.0'
       radialmesh_rmaxfactor_S = '1.0'

       atommesh% nr = 2000_t_int
       atommesh_rmin_S = '1.0e-7'
       atommesh_rmax_S = '0.0'


       iteration% scheme =it_scheme_iterat
       iteration% maxdim =5_t_int
       iteration_control_tolerance_S ='1.e-6'
       iteration_control_mixing_S ='0.4'
       iteration_control_progres_S ='0.1'
       iteration% steps= 30_t_int
       iteration% convcond=CONVCOND_ITERAT

       forces% forceiteration_control% steps= 100_t_int
       forces% forceiteration_control% maxdim =0_t_int
       forces% forceiteration_control% scheme =it_scheme_miniterat
       forces% forceiteration_control% tolerance =1.0e-3_t_real
       force_iteration_control_tol_S ='1.0e-3'
       forces% force_in_each_step=.False.
       forces% approx_nodndL_ewald=.False.
       forces% force_mode=FORCE_MODE_NONE
       forces% ngeomopt_sites=0
       Call palloc('forces% p_geomopt_sites',forces% p_geomopt_sites&
            &,1_t_int,Max(1_t_int,forces% ngeomopt_sites),nmodule,nsubfunc)
       

       bzone % method =BZ_TETRAHEDRON_METHOD
       bzone % metal =.True.
       bzone % nkxyz =(/12_t_int,12_t_int,12_t_int/)
       idum =1001_t_int
       bzone % mp_norder =0_t_int
       bzone_mp_range_S ='5.0'
       bzone_mp_width_S ='0.005'
       bzone% kTmax =100.0_t_real
       bzone_kT ='100.0'


       etotstack_etot_tolerance_S='1.e-8'
       etot% etot_calc=.True.


       loptions% noptions = Size(fplo_opt)
       
       
       Call palloc('loptions% p_options',loptions% p_options &
            &,1_t_int,Max(1_t_int,loptions% noptions)&
            &,nmodule,nsubfunc)

       loptions% p_options(:)=fplo_opt(:)


       optics% active =.False.
       optics% jointdos=.False.
       optics% bandoutput=.False.
       optics% stopafter=.False.
       optics% Ne=1000
       optics% emin=0.0_t_real
       optics% emax=10.0_t_real
       optics_emin_S="0"
       optics_emax_S="10"


       bandplot % plotbands =.False.
       bandplot % read_sympoints =.True.
       bandplot % ndiv =50_t_int
       bandplot_emin_S ='-20.0'
       bandplot_emax_S ='20.0'
       bandplot% emin=-20.0_t_real
       bandplot% emax= 20.0_t_real
       potential% make_vca=.False.
       Call palloc('potential% p_vcasorts',potential% p_vcasorts&
            &,1_t_int,1_t_int,nmodule,nsubfunc)
       Call palloc('potential% p_vcaZ',potential% p_vcaZ&
            &,1_t_int,1_t_int,nmodule,nsubfunc)
       Call palloc('vcaZ_S',vcaZ_S&
            &,1_t_int,1_t_int,nmodule,nsubfunc)
       potential% nvca=0_t_int
       
       potential_xreduce_S='1.0'
       potential% xreduce=1.0_t_real
       potential% molecule_ionicity=0.0_t_real
       potential_molecule_ionicity_S='0.0'
       potential% chargemode=CHARGEMODE_NONE
       !! new in version 4.01
       bandplot% plotidos=.False.
       bandplot% plotndos=.False.
       bandplot% nptdos=1000_t_int
       !! end new

       !! new in version 7.02
       bandplot% output_bands_in_window=.False.
       !! end new
       !! new in version 9.10
       !bandplot% frelprojection=FRELPROJECTION_JMU
       !! end new
       bandplot % bandweights = .False.
       bandplot % bweight_rot = .False.
       bandplot_z_axis_S = (/'0.0','0.0','1.0'/)
       bandplot_x_axis_S = (/'1.0','0.0','0.0'/)

       bwdefs% bwdfilename=''
       
       Call define_special_bz_points(newsymmetry,bandplot)

       Allocate(bandplot_points_S(3_t_int,Max(1_t_int,bandplot% npoints))&
            &,STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for bandplot_points_S !'")
       Endif

       Do i=1_t_int,bandplot% npoints
          Do j=1_t_int,3_t_int
             Call double_to_string_as_ratio(bandplot% p_points(j,i)&
                  &,bandplot_points_S(j,i),10_t_int,1.0e-12_t_real,"(f30.15)")
          Enddo
       Enddo


       !!new 4.0-1
       ldos% nldos=0_t_int
       Call palloc('ldos% p_ldsites',ldos% p_ldsites &
            &,1_t_int,Max(1_t_int,ldos% nldos)&
            &,nmodule,nsubfunc)
       !!end new 4.0-1


       !! initialize core occupation 
       coreoccu% count=0_t_int
       !! to avoid core dump on stupid compilers
       Allocate(coreoccu_spindn_S(7_t_int,Max(1_t_int,coreoccu% count))&
            &,STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for coreoccu_spindn_S!'")
       Endif
       Allocate(coreoccu_spinup_S(7_t_int,Max(1_t_int,coreoccu% count))&
            &,STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for coreoccu_spindn_S!'")
       Endif
       Call palloc('coreoccu% p_sort',coreoccu% p_sort &
            &,1_t_int,Max(1_t_int,coreoccu% count)&
            &,nmodule,nsubfunc)

       Call palloc('coreoccu% p_state',coreoccu% p_state &
            &,1_t_int,Max(1_t_int,coreoccu% count)&
            &,nmodule,nsubfunc)


       !!START LSDA+U
       lsdau% lsdau=.False.
       lsdau% projection=LSDAU_ORTHOGONAL
       lsdau% functional=LSDAU_AMF
       lsdau% omat_dev=1.e-2
       lsdau_omat_dev_S='1.e-2'
       lsdau% dmat_mode=LSDAU_DMAT_MODE_SC
       Ufactor_S='1.0'
       lsdau% nudef=0_t_int
       Call palloc('lsdau% p_isrtu',lsdau% p_isrtu &
            &,1_t_int,Max(1_t_int,lsdau% nudef) &
            &,nmodule,nsubfunc)
       Call palloc('lsdau% p_state',lsdau% p_state &
            &,1_t_int,Max(1_t_int,lsdau% nudef) &
            &,nmodule,nsubfunc)
       Call palloc('lsdau% p_u_f',lsdau% p_u_f &
            &,0_t_int,3_t_int &
            &,1_t_int,Max(1_t_int,lsdau% nudef) &
            &,nmodule,nsubfunc)
       Allocate(lsdau_u_f  (1_t_int:4_t_int,Max(1_t_int,lsdau% nudef))&
            &,STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Could not allocate memory for lsdau_u_f !'")
       Endif
       
       !!END START LSDA+U


       !!START OPC
       opc% make_opc=.False.
       opc% projection=OPC_ORTHOGONAL
       opc% functional=OPC_FUNC_DEFAULT
       opc% IOnodef=0_t_int
       Call palloc('opc% p_IOisrto',opc% p_IOisrto &
            &,1_t_int,Max(1_t_int,opc% IOnodef) &
            &,nmodule,nsubfunc)
       Call palloc('opc% p_IOstate',opc% p_IOstate &
            &,1_t_int,Max(1_t_int,opc% IOnodef) &
            &,nmodule,nsubfunc)
       !!END START OPC

       !! to avoid core dump on st....
       Call palloc('direction1_S',direction1_S,1_t_int,3_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
       Call palloc('direction2_S',direction2_S,1_t_int,3_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
       Call palloc('direction3_S',direction3_S,1_t_int,3_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
       Call palloc('origin_S',origin_S,1_t_int,3_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)



       
    Endif runif1

    runif3: If(action/=IO_ACTION_RUN .Or. ver/=VERSION_OK)Then
       
       If(ver/=VERSION_OK)Then
          !! take old options, but only those known to new fplo version
          
          !! copy options from file onto newoptions
          Call pfree(newoptions% p_options)
          newoptions% noptions = loptions% noptions
          Call palloc('newoptions% p_options',newoptions% p_options &
               &,1_t_int,Max(1_t_int,newoptions% noptions) &
               &,nmodule,nsubfunc)
          newoptions % p_options(:)=loptions % p_options(:)


          !! reallocale loptions according to new version
          Call pfree(loptions% p_options)
          loptions % noptions = Size(fplo_opt)
          
          Call palloc('loptions% p_options',loptions% p_options &
               &,1_t_int,Max(1_t_int,loptions% noptions) &
               &,nmodule,nsubfunc)
          
          loptions % p_options(:)=fplo_opt(:)
          
          
          Do i=1_t_int,loptions% noptions
             If(isoption(loptions% p_options(i)(2_t_int:),newoptions))Then
                loptions% p_options(i)(1_t_int:1_t_int)='+'
             Endif
             If(.not.isoption(loptions% p_options(i)(2_t_int:),newoptions))Then
                loptions% p_options(i)(1_t_int:1_t_int)='-'
             Endif
          Enddo
          
       Endif
       !!
       If(action==IO_ACTION_RUN .And. ver/=VERSION_OK)Then
          sym=> symmetry
          str=> structure
          lat=> lattice_constants_S
          ang=> axis_angles_S
          wtau=>IOwtau_S
       Else
          sym=> newsymmetry
          str=> newstructure
          lat=> newlattice_constants_S
          ang=> newaxis_angles_S
          wtau=>IOnewwtau_S
       Endif
       Call create_infile(compound,sym% spgrpnum,sym% nugen&
            &,sym% iugen,str,lat&
            &,ang,wtau,potential% max_LIO&
            
            &,structure_conao_S,mspin,initial_spin_split&
            &,radialmesh% nr,radialmesh_rmin_S,radialmesh_rmax_S&
            &,radialmesh_rmaxfactor_S &
            &,atommesh% nr,atommesh_rmin_S,atommesh_rmax_S&
            &,potential% nuc_type&
            &,numerics&
            &,numerics_cuttol_dens_S,numerics_cuttol_pot_S&
            &,numerics_cuttol_orbital_S&
            &,numerics_eweps_r_S,numerics_eweps_g_S&
            &,relativistic&
            !&,quant&
            &,quant_axis_S&
            &,loptions,out_level &
            &,cpacontrol,cpacontrol_eimagdos_S,cpacontrol_eimagscf_S&
            &,cpacontrol_efermi0_S,cpacontrol_slop_0_S,cpacontrol_slop_min_S&
            &,cpacontrol_emin0_S,cpacontrol_emax0_S&
            &,fsm_moment_S,kohnsham% fsm,bzone&
            &,bzone_mp_range_S,bzone_mp_width_S,bzone_kT&
            !&,basis_exn0_S&
            &,spin_split_S,bandplot,bandplot_emin_S,bandplot_emax_S&
            &,bandplot_z_axis_S,bandplot_x_axis_S&
            &,bandplot% npoints,bandplot% p_labels,bandplot_points_S&
            &,ldos,coreoccu% count&
            &,coreoccu% p_sort,coreoccu% p_state&
            &,coreoccu_spinup_S,coreoccu_spindn_S&
            !
            &,iteration,iteration_control_tolerance_S&
            &,iteration_control_mixing_S&
            &,iteration_control_progres_S  &
            !
            &,forces,force_iteration_control_tol_S&
            !
            &,etotstack_etot_tolerance_S,etot&
            &,numerics_symtesttol_S,kohnsham,opc,lsdau,lsdau_omat_dev_S&
            &,lsdau_u_f,xcvers,Ufactor_S&
            &,gridplot,bwdefs,direction1_S,direction2_S,direction3_S,origin_S&
            &,kpoint_S,eminmax_S,topoins,potential,potential_xreduce_S&
            &,potential_molecule_ionicity_S,vcaZ_S,optics,optics_emin_S,optics_emax_S)
       If(ver/=VERSION_OK)Then
          Write(outfile,"('Version update of ',a,':')")Trim(f_fplo_in)
          Write(outfile,"('File ',a,' updated!')")Trim(f_fplo_in)
       Endif
    End If runif3
    
    
    runif2: If(action==IO_ACTION_RUN)Then
       
       stopit=.False.
!!$       If(.Not.exist_basis)Then
!!$          Write(outfile,"('File ',a,' does not exist, will create it!')")&
!!$               &Trim(f_fplo_basis)
!!$          !!
!!$          Call basis_io(IO_ACTION_NEW_FILE,structure,basis,verstop,stopsym&
!!$               &,stopit)
!!$          !!
!!$          Write(outfile,"('File ',a,' created!')")Trim(f_fplo_basis)
!!$       Else
!!$          Write(outfile,"('File ',a,' exists!')")Trim(f_fplo_basis)
!!$          !!
!!$          Call basis_io(IO_ACTION_RUN,structure,basis,verstop,stopsym,stopit)
!!$          !!
!!$       Endif
       !!
!!$       If(.Not.exist_devel)Then
!!$          Write(outfile,"('File ',a,' does not exist, will create it!')")&
!!$               &Trim(f_fplo_devel)
!!$          !!
!!$          Call devel_io(IO_ACTION_NEW_FILE,structure,mol,stopit)
!!$          !!
!!$          Write(outfile,"('File ',a,' created!')")Trim(f_fplo_devel)
!!$
!!$       Else
!!$          Write(outfile,"('File ',a,' exists!')")Trim(f_fplo_devel)
!!$          !!
!!$          Call devel_io(IO_ACTION_RUN,structure,mol,stopit)
!!$          !!
!!$       Endif
       !!
       If(stopit)Then
          Call terminate(TERM_NORMAL,'file creation or update')
       Endif
       !!
       Call print_crystal_structure(symmetry,structure,lattice_constants_S&
            &,axis_angles_S,IOwtau_S)       
       !! cleanup
       If(Allocated(IOwtau_S)) Deallocate(IOwtau_S)
       If(Allocated(spin_split_S)) Deallocate(spin_split_S)       
       If(Allocated(spin_split_ele_S)) Deallocate(spin_split_ele_S)
       If(Allocated(structure_conao_S)) Deallocate(structure_conao_S)
       If(Allocated(structure_conao_ele_S)) Deallocate(structure_conao_ele_S)
       Call pfree(newoptions% p_options)
       !Call pfree(coreoccu% p_state)
       If(Allocated(bandplot_points_S)) Deallocate(bandplot_points_S)
       If(Allocated(coreoccu_spinup_S)) Deallocate(coreoccu_spinup_S)
       If(Allocated(coreoccu_spindn_S)) Deallocate(coreoccu_spindn_S)
       !!START LSDA+U
       If(Allocated(lsdau_u_f)) Deallocate(lsdau_u_f)       
       !!END LSDA+U
       !!START GRID OUTPUT
       Call pfree(direction1_S)
       Call pfree(direction2_S)
       Call pfree(direction3_S)
       Call pfree(origin_S)
       Call pfree(kpoint_S)
       Call pfree(eminmax_S)
       !!END GRID OUTPUT

       Return
    
    Elseif(action == IO_ACTION_NEW_FILE.Or.&
         &action == IO_ACTION_STRUCTURE_UPDATE)Then
       !!
!!$       If(.Not.exist_basis)Then
!!$          Write(outfile,"('File ',a,' does not exist, will create it!')")&
!!$               &Trim(f_fplo_basis)
!!$          !!
!!$          Call basis_io(IO_ACTION_NEW_FILE,newstructure,basis,verstop,stopsym&
!!$               &,stopit)
!!$          !!
!!$          Write(outfile,"('File ',a,' created!')")Trim(f_fplo_basis)
!!$          
!!$       Else
!!$          Write(outfile,"('File ',a,' exists!')")Trim(f_fplo_basis)
!!$          Call basis_io(IO_ACTION_STRUCTURE_UPDATE,newstructure,basis,verstop&
!!$               &,stopsym,stopit)
!!$          
!!$       Endif
       


!!$       If(.Not.exist_devel)Then
!!$          Write(outfile,"('File ',a,' does not exist, will create it!')")&
!!$               &Trim(f_fplo_devel)
!!$          !!
!!$          Call devel_io(IO_ACTION_NEW_FILE,newstructure,mol,stopit)
!!$          !!
!!$          Write(outfile,"('File ',a,' created!')")Trim(f_fplo_devel)
!!$          
!!$       Else
!!$          Write(outfile,"('File ',a,' exists!')")Trim(f_fplo_devel)
!!$          Call devel_io(IO_ACTION_STRUCTURE_UPDATE,newstructure,mol,stopit)
!!$          
!!$       Endif
       

    End If runif2
    
    
    !! cleanup 
    If(Allocated(IOwtau_S)) Deallocate(IOwtau_S)
    Call pfree(structure% p_IOelements)
    Call pfree(structure% p_IOwtau)
    Call pfree(structure% p_tau)
    Call pfree(structure% p_IOisrt)
    Call pfree(structure% p_IOmult)
    Call pfree(structure% p_kaps)
    Call pfree(structure% p_IOconao)
    If(Allocated(spin_split_S)) Deallocate(spin_split_S)
    If(Allocated(spin_split_ele_S)) Deallocate(spin_split_ele_S)
    Call pfree(spin_split)
    If(Allocated(structure_conao_S)) Deallocate(structure_conao_S)
    If(Allocated(structure_conao_ele_S)) Deallocate(structure_conao_ele_S)
    Call pfree(loptions% p_options)
    Call pfree(newoptions% p_options)
    Call pfree(bandplot% p_points)
    If(Allocated(bandplot_points_S)) Deallocate(bandplot_points_S)
    Call pfree(bandplot% p_labels)
    
    
    Call pfree(coreoccu% p_sort)
    Call pfree(coreoccu% p_state)
    Call pfree(coreoccu% p_spinup)
    Call pfree(coreoccu% p_spindn)
    If(Allocated(coreoccu_spinup_S)) Deallocate(coreoccu_spinup_S)
    If(Allocated(coreoccu_spindn_S)) Deallocate(coreoccu_spindn_S)
    !!START LSDA+U
    If(Allocated(lsdau_u_f)) Deallocate(lsdau_u_f)       
    Call pfree(lsdau%  p_u_f)
    Call pfree(lsdau%  p_isrtu)
    Call pfree(lsdau%  p_state)
    !!END LSDA+U
    !!START OPC
    Call pfree(opc%  p_IOisrto)
    Call pfree(opc%  p_IOstate)
    !!END OPC
    Call pfree(ldos%  p_ldsites)
    
    !!START GRID OUTPUT
    Call pfree(direction1_S)
    Call pfree(direction2_S)
    Call pfree(direction3_S)
    Call pfree(origin_S)
    Call pfree(kpoint_S)
    Call pfree(eminmax_S)
    !!END GRID OUTPUT

    !!
    !!
  End Subroutine fplo_io
  !!***********************************************************************
  Subroutine sym_io(action,compound,symmetry,structure&
       &,lattice_constants_S,axis_angles_s,IOwtau_S)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)     :: action
    Character(*),Intent(out)      :: compound
    Type(T_Symmetry),Intent(out)  :: symmetry
    Type(T_Structure),Intent(out) :: structure
    Character(200),Pointer        :: IOwtau_S(:,:)
    Character(200),Intent(out)    :: lattice_constants_S(3)
    Character(200),Intent(out)    :: axis_angles_S(3)
    !!LOCAL
    Character(*),Parameter::nsubfunc="sym_io"
    Character(200)  ::  mainversion,subversion
    Character(200)  :: status
    Integer(t_int)  :: rank,asize(8)
    Integer(t_int),Pointer :: iugen(:)
    Integer(t_int)  :: ver
    !!
    Nullify(iugen)
    !!
    ver=VERSION_OK
    If(action /= IO_ACTION_NEW_FILE )Then

       !! read header information
       Call initparser
       Call readfile(f_fplo_sym)

       Call getstring("status",status)
       Call getstring("version.mainversion",mainversion)
       Call getstring("version.subversion",subversion)

       ver=checkversion(mainversion,subversion,f_fplo_sym)
       !! now read file
       

       
       Call getstring("compound",compound)
       
       !! newsymmetry,newstructure
       Call getinteger("lengthunit.type",structure % lengthunit)
       Call getinteger("spacegroup.number",symmetry % spgrpnum )


       If( variable_exists('subgroupgenerators'))Then
          Call getrankandsize("subgroupgenerators",rank,asize)
          symmetry% nugen=asize(1)
          Call palloc('iugen',iugen,1_t_int,symmetry% nugen,nmodule,nsubfunc)
          Call getinteger('subgroupgenerators',iugen)
          symmetry% iugen(1:symmetry% nugen)=iugen(1:symmetry% nugen)
          Call pfree(iugen)
       Else
          symmetry% nugen=0_t_int 
          symmetry% iugen(:)=0_t_int
       Endif


       Call getreal("lattice_constants",symmetry% lattice_constants )
       Call getrealasstring('lattice_constants',lattice_constants_S)
       Call getreal("axis_angles",symmetry % axis_angles )
       Call getrealasstring("axis_angles",axis_angles_S )
       
       !! read wyckoff positions       
       Call getinteger("nsort",structure % IOnsort )

       Call palloc('structure % p_IOelements',structure % p_IOelements &
            &,1_t_int,structure% IOnsort&
            &,nmodule,nsubfunc)

       Call palloc('structure % p_IOwtau',structure % p_IOwtau &
            &,1_t_int,3_t_int&
            &,1_t_int,structure% IOnsort&
            &,nmodule,nsubfunc)

       Call palloc('IOwtau_S',IOwtau_S &
            &,1_t_int,3_t_int&
            &,1_t_int,structure% IOnsort&
            &,nmodule,nsubfunc)

       Call getstring("wyckoff_positions.element",structure% p_IOelements)
       Call getreal("wyckoff_positions.tau",structure % p_IOwtau)
       Call getrealasstring("wyckoff_positions.tau",IOwtau_S)
       
       !Call getinteger('max_LIO',potential% max_LIO)
       
       !If(adapt_max_L) potential% max_LIO=Min(4_t_int,potential% max_LIO)
       


       If( variable_exists('structure_type.type'))Then
          Call getinteger('structure_type.type',structure% str_type)
       Else
          structure% str_type=STR_TYPE_CRYSTAL
       Endif
       
       Call crystal_structure_setup(symmetry,structure&
            &,complain_subgroups=.True.,save_syminfo=.True.)
       
       Call cleanreadfile
       !!--------- NO ACCESS TO INFILE PARSER AFTER THIS LINE PLEASE !! ----

       If(ver/=VERSION_OK)Then
          
          Write(outfile,"('Version update of ',a,':')")Trim(f_fplo_sym)
          
          Call create_symfile(status,compound &
               &,symmetry% spgrpnum&
               &,symmetry% nugen&
               &,symmetry% iugen&
               &,structure&
               &,lattice_constants_S&
               &,axis_angles_S&
               &,IOwtau_S&
               )
          Write(outfile,"('File ',a,' updated!')")Trim(f_fplo_sym)

       Endif

       Return
       
       
    Else If(action==IO_ACTION_NEW_FILE)Then
       
       compound='Al example'       
       
       
       structure % lengthunit=SYM_LENGTH_BOHRRADII
       symmetry% spgrpnum=225_t_int
       symmetry% nugen=0_t_int 
       symmetry% iugen(:)=0_t_int
       symmetry% lattice_constants=(/7.55_t_real,7.55_t_real,7.55_t_real/)
       symmetry% axis_angles=(/90._t_real,90._t_real,90._t_real/)
       lattice_constants_S=(/'7.55','7.55','7.55'/)
       axis_angles_S=(/'90.','90.','90.'/)
       
       structure% IOnsort=1_t_int
       
       Call palloc('structure % p_IOelements',structure % p_IOelements &
            &,1_t_int,structure% IOnsort&
            &,nmodule,nsubfunc)

       Call palloc('IOwtau_S',IOwtau_S &
            &,1_t_int,3_t_int&
            &,1_t_int,structure% IOnsort&
            &,nmodule,nsubfunc)


       Call palloc('structure % p_IOwtau',structure % p_IOwtau &
            &,1_t_int,3_t_int&
            &,1_t_int,structure% IOnsort&
            &,nmodule,nsubfunc)
       
       structure % p_IOelements=(/'Al'/)
       structure % p_IOwtau(1_t_int:3_t_int,1_t_int)=(/0._t_real,0._t_real,0._t_real/)
       IOwtau_S(1_t_int:3_t_int,1_t_int)=(/'0.','0.','0.'/) 
       
       
       structure% str_type=STR_TYPE_CRYSTAL

       Call crystal_structure_setup(symmetry,structure&
            &,complain_subgroups=.True.,save_syminfo=.True.)
       
       
       !!
       
       status='ready'
       
       Call create_symfile(status,compound &
            &,symmetry% spgrpnum&
            &,symmetry% nugen&
            &,symmetry% iugen&
            &,structure&
            &,lattice_constants_S&
            &,axis_angles_S&
            &,IOwtau_S&
            )
       
       
       !! cleanup 
       !!
       Return
    Endif
    !!
  End Subroutine sym_io
  !!***********************************************************************
!!$  Subroutine basis_io(action,structure,basis,verstop,stopsym,stopit)
!!$    Implicit None 
!!$    !!IO
!!$    Integer(t_int),Intent(in)     :: action
!!$    Logical(t_log),Intent(inout)  :: stopit
!!$    Type(T_Basis),Intent(inout)   :: basis
!!$    Type(T_Structure),Intent(in)  :: structure
!!$    Logical(t_log),Intent(in)     :: verstop,stopsym
!!$    !!LOCAL
!!$    Character(*),Parameter::nsubfunc="basis_io"
!!$    Type(T_Basis)       :: defaultbasis,newbasis
!!$    Integer :: icheck
!!$    Integer(t_int)               :: rank,asize(8)
!!$    Integer(t_int)               :: basis_nsort
!!$    Character(200),Pointer      :: basis_x0_S(:,:)
!!$    Character(200),Pointer      :: defaultbasis_x0_S(:,:)
!!$    Character(200),Pointer      :: newbasis_x0_S(:,:)
!!$    Character(2),Allocatable    :: newbasis_elements_S(:)
!!$    Character(2),Allocatable    :: corestates(:,:)
!!$    Character(200)              :: buf
!!$    Integer(t_int) :: issaIO,ic,iv,j,ver,lc,nnc,isclex,jex,iscla,isclb,iz
!!$    Character(60)  :: chc,chs,chv,chp
!!$    Character(2)  :: ch
!!$    Integer(t_int) :: nsem,nval,npol,icl,ist,ivcl,iscl,ncor
!!$    Integer(t_int) :: nscl,nsst
!!$    Integer(t_int) :: nvcl,nvst
!!$    Integer(t_int) :: npcl,npst
!!$    Logical(t_log) :: warn,err
!!$    Character(200)      ::  mainversion,subversion
!!$    Integer             :: eof
!!$    Character(5000)     :: buffer
!!$    Integer(t_int),Allocatable  :: ind(:)
!!$    Integer(t_int),Allocatable  :: nsemicl(:)
!!$    Integer(t_int),Allocatable  :: nsemist(:,:)
!!$    Character(2),Allocatable    :: semistates(:,:,:)
!!$    Real(t_real),Allocatable    :: semix0(:,:)
!!$    Character(200),Allocatable  :: semix0_S(:,:)
!!$    Integer(t_int),Allocatable  :: nvalcl(:)
!!$    Integer(t_int),Allocatable  :: nvalst(:,:)
!!$    Character(2),Allocatable    :: valstates(:,:,:)
!!$    Real(t_real),Allocatable    :: valx0(:,:)
!!$    Character(200),Allocatable  :: valx0_S(:,:)
!!$    Integer(t_int),Allocatable  :: npolcl(:)
!!$    Integer(t_int),Allocatable  :: npolst(:,:)
!!$    Character(2),Allocatable    :: polstates(:,:,:)
!!$    Real(t_real),Allocatable    :: polx0(:,:)
!!$    Character(200),Allocatable  :: polx0_S(:,:)
!!$    Character(2),Allocatable    :: atoms(:)
!!$    !!
!!$    warn=.False.
!!$    Call init_basis(defaultbasis)
!!$    Call init_basis(newbasis)
!!$    Nullify(basis_x0_S)
!!$    Nullify(defaultbasis_x0_S)
!!$    Nullify(newbasis_x0_S)
!!$    !!
!!$    ifwrite: If(action == IO_ACTION_WRITE_FILE )Then
!!$
!!$       
!!$
!!$       Call palloc('basis_x0_S',basis_x0_S &
!!$            &,1_t_int,basis% IOnvm &
!!$            &,1_t_int,structure% IOnsort &
!!$            &,nmodule,nsubfunc)
!!$
!!$
!!$       !! make string data
!!$       Do issaIO=1_t_int,structure% IOnsort
!!$          Do iv=1_t_int,basis% p_IOnv(issaIO)
!!$1            Format(f30.8)
!!$             If(basis% p_IOtv(iv,issaIO)==ORB_TYPE_SEMICORE)Then
!!$                Write(buf,1)-Abs(basis% p_IOx0(iv,issaIO))
!!$             Else If(basis% p_IOtv(iv,issaIO)==ORB_TYPE_POLARIZATION)Then
!!$                Write(buf,1)-Abs(basis% p_IOx0(iv,issaIO))
!!$             Else If(basis% p_IOtv(iv,issaIO)==ORB_TYPE_VALENCE)Then
!!$                Write(buf,1)Abs(basis% p_IOx0(iv,issaIO))
!!$             Endif
!!$
!!$             j=Verify(buf,"0 ",.True.)
!!$             basis_x0_S(iv,issaIO)=Trim(Adjustl(buf(1_t_int:j)))
!!$          Enddo
!!$       Enddo
!!$       !! TODO: make better strings, remove trailing zeros
!!$       
!!$       Call create_basisfile(structure% IOnsort,structure% p_IOelements &
!!$            &,basis,basis_x0_S)
!!$
!!$       call pfree(basis_x0_S)
!!$       return
!!$    End If ifwrite
!!$    
!!$
!!$    ver=VERSION_OK
!!$    ifnotnew: If(action /= IO_ACTION_NEW_FILE )Then
!!$
!!$       Call initparser
!!$       Call readfile(f_fplo_basis)
!!$
!!$
!!$       Call getstring("version.mainversion",mainversion)
!!$       Call getstring("version.subversion",subversion)
!!$       
!!$       ver=checkversion(mainversion,subversion,f_fplo_basis)
!!$
!!$
!!$       If(action == IO_ACTION_RUN .And. .Not. verstop .And. .Not. stopsym )Then
!!$          Write(outfile,"(72('-'),/,'Start: content of ',a,/,72('-'))")&
!!$               & Trim(f_fplo_basis)
!!$          Open(12,file=f_fplo_basis)
!!$          Do 
!!$             Read(12,"(a)",iostat=eof)buffer
!!$             If(eof < 0_t_int) Exit
!!$             Write(outfile,"(a)")Trim(buffer)
!!$          Enddo
!!$          Close(12)
!!$          Write(outfile,"(72('-'),/,'End  : content of ',a,/,72('-'))")&
!!$               & Trim(f_fplo_basis)
!!$       Endif
!!$       
!!$
!!$
!!$
!!$       
!!$       ifver301: If(ver /= VERSION_OK .And. ver < VERSION_3_01) Then
!!$          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$          !! read input from files of version<3.01
!!$
!!$          !! core states       
!!$          Call getrankandsize('basis',rank,asize) 
!!$          basis_nsort=asize(1_t_int)       
!!$
!!$          newbasis% IOnsrtcl=basis_nsort
!!$          Call palloc('newbasis % p_IOninsrtcl',newbasis % p_IOninsrtcl &
!!$               &,1_t_int,basis_nsort &
!!$               &,nmodule,nsubfunc)
!!$          Call palloc('newbasis % p_IOsrtcl',newbasis % p_IOsrtcl &
!!$               &,1_t_int,basis_nsort &
!!$               &,1_t_int,basis_nsort &
!!$               &,nmodule,nsubfunc)
!!$
!!$
!!$          Do issaIO=1,basis_nsort
!!$             newbasis % p_IOninsrtcl(issaIO)=1_t_int
!!$             newbasis % p_IOsrtcl(1,issaIO)=issaIO
!!$          Enddo
!!$          
!!$          Allocate(newbasis_elements_S(basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for newbasis_elements_S !'")
!!$          Endif
!!$          Call getstring('basis.atom',newbasis_elements_S)
!!$          
!!$          Call getrankandsize('basis.corestates',rank,asize) 
!!$          newbasis% IOncm=asize(1_t_int)       
!!$          Allocate( corestates(newbasis% IOncm,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for corestates !'")
!!$          Endif
!!$          If(newbasis% IOncm>0)Then
!!$             Call getstring('basis.corestates.state',corestates)
!!$          Endif
!!$          
!!$          
!!$          Call alloc_basis_IO_core_arrays(newbasis,basis_nsort,newbasis% IOncm)
!!$          
!!$          Call getsizearray('basis.corestates.state',newbasis% p_IOnc) 
!!$          
!!$
!!$          Do issaIO=1_t_int,basis_nsort
!!$             Do ic=1_t_int,newbasis % p_IOnc(issaIO)
!!$                Read(corestates(ic,issaIO)(1_t_int:1_t_int),"(i1)") &
!!$                     &newbasis % p_IOnnc(ic,issaIO)
!!$                newbasis % p_IOlc(ic,issaIO)&
!!$                     &=lcharqn(corestates(ic,issaIO)(2_t_int:2_t_int))
!!$                newbasis % p_IOcnfc(ic,issaIO)=CORE_CONF_NO
!!$                newbasis % p_IOrcinf(ic,issaIO)=0.0_t_real
!!$             Enddo
!!$          End Do
!!$          If(Allocated(corestates))Deallocate(corestates)
!!$          !! valence states
!!$          Call getrankandsize('basis.valencestates',rank,asize) 
!!$          newbasis% IOnvm=asize(1_t_int)
!!$          
!!$          
!!$          Allocate( corestates(newbasis % IOnvm,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for corestates !'")
!!$          Endif
!!$          If(newbasis% IOnvm>0)Then
!!$             Call getstring('basis.valencestates.state',corestates)
!!$          Endif
!!$          
!!$          Call alloc_basis_IO_valence_arrays(newbasis,basis_nsort&
!!$               &,newbasis% IOnvm)
!!$
!!$          Call palloc('newbasis_x0_S',newbasis_x0_S &
!!$               &,1_t_int,newbasis% IOnvm &
!!$               &,1_t_int,basis_nsort &
!!$               &,nmodule,nsubfunc)
!!$
!!$          
!!$          Call getsizearray('basis.valencestates.state',newbasis% p_IOnv) 
!!$          Call getreal('basis.valencestates.compression',newbasis% p_IOx0)
!!$          Call getrealasstring('basis.valencestates.compression',newbasis_x0_S)
!!$          
!!$          
!!$
!!$          Do issaIO=1_t_int,basis_nsort
!!$             Do iv=1_t_int,newbasis% p_IOnv(issaIO)
!!$                Read(corestates(iv,issaIO)(1_t_int:1_t_int),"(i1)") &
!!$                     &newbasis% p_IOnnv(iv,issaIO)
!!$                newbasis% p_IOlv(iv,issaIO)&
!!$                     &=lcharqn(corestates(iv,issaIO)(2_t_int:2_t_int))
!!$                newbasis% p_IOnvcl(iv,issaIO)=iv
!!$                iz=getelementnumber(newbasis_elements_S(issaIO))
!!$                Call getcbas(iz,ncor,nsem,nval,npol,chc,chs,chv,chp)
!!$                !!Print "('<',a,'>','<',a,'>','<',a,'>','<',a,'>')"&
!!$                !!     &,Trim(chc),Trim(chs),Trim(chv),Trim(chp)
!!$
!!$                newbasis% p_IOQion(iv,issaIO)=0.0_t_real
!!$
!!$                If(newbasis% p_IOx0(iv,issaIO) > 1.e-5_t_real)Then
!!$                   newbasis% p_IOtv(iv,issaIO)=ORB_TYPE_VALENCE
!!$                Else If(Abs(newbasis% p_IOx0(iv,issaIO)) < 1.e-5_t_real)Then
!!$                   newbasis% p_IOtv(iv,issaIO)=ORB_TYPE_SEMICORE
!!$                Else
!!$                   
!!$                   Write(ch,987) newbasis% p_IOnnv(iv,issaIO)&
!!$                        &,lqnchar(newbasis% p_IOlv(iv,issaIO))
!!$                   If(Index(chc,ch)>0 .Or. Index(chs,ch)>0)Then
!!$                      newbasis% p_IOtv(iv,issaIO)=ORB_TYPE_SEMICORE
!!$                   Else
!!$                      newbasis% p_IOtv(iv,issaIO)=ORB_TYPE_POLARIZATION
!!$                   Endif
!!$                Endif
!!$
!!$
!!$
!!$                !!Print "(i3,1x,a2,1x,i1,a1,1x,i1,f30.15,a)"&
!!$                !!     &,iz,newbasis_elements_S(issaIO)&
!!$                !!     &,newbasis% p_IOnnv(iv,issaIO)&
!!$                !!     &,lqnchar(newbasis% p_IOlv(iv,issaIO))&
!!$                !!     &,newbasis% p_IOtv(iv,issaIO)&
!!$                !!     &,newbasis% p_IOx0(iv,issaIO)&
!!$                !!     &,newbasis_x0_S(iv,issaIO)
!!$                     
!!$             Enddo
!!$          End Do
!!$          If(Allocated(corestates))Deallocate(corestates)
!!$       Else !! ifver301
!!$          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$          !! ver>=VERSION_3_01
!!$          If( .Not. variable_exists('basis.semicorestates'))Then
!!$300          Format('"Cannot find correct basis data in input file '''&
!!$                  &,a,''' of version > 3.00 !"')
!!$             Write(errbuf,300)Trim(f_fplo_basis)
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
!!$          Endif
!!$
!!$          Call getinteger('nsort',basis_nsort) 
!!$
!!$          Allocate(newbasis_elements_S(basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for newbasis_elements_S !'")
!!$          Endif
!!$          Call getstring('elements',newbasis_elements_S)
!!$
!!$          Call getrankandsize('basis',rank,asize) 
!!$          !!TEST
!!$          If(asize(1_t_int) > basis_nsort)Then
!!$341          Format('"variable basis[] contains more than nsort(',i5&
!!$                  &,') data members&
!!$                  & in input file ''',a,''' !"')
!!$             Write(errbuf,341)basis_nsort,Trim(f_fplo_basis)
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
!!$          Endif
!!$          !!TEST
!!$
!!$          Allocate( atoms(basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for atoms !'")
!!$          Endif
!!$          Call getstring('basis.atom',atoms)
!!$
!!$
!!$          Call getrankandsize('basis.sorts',rank,asize) 
!!$          newbasis% IOnsrtcl=asize(2_t_int)       
!!$
!!$          !!TEST
!!$          If(asize(1_t_int) > basis_nsort)Then
!!$335          Format('"basis[].sorts contains more than nsort(',i5&
!!$                  &,') Data items in one class in input file ''',a,''' !"')
!!$             Write(errbuf,335)basis_nsort,Trim(f_fplo_basis)
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
!!$
!!$          Endif
!!$          !!TEST
!!$
!!$          Call palloc('newbasis % p_IOninsrtcl',newbasis % p_IOninsrtcl &
!!$               &,1_t_int,basis_nsort &
!!$               &,nmodule,nsubfunc)
!!$
!!$          Call palloc('newbasis % p_IOsrtcl',newbasis % p_IOsrtcl &
!!$               &,1_t_int,basis_nsort &
!!$               &,1_t_int,basis_nsort &
!!$               &,nmodule,nsubfunc)
!!$
!!$          Call getsizearray('basis.sorts',newbasis% p_IOninsrtcl) 
!!$          Call getinteger('basis.sorts',newbasis% p_IOsrtcl) 
!!$
!!$
!!$          !!START:TEST does basis.sorts contain basis_nsort data elements
!!$          If(Sum(newbasis% p_IOninsrtcl(1:newbasis% IOnsrtcl))/=basis_nsort)Then
!!$             Write(errbuf,330)basis_nsort,Trim(f_fplo_basis)
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
!!$
!!$          Endif
!!$330       Format('"basis[].sorts must contain exactly nsort(',i5,') Data &
!!$               &items in input file ''',a,''' !"')
!!$367       Format('"basis[',i5,'].sorts must not be empty&
!!$               & in input file ''',a,''' !"')
!!$357       Format('"basis[',i5,'].sorts[',i5,']= ',i5&
!!$               &,' out of range [1..nsort(',i5,')]&
!!$               & in input file ''',a,''' !"')
!!$331       Format('"basis[].sorts must contain each sort index exactly once&
!!$               & in input file ''',a,'''!"')
!!$1001      Format('basis[',i5,'].sorts[',i5,']=',i5,', atom=',a,' belongs to a&
!!$               & different element (',a2,')',/,' in the variable ''elements'',&
!!$               & defined in the structure section in file ''',a,'''?')
!!$332       Format('"basis[].sorts must contain only the same element type per &
!!$               &class in input file ''',a,''' !"')
!!$
!!$          Do iscl=1,newbasis% IOnsrtcl
!!$             If(newbasis% p_IOninsrtcl(iscl) < 1_t_int)Then
!!$                Write(errbuf,367)iscl,Trim(f_fplo_basis)
!!$                Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
!!$             Endif
!!$             Do j=1_t_int,newbasis% p_IOninsrtcl(iscl)
!!$                issaIO=newbasis% p_IOsrtcl(j,iscl);
!!$                If(issaIO < 1_t_int .Or. issaIO > basis_nsort)Then
!!$                   Write(errbuf,357)iscl,j,issaIO,basis_nsort,Trim(f_fplo_basis)
!!$                   Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
!!$                Endif
!!$             Enddo
!!$          Enddo
!!$          !! does basis.sorts contain each sort number exactly once
!!$          Allocate( ind(basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for ind !'")
!!$          Endif
!!$          
!!$          ind(:)=0_t_int
!!$          Do iscl=1,newbasis% IOnsrtcl
!!$             Do j=1,newbasis% p_IOninsrtcl(iscl)
!!$                ind(newbasis% p_IOsrtcl(j,iscl))=&
!!$                     &ind(newbasis% p_IOsrtcl(j,iscl))+1_t_int
!!$             Enddo
!!$          Enddo
!!$
!!$
!!$          If(Any(ind(1_t_int:basis_nsort)/=1_t_int))Then
!!$             Write(errbuf,331)Trim(f_fplo_basis)
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
!!$
!!$          Endif
!!$          If(Allocated(ind))Deallocate(ind)          
!!$          !! does each class only contain the correct element type
!!$          err=.False.
!!$          Do iscl=1,newbasis% IOnsrtcl
!!$             Do j=1,newbasis% p_IOninsrtcl(iscl)
!!$                If(newbasis_elements_S(newbasis% p_IOsrtcl(j,iscl)) /=&
!!$                     &atoms(iscl))Then
!!$                   err=.True.
!!$                   Write(outfile,1001)&
!!$                        &iscl,j,newbasis% p_IOsrtcl(j,iscl)&
!!$                        &,atoms(iscl)&
!!$                        &,newbasis_elements_S(newbasis% p_IOsrtcl(j,iscl))&
!!$                        &,Trim(f_fplo_basis)
!!$                Endif
!!$             Enddo
!!$          Enddo
!!$
!!$          If(err)Then
!!$             Write(errbuf,332)Trim(f_fplo_basis)
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
!!$          Endif
!!$          !!END:TESTS
!!$          If(Allocated(atoms))Deallocate(atoms)          
!!$
!!$
!!$          !! core states
!!$          Call getrankandsize('basis.corestates',rank,asize) 
!!$          newbasis% IOncm=asize(1_t_int)       
!!$
!!$          Allocate( corestates(newbasis% IOncm,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for corestates !'")
!!$          Endif
!!$          If(newbasis% IOncm>0)Then
!!$             Call getstring('basis.corestates.state',corestates)
!!$          Endif
!!$
!!$          Allocate( ind(basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for ind !'")
!!$          Endif
!!$
!!$          Call getsizearray('basis.corestates.state',ind) 
!!$
!!$          Call alloc_basis_IO_core_arrays(newbasis,basis_nsort,newbasis% IOncm)
!!$          
!!$          
!!$          Do iscl=1,newbasis% IOnsrtcl
!!$             Do j=1,newbasis% p_IOninsrtcl(iscl)
!!$                newbasis% p_IOnc(newbasis% p_IOsrtcl(j,iscl))=ind(iscl)
!!$             Enddo
!!$             Do ic=1_t_int,ind(iscl)
!!$                Read(corestates(ic,iscl)(1_t_int:1_t_int),"(i1)") nnc
!!$                lc=lcharqn(corestates(ic,iscl)(2_t_int:2_t_int))
!!$
!!$                Do j=1,newbasis% p_IOninsrtcl(iscl)
!!$                   issaIO=newbasis% p_IOsrtcl(j,iscl)
!!$                   newbasis % p_IOnnc(ic,issaIO)=nnc
!!$                   newbasis % p_IOlc(ic,issaIO)=lc
!!$                   newbasis % p_IOcnfc(ic,issaIO)=CORE_CONF_NO
!!$                   newbasis % p_IOrcinf(ic,issaIO)=0.0_t_real
!!$                Enddo
!!$             Enddo
!!$          Enddo
!!$
!!$
!!$          If(Allocated(ind))Deallocate(ind)
!!$          If(Allocated(corestates))Deallocate(corestates)
!!$
!!$          
!!$          !! valence states
!!$          
!!$          !! read semicore states
!!$          Call getrankandsize('basis.semicorestates.states',rank,asize) 
!!$          nscl=asize(2_t_int)
!!$          nsst=asize(1_t_int)
!!$          
!!$          Allocate( nsemicl(basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for nsemicl !'")
!!$          Endif
!!$          Allocate( nsemist(nscl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for nsemist !'")
!!$          Endif
!!$          Allocate( semistates(nsst,nscl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for semistates !'")
!!$          Endif
!!$          Allocate( semix0(nscl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for semix0 !'")
!!$          Endif
!!$          Allocate( semix0_S(nscl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for semix0_S !'")
!!$          Endif
!!$
!!$          Call getsizearray('basis.semicorestates',nsemicl) 
!!$          If(nscl>0)Then
!!$             Call getsizearray('basis.semicorestates.states',nsemist)
!!$          Endif
!!$          If(nscl*nsst>0)Then
!!$             Call getstring('basis.semicorestates.states',semistates)
!!$          Endif
!!$          If(nscl>0)Then
!!$             Call getreal('basis.semicorestates.compression',semix0)
!!$             Call getrealasstring('basis.semicorestates.compression',semix0_S)
!!$          Endif
!!$
!!$
!!$          !! read valence states
!!$          Call getrankandsize('basis.valencestates.states',rank,asize) 
!!$          nvcl=asize(2_t_int)
!!$          nvst=asize(1_t_int)
!!$          
!!$          Allocate( nvalcl(basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for nvalcl !'")
!!$          Endif
!!$          Allocate( nvalst(nvcl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for nvalst !'")
!!$          Endif
!!$          Allocate( valstates(nvst,nvcl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for valstates !'")
!!$          Endif
!!$          Allocate( valx0(nvcl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for valx0 !'")
!!$          Endif
!!$          Allocate( valx0_S(nvcl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for valx0_S !'")
!!$          Endif
!!$
!!$          Call getsizearray('basis.valencestates',nvalcl) 
!!$          If(nvcl>0)Then
!!$             Call getsizearray('basis.valencestates.states',nvalst)
!!$          Endif
!!$          If(nvcl*nvst>0)Then
!!$             Call getstring('basis.valencestates.states',valstates)
!!$          Endif
!!$          If(nvcl>0)Then
!!$             Call getreal('basis.valencestates.compression',valx0)
!!$             Call getrealasstring('basis.valencestates.compression',valx0_S)
!!$          Endif
!!$
!!$
!!$
!!$          !! read polarization states
!!$          Call getrankandsize('basis.polarizationstates.states',rank,asize) 
!!$          npcl=asize(2_t_int)
!!$          npst=asize(1_t_int)
!!$          
!!$          Allocate( npolcl(basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for npolcl !'")
!!$          Endif
!!$          Allocate( npolst(npcl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for npolst !'")
!!$          Endif
!!$          Allocate( polstates(npst,npcl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for polstates !'")
!!$          Endif
!!$          Allocate( polx0(npcl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for polx0 !'")
!!$          Endif
!!$          Allocate( polx0_S(npcl,basis_nsort),STAT=icheck)
!!$          If(icheck/=0)Then
!!$             Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                  &,msg="'Could not allocate memory for polx0_S !'")
!!$          Endif
!!$
!!$          Call getsizearray('basis.polarizationstates',npolcl) 
!!$          If(npcl>0)Then
!!$             Call getsizearray('basis.polarizationstates.states',npolst)
!!$          Endif
!!$          If(npcl*npst>0)Then
!!$             Call getstring('basis.polarizationstates.states',polstates)
!!$          Endif
!!$          If(npcl>0)Then
!!$             Call getreal('basis.polarizationstates.compression',polx0)
!!$             Call getrealasstring('basis.polarizationstates.compression'&
!!$                  &,polx0_S)
!!$          Endif
!!$
!!$          nsem=0_t_int
!!$          nval=0_t_int
!!$          npol=0_t_int
!!$          Do iscl=1,newbasis% IOnsrtcl
!!$             nsem=Max(nsem,Sum(nsemist(1:nsemicl(iscl),iscl)))
!!$             nval=Max(nval,Sum(nvalst(1:nvalcl(iscl),iscl)))
!!$             npol=Max(npol,Sum(npolst(1:npolcl(iscl),iscl)))
!!$          Enddo
!!$          
!!$
!!$          newbasis% IOnvm=nsem+nval+npol
!!$          
!!$          Call alloc_basis_IO_valence_arrays(newbasis,basis_nsort&
!!$               &,newbasis% IOnvm)
!!$               
!!$          Call palloc('newbasis_x0_S',newbasis_x0_S &
!!$               &,1_t_int,newbasis% IOnvm &
!!$               &,1_t_int,basis_nsort &
!!$               &,nmodule,nsubfunc)
!!$          
!!$
!!$          newbasis % p_IOnv(:)=0_t_int
!!$
!!$          Do iscl=1,newbasis% IOnsrtcl
!!$             Do j=1,newbasis% p_IOninsrtcl(iscl)
!!$                issaIO=newbasis% p_IOsrtcl(j,iscl)
!!$                iv=0_t_int
!!$                ivcl=0_t_int
!!$
!!$                newbasis % p_IOnv(issaIO)=newbasis % p_IOnv(issaIO)&
!!$                     &+Sum(nsemist(1:nsemicl(iscl),iscl))
!!$
!!$                Do icl=1,nsemicl(iscl)
!!$                   ivcl=ivcl+1_t_int
!!$                   Do ist=1,nsemist(icl,iscl)
!!$                      iv=iv+1_t_int
!!$                      Read(semistates(ist,icl,iscl)(1_t_int:1_t_int),"(i1)") &
!!$                           &newbasis% p_IOnnv(iv,issaIO)
!!$                      newbasis% p_IOlv(iv,issaIO)=&
!!$                           &lcharqn(semistates(ist,icl,iscl)(2_t_int:2_t_int))
!!$                      newbasis% p_IOtv(iv,issaIO)=ORB_TYPE_SEMICORE
!!$                      newbasis% p_IOx0(iv,issaIO)=-Abs(semix0(icl,iscl))
!!$                      newbasis% p_IOQion(iv,issaIO)=0.0_t_real
!!$                      newbasis_x0_S(iv,issaIO)=semix0_S(icl,iscl)
!!$                      Call makeNegativeString(newbasis_x0_S(iv,issaIO))
!!$                      newbasis% p_IOnvcl(iv,issaIO)=ivcl
!!$                   Enddo
!!$                Enddo
!!$                
!!$                newbasis % p_IOnv(issaIO)=newbasis % p_IOnv(issaIO)&
!!$                     &+Sum(nvalst(1:nvalcl(iscl),iscl))
!!$                
!!$                Do icl=1,nvalcl(iscl)
!!$                   ivcl=ivcl+1_t_int
!!$                   Do ist=1,nvalst(icl,iscl)
!!$                      iv=iv+1_t_int
!!$                      Read(valstates(ist,icl,iscl)(1_t_int:1_t_int),"(i1)") &
!!$                           &newbasis% p_IOnnv(iv,issaIO)
!!$                      newbasis% p_IOlv(iv,issaIO)=&
!!$                           &lcharqn(valstates(ist,icl,iscl)(2_t_int:2_t_int))
!!$                      newbasis% p_IOtv(iv,issaIO)=ORB_TYPE_VALENCE
!!$                      newbasis% p_IOx0(iv,issaIO)=Abs(valx0(icl,iscl))
!!$                      newbasis% p_IOQion(iv,issaIO)=0.0_t_real
!!$                      newbasis_x0_S(iv,issaIO)=valx0_S(icl,iscl)
!!$                      Call makePositiveString(newbasis_x0_S(iv,issaIO))
!!$                      newbasis% p_IOnvcl(iv,issaIO)=ivcl
!!$                   Enddo
!!$                Enddo
!!$                
!!$                newbasis % p_IOnv(issaIO)=newbasis % p_IOnv(issaIO)&
!!$                     &+Sum(npolst(1:npolcl(iscl),iscl))
!!$                
!!$                Do icl=1,npolcl(iscl)
!!$                   ivcl=ivcl+1_t_int
!!$                   Do ist=1,npolst(icl,iscl)
!!$                      iv=iv+1_t_int
!!$                      Read(polstates(ist,icl,iscl)(1_t_int:1_t_int),"(i1)") &
!!$                           &newbasis% p_IOnnv(iv,issaIO)
!!$                      newbasis% p_IOlv(iv,issaIO)=&
!!$                           &lcharqn(polstates(ist,icl,iscl)(2_t_int:2_t_int))
!!$                      newbasis% p_IOtv(iv,issaIO)=ORB_TYPE_POLARIZATION
!!$                      newbasis% p_IOx0(iv,issaIO)=-Abs(polx0(icl,iscl))
!!$                      newbasis% p_IOQion(iv,issaIO)=0.0_t_real
!!$                      newbasis_x0_S(iv,issaIO)=polx0_S(icl,iscl)
!!$                      Call makeNegativeString(newbasis_x0_S(iv,issaIO))
!!$                      newbasis% p_IOnvcl(iv,issaIO)=ivcl
!!$                   Enddo
!!$                Enddo
!!$             Enddo! all in sort class
!!$          Enddo ! all sort classes
!!$          
!!$
!!$
!!$          !!cleanup
!!$          If(Allocated(nsemicl))Deallocate(nsemicl)
!!$          If(Allocated(nsemist))Deallocate(nsemist)
!!$          If(Allocated(semistates))Deallocate(semistates)
!!$          If(Allocated(semix0))Deallocate(semix0)
!!$          If(Allocated(semix0_S))Deallocate(semix0_S)
!!$          If(Allocated(nvalcl))Deallocate(nvalcl)
!!$          If(Allocated(nvalst))Deallocate(nvalst)
!!$          If(Allocated(valstates))Deallocate(valstates)
!!$          If(Allocated(valx0))Deallocate(valx0)
!!$          If(Allocated(valx0_S))Deallocate(valx0_S)
!!$          If(Allocated(npolcl))Deallocate(npolcl)
!!$          If(Allocated(npolst))Deallocate(npolst)
!!$          If(Allocated(polstates))Deallocate(polstates)
!!$          If(Allocated(polx0))Deallocate(polx0)
!!$          If(Allocated(polx0_S))Deallocate(polx0_S)
!!$          !!
!!$
!!$       Endif ifver301
!!$
!!$       !! update basis definitions
!!$       Call free_basis_IO_arrays(basis)
!!$       Call pfree(basis_x0_S)
!!$       
!!$       Call defbasisconfig(defaultbasis,defaultbasis_x0_S,structure% IOnsort&
!!$            &,structure% p_IOelements)       
!!$       
!!$
!!$       basis % IOnsrtcl=newbasis % IOnsrtcl
!!$       
!!$       basis% IOncm =Max(defaultbasis% IOncm,newbasis% IOncm)
!!$       basis% IOnvm =Max(defaultbasis% IOnvm,newbasis% IOnvm)
!!$
!!$       Call alloc_basis_IO_core_arrays(basis,structure% IOnsort,basis% IOncm)
!!$
!!$       Call palloc('basis % p_IOninsrtcl',basis % p_IOninsrtcl &
!!$            &,1_t_int,structure% IOnsort &
!!$            &,nmodule,nsubfunc)
!!$
!!$       Call palloc('basis % p_IOsrtcl',basis % p_IOsrtcl &
!!$            &,1_t_int,structure% IOnsort &
!!$            &,1_t_int,structure% IOnsort &
!!$            &,nmodule,nsubfunc)
!!$
!!$       Call alloc_basis_IO_valence_arrays(basis,structure% IOnsort&
!!$            &,basis% IOnvm)
!!$
!!$
!!$       Call palloc('basis_x0_S',basis_x0_S &
!!$            &,1_t_int,basis% IOnvm &
!!$            &,1_t_int,structure% IOnsort &
!!$            &,nmodule,nsubfunc)
!!$
!!$
!!$       !!TODO: determine ratoms
!!$       !!TODO: if version old and not default settings convert x0
!!$       !!TODO: this may fail, if for some reasons =.basis and =.sym do not belong to the
!!$       !!TODO: same structure, which only happens if fedit was not used
!!$
!!$       !! take old basis settings
!!$       warn=.False.
!!$       ifnsorteqnsort: If(structure% IOnsort == basis_nsort) Then
!!$
!!$          basis% p_IOninsrtcl=newbasis% p_IOninsrtcl
!!$          basis% p_IOsrtcl=newbasis% p_IOsrtcl
!!$
!!$          Do issaIO=1_t_int,structure% IOnsort
!!$             If(Trim(structure% p_IOelements(issaIO)) /=&
!!$                  &Trim(newbasis_elements_S(issaIO)) )Then
!!$
!!$                !! extract this issaIO from the classes
!!$                isclex=-1
!!$                jex=-1
!!$                outer: Do iscl=1,basis% IOnsrtcl
!!$                   Do j=1,basis% p_IOninsrtcl(iscl)
!!$                      If(issaIO==basis% p_IOsrtcl(j,iscl))Then
!!$                         isclex=iscl
!!$                         jex=j
!!$                         Exit outer
!!$                      Endif
!!$                   Enddo
!!$                Enddo outer
!!$                !! extract
!!$                If(isclex==-1 .Or. jex==-1)Then
!!$                   Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$                        &,msg="'Cannot find sort in class arrays?!',/&
!!$                        &,' Please report this bug!'")
!!$                Endif
!!$                If(basis% p_IOninsrtcl(isclex)>1)Then
!!$                   Do j=jex+1,basis% p_IOninsrtcl(isclex)
!!$                      basis% p_IOsrtcl(j-1,isclex)=basis% p_IOsrtcl(j,isclex)
!!$                   Enddo
!!$                   basis% p_IOninsrtcl(isclex)=basis% p_IOninsrtcl(isclex)-1_t_int
!!$                   basis% IOnsrtcl=basis% IOnsrtcl+1
!!$                   basis% p_IOninsrtcl(basis% IOnsrtcl)=1_t_int
!!$                   basis% p_IOsrtcl(1,basis% IOnsrtcl)=issaIO
!!$                Endif
!!$
!!$
!!$
!!$                !! create default basis                
!!$                warn=.True.
!!$
!!$                Call copy_basis_IO_arrays(basis,defaultbasis,issaIO)
!!$                Do iv=1,basis% p_IOnv(issaIO)                
!!$                   basis_x0_S(iv,issaIO)=defaultbasis_x0_S(iv,issaIO)
!!$                End Do
!!$                
!!$                
!!$             Else
!!$
!!$                Call copy_basis_IO_arrays(basis,newbasis,issaIO)
!!$                Do iv=1,basis% p_IOnv(issaIO)
!!$                   basis_x0_S(iv,issaIO)=newbasis_x0_S(iv,issaIO)
!!$                End Do
!!$                
!!$                
!!$             Endif
!!$          Enddo!issaIO
!!$          
!!$          If(warn)Then
!!$             Call errmsg(nmodule,nsubfunc,E_warning&
!!$                  &,msg="'Element at some Wyckoff position changed!',/&
!!$                  &,' Will take default basis definition!'")
!!$          End If
!!$          
!!$       Else !! ifnsorteqnsort
!!$
!!$          Call errmsg(nmodule,nsubfunc,E_warning&
!!$               &,msg="'Number of Wyckoff positions changed!',/&
!!$               &,' Will take default basis definition!'")
!!$          warn=.True.
!!$
!!$          basis% IOnsrtcl=structure% IOnsort          
!!$          basis % p_IOninsrtcl=defaultbasis% p_IOninsrtcl
!!$          basis % p_IOsrtcl=defaultbasis% p_IOsrtcl
!!$          
!!$          Do issaIO=1_t_int,structure% IOnsort
!!$
!!$             Call copy_basis_IO_arrays(basis,defaultbasis,issaIO)          
!!$             Do iv=1,basis% p_IOnv(issaIO)
!!$                basis_x0_S(iv,issaIO)=defaultbasis_x0_S(iv,issaIO)
!!$             End Do
!!$             
!!$             
!!$          Enddo
!!$          
!!$          
!!$       Endif ifnsorteqnsort
!!$       
!!$       !!START:sorting of sort-class arrays
!!$       Do iscl=1,basis% IOnsrtcl
!!$          Call ishell(1_t_int,basis% p_IOninsrtcl(iscl),basis% p_IOsrtcl(1:,iscl))
!!$       Enddo
!!$       Allocate( ind(structure% IOnsort),STAT=icheck)
!!$       If(icheck/=0)Then
!!$          Call errmsg(nmodule,nsubfunc,E_fatalerror&
!!$               &,msg="'Could not allocate memory for ind !'")
!!$       Endif
!!$       Do iscla=1,basis% IOnsrtcl
!!$          Do isclb=iscla+1,basis% IOnsrtcl
!!$             If(basis% p_IOsrtcl(1,isclb) < basis% p_IOsrtcl(1,iscla))Then
!!$                ind(1:structure% IOnsort)&
!!$                     &=basis% p_IOsrtcl(1:structure% IOnsort,isclb)
!!$                basis% p_IOsrtcl(1:structure% IOnsort,isclb)&
!!$                     &=basis% p_IOsrtcl(1:structure% IOnsort,iscla)
!!$                basis% p_IOsrtcl(1:structure% IOnsort,iscla)&
!!$                     &=ind(1:structure% IOnsort)
!!$                j=basis% p_IOninsrtcl(isclb)
!!$                basis% p_IOninsrtcl(isclb)=basis% p_IOninsrtcl(iscla)
!!$                basis% p_IOninsrtcl(iscla)=j
!!$             Endif
!!$          Enddo
!!$       Enddo
!!$       If(Allocated(ind))Deallocate(ind)
!!$       !!END:sorting of sort-class arrays
!!$       !!
!!$       Call cleanreadfile
!!$       !!--------- NO ACCESS TO INFILE PARSER AFTER THIS LINE PLEASE !! ----
!!$       
!!$       
!!$    Else If(action==IO_ACTION_NEW_FILE)Then !! ifnotnew
!!$
!!$       stopit=.True.
!!$       
!!$       Call defbasisconfig(basis,basis_x0_S,structure% IOnsort&
!!$            &,structure% p_IOelements)       
!!$       
!!$       
!!$    Endif ifnotnew
!!$
!!$    If(warn.Or.ver/=VERSION_OK) Goto 0200
!!$    
!!$    If(action==IO_ACTION_RUN)Then
!!$       !! cleanup
!!$       Call pfree(basis_x0_S)
!!$
!!$       Call free_basis_IO_arrays(defaultbasis)
!!$       Call pfree(defaultbasis_x0_S)
!!$       
!!$       Call free_basis_IO_arrays(newbasis)
!!$       Call pfree(newbasis_x0_S)
!!$       If(Allocated(newbasis_elements_S)) Deallocate(newbasis_elements_S)
!!$
!!$       Return
!!$    Endif
!!$    !!
!!$    
!!$200 Continue
!!$
!!$    If(ver/=VERSION_OK)Then
!!$       Write(outfile,"('Version update of ',a,':')")Trim(f_fplo_basis)
!!$    Endif
!!$
!!$    Call create_basisfile(structure% IOnsort,structure% p_IOelements &
!!$         &,basis,basis_x0_S)
!!$    
!!$    !! cleanup 
!!$    Call free_basis_IO_arrays(defaultbasis)
!!$    Call pfree(defaultbasis_x0_S)
!!$    
!!$    Call free_basis_IO_arrays(newbasis)
!!$    Call pfree(newbasis_x0_S)
!!$    If(Allocated(newbasis_elements_S)) Deallocate(newbasis_elements_S)
!!$
!!$    !!
!!$    Call free_basis_IO_arrays(basis)
!!$    Call pfree(basis_x0_S)
!!$    !!
!!$    If(warn.Or.ver/=VERSION_OK)Then
!!$       Write(outfile,"('File ',a,' updated!')")Trim(f_fplo_basis)
!!$       If(action == IO_ACTION_RUN)Then
!!$          Write(errbuf,"('File ',a,' updated!')")Trim(f_fplo_basis)
!!$          stopit=.True.
!!$       Endif
!!$    Endif
!!$    !!
!!$987 Format(i1,a1)
!!$    !!
!!$  End Subroutine basis_io
  !!***********************************************************************
  !! Read devellopment info from devel menu.
  !! The content of the devel menu may change constantly and is not
  !! ment to be used by regular people. Everything, which leaves devel status
  !! should be put into regular menues.
  !! The devel menu in fedit is available via a devel option in =.debug.
  !!
!!$  Subroutine devel_io(action,structure,mol,stopit)
!!$    !!
!!$    Implicit None 
!!$    !!IO
!!$    Integer(t_int),Intent(in)    :: action
!!$    Logical(t_log),Intent(inout) :: stopit
!!$    Type(T_Mol),Intent(inout)    :: mol
!!$    Type(T_Structure),Intent(in) :: structure
!!$    !!LOCAL
!!$    Character(*),Parameter::nsubfunc="devel_io"
!!$    Integer(t_int) ::  issaIO,devel_nsort,ver
!!$    Character(500)   :: r_angmesh_1_S,r_angmesh_max_S
!!$    Character(200)      ::  mainversion,subversion
!!$    !!
!!$    !!
!!$    !!
!!$    ver=VERSION_OK
!!$    If(action /= IO_ACTION_NEW_FILE )Then
!!$       !!
!!$       !! read header information
!!$       Call initparser
!!$       Call readfile(f_fplo_devel)
!!$       !!
!!$       Call getstring("version.mainversion",mainversion)
!!$       Call getstring("version.subversion",subversion)
!!$       !!
!!$       ver=checkversion(mainversion,subversion,f_fplo_devel)
!!$       !!
!!$       !!
!!$       If( variable_exists('make_vatom'))Then
!!$          Call getlogical("make_vatom",mol% make_vatom)
!!$       Else
!!$          mol% make_vatom=.True.
!!$       Endif
!!$       !!
!!$       If( variable_exists('irredmesh'))Then
!!$          Call getlogical("irredmesh",mol% irredmesh)
!!$       Else
!!$          mol% irredmesh=.True.
!!$       Endif
!!$       !!
!!$       If( variable_exists('erg_nv0_separate'))Then
!!$          Call getlogical("erg_nv0_separate",mol% erg_nv0_separate)
!!$       Else
!!$          mol% erg_nv0_separate=.True.
!!$       Endif
!!$       !!
!!$       If( variable_exists('erg_kin0_separate'))Then
!!$          Call getlogical("erg_kin0_separate",mol% erg_kin0_separate)
!!$       Else
!!$          mol% erg_kin0_separate=.True.
!!$       Endif
!!$       !!
!!$       !!
!!$       If( variable_exists('compressed_vatom'))Then
!!$          Call getlogical("compressed_vatom",mol% compressed_vatom)
!!$       Else
!!$          mol% compressed_vatom=.True.
!!$       Endif
!!$       !!
!!$       If( variable_exists('rad_nr'))Then
!!$          Call getinteger("rad_nr",mol% rad_nr)
!!$       Else
!!$          mol% rad_nr=80_t_int
!!$       Endif
!!$       !!
!!$       If( variable_exists('radial_meshtype.type'))Then
!!$          Call getinteger("radial_meshtype.type",mol% rad_mesh_type)
!!$       Else
!!$          mol% rad_mesh_type=ROOT_MESH
!!$       Endif
!!$       !!
!!$       If( variable_exists('angmesh.r1'))Then
!!$          Call getreal("angmesh.r1",mol% r_angmesh_1 )
!!$          Call getrealasstring('angmesh.r1',r_angmesh_1_S)
!!$       Else
!!$          mol% r_angmesh_1=0.05_t_real
!!$          r_angmesh_1_S="0.05"
!!$       Endif
!!$       !!
!!$       If( variable_exists('angmesh.t1'))Then
!!$          Call getinteger("angmesh.t1",mol% t_angmesh_1 )
!!$       Else
!!$          mol% t_angmesh_1=1
!!$       Endif
!!$       !!
!!$       If( variable_exists('angmesh.rmax'))Then
!!$          Call getreal("angmesh.rmax",mol% r_angmesh_max )
!!$          Call getrealasstring('angmesh.rmax',r_angmesh_max_S)
!!$       Else
!!$          mol% r_angmesh_max=3.0_t_real
!!$          r_angmesh_max_S="3.0"
!!$       Endif
!!$       !!
!!$       If( variable_exists('angmesh.tmax'))Then
!!$          Call getinteger("angmesh.tmax",mol% t_angmesh_max )
!!$       Else
!!$          mol% t_angmesh_max=15_t_int
!!$       Endif
!!$       !!
!!$       If( variable_exists('nsort'))Then
!!$          Call getinteger('nsort',devel_nsort) 
!!$       Else
!!$          devel_nsort=0
!!$       Endif
!!$          
!!$
!!$       
!!$
!!$       !! cleanup parser
!!$       Call cleanreadfile
!!$       !!--------- NO ACCESS TO INFILE PARSER AFTER THIS LINE PLEASE !! ----
!!$       !!
!!$       !!
!!$    Else If(action==IO_ACTION_NEW_FILE)Then
!!$       !! set stuff
!!$       !Print *,'IO_ACTION_NEW_FILE'
!!$       mol% make_vatom=.True.
!!$       mol% irredmesh=.True.
!!$       
!!$       mol% erg_nv0_separate=.True.
!!$       mol% erg_kin0_separate=.True.
!!$       
!!$       mol% compressed_vatom=.True.
!!$       
!!$       mol% rad_nr=80_t_int
!!$       mol% rad_mesh_type=ROOT_MESH
!!$       
!!$       mol% r_angmesh_1=0.05_t_real
!!$       r_angmesh_1_S="0.05"
!!$       mol% t_angmesh_1=1_t_int
!!$       mol% r_angmesh_max=3.0_t_real
!!$       r_angmesh_max_S="3.0"
!!$       mol% t_angmesh_max=15_t_int
!!$
!!$       !!
!!$       !!
!!$       !!
!!$       stopit=.True.
!!$       !!
!!$    Endif
!!$    !!
!!$    If(action/=IO_ACTION_RUN .Or. ver /= VERSION_OK)Then
!!$       
!!$       Write(outfile,"('Version update of ',a,':')")Trim(f_fplo_devel)
!!$       
!!$       Call create_develfile(mol,r_angmesh_1_S,r_angmesh_max_S,structure)
!!$       !!
!!$       stopit=.True.
!!$    Endif
!!$    !!
!!$    !!
!!$    !!
!!$    Return
!!$    !!
!!$  End Subroutine devel_io
  !!***********************************************************************
  Subroutine write_in_sym_file(symmetry,structure)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    !!LOCAL
    Character(*),Parameter::nsubfunc="write_in_sym_file"
    Integer(t_int) :: issaIO,isa,isb,k,IOnsort,ii
    Character(200) :: nw,var,fname
    Real(t_real)   :: t(3)
    !!
    Do ii=1,2
       !!
       if(ii==1) fname=trim(f_fplo_sym)
       If(ii==2) fname=Trim(f_fplo_in)
       !!
       Call initparser
       !! read status from header information
       Call readfile(fname)
       Call getinteger("nsort",IOnsort) 
       If(IOnsort/=structure% IOnsort)&
            &Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'Oops, what happend to the "//fname//" file?!'")
       
       !!
       !!
       !!
       !!Call setParserVarValue("status","symmetry changed")
       !!
       Do issaIO=1,structure% IOnsort
          !!
          isa=0
          Do isb=1,structure% nsite
             If(structure% p_IOisrt(isb) == issaIO )Then
                isa=isb
                Exit
             Endif
          Enddo
          !!
          If(isa<1)&
               &Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Oops, cannot find input sort?!'")
          !!
          t=structure% p_tau(:,isa)
          !!
          If(structure% str_type == STR_TYPE_MOLECULE) Then
             If(structure % lengthunit==SYM_LENGTH_ANGSTROEM) Then
                t=t*brtoan
             Endif
          Else
             t=Matmul(t&
                  &,symmetry% convreciprocial_lattice_vectors(:,:))/twopi
          Endif
          !!
          !!
          Do k=1,3
             Call double_to_string_as_ratio(t(k)&
                  &,nw,12_t_int,1.0e-12_t_real,"(f30.10)")
             var="wyckoff_positions["//Trim(intToChar10(issaIO))//&
                  &"].tau["//Trim(intToChar10(k))//"]"
             Call setParserVarValue(var,nw)
          Enddo
       Enddo
       !!
       !!
       Call writeParsFile(fname)
       !!
       Call cleanreadfile
    !!
    Enddo
    !!
    Return
    !!
  End Subroutine write_in_sym_file
  !!***********************************************************************
  Subroutine read_old_coeff_file(bandplot,protect)
    !!
    Implicit None
    !!IO
    Type(T_Bandplot),Intent(inout) :: bandplot
    Logical(t_log),Intent(in)    :: protect
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_old_coeff_file"
    Logical(t_log) :: exists
    !!
    Inquire(file='=.coeff',exist=exists)
    If(.Not.exists) Return
    !!
    If(protect)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'''=.coeff'' found, this is old style ... ',/&
            &,' use ''output +coeff file'' in the fedit bandplot submenu instead!.',/&
            &,' Remove ''=.coeff'' to re-run.'")
    Endif
    !!
    Write(outfile,1865)
1865 Format('file ''=.coeff'' found.')
    bandplot% coeffout=.True.
    !!
    !!
    !!
    !!
    Return
    !!
  End Subroutine read_old_coeff_file
  !!***********************************************************************
  Subroutine read_old_xreduce_file(potential,protect)
    !!
    Implicit None
    !!IO
    Type(T_Potential),Intent(inout) :: potential
    Logical(t_log),Intent(in)    :: protect
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_old_xreduce_file"
    Logical(t_log) :: exists
    !!
    Inquire(file='=.xreduce',exist=exists)
    If(.Not.exists) Return
    !!
    If(protect)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'''=.xreduce'' found, this is old style ... ',/&
            &,' use ''xc-field strength'' in the fedit menu instead!.',/&
            &,' Remove ''=.xreduce'' to re-run.'")
    Endif
    !!
    Write(outfile,1865)
1865 Format('file ''=.xreduce'' found will read exchange-reduction factor')
    Open(12,file='=.xreduce')
    Read(12,*)potential% xreduce
    Close(12)
    !!
!!$    Call initparser
!!$    Call readfile(f_fplo_in)
!!$    Call setParserVarValue('ex_field_strength'&
!!$         &,stringify_double100(potential% xreduce))
!!$    Call writeParsFile(f_fplo_in)
!!$    Call cleanreadfile
    !!
    !!
    !!
    Return
    !!
  End Subroutine read_old_xreduce_file
  !!***********************************************************************
  Subroutine read_old_mol_charge_file(potential,protect)
    !!
    Implicit None
    !!IO
    Type(T_Potential),Intent(inout) :: potential
    Logical(t_log),Intent(in)    :: protect
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_old_mol_charge_file"
    Logical(t_log) :: exists
    !!
    Inquire(file='=.mol_charge',exist=exists)
    If(.Not.exists) Return
    !!
    If(protect)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'''=.mol_charge'' found, this is old style ... ',/&
            &,' use the ''charges'' submenu in fedit instead!.',/&
            &,' Remove ''=.mol_charge'' to re-run.'")
    Endif
    !!
    Open(12,file='=.mol_charge')
    Read(12,*)potential% molecule_ionicity
    Close(12)
    !!
    potential% chargemode=CHARGEMODE_MOL_ION
    !!
  End Subroutine read_old_mol_charge_file
  !!***********************************************************************
  Subroutine read_old_charging_file(potential,protect)
    !!
    Implicit None
    !!IO
    Type(T_Potential),Intent(inout) :: potential
    Logical(t_log),Intent(in)    :: protect
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_old_charging_file"
    Logical(t_log) :: exists
    Character(100)   :: mode
    Real(t_real)   :: Z
    !!
    Inquire(file='=.charging',exist=exists)
    If(.Not.exists) Return
    !!
    If(protect)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'''=.charging'' found, this is old style ... ',/&
            &,' use the ''charges'' submenu in fedit instead!.',/&
            &,' Remove ''=.charging'' to re-run.'")
    Endif
    !!
    Open(12,file='=.charging')
    Read(12,*)
    Read(12,*)mode
    Read(12,*)
    Read(12,*)Z
    potential% molecule_ionicity=-Z
    Close(12)
    If(mode=='jellium')Then
       potential% chargemode=CHARGEMODE_JELLIUM
    Endif
    !!
    !!
  End Subroutine read_old_charging_file
  !!***********************************************************************
  Subroutine read_old_atcharge(potential,protect)
    !!
    Implicit None
    !!IO
    Type(T_Potential),Intent(inout) :: potential
    Logical(t_log),Intent(in)    :: protect
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_old_charging_file"
    Integer(t_int) :: i
    Logical(t_log) :: exists
    !!
    Inquire(file='=.atcharge',exist=exists)
    If(.Not.exists) Return
    !!
    If(protect)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'''=.atcharge'' found, this is old style ... ',/&
            &,' use the ''charges'' submenu in fedit instead!.',/&
            &,' Remove ''=.atcharge'' to re-run.'")
    Endif
    !!
    potential% nvca=0_t_int
    potential% make_vca=.False.
    !!
    Open(12,file='=.atcharge')
    Read(12,*)potential% nvca
    If(potential% nvca>0) Then
       potential% make_vca=.True.
       Call palloc('potential% p_vcasorts',potential% p_vcasorts&
            &,1_t_int,potential% nvca,nmodule,nsubfunc)
       Call palloc('potential% p_vcaZ',potential% p_vcaZ&
            &,1_t_int,potential% nvca,nmodule,nsubfunc)
    Endif
    Do i=1,potential% nvca
       Read(12,*)potential% p_vcasorts(i),potential% p_vcaZ(i)
    End Do
    Close(12)
    !!
    !!
  End Subroutine read_old_atcharge
  !!***********************************************************************
End Module io
