!TODO:: 
!mach iterat fertig
!vergleicvhe V... mit gewuenschtem code
!!***********************************************************************
Module iteration
  !!
  Use precisiondefs
  Use errors
  Use titeration
  Use iterationmethods
  Use itmethods
  Use memory
  Use file_iounits
  !!
  Implicit None 
  !!
  Private
  !!
  Public :: iterate
  !!***********************************************************************
  Character(*),Parameter::nmodule="ITERATION"
  !!***********************************************************************
  
  
Contains
  !!***********************************************************************
  !! organize the iteration of a highdimensional problem
  Recursive Subroutine Iterate(handler,mesg,notermination,prot)
    !!
    !!
    Implicit None 
    !!
    !!----------------------------------------------------
    !!IO
    Character(*),Intent(in) :: mesg
    Logical(t_log),Intent(in) :: notermination,prot
    !! external handler
    Procedure(IterationHandler)::handler
    !!
    !! External  handler
    !!----------------------------------------------------
    !!LOCAL
    Character(*),Parameter::nsubfunc="iterate"
    Type(T_iteration) :: Data
    !!
    !!***********************************************************************
    !!
1   Format(a,':',72('='),/,a,':',15('-'),' START ',a,'(',a,')',a)
    If(outlevel>L_many .And. prot)&
         &Write(outfile,1)Trim(mesg),Trim(mesg),nsubfunc&
         &,Trim(mesg),Repeat('-',72_t_int-15_t_int-9_t_int-Len(nsubfunc)&
         &-Len_trim(mesg))
    !!----------------------------------------------------    
    !! set default values 
    Call init_iterationcontrol(Data)
    data% prot=prot
    !data% handler => handler
    data% notermination =notermination
    Data% stepsexceeded=.False.
    !!
    data% name=Trim(mesg)//':'
    data%scheme=IT_SCHEME_ITERAT
    data%vecdim=0_t_int !! invalid size
    data%steps =15_t_int
    data%step  =0_t_int
    data%reset =.false.
    data%deviation =1.e30_t_real


    
    !!----------------------------------------------------
    !! ask user whats going on
    Call handler(Data,IT_ENTRY_INIT)
    
    
    !!----------------------------------------------------
    !! now we know scheme type
    !! set default values 
    data%tolerance=1.0e-6_t_real
    
    Select Case (Int(data%scheme))
    Case(Int(IT_SCHEME_SIMPLEMIX))
       data%maxdim=0_t_int
       data%mixing=0.2_t_real
       data%progress=0.2_t_real !TODO
       data%tolerance=1.e-6_t_real
    Case(Int(IT_SCHEME_ITERAT))
       data%maxdim=5_t_int
       data%mixing=0.2_t_real
       data%tolerance=1.e-6_t_real
       data%progress=0.2_t_real !TODO
    Case(Int(IT_SCHEME_LCITERAT))
       data%maxdim=5_t_int
       data%mixing=0.8_t_real
       data%tolerance=1.e-6_t_real
       data%alpha1=0.99_t_real
       data%alpha2=1.00_t_real
       !!TODO: more settings 
    Case(Int(IT_SCHEME_NITERAT))
       data%maxdim=5_t_int
       data%mixing=0.8_t_real
       data%tolerance=1.e-6_t_real
       data%alpha1=0.99_t_real
       data%alpha2=1.00_t_real
       !!TODO: more settings 
    Case(Int(IT_SCHEME_MINITERAT))
       data%maxdim=5_t_int
       data%mixing=0.8_t_real
       data%tolerance=1.e-6_t_real
       data%alpha1=0.99_t_real
       data%alpha2=1.00_t_real
    Case(Int(IT_SCHEME_BROYDEN))
       data%tolerance=1.e-6_t_real
       !!TODO: more settings
    Case default
       Write(errbuf,2) data%scheme
2      Format('''Iteration version ',i4,' is not supported!''')
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg=Trim(errbuf))
    End Select
    
3   Format(a,': Iteration version (',i4,') : ',a)
    If(prot)Write(outfile,3)Trim(mesg),data%scheme&
         &,iteration_schemes(data%scheme)
    
    
    !!----------------------------------------------------
    !! Init dimensions and stuff
    Call handler(Data,IT_ENTRY_PREPARE)

    !! overwrite user setting to get simple mix
    Select Case (Int(data%scheme))
    Case(Int(IT_SCHEME_SIMPLEMIX))
       data%maxdim=1_t_int
    End Select
    
    
    !!----------------------------------------------------
4   Format(a,': Tolerance         =',e12.2e2)
    If(prot)Write(outfile,4)Trim(mesg),data%tolerance
5   Format(a,': Vector dimension  =',i12)
    If(prot)Write(outfile,5)Trim(mesg),data%vecdim
6   Format(a,': Max hyperspace dim=',i6)
    If(prot)Write(outfile,6)Trim(mesg),data%maxdim
7   Format(a,': Max mixing        =',e12.2e2)
    If(prot)Write(outfile,7)Trim(mesg),data%mixing
8   Format(a,': Max steps         =',i6     )
    If(prot)Write(outfile,8)Trim(mesg),data%steps
    Select Case (Int(data%scheme))
    Case(Int(IT_SCHEME_LCITERAT))
       If(prot)Write(outfile,9)Trim(mesg),data%alpha1
9      Format(a,': Improv. threshold =',f10.5  )
10     Format(a,': Flat impro thresh.=',f10.5  )
       If(prot)Write(outfile,10)Trim(mesg),data%alpha2
    end Select
    
    !!----------------------------------------------------
    !! prepare iteration vector
    If(data%vecdim<1_t_int)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'vector dimension <1 !'")
    Endif
    If(data%maxdim<0_t_int)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'hyerspace  dimension <0 !'")
    Endif

    Call palloc('data% vector',data% vector,1_t_int,Data%vecdim,nmodule,nsubfunc)


    !!----------------------------------------------------
    !! check in start data into vector
    Call handler(Data,IT_ENTRY_STARTDATA)

    !!----------------------------------------------------
    !! now we have data
    !! call iteration with scc(data,IT_ENTRY_LOOP,vector)

    If(data%scheme == IT_SCHEME_SIMPLEMIX)Then
       Call iterat(Data,handler)
    Else If(data%scheme == IT_SCHEME_ITERAT)Then
       Call iterat(Data,handler)
    Else If(data%scheme == IT_SCHEME_LCITERAT)Then
       Call lciterat(Data,handler,outfile,50_t_int)
    Else If(data%scheme == IT_SCHEME_NITERAT)Then
       !Call niterat(Data)
    Else If(data%scheme == IT_SCHEME_MINITERAT)Then
       Call iterat_minimize(Data,handler,outfile)
    End If
    

    !!----------------------------------------------------
    If(Data% stepsexceeded)Then
       If(Data% notermination)Then
6666      Format("'SCF iteration steps exceeded. ',/&
               &,' Will nevertheless continue with outer (force) loop!',/&
               &,' This might lead to instabilities of the outer iteration.'") 
          Write(errbuf,6666)
          Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
       Else
          Call terminate(TERM_NORMAL,Trim(nsubfunc)//': iteration steps exceeded')
       Endif
    Endif

    !!----------------------------------------------------
    !!call cleanup handler
    Call handler(Data,IT_ENTRY_EXIT)
    
    !!----------------------------------------------------
    !! cleanup memory
    Call clean_iterationcontrol(data)
    !!
    !!----------------------------------------------------
    !! Ciao
20  Format(a,': ',15('-'),' END   ',a,'(',a,')',a,/,a,': ',72('='))
    If(outlevel>L_many.And.prot)&
         & Write(outfile,20)Trim(mesg),nsubfunc&
         &,Trim(mesg),Repeat('-',72_t_int-15_t_int-9_t_int-Len(nsubfunc)&
         &-Len_trim(mesg))&
         &,Trim(mesg)
  End Subroutine Iterate
  !!***********************************************************************
  
End Module iteration
