!--------------------------------!
! ITERATIONMETHODS:vectorout:    !
!--------------------------------!
!TODO:  moderize, rename vars, reset pruefen, mit dirac vergleichen
Module iterationmethods
  !!
  Use precisiondefs
  Use file_iounits
  Use memory
  Use titeration
  Use matrixinvers
  Use errors
  Use matserv
  !!
  Implicit None 
  !!
  Private 
  !!
  Public :: iterat,lciterat
  !!***********************************************************************
  Character(*),Parameter::nmodule="ITERATIONMETHODS"  
  !!***********************************************************************
  !!
  Integer(t_int) :: niter=0_t_int
Contains
  !!***********************************************************************
  !!***********************************************************************
  !!     iterative solution of the n-dimensional non-linear equation system
  !!
  !!        x = vector(x,n,func)
  !!
  !!     by searching in m-dimensional subspaces (m<=data%maxdim: 
  !!                                                 data%maxdim >= 1)
  !!
  !!     convergence for u**2 = (x - vector(x,n))**2 <= eps.
  !!     permitted relative range of linear extrapolation: 1/prog.
  !!     iteration steps dx = p*u from the interpolated minimum of u**2
  !!     in the actual subspace are used (p self-controlled).
  !!     the maximum number of iterations is data%steps.
  !!***********************************************************************
  Recursive Subroutine iterat(Data,handler)
    !!
    Implicit None
    !!IO
    Type(T_iteration),Intent(inout)  :: Data
    Procedure(IterationHandler) :: handler
    !!LOCAL
    Character(*),Parameter::nsubfunc="iterat"
    Integer(t_int) :: m,i,j,ju,n,mdim
    Real(t_real) :: p,pq,ppq,tp,uu,ux,s,q,mix,p0
    Logical(t_log) :: indef,prot
    Real(t_real),Pointer :: xx(:,:)
    Real(t_real),Pointer :: yy(:,:)
    Real(t_real),Pointer :: yty(:,:)
    Real(t_real),Pointer :: aa(:,:)
    Real(t_real),Pointer :: bb(:)
    Real(t_real),Pointer :: mu(:)

    !!********************************************************************
    !!
    Nullify(xx,yy,yty,aa,bb,mu)
    prot=data% prot
    !!
    !! local to make sure, that this is not overwritten by handler
    n=data%vecdim
    mdim=data%maxdim
    data%step=0_t_int
    p0=0.01_t_real
    !!
    Call palloc('xx',xx,1_t_int,n,0_t_int,mdim,nmodule,nsubfunc)
    Call palloc('yy',yy,1_t_int,n,0_t_int,mdim,nmodule,nsubfunc)
    Call palloc('yty',yty,0_t_int,mdim,0_t_int,mdim,nmodule,nsubfunc)

    niter=0_t_int

100 pq=1.0_t_real
    p=data%mixing
    ppq=p
    m=0_t_int
    tp=0.0_t_real
    data%deviation=0.0_t_real
    !!
    !!     storage x ==> x  and calculation of u  and of u *u , i=1,...,m
    !!                    m                     m         i  m
    !!
    iterloop: Do 
       !Write(outfile,*)'IT: -------------------------------',data%step
       !Write(outfile,*)'IT: m ',m
       !Write(outfile,*)'IT: n ',n
       
       xx(1:n,m)=data% vector(1:n)
       
       
       If(data% reset)Then
          If(prot)Write(outfile,1101)Trim(data%name),Trim(data%name)&
               &,data%step,0
       Else
          If(data%step+1>data%steps)Then
             If(prot)Write(outfile,301)Trim(data%name),Trim(data%name)&
                  &, data%step,m,Sqrt(tp)
          Else
             If(prot)Write(outfile,101)Trim(data%name),Trim(data%name)&
                  &, data%step,m,Sqrt(tp),Trim(data%name)&
                  &,Sqrt(data%deviation),ppq,Trim(data%name)
          Endif
       Endif
       
       data%step=data%step+1_t_int
       If(data%step>data%steps) Goto 6
       !!
       Call handler(Data,it_entry_loop)
       If(data%reset) Then
          Goto 100
       Endif
       !!     
       yy(1:n,m)=data% vector(1:n)-xx(1:n,m)

       Call vectorout(n,data% vector,yy(:,m))
       
       !    Write(outfile,*)'IT: yty '
       Do j=0,m
          tp=Dot_product(yy(1:n,m),yy(1:n,j))
          yty(m,j)=tp
          !       Write(outfile,*)'IT: yty ',j,tp!,yty(m,j)
       End Do
       !    Write(outfile,"('IT: ')")    
       
       
       
       !    Do i=0_t_int,m
       !       Do j=0_t_int,i
       !          Write(outfile,*)'IT: yty(',i,',',j,')= ',yty(i,j) 
       !       Enddo
       !    Enddo
       
       
       !
       
       !If(Sqrt(tp)>data%tolerance) Goto 14
       
       If(stopit((Sqrt(tp)<=data%tolerance),data% letsstop&
            &,data% convcond))Then
          
          !!
          !!
          !!     
          !!     convergence: restoration of x and return
          !!
          
          data% vector(1:n)=xx(1:n,m)
          
          
          
          If(prot)Write(outfile,201)Trim(data%name),Trim(data%name)&
               &, data%step,m,Sqrt(tp)
          Data% stepsexceeded=.False.
          Goto 1000
       !!
       Endif
       !!
       If(m==0_t_int) Then
          !!
          !!     case m=0
          !!
          !!      write(outfile,*)'m=0'
          !2   Continue
          !Write(outfile,*)'IT: case m=0'

          mix=p
          If(data%step==1) Then
             mix=p0
          Endif
          data% vector(1:n)=xx(1:n,0)+mix*yy(1:n,0)
          
          
          
          
          data%deviation=yty(0,0)
          
          !Write(outfile,*)'IT: (m=0)u: ',data%deviation
          
          If(mdim<=1_t_int) Cycle iterloop
          m=1_t_int
          Cycle iterloop
       Endif
       !!     
       !!     exclusion of useless points
       !!    
       !    write(outfile,*)'IT: loop3   '
       If(m==1_t_int) Goto 32
       !Write(outfile,*)'IT: m>1   ',m
       !Write(outfile,*)'IT: exclusion'
       ju=0_t_int
       !Write(outfile,*)'IT: m       ',m 
       !Write(outfile,*)'IT: mmax    ',mdim
       
       !!      write(outfile,*)'m,mmax',m,mmax
       If(m==mdim) ju=1_t_int
       !!      write(outfile,*)'u,tp,u/tp,prog,tu(nu2+1)/tp',u,tp,u/tp,prog,yy(1,0)/tp
       !    Write(outfile,*)'IT: u**2    ',data%deviation
       !    Write(outfile,*)'IT: yy(m,m) ',tp
       !    Write(outfile,*)'IT: prog    ',data%progress
       !    Write(outfile,*)'IT: yy(0,0) ',yy(1,0)
       
       
       If(data%deviation/tp<data%progress.Or.yty(0,0)/tp<1.0_t_real) ju=m/2_t_int
       pq=Min(1.0_t_real,Sqrt(data%deviation/tp))
       !!      write(outfile,*)'u/tp,pq',u/tp,pq
       !    Write(outfile,*)'IT: pq=min(1_t_int,sqrt(u**2/Y(m,m))) ',pq
       !Write(outfile,*)'IT: remove ',ju
       
       If(ju==0_t_int) Goto 32
38     Continue
       !Write(outfile,*)'IT: remove vectors ',ju
       
       
       
       Do j=0,m-ju
          xx(1:n,j)=xx(1:n,j+ju)
          yy(1:n,j)=yy(1:n,j+ju)
          Do i=0,m-ju
             yty(i,j)=yty(i+ju,j+ju)
          Enddo
       End Do
       
       
       !    Do j=0,mdim
       !       Write(outfile,"('IT: OLD yty ')",advance='no')
       !       Do i=0,m
       !          Write(outfile,"(f30.15)",advance='no') yty(i,j)
       !       Enddo
       !       Write(outfile,*)
       !    Enddo
       !    Write(outfile,"('IT: ')")
       
       !    Print *,'IT: OLD m=',m
       
       
       
       
       
       
       
       !!      write(outfile,*)'m',m
       !!      write(outfile,*)'ju',ju
       m=m-ju
       
       !    Print *,'IT: NEW m=',m
       !    Do j=0,mdim
       !       Write(outfile,"('IT: NEW yty ')",advance='no')
       !       Do i=0,m
       !          Write(outfile,"(f30.15)",advance='no') yty(i,j)
       !       Enddo
       !       Write(outfile,*)
       !    Enddo
       !    Write(outfile,"('IT: ')")    
       
       
       !    Write(outfile,*)'IT: m=m-remove ',m 
       
       !!      write(outfile,*)'m',m
       If(m==0_t_int)Then
          m=1_t_int
          Cycle iterloop
       Endif
       !!
       !!     rearranging of x , u , u *u  with descending order of u **2;
       !!                     i   i   i  j                           i
       !!
32     Continue 
       !Write(outfile,*)'IT: rearrange  '
       !Write(outfile,*)'IT: m    ',m
       
       
       
       rearrange: Do j=m-1,0,-1
          
          uu=yty(j,j)
          ux=yty(j+1,j+1)
          
          
          
          If(ux<=uu) Exit rearrange
          
          Do i=1_t_int,n
             s=xx(i,j)
             xx(i,j)=xx(i,j+1)
             xx(i,j+1)=s
             s=yy(i,j)
             yy(i,j)=yy(i,j+1)
             yy(i,j+1)=s
          End Do
          
          
          
          yty(j,j)=ux
          yty(j+1,j+1)=uu
          If(j/=0) Then
             
             Do i=0,j-1
                
                s=yty(j,i)
                yty(j,i)=yty(j+1,i)
                yty(j+1,i)=s
             End Do
          End If
          
          
          
          If(j==m-1) Cycle rearrange
          
          
          Do i=j+2,m
             s=yty(i,j)
             yty(i,j)=yty(i,j+1)
             yty(i,j+1)=s
          End Do
          
       End Do rearrange
       
       
       
       
       !!
       !!     .                                             m-1
       !!     .finding the minimum of u**2 for u(mu) = u  + sum mu *(u -u ).
       !!     .                                         m   i=0   i   i  m
       !!     
       
       !Write(outfile,*)'IT: find minimum '
       

       
       Call palloc('aa',aa,1_t_int,m,1_t_int,m,nmodule,nsubfunc)
       Call palloc('bb',bb,1_t_int,m,nmodule,nsubfunc)
       Call palloc('mu',mu,1_t_int,m,nmodule,nsubfunc)

       
       !! u=YmYm
       data%deviation=yty(m,m)
       
       
       
       Do i=0,m-1
          !! B(i+1)=-[ (Yi-Ym)*Ym ]/|Ym|^2
          bb(i+1)=1.0_t_real-yty(m,i)/data%deviation
          !! A(i+1,j+1)=[Yj-Ym]^T*[Yi-Ym]/|Ym|^2
          Do j=i,m-1
             aa(i+1,j+1)=(data%deviation+yty(j,i)-yty(m,i)-yty(m,j))&
                  &/data%deviation
          Enddo
       End Do
       
       
       !    Do i=1,m
       !       Write(outfile,*)'IT: b(',i,')=',bb(i)
       !    Enddo
       !    Do i=1_t_int,m
       !       Do j=1_t_int,m
       !          Write(outfile,*)'IT: a(',i,',',j,')=',aa(i,j)
       !       Enddo
       !    Enddo
       
       
       indef=.False.
       If(m>1_t_int) Then
          !!
          Call dglei(aa,bb,mu,m,m,indef)
          !    Do i=1,m
          !       Write(outfile,*)'IT: c(',i,')=',mu(i)
          !    Enddo
          !!          
       Else
          uu=aa(1,1)
          !Write(outfile,*)'IT: m==',m,', trivial solution case'
          If(uu==0.0_t_real) Then
             !Write(outfile,*)'IT: no trivial solution found'
             indef=.True.
          Else
             mu(1)=bb(1)/uu
          Endif
          !Write(outfile,*)'IT:  trivial solution c(1)=',mu(1)
          
       Endif

       !!cc   if(aa(m,m)>prog) goto 44
       !!     
       !!     creation of a stochastic step, if no minimum of u**2 is found
       !!     
       !Write(outfile,*)'stoch'
       If(indef) Then
          If(prot)Write(outfile,"(a,' RANDOM STEP ',f30.15)")&
               &Trim(data%name),ppq
          Do i=1_t_int,n
             data%deviation=yy(i,m)
             data% vector(i)=xx(i,m)+ppq*data%deviation*Sin(2.0_t_real*i*data%step)
          End Do
          
          
          data%deviation=1.e29_t_real
          m=m+1_t_int
          Cycle iterloop
       Endif
       !!
       !!                      m-1
       !!     setting x = x  + sum mu *(x -x ) + ppq*u   ,
       !!                  m   i=0   i   i  m         min
       !!
       !!                   m-1
       !!     where p = abs(sum mu *(x -x ) )/abs(u ).
       !!                   i=0   i   i  m         m
       !!
       !!     and ppq is the mean of this p and the previous one,
       !!     eventually reduced by a factor pp.
       !!

       !Write(outfile,*)'IT: calculate new vectors and p'
       q=p
       p=0.0_t_real
       
       Do i=1_t_int,n
          s=Dot_product((xx(i,0:m-1)-xx(i,m)),mu(1:m))
          p=p+s**2_t_int
       End Do
       
       
       p=(Sqrt(p/data%deviation)+q)/2.0_t_real
       p=Min(data%mixing/pq,p)
       ppq=p*pq
       !Write(outfile,*)'IT: p,ppq',p,ppq

       s=1.0_t_real-Sum(mu(1:m))

       
       data%deviation=0.0_t_real
       Do i=1_t_int,n
          
          ux=s*xx(i,m)+Dot_product(xx(i,0:m-1),mu(1:m))
          uu=s*yy(i,m)+Dot_product(yy(i,0:m-1),mu(1:m))
          
          data%deviation=data%deviation+uu**2_t_int
          data% vector(i)=ux+ppq*uu
       End Do
       
       
       !Write(outfile,*)'IT: interpolated u**2',data%deviation
       ju=m
       If(data%deviation/tp<data%progress) Then
          !       Write(outfile,*)'IT: u**2    ',data%deviation
          !       Write(outfile,*)'IT: yy(m,m) ',tp
          !       Write(outfile,*)'IT: prog    ',data%progress
          !       Write(outfile,*)'IT: u**2<yy(m,m)*prog, remove ',ju
          Goto 38
       Endif
       
       m=m+1_t_int
    Enddo iterloop
    !!
6   If(prot)Write(outfile,102)Trim(data%name),Trim(data%name)

    Data% stepsexceeded=.True.
    !!
    !! cleanup
    !!
1000 Continue
    Call pfree(mu)
    Call pfree(bb)
    Call pfree(aa)
    Call pfree(yty)
    Call pfree(yy)
    Call pfree(xx)
    Return
    !!
    !!***********************************************************************
101 Format(a,' ',/,a,' iteration',i3,'  dimension',i3&
         &,'  last deviation u=',&
         & e10.2/,a,'               interpolated  new deviation  u=',&
         & e10.2,'  step p=',f6.3,/,a,' ')
201 Format(a,' ',/,a,' iteration',i3,'  dimension',i3&
         &,'  last deviation u=',e10.2,' CONVERGED')
301 Format(a,' ',/,a,' iteration',i3,'  dimension',i3&
         &,'  last deviation u=',e10.2,' NOT CONVERGED')
1101 Format(a,' ',/,a,' iteration',i3,'  dimension',i3,'  last deviation=RESTART')
102 Format(a,' ',/,a,' no convergence of iterat because of too many',&
         & ' iterations')
    !!***********************************************************************
  End Subroutine iterat
  !!***********************************************************************
  Subroutine vectorout(n,x,y)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: n
    Real(t_real),Intent(in)      :: x(:),y(:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="vectorout"
    Integer(t_int) :: j
    Integer        :: err
    !!
    !!
    If(debugfun(nmodule,nsubfunc,''))Then

       Print *,'niter=',niter

       If(niter==0)Then
          Open(12,file='+vitx',status='old',iostat=err)
          If(err==0) Close(12,status='delete')
          Open(12,file='+vity',status='old',iostat=err)
          If(err==0) Close(12,status='delete')
       Endif

       niter=niter+1
       Open(12,file='+vitx',status='unknown',position='append')
       Write(12,"(i5)",advance='no')niter
       Do j=1,n
          Write(12,"(' ',e30.15e3)",advance='no')x(j)
       Enddo
       Write(12,"()")
       Close(12)
       Open(12,file='+vity',status='unknown',position='append')
       Write(12,"(i5)",advance='no')niter
       Do j=1,n
          Write(12,"(' ',e30.15e3)",advance='no')y(j)
       Enddo
       Write(12,"()")
       Close(12)
    Endif
    !!
    Return
    !!
  End Subroutine vectorout
  !!***********************************************************************
  !!
  !!
  !!     iteration of nonlienar equaitons using subspace interpolation
  !!     inspired by the programs "iterat" by Helmut Eschrig
  !!     and  "itsol" by Arnulf Moebius
  !!     by Klaus Koepernik  (2001)
  !!
  !!     protlevel: protocol level
  !!     .     110: full output + sort details
  !!     .     100: full output
  !!     .     10:  normal progress information
  !!***********************************************************************
  Recursive Subroutine lciterat(Data,handler,lun,protlevel)
    !!
    Implicit None
    !!IO
    Type(T_iteration),Intent(inout)  :: Data
    Procedure(IterationHandler)      :: handler
    Integer(t_int),Intent(in)        :: lun,protlevel
    !!LOCAL
    Character(*),Parameter::nsubfunc="lciterat"
    Real(t_real)  :: u(0:data%maxdim +4_t_int)
    Real(t_real)  :: a(data%maxdim**2_t_int)
    Real(t_real)  :: b(data%maxdim)
    Real(t_real)  :: c(data%maxdim)
    Integer(t_int) :: rem(0:data%maxdim)
    Real(t_real),Pointer  :: xx(:,:)
    Real(t_real),Pointer  :: yy(:,:)
    Logical(t_log)::  impgrad
    Integer(t_int) :: nmixing,hyperindef,direct,badinterpol,single,simple
    Integer(t_int) :: gradient,lingradient,linindef,linear,linmixing
    Integer(t_int) :: widthreduce,nonlinmix
    Logical(t_log) :: indef,prot
    Integer(t_int) :: conv,m,i
    Real(t_real)  :: alpha1,alpha2,alpha3,bmax,bmin,p0,mix
    Real(t_real)  :: cmax,width0,width,d
    Integer(t_int) :: IPOINT,HPOINT,NPOINT,LPOINT
    Integer(t_int) :: mmax,nvec,countlinstep
    !!
    Nullify(xx)
    Nullify(yy)
    prot=data% prot
    !!
    Call palloc("xx",xx,1_t_int,data%vecdim,0_t_int,data%maxdim +4&
         &,nmodule,nsubfunc)
    Call palloc("yy",yy,1_t_int,data%vecdim,0_t_int,data%maxdim +4&
         &,nmodule,nsubfunc)
    !!
    mmax=data%maxdim
    nvec=data%vecdim
    alpha1=data%alpha1
    alpha2=data%alpha2
    data% step=0_t_int
    p0=0.01_t_real

    !! restart entry point
    Goto 112
111 Continue 
    If(prot) Write(lun,114) Trim(data% name),data%step,0
112 Continue
    !! end restart entry point


    IPOINT=mmax+1_t_int
    HPOINT=mmax+2_t_int
    NPOINT=mmax+3_t_int
    LPOINT=mmax+4_t_int

    alpha3=1.00_t_real
    !beta=1000000.0_t_real
    bmax=100000.0_t_real
    bmin=2.0_t_real
    !widthchangemax=4_t_int
    !widthchangefactor=0.5_t_real

    !!      beta=100.d0
    cmax=0.0_t_real
    conv=-1_t_int
    width0=data%mixing 
    width=width0 
    If(width<=0.0_t_real)width=0.1_t_real
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,2)Trim(data%name),width

    nmixing=0_t_int
    hyperindef=0_t_int
    direct=0_t_int
    badinterpol=0_t_int
    single=0_t_int
    simple=0_t_int
    gradient=0_t_int
    lingradient=0_t_int
    linindef=0_t_int
    linear=0_t_int
    linmixing=0_t_int
    widthreduce=0_t_int
    nonlinmix=0_t_int
    impgrad=.False.
    impgrad=.True.
    data%deviation=0.0_t_real
    u(0_t_int)=1.e30_t_real
    !r=rndmst(11_t_int)

    !! x0=x
    xx(1_t_int:nvec,0_t_int)=data% vector(1_t_int:nvec)

101 Continue !! single step entry point 
    m=0_t_int
    If(prot) Write(lun,3)Trim(data%name)
    If(prot) Write(lun,1)Trim(data%name)

    data%step=data%step+1_t_int
    single=single+1_t_int

    !! y0=f(x0)
    data% vector(1_t_int:nvec)=xx(1_t_int:nvec,m)
    Call handler(Data,it_entry_loop)
    If(data%reset) Then
       Goto 111
    Endif
    yy(1_t_int:nvec,m)=data% vector(1_t_int:nvec)-xx(1_t_int:nvec,m)
    u(m)=Dot_product(yy(1_t_int:nvec,m),yy(1_t_int:nvec,m))
    data%deviation=u(m)
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,31)Trim(data%name)
    If(prot) Write(lun,4)Trim(data%name),data%step,m,Sqrt(u(m)),Sqrt(u(0))
    Call printvectors(xx,yy,u,nvec,mmax,m,.False.,lun,protlevel,data%name&
         &,prot)
    If(stopit((u(m) < data%tolerance*data%tolerance),data% letsstop&
         &,data% convcond))Then
       conv=m
       Goto 999
    Endif
    If(data%step >= Data%steps)Then
       conv=m
       Goto 998
    Endif
    If(prot) Write(lun,1)Trim(data%name)

    !! save x0 and y0 for width calculation
    xx(1_t_int:nvec,LPOINT)=xx(1_t_int:nvec,m)
    yy(1_t_int:nvec,LPOINT)=yy(1_t_int:nvec,m)
    !!     
    mix=width
    If(data%step==1)Then
       mix=p0
    Endif
    !!
    !! x1=x0+y0*width
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,32)Trim(data%name),mix
    If(prot) Write(lun,1)Trim(data%name)

    m=1_t_int
    xx(1:nvec,m)=xx(1:nvec,m-1)+mix*yy(1:nvec,m-1)
    !!
    !!
    !!  234 continue 
    !! y1=f(x1)
    data%step=data%step+1_t_int
    simple=simple+1_t_int
    data% vector(1_t_int:nvec)=xx(1_t_int:nvec,m)
    Call handler(Data,it_entry_loop)
    If(data%reset) Then
       Goto 111
    Endif

    yy(1_t_int:nvec,m)=data% vector(1_t_int:nvec)-xx(1_t_int:nvec,m)
    u(m)=Dot_product(yy(1_t_int:nvec,m),yy(1_t_int:nvec,m))
    data%deviation=u(m)
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,33)Trim(data%name),width
    If(prot) Write(lun,4)Trim(data%name), data%step,m,Sqrt(data%deviation),Sqrt(u(0))

    Call printvectors(xx,yy,u,nvec,mmax,m,.True.,lun,protlevel,data%name&
         &,prot)



    If(stopit((u(m) < data%tolerance*data%tolerance),data% letsstop&
         &,data% convcond))Then
       conv=m
       Goto 999
    Endif
    If(data%step >= Data%steps)Then
       conv=m
       Goto 998
    Endif


    !!     
    Call itmagsort(xx,yy,u,nvec,mmax,m,lun,protlevel,data%name,prot)
    If(prot) Write(lun,1)Trim(data%name)
    !!
    !!     
    !! interpolate
1000 Continue 
    !!     
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,34)Trim(data%name)
    Call printvectors(xx,yy,u,nvec,mmax,m,.True.,lun,protlevel,data%name&
         &,prot)

    Call itmagreddim(xx,yy,u,rem,nvec,m,mmax,bmin,bmax,cmax,lun,protlevel&
         &,data%name,prot)
    !!     

    data% vector(:)=xx(:,0)
    Call handler(Data,it_entry_best)
          
    Call hyper(&
         & xx,yy,1_t_int&
         &,a,b,c,IPOINT&
         &,u(IPOINT),m,nvec,mmax,protlevel,indef,lun)
    If(indef)Then
       m=m-1_t_int
       If(prot) Write(lun,8)Trim(data%name)
       hyperindef=hyperindef+1_t_int
       If(prot) Write(lun,1)Trim(data%name)
       If(m == 0_t_int)Then 
          Goto 101
       Endif
       Goto 1000
    Endif
    !! print interpolation point
    If(prot) Write(lun,9)Trim(data%name)
    If(protlevel >= 50_t_int)Then
       If(prot) Write(lun,11)Trim(data%name),u(IPOINT)
    Endif
    If(protlevel >= 100_t_int)Then
       Call printx(xx(1:,IPOINT),nvec,'        xx',lun,data%name)
       Call printx(yy(1:,IPOINT),nvec,'        yy',lun,data%name)
    Endif
    !!
    !! calculate optimal width for use in next step
    !!
    d=Dot_product(xx(1_t_int:nvec,IPOINT)-xx(1_t_int:nvec,LPOINT),yy(1_t_int:nvec,LPOINT))&
         & /Dot_product(yy(1_t_int:nvec,LPOINT),yy(1_t_int:nvec,LPOINT))
    !! width=dsign(dmin1(width0,dmax1(abs(d),1.d-2)),d)
    width=(width+Min(width0,Max(d,1.e-2_t_real)))*0.5_t_real
    !! width=dmin1(width0,dmax1(d,1.d-2))
333 Format(a,' ITMAG: pnew=',f30.15)
    If(prot) Write(lun,333) Trim(data%name),width

    xx(1_t_int:nvec,LPOINT)=xx(1_t_int:nvec,IPOINT)
    yy(1_t_int:nvec,LPOINT)=yy(1_t_int:nvec,IPOINT)
    !! measure for quality of gradient
    cmax=0.0_t_real
    Do i=1_t_int,m
       cmax=cmax+(c(i)-1.0_t_real/Real(m+1_t_int,t_real))**2_t_int
    Enddo
    cmax=Sqrt(cmax)

    If(protlevel >= 100_t_int)Then
       Do i=1_t_int,m
          b(i)=c(i)
          If(prot) Write(lun,12)Trim(data%name),i,c(i)
       Enddo
       If(prot) Write(lun,13)Trim(data%name),cmax
    Endif


    If(u(IPOINT) > u(0_t_int))Then
       If(prot) Write(lun,14)Trim(data%name)
       If(prot) Write(lun,1)Trim(data%name)

       badinterpol=badinterpol+1_t_int
       xx(1_t_int:nvec,0_t_int)=xx(1_t_int:nvec,IPOINT)+yy(1_t_int:nvec,IPOINT)&
            &*width*(rndmcm()-0.5_t_real)
       m=0_t_int
       Goto 101
    Endif

!!$678 Continue  
    !! predicted xh=xg+p*yg
    xx(1_t_int:nvec,HPOINT)=xx(1_t_int:nvec,IPOINT)+width*yy(1_t_int:nvec,IPOINT)
    !! yh=f(xh)

    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,35)Trim(data%name),width
    If(prot) Write(lun,1)Trim(data%name)

    data%step=data%step+1_t_int
    data% vector(1_t_int:nvec)=xx(1_t_int:nvec,HPOINT)
    Call handler(Data,it_entry_loop)
    If(data%reset) Then
       Goto 111
    Endif

    yy(1_t_int:nvec,HPOINT)=data% vector(1_t_int:nvec)-xx(1_t_int:nvec,HPOINT)
    u(HPOINT)=Dot_product(yy(1_t_int:nvec,HPOINT),yy(1_t_int:nvec,HPOINT))
    data%deviation=u(HPOINT)
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,36)Trim(data%name),width
    If(prot) Write(lun,4)Trim(data%name),data%step,m,Sqrt(u(HPOINT)),Sqrt(u(0))

    !! print at predicted point
    If(prot) Write(lun,91)Trim(data%name)
    If(protlevel >= 50_t_int)Then
       If(prot) Write(lun,11)Trim(data%name),u(HPOINT)
    Endif
    If(protlevel >= 100_t_int)Then
       Call printx(xx(1:,HPOINT),nvec,'        xx',lun,data%name)
       Call printx(yy(1:,HPOINT),nvec,'        yy',lun,data%name)
    Endif
    Call printvectors(xx,yy,u,nvec,mmax,m,.True.,lun,protlevel,data%name&
         &,prot)
    !!
    If(stopit((u(HPOINT) < data%tolerance*data%tolerance),data% letsstop&
         &,data% convcond))Then
       conv=HPOINT
       direct=direct+1_t_int
       Goto 999
    Endif
    If(data%step >= Data%steps)Then
       conv=HPOINT
       direct=direct+1_t_int
       Goto 998
    Endif

    !!
    !! react according to result of prediction
    !!
!!$    Goto 1234
!!$    If(u(HPOINT) > u(m))Then
!!$       Write(lun,"('ITMAG: Must be changed')")
!!$       Write(lun,"('ITMAG: Predicted point is worse than max(|y|)')")
!!$       width=width*widthchangefactor
!!$       widthchange=widthchange+1_t_int
!!$       Write(lun,16)widthchangefactor
!!$
!!$       If(widthchange > widthchangemax)Then
!!$          Stop 'widthchange > widthchangemax'
!!$       Endif
!!$       widthreduce=widthreduce+1_t_int
!!$       Write(lun,1)
!!$       Goto 678
!!$    Endif
!!$    widthchange=0_t_int
!!$1234 Continue 
    If(u(HPOINT) <= alpha1*u(0_t_int))Then
334    Format(a,' ITMAG: Predicted point is improvement!')
       If(prot) Write(lun,334)Trim(data%name)

       If(m+1_t_int > mmax)Then
          m=m-1_t_int
          If(m < 0_t_int)Then
335          Format(a,' ITMAG: m',i5)
             If(prot) Write(lun,335)Trim(data%name),m
             Call terminate(TERM_CRASH,Trim(nsubfunc)//': remove: m <= 0')
          Endif
336       Format(a,' ITMAG: To much dimensions: remove last point')
          If(prot) Write(lun,336)Trim(data%name)
       Endif
       m=m+1_t_int
       direct=direct+1_t_int
       xx(1_t_int:nvec,m)=xx(1_t_int:nvec,HPOINT)
       yy(1_t_int:nvec,m)=yy(1_t_int:nvec,HPOINT)
       u(m)=u(HPOINT)
       Call itmagsort(xx,yy,u,nvec,mmax,m,lun,protlevel,data%name,prot)
       If(prot) Write(lun,1)Trim(data%name)

       Goto 1000
    Else If(u(HPOINT) <= alpha2*u(0_t_int))Then
       If(prot) Write(lun,337)Trim(data%name)

337    Format(a,' ITMAG: Predicted point is improvement, but not enough!')
       !! continue with linear correction step
       Goto 4001
    Else If(u(HPOINT) <= u(0_t_int))Then
       !! region to flat: random step
       If(prot) Write(lun,15)Trim(data%name)

       nmixing=nmixing+1_t_int
       xx(1_t_int:nvec,0_t_int)=xx(1_t_int:nvec,IPOINT)+yy(1_t_int:nvec,IPOINT)&
            &*width*(rndmcm()-0.5_t_real)

       m=0_t_int
       Goto 101
    Endif !! 4000 CHANGES !!

    !! no improvement
    If(prot) Write(lun,17)Trim(data%name)

    
    If(impgrad .And. u(HPOINT) < (u(m)*alpha3+u(0_t_int)*(1.0_t_real-alpha3)))Then
       !! not worse than worst average of history points
       gradient=gradient+1_t_int
       If(prot) Write(lun,18)Trim(data%name)

       If(m < mmax)Then
          xx(1_t_int:nvec,m+1_t_int)=xx(1_t_int:nvec,HPOINT)
          yy(1_t_int:nvec,m+1_t_int)=yy(1_t_int:nvec,HPOINT)
          u(m+1_t_int)=u(HPOINT)
          Call itmagsort(xx,yy,u,nvec,mmax,m+1_t_int,lun,protlevel&
               &,data%name,prot)
          m=m+1_t_int
          If(prot) Write(lun,1)Trim(data%name)

          Goto 1000
       Else
          xx(1_t_int:nvec,m)=xx(1_t_int:nvec,HPOINT)
          yy(1_t_int:nvec,m)=yy(1_t_int:nvec,HPOINT)
          
          u(m)=u(HPOINT)
          Call itmagsort(xx,yy,u,nvec,mmax,m,lun,protlevel,data%name,prot)
          If(prot) Write(lun,1) Trim(data%name)
          Goto 1000
       Endif
    Endif
    
    !!       
    !! worse than worst history point or point not improvement enough
    !!
4001 Continue
    countlinstep=1_t_int
4000 Continue
    !!
    !! interpol between xi-xh
    !!
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,1)Trim(data%name)

1337 Format(a,' ITMAG: Start "Linear interpolation: best point -predicted point"')
    If(prot) Write(lun,1337)Trim(data%name)

338 Format(a,' ITMAG: Best point:')
    If(prot) Write(lun,338)Trim(data%name)
    If(protlevel >= 50_t_int)Then
       If(prot) Write(lun,11)Trim(data%name),u(0_t_int)
    Endif
    If(protlevel >= 100_t_int)Then
       Call printx(xx(1:,0_t_int),nvec,'        xx',lun,data%name)
       Call printx(yy(1:,0_t_int),nvec,'        yy',lun,data%name)
    Endif
339 Format(a,' ITMAG: Predicted point:')
    If(prot) Write(lun,339)Trim(data%name)
    If(protlevel >= 50_t_int)Then
       If(prot) Write(lun,11)Trim(data%name),u(HPOINT)
    Endif
    If(protlevel >= 100_t_int)Then
       Call printx(xx(1:,HPOINT),nvec,'        xx',lun,data%name)
       Call printx(yy(1:,HPOINT),nvec,'        yy',lun,data%name)
    Endif
    

    Call hyper(&
         & xx,yy,HPOINT&
         &,a,b,c,IPOINT&
         &,u(IPOINT),1_t_int,nvec,mmax,protlevel,indef,lun)
    If(indef)Then
       linindef=linindef+1_t_int
       m=0_t_int
       If(prot) Write(lun,81)Trim(data%name)
       If(prot) Write(lun,1)Trim(data%name)
       Goto 101
    Endif
    
    !! print interpolation point
    If(prot) Write(lun,92)Trim(data%name)
    If(protlevel >= 50_t_int)Then
       If(prot) Write(lun,11)Trim(data%name),u(IPOINT)
    Endif
    If(protlevel >= 100_t_int)Then
       Call printx(xx(1:,IPOINT),nvec,'        xx',lun,data%name)
       Call printx(yy(1:,IPOINT),nvec,'        yy',lun,data%name)
    Endif
    
    If(protlevel >= 100_t_int)Then
       If(prot) Write(lun,12)Trim(data%name),1_t_int,c(1_t_int)
    Endif
    If(prot) Write(lun,12)Trim(data%name),1_t_int,c(1_t_int)
    
    !!       linear predcited xn=xg
    xx(1_t_int:nvec,NPOINT)=xx(1_t_int:nvec,IPOINT)+0.0_t_real*yy(1_t_int:nvec,IPOINT)
    !! yn=f(xn)
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,37)Trim(data%name)
    If(prot) Write(lun,1)Trim(data%name)
    
    
    data%step=data%step+1_t_int
    
    data% vector(1_t_int:nvec)=xx(1_t_int:nvec,NPOINT)
    Call handler(Data,it_entry_loop)
    If(data%reset) Then
       Goto 111
    Endif
    
    yy(1_t_int:nvec,NPOINT)=data% vector(1_t_int:nvec)-xx(1_t_int:nvec,NPOINT)
    u(NPOINT)=Dot_product(yy(1_t_int:nvec,NPOINT),yy(1_t_int:nvec,NPOINT))
    data%deviation=u(NPOINT)
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,38)Trim(data%name)
    If(prot) Write(lun,4) Trim(data%name),data%step,m,Sqrt(u(NPOINT)),Sqrt(u(0))
    
    
    !! print at predicted point
    If(prot) Write(lun,93)Trim(data%name)
    If(protlevel >= 50_t_int)Then
       If(prot) Write(lun,11)Trim(data%name),u(NPOINT)
    Endif
    If(protlevel >= 100_t_int)Then
       Call printx(xx(1:,NPOINT),nvec,'        xx',lun,data%name)
       Call printx(yy(1:,NPOINT),nvec,'        yy',lun,data%name)
    Endif
    Call printvectors(xx,yy,u,nvec,mmax,m,.True.,lun,protlevel,data%name&
         &,prot)
    
    If(stopit((u(NPOINT) < data%tolerance*data%tolerance),data% letsstop&
         &,data% convcond))Then
       conv=NPOINT
       linear=linear+1_t_int
       Goto 999
    Endif
    If(data%step >= Data%steps)Then
       conv=NPOINT
       linear=linear+1_t_int
       Goto 998
    Endif
    
    
    
    If(u(NPOINT) < alpha1*u(0_t_int))Then
       !! linear point is better than best alpha1*point
310    Format(a,' ITMAG: Linear predicted point is improvement!')
       If(prot) Write(lun,310)Trim(data%name)
       If(m+1_t_int > mmax)Then
          m=m-1_t_int
          If(m < 0_t_int)Then 
             If(prot) Write(lun,335)Trim(data%name),m
             Call terminate(TERM_CRASH,Trim(nsubfunc)//': linear:  remove m <= 1')
          Endif
311       Format(a,' ITMAG: To much dimensions: remove last point')
          If(prot) Write(lun,311)Trim(data%name)
       Endif
       m=m+1_t_int
       xx(1_t_int:nvec,m)=xx(1_t_int:nvec,NPOINT)
       yy(1_t_int:nvec,m)=yy(1_t_int:nvec,NPOINT)
       u(m)=u(NPOINT)
       Call itmagsort(xx,yy,u,nvec,mmax,m,lun,protlevel,data%name,prot)
       linear=linear+1_t_int
       If(prot) Write(lun,1)Trim(data%name)
       Goto 1000
!!$    Else If(u(NPOINT) <= u(0_t_int))Then
!!$       !! linear flat case
!!$       Write(lun,151)
!!$       linmixing=linmixing+1_t_int
!!$       xx(1_t_int:nvec,0_t_int)=xx(1_t_int:nvec,NPOINT)+yy(1_t_int:nvec,NPOINT)&
!!$            &*width*(rndmcm()-0.5_t_real)
!!$       m=0_t_int
!!$       Write(lun,1)
!!$       Write(lun,1)
!!$       Goto 101
    Else
       !! linear point is not better than alph1* best point
       If(prot) Write(lun,171)Trim(data%name)
       
       If(impgrad .And. u(NPOINT) < u(m))Then
          !! it is better than worst point 
          lingradient=lingradient+1_t_int
          If(prot) Write(lun,181)Trim(data%name)
          If(m < mmax)Then
             xx(1_t_int:nvec,m+1_t_int)=xx(1_t_int:nvec,NPOINT)
             yy(1_t_int:nvec,m+1_t_int)=yy(1_t_int:nvec,NPOINT)
             u(m+1_t_int)=u(NPOINT)
             Call itmagsort(xx,yy,u,nvec,mmax,m+1_t_int,lun,protlevel&
                  &,data%name,prot)
             !m=m+1_t_int
             If(prot) Write(lun,1)Trim(data%name)
             Goto 1000
          Else
             xx(1_t_int:nvec,m)=xx(1_t_int:nvec,NPOINT)
             yy(1_t_int:nvec,m)=yy(1_t_int:nvec,NPOINT)
             u(m)=u(NPOINT)
             Call itmagsort(xx,yy,u,nvec,mmax,m,lun,protlevel,data%name&
                  &,prot)
             If(prot) Write(lun,1)Trim(data%name)
             Goto 1000
          Endif
       Else
          !! it is worse than worst point
          
          !!If(prot) Write(lun,152)
567       Format("'Iteration may improve, if mixing parameter &
               &is reduced!'") 
          Write(errbuf,567)
          Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
          
          If(countlinstep< 5_t_int)Then
             If(prot) Write(lun,1521)Trim(data%name)
             
             nonlinmix=nonlinmix+1_t_int
             
             !!make a second linear step
             xx(:,HPOINT)=xx(:,NPOINT)
             yy(:,HPOINT)=yy(:,NPOINT)
             u(HPOINT)=u(NPOINT)
             countlinstep=countlinstep+1_t_int
             Goto 4000
          Else
             If(prot) Write(lun,15211)Trim(data%name)

             goto 101
          Endif
       Endif
       
       
    Endif
    !! 4000 CHANGES !! Endif
    !!
    !!     TODO: dx schaetzen
    !!     .     punkte entfernen
    !!     .     xi-xh interpol
    !!     .     linear search
    !!     .     width anpassen
    !!     .     minimum abfangen bei linearer suche
    Call terminate(TERM_CRASH,Trim(nsubfunc)//': cannot be here')
    !!
998 Continue 
    conv=0
    data% stepsexceeded=.True.
    Data% vector(1_t_int:nvec)=xx(1_t_int:nvec,conv)
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,511)Trim(data%name),data%step,data%steps
    Goto 997
999 Continue 
    data% stepsexceeded=.False.
    data% vector(1_t_int:nvec)=xx(1_t_int:nvec,conv)
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,1)Trim(data%name)
    If(prot) Write(lun,5)Trim(data%name)
997 Continue 
!    If(prot) Write(lun,4)Trim(data%name),data%step,m,Sqrt(u(conv)),Sqrt(u(conv))

    If(data% stepsexceeded)Then
       If(prot) Write(lun,444)Trim(data%name),data%step,m,Sqrt(u(conv))
    Else
       If(prot) Write(lun,445)Trim(data%name),data%step,m,Sqrt(u(conv))
    Endif

    Call printvectors(xx,yy,u,nvec,mmax,m,.True.,lun,protlevel,data%name&
         &,prot)


    If(prot) Write(lun,51)Trim(data%name)

    If(prot) Then
       Write(lun,52)Trim(data%name),data%step
       Write(lun,53)Trim(data%name),single
       Write(lun,54)Trim(data%name),simple
       Write(lun,55)Trim(data%name),direct
       Write(lun,56)Trim(data%name),linear
       Write(lun,57)Trim(data%name),gradient
       Write(lun,66)Trim(data%name),widthreduce
       Write(lun,58)Trim(data%name),lingradient
       Write(lun,59)Trim(data%name),nmixing
       Write(lun,60)Trim(data%name),linmixing
       Write(lun,61)Trim(data%name),nonlinmix
       Write(lun,65)Trim(data%name),badinterpol
       Write(lun,62)Trim(data%name),hyperindef
       Write(lun,63)Trim(data%name),linindef
       
       Write(lun,64)Trim(data%name)&
            &,direct+linear+gradient+lingradient+nmixing&
            & +linmixing+nonlinmix+linindef+hyperindef+single+simple&
            & +badinterpol+widthreduce
    Endif
    !!
    !!
    Call pfree(xx)
    Call pfree(yy)
    !!
    Return
    !!     
1   Format(a,' ITMAG: ',72('=')) 
2   Format(a,' ITMAG: Startwidth=',e12.5e2)
3   Format(a,' ITMAG: Start  "Calculation Single point"')
4   Format(a,' ITMAG: iteration ',i4,' dim=',i4&
         & ,' last deviation=',e14.3e3,' best=',e14.3e3)
444 Format(a,' ITMAG: iteration ',i4,' dim=',i4&
         & ,' last deviation=',e14.3e3,' NOT CONVERGED')
445 Format(a,' ITMAG: iteration ',i4,' dim=',i4&
         & ,' last deviation=',e14.3e3,' CONVERGED')
114 Format(a,' ITMAG: iteration step=',i4,' dimension m=',i4&
         &,' last deviation=RESTART')
5   Format(a,' ITMAG: Calculation converged !')
511 Format(a,' ITMAG: Abort iteration, to many steps (step='&
         & ,i4,' steps=',i4,')!')
31  Format(a,' ITMAG: Result "Single point"')
32  Format(a,' ITMAG: Start  "Calculation Simple mix" factor=',e12.5e2)
33  Format(a,' ITMAG: Result "Simple mix" factor=',e12.5e2)
!331 Format('ITMAG: Result "Simple mix" random')
34  Format(a,' ITMAG: Start  "Subspace interpolation"')
35  Format(a,' ITMAG: Start  "Calculation at predicted point" '&
         & ,'factor=',e12.5e2)
36  Format(a,' ITMAG: Result "Calculation at predicted point" '&
         & ,'factor=',e12.5e2)
37  Format(a,' ITMAG: Start  "Calculation at linear predicted"')
38  Format(a,' ITMAG: Result "Calculation at linear predicted"')
51  Format(a,' ITMAG: Statistics:')
52  Format(a,' ITMAG: Total calculations                        : ',i4)
53  Format(a,' ITMAG: Single point calculations                 : ',i4)
54  Format(a,' ITMAG: Simple mixing steps                       : ',i4)
55  Format(a,' ITMAG: Successfull subspace interpolations       : ',i4)
56  Format(a,' ITMAG: Successfull linear corrections            : ',i4)
57  Format(a,' ITMAG: Gradient updates                          : ',i4)
58  Format(a,' ITMAG: Gradient updates after linear corr.       : ',i4)
59  Format(a,' ITMAG: Random step due to flat subsp. interpol.  : ',i4)
60  Format(a,' ITMAG: Random step after linear corr.            : ',i4)
61  Format(a,' ITMAG: Random step due to failure of linear corr.: ',i4)
65  Format(a,' ITMAG: Random step due to bad interpolation      : ',i4)
62  Format(a,' ITMAG: Dimension reduct. due to subspace degener.: ',i4)
63  Format(a,' ITMAG: Dimension reduct. due to lin corr. degen. : ',i4)
64  Format(a,' ITMAG: Sum of cases                              : ',i4)
66  Format(a,' ITMAG: Reduction of prediction step width        : ',i4)


8   Format(a,' ITMAG: Subspace interpolation degenerated: '&
         & ,'discard dimension with largest E')
81  Format(a,' ITMAG: Linear interpolation degenerated: '&
         & ,'restart from m=0')
9   Format(a,' ITMAG: Minimum in subspace:')
91  Format(a,' ITMAG: At predicted point:')
92  Format(a,' ITMAG: Minimum in linear space:')
93  Format(a,' ITMAG: At linear predicted point:')
11  Format(a,' ITMAG: u=',e14.3e3)
12  Format(a,' ITMAG: coefficient(',i2,')  =',e12.3e3)
13  Format(a,' ITMAG: max |coefficient|=',e12.3e3)
14  Format(a,' ITMAG: Random step and reduction to m=0 due to '&
         & ,'bad interpolation!')
15  Format(a,' ITMAG: Random step and reduction to m=0 due to '&
         & ,'flat region!')
!!$151 Format('ITMAG: Random step and reduction to m=0 due to '&
!!$         & ,'flat linear region!')
!!$152 Format('ITMAG: Random step and reduction to m=0 due to '&
!!$         & ,'nonlinearities!')
1521 Format(a,' ITMAG: Linear step due to nonlinearities!')
15211 Format(a,' ITMAG: Reduction to m=0 due to nonlinearities!')
!!$16  Format('ITMAG: Change width=',f10.5,'*width new trial')
17  Format(a,' ITMAG: best point < Predicted point')
171 Format(a,' ITMAG: alpha1*best point < Linear predicted point')
18  Format(a,' ITMAG: Predicted point < worst point: update gradient!')
181 Format(a,' ITMAG: Linear predicted point < worst point: '&
         & ,'update gradient!')

    !!
  End Subroutine lciterat
  !!***********************************************************************
  !! interpolate hyperplane  x0,(xx(1,i),i=1,m)
  !!     
  Subroutine hyper(xx,yy,k0,a,b,c,kg,ui,m,nvec,mmax,protlevel,indef,lun)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(out)  :: indef
    Integer(t_int),Intent(in)   :: nvec,mmax,m,protlevel,lun,k0,kg
    Real(t_real),Intent(inout)  :: xx(1:,0:),yy(1:,0:)
    Real(t_real),Intent(out)    :: c(mmax)
    Real(t_real),Intent(out)    :: a(mmax*mmax),b(mmax)
    Real(t_real),Intent(out)    :: ui
    !!LOCAL
    Character(*),Parameter::nsubfunc="hyper"
    Integer(t_int) :: i,k,l
    Real(t_real)  :: d,dx,dy,er
    !!
    Do k=1_t_int,m
       Do l=1_t_int,m
          d=0.0_t_real
          Do i=1_t_int,nvec
             d=d+(yy(i,k0-1+k)-yy(i,0))*(yy(i,k0-1+l)-yy(i,0))
          Enddo ! i
          a(k+(l-1_t_int)*m)=d
       Enddo                   ! l
       d=0.0_t_real
       Do i=1_t_int,nvec
          d=d-yy(i,0)*(yy(i,k0-1+k)-yy(i,0))
       Enddo                   ! i
       b(k)=d
    Enddo                     ! k
    !!
    If(protlevel >= 110_t_int) Then

       Do k=1_t_int,m
          If(k == 1_t_int)Then
1            format('ITMAG: A=')
             Write(lun,1,advance='no')
          Else
2            Format('         ')
             Write(lun,2,advance='no')
          Endif
          Do l=1_t_int,m
3            Format(e12.3e3)
             Write(lun,3,advance='no')a(k+(l-1_t_int)*m)
          Enddo
          Write(lun,*)
       Enddo
4      Format('ITMAG: B=')
       Write(lun,4,advance='no')
       Do k=1_t_int,m
          Write(lun,3,advance='no')b(k)
       Enddo
       Write(lun,*)
    Endif
    !!
    Call dglei(a,b,c,m,m,indef)
    If(indef )Then
       Return
    Endif
    If(protlevel >= 110_t_int) Then
5      Format('ITMAG: C=')
       Write(lun,5,advance='no')
       Do k=1_t_int,m
          Write(lun,3,advance='no')c(k)
       Enddo
       Write(lun,*)
    Endif
    !!

    Do i=1_t_int,nvec
       dx=xx(i,0)
       dy=yy(i,0)
       Do k=1_t_int,m
          dx=dx+c(k)*(xx(i,k0-1+k)-xx(i,0))
          dy=dy+c(k)*(yy(i,k0-1+k)-yy(i,0))
       Enddo
       xx(i,kg)=dx
       yy(i,kg)=dy
    Enddo
    d=Dot_product(yy(1_t_int:nvec,kg),yy(1_t_int:nvec,kg))

    Do i=1_t_int,nvec
       xx(i,kg)=xx(i,0)+Sum(c(1_t_int:m)*(xx(i,k0:k0-1+m)-xx(i,0)))
       yy(i,kg)=yy(i,0)+Sum(c(1_t_int:m)*(yy(i,k0:k0-1+m)-yy(i,0)))
    Enddo
    ui=Dot_product(yy(1_t_int:nvec,kg),yy(1_t_int:nvec,kg))

    !!
    er=Abs(d)
    If(d<1.0_t_real)er=1.0_t_real
    
    If(Abs(ui-d) > er*1.e-8_t_real)Then
6      Format(a,': ui  /=  d ui=',e30.15e3,' d=',e30.15e3)
       Write(errbuf,6)Trim(nsubfunc),ui,d
       Call terminate(TERM_CRASH,errbuf)
    Endif
    !!
    Return
    !!
  End Subroutine hyper
  !!***********************************************************************
  Subroutine printx(x,nvec,text,lun,mesg)
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)      :: mesg
    Integer(t_int),Intent(in)    :: nvec,lun
    Real(t_real),Intent(in)     :: x(nvec)
    Character(*),Intent(in)     :: text
    !!LOCAL
    Integer(t_int) :: i
    !!
1   Format(a,' ITMAG: ',a10)
    Write(lun,1,advance='no') Trim(mesg),text
    Do i=1_t_int,nvec
2      Format(e18.5e3,' ')
       Write(lun,2,advance='no') x(i)
3      Format(/,a,' ITMAG:           ')
       If(Mod(i,3_t_int) == 0_t_int) &
            &Write(lun,3,advance='no')Trim(mesg)
    Enddo
    Write(lun,*)
    !!
  End Subroutine printx
  !!***********************************************************************
  Subroutine itmagsort(xx,yy,u,nvec,mmax,m,lun,protlevel,mesg,prot)
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)      :: mesg
    Logical(t_log),Intent(in)    :: prot
    Integer(t_int),Intent(in)    :: nvec,mmax,m,lun,protlevel
    Real(t_real),Intent(inout)  :: xx(nvec,0:mmax)
    Real(t_real),Intent(inout)  :: yy(nvec,0:mmax)
    Real(t_real),Intent(inout)  :: u(0:mmax)
    !!LOCAL
    Integer(t_int) :: n,k,i,out
    Real(t_real)  :: dx,dy,du
    !!
    out=110_t_int
    If(protlevel >= out)Then
       If(prot)Write(lun,1)Trim(mesg)
       Call printvectors(xx,yy,u,nvec,mmax,m,.True.,lun,protlevel,mesg&
            &,prot)
    Endif
    k=m
    Do n=m-1_t_int,0_t_int,-1_t_int
       If(u(m) < u(n))Then
          k=n
       Endif
    Enddo
    !!     
    If(protlevel >= out.And.prot)Write(lun,2)Trim(mesg),k,m
    !!
    Do i=1_t_int,nvec
       dx=xx(i,m)
       dy=yy(i,m)
       Do n=m,k+1_t_int,-1_t_int
          xx(i,n)=xx(i,n-1_t_int)
          yy(i,n)=yy(i,n-1_t_int)
       Enddo
       xx(i,k)=dx
       yy(i,k)=dy
    Enddo
    !!     
    du=u(m)
    Do n=m,k+1_t_int,-1_t_int
       u(n)=u(n-1_t_int)
    Enddo
    u(k)=du
    !!
    If(protlevel >= out)Then
       If(prot)Write(lun,11)Trim(mesg)
       Call printvectors(xx,yy,u,nvec,mmax,m,.True.,lun,protlevel,mesg&
            &,prot)
       If(prot)Write(lun,12)Trim(mesg)
    Endif
    !!  
1   Format(a,' ITMAG: Itmagsort: Start  ',50('-'))
2   Format(a,' ITMAG: Itmagsort: k=',i4,' m= ',i4)
11  Format(a,' ITMAG: Itmagsort: sorted ',50('-'))
12  Format(a,' ITMAG: Itmagsort: End    ',50('-'))
    !!
  End Subroutine itmagsort
  !!***********************************************************************
  Subroutine printvectors(xx,yy,u,nvec,mmax,m,all,lun,protlevel,mesg,prot)
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)      :: mesg
    Logical(t_log),Intent(in) :: all,prot
    Integer(t_int),Intent(in) :: m,nvec,mmax,lun,protlevel
    Real(t_real),Intent(in)   :: xx(nvec,0:mmax),yy(nvec,0:mmax)
    Real(t_real),Intent(in)   :: u(0:mmax)
    !!LOCAL
    Integer(t_int) :: i0,i
    i0=m
    If(all) i0=0_t_int
    If(protlevel  >= 50_t_int)Then
       If(prot)Write(lun,1)Trim(mesg)
       Do i=i0,m
          If(prot)Write(lun,11)Trim(mesg),i,u(i)
          If(protlevel >= 100_t_int)Then
             Call printx(xx(1_t_int,i),nvec,'        xx',lun,mesg)
             Call printx(yy(1_t_int,i),nvec,'        yy',lun,mesg)
          Endif
       Enddo
    Endif
    !!
1   Format(a,' ITMAG: Interpolation history:')
11  Format(a,' ITMAG: u(',i4,')=',e14.3e3)
    !!     
  End Subroutine printvectors
  !!***********************************************************************
  Subroutine itmagreddim(xx,yy,u,rem,nvec,m,mmax,bmin,bmax&
       &,cmax,lun,protlevel,mesg,prot)
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)      :: mesg
    Logical(t_log),Intent(in)    :: prot
    Integer(t_int),Intent(in) :: nvec,mmax,lun,protlevel
    Integer(t_int),Intent(inout) :: m,rem(0:mmax)
    Real(t_real),Intent(inout)  :: xx(nvec,0:mmax)
    Real(t_real),Intent(inout)  :: yy(nvec,0:mmax)
    Real(t_real),Intent(inout)  :: u(0:mmax)
    Real(t_real),Intent(in)     :: bmin,bmax,cmax
    !!LOCAL
    Character(*),Parameter::nsubfunc="itmagreddim"
    Integer(t_int) :: imin,i,j,k,n
    Real(t_real)  :: beta,distmin
    Real(t_real)  :: b(mmax)
    !!
!!$    Goto 100
!!$    !!     criterion for reduction
!!$    beta=bmax/(1.0_t_real+Exp(5.0_t_real*(cmax-1.5_t_real)))+bmin
!!$    Write(lun,6)bmin,bmax,cmax,beta
!!$    !!     
!!$    remove=-1_t_int
!!$    Write(lun,7)0_t_int,0.0_t_real,0_t_int,Sqrt(u(0_t_int)),0_t_int,0_t_int
!!$    Do i=1_t_int,m
!!$       d=Sqrt(Sum((xx(1_t_int:nvec,i)-xx(1_t_int:nvec,0_t_int))**2_t_int))
!!$       If(i == 1_t_int)Then
!!$          distmin=d
!!$       Else
!!$          If(d > beta*distmin)Then
!!$             remove=i
!!$101            Format('remove dist',i5)
!!$             Write(lun,101) i
!!$          Endif
!!$       Endif
!!$       If(u(i) > beta**2_t_int*u(0_t_int))Then
!!$          remove=i
!!$2         Format('remove u',i5)
!!$          Write(lun,2)i
!!$       Endif
!!$       Write(lun,7)i,d,i,Sqrt(u(i)),i,0_t_int
!!$    Enddo
!!$    If(m > 1_t_int)Then
!!$       If(remove > 1_t_int)Then
!!$3         Format('removed ',i5,' ',i5)
!!$          Write(lun,3) remove-1_t_int,m
!!$          m=remove-1_t_int
!!$          Call printvectors(xx,yy,u,nvec,mmax,m,.True.,lun,prot)
!!$       Endif
!!$    Endif
!!$    !!
!!$    Return
!!$100 Continue 
    !! criterion for reduction
    beta=bmax/(1.0_t_real+Exp(5.0_t_real*(cmax-1.5_t_real)))+bmin&
         &+0.0_t_real
    If(prot) Write(lun,6)Trim(mesg),bmin,bmax,Trim(mesg),cmax,beta
    !!     beta=bmax

    If(m < 2_t_int)Return
    If(prot) Write(lun,10)Trim(mesg)
    Call printvectors(xx,yy,u,nvec,mmax,m,.True.,lun,protlevel,mesg&
         &,prot)
    imin=1_t_int
    !!     calculate minimum distances 
    distmin=Sqrt(Sum((xx(1_t_int:nvec,1_t_int)-xx(1_t_int:nvec,0_t_int))**2_t_int))
    b(1_t_int)=distmin
    Do i=2_t_int,m
       b(i)=Sqrt(Sum((xx(1_t_int:nvec,i)-xx(1_t_int:nvec,0_t_int))**2_t_int))
       If(b(i) < distmin)Then
          imin=i
          distmin=b(i)
       Endif
    Enddo

    !!     
    Do i=0_t_int,mmax
       rem(i)=0_t_int
    Enddo
    !!     calculate reduction indices
    If(prot) Write(lun,1)Trim(mesg),distmin,imin
    If(prot) Write(lun,7)Trim(mesg)&
         &,0_t_int,0.0_t_real,0_t_int,Sqrt(u(0_t_int)),0_t_int,rem(0_t_int)
    Do i=m,2_t_int,-1_t_int
       !!       if(b(i) > beta*distmin)then
       !!          rem(i)=1_t_int
       !!        endif
       If(u(i) > beta**2_t_int*u(0_t_int))Then
          rem(i)=2_t_int
          Goto 99
       Endif
       !!       if(imin == i)then
       !!       rem(i)=0_t_int
       !!       endif
       If(prot) Write(lun,7)Trim(mesg),i,b(i),i,Sqrt(u(i)),i,rem(i)
    Enddo
    !!     reduce
99  Continue 
    If(m > 1_t_int)Then
       j=m
       i=1_t_int
       Do While(i <= j)
          If(rem(i) > 0_t_int)Then
             Do k=i+1_t_int,j
                Do n=1_t_int,nvec
                   xx(n,k-1_t_int)=xx(n,k)
                   yy(n,k-1_t_int)=yy(n,k)
                Enddo
                u(k-1_t_int)=u(k)
                rem(k-1_t_int)=rem(k)
             Enddo
             If(prot) Write(lun,8)Trim(mesg),i,j,m
             j=j-1_t_int
          Else
             i=i+1_t_int
          Endif
       Enddo
       m=j
    Endif
    !!     
    If(m == 0_t_int)Then
       Call terminate(TERM_CRASH,Trim(nsubfunc)//': m == 0')
    Endif
    !!     
    Call printvectors(xx,yy,u,nvec,mmax,m,.True.,lun,protlevel,mesg&
         &,prot)
    If(prot) Write(lun,11)Trim(mesg)
    !!     
    Return
    !!
1   Format(a,' ITMAG: Reduction: minimum distance=',e12.3e3,' index=',i2)
6   Format(a,' ITMAG: Reduction: Criterion min =',e12.3e3,' max ='&
         &      ,e12.3e3,/,a,' ITMAG: Reduction: Criterion cmax=',e12.3e3&
         &      ,' beta=',e12.3e3)
7   Format(a,' ITMAG: Reduction: |x(',i2,')-x0|^2=',e12.3e3&
         &      ,' |y(',i2,')|=',e13.3e3,' rem(',i2,')=',i2)
8   Format(a,' ITMAG: Reduction: remove dimension ',i2,' from ',i2&
         &      , 'dimension, total(',i2,')')
10  Format(a,' ITMAG: Reduction: Start',50('-'))
11  Format(a,' ITMAG: Reduction: End  ',50('-'))
    !!
  End Subroutine itmagreddim
  !!***********************************************************************
  Logical(t_log) Function stopit(itconv,letsstop,convcond)
    !!
    Implicit none  
    !!IO
    Logical(t_log),Intent(in)    :: itconv,letsstop
    Integer(t_int),Intent(in)    :: convcond
    !!LOCAL
    Character(*),Parameter::nsubfunc="stopit"
    !!
    stopit=.False.
    If(convcond==CONVCOND_ITERAT)Then
       stopit=itconv
    Else If(convcond==CONVCOND_LETSSTOP)Then
       stopit=letsstop
    Else If(convcond==CONVCOND_BOTH)Then
       stopit=letsstop.And.itconv
    Else If(convcond==CONVCOND_ANY)Then
       stopit=letsstop.Or.itconv
    Else
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'Unknown convergence condition!'")
    Endif
    !!
  End Function stopit
  !!***********************************************************************
  
End Module iterationmethods



