!!TODO: cleanup wannier
!!TODO: cleanup heavy duty stuff
!!TODO: use vblock...  whereever blocks are needed
Module kohnsham
  !!
  Use precisiondefs
  Use memory
  Use clock
  Use constants
  Use file_iounits
  Use errors
  Use ioaux, Only : kapToString, intToChar10,ORB_NL,ORB_NLM
#if defined (ANALYSE_S)
  Use ksaux, Only : analyze_S
#endif
  Use sort
  Use torbitalbasis
  Use tsymmetry
  Use tkohnsham
  Use tforces
  Use tbandplot
  Use toptics
  Use optics
  Use dump
  Use bandplot
  Use atomdefs
  Use tstm
  Use stm
  Use tio
  Use optionstest
  Use versioncontrol
  Use tunfold
  Use tfatband
  Use unfold
  Use fatband
  Use diagonalize
  Use tbzone
  Use bzone
  Use tlsdau
  Use topc
  Use opcorrection
  Use trelativistic
  Use ksinternal
  Use tloi
  Use lsdau
  Use matserv
  Use diracdefs
  Use tdiracdefs
  Use tloi
  Use prnt
  Use twannier
  Use molcore
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="KOHNSHAM"  
  !!
  Public :: coefdef,calc_KS_states,create_bandstructure,T_KS&
       &,init_KS,setup_ks,clean_ks,calc_at_kpoint,write_band_header
  !!***********************************************************************
  Type T_KS
     !!
     Logical(t_log) :: occu !! do we need occu information?
     Logical(t_log) :: spinmat !! do we need relat spin matrices?
     !!                           if not occu
     Logical(t_log) :: savesp !! do we need to save the overlap?
     Logical(t_log) :: lsdau_kintest !! do we make paranoid tests?
     Logical(t_log) :: lsdau_energy !! do we calculatethe LSDAU energy
     Logical(t_log) :: need_sigma !! do we need \vec{\sigma}
     !! aux arrays
     !! we allocate them only once per k-loop
     Complex(t_real),Pointer:: p_hp(:,:)! becomes eigenvectors
     Complex(t_real),Pointer:: p_sp(:,:)
     Real(t_real),Pointer   :: p_eb(:)
     Complex(t_real),Pointer:: p_sp2(:,:)
     Complex(t_real),Pointer:: p_scv(:,:)
     Complex(t_real),Pointer:: p_hcv(:,:)
     Complex(t_real),Pointer:: p_spbS(:,:)
     Complex(t_real),Pointer:: p_spbVS(:,:,:)
     Complex(t_real),Pointer:: p_scvbS(:,:)
     Complex(t_real),Pointer:: p_scvbVS(:,:,:)
     Complex(t_real),Pointer:: p_scrawv(:,:)
  End Type T_KS
  !!***********************************************************************
Contains 
  !!***********************************************************************
  Subroutine init_KS(ks,occu,savesp,lsdau_kintest,lsdau_energy,spinmat&
       &,need_sigma)
    !!
    Implicit None
    !!IO
    Type(T_KS),Intent(inout)     :: ks
    Logical(t_log),Intent(in)    :: occu,savesp,lsdau_kintest,lsdau_energy
    Logical(t_log),Intent(in)    :: spinmat,need_sigma
    !!LOCAL
    !Character(*),Parameter::nsubfunc="init_KS"
    !!
    ks% spinmat=spinmat
    ks% need_sigma=need_sigma
    ks% occu=occu
    ks% savesp=savesp
    ks% lsdau_kintest=lsdau_kintest
    ks% lsdau_energy=lsdau_energy
    !!
    Nullify(ks% p_hp)
    Nullify(ks% p_sp)
    Nullify(ks% p_eb)
    Nullify(ks% p_sp2)
    Nullify(ks% p_scv)
    Nullify(ks% p_hcv)
    Nullify(ks% p_spbS)
    Nullify(ks% p_spbVS)
    Nullify(ks% p_scvbS)
    Nullify(ks% p_scvbVS)
    Nullify(ks% p_scrawv)
    !!
    Return
    !!
  End Subroutine init_KS
  !!***********************************************************************
  Subroutine clean_ks(ks,lsdau,opc)
    !!
    Implicit None
    !!IO
    Type(T_KS),Intent(inout)     :: ks
    Type(T_Lsdau),Intent(inout)  :: lsdau
    Type(T_OPC),Intent(inout)    :: opc
    !!LOCAL
    !Character(*),Parameter::nsubfunc="clean_ks"
    !!
    !!
    Call pfree(ks% p_hp)
    Call pfree(ks% p_sp)
    Call pfree(ks% p_eb)
    Call pfree(ks% p_sp2)
    Call pfree(ks% p_scv)
    Call pfree(ks% p_hcv)
    Call pfree(ks% p_spbS)
    Call pfree(ks% p_spbVS)
    Call pfree(ks% p_scvbS)
    Call pfree(ks% p_scvbVS)
    Call pfree(ks% p_scrawv)
    !!
    Call lsdau_aux_free(lsdau)
    !!
    Call opc_free(opc)
    !!
#if defined (TIME_KS)
    Call watch('KS-lomatrix',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('KS-diagno',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('KS-coval',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('KS-occu',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
#endif
    !!
    Return
    !!
  End Subroutine clean_ks
  !!***********************************************************************
  Subroutine setup_ks(ks,mspin,nkp,structure,kohnsham,lsdau,opc&
       &,relativistic)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Lsdau),Intent(inout)  :: lsdau
    Type(T_OPC),Intent(inout)    :: opc
    Type(T_KS),Intent(inout)     :: ks
    Integer(t_int),Intent(in)    :: relativistic
    Integer(t_int),Intent(in)    :: mspin,nkp
    !!LOCAL
    Character(*),Parameter::nsubfunc="setup_ks"
    Integer(t_int) :: nvdim,nchidim,nvsmx,ncdim,nspin
    Logical(t_log) :: rel,relmag
    !!
    rel=(relativistic==FULL_RELATIVISTIC)
    relmag=(rel .And. mspin==2)
    nspin=mspin
    if(rel)nspin=1
    !!
    nchidim=kohnsham% nchidim
    ncdim=kohnsham% ncdim
    nvdim=kohnsham% nvdim
    nvsmx=kohnsham% nvsmx
    !!
    Call palloc('ks% p_hp',ks% p_hp,1_t_int,nvdim,1_t_int,nvdim&
         &,nmodule,nsubfunc)
    Call palloc('ks% p_sp',ks% p_sp,1_t_int,nvdim,1_t_int,nvdim&
         &,nmodule,nsubfunc)
    Call palloc('ks% p_eb',ks% p_eb,1_t_int,nvdim&
         &,nmodule,nsubfunc)
    Call palloc('ks% p_scv',ks% p_scv,1_t_int,nchidim,1_t_int,nvdim&
         &,nmodule,nsubfunc)
    Call palloc('ks% p_hcv',ks% p_hcv,1_t_int,nchidim,1_t_int,nvdim&
         &,nmodule,nsubfunc)
    !!
    !!
    If(ks% savesp)Then
       Call palloc('ks% p_sp2',ks% p_sp2,1_t_int,nvdim,1_t_int,nvdim&
            &,nmodule,nsubfunc)
    Endif
    !!
    If(ks% occu)Then
       Call palloc('ks% p_scrawv',ks% p_scrawv,1_t_int,nvdim,1_t_int,ncdim&
            &,nmodule,nsubfunc)
    Endif
    !!
    !!
    If(relmag)Then
       Call palloc('ks% p_spbS',ks% p_spbS,1_t_int,nvdim,1_t_int,nvdim&
            &,nmodule,nsubfunc)
       Call palloc('ks% p_scvbS',ks% p_scvbS,1_t_int,nchidim,1_t_int,nvdim&
            &,nmodule,nsubfunc)
    Else
       Call palloc('ks% p_spbS',ks% p_spbS,1_t_int,1_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
       Call palloc('ks% p_scvbS',ks% p_scvbS,1_t_int,1_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
    Endif
    !!
    If(ks% need_sigma) Then
       Call palloc('ks% p_spbVS',ks% p_spbVS,1_t_int,nvdim,1_t_int,nvdim&
            &,1_t_int,3_t_int,nmodule,nsubfunc)
       Call palloc('ks% p_scvbVS',ks% p_scvbVS,1_t_int,nchidim,1_t_int,nvdim&
            &,1_t_int,3_t_int,nmodule,nsubfunc)
    Else
       Call palloc('ks% p_spbVS',ks% p_spbVS,1_t_int,1_t_int,1_t_int,1_t_int&
            &,1_t_int,1_t_int,nmodule,nsubfunc)
       Call palloc('ks% p_scvbVS',ks% p_scvbVS,1_t_int,1_t_int,1_t_int,1_t_int&
            &,1_t_int,1_t_int,nmodule,nsubfunc)
    Endif

    !!
    Call lsdau_aux_alloc(lsdau,nvdim,kohnsham% nband,nkp,nspin&
         &,ks% lsdau_kintest)
    !!
    !! make LSDA+U potential matrix from input density matrix
    Call lsdau_calc_u_potmat(lsdau,rel,structure% p_elements&
         &,nspin,mspin,energy=ks% lsdau_energy)
    !!
    Call opc_alloc(opc,kohnsham% nband,nkp)
    !!
#if defined (TIME_KS)
    Call watch('KS-lomatrix',cpu_start,reset=.True.)
    Call watch('KS-lomatrix',cpu_stop)
    Call watch('KS-coval',cpu_start,reset=.True.)
    Call watch('KS-coval',cpu_stop)
    Call watch('KS-diagno',cpu_start,reset=.True.)
    Call watch('KS-diagno',cpu_stop)
    Call watch('KS-occu',cpu_start,reset=.True.)
    Call watch('KS-occu',cpu_stop)
#endif
    !!
    Return
    !!
  End Subroutine setup_ks
  !!***********************************************************************
  !! create Hamilton and Overlap matricees and diagonalize it
  !! create Kohn-Sham eigenvectors, values and population analysis
  !! prepare density calculation input
  !!***********************************************************************
  !!***********************************************************************
  Subroutine calc_KS_states(symmetry,structure,lattice,mspin,nspin,kohnsham&
       &,natom,bandenergy,Eent,basis,bzone,bandplot,ldos&
       &,loi,lsdau,relativistic,opc,forces,deviation,restart,force_loop&
       &,wannier,bwdefactive,optics)
    !,quant)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Forces),Intent(inout) :: forces
!    Type(T_Quant),Intent(in)     :: quant!!TODO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Bandplot),Intent(inout) :: bandplot
    Type(T_LDOS),Intent(in)      :: ldos
    Type(T_Lsdau),Intent(inout)  :: lsdau 
    Type(T_Bzone),Intent(inout)  :: bzone 
    Type(T_Kohnsham),Intent(inout):: kohnsham
    Type(T_Basis),Intent(inout)  :: basis
    Type(T_OPC),Intent(inout)    :: opc
    Type(T_Loi),Intent(in)       :: loi
    Type(T_Wannier),Intent(in)   :: wannier
    Logical(t_log),Intent(in)    :: bwdefactive
    Type(T_Optics),Intent(inout) :: optics
    Logical(t_log),Intent(in)    :: force_loop
    Integer(t_int),Intent(in)    :: relativistic
    Integer(t_int),Intent(in)    :: mspin,nspin
    Real(t_real),Intent(in)      :: natom(*)
    Real(t_real),Intent(out)     :: bandenergy(2),Eent(2)
    Real(t_real),Intent(in)      :: deviation
    Integer(t_int),Intent(inout) :: restart
    !!LOCAL
    Character(*),Parameter::nsubfunc="calc_KS_states"
    Logical(t_log),Parameter :: afm=.False. !! not yet tested
    Logical(t_log) :: nopop,rel,relmag,dumpreadd,dumpwritee,success,docalc
    Logical(t_log) :: calcfermisurfaceweights,bwdos
    Integer(t_int) :: isa,ms,in,ik,iz,mdim,nband,nkp
    Integer(t_int) :: nsort,nsite
    Integer(t_int) :: ncdim,iv,subdiv,nw,nrel
    Integer(t_int) :: nvsmx,nchidim,nvdim
    Real(t_real)  :: qq(3),tmp(3,3),tmpi(3,3),det,rbasis(3,3),kvec(3),dBfsm
    Real(t_real),Parameter  :: tolef=1.0e-9_t_real!!TODO
    !! aux arrays
    !!
    Real(t_real),Pointer :: ogrs(:,:,:,:,:) 
    Real(t_real),Pointer :: onet(:,:,:,:,:) 
    Real(t_real),Pointer :: lgrs(:,:,:,:,:)
    Real(t_real),Pointer :: lnet(:,:,:,:,:)
    Real(t_real),Pointer :: bgrs(:,:,:,:)
    Real(t_real),Pointer :: bnet(:,:,:,:)
    Real(t_real),Pointer :: net(:,:,:)
    Real(t_real),Pointer :: grs(:,:,:)
    Real(t_real),Pointer :: Mnn(:,:)
    Real(t_real),Pointer :: dbweitk(:,:,:)
    Complex(t_real):: ce,cv
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    !Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    !!
    Logical(t_log) :: wandata_out=.True.
    Logical(t_log) :: wan_jump=.False.
    Logical(t_log) :: debexpBoltztrap
    Integer(t_int) :: wio,wiu
    Character(100) :: fname
    Type(T_KS) :: ks
    Type(T_WeightRot) :: wr
    !!***********************************************************************
    !!
    debexpBoltztrap=debugfun(nmodule,nsubfunc,'EXPORT_BOLTZTRAP')
    !!
    !!
    Call init_KS(ks,occu=.True.,savesp=.True.,lsdau_kintest=.True.&
         &,lsdau_energy=.True.,spinmat=.True.,need_sigma=.False.)
    !!

    !!
    wandata_out=.False.
    !!wan_inplace=.False.!! TODO: inplace busisnes
    If(wannier% do_wanniers) Then
       If(wannier% do_wannier_from_file)Then
          wan_jump=.True.
          Write(errbuf,77) 
          Call errmsg(nmodule,nsubfunc,E_information,msg=errbuf)
77        Format("'Do-Wanniers-from-file option set by user...',/&
               &,' will start dumping data for creating wannier functions.'") 
       Else
          !!wan_inplace=.True.
       Endif
       If(.Not.bandplot% output_bands_in_window)Then
          wandata_out=.True.
          wan_jump=.False.
       Endif
    Endif
    !!
    !!
    nchidim=kohnsham% nchidim
    ncdim=kohnsham% ncdim
    nvdim=kohnsham% nvdim
    nvsmx=kohnsham% nvsmx
    nband=kohnsham% nband
    nkp=bzone% nkp
    nsort=structure% nsort
    nsite=structure% nsite
    !!
    !!
    Call init_WeightRot(wr)
    Nullify(ogrs)
    Nullify(onet)
    Nullify(lgrs)
    Nullify(lnet)
    Nullify(Mnn,dbweitk)
    Nullify(bgrs)
    Nullify(bnet)
    Nullify(net)
    Nullify(grs)
    !!
    rel=(relativistic==FULL_RELATIVISTIC)
    relmag=(rel .And. mspin==2)
    !!
    !!
    calcfermisurfaceweights=.False.
    !!
    !!
    mdim=Max(basis% nNLvmx+1_t_int,ORBITAL_MAX_L+2_t_int) 
    nopop=isoption('NO_POPANALYSIS')
    !!
    !!
    !!
    Call setup_KS(ks,mspin,nkp,structure,kohnsham,lsdau,opc&
         &,relativistic)



 

    !! prepare rotation of quantization axis (local DOS)
    !!
    Call setup_WeightRot(wr,basis% lvmx,rel,bandplot% bweight_rot&
         &,bandplot% x_axis,bandplot% z_axis,basis% lmx&
         &,basis% p_relTOpseudo,.True.)
    !!
    Call setup_ldosRot(symmetry,basis,wr,rel)
    !!
    !! START prepare local dos
    !! allocate gross occu numbers for local dos
    !!
    bwdos=(bwdefactive .And.(isoption('CALC_DOS') .Or. bandplot% plotbands)&
         &.And..Not.isoption('NO_DOS'))
    
    If(bwdos)Then
       nw=cfatbandnumweights()
       Call palloc('bgrs',bgrs,1_t_int,nvdim,1_t_int,nkp&
            &,1_t_int,nw,1_t_int,nspin,nmodule,nsubfunc)
       Call palloc('bnet',bnet,1_t_int,nvdim,1_t_int,nkp&
            &,1_t_int,nw,1_t_int,nspin,nmodule,nsubfunc)
    Else
       Call palloc('bgrs',bgrs,1_t_int,1_t_int,1_t_int,1_t_int&
            &,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
       Call palloc('bnet',bnet,1_t_int,1_t_int,1_t_int,1_t_int&
            &,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
    Endif
    !!
    If(ldos% plotldos)Then
       nrel=1
       If(rel) nrel=2
       Call palloc('lgrs',lgrs,1_t_int,nvdim,1_t_int,nkp,1_t_int,nvsmx*nrel&
            &,1_t_int,ldos% nldos,1_t_int,nspin,nmodule,nsubfunc)
       Call palloc('lnet',lnet,1_t_int,nvdim,1_t_int,nkp,1_t_int,nvsmx*nrel&
            &,1_t_int,ldos% nldos,1_t_int,nspin,nmodule,nsubfunc)
    
    Else
       Call palloc('lgrs',lgrs,1_t_int,1_t_int,1_t_int,1_t_int&
            &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
       Call palloc('lnet',lnet,1_t_int,1_t_int,1_t_int,1_t_int&
            &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
    Endif
    !! END prepare local dos



    If(relmag)Then
       Call palloc('Mnn',Mnn,1_t_int,nvdim,1_t_int,nkp,nmodule,nsubfunc)
    Else 
       Call palloc('Mnn',Mnn,1_t_int,1_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
    Endif

    If(calcfermisurfaceweights)Then
       Call palloc('dbweitk',dbweitk,1_t_int,nband,1_t_int,nkp,1_t_int,nspin&
            &,nmodule,nsubfunc)
    Else
       Call palloc('dbweitk',dbweitk,1_t_int,1_t_int,1_t_int,1_t_int&
            &,1_t_int,1_t_int,nmodule,nsubfunc)
    Endif


    !!population analysis and DOS
    
    Call palloc('ogrs',ogrs,1_t_int,nvdim,1_t_int,nkp,1_t_int,mdim&
         &,1_t_int,nsort+1_t_int,1_t_int,mspin,nmodule,nsubfunc)
    Call palloc('onet',onet,1_t_int,nvdim,1_t_int,nkp,1_t_int,mdim&
         &,1_t_int,nsort+1_t_int,1_t_int,mspin,nmodule,nsubfunc)





101 Continue

    Call lsdau_save_dmat(lsdau)


    

    ogrs(1_t_int:nvdim,1_t_int:nkp,1_t_int:mdim,1_t_int:nsort+1_t_int&
         &,1_t_int:mspin)=0.0_t_real
    onet(1_t_int:nvdim,1_t_int:nkp,1_t_int:mdim,1_t_int:nsort+1_t_int&
         &,1_t_int:mspin)=0.0_t_real
    If(bwdos)Then
       bgrs=0.0_t_real
       bnet=0.0_t_real
    Endif
    If(ldos% plotldos)Then
       lgrs=0.0_t_real
       lnet=0.0_t_real
    End If

!!$    Open(15,file='+ebk')


    dumpreadd=dumpread(DUMP_KS)
    dumpwritee=dumpwrite(DUMP_KS)
    If(dumpreadd)Then
       Open(dump_ks_unit,file=Trim(gdump(DUMP_KS)% fname),status='old'&
            &,form='UNFORMATTED')
       gdump(DUMP_KS)% doread=.False.
    Elseif(dumpwritee)Then
       Open(dump_ks_unit,file=Trim(gdump(DUMP_KS)% fname),form='UNFORMATTED')
    Endif



    If(wandata_out)Then
       !!
       wio=1
       wiu=nvdim
       If(bandplot% output_bands_in_window)Then
          !!TODO: works only for converged stuff
          wio=bandplot% lowest_in_window
          wiu=bandplot% highest_in_window
       Endif
       !!
       Open(wancoeff_unit,file=f_wancoeff_out)
       Write(wancoeff_unit,7719)
       Write(wancoeff_unit,7700) nsite,nkp,nvdim,wiu-wio+1,nspin,wio,wiu
    Endif
    !!
#if defined (TIME_KS)
    Call watch('KS-ccck',cpu_start,reset=.True.)
    Call watch('KS-ccck',cpu_stop)
#endif

    If(debexpBoltztrap)Then
       !!
       tmp(:,:)=Real(symmetry% rcentering(:,:),t_real)/12.0_t_real
       Call dinv33(tmp,1_t_int,tmpi,det)
       rbasis=Matmul(symmetry% lattice_vectors,tmpi)
       !!
       Print "('primtive real space lattice P1=',3f10.5)",symmetry% lattice_vectors(:,1)
       Print "('primtive real space lattice P2=',3f10.5)",symmetry% lattice_vectors(:,2)
       Print "('primtive real space lattice P3=',3f10.5,/)",symmetry% lattice_vectors(:,3)
       !!
       Print "('real space centering        B1=',3f10.5)"&
            &,symmetry% rcentering(:,1)/12.0_t_real
       Print "('real space centering        B2=',3f10.5)"&
            &,symmetry% rcentering(:,2)/12.0_t_real
       Print "('real space centering        B3=',3f10.5,/)"&
            &,symmetry% rcentering(:,3)/12.0_t_real
       !!
       Print "('conventional real space lattice C1=',3f10.5)",rbasis(:,1)
       Print "('conventional real space lattice C2=',3f10.5)",rbasis(:,2)
       Print "('conventional real space lattice C3=',3f10.5)",rbasis(:,3)
       !!
    Endif
    !!
    spinloop: Do ms=1_t_int,nspin
       !!
       If(debexpBoltztrap)Then
          Write(errbuf,10) 
          Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
10        Format("'boltztrap exort: k-points are exported in &
               &units of 2pi/a.'") 
          Write(fname,"('boltztrap.energy.',i1)") ms
          Open(27,file=Trim(fname),status='unknown')
          Do isa=1,nsite
             Write(27,"(f9.5)")0.0_t_real
             Write(27,"(f9.5)")0.0_t_real
          Enddo
       Endif
       !!
       !Print *,'ms=',ms
       !!
       If(wandata_out)Then
          Write(wancoeff_unit,7710)ms
       Endif
       !!
       !!
       !!
       !!
       !!
       subdiv=(Max(1_t_int,nkp/(100/10)));
       !!
       kloop: Do ik=1_t_int,nkp
          qq(:)=bzone% p_bk(:,ik)
          !! build Hamiltonian and overlap matrix

          If(debexpBoltztrap)Then
             !!
             kvec=Matmul(qq,rbasis)/twopi
             !!
             Write(27,"(3e19.12,i10,2i6,f5.1)")kvec(:),ik,nvdim,nband,1.0_t_real
             !!
          Endif
          
          If(wandata_out)Then
             Write(wancoeff_unit,7701)ik,qq
          Endif
          
!!$          Call dtest(structure,basis,kohnsham,loi,ms)
 
          If ( Mod(ik,subdiv) ==0 .Or. ik==1 .Or.ik==nkp)Then
             Write(outfile,"('DIAGONALIZATION: ',f6.2,'% done')") &
                  &100.0_t_real*ik/nkp
          Endif
          
          docalc=.True.
          If(dumpreadd)Then
             docalc=.Not.dumpks(nspin,nkp,ks,'read')
          Endif
          If(docalc)Then
             Call calc_at_kpoint(ks,ik,qq,ms,mspin&
                  &,structure,lattice,basis,loi,kohnsham&
                  &,lsdau,opc,relativistic)
          Endif
          If(dumpwritee)Then
             success=dumpks(nspin,nkp,ks,'write')
          Endif
          
          If((All(Abs(qq)<1.0e-5_t_real) .Or. .False.))Then
             Write(outfile,*) 
1            Format('K-vector ',i5,' : ',3f10.4)
             Write(outfile,1)ik,qq(1:3)
2            Format('Band energies at spin',i4)
             Write(outfile,2)ms
3            Format(5f14.7)
             Write(outfile,3)(ks% p_eb(in),in=1_t_int,nband)
          End If
          
          If(debexpBoltztrap)Then
             Do in=1,nband
                Write(27,"(i12,f19.14)")in,ks% p_eb(in)*2.0_t_real
             Enddo
          Endif

          If(wandata_out)Then
             !! ouput C^{+}*S 
             Write(wancoeff_unit,7705)
             Do in=wio,wiu
                Do iz=1,nvdim
                   cv=Dot_product(ks% p_hp(1:nvdim,in),ks% p_sp2(1:nvdim,iz))
                   Write(wancoeff_unit,7702,advance='no') cv
                Enddo
                Write(wancoeff_unit,7703)
             Enddo
             Write(wancoeff_unit,7703)
             Write(wancoeff_unit,7707)
             !! ouput C
             Do in=wio,wiu
                Do iz=1,nvdim
                   Write(wancoeff_unit,7702,advance='no') ks% p_hp(iz,in)
                Enddo
                Write(wancoeff_unit,7703)
             Enddo
             Write(wancoeff_unit,7703)
          Endif
          



          







          !!
          !!store eigenvalues for k-integration 
          kohnsham% p_ebk0(1_t_int:nvdim,ik,ms)=ks% p_eb(1_t_int:nvdim)
          !!STORE v-coeff
          If(.Not.kohnsham% DOS_savememory_onstep)Then
             Do in=1_t_int,nband
                Do iz=1_t_int,nvdim
                   kohnsham% p_ccvk(in,ik,iz,ms)=ks% p_hp(iz,in)
                Enddo               ! iz
             Enddo                 ! in
          Endif
          !!
          !!
          !!
          !!
          !!
          !!
          !!
          !!
          !! print 
          !Call printmat('Re C',zz(1,1,1),nvdim)
          !Call printmat('Im C',zz(1,1,2),nvdim)
          !!
#if defined (TIME_KS)
          Call watch('KS-occu',cpu_start)
#endif
          !!
          Call calc_occu(qq,symmetry,structure,nsite,mspin,rel&
               &,nvdim,kohnsham% p_vblockstart&
               &,kohnsham% p_vblocklength&
               &,basis,ldos,bwdos&
               &,wr,ks% p_hp,ks% p_sp2,ks% p_spbS,loi% p_vbSv0&
               &,ik,ms,ogrs,onet&
               &,lgrs,lnet,bgrs,bnet,Mnn(:,ik))
          !!
#if defined (TIME_KS)
          Call watch('KS-occu',cpu_stop)
#endif
          !!
          Call lsdau_calc_u_cs(lsdau,ks% p_sp2,ks% p_hp,nvdim,nband,ms,ik&
               &,ks% lsdau_kintest)
          !!
          !!
          Call opc_calc_o_cs(opc,ks% p_hp,nvdim,nband,ik)
          !!
          !!STORE c-coeff

#if defined (TIME_KS)
          Call watch('KS-ccck',cpu_start)
#endif
          
          If(.Not.kohnsham% DOS_savememory_onstep) Then
             Do in=1,nband
                Do iz=1,ncdim
                   ce=c0
                   Do iv=1,nvdim
                      ce=ce+ks% p_scrawv(iv,iz)*ks% p_hp(iv,in)
                   Enddo ! iv
                   kohnsham% p_ccck(in,ik,iz,ms)=-ce
                Enddo !iz
             Enddo !in
          Endif
          
#if defined (TIME_KS)
          Call watch('KS-ccck',cpu_stop)
#endif

       End Do kloop                   ! ik
!!$       Write(15,33)
!!$33     Format(' ') 
       If(debexpBoltztrap)Then
          Close(27)
       Endif
    End Do spinloop                     ! ms
!!$    Close(15)
    !!
!    Call check_RealatSym(symmetry,structure,basis,bzone,kohnsham,p_hk)
!    Call check_RealatSym_coeff(symmetry,structure,basis,bzone,kohnsham,p_hk)
    !!
    !!
    !!
    !!
    If(dumpreadd .Or. dumpwritee)Then
       Close(dump_ks_unit)
    Endif
    If(bzone% dospecial) goto 1234
    !!     -  search Fermy energy and weihgts
    
    Call det_bandweights(bzone,kohnsham% p_bweitk&
         &,kohnsham% p_ebk0,kohnsham% p_ebkfsm,Mnn&
         &,kohnsham% efermi,kohnsham% Bfsm,dBfsm&
         &,afm,nband,nkp,mspin,nspin,tolef,kohnsham% czval,kohnsham% fsm&
         &,kohnsham% fsm_moment&
         &,nvdim&
         &,bandenergy,Eent,rel,bandplot&
         &,symmetry% lattice_vectors,symmetry% Rnumops,symmetry% Ropmat&
         &,structure% vuc,dbweitk,calcfermisurfaceweights&
         &,calc_plasmon=(isoption('CALC_PLASMON_FREQ').Or.optics% active))
    !!
    If(kohnsham% fsm .and. relmag)Then
       !If(Abs(dBfsm)>1.0e-4_t_real) Goto 101
!!$       Write(outfile,"(/,' Bfsm=',f30.15,' Ha',/&
!!$            &           ,'     =',f30.15,' Tesla',/)")& 
!!$            &kohnsham% Bfsm,kohnsham% Bfsm*(hatoj/mubtojot)
    Endif
    !!
    If(wandata_out)Then
       Write(wancoeff_unit,7706)
       Do ms=1,nspin
          Write(wancoeff_unit,7711)ms,kohnsham% efermi
          Do ik=1,nkp
             Write(wancoeff_unit,7701)ik,bzone% p_bk(:,ik)
             Do in=wio,wiu
                Write(wancoeff_unit,7702) &
                     &(kohnsham% p_ebkfsm(in,ik,ms)-kohnsham% efermi)*hatoev&
                     &,kohnsham% p_bweitk(in,ik,ms)
             Enddo
             Write(wancoeff_unit,7703)
          Enddo
          Write(wancoeff_unit,7703)
       Enddo
    Endif
    !!
    If(wandata_out) Close(wancoeff_unit)
    !!
    !!
    !! print band weights
!!$    Open(12,file='+kwe')
!!$    Do ik=1,nkp
!!$       Write(12,121)ik,bzone% p_bk(1:3,ik)
!!$!       Write(outfile,*) 
!!$!       Write(outfile,21)ik,bzone% p_bk(1:3,ik)
!!$       Do ms=1,nspin
!!$          Write(12,122)ms
!!$!          Write(outfile,22)ms
!!$!          Write(outfile,3)(kohnsham% p_bweitk(in,ik,ms),in=1_t_int,nband)
!!$          Do in=1,nband
!!$             Write(12,"(2(e30.15e3,2x))") &
!!$                  &kohnsham% p_ebk0(in,ik,ms),kohnsham% p_bweitk(in,ik,ms)
!!$          Enddo
!!$       Write(12,*) 
!!$    Enddo
!!$    Enddo
!!$    Close(12)
!!$121 Format('# K-vector ',i5,' : ',3f10.4)
!!$21  Format('K-vector ',i5,' : ',3f10.4)
!!$122 Format('# Band weights at spin',i4)
!!$22  Format('Band weights at spin',i4)

    !!
    !!
    !!
    !Print *,'deviation=',deviation
    !Print *,'wsum=',wsum
    !If(deviation>0.0_t_real .And. Sqrt(deviation)<1.0e-5_t_real.And.&
    !     &bzone% kTcur>2.0_t_real)Then
    !   bzone% kTcur=Max(bzone% kTcur*0.80_t_real,2.0_t_real)
    !   restart=1_t_int
    !Endif
    If(deviation>0.0_t_real .And. Sqrt(deviation)<1.0e-4_t_real.And.&
         &bzone% kTcur>bzone% kTmin)Then
       bzone% kTcur=Max(bzone% kTcur*bzone% dkT,bzone% kTmin)
       restart=1_t_int
    Endif
    !!
    !!
    If( force_loop) Call calc_KS_forces(nspin,symmetry,structure,lattice&
         &,kohnsham,bzone,loi,ks% p_hcv,ks% p_scv,forces,lsdau)
    !!
    



    !!
    !!k-integrate density matrix
    Call  lsdau_calc_u_dmat(symmetry,structure% p_equivsites&
         &,structure% p_elements,lsdau,rel,nspin,mspin,nband,nkp&
         &,kohnsham% p_bweitk,ks% lsdau_kintest)
    !! make LSDA+U potential matrix from input density matrix
    Call lsdau_calc_u_potmat(lsdau,rel,structure% p_elements&
         &,nspin,mspin,energy=ks% lsdau_energy)

    !! jump back if dmat si deviating to much
    If( .Not. lsdau_norm_conv(lsdau,nspin) ) Goto 101

    If(wannier% do_wanniers) Then
       If(wannier% do_wannier_from_file)Then
          !!TODO:this is not good solution
          If(wan_jump) Then
             wan_jump=.False.
             wandata_out=.True.
             Goto 101
          Endif
       Endif
    Endif
    
    !!
    Call clean_WeightRot(wr)
    !!
    !!
    !!
    Call opc_calc_M_orb(structure,opc,nspin,nband,nkp,kohnsham% p_bweitk&
         &,relativistic)
    !!
    !!
    !!
    !!
    Call clean_KS(ks,lsdau,opc)
    !!
    !! output of molecular orbital analysis
    Call analyse_molorb(nspin,structure,basis,kohnsham,kohnsham% efermi&
         &,relativistic)
    !!
    !!
    !!
    Call optics_KS_assemble(nspin,structure,lattice,loi,&
       &bzone,kohnsham,optics,relativistic)
    !!
    !!
    !! calculate DOS and IDOS
    !!
    Call watch('KS-DOS',cpu_start,reset=.True.)
    !!
1234 Continue
    !!
    If(.Not.isoption('NO_DOS'))&
         &Call ndos(kohnsham% p_ebkfsm,bzone% p_tet,nvdim,nkp,mspin,nspin&
         &,bzone% ntet&
         &,bzone% ntetsum,bandplot% emax,bandplot% emin,kohnsham% efermi&
         &,nsort,ogrs,onet,mdim,ldos,bwdefactive,lgrs,lnet,bgrs,bnet&
         &,bandplot% plotbands&
         &,basis% nRvmx,basis% p_nRv,basis% p_nnRv,basis% p_kapRv&
         &,structure% p_isrt&
         &,rel,bandplot% nptdos,bandplot% plotidos,bzone% gammapoint&
         &,bzone% kTcur,bandplot% plotndos)
    !!
    Call pfree(lgrs)
    Call pfree(lnet)
    Call pfree(bgrs)
    Call pfree(bnet)
    !!
    Call watch('KS-DOS',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    !!
    If( bzone% dospecial)Then
       Write(errbuf,111) 
       Call errmsg(nmodule,nsubfunc,E_information,msg=errbuf)
111    Format("'special k-mesh for DOS use from file ''=.special_kmesh''',/&
            &,' must stop here!'") 
       Call terminate(TERM_NORMAL,'=.special_kmesh')
    Endif
    !!
    !! population analysis
    !!
    If(.Not.nopop)Then
       !! population analysis, new version

       Call palloc('net',net,1_t_int,nsite,1_t_int,basis% nRvmx&
            &,1_t_int,mspin,nmodule,nsubfunc)
       Call palloc('grs',grs,1_t_int,nsite,1_t_int,basis% nRvmx&
            &,1_t_int,mspin,nmodule,nsubfunc)


       net(1_t_int:nsite,1_t_int:basis% nRvmx,1_t_int:mspin)=0.0_t_real
       grs(1_t_int:nsite,1_t_int:basis% nRvmx,1_t_int:mspin)=0.0_t_real


       Call popa(mspin,nspin,nsite,structure% p_isrt&
            &,nsort,nkp,nband,nvdim&
            &,basis% nRvmx,basis% p_nRv,basis% p_kapRv&
            &,onet,ogrs,net,grs,kohnsham% p_bweitk,mdim,rel)

       Call prtanal(nvdim,net,grs,nsite,nsort,structure% p_isrt&
            &,structure% p_elements,structure% p_conao,natom,mspin&
            &,basis% nRvmx,basis% p_nRv,basis% p_nnRv,basis% p_kapRv&
            &,basis% p_corecharge)

       Call pfree(net)
       Call pfree(grs)
       !!
    End If
    !!
    Call pfree(ogrs)
    Call pfree(onet)
    Call pfree(Mnn)
    Call pfree(dbweitk)
    !!
    !Call print_resonaces(mspin,nsite,kohnsham,loi% p_oci_vHv,kohnsham% efermi)
    !!
#if defined (TIME_KS)
    Call watch('KS-ccck',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
#endif
    !!
    !!
    Return
    !!
7719 Format('# KS-function data-dump section')
7700 Format('# ',i5,6(' ',i10))
7710 Format('# spin= ',i5)
7711 Format('# spin= ',i5,' efermi=',e30.15e3)
7701 Format('# kpoint= ',i10,' k= ',3(e30.15e3,2x))
7705 Format('# C^{+}*S=')
7707 Format('# C=')
7703 Format()
7702 Format(2(e30.15e3,1x))
7706 Format('# e(k,n) f(k,n)=')
    !!
  End Subroutine calc_KS_states
  !!***********************************************************************
  Subroutine analyse_molorb(nspin,structure,basis,kohnsham,efermi&
       &,relativistic)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Integer(t_int),Intent(in)    :: nspin,relativistic
    Real(t_real),Intent(in)      :: efermi
    !!LOCAL
    Character(*),Parameter::nsubfunc="analyse_molorb"
    Logical(t_log) :: prtef,rel
    Integer(t_int) :: ib,ms,nvdim,isa,issa,iv,lv,iz,iw2,m,kapv,degv,jv
    Real(t_real)   :: w2,w2tol,wsum
    Character(10)  :: ang
    Integer(t_int),Pointer :: iwk(:)
    Character(100),Pointer :: p_wstr(:)
    Real(t_real),Pointer :: p_w2(:)
    !!
    If(structure% str_type /= STR_TYPE_MOLECULE) Return
    Nullify(p_w2,p_wstr,iwk)
    !!
    If(kohnsham% DOS_savememory_onstep)Then
       Write(errbuf,1110) 
       Call errmsg(nmodule,nsubfunc,E_information,msg=errbuf)
1110   Format("'debug option DOS_savememory_onstep was set in ''=.debug''',/&
            &,' molecular orbital analysis not possible!'") 
       Return
    Endif
    !!
    rel=(relativistic==FULL_RELATIVISTIC)
    !!
    w2tol=5.0e-2_t_real
    nvdim=kohnsham% nvdim
    !!
    Call palloc('iwk',iwk,1_t_int,nvdim,nmodule,nsubfunc)
    Call palloc('p_w2',p_w2,1_t_int,nvdim,nmodule,nsubfunc)
    Call palloc('p_wstr',p_wstr,1_t_int,nvdim,nmodule,nsubfunc)
    !!
    !! todo restrict to some bands
    !!
    !!
    Do ms=1,nspin
       If(rel)Then
          Write(outfile,19)
       Else
          Write(outfile,9)ms
       Endif
       prtef=.False.
       Do ib=1,kohnsham% nvdim
          If(.Not.prtef.And.kohnsham% p_ebkfsm(ib,1,ms)>efermi)Then
             Write(outfile,11)
             prtef=.True.
          Endif
          Write(outfile,10,advance='no') ib&
               &,(kohnsham% p_ebkfsm(ib,1,ms)-efermi)*hatoev&
               &,kohnsham% p_bweitk(ib,1,ms)
          
          wsum=Real(Dot_product(kohnsham% p_ccvk(ib,1,1:nvdim,ms)&
               &,kohnsham% p_ccvk(ib,1,1:nvdim,ms)),t_real)

          iz=0
          iw2=0
          isaloop: Do isa=1,structure% nsite
             issa=structure% p_isrt(isa)
             nloop:Do iv=1_t_int,basis% p_nRv(issa)
                kapv=basis% p_kapRv(iv,issa)
                degv=basis% p_degRv(iv,issa)
                lv=(Abs(2*kapv+1)-1)/2
                jv=2*Abs(kapv)-1
                maloop:Do m=1,degv
                   If(rel)Then
                      Write(ang,"(a,sp,i2,s,'/2')")&
                           &kapToString(kapv),2*(m-1)-jv
                   Else
                      Write(ang,"(a,sp,i2,s)")lqnchar(lv),m-lv-1
                   Endif
                   iz=iz+1
                   w2=Abs(kohnsham% p_ccvk(ib,1,iz,ms))**2/wsum
                   If(w2> w2tol)Then
                      iw2=iw2+1
                      p_w2(iw2)=w2
                      Write(p_wstr(iw2),14)&
                           &structure% p_elements(issa)&
                           &,Trim(intToChar10(isa))&
                           &,basis% p_nnRv(iv,issa),Trim(ang)&
                           &,Nint(w2*100,t_int)
                   Endif
                Enddo maloop
             Enddo nloop
          Enddo isaloop
          
          !!
          Call dshel2(1_t_int,iw2,p_w2,iwk,1.0e-12_t_real)
          Do iz=iw2,1,-1
             Write(outfile,"(a)",advance='no')Trim(p_wstr(iwk(iz)+1))
          Enddo
          Write(outfile,2)
          !!

       Enddo
    Enddo
    !!
    Call pfree(p_w2)
    Call pfree(iwk)
    Call pfree(p_wstr)
    !!
    !Stop
    !!
    Return
    !!
2   Format()
9   Format(30('='),'Spin  ',i2,30('='))
19  Format(68('='))
10  Format('Eigen state ',i7,' at ',f30.15,' eV f=',f10.5)
11  Format(t10,20('-'),'Chemical potential ',20('-'))
14  Format(1x,a2,'(',a,') ',i1,a,' [',i3,'%]')
    !!
  End Subroutine analyse_molorb
  !!***********************************************************************
  Subroutine calc_KS_forces(nspin,symmetry,structure,lattice&
       &,kohnsham,bzone,loi,hcv,scv,forces,lsdau)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bzone),Intent(in)     :: bzone 
    Type(T_Loi),Intent(in)       :: loi
    Type(T_Lsdau),Intent(in)     :: lsdau
    Type(T_Forces),Intent(inout) :: forces
    Integer(t_int),Intent(in)    :: nspin
    Complex(t_real),Pointer      :: scv (:,:)
    Complex(t_real),Pointer      :: hcv (:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="calc_KS_forces"
    Integer(t_int) :: nvdim,nchidim,nband,nsort,nsite,ms,ik,nkp,k,i,j,ic
    Integer(t_int) :: isa,istv,lev,lec,lecraw,istcraw,istc,ia,iz,in,iz1
    Integer(t_int) :: ioci,jops,isga
    Integer(t_int) :: isau,ib1,ib2,iva,ivb,iia,iib
    Real(t_real)   :: qq(3),fo(3),d
    Complex(t_real):: cnn,cee,cd
    Complex(t_real),Pointer   :: scv0 (:,:)
    Complex(t_real),Pointer   :: ghp  (:,:,:)
    Complex(t_real),Pointer   :: gsp  (:,:,:)
    Complex(t_real),Pointer   :: gscv (:,:,:)
    Complex(t_real),Pointer   :: ghcv (:,:,:)
    Complex(t_real),Pointer   :: ghcvr(:,:,:)
    Real(t_real),Pointer      :: fmat  (:,:)
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    !!NREL
    !!
    Real(t_real),Pointer :: p_oci_gvc(:,:)
    Real(t_real),Pointer :: p_tci_gvc(:,:)
    Real(t_real),Pointer :: p_oci_gvHc(:,:)
    Real(t_real),Pointer :: p_tci_gvHc(:,:)
    Real(t_real),Pointer :: p_oci_gvHcr(:,:)
    Real(t_real),Pointer :: p_tci_gvHcr(:,:)
    !!
    Nullify(ghp,gsp,gscv,ghcv,ghcvr,fmat,scv0)
    Nullify(p_oci_gvc,p_oci_gvHc,p_oci_gvHcr,p_tci_gvc,p_tci_gvHc,p_tci_gvHcr)
    !!
    If(kohnsham% DOS_savememory_onstep)Then
       Write(errbuf,10) 
       Call errmsg(nmodule,nsubfunc,E_information,msg=errbuf)
10     Format("'debug option DOS_savememory_onstep was set in ''=.debug''',/&
            &,' force will not be be calculated!'") 
       Return
    Endif
    !!
    Call watch('KS-force',cpu_start,reset=.True.)
    !!
    nchidim=kohnsham% nchidim
    nvdim=kohnsham% nvdim
    nband=kohnsham% nband
    nsort=structure% nsort
    nsite=structure% nsite
    nkp=bzone% nkp
    !!
!!$
!!$       Call watch('KS-force-flomatrix',cpu_start,reset=.True.)
!!$       Call watch('KS-force-flomatrix',cpu_stop)
!!$
!!$       Call watch('KS-force-gsphsp',cpu_start,reset=.True.)
!!$       Call watch('KS-force-gsphsp',cpu_stop)
!!$
!!$       Call watch('KS-force-foHfoS',cpu_start,reset=.True.)
!!$       Call watch('KS-force-foHfoS',cpu_stop)
!!$
!!$       Call watch('KS-force-foHfoS',cpu_start,reset=.True.)
!!$       Call watch('KS-force-foHfoS',cpu_stop)
!!$
!!$       Call watch('KS-force-inner',cpu_start,reset=.True.)
!!$       Call watch('KS-force-inner',cpu_stop)
!!$
!!$       Call watch('KS-force-hcc',cpu_start,reset=.True.)
!!$       Call watch('KS-force-hcc',cpu_stop)
!!$
!!$       Call watch('KS-force-prep',cpu_start,reset=.True.)
!!$       Call watch('KS-force-prep',cpu_stop)

!!$    Call watch('KS-force-LSDA+U',cpu_start,reset=.True.)
!!$    Call watch('KS-force-LSDA+U',cpu_stop)
    
    !!
    Call palloc('scv0',scv0,1_t_int,nchidim,1_t_int,nvdim,nmodule,nsubfunc)
    Call palloc('ghp',ghp,1_t_int,nvdim,1_t_int,nvdim&
         &,1_t_int,3_t_int,nmodule,nsubfunc)
    Call palloc('gsp',gsp,1_t_int,nvdim,1_t_int,nvdim&
         &,1_t_int,3_t_int,nmodule,nsubfunc)
    Call palloc('gscv',gscv,1_t_int,nchidim,1_t_int,nvdim&
         &,1_t_int,3_t_int,nmodule,nsubfunc)
    Call palloc('ghcv',ghcv,1_t_int,nchidim,1_t_int,nvdim&
         &,1_t_int,3_t_int,nmodule,nsubfunc)
    Call palloc('ghcvr',ghcvr,1_t_int,nvdim,1_t_int,nchidim&
         &,1_t_int,3_t_int,nmodule,nsubfunc)
    Call palloc('fmat',fmat,1_t_int,3_t_int,1_t_int,nsite&
         &,nmodule,nsubfunc)
    !!
    Call palloc("p_oci_gvc",p_oci_gvc,1_t_int,3_t_int&
         &,1_t_int,loi% ocivcdim,nmodule,nsubfunc)
    Call palloc("p_oci_gvHc",p_oci_gvHc,1_t_int,3_t_int&
         &,1_t_int,loi% ocivcdim,nmodule,nsubfunc)
    Call palloc("p_oci_gvHcr",p_oci_gvHcr,1_t_int,3_t_int&
         &,1_t_int,loi% ocivcdim,nmodule,nsubfunc)
    Call palloc("p_tci_gvc",p_tci_gvc,1_t_int,3_t_int&
         &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)
    Call palloc("p_tci_gvHc",p_tci_gvHc,1_t_int,3_t_int&
         &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)
    Call palloc("p_tci_gvHcr",p_tci_gvHcr,1_t_int,3_t_int&
         &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)
    !!
    !!
    fmat(:,:)=0.0_t_real
    !!
    !!
    fspinloop: Do ms=1,nspin
       !!
       Call mol_core_trans_gcv(structure,lattice,kohnsham,loi&
            &,ms&
            &,p_oci_gvc,p_tci_gvc&
            &,p_oci_gvHc,p_tci_gvHc&
            &,p_oci_gvHcr,p_tci_gvHcr)
       !!
       fkloop: Do ik=1,nkp
          qq(:)=bzone% p_bk(:,ik)
          !Print *,100.0_t_real*ik/nkp
          !!
          !!
          !Call watch('KS-force-flomatrix',cpu_start)
          
          Call flomatrix(nsite,nvdim,nchidim&
               &,kohnsham% p_chiblockstart,kohnsham% p_chiblockend&
               &,kohnsham% p_vblockstart,kohnsham% p_vblockend&
               &,lattice% p_npairs,lattice% p_pairs,qq,ghp,gsp&
               &,ghcv,ghcvr,gscv&
               &,hcv,scv&
               &,loi% p_oci_vHchi(:,ms),loi% p_oci_vchi(:,ms)&
               &,loi% p_tci_vHchi(:,ms),loi% p_tci_vchi(:,ms)&
               &,loi% p_oci_gvHv(:,:,ms),loi% p_oci_gvv0&
               &,loi% p_tci_gvHv(:,:,ms),loi% p_tci_gvv0&
               &,p_oci_gvHc,p_oci_gvHcr,p_oci_gvc&
               &,p_tci_gvHc,p_tci_gvHcr,p_tci_gvc&
               &,loi% p_ocivvindex,loi% p_tcivvindex&
               &,loi% p_ocivcindex,loi% p_tcivcindex)
          !Call watch('KS-force-flomatrix',cpu_read,Stop=.True.)
          
          !!
          !!
          !!
          !Call watch('KS-force-gsphsp',cpu_start)
          
          !!
          
          !!
          
          !!
          Do k=1,3
             Do i=1_t_int,nvdim
                Do j=1_t_int,nvdim
                   !! S_dvc(i,ic)*S_cv(ic,j)=S_cdv(ic,i)^(*) *S_cv(ic,j) 
                   cnn=c0
                   cee=c0
                   Do ic=1,nchidim
                      cd=Conjg(gscv(ic,i,k))*scv(ic,j)
                      cnn=cnn+cd
                      cee=cee+cd*kohnsham% p_hc(ic,ms)
                   Enddo
                   gsp (i,j,k)=gsp (i,j,k)-cnn
                   ghp (i,j,k)=ghp (i,j,k)+cee&
                        &-Dot_product(ghcv(1:nchidim,i,k)&
                        &            ,scv(1:nchidim,j))&
                        &-Dot_product(gscv(1:nchidim,i,k)&
                        &            ,hcv(1:nchidim,j))
                   
                Enddo
             Enddo!
          Enddo !
          !Call watch('KS-force-gsphsp',cpu_read,Stop=.True.)
          !!

          !! LSDA+U
          If (lsdau% lsdau .And.&
               & (lsdau% projection == LSDAU_GROSS ) )Then
             !Call watch('KS-force-LSDA+U',cpu_start)
             !!
             !! Re delta gsp*(cfc(+) * pvp)
             !!        iva  iz       ivb iva
             Do isau=1,lsdau% nusite
                isa=lsdau% p_isiteu(isau)
                ib1=lsdau% p_ubi1(isau) !! start index of u-block
                ib2=lsdau% p_ubi2(isau) !! end   index of u-block
                Do iva=ib1,ib2
                   iia=iva-ib1+1
                   !!
                   Do ivb=ib1,ib2
                      iib=ivb-ib1+1
                      Do iz=1,nvdim
                         cnn=c0
                         Do in=1,nband
                            cnn=cnn+kohnsham% p_ccvk(in,ik,iz,ms)&
                                 &*kohnsham% p_bweitk(in,ik,ms)&
                                 &*Conjg(kohnsham% p_ccvk(in,ik,ivb,ms))
                         Enddo
                         !!
                         fmat(:,isa)=fmat(:,isa)&
                              &+Real(gsp(iva,iz,:)*cnn&
                              &*lsdau% p_vmat(iib,iia,isau,ms),t_real)
                      Enddo ! iz
                   Enddo !!ivb
                Enddo !!iva
             Enddo !! isau
             !!
             !!
             !! Re gsp*( +pvp cfc+)
             !!   ia   ivb iva   ia
             Do isa=1,nsite
                istv=kohnsham% p_vblockstart(isa)-1
                lev=kohnsham% p_vblocklength(isa)
                !!
                Do ia=istv+1,istv+lev
                   Do isau=1,lsdau% nusite
                      ib1=lsdau% p_ubi1(isau) !! start index of u-block
                      ib2=lsdau% p_ubi2(isau) !! end   index of u-block
                      Do ivb=ib1,ib2
                         iib=ivb-ib1+1
                         Do iva=ib1,ib2
                            iia=iva-ib1+1
                            !!
                            cnn=c0
                            Do in=1,nband
                               cnn=cnn+kohnsham% p_ccvk(in,ik,iva,ms)&
                                    &*kohnsham% p_bweitk(in,ik,ms)&
                                    &*Conjg(kohnsham% p_ccvk(in,ik,ia,ms))
                            Enddo
                            !!
                            fmat(:,isa)=fmat(:,isa)&
                                 &+Real(gsp(ia,ivb,:)&
                                 &*lsdau% p_vmat(iib,iia,isau,ms)&
                                 &*cnn,t_real)
                         Enddo ! iva
                      Enddo !!ivb
                   Enddo !! isau
                Enddo !! ia
             Enddo !! isa
             !!
             !!
             !!
             !Call watch('KS-force-LSDA+U',cpu_read,Stop=.True.)
             !!
          Endif
          !!
          !Call watch('KS-force-prep',cpu_start)

          scv0=scv

          Do ic=1,nchidim
             scv(ic,1:nband)=Matmul(scv(ic,1:nvdim)&
                  &,Transpose(kohnsham% p_ccvk(1:nband,ik,1:nvdim,ms)))
          Enddo
          
          Do ic=1,nchidim
             hcv(ic,1:nband)=Matmul(hcv(ic,1:nvdim)&
                  &,Transpose(kohnsham% p_ccvk(1:nband,ik,1:nvdim,ms)))
          Enddo
          !!
          Do k=1,3
             Do ic=1,nchidim
                ghcvr(1:nvdim,ic,k)=ghcvr(1:nvdim,ic,k)&
                     &-kohnsham% p_hc(ic,ms)*gscv(ic,1:nvdim,k)
             Enddo
          Enddo
          !!
          Do k=1,3
             Do ic=1,nchidim
                ghcvr(1:nband,ic,k)=kohnsham% p_bweitk(1:nband,ik,ms)&
                     &*Matmul(kohnsham% p_ccvk(1:nband,ik,1:nvdim,ms)&
                     &,ghcvr(1:nvdim,ic,k))
             Enddo
          Enddo
          !!
          If (lsdau% lsdau .And.&
               & (lsdau% projection == LSDAU_GROSS ) )Then

             !! Re gSvc*delta*Scv(  cfc(+) * pvp )
             !!   ivb     ic      iz       iva ivb 
             !!
             !!
             Do isa=1,nsite
                lec=kohnsham% p_chiblocklength(isa)
                istc=kohnsham% p_chiblockstart(isa)-1
                Do ic=istc+1,istc+lec
                   Do isau=1,lsdau% nusite
                      ib1=lsdau% p_ubi1(isau) !! start index of u-block
                      ib2=lsdau% p_ubi2(isau) !! end   index of u-block
                      Do ivb=ib1,ib2
                         iib=ivb-ib1+1
                         
                         Do iva=ib1,ib2
                            iia=iva-ib1+1
                            
                            
                            cnn=c0
                            Do in=1,nband
                               cnn=cnn&
                                    &+scv(ic,in)&
                                    &*kohnsham% p_bweitk(in,ik,ms)&
                                    &*Conjg(kohnsham% p_ccvk(in,ik,iva,ms))
                            Enddo
                            
                            fmat(:,isa)=fmat(:,isa)&
                                 &+Real(Conjg(gscv(ic,ivb,:))&
                                 &*lsdau% p_vmat(iia,iib,isau,ms)&
                                 &*cnn,t_real)
                         Enddo ! iva
                      Enddo ! ivb
                   Enddo ! isau
                Enddo ! ic
             Enddo ! isa
             
          Endif
          !!
          Do k=1,3
             Do ic=1,nchidim
                gscv(ic,1:nband,k)=kohnsham% p_bweitk(1:nband,ik,ms)&
                     &*Matmul(gscv(ic,1:nvdim,k)&
                     &,Transpose(kohnsham% p_ccvk(1:nband,ik,1:nvdim,ms)))
             Enddo
          Enddo
          !!
          !!
          !Call watch('KS-force-prep',cpu_read,Stop=.True.)
          

          If (lsdau% lsdau .And.&
               & (lsdau% projection == LSDAU_GROSS ) )Then
             
             !! Re gSvc*delta*Scv( pvp cfc+)
             !!   iz      ic     iva ivb iz
             !!
             Do isa=1,nsite
                lec=kohnsham% p_chiblocklength(isa)
                istc=kohnsham% p_chiblockstart(isa)-1
                Do ic=istc+1,istc+lec
                   
                   Do isau=1,lsdau% nusite
                      ib1=lsdau% p_ubi1(isau) !! start index of u-block
                      ib2=lsdau% p_ubi2(isau) !! end   index of u-block
                      Do iva=ib1,ib2
                         iia=iva-ib1+1
                         
                         Do ivb=ib1,ib2
                            iib=ivb-ib1+1
                            
                            Do k=1,3
                               cnn=c0
                               Do in=1,nband
                                  cnn=cnn+Conjg(gscv(ic,in,k))&
                                       &*kohnsham% p_ccvk(in,ik,ivb,ms)
                               Enddo
                            
                               fmat(k,isa)=fmat(k,isa)&
                                    &+Real(scv0(ic,iva)&
                                    &*lsdau% p_vmat(iia,iib,isau,ms)&
                                    &*cnn,t_real)
                            Enddo! k
                            
                         Enddo ! ivb
                      Enddo ! iva
                   Enddo ! isau
                Enddo! ic
             Enddo! isa
             !!

          Endif
          !!
          !!
          !!
          !Call watch('KS-force-foHfoS',cpu_start)
          
          Do isa=1,nsite
             istv=kohnsham% p_vblockstart(isa)-1
             lev=kohnsham% p_vblocklength(isa)
             lec=kohnsham% p_chiblocklength(isa)
             lecraw=kohnsham% p_cblocklength(isa)
             istcraw=kohnsham% p_cblockstart(isa)-1
             istc=kohnsham% p_chiblockstart(isa)-1
             !!
             fo(:)=0.0_t_real
             Do ia=istv+1,istv+lev
                Do iz=1,nvdim
                   cnn=c0
                   cee=c0
                   Do in=1,nband
                      cd=kohnsham% p_ccvk(in,ik,iz,ms)&
                           &*Conjg(kohnsham% p_ccvk(in,ik,ia,ms))&
                           &*kohnsham% p_bweitk(in,ik,ms)
                      cnn=cnn+cd
                      cee=cee+cd*kohnsham% p_ebk0(in,ik,ms)
                      !!todo: if FREL FSM  ->Mnn Pulay, and ebkfsm?
                   Enddo
                   Do k=1,3
                      fo(k)=fo(k)+Real(ghp(ia,iz,k)*cnn,t_real)&
                           &       -Real(gsp(ia,iz,k)*cee,t_real)
                   Enddo
                Enddo ! iz
             Enddo ! ia
             !!
             !Call watch('KS-force-foHfoS',cpu_read,Stop=.True.)
             
             !!TODO: does not work for enlarged core-set !!!
             !!
             !Call watch('KS-force-inner',cpu_start)
             
             !!
             
             Do ic=istc+1,istc+lec
                !! 
                Do k=1,3
                   Do in=1,nband
                      
                      fo(k)=fo(k)+Real(&
                           &(   Conjg(ghcvr(in,ic,k))&
                           &  -kohnsham% p_ebk0(in,ik,ms)&
                           !!todo: if FREL FSM  ->Mnn Pulay, and ebkfsm?
                           &    *Conjg(gscv(ic,in,k))&
                           &)*scv(ic,in)&
                           &,t_real)
                      
                   Enddo
                Enddo
             Enddo
             
             
             Do ic=istc+1,istc+lec
                !! 
                Do k=1,3
                   Do in=1,nband
                      
                      fo(k)=fo(k)+Real(&
                           &Conjg(gscv(ic,in,k))*hcv(ic,in)&
                           &,t_real)
                   Enddo
                Enddo
             Enddo
             
             
             
             !Call watch('KS-force-inner',cpu_read,Stop=.True.)
             
             !!
             !Call watch('KS-force-hcc',cpu_start)
             
             ioci=loi% p_ociccindex(isa)
             Do iz1=1,lecraw
                Do iz=1,lecraw
                   d=0.0_t_real
                   Do in=1,nband
                      d=d+Real(&
                           &Conjg(kohnsham% p_ccck(in,ik,istcraw+iz1,ms))&
                           &*kohnsham% p_ccck(in,ik,istcraw+iz,ms),t_real)&
                           &*kohnsham% p_bweitk(in,ik,ms)
                   Enddo
                   ioci=ioci+1
                   fo(:)=fo(:)+d*loi% p_oci_gcHc(:,ioci,ms)
                Enddo
             Enddo
             !!
             !Call watch('KS-force-hcc',cpu_read,Stop=.True.)
             
             !!
             !!
             !!
             fmat(1:3,isa)=fmat(1:3,isa)+fo(1:3)*2.0_t_real
          Enddo ! isa
          !!
          !!
          
       End Do fkloop
    End Do fspinloop
    
    !!
    Do isa=1,nsite
       
       If(isoption('FULLBZ'))Then
          forces% p_plforces(:,isa)=fmat(:,isa)
       Else
          forces% p_plforces(:,isa)=0.0_t_real
          Do jops=1,symmetry% Rnumops
             isga=structure% p_equivsites(jops,isa)
             forces% p_plforces(:,isa)=forces% p_plforces(:,isa)&
                  &+Matmul(symmetry% Ropmat(:,:,jops),fmat(:,isga))&
                  &/symmetry% Rnumops
          Enddo
       Endif
       
    Enddo

    
    !!
    Call pfree(p_oci_gvc)
    Call pfree(p_oci_gvHc)
    Call pfree(p_oci_gvHcr)
    Call pfree(p_tci_gvc)
    Call pfree(p_tci_gvHc)
    Call pfree(p_tci_gvHcr)
    !!
    Call pfree(ghcv)
    Call pfree(ghcvr)
    Call pfree(gscv)
    Call pfree(gsp)
    Call pfree(ghp)
    Call pfree(fmat)
    Call pfree(scv0)
    !!
    !Call watch('KS-force-hcc',cpu_read,delete=.True.,Print=.True.&
    !     &,mesg='Total ')
    !Call watch('KS-force-inner',cpu_read,delete=.True.,Print=.True.&
    !     &,mesg='Total ')
    !Call watch('KS-force-foHfoS',cpu_read,delete=.True.,Print=.True.&
    !     &,mesg='Total ')
    !Call watch('KS-force-gsphsp',cpu_read,delete=.True.,Print=.True.&
    !     &,mesg='Total ')
    !Call watch('KS-force-prep',cpu_read,delete=.True.,Print=.True.&
    !     &,mesg='Total ')
    !Call watch('KS-force-flomatrix',cpu_read,delete=.True.&
    !     &,Print=.True.,mesg='Total ')
    !Call watch('KS-force-LSDA+U',cpu_read,delete=.True.&
    !     &,Print=.True.,mesg='Total ')
    
    Call watch('KS-force',cpu_stop,delete=.True.,Print=.True.)
    !!FORCES
    !!
    !!
    Return
    !!
  End Subroutine calc_KS_forces

  !!***********************************************************************
  !! 
  !! set up dimensions for cofficients and band energies
  !!
  Subroutine coefdef(structure,mspin,nkp,basis,BEB,kohnsham,relativistic)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in)   :: structure
    Type(T_Basis),Intent(in)       :: basis
    Type(T_Kohnsham),Intent(inout) :: kohnsham
    Logical(t_log),Intent(in) ::  BEB
    Integer(t_int),Intent(in) :: relativistic
    Integer(t_int),Intent(in) :: mspin,nkp
    !!LOCAL
    Character(*),Parameter::nsubfunc="coefdef"
    Integer(t_int) :: isa,issa,nvs,ncs,nchis,nbeb,mv,mc,mchi,relfac,nspin,nb
    Integer(t_int) :: ii,ivr
    !!
    !!
    nspin=mspin
    relfac=1_t_int
    If(relativistic==FULL_RELATIVISTIC)Then
       relfac=2_t_int
       nspin=1_t_int
    Endif
    !!
    kohnsham % nvdim=0_t_int ! dimension of valence part
    kohnsham % ncdim=0_t_int ! dimension of core part
    kohnsham % nchidim=0_t_int ! dimension of core part
    kohnsham % nvsmx=0_t_int ! max valence dimension of a single atom
    kohnsham % ncsmx=0_t_int ! max core dimension of a single atom
    kohnsham % nchismx=0_t_int ! max true core dimension of a single atom

    Call palloc('kohnsham % p_vblockstart',kohnsham % p_vblockstart&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc('kohnsham % p_vblockend',kohnsham % p_vblockend&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc('kohnsham % p_vblocklength',kohnsham % p_vblocklength&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)


    Call palloc('kohnsham % p_cblockstart',kohnsham % p_cblockstart&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc('kohnsham % p_cblockend',kohnsham % p_cblockend&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc('kohnsham % p_cblocklength',kohnsham % p_cblocklength&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)

    Call palloc('kohnsham % p_chiblockstart',kohnsham % p_chiblockstart&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc('kohnsham % p_chiblockend',kohnsham % p_chiblockend&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc('kohnsham % p_chiblocklength',kohnsham % p_chiblocklength&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)


    Call palloc('kohnsham % p_vivrind',kohnsham % p_vivrind&
         &,1_t_int,basis%  nRvmx&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc('kohnsham % p_vnlind',kohnsham % p_vnlind&
         &,1_t_int,basis%  nRvmx&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)

    mv=1_t_int
    mc=1_t_int
    mchi=1_t_int
    ii=1
    Do isa=1_t_int,structure % nsite
       issa=structure % p_isrt(isa)
       !! valence
       Do ivr=1,basis% p_nRv(issa)
          kohnsham% p_vivrind(ivr,isa)=ii
          kohnsham% p_vnlind(ivr,isa)=ii
          If(relfac==2.And.&
               &basis% p_kapRv(ivr,issa)<0.And.basis% p_kapRv(ivr,issa)/=-1)&
               &kohnsham% p_vnlind(ivr,isa)=kohnsham% p_vivrind(ivr-1,isa)
          ii=ii+basis% p_degRv(ivr,issa)
       Enddo
       !!
       kohnsham % p_vblockstart(isa)=mv
       !!
       nvs=Sum(basis% p_degRv(1_t_int:basis% p_nRv(issa),issa))
       !!
       kohnsham % nvdim=kohnsham % nvdim+nvs
       kohnsham % p_vblocklength(isa)=nvs
       mv=mv+nvs
       kohnsham % p_vblockend(isa)=mv-1
       kohnsham % nvsmx=Max(kohnsham % nvsmx,nvs)
       !! core
       kohnsham % p_cblockstart(isa)=mc
       kohnsham % p_chiblockstart(isa)=mchi
       !!
       ncs=Sum(basis% p_degRc(1_t_int:basis% p_nRc(issa),issa))
       nchis=Sum(basis% p_degRc(1_t_int:basis% p_nRchi(issa),issa))
       !!
       kohnsham % ncdim=kohnsham % ncdim+ncs
       kohnsham % nchidim=kohnsham % nchidim+nchis
       kohnsham % p_cblocklength(isa)=ncs
       kohnsham % p_chiblocklength(isa)=nchis
       mc=mc+ncs
       mchi=mchi+nchis
       kohnsham % p_cblockend(isa)=mc-1
       kohnsham % p_chiblockend(isa)=mchi-1
       kohnsham % ncsmx=Max(kohnsham % ncsmx,ncs)
       kohnsham % nchismx=Max(kohnsham % nchismx,nchis)
    Enddo
    !!
    !! number of occupied bands
    !!
    nb=kohnsham% io_nband*relfac
    If(nb <= 0_t_int) nb=kohnsham % nvdim

    kohnsham% nband=Min(nb,kohnsham % nvdim)

    Write(outfile,10)
    Write(outfile,11)kohnsham % nvdim
    Write(outfile,14)kohnsham % ncdim
    Write(outfile,12)kohnsham % nvsmx
    Write(outfile,13)kohnsham % ncsmx
    Write(outfile,15)kohnsham% nband
    Write(outfile,16)nkp
    If(BEB) Then
       nbeb=kohnsham % nvdim*kohnsham % nvdim*nkp*2_t_int*nspin
    Else
       nbeb=nspin*kohnsham % nvdim*kohnsham% nband*nkp*2_t_int
    Endif
    Write(outfile,17)nbeb

    If(BEB) Then
       Call palloc('kohnsham % p_ccvkbeb',kohnsham % p_ccvkbeb &
            &,1_t_int,kohnsham% nvdim &
            &,1_t_int,kohnsham% nvdim &
            &,1_t_int,nkp &
            &,1_t_int,nspin &
            &,nmodule,nsubfunc)

       Call palloc('kohnsham % p_ncvbeb',kohnsham % p_ncvbeb &
            &,1_t_int,kohnsham% ncdim &
            &,1_t_int,kohnsham% nvdim &
            &,1_t_int,nspin &
            &,nmodule,nsubfunc)

    Else

       Call palloc('kohnsham % p_ccvkbeb',kohnsham % p_ccvkbeb,1_t_int,1_t_int &
            &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
       Call palloc('kohnsham % p_ncvbeb',kohnsham % p_ncvbeb,1_t_int,1_t_int &
            &,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
       
       If(.Not.kohnsham% DOS_savememory_onstep)Then
          Call palloc('kohnsham % p_ccvk',kohnsham % p_ccvk &
               &,1_t_int,kohnsham% nband &
               &,1_t_int,nkp &
               &,1_t_int,kohnsham% nvdim &
               &,1_t_int,nspin &
               &,nmodule,nsubfunc)
       Endif
    End If


    If(BEB) Then
       nbeb=kohnsham % ncdim*kohnsham % nvdim*nkp*2_t_int*nspin
    Else
       nbeb=nspin*kohnsham % ncdim*kohnsham% nband*nkp*2_t_int
    Endif
    Write(outfile,18)nbeb
    If(BEB) Then

       Call palloc('kohnsham % p_ccckbeb',kohnsham % p_ccckbeb &
            &,1_t_int,kohnsham% ncdim &
            &,1_t_int,kohnsham% nvdim &
            &,1_t_int,nkp &
            &,1_t_int,nspin &
            &,nmodule,nsubfunc)

       Call palloc('kohnsham % p_nccbeb',kohnsham % p_nccbeb &
            &,1_t_int,kohnsham% ncdim &
            &,1_t_int,kohnsham% ncdim &
            &,1_t_int,nspin &
            &,nmodule,nsubfunc)

    Else
       Call palloc('kohnsham % p_ccckbeb',kohnsham % p_ccckbeb,1_t_int,1_t_int &
            &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
       Call palloc('kohnsham % p_nccbeb',kohnsham % p_nccbeb,1_t_int,1_t_int &
            &,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)

       If(.Not.kohnsham% DOS_savememory_onstep)Then
          Call palloc('kohnsham % p_ccck',kohnsham % p_ccck &
               &,1_t_int,kohnsham% nband &
               &,1_t_int,nkp &
               &,1_t_int,kohnsham% ncdim &
               &,1_t_int,nspin &
               &,nmodule,nsubfunc)
       Endif
       

       If(relativistic==FULL_RELATIVISTIC)Then
          Call palloc('kohnsham% p_ronvv',kohnsham% p_ronvv&
               &,1_t_int,kohnsham% nvsmx,1_t_int,kohnsham% nvsmx&
               &,1_t_int,structure% nsite,1_t_int,nspin&
               &,nmodule,nsubfunc)
          Call palloc('kohnsham% p_roncv',kohnsham% p_roncv&
               &,1_t_int,kohnsham% ncsmx,1_t_int,kohnsham% nvsmx&
               &,1_t_int,structure% nsite,1_t_int,nspin&
               &,nmodule,nsubfunc)
          Call palloc('kohnsham% p_roncc',kohnsham% p_roncc&
               &,1_t_int,kohnsham% ncsmx,1_t_int,kohnsham% ncsmx&
               &,1_t_int,structure% nsite,1_t_int,nspin&
               &,nmodule,nsubfunc)
          
       Else          
          Call palloc('kohnsham% p_nonvv',kohnsham% p_nonvv&
               &,1_t_int,kohnsham% nvsmx,1_t_int,kohnsham% nvsmx&
               &,1_t_int,structure% nsite,1_t_int,nspin,nmodule,nsubfunc)
          Call palloc('kohnsham% p_noncv',kohnsham% p_noncv&
               &,1_t_int,kohnsham% ncsmx,1_t_int,kohnsham% nvsmx&
               &,1_t_int,structure% nsite,1_t_int,nspin,nmodule,nsubfunc)
          Call palloc('kohnsham% p_noncc',kohnsham% p_noncc&
               &,1_t_int,kohnsham% ncsmx,1_t_int,kohnsham% ncsmx&
               &,1_t_int,structure% nsite,1_t_int,nspin,nmodule,nsubfunc)
       Endif
    End If


    !! band energies are needed for all bands (DOS) ->nvdim

    Call palloc('kohnsham % p_ebk0',kohnsham % p_ebk0  &
         &,1_t_int,kohnsham% nvdim &
         &,1_t_int,nkp &
         &,1_t_int,nspin &
         &,nmodule,nsubfunc)

    If(kohnsham% fsm)Then
       Call palloc('kohnsham % p_ebkfsm',kohnsham % p_ebkfsm  &
            &,1_t_int,kohnsham% nvdim &
            &,1_t_int,nkp &
            &,1_t_int,nspin &
            &,nmodule,nsubfunc)
    Else
       kohnsham % p_ebkfsm => kohnsham % p_ebk0
    Endif


    !! only occupied bands play role -> nband which may be smaller than 
    !! nvdim

    Call palloc('kohnsham % p_bweitk',kohnsham % p_bweitk  &
         &,1_t_int,kohnsham% nband &
         &,1_t_int,nkp &
         &,1_t_int,nspin &
         &,nmodule,nsubfunc)


    kohnsham % p_bweitk(:,:,:)=0.0_t_real

    !!  the core-diagonalization energies
    !!  
    Call palloc('kohnsham % p_hc',kohnsham % p_hc  &
         &,1_t_int,kohnsham% nchidim &
         &,1_t_int,nspin &
         &,nmodule,nsubfunc)
    !! core occus
    Call palloc('kohnsham % p_coccu',kohnsham % p_coccu  &
         &,1_t_int,kohnsham% nchismx &
         &,1_t_int,structure% nsite &
         &,1_t_int,nspin &
         &,nmodule,nsubfunc)
    !! the core-diagonalization coefficients
    !!
    If(relativistic==FULL_RELATIVISTIC)Then
       Call palloc('kohnsham % p_rczz',kohnsham % p_rczz  &
            &,1_t_int,kohnsham% ncsmx  &
            &,1_t_int,kohnsham% nchismx &
            &,1_t_int,structure% nsite &
            &,nmodule,nsubfunc)
       Call palloc('kohnsham % p_rcfc',kohnsham % p_rcfc  &
            &,1_t_int,kohnsham% ncsmx  &
            &,1_t_int,kohnsham% ncsmx  &
            &,1_t_int,structure% nsite &
            &,nmodule,nsubfunc)
    Else
       Call palloc('kohnsham % p_nczz',kohnsham % p_nczz  &
            &,1_t_int,kohnsham% ncsmx  &
            &,1_t_int,kohnsham% nchismx &
            &,1_t_int,structure% nsite &
            &,1_t_int,mspin &
            &,nmodule,nsubfunc)
       Call palloc('kohnsham % p_ncfc',kohnsham % p_ncfc  &
            &,1_t_int,kohnsham% ncsmx  &
            &,1_t_int,kohnsham% ncsmx  &
            &,1_t_int,structure% nsite &
            &,1_t_int,mspin &
            &,nmodule,nsubfunc)
    Endif

1   Format(72('-'),/,t25,'matrix index structure',/,72('-'))
    Write(outfile,1)
2   Format('               core block')
    Write(outfile,2)
3   Format(' site  El start_index  end_index  length ')
    Write(outfile,3)
    Do isa=1_t_int,structure% nsite
4      Format(t1,i5,2x,a2,1x,t12,i5,t24,i5,t34,i5)
       Write(outfile,4)&
            &isa,structure% p_elements(structure% p_isrt(isa))&
            &,kohnsham% p_cblockstart(isa),kohnsham% p_cblockend(isa)&
            &,kohnsham% p_cblocklength(isa)
    Enddo
5   Format('              valence block')
    Write(outfile,5)
6   Format(' site  El start_index  end_index  length ')
    Write(outfile,6)
    Do isa=1_t_int,structure% nsite
7      Format(t1,i5,2x,a2,1x,t12,i5,t24,i5,t34,i5)
       Write(outfile,7)&
            &isa,structure% p_elements(structure% p_isrt(isa))&
            &,kohnsham% p_vblockstart(isa),kohnsham% p_vblockend(isa)&
            &,kohnsham% p_vblocklength(isa)
    Enddo
8   Format(72('-'),/)
    Write(outfile,8)

    Return
    !!
10  Format('DIMENSIONS OF MATRICES')
11  Format('valence matrix dimension              ',i12)
14  Format('core    matrix dimension              ',i12)
12  Format('max number of valence states per atom ',i12)
13  Format('max number of core    states per atom ',i12)
15  Format('max number of bands                   ',i12)
16  Format('    number of k-points                ',i12)
17  Format('size of v-v coefficient matrix        ',i12)
18  Format('size of c-v coefficient matrix        ',i12)
    !!
  End Subroutine coefdef
  !!***********************************************************************
 Subroutine create_bandstructure(mspin,structure,lattice,nspin,basis,kohnsham&
       &,bandplot,bzone,lattice_constants,loi,lsdau,relativistic&
       &,opc,wannier,unfold,bwdefs,stm,optics,quant)
    Implicit None 
    !!IO
    Type(T_Quant),Intent(in) :: quant!!todo: remove
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)  :: lattice
    Type(T_Unfold),Intent(in)   :: unfold
    Type(T_STM),Intent(inout)   :: stm
    Type(T_Optics),Intent(in)   :: optics
    Type(T_BWDefs),Intent(in)   :: bwdefs
    Type(T_Kohnsham),Intent(in) :: kohnsham
    Type(T_Bandplot),Intent(in) :: bandplot
    Type(T_Bzone),Intent(in)    :: bzone
    Type(T_Lsdau),Intent(inout) :: lsdau 
    Type(T_Basis),Intent(in)    :: basis
    Type(T_Loi),Intent(inout)   :: loi
    Type(T_OPC),Intent(inout)   :: opc
    Type(T_Wannier),Intent(in)  :: wannier
    Integer(t_int),Intent(in)   :: relativistic
    Integer(t_int),Intent(in)   :: mspin,nspin
    Real(t_real),Intent(in)     :: lattice_constants(3)
    !!LOCAL
    Character(*),Parameter::nsubfunc="create_bandstructure"
    Character(*),Parameter :: cpumesg=' bandstructure plot'
    Logical(t_log)       :: emptyLtest,rel,relmag
    Logical(t_log) :: write_band_window_info
    Integer(t_int) :: ik,ms,i,in,iz,j,io,iu,nw
    Integer(t_int) :: ii,nchidim,ncdim,nvdim,iw,nsite
    Integer(t_int) :: jj
    Real(t_real)  :: qq(3),eunit,fact,scale,sofms!,d
    Complex(t_real):: cv
    Real(t_real),Pointer :: p_oci_gcc(:,:,:)
    Real(t_real),Pointer :: p_oci_gvc(:,:,:)
    Real(t_real),Pointer :: p_tci_gvc(:,:,:)
    Complex(t_real),Pointer:: p_pmat(:,:,:)
    !!
    !!
    !!
    Logical(t_log) :: wancoeff_out
    Logical(t_log) :: wan_inplace
    !! TOOD: use generic subroutines to do inline wanniers
    Integer(t_int) :: wio,wiu,nwan
    !Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    !Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
!!$    Complex(t_real),Pointer :: stcc(:,:) !!TODO: make efficient
!!$    Complex(t_real),Pointer :: ut(:,:) !!TODO: make efficient
!!$    Real(t_real),Pointer    :: fewan(:) !!TODO: make efficient
    Type(T_KS) :: ks
    Type(T_WeightRot) :: wr
    !!
    !!***********************************************************************
    !!
    Nullify(p_oci_gcc,p_oci_gvc,p_tci_gvc,p_pmat)
    !!
    Call watch(nmodule//cpumesg,cpu_start,reset=.True.&
         &,deltaProgress=0.1_t_real,Nsteps=bandplot% nkpnts)
#if defined (TIME_KS)
    Call watch('BP-calcweights',cpu_start,reset=.True.)
    Call watch('BP-calcweights',cpu_stop)
    Call watch('unfold-calcweights',cpu_start,reset=.True.)
    Call watch('unfold-calcweights',cpu_stop)
#endif
    !!
    write_band_window_info=.False.
    nchidim=kohnsham% nchidim
    ncdim=kohnsham% ncdim
    nvdim=kohnsham% nvdim
    nsite=structure% nsite
    !!
    wancoeff_out=.False.
    wan_inplace=.False.
    If(wannier% do_wanniers) Then
       If(wannier% do_wannier_from_file)Then
          wancoeff_out=.true.
          Write(errbuf,10) 
          Call errmsg(nmodule,nsubfunc,E_information,msg=errbuf)
10        Format("'Do-Wanniers-from-file option set by user...',/&
               &,' will start dumping data for creating wannier band-plots.'") 
       Else
          wan_inplace=.True.
       Endif
    Endif
    !!
    Call init_KS(ks,occu=.False.&
         &,savesp=(wan_inplace.Or.wancoeff_out.Or.unfold% active)&
         &,lsdau_kintest=.False.,lsdau_energy=.False.,spinmat=.True.&
         &,need_sigma=bandplot% plotkspintextures)
    !!
!!$    Nullify(stcc)
!!$    Nullify(ut)
!!$    Nullify(fewan)
    Call init_WeightRot(wr)
    !!
    io=1
    iu=nvdim
    !!
    If(bandplot% output_bands_in_window)Then
       io=bandplot% lowest_in_window
       iu=bandplot% highest_in_window
       write_band_window_info=.True.
       Write(outfile,15)bandplot% emin,bandplot% emax
    Endif
    !!
    !! the output_partoccu_bands option overwrites the output_bands_in_window
    If(bandplot% output_partoccu_bands)Then
       io=bzone% highest_fully_occupied-bandplot% part_occu_offset(1)
       iu=bzone% lowest_fully_unoccupied+bandplot% part_occu_offset(2)
       write_band_window_info=.True.
    Endif
    !!
    !!
    !!
    If(bandplot% coeffout)Then
360    Format(/,'Will output coefficients to +coeff (LARGE file)!',/)
       Write(outfile,360)
    Endif
    !!
    !!
    rel=(relativistic==FULL_RELATIVISTIC)
    relmag=(rel .And. mspin==2)
    !!
    !!
    emptyLtest=isoption('EMPTY_LATTICE_TEST')
    !!
    !! prepare rotation of quantization axis
    !!
    Call setup_WeightRot(wr,basis% lvmx,rel,bandplot% bweight_rot&
         &,bandplot% x_axis,bandplot% z_axis,basis% lmx&
         &,basis% p_relTOpseudo,.True.)
    !!
    !!
    !!

    !!
    Call setup_KS(ks,mspin,bzone% nkp,structure,kohnsham,lsdau,opc&
         &,relativistic)
    If(stm% active)Then
       Call palloc('stm% p_Sts',stm% p_Sts,1_t_int,stm% nvdim,1_t_int,nvdim&
            &,nmodule,nsubfunc)
       Call palloc('stm% p_Vts',stm% p_Vts,1_t_int,stm% nvdim,1_t_int,nvdim&
            &,nmodule,nsubfunc)
    Endif
    !!
    If(optics% active .And. optics% bandoutput)Then
       Call palloc("p_oci_gcc",p_oci_gcc,1_t_int,3_t_int&
            &,1_t_int,loi% ociccdim,1_t_int,nspin,nmodule,nsubfunc)
       Call palloc("p_oci_gvc",p_oci_gvc,1_t_int,3_t_int&
            &,1_t_int,loi% ocivcdim,1_t_int,nspin,nmodule,nsubfunc)
       Call palloc("p_tci_gvc",p_tci_gvc,1_t_int,3_t_int&
            &,1_t_int,loi% tcivcdim,1_t_int,nspin,nmodule,nsubfunc)
       Do ms=1,nspin 
          Call mol_core_trans_gcv_noH(structure,lattice,kohnsham,loi&
               &,ms,p_oci_gcc(:,:,ms),p_oci_gvc(:,:,ms),p_tci_gvc(:,:,ms))
       Enddo
       Call palloc('p_pmat',p_pmat,1_t_int,3_t_int&
            &,1_t_int,nvdim,1_t_int,nvdim,nmodule,nsubfunc)
    Endif
    !!
    !!
    !!
    If(wan_inplace)Then
       Stop 'sort out wan_inplace'
!!$       Call palloc('stcc',stcc,1_t_int,nvdim,1_t_int,nvdim,nmodule,nsubfunc)
!!$       Call palloc('fewan',fewan,1_t_int,nvdim,nmodule,nsubfunc)
!!$       Call palloc('ut',ut,1_t_int,nvdim,1_t_int,1_t_int,nmodule,nsubfunc)
       !!TODO: more than one wn-orb
    Endif
    !!
    !!
    
    !!     ha->eV
    eunit=hatoev
    fact=eunit
    scale=twopi/ lattice_constants(1_t_int)
    If(emptyLtest) fact=eunit/scale**2_t_int
    !!
    !!
    !!
    !!
    Open(bands_unit,file=Trim(f_bands_out)//Trim(bandplot%suffix)&
         &,status='unknown')
    Call write_band_header(bands_unit,nspin,nsite,kohnsham% efermi*eunit&
         &,bandplot% nkpnts,0_t_int,io,iu)
    !!
    If(bandplot% plotkspintextures.And.rel)Then
       Open(kspintexture_unit,file="+kspinbands"//Trim(bandplot%suffix)&
            &,status='unknown')
       Write(kspintexture_unit,"('# nsite: ',i10,' efermi: ',f12.7,' nkp: ',i10&
            &,' nband: ',i10,' nspin: ',i10,' iband0: ',i10,' iband1: ',i10,/&
            &,'#  k_vec                                        E(k,n)         &
            &        spinvec')")&
            &nsite,kohnsham% efermi*eunit,bandplot% nkpnts,iu-io+1,nspin,io,iu
    Endif
    !!
    If(optics% active .And. optics% bandoutput)Then
       Open(opticsbands_unit,file="+optbands",status='unknown')
       Call write_band_header(opticsbands_unit,nspin,nsite,kohnsham% efermi*eunit&
            &,bandplot% nkpnts,nvdim,io,iu,bweight=.True.)
       Do iw=io,iu
          Write(opticsbands_unit,"(i5,'            ')",advance='no')iw
       Enddo
       Write(opticsbands_unit,*)
    Endif
    !!
    If(bandplot% bandweights) Then
       !!
       If(unfold% active.And.bwdefs% active)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="' Handmade fatbands and unfold not implemented  yet!'")

       Endif
       !!
       If(bwdefs% active)Then
          nw=cfatbandnumweights()
          
          Open(bwdef_unit,file=Trim(bwdefs% bwfile)&
               &//Trim(bandplot%suffix),status='unknown')
          Call write_band_header(bwdef_unit,nspin,nsite,kohnsham% efermi*eunit&
               &,bandplot% nkpnts,nw,io,iu,bweight=.True.)
          Do iw=1,nw
             Write(bwdef_unit,"(a17)",advance='no')cfatbandweightlabel(iw)
          Enddo
          Write(bwdef_unit,*)
       Else
          Call init_bw_unit(bandweights_unit,nspin,structure,basis&
               &,kohnsham% efermi*eunit,bandplot,nvdim,io,iu,rel)
          If(rel)Then
             Call init_bw_unit(bandweights_unit&
                  &,nspin,structure,basis,kohnsham% efermi*eunit&
                  &,bandplot,nvdim,io,iu,rel,lmsresolved=.True.)
          Endif
          
          !!
          If(unfold% active)Then
             Call init_bw_unit(bandweights_unit,nspin,structure,basis&
                  &,kohnsham% efermi*eunit,bandplot,unfold% nw,io,iu,rel&
                  &,unfold=unfold)
             If(rel)Then
                Call init_bw_unit(bandweights_unit,nspin,structure,basis&
                     &,kohnsham% efermi*eunit,bandplot,unfold% nw,io,iu,rel&
                     &,lmsresolved=.True.,unfold=unfold)
             Endif
          Endif
       Endif
       !!
       If(stm% active)Then
          !!
          Open(stmbandweights_unit,file=Trim(f_bweights_out)//'_stm'&
               &//Trim(bandplot%suffix)&
               &,status='unknown')
          Call write_band_header(stmbandweights_unit,nspin,nsite&
               &,kohnsham% efermi*eunit,bandplot% nkpnts,nvdim,io,iu,bweight=.True.)
          If(unfold% active)Then
             Stop 'unfold and stm?'
          Else If(bwdefs% active)Then
             Stop 'bwdefs and stm?'
          Else
             Call stm_write_weight_header(stmbandweights_unit,stm)
          Endif
       Endif
       !!
    End If
    !!
    !!
    !!
    If(bandplot% coeffout)Then
       Open(bandcoeff_unit,file=f_coeff_out,status='unknown')
       Write(bandcoeff_unit,118)Trim(FPLOMAINVERSION),Trim(FPLORELEASE)
       Call write_band_header(bandcoeff_unit,nspin,nsite,kohnsham% efermi*eunit&
            &,bandplot% nkpnts,nvdim,io,iu,bweight=.True.,coeff=.True.)

       Call write_weight_header(bandcoeff_unit,structure,basis,rel&
            &,.False.,.False.)
    Endif
    !!
    !!
    !!TODO: determine energy-cutoff from wan-data and get wio wiu
    !!
    wio=io
    wiu=iu
    !!
    If(wancoeff_out)Then
       Open(wancoeff_unit,file=f_wancoeff_out,status='old',position='append')
       Write(wancoeff_unit,119)

       Call write_band_header(wancoeff_unit,nspin,nsite,kohnsham% efermi*eunit&
            &,bandplot% nkpnts,nvdim,wio,wiu,bweight=.True.,coeff=.True.)
       Call write_weight_header(wancoeff_unit,structure,basis,rel&
            &,.False.,.False.)
    Endif
    !!
    !!
    !!TODO: nwan, cleanup wan and wancoeff_out 
    !!
    nwan=1
    !!
    If(wan_inplace)Then
       Open(wanbands_unit,file=f_wanbands_out,status='unknown')
       Call write_band_header(wanbands_unit,nspin,nsite,kohnsham% efermi*eunit&
            &,bandplot% nkpnts,nvdim,1_t_int,nwan)
    Endif
    !!
    !!
    !!
    !!
    !!
    !!
    ikloop: Do ik=1_t_int,bandplot% nkpnts
       qq(:)=bandplot% p_kpnts(1:3,ik)
       !!
       Call watch(nmodule//cpumesg,cpu_read,printprogress=.True.,istep=ik-1)

       If(wan_inplace)Then
          Write(wanbands_unit,26)qq(1:3)
       Endif
       Write(bands_unit,26)qq(1_t_int:3_t_int)
       !!
       !!
       qq(:)=qq(:)*scale
       !!
       spinloop: Do ms=1_t_int,nspin
          !!
          If(wan_inplace)Then
             Write(outfile,8800) ms,ik,qq
8800         Format('spin= ',i2,/,'kpoint= ',i8,' k= ',3(f15.8,2x))
          Endif
          
          !!
          !!
          !!
          If(stm% active)Then
             Call stm_lomatrix(nsite,stm,qq&
                  &,kohnsham% p_vblockstart,kohnsham% p_vblockend)
          Endif

          !!
          !!
          Call calc_at_kpoint(ks,ik,qq,ms,mspin&
               &,structure,lattice,basis,loi,kohnsham&
               &,lsdau,opc,relativistic)
          !!
          !! rescale to Fermi level and eV
          If(rel)Then
             ks% p_eb=(ks% p_eb-kohnsham% efermi)*fact !!+sofms*kohnsham% Bfsm
          Else
             sofms=3.0_t_real-2.0_t_real*ms
             ks% p_eb=(ks% p_eb+sofms*kohnsham% Bfsm-kohnsham% efermi)*fact
          Endif
          !!
          !!
          !!
          !!
          If(wancoeff_out)Then
             !!
             Write(wancoeff_unit,369)&
                  &ms,qq(1:3),bandplot% p_kpnts(4,ik)
             Do in=wio,wiu
                Write(wancoeff_unit,367,advance='no')in,ks% p_eb(in)
                Do iz=1,nvdim
                   !! C^{+}*S
                   cv=Dot_product(ks% p_hp(1:nvdim,in),ks% p_sp2(1:nvdim,iz))
                   Write(wancoeff_unit,368,advance='no')cv
                End Do
                Write(wancoeff_unit,24)
             End Do
             !!
          Endif
          !!
          !!
          !!
          !!
          !!
          If(bandplot% coeffout)Then
             Write(bandcoeff_unit,366)&
                  &ms,qq(1:3),bandplot% p_kpnts(4,ik)
             Do in=io,iu
                Write(bandcoeff_unit,367,advance='no')in,ks% p_eb(in)
                Do iz=1_t_int,nvdim
                   Write(bandcoeff_unit,368,advance='no')&
                        &Real(ks% p_hp(iz,in),t_real),Aimag(ks% p_hp(iz,in))
                End Do
                Write(bandcoeff_unit,24)
             End Do
          End If
          !!
          !!
          !!
          !!
          !! Slms resolved band structure
          If(bandplot% bandweights) Then!!todo: wbdef
             If(bwdefs% active)Then
                Call calc_bweights(bwdef_unit&
                     &,structure,basis,kohnsham% p_vblockstart&
                     &,kohnsham% p_vblocklength&
                     &,nvdim,ks% p_hp,ks% p_eb,io,iu&
                     &,qq,bandplot% p_kpnts(4_t_int,ik)&
                     &,wr,bwdefs% active,lmsresolved=.False.,unfold=unfold)
             Else
                Call calc_bweights(bandweights_unit&
                     &,structure,basis,kohnsham% p_vblockstart&
                     &,kohnsham% p_vblocklength&
                     &,nvdim,ks% p_hp,ks% p_eb,io,iu&
                     &,qq,bandplot% p_kpnts(4_t_int,ik)&
                     &,wr,bwdefs% active,lmsresolved=.False.,unfold=unfold)
             
                If(rel)Then
                   Call calc_bweights(bandweights_unit&
                        &,structure,basis,kohnsham% p_vblockstart&
                        &,kohnsham% p_vblocklength&
                        &,nvdim,ks% p_hp,ks% p_eb,io,iu&
                        &,qq,bandplot% p_kpnts(4_t_int,ik)&
                        &,wr,bwdefs% active,lmsresolved=.True.,unfold=unfold)
                Endif
             Endif
             If(stm% active)Then
                Call stm_calc_weights(stmbandweights_unit,stm,ks% p_hp&
                     &,ks% p_eb,io,iu,bandplot% p_kpnts(4_t_int,ik))
             Endif
          Endif
          !! normal bandstructure
32        Format(f16.7,1x)
          Write(bands_unit,32,advance='no')bandplot% p_kpnts(4_t_int,ik)
          Do i=io,iu
33           Format(f16.7,1x)
             Write(bands_unit,33,advance='no')ks% p_eb(i)
          Enddo
34        Format(' ')
          Write(bands_unit,34)
          !!
          If(optics% active .And. optics% bandoutput)Then
             Call optics_calc_matel(ms,structure,lattice,loi,kohnsham,qq&
                  &,p_oci_gcc(:,:,ms),p_oci_gvc(:,:,ms),p_tci_gvc(:,:,ms),ks% p_hp&
                  &,p_pmat)


             ii=1!!todo more general
             jj=1
             Do i=io,iu
                Write(opticsbands_unit,322,advance='no')&
                     &bandplot% p_kpnts(4_t_int,ik),ks% p_eb(i)
                
                Do j=io,iu
                   Write(opticsbands_unit,333,advance='no')&
                        &Real(p_pmat(ii,i,j)*Conjg(p_pmat(jj,i,j)),t_real)
                Enddo
                Write(opticsbands_unit,*)
             Enddo
          Endif
          !!
          If(rel) Call calc_k_spin_texture(ik,io,iu,nvdim,bandplot,ks,quant)
          !!
       Enddo spinloop
    Enddo ikloop 
    !!
    !!
    !!
    !!
    !!
    Close(bands_unit)
    !!
    If(bandplot% plotkspintextures.And.rel) Close(kspintexture_unit)
    !!
    If(optics% active .And. optics% stopafter .And. optics% bandoutput)Then
       Close(opticsbands_unit)
       Call terminate(TERM_NORMAL,'after optics due to user request.')
    Endif
    If(bandplot% bandweights) Then
       If(bwdefs% active) Close(bwdef_unit)
       Close(bandweights_unit)
       If(rel) Close(bandweights_unit+1)
       If(unfold% active) Close(bandweights_unit+2)
       If(unfold% active.And.rel) Close(bandweights_unit+3)
       If(stm% active) Close(stmbandweights_unit)
    Endif
    If(wan_inplace) Close(wanbands_unit)
    If(wancoeff_out) Close(wancoeff_unit)
    If(bandplot% coeffout) Then
       If(rel)Then
          Write(bandcoeff_unit,"('# vbSv0: nvsmx=',i10,' nsite=',i10)")&
               &kohnsham% nvsmx,nsite
          Write(bandcoeff_unit,"(6(e30.15e3,1x))")&
               &loi% p_vbSv0(1:kohnsham% nvsmx&
               &,1:kohnsham% nvsmx,1:nsite)
       Endif
       Close(bandcoeff_unit)
    Endif
    !!
    !!
    !!
    Write(outfile,1)
    !!     
1   Format(/,'Band structure/band weights calculated !',/)
15  Format(/,'Band[weight]s restricted to energy window [',f15.8,',',f15.8,'] eV!',/)

    !!
    Call clean_WeightRot(wr)
    !!
    
    !!
    If(stm% active)Then
       Call pfree(stm% p_Sts)
       Call pfree(stm% p_Vts)
    Endif
!!$    Call pfree(fewan)
!!$    Call pfree(stcc)
!!$    Call pfree(ut)
    Call pfree(p_oci_gcc)
    Call pfree(p_oci_gvc)
    Call pfree(p_tci_gvc)
    Call pfree(p_pmat)
    !!
    Call clean_KS(ks,lsdau,opc)
    !!
#if defined (TIME_KS)
    Call watch('BP-calcweights',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
    Call watch('unfold-calcweights',cpu_read,delete=.True.&
         &,Print=.True.,mesg='Total ')
#endif
    !!
    Call watch(nmodule//cpumesg,cpu_stop,delete=.True.,Print=.True.,mesg="Total ")
    !!
    Return
    !!
119 Format('# bandplot data-dump section')
118 Format('# type: coeff',/,'# version: ',a,'-',a)
24  Format()
366 Format('# spin= ',i3,' k= ',3(f16.7,1x),' dk= ',f16.7)
369 Format('# spin= ',i3,' k= ',3(e30.15e3,1x),' dk= ',e30.15e3)
367 Format(i16,1x,f16.7)
368 Format(2(1x,f16.7))
26  Format('# ',3f12.7)
322 Format(f16.7,1x,f16.7)
333 Format(1x,f16.7)
    !!
  End Subroutine create_bandstructure

  !!***********************************************************************
  Subroutine calc_k_spin_texture(ik,io,iu,nvdim,bandplot,ks,quant)
    !!
    Implicit None
    !!IO
    Type(T_Quant),Intent(in)    :: quant
    Type(T_Bandplot),Intent(in) :: bandplot
    Type(T_KS),Intent(in)       :: ks
    Integer(t_int),Intent(in)   :: ik,io,iu,nvdim
    !!LOCAL
    !Character(*),Parameter::nsubfunc="calc_k_spin_texture"
    Integer(t_int) :: in,is
    Real(t_real)   :: spinvec(3)
    Complex(t_real),Pointer :: ZZ(:,:)
    !!todo: remove
    !Real(t_real)   :: maxerr
    !Complex(t_real):: c
    !Integer(t_int) :: i
    !!
    !!
    in=nvdim
    spinvec=quant% axis(1:3)
    !!
    If(.Not.bandplot% plotkspintextures) Return
    !! 
    !! 
    !! k_i n_1 e_k_i_n_1 spivec_k_i_n_1
    !! ...
    !! k_i n_M e_k_i_n_M spivec_k_i_n_M
    !! next k-point
    !!
    !!
    !!
    !!
#if defined (NEW_FULL_SIGMA_Z)
    If(.True.)Then
       Print *,'check sigma_mat',ik
       maxerr=0.0_t_real
       Do i=1,nvdim
          Do j=1,nvdim
             c=ks% p_spbS(i,j)-Sum(ks% p_spbVS(i,j,1:3)*quant% axis(1:3))&
                  &/Sqrt(Sum(quant% axis(1:3)**2))
             maxerr=Max(maxerr,Abs(c))
             If(Abs(c)>1.0e-10_t_real)Then
                Print *,'err spbVS',i,j,c
                !Stop
             Endif
          Enddo
       Enddo
       !!
       If(Abs(c)>1.0e-10_t_real)Then
          Print *,'maxerr spbVS',maxerr
       Endif
    Endif
#endif
    !!
    !!
    !!
!!$    Call printmat('bVSx',"('(',f12.5,',',f12.5,')')","('                           ')"&
!!$         &,ks% p_spbVS(:,:,1))
!!$    Call printmat('bVSy',"('(',f12.5,',',f12.5,')')","('                           ')"&
!!$         &,ks% p_spbVS(:,:,2))
!!$    Call printmat('bVSz',"('(',f12.5,',',f12.5,')')","('                           ')"&
!!$         &,ks% p_spbVS(:,:,3))
    !!
    bandloop: Do in=io,iu
       !!
       !! calculate spin vector
       !!
       ZZ => ks% p_hp(:,:)
       !!
       !! todo: dumpks
       !!
       !!    spinvec = ZZ^{+} * <Sigma> * ZZ
       !!
       Do is=1,3
          spinvec(is)=Real(Dot_product(ZZ(:,in)&
               &,Matmul(ks% p_spbVS(:,:,is),ZZ(:,in))),t_real)
       Enddo

       !! 
       Write(kspintexture_unit,32)bandplot% p_kpnts(1:3,ik)&
            &,ks% p_eb(in),spinvec(1:3)
       !!
    Enddo bandloop
    !!
    !!
    Return
    !!
32  Format(7(f16.7,1x))
    !!
  End Subroutine calc_k_spin_texture
  !!***********************************************************************
  Subroutine write_band_header(unit,nspin,nsite,efermi,nkpnts,nn,io,iu&
       &,bweight,coeff)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: unit
    Integer(t_int),Intent(in)    :: nspin,nsite,nkpnts,nn,io,iu
    Logical(t_log),Intent(in),Optional :: bweight
    Logical(t_log),Intent(in),Optional :: coeff
    Real(t_real),Intent(in)      :: efermi
    !!LOCAL
    !Character(*),Parameter::nsubfunc="write_band_header"
    Logical(t_log) :: lbweight,lcoeff
    !!
    lcoeff=.False.
    lbweight=.False.
    If(Present(coeff)) lcoeff=coeff
    If(Present(bweight)) lbweight=bweight
    !!
    Write(unit,120) nsite,efermi,nkpnts,nn,iu-io+1,nspin,io,iu
    !!
    If(lbweight) Then
       If(lcoeff)Then
          Write(unit,22,advance='no')
       Else
          Write(unit,21,advance='no')
       Endif
    Endif
    !!
    Return
    !!
120 Format('# ',i5,f12.7,6(' ',i10))
21  Format('#       ik           e(k,n)               ')
22  Format('# band index         e(k,n)               ')
    !!
  End Subroutine write_band_header
  !!***********************************************************************
  Subroutine init_bw_unit(unit,nspin,structure,basis,efermi&
       &,bandplot,nn,io,iu,rel,lmsresolved,unfold)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Unfold),Intent(in),Optional :: unfold
    Logical(t_log),Intent(in)    :: rel
    Logical(t_log),Intent(in),Optional :: lmsresolved
    Integer(t_int),Intent(in)    :: unit
    Integer(t_int),Intent(in)    :: nspin,nn,io,iu
    Real(t_real),Intent(in)      :: efermi
    !!LOCAL
    !Character(*),Parameter::nsubfunc="init_bw_unit"
    Character(20) :: fsuffix1,fsuffix2
    Integer(t_int) :: lunit
    Logical(t_log) :: lunfold,llmsresolved
    !!
    lunfold=.False.
    llmsresolved=.False.
    If(Present(unfold)) lunfold=.True.
    If(Present(lmsresolved)) llmsresolved=lmsresolved
    !!
    fsuffix1=''
    fsuffix2=''
    lunit=unit
    If(lunfold) Then
       fsuffix2='_unfold'
       lunit=lunit+2
    Endif
    If(llmsresolved) Then
       lunit=lunit+1
       fsuffix1='lms'
    Endif
    !!
    Open(lunit,file=Trim(f_bweights_out)//Trim(fsuffix1)&
         &//Trim(bandplot%suffix)//Trim(fsuffix2),status='unknown')
    !!
    Call write_band_header(lunit,nspin,structure% nsite,efermi&
         &,bandplot% nkpnts,nn,io,iu,.True.)
    !!
    If(lunfold)Then
       Call write_unfold_weight_header(lunit&
            &,structure,basis,unfold,rel,llmsresolved)
    Else
       Call write_weight_header(lunit,structure,basis,rel,.True.,llmsresolved)
    Endif
    !!
    !!
    !!
    Return
    !!
  End Subroutine init_bw_unit
  !!***********************************************************************
  !! population analysis + DOS+LDOS
  !!
  Subroutine calc_occu(qq,symmetry,structure,nsite,mspin,rel&
       &,nvdim,vblockstart,vblocklength,basis,ldos&
       &,bwdos,wr,zz,sp,spbS,vbSv0,ik,ms,ogrs,onet&
       &,lgrs,lnet,bgrs,bnet,Mnn)
    !!
    Implicit None 
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Type(T_LDOS),Intent(in)      :: ldos
    Type(T_WeightRot),Intent(in) :: wr
    Logical(t_log),Intent(in)    :: rel,bwdos
    Integer(t_int),Intent(in)    :: nsite,mspin,nvdim
    Integer(t_int),Intent(in)    :: vblockstart(:),vblocklength(:)
    Integer(t_int),Intent(in)    :: ik,ms
    Real(t_real),Intent(in)      :: qq(3)
    Complex(t_real),Intent(in)   :: zz(:,:)
    Complex(t_real),Intent(in)   :: sp(:,:)
    Complex(t_real),Intent(in)   :: spbS(:,:)
    Complex(t_real),Intent(in)   :: vbSv0(:,:,:)
    Real(t_real),Intent(inout)   :: ogrs(:,:,:,:,:)
    Real(t_real),Intent(inout)   :: onet(:,:,:,:,:)
    Real(t_real),Intent(inout)   :: lgrs(:,:,:,:,:)
    Real(t_real),Intent(inout)   :: lnet(:,:,:,:,:)
    Real(t_real),Intent(inout)   :: bgrs(:,:,:,:)
    Real(t_real),Intent(inout)   :: bnet(:,:,:,:)
    Real(t_real),Intent(out)     :: Mnn(:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="calc_occu"
    Logical(t_log) :: relmag,fbz,timerev
    Integer(t_int) :: isa,issa,in,ii,iv,l,mv,deg,jops
    Integer(t_int) :: isc,lenv,stv,iw,iz
    Integer(t_int) :: nw
    Real(t_real)   :: norm,d,ds,gqq(3)
    Complex(t_real):: cc,ctbS,cs0,ca,cb
    Complex(t_real),Pointer   :: p_cts(:)
    Complex(t_real),Pointer   :: p_DtC(:)
    Complex(t_real),Pointer   :: p_DStC(:)
    Complex(t_real),Pointer   :: p_U(:,:)
    
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    !!
    Nullify(p_U,p_cts,p_DtC,p_DStC)
    !!
    !!
    relmag=(rel .And. mspin==2 )
    !!
    If(relmag) Mnn=0.0_t_real
    !!
    fbz=isoption('FULLBZ')
    !!
    !!
    norm=1.0_t_real/Real(symmetry% Rnumops,t_real)
    !! 
    Call palloc('p_cts',p_cts,1_t_int,nvdim,nmodule,nsubfunc)
    !!
    If(bwdos)Then
       nw=cfatbandnumweights()
       Call palloc('p_cts',p_cts,1_t_int,nvdim,nmodule,nsubfunc)
       Call palloc('p_DtC',p_DtC,1_t_int,nvdim,nmodule,nsubfunc)
       Call palloc('p_DStC',p_DStC,1_t_int,nvdim,nmodule,nsubfunc)
    Endif
    !!
    bandloop: Do in=1_t_int,nvdim

       Do iz=1,nvdim
          !! (S*C)_{in,iz}
          p_cts(iz)=Dot_product(sp(1:nvdim,iz),zz(1:nvdim,in))
       Enddo

       iz=0_t_int
       isaloop:   Do isa=1_t_int,nsite
          issa=structure% p_isrt(isa)
          lenv=vblocklength(isa)
          stv=vblockstart(isa)-1
          ii=0_t_int
          ivloop: Do iv=1_t_int,basis% p_nNLv(issa)
             l=basis% p_lNLv(iv,issa)
             deg=basis% p_degNLv(iv,issa)
             Do mv=1_t_int,deg


                ctbS=c0
                cs0=c0
                If(relmag)Then
                   ctbS=Dot_product(zz(1:nvdim,in),spbS(1:nvdim,iz+mv))
                   cs0=Dot_product(zz(stv+1:stv+lenv,in)&
                        &,vbSv0(1:lenv,ii+mv,isa))
                Endif
                

                
                !! population analysis
                !! gross
                !! the matrix index is i=nlm[site]
                !! ogrs^{kn\sigma}_{i_{nl},sort}= \Sum_{m,site(sort)} 
                !!          C^{k}_{i,n}*\Sum_{j} C^{k*}_{j,n}S^{k\sigma}_{j,i}
                !!
                cc=zz(iz+mv,in)
                d=Real(Conjg(p_cts(iz+mv))*cc,t_real)

                If(relmag)Then
                   !! relativistic magnetic
                   ds=Real(ctbS*cc,t_real)
                   
                   Mnn(in)=Mnn(in)+ds
                   
                   ogrs(in,ik,iv,issa,1)=ogrs(in,ik,iv,issa,1)&
                        &+(d+ds)*0.5_t_real
                   ogrs(in,ik,iv,issa,2)=ogrs(in,ik,iv,issa,2)&
                        &+(d-ds)*0.5_t_real
                Else
                   !! non relativistic and relativistic non magnetic
                   ogrs(in,ik,iv,issa,ms)=ogrs(in,ik,iv,issa,ms)+d
                Endif
                !! netto
                d=Abs(cc)**2
                If(relmag)Then
                   !! relativistic magnetic
                   ds=Real(cs0*cc,t_real)

                   onet(in,ik,iv,issa,1)=onet(in,ik,iv,issa,1)&
                        &+(d+ds)*0.5_t_real
                   onet(in,ik,iv,issa,2)=onet(in,ik,iv,issa,2)&
                        &+(d-ds)*0.5_t_real
                Else
                   !! non relativistic and relativistic non magnetic
                   onet(in,ik,iv,issa,ms)=onet(in,ik,iv,issa,ms)+d
                Endif
                
                
             End Do ! mv



             ldosif: If(ldos% plotldos)Then
                !!
                Call assembleLDOS(symmetry,norm,structure,ldos,wr,zz(:,in),p_cts&
                     &,lgrs(:,:,:,:,ms),lnet(:,:,:,:,ms)&
                     &,in,ik,isa,l,deg,ii,iz,fbz,lmsresolved=.False.)
                If(rel)Then
                   Call assembleLDOS(symmetry,norm,structure,ldos,wr,zz(:,in),p_cts&
                        &,lgrs(:,:,:,:,ms),lnet(:,:,:,:,ms)&
                        &,in,ik,isa,l,deg,ii,iz,fbz,lmsresolved=.True.)
                Endif
                !!
             End If ldosif
             
             iz=iz+deg
             ii=ii+deg
          Enddo ivloop
       Enddo isaloop
       !!
       bdosif: If(bwdos)Then
          !!
          fbzifb: If(.Not.fbz)Then             
             !!
             symloopb: Do jops=1,symmetry% Rnumops
                !!
                timerev=( symmetry% Roptimerev(jops)==1)
                gqq=Matmul(symmetry% Ropmat(:,:,jops),qq)
                If(rel .And. timerev)Then
                   gqq=-gqq
                Endif
                !!
                Call palloc('p_U',p_U,1_t_int,nvdim,1_t_int,nw,nmodule,nsubfunc)
                Call cbuildfatbandmatrix(gqq,p_U)
                !!
                iz=0
                Do isa=1,nsite
                   !!
                   issa=structure% p_isrt(isa)
                   isc=structure% p_equivsites(jops,isa) ! g isa
                   !!
                   ii=vblockstart(isc)-1
                   !!
                   Do iv=1_t_int,basis% p_nNLv(issa)
                      l=basis% p_lNLv(iv,issa)
                      deg=basis% p_degNLv(iv,issa)
                      !!
                      !! DtC_s=K0(g)*D^{+}_g*C_{gs}*K0(g)
                      !! CtSC_s=K0(g)*(C^{+}*S)_{gs}*D_g*K0(g)
                      !!
                      Do mv=1,deg
                         
                         ca=Dot_product(symmetry% p_Rwu_tjnl_ks(1:deg,mv,l,jops)&
                              &,zz(ii+1:ii+deg,in))
                         cb=Dot_product(symmetry% p_Rwu_tjnl_ks(1:deg,mv,l,jops)&
                              &,p_cts(ii+1:ii+deg))
                         If(timerev)Then
                            ca=Conjg(ca)
                            cb=Conjg(cb)
                         Endif
                         iz=iz+1
                         p_DtC(iz)=ca
                         p_DStC(iz)=cb
                      Enddo
                      !!
                      ii=ii+deg
                   Enddo
                Enddo
                !!
                !!
                Do iw=1,nw
                   ca=Dot_product(p_U(1:nvdim,iw),p_DtC(1:nvdim))
                   cb=Dot_product(p_U(1:nvdim,iw),p_DStC(1:nvdim))
                   bgrs(in,ik,iw,ms)=bgrs(in,ik,iw,ms)+Real(Conjg(cb)*ca,t_real)*norm
                   bnet(in,ik,iw,ms)=bnet(in,ik,iw,ms)+Abs(ca)**2*norm
                Enddo
                !!
                Call pfree(p_U)
                !!
             Enddo symloopb
             !!
          Else fbzifb
             !!
             Call palloc('p_U',p_U,1_t_int,nvdim,1_t_int,nw,nmodule,nsubfunc)
             Call cbuildfatbandmatrix(qq,p_U)
             !!
             !!
             !!
             Do iw=1,nw
                ca=Dot_product(p_U(1:nvdim,iw),zz(1:nvdim,in))
                cb=Dot_product(p_U(1:nvdim,iw),p_cts(1:nvdim))
                bgrs(in,ik,iw,ms)=Real(Conjg(cb)*ca,t_real)
                bnet(in,ik,iw,ms)=Abs(ca)**2
             Enddo
             !!
             Call pfree(p_U)
             !!
          End If fbzifb
          !!
          !!
          !!
       Endif bdosif
       !!
    Enddo bandloop
    !!
    !!
    Call pfree(p_cts)
    Call pfree(p_DtC)
    Call pfree(p_DStC)
    !!
    !!***********************************************************************
  End Subroutine calc_occu
  !!***********************************************************************
  Subroutine assembleLDOS(symmetry,norm,structure,ldos,wr,zz,cts&
       &,lgrs,lnet,in,ik,isa,l,deg,ii0,iz,fbz,lmsresolved)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_LDOS),Intent(in)      :: ldos
    Type(T_WeightRot),Intent(in) :: wr
    Logical(t_log),Intent(in)    :: fbz,lmsresolved
    Integer(t_int),Intent(in)    :: in,ik,l,deg,ii0,iz,isa
    Real(t_real),Intent(in)      :: norm
    Complex(t_real),Intent(in)   :: zz(:)
    Complex(t_real),Intent(in)   :: cts(:)
    Real(t_real),Intent(inout)   :: lgrs(:,:,:,:)
    Real(t_real),Intent(inout)   :: lnet(:,:,:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="assembleLDOS"
    Integer(t_int) :: isc,ild,mv,jops,l0,ii
    Complex(t_real):: ca,cb
    Complex(t_real),Pointer   :: pr(:,:,:)
    !!
    If(.Not.lmsresolved)Then
       pr => wr% p_rotwhole
       l0=0
       ii=ii0
    Else
       pr => wr% p_relToNrelwhole
       l0=(Size(wr% p_wu_ks,3)-1)/2+1
       ii=ii0+Size(lgrs,3)/2
    Endif
    !!
    relfbziflms: If(.Not.fbz)Then
       reljopslooplms: Do jops=1,symmetry% Rnumops
          isc=structure% p_equivsitesrev(jops,isa) ! g^(+) isa
          ild=ldos% p_siteld(isc)
          If(ild <= 0_t_int)Cycle
          Do mv=1,deg
             ca=Dot_product(wr% p_wu_ks(1:deg,mv,l0+l,jops), zz(iz+1:iz+deg))
             cb=Dot_product(wr% p_wu_ks(1:deg,mv,l0+l,jops),cts(iz+1:iz+deg))
             If(symmetry% Roptimerev(jops)==1)Then
                ca=Conjg(ca)
                cb=Conjg(cb)
             Endif
             
             lgrs(in,ik,ii+mv,ild)=lgrs(in,ik,ii+mv,ild)&
                  &+Real(ca*Conjg(cb),t_real)*norm
             lnet(in,ik,ii+mv,ild)=lnet(in,ik,ii+mv,ild)&
                  &+Abs(ca)**2*norm
          End Do!mv
       End Do reljopslooplms
    Else relfbziflms
       !! do not use symmetry in FBZ mode
       ild=ldos% p_siteld(isa)
       If(ild <= 0_t_int) Return  !Cycle
       Do mv=1,deg
          ca=Dot_product(pr(1:deg,mv,l), zz(iz+1:iz+deg))
          cb=Dot_product(pr(1:deg,mv,l),cts(iz+1:iz+deg))
          
          lgrs(in,ik,ii+mv,ild)=Real(ca*Conjg(cb),t_real)
          lnet(in,ik,ii+mv,ild)=Abs(ca)**2
       Enddo
    End If relfbziflms
    
    !!
    Return
    !!
  End Subroutine assembleLDOS
  !!***********************************************************************
  Subroutine write_weight_header(unit,structure,basis,rel,real_data&
       &,lmsresolved)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Integer(t_int),Intent(in)    :: unit
    Logical(t_log),Intent(in)    :: rel,real_data,lmsresolved
    !!LOCAL
    !Character(*),Parameter::nsubfunc="write_weight_header"
    Integer(t_int) :: isa,issa,ivr,deg,mv,l,ns
    Character(2)   :: updn(2)
    Character(13) :: ifmt
    Data updn(1)/'up'/
    Data updn(2)/'dn'/
    !!
    ifmt="(a17,17(' '))"
    If(real_data) ifmt="(a17)"
    !!
    Do isa=1_t_int,structure% nsite
       issa=structure% p_isrt(isa)
       lmsresolvedif: If(.Not.lmsresolved)Then
          Do ivr=1_t_int,basis% p_nRv(issa)
             Do mv=1_t_int,basis% p_degRv(ivr,issa)
                !!
                Write(unit,fmt=ifmt,advance='no')&
                     & orblabel17(structure,isa,basis% p_nnRv(ivr,issa),&
                     &basis% p_kapRv(ivr,issa),mv,rel)
                !!
             Enddo
          Enddo
       Else lmsresolvedif
          ivrlmsloop: Do ivr=1,basis% p_nNLv(issa)
             l=basis% p_lNLv(ivr,issa)
             deg=basis% p_degNLSv(ivr,issa)
             Do mv=1,deg
                Do ns=1,2
                   Write(unit,235,advance='no')&
                        &structure% p_elements(issa),isa&
                        &,basis% p_nnNLv(ivr,issa),lqnchar(l),mv-l-1,updn(ns)
                Enddo
             Enddo
          Enddo ivrlmsloop
       Endif lmsresolvedif
    Enddo
    !!
    Write(unit,24)
    !!
    Return
    !!
!217 Format(a17)
!224 Format(a17,17(' '))
235 Format(a2,'(',i3.3,')',i1,a1,SP,i2,a2,'    ')
24  Format()
    !!
  Contains
    !!***********************************************************************
    Character(17) Function orblabel17(structure,isa,nmain,kap,mv,rel)
      !!
      Implicit None
      !!IO
      Type(T_Structure),Intent(in) :: structure
      Logical(t_log),Intent(in)    :: rel
      Integer(t_int),Intent(in)    :: isa,nmain,mv,kap
      !!LOCAL
      !Character(*),Parameter::nsubfunc="orblabel17"
      Integer(t_int) :: j,l
      !!
      !!
      l=(Abs(2*kap+1)-1)/2
      If(rel)Then
         j=2*Abs(kap)-1
         Write(orblabel17,"(a2,'(',i3.3,')',i1,a1,i1,'/2',SP,i2,'/2 ')")&
              &structure% p_elements(issa),isa&
              &,nmain,lqnchar(l),j,-j+2*(mv-1)
      Else
         Write(orblabel17,"(a2,'(',i3.3,')',i1,a1,SP,i2,6(' '))")&
              &structure% p_elements(structure% p_isrt(isa))&
              &,isa,nmain,lqnchar(l),mv-l-1
      Endif
      !!
      Return
      !!
    End Function orblabel17
    !!***********************************************************************
  End Subroutine write_weight_header
  !!***********************************************************************
  Subroutine calc_bweights(unit,structure,basis,vblockstart,vblocklength&
       &,nvdim,zz,eb,io,iu,qq,kpnt,wr&
       &,bwdefactive,lmsresolved,unfold)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Logical(t_log),Intent(in)    :: bwdefactive
    Type(T_Unfold),Intent(in)    :: unfold
    Type(T_WeightRot),Intent(in) :: wr
    Logical(t_log),Intent(in)    :: lmsresolved
    Integer(t_int),Intent(in)    :: io,iu,nvdim,unit
    Integer(t_int),Intent(in)    :: vblockstart(:),vblocklength(:)
    Real(t_real),Intent(in)      :: qq(3),kpnt
    Real(t_real),Intent(in)      :: eb(:)
    Complex(t_real),Intent(in)   :: ZZ(:,:)
    
    !!LOCAL
    Character(*),Parameter::nsubfunc="calc_bweights"
    Integer(t_int) :: in,iz,isa,issa,l,deg,mv,lnband,inn,iv
    Integer(t_int) :: nw,nuw,iw,i,udef,count,lena,nn
    Integer(t_int) :: ista,j,istb,lunit
    Real(t_real)   :: dd,d,wei
    Real(t_real),Pointer      :: p_uweight(:,:),p_weights(:,:)
    Complex(t_real),Pointer   :: p_U(:,:)
    Complex(t_real),Pointer   :: p_DC(:)
    Real(t_real),Pointer      :: p_wsum(:)
    Complex(t_real):: caa
    !Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    !Complex(t_real),Parameter:: c1=(1.0_t_real,0.0_t_real)
    !Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    Complex(t_real),Pointer   :: pr(:,:,:)
    Real(t_real),Parameter   :: wtol=1.0e-8_t_real
    External cbuildfatbandmatrix
    !!
    !!
    Nullify(p_weights,p_uweight,p_wsum,p_U,p_DC)
    !!
#if defined (TIME_KS)
    Call watch('BP-calcweights',cpu_start)
#endif
    !!
    lnband=iu-io+1
    !!
    nw=nvdim
    !!
    !!
    If(bwdefactive) nw=cfatbandnumweights()
    !!
    !!
    If(.Not.lmsresolved)Then
       lunit=unit
       pr => wr% p_rotwhole
    Else
       lunit=unit+1
       pr => wr% p_relToNrelwhole
    Endif
    !!
    !!
    Call palloc('p_weights',p_weights,1_t_int,nw,1_t_int,lnband&
         &,nmodule,nsubfunc)
    If(unfold% active)Then
       nuw=unfold% nw
       Call palloc('p_uweight',p_uweight,1_t_int,nuw,1_t_int,lnband&
            &,nmodule,nsubfunc)
    Endif
    Call palloc('p_DC',p_DC,1_t_int,nvdim,nmodule,nsubfunc)
    Call palloc('p_wsum',p_wsum,1_t_int,lnband,nmodule,nsubfunc)
    If(bwdefactive)Then
       Call palloc('p_U',p_U,1_t_int,nvdim,1_t_int,nw,nmodule,nsubfunc)
       Call cbuildfatbandmatrix(qq,p_U)
       !!
    Endif
    !!
    !!
    If(unfold% active)Then
       p_uweight=0.0_t_real
    Endif
    bandloop: Do in=io,iu
       inn=in-io+1


       casesif: If(bwdefactive) Then
          !!
          p_wsum(inn)=Sum(Abs(zz(1:nvdim,in))**2)
          !!
          !! unitary transformation, take amplitude squared
          Do iw=1,nw
             caa=Dot_product(p_U(1:nvdim,iw),zz(1:nvdim,in))
             p_weights(iw,inn)=Abs(caa)**2
          Enddo
          !!
          !!
       Else ! casesif
          !!
          p_wsum(inn)=0.0_t_real
          iz=0
          Do isa=1,structure% nsite
             issa=structure% p_isrt(isa)
             Do iv=1,basis% p_nNLv(issa)
                l=basis% p_lNLv(iv,issa)
                deg=basis% p_degNLv(iv,issa)
                Do mv=1,deg
                   caa=Dot_product(pr(1:deg,mv,l),zz(iz+1:iz+deg,in))
                   p_DC(iz+mv)=caa
                   dd=Abs(caa)**2
                   p_wsum(inn)=p_wsum(inn)+dd
                   p_weights(iz+mv,inn)=dd
                Enddo       ! mv
                iz=iz+deg
             Enddo
          Enddo
          !!
          !!
          unfoldif: If(unfold% active)Then
             iw=0
             udefloop: Do udef=1,unfold% ndefs
                !! use NCsite for label
                isa=unfold% p_SCsites(1,udef)
                count=unfold% p_count(udef)
                issa=structure% p_isrt(isa)
                lena=vblocklength(isa)
                Do nn=1,lena
                   iw=iw+1
                   wei=0.0_t_real
                   Do i=1,count
                      ista=vblockstart(unfold% p_SCsites(i,udef))-1
                      Do j=1,count
                         istb=vblockstart(unfold% p_SCsites(j,udef))-1
                         d=Real(Conjg(p_DC(ista+nn))*p_DC(istb+nn),t_real)
                         wei=wei+d
                      Enddo
                   End Do
                   p_uweight(iw,inn)=p_uweight(iw,inn)+wei/count
                End Do
             End Do udefloop
          Endif unfoldif
          !!
       Endif casesif
       !!
       !!
       !!
       !!
       !!
    End Do bandloop
    !!
    !!
    Call averageDegenerateSubspaces(io,iu,eb,nw,p_weights,p_wsum,wtol)
    !!
    Do in=io,iu
       inn=in-io+1
       Write(lunit,30,advance='no')kpnt,eb(in)
       !!
       dd=p_wsum(inn)
       If(Abs(dd)<1.0e-6_t_real)dd=1.0_t_real
       Do iw=1,nw
          Write(lunit,31,advance='no')p_weights(iw,inn)/dd
       Enddo       ! mv
       Write(lunit,24)
       !!
    Enddo             ! iband
    !!
    If(unfold% active)Then
       !!
       Call averageDegenerateSubspaces(io,iu,eb,nuw,p_uweight,p_wsum,wtol)
       !!
       Do in=io,iu
          inn=in-io+1
          Write(lunit+2,30,advance='no')kpnt,eb(in)
          !!
          dd=p_wsum(inn)
          If(Abs(dd)<1.0e-6_t_real)dd=1.0_t_real
          !!
          Do iw=1,nuw
             Write(lunit+2,31,advance='no')p_uweight(iw,inn)/dd
          Enddo
          Write(lunit+2,24)
       Enddo
       !!
    Endif
    !!
    Call pfree(p_weights)
    Call pfree(p_uweight)
    Call pfree(p_wsum)
    Call pfree(p_U)
    Call pfree(p_DC)
    !!
#if defined (TIME_KS)
    Call watch('BP-calcweights',cpu_stop)
#endif
    !!
    Return
    !!
24  Format()
30  Format(f16.7,1x,f16.7)
31  Format(1x,f16.7)
    !!
  End Subroutine calc_bweights
  !!***********************************************************************
  Subroutine calc_at_kpoint(ks,ik,qq,ms,mspin&
       &,structure,lattice,basis,loi,kohnsham&
       &,lsdau,opc,relativistic)
    !!
    Implicit None
    !!IO
    Type(T_KS),Intent(inout)     :: ks
    Type(T_Structure),Intent(in) :: structure
    Type(T_lattice),Intent(in)   :: lattice
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_LOI),Intent(in)       :: loi
    Type(T_Lsdau),Intent(inout)  :: lsdau
    Type(T_OPC),Intent(in)       :: opc
    Integer(t_int),Intent(in)    :: ms,ik,relativistic,mspin
    Real(t_real),Intent(in)      :: qq(3)
    !!LOCAL
    Character(*),Parameter::nsubfunc="calc_at_kpoint"
    Logical(t_log) :: tstdia,rel,relmag
    Logical(t_log),Parameter ::  calc_lz=.False.
    Integer(t_int) :: nvdim,nband,in,ind0,isa,issa,ia,la,deg,jmz,jz,ma
    Integer(t_int) :: nchidim,nsite,nvsmx,ncdim
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    Complex(t_real):: ce
    !! testdiagno
    Complex(t_real),Pointer :: hp1(:,:)
    Complex(t_real),Pointer :: sp1(:,:)
    !!
    in=ik
    Nullify(hp1,sp1)
    !!
    tstdia=isoption('TEST_DIAGNO')
    nchidim=kohnsham% nchidim
    ncdim=kohnsham% ncdim
    nvdim=kohnsham% nvdim
    nband=kohnsham% nband
    nvsmx=kohnsham% nvsmx
    nsite=structure% nsite
    !!
    rel=(relativistic==FULL_RELATIVISTIC)
    relmag=(rel .And. mspin==2)
    !!
    If(calc_lz .Or. tstdia) Then
       Call palloc('sp1',sp1,1_t_int,nvdim,1_t_int,nvdim,nmodule,nsubfunc)
    Endif
    !!
    If(tstdia) Then
       Call palloc('hp1',hp1,1_t_int,nvdim,1_t_int,nvdim,nmodule,nsubfunc)
    Endif
    !!
    !!
    
#if defined (TIME_KS)
    Call watch('KS-lomatrix',cpu_start)
#endif
    
    If(rel)Then
       
       !Call rel_sym_check(symmetry,structure,lattice,basis,loi)
       If(ks% occu)Then
          Call rlomatrix(nsite,nvsmx,kohnsham% nchismx,nvdim,nchidim,ncdim&
               &,kohnsham% p_chiblockstart,kohnsham% p_chiblockend&
               &,kohnsham% p_cblockstart,kohnsham% p_cblockend&
               &,kohnsham% p_vblockstart,kohnsham% p_vblockend&
               &,lattice% p_npairs,lattice% p_pairs&
               &,qq,ks% p_hp,ks% p_sp,ks% p_spbS,ks% p_scvbS&
               &,ks% p_hcv,ks% p_scv&
               &,loi% ocivvdim,loi% ocivcdim&
               &,loi% p_roci_vHv,loi% p_oci_vv0,loi% p_vbSv0&
               &,loi% p_roci_vHchi,loi% p_roci_vchi,loi% p_vbSchi&
               &,loi% tcivvdim,loi% tcivcdim&
               &,loi% p_rtci_vHv,loi% p_rtci_vv0,loi% p_rtci_vbSv0&
               &,loi% p_rtci_vHchi,loi% p_rtci_vchi,loi% p_rtci_vbSchi&
               &,loi% p_ocivvindex,loi% p_ocivcindex&
               &,loi% p_tcivvindex,loi% p_tcivcindex,relmag&
               &,ks% need_sigma,loi% p_vbVSv0,loi% p_rtci_vbVSv0,ks% p_spbVS&
               &,loi% p_vbVSchi,loi% p_rtci_vbVSchi,ks% p_scvbVS&
               &,loi% p_roci_vcraw,loi% p_rtci_vcraw,ks% p_scrawv)
       Else          
          Call rlomatrix(nsite,nvsmx,kohnsham% nchismx,nvdim,nchidim,ncdim&
               &,kohnsham% p_chiblockstart,kohnsham% p_chiblockend&
               &,kohnsham% p_cblockstart,kohnsham% p_cblockend&
               &,kohnsham% p_vblockstart,kohnsham% p_vblockend&
               &,lattice% p_npairs,lattice% p_pairs&
               &,qq,ks% p_hp,ks% p_sp,ks% p_spbS,ks% p_scvbS&
               &,ks% p_hcv,ks% p_scv&
               &,loi% ocivvdim,loi% ocivcdim&
               &,loi% p_roci_vHv,loi% p_oci_vv0,loi% p_vbSv0&
               &,loi% p_roci_vHchi,loi% p_roci_vchi,loi% p_vbSchi&
               &,loi% tcivvdim,loi% tcivcdim&
               &,loi% p_rtci_vHv,loi% p_rtci_vv0,loi% p_rtci_vbSv0&
               &,loi% p_rtci_vHchi,loi% p_rtci_vchi,loi% p_rtci_vbSchi&
               &,loi% p_ocivvindex,loi% p_ocivcindex&
               &,loi% p_tcivvindex,loi% p_tcivcindex,relmag&
               &,ks% need_sigma,loi% p_vbVSv0,loi% p_rtci_vbVSv0,ks% p_spbVS&
               &,loi% p_vbVSchi,loi% p_rtci_vbVSchi,ks% p_scvbVS)
       Endif
    Else
       If(ks% occu)Then
          Call lomatrix(nsite,nvdim,nchidim,ncdim&
               &,kohnsham% p_chiblockstart,kohnsham% p_chiblockend&
               &,kohnsham% p_cblockstart,kohnsham% p_cblockend&
               &,kohnsham% p_vblockstart,kohnsham% p_vblockend&
               &,lattice% p_npairs,lattice% p_pairs,qq,ks% p_hp,ks% p_sp&
               &,ks% p_hcv,ks% p_scv&
               &,loi% p_oci_vHv(:,ms),loi% p_oci_vv0&
               &,loi% p_oci_vHchi(:,ms),loi% p_oci_vchi(:,ms)&
               &,loi% p_tci_vHv(:,ms),loi% p_tci_vv0&
               &,loi% p_tci_vHchi(:,ms),loi% p_tci_vchi(:,ms)&
               &,loi% p_ocivvindex,loi% p_ocivcindex&
               &,loi% p_tcivvindex,loi% p_tcivcindex&
               &,loi% p_oci_vcraw(:,ms),loi% p_tci_vcraw(:,ms),ks% p_scrawv)
       Else
          Call lomatrix(nsite,nvdim,nchidim,ncdim&
               &,kohnsham% p_chiblockstart,kohnsham% p_chiblockend&
               &,kohnsham% p_cblockstart,kohnsham% p_cblockend&
               &,kohnsham% p_vblockstart,kohnsham% p_vblockend&
               &,lattice% p_npairs,lattice% p_pairs,qq,ks% p_hp,ks% p_sp&
               &,ks% p_hcv,ks% p_scv&
               &,loi% p_oci_vHv(:,ms),loi% p_oci_vv0&
               &,loi% p_oci_vHchi(:,ms),loi% p_oci_vchi(:,ms)&
               &,loi% p_tci_vHv(:,ms),loi% p_tci_vv0&
               &,loi% p_tci_vHchi(:,ms),loi% p_tci_vchi(:,ms)&
               &,loi% p_ocivvindex,loi% p_ocivcindex&
               &,loi% p_tcivvindex,loi% p_tcivcindex)
       Endif
    Endif
    
#if defined (TIME_KS)
    Call watch('KS-lomatrix',cpu_stop)
#endif


    Call opc_merge_h(opc,nvdim,ks% p_hp)
    !!
#if defined (TIME_KS)
    Call watch('KS-coval',cpu_start)
#endif
    
    !! core valence orthogonalization
    !Call ccovalS(kohnsham% p_hc(:,ms),sp,hp,scv,nvdim,nchidim)
    Call ccovalSH(kohnsham% p_hc(:,ms),ks% p_sp,ks% p_hp&
         &,ks% p_scv,ks% p_hcv,nvdim,nchidim)

    
    
    If(relmag.And.(ks% occu .Or. kohnsham% fsm .Or. ks% spinmat &
         &.Or. kohnsham% haveBfield))Then
       Call ccovalbSfull(loi% p_chibSchi,loi% p_cspchar,ks% p_spbS&
            &,ks% p_scv,ks% p_scvbS,nvdim,nchidim,nsite&
            &,kohnsham% p_chiblocklength)
    End If

    If(rel.And.ks% need_sigma)Then
       Call ccovalbVSfull(loi% p_chibVSchi,ks% p_spbVS,ks% p_scv,ks% p_scvbVS&
            &,nvdim,nchidim,nsite,kohnsham% p_chiblocklength)
    Endif

    If(relmag .And. kohnsham% fsm)Then
       ks% p_hp=ks% p_hp+kohnsham% Bfsm*ks% p_spbS
    Endif
    If(kohnsham% haveBfield)Then
       If(relmag)Then
          ks% p_hp=ks% p_hp-kohnsham% Bfield*ks% p_spbS
       Else If(.Not.rel)Then
          ks% p_hp=ks% p_hp-kohnsham% Bfield*(3.0_t_real-2.0_t_real*ms)*ks% p_sp
       Endif
    Endif
    
#if defined (TIME_KS)
    Call watch('KS-coval',cpu_stop)
#endif
    !!
    !!
    Call lsdau_merge_h(lsdau,nvdim,ks% p_hp,ks% p_sp,ms,ks% lsdau_kintest)
    !!
    !!pouplation analysis, LSDA+U, save sp
    !! new stuff
    If(ks% savesp)Then
       ks% p_sp2=ks% p_sp!!TODO: compiler bug
    Endif


    If(.False.)Then
       Call deform_h(ks% p_hp,structure,basis,qq)
    Endif


!!$          If(tstdia .And. (All(Abs(qq)<1.0e-5_t_real) .Or. .True.))Then
!!$
!!$             Write(outfile,*) 
!!$             Write(outfile,1)ik,qq(1:3)
!!$
!!$             
!!$             Call drot_mat(symmetry,structure,basis,kohnsham,bzone,nvdim,hp1,eb,quant,ik,qq)
!!$          Endif

    !!
    !!
#if defined (ANALYSE_S)
    Call analyze_S(sp,nvdim,ms,qq)
#endif
    !!
    !! diagonalization
    !!
#if defined (PRINT_HS)
    If(All(Abs(qq)<1.0e-5_t_real) .Or. .False.)Then
       Call printmat1('Re H',"(f12.5,' ')","('     0       ')"&
            &,Real(hp,t_real),nvdim,nvdim,1.0e-12_t_real)
       Call printmat1('Im H',"(f12.5,' ')","('     0       ')"&
            &,Aimag(hp),nvdim,nvdim,1.0e-12_t_real)
       Call printmat1('Re S',"(f12.5,' ')","('     0       ')"&
            &,Real(sp,t_real),nvdim,nvdim,1.0e-12_t_real)
       Call printmat1('Im S',"(f12.5,' ')","('     0       ')"&
            &,Aimag(sp),nvdim,nvdim,1.0e-12_t_real)
    Endif
#endif
    !!
    !!force hermicity make some test output
    Call checkhermes(nvdim,ks% p_sp,ks% p_hp)
    !!
    !!
!!$          If(rel)Then
!!$             Call matRelToNonrel(sp,nvdim,nsite,nsort,structure% p_isrt,basis)
!!$          Else
!!$             Call cprintmat1('sp',"('(',f12.5,',',f12.5,') ')"&
!!$                  &,"('            0               ')"&
!!$                  &,sp,nvdim,nvdim,1.0e-5_t_real)
!!$
!!$          Endif
    !!
    !!
    !!
#if defined (TIME_KS)
    Call watch('KS-diagno',cpu_start)
#endif

    If(calc_lz .Or. tstdia)Then
       sp1=ks% p_sp
    Endif
    If(tstdia) Then
       hp1=ks% p_hp
    Endif
    
    Call cdiagno(nvdim,ks% p_hp,ks% p_sp,ks% p_eb)
    
#if defined (TIME_KS)
    Call watch('KS-diagno',cpu_stop)
#endif
    !!
    !!
    !!
    !!
    !!
    !!

!!$
!!$21        Format('# K-vector:',3f10.4)
!!$23        Format(f12.7,' ')
!!$24        Format(i5,' ')
!!$          !!
!!$          Write(15,21)qq(1:3)
!!$          Write(15,24,advance='no')ik
!!$          Do in=1,nband
!!$             Write(15,23,advance='no')eb(in)
!!$          Enddo
!!$          Write(15,*)

    !!
    !! Lz for molecules and ONLY non-full-relativistic
    !!
    If(calc_lz)Then
       Write(outfile,875) ms
       Do in=1,nband
          ind0=0
          ce=c0
          Do isa=1,structure% nsite
             issa=structure% p_isrt(isa)
             Do ia=1_t_int,basis% p_nRv(issa)
                la=basis% p_lRv(ia,issa)
                deg=2*la+1
                Do ma=-la,la
                   jz=ind0+la+1+ma
                   jmz=ind0+la+1-ma
                   !! C^{+}*S_{m,-m}*(i*m)*C
                   ce=ce+Dot_product(ks% p_hp(1:nvdim,in),sp1(1:nvdim,jmz))&
                        &*ks% p_hp(jz,in)*ci*ma
                Enddo ! ma
                ind0=ind0+deg
             Enddo! orbitals
          Enddo! site
          Write(outfile,876) in,ks% p_eb(in),ce
          
       Enddo !! band index
875    Format("Lz expectation values, spin=",i2,/&
            &,"band index   energy  <Lz>   real iamg")
876    Format(i7,1x,3(f12.5,2x))
    Endif
    !!
    If(tstdia)Then
       Call ctestdia(nvdim,nband,hp1,sp1,ks% p_hp,ks% p_eb,1.0e-13_t_real)
    Endif
    !!
    !!
    !!
    Call pfree(sp1)
    Call pfree(hp1)
    !!
    Return
    !!
  End Subroutine calc_at_kpoint
  !!***********************************************************************
  Subroutine deform_h(p_hp,structure,basis,qq)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Real(t_real),Intent(in)      :: qq(3)
    Complex(t_real),Intent(inout):: p_hp(:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="deform_h"
    Logical(t_log) :: exists
    Integer(t_int) :: nsite,isa,issa,iva,nmaina,kapa,ja,la,dega,iza
    Integer(t_int) :: isb,issb,ivb,nmainb,kapb,jb,lb,degb,izb,mu
    Real(t_real)   :: dV0,dV,qa,qcut
    !!
    Inquire(file='=.deformh',exist=exists)
    If(.Not.exists)Then
       Return
    Endif
    Open(12,file='=.deformh')
    Read(12,*) dV0,qcut
    Close(12)
    !!
    nsite=structure% nsite
    !!
    qa=Sum(qq**2)
    !!
    dV=dV0/hatoev*Exp(-(qa/qcut)**2)
    !!
    iza=0
    Do isa=1,nsite
       !!
       issa=structure% p_isrt(isa)
       !!
       Do iva=1,basis% p_nRv(issa)
          !!
          nmaina=basis% p_nnRv(iva,issa)
          kapa=basis% p_kapRv(iva,issa)
          la=(Abs(2*kapa+1)-1)/2
          !!
          ja=2*Abs(kapa)-1
          dega=ja+1
          !!
          !Write(outfile,"(i3,i1,a4,i6,':',i6)")isa,nmaina,kapToString(kapa),iza+1,iza+dega
          !!
          izb=0
          Do isb=1,nsite
             !!
             issb=structure% p_isrt(isb)
             !!
             Do ivb=1,basis% p_nRv(issb)
                !!
                nmainb=basis% p_nnRv(ivb,issb)
                kapb=basis% p_kapRv(ivb,issb)
                lb=(Abs(2*kapb+1)-1)/2
                !!
                jb=2*Abs(kapb)-1
                degb=jb+1
                !!
                !!
                If((isa==1 .And. isb==1).And.&
                     &(nmaina==4 .And. nmainb==4).And.&
                     &(ja==5 .And. jb==5)&
                     &)Then
                   !Write(outfile,"(i3,i1,a4,i6,':',i6)")&
                   !     &isa,nmaina,kapToString(kapa),iza+1,iza+dega
                   !Write(outfile,"(i3,i1,a4,i6,':',i6)")&
                   !     &isb,nmainb,kapToString(kapb),izb+1,izb+degb
                   Do mu=1,dega
                      p_hp(iza+mu,izb+mu)=p_hp(iza+mu,izb+mu)+dV
                   Enddo
                Endif
                !!
                izb=izb+degb
             Enddo
             !!
          Enddo
          
          !!
          iza=iza+dega
       Enddo
       !!
    Enddo
    !!
    Return
    !!
  End Subroutine deform_h
  !!***********************************************************************
  Logical(t_log) Function dumpks(nspin,nkp,ks,mode)
    !!
    Implicit None  
    !!IO
    Type(T_KS),Intent(inout)     :: ks
    Integer(t_int),Intent(in)    :: nspin,nkp
    Character(*),Intent(in)      :: mode
    !!LOCAL
    Character(*),Parameter::nsubfunc="dumpks"
    Integer(t_int) :: nvdim,nchidim,ncdim,dimspbS,lnspin,lnkp
    Integer ::err
    Character(30)  :: str30
    !!
    dumpks=.True.
    !!
    If(Trim(mode) == 'write')Then
       nvdim=Size(ks%  p_hp,1)
       nchidim=Size(ks%  p_hcv,1)
       ncdim=Size(ks%  p_scrawv,2)
       dimspbS=Size(ks%  p_spbS,1)
       Write(dump_ks_unit) '#nspin                       =',nspin
       Write(dump_ks_unit) '#nkp                         =',nkp
       Write(dump_ks_unit) '#nvdim                       =',nvdim
       Write(dump_ks_unit) '#ncdim0                      =',nchidim
       Write(dump_ks_unit) '#ncdim                       =',ncdim
       Write(dump_ks_unit) '#dimspbS                     =',dimspbS
       Write(dump_ks_unit) '#ks% p_zz                    =',ks%  p_hp
       Write(dump_ks_unit) '#ks% p_eb                    =',ks%  p_eb
       Write(dump_ks_unit) '#ks% p_sp2                   =',ks%  p_sp2
       Write(dump_ks_unit) '#ks% p_hcv                   =',ks%  p_hcv
       Write(dump_ks_unit) '#ks% p_scv                   =',ks%  p_scv
       Write(dump_ks_unit) '#ks% p_scrawv                =',ks%  p_scrawv
       Write(dump_ks_unit) '#ks% p_spbS                  =',ks%  p_spbS
   Else
       Read(dump_ks_unit,iostat=err) str30,lnspin
       Read(dump_ks_unit,iostat=err) str30,lnkp
       Read(dump_ks_unit,iostat=err) str30,nvdim
       Read(dump_ks_unit,iostat=err) str30,nchidim
       Read(dump_ks_unit,iostat=err) str30,ncdim 
       Read(dump_ks_unit,iostat=err) str30,dimspbS
       If(err/=0.Or.&
            &lnspin/=nspin.Or.lnkp/=nkp.Or.&
            &Size(ks%  p_hp,1)/=nvdim.Or.Size(ks%  p_hp,2)/=nvdim.Or.&
            &Size(ks%  p_sp2,1)/=nvdim.Or.Size(ks%  p_sp2,2)/=nvdim.Or.&
            &Size(ks%  p_eb,1)/=nvdim.Or.&
            &Size(ks%  p_hcv,1)/=nchidim.Or.Size(ks%  p_hcv,2)/=nvdim.Or.&
            &Size(ks%  p_scv,1)/=nchidim.Or.Size(ks%  p_scv,2)/=nvdim.Or.&
            &Size(ks%  p_scrawv,1)/=nvdim.Or.Size(ks%  p_scrawv,2)/=ncdim.Or.&
            &Size(ks%  p_spbS,1)/=dimspbS.Or.Size(ks%  p_spbS,2)/=dimspbS) &
            &dumpks=.False.
       If(dumpks) Then
          Read(dump_ks_unit,iostat=err) str30,ks%  p_hp
          Read(dump_ks_unit,iostat=err) str30,ks%  p_eb
          Read(dump_ks_unit,iostat=err) str30,ks%  p_sp2
          Read(dump_ks_unit,iostat=err) str30,ks%  p_hcv
          Read(dump_ks_unit,iostat=err) str30,ks%  p_scv
          Read(dump_ks_unit,iostat=err) str30,ks%  p_scrawv
          Read(dump_ks_unit,iostat=err) str30,ks%  p_spbS
      Endif
       If(err/=0) dumpks=.False.
       If(.Not.dumpks)Then
          Write(errbuf,34) Trim(gdump(DUMP_KS)% fname)
          Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
       Endif
       !!
    Endif
    !!
    Return
    !!
34  Format("'data on dump file ",a," seem to belong to different settings.',/&
         &,' I will ignore the file''s content and proceed with normal &
         &calculation!'")
    !!
  End Function dumpks
  !!***********************************************************************


 

End Module kohnsham
