Module ksinternal
  !!
  Use precisiondefs
  Use constants
  Use file_iounits
  Use errors
  Use atomdefs
  Use optionstest
  Use matserv
  Use bzone
  Use tbandplot
  Use ioadapter, Only: mkdirectory
  Use tfatband
  Use fatband
  Use tio
  Use ioaux
  Use memory
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="KSINTERNAL"  
  !!
  Public :: ndos,prtanal,popa,lomatrix,rlomatrix,checkhermes&
       &,ccovalS,ccovalSH,ccovalbSfull,flomatrix,optlomatrix,ccovalbVSfull
  !!***********************************************************************
  Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
  !!***********************************************************************

Contains 
  !!***********************************************************************
  !!***********************************************************************
  !!       
  !! Calculation of relativistic LO-matricees
  !!TODO: complex OCIs and TCIs
  Subroutine rlomatrix(nsite,nvsmx,nchismx,nvdim,nchidim,ncdim&
       &,chiblockstart,chiblockend,cblockstart,cblockend,vblockstart,vblockend&
       &,npairs,pairs,qq&
       &,hp,sp,spbS,scvbS,hcv,scv&
       &,ocivvdim,ocivcdim,roci_vHv,oci_vv,vbSv0,roci_vHc,roci_vc,vbSchi&
       &,tcivvdim,tcivcdim,rtci_vHv,rtci_vv,rtci_vbSv,rtci_vHc,rtci_vc&
       &,rtci_vbSchi&
       &,ocivvindex,ocivcindex,tcivvindex,tcivcindex,relmag&
       &,need_sigma,vbVSv0,rtci_vbVSv,spbVS,vbVSchi,rtci_vbVSchi,scvbVS&
       &,roci_vcraw,rtci_vcraw,scrawv)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)   :: relmag,need_sigma
    Integer(t_int),Intent(in)   :: nvdim,nchidim,ncdim,nsite
    Integer(t_int),Intent(in)   :: nvsmx,nchismx
    Integer(t_int),Intent(in)   :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)   :: ocivvdim,ocivcdim,tcivvdim,tcivcdim
    Integer(t_int),Intent(in)   :: chiblockstart(nsite)
    Integer(t_int),Intent(in)   :: chiblockend(nsite)
    Integer(t_int),Intent(in)   :: cblockstart(nsite)
    Integer(t_int),Intent(in)   :: cblockend (nsite)
    Integer(t_int),Intent(in)   :: vblockstart(nsite)
    Integer(t_int),Intent(in)   :: vblockend(nsite)
    Integer(t_int),Intent(in)   :: ocivvindex(nsite)
    Integer(t_int),Intent(in)   :: ocivcindex(nsite)
    Integer(t_int),Intent(in)   :: tcivvindex(:,:,:)
    Integer(t_int),Intent(in)   :: tcivcindex(:,:,:)
    Real(t_real),Intent(in)     :: qq(3)
    Complex(t_real),Intent(in)  :: roci_vHv(ocivvdim)
    Real(t_real),Intent(in)     :: oci_vv (ocivvdim)
    Complex(t_real),Intent(in)  :: vbSv0(nvsmx,nvsmx,nsite) 
    Complex(t_real),Intent(in)  :: vbVSv0(nvsmx,nvsmx,nsite,3) 
    Complex(t_real),Intent(in)  :: roci_vc (ocivcdim)
    Complex(t_real),Intent(in)  :: roci_vHc(ocivcdim)
    Complex(t_real),Intent(in)  :: vbSchi (nvsmx,nchismx,nsite)
    Complex(t_real),Intent(in)  :: vbVSchi (nvsmx,nchismx,nsite,3)
    Complex(t_real),Intent(in)  :: rtci_vHv(tcivvdim)
    Complex(t_real),Intent(in)  :: rtci_vv (tcivvdim)
    Complex(t_real),Intent(in)  :: rtci_vbSv(tcivvdim)
    Complex(t_real),Intent(in)  :: rtci_vbVSv(tcivvdim,3)
    Complex(t_real),Intent(in)  :: rtci_vc (tcivcdim)
    Complex(t_real),Intent(in)  :: rtci_vHc(tcivcdim)
    Complex(t_real),Intent(in)  :: rtci_vbSchi(:)
    Complex(t_real),Intent(in)  :: rtci_vbVSchi(:,:)
    Complex(t_real),Intent(in),Optional  :: roci_vcraw(ocivcdim)
    Complex(t_real),Intent(in),Optional  :: rtci_vcraw (tcivcdim)
    Real(t_real),Intent(in)     :: pairs(:,:,:,:)
    Complex(t_real),Intent(out) :: sp(nvdim,nvdim)
    Complex(t_real),Intent(out) :: hp(nvdim,nvdim)
    Complex(t_real),Intent(out) :: spbS(:,:)
    Complex(t_real),Intent(out) :: scvbS(:,:)
    Complex(t_real),Intent(out) :: scvbVS(:,:,:)
    Complex(t_real),Intent(out) :: spbVS(:,:,:)
    Complex(t_real),Intent(out) :: hcv(nchidim,nvdim)
    Complex(t_real),Intent(out) :: scv(nchidim,nvdim)
    Complex(t_real),Intent(out),Optional :: scrawv(nvdim,ncdim)
    !!LOCAL
    Logical(t_log) :: doraw
    Integer(t_int) :: isa,isb,ioci,itci,iocivc,itcivc
    Integer(t_int) :: i,j,it0,it1,jt0,jt1,jt00,jt01,ir
    Complex(t_real):: eikr
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)

    !!
    !!
    doraw=(Present(roci_vcraw).And.Present(rtci_vcraw).And.Present(scrawv))
    !!
    sp  (1_t_int:nvdim,1_t_int:nvdim)=c0
    hp  (1_t_int:nvdim,1_t_int:nvdim)=c0
    If(relmag)Then
       spbS(1_t_int:nvdim,1_t_int:nvdim)=c0
       scvbS(1_t_int:nchidim,1_t_int:nvdim)=c0
    Endif
    If(need_sigma)Then
       spbVS(1:nvdim,1:nvdim,1:3)=c0
       scvbVS(1:nchidim,1:nvdim,1:3)=c0
    Endif
    !!
    scv (1_t_int:nchidim,1_t_int:nvdim)=c0
    hcv (1_t_int:nchidim,1_t_int:nvdim)=c0
    If(doraw)scrawv(1:nvdim,1:ncdim)=c0
    !!     
    !! LO-matrix of local part of basis          
    !!     
    Do isa=1_t_int,nsite

       it0=vblockstart(isa)
       it1=vblockend(isa)
       ioci=ocivvindex(isa)
       
       Do i=it0,it1
          Do j=it0,it1
             !!
             !!
             ioci=ioci+1_t_int
             
             sp(i,j)=sp(i,j)+Cmplx(oci_vv (ioci),0.0_t_real,t_real)
             hp(i,j)=hp(i,j)+roci_vHv(ioci)
             If(relmag)Then
                spbS(i,j)=spbS(i,j)+vbSv0(i-it0+1,j-it0+1,isa)
             Endif
             If(need_sigma)Then
                spbVS(i,j,1:3)=spbVS(i,j,1:3)+vbVSv0(i-it0+1,j-it0+1,isa,1:3)
             Endif
          Enddo ! j
       Enddo ! i


       Do isb=1_t_int,nsite

          jt0=vblockstart(isb)
          jt1=vblockend(isb)

          

          Do ir=1_t_int,npairs(isa,isb)
             
             itci=tcivvindex(ir,isa,isb)

             eikr=Exp(-ci*Dot_product(qq,pairs(:,ir,isa,isb)))
             

             Do i=it0,it1
                Do j=jt0,jt1
                   !!
                   itci=itci+1_t_int
                   
                   sp(i,j)=sp(i,j)+rtci_vv (itci)*eikr
                   hp(i,j)=hp(i,j)+rtci_vHv(itci)*eikr
                   If(relmag)Then
                      spbS(i,j)=spbS(i,j)+rtci_vbSv(itci)*eikr
                   Endif
                   If(need_sigma)Then
                      spbVS(i,j,1:3)=spbVS(i,j,1:3)+rtci_vbVSv(itci,1:3)*eikr
                   Endif
                Enddo ! j
             Enddo ! i

          Enddo                 ! ir 
       Enddo                   ! isb
    Enddo                     ! isa 


    Do isa=1_t_int,nsite

       it0=vblockstart(isa)
       it1=vblockend(isa)
       

       Do isb=1_t_int,nsite

          jt0=chiblockstart(isb)
          jt1=chiblockend(isb)
          jt00=cblockstart(isb)
          jt01=cblockend (isb)
          

          !! onsite core valence overlap
          If(isa == isb)Then
             iocivc=ocivcindex(isa)
             Do i=it0,it1
                Do j=jt0,jt1
                   !!
                   iocivc=iocivc+1_t_int
                   !! Scv=Svc*

                   scv(j,i)=scv(j,i)+Conjg(roci_vc(iocivc))
                   hcv(j,i)=hcv(j,i)+Conjg(roci_vHc(iocivc))
                   If(relmag)Then
                      scvbS(j,i)=scvbS(j,i)+Conjg(vbSchi(i-it0+1,j-jt0+1,isa))
                   Endif
                   If(need_sigma)Then
                      scvbVS(j,i,1:3)=scvbVS(j,i,1:3)&
                           &+Conjg(vbVSchi(i-it0+1,j-jt0+1,isa,1:3))
                   Endif
                Enddo ! j
             Enddo ! i
             If(doraw)Then
                iocivc=ocivcindex(isa)
                Do i=it0,it1
                   Do j=jt00,jt01
                      !!
                      iocivc=iocivc+1_t_int
                      !! Scv=Svc*
                      scrawv(i,j)=scrawv(i,j)+Conjg(roci_vcraw(iocivc))
                   Enddo ! j
                Enddo ! i
             End If
             
          End If

          Do ir=1_t_int,npairs(isa,isb)
             
             eikr=Exp(ci*Dot_product(qq,pairs(:,ir,isa,isb)))

             itcivc=tcivcindex(ir,isa,isb)
             Do i=it0,it1
                Do j=jt0,jt1
                   !!
                   itcivc=itcivc+1_t_int
                   !! Scv=Svc*
                   scv(j,i)=scv(j,i)+Conjg(rtci_vc(itcivc))*eikr
                   hcv(j,i)=hcv(j,i)+Conjg(rtci_vHc(itcivc))*eikr
                   If(relmag)Then
                      scvbS(j,i)=scvbS(j,i)+Conjg(rtci_vbSchi(itcivc))*eikr
                   Endif
                   If(need_sigma)Then
                      scvbVS(j,i,1:3)=scvbVS(j,i,1:3)&
                           &+Conjg(rtci_vbVSchi(itcivc,1:3))*eikr
                   Endif
                Enddo ! j
             Enddo ! i

             If(doraw)Then
                itcivc=tcivcindex(ir,isa,isb)
                Do i=it0,it1
                   Do j=jt00,jt01
                      !!
                      itcivc=itcivc+1_t_int
                      !! Scv=Svc*
                      scrawv(i,j)=scrawv(i,j)+Conjg(rtci_vcraw(itcivc))*eikr
                   Enddo ! j
                Enddo ! i
             End If
             
          Enddo                 ! ir 
       Enddo                   ! isb
    Enddo                     ! isa 
    !!cccccccccccccccccccccccccccccc
    Return
  End Subroutine rlomatrix
  !!***********************************************************************
  !!       
  !! Calculation of non-rel LO-matricees
  !!
  Subroutine flomatrix(nsite,nvdim,nchidim&
       &,chiblockstart,chiblockend,vblockstart,vblockend&
       &,npairs,pairs,qq,ghp,gsp&
       &,ghcv,ghcvr,gscv&
       &,hcv,scv&
       &,oci_vHc,oci_vc,tci_vHc,tci_vc&
       &,oci_gvHv,oci_gvv,tci_gvHv,tci_gvv&
       &,oci_gvHc,oci_gvHcr,oci_gvc&
       &,tci_gvHc,tci_gvHcr,tci_gvc&
       &,ocivvindex,tcivvindex,ocivcindex,tcivcindex)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nvdim,nchidim,nsite
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: chiblockstart(nsite)
    Integer(t_int),Intent(in)    :: chiblockend(nsite)
    Integer(t_int),Intent(in)    :: vblockstart(nsite)
    Integer(t_int),Intent(in)    :: vblockend(nsite)
    Integer(t_int),Intent(in)    :: ocivvindex(nsite)
    Integer(t_int),Intent(in)    :: ocivcindex(nsite)
    Integer(t_int),Intent(in)    :: tcivvindex(:,:,:)
    Integer(t_int),Intent(in)    :: tcivcindex(:,:,:)
    Real(t_real),Intent(in)     :: qq(3)
    Real(t_real),Intent(in)     :: oci_gvHv(:,:)
    Real(t_real),Intent(in)     :: oci_gvv (3,*)
    Real(t_real),Intent(in)     :: tci_gvHv(:,:)
    Real(t_real),Intent(in)     :: tci_gvv (3,*)
    Real(t_real),Intent(in)     :: oci_gvHc(3,*)
    Real(t_real),Intent(in)     :: oci_gvHcr(3,*)
    Real(t_real),Intent(in)     :: oci_gvc (3,*)
    Real(t_real),Intent(in)     :: tci_gvHc(3,*)
    Real(t_real),Intent(in)     :: tci_gvHcr(3,*)
    Real(t_real),Intent(in)     :: tci_gvc (3,*)
    !!
    Real(t_real),Intent(in)     :: oci_vc (:)
    Real(t_real),Intent(in)     :: oci_vHc(:)
    Real(t_real),Intent(in)     :: tci_vc (:)
    Real(t_real),Intent(in)     :: tci_vHc(:)
    Real(t_real),Intent(in)     :: pairs(:,:,:,:)
    Complex(t_real),Intent(out)  :: gsp(nvdim,nvdim,3)
    Complex(t_real),Intent(out)  :: ghp(nvdim,nvdim,3)
    Complex(t_real),Intent(out)  :: gscv(nchidim,nvdim,3)
    Complex(t_real),Intent(out)  :: ghcv(nchidim,nvdim,3)
    Complex(t_real),Intent(out)  :: ghcvr(nvdim,nchidim,3)
    Complex(t_real),Intent(out)  :: scv(nchidim,nvdim)
    Complex(t_real),Intent(out)  :: hcv(nchidim,nvdim)
    !!LOCAL
    Integer(t_int) :: isa,isb,ioci,ir,itci,iocivc,itcivc
    Integer(t_int) :: it0,it1,i,j,jt0,jt1
    Complex(t_real):: eikr
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    !!
    !!
    !!
    gsp  (1:nvdim ,1:nvdim,1:3)=c0
    ghp  (1:nvdim ,1:nvdim,1:3)=c0
    gscv (1:nchidim,1:nvdim,1:3)=c0
    ghcv (1:nchidim,1:nvdim,1:3)=c0
    ghcvr (1:nvdim,1:nchidim,1:3)=c0
    scv  (1:nchidim,1:nvdim)=c0
    hcv  (1:nchidim,1:nvdim)=c0
    !!     
    !! LO-matrix of local part of basis          
    !!     
    
    Do isa=1_t_int,nsite

       
       it0=vblockstart(isa)
       it1=vblockend(isa)
       ioci=ocivvindex(isa)
       
       Do i=it0,it1
          Do j=it0,it1
             ioci=ioci+1_t_int
             
             
             gsp(i,j,1:3)=gsp(i,j,1:3)+oci_gvv (1:3,ioci)
             ghp(i,j,1:3)=ghp(i,j,1:3)+oci_gvHv(1:3,ioci)
             
          Enddo ! j
       Enddo ! i

       

       Do isb=1_t_int,nsite
          
          jt0=vblockstart(isb)
          jt1=vblockend(isb)
          
          Do ir=1_t_int,npairs(isa,isb)

             eikr=Exp(-ci*Dot_product(qq,pairs(:,ir,isa,isb)))
             itci=tcivvindex(ir,isa,isb)
             
             Do i=it0,it1
                Do j=jt0,jt1
                   itci=itci+1_t_int
                   
                   gsp(i,j,1:3)=gsp(i,j,1:3)+tci_gvv (1:3,itci)*eikr
                   ghp(i,j,1:3)=ghp(i,j,1:3)+tci_gvHv(1:3,itci)*eikr
                Enddo ! j
             Enddo ! i

          Enddo                 ! ir 
       Enddo                   ! isb
    Enddo                     ! isa 

    
    
    !!
    !!
    Do isa=1_t_int,nsite


       it0=vblockstart(isa)
       it1=vblockend(isa)
       
       Do isb=1_t_int,nsite

          
          jt0=chiblockstart(isb)
          jt1=chiblockend(isb)


          !! onsite core valence overlap
          If(isa == isb)Then
             iocivc=ocivcindex(isa)

             Do i=it0,it1
                Do j=jt0,jt1
                   iocivc=iocivc+1_t_int
                   scv(     j,i)=scv     (j,i)+oci_vc     (iocivc)
                   hcv(     j,i)=hcv     (j,i)+oci_vHc    (iocivc)
                   gscv(j,i,1:3)=gscv(j,i,1:3)+oci_gvc(1:3,iocivc)
                   ghcv(j,i,1:3)=ghcv(j,i,1:3)+oci_gvHc(1:3,iocivc)
                   ghcvr(i,j,1:3)=ghcvr(i,j,1:3)+oci_gvHcr(1:3,iocivc)
                   
                Enddo ! j
             Enddo ! i

          End If


          Do ir=1_t_int,npairs(isa,isb)
             
             eikr=Exp(ci*Dot_product(qq,pairs(:,ir,isa,isb)))

             itcivc=tcivcindex(ir,isa,isb)

             Do i=it0,it1
                Do j=jt0,jt1
                   itcivc=itcivc+1_t_int
                   scv(j,i)=scv(j,i)+tci_vc (itcivc)*eikr
                   hcv(j,i)=hcv(j,i)+tci_vHc(itcivc)*eikr
                   gscv(j,i,1:3)=gscv(j,i,1:3)+tci_gvc(1:3,itcivc)*eikr
                   ghcv(j,i,1:3)=ghcv(j,i,1:3)+tci_gvhc(1:3,itcivc)*eikr
                   ghcvr(i,j,1:3)=ghcvr(i,j,1:3)+tci_gvhcr(1:3,itcivc)*eikr
                Enddo ! j
             Enddo ! i
          Enddo                 ! ir 
          !!
       Enddo                   ! isb
       !!
    Enddo                     ! isa 
    !!cccccccccccccccccccccccccccccc
    Return
  End Subroutine flomatrix
  !!***********************************************************************
  !!       
  !! Calculation of non-rel gradient LO-matricees
  !!
  Subroutine optlomatrix(nsite,nvdim,nchidim&
       &,chiblockstart,chiblockend,vblockstart,vblockend&
       &,npairs,pairs,qq,gsp&
       &,gscv,scv&
       &,oci_vc,tci_vc&
       &,oci_gvv,tci_gvv&
       &,oci_gvc,tci_gvc&
       &,ocivvindex,tcivvindex,ocivcindex,tcivcindex)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nvdim,nchidim,nsite
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: chiblockstart(nsite)
    Integer(t_int),Intent(in)    :: chiblockend(nsite)
    Integer(t_int),Intent(in)    :: vblockstart(nsite)
    Integer(t_int),Intent(in)    :: vblockend(nsite)
    Integer(t_int),Intent(in)    :: ocivvindex(nsite)
    Integer(t_int),Intent(in)    :: ocivcindex(nsite)
    Integer(t_int),Intent(in)    :: tcivvindex(:,:,:)
    Integer(t_int),Intent(in)    :: tcivcindex(:,:,:)
    Real(t_real),Intent(in)     :: qq(3)
    Real(t_real),Intent(in)     :: oci_gvv (3,*)
    Real(t_real),Intent(in)     :: tci_gvv (3,*)
    Real(t_real),Intent(in)     :: oci_gvc (3,*)
    Real(t_real),Intent(in)     :: tci_gvc (3,*)
    !!
    Real(t_real),Intent(in)     :: oci_vc (:)
    Real(t_real),Intent(in)     :: tci_vc (:)
    Real(t_real),Intent(in)     :: pairs(:,:,:,:)
    !! (grad v|v)
    Complex(t_real),Intent(out)  :: gsp(nvdim,nvdim,3)
    Complex(t_real),Intent(out)  :: gscv(nchidim,nvdim,3)
    Complex(t_real),Intent(out)  :: scv(nchidim,nvdim)
    !!LOCAL
    Integer(t_int) :: isa,isb,ioci,ir,itci,iocivc,itcivc
    Integer(t_int) :: it0,it1,i,j,jt0,jt1
    Complex(t_real):: eikr
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    !!
    !!
    !!
    gsp  (1:nvdim ,1:nvdim,1:3)=c0
    gscv (1:nchidim,1:nvdim,1:3)=c0
    scv  (1:nchidim,1:nvdim)=c0
    !!     
    !! LO-matrix of local part of basis          
    !!     
    
    Do isa=1_t_int,nsite

       
       it0=vblockstart(isa)
       it1=vblockend(isa)
       ioci=ocivvindex(isa)
       
       Do i=it0,it1
          Do j=it0,it1
             ioci=ioci+1_t_int
             
             
             gsp(i,j,1:3)=gsp(i,j,1:3)+oci_gvv (1:3,ioci)
             
          Enddo ! j
       Enddo ! i

       

       Do isb=1_t_int,nsite
          
          jt0=vblockstart(isb)
          jt1=vblockend(isb)
          
          Do ir=1_t_int,npairs(isa,isb)

             eikr=Exp(-ci*Dot_product(qq,pairs(:,ir,isa,isb)))
             itci=tcivvindex(ir,isa,isb)
             
             Do i=it0,it1
                Do j=jt0,jt1
                   itci=itci+1_t_int
                   
                   gsp(i,j,1:3)=gsp(i,j,1:3)+tci_gvv (1:3,itci)*eikr
                Enddo ! j
             Enddo ! i

          Enddo                 ! ir 
       Enddo                   ! isb
    Enddo                     ! isa 

    
    
    !!
    !!
    Do isa=1_t_int,nsite


       it0=vblockstart(isa)
       it1=vblockend(isa)
       
       Do isb=1_t_int,nsite

          
          jt0=chiblockstart(isb)
          jt1=chiblockend(isb)


          !! onsite core valence overlap
          If(isa == isb)Then
             iocivc=ocivcindex(isa)

             Do i=it0,it1
                Do j=jt0,jt1
                   iocivc=iocivc+1_t_int
                   scv(     j,i)=scv     (j,i)+oci_vc     (iocivc)
                   gscv(j,i,1:3)=gscv(j,i,1:3)+oci_gvc(1:3,iocivc)
                   
                Enddo ! j
             Enddo ! i

          End If


          Do ir=1_t_int,npairs(isa,isb)
             
             eikr=Exp(ci*Dot_product(qq,pairs(:,ir,isa,isb)))

             itcivc=tcivcindex(ir,isa,isb)

             Do i=it0,it1
                Do j=jt0,jt1
                   itcivc=itcivc+1_t_int
                   scv(j,i)=scv(j,i)+tci_vc (itcivc)*eikr
                   gscv(j,i,1:3)=gscv(j,i,1:3)+tci_gvc(1:3,itcivc)*eikr
                Enddo ! j
             Enddo ! i
          Enddo                 ! ir 
          !!
       Enddo                   ! isb
       !!
    Enddo                     ! isa 
    !!cccccccccccccccccccccccccccccc
    Return
  End Subroutine optlomatrix
  !!***********************************************************************
  !!       
  !! Calculation of non-rel LO-matricees
  !!
  Subroutine lomatrix(nsite,nvdim,nchidim,ncdim&
       &,chiblockstart,chiblockend,cblockstart,cblockend,vblockstart,vblockend&
       &,npairs,pairs,qq,hp,sp,hcv,scv&
       &,oci_vHv,oci_vv,oci_vHc,oci_vc,tci_vHv,tci_vv,tci_vHc,tci_vc&
       &,ocivvindex,ocivcindex,tcivvindex,tcivcindex&
       &,oci_vcraw,tci_vcraw,scrawv&
       &)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nvdim,nchidim,ncdim,nsite
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: chiblockstart(nsite)
    Integer(t_int),Intent(in)    :: chiblockend(nsite)
    Integer(t_int),Intent(in)    :: cblockstart(nsite)
    Integer(t_int),Intent(in)    :: cblockend (nsite)
    Integer(t_int),Intent(in)    :: vblockstart(nsite)
    Integer(t_int),Intent(in)    :: vblockend(nsite)
    Integer(t_int),Intent(in)    :: ocivvindex(nsite)
    Integer(t_int),Intent(in)    :: ocivcindex(nsite)
    Integer(t_int),Intent(in)    :: tcivvindex(:,:,:)
    Integer(t_int),Intent(in)    :: tcivcindex(:,:,:)
    Real(t_real),Intent(in)     :: qq(3)
    Real(t_real),Intent(in)     :: oci_vHv(:)
    Real(t_real),Intent(in)     :: oci_vv (*)
    Real(t_real),Intent(in)     :: oci_vHc (:)
    Real(t_real),Intent(in)     :: oci_vc (:)
    Real(t_real),Intent(in)     :: tci_vHv(:)
    Real(t_real),Intent(in)     :: tci_vv (*)
    Real(t_real),Intent(in)     :: tci_vHc (:)
    Real(t_real),Intent(in)     :: tci_vc (:)
    Real(t_real),Intent(in),Optional     :: oci_vcraw (:)
    Real(t_real),Intent(in),Optional     :: tci_vcraw (:)
    Real(t_real),Intent(in)     :: pairs(:,:,:,:)
    Complex(t_real),Intent(out)  :: sp(nvdim,nvdim)
    Complex(t_real),Intent(out)  :: hp(nvdim,nvdim)
    Complex(t_real),Intent(out) :: scv(nchidim,nvdim)
    Complex(t_real),Intent(out),Optional :: scrawv(nvdim,ncdim)
    Complex(t_real),Intent(out) :: hcv(nchidim,nvdim)
    !!LOCAL
    Logical(t_log) :: doraw
    Integer(t_int) :: isa,isb,ioci,itci,iocivc,itcivc
    Integer(t_int) :: it0,it1,jt0,jt1,jt00,jt01,i,j,ir
    Complex(t_real):: eikr
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    !!
    doraw=(Present(oci_vcraw).And.Present(tci_vcraw).And.Present(scrawv))
    !!
    !!
    sp  (1_t_int:nvdim,1_t_int:nvdim)=c0
    hp  (1_t_int:nvdim,1_t_int:nvdim)=c0
    scv (1_t_int:nchidim,1_t_int:nvdim)=c0
    hcv (1_t_int:nchidim,1_t_int:nvdim)=c0
    If(doraw)scrawv(1:nvdim,1:ncdim)=c0
    !!     
    !! LO-matrix of local part of basis          
    !!     
    
    Do isa=1_t_int,nsite

       
       it0=vblockstart(isa)
       it1=vblockend(isa)
       ioci=ocivvindex(isa)
       
       Do i=it0,it1
          Do j=it0,it1
             ioci=ioci+1_t_int
             
             sp(i,j)=sp(i,j)+oci_vv (ioci)
             hp(i,j)=hp(i,j)+oci_vHv(ioci)
          Enddo ! j
       Enddo ! i

       

       Do isb=1_t_int,nsite

          jt0=vblockstart(isb)
          jt1=vblockend(isb)
          
          Do ir=1_t_int,npairs(isa,isb)
             
             eikr=Exp(-ci*Dot_product(qq,pairs(:,ir,isa,isb)))
             itci=tcivvindex(ir,isa,isb)
             
             Do i=it0,it1
                Do j=jt0,jt1
                   itci=itci+1_t_int
                   sp(i,j)=sp(i,j)+tci_vv (itci)*eikr
                   hp(i,j)=hp(i,j)+tci_vHv(itci)*eikr
                Enddo ! j
             Enddo ! i

          Enddo                 ! ir 
       Enddo                   ! isb
    Enddo                     ! isa 

    
    
    !!
    !!
    Do isa=1_t_int,nsite


       it0=vblockstart(isa)
       it1=vblockend(isa)
       
       Do isb=1_t_int,nsite

          
          jt0=chiblockstart(isb)
          jt1=chiblockend(isb)
          jt00=cblockstart(isb)
          jt01=cblockend (isb)

          !! onsite core valence overlap
          If(isa == isb)Then
             iocivc=ocivcindex(isa)
             
             Do i=it0,it1
                Do j=jt0,jt1
                   iocivc=iocivc+1_t_int
                   scv(j,i)=scv(j,i)+oci_vc(iocivc)
                   hcv(j,i)=hcv(j,i)+oci_vHc(iocivc)

                Enddo ! j
             Enddo ! i

             
             If(doraw)Then
                iocivc=ocivcindex(isa)
                Do i=it0,it1
                   Do j=jt00,jt01
                      iocivc=iocivc+1_t_int
                      scrawv(i,j)=scrawv(i,j)+oci_vcraw(iocivc)
                   Enddo ! j
                Enddo ! i
             Endif
          End If
          
          Do ir=1_t_int,npairs(isa,isb)
             
             eikr=Exp(ci*Dot_product(qq,pairs(:,ir,isa,isb)))
             
             itcivc=tcivcindex(ir,isa,isb)
             Do i=it0,it1
                Do j=jt0,jt1
                   itcivc=itcivc+1_t_int
                   scv(j,i)=scv(j,i)+tci_vc(itcivc)*eikr
                   hcv(j,i)=hcv(j,i)+tci_vHc(itcivc)*eikr
                Enddo ! j
             Enddo ! i
             
             If(doraw)Then
                itcivc=tcivcindex(ir,isa,isb)
                Do i=it0,it1
                   Do j=jt00,jt01
                      itcivc=itcivc+1_t_int
                      scrawv(i,j)=scrawv(i,j)+tci_vcraw(itcivc)*eikr
                   Enddo ! j
                Enddo ! i
             Endif
          Enddo                 ! ir 
          !!
       Enddo                   ! isb
       !!
    Enddo                     ! isa 
    !!cccccccccccccccccccccccccccccc
    Return
  End Subroutine lomatrix
  !!***********************************************************************
  !!           
  !!           
  !!                     +    
  !!    O    =  O    -  S   S
  !!     vv      vv      cv  cv
  !!
  !!                     +                   
  !!    H    =  H    -  S    H   S
  !!     vv      vv      cv   cc  cv
  !!                                          
  !!------------------------------------------------------------------------
  !!
  !! input
  !!  hp(nvdim,nvdim) : valenve-valence hamiltonian matrix
  !!  sp(nvdim,nvdim) : valenve-valence overlap matrix
  !!  scv(nchidim,nvdim)     : core-valenve overlap matrix      
  !!     hc(nchidim)       : diagonal core Hamiltonian
  !!  nvdim, nchidim    : dimensions of matrices
  !!
  !! output
  !!  sp(nvdim,nvdim)   : valenve-valencew overlap matrix
  !!                    with core corrections
  !!  hp(nvdim,nvdim)   : valenve-valence hamiltonian matrix
  !!                    with core corrections
  !!------------------------------------------------------------------------
  Subroutine ccovalS(hc,sp,hp,scv,nvdim,nchidim)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nvdim,nchidim
    Complex(t_real),Intent(inout):: sp (nvdim,nvdim)
    Complex(t_real),Intent(inout):: hp (nvdim,nvdim)
    Real(t_real),Intent(in)     :: hc(nchidim)
    Complex(t_real),Intent(in)  :: scv (nchidim,nvdim)
    !!LOCAL
    Integer(t_int) :: i,k,j
    Complex(t_real):: ce
    !!
    Do i=1_t_int,nvdim
       Do j=1_t_int,nvdim
          Do k=1_t_int,nchidim       
             !! S_vc(i,k)*S_cv(k,j)=S_cv(k,i)^(*) *S_cv(k,j) 
             ce=Conjg(scv(k,i))*scv(k,j)
             sp(i,j)=sp(i,j)-ce
             hp(i,j)=hp(i,j)-ce*hc(k)
          Enddo !
       Enddo!
    Enddo !
  End Subroutine ccovalS
  !!***********************************************************************
  !!           
  !!                     +    
  !!    O    =  O    -  S   S
  !!     vv      vv      cv  cv
  !!
  !!                     +           +           +                   
  !!    H    =  H    -  H    S   -  S    H   +  S    H   S   
  !!     vv      vv      cv   cv     cv   cv     cv   cc  cv 
  !!                                          
  !!------------------------------------------------------------------------
  !!
  !! input
  !!  hp(nvdim,nvdim) : valenve-valence hamiltonian matrix
  !!  sp(nvdim,nvdim) : valenve-valence overlap matrix
  !!  scv(nchidim,nvdim)     : core-valenve overlap matrix      
  !!  hcv(nchidim,nvdim)     : core-valenve hamiltonian matrix      
  !!     hc(nchidim)       : diagonal core Hamiltonian
  !!  nvdim, nchidim    : dimensions of matrices
  !!
  !! output
  !!  sp(nvdim,nvdim)   : valenve-valence overlap matrix
  !!                    with core corrections
  !!  hp(nvdim,nvdim)   : valenve-valence hamiltonian matrix
  !!                    with core corrections
  !!------------------------------------------------------------------------
  Subroutine ccovalSH(hc,sp,hp,scv,hcv,nvdim,nchidim)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nvdim,nchidim
    Complex(t_real),Intent(inout):: sp (nvdim,nvdim)
    Complex(t_real),Intent(inout):: hp (nvdim,nvdim)
    Real(t_real),Intent(in)     :: hc(nchidim)
    Complex(t_real),Intent(in)  :: scv (nchidim,nvdim)
    Complex(t_real),Intent(in)  :: hcv (nchidim,nvdim)
    !!LOCAL
    Integer(t_int) :: i,k,j
    Complex(t_real):: ce
    !!
    !! Hvv=Hvv-H_cv^{+}*S_cv-S_cv^{+}*H_cv+S_cv^{+}*hc*S_cv
    !!
    Do i=1_t_int,nvdim
       Do j=1_t_int,nvdim
          ce=Dot_product(hcv(1:nchidim,i),scv(1:nchidim,j))
          hp(i,j)=hp(i,j)-ce
          hp(j,i)=hp(j,i)-Conjg(ce)
          
          Do k=1_t_int,nchidim       
             !!
             ce=Conjg(scv(k,i))*scv(k,j)
             sp(i,j)=sp(i,j)-ce
             hp(i,j)=hp(i,j)+ce*hc(k)
          Enddo !
       Enddo!
    Enddo !
  End Subroutine ccovalSH
  !!***********************************************************************
  Subroutine ccovalbSfull(chibSchi,cspchar,spbS,scv,scvbS,nvdim,nchidim&
       &,nsite,chiblocklength)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nvdim,nchidim,nsite,chiblocklength(:)
    Complex(t_real),Intent(inout):: spbS(:,:)
    Real(t_real),Intent(in)      :: cspchar(nchidim)
    Complex(t_real),Intent(in)   :: scv  (:,:)
    Complex(t_real),Intent(in)   :: scvbS(nchidim,nvdim)
    Complex(t_real),Intent(in)   :: chibSchi(:,:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="ccovalbSfull"
    Integer(t_int) :: i,k,j
    Complex(t_real):: ce
    !!
    i=chiblocklength(1)!! avoid warnings
    i=nsite!! avoid warnings
    ce=chibSchi(1,1,1)!! avoid warnings
    !!
    Do i=1_t_int,nvdim
       Do j=1_t_int,nvdim
          ce=Dot_product(scv(1:nchidim,i),scvbS(1:nchidim,j))
          spbS(i,j)=spbS(i,j)-ce
          spbS(j,i)=spbS(j,i)-Conjg(ce)

#if defined (NEW_FULL_SIGMA_Z)
          !! nothing to do
#else
          Do k=1_t_int,nchidim
             !! 
             ce=Conjg(scv(k,i))*scv(k,j)
             spbS(i,j)=spbS(i,j)+ce*cspchar(k)
          Enddo !
#endif
       Enddo! j
    Enddo ! i
    !!
#if defined (NEW_FULL_SIGMA_Z)
    !!
    !todo: use this new better cv-ortho
    Call ccovalbS_cc_term(nsite,nvdim,nchidim,chiblocklength&
         &,chibSchi,scv,spbS)
#endif
    !!
    !!
    Return
    !!
  End Subroutine ccovalbSfull
  !!***********************************************************************
  Subroutine ccovalbS_cc_term(nsite,nvdim,nchidim,chiblocklength&
       &,chibSchi,scv,spbS)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nvdim,nchidim,nsite,chiblocklength(:)
    Complex(t_real),Intent(in)   :: chibSchi(:,:,:),scv(:,:)
    Complex(t_real),Intent(inout):: spbS(:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="ccovalbS_cc_term"
    Integer(t_int) :: iz,isa,lechi,i,j
    Complex(t_real),Pointer:: aux(:,:)
    !!
    Nullify(Aux)
    !!
    Call palloc('Aux',Aux,1_t_int,nchidim,1_t_int,nvdim,nmodule,nsubfunc)
    !!
    iz=0
    Do isa=1,nsite
       lechi=chiblocklength(isa)
       Aux(iz+1:iz+lechi,1:nvdim)=&
            &Matmul(chibSchi(1:lechi,1:lechi,isa),scv(iz+1:iz+lechi,1:nvdim))
       iz=iz+lechi
    Enddo
    !!
    Do i=1,nvdim
       Do j=1,nvdim
          spbS(i,j)=spbS(i,j)+Dot_product(scv(1:nchidim,i),Aux(1:nchidim,j))
       Enddo
    Enddo
    !!
    !!
    Call pfree(Aux)
    !!
    Return
    !!
  End Subroutine ccovalbS_cc_term
  !!***********************************************************************
  Subroutine ccovalbVSfull(chibVschi,spbVS,scv,scvbVS,nvdim,nchidim&
       &,nsite&
       &,chiblocklength)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nvdim,nchidim,chiblocklength(:),nsite
    Complex(t_real),Intent(inout):: spbVS(:,:,:)
    Complex(t_real),Intent(in)   :: scv  (:,:)
    Complex(t_real),Intent(in)   :: scvbVS(:,:,:)
    Complex(t_real),Intent(in)   :: chibVSchi(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: i,j,ks
    Complex(t_real):: ce
    !!
    !!
    Do ks=1,3
       Do i=1,nvdim
          Do j=1,nvdim
             ce=Dot_product(scv(1:nchidim,i),scvbVS(1:nchidim,j,ks))
             spbVS(i,j,ks)=spbVS(i,j,ks)-ce
             spbVS(j,i,ks)=spbVS(j,i,ks)-Conjg(ce)
             
          Enddo !j
       Enddo !i
       !!
       Call ccovalbS_cc_term(nsite,nvdim,nchidim,chiblocklength&
            &,chibVSchi(:,:,:,ks),scv,spbVS(:,:,ks))
       !!
       !!
    Enddo !ks
  End Subroutine ccovalbVSfull
  !!***********************************************************************
  !!
  Subroutine  checkhermes(nvdim,sp,hp)
    !
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nvdim
    Complex(t_real),Intent(inout):: sp(nvdim,nvdim),hp(nvdim,nvdim)
    !!LOCAL
    Integer(t_int) :: i,j
    Real(t_real)   :: s,d,tol
    Complex(t_real):: ca
    !!
    tol=1.e-12_t_real
    s=0.0_t_real
    d=0.0_t_real
    !!
    Do i=1_t_int,nvdim
       Do j=1_t_int,nvdim
          s=Max(s,Abs(sp(i,j)-Conjg(sp(j,i)))**2)

          ca=(sp(i,j)+Conjg(sp(j,i)))*0.5_t_real

          sp(i,j)=ca
          sp(j,i)=Conjg(ca)


          d=Max(d,Abs(hp(i,j)-Conjg(hp(j,i)))**2)
          

          ca=(hp(i,j)+Conjg(hp(j,i)))*0.5_t_real

          hp(i,j)=ca
          hp(j,i)=Conjg(ca)

          
       Enddo
    Enddo
    s=Sqrt(s)
    d=Sqrt(d)
    If(s > tol .And. outlevel >=L_ALL ) Then
1      Format('CHECKHERMES: max (i|j)   hermicity error ',e30.15e3)
       Write(outfile,1)s
    Endif
    If(d > tol .And. outlevel >=L_ALL) Then
2      Format('CHECKHERMES: max (i|H|j) hermicity error ',e30.15e3)
       Write(outfile,2)d
    Endif
    !!
    !!
  End Subroutine checkhermes
  !!***********************************************************************
  !!
  !!***********************************************************************
  !!
  !! make DOS and IDOS form occupation number 
  !!
  !!
  !!
  Subroutine ndos(ebkfsm,tet,nvdim,nkp,mspin,nspin,ntet,ntetsum,emax,emin &
       &,efermi,nsort,ogrs,onet,mdim,ldos,bwdefactive,lgrs,lnet&
       &,bgrs,bnet,plotbands&
       &,nRvmx,nRv,nnRv,kapRv,isrt,rel,nptdos,plotidos,gammapoint,kT&
       &,plotndos)
    !!
    Implicit None
    !!IO
    !!
    Type(T_LDOS),Intent(in)      ::  ldos
    Logical(t_log),Intent(in)    :: bwdefactive
    !!
    Logical(t_log),Intent(in)    :: rel
    !!
    Logical(t_log),Intent(in)    :: gammapoint
    !!     calc local dos ?
    Logical(t_log),Intent(in)    :: plotbands,plotidos,plotndos
    !!
    Integer(t_int),Intent(in)    :: nsort,isrt(*)
    Integer(t_int),Intent(in)    :: nRvmx,nRv(nsort),kapRv(nRvmx,nsort)
    Integer(t_int),Intent(in)    :: nnRv(nRvmx,nsort)
    !!     maximum of
    !!         1. max number of ang mom qn. (spdf = 4) +1 (=5)
    !!         2. nvm+1 (max number of l-states/per atom)
    Integer(t_int),Intent(in)    :: mdim
    !!
    Integer(t_int),Intent(in)    :: mspin,nspin,nvdim,nkp
    !! number of energy points for DOS
    Integer(t_int),Intent(in)    :: nptdos
    !!     aux tetraedron method,  
    Integer(t_int),Intent(in)    :: ntet,tet(0:5,ntet)
    !! 
    Real(t_real),Intent(in)      :: ntetsum,kT
    !!     boundaries for dos
    Real(t_real),Intent(in)      ::  emax,emin
    !!     band energies,fermi energies
    Real(t_real),Intent(in)      :: ebkfsm(nvdim,nkp,nspin),efermi
    !!     gross occupation numbers,projected
    Real(t_real),Intent(inout)   :: ogrs(nvdim,nkp,mdim,nsort+1,mspin)
    !!     net occupation numbers,projected
    Real(t_real),Intent(inout)   :: onet(nvdim,nkp,mdim,nsort+1,mspin)
    !!     gross occus for local dos
    Real(t_real),Intent(in)      :: lgrs(:,:,:,:,:)!!nvdim,nkp,nvsmx,ldos% nldos,nspin)
    Real(t_real),Intent(in)      :: lnet(:,:,:,:,:)!!nvdim,nkp,nvsmx,ldos% nldos,nspin)
    Real(t_real),Intent(in)      :: bgrs(:,:,:,:)
    Real(t_real),Intent(in)      :: bnet(:,:,:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="ndos"
    Logical(t_log) :: exist,lmsresolved
    Integer(t_int) :: i,ms,ik,in,issa,iva,l,mm,ib,nbw,ivr,kap,lv,nw,iw,ldim
    Integer(t_int) :: irel,nrel,iva0
    Integer :: eof
    Real(t_real)   :: spinfac,e0,e1,beta
    Integer(t_int),Pointer:: ibw(:)
    Real(t_real),Pointer :: idos(:,:,:,:)
    Real(t_real),Pointer :: dos (:,:,:,:)
    Real(t_real),Pointer :: bidos(:,:,:)
    Real(t_real),Pointer :: bdos(:,:,:)
    !!     
    Nullify(bdos,bidos,dos,idos,ibw)
    e0=emin/hatoev
    e1=emax/hatoev
    !!
    ldim=Size(lgrs,3)
    nrel=1
    If(rel)Then
       ldim=Size(lgrs,3)/2
       nrel=2
    Endif
    !!
    spinfac=2.0_t_real/mspin
    If(rel) spinfac=1.0_t_real
    !!
    If(.Not.(isoption('CALC_DOS') .Or. plotbands)) Return 
    !!
    beta=1.0_t_real/(kT/(eVtokT*hatoev))
    !!
    !!
    nbw=1
    Inquire(file=f_dos_bwise,exist=exist)
    If(exist)Then
       Open(12,file=f_dos_bwise)
       nbw=0
       readloop: Do 
          Read(12,*,iostat=eof) i
          If(i>nvdim .or. i<0) Then
             Write(errbuf,666)Trim(f_dos_bwise)
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
666          Format("'File ''",a,"'' contains invalid band number !'")
          Endif
          If(eof < 0_t_int) Exit readloop
          !Print *,'read i=',i
          nbw=nbw+1
          !Read(12,*) 
       Enddo readloop
       !!
       Call palloc('ibw',ibw ,1_t_int,nbw ,nmodule,nsubfunc)
       Rewind(12)
       Do i=1,nbw
          Read(12,*,iostat=eof) ibw(i)
          !Print *,'i=',nbw,i,ibw(i)
       Enddo
       Close(12)
       !!
    Else
       Call palloc('ibw',ibw ,1_t_int,nbw ,nmodule,nsubfunc)
       ibw(1)=0_t_int
    End If
    !!

    !!     partial densities preparation
    !!     the weights a(kn,isort,l) should be:    
    !!     sum_(jl'm',isort(i),m) c(kn,ilm).c*(kn,jl'm').S(k,jl'm',ilm)
    !!     or without S for the net-DOS

    Do ms=1_t_int,mspin
       Do ik=1_t_int,nkp
          Do in=1_t_int,nvdim
             Do issa=1_t_int,nsort
                iva=0
                ivrloop: Do ivr=1,nRv(issa)
                   kap=kapRv(ivr,issa)
                   If(kap>0)Cycle ivrloop
                   lv=(Abs(2*kap+1)-1)/2
                   iva=iva+1
                   !!               mdim,issa= total of site issa
                   ogrs(in,ik,mdim,issa,ms)=ogrs(in,ik,mdim,issa,ms)&
                        &           +ogrs(in,ik,iva,issa,ms)
                   onet(in,ik,mdim,issa,ms)=onet(in,ik,mdim,issa,ms)&
                        &           +onet(in,ik,iva,issa,ms)
                   !!               total of ang mom iva
                   l=lv+1
                   ogrs(in,ik,l,nsort+1,ms)=ogrs(in,ik,l,nsort+1,ms)&
                        &           +ogrs(in,ik,iva,issa,ms)
                   onet(in,ik,l,nsort+1,ms)=onet(in,ik,l,nsort+1,ms)&
                        &           +onet(in,ik,iva,issa,ms)
                   !!               total absolut
                   ogrs(in,ik,mdim,nsort+1,ms)=&
                        &           ogrs(in,ik,mdim,nsort+1,ms)&
                        &           +ogrs(in,ik,iva,issa,ms)
                   onet(in,ik,mdim,nsort+1,ms)=&
                        &           onet(in,ik,mdim,nsort+1,ms)&
                        &           +onet(in,ik,iva,issa,ms)
                Enddo ivrloop             ! iva
             Enddo               ! isa
             If(.Not.rel)Then
                ogrs(in,ik,mdim,nsort+1,ms)=1.0_t_real
             Endif
          Enddo                 ! in
       Enddo                   ! ik
    Enddo                     ! ms        

    !!     

    Call palloc('idos',idos,1_t_int,nptdos,1_t_int,mdim,1_t_int,nsort+1&
         &,1_t_int,mspin,nmodule,nsubfunc)
    Call palloc('dos',dos,1_t_int,nptdos,1_t_int,mdim,1_t_int,nsort+1&
         &,1_t_int,mspin,nmodule,nsubfunc)

    bwiseloopd: Do ib=1,nbw
       
       idos(1:nptdos,1:mdim,1:nsort+1,1:mspin)=0.0_t_real
       dos(1:nptdos,1:mdim,1:nsort+1,1:mspin)=0.0_t_real
       !!
       Do ms=1,mspin
          mm=ms
          If(rel)mm=1
          
          Do issa=1,nsort+1
             Do iva = 1_t_int, mdim
                If(gammapoint)Then
                   Call gamdos(dos(:,iva,issa,ms),idos(:,iva,issa,ms)&
                        &,ebkfsm(:,1,mm),e1+efermi,e0+efermi,nvdim,nptdos&
                        &,ogrs(:,1,iva,issa,ms),spinfac,ibw(ib),beta)
                Else
                   Call tetdos(dos(:,iva,issa,ms),idos(:,iva,issa,ms)&
                        &,ebkfsm(:,:,mm),e1+efermi,e0+efermi,tet,nvdim,nkp&
                        &,nptdos,ntet,ntetsum&
                        &,ogrs(:,:,iva,issa,ms),spinfac,ibw(ib))
                Endif
             Enddo
          Enddo
       Enddo
       
       !!
       Call prdos(e0,e1,nptdos,nsort,mspin,dos,mdim&
            &,nRvmx,nRv,nnRv,kapRv,.False.,plotidos,' ',idos,ibw(ib))
       !!

       If(plotndos)Then
          
          idos(1:nptdos,1:mdim,1:nsort+1,1:mspin)=0.0_t_real
          dos(1:nptdos,1:mdim,1:nsort+1,1:mspin)=0.0_t_real
          !!
          Do ms=1,mspin
             mm=ms
             If(rel)mm=1
             
             Do issa=1,nsort+1
                Do iva = 1_t_int, mdim
                   If(gammapoint)Then
                      Call gamdos(dos(:,iva,issa,ms),idos(:,iva,issa,ms)&
                           &,ebkfsm(:,1,mm),e1+efermi,e0+efermi,nvdim,nptdos&
                           &,onet(:,1,iva,issa,ms),spinfac,ibw(ib),beta)
                   Else
                      Call tetdos(dos(:,iva,issa,ms),idos(:,iva,issa,ms)&
                           &,ebkfsm(:,:,mm),e1+efermi,e0+efermi,tet,nvdim,nkp&
                           &,nptdos,ntet,ntetsum&
                           &,onet(:,:,iva,issa,ms),spinfac,ibw(ib))
                   Endif
                Enddo
             Enddo
          Enddo
          
          !!
          Call prdos(e0,e1,nptdos,nsort,mspin,dos,mdim&
               &,nRvmx,nRv,nnRv,kapRv,.False.,plotidos,'n',idos,ibw(ib))
       Endif !! plotndos
       !!
    End Do bwiseloopd
    !!
    Call pfree(dos)
    Call pfree(idos)
    !!
    !!     local dos
    ldosif: If(ldos% plotldos)Then
       !Print *,'ldim=',Size(lgrs,3),ldim
       Call palloc('idos',idos,1_t_int,nptdos,1_t_int,ldim&
            &,1_t_int,ldos% nldos,1_t_int,nspin,nmodule,nsubfunc)
       Call palloc('dos' ,dos ,1_t_int,nptdos,1_t_int,ldim&
            &,1_t_int,ldos% nldos,1_t_int,nspin,nmodule,nsubfunc)
       !!
       irelloop: Do irel=1,nrel
          !!
          iva0=ldim*(irel-1)
          lmsresolved=(irel==2)
          !!
          bwiseloop: Do ib=1,nbw
             !!
             idos=0.0_t_real
             dos=0.0_t_real
             !!
             !!
             Do ms=1,nspin
                Do issa=1,ldos% nldos
                   Do iva = 1, ldim
                      If(gammapoint)Then
                         Call gamdos(dos(:,iva,issa,ms),idos(:,iva,issa,ms)&
                              &,ebkfsm(:,1,ms),e1+efermi,e0+efermi,nvdim,nptdos&
                              &,lgrs(:,:,iva+iva0,issa,ms),spinfac,ibw(ib),beta)
                      Else
                         Call tetdos(dos(:,iva,issa,ms),idos(:,iva,issa,ms)&
                              &,ebkfsm(:,:,ms),e1+efermi,e0+efermi,tet,nvdim,nkp&
                              &,nptdos,ntet,ntetsum&
                              &,lgrs(:,:,iva+iva0,issa,ms),spinfac,ibw(ib))
                      Endif
                   End Do
                End Do
             End Do
             !!
             Call prldos(e1,e0,nptdos,ldos,mspin,nspin,dos&
                  &,ldim,nRvmx,nRv,nnRv,kapRv,isrt,ibw(ib),' ',' ',rel,lmsresolved)
             If(plotidos)&
                  & Call prldos(e1,e0,nptdos,ldos,mspin,nspin,idos&
                  &,ldim,nRvmx,nRv,nnRv,kapRv,isrt,ibw(ib),'i',' ',rel,lmsresolved)
             
             
             nldosif: If(plotndos)Then
                
                idos=0.0_t_real
                dos=0.0_t_real
                
                Do ms=1,nspin
                   Do issa=1,ldos% nldos
                      Do iva = 1, ldim
                         If(gammapoint)Then
                            Call gamdos(dos(:,iva,issa,ms),idos(:,iva,issa,ms)&
                                 &,ebkfsm(:,1,ms),e1+efermi,e0+efermi,nvdim,nptdos&
                                 &,lnet(:,:,iva+iva0,issa,ms),spinfac,ibw(ib),beta)
                         Else
                            Call tetdos(dos(:,iva,issa,ms),idos(:,iva,issa,ms)&
                                 &,ebkfsm(:,:,ms),e1+efermi,e0+efermi,tet,nvdim,nkp&
                                 &,nptdos,ntet,ntetsum&
                                 &,lnet(:,:,iva+iva0,issa,ms),spinfac,ibw(ib))
                         Endif
                      End Do
                   End Do
                End Do
                !!
                Call prldos(e1,e0,nptdos,ldos,mspin,nspin,dos&
                     &,ldim,nRvmx,nRv,nnRv,kapRv,isrt,ibw(ib),' ','n',rel,lmsresolved)
                If(plotidos)&
                     & Call prldos(e1,e0,nptdos,ldos,mspin,nspin,idos&
                     &,ldim,nRvmx,nRv,nnRv,kapRv,isrt,ibw(ib),'i','n',rel,lmsresolved)
                !!
             Endif nldosif
          End Do bwiseloop
       End Do irelloop
       !!
       Call pfree(idos)
       Call pfree(dos)
       Write(outfile,1)
       !!     
       !!
    Endif ldosif
    !!
    If(bwdefactive)Then
       nw=cfatbandnumweights()
       Call palloc('bidos',bidos,1_t_int,nptdos,1_t_int,nw,1_t_int,nspin&
            &,nmodule,nsubfunc)
       Call palloc('bdos',bdos,1_t_int,nptdos,1_t_int,nw,1_t_int,nspin&
            &,nmodule,nsubfunc)
       
       bwiseloopb: Do ib=1,nbw
          
          bidos(1:nptdos,1:nw,1:nspin)=0.0_t_real
          bdos(1:nptdos,1:nw,1:nspin)=0.0_t_real
          Do ms=1,nspin
             Do iw=1,nw
                If(gammapoint)Then
                   Call gamdos(bdos(:,iw,ms),bidos(:,iw,ms)&
                        &,ebkfsm(:,1,ms),e1+efermi,e0+efermi,nvdim,nptdos&
                        &,bgrs(:,:,iw,ms),spinfac,ibw(ib),beta)
                Else
                   Call tetdos(bdos(:,iw,ms),bidos(:,iw,ms)&
                        &,ebkfsm(:,:,ms),e1+efermi,e0+efermi,tet,nvdim,nkp&
                        &,nptdos,ntet,ntetsum&
                        &,bgrs(:,:,iw,ms),spinfac,ibw(ib))
                Endif
             End Do
          End Do
          !!
          Call prbdos(e1,e0,nptdos,nspin,bidos,bdos&
               &,nw,nRvmx,nRv,nnRv,kapRv,isrt,ibw(ib),plotidos,' ',rel)
       Enddo bwiseloopb

       If(plotndos)Then

          bwiseloopb1: Do ib=1,nbw
             
             bidos(1:nptdos,1:nw,1:nspin)=0.0_t_real
             bdos(1:nptdos,1:nw,1:nspin)=0.0_t_real
             !!
             Do ms=1,nspin
                Do iw=1,nw
                   If(gammapoint)Then
                      Call gamdos(bdos(:,iw,ms),bidos(:,iw,ms)&
                           &,ebkfsm(:,1,ms),e1+efermi,e0+efermi,nvdim,nptdos&
                           &,bnet(:,:,iw,ms),spinfac,ibw(ib),beta)
                   Else
                      Call tetdos(bdos(:,iw,ms),bidos(:,iw,ms)&
                           &,ebkfsm(:,:,ms),e1+efermi,e0+efermi,tet,nvdim,nkp&
                           &,nptdos,ntet,ntetsum&
                           &,bnet(:,:,iw,ms),spinfac,ibw(ib))
                   Endif
                End Do
             End Do
             !!
             Call prbdos(e1,e0,nptdos,nspin,bidos,bdos&
                  &,nw,nRvmx,nRv,nnRv,kapRv,isrt,ibw(ib),plotidos,'n',rel)
             !!
          End Do bwiseloopb1
       Endif
       !!
       Call pfree(bdos)
       Call pfree(bidos)
       !!
    Endif
    !!
    Call pfree(ibw)
    !!
    Return
    !!
1   Format(/,'Local density of states calculated !',/)
    !!
  End Subroutine ndos
  !!***********************************************************************
  !!
  !! write DOS and IDOS to files
  !!
  Subroutine prdos(emin,emax,ne,nsort,mspin,dos,mdim&
       &,nRvmx,nRv,nnRv,kapRv,BEB,plotidos,prefix,idos,ib)
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)      :: prefix
    Integer(t_int),Intent(in)    :: nsort,mspin,mdim,ne
    Integer(t_int),Intent(in)    :: nRvmx,nRv(nsort),kapRv(nRvmx,nsort)
    Integer(t_int),Intent(in)    :: nnRv(nRvmx,nsort)
    Real(t_real),Intent(in)      :: emax,emin,dos(ne,mdim,nsort+1_t_int,mspin)
    Logical(t_log),Intent(in)    :: BEB,plotidos
    Integer(t_int),Intent(in),Optional :: ib
    Real(t_real),Intent(in),Optional   :: idos(ne,mdim,nsort+1_t_int,mspin)
    !!LOCAL
    Character(*),Parameter::nsubfunc="prdos"
    Logical(t_log) :: prib
    Integer(t_int) :: issa,iva,i,nn,ms,ivr,kap,iv0,lv,nmain
    Real(t_real)   :: de,e,f,unit
    Character(100) :: str
    Integer(t_int),Pointer :: p_nv(:),p_lv(:,:),p_nnv(:,:)
    !!
    Nullify(p_nv)
    Nullify(p_lv)
    Nullify(p_nnv)
    !!
    Call palloc('p_nv',p_nv,1_t_int,nsort,nmodule,nsubfunc)
    Call palloc('p_lv',p_lv,1_t_int,nRvmx,1_t_int,nsort,nmodule,nsubfunc)
    Call palloc('p_nnv',p_nnv,1_t_int,nRvmx,1_t_int,nsort,nmodule,nsubfunc)
    !!
#if defined (DATA_FILES_IN_DIRS)
    Call mkdirectory('+dos')
#endif
    !!
    Do issa=1,nsort
       iv0=0
       ivrloop1: Do ivr=1,nRv(issa)
          kap=kapRv(ivr,issa)
          nmain=nnRv(ivr,issa)
          lv=(Abs(2*kap+1)-1)/2
          If(kap>0) Cycle ivrloop1
          iv0=iv0+1
          p_lv(iv0,issa)=lv
          p_nnv(iv0,issa)=nmain
       Enddo ivrloop1
       p_nv(issa)=iv0
    Enddo
    !!
    prib=Present(ib)
    If(.Not.BEB .And. plotidos)Then
       If(.Not.Present(idos))Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Missing argument idos !'")
       Endif
    Endif
    !!
    de = (emax-emin)/(ne-1_t_int)
    !!     ha->eV
    unit=hatoev
    !!     
    Do issa=1_t_int,nsort+1_t_int
       If(issa<=nsort)Then
          nn=p_nv(issa)
       Else
          nn=ORBITAL_MAX_L+1_t_int
       Endif
       Do iva=1_t_int,mdim
          If((iva > nn) .And. (iva /= mdim)) Goto 1000
          If(prib .And. ib>0)Then
             Write(str,119)ib
          Else
             str=' '
          Endif
          !!
          Call open_dos_file(12,' ',prefix,str,issa,iva,nsort,mdim)
          If(.Not.BEB .And. plotidos)Then
             Call open_dos_file(13,'i',prefix,str,issa,iva,nsort,mdim)
          Endif
          !!
          Do ms=1_t_int,mspin
             !!
             f=3.0_t_real-2.0_t_real*Real(ms,t_real)
             If(issa == nsort+1_t_int)Then
                If(iva == mdim) Then
                   Write(12,14)ms
                   If(.Not.BEB .And. plotidos) Write(13,14)ms
                Else
                   Write(12,15)iva-1_t_int,ms
                   If(.Not.BEB .And. plotidos) Write(13,15)iva-1_t_int,ms
                Endif
             Else
                If(iva == mdim) Then
                   Write(12,13)issa,ms
                   If(.Not.BEB .And. plotidos) Write(13,13)issa,ms
                Else
                   Write(12,12)issa,p_nnv(iva,issa),lqnchar(p_lv(iva,issa)),ms
                   If(.Not.BEB .And. plotidos) &
                        &Write(13,12)issa,p_nnv(iva,issa),lqnchar(p_lv(iva,issa)),ms
                Endif
             Endif
             Do i=1_t_int,ne
                e=Real(i-1_t_int,t_real)*de+emin
30              Format(2(e30.15e3,2x))
                Write(12,30) e*unit,dos(i,iva,issa,ms)*f/unit
                If(.Not.BEB .And. plotidos)Then
                   Write(13,30) e*unit,idos(i,iva,issa,ms)*f
                Endif
             Enddo               ! i
             Write(12,11)
             If(.Not.BEB .And. plotidos) Write(13,11)
          Enddo                 ! ms
          Close(12)
          If(.Not.BEB .And. plotidos) Close(13)
1000      Continue 
       Enddo                   ! iv
    Enddo                     ! issa
    !!      
    Write(outfile,1)
    !!
    Call pfree(p_nnv)
    Call pfree(p_nv)
    Call pfree(p_lv)
    !!
    !!
    !!
    Return
    !!
1   Format(/,'Density of states calculated !',/)
11  Format(' ')
12  Format('# sort = ',i4,'  nl = ',i1,a1, ' spin = ',i4)
13  Format('# sort = ',i4,' spin = ',i4)
14  Format('# spin = ',i4)
15  Format('# l = ',i4, ' spin = ',i4)
    !!
    !!
119 Format('.b',i5.5)
    !!
  Contains
    !!***********************************************************************
    Subroutine open_dos_file(lun,iprefix,prefix,suffix,issa,iva,nsort,mdim)
      !!
      Implicit None
      !!IO
      Integer,Intent(in)           :: lun
      Character(*),Intent(in)      :: iprefix,prefix,suffix
      Integer(t_int),Intent(in)    :: issa,iva,nsort,mdim
      !!LOCAL
      !Character(*),Parameter::nsubfunc="open_dos_file"
      Character(500)   :: str,strnl,strsort
      !!
      strnl=' '
      strsort='.total'
      !!
      !!
      If(issa<=nsort)Then
         Write(strsort,"('.sort',i3.3)")issa
         If(iva/=mdim)Then
            Write(strnl,"('.nl',i3.3)")iva
         Endif
      Else
         If(iva/=mdim)Then
            Write(strnl,"('.l',i3.3)")iva
         Endif
      Endif
      !!
      !!
      str='+'//Trim(iprefix)//Trim(prefix)//'dos'//Trim(strsort)//Trim(strnl)&
           &//Trim(suffix)
      !!
#if defined (DATA_FILES_IN_DIRS)
      Call delete_existing_file(lun,str)
      str='+dos/'//Trim(str)
#endif
      !!
      Open(lun,file=Trim(str),status='unknown')
      !!
      Return
      !!
      !!
    End Subroutine open_dos_file
    !!***********************************************************************
  End Subroutine prdos
  !!***********************************************************************
  !!
  !! write local DOS and IDOS to files
  !!
  Subroutine prldos(emax,emin,nptdos,ldos,mspin,nspin&
       &,dos,ldim,nRvmx,nRv,nnRv,kapRv,isrt,ib,idosprefix,prefix&
       &,rel,lmsresolved)
    !!
    Implicit None
    !!IO
    Type(T_LDOS),Intent(in)      :: ldos
    Logical(t_log),Intent(in)    :: rel,lmsresolved
    Integer(t_int),Intent(in)    :: ib
    Character(*),Intent(in)      :: idosprefix,prefix
    Integer(t_int),Intent(in)    :: nptdos,mspin,nspin,ldim,isrt(*)
    Integer(t_int),Intent(in)    :: nRvmx,nRv(*),kapRv(nRvmx,*),nnRv(nRvmx,*)
    Real(t_real),Intent(in)      :: emax,emin
    Real(t_real),Intent(in)      :: dos(nptdos,ldim,ldos% nldos,nspin)
    !!LOCAL
    Integer(t_int) :: ild,isa,issa,i,ms,iva,ma,ii,ivr,kap,lv,nmain,jv,mua
    Integer(t_int) :: deg,msp,ns
    Logical(t_log) :: prlmode
    Real(t_real)  :: de,e,f,eunit,dunit
    Character(100)  :: str,nlj
    !!
#if defined (DATA_FILES_IN_DIRS)
    Call mkdirectory('+ldos')
#endif
    !!
    msp=mspin
    prlmode=rel
    If(lmsresolved)Then
       prlmode=.False.
       msp=2
    Endif
    !!
    if(prlmode) msp=1
    !Print *,'msp=',msp
    !!
    nlj='.nl'
    If(prlmode) nlj='.nlj'
    !!     ha->eV
    eunit=hatoev
    dunit=hatoev
    if(idosprefix(1:1)=='i') dunit=1.0_t_real
    de = (emax-emin)/(nptdos-1_t_int)
    !!     
    Do ild=1_t_int,ldos% nldos
       isa=ldos% p_ldsites(ild)
       issa=isrt(isa)
       
       ii=0_t_int
       iva=0
       ivrloop: Do ivr=1,nRv(issa)
          kap=kapRv(ivr,issa)
          nmain=nnRv(ivr,issa)
          If((.Not.prlmode).And.kap>0)Cycle ivrloop
          jv=2*Abs(kap)-1
          lv=(Abs(2*kap+1)-1)/2
          deg=2*lv+1
          If(prlmode)deg=jv+1
          iva=iva+1
          If(ib>0)Then
             Write(str,121)Trim(idosprefix),Trim(prefix),isa,Trim(nlj),iva,ib
          Else
             Write(str,21)Trim(idosprefix),Trim(prefix),isa,Trim(nlj),iva
          Endif
#if defined (DATA_FILES_IN_DIRS)
          Call delete_existing_file(13,str)
          str='+ldos/'//Trim(str)
#endif
          Open(13,file=Trim(str),status='unknown')
          !Print *,'ivr=',ivr
          Do ma=1,deg
             !Print *,'ma=',ma
             mua=ma-1-lv
             If(prlmode) mua=2*(ma-1)-jv
             ii=ii+1_t_int
             Do ms=1,msp
                !Print *,'ms=',ms
                !Print *,'ii=',ii
                ns=ms
                If(lmsresolved.And.ms==2) Then
                   ii=ii+1
                   ns=1
                Endif
                !Print *,'ii=',ii
                
                f=3.0_t_real-2.0_t_real*Real(ms,t_real)
                If(prlmode)Then
                   Write(13,14)isa,nmain,lqnchar(lv),jv,mua
                Else
                   Write(13,12)isa,nmain,lqnchar(lv),mua,ms
                Endif
                Do i=1_t_int,nptdos
                   e=Real(i-1_t_int,t_real)*de+emin
22                 Format(2(e30.15e3,2x))
                   Write(13,22)e*eunit,dos(i,ii,ild,ns)*f/dunit
                Enddo             ! i
                Write(13,11)
             Enddo               ! ms
          Enddo                 ! ma
          Close(13)

       Enddo ivrloop
    Enddo                     ! ild
    !!      
11  Format(' ')
12  Format('# site = ',i4,'  nl = ',i1,a1,' m = ',i4,' spin = ',i4)
14  Format('# site = ',i4,'  nlj = ',i1,a1,i1,'/2',' mu = ',i4,'/2')
21  Format('+',a,'l',a,'dos.site',i3.3,a,i3.3)
121 Format('+',a,'l',a,'dos.site',i3.3,a,i3.3,'.b',i5.5)
    
    !!
  End Subroutine prldos
  !!***********************************************************************
  !!
  !! write pattern DOS and IDOS to files
  !!
  Subroutine prbdos(emax,emin,nptdos,nspin,idos&
       &,dos,nw,nRvmx,nRv,nnRv,kapRv,isrt,ib,plotidos,prefix,rel)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: plotidos,rel
    Integer(t_int),Intent(in)    :: ib
    Character(*),Intent(in)      :: prefix
    Integer(t_int),Intent(in)    :: nptdos,nspin,nw,isrt(*)
    Integer(t_int),Intent(in)    :: nRvmx,nRv(*),kapRv(nRvmx,*),nnRv(nRvmx,*)
    Real(t_real),Intent(in)      :: idos(nptdos,nw,nspin)
    Real(t_real),Intent(in)      :: emax,emin
    Real(t_real),Intent(in)      :: dos(nptdos,nw,nspin)
    !!LOCAL
    Integer(t_int) :: iw,m,ms,i,ibwd,icn,ma,la,iva,j,l,nmain,isa,issa,ret
    Integer(t_int) :: m0,m1,nm,kapm,ja,ns,msp,nl,nbwd
    Real(t_real)  :: de,e,f,unit
    Character(100)  :: str,str1,strb
    !!
#if defined (DATA_FILES_IN_DIRS)
    Call mkdirectory('+bdos')
#endif
    !!
    !!     ha->eV
    unit=hatoev
    de = (emax-emin)/(nptdos-1_t_int)
    !!     
    iw=0
    nbwd=cfatbandnumbw()
    Do ibwd=1,nbwd
       If(.Not.cfatbandisactive(ibwd)) Cycle
       If(cfatbandissimple(ibwd))Then
          !Print "('ibwd=',i5)",ibwd
          icn=1
          isa=cfatbandsite(icn,ibwd)
          issa=isrt(isa)
          ret=cfatbandorbtype(icn,ibwd)
          nmain=cfatbandnv(icn,ibwd)
          l=cfatbandlv(icn,ibwd)
          j=cfatbandjv(icn,ibwd)
          m=cfatbandmv(icn,ibwd)
          m0=1
          m1=0
          If(ret == ORB_NL)Then
             m0=-l
             m1=l
          Else If(ret == ORB_NLJ)Then
             m0=0
             m1=j
          Else If(ret == ORB_NLJM)Then
             m0=m
             m1=m
          Else If(ret == ORB_ALL)Then
          Else If(ret == ORB_ALLNLM)Then
          Else If(ret == ORB_NLM)Then
             m0=m
             m1=m
          Else
             Print *,'prbdos ret =' , ret
             Call terminate(TERM_CRASH,'prbdos: simple orb_type not yet implemented!')
          Endif
          !!
          nl=0
          Do iva=1,nRv(issa)
             nm=nnRv(iva,issa)
             kapm=kapRv(iva,issa)
             la=(Abs(2*kapm+1)-1)/2
             ja=(2*Abs(kapm)-1)
             msp=nspin
             If(kapm<0) nl=nl+1
             !!
             !Print "('iva=',i5,' ',i1,a1,i1,'/2')",iva,nm,lqnchar(la),ja
             !!
             If(ret==ORB_NL.Or.ret==ORB_NLM)Then
                If(rel)Then
                   If(kapm>0) Cycle
                   msp=2
                Endif
                If(.Not.(nmain==nm.And. l==la)) Cycle
             Else If(ret==ORB_ALLNLM)Then
                If(rel)Then
                   If(kapm>0) Cycle
                   msp=2
                Endif
             Else if(ret==ORB_NLJ.Or.ret==ORB_NLJM)Then
                If(.Not.(nmain==nm.And. l==la.And.j==ja)) Cycle
             Else If(ret/=ORB_All.And.ret/=ORB_ALLNLM)Then
                Print *,'prbdos ret =' , ret
                Call terminate(TERM_CRASH,'prbdos: simple orb_type not yet implemented!')
             Endif
             !!
             !Print "('doing ',i1,a1)",nm,lqnchar(la)
             If((ret==ORB_NL.Or.ret==ORB_NLM.Or.ret==ORB_ALLNLM.Or.&
                  &((.Not.rel).And.ret==ORB_ALL)))Then
                Write(str1,"('.nl',i3.3)")nl
             Else
                Write(str1,"('.nlj',i3.3)")iva
             Endif
             !!
             strb=' '
             If(ib>0)Then
                Write(strb,119)ib
             Endif
             !!
             Write(str,20)'',Trim(prefix),ibwd,isa,Trim(str1)
             str=Trim(str)//Trim(strb)
#if defined (DATA_FILES_IN_DIRS)
             Call delete_existing_file(12,str)
             str='+bdos/'//Trim(str)
#endif
             Open(12,file=Trim(str),status='unknown')
             
             If(plotidos)Then
                Write(str,20)'i',Trim(prefix),ibwd,isa,Trim(str1)
                str=Trim(str)//Trim(strb)
#if defined (DATA_FILES_IN_DIRS)
                Call delete_existing_file(13,str)
                str='+bdos/'//Trim(str)
#endif
                Open(13,file=Trim(str),status='unknown')
             Endif
             
             If(ret== ORB_ALL)Then
                m0=-la
                m1=la
                If(rel)Then
                   m0=0
                   m1=ja
                Endif
             Endif
             If(ret== ORB_ALLNLM)Then
                m0=-la
                m1=la
             Endif
             !Print "('m \in [',i3,',',i3,']')",m0,m1
             Do ma=m0,m1
                iw=iw+1
                !Print "('m=',i3,' iw=',i3)",ma,iw
                Do ms=1,msp
                   ns=ms
                   if(rel)ns=1
                   f=3.0_t_real-2.0_t_real*Real(ms,t_real)
                   Write(12,12)Trim(cfatbandweightlabel(iw)),ms&
                        &,cfatbandaxes(icn,ibwd)
                   If(plotidos)Then
                      Write(13,12)Trim(cfatbandweightlabel(iw)),ms&
                           &,cfatbandaxes(icn,ibwd)
                   Endif
                   Do i=1_t_int,nptdos
                      e=Real(i-1_t_int,t_real)*de+emin
22                    Format(2(e30.15e3,2x))
                      Write(12,22)e*unit,dos(i,iw,ns)*f/unit
                      If(plotidos)Then
                         Write(13,22)e*unit,idos(i,iw,ns)*f
                      Endif
                   Enddo             ! i
                   Write(12,11)
                   If(plotidos)Then
                      Write(13,11)
                   Endif
                   If(rel.And.msp==2.And.ms==1) iw=iw+1
                Enddo               ! ms
             Enddo                 ! ma
             Close(12)
             If(plotidos)Then
                Close(13)
             Endif

          Enddo ! iva
          
       Else ! molecular
          iw=iw+1
          !!
          icn=1
          ret=cfatbandorbtype(icn,ibwd)
          msp=nspin
          If(rel.And.(ret==ORB_NL.Or.ret==ORB_NLM))Then
             msp=2
          Endif
          !!
          strb=' '
          If(ib>0)Then
             Write(strb,119)ib
          Endif

          Write(str,320)'',Trim(prefix),ibwd
          str=Trim(str)//Trim(strb)
#if defined (DATA_FILES_IN_DIRS)
          Call delete_existing_file(12,str)
          str='+bdos/'//Trim(str)
#endif
          Open(12,file=Trim(str),status='unknown')
          If(plotidos)Then
             Write(str,320)'i',Trim(prefix),ibwd
             str=Trim(str)//Trim(strb)
#if defined (DATA_FILES_IN_DIRS)
             Call delete_existing_file(13,str)
             str='+bdos/'//Trim(str)
#endif
             Open(13,file=Trim(str),status='unknown')
          Endif
          !!
          Do ms=1,msp
             ns=ms
             If(rel)ns=1

             f=3.0_t_real-2.0_t_real*Real(ms,t_real)
             Write(12,312)Trim(cfatbandweightlabel(iw)),ms
             If(plotidos)Then
                Write(13,312)Trim(cfatbandweightlabel(iw)),ms
             Endif
             Do i=1_t_int,nptdos
                e=Real(i-1_t_int,t_real)*de+emin
                Write(12,22)e*unit,dos(i,iw,ns)*f/unit
                If(plotidos)Then
                   Write(13,22)e*unit,idos(i,iw,ns)*f
                Endif
             Enddo             ! i
             Write(12,11)
             If(plotidos)Then
                Write(13,11)
             Endif
             If(rel.And.msp==2.And.ms==1) iw=iw+1
          Enddo               ! ms
          Close(12)
          If(plotidos)Then
             Close(13)
          Endif
          
       Endif
       
       
       
    Enddo ! ibwd
    !!      
    Write(outfile,1)
    !!     
1   Format(/,'Pattern density of states calculated !',/)
11  Format(' ')
!12  Format('# site = ',i4,'  nl = ',i1,a1,' m = ',i4,' spin = ',i4&
12  Format('# name=',a,' spin = ',i4,' ',a)
312 Format('# name=',a,' spin = ',i4)
20  Format('+',a,'b',a,'dos.b',i3.3,'.site',i3.3,a)
119 Format('.b',i5.5)
320  Format('+',a,'b',a,'dos.b',i3.3)
    
    !!
  End Subroutine prbdos
  !!***********************************************************************
  !! integrate aux occus about band-weights
  !!
  !!
  !!
  Subroutine popa(mspin,nspin,nsite,isrt,nsort,nkp,nband,nvdim&
       &,nRvmx,nRv,kapRv,onet,ogrs,net,grs,bweitk,mdim,rel)
    !!
    !!***********************************************************************
    !!
    Implicit None
    !!IO
    !! full relativistic?
    Logical(t_log),Intent(in)    :: rel
    !!     number of spins, (relativistic) spin dimension
    Integer(t_int),Intent(in)    :: mspin,nspin
    !!     number sites in unit cell
    Integer(t_int),Intent(in)    :: nsite,isrt(nsite)
    !!     number of sorts in unit cell
    Integer(t_int),Intent(in)    :: nsort
    !!     number of k-points in irred. BZ
    Integer(t_int),Intent(in)    :: nkp
    !!     number of occupied bands,matrix dim
    Integer(t_int),Intent(in)    :: nband,nvdim
    !!
    Integer(t_int),Intent(in)    :: nRvmx,nRv(nsort),kapRv(nRvmx,nsort)
    !!     max of
    !!       1. (spdf=4) +1 (=5)
    !!       2. max no. of l-states per atom (nvm) +1
    Integer(t_int),Intent(in)    :: mdim
    !!     aux net gross occu
    Real(t_real),Intent(in)     :: onet(nvdim,nkp,mdim,nsort+1_t_int,mspin)
    Real(t_real),Intent(in)     :: ogrs(nvdim,nkp,mdim,nsort+1_t_int,mspin)
    !!     net gross occu
    Real(t_real),Intent(inout)  :: net(nsite,nRvmx,mspin)
    Real(t_real),Intent(inout)  :: grs(nsite,nRvmx,mspin)
    !!     band weights
    Real(t_real),Intent(in)     :: bweitk(nband,nkp,nspin)
    !!LOCAL
    !!     spin,k-point,band-index,site,sort,valence-state
    Integer(t_int) :: ms,ik,in,isa,issa,ivr,iv0,mm
    !! multiplicity of Wyckoff-position
    Integer(t_int) :: mult(nsort)

    !!
    !!***********************************************************************
    !!     multiplicities
    mult(1_t_int:nsort)=0_t_int
    Do isa=1_t_int,nsite
       issa=isrt(isa)
       mult(issa)=mult(issa)+1_t_int
    Enddo
    !!     band weight integration
    Do ms=1_t_int,mspin
       mm=ms
       if(rel)mm=1
       Do isa=1_t_int,nsite
          issa=isrt(isa)
          iv0=0
          ivrloop: Do ivr=1_t_int,nRv(issa)
             If(kapRv(ivr,issa)>0)Cycle ivrloop
             iv0=iv0+1
             Do ik=1_t_int,nkp
                Do in=1_t_int,nband
                   net(isa,iv0,ms)=net(isa,iv0,ms) &
                        & +onet(in,ik,iv0,issa,ms)&
                        &*bweitk(in,ik,mm)/mult(issa)
                   grs(isa,iv0,ms)=grs(isa,iv0,ms)&
                        & +ogrs(in,ik,iv0,issa,ms)&
                        &*bweitk(in,ik,mm)/mult(issa)
                Enddo                 ! in
             Enddo                   ! ik
          Enddo ivrloop
       Enddo               ! isa
    Enddo                     ! ms
    !!
  End Subroutine popa
  !!***********************************************************************
  !!           
  !!   net and gross occupation numbers
  !!  
  !!TODO: relativistic spin-occupation
  !!
  Subroutine prtanal(nvdim,net,gros,nsite,nsort,isrt,elements&
       &,conao,natom,mspin,nRvmx,nRv,nnRv,kapRv,corecharge)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nvdim,nsite,mspin,isrt(nsite),nsort
    Integer(t_int),Intent(in)    :: nRvmx,nRv(nsort),kapRv(nRvmx,nsort)
    Integer(t_int),Intent(in)    :: nnRv(nRvmx,nsort)
    Character(2),Intent(in)     :: elements(:)
    Real(t_real),Intent(in)     :: conao(*),natom(*)
    Real(t_real),Intent(in)     :: corecharge(nsort)
    Real(t_real),Intent(in)     :: net(nsite,nRvmx,mspin)
    Real(t_real),Intent(in)     :: gros(nsite,nRvmx,mspin)
    !!LOCAL
    Character(*),Parameter::nsubfunc="prtanal"
    Integer(t_int) :: isa,issa,iv0,ms,i,j,im,lv,kap,n,ivr,nmain
    Real(t_real)  :: a,b,c,d,e,f,r,s,z,con
    !! auto arrays
    Integer(t_int) :: ic(nsite)
    Real(t_real)  :: rn(nvdim),rg(nvdim),sn(nvdim),sg(nvdim)
    Real(t_real)  :: zv(nsite)
    Integer(t_int),Pointer :: p_nv(:),p_lv(:,:),p_nnv(:,:),p_nf(:,:)
    !!
    Nullify(p_nv)
    Nullify(p_lv)
    Nullify(p_nnv)
    Nullify(p_nf)
    !!
    !!
    Call palloc('p_nv',p_nv,1_t_int,nsort,nmodule,nsubfunc)
    Call palloc('p_lv',p_lv,1_t_int,nRvmx,1_t_int,nsort,nmodule,nsubfunc)
    Call palloc('p_nnv',p_nnv,1_t_int,nRvmx,1_t_int,nsort,nmodule,nsubfunc)
    Call palloc('p_nf',p_nf,1_t_int,nRvmx*nsite,1_t_int,nsite&
         &,nmodule,nsubfunc)
    !!
    !!
    !!
    Do issa=1,nsort
       iv0=0
       ivrloop1: Do ivr=1,nRv(issa)
          kap=kapRv(ivr,issa)
          nmain=nnRv(ivr,issa)
          lv=(Abs(2*kap+1)-1)/2
          If(kap>0) Cycle ivrloop1
          iv0=iv0+1
          p_lv(iv0,issa)=lv
          p_nnv(iv0,issa)=nmain
       Enddo ivrloop1
       p_nv(issa)=iv0
    Enddo
    !!
    !!
    p_nf(1:nRvmx*nsite,1:nsite)=0_t_int
    !!
1   Format(72('-'),/,27x,'   Population Analysis ')
    Write(outfile,1)
2   Format(27x,'(valence electron numbers) ',/,/)
    Write(outfile,2)
3   format(7x,'El',1x,'Site ')
    Write(outfile,3,advance='no')
    !!     
    z=0.0_t_real
    Do isa=1_t_int,nsite
       ic(isa)=1_t_int
       issa=isrt(isa)
       con=conao(issa)
       zv(isa)=natom(issa)-corecharge(issa)
       z=z+zv(isa)*con
    Enddo
    im=0
    Do i=1,nRvmx*nsite
!!$       lm=1000
!!$       Do isa=1,nsite
!!$          issa=isrt(isa)
!!$          j=ic(isa)
!!$          If(j <= p_nv(issa))Then
!!$             lm=Min(lm,p_lv(j,issa))
!!$          Endif
!!$       Enddo
       !!        print *,(ic(k),k=1,nsite)
       !!        print *,lm
       n=0_t_int
       Do isa=1_t_int,nsite
          issa=isrt(isa)
          j=ic(isa)
          If(j <= p_nv(issa)) Then
             !If(p_lv(j,issa) == lm)Then
             p_nf(i,isa)=1
             im=i
             ic(isa)=ic(isa)+1
             !Else
             !   p_nf(i,isa)=0
             !Endif
          Else
             p_nf(i,isa)=0
          Endif
          n=n+p_nf(i,isa)
       Enddo                   ! isa
4      Format(5x,a1,'     ')
       If(n > 0_t_int)Write(outfile,4,advance='no')' ' ! lqnchar(lm)
    Enddo                     ! i 
5   Format(4x,'SUM       Excess electrons')
    Write(outfile,5)
    !!
    a=0.0_t_real
    b=0.0_t_real
    c=0.0_t_real
    d=0.0_t_real
    Do isa=1_t_int,nsite
       issa=isrt(isa)
       con=conao(issa)
       rn(1_t_int:nvdim)=0.0_t_real
       sn(1_t_int:nvdim)=0.0_t_real
       rg(1_t_int:nvdim)=0.0_t_real
       sg(1_t_int:nvdim)=0.0_t_real
       e=0.0_t_real
       f=0.0_t_real
       r=0.0_t_real
       s=0.0_t_real
       ivrloop5: Do iv0=1,p_nv(issa)
          If(mspin > 1_t_int) Then
             sn(iv0)=net(isa,iv0,1_t_int)-net(isa,iv0,2_t_int)
             e=e+sn(iv0)
             sg(iv0)=gros(isa,iv0,1_t_int)-gros(isa,iv0,2_t_int)
             f=f+sg(iv0)
          Endif
          Do ms=1_t_int,mspin
             rn(iv0)=rn(iv0)+net(isa,iv0,ms)
             rg(iv0)=rg(iv0)+gros(isa,iv0,ms)
          Enddo                 ! ms
          r=r+rn(iv0)
          s=s+rg(iv0)
       Enddo ivrloop5
       !!       total spin
       a=a+e*con
       b=b+f*con
       !!       total charge
       c=c+r*con
       d=d+s*con
       !!
       !!
56      Format(14(' '))
       Write(outfile,56,advance='no') 
       iv0=1
       Do i=1,im
          If(p_nf(i,isa) /= 0_t_int) Then
57           Format(6x,i1,a1,'   ')
             Write(outfile,57,advance='no')&
                  &p_nnv(iv0,issa),lqnchar(p_lv(iv0,issa))
             iv0=iv0+1
          Else
             Write(outfile,8,advance='no')
          Endif
       Enddo
       Write(outfile,24)
       !!
6      Format('N_net  ',a2,1x,i3,1x)
       Write(outfile,6,advance='no') elements(issa),isa
       iv0=1
       Do i=1,im
          If(p_nf(i,isa) /= 0_t_int) Then
7            Format(1x,f9.5,' ')
             Write(outfile,7,advance='no')rn(iv0)
             iv0=iv0+1
          Else
             Write(outfile,8,advance='no')
8            Format(10x,' ')
          Endif
       Enddo
9      Format(1x,f10.5)
       Write(outfile,9)r
       !!
10     Format('N_gros ',a2,1x,i3,1x)
       Write(outfile,10,advance='no')elements(issa),isa
       iv0=1
       Do i=1,im
          If(p_nf(i,isa) /= 0_t_int) Then
11           Format(1x,f9.5,' ')
             Write(outfile,11,advance='no')rg(iv0)
             iv0=iv0+1
          Else
             Write(outfile,12,advance='no')
12           Format(10x,' ')
          Endif
       Enddo
13     Format(1x,2(f10.5,1x),/)
       Write(outfile,13)s,s-zv(isa)
       !!
       If(mspin == 2_t_int)Then
14        Format('S_net  ',a2,1x,i3,1x)
          Write(outfile,14,advance='no') elements(issa),isa
          iv0=1
          Do i=1,im
             If(p_nf(i,isa) /= 0_t_int) Then
15              Format(1x,f9.5,' ')
                Write(outfile,15,advance='no')sn(iv0)
                iv0=iv0+1
             Else
                Write(outfile,16,advance='no')
16              Format(10x,' ')
             Endif
          Enddo

          Write(outfile,9)e
18        Format('S_gros ',a2,1x,i3,1x)
          Write(outfile,18,advance='no') elements(issa),isa
          iv0=1
          Do i=1,im
             If(p_nf(i,isa) /= 0_t_int) Then
19              Format(1x,f9.5,' ')
                Write(outfile,19,advance='no')sg(iv0)
                iv0=iv0+1
             Else
20              Format(10x,' ')
             Write(outfile,20,advance='no')
             Endif
          Enddo
99        Format(1x,f10.5,/)
          Write(outfile,99)f
       Endif
    Enddo                     ! isa
    !!
22  Format()
    Write(outfile,22) 
23  Format('total net   electron number: ')
    Write(outfile,23,advance='no') 
    Do i=1,im*11-15
24     Format(' ')
       Write(outfile,24,advance='no') 
    Enddo

    Write(outfile,9) c
26  Format('total gross electron number: ')
    Write(outfile,26,advance='no') 
    Do i=1,im*11-15
       Write(outfile,24,advance='no') 
    Enddo
27  Format(1x,2(f10.5,1x),/)
    Write(outfile,27) d,d-z
    If(mspin == 2_t_int)Then
28     Format('total net   spin  :')
       Write(outfile,28,advance='no')
       Do i=1,im*11-6
          Write(outfile,24,advance='no')
       Enddo
       Write(outfile,9) a
29     Format('total gross spin  :')
       Write(outfile,29,advance='no')
       Do i=1,im*11-6
          Write(outfile,24,advance='no')
       Enddo
       Write(outfile,9) b
    Endif
30  Format(/,72('-'),/)
    Write(outfile,30)
    !!
    !!
    Call pfree(p_nv)
    Call pfree(p_lv)
    Call pfree(p_nnv)
    Call pfree(p_nf)
    !!
    Return
    !!
  End Subroutine prtanal
  !!***********************************************************************


End Module ksinternal

