!!TODO: radial restrictions --> optimize
!!TODO: clean up thcis
Module loi
  !!
  Use precisiondefs
  Use constants
  Use file_iounits
  Use memory
  Use errors
  Use clock
  Use optionstest
  Use tmesh
  Use tio
  Use mesh
  Use trelativistic
  Use tdiracdefs
  Use tnumerics
  Use tmol
  Use torbitalbasis
  Use tsymmetry
  Use prnt
  Use tloi
  Use integrate1d
  Use loiorg
  Use matserv
  Use loisym
  Use loiaux
  Use diracdefs
  Use atomdefs
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="LOI"  
  !!
  Public :: loi_int
  !!***********************************************************************
  Character(*),Parameter :: fmtstart=&
       &"(/,/,'============================== START ',a&
       &,'============================== ')"
  Character(*),Parameter :: fmtend=&
       &"('============================== END   ',a&
       &,'============================== ',/,/)"
  !!***********************************************************************
Contains
  !!***********************************************************************
  Subroutine loi_int(symmetry,structure,mspin,lattice,ncsmx,nvsmx&
       !&,cblocklength,vblocklength&
       &,basis,mol,numerics,loi,relativistic)
    !!
    Implicit None  
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Basis),Intent(inout)  :: basis
    Type(T_Mol),Intent(inout)    :: mol
    Type(T_Numerics),Intent(in)  :: numerics
    Type(T_Loi),Intent(inout)    :: loi
    Integer(t_int),Intent(in)    :: mspin,ncsmx,nvsmx
    !Integer(t_int),Intent(in)    :: cblocklength(*)
    !Integer(t_int),Intent(in)    :: vblocklength(*)
    Integer(t_int),Intent(in)    :: relativistic
    !!LOCAL
    Character(*),Parameter::nsubfunc="loi_int"
    Logical(t_log) :: rel,lsp,dumploi,exists
    Integer(t_int) :: ms,i,ncomp,icomp,isa,issa,isb,issb,ir,itci
    Integer(t_int) :: ivr,icr,kap,glmax
    Integer(t_int) :: ocivvdim2,ocivvindex2(structure% nsite)
    Integer(t_int) :: ocivcdim2,ocivcindex2(structure% nsite)
    Integer(t_int) :: nvsmx2,ncsmx2,slengv,slengc,ioci,joci
    Integer(t_int),Pointer :: p_gdiff(:,:,:,:)
    Integer(t_int),Pointer :: p_kapRv2(:,:)
    Integer(t_int),Pointer :: p_lRv2(:,:)
    Integer(t_int),Pointer :: p_kapRc2(:,:)
    Integer(t_int),Pointer :: p_lRc2(:,:)
    Real(t_real),Pointer   :: p_oci_nHn(:,:)
    Real(t_real),Pointer   :: p_tci_nHn(:,:)
    Real(t_real),Pointer   :: wgaunt(:,:,:)
    Real(t_real),Pointer   :: p_ocitmp(:,:)
    Real(t_real),Pointer   :: actoci(:,:)
    !!
    !Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Character(*),Parameter :: cpumesg_occ='Core one-center integrals'
    Character(*),Parameter :: cpumesg_thci='Three-center integrals'
    Character(*),Parameter :: cpumesg_thcivc='Three-center vc-integrals'
    !!
    Nullify(p_tci_nHn)
    Nullify(p_oci_nHn)
    Nullify(p_kapRv2)
    Nullify(p_lRv2)
    Nullify(p_kapRc2)
    Nullify(p_lRc2)
    Nullify(wgaunt,p_ocitmp)
    !!
    Write(outfile,fmtstart)nsubfunc    
    !!
    rel=(relativistic == FULL_RELATIVISTIC)
    !!
    dumploi=isoption('NO_LOI')
    If(dumploi) Then
       Inquire(file=f_loi_dump ,exist=exists)
       If(exists) Then
          Write(errbuf,"(''' LOI dumping option set by user ...  ''&
               &,/,'' THIS IS A DEBUGGING OPTION!''&
               &,/,'' Reading LOIs ...'',/')")
          Call errmsg(nmodule,nsubfunc,E_warning,msg=Trim(errbuf))
          Call dump_loi(loi,rel,mspin,'read')
          Return
       Else
          Write(errbuf,"(''' LOI dumping option set by user ...  ''&
               &,/,'' THIS IS A DEBUGGING OPTION!''&
               &,/,'' LOI dump does not exist .... &
               & calculating...'',/')")
          Call errmsg(nmodule,nsubfunc,E_warning,msg=Trim(errbuf))
       Endif
    Endif
    !!
    ncomp=basis% ncomp
    !!
    !! V_cf(  r   ) = [r/(p*rmax)]^N
    !! V_cf(  rmax) = 1/p^N
    !! V_cf(l*rmax) = [l/p]^N
    !!
    !!
    !!
    !!
    !!
    glmax=basis% lmx
    Call palloc('wgaunt',wgaunt,1_t_int,(glmax+1)**2&
         &,1_t_int,(glmax+1)**2,1_t_int,(2*glmax+1)**2,nmodule,nsubfunc)

    Call makergaunt(wgaunt,glmax,glmax,2*glmax) 
    !!
    !!
    !!
    !!
    !!
    Nullify(p_gdiff)
    If(rel)Then
       Call gvecdifn(structure% nsite,lattice% p_npairs,lattice% npairsmax&
            &,lattice% p_pairs&
            &,symmetry% Rnumops,structure% p_equivsites,symmetry% Ropmat&
            &,p_gdiff)
    Else
       Call gvecdifn(structure% nsite,lattice% p_npairs,lattice% npairsmax&
            &,lattice% p_pairs&
            &,symmetry% Rnumops,structure% p_equivsites,symmetry% Ropmat&
            &,p_gdiff)


    Endif
    !!
    !!
    !! core Hamiltonian
    !!
    !!
    Call watch(nmodule//cpumesg_occ,cpu_start,reset=.True.)
    !!
    If(rel)Then
       loi% p_roci_cHc(:)=Cmplx(loi% p_oci_cHc0(:),0.0_t_real,t_real)
    Else
       Do ms=1,mspin
          loi% p_oci_cHc(:,ms)=loi% p_oci_cHc0(:)
       Enddo
       Call palloc('p_ocitmp',p_ocitmp,1_t_int,loi% ociccdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
       p_ocitmp(:,1:mspin)=0.0_t_real
    Endif
    !!
    If(rel)Then

       Call rel_calc_core_thcis(mspin,structure,symmetry&
            &,structure% nsite,structure% nsort&
            &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
            &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
            &,basis% p_basmeshs,basis% nrb&
            &,basis% nRcmx,basis% p_nRc,basis% p_kapRc&
            &,basis% p_fc,basis% p_fgam&
            &,basis% p_rtfcmax,basis% p_rfcmax,basis&
            &,loi% ociccdim,loi% p_roci_cHc,loi% p_ociccindex&
            &,numerics% degree,mol)


       
    Else


       Do icomp=1,ncomp
          
          actoci => loi% p_oci_cHc
          If(use_OVO .and. icomp>=3) actoci => p_ocitmp
          
          Call calc_core_thcis(mspin,structure% nsite,structure% nsort&
               &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
               &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
               &,basis% p_basmeshs,basis% nrb&
               &,ncsmx,ncomp,icomp&
               &,basis% nRcmx,basis% p_nRc,basis% p_lRc,basis% p_fc&
               &,basis% p_fgam&
               &,basis% p_rtfcmax,basis% p_rfcmax&
               &,loi% ociccdim,actoci,loi% p_ociccindex&
               &,numerics% degree,mol)
          
       Enddo
       Call symmetrize_oci(mspin,structure% nsite,structure% p_isrt& 
            &,symmetry% Rnumops,structure% p_equivsites,symmetry% NRwu_ks&
            &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
            &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
            &,loi% ociccdim,loi% p_oci_cHc,loi% p_ociccindex)
       Call symmetrize_oci(mspin,structure% nsite,structure% p_isrt& 
            &,symmetry% Rnumops,structure% p_equivsites,symmetry% NRwu_ks&
            &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
            &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
            &,loi% ociccdim,p_ocitmp,loi% p_ociccindex)
       If(use_OVO)Then
          Do ms=1,mspin
             Call manipulate_OVO(structure&
                  &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
                  &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
                  &,glmax,wgaunt&
                  &,loi% p_ociccindex,p_ocitmp(:,ms),loi% p_oci_cHc(:,ms))
          Enddo
       Endif
    Endif
    !!
    Call watch(nmodule//cpumesg_occ,cpu_stop,delete=.True.,Print=.True.)
    !!
    !!
    !!
    If(rel)Then
       !!
       Do i=1,loi% ocivvdim
          loi% p_roci_vHv(i)=Cmplx(loi% p_oci_vHv0(i),0.0_t_real,t_real)
       Enddo
       Do i=1,loi% ocivcdim
          loi% p_roci_vHc(i)=Cmplx(loi% p_oci_vHc0(i),0.0_t_real,t_real)
       Enddo
       Do i=1,loi% tcivvdim
          loi% p_rtci_vHv(i)=loi% p_rtci_vHv0(i)
       Enddo
       Do i=1,loi% tcivcdim
          loi% p_rtci_vHc(i)=loi% p_rtci_vHc0(i)
       Enddo
    Else
       Do ms=1,mspin
          Do i=1,loi% ocivvdim
             loi% p_oci_vHv(i,ms)=loi% p_oci_vHv0(i)
          Enddo
          Do i=1,loi% ocivcdim
             loi% p_oci_vHc(i,ms)=loi% p_oci_vHc0(i)
          Enddo
          Do i=1,loi% tcivvdim
             loi% p_tci_vHv(i,ms)=loi% p_tci_vHv0(i)
          Enddo
          Do i=1,loi% tcivcdim
             loi% p_tci_vHc(i,ms)=loi% p_tci_vHc0(i)
          Enddo
       Enddo
    Endif
    !!
    !!
    !!============================================================
    !!
    relif: If(rel)Then


       Call watch(nmodule//cpumesg_thci,cpu_start,reset=.True.)

       lsp=(mspin == 2_t_int)

       
       !!
       !! prepare aux index arrays
       !!
       Call palloc('p_kapRv2',p_kapRv2,1_t_int,basis% nRvmx&
            &,1_t_int,structure% nsort,nmodule,nsubfunc)
       Call palloc('p_lRv2',p_lRv2,1_t_int,basis% nRvmx&
            &,1_t_int,structure% nsort,nmodule,nsubfunc)
       Call palloc('p_kapRc2',p_kapRc2,1_t_int,basis% nRcmx&
            &,1_t_int,structure% nsort,nmodule,nsubfunc)
       Call palloc('p_lRc2',p_lRc2,1_t_int,basis% nRcmx&
            &,1_t_int,structure% nsort,nmodule,nsubfunc)
       !!
       Do issa=1_t_int,structure% nsort
          !!
          Do ivr=1,basis% p_nRv(issa)
             kap=basis% p_kapRv(ivr,issa)
             p_kapRv2(ivr,issa)=-kap
             p_lRv2(ivr,issa)=(Abs(-2*kap+1)-1)/2
          Enddo
          !!
          Do icr=1,basis% p_nRc(issa)
             kap=basis% p_kapRc(icr,issa)
             p_kapRc2(icr,issa)=-kap
             p_lRc2(icr,issa)=(Abs(-2*kap+1)-1)/2
          Enddo
          !!
       Enddo
       !!
       ocivvdim2=0
       nvsmx2=0
       ocivcdim2=0
       ncsmx2=0
       Do isa=1,structure% nsite
          issa=structure% p_isrt(isa)
          slengv=Sum(2*p_lRv2(1:basis% p_nRv(issa),issa)+1)
          slengc=Sum(2*p_lRc2(1:basis% p_nRc(issa),issa)+1)

          nvsmx2=Max(nvsmx2,slengv)
          ocivvindex2(isa)=ocivvdim2
          ocivvdim2=ocivvdim2+slengv**2

          ncsmx2=Max(ncsmx2,slengc)
          ocivcindex2(isa)=ocivcdim2
          ocivcdim2=ocivcdim2+slengv*slengc
       Enddo
       !!
       !!
       !! aux array
       Call palloc('p_tci_nHn',p_tci_nHn,1_t_int,loi% tcivvdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
       !!
       p_tci_nHn(:,:)=0.0_t_real
       !!
       !!
       icomp=1_t_int
       !!
       Call palloc('p_oci_nHn',p_oci_nHn,1_t_int,loi% ocivvdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
       !!
       p_oci_nHn(:,:)=0.0_t_real
       !!
       
       Call calc_thcis(mspin,structure% nsite,structure% nsort&
            &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
            &,symmetry% Rnumops,structure% p_equivsites,symmetry% Rwu_ks&
            &,p_gdiff&
            &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
            &,basis% p_basmeshs,basis% nrb&
            &,nvsmx,ncomp,icomp&
            &,basis% nRvmx,basis% p_nRv,basis% p_lRv,basis% p_fv&
            &,basis% p_fgam&
            &,basis% p_rtfvmax,basis% p_rfvmax&
            &,loi% ocivvdim,loi% tcivvdim&
            &,p_oci_nHn,p_tci_nHn&
            &,numerics% degree,loi% p_ocivvindex,loi% p_tcivvindex,mol,.True.)

       

       !! Pseudo - to full relativistic transformation
       Do isa=1,structure% nsite
          issa=structure% p_isrt(isa)
          ioci=loi% p_ocivvindex(isa)
          Call reltrans_loi_block(lsp&
               &,basis% p_nRv(issa),basis% p_kapRv(:,issa)&
               &,basis% p_nRv(issa),basis% p_kapRv(:,issa)&
               &,ioci,ioci,p_oci_nHn,loi% p_roci_vHv&
               &,basis% lmx,basis% p_relTOpseudo)

          Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             Do ir=1,lattice% p_npairs(isa,isb)
                !!
                itci=loi% p_tcivvindex(ir,isa,isb)
                
                Call reltrans_loi_block(lsp&
                     &,basis% p_nRv(issa),basis% p_kapRv(:,issa)&
                     &,basis% p_nRv(issb),basis% p_kapRv(:,issb)&
                     &,itci,itci,p_tci_nHn,loi% p_rtci_vHv&
                     &,basis% lmx,basis% p_relTOpseudo)

             End Do ! ir
          End Do ! isb
       End Do ! isa

       
       icomp=2_t_int


       Call palloc('p_oci_nHn',p_oci_nHn,1_t_int,ocivvdim2&
            &,1_t_int,mspin,nmodule,nsubfunc)

       p_oci_nHn(:,:)=0.0_t_real

       Call calc_thcis(mspin,structure% nsite,structure% nsort&
            &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
            &,symmetry% Rnumops,structure% p_equivsites,symmetry% Rwu_ks,p_gdiff&
            &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
            &,basis% p_basmeshs,basis% nrb&
            &,nvsmx2,ncomp,icomp&
            &,basis% nRvmx,basis% p_nRv,p_lRv2,basis% p_fv&
            &,basis% p_fgam&
            &,basis% p_rtfvmax,basis% p_rfvmax&
            &,ocivvdim2,loi% tcivvdim&
            &,p_oci_nHn,p_tci_nHn&
            &,numerics% degree,ocivvindex2,loi% p_tcivvindex,mol,.True.)
       !!
       !!
       !! Pseudo - to full relativistic transformation
       Do isa=1,structure% nsite
          issa=structure% p_isrt(isa)

          ioci=loi% p_ocivvindex(isa)
          joci=ocivvindex2(isa)
          
          Call reltrans_loi_block(lsp&
               &,basis% p_nRv(issa),p_kapRv2(:,issa)&
               &,basis% p_nRv(issa),p_kapRv2(:,issa)&
               &,joci,ioci,p_oci_nHn,loi% p_roci_vHv&
               &,basis% lmx,basis% p_relTOpseudo)

          
       Enddo
       !!
       Call watch(nmodule//cpumesg_thci,cpu_stop,delete=.True.,Print=.True.)
       !!
       !!
       !! core-valence
       !!
       !!
       Call watch(nmodule//cpumesg_thcivc,cpu_start,reset=.True.)
       !!
       !!
       Call palloc('p_tci_nHn',p_tci_nHn,1_t_int,loi% tcivcdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
       !!
       p_tci_nHn(:,:)=0.0_t_real
       !!
       icomp=1
       !!
       Call palloc('p_oci_nHn',p_oci_nHn,1_t_int,loi% ocivcdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
       !!
       p_oci_nHn(:,:)=0.0_t_real
       !!
       Call calc_thcis_vc(mspin,structure% nsite,structure% nsort&
            &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
            &,symmetry% Rnumops,structure% p_equivsites,symmetry% Rwu_ks&
            &,p_gdiff&
            &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
            &,basis% p_basmeshs,basis% nrb&
            &,ncsmx,ncomp,icomp&
            &,basis% nRvmx,basis% p_nRv,basis% p_lRv,basis% p_fv&
            &,basis% nRcmx,basis% p_nRc,basis% p_lRc,basis% p_fc&
            &,basis% p_fgam&
            &,basis% p_rtfvmax,basis% p_rfvmax&
            &,basis% p_rtfcmax,basis% p_rfcmax&
            &,loi% ocivcdim,loi% tcivcdim&
            &,p_oci_nHn,p_tci_nHn&
            &,numerics% degree,loi% p_ocivcindex,loi% p_tcivcindex,mol,.True.)
       !!
       !! Pseudo - to full relativistic transformation
       Do isa=1,structure% nsite
          issa=structure% p_isrt(isa)
          ioci=loi% p_ocivcindex(isa)
          Call reltrans_loi_block(lsp&
               &,basis% p_nRv(issa),basis% p_kapRv(:,issa)&
               &,basis% p_nRc(issa),basis% p_kapRc(:,issa)&
               &,ioci,ioci,p_oci_nHn,loi% p_roci_vHc&
               &,basis% lmx,basis% p_relTOpseudo)
          
          Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             Do ir=1,lattice% p_npairs(isa,isb)
                !!
                itci=loi% p_tcivcindex(ir,isa,isb)
                
                Call reltrans_loi_block(lsp&
                     &,basis% p_nRv(issa),basis% p_kapRv(:,issa)&
                     &,basis% p_nRc(issb),basis% p_kapRc(:,issb)&
                     &,itci,itci,p_tci_nHn,loi% p_rtci_vHc&
                     &,basis% lmx,basis% p_relTOpseudo)
                
             End Do ! ir
          End Do ! isb
       End Do ! isa
       !!
       icomp=2
       !!
       !!
       !!
       !!
       !!
       Call palloc('p_oci_nHn',p_oci_nHn,1_t_int,ocivcdim2&
            &,1_t_int,mspin,nmodule,nsubfunc)
       !!
       p_oci_nHn(:,:)=0.0_t_real
       !!

       Call calc_thcis_vc(mspin,structure% nsite,structure% nsort&
            &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
            &,symmetry% Rnumops,structure% p_equivsites,symmetry% Rwu_ks&
            &,p_gdiff&
            &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
            &,basis% p_basmeshs,basis% nrb&
            &,ncsmx2,ncomp,icomp&
            &,basis% nRvmx,basis% p_nRv,p_lRv2,basis% p_fv&
            &,basis% nRcmx,basis% p_nRc,p_lRc2,basis% p_fc&
            &,basis% p_fgam&
            &,basis% p_rtfvmax,basis% p_rfvmax&
            &,basis% p_rtfcmax,basis% p_rfcmax&
            &,ocivcdim2,loi% tcivcdim&
            &,p_oci_nHn,p_tci_nHn&
            &,numerics% degree,ocivcindex2,loi% p_tcivcindex,mol,.True.)
       !!
       !!
       !! Pseudo - to full relativistic transformation
       Do isa=1,structure% nsite
          issa=structure% p_isrt(isa)

          ioci=loi% p_ocivcindex(isa)
          joci=ocivcindex2(isa)
          
          Call reltrans_loi_block(lsp&
               &,basis% p_nRv(issa),p_kapRv2(:,issa)&
               &,basis% p_nRc(issa),p_kapRc2(:,issa)&
               &,joci,ioci,p_oci_nHn,loi% p_roci_vHc&
               &,basis% lmx,basis% p_relTOpseudo)

          
       Enddo
       !!
       Call pfree(p_lRc2)
       Call pfree(p_kapRc2)
       Call pfree(p_lRv2)
       Call pfree(p_kapRv2)
       Call pfree(p_oci_nHn)
       Call pfree(p_tci_nHn)
       !!
       Call watch(nmodule//cpumesg_thcivc,cpu_stop,delete=.True.,Print=.True.)

    Else relif
       !!============================================================

       Call watch(nmodule//cpumesg_thci,cpu_start,reset=.True.)


       Call palloc('p_ocitmp',p_ocitmp,1_t_int,loi% ocivvdim&
            &,1_t_int,mspin,nmodule,nsubfunc)

       p_ocitmp(:,1:mspin)=0.0_t_real

       Do icomp=1,ncomp

          actoci => loi% p_oci_vHv
          If(use_OVO .and. icomp>=3) actoci => p_ocitmp
          

          Call calc_thcis(mspin,structure% nsite,structure% nsort&
               &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
               &,symmetry% Rnumops,structure% p_equivsites,symmetry% NRwu_ks&
               &,p_gdiff&
               &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
               &,basis% p_basmeshs,basis% nrb&
               &,nvsmx,ncomp,icomp&
               &,basis% nRvmx,basis% p_nRv,basis% p_lRv,basis% p_fv&
               &,basis% p_fgam&
               &,basis% p_rtfvmax,basis% p_rfvmax&
               &,loi% ocivvdim,loi% tcivvdim&
               &,actoci&
               &,loi% p_tci_vHv&
               &,numerics% degree,loi% p_ocivvindex,loi% p_tcivvindex,mol&
               &,.False.)
          
       Enddo

       If(use_OVO)Then
          Do ms=1,mspin
             Call manipulate_OVO(structure&
                  &,basis% nRvmx,basis% p_nRv,basis% p_lRv&
                  &,basis% nRvmx,basis% p_nRv,basis% p_lRv&
                  &,glmax,wgaunt&
                  &,loi% p_ocivvindex,p_ocitmp(:,ms),loi% p_oci_vHv(:,ms))
          Enddo
       Endif

       Call watch(nmodule//cpumesg_thci,cpu_stop,delete=.True.,Print=.True.)
       !!
       !!  core-valence
       Call watch(nmodule//cpumesg_thcivc,cpu_start,reset=.True.)

       Call palloc('p_ocitmp',p_ocitmp,1_t_int,loi% ocivcdim&
            &,1_t_int,mspin,nmodule,nsubfunc)

       p_ocitmp(:,1:mspin)=0.0_t_real

       Do icomp=1,ncomp
          
          actoci => loi% p_oci_vHc
          If(use_OVO .and. icomp>=3) actoci => p_ocitmp

          Call calc_thcis_vc(mspin,structure% nsite,structure% nsort&
               &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
               &,symmetry% Rnumops,structure% p_equivsites,symmetry% NRwu_ks&
               &,p_gdiff&
               &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
               &,basis% p_basmeshs,basis% nrb&
               &,ncsmx,ncomp,icomp&
               &,basis% nRvmx,basis% p_nRv,basis% p_lRv,basis% p_fv&
               &,basis% nRcmx,basis% p_nRc,basis% p_lRc,basis% p_fc&
               &,basis% p_fgam&
               &,basis% p_rtfvmax,basis% p_rfvmax&
               &,basis% p_rtfcmax,basis% p_rfcmax&
               &,loi% ocivcdim,loi% tcivcdim&
               &,actoci,loi% p_tci_vHc&
               &,numerics% degree,loi% p_ocivcindex,loi% p_tcivcindex,mol&
               &,.False.)
       Enddo
       
       If(use_OVO)Then
          Do ms=1,mspin
             Call manipulate_OVO(structure&
                  &,basis% nRvmx,basis% p_nRv,basis% p_lRv&
                  &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
                  &,glmax,wgaunt&
                  &,loi% p_ocivcindex,p_ocitmp(:,ms),loi% p_oci_vHc(:,ms))
          Enddo
       Endif

       Call watch(nmodule//cpumesg_thcivc,cpu_stop,delete=.True.,Print=.True.)
       !!============================================================

    Endif relif
    !!
    !!
    !!
    !!
    Call pfree(p_gdiff)
    Call pfree(wgaunt)
    Call pfree(p_ocitmp)
    !!
    !!
!    If(dumploi.And.exists) Then
!       Call test_dump_loi(loi,rel,mspin)
!    Endif
    If(dumploi) Then
       Write(errbuf,"(''' dumping LOIs .... '',/')")
       Call errmsg(nmodule,nsubfunc,E_warning,msg=Trim(errbuf))
       !! write dump
       Call dump_loi(loi,rel,mspin,'write')
    Endif
    !!
    !Call print_lois(mspin,structure% nsite,lattice,cblocklength,vblocklength,loi)
    !!
    Write(outfile,fmtend)nsubfunc
    !!
    Return
    !!
  End Subroutine loi_int
  !!***********************************************************************
  !! compare to dumped thci-lois on disk .... for debugging runs
  !!
#ifdef my_compile_unused
  Subroutine test_dump_loi(loi,rel,mspin)
    !!
    Implicit none  
    !!IO
    Type(T_Loi),Intent(inout)    :: loi
    Logical(t_log),Intent(in)    :: rel
    Integer(t_int),Intent(in)    :: mspin
    !!LOCAL
    !Character(*),Parameter::nsubfunc="test_dump_loi"
    Integer(t_int) :: i,ms
    Real(t_real)   :: dum,devi,calc
    Real(t_real),Parameter :: tol=1.0e-10_t_real
    !!
    !!
    !!
    !!
    Open(12,file=f_loi_dump,status='old',form='UNFORMATTED')
    If(rel) Then
       Do i=1_t_int,loi% ociccdim
!todo          Read(12) loi% p_roci_cHc(i)
       Enddo
       Do i=1_t_int,loi% ocivvdim
!          Read(12) loi% p_roci_vHv(i)
       Enddo
       Do i=1_t_int,loi% ocivcdim
!         Read(12) loi% p_roci_vHc(i)
       Enddo
       Do i=1_t_int,loi% tcivvdim
!          Read(12) loi% p_rtci_vHv(i)
       Enddo
       Do i=1_t_int,loi% tcivcdim
!          Read(12) loi% p_rtci_vHc(i)
       Enddo
    Else
       Do ms=1,mspin
          Do i=1_t_int,loi% ociccdim
             Read(12) dum
             calc=loi% p_oci_cHc(i,ms)
             devi=dum-calc
             If(Abs(devi)> tol)Then
                Write(outfile,12)'oci_cHc',ms,i,dum,calc,devi
             Endif
          Enddo
          Do i=1_t_int,loi% ocivvdim
             Read(12) dum
             calc=loi% p_oci_vHv(i,ms)
             devi=dum-calc
             If(Abs(devi)> tol)Then
                Write(outfile,12)'oci_vHv',ms,i,dum,calc,devi
             Endif
          Enddo
          Do i=1_t_int,loi% ocivcdim
             Read(12) dum
             calc=loi% p_oci_vHc(i,ms)
             devi=dum-calc
             If(Abs(devi)> tol)Then
                Write(outfile,12)'oci_vHc',ms,i,dum,calc,devi
             Endif
          Enddo
          Do i=1_t_int,loi% tcivvdim
             Read(12) dum
             calc=loi% p_tci_vHv(i,ms)
             devi=dum-calc
             If(Abs(devi)> tol)Then
                Write(outfile,12)'tci_vHv',ms,i,dum,calc,devi
             Endif
          Enddo
          Do i=1_t_int,loi% tcivcdim
             Read(12) dum
             calc=loi% p_tci_vHc(i,ms)
             devi=dum-calc
             If(Abs(devi)> tol)Then
                Write(outfile,12)'tci_vHc',ms,i,dum,calc,devi
             Endif
          Enddo
       Enddo ! ms
    Endif
    Close(12)
    !!
    !!
    Return
    !!
12  Format(a,': ms=',i2,' i=',i7,' disk=',e30.15e3&
         &,' calc=',e30.15e3,' devi=',e30.15e3)
    !!
  End Subroutine test_dump_loi
#endif
  !!***********************************************************************
  Subroutine calc_core_thcis(mspin,nsite,nsort,naps,isrt,posToSiteRep&
       &,npairs,pairs,npairsmax&
       &,basmeshs,nrbmax&
       &,ncsmx&
       &,ncomp,icomp,ncm,nc,lc,fc,fgam&
       &,rtfcmax,rfcmax&
       &,ociccdim,oci_cHc,ociccindex&
       &,degree,mol)
    !!
    Implicit None
    !!IO
    Type(T_Mesh),Pointer         :: basmeshs(:)
    Type(T_Mol),Intent(in)       :: mol
    Integer(t_int),Intent(in)    :: nrbmax
    Integer(t_int),Intent(in)    :: mspin,naps,nsite,nsort,isrt(nsite)
    Integer(t_int),Intent(in)    :: posToSiteRep(nsite)
    !Integer(t_int),Intent(in)    :: nqAtPos(nsite),qposToSite(nsite,nsite)
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: ncomp,icomp
    Integer(t_int),Intent(in)    :: ncm,nc(nsort),lc(ncm,nsort)
    Integer(t_int),Intent(in)    :: ociccindex(nsite)
    Real(t_real),Intent(in)      :: rfcmax(ncm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fgam(nsort)
    Real(t_real),Intent(in)      :: fc(nrbmax,ncm,ncomp,nsort)
    Integer(t_int),Intent(in)    :: npairsmax,ncsmx
    Integer(t_int),Intent(in)    :: degree
    Integer(t_int),Intent(in)    :: ociccdim
    Real(t_real),Intent(in)      :: pairs(:,:,:,:)
    Real(t_real),Intent(in)      :: rtfcmax(0:ncomp,nsort)
    Real(t_real),Intent(inout)   :: oci_cHc(ociccdim,mspin)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="calc_core_thcis"
    Logical(t_log) :: lsp
    Integer(t_int) :: ispp,isp,isa,issa,nca,lmxa,i,l,m,isb
    Integer(t_int) :: ibl,inbl,mxblsize,nbl,iblb,inblb
    Integer(t_int) :: icbm1,nap,irap,im
    Integer(t_int) :: il,k,indexa
    Integer(t_int) :: lmx(nsort),blocklen(nsite)
    Integer(t_int) :: iocicc,ir0
    Real(t_real)   :: vv1,vv2,v1,v2,ww,ra,ff1,rsh(3),rra(3),oora,texp
    Real(t_real)  :: yl((ORBITAL_MAX_L+3_t_int)**2_t_int)
    Real(t_real)   :: coefa(0:degree)
    Real(t_real)   :: fb1(0:ncsmx)
    Integer(t_int),Pointer :: p_isitebl(:)
    Real(t_real),Pointer   :: p_fabl(:)
    Real(t_real),Pointer   :: p_vloc(:)
    !Real(t_real),Parameter :: zero=0.0_t_real
    Type(T_Mesh),Pointer :: bmesha
    Type(T_Mesh),Pointer :: atommesha
    !!
    Nullify(p_fabl)
    Nullify(p_vloc)
    Nullify(p_isitebl)
    !!
    Call prep_thcis(nsort,nsite,isrt,npairs,npairsmax,ncm,nc,lc&
         &,lmx,blocklen,mxblsize,p_fabl,p_vloc,p_isitebl)
    !!
    !!
    !!
    !!
    !! doit
    !!
    lsp=(mspin == 2_t_int)
    Do ispp=1_t_int,naps
1      Format('real site',i5)
       If(outlevel >= L_more) Write(outfile,1) ispp
       isp=posToSiteRep(ispp)
       !!       
       !!
       !!
       imloop: Do im=1_t_int,mol% p_nm(isp)
          If(outlevel >= L_many .And.Mod(im,(mol% p_nm(isp)/100)) == 0_t_int)Then
             Write(outfile,5) isp,100.0_t_real*im/mol% p_nm(isp)
          Endif
5         Format('site: ',i5,' ',f5.1,'% done')

          rsh(:)=mol% p_rm(:,im,isp)
          ww=mol% p_wm(im,isp)
          v1=mol% p_vm2(1,im,isp)
          v2=v1
          if(lsp) v2=mol% p_vm2(2,im,isp)
          vv1=v1*ww
          vv2=v2*ww
          !!
          !! interpolate all functions which are nonzero at r=(x,y,z)
          !!
          ibl=0
          inbl=0
          p_fabl(:)=0.0_t_real
          isapreploop: Do isa=1_t_int,nsite
             issa=isrt(isa)
             !!
             bmesha => basmeshs(issa)
             atommesha => mol% p_atommeshs(issa)
             !!
             nca=nc(issa)
             !!
             lmxa=lmx(issa)
             !!
             nap=npairs(isa,isp)
             !!
             !!
             ir0=1
             If(isp==isa)Then
                ir0=0
             Endif
             !!
             irnappreploop: Do irap=ir0,nap

                If(irap==0)Then
                   rra(:)=rsh(:)
                Else
                   rra(:)=rsh(:)-pairs(:,irap,isa,isp)
                Endif
                ra=Max(Sqrt(Dot_product(rra,rra)),1.0e-16_t_real)
                If(ra==0.0_t_real)Then
                   oora=0.0_t_real
                Else
                   oora=1.0_t_real/ra
                Endif

                If(ra > rtfcmax(icomp,issa)) Cycle irnappreploop
                !!
                texp=ra**fgam(issa)*oora
                !!
                indexa=mintpl_coefs(degree,bmesha,ra,coefa)
                Call ylms12(yl,rra(1),rra(2),rra(3),lmxa)
                !!Call yl3(yl,rx,ry,rz)
                k=0_t_int
                Do i=1_t_int,nca

                   l=lc(i,issa)

                   
                   ff1=0.0_t_real
                   If(ra <= rfcmax(i,icomp,issa) )Then
                      ff1=Dot_product(fc(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp
                   End If


                   !lq=l*l
                   il=l*l
                   Do m=1_t_int,l+l+1_t_int
                      il=il+1
                      k=k+1_t_int
                      p_fabl(inbl+k)=ff1*yl(il)
                   Enddo       ! m
                Enddo         ! i
                ibl=ibl+1
                p_isitebl(ibl)=isa
                !inblbl(ibl)=inbl
                inbl=inbl+blocklen(isa)
                !! local potential
                indexa=mintpl_coefs(degree,atommesha,ra,coefa)
                p_vloc(ibl)=&
                     &Dot_product(mol% p_vatom(indexa:indexa+degree,0,issa)&
                     &,coefa(0:degree))*oora/sq4pi*ww
                !!
             Enddo irnappreploop
          End Do isapreploop
          nbl=ibl
          !! 
          !! 
          !! 
          !! 
          !! 
          !! one-center core terms
          inblb=1
          oiblbloop: Do iblb=1,nbl
             isb=p_isitebl(iblb)
             icbm1=blocklen(isb)-1_t_int
             !!
             !!
             iocicc=ociccindex(isb)+1
             fb1(0:icbm1)=p_fabl(inblb:inblb+icbm1)*(vv1-p_vloc(iblb))
             Do k=0_t_int,icbm1
                oci_cHc(iocicc:iocicc+icbm1,1)&
                     &=oci_cHc(iocicc:iocicc+icbm1,1)&
                     &+fb1(0:icbm1)*p_fabl(inblb+k)
                iocicc=iocicc+icbm1+1
             Enddo   ! k
             If(lsp)Then
                iocicc=ociccindex(isb)+1
                fb1(0:icbm1)=p_fabl(inblb:inblb+icbm1)*(vv2-p_vloc(iblb))
                Do k=0_t_int,icbm1
                   oci_cHc(iocicc:iocicc+icbm1,2)&
                        &=oci_cHc(iocicc:iocicc+icbm1,2)&
                        &+fb1(0:icbm1)*p_fabl(inblb+k)
                   iocicc=iocicc+icbm1+1
                Enddo   ! k
             Endif
             inblb=inblb+icbm1+1
          Enddo oiblbloop

          !! 
          !!
       Enddo imloop             ! ig
    Enddo                     ! isp
    !!
    !!
    Call pfree(p_isitebl)
    Call pfree(p_vloc)
    Call pfree(p_fabl)
    !!
    Return
    !!
  End Subroutine calc_core_thcis
  !!***********************************************************************
  Subroutine calc_thcis(mspin,nsite,nsort,naps,isrt,posToSiteRep&
       &,numops,equivsites,wu_ks,gdiff&
       &,npairs,pairs,npairsmax&
       &,basmeshs,nrbmax&
       &,nvsmx&
       &,ncomp,icomp,nvm,nv,lv,fv,fgam&
       &,rtfvmax,rfvmax&
       &,ocivvdim,tcivvdim&
       &,oci_vHv&
       &,tci_vHv&
       &,degree,ocivvindex,tcivvindex,mol,switch_v_beta)
    !!
    Implicit None
    !!IO
    Type(T_Mesh),Pointer         :: basmeshs(:)
    Type(T_Mol),Intent(in)       :: mol
    Logical(t_log),Intent(in)    :: switch_v_beta
    Integer(t_int),Intent(in)    :: nrbmax
    Integer(t_int),Intent(in)    :: mspin,naps,nsite,nsort,isrt(nsite)
    Integer(t_int),Intent(in)    :: npairsmax
    Integer(t_int),Intent(in)    :: posToSiteRep(nsite)
    Integer(t_int),Intent(in)    :: numops,equivsites(48,nsite)
    Real(t_real),Intent(in)      :: wu_ks(:,:,0:,:)
    Integer(t_int),Intent(in)    :: gdiff(0:npairsmax,48,nsite,nsite)
    !Integer(t_int),Intent(in)    :: nqAtPos(nsite),qposToSite(nsite,nsite)
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: ncomp,icomp,nvm,nv(nsort),lv(nvm,nsort)
    Integer(t_int),Intent(in)    :: ocivvindex(nsite)
    Integer(t_int),Intent(in)    :: tcivvindex(:,:,:)
    Real(t_real),Intent(in)      :: rfvmax(nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fgam(nsort)
    Real(t_real),Intent(in)      :: fv(nrbmax,nvm,ncomp,nsort)
    Integer(t_int),Intent(in)    :: nvsmx
    Integer(t_int),Intent(in)    :: degree
    Integer(t_int),Intent(in)    :: ocivvdim,tcivvdim
    Real(t_real),Intent(in)      :: pairs(:,:,:,:)
    Real(t_real),Intent(in)      :: rtfvmax(0:ncomp,nsort)
    Real(t_real),Intent(inout)   :: oci_vHv(ocivvdim,mspin)
    Real(t_real),Intent(inout)   :: tci_vHv(tcivvdim,mspin)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="calc_thcis"
    Logical(t_log) :: lsp
    Integer(t_int) :: ispp,isp,isa,issa,nva,lena,lmxa,i,l,m,isb
    Integer(t_int) :: ibl,inbl,mxblsize,nbl,ibla,inbla,iblb,inblb,itci0
    Integer(t_int) :: icbm1,nap,irap,im
    Integer(t_int) :: il,k,itci,irbp,indexa
    Integer(t_int) :: itcidif(0:npairsmax,nsite,0:npairsmax,nsite) !! TODO
    Integer(t_int) :: lmx(nsort),blocklen(nsite)
    Integer(t_int) :: iocivv,ir0
    Real(t_real)   :: vv1,vv2,v1,v2,ww,ra,ff1,rsh(3),rra(3),oora,texp
    Real(t_real)   :: vv,ovv1,ovv2
    Real(t_real)   :: yl((ORBITAL_MAX_L+3_t_int)**2_t_int)
    Real(t_real)   :: coefa(0:degree)
    Real(t_real)   :: fb1(0:nvsmx)
    Integer(t_int),Pointer :: p_isitebl(:)
    Integer(t_int),Pointer :: p_ipairbl(:)
    Real(t_real),Pointer   :: p_fabl(:)
    Real(t_real),Pointer   :: p_vloc(:)
    !Real(t_real),Parameter :: zero=0.0_t_real
    Type(T_Mesh),Pointer :: bmesha
    Type(T_Mesh),Pointer :: atommesha
    !!
    !!
    Nullify(p_fabl)
    Nullify(p_vloc)
    Nullify(p_isitebl)
    Nullify(p_ipairbl)
    !!
    !!
    Call prep_thcis(nsort,nsite,isrt,npairs,npairsmax,nvm,nv,lv&
         &,lmx,blocklen,mxblsize,p_fabl,p_vloc,p_isitebl,p_ipairbl)
    !!
    !!
    !!
    !! doit
    !!
    lsp=(mspin == 2_t_int)
    Do ispp=1_t_int,naps
1      Format('real site',i5)
       If(outlevel >= L_more) Write(outfile,1) ispp
       isp=posToSiteRep(ispp)
       !!       
       !!
       Call vecdifn(nsite,isp,itcidif,npairs,npairsmax,pairs,tcivvindex)
       !!
       imloop: Do im=1_t_int,mol% p_nm(isp)
          If(outlevel >= L_many .And.Mod(im,(mol% p_nm(isp)/100)) == 0_t_int)Then
             Write(outfile,5) isp,100.0_t_real*im/mol% p_nm(isp)
          Endif
5         Format('site: ',i5,' ',f5.1,'% done')

          rsh(:)=mol% p_rm(:,im,isp)
          ww=mol% p_wm(im,isp)
          v1=mol% p_vm2(1,im,isp)
          v2=v1
          If(lsp) v2=mol% p_vm2(2,im,isp)
          vv1=v1*ww
          vv2=v2*ww
          !!
          !! exchanged vv1 and vv2 due to beta-matrix
          ovv1=vv1
          ovv2=vv2
          If(switch_v_beta .And. icomp==2 )Then
             ovv1=vv2
             ovv2=vv1
          Endif
          !!
          !! interpolate all functions which are nonzero at r=(x,y,z)
          !!
          ibl=0
          inbl=0
          p_fabl(:)=0.0_t_real
          isapreploop: Do isa=1_t_int,nsite
             issa=isrt(isa)
             !!
             bmesha => basmeshs(issa)
             atommesha => mol% p_atommeshs(issa)
             !!
             nva=nv(issa)
             !!
             lmxa=lmx(issa)
             !!
             nap=npairs(isa,isp)
             !!
             !!
             ir0=1
             If(isp==isa)Then
                !! include on-site terms, which are excluded in
                !! definition of pairs(...)
                ir0=0
             Endif
             !!
             irnappreploop: Do irap=ir0,nap

                If(irap==0)Then
                   rra(:)=rsh(:)
                Else
                   rra(:)=rsh(:)-pairs(:,irap,isa,isp)
                Endif
                ra=Max(Sqrt(Dot_product(rra,rra)),1.0e-16_t_real)
                If(ra==0.0_t_real)Then
                   oora=0.0_t_real
                Else
                   oora=1.0_t_real/ra
                Endif

                If(ra > rtfvmax(icomp,issa)) Cycle irnappreploop
                !!
                texp=ra**fgam(issa)*oora
                !!
                indexa=mintpl_coefs(degree,bmesha,ra,coefa)
                Call ylms12(yl,rra(1),rra(2),rra(3),lmxa)

                k=0_t_int
                Do i=1_t_int,nva

                   l=lv(i,issa)

                   
                   ff1=0.0_t_real
                   If(ra <= rfvmax(i,icomp,issa) )Then
                      ff1=Dot_product(fv(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp
                   End If


                   il=l*l
                   Do m=1_t_int,l+l+1_t_int
                      il=il+1
                      k=k+1_t_int
                      p_fabl(inbl+k)=ff1*yl(il)
                   Enddo       ! m
                Enddo         ! i
                ibl=ibl+1
                p_isitebl(ibl)=isa
                p_ipairbl(ibl)=irap
                inbl=inbl+blocklen(isa)
                !! local potential
                indexa=mintpl_coefs(degree,atommesha,ra,coefa)
                p_vloc(ibl)=&
                     &Dot_product(mol% p_vatom(indexa:indexa+degree,0,issa)&
                     &,coefa(0:degree))*oora/sq4pi*ww
                !!
             Enddo irnappreploop
          End Do isapreploop
          nbl=ibl
          !! 
          !! 
          !! TODO: extra lsp 
          !! 
          !! 
          !! 
          !! one-center terms
          inblb=1
          oiblbloop: Do iblb=1,nbl
             isb=p_isitebl(iblb)
             icbm1=blocklen(isb)-1_t_int
             !!
             !!
             !!
             iocivv=ocivvindex(isb)+1
             fb1(0:icbm1)=p_fabl(inblb:inblb+icbm1)*(ovv1-p_vloc(iblb))
             Do k=0_t_int,icbm1 !!a-atom
                oci_vHv(iocivv:iocivv+icbm1,1)&
                     &=oci_vHv(iocivv:iocivv+icbm1,1)&
                     &+fb1(0:icbm1)*p_fabl(inblb+k)
                iocivv=iocivv+icbm1+1
             Enddo   ! k
             If(lsp)Then
                iocivv=ocivvindex(isb)+1
                fb1(0:icbm1)=p_fabl(inblb:inblb+icbm1)*(ovv2-p_vloc(iblb))
                Do k=0_t_int,icbm1 !! a-atom
                   oci_vHv(iocivv:iocivv+icbm1,2)&
                        &=oci_vHv(iocivv:iocivv+icbm1,2)&
                        &+fb1(0:icbm1)*p_fabl(inblb+k)
                   iocivv=iocivv+icbm1+1
                Enddo   ! k
             Endif
             inblb=inblb+icbm1+1
          Enddo oiblbloop

          !! 
          !! 
          If ( icomp > 1 ) Cycle imloop
          !If ( icomp == 2 .Or. icomp ==4 ) Cycle imloop
          !! 
          !! two center terms
          !! 
          inblb=1
          iblbloop: Do iblb=1,nbl
             isb=p_isitebl(iblb)
             icbm1=blocklen(isb)-1_t_int
             irbp=p_ipairbl(iblb)

             fb1(0:icbm1)=p_fabl(inblb:inblb+icbm1)
             !! 
             inbla=0
             iblaloop: Do ibla=1,nbl
                isa=p_isitebl(ibla)
                lena=blocklen(isa)
                irap=p_ipairbl(ibla)
                !!
                itci0=itcidif(irap,isa,irbp,isb)
                !!
                If((itci0 == 0_t_int) )Goto 500 !! TODO: check this
                !! TODO: it should be impossible, what happens with atom 
                !! TODO: dependend rmax
                !!
                vv=vv1-p_vloc(iblb)-p_vloc(ibla)
                !!
                itci=itci0
                Do k=1_t_int,lena
                   tci_vHv(itci:itci+icbm1,1)&
                        &=tci_vHv(itci:itci+icbm1,1)&
                        &+fb1(0:icbm1)*p_fabl(inbla+k)*vv
                   itci=itci+icbm1+1
                Enddo   ! k
                If(lsp)Then
                   !!
                   vv=vv2-p_vloc(iblb)-p_vloc(ibla)
                   !!
                   itci=itci0
                   Do k=1_t_int,lena
                      tci_vHv(itci:itci+icbm1,2)&
                           &=tci_vHv(itci:itci+icbm1,2)&
                           &+fb1(0:icbm1)*p_fabl(inbla+k)*vv
                      itci=itci+icbm1+1
                   Enddo   ! k
                Endif
500             Continue
                inbla=inbla+lena
             Enddo iblaloop
             inblb=inblb+icbm1+1
          Enddo iblbloop
          !!
          !! 
          !!
       Enddo imloop             ! ig
    Enddo                     ! isp
    !!
    Call pfree(p_ipairbl)
    Call pfree(p_isitebl)
    Call pfree(p_vloc)
    Call pfree(p_fabl)
    !!
    Call symmetrize_oci(mspin,nsite,isrt&
         &,numops,equivsites,wu_ks&
         &,nvm,nv,lv&
         &,nvm,nv,lv&
         &,ocivvdim,oci_vHv,ocivvindex)
    !!
    If(icomp <= 1 )Then
    !If(icomp == 1 .Or. icomp == 3 )Then
       
       Call symmetrize_tci(mspin,nsite,isrt,npairsmax,npairs&
            &,numops,equivsites,wu_ks&
            &,nvm,nv,lv&
            &,nvm,nv,lv&
            &,tcivvdim,tci_vHv,tcivvindex,gdiff)
       
    Endif
    !!
    Return
    !!
  End Subroutine calc_thcis
  !!***********************************************************************
  Subroutine calc_thcis_vc(mspin,nsite,nsort,naps,isrt,posToSiteRep&
       &,numops,equivsites,wu_ks,gdiff&
       &,npairs,pairs,npairsmax&
       &,basmeshs,nrbmax&
       &,ncsmx&
       &,ncomp,icomp,nvm,nv,lv,fv,ncm,nc,lc,fc,fgam&
       &,rtfvmax,rfvmax,rtfcmax,rfcmax&
       &,ocivcdim,tcivcdim&
       &,oci_vHc,tci_vHc&
       &,degree&
       &,ocivcindex,tcivcindex,mol,switch_v_beta)
    !!
    Implicit None
    !!IO
    Type(T_Mesh),Pointer         :: basmeshs(:)
    Type(T_Mol),Intent(in)       :: mol
    Integer(t_int),Intent(in)    :: nrbmax
    Logical(t_log),Intent(in)    :: switch_v_beta
    Integer(t_int),Intent(in)    :: mspin,naps,nsite,nsort,isrt(nsite)
    Integer(t_int),Intent(in)    :: npairsmax
    Integer(t_int),Intent(in)    :: posToSiteRep(nsite)
    Integer(t_int),Intent(in)    :: numops,equivsites(48,nsite)
    Real(t_real),Intent(in)      :: wu_ks(:,:,0:,:)
    Integer(t_int),Intent(in)    :: gdiff(0:npairsmax,48,nsite,nsite)
    !Integer(t_int),Intent(in)    :: nqAtPos(nsite),qposToSite(nsite,nsite)
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: ncomp,icomp
    Integer(t_int),Intent(in)    :: nvm,nv(nsort),lv(nvm,nsort)
    Integer(t_int),Intent(in)    :: ncm,nc(nsort),lc(ncm,nsort)
    Integer(t_int),Intent(in)    :: ocivcindex(nsite)
    Integer(t_int),Intent(in)    :: tcivcindex(:,:,:)
    Real(t_real),Intent(in)      :: rfvmax(nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: rfcmax(ncm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fgam(nsort)
    Real(t_real),Intent(in)      :: fv(nrbmax,nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fc(nrbmax,ncm,ncomp,nsort)
    Integer(t_int),Intent(in)    :: ncsmx
    Integer(t_int),Intent(in)    :: degree
    Integer(t_int),Intent(in)    :: ocivcdim,tcivcdim
    Real(t_real),Intent(in)      :: pairs(:,:,:,:)
    Real(t_real),Intent(in)      :: rtfvmax(0:ncomp,nsort)
    Real(t_real),Intent(in)      :: rtfcmax(0:ncomp,nsort)
    Real(t_real),Intent(inout)   :: oci_vHc(ocivcdim,mspin)
    Real(t_real),Intent(inout)   :: tci_vHc(tcivcdim,mspin)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="calc_thcis_vc"
    Logical(t_log) :: lsp
    Integer(t_int) :: ispp,isp,isv,issa,lmxa,i,l,m,isc,isa,lena,itci0
    Integer(t_int) :: mxblsizev,mxblsizec,nva,nca,inblv,inblc,nblv,nblc
    Integer(t_int) :: ircp,irvp,iblv,iblc
    Integer(t_int) :: icbm1,nap,irap,im
    Integer(t_int) :: il,k,itci,indexa,lindexa
    Integer(t_int) :: itcidif(0:npairsmax,nsite,0:npairsmax,nsite)!!TODO
    Integer(t_int) :: lmxv(nsort),blocklenv(nsite)
    Integer(t_int) :: lmxc(nsort),blocklenc(nsite)
    Integer(t_int) :: ioci,ir0
    Real(t_real)   :: vv1,vv2,v1,v2,ww,ra,ff1,rsh(3),rra(3),oora,texp
    Real(t_real)   :: vv,ovv1,ovv2
    Real(t_real)   :: yl((ORBITAL_MAX_L+3_t_int)**2_t_int)
    Real(t_real)   :: coefa(0:degree)
    Real(t_real)   :: lcoefa(0:degree)
    Real(t_real)   :: fb1(0:ncsmx)
    Integer(t_int),Pointer :: p_isiteblv(:)
    Integer(t_int),Pointer :: p_isiteblc(:)
    Integer(t_int),Pointer :: p_ipairblv(:)
    Integer(t_int),Pointer :: p_ipairblc(:)
    Real(t_real),Pointer   :: p_fvbl(:)
    Real(t_real),Pointer   :: p_fcbl(:)
    Real(t_real),Pointer   :: p_vlocv(:)
    Real(t_real),Pointer   :: p_vlocc(:)
    !Real(t_real),Parameter :: zero=0.0_t_real
    Type(T_Mesh),Pointer   :: bmesha
    Type(T_Mesh),Pointer   :: atommesha
    !!
    Nullify(p_fvbl)
    Nullify(p_fcbl)
    Nullify(p_vlocv)
    Nullify(p_vlocc)
    Nullify(p_isiteblv)
    Nullify(p_isiteblc)
    Nullify(p_ipairblv)
    Nullify(p_ipairblc)
    !!
    Call prep_thcis(nsort,nsite,isrt,npairs,npairsmax,nvm,nv,lv&
         &,lmxv,blocklenv,mxblsizev,p_fvbl,p_vlocv,p_isiteblv,p_ipairblv)
    !!
    Call prep_thcis(nsort,nsite,isrt,npairs,npairsmax,ncm,nc,lc&
         &,lmxc,blocklenc,mxblsizec,p_fcbl,p_vlocc,p_isiteblc,p_ipairblc)
    !!
    !!
    !!
    !! doit
    !!
    lsp=(mspin == 2_t_int)
    Do ispp=1_t_int,naps
1      Format('real site',i5)
       If(outlevel >= L_more) Write(outfile,1) ispp
       isp=posToSiteRep(ispp)
       !!       
       !!
       Call vecdifn(nsite,isp,itcidif,npairs,npairsmax,pairs,tcivcindex)
       !!
       imloop: Do im=1_t_int,mol% p_nm(isp)
          If(outlevel >= L_many .And.Mod(im,(mol% p_nm(isp)/100)) == 0_t_int)Then
             Write(outfile,5) isp,100.0_t_real*im/mol% p_nm(isp)
          Endif
5         Format('site: ',i5,' ',f5.1,'% done')

          rsh(:)=mol% p_rm(:,im,isp)
          ww=mol% p_wm(im,isp)
          v1=mol% p_vm2(1,im,isp)
          v2=v1
          if(lsp) v2=mol% p_vm2(2,im,isp)
          vv1=v1*ww
          vv2=v2*ww
          !!
          !! exchanged vv1 and vv2 due to beta-matrix
          ovv1=vv1
          ovv2=vv2
          If(switch_v_beta .And. icomp==2 )Then
             ovv1=vv2
             ovv2=vv1
          Endif
          !!
          !! interpolate all functions which are nonzero at r=(x,y,z)
          !!
          iblv=0
          inblv=0
          p_fvbl(:)=0.0_t_real
          iblc=0
          inblc=0
          p_fcbl(:)=0.0_t_real
          isapreploop: Do isa=1_t_int,nsite
             issa=isrt(isa)
             !!
             bmesha => basmeshs(issa)
             atommesha => mol% p_atommeshs(issa)
             !!
             nva=nv(issa)
             nca=nc(issa)
             !!
             lmxa=Max(lmxv(issa),lmxc(issa))
             !!
             nap=npairs(isa,isp)
             !!
             !!
             ir0=1
             If(isp==isa)Then
                ir0=0
             Endif
             !!
             irnappreploop: Do irap=ir0,nap

                If(irap==0)Then
                   rra(:)=rsh(:)
                Else
                   rra(:)=rsh(:)-pairs(:,irap,isa,isp)
                Endif
                ra=Max(Sqrt(Dot_product(rra,rra)),1.0e-16_t_real)
                If(ra==0.0_t_real)Then
                   oora=0.0_t_real
                Else
                   oora=1.0_t_real/ra
                Endif
                texp=ra**fgam(issa)*oora
                !!
                If(ra > Max(rtfcmax(icomp,issa),rtfvmax(icomp,issa)))&
                     & Cycle irnappreploop
                !!
                !! valence functions
                !!
                lindexa=mintpl_coefs(degree,atommesha,ra,lcoefa)
                indexa=mintpl_coefs(degree,bmesha,ra,coefa)
                Call ylms12(yl,rra(1),rra(2),rra(3),lmxa)
                !!
                If(ra > rtfvmax(icomp,issa)) Goto 999
                !!
                !!
                k=0_t_int
                Do i=1_t_int,nva
                   l=lv(i,issa)
                   
                   ff1=0.0_t_real
                   If(ra <= rfvmax(i,icomp,issa) )Then
                      ff1=Dot_product(fv(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp
                   End If


                   il=l*l
                   Do m=1_t_int,l+l+1_t_int
                      il=il+1
                      k=k+1_t_int
                      p_fvbl(inblv+k)=ff1*yl(il)
                   Enddo       ! m
                Enddo         ! i
                iblv=iblv+1
                p_isiteblv(iblv)=isa
                p_ipairblv(iblv)=irap
                inblv=inblv+blocklenv(isa)
                !! local potential
                p_vlocv(iblv)=&
                     &Dot_product(mol% p_vatom(lindexa:lindexa+degree,0,issa)&
                     &,lcoefa(0:degree))*oora/sq4pi*ww
                !!
999             Continue
                !!
                !! core functions
                !!
                If(ra > rtfcmax(icomp,issa)) Cycle irnappreploop
                !!
                !!

                k=0_t_int
                Do i=1_t_int,nca
                   l=lc(i,issa)
                   
                   ff1=0.0_t_real
                   If(ra <= rfcmax(i,icomp,issa) )Then
                      ff1=Dot_product(fc(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp
                   End If



                   il=l*l
                   Do m=1_t_int,l+l+1_t_int
                      il=il+1
                      k=k+1_t_int
                      p_fcbl(inblc+k)=ff1*yl(il)
                   Enddo       ! m
                Enddo         ! i
                iblc=iblc+1
                p_isiteblc(iblc)=isa
                p_ipairblc(iblc)=irap
                inblc=inblc+blocklenc(isa)
                !! local potential
                p_vlocc(iblc)=&
                     &Dot_product(mol% p_vatom(lindexa:lindexa+degree,0,issa)&
                     &,lcoefa(0:degree))*oora/sq4pi*ww
                !!
                !!TODO: shift vloc-interpol before rmax test

             Enddo irnappreploop
          End Do isapreploop
          nblv=iblv
          nblc=iblc
          !! 
          !! 
          !! TODO: extra lsp 
          !! 
          !! 
          !! 
          !! one-center terms
          !! 

          inblc=1
          oblcloop: Do iblc=1,nblc !! b-site (core) blocks
             isc=p_isiteblc(iblc)
             icbm1=blocklenc(isc)-1_t_int
             lena=blocklenv(isc)
             ircp=p_ipairblc(iblc)
             !!
             !! 
             iblv=-1
             inblv=0
             oblvloop: Do i=1,nblv !! a-site (valence) blocks
                isv=p_isiteblv(i)
                If( (isc == isv) .And. ( ircp == p_ipairblv(i) )   )Then
                   iblv=i
                   Exit oblvloop
                Endif
                inblv=inblv+blocklenv(isv)
             Enddo oblvloop
             If(iblv==-1) Cycle oblcloop
             !!
             !!
             ioci=ocivcindex(isc)+1
             fb1(0:icbm1)=p_fcbl(inblc:inblc+icbm1)*(ovv1-p_vlocc(iblc))
             Do k=1_t_int,lena
                oci_vHc(ioci:ioci+icbm1,1)&
                     &=oci_vHc(ioci:ioci+icbm1,1)&
                     &+fb1(0:icbm1)*p_fvbl(inblv+k)
                ioci=ioci+icbm1+1
             Enddo   ! k
             If(lsp)Then
                ioci=ocivcindex(isc)+1
                fb1(0:icbm1)=p_fcbl(inblc:inblc+icbm1)*(ovv2-p_vlocc(iblc))
                Do k=1_t_int,lena
                   oci_vHc(ioci:ioci+icbm1,2)&
                        &=oci_vHc(ioci:ioci+icbm1,2)&
                        &+fb1(0:icbm1)*p_fvbl(inblv+k)
                   ioci=ioci+icbm1+1
                Enddo   ! k
             Endif
             inblc=inblc+icbm1+1
          Enddo oblcloop
          !!
          !! 
          !! 
          If ( icomp > 1 ) Cycle imloop
          !If(icomp == 2 .Or. icomp ==4) Cycle imloop

          !! 
          !! two center terms
          !! 
          inblc=1
          iblcloop: Do iblc=1,nblc !! b-site (core) blocks
             isc=p_isiteblc(iblc)
             icbm1=blocklenc(isc)-1_t_int
             ircp=p_ipairblc(iblc)

             fb1(0:icbm1)=p_fcbl(inblc:inblc+icbm1)
             !! 
             inblv=0
             iblvloop: Do iblv=1,nblv !! a-site (valence) blocks
                isv=p_isiteblv(iblv)
                lena=blocklenv(isv)
                irvp=p_ipairblv(iblv)
                !!
                itci0=itcidif(irvp,isv,ircp,isc)
                !!
                If((itci0 == 0_t_int) )Goto 500 !! TODO: check this
                !! TODO: it should be impossible, what happens with atom 
                !! TODO: dependend rmax
                !!
                vv=vv1-p_vlocc(iblc)-p_vlocv(iblv)
                !!
                itci=itci0
                Do k=1_t_int,lena
                   tci_vHc(itci:itci+icbm1,1)&
                        &=tci_vHc(itci:itci+icbm1,1)&
                        &+fb1(0:icbm1)*p_fvbl(inblv+k)*vv
                   itci=itci+icbm1+1
                Enddo   ! k
                If(lsp)Then
                   !!
                   vv=vv2-p_vlocc(iblc)-p_vlocv(iblv)
                   !!
                   itci=itci0
                   Do k=1_t_int,lena
                      tci_vHc(itci:itci+icbm1,2)&
                           &=tci_vHc(itci:itci+icbm1,2)&
                           &+fb1(0:icbm1)*p_fvbl(inblv+k)*vv
                      itci=itci+icbm1+1
                   Enddo   ! k
                Endif
500             Continue
                inblv=inblv+lena
             Enddo iblvloop
             inblc=inblc+icbm1+1
          Enddo iblcloop
          !!
          !! 
          !!
       Enddo imloop             ! ig
    Enddo                     ! isp
    !!
    !!
    Call pfree(p_ipairblc)
    Call pfree(p_ipairblv)
    Call pfree(p_isiteblc)
    Call pfree(p_isiteblv)
    Call pfree(p_vlocc)
    Call pfree(p_vlocv)
    Call pfree(p_fcbl)
    Call pfree(p_fvbl)
    !!
    Call symmetrize_oci(mspin,nsite,isrt&
         &,numops,equivsites,wu_ks&
         &,nvm,nv,lv&
         &,ncm,nc,lc&
         &,ocivcdim,oci_vHc,ocivcindex)

    If(icomp <= 1) Then
    !If(icomp == 1 .Or. icomp ==3) Then
       
       Call symmetrize_tci(mspin,nsite,isrt&
            &,npairsmax,npairs&
            &,numops,equivsites,wu_ks&
            &,nvm,nv,lv&
            &,ncm,nc,lc&
            &,tcivcdim,tci_vHc,tcivcindex,gdiff)
       
    Endif
    !!
    Return
    !!
  End Subroutine calc_thcis_vc
  !!***********************************************************************
  Subroutine rel_calc_core_thcis(mspin,structure,symmetry&
       &,nsite,nsort,naps,isrt,posToSiteRep&
       &,npairs,pairs,npairsmax&
       &,basmeshs,nrbmax&
       &,nRcmx,nRc,kapRc,fc,fgam&
       &,rtfcmax,rfcmax,basis&
       &,ociccdim,roci_cHc,ociccindex&
       &,degree,mol)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Mesh),Pointer         :: basmeshs(:)
    Type(T_Mol),Intent(in)       :: mol
    Type(T_Basis),Intent(in)     :: basis
    Integer(t_int),Intent(in)    :: nrbmax
    Integer(t_int),Intent(in)    :: mspin,naps,nsite,nsort,isrt(nsite)
    Integer(t_int),Intent(in)    :: posToSiteRep(nsite)
    !Integer(t_int),Intent(in)    :: nqAtPos(nsite),qposToSite(nsite,nsite)
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: nRcmx,nRc(nsort),kapRc(nRcmx,nsort)
    Integer(t_int),Intent(in)    :: ociccindex(nsite)
    Real(t_real),Intent(in)      :: rfcmax(nRcmx,2,nsort)
    Real(t_real),Intent(in)      :: fgam(nsort)
    Real(t_real),Intent(in)      :: fc(nrbmax,nRcmx,2,nsort)
    Integer(t_int),Intent(in)    :: npairsmax
    Integer(t_int),Intent(in)    :: degree
    Integer(t_int),Intent(in)    :: ociccdim
    Real(t_real),Intent(in)      :: pairs(:,:,:,:)
    Real(t_real),Intent(in)      :: rtfcmax(0:2,nsort)
    !!
    Complex(t_real),Intent(inout):: roci_cHc(ociccdim)
    !!LOCAL
    Character(*),Parameter::nsubfunc="rel_calc_core_thcis"
    Logical(t_log) :: lsp
    Integer(t_int) :: ispp,isp,isa,issa,nca,lmxa,icr,isb,icomp,i
    Integer(t_int) :: ibl,inbl,mxinbl,nbl,iblb,inblb,ind,ml
    Integer(t_int) :: smxinbl,sinbl,sk,sinblb
    Integer(t_int) :: icbm1,nap,irap,im,kap,l
    Integer(t_int) :: k,indexa,jocicc,PNRncsmx,PNRsncsmx,leng,sleng
    Integer(t_int) :: issb
    Integer(t_int) :: lmx(nsort),blocklen(nsite),lRcl(nRcmx,nsite)
    Integer(t_int) :: sblocklen(nsite),lRcs(nRcmx,nsite),kapRcs(nRcmx,nsite)
    Integer(t_int) :: isbl(nsite*Max(1_t_int,npairsmax))
    Integer(t_int) :: iocicc,siocicc,ir0,ocindex(nsite),socindex(nsite)
    Integer(t_int) :: nocicc,snocicc
    Real(t_real)   :: vv1,vv2,v1,v2,ww,ra,rsh(3),rra(3),oora,ff1(2),texp
    Real(t_real)   :: vloc(nsite*Max(1_t_int,npairsmax))
    Real(t_real)   :: coefa(0:degree)
    Real(t_real)   :: ylm((ORBITAL_MAX_L+3_t_int)**2_t_int)
    Real(t_real),Pointer   :: fabl1(:)
    Real(t_real),Pointer   :: sfabl1(:)
    Real(t_real),Pointer   :: fb1(:)
    Real(t_real),Pointer   :: sfb1(:)
    Real(t_real),Pointer   :: tmp(:,:)
    Real(t_real),Pointer   :: stmp(:,:)
    Real(t_real),Parameter :: zero=0.0_t_real
    Type(T_Mesh),Pointer :: bmesha
    Type(T_Mesh),Pointer :: atommesha
    !!
    Nullify(fabl1)
    Nullify(sfabl1)
    Nullify(fb1)
    Nullify(sfb1)
    Nullify(tmp)
    Nullify(stmp)
    !!
    !!
    !! determine max core-l and blocklenght
    !!
    lmx(1:nsort)=0_t_int
    blocklen(1:nsite)=0_t_int
    lRcl(1:nRcmx,1:nsite)=0_t_int
    sblocklen(1:nsite)=0_t_int
    lRcs(1:nRcmx,1:nsite)=0_t_int
    kapRcs(1:nRcmx,1:nsite)=0_t_int
    !!
    nocicc=0
    PNRncsmx=0
    snocicc=0
    PNRsncsmx=0
    Do isa=1_t_int,nsite
       issa=isrt(isa)
       nca=nRc(issa)
       leng=0
       sleng=0
       If(nca /= 0_t_int)Then
          Do icr=1,nca
             kap=kapRc(icr,issa)
             l=(Abs(2*kap+1)-1)/2
             lmx(issa)=Max(lmx(issa),l)
             leng=leng+(2*l+1)
             lRcl(icr,issa)=l
             !! small component
             l=(Abs(-2*kap+1)-1)/2
             lRcs(icr,issa)=l
             kapRcs(icr,issa)=-kap
             sleng=sleng+(2*l+1)
          Enddo
       End If
       blocklen(isa)=leng
       PNRncsmx=Max(PNRncsmx,leng)
       ocindex(isa)=nocicc
       nocicc=nocicc+blocklen(isa)**2
       !! small component
       sblocklen(isa)=sleng
       PNRsncsmx=Max(PNRsncsmx,sleng)
       socindex(isa)=snocicc
       snocicc=snocicc+sblocklen(isa)**2
    Enddo
    !!
    Call palloc('tmp' ,tmp ,1_t_int,nocicc ,1_t_int,mspin,nmodule,nsubfunc)
    Call palloc('stmp',stmp,1_t_int,snocicc,1_t_int,mspin,nmodule,nsubfunc)
    tmp(:,:)=zero
    stmp(:,:)=zero
    !!
    !!
    !! determine max temp array length
    !!
    mxinbl=0_t_int
    smxinbl=0_t_int
    Do isp=1,nsite
       inbl=0_t_int
       Do isa=1_t_int,nsite
          !Print *,'isa=',isa,' inbl=',inbl,' bl=',blocklen(isa),(npairs(isa,isp)+1)
          inbl=inbl+blocklen(isa)*(npairs(isa,isp)+1)
       Enddo
       !       If(outlevel >= L_more) Write(outfile,20) isp,inbl
       mxinbl=Max(mxinbl,inbl)
       !! small component
       inbl=0_t_int
       Do isa=1_t_int,nsite
          inbl=inbl+sblocklen(isa)*(npairs(isa,isp)+1)
       Enddo
       !       If(outlevel >= L_more) Write(outfile,20) isp,inbl
       smxinbl=Max(smxinbl,inbl)
    Enddo
    !    If(outlevel >= L_more) Write(outfile,21) mxinbl
!20  Format('isp=',i5,' inbl=',i7)
!21  Format('mxinbl=',i7)
    !!
    Call palloc('fabl1' ,fabl1 ,1_t_int,mxinbl  ,nmodule,nsubfunc)
    Call palloc('sfabl1',sfabl1,1_t_int,smxinbl ,nmodule,nsubfunc)
    Call palloc('fb1'   ,fb1   ,0_t_int,PNRncsmx-1 ,nmodule,nsubfunc)
    Call palloc('sfb1'  ,sfb1  ,0_t_int,PNRsncsmx-1,nmodule,nsubfunc)
    !!
    !! doit
    !!
    lsp=(mspin == 2_t_int)
    Do ispp=1_t_int,naps
1      Format('real site',i5)
       If(outlevel >= L_more) Write(outfile,1) ispp
       isp=posToSiteRep(ispp)
       !!       
       !!
       !!
       imloop: Do im=1_t_int,mol% p_nm(isp)
          If(outlevel >= L_many &
               &.And.Mod(im,(mol% p_nm(isp)/100)) == 0_t_int)Then
             Write(outfile,5) isp,100.0_t_real*im/mol% p_nm(isp)
          Endif
5         Format('site: ',i5,' ',f5.1,'% done')

          rsh(:)=mol% p_rm(:,im,isp)
          ww=mol% p_wm(im,isp)
          v1=mol% p_vm2(1,im,isp)
          v2=v1
          If(lsp) Then
             v2=mol% p_vm2(2,im,isp)
          Endif
          !! potential times integration weight
          vv1=v1*ww
          vv2=v2*ww
          !!
          !! interpolate all functions which are nonzero at r=(x,y,z)
          !!
          ibl=0 ! index of surrounding site blocks
          inbl=0
          sinbl=0
          fabl1(:)=zero
          sfabl1(:)=zero
          isapreploop: Do isa=1_t_int,nsite
             issa=isrt(isa)
             !!
             bmesha => basmeshs(issa)
             atommesha => mol% p_atommeshs(issa)
             !!
             nca=nRc(issa)
             !!
             lmxa=lmx(issa)
             !!
             nap=npairs(isa,isp)
             !!
             !!
             ir0=1
             If(isp==isa)Then
                !! include on-site terms, which are excluded in
                !! definition of pairs(...)
                ir0=0 
                !!
             Endif
             !!
             irnappreploop: Do irap=ir0,nap

                If(irap==0)Then
                   rra(:)=rsh(:)
                Else
                   rra(:)=rsh(:)-pairs(:,irap,isa,isp)
                Endif
                ra=Max(Sqrt(Dot_product(rra,rra)),1.0e-16_t_real)
                If(ra==0.0_t_real)Then
                   oora=0.0_t_real
                Else
                   oora=1.0_t_real/ra
                Endif


                If(ra > rtfcmax(0,issa)) Cycle irnappreploop
                !!
                texp=ra**fgam(issa)*oora
                !!
                indexa=mintpl_coefs(degree,bmesha,ra,coefa)

                Call ylms12(ylm,rra(1),rra(2),rra(3),lmxa+1)



                k=0_t_int
                sk=0_t_int
                Do icr=1_t_int,nca

                   !! interpolate the radial functions
                   
                   Do icomp=1,2
                      ff1(icomp)=zero
                      If(ra <= rfcmax(icr,icomp,issa) )Then
                         ff1(icomp)=Dot_product(&
                              &fc(indexa:indexa+degree,icr,icomp,issa)&
                              &,coefa(0:degree))*texp
                      End If
                   Enddo
                   !!
                   !!
                   !!
                   kap=kapRc(icr,issa)
                   l=(Abs(2*kap+1)-1)/2
                   !!
                   !!
                   Do ml=-l,l
                      k=k+1
                      !! large component
                      ind=l*(l+1)+1
                      !!
                      fabl1(inbl+k)=ff1(1)*ylm(ind+ml)
                   Enddo       ! m
                   !! small component
                   l=(Abs(-2*kap+1)-1)/2
                   !!
                   !!
                   Do ml=-l,l
                      sk=sk+1
                      !! large component
                      ind=l*(l+1)+1
                      !!
                      sfabl1(sinbl+sk)=ff1(2)*ylm(ind+ml)
                   Enddo       ! m
                Enddo         ! icr
                !Print *,'k=',k
                ibl=ibl+1
                isbl(ibl)=isa
                inbl=inbl+blocklen(isa)
                sinbl=sinbl+sblocklen(isa)
                !! local potential
                indexa=mintpl_coefs(degree,atommesha,ra,coefa)
                vloc(ibl)=&
                     &Dot_product(mol% p_vatom(indexa:indexa+degree,0,issa)&
                     &,coefa(0:degree))*oora/sq4pi*ww
                !!
             Enddo irnappreploop
          End Do isapreploop
          nbl=ibl
          !! 
          !! 
          !! 
          !! 
          !! 
          !! one-center core terms
          inblb=1
          oiblbloop: Do iblb=1,nbl
             isb=isbl(iblb)
             issb=isrt(isb)
             icbm1=blocklen(isb)-1_t_int
             !!
             !!
             iocicc=ocindex(isb)+1
             fb1(0:icbm1)=fabl1(inblb:inblb+icbm1)*(vv1-vloc(iblb))
             Do k=0,icbm1 ! a-atom
                Do i=0,icbm1 ! b-atom
                   tmp(iocicc+i,1)=tmp(iocicc+i,1)+fabl1(inblb+k)*fb1(i)
                Enddo
                iocicc=iocicc+icbm1+1
             End Do ! kk
             If(lsp)Then
                iocicc=ocindex(isb)+1
                fb1(0:icbm1)=fabl1(inblb:inblb+icbm1)*(vv2-vloc(iblb))
                Do k=0,icbm1 ! a-atom
                   Do i=0,icbm1 ! b-atom
                      tmp(iocicc+i,2)=tmp(iocicc+i,2)+fabl1(inblb+k)*fb1(i)
                   Enddo
                   iocicc=iocicc+icbm1+1
                End Do ! kk
             Endif
             inblb=inblb+icbm1+1
          Enddo oiblbloop
          !! small component
          sinblb=1
          soiblbloop: Do iblb=1,nbl
             isb=isbl(iblb)
             issb=isrt(isb)
             icbm1=sblocklen(isb)-1_t_int
             !!
             !!
             !! exchanged vv1 and vv2 due to beta-matrix
             siocicc=socindex(isb)+1
             sfb1(0:icbm1)=sfabl1(sinblb:sinblb+icbm1)*(vv2-vloc(iblb))
             Do k=0,icbm1 ! a-atom
                Do i=0,icbm1 ! b-atom
                   stmp(siocicc+i,1)=stmp(siocicc+i,1)+sfabl1(sinblb+k)*sfb1(i)
                Enddo
                siocicc=siocicc+icbm1+1
             End Do ! kk
             If(lsp)Then
                siocicc=socindex(isb)+1
                sfb1(0:icbm1)=sfabl1(sinblb:sinblb+icbm1)*(vv1-vloc(iblb))
                Do k=0,icbm1 ! a-atom
                   Do i=0,icbm1 ! b-atom
                      stmp(siocicc+i,2)=stmp(siocicc+i,2)+sfabl1(sinblb+k)*sfb1(i)
                   Enddo
                   siocicc=siocicc+icbm1+1
                End Do ! kk
             Endif
             sinblb=sinblb+icbm1+1
          Enddo soiblbloop
          !!
       Enddo imloop             ! ig
    Enddo                     ! isp
    !!
    Call pfree(fb1)
    Call pfree(sfb1)
    Call pfree(fabl1)
    Call pfree(sfabl1)
    !!

    Call symmetrize_oci(mspin,nsite,isrt&
         &,symmetry% Rnumops,structure% p_equivsites,symmetry% Rwu_ks&
         &,nRcmx,nRc,lRcl&
         &,nRcmx,nRc,lRcl&
         &,nocicc,tmp,ocindex)

    Call symmetrize_oci(mspin,nsite,isrt&
         &,symmetry% Rnumops,structure% p_equivsites,symmetry% Rwu_ks&
         &,nRcmx,nRc,lRcs&
         &,nRcmx,nRc,lRcs&
         &,snocicc,stmp,socindex)



    Do isb=1,nsite
       issb=isrt(isb)
       nca=nRc(issb)
       !!
       jocicc=ocindex(isb)
       iocicc=ociccindex(isb)
       !!
       Call reltrans_loi_block(lsp,nca,kapRc(:,issb),nca,kapRc(:,issb)&
            &,jocicc,iocicc,tmp,roci_cHc&
            &,basis% lmx,basis% p_relTOpseudo)



       !! small component

       iocicc=ociccindex(isb)
       jocicc=socindex(isb)


       Call reltrans_loi_block(lsp,nca,kapRcs(:,issb),nca,kapRcs(:,issb)&
            &,jocicc,iocicc,stmp,roci_cHc&
            &,basis% lmx,basis% p_relTOpseudo)



    Enddo ! isa
    !!
    Call pfree(tmp)
    Call pfree(stmp)
    !!
    Return
    !!
  End Subroutine rel_calc_core_thcis
  !!***********************************************************************
  Subroutine reltrans_loi_block(lsp,nRva,kapRva,nRvb,kapRvb&
       &,PNRindex,Rindex,PNRloi,Rloi,lmx,TT)
    !!
    Implicit None  
    !!IO
    Logical(t_log),Intent(in)    :: lsp
    Integer(t_int),Intent(in)    :: nRva,nRvb,kapRva(:),kapRvb(:)
    Integer(t_int),Intent(in)    :: PNRindex,Rindex
    Integer(t_int),Intent(in)    :: lmx
    Complex(t_real),Intent(in)   :: TT(2*lmx+3,2*lmx+2,2,-lmx-1:lmx+1)
    Real(t_real),Intent(in)      :: PNRloi(:,:)
    Complex(t_real),Intent(inout):: Rloi(:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="reltrans_loi_block"
    Integer(t_int) :: ii,deglb,degjb,jj,degla,degja,ia,ivb,kapb,kapa,lb,la,ma
    Integer(t_int) :: iva,ms,PNRlena,Rlenb
    Complex(t_real),Pointer:: A(:,:,:)
    !!
    A => Null()
    !!
    PNRlena=0
    Rlenb=0
    If(nRva>0) PNRlena=Sum(Abs(2*kapRva(1:nRva)+1))
    If(nRvb>0) Rlenb  =Sum(2*Abs(kapRvb(1:nRvb)))
    !!
    !!
    !!
    Call palloc('A',A,1_t_int,PNRlena,1_t_int,Rlenb,1_t_int,2_t_int&
         &,nmodule,nsubfunc)
    !!
    ms=1
    if(lsp) ms=2
    !!
    !! Oin,jm=sum_s ( G^{s+}  * O^s_{in,jm} * G^s )
    ii=PNRindex !! pseudo-nonrel index
    Do ia=1,PNRlena !! lena is pseudo-nonrel 
       jj=0
       Do ivb=1,nRvb  
          kapb=kapRvb(ivb)
          lb=(Abs(2*kapb+1)-1)/2
          deglb=2*lb+1
          degjb=2*Abs(kapb)
          !!
          A(ia,jj+1:jj+degjb,1)=Matmul(PNRloi(ii+1:ii+deglb,1)&
               &             ,TT(1:deglb,1:degjb,1,kapb))
          A(ia,jj+1:jj+degjb,2)=Matmul(PNRloi(ii+1:ii+deglb,ms)&
               &             ,TT(1:deglb,1:degjb,2,kapb))
          jj=jj+degjb
          ii=ii+deglb
       Enddo
    Enddo
    !!
    ii=Rindex
    jj=0
    Do iva=1,nRva
       kapa=kapRva(iva)
       la=(Abs(2*kapa+1)-1)/2
       degla=2*la+1
       degja=2*Abs(kapa)

       Do ma=1,degja
          !!
          Rloi(ii+1:ii+Rlenb)=Rloi(ii+1:ii+Rlenb)&
               &+Matmul(Conjg(TT(1:degla,ma,1,kapa))&
               & ,A(jj+1:jj+degla,1:Rlenb,1)) &
               &+Matmul(Conjg(TT(1:degla,ma,2,kapa))&
               & ,A(jj+1:jj+degla,1:Rlenb,2))
          !!
          ii=ii+Rlenb
       Enddo
       jj=jj+degla
    Enddo
    !!
    Call pfree(A)
    !!
    Return
    !!
  End Subroutine reltrans_loi_block
  !!***********************************************************************
  Subroutine manipulate_OVO(structure,nma,nRa,lRa,nmb,nRb,lRb,glmax,wgaunt&
       &,ociindex,ocitmp,oci)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Integer(t_int),Intent(in)    :: nma,nRa(*),lRa(nma,*)
    Integer(t_int),Intent(in)    :: nmb,nRb(*),lRb(nmb,*)
    Integer(t_int),Intent(in)    :: ociindex(*)
    Integer(t_int),Intent(in)    :: glmax
    Real(t_real),Intent(in)      :: ocitmp(:)
    Real(t_real),Intent(inout)   :: oci(:)
    Real(t_real),Intent(in)      :: wgaunt((  glmax+1)**2&
         &                               , (  glmax+1)**2&
         &                               , (2*glmax+1)**2)
    !!LOCAL
    Character(*),Parameter::nsubfunc="manipulate_OVO"
    Integer(t_int) :: isa,issa,ia,la,lqa,ma,ib,lb,lqb,mb,ila,ilb
    Integer(t_int) :: ilm,ioci,LL
    Real(t_real)   :: w,w0,alll
    Real(t_real),Pointer :: p_ociLM(:,:)
    !!
    Nullify(p_ociLM)
    !!
    Call palloc('p_ociLM',p_ociLM,1_t_int,nma,1_t_int,nmb,nmodule,nsubfunc)
    
    !!
    Do ilm=1,(2*glmax+1)**2
       !!
       !Print *,'ilm=',ilm,llilm(ilm),mmilm(ilm)-llilm(ilm)-1
       
       LL=llilm(ilm)
       !!
       !!
       Do isa=1,structure% nsite
          issa=structure% p_isrt(isa)
          !Print *,'isa=',isa
          
          
          
          !! fold the matrix elements with the gaunt coefficient
          p_ociLM(:,:)=0.0_t_real
          ioci=ociindex(isa)
          Do ia=1,nRa(issa)
             la=lRa(ia,issa)
             lqa=la*la
             Do ma=1,la+la+1
                ila=lqa+ma
                
                Do ib=1,nRb(issa)
                   lb=lRb(ib,issa)
                   lqb=lb*lb
                   Do mb=1,lb+lb+1
                      ilb=lqb+mb
                      w=wgaunt(ila,ilb,ilm)
                      !!
                      ioci=ioci+1
                      p_ociLM(ia,ib)=p_ociLM(ia,ib)+ocitmp(ioci)*w
                      !!
                   Enddo ! mb
                Enddo ! ib
             Enddo ! ma
          Enddo ! ia
          !!
          !! reassemble the matrix
          !!
          !!
          ioci=ociindex(isa)
          Do ia=1,nRa(issa)
             la=lRa(ia,issa)
             lqa=la*la
             Do ma=1,la+la+1
                ila=lqa+ma
                
                Do ib=1,nRb(issa)
                   lb=lRb(ib,issa)
                   lqb=lb*lb
                   Do mb=1,lb+lb+1
                      ilb=lqb+mb
                      w=wgaunt(ila,ilb,ilm)
                      w0=wgaunt(lqa+la+1,lqb+lb+1,LL*LL+LL+1)
                      !!
                      ioci=ioci+1
                      If(la>0 .And.lb>0 .And. Abs(w0)>1.0e-10_t_real)Then
                         alll=0.5_t_real*(la*(la+1)+lb*(lb+1)-LL*(LL+1))&
                              &/Sqrt(la*(la+1.0_t_real)*lb*(lb+1))
                         oci(ioci)=oci(ioci)+p_ociLM(ia,ib)*w/w0&
                              &*Sqrt(fourpi*(2*LL+1)/((2*la+1)*(2*lb+1)))*alll
                      Endif
                   Enddo
                Enddo
             Enddo
          Enddo
          !!
          !!
       Enddo ! isa
       !!
       !!
       !!
    Enddo ! ilm
    !!
    Call pfree(p_ociLM)
    !!
    Return
    !!
  End Subroutine manipulate_OVO
  !!***********************************************************************

  
End Module loi
