!!TODO: cleanup main routine
!!TODO: combine valence with core and core-FREL with the rest also in molint.f90
!!TODO: check semicore treatment
!! TODO: FREL
!! TODO: remove on-center term, which are zero
Module loif
  !!
  Use precisiondefs
  Use file_iounits
  Use errors
  Use memory
  Use constants
  Use tmol
  Use tsymmetry
  Use torbitalbasis
  Use loisym
  Use clock
  Use tnumerics
  Use integrate1d
  Use vecharm
  Use atomdefs
  Use tmesh
  Use tloi
  Use loiaux
  Use mesh
  Use prnt
  Use loiaux
  Use matserv
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="LOIF"  
  !!
  Public :: loif_int
  !!***********************************************************************
  Character(*),Parameter :: fmtstart=&
       &"(/,/,'============================== START ',a&
       &,'============================== ')"
  Character(*),Parameter :: fmtend=&
       &"('============================== END   ',a&
       &,'============================== ',/,/)"
Contains
  !!***********************************************************************
  !!
  Subroutine  loif_int(mspin,symmetry,structure,lattice,basis,mol&
       &,loi,numerics,ncsmx,nvsmx,cblocklength,vblocklength,calc_THCI)
    !!
    Implicit None  
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Mol),Intent(in)       :: mol
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Loi),Intent(inout)    :: loi
    Type(T_Numerics),Intent(in)  :: numerics
    Logical(t_log),Intent(in)    :: calc_THCI
    Integer(t_int),Intent(in)    :: mspin
    Integer(t_int),Intent(in)    :: ncsmx,nvsmx
    Integer(t_int),Intent(in)    :: cblocklength(*),vblocklength(*)
    !!LOCAL
    Character(*),Parameter::nsubfunc="loif_int"
    Character(*),Parameter :: cpumesg_oci='One-center force integrals'
    Character(*),Parameter :: cpumesg_tci='Two-center force integrals'
    Character(*),Parameter :: cpumesg_thcicc='Three-center core force integrals'
    Character(*),Parameter :: cpumesg_thci='Three-center force integrals'
    Character(*),Parameter :: cpumesg_thcivc='Three-center vc-integrals'
    Logical(t_log) :: exists,blckprnt
    Integer(t_int) :: coresize(10),subb_cc(4,100),subb_vc(4,100),ic,iv,lv
    Integer(t_int) :: subb_cv(4,100),subb_vv(4,100),ncomp,icomp
    Integer(t_int) :: nsite,issa,issb
    Integer(t_int) :: isa,isb,lmx,glmax
    Integer(t_int) :: i,ms,iLLm,ilm,lb,mb,ilbm,la,klj
    Real(t_real)   :: tol,rffmax
    Integer(t_int),Pointer :: p_gdiff(:,:,:,:)
    Real(t_real),Pointer :: p_ocitmp(:,:,:)
    Real(t_real),Pointer :: p_ocitmpr(:,:,:)
    Real(t_real),Pointer   :: actoci(:,:,:)
    Real(t_real),Pointer   :: actocir(:,:,:)
    Real(t_real),Pointer   :: wgaunt(:,:,:)
    Real(t_real),Pointer   :: wfgaunt(:,:,:,:,:),ccc(:,:,:,:)
    Type(T_Mesh),Pointer :: bmesha,bmeshb
    Type(T_Mesh),Pointer :: atommesha,atommeshb
    !!
    !!
    Character(*),Parameter   :: fmt="(f12.5,2x)"
    Character(*),Parameter   :: fmt0="('       0      ')"
    !!
    !!
    Nullify(p_gdiff,wgaunt,wfgaunt,ccc,p_ocitmp,p_ocitmpr)
    !!
    Write(outfile,fmtstart)nsubfunc    
    !!
    Call watch(cpumesg_oci,cpu_start,reset=.True.)
    Call watch(cpumesg_oci,cpu_stop)
    Call watch(cpumesg_tci,cpu_start,reset=.True.)
    Call watch(cpumesg_tci,cpu_stop)
    !!
    !!    
    ncomp=basis% ncomp
    !!
    !!
    glmax=basis% lmx
    Call palloc('wgaunt',wgaunt,1_t_int,(glmax+1+1)**2& !!one more from vectorharmonics
         &,1_t_int,(glmax+1)**2,1_t_int,(2*glmax+1+1)**2& !! one more from vectorharmonics
         &,nmodule,nsubfunc)
    Call palloc('wfgaunt',wfgaunt&
         &,1_t_int,3_t_int& ! cartesian index
         &,1_t_int,2_t_int& ! l+/-1 index
         &,1_t_int,(glmax+1)**2& ! l-left
         &,1_t_int,(glmax+1)**2& ! l-right
         &,1_t_int,(2*glmax+1+1)**2&  ! potential-L
         &,nmodule,nsubfunc)

    Call makergaunt(wgaunt,glmax+1,glmax,2*glmax+1)
    !!
    Call palloc('ccc',ccc,1_t_int,3_t_int,1_t_int,2_t_int,-1_t_int,1_t_int&
         &,1_t_int,(glmax+1)**2,nmodule,nsubfunc)
    Call calc_real_vec_Ylm_coefs(glmax,ccc)
    !!
    !! sum up the realvector-harmonics extraction coefficients with the
    !! potential extraction Gaunt coefficients
    wfgaunt=0.0_t_real
    iLLmloop: Do iLLm=1,(2*glmax+1+1)**2
       irightloop: Do ilm=1,(glmax+1)**2
          lleftloop: Do lb=0,glmax
             mleftloop: Do mb=-lb,lb
                ilbm=lb*(lb+1)+1+mb
                lpm1loop: Do la=Max(0_t_int,lb-1),lb+1
                   If(la==lb) Cycle
                   klj=(la-lb+3)/2

                   If(Abs(mb+1)<=la) wfgaunt(1,klj,ilbm,ilm,iLLm)=&
                        &wfgaunt(1,klj,ilbm,ilm,iLLm)&
                        &+ccc(1,klj, 1,ilbm)*wgaunt(la*(la+1)+1+mb+1,ilm,iLLm)
                   
                   If(Abs(mb-1)<=la) wfgaunt(1,klj,ilbm,ilm,iLLm)=&
                        &wfgaunt(1,klj,ilbm,ilm,iLLm)&
                        &+ccc(1,klj,-1,ilbm)*wgaunt(la*(la+1)+1+mb-1,ilm,iLLm)

                   If(Abs(-mb+1)<=la) wfgaunt(2,klj,ilbm,ilm,iLLm)=&
                        &wfgaunt(2,klj,ilbm,ilm,iLLm)&
                        &+ccc(2,klj, 1,ilbm)*wgaunt(la*(la+1)+1-mb+1,ilm,iLLm)
                   
                   If(Abs(-mb-1)<=la) wfgaunt(2,klj,ilbm,ilm,iLLm)=&
                        &wfgaunt(2,klj,ilbm,ilm,iLLm)&
                        &+ccc(2,klj,-1,ilbm)*wgaunt(la*(la+1)+1-mb-1,ilm,iLLm)

                   wfgaunt(3,klj,ilbm,ilm,iLLm)=&
                        &wfgaunt(3,klj,ilbm,ilm,iLLm)&
                        &+ccc(3,klj, 0,ilbm)*wgaunt(la*(la+1)+1+mb,ilm,iLLm)

                Enddo lpm1loop
             Enddo mleftloop
          Enddo lleftloop
       Enddo irightloop
    Enddo iLLmloop
    !!
    nsite=structure% nsite
    !!
    !!
    !!
    !!
    !!
    If(.Not. loi% gloi0_calced ) Then
       Call palloc('loi% p_oci_gcc0',loi% p_oci_gcc0,1_t_int,3_t_int&
            &,1_t_int,loi% ociccdim,nmodule,nsubfunc)
       Call palloc('loi% p_oci_gcHc0',loi% p_oci_gcHc0,1_t_int,3_t_int&
            &,1_t_int,loi% ociccdim,nmodule,nsubfunc)
       !!
       Call palloc('loi% p_oci_gvv0',loi% p_oci_gvv0,1_t_int,3_t_int&
            &,1_t_int,loi% ocivvdim,nmodule,nsubfunc)
       Call palloc('loi% p_oci_gvHv0',loi% p_oci_gvHv0,1_t_int,3_t_int&
            &,1_t_int,loi% ocivvdim,nmodule,nsubfunc)
       !!
       Call palloc('loi% p_oci_gvc0',loi% p_oci_gvc0,1_t_int,3_t_int&
            &,1_t_int,loi% ocivcdim,nmodule,nsubfunc)
       Call palloc('loi% p_oci_gvHc0',loi% p_oci_gvHc0,1_t_int,3_t_int&
            &,1_t_int,loi% ocivcdim,nmodule,nsubfunc)
       Call palloc('loi% p_oci_gvHcr0',loi% p_oci_gvHcr0,1_t_int,3_t_int&
            &,1_t_int,loi% ocivcdim,nmodule,nsubfunc)
       !!
       Call palloc('loi% p_tci_gvv0',loi% p_tci_gvv0,1_t_int,3_t_int&
            &,1_t_int,loi% tcivvdim,nmodule,nsubfunc)
       Call palloc('loi% p_tci_gvHv0',loi% p_tci_gvHv0,1_t_int,3_t_int&
            &,1_t_int,loi% tcivvdim,nmodule,nsubfunc)
       !!
       Call palloc('loi% p_tci_gvc0',loi% p_tci_gvc0,1_t_int,3_t_int&
            &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)
       Call palloc('loi% p_tci_gvHc0',loi% p_tci_gvHc0,1_t_int,3_t_int&
            &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)
       Call palloc('loi% p_tci_gvHcr0',loi% p_tci_gvHcr0,1_t_int,3_t_int&
            &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)

    Endif
    !!
    !!
    !!
    !!
    !!
    If(.Not. loi% gloi0_calced ) Then
       loi% p_oci_gcc0(:,:)=0.0_t_real
       loi% p_oci_gcHc0(:,:)=0.0_t_real
       !!
       loi% p_oci_gvv0(:,:)=0.0_t_real
       loi% p_oci_gvHv0(:,:)=0.0_t_real
       !!
       loi% p_oci_gvc0(:,:)=0.0_t_real
       loi% p_oci_gvHc0(:,:)=0.0_t_real
       loi% p_oci_gvHcr0(:,:)=0.0_t_real
       !!
       loi% p_tci_gvv0(:,:)=0.0_t_real
       loi% p_tci_gvHv0(:,:)=0.0_t_real
       !!
       loi% p_tci_gvc0(:,:)=0.0_t_real
       loi% p_tci_gvHc0(:,:)=0.0_t_real
       loi% p_tci_gvHcr0(:,:)=0.0_t_real
       !!
    Endif
    !!
    lmx=basis% lmx
    !!
    If(.Not. loi% gloi0_calced) Then
       isaloop: Do isa=1,nsite
          !!
          Call watch(cpumesg_oci,cpu_start)
          !!
          issa=structure% p_isrt(isa)
          !!
          bmesha    => basis% p_basmeshs(issa)
          atommesha => mol% p_atommeshs(issa)
          !!
          Do icomp=1,ncomp
             Call nrel_calc_foci_vcs(mol% p_vatom(:,0,issa),numerics% oci_nr&
                  &,atommesha,mol% nra,bmesha,basis% nrb,numerics% degree&
                  &,basis% nRcmx,basis% nRcmx&
                  &,basis% p_nRc(issa),basis% p_lRc(:,issa)&
                  &,basis% p_nRc(issa),basis% p_lRc(:,issa)&
                  &,basis% p_fc(:,:,icomp,issa),basis% p_fkc(:,:,icomp,issa)&
                  &,basis% p_fdpc(:,:,icomp,issa),basis% p_fdmc(:,:,icomp,issa)&
                  &,basis% p_fc(:,:,icomp,issa),basis% p_fkc(:,:,icomp,issa)&
                  &,basis% p_fdpc(:,:,icomp,issa),basis% p_fdmc(:,:,icomp,issa)&
                  &,basis% p_fgam(issa)&
                  &,loi% p_ociccindex(isa),loi% ociccdim&
                  &,loi% p_oci_gcc0,loi% p_oci_gcHc0,icomp)
          Enddo
          !!
          Do icomp=1,ncomp
             Call nrel_calc_foci_vcs(mol% p_vatom(:,0,issa),numerics% oci_nr&
                  &,atommesha,mol% nra,bmesha,basis% nrb,numerics% degree&
                  &,basis% nRvmx,basis% nRcmx&
                  &,basis% p_nRv(issa),basis% p_lRv(:,issa)&
                  &,basis% p_nRc(issa),basis% p_lRc(:,issa)&
                  &,basis% p_fv(:,:,icomp,issa),basis% p_fkv(:,:,icomp,issa)&
                  &,basis% p_fdpv(:,:,icomp,issa),basis% p_fdmv(:,:,icomp,issa)&
                  &,basis% p_fc(:,:,icomp,issa),basis% p_fkc(:,:,icomp,issa)&
                  &,basis% p_fdpc(:,:,icomp,issa),basis% p_fdmc(:,:,icomp,issa)&
                  &,basis% p_fgam(issa)&
                  &,loi% p_ocivcindex(isa),loi% ocivcdim&
                  &,loi% p_oci_gvc0,loi% p_oci_gvHc0,icomp)

             Call nrel_calc_foci_vcs(mol% p_vatom(:,0,issa),numerics% oci_nr&
                  &,atommesha,mol% nra,bmesha,basis% nrb,numerics% degree&
                  &,basis% nRvmx,basis% nRcmx&
                  &,basis% p_nRv(issa),basis% p_lRv(:,issa)&
                  &,basis% p_nRc(issa),basis% p_lRc(:,issa)&
                  &,basis% p_fv(:,:,icomp,issa),basis% p_fkv(:,:,icomp,issa)&
                  &,basis% p_fdpv(:,:,icomp,issa),basis% p_fdmv(:,:,icomp,issa)&
                  &,basis% p_fc(:,:,icomp,issa),basis% p_fkc(:,:,icomp,issa)&
                  &,basis% p_fdpc(:,:,icomp,issa),basis% p_fdmc(:,:,icomp,issa)&
                  &,basis% p_fgam(issa)&
                  &,loi% p_ocivcindex(isa),loi% ocivcdim&
                  &,loi% p_oci_gvc0,loi% p_oci_gvHcr0,icomp,right=.True.)
             
             !!
             Call nrel_calc_foci_vcs(mol% p_vatom(:,0,issa),numerics% oci_nr&
                  &,atommesha,mol% nra,bmesha,basis% nrb,numerics% degree&
                  &,basis% nRvmx,basis% nRvmx&
                  &,basis% p_nRv(issa),basis% p_lRv(:,issa)&
                  &,basis% p_nRv(issa),basis% p_lRv(:,issa)&
                  &,basis% p_fv(:,:,icomp,issa),basis% p_fkv(:,:,icomp,issa)&
                  &,basis% p_fdpv(:,:,icomp,issa),basis% p_fdmv(:,:,icomp,issa)&
                  &,basis% p_fv(:,:,icomp,issa),basis% p_fkv(:,:,icomp,issa)&
                  &,basis% p_fdpv(:,:,icomp,issa),basis% p_fdmv(:,:,icomp,issa)&
                  &,basis% p_fgam(issa)&
                  &,loi% p_ocivvindex(isa),loi% ocivvdim&
                  &,loi% p_oci_gvv0,loi% p_oci_gvHv0,icomp)
          Enddo
          !!
          Call watch(cpumesg_oci,cpu_read,Stop=.True.,Print=.True.)
          !!
          Do isb=1,nsite
             !!
             Call watch(cpumesg_tci,cpu_start)
             !!
             issb=structure% p_isrt(isb)
             !!
             bmeshb    => basis% p_basmeshs(issb)
             atommeshb => mol% p_atommeshs(issb)
             !!
             rffmax=Max(basis% p_rtfcmax(0,issa),basis% p_rtfvmax(0,issa)&
                  &    ,basis% p_rtfcmax(0,issb),basis% p_rtfvmax(0,issb))
             !!
             Call calc_ftci(&
                  !&nsite,&
                  &isa,isb&
                  &,lattice% p_npshell(isa,isb),lattice% p_ninpshell&
                  &,lattice% p_pairs,lattice% p_pairabs&
                  &,atommesha,atommeshb,mol% nra,bmesha,bmeshb,basis% nrb&
                  &,basis% lmx,basis% nRvmx,basis% nRcmx&
                  &,basis% p_nRv(issa),basis% p_nRv(issb),basis% p_nRc(issb)&
                  &,basis% p_lRv(:,issa),basis% p_lRv(:,issb)&
                  &,basis% p_lRc(:,issb)&
                  &,rffmax&
                  &,basis% p_fv(:,:,1,issa),basis% p_fv(:,:,1,issb),basis% p_fc(:,:,1,issb)&
                  &,basis% p_fkv(:,:,1,issa),basis% p_fkv(:,:,1,issb),basis% p_fkc(:,:,1,issb)&
                  &,basis% p_fdpv(:,:,1,issa),basis% p_fdpv(:,:,1,issb),basis% p_fdpc(:,:,1,issb)&
                  &,basis% p_fdmv(:,:,1,issa),basis% p_fdmv(:,:,1,issb),basis% p_fdmc(:,:,1,issb)&
                  &,basis% p_fgam(issa),basis% p_fgam(issb)&
                  &,mol% p_vatom(:,0,issa),mol% p_vatom(:,0,issb)&
                  &,numerics% degree,vblocklength,cblocklength&
                  &,loi% p_tcivvindex,loi% p_tcivcindex&
                  &,loi% p_tci_gvv0,loi% p_tci_gvHv0&
                  &,loi% p_tci_gvc0,loi% p_tci_gvHc0,loi% p_tci_gvHcr0)
             !!
             Call watch(cpumesg_tci,cpu_read,Stop=.True.,Print=.True.)
             !!
          End Do
       End Do isaloop
       loi% gloi0_calced=.True.
    Endif
    !!
    Call watch(cpumesg_oci,cpu_read,delete=.True.,Print=.True.,mesg='Total ')
    Call watch(cpumesg_tci,cpu_read,delete=.True.,Print=.True.,mesg='Total ')
    !!
    !!
    !!
    If(.Not. calc_THCI)goto 899
    !!
    Call gvecdifn(structure% nsite,lattice% p_npairs,lattice% npairsmax&
         &,lattice% p_pairs&
         &,symmetry% Rnumops,structure% p_equivsites,symmetry% Ropmat&
         &,p_gdiff)
    !!
    !! this we allocate and clean (in cleanup_loi) all allways anew
    Call palloc('loi% p_oci_gcHc',loi% p_oci_gcHc,1_t_int,3_t_int&
         &,1_t_int,loi% ociccdim,1_t_int,mspin,nmodule,nsubfunc)
    Call palloc('loi% p_oci_gvHv',loi% p_oci_gvHv,1_t_int,3_t_int&
         &,1_t_int,loi% ocivvdim,1_t_int,mspin,nmodule,nsubfunc)
    Call palloc('loi% p_oci_gvHc',loi% p_oci_gvHc,1_t_int,3_t_int&
         &,1_t_int,loi% ocivcdim,1_t_int,mspin,nmodule,nsubfunc)
    Call palloc('loi% p_oci_gvHcr',loi% p_oci_gvHcr,1_t_int,3_t_int&
         &,1_t_int,loi% ocivcdim,1_t_int,mspin,nmodule,nsubfunc)
    Call palloc('loi% p_tci_gvHv',loi% p_tci_gvHv,1_t_int,3_t_int&
         &,1_t_int,loi% tcivvdim,1_t_int,mspin,nmodule,nsubfunc)
    Call palloc('loi% p_tci_gvHc',loi% p_tci_gvHc,1_t_int,3_t_int&
         &,1_t_int,loi% tcivcdim,1_t_int,mspin,nmodule,nsubfunc)
    Call palloc('loi% p_tci_gvHcr',loi% p_tci_gvHcr,1_t_int,3_t_int&
         &,1_t_int,loi% tcivcdim,1_t_int,mspin,nmodule,nsubfunc)
    !!
    loi% p_oci_gcHc(:,:,:)=0.0_t_real
    loi% p_oci_gvHv(:,:,:)=0.0_t_real
    loi% p_oci_gvHc(:,:,:)=0.0_t_real
    loi% p_oci_gvHcr(:,:,:)=0.0_t_real
    loi% p_tci_gvHv(:,:,:)=0.0_t_real
    loi% p_tci_gvHc(:,:,:)=0.0_t_real
    loi% p_tci_gvHcr(:,:,:)=0.0_t_real
    !!
    !!
    Do ms=1,mspin
       Do i=1,loi% ociccdim
          loi% p_oci_gcHc(1:3,i,ms)=loi% p_oci_gcHc0(1:3,i)
       Enddo
       Do i=1,loi% ocivvdim
          loi% p_oci_gvHv(1:3,i,ms)=loi% p_oci_gvHv0(1:3,i)
       Enddo
       Do i=1,loi% ocivcdim
          loi% p_oci_gvHc(1:3,i,ms)=loi% p_oci_gvHc0(1:3,i)
          loi% p_oci_gvHcr(1:3,i,ms)=loi% p_oci_gvHcr0(1:3,i)
       Enddo
       Do i=1,loi% tcivvdim
          loi% p_tci_gvHv(1:3,i,ms)=loi% p_tci_gvHv0(1:3,i)
       Enddo
       Do i=1,loi% tcivcdim
          loi% p_tci_gvHc(1:3,i,ms)=loi% p_tci_gvHc0(1:3,i)
          loi% p_tci_gvHcr(1:3,i,ms)=loi% p_tci_gvHcr0(1:3,i)
       Enddo
    Enddo
    !!
    Call watch(nmodule//cpumesg_thcicc,cpu_start,reset=.True.)
    

    Call palloc('p_ocitmp',p_ocitmp,1_t_int,3_t_int&
         &,1_t_int,loi% ociccdim,1_t_int,mspin,nmodule,nsubfunc)
    p_ocitmp(:,:,:)=0.0_t_real
    
    Do icomp=1,ncomp
       

       actoci => loi% p_oci_gcHc
       If(use_OVO .and. icomp>=3) actoci => p_ocitmp

       Call calc_core_fthcis(mspin,structure% nsite,structure% nsort&
            &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
            &,symmetry% Rnumops,symmetry% Ropmat&
            &,structure% p_equivsites,symmetry% NRwu_ks&
            &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
            &,basis% p_basmeshs,basis% nrb&
            &,ncsmx,basis% lcmx&
            &,ncomp,icomp&
            &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
            &,basis% p_fc,basis% p_fdpc,basis% p_fdmc,basis% p_fgam&
            &,basis% p_rtfcmax,basis% p_rfcmax&
            &,loi% ociccdim,actoci,numerics% degree&
            &,loi% p_ociccindex,mol)
    Enddo

    If(use_OVO)Then
       Do ms=1,mspin
          Call manipulate_OVO(structure&
               &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
               &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
               &,glmax,wgaunt,wfgaunt&
               &,loi% p_ociccindex,p_ocitmp(:,:,ms),loi% p_oci_gcHc(:,:,ms))
       Enddo
    Endif

    Call watch(nmodule//cpumesg_thcicc,cpu_stop,delete=.True.,Print=.True.)
    
    !!
    Call watch(nmodule//cpumesg_thci,cpu_start,reset=.True.)
    !!
    Call palloc('p_ocitmp',p_ocitmp,1_t_int,3_t_int&
         &,1_t_int,loi% ocivvdim,1_t_int,mspin,nmodule,nsubfunc)
    p_ocitmp(:,:,:)=0.0_t_real
    !!
    Do icomp=1,ncomp
       
       actoci => loi% p_oci_gvHv
       If(use_OVO .and. icomp>=3) actoci => p_ocitmp

       Call calc_fthcis(mspin,structure% nsite,structure% nsort&
            &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
            &,symmetry% Rnumops,symmetry% Ropmat,structure% p_equivsites&
            &,symmetry% NRwu_ks,p_gdiff&
            &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
            &,basis% p_basmeshs,basis% nrb&
            &,nvsmx,basis% lvmx&
            &,ncomp,icomp&
            &,basis% nRvmx,basis% p_nRv,basis% p_lRv&
            &,basis% p_fv,basis% p_fdpv,basis% p_fdmv,basis% p_fgam&
            &,basis% p_rtfvmax,basis% p_rfvmax&
            &,loi% ocivvdim,loi% tcivvdim&
            &,actoci&
            &,loi% p_tci_gvHv&
            &,numerics% degree,loi% p_ocivvindex,loi% p_tcivvindex,mol&
            &,.False.)
    Enddo

    If(use_OVO)Then
       Do ms=1,mspin
          Call manipulate_OVO(structure&
               &,basis% nRvmx,basis% p_nRv,basis% p_lRv&
               &,basis% nRvmx,basis% p_nRv,basis% p_lRv&
               &,glmax,wgaunt,wfgaunt&
               &,loi% p_ocivvindex,p_ocitmp(:,:,ms),loi% p_oci_gvHv(:,:,ms))
       Enddo
    Endif

    Call watch(nmodule//cpumesg_thci,cpu_stop,delete=.True.,Print=.True.)
    
    !!  core-valence
    Call watch(nmodule//cpumesg_thcivc,cpu_start,reset=.True.)
    
    Call palloc('p_ocitmp',p_ocitmp,1_t_int,3_t_int&
         &,1_t_int,loi% ocivcdim,1_t_int,mspin,nmodule,nsubfunc)
    Call palloc('p_ocitmpr',p_ocitmpr,1_t_int,3_t_int&
         &,1_t_int,loi% ocivcdim,1_t_int,mspin,nmodule,nsubfunc)
    p_ocitmp(:,:,:)=0.0_t_real
    p_ocitmpr(:,:,:)=0.0_t_real

    Do icomp=1,ncomp
       
       actoci  => loi% p_oci_gvHc
       actocir => loi% p_oci_gvHcr
       If(use_OVO .and. icomp>=3) actoci  => p_ocitmp
       If(use_OVO .and. icomp>=3) actocir => p_ocitmpr

       Call calc_fthcis_vc(mspin,structure% nsite,structure% nsort&
            &,structure% naps,structure% p_isrt,structure% p_posToSiteRep&
            &,symmetry% Rnumops,symmetry% Ropmat&
            &,structure% p_equivsites,symmetry% NRwu_ks,p_gdiff&
            &,lattice% p_npairs,lattice% p_pairs,lattice% npairsmax&
            &,basis% p_basmeshs,basis% nrb&
            &,ncsmx,basis% lmx&
            &,ncomp,icomp&
            &,basis% nRvmx,basis% p_nRv,basis% p_lRv&
            &,basis% p_fv,basis% p_fdpv,basis% p_fdmv&
            &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
            &,basis% p_fc,basis% p_fdpc,basis% p_fdmc,basis% p_fgam&
            &,basis% p_rtfvmax,basis% p_rfvmax&
            &,basis% p_rtfcmax,basis% p_rfcmax&
            &,loi% ocivcdim,loi% tcivcdim&
            &,actoci,actocir,loi% p_tci_gvHc,loi% p_tci_gvHcr&
            &,numerics% degree,loi% p_ocivcindex,loi% p_tcivcindex,mol&
            &,.False.)
    Enddo
    
    If(use_OVO)Then
       Do ms=1,mspin
          Call manipulate_OVO(structure&
               &,basis% nRvmx,basis% p_nRv,basis% p_lRv&
               &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
               &,glmax,wgaunt,wfgaunt&
               &,loi% p_ocivcindex,p_ocitmp(:,:,ms),loi% p_oci_gvHc(:,:,ms))
          Call manipulate_OVO(structure&
               &,basis% nRvmx,basis% p_nRv,basis% p_lRv&
               &,basis% nRcmx,basis% p_nRc,basis% p_lRc&
               &,glmax,wgaunt,wfgaunt&
               &,loi% p_ocivcindex,p_ocitmpr(:,:,ms),loi% p_oci_gvHcr(:,:,ms),.True.)
       Enddo
    Endif
    Call watch(nmodule//cpumesg_thcivc,cpu_stop,delete=.True.,Print=.True.)
    
    !!
    !!
    !!
    Call pfree(p_gdiff)
    Call pfree(p_ocitmp)
    Call pfree(p_ocitmpr)
    Call pfree(wgaunt)
    Call pfree(wfgaunt)
    Call pfree(ccc)
    !!
    !!
    !!
899 Continue
    !!
    Goto 500
    !!
    Inquire(file='=.prntloi',exist=exists)
    blckprnt=.False.
    coresize=0
    If(exists)Then
       blckprnt=.True.
       Open(12,file='=.prntloi')
       Read(12,*)
       Read(12,*)coresize(1:nsite)
       Close(12)
    Endif
    !!
    !Print *,blckprnt,coresize
    !Stop
    !!
    tol=1.0e-10_t_real
    !!
    If(blckprnt)Then
       
       Do isa=1,nsite
          ic=coresize(isa)
          iv=ic+1
          lv=vblocklength(isa)
          subb_cc(1:4,isa)=(/1_t_int,ic,1_t_int,ic/)
          subb_vc(1:4,isa)=(/iv,lv,1_t_int,ic/)
          subb_cv(1:4,isa)=(/1_t_int,ic,iv,lv/)
          subb_vv(1:4,isa)=(/iv,lv,iv,lv/)
       Enddo

       !!
       !! ###########################################
       !!   OCI S
       !! ###########################################

       Do i=1,3 !! for all vector components
          Write(outfile,*)'OCI Scc k=',i
          Call print_oci("Scc",nsite,vblocklength,vblocklength&
               &,fmt,fmt0,loi% p_oci_gvv0(i,:),tol&
               &,loi% p_ocivvindex,subb_cc(:,1:2))
          Write(outfile,*)
       Enddo

       Do i=1,3 !! for all vector components
          Write(outfile,*)'OCI Svc k=',i
          Call print_oci("Svc",nsite,vblocklength,vblocklength&
               &,fmt,fmt0,loi% p_oci_gvv0(i,:),tol&
               &,loi% p_ocivvindex,subb_vc(:,1:2))
          Write(outfile,*)
       Enddo

       Do i=1,3 !! for all vector components
          Write(outfile,*)'OCI Svv k=',i
          Call print_oci("Svv",nsite,vblocklength,vblocklength&
               &,fmt,fmt0,loi% p_oci_gvv0(i,:),tol&
               &,loi% p_ocivvindex,subb_vv(:,1:2))
          Write(outfile,*)
       Enddo
       !!
       !!
       !!
       !! ###########################################
       !!   OCI H
       !! ###########################################
       !!
       Do ms=1,mspin
          Do i=1,3 !! for all vector components
             Write(outfile,*)'OCI Hcc k=',i,' spin=',ms
             Call print_oci("Hcc",nsite,vblocklength,vblocklength&
                  &,fmt,fmt0,loi% p_oci_gvHv(i,:,ms),tol&
                  &,loi% p_ocivvindex,subb_cc(:,1:2))
             Write(outfile,*)
          Enddo

          Do i=1,3 !! for all vector components
             Write(outfile,*)'OCI Hvc k=',i,' spin=',ms
             Call print_oci("Hvc",nsite,vblocklength,vblocklength&
                  &,fmt,fmt0,loi% p_oci_gvHv(i,:,ms),tol&
                  &,loi% p_ocivvindex,subb_vc(:,1:2))
             Write(outfile,*)
          Enddo

          Do i=1,3 !! for all vector components
             Write(outfile,*)'OCI Hvcr k=',i,' spin=',ms
             Call print_oci("Hvcr",nsite,vblocklength,vblocklength&
                  &,fmt,fmt0,loi% p_oci_gvHv(i,:,ms),tol&
                  &,loi% p_ocivvindex,subb_cv(:,1:2)&
                  & ,trans=.True.,fac=-1.0_t_real)
             Write(outfile,*)
          Enddo

          Do i=1,3 !! for all vector components
             Write(outfile,*)'OCI Hvv k=',i,' spin=',ms
             Call print_oci("Hvv",nsite,vblocklength,vblocklength&
                  &,fmt,fmt0,loi% p_oci_gvHv(i,:,ms),tol&
                  &,loi% p_ocivvindex,subb_vv(:,1:2))
             Write(outfile,*)
          Enddo
       Enddo
       !!
       !!
       !!
       !!
       !! ###########################################
       !!   TCI S
       !! ###########################################
       !! 
       !!
       !!
       !!
       Do i=1,3 !! for all vector components
          Write(outfile,*)'TCI Svc k=',i
          Call print_tci("Svc",nsite,vblocklength,vblocklength&
               &,fmt,fmt0,loi% p_tci_gvv0(i,:)&
               &,loi% p_tcivvindex,lattice% p_npairs,lattice% p_pairs&
               &,tol,subb_vc(:,1:2))
          Write(outfile,*)
       Enddo

       Do i=1,3 !! for all vector components
          Write(outfile,*)'TCI Svv k=',i
          Call print_tci("Svv",nsite,vblocklength,vblocklength&
               &,fmt,fmt0,loi% p_tci_gvv0(i,:)&
               &,loi% p_tcivvindex,lattice% p_npairs,lattice% p_pairs&
               &,tol,subb_vv(:,1:2))
          Write(outfile,*)
       Enddo

       !!
       !! ###########################################
       !!   TCI H
       !! ###########################################


       Do ms=1,mspin
          Do i=1,3 !! for all vector components
             Write(outfile,*)'TCI Hvc k=',i,' spin=',ms
             Call print_tci("Hvc",nsite,vblocklength,vblocklength&
                  &,fmt,fmt0,loi% p_tci_gvHv(i,:,ms)&
                  &,loi% p_tcivvindex,lattice% p_npairs,lattice% p_pairs&
                  &,tol,subb_vc(:,1:2))
             Write(outfile,*)
          Enddo

          Do i=1,3 !! for all vector components
             Write(outfile,*)'TCI Hvcr k=',i,' spin=',ms
             Call print_tci("Hvcr",nsite,vblocklength,vblocklength&
                  &,fmt,fmt0,loi% p_tci_gvHv(i,:,ms)&
                  &,loi% p_tcivvindex,lattice% p_npairs,lattice% p_pairs&
                  &,tol,subb_cv(:,1:2)&
                  & ,trans=.True.,fac=-1.0_t_real)
             Write(outfile,*)
          Enddo

          Do i=1,3 !! for all vector components
             Write(outfile,*)'TCI Hvv k=',i,' spin=',ms
             Call print_tci("Hvv",nsite,vblocklength,vblocklength&
                  &,fmt,fmt0,loi% p_tci_gvHv(i,:,ms)&
                  &,loi% p_tcivvindex,lattice% p_npairs,lattice% p_pairs&
                  &,tol,subb_vv(:,1:2))
             Write(outfile,*)
          Enddo
       Enddo

    Else
       !!___________________________________________________________
       !!
       !!
       !! ###########################################
       !!   OCI S
       !! ###########################################
       !!
       Do i=1,3 !! for all vector components
          Write(outfile,*)'OCI Scc k=',i
          Call print_oci("Scc",nsite,cblocklength,cblocklength&
               &,fmt,fmt0,loi% p_oci_gcc0(i,:),tol&
               &,loi% p_ociccindex)
          Write(outfile,*)
       Enddo
       Do i=1,3 !! for all vector components
          Write(outfile,*)'OCI Svc k=',i
          Call print_oci("Svc",nsite,vblocklength,cblocklength&
               &,fmt,fmt0,loi% p_oci_gvc0(i,:),tol&
               &,loi% p_ocivcindex)
          Write(outfile,*)
       Enddo
       Do i=1,3 !! for all vector components
          Write(outfile,*)'OCI Svv k=',i
          Call print_oci("Svv",nsite,vblocklength,vblocklength&
               &,fmt,fmt0,loi% p_oci_gvv0(i,:),tol&
               &,loi% p_ocivvindex)
          Write(outfile,*)
       Enddo
       !!
       !!
       !! ###########################################
       !!   OCI H
       !! ###########################################
       !!
       Do ms=1,mspin
          Do i=1,3 !! for all vector components
             Write(outfile,*)'OCI Hcc k=',i,' spin=',ms
             Call print_oci("Hcc",nsite,cblocklength,cblocklength&
                  &,fmt,fmt0,loi% p_oci_gcHc(i,:,ms),tol&
                  &,loi% p_ociccindex)
             Write(outfile,*)
          Enddo
       
          Do i=1,3 !! for all vector components
             Write(outfile,*)'OCI Hvc k=',i,' spin=',ms
             Call print_oci("Hvc",nsite,vblocklength,cblocklength&
                  &,fmt,fmt0,loi% p_oci_gvHc(i,:,ms),tol&
                  &,loi% p_ocivcindex)
             Write(outfile,*)
          Enddo

          Do i=1,3 !! for all vector components
             Write(outfile,*)'OCI Hvcr k=',i,' spin=',ms
             Call print_oci("Hvcr",nsite,vblocklength,cblocklength&
                  &,fmt,fmt0,loi% p_oci_gvHcr(i,:,ms),tol&
                  &,loi% p_ocivcindex)
             Write(outfile,*)
          Enddo

          Do i=1,3 !! for all vector components
             Write(outfile,*)'OCI Hvv k=',i,' spin=',ms
             Call print_oci("Hvv",nsite,vblocklength,vblocklength&
                  &,fmt,fmt0,loi% p_oci_gvHv(i,:,ms),tol&
                  &,loi% p_ocivvindex)
             Write(outfile,*)
          Enddo
       Enddo
       !!
       !! ###########################################
       !!   TCI S
       !! ###########################################
       !!
       !!
       Do i=1,3 !! for all vector components
          Write(outfile,*)'TCI Svc k=',i
          Call print_tci("Svc",nsite,vblocklength,cblocklength&
               &,fmt,fmt0,loi% p_tci_gvc0(i,:)&
               &,loi% p_tcivcindex,lattice% p_npairs,lattice% p_pairs,tol)
          Write(outfile,*)
       Enddo
       Do i=1,3 !! for all vector components
          Write(outfile,*)'TCI Svv k=',i
          Call print_tci("Svv",nsite,vblocklength,vblocklength&
               &,fmt,fmt0,loi% p_tci_gvv0(i,:)&
               &,loi% p_tcivvindex,lattice% p_npairs,lattice% p_pairs,tol)
          Write(outfile,*)
       Enddo
       !!
       !!
       !! ###########################################
       !!   TCI H
       !! ###########################################
       !!
       Do ms=1,mspin
          Do i=1,3 !! for all vector components
             Write(outfile,*)'TCI Hvc k=',i,' spin=',ms
             Call print_tci("Hvc",nsite,vblocklength,cblocklength&
                  &,fmt,fmt0,loi% p_tci_gvHc(i,:,ms)&
                  &,loi% p_tcivcindex,lattice% p_npairs,lattice% p_pairs,tol)
             Write(outfile,*)
          Enddo

          !!
          Do i=1,3 !! for all vector components
             Write(outfile,*)'TCI Hvcr k=',i,' spin=',ms
             Call print_tci("Hvcr",nsite,vblocklength,cblocklength&
                  &,fmt,fmt0,loi% p_tci_gvHcr(i,:,ms)&
                  &,loi% p_tcivcindex,lattice% p_npairs,lattice% p_pairs,tol)
             Write(outfile,*)
          Enddo
          !!
          Do i=1,3 !! for all vector components
             Write(outfile,*)'TCI Hvv k=',i,' spin=',ms
             Call print_tci("Hvv",nsite,vblocklength,vblocklength&
                  &,fmt,fmt0,loi% p_tci_gvHv(i,:,ms)&
                  &,loi% p_tcivvindex,lattice% p_npairs,lattice% p_pairs,tol)
             Write(outfile,*)
          Enddo
       Enddo
       !!
       !!
       !!
       !!
    Endif
    !!
500 Continue
    !!
    !!
    !!
    !!
    Write(outfile,fmtend)nsubfunc
    !!
!    Stop nsubfunc
    Return
    !!
  End Subroutine loif_int
  !!***********************************************************************
  Subroutine calc_core_fthcis(mspin,nsite,nsort,naps,isrt,posToSiteRep&
       &,numops,opmat,equivsites,wu_ks&
       &,npairs,pairs,npairsmax&
       &,basmeshs,nrbmax&
       &,ncsmx,lcmx&
       &,ncomp,icomp,ncm,nc,lc,fc,fdpc,fdmc,fgam&
       &,rtfcmax,rfcmax&
       &,ociccdim,oci_gcHc&
       &,degree,ociccindex,mol)
    !!
    Implicit None
    !!IO
    Type(T_Mesh),Pointer         :: basmeshs(:)
    Type(T_Mol),Intent(in)       :: mol
    Integer(t_int),Intent(in)    :: nrbmax
    Integer(t_int),Intent(in)    :: mspin,naps,nsite,nsort,isrt(nsite)
    Integer(t_int),Intent(in)    :: npairsmax
    Integer(t_int),Intent(in)    :: posToSiteRep(nsite)
    Integer(t_int),Intent(in)    :: numops,equivsites(48,nsite)
    Real(t_real),Intent(in)      :: wu_ks(:,:,0:,:)
    Real(t_real),Intent(in)      :: opmat(3,3,48)
    !Integer(t_int),Intent(in)    :: nqAtPos(nsite),qposToSite(nsite,nsite)
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: ncomp,icomp,ncm,nc(nsort),lc(ncm,nsort)
    Integer(t_int),Intent(in)    :: lcmx
    Integer(t_int),Intent(in)    :: ociccindex(nsite)
    Real(t_real),Intent(in)      :: rfcmax(ncm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fc(nrbmax,ncm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fdpc(nrbmax,ncm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fdmc(nrbmax,ncm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fgam(nsort)
    Integer(t_int),Intent(in)    :: ncsmx
    Integer(t_int),Intent(in)    :: degree
    Integer(t_int),Intent(in)    :: ociccdim
    Real(t_real),Intent(in)      :: pairs(:,:,:,:)
    Real(t_real),Intent(in)      :: rtfcmax(0:ncomp,nsort)
    Real(t_real),Intent(inout)   :: oci_gcHc(3,ociccdim,mspin)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="calc_core_fthcis"
    Logical(t_log) :: lsp
    Integer(t_int) :: ispp,isp,isa,issa,nca,lmxa,i,l,m,isb,deg
    Integer(t_int) :: ibl,inbl,mxblsize,nbl,iblb,inblb
    Integer(t_int) :: icbm1,nap,irap,im
    Integer(t_int) :: il,k,indexa,ik
    Integer(t_int) :: lmx(nsort),blocklen(nsite)
    Integer(t_int) :: iocicc,ir0
    Real(t_real)   :: vv1,vv2,v1,v2,ww,ra,ff1,rsh(3),rra(3),oora,texp,texp1
    Real(t_real)   :: fdp,fdm
    Real(t_real)   :: gfa(2)
    Real(t_real)   :: yl((lcmx+2)**2) !! one l more for vec harm
    Real(t_real)   :: rvylm(3,2,((lcmx+1)**2))
    Real(t_real)   :: fb1(0:ncsmx)
    Real(t_real)   :: coefa(0:degree)
    Integer(t_int),Pointer :: p_isitebl(:)
    Integer(t_int),Pointer :: p_ipairbl(:)
    Real(t_real),Pointer   :: p_fabl(:)
    Real(t_real),Pointer   :: p_gfabl(:,:)
    Real(t_real),Pointer   :: p_vloc(:)
    Type(T_Mesh),Pointer :: bmesha
    Type(T_Mesh),Pointer :: atommesha
    !!
    !!
    Nullify(p_fabl)
    Nullify(p_gfabl)
    Nullify(p_vloc)
    Nullify(p_isitebl)
    Nullify(p_ipairbl)
    !!
    !!
    Call prep_thcis(nsort,nsite,isrt,npairs,npairsmax,ncm,nc,lc&
         &,lmx,blocklen,mxblsize,p_fabl,p_vloc,p_isitebl,p_ipairbl,p_gfabl)
    !! 
    !!
    !!
    !!
    !! doit
    !!
    lsp=(mspin == 2_t_int)
    Do ispp=1_t_int,naps
1      Format('real site',i5)
       If(outlevel >= L_more) Write(outfile,1) ispp
       isp=posToSiteRep(ispp)
       !!       
       !!
       !!
       imloop: Do im=1_t_int,mol% p_nm(isp)
          If(outlevel >= L_many .And.Mod(im,(mol% p_nm(isp)/100)) == 0_t_int)Then
             Write(outfile,5) isp,100.0_t_real*im/mol% p_nm(isp)
          Endif
5         Format('site: ',i5,' ',f5.1,'% done')

          rsh(:)=mol% p_rm(:,im,isp)
          ww=mol% p_wm(im,isp)
          v1=mol% p_vm2(1,im,isp)
          v2=v1
          If(lsp) v2=mol% p_vm2(2,im,isp)
          vv1=v1*ww
          vv2=v2*ww
          !!
          !! interpolate all functions which are nonzero at r=(x,y,z)
          !!
          ibl=0
          inbl=0
          p_fabl(:)=0.0_t_real
          p_gfabl(:,:)=0.0_t_real
          isapreploop: Do isa=1_t_int,nsite
             issa=isrt(isa)
             !!
             bmesha => basmeshs(issa)
             atommesha => mol% p_atommeshs(issa)
             !!
             nca=nc(issa)
             !!
             lmxa=lmx(issa)
             !!
             nap=npairs(isa,isp)
             !!
             !!
             ir0=1
             If(isp==isa)Then
                !! include on-site terms, which are excluded in
                !! definition of pairs(...)
                ir0=0
             Endif
             !!
             irnappreploop: Do irap=ir0,nap

                If(irap==0)Then
                   rra(:)=rsh(:)
                Else
                   rra(:)=rsh(:)-pairs(:,irap,isa,isp)
                Endif
                ra=Max(Sqrt(Dot_product(rra,rra)),1.0e-16_t_real)
                If(ra==0.0_t_real)Then
                   oora=0.0_t_real
                Else
                   oora=1.0_t_real/ra
                Endif


                If(ra > rtfcmax(icomp,issa)) Cycle irnappreploop
                !!
                texp=ra**fgam(issa)*oora
                texp1=texp*oora
                !!
                indexa=mintpl_coefs(degree,bmesha,ra,coefa)
                !!
                Call calc_real_vec_Ylm_and_Ylm(rra,lmxa,yl,rvylm)

                k=0_t_int
                Do i=1_t_int,nca

                   l=lc(i,issa)
                   deg=2*l+1

                   
                   
                   ff1=0.0_t_real
                   fdp=0.0_t_real
                   fdm=0.0_t_real
                   If(ra <= rfcmax(i,icomp,issa) )Then
                      ff1=Dot_product(fc(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp
                      fdm=Dot_product(fdmc(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp1
                      fdp=Dot_product(fdpc(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp1
                   End If

                   gfa(1)= Sqrt(Real(l  ,t_real)/deg)*fdm
                   gfa(2)=-Sqrt(Real(l+1,t_real)/deg)*fdp

                   il=l*l
                   Do m=1_t_int,l+l+1_t_int
                      il=il+1
                      k=k+1_t_int
                      p_fabl(inbl+k)=ff1*yl(il)
                      p_gfabl(1:3,inbl+k)&
                           &=gfa(1)*rvylm(1:3,1,il)+gfa(2)*rvylm(1:3,2,il)

                   Enddo       ! m
                Enddo         ! i
                ibl=ibl+1
                p_isitebl(ibl)=isa
                p_ipairbl(ibl)=irap
                inbl=inbl+blocklen(isa)
                !! local potential
                indexa=mintpl_coefs(degree,atommesha,ra,coefa)
                p_vloc(ibl)=&
                     &Dot_product(mol% p_vatom(indexa:indexa+degree,0,issa)&
                     &,coefa(0:degree))*oora/sq4pi*ww
                !!
             Enddo irnappreploop
          End Do isapreploop
          nbl=ibl
          !! 
          !! 
          !! TODO: extra lsp 
          !! 
          !! 
          !! 
          !! one-center terms
          inblb=1
          oiblbloop: Do iblb=1,nbl
             isb=p_isitebl(iblb)
             icbm1=blocklen(isb)-1_t_int
             !!
             !!
             iocicc=ociccindex(isb)+1
             fb1(0:icbm1)=p_fabl(inblb:inblb+icbm1)*(vv1-p_vloc(iblb))
             Do k=0_t_int,icbm1 !!a-atom
                Do ik=1,3
                   oci_gcHc(ik,iocicc:iocicc+icbm1,1)&
                        &=oci_gcHc(ik,iocicc:iocicc+icbm1,1)&
                        &+fb1(0:icbm1)*p_gfabl(ik,inblb+k)
                Enddo
                iocicc=iocicc+icbm1+1
             Enddo   ! k
             If(lsp)Then
                iocicc=ociccindex(isb)+1
                fb1(0:icbm1)=p_fabl(inblb:inblb+icbm1)*(vv2-p_vloc(iblb))
                Do k=0_t_int,icbm1
                   Do ik=1,3
                      oci_gcHc(ik,iocicc:iocicc+icbm1,2)&
                           &=oci_gcHc(ik,iocicc:iocicc+icbm1,2)&
                           &+fb1(0:icbm1)*p_gfabl(ik,inblb+k)
                   Enddo
                   iocicc=iocicc+icbm1+1
                Enddo   ! k
             Endif
             inblb=inblb+icbm1+1
          Enddo oiblbloop

          !! 
          !! 
          !! 
          !!
          !! 
          !!
       Enddo imloop             ! ig
    Enddo                     ! isp
    !!
    Call pfree(p_ipairbl)
    Call pfree(p_isitebl)
    Call pfree(p_vloc)
    Call pfree(p_fabl)
    Call pfree(p_gfabl)
    !!
    Call symmetrize_foci(mspin,nsite,isrt&
         &,numops,opmat,equivsites,wu_ks&
         &,ncm,nc,lc&
         &,ncm,nc,lc&
         &,ociccdim,oci_gcHc,ociccindex)
    !!
    Return
    !!
  End Subroutine calc_core_fthcis
  !!***********************************************************************
  Subroutine calc_fthcis_vc(mspin,nsite,nsort,naps,isrt,posToSiteRep&
       &,numops,opmat,equivsites,wu_ks,gdiff&
       &,npairs,pairs,npairsmax&
       &,basmeshs,nrbmax&
       &,ncsmx,lvcmx&
       &,ncomp,icomp,nvm,nv,lv,fv,fdpv,fdmv&
       &,ncm,nc,lc,fc,fdpc,fdmc,fgam&
       &,rtfvmax,rfvmax,rtfcmax,rfcmax&
       &,ocivcdim,tcivcdim&
       &,oci_gvHc,oci_gvHcr,tci_gvHc,tci_gvHcr&
       &,degree&
       &,ocivcindex,tcivcindex,mol,switch_v_beta)
    !!
    Implicit None
    !!IO
    Type(T_Mesh),Pointer         :: basmeshs(:)
    Type(T_Mol),Intent(in)       :: mol
    Integer(t_int),Intent(in)    :: nrbmax
    Logical(t_log),Intent(in)    :: switch_v_beta
    Integer(t_int),Intent(in)    :: mspin,naps,nsite,nsort,isrt(nsite)
    Integer(t_int),Intent(in)    :: npairsmax
    Integer(t_int),Intent(in)    :: posToSiteRep(nsite)
    Integer(t_int),Intent(in)    :: numops,equivsites(48,nsite)
    Real(t_real),Intent(in)      :: wu_ks(:,:,0:,:)
    Real(t_real),Intent(in)      :: opmat(3,3,48)
    Integer(t_int),Intent(in)    :: gdiff(0:npairsmax,48,nsite,nsite)
    !Integer(t_int),Intent(in)    :: nqAtPos(nsite),qposToSite(nsite,nsite)
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: ncomp,icomp
    Integer(t_int),Intent(in)    :: nvm,nv(nsort),lv(nvm,nsort)
    Integer(t_int),Intent(in)    :: ncm,nc(nsort),lc(ncm,nsort)
    Integer(t_int),Intent(in)    :: lvcmx
    Integer(t_int),Intent(in)    :: ocivcindex(nsite)
    Integer(t_int),Intent(in)    :: tcivcindex(:,:,:)
    Real(t_real),Intent(in)      :: rfvmax(nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: rfcmax(ncm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fv(nrbmax,nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fdpv(nrbmax,nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fdmv(nrbmax,nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fc(nrbmax,ncm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fdpc(nrbmax,ncm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fdmc(nrbmax,ncm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fgam(nsort)
    Integer(t_int),Intent(in)    :: ncsmx
    Integer(t_int),Intent(in)    :: degree
    Integer(t_int),Intent(in)    :: ocivcdim,tcivcdim
    Real(t_real),Intent(in)      :: pairs(:,:,:,:)
    Real(t_real),Intent(in)      :: rtfvmax(0:ncomp,nsort)
    Real(t_real),Intent(in)      :: rtfcmax(0:ncomp,nsort)
    Real(t_real),Intent(inout)   :: oci_gvHc (3,ocivcdim,mspin)
    Real(t_real),Intent(inout)   :: oci_gvHcr(3,ocivcdim,mspin)
    Real(t_real),Intent(inout)   :: tci_gvHc (3,tcivcdim,mspin)
    Real(t_real),Intent(inout)   :: tci_gvHcr(3,tcivcdim,mspin)
    !!LOCAL
    Character(*),Parameter::nsubfunc="calc_fthcis_vc"
    Logical(t_log) :: lsp
    Integer(t_int) :: ispp,isp,isv,issa,lmxva,lmxca,i,l,m,isc,isa,lena,itci0
    Integer(t_int) :: deg,ik
    Integer(t_int) :: mxblsizev,mxblsizec,nva,nca,inblv,inblc,nblv,nblc
    Integer(t_int) :: ircp,irvp,iblv,iblc
    Integer(t_int) :: icbm1,nap,irap,im
    Integer(t_int) :: il,k,itci,indexa
    Integer(t_int) :: lmxv(nsort),blocklenv(nsite)
    Integer(t_int) :: lmxc(nsort),blocklenc(nsite)
    Integer(t_int) :: ioci,ir0
    Real(t_real)   :: vv1,vv2,v1,v2,ww,ra,ff1,rsh(3),rra(3),oora,texp,texp1
    Real(t_real)   :: gfa(2),fdp,fdm
    Real(t_real)   :: vv,ovv1,ovv2
    Real(t_real)   :: yl((lvcmx+2)**2) !! one l more for vec harm
    Real(t_real)   :: rvylm(3,2,((lvcmx+1)**2))
    Real(t_real)   :: coefa(0:degree)
    Real(t_real)   :: fb1(0:ncsmx)
    Real(t_real)   :: gfb1(3,0:ncsmx)
    Integer(t_int),Pointer :: p_isiteblv(:)
    Integer(t_int),Pointer :: p_isiteblc(:)
    Integer(t_int),Pointer :: p_ipairblv(:)
    Integer(t_int),Pointer :: p_ipairblc(:)
    Real(t_real),Pointer   :: p_fvbl(:)
    Real(t_real),Pointer   :: p_fcbl(:)
    Real(t_real),Pointer   :: p_gfvbl(:,:)
    Real(t_real),Pointer   :: p_gfcbl(:,:)
    Real(t_real),Pointer   :: p_vlocv(:)
    Real(t_real),Pointer   :: p_vlocc(:)
    Integer(t_int),Pointer :: p_itcidif(:,:,:,:)
    Type(T_Mesh),Pointer   :: bmesha
    Type(T_Mesh),Pointer   :: atommesha
    !!
    !!
    Nullify(p_fvbl)
    Nullify(p_fcbl)
    Nullify(p_gfvbl)
    Nullify(p_gfcbl)
    Nullify(p_vlocv)
    Nullify(p_vlocc)
    Nullify(p_isiteblv)
    Nullify(p_isiteblc)
    Nullify(p_ipairblv)
    Nullify(p_ipairblc)
    Nullify(p_itcidif)
    !!
    Call prep_thcis(nsort,nsite,isrt,npairs,npairsmax,nvm,nv,lv&
         &,lmxv,blocklenv,mxblsizev,p_fvbl,p_vlocv,p_isiteblv,p_ipairblv,p_gfvbl)
    !! 
    Call prep_thcis(nsort,nsite,isrt,npairs,npairsmax,ncm,nc,lc&
         &,lmxc,blocklenc,mxblsizec,p_fcbl,p_vlocc,p_isiteblc,p_ipairblc,p_gfcbl)
    !! 
    !!
    !!
    !!
    Call palloc('p_itcidif',p_itcidif,0_t_int,npairsmax&
         &,1_t_int,nsite,0_t_int,npairsmax,1_t_int,nsite,nmodule,nsubfunc)

    !! doit
    !!
    lsp=(mspin == 2_t_int)
    Do ispp=1_t_int,naps
1      Format('real site',i5)
       If(outlevel >= L_more) Write(outfile,1) ispp
       isp=posToSiteRep(ispp)
       !!       
       !!
       Call vecdifn(nsite,isp,p_itcidif,npairs,npairsmax,pairs,tcivcindex)
       !!
       imloop: Do im=1_t_int,mol% p_nm(isp)
          If(outlevel >= L_many .And.Mod(im,(mol% p_nm(isp)/100)) == 0_t_int)Then
             Write(outfile,5) isp,100.0_t_real*im/mol% p_nm(isp)
          Endif
5         Format('site: ',i5,' ',f5.1,'% done')

          rsh(:)=mol% p_rm(:,im,isp)
          ww=mol% p_wm(im,isp)
          v1=mol% p_vm2(1,im,isp)
          v2=v1
          if(lsp) v2=mol% p_vm2(2,im,isp)
          vv1=v1*ww
          vv2=v2*ww
          !!
          !! exchanged vv1 and vv2 due to beta-matrix
          ovv1=vv1
          ovv2=vv2
          If(switch_v_beta .And. icomp==2 )Then
             ovv1=vv2
             ovv2=vv1
          Endif
          !!
          !! interpolate all functions which are nonzero at r=(x,y,z)
          !!
          iblv=0
          inblv=0
          p_fvbl(:)=0.0_t_real
          p_gfvbl(:,:)=0.0_t_real
          iblc=0
          inblc=0
          p_fcbl(:)=0.0_t_real
          p_gfcbl(:,:)=0.0_t_real
          isapreploop: Do isa=1_t_int,nsite
             issa=isrt(isa)
             !!
             bmesha => basmeshs(issa)
             atommesha => mol% p_atommeshs(issa)
             !!
             nva=nv(issa)
             nca=nc(issa)
             !!
             lmxva=lmxv(issa)
             lmxca=lmxc(issa)
             !!
             nap=npairs(isa,isp)
             !!
             !!
             ir0=1
             If(isp==isa)Then
                !! include on-site terms, which are excluded in
                !! definition of pairs(...)
                ir0=0
             Endif
             !!
             irnappreploop: Do irap=ir0,nap

                If(irap==0)Then
                   rra(:)=rsh(:)
                Else
                   rra(:)=rsh(:)-pairs(:,irap,isa,isp)
                Endif
                ra=Max(Sqrt(Dot_product(rra,rra)),1.0e-16_t_real)
                If(ra==0.0_t_real)Then
                   oora=0.0_t_real
                Else
                   oora=1.0_t_real/ra
                Endif
                !!
                texp=ra**fgam(issa)*oora
                texp1=texp*oora
                !!
                !! valence functions
                !!
                If(ra > rtfvmax(icomp,issa)) Goto 999
                !!
                
                indexa=mintpl_coefs(degree,bmesha,ra,coefa)
                !!
                Call calc_real_vec_Ylm_and_Ylm(rra,lmxva,yl,rvylm)

                k=0_t_int
                Do i=1_t_int,nva

                   l=lv(i,issa)
                   deg=2*l+1

                   
                   ff1=0.0_t_real
                   fdp=0.0_t_real
                   fdm=0.0_t_real
                   If(ra <= rfvmax(i,icomp,issa) )Then
                      ff1=Dot_product(fv(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp
                      fdm=Dot_product(fdmv(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp1
                      fdp=Dot_product(fdpv(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp1
                   End If


                   gfa(1)= Sqrt(Real(l  ,t_real)/deg)*fdm
                   gfa(2)=-Sqrt(Real(l+1,t_real)/deg)*fdp

                   il=l*l
                   Do m=1_t_int,l+l+1_t_int
                      il=il+1
                      k=k+1_t_int
                      p_fvbl(inblv+k)=ff1*yl(il)
                      p_gfvbl(1:3,inblv+k)&
                           &=gfa(1)*rvylm(1:3,1,il)+gfa(2)*rvylm(1:3,2,il)

                   Enddo       ! m
                Enddo         ! i
                iblv=iblv+1
                p_isiteblv(iblv)=isa
                p_ipairblv(iblv)=irap
                inblv=inblv+blocklenv(isa)
                !! local potential
                indexa=mintpl_coefs(degree,atommesha,ra,coefa)
                p_vlocv(iblv)=&
                     &Dot_product(mol% p_vatom(indexa:indexa+degree,0,issa)&
                     &,coefa(0:degree))*oora/sq4pi*ww
                !!
999             Continue
                !!
                !! core functions
                !!
                If(ra > rtfcmax(icomp,issa)) Cycle irnappreploop
                !!
                indexa=mintpl_coefs(degree,bmesha,ra,coefa)
                !!
                Call calc_real_vec_Ylm_and_Ylm(rra,lmxca,yl,rvylm)

                k=0_t_int
                Do i=1_t_int,nca

                   l=lc(i,issa)
                   deg=2*l+1



                   ff1=0.0_t_real
                   fdp=0.0_t_real
                   fdm=0.0_t_real
                   If(ra <= rfcmax(i,icomp,issa) )Then
                      ff1=Dot_product(fc(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp
                      fdm=Dot_product(fdmc(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp1
                      fdp=Dot_product(fdpc(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp1
                   End If

                   gfa(1)= Sqrt(Real(l  ,t_real)/deg)*fdm
                   gfa(2)=-Sqrt(Real(l+1,t_real)/deg)*fdp

                   il=l*l
                   Do m=1_t_int,l+l+1_t_int
                      il=il+1
                      k=k+1_t_int
                      p_fcbl(inblc+k)=ff1*yl(il)
                      p_gfcbl(1:3,inblc+k)&
                           &=gfa(1)*rvylm(1:3,1,il)+gfa(2)*rvylm(1:3,2,il)
                   Enddo       ! m
                Enddo         ! i
                iblc=iblc+1
                p_isiteblc(iblc)=isa
                p_ipairblc(iblc)=irap
                inblc=inblc+blocklenc(isa)
                !! local potential
                indexa=mintpl_coefs(degree,atommesha,ra,coefa)
                p_vlocc(iblc)=&
                     &Dot_product(mol% p_vatom(indexa:indexa+degree,0,issa)&
                     &,coefa(0:degree))*oora/sq4pi*ww
                !!

             Enddo irnappreploop
          End Do isapreploop
          nblv=iblv
          nblc=iblc
          !! 
          !! 
          !! TODO: extra lsp 
          !! 
          !! 
          !! 
          !! one-center terms
          !! 

          inblc=1
          oblcloop: Do iblc=1,nblc !! b-site (core) blocks
             isc=p_isiteblc(iblc)
             icbm1=blocklenc(isc)-1_t_int
             lena=blocklenv(isc)
             ircp=p_ipairblc(iblc)
             !!
             !! 
             iblv=-1
             inblv=0
             oblvloop: Do i=1,nblv !! a-site (valence) blocks
                isv=p_isiteblv(i)
                If( (isc == isv) .And. ( ircp == p_ipairblv(i) )   )Then
                   iblv=i
                   Exit oblvloop
                Endif
                inblv=inblv+blocklenv(isv)
             Enddo oblvloop
             If(iblv==-1) Cycle oblcloop
             !!
             !!
             ioci=ocivcindex(isc)+1
             fb1(0:icbm1)=p_fcbl(inblc:inblc+icbm1)*(ovv1-p_vlocc(iblc))
             Do k=1_t_int,lena
                Do ik=1,3
                   oci_gvHc(ik,ioci:ioci+icbm1,1)&
                        &=oci_gvHc(ik,ioci:ioci+icbm1,1)&
                        &+fb1(0:icbm1)*p_gfvbl(ik,inblv+k)
                Enddo
                ioci=ioci+icbm1+1
             Enddo   ! k
             ioci=ocivcindex(isc)+1
             !!
             gfb1(1:3,0:icbm1)=p_gfcbl(1:3,inblc:inblc+icbm1)&
                  &*(ovv1-p_vlocc(iblc))
             Do k=1_t_int,lena
                Do ik=1,3
                   oci_gvHcr(ik,ioci:ioci+icbm1,1)&
                        &=oci_gvHcr(ik,ioci:ioci+icbm1,1)&
                        &-gfb1(ik,0:icbm1)*p_fvbl(inblv+k)
                Enddo
                ioci=ioci+icbm1+1
             Enddo   ! k
             If(lsp)Then
                ioci=ocivcindex(isc)+1
                fb1(0:icbm1)=p_fcbl(inblc:inblc+icbm1)*(ovv2-p_vlocc(iblc))
                Do k=1_t_int,lena
                   Do ik=1,3
                      oci_gvHc(ik,ioci:ioci+icbm1,2)&
                           &=oci_gvHc(ik,ioci:ioci+icbm1,2)&
                           &+fb1(0:icbm1)*p_gfvbl(ik,inblv+k)
                   Enddo
                   ioci=ioci+icbm1+1
                Enddo   ! k
                ioci=ocivcindex(isc)+1
                gfb1(1:3,0:icbm1)=p_gfcbl(1:3,inblc:inblc+icbm1)&
                     &*(ovv2-p_vlocc(iblc))
                Do k=1_t_int,lena
                   Do ik=1,3
                      oci_gvHcr(ik,ioci:ioci+icbm1,2)&
                           &=oci_gvHcr(ik,ioci:ioci+icbm1,2)&
                           &-gfb1(ik,0:icbm1)*p_fvbl(inblv+k)
                   Enddo
                   ioci=ioci+icbm1+1
                Enddo   ! k
             Endif
             inblc=inblc+icbm1+1
          Enddo oblcloop
          !!
          !! 
          !! 
          If ( icomp > 1 ) Cycle imloop
          !! 
          !! two center terms
          !! 
          inblc=1
          iblcloop: Do iblc=1,nblc !! b-site (core) blocks
             isc=p_isiteblc(iblc)
             icbm1=blocklenc(isc)-1_t_int
             ircp=p_ipairblc(iblc)

             fb1(0:icbm1)=p_fcbl(inblc:inblc+icbm1)
             gfb1(1:3,0:icbm1)=p_gfcbl(1:3,inblc:inblc+icbm1)
             !! 
             inblv=0
             iblvloop: Do iblv=1,nblv !! a-site (valence) blocks
                isv=p_isiteblv(iblv)
                lena=blocklenv(isv)
                irvp=p_ipairblv(iblv)
                !!
                itci0=p_itcidif(irvp,isv,ircp,isc)
                !!
                If((itci0 == 0_t_int) )Goto 500 !! TODO: check this
                !! TODO: it should be impossible, what happens with atom 
                !! TODO: dependend rmax
                !!
                vv=vv1-p_vlocc(iblc)-p_vlocv(iblv)
                !!
                itci=itci0
                Do k=1_t_int,lena
                   Do ik=1,3
                      tci_gvHc(ik,itci:itci+icbm1,1)&
                           &=tci_gvHc(ik,itci:itci+icbm1,1)&
                           &+fb1(0:icbm1)*p_gfvbl(ik,inblv+k)*vv
                   Enddo
                   itci=itci+icbm1+1
                Enddo   ! k
                itci=itci0
                Do k=1_t_int,lena
                   Do ik=1,3
                      tci_gvHcr(ik,itci:itci+icbm1,1)&
                           &=tci_gvHcr(ik,itci:itci+icbm1,1)&
                           &-gfb1(ik,0:icbm1)*p_fvbl(inblv+k)*vv
                   Enddo
                   itci=itci+icbm1+1
                Enddo   ! k
                If(lsp)Then
                   !!
                   vv=vv2-p_vlocc(iblc)-p_vlocv(iblv)
                   !!
                   itci=itci0
                   Do k=1_t_int,lena
                      Do ik=1,3
                         tci_gvHc(ik,itci:itci+icbm1,2)&
                              &=tci_gvHc(ik,itci:itci+icbm1,2)&
                              &+fb1(0:icbm1)*p_gfvbl(ik,inblv+k)*vv
                      Enddo
                      itci=itci+icbm1+1
                   Enddo   ! k
                   itci=itci0
                   Do k=1_t_int,lena
                      Do ik=1,3
                         tci_gvHcr(ik,itci:itci+icbm1,2)&
                              &=tci_gvHcr(ik,itci:itci+icbm1,2)&
                              &-gfb1(ik,0:icbm1)*p_fvbl(inblv+k)*vv
                      Enddo
                      itci=itci+icbm1+1
                   Enddo   ! k
                Endif
500             Continue
                inblv=inblv+lena
             Enddo iblvloop
             inblc=inblc+icbm1+1
          Enddo iblcloop
          !!
          !! 
          !!
       Enddo imloop             ! ig
    Enddo                     ! isp
    !!
    !!
    Call pfree(p_itcidif)
    Call pfree(p_ipairblc)
    Call pfree(p_ipairblv)
    Call pfree(p_isiteblc)
    Call pfree(p_isiteblv)
    Call pfree(p_vlocc)
    Call pfree(p_vlocv)
    Call pfree(p_fcbl)
    Call pfree(p_fvbl)
    Call pfree(p_gfcbl)
    Call pfree(p_gfvbl)
    !!
    Call symmetrize_foci(mspin,nsite,isrt&
         &,numops,opmat,equivsites,wu_ks&
         &,nvm,nv,lv&
         &,ncm,nc,lc&
         &,ocivcdim,oci_gvHc,ocivcindex)

    Call symmetrize_foci(mspin,nsite,isrt&
         &,numops,opmat,equivsites,wu_ks&
         &,nvm,nv,lv&
         &,ncm,nc,lc&
         &,ocivcdim,oci_gvHcr,ocivcindex)

    If(icomp <= 1) Then
       
       Call symmetrize_ftci(mspin,nsite,isrt,npairsmax,npairs&
            &,numops,opmat,equivsites,wu_ks&
            &,nvm,nv,lv&
            &,ncm,nc,lc&
            &,tcivcdim,tci_gvHc,tcivcindex,gdiff)

       Call symmetrize_ftci(mspin,nsite,isrt,npairsmax,npairs&
            &,numops,opmat,equivsites,wu_ks&
            &,nvm,nv,lv&
            &,ncm,nc,lc&
            &,tcivcdim,tci_gvHcr,tcivcindex,gdiff)
       
    Endif
    !!
    Return
    !!
  End Subroutine calc_fthcis_vc
  !!***********************************************************************
  Subroutine calc_fthcis(mspin,nsite,nsort,naps,isrt,posToSiteRep&
       &,numops,opmat,equivsites,wu_ks,gdiff&
       &,npairs,pairs,npairsmax&
       &,basmeshs,nrbmax&
       &,nvsmx,lvmx&
       &,ncomp,icomp,nvm,nv,lv&
       &,fv,fdpv,fdmv,fgam&
       &,rtfvmax,rfvmax&
       &,ocivvdim,tcivvdim&
       &,oci_gvHv&
       &,tci_gvHv&
       &,degree,ocivvindex,tcivvindex,mol,switch_v_beta)
    !!
    Implicit None
    !!IO
    Type(T_Mesh),Pointer         :: basmeshs(:)
    Type(T_Mol),Intent(in)       :: mol
    Logical(t_log),Intent(in)    :: switch_v_beta
    Integer(t_int),Intent(in)    :: nrbmax
    Integer(t_int),Intent(in)    :: mspin,naps,nsite,nsort,isrt(nsite)
    Integer(t_int),Intent(in)    :: npairsmax
    Integer(t_int),Intent(in)    :: posToSiteRep(nsite)
    Integer(t_int),Intent(in)    :: numops,equivsites(48,nsite)
    Real(t_real),Intent(in)      :: wu_ks(:,:,0:,:)
    Real(t_real),Intent(in)      :: opmat(3,3,48)
    Integer(t_int),Intent(in)    :: gdiff(0:npairsmax,48,nsite,nsite)
    !Integer(t_int),Intent(in)    :: nqAtPos(nsite),qposToSite(nsite,nsite)
    Integer(t_int),Intent(in)    :: npairs(nsite,nsite)
    Integer(t_int),Intent(in)    :: ncomp,icomp,nvm,nv(nsort),lv(nvm,nsort)
    Integer(t_int),Intent(in)    :: lvmx
    Integer(t_int),Intent(in)    :: ocivvindex(nsite)
    Integer(t_int),Intent(in)    :: tcivvindex(:,:,:)
    Real(t_real),Intent(in)      :: rfvmax(nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fv(nrbmax,nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fdpv(nrbmax,nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fdmv(nrbmax,nvm,ncomp,nsort)
    Real(t_real),Intent(in)      :: fgam(nsort)
    Integer(t_int),Intent(in)    :: nvsmx
    Integer(t_int),Intent(in)    :: degree
    Integer(t_int),Intent(in)    :: ocivvdim,tcivvdim
    Real(t_real),Intent(in)      :: pairs(:,:,:,:)
    Real(t_real),Intent(in)      :: rtfvmax(0:ncomp,nsort)
    Real(t_real),Intent(inout)   :: oci_gvHv(3,ocivvdim,mspin)
    Real(t_real),Intent(inout)   :: tci_gvHv(3,tcivvdim,mspin)
    !!LOCAL
    Character(*),Parameter::nsubfunc="calc_fthcis"
    Logical(t_log) :: lsp
    Integer(t_int) :: ispp,isp,isa,issa,nva,lena,lmxa,i,l,m,isb,deg
    Integer(t_int) :: ibl,inbl,mxblsize,nbl,ibla,inbla,iblb,inblb,itci0
    Integer(t_int) :: icbm1,nap,irap,im
    Integer(t_int) :: il,k,itci,irbp,indexa,ik
    Integer(t_int) :: lmx(nsort),blocklen(nsite)
    Integer(t_int) :: iocivv,ir0
    Real(t_real)   :: vv1,vv2,v1,v2,ww,ra,ff1,rsh(3),rra(3),oora,texp,texp1
    Real(t_real)   :: gfa(2),fdp,fdm
    Real(t_real)   :: vv,ovv1,ovv2
    Real(t_real)   :: yl((lvmx+2)**2) !! one l more for vec harm
    Real(t_real)   :: rvylm(3,2,((lvmx+1)**2))
    Real(t_real)   :: coefa(0:degree)
    Real(t_real)   :: fb1(0:nvsmx)
    Integer(t_int),Pointer :: p_isitebl(:)
    Integer(t_int),Pointer :: p_ipairbl(:)
    Real(t_real),Pointer   :: p_fabl(:)
    Real(t_real),Pointer   :: p_gfabl(:,:)
    Real(t_real),Pointer   :: p_vloc(:)
    Integer(t_int),Pointer :: p_itcidif(:,:,:,:)
    Type(T_Mesh),Pointer :: bmesha
    Type(T_Mesh),Pointer :: atommesha
    !!
    !!
    Nullify(p_fabl)
    Nullify(p_gfabl)
    Nullify(p_vloc)
    Nullify(p_isitebl)
    Nullify(p_ipairbl)
    Nullify(p_itcidif)
    !!
    !!
    Call prep_thcis(nsort,nsite,isrt,npairs,npairsmax,nvm,nv,lv&
         &,lmx,blocklen,mxblsize,p_fabl,p_vloc,p_isitebl,p_ipairbl,p_gfabl)
    !! 
    !!
    !!
    Call palloc('p_itcidif',p_itcidif,0_t_int,npairsmax&
         &,1_t_int,nsite,0_t_int,npairsmax,1_t_int,nsite,nmodule,nsubfunc)
    !!
    !! doit
    !!
    lsp=(mspin == 2_t_int)
    Do ispp=1_t_int,naps
1      Format('real site',i5)
       If(outlevel >= L_more) Write(outfile,1) ispp
       isp=posToSiteRep(ispp)
       !!       
       !!
       Call vecdifn(nsite,isp,p_itcidif,npairs,npairsmax,pairs,tcivvindex)
       !!
       imloop: Do im=1_t_int,mol% p_nm(isp)
          If(outlevel >= L_many .And.Mod(im,(mol% p_nm(isp)/100)) == 0_t_int)Then
             Write(outfile,5) isp,100.0_t_real*im/mol% p_nm(isp)
          Endif
5         Format('site: ',i5,' ',f5.1,'% done')

          rsh(:)=mol% p_rm(:,im,isp)
          ww=mol% p_wm(im,isp)
          v1=mol% p_vm2(1,im,isp)
          v2=v1
          If(lsp) v2=mol% p_vm2(2,im,isp)
          vv1=v1*ww
          vv2=v2*ww
          !!
          !! exchanged vv1 and vv2 due to beta-matrix
          ovv1=vv1
          ovv2=vv2
          If(switch_v_beta .And. icomp==2 )Then
             ovv1=vv2
             ovv2=vv1
          Endif
          !!
          !! interpolate all functions which are nonzero at r=(x,y,z)
          !!
          ibl=0
          inbl=0
          p_fabl(:)=0.0_t_real
          p_gfabl(:,:)=0.0_t_real
          isapreploop: Do isa=1_t_int,nsite
             issa=isrt(isa)
             !!
             bmesha => basmeshs(issa)
             atommesha => mol% p_atommeshs(issa)
             !!
             nva=nv(issa)
             !!
             lmxa=lmx(issa)
             !!
             nap=npairs(isa,isp)
             !!
             !!
             ir0=1
             If(isp==isa)Then
                !! include on-site terms, which are excluded in
                !! definition of pairs(...)
                ir0=0
             Endif
             !!
             irnappreploop: Do irap=ir0,nap

                If(irap==0)Then
                   rra(:)=rsh(:)
                Else
                   rra(:)=rsh(:)-pairs(:,irap,isa,isp)
                Endif
                ra=Max(Sqrt(Dot_product(rra,rra)),1.0e-16_t_real)
                If(ra==0.0_t_real)Then
                   oora=0.0_t_real
                Else
                   oora=1.0_t_real/ra
                Endif


                If(ra > rtfvmax(icomp,issa)) Cycle irnappreploop
                !!
                texp=ra**fgam(issa)*oora
                texp1=texp*oora
                !!
                indexa=mintpl_coefs(degree,bmesha,ra,coefa)
                !!
                Call calc_real_vec_Ylm_and_Ylm(rra,lmxa,yl,rvylm)

                k=0_t_int
                Do i=1_t_int,nva

                   l=lv(i,issa)
                   deg=2*l+1


                   ff1=0.0_t_real
                   fdp=0.0_t_real
                   fdm=0.0_t_real
                   If(ra <= rfvmax(i,icomp,issa) )Then
                      ff1=Dot_product(fv  (indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp
                      fdm=Dot_product(fdmv(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp1
                      fdp=Dot_product(fdpv(indexa:indexa+degree,i,icomp,issa)&
                           &,coefa(0:degree))*texp1
                   End If

                   gfa(1)= Sqrt(Real(l  ,t_real)/deg)*fdm
                   gfa(2)=-Sqrt(Real(l+1,t_real)/deg)*fdp

                   il=l*l
                   Do m=1_t_int,l+l+1_t_int
                      il=il+1
                      k=k+1_t_int
                      p_fabl(inbl+k)=ff1*yl(il)
                      p_gfabl(1:3,inbl+k)&
                           &=gfa(1)*rvylm(1:3,1,il)+gfa(2)*rvylm(1:3,2,il)

                   Enddo       ! m
                Enddo         ! i
                ibl=ibl+1
                p_isitebl(ibl)=isa
                p_ipairbl(ibl)=irap
                inbl=inbl+blocklen(isa)
                !! local potential
                indexa=mintpl_coefs(degree,atommesha,ra,coefa)
                p_vloc(ibl)=&
                     &Dot_product(mol% p_vatom(indexa:indexa+degree,0,issa)&
                     &,coefa(0:degree))*oora/sq4pi*ww
                !!
             Enddo irnappreploop
          End Do isapreploop
          nbl=ibl
          !! 
          !! 
          !! TODO: extra lsp 
          !! 
          !! 
          !! 
          !! one-center terms
          inblb=1
          oiblbloop: Do iblb=1,nbl
             isb=p_isitebl(iblb)
             icbm1=blocklen(isb)-1_t_int
             !!
             !!
             !!
             iocivv=ocivvindex(isb)+1
             fb1(0:icbm1)=p_fabl(inblb:inblb+icbm1)*(ovv1-p_vloc(iblb))
             Do k=0_t_int,icbm1 !!a-atom
                Do ik=1,3
                   oci_gvHv(ik,iocivv:iocivv+icbm1,1)&
                        &=oci_gvHv(ik,iocivv:iocivv+icbm1,1)&
                        &+fb1(0:icbm1)*p_gfabl(ik,inblb+k)
                Enddo
                iocivv=iocivv+icbm1+1
             Enddo   ! k
             If(lsp)Then
                iocivv=ocivvindex(isb)+1
                fb1(0:icbm1)=p_fabl(inblb:inblb+icbm1)*(ovv2-p_vloc(iblb))
                Do k=0_t_int,icbm1 !! a-atom
                   Do ik=1,3
                      oci_gvHv(ik,iocivv:iocivv+icbm1,2)&
                           &=oci_gvHv(ik,iocivv:iocivv+icbm1,2)&
                           &+fb1(0:icbm1)*p_gfabl(ik,inblb+k)
                   Enddo
                   iocivv=iocivv+icbm1+1
                Enddo   ! k
             Endif
             inblb=inblb+icbm1+1
          Enddo oiblbloop

          !! 
          !! 
          If ( icomp > 1 ) Cycle imloop
          !! 
          !! two center terms
          !! 
          inblb=1
          iblbloop: Do iblb=1,nbl
             isb=p_isitebl(iblb)
             icbm1=blocklen(isb)-1_t_int
             irbp=p_ipairbl(iblb)

             fb1(0:icbm1)=p_fabl(inblb:inblb+icbm1)
             !! 
             inbla=0
             iblaloop: Do ibla=1,nbl
                isa=p_isitebl(ibla)
                lena=blocklen(isa)
                irap=p_ipairbl(ibla)
                !!
                itci0=p_itcidif(irap,isa,irbp,isb)
                !!
                If((itci0 == 0_t_int) )Goto 500 !! TODO: check this
                !! TODO: it should be impossible, what happens with atom 
                !! TODO: dependend rmax
                !!
                vv=vv1-p_vloc(iblb)-p_vloc(ibla)
                !!
                itci=itci0
                Do k=1_t_int,lena
                   Do ik=1,3
                      tci_gvHv(ik,itci:itci+icbm1,1)&
                           &=tci_gvHv(ik,itci:itci+icbm1,1)&
                           &+fb1(0:icbm1)*p_gfabl(ik,inbla+k)*vv
                   Enddo
                   itci=itci+icbm1+1
                Enddo   ! k
                If(lsp)Then
                   !!
                   vv=vv2-p_vloc(iblb)-p_vloc(ibla)
                   !!
                   itci=itci0
                   Do k=1_t_int,lena
                      Do ik=1,3
                         tci_gvHv(ik,itci:itci+icbm1,2)&
                              &=tci_gvHv(ik,itci:itci+icbm1,2)&
                              &+fb1(0:icbm1)*p_gfabl(ik,inbla+k)*vv
                      Enddo
                      itci=itci+icbm1+1
                   Enddo   ! k
                Endif
500             Continue
                inbla=inbla+lena
             Enddo iblaloop
             inblb=inblb+icbm1+1
          Enddo iblbloop
          !!
          !! 
          !!
       Enddo imloop             ! ig
    Enddo                     ! isp
    !!
    Call pfree(p_itcidif)
    Call pfree(p_ipairbl)
    Call pfree(p_isitebl)
    Call pfree(p_vloc)
    Call pfree(p_fabl)
    Call pfree(p_gfabl)
    !!
    Call symmetrize_foci(mspin,nsite,isrt&
         &,numops,opmat,equivsites,wu_ks&
         &,nvm,nv,lv&
         &,nvm,nv,lv&
         &,ocivvdim,oci_gvHv,ocivvindex)
    !!
    If(icomp <= 1 )Then
       
       Call symmetrize_ftci(mspin,nsite,isrt,npairsmax,npairs&
            &,numops,opmat,equivsites,wu_ks&
            &,nvm,nv,lv&
            &,nvm,nv,lv&
            &,tcivvdim,tci_gvHv,tcivvindex,gdiff)
       
    Endif
    !!
    Return
    !!
  End Subroutine calc_fthcis
  !!***********************************************************************
  Subroutine calc_ftci(&
       !&nsite,&
       &isa,isb&
       &,npshell,ninpshell,pairs,pairabs&
       &,atommesha,atommeshb,nramax,bmesha,bmeshb,nrbmax&
       &,lmx,nRvmx,nRcmx,nRva,nRvb,nRcb,lRva,lRvb,lRcb,rffmax&
       &,fva,fvb,fcb,fkva,fkvb,fkcb&
       &,fdpva,fdpvb,fdpcb,fdmva,fdmvb,fdmcb&
       &,fgama,fgamb&
       &,vloca,vlocb,degree,vblocklength,cblocklength&
       &,tcivvindex,tcivcindex&
       &,tci_gvv0,tci_gvHv0,tci_gvc0,tci_gvHc0,tci_gvHcr0)
    !!
    Implicit None  
    !!IO
    Type(T_Mesh),Intent(in)      :: atommesha,atommeshb
    Type(T_Mesh),Intent(in)      :: bmesha,bmeshb
    Integer(t_int),Intent(in)    :: nrbmax,nramax
    !Integer(t_int),Intent(in)    :: nsite
    Integer(t_int),Intent(in)    :: tcivvindex(:,:,:)
    Integer(t_int),Intent(in)    :: tcivcindex(:,:,:)
    Integer(t_int),Intent(in)    :: isa,isb,degree,npshell
    Integer(t_int),Intent(in)    :: ninpshell(:,:,:)
    Real(t_real),Intent(in)      :: pairs(:,:,:,:)
    Real(t_real),Intent(in)      :: pairabs(:,:,:)
    Integer(t_int),Intent(in)    :: vblocklength(*)
    Integer(t_int),Intent(in)    :: cblocklength(*)
    Integer(t_int),Intent(in)    :: lmx,nRvmx,nRcmx,nRva,nRvb,nRcb
    Integer(t_int),Intent(in)    :: lRva(*),lRvb(*),lRcb(*)
    Real(t_real),Intent(in)      :: rffmax
    Real(t_real),Intent(in)      :: fgama,fgamb
    Real(t_real),Intent(in)      :: fva(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fvb(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fcb(nrbmax,nRcmx)
    Real(t_real),Intent(in)      :: fkva(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fkvb(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fkcb(nrbmax,nRcmx)
    Real(t_real),Intent(in)      :: fdpva(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fdpvb(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fdpcb(nrbmax,nRcmx)
    Real(t_real),Intent(in)      :: fdmva(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fdmvb(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fdmcb(nrbmax,nRcmx)
    Real(t_real),Intent(in)      :: vloca(nramax),vlocb(nramax)
    Real(t_real),Intent(inout)   :: tci_gvv0(3,*)
    Real(t_real),Intent(inout)   :: tci_gvHv0(3,*)
    Real(t_real),Intent(inout)   :: tci_gvc0(3,*)
    Real(t_real),Intent(inout)   :: tci_gvHc0(3,*)
    Real(t_real),Intent(inout)   :: tci_gvHcr0(3,*)
    !!LOCAL
    Character(*),Parameter::nsubfunc="calc_ftci"
    Integer(t_int) :: ir,ish,ne,nf,itci,itcivc,iva,lva,dega,ivb,lvb
    Integer(t_int) :: lcb,icb
    Integer(t_int) :: degb,wudim,n1,n1a,n1b,j0,na,i0,nb
    Integer(t_int) :: nda,ndb,ndc,nab1,nab2
    Integer(t_int) :: nla,nlb,nlc,nac1,nac2
    Integer(t_int) :: ma,mb,l,n,i,j,iint
    Real(t_real)   :: rho,qmin,qmax,fgammin,alfac,beta,al1,al
    Real(t_real)   :: rr,rr2,ra,rb,za,zb
    Real(t_real)   :: eu(3),MM(3,3),a(3),h(3),hr(3),etah,eta,xi,jac
    Real(t_real)   :: xijac,etajac
    Logical(t_log) :: calcxi,calceta
    Real(t_real),Pointer   :: wu(:)
    Real(t_real),Pointer   :: res(:)
    Real(t_real),Pointer   :: ltci(:,:,:)
    Real(t_real),Pointer   :: ltcivc(:,:,:)
    Real(t_real),Pointer   :: ltcih(:,:,:)
    Real(t_real),Pointer   :: ltcihvc(:,:,:)
    Real(t_real),Pointer   :: ltcihvcr(:,:,:)
    Real(t_real)   :: fac(0:2*lmx+1)
    !!
    !! GKP
    Type(T_Quadgkp) :: gkpxi,gkpeta
    Integer(t_int) :: n_ij,n_iHj1,n_iHj2,ndim_gk,n_ic,n_iHc1,n_iHc2
    Integer(t_int) :: n_iHcr1,n_iHcr2
    Real(t_real)   :: epsabs,epsrel
    Integer(t_int) :: count,counteta,countxi,mcountxi !!TODO:remove
    !!
    !!
    Nullify(wu)
    Nullify(res)
    Nullify(ltci)
    Nullify(ltcivc)
    Nullify(ltcih)
    Nullify(ltcihvc)
    Nullify(ltcihvcr)
    Call init_quadgkp(gkpxi)
    Call init_quadgkp(gkpeta)
    !!
    epsabs=1.e-6_t_real
    epsrel=1.e-6_t_real
    !!
    !!
    wudim=(lmx+1)*(4*(lmx+1)**2-1)/3
    Call palloc('wu',wu,1_t_int,wudim,nmodule,nsubfunc) 

    Call make_factorials(fac,2*lmx+1)
    !!
    nda=vblocklength(isa)
    ndb=vblocklength(isb)
    ndc=cblocklength(isb)
    If(outlevel>=L_All)Then
       Write(outfile,"('a-vblocklength=',i6)") nda
       Write(outfile,"('b-vblocklength=',i6)") ndb
       Write(outfile,"('b-cblocklength=',i6)") ndc
    Endif
    !!
    nla=Sum(lRva(1:nRva)+1)*2
    nlb=Sum(lRvb(1:nRvb)+1)*2
    nlc=Sum(lRcb(1:nRcb)+1)*2
    nab1=nlb*nRva
    nab2=nla*nRvb
    nac1=nlc*nRva
    nac2=nla*nRcb



    !!
    n_ij=0
    n_iHj1=n_ij+nab1
    n_iHj2=n_iHj1+nab1
    n_ic=n_iHj2+nab2
    n_iHc1=n_ic+nac1
    n_iHc2=n_iHc1+nac1
    n_iHcr1=n_iHc2+nac2
    n_iHcr2=n_iHcr1+nac1
    ndim_gk=n_iHcr2+nac2
    !!
    If(outlevel>=L_All)Then
       Write(outfile,"('n_ij   =',i6)") n_ij
       Write(outfile,"('n_iHj1 =',i6)") n_iHj1
       Write(outfile,"('n_iHj2 =',i6)") n_iHj2
       Write(outfile,"('n_ic   =',i6)") n_ic
       Write(outfile,"('n_iHc1 =',i6)") n_iHc1
       Write(outfile,"('n_iHc2 =',i6)") n_iHc2
       Write(outfile,"('n_iHcr1=',i6)") n_iHcr1
       Write(outfile,"('n_iHcr2=',i6)") n_iHcr2
       Write(outfile,"('ndim_gk=',i6)") ndim_gk
    Endif

    Call alloc_quadgkp(gkpxi,ndim_gk)
    Call alloc_quadgkp(gkpeta,ndim_gk)
    !!
    !!
    Call palloc('res',res,1_t_int,ndim_gk,nmodule,nsubfunc)
    Call palloc('ltci',ltci,1_t_int,3_t_int,1_t_int,ndb,1_t_int,nda&
         &,nmodule,nsubfunc)
    Call palloc('ltcivc',ltcivc,1_t_int,3_t_int,1_t_int,ndc,1_t_int,nda&
         &,nmodule,nsubfunc)
    Call palloc('ltcih',ltcih,1_t_int,3_t_int,1_t_int,ndb,1_t_int,nda&
         &,nmodule,nsubfunc)
    Call palloc('ltcihvc',ltcihvc,1_t_int,3_t_int,1_t_int,ndc,1_t_int,nda&
         &,nmodule,nsubfunc)
    Call palloc('ltcihvcr',ltcihvcr,1_t_int,3_t_int,1_t_int,ndc,1_t_int,nda&
         &,nmodule,nsubfunc)
    !!
    fgammin=Min(1.0_t_real,fgama,fgamb)
    
    alfac=1.0_t_real/fgammin
    beta=1.0_t_real
    al1=alfac*(1.0_t_real+beta)
    al=Max(al1,0.0_t_real)
    !Write(outfile,12)fgammin
    !Write(outfile,13)alfac
    !Write(outfile,14)al1
    !Write(outfile,14)al
!12  Format('minimum gamma value =',f10.5)
!13  Format('maximum alpha factor=',f10.5)
!14  Format('maximum alpha       =',f10.5)
!15  Format('alpha               =',f10.5)
    !!
    !!
    !!
    n=0_t_int
    Do ish=1_t_int,npshell
       nf=n+1_t_int
       ne=n+ninpshell(ish,isa,isb)
       n=ne
       !!
       RR=pairabs(ish,isa,isb)
       RR2=RR*0.5_t_real
       !!
       !!
       rho=Min(Max(bmesha% rmax,bmeshb% rmax),rffmax)
       !!
       count=0_t_int
       !!
       res(1:ndim_gk)=0.0_t_real
       iintloop: Do iint=1,2 !! subdivide integration area -> less points needed

          If(iint==2 .And. RR>=rho) Cycle
          
          gkpeta% typ=IJAC_TYPE_POW
          gkpeta% exx   =2.0_t_real
          gkpeta% kmin=3_t_int
          gkpeta% epsabs=epsabs
          gkpeta% epsrel=epsrel
          gkpxi% typ=IJAC_TYPE_POW
          gkpxi% exx  =al
          gkpxi% kmin=3_t_int
          gkpxi% epsabs=epsabs
          gkpxi% epsrel=epsrel


          !! 

          gkpeta% b0= 0.0_t_real
          gkpeta% b1= 1.0_t_real

          
          mcountxi=0_t_int
          counteta=0_t_int
          gkpeta% state=QUADSTART
          
          
          etaloop: Do 
             
             gkpeta% p_ff=gkpxi% p_res
             Call quad_gkp(gkpeta,etah,etajac,calceta)
             If(.Not.calceta) Exit etaloop
             
             
             
             If(iint==1)Then
                
                eta=1.0_t_real-RR/((rho-RR2)*etah+RR2)
                etajac=etajac*(rho-RR2)*RR/((rho-RR2)*etah+RR2)**2
                !cmin=-1
                !cmax=c1
                If(RR<=rho)Then
                   qmin=0.0_t_real
                Else
                   qmin=(rho-RR)/((rho-RR2)*etah-RR2)&
                        &*((rho-RR2)*etah+RR2)
                Endif
                qmax=(rho-RR2)*etah+RR2
             Else 
                eta=(rho-RR)/(RR*etah+(rho-RR))
                etajac=etajac*&
                     &RR*(rho-RR)/(RR*etah+(rho-RR))**2
                
                !cmin=1.0
                !cmax=c1
                qmin=0.0_t_real
                qmax=(RR*etah+(rho-RR))
                
             Endif
             
             
             
             gkpxi% b0=qmin
             gkpxi% b1=qmax
             
             !Print *,'qmax=',qmax
             
             countxi=0_t_int
             gkpxi% state=QUADSTART
             
             
             
             
             xiloop: Do 
                
                Call quad_gkp(gkpxi,xi,xijac,calcxi)
                If(.Not.calcxi) Exit xiloop
                
                
                rb=xi
                ra=RR+eta*rb
                If(rb==0.0_t_real)Then
                   zb=-1.0_t_real
                Else
                   zb=-(ra**2-rb**2-RR**2)/(2*rb*RR)
                Endif
                zb=Min(1.0_t_real,Max(-1.0_t_real,zb))
                za=(rb*zb-RR)/ra
                za=Min(1.0_t_real,Max(-1.0_t_real,za))
                
                jac=xijac*etajac*rb/RR
                
                
                Call ftci_kern(atommesha,atommeshb,nramax,bmesha,bmeshb,nrbmax&
                     &,ra,rb,za,zb,jac,lmx&
                     &,nRvmx,nRcmx,nRva,nRvb,nRcb,lRva,lRvb,lRcb&
                     &,fva,fvb,fcb,fkva,fkvb,fkcb&
                     &,fdpva,fdpvb,fdpcb,fdmva,fdmvb,fdmcb&
                     &,fgama,fgamb,vloca,vlocb&
                     &,degree&
                     &,n_ij,n_iHj1,n_iHj2,n_ic,n_iHc1,n_iHc2,n_iHcr1,n_iHcr2&
                     &,gkpxi% p_ff,gkpxi% ndim)
                
                
                
                countxi=countxi+1
                count=count+2
             End Do xiloop
             If(.Not.gkpxi% conv) Write(outfile,"('xi not converged!')")
             
             counteta=counteta+1
             mcountxi=Max(mcountxi,countxi)
             !Print *,'countxi=',eta,countxi
          End Do etaloop
          If(.Not.gkpeta% conv) Write(outfile,"('eta not converged!')")
          
          
          

          res(1:ndim_gk)=res(1:ndim_gk)+gkpeta% p_res(1:ndim_gk)
          
          
          !Print *,'mcountxi=',mcountxi
          !Print *,'counteta =',counteta
          !Print *,'count  =',count
          
          
       End Do iintloop


       !!
       !Stop
       !!
       !Print *,'count  =',count
       !!
       !!
       !Print *,'begin trans'
       !!
       Call ftci_trans(nRva,nRvb,nRcb,lRva,lRvb,lRcb&
            &,nda,ndb,ndc,nlb,nlc,n_ij,n_iHj1,n_iHj2,n_ic,n_iHc1,n_iHc2&
            &,n_iHcr1,n_iHcr2&
            &,res,ltci,ltcih,ltcivc,ltcihvc,ltcihvcr)
       !!
       !!

       !!Rotation
       Do ir=nf,ne

          Call reuler(pairs(:,ir,isa,isb),eu)
          Call m_euler(MM,eu)
          !!
          Do l=0,lmx
             n1=l*(l*l*4-1)/3
             Call ytr(eu,0_t_int,fac,l,wu(n1+1:),.True.)
          Enddo
          !!
          !Print *,'p=',p
          !Print *,'pM=',Matmul(p,MM)
          !!
          itci=tcivvindex(ir,isa,isb)
          i0=0
          Do iva=1,nRva
             lva=lRva(iva)
             n1a=lva*(lva*lva*4-1)/3
             dega=2*lva+1
             Do ma=1,dega
                j0=0
                Do ivb=1,nRvb
                   lvb=lRvb(ivb)
                   degb=2*lvb+1
                   n1b=lvb*(lvb*lvb*4-1)/3
                   Do mb=1,degb
                      a(1:3)=0.0_t_real
                      i=i0
                      Do na=1,dega
                         i=i+1
                         j=j0
                         Do nb=1,degb
                            j=j+1
                            a(1:3)=a(1:3)+Matmul(MM,ltci(1:3,j,i))&
                                 &*wu(n1b+mb+degb*(nb-1))&
                                 &*wu(n1a+ma+dega*(na-1))
                         Enddo
                      Enddo
                      !!
                      h(1:3)=0.0_t_real
                      i=i0
                      Do na=1,dega
                         i=i+1
                         j=j0
                         Do nb=1,degb
                            j=j+1
                            h(1:3)=h(1:3)+Matmul(MM,ltcih(1:3,j,i))&
                                 &*wu(n1b+mb+degb*(nb-1))&
                                 &*wu(n1a+ma+dega*(na-1))
                         Enddo
                      Enddo
                      !!
                      itci=itci+1
                      tci_gvv0(1:3,itci)=tci_gvv0(1:3,itci)+a(1:3)
                      tci_gvHv0(1:3,itci)=tci_gvHv0(1:3,itci)+h(1:3)
                      !!
                   Enddo !! mb
                   j0=j0+degb
                Enddo !! ivb
             Enddo !! ma
             i0=i0+dega
          Enddo!! iva
          !!
          !!
          itcivc=tcivcindex(ir,isa,isb)
          i0=0
          Do iva=1,nRva
             lva=lRva(iva)
             n1a=lva*(lva*lva*4-1)/3
             dega=2*lva+1
             Do ma=1,dega
                j0=0
                Do icb=1,nRcb
                   lcb=lRcb(icb)
                   degb=2*lcb+1
                   n1b=lcb*(lcb*lcb*4-1)/3
                   Do mb=1,degb
                      a(1:3)=0.0_t_real
                      i=i0
                      Do na=1,dega
                         i=i+1
                         j=j0
                         Do nb=1,degb
                            j=j+1
                            a(1:3)=a(1:3)+Matmul(MM,ltcivc(1:3,j,i))&
                                 &*wu(n1b+mb+degb*(nb-1))&
                                 &*wu(n1a+ma+dega*(na-1))
                         Enddo
                      Enddo
                      !!
                      h(1:3)=0.0_t_real
                      i=i0
                      Do na=1,dega
                         i=i+1
                         j=j0
                         Do nb=1,degb
                            j=j+1
                            h(1:3)=h(1:3)+Matmul(MM,ltcihvc(1:3,j,i))&
                                 &*wu(n1b+mb+degb*(nb-1))&
                                 &*wu(n1a+ma+dega*(na-1))
                         Enddo
                      Enddo
                      !!
                      hr(1:3)=0.0_t_real
                      i=i0
                      Do na=1,dega
                         i=i+1
                         j=j0
                         Do nb=1,degb
                            j=j+1
                            hr(1:3)=hr(1:3)+Matmul(MM,ltcihvcr(1:3,j,i))&
                                 &*wu(n1b+mb+degb*(nb-1))&
                                 &*wu(n1a+ma+dega*(na-1))
                         Enddo
                      Enddo
                      !!
                      !!
                      itcivc=itcivc+1
                      tci_gvc0(1:3,itcivc)  =tci_gvc0(1:3,itcivc)  +a(1:3)
                      tci_gvHc0(1:3,itcivc) =tci_gvHc0(1:3,itcivc) +h(1:3)
                      tci_gvHcr0(1:3,itcivc)=tci_gvHcr0(1:3,itcivc)+hr(1:3)
                      !!
                   Enddo !! mb
                   j0=j0+degb
                Enddo !! icb
             Enddo !! ma
             i0=i0+dega
          Enddo!! iva
          !!
          !!
          !!
          !!
          !!
       End Do !! ir
       !!
       !!
    Enddo !! ish
    !!
    Call clean_quadgkp(gkpxi)
    Call clean_quadgkp(gkpeta)
    Call pfree(wu)
    Call pfree(res)
    Call pfree(ltci)
    Call pfree(ltcivc)
    Call pfree(ltcih)
    Call pfree(ltcihvc)
    Call pfree(ltcihvcr)
    !!
    Return
    !!
  End Subroutine calc_ftci
  !!***********************************************************************
  !! put together all the raw data, except for the rotational part
  Subroutine ftci_trans(nRva,nRvb,nRcb,lRva,lRvb,lRcb,nda,ndb,ndc,nlb,nlc&
       &,n_ij,n_iHj1,n_iHj2,n_ic,n_iHc1,n_iHc2,n_iHcr1,n_iHcr2,res&
       &,ltci,ltcih,ltcivc,ltcihvc,ltcihvcr)
    !!
    Implicit None  
    !!IO
    Integer(t_int),Intent(in)    :: nda,ndb,ndc,nlb,nlc
    Integer(t_int),Intent(in)    :: nRva,nRvb,nRcb,lRva(*),lRvb(*),lRcb(*)
    Integer(t_int),Intent(in)    :: n_ij,n_iHj1,n_iHj2,n_ic,n_iHc1,n_iHc2
    Integer(t_int),Intent(in)    :: n_iHcr1,n_iHcr2
    Real(t_real),Intent(in)      :: res(*)
    Real(t_real),Intent(out)     :: ltci(3,ndb,nda)
    Real(t_real),Intent(out)     :: ltcivc(3,ndc,nda)
    Real(t_real),Intent(out)     :: ltcih(3,ndb,nda)
    Real(t_real),Intent(out)     :: ltcihvc(3,ndc,nda)
    Real(t_real),Intent(out)     :: ltcihvcr(3,ndc,nda)
    !!LOCAL
    Integer(t_int) :: ii,ii0,ii1,jj,jj1,jj0,ik,i,j
    Integer(t_int) :: iva,lva,dega,ma,mma
    Integer(t_int) :: ivb,lvb,degb,mb,mmb
    Integer(t_int) :: icb,lcb
    Real(t_real)   :: gvv,gvHv,cl(2),gvc,gvHc,gvHcr
    !!
    !!
    ltci(:,:,:)=0.0_t_real
    ltcih(:,:,:)=0.0_t_real
    ii1=0
    jj1=0
    Do iva=1,nRva
       lva=lRva(iva)
       dega=2*lva+1
       Do ma=1,dega
          ii0=ii1
          jj0=jj1
          Do ivb=1,nRvb
             lvb=lRvb(ivb)
             degb=2*lvb+1
             
             
             Do mb=1,degb
                
                mma=ma-lva-1
                mmb=mb-lvb-1
                
                
                Call rvylm_oci_coefs(lva,mma,mmb,cl,ik)
                If(ik==0)Cycle
                !!
                !!
                ii=ii0+Abs(mmb)+1
                
                gvv =res(n_ij   +ii+(lvb+1))*cl(2)
                gvHv=res(n_iHj1 +ii+(lvb+1))*cl(2)
                If(lva /= 0) Then 
                   gvv=gvv+res(n_ij     +ii)*cl(1)
                   gvHv=gvHv+res(n_iHj1 +ii)*cl(1)
                Endif
                !!
                Call rvylm_oci_coefs(lvb,mmb,mma,cl,ik)
                !!
                jj=jj0+Abs(mma)+1
                !!
                gvHv=gvHv+res(n_iHj2 +jj+(lva+1))*cl(2)
                If(lvb /=0 ) Then
                   gvHv=gvHv+res(n_iHj2 +jj)*cl(1)
                Endif
                
                !!
                i=Sum(2*lRva(1:iva-1)+1)+ma
                j=Sum(2*lRvb(1:ivb-1)+1)+mb
                
                ltci(ik,j,i)=gvv
                ltcih(ik,j,i)=gvHv
                
             End Do
             ii0=ii0+(lvb+1)*2
             jj0=jj0+(lva+1)*2
          End Do
       End Do
       ii1=ii1+nlb
       jj1=jj1+(lva+1)*2*nRvb
    End Do
    !!
    !!
    ltcivc(:,:,:)=0.0_t_real
    ltcihvc(:,:,:)=0.0_t_real
    ltcihvcr(:,:,:)=0.0_t_real
    ii1=0
    jj1=0
    Do iva=1,nRva
       lva=lRva(iva)
       dega=2*lva+1
       Do ma=1,dega
          ii0=ii1
          jj0=jj1
          Do icb=1,nRcb
             lcb=lRcb(icb)
             degb=2*lcb+1
             
             
             Do mb=1,degb
                
                mma=ma-lva-1
                mmb=mb-lcb-1
                
                
                Call rvylm_oci_coefs(lva,mma,mmb,cl,ik)
                If(ik==0)Cycle
                !!
                !!
                ii=ii0+Abs(mmb)+1
                
                gvc  =res(n_ic    +ii+(lcb+1))*cl(2)
                gvHc =res(n_iHc1  +ii+(lcb+1))*cl(2)
                gvHcr=res(n_iHcr1 +ii+(lcb+1))*cl(2)
                If(lva /= 0) Then 
                   gvc  =gvc  +res(n_ic     +ii)*cl(1)
                   gvHc =gvHc +res(n_iHc1   +ii)*cl(1)
                   gvHcr=gvHcr+res(n_iHcr1  +ii)*cl(1)
                Endif
                !!
                Call rvylm_oci_coefs(lcb,mmb,mma,cl,ik)
                !!
                jj=jj0+Abs(mma)+1
                !!
                gvHc =gvHc +res(n_iHc2  +jj+(lva+1))*cl(2)
                gvHcr=gvHcr+res(n_iHcr2 +jj+(lva+1))*cl(2)
                If(lcb /=0 ) Then
                   gvHc =gvHc +res(n_iHc2  +jj)*cl(1)
                   gvHcr=gvHcr+res(n_iHcr2 +jj)*cl(1)
                Endif

                !!
                i=Sum(2*lRva(1:iva-1)+1)+ma
                j=Sum(2*lRcb(1:icb-1)+1)+mb
                
                ltcivc  (ik,j,i)=gvc
                ltcihvc (ik,j,i)=gvHc
                ltcihvcr(ik,j,i)=gvHcr

             End Do
             ii0=ii0+(lcb+1)*2
             jj0=jj0+(lva+1)*2
          End Do
       End Do
       ii1=ii1+nlc
       jj1=jj1+(lva+1)*2*nRcb
    End Do
    !!
    !!
    !!
    Return
    !!
  End Subroutine ftci_trans
  !!***********************************************************************
  Subroutine nrel_calc_foci_vcs(vatom,oci_nr,atommesh,nramax,bmesh,nrbmax&
       &,degree,nRmxa,nRmxb,nRa,lRa,nRb,lRb&
       &,fna,fkna,fdpna,fdmna&
       &,fnb,fknb,fdpnb,fdmnb,fgam&
       &,ioci0,ocidim,oci_gnn0,oci_gnHn0,icomp,right)
    !!
    Implicit none  
    !!IO
    Type(T_Mesh),Intent(in)      :: atommesh
    Type(T_Mesh),Intent(in)      :: bmesh
    Logical(t_log),Intent(in),Optional    :: right
    Integer(t_int),Intent(in)    :: oci_nr,degree,icomp
    Integer(t_int),Intent(in)    :: nrbmax,nramax
    Integer(t_int),Intent(in)    :: ioci0
    Integer(t_int),Intent(in)    :: nRa,nRb,nRmxa,nRmxb
    Integer(t_int),Intent(in)    :: lRa(*),lRb(*)
    !! dimension of oci-arrays
    Integer(t_int),Intent(in)    :: ocidim
    Real(t_real),Intent(in)      :: fgam
    Real(t_real),Intent(in)      :: fna  (nrbmax,nRmxa)
    Real(t_real),Intent(in)      :: fkna (nrbmax,nRmxa)
    Real(t_real),Intent(in)      :: fdpna(nrbmax,nRmxa)
    Real(t_real),Intent(in)      :: fdmna(nrbmax,nRmxa)
    Real(t_real),Intent(in)      :: fnb  (nrbmax,nRmxb)
    Real(t_real),Intent(in)      :: fknb (nrbmax,nRmxb)
    Real(t_real),Intent(in)      :: fdpnb(nrbmax,nRmxb)
    Real(t_real),Intent(in)      :: fdmnb(nrbmax,nRmxb)
    Real(t_real),Intent(in)      :: vatom(nramax)
    !! output
    Real(t_real),Intent(inout)   :: oci_gnn0 (3,ocidim)
    Real(t_real),Intent(inout)   :: oci_gnHn0(3,ocidim)
    !!LOCAL
    Logical(t_log) :: doright
    Integer(t_int) :: index
    Integer(t_int) :: ir,ia,ib,ioci
    Integer(t_int) :: la,ma,lb,mb
    Integer(t_int) :: ik,ilam
    Real(t_real)   :: gov,gha,alfac,al1
    Real(t_real)   :: cl(2),alll
    Real(t_real)   :: gfa(2),gfb(2),fa,fb,fka,fka0,fkb,texp
    Real(t_real)   :: rp,we,dr,xp,al,alm1,vloc
    Real(t_real)   :: ffa(nRa),ffb(nRb),ffka(nRa),ffkb(nRb)
    Real(t_real)   :: fdpa(nRa),fdma(nRa),fdpb(nRb),fdmb(nRb)
    Real(t_real)   :: coefa(0:degree)
    !! DONT FREE THESE AFTERWARDS !!
    Real(t_real),Pointer   :: p_ar(:),p_wtr(:)
    !!

    doright=.False.
    If(Present(right))Then
       If(right)Then
          doright=.True.
       Endif
    Endif
    !!
    !!
    Call  get_gauss(oci_nr,p_ar,p_wtr)
    !!
    alfac=1.0_t_real/(2.0_t_real*fgam-1.0_t_real)
    al1=alfac*(1.0_t_real+2.0_t_real)
    al=Max(al1,3.0_t_real)
    !Write(outfile,12)fgam
    !Write(outfile,13)alfac
    !Write(outfile,14)al1
    !Write(outfile,14)al
!12  Format('minimum gamma value =',f10.5)
!13  Format('maximum alpha factor=',f10.5)
!14  Format('maximum alpha       =',f10.5)
!15  Format('alpha               =',f10.5)
    !!
    !!
    !!
    alm1=al-1.0_t_real
    dr=bmesh% rmax
    !!
    !!
    irloop: Do ir=1,oci_nr
       !Print *,'ir=',ir,oci_nr
       xp=(p_ar(ir)+1.0_t_real)*0.5_t_real
       rp=xp**al*dr
       we=p_wtr(ir)*0.5_t_real*al*xp**alm1*dr

       !!

       !!
       vloc=(minterpol(atommesh,degree,vatom,rp))/sq4pi/rp
       !!
       !!
       index=mintpl_coefs(degree,bmesh,rp,coefa)

       !!
       Do ia=1,nRa
          !! basis orbital interpolation
          texp=rp**fgam
          ffa (ia)= Dot_product(fna  (index:index+degree,ia),coefa(0:degree))*texp
          ffka(ia)= Dot_product(fkna (index:index+degree,ia),coefa(0:degree))*texp/rp
          fdpa(ia)= Dot_product(fdpna(index:index+degree,ia),coefa(0:degree))*texp/rp
          fdma(ia)= Dot_product(fdmna(index:index+degree,ia),coefa(0:degree))*texp/rp
       Enddo
       Do ib=1,nRb
          !! basis orbital interpolation
          texp=rp**fgam
          ffb (ib)= Dot_product(fnb  (index:index+degree,ib),coefa(0:degree))*texp
          ffkb(ib)= Dot_product(fknb (index:index+degree,ib),coefa(0:degree))*texp/rp
          fdpb(ib)= Dot_product(fdpnb(index:index+degree,ib),coefa(0:degree))*texp/rp
          fdmb(ib)= Dot_product(fdmnb(index:index+degree,ib),coefa(0:degree))*texp/rp
       Enddo
       !!
       ioci=ioci0
       ialoop: Do ia=1,nRa
          la=lRa(ia)
          fa=ffa(ia)
          fka0=ffka(ia)*we*0.5_t_real
          gfa( 1)=fdma(ia)*we
          gfa( 2)=fdpa(ia)*we
          maloop: Do ma=-la,la
             ibloop: Do ib=1,nRb
                lb=lRb(ib)
                fb=ffb(ib)
                fkb=ffkb(ib)*0.5_t_real
                gfb( 1)=fdmb(ib)
                gfb( 2)=fdpb(ib)

                alll=1.0_t_real
                If(icomp>2.And. use_OVO)Then
                   alll=0.0_t_real
                   If( la>0 .And. lb>0) Then
                      alll=Sqrt(1.0_t_real-1.0_t_real/Max(la,lb)**2)
                   Endif
                Endif
                fka=fka0
                If(doright) fka=fka+fa*vloc*alll*we !! H^r
                If(.Not.doright) fkb=fkb+fb*vloc*alll !! H^l
                
                mbloop: Do mb=-lb,lb

                   ioci=ioci+1


                   Call rvylm_oci_coefs(la,ma,mb,cl,ik)
                   If(ik==0) Cycle

                   Do ilam=1,2
                      !! 2*ilam-3 maps ilam=1,2 onto lambda=-1,1
                      !! 3-ilam is  ilam of -lambda
                      If(la+(2*ilam-3)/=lb) Cycle
                      !!
                      gov=gfa(ilam)*fb*cl(ilam)
                      gha=(gfa(ilam)*fkb-fka*gfb(3-ilam))*cl(ilam)
                      !!
                      !!

                      If(.Not.doright) Then
                         oci_gnn0 (ik,ioci)=oci_gnn0 (ik,ioci)+gov
                      Endif
                      oci_gnHn0(ik,ioci)=oci_gnHn0(ik,ioci)+gha
                      !!
                   Enddo ! lam
                   !!
                End Do mbloop
             End Do ibloop
          End Do maloop
       End Do ialoop
       !!
    Enddo irloop
    !!
    !!
    !!
    Return
    !!
  End Subroutine nrel_calc_foci_vcs
  !!***********************************************************************
  !!   k=(3*Abs(ik-2)-ik)/2   ik=(6-k-3*Abs(k))/2
  !!       1                      1 
  !!      -1                      2
  !!       0                      3
  !! the first  returned coeficient is for lambda=-1
  !! the second returned coeficient is for lambda=+1
  Subroutine rvylm_oci_coefs(l,ma,mb,c,ik)
    !!
    Implicit None  
    !!IO
    Integer(t_int),Intent(in)    :: l,ma,mb
    Real(t_real),Intent(out)     :: c(2)
    Integer(t_int),Intent(out)   :: ik
    !!LOCAL
    Integer(t_int) :: s,sm,k
    Real(t_real)   :: denom1,denom2,delk,deg
    Real(t_real),Parameter :: sq2=1.41421356237309504880_t_real
    Integer(t_int),Parameter :: iSphTOCart(-1:1)=(/2,3,1/)
    !!
    c(1:2)=0.0_t_real
    ik=0
    !!
    deg=Real(2*l+1,t_real)
    sm=Sign(1_t_int,ma)
    denom1=0.0_t_real
    If(l/=0) denom1= 1.0_t_real/Sqrt(4.0_t_real*(deg-2)*deg)
    denom2=-1.0_t_real/Sqrt(4.0_t_real*(deg+2)*deg)
    !!
    !!
    If(ma==mb)Then
       !!
       c( 1)= Sqrt((deg-1-2*ma)*(deg-1+2*ma))*denom1
       c( 2)=-Sqrt((deg+1-2*ma)*(deg+1+2*ma))*denom2
       ik=3
       !!
    Else If(ma==0 .And. Abs(mb)==1)Then
       !!
       c( 1)=-sq2*Sqrt((l-1)*l*1.0_t_real)*denom1
       c( 2)=-sq2*Sqrt((l+1)*(l+2)*1.0_t_real)*denom2
       ik=iSphTOCart(mb)
       !!
    Else 

       If(Abs(Abs(ma)-mb) == 1) Then
          k= sm
       Else If(Abs(Abs(ma)+mb) == 1) Then
          k=-sm
       Else
          Return
       Endif
       ik=iSphTOCart(k)
       
       s=ma-mb*k
       
       delk=sm*( s*(1+k)/2 - (1-k)/2  )*1.0_t_real
       If(ma==s) delk=sm*( s*(1+k)/2 - (1-k)/2  )*sq2*(1+s*k)/2
       c( 1)=delk*Sqrt((l+s*ma-1)*(l+s*ma)*1.0_t_real)*denom1
       c( 2)=delk*Sqrt((l-s*ma+1)*(l-s*ma+2)*1.0_t_real)*denom2
       
       
    Endif
    !!
    Return
    !!
  End Subroutine rvylm_oci_coefs
  !!***********************************************************************
  Subroutine ftci_kern(atommesha,atommeshb,nramax,bmesha,bmeshb,nrbmax&
       &,ra,rb,za,zb,jac,lmx&
       &,nRvmx,nRcmx,nRva,nRvb,nRcb,lRva,lRvb,lRcb&
       &,fva,fvb,fcb,fkva,fkvb,fkcb&
       &,fdpva,fdpvb,fdpcb,fdmva,fdmvb,fdmcb&
       &,fgama,fgamb&
       &,vloca,vlocb,degree&
       &,n_ij,n_iHj1,n_iHj2,n_ic,n_iHc1,n_iHc2,n_iHcr1,n_iHcr2,ltci,ndim_gk)
    !!
    Implicit None  
    !!IO
    Type(T_Mesh),Intent(in)      :: atommesha,atommeshb
    Type(T_Mesh),Intent(in)      :: bmesha,bmeshb
    Integer(t_int),Intent(in)    :: nrbmax,nramax
    Integer(t_int),Intent(in)    :: lmx,nRva,nRvb,nRcb,lRva(*),lRvb(*),lRcb(*)
    Integer(t_int),Intent(in)    :: nRvmx,nRcmx
    Integer(t_int),Intent(in)    :: n_ij,n_iHj1,n_iHj2,n_ic,n_iHc1,n_iHc2
    Integer(t_int),Intent(in)    :: n_iHcr1,n_iHcr2
    Integer(t_int),Intent(in)    :: ndim_gk
    Integer(t_int),Intent(in)    :: degree
    Real(t_real),Intent(in)      :: fgama,fgamb
    Real(t_real),Intent(in)      :: ra,rb,za,zb,jac
    Real(t_real),Intent(in)      :: fva(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fvb(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fcb(nrbmax,nRcmx)
    Real(t_real),Intent(in)      :: fkva(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fkvb(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fkcb(nrbmax,nRcmx)
    Real(t_real),Intent(in)      :: fdpva(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fdpvb(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fdpcb(nrbmax,nRcmx)
    Real(t_real),Intent(in)      :: fdmva(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fdmvb(nrbmax,nRvmx)
    Real(t_real),Intent(in)      :: fdmcb(nrbmax,nRcmx)
    Real(t_real),Intent(in)      :: vloca(nramax),vlocb(nramax)
    Real(t_real),Intent(out)     :: ltci(ndim_gk)
    !!LOCAL
    Integer(t_int) :: indexaa,indexab,indexba,indexbb,iv,i,iva,lva,index,ic
    Integer(t_int) :: ivb,lvb,lam,l,ii,m,lcb,icb
    Real(t_real)   :: yb,ya,gvHvp,gvHvm,texp,texp1
    Real(t_real)   :: cp,cm,gvvp,gvvm,vap,vam,vbp,vbm,fk,f,gvcp,gvcm
    Real(t_real)   :: fdp,fdm
    Real(t_real)   :: gvHcp,gvHcm,gvHcrp,gvHcrm
    Real(t_real)   :: fapv(nRva),fkap(nRva),gfap(nRva,-1:1)
    Real(t_real)   :: famv(nRva),fkam(nRva),gfam(nRva,-1:1)
    Real(t_real)   :: fbp(nRvb),fbpv(nRvb),gfbp(nRvb,-1:1)
    Real(t_real)   :: fbm(nRvb),fbmv(nRvb),gfbm(nRvb,-1:1)
    Real(t_real)   :: fcp(nRcb),fcpv(nRcb),gfcp(nRcb,-1:1)
    Real(t_real)   :: fcm(nRcb),fcmv(nRcb),gfcm(nRcb,-1:1)
    Real(t_real)   :: fkcp(nRcb),fkcm(nRcb)
    Real(t_real)   :: fcoef(0:degree)
    Real(t_real)   :: coefaa(0:degree),coefab(0:degree)
    Real(t_real)   :: coefba(0:degree),coefbb(0:degree)
    Real(t_real)   :: yhza(0:lmx+1,0:lmx+1) !! one l more for vec harm
    Real(t_real)   :: yhzb(0:lmx+1,0:lmx+1) !! one l more for vec harm
    !!
    ltci(1:ndim_gk)=0.0_t_real
    !!
    ya=Sqrt(Abs(1.0_t_real-za*za))
    yb=Sqrt(Abs(1.0_t_real-zb*zb))
    !!
    !!
    index=mintpl_coefs(degree,atommesha,ra,fcoef)
    vap=(Dot_product(vloca(index:index+degree),fcoef(0:degree))/sq4pi)/ra
    index=mintpl_coefs(degree,atommeshb,ra,fcoef)
    vbm=(Dot_product(vlocb(index:index+degree),fcoef(0:degree))/sq4pi)/ra
    !!
    index=mintpl_coefs(degree,atommeshb,rb,fcoef)    
    vbp=(Dot_product(vlocb(index:index+degree),fcoef(0:degree))/sq4pi)/rb
    index=mintpl_coefs(degree,atommesha,rb,fcoef)    
    vam=(Dot_product(vloca(index:index+degree),fcoef(0:degree))/sq4pi)/rb
    !!
    !!
    !!
    indexaa=mintpl_coefs(degree,bmesha,ra,coefaa)
    indexab=mintpl_coefs(degree,bmesha,rb,coefab)
    indexbb=mintpl_coefs(degree,bmeshb,rb,coefbb)
    indexba=mintpl_coefs(degree,bmeshb,ra,coefba)
    
    Call yhzy5(yhza,za,ya,lmx+1)
    Call yhzy5(yhzb,zb,yb,lmx+1)
    
    !!          
    !!          
    Do iv=1,nRva
       l=lRva(iv)
       texp=ra**fgama
       texp1=texp/ra
       f  =Dot_product(fva  (indexaa:indexaa+degree,iv),coefaa(0:degree))*texp
       fk =Dot_product(fkva (indexaa:indexaa+degree,iv),coefaa(0:degree))*texp1*0.5_t_real
       fdm=Dot_product(fdmva(indexaa:indexaa+degree,iv),coefaa(0:degree))*texp1
       fdp=Dot_product(fdpva(indexaa:indexaa+degree,iv),coefaa(0:degree))*texp1
       fkap(iv)=fk
       fapv(iv)=f*(vap+vbp)+fk
       gfap(iv,-1)=fdm*jac
       gfap(iv, 1)=fdp*jac
       !!
       i=(-1)**l
       texp=rb**fgama*i
       texp1=texp/rb
       f  =Dot_product(fva  (indexab:indexab+degree,iv),coefab(0:degree))*texp
       fk =Dot_product(fkva (indexab:indexab+degree,iv),coefab(0:degree))*texp1*0.5_t_real
       fdm=Dot_product(fdmva(indexab:indexab+degree,iv),coefab(0:degree))*texp1
       fdp=Dot_product(fdpva(indexab:indexab+degree,iv),coefab(0:degree))*texp1
       fkam(iv)=fk
       famv(iv)=f*(vam+vbm)+fk
       gfam(iv,-1)=-fdm*jac
       gfam(iv, 1)=-fdp*jac
    Enddo
    Do iv=1,nRvb
       l=lRvb(iv)
       texp=rb**fgamb
       texp1=texp/rb
       f   =Dot_product(fvb  (indexbb:indexbb+degree,iv),coefbb(0:degree))*texp
       fk  =Dot_product(fkvb (indexbb:indexbb+degree,iv),coefbb(0:degree))*texp1*0.5_t_real
       fdm =Dot_product(fdmvb(indexbb:indexbb+degree,iv),coefbb(0:degree))*texp1
       fdp =Dot_product(fdpvb(indexbb:indexbb+degree,iv),coefbb(0:degree))*texp1
       fbp(iv)=f
       fbpv(iv)=f*(vap+vbp)+fk
       gfbp(iv,-1)=fdm*jac
       gfbp(iv, 1)=fdp*jac
       !!
       i=(-1)**l
       texp=ra**fgamb*i
       texp1=texp/ra
       f   =Dot_product(fvb  (indexba:indexba+degree,iv),coefba(0:degree))*texp
       fk  =Dot_product(fkvb (indexba:indexba+degree,iv),coefba(0:degree))*texp1*0.5_t_real
       fdm =Dot_product(fdmvb(indexba:indexba+degree,iv),coefba(0:degree))*texp1
       fdp =Dot_product(fdpvb(indexba:indexba+degree,iv),coefba(0:degree))*texp1
       fbm(iv)=f
       fbmv(iv)=f*(vam+vbm)+fk
       gfbm(iv,-1)=-fdm*jac
       gfbm(iv, 1)=-fdp*jac
    Enddo
    !!
    Do ic=1,nRcb
       l=lRcb(ic)
       texp=rb**fgamb
       texp1=texp/rb
       f   =Dot_product(fcb  (indexbb:indexbb+degree,ic),coefbb(0:degree))*texp
       fk  =Dot_product(fkcb (indexbb:indexbb+degree,ic),coefbb(0:degree))*texp1*0.5_t_real
       fdm =Dot_product(fdmcb(indexbb:indexbb+degree,ic),coefbb(0:degree))*texp1
       fdp =Dot_product(fdpcb(indexbb:indexbb+degree,ic),coefbb(0:degree))*texp1
       fcp(ic)=f
       fkcp(ic) =fk
       fcpv(ic)=f*(vap+vbp)+fk
       gfcp(ic,-1)=fdm*jac
       gfcp(ic, 1)=fdp*jac
       !!
       i=(-1)**l
       texp=ra**fgamb*i
       texp1=texp/ra
       f   =Dot_product(fcb  (indexba:indexba+degree,ic),coefba(0:degree))*texp
       fk  =Dot_product(fkcb (indexba:indexba+degree,ic),coefba(0:degree))*texp1*0.5_t_real
       fdm =Dot_product(fdmcb(indexba:indexba+degree,ic),coefba(0:degree))*texp1
       fdp =Dot_product(fdpcb(indexba:indexba+degree,ic),coefba(0:degree))*texp1
       fcm(ic)=f
       fkcm(ic) =fk
       fcmv(ic)=f*(vam+vbm)+fk
       gfcm(ic,-1)=-fdm*jac
       gfcm(ic, 1)=-fdp*jac
    Enddo
    !!
    ii=0
    Do iva=1,nRva
       lva=lRva(iva)
       Do ivb=1,nRvb
          lvb=lRvb(ivb)
          Do lam=-1,1,2
             !!
             l=lvb+lam
             If(l<0) Then
                ii=ii+lva+1
                Cycle 
             Endif
             !!
             gvHvp=-gfbp(ivb,lam)*fkap(iva)
             !!
             gvHvm=-gfbm(ivb,lam)*fkam(iva)

             !!
             Do m=0,lva
                ii=ii+1
                If(m>l) Cycle 
                !!
                cp=yhzb(m,l)*yhza(m,lva)
                cm=yhza(m,l)*yhzb(m,lva)
                !!
                ltci(n_iHj2+ii)=gvHvp*cp+gvHvm*cm
             Enddo
          End Do 
       End Do
    End Do
    !!
    ii=0
    Do iva=1,nRva
       lva=lRva(iva)
       Do ivb=1,nRvb
          lvb=lRvb(ivb)

          Do lam=-1,1,2
             !!
             l=lva+lam
             If(l<0) Then
                ii=ii+lvb+1
                Cycle 
             Endif
             !!
             gvvp =gfap(iva,lam)*fbp(ivb)
             gvHvp=gfap(iva,lam)*fbpv(ivb)
             !!
             gvvm =gfam(iva,lam)*fbm(ivb)
             gvHvm=gfam(iva,lam)*fbmv(ivb)

             Do m=0,lvb
                ii=ii+1
                If(m>l) Cycle 
                !!
                cp=yhza(m,l)*yhzb(m,lvb)
                cm=yhzb(m,l)*yhza(m,lvb)
                !!
                ltci(n_ij   +ii)=gvvp *cp+gvvm *cm
                ltci(n_iHj1 +ii)=gvHvp*cp+gvHvm*cm
             Enddo
          End Do
       End Do
    End Do
    !!
    !!
    ic=0
    Do iva=1,nRva
       lva=lRva(iva)
       Do icb=1,nRcb
          lcb=lRcb(icb)
          Do lam=-1,1,2
             !!
             l=lcb+lam
             If(l<0) Then
                ic=ic+lva+1
                Cycle 
             Endif
             !!
             gvHcp =-fkap(iva)*gfcp(icb,lam)
             gvHcrp=-fapv(iva)*gfcp(icb,lam)
             !!
             gvHcm =-fkam(iva)*gfcm(icb,lam)
             gvHcrm=-famv(iva)*gfcm(icb,lam)

             !!
             Do m=0,lva
                ic=ic+1
                If(m>l) Cycle 
                !!
                cp=yhzb(m,l)*yhza(m,lva)
                cm=yhza(m,l)*yhzb(m,lva)
                !!
                ltci(n_iHc2+ic) =gvHcp *cp+gvHcm *cm
                ltci(n_iHcr2+ic)=gvHcrp*cp+gvHcrm*cm
             Enddo
          End Do 
       End Do
    End Do
    !!
    ic=0
    Do iva=1,nRva
       lva=lRva(iva)
       Do icb=1,nRcb
          lcb=lRcb(icb)

          Do lam=-1,1,2
             !!
             l=lva+lam
             If(l<0) Then
                ic=ic+lcb+1
                Cycle 
             Endif
             !!
             gvcp  =gfap(iva,lam)*fcp(icb)
             gvHcp =gfap(iva,lam)*fcpv(icb)
             gvHcrp=gfap(iva,lam)*fkcp(icb)

             !!
             gvcm  =gfam(iva,lam)*fcm(icb)
             gvHcm =gfam(iva,lam)*fcmv(icb)
             gvHcrm=gfam(iva,lam)*fkcm(icb)

             Do m=0,lcb
                ic=ic+1
                If(m>l) Cycle 
                !!
                cp=yhza(m,l)*yhzb(m,lcb)
                cm=yhzb(m,l)*yhza(m,lcb)
                !!
                ltci(n_ic   +ic) =gvcp  *cp+gvcm  *cm
                ltci(n_iHc1 +ic) =gvHcp *cp+gvHcm *cm
                ltci(n_iHcr1 +ic)=gvHcrp*cp+gvHcrm*cm

             Enddo
          End Do
       End Do
    End Do
    !!
    Return
    !!
  End Subroutine ftci_kern
  !!***********************************************************************
  Subroutine manipulate_OVO(structure,&
       &nma,nRa,lRa,nmb,nRb,lRb,glmax,wgaunt,wfgaunt&
       &,ociindex,ocitmp,oci,right)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Integer(t_int),Intent(in)    :: nma,nRa(*),lRa(nma,*)
    Integer(t_int),Intent(in)    :: nmb,nRb(*),lRb(nmb,*)
    Integer(t_int),Intent(in)    :: ociindex(*)
    Integer(t_int),Intent(in)    :: glmax
    Logical(t_log),Intent(in),Optional    :: right
    Real(t_real),Intent(in)      :: ocitmp(:,:)
    Real(t_real),Intent(inout)   :: oci(:,:)
    Real(t_real),Intent(in)      :: wgaunt(&
         &(glmax+1+1)**2&
         &,(glmax+1)**2&
         &,(2*glmax+1+1)**2)
    Real(t_real),Intent(in)      :: wfgaunt(3,2&
         &,(glmax+1)**2&
         &,(glmax+1)**2&
         &,(2*glmax+1+1)**2)
    !!LOCAL
    Logical(t_log) :: doright
    Character(*),Parameter::nsubfunc="manipulate_OVO"
    Integer(t_int) :: iLLm,iLLm0,ilam,ilbm,LL,MM,isa,issa,ioci
    Integer(t_int) :: ia,la,ma,lqa,ib,lb,mb,lqb,klj,lam,k
    Real(t_real)   :: LLLLp1,cl2LL0,clLLMp,clLLMm,w0,alll,vv1(3),ff(3)
    Real(t_real)   :: wpMp1(3),wpMm1(3),wmMp1(3),wmMm1(3)
    Real(t_real),Pointer :: p_ociLM(:,:,:)
    !!
    Nullify(p_ociLM)
    !!
    doright=.False.
    If(Present(right))Then
       If(right)Then
          doright=.True.
       Endif
    Endif
    !!
    Call palloc('p_ociLM',p_ociLM,1_t_int,2_t_int&
         &,1_t_int,nma,1_t_int,nmb,nmodule,nsubfunc)
    !!
    Do iLLm=1,(2*glmax+1+1)**2
       LL=llilm(iLLm)
       MM=mmilm(iLLm)-LL-1
       iLLm0=LL*LL+LL+1
       
       LLLLp1=LL*(LL+1.0_t_int)
       cl2LL0=Sqrt(2.0_t_real*LLLLp1)*0.5_t_real
       clLLMp=Sqrt(LLLLp1-MM*(MM+1))*0.5_t_real*(MM+0.1_t_real)/Abs(MM+0.1_t_real)
       clLLMm=Sqrt(LLLLp1-MM*(MM-1))*0.5_t_real*(MM+0.1_t_real)/Abs(MM+0.1_t_real)
       
       !Print *,LL,MM
       
       Do isa=1,structure% nsite
          issa=structure% p_isrt(isa)

          
          
          p_ociLM=0.0_t_real
          !! fold the matrix elements with the gaunt/Clebsch-Gordon coefficient
          ioci=ociindex(isa)
          Do ia=1,nRa(issa)
             la=lRa(ia,issa)
             lqa=la*la
             Do ma=1,2*la+1
                ilam=lqa+ma
                
                Do ib=1,nRb(issa)
                   lb=lRb(ib,issa)
                   lqb=lb*lb
                   Do mb=1,lb+lb+1
                      ilbm=lqb+mb
                      
                      
                      ioci=ioci+1
                      Do klj=1,2
                         If(doright)Then

                            lam=lb+2*klj-3
                            If(lb==0 .And. klj==1) Cycle
                            
                            w0=wgaunt(lam*lam+lam+1,lqa+la+1,iLLm0)
                            If(Abs(w0)>1.0e-10_t_real)Then
                               Do k=1,3
                                  p_ociLM(klj,ia,ib)=p_ociLM(klj,ia,ib)&
                                       &+ocitmp(k,ioci)*wfgaunt(k,klj,ilbm,ilam,iLLm)&
                                       &*Sqrt(fourpi*(2*lam+1)*(2*LL+1)/(2*la+1))/(2*lb+1)/w0
                               Enddo
                            Endif
                         Else
                            lam=la+2*klj-3
                            If(la==0 .And. klj==1) Cycle
                            
                            w0=wgaunt(lam*lam+lam+1,lqb+lb+1,iLLm0)
                            If(Abs(w0)>1.0e-10_t_real)Then
                               Do k=1,3
                                  p_ociLM(klj,ia,ib)=p_ociLM(klj,ia,ib)&
                                       &+ocitmp(k,ioci)*wfgaunt(k,klj,ilam,ilbm,iLLm)&
                                       &*Sqrt(fourpi*(2*lam+1)*(2*LL+1)/(2*lb+1))/(2*la+1)/w0
                               Enddo
                            Endif
                         Endif
                         !!
                      Enddo! klj
                   Enddo! m
                Enddo! l
             Enddo! mb
          Enddo! lb
          !!
          ioci=ociindex(isa)
          Do ia=1,nRa(issa)
             la=lRa(ia,issa)
             lqa=la*la
             Do ma=1,2*la+1
                ilam=lqa+ma
                
                Do ib=1,nRb(issa)
                   lb=lRb(ib,issa)
                   lqb=lb*lb
                   Do mb=1,lb+lb+1
                      ilbm=lqb+mb
                      ioci=ioci+1
                      
                      If(la>0 .And.lb>0)Then
                         alll=(lqa+la+lqb+lb-LLLLp1-2)*0.5_t_real
                         vv1=0.0_t_real
                         Do klj=1,2
                            wpMp1=0.0_t_real
                            wpmm1=0.0_t_real
                            wmmp1=0.0_t_real
                            wmMm1=0.0_t_real
                            If(doright)Then
                               If(Abs(MM-1)<=LL)Then
                                  wpMm1=wfgaunt(:,klj,ilbm,ilam,iLLm0+MM-1)
                                  wmMp1=wfgaunt(:,klj,ilbm,ilam,iLLm0-MM+1)
                               Endif
                               If(Abs(MM+1)<=LL)Then
                                  wpMp1=wfgaunt(:,klj,ilbm,ilam,iLLm0+MM+1)
                                  wmMm1=wfgaunt(:,klj,ilbm,ilam,iLLm0-MM-1)
                               Endif
                               
                               ff(:)=alll*wfgaunt(:,klj,ilbm,ilam,iLLm0+MM)
                               ff(1)=ff(1)+MM*wfgaunt(2,klj,ilbm,ilam,iLLm0-MM)
                               ff(2)=ff(2)-MM*wfgaunt(1,klj,ilbm,ilam,iLLm0-MM)
                            Else
                               If(Abs(MM-1)<=LL)Then
                                  wmMp1=wfgaunt(:,klj,ilam,ilbm,iLLm0-MM+1)
                                  wpMm1=wfgaunt(:,klj,ilam,ilbm,iLLm0+MM-1)
                               Endif
                               If(Abs(MM+1)<=LL)Then
                                  wpMp1=wfgaunt(:,klj,ilam,ilbm,iLLm0+MM+1)
                                  wmMm1=wfgaunt(:,klj,ilam,ilbm,iLLm0-MM-1)
                               Endif
                               
                               ff(:)=alll*wfgaunt(:,klj,ilam,ilbm,iLLm0+MM)
                               ff(1)=ff(1)+MM*wfgaunt(2,klj,ilam,ilbm,iLLm0-MM)
                               ff(2)=ff(2)-MM*wfgaunt(1,klj,ilam,ilbm,iLLm0-MM)
                            Endif
                            If(MM==0)Then
                               ff(1)=ff(1)-cl2LL0*wpMp1(3)
                               ff(2)=ff(2)-cl2LL0*wpMm1(3)
                               ff(3)=ff(3)+cl2LL0*(wpMp1(1)+wpMm1(2))
                            Else If(MM==1)Then
                               ff(1)=ff(1)+cl2LL0*wpMm1(3)
                               ff(3)=ff(3)-cl2LL0*wpMm1(1)
                               If(LL>1)Then
                                  ff(1)=ff(1)-clLLMp*wpMp1(3)
                                  ff(2)=ff(2)-clLLMp*wmMm1(3)
                                  ff(3)=ff(3)+clLLMp*(wpMp1(1)+wmMm1(2))
                               Endif
                            Else If(MM==-1)Then
                               ff(2)=ff(2)+cl2LL0*wpMp1(3)
                               ff(3)=ff(3)-cl2LL0*wpMp1(2)
                               If(LL>1)Then
                                  ff(1)=ff(1)+clLLMm*wpMm1(3)
                                  ff(2)=ff(2)-clLLMm*wmMp1(3)
                                  ff(3)=ff(3)+clLLMm*(-wpMm1(1)+wmMp1(2))
                               Endif
                            Else
                               If(-LL<=MM-1)Then
                                  ff(1)=ff(1)+clLLMm*wpMm1(3)
                                  ff(2)=ff(2)-clLLMm*wmMp1(3)
                                  ff(3)=ff(3)+clLLMm*(-wpMm1(1)+wmMp1(2))
                               Endif
                               If(MM+1<=LL)Then
                                  ff(1)=ff(1)-clLLMp*wpMp1(3)
                                  ff(2)=ff(2)-clLLMp*wmMm1(3)
                                  ff(3)=ff(3)+clLLMp*(wpMp1(1)+wmMm1(2))
                               Endif
                            Endif
                            vv1=vv1+ff*p_ociLM(klj,ia,ib)&
                                 &/Sqrt(la*(la+1.0_t_real)*lb*(lb+1.0_t_real))
                         Enddo! klj
                         oci(:,ioci)=oci(:,ioci)+vv1
                      Endif
                   Enddo! mb
                Enddo! lb
             Enddo! ma
          Enddo! la



       Enddo ! isa
       
    Enddo! iLLm
    !!
    Return
    !!
  End Subroutine manipulate_OVO
  !!***********************************************************************
End Module loif
