!!TODO: save force integral
Module loiorg
  !!
  Use precisiondefs
  Use file_iounits
  Use memory
  Use tsymmetry
  Use torbitalbasis
  Use optionstest
  Use tio
  Use tloi
  Use tdiracdefs
  Use trelativistic
  Use loiaux
  !!
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="LOIORG"  
  !!
  Public :: setup_loint,alloc_loi,alloc_loi0,dump_loi,print_loi0s,print_lois
  !!***********************************************************************
Contains
  !!***********************************************************************
  !!  dimension anmd setup of LO-integral matrices 
  !!
  Subroutine setup_loint(mspin,structure,lattice&
       &,cblocklength,vblocklength&
       &,loi,relativistic)
    !!
    Implicit None
    !!     
    !!IO
    Integer(t_int),Intent(in)    :: relativistic
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Loi),Intent(inout)    :: loi
    Integer(t_int),Intent(in)    :: mspin
    Integer(t_int),Intent(in)    :: cblocklength(*)
    Integer(t_int),Intent(in)    :: vblocklength(*)
    !!LOCAL
    Character(*),Parameter::nsubfunc="setup_loint"
    Logical(t_log) :: rel,relmag
    Integer(t_int) :: isa,isb,ir,nva,nvb,nca,ncb,i,ivv,ivc
    Integer(t_int) :: ish,n,ne,nf,itcivv,itcivc,ndim,cdim
    Integer(t_int) :: iocivv,iocivc,iocicc
    !!
    !!
    !!
    Call palloc("loi% p_ociccindex",loi% p_ociccindex&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc("loi% p_ocivvindex",loi% p_ocivvindex&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc("loi% p_ocivcindex",loi% p_ocivcindex&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    !!
    !!
    Call palloc("loi% p_tcivvindex",loi% p_tcivvindex&
         &,1_t_int,Max(1_t_int,lattice% npairsmax)&
         &,1_t_int,structure% nsite&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    Call palloc("loi% p_tcivcindex",loi% p_tcivcindex&
         &,1_t_int,Max(1_t_int,lattice% npairsmax)&
         &,1_t_int,structure% nsite&
         &,1_t_int,structure% nsite&
         &,nmodule,nsubfunc)
    !!
    !!
    rel=(relativistic==FULL_RELATIVISTIC)
    relmag=(rel .And. mspin==2)
    !!
    
    !!
    !!
    !! prepare dimensions of the mapped and normal relativistic problem
    !!
    !!
    !! ocis
    loi% ociccdim=0_t_int
    loi% ocivvdim=0_t_int
    loi% ocivcdim=0_t_int
    iocicc=0_t_int
    iocivv=0_t_int
    iocivc=0_t_int
    !!  tcis
    loi% tcivvdim=0_t_int
    loi% tcivcdim=0_t_int 
    itcivv=0_t_int
    itcivc=0_t_int
    !!
    Do isa=1_t_int,structure% nsite
       !!
       !!
       nva=vblocklength(isa)
       nca=cblocklength(isa)
       !!
       !! core-core one center integrals
       i=nca**2
       loi% ociccdim=loi% ociccdim+i 
       loi% p_ociccindex(isa)=iocicc
       iocicc=iocicc+i
       !! valence-valence one center integrals
       i=nva**2
       loi% ocivvdim=loi% ocivvdim+i
       loi% p_ocivvindex(isa)=iocivv
       iocivv=iocivv+i
       !! core valence overlap
       i=nca*nva
       loi% ocivcdim=loi% ocivcdim+i
       loi% p_ocivcindex(isa)=iocivc
       iocivc=iocivc+i

       !! two center
       Do isb=1_t_int,structure% nsite
          !!
          !!

          nvb=vblocklength(isb)
          ncb=cblocklength(isb)
          !!
          !! valence-valence two center integrals
          !!
          ivv=nva*nvb
          ivc=nva*ncb
          !!
          loi% tcivvdim=loi% tcivvdim+ivv*lattice% p_npairs(isa,isb)
          loi% tcivcdim=loi% tcivcdim+ivc*lattice% p_npairs(isa,isb)
          !!
          !!
          !!
          n=0_t_int
          ishloop: Do ish=1_t_int,lattice% p_npshell(isa,isb)
             nf=n+1_t_int
             ne=n+lattice% p_ninpshell(ish,isa,isb)
             n=ne
             !!
             Do ir=nf,ne
                !!
                loi% p_tcivvindex(ir,isa,isb)=itcivv
                loi% p_tcivcindex(ir,isa,isb)=itcivc
                itcivv=itcivv+ivv
                itcivc=itcivc+ivc
             End Do
          End Do ishloop
       Enddo                  ! isb
    Enddo                     ! isa
    !!
    !!
    !!
    !! TODO: relat counting + correct counting
    !!
    ndim=2_t_int + mspin
    If(relmag)ndim=ndim + mspin
    cdim=1_t_int
    If(relmag)cdim=cdim + mspin
!!$    Write(outfile, 99) loi% ociccdim  * ( 1    * mspin +2 )
!!$    Write(outfile,100) loi% ocivvdim  * ndim
!!$    Write(outfile,101) loi% ocivcdim  * cdim
!!$    Write(outfile,102) loi% tcivvdim  * ndim
!!$    Write(outfile,103) loi% tcivcdim  * cdim
!99  Format('number of one-center cor-cor integrals: ',i12)
!100 Format('number of one-center         integrals: ',i12)
!101 Format('number of one center cor-val integrals: ',i12)
!102 Format('number of two-center         integrals: ',i12)
!103 Format('number of two center cor-val integrals: ',i12)
    !!
    !!
    !!
    Return
    !!
  End Subroutine setup_loint
  !!***********************************************************************
  !! START live time of LO-integrals
  !!
  Subroutine alloc_loi(loi,mspin,relativistic,nsite,nchismx,ncsmx,nvsmx&
       &,nchidim,need_sigma)
    !!
    Implicit None
    !!     
    !!IO
    Type(T_Loi),Intent(inout)    :: loi
    Logical(t_log),Intent(in)    :: need_sigma
    Integer(t_int),Intent(in)    :: nsite,nchismx,ncsmx,nvsmx,nchidim
    Integer(t_int),Intent(in)    :: relativistic,mspin
    !!LOCAL
    Character(*),Parameter::nsubfunc="alloc_loi"
    Logical(t_log) :: rel, relmag
    Integer(t_int) :: ndim
    !!
    ndim=ncsmx! avoid warning
    rel=(relativistic==FULL_RELATIVISTIC)
    relmag=(rel .And. mspin==2)
    !!
    !!
    If(rel)Then
       Call palloc("loi% p_roci_cHc",loi% p_roci_cHc&
            &,1_t_int,loi% ociccdim&
            &,nmodule,nsubfunc)
    Else
       Call palloc("loi% p_oci_cHc",loi% p_oci_cHc&
            &,1_t_int,loi% ociccdim&
            &,1_t_int,mspin &
            &,nmodule,nsubfunc)
    Endif
    !!
    If(rel)Then
       Call palloc("loi% p_roci_vHv",loi% p_roci_vHv&
            &,1_t_int,loi% ocivvdim&
            &,nmodule,nsubfunc)
    Else
       Call palloc("loi% p_oci_vHv",loi% p_oci_vHv&
            &,1_t_int,loi% ocivvdim&
            &,1_t_int,mspin  &
            &,nmodule,nsubfunc)
    Endif
    !!
    If(rel)Then
       Call palloc("loi% p_roci_vHc",loi% p_roci_vHc&
            &,1_t_int,loi% ocivcdim&
            &,nmodule,nsubfunc)
    Else
       Call palloc("loi% p_oci_vHc",loi% p_oci_vHc&
            &,1_t_int,loi% ocivcdim&
            &,1_t_int,mspin  &
            &,nmodule,nsubfunc)
    Endif

    

    If(rel) Then
       Call palloc("loi% p_rtci_vHv",loi% p_rtci_vHv,1_t_int,loi% tcivvdim&
            &,nmodule,nsubfunc)
    Else
       Call palloc("loi% p_tci_vHv",loi% p_tci_vHv,1_t_int,loi% tcivvdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
    Endif

    If(rel) Then
       Call palloc("loi% p_rtci_vHc",loi% p_rtci_vHc,1_t_int,loi% tcivcdim&
            &,nmodule,nsubfunc)
    Else
       Call palloc("loi% p_tci_vHc",loi% p_tci_vHc,1_t_int,loi% tcivcdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
    Endif

    ndim=1
    If(relmag)ndim=loi% tcivcdim
    
    If(rel)Then
       Call palloc("loi% p_roci_vchi",loi% p_roci_vchi,1_t_int,loi% ocivcdim&
            &,nmodule,nsubfunc)
       Call palloc("loi% p_rtci_vchi",loi% p_rtci_vchi,1_t_int,loi% tcivcdim&
            &,nmodule,nsubfunc)
       Call palloc("loi% p_roci_vHchi",loi% p_roci_vHchi,1_t_int,loi% ocivcdim&
            &,nmodule,nsubfunc)
       Call palloc("loi% p_rtci_vHchi",loi% p_rtci_vHchi,1_t_int,loi% tcivcdim&
            &,nmodule,nsubfunc)
       Call palloc("loi% p_rtci_vbSchi",loi% p_rtci_vbSchi,1_t_int,ndim&
            &,nmodule,nsubfunc)
       If(relmag)Then
          Call palloc("loi% p_vbSchi",loi% p_vbSchi,1_t_int,nvsmx,1_t_int&
               &,nchismx,1_t_int,nsite,nmodule,nsubfunc)
          Call palloc("loi% p_chibSchi",loi% p_chibSchi,1_t_int,nchismx,1_t_int&
               &,nchismx,1_t_int,nsite,nmodule,nsubfunc)
          Call palloc('loi% p_cspchar',loi% p_cspchar,1_t_int,nchidim&
               &,nmodule,nsubfunc)
       Else
          Call palloc('loi% p_cspchar',loi% p_cspchar,1_t_int,1_t_int&
               &,nmodule,nsubfunc)
          Call palloc("loi% p_chibSchi",loi% p_chibSchi,1_t_int,1_t_int,1_t_int&
               &,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
          Call palloc("loi% p_vbSchi",loi% p_vbSchi,1_t_int,1_t_int&
               &,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
       Endif
       If(need_sigma)Then
          Call palloc("loi% p_chibVSchi",loi% p_chibVSchi,1_t_int,nchismx,1_t_int&
               &,nchismx,1_t_int,nsite,1_t_int,3_t_int,nmodule,nsubfunc)
          Call palloc("loi% p_vbVSchi",loi% p_vbVSchi,1_t_int,nvsmx,1_t_int&
               &,nchismx,1_t_int,nsite,1_t_int,3_t_int,nmodule,nsubfunc)
          Call palloc("loi% p_rtci_vbVSchi",loi% p_rtci_vbVSchi,1_t_int,loi% tcivcdim&
               &,1_t_int,3_t_int,nmodule,nsubfunc)
       Else
          Call palloc("loi% p_chibVSchi",loi% p_chibVSchi,1_t_int,1_t_int,1_t_int&
               &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
          Call palloc("loi% p_vbVSchi",loi% p_vbVSchi,1_t_int,1_t_int,1_t_int&
               &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
          Call palloc("loi% p_rtci_vbVSchi",loi% p_rtci_vbVSchi,1_t_int,1_t_int&
               &,1_t_int,1_t_int,nmodule,nsubfunc)
       Endif
       Call palloc("loi% p_roci_vcraw",loi% p_roci_vcraw,1_t_int,loi% ocivcdim&
            &,nmodule,nsubfunc)
       Call palloc("loi% p_rtci_vcraw",loi% p_rtci_vcraw,1_t_int,loi% tcivcdim&
            &,nmodule,nsubfunc)

    Else

       Call palloc("loi% p_oci_vchi",loi% p_oci_vchi,1_t_int,loi% ocivcdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
       Call palloc("loi% p_tci_vchi",loi% p_tci_vchi,1_t_int,loi% tcivcdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
       Call palloc("loi% p_oci_vHchi",loi% p_oci_vHchi,1_t_int,loi% ocivcdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
       Call palloc("loi% p_tci_vHchi",loi% p_tci_vHchi,1_t_int,loi% tcivcdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
       Call palloc("loi% p_oci_vcraw",loi% p_oci_vcraw,1_t_int,loi% ocivcdim&
            &,1_t_int,mspin,nmodule,nsubfunc)
       Call palloc("loi% p_tci_vcraw",loi% p_tci_vcraw,1_t_int,loi% tcivcdim&
            &,1_t_int,mspin,nmodule,nsubfunc)

    Endif
    

    Return
    !!
  End Subroutine alloc_loi
  !!***********************************************************************
  Subroutine alloc_loi0(loi,mspin,nsite,relativistic,ncsmx,nvsmx,need_sigma)
    !!
    Implicit None
    !!     
    !!IO
    Type(T_Loi),Intent(inout)    :: loi
    Logical(t_log),Intent(in)    :: need_sigma
    Integer(t_int),Intent(in)    :: mspin,ncsmx,nvsmx,nsite
    Integer(t_int),Intent(in)    :: relativistic
    !!LOCAL
    Character(*),Parameter::nsubfunc="alloc_loi0"
    Logical(t_log) :: rel,relmag
    Integer(t_int) :: ndim
    !!
    rel=(relativistic == FULL_RELATIVISTIC)
    relmag=(rel .And. mspin==2)

    !!
    Call palloc("loi% p_oci_cc0",loi% p_oci_cc0&
         &,1_t_int,loi% ociccdim ,nmodule,nsubfunc)
    Call palloc("loi% p_oci_cHc0",loi% p_oci_cHc0&
         &,1_t_int,loi% ociccdim ,nmodule,nsubfunc)
    !!
    If(rel)Then
       Call palloc("loi% p_vbSc0",loi% p_vbSc0&
            &,1_t_int,nvsmx,1_t_int,ncsmx,1_t_int,nsite,nmodule,nsubfunc)
       Call palloc("loi% p_vbSv0",loi% p_vbSv0&
            &,1_t_int,nvsmx,1_t_int,nvsmx,1_t_int,nsite,nmodule,nsubfunc)
       Call palloc("loi% p_cbSc0",loi% p_cbSc0&
            &,1_t_int,ncsmx,1_t_int,ncsmx,1_t_int,nsite,nmodule,nsubfunc)
    Else
       Call palloc("loi% p_vbSc0",loi% p_vbSc0&
            &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
       Call palloc("loi% p_vbSv0",loi% p_vbSv0&
            &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
       Call palloc("loi% p_cbSc0",loi% p_cbSc0&
            &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
    Endif
    !!
    If(need_sigma)Then
       Call palloc("loi% p_vbVSc0",loi% p_vbVSc0&
            &,1_t_int,nvsmx,1_t_int,ncsmx,1_t_int,nsite&
            &,1_t_int,3_t_int,nmodule,nsubfunc)
       Call palloc("loi% p_vbVSv0",loi% p_vbVSv0&
            &,1_t_int,nvsmx,1_t_int,nvsmx,1_t_int,nsite&
            &,1_t_int,3_t_int,nmodule,nsubfunc)
       Call palloc("loi% p_cbVSc0",loi% p_cbVSc0&
            &,1_t_int,ncsmx,1_t_int,ncsmx,1_t_int,nsite&
            &,1_t_int,3_t_int,nmodule,nsubfunc)
    Else
       Call palloc("loi% p_vbVSc0",loi% p_vbVSc0&
            &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
       Call palloc("loi% p_vbVSv0",loi% p_vbVSv0&
            &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
       Call palloc("loi% p_cbVSc0",loi% p_cbVSc0&
            &,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int,1_t_int&
            &,nmodule,nsubfunc)
    Endif
    !!
    Call palloc("loi% p_oci_vc0",loi% p_oci_vc0&
         &,1_t_int,loi% ocivcdim ,nmodule,nsubfunc)
    Call palloc("loi% p_oci_vHc0",loi% p_oci_vHc0&
         &,1_t_int,loi% ocivcdim ,nmodule,nsubfunc)
    Call palloc("loi% p_oci_vHv0",loi% p_oci_vHv0&
         &,1_t_int,loi% ocivvdim,nmodule,nsubfunc)
    Call palloc("loi% p_oci_vv0",loi% p_oci_vv0&
         &,1_t_int,loi% ocivvdim,nmodule,nsubfunc)
    !!
    If(rel)Then
       ndim=1
       If(relmag)ndim=loi% tcivvdim
       
       Call palloc("loi% p_rtci_vbSv0",loi% p_rtci_vbSv0&
            &,1_t_int,ndim,nmodule,nsubfunc)

       ndim=1
       If(relmag)ndim=loi% tcivcdim
       
       Call palloc("loi% p_rtci_vbSc0",loi% p_rtci_vbSc0&
            &,1_t_int,ndim,nmodule,nsubfunc)
       
       Call palloc("loi% p_rtci_vv0",loi% p_rtci_vv0&
            &,1_t_int,loi% tcivvdim,nmodule,nsubfunc)
       Call palloc("loi% p_rtci_vHv0",loi% p_rtci_vHv0&
            &,1_t_int,loi% tcivvdim,nmodule,nsubfunc)
       Call palloc("loi% p_rtci_vc0",loi% p_rtci_vc0&
            &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)
       Call palloc("loi% p_rtci_vHc0",loi% p_rtci_vHc0&
            &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)
    Else
       Call palloc("loi% p_tci_vv0",loi% p_tci_vv0&
            &,1_t_int,loi% tcivvdim,nmodule,nsubfunc)
       Call palloc("loi% p_tci_vHv0",loi% p_tci_vHv0&
            &,1_t_int,loi% tcivvdim,nmodule,nsubfunc)
       Call palloc("loi% p_tci_vc0",loi% p_tci_vc0&
            &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)
       Call palloc("loi% p_tci_vHc0",loi% p_tci_vHc0&
            &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)
    Endif
    !!
    If(need_sigma)Then
       Call palloc("loi% p_rtci_vbVSv0",loi% p_rtci_vbVSv0&
            &,1_t_int,loi% tcivvdim,1_t_int,3_t_int,nmodule,nsubfunc)
       Call palloc("loi% p_rtci_vbVSc0",loi% p_rtci_vbVSc0&
            &,1_t_int,loi% tcivcdim,1_t_int,3_t_int,nmodule,nsubfunc)
    Else
       Call palloc("loi% p_rtci_vbVSv0",loi% p_rtci_vbVSv0&
            &,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
       Call palloc("loi% p_rtci_vbVSc0",loi% p_rtci_vbVSc0&
            &,1_t_int,1_t_int,1_t_int,1_t_int,nmodule,nsubfunc)
    Endif
    !!
    Return
    !!
  End Subroutine alloc_loi0
  !!***********************************************************************
  !! dump thci-lois onto disk .... for debugging runs
  !!
  Subroutine dump_loi(loi,rel,mspin,mode)
    !!
    Implicit none  
    !!IO
    Type(T_Loi),Intent(inout)    :: loi
    Logical(t_log),Intent(in)    :: rel
    Character(*),Intent(in)      :: mode
    Integer(t_int),Intent(in)    :: mspin
    !!LOCAL
    !Character(*),Parameter::nsubfunc="dump_loi"
    Integer(t_int) :: i,ms
    !!
    !!
    !!
    !!
    If(Trim(mode) == 'write')Then
       !!
       Open(12,file=f_loi_dump,form='UNFORMATTED')
       If(rel) Then
          Do i=1_t_int,loi% ociccdim
             Write(12) loi% p_roci_cHc(i)
          Enddo
          Do i=1_t_int,loi% ocivvdim
             Write(12) loi% p_roci_vHv(i)
          Enddo
          Do i=1_t_int,loi% ocivcdim
             Write(12) loi% p_roci_vHc(i)
          enddo
          Do i=1_t_int,loi% tcivvdim
             Write(12) loi% p_rtci_vHv(i)
          Enddo
          Do i=1_t_int,loi% tcivcdim
             Write(12) loi% p_rtci_vHc(i)
          Enddo
       Else
          Do ms=1,mspin
             Do i=1_t_int,loi% ociccdim
                Write(12) loi% p_oci_cHc(i,ms)
             Enddo
             Do i=1_t_int,loi% ocivvdim
                Write(12) loi% p_oci_vHv(i,ms)
             Enddo
             Do i=1_t_int,loi% ocivcdim
                Write(12) loi% p_oci_vHc(i,ms)
             Enddo
             Do i=1_t_int,loi% tcivvdim
                Write(12) loi% p_tci_vHv(i,ms)
             Enddo
             Do i=1_t_int,loi% tcivcdim
                Write(12) loi% p_tci_vHc(i,ms)
             Enddo
          Enddo ! ms
       Endif
       Close(12)
    Else
       Open(12,file=f_loi_dump,status='old',form='UNFORMATTED')
       If(rel) Then
          Do i=1_t_int,loi% ociccdim
             Read(12) loi% p_roci_cHc(i)
          Enddo
          Do i=1_t_int,loi% ocivvdim
             Read(12) loi% p_roci_vHv(i)
          Enddo
          Do i=1_t_int,loi% ocivcdim
             Read(12) loi% p_roci_vHc(i)
          enddo
          Do i=1_t_int,loi% tcivvdim
             Read(12) loi% p_rtci_vHv(i)
          Enddo
          Do i=1_t_int,loi% tcivcdim
             Read(12) loi% p_rtci_vHc(i)
          Enddo
       Else
          Do ms=1,mspin
             Do i=1_t_int,loi% ociccdim
                Read(12) loi% p_oci_cHc(i,ms)
             Enddo
             Do i=1_t_int,loi% ocivvdim
                Read(12) loi% p_oci_vHv(i,ms)
             Enddo
             Do i=1_t_int,loi% ocivcdim
                Read(12) loi% p_oci_vHc(i,ms)
             Enddo
             Do i=1_t_int,loi% tcivvdim
                Read(12) loi% p_tci_vHv(i,ms)
             Enddo
             Do i=1_t_int,loi% tcivcdim
                Read(12) loi% p_tci_vHc(i,ms)
             Enddo
          Enddo ! ms
       Endif
       Close(12)
    Endif
    !!
    !!
    Return
    !!
  End Subroutine dump_loi
  !!***********************************************************************
  !! debugging routine, only non-rel in the moment
  !!
  Subroutine print_loi0s(nsite,lattice,cblocklength,vblocklength,loi)
    !!
    Implicit None
    !!IO
    Type(T_Lattice),Intent(in)   :: lattice
    Integer(t_int),Intent(in)    :: nsite
    Integer(t_int),Intent(in)    :: cblocklength(*),vblocklength(*)
    Type(T_Loi),Intent(inout)    :: loi
    !!LOCAL
    !Character(*),Parameter::nsubfunc="print_loi0s"
    Real(t_real),Parameter :: tol=1.0e-10_t_real
    Character(*),Parameter   :: fmt="(f12.5,2x)"
    Character(*),Parameter   :: fmt0="('       0      ')"
    !!
    !! ###########################################
    !!   OCI S
    !! ###########################################
    !!
    Write(outfile,*)'OCI Scc0 '
    Call print_oci("Scc",nsite,cblocklength,cblocklength&
         &,fmt,fmt0,loi% p_oci_cc0(:),tol&
         &,loi% p_ociccindex)
    Write(outfile,*)
    !!
    Write(outfile,*)'OCI Svc0 '
    Call print_oci("Svc",nsite,vblocklength,cblocklength&
         &,fmt,fmt0,loi% p_oci_vc0(:),tol&
         &,loi% p_ocivcindex)
    Write(outfile,*)
    !!
    Write(outfile,*)'OCI Svv0 '
    Call print_oci("Svv",nsite,vblocklength,vblocklength&
         &,fmt,fmt0,loi% p_oci_vv0(:),tol&
         &,loi% p_ocivvindex)
    Write(outfile,*)
    !!
    !! ###########################################
    !!   OCI H
    !! ###########################################
    !!
    Write(outfile,*)'OCI Hcc0 '
    Call print_oci("Hcc",nsite,cblocklength,cblocklength&
         &,fmt,fmt0,loi% p_oci_cHc0(:),tol&
         &,loi% p_ociccindex)
    Write(outfile,*)
    !!
    Write(outfile,*)'OCI Hvc0 '
    Call print_oci("Hvc",nsite,vblocklength,cblocklength&
         &,fmt,fmt0,loi% p_oci_vHc0(:),tol&
         &,loi% p_ocivcindex)
    Write(outfile,*)
    !!
    Write(outfile,*)'OCI Hvv0 '
    Call print_oci("Hvv",nsite,vblocklength,vblocklength&
         &,fmt,fmt0,loi% p_oci_vHv0(:),tol&
         &,loi% p_ocivvindex)
    Write(outfile,*)
    !!
    !! ###########################################
    !!   TCI S
    !! ###########################################
    !!
    !!
    Write(outfile,*)'TCI Svc0 '
    Call print_tci("Svc",nsite,vblocklength,cblocklength&
         &,fmt,fmt0,loi% p_tci_vc0(:)&
         &,loi% p_tcivcindex,lattice% p_npairs,lattice% p_pairs,tol)
    Write(outfile,*)
    !!
    Write(outfile,*)'TCI Svv0 '
    Call print_tci("Svv",nsite,vblocklength,vblocklength&
         &,fmt,fmt0,loi% p_tci_vv0(:)&
         &,loi% p_tcivvindex,lattice% p_npairs,lattice% p_pairs,tol)
    Write(outfile,*)
    !!
    !!
    !! ###########################################
    !!   TCI H
    !! ###########################################
    !!
    Write(outfile,*)'TCI Hvc0 '
    Call print_tci("Hvc",nsite,vblocklength,cblocklength&
         &,fmt,fmt0,loi% p_tci_vHc0(:)&
         &,loi% p_tcivcindex,lattice% p_npairs,lattice% p_pairs,tol)
    Write(outfile,*)
    !!
    !!
    Write(outfile,*)'TCI Hvv0 '
    Call print_tci("Hvv",nsite,vblocklength,vblocklength&
         &,fmt,fmt0,loi% p_tci_vHv0(:)&
         &,loi% p_tcivvindex,lattice% p_npairs,lattice% p_pairs,tol)
    Write(outfile,*)
    !!
    !!
    !!
    Return
    !!
  End Subroutine print_loi0s
  !!***********************************************************************
  !! debugging routine, only non-rel in the moment
  !!
  Subroutine print_lois(mspin,nsite,lattice,cblocklength,vblocklength,loi)
    !!
    Implicit None
    !!IO
    Type(T_Lattice),Intent(in)   :: lattice
    Integer(t_int),Intent(in)    :: mspin,nsite
    Integer(t_int),Intent(in)    :: cblocklength(*),vblocklength(*)
    Type(T_Loi),Intent(inout)    :: loi
    !!LOCAL
    !Character(*),Parameter::nsubfunc="print_lois"
    Integer(t_int) :: ms
    Real(t_real),Parameter :: tol=1.0e-10_t_real
    Character(*),Parameter   :: fmt="(f12.5,2x)"
    Character(*),Parameter   :: fmt0="('       0      ')"
    !!
    !!
    !! ###########################################
    !!   OCI H
    !! ###########################################
    !!
    Do ms=1,mspin
       Write(outfile,*)'OCI Hcc spin=',ms
       Call print_oci("Hcc",nsite,cblocklength,cblocklength&
            &,fmt,fmt0,loi% p_oci_cHc(:,ms),tol&
            &,loi% p_ociccindex)
       Write(outfile,*)
       !!
       Write(outfile,*)'OCI Hvc spin=',ms
       Call print_oci("Hvc",nsite,vblocklength,cblocklength&
            &,fmt,fmt0,loi% p_oci_vHc(:,ms),tol&
            &,loi% p_ocivcindex)
       Write(outfile,*)
       !!
       Write(outfile,*)'OCI Hvv spin=',ms
       Call print_oci("Hvv",nsite,vblocklength,vblocklength&
            &,fmt,fmt0,loi% p_oci_vHv(:,ms),tol&
            &,loi% p_ocivvindex)
       Write(outfile,*)
    Enddo
    !!
    !!
    !!
    !! ###########################################
    !!   TCI H
    !! ###########################################
    !!
    Do ms=1,mspin
       Write(outfile,*)'TCI Hvc spin=',ms
       Call print_tci("Hvc",nsite,vblocklength,cblocklength&
            &,fmt,fmt0,loi% p_tci_vHc(:,ms)&
            &,loi% p_tcivcindex,lattice% p_npairs,lattice% p_pairs,tol)
       Write(outfile,*)
       !!
       !!
       Write(outfile,*)'TCI Hvv spin=',ms
       Call print_tci("Hvv",nsite,vblocklength,vblocklength&
            &,fmt,fmt0,loi% p_tci_vHv(:,ms)&
            &,loi% p_tcivvindex,lattice% p_npairs,lattice% p_pairs,tol)
       Write(outfile,*)
    Enddo
    !!
    !!
    !!
    Return
    !!
  End Subroutine print_lois
  !!***********************************************************************
End Module loiorg

