Module mol
  !!
  Use precisiondefs
  Use memory
  Use file_iounits
  Use errors
  Use tsymmetry
  Use constants
  Use clock
  Use optionstest
  Use tpotentialdensity
  Use atomdefs
  Use basdef
  Use finuc
  Use trelativistic
  Use diagonalize
  Use titeration
  Use iteration
  Use tatom
  Use diracdata
  Use dump
  Use diracdriver
  Use diracpotorb
  Use diracio
  Use tnumerics
  Use xc
  Use integrate1d
  Use shape
  Use tmesh
  Use mesh
  Use tkohnsham
  Use torbitalbasis
  Use tmol
  Use tloi
  Use mesh
  Use nsphintirred
  Use matserv
  Use prnt
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="MOL"  
  !!
  Public :: molinit
  !!***********************************************************************
  Character(*),Parameter :: fmtstart=&
       &"(/,/,'============================== START ',a&
       &,'============================== ')"
  Character(*),Parameter :: fmtend=&
       &"('============================== END   ',a&
         &,'============================== ',/,/)"
  !!
Contains
  !!***********************************************************************
  Subroutine molinit(mspin,symmetry,structure,lattice,basmeshs,mol)
    !!
    Implicit None  
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Mesh),Pointer         :: basmeshs(:)
    Type(T_Mol),Intent(inout)    :: mol
    Integer(t_int),Intent(in)    :: mspin
    !!LOCAL
    Character(*),Parameter::nsubfunc="molinit"
    Integer(t_int) :: ir,isa,issa,im,ig,count,count0,nvg
    Logical(t_log) :: success
    Real(t_real)   :: d,ri,wi,wg,d0,ww,sumwg
    Real(t_real)   :: ff
    Real(t_real)   :: rsh(3)
    Real(t_real),Pointer   :: p_rmesh(:),p_cc(:)
    Integer(t_int) :: vnga
    Real(t_real)   :: vag(3,2000)
    Real(t_real)   :: vwg(2000)
    Type(T_Mesh),Pointer :: bmesh
    !!
    !!
    Nullify(p_cc)
    Nullify(p_rmesh)
    !!
    Write(outfile,fmtstart)nsubfunc    
    !!
    !!
    !!
    !!
    !!
    !!
    Call palloc('p_rmesh',p_rmesh,1_t_int,mol% rad_nr, nmodule,nsubfunc)
    Call palloc('p_cc'   ,p_cc   ,1_t_int,mol% rad_nr, nmodule,nsubfunc)
    !!
    !!
    Call reduced_sph_mesh(symmetry,mol% irredmesh,mol% t_angmesh_max&
         &,vnga,vag,vwg,symmetry% reduced_sym)

    !!
    mol% maxpnts=vnga*mol% rad_nr !! TODO: flexible
    Call palloc('mol% p_wm',mol% p_wm&
         &,1_t_int,mol% maxpnts&
         &,1_t_int,structure% nsite&
         &, nmodule,nsubfunc)
    Call palloc('mol% p_rindxm',mol% p_rindxm&
         &,1_t_int,mol% maxpnts&
         &,1_t_int,structure% nsite&
         &, nmodule,nsubfunc)
    Call palloc('mol% p_rm',mol% p_rm&
         &,1_t_int,3_t_int&
         &,1_t_int,mol% maxpnts&
         &,1_t_int,structure% nsite&
         &, nmodule,nsubfunc)
    Call palloc('mol% p_nm',mol% p_nm&
         &,1_t_int,structure% nsite&
         &, nmodule,nsubfunc)
    Call palloc('mol% p_wgm',mol% p_wgm&
         &,1_t_int,mol% maxpnts&
         &,1_t_int,structure% nsite&
         &, nmodule,nsubfunc)
    Call palloc('mol% p_vm2',mol% p_vm2&
         &,1_t_int,mspin&
         &,1_t_int,mol% maxpnts&
         &,1_t_int,structure% nsite&
         &, nmodule,nsubfunc)
    !!
    If(dumpread(DUMP_MOLINIT))Then
       success=dumpmolinit(mol,structure% nsite,'read')
       If(success)Then
          gdump(DUMP_MOLINIT)% doread=.False.
          Goto 1000
       Endif
    Endif
    !!
    count=0
    count0=0
    isaloop: Do isa=1,structure% nsite
       Write(outfile,"('isa=',i4)") isa
       !!
       issa=structure% p_isrt(isa)
       !!
       bmesh => basmeshs(issa)
       !!
       Call gaus_rad_mesh(mol% rad_nr,bmesh% rmin,bmesh% rmax,p_rmesh,p_cc)
       !!
       im=0_t_int
       irloop: Do ir=1,mol% rad_nr
          !Print *,'ir=',ir,mol% rmesh% nr
          ri=p_rmesh(ir)
          wi=p_cc(ir)*ri**2
          !!
          sumwg=0.0_t_real
          If(ir==1)Then 
             ig=1
             rsh(:)=0.0_t_real
             wg=fourpi
             sumwg=sumwg+wg
             ff=cheese_shape(rsh,isa,structure% nsite&
                  &,structure% p_isrt,structure% p_rcompsup&
                  &,lattice% p_npshell,lattice% p_ninpshell&
                  &,lattice% p_pairabs,lattice% p_pairs,lattice% p_rsite)

             !!
             ww=ff*wg
             im=im+1_t_int
             mol% p_rm(:,im,isa)=rsh(:)
             mol% p_wm(im,isa)=ww*wi
             mol% p_rindxm(im,isa)=ir
             mol% p_wgm(im,isa)=wg
             count=count+1
             count0=count0+1
          Else 
             !!
             !!
             If(ri<=mol% r_angmesh_1)Then
                nvg=mol% t_angmesh_1 
             Else If(ri>=mol% r_angmesh_max)Then
                nvg=mol% t_angmesh_max
             Else
                nvg=Nint( (Log(ri)-Log(mol% r_angmesh_1))&
                     &/(Log(mol% r_angmesh_max)-Log(mol% r_angmesh_1))&
                     &*(mol% t_angmesh_max-mol% t_angmesh_1 )&
                     &+mol% t_angmesh_1 )
             Endif
             Call reduced_sph_mesh(symmetry,mol% irredmesh,nvg,vnga,vag,vwg&
                  &,symmetry% reduced_sym)

             !!
             !Print *,'ri=',ri,' vnga=',vnga,' nvg=',nvg
             angloop: Do ig=1,vnga
                rsh(:)=ri*vag(:,ig)
                wg=vwg(ig)
                sumwg=sumwg+wg
                !!
                ff=cheese_shape(rsh,isa,structure% nsite&
                     &,structure% p_isrt,structure% p_rcompsup&
                     &,lattice% p_npshell,lattice% p_ninpshell&
                     &,lattice% p_pairabs,lattice% p_pairs,lattice% p_rsite)
                !!
                !!
                ww=ff*wg
                !Print *,'ig=',ig,' ff=',ff,' wg=',wg

                If(ww*wi /=0.0_t_real)Then 
                   im=im+1_t_int
                   mol% p_rm(:,im,isa)=rsh(:)
                   mol% p_wm(im,isa)=ww*wi
                   mol% p_rindxm(im,isa)=ir
                   mol% p_wgm(im,isa)=wg
                   count=count+1
                Else
                   count0=count0+1
                Endif
             End Do angloop
          Endif
          !Print *,'sumwg: ir=',im,ri,sumwg/fourpi,wi
       Enddo irloop
       mol% p_nm(isa)=im
    End Do isaloop
    !!
    If(dumpwrite(DUMP_MOLINIT)) success=dumpmolinit(mol,structure% nsite,'write')
    !!
    !!
    Write(outfile,23) count
    Write(outfile,24) count0
23  Format('Total number of irreducible points: ',i6)
24  Format('Total number of skipped     points: ',i6)
    !!
    d0=0.0_t_real
    Do isa=1,structure% nsite
       d=0.0_t_real
       Do im=1,mol% p_nm(isa)
          rsh(:)=mol% p_rm(:,im,isa)
          !!ra=Sqrt(Dot_product(rsh,rsh))
          ww=mol% p_wm(im,isa)
          ff=1.0_t_real
          d=d+ff*ww
          !Print *,'im=',im,' ra=',ra,' ww=',ww
             
       Enddo
       d0=d0+d
    Enddo
    !Print *,' vux num,ex,rel=',d0,structure% vuc,(d0-structure% vuc)/structure% vuc
    !!
1000 Continue
    !!
    Call pfree(p_cc)
    Call pfree(p_rmesh)
    !!
    !!
    !!
    Write(outfile,fmtend)nsubfunc
    !!
    !!
    Return
    !!
    !!
  End Subroutine molinit
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine symstuff(symmetry)
    !!
    Implicit None  
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry  
    !!LOCAL
    !Character(*),Parameter::nsubfunc="symstuff"
    Integer(t_int) :: jops,i,j,kinv,l,m
    !Integer(t_int),Parameter  :: in(3)=(/3_t_int,1_t_int,2_t_int/)
    Real(t_real)   :: eu(3),b(3,3),fac(0:2*12),DR(3,3),yr(100),rD(3),yrD(100)
    Real(t_real)   :: nx(3),nz(3),PPi(3,3),r(3),ylm(169)
    Real(t_real)   :: wu1(2*1+1,2*1+1),wu(7*7)
    Real(t_real)   :: rdum(3)
    !!
    !!
    Call make_factorials(fac,2*12_t_int)
    !!
    !!
    !!

    
    !!
    Do jops=1,symmetry% Rnumops
       !!TODO: test equivsites
       !!
       !!
       Write(outfile,1) symmetry% Ropsymbol(jops)
       Do i=1,3
          If(i==1)Then
             Write(outfile,3) (symmetry% Ropmat(i,j,jops),j=1,3)&
                  &,symmetry% Roptau(1:3,jops)
          Else
             Write(outfile,31) (symmetry% Ropmat(i,j,jops),j=1,3)
          Endif
       End Do
       !!
       kinv=symmetry% opeulerinv(symmetry% Ropind(jops))
       eu=symmetry% opeuler(:,symmetry% Ropind(jops))
       !!
       Call write_euler(eu) 
       Call m_euler(DR,eu)
       !!
       !!
       Call ytr(eu,kinv,fac,1_t_int,b,.True.)
       !!
       
       !!

       Write(outfile,"(/,/,/)")
       If(jops==15) Stop
    Enddo
    !!
    Return
    !! build orthogonal new z and x axes
    !!
    !!
    !!
    PPi(:,1)=(/ 0.0_t_real , 1.0_t_real , 0.0_t_real /)
    PPi(:,2)=(/ 0.0_t_real , 0.0_t_real , 1.0_t_real /)
    PPi(:,3)=(/ 1.0_t_real , 0.0_t_real , 0.0_t_real /)
    Do i=1,3 
       Write(outfile,35) (PPi(i,j),j=1,3) 
    End Do
    !!
    !!
    nz(:)=(/ 0.1_t_real , 0.2_t_real ,-0.3_t_real /)
    nz=nz/Sqrt(Dot_product(nz,nz))
    Print *,'|nz|=',Dot_product (nz,nz)
    nx(:)=(/ 5.0_t_real ,-6.0_t_real , 9.0_t_real /)
    nx=nx-Dot_product(nx,nz)*nz
    nx=nx/Sqrt(Dot_product(nx,nx))
    Print *,'|nx|=',Dot_product (nx,nx)
    Print *,'(nx|nz)=',Dot_product (nx,nz)
    !!
    !! calcualte euler angles in the definition
    !!
    !!  E^{new}= \hat{D}(al,be,ga) E^{old}= E^{old} DR(al,be,ga) 
    !!
    Call reuler2(nz,nx,eu)
    Call write_euler(eu)
    !! calculate DR(al,be,ga) 
    Call m_euler(DR,eu)
    Do i=1,3 
       Write(outfile,34) (DR(i,j),j=1,3) 
    End Do
    !!
    Print *,'0x=',nx-Matmul(DR(:,:),(/ 1.0_t_real , 0.0_t_real , 0.0_t_real/))
    Print *,'0z=',nz-Matmul(DR(:,:),(/ 0.0_t_real , 0.0_t_real , 1.0_t_real/))
    !!
    Print *
    r=(/ 0.23_t_real , 3.5_t_real , -8.91_t_real /)
    r=r/Sqrt(Dot_product(r,r))
    Write(outfile,36) (r(j),j=1,3) 
    !!
    !! 
    rD=Matmul(r,DR)
    Write(outfile,37) (rD(j),j=1,3) 
    !!
    !!
    l=1
    kinv=0
    Call ytr(eu,kinv,fac,1_t_int,wu1,.False.)
    Call ytr(eu,kinv,fac,l,wu,.False.)
    !!
    !!
    b=Matmul(PPi,Matmul(Transpose(wu1),Transpose(PPi)))
    Do i=1,3
       Write(outfile,40) (b(i,j),j=1,3)
    End Do

    !!
    !! Y(r)
    Call ylms12(ylm,r(1),r(2),r(3),12_t_int)
    Do m=-l,l
       yr(m+l+1)=ylm(l*l+m+l+1)
    Enddo
    !! Y(r.D)=Y(r).D
    Call ylms12(ylm,rD(1),rD(2),rD(3),12_t_int)
    Do m=-l,l
       yrD(m+l+1)=ylm(l*l+m+l+1)
    Enddo
    !!
    !!
    rdum=Sqrt(3.0_t_real/fourpi)*Matmul(r,PPi)
    Do i=1,2*l+1
       Write(outfile,14) l,i-l-1,yr(i)-rdum(i)
14     Format('Y_',i1,i2,'(r)',f12.7)
    Enddo
    rdum=Sqrt(3.0_t_real/fourpi)*Matmul(rD,PPi)
    Do i=1,2*l+1
       Write(outfile,15) l,i-l-1,yrD(i)-rdum(i)
15     Format('Y_',i1,i2,'(rD)',f12.7)
    Enddo
    !!
    !!
    !!
    Do i=1,2*l+1
       rdum(i)=0.0_t_real
       Do j=1,2*l+1
          rdum(i)=rdum(i)+yr(j)*wu(i+(j-1)*(2*l+1))
       Enddo
    Enddo
    !rdum=Matmul(yr(1:2*l+1),Transpose(wu1))
    Do i=1,2*l+1
       Write(outfile,16) l,i-l-1,yrD(i)-rdum(i)
16     Format('Y_',i1,i2,'(r)D',f12.7)
    Enddo
    !!
    !!
    !Print *,'xPPi=',Matmul((/ 1.0_t_real , 0.0_t_real , 0.0_t_real/),PPi)
    !Print *,'yPPi=',Matmul((/ 0.0_t_real , 1.0_t_real , 0.0_t_real/),PPi)
    !Print *,'zPPi=',Matmul((/ 0.0_t_real , 0.0_t_real , 1.0_t_real/),PPi)
    !!
    Return
    !!
3   Format('O: ',3(f10.4,1x),' : ',3(f10.4,1x))
31  Format('O: ',3(f10.4,1x))
!32  Format('D: ',3(f10.4,1x))
!33  Format('PiDPiT: ',3(f10.4,1x))
34  Format('DR: ',3(f10.4,1x))
35  Format('Pi: ',3(f10.4,1x))
36  Format('r: ',3(f10.4,1x))
37  Format('rD: ',3(f10.4,1x))
40  Format('wu: ',3(f10.4,1x))
1   Format(a15)
    !!
  End Subroutine symstuff
#endif
  !!***********************************************************************
  !! create a mesh and integration points for the radial part of the 3D grid
  !! use half a gauss mesh, since this gives a better point distribution
  !! this assumes that the integrated functions fall of to zero sufficiently
  !! fast at the maximum mesh radius
  !! 
  Subroutine gaus_rad_mesh(nr,rmin,rmax,p_rmesh,p_we)
    !!
    Implicit None  
    !!IO
    Integer(t_int),Intent(in)    :: nr
    Real(t_real),Intent(in)      :: rmin,rmax
    Real(t_real),Intent(out)     :: p_rmesh(:),p_we(:)
    !!LOCAL
    Integer(t_int) :: ir
    Real(t_real)   :: x,r,alpha,hx,jr
    !! DONT FREE THEM
    Real(t_real),Pointer  :: p_xx(:),p_cc(:)
    !!
    !!
    Call get_gauss(2*nr-3,p_xx,p_cc)
    !!
    !!
    alpha=Log(rmax/rmin)&
         &/Log((p_xx(nr-1)+1.0_t_real)/(p_xx(1)+1.0_t_real))
    hx=(rmin**(1.0_t_real/alpha))&
         &/((p_xx(1)+1.0_t_real)*0.5_t_real)
    !!
    !!
    !!
    p_rmesh(1)=0.0_t_real
    p_we(1)=0.0_t_real
    !!
    Do ir=2,nr
       x=(p_xx(ir-1)+1.0_t_real)*0.5_t_real*hx
       r=x**alpha
       jr=r*alpha/x
       !Print *,ir,x,r
       p_rmesh(ir)=r
       p_we(ir)= jr * p_cc(ir-1)*0.5_t_real *hx
    Enddo
    !!
    Return
    !!
  End Subroutine gaus_rad_mesh
  !!***********************************************************************
  Subroutine reduced_sph_mesh(symmetry,usesym,nvg,vnga,vag,vwg,reduce)
    !!
    Implicit None  
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    !! use symmetry ?
    Logical(t_log),Intent(in)    :: usesym
    !! which mesh type
    Integer(t_int),Intent(in)    :: nvg
    !! reduce mesh with respect to reduced symemtry
    Logical(t_log),Intent(in)    :: reduce
    !! output mesh (must have correct size)
    !! size
    Integer(t_int),Intent(out)   :: vnga
    Real(t_real),Intent(out)     :: vag(3,*)
    Real(t_real),Intent(out)     :: vwg(*)
    !!
    !!LOCAL
    Character(*),Parameter::nsubfunc="reduced_sph_mesh"
    Integer(t_int) :: jops,ip0,ip,ig
    Real(t_real)   :: p(3),f(3)
    Integer(t_int),Pointer :: mul(:)
    !!The 2000 is hardcoded and related to the maximum spherical
    !!mesh size from gsphirred
    Integer(t_int) :: nga
    Real(t_real)   :: ag(3,2000)
    Real(t_real)   :: wg(2000)
    !!
    !!
    !!
    symif: If(usesym) Then
       reduceif: If(reduce)Then
          !! magnetic relativistic reduction
          Call gsphirred(nvg,ag,wg,nga,symmetry% HEX,1_t_int,.False.)

          !! now reduce mesh with respect to symmetry
          !!
          !! for all points p
          !! 
          !! for all G
          !! 
          !! f= G p
          !!

          !! search  f in mesh, and delete it if not equivalent
          !! with p, count number of removed points +1
          !! multiply weight with multiplicity

          Nullify(mul)
          Call palloc('mul',mul,1_t_int,nga,nmodule,nsubfunc)
          !!
          Do ig=1,nga
             mul(ig)=1_t_int
          Enddo
          !!
          pointloop:Do ig=1,nga
             !!
             If(mul(ig)==0) Cycle pointloop
             !!
             p(:)=ag(:,ig)
             !Print *,'p=',p(:)

             oploop: Do jops=1,symmetry% Rnumops
                !Print *, jops,Trim(symmetry% Ropsymbol(jops))
                f=Matmul(p,symmetry% Ropmat(:,:,jops))!&
                     !&+symmetry% Roptau(:,jops)
                !Print *,'f=',f(:)
                ip0=0
                searchloop: Do ip=1,nga
                   !!
                   If(All(Abs(f-ag(:,ip))<1.0e-6_t_real))Then
                      ip0=ip
                      Exit searchloop
                   Endif
                Enddo searchloop
                If(ip0==0_t_int)Then
                   Write(errbuf,33) 
                   Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
                Endif
                !Print *,'Gp= point ' ,ip0,mul(ip0)
                If(mul(ip0)/=0_t_int .And. ip0/=ig )Then
                   mul(ig)=mul(ig)+1
                   mul(ip0)=0_t_int
                Endif
             Enddo oploop

             !Print *,'M=',ig,mul(ig)

             !! check Numops/mul = integer
             If( mul(ig)*(symmetry% Rnumops/mul(ig)) /= symmetry% Rnumops)Then
                Write(errbuf,34) 
                Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
             Endif
             !! collect results
          Enddo pointloop
          !!
          ip=0_t_int
          Do ig=1,nga
             If(mul(ig)/=0_t_int)Then
                !Print *,ip,ig,ag(:,ig),mul(ig)
                ip=ip+1_t_int
                vag(:,ip)=ag(:,ig)
                vwg(ip)=wg(ig)*mul(ig)
             Endif
          Enddo
          vnga=ip
          Call pfree(mul)
          !!
          !!
       Else !! reduceif
          Call gsphirred(nvg,vag,vwg&
               &,vnga,symmetry% HEX,symmetry% pgrpnum,.False.)

       Endif reduceif
    Else !! symif

       Call gsphirred(nvg,vag,vwg,vnga,symmetry% HEX,1_t_int,.False.)

    Endif symif
    Return
    !!
33  Format("'Cannot find symmetry equivalent of spherical mesh point??!'")
34  Format("'Some mesh point has group incompatible multiplicity??!'")
    !!
  End Subroutine reduced_sph_mesh
  !!***********************************************************************
  Logical(t_log) Function dumpmolinit(mol,nsite,mode)
    !!
    Implicit None  
    !!IO
    Type(T_Mol),Intent(inout)    :: mol
    Integer(t_int),Intent(in)    :: nsite
    Character(*),Intent(in)      :: mode
    !!LOCAL
    Character(*),Parameter::nsubfunc="dumpmolinit"
    Integer(t_int) :: idum
    Character(30)  :: str30
    !!
    dumpmolinit=.True.
    !!
    If(Trim(mode) == 'write')Then
       Open(12,file=Trim(gdump(DUMP_MOLINIT)% fname),form='UNFORMATTED')
       Write(12) '# mol% rad_nr                =',mol% rad_nr
       Write(12) '# mol% maxpnts               =',mol% maxpnts
       Write(12) '# structure% nsite           =',nsite
       Write(12) '# mol% mol% p_wm             =',mol% p_wm
       Write(12) '# mol% p_rindxm              =',mol% p_rindxm
       Write(12) '# mol% rad_rm                =',mol% p_rm
       Write(12) '# mol% rad_nm                =',mol% p_nm
       Write(12) '# mol% rad_wgm               =',mol% p_wgm
       Close(12)
    Else
       Open(12,file=Trim(gdump(DUMP_MOLINIT)% fname),status='old'&
            &,form='UNFORMATTED')
       Read(12) str30,idum
       If(mol% rad_nr/=idum) dumpmolinit=.False.
       Print "('from file ',a,i10,' now=',i10)",str30,mol% rad_nr,idum
       Read(12) str30,idum
       If(mol% maxpnts/=idum) dumpmolinit=.False.
       Print "('from file ',a,i10,' now=',i10)",str30,mol% maxpnts,idum
       Read(12) str30,idum
       If(nsite/=idum) dumpmolinit=.False.
       Print "('from file ',a,i10,' now=',i10)",str30,nsite,idum
       If(dumpmolinit) Then
          Read(12) str30,mol% p_wm
          Read(12) str30,mol% p_rindxm
          Read(12) str30,mol% p_rm
          Read(12) str30,mol% p_nm
          Read(12) str30,mol% p_wgm
       Endif
       Close(12)
       If(.Not.dumpmolinit)Then
          Write(errbuf,34) Trim(gdump(DUMP_MOLINIT)% fname)
          Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
       Endif
    Endif
    !!
    Return
    !!
34  Format("'data on dump file ",a," seem to belong to different settings.',/&
         &,' I will ignore the file''s content and proceed with normal &
         &calculation!'")
    !!
  End Function dumpmolinit
  !!***********************************************************************

End Module mol
