!!todo: bandplot only some bands or energy differences
!!todo: symmetrize:FREL
!!todo: FREL
!!todo: sig, sumrules, band selective 
Module optics
  !!
  Use precisiondefs
  Use errors
  Use memory
  Use file_iounits
  Use constants
  Use clock
  Use tbzone
  Use tkohnsham
  Use optionstest
  Use sort
  Use ksinternal
  Use tloi
  Use trelativistic
  Use diagonalize
  Use toptics
  Use tsymmetry
  Use molcore
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="OPTICS"  
  !!
  Public :: optics_KS_assemble,optics_setup,optics_calc_matel&
       &,read_old_optics_file
  !!***********************************************************************
Contains

  !!***********************************************************************
  Subroutine optics_setup(symmetry,optics,prot)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Optics),Intent(inout) :: optics
    Logical(t_log),Intent(in)    :: prot
    !!LOCAL
    !Character(*),Parameter::nsubfunc="optics_setup"
    Character(1)   :: ch
    Character(*),Parameter :: mesg="OPTICS:"
    Logical(t_log) :: usekramer
    Integer(t_int) :: i,j,k,l,jops
    Integer(t_int) :: idum
    Real(t_real)   :: dum
    Real(t_real)   :: symproj(9,9)!,Zproj(9,9),eproj(9)
    !!
    Call read_old_optics_file(optics,protect=.True.)
    !!
    If(.Not. optics% active) Return
    !!
    !! determine symmetry
    usekramer=.True.
    !! todo: FREL
    symproj=0.0_t_real
    Do jops=1,symmetry% Rnumops
       Do i=1,3
          Do j=1,3
             Do k=1,3
                Do l=1,3
                   symproj(i+3*j-3,k+3*l-3)=symproj(i+3*j-3,k+3*l-3)&
                        &+symmetry% Ropmat(k,i,jops)&
                        &*symmetry% Ropmat(l,j,jops)
                   If(usekramer)Then
                      symproj(i+3*j-3,k+3*l-3)=symproj(i+3*j-3,k+3*l-3)&
                           &+symmetry% Ropmat(k,j,jops)&
                           &*symmetry% Ropmat(l,i,jops)
                   Endif
                   !optdosym(i,j)=optdosym(i,j)+optdos(ie,k,l)*proj(i,j,k,l)
                Enddo
             Enddo
          Enddo
       Enddo
    Enddo
    symproj=symproj/symmetry% Rnumops
    If(usekramer)Then
       symproj=symproj*0.5_t_real
    Endif
    !!
    !!
    If(prot)Then
       Write(outfile,2)Trim(mesg)
       Write(outfile,2)Trim(mesg)//" structure of tensor"
       Write(outfile,2)Trim(mesg)
       Do i=1,3
          Write(outfile,2,advance='no')Trim(mesg)
          Do j=1,3
             ch='0'
             Do k=1,3
                Do l=1,3
                   If(Abs(symproj(i+3*j-3,k+3*l-3))>1.0e-6_t_real)Then
                      ch='X'
                   Endif
                Enddo
             Enddo
             Write(outfile,1,advance='no')ch
          Enddo
          Write(outfile,*)
       Enddo
       Write(outfile,2)Trim(mesg)
    Endif
    !!
    optics% Ni=0
    Do i=1,9
       optics% equiv(i)=i
       If(Any(Abs(symproj(i,:))>1.0e-6_t_real))Then
          optics% Ni=optics% Ni+1
          optics% iof(optics% Ni)=i
          optics% Njofi(optics% Ni)=0
          Do j=1,9
             If(Abs(symproj(i,j))>1.0e-6_t_real)Then
                optics% Njofi(optics% Ni)=optics% Njofi(optics% Ni)+1
                optics% jofi(optics% Njofi(optics% Ni),optics% Ni)=j
                optics% aofji(optics% Njofi(optics% Ni),optics% Ni)=symproj(i,j)
             Endif
          Enddo
       End If
    Enddo
    !!
    Do i=1,optics% Ni
       Do l=i+1,optics% Ni
          If(optics% Njofi(i)==optics% Njofi(l))Then
             If(All(optics% jofi(1:optics% Njofi(i),i)==&
                  & optics% jofi(1:optics% Njofi(l),l)))Then
                If(All(Abs(optics% aofji(1:optics% Njofi(i),i)&
                     &    -optics% aofji(1:optics% Njofi(l),l))&
                     & <1.0e-8_t_real))Then
                   optics% equiv(l)=i
                Endif
                If(All(Abs(optics% aofji(1:optics% Njofi(i),i)&
                     &    +optics% aofji(1:optics% Njofi(l),l))&
                     & <1.0e-8_t_real))Then
                   optics% equiv(l)=-i
                Endif
             Endif
          Endif
       Enddo
    Enddo
    !!
    Do i=2,optics% Ni
       j=i
       Do While(Abs(j)/=Abs(optics% equiv(Abs(j))))
          j=optics% equiv(Abs(j))*Sign(1_t_int,j)
       Enddo
       optics% equiv(i)=j
    Enddo
    !!
    Do i=1,optics% Ni
       If(Abs(optics% equiv(i))==i)Then
          optics% Ninoneq=i
          Cycle
       Endif
       Do j=i+1,optics% Ni
          If(Abs(optics% equiv(j))==j)Then
             optics% Ninoneq=i
             idum=optics% iof(i)
             optics% iof(i)=optics% iof(j)
             optics% iof(j)=idum
             idum=optics%  equiv(i)
             optics%  equiv(i)=optics%  equiv(j)
             optics%  equiv(j)=idum
             idum=optics% Njofi(i)
             optics% Njofi(i)=optics% Njofi(j)
             optics% Njofi(j)=idum
             Do l=1,9
                idum=optics% jofi(l,i)
                optics% jofi(l,i)=optics% jofi(l,j)
                optics% jofi(l,j)=idum
                dum=optics% aofji(l,i)
                optics% aofji(l,i)=optics% aofji(l,j)
                optics% aofji(l,j)=dum
             Enddo
          Endif
       Enddo
    Enddo
    !!
    If(prot)Then
       Do i=1,optics% Ninoneq
          k=Mod(optics% iof(i)-1,3_t_int)+1
          l=(optics% iof(i)-k)/3+1
          Write(outfile,"(a,' P(',i1,',',i1,')=')",advance='no')Trim(mesg),k,l
          Do j=i+1,optics% Ni
             If(optics%  equiv(j)==i)Then
                k=Mod(optics% iof(j)-1,3_t_int)+1
                l=(optics% iof(j)-k)/3+1
                Write(outfile,5,advance='no')k,l
             Endif
             If(optics%  equiv(j)==-i)Then
                k=Mod(optics% iof(j)-1,3_t_int)+1
                l=(optics% iof(j)-k)/3+1
                Write(outfile,6,advance='no')k,l
             Endif
          Enddo
          Do j=1,optics% Njofi(i)
             k=Mod(optics% jofi(j,i)-1,3_t_int)+1
             l=(optics% jofi(j,i)-k)/3+1
             Write(outfile,7,advance='no')optics% aofji(j,i),k,l
          Enddo
          Write(outfile,*)
       Enddo
    Endif
    Write(outfile,2)Trim(mesg)
    Write(outfile,2)Trim(mesg)
    !!
!!$    Call rdiagno_noO(9_t_int,symproj,Zproj,eproj)
!!$    !!
!!$    optics% Nsymproj=0
!!$    Do i=1,9
!!$       If(Abs(eproj(i))>1.0e-8_t_real)Then
!!$          optics% Nsymproj=optics% Nsymproj+1
!!$          optics% Vsymproj(:,optics% Nsymproj)=Zproj(:,i)
!!$       Endif
!!$    Enddo
!!$    !!
!!$    If(prot)Then
!!$       Write(outfile,2)Trim(mesg)
!!$       Write(outfile,2)Trim(mesg)//" symmetry Projectors"
!!$       Write(outfile,2)Trim(mesg) 
!!$       Do i=1,optics% Nsymproj
!!$          Write(outfile,"(a,' V(',i1,')=')",advance='no'),Trim(mesg),i
!!$          Write(outfile,"(9(1x,f7.3))")optics% Vsymproj(1:9,i)
!!$       Enddo
!!$       Write(outfile,2)Trim(mesg)
!!$    Endif
    !!
    !!
    !Stop
    !!
    Return
    !!
1   Format(' ',a1,' ')
2   Format(a)
5   Format(' P(',i1,',',i1,')=')
6   Format('-P(',i1,',',i1,')=')
7   Format(f7.3,'*P(',i1,',',i1,') ')
    !!
  End Subroutine optics_setup
  !!***********************************************************************
  Subroutine optics_KS_assemble(nspin,structure,lattice,loi,&
       &bzone,kohnsham,optics,relativistic)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Optics),Intent(inout) :: optics
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bzone),Intent(in)     :: bzone 
    Type(T_Loi),Intent(in)       :: loi
    Integer(t_int),Intent(in)    :: nspin,relativistic
    !!LOCAL
    Character(*),Parameter::nsubfunc="optics_KS_assemble"
    Logical(t_log) :: rel
    Integer(t_int) :: nkp,nvdim,nchidim,ms,ik,nsite,nband,j,k,l,iw
    Integer(t_int) :: inr,nptdos,ii,jj,subdiv,kk,ll
    Real(t_real)   :: qq(3),wmin,wmax,w0,w1,spinfac,w,optdosym(9),d,dd
    Real(t_real),Pointer :: p_oci_gcc(:,:)
    Real(t_real),Pointer :: p_oci_gvc(:,:)
    Real(t_real),Pointer :: p_tci_gvc(:,:)
    Real(t_real),Pointer :: p_optdos(:,:)
    Complex(t_real),Pointer   :: Ck (:,:)
    Character(*),Parameter  :: cpumesg_matel='optics matrix elements'
    Character(1)   :: comp(3)
    Data comp/'x','y','z'/
    !!
    If(.Not.optics% active) Return
    !!
    Nullify(p_optdos,Ck)
    Nullify(p_oci_gcc,p_oci_gvc,p_tci_gvc)
    !!
    !!
    rel=(relativistic==FULL_RELATIVISTIC)
    nsite=structure% nsite
    nchidim=kohnsham% nchidim
    nvdim=kohnsham% nvdim
    nband=kohnsham% nband
    nkp=bzone% nkp
    !!
    Call palloc('optics% p_pmat',optics% p_pmat,1_t_int,3_t_int&
         &,1_t_int,nband,1_t_int,nband&
         &,1_t_int,nkp,1_t_int,nspin,nmodule,nsubfunc)
    !!
    Call palloc('Ck',Ck,1_t_int,nvdim,1_t_int,nband,nmodule,nsubfunc)
    Call palloc("p_oci_gcc",p_oci_gcc,1_t_int,3_t_int&
         &,1_t_int,loi% ociccdim,nmodule,nsubfunc)
    Call palloc("p_oci_gvc",p_oci_gvc,1_t_int,3_t_int&
         &,1_t_int,loi% ocivcdim,nmodule,nsubfunc)
    Call palloc("p_tci_gvc",p_tci_gvc,1_t_int,3_t_int&
         &,1_t_int,loi% tcivcdim,nmodule,nsubfunc)
    !!
    !!
    Write(outfile,"('START: optics matrix elements')")
    !!
    subdiv=(Max(1_t_int,nkp/(100/10)));
    !!
    Call watch(cpumesg_matel,cpu_start,reset=.True.)            
    !!
    spinloop: Do ms=1,nspin
       !!
       Call mol_core_trans_gcv_noH(structure,lattice,kohnsham,loi&
            &,ms,p_oci_gcc,p_oci_gvc,p_tci_gvc)
       !!
       kloop: Do ik=1,nkp
          !!
          If ( Mod(ik,subdiv) ==0 .Or. ik==1 .Or.ik==nkp)Then
             Write(outfile,"('OPTMATEL: ',f6.2,'% done')") &
                  &100.0_t_real*ik/nkp
          Endif
          !!
          qq(:)=bzone% p_bk(:,ik)
          !!
          !! make a transposed copy
          Do inr=1,nband
             Do j=1,nvdim
                Ck(j,inr)=kohnsham% p_ccvk(inr,ik,j,ms)
             Enddo
          Enddo
          !!
          Call optics_calc_matel(ms,structure,lattice,loi,kohnsham,qq&
               &,p_oci_gcc,p_oci_gvc,p_tci_gvc,Ck&
               &,optics% p_pmat(:,:,:,ik,ms))
          !!
       End Do kloop
       !!
    End Do spinloop
    !!
    Call pfree(Ck)
    Call pfree(p_oci_gvc)
    Call pfree(p_tci_gvc)
    !!
    Call watch(cpumesg_matel,cpu_stop,delete=.True.,Print=.True.)         
    !!
    !!
    wmin=optics% emin
    wmax=optics% emax
    w0=wmin/hatoev
    w1=wmax/hatoev
    nptdos=optics% Ne
    !!
    Call palloc('p_optdos',p_optdos,1_t_int,nptdos,1_t_int,9_t_int&
         &,nmodule,nsubfunc)
    !!
    !!
    spinfac=2.0_t_real/nspin
    If(rel) spinfac=1.0_t_real
    !!
    Open(12,file='+imeps')
    !!
    spinloop2: Do ms=1,nspin
       !!
       p_optdos=0.0_t_real
       !!
       If(optics% jointdos)Then
          Call tetopt(p_optdos&
               &,kohnsham% p_ebkfsm(:,:,ms),kohnsham% efermi&
               &,w1,w0&
               &,bzone% p_tet&
               &,nptdos,bzone% ntet,bzone% ntetsum&
               &,optics% p_pmat(:,:,:,:,ms),spinfac&
               &,structure% vuc)
       Else
          Call tetopt2(p_optdos&
               &,kohnsham% p_ebkfsm(:,:,ms),kohnsham% efermi&
               &,w1,w0&
               &,bzone% p_tet&
               &,nptdos,bzone% ntet,bzone% ntetsum&
               &,optics% p_pmat(:,:,:,:,ms),spinfac&
               &,structure% vuc)
       Endif
       !!
       If (.Not.isoption('FULLBZ'))Then
          !!
          Do iw=1,nptdos
             optdosym(:)=0.0_t_real
             Do ii=1,optics% Ninoneq
                d=0.0_t_real
                Do jj=1,optics% Njofi(ii)
                   d=d+optics% aofji(jj,ii)*p_optdos(iw,optics% jofi(jj,ii))
                Enddo
                optdosym(optics% iof(ii))=d
             Enddo
             p_optdos(iw,:)=optdosym(:)
          Enddo
          !!
       Endif
       !!
       !!header
       Write(12,"('# spin=',i1)")ms
       Write(12,"('# e[eV]                        ')",advance='no')
       Do ii=1,optics% Ninoneq
          k=Mod(optics% iof(ii)-1,3_t_int)+1
          l=(optics% iof(ii)-k)/3+1
          Write(12,"('eps_',a1,a1,25x)",advance='no')comp(k),comp(l)
          Do j=ii+1,optics% Ni
             If(Abs(optics%  equiv(j))==ii)Then
                kk=Mod(optics% iof(j)-1,3_t_int)+1
                ll=(optics% iof(j)-kk)/3+1
                If(optics%  equiv(j)==ii)Then
                   Write(12,"('eps_',a1,a1,'(+',a1,a1,')',25x)",advance='no')&
                        &comp(kk),comp(ll),comp(k),comp(l)
                Else
                   Write(12,"('eps_',a1,a1,'(-',a1,a1,')',25x)",advance='no')&
                        &comp(kk),comp(ll),comp(k),comp(l)
                Endif
             Endif
          Enddo
       Enddo
       Write(12,1)
       !!
       Do iw=1,nptdos
          w=(iw-1.0_t_real)/(nptdos-1.0_t_real)*(wmax-wmin)+wmin
          Write(12,4,advance='no')w
          d=1.0_t_real
          If(w/=0)Then
             d=hatoev**2/w**2
          Endif
          Do ii=1,optics% Ninoneq
             j=optics% iof(ii)
             dd=p_optdos(iw,j)*d
             Write(12,4,advance='no') dd
             Do j=ii+1,optics% Ni
                If(optics%  equiv(j)==ii)Then
                   Write(12,4,advance='no') dd
                Else If(optics%  equiv(j)==-ii)Then
                   Write(12,4,advance='no') -dd
                Endif
             Enddo
          Enddo
          Write(12,1)
       Enddo
       !!
       If(ms<2)Write(12,"()")
       !!
    Enddo spinloop2
    !!
    Close(12)
    !!
    !!
    !!
    Call pfree(optics% p_pmat)
    Call pfree(p_optdos)
    !!
    If(optics% stopafter.And..Not.optics% bandoutput) Then
       Call terminate(TERM_NORMAL,'after optics due to user request.')
    Endif
    !!
    Return
    !!
1   Format()
4   Format(1(e30.15e3,1x))
    !!
  End Subroutine optics_KS_assemble
  !!***********************************************************************
  Subroutine optics_calc_matel(ms,structure,lattice,loi,kohnsham,qq&
       &,oci_gcc,oci_gvc,tci_gvc,Ck,pmat)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Loi),Intent(in)       :: loi
    Integer(t_int),Intent(in)    :: ms
    Real(t_real),Intent(in)      :: qq(3)
    Real(t_real),Intent(in)      :: oci_gcc(:,:),oci_gvc(:,:),tci_gvc(:,:)
    Complex(t_real),Intent(in)   :: Ck(:,:)
    Complex(t_real),Intent(inout):: pmat(:,:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="optics_calc_matel"
    Integer(t_int) :: nvdim,nchidim,nband,k,i,j,inr,inl,iz,isa,ioci,lenchi,l
    Complex(t_real):: cnn
    Complex(t_real),Pointer   :: scv (:,:)
    Complex(t_real),Pointer   :: gsp  (:,:,:)
    Complex(t_real),Pointer   :: gscv (:,:,:)
    Complex(t_real),Pointer   :: ctmp (:,:)
    Complex(t_real),Pointer   :: vtmp (:,:)
    !Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    !!
    Nullify(gsp,gscv,scv,vtmp)
    !!
    !!
    nband=Size(Ck,2)
    nvdim=kohnsham% nvdim
    nchidim=kohnsham% nchidim
    !!
    Call palloc('scv',scv,1_t_int,nchidim,1_t_int,nvdim&
         &,nmodule,nsubfunc)
    Call palloc('gsp',gsp,1_t_int,nvdim,1_t_int,nvdim&
         &,1_t_int,3_t_int,nmodule,nsubfunc)
    Call palloc('gscv',gscv,1_t_int,nchidim,1_t_int,nvdim&
         &,1_t_int,3_t_int,nmodule,nsubfunc)
    Call palloc('vtmp',vtmp,1_t_int,nvdim,1_t_int,nvdim&
         &,nmodule,nsubfunc)
    Call palloc('ctmp',ctmp,1_t_int,nchidim,1_t_int,nvdim&
         &,nmodule,nsubfunc)
    !!
    Call optlomatrix(structure% nsite,nvdim,nchidim&
         &,kohnsham% p_chiblockstart,kohnsham% p_chiblockend&
         &,kohnsham% p_vblockstart,kohnsham% p_vblockend&
         &,lattice% p_npairs,lattice% p_pairs,qq,gsp&
         &,gscv,scv&
         &,loi% p_oci_vchi(:,ms),loi% p_tci_vchi(:,ms)&
         &,loi% p_oci_gvv0,loi% p_tci_gvv0&
         &,oci_gvc,tci_gvc&
         &,loi% p_ocivvindex,loi% p_tcivvindex&
         &,loi% p_ocivcindex,loi% p_tcivcindex)
    
    !!
    cartloop: Do k=1,3
       !!
       
       Do j=1,nvdim
          iz=0
          Do isa=1,structure% nsite
             ioci=loi% p_ociccindex(isa)
             lenchi=kohnsham% p_chiblocklength(isa)
             Do l=1,lenchi
                ctmp(iz+l,j)=Sum(oci_gcc(k,ioci+1:ioci+lenchi)*scv(iz+1:iz+lenchi,j))
                ioci=ioci+lenchi
             Enddo
             iz=iz+lenchi
          Enddo
       Enddo


       Do i=1,nvdim
          Do j=1,nvdim
             cnn=Dot_product(gscv(1:nchidim,i,k),scv(1:nchidim,j))
             gsp(i,j,k)=gsp(i,j,k)-cnn
             gsp(j,i,k)=gsp(j,i,k)+Conjg(cnn)
             gsp(i,j,k)=gsp(i,j,k)&
                  &+Dot_product(scv(1:nchidim,i),ctmp(1:nchidim,j))
          Enddo
       Enddo
       !!


!!$       Do i=1,nvdim
!!$          Do j=1,nvdim
!!$             If(Abs(gsp(i,j,k)+Conjg(gsp(j,i,k)))>1.0e-7_t_real)Then
!!$                Write(outfile,"('anti-hermitian error: Sgvvij=',2f30.15,/&
!!$                     &,         '                      Sgvvji=',2f30.15)")&
!!$                     &gsp(i,j,k),gsp(j,i,k)
!!$             Endif
!!$          Enddo
!!$       Enddo

       !!
       Do inl=1,nband
          Do j=1,nvdim
             vtmp(j,inl)=Dot_product(Ck(1:nvdim,inl),gsp(1:nvdim,j,k))
          Enddo
       Enddo
       !!
       Do inl=1,nband
          Do inr=1,nband
             pmat(k,inl,inr)=ci*Sum(vtmp(1:nvdim,inl)*Ck(1:nvdim,inr))
          Enddo
       Enddo
       !!
!!$       Do i=1,nband
!!$          Do j=1,nband
!!$             If(Abs(pmat(k,i,j)-Conjg(pmat(k,j,i)))>1.0e-6_t_real)Then
!!$                Write(outfile,"('hermitian error: Pij=',2f30.15,/&
!!$                     &,         '                 Pji=',2f30.15)")&
!!$                     &pmat(k,i,j),pmat(k,j,i)
!!$             Endif
!!$          Enddo
!!$       Enddo

       !!
       !!
    Enddo cartloop
    !!
    Call pfree(gsp)
    Call pfree(gscv)
    Call pfree(scv)
    Call pfree(vtmp)
    !!
    Return
    !!
  End Subroutine optics_calc_matel
  !!***********************************************************************
  Subroutine tetopt(optdos,ebk,efermi,emax,emin,tet,ne,ntet,ntetsum&
       &,pmat,spinfac,vuc)
    !!- optics integral Im eps(w)
    !!  sum_{nm} (F(e_n)-F(e_m))delta(e_n-e_m-w)*pmatel*pmatel
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   pmat  :momentum matrix element
    !!i   ebk   :band energies-efermi
    !!i   emax  :upper bound of energy window
    !!i   emin  :lower bound of energy window
    !!i   tet :tet(1-5,i) points to the 4 irreducible k-points defining
    !!i           the tetrahedron. tet(0,i)=no. of tetr. of the i'th kind
    !!i   nvdim :number of bands
    !!i   ne    :no of DOS tabulation points in energy range: [emin, emax]
    !!i   ntet  :number of different tetrahedra (output from TETIRR)
    !!o Outputs:
    !!o   optdos   :OPTDOS *w^2in [Ha^2]
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)   :: ntet,ne
    Integer(t_int),Intent(in)   :: tet(0:5,ntet)
    Real(t_real),Intent(in)     :: spinfac,ntetsum
    Real(t_real),Intent(in)     :: ebk(:,:),emin,emax,efermi,vuc
    Real(t_real),Intent(out)    :: optdos(ne,3,3)
    Complex(t_real),Intent(in)  :: pmat(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: ib1,ib2,itet,ikp1,ikp2,ikp3,ikp4,nband,ik,i,j
    Integer(t_int) :: subdiv,n1,n2,fcorn1(4),fcorn2(4)
    Real(t_real)   :: ecorn1(4),ecorn2(4),tetwgt,volwgt,ebot,etop,acorn(4)
    Real(t_real)   :: dcorn(4)
    !!
    volwgt = spinfac / ntetsum*fourpi*pi/vuc
    !!
    nband=Size(pmat,2)
    !!
    !!
    !!
    subdiv=(Max(1_t_int,ntet/(100/10)));

    !! --- Loop over tetrahedra ---
    tetloop: Do itet = 1_t_int, ntet
       !Print "('dos: ',f10.2,'%')",100.0_t_real*itet/ntet
       If ( Mod(itet,subdiv) ==0 .Or. itet==1 .Or.itet==ntet)Then
          Write(outfile,"('tetopt: ',f6.2,'% done')") &
               &100.0_t_real*itet/ntet
       Endif
       ikp1=tet(1,itet)
       ikp2=tet(2,itet)
       ikp3=tet(3,itet)
       ikp4=tet(4,itet)
       tetwgt=volwgt*tet(0,itet)

       !! ----- Loop over bands
       bandloop1: Do ib1=1,nband
          !! --------- SET UP ENERGIES AT 4 CORNERS OF TETRAHEDRA
          ecorn1(1) = ebk(ib1,ikp1)
          ecorn1(2) = ebk(ib1,ikp2)
          ecorn1(3) = ebk(ib1,ikp3)
          ecorn1(4) = ebk(ib1,ikp4)
          n1=0
          Do ik=1,4
             If(efermi>=ecorn1(ik))Then
                fcorn1(ik)=1
                n1=1
             Else
                fcorn1(ik)=0
             Endif
          Enddo
          If(All(efermi>=ecorn1(1:4))) n1=1
          bandloop2: Do ib2=1,nband
             ecorn2(1) = ebk(ib2,ikp1)
             ecorn2(2) = ebk(ib2,ikp2)
             ecorn2(3) = ebk(ib2,ikp3)
             ecorn2(4) = ebk(ib2,ikp4)
             n2=0
             Do ik=1,4
                If(efermi>=ecorn2(ik))Then
                   fcorn2(ik)=1
                   n2=1
                Else
                   fcorn2(ik)=0
                Endif
             Enddo
             !!
             If(n1-n2==0) Cycle
             !!
             Do ik=1,4
                dcorn(ik)=ecorn1(ik)-ecorn2(ik)
             Enddo
             ebot = Minval(dcorn(1:4))
             etop = Maxval(dcorn(1:4))
             If (ebot >=  emax .Or. etop <= emin)Cycle

             Do i=1,3
                Do j=1,3
                   !!TODO: find correct expression !!!!
                   acorn(1)=-&
                        &  Real(pmat(i,ib1,ib2,ikp1)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp1)),t_real)&
                        &  *(fcorn1(1)-fcorn2(1))
                   !!todo: fcorn
                   acorn(2)=-&
                        &  Real(pmat(i,ib1,ib2,ikp2)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp2)),t_real)&
                        &  *(fcorn1(2)-fcorn2(2))
                   acorn(3)=-&
                        &  Real(pmat(i,ib1,ib2,ikp3)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp3)),t_real)&
                        &  *(fcorn1(3)-fcorn2(3))!(n1-n2)!
                   acorn(4)=-&
                        &  Real(pmat(i,ib1,ib2,ikp4)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp4)),t_real)&
                        &  *(fcorn1(4)-fcorn2(4))
                   !!
                   Call sliny1a(acorn,tetwgt,dcorn,emin,emax,optdos(:,i,j),ne)
                Enddo
             Enddo
          Enddo bandloop2
       Enddo bandloop1
    Enddo tetloop
    !!
    !!
  End Subroutine tetopt
  !!***********************************************************************
  !!
  Subroutine tetopt2(optdos,ebk,efermi,emax,emin,tet,ne,ntet,ntetsum&
       &,pmat,spinfac,vuc)
    !!- optics integral Im eps(w)
    !!  sum_{nm} (F(e_n)-F(e_m))delta(e_n-e_m-w)*pmatel*pmatel
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   pmat  :momentum matrix element
    !!i   ebk   :band energies-efermi
    !!i   emax  :upper bound of energy window
    !!i   emin  :lower bound of energy window
    !!i   tet :tet(1-5,i) points to the 4 irreducible k-points defining
    !!i           the tetrahedron. tet(0,i)=no. of tetr. of the i'th kind
    !!i   nvdim :number of bands
    !!i   ne    :no of DOS tabulation points in energy range: [emin, emax]
    !!i   ntet  :number of different tetrahedra (output from TETIRR)
    !!o Outputs:
    !!o   optdos   :OPTDOS *w^2in [Ha^2]
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)   :: ntet,ne
    Integer(t_int),Intent(in)   :: tet(0:5,ntet)
    Real(t_real),Intent(in)     :: spinfac,ntetsum
    Real(t_real),Intent(in)     :: ebk(:,:),emin,emax,efermi,vuc
    Real(t_real),Intent(out)    :: optdos(ne,3,3)
    Complex(t_real),Intent(in)  :: pmat(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: ib1,ib2,itet,ikp1,ikp2,ikp3,ikp4,nband,ik,i,j
    Integer(t_int) :: subdiv,n1,n2
    Real(t_real)   :: ecorn1(4),ecorn2(4),tetwgt,volwgt,ebot,etop,acorn(4)
    Real(t_real)   :: dcorn(4),aacorn(4)
    !!
    volwgt = spinfac / ntetsum*fourpi*pi/vuc
    !!
    nband=Size(pmat,2)
    !!
    !!
    !!
    subdiv=(Max(1_t_int,ntet/(100/10)));

    !! --- Loop over tetrahedra ---
    tetloop: Do itet = 1_t_int, ntet
       !Print "('dos: ',f10.2,'%')",100.0_t_real*itet/ntet
       If ( Mod(itet,subdiv) ==0 .Or. itet==1 .Or.itet==ntet)Then
          Write(outfile,"('tetopt: ',f6.2,'% done')") &
               &100.0_t_real*itet/ntet
       Endif
       ikp1=tet(1,itet)
       ikp2=tet(2,itet)
       ikp3=tet(3,itet)
       ikp4=tet(4,itet)
       tetwgt=volwgt*tet(0,itet)

       !! ----- Loop over bands
       bandloop1: Do ib1=1,nband
          !! --------- SET UP ENERGIES AT 4 CORNERS OF TETRAHEDRA
          ecorn1(1) = ebk(ib1,ikp1)
          ecorn1(2) = ebk(ib1,ikp2)
          ecorn1(3) = ebk(ib1,ikp3)
          ecorn1(4) = ebk(ib1,ikp4)
          n1=0
          If(All(efermi>=ecorn1(1:4))) n1=1
          bandloop2: Do ib2=1,nband
             ecorn2(1) = ebk(ib2,ikp1)
             ecorn2(2) = ebk(ib2,ikp2)
             ecorn2(3) = ebk(ib2,ikp3)
             ecorn2(4) = ebk(ib2,ikp4)
             n2=0
             If(All(efermi>=ecorn2(1:4))) n2=1
             !!
             If(n1-n2==0) Cycle
             !!
             Do ik=1,4
                dcorn(ik)=ecorn1(ik)-ecorn2(ik)
             Enddo
             ebot = Minval(dcorn(1:4))
             etop = Maxval(dcorn(1:4))
             If (ebot >=  emax .Or. etop <= emin)Cycle

             Do i=1,3
                Do j=1,3
                   !!TODO: find correct expression !!!!
                   acorn(1)=-&
                        &  Real(pmat(i,ib1,ib2,ikp1)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp1)),t_real)
                   acorn(2)=-&
                        &  Real(pmat(i,ib1,ib2,ikp2)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp2)),t_real)
                   acorn(3)=-&
                        &  Real(pmat(i,ib1,ib2,ikp3)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp3)),t_real)
                   acorn(4)=-&
                        &  Real(pmat(i,ib1,ib2,ikp4)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp4)),t_real)
                   !!
                   aacorn=efermi-ecorn1
                   Call slinyopt(acorn,tetwgt,dcorn,aacorn,emin,emax&
                        &,optdos(:,i,j),ne)
                   aacorn=efermi-ecorn2
                   Call slinyopt(acorn,-tetwgt,dcorn,aacorn,emin,emax&
                        &,optdos(:,i,j),ne)
                Enddo
             Enddo
          Enddo bandloop2
       Enddo bandloop1
    Enddo tetloop
    !!
    !!
  End Subroutine tetopt2
  !!***********************************************************************
  Subroutine sliny1a(acorn,volwgt,ecorn,emin,emax,dos,npts)
    !!- Adds to density-of-states for one tetrahedron
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   volwgt:weight of irreducible tetrahedron
    !!i   ecorn :energies at corners of tetrahedron
    !!i   acorn :weigths of partial DOS at corners of tetrahedron
    !!i   emin  :lower bound of energy window
    !!i   emax  :upper bound of energy window
    !!io  dos   :density of states from tetrahedron
    !!i   npts  :number of dos tabulation points
    !!o Outputs:
    !!io  dos   :density of states from tetrahedron
    !!r Remarks:
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: npts
    Real(t_real),Intent(in)      :: volwgt,emin,emax
    Real(t_real),Intent(in)      :: acorn(4)
    Real(t_real),Intent(inout)   :: ecorn(4),dos(npts)
    !!LOCAL
    Integer(t_int) :: i,i0(4),m,iwk(4)
    Real(t_real)  :: de,e1,e2,e3,e4,c1,c2,c3,x,ac0,ec(4),ac(4)
    Real(t_real)   :: da41,da31,da21,da42,da43,a1,a2,a3,a4,q,x0
    Real(t_real)   :: de21,de31,de41,de42,de43,de32
    Real(t_real)   :: c4,q31,q41,dq,q1,q2,q3,q4
    !! ----sort ecorn -------
    Call dshel2(1_t_int,4_t_int,ecorn,iwk,1.0e-12_t_real)
    Do i=1,4
       ec(i)=ecorn(iwk(i)+1)
       ac(i)=acorn(iwk(i)+1)
    Enddo
    ac0=Sum(acorn)/4

    e1 = ec(1)
    e2 = ec(2)
    e3 = ec(3)
    e4 = ec(4)
    If (e4 < emin .Or. e1 > emax) Return
    a1 = ac(1)
    a2 = ac(2)
    a3 = ac(3)
    a4 = ac(4)
    de = (emax-emin)/(npts-1_t_int)
    Do m=1_t_int,4_t_int
       If (ec(m) < emin) Then
          i0(m)=1_t_int
       Elseif (ec(m) > emax) Then
          i0(m)=npts+1_t_int
       Else
          i0(m) = 2_t_int + Int((ec(m)-emin)/de - Epsilon(1.0_t_real)&
               &,t_int)
       Endif
    Enddo
    da21=a2-a1
    da31=a3-a1
    da41=a4-a1
    de31=1.0_t_real/(e3-e1)
    de41=1.0_t_real/(e4-e1)
    If (i0(1_t_int) < i0(2_t_int)) Then
       de21=1.0_t_real/(e2-e1)
       q=(da21*de21+da31*de31+da41*de41)*c1o3
       c3 = volwgt*3.0_t_real*de21*de31*de41
       x0 = emin-e1-de
       Do i = i0(1_t_int), i0(2_t_int)-1_t_int
          x = x0 + i*de
          dos(i) = dos(i) + c3*x*x*(a1 + x*q)
       Enddo
    Endif
    If (i0(2_t_int) < i0(3_t_int)) Then
       de21=e2-e1
       de42=e4-e2
       de32=e3-e2
       c4 = volwgt/(de32**2*de42**2)
       c3 = volwgt*3.0_t_real*(e1+e2-e3-e4)/(de32*de42)*de31*de41
       c2 = volwgt*6.0_t_real*de31*de41
       c1 = c2*de21*0.5_t_real

       !!
       q31=da31*de31
       q41=da41*de41
       q=q31+q41
       dq=da21+de21*q
       !!

       q1= a1 + dq*c1o3
       q2= a1 + dq*0.5_t_real
       q3= a1*c3 +da21*c3 +c2*q*0.5_t_real
       q4=+c3*(q-da21/de32)*c1o3&
            &-c4*(de42*q31+de32*(q41-da21*de41))
       !!
       x0 = emin-e2-de
       Do i = i0(2_t_int), i0(3_t_int)-1_t_int
          x = x0 + i*de
          dos(i) = dos(i)   + c1*q1  + x*(c2*q2  + x*(q3+x*q4))
       Enddo
    Endif
    If (i0(3_t_int) < i0(4_t_int)) Then
       de42=1.0_t_real/(e4-e2)
       de43=1.0_t_real/(e4-e3)
       da42=a4-a2
       da43=a4-a3
       q=(da41*de41+da42*de42+da43*de43)*c1o3
       c3 = volwgt*3.0_t_real*de42*de43*de41
       x0 = emin-e4-de
       Do i = i0(3_t_int), i0(4_t_int)-1_t_int
          x = x0 +i*de
          dos(i) = dos(i)  + c3*x*x*(a4+x*q)
       Enddo
    Endif
    !!
    Return
    !!
  End Subroutine sliny1a
  !!***********************************************************************
  Subroutine slinyopt(ccorn,volwgt,dcorn,acorn,emin,emax,dos,npts)
    !!- Adds to density-of-states for one tetrahedron
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   volwgt:weight of irreducible tetrahedron
    !!i   dcorn :energies at corners of tetrahedron
    !!i   ccorn :weigths of partial DOS at corners of tetrahedron
    !!i   emin  :lower bound of energy window
    !!i   emax  :upper bound of energy window
    !!io  dos   :density of states from tetrahedron
    !!i   npts  :number of dos tabulation points
    !!o Outputs:
    !!io  dos   :density of states from tetrahedron
    !!r Remarks:
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: npts
    Real(t_real),Intent(in)      :: volwgt,emin,emax
    Real(t_real),Intent(in)      :: ccorn(4),acorn(4)
    Real(t_real),Intent(inout)   :: dcorn(4),dos(npts)
    !!LOCAL
    Integer(t_int) :: i,i0(4),m,iwk(4),ie
    Real(t_real)   :: de,d1,d2,d3,d4,p1,p2,p3,x,dc(4),cc(4),ac(4)
    Real(t_real)   :: dc41,dc31,dc21,dc42,dc43,c1,c2,c3,c4,q,x0
    Real(t_real)   :: dd21,dd31,dd41,dd42,dd43,dd32
    Real(t_real)   :: p4,q31,q41,dq,q1,q2,q3,q4
    !! ----sort dcorn -------
    Call dshel2(1_t_int,4_t_int,dcorn,iwk,1.0e-12_t_real)
    Do i=1,4
       dc(i)=dcorn(iwk(i)+1)
       ac(i)=acorn(iwk(i)+1)
       cc(i)=ccorn(iwk(i)+1)
    Enddo

    d1 = dc(1)
    d2 = dc(2)
    d3 = dc(3)
    d4 = dc(4)
    If (d4 < emin .Or. d1 > emax) Return

    de = (emax-emin)/(npts-1_t_int)

    If(Maxval(ac)<0.0_t_real)Return

    Do m=1,4
       If (dc(m) < emin) Then
          i0(m)=1_t_int
       Elseif (dc(m) > emax) Then
          i0(m)=npts+1
       Else
          i0(m)=2+Int((dc(m)-emin)/de-Epsilon(1.0_t_real),t_int)
       Endif
    Enddo
    !!
    If(Minval(ac)>0.0_t_real) Goto 1000
    !!

    If(i0(1) < i0(2)) Then
       !Print *,'case 1: ',i0(1),' ... ',i0(2)
       Do  ie=i0(1),i0(2)-1
          x=emin+ie*de-de
          dos(ie)=dos(ie)+iterm01(x,ac,cc,dc)*volwgt;
       Enddo
    Endif
    If(i0(2) < i0(3)) Then
       !Print *,'case 2: ',i0(2),' ... ',i0(3)
       Do  ie=i0(2),i0(3)-1
          x=emin+ie*de-de
          dos(ie)=dos(ie)+iterm02(x,ac,cc,dc)*volwgt;
       Enddo
    Endif
    If(i0(3) < i0(4)) Then
       !Print *,'case 3: ',i0(3),' ... ',i0(4)
       Do  ie=i0(3),i0(4)-1
          x=emin+ie*de-de
          dos(ie)=dos(ie)+iterm03(x,ac,cc,dc)*volwgt;
       Enddo
    Endif


    Return

    !! normal dos
1000 Continue

    c1 = cc(1)
    c2 = cc(2)
    c3 = cc(3)
    c4 = cc(4)

    dc21=c2-c1
    dc31=c3-c1
    dc41=c4-c1
    dd31=1.0_t_real/(d3-d1)
    dd41=1.0_t_real/(d4-d1)
    If (i0(1_t_int) < i0(2_t_int)) Then
       dd21=1.0_t_real/(d2-d1)
       q=(dc21*dd21+dc31*dd31+dc41*dd41)*c1o3
       p3 = volwgt*3.0_t_real*dd21*dd31*dd41
       x0 = emin-d1-de
       Do i = i0(1_t_int), i0(2_t_int)-1_t_int
          x = x0 + i*de
          dos(i) = dos(i) + p3*x*x*(c1 + x*q)
       Enddo
    Endif
    If (i0(2_t_int) < i0(3_t_int)) Then
       dd21=d2-d1
       dd42=d4-d2
       dd32=d3-d2
       p4 = volwgt/(dd32**2*dd42**2)
       p3 = volwgt*3.0_t_real*(d1+d2-d3-d4)/(dd32*dd42)*dd31*dd41
       p2 = volwgt*6.0_t_real*dd31*dd41
       p1 = p2*dd21*0.5_t_real

       !!
       q31=dc31*dd31
       q41=dc41*dd41
       q=q31+q41
       dq=dc21+dd21*q
       !!

       q1= c1 + dq*c1o3
       q2= c1 + dq*0.5_t_real
       q3= c1*p3 +dc21*p3 +p2*q*0.5_t_real
       q4=+p3*(q-dc21/dd32)*c1o3&
            &-p4*(dd42*q31+dd32*(q41-dc21*dd41))
       !!
       x0 = emin-d2-de
       Do i = i0(2_t_int), i0(3_t_int)-1_t_int
          x = x0 + i*de
          dos(i) = dos(i)   + (p1*q1  + x*(p2*q2  + x*(q3+x*q4)))
       Enddo
    Endif
    If (i0(3_t_int) < i0(4_t_int)) Then
       dd42=1.0_t_real/(d4-d2)
       dd43=1.0_t_real/(d4-d3)
       dc42=c4-c2
       dc43=c4-c3
       q=(dc41*dd41+dc42*dd42+dc43*dd43)*c1o3
       p3 = volwgt*3.0_t_real*dd42*dd43*dd41
       x0 = emin-d4-de
       Do i = i0(3_t_int), i0(4_t_int)-1_t_int
          x = x0 +i*de
          dos(i) = dos(i)  + p3*x*x*(c4+x*q)
       Enddo
    Endif
    !!
    Return
    !!
  End Subroutine slinyopt
  !!***********************************************************************
  Real(t_real) Function iterm01(w,a,c,d)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: w,a(1:4),c(1:4),d(1:4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="iterm01"
    Real(t_real)   :: dd01,dd02,dd03,pre,Dad01,Dad02,Dad03,dum,W0
    Real(t_real)   :: a01w,a02w,a03w,Dcd01,Dcd02,Dcd03,c01w,c03w
    Real(t_real)   :: dcd0102,dcd0103,dcd0203,dad0102,dad0103,dad0203
    !!
    !!
    iterm01=0.0_t_real

    dd01=1.0_t_real/(d(1)-d(2))
    dd02=1.0_t_real/(d(1)-d(3))
    dd03=1.0_t_real/(d(1)-d(4))

    pre=dd01*dd02*dd03

    Dad01=(a(1)-a(2))*dd01
    Dad02=(a(1)-a(3))*dd02
    Dad03=(a(1)-a(4))*dd03

    Dcd01=(c(1)-c(2))*dd01;
    Dcd02=(c(1)-c(3))*dd02;
    Dcd03=(c(1)-c(4))*dd03;


    !Print *,"Dad01,Dad02,Dad03 "

    If(Dad01 < Dad02)Then
       dum=Dad01;Dad01=Dad02;Dad02=dum;
       dum=Dcd01;Dcd01=Dcd02;Dcd02=dum;
    Endif
    If(Dad01 < Dad03)Then
       dum=Dad01;Dad01=Dad03;Dad03=dum;
       dum=Dcd01;Dcd01=Dcd03;Dcd03=dum;
    Endif
    If(Dad02 < Dad03)Then
       dum=Dad02;Dad02=Dad03;Dad03=dum;
       dum=Dcd02;Dcd02=Dcd03;Dcd03=dum;
    Endif

    !Print *,",Dad01,Dad02,Dad03 "

    W0=w-d(1);

    a01w=a(1)+Dad01*W0;
    a02w=a(1)+Dad02*W0;
    a03w=a(1)+Dad03*W0;




    !Print *,"a01w,a02w,a03w "

    If (a01w>0.0_t_real .And. a02w<=0.0_t_real) Then
       !Print *,"01 full 02 03 empty"
       c01w=c(1)+Dcd01*W0
       dad0102=Dad02-Dad01
       dad0103=Dad03-Dad01
       dcd0102=Dcd01-Dcd02
       dcd0103=Dcd01-Dcd03
       iterm01=-pre*(a01w*a01w*((dcd0103/dad0103+dcd0102/dad0102)*a01w&
            &+3.0_t_real*c01w))/(dad0102*dad0103)

    Elseif(a02w>0.0_t_real .And. a03w<=0.0_t_real)then
       !Print *,"01 02 full  03 empty"
       c03w=c(1)+Dcd03*W0
       dad0103=Dad03-Dad01
       dad0203=Dad03-Dad02
       dcd0103=Dcd01-Dcd03
       dcd0203=Dcd02-Dcd03
       iterm01=pre*(-(3.0_t_real*c(1)+(Dcd01+Dcd02+Dcd03)*W0)*W0*W0&
            &+(a03w*a03w*((dcd0203/dad0203+dcd0103/dad0103)*a03w&
            &+3.0_t_real*c03w))/(dad0103*dad0203))
    Elseif(a03w>0.0_t_real) Then
       !Print *,"01 02 03 full"
       c03w=c(1)+Dcd03*W0
       iterm01=-pre*(3.0_t_real*c(1)+(Dcd01+Dcd02+Dcd03)*W0)*W0*W0
       !Print *,"01 02 03 q=q "
    Endif
    !!
    !!
    Return
    !!
  End Function iterm01
  !!***********************************************************************
  Real(t_real) Function iterm03(w,a,c,d)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: w,a(1:4),c(1:4),d(1:4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="iterm03"
    Real(t_real)   :: dd03,dd13,dd23,Dad03,Dad13,Dad23,dum,Dcd03,Dcd13,Dcd23
    Real(t_real)   :: W3,pre,a03w,a13w,a23w,c03w,c23w
    Real(t_real)   :: dad0313,dad0323,dad1323,dcd0313,dcd0323,dcd1323
    !!
    iterm03=0.0_t_real
    !!

    !a=[amm->[0],amm->[1],amm->[2],amm->[3]];
    !c=[cmm->[0],cmm->[1],cmm->[2],cmm->[3]];
    !d=[dmm->[0],dmm->[1],dmm->[2],dmm->[3]];


    dd03=1.0_t_real/(d(1)-d(4))
    dd13=1.0_t_real/(d(2)-d(4))
    dd23=1.0_t_real/(d(3)-d(4))

    pre=dd03*dd13*dd23


    Dad03=(a(1)-a(4))*dd03
    Dad13=(a(2)-a(4))*dd13
    Dad23=(a(3)-a(4))*dd23

    Dcd03=(c(1)-c(4))*dd03
    Dcd13=(c(2)-c(4))*dd13
    Dcd23=(c(3)-c(4))*dd23


    !print *,"Dad03,Dad13,Dad23 "
    If(Dad03 > Dad13)Then
       dum=Dad03;Dad03=Dad13;Dad13=dum
       dum=Dcd03;Dcd03=Dcd13;Dcd13=dum
    Endif
    If(Dad03 > Dad23)Then
       dum=Dad03;Dad03=Dad23;Dad23=dum
       dum=Dcd03;Dcd03=Dcd23;Dcd23=dum
    Endif
    If(Dad13 > Dad23)Then
       dum=Dad13;Dad13=Dad23;Dad23=dum
       dum=Dcd13;Dcd13=Dcd23;Dcd23=dum
    Endif
    !print *,"Dad03,Dad13,Dad23 "

    W3=w-d(4)


    a03w=a(4)+Dad03*W3
    a13w=a(4)+Dad13*W3
    a23w=a(4)+Dad23*W3

    If (a03w>0.0_t_real .And. a13w<=0.0_t_real) Then
       !print "03 full 13 23 empty\n"
       dad0313=Dad13-Dad03
       dad0323=Dad23-Dad03
       dcd0313=Dcd03-Dcd13
       dcd0323=Dcd03-Dcd23
       c03w=c(4)+Dcd03*W3
       iterm03=-pre*(3.0_t_real*c03w+(dcd0313/dad0313+dcd0323/dad0323)*a03w)&
            &*a03w*a03w/(dad0313*dad0323)
    Elseif (a13w>0.0_t_real .And. a23w<=0.0_t_real) Then
       !print "03 13 full 23 empty\n"
       dad0323=Dad23-Dad03
       dad1323=Dad23-Dad13
       dcd0323=Dcd03-Dcd23
       dcd1323=Dcd13-Dcd23
       c23w=c(4)+Dcd23*W3
       iterm03=pre*(-(3.0_t_real*c(4)+(Dcd03+Dcd13+Dcd23)*W3)*W3*W3&
            &+(3.0_t_real*c23w+(dcd0323/dad0323+dcd1323/dad1323)*a23w)&
            & *a23w*a23w/(dad0323*dad1323))
    Elseif (a23w>0.0_t_real) Then
       !print "03 13 23 full\n"
       iterm03=-pre*(3.0_t_real*c(4)+(Dcd03+Dcd13+Dcd23)*W3)*W3*W3
    Endif
    !!
    Return
    !!
  End Function iterm03
  !!***********************************************************************
  Real(t_real) Function iterm02(w,amm,cmm,dmm)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: w,amm(1:4),cmm(1:4),dmm(1:4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="iterm02"
    Integer(t_int) :: imin
    Real(t_real)   :: a(4),c(4),d(4),dd12,dd02,dd03,dd13
    Real(t_real)   :: a02w,a12w,a03w,a13w,sig,amin,Dad02,Dad12,Dad03,Dad13
    Real(t_real)   :: pre0,pre1,y,y2,c03w,c13w,dad0313,dad0223,dcd0313,Dad23
    Real(t_real)   :: dd01,dd23,dcd1213,dad1213,W1,W2,W3,c12w,dad0212,dad0203
    Real(t_real)   :: dcd0203,dcd0212,c02w,Dcd02,Dcd12,Dcd13,Dcd03,dum
    !!
    iterm02=0.0_t_real
    !!
    a(1:4)=amm(1:4)
    c(1:4)=cmm(1:4)
    d(1:4)=dmm(1:4)
    
    dd12=d(2)-d(3)
    dd02=d(1)-d(3)
    dd03=d(1)-d(4)
    dd13=d(2)-d(4)
    
    Dad02=(a(1)-a(3))/dd02
    Dad12=(a(2)-a(3))/dd12
    Dad03=(a(1)-a(4))/dd03
    Dad13=(a(2)-a(4))/dd13
    
    W1=w-d(2)
    W2=w-d(3)
    W3=w-d(4)
    
    a02w=a(3)+Dad02*W2
    a03w=a(4)+Dad03*W3
    a12w=a(3)+Dad12*W2
    a13w=a(4)+Dad13*W3
    
    sig=1.0_t_real
    
    !printf("in : w=%g: %10g %10g %10g %10g \n",w,a02w,a12w,a03w,a13w )
    
    amin=a02w
    imin=0
    
    If (a12w>amin) Then
       imin=1
       amin=a12w
    Endif
    If (a03w>amin) Then
       imin=2
       amin=a03w
    Endif
    If (a13w>amin) Then
       imin=3
       amin=a13w
    Endif
    !printf("amin=%s imin=%d\n",types->[imin],imin)
    
    If (imin==1) Then
       !printf("ex1: a12 <->a02 \n")
       ! 21 <->20
       ! 0<->1
       dum=a02w;a02w=a12w;a12w=dum
       dum=a03w;a03w=a13w;a13w=dum
       
       dum=a(1);a(1)=a(2);a(2)=dum
       dum=c(1);c(1)=c(2);c(2)=dum
       dum=d(1);d(1)=d(2);d(2)=dum
    Elseif (imin==2) Then
       !printf("ex2: a02 <->a03 \n")
       ! 30 <->20
       ! 2<->3
       dum=a(3);a(3)=a(4);a(4)=dum
       dum=c(3);c(3)=c(4);c(4)=dum
       dum=d(3);d(3)=d(4);d(4)=dum
       dum=a02w;a02w=a03w;a03w=dum
       dum=a12w;a12w=a13w;a13w=dum
    Elseif (imin==3) Then
       !printf("ex3: a13 <->a02 \n")
       ! 31 <->20
       ! 1<->2
       ! 0<->3
       dum=a02w;a02w=a13w;a13w=dum
       dum=a(2);a(2)=a(3);a(3)=dum
       dum=c(2);c(2)=c(3);c(3)=dum
       dum=d(2);d(2)=d(3);d(3)=dum
       dum=a(1);a(1)=a(4);a(4)=dum
       dum=c(1);c(1)=c(4);c(4)=dum
       dum=d(1);d(1)=d(4);d(4)=dum
       sig=-sig;
    Endif
    
    
    If (a12w<a03w) Then
       !printf("ex1203: a12 <->a03 \n")
       ! 21<->30
       ! 1<->3
       ! 0<->2
       dum=a(1);a(1)=a(3);a(3)=dum
       dum=c(1);c(1)=c(3);c(3)=dum
       dum=d(1);d(1)=d(3);d(3)=dum
       dum=a(2);a(2)=a(4);a(4)=dum
       dum=c(2);c(2)=c(4);c(4)=dum
       dum=d(2);d(2)=d(4);d(4)=dum
       sig=-sig
    Endif
    
    
    
    dd12=d(2)-d(3)
    dd02=d(1)-d(3)
    dd03=d(1)-d(4)
    dd13=d(2)-d(4)
    
    Dad02=(a(1)-a(3))/dd02
    Dad12=(a(2)-a(3))/dd12
    Dad03=(a(1)-a(4))/dd03
    Dad13=(a(2)-a(4))/dd13
    
    W1=w-d(2)
    W2=w-d(3)
    W3=w-d(4)
    
    a02w=(a(3)+Dad02*W2)
    a03w=(a(4)+Dad03*W3)
    a12w=(a(3)+Dad12*W2)
    a13w=(a(4)+Dad13*W3)
    
    !printf("out: w=%g: %10g %10g %10g %10g \n",w,a02w,a12w,a03w,a13w )
    
    Dcd02=(c(1)-c(3))/dd02
    Dcd12=(c(2)-c(3))/dd12
    Dcd03=(c(1)-c(4))/dd03
    Dcd13=(c(2)-c(4))/dd13
    
    If (a02w>0.0_t_real .And. a12w <=0.0_t_real) Then
       !printf(" 02 full 12 03 13 empty\n")
       pre0=-1.0_t_real/(dd02*dd03)
       c02w=(c(3)+Dcd02*W2)
       dcd0212=Dcd02-Dcd12
       dcd0203=Dcd02-Dcd03
       dad0212=Dad12-Dad02
       dad0203=Dad03-Dad02
       iterm02=-pre0/dd12*(3.0_t_real*c02w&
            &+(dcd0212/dad0212+dcd0203/dad0203)*a02w)*a02w*a02w&
            &/(dad0212*dad0203)
    Elseif(a12w>0.0_t_real .And. a03w <=0.0_t_real .And.&
         & a13w <=0.0_t_real)Then
       !printf(" 02 12 full 03 13 empty\n")
       
       c02w=(c(3)+Dcd02*W2)
       c12w=(c(3)+Dcd12*W2)
       dad0212=Dad12-Dad02
       dad0203=Dad03-Dad02
       dad1213=Dad13-Dad12
       dcd0212=Dcd02-Dcd12
       dcd0203=Dcd02-Dcd03
       dcd1213=Dcd12-Dcd13
       dd23=d(3)-d(4)
       Dad23=(a(3)-a(4))/dd23
       dad0223=Dad23-Dad02
       y=a02w
       y2=y*y
       iterm02=-(dad0203*dcd1213+dcd0203*dad1213)*dd23*y2*y&
            &/(dd02*dad0203*dad0203*dd03*dd12*dad1213*dad1213*dd13)&
            &-3.0_t_real*(dad0223*dcd1213*W2+c02w*dad1213)*dd23*y2&
            &/(dd02*dad0203*dd03*dd12*dad1213*dad1213*dd13)&
            &-3.0_t_real*W2*(dad1213*(dcd0212*W2+c12w)+dad0212*dcd1213*W2&
            &-dcd0212*dad1213*W2+c02w*dad1213)*y&
            &/(dd02*dd12*dad1213*dad1213*dd13)&
            &-dad0212*W2*W2*(dad0212*dcd1213*W2-2.0_t_real*dcd0212*dad1213*W2&
            &+3.0_t_real*c02w*dad1213)/(dd02*dd12*dad1213*dad1213*dd13)
    Elseif(a13w>0.0_t_real .And. a03w <=0.0_t_real) Then
       !printf(" 02 12 13 full 03 empty\n")
       pre0=-1.0_t_real/(dd02*dd03)
       dd01=d(1)-d(2)
       c03w=(c(4)+Dcd03*W3)
       dad0313=Dad13-Dad03
       dad0203=Dad03-Dad02
       dcd0313=Dcd03-Dcd13
       dcd0203=Dcd02-Dcd03
       iterm02=(&
            & W1*W1*W1*(-Dcd03*dd03+(Dcd13+Dcd12+Dcd03+Dcd02)*(dd03+dd12)&
            &-Dcd12*dd12)/(dd02*dd03*dd12*dd13)&
            & +3.0_t_real*W1*W1*(Dcd03*dd12*dd13+Dcd02*dd12*dd13&
            &+c(2)*(dd13+dd02))/(dd02*dd03*dd12*dd13)&
            & -3.0_t_real*(dd01*Dcd03+dd01*Dcd02+(-c(1)-c(2)))*W1/(dd02*dd03)&
            &+dd01*(dd01*Dcd03+dd01*Dcd02+(-2.0_t_real*c(1)-c(2)))/(dd02*dd03)&
            & )&
            &-pre0/dd13*(3.0_t_real*c03w&
            &+(dcd0313/dad0313+dcd0203/dad0203)*a03w)&
            & *a03w*a03w/(dad0313*dad0203)
    Elseif(a03w>0.0_t_real .And. a13w <=0.0_t_real) Then
       !printf(" 02 12 03 full 13 empty\n")
       pre1=1.0_t_real/(dd12*dd13)
       dd01=d(1)-d(2)
       dad0313=Dad13-Dad03
       dad1213=Dad13-Dad12
       dcd0313=Dcd03-Dcd13
       dcd1213=Dcd12-Dcd13
       c13w=(c(4)+Dcd13*W3)
       
       iterm02=(&
            & W1*W1*W1*(-Dcd03*dd03+(Dcd13+Dcd12+Dcd03+Dcd02)*(dd03+dd12)&
            & -Dcd12*dd12)/(dd02*dd03*dd12*dd13)&
            & +3.0_t_real*W1*W1*(Dcd03*dd12*dd13+Dcd02*dd12*dd13&
            & +c(2)*(dd13+dd02))/(dd02*dd03*dd12*dd13)&
            & -3.0_t_real*(dd01*Dcd03+dd01*Dcd02+(-c(1)-c(2)))*W1/(dd02*dd03)&
            & +dd01*(dd01*Dcd03+dd01*Dcd02+(-2.0_t_real*c(1)-c(2)))/(dd02*dd03)&
            & )&
            &-pre1/dd03*(3.0_t_real*c13w&
            &+(dcd0313/dad0313+dcd1213/dad1213)*a13w)&
            &*a13w*a13w/(dad0313*dad1213)
       
    Elseif(a13w>0.0_t_real) Then
       !printf(" 02 12 03 13 full\n")
       dd01=d(1)-d(2)
       iterm02=(&
            & W1*W1*W1*(-Dcd03*dd03+(Dcd13+Dcd12+Dcd03+Dcd02)*(dd03+dd12)&
            & -Dcd12*dd12)/(dd02*dd03*dd12*dd13)&
            & +3.0_t_real*W1*W1*(Dcd03*dd12*dd13+Dcd02*dd12*dd13&
            & +c(2)*(dd13+dd02))/(dd02*dd03*dd12*dd13)&
            & -3.0_t_real*(dd01*Dcd03+dd01*Dcd02+(-c(1)-c(2)))*W1/(dd02*dd03)&
            & +dd01*(dd01*Dcd03+dd01*Dcd02+(-2.0_t_real*c(1)-c(2)))/(dd02*dd03)&
            & )  
    Endif
    !!
    iterm02=iterm02*sig
    
    Return
    !!
  End Function iterm02
  !!***********************************************************************
  Subroutine read_old_optics_file(optics,protect)
    !!
    Implicit None
    !!IO
    Type(T_Optics),Intent(inout) :: optics
    Logical(t_log),Intent(in)    :: protect
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_old_optics_file"
    Logical(t_log) :: exists
    !!
    Inquire(file='=.optics',exist=exists)
    If(.Not.exists) Return
    !!
    If(protect)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'''=.optics'' found, this is old style ... ',/&
            &,' use the ''optics'' submenu in fedit instead!.',/&
            &,' Remove ''=.optics'' to re-run.'")
    Endif
    !!
    Write(outfile,1865)
1865 Format('file ''=.optics'' found will read optics input')
    Open(12,file='=.optics')
    Read(12,*)
    Read(12,*)optics% active,optics% jointdos,optics% bandoutput
    Read(12,*)
    Read(12,*)optics% Ne,optics% emin,optics% emax
    Close(12)
    !!
    !!
    !!
    !!
    Return
    !!
  End Subroutine read_old_optics_file
  !!***********************************************************************
  
End Module optics
