Module optionstest
  !!
  Use precisiondefs
  Use errors
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="OPTIONSTEST"  
  !!
  Public :: T_Options,isoption,g_options,fplo_opt,atom_opt,init_options
  !!***********************************************************************
  Type T_Options
     Integer(t_int)          :: noptions
     Character(50),Pointer  :: p_options(:)
  End Type T_Options
  !! global options (input flags)
  Type(T_Options),Target :: g_options
  !! default options 
  Character(20),Parameter :: fplo_opt(31)=(/&
       & '-CALC_DOS           '&
!CPA:       &,'-BEB                '&
       &,'-NOT_USED           '&
       &,'-FULLBZ             '&
       &,'-CALC_PLASMON_FREQ  '&
       &,'-EMPTY_LATTICE_TEST '&
       &,'-NO_DOS             '&
       &,'-PLOT_REALFUNC      '&
       &,'-PLOT_BASIS         '&
       &,'-TEST_LOI           '&
       &,'-TEST_DIAGNO        '&
       &,'-TEST_SYMMETRIZATION'&
       &,'-TEST_HS_SYM        '&
       &,'-PROT_PRINT_BASIS   '&
       &,'-PROT_MAKELATTICE   '&
       &,'-PROT_STRUCTURE_PRNT'&
       &,'-PROT_TCI           '&
!CPA:       &,'-PROT_CPA           '&
       &,'-NOT_USED           '&
!CPA:       &,'-PROT_CPAEFITER     '&
       &,'-NOT_USED           '&
!CPA:       &,'-PRCA               '&
       &,'-NOT_USED           '&
       &,'+NO_SYMMETRYTEST    '& 
       &,'-NO_POTENTIAL       '& 
       &,'-NOT_USED           '&
       &,'-NO_CORE            '&
       &,'-NOT_USED           '&
       &,'-NO_POPANALYSIS     '&
       &,'-NO_LOI             '&
       &,'-NO_BASIS           '&
       &,'-NO_EFCH            '&
       &,'-NOT_USED           '&
       &,'-NOT_USED           '&
       &,'-NOT_USED           '&
       &/)
  !!
  Character(20),Parameter :: atom_opt(4)=(/&
       & '-SIC_ALL            '&
       &,'-SIC_4F             '&
       &,'-CALC_ONLY_OCCUPIED '&
       &,'+FORCE_POSITIVE_SPIN'&
       &/)
  !!
Contains
  !!***********************************************************************
  Logical(t_log) Function isoption(option,options)
    !!
    Implicit None 
    !!IO
    Character(*),Intent(in)    :: option
    Type(T_Options),Intent(in),Optional,Target :: options
    !!LOCAL
    Type(T_Options),Pointer :: p
    Integer(t_int) :: i
    !!
    If(Present(options)) Then
       p=>options
    Else
       p=>g_options
    End If
    
    
    Do i=1_t_int,p % noptions
       
       If(Trim(p % p_options(i)(2_t_int:)) == Trim(option) ) Then
          If(p % p_options(i)(1_t_int:1_t_int)=='+')Then
             isoption=.True.
             Return 
          End If
          
       End If
       
    End Do
    
    isoption=.False.
  End Function isoption
  !!***********************************************************************
  Subroutine init_options(op)
    Implicit None 
    !!IO
    Type(T_Options),Intent(inout),Optional :: op
    !!LOCAL
    If(Present(op)) Then
       Nullify(op% p_options)
    Else
       Nullify(g_options% p_options)
    Endif

  End Subroutine init_options
  !!***********************************************************************
  
  
End Module optionstest
