Module prnt
  !!
  Use precisiondefs
  Use file_iounits
  Use constants
  Use matserv
  Use tmesh
  Use mesh
  Use versioncontrol
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="PRNT"  
  !!
  Public :: printfunc,PRINTFUNC_DENS,PRINTFUNC_RAW,PRINTFUNC_POT&
       &,printmat,printmatsb,printmatdiag,PRINTFUNC_VEWLOC
  !!***********************************************************************
  !!***********************************************************************
  !! printfunc switches
  Integer(t_int),Parameter :: PRINTFUNC_RAW  =0_t_int
  Integer(t_int),Parameter :: PRINTFUNC_DENS =1_t_int
  Integer(t_int),Parameter :: PRINTFUNC_POT  =2_t_int
  Integer(t_int),Parameter :: PRINTFUNC_VEWLOC=4_t_int
  !!***********************************************************************
  Interface printmat
     Module Procedure cprintmat11,cprintmat12,cprintmat21,cprintmat22&
          &,printmat11,printmat21,printmat22
  End Interface printmat
Contains
  !!***********************************************************************
  !! write function f defined on mesh x into file=fname.site.spin
  Subroutine printfunc(meshs,nrp,f,mspin,nsite,isrt,elements&
       &,mlmp,nlmp,lmp,fname,swl)
    !!
    Implicit None
    !!IO
    Type(T_Mesh),Pointer     :: meshs(:)
    Character(*),Intent(in)  :: fname
    Character(2),Intent(in)  :: elements(:)
    Integer(t_int),Intent(in):: mspin,nsite,mlmp,nlmp(nsite),lmp(mlmp,nsite)
    Integer(t_int),Intent(in):: swl,nrp,isrt(nsite)
    Real(t_real),Intent(in)  :: f(nrp,mlmp,nsite,mspin)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="printfunc"
    Integer(t_int) :: ir,ms,isa,j,l,il,nj,ml,n0,issa
    Real(t_real)  :: ri,rl
    Character(200):: str
    Type(T_Mesh),Pointer     :: mesh
    !!
    Do ms=1_t_int,mspin
       Do isa=1_t_int,nsite

          issa=isrt(isa)
          !!
          mesh => meshs(issa)
          !!
10        Format(a,'.',i3.3,'.',i1.1)
          Write(str,10)Trim(fname),isa,ms

          Open(12,file=str,status='unknown')
          Write(12,100) Trim(FPLOMAINVERSION)
          Write(12,101) elements(issa)
          Call write_mesh_info(12_t_int,mesh)


          !!
          !! n=n00*Y00/r^2
          !! int_d3r n=int_r r^2 int_dW n00*Y00/r^2
          !!          =int_r sqrt(4 pi) n00
          !!
          !!

          nj=nlmp(isa)
          Do j=1_t_int,nj
             il=lmp(j,isa)
             l=llilm(il)
             ml=mmilm(il)-l-1_t_int
             !Write(12,2)l,ml
             If(l==0)Then
                Write(12,991)l,ml
             Else
                Write(12,99)l,ml
             Endif
             n0=1_t_int
             If(swl ==PRINTFUNC_DENS)Then 
                n0=2_t_int
             Endif
             Do ir=n0,mesh% nr
                ri=mesh% p_rmesh(ir)
                rl=1.0_t_real
                
                If(swl ==PRINTFUNC_DENS) Then
                   !! here we print the L>0 component as is
                   rl=1.0_t_real/(ri*ri)
                   !! here we print the L=0 component times r^2*Sqrt(4 Pi)
                   !! which integrates to the number of electrons
                   If(l == 0_t_int) rl=sq4pi
                Endif
                If(swl ==PRINTFUNC_POT)Then
                   If(l == 0_t_int) Then
                      rl=1.0_t_int/sq4pi
                   Else
                      If(ir==1)Then
                         rl=0.0_t_int
                      Else
                         rl=1.0_t_int/ri
                      Endif
                   Endif
                Endif
                If(swl ==PRINTFUNC_VEWLOC)Then
                   rl=1.0_t_real
                Endif
                !!
                Write(12,4) ri,f(ir,j,isa,ms)*rl
             Enddo               ! ir
             Write(12,107)l,ml
             Write(12,5)
          Enddo                 ! j
          Close(12)

       Enddo                   ! isa
    Enddo                     ! ms
    !!
!2   Format('# l : ',i4,'  m: ',i4)
4   Format(2(e30.15e3,1x))
5   Format(' ')
100 Format('# Version: ',a)
101 Format('# element: ',a2)
991 Format('# <start function sqrt(4*pi)*r^2* l : ',i4,'  m: ',i4,'>')
99  Format('# <start function l : ',i4,'  m: ',i4,'>')
107 Format('# <end function l : ',i4,'  m: ',i4,'>')
    !!
  End Subroutine printfunc
  !!***********************************************************************
  Subroutine printmat21(txt,fmt,fmt0,h,ndim1,ndim2,tol)
    Implicit None
    !!IO      
    Character(*),Intent(in)      :: txt,fmt,fmt0
    Integer(t_int),Intent(in)    :: ndim1,ndim2
    Real(t_real),Intent(in)      :: h(ndim1,ndim2)
    Real(t_real),Intent(in)      :: tol
    !!LOCAL
    Integer(t_int) :: i,j
    Real(t_real)   :: d
    !!
    Write(outfile,2)Trim(txt)
2   Format('printmat: ',a)
    Do i=1,ndim1
       Do j=1,ndim2
          d=h(i,j)
          If(Abs(d)<tol)Then
             Write(outfile,fmt0,advance='no') 
          Else
             Write(outfile,fmt,advance='no') d
          Endif

       Enddo
       Write(outfile,*)
    Enddo
    !!
  End Subroutine printmat21
  !!***********************************************************************
  !! for matrix h_{ij} subblock gives a subblock 
  !! subblock(4)=[ i0,i1 ,j0,j1 ]
  Subroutine printmatsb(txt,fmt,fmt0,h,ndim1,ndim2,tol,subblock,trans)
    Implicit None
    !!IO      
    Character(*),Intent(in)      :: txt,fmt,fmt0
    Integer(t_int),Intent(in)    :: ndim1,ndim2
    Integer(t_int),Intent(in),Optional    :: subblock(4)
    Logical(t_log),Intent(in),Optional    :: trans
    Real(t_real),Intent(in)      :: h(ndim1,ndim2)
    Real(t_real),Intent(in)      :: tol
    !!LOCAL
    Logical(t_log) :: dotr
    Integer(t_int) :: i,j,i0,i1,j0,j1
    Real(t_real)   :: d
    !!
    dotr=.False.
    If(Present(trans))Then
       If(trans)Then
          dotr=.True.
       Endif
    Endif
    !!
    Write(outfile,2)Trim(txt)
2   Format('printmat: ',a)
    i0=1
    i1=ndim1
    j0=1
    j1=ndim2
    If(Present(subblock))Then
       i0=Max(1_t_int,subblock(1))
       i1=Min(subblock(2),ndim1)
       j0=Max(1_t_int,subblock(3))
       j1=Min(subblock(4),ndim2)
    Endif
    If(dotr)Then
       i=i0
       i0=j0
       j0=i
       i=i1
       i1=j1
       j1=i
    Endif
    Do i=i0,i1
       Do j=j0,j1
          If(dotr)Then
             d=h(j,i)
          Else
             d=h(i,j)
          Endif
          If(Abs(d)<tol)Then
             Write(outfile,fmt0,advance='no') 
          Else
             Write(outfile,fmt,advance='no') d
          Endif

       Enddo
       If(j1>j0-1) Write(outfile,*)
    Enddo
    !!
  End Subroutine printmatsb
  !!***********************************************************************
  Subroutine cprintmat11(txt,fmt,fmt0,h,ndim1,tol)
    Implicit None
    !!IO      
    Character(*),Intent(in)      :: txt,fmt,fmt0
    Integer(t_int),Intent(in)    :: ndim1
    Complex(t_real),Intent(in)   :: h(ndim1)
    Real(t_real),Intent(in)      :: tol
    !!LOCAL
    Integer(t_int) :: i
    Complex(t_real)   :: c
    !!
    Write(outfile,2)Trim(txt)
2   Format('printmat: ',a)
    Do i=1,ndim1
       c=h(i)
       If(Abs(c)<tol)Then
          Write(outfile,fmt0,advance='no') 
       Else
          Write(outfile,fmt,advance='no') c
       Endif
    Enddo
    Write(outfile,*)
!1   Format(f10.4,1x)
!11  Format('    0     ',1x)
    !!
  End Subroutine cprintmat11
  !!***********************************************************************
  Subroutine printmat11(txt,fmt,fmt0,h,ndim1,tol)
    Implicit None
    !!IO      
    Character(*),Intent(in)      :: txt,fmt,fmt0
    Integer(t_int),Intent(in)    :: ndim1
    Real(t_real),Intent(in)      :: h(ndim1)
    Real(t_real),Intent(in)      :: tol
    !!LOCAL
    Integer(t_int) :: i
    Real(t_real)   :: c
    !!
    Write(outfile,2)Trim(txt)
2   Format('printmat: ',a)
    Do i=1,ndim1
       c=h(i)
       If(Abs(c)<tol)Then
          Write(outfile,fmt0,advance='no') 
       Else
          Write(outfile,fmt,advance='no') c
       Endif
    Enddo
    Write(outfile,*)
!1   Format(f10.4,1x)
!11  Format('    0     ',1x)
    !!
  End Subroutine printmat11
  !!***********************************************************************
  Subroutine cprintmat12(txt,fmt,fmt0,h,tol)
    Implicit None
    !!IO      
    Character(*),Intent(in)      :: txt,fmt,fmt0
    Complex(t_real),Intent(in)   :: h(:)
    Real(t_real),Intent(in),Optional :: tol
    !!LOCAL
    Integer(t_int) :: i,ndim1
    Real(t_real)   :: ltol
    Complex(t_real)   :: c
    !!
    If(Present(tol))Then
       ltol=tol
    Else
       ltol=1.0e-6_t_real
    Endif
    ndim1=Size(h,1)
    Write(outfile,2)Trim(txt)
2   Format('cprintmat: ',a)
    Do i=1,ndim1
       c=h(i)
       If(Abs(c)<ltol)Then
          Write(outfile,fmt0,advance='no') 
       Else
          Write(outfile,fmt,advance='no') c
       Endif
       
    Enddo
    Write(outfile,*)
!1   Format(f10.4,1x)
!11  Format('    0     ',1x)
    !!
  End Subroutine cprintmat12
  !!***********************************************************************
  Subroutine cprintmat21(txt,fmt,fmt0,h,ndim1,ndim2,tol)
    Implicit None
    !!IO      
    Character(*),Intent(in)      :: txt,fmt,fmt0
    Integer(t_int),Intent(in)    :: ndim1,ndim2
    Complex(t_real),Intent(in)   :: h(ndim1,ndim2)
    Real(t_real),Intent(in)      :: tol
    !!LOCAL
    Integer(t_int) :: i,j
    Complex(t_real)   :: c
    !!
    Write(outfile,2)Trim(txt)
2   Format('cprintmat: ',a)
    Do i=1,ndim1
       Do j=1,ndim2
          c=h(i,j)
          If(Abs(c)<tol)Then
             Write(outfile,fmt0,advance='no') 
          Else
             Write(outfile,fmt,advance='no') c
          Endif

       Enddo
       Write(outfile,*)
    Enddo
    !!
  End Subroutine cprintmat21
  !!***********************************************************************
  Subroutine printmat22(txt,fmt,fmt0,h,tol)
    Implicit None
    !!IO      
    Character(*),Intent(in)      :: txt,fmt,fmt0
    Real(t_real),Intent(in)      :: h(:,:)
    Real(t_real),Intent(in),Optional :: tol
    !!LOCAL
    Integer(t_int) :: i,j,ndim1,ndim2
    Real(t_real)   :: ltol,c
    !!
    If(Present(tol))Then
       ltol=tol
    Else
       ltol=1.0e-6_t_real
    Endif
    ndim1=Size(h,1)
    ndim2=Size(h,2)
    Write(outfile,2)Trim(txt)
2   Format('printmat: ',a)
    Do i=1,ndim1
       Do j=1,ndim2
          c=h(i,j)
          If(Abs(c)<ltol)Then
             Write(outfile,fmt0,advance='no') 
          Else
             Write(outfile,fmt,advance='no') c
          Endif

       Enddo
       Write(outfile,*)
    Enddo
!1   Format(f10.4,1x)
!11  Format('    0     ',1x)
    !!
  End Subroutine printmat22
  !!***********************************************************************
  Subroutine cprintmat22(txt,fmt,fmt0,h,tol)
    Implicit None
    !!IO      
    Character(*),Intent(in)      :: txt,fmt,fmt0
    Complex(t_real),Intent(in)   :: h(:,:)
    Real(t_real),Intent(in),Optional :: tol
    !!LOCAL
    Integer(t_int) :: i,j,ndim1,ndim2
    Real(t_real)   :: ltol
    Complex(t_real)   :: c
    !!
    If(Present(tol))Then
       ltol=tol
    Else
       ltol=1.0e-6_t_real
    Endif
    ndim1=Size(h,1)
    ndim2=Size(h,2)
    Write(outfile,2)Trim(txt)
2   Format('cprintmat: ',a)
    Do i=1,ndim1
       Do j=1,ndim2
          c=h(i,j)
          If(Abs(c)<ltol)Then
             Write(outfile,fmt0,advance='no') 
          Else
             Write(outfile,fmt,advance='no') c
          Endif

       Enddo
       Write(outfile,*)
    Enddo
!1   Format(f10.4,1x)
!11  Format('    0     ',1x)
    !!
  End Subroutine cprintmat22
  !!***********************************************************************
  Subroutine printmatdiag(txt,fmt,fmt0,h,ndim1,ndim2)
    Implicit None
    !!IO      
    Character(*),Intent(in)      :: txt,fmt,fmt0
    Integer(t_int),Intent(in)    :: ndim1,ndim2
    Real(t_real),Intent(in)      :: h(ndim1,ndim2)
    !!LOCAL
    Integer(t_int) :: i,j
    Real(t_real)   :: d
    !!
    Write(outfile,2)Trim(txt)
2   Format('printmat1: ',a)
    Do i=1,ndim1
       Do j=1,ndim2
          d=h(i,j)
          If(i==j)Then
             If(Abs(d)<1.0e-10_t_real)Then
                Write(outfile,fmt0,advance='no') 
             Else
                Write(outfile,fmt,advance='no') d
             Endif
          Endif
       Enddo
       Write(outfile,*)
    Enddo
!1   Format(f10.4,1x)
!11  Format('    0     ',1x)
    !!
  End Subroutine printmatdiag
  !!***********************************************************************

End Module prnt
