
  !!***********************************************************************
  Subroutine splinetest()
    !!
    Use precisiondefs
    Use tmesh
    Use mesh
    Use memory
    Use errors
    Use spline
    Use bspline
    Use prnt
    Use matrixinvers
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="splinetest"
    Character(2000) :: fname,oname
    Logical(t_log) :: indef
    Integer(t_int) :: nline,i,nr,j,jderiv
    Integer(t_int) :: p,k
    Real(t_real)   :: dum,d,a,dy1,cc,cd,sd,sd1,sd2,sf,sf1,sf2,iisf,df1,dfN
    Real(t_real)   :: int,h,sum,iisd,iisd1,iisd2
    Real(t_real),Pointer :: r(:),f(:),d2f(:),work(:),iif(:),iid2f(:)
    Real(t_real),Pointer :: p_q(:),p_knots(:)
    Integer :: eof
    !!
    Nullify(r,f,d2f,work,iif,iid2f)
    !!
    Open(12,file='=.splineit')
    Read(12,*)
    Read(12,*)fname
    Read(12,*)
    Read(12,*)oname
    Read(12,*)
    Read(12,*)
    Read(12,*)nr, jderiv
    Close(12)
    !!
    Print *,'input file=',Trim(fname)
    Print *,'outfile =',Trim(oname)
    !!
    Open(12,file=Trim(fname))
    nline=0
    countloop: Do
       Read(12,fmt=*,iostat=eof) dum,dum
       !Print *,dum,eof
       If(eof < 0 ) Exit countloop
       nline=nline+1
    Enddo countloop
    !!
    Print *,'nline=',nline
    !cd=1.0_t_real
    !cc=8.0_t_real
    !!
    Call palloc('r',r,1_t_int,nline,nmodule,nsubfunc)
    Call palloc('f',f,1_t_int,nline,nmodule,nsubfunc)
    Rewind(12)
    Do i=1,nline
       Read(12,fmt=*) r(i),f(i)
       f(i)=testfunc(r(i),0_t_int)
       !a=(4.0_t_real-0.75_t_real)*Real(i-1,t_real)/(nline-1)+0.75_t_real
       !r(i)=a
       !f(i)=(1.0_t_real/(a/1.0_t_real)**12-2.0_t_real/(a/1.0_t_real)**6)
    Enddo
    Close(12)
    !!
    !!
    Call palloc("d2f",d2f,1_t_int,nline,nmodule,nsubfunc)
    Call palloc("work",work,1_t_int,nline,nmodule,nsubfunc)
    Call palloc('iif',iif,1_t_int,nline,nmodule,nsubfunc)
    Call palloc('iid2f',iid2f,1_t_int,nline,nmodule,nsubfunc)

    !!
    !!
    !!
    Call nanspline(nline,r,f,d2f,work,1_t_int)
    !!
    !h=r(2)-r(1)
    !iid2f(1)=(f(2)-f(1))/h-(2.0_t_real*d2f(1)+d2f(2))*h/6.0_t_real
    iif(1)=0.0_t_real
    sum=0.0_t_real
    Do i=2,nline
       !!
       h=r(i)-r(i-1)
       !!
       If (h == 0.0_t_real) Stop 'bad x input '
       !!
       int=h*(f(i)+f(i-1))*0.5_t_real-(d2f(i-1)+d2f(i))*(h**3)/24.0_t_real
       !!
       sum=sum+int
       iif(i)=sum
       !sd1=(f(i)-f(i-1))/h+(2.0_t_real*d2f(i)+d2f(i-1))*h/6.0_t_real
       !iid2f(i)=sd1
    Enddo
    !iid2f(:)=0.0_t_real
    !!
    Call splint(nline,r,f,d2f,r(1),df1,sd1,sd2)
    Call splint(nline,r,f,d2f,r(nline),dfN,sd1,sd2)
    
    Call nanspline(nline,r,iif,iid2f,work,1_t_int,df1=df1,dfN=dfN)
    !Call nanspline(nline,r,iif,iid2f,work,1_t_int)
    !!
    Call printmat1('iif',"(f15.7,' ')","('       0        ')"&
         &,iif,nline,1_t_int,1.0e-10_t_real)
    Call printmat1('iid2f',"(f15.7,' ')","('       0        ')"&
         &,iid2f,nline,1_t_int,1.0e-10_t_real)
    !!
    !!
    Open(12,file=Trim(oname))
    Do i=1,nr
       a=(r(nline)-r(1))*Real(i-1,t_real)/(nr-1)+r(1)
       Call splint(nline,r,f,d2f,a,sd,sd1,sd2)
       Call splint(nline,r,iif,iid2f,a,iisd,iisd1,iisd2)
       
       !sf=(1.0_t_real/(a/1.0_t_real)**12-2.0_t_real/(a/1.0_t_real)**6)
       !sf1=-(12.0_t_real/(a/1.0_t_real)**13-12.0_t_real/(a/1.0_t_real)**7)/1.0_t_real
       sf=testfunc(a,0_t_int)
       sf1=testfunc(a,1_t_int)
       sf2=testfunc(a,2_t_int)
       iisf=testfunc(a,-1_t_int)-testfunc(r(1),-1_t_int)
       d=(iisf-iisd)
       !If(i/=1)d=d/iisf
       Write(12,10) a,sf,sd,iisf,iisd,d
    Enddo
    Close(12)
    !!
    !! 
!!$    Nullify(p_q,p_knots)
!!$    !! define knot sequence
!!$    p=3
!!$    k=p+1
!!$    !!
!!$    Call palloc("p_q",p_q&
!!$         &,1_t_int,(2_t_int*k-1_t_int)*nline,nmodule,nsubfunc)
!!$    Call palloc("p_knots",p_knots,1_t_int,nline+k,nmodule,nsubfunc)
!!$    Call palloc("work",work,1_t_int,nline,nmodule,nsubfunc)
!!$
!!$    
!!$    Do i=1,k/2
!!$       p_knots(i)=r(1)-0.1*(k/2-i+1)
!!$       p_knots(i)=r(1)
!!$       !! i=1: 0
!!$       !! i=k/2: k/2-1
!!$    Enddo
!!$    Do i=1+k/2,nline+k/2
!!$       Print *,i,(i-k/2),r(i-k/2)
!!$       p_knots(i)=r(i-k/2)
!!$    Enddo
!!$    Do i=nline+k/2+1,nline+k
!!$       p_knots(i)=r(nline)+0.1*(i-nline-k/2+1)
!!$       p_knots(i)=r(nline)
!!$    Enddo
!!$    
!!$
!!$    p_knots(1:k)=r(1)
!!$    p_knots(k+1:nline)=r(k+1-k/2:nline-k/2)
!!$    p_knots(nline+1:nline+k)=r(nline)
!!$
!!$
!!$    Do i=1,nline
!!$       Print *,'r(i)=',r(i)
!!$    Enddo
!!$
!!$    Do i=1,nline+k
!!$       Print "('t(',i2,')=',f15.7)",i,p_knots(i)
!!$    Enddo
!!$
!!$
!!$    Call bsplint(r,p_knots,nline,k,p_q,work)
!!$
!!$
!!$    Do i=1,nline
!!$       work(i)=f(i)
!!$    Enddo
!!$    
!!$
!!$    Call banslv(p_q,2*k-1,nline,k-1,k-1,work)
!!$    
!!$    Open(12,file='+spl')
!!$    Do i=1,nline
!!$       a=(r(nline)-r(1))*Real(i-1,t_real)/(nr-1)+r(1)
!!$       !Call splint(nline,r,f,d2f,a,d,dd,d2d)
!!$       d=bvalue(p_knots,work,nline,k,a,0_t_int)
!!$       dd=bvalue(p_knots,work,nline,k,a,1_t_int)
!!$       d2d=bvalue(p_knots,work,nline,k,a,2_t_int)
!!$
!!$       Call splint(nline,r,f,d2f,a,sd,sd1,sd2)
!!$
!!$       !Write(12,10) a,d,(cd*a**4+cc*a**3-6*a**2+11*a-13),sd,d-sd
!!$       !Write(12,10) a,dd,(4*cd*a**3+3*cc*a**2-12*a+11),sd1,dd-sd1
!!$       Write(12,10) a,d2d,(12*cd*a**2+6*cc*a-12),sd2,d2d-sd2
!!$    Enddo
!!$    Close(12)
!!$
!!$    !!
!!$    Open(12,file='+b')
!!$    Do j=1,nline
!!$       work=0.0_t_real
!!$       work(j)=1.0_t_real
!!$       Do i=1,nr
!!$          a=(p_knots(nline+k)-p_knots(1))*Real(i-1,t_real)/(nr-1)+p_knots(1)
!!$          d=bvalue(p_knots,work,nline,k,a,0_t_int)
!!$          Write(12,10) a,d
!!$       Enddo
!!$       Write(12,*)
!!$    Enddo
!!$    Do i=1,nline
!!$       Write(12,10) r(i),0.0_t_real
!!$       Write(12,10) r(i),1.0_t_real
!!$       Write(12,*)
!!$    Enddo
!!$    Close(12)
!!$
    !!
    !!
    Call pfree(work)
    Call pfree(d2f)
    Call pfree(r)
    Call pfree(f)
    !!
    Call terminate(TERM_NORMAL,'Spline')
    !!
    Return
    !!
10  Format(10(e30.15e3,2x))
  End Subroutine splinetest
  !!***********************************************************************
  Real(t_real) Function testfunc(x,jderiv)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: jderiv
    Real(t_real),Intent(in)      :: x
    !!LOCAL
    Character(*),Parameter::nsubfunc="testfunc"
    Real(t_real)   :: cc,cd
    !!
    cd=1.0_t_real
    cc=8.0_t_real
    !!
    If(jderiv==-1) testfunc=cd*x**5/5+cc*x**4/4-6*x**3/3+11*x**2/2-13*x
    If(jderiv==0) testfunc=cd*x**4+cc*x**3-6*x**2+11*x-13
    If(jderiv==1) testfunc=4*cd*x**3+3*cc*x**2-12*x+11
    If(jderiv==2) testfunc=12*cd*x**2+6*cc*x-12
    If(jderiv==3) testfunc=24*cd*x+6*cc
    If(jderiv==4) testfunc=24*cd
    If(jderiv>=5) testfunc=0.0_t_real
    !!
    Return
    !!
  End Function testfunc
  !!***********************************************************************
  Real(t_real) Function L20(c)
    !!
    Use precisiondefs
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: c
    !!LOCAL
    Character(*),Parameter::nsubfunc="L20"
    !!
    !!
    L20=(1-c)*(1-2*c)
    !!
    Return
    !!
  End Function L20
  !!***********************************************************************
  Real(t_real) Function L21(c)
    !!
    Use precisiondefs
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: c
    !!LOCAL
    Character(*),Parameter::nsubfunc="L21"
    !!
    !!
    L21=4*c*(1-c)
    !!
    Return
    !!
  End Function L21
  !!***********************************************************************
  Real(t_real) Function L22(c)
    !!
    Use precisiondefs
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: c
    !!LOCAL
    Character(*),Parameter::nsubfunc="L22"
    !!
    !!
    L22=c*(2*c-1)
    !!
    Return
    !!
  End Function L22
