Module string
  !!
  Use precisiondefs
  Use errors
  Use memory
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="STRING"  
  !!
  Public :: scopy,replace,concat

  Interface scopy
     Module Procedure ctos,stoc
  End Interface
  !!***********************************************************************
Contains 
  !!***********************************************************************
  Function stoc(s)
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)      :: s
    Character(1)     :: stoc(len(s))
    !!LOCAL
    !Character(*),Parameter::nsubfunc="ctos"
    Integer(t_int) :: i
    !!
    Do i=1,Len(s)
       stoc(i)=s(i:i)
    Enddo
    !!
    !!
    Return
    !!
  End Function stoc
  !!***********************************************************************
  Function ctos(c)
    !!
    Implicit None
    !!IO
    Character(1),Intent(in)      :: c(:)
    Character(size(c))     :: ctos
    !!LOCAL
    !Character(*),Parameter::nsubfunc="ctos"
    Integer(t_int) :: i
    !!
    Do i=1,size(c)
       ctos(i:i)=c(i)
    Enddo
    !!
    !!
    Return
    !!
  End Function ctos
  !!***********************************************************************
  Subroutine replace(c,heystack,needle,rep) 
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)      :: heystack
    Character(*),Intent(in)      :: needle
    Character(*),Intent(in)      :: rep
    Character(1),Pointer         :: c(:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="replace"
    Integer(t_int) :: i,j,lr,ln,lc,lhs
    !!
    !!
    j=Index(heystack,needle)
    If(j>0)Then
       !!
       lr=Len(rep)
       ln=Len(needle)
       lhs=Len(heystack)
       lc=lhs-ln+lr
       Call palloc('c',c,1_t_int,lc,nmodule,nsubfunc)
       
       !!c(1:j-1)=(/(heystack(i:i),i=1,j-1)/)
       Do i=1,j-1
          c(i)=heystack(i:i)
       Enddo
       !!c(j:j+lr-1)=(/(rep(i:i),i=1,lr)/)
       Do i=1,lr
          c(j+i-1)=rep(i:i)
       Enddo
       !!c(j+lr:lr+lhs-ln)=(/(heystack(i:i),i=j+ln,lhs)/) <-wrong
       Do i=j+ln,Len(heystack)
          c(lr-ln+i)=heystack(i:i)
       Enddo
       
    Else
       lhs=Len(heystack)
       Call palloc('c',c,1_t_int,lhs,nmodule,nsubfunc)
       !!c(1:lhs)=(/(heystack(i:i),i=1,lhs)/)
       Do i=1,lhs
          c(i)=heystack(i:i)
       Enddo
    Endif
    !!
    !!
    Return
    !!
  End Subroutine replace
  !!***********************************************************************
  Function concat(a,b)
    !!
    Implicit None
    !!IO
    Character(*),Intent(in)      :: a,b
    Character(Len(a)+Len(b))   :: concat
    !!LOCAL
    !Character(*),Parameter::nsubfunc="concat"
    !!
    !!
    concat=a // b
    !!
    Return
    !!
  End Function concat
  !!***********************************************************************


End Module string
