Module tcpa
  !!
  Use precisiondefs
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="TCPA"  
  !!
  Public :: T_Cpacontrol,T_Trace,init_trace,init_cpacontrol &
       &,CPA_FERMI_METHOD_SECANT,CPA_FERMI_METHOD_BISEC,CPA_FERMI_METHODS
  !!***********************************************************************
  Type T_Cpacontrol
     Integer(t_int) :: max_ef_loops,nec,max_se_loops,istart
     Real(t_real)   :: emin0,emax0,efermi0,slop_0,slop_min
     Integer(t_int) :: fermi_method
     Integer(t_int) :: nedos
     Real(t_real)   :: eimagdos
     Real(t_real)   :: eimagscf
     Logical(t_log) :: invprt !! is there a subset of nonrandom sites
     Integer(t_int) :: nblock !! index of last orbital in last random block 
     Real(t_real)   :: son(2)
  End Type T_Cpacontrol
  !!
  Type T_Trace
     Integer(t_int),Pointer :: p_ning(:,:)
     Real(t_real),Pointer   :: p_trace(:,:,:,:,:,:,:)
  End Type T_Trace


  
  !!***********************************************************************
  !!
  Integer(t_int),Parameter :: CPA_FERMI_METHOD_SECANT=1_t_int
  Integer(t_int),Parameter :: CPA_FERMI_METHOD_BISEC=2_t_int
  Character(16),Parameter :: CPA_FERMI_METHODS(2)=(/&
       & 'secant method   '&
       &,'bisection method'/)
  !!***********************************************************************
Contains
  Subroutine init_trace(trace)
    Implicit None 
    !!IO
    Type(T_Trace),Intent(inout) :: trace
    !!LOCAL
    Nullify(trace% p_ning)
    Nullify(trace% p_trace)
  End Subroutine init_trace
  !!***********************************************************************
  Subroutine init_cpacontrol(cc)
    Implicit None 
    !!IO
    Type(T_Cpacontrol),Intent(inout) :: cc
    !!LOCAL
    !! avoid wanings
    cc% invprt=.False.
    cc% istart=0_t_int
  End Subroutine init_cpacontrol
  !!***********************************************************************
  
  

End Module tcpa
