Module tkohnsham
  !!
  Use precisiondefs
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="TKOHNSHAM"  
  !!
  Public :: T_Kohnsham,init_kohnsham
  !!***********************************************************************
  Type T_Kohnsham
     !! dimension of valenve and core part
     Integer(t_int) :: nvdim,ncdim,nchidim !!TODO: check
     !! minimum of occupied bands 
     Integer(t_int) :: io_nband
     Integer(t_int) :: nband
     !! max number of states at a single atom, equals the maximum number
     !! of rows and columns of a site1,site2-sub-block
     Integer(t_int) :: nvsmx,ncsmx,nchismx
     Complex(t_real),Pointer :: p_ccvk(:,:,:,:) !nband,nkp,nvdim,nspin
     Complex(t_real),Pointer :: p_ccck(:,:,:,:) !nband,nkp,ncdim,nspin
     Complex(t_real),Pointer :: p_ccvkbeb(:,:,:,:)! nvdim,nvdim,nkp,mspin
     Complex(t_real),Pointer :: p_ccckbeb(:,:,:,:)
     Complex(t_real),Pointer :: p_nccbeb(:,:,:) !! onsite core-core occus
     Complex(t_real),Pointer :: p_ncvbeb(:,:,:) !! onsite core-valence occus
     !! the valence eigenvalues are ebk0, which are the outpu 
     !! of H C=S C ebk0
     Real(t_real),Pointer :: p_ebk0(:,:,:) ! nvdim,nkp,nspin
     !! For fsm and not FREL the energies are modified by 
     !! ebkfsm_s=ebk0_s+s*Bfsm, where s=spin index
     !! this allows to use a common Fermi energy almost everywhere.
     !! For FREL there is only a common Fermi energy and ebkfsm=ebk0
     !! is modifies by the fsm procedure
     Real(t_real),Pointer :: p_ebkfsm(:,:,:) ! nvdim,nkp,nspin
     Real(t_real),Pointer :: p_bweitk(:,:,:)! nband,nkp,nspin
     Real(t_real)         :: czval
     !! in the matricees site isa starts with index vblockstart(isa) and
     !! ends with vlbockend(isa) and has length vblocklength
     !! valence
     Integer(t_int),Pointer :: p_vblockstart(:) !1:nsite !!TODO: check
     Integer(t_int),Pointer :: p_vblockend(:)   !1:nsite !!TODO: check
     Integer(t_int),Pointer :: p_vblocklength(:)!1:nsite !!TODO: check
     !! core
     Integer(t_int),Pointer :: p_cblockstart(:) !1:nsite !!TODO: check
     Integer(t_int),Pointer :: p_cblockend(:)   !1:nsite !!TODO: check
     Integer(t_int),Pointer :: p_cblocklength(:)!1:nsite !!TODO: check
     Integer(t_int),Pointer :: p_chiblockstart(:) !1:nsite
     Integer(t_int),Pointer :: p_chiblockend(:)   !1:nsite
     Integer(t_int),Pointer :: p_chiblocklength(:)!1:nsite
     !! in every site block the orbital subblock containing subblock 
     !! index nlm starts 
     !! at vblocklindex(1,nlm,isa) and has momentum vblocklindex(2,nlm,isa) 
     !! where i runs from 0 to maximum block size
     !! the index nlm starts at 1 at the beginning of every nlm 
     !! subblock
     Integer(t_int),Pointer :: p_vblocklindex(:,:,:) ! 1:2,1:kohnsham% nvsmx,1:nsite  !!TODO: check
     !!
     !! the valence block of basis state ivr of site isa starts at the matrix
     !! index p_vivrind(ivr,isa)
     Integer(t_int),Pointer :: p_vivrind(:,:) !basis% nRvmx,nsite
     !! the valence block of basis states with qn. nl of site isa start at the matrix
     !! index p_vivrind(ivr,isa): 
     !! Note: for FREL p_vivrind(nlj=l+1/2,isa)=p_vivrind(nlj=l-1/2,isa)
     Integer(t_int),Pointer :: p_vnlind(:,:) !basis% nRvmx,nsite

     !! core-diagonalization
     !! the energies per atom
     Real(t_real),Pointer   :: p_hc(:,:) ! nchidim,nspin
     !! core occus in core-solution-matrix order
     Real(t_real),Pointer   :: p_coccu(:,:,:) ! nchismx,nsite,nspin
     !! the coefficient matrix C(raw_c,contracted_c)
     !! non relativistic
     Real(t_real),Pointer   :: p_nczz(:,:,:,:) ! ncsmx,nchismx,nsite,mspin
     !! relativistic
     Complex(t_real),Pointer:: p_rczz(:,:,:) ! ncsmx,nchismx,nsite
     !! the orthogonalization matrix
     !! C_{c,\chi}*f_{\chi}*C_{\chi,c}
     !! where \chi is the contracted core index and c the raw one.
     !! f_{\chi} is the core KS occupation (realized by throwing away 
     !! the unused indices).
     !! nrel
     Real(t_real),Pointer   :: p_ncfc(:,:,:,:) ! ncsmx,ncsmx,nsite,mspin
     !! frel
     Complex(t_real),Pointer:: p_rcfc(:,:,:) ! ncsmx,ncsmx,nsite
     !! non/scalar-rel net-occus
     Real(t_real),Pointer   :: p_nonvv(:,:,:,:) !! nvsmx,nvsmx,nsite,ms
     Real(t_real),Pointer   :: p_noncv(:,:,:,:) !! ncsmx,nvsmx,nsite,ms
     Real(t_real),Pointer   :: p_noncc(:,:,:,:) !! ncsmx,nvsmx,nsite,ms
     !! full-rel net-occus
     !! the last dimension is needed for generalizing the occu routines
     Complex(t_real),Pointer   :: p_ronvv(:,:,:,:) !! nvsmx,nvsmx,nsite,1
     Complex(t_real),Pointer   :: p_roncv(:,:,:,:) !! ncsmx,nvsmx,nsite,1
     Complex(t_real),Pointer   :: p_roncc(:,:,:,:) !! ncsmx,nvsmx,nsite,1
     Logical(t_log) :: DOS_savememory_onstep
     !! fixed spin moment
     Real(t_real)       :: fsm_moment
     !! do fixed spin moment calculation ?
     Logical(t_log)     :: fsm
     !! fermi energies
     Real(t_real)   :: efermi
     !! the FSM constant magnetic field
     Real(t_real)   :: Bfsm
     !! constant external B-field
     Logical(t_log) :: haveBfield
     Real(t_real)   :: Bfield
  End Type T_Kohnsham
  !!***********************************************************************
Contains
  Subroutine init_kohnsham(ko)
    Implicit None 
    !!IO
    Type(T_Kohnsham),Intent(inout) :: ko 
    !!LOCAL
    ko% fsm=.False.
    ko% fsm_moment=0.0_t_real
    Nullify(ko% p_ccvk)
    Nullify(ko% p_ccck)
    Nullify(ko% p_ccvkbeb)
    Nullify(ko% p_ccckbeb)
    Nullify(ko% p_nccbeb)
    Nullify(ko% p_ncvbeb)
    Nullify(ko% p_ebk0)
    Nullify(ko% p_ebkfsm)
    Nullify(ko% p_bweitk)
    Nullify(ko% p_vblockstart)
    Nullify(ko% p_vblockend)
    Nullify(ko% p_vblocklength)
    Nullify(ko% p_cblockstart)
    Nullify(ko% p_cblockend)
    Nullify(ko% p_cblocklength)
    Nullify(ko% p_chiblockstart)
    Nullify(ko% p_chiblockend)
    Nullify(ko% p_chiblocklength)
    Nullify(ko% p_vblocklindex)
    Nullify(ko% p_vivrind)
    Nullify(ko% p_vnlind)
    Nullify(ko% p_coccu)
    Nullify(ko% p_hc)
    Nullify(ko% p_nczz)
    Nullify(ko% p_rczz)
    Nullify(ko% p_ncfc)
    Nullify(ko% p_rcfc)
    Nullify(ko% p_nonvv)
    Nullify(ko% p_noncv)
    Nullify(ko% p_noncc)
    Nullify(ko% p_ronvv)
    Nullify(ko% p_roncv)
    Nullify(ko% p_roncc)
    ko% DOS_savememory_onstep=.False.
    ko% Bfsm=0.0_t_real
    ko% haveBfield=.False.
    ko% Bfield=0.0_t_real
    !!
  End Subroutine init_kohnsham
  !!***********************************************************************
  

End Module tkohnsham
