Module TMPI
  !!
  Use precisiondefs
  !!
  Implicit None 
  !!
#if defined (MPI)
  Include 'mpif.h'
#endif
  !!
  Private
  !!
  Character(*),Parameter::nmodule="TMPI"  
  !!
  Public :: T_MPI,clean_mpi,g_mpi,request_slave_termination
  !!***********************************************************************
  Type T_MPI
     Logical(t_log) :: mpion
     Integer :: nprocs
     Integer :: my_rank
  End Type T_MPI
  !!***********************************************************************
  Type(T_MPI) :: g_mpi  
  !!***********************************************************************
Contains
  !!***********************************************************************
  Subroutine clean_mpi()
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="clean_mpi"
#if defined (MPI)
    Integer :: ierr
    !!
    !!
    If(g_mpi% mpion)Then
       !!
       Call mpi_finalize(ierr)
       !!
    Endif
    !!
#endif
    !!
    Return
    !!
  End Subroutine clean_mpi
  !!***********************************************************************
  Subroutine request_slave_termination()
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="request_slave_termination"
#if defined (MPI)
    Integer :: proc,tag,ierr
    !!
    Do proc=1,g_mpi% nprocs-1
       tag=0
       Call MPI_Send('die', 3, MPI_CHARACTER&
            &,proc, tag, MPI_COMM_WORLD, ierr)
    Enddo
    !!
#endif
    !!
    Return
    !!
  End Subroutine request_slave_termination
  !!***********************************************************************

End Module TMPI
