Module tnumerics
  !!
  Use precisiondefs
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="TNUMERICS"  
  !!
  Public :: T_Numerics,init_numerics
  !!***********************************************************************
  Type T_Numerics
     !! radial function interpolaiton degree
     Integer(t_int) :: degree
     !! number of fourier components per site for Ewald potential calculation
!     Integer(t_int) :: nfft_ewp_per_site
!     !! the old style cutoff factor such that p_ew=ewcutoff/(r_NN/2)
!     Real(t_real)   :: ewcutoff
     !! cut-off tolerance for radial Ewald compensation charges
     Real(t_real)   :: eweps_r
     !! cut-off tolerance for Fourier Ewald compensation charges
     Real(t_real)   :: eweps_g
     !! one center integrals, radial mesh points(TODO: remove)
     Integer(t_int) :: oci_nr
     !! Coulomb energy calculation, onsite radial mesh
     Integer(t_int) :: coulerg_nr
     !! Coulomb energy calculation, elliptical mesh
     Integer(t_int) :: coulerg_nxi,coulerg_neta
     !! overlap density calculation
     !!   radial and azimutal mesh points
     Integer(t_int) :: ovldns_nr,ovldns_neta
     !!   temporary radial mesh type
     Integer(t_int) :: ovldns_meshtype
     !!   temporary radial mesh rmin
     Real(t_real)   :: ovldns_rmin
     !! cutoff tolerances, defining maximum extension of radial functions
     Real(t_real) :: cuttol_orbital
     !! tolerance for symtest
     Real(t_real) :: symtesttol
     !!***********************************************************************
     
  End Type T_Numerics
  !!***********************************************************************
Contains
  Subroutine init_numerics(nu)
    Implicit None 
    !!IO
    Type(T_Numerics),Intent(inout) :: nu 
    !!LOCAL
    !! avoid wanings
    nu% degree=8_t_int
    nu% eweps_r=1.0e-5_t_real
    nu% eweps_g=1.0e-5_t_real
!    nu% ewcutoff=2.0_t_real
    nu% coulerg_nr=400_t_int
  End Subroutine init_numerics
  !!***********************************************************************
  
  



End Module tnumerics
