Module trelativistic
  !!
  Use precisiondefs
  Use errors
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="TRELATIVISTIC"  
  !!
  Public :: &
       & NON_RELATIVISTIC&
       &,SCALAR_RELATIVISTIC&
       &,SCALAR_RELATIVISTIC_KH&
       &,FULL_RELATIVISTIC&
       &,relat_name&
       &,MAP_RELAT_TYPES
  !!***********************************************************************
  Integer(t_int),Parameter :: NON_RELATIVISTIC   =1_t_int
  Integer(t_int),Parameter :: SCALAR_RELATIVISTIC=2_t_int
  Integer(t_int),Parameter :: FULL_RELATIVISTIC  =3_t_int
  Integer(t_int),Parameter :: SCALAR_RELATIVISTIC_KH=4_t_int
  Integer(t_int),Parameter :: relatnamelength         =22_t_int
  Character(relatnamelength),Parameter :: INT_RELAT_TYPES(4)=(/ &
       & "non relativistic      " &
       &,"scalar relativistic   "&
       &,"KH scalar relativistic"&
       &,"full relativistic     "&
       &/)
  Integer(t_int)           :: MAP_RELAT_TYPES(4)
  Data MAP_RELAT_TYPES/&
       & NON_RELATIVISTIC &
       &,SCALAR_RELATIVISTIC &
       &,SCALAR_RELATIVISTIC_KH &
       &,FULL_RELATIVISTIC &
       &/
Contains
  !!***********************************************************************
  !!***********************************************************************
  Character(relatnamelength) Function relat_name(relativistic)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: relativistic
    !!LOCAL
    Character(*),Parameter::nsubfunc="relat_name"
    Integer(t_int) :: index,i
    !!
    !!
    index=-1
    Do i=1,Size(MAP_RELAT_TYPES)
       If(MAP_RELAT_TYPES(i)==relativistic) Then
          index=i
          Exit
       End If
    Enddo
    If(index<0_t_int)Then
       Write(errbuf,"('''RELATIVISM-type ',i4,' is not supported!''')")&
            & relativistic
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg=Trim(errbuf))
    End If
    
    relat_name=INT_RELAT_TYPES(index)
    !!
    Return
    !!
  End Function relat_name
  !!***********************************************************************


  
End Module trelativistic
