Module tstm
  !!
  Use precisiondefs
  Use tmesh
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="TSTM"  
  !!
  Public :: T_STM,init_stm
  !!***********************************************************************
  Type T_STM
     !! do we bother?
     Logical(t_log) :: active
     !! which element
     Character(2)   :: element
     !! the single tip atom sits ar tau relative to the cartesian zero
     Real(t_real)   :: tau(3)
     !! the tip atom has a maximum radius
     Real(t_real)   :: maxradius
     !! max number of pairs
     Integer(t_int) :: npairmax
     !! how many pairs to site 
     Integer(t_int),Pointer :: p_npairs(:) !! nsite
     !! just for using existing routines
     Integer(t_int),Pointer :: p_ninpshell(:,:) !! npairmax,nsite
     !! which pairs
     Real(t_real),Pointer :: p_pairs(:,:,:)!!3,npairmax,nsite
     Real(t_real),Pointer :: p_pairabs(:,:)!!npairmax,nsite
     !! nuclear charge
     Real(t_real)   :: natom
     !! atompotential mesh
     Type(T_Mesh)   :: atommesh
     !! basis mesh
     Type(T_Mesh)   :: basmesh
     !! max orbital momentum
     Integer(t_int) :: lmx
     Character(200)   :: vatomfile,fvalfile,fkvalfile
     !! the spherical potential of the atom
     Real(t_real),Pointer :: p_vatom(:)
     !! number of orbitals
     Integer(t_int) :: nRv
     Integer(t_int),Pointer :: p_nnRv(:)
     Integer(t_int),Pointer :: p_lRv(:)
     Real(t_real),Pointer :: p_fv(:,:)
     Real(t_real),Pointer :: p_fkv(:,:)
     Real(t_real),Pointer :: p_ev(:)
     Real(t_real),Pointer :: p_delta(:)
     Real(t_real)   :: fgam
     !!
     Integer(t_int) :: tcivvdim,tcivcdim
     Real(t_real),Pointer :: p_tci_vv0 (:)
     Real(t_real),Pointer :: p_tci_vHv0(:)
     Real(t_real),Pointer :: p_tci_vc0 (:)
     Real(t_real),Pointer :: p_tci_vHc0 (:)
     Integer(t_int),Pointer :: p_tcivvindex(:,:)
     Integer(t_int),Pointer :: p_tcivcindex(:,:)
     Real(t_real),Pointer   :: p_akdIdV(:,:,:,:,:)
     Complex(t_real),Pointer:: p_Sts(:,:)
     Complex(t_real),Pointer:: p_Vts(:,:)
     !!
     Integer(t_int) :: nvdim
     !!
     Integer(t_int) :: nev
     Real(t_real)   :: v0,v1
     Real(t_real),Pointer :: p_voltage(:)
     !!
     Integer(t_int) :: mapNx,mapNy,mapN
     Real(t_real),Pointer :: p_mapxy(:,:)!2 , mapN 
     Real(t_real),Pointer :: p_map(:,:)!3 , mapN 
     !!
     !! sort nl-resolved data
     Integer(t_int) :: N_sort_nl
     Integer(t_int),Pointer :: p_sort_nl(:) ! N_sort_nl
     Real(t_real),Pointer :: p_akdIdVnl(:,:,:,:,:,:)
     !!
  End Type T_STM
  !!***********************************************************************
Contains  
  !!***********************************************************************
  Subroutine init_stm(stm)
    !!
    Implicit None
    !!IO
    Type(T_STM),Intent(inout)    :: stm
    !!LOCAL
    !Character(*),Parameter::nsubfunc="init_stm"
    !!
    stm% active=.False.
    Nullify(stm% p_pairs)
    Nullify(stm% p_pairabs)
    Nullify(stm% p_npairs)
    Nullify(stm% p_ninpshell)
    Nullify(stm% p_vatom)
    Nullify(stm% p_nnRv)
    Nullify(stm% p_lRv)
    Nullify(stm% p_fv)
    Nullify(stm% p_ev)
    Nullify(stm% p_delta)
    Nullify(stm% p_fkv)
    Nullify(stm% p_tci_vv0)
    Nullify(stm% p_tci_vHv0)
    Nullify(stm% p_tci_vc0)
    Nullify(stm% p_tci_vHc0)
    Nullify(stm% p_tcivvindex)
    Nullify(stm% p_tcivcindex)
    Nullify(stm% p_akdIdV)
    Nullify(stm% p_Sts)
    Nullify(stm% p_Vts)
    Nullify(stm% p_map)
    Nullify(stm% p_mapxy)
    Nullify(stm% p_voltage)
    Nullify(stm% p_sort_nl)
    Nullify(stm% p_akdIdVnl)
    !!
    Call init_mesh(stm% atommesh)
    Call init_mesh(stm% basmesh)
    !!
    Return
    !!
  End Subroutine init_stm
  !!***********************************************************************

End Module tstm
