Module tunfold
  !!
  Use precisiondefs
  Use errors
  Use memory
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="TUNFOLD"  
  !!
  Public :: T_Unfold,init_unfold,cleanup_unfold
  !!***********************************************************************
  !! NC means normal cell
  !! SC means super cell
  Type T_Unfold
     !! do we bother
     Logical(t_log) :: active
     !! maximum number of equivalent atoms
     Integer(t_int) :: maxSCsites
     !! number of definitions to project on
     Integer(t_int) :: ndefs
     !! site number in NC 
     Integer(t_int),Pointer :: p_NCsite(:)
     !! number of equivalent sites in SC
     Integer(t_int),Pointer :: p_count(:)
     !! is this one mixed elements?
     Logical(t_log),Pointer :: p_mixedel(:)
     !! which site in SC 
     Integer(t_int),Pointer :: p_SCsites(:,:) !! maxSCsites,ndefs
     !! max number of weights 
     Integer(t_int) :: nw
  End Type T_Unfold
  !!***********************************************************************
contains
  Subroutine init_unfold(un)
    Implicit None 
    !!IO
    Type(T_Unfold),Intent(inout) :: un
    !!LOCAL
    un% active=.False.
    un% maxSCsites=0_t_int
    un% ndefs=0_t_int
    Nullify(un% p_NCsite)
    Nullify(un% p_SCsites)
    Nullify(un% p_count)
    Nullify(un% p_mixedel)
  End Subroutine init_unfold
  !!***********************************************************************
  Subroutine cleanup_unfold(un)
    !!
    Implicit None
    !!IO
    Type(T_Unfold),Intent(inout) :: un
    !!LOCAL
    !Character(*),Parameter::nsubfunc="cleanup_unfold"
    !!
    Call pfree(un% p_NCsite)
    Call pfree(un% p_SCsites)
    Call pfree(un% p_count)
    Call pfree(un% p_mixedel)
    !!
    Return
  End Subroutine cleanup_unfold
  !!***********************************************************************


End Module tunfold
