/* @(#)tools.h
 */

#ifndef _TOOLS_H
#define _TOOLS_H 1

#include <stdio.h>

#ifdef	__cplusplus
extern "C" {
#endif
  
  extern char* strncpy0(char *dest,const char *src,size_t count);
  extern char* strncat0(char *dest,const char *src,size_t count);
  extern void doubletoratio(char *r,double d,long maxn,double tol);
  extern void dswap(double *a,double *b,long n);
  extern void iswap(long *a,long *b,long n);
  extern void dsort(long m,long n,const double *darray,long *iwk,double tol);
  extern void ishell(long m,long n,long *iarray);
  extern char* strncpy0(char *dest,const char *src,size_t count);
  extern long  isratio(double  *d,char *ptr);
  extern long isdouble(double  *d,char *ptr);
  extern void iwshell(long m,long n,const long *iarray,long *iwk);
  extern long idebfun(FILE *FH,const char *name,long over,char *line);
  extern void chop(char *p);
  extern void ratio(double d,long *m,long *n,long maxn,double tol);

  /* normalize vector */
  extern double norm(double *v,long n); 
  /* scalar product */
  extern double ddotn(const double *x,const double *y,long n);
  extern long   idotn(const long *x,const long *y,long n);
  /* x,y,R -> x,y,z : z=0 outsie sphere */ 
  extern void XYRtoXYZ(double *vec,double rad);
  /* v2-v1, return |v2-v1|*/
  extern double vdiff(const double *v1,const double *v2,double *v,long n);
  extern double *vplus(double *v,const double *v1,double a,long n);
  /* initialiye  arrays */
  extern void dinit(double *a,double x,long n); 
  extern void linit(long *a,long x,long n); 
  /* scale double array */
  extern void dscale(double *a,double x,long n);
  extern void iscal(long *a,long x,long n);
  /* 3x3 invert aa into iaa calc determinant */
  extern long dinv33(const double *aa,long opt,double *iaa,double *det);	
  /* cross product */
  extern void cross(const double *x1,const double *x2,double *cr12);
  extern void icross(const long *x1,const long *x2,long *cr12);
  /* v0=v1+v2*g */
  extern void vec1(double *v0,const double *v1,const double *v2,const double *g);
  /* v0=v2*g */
  extern void vec2(double *v0,const double *v2,const double *g,long n);
  /* v0=v1+v2*g mod unit cell */
/*   extern void vec(double *v0,const double *v1,const double *v2,const double *g */
/* 		  ,const double *cell,const double *rcell); */
  /* c=a*b a[i,j]=a[i+dim*j] */
  extern void matmult(double *cc,const double *aa,const double *bb
		      ,const long dim);
  double *AtimesV(double *res,const double *A,const double *v,long n);
  double *VtimesA(double *res,const double *v,const double *A,long n);
  extern void imatmult(long *cc,const long *aa,const long *bb,const long dim);
  /* transpose of matrix a[i,j]=a[i+dim*j] */
  extern void transpose(double *a,long dim);
  /* generate special rotation matrix */
  extern void rtomat(double *v,double *aa);
  /* spat product */
  extern double spat(const double *a1,const double *a2,const double *a3);
  extern long ispat(const long *a1,const long *a2,const long *a3);
  extern void lpiksrt(long *iarr,long n); 
  extern void luniq(long *iarr,long n,long *nap); 
  extern long pathExists(const char *pathname)  ;
  extern void removetrailingspace(char *s);
  extern long getcwdir(char **cwd);
  extern void lenTextStripWhitespace(const char *txt,long *i0,long *i1);
  extern void splitpath(char *dir,char *file,const char *path);
  extern char *strposprotect(const char *src,const char delimit);
  //extern long aloctmpfile(char **file,char *emsg);
  extern char *strstri(const char* haystack,const char *needle
		       ,long casesensitive);
  extern long ntoken(const char *line);
  extern char *sscan(char **src);
  
  //extern const char *mytmpname();

#ifdef	__cplusplus
}
#endif


#endif /* _TOOLS_H */

