/*************************************************************************
 * @(#)FileLoader.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   08 Jul 2012
 *************************************************************************
 */

#include <stdio.h>
#include "FileLoader.hh"
#include "MyMath.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void FileLoader::workOnIt()
{
  QMutexLocker locker(&mutex);
  
  if (!isRunning()) {
    start(LowestPriority);
  } 
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void FileLoader::interrupt()
{
  abort();
  emit progress(0.);
  emit aborted();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void FileLoader::abort()
{
  printf("Tester::abort()\n");
  mutex.lock();
  pabort=true; // request abort
  condition.wakeOne(); // make sure the thread is running to process
  mutex.unlock();
  
  wait(); // wait for run() to return
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void FileLoader::run()
{
  printf("Tester:run\n");
  
  printf("Tester:restart\n");
  mutex.lock();
  //read class data
  mutex.unlock();
  long N=100000;
  long subdiv=(MyMath::max<long>(1,N/(100/5)));
  
  for(long i=0;i<N;i++){
    printf("Tester:i=%ld\n",i);
    if(pabort) return;
    if((i % subdiv)==0){
      //myDebug()<<"progress"<<1.*i/N;
      emit progress(1.*i/N);
    }
  }
  emit progress(0.);
  emit resultReady();
  
  
}
/*EOF*/ 
