/* @(#)FileLoader.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _FILELOADER_HH
#define _FILELOADER_HH 1

#include <QThread>
#include <QMutex>
#include <QWaitCondition>


/* ***********************************************************************
 *
 * ***********************************************************************
 */
class FileLoader:public QThread{
  Q_OBJECT;
public:
  FileLoader(QObject *parent):QThread(parent),pabort(false){};;
  ~FileLoader(){ abort(); };

  void workOnIt();
  
signals:
  void resultReady();
  void aborted();
  void progress(double);

public slots:
  void interrupt();
protected:
  virtual void run();
private:
  void abort();
private:
  QMutex mutex;
  QWaitCondition condition;
  bool pabort;

};


#endif /* _FILELOADER_HH */

