TEMPLATE = app
LANGUAGE = C++
QMAKE_CXXFLAGS += -Wno-deprecated   -DQXFPL   
QMAKE_CFLAGS +=    

CONFIG += qt warn_off release help

#VPATH +=./ui/ ./src/

BASE=.
XFPLOSRCPATH=$$BASE/src/lib/XFPLO
DIALOGPATH=$$BASE/src/dialogs
ENGINEPATH=$$BASE/src/engine
PARSERPATH=$$BASE/src/parser
COMPATPATH=$$BASE/src/compat
COMMONPATH=$$BASE/src/lib/COMMON
BPPATH=$$BASE/src/lib/BP
IOPATH=$$BASE/src/lib/IO
INTERFACEPATH=$$BASE/src/lib/INTERFACE
TOOLSPATH=$$BASE/src/lib/TOOLS
QTPATH=$$BASE/src/qt

DEPENDPATH=$$BASE $$XFPLOSRCPATH $$DIALOGPATH $$ENGINEPATH $$QTPATH $$PARSERPATH $$COMPATPATH $$COMMONPATH  $$BPPATH $$TOOLSPATH  $$IOPATH $$INTERFACEPATH

INCLUDEPATH +=  src/lib/TOOLS src/lib/BP src/lib/IO src/lib/INTERFACE src/lib/SYM src/lib/COMMON src/lib/XFPLO/core src/lib/XFPLO/dialogs src/lib/XFPLO/qt\
	$$BASE/src \
	$$BASE/src/qt\
	$$DIALOGPATH\
	$$ENGINEPATH\
	$$QTPATH\
	$$XFPLOSRCPATH\
        $$PARSERPATH\
        $$COMPATPATH


SOURCES = \
	FileLoader.cpp\
	graphview.cpp\
	iofunc.cpp\
	main.cpp\
	plotview.cpp\
	$$ENGINEPATH/Attributes.cpp\
	$$ENGINEPATH/BSpline.cpp\
	$$ENGINEPATH/EllipseShape.cpp\
	$$ENGINEPATH/FGObject.cpp\
	$$ENGINEPATH/Function.cpp\
	$$ENGINEPATH/FunctionGroup.cpp\
	$$ENGINEPATH/FunctionGroups.cpp\
	$$ENGINEPATH/Functions.cpp\
	$$ENGINEPATH/Graph.cpp\
	$$ENGINEPATH/GraphAxis.cpp\
	$$ENGINEPATH/GraphObject.cpp\
	$$ENGINEPATH/Graphs.cpp\
	$$ENGINEPATH/IOControl.cpp\
	$$ENGINEPATH/LegendBox.cpp\
	$$ENGINEPATH/LineShape.cpp\
	$$ENGINEPATH/Page.cpp\
	$$ENGINEPATH/PaintEngine.cpp\
	$$ENGINEPATH/Paper.cpp\
	$$ENGINEPATH/ParameterList.cpp\
	$$ENGINEPATH/Point.cpp\
	$$ENGINEPATH/Position.cpp\
	$$ENGINEPATH/PSPaintEngine.cpp\
	$$ENGINEPATH/Shape.cpp\
	$$ENGINEPATH/TextBox.cpp\
	$$ENGINEPATH/TicMarks.cpp\
	$$ENGINEPATH/ViewBox.cpp\
	$$ENGINEPATH/WeightLabels.cpp\
	$$ENGINEPATH/WeightSelection.cpp\
	$$ENGINEPATH/World.cpp\
	$$ENGINEPATH/Xfp.cpp\
	$$DIALOGPATH/ApplyDlg.cpp\
	$$DIALOGPATH/AxesDlg.cpp\
	$$DIALOGPATH/AxesPropWdg.cpp\
	$$DIALOGPATH/BandDlgControl.cpp\
	$$DIALOGPATH/ComboBoxDelegate.cpp\
	$$DIALOGPATH/DataFileDialog.cpp\
	$$DIALOGPATH/DlgBase.cpp\
	$$DIALOGPATH/GraphDlg.cpp\
	$$DIALOGPATH/GraphPropWdg.cpp\
	$$DIALOGPATH/GraphsModel.cpp\
	$$DIALOGPATH/LegendBoxPropWdg.cpp\
	$$DIALOGPATH/MyPlainTextEdit.cpp\
	$$DIALOGPATH/PageSetupDlg.cpp\
	$$DIALOGPATH/PrintDlg.cpp\
	$$DIALOGPATH/PropWdgBase.cpp\
	$$DIALOGPATH/SetDlg.cpp\
	$$DIALOGPATH/SetPropWdg.cpp\
	$$DIALOGPATH/SetTreeModel.cpp\
	$$DIALOGPATH/SetTreeSelectionModel.cpp\
	$$DIALOGPATH/SetTreeView.cpp\
	$$DIALOGPATH/ShapeDlg.cpp\
	$$DIALOGPATH/ShapePropWdg.cpp\
	$$DIALOGPATH/ShapesModel.cpp\
	$$DIALOGPATH/TextBoxDlg.cpp\
	$$DIALOGPATH/TextBoxesModel.cpp\
	$$DIALOGPATH/TextBoxPropWdg.cpp\
	$$DIALOGPATH/TicMarksDlg.cpp\
	$$DIALOGPATH/TicMarksPropWdg.cpp\
	$$DIALOGPATH/TransformDlg.cpp\
	$$DIALOGPATH/UserTicModel.cpp\
	$$DIALOGPATH/UserTicWdg.cpp\
	$$DIALOGPATH/ViewBoxPropWdg.cpp\
	$$DIALOGPATH/WeightDefDlg.cpp\
	$$DIALOGPATH/WeightDefModel.cpp\
	$$DIALOGPATH/WeightLabelModel.cpp\
	$$DIALOGPATH/WeightSelListView.cpp\
	$$DIALOGPATH/WeightSelModel.cpp\
	$$DIALOGPATH/WorldPropWdg.cpp\
	$$DIALOGPATH/XNYDlgControl.cpp\
	$$PARSERPATH/ParamDriver.cpp\
	$$PARSERPATH/ParserFunctions.cpp\
	$$PARSERPATH/SetDescriptor.cpp\
	$$PARSERPATH/TempSetDescriptor.cpp\
	$$PARSERPATH/ParamLexer.yy.cc\
	$$PARSERPATH/ParamParser.tab.cc\
	$$COMMONPATH/Assorted.cpp\
	$$COMMONPATH/FString.cpp\
	$$COMMONPATH/MyDebug.cpp\
	$$COMMONPATH/MyMath.cpp\
	$$COMMONPATH/OutGrep.cpp\
	$$COMMONPATH/Parser.cpp\
	$$COMMONPATH/StringPtr.cpp\
	$$COMMONPATH/Sysinfo.cpp\
	$$COMMONPATH/ValueArray.cpp\
	$$COMMONPATH/Vec3.cpp\
	$$BPPATH/allocread.c\
	$$TOOLSPATH/allocate.c\
	$$TOOLSPATH/cbuffer.c\
	$$TOOLSPATH/constants.c\
	$$TOOLSPATH/helper.c\
	$$TOOLSPATH/merror.c\
	$$TOOLSPATH/tools.c\
	$$IOPATH/convtests.c\
	$$IOPATH/io.lex.yy.c\
	$$IOPATH/io.y.tab.c\
	$$IOPATH/ioparser.c\
	$$IOPATH/stdstack.c\
	$$IOPATH/table.c\
	$$IOPATH/tparser.c\
	$$IOPATH/vartable.c\
	$$INTERFACEPATH/cio.c\
	$$INTERFACEPATH/fortrantypes.c\
	$$BASE/src/xfpresources.cpp\
	$$XFPLOSRCPATH/core/AntiAliasing.cpp\
	$$XFPLOSRCPATH/dialogs/BrainDialog.cpp\
	$$XFPLOSRCPATH/dialogs/ColorButton.cpp\
	$$XFPLOSRCPATH/qt/ReselectEvent.cpp\
	$$XFPLOSRCPATH/qt/AfterShowEvent.cpp\
	$$XFPLOSRCPATH/core/Settings.cpp\
	$$XFPLOSRCPATH/qt/ShortCuts.cpp\
	$$XFPLOSRCPATH/dialogs/ToolButtons.cpp\
	$$XFPLOSRCPATH/dialogs/HelpDlg.cpp\
	$$XFPLOSRCPATH/dialogs/HelpBrowser.cpp\
	$$XFPLOSRCPATH/dialogs/SearchWidget.cpp\
	$$XFPLOSRCPATH/core/XfploHelp.cpp\
	$$XFPLOSRCPATH/qt/valid.cpp\
	$$QTPATH/ButtonStatusWidget.cpp\
	$$QTPATH/DlgReg.cpp\
	$$QTPATH/FileActions.cpp\
	$$QTPATH/GraphToolBox.cpp\
	$$QTPATH/MainWindow.cpp\
	$$QTPATH/ObserveView.cpp\
	$$QTPATH/ParameterDocument.cpp\
	$$QTPATH/QtPaintEngine.cpp\
	$$QTPATH/WeightSetDataEvent.cpp\
	$$QTPATH/XFPStatusBar.cpp\
	$$COMPATPATH/ReadOldGraph.cpp
FORMS = \
	ui/ApplyDlg.ui\
	ui/AxesDlg.ui\
	ui/AxesPropWdg.ui\
	ui/BandDlgControl.ui\
	ui/ButtonStatusWidget.ui\
	ui/DlgBase.ui\
	ui/GraphDlg.ui\
	ui/GraphPropWdg.ui\
	ui/GraphToolBox.ui\
	ui/HelpDlg.ui\
	ui/LegendBoxPropWdg.ui\
	ui/PageSetupDlg.ui\
	ui/PrintDlg.ui\
	ui/SearchWidget.ui\
	ui/SetDlg.ui\
	ui/SetPropWdg.ui\
	ui/ShapeDlg.ui\
	ui/ShapePropWdg.ui\
	ui/TextBoxDlg.ui\
	ui/TextBoxPropWdg.ui\
	ui/TicMarksDlg.ui\
	ui/TicMarksPropWdg.ui\
	ui/TransformDlg.ui\
	ui/UserTicWdg.ui\
	ui/ViewBoxPropWdg.ui\
	ui/WeightDefDlg.ui\
	ui/WorldPropWdg.ui\
	ui/XNYDlgControl.ui
HEADERS = \
	ui/ApplyDlg.ui\
	ui/AxesDlg.ui\
	ui/AxesPropWdg.ui\
	ui/BandDlgControl.ui\
	ui/ButtonStatusWidget.ui\
	ui/DlgBase.ui\
	ui/GraphDlg.ui\
	ui/GraphPropWdg.ui\
	ui/GraphToolBox.ui\
	ui/HelpDlg.ui\
	ui/LegendBoxPropWdg.ui\
	ui/PageSetupDlg.ui\
	ui/PrintDlg.ui\
	ui/SearchWidget.ui\
	ui/SetDlg.ui\
	ui/SetPropWdg.ui\
	ui/ShapeDlg.ui\
	ui/ShapePropWdg.ui\
	ui/TextBoxDlg.ui\
	ui/TextBoxPropWdg.ui\
	ui/TicMarksDlg.ui\
	ui/TicMarksPropWdg.ui\
	ui/TransformDlg.ui\
	ui/UserTicWdg.ui\
	ui/ViewBoxPropWdg.ui\
	ui/WeightDefDlg.ui\
	ui/WorldPropWdg.ui\
	ui/XNYDlgControl.ui\
	defs.hh\
	FileLoader.hh\
	graphview.hh\
	iofunc.hh\
	plotview.hh\
	Tester.hh\
	$$ENGINEPATH/Attributes.hh\
	$$ENGINEPATH/BSpline.hh\
	$$ENGINEPATH/EllipseShape.hh\
	$$ENGINEPATH/FGObject.hh\
	$$ENGINEPATH/Function.hh\
	$$ENGINEPATH/FunctionGroup.hh\
	$$ENGINEPATH/FunctionGroups.hh\
	$$ENGINEPATH/Functions.hh\
	$$ENGINEPATH/Graph.hh\
	$$ENGINEPATH/GraphAxis.hh\
	$$ENGINEPATH/GraphObject.hh\
	$$ENGINEPATH/Graphs.hh\
	$$ENGINEPATH/IOControl.hh\
	$$ENGINEPATH/LegendBox.hh\
	$$ENGINEPATH/LineShape.hh\
	$$ENGINEPATH/MyProgressDialog.hh\
	$$ENGINEPATH/OptMatelDefinition.hh\
	$$ENGINEPATH/Page.hh\
	$$ENGINEPATH/PaintEngine.hh\
	$$ENGINEPATH/Paper.hh\
	$$ENGINEPATH/ParameterList.hh\
	$$ENGINEPATH/Point.hh\
	$$ENGINEPATH/Position.hh\
	$$ENGINEPATH/PSPaintEngine.hh\
	$$ENGINEPATH/Range.hh\
	$$ENGINEPATH/Shape.hh\
	$$ENGINEPATH/TextBox.hh\
	$$ENGINEPATH/TicMarks.hh\
	$$ENGINEPATH/ViewBox.hh\
	$$ENGINEPATH/WeightLabels.hh\
	$$ENGINEPATH/WeightSelection.hh\
	$$ENGINEPATH/World.hh\
	$$ENGINEPATH/Xfp.hh\
	$$PARSERPATH/location.hh\
	$$PARSERPATH/ParamDriver.hh\
	$$PARSERPATH/ParamLexer.yy.hh\
	$$PARSERPATH/ParamParser.tab.hh\
	$$PARSERPATH/ParserDecl.hh\
	$$PARSERPATH/ParserFunctions.hh\
	$$PARSERPATH/position.hh\
	$$PARSERPATH/SetDescriptor.hh\
	$$PARSERPATH/stack.hh\
	$$PARSERPATH/t.hh\
	$$PARSERPATH/TempSetDescriptor.hh\
	$$DIALOGPATH/ApplyDlg.hh\
	$$DIALOGPATH/AxesDlg.hh\
	$$DIALOGPATH/AxesPropWdg.hh\
	$$DIALOGPATH/BandDlgControl.hh\
	$$DIALOGPATH/ComboBoxDelegate.hh\
	$$DIALOGPATH/DataFileDialog.hh\
	$$DIALOGPATH/DlgBase.hh\
	$$DIALOGPATH/GraphDlg.hh\
	$$DIALOGPATH/GraphPropWdg.hh\
	$$DIALOGPATH/GraphsModel.hh\
	$$DIALOGPATH/InsertMenuData.hh\
	$$DIALOGPATH/LegendBoxDlg.hh\
	$$DIALOGPATH/LegendBoxPropWdg.hh\
	$$DIALOGPATH/MyAction.hh\
	$$DIALOGPATH/MyMenu.hh\
	$$DIALOGPATH/MyPlainTextEdit.hh\
	$$DIALOGPATH/PageSetupDlg.hh\
	$$DIALOGPATH/PrintDlg.hh\
	$$DIALOGPATH/PropWdgBase.hh\
	$$DIALOGPATH/SetDlg.hh\
	$$DIALOGPATH/SetPropWdg.hh\
	$$DIALOGPATH/SetTreeModel.hh\
	$$DIALOGPATH/SetTreeSelectionModel.hh\
	$$DIALOGPATH/SetTreeView.hh\
	$$DIALOGPATH/ShapeDlg.hh\
	$$DIALOGPATH/ShapePropWdg.hh\
	$$DIALOGPATH/ShapesModel.hh\
	$$DIALOGPATH/TextBoxDlg.hh\
	$$DIALOGPATH/TextBoxesModel.hh\
	$$DIALOGPATH/TextBoxPropWdg.hh\
	$$DIALOGPATH/TicMarksDlg.hh\
	$$DIALOGPATH/TicMarksPropWdg.hh\
	$$DIALOGPATH/TransformDlg.hh\
	$$DIALOGPATH/UserTicModel.hh\
	$$DIALOGPATH/UserTicWdg.hh\
	$$DIALOGPATH/ViewBoxDlg.hh\
	$$DIALOGPATH/ViewBoxPropWdg.hh\
	$$DIALOGPATH/WeightDefDlg.hh\
	$$DIALOGPATH/WeightDefModel.hh\
	$$DIALOGPATH/WeightLabelModel.hh\
	$$DIALOGPATH/WeightSelListView.hh\
	$$DIALOGPATH/WeightSelModel.hh\
	$$DIALOGPATH/WorldDlg.hh\
	$$DIALOGPATH/WorldPropWdg.hh\
	$$DIALOGPATH/XNYDlgControl.hh\
	$$XFPLOSRCPATH/core/AntiAliasing.hh\
	$$XFPLOSRCPATH/dialogs/BrainDialog.hh\
	$$XFPLOSRCPATH/dialogs/ColorButton.hh\
	$$XFPLOSRCPATH/dialogs/HelpBrowser.hh\
	$$XFPLOSRCPATH/qt/ReselectEvent.hh\
	$$XFPLOSRCPATH/qt/AfterShowEvent.hh\
	$$XFPLOSRCPATH/core/Settings.hh\
	$$XFPLOSRCPATH/qt/ShortCuts.hh\
	$$XFPLOSRCPATH/dialogs/ToolButtons.hh\
	$$XFPLOSRCPATH/dialogs/MyListView.hh\
	$$XFPLOSRCPATH/dialogs/SearchWidget.hh\
	$$XFPLOSRCPATH/dialogs/HelpDlg.hh\
	$$XFPLOSRCPATH/qt/Valid.hh\
	$$QTPATH/ButtonStatusWidget.hh\
	$$QTPATH/DlgReg.hh\
	$$QTPATH/FileActions.hh\
	$$QTPATH/GraphToolBox.hh\
	$$QTPATH/MainWindow.hh\
	$$QTPATH/MenuData.hh\
	$$QTPATH/ObserveView.hh\
	$$QTPATH/ParameterDocument.hh\
	$$QTPATH/QtPaintEngine.hh\
	$$QTPATH/WeightSetDataEvent.hh\
	$$QTPATH/XFPStatusBar.hh\
	$$COMPATPATH/ReadOldGraph.hh

RESOURCES = resources.qrc
TARGET = xfbp
target.path = "../../../bin/"
INSTALLS += target 
unix { 
    UI_DIR = .ui
    MOC_DIR = .moc
    OBJECTS_DIR = .obj
}
