/* @(#)iofunc.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _IOFUNC_H
#define _IOFUNC_H 1

#include <QObject>
#include <stdio.h>



class Graph;
class String;
class IOControl;
class FunctionGroup;

class IOFunc : public QObject
{
  Q_OBJECT;
 public:

  void readBandWeightData(Graph *graph,const String &fname
			  , IOControl *iobwc);

 signals:
  void statusMesg(const String &);
  void progress(int);


};

#ifdef	__cplusplus
extern "C" {
#endif



  
  extern void readXYFuncs(Graph *graph,const String &fname
			  ,IOControl *iofc);
  extern FunctionGroup *readGridFuncs(Graph *graph,const String &fname
				      ,const IOControl *iofc);

  extern void readBandData(Graph *graph,const String &fname
			   ,IOControl *iobc);



  extern long autoBPAdjustment(Graph *graph,IOControl *iobc);

  extern void readFploPointData(Graph *graph,const String &fname
				,FunctionGroup *group
				,long scale,double dkmin,double ddk);

#ifdef	__cplusplus
}
#endif


#endif /* _IOFUNC_H */

