#include <QApplication>
#include <stdlib.h>
#include <QDir>
#include "MainWindow.hh"
#include "heapcheck.h"
#include "Config.hh"
#include "ShortCuts.hh"
#include "AntiAliasing.hh"
#include "ReselectEvent.hh"
#include "AfterShowEvent.hh"
#include "Settings.hh"
#include "Assorted.hh"
#include "WeightSetDataEvent.hh"
#include "FString.hh"
#include "Except.hh"
#include "XfploHelp.hh"
#include <iostream>
#include "ParamDriver.hh"
#include "ParameterList.hh"
//#include "BSpline.hh"


AntiAliasing antiAliasing("graphview");
char lang[7] ="LANG=C";
char lcall[9]="LC_ALL=C";



const String  
#include "../mainversion.h" 
;

const String VERSION=FPLOMAINVERSION;

const String  
#include "../subversion.h" 
;
const String  
#include "../release.h" 
;

ParameterList parameterList;

const QString IDS_APP_NAME=QString("XFBP ") + FPLOMAINVERSION();
const QString IDS_APP_ABOUT=QString("XFBP\nVersion ") + FPLOMAINVERSION()
  + "\n(w) 2014 by Klaus Koepernik";

const QString IDS_APP_INI_PATH=QDir::homePath()+"/.xfbp";
const QString IDS_APP_HELP_PATH=IDS_APP_INI_PATH+"/Help";
const QString IDS_APP_HELP_FILE="xfbphelp";
const QString IDS_APP_HELP_FULL_FILE=IDS_APP_HELP_PATH+"/"+IDS_APP_HELP_FILE
  +".qhc";



//   class Double{
//     public:
//     Double():d(0){
//       printf("%p=default starts living\n",this);
//     }
//     Double(double dd):d(dd){
//       printf("%p=%g starts living\n",this,d);
//     }
//     ~Double(){
//       printf("%p=%g dies\n",this,d);
//     }
//     double d;
//   };


int main( int argc, char ** argv )
{

  // hack to force english numeric settings and stuff
  putenv(lang);
  putenv(lcall);

   // PtrArray<int> vi;
   // vi.append(new int(9));
   // vi.append(new int(-2));
   // vi.append(new int(13));
   // myDebug()<<vi;
   // vi.resize(5,false);
   // myDebug()<<vi;

//   PtrArray<ValueArray<int> > vvi;
//   vvi.append(new ValueArray<int>());
//   vvi.last()->append(1);
//   vvi.last()->append(3);
//   vvi.last()->append(5);
//   vvi.append(new ValueArray<int>());
//   vvi.last()->append(-2);
//   vvi.last()->append(-4);
//   vvi.last()->append(-6);
//   vvi.append(new ValueArray<int>());
//   vvi.last()->append(7);
//   vvi.last()->append(14);
//   myDebug()<<vvi;
//   ValueArray<int> vint;
//   vint.append(13);
//   vint.append(17);
//   vint.append(21);
//   vint.append(29);
//   vvi.resize(6,false,vint);
//   (*vvi[5])[2]=112;
//   myDebug()<<vvi;

//   return 1;
  
  //myDebug()<<argc<<argv[1];
  // if(argc>1 && String(argv[1])=="-testspline"){
//     ValueArray<double> x;
//     ValueArray<double> y;
//     //x.createMesh(1,3,4);

//     FILE *FH=openforread("t");
//     String line;
//     while(getLine(FH,line)){
//       line.chop(" \t\n");
//       if(line.length()==0) break;
//       StringList sl=line.split(" \t");
//       x.append(sl[0].convertToFortranReal());
//       y.append(sl[1].convertToFortranReal());
//     }
//     fclose(FH);

//     myDebug()<<"read";
//     long nout=10000;
//     ValueArray<double> xout,yout(nout,0.),d2yout(nout,0.);
//     xout.createMesh(x.at(0),x.last(),nout);
//     try{
//       BSpline bsp(4,x);
//       //myDebug()<<"have bsp";
//       //bsp.writeBasisFunctions("+splinebasis",xout);
//       //myDebug()<<"wrote basis";
//       bsp.splint(y);
//       bsp.spline(xout,yout,0);
//       bsp.spline(xout,d2yout,2);
//       //myDebug()<<"did spline";
//       FILE *FH=openforwrite("es");
//       for(long i=0;i<xout.size();i++){
// 	fprintf(FH,"%g %g\n",xout.at(i),yout.at(i)*MyMath::max<double>(0,-d2yout.at(i))/20000);
//       }
//       fclose(FH);
//     }catch(Except &ex){
//       myDebug()<<ex.msg();
//     }
//     exit(1);
//   }

  Settings::setMainSettingsFile(QDir::homePath()+"/.xfbp/xfbp.ini");


//   ValueArray<int> v1;
//   ValueArray<int> v2;
//   v1.append(1);
//   v1.append(13);
//   v1.append(6);
//   v2.append(2);
//   v2.append(14);
//   v2.append(7);
//   v2.append(8);
//   printf("v1\n");
//   for(long i=0;i<v1.size();i++){
//     printf("%ld: %d\n",i,v1.at(i));
//   }
//   printf("v2\n");
//   for(long i=0;i<v2.size();i++){
//     printf("%ld: %d\n",i,v2.at(i));
//   }
//   printf("v1+v2\n");
//   v1.append(v2);
//   for(long i=0;i<v1.size();i++){
//     printf("%ld: %d\n",i,v1.at(i));
//   }

//   exit(0);
  if(0){
    ParamDriver driver;
    for (++argv; argv[0]; ++argv){
      if (*argv == std::string ("-p"))
	driver.setTraceParsing(true);
      else if (*argv == std::string ("-s"))
	driver.setTraceScanning(true);
      else{
	try{
	  driver.parse(*argv);
	}catch(Except &ex){
	  printf("ERROR: %s",ex.msg());
	}
      }
    }
    exit(0);
  }
  antiAliasing.readSettings();


  XfploHelp::createHelpFiles();

  //test();
  //return 1;


  //todo no autodelete


//   PtrArray1<Double> p;

//   Double *dm1=new Double(-1.);
//   Double *d0=new Double(0.1);
//   Double *d1=new Double(1.1);
//   Double *d2=new Double(2.2);
//   Double *d3=new Double(3.3);
//   Double *d21=new Double(2.21);
//   Double *d22=new Double(2.22);
//   Double *d8=new Double(8.8);
//   //todo
//   //p.resize();

/*
 #define PRT						\
   printf("size=%ld\n",p.size());			\
   for(int i=0;i<p.size();i++){				\
     printf("%d %p=%g\n",i,p.at(i),p.at(i)->d);		\
   }
*/
//   PRT;  
//   p.append(d1);
//   PRT;
//   p.append(d2);
//   PRT;
//   p.append(d3);
//   PRT;

//   //todo
//   p.insert(1,d21);
//   PRT;
//   p.insert(2,d22);
//   PRT;

//   p.insert(-1,dm1);
//   PRT;
//   p.insert(0,d0);
//   PRT;

//   p.insert(8,d8);
//   PRT;


//   Double *pd=p.take(d22);
//   printf("taken %p=%g\n",pd,pd->d);
//   PRT;

//   pd=p.take(0);
//   printf("taken %p=%g\n",pd,(pd?pd->d:0));
//   PRT;

//   p.remove(d3);

//   pd=p.takeAt(1);
//   printf("taken %p=%g\n",pd,pd->d);
//   PRT;

//   p.insert(0,pd);
//   PRT;

//   p.removeAt(3);
//   PRT;

  
//   return 0;


    ShortCuts::setDefaulShortCuts();

    AfterShowEvent::AfterShowEventType
      =(QEvent::Type)QEvent::registerEventType();
    ReselectEvent::ReselectEventType=(QEvent::Type)QEvent::registerEventType();
    WeightSetDataEvent::WeightSetDataEventType
      =(QEvent::Type)QEvent::registerEventType();
    

    
    QApplication app(argc,argv);
    app.connect(&app,SIGNAL(lastWindowClosed()),&app,SLOT(quit()));

    try{ 
      parameterList.scanCommandLine();
    }catch(Except &ex){
      myDebug()<<ex.msg();
      exit(1);
    }

    

    MainWindow w;
    w.show();
    try{
      return app.exec();
    }catch(Except &ex){
      myDebug()<<"error:"<<ex.msg();
    }
    
}
