/*************************************************************************
 * @(#)ApplyDlg.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   17 May 2011
 *************************************************************************
 */

#include "DlgReg.hh"
#include "ApplyDlg.hh"
#include "FString.hh"
#include "MyDebug.hh"
#include "Config.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
ApplyDlg::ApplyDlg(QWidget *parent,QWidget *base,const char *name)
  :BrainDialog(parent,base,name,true,false,false),pdlgreg(0)
{
  setupUi(this);
  setWindowTitle(IDS_APP_NAME);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ApplyDlg::setData(DlgReg *dlgreg)
{
  if(!dlgreg) return;
  
  pdlgreg=dlgreg;
  bool showall=dlgreg->nonChanged();
  foreach(DlgReg::DlgRegData *dd,dlgreg->pdata.values()){
    const QString &s=dd->pname;
    if(dd->pchanged||showall){
      QListWidgetItem *item=new QListWidgetItem(s,lwTake);
      item->setCheckState((dd->pchanged?Qt::Checked:Qt::Unchecked));
      item->setData(Qt::UserRole,QVariant::fromValue((void*)dd));
    }
  }
  cbShowAll->setChecked(showall);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
long ApplyDlg::applyDlg(QWidget *parent,DlgReg *dlgreg)
{
  ApplyDlg dlg(parent,parent,"ApplyDlg");
  dlg.setData(dlgreg);
  return dlg.exec();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ApplyDlg::on_pbOk_clicked()
{

  if(pdlgreg){
    for(int i=0;i<lwTake->count();i++){
      QListWidgetItem *item=lwTake->item(i);
      DlgReg::DlgRegData *dd=
	(DlgReg::DlgRegData*)item->data(Qt::UserRole).value<void*>();
      dd->papply=(item->checkState()==Qt::Checked);
    }
  }  
  QDialog::accept();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ApplyDlg::on_pbApplyAll_clicked()
{
  for(int i=0;i<lwTake->count();i++){
    QListWidgetItem *item=lwTake->item(i);
    DlgReg::DlgRegData *dd=
      (DlgReg::DlgRegData*)item->data(Qt::UserRole).value<void*>();
    dd->papply=true;
  }
  QDialog::accept();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ApplyDlg::on_cbShowAll_toggled(bool c)
{
  QMap<DlgReg::DlgRegData *,bool> tmpmap;
  for(int i=0;i<lwTake->count();i++){
    QListWidgetItem *item=lwTake->item(i);
    DlgReg::DlgRegData *dd=
      (DlgReg::DlgRegData*)item->data(Qt::UserRole).value<void*>();
    tmpmap[dd]=(item->checkState()==Qt::Checked);
  }
  lwTake->clear();

  bool showall=c;//pdlgreg->nonChanged()||c;
  foreach(DlgReg::DlgRegData *dd,pdlgreg->pdata.values()){
    const QString &s=dd->pname;
    bool check=false;
    if(tmpmap.contains(dd))check=tmpmap[dd];
    if(check||showall){
      QListWidgetItem *item=new QListWidgetItem(s,lwTake);
      item->setCheckState((check?Qt::Checked:Qt::Unchecked));
      item->setData(Qt::UserRole,QVariant::fromValue((void*)dd));
    }
  }
  
}


/*EOF*/ 
