/*************************************************************************
 * @(#)AxesDlg.cpp
 * author: magru@unas
 * date:   13 Jan 2014
 *************************************************************************
 */

#include <QMessageBox>
#include "AxesDlg.hh"
#include "AxesPropWdg.hh"
#include "GraphAxis.hh"
#include "Config.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
AxesDlg::AxesDlg(QWidget *parent,QWidget *base,const char *name)
  : BrainDialog(parent,base,name,false),
    t_axes(0)
    //,t_graphs(0),t_graph(0),grsmodel(0),
    //mute_currentIndexChanged(false)
{
  setupUi(this);
  setWindowTitle(IDS_APP_NAME);
  pbClose->setToolTip(IDS_CLOSE_TIP);
  pbApply->setToolTip(IDS_APPLY_TIP);
  pbCancel->setToolTip(IDS_CANCEL_TIP);

  connect(this,SIGNAL(endRequest()),this,SLOT(deleteLater()));
  if(wProps) delete wProps;
  wProps=new AxesPropWdg(this);
  verticalLayout->insertWidget(0,wProps,10);


}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
AxesDlg::~AxesDlg()
{
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void AxesDlg::setData(GraphAxes *axes)
{
  if(axes){
    t_axes=axes;
  }else{
    t_axes=0;
  }
  wProps->setData(t_axes);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool AxesDlg::dataAcceptable()
{
  QString s,txt="";

  if(wProps) wProps->check(txt);

  if(txt.length()){
    QMessageBox::warning ( this,IDS_APP_NAME 
			   , txt, 1, 0,0 ) ;
    return false;
  }


  return true;
 
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void AxesDlg::apply()
{
  if(wProps) wProps->applyData(t_axes);

  //shsmodel->resetItem(t_sh);
  emit acceptRequest(t_axes,false);
}


/*EOF*/ 
