/* @(#)AxesDlg.hh
 * author: magru@unas
 */

#ifndef _AXESDLG_HH
#define _AXESDLG_HH 1

#include <QCloseEvent>
#include "BrainDialog.hh"
#include "ui_AxesDlg.h"

class GraphAxes;
class GraphObject;

/* ***********************************************************************
 *
 * ***********************************************************************
 */


class AxesDlg: public BrainDialog, protected Ui::AxesDlg
{
  Q_OBJECT
public:
  AxesDlg(QWidget *parent,QWidget *base,const char *name);
  ~AxesDlg();

  void setData(GraphAxes *);
  void reloadDialog();

signals:
  void acceptRequest(GraphObject *,bool forceChanged);
  void endRequest();

public slots:
  virtual void reject(){ emit endRequest();}
protected:
  virtual void closeEvent( QCloseEvent * e ) {e->accept(); emit endRequest();}
  // virtual bool event(QEvent *event);

private slots:
  void on_pbApply_clicked(){ if(dataAcceptable()){apply();}}
  void on_pbCancel_clicked(){ reject(); }
  void on_pbClose_clicked(){
    if(dataAcceptable()){apply(); emit endRequest();return;}}
  void onDlgEnd(){deleteLater();}
  virtual void on_pbHelp_clicked(){}
  // void on_tvSets_myCurrentChanged(const QModelIndex &,const QModelIndex &);
  void onContentChanged(bool changed){pbApply->setEnabled(changed);}

  // void onToolsActionsTriggered();

  // QList<FGObject*> getSelectedFGObjects(bool considercurrent);
  // void triggerUpdate(){emit acceptRequest(t_graph,false);};
  // void slotMoveSetGroupSelection();
  // void slotDeleteSetGroupSelection();

private:
  // bool protectChanges(bool withCancel=true);
  bool dataAcceptable();
  void apply();
  // void selectFGObject(FGObject *fgo);
  // void enableToolButtons();

private:
  GraphAxes *t_axes;
  // SetTreeModel *stmodel;
  // SetTreeSelectionModel *stselmodel;
  // Graph *t_graph;
  // Page *t_page;
  // bool mute_currentIndexChanged;
  // QList<QAction*> toolactions;
  // bool pfirstcall;
  // ToolButtons *ptoolbuttons;
  // friend class SetPropWdg;
};

#endif /* _AXESDLG_HH */

