/*************************************************************************
 * @(#)AxesPropWdg.cpp
 * author: magru@unas
 * date:   13 Jan 2014
 *************************************************************************
 */

#include <QDebug>
#include "AxesPropWdg.hh"
#include "GraphAxis.hh"
#include "Xfp.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
AxesPropWdg::AxesPropWdg(QWidget *parent)
  :PropWdgBase(parent)
{
  setupUi(this);

  
  connectChanged(this);

  tabScaling->setEnabled(true);

  cmbXScaling->clear();
  for(int i=0;i<Xfp::maxGraphAxisScalingTypes();i++){
    cmbXScaling->insertItem(i,
			    Xfp::graphAxisScalingTypeGuiName((Xfp::GraphAxisScaling)i),i);
  }

  cmbYScaling->clear();
  for(int i=0;i<Xfp::maxGraphAxisScalingTypes();i++){
    cmbYScaling->insertItem(i,
			    Xfp::graphAxisScalingTypeGuiName((Xfp::GraphAxisScaling)i),i);
  }

  cmbXScaling->setFocus();

  setDirty(false);
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void AxesPropWdg::applyData(void *go)
{
  //NSF("applydata");
  if(!go) return;
  GraphAxes *ax=0;
  if(go) ax=dynamic_cast<GraphAxes*>((GraphObject *)go);

  
  //  ax->setActive(cbActive->isChecked());



  ax->setScaling(Xfp::Graph_X,((Xfp::GraphAxisScaling)cmbXScaling
			       ->itemData(cmbXScaling->currentIndex()).toInt()));
		 
  ax->setScaling(Xfp::Graph_Y,((Xfp::GraphAxisScaling)cmbYScaling
			       ->itemData(cmbYScaling->currentIndex()).toInt()));
  
		 
		 

  setDirty(false);
  
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void AxesPropWdg::setData(void *go)
{
  //myDebug()<<"setData";
  GraphAxes *ax=0;
  if(!go) PropWdgBase::reset(this);
  if(go) ax=dynamic_cast<GraphAxes*>((GraphObject *)go);
  p_axes=ax;

  
  if(!ax) {
    tabScaling->setEnabled(false);
    return;
  }


  cmbXScaling->setCurrentIndex(ax->axisScaling(Xfp::Graph_X));
  cmbYScaling->setCurrentIndex(ax->axisScaling(Xfp::Graph_Y));


  ax->setChanged(false);

  setDirty(false);

}
/*EOF*/ 
