/*************************************************************************
 * @(#)BandDlgControl.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   12 May 2011
 *************************************************************************
 */

#include <QColor>
#include "GraphObject.hh"
#include "FGObject.hh"
#include "Function.hh"
#include "Graph.hh"
#include "Graphs.hh"
#include "Page.hh"
#include "IOControl.hh"
#include "BandDlgControl.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
BandDlgControl::BandDlgControl(QWidget *parent)
  :QWidget(parent),piobc(0)
{
  setupUi(this);

  cmbAutoScale->clear();
  for(int i=0;i<IOControl::autoScaleMaxTypes();i++){
    cmbAutoScale->insertItem(i, IOControl::autoScaleGuiName(i) ,i);
  }

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
BandDlgControl::~BandDlgControl()
{
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void BandDlgControl::setData(IOControl *iobc,const Page *page)
{
  ppage=page;
  piobc=iobc;

  int ii=0;
  cmbGraph->clear();
  if(ppage->graphs()->size()>0)
    cmbGraph->insertItem( ii++,Graph::graphIDGuiName(Graph::CurrentGraph)
			  ,Graph::CurrentGraph);
  cmbGraph->insertItem( ii++,Graph::graphIDGuiName(Graph::NewGraph)
			,Graph::NewGraph);
  for(int i=0;i<ppage->graphs()->size();i++){
    const Graph *gr=ppage->graphs()->at(i);
    cmbGraph->insertItem( ii++,gr->guiName(true)(),(int)gr->ID());
  }
  int index=cmbGraph->findData((int)piobc->targetGraphId());
  if(index<0)index=0;
  cmbGraph->setCurrentIndex(index);

  cmbAutoScale->setCurrentIndex(piobc->autoScale());
  
  cbAutoColor->setChecked(iobc->autoColor());

  cbDefaultYLabel->setChecked(iobc->defaultYLabel());
  cbAdjustXTics->setChecked(iobc->adjustXTics());
  cbEFTic->setChecked(iobc->EFTic());
  cbHideXLabel->setChecked(iobc->hideXLabel());

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
IOControl *BandDlgControl::getData(  )
{
  if(!piobc) return 0;
  piobc->setAutoScale((IOControl::AutoScale)cmbAutoScale->currentIndex());

  
  piobc->setAutoColor(cbAutoColor->isChecked());

  piobc->setDefaultYLabel(cbDefaultYLabel->isChecked());

  piobc->setAdjustXTics(cbAdjustXTics->isChecked());

  piobc->setEFTic(cbEFTic->isChecked());    

  piobc->setHideXLabel(cbHideXLabel->isChecked());

  piobc->setTargetGraphId(cmbGraph->itemData(cmbGraph->currentIndex()).toInt());

  return piobc;
}


/*EOF*/ 



/*EOF*/ 
