/* @(#)DataFileDialog.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _DATAFILEDIALOG_H
#define _DATAFILEDIALOG_H 1

#include <QFileDialog> 
#include <QDir> 


class Page;
class IOControl;
class XNYDlgControl;
class BandDlgControl;

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class DataFileDialog:public QFileDialog
{

  Q_OBJECT
 public:
  enum Type{XNY=1,BAND=2};

  DataFileDialog(Type type,QWidget *parent,const QString &caption
		 ,IOControl *iofc,const Page *page
		 ,const QDir &dir,const QString &filter);
  ~DataFileDialog();

  void accept();

  

 private:
  XNYDlgControl *xnyctrl;
  BandDlgControl *bandctrl;
  Type ptype;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _DATAFILEDIALOG_H */

