/*************************************************************************
 * @(#)DlgBase.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   27 Apr 2011
 *************************************************************************
 */

#include <QMessageBox>
#include "DlgBase.hh"
#include "Config.hh"


DlgBase::DlgBase(QWidget *parent,QWidget *base,const char *name)
  : BrainDialog(parent,base,name,false),t_go(0)
{
  //myDebug()<<"hier DlgBase"<<this;
  setupUi(this);
  setWindowTitle(IDS_APP_NAME);

  pbClose->setToolTip(IDS_CLOSE_TIP);
  pbApply->setToolTip(IDS_APPLY_TIP);
  pbCancel->setToolTip(IDS_CANCEL_TIP);

  connect(this,SIGNAL(endRequest()),this,SLOT(onDlgEnd()));

  connect(wProps,SIGNAL(contentChanged(bool))
	  ,this,SLOT(onContentChanged(bool)));
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
DlgBase::~DlgBase()
{
  //  myDebug()<<"hier ~DlgBase"<<this;
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void DlgBase::on_pbApply_clicked()
{
  //myDebug() <<"FogDlg::on_pbApply_clicked";
  if(dataAcceptable()){
    apply();
  }
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void DlgBase::onContentChanged(bool changed)
{
  pbApply->setEnabled(changed);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void DlgBase::on_pbClose_clicked()
{
  //myDebug() <<"DlgBase::on_pbClose_clicked";
  if(dataAcceptable()){
    apply();
    emit endRequest();
    return;
  }
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool DlgBase::dataAcceptable()
{
  QString s,txt="";

  wProps->check(txt);

  if(txt.length()){
    QMessageBox::warning ( this,IDS_APP_NAME 
			   , txt, 1, 0,0 ) ;
    //myDebug() << "returning";
    return false;
  }

  //myDebug() << "END BondsDlg::dataAcceptable";

  return true;
 
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void DlgBase::apply()
{
  wProps->applyData(t_go);
  emit acceptRequest(t_go,false);
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void DlgBase::onDlgEnd()
{
  //myDebug()<<"DlgBase::onDlgEnd"<<this;
  deleteLater();
}


/*EOF*/ 
