/* @(#)DlgBase.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _DLGBASE_H
#define _DLGBASE_H 1

#include <QCloseEvent>
#include "ui_DlgBase.h"

class GraphObject;

class DlgBase:public BrainDialog, protected Ui::DlgBase
{
  Q_OBJECT
public:
  DlgBase(QWidget *parent,QWidget *base,const char *name);
  virtual ~DlgBase();
  
  virtual void updateRequest(GraphObject *go){
    if(!go) return;
    wProps->updateRequest(go);
  };

  void setData(GraphObject *go){
    t_go=go;
    wProps->setData(t_go);
  };
  virtual void reloadDialog(){
    wProps->setData(t_go);
    update();
  }; 

signals:
  void acceptRequest(GraphObject *,bool forceChanged);
  void endRequest();

public slots:
  virtual void reject(){ emit endRequest();};
protected:
  virtual void closeEvent( QCloseEvent * e ) {e->accept(); emit endRequest();};


private slots:
  void on_pbApply_clicked();
  void on_pbCancel_clicked(){ reject(); };
  void on_pbClose_clicked();
  void onDlgEnd();
  virtual void on_pbHelp_clicked(){};
  void onContentChanged(bool);

private:
  bool dataAcceptable();
  void apply();
 private:
  GraphObject *t_go;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _DLGBASE_H */

