/* @(#)GraphsModel.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _GRAPHSMODEL_H
#define _GRAPHSMODEL_H 1

#include <QAbstractListModel>

class Shape;
class Graphs;
class Graph;

class GraphsModel: public QAbstractListModel
{
 public:
  GraphsModel(QObject * parent);
  QVariant headerData(int section,Qt::Orientation orientation
			      ,int role=Qt::DisplayRole)const;
  int rowCount(const QModelIndex & parent=QModelIndex()) const;
  QVariant data(const QModelIndex &index,int role=Qt::DisplayRole)const;
  bool insertRow(int &row,Graph *sh);
  bool insertRow(int &row);
  void removeRow(int row);
  bool moveRow(int row,int by);

  Graph *currentGraph(const QModelIndex &index)const;
  QModelIndex graphIndex(Graph *)const;
  void reset(Graphs *);
  void resetItem(Graph *);
 private:
  Graphs *pgraphs;
};



#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _GRAPHSMODEL_H */

