/* @(#)PageSetupDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _PAGESETUPDLG_H
#define _PAGESETUPDLG_H 1

#include <QCloseEvent>
#include "Paper.hh"
#include "BrainDialog.hh"
#include "ui_PageSetupDlg.h"

class Page;

class PageSetupDlg:public BrainDialog, protected Ui::PageSetupDlg
{
  Q_OBJECT
 public:
  PageSetupDlg(QWidget *parent,QWidget *base,const char *name);
  virtual ~PageSetupDlg();

  void setData(Page *);

 signals:
  void acceptRequest();
  void endRequest();
  
 public slots:
  virtual void reject(){ emit endRequest();};
 protected:
  virtual void closeEvent( QCloseEvent * e ) {e->accept(); emit endRequest();};

 private slots:
  void on_pbApply_clicked();
  void on_pbCancel_clicked(){ reject(); };
  void on_pbClose_clicked();
  void onDlgEnd();
  void on_cmbSize_currentIndexChanged(int);
  void on_cmbOrientation_currentIndexChanged(int);
  void on_spbxWidth_valueChanged(int);
  void on_spbxHeight_valueChanged(int);

private:
  bool dataAcceptable();
  void apply();

 private:
  Page *ppage;
  Paper ppaper;
  bool mute;
  long pwidth,pheight;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _PAGESETUPDLG_H */

