/*************************************************************************
 * @(#)PrintDlg.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   11 Jun 2011
 *************************************************************************
 */

#include <QFileInfo>
#include <QFileDialog>
#include <QDir>
#include "PrintDlg.hh"
#include "Config.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
PrintDlg::PrintDlg(QWidget *parent,const QString &filename)
  :QDialog(parent)
{
  setupUi(this);
  setWindowTitle(IDS_APP_NAME);

  pbPrint->setToolTip(IDS_PRINT_TIP);
  pbCancel->setToolTip(IDS_CANCEL_TIP);

  QString s=filename;
  QFileInfo fi(filename);
  if(fi.absolutePath()==QDir::currentPath()){
    s=fi.fileName();
  }else{
    s=fi.filePath();
  }
  leFileName->setText(s);
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */

PrintDlg::~PrintDlg()
{
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void PrintDlg::on_pbPrint_clicked()
{
  QDialog::accept();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void PrintDlg::on_pbBrowse_clicked()
{
  QFileDialog *dlg=new QFileDialog(this,"Print graph to postscript","."
				   ,"Postscript ( *.eps ) ;;  All ( * )");
  dlg->setAcceptMode(QFileDialog::AcceptSave);
  dlg->setFileMode(QFileDialog::AnyFile);
  QFileDialog::Options options=QFileDialog::DontConfirmOverwrite;
#ifdef Q_OS_MAC
  options|=QFileDialog::DontUseNativeDialog;
#endif
  dlg->setOptions(options);
  dlg->setDirectory(QDir::currentPath());
  QString file=leFileName->text();
  if(!file.isEmpty()){
    dlg->selectFile(file);
  }

  //dlg->setCaption(IDS_APP_NAME);
  int ret= dlg->exec()  ;

  if (ret==QDialog::Accepted){
    QString s=dlg->selectedFiles().at(0);
    QFileInfo fi(s);
    if(fi.absolutePath()==QDir::currentPath()){
      s=fi.fileName();
    }else{
      s=fi.filePath();
    }
    leFileName->setText(s);
  }
}


/*EOF*/ 
