/* @(#)PropWdgBase.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _PROPWDGBASE_H
#define _PROPWDGBASE_H 1

#include <stdlib.h>
#include <stdio.h>
#include <QWidget>

class String;

class PropWdgBase:public QWidget
{
  Q_OBJECT
 public:
  PropWdgBase(QWidget *parent):QWidget(parent)
    ,mutecontentchanged(false)
    ,pisdirty(false)
    ,pconnected(false)
    {
      connect(this,SIGNAL(contentChanged(bool))
	      ,parent,SLOT(onContentChanged(bool)));
    };
  virtual void check(QString &);
  virtual void setData(void *);
  virtual void applyData(void *);
  virtual void updateRequest(void *);

  bool isDirty()const{return pisdirty;};
  void setDirty(bool d){
    if(!pconnected){
      printf("did not call connectChanged() at end of constructor\n");
      exit(1);
    }
    pisdirty=d;emit contentChanged(pisdirty);};

 signals:
  void contentChanged(bool);
  void contentChanged(QObject *);
 private slots:
  void onContentChanged(){if(!mutecontentchanged) setDirty(true);
    emit contentChanged(sender());};

 protected:
  virtual void reset(QObject *obj);
  virtual void connectChanged(QObject *,QList<QObject *>exceptlist=
			      QList<QObject*>());
  
 protected:
  bool mutecontentchanged;
 private:
  bool pisdirty;
  bool pconnected;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _PROPWDGBASE_H */

