//todo: set multiset logic of weights
//todo: weightsel order
//todo: weights spin different look
//todo: weightdefs separte data record in graph, assignement possible!
/*************************************************************************
 * @(#)SetPropWdg.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   17 May 2011
 *************************************************************************
 */

#include <QMenu>
#include "MyQRgb.hh"
#include "Attributes.hh"
#include "ApplyDlg.hh"
#include "GraphObject.hh"
#include "FGObject.hh"
#include "Function.hh"
#include "Functions.hh"
#include "SetDlg.hh"
#include "FunctionGroup.hh"
#include "DlgReg.hh"
#include "SetPropWdg.hh"
#include "OptMatelDefinition.hh"
#include "ToolButtons.hh"
#include "WeightSelModel.hh"
#include "WeightSelection.hh"
#include "WeightDefDlg.hh"
#include "Valid.hh"
#include "MyDebug.hh"

enum MWActions{LineColor=0,Checked=1,Unchecked=2,CurrentColor=3};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
SetPropWdg::SetPropWdg(QWidget *parent)
  :PropWdgBase(parent),wsmodel(0),mute_weightcolor(false)
  ,mute_weightsymtype(false),mute_weightsymfill(false)
  ,mute_weightsymlinewidth(false)
  ,mute_weightskip(false),ptoolbuttons(new ToolButtons())

{
  setupUi(this);

  QString s="Symbol ";
  new IntValidator(this,lSymSize->buddy(),s+lSymSize->text(),1,1000);
  s="weight property ";
  // new RealValidator(this,lFactor->buddy(),s+lFactor->text(),-1.0e100,
  // 		    1.e100);

  s="matrix element scale factor ";
  new RealValidator(this,lMEScale->buddy(),s+lMEScale->text(),-1.0e10,
		    1.e10);

  cmbSymType->clear();
  for(int i=0;i<Xfp::maxSymbols();i++){
    cmbSymType->insertItem(i,Xfp::symbolName((Xfp::SymbolTypes)i),i);
  }


  cmbLineStyle->clear();
  for(int i=0;i<Xfp::maxLineStyles();i++){
    cmbLineStyle->insertItem(i,Xfp::lineStyleGuiName((Xfp::LineStyles)i),i);
  }
  
  cmbSymLineStyle->clear();
  for(int i=0;i<Xfp::maxLineStyles();i++){
    cmbSymLineStyle->insertItem(i,Xfp::lineStyleGuiName((Xfp::LineStyles)i),i);
  }

  cmbWeightStyle->clear();
  for(int i=0;i<Xfp::maxWeightsStyles();i++){
    cmbWeightStyle->
      insertItem(i,Xfp::weightsStylesGuiName((Xfp::WeightsStyle)i),i);
  }

  mute_weightsymtype=true;
  cmbWeightSymType->clear();
  for(int i=0;i<Xfp::maxSymbols();i++){
    cmbWeightSymType->insertItem(i,Xfp::symbolName((Xfp::SymbolTypes)i),i);
  }
  mute_weightsymtype=false;

  pdlgreg=new DlgReg();

  pdlgreg->Register(cbUseLegend,cbUseLegend->text());
  pdlgreg->Register(cbActive,cbActive->text());
  pdlgreg->Register(cmbSymType,gbSymProps->title()+": "+lSymType->text());
  pdlgreg->Register(cmbSymType,gbSymProps->title()+": "+lSymType->text());
  pdlgreg->Register(cmbWeightSymType,gbSymProps->title()+": "
		    +lWeightSymType->text());
  pdlgreg->Register(leLegendText,lLegendText->text());
  pdlgreg->Register(leSymSize,gbSymProps->title()+": "+lSymSize->text());
  pdlgreg->Register(cbSymFill,gbSymProps->title()+": "+cbSymFill->text());
  pdlgreg->Register(cmbLineStyle,gbLineProps->title()+": "+lLineStyle->text());
  pdlgreg->Register(dspbxLineWidth,gbLineProps->title()+": "+lLineWidth->text());
  pdlgreg->Register(cbLineColor,gbLineProps->title()+": "+lLineColor->text());

  pdlgreg->Register(cmbSymLineStyle,gbSymLine->title()+": "+
		    lSymLineStyle->text());
  pdlgreg->Register(dspbxSymLineWidth,gbSymLine->title()+": "+
		    lSymLineWidth->text());
  pdlgreg->Register(cbSymLineColorExtra,gbSymLine->title()+": "+
		    cbSymLineColorExtra->text());
  pdlgreg->Register(cbSymLineColor,gbSymLine->title()+": "+
		    lSymLineColor->text());

  pdlgreg->Register(cbSymFillColorExtra,gbSymFill->title()+": "+
		    cbSymFillColorExtra->text());
  pdlgreg->Register(cbSymFillColor,gbSymFill->title()+": "+
		    lSymFillColor->text());  

  pdlgreg->Register(cbUseAttribs,cbUseAttribs->text());  
  pdlgreg->Register(cbSetUseGroupAttribs,cbSetUseGroupAttribs->text());  

  pdlgreg->Register(dspbxMinWidth,lMinWidth->text());  
  pdlgreg->Register(dspbxMaxWidth,lMaxWidth->text());  
  pdlgreg->Register(dspbxFactor,"Weights properties factor");
  pdlgreg->Register(cbDisplayWeightLegend,cbDisplayWeightLegend->text());  
  pdlgreg->Register(lvWeights,"Weights properties");  
  pdlgreg->Register(cmbWeightStyle,"Weights style");  

  pdlgreg->Register(leMEScale,"Matrix element scale factor");
  pdlgreg->Register(dspbxMEErgMin,lMEErgMin->text());  
  pdlgreg->Register(dspbxMEErgMax,lMEErgMax->text());  
  pdlgreg->Register(dspbxMEErgDe,lMEErgDe->text());  
  pdlgreg->Register(dspbxMEMinValue,lMEMinValue->text());  
  pdlgreg->Register(dspbxMEMaxValue,lMEMaxValue->text());  
  pdlgreg->Register(dspbxZmax,lZmax->text());  
  pdlgreg->Register(spbxZPower,lZPower->text());  
  pdlgreg->Register(spbxInterpolationDepth,lInterpolationDepth->text());  
  pdlgreg->Register(cbSecondDerivative,cbSecondDerivative->text());  

  wsmodel=new WeightSelModel(this);
  WeightSelSelectionModel *wdselmodel=new WeightSelSelectionModel(wsmodel);
  lvWeights->setModel(wsmodel);
  lvWeights->setSelectionModel(wdselmodel);

  {
    QMenu *m=new QMenu(tbModifyWeights);
    QAction *a;
    a=m->addAction("&Different colors");  
    a->setData(LineColor);
    mwactions.append(a);
    
    a=m->addAction("&Checked");  
    a->setData(Checked);
    mwactions.append(a);
    
    a=m->addAction("&Unchecked");  
    a->setData(Unchecked);
    mwactions.append(a);

    a=m->addAction("&Current color");  
    a->setData(CurrentColor);
    mwactions.append(a);
    
    foreach(QAction *a,mwactions)
      connect(a,SIGNAL(triggered()),this,SLOT(onMWActions()));;
    
    tbModifyWeights->setMenu(m);
    tbModifyWeights->setDefaultAction(mwactions[0]);
  }
  // //  exceptlist<<cbWeightColor;
  connectChanged(this,QList<QObject *>()<<dspbxSetValues<<tbSetValues);

  connect(this,SIGNAL(contentChanged(QObject *)),
	  this,SLOT(onContentChanged(QObject *)));

  connect(wsmodel,SIGNAL(weightItemSelected(WeightSelection *)),
	  this,SLOT(onWeightItemSelected(WeightSelection *)));


  ptoolbuttons->createToolButtonsActions(lvWeights,"weight(s)"
					 ,0,0,tbUp,tbDown);

  ptoolbuttons->connectSlots(this,0,0,
			     SLOT(slotMoveWeightSelection()),
			     SLOT(slotMoveWeightSelection()));

  leMEScale->setText("1");

  connect(dspbxMEErgMin,SIGNAL(valueChanged(double))
	  ,this,SLOT(setDSpbxMinMax(double)));
  connect(dspbxMEErgMax,SIGNAL(valueChanged(double))
	  ,this,SLOT(setDSpbxMinMax(double)));


  QMenu *m=new QMenu(tbSetValues);
  QAction *a;
  a=m->addAction("set &x-zero");  
  a->setData("x-zero");  
  tbSetValues->setDefaultAction(a);
  a=m->addAction("set &y-zero");  
  a->setData("y-zero");
  tbSetValues->setMenu(m);
  a=m->addAction("&scale x");  
  a->setData("scale-x");
  tbSetValues->setMenu(m);
  a=m->addAction("s&cale y");  
  a->setData("scale-y");
  tbSetValues->setMenu(m);

  connect(m,SIGNAL(triggered(QAction *)),this
	  ,SLOT(onSetValueTbAction(QAction *)));

  setDirty(false);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
SetPropWdg::~SetPropWdg()
{
  if(pdlgreg) delete pdlgreg;pdlgreg=0;
  if(wsmodel) delete wsmodel;wsmodel=0;
  if(ptoolbuttons) delete ptoolbuttons;ptoolbuttons=0;

  qDeleteAll(mwactions.begin(),mwactions.end());


}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::check(QString &msg)
{
  if(!pfgo)return;
  ((IntValidator*)leSymSize->validator())->check(msg);
  //  ((IntValidator*)leFactor->validator())->check(msg);
  ((IntValidator*)leMEScale->validator())->check(msg);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::setData(FGObject *fgo,bool weightsallowed)
{
  pfgo=fgo;
  if(!fgo) {
    cbActive->setEnabled(false);
    cbUseAttribs->setEnabled(false);
    cbSetUseGroupAttribs->hide();
    tabwProps->removeTab(tabwProps->indexOf(Weights));
    tabwProps->removeTab(tabwProps->indexOf(MatEl));
    tabwProps->removeTab(tabwProps->indexOf(Akbl));
    tabwProps->removeTab(tabwProps->indexOf(Manipulate));
    tabwProps->setEnabled(false);
    return;
  }
  cbActive->setEnabled(true);
  cbUseAttribs->setEnabled(true);

  FunctionGroup *fg=0;
  //  Function *fu=0;
  WeightLabels *wls=0;
  
  bool enableakbl=false;

  if(fgo->type()==FGObject::FGOTGroup){
    fg=((FunctionGroup*)fgo);
    cbUseAttribs->setChecked(fg->useAttribs());
    cbUseAttribs->show();
    on_cbUseAttribs_toggled(fg->useAttribs());
    cbSetUseGroupAttribs->hide();
    
  }else if(fgo->type()==FGObject::FGOTFunction){
    Function *fu=((Function*)fgo);
    cbUseAttribs->hide();
    cbSetUseGroupAttribs->setChecked(fu->group()->useAttribs());
    cbSetUseGroupAttribs->show();
    on_cbUseAttribs_toggled(!fu->group()->useAttribs());
    //myDebug()<<fu->dataType();
    enableakbl=(fu->dataType()==Function::GRIDX_Y_NZ);
  }

  WeightSelections *wss=fgo->weightSelections();
  bool enableweights=((wls=fgo->weightLabels())!=0);
  OptMatelDefinition *matel=0;
  bool enablematel=((matel=fgo->optMatelDefinition())!=0);


  if(weightsallowed){
    lWarning->hide();
    enableweights&=true;
  }else{
    enableweights=false;
    lWarning->show();
    lWarning->setText("selected Sets/Groups do not refer to \nthe same weight data");
  }


  QWidget *tcw=tabwProps->currentWidget();

  enableWeightWidgets(enableweights);



  //tabwProps->setTabEnabled(tabwProps->indexOf(MatEl),enablematel);
  //MatEl->setVisible(enablematel);
  if(enablematel){
    int index=tabwProps->indexOf(Weights)+1;
    if(index<1)index=2;
    //myDebug()<< index;
    tabwProps->insertTab(index,MatEl,"&Matrix Elements");
    tabwProps->setTabEnabled(tabwProps->indexOf(MatEl),enablematel);
  }else{
    tabwProps->removeTab(tabwProps->indexOf(MatEl));
  }
  if(enableakbl){
    int index=tabwProps->indexOf(Weights)+1;
    if(index<1)index=2;
    //myDebug()<< index;
    tabwProps->insertTab(index,Akbl,"DensityPlot");
  }else{
    tabwProps->removeTab(tabwProps->indexOf(Akbl));
  }
  //tabwProps->setTabEnabled(tabwProps->indexOf(Weights),enableweights);


  int index=tabwProps->count();
  tabwProps->insertTab(index,Manipulate,"Manipulate");
  tabwProps->setTabEnabled(tabwProps->indexOf(Manipulate),true);

  int icw=tabwProps->indexOf(tcw);
  if(icw>=0){
    tabwProps->setCurrentWidget(tcw);
  }
  

//     myDebug() <<"fu"<<fu;
//     wls->print();
  wsmodel->reset(wss);
  lvWeights->setCurrentIndex(wsmodel->index(0,0,QModelIndex()));

  

  cbActive->setChecked(fgo->active());
  const FunctionAttribs *at=0;
  if((at=fgo->attribs())){
    leLegendText->setText(at->legend()());
    cbUseLegend->setChecked(at->useLegend());
    leSymSize->setText(QString().setNum(at->symbolStyle().size()));
    
    cmbSymType->setCurrentIndex(at->symbolStyle().type());  
    
    cmbLineStyle->setCurrentIndex(at->lineStyle().style());  
    
    if(wss){
      dspbxMinWidth->setValue(wss->minWidth());
      dspbxMaxWidth->setValue(wss->maxWidth());
      dspbxFactor->setValue(wss->factor());
      cbDisplayWeightLegend->setChecked(wss->displayWeightLegend());
      cmbWeightStyle->setCurrentIndex(wss->style());
    }

    if(matel){
      leMEScale->setText(QString().setNum(matel->matelScale()));
      dspbxMEErgMin->setValue(matel->ergMin());
      dspbxMEErgMax->setValue(matel->ergMax());
      dspbxMEErgDe->setValue(matel->ergDe());
      dspbxMEMinValue->setValue(matel->matelMin());
      dspbxMEMaxValue->setValue(matel->matelMax());
    }

    if(enableakbl){
      spbxInterpolationDepth->setValue(at->interpolationDepth());
      dspbxZmax->setValue(at->zmax());
      spbxZPower->setValue(at->zPower());
      cbSecondDerivative->setChecked(at->useSecondDerivative());
    }
    
    dspbxLineWidth->setValue(at->lineStyle().width());
    
    cbLineColor->setColor(at->lineStyle().color());
    
    cmbSymLineStyle->setCurrentIndex(at->symbolStyle().lineStyle().style());  
    
    dspbxSymLineWidth->setValue(at->symbolStyle().lineStyle().width());
    
    cbSymLineColor->setColor(at->symbolStyle().lineStyle().color());
    
    cbSymFill->setChecked(at->symbolStyle().fillStyle().fill());
    
    cbSymFillColor->setColor(at->symbolStyle().fillStyle().color());
    
    cbSymLineColorExtra->setChecked(at->symbolStyle().extraLineColor());
    cbSymFillColorExtra->setChecked(at->symbolStyle().extraFillColor());
    
    
    setDirty(false);
    
  }
  
  pdlgreg->reset();
  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::enableWeightWidgets(bool e)
{
  int iw=tabwProps->indexOf(Weights);
  bool ise=false;
  if(tabwProps->currentIndex()==iw){
    ise=true;
  }
  
  if(e){
    int index=tabwProps->indexOf(Symbol)+1;
    tabwProps->insertTab(index,Weights,"Weig&hts");
    if(ise)
      tabwProps->setCurrentWidget(Weights);
    //myDebug()<<"added Weights"<<tabwProps->indexOf(Weights);
  }else{
    tabwProps->removeTab(tabwProps->indexOf(Weights));
    //myDebug()<<"removed Weights"<<tabwProps->indexOf(Weights);
  }
  if(iw>=0)tabwProps->setTabEnabled(iw,e);
  
//   frWeights->setEnabled(e);
//   cbDisplayWeightLegend->setEnabled(e);
//   grbxPropAll->setEnabled(e);
//   grbxIndivProp->setEnabled(e);
//   tbManage->setEnabled(e);
}




/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::applyData(const QList<FGObject*> &fgolist)
{
  bool ok;
  QString t;

  if(fgolist.size()>1){
    if(ApplyDlg::applyDlg(this,pdlgreg)!=QDialog::Accepted) return;
  }else{
    pdlgreg->setApplyAll(true);
  }
  
  //pdlgreg->print();

  foreach(FGObject *fgo,fgolist){
    //todo: check consistency
    //todo: if group all must have the same WeightDefinitions
    
    //myDebug() << wsmodel->weightDefinitions();
    WeightSelections *wss=fgo->weightSelections();
    //todo: create wss if needed
    if(pdlgreg->toBeApplied(lvWeights)){
      if(wsmodel->weightSelections() && wss){
	wss->copySelections(wsmodel->weightSelections());
	pdlgreg->setChanged(lvWeights,false);
      }
    }
    if(pdlgreg->toBeApplied(cbUseAttribs) && cbUseAttribs->isVisible()){
      if(fgo->type()==FGObject::FGOTGroup){
	((FunctionGroup*)fgo)->setUseAttribs(cbUseAttribs->isChecked());
	pdlgreg->setChanged(cbUseAttribs,false);
      }
    }
    if(pdlgreg->toBeApplied(cbSetUseGroupAttribs) && 
       cbSetUseGroupAttribs->isVisible()){
      if(fgo->type()==FGObject::FGOTGroup){
	((FunctionGroup*)fgo)
	  ->setUseAttribs(cbSetUseGroupAttribs->isChecked());
      }else{
	((Function*)fgo)->group()
	  ->setUseAttribs(cbSetUseGroupAttribs->isChecked());
      }
      pdlgreg->setChanged(cbSetUseGroupAttribs,false);
    }
    if(pdlgreg->toBeApplied(cbActive)){
      fgo->setActive(cbActive->isChecked());
      pdlgreg->setChanged(cbActive,false);
    }
    OptMatelDefinition *matel=fgo->optMatelDefinition();

    if(matel){
      if(pdlgreg->toBeApplied(leMEScale)){
	matel->setMatelScale(leMEScale->text().toDouble());
	pdlgreg->setChanged(leMEScale,false);
      }
      if(pdlgreg->toBeApplied(dspbxMEErgMin)){
	matel->setErgMin(dspbxMEErgMin->value());
	pdlgreg->setChanged(dspbxMEErgMin,false);
      }
      if(pdlgreg->toBeApplied(dspbxMEErgMax)){
	matel->setErgMax(dspbxMEErgMax->value());
	pdlgreg->setChanged(dspbxMEErgMax,false);
      }
      if(pdlgreg->toBeApplied(dspbxMEErgDe)){
	matel->setErgDe(dspbxMEErgDe->value());
	pdlgreg->setChanged(dspbxMEErgDe,false);
      }
      if(pdlgreg->toBeApplied(dspbxMEMinValue)){
	matel->setMatelMin(dspbxMEMinValue->value());
	pdlgreg->setChanged(dspbxMEMinValue,false);
      }
      if(pdlgreg->toBeApplied(dspbxMEMaxValue)){
	matel->setMatelMax(dspbxMEMaxValue->value());
	pdlgreg->setChanged(dspbxMEMaxValue,false);
      }
    }

    
    if(wss){
      if(pdlgreg->toBeApplied(dspbxMinWidth)){
	wss->setMinWidth(dspbxMinWidth->value());
	pdlgreg->setChanged(dspbxMinWidth,false);
      }
      if(pdlgreg->toBeApplied(dspbxMaxWidth)){
	wss->setMaxWidth(dspbxMaxWidth->value());
	pdlgreg->setChanged(dspbxMaxWidth,false);
      }
      if(pdlgreg->toBeApplied(dspbxFactor)){
	wss->setFactor(dspbxFactor->value());
	pdlgreg->setChanged(dspbxFactor,false);
      }
      if(pdlgreg->toBeApplied(cbDisplayWeightLegend)){
	wss->setDisplayWeightLegend(cbDisplayWeightLegend->isChecked());
	pdlgreg->setChanged(cbDisplayWeightLegend,false);
      }
      if(pdlgreg->toBeApplied(cmbWeightStyle)){
	wss->setStyle((Xfp::WeightsStyle)cmbWeightStyle->currentIndex());
	pdlgreg->setChanged(cmbWeightStyle,false);
      }
    }

    FunctionAttribs *at=fgo->attribs();
    if(!at) continue;

    bool enableakbl=false;
    if(fgo->type()==FGObject::FGOTFunction){
      Function *fu=((Function*)fgo);
      enableakbl=(fu->dataType()==Function::GRIDX_Y_NZ);
    }

    if(enableakbl){
      if(pdlgreg->toBeApplied(spbxInterpolationDepth)){
	at->setInterpolationDepth(spbxInterpolationDepth->value());
	pdlgreg->setChanged(spbxInterpolationDepth,false);
      }
      if(pdlgreg->toBeApplied(dspbxZmax)){
	at->setZMax(dspbxZmax->value());
	pdlgreg->setChanged(dspbxZmax,false);
      }
      if(pdlgreg->toBeApplied(spbxZPower)){
	at->setZPower(spbxZPower->value());
	pdlgreg->setChanged(spbxZPower,false);
      }
      if(pdlgreg->toBeApplied(cbSecondDerivative)){
	at->setUseSecondDerivative(cbSecondDerivative->isChecked());
	pdlgreg->setChanged(cbSecondDerivative,false);
      }

    }
    
    if(pdlgreg->toBeApplied(cbUseLegend)){
      at->setUseLegend(cbUseLegend->isChecked());
      pdlgreg->setChanged(cbUseLegend,false);
    }
    if(pdlgreg->toBeApplied(leLegendText)){
      at->setLegend(String(leLegendText->text()));
      pdlgreg->setChanged(leLegendText,false);
    }
    if(pdlgreg->toBeApplied(cmbSymType)){
      at->symbolStyle().setType((Xfp::SymbolTypes)cmbSymType->currentIndex());
      pdlgreg->setChanged(cmbSymType,false);
    }
    if(pdlgreg->toBeApplied(leSymSize)){
      t=leSymSize->text();IntValidator::stripAllWhiteSpace(t);
      at->symbolStyle().setSize(t.toLong(&ok));
      pdlgreg->setChanged(leSymSize,false);
    }
    if(pdlgreg->toBeApplied(cbSymFill)){
      at->symbolStyle().fillStyle().setFill(cbSymFill->isChecked());
      pdlgreg->setChanged(cbSymFill,false);
    }
    if(pdlgreg->toBeApplied(cmbLineStyle)){
      at->lineStyle().setStyle((Xfp::LineStyles)cmbLineStyle->currentIndex());
      pdlgreg->setChanged(cmbLineStyle,false);
    }
    if(pdlgreg->toBeApplied(dspbxLineWidth)){
      at->lineStyle().setWidth(dspbxLineWidth->value());
      pdlgreg->setChanged(dspbxLineWidth,false);
    }
    if(pdlgreg->toBeApplied(cbLineColor)){
      at->lineStyle().setColor(cbLineColor->color());
      pdlgreg->setChanged(cbLineColor,false);
    }
    
    if(pdlgreg->toBeApplied(cmbSymLineStyle)){
      at->symbolStyle().lineStyle().
	setStyle((Xfp::LineStyles)cmbSymLineStyle->currentIndex());
      pdlgreg->setChanged(cmbSymLineStyle,false);
    }
    if(pdlgreg->toBeApplied(dspbxSymLineWidth)){
      at->symbolStyle().lineStyle().setWidth(dspbxSymLineWidth->value());
      pdlgreg->setChanged(dspbxSymLineWidth,false);
    }
    if(pdlgreg->toBeApplied(cbSymLineColorExtra)){
      at->symbolStyle().setExtraLineColor(cbSymLineColorExtra->isChecked());
      pdlgreg->setChanged(cbSymLineColorExtra,false);
    }
    if(pdlgreg->toBeApplied(cbSymLineColor)){
      at->symbolStyle().lineStyle().setColor(cbSymLineColor->color());
      pdlgreg->setChanged(cbSymLineColor,false);
    }
    if(pdlgreg->toBeApplied(cbSymFillColorExtra)){
      at->symbolStyle().setExtraFillColor(cbSymFillColorExtra->isChecked());
      pdlgreg->setChanged(cbSymFillColorExtra,false);
    }
    if(pdlgreg->toBeApplied(cbSymFillColor)){
      at->symbolStyle().fillStyle().setColor(cbSymFillColor->color());
      pdlgreg->setChanged(cbSymFillColor,false);
    }
  }

  setDirty(false);
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::onContentChanged(QObject *o)
{
  if(o==cbWeightColor||
     o==cmbWeightSymType||
     o==cbWeightSymFill ||
     o==dspbxWeightSymLineWidth|| 
     o==spbxWeightSkip
     ){
    pdlgreg->setChanged(lvWeights,true);
  }else{
    pdlgreg->setChanged(o,true);
  }
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_lvWeights_myCurrentItemChanged(const QModelIndex &current,
						   const QModelIndex &)
{
  if(!current.isValid())return;
  WeightSelection *ws=(WeightSelection*)(wsmodel->
					   data(current,Qt::UserRole).
					   value<void*>());
  onWeightItemSelected(ws);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::onWeightItemSelected(WeightSelection *ws)
{
  if(!ws) return;
  mute_weightcolor=true;
  mute_weightsymtype=true;
  mute_weightsymfill=true;
  mute_weightsymlinewidth=true;
  mute_weightskip=true;
  cbWeightColor->setColor(ws->color());
  Xfp::SymbolTypes st=ws->type();
  cmbWeightSymType->setCurrentIndex(cmbWeightSymType->findData(st));
  cbWeightSymFill->setChecked(ws->fill());
  dspbxWeightSymLineWidth->setValue(ws->lineWidth());
  spbxWeightSkip->setValue(ws->skip());
  mute_weightcolor=false;
  mute_weightsymtype=false;
  mute_weightsymfill=false;
  mute_weightsymlinewidth=false;
  mute_weightskip=false;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_dspbxWeightSymLineWidth_valueChanged(double v)
{
  if(mute_weightsymlinewidth) return;
  //myDebug() <<"on_cbWeightColor_colorChanged"<<c;
  
  foreach(QModelIndex index,lvWeights->selectionModel()->selectedIndexes()){
    WeightSelection *ws=(WeightSelection*)(wsmodel->data(index,Qt::UserRole)
					   .value<void*>());
    if(ws){
      //myDebug()<<ws->color();
      ws->setLineWidth(v);
    }
  }
  if(!mutecontentchanged) setDirty(true);
  onContentChanged(dspbxWeightSymLineWidth);

}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_spbxWeightSkip_valueChanged(int v)
{
  if(mute_weightskip) return;
  
  foreach(QModelIndex index,lvWeights->selectionModel()->selectedIndexes()){
    WeightSelection *ws=(WeightSelection*)(wsmodel->data(index,Qt::UserRole)
					   .value<void*>());
    if(ws){
      ws->setSkip(v);
    }
  }
  if(!mutecontentchanged) setDirty(true);
  onContentChanged(spbxWeightSkip);

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_cbWeightColor_colorChanged(QRgb c)
{
  if(mute_weightcolor) return;
  //myDebug() <<"on_cbWeightColor_colorChanged"<<c;
  
  foreach(QModelIndex index,lvWeights->selectionModel()->selectedIndexes()){
    WeightSelection *ws=(WeightSelection*)(wsmodel->data(index,Qt::UserRole)
					   .value<void*>());
    if(ws){
      //myDebug()<<ws->color();
      ws->setColor(c);
    }
  }
  if(!mutecontentchanged) setDirty(true);
  onContentChanged(cbWeightColor);

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_cbWeightSymFill_toggled(bool checked)
{
  if(mute_weightsymfill) return;
  
  foreach(QModelIndex index,lvWeights->selectionModel()->selectedIndexes()){
    WeightSelection *ws=(WeightSelection*)(wsmodel->data(index,Qt::UserRole)
					   .value<void*>());
    if(ws){
      ws->setFill(checked);
    }
  }
  if(!mutecontentchanged) setDirty(true);
  onContentChanged(cbWeightSymFill);

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_cmbWeightSymType_currentIndexChanged(int current)
{
  if(mute_weightsymtype) return;
  Xfp::SymbolTypes st=(Xfp::SymbolTypes)cmbWeightSymType
    ->itemData(current).toInt();
  foreach(QModelIndex index,lvWeights->selectionModel()->selectedIndexes()){
    WeightSelection *ws=(WeightSelection*)(wsmodel->data(index,Qt::UserRole)
 					   .value<void*>());
    if(ws){
      ws->setType(st);
    }
  }
  if(!mutecontentchanged) setDirty(true);
  onContentChanged(cmbWeightSymType);

}
/* ***********************************************************************
 *
 * ***********************************************************************
 */

void SetPropWdg::onMWActions()
{
  if(!sender()) return;
  QAction *a=dynamic_cast<QAction*>(sender());
  if(!a)return;
  MWActions mode=(MWActions)a->data().toInt();
  //myDebug()<<"onMWActions"<<a<<mode;
  if(mode==LineColor){
    mute_weightcolor=true;
    long icol=0;
    WeightSelection *wscur=0;
    QModelIndexList mil=lvWeights->selectionModel()->selectedIndexes();
    qSort(mil);
    foreach(QModelIndex index,mil){
      WeightSelection *ws=(WeightSelection*)(wsmodel->data(index,Qt::UserRole)
					     .value<void*>());
      if(ws){
	QRgb cc=Xfp::rgbColor((icol % (Xfp::maxRgbColors()-2))+1);
	if(index==lvWeights->currentIndex()) wscur=ws;
	ws->setColor(cc);
	//myDebug("%ld %x\n",icol,cc);
	icol++;
      }
    }  
    if(wscur)
      cbWeightColor->setColor(wscur->color());
    
    mute_weightcolor=false;

    
  }else if(mode==CurrentColor){
    mute_weightcolor=true;
    foreach(QModelIndex index,lvWeights->selectionModel()->selectedIndexes()){
      WeightSelection *ws=(WeightSelection*)(wsmodel->data(index,Qt::UserRole)
					     .value<void*>());
      if(ws){
	QRgb cc=cbWeightColor->color();
	ws->setColor(cc);
      }
    }  
    
    mute_weightcolor=false;

    
  }else if(mode==Checked){
    foreach(QModelIndex index,lvWeights->selectionModel()->selectedIndexes()){
      wsmodel->setData(index,Qt::Checked,Qt::CheckStateRole);
    }
  }else if(mode==Unchecked){
    foreach(QModelIndex index,lvWeights->selectionModel()->selectedIndexes()){
      wsmodel->setData(index,Qt::Unchecked,Qt::CheckStateRole);
    }
  }

  tbModifyWeights->setDefaultAction(a);
  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_tbManage_clicked()
{
  WeightDefDlg *dlg=new WeightDefDlg(this);
  dlg->setData(pfgo->weightLabels());
  dlg->exec();
  delete dlg;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_cbActive_toggled(bool onoff)
{
  if(cbUseAttribs->isVisible())
    tabwProps->setEnabled(cbUseAttribs->isChecked() && onoff);
  else if(cbSetUseGroupAttribs->isVisible())
    tabwProps->setEnabled((!cbSetUseGroupAttribs->isChecked()) && onoff);
  else
    tabwProps->setEnabled(onoff);
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_cbUseAttribs_toggled(bool onoff)
{
  //myDebug() << "SetPropWdg::on_cbUseAttribs_toggled()";
  tabwProps->setEnabled(cbActive->isChecked()&&onoff);
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_cbSetUseGroupAttribs_toggled(bool onoff)
{
  tabwProps->setEnabled(cbActive->isChecked()&& (!onoff));
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::on_cmbWeightStyle_currentIndexChanged(int current)
{
  //myDebug() << "SetPropWdg::on_cmbWeightStyle_currentIndexChanged(int current)";
  Xfp::WeightsStyle wst=(Xfp::WeightsStyle)cmbWeightStyle->itemData(current)
    .toInt();
  if(wst==Xfp::WESIndividual){
    cmbWeightSymType->setVisible(true);
    lWeightSymType->setVisible(true);
    cbWeightSymFill->setVisible(true);
    dspbxWeightSymLineWidth->setVisible(true);
    //spbxWeightSkip->setVisible(true);
    lWeightSymLineWidth->setVisible(true);
  }else{
    cmbWeightSymType->setVisible(false);
    lWeightSymType->setVisible(false);
    cbWeightSymFill->setVisible(false);
    dspbxWeightSymLineWidth->setVisible(false);
    //spbxWeightSkip->setVisible(false);
    lWeightSymLineWidth->setVisible(false);
  }
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::slotMoveWeightSelection()
{
  long by=-1;
  if(sender()==ptoolbuttons->pmoveDownAction)by=1;
  
  //myDebug() << "SetPropWdg::slotMoveWeightSelection by="<<by;
  QModelIndexList mil=lvWeights->selectionModel()->selectedIndexes();
  if(by<0 && mil.first().row()<=0) return;
  if(by>0 && mil.last().row()>=wsmodel->rowCount()-1)return;
  if(by<0){
    foreach(QModelIndex index,mil){
      int row=index.row();
      wsmodel->moveRow(row,by);
    }  
    lvWeights->setCurrentIndex(wsmodel->index(mil.first().row()+by,0,
					      QModelIndex()));
    foreach(QModelIndex index,mil){
      lvWeights->selectionModel()
	->select(wsmodel->index(index.row()+by,0,QModelIndex())
		 ,QItemSelectionModel::Select);
    }
  }else{
    for(long i=mil.size()-1;i>=0;i--){
      QModelIndex index=mil.at(i);
      int row=index.row();
      wsmodel->moveRow(row,by);
    }  
    lvWeights->setCurrentIndex(wsmodel->index(mil.first().row()+by,0,
					      QModelIndex()));
    foreach(QModelIndex index,mil){
      lvWeights->selectionModel()
	->select(wsmodel->index(index.row()+by,0,QModelIndex())
		 ,QItemSelectionModel::Select);
    }
  }
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::setSelectedProps(const QString &what)
{
  //myDebug()<<what;
  if(what=="linecolor"){
    const FunctionAttribs *at=pfgo->attribs();
    cbLineColor->setColor(at->lineStyle().color());
    //at->lineStyle().setColor(cbLineColor->color());
    pdlgreg->setChanged(cbLineColor,false);
  }
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::setDSpbxMinMax(double d)
{
  if(sender()==dspbxMEErgMin){
    dspbxMEErgMax->setMinimum(d);
  }
  if(sender()==dspbxMEErgMax){
    dspbxMEErgMin->setMaximum(d);
  }
  
//   myDebug()<<"dspbxMEErgMin"<<dspbxMEErgMin->minimum()<<dspbxMEErgMin->maximum();
//   myDebug()<<"dspbxMEErgMax"<<dspbxMEErgMax->minimum()<<dspbxMEErgMax->maximum();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetPropWdg::onSetValueTbAction(QAction *a)
{
  double d=dspbxSetValues->value();
  QString mode=a->data().toString();
  Xfp::XYAxisType at=Xfp::Graph_X;
  if(mode=="y-zero"||mode=="scale-y"){
    at=Xfp::Graph_Y;
  }


  //myDebug()<<"SetPropWdg::slotSetValues("<<a<<")"<<d;
  tbSetValues->setDefaultAction(a);
  
  SetDlg *setdlg=((SetDlg*)parent());

  QList<FGObject*> fgolist=setdlg->getSelectedFGObjects(true);
  foreach(FGObject *fgo,fgolist){
    if(fgo->type()==FGObject::FGOTFunction){
      if(mode.contains("-zero")) ((Function*)fgo)->shiftOrigin(at,d);
      if(mode.contains("scale-")) ((Function*)fgo)->scaleData(at,d);
    }else if(fgo->type()==FGObject::FGOTGroup){
      FunctionGroup *fg=((FunctionGroup*)fgo);
      for(long ig=0;ig<fg->funcs()->size();ig++){
	if(mode.contains("-zero")) fg->funcs()->at(ig)->shiftOrigin(at,d);
	if(mode.contains("scale-")) fg->funcs()->at(ig)->scaleData(at,d);
      }
    }

  }
  setdlg->triggerUpdate();
}
/*EOF*/ 
