/* @(#)SetPropWdg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SETPROPWDG_H
#define _SETPROPWDG_H 1

#include <QList>
#include "PropWdgBase.hh"
#include "ui_SetPropWdg.h" 

class QAction;
class FunctionAttribs;
class FGObject;
class DlgReg;
class WeightSelModel;
class WeightSelection;
class ToolButtons;


class SetPropWdg: public PropWdgBase,protected Ui::SetPropWdg
{
  Q_OBJECT
public:
  SetPropWdg(QWidget *parent);
  ~SetPropWdg();

  void setData(FGObject *,bool weightsallowed);
  void check(QString &msg);
  void applyData(const QList<FGObject*> &);
  void setSelectedProps(const QString &what);


 private slots:
  void onContentChanged(QObject *);
  void on_lvWeights_myCurrentItemChanged(const QModelIndex &,
					 const QModelIndex &);
  void onWeightItemSelected(WeightSelection *ws);
  void on_cbWeightColor_colorChanged(QRgb);
  void on_cmbWeightStyle_currentIndexChanged(int current);
  void on_cmbWeightSymType_currentIndexChanged(int current);
  void onMWActions();
  void on_tbManage_clicked();
  void on_cbUseAttribs_toggled(bool);
  void on_cbSetUseGroupAttribs_toggled(bool onoff);
  void on_cbActive_toggled(bool);
  void on_cbWeightSymFill_toggled(bool checked);
  void on_dspbxWeightSymLineWidth_valueChanged(double v);
  void on_spbxWeightSkip_valueChanged(int v);
  void slotMoveWeightSelection();
  void onSetValueTbAction(QAction *);
  void setDSpbxMinMax(double);

 private:
  void enableWeightWidgets(bool);
 private:
  DlgReg *pdlgreg;
  WeightSelModel *wsmodel;
  bool mute_weightcolor;
  bool mute_weightsymtype;
  bool mute_weightsymfill;
  bool mute_weightsymlinewidth;
  bool mute_weightskip;
  QList<QAction*> mwactions;
  FGObject *pfgo;
  ToolButtons *ptoolbuttons;

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _SETPROPWDG_H */

