/* @(#)SetTreeModel.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SETTREEMODEL_H
#define _SETTREEMODEL_H 1

#include <QAbstractItemModel>

class Graph;
class FGObject;

class SetTreeModel:public QAbstractItemModel{
  Q_OBJECT
public:
  SetTreeModel(QObject *parent);
  ~SetTreeModel();

  int rowCount(const QModelIndex &parent=QModelIndex())const;
  int columnCount(const QModelIndex &parent=QModelIndex())const;

  QModelIndex parent(const QModelIndex &index)const;
  QModelIndex index(int row, int column,
		    const QModelIndex &parent=QModelIndex())const;
  QVariant data(const QModelIndex&, int role) const;
  QVariant headerData(int, Qt::Orientation,int) const{return QVariant();};

  FGObject *getFGObject(const QModelIndex &index)const;
  QModelIndex index(FGObject *,const QModelIndex &parent=QModelIndex())const;

  void resetData(Graph *);
  void packIDs();

  FGObject *removeRow(QModelIndex &parent,int position);
  QModelIndex insertRow(QModelIndex &parent,int position,FGObject *fgo);
  QModelIndex moveRow(QModelIndex &parent,int row,int by);
 private:
  Graph *pgraph;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _SETTREEMODEL_H */

