/*************************************************************************
 * @(#)SetTreeView.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   17 May 2011
 *************************************************************************
 */

#include <QColor>
#include "GraphObject.hh"
#include "FGObject.hh"
#include "Function.hh"
#include "SetTreeView.hh"
#include "SetTreeModel.hh"
#include "Function.hh"
#include "MyDebug.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
SetTreeView::SetTreeView(QWidget *parent)
  :QTreeView(parent)
{
  connect(this,SIGNAL(collapsed(const QModelIndex &)),
	  this,SLOT(onCollapsed(const QModelIndex &)));
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetTreeView::currentChanged(const QModelIndex &current,
				 const QModelIndex &previous
				 )
{
  if(!current.isValid()) return;
  //QTreeView::currentChanged(current,previous);
  scrollTo(current);
  emit myCurrentChanged(current,previous);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetTreeView::onCollapsed(const QModelIndex & index)
{
  return;
  //ItemSelection sel=selectionModel()->selection();
  //ItemSelection del;
  if(!index.isValid()) return;


  for(int i=0;i<model()->rowCount(index);i++){
    const QModelIndex &ci=index.child(i,0);
    //    myDebug()<<"child"<<ci;
    //del
    selectionModel()->select(ci,QItemSelectionModel::Deselect);
  }

  
}



/*EOF*/ 
