/* @(#)ShapeDlg.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SHAPEDLG_H
#define _SHAPEDLG_H 1


#include <QCloseEvent>
#include "BrainDialog.hh"
#include "ui_ShapeDlg.h"
#include "ToolButtons.hh"

class QSignalMapper;
class QMenu;
class GraphObject;
class Shape; 
class Shapes; 
class ShapesModel;
class String;


/* ***********************************************************************
 *
 * ***********************************************************************
 */
class ShapeDlg:public BrainDialog, protected Ui::ShapeDlg
{
  Q_OBJECT
public:
  ShapeDlg(QWidget *parent,QWidget *base,const char *name);
  ~ShapeDlg();
  
  void setData(Shapes *shs=0,Shape *sh=0);  
  virtual void reloadDialog();
  
  void updateRequest(Shape *);
  void deleteShape(Shape *);
  
signals:
  void acceptRequest(GraphObject *,bool forceChanged);
  void endRequest();

public slots:
  virtual void reject(){ emit endRequest();};
protected:
  virtual void closeEvent( QCloseEvent * e ) {e->accept(); emit endRequest();};
  virtual bool event(QEvent *event);


private slots:
  void on_pbApply_clicked();
  void on_pbCancel_clicked(){ reject(); };
  void on_pbClose_clicked();
  void onDlgEnd();
  virtual void on_pbHelp_clicked(){};
  void slotInsertShape(int);
  void slotDeleteShape(bool warn=true);
  void slotMoveShape();
  void setAddDeleteEnabed(const QModelIndex &current);
  void on_lvShapes_currentItemChanged(const QModelIndex &
					 ,const QModelIndex &);
  void onContentChanged(bool);
  void slotInsertTriggerd();

private:
  bool dataAcceptable();
  void apply();
  bool protectChanges(bool withCancel=true);

 private:
  Shape *t_sh;
  Shapes *t_shs;
  ShapesModel *shsmodel; 
  QMenu *insertMenu;
  QSignalMapper *signalMapper;
  bool mute_currentIndexChanged;
  ToolButtons ptoolbuttons;
};



#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _SHAPEDLG_H */

