/* @(#)ShapePropWdg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SHAPEPROPWDG_H
#define _SHAPEPROPWDG_H 1


#include "PropWdgBase.hh"
#include "ui_ShapePropWdg.h"
#include "Xfp.hh"

class Shape;
class Point;
class Size;

class ShapePropWdg:public PropWdgBase, private Ui::ShapePropWdg
{
  Q_OBJECT
 public:
  ShapePropWdg(QWidget *parent);
  ~ShapePropWdg();

  void setData(void *);
  void check(QString &msg);
  void applyData(void *);
  void updateRequest(void *);

 private slots:
  void on_cmbHeadPosition_currentIndexChanged(int);
  void on_cmbCoordSystem_currentIndexChanged(int);
  void on_cmbEllCoordSystem_currentIndexChanged(int index);
 private :
  void setPosition(const Point &s,const Point &e);
  void getPosition(Point &s,Point &e);
  void setCenter(const Point &c);
  void getCenter(Point &c);
  void setRadii(const Size &r);
  void getRadii(Size &r);
 private :
  bool mute_coordsystem;
  Shape *p_sh;
  Xfp::CoordinateSystem oldcoordsys;
  Xfp::CoordinateSystem oldellcoordsys;
};




#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _SHAPEPROPWDG_H */

