/* @(#)ShapesModel.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SHAPESMODEL_H
#define _SHAPESMODEL_H 1

#include <QAbstractListModel>

class Shape;
class Shapes;

class ShapesModel: public QAbstractListModel
{
 public:
  ShapesModel(QObject * parent);
  QVariant headerData(int section,Qt::Orientation orientation
			      ,int role=Qt::DisplayRole)const;
  int rowCount(const QModelIndex & parent=QModelIndex()) const;
  QVariant data(const QModelIndex &index,int role=Qt::DisplayRole)const;
  bool insertRow(int &row,Shape *sh);
  bool insertRow(int &row,Xfp::ShapeType mode);
  void removeRow(int row);
  bool moveRow(int row,int by);

  Shape *currentShape(const QModelIndex &index)const;
  QModelIndex shapeIndex(Shape *)const;
  void reset(Shapes *);
  void resetItem(Shape *);
 private:
  Shapes *pshapes;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _SHAPESMODEL_H */

