/* @(#)TextBoxDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _TEXTBOXDLG_H
#define _TEXTBOXDLG_H 1


#include <QCloseEvent>
#include "BrainDialog.hh"
#include "ui_TextBoxDlg.h"

class GraphObject;
class TextBoxes; 
class TextBox; 
class TextBoxesModel;
class String;
class ToolButtons;

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class TextBoxDlg:public BrainDialog, protected Ui::TextBoxDlg
{
  Q_OBJECT
public:
  TextBoxDlg(QWidget *parent,QWidget *base,const char *name);
  ~TextBoxDlg();
  
  void setData(TextBoxes *tbs=0,TextBox *tb=0); 
  virtual void reloadDialog();
  
  void updateRequest(TextBox *);
  void deleteTextBox(TextBox *);
  void copyTextBox(TextBox *);
  
signals:
  void acceptRequest(GraphObject *,bool forceChanged);
  void endRequest();

public slots:
  virtual void reject(){ emit endRequest();};
protected:
  virtual void closeEvent( QCloseEvent * e ) {e->accept(); emit endRequest();};
  virtual bool event(QEvent *event);


private slots:
  void on_pbApply_clicked();
  void on_pbCancel_clicked(){ reject(); };
  void on_pbClose_clicked();
  void onDlgEnd();
  virtual void on_pbHelp_clicked();
  void slotInsertTextBox();
  void slotDeleteTextBox(bool warn=true);
  void slotMoveTextBox();
  void setAddDeleteEnabed(const QModelIndex &current);
  void on_lvTextBoxes_currentItemChanged(const QModelIndex &
					 ,const QModelIndex &);
  void onContentChanged(bool);

private:
  bool dataAcceptable();
  void apply();
  bool protectChanges(bool withCancel=true);

 private:
  TextBox *t_tb;
  TextBoxes *t_tbs;
  TextBoxesModel *tbsmodel;
  bool mute_currentIndexChanged;
  ToolButtons *ptoolbuttons;
};



#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _TEXTBOXDLG_H */

