/* @(#)TextBoxPropWdg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _TEXTBOXPROPWDG_H
#define _TEXTBOXPROPWDG_H 1

#include "PropWdgBase.hh"
#include "Point.hh"
#include "Xfp.hh"
#include "ui_TextBoxPropWdg.h"


class TextBox;

class TextBoxPropWdg:public PropWdgBase, private Ui::TextBoxPropWdg
{
  Q_OBJECT
 public:
  TextBoxPropWdg(QWidget *parent);
  ~TextBoxPropWdg();

  void setData(void *);
  void check(QString &msg);
  void applyData(void *);
  void updateRequest(void *);

 private slots:
  void on_cmbPosCoordSystem_currentIndexChanged(int index);
  void placementChanged();

 private:
  void getPosition(Point &s,double &o);
  void setPosition(const Point &s);

 private:
  TextBox *p_tb;
  bool mute_coordsystem;
  Xfp::CoordinateSystem oldcoordsys;

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _TEXTBOXPROPWDG_H */

