/* @(#)TextBoxesModel.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _TEXTBOXESMODEL_H
#define _TEXTBOXESMODEL_H 1

#include <QAbstractListModel>

class TextBox;
class TextBoxes;

class TextBoxesModel: public QAbstractListModel
{
 public:
  TextBoxesModel(QObject * parent);
  QVariant headerData(int section,Qt::Orientation orientation
			      ,int role=Qt::DisplayRole)const;
  int rowCount(const QModelIndex & parent=QModelIndex()) const;
  QVariant data(const QModelIndex &index,int role=Qt::DisplayRole)const;
  bool insertRow(int &row,TextBox *tb=0);
  void removeRow(int row);
  bool moveRow(int row,int by);

  TextBox *currentTextBox(const QModelIndex &index)const;
  QModelIndex textBoxIndex(TextBox *)const;
  void reset(TextBoxes *tbs);
  void resetItem(TextBox *tb);
 private:
  TextBoxes *ptextboxes;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _TEXTBOXESMODEL_H */

