/* @(#)TicMarksDlg.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _TICMARKDLG_H
#define _TICMARKDLG_H 1

#include <QCloseEvent>
#include "BrainDialog.hh"
#include "ui_TicMarksDlg.h"

class GraphObject;
class Graph;
class TicMarks;

class TicMarksDlg:public BrainDialog, protected Ui::TicMarksDlg
{
  Q_OBJECT
public:
  TicMarksDlg(QWidget *parent,QWidget *base,const char *name);
  ~TicMarksDlg();

  void setData(Graph *graph,TicMarks *tms=0); 
  virtual void reloadDialog();
  void updateRequest(Graph *graph,TicMarks *,const QString &requ);
signals:
  void acceptRequest(GraphObject *,bool forceChanged);
  void endRequest();
  
public slots:
  virtual void reject(){ emit endRequest();};

protected:
  virtual void closeEvent( QCloseEvent * e ) {e->accept(); emit endRequest();};

private slots:
  void on_pbApply_clicked();
  void on_pbCancel_clicked(){ reject(); };
  void on_pbClose_clicked();
  void onDlgEnd();
  virtual void on_pbHelp_clicked(){};

  void onContentChanged(bool changed){
    pbApply->setEnabled(changed);
  };
  
private:
  bool dataAcceptable();
  void apply();

 private:
  Graph *t_graph;
  TicMarks *t_tms;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _TICMARKDLG_H */

