/* @(#)UserTicModel.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _USERTICMODEL_H
#define _USERTICMODEL_H 1

#include <QAbstractTableModel>
#include <QStringList>

class Tic;
class Tics;



/* ***********************************************************************
 *
 * ***********************************************************************
 */
class UserTicModel: public QAbstractTableModel
{
public:
  enum Columns{AxisType=0,Kind=1,Position=2,Label=3,TicSide=4,
	       TicLabelSide=5,TicLength=6};
  UserTicModel( QObject * parent);
  ~UserTicModel();

  int rowCount(const QModelIndex & parent=QModelIndex()) const;
  int columnCount(const QModelIndex &parent=QModelIndex()) const;
  QVariant headerData(int section, Qt::Orientation orientation, int role) const;
  QVariant data(const QModelIndex &index, int role) const;
  Qt::ItemFlags flags(const QModelIndex &index) const;
  bool setData(const QModelIndex &index, const QVariant &value
	       , int role=Qt::EditRole);
  bool insertRow(int &row,Tic *t=0);
  void removeRow(int row);
  bool moveRow(int row,int by);


  void resetData(Tics *);

private:
  QStringList pheader;
  Tics *ptics;

};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _USERTICMODEL_H */

