/* @(#)UserTicWdg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _USERTICWDG_H
#define _USERTICWDG_H 1


#include <QMap>
#include "ui_UserTicWdg.h"
#include "ToolButtons.hh"
#include "UserTicModel.hh"

class FunctionGroup;
class Graph;
class ComboBoxDelegate;
class Tics;

class UserTicWdg:public QWidget, private Ui::UserTicWdg
{
  Q_OBJECT
 public:
  UserTicWdg(QWidget *parent=0);
  ~UserTicWdg();
  
  void setData(Graph *graph);
  void updateRequest(Graph *,const QString &);
  void applydata();
  
 signals:
  void dataChanged();

 private slots:
  void on_cmbGroup_currentIndexChanged(int);
  void on_cbDrawUserTics_toggled(bool);
  void onModelDataChanged(const QModelIndex&,const QModelIndex&);
  void slotInsertTic();
  void slotDeleteTic();
  void slotMoveTic();

 private:
  void adjustTvUserTics();

 private:
  UserTicModel *umodel;
  Graph *pgraph;
  ComboBoxDelegate *axisdelegate;
  ComboBoxDelegate *kinddelegate;
  ComboBoxDelegate *sidedelegate;
  Tics *putics;
  QList<QPair<FunctionGroup*,Tics*> > pgtics;

  ToolButtons ptoolbuttons;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _USERTICWDG_H */

