/*************************************************************************
 * @(#)WeightDefDlg.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   02 Jun 2011
 *************************************************************************
 */

#include "WeightDefDlg.hh"
#include "WeightDefModel.hh"
#include "WeightLabelModel.hh"
#include "FString.hh"
#include "Config.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
WeightDefDlg::WeightDefDlg(QWidget *parent)
  :QDialog(parent),wdmodel(0),wlmodel(0)
{
  setupUi(this);
  setWindowTitle(IDS_APP_NAME);

  wdmodel=new WeightDefModel(this);
  lvWeightDefs->setModel(wdmodel);

  wlmodel=new WeightLabelModel(this);
  lvAvailableWeights->setModel(wlmodel);

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
WeightDefDlg::~WeightDefDlg()
{
  if(wdmodel) delete wdmodel; wdmodel=0;
  if(wlmodel) delete wlmodel; wlmodel=0;
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void WeightDefDlg::setData(WeightLabels *wls)
{
  wdmodel->reset(wls);
  wlmodel->reset(wls);
}

/*EOF*/ 
