/*************************************************************************
 * @(#)WeightDefModel.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   02 Jun 2011
 *************************************************************************
 */

#include "WeightDefModel.hh"
#include "WeightLabels.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
WeightDefModel::WeightDefModel(QObject * parent)
  : QAbstractListModel(parent),pwls(0)
{
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void WeightDefModel::reset(WeightLabels *wls)
{
  pwls=wls;

  
  if(pwls) QAbstractListModel::reset();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
QVariant WeightDefModel::headerData(int section,Qt::Orientation orientation
		    ,int role)const
{
  Q_UNUSED(section);
  if (role != Qt::DisplayRole)
    return QVariant();
  if (orientation == Qt::Horizontal) {
    return "Header";
  }
  return QVariant();

}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
int WeightDefModel::rowCount(const QModelIndex & parent) const
{
  Q_UNUSED(parent);
  if(!pwls) return 0;
  return pwls->size();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
Qt::ItemFlags WeightDefModel::flags(const QModelIndex &index)const
{
  if (!index.isValid())
    return Qt::ItemIsEnabled;
  return QAbstractListModel::flags(index) ;//| Qt::ItemIsUserCheckable;

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
QVariant WeightDefModel::
data(const QModelIndex &index,int role)const
{
  if(!pwls) return QVariant();
  if (!index.isValid()) return QVariant();
  int row=index.row();
  //int col=0;
  if (row >= pwls->size() || row < 0) return QVariant();

  const WeightLabel *wl=pwls->at(row);
  
  if (role == Qt::DisplayRole) {
    return wl->label()();
//   }else if (role == Qt::UserRole) {
//     int ind;
//     if((ind=pwss->indexOf(wd))>=0)
//       return QVariant::fromValue((void*)(*pwss)[ind]);
//     else
//       return QVariant::fromValue((void*)0);
//   }else if(role == Qt::CheckStateRole){
//     int ind;
//     if((ind=pwss->indexOf(wd))>=0)
//       return ((*pwss)[ind]->active()?Qt::Checked:Qt::Unchecked);
//     else
//       return Qt::Unchecked;
  }

  return QVariant();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
// bool WeightDefModel::setData(const QModelIndex &index,const QVariant &value,
// 			     int role)
// {
//   Q_UNUSED(value);
//   if(!pwds || !pwss) return false;
//   if (!index.isValid()) return false;
//   int row=index.row();
//   //int col=0;
//   if (row >= pwds->size() || row < 0) return false;

//   const WeightLabel *wd=pwds->at(row);
//   WeightSelection *ws=0;
//   if(role == Qt::CheckStateRole){
//     int ind;
//     if((ind=pwss->indexOf(wd))>=0){
//       //myDebug()<<value.toInt();
//       ws=(*pwss)[ind];
//       ws->setActive(value.toInt()==Qt::Checked);
//       emit weightItemSelected(ws);
//     }else{
//       //myDebug()<<value.toInt();
//       pwss->append(new WeightSelection(wd,value.toInt()==Qt::Checked));
//       emit weightItemSelected(pwss->last());

//     }
//     emit(dataChanged(index, index));
//     return true;

    
//   }
//   return false;
// }



/*EOF*/ 



/*EOF*/ 
