/*************************************************************************
 * @(#)WeightLabelModel.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   02 Jun 2011
 *************************************************************************
 */

#include "WeightLabelModel.hh"
#include "WeightLabels.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
WeightLabelModel::WeightLabelModel(QObject * parent)
  : QAbstractListModel(parent),pwls(0)
{
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void WeightLabelModel::reset(WeightLabels *wls)
{
  pwls=wls;

  
  if(pwls) QAbstractListModel::reset();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
QVariant WeightLabelModel::headerData(int section,Qt::Orientation orientation
		    ,int role)const
{
  Q_UNUSED(section);
  if (role != Qt::DisplayRole)
    return QVariant();
  if (orientation == Qt::Horizontal) {
    return "Header";
  }
  return QVariant();

}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
int WeightLabelModel::rowCount(const QModelIndex & parent) const
{
  Q_UNUSED(parent);
  if(!pwls) return 0;
  return pwls->size();
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
Qt::ItemFlags WeightLabelModel::flags(const QModelIndex &index)const
{
  if (!index.isValid())
    return Qt::ItemIsEnabled;
  return QAbstractListModel::flags(index) ;//| Qt::ItemIsUserCheckable;

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
QVariant WeightLabelModel::
data(const QModelIndex &index,int role)const
{
  if(!pwls) return QVariant();
  if (!index.isValid()) return QVariant();
  int row=index.row();
  //int col=0;
  if (row >= pwls->size() || row < 0) return QVariant();

  const String &s=pwls->at(row)->label();
  
  if (role == Qt::DisplayRole) {
    return s();
  }

  return QVariant();
}


/*EOF*/ 
