/* @(#)WeightSelListView.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _WEIGHTSELLISTVIEW_H
#define _WEIGHTSELLISTVIEW_H 1

#include <QListView>
#include <QItemSelectionModel>
#include <QDebug>


/* ***********************************************************************
 *
 * ***********************************************************************
 */

class WeightSelSelectionModel: public QItemSelectionModel
{
  Q_OBJECT
public:
  WeightSelSelectionModel(QAbstractItemModel *model)    
    :QItemSelectionModel(model){
  };
  virtual void select(const QItemSelection &selection,
		      QItemSelectionModel::SelectionFlags command);
    
  
private:
  QModelIndex plastcurrent;

};
/* ***********************************************************************
 *
 * ***********************************************************************
 */


class WeightSelListView:public QListView{
  Q_OBJECT
public:
  WeightSelListView(QWidget *parent=0)
    :QListView(parent){};

signals:
  void myCurrentItemChanged(const QModelIndex &,const QModelIndex &);
  void myDataChanged();
protected slots:
  virtual void currentChanged(const QModelIndex &current
			      ,const QModelIndex &previous){
    QListView::currentChanged(current,previous);
    scrollTo(current);
    emit myCurrentItemChanged(current,previous);
  };
  void dataChanged(const QModelIndex&,const QModelIndex&){
    emit myDataChanged();
  };
 private:

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _WEIGHTSELLISTVIEW_H */

