/* @(#)WeightSelModel.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _WEIGHTDEFMODEL_H
#define _WEIGHTDEFMODEL_H 1

#include <QAbstractListModel>

class WeightSelections;
class WeightSelection;

class WeightSelModel: public QAbstractListModel
{
  Q_OBJECT;
 public:
  WeightSelModel(QObject * parent);
  QVariant headerData(int section,Qt::Orientation orientation
		      ,int role=Qt::DisplayRole)const;
  int rowCount(const QModelIndex & parent=QModelIndex()) const;
  Qt::ItemFlags flags(const QModelIndex &index)const;
  QVariant data(const QModelIndex &index,int role=Qt::DisplayRole)const;
  bool setData(const QModelIndex &index,const QVariant &value,
	       int role=Qt::EditRole);
  void reset(WeightSelections *wss);

  WeightSelections *weightSelections()const{return pwss;};

  WeightSelection *removeRow(int position);
  bool insertRow(int position,WeightSelection *ws=0);
  bool moveRow(int row,int by);

 signals:
  void weightItemSelected(WeightSelection *);
 private:
  WeightSelections *pwss;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _WEIGHTDEFMODEL_H */

