/*************************************************************************
 * @(#)Attributes.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   06 Oct 2011
 *************************************************************************
 */

#include "Attributes.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
String SymbolStyle::asCommands(const String &tab)const
{
  String s=Sprintf("%sstyle %s\n"
		   "%ssize %g\n"
		   "%s"
		   "%s"
		   ,tab(),Xfp::symbolName(ptype)
		   ,tab(),psize
		   ,plinestyle.asCommands(tab+"line",pextralinecolor)()
		   ,pfillstyle.asCommands(tab+"fill",pextrafillcolor)()
		   

);
  return s;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
String FunctionAttribs::asCommands(const String &tab)const
{
  String s=Sprintf("%slegend \"%s\"\n"
		   "%sshow in legend %s\n"
		   "%sinterpolation depth %ld\n"
		   "%smax cutoff %g\n"
		   "%suse second derivative %s\n"
		   "%s"
		   "%s"
		   ,tab(),plegend()
		   ,tab(),Xfp::OnOff(puselegend)
		   ,tab(),pinterpolationdepth
		   ,tab(),pzmax
		   ,tab(),Xfp::OnOff(pusesecondderivative)
		   ,plinestyle.asCommands(tab+"line")()
		   ,psymbolstyle.asCommands(tab+"symbol ")()
		   );
  
  return s;
}




/*EOF*/ 
