/* @(#)FunctionGroups.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _FUNCTIONGROUPS_HH
#define _FUNCTIONGROUPS_HH 1


class FunctionGroup;

/* ***********************************************************************
 *
 * ***********************************************************************
 */

class FunctionGroups
{
 public:
  FunctionGroups(Graph *parent);
  ~FunctionGroups();

  void reset();

  inline long size()const{return pgroups.size();};
  inline FunctionGroup *at(long i){return pgroups[i];};
  inline const FunctionGroup *at(long i)const{return pgroups.at(i);};
  inline FunctionGroup *last(){return pgroups.last();};

  inline long indexOf(FunctionGroup *fg){return pgroups.indexOf(fg);};

  FunctionGroup *getById(long uniqueid,bool append=false);
  FunctionGroup *getExistingGroupOrNew(long id);

  FunctionGroup *takeAt(long i);
  
  FunctionGroup *take(FunctionGroup *g);

  void insert(long position,FunctionGroup *fg);
  FunctionGroup *insert(long position);

  FunctionGroup *append(){return insert(pgroups.size());};

  void packIDs();

  void invalidateRange();
  
  bool changed()const;
  void setChanged(bool c);

 private:
  long makeUniqueId();

 private:
  PtrArray<FunctionGroup> pgroups;
  Graph *pgraph;
  long pcurrentgroupindex;
};


#endif /* _FUNCTIONGROUPS_HH */

