/* @(#)Functions.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _FUNCTIONS_HH
#define _FUNCTIONS_HH 1

//#include <>
#include "PtrArray.hh"

class FunctionGroup;
class Function;
class Graph;

/* ***********************************************************************
 *
 * ***********************************************************************
 */


class Functions{
public:
  Functions(FunctionGroup *parent);
  ~Functions(){};

  void reset(){ pfuncs.clear(); };

  inline long size()const{return pfuncs.size();};
  void setSize(long size); //shrinking
  void assureSize(long size);//non shrinking

  inline Function *at(long i){return pfuncs[i];};
  inline const Function *at(long i)const{return pfuncs.at(i);};

  void insert(long position,Function *fu);
  Function *insert(long position);
  Function *append(){return insert(pfuncs.size());};

  Function *takeAt(long i);
  Function *take(Function *f);

  Function *getById(long uniqueid,bool append=false);

  void invalidateRange();


  bool changed()const;
  void setChanged(bool c);

private:
  long makeUniqueId();
  void assureUniqueId(Function *fu);

private:
  PtrArray<Function> pfuncs;
  FunctionGroup *pgroup;

};


#endif /* _FUNCTIONS_HH */

