/*************************************************************************
 * @(#)Graphs.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   19 Jul 2012
 *************************************************************************
 */

#include "PtrArray.hh"
#include "Graph.hh"
#include "Graphs.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
Graphs::Graphs(Page *parent)
  :ppage(parent),
   pcurrentgraphindex(-1)
{
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void Graphs::reset(bool createOneGraph)
{
  pgraphs.resize(0,true);
  
  if(createOneGraph){
    getById(0,true);
    pcurrentgraphindex=0;
  }

    
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
Graph *Graphs::getById(long uniqueid,bool append)
{
  // get an existing graph by id or create a new one with id
  for(int i=0;i<size();i++){
    if(at(i)->puniqueid==uniqueid){
      return at(i);
    }
  }
  if(!append) return 0;
  
  Graph *gr=new Graph(ppage,uniqueid);
  pgraphs.append(gr);

  return gr;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void Graphs::insertGraph(long i,Graph *gr)
{
  //todo: this is an index based fuinction?
  if(!gr){
    printf("Graphs::insertGraph: gr=0!?\n");
    exit(1);
  }
  gr->reParent(ppage);
  pgraphs.insert(i,gr);
 
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void Graphs::insertGraph(long i)
{
  Graph *gr=new Graph(ppage,makeUniqueId());
  pgraphs.insert(i,gr);
 
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
long Graphs::makeUniqueId()
{
  long ind=0;
  while (true){
  again:;
    for(long i=0;i<size();i++){
      if(at(i)->puniqueid==ind){
	ind++;
	goto again;
      }
    }
    break;
  }
  return ind;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
Graph *Graphs::getExistingGraphOrNew1(long id)
{
  if(id==Graph::CurrentGraph) {
    if(pcurrentgraphindex<0 || pcurrentgraphindex>=pgraphs.size())
      return 0;
    return pgraphs[pcurrentgraphindex];
  }
  if(id==Graph::NewGraph){
    insertGraph(size());
    return pgraphs[size()-1];
  }
  return getById(id);
}



/*EOF*/ 
