/* @(#)Graphs.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _GRAPHS_HH
#define _GRAPHS_HH 1

#include "MyMath.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class Page;
class Graph;

class Graphs
{
 public:
  Graphs(Page *);
  ~Graphs(){};

  inline long size()const{return pgraphs.size();};
  inline Graph *at(long i){return pgraphs[i];};
  inline const Graph *at(long i)const{return pgraphs.at(i);};

  Graph *getExistingGraphOrNew1(long id);
  Graph *getById(long id,bool append=false);

  inline long indexOf(Graph *gr){return pgraphs.indexOf(gr);};
  inline Graph *takeAt(long i){return pgraphs.takeAt(i);};
  inline Graph *take(Graph *gr){return pgraphs.take(gr);};

  inline void deleteGraph(long i){
    pgraphs.removeAt(i);
    pcurrentgraphindex=MyMath::max<long>(0,pcurrentgraphindex-1);
    if(pgraphs.size()==0)pcurrentgraphindex=-1;
    
  };
/*   inline void deleteGraphById(long id){ */
/*     Graph *gr=getById(id); */
/*     if(gr){ */
/*       pgraphs.remove(gr); */
/*     } */
/*   }; */

  void insertGraph(long i,Graph *gr);
  void insertGraph(long i);

  inline long currentGraphIndex()const{return pcurrentgraphindex;};

  inline const Graph *currentGraph()const {
    if(pcurrentgraphindex<0 || pcurrentgraphindex>=pgraphs.size())
      return 0;
    return pgraphs.at(pcurrentgraphindex);};
  inline Graph *currentGraph(){
    if(pcurrentgraphindex<0 || pcurrentgraphindex>=pgraphs.size())
      return 0;
    return pgraphs[pcurrentgraphindex];
  };
  inline void setCurrentGraph(const Graph *gr){
    pcurrentgraphindex=pgraphs.indexOf(gr);
  };


  void reset(bool createOneGraph=true);


 private:
  long makeUniqueId();

 private:
  PtrArray<Graph> pgraphs;
  Page *ppage;
  long pcurrentgraphindex;
  
};

#endif /* _GRAPHS_HH */

