/* @(#)OptMatelDefinition.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _OPTMATELDEF_H
#define _OPTMATELDEF_H 1

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class OptMatelDefinition{
 public:
  OptMatelDefinition():pchanged(false),pemin(0.0),pemax(1),pde(0.5),
    pmatelmin(0.05),pmatelmax(1),pmatelscale(1000){};
  ~OptMatelDefinition(){};
  
  double ergMin()const{return pemin;};
  void setErgMin(double e){pchanged|=(pemin!=e);pemin=e;};

  double ergDe()const{return pde;};
  void setErgDe(double e){pchanged|=(pde!=e);pde=e;};

  double ergMax()const{return pemax;};
  void setErgMax(double e){pchanged|=(pemax!=e);pemax=e;};

  double matelMin()const{return pmatelmin;};
  void setMatelMin(double m){pchanged|=(pmatelmin!=m);pmatelmin=m;};

  double matelMax()const{return pmatelmax;};
  void setMatelMax(double m){pchanged|=(pmatelmax!=m);pmatelmax=m;};

  double matelScale()const{return pmatelscale;};
  void setMatelScale(double s){pchanged|=(pmatelscale!=s);pmatelscale=s;};
  
  bool changed()const{return pchanged;};
  void setChanged(bool c){pchanged=c;};

 private:
  bool pchanged;
  double pemin,pemax,pde,pmatelmin,pmatelmax,pmatelscale;
};



#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _OPTMATELDEF_H */

