/*************************************************************************
 * @(#)Paper.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   14 Oct 2011
 *************************************************************************
 */

#include "Paper.hh"

const char *Paper::pspapersizes[]={
 "Letter"       ,"LetterSmall"  ,"Legal"        ,"Statement"    
,"Tabloid"      ,"Ledger"       ,"Folio"        ,"Quarto"       
,"7x9"          ,"9x11"         ,"9x12"         ,"10x13"        
,"10x14"        ,"Executive"    ,"A0"           ,"A1"           
,"A2"           ,"A3"           ,"A4"           ,"A5"           
,"A6"           ,"A7"           ,"A8"           ,"A9"           
,"A10"          ,"B0"           ,"B1"           ,"B2"           
,"B3"           ,"B4"           ,"B5"           ,"B6"           
,"B7"           ,"B8"           ,"B9"           ,"B10"          
,"ISOB0"        ,"ISOB1"        ,"ISOB2"        ,"ISOB3"        
,"ISOB4"        ,"ISOB5"        ,"ISOB6"        ,"ISOB7"        
,"ISOB8"        ,"ISOB9"        ,"ISOB10"       ,"C0"           
,"C1"           ,"C2"           ,"C3"           ,"C4"           
,"C5"           ,"C6"           ,"C7"           ,"DL"           
};


const  char *Paper::psorienttypes[]={
  "Portrait",
  "Landscape"
};

const long Paper::pspaperwidth[]={
 612            ,612            ,612            ,396            
,792            ,1224           ,612            ,610            
,504            ,648            ,648            ,720            
,720            ,540            ,2384           ,1684           
,1191           ,842            ,595            ,420            
,297            ,210            ,148            ,105            
,73             ,2920           ,2064           ,1460           
,1032           ,729            ,516            ,363            
,258            ,181            ,127            ,91             
,2835           ,2004           ,1417           ,1001           
,709            ,499            ,354            ,249            
,176            ,125            ,88             ,2599           
,1837           ,1298           ,918            ,649            
,459            ,323            ,230            ,312            
};

const  long Paper::pspaperheight[]={
 792            ,792            ,1008           ,612            
,1224           ,792            ,936            ,780            
,648            ,792            ,864            ,936            
,1008           ,720            ,3370           ,2384           
,1684           ,1191           ,842            ,595            
,420            ,297            ,210            ,148            
,105            ,4127           ,2920           ,2064           
,1460           ,1032           ,729            ,516            
,363            ,258            ,181            ,127            
,4008           ,2835           ,2004           ,1417           
,1001           ,709            ,499            ,354            
,249            ,176            ,125            ,3676           
,2599           ,1837           ,1296           ,918            
,649            ,459            ,323            ,624            
};


/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool Paper::changed()const
{
  return pchanged;
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void Paper::setChanged(bool c){
  pchanged=c;
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
String Paper::asCommands(const String &tab)const
{
  if(ppapersize==Custom){
  return Sprintf("%spaper size %ld , %ld\n"
		 "%spaper orientation %s\n"
		 ,tab(),pcustomwidth,pcustomheight
		 ,tab(),orientationTypeName(porientation)
		 );
  }else{
    return Sprintf("%spaper size %s\n"
		 "%spaper orientation %s\n"
		   ,tab(),paperSizeName(ppapersize)
		   ,tab(),orientationTypeName(porientation)
		   );
  }
}



/*EOF*/ 
