/* @(#)ParameterList.hh
 * author: magru@unas
 */

#ifndef _PARAMETERLIST_H
#define _PARAMETERLIST_H 1

#include "FString.hh"
#include "ValueArray.hh"

class ParameterList{
 public:

  enum ParameterListType{None=0,Parameter=1};

  class ParameterListEntry{
  public:
  ParameterListEntry():ptype(None){};
    ParameterListEntry(ParameterListType t,const String &pair);
    inline ParameterListType type()const{return ptype;};
    inline const String &name()const{return pname;};
    inline const String &value()const{return pvalue;};
  private:
    ParameterListType ptype;    
    String pname;
    String pvalue;
  };

  ParameterList(){};
 public:
  void scanCommandLine();
  String getValueAsString(const String &name);
  double getValue(const String &name);
 private:
  ValueArray<ParameterListEntry> pdata;
};

extern ParameterList parameterList;


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _PARAMETERLIST_H */

