/*************************************************************************
 * @(#)Position.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   25 Apr 2011
 *************************************************************************
 */

#include "Position.hh"
#include "Graph.hh"
#include "ViewBox.hh"
#include "World.hh"





const Position::tsOffsetDescriptor Position::paddoffset_description[]={
  {Position::None,"none","NONE"}
  ,{Position::XOposSiteTicLabelHeight,"opposite x tic label height","XOPPTICLHEI"}
  ,{Position::XOposSiteTicLabelOffset,"opposite x tic label offset","XOPPTICLOFF"}
  ,{Position::XNormSiteTicLabelHeight,"normal   x tic label height","XNORTICLHEI"}
  ,{Position::XNormSiteTicLabelOffset,"normal   x tic label offset","XNORTICLOFF"}
  ,{Position::YOposSiteTicLabelWidth,"opposite y tic label width","YOPPTICLWID"}
  ,{Position::YOposSiteTicLabelOffset,"opposite y tic label offset","YOPPTICLOFF"}
  ,{Position::YNormSiteTicLabelWidth,"normal   y tic label width","YNORTICLWID"}
  ,{Position::YNormSiteTicLabelOffset,"normal   y tic label offset","YNORTICLOFF"}
  ,{Position::SubTitleOffset,"subtitle offset","SUBTITLEOFF"}
  ,{Position::SubTitleHeight,"subtitle height","SUBTITLEHEI"}
  ,{Position::OppXaLabelOffset,"opposite x-axis label offset","XOPXALBLOFF"}
  ,{Position::OppXaLabelHeight,"opposite x-axis label height","XOPXALBLHEI"}
};

const long Position::pmax_addoffsets=sizeof(Position::paddoffset_description)
  /sizeof(Position::tsOffsetDescriptor);


/* ***********************************************************************
 *
 * ***********************************************************************
 */
Point Position::posToDC(const Graph *graph
			,const Point &p,Xfp::CoordinateSystem currentmode)
  const
{
  if(currentmode==Xfp::CSYView){
    const ViewBox *vb=graph->viewBox();
    return vb->vctodc(p);
  }else{
    const World *world=graph->world();
    return world->wctodc(p);
  }

}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
Point Position::dcToPos(const Graph *graph
			 ,const Point &p,Xfp::CoordinateSystem currentmode)
  const
{
  if(currentmode==Xfp::CSYView){
    const ViewBox *vb=graph->viewBox();
    return vb->dctovc(p);
  }else{
    const World *world=graph->world();
    return world->dctowc(p);
  }

}


/*EOF*/ 
