/*************************************************************************
 * @(#)WeightLabels.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   02 Jun 2011
 *************************************************************************
 */

#include "Except.hh"
#include "WeightLabels.hh"
#include "MyMath.hh"
#include "MyDebug.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
WeightLabels::~WeightLabels()
{
  //  myDebug()<<"WeightLabels"<<this<<"dying";
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void WeightLabels::analyse()
{
  return;
  myDebug()<<"analyse";
  for(int i=0;i<pwls.size();i++){
    String s=pwls.at(i)->label();
    //myDebug()<<"s"<<i<<s;
    int ipar=s.find("(");
    String el="";
    long  site=-1;
    //myDebug()<<"iapar"<<ipar;
    if(ipar>=0 && ipar<3){
      el=(s.subString(0,ipar-1)+" ").subString(0,1);
      //myDebug("el <%s>",el());
    }
    s=s.subString(ipar+1);
    ipar=s.find(")");
    if(ipar>=0){
      if(!String::islong(&site,s.subString(0,ipar-1)()))
	site=-1;
    }
    s=s.subString(ipar+1);
    long nmain,l,j,m;
    String::StateLabels sl=String::isStateLabel(s,nmain,l,j,m);
    switch(sl){
    case String::SL_nlm:
      {
 	break;
      }
    default:
      nmain=-1;
      l=-1;
      j=-1;
      break;
    }
    char c='?';
    try{
      c=String::intToSpdf(l);
    }catch(Except &){};
    //if(el.length()>0){
    myDebug("<%s><%ld><%1ld%c %1ld/2 %-ld>",el(),site,nmain,c,j,m);
      //}
  }

}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
WeightLabelsCollector::WeightLabelsCollector()
  : pminuniqueindex(-1),plastuniqueindex(0)
{
  //printf("WeightLabelsCollector this=%p\n",this);
  pwls.setAutoDelete(true);
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
WeightLabelsCollector::~WeightLabelsCollector()
{
  //  printf("WeightLabelsCollector %p dying\n",this);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void WeightLabelsCollector::writeAsCommand(FILE *FHO,const String &tab)
{
  fprintf(FHO,"%sweightlabel definitions\n",tab());
  for(long i=0;i<pwls.size();i++){
    fprintf(FHO,"%s  weightlabels%ld\n",tab(),pwls[i]->uniqueIndex()+1);
    for(long l=0;l<pwls[i]->size();l++){
      fprintf(FHO,"%s    \"%s\"\n",tab(),pwls[i]->at(l)->label()());
    }
    fprintf(FHO,"%s  end weightlabels\n",tab());
  }
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
WeightLabels *WeightLabelsCollector::demandNewAuto()
//  create a new WeightLabels with a unique ID
{
  WeightLabels *wl=new WeightLabels(plastuniqueindex++);
  //printf("WeightLabelsCollector::demandNew wl=%p\n",wl);
  pwls.append(wl);
  return wl;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
WeightLabels *WeightLabelsCollector::demandNew(long definiteUniqueIndex)
// return a WeighLabels with the desired unique index
// this can be a new one or an existing one
{
  //  myDebug() <<"demandNew "<<pwls.size()<<definiteUniqueIndex;
  
  for(long i=0;i<pwls.size();i++){
    if(pwls[i]->uniqueIndex()==definiteUniqueIndex){
      // index is given
      {
	//myDebug() <<"haveallready "<<pwls[i];
	return pwls[i];
      }
    }
  }
    
  WeightLabels *wl=new WeightLabels(definiteUniqueIndex);
  plastuniqueindex=MyMath::max<long>(plastuniqueindex+1,definiteUniqueIndex+1);
  pwls.append(wl);
  return wl;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void WeightLabelsCollector::remove(WeightLabels *wl)
{
  //  printf("WeightLabelsCollector::remove %p this=%p\n",wl,this);
  if(!wl) return;
  if(wl->decreaseUsage())
    pwls.remove(wl);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void WeightLabelsCollector::collectGarbage()
{
  //myDebug() << "WeightLabelsCollector::collectGarbage";
  for(long i=pwls.size()-1;i>=0;i--){
    WeightLabels *wl=pwls[i];
    //myDebug() << "wl"<<i<<wl<<wl->uniqueIndex();
    if(!wl->inUse())
      pwls.remove(wl);
  }
}


/*EOF*/ 
