/*************************************************************************
 * @(#)Xfp.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   26 Apr 2011
 *************************************************************************
 */

#include "Xfp.hh"


const Xfp::tsTicSides Xfp::pticsides[]={
  {Xfp::TSNoSide,"None"}
  ,{Xfp::TSNormal,"Normal"}
  ,{Xfp::TSOpposite,"Opposite"}
  ,{Xfp::TSBoth,"Both"}
};

const long Xfp::pticmaxsides=sizeof(Xfp::pticsides)/sizeof(Xfp::tsTicSides);


const Xfp::tsShapeTypes Xfp::pshapetypes[]={
  {Xfp::SHTNone,"None"},
  {Xfp::SHTLine,"Line"},
  {Xfp::SHTEllipse,"Ellipse"}
};
const long Xfp::pmaxshapetypes=sizeof(Xfp::pshapetypes)
  /sizeof(Xfp::tsShapeTypes);

const Xfp::tsGraphAxisScalingTypes Xfp::pgraphaxisscalingtypes[]={
  {Xfp::GASLinear,"Linear"},
  {Xfp::GASLogarithmic,"Logarithmic"},
};
const long Xfp::pmaxgraphaxisscalingtypes=sizeof(Xfp::pgraphaxisscalingtypes)
  /sizeof(Xfp::tsGraphAxisScalingTypes);

const Xfp::tsArrowPositions Xfp::parrowpositions[]={
  {Xfp::ARPNone,"None"},
  {Xfp::ARPEnd,"End"},
  {Xfp::ARPStart,"Start"},
  {Xfp::ARPBoth,"Both"}
};
const long Xfp::pmaxarrowpositions=sizeof(Xfp::parrowpositions)
  /sizeof(Xfp::tsArrowPositions);


const Xfp::tsArrowStyles Xfp::parrowstyles[]={
  {Xfp::ARSTClosed,"Closed"},
  {Xfp::ARSTOpen,"Open"}
};
const long Xfp::pmaxarrowstyles=sizeof(Xfp::parrowstyles)
  /sizeof(Xfp::tsArrowStyles);

const Xfp::tsCoordinateSystem Xfp::pcoordsystems[]={
  {Xfp::CSYView,"View"},
  {Xfp::CSYWorld,"World"}
};
const long Xfp::pmaxcoordinatesystems=sizeof(Xfp::pcoordsystems)
  /sizeof(Xfp::tsCoordinateSystem);


const Xfp::tsLineStyles Xfp::plinestyles[]={
  {"None","none",{0}}
  ,{"Solid","solid",{0}}
  ,{"Dash","dash",{2,6,4}}
  ,{"Dot","dot",{2,1,3}}
  ,{"Dash Dot","dash dot",{4,6,4,1,4}}
  ,{"Dash Dot Dot","dash dot dot",{6,6,4,1,4,1,4}}
  ,{"Dot Dash Dash","dot dash dash",{6,1,4,6,4,6,4}}
  ,{"Long Dash","long dash",{2,12,4}}
  ,{"Long Dash Dot","long dash dot",{4,12,4,1,4}}
  ,{"Long Dash Dot Dot","long dash dot dot",{6,12,4,1,4,1,4}}
  ,{"Dot Long Dash Long Dash","dot long dash long dash",{6,1,4,12,4,12,4}}
  
};

const long Xfp::pmaxlinestyles=sizeof(Xfp::plinestyles)
  /sizeof(Xfp::tsLineStyles);


const Xfp::tsSymbols Xfp::psymbols[]={
  {"None","SymbolNone",1.,false}
  ,{"Circle","SymbolCircle",1.,true}
  ,{"Square","SymbolSquare",0.87,true}
  ,{"Diamond","SymbolDiamond",1.25,true}
  ,{"Triangle up","SymbolTriangleUp",1.,true}
  ,{"Triangle left","SymbolTriangleLeft",1.,true}
  ,{"Triangle down","SymbolTriangleDown",1.,true}
  ,{"Triangle right","SymbolTriangleRight",1.,true}
  ,{"Plus","SymbolPlus",1.,false}
  ,{"X","SymbolX",1.,false}
  ,{"*","SymbolStar",1.,false}
  ,{"Char","SymbolChar",1.,false}
};
const long Xfp::pmaxsymbols=sizeof(Xfp::psymbols)/sizeof(Xfp::tsSymbols)-1;


const QRgb  Xfp::prgbcolors[]={
  /* black */
  0x000000,
  /* red */
  0xcc0000,
  /* green */
  0x00b200,
  /* blue */
  0x0000ff,
  /* yellow */
  0xe5e500,
  /* magenta */
  0xff00ff,
  /* gray */
  0xb2b2b2,
  /* orange */
  0xFF8000,
  /* turquoise */
  0x00b2b2,
  /* brown */
  0xc05800,
  /* Indigo */
  0x6A00FF,
  /* Maron */
  0x5D2132, 
  /* Violet */
  0x800080,
 /* white */
  0xffffff
};

const long Xfp::prgbmaxcolors=sizeof(Xfp::prgbcolors)/sizeof(QRgb);




const char *Xfp::pstyles[]={
  "Dots","Connected","Individual"
};

const char *Xfp::weightsStylesGuiName(Xfp::WeightsStyle s){
  return pstyles[s];
}

const long Xfp::pmaxweightsstyles=sizeof(Xfp::pstyles)/sizeof(char*);

const double Xfp::pointsToInch=1./72.;
const double Xfp::inchToCM=2.54;

/*EOF*/ 
