/* @(#)Except.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _EXCEPTXX_H
#define _EXCEPTXX_H 1

#include "FString.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class Except
{
  //
 public:
  //
  //
  Except(String const &s="Error occured",String const &t="Error Report"
	 ,long st=1)
    :pmsg(s),ptitle(t),pstop(st){};
  const char *msg() const{return pmsg(); };
  const char *title() const{return ptitle(); };
  long stop() const{return pstop; };
 private:
  String pmsg;
  String ptitle;
  long pstop;
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class TerminateExcept
{
  // EXIT_EMERGENCY_ABORT 0 /* shell return value for emergencyabort */
  // EXIT_USER_ABORT      2 /* shell return value for CTRL-C user abort */
  // EXIT_NORMAL          1 /* shell return value for normal exit */
 public: 
  enum ExitStatus{ExitEmergencyAbort=0,ExitNormal=1,ExitUserAbort=2};

  TerminateExcept(String const &s="Error occured"
		  ,ExitStatus rv=ExitEmergencyAbort)
    :pmsg(s),retval(rv){};

  const char *msg() const{return pmsg(); };
  ExitStatus retVal() const{return retval; };

 private:
  String pmsg;
  ExitStatus retval;
 
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _EXCEPTXX_H */

