/*************************************************************************
 * @(#)StringPtr.cpp
 * author: magru@unas
 * date:   25 Nov 2013
 *************************************************************************
 */

#include "StringPtr.hh"


const char *StringPtrLexer::tokenNames[]={
  "None","String","KeyWord","Range","Integer","Double","Word",
  "Punctuation/Operator","Comment"
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void StringPtrLexer::nextTokenInternal(TokenValue &val,bool prot)
{
  if(prot) {
    if(&val==&pvalue)
      myDebug()<<"pvalue";
    else
      myDebug()<<"plookaheadvalue";
  }
  
  val.type=TNone;
  
  long wordlength=0;
  pstr->skipWhiteSpace();

  if(!pkeepcomments){
    while(pstr->commentAhead(wordlength)){
      pstr->forward(wordlength,true);
    }
  }


  if(pstr->commentAhead(wordlength)){
    val.sval.ncopy((*pstr)(),wordlength);
    val.type=TComment;
  }else if(pstr->quotedWordAhead(wordlength)){
    val.sval.ncopy((*pstr)()+1,wordlength-2);
    val.type=TString;
  }else if(pstr->keywordAhead(*pkeywords,ppunctuation,wordlength,val.sval)){
    val.type=TKeyWord;
    if(prot){
      myDebug()<<"type="<<val.type;
      myDebug()<<"val="<<val.sval;
    }
  }else if(pstr->rangeAhead(wordlength,ppunctuation,val.lvalue,val.rvalue)){
    val.type=TRange;
  }else if((val.type=pstr->numberAhead(wordlength,ppunctuation,val.dvalue,val.lvalue))){
  }else if (pstr->punctuationAhead(wordlength,ppunctuation)){
    val.sval.ncopy((*pstr)(),wordlength);
    val.type=TPunctuation;
  }else if(pstr->wordAhead(wordlength)){
    val.sval.ncopy((*pstr)(),wordlength);
    val.type=TWord;
  }
  val.linenr=pstr->lineNo();
  val.columnnr=pstr->columnNo();
  pstr->forward(wordlength,true);
  if(prot) myDebug()<<"ret type="<<val.type;
  return;
}



/*EOF*/ 
