/* @(#)ioparser.c
 */


#include <string.h>
#include "ioparser.h"
#include "merror.h"



/* ***********************************************************************
 * initialize parsre_control
 * ***********************************************************************
 */
long init_parser_control(PARSER_CONTROLL *pc,long padding,long aschar)
{
  long i;
  pc->padding=padding;
  pc->aschar=aschar;
  if(!init_vartable(&(pc->table),pc->aschar)){
    return 0;
  }
  pc->stopaftersection=0;
  pc->stopsectionname[0]='\0';
  for(i=0;i<MAX_EXTERN_DATA_TABLE_ENTRIES;i++)
    {
      pc->externdatatable[i].arrayname[0]='\0';
      pc->externdatatable[i].array=NULL;
    }
  
  return 1;
}



/* ***********************************************************************
 *
 * ***********************************************************************
 */

/* cleanup lex memory */
extern void lexcleanup(void); 

/* ***********************************************************************
 * clean up lexer at end of programm 
 * ***********************************************************************
 */

void finalcleanup(void)
{
  lexcleanup();
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */

long AddExternalArrayAddress(PARSER_CONTROLL *pc,const char *name
			     ,void *array)
{
  long i;
  for(i=0;i<MAX_EXTERN_DATA_TABLE_ENTRIES;i++){
    if(strcmp(pc->externdatatable[i].arrayname,name)==0){
      (void)sprintf(errorbuffer,"error(AddExternalArrayAddress): external array %s allready defined!",name);
      return 0;
    }
    if(pc->externdatatable[i].arrayname[0]=='\0'){
      (void)strcpy(pc->externdatatable[i].arrayname,name);
      pc->externdatatable[i].array=array;
      pc->aschar=0;
      if(!init_vartable(&(pc->table),pc->aschar)) return 0;
      

      return 1;
    }
  }
  (void)sprintf(errorbuffer,"error(AddExternalArrayAddress): To many external array addresses defined!");
  return 0;

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */

void *getExternalArrayAddress(PARSER_CONTROLL *pc,const char *name)
{
  long i;
  for(i=0;i<MAX_EXTERN_DATA_TABLE_ENTRIES;i++){
    if(strcmp(pc->externdatatable[i].arrayname,name)==0){
      return pc->externdatatable[i].array;
    }
  }
  return NULL;

}
