/* @(#)ioparser.h
 */

#ifndef _IOPARSER_H
#define _IOPARSER_H 1

#include <stdio.h>
#include "ioconfig.h"
#include "table.h"

#define MAX_EXTERN_DATA_TABLE_ENTRIES 100

typedef struct extern_data{
  void *array;
  char arrayname[MAX_ID_LENGTH+1];
}EXTERN_DATA;


typedef struct parser_controll{
  /* are the data stored as char or as internal representation 
     for fedit and normal input aschar=1 is nesseccary, 
     for direct scanning (large arrays) aschar=0 is nesseccary
   */
  long aschar;
  /* automatic padding of undefined array data is possible, but not recommended */
  long padding;
  /* THE data table */
  VARTABLE table;
  long stopaftersection;
  EXTERN_DATA externdatatable[MAX_EXTERN_DATA_TABLE_ENTRIES];
  char stopsectionname[MAX_ID_LENGTH+1];
  
}PARSER_CONTROLL;


/* for lex */
extern FILE *yyin;

#ifdef	__cplusplus
extern "C" {
#endif


  extern long yyparse (void *);
  extern long init_parser_control(PARSER_CONTROLL *pc,long padding,long aschar);
  extern void finalcleanup(void);
  extern long AddExternalArrayAddress(PARSER_CONTROLL *pc,const char *name
				      ,void *array);
  extern void *getExternalArrayAddress(PARSER_CONTROLL *pc,const char *name);
#ifdef	__cplusplus
}
#endif

#endif /* _IOPARSER_H */

