/* @(#)ioparserinternal.h
 */
#ifndef _IOPARSERINTERNAL_H
#define _IOPARSERINTERNAL_H 1


/* ***********************************************************************
 * to be included in io.y and io.lex only
 * ***********************************************************************
 */
#include "fortrantypes.h"

typedef union {
  FPLOINTEGER            i;
  FPLOLOGICAL            l;
  FPLODOUBLEPRECISION    d;
  char               c;
  const char        *s;
}CONSTANTVALUE;

typedef struct{
  long type;
  CONSTANTVALUE value;
}CONSTANTS;

typedef struct{
  long type;
  long strlength;
  long variable;
}TYPE;


typedef struct{
  long rank;
  long variable;
  long value[8];
  char *idref[8];
} DIMSPECS;



#define ASSIGNEMENT_SCALAR      1
#define ASSIGNEMENT_ARRAY       2
#define ASSIGNEMENT_STRUCT      7
#define ASSIGNEMENT_STRUCTARRAY 8


/* lex prototype */

#define YY_DECL long yylex (YYSTYPE *yylval                          \
			   ,long *lnr,long *cnr,long assignementtype\
			   ,long forceend                           \
			   ,long expectlogical)


#endif /* _IOPARSERINTERNAL_H */

 
