/* @(#)AntiAliasing.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ANTIALIASING_H
#define _ANTIALIASING_H 1

#include <QString>

class AntiAliasing
{
 public:


  AntiAliasing(const char *mode="graphics")
    :pantialiasing(true),pantialiasingprintonly(true),pwhilemoving(false)
    ,pjitter(4),tmode(mode){};


  void readSettings();
  void writeSettings();


  inline bool isOn()const{return pantialiasing && pjitter>1;};

  inline bool antiAliasing()const{return pantialiasing;};
  inline void setAntiAliasing(bool a){pantialiasing=a;};

  inline bool whileMoving()const{return pwhilemoving;};
  inline void setWhileMoving(bool w){pwhilemoving=w;};

  inline bool forPrintingOnly()const{return pantialiasingprintonly;};
  inline void setAntiAliasingForPrintOnly(bool po){pantialiasingprintonly=po;};

  inline int jitter()const {return pjitter;};
  inline void setJitter(int j){pjitter=j;};

 private:
  bool pantialiasing;
  bool pantialiasingprintonly;
  bool pwhilemoving;
  int pjitter;
  QString tmode;
};


extern AntiAliasing antiAliasing;

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _ANTIALIASING_H */

