/* @(#)Xf.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _XF_H
#define _XF_H 1

#include "strtype.h"
#include "Pair.hh"

class Xf
{
 public:
  
  enum LatticeType{ LTDirect=1,LTReciprocial=2 };

  enum RelativisticMode{ NonRelativistic=1,ScalarRelativistic=2,
			 FullRelativistic=3,ScalarRelativisticKH=4 };
  
  enum LengthUnits{Unknown=0,BohrRadius=1,Angstroem=2};
  
  enum StructureType{STCrystal=STRTYPE_CRYSTAL,STMolecule=STRTYPE_MOLECULE};
  
  enum AxesType {ATCartesian=0,ATConventional=1,ATPrimitive=2,ATGeneral=3};
  
  enum DisplayCellType {DCTMainBoundary=1,DCTConventional=2
			,DCTPrimitive=3,DCTGeneral=4};
  
  enum SceeneUnits{SUBoundary=0,SUWorld=1,SUAngstroem=2,SUBohrRadius=3
		   ,SURodRadius=4,SUTipRadius=5
		   ,SUConvCell=6,SUPrimCell=7 };

  enum SpecialPointType{SPTPoint=0,SPTJump=1,SPTBreak=2};
  
  enum FindAtomModes{FindSite=0,FindSort=1,FindType=2,FindElement=3
		     
		     ,FindClusterNumber=4};
  
  static const char *axesTypeName(AxesType u)
    {return paxestypenames[u];};
  static const char *axesName(AxesType u,long i)
    {return paxesnames[u][i];};
  static const char *sceeneUnitName(SceeneUnits u)
    {return psceeneunitnames[u];};
  static const char *displayCellTypeName(DisplayCellType t)
    {return pdisplaycelltypename[t];};
  static const char *specialPointTypeName(SpecialPointType t)
    {return pspecialpointtypename[t];};
  static const char *lengthUnitName(Xf::LengthUnits l) 
    {return plengthunits[l];};

  typedef Pair<int,const char*> PairIntCharP ;

 private:
  static const char *paxestypenames[];
  static const char *paxesnames[][3];
  static const char *psceeneunitnames[];
  static const char *pdisplaycelltypename[];
  static const char *pspecialpointtypename[];
  static const char *plengthunits[];
  
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _XF_H */

