/*************************************************************************
 * @(#)XfploHelp.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   10 Mar 2011
 *************************************************************************
 */

#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "Assorted.hh"
#include "Except.hh"
#include "XfploHelp.hh"
#include "Config.hh"
#include "MyDebug.hh"
#ifdef QXFPL 
#include "xfbphelp_qch.h"
#include "xfbphelp_qhc.h"
#endif
#ifdef QXFSF 
#include "xfplohelp_qch.h"
#include "xfplohelp_qhc.h"
#endif

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void XfploHelp::createHelpFiles()
{
  
  String dir=String(IDS_APP_INI_PATH);
  FileExistence ret=pathExistence(dir);
  if(ret==DoesNotExist){
    if(mkdir(dir(),0755)){
      printf("Cannot create directory \"%s\"!\n",dir());
      exit(1);
    }
  }



  dir=String(IDS_APP_HELP_PATH);
  ret=pathExistence(dir);
  if(ret==DoesNotExist){
    if(mkdir(dir(),0755)){
      printf("Cannot create directory \"%s\"!\n",dir());
      exit(1);
    }
  }

  String filebase=IDS_APP_HELP_PATH+"/"+IDS_APP_HELP_FILE;
  
  String file=filebase+".qch";
  ret=pathExistence(file);
  if( ret==DoesNotExist  ){
  }else if( ret!=RegularFile  ){
    printf("Failed to install help file \"%s\"!\n"
	   "Seems to exist but not being a file!\n"
	   ,file());
    exit(1);
    
  }
  
  try{
    FILE *FH=openforwrite(file);
    int n=sizeof(xfplohelp_qch)/sizeof(char);
    for(int i=0;i<n;i++){
      fprintf(FH,"%c",xfplohelp_qch[i]);
    }
    fclose(FH);
  }catch(Except &ex){ 
    printf("Failed to install help file \"%s\"!\n%s\n"
	   ,file(),ex.msg());
    exit(1);
  }

  file=filebase+".qhc";
  ret=pathExistence(file);
  if( ret==DoesNotExist  ){
  }else if( ret!=RegularFile  ){
    printf("Failed to install help file \"%s\"!\n"
	   "Seems to exist but not being a file!\n"
	   ,file());
    exit(1);
    
  }
  
  try{
    FILE *FH=openforwrite(file);
    int n=sizeof(xfplohelp_qhc)/sizeof(char);
    for(int i=0;i<n;i++){
      fprintf(FH,"%c",xfplohelp_qhc[i]);
    }
    fclose(FH);
  }catch(Except &ex){ 
    printf("Failed to install help file \"%s\"!\n%s\n"
	   ,file(),ex.msg());
    exit(1);
  }

  
  

  
}


/*EOF*/ 
