/* @(#)SearchWidget.hh
 * author: magru@unas
 */

#ifndef _SEARCHWIDGET2_HH
#define _SEARCHWIDGET2_HH 1

#include "ui_SearchWidget.h"

class QTextCursor;


/* ***********************************************************************
 *
 * ***********************************************************************
 */


class SearchWidget: public QWidget,protected Ui::SearchWidget
{
  Q_OBJECT;
public:
  // ----------------------------------------------------------------
  SearchWidget(QWidget *parent);
  ~SearchWidget();
  
  // ----------------------------------------------------------------
  void setTextWidget(QWidget *tw);
				 
				 
public slots:
  // ----------------------------------------------------------------
  void startSearch();
		    
		    
private slots:
  void on_tbNext_clicked(){onSearchNext();}
  void on_tbPrev_clicked(){onSearchNext(true);}
  void on_tbClose_clicked(){stopSearching();}
  void on_cmbSearch_editTextChanged();
  
  
private:
  
  void stopSearching();
  void onSearchSucces(bool s);
  QTextCursor textCursor()const;
  void setTextCursor(QTextCursor &cur);
  bool find(const QString &content,bool back=false);
  void onSearchNext(bool back=false);
  bool eventFilter(QObject *obj, QEvent *event);
  void registerSearchString(const QString &);

private:
  // ----------------------------------------------------------------
  QPalette pnormalpalette;
  QPalette palertpalette;


  QString psearchstring,poldsearchstring;
  bool pinsearch;
  bool phadsearchhit;
  bool pnewstring;
  int pwraparound;
  QTextCursor *psearchcursor;
  Qt::Key pshortcut;
  Qt::KeyboardModifier pshortcutmod;
  QWidget *ptextwidget;
  bool pmute;
};


#endif /* _SEARCHWIDGET2_HH */

