/* @(#)ReselectEvent.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _RESELECTEVENT_H
#define _RESELECTEVENT_H 1

#include  <QEvent>
#include  <QString>
#include  <QModelIndex>

class QTreeWidgetItem;

class ReselectEvent: public QEvent
{
 public:
  ReselectEvent(Type type,QTreeWidgetItem *item)
    : QEvent(type),pitem(item){};
  ReselectEvent(Type type,const QModelIndex &index)
    : QEvent(type),pindex(index){};

  QTreeWidgetItem *item(){return pitem;};
  const QModelIndex &index(){return pindex;};

  static QEvent::Type ReselectEventType;


 private:
    QTreeWidgetItem *pitem;
    QModelIndex pindex;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _RESELECTEVENT_H */

