/* A Bison parser, made by GNU Bison 2.7.12-4996.  */

/* Skeleton interface for Bison LALR(1) parsers in C++
   
      Copyright (C) 2002-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/**
 ** \file ParamParser.tab.hh
 ** Define the PP::parser class.
 */

/* C++ LALR(1) parser skeleton written by Akim Demaille.  */

#ifndef YY_YY_PARAMPARSER_TAB_HH_INCLUDED
# define YY_YY_PARAMPARSER_TAB_HH_INCLUDED

/* "%code requires" blocks.  */
/* Line 33 of lalr1.cc  */
#line 8 "ParamParser.yy"

# include <stdio.h>
# include <string>
# include <math.h>
# include "MyDebug.hh"
# include "Xfp.hh"
# include "Graph.hh"
# include "Graphs.hh"
# include "Page.hh"
# include "TextBox.hh"
# include "Attributes.hh"
# include "GraphObject.hh"
# include "GraphAxis.hh"
# include "FGObject.hh"
# include "Except.hh"
# include "ParserFunctions.hh"
# include "TempSetDescriptor.hh"
# include "Function.hh"
# include "Functions.hh"
# include "FunctionGroup.hh"
# include "FunctionGroups.hh"
# include "Point.hh"
# include "Position.hh"
# include "ParameterList.hh"
# include "World.hh"
# include "LineShape.hh"
# include "EllipseShape.hh"
# include "WeightLabels.hh"
# include "WeightSelection.hh"
# include "LegendBox.hh"
# include "TicMarks.hh"
# include "ViewBox.hh"
  class ParamDriver;

#define SERR paramDriver.setLocation(yyloc);if(s.length()) error(yyloc,s());
#define   PROTECT_AGAINST_VECTORS(x) if(x->type() != TempSetDescriptor::Value) \
    error(yyloc,"expression needs to be scalar");
  ;
#define   PROTECT_AGAINST_SCALARS(x) if(x->type() != TempSetDescriptor::Vector) \
    error(yyloc,"expression needs to be a vector");			\
  ;
#define   PROTECT_AGAINST_WEIGHTS(x)				\
  if(!paramDriver.context("notweight") &&			\
     paramDriver.currentSetDescriptor()->weightid>=0)		\
    error(yyloc,Sprintf("%s not allowed for weights",x)());
  ;
  


/* Line 33 of lalr1.cc  */
#line 97 "ParamParser.tab.hh"


#include <string>
#include <iostream>
#include "stack.hh"
#include "location.hh"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Line 33 of lalr1.cc  */
#line 4 "ParamParser.yy"
namespace PP {
/* Line 33 of lalr1.cc  */
#line 114 "ParamParser.tab.hh"

  /// A Bison parser.
  class ParamParser
  {
  public:
    /// Symbol semantic values.
#ifndef YYSTYPE
    union semantic_type
    {
/* Line 33 of lalr1.cc  */
#line 78 "ParamParser.yy"

  bool         bval;
  long         ival;
  unsigned int uival;
  double       dval;
  Function::DataType dtval;
  Xfp::FileType ftval;
  Xfp::SymbolTypes sstval;
  Xfp::XYAxisType xyval;
  Xfp::TicSide sideval;
  Xfp::GraphAxisScaling gasid;
  Xfp::WeightsStyle wsval;
  Xfp::TicKind majminval;
  Xfp::LineStyles lstval;
  Xfp::ArrowPosition ahpval;
  Xfp::ArrowStyle astval;
  Xfp::CoordinateSystem csyval;
  Position::OffsetType offtypeval;
  Paper::Size psval;
  Paper::Orientation poval;
  String *strval;
  class TempSetDescriptor *tempsetval;
  const struct ParserFunctions::tsfuncdef *fptrval;
  ValueArray<long> *larray;
  ValueArray<double> *darray;
  ValueArray<String> *sarray;


/* Line 33 of lalr1.cc  */
#line 155 "ParamParser.tab.hh"
    };
#else
    typedef YYSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef location location_type;
    /// Tokens.
    struct token
    {
      /* Tokens.  */
   enum yytokentype {
     ENDOFFILE = 0,
     EOL = 258,
     COMMENTLINE = 259,
     ADDITIONAL = 260,
     APPEND = 261,
     ANGLE = 262,
     ARROW = 263,
     ASSIGN = 264,
     ATTRIBUTES = 265,
     AUTO = 266,
     AUTOSCALE = 267,
     AXIS = 268,
     BORDER = 269,
     BSPLINE = 270,
     CAP = 271,
     CENTER = 272,
     CURSOR = 273,
     COLOR = 274,
     CONVOLUTE = 275,
     COPY = 276,
     CUTOFF = 277,
     DATA = 278,
     DECIMALS = 279,
     EECHO = 280,
     END = 281,
     ENDDATA = 282,
     ENDWEIGHTLABELS = 283,
     ENDXDATA = 284,
     ENDYDATA = 285,
     ENDZDATA = 286,
     EXTRA = 287,
     FACTOR = 288,
     FILE = 289,
     FILENAME = 290,
     FILL = 291,
     FONT = 292,
     FRAME = 293,
     GRAPH = 294,
     HACKSHIFT = 295,
     HOOK = 296,
     INTEGRATE = 297,
     INTO = 298,
     INTERPOLATIONDEPTH = 299,
     IRREGULAR = 300,
     KILLALL = 301,
     KILL = 302,
     LABELS = 303,
     LEFT = 304,
     LEGEND = 305,
     LENGTH = 306,
     LINE = 307,
     MARKER = 308,
     MAX = 309,
     MIN = 310,
     MESH = 311,
     MOMENT = 312,
     MOUSECLICK = 313,
     MOVE = 314,
     NAME = 315,
     NEW = 316,
     NONE = 317,
     ORIGIN = 318,
     ORIENTATION = 319,
     OFFSET = 320,
     PAPER = 321,
     POINT = 322,
     PLOTORDER = 323,
     POSITION = 324,
     PRINT = 325,
     RADII = 326,
     RADIUS = 327,
     RESTRICTION = 328,
     READ = 329,
     RIM = 330,
     SCALE = 331,
     SCALING = 332,
     SEPARATE = 333,
     SETCOMMENT = 334,
     SECONDDERIVATIVE = 335,
     SHARPNESS = 336,
     SIDE = 337,
     SIZE = 338,
     SHOWIN = 339,
     SKIP = 340,
     SPACING = 341,
     START = 342,
     STYLE = 343,
     SUBSCRIPTSCALE = 344,
     SUBDIV = 345,
     SYMBOL = 346,
     COORDINATESYSTEM = 347,
     TICS = 348,
     TOGGLE = 349,
     TO = 350,
     TYPE = 351,
     USE = 352,
     VIEW = 353,
     VERSION = 354,
     WEIGHT = 355,
     WEIGHTLABELDEFS = 356,
     WITH = 357,
     WIDTH = 358,
     WORLD = 359,
     X = 360,
     XDATA = 361,
     XMAX = 362,
     XMIN = 363,
     DXMIN = 364,
     DXMAX = 365,
     DYMIN = 366,
     DYMAX = 367,
     Y = 368,
     YDATA = 369,
     YMAX = 370,
     YMIN = 371,
     ZDATA = 372,
     RESTRICTIONTYPE = 373,
     IDENTIFIER = 374,
     STRING = 375,
     PARAMETER = 376,
     FILETYPE = 377,
     ONOFF = 378,
     INT = 379,
     HEXCONSTANT = 380,
     REAL = 381,
     GRAPHAXISSCALINGID = 382,
     GRAPHID = 383,
     GROUPID = 384,
     SETID = 385,
     WEIGHTID = 386,
     TEXTBOX = 387,
     LINEN = 388,
     ELLIPSEN = 389,
     ITICID = 390,
     WEIGHTLABELREFERENCE = 391,
     XXYY = 392,
     SYMBOLTYPE = 393,
     SIDEID = 394,
     MAJOR = 395,
     MINOR = 396,
     WEIGHTSSTYLE = 397,
     LINESTYLE = 398,
     ARROWPOSTYPE = 399,
     ARROWSTYLE = 400,
     COORDYSTEM = 401,
     PAPERSIZES = 402,
     ORIENTATIONS = 403,
     WEIGHTSID = 404,
     WEIGHTLABELSID = 405,
     FUNCTION = 406,
     DATATYPE = 407,
     TAGLESS = 422
   };

    };
    /// Token type.
    typedef token::yytokentype token_type;

    /// Build a parser object.
    ParamParser (ParamDriver& paramDriver_yyarg, void *scanner_yyarg);
    virtual ~ParamParser ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

  private:
    /// This class is not copyable.
    ParamParser (const ParamParser&);
    ParamParser& operator= (const ParamParser&);

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

    /// Generate an error message.
    /// \param state   the state where the error occurred.
    /// \param tok     the lookahead token.
    virtual std::string yysyntax_error_ (int yystate, int tok);

#if YYDEBUG
    /// \brief Report a symbol value on the debug stream.
    /// \param yytype       The token type.
    /// \param yyvaluep     Its semantic value.
    /// \param yylocationp  Its location.
    virtual void yy_symbol_value_print_ (int yytype,
					 const semantic_type* yyvaluep,
					 const location_type* yylocationp);
    /// \brief Report a symbol on the debug stream.
    /// \param yytype       The token type.
    /// \param yyvaluep     Its semantic value.
    /// \param yylocationp  Its location.
    virtual void yy_symbol_print_ (int yytype,
				   const semantic_type* yyvaluep,
				   const location_type* yylocationp);
#endif


    /// State numbers.
    typedef int state_type;
    /// State stack type.
    typedef stack<state_type>    state_stack_type;
    /// Semantic value stack type.
    typedef stack<semantic_type> semantic_stack_type;
    /// location stack type.
    typedef stack<location_type> location_stack_type;

    /// The state stack.
    state_stack_type yystate_stack_;
    /// The semantic value stack.
    semantic_stack_type yysemantic_stack_;
    /// The location stack.
    location_stack_type yylocation_stack_;

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue);

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue);

    /// Internal symbol numbers.
    typedef unsigned char token_number_type;
    /* Tables.  */
    /// For a state, the index in \a yytable_ of its portion.
    static const short int yypact_[];
    static const short int yypact_ninf_;

    /// For a state, default reduction number.
    /// Unless\a  yytable_ specifies something else to do.
    /// Zero means the default is an error.
    static const unsigned short int yydefact_[];

    static const short int yypgoto_[];
    static const short int yydefgoto_[];

    /// What to do in a state.
    /// \a yytable_[yypact_[s]]: what to do in state \a s.
    /// - if positive, shift that token.
    /// - if negative, reduce the rule which number is the opposite.
    /// - if zero, do what YYDEFACT says.
    static const unsigned short int yytable_[];
    static const signed char yytable_ninf_;

    static const short int yycheck_[];

    /// For a state, its accessing symbol.
    static const unsigned short int yystos_[];

    /// For a rule, its LHS.
    static const unsigned short int yyr1_[];
    /// For a rule, its RHS length.
    static const unsigned char yyr2_[]; 

    /// Convert the symbol name \a n to a form suitable for a diagnostic.
    static std::string yytnamerr_ (const char *n);


    /// For a symbol, its name in clear.
    static const char* const yytname_[];
#if YYDEBUG
    /// A type to store symbol numbers and -1.
    typedef short int rhs_number_type;
    /// A `-1'-separated list of the rules' RHS.
    static const rhs_number_type yyrhs_[];
    /// For each rule, the index of the first RHS symbol in \a yyrhs_.
    static const unsigned short int yyprhs_[];
    /// For each rule, its source line number.
    static const unsigned short int yyrline_[];
    /// For each scanner token number, its symbol number.
    static const unsigned short int yytoken_number_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r);
    /// Print the state stack on the debug stream.
    virtual void yystack_print_ ();

    /* Debugging.  */
    int yydebug_;
    std::ostream* yycdebug_;
#endif

    /// Convert a scanner token number \a t to a symbol number.
    token_number_type yytranslate_ (int t);

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg        Why this token is reclaimed.
    ///                     If null, do not display the symbol, just free it.
    /// \param yytype       The symbol type.
    /// \param yyvaluep     Its semantic value.
    /// \param yylocationp  Its location.
    inline void yydestruct_ (const char* yymsg,
			     int yytype,
			     semantic_type* yyvaluep,
			     location_type* yylocationp);

    /// Pop \a n symbols the three stacks.
    inline void yypop_ (unsigned int n = 1);

    /* Constants.  */
    static const int yyeof_;
    /* LAST_ -- Last index in TABLE_.  */
    static const int yylast_;
    static const int yynnts_;
    static const int yyempty_;
    static const int yyfinal_;
    static const int yyterror_;
    static const int yyerrcode_;
    static const int yyntokens_;
    static const unsigned int yyuser_token_number_max_;
    static const token_number_type yyundef_token_;

    /* User arguments.  */
    ParamDriver& paramDriver;
    void *scanner;
  };
/* Line 33 of lalr1.cc  */
#line 4 "ParamParser.yy"
} // PP
/* Line 33 of lalr1.cc  */
#line 502 "ParamParser.tab.hh"



#endif /* !YY_YY_PARAMPARSER_TAB_HH_INCLUDED  */
