/* @(#)ParserFunctions.hh
 * author: magru@unas
 */

#ifndef _PARSERFUNCTIONS_HH
#define _PARSERFUNCTIONS_HH 1

#include <math.h>

/* ***********************************************************************
 *
 * ***********************************************************************
 */

class ParserFunctions
{
public:
  enum Names{Sqrt=0,Cos=1,Sin=2,Tan=3,Cot=4,Acos=5,Asin=6,Atan=7,
	     Abs=8,Exp=9,Log=10,
	     Atan2=11,Min=12,Max=13,Sign=14,Theta=15,Log10=16,Add=17,
	     Sub=18,Div=19,Mul=20,Pow=21};

  typedef double(*tfFUNC_DeqD)(double) ;
  typedef double(*tfFUNC_DeqD_D)(double,double) ;

  struct tsfuncdef{
    long type;
    Names name;
    const char *guiName;
    tfFUNC_DeqD fp1;
    tfFUNC_DeqD_D fp2;
  };


  static const struct tsfuncdef funcs[];
  static const int MAXFUNS;
  
  inline static  double cot(double a){return 1./tan(a);}
  inline static  double dmax2(double a, double b){return (a>b?a:b);}
  inline static  double dmin2(double a, double b){return (a<b?a:b);}
  inline static  double sign2(double a, double b){return (fabs(a)*(b>=0. ? 1.:-1.) );}
  inline static  double add(double a, double b){return a+b;}
  inline static  double sub(double a, double b){return a-b;}
  inline static  double div(double a, double b){return a/b;}
  inline static  double mul(double a, double b){return a*b;}
  inline static  double pow(double a, double b){return ::pow(a,b);}
  inline static  double theta(double a){return ((a>=0. ? 1.:0.));}
  
};

#endif /* _PARSERFUNCTIONS_HH */

