/* @(#)SetDescriptor.hh
 * author: magru@unas
 */

#ifndef _SETDESCRIPTOR_HH
#define _SETDESCRIPTOR_HH 1

#include "Xfp.hh"
#include "Graph.hh"
#include "MyDebug.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */


class SetDescriptor{
public:
  SetDescriptor()
    :graphid(Graph::UnknownGraph),
     groupid(-1),
     setid(-1),
     weightid(-1),
     xy(Xfp::Graph_X)
  {};
  
  void resetGroup(){
    groupid=-1;
    setid=-1;
    weightid=-1;
    xy=Xfp::Graph_X;
  };
  void resetSet(){
    setid=-1;
    weightid=-1;
    xy=Xfp::Graph_X;
  };
  void resetWeights(){
    weightid=-1;
    xy=Xfp::Graph_X;
  };
  bool isSet()const{return (weightid<0 && setid>=0);};
public:
  long graphid;
  long groupid;
  long setid;
  long weightid;
  Xfp::XYAxisType xy;
};

MyDebug operator<<(MyDebug dbg,const SetDescriptor &v);

#endif /* _SETDESCRIPTOR_HH */

