/* @(#)DlgReg.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _DLGREG_H
#define _DLGREG_H 1

#include <QObject>
#include <QMap>

class ApplyDlg;

class DlgReg{
 private:
  class DlgRegData{
  public:
    DlgRegData(const QString &s)
      :pname(s),pchanged(false),papply(false){};
    ~DlgRegData(){};
    QString pname;
    bool pchanged;
    bool papply;

    friend class ApplyData;
  };
 public:
  DlgReg();
  ~DlgReg();
  void Register(QObject *p,const QString &name);
  bool toBeApplied(QObject *p)const{
    if(pdata.contains(p))
      return pdata[p]->papply;
    else
      return false;
  };
  void setChanged(QObject *p,bool c)const{
    if(pdata.contains(p))
      pdata[p]->pchanged=c;};
  bool nonChanged()const{
    foreach(DlgRegData *dd,pdata.values()){
      if(dd->pchanged) return false;
    }
    return true;
  }
  void setApplyAll(bool c)const{
    foreach(DlgRegData *dd,pdata.values()){
      dd->papply=c;
    }
  };
  void reset();
  void print();
 private:
  QMap<QObject *,DlgRegData *> pdata;

  friend class ApplyDlg;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _DLGREG_H */

