/*************************************************************************
 * @(#)FileActions.cpp
 * author: magru@unas
 * date:   06 Feb 2013
 *************************************************************************
 */

#include <QFileDialog>
#include "FileActions.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
FileActions::FileActions(QWidget *parent,const QString &def)
  :QObject(0),pparent(parent)
{
  setFileName(def,false);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
QString FileActions::load(const QString &title,const QString &dir,
				 const QString &filter)
{
  QString ret="";

  QFileDialog *dlg=new QFileDialog(pparent,title,dir,filter);
  dlg->setAcceptMode(QFileDialog::AcceptOpen);
  dlg->setFileMode(QFileDialog::ExistingFile);
#ifdef Q_OS_MAC
  dlg->setOptions(QFileDialog::DontUseNativeDialog);
#endif
  dlg->setDirectory(QDir::currentPath()+"/");
  
  dlg->selectFile(pfilename);
  if((dlg->exec())==QDialog::Accepted){
    setFileName(dlg->selectedFiles().at(0),true);
    ret=pfilename;
  }
  delete (dlg);
  
  return ret;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */

QString FileActions::save(const QString &title,const QString &dir,
			  const QString &filter,bool saveas)
{
  QString ret="";
  
  
  if(!pknowfname || pfilename.isEmpty() || saveas){
    
    QFileDialog *dlg=new QFileDialog(pparent,title,dir,filter);
    
    dlg->setAcceptMode(QFileDialog::AcceptSave);
    dlg->setFileMode(QFileDialog::AnyFile);
#ifdef Q_OS_MAC
    dlg->setOptions(QFileDialog::DontUseNativeDialog);
#endif
    dlg->setDirectory(QDir::currentPath()+"/");
    
    
    //if(pknowfname && !pfilename.isEmpty()){
    dlg->selectFile(pfilename);
    //}else{
    //dlg->selectFile("commands.cmd");
    //}  
    
    if((dlg->exec())==QDialog::Accepted){
      if(dlg->selectedFiles().size()>0){
	setFileName(dlg->selectedFiles().at(0),true);
	ret=pfilename;
      }
    }
    delete (dlg);
  }else{
    ret=pfilename;
  }

  //pknowfname=(!ret.isEmpty());

  return ret;
  
  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void FileActions::setFileName(const QString &f,bool known)
{
  pknowfname=known;
  pfilename=f;
  if(!pfilename.isEmpty())
    pfilebasename=QFileInfo(pfilename).fileName();
  else
    pfilebasename="";
}



/*EOF*/ 
