/* @(#)GraphToolBox.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _GRAPHTOOLBOX_H
#define _GRAPHTOOLBOX_H 1

#include <QDockWidget>
#include "ui_GraphToolBox.h"


class Graph;
class GraphView;

class GraphToolBox : public QDockWidget, private Ui::GraphToolBox
{
  Q_OBJECT
 public:
  GraphToolBox(QWidget *parent);
  ~GraphToolBox();

  void setGraphView(GraphView *gv);

 signals:
  void worldChanged();  

 public slots:
  void onReloadWorldStack();
  void on_cmbWorldStack_activated(int current);

 private slots:
  void saveWorld();
  void clearWorldStack();
  void setMessageText(const QString& s);

 private:

  GraphView *p_gv;
  bool mutecmbWorldStack;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _GRAPHTOOLBOX_H */

