/* @(#)MainWindow.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _MAINWINDOW_H
#define _MAINWINDOW_H 1

#include <QMainWindow> 
#include <QPointer> 
#include  "ObserveView.hh"
#include  "Xfp.hh"

class QToolBar;
class QMenu;

class QGridLayout;
class QEvent;
class GraphView;
class ObserveView;
class GraphToolBox;
class XFPStatusBar;
class PageSetupDlg;


class MainWindow:public QMainWindow
{
  Q_OBJECT
 public:
  MainWindow(QWidget *parent=0,Qt::WindowFlags fl=0);
  ~MainWindow();

  XFPStatusBar *statusBar(){return pstatusbar;};
  
 private slots:
  void fileNew();
  void fileOpen();
  void fileSave();
  void fileSaveAs();
  void filePrint();
  void fileQuit();
  void help();
  void about();
  void plotMode();
  void pageSetup();
  void onPageSetupDlgAccept();

  void manageForeignPopups(const QString&, QMenu*);
  void onBusyGraphView(bool);

  protected slots:
  bool event(QEvent *event);

 private:
  void specialize(ObserveView::Mode what);
  void onCmdArguments();
  Xfp::FileType guessFileType(const QString &filename);


 private:
  GraphView *p_gv;
  ObserveView *pov;
  // central layout
  QWidget *centralwidget;
  //
  GraphToolBox *graphtoolbox;
  QMenu *helpmenu;
  QMenu *datamenu;
  QMenu *editmenu;
  QMenu *modemenu;
  QMenu *filemenu;
  QToolBar *fileToolBar;
  QAction *fileQuitAction;
 XFPStatusBar *pstatusbar;
  QPointer<PageSetupDlg> pageSetupDlg;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _MAINWINDOW_H */

