/* @(#)MenuData.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _MENUDATA_H
#define _MENUDATA_H 1

class GraphObject;

class MenuData{
public:
  enum MenuId{
    // sublevels
    LegendBox    =0x1,
    Title        =0x2,
    SubTitle     =0x3,
    XAxisLabel   =0x4,
    YAxisLabel   =0x5,
    OppXAxisLabel=0x6,
    OppYAxisLabel=0x7,
    TextBox      =0x8,
    ViewBox      =0x9,
    World        =0xa,
    Sets         =0xb,
    SaveAs       =0xe,
    Save         =0xf,
    Open         =0x10,
    TicMarks     =0x11,
    Transform    =0x12,
    Graph        =0x13,
    Shape        =0x14,
    FunctionOrGroup =0x15,
    Axes         =0x16,
    // subsublevels
    Prop         =0x1,
    Move         =0x2,
    ZoomXY       =0x3,
    ZoomX        =0x4,
    ZoomY        =0x5,
    Appearance   =0x6,
    Delete       =0x7,
    New          =0x8,
    AutoScaleX   =0x9,
    AutoScaleY   =0xa,
    AutoScaleXY  =0xb,
    Hide         =0xc,
    Copy         =0xd
  };
  MenuData():pid(0),pgo(0){};
  MenuData(unsigned long id,unsigned long sublevel,unsigned long subsublevel)
    :pid(id)
    ,psublevel(sublevel)
    ,psubsublevel(subsublevel)
    ,pgo(0){};
  MenuData(GraphObject *go
	   ,unsigned long id,unsigned long sublevel,unsigned long subsublevel)
    :pid(id)
    ,psublevel(sublevel)
    ,psubsublevel(subsublevel)
    ,pgo(go){};
  
  GraphObject *graphObject()const{return pgo;};
  unsigned long id()const{return pid;};
  unsigned long subLevel()const{return psublevel;};
  unsigned long subSubLevel()const{return psubsublevel;};
  
private:
  unsigned long pid;
  unsigned long psublevel;
  unsigned long psubsublevel;
  GraphObject *pgo;
};



#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _MENUDATA_H */

