/*************************************************************************
 * @(#)ParameterDocument.cpp
 * author: magru@unas
 * date:   06 Feb 2013
 *************************************************************************
 */

#include <QMessageBox>
#include "ParameterDocument.hh"
#include "Assorted.hh"
#include "Except.hh"
#include "Config.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ParameterDocument::loadDocument(const QString &pfilename)
{
  pstartupparamfilename=pfilename;

  if(!(pstartupparamfilename.isNull() || pstartupparamfilename.isEmpty() || 
       pstartupparamfilename=="-")){
      

    FILE *FI;
    try{
      FI=openforread(pstartupparamfilename);
    }catch(Except ex) {
      QMessageBox::warning(pparent,IDS_APP_NAME
			   ,QString("Cannot open %1 for read!")
			   .arg(pstartupparamfilename)
			   ,QMessageBox::Ok|QMessageBox::Default
			   );
      return;
    }

    pdocument->clear();
    QString text;
    String line;
    while (getLine(FI,line)){
      text=text+line();
    }
    fclose(FI);
    pdocument->setPlainText(text);
    pdocument->setModified(false);
      
  }

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ParameterDocument::saveDocument(const QString &pfilename)
{
  pstartupparamfilename=pfilename;

  FILE *FO;
  try{
    FO=openforwrite(pstartupparamfilename);
  }catch(Except ex) {
    QMessageBox::warning(pparent,IDS_APP_NAME
			 ,QString("Cannot open %1 for write!")
			 .arg(pstartupparamfilename)
			 ,QMessageBox::Ok|QMessageBox::Default
			 );
    return;
  }
  
  
  fprintf(FO,"%s",pdocument->toPlainText()
	  .toAscii().constData());
  fclose(FO);
  pdocument->setModified(false);

}


/*EOF*/ 
