/* @(#)XFPStatusBar.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _XFPSTATUSBAR_H
#define _XFPSTATUSBAR_H 1

#include <QStatusBar>
#include <QString>
#include "FString.hh"

class QLabel;
class QTimer;
class String;
class Point;
class Graph;
class QProgressBar;
class QToolButton;
class ButtonStatusWidget;

class XFPStatusBar:public QStatusBar{
  Q_OBJECT
 public:
  XFPStatusBar(QWidget *parent);
  ~XFPStatusBar();

  void setDocument(const QString &name);
  void setMessage(const QString &msg,int msec=0);
  void setMessage(){setMessage(QString(""));};
  void deleteMessage(){labelTimer();};
  void setCurrentCoordinates(const Point &);
  void setCurrentGraph(Graph *gr);
  void setHint(const QString &what,const QString &s);

public slots:
  void setProgress(double percent);
  void setProgressInt(int p){setProgress(p/100.);}
  void setMessage(const String &msg,int msec=0)
  {
    setMessage(QString(msg()),msec);
  }


signals:
  void interruptRequest();

private slots:
  void beware(const QString &);
  void labelTimer();

 private:
  QLabel *indicator;
  QLabel *grindicator;
  ButtonStatusWidget *bsw;
  QLabel *msglabel;
  QTimer *labeltimer;
  QProgressBar *progbar;
  QToolButton *tbInterupt;
  QString pdocumentname;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _XFPSTATUSBAR_H */

