TEMPLATE = app
LANGUAGE = C++
QMAKE_CXXFLAGS += -Wno-deprecated   -DQXFSF   
QMAKE_CFLAGS +=    
QT += opengl
CONFIG += qt \
    help \
    warn_off \
    release
LIBS +=-lGLU
INCLUDEPATH += src  src/lib/TOOLS src/lib/BP src/lib/IO src/lib/SYM src/lib/INTERFACE src/lib/COMMON src/lib/CIF src/core src/dialogs src/models src/opengl src/qt
DEPENDPATH=./src/qt ./src/core ./src/dialogs ./src/models \
     ./src/lib/CIF ./src/lib/COMMON\
    ./src/lib/INTERFACE ./src/lib/IO ./src/lib/SYM  ./src/lib/TOOLS\
    ./src/lib/BP
VPATH +=./ui/ ./src/ ./src/qt ./src/core ./src/dialogs ./src/models 

SOURCES = \
	lib/BP/allocread.c\
	lib/COMMON/Assorted.cpp\
	lib/COMMON/Cmplx.cpp\
	lib/COMMON/CoeffBasisInfo.cpp\
	lib/COMMON/DMQuantAxis.cpp\
	lib/COMMON/FString.cpp\
	lib/COMMON/MolecularOrbital.cpp\
	lib/COMMON/MyDebug.cpp\
	lib/COMMON/MyMath.cpp\
	lib/COMMON/MyQRgb.cpp\
	lib/COMMON/Parser.cpp\
	lib/COMMON/SqMatrix.cpp\
	lib/COMMON/SqMatrixYlm.cpp\
	lib/COMMON/Sysinfo.cpp\
	lib/COMMON/Vec3.cpp\
	lib/COMMON/Vlevel.cpp\
	lib/CIF/CIFData.cpp\
	lib/CIF/CIFDriver.cpp\
	lib/CIF/CIFLexer.cpp\
	lib/CIF/CIFParse.cpp\
	lib/CIF/FMatrix.cpp\
	lib/CIF/IMatrix.cpp\
	lib/CIF/IntegerTricks.cpp\
	dialogs/AnnotationDlg.cpp\
	dialogs/AtomMarkerPropertyWidget.cpp\
	dialogs/AtomPropsDlg.cpp\
	dialogs/AtomSequenceDlg.cpp\
	dialogs/AxisWidget.cpp\
	dialogs/BondPolyDlg.cpp\
	dialogs/BondsDlg.cpp\
	dialogs/BoundDlg.cpp\
	dialogs/BoundDlgWidget.cpp\
	dialogs/BrainDialog.cpp\
	dialogs/CanvasDlg.cpp\
	dialogs/CIFImportDlg.cpp\
	dialogs/ColorButton.cpp\
	dialogs/ColorModelEditor.cpp\
	dialogs/ColorRampWidget.cpp\
	dialogs/ContribDlg.cpp\
	dialogs/CutDlg.cpp\
	dialogs/Delegates.cpp\
	dialogs/DisplayCellWidget.cpp\
	dialogs/ElidLabel.cpp\
	dialogs/ExecPathDlg.cpp\
	dialogs/FermiDlg.cpp\
	dialogs/FilesDlg.cpp\
	dialogs/FindAtomDlg.cpp\
	dialogs/FogDlg.cpp\
	dialogs/FploDlg.cpp\
	dialogs/FSSweepDialog.cpp\
	dialogs/FSToolBox.cpp\
	dialogs/HelpBrowser.cpp\
	dialogs/HelpDlg.cpp\
	dialogs/HsvSampler.cpp\
	dialogs/InpConDlg.cpp\
	dialogs/KexpDlg.cpp\
	dialogs/LightDlg.cpp\
	dialogs/MapAtomsDlg.cpp\
	dialogs/MeshDlg.cpp\
	dialogs/MeshSymDlg.cpp\
	dialogs/OptDlg.cpp\
	dialogs/PlotDlg.cpp\
	dialogs/PrntDlg.cpp\
	dialogs/Propview.cpp\
	dialogs/ProtoDlg.cpp\
	dialogs/RealDlg.cpp\
	dialogs/SearchWidget.cpp\
	dialogs/SettingsDlg.cpp\
	dialogs/SettingsExternalWidget.cpp\
	dialogs/SettingsGraphicsWidget.cpp\
	dialogs/SettingsOGLWidget.cpp\
	dialogs/SetTypeDlg.cpp\
	dialogs/Sheet.cpp\
	dialogs/SpecialPointDlg.cpp\
	dialogs/StatusConfigDlg.cpp\
	dialogs/STToolBox.cpp\
	dialogs/SubGroupGenDlg.cpp\
	dialogs/SurColDlg.cpp\
	dialogs/SymDlg.cpp\
	dialogs/SymManipulateWdg.cpp\
	dialogs/TestDlg.cpp\
	dialogs/ThemeDlg.cpp\
	dialogs/ToolBox.cpp\
	dialogs/ToolButtons.cpp\
	dialogs/UnfoldDlg.cpp\
	core/AntiAliasing.cpp\
	core/Array.cpp\
	core/Atom.cpp\
	core/AtomFindMarker.cpp\
	core/AtomPropPicker.cpp\
	core/AutoColor.cpp\
	core/Axes.cpp\
	core/BBins.cpp\
	core/Bond.cpp\
	core/BondDefs.cpp\
	core/Boundary.cpp\
	core/BoundingBox.cpp\
	core/BWDoc.cpp\
	core/BWeights.cpp\
	core/BWFromCoeffs.cpp\
	core/Cluster.cpp\
	core/Coeffs.cpp\
	core/ColorMap.cpp\
	core/ColorModel.cpp\
	core/Connection.cpp\
	core/DataExchange.cpp\
	core/DisplayCells.cpp\
	core/DocBase.cpp\
	core/Erg.cpp\
	core/Field.cpp\
	core/Fog.cpp\
	core/Fplo.cpp\
	core/FSDoc.cpp\
	core/IDCache.cpp\
	core/IsoColor.cpp\
	core/IsoSurface.cpp\
	core/Light.cpp\
	core/MeshData.cpp\
	core/MeshSymmetry.cpp\
	core/Module.cpp\
	core/Plane.cpp\
	core/Polyhedron.cpp\
	core/Position.cpp\
	core/PropertyTable.cpp\
	core/RegularMesh.cpp\
	core/Settings.cpp\
	core/Spsp.cpp\
	core/SReal.cpp\
	core/STDoc.cpp\
	core/STM.cpp\
	core/Symmetry.cpp\
	core/TriangleMesh.cpp\
	core/Types.cpp\
	core/View.cpp\
	core/Vunit.cpp\
	core/Xf.cpp\
	core/XfploHelp.cpp\
	qt/Activity.cpp\
	qt/AfterShowEvent.cpp\
	qt/BWEdit.cpp\
	qt/CanvasSize.cpp\
	qt/ControlBase.cpp\
	qt/FSW.cpp\
	qt/IconCache.cpp\
	qt/Main.cpp\
	qt/Master.cpp\
	qt/MWBase.cpp\
	qt/OutWin.cpp\
	qt/ReselectEvent.cpp\
	qt/ShortCuts.cpp\
	qt/Status.cpp\
	qt/STR.cpp\
	qt/Valid.cpp\
	models/BFacesModel.cpp\
	models/SpspModel.cpp\
	models/WyckPosModel.cpp\
	opengl/OGL.cpp\
	opengl/OGLAutoGlyph.cpp\
	opengl/OGLBSPTree.cpp\
	opengl/OGLDataCache.cpp\
	opengl/OGLLegend.cpp\
	opengl/OGLLightHelper.cpp\
	opengl/OGLLine.cpp\
	opengl/OGLMaterial.cpp\
	opengl/OGLMeshCells.cpp\
	opengl/OGLMeshPoints.cpp\
	opengl/OGLObject.cpp\
	opengl/OGLPoly.cpp\
	opengl/OGLPrimitives.cpp\
	opengl/OGLRotationSymbol.cpp\
	opengl/OGLSphere.cpp\
	opengl/OGLText.cpp\
	opengl/OGLTransparentCollector.cpp\
	opengl/OGLTriangleMesh.cpp\
	opengl/OGLTube.cpp\
	opengl/OGLView.cpp\
	opengl/OGLVolume.cpp\
	opengl/RepAutoGlyph.cpp\
	opengl/RepBoundingBox.cpp\
	opengl/Representation.cpp\
	opengl/RepVolume.cpp\
	lib/IO/convtests.c\
	lib/IO/idparser.c\
	lib/IO/io.lex.yy.c\
	lib/IO/io.y.tab.c\
	lib/IO/ioparser.c\
	lib/IO/stdstack.c\
	lib/IO/table.c\
	lib/IO/tparser.c\
	lib/IO/vartable.c\
	lib/INTERFACE/cio.c\
	lib/INTERFACE/fortrantypes.c\
	lib/TOOLS/allocate.c\
	lib/TOOLS/cbuffer.c\
	lib/TOOLS/constants.c\
	lib/TOOLS/helper.c\
	lib/TOOLS/merror.c\
	lib/TOOLS/tools.c\
	lib/SYM/fsymmetry.c\
	lib/SYM/generatetau.c
#    ../../../../../../usr/share/qtcreator/gdbmacros/gdbmacros.cpp 
FORMS = \
	AnnotationDlg.ui\
	AtomMarkerPropertyWidget.ui\
	AtomPropsDlg.ui\
	AtomSequenceDlg.ui\
	AxisWidget.ui\
	BondPolyDlg.ui\
	BondsDlg.ui\
	BoundDlg.ui\
	BoundDlgWidget.ui\
	BWEdit.ui\
	CanvasDlg.ui\
	CIFImportDlg.ui\
	ColorModelEditor.ui\
	ContribDlg.ui\
	ContribDlgOld.ui\
	CutDlg.ui\
	DisplayCellWidget.ui\
	ExecPathDlg.ui\
	FermiDlg.ui\
	FilesDlg.ui\
	FindAtomDlg.ui\
	FogDlg.ui\
	FploDlg.ui\
	fploselectdlg.ui\
	FSSettings.ui\
	FSSweepDialog.ui\
	FSToolBox.ui\
	FSW.ui\
	HelpDlg.ui\
	InpConDlg.ui\
	KexpDlg.ui\
	LightDlg.ui\
	MapAtomsDlg.ui\
	MBox.ui\
	MeshDlg.ui\
	MeshSymDlg.ui\
	OptDlg.ui\
	OutWin.ui\
	PlotDlg.ui\
	PrntDlg.ui\
	PropView.ui\
	RealDlg.ui\
	SearchWidget.ui\
	SettingsDlg.ui\
	SettingsExternalWidget.ui\
	SettingsGraphicsWidget.ui\
	SettingsOGLWidget.ui\
	SetTypeDlg.ui\
	SpecialPointDlg.ui\
	StatusConfigDlg.ui\
	STR.ui\
	STToolBox.ui\
	SubGroupGenDlg.ui\
	SurColDlg.ui\
	SymDlg.ui\
	SymManipulateWdg.ui\
	TestDlg.ui\
	ThemeDlg.ui\
	UnfoldDlg.ui\
	widget.ui
HEADERS = \
	dialogs/AnnotationDlg.hh\
	dialogs/AtomMarkerPropertyWidget.hh\
	dialogs/AtomPropsDlg.hh\
	dialogs/AtomSequenceDlg.hh\
	dialogs/AxisWidget.hh\
	dialogs/BondPolyDlg.hh\
	dialogs/BondsDlg.hh\
	dialogs/BondTreeView.hh\
	dialogs/BoundDlg.hh\
	dialogs/BoundDlgWidget.hh\
	dialogs/BrainDialog.hh\
	dialogs/CanvasDlg.hh\
	dialogs/CIFImportDlg.hh\
	dialogs/ColorButton.hh\
	dialogs/ColorModelEditor.hh\
	dialogs/ColorRampWidget.hh\
	dialogs/CombiTreeView.hh\
	dialogs/ComboBoxHelper.hh\
	dialogs/ContribDlg.hh\
	dialogs/CutDlg.hh\
	dialogs/Delegates.hh\
	dialogs/DisplayCellWidget.hh\
	dialogs/ElidLabel.hh\
	dialogs/ExecPathDlg.hh\
	dialogs/FermiDlg.hh\
	dialogs/FilesDlg.hh\
	dialogs/FindAtomDlg.hh\
	dialogs/FogDlg.hh\
	dialogs/FploDlg.hh\
	dialogs/FSSweepDialog.hh\
	dialogs/FSToolBox.hh\
	dialogs/HelpBrowser.hh\
	dialogs/HelpDlg.hh\
	dialogs/HsvSampler.hh\
	dialogs/InpConDlg.hh\
	dialogs/KexpDlg.hh\
	dialogs/LightDlg.hh\
	dialogs/MapAtomsDlg.hh\
	dialogs/MBox.hh\
	dialogs/MeshDlg.hh\
	dialogs/MeshSymDlg.hh\
	dialogs/MyGroupBox.hh\
	dialogs/MyListView.hh\
	dialogs/MyTableView.hh\
	dialogs/MyTreeView.hh\
	dialogs/OptDlg.hh\
	dialogs/PlotDlg.hh\
	dialogs/PrntDlg.hh\
	dialogs/Propview.hh\
	dialogs/ProtoDlg.hh\
	dialogs/RealDlg.hh\
	dialogs/SearchWidget.hh\
	dialogs/SettingsDlg.hh\
	dialogs/SettingsExternalWidget.hh\
	dialogs/SettingsGraphicsWidget.hh\
	dialogs/SettingsOGLWidget.hh\
	dialogs/SetTypeDlg.hh\
	dialogs/Sheet.hh\
	dialogs/SpecialPointDlg.hh\
	dialogs/StatusConfigDlg.hh\
	dialogs/STToolBox.hh\
	dialogs/SubGroupGenDlg.hh\
	dialogs/SurColDlg.hh\
	dialogs/SymDlg.hh\
	dialogs/SymManipulateWdg.hh\
	dialogs/TestDlg.hh\
	dialogs/ThemeDlg.hh\
	dialogs/ToolBox.hh\
	dialogs/ToolButtons.hh\
	dialogs/UnfoldDlg.hh\
	opengl/OGL.hh\
	opengl/OGLAutoGlyph.hh\
	opengl/OGLBSPTree.hh\
	opengl/OGLDataCache.hh\
	opengl/OGLLegend.hh\
	opengl/OGLLight.hh\
	opengl/OGLLightHelper.hh\
	opengl/OGLLine.hh\
	opengl/OGLMaterial.hh\
	opengl/OGLMeshCells.hh\
	opengl/OGLMeshPoints.hh\
	opengl/OGLObject.hh\
	opengl/OGLPoly.hh\
	opengl/OGLPrimitives.hh\
	opengl/OGLRotationSymbol.hh\
	opengl/OGLSphere.hh\
	opengl/OGLText.hh\
	opengl/OGLTransparentCollector.hh\
	opengl/OGLTriangleMesh.hh\
	opengl/OGLTube.hh\
	opengl/OGLUserData.hh\
	opengl/OGLView.hh\
	opengl/OGLVolume.hh\
	opengl/RepAutoGlyph.hh\
	opengl/RepBoundingBox.hh\
	opengl/Representation.hh\
	opengl/RepVolume.hh\
	qt/Action.hh\
	qt/Actions.hh\
	qt/Activity.hh\
	qt/AfterShowEvent.hh\
	qt/BWEdit.hh\
	qt/CanvasSize.hh\
	qt/Config.hh\
	qt/ControlBase.hh\
	qt/FSW.hh\
	qt/IconCache.hh\
	qt/Interrupt.hh\
	qt/Master.hh\
	qt/MWBase.hh\
	qt/MySignalMapper.hh\
	qt/MyVariant.hh\
	qt/OutWin.hh\
	qt/qt5compat.hh\
	qt/ReselectEvent.hh\
	qt/ShortCuts.hh\
	qt/Status.hh\
	qt/STR.hh\
	qt/Valid.hh\
	core/AntiAliasing.hh\
	core/Array.hh\
	core/Array_cpp.hh\
	core/Atom.hh\
	core/AtomFindMarker.hh\
	core/AtomMarkerProperties.hh\
	core/AtomPropPicker.hh\
	core/AutoColor.hh\
	core/AutoColor_internal_cpp.hh\
	core/Axes.hh\
	core/BBins.hh\
	core/Bond.hh\
	core/BondDefs.hh\
	core/Boundary.hh\
	core/BoundingBox.hh\
	core/BWDoc.hh\
	core/BWeights.hh\
	core/BWFromCoeffs.hh\
	core/Cluster.hh\
	core/Coeffs.hh\
	core/ColorMap.hh\
	core/ColorModel.hh\
	core/Connection.hh\
	core/DataExchange.hh\
	core/DataStatistics.hh\
	core/DataStatistics_cpp.hh\
	core/DisplayCells.hh\
	core/DocBase.hh\
	core/Erg.hh\
	core/Field.hh\
	core/Fog.hh\
	core/Fplo.hh\
	core/FSDoc.hh\
	core/Group.hh\
	core/IDCache.hh\
	core/IsoColor.hh\
	core/IsoSurface.hh\
	core/IsoSurface_internal_cpp.hh\
	core/Light.hh\
	core/Material.hh\
	core/MeshData.hh\
	core/MeshSymmetry.hh\
	core/Module.hh\
	core/PatternCount.hh\
	core/Plane.hh\
	core/PointerT.hh\
	core/Polyhedron.hh\
	core/Position.hh\
	core/PropertyTable.hh\
	core/RegularMesh.hh\
	core/Settings.hh\
	core/Spsp.hh\
	core/SReal.hh\
	core/STDoc.hh\
	core/STM.hh\
	core/Symmetry.hh\
	core/TriangleMesh.hh\
	core/Types.hh\
	core/Value.hh\
	core/View.hh\
	core/Vunit.hh\
	core/Worker.hh\
	core/Xf.hh\
	core/XfploHelp.hh\
	models/AnnotationsTreeModel.hh\
	models/AtomPropsModel.hh\
	models/BBoxModel.hh\
	models/BFacesModel.hh\
	models/BondGroupsModel.hh\
	models/BondModel.hh\
	models/CombiModel.hh\
	models/LightsModel.hh\
	models/SpspModel.hh\
	models/WyckPosModel.hh

RESOURCES = resources.qrc
TARGET = xfplo
target.path = "../../../bin/"
INSTALLS += target 
unix { 
    UI_DIR = .ui
    MOC_DIR = .moc
    OBJECTS_DIR = .obj
}
