/* @(#)AtomFindMarker.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ATOMFINDMARKER_H
#define _ATOMFINDMARKER_H 1

#include <QObject>
#include "Atom.hh"
#include "Xf.hh"
#include "AtomMarkerProperties.hh"

namespace XFPLO{
class Cluster;
}

using namespace XFPLO;


class AtomFindMarker: public QObject{
  Q_OBJECT;
 public:
  AtomFindMarker();
  ~AtomFindMarker(){};

  bool mark(Cluster *cluster,Xf::FindAtomModes mode,long number);
  void print();
  void clear(){emit markAtomsRequest(false,true);patomlist.clear();};
  void refresh(){emit markAtomsRequest(true,true);};

  AtomMarkerProperties &properties(){return pmarkproperties;};


  QList<XFPLO::Atom>&atomList(){return patomlist;};

 signals:
  void markAtomsRequest(bool onoff,bool update);

 private slots:
  void onPropertiesChanged();
    

 private:
  QList<XFPLO::Atom> patomlist;
  AtomMarkerProperties pmarkproperties;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _ATOMFINDMARKER_H */

