/* @(#)AtomMarkerProperties.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ATOMMARKERPROPERTIES_H
#define _ATOMMARKERPROPERTIES_H 1

#include <QObject>
#include "MyQRgb.hh"
#include "Settings.hh"

class AtomMarkerProperties: public QObject
{
  Q_OBJECT;
 public:
  AtomMarkerProperties()
    :pcolor(0xff00ff),pspec(true),pemission(0.3){
/*     settings.get("structure/AtomMarkerProperties/diffusecolor",pcolor); */
/*     settings.get("structure/AtomMarkerProperties/hasspecular",pspec); */
/*     settings.get("structure/AtomMarkerProperties/brightness",pemission); */
  };
  
  inline QRgb color()const{return pcolor;};
  inline bool isSpecular()const{return pspec;};
  inline double emission()const{return pemission;};
  inline void setColor(QRgb color){
    pcolor=color;

    Settings("structure").set("AtomMarkerProperties/diffusecolor",pcolor); 
    emit propertiesChanged();
    
  };
  inline void setIsSpecular(bool isspec){
    pspec=isspec;
    Settings("structure").set("AtomMarkerProperties/hasspecular",pspec);
    emit propertiesChanged();
  };
  inline void setEmission(double emission){
    pemission=emission;
    Settings("structure").set("AtomMarkerProperties/brightness",emission);
    emit propertiesChanged();
  };

 signals:
  void propertiesChanged();
  
 private:
  QRgb pcolor;
  bool pspec;
  double pemission;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _ATOMMARKERPROPERTIES_H */

