/* @(#)AtomPropPicker.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ATOMPROPPICKER_H
#define _ATOMPROPPICKER_H 1

#include <QObject>

class AtomPropPicker: public QObject
{
  Q_OBJECT;
public:
  AtomPropPicker():tmpatom(-1){};
    //  const QList<long> &list()const { return atoms;};
  void reset(){atoms.clear();tmpatom=-1;};

  // just the clicked/picked atoms
  int pickedSize()const {return atoms.size();};
  long operator[](long i){return atoms.at(i);};

  //these include the tmp atom
  int size()const;
  long at(long i);
  
  long last()const{return atoms.last();};

/*   void setTmpAtom(long i){tmpatom=i;}; */
/*   long tmpAtom()const{return tmpatom;}; */

  void addAtom(long i){atoms.append(i);};
  bool isAtomInList(long i){return atoms.contains(i);};
  void takeAtom(long i){atoms.removeAll(i);};

  void pickerChanged(){emit atomPropPickerChanged();};

signals:
  void atomPropPickerChanged();

private:
  QList<long> atoms;
  long tmpatom;


};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _ATOMPROPPICKER_H */

