/* @(#)BWeights.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _BWEIGHTS_H
#define _BWEIGHTS_H 1

#include <QStringList>

class RegularMesh;


class BWeights{
 public:
  BWeights();
  ~BWeights();
  
  long  ilower()const{return pilower;};
  long  iupper()const{return piupper;};
  long  nband()const{return pnband;};
  long  nspin()const{return pnspin;};
  long  nkp()const{return pnkp;};
  long  nweights()const{return plabels.size();};
  const QStringList &labels()const{return plabels;};

  void load(const char *fname,RegularMesh *pmesh
	    ,long b0,long b1);
  
 private:
  long pilower,piupper,pnband,pnspin,pnkp;
  QStringList plabels;
  
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _BWEIGHTS_H */

