/* @(#)Bond.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _BOND_H
#define _BOND_H 1

#include "MyQRgb.hh"
#include "Vec3.hh"

namespace XFPLO{

/* ***********************************************************************
 *
 * ***********************************************************************
 */

class Bond
{
public:

  Bond(){}
  Bond(const Vec3 &pa,const Vec3 &pb,QRgb rgb=0x7f7f7f
	     ,double opac=0.6,double rad=1.,bool vis=true)
    :radius(rad),color(rgb),opacity(opac),visible(vis){
    bondpoints[0]=pa;
    bondpoints[1]=pb;
  };

  String printS();

  Vec3 bondpoints[2];
  double radius;
  QRgb color;
  double opacity;
  bool visible;

};

}
#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _BOND_H */

