/* @(#)BoundingBox.hh
 * author: magru@unas
 */

#ifndef _BOUNDINGBOX_HH
#define _BOUNDINGBOX_HH 1

#include "Vec3.hh"

namespace XFPLO{


/* ***********************************************************************
 *
 * ***********************************************************************
 */


class BoundingBox{
public:
  BoundingBox():pcell(Matrix3x3::unitMatrix()){}
  ~BoundingBox(){}

  const Vec3 &origin()const{return porigin;}
  const Matrix3x3 &cell()const{return pcell;}

  void setOrigin(const Vec3 &o){porigin=o;}
  void setCell(const Matrix3x3 &c){pcell=c;}

  String toString();
  
protected:
private:
  Vec3 porigin;
  Matrix3x3 pcell;
public:
  static BoundingBox defaultBox;
};

}

#endif /* _BOUNDINGBOX_HH */

