/* @(#)Coeffs.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _COEFFS_H
#define _COEFFS_H 1

#include <QObject>
#include "FString.hh"

namespace XFPLO{
class MolecularOrbitals;
class CoeffBasisInfo;



/* ***********************************************************************
 *
 * ***********************************************************************
 */
class Coeffs:public QObject{
  Q_OBJECT;
public:
  Coeffs();
  ~Coeffs();
  
  
  
  void readFromFile(const String &fileName,CoeffBasisInfo &cbi,bool forceload);
  
  static bool isCoeffFile(const String &fileName);
  
  void makeBandWeights(const String &wfname,MolecularOrbitals &cc
		       ,CoeffBasisInfo &cbi);
  
  bool isReady()const {return pisready;};
  
  void clean();

signals:
  void progress(int);

private:

private:
  long nkp,nspin,nband;
  double *kpoints;
  double *ekb;
  double *zz;

  double eff;
  long ilower,iupper;
  String pcurrentfile;
  bool pisready;
};
}
#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _COEFFS_H */

