/*************************************************************************
 * @(#)ColorModel.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   17 Jun 2011
 *************************************************************************
 */

#include "ColorModel.hh"
#include "MyMath.hh"
#include "MyDebug.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */

QColor ColorModel::getColorFromIndex(double h)const
{
  QColor c;
  if(ptype==RainBow){
    c.setHsv(MyMath::max<long>(0,MyMath::min<long>(255,(int)(h*240.))),255,255);
  }else if(ptype==TwoColors){
    //c.setHsv(0,MyMath::max<long>(0,MyMath::min<long>(2e55,(int)((1-h)*240.))),255);
    QColor pc(0xffffff);
    double v1=pcolor1.value();
    double vc=pc.value();
    double v2=pcolor2.value();

    double x0=-1.;
    double x1=1.;
    h=1-h;
    if(h<x0)h=x0;
    if(h>x1)h=x1;
    h=(h-x0)/(x1-x0);

    if(h<0.5){
      double x=2*h;
      c.setHsv(pcolor1.hsvHue(),255*(1-2*h),(1-x)*v1+x*vc);
    }else{
      double x=2*h-1;
      c.setHsv(pcolor2.hsvHue(),255*2*(h-0.5),(1-x)*vc+x*v2);
    }
    
    
    //myDebug()<<h<<c.red()<<c.green()<<c.blue();
    //exit(1);
  }else if(ptype==Map){
    c=pcolormap.colorFromIndex(h);
  }
  
  return c;
  
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ColorModel::getColorArrayFromIndex(double h,double *rgba)const
{
  QColor c=getColorFromIndex(h);
  rgba[0]=c.red()/255.;
  rgba[1]=c.green()/255.;
  rgba[2]=c.blue()/255.;
  rgba[3]=c.alpha()/255.;
}





/*EOF*/ 
