/* @(#)ColorModel.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _COLORMODEL_H
#define _COLORMODEL_H 1

#include "MyQRgb.hh"
#include "ColorMap.hh"

class ColorModel
{
 public:
  enum ColorModelType{RainBow=1,TwoColors=2,Map=3};
  ColorModel():ptype(RainBow),pcolor1(0x000000ff),pcolor2(0xff0000){
    pcolormap.append(0,240,255,255);
    pcolormap.append(1,0,255,255);
  };
  ~ColorModel(){};
  
  void setRainBow(){ptype=RainBow;};
  void setMap(){ptype=Map;};
  void setTwoColors(QRgb c1,QRgb c2){ptype=TwoColors;
    pcolor1=c1;pcolor2=c2;};

  ColorMap &colorMap(){return pcolormap;};
  void setColorMap(const ColorMap &cm){pcolormap=cm;};

  QColor getColorFromIndex(double )const;
  void getColorArrayFromIndex(double ,double *)const;
 private:
  ColorModelType ptype;
  QColor pcolor1,pcolor2;
  ColorMap pcolormap;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _COLORMODEL_H */

