/* @(#)DataExchange.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _DATAEXCHANGE_H
#define _DATAEXCHANGE_H 1


#include <QObject>
#include <QString>
#include <QPair>

class DataExchange: public QObject
{
  Q_OBJECT;
 public:
  DataExchange(){};
  ~DataExchange(){};
  void registerListener(QObject *listener,const QString &expectedData){
    QPair<QObject*,QString> pair=qMakePair(listener,expectedData);
    if(!plistenerlist.contains(pair)){
      plistenerlist.append(pair);
    }
  };
  void unRegisterListener(QObject *listener){
    for(int i=plistenerlist.size()-1;i>=0;i--){
      QPair<QObject*,QString> pair=plistenerlist.at(i);
      if(pair.first==listener){
	plistenerlist.removeAt(i);
      }
    }
  };
  void unRegisterListener(QObject *listener,const QString &expectedData){
    for(int i=plistenerlist.size()-1;i>=0;i--){
      QPair<QObject*,QString> pair=plistenerlist.at(i);
      if(pair.first==listener && pair.second==expectedData){
	plistenerlist.removeAt(i);
      }
    }
  };
  bool listensFor(const QString &expectedData){
    QPair<QObject*,QString> pair;
    foreach (pair, plistenerlist){
      if(pair.second==expectedData){
	return true;
      }
    }
    return false;
  }
  void sendData(QObject *sender,const QString &expectedData,const void *data){
    for(int i=plistenerlist.size()-1;i>=0;i--){
      QPair<QObject*,QString> pair=plistenerlist.at(i);
      //      myDebug() <<"send to: "<<pair;
      if(pair.second==expectedData){
	emit dataAvailable(sender,pair.first,expectedData,data);
      }
    }
    
  }

 signals:
  void dataAvailable(QObject *sender,const QObject *listener
		     ,const QString &expectedData,const void *data);
  
 private:
  QList<QPair<QObject*,QString> > plistenerlist;
  
};


extern DataExchange dataExchange;


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _DATAEXCHANGE_H */

