/*************************************************************************
 * @(#)Fog.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   15 Mar 2011
 *************************************************************************
 */

#include "Parser.hh"
#include "Except.hh"
#include "Fog.hh"


const char *Fog::pfogmodenames[]={
  "",
  "Exponential",
  "Gaussian",
  "Linear"
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void Fog::PTSectionToFile(FILE *FH)
{
  fprintf(FH,"struct{logical usefog;real density;real near;real far;\n"
	  "          char[*] color;int mode;}fog\n"
	  "={%c,%g,%g,%g,%s,%d};\n"
	  ,(pusefog?'t':'f'),pdensity,pnear,pfar,Sprintf("\"%x\"",pcolor)()
	  ,pfogmode
	  );
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void Fog::readPTSectionFromFile(const Dobj &root)
{
  try{
    FogMode m=(FogMode)root("fog.mode").valueL();
    setFogMode(m);
    setUseFog(root("fog.usefog").valueL());
    Dobj c=root("fog.color");
    if(c.isInt()){
      setColor(c.valueL());
    }else{
      setColor(c().convertToULong());
    }
    setDensity(root("fog.density").valueD());
    setNear(root("fog.near").valueD());
    setFar(root("fog.far").valueD());
  }catch(Except e){};

}



/*EOF*/ 
