/* @(#)IsoColor.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ISOCOLOR_H
#define _ISOCOLOR_H 1

#include "MyQRgb.hh"

class ColorModel;

class IsoColor{
 public:
  IsoColor();
  inline bool innerFromData()const{return pinnerfromdata;};
  inline bool outerFromData()const{return pouterfromdata;};
  inline QRgb outerColor()const{return poutercolor;};
  inline QRgb innerColor()const{return pinnercolor;};
  inline int alpha()const{return qAlpha(poutercolor);}
  inline void setOuterColor(QRgb ac){poutercolor=ac;pchanged=true;};
  inline void setInnerColor(QRgb ac){pinnercolor=ac;pchanged=true;};

  inline void setInnerFromData(bool b){pinnerfromdata=b;pchanged=true;};
  inline void setOuterFromData(bool b){pouterfromdata=b;pchanged=true;};
  
  ColorModel *colorModel(){return pcolormodel;};
  const ColorModel *colorModel()const{return pcolormodel;};

  inline bool changed()const{return pchanged;};
  inline void setChanged(bool b){pchanged=b;};

 private:
  bool pouterfromdata;
  bool pinnerfromdata;
  QRgb poutercolor;
  QRgb pinnercolor;
  bool pchanged;
  ColorModel *pcolormodel;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _ISOCOLOR_H */

