/* @(#)IsoSurface.hh
 * author: magru@unas
 */

#ifndef _ISOSURFACE_HH
#define _ISOSURFACE_HH 1

#include "Module.hh"
#include "Value.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */

namespace XFPLO{


class Field;

class IsoSurface: public Module{
  // ----------------------------------------------------------------
  // we connect a field to this one and it contains its own field
  // it can  be connected to a represenation, which needs to check
  // wether, the input is  a Field or contains a field.
  // ----------------------------------------------------------------
public:
  IsoSurface();
  ~IsoSurface();

  bool useGradientAsNewData()const{return pusegradientasnewdata;}
  void setUseGradientAsNewData(bool s){pusegradientasnewdata=s;pisdirty=true;}
  
  void setIsoValue(const Value &isovalue){pisovalue=isovalue;pisdirty=true;}


  virtual bool cascadingUpdate(const String &prefix);

  const Field *outputField()const{return poutputfield;}
  Field *outputField(){return poutputfield;}

private:

  void calcIsoSurface();
  template <class T>
  void calcIsoSurface_internal();
  
protected:
  virtual void setInput(const Module *input);
  virtual void removeInput(const Module *);
private:
  const Field *pinputfield;
  Field *poutputfield;
  Value pisovalue;
  bool pusegradientasnewdata;
};
}
#endif /* _ISOSURFACE_HH */

