/* @(#)Material.hh
 * author: magru@unas
 */

#ifndef _MATERIAL_HH
#define _MATERIAL_HH 1

#include "MyQRgb.hh"
#include "MACROS.hh"

namespace XFPLO{
  
  /* ***********************************************************************
   *
   * ***********************************************************************
   */
  
  
  class Material{
  public:
    Material():pcolor(0xff0000),pshininess(50.),pspecularcolor(0xffffff){}
    Material(QRgb c,double s):pcolor(c),pshininess(s),pspecularcolor(0xffffff){}
    Material(QRgb c,QRgb spec,double s):pcolor(c),pshininess(s),pspecularcolor(spec){}
    
    bool operator!=(const Material &other)const{
      return (
	      ( pcolor!=other.pcolor)||
	      ( pspecularcolor!=other.pspecularcolor)||
	      ( pshininess!=other.pshininess)
	      );
    }
    
  protected:
  private:
    CPROPERTY(color,color,Color,QRgb);
    CPROPERTY(shininess,shininess,Shininess,double);
    CPROPERTY(specularcolor,specularColor,SpecularColor,QRgb);
  };
  
  
}
#endif /* _MATERIAL_HH */

