/* @(#)MeshData.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _MESHDATA_H
#define _MESHDATA_H 1

#include <string.h> 
#include "MyQRgb.hh"
#include <QVector> 

class MeshData
{
 public:
  MeshData();
  MeshData(long N);
  ~MeshData();

  

  void addExtraDataArray(long min);

  inline void setGradient(long index,double data[3]){
    memcpy(pgradients+3*index,data,sizeof(double)*3);
  };
  inline void addToGradient(long index,double data[3]){
    pgradients[3*index+0]+=data[0];
    pgradients[3*index+1]+=data[1];
    pgradients[3*index+2]+=data[2];
  };

  inline double element(long i)const{return parray[i];};
  inline double *gradient(long i)const{return pgradients+3*i;};
  

 private:
  void resizeData(long N);

 private:
  double *parray;
  double *pgradients;
  QVector<double *> pextradata;
  long psize;

  friend class RegularMesh;

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _MESHDATA_H */

