/* @(#)Module.hh
 * author: magru@unas
 */

#ifndef _MODULE_HH
#define _MODULE_HH 1

#include "ValueArray.hh"
#include "FString.hh"
#include "IDCache.hh"


template <class T>
class ValueArray;

namespace XFPLO{



/* ***********************************************************************
 *
 * ***********************************************************************
 */

class Module{
  // ----------------------------------------------------------------
  // Module has inputs, which tell it that they are dirty
  //        and outpus, which need to betold that they are dirty
  // ----------------------------------------------------------------
  class Data{
  public:
    Data():module(0){}
    Data(Module *m):module(m){}
    bool operator==(const Data &other)const{return module==other.module;}
    Module *module;
    StringList changedinput; 
  };

public:
  Module(const char *classname="Module");
  virtual ~Module();
  
  const String &id()const{return pid;}
  const String &classname()const{return pclassname;}
  bool isA(const String &a)const{return (pclassname==a);}

  static void connect(Module *input,Module *output);

  void debug(const String &direction,const String &prefix="")const;

  virtual bool cascadingUpdate(const String &prefix);//return false if no dirt was present

  bool isDirty()const{return pisdirty;}
  void setDirty(bool d){pisdirty=d;}

  static void showIDCache(){pidchache.showIDCache();};

  static String makeUniqueName(const char *prefix="Module"){
    return pidchache.makeUniqueName(Sprintf("%s_",prefix));}

  void showDirt(const String &prefix,const String &context);

protected:
  virtual void setInput(const Module *){pisdirty=true;}
  virtual void removeInput(const Module *){}
  void sendDirt(const String &whatchanged);
  bool dirtyInput(const String &whatsdirty="")const;
  void resetDirt(const String &what="");


protected:
  String pclassname;
  bool pisdirty;


private:
  ValueArray<Data> pinputs;
  ValueArray<Data> poutputs;
  String pid;
  static IDCache pidchache;

public:
  static bool debugmode;

};


  //void connect(Module *input,Module *output);

}

#endif /* _MODULE_HH */

