/* @(#)PatternCount.hh
 * author: magru@unas
 */

#ifndef _PATTERCOUNT_HH
#define _PATTERCOUNT_HH 1

#include "Assorted.hh"

/* ***********************************************************************
 * keep accumulated track of counts of integer events save and load to/fro file
 * ***********************************************************************
 */
class PatternCount{
public:
  PatternCount(long size):counter(new ValueArray<double>(size,0)){
    load();
  }
  ~PatternCount(){
    save();
    delete counter;
  }

  double &operator[](long i){
    return (*counter)[i];
  }

  void load(){
    try{
      FILE *FH=openforread("=.patterncount");
      for(int i=-1;++i<counter->size();){
	(void)fscanf(FH,"%lg ",&((*counter)[i]));
      }
      fclose(FH);
    }catch(...){}
  }


  void save(){
    try{
      FILE *FH=openforwrite("=.patterncount");
      for(int i=-1;++i<counter->size();){
	fprintf(FH,"%lg ",counter->at(i));
      }
      fclose(FH);
    }catch(...){}
  }


  void print(){
    double sum=counter->sum();
    printf("patterncount: total=%g\n",sum);
    for(int i=-1;++i<counter->size();){
      if(counter->at(i)!=0){
	printf("patternc %8s=%x: %5.2f\n",toBin(i,true)(),i,
	       100.*counter->at(i)/sum);
      }
    }
  }



  ValueArray<double> *counter;
};

#endif /* _PATTERCOUNT_HH */

