/* @(#)SReal.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SREAL_H
#define _SREAL_H 1

#include <QString>
#include "FString.hh"
#include "Except.hh"

class Vec3;

class SReal{
public:
  SReal():S("0"),D(0){};
  SReal(const QString &s){ *this=s;};
  SReal(double d){ *this=d;};


  bool operator!=(const SReal &other){
    return (S!=other.S);
  };

  // const SReal &operator/(double a){
  //   D/=a;
  //   S=Sprintf("%g",D);
  //   return *this;
  // };
  const SReal &operator/=(double a){
    D/=a;
    S=Sprintf("%g",D);
    return *this;
  };
  const SReal &operator=(const QString &other){
    S=other;
    try{
      D=S.convertToFortranReal();
    }catch(Except &e){D=0.;};
    return *this;
  };
  const SReal &operator=(const String &s){
    S=s;
    try{
      D=S.convertToFortranReal();
    }catch(Except &e){D=0.;};
    return *this;
  };
  const SReal &operator=(const SReal &other){
    S=other.S; D=other.D; return *this;};

  const SReal &operator=(double d){
    if((S=Sprintf("%30.15f",d).removeLeadingBlanks().chop("0")).empty()) S="0";
    D=d; return *this;};


  String S;
  double D;

};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class SReal3{
 public:
/*    SReal3(const Vec3 &v){  
      data[0]=v[0];  
      data[1]=v[1];  
      data[2]=v[2];  
    }  */

  SReal3(){};

  SReal3(double x,double y,double z,const String &fmt="%g");

  SReal &operator[](int i){return data[i];};
  const SReal &operator[](int i)const {return data[i];};
  
  const SReal3 &operator=(const SReal3 &other){
    data[0]=other.data[0];
    data[1]=other.data[1];
    data[2]=other.data[2];
    return *this;
  }

  const SReal3 &operator/=(double a){
    data[0]/=a;
    data[1]/=a;
    data[2]/=a;
    return *this;
  };

  inline bool operator!=(const SReal3 &other)const{
    return 
      (data[0].S!=other.data[0].S)||
      (data[1].S!=other.data[1].S)||
      (data[2].S!=other.data[2].S) ;
  }
  Vec3 toVec3()const;
 private:
  SReal data[3];
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _SREAL_H */

