/* @(#)STM.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _STM_H
#define _STM_H 1

#include "FString.hh"
#include "Vec3.hh"
#include "PropertyTable.hh"
#include "Xf.hh"

class QString;
namespace XFPLO{
  class Symmetry;
}

using namespace XFPLO;

class STM{
 public:
  STM();
  ~STM(){};

  Xf::LengthUnits lengthUnit()const{return pdatalengthunit;};
  const String &element()const{return pel;};
  const Vec3 &tauD()const{return tau;};
  bool visible()const{return pvisible;};

  void readSTMFile(const QString &fileName);
  
  QString calculate(const Symmetry *);
  bool calculated()const{return pcalculated;};

  inline double atomicRadius() const{
    return pproperty.atomicRadii().current(pdatalengthunit);
  }

 private:
  void readCoorddinate(const String &buffer);
 private:
  String pel;
  bool relative[3];
  long sites[3]; //one based
  Xf::LengthUnits lengthunits[3]; 
  Vec3 lxyz; 
  Vec3 tau;
  CMODPROPERTY(property,property,AtomProperty,AtomProperty);
  Xf::LengthUnits pdatalengthunit;
  bool pvisible;
  bool pcalculated;
  
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _STM_H */

