/*************************************************************************
 * @(#)Vunit.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   24 Jun 2009
 *************************************************************************
 */

#include "constants.h"
#include "Vunit.hh"



struct VUnits::tsvunit VUnits::p_vunits[]={
  {"m/s",METERperSEC,1.0}
  ,{"cm/s",CENTIMETERperSEC,100.0}
  ,{"C",SPEEDofLIGHT,1.0/def_speed_of_light_mpers}
  ,{"% C",percentSPEEDofLIGHT,100.0/def_speed_of_light_mpers}
};

int VUnits::p_numunits=sizeof(VUnits::p_vunits)/sizeof(VUnits::tsvunit);


/* ***********************************************************************
 *
 * ***********************************************************************
 */
double VUnits::velocityUnitFactor(VelUnits v)
{
  for(int i=0;i<p_numunits;i++){
    if(p_vunits[i].vunit == v){
      return p_vunits[i].msfactor;
    }
  }
  return p_vunits[METERperSEC].msfactor;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
VUnits::VelUnits  VUnits::vunitFromIndex(int i)
{
  int j=i;
  if(i<0 || i>=p_numunits) j=0;
  return p_vunits[j].vunit;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
int VUnits::indexFromVunit(VUnits::VelUnits v)
{
  for(int i=0;i<p_numunits;i++){
    if(p_vunits[i].vunit == v){
      return i;
    }
  }
  return METERperSEC;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */

const char* VUnits::velocityUnit(VUnits::VelUnits v)
{
  for(int i=0;i<p_numunits;i++){
    if(p_vunits[i].vunit == v){
      return p_vunits[i].name;
    }
  }
  return p_vunits[METERperSEC].name;
}



/*EOF*/ 
