/* @(#)AnnotationDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ANNOTATIONDLG_H
#define _ANNOTATIONDLG_H 1

#include "ui_AnnotationDlg.h"
#include "Xf.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */


class Sheet;
class QAction;
class DisplayCell;
class DisplayCells;
class ToolButtons;
class AnnotationsTreeModel;
namespace XFPLO{
  class Axes;
  class Axess;
  class Symmetry;
}
class DocBase;


using namespace XFPLO;

class AnnotationDlg: public ProtoDlg, private Ui::AnnotationDlg
{
  Q_OBJECT;
public:
  enum AnnotationMode{AMNone=0,AMAxes=1,AMDisplayCells=2};
  
  AnnotationDlg(QWidget *parent,QWidget *base,const char *name);
  ~AnnotationDlg();
  
  void setData(AnnotationMode mode
	       ,DocBase *doc,const Symmetry *sym
	       ,Xf::StructureType datastructurestype
	       ,Xf::LatticeType datalatticetype);
  void refresh(Xf::StructureType datastructurestype
	       ,Xf::LatticeType datalatticetype);
  void getData(DocBase *doc,long &chn);
  
  void refreshAxesActive(Xf::AxesType );
  void refreshDisplayCellsActive(Xf::DisplayCellType,bool);
  
 
  
protected:
  virtual bool event(QEvent *event);
  virtual bool dataAcceptable();  
private:
  
  void setSheet(const QModelIndex &current);
  void setAddDeleteEnabed();

private slots:

  void on_trvAnnotations_myCurrentChanged(const QModelIndex &,const QModelIndex &);
  void onAddActionTriggered();
  void onDeleteActionTriggered();

private:
  DocBase *p_doc;
  const Symmetry *t_sym;
  Sheet *currentsheet;
  Axess *t_axes;
  DisplayCells *t_displaycells;
  Xf::StructureType pdatastructurestype;
  Xf::LatticeType pdatalatticetype;
  bool mute_currentIndexChanged;
  ToolButtons *ptoolbuttons;
  AnnotationsTreeModel *anmodel;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _ANNOTATIONDLG_H */

