/*************************************************************************
 * @(#)AtomMarkerPropertyWidget.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   01 Mar 2011
 *************************************************************************
 */

#include "AtomMarkerPropertyWidget.hh"
#include "AtomMarkerProperties.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
AtomMarkerPropertyWidget::AtomMarkerPropertyWidget(QWidget *parent)
  : QWidget(parent),pamp(0)
{
  setupUi(this);

  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void AtomMarkerPropertyWidget::setData(AtomMarkerProperties *amp)
{
  pbColor->setColor(amp->color());
  cbxSpecular->setChecked(amp->isSpecular());
  dspbxBrightness->setValue(amp->emission());
  pamp=amp;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void AtomMarkerPropertyWidget::on_cbxSpecular_clicked(bool checked)
{
  if(!pamp) return;
  pamp->setIsSpecular(checked);
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void AtomMarkerPropertyWidget::on_pbColor_colorChanged(QRgb rgb)
{
  if(!pamp) return;
  pamp->setColor(rgb);
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void AtomMarkerPropertyWidget::on_dspbxBrightness_valueChanged(double d)
{
  if(!pamp) return;
  pamp->setEmission(d);
}




/*EOF*/ 
