/* @(#)AtomPropsDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ATOMPROPSDLG_H
#define _ATOMPROPSDLG_H 1

#include "ProtoDlg.hh"
#include "ui_AtomPropsDlg.h"

class AtomPropsModel;
class ColorDelegate;
class ComboDelegate;
namespace XFPLO{
  class AtomPropertyTable;
  class AtomPropertyTables;
}
class STDoc;
class String;

using namespace XFPLO;

class AtomPropsDlg : public ProtoDlg, private Ui::AtomPropsDlg
{
  Q_OBJECT;
 public:
  AtomPropsDlg(QWidget *parent,QWidget *base,const char *name);
  virtual ~AtomPropsDlg();
  void selectElement(const String &element);
public slots:
  void setData(STDoc *stdoc,const AtomPropertyTables *ptables);
  void getData(STDoc *stdoc,AtomPropertyTables *ptables);

private slots:
  void on_tvProps_clicked(const QModelIndex &index);
  void on_pbLoadDefault_clicked();
  void on_pbApplyTheme_clicked();
  void on_cmbTheme_currentIndexChanged(int index);
  void on_cmbTheme_editTextChanged(const QString &text);
  void on_tbAdd_clicked();
  void on_tbDelete_clicked();
  //  void onContentChanged(QObject* sender);

private:
  void adjustTvProps();
  void setTbDeleteEnabled();
  

private:
  AtomPropertyTables *t_ptables;
  AtomPropsModel *apmodel;
  ColorDelegate *colordelegate;
  ColorDelegate *speccolordelegate;
  ComboDelegate *radtypdelegate;
  bool mute_cmbThemeEdit;
  bool mute_cmbThemeIndex;
  STDoc *pstdoc;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _ATOMPROPSDLG_H */

