/* @(#)AtomSequenceDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ATOMSEQUENCEDLG_H
#define _ATOMSEQUENCEDLG_H 1

#include <QDialog>
#include "Symmetry.hh"
#include "ui_AtomSequenceDlg.h"

namespace XFPLO{ 

class AtomSequenceDlg: public BrainDialog, private Ui::AtomSequenceDlg
{
Q_OBJECT
public:
  AtomSequenceDlg(QWidget *parent,QWidget *base,const char *name);
  ~AtomSequenceDlg();

  void setData(Symmetry *);

signals:
  void atomSequenceChanged();

private slots:
  void loadSequence(QString);
  void onValueChanged(int);

protected slots:
  virtual void accept();

private:
  Symmetry *psym;
  ValueArray<ValueArray<WyckPos> > aseq;
};

}
#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _ATOMSEQUENCEDLG_H */

