/* @(#)AxisEdit.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _AXISEDIT_H
#define _AXISEDIT_H 1

#include <QDialog>
#include "ui_AxisEdit.h"
#include "DMDoc.hh"


class AxisEdit : public QDialog, private Ui::AxisEdit
{
  Q_OBJECT
public:
  AxisEdit(QWidget *parent = 0);
  ~AxisEdit();

  void setData(DMDoc *dm,long ioccu,long iaxes);
  void getData();

public slots:
 virtual void reject();

private slots:
 void on_pbQuit_clicked();
 void onLedPageTextEdited(const QString &text);
 void on_cmbAxes_currentIndexChanged(int index);

private:
 bool setLedPageText(bool betight);

 void saveMainSettings();
 void checkData();


 private:
 DMQuantAxis paxes;
 DMDoc *dmdoc;
 long currentioccu;
 long currentaxes;
 long pl;
 Vec3 x,z;

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _AXISEDIT_H */

