/* @(#)AxisWidget.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _AXISWIDGET_H
#define _AXISWIDGET_H 1

#include "ui_AxisWidget.h"
#include "Sheet.hh"
#include "ComboBoxHelper.hh"
#include "Xf.hh"


namespace XFPLO{
  class Axes;
  class Axess;
}
class QAction;
class OGLView;
class String;
class Vec3;

typedef class ComboBoxHelper<Xf::SceeneUnits> SUCH;


using namespace XFPLO;

class AxisWidget: public Sheet, private Ui::AxisWidget
{
Q_OBJECT;
public:
  AxisWidget(QWidget *parent);
  ~AxisWidget();


  void setData(Axes *ax,Axess *axess,OGLView *oglview);
  
  
  virtual bool commit();

  virtual bool isValid();


public slots:
  void onActiveToggled(const Axes *);

private slots:
  void onColorActionTriggered(QAction *);
  void onDefaultActionTriggered(QAction *);
  void on_pbMove_clicked();
  void onTextShiftChanged(const String &id,const Vec3 &v);

private:
  void setUpLabels();
  void setUpRod();
  void setUpTip();
  void setUpOrigin();
  void setUpAxes();
  void enableWidgets(bool onoff);

private:
  Axes *t_axes;
  Axess *paxes;
  SUCH *rodRHelper;
  SUCH *tipRHelper;
  SUCH *tipLHelper;
  SUCH *axesLHelper;
  SUCH *originHelper;
  OGLView *poglview;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _AXISWIDGET_H */

