/* @(#)BondPolyDlg.hh
 * author: magru@unas
 */

#ifndef _BONDPOLYDLG_HH
#define _BONDPOLYDLG_HH 1

#include "ui_BondPolyDlg.h"
#include "BondDefs.hh"
#include "ComboBoxHelper.hh"



using namespace XFPLO;

typedef class ComboBoxHelper<BondDefGroupEnum::CutOffMode> CMCH;
typedef class ComboBoxHelper<Xf::SceeneUnits> RUCH;

/* ***********************************************************************
 *
 * ***********************************************************************
 */


class BondPolyDlg: public QDialog, private Ui::BondPolyDlg{
  Q_OBJECT;
public:
  BondPolyDlg(QWidget *parent,const char *name,QVariant v);
  ~BondPolyDlg();

  void setData(QVariant v);
  QVariant getData();

signals:
  void haveData();

protected slots:
  virtual void accept();

  void on_pbOK_clicked(){accept();}
  void on_pbCancel_clicked(){QDialog::reject();}
  void on_pbApply_clicked(){ acceptData(); emit haveData();}
  void on_pbHelp_clicked();

protected:
private:
  void acceptData();
private:

  PolyhedronProperties polyprops;
  CMCH *cutoffmodeHelper;
  RUCH *rimRHelper;

  BondDefGroupEnum::CutOffMode pmode;
};


#endif /* _BONDPOLYDLG_HH */

