/* @(#)BondsDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _BONDSDLG_H
#define _BONDSDLG_H 1


#include "ProtoDlg.hh"
#include "ui_BondsDlg.h"
#include "BondDefs.hh"
#include "SReal.hh"




class STDoc;
class QAction;
class BondGroupsModel;
class ColorDelegate;
class BondPrimaryAtomDelegate;
class ToolButtons;

namespace XFPLO{
  class BondDefs;
  class BondDefGroup;
}

using namespace XFPLO;


/* ***********************************************************************
 *
 * ***********************************************************************
 */

class BondsDlg : public ProtoDlg, private Ui::BondsDlg
{
  Q_OBJECT
    
public:
  BondsDlg(QWidget *parent,QWidget *base,const char *name);
  ~BondsDlg();

  void selectSite(long site);


public slots:
  void setData(const STDoc *doc);
  void getData(STDoc *doc,long &chn);


private:
  bool dataAcceptable();
  
  void updateBins();
  void adjustTvGroup();

private slots:

  void onKeys();
  void on_cbTopLevelGrouping_currentIndexChanged(int);
  void on_spbxLevels_valueChanged(int);



  void slotTvGroupButtons();

  
  void on_dspbxBinTol_valueChanged(double);
  void on_tvGroup_clicked(const QModelIndex &index);

  void on_tvGroup_myCurrentChanged(const QModelIndex &currentindex
				   ,const QModelIndex &/*previous*/);



  void on_trvBonds_acceptRequest(){onpbAcceptClicked();}

  void on_tbSetBonds_triggered(QAction *);

private:
  SReal t_ballscale;
  SReal t_stickballratio;

  BondGroupsModel *grmodel;
  ColorDelegate *bondcolordelegate;
  const STDoc  *p_doc;
  BondDefs    *t_bonddefs;
  

  long pcurrentsort;
  bool muteTrvBonds;



  ToolButtons *ptoolbuttons;  
  QList<QAction*> keyactions;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _BONDSDLG_H */

