/*************************************************************************
 * @(#)BoundDlg.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   23 May 2009
 *************************************************************************
 */

#include <QMessageBox>
#include "BoundDlg.hh"
#include "HelpDlg.hh"
#include "Config.hh"



/* ***********************************************************************
 *
 * ***********************************************************************
 */
BoundDlg::BoundDlg(QWidget *parent ,QWidget *base,const char *name)
  : ProtoDlg(parent,base,name)
{
  setupUi(this);
  setUp(pbAccept,pbClose,pbCancel,pbHelp,"BoundaryDialog",": Boundary settings");

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
BoundDlg::~BoundDlg()
{
}



/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool BoundDlg::dataAcceptable()
{ 
  //myDebug() << "BoundDlg::dataAcceptable";
  QString txt=wBoundDlg->dataAcceptable();
  if(txt.length()){
    QMessageBox::warning ( this,IDS_APP_NAME+ " " + FPLOMAINVERSION()
			   , txt, 1, 0,0 ) ;
    //myDebug() << "returning";
    return false;
  }
  return true;

}



/* ***********************************************************************
 *
 * ***********************************************************************
 */
void BoundDlg::setData( const Boundary *bound,const Symmetry *sym)
{
  //  NSF("BoundDlg::setData");
  //  CPR("");
  wBoundDlg->setData(bound,sym,true);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void BoundDlg::getData(Boundary *bound, bool &chn )
{
  //  NSF("BoundDlg::getData");
  //  CPR("");
  wBoundDlg->getData(bound,chn);
}



/*EOF*/ 
