/* @(#)BoundDlgWidget.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _BOUNDDLGWIDGET_H
#define _BOUNDDLGWIDGET_H 1

#include "ui_BoundDlgWidget.h"
#include "ToolButtons.hh"

class Boundary;
class BBoxModel;
class BFacesModel;
class RatValidator;
namespace XFPLO{
  class Symmetry;
}
using namespace XFPLO;

class BoundDlgWidget : public QWidget, private Ui::BoundDlgWidget
{
  Q_OBJECT;
  
public:
  BoundDlgWidget(QWidget *parent);
  ~BoundDlgWidget();

 public slots:
  void setData( const Boundary *,const Symmetry *,bool setfocus);
  void getData(  struct Boundary *,bool &chn);

  QString dataAcceptable();
private:

private slots:
  void on_pbResetD_clicked();
  void on_pbSaveCurrentFaces_clicked();

  void onFWignactionTriggered();
  void onFHexactionTriggered();
  void onFDefaultactionTriggered();
  void onFConvcellactionTriggered();
  void onFPrimcellactionTriggered();
  void onFWSRSConvRECcellactionTriggered();
  void onFUsercellactionTriggered();

  void onCDefaultactionTriggered();
  void onCConvcellactionTriggered();
  void onCPrimcellactionTriggered();


  void switchInterface(bool);

  void slotTblvFacesInsertPressed();
  void slotTblvFacesDeletePressed();
  void slotTblvFacesMoveUpPressed();
  void slotTblvFacesMoveDownPressed();

  void setupCbOriginBasis(bool withbox);

private:
  Boundary *t_bound;
  const Symmetry *t_sym;
  BBoxModel *bbmodel;
  BFacesModel *bfmodel;
  RatValidator *xyzvalid;
  QAction *fhexaction;
  QAction *fwignaction;
  QAction *fdefaultaction;
  QAction *fconvcellaction;
  QAction *fprimcellaction;
  QAction *fWSRSConvRECcellaction;
  QAction *fusercellaction;
  QAction *cdefaultaction;
  QAction *cconvcellaction;
  QAction *cprimcellaction;
  ToolButtons ptoolbuttons;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _BOUNDDLGWIDGET_H */

