/* @(#)CIFImportDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _CIFIMPORTDLG_H
#define _CIFIMPORTDLG_H 1

#include "ProtoDlg.hh"
#include "ui_CIFImportDlg.h"
#include "CIFData.hh"

class STDoc;

class CIFImportDlg : public ProtoDlg, private Ui::CIFImportDlg
{
  Q_OBJECT;
 public:
  CIFImportDlg(QWidget *parent,QWidget *base,const char *name);
  ~CIFImportDlg();

public slots:
  void setData(STDoc *stdoc,const QString &filename="");
  void getData(bool &);
private slots:
  void on_cmbDataBlock_currentIndexChanged(const QString &);
  void on_pbBrowseCIFFile_clicked();
  void on_cbShowFullContent_stateChanged(int);
private:
  void adjustTw(QTableWidget*);
  //void loadTwDictionary();
  void loadTebrCIFContent(const QString &datablockname);
  void loadCFFile(const QString &fname);
  QString allOfSingleSection(const CIF::CIFData::DataBlock *datablock,
			     CIF::CIFMetaDict::DictKey key,
			     const char *valuecolor);
  QString cellSection(const CIF::CIFData::DataBlock *datablock,
		      const char *valuecolor);
  QString symmetrySection(const CIF::CIFData::DataBlock *datablock,
			  const char *valuecolor,
			  const char *tableheadercolor);
  QString atomTableSection(const CIF::CIFData::DataBlock *datablock,
			   const char *valuecolor,
			   const char *tableheadercolor);
  QString allSection(const CIF::CIFData::DataBlock *datablock,
		     const char *valuecolor,
		     const char *tableheadercolor
		  );
  QString genericTable(const CIF::CIFData::DataTable *datatable,
		       const char *valuecolor,const char *tableheadercolor);
  QString genericDataBlock(const CIF::CIFData::DataBlock *datablock,
			   const char *valuecolor,
			   const char *tableheadercolor);



private:
  STDoc *t_stdoc;
  CIF::CIFData  pcifdata;
  CIF::CIFMetaDict pmetadict;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _CIFIMPORTDLG_H */

