/*************************************************************************
 * @(#)CanvasDlg.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   13 Jun 2009
 *************************************************************************
 */

#include <QMessageBox> 
#include "CanvasDlg.hh"
#include "Config.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
CanvasDlg::CanvasDlg(QWidget *parent,const char *name)
  : QDialog(parent)
{
  setObjectName(name);
  setupUi(this);


  setWindowTitle(IDS_APP_NAME + ": Canvas Settings");

  //  setWindowModality ( Qt::WindowModal);

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void CanvasDlg::setData( const CanvasSize &c)
{
  t_c=c;

  spbxWidth->setValue(c.width());
  spbxHeight->setValue(c.height());

  spbxWidth->selectAll();

  cbLocked->setChecked(c.locked());

  spbxWidth->setEnabled(c.locked());
  spbxHeight->setEnabled(c.locked());
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void CanvasDlg::getData( CanvasSize &c)
{
  c.setWidth(spbxWidth->value());
  c.setHeight(spbxHeight->value());
  c.setLocked(cbLocked->isChecked());

  t_c=c;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void CanvasDlg::accept()
{
  QString txt="";

  
  if(txt.length()){
    QMessageBox::warning ( this,IDS_APP_NAME+ " " + FPLOMAINVERSION()
			   , txt, 1, 0,0 ) ;
  }else{
    QDialog::accept();
  }

}


/*EOF*/ 
