/*************************************************************************
 * @(#)ColorButton.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   14 Aug 2009
 *************************************************************************
 */


#include <QColorDialog> 
#include "ColorButton.hh"


ColorButton::ColorButton(QWidget *parent)
  :QToolButton(parent),pcolor(0xff0000),pwithalpha(false)
  ,pchangedoninvoke(true)
{
  QObject::connect(this,SIGNAL(clicked()),this, SLOT(slotColorButton()) );
  //  myDebug() << "ColorButton:: start living"<<this;
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
ColorButton::~ColorButton()
{
  //  myDebug() << "ColorButton:: dying"<<this;
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ColorButton::setColor(QRgb rgb)
{
  QRgb previouscolor=pcolor;
  pcolor=rgb;

  //myDebug()<<"stystyleSheet"<<styleSheet();

  setStyleSheet(QString("ColorButton {\
     /*border-radius: 6px;	      */	\
     background-color: rgb(%1,%2,%3);\
 }\
ColorButton:disabled {\
     /*border-radius: 6px;	      */	\
     background-color: #C6C3BF;\
 }\
").arg(qRed(pcolor)).arg(qGreen(pcolor)).arg(qBlue(pcolor)));
  repaint();
  if(previouscolor!=pcolor || pchangedoninvoke)
    emit colorChanged(pcolor);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ColorButton::slotColorButton()
{
  QColor c(pcolor);
  QRgb pc=pcolor;
  if(pwithalpha) c.setAlpha(qAlpha(pcolor));
  //myDebug("%x",c.rgba());
  if(pwithalpha)
    c=QColorDialog::getColor(c,this,"",QColorDialog::ShowAlphaChannel);
  else
    c=QColorDialog::getColor(c,this,"");
  if(c.isValid()){
    if(pwithalpha){
      pcolor=c.rgba();
      setColor(c.rgba());
    }else{
      pcolor=c.rgb()&0xffffff;
      setColor(c.rgb()&0xffffff);
    }
  }
  repaint();
  if(pcolor!=pc)
    emit colorValueChanged(pcolor);

}


/*EOF*/ 
