/* @(#)ColorButton.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _COLORBUTTON_H
#define _COLORBUTTON_H 1

#include <QToolButton>
#include "MyQRgb.hh"


class ColorButton: public QToolButton
{
  Q_OBJECT
public:
  ColorButton(QWidget *parent);
  ~ColorButton();
  
  void setChangedOnInvoke(bool c){pchangedoninvoke=c;};
  void setWithAlpha(bool w){pwithalpha=w;};
  void setColor(QRgb rgb);
  QRgb color()const {return pcolor;};

 signals:
  void colorChanged(QRgb rgb);
  void colorValueChanged(QRgb rgb);

private slots:

  void slotColorButton();

private:
  QRgb pcolor;
  bool pwithalpha;
  bool pchangedoninvoke;
  
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _COLORBUTTON_H */

