/*************************************************************************
 * @(#)ColorModelEditor.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   20 Jun 2012
 *************************************************************************
 */

#include <QMessageBox>
#include "ColorModelEditor.hh"
#include "ColorMap.hh"
#include "Config.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
ColorModelEditor::ColorModelEditor(QWidget *parent,QWidget *base,
				   const  char *name)
  : BrainDialog(parent,base,name,false)
{
  setupUi(this);
  setWindowTitle(IDS_APP_NAME + ": Color model editor");

  //undolistview->setStack(colorramp->undoStack());
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ColorModelEditor::accept()
{

  QString txt="";



  if(txt.length()){
    QMessageBox::warning ( this,IDS_APP_NAME, txt, 1, 0,0 ) ;
  }else{
    QDialog::accept();
  }  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ColorModelEditor::setData(const ColorMap &map)
{
  
  colorramp->setColorMap(map);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void ColorModelEditor::getData(ColorMap &map)
{
  
  colorramp->getColorMap(map);
}


/*EOF*/ 
