//todo: edit in place
//todo: make data consistency checks

/* @(#)CombiTreeView.hh
 * author: magru@unas
 */

#ifndef _COMBITREEVIEW_HH
#define _COMBITREEVIEW_HH 1

#include <QTreeView>
#include <QPointer>
#include <QHeaderView>
#include <QMessageBox>
#include "CombiModel.hh"
//#include "MyDebug.hh"
#include "ContribDlg.hh"
#include "Config.hh"
#include "MolecularOrbital.hh"
#include "MyVariant.hh"

class MWBase;

// Q_DECLARE_METATYPE(XFPLO::MolecularOrbitalData*)
// Q_DECLARE_METATYPE(XFPLO::MolecularOrbital*)

/* ***********************************************************************
 *
 * ***********************************************************************
 */

class CombiTreeView : public QTreeView
{
  Q_OBJECT;
public:
  // ----------------------------------------------------------------
  CombiTreeView(QWidget *parent=0):QTreeView(parent),contribdlg(0)
  {
    header()->setResizeMode(QHeaderView::ResizeToContents);
    model=new CombiModel(this);
    setModel(model);
  }

  // ----------------------------------------------------------------
  ~CombiTreeView()
  {
      if(model) delete model;
      if(!contribdlg.isNull()) delete contribdlg;contribdlg=0;
  }

  // ----------------------------------------------------------------
  void setBase(MWBase *b){base=b;};

  // ----------------------------------------------------------------
  void resetModel(MolecularOrbitals *mos=0,const CoeffBasisInfo *cbi=0)
  {
    if(cbi) pcbi=cbi;
    emit contribsValid(false);
    model->resetModel(mos,cbi);


    // if(false){
    //   long rc=model->rowCount(QModelIndex());
    //   qDebug()<<"rowcount="<<rc<<mos->size();;
    //   for(int imo=-1;++imo<model->rowCount(QModelIndex());){
    // 	QModelIndex index=model->index(imo,0,QModelIndex());
    // 	qDebug()<<"  "<<imo<<index<<index.internalPointer()<<mos;
    // 	qDebug()<<"   #children="<<(*mos)[imo]->numOfContribs();
    // 	qDebug()<<"   mo="<<(*mos)[imo];
    // 	qDebug()<<"   parent="<<model->parent(index);
    // 	for(int imd=-1;++imd<model->rowCount(index);){
    // 	  QModelIndex index1=model->index(imd,0,index);
    // 	  qDebug()<<"    "<<imd<<index1<<index1.internalPointer()<<(*mos)[imo];
    // 	  qDebug()<<"     parent="<<model->parent(index1);
    // 	  qDebug()<<"     #children="<<model->rowCount(index1);
    // 	  if(model->parent(index1)!=index){
    // 	    qDebug()<<"level 2 parent!=index";
    // 	    exit(1);
    // 	  }
    // 	}
	
    //   }
      
    //   if(rc) exit(1);
    // }
    expandToDepth(1);
    setCurrentIndex(model->index(0,0,QModelIndex()));
    // for(int icol=0;icol<model->columnCount();icol++)
    //   resizeColumnToContents(icol);
  }

signals:
  void contribsValid(bool);
  void enableBase(bool);


public slots:

  // ----------------------------------------------------------------
  void onActions(int code)
  {
    
    if(code == 0){

      setFocus();
      MolecularOrbitalData *md=new MolecularOrbitalData();
      onContribDlgTalkBack(ProtoDlg::Create,code,false,0,md);


    }else if(code == 1){

      setFocus();
      MolecularOrbital *mo=new MolecularOrbital("new");

      onContribDlgTalkBack(ProtoDlg::Create,code,false,mo,0);

    }else if(code == 2){
      
      setFocus();
      MolecularOrbitalData *md=new MolecularOrbitalData();
      md->setOrbital("1s+0");
      
      onContribDlgTalkBack(ProtoDlg::Create,code,false,0,md);

    }else if(code == 3){
      QModelIndex index=currentIndex();
      if(index ==  QModelIndex()){
	QMessageBox::warning ( this,IDS_APP_NAME, "Select an item first."
			       , 1, 0,0 );
	return;
      }

      model->removeRow(index);
      setFocus();      
    }else if(code == 4 || code==5){
      QModelIndex index=currentIndex();
      if(index ==  QModelIndex()){
	QMessageBox::warning ( this,IDS_APP_NAME, "Select an item first.", 1, 0,0 );
	return;
      }
      
      int by=-1;
      if(code==5) by=1;

      index=model->moveRow(index,by);
      if(index.isValid()){
	expandToDepth(1);
       	setCurrentIndex(index);
	scrollTo(index);
      }
      setFocus();     
    }else if(code==6){
      QModelIndex index=currentIndex();
      if(index ==  QModelIndex()){
	QMessageBox::warning ( this,IDS_APP_NAME, "Select an item first.", 1, 0,0 );
	return;
      }
      index=model->copyRow(index);
      if(index.isValid()){
	expandToDepth(1);
       	setCurrentIndex(index);
	scrollTo(index);
      }
      setFocus();    
    }
  }


protected slots:
  // ----------------------------------------------------------------
  void currentChanged(const QModelIndex &current,const QModelIndex &previous)
  {
    Q_UNUSED(previous);
    MolecularOrbital *mo=model->molOrb(current);
    if(mo && mo->isMolecular()){
      emit contribsValid(true);
    }else{
      emit contribsValid(false);
    }
  }
  


private slots:

  // ----------------------------------------------------------------
  void onContribDlgTalkBack(int mode=ProtoDlg::Create,int code=0,
			    bool editexisting=false,
			    MolecularOrbital *mo=0,
			    MolecularOrbitalData *md=0)
  {
    if(mode==ProtoDlg::Create){
      if(!contribdlg.isNull()) {
	contribdlg->activateWindow();
	contribdlg->raise();
	return;
      }
      
      emit enableBase(false);

      contribdlg=new ContribDlg(this,(QWidget*)base,"ContribDlg",code,editexisting);
      connect(contribdlg,SIGNAL(talkBack(int)),
	      this,SLOT(onContribDlgTalkBack(int)));

      contribdlg->setData(pcbi,mo,md);

      contribdlg->show();



    }else if(mode==ProtoDlg::Refresh){
    }else if(mode==ProtoDlg::End){
      emit enableBase(true);
      setFocus();
    }else if(mode==ProtoDlg::Accept){
      if(contribdlg.isNull()) return;
      // IMPORTANT: when we are here only the mode argument exists, since we got called
      // by callback
      mo=0;
      md=0;
      code=contribdlg->getData(mo,md,editexisting);
      

      QModelIndex index=currentIndex();
      if(editexisting){
	if(code==0||code==2){
	  model->setData(index,toQVariant(md),Qt::EditRole);
	}else if(code==1){
	  model->setData(index,toQVariant(mo),Qt::EditRole);
	}
      }else{
	if(code==0){
	  index=model->insertRow(index,new MolecularOrbital(md));
	}else if(code==1){
	  index=model->insertRow(index,mo);
	}else if(code==2){
	  index=model->insertRow(index,md);
	}
	if(index.isValid()){
	  setCurrentIndex(index);
	  // for(int c=-1;++c<model->columnCount(index);){
	  //   selectionModel()->select(model->index(index.row(),c,index.parent()),
	  // 			     QItemSelectionModel::Select);
	  // }
	  scrollTo(index);
	}
      }
      expandToDepth(1);

      emit enableBase(true);
      
      setFocus();
      activateWindow();
      qApp->processEvents();
      qApp->flush();

    }

  }

protected:
  // ----------------------------------------------------------------
  virtual bool event(QEvent *e)
  {
    if(e->type()==QEvent::KeyPress){
      QKeyEvent *k=(QKeyEvent*)e;
      QString key=k->text();
      if((k->key()==Qt::Key_F2) 
	 || (k->key()==Qt::Key_Space) 
	 || (k->key()==Qt::Key_Enter)
	 || (k->key()==Qt::Key_Return)
	 ){
	editDialog();
	return true;
      } //if right key
    }// if e->type
    return QTreeView::event(e);

  }

  // ----------------------------------------------------------------
   virtual void mouseDoubleClickEvent(QMouseEvent *m)
   {
     if(m->button()==Qt::LeftButton){
       editDialog();
       return;
     }
     QTreeView::mouseDoubleClickEvent(m);
   }
  
private:  
  
  // ----------------------------------------------------------------
  void editDialog()
  {
    QModelIndex index=currentIndex();
    if(index.isValid()){
      MolecularOrbital *mo=model->molOrb(index);
      if(model->isTopLevelItem(index)){
	if(mo->isMolecular()){
	  onContribDlgTalkBack(ProtoDlg::Create,1,true,mo,0);
	}else{
	  onContribDlgTalkBack(ProtoDlg::Create,0,true,0,(*mo)[0]);
	}
      }else{
	onContribDlgTalkBack(ProtoDlg::Create,2,true,0,(*mo)[index.row()]);
      }
    }
  }
  

  
private:
  CombiModel *model;
  const CoeffBasisInfo *pcbi;
  QPointer<ContribDlg> contribdlg;
  MWBase *base;
};


#endif /* _COMBITREEVIEW_HH */

