/* @(#)ComboBoxHelper.hh
 * author: magru@unas
 */

#ifndef _COMBOBOXHELPER_HH
#define _COMBOBOXHELPER_HH 1

#include <QComboBox>
#include "ValueArray.hh"
#include "Pair.hh"
#include "FString.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */

template <class X>
class ComboBoxHelper
{
public:
  
  typedef Pair<X,const char *> Type;

  // ----------------------------------------------------------------
  ComboBoxHelper(QComboBox *cmb,const ValueArray<Type> &content)
    :pcmb(cmb),pcontent(content)
  {
  }
  
  // ----------------------------------------------------------------
  ComboBoxHelper(QComboBox *cmb,const ValueArray<Type> &content,
		 const ValueArray<String> &icons)
    :pcmb(cmb),pcontent(content),picons(icons)
  {
  }
  
  // ----------------------------------------------------------------
  void populate()
  {
    pcmb->clear();
    for(int i=-1;++i<pcontent.size();){
      if(picons.size()>0){
	pcmb->insertItem(i,QIcon(picons.at(i)()),pcontent.at(i).v2,pcontent.at(i).v1);
      }else{
	pcmb->insertItem(i,pcontent.at(i).v2,pcontent.at(i).v1);
      }
    }
  }

  // ----------------------------------------------------------------
  inline void setIndexFromData(X data)
  {
    pcmb->setCurrentIndex(pcontent.indexOf(makePair<X,const char*>(data,"")));

  }

  // ----------------------------------------------------------------
  inline X data()
  {
    return (X)(pcmb->itemData(pcmb->currentIndex(),Qt::UserRole).toInt());
  }

private:
  QComboBox *pcmb;
  const ValueArray<Type> pcontent;
  const ValueArray<String> picons;
  
};


// ----------------------------------------------------------------
template<>
inline QString ComboBoxHelper<QString>::data()
{
  return (pcmb->itemData(pcmb->currentIndex(),Qt::UserRole).toString());
}


#endif /* _COMBOBOXHELPER_HH */

