/* @(#)ContribDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _CONTRIBDLG_H
#define _CONTRIBDLG_H 1

#include "ProtoDlg.hh"
#include "ui_ContribDlg.h"
#include "Vec3.hh"

namespace XFPLO{
  class CoeffBasisInfo;
  class MolecularOrbital;
  class MolecularOrbitalData;
}
class QCompleter;
class Cmplx;
class String;

using namespace XFPLO;

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class ContribDlg: public ProtoDlg,private Ui::ContribDlg
{
  Q_OBJECT
public:
  ContribDlg(QWidget *parent,QWidget *base,const char *name
	     ,int code,bool editexisting);
  ~ContribDlg();

  void setData(const CoeffBasisInfo *cbi,MolecularOrbital *mo,
	       MolecularOrbitalData *md);

  int getData(MolecularOrbital *&mo,MolecularOrbitalData *&md,
	      bool &editexisting);



protected slots:
   virtual void reject(){ 
     if(!piswaiting)
       emit talkBack(End); 
     else{
       waitMode(false);
     }
   };

private slots: 
  void on_cmbSite_currentIndexChanged(int siteindex);
  void on_pbGetAtom_clicked();
  void on_pbGetPosition_clicked();
  void onDataAvailable(QObject *sender,const QObject *,const QString &
   		       ,const void*);
  void onLedPageTextEdited(const QString &text);

private:
  bool setLedPageText(bool betight);
  bool dataAcceptable();
  void waitMode(bool on);
  void checkData();
  void makeCompleter();

private:
  const CoeffBasisInfo *pcbi;
  int pcode;
  bool piswaiting;
  Vec3 x,z;
  QCompleter *orbcompleter;
  bool pfrel;
  MolecularOrbital *pmo;
  MolecularOrbitalData *pmd;
  bool peditexisting;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _CONTRIBDLG_H */

