/* @(#)ExecPathDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _EXECPATHDLG_H
#define _EXECPATHDLG_H 1

#include <QStyledItemDelegate>
#include <QLineEdit>
#include "ui_ExecPathDlg.h"
#include "ToolButtons.hh"

class QSignalMapper;
class QMenu;
class Fplo;
class ExecPathDelegate;


/* ***********************************************************************
 *
 * ***********************************************************************
 */

class ButtonedLineEdit: public QWidget
{
  Q_OBJECT;
 public:
  ButtonedLineEdit(QWidget *parent=0);
  ~ButtonedLineEdit();
  QString text()const{return ple->text();};
  void setText(const QString & t){ple->setText(t);};
 signals:
  void editingFinished();
 private:
  QPushButton *pb;
  QLineEdit *ple;
  QHBoxLayout *horizontalLayout;

};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class ExecPathDelegate: public QStyledItemDelegate
{
  Q_OBJECT
    public:
  ExecPathDelegate(QWidget *parent=0):QStyledItemDelegate(parent){};
    void paint(QPainter *painter, const QStyleOptionViewItem &option,
	       const QModelIndex &index) const;
    void updateEditorGeometry(QWidget *editor,
			      const QStyleOptionViewItem &option
			      ,const QModelIndex &index) const;
    QSize sizeHint(const QStyleOptionViewItem &option,
		   const QModelIndex &index) const;
    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
			  const QModelIndex &index) const;
    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
		      const QModelIndex &index) const;
    private slots:
    void commitAndCloseEditor();
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class ExecPathDlg: public QDialog, private Ui::ExecPathDlg
{
Q_OBJECT
 public:
  ExecPathDlg(QWidget *parent,Fplo *fplo);
  ~ExecPathDlg();

private slots:
  void on_pbOK_clicked();
  void on_pbCancel_clicked(){QDialog::reject();};
  void on_pbHelp_clicked();

  void onTbInsertClicked();
  void onTbDeleteClicked();
  void onTbMoveClicked();

  void on_twPatterns_cellClicked(int,int);

  void slotInsertPattern(int);

private:
  void adjustTwPatterns();

private:
  ToolButtons ptoolbuttons;
  QMenu *insertMenu;
  QSignalMapper *signalMapper;
  Fplo *pfplo;
  ExecPathDelegate *delegate;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _EXECPATHDLG_H */

