/* @(#)FSSweepDialog.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _FSSWEEPDIALOG_H
#define _FSSWEEPDIALOG_H 1

#include "ui_FSSweepDialog.h"
#include "ProtoDlg.hh"

class Energies;

class FSSweepDialog: public ProtoDlg, private Ui::FSSweepDialog
{
  Q_OBJECT
public:
  FSSweepDialog(QWidget *parent,QWidget *base,const char *name);
  ~FSSweepDialog();

  void saveData(const Energies &erg);
  void restoreData(Energies &erg);

signals:
  void currentValueChanged(double);



private slots:

  void on_tbBack_clicked();
  void on_tbForward_clicked();
  void on_tbStep_clicked();
  void on_tbStart_clicked();
  void on_dspbxCurrent_valueChanged(double);
  void on_dspbxMin_valueChanged(double);
  void on_dspbxMax_valueChanged(double);


 private:
  bool pcurrentUseDefault;
  double pcurrentEF;
  QVector<long> pcurrentbands[2];

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _FSSWEEPDIALOG_H */

