/* @(#)FermiDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _FERMIDLG_H
#define _FERMIDLG_H 1

#include <QGroupBox>
#include "ui_FermiDlg.h"
#include "Vlevel.hh"

class QWidget;
class QMainWindow;
class Energies;

class FermiDlg : public BrainDialog, private Ui::FermiDlg
{
  Q_OBJECT
    
public:
  FermiDlg(QWidget *parent,QWidget *base,const  char *name);
    

 public slots:
  void setData( Energies * erg ,const Vlevel &vlevel);
  void getData( Energies * erg );

 protected slots:
  virtual void accept() ;
  virtual void reject() { BrainDialog::reject(); };

 private slots:
  void on_leFermi_textChanged(const QString &) { t_efchn=true; };
  void on_pbOK_clicked(){accept();};
  void on_pbCancel_clicked() {reject();};
  void on_updatePB_clicked();
  void on_cbDefEf_clicked();
  //


 private:
  void makeButtonList(QGroupBox *bg
		      ,long nmin,long nmax,const QVector<long> &bands);
  void readButtonList(QGroupBox *bg,QVector<long> &bands);
  void cleanGroupBox(QGroupBox *gbx);
  long countCheckBoxes(QGroupBox *gbx);

 private:
  QString t_ef;
  long t_defef,t_emptyl;
  bool t_efchn;
  QVector<long> t_bands[2];
  Energies *t_erg;
  Vlevel t_vlevel;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _FERMIDLG_H */

