/* @(#)FindAtomDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _FINDATOMDLG_H
#define _FINDATOMDLG_H 1

#include "ui_FindAtomDlg.h"
#include "Xf.hh"

class QButtonGroup;
namespace XFPLO{
  class Atom;
}
class AtomMarkerProperties;
class AtomFindMarker;

class FindAtomDlg : public ProtoDlg, private Ui::FindAtomDlg
{
  Q_OBJECT
public:
  FindAtomDlg(QWidget *parent,QWidget *base,const char *name
	      ,AtomFindMarker *atomFindMarker);
  ~FindAtomDlg();

  void setData();
  void updateData(const XFPLO::Atom &at);
  void getData(Xf::FindAtomModes &mode,long &number);

  void setMessage(const QString &msg);


private slots:

  void onRbToggled(bool );
  void on_spbxSite_valueChanged(int);

private:
  void apply();

private:
  QButtonGroup *rbbg;
  AtomFindMarker *patomfindmarker;
  bool mute_apply;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _FINDATOMDLG_H */

