/* @(#)FploDlg.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _FPLODLG_H
#define _FPLODLG_H 1

#include <QDialog>
#include <QProcess>
#include <QFile>
#include "ui_FploDlg.h"

class Fplo;

/* ***********************************************************************
 *
 * ***********************************************************************
 */

class FploDlg: public QDialog, private Ui::FploDlg
{
Q_OBJECT
public:
  FploDlg(QWidget *parent,Fplo *fplo);
  ~FploDlg();
  
  bool didRun()const{return pdidrun;};
  
private slots:

  void on_pbRun_clicked();
  void on_pbKill_clicked();
  void on_pbManageExecs_clicked();
  void onProcStarted();
  void onProcError(QProcess::ProcessError error);
  void onProcFinished(int exitCode,QProcess::ExitStatus exitStatus);
  void onProcReadFromStdout();
  void ptimerTimout();
  void readFromTsOut();

protected:
  virtual void accept();
  virtual void reject(){accept();};

private:
  void populateCmbFploExec();

private:
  QProcess *proc;
  QString pprogram;
  QString ptxtStdout;
  QTimer *ptimer;
  QFile *outFile;
  QTextStream *tsout;
  long refreshtime;
  Fplo *pfplo;
  bool pdidrun;
  bool pkilleractive;
  static QMap<QString,QString> ppreviousprograms;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _FPLODLG_H */

