/* @(#)LightDlg.hh
 * author: magru@unas
 */

#ifndef _LIGHTDLG_HH
#define _LIGHTDLG_HH 1

#include "ProtoDlg.hh"
#include "ui_LightDlg.h"
#include "Light.hh"
#include "ComboBoxHelper.hh"

class QSignalMapper;

using namespace XFPLO;

class DocBase;
class LightsModel;
class ToolButtons;
class OGLView;
typedef class ComboBoxHelper<Lights::LightTypes> LTCH;

/* ***********************************************************************
 *
 * ***********************************************************************
 */

class LightDlg : public ProtoDlg, private Ui::LightDlg
{
  Q_OBJECT;
 public:
  LightDlg(QWidget *parent,QWidget *base,const char *name);
  virtual ~LightDlg();

signals:
  void showLightHelpersToggled(bool);

public slots:
  void setData(DocBase *stdoc,OGLView *oglview);
  void getData(DocBase *stdoc);
private slots:
  void onLvLightstoolButtons();
  void onAddSignalMapper(int);
  void on_lvLights_currentItemChanged(const QModelIndex &current
				      ,const QModelIndex &previous);
  void onContentChanged(QObject* sender);
  void on_tbDefault_clicked();
  void on_tbSaveTheme_clicked();
  void on_tbLoadTheme_clicked();
  void onModeldataChanged(const QModelIndex&,const QModelIndex&);
private:
  void setLights();
  void setLightTypeEnabled();;
private:
  Lights *t_lights;
  DocBase *pdoc;
  LightsModel *lightsmodel;
  ToolButtons *ptoolbuttons;
  LTCH *typeHelper;
  bool mute,mutetalkback;
  OGLView *poglview;
  bool pcontinuous;
  QMenu *insertMenu;
  QSignalMapper *signalMapper;
};

#endif /* _LIGHTDLG_HH */

