/* @(#)MapAtomsDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _MAPATOMSDLG_H
#define _MAPATOMSDLG_H 1

#include <QPointer>
#include "FString.hh"
#include "ui_MapAtomsDlg.h"

class STR;
class STDoc;
class AtomMarkerProperties;

class MapAtomsDlg : public ProtoDlg, private Ui::MapAtomsDlg
{
  Q_OBJECT
public:
  MapAtomsDlg(QWidget *parent,QWidget *base,const char *name);
  ~MapAtomsDlg();

  void setData(AtomMarkerProperties &amp);

  void selectSite(long);
  

  bool dataAcceptable();

private slots:
  void on_pbSave_clicked();
  void on_pbLoad_clicked();
  void on_pbLoadSiteList_clicked();
  void on_tbClearOldSite_clicked();
  void on_twMap_currentCellChanged(int,int);
  void onDataAvailable(QObject *sender,const QObject *,const QString&
		       ,const void*);
  void on_pbCopyThisAtom_clicked();
  void on_pbOpenOldStructure_clicked();
  void on_pbHide_toggled();


private: 
  class MapData{
  public:
    MapData(long si=-1,long so=-1,const String &e="??",const QString &f="")
      :site(si),sort(so),el(e),file(f){};
    long site;
    long sort;
    String el;
    QString file;
  };

private:
  void load_twMap();
  void setOldSiteItemText(QTableWidgetItem *item,
			  QTableWidgetItem *itemf,
			  const MapData &md);

  bool rejectable(){return dataAcceptable();}

private: 
  bool pchanged;
  bool pisnew;
  const STDoc *p_doc;
  QStringList headers;
  STR *pstr;
  QPointer<STR> poldstr;
  QMap<long,MapData> pmapdata;
  QString pcurrentstrfile;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _MAPATOMSDLG_H */

