/* @(#)MeshSymDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _MESHSYMDLG_H
#define _MESHSYMDLG_H 1

#include "ui_MeshSymDlg.h"

class MeshSymmetry;
class QWidget;

class MeshSymDlg : public BrainDialog, private Ui::MeshSymDlg
{
  Q_OBJECT
public:

  MeshSymDlg(QWidget *parent,QWidget *base,const  char *name);

 public slots:
  void setData(const MeshSymmetry * meshsym);
  void getData(MeshSymmetry * meshsym);

 protected slots:
  virtual void accept() ;
  virtual void reject() { BrainDialog::reject(); };

 private slots:
  void on_pbOK_clicked(){accept();};
  void on_pbCancel_clicked() {reject();};
  void on_pbAdd_clicked();
  void on_pbTake_clicked();
  void on_pbDelete_clicked();
  void on_liwiOps_currentRowChanged(int);

 private:
  bool t_handmade;
  bool t_hex;
  bool t_rtg;
  long t_bravais;
  bool changed;
  QString t_C[3][3];
  QLineEdit *lesC[3][3];
  QLineEdit *lesOp[3][3];
  
  class SymOp
  {
  public:
    SymOp(QString s,QString o[3][3]):symbol(s){
      for(int c=0;c<3;c++){
	for(int r=0;r<3;r++){
	  op[r][c]=o[r][c];
	}
      }
    };
    QString printQ()const{
      QString s=symbol+" [";
      for(int r=0;r<3;r++){
	s+=QString("[%1,%2,%3]").arg(op[r][0]).arg(op[r][1]).arg(op[r][2]);
	if(r<2) s+=",";
      }
      s+="]";
      return s;
    };
    QString symbol;
    QString op[3][3];
  };

  QList<SymOp> symops;
  
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _MESHSYMDLG_H */

