/* @(#)MyGroupBox.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _MYGROUPBOX_H
#define _MYGROUPBOX_H 1

#include <QWidget>
#include <QCheckBox>
#include <QVBoxLayout>

/* ***********************************************************************
 * make my own group box, since the QT one does not align as I want
 * ***********************************************************************
 */

class MyGroupBox: public QWidget
{
  Q_OBJECT
 public:
  MyGroupBox(QWidget *parent,const QString &title)
    :QWidget(parent),cb(0),myLayout(0),pcheckingenables(true){
    mainVLayout=new QVBoxLayout(this);
    mainVLayout->setObjectName("mainVLayout");
    mainVLayout->setContentsMargins(0,0,0,0);
    //mainVLayout->setMinimumSize(0,0);
    QHBoxLayout *hl=new QHBoxLayout();
    hl->setObjectName("hl");
    mainVLayout->addLayout(hl);

    cb=new QCheckBox(this);
    cb->setText(title);
    cb->setObjectName("internal_control_cb");
    cb->setChecked(true);
    QFont f=cb->font();
    f.setWeight(QFont::Bold);
    cb->setFont(f);
    hl->addWidget(cb);
    
    connect(cb,SIGNAL(stateChanged(int)),
	    this,SLOT(onCbStateChanged(int)));

    /*     setStyleSheet(Sprintf("background-color: rgb(%d, %d, %d);", */
    /* 			  qRed(background),qGreen(background), */
    /* 			  qBlue(background))()); */
  };
  ~MyGroupBox(){
    //if(cb) delete cb; cb=0;
    //todo delete all;
    deleteChildren(this);
    //if(mainVLayout) delete mainVLayout;
  };

  void addLayout(QLayout *l){
    myLayout=l;
    mainVLayout->addLayout(l);
  };
  
  void setChecked(bool c){cb->setChecked(c);onCbStateChanged(c);};
  
  void setCheckingEnables(){pcheckingenables=true;};
  void setCheckingDisables(){pcheckingenables=false;};
  
 signals:
    void stateChanged(int state);

 private slots:
  void onCbStateChanged(int state){
    foreach(QObject *o,this->children()){
      if(o->isWidgetType() && o->objectName() != "internal_control_cb"){
	QWidget *w=((QWidget*)o);
	if(pcheckingenables)
	  w->setEnabled(state);
	else
	  w->setDisabled(state);
      }
    }
    emit stateChanged(state);
  };
 private:

  void deleteChildren(QObject *parent){
    if(!parent) return;
    foreach(QObject *o,parent->children()){
      //myDebug()<<"delete "<<QString(o->metaObject()->className())<<o->objectName();
      deleteChildren(o);
      delete o;
    }
    
  };
 private:

  QCheckBox *cb;
  QVBoxLayout *mainVLayout;
  QLayout *myLayout;
  bool pcheckingenables;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _MYGROUPBOX_H */

