/* @(#)Propview.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _PROPVIEW_H
#define _PROPVIEW_H 1

#include "MyQRgb.hh"
#include "ui_PropView.h"
#include "AtomPropPicker.hh"

class STDoc;
class OGLView;
class Vec3;


/* ***********************************************************************
 *
 * ***********************************************************************
 */
class PropViewFilter: public QObject
{
  Q_OBJECT
    public: 
  PropViewFilter():QObject(){};
    ~PropViewFilter(){};
 protected:
    virtual bool eventFilter(QObject *object, QEvent *event);
    
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class PropView:public QWidget, private Ui::PropView
{
  Q_OBJECT
public:
  PropView(QWidget *parent,STDoc *doc,OGLView *oglview);
  ~PropView();
  void fullReset();
  void toggleVisiblity();



signals:
/*   void escapePressed(); */
/*   void mPressed(); */

protected:
  virtual void closeEvent(QCloseEvent *e);
  //  void keyPressEvent(QKeyEvent *event);

private slots:
  void onAtomPropPickerChanged();
  void on_pbHelp_clicked();
  void on_cmbUnits_currentIndexChanged(int index);
  void on_pbClear_clicked();
  void on_pbSave_clicked();
private:

  void reset();
  void loadIcon(QRgb rgb);
  void applyUnits(Vec3 &v,QString &unit);
private:
  const STDoc *doc;
  OGLView *oglview;
  AtomPropPicker ppicker;
  static const char *header;
  static const char *footer;
  static const char *tablerow;
  static const char *tablerowdif;
  static const char *distrow;
  static const char *anglerow;


  PropViewFilter *filter;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _PROPVIEW_H */

