/* @(#)ProtoDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _PROTODLG_H
#define _PROTODLG_H 1

#include <stdio.h>
#include <QCloseEvent>
#include "BrainDialog.hh"

class ProtoDlg: public BrainDialog
{
  Q_OBJECT
public:

  enum TalkMode{End=0,Create=1,Accept=2,Refresh=3};

  ProtoDlg(QWidget *parent,QWidget *base,const char *name,bool stayontop=false);
  ~ProtoDlg();


public slots:
signals:
  void talkBack(int);
  void contentChanged();
  void contentChanged(QObject *);
protected slots:
  virtual void reject(){ if(rejectable()) {emit talkBack(End);} };

protected:
  virtual void closeEvent( QCloseEvent * e ) {e->accept(); 
    emit talkBack(End);};
  void setUp(QPushButton *pbAccept,QPushButton *pbClose,
	     QPushButton *pbCancel,QPushButton *pbHelp,
	     const QString &helpchapter,
	     const QString &title);

  virtual bool dataAcceptable(){return dataAcceptable("");};
  bool dataAcceptable(const QString&txt);
  virtual void connectChanged(QObject *,QList<QObject *>exceptlist=
			      QList<QObject*>());

  virtual void afterAcceptAction(){}
  virtual bool rejectable(){return true;}

protected slots:
  void onpbHelpClicked();
  void onpbAcceptClicked();
  void onpbCloseClicked();
  void onDlgEnd(int mode){if(mode==End){hide();deleteLater();}};

  void onContentChanged(){
    if(!mutecontentchanged) {
      emit contentChanged(sender());
    }
  }


protected:
  bool mutecontentchanged;
private:
  QString phelpchapter;
  bool pconnected;

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _PROTODLG_H */

