/*************************************************************************
 * @(#)RealDlg.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   08 Apr 2011
 *************************************************************************
 */

#include <QMessageBox> 
#include "Except.hh"
#include "RealDlg.hh"
#include "Config.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
RealDlg::RealDlg(QWidget *parent)
  :QDialog(parent)
{
  setupUi(this);
  setWindowTitle(IDS_APP_NAME);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
double RealDlg::getReal(double value,QWidget *parent,const QString &text)
{
  RealDlg *dlg=new RealDlg(parent);
  dlg->lblValue->setText(text);
  dlg->leValue->setText(QString("%1").arg(value));
  long ret=dlg->exec();
  if(ret){
    return dlg->value;
  }
  return value;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void RealDlg::accept()
{
  String s(leValue->text());
  try{
    value=s.convertToFortranReal();
    QDialog::accept();
  }catch(Except &ex){
    QMessageBox::warning ( this,IDS_APP_NAME, "Not a real number."
			   ,QMessageBox::Ok );

    value=0;
  }
}



/*EOF*/ 
