/*************************************************************************
 * @(#)STToolBox.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   06 Jul 2009
 *************************************************************************
 */
#include <QMenu>
#include "STR.hh"
#include "STDoc.hh"
#include "Symmetry.hh"
#include "STToolBox.hh"
#include "Status.hh"
#include "Settings.hh"
#include "MyDebug.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
STToolBox::STToolBox(STR *parent,STDoc *d)
  :ToolBox(parent,d),str(parent),doc(d)
{
  setupUi(this);

  prbPersp=rbPersp;
  prbOrtho=rbOrtho;
  ptbResetCamera=tbResetCamera;
  ptbCamSaveLoad=tbCamSaveLoad;
  ptbCart=tbCart;
  ptbConv=tbConv;
  ptbPrim=tbPrim;
  ptbXYView=tbXYView;
  ptbYXView=tbYXView;
  ptbXZView=tbXZView;
  ptbZXView=tbZXView;
  ptbYZView=tbYZView;
  ptbZYView=tbZYView;
  ptbXYZView=tbXYZView;
  ptbWireFrame=tbWireFrame;
  ptbBoundOnRotate=tbBoundOnRotate;
  ptbAA=tbAA;
  ptbBoundCell=tbBoundCell;
  ptbPrimCell=tbPrimCell;
  ptbConvCell=tbConvCell;
  pdspbxEye=dspbxEye;

  ToolBox::init();


  connect(tbShowHideAtoms,SIGNAL(toggled(bool))
	  ,this,SLOT(onTbShowHideAtomsToggled(bool)));

  
  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
STToolBox::~STToolBox()
{
  //  myDebug() << "~STToolBox";
}






/* ***********************************************************************
 *
 * ***********************************************************************
 */
void STToolBox::onTbShowHideAtomsToggled(bool on)
{
  //myDebug("onTbShowHideAtomsToggled %d\n",onoff);
  if(!str) return;
  Settings set("structure");
  set.set("Atoms/ShowHidden",on);
  str->oglView()->toggleHiddenAtoms(doc,on);
  str->oglView()->doRendering();
  
  
}










/* ***********************************************************************
 *
 * ***********************************************************************
 */
void STToolBox::updateToolBox()
{
  myDebug() << "STToolBox::updateToolBox";

  if(!str) return;
  if(!doc) return;


  ToolBox::updateToolBox();


  
  
//   tbShowLegend->setChecked(doc->pstate.pvelolegend);
//   tbShowLegendUnits->setChecked(doc->pstate.pvelolegunit);





//   tbNormals->setChecked(doc->pstate.pusenormals);

//   tbShowHideFermiSurface->setChecked(doc->pstate.pfermi);

//   tbSubDiv->setChecked(doc->pstate.pusesubdivs);

//   tbSpecPoi->setChecked(doc->pstate.pspecpoi);
  
  
  Settings set("structure");
  tbShowHideAtoms->setChecked(set.getBool("Atoms/ShowHidden",false));


  setMuted(false);

  
}

