/*************************************************************************
 * @(#)SetTypeDlg.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   15 Mar 2011
 *************************************************************************
 */

#include "SetTypeDlg.hh"
#include "Config.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
SetTypeDlg::SetTypeDlg(QWidget *parent,const QMap<QString,int> &map)
  :QDialog(parent)
{
  setupUi(this);
  setWindowTitle(IDS_APP_NAME  + ": Set element type");

  QStringList headers;
  headers << "Element" << "Type" ;
  tblwElementType->setColumnCount(headers.count());
  tblwElementType->setHorizontalHeaderLabels(headers);



  tblwElementType->setRowCount(map.size());
  //  tblwElementType->setItemDelegateForColumn(0,);

  int row=0;
  foreach(QString s,map.keys()){
    //myDebug()<<s<<map[s];
    QTableWidgetItem *item;
    item=tblwElementType->item(row,0);
    if(!item) tblwElementType->setItem(row,0,item=new QTableWidgetItem(""));
    item->setFlags(Qt::ItemIsSelectable|Qt::ItemIsEnabled);
    item->setText(s);
    item->setData(Qt::UserRole,s);

    item=tblwElementType->item(row,1);
    if(!item) tblwElementType->setItem(row,1,item=new QTableWidgetItem(""));
    item->setFlags(Qt::ItemIsSelectable|Qt::ItemIsEnabled|Qt::ItemIsEditable);
    item->setData(Qt::UserRole,map[s]);
    item->setData(Qt::DisplayRole,map[s]);


    row++;
  }
  long r=0;
  tblwElementType->setCurrentCell(r,1,QItemSelectionModel::Select);
  tblwElementType->setRangeSelected(QTableWidgetSelectionRange(r,0,r,1),true);


  int rows=tblwElementType->rowCount();
  for(int irow=0;irow<rows;irow++)
    tblwElementType->resizeRowToContents(irow);
  int cols=tblwElementType->columnCount();
  for(int icol=0;icol<cols;icol++)
    tblwElementType->resizeColumnToContents(icol);

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
QMap<QString,int> SetTypeDlg::getData()
{
  QMap<QString,int> map;
  int rows=tblwElementType->rowCount();
  for(int row=0;row<rows;row++){
    map[tblwElementType->item(row,0)->text()]=
      tblwElementType->item(row,1)->data(Qt::DisplayRole).toInt();
  }
  return map;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void SetTypeDlg::on_tblwElementType_currentCellChanged(int row,int col)
{
  if(col==0){
    tblwElementType->setCurrentCell(row,1);
  }
}


/*EOF*/ 
