/* @(#)SettingsDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SETTINGSDLG_H
#define _SETTINGSDLG_H 1

#include <QPointer>
#include "ui_SettingsDlg.h"
#include "Sheet.hh"

class SettingsDlg : public BrainDialog, private Ui::SettingsDlg
{
  Q_OBJECT;


public:
  SettingsDlg(QWidget *parent,QWidget *base,const char *name);
  ~SettingsDlg();


protected slots:
  virtual void reject(){ BrainDialog::reject(); };

private slots:  
  void on_pbClose_clicked();
  void on_pbSave_clicked();
  void on_lwGroup_currentItemChanged(QListWidgetItem *current
				     ,QListWidgetItem *previous);
  void on_pbHelp_clicked();
  void onSheetHasChanged();

private:
  void setSheet(QListWidgetItem *current);
  void setButtonState(bool saved);

private:

  class Group{
  public:
    Group(const QString &n,Sheet *tw):name(n),sheet(tw){
      sheet->setVisible(false);};
    QString name;
    QPointer<Sheet> sheet;
  };
  
  Sheet *currentsheet;

  QList<Group> pgroups;

};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _SETTINGSDLG_H */

