/*************************************************************************
 * @(#)SettingsExternalWidget.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   11 Mar 2011
 *************************************************************************
 */

#include "Settings.hh"
#include "SettingsExternalWidget.hh"

SettingsExternalWidget::SettingsExternalWidget(QWidget *parent)
  :Sheet(parent)
{
  setupUi(this);
  
  setObjectName("SettingsExternalWidget");

  QSizePolicy sizepolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
  sizepolicy.setHorizontalStretch(3);
  sizepolicy.setVerticalStretch(0);
  sizepolicy.setHeightForWidth(sizePolicy().hasHeightForWidth());
  setSizePolicy(sizepolicy);
  
  Settings set("application");
  leEditor->setText(set.getString("external editor","vi"));
  cbTerminal->setChecked(set.getBool("external editor in terminal",true));

  connectChanged(this);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool SettingsExternalWidget::commit()
{
  if(!isValid()) return false;

  Settings set("application");
  set.set("external editor",leEditor->text());
  set.set("external editor in terminal",cbTerminal->isChecked());

  return true;

}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool SettingsExternalWidget::isValid()
{
  return true;
}
/*EOF*/ 
