/*************************************************************************
 * @(#)SettingsGraphicsWidget.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   11 Mar 2011
 *************************************************************************
 */

#include "AntiAliasing.hh"
#include "Settings.hh"
#include "SettingsGraphicsWidget.hh"
#include "MyDebug.hh"

SettingsGraphicsWidget::SettingsGraphicsWidget(QWidget *parent)
  :Sheet(parent)
{
  setupUi(this);
  
  setObjectName("SettingsGraphicsWidget");

//   QSizePolicy sizepolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
//   sizepolicy.setHorizontalStretch(3);
//   sizepolicy.setVerticalStretch(0);
//   sizepolicy.setHeightForWidth(sizePolicy().hasHeightForWidth());
//   setSizePolicy(sizepolicy);

  
  Settings set("application");
  cbLowResOnMove->setChecked(set.getBool("graphics/reducedModelOnMove",false));
  cbWireframeOnMove->setChecked(set.getBool("graphics/wireFrameOnMove",false));
  cbBadTransparencyOnMove->
    setChecked(set.getBool("graphics/badTransparencyOnMove",true));
  grbxAntiAliasing->setChecked(antiAliasing.antiAliasing());
  spbxJitter->setValue(antiAliasing.jitter());
  cbPrintOnly->setChecked(antiAliasing.forPrintingOnly());
  cbNoAntiAliasingWhileMoving->setChecked(!antiAliasing.whileMoving());

  connectChanged(this);

}



/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool SettingsGraphicsWidget::commit()
{
  if(!isValid()) return false;

  Settings set("application");
  set.set("graphics/reducedModelOnMove",cbLowResOnMove->isChecked());
  set.set("graphics/wireFrameOnMove",cbWireframeOnMove->isChecked());
  set.set("graphics/badTransparencyOnMove",cbBadTransparencyOnMove
	  ->isChecked());
  antiAliasing.setAntiAliasing(grbxAntiAliasing->isChecked());
  antiAliasing.setAntiAliasingForPrintOnly(cbPrintOnly->isChecked());
  antiAliasing.setJitter(spbxJitter->value());
  antiAliasing.setWhileMoving(!cbNoAntiAliasingWhileMoving->isChecked());
  antiAliasing.writeSettings();

  return true;

}


/*EOF*/ 
