/*************************************************************************
 * @(#)SettingsOGLWidget.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   11 Mar 2011
 *************************************************************************
 */

#include <QMessageBox> 
#include "AntiAliasing.hh"
#include "Settings.hh"
#include "OGL.hh"
#include "SettingsOGLWidget.hh"
#include "MyDebug.hh"

SettingsOGLWidget::SettingsOGLWidget(QWidget *parent)
  :Sheet(parent)
{
  setupUi(this);
  
  setObjectName("SettingsOGLWidget");

//   QSizePolicy sizepolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
//   sizepolicy.setHorizontalStretch(3);
//   sizepolicy.setVerticalStretch(0);
//   sizepolicy.setHeightForWidth(sizePolicy().hasHeightForWidth());
//   setSizePolicy(sizepolicy);

  
  Settings set("application");
  cbAllowVertexArrays->setChecked(ogl.allowVertexArrays());
  cbAllowDisplayLists->setChecked(ogl.allowDisplayLists());
  cbAllowDiagnostics->setChecked(ogl.allowDiagnostics());
  cbAllowMultiSample->setChecked(ogl.allowMultiSample());

  padl=cbAllowDisplayLists->isChecked();
  pams=cbAllowMultiSample->isChecked();

  connectChanged(this);

}



/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool SettingsOGLWidget::commit()
{
  if(!isValid()) return false;

  Settings set("application");
  ogl.setAllowVertexArrays(cbAllowVertexArrays->isChecked());
  ogl.setAllowDisplayLists(cbAllowDisplayLists->isChecked());
  ogl.setAllowDiagnostics(cbAllowDiagnostics->isChecked());
  ogl.setAllowMultiSample(cbAllowMultiSample->isChecked());


  if((padl!=cbAllowDisplayLists->isChecked())||
     (pams!=cbAllowMultiSample->isChecked())){
    QMessageBox::warning(this,"Restart !"
			 ,"A restart is nesscary for displaylist\n"
			 "or antialias option changes to become effective!"
			 ,QMessageBox::Ok);
    
  }

  padl=cbAllowDisplayLists->isChecked();
  pams=cbAllowMultiSample->isChecked();

  return true;

}


/*EOF*/ 
