/*************************************************************************
 * @(#)StatusConfigDlg.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   05 Aug 2011
 *************************************************************************
 */

#include <QMessageBox>
#include "StatusConfigDlg.hh"
#include "Config.hh"
#include "MyDebug.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
StatusConfigDlg::StatusConfigDlg(QWidget *parent)
  :QDialog(parent)
{
  setupUi(this);
  setWindowTitle(IDS_APP_NAME  + ": Status bar configuration");

}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void StatusConfigDlg::accept()
{
  if(dataAcceptable()){
    QDialog::accept();
  }
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool StatusConfigDlg::dataAcceptable()
{

  QString txt="";


  if(txt.length()){
    QMessageBox::warning ( this,IDS_APP_NAME, txt, 1, 0,0 ) ;
    return false;
  }else{
    return  true;
  }
  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void StatusConfigDlg::setData(Xf::LengthUnits lu)
{
  plengthunit=lu;
  
  cmbLengthUnits->insertItem(0,Xf::lengthUnitName(Xf::BohrRadius)
			     ,Xf::BohrRadius);
  cmbLengthUnits->insertItem(1,Xf::lengthUnitName(Xf::Angstroem)
			     ,Xf::Angstroem);

  cmbLengthUnits->setCurrentIndex(cmbLengthUnits->findData(lu));
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void StatusConfigDlg::getData(Xf::LengthUnits &lu)
{
  int index=cmbLengthUnits->currentIndex();
  lu=(Xf::LengthUnits)cmbLengthUnits->itemData(index).toInt();
}


/*EOF*/ 
