/* @(#)SurColDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SURCOLDLG_H
#define _SURCOLDLG_H 1

#include "ui_SurColDlg.h"
#include "Vunit.hh"
#include "IsoColor.hh"
#include "ColorMap.hh"
#include "FSDoc.hh"


class SurColDlg: public ProtoDlg, private Ui::SurColDlg
{
  Q_OBJECT

public:
  SurColDlg(QWidget *parent,QWidget *base,const char *name);

  void setData( const IsoColor &isocolor , long excol
		, double vmin, double vmax , double vmine
		, double vmaxe , long def, long defe 
		, double *dmin, double *dmax , double *edmin
		, double *edmax ,VUnits::VelUnits vunit,long ufactor
		,long ufactore,long iweight
		,const FSDoc::LegendControl &legendcontrol);
  void getData(  IsoColor &isocolor , long &excol , double &min
		, double &max, double &mine, double &maxe
		, long &def, long &defe,VUnits::VelUnits &vunit,long &ufactor
		 ,long &ufactore,long &iweight
		 , FSDoc::LegendControl &legendcontrol
		 ,long &chn,long &excolchn);
    


private slots:
  void on_pbColorModel_clicked();
  void setToDefault();
  void setToDefaulte();
  void setEnable();

private:
  bool dataAcceptable();

private:
  IsoColor t_isocolor;
  ColorMap t_colormap;
  long t_def;
  long t_defe;
  long t_excol;
  VUnits::VelUnits t_vunit;
  long t_ufactor;
  long t_ufactore;
  QString t_min,t_max;
  QString t_mine,t_maxe;
  double *t_dmin,*t_dmax;
  double *t_edmin,*t_edmax;
  long t_iweight;
  FSDoc::LegendControl t_legcontrol;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _SURCOLDLG_H */

