/* @(#)SymManipulateWdg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _SYMMANIPULATEWDG_H
#define _SYMMANIPULATEWDG_H 1

#include "ui_SymManipulateWdg.h"

namespace XFPLO{
  class Symmetry;
}
class IntValidator;
class SymDlg;

using namespace XFPLO;

class SymManipulateWdg: public QWidget, private Ui::SymManipulateWdg
{
  Q_OBJECT;

 public:
  SymManipulateWdg(QWidget *parent);
  ~SymManipulateWdg();
  
  void onOpen();

 private slots:
  void on_pbToP1_clicked();
  void on_pbToConvCell_clicked();
  void on_pbRemoveGenerators_clicked();
  void on_pbDetermineSym_clicked();
  void on_pbIncreaseCell_clicked();
  void on_pbInsertVac_clicked();
  void on_pbUndo_clicked();
 private:
  void communicateback(Symmetry &);
  void pushUndo(Symmetry &);
  bool getSymmetry(Symmetry &sym);

 private:
  IntValidator *xyzvalid;
  IntValidator *ratvalid;
  SymDlg *psymdlg;
  QList<Symmetry> pundostack;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _SYMMANIPULATEWDG_H */

