/*************************************************************************
 * @(#)TestDlg.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   15 Mar 2011
 *************************************************************************
 */

#include "MyDebug.hh"
#include "TestDlg.hh"
#include "HelpDlg.hh"
#include "STDoc.hh"
#include "IsoSurface.hh"
#include "RepAutoGlyph.hh"
#include "RepVolume.hh"
#include "RepBoundingBox.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
TestDlg::TestDlg(QWidget *parent,QWidget *base,const char *name)
  : ProtoDlg(parent,base,name),pstdoc(0)
{
  setupUi(this);
  setUp(pbAccept,pbClose,pbCancel,pbHelp,"TestDialog",": Test settings");

  //  t_fog=new Test();

  // cmbTestMode->insertItem(0,Test::fogModeName(Test::Linear),Test::Linear);
  // cmbTestMode->insertItem(1,Test::fogModeName(Test::Exp),Test::Exp);
  // cmbTestMode->insertItem(2,Test::fogModeName(Test::Gaussian),Test::Gaussian);
  for(int i=-1;++i<STDoc::TempData::funcnames.size();){
    cmbFunc->insertItem(i,STDoc::TempData::funcnames.at(i).v2,
			STDoc::TempData::funcnames.at(i).v1);
  }
  connectChanged(this);
  connect(this,SIGNAL(contentChanged(QObject *)),
	  this,SLOT(onContentChanged(QObject *)));

  dspbxD<<dspbxD0<<dspbxD1<<dspbxD2<<dspbxD3<<dspbxD4<<dspbxD5<<dspbxD6<<dspbxD7;

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
TestDlg::~TestDlg()
{
}



/* ***********************************************************************
 *
 * ***********************************************************************
 */
void TestDlg::setData(STDoc *stdoc)
{
  pstdoc=stdoc;
  //myDebug() <<"setData: pstdoc="<<pstdoc;
  mutecontentchanged=true;
  cbGridVisible->setChecked(stdoc->fieldposautoglyphrep->isVisible());
  cbBBoxVisible->setChecked(stdoc->fieldbbrep->isVisible());
  cbConVisible->setChecked(stdoc->fieldconautoglyphrep->isVisible());
  cbIsoConVisible->setChecked(stdoc->isoconrep->isVisible());
  cbIsoShowNormals->setChecked(stdoc->isovolrep->showNormals());

  spbxNx->setValue(stdoc->tmpfielddata.NN.at(0));
  // dspbxIsoValue->setMinimum(v0);
  // dspbxIsoValue->setMaximum(v1);
  dspbxIsoValue->setValue(stdoc->tmpfielddata.isovalue);
  for(int i=-1;++i<8;)
    dspbxD[i]->setValue(stdoc->tmpfielddata.dd[i]);
  int i=cmbFunc->findData(stdoc->tmpfielddata.func);
  
  i=MyMath::min<long>(MyMath::max(i,0),STDoc::TempData::funcnames.size()-1);
  //myDebug()<<"stdoc->tmpfielddata.func"<<stdoc->tmpfielddata.func<<i;
  cmbFunc->setCurrentIndex(i);
  mutecontentchanged=false;
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void TestDlg::getData(STDoc *stdoc)
{
  //myDebug() <<"getData: pstdoc="<<pstdoc;


  stdoc->fieldposautoglyphrep->setVisible(cbGridVisible->isChecked());
  stdoc->fieldbbrep->setVisible(cbBBoxVisible->isChecked());
  stdoc->fieldconautoglyphrep->setVisible(cbConVisible->isChecked());
  stdoc->isoconrep->setVisible(cbIsoConVisible->isChecked());

  //   *fog=*t_fog;
  //   t_fog->setChanged(false);
}




/* ***********************************************************************
 *
 * ***********************************************************************
 */
void TestDlg::onContentChanged(QObject* sender)
{
  if(!pstdoc) return;
  QString isA(sender->metaObject()->className());
  //myDebug()<<"onContentChanged(QObject* sender))"<<sender<<isA;
  if(sender==dspbxIsoValue){
    //myDebug()<<"d="<<d;
    pstdoc->tmpfielddata.isovalue=dspbxIsoValue->value();
    pstdoc->isosurface1->setIsoValue(XFPLO::Value(pstdoc->tmpfielddata.isovalue));
    pstdoc->isosurface2->setIsoValue(XFPLO::Value(-pstdoc->tmpfielddata.isovalue));
    emit talkBack(Accept);
  }else if(sender==cmbFunc){
    int index=cmbFunc->currentIndex();
    if(index<0) return;
    //myDebug() <<"on_cmbFunc_currentIndexChanged: pstdoc="<<pstdoc;
    //myDebug() <<index<<cmbFunc->itemData(index).toInt();
    
    pstdoc->tmpfielddata.func=(STDoc::TempData::Funcs)(cmbFunc->itemData(index).toInt());
    //myDebug()<<"on_cmbFunc_currentIndexChanged stdoc->tmpfielddata.func"
    //	     <<pstdoc->tmpfielddata.func<<index;
    pstdoc->setField();
    
    emit talkBack(Accept);
    
  }else if(sender==spbxNx){
    pstdoc->tmpfielddata.NN[0]=spbxNx->value();
    pstdoc->tmpfielddata.NN[1]=spbxNx->value();
    pstdoc->tmpfielddata.NN[2]=spbxNx->value();
    pstdoc->setField();
    emit talkBack(Accept);
  }else if(sender==cbBBoxVisible){
    pstdoc->fieldbbrep->setVisible(cbBBoxVisible->isChecked());
    emit talkBack(Accept);
  }else if(sender==cbConVisible){
    pstdoc->fieldconautoglyphrep->setVisible(cbConVisible->isChecked());
    emit talkBack(Accept);
  }else if(sender==cbIsoConVisible){
    pstdoc->isoconrep->setVisible(cbIsoConVisible->isChecked());
    emit talkBack(Accept);
  }else if(sender==cbIsoShowNormals){
    pstdoc->isovolrep->setShowNormals(cbIsoShowNormals->isChecked());
    emit talkBack(Accept);
  }else if(sender==cbGridVisible){
    pstdoc->fieldposautoglyphrep->setVisible(cbGridVisible->isChecked());
    emit talkBack(Accept);
  }else{
    for(int i=-1;++i<8;){
      if(sender==dspbxD[i]){
	pstdoc->tmpfielddata.dd[i]=dspbxD[i]->value();
	pstdoc->setField();
	emit talkBack(Accept);
      }
    }
  }

}
/*EOF*/ 
