/* @(#)ThemeDlg.hh
 * author: magru@unas
 */

#ifndef _THEMEDLG_HH
#define _THEMEDLG_HH 1

#include <QDialog>
#include "ui_ThemeDlg.h"

namespace XFPLO{
class LightThemes;
}

using namespace XFPLO;

/* ***********************************************************************
 *
 * ***********************************************************************
 */


class ThemeDlg:public QDialog, private Ui::ThemeDlg{
  Q_OBJECT;
public:
  enum Mode{Save=0,Load=1};
  ThemeDlg(QWidget *,Mode mode,LightThemes *lightthemes);
  ~ThemeDlg();
protected slots:
  void accept();
private slots:
  void on_pbSave_clicked();
  void on_cmbTheme_editTextChanged(const QString &text);
  void on_cmbTheme_currentIndexChanged(int index);
  void on_tbAdd_clicked();
  void on_tbDelete_clicked();
  void on_tbHelp_clicked();
private:
  void setTbDeleteEnabled();
private:
  Mode pmode;
  LightThemes *plightthemes;
  bool mute_cmbThemeEdit,mute_cmbThemeIndex;
};


#endif /* _THEMEDLG_HH */

