/* @(#)UnfoldDlg.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _UNFOLDDLG_HH
#define _UNFOLDDLG_HH 1

#include "ProtoDlg.hh"
#include "ui_UnfoldDlg.h"
#include "ComboBoxHelper.hh"
#include "Vec3.hh"

class IntValidator;
class STR;
namespace XFPLO{
  class Symmetry;
}

using namespace XFPLO;

/* ***********************************************************************
 *
 * ***********************************************************************
 */

typedef class ComboBoxHelper<QString> UCH;

class UnfoldDlg:public ProtoDlg, private Ui::UnfoldDlg
{
  Q_OBJECT;
public:
  UnfoldDlg(QWidget *parent,QWidget *base,const char *name);
  ~UnfoldDlg();
  void setData(const Symmetry *sym);
private slots:
  void on_pbApplySCBasis_clicked();
  void on_cmbUnits_currentIndexChanged(int);
  void on_pbLoad_clicked();
  void on_pbSave_clicked();
protected:
  bool dataAcceptable();

private:
  Matrix3x3 readTwBasis();
  void setTwBasis(const Matrix3x3 &mat);
  void saveSettings(const Matrix3x3 &mat);
  void loadSettings();

protected:
private:
  IntValidator *xyzvalid;
  const Symmetry *t_sym;
  QString currentunits;
  UCH *unitHelper;
  STR *pstr;
};


#endif /* _UNFOLDDLG_HH */

