/*************************************************************************
 * @(#)BP_allocread.c
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   30 Aug 2006
 *************************************************************************
 */

#include <stdlib.h>
#include "allocread.h"
#include "merror.h"


/* ***********************************************************************
 *
 * ***********************************************************************
 */

long allocreadbuf(FILE *FHI,char ** pbuffer,long *lenpbuffer)
{
  const char *nsubfunc="allocreadbuf"; 
  int c;
  long indx,lp,eof;

  indx=0;
  eof=0;
  while (1) {
    c=fgetc(FHI);
    /* fprintf(stderr,"c=%c\n",c); */
    
    if(c==EOF){
      eof=1;
      c='\0';
      lp=0;
    }else{
      lp=1;
    }
    
    if(indx+lp>=(*lenpbuffer)){
      (*lenpbuffer)+=1024;
      if(
	 ((*pbuffer)=(char*) realloc((*pbuffer),sizeof(char)*(*lenpbuffer)))
	 ==NULL
	 ){
	sprintf(errorbuffer,"%s: Cannot (re)allocate buffer!\n",nsubfunc);
	goto error;
      }
    }
    /* fprintf(stderr,"indx=%d [%c] eof=%ld\n",indx,c,eof); */
    (*pbuffer)[indx++]=c;
    (*pbuffer)[indx]='\0';
    

    if(c=='\n') return 1;
    
    if(eof) { 
      /* HIERL(eof); */
      /*       HIERL(indx); */
      if(indx>1) {
	/* HIER("return 1"); */
	return 1;
      }else {
	/* HIER("return 0"); */
	return 0; 
      }
    }
    
  }



  
 error:
  (void)fprintf(stderr,"%s\n",errorbuffer);
  exit(2);
}


/* EOF*/
