/*************************************************************************
 * @(#)Cmplx.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   03 Mar 2010
 *************************************************************************
 */

#include "Cmplx.hh"

const Cmplx Cmplx::ci=Cmplx(0.,1.);
const Cmplx Cmplx::c1=Cmplx(1.,0.);

/* ***********************************************************************
 * Clebsch-Gordon coefficients for coupling of l and s=1/2
 * ***********************************************************************
 */
double MyMath::ClebschGordonChi(long kap,long mu,long s)
{
  if(abs(s)!=1){
    return 0.;
  }
  long j=2*abs(kap)-1;
  if(!kap || abs(mu)>j) return 0.;
  
  double degk=2*kap+1.0;
  double ks=dSign(1.,kap);
  
  
  if(kap<0){
    if(mu==j){
      return (1+s)*0.5;
    }else if(mu==-j){
      return (1-s)*0.5;
    }
  }

  if(s==1){
    return -ks*sqrt( (1.0-mu/degk)*0.5 );
  }else{
    return sqrt( (1.0+mu/degk)*0.5 );
  }
    

}

/*EOF*/ 
