/* @(#)DMQuantAxis.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _DMQUANTAXIS_H
#define _DMQUANTAXIS_H 1

#include "Vec3.hh"
#include "SqMatrix.hh"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class DMQuantAxis{
 public:
  DMQuantAxis(){
    xaxis=Vec3(1.,0.,0.);
    zaxis=Vec3(0.,0.,1.);
  };

  DMQuantAxis(const Vec3 &x,const Vec3 &z)
    :xaxis(x),zaxis(z){};

  
  const SqMatrix<Cmplx> &YTransMat()const { return ytr; }

  static StringList calcAxesTrans(const Vec3 &x,const Vec3 &z
				  ,long l,SqMatrix<Cmplx> &ytr);
  static StringList calcAxesTransJ(const Vec3 &x,const Vec3 &z
				   ,long j,SqMatrix<Cmplx> &Djmm);
  void calcTrans(long l);
  void calcTransJ(long j);
  void calcTransLJ(long l);
  void calcTransLL(long l);
  
  bool operator==(const DMQuantAxis &other) const {

    return xaxis.eq(other.xaxis) && zaxis.eq(other.zaxis);
  };


  //private:
  Vec3 xaxis;
  Vec3 zaxis;
 private:
  SqMatrix<Cmplx> ytr;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _DMQUANTAXIS_H */

