/* @(#)MACROS.hh
 * author: magru@unas
 */

#ifndef _MACROS_HH
#define _MACROS_HH 1


/* ***********************************************************************
 *
 * ***********************************************************************
 */


#define PROPERTY(name,getname,setname,type)			\
  private:							\
  type p##name;							\
public:								\
 inline type getname()const{return p##name;}			\
 inline void set##setname(type arg##name){p##name=arg##name;}		

#define ROPROPERTY(name,getname,type)				\
  private:							\
  type p##name;							\
public:								\
 inline type getname()const{return p##name;}			

#define PROPERTY_CHANGED(name,getname,setname,type)			\
  private:								\
  type p##name;								\
public:									\
 inline type getname()const{return p##name;}			\
 inline void set##setname(type arg##name){				\
   pchanged|=(p##name!=arg##name);					\
   p##name=arg##name;}

#define PROPERTY_CHANGED_CALCED(name,getname,setname,type)		\
  private:								\
  type p##name;								\
public:									\
 inline type getname()const{return p##name;}				\
 inline void set##setname(type arg##name){				\
   pchanged|=(p##name!=arg##name);					\
   p##name=arg##name;pcalced&=!pchanged;}

#define VPROPERTY_CHANGED_CALCED(name,dim,getname,setname,type)		\
  private:								\
  type p##name[dim];							\
public:									\
 inline const type *getname()const{return p##name;}			\
 inline type getname(long i)const{return p##name[i];}			\
 inline void set##setname(long i,const type &arg##name){		\
   pchanged|=(p##name[i]!=arg##name);					\
   p##name[i]=arg##name;pcalced&=!pchanged;}				\
 inline void set##setname(const type arg##name[dim]){			\
   for(long i=-1;++i<dim;){						\
     pchanged|=(p##name[i]!=arg##name[i]);				\
     p##name[i]=arg##name[i];						\
   }									\
   pcalced&=!pchanged;							\
 }

#define POINTERPROPERTY(name,getname,setname,type)			\
  private:								\
  type *p##name;							\
public:									\
 inline type *getname()const{return p##name;}				\
 inline void set##setname(type *arg##name){p##name=arg##name;}		


#define CPROPERTY(name,getname,setname,type)				\
  private:								\
  type p##name;								\
public:									\
 inline const type &getname()const{return p##name;}			\
 inline void set##setname(const type &arg##name){p##name=arg##name;}		

#define ROCPROPERTY(name,getname,type)				\
  private:							\
  type p##name;							\
public:								\
 inline const type &getname()const{return p##name;}			

#define CVPROPERTY(name,dim,getname,setname,type)			\
  private:								\
  type p##name[dim];							\
public:									\
 inline const type *getname()const{return p##name;}			\
 inline const type &getname(long i)const{return p##name[i];}		\
 inline void set##setname(long i,const type &arg##name){		\
   p##name[i]=arg##name;}						\
 inline void set##setname(const type arg##name[dim]){			\
   for(long i=-1;++i<dim;){						\
     p##name[i]=arg##name[i];						\
   }									\
 }


#define CMODPROPERTY(name,getname,setname,type)				\
  private:								\
  type p##name;								\
public:									\
 inline const type &getname()const{return p##name;}			\
 inline type &getname(){return p##name;}				\
 inline void set##setname(const type &arg##name){p##name=arg##name;}		

#define ROCMODPROPERTY(name,getname,type)				\
  private:								\
  type p##name;								\
public:									\
 inline const type &getname()const{return p##name;}			\
 inline type &getname(){return p##name;}				


#define CPROPERTY_CHANGED(name,getname,setname,type)			\
  private:								\
  type p##name;								\
public:									\
 inline const type &getname()const{return p##name;}			\
 inline void set##setname(const type &arg##name){			\
   pchanged|=(p##name!=arg##name);					\
   p##name=arg##name;}

#define CPROPERTY_CHANGED_CALCED(name,getname,setname,type)		\
  private:								\
  type p##name;								\
public:									\
 inline const type &getname()const{return p##name;}			\
 inline void set##setname(const type &arg##name){			\
   pchanged|=(p##name!=arg##name);					\
   p##name=arg##name;pcalced&=!pchanged;}

#define CVPROPERTY_CHANGED_CALCED(name,dim,getname,setname,type)	\
  private:								\
  type p##name[dim];							\
public:									\
 inline const type *getname()const{return p##name;}			\
 inline const type &getname(long i)const{return p##name[i];}		\
 inline void set##setname(long i,const type &arg##name){		\
   pchanged|=(p##name[i]!=arg##name);					\
   p##name[i]=arg##name;pcalced&=!pchanged;}				\
 inline void set##setname(const type arg##name[dim]){			\
   for(long i=-1;++i<dim;){						\
     pchanged|=(p##name[i]!=arg##name[i]);				\
     p##name[i]=arg##name[i];						\
   }									\
   pcalced&=!pchanged;							\
 }

#endif /* _MACROS_HH */

