#include "Vlevel.hh"



const Vlevel::tsvlevels Vlevel::pvlevels[]={
  {"silent",Silent}
  ,{"basic information",Info}
  ,{"more information ",More}
  ,{"much information ",Many}
  ,{"complete information  ",All}
  ,{"unknown verbosity level  ",Unknown}
};

const long Vlevel::pmaxvlevels=
  sizeof(Vlevel::pvlevels)/sizeof(Vlevel::tsvlevels);


/* ***********************************************************************
 *
 * ***********************************************************************
 */
const  char *Vlevel::name() const 
{
  
  for(long i=0;i<pmaxvlevels-1;i++){
    if(pvlevels[i].vlevel == plevel){
      return pvlevels[i].name;
    }
  }
  return pvlevels[pmaxvlevels-1].name;

}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
long Vlevel::index() const
{
  for(long i=0;i<pmaxvlevels-1;i++){
    if(pvlevels[i].vlevel == plevel){
      return i;
    }
  }
  return Info;
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
Vlevel Vlevel::verbosityLevelFromIndex(long i)
{
  long j=i;
  if(i<0 || i>=pmaxvlevels-1) j=Silent;
  return Vlevel(pvlevels[j].vlevel);
}
