/* @(#)Vlevel.h
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef VLEVEL_H
#define VLEVEL_H

class Vlevel
{
public:
  enum VerbosityLevel{Silent=0,Info=100,More=200,Many=300,All=1000,
		      Unknown=-1};

  Vlevel(){};
  Vlevel(VerbosityLevel l):plevel(l){};


  const Vlevel &operator=(VerbosityLevel l){plevel=l; return *this;};
  bool operator!=(const Vlevel &other) const {return (plevel != other.plevel);};
  bool operator>=(const VerbosityLevel &l) const {return (plevel >= l);};

  VerbosityLevel level() const {return plevel;};
  const  char *name() const ;

  long index() const;

  static long noVerbosityLevels(){return pmaxvlevels-1;};
  static Vlevel verbosityLevelFromIndex(long i); 

 private:

  struct tsvlevels{
    const char *name;
    VerbosityLevel vlevel;
  };
  static const struct tsvlevels pvlevels[];
  static const long pmaxvlevels;

  VerbosityLevel plevel;
};

#endif // VLEVEL_H
