/* @(#)convtests.c
 */


#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <ctype.h>
#include "merror.h"
#include "convtests.h"



/* ***********************************************************************
 *
 * ***********************************************************************
 */
long convertfortranreal(char *value,FPLODOUBLEPRECISION *ret)
{
  unsigned long i;
  char *err;
  char *p;
  double dn,dd;
  long l;
  char buf[5000];

  
  if(strstr(value,"/")!=NULL){
    (void)strcpy(buf,value);
    p=strstr(buf,"/");
    *p='\0';
    l=strtol(buf,&err,10);
    if (*err!='\0' || *buf =='\0') { *p='/'; goto fractionalerror; }
    dn=strtod(buf,&err);
    if (*err!='\0' || *buf =='\0') { *p='/'; goto fractionalerror; }

    l=strtol(p+1,&err,10);
    if (*err!='\0' || *(p+1) =='\0') { *p='/'; goto fractionalerror; }
    if(l<0) { *p='/'; goto fractionalerror; }
    dd=strtod(p+1,&err);
    if (*err!='\0' || *(p+1) =='\0') { *p='/'; goto fractionalerror; }
    dd=dn/dd;
    if(dd>=R_POS_INFINITY){
      *ret=R_POS_INFINITY;
    }else if(dd<=R_NEG_INFINITY){
      *ret=R_NEG_INFINITY;
    }else{
      *ret=dd;
    }
    
  }else{

    i=strlen(value);
    while (i--){ if(value[i] =='d' || value[i]=='D' ) {value[i]='e';break;} }
    
    errno=0;
    dd=strtod(value,&err);

    if(dd>=R_POS_INFINITY){
      *ret=R_POS_INFINITY;
    }else if(dd<=R_NEG_INFINITY){
      *ret=R_NEG_INFINITY;
    }else{
      *ret=(FPLODOUBLEPRECISION)dd;
    }
    
    if (*err!='\0' || *value == '\0' ) {
      (void)sprintf(errorbuffer,"Conversion error for real constant '%s'!",value);
      return 0;
    }

/*     if ((double)(*ret)!=d ) { */
/*       (void)sprintf(errorbuffer,"Overlow error for real constant '%s' ( %g != %g!",value,d,*ret); */
/*       return 0; */
/*     } */
  }
  return 1;
 fractionalerror:
  (void)sprintf(errorbuffer,"Conversion error for fractional constant '%s'!",value);
  return 0;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */

long convertlong(const char *value,FPLOINTEGER *ret)
{
  
  long l;
  char *err;
  if(strcmp(value,"+INF")==0){
    l=I_POS_INFINITY;
  }else if(strcmp(value,"-INF")==0){
    l=I_NEG_INFINITY;
  }else{
    l= strtol(value,&err,10);
    if (*err!='\0' ||  *value == '\0') {
      (void)sprintf(errorbuffer,"Conversion error for integer constant '%s'!",value);
      return 0;
    }
  }
  *ret=(FPLOINTEGER)l;
  if (*ret!=l ) { 
    (void)sprintf(errorbuffer,"Conversion error: overlow for integer constant '%s' " 
 	    "("FPLOINTEGERFORMAT" != %ld)!",value,*ret,l); 
    return 0; 
  } 


  return 1;
}


/* ***********************************************************************
 * returns 
 *        strlen(value) of variable string
 *        strlength of non variable string
 *        -1 on error
 * ***********************************************************************
 */
long teststringlength(const char *value,long strvariable,long strlength)
{
  unsigned long l;
  l=strlen(value);
  if(!strvariable){
    if(l>(unsigned long)strlength){
      return -1;
    }
    l=strlength;
  }
  return l;
}


    
/* ***********************************************************************
 *
 * ***********************************************************************
 */
long isinternflag(const char *flag)
{
  const char *p;
  if(strlen(flag)<2) return 0;
  if(! (flag[0]=='+' || flag[0]=='-')){
    return 0;
  }
  if(! ( islower(flag[1])  || isupper(flag[1]) ) ) return 0;
  p=flag+2;
  while(*p!='\0'){
    if(! ( islower(*p)  || isupper(*p) || isdigit(*p) || *p=='_' ) ) 
      return 0;
    p++;
  }
  return 1;
}



