/* @(#)stdstack.c
 */


#include <stdlib.h>
#include <stdio.h>
#include "stdstack.h"
#include "merror.h"

/* ***********************************************************************
 *
 * ***********************************************************************
 */
long init_stdstack(STRUCTDATASTACK *std,long aschar)
{
  char *subfunc="init_stdstack";
  long i;
  subfunc=subfunc;
  for(i=0;i<STRSTACK_DEPTH;i++){
    std->stdstack[i].saindx=0;
    std->stdstack[i].structmember=NULL;
    std->stdstack[i].parent=NULL;
    std->stdstack[i].currentnode=NULL;
    std->stdstack[i].structname[0]='\0';
    std->aschar=aschar;
    (void)init_vartable(&(std->stdstack[i].structtable),std->aschar);
  }
  std->depth=0;
  std->stdtop=std->stdstack+std->depth;
  return 1;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
long clean_stdstack(STRUCTDATASTACK *std)
{
  char *subfunc="clean_stdstack";
  long i;
  subfunc=subfunc;
  for(i=0;i<STRSTACK_DEPTH;i++){
    if(!clean_vartable(&(std->stdstack[i].structtable))) return 0;
    (void)init_vartable(&(std->stdstack[i].structtable),std->aschar);
  }
  return 1;
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
long push_stdstack(STRUCTDATASTACK *std)
{
  char *subfunc="push_stdstack";

  if(std->depth>=STRSTACK_DEPTH){
    (void)sprintf(errorbuffer
	    ,"error(%s): stack overflow!"
	    ,subfunc);
    return 0;
  }
  std->depth++;
  std->stdtop=std->stdstack+std->depth;
  /* initialize top of stack */
  std->stdstack[std->depth].structname[0]='\0';
  if(!clean_vartable(&(std->stdstack[std->depth].structtable))) return 0;
  (void)init_vartable(&(std->stdstack[std->depth].structtable),std->aschar);

  return 1;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
long pop_stdstack(STRUCTDATASTACK *std)
{
  char *subfunc="pop_stdstack";

  if(std->depth<=0){
    (void)sprintf(errorbuffer
	    ,"error(%s): stack underflow!"
	    ,subfunc);
    return 0;
  }
  /* clean top of stack */
  std->stdstack[std->depth].structname[0]='\0';
  if(!clean_vartable(&(std->stdstack[std->depth].structtable))) return 0;
  (void)init_vartable(&(std->stdstack[std->depth].structtable),std->aschar);
  
  std->depth--;
  std->stdtop=std->stdstack+std->depth;
  return 1;
}


/* EOF */
