/************************************************************************
 *
 * graphic package for FPLO
 * (C) Klaus Koepernik April '98
 *
 * **********************************************************************
 */
#ifndef _MERROR_H_
#define _MERROR_H_



#include <stdio.h> 


/* sverity level */
/* These constants are also defined in errors.f90, dont change them */
#define INFORMATION  1
#define WARNING      2
#define ERROR        3
#define SEVERE_ERROR 4



#define ERR_CATCH       0x0001
#define ERR_NOCATCH     0x0000
#define ERR_BUFFERED    0x0100
#define ERR_NOBUFFERED  0x0000
#define ERR_RESETBUFFER 0x0200

/* buffer */
extern char errormsg[5000];
extern char errorbuffer[5000];


#ifdef	__cplusplus
extern "C" {
#endif


/* error handling */
extern void errmsg(const char *locations,char *msg,long level);
/* return and reset severitylevel */
extern long severitylevel(void);
/* return if error occured */
extern long erroroccured(void);
/* set error handling */
extern void seterrorhandling(long e);
/* print buffer into FILE */
extern void flusherror(FILE *FH);


/*  return pointer to buffer */
extern const char * errorgetbuffer(void);

#ifdef	__cplusplus
}
#endif


#endif /* _MERROR_H_ */
/* EOF */
