/* @(#)BFacesModel.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _BFACESMODEL_H
#define _BFACESMODEL_H 1

#include <QAbstractTableModel>
#include "Boundary.hh"

namespace XFPLO{
  class Symmetry;
}
using namespace XFPLO;

class BFacesModel: public QAbstractTableModel
{
public:
  BFacesModel( QObject * parent = 0,Boundary *bound=0);
  ~BFacesModel();
  
  int rowCount(const QModelIndex & parent ) const;
  int columnCount(const QModelIndex &parent) const;
  QVariant data(const QModelIndex &index, int role) const;
  QVariant headerData(int section, Qt::Orientation orientation, int role) const;
  Qt::ItemFlags flags(const QModelIndex &index) const;
  
  bool setData(const QModelIndex &index, const QVariant &value, int role);

  bool removeRows(int position,int rows,const QModelIndex &index);

  bool insertRows(int position,int rows,const QModelIndex &index
		  ,const Face &f=Face());



  void reset(const String &,const Symmetry *sym,Boundary::BasisType b);

  const Face *getData(int row) const;
private:
  Boundary *pbound;

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _BFACESMODEL_H */

