#ifndef WYCKPOSMODEL_H
#define WYCKPOSMODEL_H

#include <QAbstractTableModel>

namespace XFPLO{
  class WyckPos;
  class Symmetry;
}

using namespace XFPLO;

class WyckPosModel: public QAbstractTableModel
{
  Q_OBJECT;
public:

  enum SetDefaultsActions{TypeByZ=0,TypePerElement=1};

  enum Columns{El=0,Type=1,X=2,Y=3,Z=4};
    WyckPosModel( QObject * parent = 0,Symmetry *sym=0);
    ~WyckPosModel();

    void reload(){beginResetModel();endResetModel();};

    int rowCount(const QModelIndex & parent=QModelIndex()) const;
    int columnCount(const QModelIndex &parent=QModelIndex()) const;
    QVariant data(const QModelIndex &index, int role) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role) const;
    Qt::ItemFlags flags(const QModelIndex &index) const;
    bool setData(const QModelIndex &index, const QVariant &value
		 , int role=Qt::EditRole);


    bool insertRow(int position,const WyckPos *w=0);
    WyckPos removeRow(int position);
    bool moveRow(int row,int by);

    void setDefaults(SetDefaultsActions action,const QMap<QString,int>&map);
    QMap<QString,int> getElementTypeList();

private slots:
    void userCommitHappening(bool p){pallowDefaultOnSetData=p;};
private:
    Symmetry *psym;
    bool pallowDefaultOnSetData;
};

#endif // WYCKPOSMODEL_H
