/* @(#)OGLAutoGlyph.hh
 * author: magru@unas
 */

#ifndef _OGLAUTOGLYPH_HH
#define _OGLAUTOGLYPH_HH 1

#include "OGLDataCache.hh"
#include "OGLObject.hh"

class Vec3;

namespace XFPLO{
class RepAutoGlyph;


/* ***********************************************************************
 *
 * ***********************************************************************
 */

class OGLAutoGlyph: public OGLObject
{
public:
  
  OGLAutoGlyph(const RepAutoGlyph *rep);
  virtual ~OGLAutoGlyph();

  bool NFPlane(const Vec3 &n,double &near,double &far);

  
  void paint(OGLView *oglview,const OGLMagnifier &mag
	     ,bool reduced,bool badTransparency)const;
  void construct(OGLView *oglview);
  void protectCachedData();


  OGLMaterial &material(){return pmaterial;};

  bool pick(const View &,double ,double ,double &z)
  {z=0.;return false;};
  
  static void setUseDisplayLists(bool u){pusedisplaylists=u;};
  static bool useDisplayLists() {return pusedisplaylists;};

protected:


private:
  const RepAutoGlyph *prep;
  static bool pusedisplaylists;
  OGLMaterial pmaterial;
  OGLDataCacheItem *cachedData;

};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class OGLDataCacheAutoGlyphItem: public OGLDataCacheItem
{
 public:
  OGLDataCacheAutoGlyphItem(const RepAutoGlyph *rep);
  
  QString printSpecQ()const;
  
  void construct(bool transparent);

  
 private:
  const RepAutoGlyph *prep;


  friend class OGLDataCache;

};


}

#endif /* _OGLAUTOGLYPH_HH */

