/* @(#)OGLLegend.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */


#include <QGLWidget>
#include "OGLDataCache.hh"
#include "OGLObject.hh"
#include "OGLMaterial.hh"
#include "Vec3.hh"

#ifndef _OGLLEGEND_H
#define _OGLLEGEND_H 1

class ColorModel;


/* ***********************************************************************
 *
 * ***********************************************************************
 */
class OGLLegend: public OGLObject
{
public:

  enum OGLLegendType{Horizontal=1,Vertical=2};
  
  OGLLegend(double width,double height,double ratio,double x0,double y0
	    ,OGLLegendType type,const ColorModel *pcm);
  virtual ~OGLLegend();

  bool NFPlane(const Vec3 &n,double &near,double &far);
  
  void paint(OGLView *oglview,const OGLMagnifier &mag
	     ,bool reduced,bool badTransparency)const;
  void construct(OGLView *oglview);
  void protectCachedData();

  OGLMaterial &material(){return pmaterial;};

  bool pick(const View &,double ,double ,double &z)
  {z=0.;return false;};
  
  static void setUseDisplayLists(bool u){pusedisplaylists=u;};
  static bool useDisplayLists() {return pusedisplaylists;};

protected:


private:
  OGLLegendType ptype;
  double pwidth,pheight,pratio,px0,py0;
  static bool pusedisplaylists;
  OGLMaterial pmaterial;
  OGLDataCacheItem *cachedData;
  const ColorModel *pcolormodel;

 
};


/* ***********************************************************************
 *
 * ***********************************************************************
 */
class OGLDataCacheLegendItem: public OGLDataCacheItem
{
 public: 
  OGLDataCacheLegendItem(double width,double height
			 ,OGLLegend::OGLLegendType type,
			 const ColorModel *pcm			 
			 );
  
/*   ~OGLDataCacheLegendItem(){}; */
  
  
  
  QString printSpecQ()const;
  
  void construct(bool transparent);
  
 private:
  OGLLegend::OGLLegendType ptype;
  double pwidth,pheight;
  const ColorModel *pcolormodel;

  friend class OGLDataCache;

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _OGLLEGEND_H */

