/* @(#)OGLLightHelper.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _OGLLIGHTHELPER_H
#define _OGLLIGHTHELPER_H 1


#include <QGLWidget>
#include "OGLDataCache.hh"
#include "OGLObject.hh"
#include "OGLMaterial.hh"
#include "Light.hh"
#include "Vec3.hh"


using namespace XFPLO;

class OGLDataCache;

class OGLLightHelper: public OGLObject
{
public:
  
  OGLLightHelper(const Lights::Light *light,const View *view);
  virtual ~OGLLightHelper();

  bool NFPlane(const Vec3 &n,double &near,double &far);

  
  void paint(OGLView *oglview,const OGLMagnifier &mag
	     ,bool reduced,bool badTransparency)const;
  void construct(OGLView *){};
  void protectCachedData(){};


  OGLMaterial &material(){return pmaterial;};

  bool pick(const View &/*v*/,double /*x*/,double /*y*/,double &z)
  {z=0.;return false;};


protected:

private:
  void construct();
private:

  OGLMaterial pmaterial;
  const View *pview;
  const Lights::Light plight;

  long pverticessize;
  GLdouble *pvertices;   // private data
  long pndefs;
  struct VertexArrayDef *pdefs;
};




#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _OGLLIGHTHELPER_H */

