/* @(#)OGLLine.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _OGLLINE_H
#define _OGLLINE_H 1


#include <QGLWidget>
#include "OGLDataCache.hh"
#include "OGLObject.hh"
#include "OGLMaterial.hh"
#include "Vec3.hh"

class OGLDataCache;

class OGLLine: public OGLObject
{
public:
  
  OGLLine(const ValueArray<ValueArray<Vec3> > &line,double linewidth);
  virtual ~OGLLine();

  bool NFPlane(const Vec3 &n,double &near,double &far);

  
  void paint(OGLView *oglview,const OGLMagnifier &mag
	     ,bool reduced,bool badTransparency)const;
  void construct(OGLView *){};
  void protectCachedData(){};


  OGLMaterial &material(){return pmaterial;};

  bool pick(const View &/*v*/,double /*x*/,double /*y*/,double &z)
  {z=0.;return false;};

  static void setUseDisplayLists(bool u){pusedisplaylists=u;};
  static bool useDisplayLists() {return pusedisplaylists;};

protected:


private:

  static bool pusedisplaylists;
  Vec3 pposition;
  long pverticessize;
  GLdouble *pvertices;   // private data
  long pndefs;
  struct VertexArrayDef *pdefs;
  OGLMaterial pmaterial;
  double plinewidth;
};




#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _OGLLINE_H */

