/* @(#)OGLMeshPoints.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */


#ifndef _OGLMESHPOINTS_H
#define _OGLMESHPOINTS_H 1

#include <QGLWidget>
#include "OGLDataCache.hh"
#include "OGLObject.hh"
#include "OGLMaterial.hh"
#include "Vec3.hh"

class RegularMesh;

class OGLMeshPoints: public OGLObject
{
public:
  enum OGLMeshPointsType{Full=1,Irreducible=2};
  
  OGLMeshPoints(OGLMeshPointsType type,const RegularMesh *mesh);
  virtual ~OGLMeshPoints();

  bool NFPlane(const Vec3 &n,double &near,double &far);

  
  void paint(OGLView *oglview,const OGLMagnifier &mag
	     ,bool reduced,bool badTransparency)const;
  void construct(OGLView *oglview);
  void protectCachedData();


  OGLMaterial &material(){return pmaterial;};

  bool pick(const View &/*v*/,double /*x*/,double /*y*/,double &z)
  {z=0.;return false;};
  
  static void setUseDisplayLists(bool u){pusedisplaylists=u;};
  static bool useDisplayLists() {return pusedisplaylists;};

protected:


private:
  OGLMeshPointsType ptype;
  const RegularMesh *pmesh;
  static bool pusedisplaylists;
  OGLMaterial pmaterial;
  OGLDataCacheItem *cachedData;

};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class OGLDataCacheMeshPointsItem: public OGLDataCacheItem
{
 public:
  OGLDataCacheMeshPointsItem(OGLMeshPoints::OGLMeshPointsType type
			     ,const RegularMesh *mesh);
  
  QString printSpecQ()const;
  
  void construct(bool transparent);

  
 private:
  OGLMeshPoints::OGLMeshPointsType ptype;
  const RegularMesh *pmesh;


  friend class OGLDataCache;

};




#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _OGLMESHPOINTS_H */

