/* @(#)OGLPoly.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _OGLPOLY_H
#define _OGLPOLY_H 1

#include <QGLWidget>
#include "OGLObject.hh"
#include "OGLMaterial.hh"
#include "Vec3.hh"

class OGLDataCache;
namespace XFPLO{
  class Polyhedron;
}

class OGLPoly: public OGLObject
{
public:
  
  OGLPoly(const Vec3 &position,const XFPLO::Polyhedron *poly);
  virtual ~OGLPoly();

  bool NFPlane(const Vec3 &n,double &near,double &far);

  
  void paint(OGLView *oglview,const OGLMagnifier &mag
	     ,bool reduced,bool badTransparency)const;
  void construct(OGLView *oglview);
  void protectCachedData();
  void collectTransparent(OGLTransparentCollector *,bool );


  OGLMaterial &material(){return pmaterial;};

  bool pick(const View &/*v*/,double /*x*/,double /*y*/,double &z)
  {z=0.;return false;};

  static void setUseDisplayLists(bool u){pusedisplaylists=u;};
  static bool useDisplayLists() {return pusedisplaylists;};

protected:


private:
  static bool pusedisplaylists;
  Vec3 pposition;
  XFPLO::Polyhedron *polyhedron;
  OGLMaterial pmaterial;
  OGLDataCacheItem *cachedData;
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class OGLDataCachePolyItem: public OGLDataCacheItem
{
 public:
  OGLDataCachePolyItem(const XFPLO::Polyhedron *poly);
  ~OGLDataCachePolyItem();
  
  QString printSpecQ()const;
  
  void construct(bool transparent);
  void collectTransparent(OGLTransparentCollector *
			  ,const Vec3 &pos
			  ,const OGLMaterial &mat);

  
 private:
  XFPLO::Polyhedron *polyhedron;
    
};
#ifdef	__cplusplus
extern "C" {
#endif
  
#ifdef	__cplusplus
}
#endif


#endif /* _OGLPOLY_H */

