/* @(#)OGLTransparentCollector.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _OGLTRANSPARENTCOLLECTOR_H
#define _OGLTRANSPARENTCOLLECTOR_H 1


#include <QList>
#include "OGLPrimitives.hh"
#include "OGLBSPTree.hh"



template <class T>
class ValueArray;

class Plane;
class OGLMaterial;

class OGLTransparentCollector{
 public:
  OGLTransparentCollector();
  ~OGLTransparentCollector();

  void addObject(const GLdouble *pvertices
		 ,const GLdouble *pnormals
		 ,const GLfloat *pcolors
		 ,GLenum colormode
		 ,const OGLMaterial &front
		 ,const OGLMaterial &back
		 ,const GLuint *pindices
		 ,long ndefs
		 ,const struct VertexArrayDef *defs);
  void addObjecttoTree(const GLdouble *pvertices
		       ,const GLdouble *pnormals
		       ,const GLfloat *pcolors
		       ,GLenum faces
		       ,const OGLMaterial *front
		       ,const OGLMaterial *back
		       ,const GLuint *pindices
		       ,long ndefs
		       ,const struct VertexArrayDef *defs);
  void reset(const ValueArray<ValueArray<GLdouble> > &seedplanes);

  inline void addToTree(OGLPolygon *poly){
    bsptree->addToTree(poly);}

  inline bool needReConstruct()const{return pneedreconstruct;};
  inline void setNeedReConstruct(bool n){pneedreconstruct|=n;};
  inline void resetNeedReConstruct(){pneedreconstruct=false;};

  void sort(const Vec3 &z);

  void paint(const Vec3 &eye,const Vec3 &z,bool persp);

 private:
  void clean();
  
 private:
  bool pneedreconstruct;
  GLdouble *pvertices; 
  GLdouble *pnormals; 
  GLfloat  *pcolors; 
  GLuint *pindices; 
  long pverticessize; 
  long pindicessize; 
  QList<OGLPrimitives*> pdata;


  OGLBSPTree *bsptree;  

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _OGLTRANSPARENTCOLLECTOR_H */

