/* @(#)OGLUserData.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _OGLUSERDATA_H
#define _OGLUSERDATA_H 1

#include "Vec3.hh"
#include "MyDebug.hh"

class OGLUserData{
  enum Type{TypeVec3=1};
 public:
  OGLUserData(){
    //myDebug() << "OGLUserData born";
  };
  OGLUserData(const Vec3 &v){
    //myDebug() << "OGLUserData(const Vec3&) born";
    ptype=TypeVec3;
    pdata=new Vec3(v);
  };
  ~OGLUserData(){
    //myDebug() << "OGLUserData dying";
    if(pdata){
      if(ptype==TypeVec3){
	//myDebug() << "    type  TypeVec3";
	delete ((Vec3*)pdata);
      }
    }
    pdata=0;
  };

  const Vec3 toVec3()const{
    if(ptype==TypeVec3){
      return *((Vec3*)pdata);
    }else{
      myDebug()<<"OGLUserData not of type Vec3";
      return Vec3();
    }
  };

 private:
  Type ptype;
  void *pdata;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _OGLUSERDATA_H */

