//todo: find compound operations beforehand, with userfilter.
//todo: here only display the stuff
//todo: Spacegroup operations and molecules
//todo: remove tetra and make sheets individual colored
//TODO:  legend width and height need be canvas independend ?
//TODO:  positionibg of legend ?
//todo: cleanup slotPlotCalc and replace with proper command (doRendering?)
//todo: MAC mouse + modifier
//todo: rotate around object
//todo: transparent FS
//todo: status
//todo: cuts
//todo: higher order interpolation
//todo: introduce and formulate rotation midpoints
//todo: hidden line dashing
//todo: fsw
//todo: potential spec points of invisible cells are shown
//
/*************************************************************************
 * @(#)OGLView.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   01 Apr 2010
 *************************************************************************
 */

#include <QMouseEvent>
#include <QMenu>
#include <QMessageBox>
#include <QApplication>
#include "OGLView.hh"
#include "MachineTime.hh"
#include "OGLDataCache.hh"
#include "OGLSphere.hh"
#include "OGLTube.hh"
#include "OGLMeshPoints.hh"
#include "OGLMeshCells.hh"
#include "OGLObject.hh"
#include "OGLLine.hh"
#include "OGLUserData.hh"
#include "OGLTriangleMesh.hh"
#include "OGLMaterial.hh"
#include "OGLLegend.hh"
#include "OGLTransparentCollector.hh"
#include "OGLPoly.hh"
#include "OGLAutoGlyph.hh"
#include "OGLRotationSymbol.hh"
#include "OGLText.hh"
#include "OGLLight.hh"
#include "OGLLightHelper.hh"
#include "Vec3.hh"
#include "Axes.hh"
#include "AntiAliasing.hh"
#include "Fog.hh"
#include "STDoc.hh"
//#include "SpaceGroupOperation.hh"
#include "FSDoc.hh"
#include "STM.hh"
#include "Cluster.hh"
#include "Interrupt.hh"
#include "MyMath.hh"
#include "DocBase.hh"
#include "AtomPropPicker.hh"
#include "AtomFindMarker.hh"
#include "Spsp.hh"
#include "Status.hh"
#include "Light.hh"
#include "Boundary.hh"
#include "DisplayCells.hh"
#include "RegularMesh.hh"
#include "TriangleMesh.hh"
#include "qt5compat.hh"

using namespace XFPLO;


#ifndef GL_MULTISAMPLE
#define GL_MULTISAMPLE GL_MULTISAMPLE_ARB
#endif

Q_DECLARE_METATYPE(ContextMenuContext)


static const int ACSIZE[]={1,1,2,3,4,5,6,6,8};
static const struct{double x;double y;} pj[][8]={
  {
    {0, 0}, 
  },
  {
    {0., 0.}
  },
  {
    {0.25, 0.75}, {0.75, 0.25}
  },
  {
    {0.5033922635, 0.8317967229}, {0.7806016275, 0.2504380877},
    {0.2261828938, 0.4131553612}
  },
  {
    {0.375, 0.25}, {0.125, 0.75}, {0.875, 0.25}, {0.625, 0.75}
  },
  {
    {0.5, 0.5}, {0.3, 0.1}, {0.7, 0.9}, {0.9, 0.3}, {0.1, 0.7}
  },
  {
    {0.4646464646, 0.4646464646}, {0.1313131313, 0.7979797979},
    {0.5353535353, 0.8686868686}, {0.8686868686, 0.5353535353},
    {0.7979797979, 0.1313131313}, {0.2020202020, 0.2020202020}
  },
  {
    {0.4646464646, 0.4646464646}, {0.1313131313, 0.7979797979},
    {0.5353535353, 0.8686868686}, {0.8686868686, 0.5353535353},
    {0.7979797979, 0.1313131313}, {0.2020202020, 0.2020202020}
  },
  {
    {0.5625, 0.4375}, {0.0625, 0.9375}, {0.3125, 0.6875}, {0.6875, 0.8125}
    , {0.8125,0.1875}, {0.9375, 0.5625}, {0.4375, 0.0625}, {0.1875, 0.3125}
  }
};


/* ***********************************************************************
 *
 * ***********************************************************************
 */
class PickAngleObject{
public:
  PickAngleObject():psize(0),pvisible(false){};

  inline void setVisibility(bool v){pvisible=v;}
  inline void reset(){psize=0;};
  inline void setPoint(int i,const Vec3 &p){
    psize=MyMath::max<long>(i+1,psize);pp[i]=p;
    if(i==2){
      Vec3 d12=pp[0]-pp[1];
      Vec3 d32=pp[2]-pp[1];
      double l12=norm(d12);
      double l32=norm(d32);
      double l=MyMath::min<double>(l12,l32)*0.5;
      pp[3]=pp[1]+d12*(l/l12);
      pp[4]=pp[1]+d32*(l/l32);
      psize=5;
    }
    
  };
  
  void draw(){
    if(pvisible){
      glPushMatrix();
      glLineWidth(2);
      glDisable(GL_LIGHTING);
      glBegin(GL_LINES);
      glColor3d(0.7,0,0);
      if(psize>=2){
	glVertex3dv(pp[0]());
	glVertex3dv(pp[1]());
      }
      if(psize>=3){
	glVertex3dv(pp[1]());
	glVertex3dv(pp[2]());
      }
      if(psize>=5){
	glVertex3dv(pp[3]());
	glVertex3dv(pp[4]());
      }
      glEnd();
      glEnable(GL_LIGHTING);
      glLineWidth(1);
      glPopMatrix();  
    }
    
  };
  
private:
  long psize;
  Vec3 pp[5];
  bool pvisible;
};


PickAngleObject pickAngleObject;

/* ***********************************************************************
 *
 * ***********************************************************************
 */
OGLView::OGLView(QWidget *parent)
  :QGLWidget(parent)
  ,pobjects(0)
  ,pwireFrameOnMove(false)
  ,preducedModelOnMove(false)
  ,pdrawReduced(false)
  ,pnoaa(false)
  ,pbadtrans(false)
  ,pblockmove(false)
  ,pmoveblockingclick(false)
  ,pneedrepaint(true)
  ,pmuted(false)
  ,pbufferedrepaint(true)
  ,pprinting(false)
  ,pbadTransparency(false)
  ,pshowpotentialspcepoints(false)
  ,pdoc(0)
  ,atomPropPicker(0)
  ,patomFindMarker(0)
  ,pfog(0)
  ,phasaccumbuffer(false)
  ,phasmultisample(false)
  ,ogldatacache(0)
  ,ptpCollector(0)
  ,pcurrentmoveobject(0)
  ,pallowedmoveobjecttype("None"),pallowedmoveobjectidprefix(""),
   pshowlighthelpers(false)
{

  setMouseTracking(true);

  ogl.init(false);

  pobjects=new OGLObjects(this);
  ptpCollector=new OGLTransparentCollector();
  ogldatacache=new OGLDataCache();

  
  OGLSphere::setUseDisplayLists(ogl.allowDisplayLists());
  OGLTube::setUseDisplayLists(ogl.allowDisplayLists());
  OGLRotationSymbol::setUseDisplayLists(ogl.allowDisplayLists());

  OGLAutoGlyph::setUseDisplayLists(ogl.allowDisplayLists());
  OGLMeshPoints::setUseDisplayLists(ogl.allowDisplayLists());
  OGLMeshCells::setUseDisplayLists(ogl.allowDisplayLists());

  OGLLegend::setUseDisplayLists(ogl.allowDisplayLists());
  OGLText::setUseDisplayLists(ogl.allowDisplayLists());


  patomFindMarker=new AtomFindMarker();

  connect(patomFindMarker,SIGNAL(markAtomsRequest(bool,bool))
	  ,this,SLOT(onMarkAtomsRequest(bool,bool)));

  QGLFormat fmt=format();

  
  //myDebug()<<"ogl.allowMultiSample()="<<ogl.allowMultiSample();
  //myDebug() << "multisampling "<<format().sampleBuffers();
  if(1){ 
    fmt.setSampleBuffers(ogl.allowMultiSample());
    setFormat(fmt);
  }
  if(1){
    if(!format().sampleBuffers()){
      //myDebug()<<"no sampleBuffers";
      if(!format().accum()){
	fmt.setAccum(true);
	setFormat(fmt);
      }
    }  
  }

  
  myDebug() << "doubleBuffers "<<format().doubleBuffer();
  myDebug() << "multisampling "<<format().sampleBuffers();
  myDebug() << "multisample.samples"<<format().samples();
  myDebug() << "accum"<<format().accum();
  myDebug() << "accum"<<format().accumBufferSize();

  //  exit(1);
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::init(DocBase *d)
{
  pdoc=d;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
const View &OGLView::view()const
{
  return pdoc->view();
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */
OGLView::~OGLView()
{
  NSF("OGLView::~OGLView");
  //myDebug() << nsubfunc;
  pobjects->clear();
  delete pobjects;
  if(patomFindMarker) delete patomFindMarker;
  if(ptpCollector) delete ptpCollector; ptpCollector=0;
  if(ogldatacache) delete ogldatacache; ogldatacache=0;
  //  myDebug() << nsubfunc << " done";
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::initializeGL()
{
  NSF("OGLView::initializeGL");
  myDebug() << nsubfunc;
  
  ogl.init(true);
  
  if(0){
    printf("%ld\n",(long)format().openGLVersionFlags());
    printf("%s\n",(char*)glGetString(GL_VERSION));
    String ext=(char*)glGetString(GL_EXTENSIONS);
    StringList sl=ext.split(" ");
    String s=sl.join("\n");
    printf("%s\n",s());
  }
  
//   static const char *yes="yes";
//   static const char *no="no";
  
//   if(doubleBuffer()){
//     setAutoBufferSwap(true);
//   }
//  myDebug() << "autobuffer" << autoBufferSwap();
//   exit(1);


  glEnable(GL_DEPTH_TEST);
  //glDisable(GL_DEPTH_TEST);

  glDisable(GL_MULTISAMPLE);

  glShadeModel(GL_SMOOTH);
  //glShadeModel(GL_FLAT);

  glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);

  //glEnable(GL_COLOR_MATERIAL);
  //glEnable(GL_NORMALIZE);
  glDisable(GL_NORMALIZE);


 
  setLighting();

  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);



  phasaccumbuffer=format().accum();
  phasmultisample=((format().sampleBuffers()) &&(format().samples()>0));

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::applyAntiAliasing()
{
  NSF("OGLView::setAntiAliasing");
  myDebug() << nsubfunc<<antiAliasing.isOn();
  makeCurrent();

  if(antiAliasing.isOn()){
    if(!format().accum()){
      QGLFormat fmt=format();
      fmt.setAccum(true);
      setFormat(fmt);
    }
    myDebug() << "accum"<<format().accum();
    myDebug() << "accum"<<format().accumBufferSize();
  }
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
OGLView::AntiAliasingMode OGLView::currentAntiAliasingMode()
{
  if( phasmultisample) 
    return Hardware;
  else if(phasaccumbuffer)
    return Software;
  else
    return None;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::setTransNeedReConstruct(bool r)
{
  ptpCollector->setNeedReConstruct(r);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::setLighting()
{
  NSF("OGLView::setLighting");
  //myDebug() <<nsubfunc;
  if(!pdoc) return;

  const Lights *lights=pdoc->lights();

  makeCurrent();
  
  OGLLights::issueGlobalAmbient(lights->ambientLight());
  OGLLights::issueLights(lights);  

  ogl.reportGLError(nsubfunc,"ogllights.initializeLights()");

}



/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::resizeEvent(QResizeEvent *event)
{
  NSF("OGLView::resizeEvent");
  myDebug()<<nsubfunc;
  QGLWidget::resizeEvent(event);
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::applyFog()
{
  makeCurrent();

  if(pfog && pfog->useFog()){
    glEnable(GL_FOG);
    glFogf(GL_FOG_DENSITY,pfog->density());
    GLfloat fogcolor[4];
    GLfloat4FromQRgb(fogcolor,pfog->color());    
    glFogfv(GL_FOG_COLOR,fogcolor);

    if(pfog->fogMode()==Fog::Exp)
      glFogi(GL_FOG_MODE,GL_EXP);
    else if(pfog->fogMode()==Fog::Gaussian)
      glFogi(GL_FOG_MODE,GL_EXP2);
    else if(pfog->fogMode()==Fog::Linear)
      glFogi(GL_FOG_MODE,GL_LINEAR);

    glHint (GL_FOG_HINT, GL_DONT_CARE);




    if(pfog->fogMode()==Fog::Linear){
      View &view=pdoc->view();
      double n=view.near();
      double f=view.far();
      
      n=view.near()+pfog->near()*(view.far()-view.near());
      f=view.near()+pfog->far()*(view.far()-view.near());
      
      glFogf (GL_FOG_END, f);
      glFogf (GL_FOG_START, n);
    }

    
  }else{
    glDisable(GL_FOG);
  }
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::resizeGL(int width, int height)
{
  NSF("OGLView::resizeGL");
  myDebug() <<nsubfunc<< "width"<<width;
  makeCurrent();

  glViewport(0,0, width, height);
  

  setCamera();

  emit sizeChanged(this);

}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::paintGL()
{
  NSF("OGLView::paintGL");
  //myDebug()<<nsubfunc<<pneedrepaint;
  MachineTime time;
  makeCurrent();
  if(pmuted){
    //myDebug()<<"muted";
    glClearDepth(1.0);
    GLfloat rgb[4];
    GLfloat4FromQRgb(rgb,pdoc->lights()->backgroundColor());
    glClearColor(rgb[0],rgb[1],rgb[2],rgb[3]);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    return;
  }
  //myDebug() << nsubfunc;

  bool repaint=false;
  
  if(pneedrepaint){
    repaint=true;
    ptriggerrepaint=true;
  }else{
    if(ptriggerrepaint){
      ptriggerrepaint=false;
      repaint=true;
    }
  }
  
  if(pbufferedrepaint && !repaint && doubleBuffer()) {
    //myDebug()<<"swapBuffers";
    swapBuffers();
    return;
  }
  
  ogldatacache->markAsOld();
  
  // myDebug()<< "OGLView::paintGL: ptpCollector->needReConstruct()"
  // 	   <<ptpCollector->needReConstruct()<<"pseedplanes"<<pseedplanes.size();
  pobjects->collectTransparentObjects(pdrawReduced,pseedplanes);
  

  glClearDepth(1.0);
  GLfloat rgb[4];
  GLfloat4FromQRgb(rgb,pdoc->lights()->backgroundColor());
  glClearColor(rgb[0],rgb[1],rgb[2],rgb[3]);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  applyFog();
  //  applyAntiAliasing();

  View &view=pdoc->view();

  if(!pbadtrans ) ptpCollector->sort(view.z());
  


  if( antiAliasing.isOn() && 
     (antiAliasing.whileMoving() || ! pnoaa) && 
     ((!antiAliasing.forPrintingOnly()) ||  
      (antiAliasing.forPrintingOnly() && pprinting) )
     ){

    if(phasmultisample){
      //myDebug()<<"antialiasing with multisample";
      glEnable(GL_MULTISAMPLE);
      drawScene(view);
      glDisable(GL_MULTISAMPLE);
    }else if(phasaccumbuffer){
      //myDebug()<<"antialiasing with accum";
      
      
      GLint viewport[4];
      glGetIntegerv(GL_VIEWPORT,viewport);
      glClear(GL_ACCUM_BUFFER_BIT);
      
      double T=view.top();
      int pjitter=antiAliasing.jitter();
      for(int jitter=0;jitter<ACSIZE[pjitter];jitter++){
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
	//myDebug()<< "jitter"<<jitter<<pj[pjitter][jitter].x<<pj[pjitter][jitter].y;
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	
	double dx=1.*(pj[pjitter][jitter].x-0.5)/viewport[2]*W*T;
	double dy=1.*(pj[pjitter][jitter].y-0.5)/viewport[3]*H*T;
	glTranslated(dx,dy,0);
	glMatrixMode(GL_MODELVIEW);
	
	drawScene(view);
	
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	
	glAccum(GL_ACCUM,1.0/ACSIZE[pjitter]);
      }
      glAccum(GL_RETURN,1.0); 
    }else{
      //myDebug()<<"no antialiasing due to missing hardware capabilities";
      drawScene(view);
    }
  }else{
    //myDebug()<<"no antialiasing";
    drawScene(view);
  }
 
  pneedrepaint=false;

  ogl.reportGLError(nsubfunc);
  
  
  //swapBuffers();
    
  ogldatacache->cleanOldCacheData();
  
  //time.print(nsubfunc);
    
  return;
}



/* ***********************************************************************
 *
 * ***********************************************************************
 */

void OGLView::drawScene(const View &)
{
  makeCurrent();
  
  if(0){

    glPushMatrix();
    glDisable(GL_LIGHTING);
    glColor4f(0.,1.,1.,1.);
    
    glBegin(GL_POLYGON);
    glVertex3d(0.,0.,0);
    glVertex3d(1.,0.,0);
    glVertex3d(1.,1.,0);
    glVertex3d(0.,1.,0);
    glEnd();
    
    glEnable(GL_LIGHTING);
    
    glPopMatrix();  
    
  }


  View &view=pdoc->view();
  Matrix3x3 M(view.x(),view.up(),view.z());
  Vec3 nz=M*Vec3(0,0,-1);
  Vec3 eye=view.origin_cam_w(); //   eye=M*eye+view.origin_cam_w();


  pobjects->paint(eye,nz,pdrawReduced,pbadtrans);


  if(0){
    glPushMatrix();  
    
    glColor4f(0.,1.,0.,0.);

    glScaled(6,6,6);
    glTranslated(0,0,0);

    glBegin(GL_POLYGON);
    glVertex3d(0.,0.,0);
    glVertex3d(1.,0.,0);
    glVertex3d(1.,1.,0);
    glVertex3d(0.,1.,0);
    glEnd();
    glPopMatrix();  
  }

  pickAngleObject.draw();

}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::setAllowedMoveObjects(const String &objectType
				    ,const String &idprefix)
{
  pallowedmoveobjecttype=objectType;
  pallowedmoveobjectidprefix=idprefix;
}

/* ***********************************************************************
 * set GL projections from pview
 * ***********************************************************************
 */
void OGLView::setCamera()
{
  if(!pdoc) return;
  if(pmuted) return;
  NSF("OGLView::setCamera()");
  //myDebug() << "width" << width();
  //myDebug() << "height" << height();



  View &view=pdoc->view();
  //  view.print();

  //myDebug() << "theta="<<view.theta();



  makeCurrent();


  double far,near;
  pobjects->NFPlane(view.z(),near,far);

  //  myDebug()<<"N/F="<<near<<far;

  view.setGLViewTransformation(near,far);



  double r0=1.*width()/height();
				
  if(r0/(1.-view.lowerRim())>1){
    winB=-(1+view.lowerRim())/(1-view.lowerRim());
    winT=1;
    H=winT-winB;

    W=H*r0;
    winL=-W/2;
    winR=W/2;

  }else{
    winL=-1;
    winR= 1;
    W=winR-winL;

    // H=winT-winB
    // r0=W/H
    // winB=-winT-d
    // d/H=rim

    H=W/r0;
    winB=H*(-1-view.lowerRim())/2;
    winT=H*(1-view.lowerRim())/2;
  

  }


  //if(width()>height()){
  //    worldUnitInPixel=height()/view.radius();
  //}else{
  //    worldUnitInPixel=width()/view.radius();
  //}

  

  if(view.isPerspective()){
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    double T=view.top();
    glFrustum(winL*T,winR*T,winB*T,winT*T,view.near(),view.far());
    ogl.reportGLError(nsubfunc,"glFrustum");
  }else{
//     myDebug() << "N="<<N;
//     myDebug() << "F="<<F;
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    double T=view.top();
#ifdef QT_OPENGL_ES_1
    glOrthod(winL*T,winR*T,winB*T,winT*T,view.near(),view.far());
#else
    glOrtho (winL*T,winR*T,winB*T,winT*T,view.near(),view.far());
#endif
  }

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  OGLLights::placeCameraLights(pdoc->lights(),pdoc->view().radius(),
			       Vec3(0.,0.,-pdoc->view().focalDistance()));
  //			       ,MyMath::max<double>(1,fabs(view.far()-view.near())));


  glMultMatrixd(view.matrix()());
  glTranslated(-view.origin_cam_w()[0],-view.origin_cam_w()[1],
	       -view.origin_cam_w()[2]);


  pseedplanes.clear();
  //myDebug()<<"pdoc"<<pdoc<<pdoc->bound();
  if(1 ){
    double radius=pdoc->dataRadius();
    Vec3 mp=pdoc->dataMidPoint();
    pseedplanes.resize(3);
    //myDebug()<<"pseedplanes"<<pseedplanes;
    long i=0;
    pseedplanes[i++]<<1.0<<0.0<<0.0<<0.0*radius+mp[0];
    pseedplanes[i++]<<0.0<<1.0<<0.0<<0.0*radius+mp[1];
    pseedplanes[i++]<<0.0<<0.0<<1.0<<0.0*radius+mp[2];
  }
  //myDebug()<<"define pseedplanes "<<pseedplanes;
  pneedrepaint=true;
  
  return;  
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::resetPanZoom(CameraResetMode mode,bool render,const Vec3 &center)
{
  if(!pdoc) return;
  NSF("OGLView::resetPanZoom");
  //  myDebug() << nsubfunc << mode << render;
  
  View &view=pdoc->view();

  //view.print();
  // for ortho camera: move the midpoint into the boundary center
  //                   and rescale
  if(mode & Rescale) {
    view.setRadius(pdoc->dataRadius());
    view.setScale(1.);
  }
  if(mode & Center) { 
    view.setFocus(pdoc->dataMidPoint());
  }

  if(mode == UserFocus) { 
    view.setFocus(center);
  }

  //view.print();

  
  if(render)
    doRendering();


}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::mouseMoveEvent(QMouseEvent *event)
{
  if(!pdoc) return;

  //myDebug()<<"pblockmove="<<pblockmove;

  if(pblockmove) return;


  View &view=pdoc->view();

  //myDebug() << "lastPos" << lastPos;
  //myDebug() << "pos" <<  event->pos();

  int dx = event->x() - lastPos.x();
  int dy = event->y() - lastPos.y();

  //myDebug() << "dx"<<dx;
  //myDebug() << "dy"<<dy;

  
  if( ( (event->modifiers()== Qt::ShiftModifier) && 
	(event->buttons() & Qt::LeftButton)) ||
      (event->buttons() & Qt::MidButton)
      ){

    //myDebug() << "scale" <<  scale;   
    const Vec3 &up=view.up();
    const Vec3 &x=view.x();
    double T=view.radius()*view.lambda()/view.scale();
    //myDebug() << "T="<<T << W << H;
    view.setFocus(view.focus()-T*W*dx/width()*x+T*H*dy/height()*up);
    
    
    setCamera();
    pneedrepaint=true;
    updateGL();
  }else if ( (event->modifiers()== Qt::ControlModifier) &&
	     (event->buttons() & Qt::LeftButton)) {

    Vec3 vold(lastPos.x()-0.5*width(),-(lastPos.y()-0.5*height()),0);
    Vec3 v(event->x()-0.5*width(),-(event->y()-0.5*height()),0);

    double fac=norm(vold)*norm(v);

    if(fac>0){
      
      double sang=MyMath::max<double>(-1.,MyMath::min<double>(1.,vold.cross(v)[2]/fac));
      double cang=vold*v/fac;
      
      view.setUp(view.x()*sang+view.up()*cang);
      
      setCamera();
      pneedrepaint=true;
      updateGL();
      
    }    
    
  }else if (event->buttons() & Qt::RightButton || 
	    ((event->buttons() & Qt::LeftButton) && 
	     (event->modifiers() == (Qt::ShiftModifier | Qt::ControlModifier) ))) {

    double amount=-2.*dy/height();
    view.pan(amount);
    setCamera();
    pneedrepaint=true;
    updateGL();
  }else if (event->buttons() & Qt::LeftButton) {
    //myDebug()  << "rotation";

    if(pcurrentmoveobject){
      double T=view.radius()*view.lambda()/view.scale();
      pcurrentmoveobject->shiftInViewCoords(T*W*dx/width(),-T*H*dy/height());
      pneedrepaint=true;
      updateGL();
    }else{
      
      Vec3 v(dx,-dy,0);
      double dphi=norm(v);
      if(dphi!=0){
	v/=dphi;
	dphi*=Pi/width();
	
	double c=cos(dphi);
	double s=sin(dphi);
	
	Vec3 n=Vec3(0,0,1).cross(v);
	
	
	//myDebug()  << "dphi" << dphi;
	//myDebug()  << "v" << v.printS()();
	//myDebug()  << "n" << n.printS()();
	
	// (n x r)_k = n_i r_j eps_ijk =  r_j R_jk
	// R_jk=n_i eps_ijk
	Matrix3x3 R( 
		    0    ,  n[2] ,-n[1],
		    -n[2] ,  0    , n[0],
		    n[1] , -n[0] , 0 );
	R=-R*s+Matrix3x3::unitMatrix()*c+n.outer(n)*(1-c);
	
	//myDebug()  << "R" << R.printS();
	
	
	Matrix3x3 S(view.x(),view.up(),view.z());
	S=S*R;
	
	view.setZ(S(2));
	view.setUp(S(1));
	//view.print();
	setCamera();
	pneedrepaint=true;
	updateGL();
      }    
    }
  }
  lastPos = event->pos();

  // now for picking
  //myDebug() << "pos" <<  event->pos();
  {
    double x=1.*event->x()/width()-0.5;
    double y=winT/H-1.*event->y()/height();
    double T=view.top();
    OGLObject *obj=pobjects->pickObject(view,T*W*x,T*H*y);
    if(obj && obj->isA("OGLSphere")){
      emit atomInfoToShow(obj->id());
    }else{
      emit atomInfoToShow("");
    }

  }


  return;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::wheelEvent(QWheelEvent *event)
{
  if(!pdoc) return;
  View &view=pdoc->view();

  double degree=event->delta()/8.;
  double amount=degree/75.;

  view.pan(amount);
  setCamera();
  pneedrepaint=true;
  updateGL();
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::mousePressEvent(QMouseEvent *event)
{
  NSF("OGLView::mousePressEvent");
  //  myDebug()<<nsubfunc;
  
  View &view=pdoc->view();
  double x=1.*event->x()/width()-0.5;
  double y=winT/H-1.*event->y()/height();
  double T=view.top();
  
  // now for picking
  if(event->button()  ==  Qt::LeftButton && pdoc){
    

    OGLObject *obj=pobjects->pickObject(view,T*W*x,T*H*y);
    long atomindex=-1;
    bool gotomove=true;
    //myDebug() << "pick"<<obj;
    if(obj && obj->isA("OGLSphere")){
      //myDebug() << "pick"<<obj->id();
      if(obj->id().startsWith("potential special point dots")){
	emit objectClicked(obj->id(),obj->userData());
	gotomove=false;
      }else if(obj->id().startsWith("atom")){
	atomindex=QString(obj->id()()).remove("atom ").toInt();
	emit atomClicked(atomindex);
	gotomove=false;
      }
    }else if(obj && obj->isA(pallowedmoveobjecttype)){
      if(obj->id().startsWith(pallowedmoveobjectidprefix)){
	pcurrentmoveobject=obj;
      }
    }
    //myDebug()<<"gotomove="<<gotomove;
    if(gotomove) goto move;

    if(!atomPropPicker) {
      if(pmoveblockingclick) {
	pblockmove=true;
	pmoveblockingclick=false;
	return;
      }else{
	goto move;
      }
    }

    makeCurrent();

    if(!atomPropPicker->isAtomInList(atomindex)){
      
      if(atomPropPicker->pickedSize()==3){
	// unmark the last pick-atom
	long lastindex=atomPropPicker->last();
	atomPropPicker->takeAtom(lastindex);
	if(!markPickedAtom(lastindex,false)){
	  myDebug("Oops atompicker invalid?"); exit(2);
	}
      }
      
      atomPropPicker->addAtom(atomindex);
      markPickedAtom(atomindex,true);
    }else{
      atomPropPicker->takeAtom(atomindex);
      markPickedAtom(atomindex,false);
    }
    if(atomPropPicker->pickedSize()>1){
      
      pickAngleObject.reset();
      
      if(atomPropPicker->pickedSize()>=2){


	int a1=pobjects->indexOf(Sprintf("atom %ld",(*atomPropPicker)[0]));
	int a2=pobjects->indexOf(Sprintf("atom %ld",(*atomPropPicker)[1]));

	MASSERT("Oops",a1>=0);
	MASSERT("Oops",a2>=0);

	OGLSphere *sph1=dynamic_cast<OGLSphere*>((*pobjects)[a1]);
	OGLSphere *sph2=dynamic_cast<OGLSphere*>((*pobjects)[a2]);
	
	MASSERT("Oops",sph1);
	MASSERT("Oops",sph2);
	
	pickAngleObject.setPoint(0,sph1->position());
	pickAngleObject.setPoint(1,sph2->position());
      }
      
      if(atomPropPicker->pickedSize()==3){
	int a3=pobjects->indexOf(Sprintf("atom %ld",(*atomPropPicker)[2]));
	MASSERT("Oops",a3>=0);

	OGLSphere *sph3=dynamic_cast<OGLSphere*>((*pobjects)[a3]);
	MASSERT("Oops",sph3);
	
	pickAngleObject.setPoint(2,sph3->position());
       }
      
      pickAngleObject.setVisibility(true);
      
    }else{
      pickAngleObject.setVisibility(false);
    }

    updateGL();
    
    atomPropPicker->pickerChanged();
    
  

    pblockmove=true;
    
    return;
  }else if(event->button()  ==  Qt::RightButton && pdoc){
    QList<ContextMenuContext> comucontextlist;
    OGLObject *obj=pobjects->pickObject(view,T*W*x,T*H*y);
    bool doreturn=false;
    if(obj && obj->isA("OGLSphere")){
      if(obj->id().startsWith("atom")){
	//myDebug()<<"pcopcontexts="<<pcontexts;
	long atomindex=QString(obj->id()()).remove("atom ").toInt();
	if(pcontexts["deletewyck"]){
	  comucontextlist.append(ContextMenuContext().setAtomDelete(atomindex));
	  doreturn=true;

	}
	if(pcontexts["recenter"]){
	  STDoc *stdoc=dynamic_cast<STDoc*>(pdoc);
	  //myDebug()<<stdoc;
	  const Atom &at=stdoc->cluster->atom(atomindex);
	  //myDebug()<<"obj"<<obj<<at.tauD;
	  comucontextlist.append(ContextMenuContext().setViewCenter(at.tauD));
	  doreturn=true;
	}
	if(pcontexts["hideatom"]){
	  comucontextlist.append(ContextMenuContext().setHideAtom(atomindex));
	  doreturn=true;

	}
      }
    }
    if(doreturn) {
      pblockmove=true;
      contextMenu(comucontextlist,event);
      return;
    }
    goto move;
  }

 move:;
  //myDebug()<<"move";
  lastPos = event->pos();
  pnoaa=true;
  bool update=false;
  if(pbadTransparency){
    pbadtrans=true;
    update|=true;
  }
  if(pwireFrameOnMove || preducedModelOnMove){
    if(pwireFrameOnMove){
      makeCurrent();
      glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
    }
    if(preducedModelOnMove) pdrawReduced=true;
    update|=true;
  }
  
  if(update){
    pneedrepaint=true;
    updateGL();
  }

  //myDebug()<<nsubfunc<<"move: "<<pbadtrans;

  return;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::contextMenu(const QList<ContextMenuContext> &contextlist,
			  QMouseEvent *event)
{
  QMenu *menu=new QMenu("Context",this);
  QAction *a;
  QMenu *m=menu;
  foreach( const ContextMenuContext &comuc,contextlist){
    //myDebug()<<comuc.type();
    a=m->addAction(comuc.menuTitle(),this,SLOT(contextMenuCallback()));
    a->setData(QVariant::fromValue(comuc));
  }
  menu->exec(event->globalPos());
  pblockmove=false;
  delete menu;

}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::contextMenuCallback()
{
  QAction *a=dynamic_cast<QAction*>(sender());
  if(!a) return;
  ContextMenuContext comuc=a->data().value<ContextMenuContext>();
  emit contextActionRequest(comuc);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::mouseReleaseEvent(QMouseEvent *event)
{
  NSF("OGLView::mouseReleaseEvent");
  //myDebug()<<nsubfunc<<pbadtrans<<pblockmove;

  //todo: notify the dialog about change of pfshift
  if(pcurrentmoveobject){
    OGLText *txt=dynamic_cast<OGLText*>(pcurrentmoveobject);
    if(txt){
      emit textShiftChanged(txt->id(),txt->getShift());

    }
  }
  pcurrentmoveobject=0;

  Q_UNUSED(event);
  if(pblockmove){
    pblockmove=false;
    return;
  }
  bool update=false;
  if(pwireFrameOnMove || preducedModelOnMove){
    if(pwireFrameOnMove){
      makeCurrent();
      glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
    }
    pdrawReduced=false;
    update|=true;
  }
  if(pnoaa){
    pnoaa=false;
    update|=true;
  }
  if(pbadtrans){
    pbadtrans=false;
    update|=true;
  }

  //myDebug()<<nsubfunc<<"end"<<pbadtrans<<update;
  if(update){
    pneedrepaint=true;
    updateGL();
  }


}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::setAtomPropPicker(AtomPropPicker *ap)
{
  NSF("OGLView::setAtomPropPicker");
  bool render=setAtomPickerMarkers(false) || !ap;
  pickAngleObject.setVisibility(false);
  if(render){
    makeCurrent();
    pneedrepaint=true;
    updateGL();
  }
  atomPropPicker=ap;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool OGLView::setAtomPickerMarkers(bool onoff)
{
  NSF("OGLView::setAtomPickerMarkers");
  //myDebug() << nsubfunc << "atomPropPicker"<<atomPropPicker;

  if(!atomPropPicker) return false;

  bool needrendering=false;

  for(int i=0;i< atomPropPicker->pickedSize();i++){
    long atindex=(*atomPropPicker)[i];
    needrendering|=markPickedAtom(atindex,onoff);
  }
  return needrendering;
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */

bool OGLView::markPickedAtom(long atindex,bool onoff)
{
  NSF("OGLView::markPickedAtom");
  myDebug() << nsubfunc << atindex <<onoff;
  if(atindex<0)return false;
  
  makeCurrent();

  int a1=pobjects->indexOf(Sprintf("atom %ld",atindex));


  OGLSphere *sph=dynamic_cast<OGLSphere*>((*pobjects)[a1]);
  if(!sph)return false;

  STDoc *stdoc=dynamic_cast<STDoc*>(pdoc);
  const Atom &at=stdoc->cluster->atom(atindex);

  QRgb basecolor=sph->material().base();
  QRgb diffusecolor=(onoff?~basecolor:basecolor)| 0xff000000;
  double darkest=0.3;
  QRgb emissioncolor=(onoff? scaleRgb(0xffffff,pow(darkest,1))|0xff000000 : 0x0);

  colorAtom(sph,diffusecolor,emissioncolor,
	    at.property.material().specularColor(),
	    at.property.material().shininess());
  
  pneedrepaint=true;

  return true;

}




/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::onMarkAtomsRequest(bool onoff,bool update)
{
  //myDebug() << "markAtoms";

  makeCurrent();

  if(!pdoc) return;

  const QList<Atom> &al=patomFindMarker->atomList();
  const AtomMarkerProperties &amp=patomFindMarker->properties();
  bool render=false;
  foreach(Atom at,al){
    int a1=pobjects->indexOf(Sprintf("atom %ld",at.index));
    OGLSphere *sph=dynamic_cast<OGLSphere*>((*pobjects)[a1]);
    if(sph){
      //myDebug() << "a1"<<a1;
      QRgb basecolor=sph->material().base();
      QRgb diffusecolor=(onoff?amp.color():basecolor)| 0xff000000;
      //QRgb diffusecolor=(basecolor| 0xff000000);
      QRgb spotcolor=(onoff & !amp.isSpecular()?0x0:
		      at.property.material().specularColor());
      double darkest=(onoff ? amp.emission():0.);
      QRgb emissioncolor=(onoff? scaleRgb(0xffffff,pow(darkest,1))|0xff000000 : 0x0);

      colorAtom(sph,diffusecolor,emissioncolor,spotcolor,
		at.property.material().shininess());
      
      pneedrepaint=true;
      render=true;
    }
  }
  if(render&&update){
    pneedrepaint=true;
    //myDebug() << "updateGL";
    updateGL();
  }
  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::reCalcScene()
{

  NSF("OGLView::reCalcScene");
  //myDebug() << nsubfunc;

  if(!pdoc) return;


  
  

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::toggleHiddenAtoms(const STDoc *stdoc,bool on)
{
  NSF("OGLView::toggleHiddenAtoms");
  myDebug() << nsubfunc<<on;

  makeCurrent();
  if(!stdoc) return;

  long na=stdoc->cluster->numAtoms();

  for(long i=0;i<na;i++){
  
    const Atom &atom=stdoc->cluster->atom(i);

    int ind=pobjects->indexOf(Sprintf("atom %ld",i));
    if(ind>=0 && (*pobjects)[ind]->isA("OGLSphere")){
      OGLSphere *sph=(OGLSphere*)(*pobjects)[ind];
      sph->setHidden(!(on || atom.visible));
    }
  }

  pneedrepaint=true;

}





/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawSTMAtom(const STDoc *stdoc)
{
  NSF("OGLView::drawSTMAtom");
  //myDebug() << nsubfunc;
  
  pobjects->clear("stm atom ");
  makeCurrent();
      
  if(!stdoc) return;
  
  
  const STM *stm=stdoc->stm;
    
  double radius=stm->atomicRadius()*stdoc->ballscale.D*0.5;
    
  OGLSphere *sph=new OGLSphere(stm->tauD(),radius
			       ,OGLSphere::Icosahedron,3);
    
  sph->setPickable(true);
  sph->setID("stm atom 1");
  sph->setHidden(!stdoc->stm->visible());
  
  
  //sph->setTransparent(temp_transparent);
  //ptpCollector->setNeedReConstruct(true);
  
  {      
    OGLMaterial &mat=sph->material();
    mat.setBase(stdoc->stm->property().material().color()); // todo: This is only for memorizing,
    //todo: does that belong into material?
    colorAtom(sph,stm->property().material().color(),0x0,
	      stm->property().material().specularColor(),
	      stm->property().material().shininess());
  }

  pobjects->append(sph);
  
    
  
  pneedrepaint=true;

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawAtoms(const STDoc *stdoc)
{
  NSF("OGLView::drawAtoms");
  //myDebug() << nsubfunc;
  
  pobjects->clear("atom ");
  makeCurrent();
      
  if(!stdoc) return;
  
  long na=stdoc->cluster->numAtoms();
  
  for(long i=0;i<na;i++){
    const Atom &atom=stdoc->cluster->atom(i);
    
    double radius=atom.atomicRadius()*stdoc->ballscale.D*0.5;
    
    OGLSphere *sph=new OGLSphere(atom.tauD(),radius,OGLSphere::Icosahedron,3);
    //OGLSphere *sph=new OGLSphere(atom.tauD(),radius,OGLSphere::Earth,22,22);
    
    sph->setPickable(true);
    sph->setID(Sprintf("atom %ld",i));
    Settings set("structure");
    bool on=set.getBool("Atoms/ShowHidden",false);

    sph->setHidden(!(on || atom.visible));



    //sph->setTransparent(temp_transparent);
    //ptpCollector->setNeedReConstruct(true);

    pobjects->append(sph);

    
  }
  pneedrepaint=true;

}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::standardMaterialSettings(OGLMaterial &mat,QRgb base,double opacity)
{
  QRgb opac=MyMath::max<long>(0,MyMath::min<long>(255,((unsigned int)(opacity*255))))<<24;

  mat.setBase(base);
  mat.setDiffuse((base&0xffffff)|opac);
  mat.setAmbient((base&0xffffff)|0xff000000);
  mat.setSpecular(0xffffffff);
  
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawBonds(const STDoc *stdoc)
{
  NSF("OGLView::drawBonds");
  //myDebug() << nsubfunc;

  pobjects->clear("bond ");
  makeCurrent();

  if(!stdoc) return;

  long nb=stdoc->cluster->numBonds();

  for(long i=0;i<nb;i++){
    const Bond &bond=stdoc->cluster->bond(i);

    if(bond.visible){
      double radius=bond.radius*stdoc->ballscale.D*0.5*stdoc->stickballratio.D;

      OGLTube *tube=new OGLTube(OGLTube::CylinderCap
				,bond.bondpoints[0]
				,bond.bondpoints[1]
				,radius,12);
      
      tube->setID(Sprintf("bond %ld",i));

      {//coloring
	QRgb ac=bond.color;
	OGLMaterial &mat=tube->material();
	mat.setBase(ac);
	mat.setDiffuse(ac);
	mat.setAmbient(ac);
	mat.setSpecular(0x00000000);
	//mat.setShininess(50.);

      }
      pobjects->append(tube);
      
    }
    
  }
  pneedrepaint=true;

}

/* ***********************************************************************
 * for sorting an eliminating operations
 * ***********************************************************************
 */
class OperationDescriptor{
public:
  OperationDescriptor():active(false),type(OGLRotationSymbol::Rotation),
			pos1(0,0,1),axis((pos1-pos0).normalized()),
			order(1),mtau0(0),originonaxisrel(0),
			pos0perp(pos0-axis*(axis*pos0)){ };
  OperationDescriptor(bool show,OGLRotationSymbol::OGLRotationSymbolType t,
		      const Vec3 &p0,const Vec3 &p1,
		      long o,long m,double orel,
		      double mmu0,double ddmu,
		      const QString &i)
    :active(show),type(t),pos0(p0),pos1(p1),order(o),mtau0(m),
     originonaxisrel(orel),id(i),mu0(mmu0),dmu(ddmu){
    if(order!=1){
      axis=(pos1-pos0).normalized();
      pos0perp=pos0-axis*(axis*pos0);
    }
  };

  bool equalGeometry(const OperationDescriptor &other,double tol=1.0e-6)const
  {
    if(order==1){
      if(other.order==1){
	Vec3 p=other.pos0-pos0;
	return (norm(p)<tol);
      }else{
	Vec3 p=(pos0-other.pos0)-other.axis*((pos0-other.pos0)*other.axis);
	return (norm(p)<tol);
      }
    }else{
      if(other.order==1){
	Vec3 p=(other.pos0-pos0)-axis*((other.pos0-pos0)*axis);
	//myDebug()<<"p="<<p<<(norm(p)<tol);
	return (norm(p)<tol);
      }else{
	return (fabs(1-fabs(axis*other.axis))<tol
		&& norm(pos0perp-other.pos0perp)<tol );
      }
    }
  };

  String printS(long index)const{
    if(type==OGLRotationSymbol::Rotation){
      return Sprintf("%-8s operation %ld: C%ld_%ld axis (%s) at %s",
		     (active?"active":"inactive"),
		     index,
		     order,mtau0,axis.printS()(),
		     pos0.printS()());
    }else if(type==OGLRotationSymbol::MirrorRotation){
      if(order==1){
	return Sprintf("%-8s operation %ld: I at %s;",
		       (active?"active":"inactive"),
		       index,
		       pos0.printS()());
      }else{
	return Sprintf("%-8s operation %ld: B%ld_%ld axis (%s) at %s; %g",
		       (active?"active":"inactive"),
		       index,
		       order,mtau0,axis.printS()(),
		       pos0.printS()(),originonaxisrel);
      }
    }else if(type==OGLRotationSymbol::AxisWithCenter){
      return Sprintf("%-8s operation %ld: %ld_%ld/m axis (%s) at %s; %g",
		     (active?"active":"inactive"),
		     index,
		     order,mtau0,axis.printS()(),
		     pos0.printS()(),originonaxisrel);
    }else{
      myDebug()<<"what type?";
      exit(1);
      
    }
    return "???";
  };
  


public:
  bool active;
  OGLRotationSymbol::OGLRotationSymbolType type;
  Vec3 pos0,pos1,axis;
  long order,mtau0;
  double originonaxisrel;
  QString id;
  double mu0,dmu;
private:
  Vec3 pos0perp;
};

/* ***********************************************************************
 *
 * ***********************************************************************
 */

OperationDescriptor highestSymmetry(OperationDescriptor &a,
				    OperationDescriptor &b)
{
  OperationDescriptor res=a;
  OperationDescriptor &aa=a;
  OperationDescriptor &bb=b;
  
  if(OGLRotationSymbol::
     equalBaseType(aa.type,OGLRotationSymbol::MirrorRotation) &&
     bb.type==OGLRotationSymbol::Rotation ){
    MyMath::swap(aa,bb);
  }

  long D=MyMath::gcd(aa.order,bb.order);
  myDebug()<<"aorder,border,D"<<aa.order<<bb.order<<D;
  
  long n1=aa.order/D;
  long n2=bb.order/D;

  res.order=D*n1*n2;

  // find beta1 and alpha1 such that beta1*n1+alpha1*n2=1
  long beta1=0;
  for(int i=0;i<=n2;i++){
    if( (i*n1)% n2==1){
      beta1=i;
      break;
    }
  }
  long alpha1=(1-beta1*n1)/n2;
  myDebug()<<"alpha1="<<alpha1<<"beta1="<<beta1;
  myDebug()<<"[n1]="<<n1<<"[n2]="<<n2;
  myDebug()<<" alpha1*"<<n2<<"+beta1*"<<n1<<"=1 N="<<res.order;

  //alpha*n2*mtau0_1+n1*beta*mtau0_2=k




  if( aa.type==OGLRotationSymbol::Rotation &&
      bb.type==OGLRotationSymbol::Rotation    ){
    res.mtau0=(alpha1*aa.mtau0*n2+beta1*bb.mtau0*n1)%res.order;
    while(res.mtau0<0){
      res.mtau0+=res.order;
    }
    return res;
  }

  long beta=res.order*beta1;
  long alpha=res.order*alpha1;

  myDebug()<<"alpha="<<alpha<<"beta="<<beta;

  bool hasinv=false;
  bool hasmir=false;
  
  if( aa.type==OGLRotationSymbol::Rotation &&
	    OGLRotationSymbol::
	    equalBaseType(bb.type,OGLRotationSymbol::MirrorRotation) ){
    myDebug()<<"rot and mirror ..."<<aa.type<<bb.type;

    hasinv=(bb.type&OGLRotationSymbol::AxisWithCenterFlag);
    hasmir=(bb.type&OGLRotationSymbol::AxisWithCenterFlag);

    // find beta such that beta*n1+alpha*n2=l*D*n1*n2
    
    long betainv=beta;
    if(betainv%2!=0){
      // we have inversion in the group product
      hasinv|=true;
      betainv=beta;
      myDebug()<<"betainv was odd";
    }
    if(n2%2!=0){
      // we have inversion in the group product
      hasinv|=true;
      myDebug()<<"betainv was even but n2 odd";
      betainv=n2;
    }
    if(hasinv) {
      long alphainv=(res.order-betainv*n1)/n2;
      myDebug()<<"alphainv*n2+betainv*n1="<<alphainv*n2+betainv*n1;
      res.mtau0=(alpha1+beta1*alphainv)*aa.mtau0*n2%res.order;
      while(res.mtau0<0){ res.mtau0+=res.order; }
      myDebug()<<"have inversion";
    }
    

    if((res.order)%2==0){
      long betamirr=beta/2;
      if(betamirr%2!=0 || n2%2!=0){
	// we have mirror in the group product
	hasmir|=true;
	myDebug()<<"have mirror";
	// no consideration for mtau0, since if it has inversion,
	// we already took care of mtau0, if it does not have Inv
	// it cannot be no-symmorphic
      }
    }
   
    
  }else if( OGLRotationSymbol::
	    equalBaseType(aa.type,OGLRotationSymbol::MirrorRotation) &&
	    OGLRotationSymbol::
	    equalBaseType(bb.type,OGLRotationSymbol::MirrorRotation) ){


    hasinv=(aa.type&OGLRotationSymbol::AxisWithCenterFlag)|
      (bb.type&OGLRotationSymbol::AxisWithCenterFlag);
    hasmir=(aa.type&OGLRotationSymbol::AxisWithCenterFlag)|
      (bb.type&OGLRotationSymbol::AxisWithCenterFlag);


    myDebug()<<"both MirrorRotation: inv,mir"<<hasinv<<hasmir;

    
    long exinv=alpha+beta;
    myDebug()<<"alpha+beta="<<exinv<<"n1-n2"<<n1-n2;
    if(exinv%2!=0 || (n1-n2)%2!=0){
      // we have inversion in the group product
      hasinv|=true;
      myDebug()<<"have inversion";
      if((res.order%2)==0){
	// even order can have skrew of heighest order
	long k=((alpha1+beta1)%2==0?0:1);
	long beta=beta1+k*n2;
	long alpha=alpha1-k*n1;
	double tau=0;
	myDebug()<<"alpha,beta for tau"<<alpha<<beta;
	if((alpha%2)!=0){
	  tau+=2*aa.originonaxisrel;
	}
	if((beta%2)!=0){
	  tau-=2*bb.originonaxisrel;
	}
	res.mtau0=dRound(tau*res.order);
	while(res.mtau0<0){ res.mtau0+=res.order; }
	myDebug()<<"tau="<<tau<<res.mtau0;
      }
    }
    if((res.order%2)==0){
      long exmirr=(alpha+beta)/2;
      if(exmirr%2!=0 || (n1-n2)%2!=0){
	// we have mirror in the group product
	hasmir|=true;
	myDebug()<<"have mirror";
      }
    }
    
    //todo: add the Opar and use it to determine the nonsym flags
    //todo: add inversion as bar1, such that we get 2/m

  }else{
    myDebug()<<"what the ..."<<aa.type<<bb.type;
    //    exit(1);
  }
  //todo: C2 AxisWithCenter


  // now we have a maximum order and hasinv and hasmir -> decide the group
  myDebug()<<"maxnbarorder"<<res.order;
  if(res.order%2!=0){
    // odd max nbar has inv anyways
    if(hasmir){
      res.order=res.order*2;
      res.type=OGLRotationSymbol::AxisWithCenter;
      myDebug()<<"odd with mirror?";
      // this should not happen, since we already have the highest order
      // but mir*Nbar{odd} give (2N)bar, which is of higher order
      exit(1);
    }else{
      myDebug()<<"odd no mirror?";
      res.type=OGLRotationSymbol::MirrorRotation;
    }
  }else{
    if(hasinv){
      myDebug()<<"even with inv= m/n";
      res.type=OGLRotationSymbol::AxisWithCenter;
    }else{
      res.type=OGLRotationSymbol::MirrorRotation;
    }
  }
  
  return res; 
};


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawSymmetryOperations(const STDoc *stdoc)
{
  NSF("OGLView::drawSymmetryOperations");
  myDebug() << nsubfunc;
  if(!stdoc) return;

  pobjects->clear("symops ");
  makeCurrent();

  //  const Light *light=pdoc->lightRef();
  
  // double thickness=0.02*stdoc->bound()->radius();
  // thickness=0.015; //current world units

  QList<OperationDescriptor*> opdescs;

  // SpaceGroupOperations *spops=stdoc->symmetry->spaceGroupOperations();
  // spops->unfold();
  //  bool showall=spops->allAreVisible();
//   for(int ig=0;ig<spops->size();ig++){
//     const SpaceGroupOperationBase *spop=spops->at(ig);

    
    
//     if((spop->type()==SpaceGroupOperationBase::Mirror) && (spop->isVisible()||
// 			   spops->mirrorsAreVisible()||
// 			   showall)){
//       const Vec3 &shiftperiod=spop.shiftPeriods().at(0);
      
      
//       const ValueArray<SpaceGroupOperation::OpShift> &shifts=spop.opShifts();
      
//       for(int is=0;is<shifts.size();is++){
// 	const SpaceGroupOperation::OpShift &os=shifts.at(is);
	

	
// 	Vec3 ndirection=spop.axis().normalized();
// 	Vec3 x,y;
// 	ndirection.findPerpDirections(x,y);
	
	
// 	double xmin=0,xmax=1;
// 	double ymin=0,ymax=1;
// 	double zmin=0,zmax=1;
// 	const QList<Vec3> &corners=stdoc->bound()->polyhedron()->vertices();
// 	long nv=corners.size();
// 	for(long i=0;i<nv;i++){
// 	  const Vec3 tau=corners.at(i);
// 	  if(i==0){
// 	    xmax=xmin=tau*x;
// 	    ymax=ymin=tau*y;
// 	    zmax=zmin=tau*ndirection;
// 	  }else{
// 	    xmin=MyMath::min<double>(xmin,tau*x);
// 	    xmax=MyMath::max<double>(xmax,tau*x);
	    
// 	    ymin=MyMath::min<double>(ymin,tau*y);
// 	    ymax=MyMath::max<double>(ymax,tau*y);
	    
// 	    zmin=MyMath::min<double>(zmin,tau*ndirection);
// 	    zmax=MyMath::max<double>(zmax,tau*ndirection);
// 	  }
// 	}

// 	Vec3 origin=os.origin;
// 	Vec3 tau0=os.tau0;
	
// 	double on=origin*ndirection;
// 	double deltan=shiftperiod*ndirection;
// 	long kmin=lRound((zmin-on)/deltan)-1;
// 	long kmax=lRound((zmax-on)/deltan)+1;
// 	double tol=1.0e-4;
// 	while(on+kmin*deltan<zmin-tol*deltan) kmin++;
// 	while(on+kmax*deltan>zmax+tol*deltan) kmax--;
// 	double dx=(xmax-xmin);
// 	double dy=(ymax-ymin);
// 	for(int k=kmin;k<=kmax;k++){

// 	  QString idprefix=QString("symops %1 origin %2,%3")
// 	    .arg(ig).arg(is).arg(k);

// 	  Vec3 pos=origin+shiftperiod*k;
	
	
// 	  double dxp=xmax+0.2*dx-(x*pos);
// 	  double dxm=(x*pos)-xmin+0.2*dx;
	
	
// 	  double dyp=ymax+0.1*dy-(y*pos);
// 	  double dym=(y*pos)-ymin+0.1*dy;
	
// 	  QList<Plane> pla;
// 	  pla.append(Plane(ndirection,thickness));
// 	  pla.append(Plane(-ndirection,thickness));
// 	  pla.append(Plane(x,dxp));
// 	  pla.append(Plane(-x,dxm));
// 	  pla.append(Plane(y,dyp));
// 	  pla.append(Plane(-y,dym));
	  
// 	  Polyhedron temppoly;
// 	  Polyhedron *poly=&temppoly;
// 	  const PolyhedronProperties &polprops=poly->properties();

// 	  poly->makeCorners(pla,1.0e-6,Vlevel::Silent);
	  
// 	  OGLPoly *opoly=new OGLPoly(pos,poly);
// 	  opoly->setID(idprefix+" plane ");
// 	  opoly->setTransparent(true);
// 	  opoly->setVisible(polprops.isVisible());
// 	  pobjects->append(opoly);
	  
// 	  {
// 	    QRgb ac=spops->symmorphicColor();
// 	    if(!os.isSymmorphic()) ac=spops->nonsymmorphicColor();
	    
// 	    OGLMaterial &mat=opoly->material();
// 	    mat.setFace(GL_FRONT_AND_BACK);
// 	    standardMaterialSettings(mat,light,ac,qAlpha(ac)/255.);
	    
// 	  }
// 	  if(!os.isSymmorphic()){
// 	    // show tau0
// 	    double polyradius=3*thickness/0.05;
// 	    Vec3 center=poly->midPoint()+pos;
// 	    OGLTube *tube=new OGLTube(OGLTube::ArrowLeftCap
// 				      ,center
// 				      ,center+tau0
// 				      ,0.05*polyradius,12
// 				      ,0.2*polyradius
// 				      ,0.1*polyradius
// 				      );
// 	    tube->setID(QString("%1 tau0").arg(idprefix));

// 	    pobjects->append(tube);
// 	    if(1){
// 	      QRgb ac=opoly->material().base();
// 	      OGLMaterial &mat=tube->material();
// 	      mat.setFace(GL_FRONT_AND_BACK);
// 	      standardMaterialSettings(mat,light,ac,qAlpha(ac)/255.);
// 	    }
// 	  }
	    
// 	}// k-origins
//       }//forall shifts
//     }else if(spop.type()==SpaceGroupOperation::Inversion&&
// 	     ((spop.isVisible()|| spops->inversionIsVisible()||
// 	       showall))){
      

//       bool showflags= ((spop.isVisible()|| spops->inversionIsVisible()||
// 			showall));

//       const ValueArray<SpaceGroupOperation::OpShift> &shifts=spop.opShifts();
      
//       Matrix3x3 A;
//       A.setColumn(0,spop.shiftPeriods().at(0));
//       A.setColumn(1,spop.shiftPeriods().at(1));
//       A.setColumn(2,spop.shiftPeriods().at(2));
//       Matrix3x3 G=A.inverseT();

//       for(int is=0;is<shifts.size();is++){
// 	const SpaceGroupOperation::OpShift &os=shifts.at(is);
// 	Vec3 origin=os.origin;
	
// 	double tol=1.0e-4;
	
// 	// find out maximum parallelepiped to cover the boundary
// 	// origin+(k0,k1,k2)*shiftPeriods() must be in boundary
// 	// hence we need the reciprocal shiftPeriods
// 	long Nmin[3],Nmax[3];
//  	const QList<Vec3> &corners=stdoc->bound()->polyhedron()->vertices();
//  	long nc=corners.size();
//  	for(long ic=0;ic<nc;ic++){
//  	  const Vec3 corn=corners.at(ic);
// 	  for(int k=0;k<3;k++){
// 	    double d=(corn-origin)*G(k);
// 	    long dmin=dRound(floor(d+tol));
// 	    long dmax=dRound(ceil (d-tol));
// 	    if(ic==0){
// 	      Nmin[k]=d;
// 	      Nmax[k]=d;
// 	    }else{
// 	      Nmin[k]=MyMath::min<long>(dmin,Nmin[k]);
// 	      Nmax[k]=MyMath::max<long>(dmax,Nmax[k]);
// 	    }
//  	  }
//  	}

	
//  	for(int k0=Nmin[0];k0<=Nmax[0];k0++){
// 	  for(int k1=Nmin[1];k1<=Nmax[1];k1++){
// 	    for(int k2=Nmin[2];k2<=Nmax[2];k2++){
	      
	      
// 	      Vec3 pos=origin+A*Vec3(k0,k1,k2);
	      
// 	      if(!stdoc->bound()->isInBoundary(pos,tol)) continue;
	      
// 	      QString idprefix=QString("symops %1 origin %2,%3,%4,%5")
// 		.arg(ig).arg(is).arg(k0).arg(k1).arg(k2);
	      
	      
	      
// 	      opdescs.
// 		append(new OperationDescriptor(showflags,
// 					       OGLRotationSymbol::MirrorRotation,
// 					       pos,
// 					       pos,
// 					       1,0,0.,0.,0.,
// 					       idprefix
// 					       ));
// 	    }//k2
// 	  }//k1
// 	}//k0
	
//       }//forall shifts
//     }else if((spop.type()==SpaceGroupOperation::Rotation) &&
// 	     (spop.exponent()==1) ){

//       bool showflags= (spop.isVisible()|| spops->rotationsAreVisible()||
// 		       showall);

//       const ValueArray<SpaceGroupOperation::OpShift> &shifts=spop.opShifts();
//       for(int is=0;is<shifts.size();is++){
// 	const SpaceGroupOperation::OpShift &os=shifts.at(is);
	

// 	Vec3 ndirection=spop.axis().normalized();


// 	Vec3 origin=os.origin;
// 	long mtau0=spop.order()/os.kn;
// 	mtau0*=os.km;
	
// 	double zmin,zmax;
	
	
// 	Vec3 a0=spop.shiftPeriods().at(0);
// 	Vec3 a1=spop.shiftPeriods().at(1);
// 	Vec3 a2=a0.cross(a1);
	
// 	Vec3 g0=a1.cross(a2);
// 	double V=g0*a0;
// 	g0/=V;
// 	Vec3 g1=a2.cross(a0)/V;

// // 	printf("a0g0=%g\n",a0*g0);
// // 	printf("a0g1=%g\n",a0*g1);
// // 	printf("a1g0=%g\n",a1*g0);
// // 	printf("a1g1=%g\n",a1*g1);

// 	long Nmin[2];
// 	long Nmax[2];

// 	Vec3 o=origin-stdoc->bound()->midPoint();
// 	o=(o-ndirection*(ndirection*o));
// 	double d1=stdoc->bound()->radius()*norm(g0);
// 	double d2=g0*o;
// 	Nmin[0]=dRound(-d1-d2)-1;
// 	Nmax[0]=dRound( d1-d2)+1;

// 	d1=stdoc->bound()->radius()*norm(g1);
// 	d2=g1*o;
// 	Nmin[1]=dRound(-d1-d2)-1;
// 	Nmax[1]=dRound( d1-d2)+1;

// 	double dz=2;
	
//  	for(int k0=Nmin[0];k0<=Nmax[0];k0++){
// 	  for(int k1=Nmin[1];k1<=Nmax[1];k1++){

// 	    Vec3 pos=origin+spop.shiftPeriods().at(0)*k0+
// 	      spop.shiftPeriods().at(1)*k1;


// 	    {//check if axis cuts boundary polyhdron
// 	      const QList<Plane> &planes=stdoc->bound()->polyhedron()->planes();
// 	      double z0=-1.e30;
// 	      double z1= 1.e30;
// 	      double tol=1.0e-6;
// 	      //printf("axis=%s\n",ndirection.printS()());
// 	      //printf("orig=%s\n",pos.printS()());
// 	      for(long ip=0;ip<planes.size();ip++){
// 		const Vec3 &n=planes[ip].n();
// 		//printf("plane: n=%s,d=%g\n",n.printS()(),planes[ip].d());
// 		double det=(n*ndirection);
// 		double d=planes[ip].d()-n*pos;
// 		//printf("plane: det=%g,d=%g\n",det,d);
// 		if(det==0){
// 		  //printf("det=0\n");
// 		  if(0>=d+tol){
// 		    //printf("det=0, d=0\n");
// 		    z0=1;
// 		    z1=-1;
// 		    //printf("det=0: z0=%g, z1=%g\n",z0,z1);
// 		    break;
// 		  }
// 		}else{
// 		  if(det>0){
// 		    z1=MyMath::min<double>(z1,d/det);
// 		    //printf("det>0: z0=%g, z1=%g\n",z0,z1);
// 		  }else{
// 		    z0=MyMath::max<double>(z0,d/det);
// 		    //printf("det<0: z0=%g, z1=%g\n",z0,z1);
// 		  }
// 		  if(z0>=z1+tol)break;
// 		}
// 	      }
// 	      //printf("after: z0=%g, z1=%g\n",z0,z1);
// 	      if(z0>=z1+tol){
// 		// we are out
// 		continue;
// 	      }

//  	      // determine the max extend of the axis
// 	      zmin=-1.0e30;
// 	      zmax=1.0e30;
		
// 	      for(long ip=0;ip<planes.size();ip++){
// 		const Vec3 &n=planes[ip].n();

// 		double pn=planes[ip].d()+dz-pos*n;
// 		double nn=ndirection*n;
// 		if(nn>0){

// 		  zmax=MyMath::min<double>(zmax,pn/nn);

// 		}else if(nn<0){
// 		  zmin=MyMath::max<double>(zmin,pn/nn);
// 		}
// 	      }

// 	      if(fabs(zmax-zmin)<tol){
// 		zmin=zmin-1;
// 		zmax=zmax+1;
// 	      }
// 	    }


// 	    QString idprefix=QString("symops %1 origin %2,%3 %4")
// 	      .arg(ig).arg(is).arg(k0).arg(k1);



// 	    opdescs.
// 	      append(new OperationDescriptor(showflags,
// 					     OGLRotationSymbol::Rotation,
// 					     pos+ndirection*zmin,
// 					     pos+ndirection*zmax,
// 					     spop.order(),mtau0,0.,0.,0.,
// 					     idprefix
// 					     ));

// 	  } // k1
// 	} // k0

//       }// forall shifts
//     }else if((spop.type()==SpaceGroupOperation::MirrorRotation) &&
// 	     (spop.rotoInversionExponent()==1) ){

//       bool showflags= (spop.isVisible()|| spops->mirrorRotationsAreVisible()||
// 		       showall);

//       const ValueArray<SpaceGroupOperation::OpShift> &shifts=spop.opShifts();
//       for(int is=0;is<shifts.size();is++){
// 	const SpaceGroupOperation::OpShift &os=shifts.at(is);
	

// 	Vec3 ndirection=spop.axis().normalized();


// 	Vec3 origin=os.origin;
// 	double originonaxisrel=os.originonaxisrel;
// 	double zmin,zmax;
	
// 	Vec3 a0=spop.shiftPeriods().at(0);
// 	Vec3 a1=spop.shiftPeriods().at(1);
// 	Vec3 Pmin=spop.shiftPeriods().at(2);
// 	Vec3 a2=a0.cross(a1);
	
// 	Vec3 g0=a1.cross(a2);
// 	double V=g0*a0;
// 	g0/=V;
// 	Vec3 g1=a2.cross(a0)/V;



// 	long Nmin[2];
// 	long Nmax[2];

// 	Vec3 o=origin-stdoc->bound()->midPoint();
// 	o=(o-ndirection*(ndirection*o));
// 	double d1=stdoc->bound()->radius()*norm(g0);
// 	double d2=g0*o;
// 	Nmin[0]=dRound(-d1-d2)-1;
// 	Nmax[0]=dRound( d1-d2)+1;

// 	d1=stdoc->bound()->radius()*norm(g1);
// 	d2=g1*o;
// 	Nmin[1]=dRound(-d1-d2)-1;
// 	Nmax[1]=dRound( d1-d2)+1;

// 	double dz=2;
	
//  	for(int k0=Nmin[0];k0<=Nmax[0];k0++){
// 	  for(int k1=Nmin[1];k1<=Nmax[1];k1++){

// 	    Vec3 pos=origin+Pmin*originonaxisrel+spop.shiftPeriods().at(0)*k0+
// 	      spop.shiftPeriods().at(1)*k1;


// 	    {//check if axis cuts boundary polyhedron
// 	      const QList<Plane> &planes=stdoc->bound()->polyhedron()->planes();
// 	      double z0=-1.e30;
// 	      double z1= 1.e30;
// 	      double tol=1.0e-6;
// 	      //printf("axis=%s\n",ndirection.printS()());
// 	      //printf("orig=%s\n",pos.printS()());
// 	      for(long ip=0;ip<planes.size();ip++){
// 		const Vec3 &n=planes[ip].n();
// 		//printf("plane: n=%s,d=%g\n",n.printS()(),planes[ip].d());
// 		double det=(n*ndirection);
// 		double d=planes[ip].d()-n*pos;
// 		//printf("plane: det=%g,d=%g\n",det,d);
// 		if(det==0){
// 		  //printf("det=0\n");
// 		  if(0>=d+tol){
// 		    //printf("det=0, d=0\n");
// 		    z0=1;
// 		    z1=-1;
// 		    //printf("det=0: z0=%g, z1=%g\n",z0,z1);
// 		    break;
// 		  }
// 		}else{
// 		  if(det>0){
// 		    z1=MyMath::min<double>(z1,d/det);
// 		    //printf("det>0: z0=%g, z1=%g\n",z0,z1);
// 		  }else{
// 		    z0=MyMath::max<double>(z0,d/det);
// 		    //printf("det<0: z0=%g, z1=%g\n",z0,z1);
// 		  }
// 		  if(z0>=z1+tol)break;
// 		}
// 	      }
// 	      //printf("after: z0=%g, z1=%g\n",z0,z1);
// 	      if(z0>=z1+tol){
// 		// we are out
// 		continue;
// 	      }

//  	      // determine the max extend of the axis
// 	      zmin=-1.0e30;
// 	      zmax=1.0e30;
		
// 	      for(long ip=0;ip<planes.size();ip++){
// 		const Vec3 &n=planes[ip].n();

// 		double pn=planes[ip].d()+dz-pos*n;
// 		double nn=ndirection*n;
// 		if(nn>0){

// 		  zmax=MyMath::min<double>(zmax,pn/nn);

// 		}else if(nn<0){
// 		  zmin=MyMath::max<double>(zmin,pn/nn);
// 		}
// 	      }

// 	      if(fabs(zmax-zmin)<tol){
// 		zmin=zmin-1;
// 		zmax=zmax+1;
// 	      }
// 	    }

// 	    //determine the appearance of invariant points on the axis
// 	    double dz=(zmax-zmin);
// 	    double mu0=-zmin/dz; //where is origin of barN relative to whole
// 	    // visible rod
// 	    double dmu=fabs(Pmin*ndirection)*0.5/dz;//periodicity of the origin on the rod


// 	    QString idprefix=QString("symops %1 origin %2,%3 %4")
// 	      .arg(ig).arg(is).arg(k0).arg(k1);

 

// 	    opdescs.
// 	      append(new OperationDescriptor(showflags,
// 					     OGLRotationSymbol::MirrorRotation,
// 					     pos+ndirection*zmin,
// 					     pos+ndirection*zmax,
// 					     spop.rotoInversionOrder(),
// 					     0.,originonaxisrel,
// 					     mu0,dmu,idprefix
// 					     ));

// 	  } // k1
// 	} // k0

//       }// forall shifts
//     }
//   }//spops  


//   for(long i=0;i<opdescs.size();i++){ myDebug()<<opdescs.at(i)->printS(i)(); }
//   // cleanup unwanted operations

//   bool changed=true;
//   while(changed){
//     changed=false;
//     for(long i=0;i<opdescs.size();i++){
//       OperationDescriptor *opdesci=opdescs.at(i);
//       if(!opdesci->active)continue;

//       for(long j=i+1;j<opdescs.size();j++){
// 	OperationDescriptor *opdescj=opdescs.at(j);
// 	if(!opdescj->active)continue;

// 	if(opdesci->equalGeometry(*opdescj)){

// 	  myDebug()<<"        "<<opdesci->printS(i);
// 	  myDebug()<<"    and "<<opdescj->printS(j);
// 	  OperationDescriptor desc=highestSymmetry(*opdesci,*opdescj);
	  
// 	  myDebug()<<"       resulting in"<<desc.printS(0);

// 	  if(opdesci->order==desc.order && 
// 	     OGLRotationSymbol::equalBaseType(opdesci->type,desc.type)){
// 	    opdescj->active=false;
// 	    opdesci->type=desc.type;
// 	    opdesci->mtau0=desc.mtau0;
// 	    changed=true;
// 	  }else if(opdescj->order==desc.order && 
// 		   OGLRotationSymbol::equalBaseType(opdescj->type,desc.type)){
// 	    opdesci->active=false;
// 	    opdescj->type=desc.type;
// 	    opdescj->mtau0=desc.mtau0;
// 	    changed=true;
// 	  }else{
// 	    myDebug()<<"search op";
// 	    for(long k=0;k<opdescs.size();k++){
// 	      OperationDescriptor *opdesck=opdescs.at(k);
// 	      if(opdesck->equalGeometry(desc) && 
// 		 opdesck->order==desc.order && 
// 		 OGLRotationSymbol::equalBaseType(opdesck->type,desc.type)){
// 		opdesci->active=false;
// 		opdescj->active=false;
// 		opdesck->active=true;
// 		opdesck->type=desc.type;
// 		opdesck->mtau0=desc.mtau0;
// 		myDebug()<<"    get"<<opdesck->printS(k);
			    
// 		break;
// 	      }
// 	    }
	    
// 	  }

	  
// 	}
//       }
//     }
//   }
//   myDebug()<<"done";
//   //todo: test if several at same spot
//   for(long i=0;i<opdescs.size();i++){ myDebug()<<opdescs.at(i)->printS(i)(); }

//   // now display the remaining operations
//   for(long i=0;i<opdescs.size();i++){

//     const OperationDescriptor *opdesc=opdescs.at(i);
//     if(!opdesc->active) continue;
    
//     double polyradius=6*thickness/0.05;


//     OGLRotationSymbol *rots=
//       new OGLRotationSymbol(
// 			    opdesc->type
// 			    ,opdesc->pos0,opdesc->pos1 
// 			    ,opdesc->order
// 			    ,opdesc->mtau0
// 			    ,opdesc->mu0,opdesc->dmu
// 			    ,0.05*polyradius,
// 			    0.0125*polyradius*spops->inversionSymbolSize(),
// 			    12,
// 			    0.05*polyradius
// 			    ,8*0.05*polyradius
// 			    ,spops->showBottom()
// 			    ,spops->showTop()
// 			    );
//     rots->setID(opdesc->id);
//     pobjects->append(rots);
//     if(1){
//       QRgb ac=spops->symmorphicColor();
//       if((opdesc->mtau0!=0)) ac=spops->nonsymmorphicColor();
      
//       OGLMaterial &mat=rots->material();
//       mat.setFace(GL_FRONT_AND_BACK);
//       standardMaterialSettings(mat,light,ac,qAlpha(ac)/255.);
//       mat.setSpecular(0x0);

//       {
// 	OGLMaterial &mat=rots->specifierMaterial();
// 	mat.setFace(GL_FRONT_AND_BACK);
// 	standardMaterialSettings(mat,light,0x00,qAlpha(ac)/255.);
// 	mat.setSpecular(0x0);
//       }
//     }
    
//   }
//   //todo:C2 in 178 is wrong ?
//   //todo:axis sort-out after rotoinversions are added

  qDeleteAll(opdescs.begin(),opdescs.end());

  ptpCollector->setNeedReConstruct(false);
  pneedrepaint=true;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawPolyhedra(const STDoc *stdoc)
{
  NSF("OGLView::drawPolyhedra");
  //myDebug() << nsubfunc;
  if(!stdoc) return;

  pobjects->clear("polyhedra ");
  makeCurrent();


  int np=stdoc->cluster->numPolys();
  for(long i=0;i<np;i++){
    const AtomPolyhedron *poly=stdoc->cluster->polyhedron(i);
    //myDebug()<<"atompoly "<<i<<poly->properties();

    //((AtomPolyhedron *)poly)->properties().setDrawNormals(true);
    drawPolyhedron(poly,Sprintf("polyhedra %ld",i),false);
      
  }

  //todo: is this always nessacary?  yes because the clear invalidates
  // everything
  ptpCollector->setNeedReConstruct(true);
  pneedrepaint=true;
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::colorAtoms(const STDoc *stdoc)
{
  NSF("OGLView::colorAtoms");
  //myDebug() << nsubfunc;

  makeCurrent();
  if(!stdoc) return;

  long na=stdoc->cluster->numAtoms();

  for(long i=0;i<na;i++){
    const Atom &atom=stdoc->cluster->atom(i);

    int ind=pobjects->indexOf(Sprintf("atom %ld",i));
    
    if(ind>=0 && (*pobjects)[ind]->isA("OGLSphere")){

      OGLSphere *sph=(OGLSphere*)(*pobjects)[ind];

      OGLMaterial &mat=sph->material();
      mat.setBase(atom.property.material().color()); // todo: This is only for memorizing,
      //todo: does that belong into material?
      colorAtom(sph,atom.property.material().color(),0x0,
		atom.property.material().specularColor(),
		atom.property.material().shininess());
    }

  }
  pneedrepaint=true;

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::colorAtom(OGLSphere *sph,QRgb diffusecolor,QRgb emissioncolor,
			QRgb spotcolor,double shininess)
{
  OGLMaterial &mat=sph->material();

  
  mat.setDiffuse(diffusecolor);
  mat.setAmbient(diffusecolor);
  mat.setSpecular(spotcolor);
  mat.setEmission(emissioncolor);
  mat.setShininess(MyMath::min(shininess,128.));
  //  if(temp_transparent) mat.setOpacity(0.7);
  //  ptpCollector->setNeedReConstruct(true);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::doRendering()
{
  NSF("OGLView::doRendering");
  myDebug() << nsubfunc;

  MachineTime time;

  makeCurrent();
  setAtomPickerMarkers(true);


  pobjects->clear("Light helpers");
  if(pshowlighthelpers){
    
    for(long i=-1;++i<pdoc->lights()->size();){
       const Lights::Light *li=pdoc->lights()->at(i);
       if(!li->active()) continue;
       
       String id=Sprintf("Light helpers Light %ld",i);;
       

       OGLLightHelper *lhelper=new OGLLightHelper(li,&(pdoc->view()));
       lhelper->setID(id);
       OGLMaterial &mat=lhelper->material();
       QRgb col=(pdoc->lights()->backgroundColor() ^ 0xffffff)|0xff000000;
       mat.setBase(col);
       mat.setDiffuse(col);
       lhelper->setVisible(true);
       pobjects->append(lhelper);
     }
  }

  setCamera(); // we need that here for the camera lights update


  pneedrepaint=true;

  updateGL();

  time.print(nsubfunc);

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::setShowLightHelpers(bool onoff)
{
  if(pshowlighthelpers!=onoff){
    pshowlighthelpers=onoff;
    doRendering();
  }
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawDisplayCell(const DisplayCell *dc)
{
  NSF("OGLView::drawDisplayCell");
  //myDebug() << nsubfunc;

  makeCurrent();

  if(0){
    Vec3 eye=Vec3(0,0,-1);
    Vec3 nz=Vec3(0,0,-1);
    View &view=pdoc->view();

    Matrix3x3 M(view.x(),view.up(),view.z());
    nz=M*nz;
    eye=M*eye+view.origin_cam_w();
//     myDebug() << "nz"<<nz;
//     myDebug() << "shift"<<view.origin_cam_w();
    
    pobjects->clear("nzzzz");
    double rad=3;
    OGLTube *tube=new OGLTube(OGLTube::Arrow
			      ,eye
			      ,eye+nz
			      ,0.05*rad,12
			      ,0.2*rad
			      ,0.1*rad
			      );
    tube->setID("nzzzz");
    pobjects->append(tube);
    
  }

  //  myDebug() << "ID="<<dc->id();

  pobjects->clear(dc->id());
  //  ((DisplayCell*)dc)->boundary()->polyhedron()->properties().setDrawNormals(true);
  drawPolyhedron(dc->boundary()->polyhedron(),dc->id(),true);

    //todo: is this always nessacary?
  ptpCollector->setNeedReConstruct(true);
  pneedrepaint=true;

  
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawPolyhedron(const Polyhedron *poly,const String &idprefix
			      ,bool drawspecdot)
{
  NSF("OGLView::drawPolyhedron");
  //myDebug() <<  nsubfunc;
  if(!pdoc) return;
  makeCurrent();

  const PolyhedronProperties &polprops=poly->properties();

//   if(!polprops.isVisible()) {
//     ptpCollector->setNeedReConstruct(true);
//     pneedrepaint=true;
//     return;
//   }

  Vec3 pos;
  if(poly->isA("AtomPolyhedron")){
    pos=((AtomPolyhedron*)poly)->position;
  }
  if(polprops.drawFaces()){
    OGLPoly *opoly=new OGLPoly(pos,poly);
    opoly->setID(idprefix+" faces ");
    opoly->setVisible(polprops.isVisible());
    
    //todo: if we set transparent only with alpha<255
    // and on first creation we have nono transpaernt
    // the DataCachePolyItem destroys the intermittent
    // data and on later setTransparent we do not have data
    // to sort into bsp
    pobjects->append(opoly);

    QRgb opac;    
    {//coloring
      const Material &fm=poly->properties().faceMaterial();
      QRgb ac=fm.color();
      int alpha=qAlpha(ac);
      
      
      OGLMaterial &mat=opoly->material();
      mat.setFace(GL_FRONT_AND_BACK);
      mat.setBase(ac);
      opac=0xff000000;
      if(alpha<255){
	opac=alpha*0x1000000;
      }
      //myDebug("%s:%x %g %x",nsubfunc,ac,alpha/255.,opac);
      
      mat.setDiffuse((ac&0xffffff)|opac);
      mat.setAmbient((ac&0xffffff)|0xff000000);
      mat.setSpecular(fm.specularColor());
      mat.setEmission(0);
      mat.setShininess(MyMath::min(fm.shininess(),128.));
      //myDebug() << opoly->material();
      
    }

    opoly->setTransparent(opac<0xff000000);

    
    if(polprops.drawNormals()){

      for(int ii=0;ii<poly->normals().size();ii++){	
	Vec3 pos1;
	long nfa=poly->polyIndices().at(ii).size();
	for(int ip=0;ip<nfa;ip++){
	  int ind=poly->polyIndices().at(ii).at(ip);
	  pos1+=poly->vertices().at(ind);
	}
	pos1=pos+pos1/nfa;

	OGLTube *tube=new OGLTube(OGLTube::Arrow
				  ,pos1
				  ,pos1+poly->normals().at(ii)
				  *poly->radius()//*1.5
				  ,0.05*poly->radius(),12
				  ,0.2*poly->radius()
				  ,0.1*poly->radius()
				  );
	tube->setID(Sprintf("%s normal %d",idprefix(),ii));
	pobjects->append(tube);
	
      }
    }
  }
  if(polprops.drawRim()){
    
    QList<QPair<long,long> > edges;
    
    for(long ip=0;ip<poly->planes().size();ip++){
      const ValueArray<long> &pol=poly->polyIndices().at(ip);
      long n=pol.size();
      for(long j=0;j<n;j++) {
	long i0=pol.at(j);
	long i1=pol.at((j+1)%n);
	if(i0>i1)MyMath::swap(i0,i1);
	QPair<long,long> pair=qMakePair(i0,i1);
	if(!edges.contains(pair)){
	  edges.append(pair);
	  //printf("%ld %ld\n",i0,i1);
	}
      }
    }

    for(int ie=0;ie<edges.size();ie++){
      long i0=edges.at(ie).first;
      long i1=edges.at(ie).second;
      // printf("edge %ld %ld radius %g visible %d\n",i0,i1,polprops.dispRimRadius()
      // 	     ,polprops.isVisible());
      
      OGLTube *tube=new OGLTube(OGLTube::CylinderCap
				,poly->vertices().at(i0)+pos
				,poly->vertices().at(i1)+pos
				,polprops.dispRimRadius(),20);
      tube->setID(idprefix+Sprintf(" edge %ld",ie));
      tube->setVisible(polprops.isVisible());
      
      tube->material().setDiffuse(polprops.rimMaterial().color());
      tube->material().setSpecular(polprops.rimMaterial().color());
      
      pobjects->append(tube);
    }

  }
  

  //myDebug() <<"drawspecdot"<<drawspecdot<<pshowpotentialspcepoints;
  if(drawspecdot&&polprops.isVisible()){
    String id=Sprintf("potential special point dots %s ",idprefix());
    //myDebug() << id;
    pobjects->clear(id);

    double radscale=0.035;
    double radius=pdoc->bound()->radius()*radscale;

    QList<QPair<long,long> > edges;
    
    for(long ip=0;ip<poly->planes().size();ip++){
      const ValueArray<long> &pol=poly->polyIndices().at(ip);
      long n=pol.size();
      for(long j=0;j<n;j++) {
	long i0=pol.at(j);
	long i1=pol.at((j+1)%n);
	if(i0>i1)MyMath::swap(i0,i1);
	QPair<long,long> pair=qMakePair(i0,i1);
	if(!edges.contains(pair)){
	  edges.append(pair);
	  //printf("%ld %ld\n",i0,i1);
	}
      }
    }
    //todo avoid doubling of points from different cells
    Vec3 point;
    QList<long> vert;
    for(int ie=0;ie<edges.size();ie++){
      long i0=edges.at(ie).first;
      long i1=edges.at(ie).second;
      //myDebug("edge %ld %ld radius %g visible %d\n",i0,i1,props.dispRimRadius()
      //	   ,props.isVisible());
      point=(poly->vertices().at(i0)+poly->vertices().at(i1))/2;
      OGLSphere *sph
	=new OGLSphere(point,radius,OGLSphere::Icosahedron,1);
      sph->setPickable(true);
      sph->setID(Sprintf("%s mid edge %d",id(),ie));
      sph->setVisible(pshowpotentialspcepoints);
      sph->material().setDiffuse(0xff00);
      sph->material().setSpecular(0xff00);
      sph->setUserData(new OGLUserData(point));
      pobjects->append(sph);

      if(!vert.contains(i0)){
	point=poly->vertices().at(i0);
	OGLSphere *sph
	  =new OGLSphere(point
			 ,radius,OGLSphere::Icosahedron,1);
	sph->setPickable(true);
	sph->setID(Sprintf("%s corner %d",id(),i0));
	sph->setVisible(pshowpotentialspcepoints);
	sph->material().setDiffuse(0xff00);
	sph->material().setSpecular(0xff00);
	sph->setUserData(new OGLUserData(point));
      	pobjects->append(sph);
      }
      vert.append(i0);
      if(!vert.contains(i1)) {
	point=poly->vertices().at(i1);
	OGLSphere *sph
	  =new OGLSphere(point
			 ,radius,OGLSphere::Icosahedron,1);
	sph->setPickable(true);
	sph->setID(Sprintf("%s corner %d",id(),i1));
	sph->setVisible(pshowpotentialspcepoints);
	sph->material().setDiffuse(0xff00);
	sph->material().setSpecular(0xff00);
	sph->setUserData(new OGLUserData(point));
	pobjects->append(sph);
      }
      vert.append(i1);
      

    }
    Vec3 gamma;
    long ngamma=0;
    for(long ip=0;ip<poly->planes().size();ip++){
      const ValueArray<long> &pol=poly->polyIndices().at(ip);
      long n=pol.size();
      Vec3 point;
      for(long j=0;j<n;j++) {
	long ind=pol.at(j);
	point+=poly->vertices().at(ind);
	gamma+=poly->vertices().at(ind);
	ngamma++;
      }
      point/=n;
      OGLSphere *sph
	=new OGLSphere(point
		       ,radius,OGLSphere::Icosahedron,1);
      sph->setPickable(true);
      sph->setID(Sprintf("%s face %d",id(),ip));
      sph->setVisible(pshowpotentialspcepoints);
      sph->material().setDiffuse(0xff00);
      sph->material().setSpecular(0xff00);
      sph->setUserData(new OGLUserData(point));
      pobjects->append(sph);
      
    }
    gamma/=ngamma;
    OGLSphere *sph
      =new OGLSphere(gamma
		     ,radius,OGLSphere::Icosahedron,1);
    sph->setPickable(true);
    sph->setID(Sprintf("%s gamma",id()));
    sph->setVisible(pshowpotentialspcepoints);
    sph->material().setDiffuse(0xff00);
    sph->material().setSpecular(0xff00);
    sph->setUserData(new OGLUserData(gamma));
    pobjects->append(sph);

  }

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::showPotentialSpecPoints(bool on)
{
  makeCurrent();
  pshowpotentialspcepoints=on;
  pobjects->setVisible("potential special point dots",on);
  pneedrepaint=true;
  updateGL();


}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
// void OGLView::drawCell(const Boundary *bd,const DisplayCell *dc)
// {
//   NSF("OGLView::drawCell");
//   //myDebug() << nsubfunc;

//   if(!dc) return;
  
//   makeCurrent();

//   const DisplayCellProperties &props=dc->properties();
//   QString id=dc->id()+"edge ";
//   pobjects->clear(id);
  

//   // draw tubes
  
//   QList<QPair<long,long> > edges;
  
//   for(long ip=0;ip<bd->numPlanes();ip++){
//     //printf("plane %ld\n",ip);
//     long n=bd->numCorners(ip);
//     for(long j=0;j<n;j++) {
//       long i0=bd->polygon(j,ip);
//       long i1=bd->polygon((j+1)%n,ip);
//       if(i0>i1)MyMath::swap(i0,i1);
//       QPair<long,long> pair=qMakePair(i0,i1);
//       if(!edges.contains(pair)){
// 	edges.append(pair);
// 	//printf("%ld %ld\n",i0,i1);
//       }
//     }
//   }
  
//   for(int ie=0;ie<edges.size();ie++){
//     long i0=edges.at(ie).first;
//     long i1=edges.at(ie).second;
//     //printf("edge %ld %ld\n",i0,i1);
    
//     OGLTube *tube=new OGLTube(OGLTube::Cylinder
// 			      ,bd->vertices(i0),bd->vertices(i1)
// 			      ,props.dispRimRadius(),6);
//     tube->setID(id+QString("%1").arg(ie));
//     tube->setVisible(props.isVisible());
    
//     tube->material().setDiffuse(props.rimColor());
//     tube->material().setSpecular(props.rimColor());
    
//     pobjects->append(tube);
    
    
//   }
  
  

//   pneedrepaint=true;
  
// }


/* ***********************************************************************
 *
 * ***********************************************************************
 */
// void OGLView::drawSpannedBox(const Matrix3x3 &cell,const cellState& cellstate)
// {
//   NSF("OGLView::drawSpannedBox");
//   //myDebug() << nsubfunc;

//   makeCurrent();

//   QString id=cellstate.id+"edge ";
//   pobjects->clear(id);
  

//   if(cellstate.thickness>0.0001){
//     // draw tubes

//     Vec3 x[8]={
//       Vec3(0  ,0  ,0  ), 
//       Vec3(1  ,0  ,0  ), 
//       Vec3(0  ,1  ,0  ), 
//       Vec3(1  ,1  ,0  ), 
//       Vec3(0  ,0  ,1  ), 
//       Vec3(1  ,0  ,1  ), 
//       Vec3(0  ,1  ,1  ), 
//       Vec3(1  ,1  ,1  )
      
//     };
//     int edges[12][2]={
//       {0,2},
//       {2,3},
//       {3,1},
//       {1,0},
//       {4,5},
//       {5,7},
//       {7,6},
//       {6,4},
//       {1,5},
//       {7,3},
//       {0,4},
//       {6,2},
//     };

//     for(int ie=0;ie<12;ie++){

//       long i0=edges[ie][0];
//       long i1=edges[ie][1];
      
//       OGLTube *tube=new OGLTube(OGLTube::Cylinder
// 				,cell*x[i0],cell*x[i1]
// 				,pdoc->bound()->radius()*cellstate.thickness
// 				,12);
//       tube->setID(id+QString("%1").arg(ie));
//       tube->setVisible(cellstate.plot);

//       tube->material().setAmbient(cellstate.rgb);
//       tube->material().setDiffuse(cellstate.rgb);
//       tube->material().setSpecular(0x00000000);

//       pobjects->append(tube);

      
//     }

//   }else{
//     // drawlines
//   }
  
  
//   pneedrepaint=true;
  
// }
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawAxes(const Axes *axes,int fontres)
{
  NSF("OGLView::drawAxes");
  //myDebug() << nsubfunc;
  
  makeCurrent();

  //myDebug() << "ID="<<axes->id();
  pobjects->clear(axes->id());
  
  const Vec3 &o=axes->dispOrigin();

  for(int ia=0;ia<3;ia++){
    
    double d0=axes->dispRodRadius()/norm(axes->dispVector(ia))*0.04;
    double d=axes->dispRodRadius()/norm(axes->dispVector(ia))*0.2;
    OGLTube *tube
      =new OGLTube(
		   (ia==0?OGLTube::ArrowLeftCap:OGLTube::Arrow)
		   ,(ia==0?o+d0*axes->dispVector(ia):o+d*axes->dispVector(ia))
		   ,o+axes->dispVector(ia)
		   ,axes->dispRodRadius()
		   ,20
		   ,axes->dispTipLength()
		   ,axes->dispTipRadius()
		   );
    tube->setID(Sprintf("%s %d",axes->id()(),ia));
    tube->setVisible(axes->show());
  
    tube->material().setDiffuse(axes->color(ia));
    tube->material().setSpecular(axes->color(ia));
  
    pobjects->append(tube);

    if(!axes->label(ia).empty()){
      OGLText *txt
	=new OGLText(axes->label(ia)()
		     ,o+axes->dispVector(ia)*1.05
		     ,pdoc->bound()->radius()*axes->fontScale().D
		     ,1//,pdoc->bound()->radius()*axes->fontScale().D
		     ,fontres,axes->fontShift(ia).toVec3(),true
		     ,OGLText::CoMovingCameraFacing);
      txt->setPickable(true);
      txt->setVisible(axes->show());
      {
	OGLMaterial &mat=txt->material();
	QRgb col=axes->fontColor();
	mat.setBase(col);
	mat.setDiffuse(col);
	mat.setAmbient((QRgb)0);
	mat.setSpecular(0);
	mat.setShininess(0);
      }
      txt->setID(Sprintf("%s %d label",axes->id()(),ia));
      pobjects->append(txt);
      
    }
  }
  pneedrepaint=true;
  
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::invalidateMesh(const RegularMesh *mesh)
{
  NSF("OGLView::invalidateMesh(RegularMesh)");
  myDebug() << nsubfunc;
  ogldatacache->invalidateMesh(mesh);
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::invalidateMesh(const TriangleMesh *mesh)
{
  NSF("OGLView::invalidateMesh(TriangleMesh)");
  myDebug() << nsubfunc;
  ogldatacache->invalidateMesh(mesh);
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawMeshPoints(const RegularMesh *mesh
			     ,OGLMeshPoints::OGLMeshPointsType type
			     ,bool state)
{
  NSF("OGLView::drawMeshPoints");
  myDebug() << nsubfunc;
  if(!mesh) return;
  //myDebug() << mesh->id();
  
  makeCurrent();

  String id=mesh->id()+Sprintf(" points type(%d)",type);

  pobjects->clear(id);



  OGLMeshPoints *meshp=new OGLMeshPoints(type,mesh);
  
  if(type==OGLMeshPoints::Full)
    meshp->material().setDiffuse(0xffff0000);
  else
    meshp->material().setDiffuse(0xff0000ff);
  
  meshp->setVisible(state);
  meshp->setID(id);
  pobjects->append(meshp);
  
  
  pneedrepaint=true;

}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawMeshCells(const RegularMesh *mesh
			    ,OGLMeshCells::OGLMeshCellsType type,bool state)
{
  NSF("OGLView::drawMeshCells");
  myDebug() << nsubfunc;
  if(!mesh) return;
  
  makeCurrent();

  String id=mesh->id()+Sprintf(" cells type(%d)",type);
  
  pobjects->clear(id);
  
  OGLMeshCells *meshc=new OGLMeshCells(type,mesh);
  
  if(type==OGLMeshCells::Microcells)
    meshc->material().setDiffuse(0xff00ff00);
  else
    meshc->material().setDiffuse(0xff7777ff);
  
  meshc->setVisible(state);
  meshc->setID(id);
  pobjects->append(meshc);

  
  pneedrepaint=true;

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawTriangleMesh(const TriangleMesh *triamesh,bool state,double linewidth)
{
  NSF("OGLView::drawTriangleMesh");
  myDebug() << nsubfunc;
  if(!triamesh) return;
  
  makeCurrent();

  String id=triamesh->id();
  pobjects->clear(id);

  //myDebug() << "triamesh" << triamesh;
  OGLTriangleMesh *mesht
    =new OGLTriangleMesh(OGLTriangleMesh::Regular,triamesh,linewidth);


//   mesht->setTransparent(temp_transparent);
//   ptpCollector->setNeedReConstruct(true);

  
  QRgb opac=0xff000000;
  
  {

    QRgb ac=triamesh->isoColor().outerColor();
    int alpha=triamesh->isoColor().alpha();
    if(alpha<255) opac=alpha*0x1000000;
    
    //printf("ac =%x\n",ac);
    OGLMaterial &mat=mesht->materialFront();
    mat.setBase(ac);
    mat.setDiffuse((ac&0xffffff)|opac);
    mat.setAmbient((ac&0xffffff)|0xff000000);
    mat.setSpecular(0xffffffff);
    mat.setShininess(50.);
    //todo    mat.setOpacity(0.7);
  }
  {

    QRgb ac=triamesh->isoColor().innerColor();
    
    OGLMaterial &mat=mesht->materialBack();
    mat.setBase(ac);
    mat.setDiffuse((ac&0xffffff)|opac);
    mat.setAmbient((ac&0xffffff)|0xff000000);
    mat.setSpecular(0xffffffff);
    mat.setShininess(50.);
    //todo: mat.setOpacity(0.7);
    
  }
  
  mesht->setVisible(state);
  mesht->setTransparent(opac<0xff000000);
  
  mesht->setID(id);
  pobjects->append(mesht);
  
  ptpCollector->setNeedReConstruct(mesht->isTransparent()||true);
  //todo: if it was on before and we switch transparency off, the above
  // does not work, since now we had a change and need to recollect the tree
  pneedrepaint=true;

}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawLegend(const QString &title
			 ,const QString &min
			 ,const QString &max
			 ,bool legendstate,bool legendunitstate
			 ,const IsoColor &isocolor)
{
  NSF("OGLView::drawLegend");
  myDebug() << nsubfunc;
  
  makeCurrent();

  String id="Legend colorband";
  pobjects->clear(id);

  long fontres=0;
  bool antialias=true;

  double width=0.8;
  double height=0.06;
  double x0=(1-width)*0.5;
  double y0=0.055;

  ogldatacache->invalidateLegend(isocolor.colorModel());
  
  OGLLegend *leg
    =new OGLLegend(width,height,height/width,x0,y0,OGLLegend::Horizontal,
		   isocolor.colorModel());

  OGLMaterial &mat=leg->material();
  mat.setAmbient((QRgb)0);
  mat.setSpecular(0);
  mat.setBase(0);
  mat.setDiffuse((QRgb)0);

  if(legendstate)
    pdoc->view().setLowerRim(y0+height+0.02);
  else
    pdoc->view().setLowerRim(0);
  
  leg->setVisible(legendstate);
  leg->setOntop(true);
  
  leg->setID(id);
  pobjects->append(leg);


  
  id="Legend title";
  pobjects->clear(id);
  if(!title.isEmpty()){
    
    OGLText *txt
      =new OGLText(title,Vec3(0.5,0.001,0),y0,1.
		   ,fontres,Vec3(-0.5,0.,0),antialias,OGLText::TwoD);
    
    
    {
      OGLMaterial &mat=txt->material();
      mat.setBase(0);
      mat.setDiffuse(0xff000000);
      mat.setAmbient((QRgb)0);
      mat.setSpecular(0);
      mat.setShininess(0);
    }
    txt->setVisible(legendunitstate);
    txt->setOntop(true);
    
    txt->setID(id);
    pobjects->append(txt);
  }
  {
    id="Legend text min";
    pobjects->clear(id);
    
    OGLText *txt
      =new OGLText(min,Vec3(x0,0.001,0),y0,1.
		   ,fontres,Vec3(-0.5,0.,0),antialias,OGLText::TwoD);
    
    
    {
      OGLMaterial &mat=txt->material();
      mat.setBase(0);
      mat.setDiffuse(0xff000000);
      mat.setAmbient((QRgb)0);
      mat.setSpecular(0);
      mat.setShininess(0);
    }
    txt->setVisible(legendstate);
    txt->setOntop(true);
    
    txt->setID(id);
    pobjects->append(txt);
  }
  {
    id="Legend text max";
    pobjects->clear(id);
    
    OGLText *txt
      =new OGLText(max,Vec3(1-x0,0.001,0),y0,1.
		   ,fontres,Vec3(-0.5,0.,0),antialias,OGLText::TwoD);
    
    
    {
      OGLMaterial &mat=txt->material();
      mat.setBase(0);
      mat.setDiffuse(0xff000000);
      mat.setAmbient((QRgb)0);
      mat.setSpecular(0);
      mat.setShininess(0);
    }
    txt->setVisible(legendstate);
    txt->setOntop(true);
    
    txt->setID(id);
    pobjects->append(txt);
  }
  
  
  pneedrepaint=true;

}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::drawSpecialPoints(const SpecialSymPoints *specialpoints
				,int fontres)
{
  NSF("OGLView::drawSpecialPoints");
  myDebug() << nsubfunc;
  
  makeCurrent();

  String id="special point glyph";
  pobjects->clear(id);
  String idl="special point label";
  pobjects->clear(idl);
  String idp="special point path";
  pobjects->clear(idp);


  for(int ip=0;ip<specialpoints->size();ip++){
    const SpecialPoint *sp=specialpoints->at(ip);
    if(sp->type()!=Xf::SPTPoint) continue;

    double radscale=sp->pointRadius().D;
    if(specialpoints->useCommonProperties())
      radscale=specialpoints->pointRadius().D;
    double radius=pdoc->bound()->radius()*radscale;

    
    OGLSphere *sph
      =new OGLSphere(sp->point().toVec3(),radius,OGLSphere::Icosahedron,1);

    sph->setID(Sprintf("%s %d",id(),ip));

    {
      OGLMaterial &mat=sph->material();
      QRgb col=sp->pointColor();
      if(specialpoints->useCommonProperties())
	col=specialpoints->pointColor();

      mat.setBase(col);
      mat.setDiffuse(col);
      mat.setAmbient((QRgb)0);
      mat.setSpecular(0);
      mat.setShininess(0);
    }
    sph->setVisible(specialpoints->isVisible()&&sp->isVisible());

    pobjects->append(sph);
    

    if(!sp->name().isEmpty()){
      double fscale=sp->fontScale().D;
      if(specialpoints->useCommonProperties())
	fscale=specialpoints->fontScale().D;
      OGLText *txt
	=new OGLText(sp->name(),sp->point().toVec3()
		     ,pdoc->bound()->radius()*fscale,1.
		     ,fontres,sp->shift().toVec3(),true
		     ,OGLText::CoMovingCameraFacing);
      txt->setPickable(true);
      txt->setVisible(specialpoints->isVisible()&&sp->isVisible());
      {
	OGLMaterial &mat=txt->material();
	mat.setBase(0);
	QRgb col=sp->textColor();
	if(specialpoints->useCommonProperties())
	  col=specialpoints->textColor();
	
	mat.setDiffuse(col);
	mat.setAmbient((QRgb)0);
	mat.setSpecular(0);
	mat.setShininess(0);
      }    
      txt->setID(Sprintf("%s %d",idl(),ip));
      pobjects->append(txt);
    }    

  }

  ValueArray<ValueArray<Vec3> > paths;
  ValueArray<Vec3> segment;
  for(int ip=0;ip<specialpoints->size();ip++){
    const SpecialPoint *sp=specialpoints->at(ip);
    if(!sp->isVisible()) continue;

    if(sp->type()==Xf::SPTPoint){
      segment.append(sp->point().toVec3());      
    }else if(sp->type()==Xf::SPTJump){
      if(segment.size()>1){
	paths.append(segment);
      }
      segment.clear();
    }
  }
  if(segment.size()>1){
    paths.append(segment);
  }
  
  OGLLine *line=new OGLLine(paths,specialpoints->pathLineWidth());
  line->setID(idp);
  OGLMaterial &mat=line->material();
  QRgb col=specialpoints->pathColor();
  mat.setBase(col);
  mat.setDiffuse(col);
  line->setVisible(specialpoints->isVisible()&&specialpoints->showPath());
  pobjects->append(line);
	





  
    
  pneedrepaint=true;

}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::setVisible(const String &id,bool v)
{
  bool trans=pobjects->setVisible(id,v);
  ptpCollector->setNeedReConstruct(trans);
  myDebug()<<"OGLView::setVisible needReConstruct="<<id<<ptpCollector->needReConstruct();
  myDebug()<<"OGLView::setVisible trans="<<trans;
  pneedrepaint=true;

  //updateGL();

}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void OGLView::writePNG(const QString &file,long magfac,int quality
		       ,Status *statusbar)
{
  NSF("OGLView::writePNG");
  //myDebug() << nsubfunc;

  QFileInfo fi(file);
  QString suffix=fi.suffix().toUpper();
  QString fmt;
//   if(suffix=="PNG" ){
//     fmt="PNG";
//  }else
  if(suffix=="JPG" || suffix=="JPEG"){
    fmt="JPG";
  }else if( suffix=="BMP" ){
    fmt="BMP";
  }else{
    QMessageBox::warning(this,"Save image"
			 ,"Unknown image type (supported: jpg bmp)"
			 ,QMessageBox::Yes );
    return;
  }


  makeCurrent();
  

  pprinting=true;
  QImage *pic;pic=0;

  statusbar->setProgress(0.); 

  if(doubleBuffer()){
    setAutoBufferSwap(false);
  }

  for(int i=0;i<magfac;i++){
    for(int j=0;j<magfac;j++){

      statusbar->setProgress(1.*(j+magfac*i)/(magfac*magfac-1)); 
      if(interrupt.requested()) goto clean;

      {
	View &view=pdoc->view();
	
	
	
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	double T=view.top();
	if(view.isPerspective()){

	  double phimax=atan2(winT*T,view.near());
	  double phimin=atan2(winB*T,view.near());
	  double dphi=phimax-phimin;

	  double DN=view.near()*tan((dphi/magfac*(j)+phimin));
	  double UP=view.near()*tan((dphi/magfac*(j+1)+phimin));
	  

	  phimax=atan2(winR*T,view.near());
	  phimin=atan2(winL*T,view.near());
	  dphi=phimax-phimin;
	  
	  double L=view.near()*tan((dphi/magfac*(i)+phimin));
	  double R=view.near()*tan((dphi/magfac*(i+1)+phimin));

	  glFrustum(L,R,DN,UP,view.near(),view.far());
	  ogl.reportGLError(nsubfunc,"glFrustum");
	}else{
	  //     myDebug() << "N="<<N;
	  //     myDebug() << "F="<<F;
	  double L=i*W*T/magfac+winL*T;
	  double R=(i+1)*W*T/magfac+winL*T;
	  double DN=j*H*T/magfac+winB*T;
	  double UP=(j+1)*H*T/magfac+winB*T;
#ifdef QT_OPENGL_ES_1
	  glOrthod(L,R,DN,UP,view.near(),view.far());
#else
	  glOrtho (L,R,DN,UP,view.near(),view.far());
#endif
	}
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	
	glMultMatrixd(view.matrix()());
	glTranslated(-view.origin_cam_w()[0],-view.origin_cam_w()[1],
		     -view.origin_cam_w()[2]);
	
      }
      pneedrepaint=true;
      pobjects->setMagnifier(OGLMagnifier(i,j,magfac));
      updateGL();

      QImage img=grabFrameBuffer();
      //QImage img=renderPixmap().toImage();


      if(!pic){
	pic=new QImage(width()*magfac,height()*magfac,img.format());
	pic->fill(Qt::white);
      }


//       myDebug() << img.format()<<img.size();
//       myDebug() << pic->format();
      //wp.drawImage(i*width(),(magfac-1-j)*height(),img,Qt::AutoColor);
      for(int ix=0;ix<width();ix++){
	for(int iy=0;iy<height();iy++){
	  pic->setPixel(ix+i*width(),iy+(magfac-1-j)*height()
			,img.pixel(ix,iy));
	}
      }
      
    }
  }



  pobjects->setMagnifier(OGLMagnifier());

  pobjects->overpaint(pic);

  pic->save(file,fmt.toAscii().constData(),quality);


  if(doubleBuffer()){
    setAutoBufferSwap(true);
  }

 clean:
  pprinting=false;

  pobjects->setMagnifier(OGLMagnifier());

  if(pic) delete pic;

  statusbar->setProgress(0); 
  
  //myDebug() << "doubleBuffer()" << doubleBuffer();
  if(!doubleBuffer()){
    swapBuffers();
  }else{
    doRendering();
  }

  return;


}


/*EOF*/ 
