/* @(#)OGLVolume.hh
 * author: magru@unas
 */

#ifndef _OGLVOLUME_HH
#define _OGLVOLUME_HH 1

#include "OGLDataCache.hh"
#include "OGLObject.hh"


namespace XFPLO{
  class RepVolume;
  
  /* ***********************************************************************
   *
   * ***********************************************************************
   */
  class OGLVolume: public OGLObject
  {
  public:
    
    OGLVolume(const RepVolume *rep);
    virtual ~OGLVolume();
    
    bool NFPlane(const Vec3 &n,double &near,double &far);
    
    
    void paint(OGLView *oglview,const OGLMagnifier &mag
	       ,bool reduced,bool badTransparency)const;
    void construct(OGLView *oglview);
    void protectCachedData();
    //    void collectTransparent(OGLTransparentCollector *tpCollector,bool reduced);
    
    OGLMaterial &materialFront(){return pmaterialfront;};
    OGLMaterial &materialBack(){return pmaterialback;};
    
    bool pick(const View &/*v*/,double /*x*/,double /*y*/,double &z)
    {z=0.;return false;};
    
    
  protected:
    
    
  private:
    const RepVolume *prep;
    OGLMaterial pmaterialfront;
    OGLMaterial pmaterialback;
    OGLDataCacheItem *cachedData;
    
  };

  /* ***********************************************************************
   *
   * ***********************************************************************
   */
  class OGLDataCacheVolumeItem: public OGLDataCacheItem
  {
  public:
    OGLDataCacheVolumeItem(const RepVolume *rep);
    
    QString printSpecQ()const;
    
    void construct(bool transparent);
    void paint(bool transparent)  const;
    // void collectTransparent(OGLTransparentCollector *
    // 			    ,const OGLMaterial &matfront,const OGLMaterial &matback);
    
    
  private:
    const RepVolume *prep;
    friend class OGLDataCache;
    
  };
  
}
#endif /* _OGLVOLUME_HH */
  
  
