/*************************************************************************
 * @(#)RepAutoGlyph.cpp
 * author: magru@unas
 * date:   09 Jun 2013
 *************************************************************************
 */

#include "RepAutoGlyph.hh"
#include "Field.hh"
#include "IsoSurface.hh"
#include "OGLView.hh"
#include "OGLAutoGlyph.hh"

using namespace XFPLO;

/* ***********************************************************************
 *
 * ***********************************************************************
 */

RepAutoGlyph::RepAutoGlyph(OGLView *oglview)
  :Representation(oglview,"RepAutoGlyph"),pcolor(0xff0000)
{
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool RepAutoGlyph::cascadingUpdate(const String &prefix)
{
  if(Module::debugmode) printf("%s%s::cascadingUpdate\n",prefix(),id()());
  Module::cascadingUpdate(prefix+"  ");

  bool ret=false;
  
  showDirt(prefix,Sprintf("%s must react to",id()()));
  if(pisdirty||dirtyInput()){
    sendDirt("changed");
    ret=true;
  }
  resetDirt();
  if(Module::debugmode) printf("%sret=%d\n",prefix(),ret);
  return ret;
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
void RepAutoGlyph::draw(OGLView *oglview)
{
  //printf("%s::draw\n",id()());

    
  oglview->makeCurrent();

  
  
  if(!pisvisible) return;
  
  //find out if we need updates of data
  if(!cascadingUpdate("")) return;
  // if data update was succesfull, and if changed remake the object

  //todo: we need a way to interrupt the cascading update and return 
  //      a stop signal
  //todo: do we need a non-recursive alog, which can run the tree in
  //      parallel, if not dependend?


    
  //myDebug()<<"id = "<<id()<<"is visible";

  oglview->removeObject(id());
    
  OGLAutoGlyph *aglp=new OGLAutoGlyph(this);
  aglp->material().setBase(pcolor);
  aglp->material().setDiffuse(pcolor);
  oglview->appendObject(aglp);
    
  oglview->setNeedRepaint(true);
    
  
}

/*EOF*/ 
