/*************************************************************************
 * @(#)RepVolume.cpp
 * author: magru@unas
 * date:   02 Jul 2013
 *************************************************************************
 */

#include "RepVolume.hh"
#include "OGLView.hh"
#include "OGLVolume.hh"
#include "MyDebug.hh"

using namespace XFPLO;

/* ***********************************************************************
 *
 * ***********************************************************************
 */

RepVolume::RepVolume(OGLView *oglview)
  :Representation(oglview,"RepVolume"),pcolor(0xff0000),pshownormals(false)
{
}

/* ***********************************************************************
 *
 * ***********************************************************************
 */
bool RepVolume::cascadingUpdate(const String &prefix)
{
  if(Module::debugmode) printf("%s%s::cascadingUpdate\n",prefix(),id()());
  Module::cascadingUpdate(prefix+"  ");

  bool ret=false;
  
  showDirt(prefix,Sprintf("%s must react to",id()()));
  if(pisdirty||dirtyInput()){
    sendDirt("changed");
    ret=true;
  }
  resetDirt();
  if(Module::debugmode) printf("%sret=%d pisdirty=%d\n",prefix(),ret,pisdirty);
  return ret;
}


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void RepVolume::draw(OGLView *oglview)
{
  //printf("%s::draw\n",id()());

    
  oglview->makeCurrent();

  
  
  if(!pisvisible) return;
  
  //find out if we need updates of data
  if(!cascadingUpdate("")) return;
  // if data update was succesfull, and if changed remake the object

  //todo: we need a way to interrupt the cascading update and return 
  //      a stop signal
  //todo: do we need a non-recursive alog, which can run the tree in
  //      parallel, if not dependend?


    
  //myDebug()<<"id = "<<id()<<"is visible";
  //myDebug()<<"index = "<<oglview->objects()->indexOf(id(),true);

  oglview->removeObject(id());
    
  OGLVolume *ob=new OGLVolume(this);
  double shininess=50.;
  QRgb specc=0xff777777;
  ob->materialFront().setBase(pcolor);
  ob->materialFront().setDiffuse(pcolor);
  ob->materialFront().setShininess(shininess);
  ob->materialFront().setSpecular(specc);
  ob->materialBack().setBase(0xff00);
  ob->materialBack().setDiffuse(0xff00);
  ob->materialBack().setShininess(shininess);
  ob->materialBack().setSpecular(specc);
  // setEmission(0xff000000);
  // setShininess(50.0);


  oglview->appendObject(ob);

  //todo: the transparent thing, which did not always work for triang
    
  oglview->setNeedRepaint(true);
    
  
}



/*EOF*/ 
