/* @(#)Representation.hh
 * author: magru@unas
 */

#ifndef _REPRESENTATION_HH
#define _REPRESENTATION_HH 1

#include "BoundingBox.hh"
#include "Module.hh"

class OGLView;

namespace XFPLO{


  class Field;
  
  /* ***********************************************************************
   *
   * ***********************************************************************
   */
  
  
  class Representation: public Module{
  public:
    Representation(OGLView *oglview,const char *classname)
      :Module(classname),pfield(0),poglview(oglview){setVisible(false);}
    virtual ~Representation(){}
    
    virtual bool hasTransparency()const{return false;}
    
    virtual bool isVisible()const{return pisvisible;}
    
    virtual void setVisible(bool v);
    
    const Field *field()const{return pfield;}
    
    virtual const BoundingBox &boundingBox() const;
    
    virtual void draw(OGLView *oglview)=0;
    
    static void draw(OGLView *oglview,ValueArray<Representation *>reps);
    
  protected:
    virtual void setInput(const Module *input);
    virtual void removeInput(const Module *);
  protected:
    const Field *pfield;
    bool pisvisible;
    OGLView *poglview;
  private:
  };
  
}

#endif /* _REPRESENTATION_HH */

