/* @(#)Actions.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ACTIONS_H
#define _ACTIONS_H 1

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class Actions{

 public:
  enum ActionData{
    Activities=1
    ,Activities_FermiSurface=10
    ,Activities_Structure=11
    ,Activities_StructureFromIn=12
    ,Activities_FatBand=13
    ,Activities_Quit=14
    ,File=2
    ,File_Open=20
    ,File_Save=21
    ,File_SaveAs=22
    ,File_Reload=23
    ,File_Close=24
    ,File_Export=25
    ,File_Export_kPoints=250
    ,File_Print=26
    ,File_Print_Surface=260
    ,File_Print_Structure=261
    ,File_Import=27
    ,File_Import_In=270
    ,File_Import_STM=271
    ,File_Import_CIF=272
    ,Input=3
    ,Input_DefineMesh=30
    ,Input_FermiDlg=31
    ,Input_HandMadeSymmetry=32
    ,Input_BoundaryDlg=33
    ,Input_SymmetryDlg=34
    ,Input_FileDlg=35
    ,Plot=4
    ,Plot_PlotSettings=40
    ,Plot_ColorSettings=41
    ,Plot_Annotations=42
    ,Plot_DisplayCells=43
    ,Plot_Lighting=44
    ,Plot_SpecialPoints=4049
    ,Plot_Fog=49
    ,Plot_Calculate=45
    ,Plot_Recalculate=46
    ,Plot_Canvas=47
    ,Plot_Bonds=48
    ,Plot_AtomProps=4050
    ,Plot_Test=4051
    ,Options=5
    ,Options_kExport=50
    ,Options_InputControl=51
    ,Options_Misc=52
    ,Options_EmptyLattice=53
    ,Options_Clip=54
    ,Tools=6
    ,Tools_Measure=60
    ,Tools_FindAtom=61
    ,Tools_MapDensity=62
    ,Tools_FSSweep=63
    ,Tools_ShowSymOps=64
    ,Tools_UnfoldingEditor=65
    ,Tools_SiteHistory=66
    ,Run=9
    ,Run_Terminal=90
    ,Run_ExternalEditor=91
    ,Run_RunFPLO=92
    ,Window=100
    ,Window_Output=101
    ,Window_Style=102
    ,Window_Style_Style=1020
    ,Help=200
    ,Settings=300
    ,Preferences=301
  };

  static QStringList data(ActionData ad){
    return QString("%1 0").arg(ad).split(" ");};
  static QStringList data(ActionData ad,const QString s){
    return QString("%1 %2").arg(ad).arg(s).split(" ");};

  static QString extract(const QVariant &v,int which){
    QStringList sl=v.toStringList();
    if(which<sl.size())
      return sl.at(which);
    else
      return "";
  };
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _ACTIONS_H */

