/* @(#)Activity.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _ACTIVITY_H
#define _ACTIVITY_H 1

#include <QString>
#include "MyDebug.hh"

class Activity{
 public:
  enum ActivityType{None=0,Structure=1,FermiSurface=2,BandWeightCreate=3
		     ,StructureFPLOIn=4};
  Activity(ActivityType at,const QString &cdir="",
	     const QString &file=""):ptype(at),pcdir(cdir),pfile(file){};

    inline ActivityType type()const{ return ptype; };
    inline bool isA(ActivityType at)const{ return at==ptype; };
    inline const QString cdir()const{ return pcdir; };
    inline const QString file()const{ return pfile; };
    inline QString activityTypeName()const{return ptypename[ptype];};
private:
  ActivityType ptype;
  QString pcdir;
  QString pfile;
  static const char *ptypename[];
};

MyDebug operator<<(MyDebug dbg, const Activity &a);

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _ACTIVITY_H */

