/* @(#)BWEdit.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _BWEDIT_H
#define _BWEDIT_H 1

#include "ui_BWEdit.h"
#include "ControlBase.hh"

class MySignalMapper;
class BWDoc;

class BWEdit  : public ControlBase ,private Ui::BWEdit
{
  Q_OBJECT
public:
  BWEdit(MWBase *parent = 0);
  ~BWEdit();

  virtual void afterShow(const QString &load);
  virtual bool queryExit();

protected:
  bool isModified();

private:
  enum SaveMode{FILESAVE=1,FILESAVEAS=2};

private:
  void setupMenus();
  void CoeffImport(const QString &fileName,bool forceload);
  void populateTrvCombis();
  void saveit( SaveMode saveas );
  void fileLoad(const QString &fileName);
  void enableOnCoeffRead(bool onoff);

private slots:
  void slotFileClose();
  void slotPlotCalc();
  void on_tbBrowse_clicked();
  void on_tbBrowseBWF_clicked();
  void on_leBandWeights_textChanged();
  void on_leCoefficients_textChanged();
  void on_pbBuildWeights_clicked();
  void on_pbRefresh_clicked();
  void on_cbUseCoeffFile_toggled(bool);

  void help();
  void slotFileSave();
  void slotFileSaveAs();
  void slotExternalEdit();
  void slotFileOpen();
  void slotReload();
  void slotEnableBase(bool en);

  //  void filemodified(const QString & path);
private:
  BWDoc *doc;
  QAction *reloadAction;
  MySignalMapper *signalMapper;

};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _BWEDIT_H */

