/*************************************************************************
 * @(#)CanvasSize.cpp
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   04 Aug 2009
 *************************************************************************
 */


#include "CanvasSize.hh"
#include "Parser.hh"
#include "Except.hh"


/* ***********************************************************************
 *
 * ***********************************************************************
 */
void CanvasSize::canvasPTSectionToFile(FILE *FH)
{
  fprintf(FH,
	  "    struct{ logical locked; "
	  "struct{int width;int height;}size;}canvas\n"
	  "    ={%c,{%ld,%ld}};\n\n"
	  ,(plocked ? 't':'f'),pwidth,pheight);
}
/* ***********************************************************************
 *
 * ***********************************************************************
 */
void CanvasSize::readCanvasPTSectionFromFile(Parser *par)
{

  pwidth=400;
  try{
    pwidth=(*par)()("canvas.size.width").valueL();
  }catch(Except){};

  plocked=false;
  try{
    plocked=(*par)()("canvas.locked").valueL();
  }catch(Except){};

  pheight=400;
  try{
    pheight=(*par)()("canvas.size.height").valueL();
  }catch(Except){};
  
}



/*EOF*/ 
