#include <QApplication>
#include <QStyleFactory>
#include <QGLFormat>
#include <QFileInfo>
#include <QPixmap>
#include <QDir>
#include <stdlib.h>





#include "BrainDialog.hh"
#include "ReselectEvent.hh"
#include "AfterShowEvent.hh"
#include "AntiAliasing.hh"
#include "Boundary.hh"
#include "Vlevel.hh"
#include "Config.hh"
#include "Parser.hh"
#include "OGL.hh"
#include "Settings.hh"
#include "PropertyTable.hh"
#include "Except.hh"
#include "BondDefs.hh"
#include "IconCache.hh"
#include "Master.hh"
#include "ShortCuts.hh"
#include "Interrupt.hh"
#include "XfploHelp.hh"
#include "qt5compat.hh"
#include "SqMatrix.hh"
#include "Cmplx.hh"




// #include "CIF.h"


String EXECNAME;
String EXECNAMESHORT;

IconCache iconcache;

const String  
#include "../mainversion.h" 
;
const String  
#include "../subversion.h" 
;
const String  
#include "../release.h" 
;

const QString IDS_APP_NAME=QString("XFPLO ") + FPLOMAINVERSION();
const QString IDS_APP_ABOUT=QString("XFPLO\nVersion ") + FPLOMAINVERSION()
  + "\n(w) 2014 by Klaus Koepernik";

const QString IDS_APP_INI_PATH=QDir::homePath()+"/.xfplo";
const QString IDS_APP_HELP_PATH=IDS_APP_INI_PATH+"/Help";
const QString IDS_APP_HELP_FILE="xfplohelp";
const QString IDS_APP_HELP_FULL_FILE=IDS_APP_HELP_PATH+"/"+IDS_APP_HELP_FILE
  +".qhc";

const QString IDS_CLOSE_TIP="\
Commit, update and close";

const QString IDS_APPLY_TIP="\
Commit data and update the sceene.\
";
const QString IDS_CANCEL_TIP="\
Discard changes after last commit and close\
";

OGL ogl;

Interrupt interrupt;

AntiAliasing antiAliasing;


QFileSystemWatcher fileSystemWatcher;

char lang[7] ="LANG=C";
char lcall[9]="LC_ALL=C";




/* ***********************************************************************
 *
 * ***********************************************************************
 */
int main( int argc, char ** argv )
{

  if(0){
    Vec3 nz(0,0,1);
    //nz=Vec3(3,-1,4.2);
    for(long l=-1;++l<3;){
      SqMatrix<Cmplx> T=relTOpseudo(nz,l);
      printSqMatrix(T,"%9.5f+i*%9.5f ");
    }
    
    exit(0);
  }
  
  if(0){

    if(0){
      for(int i=0;i<256;i++) {
	unsigned char x=i;
	
	unsigned char co = x - ((x >> 1) & 0x55);
	co = ((co >> 2) & 0x33) + (co & 0x33);
	co = ((co >> 4) + co) & 0x0f;
	
	printf("%3d: %8s %x count=%d,%s\n",i,toBin(x,true)(),x,MyMath::bitCount(x)-co,
	       toBin(co,true)());
      }
      exit(0);
    }
    
    ValueArray<unsigned char> pats;
    for(int i=0;i<256;i++) pats<<i;

    //for(int i=pats.size();--i>=0;){
      //int s;
      //detPattern3DCub(pats[i],s);
    //}

    pats.qSort();
    for(int i=-1;++i<pats.size();){
      for(int j=pats.size();--j>i;){
	if(pats.at(i)==pats.at(j))
	  pats.removeAt(j);
      }
    }
    for(int i=-1;++i<pats.size();){
      unsigned char x=pats[i];
      int count=8-MyMath::bitCount(x);

      unsigned char x0=MyMath::bitCount(x& 0x55);
      unsigned char x1=MyMath::bitCount(x& 0xaa);
      unsigned char y0=MyMath::bitCount(x& 0x33);
      unsigned char y1=MyMath::bitCount(x& 0xcc);
      unsigned char z0=MyMath::bitCount(x& 0x0f);
      unsigned char z1=MyMath::bitCount(x& 0xf0);
      
      // if(x==0xfe) continue; //here count==1 343434is ready
      // if(x==0xf8) continue; //here count==3:232314 is ready
      // if(x==0xf0) continue; //here count==4:222204 is ready
      // if(x==0xfc) continue; //here count==2:332424 is ready
      // if(x==0xe9) continue; //here count==3:232323 is ready
      // if(x==0xe8) continue; //here count==4:131313 is ready
      // if(x==0x96) continue; //here count==4:222222 is ready
      // if(x==0xda) continue; //here count==3:232323 da is ready
      // if(x==0xa5) continue; //here count==4:222222 a5 is ready
      // if(x==0xd8) continue; //here count==4:221313 d8 is ready
      // if(x==0xf6) continue; //here count==2:333324 f6 is ready
      // if(x==0x7e) continue; //here count==2:333333 7e is ready
      // if(x==0xe1) continue; //here count==4:222213 e1 is ready

      int s;
      //count=detPattern3DCub(pats[i],s);

      printf("%3d: %8s %x inv=%d, count=%d: %d%d%d%d%d%d\n",i,toBin(x,true)(),x,s,
	     count,x0,x1,y0,y1,z0,z1);
    }

    exit(0);
  }
  if(0){
    double a=17.3;
    double b=-5.2;
    myDebug()<<a<<b;
    MyMath::swap(a,b);
    myDebug()<<a<<b;
    
    exit(0);
  }
  if(0){
    long N=1000;
    for(long nn1=1;nn1<=N;nn1++){
      for(long nn2=1;nn2<=N;nn2++){
	long D=MyMath::gcd(nn1,nn2);
	long N=nn1*nn2/D;
	if(N<nn1*nn2 && !(N%nn1==0|| N%nn2==0)){
	  myDebug()<<"n1"<<nn1<<"n2"<<nn2<<N;
	}
      }
    }
    exit(0);
  }

  if(0){
    long N=1000;
    for(long nn1=1;nn1<=N;nn1++){
      for(long nn2=1;nn2<=N;nn2++){
	long D=MyMath::gcd(nn1,nn2);
	long n1=nn1/D;
	long n2=nn2/D;
	
	for(long r=0;r<MyMath::min<long>(n1,n2);r++){
	  //alpha*n1+beta*n2=r

	  long beta1;
	  for(long i=0;i<=n1;i++){
	    if((i*n2)%n1==1){
	      beta1=i;
	      break;
	    }
	  }
	  long alpha1=(1-beta1*n2)/n1;
	  if(alpha1*n1+beta1*n2!=1){
	    myDebug()<<"error beta1"<<alpha1<<"*"<<n1<<"+"<<beta1<<"*"<<n2;
	    exit(1);
	  }

	  long beta;
	  for(long i=0;i<=n1*r;i++){
	    if((i*n2)%n1==r){
	      beta=i;
	      break;
	    }
	  }
	  long alpha=(r-beta*n2)/n1;
	  if(alpha*n1+beta*n2!=r){
	    myDebug()<<"error beta";
	    exit(1);
	  }

	  
	  if((beta-r*beta1)%n1!=0){
	    myDebug()<<" not multiple "<<alpha<<"*"<<n1<<"+"<<beta<<"*"<<n2<<"="
		    <<r;
	  }
	  
	  

	}
	
      }
    }
    exit(0);
  }
  if(0){
    long N=10;
    for(long n1=1;n1<=N;n1++){
      for(long n2=1;n2<=N;n2++){
	long D1=MyMath::gcd(n1,n2);
	long D2=MyMath::gcd(n1+n2,n1*n2);
	if(abs(D1-D2)!=0){
	  myDebug()<<"not true"<<n1<<n2<<D1<<D2;
	  //exit(1);
	}
      }
    }
    exit(0);
  }



  globalproperties=new AtomPropertyTables();

//   myDebug() << "here 1";
//   CIF cif;
//   myDebug() << "here 2";
//   cif.readFromFile(argv[1]);
//   exit(0);
  

  // hack to force english numeric settings and stuff
  putenv(lang);
  putenv(lcall);


  BondDefSortProperties::setUpDefaultPolyProps();

  myDebug() << "loading ...";
  //QLocale::setDefault(QLocale("en_US"));
  
  ShortCuts::setDefaulShortCuts();
  Boundary::setDefaultUserFaces();
  
  EXECNAME=argv[0];
  
  EXECNAMESHORT=QFileInfo(EXECNAME()).fileName().toAscii().constData();
  
  AfterShowEvent::AfterShowEventType=(QEvent::Type)QEvent::registerEventType();
  ReselectEvent::ReselectEventType=(QEvent::Type)QEvent::registerEventType();
  //QApplication::setColorSpec( QApplication::ManyColor );
  QApplication *a=new QApplication( argc, argv );

  
  antiAliasing.readSettings();

  XfploHelp::createHelpFiles();

  if(!QGLFormat::hasOpenGL()){
    printf("The system seems not ot support opengl!\n");
    exit(1);
  }

  //a.setFont(QFont("helvetica", 9,QFont::Normal));
  //  a->setStyle( new QPlastiqueStyle() );
  {
    QString st=Settings("application").getString("style");
    if(QStyleFactory::keys().contains(st)){
      a->setStyle(st);
    }
  }
  

  a->connect(a,SIGNAL(lastWindowClosed()),a,SLOT(quit()));

  int ret;
  try{
    Master master(a);
    //myDebug() << "master lives";
    ret=a->exec();
  }catch(Except ex){
    printf("%s\n",ex.msg());
  }

  
  delete a;
  Parser::finalCleanUp();
  delete globalproperties;



  return ret;

}
