/*************************************************************************
 * @(#)Master.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 * date:   03 Jul 2009
 *************************************************************************
 */
#ifndef MASTER_H
#define MASTER_H
#include <QObject>
#include <QStringList>
#include <QList>
#include "Activity.hh"

class QApplication;
class QTimer;
class MWBase;

/* ***********************************************************************
 *
 * ***********************************************************************
 */
class Master : public QObject
{

Q_OBJECT

public:
  Master(QApplication *a=0);
  ~Master();

  void registerActivity(MWBase *);
  void unRegisterActivity(MWBase *);
  bool showOutWin() {return showoutwin;};

  long numOfActivitiesOfType(Activity act);

  static QString fileType(QString fname,bool complain);

public slots:
  void requireQuit();

private slots:
  void checkActs();

private:
  QString getArgument(int i);

private:

/*   class Acts{ */
/*   public: */
/*     Acts(MWBase *b):base(b),closed(false){}; */
/*     MWBase *base; */
/*     bool   closed; */
/*     bool operator==(const Acts &other){ return (base==other.base);}; */
/*   private: */
/*     Acts();// not implemented */
/*   }; */
  QStringList arg;
  QList<MWBase *> activities;
  QTimer *timer;
  bool showoutwin;
};

#endif // MASTER_H
