/* @(#)MySignalMapper.hh
 * author: magru@unas
 */

#ifndef _MYSIGNALMAPPER_HH
#define _MYSIGNALMAPPER_HH 1

#include <QSignalMapper>
#include <QList>

/* ***********************************************************************
 *
 * ***********************************************************************
 */


class MySignalMapper: public QSignalMapper
{
  Q_OBJECT;
public:

  // ----------------------------------------------------------------
  class Data{
  public:
    Data(QObject *o,const char *s,int c):object(o),signal(s),code(c){}
    QObject *object;
    QString signal;
    int code;
  };
  
  // ----------------------------------------------------------------
  MySignalMapper(QObject *parent,QObject * receiver,const char *slot,
		 const QList<Data> &mappees)
  :QSignalMapper(parent)
  {
    connect(this,SIGNAL(mapped(int)),receiver,slot);

    for(int i=-1;++i<mappees.size();){
      setMapping(mappees[i].object,mappees[i].code);
      connect(mappees[i].object,
	      mappees[i].signal.toAscii().constData(),
	      this,SLOT(map()));
    }
  }

  // ----------------------------------------------------------------
  ~MySignalMapper()
  {
  }
protected:
private:
};


#endif /* _MYSIGNALMAPPER_HH */

