/* @(#)OutWin.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _OUTWIN_H
#define _OUTWIN_H 1

#include <QList>
#include <QFont>
#include "ui_OutWin.h"

class OutWin: public QMainWindow, private Ui::OutWin
{
  Q_OBJECT
    
public:
  OutWin(QWidget *parent=0);

  void clear();
  void setText(const QString &title ,const QString &text);


 private slots:
  void stateChanged();
  void setControlEnabled();
  void setCurrentFont(QFont);
  void save();

 private:

  void setupCheckBoxes();
  bool visible(const QString &title);


  class Chapter 
  {
  public:
    Chapter(const QString &t):title(t),text(""){};
    Chapter(const QString &t,const QString &te):title(t),text(te){};
    bool operator==(const Chapter &other ){return ( title==other.title);};
    QString title;
    QString text;
  };

  QList<Chapter> list;


  QList<QString> chlist;

  QString fname;
};

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _OUTWIN_H */

