/* @(#)Status.hh
 * author: Klaus.Koepernik@ifw-dresden.de
 */

#ifndef _STATUS_H
#define _STATUS_H 1

#include <QStatusBar>
#include "Xf.hh"

//forward
class QProgressBar;
class QTimer;
class QLabel;
class QString;
class QToolButton;
class CanvasSize;

class ElidLabel;

// the class
class Status: public QStatusBar
{
  Q_OBJECT
public:
  Status(QWidget * parent = 0 );
  ~Status();

public slots:


  void setBusyProgress(bool onoff);

  void setProgressInt(int p){setProgress(p/100.);}
  void setProgress(double percent);
  double getCurrentProgress();
  void setAllotedPercent(double a){palloted=a;};
  double allotedPercent()const{if(palloted<0)return 0.1;return palloted;};

  void setDocument(const QString &name);
  void setMessage(const QString &msg,int msec=0);
  void setMessage(){setMessage("");};
  void deleteMessage(){labelTimer();};

  void setCanvasControlEnabled(bool e);
  void setCanvasControl(const CanvasSize &canvas);

  void setName(const QString &n){pname="["+n+"] ";};

  Xf::LengthUnits preferedLengthUnit()const{return plengthunit;};

  //  void setFullGo(bool go){pfullgo=go;};

 signals:
  void canvasLockClicked(bool);

 private slots:

  void labelTimer();
  void beware(const QString &);
  void tbCanvasLockClicked(bool onoff);
  void tbConfigClicked(bool onoff);
  void onTbInteruptClicked();

 private:


  QProgressBar *progbar;
  QToolButton *tbInterupt;
  QLabel *msglabel;
  QLabel *sizeindicator;
  QTimer *labeltimer;
  long interval;
  QToolButton *tbCanvasLock;
  QToolButton *tbConfig;
  QString pdocumentname;
  bool pcanvascontrol;
  double pcurrentprogold;
  double pcurrentprog;
  double palloted;
  bool pfullgo;
  QString pname;
  Xf::LengthUnits plengthunit;
};


#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif


#endif /* _STATUS_H */

