#!/usr/bin/perl -w

$f90ext="f90";
$modules_path=".";
$makefile="Makefile";
$specialflagfiles="";
$mainfiles="";
$makefiledep="";
$main_flag=0;

while (@ARGV){
  $arg=shift;
  # search path for F90 files
  if ($arg =~ /^-p$/){
    $modules_path=shift;
  }
  # extension of F90 source
  if ($arg =~ /^-tag$/){
    $f90ext=shift;
  }
  # which objs to be compiled with special flags
  if ($arg =~ /^-sf$/){
    $specialflagfiles=shift;
    $specialflagfiles=~s/^\s+//g;
    $specialflagfiles=~s/\s+$//g;
    $specialflagfiles=~s/\s+/ /g;
    @specialflagfiles=split /\s+/ , $specialflagfiles;
  }
  # driver list of execs and libs
  if ($arg =~ /^-main$/){
    $mainfiles=shift;
    $mainfiles=~s/^\s+//g;
    $mainfiles=~s/\s+$//g;
    @mainfiles=split ';',$mainfiles;
    $main_flag=1;
  }
  # nameo of makefile
  if ($arg =~ /^-m$/){
    $makefile=shift;
  }
  # make OBJS dependend on makefile ?
  if ($arg =~ /^-makedep$/){
    $makefiledep=$makefile;
  }

}


if(!$main_flag)  {
  print STDERR "This script needs an argument -main DESCRIPTION\n";
  print STDERR "Where DESCRIPTION has the following format\n";
  print STDERR " exec1:main_f90_file1:LIBS1[;exec2:main_f90_file2:LIBS1[;...]]\n";
  exit;
}



# vars for recursive run
@modules_path=split(/:/,$modules_path);
@global_out_dep=();
%hash_modules=();
%hash_uses=();
%hash_incs=();
#%libhash=();
%objhash=();
;
# output stuff
$global_out_objs="";
$global_out_targets="";
$outs="";
$targets="";
$links="";
$alttarget="";
$TARGETS="TARGETS=";
$target="";
$libsdep="";
#$libsdeps="";
#$make_lib_dep="";
$make_target="";

# prescan all F90-files (this enormously saves time)
&maketables();

#print STDERR %hash_modules;
#foreach $k (keys %hash_uses){
#  print "$k ",@{$hash_uses{$k}},"\n";
#}


# recursive run to create dependencies
my $prot=0;
$nt=0;
foreach $mf(@mainfiles){
  $nt++;
  my ($ex,$m,$libs)=split ':',$mf;
  $ex=~s/\s+//g;
  $m=~s/\s+//g;
  @global_objlist=();
  %globjhash=();
  $g_level="";
  make_dependenices($m); 
  $target.="\$(TARGET$nt) ";
  if ($ex eq "fplo") {
    $ex="\$\(PARALLEL)$ex";
  }
  $outs.="OUTGEN$nt=$ex\nOUT$nt=\$\(OUTGEN$nt\)\$\(MAINVERSION\)-\$\(RELEASE\)\$\(PLATFORM\)\$\(EXECBUILDSUFFIX\)\n";
  
  $targets.="TARGET$nt=\$\(OUT$nt\)\n";
  $alttarget.="\$\(OUTGEN$nt\): \$\(TARGET$nt\)\n";
#no generic links:  $links.="\trm -f \$\(BINDIR\)/\$\(OUTGEN$nt\)\n\tln -s \$\(TARGET$nt\) \$\(BINDIR\)/\$\(OUTGEN$nt\)\n";
  $links.="\trm -f \$\(BINDIR\)/\$\(OUTGEN$nt\)\n";
  $TARGETS.="\$\(TARGET$nt\) ";
  $global_out_objs.="OBJS${nt}=@global_objlist\n";
  $global_out_targets.="\$(TARGET$nt): \$(LIBS_DEP${nt})  \$(OBJS${nt}) \$(MAKEFILE)\n";
#  $global_out_targets.="\$(TARGET$nt): OPTIONSUPDATE \$(LIBS_DEP${nt})  \$(OBJS${nt}) \$(MAKEFILE)\n";
  $global_out_targets.="\t\$(F90) -o \$(TARGET$nt) \$(OBJS${nt}) \$(LOBJS${nt}) \$(LDFLAGS)\n";
  $libs=~s/^\s+//;
  $libs=~s/\s+$//;
  $libs=~s/\s+/ /g;
  $libsdep.="LIBS_DEP${nt}=m;;$libs\n";
#  @libs=split /\s/,$libs;
#  $libsdeps.="\nLIBS_DEP${nt}=";
  $make_target.="\t\$(MAKE) \$(TARGET${nt})\n";
#  foreach $l (@libs){
#    $libsdeps.="\\\n\t\$(LIBDIR)/lib$l.a";
#    if (! defined $libhash{$l} ){  
#      $libhash{$l}=1;
#      $make_lib_dep.="\t\@cd ../$l; \$(MAKE) all\n"
#    }
#  }
}

# make library dependency file
open FHO, ">$makefile.lib";
print FHO "\n$libsdep\n";
close FHO;
# create the rule  file
open FHO, ">$makefile.src";
#print FHO "\n$libsdeps\n";
print FHO "\nMAINVERSION=\n";
print FHO "\nRELEASE=\n";
print FHO "\nPLATFORM=\n";
print FHO "\nPARALLEL=\n";
print FHO "\n$outs\n";
print FHO "\n$targets\n";
print FHO "\n$TARGETS\n";
print FHO "\n$global_out_objs\n";
print FHO "\nall: $target\n";
print FHO "\t\@cd \$(ROOTDIR)/FEDIT ; \$(MAKE) all\n";
print FHO "\t\@cd \$(ROOTDIR)/BP    ; \$(MAKE) all\n";
print FHO "\t\@cd \$(ROOTDIR)/IOTEST; \$(MAKE) all\n";
print FHO "\t\@cd \$(ROOTDIR)/OPTICS; \$(MAKE) all\n";
print FHO "\t\@cd \$(ROOTDIR)/COMMON; \$(MAKE) install\n";
#print FHO "$make_target\n\n";
#print FHO "$make_lib_dep";
print FHO "\ninstall: $target\n";
print FHO "\t\@cd \$(ROOTDIR)/FEDIT ; \$(MAKE) install\n";
print FHO "\t\@cd \$(ROOTDIR)/BP    ; \$(MAKE) install\n";
print FHO "\t\@cd \$(ROOTDIR)/IOTEST; \$(MAKE) install\n";
print FHO "\t\@cd \$(ROOTDIR)/OPTICS; \$(MAKE) install\n";
print FHO "\t\@cd \$(ROOTDIR)/COMMON; \$(MAKE) install\n";
print FHO "\tmv $target \$(BINDIR)\n";
print FHO "$links";
print FHO "\nLIBRARIES:\n";
#print FHO "$alttarget";

print FHO "\n$global_out_targets\n";
close FHO;

# create the dependency  file
open FHO, ">$makefile.dep";
print FHO "\n# compile steps\n";
print FHO  @global_out_dep;
close FHO;


# End of main program 

##############################################

sub make_dependenices {# make_dependenices
  
  my $sourcefile=$_[0];
  $g_level.="   ";
  if($prot){
    print STDERR "$g_level# make_dependenices called with arg $sourcefile \n" ;
    print STDERR "$g_level# $sourcefile uses modules: ".
      "@{$hash_uses{$sourcefile}}  \n";
    print STDERR "$g_level# $sourcefile uses includes: ".
      "@{$hash_incs{$sourcefile}}  \n";
    print STDERR "$g_level# on entry HASH: @global_objlist\n";
  }
  
  my @modfiles=();
 MODULE:foreach $module (@{$hash_uses{$sourcefile}}){
    $f90filepath=$hash_modules{lc($module)};
    #print STDERR "\n$f90filepath contains $module\n";
    if(defined ($f90filepath) && "$f90filepath" ne "" ){
      if($prot){
	print STDERR "$g_level# $sourcefile uses $module which "
	  ."is in $f90filepath\n" ;
      }
      @modfiles=(@modfiles,$f90filepath);
      make_dependenices($f90filepath);
      next MODULE;	    
    }
    
    print STDERR "Couldn't find source file for module $module\n";
  }
  
  # name of file we want to make
  $objfile=$sourcefile;
  # replace source file name with .o
  $objfile=~s/\.$f90ext/\.o/;
  # strip path so object files go in current dir
  $objfile=~s|.*/||;

  if ( defined $globjhash{$objfile} ){  
    if($prot){
      print STDERR "$g_level# obj $objfile already in list\n" ;
    }
  }else{
    $globjhash{$objfile}=1;
    push(@global_objlist,"$objfile");	      	      
    if($prot){
      print STDERR "$g_level# on update HASH:@global_objlist\n";
    }
  }
  if($prot){
    print STDERR "$g_level# on exit HASH:@global_objlist\n";
  }
  
  $incs="";
  if( defined $hash_incs{$sourcefile}){
    $incs.=" @{$hash_incs{$sourcefile}}";
  }
  
  # list of dependencies
  if (! defined $objhash{$objfile} ){
    $objhash{$objfile}=1;
    @objlist=();
    foreach  $mf (@modfiles) { 
      $obj=$mf;
      # replace source file name with .o
      $obj=~s/\.$f90ext/\.o/;
      # strip path so object files go in current dir
      $obj=~s|.*/||;
      @objlist=(@objlist,$obj);
    }
    my $objstr="";
    my $ii=0;
  wloop: while(1){
      if($ii<=$#objlist){
	$objstr.="\\\n\t";
      }
      for (my $n=0;$n<=3;$n++) {
	if($ii>$#objlist) {last wloop; }
	$objstr.="$objlist[$ii] ";
	$ii++;
      }
    }

    @global_out_dep=(@global_out_dep
		     ,"\n$objfile:$sourcefile $makefiledep $incs $objstr \n");
    
    # observe special flags
    $mf=$sourcefile;
    $mf=~s|.*/||;
    $spc=0;
    foreach $sp(@specialflagfiles){
      if($prot){
	print STDERR "$g_level SP=$sp $mf\n";
      }
      if( "$mf" eq "$sp" ){
	$spc=1;
	if($prot){
	  print STDERR "$g_level FOUNDSPC=$mf $spc\n";
	}
	last;
      }
    }
    if($prot){
      print STDERR "$g_level SPC=$sourcefile $spc\n";
    }
    
    if($spc){
      push @global_out_dep,"\t \$(F90) \$(FULLSPECIALF90FLAGS) -c $sourcefile -o $objfile \n";
    }else{
      push @global_out_dep,"\t \$(F90) \$(FULLF90FLAGS) -c $sourcefile -o $objfile \n";
    }
  }  
  $g_level=~s/\s\s\s$//;  
}








########################################################################
# make tables of used modules and modules contained in files 
########################################################################

sub maketables{
  
  foreach $directory (@modules_path){
    opendir( DIR, $directory) or 
      die "Can't open directory $directory : $! \n";
    @f90files=grep /\.$f90ext\Z/, readdir(DIR);
    foreach $f90file (@f90files){
      $f90filepath="$directory/$f90file";
      open( FHI, "$f90filepath") or 
	die "Can't find source file $f90filepath: $! \n";
      while ($line=<FHI>){
	if ($line =~ /^ *module (\w+)/i ){
	  $hash_modules{lc($1)}="$f90filepath";
	}elsif ($line =~ /^[ \t]*include\s+[\'\"](.+)[\'\"]/i ) { 
	  #print "$1\n";
	  if ($1 ne "mpif.h") {
	    push @{$hash_incs{$f90filepath}},$1;
	  }
	}elsif ($line =~ /^[ \t]*use\s+(\w+)/i ) { 
	  if ($1 ne "mpi") {
	      
	  
	      if($prot){
		  print STDERR "$g_level# $f90filepath Uses Module $1\n" ;
	      }
	      if(!defined $hash_uses{$f90filepath}){
		  $hash_uses{$f90filepath}=[];
	      }
	      if(lc($1) ne "iso_c_binding"){
		  push @{$hash_uses{$f90filepath}},$1;
	      }
	  }
	}
      }
      close( FHI );
    }
  }

}
