Module atomdata
  !!
  Use precisiondefs
  Use constants
  Use errors
  Use file_iounits
  Use tmesh
  Use trelativistic
  Use mesh
  Use memory
  Use atomdefs
  !!
  Implicit None 
  !!
  Private
  !!
  Public :: getatpotfit
  !!
  Character(*),Parameter::nmodule="ATOMDATA"  
  !!***********************************************************************
  !! define a rough atom potential as initial potential
  Integer(t_int),Parameter :: nmax=50
  Integer(t_int) :: ncoeffrel (0:MAX_ELEMENT)
  Integer(t_int) :: ncoefnrel (0:MAX_ELEMENT)
  Real(t_real)   :: vcoeffrel (0:nmax,0:MAX_ELEMENT)
  Real(t_real)   :: vscoeffrel (0:nmax,0:MAX_ELEMENT)
  Real(t_real)   :: bscoeffrel (0:nmax,0:MAX_ELEMENT)
  !!
  Real(t_real)   :: vcoefnrel (1:nmax,0:MAX_ELEMENT)
  Real(t_real)   :: vscoefnrel (1:nmax,0:MAX_ELEMENT)
  Real(t_real)   :: bscoefnrel (1:nmax,0:MAX_ELEMENT)
  !!
  Data ncoefnrel(  0) / 50 /
  Data vcoefnrel(1:50,  0) /&
       &     0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real/
  !!
  !!1s
  !!
  Data ncoefnrel(  1) / 50 /
  Data vcoefnrel(1:50,  1) /&
       &     -1.000000_t_real,    -0.999964_t_real,    -0.999709_t_real &
       &,    -0.999011_t_real,    -0.997626_t_real,    -0.995270_t_real &
       &,    -0.991598_t_real,    -0.986181_t_real,    -0.978501_t_real &
       &,    -0.967968_t_real,    -0.953962_t_real,    -0.935912_t_real &
       &,    -0.913396_t_real,    -0.886248_t_real,    -0.854645_t_real &
       &,    -0.819142_t_real,    -0.780638_t_real,    -0.740277_t_real &
       &,    -0.699275_t_real,    -0.658739_t_real,    -0.619492_t_real &
       &,    -0.581964_t_real,    -0.546165_t_real,    -0.511747_t_real &
       &,    -0.478125_t_real,    -0.444645_t_real,    -0.410744_t_real &
       &,    -0.376076_t_real,    -0.340582_t_real,    -0.304501_t_real &
       &,    -0.268327_t_real,    -0.232729_t_real,    -0.198451_t_real &
       &,    -0.166212_t_real,    -0.136630_t_real,    -0.110160_t_real &
       &,    -0.087067_t_real,    -0.067427_t_real,    -0.051142_t_real &
       &,    -0.037978_t_real,    -0.027604_t_real,    -0.019632_t_real &
       &,    -0.013659_t_real,    -0.009294_t_real,    -0.006184_t_real &
       &,    -0.004023_t_real,    -0.002558_t_real,    -0.001589_t_real &
       &,    -0.000964_t_real,    -0.000572_t_real/
  !!
  Data ncoefnrel(  2) / 50 /
  Data vcoefnrel(1:50,  2) /&
       &     -2.000000_t_real,    -1.999707_t_real,    -1.997653_t_real &
       &,    -1.992050_t_real,    -1.981024_t_real,    -1.962550_t_real &
       &,    -1.934400_t_real,    -1.894201_t_real,    -1.839649_t_real &
       &,    -1.768910_t_real,    -1.681170_t_real,    -1.577175_t_real &
       &,    -1.459560_t_real,    -1.332763_t_real,    -1.202461_t_real &
       &,    -1.074636_t_real,    -0.954533_t_real,    -0.845816_t_real &
       &,    -0.750152_t_real,    -0.667285_t_real,    -0.595508_t_real &
       &,    -0.532353_t_real,    -0.475266_t_real,    -0.422131_t_real &
       &,    -0.371548_t_real,    -0.322883_t_real,    -0.276154_t_real &
       &,    -0.231830_t_real,    -0.190605_t_real,    -0.153196_t_real &
       &,    -0.120182_t_real,    -0.091907_t_real,    -0.068436_t_real &
       &,    -0.049570_t_real,    -0.034898_t_real,    -0.023862_t_real &
       &,    -0.015839_t_real,    -0.010200_t_real,    -0.006371_t_real &
       &,    -0.003858_t_real,    -0.002264_t_real,    -0.001288_t_real &
       &,    -0.000709_t_real,    -0.000378_t_real,    -0.000195_t_real &
       &,    -0.000097_t_real,    -0.000047_t_real,    -0.000022_t_real &
       &,    -0.000010_t_real,    -0.000004_t_real/
  !!2s
  Data ncoefnrel(  3) / 50 /
  Data vcoefnrel(1:50,  3) /&
       &     -3.000000_t_real,    -2.999458_t_real,    -2.995659_t_real &
       &,    -2.985280_t_real,    -2.964818_t_real,    -2.930459_t_real &
       &,    -2.878113_t_real,    -2.803780_t_real,    -2.704381_t_real &
       &,    -2.578932_t_real,    -2.429649_t_real,    -2.262355_t_real &
       &,    -2.085719_t_real,    -1.909348_t_real,    -1.741389_t_real &
       &,    -1.586609_t_real,    -1.445776_t_real,    -1.316553_t_real &
       &,    -1.195622_t_real,    -1.081495_t_real,    -0.977452_t_real &
       &,    -0.892238_t_real,    -0.832680_t_real,    -0.793917_t_real &
       &,    -0.765097_t_real,    -0.738829_t_real,    -0.712032_t_real &
       &,    -0.683809_t_real,    -0.654003_t_real,    -0.622559_t_real &
       &,    -0.589333_t_real,    -0.554119_t_real,    -0.516748_t_real &
       &,    -0.477217_t_real,    -0.435763_t_real,    -0.392898_t_real &
       &,    -0.349370_t_real,    -0.306092_t_real,    -0.264030_t_real &
       &,    -0.224104_t_real,    -0.187099_t_real,    -0.153600_t_real &
       &,    -0.123975_t_real,    -0.098363_t_real,    -0.076710_t_real &
       &,    -0.058799_t_real,    -0.044294_t_real,    -0.032793_t_real &
       &,    -0.023858_t_real,    -0.017056_t_real/

  !!
  Data ncoefnrel(  4) / 50 /
  Data vcoefnrel(1:50,  4) /&
       &     -4.000000_t_real,    -3.999148_t_real,    -3.993170_t_real &
       &,    -3.976828_t_real,    -3.944569_t_real,    -3.890380_t_real &
       &,    -3.808058_t_real,    -3.692230_t_real,    -3.540177_t_real &
       &,    -3.353827_t_real,    -3.140711_t_real,    -2.912759_t_real &
       &,    -2.682884_t_real,    -2.460797_t_real,    -2.250265_t_real &
       &,    -2.049546_t_real,    -1.855438_t_real,    -1.670080_t_real &
       &,    -1.506019_t_real,    -1.375181_t_real,    -1.269954_t_real &
       &,    -1.175215_t_real,    -1.083793_t_real,    -0.995072_t_real &
       &,    -0.910576_t_real,    -0.831606_t_real,    -0.758461_t_real &
       &,    -0.690474_t_real,    -0.626428_t_real,    -0.565047_t_real &
       &,    -0.505377_t_real,    -0.446999_t_real,    -0.390053_t_real &
       &,    -0.335123_t_real,    -0.283053_t_real,    -0.234743_t_real &
       &,    -0.190980_t_real,    -0.152319_t_real,    -0.119032_t_real &
       &,    -0.091104_t_real,    -0.068270_t_real,    -0.050075_t_real &
       &,    -0.035944_t_real,    -0.025243_t_real,    -0.017343_t_real &
       &,    -0.011655_t_real,    -0.007660_t_real,    -0.004923_t_real &
       &,    -0.003094_t_real,    -0.001900_t_real/

  !! 2p  
  !!
  Data ncoefnrel(  5) / 50 /
  Data vcoefnrel(1:50,  5) /&
       &     -5.000000_t_real,    -4.998793_t_real,    -4.990318_t_real &
       &,    -4.967136_t_real,    -4.921337_t_real,    -4.844437_t_real &
       &,    -4.728083_t_real,    -4.566054_t_real,    -4.357244_t_real &
       &,    -4.108013_t_real,    -3.831726_t_real,    -3.544562_t_real &
       &,    -3.259338_t_real,    -2.981260_t_real,    -2.709086_t_real &
       &,    -2.442649_t_real,    -2.192532_t_real,    -1.974659_t_real &
       &,    -1.786085_t_real,    -1.611479_t_real,    -1.444022_t_real &
       &,    -1.285337_t_real,    -1.139363_t_real,    -1.008890_t_real &
       &,    -0.894527_t_real,    -0.794990_t_real,    -0.707911_t_real &
       &,    -0.630659_t_real,    -0.560935_t_real,    -0.497057_t_real &
       &,    -0.437987_t_real,    -0.383204_t_real,    -0.332522_t_real &
       &,    -0.285918_t_real,    -0.243414_t_real,    -0.205012_t_real &
       &,    -0.170674_t_real,    -0.140318_t_real,    -0.113819_t_real &
       &,    -0.091010_t_real,    -0.071680_t_real,    -0.055569_t_real &
       &,    -0.042380_t_real,    -0.031781_t_real,    -0.023425_t_real &
       &,    -0.016967_t_real,    -0.012072_t_real,    -0.008436_t_real &
       &,    -0.005788_t_real,    -0.003899_t_real/
  !!
  Data ncoefnrel(  6) / 50 /
  Data vcoefnrel(1:50,  6) /&
       &     -6.000000_t_real,    -5.998380_t_real,    -5.987011_t_real &
       &,    -5.955894_t_real,    -5.894394_t_real,    -5.791253_t_real &
       &,    -5.635952_t_real,    -5.421993_t_real,    -5.150973_t_real &
       &,    -4.834457_t_real,    -4.490797_t_real,    -4.137465_t_real &
       &,    -3.783957_t_real,    -3.431651_t_real,    -3.083220_t_real &
       &,    -2.753446_t_real,    -2.456498_t_real,    -2.184268_t_real &
       &,    -1.925140_t_real,    -1.679420_t_real,    -1.453703_t_real &
       &,    -1.253971_t_real,    -1.082688_t_real,    -0.938685_t_real &
       &,    -0.818336_t_real,    -0.717001_t_real,    -0.630163_t_real &
       &,    -0.554088_t_real,    -0.486037_t_real,    -0.424207_t_real &
       &,    -0.367527_t_real,    -0.315448_t_real,    -0.267749_t_real &
       &,    -0.224397_t_real,    -0.185437_t_real,    -0.150915_t_real &
       &,    -0.120826_t_real,    -0.095077_t_real,    -0.073474_t_real &
       &,    -0.055725_t_real,    -0.041457_t_real,    -0.030240_t_real &
       &,    -0.021619_t_real,    -0.015144_t_real,    -0.010391_t_real &
       &,    -0.006983_t_real,    -0.004595_t_real,    -0.002959_t_real &
       &,    -0.001865_t_real,    -0.001151_t_real/
  !!
  Data ncoefnrel(  7) / 50 /
  Data vcoefnrel(1:50,  7) /&
       &     -7.000000_t_real,    -6.997912_t_real,    -6.983254_t_real &
       &,    -6.943123_t_real,    -6.863802_t_real,    -6.730986_t_real &
       &,    -6.532057_t_real,    -6.260846_t_real,    -5.922510_t_real &
       &,    -5.533888_t_real,    -5.116645_t_real,    -4.686978_t_real &
       &,    -4.251084_t_real,    -3.813303_t_real,    -3.389571_t_real &
       &,    -2.996168_t_real,    -2.627074_t_real,    -2.274311_t_real &
       &,    -1.943232_t_real,    -1.644668_t_real,    -1.386612_t_real &
       &,    -1.171222_t_real,    -0.995417_t_real,    -0.852961_t_real &
       &,    -0.736615_t_real,    -0.639668_t_real,    -0.556716_t_real &
       &,    -0.483847_t_real,    -0.418485_t_real,    -0.359099_t_real &
       &,    -0.304899_t_real,    -0.255578_t_real,    -0.211097_t_real &
       &,    -0.171527_t_real,    -0.136925_t_real,    -0.107259_t_real &
       &,    -0.082371_t_real,    -0.061967_t_real,    -0.045636_t_real &
       &,    -0.032884_t_real,    -0.023174_t_real,    -0.015966_t_real &
       &,    -0.010751_t_real,    -0.007074_t_real,    -0.004546_t_real &
       &,    -0.002854_t_real,    -0.001749_t_real,    -0.001046_t_real &
       &,    -0.000611_t_real,    -0.000348_t_real/
  !!
  Data ncoefnrel(  8) / 50 /
  Data vcoefnrel(1:50,  8) /&
       &     -8.000000_t_real,    -7.997389_t_real,    -7.979052_t_real &
       &,    -7.928836_t_real,    -7.829598_t_real,    -7.663745_t_real &
       &,    -7.416680_t_real,    -7.083157_t_real,    -6.672461_t_real &
       &,    -6.206205_t_real,    -5.707507_t_real,    -5.190257_t_real &
       &,    -4.661204_t_real,    -4.135300_t_real,    -3.633799_t_real &
       &,    -3.157489_t_real,    -2.700834_t_real,    -2.272867_t_real &
       &,    -1.889285_t_real,    -1.561443_t_real,    -1.292241_t_real &
       &,    -1.077118_t_real,    -0.907134_t_real,    -0.772068_t_real &
       &,    -0.662541_t_real,    -0.571064_t_real,    -0.492242_t_real &
       &,    -0.422527_t_real,    -0.359809_t_real,    -0.302985_t_real &
       &,    -0.251609_t_real,    -0.205594_t_real,    -0.164997_t_real &
       &,    -0.129856_t_real,    -0.100097_t_real,    -0.075494_t_real &
       &,    -0.055661_t_real,    -0.040091_t_real,    -0.028193_t_real &
       &,    -0.019348_t_real,    -0.012953_t_real,    -0.008456_t_real &
       &,    -0.005382_t_real,    -0.003339_t_real,    -0.002018_t_real &
       &,    -0.001188_t_real,    -0.000681_t_real,    -0.000380_t_real &
       &,    -0.000207_t_real,    -0.000109_t_real/
  !!
  Data ncoefnrel(  9) / 50 /
  Data vcoefnrel(1:50,  9) /&
       &     -9.000000_t_real,    -8.996810_t_real,    -8.974407_t_real &
       &,    -8.913043_t_real,    -8.791808_t_real,    -8.589615_t_real &
       &,    -8.290041_t_real,    -7.889303_t_real,    -7.401103_t_real &
       &,    -6.850946_t_real,    -6.261946_t_real,    -5.646794_t_real &
       &,    -5.018633_t_real,    -4.402139_t_real,    -3.809589_t_real &
       &,    -3.238324_t_real,    -2.699218_t_real,    -2.213686_t_real &
       &,    -1.798822_t_real,    -1.460419_t_real,    -1.193602_t_real &
       &,    -0.986935_t_real,    -0.826800_t_real,    -0.700501_t_real &
       &,    -0.597805_t_real,    -0.511305_t_real,    -0.436102_t_real &
       &,    -0.369246_t_real,    -0.309160_t_real,    -0.255150_t_real &
       &,    -0.207021_t_real,    -0.164785_t_real,    -0.128456_t_real &
       &,    -0.097930_t_real,    -0.072927_t_real,    -0.052999_t_real &
       &,    -0.037558_t_real,    -0.025937_t_real,    -0.017446_t_real &
       &,    -0.011424_t_real,    -0.007281_t_real,    -0.004515_t_real &
       &,    -0.002723_t_real,    -0.001597_t_real,    -0.000911_t_real &
       &,    -0.000504_t_real,    -0.000271_t_real,    -0.000142_t_real &
       &,    -0.000072_t_real,    -0.000035_t_real/
  !!
  Data ncoefnrel( 10) / 50 /
  Data vcoefnrel(1:50, 10) /&
       &    -10.000000_t_real,    -9.996176_t_real,    -9.969319_t_real &
       &,    -9.895747_t_real,    -9.750451_t_real,    -9.508665_t_real &
       &,    -9.152315_t_real,    -8.679551_t_real,    -8.108508_t_real &
       &,    -7.467576_t_real,    -6.779242_t_real,    -6.058054_t_real &
       &,    -5.327202_t_real,    -4.611948_t_real,    -3.917037_t_real &
       &,    -3.252770_t_real,    -2.645870_t_real,    -2.122032_t_real &
       &,    -1.693412_t_real,    -1.357177_t_real,    -1.100279_t_real &
       &,    -0.905495_t_real,    -0.756041_t_real,    -0.638055_t_real &
       &,    -0.541333_t_real,    -0.459034_t_real,    -0.386967_t_real &
       &,    -0.322816_t_real,    -0.265484_t_real,    -0.214576_t_real &
       &,    -0.170023_t_real,    -0.131811_t_real,    -0.099816_t_real &
       &,    -0.073737_t_real,    -0.053079_t_real,    -0.037199_t_real &
       &,    -0.025362_t_real,    -0.016812_t_real,    -0.010831_t_real &
       &,    -0.006778_t_real,    -0.004120_t_real,    -0.002431_t_real &
       &,    -0.001392_t_real,    -0.000773_t_real,    -0.000417_t_real &
       &,    -0.000218_t_real,    -0.000110_t_real,    -0.000054_t_real &
       &,    -0.000026_t_real,    -0.000012_t_real/
  !!
  Data ncoefnrel( 11) / 50 /
  Data vcoefnrel(1:50, 11) /&
       &    -11.000000_t_real,   -10.995589_t_real,   -10.964607_t_real &
       &,   -10.879708_t_real,   -10.712075_t_real,   -10.433723_t_real &
       &,   -10.025801_t_real,    -9.489513_t_real,    -8.847993_t_real &
       &,    -8.132126_t_real,    -7.364345_t_real,    -6.564726_t_real &
       &,    -5.765244_t_real,    -4.985439_t_real,    -4.233383_t_real &
       &,    -3.535334_t_real,    -2.923940_t_real,    -2.417599_t_real &
       &,    -2.014493_t_real,    -1.698225_t_real,    -1.447384_t_real &
       &,    -1.243752_t_real,    -1.077081_t_real,    -0.945527_t_real &
       &,    -0.850020_t_real,    -0.785431_t_real,    -0.740333_t_real &
       &,    -0.704382_t_real,    -0.671564_t_real,    -0.639021_t_real &
       &,    -0.605429_t_real,    -0.570109_t_real,    -0.532696_t_real &
       &,    -0.493083_t_real,    -0.451434_t_real,    -0.408206_t_real &
       &,    -0.364113_t_real,    -0.320056_t_real,    -0.277016_t_real &
       &,    -0.235951_t_real,    -0.197693_t_real,    -0.162888_t_real &
       &,    -0.131956_t_real,    -0.105088_t_real,    -0.082266_t_real &
       &,    -0.063300_t_real,    -0.047873_t_real,    -0.035584_t_real &
       &,    -0.025994_t_real,    -0.018661_t_real/
  !!
  Data ncoefnrel( 12) / 50 /
  Data vcoefnrel(1:50, 12) /&
       &    -12.000000_t_real,   -11.994973_t_real,   -11.959658_t_real &
       &,   -11.862860_t_real,   -11.671791_t_real,   -11.355267_t_real &
       &,   -10.894063_t_real,   -10.292958_t_real,    -9.579888_t_real &
       &,    -8.787410_t_real,    -7.938906_t_real,    -7.062708_t_real &
       &,    -6.194399_t_real,    -5.348659_t_real,    -4.545517_t_real &
       &,    -3.822377_t_real,    -3.207880_t_real,    -2.706130_t_real &
       &,    -2.300531_t_real,    -1.967581_t_real,    -1.690626_t_real &
       &,    -1.466007_t_real,    -1.294457_t_real,    -1.165754_t_real &
       &,    -1.062512_t_real,    -0.972700_t_real,    -0.891084_t_real &
       &,    -0.815655_t_real,    -0.745209_t_real,    -0.678532_t_real &
       &,    -0.614408_t_real,    -0.551883_t_real,    -0.490486_t_real &
       &,    -0.430302_t_real,    -0.371897_t_real,    -0.316148_t_real &
       &,    -0.264032_t_real,    -0.216440_t_real,    -0.174042_t_real &
       &,    -0.137215_t_real,    -0.106030_t_real,    -0.080282_t_real &
       &,    -0.059549_t_real,    -0.043265_t_real,    -0.030784_t_real &
       &,    -0.021450_t_real,    -0.014634_t_real,    -0.009775_t_real &
       &,    -0.006391_t_real,    -0.004091_t_real/
  !!3p
  !!
  Data ncoefnrel( 13) / 50 /
  Data vcoefnrel(1:50, 13) /&
       &    -13.000000_t_real,   -12.994344_t_real,   -12.954607_t_real &
       &,   -12.845660_t_real,   -12.630687_t_real,   -12.275437_t_real &
       &,   -11.760775_t_real,   -11.095490_t_real,   -10.311995_t_real &
       &,    -9.444071_t_real,    -8.518026_t_real,    -7.571323_t_real &
       &,    -6.637914_t_real,    -5.734070_t_real,    -4.894082_t_real &
       &,    -4.158170_t_real,    -3.542921_t_real,    -3.036096_t_real &
       &,    -2.612082_t_real,    -2.252535_t_real,    -1.956218_t_real &
       &,    -1.723155_t_real,    -1.535804_t_real,    -1.373949_t_real &
       &,    -1.228325_t_real,    -1.096957_t_real,    -0.979711_t_real &
       &,    -0.875961_t_real,    -0.784251_t_real,    -0.702677_t_real &
       &,    -0.629334_t_real,    -0.562600_t_real,    -0.501236_t_real &
       &,    -0.444364_t_real,    -0.391413_t_real,    -0.342050_t_real &
       &,    -0.296130_t_real,    -0.253650_t_real,    -0.214696_t_real &
       &,    -0.179390_t_real,    -0.147835_t_real,    -0.120077_t_real &
       &,    -0.096074_t_real,    -0.075689_t_real,    -0.058695_t_real &
       &,    -0.044793_t_real,    -0.033633_t_real,    -0.024843_t_real &
       &,    -0.018050_t_real,    -0.012898_t_real/
  !!
  Data ncoefnrel( 14) / 50 /
  Data vcoefnrel(1:50, 14) /&
       &    -14.000000_t_real,   -13.993688_t_real,   -13.949338_t_real &
       &,   -13.827716_t_real,   -13.587840_t_real,   -13.192452_t_real &
       &,   -12.622877_t_real,   -11.892171_t_real,   -11.036737_t_real &
       &,   -10.091444_t_real,    -9.087668_t_real,    -8.070354_t_real &
       &,    -7.069770_t_real,    -6.110474_t_real,    -5.237541_t_real &
       &,    -4.485333_t_real,    -3.853887_t_real,    -3.318473_t_real &
       &,    -2.856764_t_real,    -2.467587_t_real,    -2.152456_t_real &
       &,    -1.889837_t_real,    -1.657544_t_real,    -1.448538_t_real &
       &,    -1.263371_t_real,    -1.102890_t_real,    -0.965885_t_real &
       &,    -0.849330_t_real,    -0.749367_t_real,    -0.662192_t_real &
       &,    -0.584598_t_real,    -0.514192_t_real,    -0.449391_t_real &
       &,    -0.389311_t_real,    -0.333594_t_real,    -0.282239_t_real &
       &,    -0.235428_t_real,    -0.193388_t_real,    -0.156287_t_real &
       &,    -0.124172_t_real,    -0.096934_t_real,    -0.074316_t_real &
       &,    -0.055936_t_real,    -0.041321_t_real,    -0.029953_t_real &
       &,    -0.021301_t_real,    -0.014859_t_real,    -0.010166_t_real &
       &,    -0.006820_t_real,    -0.004486_t_real/
  !!
  Data ncoefnrel( 15) / 50 /
  Data vcoefnrel(1:50, 15) /&
       &    -15.000000_t_real,   -14.993006_t_real,   -14.943856_t_real &
       &,   -14.809047_t_real,   -14.543301_t_real,   -14.106429_t_real &
       &,   -13.480568_t_real,   -12.683196_t_real,   -11.754206_t_real &
       &,   -10.729855_t_real,    -9.648438_t_real,    -8.559234_t_real &
       &,    -7.490535_t_real,    -6.478833_t_real,    -5.573444_t_real &
       &,    -4.795956_t_real,    -4.130196_t_real,    -3.549061_t_real &
       &,    -3.046998_t_real,    -2.630145_t_real,    -2.277467_t_real &
       &,    -1.963390_t_real,    -1.681722_t_real,    -1.435452_t_real &
       &,    -1.226502_t_real,    -1.052873_t_real,    -0.909520_t_real &
       &,    -0.790159_t_real,    -0.688756_t_real,    -0.600368_t_real &
       &,    -0.521426_t_real,    -0.449671_t_real,    -0.383894_t_real &
       &,    -0.323633_t_real,    -0.268870_t_real,    -0.219781_t_real &
       &,    -0.176546_t_real,    -0.139227_t_real,    -0.107709_t_real &
       &,    -0.081692_t_real,    -0.060715_t_real,    -0.044200_t_real &
       &,    -0.031510_t_real,    -0.021991_t_real,    -0.015022_t_real &
       &,    -0.010042_t_real,    -0.006568_t_real,    -0.004202_t_real &
       &,    -0.002630_t_real,    -0.001609_t_real/
  !!
  Data ncoefnrel( 16) / 50 /
  Data vcoefnrel(1:50, 16) /&
       &    -16.000000_t_real,   -15.992298_t_real,   -15.938163_t_real &
       &,   -15.789661_t_real,   -15.497096_t_real,   -15.017431_t_real &
       &,   -14.333953_t_real,   -13.468619_t_real,   -12.464348_t_real &
       &,   -11.359492_t_real,   -10.200328_t_real,    -9.037265_t_real &
       &,    -7.900585_t_real,    -6.838524_t_real,    -5.897255_t_real &
       &,    -5.081775_t_real,    -4.365514_t_real,    -3.732868_t_real &
       &,    -3.193750_t_real,    -2.735060_t_real,    -2.326401_t_real &
       &,    -1.959823_t_real,    -1.641003_t_real,    -1.373952_t_real &
       &,    -1.156433_t_real,    -0.981335_t_real,    -0.839544_t_real &
       &,    -0.722293_t_real,    -0.622456_t_real,    -0.534946_t_real &
       &,    -0.456561_t_real,    -0.385574_t_real,    -0.321261_t_real &
       &,    -0.263478_t_real,    -0.212319_t_real,    -0.167875_t_real &
       &,    -0.130097_t_real,    -0.098732_t_real,    -0.073326_t_real &
       &,    -0.053263_t_real,    -0.037825_t_real,    -0.026251_t_real &
       &,    -0.017800_t_real,    -0.011790_t_real,    -0.007626_t_real &
       &,    -0.004816_t_real,    -0.002969_t_real,    -0.001787_t_real &
       &,    -0.001049_t_real,    -0.000601_t_real/
  !!
  Data ncoefnrel( 17) / 50 /
  Data vcoefnrel(1:50, 17) /&
       &    -17.000000_t_real,   -16.991564_t_real,   -16.932261_t_real &
       &,   -16.769564_t_real,   -16.449242_t_real,   -15.925506_t_real &
       &,   -15.183094_t_real,   -14.248430_t_real,   -13.167081_t_real &
       &,   -11.980503_t_real,   -10.742978_t_real,    -9.504011_t_real &
       &,    -8.300062_t_real,    -7.187828_t_real,    -6.203721_t_real &
       &,    -5.336344_t_real,    -4.559601_t_real,    -3.877896_t_real &
       &,    -3.294219_t_real,    -2.776452_t_real,    -2.310158_t_real &
       &,    -1.903255_t_real,    -1.563687_t_real,    -1.290508_t_real &
       &,    -1.075042_t_real,    -0.905066_t_real,    -0.768435_t_real &
       &,    -0.655149_t_real,    -0.558018_t_real,    -0.472467_t_real &
       &,    -0.395952_t_real,    -0.327305_t_real,    -0.266146_t_real &
       &,    -0.212442_t_real,    -0.166195_t_real,    -0.127264_t_real &
       &,    -0.095297_t_real,    -0.069724_t_real,    -0.049813_t_real &
       &,    -0.034733_t_real,    -0.023626_t_real,    -0.015673_t_real &
       &,    -0.010137_t_real,    -0.006391_t_real,    -0.003927_t_real &
       &,    -0.002351_t_real,    -0.001371_t_real,    -0.000779_t_real &
       &,    -0.000431_t_real,    -0.000232_t_real/
  !!
  Data ncoefnrel( 18) / 50 /
  Data vcoefnrel(1:50, 18) /&
       &    -18.000000_t_real,   -17.990803_t_real,   -17.926151_t_real &
       &,   -17.748758_t_real,   -17.399751_t_real,   -16.830685_t_real &
       &,   -16.028032_t_real,   -15.022596_t_real,   -13.862340_t_real &
       &,   -12.592992_t_real,   -11.275903_t_real,    -9.959308_t_real &
       &,    -8.688772_t_real,    -7.524298_t_real,    -6.487834_t_real &
       &,    -5.556306_t_real,    -4.716822_t_real,    -3.985542_t_real &
       &,    -3.341999_t_real,    -2.760048_t_real,    -2.246488_t_real &
       &,    -1.815274_t_real,    -1.469562_t_real,    -1.200628_t_real &
       &,    -0.993274_t_real,    -0.831316_t_real,    -0.700962_t_real &
       &,    -0.592080_t_real,    -0.498082_t_real,    -0.415180_t_real &
       &,    -0.341493_t_real,    -0.276270_t_real,    -0.219287_t_real &
       &,    -0.170452_t_real,    -0.129556_t_real,    -0.096178_t_real &
       &,    -0.069671_t_real,    -0.049210_t_real,    -0.033870_t_real &
       &,    -0.022706_t_real,    -0.014821_t_real,    -0.009416_t_real &
       &,    -0.005821_t_real,    -0.003501_t_real,    -0.002048_t_real &
       &,    -0.001165_t_real,    -0.000644_t_real,    -0.000346_t_real &
       &,    -0.000181_t_real,    -0.000092_t_real/
  !!4s
  !!
  Data ncoefnrel( 19) / 50 /
  Data vcoefnrel(1:50, 19) /&
       &    -19.000000_t_real,   -18.990073_t_real,   -18.920279_t_real &
       &,   -18.728755_t_real,   -18.352211_t_real,   -17.740007_t_real &
       &,   -16.880962_t_real,   -15.810495_t_real,   -14.579120_t_real &
       &,   -13.238130_t_real,   -11.854671_t_real,   -10.477046_t_real &
       &,    -9.161043_t_real,    -7.964535_t_real,    -6.893451_t_real &
       &,    -5.922173_t_real,    -5.057847_t_real,    -4.306398_t_real &
       &,    -3.632714_t_real,    -3.030227_t_real,    -2.514242_t_real &
       &,    -2.091161_t_real,    -1.752184_t_real,    -1.480538_t_real &
       &,    -1.260483_t_real,    -1.082834_t_real,    -0.945172_t_real &
       &,    -0.846160_t_real,    -0.778716_t_real,    -0.731034_t_real &
       &,    -0.692729_t_real,    -0.657425_t_real,    -0.621849_t_real &
       &,    -0.584453_t_real,    -0.544602_t_real,    -0.502211_t_real &
       &,    -0.457613_t_real,    -0.411476_t_real,    -0.364720_t_real &
       &,    -0.318408_t_real,    -0.273623_t_real,    -0.231356_t_real &
       &,    -0.192421_t_real,    -0.157396_t_real,    -0.126611_t_real &
       &,    -0.100153_t_real,    -0.077907_t_real,    -0.059594_t_real &
       &,    -0.044828_t_real,    -0.033160_t_real/
  !!
  Data ncoefnrel( 20) / 50 /
  Data vcoefnrel(1:50, 20) /&
       &    -20.000000_t_real,   -19.989326_t_real,   -19.914271_t_real &
       &,   -19.708286_t_real,   -19.303622_t_real,   -18.647611_t_real &
       &,   -17.731716_t_real,   -16.595851_t_real,   -15.293092_t_real &
       &,   -13.881203_t_real,   -12.431403_t_real,   -10.994009_t_real &
       &,    -9.634054_t_real,    -8.401937_t_real,    -7.288900_t_real &
       &,    -6.277539_t_real,    -5.388721_t_real,    -4.604395_t_real &
       &,    -3.895582_t_real,    -3.272154_t_real,    -2.746183_t_real &
       &,    -2.312559_t_real,    -1.955678_t_real,    -1.662577_t_real &
       &,    -1.429205_t_real,    -1.253430_t_real,    -1.123813_t_real &
       &,    -1.022999_t_real,    -0.937777_t_real,    -0.861100_t_real &
       &,    -0.789496_t_real,    -0.720979_t_real,    -0.654215_t_real &
       &,    -0.588385_t_real,    -0.523230_t_real,    -0.459063_t_real &
       &,    -0.396663_t_real,    -0.337083_t_real,    -0.281433_t_real &
       &,    -0.230690_t_real,    -0.185561_t_real,    -0.146423_t_real &
       &,    -0.113319_t_real,    -0.086001_t_real,    -0.063998_t_real &
       &,    -0.046695_t_real,    -0.033403_t_real,    -0.023426_t_real &
       &,    -0.016105_t_real,    -0.010854_t_real/
  !!3d
  !!
  Data ncoefnrel( 21) / 50 /
  Data vcoefnrel(1:50, 21) /&
       &    -21.000000_t_real,   -20.988535_t_real,   -20.907902_t_real &
       &,   -20.686598_t_real,   -20.252199_t_real,   -19.549988_t_real &
       &,   -18.574092_t_real,   -17.368486_t_real,   -15.988621_t_real &
       &,   -14.498867_t_real,   -12.972433_t_real,   -11.463331_t_real &
       &,   -10.043070_t_real,    -8.751276_t_real,    -7.570570_t_real &
       &,    -6.499607_t_real,    -5.555969_t_real,    -4.706626_t_real &
       &,    -3.943418_t_real,    -3.285878_t_real,    -2.740464_t_real &
       &,    -2.294943_t_real,    -1.931921_t_real,    -1.640345_t_real &
       &,    -1.414474_t_real,    -1.243997_t_real,    -1.112299_t_real &
       &,    -1.004524_t_real,    -0.911499_t_real,    -0.828149_t_real &
       &,    -0.751342_t_real,    -0.678846_t_real,    -0.609085_t_real &
       &,    -0.541180_t_real,    -0.474957_t_real,    -0.410849_t_real &
       &,    -0.349698_t_real,    -0.292509_t_real,    -0.240232_t_real &
       &,    -0.193595_t_real,    -0.153018_t_real,    -0.118590_t_real &
       &,    -0.090098_t_real,    -0.067095_t_real,    -0.048969_t_real &
       &,    -0.035025_t_real,    -0.024549_t_real,    -0.016861_t_real &
       &,    -0.011348_t_real,    -0.007483_t_real/
  !!
  Data ncoefnrel( 22) / 50 /
  Data vcoefnrel(1:50, 22) /&
       &    -22.000000_t_real,   -21.987716_t_real,   -21.901320_t_real &
       &,   -21.664189_t_real,   -21.199124_t_real,   -20.449463_t_real &
       &,   -19.412127_t_real,   -18.134861_t_real,   -16.675617_t_real &
       &,   -15.105442_t_real,   -13.498270_t_real,   -11.913607_t_real &
       &,   -10.426389_t_real,    -9.064120_t_real,    -7.808302_t_real &
       &,    -6.673973_t_real,    -5.663223_t_real,    -4.745912_t_real &
       &,    -3.934928_t_real,    -3.251434_t_real,    -2.693736_t_real &
       &,    -2.243453_t_real,    -1.881790_t_real,    -1.596938_t_real &
       &,    -1.378615_t_real,    -1.211555_t_real,    -1.079127_t_real &
       &,    -0.969094_t_real,    -0.874026_t_real,    -0.789294_t_real &
       &,    -0.711632_t_real,    -0.638629_t_real,    -0.568682_t_real &
       &,    -0.501013_t_real,    -0.435597_t_real,    -0.372980_t_real &
       &,    -0.314030_t_real,    -0.259681_t_real,    -0.210735_t_real &
       &,    -0.167729_t_real,    -0.130881_t_real,    -0.100094_t_real &
       &,    -0.075009_t_real,    -0.055069_t_real,    -0.039605_t_real &
       &,    -0.027899_t_real,    -0.019248_t_real,    -0.013004_t_real &
       &,    -0.008604_t_real,    -0.005574_t_real/
  !!
  Data ncoefnrel( 23) / 50 /
  Data vcoefnrel(1:50, 23) /&
       &    -23.000000_t_real,   -22.986873_t_real,   -22.894539_t_real &
       &,   -22.641107_t_real,   -22.144519_t_real,   -21.346278_t_real &
       &,   -20.246208_t_real,   -18.895542_t_real,   -17.354965_t_real &
       &,   -15.701974_t_real,   -14.010555_t_real,   -12.347031_t_real &
       &,   -10.786585_t_real,    -9.345299_t_real,    -8.011124_t_real &
       &,    -6.808534_t_real,    -5.723381_t_real,    -4.742460_t_real &
       &,    -3.893259_t_real,    -3.192447_t_real,    -2.629159_t_real &
       &,    -2.179767_t_real,    -1.823906_t_real,    -1.547517_t_real &
       &,    -1.336157_t_real,    -1.172492_t_real,    -1.041102_t_real &
       &,    -0.931445_t_real,    -0.836841_t_real,    -0.752722_t_real &
       &,    -0.675708_t_real,    -0.603358_t_real,    -0.534160_t_real &
       &,    -0.467492_t_real,    -0.403473_t_real,    -0.342731_t_real &
       &,    -0.286125_t_real,    -0.234511_t_real,    -0.188558_t_real &
       &,    -0.148650_t_real,    -0.114856_t_real,    -0.086952_t_real &
       &,    -0.064482_t_real,    -0.046835_t_real,    -0.033312_t_real &
       &,    -0.023200_t_real,    -0.015819_t_real,    -0.010560_t_real &
       &,    -0.006900_t_real,    -0.004413_t_real/
  !!
  Data ncoefnrel( 24) / 50 /
  Data vcoefnrel(1:50, 24) /&
       &    -24.000000_t_real,   -23.985982_t_real,   -23.887373_t_real &
       &,   -23.616725_t_real,   -23.086895_t_real,   -22.237499_t_real &
       &,   -21.071139_t_real,   -19.642039_t_real,   -18.013668_t_real &
       &,   -16.269091_t_real,   -14.481907_t_real,   -12.725580_t_real &
       &,   -11.072826_t_real,    -9.531580_t_real,    -8.101531_t_real &
       &,    -6.806402_t_real,    -5.626537_t_real,    -4.572575_t_real &
       &,    -3.681264_t_real,    -2.964261_t_real,    -2.403490_t_real &
       &,    -1.969217_t_real,    -1.634504_t_real,    -1.378631_t_real &
       &,    -1.184206_t_real,    -1.035293_t_real,    -0.918388_t_real &
       &,    -0.823376_t_real,    -0.743150_t_real,    -0.672730_t_real &
       &,    -0.608597_t_real,    -0.548348_t_real,    -0.490525_t_real &
       &,    -0.434471_t_real,    -0.380170_t_real,    -0.328051_t_real &
       &,    -0.278783_t_real,    -0.233091_t_real,    -0.191606_t_real &
       &,    -0.154776_t_real,    -0.122817_t_real,    -0.095714_t_real &
       &,    -0.073248_t_real,    -0.055040_t_real,    -0.040609_t_real &
       &,    -0.029419_t_real,    -0.020928_t_real,    -0.014620_t_real &
       &,    -0.010031_t_real,    -0.006761_t_real/
  !!
  Data ncoefnrel( 25) / 50 /
  Data vcoefnrel(1:50, 25) /&
       &    -25.000000_t_real,   -24.985115_t_real,   -24.880399_t_real &
       &,   -24.592988_t_real,   -24.030879_t_real,   -23.132248_t_real &
       &,   -21.902933_t_real,   -20.400321_t_real,   -18.691532_t_real &
       &,   -16.865218_t_real,   -14.995717_t_real,   -13.164319_t_real &
       &,   -11.438762_t_real,    -9.821476_t_real,    -8.326107_t_real &
       &,    -6.968949_t_real,    -5.734097_t_real,    -4.651291_t_real &
       &,    -3.754162_t_real,    -3.040093_t_real,    -2.480547_t_real &
       &,    -2.043818_t_real,    -1.705828_t_real,    -1.447243_t_real &
       &,    -1.248857_t_real,    -1.093140_t_real,    -0.967005_t_real &
       &,    -0.861583_t_real,    -0.770684_t_real,    -0.689733_t_real &
       &,    -0.615365_t_real,    -0.545333_t_real,    -0.478441_t_real &
       &,    -0.414389_t_real,    -0.353524_t_real,    -0.296559_t_real &
       &,    -0.244303_t_real,    -0.197456_t_real,    -0.156473_t_real &
       &,    -0.121511_t_real,    -0.092435_t_real,    -0.068860_t_real &
       &,    -0.050223_t_real,    -0.035857_t_real,    -0.025056_t_real &
       &,    -0.017134_t_real,    -0.011464_t_real,    -0.007505_t_real &
       &,    -0.004806_t_real,    -0.003011_t_real/
  !!
  Data ncoefnrel( 26) / 50 /
  Data vcoefnrel(1:50, 26) /&
       &    -26.000000_t_real,   -25.984201_t_real,   -25.873043_t_real &
       &,   -25.567966_t_real,   -24.971887_t_real,   -24.021482_t_real &
       &,   -22.725649_t_real,   -21.144470_t_real,   -19.348817_t_real &
       &,   -17.431700_t_real,   -15.468640_t_real,   -13.547832_t_real &
       &,   -11.730856_t_real,   -10.020088_t_real,    -8.440972_t_real &
       &,    -7.000381_t_real,    -5.698002_t_real,    -4.578593_t_real &
       &,    -3.669752_t_real,    -2.957106_t_real,    -2.404545_t_real &
       &,    -1.977316_t_real,    -1.649448_t_real,    -1.399495_t_real &
       &,    -1.207327_t_real,    -1.055993_t_real,    -0.933234_t_real &
       &,    -0.830585_t_real,    -0.741960_t_real,    -0.662825_t_real &
       &,    -0.589911_t_real,    -0.521132_t_real,    -0.455465_t_real &
       &,    -0.392751_t_real,    -0.333425_t_real,    -0.278218_t_real &
       &,    -0.227905_t_real,    -0.183113_t_real,    -0.144211_t_real &
       &,    -0.111270_t_real,    -0.084080_t_real,    -0.062203_t_real &
       &,    -0.045043_t_real,    -0.031920_t_real,    -0.022134_t_real &
       &,    -0.015015_t_real,    -0.009964_t_real,    -0.006468_t_real &
       &,    -0.004106_t_real,    -0.002548_t_real/
  !!
  Data ncoefnrel( 27) / 50 /
  Data vcoefnrel(1:50, 27) /&
       &    -27.000000_t_real,   -26.983263_t_real,   -26.865499_t_real &
       &,   -26.542309_t_real,   -25.911464_t_real,   -24.908248_t_real &
       &,   -23.544614_t_real,   -21.883118_t_real,   -19.998718_t_real &
       &,   -17.987891_t_real,   -15.928358_t_real,   -13.914226_t_real &
       &,   -12.000581_t_real,   -10.194344_t_real,    -8.528327_t_real &
       &,    -7.003922_t_real,    -5.641807_t_real,    -4.494924_t_real &
       &,    -3.580877_t_real,    -2.873470_t_real,    -2.330075_t_real &
       &,    -1.913414_t_real,    -1.595771_t_real,    -1.354125_t_real &
       &,    -1.168018_t_real,    -1.021165_t_real,    -0.901937_t_real &
       &,    -0.802150_t_real,    -0.715805_t_real,    -0.638448_t_real &
       &,    -0.566947_t_real,    -0.499386_t_real,    -0.434914_t_real &
       &,    -0.373500_t_real,    -0.315645_t_real,    -0.262092_t_real &
       &,    -0.213577_t_real,    -0.170660_t_real,    -0.133634_t_real &
       &,    -0.102493_t_real,    -0.076966_t_real,    -0.056573_t_real &
       &,    -0.040692_t_real,    -0.028637_t_real,    -0.019714_t_real &
       &,    -0.013275_t_real,    -0.008742_t_real,    -0.005629_t_real &
       &,    -0.003544_t_real,    -0.002181_t_real/
  !!
  Data ncoefnrel( 28) / 50 /
  Data vcoefnrel(1:50, 28) /&
       &    -28.000000_t_real,   -27.982302_t_real,   -27.857767_t_real &
       &,   -27.516019_t_real,   -26.849619_t_real,   -25.792562_t_real &
       &,   -24.359825_t_real,   -22.616248_t_real,   -20.641156_t_real &
       &,   -18.533649_t_real,   -16.374757_t_real,   -14.263251_t_real &
       &,   -12.248385_t_real,   -10.345231_t_real,    -8.589145_t_real &
       &,    -6.983344_t_real,    -5.570145_t_real,    -4.404054_t_real &
       &,    -3.490111_t_real,    -2.790826_t_real,    -2.258096_t_real &
       &,    -1.852559_t_real,    -1.544991_t_real,    -1.311298_t_real &
       &,    -1.131081_t_real,    -0.988701_t_real,    -0.873018_t_real &
       &,    -0.776057_t_real,    -0.691913_t_real,    -0.616247_t_real &
       &,    -0.546082_t_real,    -0.479684_t_real,    -0.416360_t_real &
       &,    -0.356192_t_real,    -0.299737_t_real,    -0.247738_t_real &
       &,    -0.200893_t_real,    -0.159699_t_real,    -0.124376_t_real &
       &,    -0.094856_t_real,    -0.070814_t_real,    -0.051734_t_real &
       &,    -0.036977_t_real,    -0.025852_t_real,    -0.017676_t_real &
       &,    -0.011819_t_real,    -0.007726_t_real,    -0.004938_t_real &
       &,    -0.003085_t_real,    -0.001883_t_real/
  !!
  Data ncoefnrel( 29) / 50 /
  Data vcoefnrel(1:50, 29) /&
       &    -29.000000_t_real,   -28.981285_t_real,   -28.849588_t_real &
       &,   -28.488220_t_real,   -27.784274_t_real,   -26.670316_t_real &
       &,   -25.164034_t_real,   -23.332118_t_real,   -21.258111_t_real &
       &,   -19.042582_t_real,   -16.770555_t_real,   -14.544034_t_real &
       &,   -12.408434_t_real,   -10.388929_t_real,    -8.520059_t_real &
       &,    -6.816009_t_real,    -5.339605_t_real,    -4.144750_t_real &
       &,    -3.226698_t_real,    -2.539673_t_real,    -2.029284_t_real &
       &,    -1.649941_t_real,    -1.367311_t_real,    -1.155418_t_real &
       &,    -0.994423_t_real,    -0.869516_t_real,    -0.769875_t_real &
       &,    -0.687608_t_real,    -0.616956_t_real,    -0.553795_t_real &
       &,    -0.495348_t_real,    -0.439956_t_real,    -0.386858_t_real &
       &,    -0.335966_t_real,    -0.287621_t_real,    -0.242387_t_real &
       &,    -0.200857_t_real,    -0.163533_t_real,    -0.130735_t_real &
       &,    -0.102574_t_real,    -0.078954_t_real,    -0.059604_t_real &
       &,    -0.044119_t_real,    -0.032013_t_real,    -0.022767_t_real &
       &,    -0.015867_t_real,    -0.010835_t_real,    -0.007249_t_real &
       &,    -0.004750_t_real,    -0.003048_t_real/
  !!
  Data ncoefnrel( 30) / 50 /
  Data vcoefnrel(1:50, 30) /&
       &    -30.000000_t_real,   -29.980310_t_real,   -29.841741_t_real &
       &,   -29.461548_t_real,   -28.721696_t_real,   -27.553877_t_real &
       &,   -25.978945_t_real,   -24.065872_t_real,   -21.903260_t_real &
       &,   -19.593401_t_real,   -17.227085_t_real,   -14.908552_t_real &
       &,   -12.680644_t_real,   -10.579300_t_real,    -8.637448_t_real &
       &,    -6.884382_t_real,    -5.395173_t_real,    -4.211411_t_real &
       &,    -3.309502_t_real,    -2.632247_t_real,    -2.123374_t_real &
       &,    -1.740441_t_real,    -1.452065_t_real,    -1.233222_t_real &
       &,    -1.064199_t_real,    -0.930471_t_real,    -0.821600_t_real &
       &,    -0.729939_t_real,    -0.649823_t_real,    -0.577202_t_real &
       &,    -0.509453_t_real,    -0.445189_t_real,    -0.384003_t_real &
       &,    -0.326163_t_real,    -0.272302_t_real,    -0.223148_t_real &
       &,    -0.179316_t_real,    -0.141189_t_real,    -0.108862_t_real &
       &,    -0.082159_t_real,    -0.060669_t_real,    -0.043822_t_real &
       &,    -0.030954_t_real,    -0.021378_t_real,    -0.014433_t_real &
       &,    -0.009524_t_real,    -0.006142_t_real,    -0.003871_t_real &
       &,    -0.002383_t_real,    -0.001433_t_real/
  !! 4p
  !!
  Data ncoefnrel( 31) / 50 /
  Data vcoefnrel(1:50, 31) /&
       &    -31.000000_t_real,   -30.979338_t_real,   -30.833921_t_real &
       &,   -30.434966_t_real,   -29.659416_t_real,   -28.438322_t_real &
       &,   -26.795773_t_real,   -24.803152_t_real,   -22.554413_t_real &
       &,   -20.153382_t_real,   -17.697592_t_real,   -15.292331_t_real &
       &,   -12.980354_t_real,   -10.807613_t_real,    -8.806470_t_real &
       &,    -7.024751_t_real,    -5.542390_t_real,    -4.383096_t_real &
       &,    -3.503660_t_real,    -2.837559_t_real,    -2.329205_t_real &
       &,    -1.940202_t_real,    -1.641036_t_real,    -1.406927_t_real &
       &,    -1.219383_t_real,    -1.066149_t_real,    -0.939068_t_real &
       &,    -0.832246_t_real,    -0.741142_t_real,    -0.662196_t_real &
       &,    -0.592648_t_real,    -0.530376_t_real,    -0.473761_t_real &
       &,    -0.421588_t_real,    -0.373001_t_real,    -0.327474_t_real &
       &,    -0.284772_t_real,    -0.244897_t_real,    -0.207998_t_real &
       &,    -0.174290_t_real,    -0.143971_t_real,    -0.117168_t_real &
       &,    -0.093903_t_real,    -0.074089_t_real,    -0.057534_t_real &
       &,    -0.043965_t_real,    -0.033056_t_real,    -0.024452_t_real &
       &,    -0.017791_t_real,    -0.012732_t_real/
  !!
  Data ncoefnrel( 32) / 50 /
  Data vcoefnrel(1:50, 32) /&
       &    -32.000000_t_real,   -31.978353_t_real,   -31.825988_t_real &
       &,   -31.408010_t_real,   -30.596341_t_real,   -29.321530_t_real &
       &,   -27.610879_t_real,   -25.538266_t_real,   -23.203108_t_real &
       &,   -20.710718_t_real,   -18.166001_t_real,   -15.674146_t_real &
       &,   -13.280160_t_real,   -11.038170_t_real,    -8.982617_t_real &
       &,    -7.179838_t_real,    -5.706425_t_real,    -4.563841_t_real &
       &,    -3.690966_t_real,    -3.017817_t_real,    -2.495141_t_real &
       &,    -2.089090_t_real,    -1.769355_t_real,    -1.511404_t_real &
       &,    -1.299757_t_real,    -1.125047_t_real,    -0.980420_t_real &
       &,    -0.859903_t_real,    -0.758106_t_real,    -0.670382_t_real &
       &,    -0.592984_t_real,    -0.523120_t_real,    -0.458905_t_real &
       &,    -0.399238_t_real,    -0.343642_t_real,    -0.292075_t_real &
       &,    -0.244744_t_real,    -0.201941_t_real,    -0.163916_t_real &
       &,    -0.130796_t_real,    -0.102542_t_real,    -0.078952_t_real &
       &,    -0.059682_t_real,    -0.044283_t_real,    -0.032244_t_real &
       &,    -0.023036_t_real,    -0.016145_t_real,    -0.011100_t_real &
       &,    -0.007484_t_real,    -0.004949_t_real/
  !!
  Data ncoefnrel( 33) / 50 /
  Data vcoefnrel(1:50, 33) /&
       &    -33.000000_t_real,   -32.977353_t_real,   -32.817944_t_real &
       &,   -32.380682_t_real,   -31.532473_t_real,   -30.203504_t_real &
       &,   -28.424248_t_real,   -26.271199_t_real,   -23.849250_t_real &
       &,   -21.265335_t_real,   -18.632049_t_real,   -16.053625_t_real &
       &,   -13.579563_t_real,   -11.269977_t_real,    -9.164987_t_real &
       &,    -7.346738_t_real,    -5.880741_t_real,    -4.744188_t_real &
       &,    -3.862708_t_real,    -3.170269_t_real,    -2.626192_t_real &
       &,    -2.196310_t_real,    -1.848515_t_real,    -1.562183_t_real &
       &,    -1.326373_t_real,    -1.133438_t_real,    -0.975921_t_real &
       &,    -0.846277_t_real,    -0.737530_t_real,    -0.643892_t_real &
       &,    -0.561035_t_real,    -0.486075_t_real,    -0.417356_t_real &
       &,    -0.354143_t_real,    -0.296306_t_real,    -0.244020_t_real &
       &,    -0.197538_t_real,    -0.157024_t_real,    -0.122472_t_real &
       &,    -0.093668_t_real,    -0.070216_t_real,    -0.051570_t_real &
       &,    -0.037098_t_real,    -0.026133_t_real,    -0.018024_t_real &
       &,    -0.012168_t_real,    -0.008040_t_real,    -0.005199_t_real &
       &,    -0.003289_t_real,    -0.002035_t_real/
  !!
  Data ncoefnrel( 34) / 50 /
  Data vcoefnrel(1:50, 34) /&
       &    -34.000000_t_real,   -33.976340_t_real,   -33.809787_t_real &
       &,   -33.352976_t_real,   -32.467804_t_real,   -31.084218_t_real &
       &,   -29.235818_t_real,   -27.001869_t_real,   -24.492647_t_real &
       &,   -21.817017_t_real,   -19.095283_t_real,   -16.430222_t_real &
       &,   -13.877726_t_real,   -11.501902_t_real,    -9.352218_t_real &
       &,    -7.521818_t_real,    -6.058501_t_real,    -4.915792_t_real &
       &,    -4.013226_t_real,    -3.294879_t_real,    -2.724570_t_real &
       &,    -2.263767_t_real,    -1.883492_t_real,    -1.569924_t_real &
       &,    -1.315038_t_real,    -1.110310_t_real,    -0.945898_t_real &
       &,    -0.811943_t_real,    -0.699911_t_real,    -0.603277_t_real &
       &,    -0.517618_t_real,    -0.440310_t_real,    -0.370076_t_real &
       &,    -0.306505_t_real,    -0.249631_t_real,    -0.199614_t_real &
       &,    -0.156531_t_real,    -0.120262_t_real,    -0.090463_t_real &
       &,    -0.066585_t_real,    -0.047935_t_real,    -0.033741_t_real &
       &,    -0.023215_t_real,    -0.015609_t_real,    -0.010254_t_real &
       &,    -0.006581_t_real,    -0.004125_t_real,    -0.002525_t_real &
       &,    -0.001509_t_real,    -0.000880_t_real/
  !! 
  !!
  Data ncoefnrel( 35) / 50 /
  Data vcoefnrel(1:50, 35) /&
       &    -35.000000_t_real,   -34.975312_t_real,   -34.801515_t_real &
       &,   -34.324889_t_real,   -33.402326_t_real,   -31.963651_t_real &
       &,   -30.045540_t_real,   -27.730201_t_real,   -25.133136_t_real &
       &,   -22.365587_t_real,   -19.555306_t_real,   -16.803516_t_real &
       &,   -14.173878_t_real,   -11.733118_t_real,    -9.543011_t_real &
       &,    -7.701481_t_real,    -6.233613_t_real,    -5.072620_t_real &
       &,    -4.140415_t_real,    -3.392595_t_real,    -2.790043_t_real &
       &,    -2.293001_t_real,    -1.881115_t_real,    -1.546054_t_real &
       &,    -1.279373_t_real,    -1.069408_t_real,    -0.903070_t_real &
       &,    -0.768279_t_real,    -0.655438_t_real,    -0.557832_t_real &
       &,    -0.471318_t_real,    -0.393707_t_real,    -0.324082_t_real &
       &,    -0.262224_t_real,    -0.208164_t_real,    -0.161897_t_real &
       &,    -0.123224_t_real,    -0.091709_t_real,    -0.066695_t_real &
       &,    -0.047370_t_real,    -0.032845_t_real,    -0.022225_t_real &
       &,    -0.014673_t_real,    -0.009449_t_real,    -0.005934_t_real &
       &,    -0.003634_t_real,    -0.002170_t_real,    -0.001262_t_real &
       &,    -0.000716_t_real,    -0.000395_t_real/
  !!
  Data ncoefnrel( 36) / 50 /
  Data vcoefnrel(1:50, 36) /&
       &    -36.000000_t_real,   -35.974270_t_real,   -35.793127_t_real &
       &,   -35.296417_t_real,   -34.336032_t_real,   -32.841787_t_real &
       &,   -30.853372_t_real,   -28.456141_t_real,   -25.770594_t_real &
       &,   -22.910905_t_real,   -20.011790_t_real,   -17.173212_t_real &
       &,   -14.467354_t_real,   -11.963059_t_real,    -9.736088_t_real &
       &,    -7.882243_t_real,    -6.400924_t_real,    -5.210989_t_real &
       &,    -4.244375_t_real,    -3.463306_t_real,    -2.822247_t_real &
       &,    -2.288051_t_real,    -1.849894_t_real,    -1.501062_t_real &
       &,    -1.229656_t_real,    -1.019655_t_real,    -0.854760_t_real &
       &,    -0.721246_t_real,    -0.609093_t_real,    -0.511851_t_real &
       &,    -0.425874_t_real,    -0.349419_t_real,    -0.281839_t_real &
       &,    -0.222966_t_real,    -0.172705_t_real,    -0.130807_t_real &
       &,    -0.096777_t_real,    -0.069883_t_real,    -0.049221_t_real &
       &,    -0.033798_t_real,    -0.022617_t_real,    -0.014744_t_real &
       &,    -0.009362_t_real,    -0.005789_t_real,    -0.003485_t_real &
       &,    -0.002042_t_real,    -0.001164_t_real,    -0.000646_t_real &
       &,    -0.000348_t_real,    -0.000183_t_real/
  !!
  !!5s
  !!
  Data ncoefnrel( 37) / 50 /
  Data vcoefnrel(1:50, 37) /&
       &    -37.000000_t_real,   -36.973258_t_real,   -36.784971_t_real &
       &,   -36.268731_t_real,   -35.271702_t_real,   -33.724065_t_real &
       &,   -31.668722_t_real,   -29.194588_t_real,   -26.427118_t_real &
       &,   -23.484257_t_real,   -20.507320_t_real,   -17.595980_t_real &
       &,   -14.831302_t_real,   -12.284830_t_real,   -10.046517_t_real &
       &,    -8.203336_t_real,    -6.728729_t_real,    -5.535223_t_real &
       &,    -4.567453_t_real,    -3.783790_t_real,    -3.134034_t_real &
       &,    -2.593159_t_real,    -2.151789_t_real,    -1.797611_t_real &
       &,    -1.513731_t_real,    -1.284504_t_real,    -1.100251_t_real &
       &,    -0.957422_t_real,    -0.853606_t_real,    -0.781639_t_real &
       &,    -0.730178_t_real,    -0.688904_t_real,    -0.651132_t_real &
       &,    -0.613271_t_real,    -0.573609_t_real,    -0.531503_t_real &
       &,    -0.486978_t_real,    -0.440527_t_real,    -0.392981_t_real &
       &,    -0.345380_t_real,    -0.298848_t_real,    -0.254462_t_real &
       &,    -0.213145_t_real,    -0.175603_t_real,    -0.142282_t_real &
       &,    -0.113374_t_real,    -0.088844_t_real,    -0.068469_t_real &
       &,    -0.051895_t_real,    -0.038683_t_real/
  !!
  Data ncoefnrel( 38) / 50 /
  Data vcoefnrel(1:50, 38) /&
       &    -38.000000_t_real,   -37.972234_t_real,   -37.776727_t_real &
       &,   -37.240757_t_real,   -36.206790_t_real,   -34.605501_t_real &
       &,   -32.482955_t_real,   -29.931830_t_real,   -27.082256_t_real &
       &,   -24.056593_t_real,   -21.002038_t_real,   -18.018944_t_real &
       &,   -15.196831_t_real,   -12.611032_t_real,   -10.364068_t_real &
       &,    -8.527804_t_real,    -7.051604_t_real,    -5.849705_t_real &
       &,    -4.876276_t_real,    -4.079334_t_real,    -3.410724_t_real &
       &,    -2.851949_t_real,    -2.391166_t_real,    -2.012677_t_real &
       &,    -1.702918_t_real,    -1.455894_t_real,    -1.268419_t_real &
       &,    -1.130187_t_real,    -1.024542_t_real,    -0.937253_t_real &
       &,    -0.859819_t_real,    -0.787743_t_real,    -0.718531_t_real &
       &,    -0.650716_t_real,    -0.583565_t_real,    -0.517019_t_real &
       &,    -0.451602_t_real,    -0.388266_t_real,    -0.328168_t_real &
       &,    -0.272447_t_real,    -0.222040_t_real,    -0.177574_t_real &
       &,    -0.139324_t_real,    -0.107227_t_real,    -0.080942_t_real &
       &,    -0.059927_t_real,    -0.043513_t_real,    -0.030987_t_real &
       &,    -0.021640_t_real,    -0.014821_t_real/
  !!4d
  Data ncoefnrel( 39) / 50 /
  Data vcoefnrel(1:50, 39) /&
       &    -39.000000_t_real,   -38.971185_t_real,   -38.768278_t_real &
       &,   -38.212100_t_real,   -37.140357_t_real,   -35.484222_t_real &
       &,   -33.292756_t_real,   -30.662454_t_real,   -27.727662_t_real &
       &,   -24.615650_t_real,   -21.478773_t_real,   -18.419421_t_real &
       &,   -15.534645_t_real,   -12.905115_t_real,   -10.642599_t_real &
       &,    -8.798433_t_real,    -7.301312_t_real,    -6.072713_t_real &
       &,    -5.070269_t_real,    -4.234105_t_real,    -3.525783_t_real &
       &,    -2.933812_t_real,    -2.446349_t_real,    -2.048266_t_real &
       &,    -1.728438_t_real,    -1.479655_t_real,    -1.290881_t_real &
       &,    -1.145492_t_real,    -1.027976_t_real,    -0.927935_t_real &
       &,    -0.839152_t_real,    -0.757719_t_real,    -0.681003_t_real &
       &,    -0.607331_t_real,    -0.535911_t_real,    -0.466740_t_real &
       &,    -0.400411_t_real,    -0.337858_t_real,    -0.280091_t_real &
       &,    -0.227976_t_real,    -0.182101_t_real,    -0.142710_t_real &
       &,    -0.109714_t_real,    -0.082740_t_real,    -0.061214_t_real &
       &,    -0.044433_t_real,    -0.031650_t_real,    -0.022129_t_real &
       &,    -0.015191_t_real,    -0.010242_t_real/
  !!
  Data ncoefnrel( 40) / 50 /
  Data vcoefnrel(1:50, 40) /&
       &    -40.000000_t_real,   -39.970119_t_real,   -39.759691_t_real &
       &,   -39.182980_t_real,   -38.072927_t_real,   -36.361259_t_real &
       &,   -34.099925_t_real,   -31.389364_t_real,   -28.367788_t_real &
       &,   -25.167942_t_real,   -21.946699_t_real,   -18.809803_t_real &
       &,   -15.860777_t_real,   -13.187310_t_real,   -10.905974_t_real &
       &,    -9.043771_t_real,    -7.514307_t_real,    -6.250636_t_real &
       &,    -5.207505_t_real,    -4.323248_t_real,    -3.572844_t_real &
       &,    -2.949752_t_real,    -2.441310_t_real,    -2.031826_t_real &
       &,    -1.708765_t_real,    -1.459942_t_real,    -1.269138_t_real &
       &,    -1.119066_t_real,    -0.996230_t_real,    -0.891677_t_real &
       &,    -0.799490_t_real,    -0.715551_t_real,    -0.637030_t_real &
       &,    -0.562223_t_real,    -0.490445_t_real,    -0.421825_t_real &
       &,    -0.357029_t_real,    -0.296956_t_real,    -0.242472_t_real &
       &,    -0.194229_t_real,    -0.152560_t_real,    -0.117463_t_real &
       &,    -0.088632_t_real,    -0.065529_t_real,    -0.047466_t_real &
       &,    -0.033681_t_real,    -0.023412_t_real,    -0.015940_t_real &
       &,    -0.010629_t_real,    -0.006942_t_real/
  !!
  Data ncoefnrel( 41) / 50 /
  Data vcoefnrel(1:50, 41) /&
       &    -41.000000_t_real,   -40.969020_t_real,   -40.750848_t_real &
       &,   -40.153008_t_real,   -39.003571_t_real,   -37.234765_t_real &
       &,   -34.901203_t_real,   -32.107245_t_real,   -28.994499_t_real &
       &,   -25.701589_t_real,   -22.389423_t_real,   -19.168448_t_real &
       &,   -16.147501_t_real,   -13.422660_t_real,   -11.109816_t_real &
       &,    -9.209307_t_real,    -7.625874_t_real,    -6.305313_t_real &
       &,    -5.196740_t_real,    -4.246552_t_real,    -3.446332_t_real &
       &,    -2.794715_t_real,    -2.277101_t_real,    -1.872237_t_real &
       &,    -1.559802_t_real,    -1.321439_t_real,    -1.139689_t_real &
       &,    -0.998771_t_real,    -0.886049_t_real,    -0.792301_t_real &
       &,    -0.711052_t_real,    -0.637850_t_real,    -0.569770_t_real &
       &,    -0.505114_t_real,    -0.443153_t_real,    -0.383883_t_real &
       &,    -0.327764_t_real,    -0.275466_t_real,    -0.227673_t_real &
       &,    -0.184926_t_real,    -0.147544_t_real,    -0.115595_t_real &
       &,    -0.088910_t_real,    -0.067124_t_real,    -0.049737_t_real &
       &,    -0.036167_t_real,    -0.025807_t_real,    -0.018071_t_real &
       &,    -0.012416_t_real,    -0.008370_t_real/
  !!
  Data ncoefnrel( 42) / 50 /
  Data vcoefnrel(1:50, 42) /&
       &    -42.000000_t_real,   -41.967922_t_real,   -41.741999_t_real &
       &,   -41.123020_t_real,   -39.934284_t_real,   -38.108684_t_real &
       &,   -35.703527_t_real,   -32.827337_t_real,   -29.625028_t_real &
       &,   -26.241723_t_real,   -22.841914_t_real,   -19.541662_t_real &
       &,   -16.454406_t_real,   -13.685483_t_real,   -11.344856_t_real &
       &,    -9.406396_t_real,    -7.774488_t_real,    -6.405659_t_real &
       &,    -5.240759_t_real,    -4.240166_t_real,    -3.407017_t_real &
       &,    -2.738554_t_real,    -2.215312_t_real,    -1.811850_t_real &
       &,    -1.504254_t_real,    -1.271194_t_real,    -1.093664_t_real &
       &,    -0.955737_t_real,    -0.845165_t_real,    -0.753049_t_real &
       &,    -0.673104_t_real,    -0.601021_t_real,    -0.534036_t_real &
       &,    -0.470616_t_real,    -0.410178_t_real,    -0.352801_t_real &
       &,    -0.298961_t_real,    -0.249277_t_real,    -0.204336_t_real &
       &,    -0.164556_t_real,    -0.130132_t_real,    -0.101018_t_real &
       &,    -0.076955_t_real,    -0.057519_t_real,    -0.042174_t_real &
       &,    -0.030331_t_real,    -0.021393_t_real,    -0.014796_t_real &
       &,    -0.010035_t_real,    -0.006672_t_real/
  !!
  Data ncoefnrel( 43) / 50 /
  Data vcoefnrel(1:50, 43) /&
       &    -43.000000_t_real,   -42.966808_t_real,   -42.733032_t_real &
       &,   -42.092647_t_real,   -40.864189_t_real,   -38.981268_t_real &
       &,   -36.503813_t_real,   -33.544607_t_real,   -30.251676_t_real &
       &,   -26.777076_t_real,   -23.288605_t_real,   -19.908754_t_real &
       &,   -16.755016_t_real,   -13.942067_t_real,   -11.568592_t_real &
       &,    -9.583922_t_real,    -7.899377_t_real,    -6.476772_t_real &
       &,    -5.252502_t_real,    -4.205575_t_real,    -3.346448_t_real &
       &,    -2.668011_t_real,    -2.144775_t_real,    -1.746645_t_real &
       &,    -1.446228_t_real,    -1.219916_t_real,    -1.047818_t_real &
       &,    -0.914067_t_real,    -0.806744_t_real,    -0.717230_t_real &
       &,    -0.639448_t_real,    -0.569274_t_real,    -0.504115_t_real &
       &,    -0.442586_t_real,    -0.384198_t_real,    -0.329071_t_real &
       &,    -0.277656_t_real,    -0.230515_t_real,    -0.188143_t_real &
       &,    -0.150870_t_real,    -0.118806_t_real,    -0.091841_t_real &
       &,    -0.069676_t_real,    -0.051866_t_real,    -0.037876_t_real &
       &,    -0.027130_t_real,    -0.019058_t_real,    -0.013129_t_real &
       &,    -0.008868_t_real,    -0.005872_t_real/
  !!
  Data ncoefnrel( 44) / 50 /
  Data vcoefnrel(1:50, 44) /&
       &    -44.000000_t_real,   -43.965681_t_real,   -43.723950_t_real &
       &,   -43.061893_t_real,   -41.793294_t_real,   -39.852531_t_real &
       &,   -37.302078_t_real,   -34.259061_t_real,   -30.874477_t_real &
       &,   -27.307678_t_real,   -23.729632_t_real,   -20.269829_t_real &
       &,   -17.049569_t_real,   -14.192097_t_real,   -11.779988_t_real &
       &,    -9.741856_t_real,    -8.001529_t_real,    -6.519737_t_real &
       &,    -5.235869_t_real,    -4.148505_t_real,    -3.270697_t_real &
       &,    -2.588603_t_real,    -2.070015_t_real,    -1.680149_t_real &
       &,    -1.388542_t_real,    -1.169940_t_real,    -1.004011_t_real &
       &,    -0.875088_t_real,    -0.771594_t_real,    -0.685198_t_real &
       &,    -0.610050_t_real,    -0.542214_t_real,    -0.479252_t_real &
       &,    -0.419890_t_real,    -0.363702_t_real,    -0.310819_t_real &
       &,    -0.261669_t_real,    -0.216761_t_real,    -0.176533_t_real &
       &,    -0.141258_t_real,    -0.111003_t_real,    -0.085631_t_real &
       &,    -0.064829_t_real,    -0.048157_t_real,    -0.035091_t_real &
       &,    -0.025080_t_real,    -0.017579_t_real,    -0.012081_t_real &
       &,    -0.008140_t_real,    -0.005376_t_real/
  !!
  Data ncoefnrel( 45) / 50 /
  Data vcoefnrel(1:50, 45) /&
       &    -45.000000_t_real,   -44.964539_t_real,   -44.714754_t_real &
       &,   -44.030762_t_real,   -42.721608_t_real,   -40.722480_t_real &
       &,   -38.098333_t_real,   -34.970689_t_real,   -31.493443_t_real &
       &,   -27.833528_t_real,   -24.165092_t_real,   -20.624930_t_real &
       &,   -17.338192_t_real,   -14.435059_t_real,   -11.978029_t_real &
       &,    -9.880455_t_real,    -8.081467_t_real,    -6.535877_t_real &
       &,    -5.194742_t_real,    -4.073927_t_real,    -3.184563_t_real &
       &,    -2.504344_t_real,    -1.994081_t_real,    -1.614568_t_real &
       &,    -1.332805_t_real,    -1.122445_t_real,    -0.963043_t_real &
       &,    -0.839254_t_real,    -0.739867_t_real,    -0.656849_t_real &
       &,    -0.584573_t_real,    -0.519272_t_real,    -0.458637_t_real &
       &,    -0.401479_t_real,    -0.347416_t_real,    -0.296591_t_real &
       &,    -0.249416_t_real,    -0.206375_t_real,    -0.167874_t_real &
       &,    -0.134162_t_real,    -0.105288_t_real,    -0.081109_t_real &
       &,    -0.061314_t_real,    -0.045473_t_real,    -0.033079_t_real &
       &,    -0.023598_t_real,    -0.016507_t_real,    -0.011320_t_real &
       &,    -0.007610_t_real,    -0.005014_t_real/
  !!
  !!
  Data ncoefnrel( 46) / 50 /
  Data vcoefnrel(1:50, 46) /&
       &    -46.000000_t_real,   -45.963360_t_real,   -45.705261_t_real &
       &,   -44.998641_t_real,   -43.647671_t_real,   -41.588230_t_real &
       &,   -38.887529_t_real,   -35.671333_t_real,   -32.096220_t_real &
       &,   -28.336791_t_real,   -24.570567_t_real,   -20.941641_t_real &
       &,   -17.579134_t_real,   -14.617497_t_real,   -12.096005_t_real &
       &,    -9.918835_t_real,    -8.039863_t_real,    -6.407777_t_real &
       &,    -4.994213_t_real,    -3.831087_t_real,    -2.927371_t_real &
       &,    -2.253061_t_real,    -1.761157_t_real,    -1.405458_t_real &
       &,    -1.147451_t_real,    -0.957365_t_real,    -0.813316_t_real &
       &,    -0.699924_t_real,    -0.606816_t_real,    -0.527284_t_real &
       &,    -0.457192_t_real,    -0.394149_t_real,    -0.336901_t_real &
       &,    -0.284893_t_real,    -0.237948_t_real,    -0.196044_t_real &
       &,    -0.159176_t_real,    -0.127270_t_real,    -0.100145_t_real &
       &,    -0.077514_t_real,    -0.058990_t_real,    -0.044125_t_real &
       &,    -0.032431_t_real,    -0.023414_t_real,    -0.016600_t_real &
       &,    -0.011555_t_real,    -0.007896_t_real,    -0.005294_t_real &
       &,    -0.003483_t_real,    -0.002248_t_real/
  !!
  Data ncoefnrel( 47) / 50 /
  Data vcoefnrel(1:50, 47) /&
       &    -47.000000_t_real,   -46.962213_t_real,   -46.696018_t_real &
       &,   -45.967374_t_real,   -44.575878_t_real,   -42.458446_t_real &
       &,   -39.684819_t_real,   -36.385394_t_real,   -32.719860_t_real &
       &,   -28.870917_t_real,   -25.019586_t_real,   -21.317275_t_real &
       &,   -17.897724_t_real,   -14.897161_t_real,   -12.330722_t_real &
       &,   -10.101638_t_real,    -8.175383_t_real,    -6.494899_t_real &
       &,    -5.053994_t_real,    -3.888751_t_real,    -2.995461_t_real &
       &,    -2.332101_t_real,    -1.846094_t_real,    -1.490899_t_real &
       &,    -1.230142_t_real,    -1.036630_t_real,    -0.890422_t_real &
       &,    -0.777056_t_real,    -0.686091_t_real,    -0.610039_t_real &
       &,    -0.543646_t_real,    -0.483416_t_real,    -0.427243_t_real &
       &,    -0.374084_t_real,    -0.323655_t_real,    -0.276155_t_real &
       &,    -0.232023_t_real,    -0.191748_t_real,    -0.155737_t_real &
       &,    -0.124235_t_real,    -0.097291_t_real,    -0.074769_t_real &
       &,    -0.056372_t_real,    -0.041687_t_real,    -0.030230_t_real &
       &,    -0.021494_t_real,    -0.014982_t_real,    -0.010236_t_real &
       &,    -0.006855_t_real,    -0.004498_t_real/
  !!
  Data ncoefnrel( 48) / 50 /
  Data vcoefnrel(1:50, 48) /&
       &    -48.000000_t_real,   -47.961058_t_real,   -47.686721_t_real &
       &,   -46.935935_t_real,   -45.503784_t_real,   -43.328298_t_real &
       &,   -40.481767_t_real,   -37.099277_t_real,   -33.343790_t_real &
       &,   -29.406200_t_real,   -25.471282_t_real,   -21.697511_t_real &
       &,   -18.223650_t_real,   -15.184394_t_real,   -12.570803_t_real &
       &,   -10.292083_t_real,    -8.319321_t_real,    -6.595262_t_real &
       &,    -5.135170_t_real,    -3.971653_t_real,    -3.085873_t_real &
       &,    -2.425986_t_real,    -1.937801_t_real,    -1.577342_t_real &
       &,    -1.310721_t_real,    -1.111589_t_real,    -0.959742_t_real &
       &,    -0.840187_t_real,    -0.742080_t_real,    -0.657776_t_real &
       &,    -0.582131_t_real,    -0.511992_t_real,    -0.445764_t_real &
       &,    -0.382990_t_real,    -0.323948_t_real,    -0.269276_t_real &
       &,    -0.219685_t_real,    -0.175743_t_real,    -0.137765_t_real &
       &,    -0.105770_t_real,    -0.079503_t_real,    -0.058488_t_real &
       &,    -0.042102_t_real,    -0.029651_t_real,    -0.020425_t_real &
       &,    -0.013762_t_real,    -0.009067_t_real,    -0.005842_t_real &
       &,    -0.003680_t_real,    -0.002266_t_real/
  !!5p
  Data ncoefnrel( 49) / 50 /
  Data vcoefnrel(1:50, 49) /&
       &    -49.000000_t_real,   -48.959908_t_real,   -48.677448_t_real &
       &,   -47.904590_t_real,   -46.432016_t_real,   -44.198986_t_real &
       &,   -41.280417_t_real,   -37.816195_t_real,   -33.972810_t_real &
       &,   -29.949433_t_real,   -25.934996_t_real,   -22.094756_t_real &
       &,   -18.572882_t_real,   -15.499015_t_real,   -12.841677_t_real &
       &,   -10.521497_t_real,    -8.509199_t_real,    -6.754877_t_real &
       &,    -5.291238_t_real,    -4.140720_t_real,    -3.267794_t_real &
       &,    -2.612330_t_real,    -2.120495_t_real,    -1.751470_t_real &
       &,    -1.473141_t_real,    -1.259823_t_real,    -1.092412_t_real &
       &,    -0.957609_t_real,    -0.846250_t_real,    -0.751901_t_real &
       &,    -0.669993_t_real,    -0.597304_t_real,    -0.531606_t_real &
       &,    -0.471395_t_real,    -0.415691_t_real,    -0.363898_t_real &
       &,    -0.315716_t_real,    -0.271057_t_real,    -0.229984_t_real &
       &,    -0.192625_t_real,    -0.159115_t_real,    -0.129531_t_real &
       &,    -0.103863_t_real,    -0.081996_t_real,    -0.063713_t_real &
       &,    -0.048716_t_real,    -0.036648_t_real,    -0.027120_t_real &
       &,    -0.019740_t_real,    -0.014130_t_real/
  !!
  Data ncoefnrel( 50) / 50 /
  Data vcoefnrel(1:50, 50) /&
       &    -50.000000_t_real,   -49.958747_t_real,   -49.668097_t_real &
       &,   -48.872991_t_real,   -47.359749_t_real,   -45.068910_t_real &
       &,   -42.078034_t_real,   -38.531823_t_real,   -34.600529_t_real &
       &,   -30.491537_t_real,   -26.398235_t_real,   -22.492230_t_real &
       &,   -18.923229_t_real,   -15.812250_t_real,   -13.108213_t_real &
       &,   -10.746513_t_real,    -8.692687_t_real,    -6.910774_t_real &
       &,    -5.444011_t_real,    -4.299328_t_real,    -3.426196_t_real &
       &,    -2.761770_t_real,    -2.256804_t_real,    -1.873140_t_real &
       &,    -1.578074_t_real,    -1.346240_t_real,    -1.160451_t_real &
       &,    -1.009147_t_real,    -0.883848_t_real,    -0.777914_t_real &
       &,    -0.686134_t_real,    -0.604605_t_real,    -0.530609_t_real &
       &,    -0.462454_t_real,    -0.399257_t_real,    -0.340722_t_real &
       &,    -0.286916_t_real,    -0.238076_t_real,    -0.194453_t_real &
       &,    -0.156202_t_real,    -0.123326_t_real,    -0.095655_t_real &
       &,    -0.072858_t_real,    -0.054480_t_real,    -0.039984_t_real &
       &,    -0.028798_t_real,    -0.020351_t_real,    -0.014109_t_real &
       &,    -0.009595_t_real,    -0.006400_t_real/
  !!
  Data ncoefnrel( 51) / 50 /
  Data vcoefnrel(1:50, 51) /&
       &    -51.000000_t_real,   -50.957577_t_real,   -50.658670_t_real &
       &,   -49.841150_t_real,   -48.287016_t_real,   -45.938125_t_real &
       &,   -42.874710_t_real,   -39.246293_t_real,   -35.227153_t_real &
       &,   -31.032771_t_real,   -26.861325_t_real,   -22.890332_t_real &
       &,   -19.274924_t_real,   -16.124125_t_real,   -13.371398_t_real &
       &,   -10.967727_t_real,    -8.871207_t_real,    -7.064376_t_real &
       &,    -5.593133_t_real,    -4.446068_t_real,    -3.561961_t_real &
       &,    -2.881044_t_real,    -2.358999_t_real,    -1.956567_t_real &
       &,    -1.640265_t_real,    -1.387466_t_real,    -1.183719_t_real &
       &,    -1.018296_t_real,    -0.882130_t_real,    -0.767526_t_real &
       &,    -0.668383_t_real,    -0.580305_t_real,    -0.500481_t_real &
       &,    -0.427389_t_real,    -0.360425_t_real,    -0.299543_t_real &
       &,    -0.244941_t_real,    -0.196833_t_real,    -0.155298_t_real &
       &,    -0.120216_t_real,    -0.091254_t_real,    -0.067897_t_real &
       &,    -0.049501_t_real,    -0.035353_t_real,    -0.024729_t_real &
       &,    -0.016939_t_real,    -0.011360_t_real,    -0.007459_t_real &
       &,    -0.004793_t_real,    -0.003015_t_real/
  !!
  Data ncoefnrel( 52) / 50 /
  Data vcoefnrel(1:50, 52) /&
       &    -52.000000_t_real,   -51.956398_t_real,   -51.649169_t_real &
       &,   -50.809070_t_real,   -49.213820_t_real,   -46.806637_t_real &
       &,   -43.670459_t_real,   -39.959610_t_real,   -35.852694_t_real &
       &,   -31.573127_t_real,   -27.324217_t_real,   -23.288973_t_real &
       &,   -19.627537_t_real,   -16.433963_t_real,   -13.631290_t_real &
       &,   -11.184468_t_real,    -9.044836_t_real,    -7.215047_t_real &
       &,    -5.736076_t_real,    -4.578047_t_real,    -3.675130_t_real &
       &,    -2.974174_t_real,    -2.431893_t_real,    -2.006233_t_real &
       &,    -1.666452_t_real,    -1.394173_t_real,    -1.176384_t_real &
       &,    -1.001435_t_real,    -0.858601_t_real,    -0.738825_t_real &
       &,    -0.635274_t_real,    -0.543382_t_real,    -0.460509_t_real &
       &,    -0.385418_t_real,    -0.317741_t_real,    -0.257526_t_real &
       &,    -0.204903_t_real,    -0.159876_t_real,    -0.122228_t_real &
       &,    -0.091502_t_real,    -0.067042_t_real,    -0.048056_t_real &
       &,    -0.033691_t_real,    -0.023095_t_real,    -0.015477_t_real &
       &,    -0.010138_t_real,    -0.006490_t_real,    -0.004060_t_real &
       &,    -0.002481_t_real,    -0.001481_t_real/
  !!
  Data ncoefnrel( 53) / 50 /
  Data vcoefnrel(1:50, 53) /&
       &    -53.000000_t_real,   -52.955209_t_real,   -52.639594_t_real &
       &,   -51.776750_t_real,   -50.140163_t_real,   -47.674441_t_real &
       &,   -44.465272_t_real,   -40.671751_t_real,   -36.477122_t_real &
       &,   -32.112545_t_real,   -27.786784_t_real,   -23.687962_t_real &
       &,   -19.980495_t_real,   -16.741047_t_real,   -13.887739_t_real &
       &,   -11.395920_t_real,    -9.213406_t_real,    -7.361550_t_real &
       &,    -5.870053_t_real,    -4.693099_t_real,    -3.766657_t_real &
       &,    -3.043547_t_real,    -2.476993_t_real,    -2.025246_t_real &
       &,    -1.663406_t_real,    -1.376109_t_real,    -1.149499_t_real &
       &,    -0.969601_t_real,    -0.823642_t_real,    -0.701400_t_real &
       &,    -0.595692_t_real,    -0.502097_t_real,    -0.418296_t_real &
       &,    -0.343335_t_real,    -0.276977_t_real,    -0.219223_t_real &
       &,    -0.170010_t_real,    -0.129054_t_real,    -0.095818_t_real &
       &,    -0.069541_t_real,    -0.049311_t_real,    -0.034151_t_real &
       &,    -0.023093_t_real,    -0.015244_t_real,    -0.009822_t_real &
       &,    -0.006175_t_real,    -0.003788_t_real,    -0.002267_t_real &
       &,    -0.001323_t_real,    -0.000753_t_real/
  !!
  Data ncoefnrel( 54) / 50 /
  Data vcoefnrel(1:50, 54) /&
       &    -54.000000_t_real,   -53.954012_t_real,   -53.629943_t_real &
       &,   -52.744191_t_real,   -51.066043_t_real,   -48.541531_t_real &
       &,   -45.259140_t_real,   -41.382691_t_real,   -37.100400_t_real &
       &,   -32.650959_t_real,   -28.248887_t_real,   -24.087093_t_real &
       &,   -20.333199_t_real,   -17.044772_t_real,   -14.140483_t_real &
       &,   -11.601398_t_real,    -9.376673_t_real,    -7.502403_t_real &
       &,    -5.992577_t_real,    -4.790226_t_real,    -3.837919_t_real &
       &,    -3.089954_t_real,    -2.495364_t_real,    -2.017804_t_real &
       &,    -1.638211_t_real,    -1.341493_t_real,    -1.110989_t_real &
       &,    -0.929768_t_real,    -0.783193_t_real,    -0.660336_t_real &
       &,    -0.554059_t_real,    -0.460303_t_real,    -0.377116_t_real &
       &,    -0.303756_t_real,    -0.240004_t_real,    -0.185713_t_real &
       &,    -0.140560_t_real,    -0.103961_t_real,    -0.075085_t_real &
       &,    -0.052924_t_real,    -0.036390_t_real,    -0.024400_t_real &
       &,    -0.015950_t_real,    -0.010163_t_real,    -0.006311_t_real &
       &,    -0.003818_t_real,    -0.002250_t_real,    -0.001292_t_real &
       &,    -0.000722_t_real,    -0.000393_t_real/
  !!6s
  !!
  Data ncoefnrel( 55) / 50 /
  Data vcoefnrel(1:50, 55) /&
       &    -55.000000_t_real,   -54.952839_t_real,   -54.620491_t_real &
       &,   -53.712313_t_real,   -51.993648_t_real,   -49.412184_t_real &
       &,   -46.059441_t_real,   -42.104097_t_real,   -37.739857_t_real &
       &,   -33.212964_t_real,   -28.744166_t_real,   -24.531068_t_real &
       &,   -20.743252_t_real,   -17.418519_t_real,   -14.481155_t_real &
       &,   -11.913206_t_real,    -9.670646_t_real,    -7.798864_t_real &
       &,    -6.294437_t_real,    -5.095124_t_real,    -4.149246_t_real &
       &,    -3.404457_t_real,    -2.806589_t_real,    -2.323440_t_real &
       &,    -1.935475_t_real,    -1.624342_t_real,    -1.373100_t_real &
       &,    -1.170140_t_real,    -1.010479_t_real,    -0.892072_t_real &
       &,    -0.809351_t_real,    -0.751421_t_real,    -0.706761_t_real &
       &,    -0.667187_t_real,    -0.628099_t_real,    -0.587276_t_real &
       &,    -0.543881_t_real,    -0.497910_t_real,    -0.449908_t_real &
       &,    -0.400785_t_real,    -0.351667_t_real,    -0.303746_t_real &
       &,    -0.258147_t_real,    -0.215821_t_real,    -0.177475_t_real &
       &,    -0.143541_t_real,    -0.114188_t_real,    -0.089348_t_real &
       &,    -0.068769_t_real,    -0.052064_t_real/
  !!
  Data ncoefnrel( 56) / 50 /
  Data vcoefnrel(1:50, 56) /&
       &    -56.000000_t_real,   -55.951658_t_real,   -55.610974_t_real &
       &,   -54.680232_t_real,   -52.920879_t_real,   -50.282293_t_real &
       &,   -46.859081_t_real,   -42.824713_t_real,   -38.378721_t_real &
       &,   -33.774709_t_real,   -29.239857_t_real,   -24.976232_t_real &
       &,   -21.153682_t_real,   -17.790272_t_real,   -14.819754_t_real &
       &,   -12.220966_t_real,    -9.961396_t_real,    -8.089402_t_real &
       &,    -6.584468_t_real,    -5.384225_t_real,    -4.438498_t_real &
       &,    -3.685283_t_real,    -3.071478_t_real,    -2.568144_t_real &
       &,    -2.155169_t_real,    -1.816394_t_real,    -1.543131_t_real &
       &,    -1.332415_t_real,    -1.177202_t_real,    -1.061951_t_real &
       &,    -0.970137_t_real,    -0.890554_t_real,    -0.817057_t_real &
       &,    -0.746413_t_real,    -0.676897_t_real,    -0.607739_t_real &
       &,    -0.538929_t_real,    -0.471083_t_real,    -0.405259_t_real &
       &,    -0.342714_t_real,    -0.284674_t_real,    -0.232144_t_real &
       &,    -0.185792_t_real,    -0.145908_t_real,    -0.112429_t_real &
       &,    -0.084999_t_real,    -0.063049_t_real,    -0.045887_t_real &
       &,    -0.032768_t_real,    -0.022959_t_real/
  !!5d
  !!
  Data ncoefnrel( 57) / 50 /
  Data vcoefnrel(1:50, 57) /&
       &    -57.000000_t_real,   -56.950456_t_real,   -56.601287_t_real &
       &,   -55.647593_t_real,   -53.846886_t_real,   -51.150166_t_real &
       &,   -47.655077_t_real,   -43.539698_t_real,   -39.009621_t_real &
       &,   -34.325654_t_real,   -29.721577_t_real,   -25.403605_t_real &
       &,   -21.539735_t_real,   -18.129126_t_real,   -15.117381_t_real &
       &,   -12.477521_t_real,   -10.192054_t_real,    -8.305896_t_real &
       &,    -6.782307_t_real,    -5.561316_t_real,    -4.591063_t_real &
       &,    -3.804403_t_real,    -3.155625_t_real,    -2.621892_t_real &
       &,    -2.185654_t_real,    -1.833094_t_real,    -1.555660_t_real &
       &,    -1.344600_t_real,    -1.185331_t_real,    -1.060837_t_real &
       &,    -0.957712_t_real,    -0.867458_t_real,    -0.784959_t_real &
       &,    -0.707068_t_real,    -0.631936_t_real,    -0.558745_t_real &
       &,    -0.487535_t_real,    -0.418976_t_real,    -0.354095_t_real &
       &,    -0.293996_t_real,    -0.239633_t_real,    -0.191664_t_real &
       &,    -0.150384_t_real,    -0.115732_t_real,    -0.087348_t_real &
       &,    -0.064652_t_real,    -0.046927_t_real,    -0.033401_t_real &
       &,    -0.023314_t_real,    -0.015957_t_real/
  !!4f
  !!
  Data ncoefnrel( 58) / 50 /
  Data vcoefnrel(1:50, 58) /&
       &    -58.000000_t_real,   -57.949195_t_real,   -57.591126_t_real &
       &,   -56.613365_t_real,   -54.769219_t_real,   -52.010982_t_real &
       &,   -48.438965_t_real,   -44.235254_t_real,   -39.611113_t_real &
       &,   -34.833424_t_real,   -30.141342_t_real,   -25.744139_t_real &
       &,   -21.806945_t_real,   -18.315304_t_real,   -15.227848_t_real &
       &,   -12.514182_t_real,   -10.179192_t_real,    -8.266622_t_real &
       &,    -6.728906_t_real,    -5.502788_t_real,    -4.529281_t_real &
       &,    -3.740323_t_real,    -3.093490_t_real,    -2.565257_t_real &
       &,    -2.136195_t_real,    -1.791649_t_real,    -1.522575_t_real &
       &,    -1.319005_t_real,    -1.165203_t_real,    -1.044144_t_real &
       &,    -0.943075_t_real,    -0.854083_t_real,    -0.772400_t_real &
       &,    -0.695081_t_real,    -0.620410_t_real,    -0.547676_t_real &
       &,    -0.476996_t_real,    -0.409085_t_real,    -0.344982_t_real &
       &,    -0.285775_t_real,    -0.232381_t_real,    -0.185411_t_real &
       &,    -0.145115_t_real,    -0.111393_t_real,    -0.083854_t_real &
       &,    -0.061901_t_real,    -0.044807_t_real,    -0.031804_t_real &
       &,    -0.022135_t_real,    -0.015105_t_real/
  !!
  Data ncoefnrel( 59) / 50 /
  Data vcoefnrel(1:50, 59) /&
       &    -59.000000_t_real,   -58.947877_t_real,   -58.580513_t_real &
       &,   -57.577624_t_real,   -55.688061_t_real,   -52.865097_t_real &
       &,   -49.211361_t_real,   -44.912378_t_real,   -40.184717_t_real &
       &,   -35.300276_t_real,   -30.502458_t_real,   -26.002837_t_real &
       &,   -21.963267_t_real,   -18.360929_t_real,   -15.166861_t_real &
       &,   -12.352449_t_real,    -9.949848_t_real,    -8.004087_t_real &
       &,    -6.458969_t_real,    -5.241980_t_real,    -4.286251_t_real &
       &,    -3.523852_t_real,    -2.910494_t_real,    -2.417235_t_real &
       &,    -2.019299_t_real,    -1.698716_t_real,    -1.447057_t_real &
       &,    -1.258666_t_real,    -1.120816_t_real,    -1.015626_t_real &
       &,    -0.928559_t_real,    -0.850997_t_real,    -0.778347_t_real &
       &,    -0.708104_t_real,    -0.638916_t_real,    -0.570271_t_real &
       &,    -0.502365_t_real,    -0.435960_t_real,    -0.372166_t_real &
       &,    -0.312204_t_real,    -0.257185_t_real,    -0.207950_t_real &
       &,    -0.164992_t_real,    -0.128435_t_real,    -0.098081_t_real &
       &,    -0.073477_t_real,    -0.053998_t_real,    -0.038928_t_real &
       &,    -0.027530_t_real,    -0.019098_t_real/
  !!
  Data ncoefnrel( 60) / 50 /
  Data vcoefnrel(1:50, 60) /&
       &    -60.000000_t_real,   -59.946588_t_real,   -59.570126_t_real &
       &,   -58.542662_t_real,   -56.608857_t_real,   -53.723222_t_real &
       &,   -49.991050_t_real,   -45.601603_t_real,   -40.777518_t_real &
       &,   -35.796248_t_real,   -30.906344_t_real,   -26.322389_t_real &
       &,   -22.201088_t_real,   -18.512045_t_real,   -15.237572_t_real &
       &,   -12.352057_t_real,    -9.909389_t_real,    -7.945815_t_real &
       &,    -6.393881_t_real,    -5.176627_t_real,    -4.221842_t_real &
       &,    -3.461935_t_real,    -2.853944_t_real,    -2.367590_t_real &
       &,    -1.976740_t_real,    -1.663323_t_real,    -1.419126_t_real &
       &,    -1.237620_t_real,    -1.104739_t_real,    -1.002440_t_real &
       &,    -0.916901_t_real,    -0.840162_t_real,    -0.767995_t_real &
       &,    -0.698076_t_real,    -0.629156_t_real,    -0.560796_t_real &
       &,    -0.493254_t_real,    -0.427325_t_real,    -0.364132_t_real &
       &,    -0.304884_t_real,    -0.250661_t_real,    -0.202268_t_real &
       &,    -0.160154_t_real,    -0.124409_t_real,    -0.094805_t_real &
       &,    -0.070869_t_real,    -0.051966_t_real,    -0.037379_t_real &
       &,    -0.026373_t_real,    -0.018253_t_real/
  !!
  Data ncoefnrel( 61) / 50 /
  Data vcoefnrel(1:50, 61) /&
       &    -61.000000_t_real,   -60.945285_t_real,   -60.559630_t_real &
       &,   -59.507347_t_real,   -57.528918_t_real,   -54.580059_t_real &
       &,   -50.768734_t_real,   -46.287818_t_real,   -41.366192_t_real &
       &,   -36.286649_t_real,   -31.302723_t_real,   -26.632007_t_real &
       &,   -22.425053_t_real,   -18.647213_t_real,   -15.290424_t_real &
       &,   -12.336340_t_real,    -9.858004_t_real,    -7.879948_t_real &
       &,    -6.323918_t_real,    -5.108184_t_real,    -4.155899_t_real &
       &,    -3.400253_t_real,    -2.798918_t_real,    -2.320088_t_real &
       &,    -1.936525_t_real,    -1.630286_t_real,    -1.393377_t_real &
       &,    -1.218358_t_real,    -1.090000_t_real,    -0.990284_t_real &
       &,    -0.906111_t_real,    -0.830118_t_real,    -0.758398_t_real &
       &,    -0.688783_t_real,    -0.620119_t_real,    -0.552036_t_real &
       &,    -0.484843_t_real,    -0.419369_t_real,    -0.356745_t_real &
       &,    -0.298167_t_real,    -0.244689_t_real,    -0.197078_t_real &
       &,    -0.155745_t_real,    -0.120748_t_real,    -0.091832_t_real &
       &,    -0.068507_t_real,    -0.050131_t_real,    -0.035982_t_real &
       &,    -0.025333_t_real,    -0.017494_t_real/
  !!
  Data ncoefnrel( 62) / 50 /
  Data vcoefnrel(1:50, 62) /&
       &    -62.000000_t_real,   -61.943969_t_real,   -61.549026_t_real &
       &,   -60.471685_t_real,   -58.448257_t_real,   -55.435634_t_real &
       &,   -51.544453_t_real,   -46.971090_t_real,   -41.950829_t_real &
       &,   -36.771613_t_real,   -31.691782_t_real,   -26.931950_t_real &
       &,   -22.635735_t_real,   -18.767475_t_real,   -15.326999_t_real &
       &,   -12.307640_t_real,    -9.797991_t_real,    -7.808557_t_real &
       &,    -6.250798_t_real,    -5.038042_t_real,    -4.089590_t_real &
       &,    -3.339594_t_real,    -2.745796_t_real,    -2.274813_t_real &
       &,    -1.898571_t_real,    -1.599430_t_real,    -1.369591_t_real &
       &,    -1.200656_t_real,    -1.076401_t_real,    -0.978985_t_real &
       &,    -0.896026_t_real,    -0.820703_t_real,    -0.749390_t_real &
       &,    -0.680059_t_real,    -0.611636_t_real,    -0.543820_t_real &
       &,    -0.476964_t_real,    -0.411927_t_real,    -0.349847_t_real &
       &,    -0.291908_t_real,    -0.239135_t_real,    -0.192260_t_real &
       &,    -0.151661_t_real,    -0.117363_t_real,    -0.089088_t_real &
       &,    -0.066333_t_real,    -0.048444_t_real,    -0.034702_t_real &
       &,    -0.024381_t_real,    -0.016801_t_real/
  !!
  Data ncoefnrel( 63) / 50 /
  Data vcoefnrel(1:50, 63) /&
       &    -63.000000_t_real,   -62.942640_t_real,   -62.538317_t_real &
       &,   -61.435681_t_real,   -59.366885_t_real,   -56.289963_t_real &
       &,   -52.318232_t_real,   -47.651462_t_real,   -42.531480_t_real &
       &,   -37.251216_t_real,   -32.073628_t_real,   -27.222370_t_real &
       &,   -22.833589_t_real,   -18.873601_t_real,   -15.348665_t_real &
       &,   -12.267870_t_real,    -9.731116_t_real,    -7.733153_t_real &
       &,    -6.175708_t_real,    -4.967140_t_real,    -4.023665_t_real &
       &,    -3.280406_t_real,    -2.694730_t_real,    -2.231728_t_real &
       &,    -1.862741_t_real,    -1.570573_t_real,    -1.347557_t_real &
       &,    -1.184310_t_real,    -1.063773_t_real,    -0.968403_t_real &
       &,    -0.886524_t_real,    -0.811803_t_real,    -0.740861_t_real &
       &,    -0.671791_t_real,    -0.603599_t_real,    -0.536039_t_real &
       &,    -0.469511_t_real,    -0.404898_t_real,    -0.343343_t_real &
       &,    -0.286016_t_real,    -0.233917_t_real,    -0.187742_t_real &
       &,    -0.147838_t_real,    -0.114200_t_real,    -0.086530_t_real &
       &,    -0.064308_t_real,    -0.046877_t_real,    -0.033514_t_real &
       &,    -0.023500_t_real,    -0.016161_t_real/
  !!
  Data ncoefnrel( 64) / 50 /
  Data vcoefnrel(1:50, 64) /&
       &    -64.000000_t_real,   -63.941342_t_real,   -63.527860_t_real &
       &,   -62.400545_t_real,   -60.287676_t_real,   -57.148702_t_real &
       &,   -53.099989_t_real,   -48.345057_t_real,   -43.132985_t_real &
       &,   -37.762337_t_real,   -32.501395_t_real,   -27.577204_t_real &
       &,   -23.116772_t_real,   -19.090016_t_real,   -15.508098_t_real &
       &,   -12.396233_t_real,    -9.855708_t_real,    -7.858801_t_real &
       &,    -6.299359_t_real,    -5.084000_t_real,    -4.126833_t_real &
       &,    -3.366133_t_real,    -2.761960_t_real,    -2.281634_t_real &
       &,    -1.900144_t_real,    -1.602571_t_real,    -1.377553_t_real &
       &,    -1.209007_t_real,    -1.078320_t_real,    -0.970946_t_real &
       &,    -0.877867_t_real,    -0.793727_t_real,    -0.715164_t_real &
       &,    -0.640053_t_real,    -0.567271_t_real,    -0.496563_t_real &
       &,    -0.428370_t_real,    -0.363577_t_real,    -0.303231_t_real &
       &,    -0.248303_t_real,    -0.199514_t_real,    -0.157250_t_real &
       &,    -0.121542_t_real,    -0.092111_t_real,    -0.068440_t_real &
       &,    -0.049853_t_real,    -0.035599_t_real,    -0.024919_t_real &
       &,    -0.017099_t_real,    -0.011501_t_real/
  !!
  !!
  Data ncoefnrel( 65) / 50 /
  Data vcoefnrel(1:50, 65) /&
       &    -65.000000_t_real,   -64.939942_t_real,   -64.516585_t_real &
       &,   -63.362661_t_real,   -61.202035_t_real,   -57.994928_t_real &
       &,   -53.860021_t_real,   -49.003604_t_real,   -43.680923_t_real &
       &,   -38.194477_t_real,   -32.815910_t_real,   -27.774956_t_real &
       &,   -23.192350_t_real,   -19.045784_t_real,   -15.352149_t_real &
       &,   -12.161326_t_real,    -9.582104_t_real,    -7.574602_t_real &
       &,    -6.022795_t_real,    -4.825496_t_real,    -3.894779_t_real &
       &,    -3.167314_t_real,    -2.598836_t_real,    -2.151732_t_real &
       &,    -1.796865_t_real,    -1.518171_t_real,    -1.308018_t_real &
       &,    -1.155013_t_real,    -1.040891_t_real,    -0.948979_t_real &
       &,    -0.868924_t_real,    -0.795235_t_real,    -0.724943_t_real &
       &,    -0.656345_t_real,    -0.588583_t_real,    -0.521515_t_real &
       &,    -0.455619_t_real,    -0.391823_t_real,    -0.331274_t_real &
       &,    -0.275111_t_real,    -0.224283_t_real,    -0.179424_t_real &
       &,    -0.140818_t_real,    -0.108409_t_real,    -0.081858_t_real &
       &,    -0.060621_t_real,    -0.044030_t_real,    -0.031362_t_real &
       &,    -0.021908_t_real,    -0.015008_t_real/
  !!
  Data ncoefnrel( 66) / 50 /
  Data vcoefnrel(1:50, 66) /&
       &    -66.000000_t_real,   -65.938574_t_real,   -65.505563_t_real &
       &,   -64.325649_t_real,   -62.118568_t_real,   -58.845577_t_real &
       &,   -54.628044_t_real,   -49.675404_t_real,   -44.249731_t_real &
       &,   -38.658154_t_real,   -33.176400_t_real,   -28.037212_t_real &
       &,   -23.353957_t_real,   -19.112807_t_real,   -15.336223_t_real &
       &,   -12.097135_t_real,    -9.502039_t_real,    -7.493036_t_real &
       &,    -5.946076_t_real,    -4.755578_t_real,    -3.832368_t_real &
       &,    -3.113597_t_real,    -2.553916_t_real,    -2.114591_t_real &
       &,    -1.766538_t_real,    -1.494325_t_real,    -1.290204_t_real &
       &,    -1.141788_t_real,    -1.030429_t_real,    -0.939979_t_real &
       &,    -0.860698_t_real,    -0.787456_t_real,    -0.717451_t_real &
       &,    -0.649069_t_real,    -0.581509_t_real,    -0.514679_t_real &
       &,    -0.449091_t_real,    -0.385691_t_real,    -0.325626_t_real &
       &,    -0.270022_t_real,    -0.219798_t_real,    -0.175562_t_real &
       &,    -0.137567_t_real,    -0.105734_t_real,    -0.079705_t_real &
       &,    -0.058927_t_real,    -0.042725_t_real,    -0.030379_t_real &
       &,    -0.021183_t_real,    -0.014484_t_real/
  !!
  Data ncoefnrel( 67) / 50 /
  Data vcoefnrel(1:50, 67) /&
       &    -67.000000_t_real,   -66.937193_t_real,   -66.494438_t_real &
       &,   -65.288306_t_real,   -63.034410_t_real,   -59.695010_t_real &
       &,   -55.394155_t_real,   -50.344365_t_real,   -44.814596_t_real &
       &,   -39.116521_t_real,   -33.529804_t_real,   -28.290150_t_real &
       &,   -23.504152_t_real,   -19.167705_t_real,   -15.309918_t_real &
       &,   -12.027109_t_real,    -9.419356_t_real,    -7.410727_t_real &
       &,    -5.869699_t_real,    -4.686633_t_real,    -3.771526_t_real &
       &,    -3.061794_t_real,    -2.510910_t_real,    -2.079196_t_real &
       &,    -1.737782_t_real,    -1.471874_t_real,    -1.273518_t_real &
       &,    -1.129363_t_real,    -1.020510_t_real,    -0.931374_t_real &
       &,    -0.852792_t_real,    -0.779958_t_real,    -0.710221_t_real &
       &,    -0.642043_t_real,    -0.574680_t_real,    -0.508084_t_real &
       &,    -0.442800_t_real,    -0.379789_t_real,    -0.320199_t_real &
       &,    -0.265138_t_real,    -0.215501_t_real,    -0.171868_t_real &
       &,    -0.134463_t_real,    -0.103184_t_real,    -0.077657_t_real &
       &,    -0.057317_t_real,    -0.041487_t_real,    -0.029448_t_real &
       &,    -0.020497_t_real,    -0.013990_t_real/
  !!
  Data ncoefnrel( 68) / 50 /
  Data vcoefnrel(1:50, 68) /&
       &    -68.000000_t_real,   -67.935799_t_real,   -67.483210_t_real &
       &,   -66.250632_t_real,   -63.949565_t_real,   -60.543230_t_real &
       &,   -56.158355_t_real,   -51.010493_t_real,   -45.375513_t_real &
       &,   -39.569563_t_real,   -33.876123_t_real,   -28.533797_t_real &
       &,   -23.643243_t_real,   -19.210912_t_real,   -15.274210_t_real &
       &,   -11.952164_t_real,    -9.334702_t_real,    -7.328114_t_real &
       &,    -5.793938_t_real,    -4.618849_t_real,    -3.712340_t_real &
       &,    -3.011879_t_real,    -2.469728_t_real,    -2.045437_t_real &
       &,    -1.710483_t_real,    -1.450705_t_real,    -1.257849_t_real &
       &,    -1.117645_t_real,    -1.011068_t_real,    -0.923117_t_real &
       &,    -0.845171_t_real,    -0.772712_t_real,    -0.703224_t_real &
       &,    -0.635242_t_real,    -0.568070_t_real,    -0.501704_t_real &
       &,    -0.436720_t_real,    -0.374094_t_real,    -0.314969_t_real &
       &,    -0.260439_t_real,    -0.211374_t_real,    -0.168325_t_real &
       &,    -0.131491_t_real,    -0.100746_t_real,    -0.075702_t_real &
       &,    -0.055784_t_real,    -0.040310_t_real,    -0.028564_t_real &
       &,    -0.019847_t_real,    -0.013522_t_real/
  !!
  Data ncoefnrel( 69) / 50 /
  Data vcoefnrel(1:50, 69) /&
       &    -69.000000_t_real,   -68.934392_t_real,   -68.471879_t_real &
       &,   -67.212628_t_real,   -64.864034_t_real,   -61.390239_t_real &
       &,   -56.920640_t_real,   -51.673787_t_real,   -45.932471_t_real &
       &,   -40.017257_t_real,   -34.215353_t_real,   -28.768181_t_real &
       &,   -23.771524_t_real,   -19.242874_t_real,   -15.230020_t_real &
       &,   -11.873104_t_real,    -9.248622_t_real,    -7.245552_t_real &
       &,    -5.719006_t_real,    -4.552363_t_real,    -3.654856_t_real &
       &,    -2.963811_t_real,    -2.430278_t_real,    -2.013207_t_real &
       &,    -1.684541_t_real,    -1.430715_t_real,    -1.243098_t_real &
       &,    -1.106558_t_real,    -1.002049_t_real,    -0.915170_t_real &
       &,    -0.837803_t_real,    -0.765692_t_real,    -0.696439_t_real &
       &,    -0.628643_t_real,    -0.561659_t_real,    -0.495521_t_real &
       &,    -0.430834_t_real,    -0.368586_t_real,    -0.309919_t_real &
       &,    -0.255908_t_real,    -0.207401_t_real,    -0.164920_t_real &
       &,    -0.128638_t_real,    -0.098410_t_real,    -0.073831_t_real &
       &,    -0.054319_t_real,    -0.039187_t_real,    -0.027722_t_real &
       &,    -0.019229_t_real,    -0.013078_t_real/
  !!
  Data ncoefnrel( 70) / 50 /
  Data vcoefnrel(1:50, 70) /&
       &    -70.000000_t_real,   -69.932973_t_real,   -69.460446_t_real &
       &,   -68.174297_t_real,   -65.777820_t_real,   -62.236039_t_real &
       &,   -57.681007_t_real,   -52.334247_t_real,   -46.485459_t_real &
       &,   -40.459581_t_real,   -34.547488_t_real,   -28.993341_t_real &
       &,   -23.889269_t_real,   -19.264058_t_real,   -15.178213_t_real &
       &,   -11.790634_t_real,    -9.161574_t_real,    -7.163326_t_real &
       &,    -5.645065_t_real,    -4.487274_t_real,    -3.599093_t_real &
       &,    -2.917533_t_real,    -2.392468_t_real,    -1.982410_t_real &
       &,    -1.659861_t_real,    -1.411813_t_real,    -1.229179_t_real &
       &,    -1.096033_t_real,    -0.993408_t_real,    -0.907502_t_real &
       &,    -0.830665_t_real,    -0.758877_t_real,    -0.689846_t_real &
       &,    -0.622230_t_real,    -0.555429_t_real,    -0.489516_t_real &
       &,    -0.425123_t_real,    -0.363250_t_real,    -0.305033_t_real &
       &,    -0.251532_t_real,    -0.203569_t_real,    -0.161640_t_real &
       &,    -0.125895_t_real,    -0.096167_t_real,    -0.072038_t_real &
       &,    -0.052916_t_real,    -0.038115_t_real,    -0.026918_t_real &
       &,    -0.018640_t_real,    -0.012656_t_real/
  !!
  Data ncoefnrel( 71) / 50 /
  Data vcoefnrel(1:50, 71) /&
       &    -71.000000_t_real,   -70.931590_t_real,   -70.449304_t_real &
       &,   -69.136965_t_real,   -66.694078_t_real,   -63.086842_t_real &
       &,   -58.450356_t_real,   -53.009579_t_real,   -47.061715_t_real &
       &,   -40.936813_t_real,   -34.930142_t_real,   -29.288415_t_real &
       &,   -24.100224_t_real,   -19.405629_t_real,   -15.278707_t_real &
       &,   -11.890318_t_real,    -9.275572_t_real,    -7.288307_t_real &
       &,    -5.774669_t_real,    -4.613733_t_real,    -3.715715_t_real &
       &,    -3.019377_t_real,    -2.476588_t_real,    -2.050122_t_real &
       &,    -1.717182_t_real,    -1.464148_t_real,    -1.275228_t_real &
       &,    -1.130636_t_real,    -1.013719_t_real,    -0.913985_t_real &
       &,    -0.825330_t_real,    -0.743925_t_real,    -0.667209_t_real &
       &,    -0.593588_t_real,    -0.522357_t_real,    -0.453587_t_real &
       &,    -0.387914_t_real,    -0.326272_t_real,    -0.269633_t_real &
       &,    -0.218799_t_real,    -0.174277_t_real,    -0.136236_t_real &
       &,    -0.104520_t_real,    -0.078707_t_real,    -0.058187_t_real &
       &,    -0.042247_t_real,    -0.030138_t_real,    -0.021134_t_real &
       &,    -0.014578_t_real,    -0.009897_t_real/
  !!5d
  !!
  Data ncoefnrel( 72) / 50 /
  Data vcoefnrel(1:50, 72) /&
       &    -72.000000_t_real,   -71.930199_t_real,   -71.438094_t_real &
       &,   -70.099420_t_real,   -67.609926_t_real,   -63.936971_t_real &
       &,   -59.218727_t_real,   -53.683644_t_real,   -47.636521_t_real &
       &,   -41.412678_t_real,   -35.311848_t_real,   -29.582860_t_real &
       &,   -24.311803_t_real,   -19.549798_t_real,   -15.386010_t_real &
       &,   -11.998108_t_real,    -9.392766_t_real,    -7.407368_t_real &
       &,    -5.887024_t_real,    -4.710981_t_real,    -3.792905_t_real &
       &,    -3.075378_t_real,    -2.513486_t_real,    -2.073296_t_real &
       &,    -1.732712_t_real,    -1.474156_t_real,    -1.277759_t_real &
       &,    -1.124029_t_real,    -0.998494_t_real,    -0.891832_t_real &
       &,    -0.797954_t_real,    -0.712635_t_real,    -0.632988_t_real &
       &,    -0.557293_t_real,    -0.484872_t_real,    -0.415870_t_real &
       &,    -0.350954_t_real,    -0.291007_t_real,    -0.236861_t_real &
       &,    -0.189115_t_real,    -0.148048_t_real,    -0.113602_t_real &
       &,    -0.085423_t_real,    -0.062938_t_real,    -0.045431_t_real &
       &,    -0.032126_t_real,    -0.022254_t_real,    -0.015101_t_real &
       &,    -0.010038_t_real,    -0.006535_t_real/
  !!
  Data ncoefnrel( 73) / 50 /
  Data vcoefnrel(1:50, 73) /&
       &    -73.000000_t_real,   -72.928799_t_real,   -72.426818_t_real &
       &,   -71.061672_t_real,   -68.525385_t_real,   -64.786469_t_real &
       &,   -59.986185_t_real,   -54.356549_t_real,   -48.210024_t_real &
       &,   -41.887350_t_real,   -35.692783_t_real,   -29.876792_t_real &
       &,   -24.524131_t_real,   -19.696704_t_real,   -15.500007_t_real &
       &,   -12.112995_t_real,    -9.511770_t_real,    -7.520226_t_real &
       &,    -5.984391_t_real,    -4.785202_t_real,    -3.841813_t_real &
       &,    -3.101544_t_real,    -2.522285_t_real,    -2.071328_t_real &
       &,    -1.724809_t_real,    -1.461445_t_real,    -1.259658_t_real &
       &,    -1.100777_t_real,    -0.971288_t_real,    -0.861989_t_real &
       &,    -0.766448_t_real,    -0.680103_t_real,    -0.599913_t_real &
       &,    -0.524174_t_real,    -0.452294_t_real,    -0.384484_t_real &
       &,    -0.321409_t_real,    -0.263871_t_real,    -0.212557_t_real &
       &,    -0.167891_t_real,    -0.129972_t_real,    -0.098582_t_real &
       &,    -0.073243_t_real,    -0.053293_t_real,    -0.037971_t_real &
       &,    -0.026489_t_real,    -0.018092_t_real,    -0.012096_t_real &
       &,    -0.007916_t_real,    -0.005071_t_real/
  !!
  Data ncoefnrel( 74) / 50 /
  Data vcoefnrel(1:50, 74) /&
       &    -74.000000_t_real,   -73.927391_t_real,   -73.415476_t_real &
       &,   -72.023719_t_real,   -69.440450_t_real,   -65.635321_t_real &
       &,   -60.752699_t_real,   -55.028244_t_real,   -48.782148_t_real &
       &,   -42.360692_t_real,   -36.072723_t_real,   -30.169842_t_real &
       &,   -24.736705_t_real,   -19.845730_t_real,   -15.619557_t_real &
       &,   -12.232737_t_real,    -9.629803_t_real,    -7.624788_t_real &
       &,    -6.066243_t_real,    -4.838289_t_real,    -3.867184_t_real &
       &,    -3.104962_t_real,    -2.511089_t_real,    -2.052217_t_real &
       &,    -1.701744_t_real,    -1.435563_t_real,    -1.231284_t_real &
       &,    -1.070643_t_real,    -0.940339_t_real,    -0.830943_t_real &
       &,    -0.735706_t_real,    -0.649882_t_real,    -0.570412_t_real &
       &,    -0.495673_t_real,    -0.425160_t_real,    -0.359129_t_real &
       &,    -0.298220_t_real,    -0.243150_t_real,    -0.194482_t_real &
       &,    -0.152504_t_real,    -0.117188_t_real,    -0.088216_t_real &
       &,    -0.065036_t_real,    -0.046950_t_real,    -0.033183_t_real &
       &,    -0.022958_t_real,    -0.015548_t_real,    -0.010305_t_real &
       &,    -0.006685_t_real,    -0.004243_t_real/
  !!
  Data ncoefnrel( 75) / 50 /
  Data vcoefnrel(1:50, 75) /&
       &    -75.000000_t_real,   -74.925975_t_real,   -74.404066_t_real &
       &,   -72.985556_t_real,   -70.355110_t_real,   -66.483505_t_real &
       &,   -61.518226_t_real,   -55.698665_t_real,   -49.352793_t_real &
       &,   -42.832550_t_real,   -36.451424_t_real,   -30.461636_t_real &
       &,   -24.949018_t_real,   -19.996275_t_real,   -15.743489_t_real &
       &,   -12.355132_t_real,    -9.744329_t_real,    -7.719243_t_real &
       &,    -6.132027_t_real,    -4.871558_t_real,    -3.872310_t_real &
       &,    -3.090275_t_real,    -2.484984_t_real,    -2.021086_t_real &
       &,    -1.668977_t_real,    -1.402347_t_real,    -1.198179_t_real &
       &,    -1.038241_t_real,    -0.909116_t_real,    -0.801117_t_real &
       &,    -0.707288_t_real,    -0.622829_t_real,    -0.544741_t_real &
       &,    -0.471500_t_real,    -0.402687_t_real,    -0.338586_t_real &
       &,    -0.279810_t_real,    -0.227003_t_real,    -0.180636_t_real &
       &,    -0.140902_t_real,    -0.107689_t_real,    -0.080615_t_real &
       &,    -0.059094_t_real,    -0.042409_t_real,    -0.029792_t_real &
       &,    -0.020483_t_real,    -0.013782_t_real,    -0.009074_t_real &
       &,    -0.005845_t_real,    -0.003683_t_real/
  !!
  Data ncoefnrel( 76) / 50 /
  Data vcoefnrel(1:50, 76) /&
       &    -76.000000_t_real,   -75.924550_t_real,   -75.392589_t_real &
       &,   -73.947181_t_real,   -71.269355_t_real,   -67.331002_t_real &
       &,   -62.282728_t_real,   -56.367754_t_real,   -49.921876_t_real &
       &,   -43.302787_t_real,   -36.828667_t_real,   -30.751861_t_real &
       &,   -25.160627_t_real,   -20.147840_t_real,   -15.870707_t_real &
       &,   -12.478179_t_real,    -9.853266_t_real,    -7.802267_t_real &
       &,    -6.181491_t_real,    -4.886314_t_real,    -3.859964_t_real &
       &,    -3.061090_t_real,    -2.447778_t_real,    -1.981737_t_real &
       &,    -1.630353_t_real,    -1.365461_t_real,    -1.163436_t_real &
       &,    -1.005872_t_real,    -0.879162_t_real,    -0.773424_t_real &
       &,    -0.681613_t_real,    -0.598959_t_real,    -0.522562_t_real &
       &,    -0.451011_t_real,    -0.383964_t_real,    -0.321731_t_real &
       &,    -0.264908_t_real,    -0.214087_t_real,    -0.169676_t_real &
       &,    -0.131800_t_real,    -0.100295_t_real,    -0.074741_t_real &
       &,    -0.054530_t_real,    -0.038943_t_real,    -0.027218_t_real &
       &,    -0.018614_t_real,    -0.012456_t_real,    -0.008154_t_real &
       &,    -0.005221_t_real,    -0.003270_t_real/
  !!
  Data ncoefnrel( 77) / 50 /
  Data vcoefnrel(1:50, 77) /&
       &    -77.000000_t_real,   -76.923117_t_real,   -76.381041_t_real &
       &,   -74.908590_t_real,   -72.183179_t_real,   -68.177796_t_real &
       &,   -63.046174_t_real,   -57.035463_t_real,   -50.489325_t_real &
       &,   -43.771291_t_real,   -37.204267_t_real,   -31.040259_t_real &
       &,   -25.371162_t_real,   -20.300016_t_real,   -16.000196_t_real &
       &,   -12.600094_t_real,    -9.954968_t_real,    -7.872950_t_real &
       &,    -6.214676_t_real,    -4.883966_t_real,    -3.832665_t_real &
       &,    -3.020430_t_real,    -2.402516_t_real,    -1.937075_t_real &
       &,    -1.588567_t_real,    -1.327209_t_real,    -1.128792_t_real &
       &,    -0.974692_t_real,    -0.851137_t_real,    -0.748142_t_real &
       &,    -0.658658_t_real,    -0.578001_t_real,    -0.503397_t_real &
       &,    -0.433550_t_real,    -0.368196_t_real,    -0.307678_t_real &
       &,    -0.252588_t_real,    -0.203485_t_real,    -0.160731_t_real &
       &,    -0.124410_t_real,    -0.094319_t_real,    -0.070013_t_real &
       &,    -0.050872_t_real,    -0.036175_t_real,    -0.025171_t_real &
       &,    -0.017135_t_real,    -0.011410_t_real,    -0.007432_t_real &
       &,    -0.004735_t_real,    -0.002949_t_real/
  !!
  Data ncoefnrel( 78) / 50 /
  Data vcoefnrel(1:50, 78) /&
       &    -78.000000_t_real,   -77.921652_t_real,   -77.369242_t_real &
       &,   -75.869164_t_real,   -73.095100_t_real,   -69.020962_t_real &
       &,   -63.803437_t_real,   -57.693558_t_real,   -51.042828_t_real &
       &,   -44.220649_t_real,   -37.554484_t_real,   -31.295314_t_real &
       &,   -25.539672_t_real,   -20.400850_t_real,   -16.066772_t_real &
       &,   -12.640456_t_real,    -9.951771_t_real,    -7.814084_t_real &
       &,    -6.094930_t_real,    -4.712017_t_real,    -3.629467_t_real &
       &,    -2.808678_t_real,    -2.199472_t_real,    -1.751898_t_real &
       &,    -1.423631_t_real,    -1.181356_t_real,    -0.999889_t_real &
       &,    -0.860731_t_real,    -0.750568_t_real,    -0.659955_t_real &
       &,    -0.582325_t_real,    -0.513292_t_real,    -0.450143_t_real &
       &,    -0.391418_t_real,    -0.336545_t_real,    -0.285516_t_real &
       &,    -0.238614_t_real,    -0.196205_t_real,    -0.158588_t_real &
       &,    -0.125915_t_real,    -0.098151_t_real,    -0.075082_t_real &
       &,    -0.056345_t_real,    -0.041470_t_real,    -0.029928_t_real &
       &,    -0.021174_t_real,    -0.014684_t_real,    -0.009980_t_real &
       &,    -0.006646_t_real,    -0.004337_t_real/
  !!
  Data ncoefnrel( 79) / 50 /
  Data vcoefnrel(1:50, 79) /&
       &    -79.000000_t_real,   -78.920200_t_real,   -78.357542_t_real &
       &,   -76.830096_t_real,   -74.007967_t_real,   -69.866124_t_real &
       &,   -64.564362_t_real,   -58.357868_t_real,   -51.606074_t_real &
       &,   -44.684329_t_real,   -37.924840_t_real,   -31.577486_t_real &
       &,   -25.744597_t_real,   -20.550016_t_real,   -16.193958_t_real &
       &,   -12.750592_t_real,   -10.029514_t_real,    -7.851525_t_real &
       &,    -6.089083_t_real,    -4.672497_t_real,    -3.572389_t_real &
       &,    -2.747157_t_real,    -2.141190_t_real,    -1.700098_t_real &
       &,    -1.378814_t_real,    -1.142775_t_real,    -0.966505_t_real &
       &,    -0.831650_t_real,    -0.725130_t_real,    -0.637689_t_real &
       &,    -0.562881_t_real,    -0.496393_t_real,    -0.435549_t_real &
       &,    -0.378911_t_real,    -0.325921_t_real,    -0.276578_t_real &
       &,    -0.231174_t_real,    -0.190081_t_real,    -0.153609_t_real &
       &,    -0.121917_t_real,    -0.094985_t_real,    -0.072611_t_real &
       &,    -0.054446_t_real,    -0.040035_t_real,    -0.028862_t_real &
       &,    -0.020396_t_real,    -0.014126_t_real,    -0.009588_t_real &
       &,    -0.006376_t_real,    -0.004154_t_real/
  !!
  Data ncoefnrel( 80) / 50 /
  Data vcoefnrel(1:50, 80) /&
       &    -80.000000_t_real,   -79.918764_t_real,   -79.345977_t_real &
       &,   -77.791505_t_real,   -74.922064_t_real,   -70.713839_t_real &
       &,   -65.329915_t_real,   -59.029934_t_real,   -52.181349_t_real &
       &,   -45.165551_t_real,   -38.319709_t_real,   -31.892627_t_real &
       &,   -25.993479_t_real,   -20.757025_t_real,   -16.392981_t_real &
       &,   -12.944209_t_real,   -10.205743_t_real,    -8.006004_t_real &
       &,    -6.220599_t_real,    -4.789758_t_real,    -3.683620_t_real &
       &,    -2.853732_t_real,    -2.240650_t_real,    -1.790417_t_real &
       &,    -1.459940_t_real,    -1.215950_t_real,    -1.033093_t_real &
       &,    -0.892413_t_real,    -0.780043_t_real,    -0.686106_t_real &
       &,    -0.603873_t_real,    -0.529103_t_real,    -0.459483_t_real &
       &,    -0.394103_t_real,    -0.332963_t_real,    -0.276548_t_real &
       &,    -0.225483_t_real,    -0.180294_t_real,    -0.141269_t_real &
       &,    -0.108411_t_real,    -0.081449_t_real,    -0.059887_t_real &
       &,    -0.043085_t_real,    -0.030322_t_real,    -0.020873_t_real &
       &,    -0.014052_t_real,    -0.009250_t_real,    -0.005954_t_real &
       &,    -0.003746_t_real,    -0.002304_t_real/
  !!6p
  !!
  Data ncoefnrel( 81) / 50 /
  Data vcoefnrel(1:50, 81) /&
       &    -81.000000_t_real,   -80.917335_t_real,   -80.334457_t_real &
       &,   -78.753081_t_real,   -75.836638_t_real,   -71.562601_t_real &
       &,   -66.097431_t_real,   -59.705445_t_real,   -52.762189_t_real &
       &,   -45.655199_t_real,   -38.726680_t_real,   -32.224287_t_real &
       &,   -26.264894_t_real,   -20.994609_t_real,   -16.629393_t_real &
       &,   -13.178967_t_real,   -10.428666_t_real,    -8.214122_t_real &
       &,    -6.415199_t_real,    -4.981214_t_real,    -3.878216_t_real &
       &,    -3.049122_t_real,    -2.430707_t_real,    -1.970090_t_real &
       &,    -1.626459_t_real,    -1.367974_t_real,    -1.170206_t_real &
       &,    -1.015285_t_real,    -0.890575_t_real,    -0.787233_t_real &
       &,    -0.699088_t_real,    -0.621885_t_real,    -0.552745_t_real &
       &,    -0.489763_t_real,    -0.431726_t_real,    -0.377900_t_real &
       &,    -0.327907_t_real,    -0.281612_t_real,    -0.239050_t_real &
       &,    -0.200336_t_real,    -0.165595_t_real,    -0.134905_t_real &
       &,    -0.108256_t_real,    -0.085530_t_real,    -0.066512_t_real &
       &,    -0.050896_t_real,    -0.038316_t_real,    -0.028376_t_real &
       &,    -0.020669_t_real,    -0.014806_t_real/
  !!
  Data ncoefnrel( 82) / 50 /
  Data vcoefnrel(1:50, 82) /&
       &    -82.000000_t_real,   -81.915898_t_real,   -81.322883_t_real &
       &,   -79.714497_t_real,   -76.750919_t_real,   -72.410915_t_real &
       &,   -66.864342_t_real,   -60.380337_t_real,   -53.342525_t_real &
       &,   -46.144581_t_real,   -39.133749_t_real,   -32.556507_t_real &
       &,   -26.538071_t_real,   -21.236224_t_real,   -16.869420_t_real &
       &,   -13.413436_t_real,   -10.648730_t_real,    -8.416557_t_real &
       &,    -6.601987_t_real,    -5.161091_t_real,    -4.053005_t_real &
       &,    -3.213543_t_real,    -2.579729_t_real,    -2.102213_t_real &
       &,    -1.741636_t_real,    -1.465899_t_real,    -1.250949_t_real &
       &,    -1.079972_t_real,    -0.941106_t_real,    -0.825611_t_real &
       &,    -0.726920_t_real,    -0.640212_t_real,    -0.562135_t_real &
       &,    -0.490563_t_real,    -0.424334_t_real,    -0.362985_t_real &
       &,    -0.306501_t_real,    -0.255093_t_real,    -0.209021_t_real &
       &,    -0.168471_t_real,    -0.133478_t_real,    -0.103902_t_real &
       &,    -0.079432_t_real,    -0.059620_t_real,    -0.043926_t_real &
       &,    -0.031762_t_real,    -0.022535_t_real,    -0.015688_t_real &
       &,    -0.010714_t_real,    -0.007177_t_real/
  !!
  Data ncoefnrel( 83) / 50 /
  Data vcoefnrel(1:50, 83) /&
       &    -83.000000_t_real,   -82.914455_t_real,   -82.311260_t_real &
       &,   -80.675765_t_real,   -77.664932_t_real,   -73.258830_t_real &
       &,   -67.630727_t_real,   -61.054737_t_real,   -53.922537_t_real &
       &,   -46.633948_t_real,   -39.541230_t_real,   -32.889742_t_real &
       &,   -26.813561_t_real,   -21.482434_t_real,   -17.113274_t_real &
       &,   -13.648139_t_real,   -10.866889_t_real,    -8.614449_t_real &
       &,    -6.782315_t_real,    -5.330430_t_real,    -4.209635_t_real &
       &,    -3.351821_t_real,    -2.697713_t_real,    -2.200752_t_real &
       &,    -1.820556_t_real,    -1.524891_t_real,    -1.291448_t_real &
       &,    -1.104821_t_real,    -0.953311_t_real,    -0.827540_t_real &
       &,    -0.720150_t_real,    -0.625760_t_real,    -0.540814_t_real &
       &,    -0.463273_t_real,    -0.392214_t_real,    -0.327428_t_real &
       &,    -0.269066_t_real,    -0.217360_t_real,    -0.172445_t_real &
       &,    -0.134260_t_real,    -0.102523_t_real,    -0.076751_t_real &
       &,    -0.056310_t_real,    -0.040478_t_real,    -0.028503_t_real &
       &,    -0.019658_t_real,    -0.013276_t_real,    -0.008779_t_real &
       &,    -0.005684_t_real,    -0.003602_t_real/
  !!
  Data ncoefnrel( 84) / 50 /
  Data vcoefnrel(1:50, 84) /&
       &    -84.000000_t_real,   -83.913007_t_real,   -83.299587_t_real &
       &,   -81.636885_t_real,   -78.578681_t_real,   -74.106353_t_real &
       &,   -68.396594_t_real,   -61.728653_t_real,   -54.502236_t_real &
       &,   -47.123303_t_real,   -39.949094_t_real,   -33.223996_t_real &
       &,   -27.091341_t_real,   -21.733035_t_real,   -17.360262_t_real &
       &,   -13.882589_t_real,   -11.082725_t_real,    -8.807385_t_real &
       &,    -6.955612_t_real,    -5.488152_t_real,    -4.347784_t_real &
       &,    -3.466490_t_real,    -2.789955_t_real,    -2.271372_t_real &
       &,    -1.868871_t_real,    -1.552351_t_real,    -1.301972_t_real &
       &,    -1.102790_t_real,    -0.942130_t_real,    -0.809331_t_real &
       &,    -0.696117_t_real,    -0.596715_t_real,    -0.507587_t_real &
       &,    -0.426909_t_real,    -0.353997_t_real,    -0.288776_t_real &
       &,    -0.231378_t_real,    -0.181874_t_real,    -0.140125_t_real &
       &,    -0.105748_t_real,    -0.078128_t_real,    -0.056487_t_real &
       &,    -0.039954_t_real,    -0.027640_t_real,    -0.018698_t_real &
       &,    -0.012367_t_real,    -0.007997_t_real,    -0.005054_t_real &
       &,    -0.003121_t_real,    -0.001884_t_real/
  !!
  Data ncoefnrel( 85) / 50 /
  Data vcoefnrel(1:50, 85) /&
       &    -85.000000_t_real,   -84.911551_t_real,   -84.287864_t_real &
       &,   -82.597857_t_real,   -79.492163_t_real,   -74.953479_t_real &
       &,   -69.161934_t_real,   -62.402068_t_real,   -55.081591_t_real &
       &,   -47.612597_t_real,   -40.357244_t_real,   -33.559171_t_real &
       &,   -27.371263_t_real,   -21.987635_t_real,   -17.609526_t_real &
       &,   -14.116158_t_real,   -11.295518_t_real,    -8.994675_t_real &
       &,    -7.120899_t_real,    -5.632926_t_real,    -4.467285_t_real &
       &,    -3.559752_t_real,    -2.859376_t_real,    -2.316604_t_real &
       &,    -1.890505_t_real,    -1.554809_t_real,    -1.291145_t_real &
       &,    -1.083479_t_real,    -0.917253_t_real,    -0.780325_t_real &
       &,    -0.663687_t_real,    -0.561447_t_real,    -0.470267_t_real &
       &,    -0.388591_t_real,    -0.315906_t_real,    -0.252152_t_real &
       &,    -0.197316_t_real,    -0.151212_t_real,    -0.113390_t_real &
       &,    -0.083149_t_real,    -0.059596_t_real,    -0.041734_t_real &
       &,    -0.028546_t_real,    -0.019067_t_real,    -0.012435_t_real &
       &,    -0.007916_t_real,    -0.004919_t_real,    -0.002983_t_real &
       &,    -0.001765_t_real,    -0.001019_t_real/
  !!
  Data ncoefnrel( 86) / 50 /
  Data vcoefnrel(1:50, 86) /&
       &    -86.000000_t_real,   -85.910090_t_real,   -85.276092_t_real &
       &,   -83.558682_t_real,   -80.405377_t_real,   -75.800201_t_real &
       &,   -69.926734_t_real,   -63.074959_t_real,   -55.660564_t_real &
       &,   -48.101769_t_real,   -40.765567_t_real,   -33.895153_t_real &
       &,   -27.653166_t_real,   -22.245796_t_real,   -17.860220_t_real &
       &,   -14.348262_t_real,   -11.504514_t_real,    -9.175632_t_real &
       &,    -7.277145_t_real,    -5.763652_t_real,    -4.568514_t_real &
       &,    -3.633472_t_real,    -2.907412_t_real,    -2.338402_t_real &
       &,    -1.889647_t_real,    -1.538413_t_real,    -1.265869_t_real &
       &,    -1.053573_t_real,    -0.884706_t_real,    -0.745825_t_real &
       &,    -0.627533_t_real,    -0.524076_t_real,    -0.432431_t_real &
       &,    -0.351291_t_real,    -0.280231_t_real,    -0.219102_t_real &
       &,    -0.167672_t_real,    -0.125462_t_real,    -0.091721_t_real &
       &,    -0.065473_t_real,    -0.045613_t_real,    -0.031003_t_real &
       &,    -0.020553_t_real,    -0.013286_t_real,    -0.008374_t_real &
       &,    -0.005145_t_real,    -0.003081_t_real,    -0.001798_t_real &
       &,    -0.001022_t_real,    -0.000566_t_real/
  !!7s
  !!
  Data ncoefnrel( 87) / 50 /
  Data vcoefnrel(1:50, 87) /&
       &    -87.000000_t_real,   -86.908653_t_real,   -86.264509_t_real &
       &,   -84.520169_t_real,   -81.320246_t_real,   -76.650279_t_real &
       &,   -70.697469_t_real,   -63.757570_t_real,   -56.254419_t_real &
       &,   -48.612530_t_real,   -41.203784_t_real,   -34.271491_t_real &
       &,   -27.988353_t_real,   -22.572429_t_real,   -18.193111_t_real &
       &,   -14.678522_t_real,   -11.830121_t_real,    -9.494275_t_real &
       &,    -7.594413_t_real,    -6.080326_t_real,    -4.885250_t_real &
       &,    -3.953908_t_real,    -3.228689_t_real,    -2.655021_t_real &
       &,    -2.197826_t_real,    -1.833249_t_real,    -1.540929_t_real &
       &,    -1.304754_t_real,    -1.115312_t_real,    -0.969071_t_real &
       &,    -0.863053_t_real,    -0.789356_t_real,    -0.736170_t_real &
       &,    -0.692906_t_real,    -0.652701_t_real,    -0.611906_t_real &
       &,    -0.568895_t_real,    -0.523238_t_real,    -0.475241_t_real &
       &,    -0.425692_t_real,    -0.375675_t_real,    -0.326404_t_real &
       &,    -0.279072_t_real,    -0.234731_t_real,    -0.194202_t_real &
       &,    -0.158031_t_real,    -0.126486_t_real,    -0.099582_t_real &
       &,    -0.077121_t_real,    -0.058753_t_real/
  !!
  Data ncoefnrel( 88) / 50 /
  Data vcoefnrel(1:50, 88) /&
       &    -88.000000_t_real,   -87.907209_t_real,   -87.252880_t_real &
       &,   -85.481517_t_real,   -82.234868_t_real,   -77.499994_t_real &
       &,   -71.467719_t_real,   -64.439721_t_real,   -56.847966_t_real &
       &,   -49.123245_t_real,   -41.642198_t_real,   -34.648691_t_real &
       &,   -28.325550_t_real,   -22.902064_t_real,   -18.526294_t_real &
       &,   -15.006607_t_real,   -12.150550_t_real,    -9.804878_t_real &
       &,    -7.899752_t_real,    -6.380156_t_real,    -5.181362_t_real &
       &,    -4.246960_t_real,    -3.511254_t_real,    -2.919711_t_real &
       &,    -2.439001_t_real,    -2.046160_t_real,    -1.725727_t_real &
       &,    -1.470886_t_real,    -1.277970_t_real,    -1.136719_t_real &
       &,    -1.030184_t_real,    -0.943078_t_real,    -0.865769_t_real &
       &,    -0.793062_t_real,    -0.722236_t_real,    -0.651958_t_real &
       &,    -0.581843_t_real,    -0.512252_t_real,    -0.444108_t_real &
       &,    -0.378655_t_real,    -0.317207_t_real,    -0.260930_t_real &
       &,    -0.210682_t_real,    -0.166943_t_real,    -0.129810_t_real &
       &,    -0.099045_t_real,    -0.074157_t_real,    -0.054485_t_real &
       &,    -0.039285_t_real,    -0.027798_t_real/
  !!6d
  Data ncoefnrel( 89) / 50 /
  Data vcoefnrel(1:50, 89) /&
       &    -89.000000_t_real,   -88.905749_t_real,   -88.241115_t_real &
       &,   -86.442431_t_real,   -83.148535_t_real,   -78.347946_t_real &
       &,   -72.235025_t_real,   -65.117458_t_real,   -57.435311_t_real &
       &,   -49.625591_t_real,   -42.069422_t_real,   -35.011635_t_real &
       &,   -28.645166_t_real,   -23.209598_t_real,   -18.828404_t_real &
       &,   -15.294100_t_real,   -12.419172_t_real,   -10.052300_t_real &
       &,    -8.128516_t_real,    -6.587211_t_real,    -5.365867_t_real &
       &,    -4.405587_t_real,    -3.637080_t_real,    -3.011240_t_real &
       &,    -2.500154_t_real,    -2.084455_t_real,    -1.751268_t_real &
       &,    -1.492234_t_real,    -1.296553_t_real,    -1.147986_t_real &
       &,    -1.030031_t_real,    -0.930603_t_real,    -0.842169_t_real &
       &,    -0.760181_t_real,    -0.681929_t_real,    -0.606001_t_real &
       &,    -0.532017_t_real,    -0.460388_t_real,    -0.392037_t_real &
       &,    -0.328097_t_real,    -0.269643_t_real,    -0.217499_t_real &
       &,    -0.172133_t_real,    -0.133639_t_real,    -0.101769_t_real &
       &,    -0.076014_t_real,    -0.055688_t_real,    -0.040014_t_real &
       &,    -0.028200_t_real,    -0.019493_t_real/
  !!5f
  !!
  Data ncoefnrel( 90) / 50 /
  Data vcoefnrel(1:50, 90) /&
       &    -90.000000_t_real,   -89.904281_t_real,   -89.229289_t_real &
       &,   -87.403156_t_real,   -84.061833_t_real,   -79.195288_t_real &
       &,   -73.001407_t_real,   -65.794018_t_real,   -58.021287_t_real &
       &,   -50.126412_t_real,   -42.494799_t_real,   -35.372767_t_real &
       &,   -28.963359_t_real,   -23.515237_t_real,   -19.124668_t_real &
       &,   -15.572447_t_real,   -12.674402_t_real,   -10.282596_t_real &
       &,    -8.334737_t_real,    -6.765598_t_real,    -5.516091_t_real &
       &,    -4.523231_t_real,    -3.717416_t_real,    -3.057200_t_real &
       &,    -2.519614_t_real,    -2.087110_t_real,    -1.745988_t_real &
       &,    -1.483575_t_real,    -1.284036_t_real,    -1.129609_t_real &
       &,    -1.005110_t_real,    -0.899806_t_real,    -0.806637_t_real &
       &,    -0.721043_t_real,    -0.640235_t_real,    -0.562811_t_real &
       &,    -0.488453_t_real,    -0.417616_t_real,    -0.351179_t_real &
       &,    -0.290127_t_real,    -0.235305_t_real,    -0.187259_t_real &
       &,    -0.146182_t_real,    -0.111918_t_real,    -0.084026_t_real &
       &,    -0.061858_t_real,    -0.044652_t_real,    -0.031603_t_real &
       &,    -0.021931_t_real,    -0.014921_t_real/
  !!
  Data ncoefnrel( 91) / 50 /
  Data vcoefnrel(1:50, 91) /&
       &    -91.000000_t_real,   -90.902740_t_real,   -90.216878_t_real &
       &,   -88.361926_t_real,   -84.970556_t_real,   -80.033725_t_real &
       &,   -73.752271_t_real,   -66.445569_t_real,   -58.568876_t_real &
       &,   -50.570782_t_real,   -42.841498_t_real,   -35.631038_t_real &
       &,   -29.152018_t_real,   -23.659257_t_real,   -19.217967_t_real &
       &,   -15.598261_t_real,   -12.621265_t_real,   -10.154250_t_real &
       &,    -8.153068_t_real,    -6.557509_t_real,    -5.302522_t_real &
       &,    -4.317400_t_real,    -3.532456_t_real,    -2.902270_t_real &
       &,    -2.396268_t_real,    -1.991222_t_real,    -1.672042_t_real &
       &,    -1.428134_t_real,    -1.245613_t_real,    -1.106463_t_real &
       &,    -0.994563_t_real,    -0.898973_t_real,    -0.813061_t_real &
       &,    -0.732836_t_real,    -0.655946_t_real,    -0.581244_t_real &
       &,    -0.508548_t_real,    -0.438398_t_real,    -0.371769_t_real &
       &,    -0.309781_t_real,    -0.253442_t_real,    -0.203485_t_real &
       &,    -0.160282_t_real,    -0.123840_t_real,    -0.093846_t_real &
       &,    -0.069747_t_real,    -0.050838_t_real,    -0.036340_t_real &
       &,    -0.025476_t_real,    -0.017514_t_real/
  !!
  Data ncoefnrel( 92) / 50 /
  Data vcoefnrel(1:50, 92) /&
       &    -92.000000_t_real,   -91.901221_t_real,   -91.204637_t_real &
       &,   -89.321289_t_real,   -85.880769_t_real,   -80.875215_t_real &
       &,   -74.508641_t_real,   -67.106397_t_real,   -59.131212_t_real &
       &,   -51.037418_t_real,   -43.219764_t_real,   -35.931841_t_real &
       &,   -29.395930_t_real,   -23.871603_t_real,   -19.392359_t_real &
       &,   -15.723133_t_real,   -12.688967_t_real,   -10.171014_t_real &
       &,    -8.134211_t_real,    -6.517064_t_real,    -5.250588_t_real &
       &,    -4.258755_t_real,    -3.472216_t_real,    -2.845421_t_real &
       &,    -2.345599_t_real,    -1.947916_t_real,    -1.636672_t_real &
       &,    -1.400476_t_real,    -1.224234_t_real,    -1.089400_t_real &
       &,    -0.980217_t_real,    -0.886322_t_real,    -0.801506_t_real &
       &,    -0.722031_t_real,    -0.645710_t_real,    -0.571514_t_real &
       &,    -0.499345_t_real,    -0.429797_t_real,    -0.363863_t_real &
       &,    -0.302656_t_real,    -0.247158_t_real,    -0.198065_t_real &
       &,    -0.155712_t_real,    -0.120072_t_real,    -0.090808_t_real &
       &,    -0.067352_t_real,    -0.048989_t_real,    -0.034944_t_real &
       &,    -0.024443_t_real,    -0.016767_t_real/
  !!
  Data ncoefnrel( 93) / 50 /
  Data vcoefnrel(1:50, 93) /&
       &    -93.000000_t_real,   -92.899691_t_real,   -92.192318_t_real &
       &,   -90.280411_t_real,   -86.790483_t_real,   -81.715837_t_real &
       &,   -75.263619_t_real,   -67.765249_t_real,   -59.690852_t_real &
       &,   -51.500490_t_real,   -43.593458_t_real,   -36.227546_t_real &
       &,   -29.634544_t_real,   -24.076509_t_real,   -19.554449_t_real &
       &,   -15.831843_t_real,   -12.737666_t_real,   -10.169635_t_real &
       &,    -8.100181_t_real,    -6.465189_t_real,    -5.190515_t_real &
       &,    -4.195420_t_real,    -3.410629_t_real,    -2.789563_t_real &
       &,    -2.297177_t_real,    -1.907404_t_real,    -1.604218_t_real &
       &,    -1.375533_t_real,    -1.205180_t_real,    -1.074274_t_real &
       &,    -0.967513_t_real,    -0.875108_t_real,    -0.791241_t_real &
       &,    -0.712410_t_real,    -0.636577_t_real,    -0.562821_t_real &
       &,    -0.491118_t_real,    -0.422106_t_real,    -0.356796_t_real &
       &,    -0.296291_t_real,    -0.241548_t_real,    -0.193231_t_real &
       &,    -0.151640_t_real,    -0.116719_t_real,    -0.088108_t_real &
       &,    -0.065224_t_real,    -0.047350_t_real,    -0.033707_t_real &
       &,    -0.023531_t_real,    -0.016107_t_real/
  !!
  Data ncoefnrel( 94) / 50 /
  Data vcoefnrel(1:50, 94) /&
       &    -94.000000_t_real,   -93.898119_t_real,   -93.179655_t_real &
       &,   -91.238395_t_real,   -87.697566_t_real,   -82.551383_t_real &
       &,   -76.009816_t_real,   -68.410091_t_real,   -60.229233_t_real &
       &,   -51.932722_t_real,   -43.924745_t_real,   -36.468364_t_real &
       &,   -29.804363_t_real,   -24.194063_t_real,   -19.605075_t_real &
       &,   -15.801843_t_real,   -12.619906_t_real,    -9.980481_t_real &
       &,    -7.868528_t_real,    -6.217871_t_real,    -4.946265_t_real &
       &,    -3.968249_t_real,    -3.212022_t_real,    -2.625198_t_real &
       &,    -2.165923_t_real,    -1.803032_t_real,    -1.519352_t_real &
       &,    -1.306551_t_real,    -1.152727_t_real,    -1.038994_t_real &
       &,    -0.947919_t_real,    -0.868529_t_real,    -0.794990_t_real &
       &,    -0.724242_t_real,    -0.654673_t_real,    -0.585619_t_real &
       &,    -0.517177_t_real,    -0.450043_t_real,    -0.385308_t_real &
       &,    -0.324211_t_real,    -0.267910_t_real,    -0.217313_t_real &
       &,    -0.172978_t_real,    -0.135093_t_real,    -0.103509_t_real &
       &,    -0.077805_t_real,    -0.057375_t_real,    -0.041507_t_real &
       &,    -0.029458_t_real,    -0.020511_t_real/
  !!
  Data ncoefnrel( 95) / 50 /
  Data vcoefnrel(1:50, 95) /&
       &    -95.000000_t_real,   -94.896569_t_real,   -94.167176_t_real &
       &,   -92.197018_t_real,   -88.606242_t_real,   -83.390184_t_real &
       &,   -76.761864_t_real,   -69.064740_t_real,   -60.783088_t_real &
       &,   -52.388143_t_real,   -44.288735_t_real,   -36.753194_t_real &
       &,   -30.031387_t_real,   -24.381905_t_real,   -19.740472_t_real &
       &,   -15.876420_t_real,   -12.630742_t_real,    -9.945359_t_real &
       &,    -7.808480_t_real,    -6.148055_t_real,    -4.875398_t_real &
       &,    -3.901087_t_real,    -3.152136_t_real,    -2.574134_t_real &
       &,    -2.123308_t_real,    -1.768058_t_real,    -1.491737_t_real &
       &,    -1.285966_t_real,    -1.137759_t_real,    -1.027625_t_real &
       &,    -0.938564_t_real,    -0.860268_t_real,    -0.787346_t_real &
       &,    -0.716978_t_real,    -0.647681_t_real,    -0.578873_t_real &
       &,    -0.510707_t_real,    -0.443914_t_real,    -0.379601_t_real &
       &,    -0.319002_t_real,    -0.263259_t_real,    -0.213253_t_real &
       &,    -0.169513_t_real,    -0.132203_t_real,    -0.101151_t_real &
       &,    -0.075924_t_real,    -0.055906_t_real,    -0.040384_t_real &
       &,    -0.028618_t_real,    -0.019894_t_real/
  !!
  Data ncoefnrel( 96) / 50 /
  Data vcoefnrel(1:50, 96) /&
       &    -96.000000_t_real,   -95.895046_t_real,   -95.154909_t_real &
       &,   -93.156379_t_real,   -89.516752_t_real,   -84.232710_t_real &
       &,   -77.520592_t_real,   -69.730541_t_real,   -61.354465_t_real &
       &,   -52.869688_t_real,   -44.689355_t_real,   -37.087108_t_real &
       &,   -30.322046_t_real,   -24.648046_t_real,   -19.971262_t_real &
       &,   -16.068648_t_real,   -12.785313_t_real,   -10.079180_t_real &
       &,    -7.932430_t_real,    -6.265049_t_real,    -4.983547_t_real &
       &,    -3.995755_t_real,    -3.230021_t_real,    -2.634043_t_real &
       &,    -2.167213_t_real,    -1.801929_t_real,    -1.522207_t_real &
       &,    -1.314058_t_real,    -1.158777_t_real,    -1.037399_t_real &
       &,    -0.936300_t_real,    -0.847293_t_real,    -0.765559_t_real &
       &,    -0.688166_t_real,    -0.613441_t_real,    -0.540721_t_real &
       &,    -0.470160_t_real,    -0.402501_t_real,    -0.338785_t_real &
       &,    -0.280083_t_real,    -0.227283_t_real,    -0.180958_t_real &
       &,    -0.141319_t_real,    -0.108235_t_real,    -0.081289_t_real &
       &,    -0.059865_t_real,    -0.043228_t_real,    -0.030606_t_real &
       &,    -0.021246_t_real,    -0.014460_t_real/
  !!
  Data ncoefnrel( 97) / 50 /
  Data vcoefnrel(1:50, 97) /&
       &    -97.000000_t_real,   -96.893442_t_real,   -96.141996_t_real &
       &,   -94.113581_t_real,   -90.422194_t_real,   -85.065354_t_real &
       &,   -78.262093_t_real,   -70.368578_t_real,   -61.883400_t_real &
       &,   -53.289404_t_real,   -45.004892_t_real,   -37.310087_t_real &
       &,   -30.472193_t_real,   -24.735917_t_real,   -19.977987_t_real &
       &,   -15.983771_t_real,   -12.609785_t_real,    -9.841137_t_real &
       &,    -7.665207_t_real,    -5.994859_t_real,    -4.727770_t_real &
       &,    -3.767257_t_real,    -3.037080_t_real,    -2.478525_t_real &
       &,    -2.044902_t_real,    -1.704696_t_real,    -1.442638_t_real &
       &,    -1.250052_t_real,    -1.111860_t_real,    -1.007838_t_real &
       &,    -0.922081_t_real,    -0.845543_t_real,    -0.773608_t_real &
       &,    -0.703850_t_real,    -0.635002_t_real,    -0.566620_t_real &
       &,    -0.498950_t_real,    -0.432784_t_real,    -0.369249_t_real &
       &,    -0.309569_t_real,    -0.254851_t_real,    -0.205926_t_real &
       &,    -0.163273_t_real,    -0.127007_t_real,    -0.096920_t_real &
       &,    -0.072554_t_real,    -0.053279_t_real,    -0.038380_t_real &
       &,    -0.027120_t_real,    -0.018799_t_real/
  !!
  Data ncoefnrel( 98) / 50 /
  Data vcoefnrel(1:50, 98) /&
       &    -98.000000_t_real,   -97.891865_t_real,   -97.129297_t_real &
       &,   -95.071526_t_real,   -91.329477_t_real,   -85.901739_t_real &
       &,   -79.010300_t_real,   -71.017803_t_real,   -62.429906_t_real &
       &,   -53.735339_t_real,   -45.357257_t_real,   -37.582400_t_real &
       &,   -30.686110_t_real,   -24.901881_t_real,   -20.080531_t_real &
       &,   -16.017457_t_real,   -12.580231_t_real,    -9.774917_t_real &
       &,    -7.584819_t_real,    -5.913907_t_real,    -4.652946_t_real &
       &,    -3.701856_t_real,    -2.982474_t_real,    -2.434049_t_real &
       &,    -2.008923_t_real,    -1.676006_t_real,    -1.420792_t_real &
       &,    -1.234329_t_real,    -1.100555_t_real,    -0.999108_t_real &
       &,    -0.914700_t_real,    -0.838869_t_real,    -0.767330_t_real &
       &,    -0.697821_t_real,    -0.629164_t_real,    -0.560971_t_real &
       &,    -0.493530_t_real,    -0.427657_t_real,    -0.364487_t_real &
       &,    -0.305237_t_real,    -0.250996_t_real,    -0.202573_t_real &
       &,    -0.160422_t_real,    -0.124637_t_real,    -0.094994_t_real &
       &,    -0.071023_t_real,    -0.052088_t_real,    -0.037472_t_real &
       &,    -0.026444_t_real,    -0.018305_t_real/
  !!
  Data ncoefnrel( 99) / 50 /
  Data vcoefnrel(1:50, 99) /&
       &    -99.000000_t_real,   -98.890279_t_real,   -98.116526_t_real &
       &,   -96.029248_t_real,   -92.236303_t_real,   -86.737331_t_real &
       &,   -79.757249_t_real,   -71.665247_t_real,   -62.974000_t_real &
       &,   -54.178187_t_real,   -45.705917_t_real,   -37.850752_t_real &
       &,   -30.895719_t_real,   -25.060313_t_real,   -20.172505_t_real &
       &,   -16.038400_t_real,   -12.539347_t_real,    -9.700954_t_real &
       &,    -7.500143_t_real,    -5.831309_t_real,    -4.578377_t_real &
       &,    -3.637992_t_real,    -2.929982_t_real,    -2.391732_t_real &
       &,    -1.974929_t_real,    -1.649109_t_real,    -1.400526_t_real &
       &,    -1.219865_t_real,    -1.090144_t_real,    -0.990993_t_real &
       &,    -0.907769_t_real,    -0.832555_t_real,    -0.761362_t_real &
       &,    -0.692075_t_real,    -0.623592_t_real,    -0.555579_t_real &
       &,    -0.488358_t_real,    -0.422767_t_real,    -0.359949_t_real &
       &,    -0.301113_t_real,    -0.247330_t_real,    -0.199388_t_real &
       &,    -0.157717_t_real,    -0.122392_t_real,    -0.093172_t_real &
       &,    -0.069575_t_real,    -0.050963_t_real,    -0.036617_t_real &
       &,    -0.025807_t_real,    -0.017840_t_real/
  !!
  Data ncoefnrel(100) / 50 /
  Data vcoefnrel(1:50,100) /&
       &   -100.000000_t_real,   -99.888684_t_real,   -99.103683_t_real &
       &,   -96.986750_t_real,   -93.142674_t_real,   -87.572133_t_real &
       &,   -80.502944_t_real,   -72.310917_t_real,   -63.515689_t_real &
       &,   -54.617969_t_real,   -46.050934_t_real,   -38.115216_t_real &
       &,   -31.100983_t_real,   -25.211083_t_real,   -20.254065_t_real &
       &,   -16.047048_t_real,   -12.488105_t_real,    -9.620341_t_real &
       &,    -7.412135_t_real,    -5.747798_t_real,    -4.504558_t_real &
       &,    -3.575899_t_real,    -2.879628_t_real,    -2.351485_t_real &
       &,    -1.942790_t_real,    -1.623864_t_real,    -1.381692_t_real &
       &,    -1.206514_t_real,    -1.080504_t_real,    -0.983403_t_real &
       &,    -0.901220_t_real,    -0.826547_t_real,    -0.755662_t_real &
       &,    -0.686574_t_real,    -0.618252_t_real,    -0.550409_t_real &
       &,    -0.483401_t_real,    -0.418085_t_real,    -0.355608_t_real &
       &,    -0.297171_t_real,    -0.243831_t_real,    -0.196351_t_real &
       &,    -0.155142_t_real,    -0.120256_t_real,    -0.091440_t_real &
       &,    -0.068201_t_real,    -0.049896_t_real,    -0.035807_t_real &
       &,    -0.025204_t_real,    -0.017401_t_real/
  !!
  Data ncoefnrel(101) / 50 /
  Data vcoefnrel(1:50,101) /&
       &   -101.000000_t_real,  -100.887080_t_real,  -100.090769_t_real &
       &,   -97.944032_t_real,   -94.048591_t_real,   -88.406147_t_real &
       &,   -81.247390_t_real,   -72.954817_t_real,   -64.054978_t_real &
       &,   -55.054702_t_real,   -46.392363_t_real,   -38.375854_t_real &
       &,   -31.301845_t_real,   -25.354073_t_real,   -20.325345_t_real &
       &,   -16.043865_t_real,   -12.427438_t_real,    -9.534060_t_real &
       &,    -7.321619_t_real,    -5.663977_t_real,    -4.431862_t_real &
       &,    -3.515724_t_real,    -2.831395_t_real,    -2.313206_t_real &
       &,    -1.912379_t_real,    -1.600140_t_real,    -1.364156_t_real &
       &,    -1.194146_t_real,    -1.071531_t_real,    -0.976262_t_real &
       &,    -0.895000_t_real,    -0.820805_t_real,    -0.750193_t_real &
       &,    -0.681287_t_real,    -0.613117_t_real,    -0.545438_t_real &
       &,    -0.478637_t_real,    -0.413587_t_real,    -0.351441_t_real &
       &,    -0.293393_t_real,    -0.240480_t_real,    -0.193446_t_real &
       &,    -0.152680_t_real,    -0.118217_t_real,    -0.089788_t_real &
       &,    -0.066893_t_real,    -0.048882_t_real,    -0.035037_t_real &
       &,    -0.024632_t_real,    -0.016985_t_real/
  !!
  Data ncoefnrel(102) / 50 /
  Data vcoefnrel(1:50,102) /&
       &   -102.000000_t_real,  -101.885467_t_real,  -101.077783_t_real &
       &,   -98.901095_t_real,   -94.954057_t_real,   -89.239374_t_real &
       &,   -81.990590_t_real,   -73.596950_t_real,   -64.591869_t_real &
       &,   -55.488400_t_real,   -46.730253_t_real,   -38.632716_t_real &
       &,   -31.498220_t_real,   -25.489178_t_real,   -20.386462_t_real &
       &,   -16.029337_t_real,   -12.358229_t_real,    -9.443001_t_real &
       &,    -7.229304_t_real,    -5.580338_t_real,    -4.360569_t_real &
       &,    -3.457548_t_real,    -2.785232_t_real,    -2.276789_t_real &
       &,    -1.883577_t_real,    -1.577818_t_real,    -1.347796_t_real &
       &,    -1.182650_t_real,    -1.063139_t_real,    -0.969511_t_real &
       &,    -0.889064_t_real,    -0.815295_t_real,    -0.744931_t_real &
       &,    -0.676191_t_real,    -0.608165_t_real,    -0.540644_t_real &
       &,    -0.474044_t_real,    -0.409255_t_real,    -0.347432_t_real &
       &,    -0.289761_t_real,    -0.237262_t_real,    -0.190660_t_real &
       &,    -0.150322_t_real,    -0.116266_t_real,    -0.088210_t_real &
       &,    -0.065643_t_real,    -0.047914_t_real,    -0.034303_t_real &
       &,    -0.024087_t_real,    -0.016589_t_real/
  !!
  Data ncoefnrel(103) / 50 /
  Data vcoefnrel(1:50,103) /&
       &   -103.000000_t_real,  -102.883890_t_real,  -102.065079_t_real &
       &,   -99.859133_t_real,   -95.861912_t_real,   -90.077421_t_real &
       &,   -82.742393_t_real,   -74.253324_t_real,   -65.150946_t_real &
       &,   -55.954889_t_real,   -47.113808_t_real,   -38.950368_t_real &
       &,   -31.772597_t_real,   -25.720600_t_real,   -20.568105_t_real &
       &,   -16.164147_t_real,   -12.470147_t_real,    -9.556432_t_real &
       &,    -7.350090_t_real,    -5.704970_t_real,    -4.481685_t_real &
       &,    -3.567413_t_real,    -2.877996_t_real,    -2.350421_t_real &
       &,    -1.941695_t_real,    -1.627800_t_real,    -1.393499_t_real &
       &,    -1.220373_t_real,    -1.087591_t_real,    -0.979110_t_real &
       &,    -0.885263_t_real,    -0.800498_t_real,    -0.721403_t_real &
       &,    -0.645830_t_real,    -0.572626_t_real,    -0.501507_t_real &
       &,    -0.432892_t_real,    -0.367654_t_real,    -0.306844_t_real &
       &,    -0.251442_t_real,    -0.202186_t_real,    -0.159474_t_real &
       &,    -0.123354_t_real,    -0.093556_t_real,    -0.069567_t_real &
       &,    -0.050713_t_real,    -0.036241_t_real,    -0.025389_t_real &
       &,    -0.017435_t_real,    -0.011737_t_real/
  !!
  !!
  Data vscoefnrel(1:50,  0) /&
       &     0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real/
  Data bscoefnrel(1:50,  0) /&
       &     0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real/

  Data vscoefnrel(1:50,  1) /&
       &     -1.000000_t_real,    -0.999932_t_real,    -0.999456_t_real &
       &,    -0.998160_t_real,    -0.995617_t_real,    -0.991375_t_real &
       &,    -0.984937_t_real,    -0.975759_t_real,    -0.963254_t_real &
       &,    -0.946820_t_real,    -0.925910_t_real,    -0.900112_t_real &
       &,    -0.869266_t_real,    -0.833566_t_real,    -0.793628_t_real &
       &,    -0.750496_t_real,    -0.705562_t_real,    -0.660399_t_real &
       &,    -0.616540_t_real,    -0.575235_t_real,    -0.537264_t_real &
       &,    -0.502828_t_real,    -0.471557_t_real,    -0.442630_t_real &
       &,    -0.414976_t_real,    -0.387504_t_real,    -0.359319_t_real &
       &,    -0.329871_t_real,    -0.299023_t_real,    -0.267025_t_real &
       &,    -0.234433_t_real,    -0.201994_t_real,    -0.170539_t_real &
       &,    -0.140887_t_real,    -0.113761_t_real,    -0.089710_t_real &
       &,    -0.069059_t_real,    -0.051889_t_real,    -0.038059_t_real &
       &,    -0.027258_t_real,    -0.019069_t_real,    -0.013035_t_real &
       &,    -0.008708_t_real,    -0.005687_t_real,    -0.003630_t_real &
       &,    -0.002264_t_real,    -0.001380_t_real,    -0.000822_t_real &
       &,    -0.000478_t_real,    -0.000271_t_real/
  Data bscoefnrel(1:50,  1) /&
       &      0.000000_t_real,    -0.000052_t_real,    -0.000412_t_real &
       &,    -0.001386_t_real,    -0.003268_t_real,    -0.006329_t_real &
       &,    -0.010800_t_real,    -0.016852_t_real,    -0.024573_t_real &
       &,    -0.033948_t_real,    -0.044838_t_real,    -0.056970_t_real &
       &,    -0.069934_t_real,    -0.083193_t_real,    -0.096114_t_real &
       &,    -0.108003_t_real,    -0.118162_t_real,    -0.125949_t_real &
       &,    -0.130834_t_real,    -0.132453_t_real,    -0.130647_t_real &
       &,    -0.125483_t_real,    -0.117259_t_real,    -0.106482_t_real &
       &,    -0.093828_t_real,    -0.080081_t_real,    -0.066052_t_real &
       &,    -0.052505_t_real,    -0.040086_t_real,    -0.029276_t_real &
       &,    -0.020371_t_real,    -0.013474_t_real,    -0.008503_t_real &
       &,    -0.005214_t_real,    -0.003248_t_real,    -0.002208_t_real &
       &,    -0.001725_t_real,    -0.001513_t_real,    -0.001387_t_real &
       &,    -0.001253_t_real,    -0.001086_t_real,    -0.000893_t_real &
       &,    -0.000696_t_real,    -0.000516_t_real,    -0.000365_t_real &
       &,    -0.000247_t_real,    -0.000161_t_real,    -0.000101_t_real &
       &,    -0.000061_t_real,    -0.000036_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,  2) /&
       &     -2.000000_t_real,    -1.999707_t_real,    -1.997653_t_real &
       &,    -1.992050_t_real,    -1.981024_t_real,    -1.962550_t_real &
       &,    -1.934400_t_real,    -1.894201_t_real,    -1.839649_t_real &
       &,    -1.768910_t_real,    -1.681170_t_real,    -1.577175_t_real &
       &,    -1.459560_t_real,    -1.332763_t_real,    -1.202461_t_real &
       &,    -1.074636_t_real,    -0.954533_t_real,    -0.845816_t_real &
       &,    -0.750152_t_real,    -0.667285_t_real,    -0.595508_t_real &
       &,    -0.532353_t_real,    -0.475266_t_real,    -0.422131_t_real &
       &,    -0.371548_t_real,    -0.322883_t_real,    -0.276154_t_real &
       &,    -0.231830_t_real,    -0.190605_t_real,    -0.153196_t_real &
       &,    -0.120182_t_real,    -0.091907_t_real,    -0.068436_t_real &
       &,    -0.049570_t_real,    -0.034898_t_real,    -0.023862_t_real &
       &,    -0.015839_t_real,    -0.010200_t_real,    -0.006371_t_real &
       &,    -0.003858_t_real,    -0.002264_t_real,    -0.001288_t_real &
       &,    -0.000709_t_real,    -0.000378_t_real,    -0.000195_t_real &
       &,    -0.000097_t_real,    -0.000047_t_real,    -0.000022_t_real &
       &,    -0.000010_t_real,    -0.000004_t_real/
  Data bscoefnrel(1:50,  2) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,  3) /&
       &     -3.000000_t_real,    -2.999457_t_real,    -2.995647_t_real &
       &,    -2.985241_t_real,    -2.964725_t_real,    -2.930279_t_real &
       &,    -2.877802_t_real,    -2.803287_t_real,    -2.703648_t_real &
       &,    -2.577896_t_real,    -2.428245_t_real,    -2.260520_t_real &
       &,    -2.083389_t_real,    -1.906460_t_real,    -1.737878_t_real &
       &,    -1.582404_t_real,    -1.440793_t_real,    -1.310709_t_real &
       &,    -1.188869_t_real,    -1.073863_t_real,    -0.968812_t_real &
       &,    -0.881141_t_real,    -0.816414_t_real,    -0.771425_t_real &
       &,    -0.735010_t_real,    -0.700561_t_real,    -0.667014_t_real &
       &,    -0.634541_t_real,    -0.603077_t_real,    -0.572142_t_real &
       &,    -0.540984_t_real,    -0.508783_t_real,    -0.474854_t_real &
       &,    -0.438811_t_real,    -0.400653_t_real,    -0.360765_t_real &
       &,    -0.319857_t_real,    -0.278858_t_real,    -0.238801_t_real &
       &,    -0.200700_t_real,    -0.165449_t_real,    -0.133733_t_real &
       &,    -0.105984_t_real,    -0.082358_t_real,    -0.062772_t_real &
       &,    -0.046942_t_real,    -0.034456_t_real,    -0.024834_t_real &
       &,    -0.017580_t_real,    -0.012227_t_real/
  Data bscoefnrel(1:50,  3) /&
       &      0.000000_t_real,    -0.000002_t_real,    -0.000017_t_real &
       &,    -0.000055_t_real,    -0.000129_t_real,    -0.000247_t_real &
       &,    -0.000413_t_real,    -0.000624_t_real,    -0.000871_t_real &
       &,    -0.001133_t_real,    -0.001379_t_real,    -0.001567_t_real &
       &,    -0.001646_t_real,    -0.001565_t_real,    -0.001285_t_real &
       &,    -0.000808_t_real,    -0.000235_t_real,     0.000110_t_real &
       &,    -0.000553_t_real,    -0.003807_t_real,    -0.012055_t_real &
       &,    -0.026742_t_real,    -0.044321_t_real,    -0.059604_t_real &
       &,    -0.073387_t_real,    -0.085373_t_real,    -0.093784_t_real &
       &,    -0.097652_t_real,    -0.096946_t_real,    -0.092203_t_real &
       &,    -0.084262_t_real,    -0.074097_t_real,    -0.062705_t_real &
       &,    -0.051021_t_real,    -0.039852_t_real,    -0.029831_t_real &
       &,    -0.021380_t_real,    -0.014705_t_real,    -0.009796_t_real &
       &,    -0.006466_t_real,    -0.004405_t_real,    -0.003254_t_real &
       &,    -0.002674_t_real,    -0.002387_t_real,    -0.002207_t_real &
       &,    -0.002028_t_real,    -0.001810_t_real,    -0.001553_t_real &
       &,    -0.001279_t_real,    -0.001012_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,  4) /&
       &     -4.000000_t_real,    -3.999148_t_real,    -3.993170_t_real &
       &,    -3.976828_t_real,    -3.944569_t_real,    -3.890380_t_real &
       &,    -3.808058_t_real,    -3.692230_t_real,    -3.540176_t_real &
       &,    -3.353827_t_real,    -3.140711_t_real,    -2.912759_t_real &
       &,    -2.682884_t_real,    -2.460797_t_real,    -2.250265_t_real &
       &,    -2.049546_t_real,    -1.855438_t_real,    -1.670080_t_real &
       &,    -1.506019_t_real,    -1.375181_t_real,    -1.269954_t_real &
       &,    -1.175215_t_real,    -1.083793_t_real,    -0.995072_t_real &
       &,    -0.910576_t_real,    -0.831606_t_real,    -0.758461_t_real &
       &,    -0.690474_t_real,    -0.626428_t_real,    -0.565047_t_real &
       &,    -0.505377_t_real,    -0.446999_t_real,    -0.390053_t_real &
       &,    -0.335123_t_real,    -0.283053_t_real,    -0.234743_t_real &
       &,    -0.190980_t_real,    -0.152319_t_real,    -0.119032_t_real &
       &,    -0.091104_t_real,    -0.068270_t_real,    -0.050075_t_real &
       &,    -0.035944_t_real,    -0.025243_t_real,    -0.017343_t_real &
       &,    -0.011655_t_real,    -0.007660_t_real,    -0.004923_t_real &
       &,    -0.003094_t_real,    -0.001900_t_real/
  Data bscoefnrel(1:50,  4) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,  5) /&
       &     -5.000000_t_real,    -4.998791_t_real,    -4.990309_t_real &
       &,    -4.967105_t_real,    -4.921262_t_real,    -4.844292_t_real &
       &,    -4.727832_t_real,    -4.565653_t_real,    -4.356641_t_real &
       &,    -4.107142_t_real,    -3.830511_t_real,    -3.542919_t_real &
       &,    -3.257186_t_real,    -2.978535_t_real,    -2.705740_t_real &
       &,    -2.438559_t_real,    -2.187213_t_real,    -1.967616_t_real &
       &,    -1.777770_t_real,    -1.602495_t_real,    -1.434697_t_real &
       &,    -1.275892_t_real,    -1.129995_t_real,    -0.999764_t_real &
       &,    -0.885746_t_real,    -0.786567_t_real,    -0.699750_t_real &
       &,    -0.622565_t_real,    -0.552643_t_real,    -0.488279_t_real &
       &,    -0.428471_t_real,    -0.372796_t_real,    -0.321204_t_real &
       &,    -0.273826_t_real,    -0.230806_t_real,    -0.192210_t_real &
       &,    -0.157993_t_real,    -0.128024_t_real,    -0.102130_t_real &
       &,    -0.080112_t_real,    -0.061739_t_real,    -0.046724_t_real &
       &,    -0.034722_t_real,    -0.025339_t_real,    -0.018161_t_real &
       &,    -0.012786_t_real,    -0.008843_t_real,    -0.006007_t_real &
       &,    -0.004008_t_real,    -0.002626_t_real/
  Data bscoefnrel(1:50,  5) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,     0.000001_t_real &
       &,     0.000002_t_real,     0.000000_t_real,    -0.000008_t_real &
       &,    -0.000036_t_real,    -0.000111_t_real,    -0.000305_t_real &
       &,    -0.000778_t_real,    -0.001897_t_real,    -0.004453_t_real &
       &,    -0.009813_t_real,    -0.018678_t_real,    -0.027805_t_real &
       &,    -0.033388_t_real,    -0.036237_t_real,    -0.037884_t_real &
       &,    -0.038861_t_real,    -0.039239_t_real,    -0.038987_t_real &
       &,    -0.038078_t_real,    -0.036509_t_real,    -0.034307_t_real &
       &,    -0.031524_t_real,    -0.028249_t_real,    -0.024611_t_real &
       &,    -0.020777_t_real,    -0.016939_t_real,    -0.013286_t_real &
       &,    -0.009979_t_real,    -0.007144_t_real,    -0.004869_t_real &
       &,    -0.003200_t_real,    -0.002122_t_real,    -0.001546_t_real &
       &,    -0.001321_t_real,    -0.001285_t_real,    -0.001300_t_real &
       &,    -0.001283_t_real,    -0.001203_t_real,    -0.001066_t_real &
       &,    -0.000895_t_real,    -0.000715_t_real,    -0.000546_t_real &
       &,    -0.000401_t_real,    -0.000283_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,  6) /&
       &     -6.000000_t_real,    -5.998376_t_real,    -5.986979_t_real &
       &,    -5.955788_t_real,    -5.894143_t_real,    -5.790762_t_real &
       &,    -5.635101_t_real,    -5.420634_t_real,    -5.148921_t_real &
       &,    -4.831490_t_real,    -4.486663_t_real,    -4.131908_t_real &
       &,    -3.776756_t_real,    -3.422587_t_real,    -3.071607_t_real &
       &,    -2.737265_t_real,    -2.434893_t_real,    -2.159443_t_real &
       &,    -1.898914_t_real,    -1.652752_t_real,    -1.427294_t_real &
       &,    -1.228427_t_real,    -1.058474_t_real,    -0.916048_t_real &
       &,    -0.797258_t_real,    -0.697203_t_real,    -0.611178_t_real &
       &,    -0.535368_t_real,    -0.467082_t_real,    -0.404670_t_real &
       &,    -0.347294_t_real,    -0.294655_t_real,    -0.246743_t_real &
       &,    -0.203638_t_real,    -0.165396_t_real,    -0.131997_t_real &
       &,    -0.103350_t_real,    -0.079284_t_real,    -0.059538_t_real &
       &,    -0.043747_t_real,    -0.031450_t_real,    -0.022126_t_real &
       &,    -0.015236_t_real,    -0.010273_t_real,    -0.006782_t_real &
       &,    -0.004384_t_real,    -0.002775_t_real,    -0.001719_t_real &
       &,    -0.001042_t_real,    -0.000618_t_real/
  Data bscoefnrel(1:50,  6) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,     0.000001_t_real &
       &,    -0.000001_t_real,    -0.000014_t_real,    -0.000059_t_real &
       &,    -0.000196_t_real,    -0.000575_t_real,    -0.001559_t_real &
       &,    -0.004010_t_real,    -0.009795_t_real,    -0.021881_t_real &
       &,    -0.040484_t_real,    -0.057189_t_real,    -0.066292_t_real &
       &,    -0.070634_t_real,    -0.072716_t_real,    -0.073250_t_real &
       &,    -0.072341_t_real,    -0.070014_t_real,    -0.066344_t_real &
       &,    -0.061465_t_real,    -0.055564_t_real,    -0.048877_t_real &
       &,    -0.041697_t_real,    -0.034372_t_real,    -0.027273_t_real &
       &,    -0.020751_t_real,    -0.015076_t_real,    -0.010409_t_real &
       &,    -0.006810_t_real,    -0.004249_t_real,    -0.002615_t_real &
       &,    -0.001721_t_real,    -0.001333_t_real,    -0.001217_t_real &
       &,    -0.001194_t_real,    -0.001154_t_real,    -0.001059_t_real &
       &,    -0.000912_t_real,    -0.000740_t_real,    -0.000567_t_real &
       &,    -0.000413_t_real,    -0.000287_t_real,    -0.000192_t_real &
       &,    -0.000123_t_real,    -0.000077_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,  7) /&
       &     -7.000000_t_real,    -6.997904_t_real,    -6.983193_t_real &
       &,    -6.942915_t_real,    -6.863309_t_real,    -6.730022_t_real &
       &,    -6.530386_t_real,    -6.258173_t_real,    -5.918469_t_real &
       &,    -5.528049_t_real,    -5.108541_t_real,    -4.676163_t_real &
       &,    -4.237093_t_real,    -3.794871_t_real,    -3.362984_t_real &
       &,    -2.959663_t_real,    -2.584776_t_real,    -2.229732_t_real &
       &,    -1.898219_t_real,    -1.600552_t_real,    -1.344513_t_real &
       &,    -1.131969_t_real,    -0.959429_t_real,    -0.820197_t_real &
       &,    -0.706623_t_real,    -0.611729_t_real,    -0.530030_t_real &
       &,    -0.457716_t_real,    -0.392452_t_real,    -0.333018_t_real &
       &,    -0.278939_t_real,    -0.230138_t_real,    -0.186680_t_real &
       &,    -0.148608_t_real,    -0.115881_t_real,    -0.088365_t_real &
       &,    -0.065808_t_real,    -0.047827_t_real,    -0.033911_t_real &
       &,    -0.023462_t_real,    -0.015844_t_real,    -0.010447_t_real &
       &,    -0.006727_t_real,    -0.004231_t_real,    -0.002599_t_real &
       &,    -0.001559_t_real,    -0.000912_t_real,    -0.000521_t_real &
       &,    -0.000290_t_real,    -0.000158_t_real/
  Data bscoefnrel(1:50,  7) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,     0.000000_t_real &
       &,    -0.000009_t_real,    -0.000048_t_real,    -0.000183_t_real &
       &,    -0.000596_t_real,    -0.001752_t_real,    -0.004803_t_real &
       &,    -0.012362_t_real,    -0.028853_t_real,    -0.055359_t_real &
       &,    -0.080053_t_real,    -0.093595_t_real,    -0.099778_t_real &
       &,    -0.102326_t_real,    -0.102331_t_real,    -0.100027_t_real &
       &,    -0.095562_t_real,    -0.089164_t_real,    -0.081138_t_real &
       &,    -0.071855_t_real,    -0.061742_t_real,    -0.051286_t_real &
       &,    -0.041016_t_real,    -0.031452_t_real,    -0.023028_t_real &
       &,    -0.016022_t_real,    -0.010537_t_real,    -0.006533_t_real &
       &,    -0.003861_t_real,    -0.002284_t_real,    -0.001501_t_real &
       &,    -0.001201_t_real,    -0.001119_t_real,    -0.001081_t_real &
       &,    -0.001005_t_real,    -0.000875_t_real,    -0.000711_t_real &
       &,    -0.000542_t_real,    -0.000389_t_real,    -0.000266_t_real &
       &,    -0.000173_t_real,    -0.000108_t_real,    -0.000065_t_real &
       &,    -0.000037_t_real,    -0.000021_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,  8) /&
       &     -8.000000_t_real,    -7.997386_t_real,    -7.979030_t_real &
       &,    -7.928760_t_real,    -7.829417_t_real,    -7.663392_t_real &
       &,    -7.416067_t_real,    -7.082175_t_real,    -6.670976_t_real &
       &,    -6.204062_t_real,    -5.704546_t_real,    -5.186313_t_real &
       &,    -4.655901_t_real,    -4.127426_t_real,    -3.622390_t_real &
       &,    -3.143857_t_real,    -2.686416_t_real,    -2.258457_t_real &
       &,    -1.875428_t_real,    -1.548567_t_real,    -1.280640_t_real &
       &,    -1.066927_t_real,    -0.898330_t_real,    -0.764507_t_real &
       &,    -0.656021_t_real,    -0.565383_t_real,    -0.487250_t_real &
       &,    -0.418153_t_real,    -0.356061_t_real,    -0.299932_t_real &
       &,    -0.249343_t_real,    -0.204190_t_real,    -0.164476_t_real &
       &,    -0.130171_t_real,    -0.101135_t_real,    -0.077087_t_real &
       &,    -0.057618_t_real,    -0.042215_t_real,    -0.030308_t_real &
       &,    -0.021314_t_real,    -0.014673_t_real,    -0.009881_t_real &
       &,    -0.006503_t_real,    -0.004181_t_real,    -0.002625_t_real &
       &,    -0.001609_t_real,    -0.000963_t_real,    -0.000563_t_real &
       &,    -0.000321_t_real,    -0.000179_t_real/
  Data bscoefnrel(1:50,  8) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,    -0.000001_t_real &
       &,    -0.000012_t_real,    -0.000059_t_real,    -0.000226_t_real &
       &,    -0.000739_t_real,    -0.002194_t_real,    -0.006039_t_real &
       &,    -0.015056_t_real,    -0.030942_t_real,    -0.047349_t_real &
       &,    -0.057111_t_real,    -0.061639_t_real,    -0.063314_t_real &
       &,    -0.062944_t_real,    -0.060753_t_real,    -0.056917_t_real &
       &,    -0.051681_t_real,    -0.045363_t_real,    -0.038343_t_real &
       &,    -0.031042_t_real,    -0.023906_t_real,    -0.017364_t_real &
       &,    -0.011770_t_real,    -0.007342_t_real,    -0.004124_t_real &
       &,    -0.001995_t_real,    -0.000731_t_real,    -0.000077_t_real &
       &,     0.000192_t_real,     0.000246_t_real,     0.000198_t_real &
       &,     0.000118_t_real,     0.000046_t_real,     0.000000_t_real &
       &,    -0.000014_t_real,    -0.000004_t_real,     0.000020_t_real &
       &,     0.000044_t_real,     0.000060_t_real,     0.000064_t_real &
       &,     0.000059_t_real,     0.000048_t_real,     0.000036_t_real &
       &,     0.000025_t_real,     0.000016_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,  9) /&
       &     -9.000000_t_real,    -8.996809_t_real,    -8.974402_t_real &
       &,    -8.913026_t_real,    -8.791768_t_real,    -8.589538_t_real &
       &,    -8.289908_t_real,    -7.889089_t_real,    -7.400779_t_real &
       &,    -6.850480_t_real,    -6.261304_t_real,    -5.645923_t_real &
       &,    -5.017349_t_real,    -4.400157_t_real,    -3.807048_t_real &
       &,    -3.235556_t_real,    -2.696428_t_real,    -2.211006_t_real &
       &,    -1.796351_t_real,    -1.458227_t_real,    -1.191719_t_real &
       &,    -0.985359_t_real,    -0.825501_t_real,    -0.699437_t_real &
       &,    -0.596936_t_real,    -0.510599_t_real,    -0.435543_t_real &
       &,    -0.368834_t_real,    -0.308902_t_real,    -0.255056_t_real &
       &,    -0.207094_t_real,    -0.165016_t_real,    -0.128824_t_real &
       &,    -0.098401_t_real,    -0.073463_t_real,    -0.053558_t_real &
       &,    -0.038104_t_real,    -0.026441_t_real,    -0.017887_t_real &
       &,    -0.011793_t_real,    -0.007576_t_real,    -0.004741_t_real &
       &,    -0.002889_t_real,    -0.001714_t_real,    -0.000989_t_real &
       &,    -0.000555_t_real,    -0.000303_t_real,    -0.000161_t_real &
       &,    -0.000083_t_real,    -0.000042_t_real/
  Data bscoefnrel(1:50,  9) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,    -0.000001_t_real &
       &,    -0.000010_t_real,    -0.000049_t_real,    -0.000186_t_real &
       &,    -0.000612_t_real,    -0.001828_t_real,    -0.004958_t_real &
       &,    -0.011380_t_real,    -0.019544_t_real,    -0.025266_t_real &
       &,    -0.028105_t_real,    -0.029261_t_real,    -0.029267_t_real &
       &,    -0.028284_t_real,    -0.026423_t_real,    -0.023831_t_real &
       &,    -0.020691_t_real,    -0.017220_t_real,    -0.013648_t_real &
       &,    -0.010211_t_real,    -0.007127_t_real,    -0.004560_t_real &
       &,    -0.002600_t_real,    -0.001245_t_real,    -0.000412_t_real &
       &,     0.000025_t_real,     0.000202_t_real,     0.000230_t_real &
       &,     0.000189_t_real,     0.000125_t_real,     0.000065_t_real &
       &,     0.000019_t_real,    -0.000010_t_real,    -0.000024_t_real &
       &,    -0.000028_t_real,    -0.000025_t_real,    -0.000019_t_real &
       &,    -0.000013_t_real,    -0.000007_t_real,    -0.000003_t_real &
       &,    -0.000001_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000001_t_real,     0.000001_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 10) /&
       &    -10.000000_t_real,    -9.996176_t_real,    -9.969319_t_real &
       &,    -9.895747_t_real,    -9.750451_t_real,    -9.508665_t_real &
       &,    -9.152315_t_real,    -8.679551_t_real,    -8.108508_t_real &
       &,    -7.467576_t_real,    -6.779242_t_real,    -6.058054_t_real &
       &,    -5.327202_t_real,    -4.611948_t_real,    -3.917037_t_real &
       &,    -3.252771_t_real,    -2.645870_t_real,    -2.122032_t_real &
       &,    -1.693412_t_real,    -1.357177_t_real,    -1.100279_t_real &
       &,    -0.905495_t_real,    -0.756041_t_real,    -0.638055_t_real &
       &,    -0.541333_t_real,    -0.459034_t_real,    -0.386967_t_real &
       &,    -0.322816_t_real,    -0.265484_t_real,    -0.214576_t_real &
       &,    -0.170023_t_real,    -0.131811_t_real,    -0.099816_t_real &
       &,    -0.073737_t_real,    -0.053079_t_real,    -0.037199_t_real &
       &,    -0.025362_t_real,    -0.016812_t_real,    -0.010831_t_real &
       &,    -0.006778_t_real,    -0.004120_t_real,    -0.002431_t_real &
       &,    -0.001392_t_real,    -0.000773_t_real,    -0.000417_t_real &
       &,    -0.000218_t_real,    -0.000110_t_real,    -0.000054_t_real &
       &,    -0.000026_t_real,    -0.000012_t_real/
  Data bscoefnrel(1:50, 10) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 11) /&
       &    -11.000000_t_real,   -10.995588_t_real,   -10.964600_t_real &
       &,   -10.879683_t_real,   -10.712018_t_real,   -10.433611_t_real &
       &,   -10.025607_t_real,    -9.489208_t_real,    -8.847540_t_real &
       &,    -8.131486_t_real,    -7.363471_t_real,    -6.563567_t_real &
       &,    -5.763748_t_real,    -4.983549_t_real,    -4.231039_t_real &
       &,    -3.532479_t_real,    -2.920518_t_real,    -2.413552_t_real &
       &,    -2.009760_t_real,    -1.692751_t_real,    -1.441139_t_real &
       &,    -1.236732_t_real,    -1.069069_t_real,    -0.935326_t_real &
       &,    -0.835260_t_real,    -0.765250_t_real,    -0.715005_t_real &
       &,    -0.673567_t_real,    -0.635823_t_real,    -0.600062_t_real &
       &,    -0.565298_t_real,    -0.530567_t_real,    -0.494971_t_real &
       &,    -0.457861_t_real,    -0.418967_t_real,    -0.378443_t_real &
       &,    -0.336828_t_real,    -0.294949_t_real,    -0.253796_t_real &
       &,    -0.214392_t_real,    -0.177675_t_real,    -0.144397_t_real &
       &,    -0.115065_t_real,    -0.089911_t_real,    -0.068908_t_real &
       &,    -0.051816_t_real,    -0.038244_t_real,    -0.027717_t_real &
       &,    -0.019731_t_real,    -0.013800_t_real/
  Data bscoefnrel(1:50, 11) /&
       &      0.000000_t_real,    -0.000001_t_real,    -0.000004_t_real &
       &,    -0.000013_t_real,    -0.000030_t_real,    -0.000054_t_real &
       &,    -0.000080_t_real,    -0.000101_t_real,    -0.000098_t_real &
       &,    -0.000056_t_real,     0.000028_t_real,     0.000070_t_real &
       &,    -0.000083_t_real,    -0.000368_t_real,    -0.000579_t_real &
       &,    -0.000609_t_real,    -0.000436_t_real,    -0.000128_t_real &
       &,     0.000099_t_real,    -0.000233_t_real,    -0.002023_t_real &
       &,    -0.006739_t_real,    -0.016176_t_real,    -0.031118_t_real &
       &,    -0.048806_t_real,    -0.063365_t_real,    -0.073469_t_real &
       &,    -0.080667_t_real,    -0.084601_t_real,    -0.084541_t_real &
       &,    -0.080532_t_real,    -0.073270_t_real,    -0.063775_t_real &
       &,    -0.053139_t_real,    -0.042374_t_real,    -0.032309_t_real &
       &,    -0.023545_t_real,    -0.016427_t_real,    -0.011053_t_real &
       &,    -0.007309_t_real,    -0.004925_t_real,    -0.003552_t_real &
       &,    -0.002841_t_real,    -0.002493_t_real,    -0.002294_t_real &
       &,    -0.002118_t_real,    -0.001908_t_real,    -0.001656_t_real &
       &,    -0.001380_t_real,    -0.001104_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 12) /&
       &    -12.000000_t_real,   -11.994973_t_real,   -11.959658_t_real &
       &,   -11.862860_t_real,   -11.671791_t_real,   -11.355267_t_real &
       &,   -10.894063_t_real,   -10.292958_t_real,    -9.579888_t_real &
       &,    -8.787410_t_real,    -7.938906_t_real,    -7.062708_t_real &
       &,    -6.194399_t_real,    -5.348659_t_real,    -4.545517_t_real &
       &,    -3.822377_t_real,    -3.207880_t_real,    -2.706130_t_real &
       &,    -2.300531_t_real,    -1.967581_t_real,    -1.690626_t_real &
       &,    -1.466007_t_real,    -1.294457_t_real,    -1.165754_t_real &
       &,    -1.062512_t_real,    -0.972700_t_real,    -0.891084_t_real &
       &,    -0.815655_t_real,    -0.745209_t_real,    -0.678532_t_real &
       &,    -0.614408_t_real,    -0.551883_t_real,    -0.490486_t_real &
       &,    -0.430302_t_real,    -0.371897_t_real,    -0.316148_t_real &
       &,    -0.264032_t_real,    -0.216440_t_real,    -0.174042_t_real &
       &,    -0.137215_t_real,    -0.106030_t_real,    -0.080282_t_real &
       &,    -0.059549_t_real,    -0.043265_t_real,    -0.030784_t_real &
       &,    -0.021450_t_real,    -0.014634_t_real,    -0.009775_t_real &
       &,    -0.006391_t_real,    -0.004091_t_real/
  Data bscoefnrel(1:50, 12) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 13) /&
       &    -13.000000_t_real,   -12.994344_t_real,   -12.954603_t_real &
       &,   -12.845646_t_real,   -12.630653_t_real,   -12.275372_t_real &
       &,   -11.760662_t_real,   -11.095311_t_real,   -10.311727_t_real &
       &,    -9.443690_t_real,    -8.517505_t_real,    -7.570635_t_real &
       &,    -6.637029_t_real,    -5.732959_t_real,    -4.892716_t_real &
       &,    -4.156518_t_real,    -3.540948_t_real,    -3.033764_t_real &
       &,    -2.609356_t_real,    -2.249375_t_real,    -1.952515_t_real &
       &,    -1.718680_t_real,    -1.530447_t_real,    -1.367768_t_real &
       &,    -1.221422_t_real,    -1.089442_t_real,    -0.971683_t_real &
       &,    -0.867494_t_real,    -0.775375_t_real,    -0.693373_t_real &
       &,    -0.619549_t_real,    -0.552274_t_real,    -0.490330_t_real &
       &,    -0.432895_t_real,    -0.379460_t_real,    -0.329753_t_real &
       &,    -0.283654_t_real,    -0.241151_t_real,    -0.202308_t_real &
       &,    -0.167240_t_real,    -0.136071_t_real,    -0.108876_t_real &
       &,    -0.085632_t_real,    -0.066192_t_real,    -0.050285_t_real &
       &,    -0.037549_t_real,    -0.027565_t_real,    -0.019898_t_real &
       &,    -0.014125_t_real,    -0.009862_t_real/
  Data bscoefnrel(1:50, 13) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,     0.000002_t_real &
       &,     0.000001_t_real,    -0.000006_t_real,    -0.000035_t_real &
       &,    -0.000122_t_real,    -0.000334_t_real,    -0.000636_t_real &
       &,    -0.000816_t_real,    -0.000816_t_real,    -0.000674_t_real &
       &,    -0.000415_t_real,    -0.000102_t_real,     0.000045_t_real &
       &,    -0.000578_t_real,    -0.003192_t_real,    -0.008887_t_real &
       &,    -0.016470_t_real,    -0.023615_t_real,    -0.029618_t_real &
       &,    -0.034603_t_real,    -0.038603_t_real,    -0.041492_t_real &
       &,    -0.043088_t_real,    -0.043244_t_real,    -0.041897_t_real &
       &,    -0.039113_t_real,    -0.035108_t_real,    -0.030233_t_real &
       &,    -0.024924_t_real,    -0.019627_t_real,    -0.014735_t_real &
       &,    -0.010545_t_real,    -0.007237_t_real,    -0.004862_t_real &
       &,    -0.003342_t_real,    -0.002500_t_real,    -0.002115_t_real &
       &,    -0.001975_t_real,    -0.001919_t_real,    -0.001848_t_real &
       &,    -0.001722_t_real,    -0.001538_t_real,    -0.001314_t_real &
       &,    -0.001076_t_real,    -0.000847_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 14) /&
       &    -14.000000_t_real,   -13.993687_t_real,   -13.949325_t_real &
       &,   -13.827671_t_real,   -13.587733_t_real,   -13.192244_t_real &
       &,   -12.622515_t_real,   -11.891594_t_real,   -11.035874_t_real &
       &,   -10.090218_t_real,    -9.085999_t_real,    -8.068158_t_real &
       &,    -7.066965_t_real,    -6.106983_t_real,    -5.233287_t_real &
       &,    -4.480230_t_real,    -3.847835_t_real,    -3.311367_t_real &
       &,    -2.848467_t_real,    -2.457525_t_real,    -2.139510_t_real &
       &,    -1.873772_t_real,    -1.638923_t_real,    -1.428025_t_real &
       &,    -1.241614_t_real,    -1.080504_t_real,    -0.943392_t_real &
       &,    -0.827092_t_real,    -0.727556_t_real,    -0.640805_t_real &
       &,    -0.563516_t_real,    -0.493266_t_real,    -0.428542_t_real &
       &,    -0.368585_t_real,    -0.313167_t_real,    -0.262351_t_real &
       &,    -0.216321_t_real,    -0.175277_t_real,    -0.139367_t_real &
       &,    -0.108633_t_real,    -0.082959_t_real,    -0.062053_t_real &
       &,    -0.045467_t_real,    -0.032641_t_real,    -0.022966_t_real &
       &,    -0.015842_t_real,    -0.010715_t_real,    -0.007107_t_real &
       &,    -0.004623_t_real,    -0.002949_t_real/
  Data bscoefnrel(1:50, 14) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,     0.000001_t_real &
       &,    -0.000004_t_real,    -0.000033_t_real,    -0.000137_t_real &
       &,    -0.000455_t_real,    -0.001156_t_real,    -0.001946_t_real &
       &,    -0.002252_t_real,    -0.002056_t_real,    -0.001459_t_real &
       &,    -0.000587_t_real,     0.000095_t_real,    -0.000822_t_real &
       &,    -0.006434_t_real,    -0.019626_t_real,    -0.036754_t_real &
       &,    -0.051444_t_real,    -0.062349_t_real,    -0.070118_t_real &
       &,    -0.075039_t_real,    -0.077081_t_real,    -0.076205_t_real &
       &,    -0.072525_t_real,    -0.066379_t_real,    -0.058343_t_real &
       &,    -0.049167_t_real,    -0.039665_t_real,    -0.030574_t_real &
       &,    -0.022460_t_real,    -0.015678_t_real,    -0.010392_t_real &
       &,    -0.006598_t_real,    -0.004139_t_real,    -0.002740_t_real &
       &,    -0.002068_t_real,    -0.001806_t_real,    -0.001709_t_real &
       &,    -0.001626_t_real,    -0.001493_t_real,    -0.001304_t_real &
       &,    -0.001079_t_real,    -0.000849_t_real,    -0.000638_t_real &
       &,    -0.000459_t_real,    -0.000318_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 15) /&
       &    -15.000000_t_real,   -14.993003_t_real,   -14.943830_t_real &
       &,   -14.808961_t_real,   -14.543097_t_real,   -14.106030_t_real &
       &,   -13.479877_t_real,   -12.682094_t_real,   -11.752557_t_real &
       &,   -10.727517_t_real,    -9.645265_t_real,    -8.555075_t_real &
       &,    -7.485262_t_real,    -6.472330_t_real,    -5.565584_t_real &
       &,    -4.786588_t_real,    -4.119140_t_real,    -3.536100_t_real &
       &,    -3.031095_t_real,    -2.608653_t_real,    -2.249747_t_real &
       &,    -1.931004_t_real,    -1.646360_t_real,    -1.398643_t_real &
       &,    -1.189621_t_real,    -1.017022_t_real,    -0.875399_t_real &
       &,    -0.758033_t_real,    -0.658516_t_real,    -0.571682_t_real &
       &,    -0.493921_t_real,    -0.423093_t_real,    -0.358199_t_real &
       &,    -0.298967_t_real,    -0.245472_t_real,    -0.197886_t_real &
       &,    -0.156347_t_real,    -0.120885_t_real,    -0.091372_t_real &
       &,    -0.067478_t_real,    -0.048683_t_real,    -0.034320_t_real &
       &,    -0.023650_t_real,    -0.015936_t_real,    -0.010504_t_real &
       &,    -0.006774_t_real,    -0.004274_t_real,    -0.002638_t_real &
       &,    -0.001593_t_real,    -0.000940_t_real/
  Data bscoefnrel(1:50, 15) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,    -0.000001_t_real &
       &,    -0.000016_t_real,    -0.000087_t_real,    -0.000342_t_real &
       &,    -0.001093_t_real,    -0.002553_t_real,    -0.003814_t_real &
       &,    -0.004025_t_real,    -0.003313_t_real,    -0.001881_t_real &
       &,    -0.000247_t_real,    -0.000239_t_real,    -0.006582_t_real &
       &,    -0.025386_t_real,    -0.052429_t_real,    -0.075380_t_real &
       &,    -0.091014_t_real,    -0.100834_t_real,    -0.105751_t_real &
       &,    -0.106107_t_real,    -0.102220_t_real,    -0.094623_t_real &
       &,    -0.084117_t_real,    -0.071719_t_real,    -0.058553_t_real &
       &,    -0.045689_t_real,    -0.033989_t_real,    -0.024021_t_real &
       &,    -0.016058_t_real,    -0.010136_t_real,    -0.006099_t_real &
       &,    -0.003640_t_real,    -0.002345_t_real,    -0.001782_t_real &
       &,    -0.001583_t_real,    -0.001496_t_real,    -0.001391_t_real &
       &,    -0.001228_t_real,    -0.001021_t_real,    -0.000800_t_real &
       &,    -0.000593_t_real,    -0.000419_t_real,    -0.000282_t_real &
       &,    -0.000183_t_real,    -0.000114_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 16) /&
       &    -16.000000_t_real,   -15.992297_t_real,   -15.938154_t_real &
       &,   -15.789629_t_real,   -15.497020_t_real,   -15.017284_t_real &
       &,   -14.333696_t_real,   -13.468210_t_real,   -12.463737_t_real &
       &,   -11.358627_t_real,   -10.199155_t_real,    -9.035738_t_real &
       &,    -7.898669_t_real,    -6.836187_t_real,    -5.894455_t_real &
       &,    -5.078459_t_real,    -4.361619_t_real,    -3.728143_t_real &
       &,    -3.187146_t_real,    -2.726051_t_real,    -2.315666_t_real &
       &,    -1.948140_t_real,    -1.629033_t_real,    -1.362264_t_real &
       &,    -1.145463_t_real,    -0.971344_t_real,    -0.830614_t_real &
       &,    -0.714368_t_real,    -0.615400_t_real,    -0.528610_t_real &
       &,    -0.450831_t_real,    -0.380394_t_real,    -0.316637_t_real &
       &,    -0.259454_t_real,    -0.208945_t_real,    -0.165180_t_real &
       &,    -0.128070_t_real,    -0.097323_t_real,    -0.072452_t_real &
       &,    -0.052820_t_real,    -0.037703_t_real,    -0.026346_t_real &
       &,    -0.018021_t_real,    -0.012066_t_real,    -0.007907_t_real &
       &,    -0.005071_t_real,    -0.003183_t_real,    -0.001954_t_real &
       &,    -0.001173_t_real,    -0.000688_t_real/
  Data bscoefnrel(1:50, 16) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000003_t_real &
       &,    -0.000019_t_real,    -0.000092_t_real,    -0.000352_t_real &
       &,    -0.001084_t_real,    -0.002307_t_real,    -0.003092_t_real &
       &,    -0.002992_t_real,    -0.002169_t_real,    -0.000856_t_real &
       &,     0.000114_t_real,    -0.001893_t_real,    -0.011849_t_real &
       &,    -0.029698_t_real,    -0.045831_t_real,    -0.056256_t_real &
       &,    -0.062124_t_real,    -0.064361_t_real,    -0.063411_t_real &
       &,    -0.059682_t_real,    -0.053709_t_real,    -0.046167_t_real &
       &,    -0.037821_t_real,    -0.029439_t_real,    -0.021697_t_real &
       &,    -0.015090_t_real,    -0.009873_t_real,    -0.006057_t_real &
       &,    -0.003468_t_real,    -0.001836_t_real,    -0.000882_t_real &
       &,    -0.000368_t_real,    -0.000121_t_real,    -0.000022_t_real &
       &,     0.000003_t_real,    -0.000002_t_real,    -0.000015_t_real &
       &,    -0.000025_t_real,    -0.000028_t_real,    -0.000027_t_real &
       &,    -0.000021_t_real,    -0.000014_t_real,    -0.000007_t_real &
       &,    -0.000002_t_real,     0.000001_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 17) /&
       &    -17.000000_t_real,   -16.991563_t_real,   -16.932259_t_real &
       &,   -16.769557_t_real,   -16.449225_t_real,   -15.925473_t_real &
       &,   -15.183038_t_real,   -14.248341_t_real,   -13.166947_t_real &
       &,   -11.980314_t_real,   -10.742723_t_real,    -9.503680_t_real &
       &,    -8.299652_t_real,    -7.187332_t_real,    -6.203130_t_real &
       &,    -5.335647_t_real,    -4.558775_t_real,    -3.876770_t_real &
       &,    -3.292569_t_real,    -2.774390_t_real,    -2.307878_t_real &
       &,    -1.900916_t_real,    -1.561423_t_real,    -1.288417_t_real &
       &,    -1.073184_t_real,    -0.903456_t_real,    -0.767059_t_real &
       &,    -0.653974_t_real,    -0.557007_t_real,    -0.471592_t_real &
       &,    -0.395197_t_real,    -0.326664_t_real,    -0.265623_t_real &
       &,    -0.212038_t_real,    -0.165908_t_real,    -0.127086_t_real &
       &,    -0.095213_t_real,    -0.069715_t_real,    -0.049857_t_real &
       &,    -0.034809_t_real,    -0.023718_t_real,    -0.015767_t_real &
       &,    -0.010224_t_real,    -0.006466_t_real,    -0.003987_t_real &
       &,    -0.002397_t_real,    -0.001405_t_real,    -0.000802_t_real &
       &,    -0.000446_t_real,    -0.000242_t_real/
  Data bscoefnrel(1:50, 17) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000014_t_real,    -0.000067_t_real,    -0.000251_t_real &
       &,    -0.000743_t_real,    -0.001431_t_real,    -0.001741_t_real &
       &,    -0.001543_t_real,    -0.000947_t_real,    -0.000181_t_real &
       &,    -0.000099_t_real,    -0.002989_t_real,    -0.010840_t_real &
       &,    -0.019619_t_real,    -0.025448_t_real,    -0.028621_t_real &
       &,    -0.029799_t_real,    -0.029316_t_real,    -0.027439_t_real &
       &,    -0.024480_t_real,    -0.020803_t_real,    -0.016800_t_real &
       &,    -0.012846_t_real,    -0.009257_t_real,    -0.006255_t_real &
       &,    -0.003939_t_real,    -0.002296_t_real,    -0.001226_t_real &
       &,    -0.000586_t_real,    -0.000239_t_real,    -0.000071_t_real &
       &,    -0.000004_t_real,     0.000012_t_real,     0.000008_t_real &
       &,    -0.000002_t_real,    -0.000010_t_real,    -0.000014_t_real &
       &,    -0.000015_t_real,    -0.000014_t_real,    -0.000011_t_real &
       &,    -0.000008_t_real,    -0.000006_t_real,    -0.000004_t_real &
       &,    -0.000002_t_real,    -0.000001_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 18) /&
       &    -18.000000_t_real,   -17.990803_t_real,   -17.926151_t_real &
       &,   -17.748758_t_real,   -17.399751_t_real,   -16.830685_t_real &
       &,   -16.028032_t_real,   -15.022596_t_real,   -13.862340_t_real &
       &,   -12.592992_t_real,   -11.275903_t_real,    -9.959308_t_real &
       &,    -8.688772_t_real,    -7.524298_t_real,    -6.487834_t_real &
       &,    -5.556306_t_real,    -4.716822_t_real,    -3.985542_t_real &
       &,    -3.341999_t_real,    -2.760048_t_real,    -2.246488_t_real &
       &,    -1.815274_t_real,    -1.469562_t_real,    -1.200628_t_real &
       &,    -0.993274_t_real,    -0.831316_t_real,    -0.700962_t_real &
       &,    -0.592080_t_real,    -0.498082_t_real,    -0.415180_t_real &
       &,    -0.341493_t_real,    -0.276270_t_real,    -0.219287_t_real &
       &,    -0.170452_t_real,    -0.129556_t_real,    -0.096178_t_real &
       &,    -0.069671_t_real,    -0.049210_t_real,    -0.033870_t_real &
       &,    -0.022706_t_real,    -0.014821_t_real,    -0.009416_t_real &
       &,    -0.005821_t_real,    -0.003501_t_real,    -0.002048_t_real &
       &,    -0.001165_t_real,    -0.000644_t_real,    -0.000346_t_real &
       &,    -0.000181_t_real,    -0.000092_t_real/
  Data bscoefnrel(1:50, 18) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 19) /&
       &    -19.000000_t_real,   -18.990073_t_real,   -18.920275_t_real &
       &,   -18.728740_t_real,   -18.352177_t_real,   -17.739940_t_real &
       &,   -16.880848_t_real,   -15.810315_t_real,   -14.578853_t_real &
       &,   -13.237750_t_real,   -11.854151_t_real,   -10.476356_t_real &
       &,    -9.160151_t_real,    -7.963406_t_real,    -6.892047_t_real &
       &,    -5.920457_t_real,    -5.055784_t_real,    -4.303952_t_real &
       &,    -3.629846_t_real,    -3.026904_t_real,    -2.510432_t_real &
       &,    -2.086831_t_real,    -1.747305_t_real,    -1.475100_t_real &
       &,    -1.254443_t_real,    -1.075827_t_real,    -0.935912_t_real &
       &,    -0.832793_t_real,    -0.761074_t_real,    -0.709729_t_real &
       &,    -0.667617_t_real,    -0.628869_t_real,    -0.591088_t_real &
       &,    -0.553011_t_real,    -0.513774_t_real,    -0.472862_t_real &
       &,    -0.430178_t_real,    -0.386055_t_real,    -0.341198_t_real &
       &,    -0.296568_t_real,    -0.253244_t_real,    -0.212284_t_real &
       &,    -0.174603_t_real,    -0.140880_t_real,    -0.111513_t_real &
       &,    -0.086610_t_real,    -0.066029_t_real,    -0.049430_t_real &
       &,    -0.036353_t_real,    -0.026273_t_real/
  Data bscoefnrel(1:50, 19) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000006_t_real,    -0.000013_t_real,    -0.000021_t_real &
       &,    -0.000027_t_real,    -0.000021_t_real,     0.000001_t_real &
       &,     0.000014_t_real,    -0.000033_t_real,    -0.000101_t_real &
       &,    -0.000121_t_real,    -0.000068_t_real,     0.000002_t_real &
       &,    -0.000123_t_real,    -0.000631_t_real,    -0.001053_t_real &
       &,    -0.001002_t_real,    -0.000576_t_real,    -0.000019_t_real &
       &,     0.000254_t_real,    -0.000452_t_real,    -0.003202_t_real &
       &,    -0.009385_t_real,    -0.020183_t_real,    -0.035263_t_real &
       &,    -0.051139_t_real,    -0.062724_t_real,    -0.069397_t_real &
       &,    -0.072865_t_real,    -0.073260_t_real,    -0.070286_t_real &
       &,    -0.064237_t_real,    -0.055937_t_real,    -0.046436_t_real &
       &,    -0.036755_t_real,    -0.027745_t_real,    -0.020003_t_real &
       &,    -0.013847_t_real,    -0.009330_t_real,    -0.006291_t_real &
       &,    -0.004436_t_real,    -0.003413_t_real,    -0.002897_t_real &
       &,    -0.002629_t_real,    -0.002437_t_real,    -0.002229_t_real &
       &,    -0.001978_t_real,    -0.001689_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 20) /&
       &    -20.000000_t_real,   -19.989326_t_real,   -19.914271_t_real &
       &,   -19.708286_t_real,   -19.303622_t_real,   -18.647611_t_real &
       &,   -17.731716_t_real,   -16.595851_t_real,   -15.293092_t_real &
       &,   -13.881203_t_real,   -12.431403_t_real,   -10.994009_t_real &
       &,    -9.634054_t_real,    -8.401937_t_real,    -7.288900_t_real &
       &,    -6.277539_t_real,    -5.388721_t_real,    -4.604395_t_real &
       &,    -3.895582_t_real,    -3.272154_t_real,    -2.746183_t_real &
       &,    -2.312559_t_real,    -1.955678_t_real,    -1.662577_t_real &
       &,    -1.429205_t_real,    -1.253430_t_real,    -1.123813_t_real &
       &,    -1.022999_t_real,    -0.937777_t_real,    -0.861100_t_real &
       &,    -0.789496_t_real,    -0.720979_t_real,    -0.654215_t_real &
       &,    -0.588385_t_real,    -0.523230_t_real,    -0.459063_t_real &
       &,    -0.396663_t_real,    -0.337083_t_real,    -0.281433_t_real &
       &,    -0.230690_t_real,    -0.185561_t_real,    -0.146423_t_real &
       &,    -0.113319_t_real,    -0.086001_t_real,    -0.063998_t_real &
       &,    -0.046695_t_real,    -0.033403_t_real,    -0.023426_t_real &
       &,    -0.016105_t_real,    -0.010854_t_real/
  Data bscoefnrel(1:50, 20) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 21) /&
       &    -21.000000_t_real,   -20.988534_t_real,   -20.907898_t_real &
       &,   -20.686586_t_real,   -20.252171_t_real,   -19.549932_t_real &
       &,   -18.573994_t_real,   -17.368328_t_real,   -15.988382_t_real &
       &,   -14.498517_t_real,   -12.971940_t_real,   -11.462653_t_real &
       &,   -10.042164_t_real,    -8.750109_t_real,    -7.569109_t_real &
       &,    -6.497780_t_real,    -5.553758_t_real,    -4.704102_t_real &
       &,    -3.940641_t_real,    -3.282919_t_real,    -2.737403_t_real &
       &,    -2.291823_t_real,    -1.928699_t_real,    -1.636978_t_real &
       &,    -1.411171_t_real,    -1.241143_t_real,    -1.110092_t_real &
       &,    -1.002937_t_real,    -0.910430_t_real,    -0.827497_t_real &
       &,    -0.751025_t_real,    -0.678808_t_real,    -0.609289_t_real &
       &,    -0.541595_t_real,    -0.475552_t_real,    -0.411592_t_real &
       &,    -0.350549_t_real,    -0.293425_t_real,    -0.241171_t_real &
       &,    -0.194517_t_real,    -0.153890_t_real,    -0.119387_t_real &
       &,    -0.090804_t_real,    -0.067701_t_real,    -0.049474_t_real &
       &,    -0.035435_t_real,    -0.024872_t_real,    -0.017109_t_real &
       &,    -0.011533_t_real,    -0.007617_t_real/
  Data bscoefnrel(1:50, 21) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000003_t_real,     0.000012_t_real &
       &,     0.000016_t_real,    -0.000020_t_real,    -0.000152_t_real &
       &,    -0.000517_t_real,    -0.001499_t_real,    -0.003938_t_real &
       &,    -0.008037_t_real,    -0.011154_t_real,    -0.012821_t_real &
       &,    -0.014386_t_real,    -0.016402_t_real,    -0.019039_t_real &
       &,    -0.022271_t_real,    -0.025631_t_real,    -0.027836_t_real &
       &,    -0.027272_t_real,    -0.023814_t_real,    -0.019018_t_real &
       &,    -0.014266_t_real,    -0.010121_t_real,    -0.006706_t_real &
       &,    -0.004010_t_real,    -0.001988_t_real,    -0.000575_t_real &
       &,     0.000316_t_real,     0.000790_t_real,     0.000960_t_real &
       &,     0.000932_t_real,     0.000798_t_real,     0.000623_t_real &
       &,     0.000448_t_real,     0.000297_t_real,     0.000176_t_real &
       &,     0.000089_t_real,     0.000029_t_real,    -0.000006_t_real &
       &,    -0.000025_t_real,    -0.000032_t_real,    -0.000032_t_real &
       &,    -0.000028_t_real,    -0.000023_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 22) /&
       &    -22.000000_t_real,   -21.987715_t_real,   -21.901308_t_real &
       &,   -21.664150_t_real,   -21.199032_t_real,   -20.449282_t_real &
       &,   -19.411811_t_real,   -18.134353_t_real,   -16.674844_t_real &
       &,   -15.104312_t_real,   -13.496671_t_real,   -11.911410_t_real &
       &,   -10.423461_t_real,    -9.060361_t_real,    -7.803542_t_real &
       &,    -6.667903_t_real,    -5.656040_t_real,    -4.737934_t_real &
       &,    -3.926369_t_real,    -3.242530_t_real,    -2.684697_t_real &
       &,    -2.234317_t_real,    -1.872475_t_real,    -1.587770_t_real &
       &,    -1.370576_t_real,    -1.205405_t_real,    -1.074905_t_real &
       &,    -0.966476_t_real,    -0.872660_t_real,    -0.788907_t_real &
       &,    -0.712044_t_real,    -0.639732_t_real,    -0.570405_t_real &
       &,    -0.503289_t_real,    -0.438347_t_real,    -0.376101_t_real &
       &,    -0.317397_t_real,    -0.263159_t_real,    -0.214192_t_real &
       &,    -0.171046_t_real,    -0.133962_t_real,    -0.102871_t_real &
       &,    -0.077439_t_real,    -0.057137_t_real,    -0.041318_t_real &
       &,    -0.029280_t_real,    -0.020333_t_real,    -0.013835_t_real &
       &,    -0.009223_t_real,    -0.006024_t_real/
  Data bscoefnrel(1:50, 22) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000007_t_real,     0.000019_t_real &
       &,     0.000007_t_real,    -0.000122_t_real,    -0.000527_t_real &
       &,    -0.001651_t_real,    -0.004687_t_real,    -0.011706_t_real &
       &,    -0.020866_t_real,    -0.026085_t_real,    -0.028971_t_real &
       &,    -0.031976_t_real,    -0.035789_t_real,    -0.040477_t_real &
       &,    -0.045555_t_real,    -0.049464_t_real,    -0.049574_t_real &
       &,    -0.044431_t_real,    -0.035843_t_real,    -0.026694_t_real &
       &,    -0.018563_t_real,    -0.011889_t_real,    -0.006673_t_real &
       &,    -0.002801_t_real,    -0.000130_t_real,     0.001518_t_real &
       &,     0.002344_t_real,     0.002568_t_real,     0.002402_t_real &
       &,     0.002028_t_real,     0.001581_t_real,     0.001148_t_real &
       &,     0.000776_t_real,     0.000482_t_real,     0.000265_t_real &
       &,     0.000117_t_real,     0.000025_t_real,    -0.000025_t_real &
       &,    -0.000047_t_real,    -0.000050_t_real,    -0.000044_t_real &
       &,    -0.000034_t_real,    -0.000024_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 23) /&
       &    -23.000000_t_real,   -22.986870_t_real,   -22.894516_t_real &
       &,   -22.641030_t_real,   -22.144338_t_real,   -21.345924_t_real &
       &,   -20.245591_t_real,   -18.894548_t_real,   -17.353450_t_real &
       &,   -15.699756_t_real,   -14.007414_t_real,   -12.342716_t_real &
       &,   -10.780857_t_real,    -9.337942_t_real,    -8.001582_t_real &
       &,    -6.796358_t_real,    -5.709407_t_real,    -4.727302_t_real &
       &,    -3.877344_t_real,    -3.176225_t_real,    -2.612945_t_real &
       &,    -2.163598_t_real,    -1.807979_t_real,    -1.533016_t_real &
       &,    -1.324670_t_real,    -1.164567_t_real,    -1.036292_t_real &
       &,    -0.929050_t_real,    -0.836273_t_real,    -0.753582_t_real &
       &,    -0.677761_t_real,    -0.606471_t_real,    -0.538234_t_real &
       &,    -0.472415_t_real,    -0.409094_t_real,    -0.348852_t_real &
       &,    -0.292518_t_real,    -0.240939_t_real,    -0.194798_t_real &
       &,    -0.154513_t_real,    -0.120197_t_real,    -0.091676_t_real &
       &,    -0.068543_t_real,    -0.050230_t_real,    -0.036073_t_real &
       &,    -0.025386_t_real,    -0.017504_t_real,    -0.011824_t_real &
       &,    -0.007824_t_real,    -0.005070_t_real/
  Data bscoefnrel(1:50, 23) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000002_t_real,     0.000009_t_real,     0.000020_t_real &
       &,    -0.000036_t_real,    -0.000327_t_real,    -0.001194_t_real &
       &,    -0.003619_t_real,    -0.010091_t_real,    -0.023394_t_real &
       &,    -0.036487_t_real,    -0.042562_t_real,    -0.046308_t_real &
       &,    -0.050467_t_real,    -0.055586_t_real,    -0.061413_t_real &
       &,    -0.066701_t_real,    -0.068697_t_real,    -0.064375_t_real &
       &,    -0.053950_t_real,    -0.041047_t_real,    -0.028861_t_real &
       &,    -0.018666_t_real,    -0.010647_t_real,    -0.004648_t_real &
       &,    -0.000439_t_real,     0.002233_t_real,     0.003653_t_real &
       &,     0.004126_t_real,     0.003957_t_real,     0.003419_t_real &
       &,     0.002728_t_real,     0.002034_t_real,     0.001420_t_real &
       &,     0.000923_t_real,     0.000548_t_real,     0.000287_t_real &
       &,     0.000118_t_real,     0.000022_t_real,    -0.000024_t_real &
       &,    -0.000037_t_real,    -0.000032_t_real,    -0.000020_t_real &
       &,    -0.000008_t_real,     0.000002_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 24) /&
       &    -24.000000_t_real,   -23.985974_t_real,   -23.887306_t_real &
       &,   -23.616499_t_real,   -23.086359_t_real,   -22.236452_t_real &
       &,   -21.069329_t_real,   -19.639156_t_real,   -18.009329_t_real &
       &,   -16.262841_t_real,   -14.473220_t_real,   -12.713869_t_real &
       &,   -11.057495_t_real,    -9.511836_t_real,    -8.075589_t_real &
       &,    -6.773886_t_real,    -5.588982_t_real,    -4.530548_t_real &
       &,    -3.635025_t_real,    -2.914026_t_real,    -2.349182_t_real &
       &,    -1.910222_t_real,    -1.570069_t_real,    -1.309126_t_real &
       &,    -1.111221_t_real,    -0.960023_t_real,    -0.841750_t_real &
       &,    -0.747027_t_real,    -0.669268_t_real,    -0.603229_t_real &
       &,    -0.544671_t_real,    -0.490436_t_real,    -0.438499_t_real &
       &,    -0.387873_t_real,    -0.338405_t_real,    -0.290507_t_real &
       &,    -0.244917_t_real,    -0.202474_t_real,    -0.163959_t_real &
       &,    -0.129962_t_real,    -0.100804_t_real,    -0.076510_t_real &
       &,    -0.056839_t_real,    -0.041347_t_real,    -0.029464_t_real &
       &,    -0.020578_t_real,    -0.014090_t_real,    -0.009462_t_real &
       &,    -0.006232_t_real,    -0.004027_t_real/
  Data bscoefnrel(1:50, 24) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000008_t_real,    -0.000017_t_real,    -0.000025_t_real &
       &,    -0.000024_t_real,     0.000003_t_real,     0.000031_t_real &
       &,    -0.000142_t_real,    -0.000793_t_real,    -0.002509_t_real &
       &,    -0.007199_t_real,    -0.019426_t_real,    -0.041279_t_real &
       &,    -0.058140_t_real,    -0.065366_t_real,    -0.070301_t_real &
       &,    -0.076013_t_real,    -0.083546_t_real,    -0.093482_t_real &
       &,    -0.105688_t_real,    -0.118423_t_real,    -0.128422_t_real &
       &,    -0.133694_t_real,    -0.134941_t_real,    -0.132772_t_real &
       &,    -0.126707_t_real,    -0.116533_t_real,    -0.102920_t_real &
       &,    -0.087151_t_real,    -0.070675_t_real,    -0.054805_t_real &
       &,    -0.040548_t_real,    -0.028559_t_real,    -0.019131_t_real &
       &,    -0.012242_t_real,    -0.007609_t_real,    -0.004780_t_real &
       &,    -0.003233_t_real,    -0.002482_t_real,    -0.002141_t_real &
       &,    -0.001952_t_real,    -0.001777_t_real,    -0.001565_t_real &
       &,    -0.001317_t_real,    -0.001057_t_real,    -0.000811_t_real &
       &,    -0.000595_t_real,    -0.000420_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 25) /&
       &    -25.000000_t_real,   -24.985109_t_real,   -24.880347_t_real &
       &,   -24.592813_t_real,   -24.030465_t_real,   -23.131434_t_real &
       &,   -21.901514_t_real,   -20.398033_t_real,   -18.688039_t_real &
       &,   -16.860093_t_real,   -14.988458_t_real,   -13.154370_t_real &
       &,   -11.425614_t_real,    -9.804186_t_real,    -8.302632_t_real &
       &,    -6.940631_t_real,    -5.703290_t_real,    -4.619101_t_real &
       &,    -3.721562_t_real,    -3.007970_t_real,    -2.449409_t_real &
       &,    -2.014191_t_real,    -1.679450_t_real,    -1.426685_t_real &
       &,    -1.235208_t_real,    -1.085561_t_real,    -0.964015_t_real &
       &,    -0.861918_t_real,    -0.773500_t_real,    -0.694546_t_real &
       &,    -0.621922_t_real,    -0.553477_t_real,    -0.488006_t_real &
       &,    -0.425139_t_real,    -0.365138_t_real,    -0.308648_t_real &
       &,    -0.256452_t_real,    -0.209264_t_real,    -0.167592_t_real &
       &,    -0.131668_t_real,    -0.101444_t_real,    -0.076623_t_real &
       &,    -0.056725_t_real,    -0.041150_t_real,    -0.029244_t_real &
       &,    -0.020355_t_real,    -0.013874_t_real,    -0.009259_t_real &
       &,    -0.006049_t_real,    -0.003868_t_real/
  Data bscoefnrel(1:50, 25) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000003_t_real,     0.000013_t_real,    -0.000006_t_real &
       &,    -0.000254_t_real,    -0.001152_t_real,    -0.003768_t_real &
       &,    -0.011119_t_real,    -0.029145_t_real,    -0.055173_t_real &
       &,    -0.070139_t_real,    -0.076173_t_real,    -0.080948_t_real &
       &,    -0.086417_t_real,    -0.092487_t_real,    -0.097816_t_real &
       &,    -0.099336_t_real,    -0.093165_t_real,    -0.078569_t_real &
       &,    -0.059725_t_real,    -0.041483_t_real,    -0.026212_t_real &
       &,    -0.014341_t_real,    -0.005587_t_real,     0.000477_t_real &
       &,     0.004284_t_real,     0.006269_t_real,     0.006875_t_real &
       &,     0.006537_t_real,     0.005649_t_real,     0.004530_t_real &
       &,     0.003405_t_real,     0.002407_t_real,     0.001596_t_real &
       &,     0.000985_t_real,     0.000559_t_real,     0.000289_t_real &
       &,     0.000138_t_real,     0.000070_t_real,     0.000053_t_real &
       &,     0.000060_t_real,     0.000072_t_real,     0.000081_t_real &
       &,     0.000081_t_real,     0.000075_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 26) /&
       &    -26.000000_t_real,   -25.984197_t_real,   -25.873014_t_real &
       &,   -25.567867_t_real,   -24.971652_t_real,   -24.021021_t_real &
       &,   -22.724845_t_real,   -21.143172_t_real,   -19.346832_t_real &
       &,   -17.428784_t_real,   -15.464506_t_real,   -13.542171_t_real &
       &,   -11.723359_t_real,   -10.009932_t_real,    -8.427125_t_real &
       &,    -6.984344_t_real,    -5.681029_t_real,    -4.561296_t_real &
       &,    -3.652691_t_real,    -2.940756_t_real,    -2.389237_t_real &
       &,    -1.963570_t_real,    -1.638289_t_real,    -1.391789_t_real &
       &,    -1.202996_t_real,    -1.054323_t_real,    -0.933460_t_real &
       &,    -0.832144_t_real,    -0.744508_t_real,    -0.666179_t_real &
       &,    -0.593980_t_real,    -0.525847_t_real,    -0.460740_t_real &
       &,    -0.398460_t_real,    -0.339403_t_real,    -0.284278_t_real &
       &,    -0.233855_t_real,    -0.188780_t_real,    -0.149452_t_real &
       &,    -0.115981_t_real,    -0.088199_t_real,    -0.065708_t_real &
       &,    -0.047947_t_real,    -0.034263_t_real,    -0.023974_t_real &
       &,    -0.016422_t_real,    -0.011012_t_real,    -0.007227_t_real &
       &,    -0.004642_t_real,    -0.002917_t_real/
  Data bscoefnrel(1:50, 26) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000003_t_real,     0.000007_t_real,    -0.000030_t_real &
       &,    -0.000312_t_real,    -0.001260_t_real,    -0.004025_t_real &
       &,    -0.011742_t_real,    -0.029188_t_real,    -0.049258_t_real &
       &,    -0.058481_t_real,    -0.062284_t_real,    -0.065434_t_real &
       &,    -0.068781_t_real,    -0.071882_t_real,    -0.073317_t_real &
       &,    -0.070746_t_real,    -0.062411_t_real,    -0.049509_t_real &
       &,    -0.035500_t_real,    -0.023072_t_real,    -0.013174_t_real &
       &,    -0.005781_t_real,    -0.000578_t_real,     0.002794_t_real &
       &,     0.004681_t_real,     0.005420_t_real,     0.005341_t_real &
       &,     0.004751_t_real,     0.003910_t_real,     0.003015_t_real &
       &,     0.002191_t_real,     0.001500_t_real,     0.000960_t_real &
       &,     0.000565_t_real,     0.000294_t_real,     0.000122_t_real &
       &,     0.000025_t_real,    -0.000021_t_real,    -0.000035_t_real &
       &,    -0.000031_t_real,    -0.000021_t_real,    -0.000009_t_real &
       &,     0.000000_t_real,     0.000006_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 27) /&
       &    -27.000000_t_real,   -26.983261_t_real,   -26.865484_t_real &
       &,   -26.542258_t_real,   -25.911344_t_real,   -24.908013_t_real &
       &,   -23.544203_t_real,   -21.882454_t_real,   -19.997700_t_real &
       &,   -17.986394_t_real,   -15.926237_t_real,   -13.911325_t_real &
       &,   -11.996711_t_real,   -10.188918_t_real,    -8.521082_t_real &
       &,    -6.995845_t_real,    -5.633455_t_real,    -4.486602_t_real &
       &,    -3.572869_t_real,    -2.866006_t_real,    -2.323350_t_real &
       &,    -1.907742_t_real,    -1.591575_t_real,    -1.351578_t_real &
       &,    -1.166901_t_real,    -1.021095_t_real,    -0.902581_t_real &
       &,    -0.803284_t_real,    -0.717301_t_real,    -0.640243_t_real &
       &,    -0.569007_t_real,    -0.501683_t_real,    -0.437407_t_real &
       &,    -0.376131_t_real,    -0.318341_t_real,    -0.264775_t_real &
       &,    -0.216169_t_real,    -0.173095_t_real,    -0.135858_t_real &
       &,    -0.104471_t_real,    -0.078680_t_real,    -0.058019_t_real &
       &,    -0.041882_t_real,    -0.029591_t_real,    -0.020460_t_real &
       &,    -0.013843_t_real,    -0.009164_t_real,    -0.005934_t_real &
       &,    -0.003759_t_real,    -0.002329_t_real/
  Data bscoefnrel(1:50, 27) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000002_t_real,     0.000003_t_real,    -0.000045_t_real &
       &,    -0.000327_t_real,    -0.001237_t_real,    -0.003898_t_real &
       &,    -0.011202_t_real,    -0.026006_t_real,    -0.039460_t_real &
       &,    -0.044681_t_real,    -0.046930_t_real,    -0.048782_t_real &
       &,    -0.050509_t_real,    -0.051586_t_real,    -0.050859_t_real &
       &,    -0.046907_t_real,    -0.039326_t_real,    -0.029672_t_real &
       &,    -0.020204_t_real,    -0.012266_t_real,    -0.006181_t_real &
       &,    -0.001800_t_real,     0.001144_t_real,     0.002922_t_real &
       &,     0.003783_t_real,     0.003964_t_real,     0.003688_t_real &
       &,     0.003151_t_real,     0.002513_t_real,     0.001887_t_real &
       &,     0.001339_t_real,     0.000894_t_real,     0.000556_t_real &
       &,     0.000314_t_real,     0.000150_t_real,     0.000048_t_real &
       &,    -0.000009_t_real,    -0.000036_t_real,    -0.000044_t_real &
       &,    -0.000041_t_real,    -0.000033_t_real,    -0.000025_t_real &
       &,    -0.000017_t_real,    -0.000010_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 28) /&
       &    -28.000000_t_real,   -27.982301_t_real,   -27.857761_t_real &
       &,   -27.515998_t_real,   -26.849570_t_real,   -25.792465_t_real &
       &,   -24.359656_t_real,   -22.615975_t_real,   -20.640738_t_real &
       &,   -18.533033_t_real,   -16.373885_t_real,   -14.262059_t_real &
       &,   -12.246772_t_real,   -10.342903_t_real,    -8.586151_t_real &
       &,    -6.980112_t_real,    -5.566870_t_real,    -4.400860_t_real &
       &,    -3.487108_t_real,    -2.788106_t_real,    -2.255744_t_real &
       &,    -1.850702_t_real,    -1.543745_t_real,    -1.310655_t_real &
       &,    -1.130918_t_real,    -0.988869_t_real,    -0.873404_t_real &
       &,    -0.776588_t_real,    -0.692552_t_real,    -0.616974_t_real &
       &,    -0.546889_t_real,    -0.480560_t_real,    -0.417290_t_real &
       &,    -0.357156_t_real,    -0.300709_t_real,    -0.248693_t_real &
       &,    -0.201805_t_real,    -0.160547_t_real,    -0.125144_t_real &
       &,    -0.095534_t_real,    -0.071398_t_real,    -0.052224_t_real &
       &,    -0.037378_t_real,    -0.026172_t_real,    -0.017925_t_real &
       &,    -0.012008_t_real,    -0.007866_t_real,    -0.005039_t_real &
       &,    -0.003155_t_real,    -0.001932_t_real/
  Data bscoefnrel(1:50, 28) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000000_t_real,    -0.000047_t_real &
       &,    -0.000288_t_real,    -0.001047_t_real,    -0.003273_t_real &
       &,    -0.009206_t_real,    -0.019720_t_real,    -0.027321_t_real &
       &,    -0.029943_t_real,    -0.031111_t_real,    -0.032013_t_real &
       &,    -0.032662_t_real,    -0.032631_t_real,    -0.031170_t_real &
       &,    -0.027615_t_real,    -0.022159_t_real,    -0.015994_t_real &
       &,    -0.010355_t_real,    -0.005827_t_real,    -0.002472_t_real &
       &,    -0.000139_t_real,     0.001358_t_real,     0.002193_t_real &
       &,     0.002523_t_real,     0.002493_t_real,     0.002233_t_real &
       &,     0.001855_t_real,     0.001446_t_real,     0.001065_t_real &
       &,     0.000741_t_real,     0.000485_t_real,     0.000294_t_real &
       &,     0.000160_t_real,     0.000071_t_real,     0.000016_t_real &
       &,    -0.000014_t_real,    -0.000027_t_real,    -0.000030_t_real &
       &,    -0.000028_t_real,    -0.000023_t_real,    -0.000017_t_real &
       &,    -0.000013_t_real,    -0.000009_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 29) /&
       &    -29.000000_t_real,   -28.981285_t_real,   -28.849584_t_real &
       &,   -28.488208_t_real,   -27.784245_t_real,   -26.670259_t_real &
       &,   -25.163937_t_real,   -23.331963_t_real,   -21.257880_t_real &
       &,   -19.042253_t_real,   -16.770103_t_real,   -14.543433_t_real &
       &,   -12.407656_t_real,   -10.387948_t_real,    -8.518847_t_real &
       &,    -6.814543_t_real,    -5.337866_t_real,    -4.142723_t_real &
       &,    -3.224373_t_real,    -2.537039_t_real,    -2.026291_t_real &
       &,    -1.646400_t_real,    -1.362780_t_real,    -1.149299_t_real &
       &,    -0.986279_t_real,    -0.859337_t_real,    -0.758099_t_real &
       &,    -0.674916_t_real,    -0.604005_t_real,    -0.541047_t_real &
       &,    -0.483034_t_real,    -0.428136_t_real,    -0.375513_t_real &
       &,    -0.325064_t_real,    -0.277147_t_real,    -0.232344_t_real &
       &,    -0.191268_t_real,    -0.154441_t_real,    -0.122212_t_real &
       &,    -0.094717_t_real,    -0.071868_t_real,    -0.053379_t_real &
       &,    -0.038809_t_real,    -0.027622_t_real,    -0.019249_t_real &
       &,    -0.013136_t_real,    -0.008780_t_real,    -0.005747_t_real &
       &,    -0.003685_t_real,    -0.002314_t_real/
  Data bscoefnrel(1:50, 29) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000003_t_real &
       &,    -0.000010_t_real,    -0.000021_t_real,    -0.000031_t_real &
       &,    -0.000027_t_real,    -0.000002_t_real,    -0.000007_t_real &
       &,    -0.000079_t_real,    -0.000086_t_real,     0.000100_t_real &
       &,     0.000477_t_real,     0.000662_t_real,     0.000472_t_real &
       &,     0.000445_t_real,     0.000742_t_real,     0.001065_t_real &
       &,     0.000717_t_real,    -0.001395_t_real,    -0.006463_t_real &
       &,    -0.015022_t_real,    -0.026232_t_real,    -0.038080_t_real &
       &,    -0.048359_t_real,    -0.055439_t_real,    -0.058535_t_real &
       &,    -0.057688_t_real,    -0.053553_t_real,    -0.047116_t_real &
       &,    -0.039429_t_real,    -0.031436_t_real,    -0.023877_t_real &
       &,    -0.017257_t_real,    -0.011855_t_real,    -0.007754_t_real &
       &,    -0.004881_t_real,    -0.003045_t_real,    -0.001993_t_real &
       &,    -0.001462_t_real,    -0.001223_t_real,    -0.001112_t_real &
       &,    -0.001027_t_real,    -0.000925_t_real,    -0.000797_t_real &
       &,    -0.000653_t_real,    -0.000510_t_real,    -0.000380_t_real &
       &,    -0.000272_t_real,    -0.000187_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 30) /&
       &    -30.000000_t_real,   -29.980310_t_real,   -29.841741_t_real &
       &,   -29.461548_t_real,   -28.721696_t_real,   -27.553877_t_real &
       &,   -25.978945_t_real,   -24.065872_t_real,   -21.903260_t_real &
       &,   -19.593401_t_real,   -17.227085_t_real,   -14.908552_t_real &
       &,   -12.680644_t_real,   -10.579300_t_real,    -8.637448_t_real &
       &,    -6.884383_t_real,    -5.395173_t_real,    -4.211411_t_real &
       &,    -3.309502_t_real,    -2.632247_t_real,    -2.123374_t_real &
       &,    -1.740441_t_real,    -1.452065_t_real,    -1.233222_t_real &
       &,    -1.064199_t_real,    -0.930471_t_real,    -0.821600_t_real &
       &,    -0.729939_t_real,    -0.649823_t_real,    -0.577202_t_real &
       &,    -0.509453_t_real,    -0.445189_t_real,    -0.384003_t_real &
       &,    -0.326163_t_real,    -0.272302_t_real,    -0.223148_t_real &
       &,    -0.179316_t_real,    -0.141189_t_real,    -0.108862_t_real &
       &,    -0.082159_t_real,    -0.060669_t_real,    -0.043822_t_real &
       &,    -0.030954_t_real,    -0.021378_t_real,    -0.014433_t_real &
       &,    -0.009524_t_real,    -0.006142_t_real,    -0.003871_t_real &
       &,    -0.002383_t_real,    -0.001433_t_real/
  Data bscoefnrel(1:50, 30) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 31) /&
       &    -31.000000_t_real,   -30.979338_t_real,   -30.833917_t_real &
       &,   -30.434954_t_real,   -29.659389_t_real,   -28.438269_t_real &
       &,   -26.795682_t_real,   -24.803008_t_real,   -22.554198_t_real &
       &,   -20.153078_t_real,   -17.697177_t_real,   -15.291781_t_real &
       &,   -12.979642_t_real,   -10.806710_t_real,    -8.805344_t_real &
       &,    -7.023371_t_real,    -5.540722_t_real,    -4.381104_t_real &
       &,    -3.501308_t_real,    -2.834816_t_real,    -2.326034_t_real &
       &,    -1.936515_t_real,    -1.636677_t_real,    -1.401748_t_real &
       &,    -1.213317_t_real,    -1.059197_t_real,    -0.931268_t_real &
       &,    -0.823650_t_real,    -0.731800_t_real,    -0.652170_t_real &
       &,    -0.582014_t_real,    -0.519224_t_real,    -0.462183_t_real &
       &,    -0.409673_t_real,    -0.360841_t_real,    -0.315166_t_real &
       &,    -0.272413_t_real,    -0.232574_t_real,    -0.195803_t_real &
       &,    -0.162334_t_real,    -0.132403_t_real,    -0.106169_t_real &
       &,    -0.083668_t_real,    -0.064795_t_real,    -0.049314_t_real &
       &,    -0.036891_t_real,    -0.027131_t_real,    -0.019620_t_real &
       &,    -0.013954_t_real,    -0.009761_t_real/
  Data bscoefnrel(1:50, 31) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,     0.000000_t_real &
       &,    -0.000008_t_real,    -0.000036_t_real,    -0.000080_t_real &
       &,    -0.000080_t_real,    -0.000027_t_real,     0.000055_t_real &
       &,     0.000064_t_real,    -0.000105_t_real,    -0.000243_t_real &
       &,    -0.000199_t_real,    -0.000007_t_real,     0.000166_t_real &
       &,    -0.000090_t_real,    -0.001536_t_real,    -0.005077_t_real &
       &,    -0.010974_t_real,    -0.018338_t_real,    -0.025875_t_real &
       &,    -0.032707_t_real,    -0.038367_t_real,    -0.042561_t_real &
       &,    -0.045059_t_real,    -0.045689_t_real,    -0.044399_t_real &
       &,    -0.041315_t_real,    -0.036773_t_real,    -0.031286_t_real &
       &,    -0.025433_t_real,    -0.019751_t_real,    -0.014656_t_real &
       &,    -0.010421_t_real,    -0.007171_t_real,    -0.004892_t_real &
       &,    -0.003455_t_real,    -0.002656_t_real,    -0.002274_t_real &
       &,    -0.002109_t_real,    -0.002019_t_real,    -0.001915_t_real &
       &,    -0.001762_t_real,    -0.001559_t_real,    -0.001324_t_real &
       &,    -0.001081_t_real,    -0.000849_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 32) /&
       &    -32.000000_t_real,   -31.978351_t_real,   -31.825978_t_real &
       &,   -31.407976_t_real,   -30.596260_t_real,   -29.321373_t_real &
       &,   -27.610608_t_real,   -25.537836_t_real,   -23.202470_t_real &
       &,   -20.709816_t_real,   -18.164773_t_real,   -15.672520_t_real &
       &,   -13.278058_t_real,   -11.035510_t_real,    -8.979315_t_real &
       &,    -7.175814_t_real,    -5.701599_t_real,    -4.558125_t_real &
       &,    -3.684272_t_real,    -3.010032_t_real,    -2.485920_t_real &
       &,    -2.077675_t_real,    -1.755099_t_real,    -1.494282_t_real &
       &,    -1.280234_t_real,    -1.103808_t_real,    -0.958190_t_real &
       &,    -0.837322_t_real,    -0.735653_t_real,    -0.648321_t_real &
       &,    -0.571379_t_real,    -0.501910_t_real,    -0.438023_t_real &
       &,    -0.378703_t_real,    -0.323577_t_real,    -0.272655_t_real &
       &,    -0.226142_t_real,    -0.184308_t_real,    -0.147400_t_real &
       &,    -0.115558_t_real,    -0.088757_t_real,    -0.066774_t_real &
       &,    -0.049210_t_real,    -0.035533_t_real,    -0.025147_t_real &
       &,    -0.017448_t_real,    -0.011871_t_real,    -0.007922_t_real &
       &,    -0.005185_t_real,    -0.003329_t_real/
  Data bscoefnrel(1:50, 32) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,    -0.000003_t_real &
       &,    -0.000026_t_real,    -0.000111_t_real,    -0.000232_t_real &
       &,    -0.000226_t_real,    -0.000076_t_real,     0.000108_t_real &
       &,    -0.000041_t_real,    -0.000646_t_real,    -0.000965_t_real &
       &,    -0.000716_t_real,    -0.000097_t_real,     0.000227_t_real &
       &,    -0.001270_t_real,    -0.007051_t_real,    -0.018830_t_real &
       &,    -0.034732_t_real,    -0.050559_t_real,    -0.063531_t_real &
       &,    -0.072729_t_real,    -0.077975_t_real,    -0.079308_t_real &
       &,    -0.076949_t_real,    -0.071368_t_real,    -0.063315_t_real &
       &,    -0.053737_t_real,    -0.043628_t_real,    -0.033855_t_real &
       &,    -0.025061_t_real,    -0.017649_t_real,    -0.011818_t_real &
       &,    -0.007584_t_real,    -0.004794_t_real,    -0.003164_t_real &
       &,    -0.002342_t_real,    -0.001991_t_real,    -0.001846_t_real &
       &,    -0.001741_t_real,    -0.001597_t_real,    -0.001399_t_real &
       &,    -0.001166_t_real,    -0.000925_t_real,    -0.000700_t_real &
       &,    -0.000508_t_real,    -0.000355_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 33) /&
       &    -33.000000_t_real,   -32.977351_t_real,   -32.817926_t_real &
       &,   -32.380620_t_real,   -31.532327_t_real,   -30.203218_t_real &
       &,   -28.423755_t_real,   -26.270420_t_real,   -23.848095_t_real &
       &,   -21.263705_t_real,   -18.629835_t_real,   -16.050699_t_real &
       &,   -13.575787_t_real,   -11.265211_t_real,    -9.159096_t_real &
       &,    -7.339606_t_real,    -5.872249_t_real,    -4.734200_t_real &
       &,    -3.851065_t_real,    -3.156502_t_real,    -2.608757_t_real &
       &,    -2.173439_t_real,    -1.820132_t_real,    -1.529632_t_real &
       &,    -1.291428_t_real,    -1.097786_t_real,    -0.940907_t_real &
       &,    -0.812762_t_real,    -0.705876_t_real,    -0.614051_t_real &
       &,    -0.532743_t_real,    -0.459061_t_real,    -0.391496_t_real &
       &,    -0.329489_t_real,    -0.273009_t_real,    -0.222235_t_real &
       &,    -0.177385_t_real,    -0.138611_t_real,    -0.105913_t_real &
       &,    -0.079086_t_real,    -0.057699_t_real,    -0.041136_t_real &
       &,    -0.028669_t_real,    -0.019540_t_real,    -0.013028_t_real &
       &,    -0.008500_t_real,    -0.005428_t_real,    -0.003392_t_real &
       &,    -0.002074_t_real,    -0.001241_t_real/
  Data bscoefnrel(1:50, 33) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000000_t_real,    -0.000008_t_real &
       &,    -0.000057_t_real,    -0.000231_t_real,    -0.000457_t_real &
       &,    -0.000421_t_real,    -0.000126_t_real,     0.000149_t_real &
       &,    -0.000395_t_real,    -0.001614_t_real,    -0.002022_t_real &
       &,    -0.001314_t_real,    -0.000077_t_real,    -0.000032_t_real &
       &,    -0.004865_t_real,    -0.019221_t_real,    -0.042842_t_real &
       &,    -0.068065_t_real,    -0.088135_t_real,    -0.101177_t_real &
       &,    -0.107491_t_real,    -0.107767_t_real,    -0.102819_t_real &
       &,    -0.093674_t_real,    -0.081589_t_real,    -0.067945_t_real &
       &,    -0.054069_t_real,    -0.041056_t_real,    -0.029659_t_real &
       &,    -0.020300_t_real,    -0.013124_t_real,    -0.008054_t_real &
       &,    -0.004820_t_real,    -0.003006_t_real,    -0.002142_t_real &
       &,    -0.001798_t_real,    -0.001659_t_real,    -0.001546_t_real &
       &,    -0.001386_t_real,    -0.001174_t_real,    -0.000940_t_real &
       &,    -0.000712_t_real,    -0.000513_t_real,    -0.000353_t_real &
       &,    -0.000233_t_real,    -0.000148_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 34) /&
       &    -34.000000_t_real,   -33.976339_t_real,   -33.809780_t_real &
       &,   -33.352954_t_real,   -32.467752_t_real,   -31.084116_t_real &
       &,   -29.235642_t_real,   -27.001590_t_real,   -24.492235_t_real &
       &,   -21.816438_t_real,   -19.094498_t_real,   -16.429186_t_real &
       &,   -13.876392_t_real,   -11.500223_t_real,    -9.350155_t_real &
       &,    -7.519339_t_real,    -6.055572_t_real,    -4.912371_t_real &
       &,    -4.009223_t_real,    -3.289859_t_real,    -2.717679_t_real &
       &,    -2.254787_t_real,    -1.872998_t_real,    -1.558698_t_real &
       &,    -1.303788_t_real,    -1.099581_t_real,    -0.936026_t_real &
       &,    -0.803066_t_real,    -0.692004_t_real,    -0.596222_t_real &
       &,    -0.511273_t_real,    -0.434565_t_real,    -0.364878_t_real &
       &,    -0.301858_t_real,    -0.245571_t_real,    -0.196183_t_real &
       &,    -0.153746_t_real,    -0.118108_t_real,    -0.088889_t_real &
       &,    -0.065515_t_real,    -0.047276_t_real,    -0.033394_t_real &
       &,    -0.023088_t_real,    -0.015624_t_real,    -0.010348_t_real &
       &,    -0.006708_t_real,    -0.004256_t_real,    -0.002642_t_real &
       &,    -0.001605_t_real,    -0.000953_t_real/
  Data bscoefnrel(1:50, 34) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000008_t_real &
       &,    -0.000052_t_real,    -0.000204_t_real,    -0.000381_t_real &
       &,    -0.000331_t_real,    -0.000082_t_real,     0.000074_t_real &
       &,    -0.000546_t_real,    -0.001511_t_real,    -0.001659_t_real &
       &,    -0.000916_t_real,     0.000048_t_real,    -0.000626_t_real &
       &,    -0.006499_t_real,    -0.020175_t_real,    -0.037539_t_real &
       &,    -0.051775_t_real,    -0.060601_t_real,    -0.064457_t_real &
       &,    -0.064140_t_real,    -0.060411_t_real,    -0.054083_t_real &
       &,    -0.046053_t_real,    -0.037259_t_real,    -0.028585_t_real &
       &,    -0.020749_t_real,    -0.014222_t_real,    -0.009190_t_real &
       &,    -0.005589_t_real,    -0.003189_t_real,    -0.001694_t_real &
       &,    -0.000824_t_real,    -0.000355_t_real,    -0.000126_t_real &
       &,    -0.000030_t_real,    -0.000002_t_real,    -0.000002_t_real &
       &,    -0.000010_t_real,    -0.000017_t_real,    -0.000021_t_real &
       &,    -0.000020_t_real,    -0.000017_t_real,    -0.000012_t_real &
       &,    -0.000008_t_real,    -0.000004_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 35) /&
       &    -35.000000_t_real,   -34.975312_t_real,   -34.801513_t_real &
       &,   -34.324884_t_real,   -33.402314_t_real,   -31.963629_t_real &
       &,   -30.045502_t_real,   -27.730142_t_real,   -25.133049_t_real &
       &,   -22.365464_t_real,   -19.555140_t_real,   -16.803298_t_real &
       &,   -14.173597_t_real,   -11.732766_t_real,    -9.542581_t_real &
       &,    -7.700968_t_real,    -6.233011_t_real,    -5.071920_t_real &
       &,    -4.139574_t_real,    -3.391441_t_real,    -2.788428_t_real &
       &,    -2.291018_t_real,    -1.878948_t_real,    -1.543873_t_real &
       &,    -1.277309_t_real,    -1.067542_t_real,    -0.901435_t_real &
       &,    -0.766870_t_real,    -0.654226_t_real,    -0.556782_t_real &
       &,    -0.470402_t_real,    -0.392906_t_real,    -0.323391_t_real &
       &,    -0.261644_t_real,    -0.207696_t_real,    -0.161541_t_real &
       &,    -0.122973_t_real,    -0.091549_t_real,    -0.066610_t_real &
       &,    -0.047342_t_real,    -0.032855_t_real,    -0.022259_t_real &
       &,    -0.014717_t_real,    -0.009495_t_real,    -0.005977_t_real &
       &,    -0.003670_t_real,    -0.002198_t_real,    -0.001283_t_real &
       &,    -0.000731_t_real,    -0.000405_t_real/
  Data bscoefnrel(1:50, 35) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000006_t_real &
       &,    -0.000034_t_real,    -0.000129_t_real,    -0.000226_t_real &
       &,    -0.000184_t_real,    -0.000034_t_real,     0.000012_t_real &
       &,    -0.000434_t_real,    -0.000949_t_real,    -0.000925_t_real &
       &,    -0.000413_t_real,     0.000060_t_real,    -0.000904_t_real &
       &,    -0.005511_t_real,    -0.013813_t_real,    -0.021864_t_real &
       &,    -0.027092_t_real,    -0.029521_t_real,    -0.029696_t_real &
       &,    -0.028096_t_real,    -0.025176_t_real,    -0.021402_t_real &
       &,    -0.017246_t_real,    -0.013141_t_real,    -0.009439_t_real &
       &,    -0.006369_t_real,    -0.004022_t_real,    -0.002369_t_real &
       &,    -0.001293_t_real,    -0.000647_t_real,    -0.000288_t_real &
       &,    -0.000108_t_real,    -0.000029_t_real,    -0.000002_t_real &
       &,     0.000002_t_real,    -0.000003_t_real,    -0.000008_t_real &
       &,    -0.000011_t_real,    -0.000011_t_real,    -0.000010_t_real &
       &,    -0.000009_t_real,    -0.000006_t_real,    -0.000005_t_real &
       &,    -0.000003_t_real,    -0.000002_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 36) /&
       &    -36.000000_t_real,   -35.974270_t_real,   -35.793127_t_real &
       &,   -35.296417_t_real,   -34.336032_t_real,   -32.841787_t_real &
       &,   -30.853372_t_real,   -28.456141_t_real,   -25.770594_t_real &
       &,   -22.910905_t_real,   -20.011790_t_real,   -17.173212_t_real &
       &,   -14.467354_t_real,   -11.963059_t_real,    -9.736088_t_real &
       &,    -7.882243_t_real,    -6.400924_t_real,    -5.210989_t_real &
       &,    -4.244375_t_real,    -3.463306_t_real,    -2.822247_t_real &
       &,    -2.288051_t_real,    -1.849894_t_real,    -1.501062_t_real &
       &,    -1.229656_t_real,    -1.019655_t_real,    -0.854760_t_real &
       &,    -0.721246_t_real,    -0.609093_t_real,    -0.511851_t_real &
       &,    -0.425874_t_real,    -0.349419_t_real,    -0.281839_t_real &
       &,    -0.222966_t_real,    -0.172705_t_real,    -0.130807_t_real &
       &,    -0.096777_t_real,    -0.069883_t_real,    -0.049221_t_real &
       &,    -0.033798_t_real,    -0.022617_t_real,    -0.014744_t_real &
       &,    -0.009362_t_real,    -0.005789_t_real,    -0.003485_t_real &
       &,    -0.002042_t_real,    -0.001164_t_real,    -0.000646_t_real &
       &,    -0.000348_t_real,    -0.000183_t_real/
  Data bscoefnrel(1:50, 36) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 37) /&
       &    -37.000000_t_real,   -36.973257_t_real,   -36.784967_t_real &
       &,   -36.268720_t_real,   -35.271675_t_real,   -33.724013_t_real &
       &,   -31.668632_t_real,   -29.194444_t_real,   -26.426904_t_real &
       &,   -23.483953_t_real,   -20.506904_t_real,   -17.595427_t_real &
       &,   -14.830585_t_real,   -12.283920_t_real,   -10.045383_t_real &
       &,    -8.201944_t_real,    -6.727045_t_real,    -5.533216_t_real &
       &,    -4.565098_t_real,    -3.781059_t_real,    -3.130901_t_real &
       &,    -2.589599_t_real,    -2.147777_t_real,    -1.793126_t_real &
       &,    -1.508761_t_real,    -1.278983_t_real,    -1.093783_t_real &
       &,    -0.948800_t_real,    -0.841190_t_real,    -0.765327_t_real &
       &,    -0.710758_t_real,    -0.666386_t_real,    -0.625723_t_real &
       &,    -0.585928_t_real,    -0.545616_t_real,    -0.503994_t_real &
       &,    -0.460719_t_real,    -0.415899_t_real,    -0.370060_t_real &
       &,    -0.324056_t_real,    -0.278931_t_real,    -0.235780_t_real &
       &,    -0.195608_t_real,    -0.159220_t_real,    -0.127149_t_real &
       &,    -0.099632_t_real,    -0.076628_t_real,    -0.057869_t_real &
       &,    -0.042931_t_real,    -0.031299_t_real/
  Data bscoefnrel(1:50, 37) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000001_t_real &
       &,    -0.000003_t_real,    -0.000005_t_real,    -0.000006_t_real &
       &,    -0.000002_t_real,     0.000004_t_real,    -0.000009_t_real &
       &,    -0.000023_t_real,    -0.000013_t_real,     0.000004_t_real &
       &,    -0.000040_t_real,    -0.000090_t_real,    -0.000067_t_real &
       &,    -0.000004_t_real,    -0.000051_t_real,    -0.000420_t_real &
       &,    -0.000972_t_real,    -0.001078_t_real,    -0.000608_t_real &
       &,     0.000056_t_real,     0.000346_t_real,    -0.000528_t_real &
       &,    -0.003645_t_real,    -0.010256_t_real,    -0.021227_t_real &
       &,    -0.035907_t_real,    -0.050926_t_real,    -0.061576_t_real &
       &,    -0.067038_t_real,    -0.069085_t_real,    -0.068236_t_real &
       &,    -0.064399_t_real,    -0.057909_t_real,    -0.049574_t_real &
       &,    -0.040400_t_real,    -0.031350_t_real,    -0.023188_t_real &
       &,    -0.016405_t_real,    -0.011211_t_real,    -0.007560_t_real &
       &,    -0.005221_t_real,    -0.003869_t_real,    -0.003161_t_real &
       &,    -0.002806_t_real,    -0.002591_t_real,    -0.002391_t_real &
       &,    -0.002154_t_real,    -0.001873_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 38) /&
       &    -38.000000_t_real,   -37.972234_t_real,   -37.776727_t_real &
       &,   -37.240757_t_real,   -36.206790_t_real,   -34.605501_t_real &
       &,   -32.482955_t_real,   -29.931830_t_real,   -27.082256_t_real &
       &,   -24.056593_t_real,   -21.002038_t_real,   -18.018944_t_real &
       &,   -15.196831_t_real,   -12.611032_t_real,   -10.364068_t_real &
       &,    -8.527804_t_real,    -7.051604_t_real,    -5.849705_t_real &
       &,    -4.876276_t_real,    -4.079334_t_real,    -3.410724_t_real &
       &,    -2.851949_t_real,    -2.391166_t_real,    -2.012677_t_real &
       &,    -1.702918_t_real,    -1.455894_t_real,    -1.268419_t_real &
       &,    -1.130187_t_real,    -1.024542_t_real,    -0.937253_t_real &
       &,    -0.859819_t_real,    -0.787743_t_real,    -0.718531_t_real &
       &,    -0.650716_t_real,    -0.583565_t_real,    -0.517019_t_real &
       &,    -0.451602_t_real,    -0.388266_t_real,    -0.328168_t_real &
       &,    -0.272447_t_real,    -0.222040_t_real,    -0.177574_t_real &
       &,    -0.139324_t_real,    -0.107227_t_real,    -0.080942_t_real &
       &,    -0.059927_t_real,    -0.043513_t_real,    -0.030987_t_real &
       &,    -0.021640_t_real,    -0.014821_t_real/
  Data bscoefnrel(1:50, 38) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 39) /&
       &    -39.000000_t_real,   -38.971185_t_real,   -38.768276_t_real &
       &,   -38.212092_t_real,   -37.140339_t_real,   -35.484187_t_real &
       &,   -33.292694_t_real,   -30.662355_t_real,   -27.727513_t_real &
       &,   -24.615437_t_real,   -21.478479_t_real,   -18.419031_t_real &
       &,   -15.534144_t_real,   -12.904485_t_real,   -10.641822_t_real &
       &,    -8.797488_t_real,    -7.300173_t_real,    -6.071346_t_real &
       &,    -5.068641_t_real,    -4.232194_t_real,    -3.523583_t_real &
       &,    -2.931329_t_real,    -2.443561_t_real,    -2.045082_t_real &
       &,    -1.724784_t_real,    -1.475744_t_real,    -1.287210_t_real &
       &,    -1.142412_t_real,    -1.025549_t_real,    -0.926084_t_real &
       &,    -0.837773_t_real,    -0.756718_t_real,    -0.680308_t_real &
       &,    -0.606886_t_real,    -0.535673_t_real,    -0.466669_t_real &
       &,    -0.400469_t_real,    -0.338007_t_real,    -0.280294_t_real &
       &,    -0.228198_t_real,    -0.182311_t_real,    -0.142886_t_real &
       &,    -0.109840_t_real,    -0.082811_t_real,    -0.061229_t_real &
       &,    -0.044399_t_real,    -0.031576_t_real,    -0.022026_t_real &
       &,    -0.015071_t_real,    -0.010117_t_real/
  Data bscoefnrel(1:50, 39) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000002_t_real,     0.000005_t_real,    -0.000006_t_real &
       &,    -0.000056_t_real,    -0.000194_t_real,    -0.000438_t_real &
       &,    -0.000543_t_real,    -0.000428_t_real,    -0.000216_t_real &
       &,    -0.000004_t_real,    -0.000131_t_real,    -0.001427_t_real &
       &,    -0.004139_t_real,    -0.007524_t_real,    -0.011426_t_real &
       &,    -0.016044_t_real,    -0.021419_t_real,    -0.027083_t_real &
       &,    -0.031638_t_real,    -0.033132_t_real,    -0.030909_t_real &
       &,    -0.026335_t_real,    -0.021098_t_real,    -0.016131_t_real &
       &,    -0.011793_t_real,    -0.008194_t_real,    -0.005347_t_real &
       &,    -0.003214_t_real,    -0.001717_t_real,    -0.000748_t_real &
       &,    -0.000181_t_real,     0.000103_t_real,     0.000208_t_real &
       &,     0.000214_t_real,     0.000174_t_real,     0.000121_t_real &
       &,     0.000071_t_real,     0.000032_t_real,     0.000006_t_real &
       &,    -0.000009_t_real,    -0.000016_t_real,    -0.000016_t_real &
       &,    -0.000014_t_real,    -0.000011_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 40) /&
       &    -40.000000_t_real,   -39.970118_t_real,   -39.759684_t_real &
       &,   -39.182958_t_real,   -38.072874_t_real,   -36.361156_t_real &
       &,   -34.099745_t_real,   -31.389076_t_real,   -28.367355_t_real &
       &,   -25.167320_t_real,   -21.945844_t_real,   -18.808671_t_real &
       &,   -15.859325_t_real,   -13.185496_t_real,   -10.903751_t_real &
       &,    -9.041080_t_real,    -7.511074_t_real,    -6.246754_t_real &
       &,    -5.202835_t_real,    -4.317708_t_real,    -3.566407_t_real &
       &,    -2.942379_t_real,    -2.432855_t_real,    -2.022137_t_real &
       &,    -1.698270_t_real,    -1.449972_t_real,    -1.260925_t_real &
       &,    -1.112945_t_real,    -0.991948_t_real,    -0.888856_t_real &
       &,    -0.797816_t_real,    -0.714817_t_real,    -0.637108_t_real &
       &,    -0.563034_t_real,    -0.491920_t_real,    -0.423880_t_real &
       &,    -0.359557_t_real,    -0.299825_t_real,    -0.245538_t_real &
       &,    -0.197349_t_real,    -0.155604_t_real,    -0.120322_t_real &
       &,    -0.091227_t_real,    -0.067811_t_real,    -0.049412_t_real &
       &,    -0.035293_t_real,    -0.024709_t_real,    -0.016955_t_real &
       &,    -0.011403_t_real,    -0.007515_t_real/
  Data bscoefnrel(1:50, 40) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000004_t_real,     0.000006_t_real,    -0.000030_t_real &
       &,    -0.000170_t_real,    -0.000556_t_real,    -0.001188_t_real &
       &,    -0.001371_t_real,    -0.001002_t_real,    -0.000405_t_real &
       &,     0.000048_t_real,    -0.000951_t_real,    -0.005581_t_real &
       &,    -0.012958_t_real,    -0.020993_t_real,    -0.029644_t_real &
       &,    -0.039118_t_real,    -0.048892_t_real,    -0.057124_t_real &
       &,    -0.060689_t_real,    -0.057494_t_real,    -0.049007_t_real &
       &,    -0.038534_t_real,    -0.028423_t_real,    -0.019675_t_real &
       &,    -0.012577_t_real,    -0.007135_t_real,    -0.003228_t_real &
       &,    -0.000657_t_real,     0.000832_t_real,     0.001519_t_real &
       &,     0.001673_t_real,     0.001518_t_real,     0.001224_t_real &
       &,     0.000898_t_real,     0.000601_t_real,     0.000361_t_real &
       &,     0.000183_t_real,     0.000064_t_real,    -0.000006_t_real &
       &,    -0.000041_t_real,    -0.000052_t_real,    -0.000048_t_real &
       &,    -0.000038_t_real,    -0.000026_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 41) /&
       &    -41.000000_t_real,   -40.969017_t_real,   -40.750819_t_real &
       &,   -40.152910_t_real,   -39.003339_t_real,   -37.234314_t_real &
       &,   -34.900428_t_real,   -32.106020_t_real,   -28.992682_t_real &
       &,   -25.699019_t_real,   -22.385912_t_real,   -19.163786_t_real &
       &,   -16.141476_t_real,   -13.415056_t_real,   -11.100408_t_real &
       &,    -9.197854_t_real,    -7.612128_t_real,    -6.288788_t_real &
       &,    -5.176726_t_real,    -4.222573_t_real,    -3.417875_t_real &
       &,    -2.761019_t_real,    -2.237077_t_real,    -1.824733_t_real &
       &,    -1.504714_t_real,    -1.260560_t_real,    -1.075165_t_real &
       &,    -0.931875_t_real,    -0.818130_t_real,    -0.725294_t_real &
       &,    -0.646944_t_real,    -0.578084_t_real,    -0.515072_t_real &
       &,    -0.455599_t_real,    -0.398553_t_real,    -0.343738_t_real &
       &,    -0.291563_t_real,    -0.242747_t_real,    -0.198087_t_real &
       &,    -0.158272_t_real,    -0.123750_t_real,    -0.094668_t_real &
       &,    -0.070865_t_real,    -0.051927_t_real,    -0.037262_t_real &
       &,    -0.026199_t_real,    -0.018055_t_real,    -0.012201_t_real &
       &,    -0.008086_t_real,    -0.005257_t_real/
  Data bscoefnrel(1:50, 41) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000001_t_real &
       &,    -0.000004_t_real,    -0.000008_t_real,    -0.000007_t_real &
       &,     0.000005_t_real,     0.000005_t_real,    -0.000107_t_real &
       &,    -0.000438_t_real,    -0.001283_t_real,    -0.002578_t_real &
       &,    -0.002850_t_real,    -0.001963_t_real,    -0.000584_t_real &
       &,     0.000006_t_real,    -0.004119_t_real,    -0.016365_t_real &
       &,    -0.031301_t_real,    -0.045546_t_real,    -0.060218_t_real &
       &,    -0.076449_t_real,    -0.094445_t_real,    -0.112803_t_real &
       &,    -0.128065_t_real,    -0.136859_t_real,    -0.139098_t_real &
       &,    -0.136440_t_real,    -0.129516_t_real,    -0.118431_t_real &
       &,    -0.103859_t_real,    -0.087124_t_real,    -0.069790_t_real &
       &,    -0.053286_t_real,    -0.038693_t_real,    -0.026669_t_real &
       &,    -0.017458_t_real,    -0.010941_t_real,    -0.006729_t_real &
       &,    -0.004276_t_real,    -0.003006_t_real,    -0.002418_t_real &
       &,    -0.002144_t_real,    -0.001959_t_real,    -0.001758_t_real &
       &,    -0.001515_t_real,    -0.001245_t_real,    -0.000975_t_real &
       &,    -0.000730_t_real,    -0.000525_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 42) /&
       &    -42.000000_t_real,   -41.967917_t_real,   -41.741960_t_real &
       &,   -41.122889_t_real,   -39.933975_t_real,   -38.108082_t_real &
       &,   -35.702491_t_real,   -32.825698_t_real,   -29.622592_t_real &
       &,   -26.238271_t_real,   -22.837197_t_real,   -19.535406_t_real &
       &,   -16.446350_t_real,   -13.675361_t_real,   -11.332386_t_real &
       &,    -9.391265_t_real,    -7.756298_t_real,    -6.383405_t_real &
       &,    -5.213452_t_real,    -4.207324_t_real,    -3.368097_t_real &
       &,    -2.692807_t_real,    -2.161909_t_real,    -1.750607_t_real &
       &,    -1.436657_t_real,    -1.199827_t_real,    -1.020422_t_real &
       &,    -0.881906_t_real,    -0.772376_t_real,    -0.683222_t_real &
       &,    -0.607843_t_real,    -0.541258_t_real,    -0.480035_t_real &
       &,    -0.422169_t_real,    -0.366816_t_real,    -0.313962_t_real &
       &,    -0.264094_t_real,    -0.217924_t_real,    -0.176170_t_real &
       &,    -0.139398_t_real,    -0.107916_t_real,    -0.081731_t_real &
       &,    -0.060568_t_real,    -0.043935_t_real,    -0.031210_t_real &
       &,    -0.021721_t_real,    -0.014816_t_real,    -0.009907_t_real &
       &,    -0.006495_t_real,    -0.004175_t_real/
  Data bscoefnrel(1:50, 42) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000001_t_real &
       &,    -0.000004_t_real,    -0.000008_t_real,    -0.000007_t_real &
       &,     0.000006_t_real,    -0.000007_t_real,    -0.000178_t_real &
       &,    -0.000704_t_real,    -0.002050_t_real,    -0.003866_t_real &
       &,    -0.003934_t_real,    -0.002432_t_real,    -0.000446_t_real &
       &,    -0.000449_t_real,    -0.009090_t_real,    -0.028274_t_real &
       &,    -0.048221_t_real,    -0.066349_t_real,    -0.084239_t_real &
       &,    -0.102629_t_real,    -0.120866_t_real,    -0.136570_t_real &
       &,    -0.146507_t_real,    -0.149460_t_real,    -0.146875_t_real &
       &,    -0.140094_t_real,    -0.129410_t_real,    -0.115167_t_real &
       &,    -0.098361_t_real,    -0.080427_t_real,    -0.062833_t_real &
       &,    -0.046792_t_real,    -0.033133_t_real,    -0.022272_t_real &
       &,    -0.014248_t_real,    -0.008790_t_real,    -0.005415_t_real &
       &,    -0.003545_t_real,    -0.002628_t_real,    -0.002215_t_real &
       &,    -0.002004_t_real,    -0.001825_t_real,    -0.001612_t_real &
       &,    -0.001361_t_real,    -0.001094_t_real,    -0.000839_t_real &
       &,    -0.000615_t_real,    -0.000433_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 43) /&
       &    -43.000000_t_real,   -42.966805_t_real,   -42.733009_t_real &
       &,   -42.092568_t_real,   -40.864002_t_real,   -38.980905_t_real &
       &,   -36.503188_t_real,   -33.543620_t_real,   -30.250212_t_real &
       &,   -26.775003_t_real,   -23.285773_t_real,   -19.905000_t_real &
       &,   -16.750192_t_real,   -13.936021_t_real,   -11.561160_t_real &
       &,    -9.574921_t_real,    -7.888487_t_real,    -6.463171_t_real &
       &,    -5.235715_t_real,    -4.185412_t_real,    -3.322640_t_real &
       &,    -2.640226_t_real,    -2.112793_t_real,    -1.710741_t_real &
       &,    -1.407573_t_real,    -1.180420_t_real,    -1.009363_t_real &
       &,    -0.877887_t_real,    -0.773316_t_real,    -0.686461_t_real &
       &,    -0.610920_t_real,    -0.542465_t_real,    -0.478567_t_real &
       &,    -0.418000_t_real,    -0.360472_t_real,    -0.306272_t_real &
       &,    -0.255976_t_real,    -0.210213_t_real,    -0.169498_t_real &
       &,    -0.134129_t_real,    -0.104149_t_real,    -0.079353_t_real &
       &,    -0.059330_t_real,    -0.043536_t_real,    -0.031356_t_real &
       &,    -0.022166_t_real,    -0.015380_t_real,    -0.010475_t_real &
       &,    -0.007003_t_real,    -0.004597_t_real/
  Data bscoefnrel(1:50, 43) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000005_t_real,    -0.000008_t_real,    -0.000008_t_real &
       &,     0.000003_t_real,    -0.000019_t_real,    -0.000199_t_real &
       &,    -0.000725_t_real,    -0.002036_t_real,    -0.003604_t_real &
       &,    -0.003431_t_real,    -0.001896_t_real,    -0.000132_t_real &
       &,    -0.001227_t_real,    -0.011793_t_real,    -0.029615_t_real &
       &,    -0.045517_t_real,    -0.059107_t_real,    -0.071829_t_real &
       &,    -0.084145_t_real,    -0.095558_t_real,    -0.104625_t_real &
       &,    -0.109519_t_real,    -0.109249_t_real,    -0.104226_t_real &
       &,    -0.095642_t_real,    -0.084736_t_real,    -0.072560_t_real &
       &,    -0.059999_t_real,    -0.047815_t_real,    -0.036635_t_real &
       &,    -0.026921_t_real,    -0.018933_t_real,    -0.012735_t_real &
       &,    -0.008209_t_real,    -0.005104_t_real,    -0.003099_t_real &
       &,    -0.001870_t_real,    -0.001138_t_real,    -0.000699_t_real &
       &,    -0.000424_t_real,    -0.000242_t_real,    -0.000120_t_real &
       &,    -0.000041_t_real,     0.000003_t_real,     0.000023_t_real &
       &,     0.000026_t_real,     0.000021_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 44) /&
       &    -44.000000_t_real,   -43.965679_t_real,   -43.723936_t_real &
       &,   -43.061846_t_real,   -41.793182_t_real,   -39.852314_t_real &
       &,   -37.301705_t_real,   -34.258472_t_real,   -30.873604_t_real &
       &,   -27.306444_t_real,   -23.727946_t_real,   -20.267594_t_real &
       &,   -17.046698_t_real,   -14.188498_t_real,   -11.775563_t_real &
       &,    -9.736495_t_real,    -7.994960_t_real,    -6.511444_t_real &
       &,    -5.225695_t_real,    -4.136372_t_real,    -3.256457_t_real &
       &,    -2.572096_t_real,    -2.051169_t_real,    -1.659110_t_real &
       &,    -1.365770_t_real,    -1.146165_t_real,    -0.980023_t_real &
       &,    -0.851525_t_real,    -0.748821_t_real,    -0.663306_t_real &
       &,    -0.588929_t_real,    -0.521655_t_real,    -0.459063_t_real &
       &,    -0.399975_t_real,    -0.344091_t_real,    -0.291658_t_real &
       &,    -0.243172_t_real,    -0.199174_t_real,    -0.160101_t_real &
       &,    -0.126204_t_real,    -0.097510_t_real,    -0.073823_t_real &
       &,    -0.054756_t_real,    -0.039791_t_real,    -0.028330_t_real &
       &,    -0.019764_t_real,    -0.013512_t_real,    -0.009052_t_real &
       &,    -0.005942_t_real,    -0.003823_t_real/
  Data bscoefnrel(1:50, 44) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000005_t_real,    -0.000009_t_real,    -0.000009_t_real &
       &,     0.000001_t_real,    -0.000026_t_real,    -0.000198_t_real &
       &,    -0.000674_t_real,    -0.001823_t_real,    -0.003027_t_real &
       &,    -0.002705_t_real,    -0.001309_t_real,     0.000035_t_real &
       &,    -0.002050_t_real,    -0.012801_t_real,    -0.026934_t_real &
       &,    -0.038072_t_real,    -0.047094_t_real,    -0.055216_t_real &
       &,    -0.062948_t_real,    -0.070249_t_real,    -0.076521_t_real &
       &,    -0.080827_t_real,    -0.082380_t_real,    -0.080887_t_real &
       &,    -0.076522_t_real,    -0.069754_t_real,    -0.061236_t_real &
       &,    -0.051716_t_real,    -0.041958_t_real,    -0.032645_t_real &
       &,    -0.024308_t_real,    -0.017287_t_real,    -0.011727_t_real &
       &,    -0.007604_t_real,    -0.004759_t_real,    -0.002949_t_real &
       &,    -0.001898_t_real,    -0.001342_t_real,    -0.001066_t_real &
       &,    -0.000921_t_real,    -0.000816_t_real,    -0.000712_t_real &
       &,    -0.000599_t_real,    -0.000482_t_real,    -0.000370_t_real &
       &,    -0.000272_t_real,    -0.000192_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 45) /&
       &    -45.000000_t_real,   -44.964538_t_real,   -44.714746_t_real &
       &,   -44.030735_t_real,   -42.721544_t_real,   -40.722356_t_real &
       &,   -38.098120_t_real,   -34.970352_t_real,   -31.492945_t_real &
       &,   -27.832825_t_real,   -24.164131_t_real,   -20.623654_t_real &
       &,   -17.336549_t_real,   -14.432994_t_real,   -11.975480_t_real &
       &,    -9.877357_t_real,    -8.077631_t_real,    -6.531075_t_real &
       &,    -5.188935_t_real,    -4.067058_t_real,    -3.176524_t_real &
       &,    -2.495017_t_real,    -1.983372_t_real,    -1.602418_t_real &
       &,    -1.319214_t_real,    -1.107510_t_real,    -0.947000_t_real &
       &,    -0.822454_t_real,    -0.722686_t_real,    -0.639584_t_real &
       &,    -0.567385_t_real,    -0.502207_t_real,    -0.441694_t_real &
       &,    -0.384685_t_real,    -0.330860_t_real,    -0.280415_t_real &
       &,    -0.233786_t_real,    -0.191455_t_real,    -0.153826_t_real &
       &,    -0.121144_t_real,    -0.093456_t_real,    -0.070598_t_real &
       &,    -0.052217_t_real,    -0.037817_t_real,    -0.026824_t_real &
       &,    -0.018639_t_real,    -0.012691_t_real,    -0.008469_t_real &
       &,    -0.005539_t_real,    -0.003551_t_real/
  Data bscoefnrel(1:50, 45) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000005_t_real,    -0.000009_t_real,    -0.000009_t_real &
       &,     0.000000_t_real,    -0.000027_t_real,    -0.000171_t_real &
       &,    -0.000543_t_real,    -0.001403_t_real,    -0.002197_t_real &
       &,    -0.001855_t_real,    -0.000768_t_real,     0.000052_t_real &
       &,    -0.002509_t_real,    -0.011392_t_real,    -0.020651_t_real &
       &,    -0.027177_t_real,    -0.032220_t_real,    -0.036840_t_real &
       &,    -0.041755_t_real,    -0.047345_t_real,    -0.053440_t_real &
       &,    -0.059271_t_real,    -0.063758_t_real,    -0.065934_t_real &
       &,    -0.065251_t_real,    -0.061687_t_real,    -0.055692_t_real &
       &,    -0.048030_t_real,    -0.039576_t_real,    -0.031142_t_real &
       &,    -0.023370_t_real,    -0.016692_t_real,    -0.011333_t_real &
       &,    -0.007340_t_real,    -0.004610_t_real,    -0.002928_t_real &
       &,    -0.002019_t_real,    -0.001601_t_real,    -0.001438_t_real &
       &,    -0.001362_t_real,    -0.001279_t_real,    -0.001155_t_real &
       &,    -0.000991_t_real,    -0.000807_t_real,    -0.000626_t_real &
       &,    -0.000464_t_real,    -0.000329_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 46) /&
       &    -46.000000_t_real,   -45.963360_t_real,   -45.705261_t_real &
       &,   -44.998641_t_real,   -43.647671_t_real,   -41.588230_t_real &
       &,   -38.887529_t_real,   -35.671333_t_real,   -32.096220_t_real &
       &,   -28.336791_t_real,   -24.570567_t_real,   -20.941641_t_real &
       &,   -17.579134_t_real,   -14.617497_t_real,   -12.096005_t_real &
       &,    -9.918835_t_real,    -8.039863_t_real,    -6.407777_t_real &
       &,    -4.994213_t_real,    -3.831087_t_real,    -2.927371_t_real &
       &,    -2.253061_t_real,    -1.761157_t_real,    -1.405458_t_real &
       &,    -1.147451_t_real,    -0.957365_t_real,    -0.813316_t_real &
       &,    -0.699924_t_real,    -0.606816_t_real,    -0.527284_t_real &
       &,    -0.457192_t_real,    -0.394149_t_real,    -0.336901_t_real &
       &,    -0.284893_t_real,    -0.237948_t_real,    -0.196044_t_real &
       &,    -0.159176_t_real,    -0.127270_t_real,    -0.100145_t_real &
       &,    -0.077514_t_real,    -0.058990_t_real,    -0.044125_t_real &
       &,    -0.032431_t_real,    -0.023414_t_real,    -0.016600_t_real &
       &,    -0.011555_t_real,    -0.007896_t_real,    -0.005294_t_real &
       &,    -0.003483_t_real,    -0.002248_t_real/
  Data bscoefnrel(1:50, 46) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 47) /&
       &    -47.000000_t_real,   -46.962212_t_real,   -46.696016_t_real &
       &,   -45.967366_t_real,   -44.575858_t_real,   -42.458405_t_real &
       &,   -39.684749_t_real,   -36.385283_t_real,   -32.719695_t_real &
       &,   -28.870680_t_real,   -25.019263_t_real,   -21.316848_t_real &
       &,   -17.897173_t_real,   -14.896466_t_real,   -12.329860_t_real &
       &,   -10.100586_t_real,    -8.174119_t_real,    -6.493410_t_real &
       &,    -5.052273_t_real,    -3.886802_t_real,    -2.993294_t_real &
       &,    -2.329702_t_real,    -1.843363_t_real,    -1.487542_t_real &
       &,    -1.225650_t_real,    -1.030431_t_real,    -0.882170_t_real &
       &,    -0.766860_t_real,    -0.674511_t_real,    -0.597811_t_real &
       &,    -0.531377_t_real,    -0.471450_t_real,    -0.415717_t_real &
       &,    -0.363038_t_real,    -0.313097_t_real,    -0.266069_t_real &
       &,    -0.222368_t_real,    -0.182482_t_real,    -0.146852_t_real &
       &,    -0.115783_t_real,    -0.089389_t_real,    -0.067563_t_real &
       &,    -0.049998_t_real,    -0.036233_t_real,    -0.025723_t_real &
       &,    -0.017895_t_real,    -0.012202_t_real,    -0.008157_t_real &
       &,    -0.005346_t_real,    -0.003435_t_real/
  Data bscoefnrel(1:50, 47) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000005_t_real,    -0.000010_t_real,    -0.000010_t_real &
       &,     0.000000_t_real,    -0.000008_t_real,    -0.000031_t_real &
       &,     0.000002_t_real,     0.000074_t_real,     0.000011_t_real &
       &,    -0.000085_t_real,    -0.000050_t_real,    -0.000004_t_real &
       &,    -0.000252_t_real,    -0.000437_t_real,     0.000034_t_real &
       &,     0.000792_t_real,     0.001075_t_real,    -0.000133_t_real &
       &,    -0.003917_t_real,    -0.010933_t_real,    -0.020835_t_real &
       &,    -0.032173_t_real,    -0.042920_t_real,    -0.051172_t_real &
       &,    -0.055618_t_real,    -0.055825_t_real,    -0.052268_t_real &
       &,    -0.046040_t_real,    -0.038394_t_real,    -0.030414_t_real &
       &,    -0.022896_t_real,    -0.016362_t_real,    -0.011104_t_real &
       &,    -0.007213_t_real,    -0.004607_t_real,    -0.003058_t_real &
       &,    -0.002266_t_real,    -0.001926_t_real,    -0.001791_t_real &
       &,    -0.001699_t_real,    -0.001570_t_real,    -0.001386_t_real &
       &,    -0.001163_t_real,    -0.000928_t_real,    -0.000706_t_real &
       &,    -0.000515_t_real,    -0.000361_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 48) /&
       &    -48.000000_t_real,   -47.961058_t_real,   -47.686721_t_real &
       &,   -46.935935_t_real,   -45.503784_t_real,   -43.328298_t_real &
       &,   -40.481767_t_real,   -37.099277_t_real,   -33.343790_t_real &
       &,   -29.406200_t_real,   -25.471282_t_real,   -21.697511_t_real &
       &,   -18.223650_t_real,   -15.184394_t_real,   -12.570803_t_real &
       &,   -10.292083_t_real,    -8.319321_t_real,    -6.595262_t_real &
       &,    -5.135170_t_real,    -3.971653_t_real,    -3.085873_t_real &
       &,    -2.425986_t_real,    -1.937801_t_real,    -1.577342_t_real &
       &,    -1.310721_t_real,    -1.111589_t_real,    -0.959742_t_real &
       &,    -0.840187_t_real,    -0.742080_t_real,    -0.657776_t_real &
       &,    -0.582131_t_real,    -0.511992_t_real,    -0.445764_t_real &
       &,    -0.382990_t_real,    -0.323948_t_real,    -0.269276_t_real &
       &,    -0.219685_t_real,    -0.175743_t_real,    -0.137765_t_real &
       &,    -0.105770_t_real,    -0.079503_t_real,    -0.058488_t_real &
       &,    -0.042102_t_real,    -0.029651_t_real,    -0.020425_t_real &
       &,    -0.013762_t_real,    -0.009067_t_real,    -0.005842_t_real &
       &,    -0.003680_t_real,    -0.002266_t_real/
  Data bscoefnrel(1:50, 48) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 49) /&
       &    -49.000000_t_real,   -48.959907_t_real,   -48.677446_t_real &
       &,   -47.904582_t_real,   -46.431996_t_real,   -44.198948_t_real &
       &,   -41.280352_t_real,   -37.816092_t_real,   -33.972656_t_real &
       &,   -29.949215_t_real,   -25.934697_t_real,   -22.094358_t_real &
       &,   -18.572367_t_real,   -15.498362_t_real,   -12.840864_t_real &
       &,   -10.520501_t_real,    -8.507997_t_real,    -6.753445_t_real &
       &,    -5.289552_t_real,    -4.138754_t_real,    -3.265525_t_real &
       &,    -2.609737_t_real,    -2.117529_t_real,    -1.747993_t_real &
       &,    -1.468948_t_real,    -1.254751_t_real,    -1.086413_t_real &
       &,    -0.950727_t_real,    -0.838575_t_real,    -0.743538_t_real &
       &,    -0.661042_t_real,    -0.587855_t_real,    -0.521740_t_real &
       &,    -0.461189_t_real,    -0.405226_t_real,    -0.353265_t_real &
       &,    -0.305003_t_real,    -0.260339_t_real,    -0.219315_t_real &
       &,    -0.182069_t_real,    -0.148767_t_real,    -0.119537_t_real &
       &,    -0.094406_t_real,    -0.073267_t_real,    -0.055876_t_real &
       &,    -0.041880_t_real,    -0.030856_t_real,    -0.022352_t_real &
       &,    -0.015923_t_real,    -0.011155_t_real/
  Data bscoefnrel(1:50, 49) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000013_t_real,    -0.000028_t_real,    -0.000017_t_real &
       &,     0.000010_t_real,     0.000005_t_real,    -0.000058_t_real &
       &,    -0.000070_t_real,    -0.000015_t_real,    -0.000031_t_real &
       &,    -0.000305_t_real,    -0.000482_t_real,    -0.000291_t_real &
       &,     0.000088_t_real,     0.000272_t_real,    -0.000423_t_real &
       &,    -0.002949_t_real,    -0.008030_t_real,    -0.015383_t_real &
       &,    -0.023675_t_real,    -0.031443_t_real,    -0.037744_t_real &
       &,    -0.042116_t_real,    -0.044371_t_real,    -0.044480_t_real &
       &,    -0.042569_t_real,    -0.038926_t_real,    -0.034006_t_real &
       &,    -0.028363_t_real,    -0.022565_t_real,    -0.017107_t_real &
       &,    -0.012361_t_real,    -0.008553_t_real,    -0.005763_t_real &
       &,    -0.003923_t_real,    -0.002857_t_real,    -0.002331_t_real &
       &,    -0.002117_t_real,    -0.002030_t_real,    -0.001953_t_real &
       &,    -0.001829_t_real,    -0.001647_t_real,    -0.001420_t_real &
       &,    -0.001173_t_real,    -0.000931_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 50) /&
       &    -50.000000_t_real,   -49.958746_t_real,   -49.668090_t_real &
       &,   -48.872967_t_real,   -47.359692_t_real,   -45.068799_t_real &
       &,   -42.077841_t_real,   -38.531518_t_real,   -34.600076_t_real &
       &,   -30.490894_t_real,   -26.397356_t_real,   -22.491063_t_real &
       &,   -18.921720_t_real,   -15.810340_t_real,   -13.105839_t_real &
       &,   -10.743614_t_real,    -8.689200_t_real,    -6.906646_t_real &
       &,    -5.439185_t_real,    -4.293748_t_real,    -3.419798_t_real &
       &,    -2.754410_t_real,    -2.247973_t_real,    -1.861969_t_real &
       &,    -1.564006_t_real,    -1.329449_t_real,    -1.141623_t_real &
       &,    -0.989123_t_real,    -0.863391_t_real,    -0.757571_t_real &
       &,    -0.666196_t_real,    -0.585135_t_real,    -0.511547_t_real &
       &,    -0.443733_t_real,    -0.380889_t_real,    -0.322805_t_real &
       &,    -0.269589_t_real,    -0.221475_t_real,    -0.178703_t_real &
       &,    -0.141445_t_real,    -0.109727_t_real,    -0.083392_t_real &
       &,    -0.062084_t_real,    -0.045284_t_real,    -0.032371_t_real &
       &,    -0.022686_t_real,    -0.015591_t_real,    -0.010510_t_real &
       &,    -0.006951_t_real,    -0.004509_t_real/
  Data bscoefnrel(1:50, 50) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000007_t_real &
       &,    -0.000038_t_real,    -0.000076_t_real,    -0.000048_t_real &
       &,     0.000021_t_real,    -0.000023_t_real,    -0.000196_t_real &
       &,    -0.000193_t_real,    -0.000023_t_real,    -0.000164_t_real &
       &,    -0.001055_t_real,    -0.001431_t_real,    -0.000803_t_real &
       &,     0.000182_t_real,     0.000253_t_real,    -0.002754_t_real &
       &,    -0.011292_t_real,    -0.025776_t_real,    -0.042994_t_real &
       &,    -0.058596_t_real,    -0.070019_t_real,    -0.076527_t_real &
       &,    -0.078267_t_real,    -0.075763_t_real,    -0.069785_t_real &
       &,    -0.061308_t_real,    -0.051419_t_real,    -0.041170_t_real &
       &,    -0.031438_t_real,    -0.022845_t_real,    -0.015762_t_real &
       &,    -0.010338_t_real,    -0.006528_t_real,    -0.004124_t_real &
       &,    -0.002798_t_real,    -0.002180_t_real,    -0.001939_t_real &
       &,    -0.001834_t_real,    -0.001727_t_real,    -0.001564_t_real &
       &,    -0.001347_t_real,    -0.001101_t_real,    -0.000858_t_real &
       &,    -0.000638_t_real,    -0.000456_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 51) /&
       &    -51.000000_t_real,   -50.957575_t_real,   -50.658658_t_real &
       &,   -49.841107_t_real,   -48.286913_t_real,   -45.937925_t_real &
       &,   -42.874364_t_real,   -39.245746_t_real,   -35.226341_t_real &
       &,   -31.031620_t_real,   -26.859752_t_real,   -22.888248_t_real &
       &,   -19.272233_t_real,   -16.120726_t_real,   -13.367182_t_real &
       &,   -10.962590_t_real,    -8.865057_t_real,    -7.057140_t_real &
       &,    -5.584737_t_real,    -4.436422_t_real,    -3.550906_t_real &
       &,    -2.867872_t_real,    -2.341897_t_real,    -1.934002_t_real &
       &,    -1.612599_t_real,    -1.356412_t_real,    -1.151249_t_real &
       &,    -0.986042_t_real,    -0.851155_t_real,    -0.738302_t_real &
       &,    -0.640912_t_real,    -0.554338_t_real,    -0.475745_t_real &
       &,    -0.403744_t_real,    -0.337893_t_real,    -0.278239_t_real &
       &,    -0.224991_t_real,    -0.178342_t_real,    -0.138376_t_real &
       &,    -0.104990_t_real,    -0.077857_t_real,    -0.056425_t_real &
       &,    -0.039975_t_real,    -0.027695_t_real,    -0.018772_t_real &
       &,    -0.012453_t_real,    -0.008087_t_real,    -0.005142_t_real &
       &,    -0.003201_t_real,    -0.001950_t_real/
  Data bscoefnrel(1:50, 51) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000001_t_real,    -0.000015_t_real &
       &,    -0.000076_t_real,    -0.000145_t_real,    -0.000087_t_real &
       &,     0.000033_t_real,    -0.000093_t_real,    -0.000412_t_real &
       &,    -0.000347_t_real,    -0.000015_t_real,    -0.000499_t_real &
       &,    -0.002286_t_real,    -0.002686_t_real,    -0.001299_t_real &
       &,     0.000379_t_real,    -0.000521_t_real,    -0.008500_t_real &
       &,    -0.026972_t_real,    -0.052827_t_real,    -0.077680_t_real &
       &,    -0.095573_t_real,    -0.105095_t_real,    -0.107003_t_real &
       &,    -0.102619_t_real,    -0.093434_t_real,    -0.081042_t_real &
       &,    -0.067042_t_real,    -0.052890_t_real,    -0.039735_t_real &
       &,    -0.028346_t_real,    -0.019127_t_real,    -0.012184_t_real &
       &,    -0.007387_t_real,    -0.004411_t_real,    -0.002802_t_real &
       &,    -0.002072_t_real,    -0.001798_t_real,    -0.001683_t_real &
       &,    -0.001566_t_real,    -0.001391_t_real,    -0.001167_t_real &
       &,    -0.000923_t_real,    -0.000692_t_real,    -0.000494_t_real &
       &,    -0.000337_t_real,    -0.000221_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 52) /&
       &    -52.000000_t_real,   -51.956397_t_real,   -51.649165_t_real &
       &,   -50.809054_t_real,   -49.213783_t_real,   -46.806565_t_real &
       &,   -43.670336_t_real,   -39.959415_t_real,   -35.852405_t_real &
       &,   -31.572718_t_real,   -27.323659_t_real,   -23.288234_t_real &
       &,   -19.626585_t_real,   -16.432763_t_real,   -13.629806_t_real &
       &,   -11.182665_t_real,    -9.042689_t_real,    -7.212540_t_real &
       &,    -5.733188_t_real,    -4.574746_t_real,    -3.671291_t_real &
       &,    -2.969237_t_real,    -2.425068_t_real,    -1.997485_t_real &
       &,    -1.656461_t_real,    -1.383762_t_real,    -1.166228_t_real &
       &,    -0.991974_t_real,    -0.850035_t_real,    -0.731165_t_real &
       &,    -0.628414_t_real,    -0.537180_t_real,    -0.454850_t_real &
       &,    -0.380244_t_real,    -0.313055_t_real,    -0.253368_t_real &
       &,    -0.201320_t_real,    -0.156895_t_real,    -0.119846_t_real &
       &,    -0.089681_t_real,    -0.065719_t_real,    -0.047149_t_real &
       &,    -0.033112_t_real,    -0.022760_t_real,    -0.015312_t_real &
       &,    -0.010082_t_real,    -0.006498_t_real,    -0.004098_t_real &
       &,    -0.002530_t_real,    -0.001528_t_real/
  Data bscoefnrel(1:50, 52) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000001_t_real,    -0.000013_t_real &
       &,    -0.000064_t_real,    -0.000118_t_real,    -0.000067_t_real &
       &,     0.000022_t_real,    -0.000110_t_real,    -0.000353_t_real &
       &,    -0.000257_t_real,     0.000003_t_real,    -0.000580_t_real &
       &,    -0.002010_t_real,    -0.002062_t_real,    -0.000812_t_real &
       &,     0.000300_t_real,    -0.001455_t_real,    -0.009772_t_real &
       &,    -0.025397_t_real,    -0.042717_t_real,    -0.055669_t_real &
       &,    -0.062557_t_real,    -0.064052_t_real,    -0.061271_t_real &
       &,    -0.055339_t_real,    -0.047375_t_real,    -0.038469_t_real &
       &,    -0.029602_t_real,    -0.021558_t_real,    -0.014840_t_real &
       &,    -0.009650_t_real,    -0.005924_t_real,    -0.003426_t_real &
       &,    -0.001857_t_real,    -0.000930_t_real,    -0.000419_t_real &
       &,    -0.000160_t_real,    -0.000044_t_real,    -0.000003_t_real &
       &,     0.000004_t_real,    -0.000001_t_real,    -0.000008_t_real &
       &,    -0.000012_t_real,    -0.000013_t_real,    -0.000012_t_real &
       &,    -0.000010_t_real,    -0.000007_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 53) /&
       &    -53.000000_t_real,   -52.955209_t_real,   -52.639593_t_real &
       &,   -51.776747_t_real,   -50.140155_t_real,   -47.674426_t_real &
       &,   -44.465246_t_real,   -40.671710_t_real,   -36.477061_t_real &
       &,   -32.112459_t_real,   -27.786667_t_real,   -23.687807_t_real &
       &,   -19.980295_t_real,   -16.740796_t_real,   -13.887429_t_real &
       &,   -11.395544_t_real,    -9.212961_t_real,    -7.361035_t_real &
       &,    -5.869463_t_real,    -4.692425_t_real,    -3.765838_t_real &
       &,    -3.042400_t_real,    -2.475412_t_real,    -2.023348_t_real &
       &,    -1.661383_t_real,    -1.374128_t_real,    -1.147670_t_real &
       &,    -0.967978_t_real,    -0.822232_t_real,    -0.700181_t_real &
       &,    -0.594629_t_real,    -0.501158_t_real,    -0.417463_t_real &
       &,    -0.342601_t_real,    -0.276343_t_real,    -0.218694_t_real &
       &,    -0.169586_t_real,    -0.128732_t_real,    -0.095588_t_real &
       &,    -0.069389_t_real,    -0.049221_t_real,    -0.034107_t_real &
       &,    -0.023081_t_real,    -0.015251_t_real,    -0.009838_t_real &
       &,    -0.006195_t_real,    -0.003807_t_real,    -0.002283_t_real &
       &,    -0.001336_t_real,    -0.000763_t_real/
  Data bscoefnrel(1:50, 53) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000001_t_real,    -0.000008_t_real &
       &,    -0.000039_t_real,    -0.000069_t_real,    -0.000037_t_real &
       &,     0.000011_t_real,    -0.000082_t_real,    -0.000213_t_real &
       &,    -0.000133_t_real,     0.000003_t_real,    -0.000449_t_real &
       &,    -0.001224_t_real,    -0.001100_t_real,    -0.000324_t_real &
       &,     0.000116_t_real,    -0.001610_t_real,    -0.007396_t_real &
       &,    -0.016082_t_real,    -0.023669_t_real,    -0.028112_t_real &
       &,    -0.029567_t_real,    -0.028694_t_real,    -0.026133_t_real &
       &,    -0.022479_t_real,    -0.018291_t_real,    -0.014067_t_real &
       &,    -0.010204_t_real,    -0.006966_t_real,    -0.004466_t_real &
       &,    -0.002684_t_real,    -0.001508_t_real,    -0.000786_t_real &
       &,    -0.000375_t_real,    -0.000158_t_real,    -0.000055_t_real &
       &,    -0.000013_t_real,    -0.000001_t_real,    -0.000001_t_real &
       &,    -0.000004_t_real,    -0.000007_t_real,    -0.000008_t_real &
       &,    -0.000008_t_real,    -0.000007_t_real,    -0.000005_t_real &
       &,    -0.000004_t_real,    -0.000003_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 54) /&
       &    -54.000000_t_real,   -53.954012_t_real,   -53.629943_t_real &
       &,   -52.744191_t_real,   -51.066043_t_real,   -48.541531_t_real &
       &,   -45.259140_t_real,   -41.382691_t_real,   -37.100400_t_real &
       &,   -32.650959_t_real,   -28.248887_t_real,   -24.087093_t_real &
       &,   -20.333199_t_real,   -17.044772_t_real,   -14.140483_t_real &
       &,   -11.601398_t_real,    -9.376673_t_real,    -7.502403_t_real &
       &,    -5.992577_t_real,    -4.790226_t_real,    -3.837919_t_real &
       &,    -3.089954_t_real,    -2.495364_t_real,    -2.017804_t_real &
       &,    -1.638211_t_real,    -1.341493_t_real,    -1.110989_t_real &
       &,    -0.929768_t_real,    -0.783193_t_real,    -0.660336_t_real &
       &,    -0.554059_t_real,    -0.460303_t_real,    -0.377116_t_real &
       &,    -0.303756_t_real,    -0.240004_t_real,    -0.185713_t_real &
       &,    -0.140560_t_real,    -0.103961_t_real,    -0.075085_t_real &
       &,    -0.052924_t_real,    -0.036390_t_real,    -0.024400_t_real &
       &,    -0.015950_t_real,    -0.010163_t_real,    -0.006311_t_real &
       &,    -0.003818_t_real,    -0.002250_t_real,    -0.001292_t_real &
       &,    -0.000722_t_real,    -0.000393_t_real/
  Data bscoefnrel(1:50, 54) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 55) /&
       &    -55.000000_t_real,   -54.952838_t_real,   -54.620488_t_real &
       &,   -53.712304_t_real,   -51.993627_t_real,   -49.412143_t_real &
       &,   -46.059370_t_real,   -42.103984_t_real,   -37.739689_t_real &
       &,   -33.212726_t_real,   -28.743839_t_real,   -24.530633_t_real &
       &,   -20.742688_t_real,   -17.417803_t_real,   -14.480263_t_real &
       &,   -11.912113_t_real,    -9.669322_t_real,    -7.797280_t_real &
       &,    -6.292564_t_real,    -5.092939_t_real,    -4.146731_t_real &
       &,    -3.401595_t_real,    -2.803362_t_real,    -2.319828_t_real &
       &,    -1.931461_t_real,    -1.619913_t_real,    -1.368219_t_real &
       &,    -1.164568_t_real,    -1.003354_t_real,    -0.881843_t_real &
       &,    -0.795374_t_real,    -0.734523_t_real,    -0.687199_t_real &
       &,    -0.644925_t_real,    -0.603749_t_real,    -0.561935_t_real &
       &,    -0.518640_t_real,    -0.473561_t_real,    -0.426880_t_real &
       &,    -0.379202_t_real,    -0.331457_t_real,    -0.284756_t_real &
       &,    -0.240240_t_real,    -0.198935_t_real,    -0.161647_t_real &
       &,    -0.128889_t_real,    -0.100867_t_real,    -0.077502_t_real &
       &,    -0.058493_t_real,    -0.043380_t_real/
  Data bscoefnrel(1:50, 55) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000001_t_real &
       &,    -0.000001_t_real,    -0.000002_t_real,    -0.000002_t_real &
       &,     0.000001_t_real,    -0.000004_t_real,    -0.000008_t_real &
       &,     0.000000_t_real,    -0.000005_t_real,    -0.000025_t_real &
       &,    -0.000015_t_real,    -0.000002_t_real,    -0.000080_t_real &
       &,    -0.000132_t_real,    -0.000056_t_real,     0.000011_t_real &
       &,    -0.000161_t_real,    -0.000698_t_real,    -0.001174_t_real &
       &,    -0.000984_t_real,    -0.000272_t_real,     0.000337_t_real &
       &,     0.000030_t_real,    -0.002221_t_real,    -0.007614_t_real &
       &,    -0.017116_t_real,    -0.030547_t_real,    -0.045423_t_real &
       &,    -0.057090_t_real,    -0.063230_t_real,    -0.065403_t_real &
       &,    -0.064734_t_real,    -0.061282_t_real,    -0.055275_t_real &
       &,    -0.047421_t_real,    -0.038684_t_real,    -0.030019_t_real &
       &,    -0.022197_t_real,    -0.015713_t_real,    -0.010776_t_real &
       &,    -0.007332_t_real,    -0.005150_t_real,    -0.003901_t_real &
       &,    -0.003252_t_real,    -0.002918_t_real,    -0.002702_t_real &
       &,    -0.002489_t_real,    -0.002233_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 56) /&
       &    -56.000000_t_real,   -55.951658_t_real,   -55.610974_t_real &
       &,   -54.680232_t_real,   -52.920879_t_real,   -50.282293_t_real &
       &,   -46.859081_t_real,   -42.824713_t_real,   -38.378721_t_real &
       &,   -33.774709_t_real,   -29.239857_t_real,   -24.976232_t_real &
       &,   -21.153682_t_real,   -17.790272_t_real,   -14.819754_t_real &
       &,   -12.220966_t_real,    -9.961396_t_real,    -8.089402_t_real &
       &,    -6.584468_t_real,    -5.384225_t_real,    -4.438498_t_real &
       &,    -3.685283_t_real,    -3.071478_t_real,    -2.568144_t_real &
       &,    -2.155169_t_real,    -1.816394_t_real,    -1.543131_t_real &
       &,    -1.332415_t_real,    -1.177202_t_real,    -1.061951_t_real &
       &,    -0.970137_t_real,    -0.890554_t_real,    -0.817057_t_real &
       &,    -0.746413_t_real,    -0.676897_t_real,    -0.607739_t_real &
       &,    -0.538929_t_real,    -0.471083_t_real,    -0.405259_t_real &
       &,    -0.342714_t_real,    -0.284674_t_real,    -0.232144_t_real &
       &,    -0.185792_t_real,    -0.145908_t_real,    -0.112429_t_real &
       &,    -0.084999_t_real,    -0.063049_t_real,    -0.045887_t_real &
       &,    -0.032768_t_real,    -0.022959_t_real/
  Data bscoefnrel(1:50, 56) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 57) /&
       &    -57.000000_t_real,   -56.950456_t_real,   -56.601286_t_real &
       &,   -55.647589_t_real,   -53.846876_t_real,   -51.150146_t_real &
       &,   -47.655043_t_real,   -43.539644_t_real,   -39.009539_t_real &
       &,   -34.325537_t_real,   -29.721418_t_real,   -25.403396_t_real &
       &,   -21.539464_t_real,   -18.128784_t_real,   -15.116956_t_real &
       &,   -12.477004_t_real,   -10.191436_t_real,    -8.305168_t_real &
       &,    -6.781455_t_real,    -5.560321_t_real,    -4.589904_t_real &
       &,    -3.803048_t_real,    -3.154043_t_real,    -2.620033_t_real &
       &,    -2.183430_t_real,    -1.830416_t_real,    -1.552653_t_real &
       &,    -1.341703_t_real,    -1.182946_t_real,    -1.059068_t_real &
       &,    -0.956483_t_real,    -0.866662_t_real,    -0.784516_t_real &
       &,    -0.706926_t_real,    -0.632066_t_real,    -0.559126_t_real &
       &,    -0.488143_t_real,    -0.419778_t_real,    -0.355049_t_real &
       &,    -0.295053_t_real,    -0.240742_t_real,    -0.192775_t_real &
       &,    -0.151453_t_real,    -0.116725_t_real,    -0.088241_t_real &
       &,    -0.065431_t_real,    -0.047588_t_real,    -0.033947_t_real &
       &,    -0.023752_t_real,    -0.016300_t_real/
  Data bscoefnrel(1:50, 57) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,    -0.000005_t_real,    -0.000033_t_real &
       &,    -0.000102_t_real,    -0.000140_t_real,    -0.000072_t_real &
       &,     0.000002_t_real,    -0.000123_t_real,    -0.000587_t_real &
       &,    -0.000803_t_real,    -0.000618_t_real,    -0.000169_t_real &
       &,     0.000048_t_real,    -0.001224_t_real,    -0.004643_t_real &
       &,    -0.009368_t_real,    -0.014794_t_real,    -0.020703_t_real &
       &,    -0.026634_t_real,    -0.031442_t_real,    -0.033353_t_real &
       &,    -0.031309_t_real,    -0.026306_t_real,    -0.020306_t_real &
       &,    -0.014640_t_real,    -0.009845_t_real,    -0.006047_t_real &
       &,    -0.003217_t_real,    -0.001254_t_real,    -0.000018_t_real &
       &,     0.000652_t_real,     0.000920_t_real,     0.000933_t_real &
       &,     0.000810_t_real,     0.000631_t_real,     0.000449_t_real &
       &,     0.000289_t_real,     0.000164_t_real,     0.000073_t_real &
       &,     0.000014_t_real,    -0.000021_t_real,    -0.000037_t_real &
       &,    -0.000042_t_real,    -0.000039_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 58) /&
       &    -58.000000_t_real,   -57.949194_t_real,   -57.591123_t_real &
       &,   -56.613354_t_real,   -54.769194_t_real,   -52.010934_t_real &
       &,   -48.438880_t_real,   -44.235119_t_real,   -39.610908_t_real &
       &,   -34.833132_t_real,   -30.140943_t_real,   -25.743614_t_real &
       &,   -21.806265_t_real,   -18.314430_t_real,   -15.226728_t_real &
       &,   -12.512828_t_real,   -10.177599_t_real,    -8.264759_t_real &
       &,    -6.726708_t_real,    -5.500236_t_real,    -4.526454_t_real &
       &,    -3.737281_t_real,    -3.090266_t_real,    -2.561871_t_real &
       &,    -2.132606_t_real,    -1.787781_t_real,    -1.518559_t_real &
       &,    -1.315287_t_real,    -1.162171_t_real,    -1.041889_t_real &
       &,    -0.941513_t_real,    -0.853097_t_real,    -0.771900_t_real &
       &,    -0.695004_t_real,    -0.620716_t_real,    -0.548331_t_real &
       &,    -0.477960_t_real,    -0.410306_t_real,    -0.346396_t_real &
       &,    -0.287310_t_real,    -0.233964_t_real,    -0.186975_t_real &
       &,    -0.146603_t_real,    -0.112760_t_real,    -0.085073_t_real &
       &,    -0.062954_t_real,    -0.045694_t_real,    -0.032530_t_real &
       &,    -0.022715_t_real,    -0.015557_t_real/
  Data bscoefnrel(1:50, 58) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,    -0.000005_t_real,    -0.000033_t_real &
       &,    -0.000114_t_real,    -0.000242_t_real,    -0.000492_t_real &
       &,    -0.001413_t_real,    -0.004321_t_real,    -0.008151_t_real &
       &,    -0.009875_t_real,    -0.011239_t_real,    -0.013230_t_real &
       &,    -0.015819_t_real,    -0.017854_t_real,    -0.018805_t_real &
       &,    -0.020072_t_real,    -0.022541_t_real,    -0.026180_t_real &
       &,    -0.030379_t_real,    -0.033773_t_real,    -0.034434_t_real &
       &,    -0.031397_t_real,    -0.025796_t_real,    -0.019516_t_real &
       &,    -0.013741_t_real,    -0.008922_t_real,    -0.005158_t_real &
       &,    -0.002403_t_real,    -0.000545_t_real,     0.000569_t_real &
       &,     0.001115_t_real,     0.001267_t_real,     0.001182_t_real &
       &,     0.000979_t_real,     0.000740_t_real,     0.000514_t_real &
       &,     0.000324_t_real,     0.000179_t_real,     0.000077_t_real &
       &,     0.000011_t_real,    -0.000026_t_real,    -0.000043_t_real &
       &,    -0.000047_t_real,    -0.000043_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 59) /&
       &    -59.000000_t_real,   -58.947876_t_real,   -58.580499_t_real &
       &,   -57.577578_t_real,   -55.687951_t_real,   -52.864881_t_real &
       &,   -49.210982_t_real,   -44.911762_t_real,   -40.183769_t_real &
       &,   -35.298872_t_real,   -30.500443_t_real,   -26.000028_t_real &
       &,   -21.959506_t_real,   -18.356048_t_real,   -15.160707_t_real &
       &,   -12.345326_t_real,    -9.942017_t_real,    -7.995845_t_real &
       &,    -6.450585_t_real,    -5.234142_t_real,    -4.279977_t_real &
       &,    -3.519362_t_real,    -2.907484_t_real,    -2.415339_t_real &
       &,    -2.018187_t_real,    -1.698073_t_real,    -1.446623_t_real &
       &,    -1.258346_t_real,    -1.120671_t_real,    -1.015726_t_real &
       &,    -0.928910_t_real,    -0.851568_t_real,    -0.779100_t_real &
       &,    -0.709003_t_real,    -0.639932_t_real,    -0.571376_t_real &
       &,    -0.503529_t_real,    -0.437149_t_real,    -0.373347_t_real &
       &,    -0.313343_t_real,    -0.258254_t_real,    -0.208927_t_real &
       &,    -0.165860_t_real,    -0.129189_t_real,    -0.098721_t_real &
       &,    -0.074007_t_real,    -0.054427_t_real,    -0.039268_t_real &
       &,    -0.027793_t_real,    -0.019298_t_real/
  Data bscoefnrel(1:50, 59) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000003_t_real,     0.000009_t_real &
       &,    -0.000030_t_real,    -0.000345_t_real,    -0.001363_t_real &
       &,    -0.004479_t_real,    -0.012703_t_real,    -0.021485_t_real &
       &,    -0.025491_t_real,    -0.029977_t_real,    -0.036759_t_real &
       &,    -0.043918_t_real,    -0.045303_t_real,    -0.038956_t_real &
       &,    -0.030297_t_real,    -0.022745_t_real,    -0.016899_t_real &
       &,    -0.012592_t_real,    -0.009504_t_real,    -0.007207_t_real &
       &,    -0.005292_t_real,    -0.003583_t_real,    -0.002091_t_real &
       &,    -0.000853_t_real,     0.000115_t_real,     0.000813_t_real &
       &,     0.001251_t_real,     0.001460_t_real,     0.001480_t_real &
       &,     0.001366_t_real,     0.001171_t_real,     0.000943_t_real &
       &,     0.000717_t_real,     0.000516_t_real,     0.000350_t_real &
       &,     0.000221_t_real,     0.000126_t_real,     0.000060_t_real &
       &,     0.000018_t_real,    -0.000007_t_real,    -0.000019_t_real &
       &,    -0.000024_t_real,    -0.000023_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 60) /&
       &    -60.000000_t_real,   -59.946585_t_real,   -59.570105_t_real &
       &,   -58.542590_t_real,   -56.608686_t_real,   -53.722884_t_real &
       &,   -49.990456_t_real,   -45.600638_t_real,   -40.776030_t_real &
       &,   -35.794045_t_real,   -30.903179_t_real,   -26.317982_t_real &
       &,   -22.195193_t_real,   -18.504334_t_real,   -15.227881_t_real &
       &,   -12.340976_t_real,    -9.897336_t_real,    -7.933235_t_real &
       &,    -6.381244_t_real,    -5.165248_t_real,    -4.213195_t_real &
       &,    -3.456077_t_real,    -2.850270_t_real,    -2.365487_t_real &
       &,    -1.975689_t_real,    -1.662860_t_real,    -1.418896_t_real &
       &,    -1.237515_t_real,    -1.104847_t_real,    -1.002845_t_real &
       &,    -0.917605_t_real,    -0.841123_t_real,    -0.769165_t_real &
       &,    -0.699413_t_real,    -0.630626_t_real,    -0.562365_t_real &
       &,    -0.494883_t_real,    -0.428971_t_real,    -0.365752_t_real &
       &,    -0.306435_t_real,    -0.252109_t_real,    -0.203584_t_real &
       &,    -0.161320_t_real,    -0.125418_t_real,    -0.095658_t_real &
       &,    -0.071574_t_real,    -0.052536_t_real,    -0.037829_t_real &
       &,    -0.026722_t_real,    -0.018517_t_real/
  Data bscoefnrel(1:50, 60) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000004_t_real,     0.000009_t_real &
       &,    -0.000065_t_real,    -0.000575_t_real,    -0.002175_t_real &
       &,    -0.007088_t_real,    -0.019316_t_real,    -0.030497_t_real &
       &,    -0.035448_t_real,    -0.041412_t_real,    -0.050130_t_real &
       &,    -0.058194_t_real,    -0.057611_t_real,    -0.047914_t_real &
       &,    -0.036402_t_real,    -0.026710_t_real,    -0.019302_t_real &
       &,    -0.013908_t_real,    -0.010121_t_real,    -0.007417_t_real &
       &,    -0.005284_t_real,    -0.003453_t_real,    -0.001870_t_real &
       &,    -0.000553_t_real,     0.000479_t_real,     0.001215_t_real &
       &,     0.001663_t_real,     0.001852_t_real,     0.001832_t_real &
       &,     0.001663_t_real,     0.001409_t_real,     0.001124_t_real &
       &,     0.000848_t_real,     0.000606_t_real,     0.000408_t_real &
       &,     0.000255_t_real,     0.000144_t_real,     0.000067_t_real &
       &,     0.000018_t_real,    -0.000010_t_real,    -0.000024_t_real &
       &,    -0.000029_t_real,    -0.000028_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 61) /&
       &    -61.000000_t_real,   -60.945281_t_real,   -60.559600_t_real &
       &,   -59.507245_t_real,   -57.528675_t_real,   -54.579581_t_real &
       &,   -50.767894_t_real,   -46.286452_t_real,   -41.364085_t_real &
       &,   -36.283528_t_real,   -31.298239_t_real,   -26.625765_t_real &
       &,   -22.416710_t_real,   -18.636199_t_real,   -15.276679_t_real &
       &,   -12.320804_t_real,    -9.841268_t_real,    -7.862625_t_real &
       &,    -6.306787_t_real,    -5.093353_t_real,    -4.145155_t_real &
       &,    -3.393336_t_real,    -2.794861_t_real,    -2.318012_t_real &
       &,    -1.935719_t_real,    -1.630141_t_real,    -1.393461_t_real &
       &,    -1.218561_t_real,    -1.090437_t_real,    -0.991049_t_real &
       &,    -0.907202_t_real,    -0.831486_t_real,    -0.759990_t_real &
       &,    -0.690555_t_real,    -0.622031_t_real,    -0.554050_t_real &
       &,    -0.486914_t_real,    -0.421447_t_real,    -0.358778_t_real &
       &,    -0.300105_t_real,    -0.246489_t_real,    -0.198709_t_real &
       &,    -0.157187_t_real,    -0.121992_t_real,    -0.092881_t_real &
       &,    -0.069373_t_real,    -0.050829_t_real,    -0.036534_t_real &
       &,    -0.025759_t_real,    -0.017817_t_real/
  Data bscoefnrel(1:50, 61) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000004_t_real,     0.000007_t_real &
       &,    -0.000118_t_real,    -0.000871_t_real,    -0.003200_t_real &
       &,    -0.010348_t_real,    -0.026944_t_real,    -0.039959_t_real &
       &,    -0.045712_t_real,    -0.053093_t_real,    -0.063454_t_real &
       &,    -0.071627_t_real,    -0.068317_t_real,    -0.055234_t_real &
       &,    -0.041131_t_real,    -0.029573_t_real,    -0.020845_t_real &
       &,    -0.014575_t_real,    -0.010273_t_real,    -0.007320_t_real &
       &,    -0.005095_t_real,    -0.003227_t_real,    -0.001608_t_real &
       &,    -0.000247_t_real,     0.000824_t_real,     0.001581_t_real &
       &,     0.002027_t_real,     0.002193_t_real,     0.002132_t_real &
       &,     0.001913_t_real,     0.001606_t_real,     0.001272_t_real &
       &,     0.000954_t_real,     0.000677_t_real,     0.000453_t_real &
       &,     0.000281_t_real,     0.000156_t_real,     0.000071_t_real &
       &,     0.000017_t_real,    -0.000013_t_real,    -0.000028_t_real &
       &,    -0.000033_t_real,    -0.000031_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 62) /&
       &    -62.000000_t_real,   -61.943964_t_real,   -61.548986_t_real &
       &,   -60.471549_t_real,   -58.447934_t_real,   -55.434999_t_real &
       &,   -51.543338_t_real,   -46.969276_t_real,   -41.948031_t_real &
       &,   -36.767467_t_real,   -31.685824_t_real,   -26.923664_t_real &
       &,   -22.624654_t_real,   -18.752702_t_real,   -15.308755_t_real &
       &,   -12.287243_t_real,    -9.776217_t_real,    -7.786206_t_real &
       &,    -6.229099_t_real,    -5.019989_t_real,    -4.077076_t_real &
       &,    -3.331920_t_real,    -2.741601_t_real,    -2.272951_t_real &
       &,    -1.898145_t_real,    -1.599699_t_real,    -1.370057_t_real &
       &,    -1.201222_t_real,    -1.077209_t_real,    -0.980137_t_real &
       &,    -0.897518_t_real,    -0.822482_t_real,    -0.751399_t_real &
       &,    -0.682252_t_real,    -0.613975_t_real,    -0.546260_t_real &
       &,    -0.479457_t_real,    -0.414415_t_real,    -0.352270_t_real &
       &,    -0.294209_t_real,    -0.241266_t_real,    -0.194186_t_real &
       &,    -0.153359_t_real,    -0.118826_t_real,    -0.090320_t_real &
       &,    -0.067347_t_real,    -0.049261_t_real,    -0.035346_t_real &
       &,    -0.024879_t_real,    -0.017177_t_real/
  Data bscoefnrel(1:50, 62) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000005_t_real,     0.000004_t_real &
       &,    -0.000190_t_real,    -0.001243_t_real,    -0.004464_t_real &
       &,    -0.014310_t_real,    -0.035434_t_real,    -0.049693_t_real &
       &,    -0.056148_t_real,    -0.064870_t_real,    -0.076544_t_real &
       &,    -0.084074_t_real,    -0.077525_t_real,    -0.061174_t_real &
       &,    -0.044763_t_real,    -0.031598_t_real,    -0.021769_t_real &
       &,    -0.014807_t_real,    -0.010146_t_real,    -0.007068_t_real &
       &,    -0.004832_t_real,    -0.002971_t_real,    -0.001340_t_real &
       &,     0.000049_t_real,     0.001146_t_real,     0.001916_t_real &
       &,     0.002355_t_real,     0.002494_t_real,     0.002393_t_real &
       &,     0.002128_t_real,     0.001774_t_real,     0.001397_t_real &
       &,     0.001042_t_real,     0.000736_t_real,     0.000489_t_real &
       &,     0.000301_t_real,     0.000165_t_real,     0.000074_t_real &
       &,     0.000016_t_real,    -0.000017_t_real,    -0.000032_t_real &
       &,    -0.000036_t_real,    -0.000034_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 63) /&
       &    -63.000000_t_real,   -62.942633_t_real,   -62.538266_t_real &
       &,   -61.435509_t_real,   -59.366475_t_real,   -56.289157_t_real &
       &,   -52.316816_t_real,   -47.649158_t_real,   -42.527925_t_real &
       &,   -37.245946_t_real,   -32.066055_t_real,   -27.211845_t_real &
       &,   -22.819490_t_real,   -18.854636_t_real,   -15.325540_t_real &
       &,   -12.242278_t_real,    -9.704028_t_real,    -7.705586_t_real &
       &,    -6.149500_t_real,    -4.946174_t_real,    -4.009718_t_real &
       &,    -3.272248_t_real,    -2.690601_t_real,    -2.230223_t_real &
       &,    -1.862791_t_real,    -1.571315_t_real,    -1.348447_t_real &
       &,    -1.185270_t_real,    -1.064973_t_real,    -0.969955_t_real &
       &,    -0.888419_t_real,    -0.813986_t_real,    -0.743276_t_real &
       &,    -0.674394_t_real,    -0.606348_t_real,    -0.538889_t_real &
       &,    -0.472407_t_real,    -0.407776_t_real,    -0.346137_t_real &
       &,    -0.288662_t_real,    -0.236361_t_real,    -0.189947_t_real &
       &,    -0.149779_t_real,    -0.115870_t_real,    -0.087934_t_real &
       &,    -0.065463_t_real,    -0.047805_t_real,    -0.034245_t_real &
       &,    -0.024064_t_real,    -0.016587_t_real/
  Data bscoefnrel(1:50, 63) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000006_t_real,    -0.000003_t_real &
       &,    -0.000285_t_real,    -0.001698_t_real,    -0.005992_t_real &
       &,    -0.019017_t_real,    -0.044608_t_real,    -0.059567_t_real &
       &,    -0.066662_t_real,    -0.076634_t_real,    -0.089263_t_real &
       &,    -0.095463_t_real,    -0.085368_t_real,    -0.065957_t_real &
       &,    -0.047517_t_real,    -0.032980_t_real,    -0.022242_t_real &
       &,    -0.014748_t_real,    -0.009856_t_real,    -0.006744_t_real &
       &,    -0.004548_t_real,    -0.002715_t_real,    -0.001081_t_real &
       &,     0.000330_t_real,     0.001447_t_real,     0.002224_t_real &
       &,     0.002652_t_real,     0.002765_t_real,     0.002626_t_real &
       &,     0.002317_t_real,     0.001920_t_real,     0.001503_t_real &
       &,     0.001115_t_real,     0.000784_t_real,     0.000518_t_real &
       &,     0.000316_t_real,     0.000172_t_real,     0.000075_t_real &
       &,     0.000014_t_real,    -0.000020_t_real,    -0.000036_t_real &
       &,    -0.000040_t_real,    -0.000037_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 64) /&
       &    -64.000000_t_real,   -63.941336_t_real,   -63.527811_t_real &
       &,   -62.400379_t_real,   -60.287281_t_real,   -57.147925_t_real &
       &,   -53.098625_t_real,   -48.342840_t_real,   -43.129580_t_real &
       &,   -37.757328_t_real,   -32.494265_t_real,   -27.567384_t_real &
       &,   -23.103585_t_real,   -19.071903_t_real,   -15.486321_t_real &
       &,   -12.372455_t_real,    -9.830584_t_real,    -7.832871_t_real &
       &,    -6.274431_t_real,    -5.063480_t_real,    -4.111332_t_real &
       &,    -3.354273_t_real,    -2.752549_t_real,    -2.273912_t_real &
       &,    -1.893435_t_real,    -1.596265_t_real,    -1.371586_t_real &
       &,    -1.203856_t_real,    -1.074390_t_real,    -0.968322_t_real &
       &,    -0.876443_t_real,    -0.793356_t_real,    -0.715721_t_real &
       &,    -0.641444_t_real,    -0.569410_t_real,    -0.499355_t_real &
       &,    -0.431696_t_real,    -0.367289_t_real,    -0.307167_t_real &
       &,    -0.252297_t_real,    -0.203414_t_real,    -0.160927_t_real &
       &,    -0.124899_t_real,    -0.095087_t_real,    -0.071002_t_real &
       &,    -0.052000_t_real,    -0.037351_t_real,    -0.026312_t_real &
       &,    -0.018179_t_real,    -0.012317_t_real/
  Data bscoefnrel(1:50, 64) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,    -0.000005_t_real,    -0.000064_t_real &
       &,    -0.000505_t_real,    -0.002220_t_real,    -0.007387_t_real &
       &,    -0.023160_t_real,    -0.051483_t_real,    -0.065662_t_real &
       &,    -0.072389_t_real,    -0.081851_t_real,    -0.092592_t_real &
       &,    -0.094465_t_real,    -0.081147_t_real,    -0.063223_t_real &
       &,    -0.049404_t_real,    -0.041067_t_real,    -0.037346_t_real &
       &,    -0.036606_t_real,    -0.036280_t_real,    -0.033807_t_real &
       &,    -0.028658_t_real,    -0.022179_t_real,    -0.015748_t_real &
       &,    -0.010097_t_real,    -0.005517_t_real,    -0.002077_t_real &
       &,     0.000274_t_real,     0.001675_t_real,     0.002320_t_real &
       &,     0.002426_t_real,     0.002198_t_real,     0.001807_t_real &
       &,     0.001373_t_real,     0.000969_t_real,     0.000631_t_real &
       &,     0.000371_t_real,     0.000185_t_real,     0.000062_t_real &
       &,    -0.000009_t_real,    -0.000044_t_real,    -0.000055_t_real &
       &,    -0.000052_t_real,    -0.000042_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 65) /&
       &    -65.000000_t_real,   -64.939939_t_real,   -64.516563_t_real &
       &,   -63.362588_t_real,   -61.201861_t_real,   -57.994585_t_real &
       &,   -53.859418_t_real,   -49.002622_t_real,   -43.679406_t_real &
       &,   -38.192225_t_real,   -32.812670_t_real,   -27.770456_t_real &
       &,   -23.186261_t_real,   -19.037447_t_real,   -15.342312_t_real &
       &,   -12.150720_t_real,    -9.571150_t_real,    -7.563791_t_real &
       &,    -6.013201_t_real,    -4.818648_t_real,    -3.890858_t_real &
       &,    -3.165539_t_real,    -2.598417_t_real,    -2.152102_t_real &
       &,    -1.797630_t_real,    -1.519052_t_real,    -1.308860_t_real &
       &,    -1.155798_t_real,    -1.041665_t_real,    -0.949774_t_real &
       &,    -0.869747_t_real,    -0.796083_t_real,    -0.725811_t_real &
       &,    -0.657232_t_real,    -0.589484_t_real,    -0.522422_t_real &
       &,    -0.456521_t_real,    -0.392705_t_real,    -0.332118_t_real &
       &,    -0.275904_t_real,    -0.225009_t_real,    -0.180076_t_real &
       &,    -0.141389_t_real,    -0.108899_t_real,    -0.082269_t_real &
       &,    -0.060959_t_real,    -0.044301_t_real,    -0.031576_t_real &
       &,    -0.022073_t_real,    -0.015133_t_real/
  Data bscoefnrel(1:50, 65) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000003_t_real,    -0.000016_t_real &
       &,    -0.000317_t_real,    -0.001637_t_real,    -0.005629_t_real &
       &,    -0.017382_t_real,    -0.036202_t_real,    -0.044603_t_real &
       &,    -0.049157_t_real,    -0.055702_t_real,    -0.062592_t_real &
       &,    -0.062848_t_real,    -0.052840_t_real,    -0.039104_t_real &
       &,    -0.027057_t_real,    -0.017801_t_real,    -0.011100_t_real &
       &,    -0.006585_t_real,    -0.003851_t_real,    -0.002347_t_real &
       &,    -0.001435_t_real,    -0.000684_t_real,     0.000034_t_real &
       &,     0.000686_t_real,     0.001209_t_real,     0.001561_t_real &
       &,     0.001729_t_real,     0.001729_t_real,     0.001597_t_real &
       &,     0.001381_t_real,     0.001126_t_real,     0.000869_t_real &
       &,     0.000637_t_real,     0.000441_t_real,     0.000287_t_real &
       &,     0.000172_t_real,     0.000091_t_real,     0.000036_t_real &
       &,     0.000003_t_real,    -0.000015_t_real,    -0.000023_t_real &
       &,    -0.000024_t_real,    -0.000022_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 66) /&
       &    -66.000000_t_real,   -65.938572_t_real,   -65.505550_t_real &
       &,   -64.325606_t_real,   -62.118464_t_real,   -58.845372_t_real &
       &,   -54.627684_t_real,   -49.674817_t_real,   -44.248825_t_real &
       &,   -38.656809_t_real,   -33.174464_t_real,   -28.034523_t_real &
       &,   -23.350289_t_real,   -19.107770_t_real,   -15.330383_t_real &
       &,   -12.090911_t_real,    -9.495687_t_real,    -7.486873_t_real &
       &,    -5.940808_t_real,    -4.752025_t_real,    -3.830496_t_real &
       &,    -3.112900_t_real,    -2.553928_t_real,    -2.114993_t_real &
       &,    -1.767118_t_real,    -1.494938_t_real,    -1.290772_t_real &
       &,    -1.142303_t_real,    -1.030915_t_real,    -0.940454_t_real &
       &,    -0.861170_t_real,    -0.787926_t_real,    -0.717921_t_real &
       &,    -0.649541_t_real,    -0.581982_t_real,    -0.515151_t_real &
       &,    -0.449557_t_real,    -0.386144_t_real,    -0.326059_t_real &
       &,    -0.270426_t_real,    -0.220168_t_real,    -0.175893_t_real &
       &,    -0.137857_t_real,    -0.105983_t_real,    -0.079914_t_real &
       &,    -0.059099_t_real,    -0.042863_t_real,    -0.030488_t_real &
       &,    -0.021267_t_real,    -0.014548_t_real/
  Data bscoefnrel(1:50, 66) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000002_t_real,    -0.000019_t_real &
       &,    -0.000305_t_real,    -0.001496_t_real,    -0.005096_t_real &
       &,    -0.015458_t_real,    -0.030296_t_real,    -0.036187_t_real &
       &,    -0.039656_t_real,    -0.044611_t_real,    -0.049244_t_real &
       &,    -0.048053_t_real,    -0.039379_t_real,    -0.028618_t_real &
       &,    -0.019442_t_real,    -0.012468_t_real,    -0.007474_t_real &
       &,    -0.004177_t_real,    -0.002264_t_real,    -0.001293_t_real &
       &,    -0.000746_t_real,    -0.000284_t_real,     0.000184_t_real &
       &,     0.000623_t_real,     0.000977_t_real,     0.001211_t_real &
       &,     0.001315_t_real,     0.001298_t_real,     0.001189_t_real &
       &,     0.001021_t_real,     0.000827_t_real,     0.000635_t_real &
       &,     0.000463_t_real,     0.000319_t_real,     0.000207_t_real &
       &,     0.000123_t_real,     0.000064_t_real,     0.000025_t_real &
       &,     0.000001_t_real,    -0.000012_t_real,    -0.000017_t_real &
       &,    -0.000018_t_real,    -0.000016_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 67) /&
       &    -67.000000_t_real,   -66.937192_t_real,   -66.494431_t_real &
       &,   -65.288283_t_real,   -63.034355_t_real,   -59.694902_t_real &
       &,   -55.393965_t_real,   -50.344055_t_real,   -44.814117_t_real &
       &,   -39.115809_t_real,   -33.528779_t_real,   -28.288727_t_real &
       &,   -23.502191_t_real,   -19.165016_t_real,   -15.306854_t_real &
       &,   -12.023879_t_real,    -9.416097_t_real,    -7.407623_t_real &
       &,    -5.867148_t_real,    -4.685010_t_real,    -3.770750_t_real &
       &,    -3.061583_t_real,    -2.511026_t_real,    -2.079482_t_real &
       &,    -1.738135_t_real,    -1.472230_t_real,    -1.273841_t_real &
       &,    -1.129650_t_real,    -1.020772_t_real,    -0.931621_t_real &
       &,    -0.853030_t_real,    -0.780188_t_real,    -0.710446_t_real &
       &,    -0.642266_t_real,    -0.574901_t_real,    -0.508302_t_real &
       &,    -0.443014_t_real,    -0.379997_t_real,    -0.320396_t_real &
       &,    -0.265322_t_real,    -0.215670_t_real,    -0.172018_t_real &
       &,    -0.134595_t_real,    -0.103297_t_real,    -0.077752_t_real &
       &,    -0.057395_t_real,    -0.041550_t_real,    -0.029497_t_real &
       &,    -0.020535_t_real,    -0.014019_t_real/
  Data bscoefnrel(1:50, 67) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,    -0.000020_t_real &
       &,    -0.000271_t_real,    -0.001271_t_real,    -0.004295_t_real &
       &,    -0.012757_t_real,    -0.023545_t_real,    -0.027407_t_real &
       &,    -0.029889_t_real,    -0.033378_t_real,    -0.036199_t_real &
       &,    -0.034390_t_real,    -0.027542_t_real,    -0.019684_t_real &
       &,    -0.013139_t_real,    -0.008214_t_real,    -0.004727_t_real &
       &,    -0.002473_t_real,    -0.001224_t_real,    -0.000645_t_real &
       &,    -0.000343_t_real,    -0.000074_t_real,     0.000219_t_real &
       &,     0.000501_t_real,     0.000730_t_real,     0.000879_t_real &
       &,     0.000939_t_real,     0.000918_t_real,     0.000834_t_real &
       &,     0.000712_t_real,     0.000574_t_real,     0.000439_t_real &
       &,     0.000318_t_real,     0.000218_t_real,     0.000140_t_real &
       &,     0.000083_t_real,     0.000042_t_real,     0.000016_t_real &
       &,     0.000000_t_real,    -0.000009_t_real,    -0.000012_t_real &
       &,    -0.000013_t_real,    -0.000011_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 68) /&
       &    -68.000000_t_real,   -67.935799_t_real,   -67.483207_t_real &
       &,   -66.250622_t_real,   -63.949542_t_real,   -60.543185_t_real &
       &,   -56.158275_t_real,   -51.010362_t_real,   -45.375312_t_real &
       &,   -39.569263_t_real,   -33.875692_t_real,   -28.533198_t_real &
       &,   -23.642409_t_real,   -19.209774_t_real,   -15.272934_t_real &
       &,   -11.950834_t_real,    -9.333376_t_real,    -7.326875_t_real &
       &,    -5.792961_t_real,    -4.618264_t_real,    -3.712092_t_real &
       &,    -3.011847_t_real,    -2.469815_t_real,    -2.045581_t_real &
       &,    -1.710647_t_real,    -1.450864_t_real,    -1.257991_t_real &
       &,    -1.117769_t_real,    -1.011179_t_real,    -0.923218_t_real &
       &,    -0.845265_t_real,    -0.772801_t_real,    -0.703310_t_real &
       &,    -0.635325_t_real,    -0.568152_t_real,    -0.501785_t_real &
       &,    -0.436799_t_real,    -0.374169_t_real,    -0.315041_t_real &
       &,    -0.260506_t_real,    -0.211435_t_real,    -0.168380_t_real &
       &,    -0.131538_t_real,    -0.100787_t_real,    -0.075736_t_real &
       &,    -0.055812_t_real,    -0.040333_t_real,    -0.028582_t_real &
       &,    -0.019861_t_real,    -0.013532_t_real/
  Data bscoefnrel(1:50, 68) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,    -0.000018_t_real &
       &,    -0.000211_t_real,    -0.000953_t_real,    -0.003197_t_real &
       &,    -0.009270_t_real,    -0.016141_t_real,    -0.018390_t_real &
       &,    -0.019971_t_real,    -0.022138_t_real,    -0.023591_t_real &
       &,    -0.021856_t_real,    -0.017142_t_real,    -0.012063_t_real &
       &,    -0.007915_t_real,    -0.004822_t_real,    -0.002657_t_real &
       &,    -0.001289_t_real,    -0.000568_t_real,    -0.000266_t_real &
       &,    -0.000122_t_real,     0.000019_t_real,     0.000184_t_real &
       &,     0.000349_t_real,     0.000482_t_real,     0.000567_t_real &
       &,     0.000598_t_real,     0.000579_t_real,     0.000523_t_real &
       &,     0.000443_t_real,     0.000356_t_real,     0.000271_t_real &
       &,     0.000196_t_real,     0.000134_t_real,     0.000085_t_real &
       &,     0.000050_t_real,     0.000025_t_real,     0.000009_t_real &
       &,    -0.000001_t_real,    -0.000006_t_real,    -0.000008_t_real &
       &,    -0.000008_t_real,    -0.000007_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 69) /&
       &    -69.000000_t_real,   -68.934392_t_real,   -68.471879_t_real &
       &,   -67.212626_t_real,   -64.864029_t_real,   -61.390229_t_real &
       &,   -56.920621_t_real,   -51.673756_t_real,   -45.932423_t_real &
       &,   -40.017186_t_real,   -34.215251_t_real,   -28.768039_t_real &
       &,   -23.771323_t_real,   -19.242603_t_real,   -15.229721_t_real &
       &,   -11.872795_t_real,    -9.248317_t_real,    -7.245274_t_real &
       &,    -5.718796_t_real,    -4.552246_t_real,    -3.654814_t_real &
       &,    -2.963814_t_real,    -2.430306_t_real,    -2.013246_t_real &
       &,    -1.684582_t_real,    -1.430755_t_real,    -1.243133_t_real &
       &,    -1.106588_t_real,    -1.002076_t_real,    -0.915194_t_real &
       &,    -0.837824_t_real,    -0.765712_t_real,    -0.696458_t_real &
       &,    -0.628661_t_real,    -0.561676_t_real,    -0.495537_t_real &
       &,    -0.430850_t_real,    -0.368602_t_real,    -0.309933_t_real &
       &,    -0.255922_t_real,    -0.207414_t_real,    -0.164931_t_real &
       &,    -0.128648_t_real,    -0.098418_t_real,    -0.073838_t_real &
       &,    -0.054324_t_real,    -0.039192_t_real,    -0.027725_t_real &
       &,    -0.019232_t_real,    -0.013080_t_real/
  Data bscoefnrel(1:50, 69) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000011_t_real &
       &,    -0.000122_t_real,    -0.000532_t_real,    -0.001775_t_real &
       &,    -0.005007_t_real,    -0.008246_t_real,    -0.009231_t_real &
       &,    -0.009987_t_real,    -0.010987_t_real,    -0.011507_t_real &
       &,    -0.010411_t_real,    -0.008011_t_real,    -0.005556_t_real &
       &,    -0.003584_t_real,    -0.002127_t_real,    -0.001119_t_real &
       &,    -0.000496_t_real,    -0.000185_t_real,    -0.000070_t_real &
       &,    -0.000020_t_real,     0.000036_t_real,     0.000107_t_real &
       &,     0.000179_t_real,     0.000238_t_real,     0.000274_t_real &
       &,     0.000286_t_real,     0.000275_t_real,     0.000246_t_real &
       &,     0.000208_t_real,     0.000166_t_real,     0.000126_t_real &
       &,     0.000091_t_real,     0.000062_t_real,     0.000039_t_real &
       &,     0.000023_t_real,     0.000011_t_real,     0.000004_t_real &
       &,    -0.000001_t_real,    -0.000003_t_real,    -0.000004_t_real &
       &,    -0.000004_t_real,    -0.000003_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 70) /&
       &    -70.000000_t_real,   -69.932973_t_real,   -69.460446_t_real &
       &,   -68.174297_t_real,   -65.777820_t_real,   -62.236039_t_real &
       &,   -57.681007_t_real,   -52.334247_t_real,   -46.485459_t_real &
       &,   -40.459581_t_real,   -34.547488_t_real,   -28.993341_t_real &
       &,   -23.889269_t_real,   -19.264058_t_real,   -15.178213_t_real &
       &,   -11.790634_t_real,    -9.161574_t_real,    -7.163326_t_real &
       &,    -5.645065_t_real,    -4.487274_t_real,    -3.599093_t_real &
       &,    -2.917533_t_real,    -2.392468_t_real,    -1.982410_t_real &
       &,    -1.659861_t_real,    -1.411813_t_real,    -1.229179_t_real &
       &,    -1.096033_t_real,    -0.993408_t_real,    -0.907502_t_real &
       &,    -0.830665_t_real,    -0.758877_t_real,    -0.689846_t_real &
       &,    -0.622230_t_real,    -0.555429_t_real,    -0.489516_t_real &
       &,    -0.425123_t_real,    -0.363250_t_real,    -0.305033_t_real &
       &,    -0.251532_t_real,    -0.203569_t_real,    -0.161640_t_real &
       &,    -0.125895_t_real,    -0.096167_t_real,    -0.072038_t_real &
       &,    -0.052916_t_real,    -0.038115_t_real,    -0.026918_t_real &
       &,    -0.018640_t_real,    -0.012656_t_real/
  Data bscoefnrel(1:50, 70) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 71) /&
       &    -71.000000_t_real,   -70.931590_t_real,   -70.449302_t_real &
       &,   -69.136958_t_real,   -66.694062_t_real,   -63.086810_t_real &
       &,   -58.450301_t_real,   -53.009491_t_real,   -47.061584_t_real &
       &,   -40.936627_t_real,   -34.929889_t_real,   -29.288081_t_real &
       &,   -24.099790_t_real,   -19.405078_t_real,   -15.278019_t_real &
       &,   -11.889474_t_real,    -9.274547_t_real,    -7.287069_t_real &
       &,    -5.773187_t_real,    -4.611984_t_real,    -3.713686_t_real &
       &,    -3.017064_t_real,    -2.473953_t_real,    -2.047048_t_real &
       &,    -1.713570_t_real,    -1.460232_t_real,    -1.271537_t_real &
       &,    -1.127525_t_real,    -1.011242_t_real,    -0.912064_t_real &
       &,    -0.823859_t_real,    -0.742811_t_real,    -0.666375_t_real &
       &,    -0.592972_t_real,    -0.521910_t_real,    -0.453265_t_real &
       &,    -0.387677_t_real,    -0.326084_t_real,    -0.269459_t_real &
       &,    -0.218611_t_real,    -0.174054_t_real,    -0.135965_t_real &
       &,    -0.104197_t_real,    -0.078336_t_real,    -0.057779_t_real &
       &,    -0.041815_t_real,    -0.029699_t_real,    -0.020705_t_real &
       &,    -0.014174_t_real,    -0.009531_t_real/
  Data bscoefnrel(1:50, 71) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000000_t_real,    -0.000012_t_real,    -0.000051_t_real &
       &,    -0.000082_t_real,    -0.000028_t_real,     0.000042_t_real &
       &,    -0.000018_t_real,    -0.000193_t_real,    -0.000184_t_real &
       &,     0.000002_t_real,     0.000146_t_real,    -0.000370_t_real &
       &,    -0.002247_t_real,    -0.005409_t_real,    -0.009510_t_real &
       &,    -0.014513_t_real,    -0.020398_t_real,    -0.026652_t_real &
       &,    -0.031716_t_real,    -0.033446_t_real,    -0.031255_t_real &
       &,    -0.026706_t_real,    -0.021533_t_real,    -0.016637_t_real &
       &,    -0.012351_t_real,    -0.008777_t_real,    -0.005930_t_real &
       &,    -0.003772_t_real,    -0.002231_t_real,    -0.001201_t_real &
       &,    -0.000566_t_real,    -0.000211_t_real,    -0.000036_t_real &
       &,     0.000033_t_real,     0.000046_t_real,     0.000037_t_real &
       &,     0.000022_t_real,     0.000009_t_real,     0.000001_t_real &
       &,    -0.000002_t_real,    -0.000002_t_real,     0.000000_t_real &
       &,     0.000003_t_real,     0.000005_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 72) /&
       &    -72.000000_t_real,   -71.930198_t_real,   -71.438088_t_real &
       &,   -70.099401_t_real,   -67.609881_t_real,   -63.936883_t_real &
       &,   -59.218573_t_real,   -53.683400_t_real,   -47.636156_t_real &
       &,   -41.412162_t_real,   -35.311146_t_real,   -29.581931_t_real &
       &,   -24.310600_t_real,   -19.548271_t_real,   -15.384113_t_real &
       &,   -11.995791_t_real,    -9.389969_t_real,    -7.404014_t_real &
       &,    -5.883023_t_real,    -4.706225_t_real,    -3.787296_t_real &
       &,    -3.068794_t_real,    -2.505672_t_real,    -2.063951_t_real &
       &,    -1.722168_t_real,    -1.463845_t_real,    -1.269094_t_real &
       &,    -1.117445_t_real,    -0.993767_t_real,    -0.888582_t_real &
       &,    -0.795857_t_real,    -0.711469_t_real,    -0.632612_t_real &
       &,    -0.557617_t_real,    -0.485824_t_real,    -0.417370_t_real &
       &,    -0.352903_t_real,    -0.293285_t_real,    -0.239337_t_real &
       &,    -0.191660_t_real,    -0.150545_t_real,    -0.115953_t_real &
       &,    -0.087559_t_real,    -0.064812_t_real,    -0.047023_t_real &
       &,    -0.033438_t_real,    -0.023303_t_real,    -0.015916_t_real &
       &,    -0.010652_t_real,    -0.006986_t_real/
  Data bscoefnrel(1:50, 72) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000002_t_real,    -0.000035_t_real,    -0.000135_t_real &
       &,    -0.000211_t_real,    -0.000073_t_real,     0.000076_t_real &
       &,    -0.000170_t_real,    -0.000638_t_real,    -0.000563_t_real &
       &,    -0.000053_t_real,     0.000191_t_real,    -0.001572_t_real &
       &,    -0.006830_t_real,    -0.014792_t_real,    -0.024367_t_real &
       &,    -0.035190_t_real,    -0.046631_t_real,    -0.056724_t_real &
       &,    -0.061949_t_real,    -0.059772_t_real,    -0.051662_t_real &
       &,    -0.041196_t_real,    -0.030910_t_real,    -0.021895_t_real &
       &,    -0.014489_t_real,    -0.008732_t_real,    -0.004525_t_real &
       &,    -0.001684_t_real,     0.000039_t_real,     0.000921_t_real &
       &,     0.001232_t_real,     0.001202_t_real,     0.001003_t_real &
       &,     0.000749_t_real,     0.000505_t_real,     0.000302_t_real &
       &,     0.000150_t_real,     0.000048_t_real,    -0.000013_t_real &
       &,    -0.000043_t_real,    -0.000051_t_real,    -0.000047_t_real &
       &,    -0.000038_t_real,    -0.000027_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 73) /&
       &    -73.000000_t_real,   -72.928798_t_real,   -72.426808_t_real &
       &,   -71.061638_t_real,   -68.525306_t_real,   -64.786313_t_real &
       &,   -59.985914_t_real,   -54.356119_t_real,   -48.209383_t_real &
       &,   -41.886442_t_real,   -35.691549_t_real,   -29.875161_t_real &
       &,   -24.522021_t_real,   -19.694033_t_real,   -15.496699_t_real &
       &,   -12.108976_t_real,    -9.506946_t_real,    -7.514469_t_real &
       &,    -5.977486_t_real,    -4.776838_t_real,    -3.831700_t_real &
       &,    -3.089352_t_real,    -2.507593_t_real,    -2.054206_t_real &
       &,    -1.706963_t_real,    -1.445658_t_real,    -1.247572_t_real &
       &,    -1.092387_t_real,    -0.965884_t_real,    -0.858854_t_real &
       &,    -0.765079_t_real,    -0.680212_t_real,    -0.601349_t_real &
       &,    -0.526842_t_real,    -0.456086_t_real,    -0.389242_t_real &
       &,    -0.326916_t_real,    -0.269867_t_real,    -0.218765_t_real &
       &,    -0.174044_t_real,    -0.135838_t_real,    -0.103978_t_real &
       &,    -0.078043_t_real,    -0.057428_t_real,    -0.041423_t_real &
       &,    -0.029285_t_real,    -0.020288_t_real,    -0.013772_t_real &
       &,    -0.009158_t_real,    -0.005965_t_real/
  Data bscoefnrel(1:50, 73) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000002_t_real &
       &,    -0.000006_t_real,    -0.000067_t_real,    -0.000252_t_real &
       &,    -0.000378_t_real,    -0.000126_t_real,     0.000100_t_real &
       &,    -0.000472_t_real,    -0.001289_t_real,    -0.001049_t_real &
       &,    -0.000093_t_real,     0.000071_t_real,    -0.003934_t_real &
       &,    -0.014029_t_real,    -0.027828_t_real,    -0.043212_t_real &
       &,    -0.059246_t_real,    -0.074262_t_real,    -0.084667_t_real &
       &,    -0.086092_t_real,    -0.077670_t_real,    -0.063344_t_real &
       &,    -0.047760_t_real,    -0.033584_t_real,    -0.021815_t_real &
       &,    -0.012654_t_real,    -0.005974_t_real,    -0.001484_t_real &
       &,     0.001198_t_real,     0.002507_t_real,     0.002875_t_real &
       &,     0.002678_t_real,     0.002207_t_real,     0.001658_t_real &
       &,     0.001145_t_real,     0.000722_t_real,     0.000406_t_real &
       &,     0.000192_t_real,     0.000064_t_real,     0.000002_t_real &
       &,    -0.000017_t_real,    -0.000012_t_real,     0.000003_t_real &
       &,     0.000018_t_real,     0.000028_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 74) /&
       &    -74.000000_t_real,   -73.927389_t_real,   -73.415461_t_real &
       &,   -72.023669_t_real,   -69.440332_t_real,   -65.635089_t_real &
       &,   -60.752297_t_real,   -55.027605_t_real,   -48.781196_t_real &
       &,   -42.359349_t_real,   -36.070899_t_real,   -30.167431_t_real &
       &,   -24.733592_t_real,   -19.841796_t_real,   -15.614706_t_real &
       &,   -12.226873_t_real,    -9.622798_t_real,    -7.616441_t_real &
       &,    -6.056078_t_real,    -4.825658_t_real,    -3.851567_t_real &
       &,    -3.085914_t_real,    -2.488434_t_real,    -2.027184_t_real &
       &,    -1.677736_t_real,    -1.416078_t_real,    -1.217531_t_real &
       &,    -1.061938_t_real,    -0.935473_t_real,    -0.828934_t_real &
       &,    -0.735953_t_real,    -0.652088_t_real,    -0.574435_t_real &
       &,    -0.501393_t_real,    -0.432397_t_real,    -0.367605_t_real &
       &,    -0.307571_t_real,    -0.252959_t_real,    -0.204332_t_real &
       &,    -0.162012_t_real,    -0.126040_t_real,    -0.096178_t_real &
       &,    -0.071968_t_real,    -0.052795_t_real,    -0.037959_t_real &
       &,    -0.026743_t_real,    -0.018458_t_real,    -0.012478_t_real &
       &,    -0.008260_t_real,    -0.005354_t_real/
  Data bscoefnrel(1:50, 74) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000002_t_real &
       &,    -0.000012_t_real,    -0.000112_t_real,    -0.000403_t_real &
       &,    -0.000578_t_real,    -0.000178_t_real,     0.000107_t_real &
       &,    -0.000935_t_real,    -0.002111_t_real,    -0.001578_t_real &
       &,    -0.000077_t_real,    -0.000345_t_real,    -0.007820_t_real &
       &,    -0.024002_t_real,    -0.044035_t_real,    -0.064754_t_real &
       &,    -0.084566_t_real,    -0.100660_t_real,    -0.108324_t_real &
       &,    -0.103830_t_real,    -0.088824_t_real,    -0.069047_t_real &
       &,    -0.049478_t_real,    -0.032618_t_real,    -0.019247_t_real &
       &,    -0.009344_t_real,    -0.002552_t_real,     0.001635_t_real &
       &,     0.003794_t_real,     0.004512_t_real,     0.004323_t_real &
       &,     0.003660_t_real,     0.002831_t_real,     0.002025_t_real &
       &,     0.001341_t_real,     0.000817_t_real,     0.000451_t_real &
       &,     0.000226_t_real,     0.000108_t_real,     0.000064_t_real &
       &,     0.000061_t_real,     0.000075_t_real,     0.000089_t_real &
       &,     0.000096_t_real,     0.000093_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 75) /&
       &    -75.000000_t_real,   -74.925972_t_real,   -74.404047_t_real &
       &,   -72.985488_t_real,   -70.354949_t_real,   -66.483190_t_real &
       &,   -61.517681_t_real,   -55.697799_t_real,   -49.351504_t_real &
       &,   -42.830732_t_real,   -36.448958_t_real,   -30.458382_t_real &
       &,   -24.944820_t_real,   -19.990982_t_real,   -15.736989_t_real &
       &,   -12.347316_t_real,    -9.735035_t_real,    -7.708128_t_real &
       &,    -6.118156_t_real,    -4.853875_t_real,    -3.850175_t_real &
       &,    -3.063422_t_real,    -2.454065_t_real,    -1.988978_t_real &
       &,    -1.640456_t_real,    -1.380883_t_real,    -1.184174_t_real &
       &,    -1.030287_t_real,    -0.905584_t_real,    -0.800853_t_real &
       &,    -0.709668_t_real,    -0.627572_t_real,    -0.551702_t_real &
       &,    -0.480509_t_real,    -0.413461_t_real,    -0.350712_t_real &
       &,    -0.292780_t_real,    -0.240270_t_real,    -0.193672_t_real &
       &,    -0.153247_t_real,    -0.118982_t_real,    -0.090610_t_real &
       &,    -0.067658_t_real,    -0.049519_t_real,    -0.035513_t_real &
       &,    -0.024949_t_real,    -0.017165_t_real,    -0.011564_t_real &
       &,    -0.007628_t_real,    -0.004926_t_real/
  Data bscoefnrel(1:50, 75) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000002_t_real &
       &,    -0.000021_t_real,    -0.000168_t_real,    -0.000588_t_real &
       &,    -0.000805_t_real,    -0.000223_t_real,     0.000086_t_real &
       &,    -0.001571_t_real,    -0.003067_t_real,    -0.002096_t_real &
       &,     0.000007_t_real,    -0.001243_t_real,    -0.013576_t_real &
       &,    -0.036706_t_real,    -0.062756_t_real,    -0.087775_t_real &
       &,    -0.109566_t_real,    -0.124371_t_real,    -0.127227_t_real &
       &,    -0.116080_t_real,    -0.094988_t_real,    -0.070744_t_real &
       &,    -0.048252_t_real,    -0.029714_t_real,    -0.015615_t_real &
       &,    -0.005653_t_real,     0.000776_t_real,     0.004385_t_real &
       &,     0.005905_t_real,     0.006029_t_real,     0.005346_t_real &
       &,     0.004305_t_real,     0.003207_t_real,     0.002223_t_real &
       &,     0.001434_t_real,     0.000859_t_real,     0.000483_t_real &
       &,     0.000269_t_real,     0.000172_t_real,     0.000147_t_real &
       &,     0.000155_t_real,     0.000169_t_real,     0.000174_t_real &
       &,     0.000166_t_real,     0.000147_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 76) /&
       &    -76.000000_t_real,   -75.924549_t_real,   -75.392578_t_real &
       &,   -73.947143_t_real,   -71.269266_t_real,   -67.330827_t_real &
       &,   -62.282425_t_real,   -56.367273_t_real,   -49.921160_t_real &
       &,   -43.301779_t_real,   -36.827302_t_real,   -30.750062_t_real &
       &,   -25.158309_t_real,   -20.144925_t_real,   -15.867146_t_real &
       &,   -12.473922_t_real,    -9.848224_t_real,    -7.796171_t_real &
       &,    -6.173617_t_real,    -4.876055_t_real,    -3.847146_t_real &
       &,    -3.045961_t_real,    -2.431312_t_real,    -1.965924_t_real &
       &,    -1.617436_t_real,    -1.356523_t_real,    -1.158159_t_real &
       &,    -1.003365_t_real,    -0.878624_t_real,    -0.774356_t_real &
       &,    -0.683767_t_real,    -0.602224_t_real,    -0.526864_t_real &
       &,    -0.456242_t_real,    -0.389952_t_real,    -0.328248_t_real &
       &,    -0.271691_t_real,    -0.220869_t_real,    -0.176211_t_real &
       &,    -0.137888_t_real,    -0.105787_t_real,    -0.079547_t_real &
       &,    -0.058611_t_real,    -0.042308_t_real,    -0.029914_t_real &
       &,    -0.020713_t_real,    -0.014044_t_real,    -0.009322_t_real &
       &,    -0.006056_t_real,    -0.003851_t_real/
  Data bscoefnrel(1:50, 76) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000023_t_real,    -0.000160_t_real,    -0.000544_t_real &
       &,    -0.000709_t_real,    -0.000175_t_real,     0.000017_t_real &
       &,    -0.001606_t_real,    -0.002776_t_real,    -0.001721_t_real &
       &,     0.000095_t_real,    -0.001933_t_real,    -0.014445_t_real &
       &,    -0.034828_t_real,    -0.055616_t_real,    -0.073814_t_real &
       &,    -0.087580_t_real,    -0.094216_t_real,    -0.091282_t_real &
       &,    -0.079225_t_real,    -0.061944_t_real,    -0.044016_t_real &
       &,    -0.028321_t_real,    -0.015940_t_real,    -0.006921_t_real &
       &,    -0.000880_t_real,     0.002724_t_real,     0.004471_t_real &
       &,     0.004923_t_real,     0.004575_t_real,     0.003823_t_real &
       &,     0.002949_t_real,     0.002121_t_real,     0.001424_t_real &
       &,     0.000885_t_real,     0.000499_t_real,     0.000245_t_real &
       &,     0.000094_t_real,     0.000018_t_real,    -0.000008_t_real &
       &,    -0.000008_t_real,     0.000003_t_real,     0.000016_t_real &
       &,     0.000025_t_real,     0.000029_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 77) /&
       &    -77.000000_t_real,   -76.923116_t_real,   -76.381036_t_real &
       &,   -74.908571_t_real,   -72.183134_t_real,   -68.177707_t_real &
       &,   -63.046021_t_real,   -57.035220_t_real,   -50.488964_t_real &
       &,   -43.770784_t_real,   -37.203581_t_real,   -31.039357_t_real &
       &,   -25.370001_t_real,   -20.298560_t_real,   -15.998427_t_real &
       &,   -12.597990_t_real,    -9.952483_t_real,    -7.869883_t_real &
       &,    -6.210575_t_real,    -4.878579_t_real,    -3.826044_t_real &
       &,    -3.012910_t_real,    -2.394795_t_real,    -1.930163_t_real &
       &,    -1.583316_t_real,    -1.323846_t_real,    -1.127017_t_real &
       &,    -0.974066_t_real,    -0.851317_t_real,    -0.748931_t_real &
       &,    -0.659964_t_real,    -0.579780_t_real,    -0.505612_t_real &
       &,    -0.436141_t_real,    -0.371078_t_real,    -0.310746_t_real &
       &,    -0.255722_t_real,    -0.206571_t_real,    -0.163668_t_real &
       &,    -0.127118_t_real,    -0.096741_t_real,    -0.072117_t_real &
       &,    -0.052650_t_real,    -0.037636_t_real,    -0.026338_t_real &
       &,    -0.018043_t_real,    -0.012098_t_real,    -0.007939_t_real &
       &,    -0.005098_t_real,    -0.003203_t_real/
  Data bscoefnrel(1:50, 77) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,    -0.000021_t_real,    -0.000140_t_real,    -0.000463_t_real &
       &,    -0.000573_t_real,    -0.000123_t_real,    -0.000040_t_real &
       &,    -0.001470_t_real,    -0.002281_t_real,    -0.001270_t_real &
       &,     0.000123_t_real,    -0.002391_t_real,    -0.013745_t_real &
       &,    -0.029885_t_real,    -0.044849_t_real,    -0.056750_t_real &
       &,    -0.064354_t_real,    -0.066118_t_real,    -0.061253_t_real &
       &,    -0.051018_t_real,    -0.038360_t_real,    -0.026101_t_real &
       &,    -0.015826_t_real,    -0.008018_t_real,    -0.002559_t_real &
       &,     0.000907_t_real,     0.002807_t_real,     0.003566_t_real &
       &,     0.003571_t_real,     0.003146_t_real,     0.002536_t_real &
       &,     0.001902_t_real,     0.001336_t_real,     0.000876_t_real &
       &,     0.000529_t_real,     0.000284_t_real,     0.000122_t_real &
       &,     0.000026_t_real,    -0.000025_t_real,    -0.000044_t_real &
       &,    -0.000046_t_real,    -0.000038_t_real,    -0.000028_t_real &
       &,    -0.000018_t_real,    -0.000010_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 78) /&
       &    -78.000000_t_real,   -77.921652_t_real,   -77.369238_t_real &
       &,   -75.869152_t_real,   -73.095071_t_real,   -69.020905_t_real &
       &,   -63.803340_t_real,   -57.693405_t_real,   -51.042601_t_real &
       &,   -44.220326_t_real,   -37.554041_t_real,   -31.294725_t_real &
       &,   -25.538909_t_real,   -20.399881_t_real,   -16.065567_t_real &
       &,   -12.638980_t_real,    -9.949995_t_real,    -7.811954_t_real &
       &,    -6.092371_t_real,    -4.708973_t_real,    -3.625870_t_real &
       &,    -2.804440_t_real,    -2.194481_t_real,    -1.745998_t_real &
       &,    -1.416607_t_real,    -1.172991_t_real,    -0.990072_t_real &
       &,    -0.849555_t_real,    -0.738339_t_real,    -0.647088_t_real &
       &,    -0.569202_t_real,    -0.500174_t_real,    -0.437173_t_real &
       &,    -0.378685_t_real,    -0.324126_t_real,    -0.273489_t_real &
       &,    -0.227044_t_real,    -0.185143_t_real,    -0.148093_t_real &
       &,    -0.116074_t_real,    -0.089087_t_real,    -0.066932_t_real &
       &,    -0.049224_t_real,    -0.035442_t_real,    -0.024992_t_real &
       &,    -0.017264_t_real,    -0.011687_t_real,    -0.007754_t_real &
       &,    -0.005043_t_real,    -0.003214_t_real/
  Data bscoefnrel(1:50, 78) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000001_t_real &
       &,    -0.000003_t_real,    -0.000004_t_real,     0.000000_t_real &
       &,    -0.000012_t_real,    -0.000059_t_real,    -0.000150_t_real &
       &,    -0.000194_t_real,    -0.000066_t_real,    -0.000027_t_real &
       &,    -0.000562_t_real,    -0.000827_t_real,    -0.000380_t_real &
       &,    -0.000001_t_real,    -0.001540_t_real,    -0.005843_t_real &
       &,    -0.010314_t_real,    -0.013753_t_real,    -0.016940_t_real &
       &,    -0.020911_t_real,    -0.026403_t_real,    -0.033480_t_real &
       &,    -0.041370_t_real,    -0.048744_t_real,    -0.054220_t_real &
       &,    -0.056780_t_real,    -0.055999_t_real,    -0.052105_t_real &
       &,    -0.045849_t_real,    -0.038245_t_real,    -0.030286_t_real &
       &,    -0.022769_t_real,    -0.016230_t_real,    -0.010964_t_real &
       &,    -0.007057_t_real,    -0.004426_t_real,    -0.002854_t_real &
       &,    -0.002048_t_real,    -0.001711_t_real,    -0.001592_t_real &
       &,    -0.001526_t_real,    -0.001426_t_real,    -0.001269_t_real &
       &,    -0.001070_t_real,    -0.000856_t_real,    -0.000652_t_real &
       &,    -0.000474_t_real,    -0.000331_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 79) /&
       &    -79.000000_t_real,   -78.920200_t_real,   -78.357540_t_real &
       &,   -76.830089_t_real,   -74.007951_t_real,   -69.866092_t_real &
       &,   -64.564307_t_real,   -58.357779_t_real,   -51.605942_t_real &
       &,   -44.684142_t_real,   -37.924585_t_real,   -31.577148_t_real &
       &,   -25.744159_t_real,   -20.549460_t_real,   -16.193267_t_real &
       &,   -12.749744_t_real,   -10.028489_t_real,    -7.850308_t_real &
       &,    -6.087668_t_real,    -4.670890_t_real,    -3.570604_t_real &
       &,    -2.745204_t_real,    -2.139017_t_real,    -1.697512_t_real &
       &,    -1.375425_t_real,    -1.138086_t_real,    -0.960115_t_real &
       &,    -0.823472_t_real,    -0.715480_t_real,    -0.627163_t_real &
       &,    -0.552098_t_real,    -0.485786_t_real,    -0.425337_t_real &
       &,    -0.369169_t_real,    -0.316658_t_real,    -0.267765_t_real &
       &,    -0.222752_t_real,    -0.181985_t_real,    -0.145811_t_real &
       &,    -0.114455_t_real,    -0.087965_t_real,    -0.066177_t_real &
       &,    -0.048735_t_real,    -0.035142_t_real,    -0.024820_t_real &
       &,    -0.017175_t_real,    -0.011647_t_real,    -0.007742_t_real &
       &,    -0.005045_t_real,    -0.003222_t_real/
  Data bscoefnrel(1:50, 79) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000001_t_real &
       &,    -0.000003_t_real,    -0.000004_t_real,     0.000000_t_real &
       &,    -0.000004_t_real,    -0.000008_t_real,     0.000015_t_real &
       &,    -0.000005_t_real,    -0.000031_t_real,     0.000008_t_real &
       &,    -0.000021_t_real,    -0.000058_t_real,     0.000005_t_real &
       &,    -0.000066_t_real,    -0.000462_t_real,    -0.000519_t_real &
       &,     0.000251_t_real,     0.001074_t_real,     0.000777_t_real &
       &,    -0.001828_t_real,    -0.007553_t_real,    -0.016313_t_real &
       &,    -0.026928_t_real,    -0.037530_t_real,    -0.046235_t_real &
       &,    -0.051626_t_real,    -0.053013_t_real,    -0.050551_t_real &
       &,    -0.045110_t_real,    -0.037912_t_real,    -0.030137_t_real &
       &,    -0.022696_t_real,    -0.016187_t_real,    -0.010939_t_real &
       &,    -0.007062_t_real,    -0.004474_t_real,    -0.002949_t_real &
       &,    -0.002181_t_real,    -0.001861_t_real,    -0.001740_t_real &
       &,    -0.001656_t_real,    -0.001530_t_real,    -0.001348_t_real &
       &,    -0.001126_t_real,    -0.000894_t_real,    -0.000676_t_real &
       &,    -0.000490_t_real,    -0.000341_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 80) /&
       &    -80.000000_t_real,   -79.918764_t_real,   -79.345977_t_real &
       &,   -77.791505_t_real,   -74.922064_t_real,   -70.713839_t_real &
       &,   -65.329915_t_real,   -59.029934_t_real,   -52.181349_t_real &
       &,   -45.165551_t_real,   -38.319709_t_real,   -31.892627_t_real &
       &,   -25.993479_t_real,   -20.757025_t_real,   -16.392981_t_real &
       &,   -12.944209_t_real,   -10.205743_t_real,    -8.006004_t_real &
       &,    -6.220599_t_real,    -4.789758_t_real,    -3.683620_t_real &
       &,    -2.853732_t_real,    -2.240650_t_real,    -1.790417_t_real &
       &,    -1.459940_t_real,    -1.215950_t_real,    -1.033093_t_real &
       &,    -0.892413_t_real,    -0.780043_t_real,    -0.686106_t_real &
       &,    -0.603873_t_real,    -0.529103_t_real,    -0.459483_t_real &
       &,    -0.394103_t_real,    -0.332963_t_real,    -0.276548_t_real &
       &,    -0.225483_t_real,    -0.180294_t_real,    -0.141269_t_real &
       &,    -0.108411_t_real,    -0.081449_t_real,    -0.059887_t_real &
       &,    -0.043085_t_real,    -0.030322_t_real,    -0.020873_t_real &
       &,    -0.014052_t_real,    -0.009250_t_real,    -0.005954_t_real &
       &,    -0.003746_t_real,    -0.002304_t_real/
  Data bscoefnrel(1:50, 80) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 81) /&
       &    -81.000000_t_real,   -80.917334_t_real,   -80.334455_t_real &
       &,   -78.753074_t_real,   -75.836622_t_real,   -71.562568_t_real &
       &,   -66.097376_t_real,   -59.705356_t_real,   -52.762058_t_real &
       &,   -45.655012_t_real,   -38.726424_t_real,   -32.223947_t_real &
       &,   -26.264453_t_real,   -20.994048_t_real,   -16.628694_t_real &
       &,   -13.178108_t_real,   -10.427628_t_real,    -8.212884_t_real &
       &,    -6.413742_t_real,    -4.979517_t_real,    -3.876260_t_real &
       &,    -3.046889_t_real,    -2.428173_t_real,    -1.967178_t_real &
       &,    -1.622992_t_real,    -1.363736_t_real,    -1.165045_t_real &
       &,    -1.009165_t_real,    -0.883556_t_real,    -0.779424_t_real &
       &,    -0.690622_t_real,    -0.612890_t_real,    -0.543336_t_real &
       &,    -0.480039_t_real,    -0.421774_t_real,    -0.367807_t_real &
       &,    -0.317750_t_real,    -0.271454_t_real,    -0.228930_t_real &
       &,    -0.190295_t_real,    -0.155708_t_real,    -0.125299_t_real &
       &,    -0.099105_t_real,    -0.077026_t_real,    -0.058826_t_real &
       &,    -0.044152_t_real,    -0.032573_t_real,    -0.023626_t_real &
       &,    -0.016851_t_real,    -0.011819_t_real/
  Data bscoefnrel(1:50, 81) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000004_t_real &
       &,    -0.000009_t_real,    -0.000001_t_real,     0.000004_t_real &
       &,    -0.000016_t_real,    -0.000014_t_real,     0.000003_t_real &
       &,    -0.000042_t_real,    -0.000054_t_real,    -0.000004_t_real &
       &,    -0.000051_t_real,    -0.000346_t_real,    -0.000499_t_real &
       &,    -0.000201_t_real,     0.000253_t_real,     0.000252_t_real &
       &,    -0.001090_t_real,    -0.004697_t_real,    -0.010893_t_real &
       &,    -0.018911_t_real,    -0.027284_t_real,    -0.034670_t_real &
       &,    -0.040230_t_real,    -0.043559_t_real,    -0.044543_t_real &
       &,    -0.043279_t_real,    -0.040063_t_real,    -0.035363_t_real &
       &,    -0.029768_t_real,    -0.023884_t_real,    -0.018252_t_real &
       &,    -0.013282_t_real,    -0.009239_t_real,    -0.006228_t_real &
       &,    -0.004207_t_real,    -0.003011_t_real,    -0.002406_t_real &
       &,    -0.002153_t_real,    -0.002056_t_real,    -0.001982_t_real &
       &,    -0.001866_t_real,    -0.001689_t_real,    -0.001465_t_real &
       &,    -0.001217_t_real,    -0.000971_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 82) /&
       &    -82.000000_t_real,   -81.915897_t_real,   -81.322877_t_real &
       &,   -79.714477_t_real,   -76.750871_t_real,   -72.410820_t_real &
       &,   -66.864179_t_real,   -60.380079_t_real,   -53.342141_t_real &
       &,   -46.144036_t_real,   -39.133004_t_real,   -32.555516_t_real &
       &,   -26.536786_t_real,   -21.234594_t_real,   -16.867388_t_real &
       &,   -13.410944_t_real,   -10.645724_t_real,    -8.412987_t_real &
       &,    -6.597810_t_real,    -5.156264_t_real,    -4.047483_t_real &
       &,    -3.207264_t_real,    -2.572471_t_real,    -2.093335_t_real &
       &,    -1.730280_t_real,    -1.451655_t_real,    -1.234118_t_real &
       &,    -1.061324_t_real,    -0.921520_t_real,    -0.805823_t_real &
       &,    -0.707405_t_real,    -0.621163_t_real,    -0.543552_t_real &
       &,    -0.472379_t_real,    -0.406525_t_real,    -0.345609_t_real &
       &,    -0.289668_t_real,    -0.238919_t_real,    -0.193615_t_real &
       &,    -0.153954_t_real,    -0.120003_t_real,    -0.091647_t_real &
       &,    -0.068563_t_real,    -0.050254_t_real,    -0.036098_t_real &
       &,    -0.025419_t_real,    -0.017554_t_real,    -0.011891_t_real &
       &,    -0.007902_t_real,    -0.005152_t_real/
  Data bscoefnrel(1:50, 82) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000001_t_real,    -0.000012_t_real &
       &,    -0.000024_t_real,    -0.000005_t_real,     0.000005_t_real &
       &,    -0.000050_t_real,    -0.000035_t_real,     0.000003_t_real &
       &,    -0.000140_t_real,    -0.000155_t_real,    -0.000006_t_real &
       &,    -0.000197_t_real,    -0.001084_t_real,    -0.001414_t_real &
       &,    -0.000551_t_real,     0.000498_t_real,    -0.000106_t_real &
       &,    -0.004852_t_real,    -0.015628_t_real,    -0.031515_t_real &
       &,    -0.048689_t_real,    -0.063234_t_real,    -0.073032_t_real &
       &,    -0.077550_t_real,    -0.077123_t_real,    -0.072531_t_real &
       &,    -0.064826_t_real,    -0.055198_t_real,    -0.044819_t_real &
       &,    -0.034694_t_real,    -0.025562_t_real,    -0.017884_t_real &
       &,    -0.011878_t_real,    -0.007555_t_real,    -0.004742_t_real &
       &,    -0.003128_t_real,    -0.002339_t_real,    -0.002019_t_real &
       &,    -0.001892_t_real,    -0.001791_t_real,    -0.001641_t_real &
       &,    -0.001432_t_real,    -0.001187_t_real,    -0.000936_t_real &
       &,    -0.000705_t_real,    -0.000509_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 83) /&
       &    -83.000000_t_real,   -82.914454_t_real,   -82.311249_t_real &
       &,   -80.675728_t_real,   -77.664846_t_real,   -73.258662_t_real &
       &,   -67.630437_t_real,   -61.054279_t_real,   -53.921856_t_real &
       &,   -46.632981_t_real,   -39.539908_t_real,   -32.887987_t_real &
       &,   -26.811288_t_real,   -21.479551_t_real,   -17.109685_t_real &
       &,   -13.643745_t_real,   -10.861600_t_real,    -8.608195_t_real &
       &,    -6.775047_t_real,    -5.322091_t_real,    -4.200152_t_real &
       &,    -3.340976_t_real,    -2.684543_t_real,    -2.183379_t_real &
       &,    -1.797784_t_real,    -1.497383_t_real,    -1.261044_t_real &
       &,    -1.073493_t_real,    -0.922579_t_real,    -0.798276_t_real &
       &,    -0.692627_t_real,    -0.599856_t_real,    -0.516261_t_real &
       &,    -0.439870_t_real,    -0.369912_t_real,    -0.306298_t_real &
       &,    -0.249212_t_real,    -0.198875_t_real,    -0.155420_t_real &
       &,    -0.118811_t_real,    -0.088787_t_real,    -0.064849_t_real &
       &,    -0.046301_t_real,    -0.032328_t_real,    -0.022083_t_real &
       &,    -0.014764_t_real,    -0.009664_t_real,    -0.006194_t_real &
       &,    -0.003888_t_real,    -0.002389_t_real/
  Data bscoefnrel(1:50, 83) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000003_t_real,    -0.000023_t_real &
       &,    -0.000045_t_real,    -0.000010_t_real,     0.000001_t_real &
       &,    -0.000102_t_real,    -0.000061_t_real,    -0.000006_t_real &
       &,    -0.000298_t_real,    -0.000290_t_real,    -0.000001_t_real &
       &,    -0.000498_t_real,    -0.002247_t_real,    -0.002602_t_real &
       &,    -0.000857_t_real,     0.000735_t_real,    -0.001644_t_real &
       &,    -0.012592_t_real,    -0.033730_t_real,    -0.060013_t_real &
       &,    -0.083426_t_real,    -0.099079_t_real,    -0.106018_t_real &
       &,    -0.105238_t_real,    -0.098362_t_real,    -0.087192_t_real &
       &,    -0.073546_t_real,    -0.059096_t_real,    -0.045214_t_real &
       &,    -0.032870_t_real,    -0.022625_t_real,    -0.014700_t_real &
       &,    -0.009046_t_real,    -0.005396_t_real,    -0.003320_t_real &
       &,    -0.002315_t_real,    -0.001913_t_real,    -0.001763_t_real &
       &,    -0.001653_t_real,    -0.001495_t_real,    -0.001279_t_real &
       &,    -0.001033_t_real,    -0.000789_t_real,    -0.000573_t_real &
       &,    -0.000397_t_real,    -0.000264_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 84) /&
       &    -84.000000_t_real,   -83.913006_t_real,   -83.299583_t_real &
       &,   -81.636872_t_real,   -78.578651_t_real,   -74.106293_t_real &
       &,   -68.396492_t_real,   -61.728491_t_real,   -54.501995_t_real &
       &,   -47.122962_t_real,   -39.948628_t_real,   -33.223377_t_real &
       &,   -27.090540_t_real,   -21.732020_t_real,   -17.359001_t_real &
       &,   -13.881048_t_real,   -11.080875_t_real,    -8.805210_t_real &
       &,    -6.953103_t_real,    -5.485294_t_real,    -4.344544_t_real &
       &,    -3.462687_t_real,    -2.784952_t_real,    -2.264487_t_real &
       &,    -1.860200_t_real,    -1.542611_t_real,    -1.291973_t_real &
       &,    -1.093164_t_real,    -0.933251_t_real,    -0.801332_t_real &
       &,    -0.688958_t_real,    -0.590269_t_real,    -0.501720_t_real &
       &,    -0.421532_t_real,    -0.349083_t_real,    -0.284350_t_real &
       &,    -0.227487_t_real,    -0.178558_t_real,    -0.137401_t_real &
       &,    -0.103596_t_real,    -0.076500_t_real,    -0.055313_t_real &
       &,    -0.039152_t_real,    -0.027127_t_real,    -0.018396_t_real &
       &,    -0.012211_t_real,    -0.007933_t_real,    -0.005044_t_real &
       &,    -0.003139_t_real,    -0.001912_t_real/
  Data bscoefnrel(1:50, 84) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000002_t_real,    -0.000019_t_real &
       &,    -0.000036_t_real,    -0.000008_t_real,    -0.000004_t_real &
       &,    -0.000087_t_real,    -0.000044_t_real,    -0.000016_t_real &
       &,    -0.000261_t_real,    -0.000224_t_real,     0.000005_t_real &
       &,    -0.000516_t_real,    -0.001935_t_real,    -0.001977_t_real &
       &,    -0.000501_t_real,     0.000401_t_real,    -0.002613_t_real &
       &,    -0.012833_t_real,    -0.029321_t_real,    -0.045950_t_real &
       &,    -0.057595_t_real,    -0.063054_t_real,    -0.063109_t_real &
       &,    -0.059006_t_real,    -0.052028_t_real,    -0.043417_t_real &
       &,    -0.034313_t_real,    -0.025669_t_real,    -0.018160_t_real &
       &,    -0.012145_t_real,    -0.007677_t_real,    -0.004584_t_real &
       &,    -0.002577_t_real,    -0.001353_t_real,    -0.000650_t_real &
       &,    -0.000275_t_real,    -0.000093_t_real,    -0.000017_t_real &
       &,     0.000006_t_real,     0.000006_t_real,     0.000000_t_real &
       &,    -0.000006_t_real,    -0.000009_t_real,    -0.000010_t_real &
       &,    -0.000009_t_real,    -0.000008_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 85) /&
       &    -85.000000_t_real,   -84.911551_t_real,   -84.287863_t_real &
       &,   -82.597855_t_real,   -79.492157_t_real,   -74.953466_t_real &
       &,   -69.161912_t_real,   -62.402034_t_real,   -55.081540_t_real &
       &,   -47.612525_t_real,   -40.357146_t_real,   -33.559042_t_real &
       &,   -27.371096_t_real,   -21.987424_t_real,   -17.609264_t_real &
       &,   -14.115837_t_real,   -11.295135_t_real,    -8.994226_t_real &
       &,    -7.120385_t_real,    -5.632345_t_real,    -4.466624_t_real &
       &,    -3.558934_t_real,    -2.858218_t_real,    -2.315035_t_real &
       &,    -1.888653_t_real,    -1.552864_t_real,    -1.289265_t_real &
       &,    -1.081763_t_real,    -0.915740_t_real,    -0.779011_t_real &
       &,    -0.662545_t_real,    -0.560442_t_real,    -0.469373_t_real &
       &,    -0.387795_t_real,    -0.315205_t_real,    -0.251550_t_real &
       &,    -0.196817_t_real,    -0.150815_t_real,    -0.113090_t_real &
       &,    -0.082935_t_real,    -0.059453_t_real,    -0.041648_t_real &
       &,    -0.028501_t_real,    -0.019050_t_real,    -0.012435_t_real &
       &,    -0.007925_t_real,    -0.004932_t_real,    -0.002996_t_real &
       &,    -0.001776_t_real,    -0.001028_t_real/
  Data bscoefnrel(1:50, 85) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000002_t_real,    -0.000011_t_real &
       &,    -0.000021_t_real,    -0.000004_t_real,    -0.000005_t_real &
       &,    -0.000053_t_real,    -0.000022_t_real,    -0.000016_t_real &
       &,    -0.000161_t_real,    -0.000122_t_real,     0.000004_t_real &
       &,    -0.000374_t_real,    -0.001174_t_real,    -0.001052_t_real &
       &,    -0.000175_t_real,     0.000080_t_real,    -0.002354_t_real &
       &,    -0.008879_t_real,    -0.017547_t_real,    -0.024615_t_real &
       &,    -0.028459_t_real,    -0.029315_t_real,    -0.027878_t_real &
       &,    -0.024855_t_real,    -0.020898_t_real,    -0.016595_t_real &
       &,    -0.012437_t_real,    -0.008782_t_real,    -0.005834_t_real &
       &,    -0.003642_t_real,    -0.002133_t_real,    -0.001168_t_real &
       &,    -0.000593_t_real,    -0.000274_t_real,    -0.000110_t_real &
       &,    -0.000035_t_real,    -0.000007_t_real,     0.000000_t_real &
       &,    -0.000001_t_real,    -0.000004_t_real,    -0.000006_t_real &
       &,    -0.000007_t_real,    -0.000006_t_real,    -0.000005_t_real &
       &,    -0.000004_t_real,    -0.000003_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 86) /&
       &    -86.000000_t_real,   -85.910090_t_real,   -85.276092_t_real &
       &,   -83.558682_t_real,   -80.405377_t_real,   -75.800201_t_real &
       &,   -69.926734_t_real,   -63.074959_t_real,   -55.660564_t_real &
       &,   -48.101769_t_real,   -40.765567_t_real,   -33.895153_t_real &
       &,   -27.653166_t_real,   -22.245796_t_real,   -17.860220_t_real &
       &,   -14.348262_t_real,   -11.504514_t_real,    -9.175632_t_real &
       &,    -7.277145_t_real,    -5.763652_t_real,    -4.568514_t_real &
       &,    -3.633472_t_real,    -2.907412_t_real,    -2.338402_t_real &
       &,    -1.889647_t_real,    -1.538413_t_real,    -1.265869_t_real &
       &,    -1.053573_t_real,    -0.884706_t_real,    -0.745825_t_real &
       &,    -0.627533_t_real,    -0.524076_t_real,    -0.432431_t_real &
       &,    -0.351291_t_real,    -0.280231_t_real,    -0.219102_t_real &
       &,    -0.167672_t_real,    -0.125462_t_real,    -0.091721_t_real &
       &,    -0.065473_t_real,    -0.045613_t_real,    -0.031003_t_real &
       &,    -0.020553_t_real,    -0.013286_t_real,    -0.008374_t_real &
       &,    -0.005145_t_real,    -0.003081_t_real,    -0.001798_t_real &
       &,    -0.001022_t_real,    -0.000566_t_real/
  Data bscoefnrel(1:50, 86) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 87) /&
       &    -87.000000_t_real,   -86.908652_t_real,   -86.264507_t_real &
       &,   -84.520161_t_real,   -81.320227_t_real,   -76.650243_t_real &
       &,   -70.697406_t_real,   -63.757471_t_real,   -56.254272_t_real &
       &,   -48.612320_t_real,   -41.203496_t_real,   -34.271108_t_real &
       &,   -27.987856_t_real,   -22.571796_t_real,   -18.192322_t_real &
       &,   -14.677554_t_real,   -11.828949_t_real,    -9.492874_t_real &
       &,    -7.592755_t_real,    -6.078384_t_real,    -4.883006_t_real &
       &,    -3.951349_t_real,    -3.225800_t_real,    -2.651788_t_real &
       &,    -2.194232_t_real,    -1.829281_t_real,    -1.536571_t_real &
       &,    -1.299920_t_real,    -1.109591_t_real,    -0.961326_t_real &
       &,    -0.851888_t_real,    -0.774861_t_real,    -0.719173_t_real &
       &,    -0.673434_t_real,    -0.630865_t_real,    -0.588461_t_real &
       &,    -0.544895_t_real,    -0.499613_t_real,    -0.452600_t_real &
       &,    -0.404314_t_real,    -0.355588_t_real,    -0.307500_t_real &
       &,    -0.261216_t_real,    -0.217838_t_real,    -0.178281_t_real &
       &,    -0.143180_t_real,    -0.112858_t_real,    -0.087336_t_real &
       &,    -0.066381_t_real,    -0.049575_t_real/
  Data bscoefnrel(1:50, 87) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,    -0.000001_t_real,    -0.000001_t_real,     0.000000_t_real &
       &,    -0.000001_t_real,    -0.000002_t_real,     0.000001_t_real &
       &,    -0.000006_t_real,    -0.000004_t_real,    -0.000002_t_real &
       &,    -0.000021_t_real,    -0.000012_t_real,    -0.000003_t_real &
       &,    -0.000082_t_real,    -0.000134_t_real,    -0.000036_t_real &
       &,     0.000007_t_real,    -0.000267_t_real,    -0.000863_t_real &
       &,    -0.001206_t_real,    -0.000809_t_real,    -0.000012_t_real &
       &,     0.000411_t_real,    -0.000491_t_real,    -0.003839_t_real &
       &,    -0.010762_t_real,    -0.021818_t_real,    -0.035995_t_real &
       &,    -0.049841_t_real,    -0.059017_t_real,    -0.062967_t_real &
       &,    -0.063521_t_real,    -0.061382_t_real,    -0.056648_t_real &
       &,    -0.049757_t_real,    -0.041541_t_real,    -0.032965_t_real &
       &,    -0.024892_t_real,    -0.017948_t_real,    -0.012468_t_real &
       &,    -0.008506_t_real,    -0.005897_t_real,    -0.004344_t_real &
       &,    -0.003509_t_real,    -0.003084_t_real,    -0.002839_t_real &
       &,    -0.002628_t_real,    -0.002385_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 88) /&
       &    -88.000000_t_real,   -87.907209_t_real,   -87.252880_t_real &
       &,   -85.481517_t_real,   -82.234868_t_real,   -77.499994_t_real &
       &,   -71.467719_t_real,   -64.439721_t_real,   -56.847966_t_real &
       &,   -49.123245_t_real,   -41.642198_t_real,   -34.648691_t_real &
       &,   -28.325550_t_real,   -22.902064_t_real,   -18.526294_t_real &
       &,   -15.006607_t_real,   -12.150550_t_real,    -9.804878_t_real &
       &,    -7.899752_t_real,    -6.380156_t_real,    -5.181362_t_real &
       &,    -4.246960_t_real,    -3.511254_t_real,    -2.919711_t_real &
       &,    -2.439001_t_real,    -2.046160_t_real,    -1.725727_t_real &
       &,    -1.470886_t_real,    -1.277970_t_real,    -1.136719_t_real &
       &,    -1.030184_t_real,    -0.943078_t_real,    -0.865769_t_real &
       &,    -0.793062_t_real,    -0.722236_t_real,    -0.651958_t_real &
       &,    -0.581843_t_real,    -0.512252_t_real,    -0.444108_t_real &
       &,    -0.378655_t_real,    -0.317207_t_real,    -0.260930_t_real &
       &,    -0.210682_t_real,    -0.166943_t_real,    -0.129810_t_real &
       &,    -0.099045_t_real,    -0.074157_t_real,    -0.054485_t_real &
       &,    -0.039285_t_real,    -0.027798_t_real/
  Data bscoefnrel(1:50, 88) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 89) /&
       &    -89.000000_t_real,   -88.905749_t_real,   -88.241114_t_real &
       &,   -86.442427_t_real,   -83.148527_t_real,   -78.347929_t_real &
       &,   -72.234997_t_real,   -65.117414_t_real,   -57.435245_t_real &
       &,   -49.625498_t_real,   -42.069294_t_real,   -35.011466_t_real &
       &,   -28.644947_t_real,   -23.209321_t_real,   -18.828060_t_real &
       &,   -15.293678_t_real,   -12.418664_t_real,   -10.051700_t_real &
       &,    -8.127817_t_real,    -6.586401_t_real,    -5.364934_t_real &
       &,    -4.404516_t_real,    -3.635837_t_real,    -3.009771_t_real &
       &,    -2.498376_t_real,    -2.082246_t_real,    -1.748566_t_real &
       &,    -1.489267_t_real,    -1.293800_t_real,    -1.145780_t_real &
       &,    -1.028413_t_real,    -0.929485_t_real,    -0.841453_t_real &
       &,    -0.759800_t_real,    -0.681842_t_real,    -0.606185_t_real &
       &,    -0.532450_t_real,    -0.461043_t_real,    -0.392877_t_real &
       &,    -0.329076_t_real,    -0.270708_t_real,    -0.218597_t_real &
       &,    -0.173216_t_real,    -0.134666_t_real,    -0.102711_t_real &
       &,    -0.076850_t_real,    -0.056408_t_real,    -0.040618_t_real &
       &,    -0.028693_t_real,    -0.019884_t_real/
  Data bscoefnrel(1:50, 89) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,    -0.000002_t_real,    -0.000015_t_real,    -0.000036_t_real &
       &,    -0.000018_t_real,     0.000001_t_real,    -0.000064_t_real &
       &,    -0.000113_t_real,    -0.000046_t_real,    -0.000007_t_real &
       &,    -0.000322_t_real,    -0.000791_t_real,    -0.000815_t_real &
       &,    -0.000346_t_real,     0.000130_t_real,    -0.000768_t_real &
       &,    -0.004038_t_real,    -0.009081_t_real,    -0.015139_t_real &
       &,    -0.021715_t_real,    -0.028026_t_real,    -0.032590_t_real &
       &,    -0.033624_t_real,    -0.030650_t_real,    -0.025163_t_real &
       &,    -0.019073_t_real,    -0.013504_t_real,    -0.008881_t_real &
       &,    -0.005290_t_real,    -0.002678_t_real,    -0.000922_t_real &
       &,     0.000137_t_real,     0.000673_t_real,     0.000855_t_real &
       &,     0.000825_t_real,     0.000688_t_real,     0.000517_t_real &
       &,     0.000352_t_real,     0.000214_t_real,     0.000109_t_real &
       &,     0.000037_t_real,    -0.000008_t_real,    -0.000032_t_real &
       &,    -0.000042_t_real,    -0.000042_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 90) /&
       &    -90.000000_t_real,   -89.904281_t_real,   -89.229286_t_real &
       &,   -87.403145_t_real,   -84.061808_t_real,   -79.195239_t_real &
       &,   -73.001321_t_real,   -65.793882_t_real,   -58.021085_t_real &
       &,   -50.126126_t_real,   -42.494408_t_real,   -35.372249_t_real &
       &,   -28.962690_t_real,   -23.514391_t_real,   -19.123616_t_real &
       &,   -15.571162_t_real,   -12.672860_t_real,   -10.280786_t_real &
       &,    -8.332645_t_real,    -6.763190_t_real,    -5.513328_t_real &
       &,    -4.520002_t_real,    -3.713501_t_real,    -3.052337_t_real &
       &,    -2.513507_t_real,    -2.079573_t_real,    -1.737442_t_real &
       &,    -1.475294_t_real,    -1.277264_t_real,    -1.124735_t_real &
       &,    -1.001904_t_real,    -0.897911_t_real,    -0.805789_t_real &
       &,    -0.721089_t_real,    -0.641095_t_real,    -0.564425_t_real &
       &,    -0.490748_t_real,    -0.420486_t_real,    -0.354482_t_real &
       &,    -0.293701_t_real,    -0.238979_t_real,    -0.190878_t_real &
       &,    -0.149613_t_real,    -0.115060_t_real,    -0.086813_t_real &
       &,    -0.064259_t_real,    -0.046661_t_real,    -0.033239_t_real &
       &,    -0.023228_t_real,    -0.015923_t_real/
  Data bscoefnrel(1:50, 90) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000006_t_real,    -0.000040_t_real,    -0.000089_t_real &
       &,    -0.000042_t_real,     0.000001_t_real,    -0.000172_t_real &
       &,    -0.000274_t_real,    -0.000094_t_real,    -0.000044_t_real &
       &,    -0.000937_t_real,    -0.001969_t_real,    -0.001774_t_real &
       &,    -0.000497_t_real,     0.000133_t_real,    -0.003501_t_real &
       &,    -0.012385_t_real,    -0.024045_t_real,    -0.036617_t_real &
       &,    -0.048703_t_real,    -0.058180_t_real,    -0.062121_t_real &
       &,    -0.058686_t_real,    -0.049360_t_real,    -0.037704_t_real &
       &,    -0.026536_t_real,    -0.017150_t_real,    -0.009879_t_real &
       &,    -0.004635_t_real,    -0.001157_t_real,     0.000895_t_real &
       &,     0.001885_t_real,     0.002158_t_real,     0.002008_t_real &
       &,     0.001654_t_real,     0.001243_t_real,     0.000859_t_real &
       &,     0.000540_t_real,     0.000300_t_real,     0.000133_t_real &
       &,     0.000028_t_real,    -0.000029_t_real,    -0.000053_t_real &
       &,    -0.000057_t_real,    -0.000049_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 91) /&
       &    -91.000000_t_real,   -90.902740_t_real,   -90.216873_t_real &
       &,   -88.361909_t_real,   -84.970515_t_real,   -80.033645_t_real &
       &,   -73.752132_t_real,   -66.445347_t_real,   -58.568545_t_real &
       &,   -50.570315_t_real,   -42.840861_t_real,   -35.630193_t_real &
       &,   -29.150933_t_real,   -23.657897_t_real,   -19.216291_t_real &
       &,   -15.596210_t_real,   -12.618742_t_real,   -10.151150_t_real &
       &,    -8.149221_t_real,    -6.552699_t_real,    -5.296945_t_real &
       &,    -4.311610_t_real,    -3.526717_t_real,    -2.896652_t_real &
       &,    -2.390782_t_real,    -1.985794_t_real,    -1.666634_t_real &
       &,    -1.423014_t_real,    -1.241249_t_real,    -1.103105_t_real &
       &,    -0.992190_t_real,    -0.897458_t_real,    -0.812278_t_real &
       &,    -0.732694_t_real,    -0.656383_t_real,    -0.582209_t_real &
       &,    -0.509983_t_real,    -0.440228_t_real,    -0.373901_t_real &
       &,    -0.312107_t_real,    -0.255853_t_real,    -0.205877_t_real &
       &,    -0.162567_t_real,    -0.125948_t_real,    -0.095732_t_real &
       &,    -0.071385_t_real,    -0.052221_t_real,    -0.037478_t_real &
       &,    -0.026388_t_real,    -0.018228_t_real/
  Data bscoefnrel(1:50, 91) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000002_t_real,    -0.000017_t_real,    -0.000082_t_real &
       &,    -0.000269_t_real,    -0.000810_t_real,    -0.001567_t_real &
       &,    -0.001251_t_real,    -0.000365_t_real,    -0.000093_t_real &
       &,    -0.003341_t_real,    -0.009861_t_real,    -0.017373_t_real &
       &,    -0.026189_t_real,    -0.034949_t_real,    -0.039339_t_real &
       &,    -0.038689_t_real,    -0.036984_t_real,    -0.036556_t_real &
       &,    -0.037605_t_real,    -0.039186_t_real,    -0.039482_t_real &
       &,    -0.036719_t_real,    -0.030902_t_real,    -0.023735_t_real &
       &,    -0.016826_t_real,    -0.010940_t_real,    -0.006293_t_real &
       &,    -0.002866_t_real,    -0.000536_t_real,     0.000872_t_real &
       &,     0.001566_t_real,     0.001759_t_real,     0.001642_t_real &
       &,     0.001369_t_real,     0.001046_t_real,     0.000738_t_real &
       &,     0.000478_t_real,     0.000276_t_real,     0.000132_t_real &
       &,     0.000037_t_real,    -0.000018_t_real,    -0.000046_t_real &
       &,    -0.000054_t_real,    -0.000051_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 92) /&
       &    -92.000000_t_real,   -91.901219_t_real,   -91.204628_t_real &
       &,   -89.321260_t_real,   -85.880699_t_real,   -80.875078_t_real &
       &,   -74.508400_t_real,   -67.106012_t_real,   -59.130636_t_real &
       &,   -51.036600_t_real,   -43.218644_t_real,   -35.930361_t_real &
       &,   -29.394042_t_real,   -23.869255_t_real,   -19.389479_t_real &
       &,   -15.719598_t_real,   -12.684569_t_real,   -10.165549_t_real &
       &,    -8.127371_t_real,    -6.508625_t_real,    -5.241373_t_real &
       &,    -4.249923_t_real,    -3.464095_t_real,    -2.837986_t_real &
       &,    -2.338761_t_real,    -1.941500_t_real,    -1.630550_t_real &
       &,    -1.394861_t_real,    -1.219551_t_real,    -1.085869_t_real &
       &,    -0.977800_t_real,    -0.884884_t_real,    -0.800912_t_real &
       &,    -0.722183_t_real,    -0.646539_t_real,    -0.572957_t_real &
       &,    -0.501330_t_real,    -0.432227_t_real,    -0.366621_t_real &
       &,    -0.305611_t_real,    -0.250178_t_real,    -0.201028_t_real &
       &,    -0.158515_t_real,    -0.122639_t_real,    -0.093088_t_real &
       &,    -0.069319_t_real,    -0.050641_t_real,    -0.036296_t_real &
       &,    -0.025521_t_real,    -0.017605_t_real/
  Data bscoefnrel(1:50, 92) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000001_t_real,    -0.000020_t_real,    -0.000120_t_real &
       &,    -0.000454_t_real,    -0.001379_t_real,    -0.002496_t_real &
       &,    -0.001844_t_real,    -0.000435_t_real,    -0.000323_t_real &
       &,    -0.006180_t_real,    -0.016592_t_real,    -0.028324_t_real &
       &,    -0.041632_t_real,    -0.053228_t_real,    -0.056397_t_real &
       &,    -0.052020_t_real,    -0.046539_t_real,    -0.043030_t_real &
       &,    -0.041705_t_real,    -0.041466_t_real,    -0.040325_t_real &
       &,    -0.036482_t_real,    -0.030029_t_real,    -0.022615_t_real &
       &,    -0.015672_t_real,    -0.009844_t_real,    -0.005296_t_real &
       &,    -0.001992_t_real,     0.000199_t_real,     0.001466_t_real &
       &,     0.002025_t_real,     0.002097_t_real,     0.001880_t_real &
       &,     0.001529_t_real,     0.001147_t_real,     0.000798_t_real &
       &,     0.000510_t_real,     0.000290_t_real,     0.000136_t_real &
       &,     0.000036_t_real,    -0.000022_t_real,    -0.000049_t_real &
       &,    -0.000057_t_real,    -0.000053_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 93) /&
       &    -93.000000_t_real,   -92.899689_t_real,   -92.192305_t_real &
       &,   -90.280367_t_real,   -86.790379_t_real,   -81.715631_t_real &
       &,   -75.263259_t_real,   -67.764671_t_real,   -59.689984_t_real &
       &,   -51.499252_t_real,   -43.591761_t_real,   -36.225310_t_real &
       &,   -29.631709_t_real,   -24.073000_t_real,   -19.550159_t_real &
       &,   -15.826553_t_real,   -12.731003_t_real,   -10.161273_t_real &
       &,    -8.089665_t_real,    -6.452502_t_real,    -5.177446_t_real &
       &,    -4.183676_t_real,    -3.400437_t_real,    -2.780694_t_real &
       &,    -2.289383_t_real,    -1.900368_t_real,    -1.597694_t_real &
       &,    -1.369666_t_real,    -1.200360_t_real,    -1.070704_t_real &
       &,    -0.965150_t_real,    -0.873812_t_real,    -0.790876_t_real &
       &,    -0.712874_t_real,    -0.637796_t_real,    -0.564724_t_real &
       &,    -0.493617_t_real,    -0.425088_t_real,    -0.360123_t_real &
       &,    -0.299811_t_real,    -0.245111_t_real,    -0.196699_t_real &
       &,    -0.154900_t_real,    -0.119686_t_real,    -0.090729_t_real &
       &,    -0.067476_t_real,    -0.049232_t_real,    -0.035241_t_real &
       &,    -0.024748_t_real,    -0.017051_t_real/
  Data bscoefnrel(1:50, 93) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000001_t_real,    -0.000023_t_real,    -0.000169_t_real &
       &,    -0.000681_t_real,    -0.002057_t_real,    -0.003510_t_real &
       &,    -0.002414_t_real,    -0.000437_t_real,    -0.000802_t_real &
       &,    -0.010052_t_real,    -0.024666_t_real,    -0.040634_t_real &
       &,    -0.057922_t_real,    -0.070935_t_real,    -0.071452_t_real &
       &,    -0.062912_t_real,    -0.053803_t_real,    -0.047531_t_real &
       &,    -0.044201_t_real,    -0.042533_t_real,    -0.040355_t_real &
       &,    -0.035805_t_real,    -0.029008_t_real,    -0.021524_t_real &
       &,    -0.014635_t_real,    -0.008901_t_real,    -0.004462_t_real &
       &,    -0.001275_t_real,     0.000794_t_real,     0.001939_t_real &
       &,     0.002385_t_real,     0.002359_t_real,     0.002062_t_real &
       &,     0.001648_t_real,     0.001222_t_real,     0.000841_t_real &
       &,     0.000531_t_real,     0.000299_t_real,     0.000137_t_real &
       &,     0.000034_t_real,    -0.000025_t_real,    -0.000051_t_real &
       &,    -0.000058_t_real,    -0.000052_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 94) /&
       &    -94.000000_t_real,   -93.898116_t_real,   -93.179633_t_real &
       &,   -91.238319_t_real,   -87.697385_t_real,   -82.551026_t_real &
       &,   -76.009189_t_real,   -68.409074_t_real,   -60.227683_t_real &
       &,   -51.930472_t_real,   -43.921642_t_real,   -36.464302_t_real &
       &,   -29.799273_t_real,   -24.187821_t_real,   -19.597472_t_real &
       &,   -15.792400_t_real,   -12.607931_t_real,    -9.965550_t_real &
       &,    -7.850316_t_real,    -6.197375_t_real,    -4.927678_t_real &
       &,    -3.954720_t_real,    -3.203423_t_real,    -2.620306_t_real &
       &,    -2.163557_t_real,    -1.802226_t_real,    -1.519364_t_real &
       &,    -1.306955_t_real,    -1.153428_t_real,    -1.040024_t_real &
       &,    -0.949270_t_real,    -0.870147_t_real,    -0.796820_t_real &
       &,    -0.726241_t_real,    -0.656811_t_real,    -0.587867_t_real &
       &,    -0.519497_t_real,    -0.452391_t_real,    -0.387632_t_real &
       &,    -0.326456_t_real,    -0.270028_t_real,    -0.219261_t_real &
       &,    -0.174728_t_real,    -0.136629_t_real,    -0.104826_t_real &
       &,    -0.078910_t_real,    -0.058282_t_real,    -0.042235_t_real &
       &,    -0.030031_t_real,    -0.020951_t_real/
  Data bscoefnrel(1:50, 94) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000002_t_real,    -0.000008_t_real,    -0.000214_t_real &
       &,    -0.001057_t_real,    -0.003192_t_real,    -0.005052_t_real &
       &,    -0.003198_t_real,    -0.000415_t_real,    -0.001706_t_real &
       &,    -0.016150_t_real,    -0.037240_t_real,    -0.060213_t_real &
       &,    -0.084338_t_real,    -0.100319_t_real,    -0.096910_t_real &
       &,    -0.079662_t_real,    -0.060211_t_real,    -0.043473_t_real &
       &,    -0.030307_t_real,    -0.020467_t_real,    -0.013414_t_real &
       &,    -0.008493_t_real,    -0.005056_t_real,    -0.002562_t_real &
       &,    -0.000664_t_real,     0.000790_t_real,     0.001841_t_real &
       &,     0.002504_t_real,     0.002805_t_real,     0.002803_t_real &
       &,     0.002575_t_real,     0.002209_t_real,     0.001784_t_real &
       &,     0.001364_t_real,     0.000988_t_real,     0.000676_t_real &
       &,     0.000432_t_real,     0.000252_t_real,     0.000126_t_real &
       &,     0.000044_t_real,    -0.000006_t_real,    -0.000031_t_real &
       &,    -0.000041_t_real,    -0.000041_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 95) /&
       &    -95.000000_t_real,   -94.896566_t_real,   -94.167148_t_real &
       &,   -92.196923_t_real,   -88.606017_t_real,   -83.389739_t_real &
       &,   -76.761083_t_real,   -69.063474_t_real,   -60.781159_t_real &
       &,   -52.385345_t_real,   -44.284881_t_real,   -36.748161_t_real &
       &,   -30.025103_t_real,   -24.374220_t_real,   -19.731122_t_real &
       &,   -15.864696_t_real,   -12.615709_t_real,    -9.926505_t_real &
       &,    -7.785547_t_real,    -6.122997_t_real,    -4.853834_t_real &
       &,    -3.886231_t_real,    -3.143283_t_real,    -2.569573_t_real &
       &,    -2.121544_t_real,    -1.767940_t_real,    -1.492419_t_real &
       &,    -1.286978_t_real,    -1.138996_t_real,    -1.029117_t_real &
       &,    -0.940309_t_real,    -0.862227_t_real,    -0.789481_t_real &
       &,    -0.719257_t_real,    -0.650083_t_real,    -0.581374_t_real &
       &,    -0.513273_t_real,    -0.446500_t_real,    -0.382152_t_real &
       &,    -0.321462_t_real,    -0.265574_t_real,    -0.215380_t_real &
       &,    -0.171422_t_real,    -0.133876_t_real,    -0.102585_t_real &
       &,    -0.077126_t_real,    -0.056891_t_real,    -0.041175_t_real &
       &,    -0.029239_t_real,    -0.020372_t_real/
  Data bscoefnrel(1:50, 95) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000003_t_real,    -0.000014_t_real,    -0.000291_t_real &
       &,    -0.001384_t_real,    -0.004099_t_real,    -0.006157_t_real &
       &,    -0.003641_t_real,    -0.000285_t_real,    -0.003070_t_real &
       &,    -0.022397_t_real,    -0.047809_t_real,    -0.074499_t_real &
       &,    -0.100934_t_real,    -0.115480_t_real,    -0.107497_t_real &
       &,    -0.085905_t_real,    -0.063331_t_real,    -0.044448_t_real &
       &,    -0.029896_t_real,    -0.019309_t_real,    -0.012054_t_real &
       &,    -0.007320_t_real,    -0.004205_t_real,    -0.001972_t_real &
       &,    -0.000226_t_real,     0.001151_t_real,     0.002162_t_real &
       &,     0.002793_t_real,     0.003063_t_real,     0.003023_t_real &
       &,     0.002755_t_real,     0.002349_t_real,     0.001888_t_real &
       &,     0.001437_t_real,     0.001037_t_real,     0.000706_t_real &
       &,     0.000449_t_real,     0.000259_t_real,     0.000128_t_real &
       &,     0.000042_t_real,    -0.000008_t_real,    -0.000034_t_real &
       &,    -0.000044_t_real,    -0.000043_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 96) /&
       &    -96.000000_t_real,   -95.895042_t_real,   -95.154880_t_real &
       &,   -93.156281_t_real,   -89.516519_t_real,   -84.232251_t_real &
       &,   -77.519787_t_real,   -69.729244_t_real,   -61.352510_t_real &
       &,   -52.866885_t_real,   -44.685511_t_real,   -37.082081_t_real &
       &,   -30.315763_t_real,   -24.640359_t_real,   -19.961903_t_real &
       &,   -16.056743_t_real,   -12.769798_t_real,   -10.059381_t_real &
       &,    -7.907922_t_real,    -6.238290_t_real,    -4.959972_t_real &
       &,    -3.977365_t_real,    -3.215869_t_real,    -2.622971_t_real &
       &,    -2.158348_t_real,    -1.794459_t_real,    -1.515527_t_real &
       &,    -1.308165_t_real,    -1.154036_t_real,    -1.034032_t_real &
       &,    -0.934287_t_real,    -0.846510_t_real,    -0.765878_t_real &
       &,    -0.689489_t_real,    -0.615688_t_real,    -0.543800_t_real &
       &,    -0.473952_t_real,    -0.406848_t_real,    -0.343500_t_real &
       &,    -0.284966_t_real,    -0.232140_t_real,    -0.185617_t_real &
       &,    -0.145645_t_real,    -0.112129_t_real,    -0.084695_t_real &
       &,    -0.062762_t_real,    -0.045629_t_real,    -0.032544_t_real &
       &,    -0.022772_t_real,    -0.015632_t_real/
  Data bscoefnrel(1:50, 96) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000002_t_real,    -0.000043_t_real,    -0.000396_t_real &
       &,    -0.001640_t_real,    -0.004739_t_real,    -0.006831_t_real &
       &,    -0.003787_t_real,    -0.000114_t_real,    -0.004869_t_real &
       &,    -0.028193_t_real,    -0.055574_t_real,    -0.082825_t_real &
       &,    -0.107499_t_real,    -0.117025_t_real,    -0.104828_t_real &
       &,    -0.083878_t_real,    -0.065705_t_real,    -0.053272_t_real &
       &,    -0.046015_t_real,    -0.041987_t_real,    -0.038378_t_real &
       &,    -0.033052_t_real,    -0.026090_t_real,    -0.018808_t_real &
       &,    -0.012221_t_real,    -0.006785_t_real,    -0.002635_t_real &
       &,     0.000264_t_real,     0.002044_t_real,     0.002912_t_real &
       &,     0.003107_t_real,     0.002869_t_real,     0.002404_t_real &
       &,     0.001865_t_real,     0.001348_t_real,     0.000907_t_real &
       &,     0.000559_t_real,     0.000305_t_real,     0.000133_t_real &
       &,     0.000026_t_real,    -0.000030_t_real,    -0.000053_t_real &
       &,    -0.000055_t_real,    -0.000047_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 97) /&
       &    -97.000000_t_real,   -96.893441_t_real,   -96.141984_t_real &
       &,   -94.113540_t_real,   -90.422097_t_real,   -85.065164_t_real &
       &,   -78.261758_t_real,   -70.368036_t_real,   -61.882574_t_real &
       &,   -53.288208_t_real,   -45.003247_t_real,   -37.307951_t_real &
       &,   -30.469550_t_real,   -24.732707_t_real,   -19.974083_t_real &
       &,   -15.978731_t_real,   -12.603185_t_real,    -9.832827_t_real &
       &,    -7.655356_t_real,    -5.984957_t_real,    -4.720159_t_real &
       &,    -3.762616_t_real,    -3.034757_t_real,    -2.477710_t_real &
       &,    -2.044982_t_real,    -1.705245_t_real,    -1.443366_t_real &
       &,    -1.250800_t_real,    -1.112587_t_real,    -1.008559_t_real &
       &,    -0.922811_t_real,    -0.846287_t_real,    -0.774371_t_real &
       &,    -0.704634_t_real,    -0.635810_t_real,    -0.567448_t_real &
       &,    -0.499792_t_real,    -0.433626_t_real,    -0.370076_t_real &
       &,    -0.310365_t_real,    -0.255598_t_real,    -0.206611_t_real &
       &,    -0.163886_t_real,    -0.127544_t_real,    -0.097380_t_real &
       &,    -0.072939_t_real,    -0.053595_t_real,    -0.038633_t_real &
       &,    -0.027319_t_real,    -0.018952_t_real/
  Data bscoefnrel(1:50, 97) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,    -0.000019_t_real,    -0.000276_t_real &
       &,    -0.001227_t_real,    -0.003485_t_real,    -0.004705_t_real &
       &,    -0.002401_t_real,     0.000016_t_real,    -0.004335_t_real &
       &,    -0.021276_t_real,    -0.039865_t_real,    -0.057933_t_real &
       &,    -0.073150_t_real,    -0.077269_t_real,    -0.067215_t_real &
       &,    -0.051068_t_real,    -0.035827_t_real,    -0.023613_t_real &
       &,    -0.014562_t_real,    -0.008366_t_real,    -0.004564_t_real &
       &,    -0.002475_t_real,    -0.001286_t_real,    -0.000419_t_real &
       &,     0.000338_t_real,     0.000986_t_real,     0.001478_t_real &
       &,     0.001778_t_real,     0.001883_t_real,     0.001820_t_real &
       &,     0.001634_t_real,     0.001376_t_real,     0.001095_t_real &
       &,     0.000825_t_real,     0.000590_t_real,     0.000397_t_real &
       &,     0.000249_t_real,     0.000141_t_real,     0.000067_t_real &
       &,     0.000019_t_real,    -0.000009_t_real,    -0.000022_t_real &
       &,    -0.000027_t_real,    -0.000026_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 98) /&
       &    -98.000000_t_real,   -97.891864_t_real,   -97.129290_t_real &
       &,   -95.071501_t_real,   -91.329420_t_real,   -85.901626_t_real &
       &,   -79.010101_t_real,   -71.017479_t_real,   -62.429413_t_real &
       &,   -53.734625_t_real,   -45.356276_t_real,   -37.581130_t_real &
       &,   -30.684546_t_real,   -24.899985_t_real,   -20.078221_t_real &
       &,   -16.014421_t_real,   -12.576231_t_real,    -9.769900_t_real &
       &,    -7.578993_t_real,    -5.908304_t_real,    -4.648862_t_real &
       &,    -3.699514_t_real,    -2.981422_t_real,    -2.433801_t_real &
       &,    -2.009131_t_real,    -1.676439_t_real,    -1.421295_t_real &
       &,    -1.234817_t_real,    -1.101007_t_real,    -0.999534_t_real &
       &,    -0.915115_t_real,    -0.839281_t_real,    -0.767745_t_real &
       &,    -0.698243_t_real,    -0.629596_t_real,    -0.561413_t_real &
       &,    -0.493979_t_real,    -0.428105_t_real,    -0.364926_t_real &
       &,    -0.305659_t_real,    -0.251392_t_real,    -0.202936_t_real &
       &,    -0.160747_t_real,    -0.124922_t_real,    -0.095238_t_real &
       &,    -0.071226_t_real,    -0.052255_t_real,    -0.037606_t_real &
       &,    -0.026549_t_real,    -0.018386_t_real/
  Data bscoefnrel(1:50, 98) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,    -0.000019_t_real,    -0.000250_t_real &
       &,    -0.001081_t_real,    -0.003004_t_real,    -0.003841_t_real &
       &,    -0.001808_t_real,     0.000057_t_real,    -0.004548_t_real &
       &,    -0.019062_t_real,    -0.033826_t_real,    -0.047642_t_real &
       &,    -0.058238_t_real,    -0.059420_t_real,    -0.050242_t_real &
       &,    -0.037330_t_real,    -0.025582_t_real,    -0.016343_t_real &
       &,    -0.009634_t_real,    -0.005188_t_real,    -0.002621_t_real &
       &,    -0.001343_t_real,    -0.000664_t_real,    -0.000141_t_real &
       &,     0.000355_t_real,     0.000799_t_real,     0.001140_t_real &
       &,     0.001345_t_real,     0.001409_t_real,     0.001352_t_real &
       &,     0.001207_t_real,     0.001012_t_real,     0.000802_t_real &
       &,     0.000602_t_real,     0.000429_t_real,     0.000288_t_real &
       &,     0.000179_t_real,     0.000101_t_real,     0.000047_t_real &
       &,     0.000013_t_real,    -0.000007_t_real,    -0.000017_t_real &
       &,    -0.000020_t_real,    -0.000020_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50, 99) /&
       &    -99.000000_t_real,   -98.890279_t_real,   -98.116522_t_real &
       &,   -96.029235_t_real,   -92.236273_t_real,   -86.737271_t_real &
       &,   -79.757143_t_real,   -71.665075_t_real,   -62.973738_t_real &
       &,   -54.177808_t_real,   -45.705397_t_real,   -37.850083_t_real &
       &,   -30.894897_t_real,   -25.059320_t_real,   -20.171291_t_real &
       &,   -16.036774_t_real,   -12.537197_t_real,    -9.698278_t_real &
       &,    -7.497109_t_real,    -5.828518_t_real,    -4.576444_t_real &
       &,    -3.636953_t_real,    -2.929573_t_real,    -2.391701_t_real &
       &,    -1.975103_t_real,    -1.649378_t_real,    -1.400816_t_real &
       &,    -1.220134_t_real,    -1.090384_t_real,    -0.991212_t_real &
       &,    -0.907976_t_real,    -0.832756_t_real,    -0.761563_t_real &
       &,    -0.692278_t_real,    -0.623799_t_real,    -0.555790_t_real &
       &,    -0.488571_t_real,    -0.422981_t_real,    -0.360158_t_real &
       &,    -0.301313_t_real,    -0.247518_t_real,    -0.199560_t_real &
       &,    -0.157872_t_real,    -0.122527_t_real,    -0.093287_t_real &
       &,    -0.069672_t_real,    -0.051042_t_real,    -0.036680_t_real &
       &,    -0.025857_t_real,    -0.017879_t_real/
  Data bscoefnrel(1:50, 99) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000017_t_real,    -0.000211_t_real &
       &,    -0.000887_t_real,    -0.002411_t_real,    -0.002919_t_real &
       &,    -0.001259_t_real,     0.000045_t_real,    -0.004324_t_real &
       &,    -0.015764_t_real,    -0.026651_t_real,    -0.036453_t_real &
       &,    -0.043222_t_real,    -0.042720_t_real,    -0.035203_t_real &
       &,    -0.025613_t_real,    -0.017152_t_real,    -0.010617_t_real &
       &,    -0.005967_t_real,    -0.002990_t_real,    -0.001382_t_real &
       &,    -0.000666_t_real,    -0.000312_t_real,    -0.000010_t_real &
       &,     0.000304_t_real,     0.000597_t_real,     0.000823_t_real &
       &,     0.000957_t_real,     0.000994_t_real,     0.000948_t_real &
       &,     0.000842_t_real,     0.000703_t_real,     0.000555_t_real &
       &,     0.000416_t_real,     0.000295_t_real,     0.000197_t_real &
       &,     0.000122_t_real,     0.000068_t_real,     0.000031_t_real &
       &,     0.000008_t_real,    -0.000006_t_real,    -0.000012_t_real &
       &,    -0.000014_t_real,    -0.000014_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,100) /&
       &   -100.000000_t_real,   -99.888684_t_real,   -99.103681_t_real &
       &,   -96.986745_t_real,   -93.142661_t_real,   -87.572108_t_real &
       &,   -80.502899_t_real,   -72.310844_t_real,   -63.515579_t_real &
       &,   -54.617809_t_real,   -46.050715_t_real,   -38.114936_t_real &
       &,   -31.100640_t_real,   -25.210670_t_real,   -20.253556_t_real &
       &,   -16.046354_t_real,   -12.487187_t_real,    -9.619209_t_real &
       &,    -7.410886_t_real,    -5.746699_t_real,    -4.503833_t_real &
       &,    -3.575535_t_real,    -2.879509_t_real,    -2.351506_t_real &
       &,    -1.942883_t_real,    -1.623989_t_real,    -1.381820_t_real &
       &,    -1.206629_t_real,    -1.080603_t_real,    -0.983491_t_real &
       &,    -0.901302_t_real,    -0.826626_t_real,    -0.755739_t_real &
       &,    -0.686651_t_real,    -0.618332_t_real,    -0.550490_t_real &
       &,    -0.483483_t_real,    -0.418167_t_real,    -0.355687_t_real &
       &,    -0.297248_t_real,    -0.243903_t_real,    -0.196417_t_real &
       &,    -0.155200_t_real,    -0.120308_t_real,    -0.091484_t_real &
       &,    -0.068238_t_real,    -0.049927_t_real,    -0.035831_t_real &
       &,    -0.025223_t_real,    -0.017416_t_real/
  Data bscoefnrel(1:50,100) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000014_t_real,    -0.000156_t_real &
       &,    -0.000644_t_real,    -0.001710_t_real,    -0.001959_t_real &
       &,    -0.000768_t_real,     0.000007_t_real,    -0.003550_t_real &
       &,    -0.011437_t_real,    -0.018513_t_real,    -0.024639_t_real &
       &,    -0.028386_t_real,    -0.027248_t_real,    -0.021929_t_real &
       &,    -0.015637_t_real,    -0.010235_t_real,    -0.006134_t_real &
       &,    -0.003275_t_real,    -0.001511_t_real,    -0.000625_t_real &
       &,    -0.000280_t_real,    -0.000122_t_real,     0.000036_t_real &
       &,     0.000218_t_real,     0.000393_t_real,     0.000529_t_real &
       &,     0.000607_t_real,     0.000626_t_real,     0.000594_t_real &
       &,     0.000526_t_real,     0.000437_t_real,     0.000344_t_real &
       &,     0.000257_t_real,     0.000181_t_real,     0.000121_t_real &
       &,     0.000074_t_real,     0.000041_t_real,     0.000018_t_real &
       &,     0.000004_t_real,    -0.000004_t_real,    -0.000008_t_real &
       &,    -0.000009_t_real,    -0.000009_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,101) /&
       &   -101.000000_t_real,  -100.887080_t_real,  -100.090768_t_real &
       &,   -97.944031_t_real,   -94.048588_t_real,   -88.406141_t_real &
       &,   -81.247379_t_real,   -72.954800_t_real,   -64.054951_t_real &
       &,   -55.054664_t_real,   -46.392311_t_real,   -38.375787_t_real &
       &,   -31.301764_t_real,   -25.353976_t_real,   -20.325223_t_real &
       &,   -16.043697_t_real,   -12.427216_t_real,    -9.533790_t_real &
       &,    -7.321330_t_real,    -5.663733_t_real,    -4.431709_t_real &
       &,    -3.515653_t_real,    -2.831377_t_real,    -2.313218_t_real &
       &,    -1.912405_t_real,    -1.600172_t_real,    -1.364187_t_real &
       &,    -1.194174_t_real,    -1.071554_t_real,    -0.976283_t_real &
       &,    -0.895018_t_real,    -0.820822_t_real,    -0.750210_t_real &
       &,    -0.681304_t_real,    -0.613134_t_real,    -0.545456_t_real &
       &,    -0.478654_t_real,    -0.413605_t_real,    -0.351458_t_real &
       &,    -0.293409_t_real,    -0.240495_t_real,    -0.193460_t_real &
       &,    -0.152693_t_real,    -0.118229_t_real,    -0.089798_t_real &
       &,    -0.066901_t_real,    -0.048888_t_real,    -0.035042_t_real &
       &,    -0.024636_t_real,    -0.016988_t_real/
  Data bscoefnrel(1:50,101) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000008_t_real,    -0.000087_t_real &
       &,    -0.000349_t_real,    -0.000904_t_real,    -0.000980_t_real &
       &,    -0.000346_t_real,    -0.000023_t_real,    -0.002132_t_real &
       &,    -0.006153_t_real,    -0.009579_t_real,    -0.012424_t_real &
       &,    -0.013931_t_real,    -0.013016_t_real,    -0.010247_t_real &
       &,    -0.007167_t_real,    -0.004586_t_real,    -0.002658_t_real &
       &,    -0.001342_t_real,    -0.000560_t_real,    -0.000199_t_real &
       &,    -0.000081_t_real,    -0.000031_t_real,     0.000033_t_real &
       &,     0.000113_t_real,     0.000193_t_real,     0.000255_t_real &
       &,     0.000290_t_real,     0.000297_t_real,     0.000281_t_real &
       &,     0.000247_t_real,     0.000205_t_real,     0.000161_t_real &
       &,     0.000119_t_real,     0.000084_t_real,     0.000056_t_real &
       &,     0.000034_t_real,     0.000019_t_real,     0.000008_t_real &
       &,     0.000002_t_real,    -0.000002_t_real,    -0.000004_t_real &
       &,    -0.000004_t_real,    -0.000004_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,102) /&
       &   -102.000000_t_real,  -101.885467_t_real,  -101.077783_t_real &
       &,   -98.901095_t_real,   -94.954057_t_real,   -89.239374_t_real &
       &,   -81.990590_t_real,   -73.596950_t_real,   -64.591869_t_real &
       &,   -55.488400_t_real,   -46.730253_t_real,   -38.632716_t_real &
       &,   -31.498220_t_real,   -25.489178_t_real,   -20.386463_t_real &
       &,   -16.029337_t_real,   -12.358229_t_real,    -9.443001_t_real &
       &,    -7.229304_t_real,    -5.580338_t_real,    -4.360569_t_real &
       &,    -3.457548_t_real,    -2.785232_t_real,    -2.276789_t_real &
       &,    -1.883577_t_real,    -1.577818_t_real,    -1.347796_t_real &
       &,    -1.182650_t_real,    -1.063139_t_real,    -0.969511_t_real &
       &,    -0.889064_t_real,    -0.815295_t_real,    -0.744931_t_real &
       &,    -0.676191_t_real,    -0.608165_t_real,    -0.540644_t_real &
       &,    -0.474044_t_real,    -0.409255_t_real,    -0.347432_t_real &
       &,    -0.289761_t_real,    -0.237262_t_real,    -0.190660_t_real &
       &,    -0.150322_t_real,    -0.116266_t_real,    -0.088209_t_real &
       &,    -0.065643_t_real,    -0.047914_t_real,    -0.034303_t_real &
       &,    -0.024087_t_real,    -0.016589_t_real/
  Data bscoefnrel(1:50,102) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoefnrel(1:50,103) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  Data bscoefnrel(1:50,103) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  
  !! full relativistic
  Data ncoeffrel(  0) / 50 /
  Data vcoeffrel(1:50,  0) /&
       &     0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real/
  !! 1s
  !!
  Data ncoeffrel(  1) / 50 /
  Data vcoeffrel(1:50,  1) /&
       &     -1.000000_t_real,    -0.999964_t_real,    -0.999709_t_real &
       &,    -0.999011_t_real,    -0.997626_t_real,    -0.995270_t_real &
       &,    -0.991598_t_real,    -0.986181_t_real,    -0.978502_t_real &
       &,    -0.967968_t_real,    -0.953962_t_real,    -0.935911_t_real &
       &,    -0.913394_t_real,    -0.886246_t_real,    -0.854643_t_real &
       &,    -0.819138_t_real,    -0.780634_t_real,    -0.740272_t_real &
       &,    -0.699270_t_real,    -0.658734_t_real,    -0.619486_t_real &
       &,    -0.581958_t_real,    -0.546160_t_real,    -0.511742_t_real &
       &,    -0.478120_t_real,    -0.444640_t_real,    -0.410740_t_real &
       &,    -0.376072_t_real,    -0.340578_t_real,    -0.304497_t_real &
       &,    -0.268324_t_real,    -0.232726_t_real,    -0.198448_t_real &
       &,    -0.166210_t_real,    -0.136628_t_real,    -0.110158_t_real &
       &,    -0.087066_t_real,    -0.067426_t_real,    -0.051141_t_real &
       &,    -0.037978_t_real,    -0.027603_t_real,    -0.019631_t_real &
       &,    -0.013658_t_real,    -0.009294_t_real,    -0.006184_t_real &
       &,    -0.004023_t_real,    -0.002558_t_real,    -0.001589_t_real &
       &,    -0.000964_t_real,    -0.000572_t_real/
  !!
  Data ncoeffrel(  2) / 50 /
  Data vcoeffrel(1:50,  2) /&
       &     -2.000000_t_real,    -1.999707_t_real,    -1.997653_t_real &
       &,    -1.992051_t_real,    -1.981026_t_real,    -1.962551_t_real &
       &,    -1.934399_t_real,    -1.894198_t_real,    -1.839642_t_real &
       &,    -1.768897_t_real,    -1.681149_t_real,    -1.577147_t_real &
       &,    -1.459526_t_real,    -1.332725_t_real,    -1.202421_t_real &
       &,    -1.074597_t_real,    -0.954496_t_real,    -0.845782_t_real &
       &,    -0.750122_t_real,    -0.667258_t_real,    -0.595484_t_real &
       &,    -0.532332_t_real,    -0.475248_t_real,    -0.422115_t_real &
       &,    -0.371533_t_real,    -0.322869_t_real,    -0.276142_t_real &
       &,    -0.231819_t_real,    -0.190596_t_real,    -0.153188_t_real &
       &,    -0.120175_t_real,    -0.091901_t_real,    -0.068431_t_real &
       &,    -0.049567_t_real,    -0.034895_t_real,    -0.023861_t_real &
       &,    -0.015837_t_real,    -0.010199_t_real,    -0.006370_t_real &
       &,    -0.003858_t_real,    -0.002264_t_real,    -0.001288_t_real &
       &,    -0.000709_t_real,    -0.000378_t_real,    -0.000195_t_real &
       &,    -0.000097_t_real,    -0.000047_t_real,    -0.000022_t_real &
       &,    -0.000010_t_real,    -0.000004_t_real/
  !! 2s
  !!
  Data ncoeffrel(  3) / 50 /
  Data vcoeffrel(1:50,  3) /&
       &     -3.000000_t_real,    -2.999459_t_real,    -2.995660_t_real &
       &,    -2.985282_t_real,    -2.964819_t_real,    -2.930457_t_real &
       &,    -2.878102_t_real,    -2.803756_t_real,    -2.704338_t_real &
       &,    -2.578868_t_real,    -2.429564_t_real,    -2.262255_t_real &
       &,    -2.085610_t_real,    -1.909238_t_real,    -1.741282_t_real &
       &,    -1.586510_t_real,    -1.445684_t_real,    -1.316467_t_real &
       &,    -1.195541_t_real,    -1.081421_t_real,    -0.977389_t_real &
       &,    -0.892192_t_real,    -0.832649_t_real,    -0.793893_t_real &
       &,    -0.765073_t_real,    -0.738802_t_real,    -0.712002_t_real &
       &,    -0.683777_t_real,    -0.653970_t_real,    -0.622524_t_real &
       &,    -0.589297_t_real,    -0.554081_t_real,    -0.516710_t_real &
       &,    -0.477178_t_real,    -0.435724_t_real,    -0.392858_t_real &
       &,    -0.349332_t_real,    -0.306055_t_real,    -0.263996_t_real &
       &,    -0.224073_t_real,    -0.187070_t_real,    -0.153575_t_real &
       &,    -0.123953_t_real,    -0.098345_t_real,    -0.076695_t_real &
       &,    -0.058786_t_real,    -0.044284_t_real,    -0.032785_t_real &
       &,    -0.023852_t_real,    -0.017052_t_real/
  !!
  Data ncoeffrel(  4) / 50 /
  Data vcoeffrel(1:50,  4) /&
       &     -4.000000_t_real,    -3.999149_t_real,    -3.993173_t_real &
       &,    -3.976832_t_real,    -3.944567_t_real,    -3.890365_t_real &
       &,    -3.808016_t_real,    -3.692148_t_real,    -3.540047_t_real &
       &,    -3.353650_t_real,    -3.140497_t_real,    -2.912523_t_real &
       &,    -2.682642_t_real,    -2.460559_t_real,    -2.250033_t_real &
       &,    -2.049320_t_real,    -1.855217_t_real,    -1.669876_t_real &
       &,    -1.505850_t_real,    -1.375044_t_real,    -1.269827_t_real &
       &,    -1.175084_t_real,    -1.083658_t_real,    -0.994937_t_real &
       &,    -0.910444_t_real,    -0.831481_t_real,    -0.758343_t_real &
       &,    -0.690362_t_real,    -0.626323_t_real,    -0.564947_t_real &
       &,    -0.505281_t_real,    -0.446907_t_real,    -0.389965_t_real &
       &,    -0.335041_t_real,    -0.282978_t_real,    -0.234675_t_real &
       &,    -0.190920_t_real,    -0.152267_t_real,    -0.118989_t_real &
       &,    -0.091068_t_real,    -0.068241_t_real,    -0.050053_t_real &
       &,    -0.035926_t_real,    -0.025231_t_real,    -0.017334_t_real &
       &,    -0.011648_t_real,    -0.007656_t_real,    -0.004920_t_real &
       &,    -0.003092_t_real,    -0.001899_t_real/
  !! 2p
  !!
  Data ncoeffrel(  5) / 50 /
  Data vcoeffrel(1:50,  5) /&
       &     -5.000000_t_real,    -4.998794_t_real,    -4.990322_t_real &
       &,    -4.967139_t_real,    -4.921325_t_real,    -4.844390_t_real &
       &,    -4.727975_t_real,    -4.565863_t_real,    -4.356963_t_real &
       &,    -4.107652_t_real,    -3.831312_t_real,    -3.544123_t_real &
       &,    -3.258894_t_real,    -2.980817_t_real,    -2.708646_t_real &
       &,    -2.442224_t_real,    -2.192151_t_real,    -1.974329_t_real &
       &,    -1.785775_t_real,    -1.611167_t_real,    -1.443712_t_real &
       &,    -1.285040_t_real,    -1.139088_t_real,    -1.008643_t_real &
       &,    -0.894308_t_real,    -0.794798_t_real,    -0.707741_t_real &
       &,    -0.630510_t_real,    -0.560804_t_real,    -0.496944_t_real &
       &,    -0.437891_t_real,    -0.383127_t_real,    -0.332462_t_real &
       &,    -0.285875_t_real,    -0.243386_t_real,    -0.204996_t_real &
       &,    -0.170667_t_real,    -0.140317_t_real,    -0.113823_t_real &
       &,    -0.091017_t_real,    -0.071688_t_real,    -0.055578_t_real &
       &,    -0.042388_t_real,    -0.031788_t_real,    -0.023431_t_real &
       &,    -0.016972_t_real,    -0.012076_t_real,    -0.008439_t_real &
       &,    -0.005791_t_real,    -0.003901_t_real/
  !!
  Data ncoeffrel(  6) / 50 /
  Data vcoeffrel(1:50,  6) /&
       &     -6.000000_t_real,    -5.998382_t_real,    -5.987016_t_real &
       &,    -5.955892_t_real,    -5.894360_t_real,    -5.791146_t_real &
       &,    -5.635728_t_real,    -5.421620_t_real,    -5.150450_t_real &
       &,    -4.833813_t_real,    -4.490079_t_real,    -4.136710_t_real &
       &,    -3.783184_t_real,    -3.430868_t_real,    -3.082455_t_real &
       &,    -2.752743_t_real,    -2.455848_t_real,    -2.183632_t_real &
       &,    -1.924510_t_real,    -1.678819_t_real,    -1.453154_t_real &
       &,    -1.253488_t_real,    -1.082275_t_real,    -0.938337_t_real &
       &,    -0.818044_t_real,    -0.716755_t_real,    -0.629956_t_real &
       &,    -0.553914_t_real,    -0.485893_t_real,    -0.424090_t_real &
       &,    -0.367436_t_real,    -0.315379_t_real,    -0.267700_t_real &
       &,    -0.224364_t_real,    -0.185416_t_real,    -0.150904_t_real &
       &,    -0.120821_t_real,    -0.095076_t_real,    -0.073476_t_real &
       &,    -0.055729_t_real,    -0.041461_t_real,    -0.030243_t_real &
       &,    -0.021622_t_real,    -0.015147_t_real,    -0.010394_t_real &
       &,    -0.006985_t_real,    -0.004596_t_real,    -0.002960_t_real &
       &,    -0.001866_t_real,    -0.001151_t_real/
  !!
  Data ncoeffrel(  7) / 50 /
  Data vcoeffrel(1:50,  7) /&
       &     -7.000000_t_real,    -6.997915_t_real,    -6.983261_t_real &
       &,    -6.943114_t_real,    -6.863735_t_real,    -6.730793_t_real &
       &,    -6.531673_t_real,    -6.260235_t_real,    -5.921687_t_real &
       &,    -5.532915_t_real,    -5.115592_t_real,    -4.685888_t_real &
       &,    -4.249975_t_real,    -3.812208_t_real,    -3.388551_t_real &
       &,    -2.995221_t_real,    -2.626152_t_real,    -2.273415_t_real &
       &,    -1.942398_t_real,    -1.643930_t_real,    -1.385988_t_real &
       &,    -1.170711_t_real,    -0.995006_t_real,    -0.852633_t_real &
       &,    -0.736354_t_real,    -0.639463_t_real,    -0.556559_t_real &
       &,    -0.483734_t_real,    -0.418411_t_real,    -0.359059_t_real &
       &,    -0.304887_t_real,    -0.255587_t_real,    -0.211122_t_real &
       &,    -0.171561_t_real,    -0.136963_t_real,    -0.107298_t_real &
       &,    -0.082408_t_real,    -0.062000_t_real,    -0.045664_t_real &
       &,    -0.032907_t_real,    -0.023192_t_real,    -0.015981_t_real &
       &,    -0.010762_t_real,    -0.007082_t_real,    -0.004552_t_real &
       &,    -0.002858_t_real,    -0.001751_t_real,    -0.001048_t_real &
       &,    -0.000612_t_real,    -0.000348_t_real/
  !!
  Data ncoeffrel(  8) / 50 /
  Data vcoeffrel(1:50,  8) /&
       &     -8.000000_t_real,    -7.997392_t_real,    -7.979059_t_real &
       &,    -7.928816_t_real,    -7.829480_t_real,    -7.663430_t_real &
       &,    -7.416077_t_real,    -7.082231_t_real,    -6.671262_t_real &
       &,    -6.204831_t_real,    -5.706048_t_real,    -5.188758_t_real &
       &,    -4.659702_t_real,    -4.133869_t_real,    -3.632468_t_real &
       &,    -3.156204_t_real,    -2.699595_t_real,    -2.271725_t_real &
       &,    -1.888293_t_real,    -1.560627_t_real,    -1.291595_t_real &
       &,    -1.076618_t_real,    -0.906753_t_real,    -0.771779_t_real &
       &,    -0.662329_t_real,    -0.570916_t_real,    -0.492151_t_real &
       &,    -0.422486_t_real,    -0.359809_t_real,    -0.303018_t_real &
       &,    -0.251665_t_real,    -0.205664_t_real,    -0.165072_t_real &
       &,    -0.129931_t_real,    -0.100167_t_real,    -0.075556_t_real &
       &,    -0.055715_t_real,    -0.040135_t_real,    -0.028228_t_real &
       &,    -0.019375_t_real,    -0.012973_t_real,    -0.008471_t_real &
       &,    -0.005393_t_real,    -0.003346_t_real,    -0.002023_t_real &
       &,    -0.001191_t_real,    -0.000683_t_real,    -0.000381_t_real &
       &,    -0.000207_t_real,    -0.000110_t_real/
  !!
  Data ncoeffrel(  9) / 50 /
  Data vcoeffrel(1:50,  9) /&
       &     -9.000000_t_real,    -8.996814_t_real,    -8.974414_t_real &
       &,    -8.913004_t_real,    -8.791618_t_real,    -8.589134_t_real &
       &,    -8.289151_t_real,    -7.887983_t_real,    -7.399445_t_real &
       &,    -6.849094_t_real,    -6.260003_t_real,    -5.644814_t_real &
       &,    -5.016693_t_real,    -4.400319_t_real,    -3.807850_t_real &
       &,    -3.236645_t_real,    -2.697666_t_real,    -2.212342_t_real &
       &,    -1.797730_t_real,    -1.459576_t_real,    -1.192972_t_real &
       &,    -0.986473_t_real,    -0.826466_t_real,    -0.700267_t_real &
       &,    -0.597655_t_real,    -0.511226_t_real,    -0.436084_t_real &
       &,    -0.369279_t_real,    -0.309231_t_real,    -0.255246_t_real &
       &,    -0.207131_t_real,    -0.164898_t_real,    -0.128565_t_real &
       &,    -0.098029_t_real,    -0.073013_t_real,    -0.053071_t_real &
       &,    -0.037616_t_real,    -0.025982_t_real,    -0.017480_t_real &
       &,    -0.011449_t_real,    -0.007299_t_real,    -0.004527_t_real &
       &,    -0.002731_t_real,    -0.001602_t_real,    -0.000914_t_real &
       &,    -0.000506_t_real,    -0.000273_t_real,    -0.000142_t_real &
       &,    -0.000072_t_real,    -0.000036_t_real/
  !!
  Data ncoeffrel( 10) / 50 /
  Data vcoeffrel(1:50, 10) /&
       &    -10.000000_t_real,    -9.996182_t_real,    -9.969325_t_real &
       &,    -9.895682_t_real,    -9.750165_t_real,    -9.507966_t_real &
       &,    -9.151064_t_real,    -8.677751_t_real,    -8.106309_t_real &
       &,    -7.465163_t_real,    -6.776731_t_real,    -6.055524_t_real &
       &,    -5.324775_t_real,    -4.609645_t_real,    -3.914811_t_real &
       &,    -3.250684_t_real,    -2.644041_t_real,    -2.120544_t_real &
       &,    -1.692275_t_real,    -1.356348_t_real,    -1.099691_t_real &
       &,    -0.905085_t_real,    -0.755766_t_real,    -0.637888_t_real &
       &,    -0.541255_t_real,    -0.459031_t_real,    -0.387025_t_real &
       &,    -0.322920_t_real,    -0.265617_t_real,    -0.214725_t_real &
       &,    -0.170174_t_real,    -0.131954_t_real,    -0.099946_t_real &
       &,    -0.073849_t_real,    -0.053172_t_real,    -0.037273_t_real &
       &,    -0.025419_t_real,    -0.016855_t_real,    -0.010862_t_real &
       &,    -0.006800_t_real,    -0.004134_t_real,    -0.002440_t_real &
       &,    -0.001398_t_real,    -0.000777_t_real,    -0.000419_t_real &
       &,    -0.000219_t_real,    -0.000111_t_real,    -0.000054_t_real &
       &,    -0.000026_t_real,    -0.000012_t_real/
  !!
  Data ncoeffrel( 11) / 50 /
  Data vcoeffrel(1:50, 11) /&
       &    -11.000000_t_real,   -10.995597_t_real,   -10.964609_t_real &
       &,   -10.879600_t_real,   -10.711646_t_real,   -10.432716_t_real &
       &,   -10.024048_t_real,    -9.487052_t_real,    -8.845034_t_real &
       &,    -8.128886_t_real,    -7.360948_t_real,    -6.561307_t_real &
       &,    -5.761935_t_real,    -4.982201_t_real,    -4.230242_t_real &
       &,    -3.532447_t_real,    -2.921447_t_real,    -2.415539_t_real &
       &,    -2.012810_t_real,    -1.696825_t_real,    -1.446189_t_real &
       &,    -1.242734_t_real,    -1.076252_t_real,    -0.944900_t_real &
       &,    -0.849548_t_real,    -0.785014_t_real,    -0.739895_t_real &
       &,    -0.703896_t_real,    -0.671031_t_real,    -0.638448_t_real &
       &,    -0.604821_t_real,    -0.569471_t_real,    -0.532033_t_real &
       &,    -0.492400_t_real,    -0.450739_t_real,    -0.407508_t_real &
       &,    -0.363425_t_real,    -0.319389_t_real,    -0.276384_t_real &
       &,    -0.235364_t_real,    -0.197159_t_real,    -0.162413_t_real &
       &,    -0.131541_t_real,    -0.104733_t_real,    -0.081969_t_real &
       &,    -0.063057_t_real,    -0.047677_t_real,    -0.035430_t_real &
       &,    -0.025875_t_real,    -0.018571_t_real/
  !!3p
  !!
  Data ncoeffrel( 12) / 50 /
  Data vcoeffrel(1:50, 12) /&
       &    -12.000000_t_real,   -11.994982_t_real,   -11.959653_t_real &
       &,   -11.862693_t_real,   -11.671176_t_real,   -11.353870_t_real &
       &,   -10.891692_t_real,   -10.289698_t_real,    -9.576015_t_real &
       &,    -8.783167_t_real,    -7.934445_t_real,    -7.058232_t_real &
       &,    -6.189996_t_real,    -5.344294_t_real,    -4.541340_t_real &
       &,    -3.818609_t_real,    -3.204622_t_real,    -2.703333_t_real &
       &,    -2.298076_t_real,    -1.965390_t_real,    -1.688712_t_real &
       &,    -1.464423_t_real,    -1.293139_t_real,    -1.164540_t_real &
       &,    -1.061307_t_real,    -0.971493_t_real,    -0.889896_t_real &
       &,    -0.814505_t_real,    -0.744104_t_real,    -0.677468_t_real &
       &,    -0.613380_t_real,    -0.550887_t_real,    -0.489524_t_real &
       &,    -0.429379_t_real,    -0.371024_t_real,    -0.315336_t_real &
       &,    -0.263292_t_real,    -0.215780_t_real,    -0.173467_t_real &
       &,    -0.136725_t_real,    -0.105622_t_real,    -0.079950_t_real &
       &,    -0.059286_t_real,    -0.043060_t_real,    -0.030629_t_real &
       &,    -0.021335_t_real,    -0.014550_t_real,    -0.009716_t_real &
       &,    -0.006351_t_real,    -0.004063_t_real/
  !!
  Data ncoeffrel( 13) / 50 /
  Data vcoeffrel(1:50, 13) /&
       &    -13.000000_t_real,   -12.994354_t_real,   -12.954591_t_real &
       &,   -12.845418_t_real,   -12.629840_t_real,   -12.273566_t_real &
       &,   -11.757669_t_real,   -11.091298_t_real,   -10.307062_t_real &
       &,    -9.438666_t_real,    -8.512359_t_real,    -7.565655_t_real &
       &,    -6.632270_t_real,    -5.728510_t_real,    -4.888887_t_real &
       &,    -4.153563_t_real,    -3.538907_t_real,    -3.032537_t_real &
       &,    -2.608868_t_real,    -2.249703_t_real,    -1.953845_t_real &
       &,    -1.721105_t_real,    -1.533859_t_real,    -1.372040_t_real &
       &,    -1.226487_t_real,    -1.095241_t_real,    -0.978146_t_real &
       &,    -0.874554_t_real,    -0.782996_t_real,    -0.701564_t_real &
       &,    -0.628356_t_real,    -0.561751_t_real,    -0.500510_t_real &
       &,    -0.443758_t_real,    -0.390917_t_real,    -0.341652_t_real &
       &,    -0.295818_t_real,    -0.253410_t_real,    -0.214514_t_real &
       &,    -0.179254_t_real,    -0.147735_t_real,    -0.120005_t_real &
       &,    -0.096024_t_real,    -0.075655_t_real,    -0.058672_t_real &
       &,    -0.044779_t_real,    -0.033625_t_real,    -0.024839_t_real &
       &,    -0.018048_t_real,    -0.012897_t_real/
  !!
  Data ncoeffrel( 14) / 50 /
  Data vcoeffrel(1:50, 14) /&
       &    -14.000000_t_real,   -13.993700_t_real,   -13.949308_t_real &
       &,   -13.827377_t_real,   -13.586705_t_real,   -13.190005_t_real &
       &,   -12.618897_t_real,   -11.886880_t_real,   -11.030551_t_real &
       &,   -10.084664_t_real,    -9.080592_t_real,    -8.063256_t_real &
       &,    -7.062651_t_real,    -6.103553_t_real,    -5.231183_t_real &
       &,    -4.479683_t_real,    -3.848823_t_real,    -3.313831_t_real &
       &,    -2.852577_t_real,    -2.463990_t_real,    -2.149276_t_real &
       &,    -1.886797_t_real,    -1.654603_t_real,    -1.445785_t_real &
       &,    -1.260890_t_real,    -1.100715_t_real,    -0.964009_t_real &
       &,    -0.847723_t_real,    -0.747991_t_real,    -0.661014_t_real &
       &,    -0.583590_t_real,    -0.513331_t_real,    -0.448661_t_real &
       &,    -0.388694_t_real,    -0.333078_t_real,    -0.281811_t_real &
       &,    -0.235075_t_real,    -0.193101_t_real,    -0.156056_t_real &
       &,    -0.123988_t_real,    -0.096790_t_real,    -0.074205_t_real &
       &,    -0.055852_t_real,    -0.041259_t_real,    -0.029907_t_real &
       &,    -0.021268_t_real,    -0.014836_t_real,    -0.010150_t_real &
       &,    -0.006809_t_real,    -0.004479_t_real/
  !!
  Data ncoeffrel( 15) / 50 /
  Data vcoeffrel(1:50, 15) /&
       &    -15.000000_t_real,   -14.993019_t_real,   -14.943808_t_real &
       &,   -14.808594_t_real,   -14.541830_t_real,   -14.103323_t_real &
       &,   -13.475611_t_real,   -12.676706_t_real,   -11.746672_t_real &
       &,   -10.721630_t_real,    -9.639933_t_real,    -8.550694_t_real &
       &,    -7.482028_t_real,    -6.470770_t_real,    -5.566216_t_real &
       &,    -4.789588_t_real,    -4.124478_t_real,    -3.543928_t_real &
       &,    -3.042619_t_real,    -2.626391_t_real,    -2.273977_t_real &
       &,    -1.960090_t_real,    -1.678720_t_real,    -1.432843_t_real &
       &,    -1.224314_t_real,    -1.051077_t_real,    -0.908064_t_real &
       &,    -0.788989_t_real,    -0.687826_t_real,    -0.599641_t_real &
       &,    -0.520875_t_real,    -0.449268_t_real,    -0.383614_t_real &
       &,    -0.323452_t_real,    -0.268765_t_real,    -0.219732_t_real &
       &,    -0.176535_t_real,    -0.139241_t_real,    -0.107737_t_real &
       &,    -0.081727_t_real,    -0.060751_t_real,    -0.044235_t_real &
       &,    -0.031540_t_real,    -0.022016_t_real,    -0.015042_t_real &
       &,    -0.010057_t_real,    -0.006580_t_real,    -0.004211_t_real &
       &,    -0.002636_t_real,    -0.001613_t_real/
  !!
  Data ncoeffrel( 16) / 50 /
  Data vcoeffrel(1:50, 16) /&
       &    -16.000000_t_real,   -15.992312_t_real,   -15.938092_t_real &
       &,   -15.789070_t_real,   -15.495229_t_real,   -15.013561_t_real &
       &,   -14.327883_t_real,   -13.460777_t_real,   -12.455298_t_real &
       &,   -11.349662_t_real,   -10.190240_t_real,    -9.027123_t_real &
       &,    -7.890615_t_real,    -6.829310_t_real,    -5.889135_t_real &
       &,    -5.074622_t_real,    -4.359120_t_real,    -3.727355_t_real &
       &,    -3.189143_t_real,    -2.730923_t_real,    -2.322553_t_real &
       &,    -1.956375_t_real,    -1.638075_t_real,    -1.371573_t_real &
       &,    -1.154555_t_real,    -0.979878_t_real,    -0.838428_t_real &
       &,    -0.721456_t_real,    -0.621850_t_real,    -0.534535_t_real &
       &,    -0.456312_t_real,    -0.385453_t_real,    -0.321238_t_real &
       &,    -0.263524_t_real,    -0.212409_t_real,    -0.167988_t_real &
       &,    -0.130217_t_real,    -0.098849_t_real,    -0.073432_t_real &
       &,    -0.053355_t_real,    -0.037901_t_real,    -0.026313_t_real &
       &,    -0.017848_t_real,    -0.011825_t_real,    -0.007652_t_real &
       &,    -0.004834_t_real,    -0.002982_t_real,    -0.001795_t_real &
       &,    -0.001054_t_real,    -0.000604_t_real/
  !!
  Data ncoeffrel( 17) / 50 /
  Data vcoeffrel(1:50, 17) /&
       &    -17.000000_t_real,   -16.991579_t_real,   -16.932163_t_real &
       &,   -16.768809_t_real,   -16.446911_t_real,   -15.920759_t_real &
       &,   -15.175769_t_real,   -14.239076_t_real,   -13.156338_t_real &
       &,   -11.968907_t_real,   -10.731140_t_real,    -9.492119_t_real &
       &,    -8.288574_t_real,    -7.177445_t_real,    -6.194649_t_real &
       &,    -5.328328_t_real,    -4.552567_t_real,    -3.872044_t_real &
       &,    -3.289177_t_real,    -2.771836_t_real,    -2.306033_t_real &
       &,    -1.899781_t_real,    -1.560917_t_real,    -1.288380_t_real &
       &,    -1.073444_t_real,    -0.903885_t_real,    -0.767584_t_real &
       &,    -0.654564_t_real,    -0.557652_t_real,    -0.472280_t_real &
       &,    -0.395906_t_real,    -0.327362_t_real,    -0.266273_t_real &
       &,    -0.212609_t_real,    -0.166377_t_real,    -0.127445_t_real &
       &,    -0.095464_t_real,    -0.069870_t_real,    -0.049936_t_real &
       &,    -0.034831_t_real,    -0.023703_t_real,    -0.015731_t_real &
       &,    -0.010179_t_real,    -0.006421_t_real,    -0.003947_t_real &
       &,    -0.002364_t_real,    -0.001380_t_real,    -0.000784_t_real &
       &,    -0.000434_t_real,    -0.000234_t_real/
  !!
  Data ncoeffrel( 18) / 50 /
  Data vcoeffrel(1:50, 18) /&
       &    -18.000000_t_real,   -17.990820_t_real,   -17.926018_t_real &
       &,   -17.747809_t_real,   -17.396884_t_real,   -16.824942_t_real &
       &,   -16.019302_t_real,   -15.011561_t_real,   -13.849724_t_real &
       &,   -12.579468_t_real,   -11.262134_t_real,    -9.945534_t_real &
       &,    -8.675722_t_real,    -7.512706_t_real,    -6.477719_t_real &
       &,    -5.547372_t_real,    -4.709216_t_real,    -3.979218_t_real &
       &,    -3.336355_t_real,    -2.754978_t_real,    -2.242192_t_real &
       &,    -1.811863_t_real,    -1.466983_t_real,    -1.198737_t_real &
       &,    -0.991914_t_real,    -0.830359_t_real,    -0.700321_t_real &
       &,    -0.591692_t_real,    -0.497899_t_real,    -0.415156_t_real &
       &,    -0.341587_t_real,    -0.276441_t_real,    -0.219502_t_real &
       &,    -0.170681_t_real,    -0.129779_t_real,    -0.096382_t_real &
       &,    -0.069847_t_real,    -0.049355_t_real,    -0.033986_t_real &
       &,    -0.022795_t_real,    -0.014886_t_real,    -0.009463_t_real &
       &,    -0.005854_t_real,    -0.003523_t_real,    -0.002063_t_real &
       &,    -0.001174_t_real,    -0.000650_t_real,    -0.000350_t_real &
       &,    -0.000183_t_real,    -0.000093_t_real/
  !!
  Data ncoeffrel( 19) / 50 /
  Data vcoeffrel(1:50, 19) /&
       &    -19.000000_t_real,   -18.990090_t_real,   -18.920103_t_real &
       &,   -18.727572_t_real,   -18.348711_t_real,   -17.733101_t_real &
       &,   -16.870604_t_real,   -15.797499_t_real,   -14.564293_t_real &
       &,   -13.222305_t_real,   -11.838522_t_real,   -10.460940_t_real &
       &,    -9.145958_t_real,    -7.951116_t_real,    -6.881498_t_real &
       &,    -5.911513_t_real,    -5.048768_t_real,    -4.298370_t_real &
       &,    -3.625257_t_real,    -3.023495_t_real,    -2.508424_t_real &
       &,    -2.086236_t_real,    -1.747998_t_real,    -1.476955_t_real &
       &,    -1.257463_t_real,    -1.080412_t_real,    -0.943335_t_real &
       &,    -0.844724_t_real,    -0.777401_t_real,    -0.729639_t_real &
       &,    -0.691177_t_real,    -0.655709_t_real,    -0.619983_t_real &
       &,    -0.582458_t_real,    -0.542499_t_real,    -0.500028_t_real &
       &,    -0.455384_t_real,    -0.409242_t_real,    -0.362526_t_real &
       &,    -0.316297_t_real,    -0.271636_t_real,    -0.229527_t_real &
       &,    -0.190773_t_real,    -0.155944_t_real,    -0.125357_t_real &
       &,    -0.099093_t_real,    -0.077027_t_real,    -0.058879_t_real &
       &,    -0.044258_t_real,    -0.032713_t_real/
  !!
  Data ncoeffrel( 20) / 50 /
  Data vcoeffrel(1:50, 20) /&
       &    -20.000000_t_real,   -19.989344_t_real,   -19.914043_t_real &
       &,   -19.706833_t_real,   -19.299398_t_real,   -18.639399_t_real &
       &,   -17.719550_t_real,   -16.580685_t_real,   -15.275830_t_real &
       &,   -13.862856_t_real,   -12.412633_t_real,   -10.975405_t_real &
       &,    -9.616791_t_real,    -8.386470_t_real,    -7.274877_t_real &
       &,    -6.265080_t_real,    -5.377895_t_real,    -4.594338_t_real &
       &,    -3.886155_t_real,    -3.263621_t_real,    -2.738611_t_real &
       &,    -2.305829_t_real,    -1.949714_t_real,    -1.657460_t_real &
       &,    -1.425012_t_real,    -1.249948_t_real,    -1.120642_t_real &
       &,    -1.019883_t_real,    -0.934659_t_real,    -0.858001_t_real &
       &,    -0.786440_t_real,    -0.717977_t_real,    -0.651268_t_real &
       &,    -0.585498_t_real,    -0.520419_t_real,    -0.456356_t_real &
       &,    -0.394096_t_real,    -0.334695_t_real,    -0.279259_t_real &
       &,    -0.228754_t_real,    -0.183877_t_real,    -0.144991_t_real &
       &,    -0.112129_t_real,    -0.085034_t_real,    -0.063230_t_real &
       &,    -0.046098_t_real,    -0.032950_t_real,    -0.023089_t_real &
       &,    -0.015860_t_real,    -0.010680_t_real/
  !! 3d
  !!
  Data ncoeffrel( 21) / 50 /
  Data vcoeffrel(1:50, 21) /&
       &    -21.000000_t_real,   -20.988552_t_real,   -20.907619_t_real &
       &,   -20.684854_t_real,   -20.247202_t_real,   -19.540407_t_real &
       &,   -18.560079_t_real,   -17.351163_t_real,   -15.969038_t_real &
       &,   -14.478248_t_real,   -12.951479_t_real,   -11.442975_t_real &
       &,   -10.024659_t_real,    -8.735061_t_real,    -7.556190_t_real &
       &,    -6.487430_t_real,    -5.545555_t_real,    -4.697177_t_real &
       &,    -3.935052_t_real,    -3.278750_t_real,    -2.734395_t_real &
       &,    -2.289659_t_real,    -1.927345_t_real,    -1.636591_t_real &
       &,    -1.411495_t_real,    -1.241413_t_real,    -1.109725_t_real &
       &,    -1.001794_t_real,    -0.908605_t_real,    -0.825130_t_real &
       &,    -0.748230_t_real,    -0.675662_t_real,    -0.605850_t_real &
       &,    -0.537925_t_real,    -0.471730_t_real,    -0.407712_t_real &
       &,    -0.346716_t_real,    -0.289744_t_real,    -0.237734_t_real &
       &,    -0.191396_t_real,    -0.151134_t_real,    -0.117017_t_real &
       &,    -0.088820_t_real,    -0.066083_t_real,    -0.048188_t_real &
       &,    -0.034439_t_real,    -0.024122_t_real,    -0.016557_t_real &
       &,    -0.011138_t_real,    -0.007343_t_real/
  !!
  Data ncoeffrel( 22) / 50 /
  Data vcoeffrel(1:50, 22) /&
       &    -22.000000_t_real,   -21.987734_t_real,   -21.900972_t_real &
       &,   -21.662111_t_real,   -21.193255_t_real,   -20.438360_t_real &
       &,   -19.396078_t_real,   -18.115159_t_real,   -16.653481_t_real &
       &,   -15.082299_t_real,   -13.474883_t_real,   -11.891300_t_real &
       &,   -10.406576_t_real,    -9.046801_t_real,    -7.793250_t_real &
       &,    -6.661560_t_real,    -5.652507_t_real,    -4.736403_t_real &
       &,    -3.926864_t_real,    -3.244777_t_real,    -2.688103_t_real &
       &,    -2.238526_t_real,    -1.877556_t_real,    -1.593479_t_real &
       &,    -1.375716_t_real,    -1.208781_t_real,    -1.076185_t_real &
       &,    -0.965909_t_real,    -0.870629_t_real,    -0.785729_t_real &
       &,    -0.707926_t_real,    -0.634803_t_real,    -0.564765_t_real &
       &,    -0.497053_t_real,    -0.431663_t_real,    -0.369156_t_real &
       &,    -0.310400_t_real,    -0.256322_t_real,    -0.207706_t_real &
       &,    -0.165068_t_real,    -0.128602_t_real,    -0.098191_t_real &
       &,    -0.073459_t_real,    -0.053838_t_real,    -0.038650_t_real &
       &,    -0.027175_t_real,    -0.018713_t_real,    -0.012618_t_real &
       &,    -0.008331_t_real,    -0.005386_t_real/
  !!
  Data ncoeffrel( 23) / 50 /
  Data vcoeffrel(1:50, 23) /&
       &    -23.000000_t_real,   -22.986891_t_real,   -22.894117_t_real &
       &,   -22.638653_t_real,   -22.137680_t_real,   -21.333504_t_real &
       &,   -20.227945_t_real,   -18.873259_t_real,   -17.330082_t_real &
       &,   -15.676100_t_real,   -13.984576_t_real,   -12.322681_t_real &
       &,   -10.765239_t_real,    -9.326727_t_real,    -7.995338_t_real &
       &,    -6.795590_t_real,    -5.712108_t_real,    -4.732732_t_real &
       &,    -3.885291_t_real,    -3.185960_t_real,    -2.623615_t_real &
       &,    -2.174865_t_real,    -1.819683_t_real,    -1.543963_t_real &
       &,    -1.332937_t_real,    -1.169204_t_real,    -1.037553_t_real &
       &,    -0.927624_t_real,    -0.832796_t_real,    -0.748490_t_real &
       &,    -0.671311_t_real,    -0.598818_t_real,    -0.529517_t_real &
       &,    -0.462814_t_real,    -0.398851_t_real,    -0.338266_t_real &
       &,    -0.281919_t_real,    -0.230651_t_real,    -0.185107_t_real &
       &,    -0.145645_t_real,    -0.112305_t_real,    -0.084841_t_real &
       &,    -0.062780_t_real,    -0.045495_t_real,    -0.032283_t_real &
       &,    -0.022429_t_real,    -0.015255_t_real,    -0.010157_t_real &
       &,    -0.006619_t_real,    -0.004221_t_real/
  !!
  Data ncoeffrel( 24) / 50 /
  Data vcoeffrel(1:50, 24) /&
       &    -24.000000_t_real,   -23.986001_t_real,   -23.886876_t_real &
       &,   -23.613880_t_real,   -23.079055_t_real,   -22.223038_t_real &
       &,   -21.050715_t_real,   -19.617340_t_real,   -17.986394_t_real &
       &,   -16.241062_t_real,   -14.454276_t_real,   -12.700549_t_real &
       &,   -11.051696_t_real,    -9.514000_t_real,    -8.087735_t_real &
       &,    -6.795962_t_real,    -5.618415_t_real,    -4.566952_t_real &
       &,    -3.678235_t_real,    -2.963244_t_real,    -2.403628_t_real &
       &,    -1.969897_t_real,    -1.635480_t_real,    -1.379793_t_real &
       &,    -1.185344_t_real,    -1.036130_t_real,    -0.918717_t_real &
       &,    -0.823105_t_real,    -0.742264_t_real,    -0.671249_t_real &
       &,    -0.606560_t_real,    -0.545814_t_real,    -0.487574_t_real &
       &,    -0.431209_t_real,    -0.376723_t_real,    -0.324555_t_real &
       &,    -0.275370_t_real,    -0.229878_t_real,    -0.188686_t_real &
       &,    -0.152212_t_real,    -0.120642_t_real,    -0.093933_t_real &
       &,    -0.071840_t_real,    -0.053969_t_real,    -0.039828_t_real &
       &,    -0.028876_t_real,    -0.020572_t_real,    -0.014403_t_real &
       &,    -0.009913_t_real,    -0.006708_t_real/
  !!
  Data ncoeffrel( 25) / 50 /
  Data vcoeffrel(1:50, 25) /&
       &    -25.000000_t_real,   -24.985132_t_real,   -24.879799_t_real &
       &,   -24.589652_t_real,   -24.021808_t_real,   -23.115705_t_real &
       &,   -21.879757_t_real,   -20.372365_t_real,   -18.660739_t_real &
       &,   -16.833504_t_real,   -14.964488_t_real,   -13.136080_t_real &
       &,   -11.414518_t_real,    -9.800780_t_real,    -8.309284_t_real &
       &,    -6.954940_t_real,    -5.722135_t_real,    -4.641665_t_real &
       &,    -3.746669_t_real,    -3.033933_t_real,    -2.475026_t_real &
       &,    -2.038757_t_real,    -1.701276_t_real,    -1.443004_t_real &
       &,    -1.244547_t_real,    -1.088514_t_real,    -0.962027_t_real &
       &,    -0.856308_t_real,    -0.765162_t_real,    -0.683989_t_real &
       &,    -0.609418_t_real,    -0.539223_t_real,    -0.472245_t_real &
       &,    -0.408219_t_real,    -0.347515_t_real,    -0.290851_t_real &
       &,    -0.239022_t_real,    -0.192697_t_real,    -0.152298_t_real &
       &,    -0.117944_t_real,    -0.089466_t_real,    -0.066451_t_real &
       &,    -0.048319_t_real,    -0.034389_t_real,    -0.023951_t_real &
       &,    -0.016323_t_real,    -0.010884_t_real,    -0.007100_t_real &
       &,    -0.004530_t_real,    -0.002827_t_real/
  !!
  Data ncoeffrel( 26) / 50 /
  Data vcoeffrel(1:50, 26) /&
       &    -26.000000_t_real,   -25.984217_t_real,   -25.872339_t_real &
       &,   -25.564121_t_real,   -24.961549_t_real,   -24.002845_t_real &
       &,   -22.699784_t_real,   -21.113449_t_real,   -19.314904_t_real &
       &,   -17.396952_t_real,   -15.434871_t_real,   -13.517852_t_real &
       &,   -11.705375_t_real,    -9.998702_t_real,    -8.423841_t_real &
       &,    -6.986040_t_real,    -5.686071_t_real,    -4.569340_t_real &
       &,    -3.662643_t_real,    -2.951116_t_real,    -2.398981_t_real &
       &,    -1.972077_t_real,    -1.644563_t_real,    -1.394717_t_real &
       &,    -1.202314_t_real,    -1.050588_t_real,    -0.927453_t_real &
       &,    -0.824498_t_real,    -0.735612_t_real,    -0.656236_t_real &
       &,    -0.583106_t_real,    -0.514165_t_real,    -0.448437_t_real &
       &,    -0.385799_t_real,    -0.326706_t_real,    -0.271887_t_real &
       &,    -0.222095_t_real,    -0.177923_t_real,    -0.139696_t_real &
       &,    -0.107446_t_real,    -0.080924_t_real,    -0.059665_t_real &
       &,    -0.043054_t_real,    -0.030400_t_real,    -0.021000_t_real &
       &,    -0.014191_t_real,    -0.009380_t_real,    -0.006063_t_real &
       &,    -0.003833_t_real,    -0.002368_t_real/
  !!
  Data ncoeffrel( 27) / 50 /
  Data vcoeffrel(1:50, 27) /&
       &    -27.000000_t_real,   -26.983277_t_real,   -26.864679_t_real &
       &,   -26.537904_t_real,   -25.899748_t_real,   -24.887362_t_real &
       &,   -23.515885_t_real,   -21.848853_t_real,   -19.961536_t_real &
       &,   -17.949986_t_real,   -15.892045_t_real,   -13.882525_t_real &
       &,   -11.973875_t_real,   -10.172352_t_real,    -8.510796_t_real &
       &,    -6.989248_t_real,    -5.629980_t_real,    -4.486048_t_real &
       &,    -3.574058_t_real,    -2.867506_t_real,    -2.324322_t_real &
       &,    -1.907843_t_real,    -1.590386_t_real,    -1.348660_t_real &
       &,    -1.162197_t_real,    -1.014907_t_real,    -0.895300_t_real &
       &,    -0.795205_t_real,    -0.708589_t_real,    -0.630978_t_real &
       &,    -0.559255_t_real,    -0.491547_t_real,    -0.427050_t_real &
       &,    -0.365773_t_real,    -0.308232_t_real,    -0.255160_t_real &
       &,    -0.207266_t_real,    -0.165067_t_real,    -0.128807_t_real &
       &,    -0.098437_t_real,    -0.073646_t_real,    -0.053924_t_real &
       &,    -0.038632_t_real,    -0.027075_t_real,    -0.018560_t_real &
       &,    -0.012442_t_real,    -0.008156_t_real,    -0.005227_t_real &
       &,    -0.003275_t_real,    -0.002005_t_real/
  !!
  Data ncoeffrel( 28) / 50 /
  Data vcoeffrel(1:50, 28) /&
       &    -28.000000_t_real,   -27.982314_t_real,   -27.856818_t_real &
       &,   -27.511000_t_real,   -26.836411_t_real,   -25.769269_t_real &
       &,   -24.328053_t_real,   -22.578562_t_real,   -20.600554_t_real &
       &,   -18.492479_t_real,   -16.335905_t_real,   -14.229843_t_real &
       &,   -12.220483_t_real,   -10.322685_t_real,    -8.571123_t_real &
       &,    -6.968377_t_real,    -5.558493_t_real,    -4.395544_t_real &
       &,    -3.483481_t_real,    -2.784753_t_real,    -2.252019_t_real &
       &,    -1.846514_t_real,    -1.538960_t_real,    -1.305028_t_real &
       &,    -1.124371_t_real,    -0.981537_t_real,    -0.865480_t_real &
       &,    -0.768213_t_real,    -0.683793_t_real,    -0.607864_t_real &
       &,    -0.537480_t_real,    -0.470957_t_real,    -0.407655_t_real &
       &,    -0.347694_t_real,    -0.291641_t_real,    -0.240223_t_real &
       &,    -0.194101_t_real,    -0.153723_t_real,    -0.119257_t_real &
       &,    -0.090585_t_real,    -0.067343_t_real,    -0.048985_t_real &
       &,    -0.034855_t_real,    -0.024255_t_real,    -0.016505_t_real &
       &,    -0.010981_t_real,    -0.007142_t_real,    -0.004540_t_real &
       &,    -0.002821_t_real,    -0.001712_t_real/
  !!
  Data ncoeffrel( 29) / 50 /
  Data vcoeffrel(1:50, 29) /&
       &    -29.000000_t_real,   -28.981297_t_real,   -28.848511_t_real &
       &,   -28.482580_t_real,   -27.769568_t_real,   -26.644673_t_real &
       &,   -25.129407_t_real,   -23.291413_t_real,   -21.214794_t_real &
       &,   -18.999265_t_real,   -16.730838_t_real,   -14.511131_t_real &
       &,   -12.382201_t_real,   -10.369284_t_real,    -8.505643_t_real &
       &,    -6.805756_t_real,    -5.334014_t_real,    -4.143380_t_real &
       &,    -3.227882_t_real,    -2.541667_t_real,    -2.031068_t_real &
       &,    -1.651183_t_real,    -1.367939_t_real,    -1.155354_t_real &
       &,    -0.993578_t_real,    -0.867827_t_real,    -0.767301_t_real &
       &,    -0.684114_t_real,    -0.612511_t_real,    -0.548396_t_real &
       &,    -0.489041_t_real,    -0.432851_t_real,    -0.379132_t_real &
       &,    -0.327847_t_real,    -0.279368_t_real,    -0.234260_t_real &
       &,    -0.193097_t_real,    -0.156336_t_real,    -0.124246_t_real &
       &,    -0.096881_t_real,    -0.074090_t_real,    -0.055554_t_real &
       &,    -0.040830_t_real,    -0.029409_t_real,    -0.020755_t_real &
       &,    -0.014349_t_real,    -0.009718_t_real,    -0.006445_t_real &
       &,    -0.004186_t_real,    -0.002661_t_real/
  !!
  Data ncoeffrel( 30) / 50 /
  Data vcoeffrel(1:50, 30) /&
       &    -30.000000_t_real,   -29.980317_t_real,   -29.840494_t_real &
       &,   -29.455131_t_real,   -28.705144_t_real,   -27.525284_t_real &
       &,   -25.940540_t_real,   -24.020815_t_real,   -21.855356_t_real &
       &,   -19.545421_t_real,   -17.183194_t_real,   -14.871745_t_real &
       &,   -12.650496_t_real,   -10.555608_t_real,    -8.618274_t_real &
       &,    -6.869046_t_real,    -5.384066_t_real,    -4.203533_t_real &
       &,    -3.302924_t_real,    -2.625574_t_real,    -2.116274_t_real &
       &,    -1.733058_t_real,    -1.444380_t_real,    -1.225071_t_real &
       &,    -1.055531_t_real,    -0.921364_t_real,    -0.812149_t_real &
       &,    -0.720191_t_real,    -0.639789_t_real,    -0.566902_t_real &
       &,    -0.498958_t_real,    -0.434639_t_real,    -0.373595_t_real &
       &,    -0.316125_t_real,    -0.262861_t_real,    -0.214498_t_real &
       &,    -0.171601_t_real,    -0.134489_t_real,    -0.103198_t_real &
       &,    -0.077495_t_real,    -0.056928_t_real,    -0.040899_t_real &
       &,    -0.028728_t_real,    -0.019726_t_real,    -0.013238_t_real &
       &,    -0.008682_t_real,    -0.005563_t_real,    -0.003482_t_real &
       &,    -0.002129_t_real,    -0.001271_t_real/
  !!
  Data ncoeffrel( 31) / 50 /
  Data vcoeffrel(1:50, 31) /&
       &    -31.000000_t_real,   -30.979340_t_real,   -30.832486_t_real &
       &,   -30.427705_t_real,   -29.640876_t_real,   -28.406582_t_real &
       &,   -26.753349_t_real,   -24.753484_t_real,   -22.501640_t_real &
       &,   -20.100484_t_real,   -17.649280_t_real,   -15.251265_t_real &
       &,   -12.945947_t_real,   -10.779372_t_real,    -8.782133_t_real &
       &,    -7.004127_t_real,    -5.525687_t_real,    -4.368879_t_real &
       &,    -3.490042_t_real,    -2.823729_t_real,    -2.315375_t_real &
       &,    -1.926514_t_real,    -1.627212_t_real,    -1.392843_t_real &
       &,    -1.205303_t_real,    -1.052477_t_real,    -0.926123_t_real &
       &,    -0.820209_t_real,    -0.730086_t_real,    -0.652141_t_real &
       &,    -0.583585_t_real,    -0.522274_t_real,    -0.466567_t_real &
       &,    -0.415228_t_real,    -0.367392_t_real,    -0.322530_t_real &
       &,    -0.280421_t_real,    -0.241078_t_real,    -0.204665_t_real &
       &,    -0.171404_t_real,    -0.141498_t_real,    -0.115076_t_real &
       &,    -0.092159_t_real,    -0.072657_t_real,    -0.056377_t_real &
       &,    -0.043047_t_real,    -0.032339_t_real,    -0.023901_t_real &
       &,    -0.017376_t_real,    -0.012424_t_real/
  !!
  Data ncoeffrel( 32) / 50 /
  Data vcoeffrel(1:50, 32) /&
       &    -32.000000_t_real,   -31.978347_t_real,   -31.824346_t_real &
       &,   -31.399827_t_real,   -30.575653_t_real,   -29.286417_t_real &
       &,   -27.564154_t_real,   -25.483679_t_real,   -23.145117_t_real &
       &,   -20.652585_t_real,   -18.112937_t_real,   -15.628387_t_real &
       &,   -13.241056_t_real,   -11.004771_t_real,    -8.952628_t_real &
       &,    -7.153507_t_real,    -5.683604_t_real,    -4.542716_t_real &
       &,    -3.669963_t_real,    -2.996882_t_real,    -2.474766_t_real &
       &,    -2.069060_t_real,    -1.749402_t_real,    -1.491933_t_real &
       &,    -1.281469_t_real,    -1.108450_t_real,    -0.965698_t_real &
       &,    -0.846990_t_real,    -0.746813_t_real,    -0.660482_t_real &
       &,    -0.584267_t_real,    -0.515409_t_real,    -0.452062_t_real &
       &,    -0.393161_t_real,    -0.338258_t_real,    -0.287332_t_real &
       &,    -0.240602_t_real,    -0.198368_t_real,    -0.160877_t_real &
       &,    -0.128252_t_real,    -0.100449_t_real,    -0.077262_t_real &
       &,    -0.058343_t_real,    -0.043242_t_real,    -0.031451_t_real &
       &,    -0.022443_t_real,    -0.015712_t_real,    -0.010789_t_real &
       &,    -0.007265_t_real,    -0.004798_t_real/
  !!
  Data ncoeffrel( 33) / 50 /
  Data vcoeffrel(1:50, 33) /&
       &    -33.000000_t_real,   -32.977341_t_real,   -32.816083_t_real &
       &,   -32.371523_t_real,   -31.509533_t_real,   -30.164902_t_real &
       &,   -28.373132_t_real,   -26.211687_t_real,   -23.786126_t_real &
       &,   -21.202262_t_real,   -18.574715_t_real,   -16.003844_t_real &
       &,   -13.536735_t_real,   -11.232633_t_real,    -9.131152_t_real &
       &,    -7.317060_t_real,    -5.854710_t_real,    -4.719853_t_real &
       &,    -3.839051_t_real,    -3.147724_t_real,    -2.604781_t_real &
       &,    -2.175424_t_real,    -1.828353_t_real,    -1.543581_t_real &
       &,    -1.309991_t_real,    -1.119485_t_real,    -0.964265_t_real &
       &,    -0.836625_t_real,    -0.729564_t_real,    -0.637328_t_real &
       &,    -0.555640_t_real,    -0.481660_t_real,    -0.413764_t_real &
       &,    -0.351247_t_real,    -0.293995_t_real,    -0.242203_t_real &
       &,    -0.196132_t_real,    -0.155960_t_real,    -0.121686_t_real &
       &,    -0.093106_t_real,    -0.069827_t_real,    -0.051313_t_real &
       &,    -0.036937_t_real,    -0.026040_t_real,    -0.017975_t_real &
       &,    -0.012148_t_real,    -0.008036_t_real,    -0.005203_t_real &
       &,    -0.003297_t_real,    -0.002044_t_real/
  !!
  Data ncoeffrel( 34) / 50 /
  Data vcoeffrel(1:50, 34) /&
       &    -34.000000_t_real,   -33.976320_t_real,   -33.807686_t_real &
       &,   -33.342762_t_real,   -32.442455_t_real,   -31.041915_t_real &
       &,   -29.180060_t_real,   -26.937177_t_real,   -24.424118_t_real &
       &,   -21.748815_t_real,   -19.033489_t_real,   -16.376216_t_real &
       &,   -13.830982_t_real,   -11.460406_t_real,    -9.314560_t_real &
       &,    -7.488872_t_real,    -6.029323_t_real,    -4.888469_t_real &
       &,    -3.987383_t_real,    -3.270966_t_real,    -2.701927_t_real &
       &,    -2.242064_t_real,    -1.863546_t_real,    -1.552612_t_real &
       &,    -1.300676_t_real,    -1.098726_t_real,    -0.936687_t_real &
       &,    -0.804673_t_real,    -0.694210_t_real,    -0.598851_t_real &
       &,    -0.514234_t_real,    -0.437779_t_real,    -0.368237_t_real &
       &,    -0.305219_t_real,    -0.248778_t_real,    -0.199092_t_real &
       &,    -0.156253_t_real,    -0.120158_t_real,    -0.090474_t_real &
       &,    -0.066667_t_real,    -0.048054_t_real,    -0.033871_t_real &
       &,    -0.023341_t_real,    -0.015721_t_real,    -0.010348_t_real &
       &,    -0.006655_t_real,    -0.004182_t_real,    -0.002566_t_real &
       &,    -0.001538_t_real,    -0.000900_t_real/
  !!
  !!
  Data ncoeffrel( 35) / 50 /
  Data vcoeffrel(1:50, 35) /&
       &    -35.000000_t_real,   -34.975283_t_real,   -34.799153_t_real &
       &,   -34.313539_t_real,   -33.374405_t_real,   -31.917430_t_real &
       &,   -29.984879_t_real,   -27.660071_t_real,   -25.058929_t_real &
       &,   -22.292064_t_real,   -19.488845_t_real,   -16.745089_t_real &
       &,   -14.122997_t_real,   -11.687299_t_real,    -9.501564_t_real &
       &,    -7.665305_t_real,    -6.201316_t_real,    -5.042535_t_real &
       &,    -4.112730_t_real,    -3.367251_t_real,    -2.766090_t_real &
       &,    -2.270840_t_real,    -1.861846_t_real,    -1.530251_t_real &
       &,    -1.266916_t_real,    -1.059799_t_real,    -0.895739_t_real &
       &,    -0.762736_t_real,    -0.651308_t_real,    -0.554832_t_real &
       &,    -0.469226_t_real,    -0.392335_t_real,    -0.323269_t_real &
       &,    -0.261830_t_real,    -0.208069_t_real,    -0.162003_t_real &
       &,    -0.123453_t_real,    -0.091999_t_real,    -0.067003_t_real &
       &,    -0.047665_t_real,    -0.033109_t_real,    -0.022448_t_real &
       &,    -0.014853_t_real,    -0.009589_t_real,    -0.006038_t_real &
       &,    -0.003709_t_real,    -0.002221_t_real,    -0.001297_t_real &
       &,    -0.000738_t_real,    -0.000410_t_real/
  !!
  Data ncoeffrel( 36) / 50 /
  Data vcoeffrel(1:50, 36) /&
       &    -36.000000_t_real,   -35.974232_t_real,   -35.790483_t_real &
       &,   -35.283845_t_real,   -34.305372_t_real,   -32.791424_t_real &
       &,   -30.787545_t_real,   -28.380305_t_real,   -25.690430_t_real &
       &,   -22.831867_t_real,   -19.940440_t_real,   -17.110169_t_real &
       &,   -14.412084_t_real,   -11.912777_t_real,    -9.690880_t_real &
       &,    -7.842823_t_real,    -6.365508_t_real,    -5.178365_t_real &
       &,    -4.214986_t_real,    -3.436345_t_real,    -2.797142_t_real &
       &,    -2.265860_t_real,    -1.831607_t_real,    -1.486789_t_real &
       &,    -1.218873_t_real,    -1.011639_t_real,    -0.848861_t_real &
       &,    -0.716970_t_real,    -0.606084_t_real,    -0.509842_t_real &
       &,    -0.424649_t_real,    -0.348795_t_real,    -0.281656_t_real &
       &,    -0.223088_t_real,    -0.173020_t_real,    -0.131225_t_real &
       &,    -0.097231_t_real,    -0.070327_t_real,    -0.049624_t_real &
       &,    -0.034144_t_real,    -0.022900_t_real,    -0.014966_t_real &
       &,    -0.009529_t_real,    -0.005910_t_real,    -0.003570_t_real &
       &,    -0.002099_t_real,    -0.001202_t_real,    -0.000670_t_real &
       &,    -0.000363_t_real,    -0.000191_t_real/
  !!5s
  Data ncoeffrel( 37) / 50 /
  Data vcoeffrel(1:50, 37) /&
       &    -37.000000_t_real,   -36.973207_t_real,   -36.782014_t_real &
       &,   -36.254826_t_real,   -35.238078_t_real,   -33.669229_t_real &
       &,   -31.597289_t_real,   -29.112514_t_real,   -26.340345_t_real &
       &,   -23.398981_t_real,   -20.430124_t_real,   -17.527174_t_real &
       &,   -14.770152_t_real,   -12.228436_t_real,    -9.995644_t_real &
       &,    -8.158239_t_real,    -6.687347_t_real,    -5.497029_t_real &
       &,    -4.532691_t_real,    -3.751063_t_real,    -3.103455_t_real &
       &,    -2.565938_t_real,    -2.128418_t_real,    -1.777778_t_real &
       &,    -1.496949_t_real,    -1.270550_t_real,    -1.089134_t_real &
       &,    -0.948950_t_real,    -0.846972_t_real,    -0.775686_t_real &
       &,    -0.724036_t_real,    -0.682184_t_real,    -0.643747_t_real &
       &,    -0.605258_t_real,    -0.565050_t_real,    -0.522511_t_real &
       &,    -0.477695_t_real,    -0.431122_t_real,    -0.383644_t_real &
       &,    -0.336309_t_real,    -0.290228_t_real,    -0.246450_t_real &
       &,    -0.205864_t_real,    -0.169127_t_real,    -0.136644_t_real &
       &,    -0.108567_t_real,    -0.084827_t_real,    -0.065179_t_real &
       &,    -0.049251_t_real,    -0.036599_t_real/
  !!
  Data ncoeffrel( 38) / 50 /
  Data vcoeffrel(1:50, 38) /&
       &    -38.000000_t_real,   -37.972169_t_real,   -37.773432_t_real &
       &,   -37.225422_t_real,   -36.170018_t_real,   -34.545945_t_real &
       &,   -32.405622_t_real,   -29.843214_t_real,   -26.988564_t_real &
       &,   -23.964830_t_real,   -20.918686_t_real,   -17.944098_t_real &
       &,   -15.129431_t_real,   -12.548329_t_real,   -10.307362_t_real &
       &,    -8.476749_t_real,    -7.004149_t_real,    -5.806021_t_real &
       &,    -4.835848_t_real,    -4.040688_t_real,    -3.374614_t_real &
       &,    -2.819375_t_real,    -2.362256_t_real,    -1.987322_t_real &
       &,    -1.681355_t_real,    -1.438317_t_real,    -1.254052_t_real &
       &,    -1.117491_t_real,    -1.012365_t_real,    -0.925173_t_real &
       &,    -0.847794_t_real,    -0.775816_t_real,    -0.706732_t_real &
       &,    -0.639068_t_real,    -0.572123_t_real,    -0.505879_t_real &
       &,    -0.440906_t_real,    -0.378177_t_real,    -0.318846_t_real &
       &,    -0.264022_t_real,    -0.214599_t_real,    -0.171153_t_real &
       &,    -0.133909_t_real,    -0.102764_t_real,    -0.077347_t_real &
       &,    -0.057093_t_real,    -0.041329_t_real,    -0.029338_t_real &
       &,    -0.020423_t_real,    -0.013941_t_real/
  !!4d
  Data ncoeffrel( 39) / 50 /
  Data vcoeffrel(1:50, 39) /&
       &    -39.000000_t_real,   -38.971107_t_real,   -38.764631_t_real &
       &,   -38.195279_t_real,   -37.100346_t_real,   -35.419885_t_real &
       &,   -33.209550_t_real,   -30.567498_t_real,   -27.627511_t_real &
       &,   -24.518245_t_real,   -21.390478_t_real,   -18.340281_t_real &
       &,   -15.463233_t_real,   -12.839192_t_real,   -10.583909_t_real &
       &,    -8.746095_t_real,    -7.253666_t_real,    -6.030443_t_real &
       &,    -5.031997_t_real,    -4.198831_t_real,    -3.494560_t_real &
       &,    -2.907045_t_real,    -2.423571_t_real,    -2.029176_t_real &
       &,    -1.713147_t_real,    -1.467785_t_real,    -1.281089_t_real &
       &,    -1.136365_t_real,    -1.018755_t_real,    -0.918403_t_real &
       &,    -0.829312_t_real,    -0.747622_t_real,    -0.670721_t_real &
       &,    -0.596975_t_real,    -0.525648_t_real,    -0.456786_t_real &
       &,    -0.391010_t_real,    -0.329242_t_real,    -0.272451_t_real &
       &,    -0.221440_t_real,    -0.176723_t_real,    -0.138473_t_real &
       &,    -0.106540_t_real,    -0.080509_t_real,    -0.059776_t_real &
       &,    -0.043630_t_real,    -0.031324_t_real,    -0.022137_t_real &
       &,    -0.015412_t_real,    -0.010579_t_real/
  !!
  Data ncoeffrel( 40) / 50 /
  Data vcoeffrel(1:50, 40) /&
       &    -40.000000_t_real,   -39.970025_t_real,   -39.755663_t_real &
       &,   -39.164565_t_real,   -38.029472_t_real,   -36.291861_t_real &
       &,   -34.010504_t_real,   -31.287679_t_real,   -28.260760_t_real &
       &,   -25.064466_t_real,   -21.852918_t_real,   -18.725767_t_real &
       &,   -15.784603_t_real,   -13.117483_t_real,   -10.844424_t_real &
       &,    -8.989075_t_real,    -7.465398_t_real,    -6.208156_t_real &
       &,    -5.169293_t_real,    -4.289033_t_real,    -3.543623_t_real &
       &,    -2.925293_t_real,    -2.420800_t_real,    -2.014937_t_real &
       &,    -1.695364_t_real,    -1.449152_t_real,    -1.259517_t_real &
       &,    -1.109523_t_real,    -0.986296_t_real,    -0.881242_t_real &
       &,    -0.788554_t_real,    -0.704140_t_real,    -0.625202_t_real &
       &,    -0.550108_t_real,    -0.478250_t_real,    -0.409819_t_real &
       &,    -0.345506_t_real,    -0.286194_t_real,    -0.232700_t_real &
       &,    -0.185601_t_real,    -0.145153_t_real,    -0.111276_t_real &
       &,    -0.083603_t_real,    -0.061551_t_real,    -0.044402_t_real &
       &,    -0.031385_t_real,    -0.021736_t_real,    -0.014750_t_real &
       &,    -0.009807_t_real,    -0.006390_t_real/
  !!
  Data ncoeffrel( 41) / 50 /
  Data vcoeffrel(1:50, 41) /&
       &    -41.000000_t_real,   -40.968912_t_real,   -40.746424_t_real &
       &,   -40.132937_t_real,   -38.956575_t_real,   -37.160235_t_real &
       &,   -34.805582_t_real,   -31.999007_t_real,   -28.881028_t_real &
       &,   -25.592817_t_real,   -22.291290_t_real,   -19.081119_t_real &
       &,   -16.068719_t_real,   -13.351892_t_real,   -11.049054_t_real &
       &,    -9.156768_t_real,    -7.581229_t_real,    -6.268762_t_real &
       &,    -5.165989_t_real,    -4.222228_t_real,    -3.429190_t_real &
       &,    -2.783672_t_real,    -2.270380_t_real,    -1.868536_t_real &
       &,    -1.558317_t_real,    -1.321342_t_real,    -1.139994_t_real &
       &,    -0.998624_t_real,    -0.884915_t_real,    -0.789919_t_real &
       &,    -0.707331_t_real,    -0.632806_t_real,    -0.563508_t_real &
       &,    -0.497824_t_real,    -0.435105_t_real,    -0.375404_t_real &
       &,    -0.319200_t_real,    -0.267152_t_real,    -0.219895_t_real &
       &,    -0.177903_t_real,    -0.141416_t_real,    -0.110423_t_real &
       &,    -0.084687_t_real,    -0.063790_t_real,    -0.047192_t_real &
       &,    -0.034292_t_real,    -0.024478_t_real,    -0.017167_t_real &
       &,    -0.011829_t_real,    -0.008011_t_real/
  !!
  Data ncoeffrel( 42) / 50 /
  Data vcoeffrel(1:50, 42) /&
       &    -42.000000_t_real,   -41.967795_t_real,   -41.737140_t_real &
       &,   -41.101158_t_real,   -39.883489_t_real,   -38.028651_t_real &
       &,   -35.601220_t_real,   -32.711938_t_real,   -29.504403_t_real &
       &,   -26.126787_t_real,   -22.738284_t_real,   -19.449558_t_real &
       &,   -16.371211_t_real,   -13.611677_t_real,   -11.282195_t_real &
       &,    -9.352849_t_real,    -7.730422_t_real,    -6.370227_t_real &
       &,    -5.211889_t_real,    -4.218911_t_real,    -3.393372_t_real &
       &,    -2.730639_t_real,    -2.211031_t_real,    -1.809867_t_real &
       &,    -1.503745_t_real,    -1.271336_t_real,    -1.093598_t_real &
       &,    -0.954784_t_real,    -0.842901_t_real,    -0.749239_t_real &
       &,    -0.667634_t_real,    -0.593878_t_real,    -0.525320_t_real &
       &,    -0.460544_t_real,    -0.399075_t_real,    -0.341073_t_real &
       &,    -0.287044_t_real,    -0.237599_t_real,    -0.193268_t_real &
       &,    -0.154392_t_real,    -0.121072_t_real,    -0.093168_t_real &
       &,    -0.070336_t_real,    -0.052084_t_real,    -0.037823_t_real &
       &,    -0.026934_t_real,    -0.018806_t_real,    -0.012873_t_real &
       &,    -0.008638_t_real,    -0.005682_t_real/
  !!
  Data ncoeffrel( 43) / 50 /
  Data vcoeffrel(1:50, 43) /&
       &    -43.000000_t_real,   -42.966663_t_real,   -42.727710_t_real &
       &,   -42.068887_t_real,   -40.809399_t_real,   -38.895482_t_real &
       &,   -36.394544_t_real,   -33.421766_t_real,   -30.123683_t_real &
       &,   -26.655803_t_real,   -23.179319_t_real,   -19.811705_t_real &
       &,   -16.667365_t_real,   -13.865321_t_real,   -11.504077_t_real &
       &,    -9.529571_t_real,    -7.856012_t_real,    -6.442336_t_real &
       &,    -5.225593_t_real,    -4.187267_t_real,    -3.335810_t_real &
       &,    -2.662474_t_real,    -2.142064_t_real,    -1.745474_t_real &
       &,    -1.445837_t_real,    -1.219584_t_real,    -1.046845_t_real &
       &,    -0.911901_t_real,    -0.803002_t_real,    -0.711657_t_real &
       &,    -0.631893_t_real,    -0.559708_t_real,    -0.492660_t_real &
       &,    -0.429519_t_real,    -0.369935_t_real,    -0.314120_t_real &
       &,    -0.262560_t_real,    -0.215795_t_real,    -0.174249_t_real &
       &,    -0.138152_t_real,    -0.107498_t_real,    -0.082064_t_real &
       &,    -0.061445_t_real,    -0.045113_t_real,    -0.032474_t_real &
       &,    -0.022915_t_real,    -0.015848_t_real,    -0.010742_t_real &
       &,    -0.007134_t_real,    -0.004642_t_real/
  !!
  Data ncoeffrel( 44) / 50 /
  Data vcoeffrel(1:50, 44) /&
       &    -44.000000_t_real,   -43.965514_t_real,   -43.718134_t_real &
       &,   -43.036123_t_real,   -41.734310_t_real,   -39.760737_t_real &
       &,   -37.185572_t_real,   -34.128495_t_real,   -30.738908_t_real &
       &,   -27.179890_t_real,   -23.614542_t_real,   -20.167659_t_real &
       &,   -16.957457_t_real,   -14.112514_t_real,   -11.713673_t_real &
       &,    -9.686947_t_real,    -7.958875_t_real,    -6.486264_t_real &
       &,    -5.211029_t_real,    -4.132989_t_real,    -3.262580_t_real &
       &,    -2.584772_t_real,    -2.068153_t_real,    -1.679101_t_real &
       &,    -1.387684_t_real,    -1.168702_t_real,    -1.001829_t_real &
       &,    -0.871477_t_real,    -0.766160_t_real,    -0.677642_t_real &
       &,    -0.600191_t_real,    -0.530032_t_real,    -0.464925_t_real &
       &,    -0.403788_t_real,    -0.346352_t_real,    -0.292844_t_real &
       &,    -0.243714_t_real,    -0.199428_t_real,    -0.160328_t_real &
       &,    -0.126560_t_real,    -0.098050_t_real,    -0.074527_t_real &
       &,    -0.055561_t_real,    -0.040618_t_real,    -0.029112_t_real &
       &,    -0.020454_t_real,    -0.014084_t_real,    -0.009504_t_real &
       &,    -0.006284_t_real,    -0.004071_t_real/
  !!
  Data ncoeffrel( 45) / 50 /
  Data vcoeffrel(1:50, 45) /&
       &    -45.000000_t_real,   -44.964350_t_real,   -44.708411_t_real &
       &,   -44.002865_t_real,   -42.658224_t_real,   -40.624419_t_real &
       &,   -37.974309_t_real,   -34.832112_t_real,   -31.350093_t_real &
       &,   -27.699045_t_real,   -24.044058_t_real,   -20.517467_t_real &
       &,   -17.241646_t_real,   -14.352736_t_real,   -11.909981_t_real &
       &,    -9.825242_t_real,    -8.039447_t_real,    -6.503420_t_real &
       &,    -5.172061_t_real,    -4.060996_t_real,    -3.178483_t_real &
       &,    -2.501617_t_real,    -1.992471_t_real,    -1.613122_t_real &
       &,    -1.331086_t_real,    -1.120035_t_real,    -0.959473_t_real &
       &,    -0.834047_t_real,    -0.732587_t_real,    -0.647148_t_real &
       &,    -0.572259_t_real,    -0.504368_t_real,    -0.441407_t_real &
       &,    -0.382405_t_real,    -0.327147_t_real,    -0.275857_t_real &
       &,    -0.228951_t_real,    -0.186838_t_real,    -0.149800_t_real &
       &,    -0.117931_t_real,    -0.091118_t_real,    -0.069070_t_real &
       &,    -0.051352_t_real,    -0.037436_t_real,    -0.026755_t_real &
       &,    -0.018742_t_real,    -0.012867_t_real,    -0.008655_t_real &
       &,    -0.005704_t_real,    -0.003682_t_real/
  !!
  Data ncoeffrel( 46) / 50 /
  Data vcoeffrel(1:50, 46) /&
       &    -46.000000_t_real,   -45.963149_t_real,   -45.698380_t_real &
       &,   -44.968573_t_real,   -43.579856_t_real,   -41.483979_t_real &
       &,   -38.756285_t_real,   -35.525361_t_real,   -31.946226_t_real &
       &,   -28.197310_t_real,   -24.446014_t_real,   -20.832092_t_real &
       &,   -17.482580_t_real,   -14.538111_t_real,   -12.033337_t_real &
       &,    -9.872065_t_real,    -8.008573_t_real,    -6.388605_t_real &
       &,    -4.988136_t_real,    -3.837446_t_real,    -2.942367_t_real &
       &,    -2.272307_t_real,    -1.781425_t_real,    -1.424894_t_real &
       &,    -1.165177_t_real,    -0.973112_t_real,    -0.827181_t_real &
       &,    -0.712183_t_real,    -0.617791_t_real,    -0.537251_t_real &
       &,    -0.466349_t_real,    -0.402613_t_real,    -0.344725_t_real &
       &,    -0.292088_t_real,    -0.244502_t_real,    -0.201943_t_real &
       &,    -0.164412_t_real,    -0.131846_t_real,    -0.104082_t_real &
       &,    -0.080843_t_real,    -0.061758_t_real,    -0.046386_t_real &
       &,    -0.034244_t_real,    -0.024843_t_real,    -0.017705_t_real &
       &,    -0.012394_t_real,    -0.008521_t_real,    -0.005751_t_real &
       &,    -0.003810_t_real,    -0.002478_t_real/
  !!
  Data ncoeffrel( 47) / 50 /
  Data vcoeffrel(1:50, 47) /&
       &    -47.000000_t_real,   -46.961973_t_real,   -46.688520_t_real &
       &,   -45.934861_t_real,   -44.503063_t_real,   -42.347055_t_real &
       &,   -39.544912_t_real,   -36.229922_t_real,   -32.560353_t_real &
       &,   -28.722480_t_real,   -24.886249_t_real,   -21.198732_t_real &
       &,   -17.792488_t_real,   -14.809589_t_real,   -12.259483_t_real &
       &,   -10.046444_t_real,    -8.134314_t_real,    -6.464844_t_real &
       &,    -5.035729_t_real,    -3.880174_t_real,    -2.992030_t_real &
       &,    -2.330034_t_real,    -1.843620_t_real,    -1.487610_t_real &
       &,    -1.226001_t_real,    -1.031445_t_real,    -0.883758_t_real &
       &,    -0.768338_t_real,    -0.674758_t_real,    -0.595693_t_real &
       &,    -0.526161_t_real,    -0.462984_t_real,    -0.404354_t_real &
       &,    -0.349464_t_real,    -0.298168_t_real,    -0.250698_t_real &
       &,    -0.207432_t_real,    -0.168729_t_real,    -0.134818_t_real &
       &,    -0.105751_t_real,    -0.081393_t_real,    -0.061445_t_real &
       &,    -0.045483_t_real,    -0.033003_t_real,    -0.023470_t_real &
       &,    -0.016355_t_real,    -0.011165_t_real,    -0.007466_t_real &
       &,    -0.004890_t_real,    -0.003136_t_real/
  !!
  Data ncoeffrel( 48) / 50 /
  Data vcoeffrel(1:50, 48) /&
       &    -48.000000_t_real,   -47.960787_t_real,   -47.678564_t_real &
       &,   -46.900835_t_real,   -45.425719_t_real,   -43.209436_t_real &
       &,   -40.332812_t_real,   -36.933858_t_real,   -33.174347_t_real &
       &,   -29.248293_t_real,   -25.328594_t_real,   -21.569288_t_real &
       &,   -18.109130_t_real,   -15.087816_t_real,   -12.490100_t_real &
       &,   -10.227395_t_real,    -8.267059_t_real,    -6.552959_t_real &
       &,    -5.103055_t_real,    -3.946456_t_real,    -3.063182_t_real &
       &,    -2.403474_t_real,    -1.915263_t_real,    -1.555037_t_real &
       &,    -1.288436_t_real,    -1.088827_t_real,    -0.936092_t_real &
       &,    -0.815403_t_real,    -0.716044_t_real,    -0.630497_t_real &
       &,    -0.553785_t_real,    -0.482957_t_real,    -0.416597_t_real &
       &,    -0.354367_t_real,    -0.296569_t_real,    -0.243783_t_real &
       &,    -0.196584_t_real,    -0.155371_t_real,    -0.120274_t_real &
       &,    -0.091145_t_real,    -0.067589_t_real,    -0.049030_t_real &
       &,    -0.034785_t_real,    -0.024130_t_real,    -0.016365_t_real &
       &,    -0.010849_t_real,    -0.007029_t_real,    -0.004451_t_real &
       &,    -0.002754_t_real,    -0.001664_t_real/
  !!5p
  Data ncoeffrel( 49) / 50 /
  Data vcoeffrel(1:50, 49) /&
       &    -49.000000_t_real,   -48.959603_t_real,   -48.668595_t_real &
       &,   -47.866771_t_real,   -46.348474_t_real,   -44.072362_t_real &
       &,   -41.122108_t_real,   -37.640507_t_real,   -33.793197_t_real &
       &,   -29.781799_t_real,   -25.782751_t_real,   -21.956687_t_real &
       &,   -18.449147_t_real,   -15.393462_t_real,   -12.751749_t_real &
       &,   -10.447455_t_real,    -8.446049_t_real,    -6.701070_t_real &
       &,    -5.246327_t_real,    -4.100707_t_real,    -3.228948_t_real &
       &,    -2.573768_t_real,    -2.082805_t_real,    -1.714665_t_real &
       &,    -1.436712_t_real,    -1.223682_t_real,    -1.057027_t_real &
       &,    -0.923584_t_real,    -0.814036_t_real,    -0.721752_t_real &
       &,    -0.642029_t_real,    -0.571571_t_real,    -0.508098_t_real &
       &,    -0.450060_t_real,    -0.396437_t_real,    -0.346608_t_real &
       &,    -0.300264_t_real,    -0.257327_t_real,    -0.217868_t_real &
       &,    -0.182031_t_real,    -0.149952_t_real,    -0.121708_t_real &
       &,    -0.097278_t_real,    -0.076539_t_real,    -0.059264_t_real &
       &,    -0.045149_t_real,    -0.033837_t_real,    -0.024943_t_real &
       &,    -0.018083_t_real,    -0.012891_t_real/
  !!
  Data ncoeffrel( 50) / 50 /
  Data vcoeffrel(1:50, 50) /&
       &    -50.000000_t_real,   -49.958406_t_real,   -49.658504_t_real &
       &,   -48.832303_t_real,   -47.270471_t_real,   -44.934185_t_real &
       &,   -41.909989_t_real,   -38.345442_t_real,   -34.410373_t_real &
       &,   -30.313732_t_real,   -26.235964_t_real,   -22.343823_t_real &
       &,   -18.789864_t_real,   -15.697097_t_real,   -13.008537_t_real &
       &,   -10.662270_t_real,    -8.617916_t_real,    -6.844744_t_real &
       &,    -5.385350_t_real,    -4.243707_t_real,    -3.371173_t_real &
       &,    -2.707946_t_real,    -2.204875_t_real,    -1.822642_t_real &
       &,    -1.528988_t_real,    -1.299558_t_real,    -1.117299_t_real &
       &,    -0.970112_t_real,    -0.848933_t_real,    -0.746763_t_real &
       &,    -0.658273_t_real,    -0.579585_t_real,    -0.508074_t_real &
       &,    -0.442150_t_real,    -0.381016_t_real,    -0.324436_t_real &
       &,    -0.272511_t_real,    -0.225487_t_real,    -0.183606_t_real &
       &,    -0.147005_t_real,    -0.115661_t_real,    -0.089382_t_real &
       &,    -0.067821_t_real,    -0.050513_t_real,    -0.036922_t_real &
       &,    -0.026481_t_real,    -0.018632_t_real,    -0.012860_t_real &
       &,    -0.008706_t_real,    -0.005779_t_real/
  !!
  Data ncoeffrel( 51) / 50 /
  Data vcoeffrel(1:50, 51) /&
       &    -51.000000_t_real,   -50.957199_t_real,   -50.648307_t_real &
       &,   -49.797490_t_real,   -48.191856_t_real,   -45.795180_t_real &
       &,   -42.696925_t_real,   -39.049380_t_real,   -35.026936_t_real &
       &,   -30.845567_t_real,   -26.690219_t_real,   -22.733336_t_real &
       &,   -19.134382_t_real,   -16.002433_t_real,   -13.266061_t_real &
       &,   -10.877978_t_real,    -8.790908_t_real,    -6.993571_t_real &
       &,    -5.529733_t_real,    -4.386069_t_real,    -3.504309_t_real &
       &,    -2.826622_t_real,    -2.307318_t_real,    -1.906947_t_real &
       &,    -1.593648_t_real,    -1.345369_t_real,    -1.146997_t_real &
       &,    -0.986951_t_real,    -0.855649_t_real,    -0.745241_t_real &
       &,    -0.649668_t_real,    -0.564645_t_real,    -0.487466_t_real &
       &,    -0.416683_t_real,    -0.351741_t_real,    -0.292621_t_real &
       &,    -0.239542_t_real,    -0.192728_t_real,    -0.152273_t_real &
       &,    -0.118069_t_real,    -0.089802_t_real,    -0.066975_t_real &
       &,    -0.048968_t_real,    -0.035091_t_real,    -0.024645_t_real &
       &,    -0.016960_t_real,    -0.011436_t_real,    -0.007555_t_real &
       &,    -0.004890_t_real,    -0.003100_t_real/
  !!
  Data ncoeffrel( 52) / 50 /
  Data vcoeffrel(1:50, 52) /&
       &    -52.000000_t_real,   -51.955980_t_real,   -51.637991_t_real &
       &,   -50.762286_t_real,   -49.112523_t_real,   -46.655146_t_real &
       &,   -43.482584_t_real,   -39.751797_t_real,   -35.642119_t_real &
       &,   -31.376197_t_real,   -27.143950_t_real,   -23.123146_t_real &
       &,   -19.479641_t_real,   -16.305454_t_real,   -13.520195_t_real &
       &,   -11.088823_t_real,    -8.958953_t_real,    -7.139392_t_real &
       &,    -5.667892_t_real,    -4.514028_t_real,    -3.615343_t_real &
       &,    -2.918831_t_real,    -2.379654_t_real,    -1.957337_t_real &
       &,    -1.622665_t_real,    -1.356760_t_real,    -1.145452_t_real &
       &,    -0.976314_t_real,    -0.838375_t_real,    -0.722642_t_real &
       &,    -0.622449_t_real,    -0.533378_t_real,    -0.452889_t_real &
       &,    -0.379803_t_real,    -0.313787_t_real,    -0.254917_t_real &
       &,    -0.203349_t_real,    -0.159117_t_real,    -0.122039_t_real &
       &,    -0.091694_t_real,    -0.067461_t_real,    -0.048585_t_real &
       &,    -0.034244_t_real,    -0.023617_t_real,    -0.015935_t_real &
       &,    -0.010518_t_real,    -0.006791_t_real,    -0.004288_t_real &
       &,    -0.002648_t_real,    -0.001599_t_real/
  !!
  Data ncoeffrel( 53) / 50 /
  Data vcoeffrel(1:50, 53) /&
       &    -53.000000_t_real,   -52.954750_t_real,   -52.627554_t_real &
       &,   -51.726686_t_real,   -50.032469_t_real,   -47.514074_t_real &
       &,   -44.266955_t_real,   -40.452673_t_real,   -36.255893_t_real &
       &,   -31.905569_t_real,   -27.597031_t_real,   -23.513099_t_real &
       &,   -19.825064_t_real,   -16.605485_t_real,   -13.770777_t_real &
       &,   -11.294068_t_real,    -9.121944_t_real,    -7.280991_t_real &
       &,    -5.797138_t_real,    -4.625518_t_real,    -3.705005_t_real &
       &,    -2.986835_t_real,    -2.424086_t_real,    -1.977613_t_real &
       &,    -1.622897_t_real,    -1.343218_t_real,    -1.123525_t_real &
       &,    -0.949372_t_real,    -0.808026_t_real,    -0.689495_t_real &
       &,    -0.586819_t_real,    -0.495726_t_real,    -0.413982_t_real &
       &,    -0.340678_t_real,    -0.275613_t_real,    -0.218822_t_real &
       &,    -0.170281_t_real,    -0.129755_t_real,    -0.096751_t_real &
       &,    -0.070555_t_real,    -0.050300_t_real,    -0.035047_t_real &
       &,    -0.023860_t_real,    -0.015869_t_real,    -0.010310_t_real &
       &,    -0.006542_t_real,    -0.004053_t_real,    -0.002452_t_real &
       &,    -0.001448_t_real,    -0.000835_t_real/
  !!
  Data ncoeffrel( 54) / 50 /
  Data vcoeffrel(1:50, 54) /&
       &    -54.000000_t_real,   -53.953507_t_real,   -53.616994_t_real &
       &,   -52.690686_t_real,   -50.951687_t_real,   -48.371951_t_real &
       &,   -45.050022_t_real,   -41.151984_t_real,   -36.868215_t_real &
       &,   -32.433617_t_real,   -28.049312_t_real,   -23.903001_t_real &
       &,   -20.170027_t_real,   -16.901949_t_real,   -14.017480_t_real &
       &,   -11.493086_t_real,    -9.279638_t_real,    -7.416857_t_real &
       &,    -5.915036_t_real,    -4.719507_t_real,    -3.774352_t_real &
       &,    -3.031573_t_real,    -2.442178_t_real,    -1.972047_t_real &
       &,    -1.601163_t_real,    -1.312718_t_real,    -1.089126_t_real &
       &,    -0.913345_t_real,    -0.771007_t_real,    -0.651506_t_real &
       &,    -0.547938_t_real,    -0.456374_t_real,    -0.374931_t_real &
       &,    -0.302909_t_real,    -0.240129_t_real,    -0.186489_t_real &
       &,    -0.141720_t_real,    -0.105293_t_real,    -0.076430_t_real &
       &,    -0.054176_t_real,    -0.037485_t_real,    -0.025311_t_real &
       &,    -0.016674_t_real,    -0.010715_t_real,    -0.006716_t_real &
       &,    -0.004105_t_real,    -0.002446_t_real,    -0.001421_t_real &
       &,    -0.000805_t_real,    -0.000444_t_real/
  !!6s
  Data ncoeffrel( 55) / 50 /
  Data vcoeffrel(1:50, 55) /&
       &    -55.000000_t_real,   -54.952285_t_real,   -54.606569_t_real &
       &,   -53.655164_t_real,   -51.872269_t_real,   -49.232881_t_real &
       &,   -45.838874_t_real,   -41.860952_t_real,   -37.495750_t_real &
       &,   -32.984004_t_real,   -28.533156_t_real,   -24.335879_t_real &
       &,   -20.569914_t_real,   -17.265482_t_real,   -14.348449_t_real &
       &,   -11.794054_t_real,    -9.562925_t_real,    -7.702120_t_real &
       &,    -6.205382_t_real,    -5.013708_t_real,    -4.074713_t_real &
       &,    -3.334440_t_real,    -2.742114_t_real,    -2.266455_t_real &
       &,    -1.886384_t_real,    -1.582560_t_real,    -1.338200_t_real &
       &,    -1.142150_t_real,    -0.989137_t_real,    -0.875784_t_real &
       &,    -0.795384_t_real,    -0.737369_t_real,    -0.691358_t_real &
       &,    -0.650056_t_real,    -0.609287_t_real,    -0.567005_t_real &
       &,    -0.522467_t_real,    -0.475744_t_real,    -0.427443_t_real &
       &,    -0.378515_t_real,    -0.330087_t_real,    -0.283310_t_real &
       &,    -0.239233_t_real,    -0.198705_t_real,    -0.162323_t_real &
       &,    -0.130411_t_real,    -0.103044_t_real,    -0.080078_t_real &
       &,    -0.061208_t_real,    -0.046015_t_real/
  !!
  Data ncoeffrel( 56) / 50 /
  Data vcoeffrel(1:50, 56) /&
       &    -56.000000_t_real,   -55.951052_t_real,   -55.596028_t_real &
       &,   -54.619266_t_real,   -52.792196_t_real,   -50.092910_t_real &
       &,   -46.626682_t_real,   -42.568751_t_real,   -38.122356_t_real &
       &,   -33.533780_t_real,   -29.017026_t_real,   -24.769719_t_real &
       &,   -20.969849_t_real,   -17.626812_t_real,   -14.676945_t_real &
       &,   -12.090726_t_real,    -9.842801_t_real,    -7.981262_t_real &
       &,    -6.484208_t_real,    -5.292391_t_real,    -4.352722_t_real &
       &,    -3.603618_t_real,    -2.995635_t_real,    -2.499656_t_real &
       &,    -2.094571_t_real,    -1.764415_t_real,    -1.500568_t_real &
       &,    -1.298269_t_real,    -1.148174_t_real,    -1.034783_t_real &
       &,    -0.943214_t_real,    -0.863476_t_real,    -0.789863_t_real &
       &,    -0.719213_t_real,    -0.649822_t_real,    -0.580985_t_real &
       &,    -0.512790_t_real,    -0.445941_t_real,    -0.381531_t_real &
       &,    -0.320798_t_real,    -0.264890_t_real,    -0.214696_t_real &
       &,    -0.170761_t_real,    -0.133256_t_real,    -0.102019_t_real &
       &,    -0.076623_t_real,    -0.056457_t_real,    -0.040809_t_real &
       &,    -0.028938_t_real,    -0.020131_t_real/
  !!5d
  Data ncoeffrel( 57) / 50 /
  Data vcoeffrel(1:50, 57) /&
       &    -57.000000_t_real,   -56.949797_t_real,   -56.585280_t_real &
       &,   -55.582690_t_real,   -53.710748_t_real,   -50.950607_t_real &
       &,   -47.410914_t_real,   -43.271259_t_real,   -38.741732_t_real &
       &,   -34.073958_t_real,   -29.488653_t_real,   -25.188338_t_real &
       &,   -21.348670_t_real,   -17.959627_t_real,   -14.969649_t_real &
       &,   -12.342904_t_real,   -10.070739_t_real,    -8.196154_t_real &
       &,    -6.682679_t_real,    -5.472368_t_real,    -4.509169_t_real &
       &,    -3.728558_t_real,    -3.087627_t_real,    -2.562367_t_real &
       &,    -2.134589_t_real,    -1.790956_t_real,    -1.522307_t_real &
       &,    -1.317727_t_real,    -1.161522_t_real,    -1.037637_t_real &
       &,    -0.934047_t_real,    -0.843025_t_real,    -0.759728_t_real &
       &,    -0.681114_t_real,    -0.605451_t_real,    -0.532065_t_real &
       &,    -0.461136_t_real,    -0.393417_t_real,    -0.329944_t_real &
       &,    -0.271752_t_real,    -0.219671_t_real,    -0.174207_t_real &
       &,    -0.135500_t_real,    -0.103354_t_real,    -0.077302_t_real &
       &,    -0.056690_t_real,    -0.040763_t_real,    -0.028739_t_real &
       &,    -0.019866_t_real,    -0.013465_t_real/
  !!4f
  Data ncoeffrel( 58) / 50 /
  Data vcoeffrel(1:50, 58) /&
       &    -58.000000_t_real,   -57.948483_t_real,   -57.574030_t_real &
       &,   -56.544446_t_real,   -54.625575_t_real,   -51.801343_t_real &
       &,   -48.183428_t_real,   -43.955195_t_real,   -39.333209_t_real &
       &,   -34.573341_t_real,   -29.901864_t_real,   -25.525375_t_real &
       &,   -21.615654_t_real,   -18.148563_t_real,   -15.084832_t_real &
       &,   -12.385866_t_real,   -10.065609_t_real,    -8.164185_t_real &
       &,    -6.635472_t_real,    -5.418061_t_real,    -4.449546_t_real &
       &,    -3.665489_t_real,    -3.025615_t_real,    -2.505089_t_real &
       &,    -2.084106_t_real,    -1.748479_t_real,    -1.488113_t_real &
       &,    -1.290610_t_real,    -1.139385_t_real,    -1.018627_t_real &
       &,    -0.916964_t_real,    -0.827169_t_real,    -0.744695_t_real &
       &,    -0.666690_t_real,    -0.591561_t_real,    -0.518751_t_real &
       &,    -0.448518_t_real,    -0.381656_t_real,    -0.319199_t_real &
       &,    -0.262151_t_real,    -0.211289_t_real,    -0.167058_t_real &
       &,    -0.129545_t_real,    -0.098508_t_real,    -0.073449_t_real &
       &,    -0.053696_t_real,    -0.038489_t_real,    -0.027050_t_real &
       &,    -0.018639_t_real,    -0.012593_t_real/
  !!
  Data ncoeffrel( 59) / 50 /
  Data vcoeffrel(1:50, 59) /&
       &    -59.000000_t_real,   -58.947115_t_real,   -58.562319_t_real &
       &,   -57.504667_t_real,   -55.537001_t_real,   -52.645754_t_real &
       &,   -48.945335_t_real,   -44.622370_t_real,   -39.899549_t_real &
       &,   -35.036011_t_real,   -30.262567_t_real,   -25.789385_t_real &
       &,   -21.783407_t_real,   -18.211525_t_real,   -15.045538_t_real &
       &,   -12.249953_t_real,    -9.864790_t_real,    -7.929299_t_real &
       &,    -6.389426_t_real,    -5.175892_t_real,    -4.220083_t_real &
       &,    -3.457835_t_real,    -2.847017_t_real,    -2.357725_t_real &
       &,    -1.965141_t_real,    -1.652197_t_real,    -1.409513_t_real &
       &,    -1.227852_t_real,    -1.092315_t_real,    -0.986353_t_real &
       &,    -0.897533_t_real,    -0.818312_t_real,    -0.744363_t_real &
       &,    -0.673187_t_real,    -0.603460_t_real,    -0.534769_t_real &
       &,    -0.467434_t_real,    -0.402297_t_real,    -0.340472_t_real &
       &,    -0.283096_t_real,    -0.231129_t_real,    -0.185226_t_real &
       &,    -0.145686_t_real,    -0.112461_t_real,    -0.085217_t_real &
       &,    -0.063403_t_real,    -0.046343_t_real,    -0.033300_t_real &
       &,    -0.023549_t_real,    -0.016415_t_real/
  !!
  Data ncoeffrel( 60) / 50 /
  Data vcoeffrel(1:50, 60) /&
       &    -60.000000_t_real,   -59.945766_t_real,   -59.550724_t_real &
       &,   -58.465309_t_real,   -56.449687_t_real,   -53.493038_t_real &
       &,   -49.712813_t_real,   -45.299147_t_real,   -40.481476_t_real &
       &,   -35.522658_t_real,   -30.658764_t_real,   -26.104319_t_real &
       &,   -22.019195_t_real,   -18.363122_t_real,   -15.117456_t_real &
       &,   -12.251944_t_real,    -9.827044_t_real,    -7.872499_t_real &
       &,    -6.324455_t_real,    -5.108900_t_real,    -4.152763_t_real &
       &,    -3.392711_t_real,    -2.787224_t_real,    -2.304890_t_real &
       &,    -1.919739_t_real,    -1.614544_t_real,    -1.379622_t_real &
       &,    -1.204566_t_real,    -1.073572_t_real,    -0.970316_t_real &
       &,    -0.883055_t_real,    -0.804775_t_real,    -0.731440_t_real &
       &,    -0.660709_t_real,    -0.591371_t_real,    -0.523098_t_real &
       &,    -0.456274_t_real,    -0.391778_t_real,    -0.330727_t_real &
       &,    -0.274239_t_real,    -0.223233_t_real,    -0.178319_t_real &
       &,    -0.139749_t_real,    -0.107440_t_real,    -0.081027_t_real &
       &,    -0.059943_t_real,    -0.043504_t_real,    -0.030978_t_real &
       &,    -0.021646_t_real,    -0.014845_t_real/
  !!
  Data ncoeffrel( 61) / 50 /
  Data vcoeffrel(1:50, 61) /&
       &    -61.000000_t_real,   -60.944400_t_real,   -60.538960_t_real &
       &,   -59.425409_t_real,   -57.361346_t_real,   -54.338685_t_real &
       &,   -50.477926_t_real,   -45.972614_t_real,   -41.059011_t_real &
       &,   -36.003515_t_real,   -31.047268_t_real,   -26.409267_t_real &
       &,   -22.240949_t_real,   -18.498551_t_real,   -15.171031_t_real &
       &,   -12.238160_t_real,    -9.777614_t_real,    -7.807216_t_real &
       &,    -6.253704_t_real,    -5.038019_t_real,    -4.083453_t_real &
       &,    -3.327623_t_real,    -2.728918_t_real,    -2.254301_t_real &
       &,    -1.876901_t_real,    -1.579504_t_real,    -1.352120_t_real &
       &,    -1.183246_t_real,    -1.056393_t_real,    -0.955579_t_real &
       &,    -0.869734_t_real,    -0.792317_t_real,    -0.719551_t_real &
       &,    -0.649243_t_real,    -0.580283_t_real,    -0.512426_t_real &
       &,    -0.446115_t_real,    -0.382256_t_real,    -0.321970_t_real &
       &,    -0.266350_t_real,    -0.216278_t_real,    -0.172318_t_real &
       &,    -0.134682_t_real,    -0.103248_t_real,    -0.077628_t_real &
       &,    -0.057240_t_real,    -0.041393_t_real,    -0.029355_t_real &
       &,    -0.020417_t_real,    -0.013927_t_real/
  !!
  Data ncoeffrel( 62) / 50 /
  Data vcoeffrel(1:50, 62) /&
       &    -62.000000_t_real,   -61.943018_t_real,   -61.527025_t_real &
       &,   -60.384968_t_real,   -58.271989_t_real,   -55.182718_t_real &
       &,   -51.240715_t_real,   -46.642849_t_real,   -41.632255_t_real &
       &,   -36.478739_t_real,   -31.428317_t_real,   -26.704532_t_real &
       &,   -22.449325_t_real,   -18.618895_t_real,   -15.208012_t_real &
       &,   -12.211101_t_real,    -9.718982_t_real,    -7.735740_t_real &
       &,    -6.179114_t_real,    -4.964887_t_real,    -4.013520_t_real &
       &,    -3.263482_t_real,    -2.672537_t_real,    -2.206050_t_real &
       &,    -1.836508_t_real,    -1.546835_t_real,    -1.326706_t_real &
       &,    -1.163582_t_real,    -1.040482_t_real,    -0.941860_t_real &
       &,    -0.857286_t_real,    -0.780649_t_real,    -0.708401_t_real &
       &,    -0.638484_t_real,    -0.569884_t_real,    -0.502430_t_real &
       &,    -0.436619_t_real,    -0.373382_t_real,    -0.313838_t_real &
       &,    -0.259054_t_real,    -0.209876_t_real,    -0.166826_t_real &
       &,    -0.130075_t_real,    -0.099468_t_real,    -0.074593_t_real &
       &,    -0.054855_t_real,    -0.039556_t_real,    -0.027970_t_real &
       &,    -0.019392_t_real,    -0.013184_t_real/
  !!
  Data ncoeffrel( 63) / 50 /
  Data vcoeffrel(1:50, 63) /&
       &    -63.000000_t_real,   -62.941619_t_real,   -62.514927_t_real &
       &,   -61.344010_t_real,   -59.181676_t_real,   -56.025264_t_real &
       &,   -52.001401_t_real,   -47.310228_t_real,   -42.201766_t_real &
       &,   -36.949164_t_real,   -31.803118_t_real,   -26.991717_t_real &
       &,   -22.646588_t_real,   -18.726915_t_real,   -15.231976_t_real &
       &,   -12.174826_t_real,    -9.654906_t_real,    -7.661322_t_real &
       &,    -6.103299_t_real,    -4.891580_t_real,    -3.944528_t_real &
       &,    -3.201265_t_real,    -2.618553_t_real,    -2.160267_t_real &
       &,    -1.798493_t_real,    -1.516370_t_real,    -1.303171_t_real &
       &,    -1.145358_t_real,    -1.025621_t_real,    -0.928926_t_real &
       &,    -0.845456_t_real,    -0.769491_t_real,    -0.697689_t_real &
       &,    -0.628113_t_real,    -0.559838_t_real,    -0.492767_t_real &
       &,    -0.427440_t_real,    -0.364813_t_real,    -0.305996_t_real &
       &,    -0.252034_t_real,    -0.203733_t_real,    -0.161572_t_real &
       &,    -0.125682_t_real,    -0.095878_t_real,    -0.071724_t_real &
       &,    -0.052612_t_real,    -0.037841_t_real,    -0.026686_t_real &
       &,    -0.018452_t_real,    -0.012509_t_real/
  !!
  Data ncoeffrel( 64) / 50 /
  Data vcoeffrel(1:50, 64) /&
       &    -64.000000_t_real,   -63.940242_t_real,   -63.502956_t_real &
       &,   -62.303524_t_real,   -60.092773_t_real,   -56.870990_t_real &
       &,   -52.768195_t_real,   -47.988135_t_real,   -42.788192_t_real &
       &,   -37.445481_t_real,   -32.215959_t_real,   -27.332520_t_real &
       &,   -22.915019_t_real,   -18.927742_t_real,   -15.373234_t_real &
       &,   -12.283737_t_real,    -9.758007_t_real,    -7.765160_t_real &
       &,    -6.207142_t_real,    -4.991330_t_real,    -4.034840_t_real &
       &,    -3.278975_t_real,    -2.682027_t_real,    -2.210104_t_real &
       &,    -1.838749_t_real,    -1.552205_t_real,    -1.335824_t_real &
       &,    -1.171570_t_real,    -1.042016_t_real,    -0.934499_t_real &
       &,    -0.841000_t_real,    -0.756451_t_real,    -0.677568_t_real &
       &,    -0.602347_t_real,    -0.529849_t_real,    -0.460015_t_real &
       &,    -0.393410_t_real,    -0.330935_t_real,    -0.273549_t_real &
       &,    -0.222051_t_real,    -0.176948_t_real,    -0.138408_t_real &
       &,    -0.106269_t_real,    -0.080105_t_real,    -0.059299_t_real &
       &,    -0.043125_t_real,    -0.030827_t_real,    -0.021673_t_real &
       &,    -0.014995_t_real,    -0.010217_t_real/
  !!
  Data ncoeffrel( 65) / 50 /
  Data vcoeffrel(1:50, 65) /&
       &    -65.000000_t_real,   -64.938773_t_real,   -64.490213_t_real &
       &,   -63.260469_t_real,   -60.998040_t_real,   -57.705619_t_real &
       &,   -53.515971_t_real,   -48.635659_t_real,   -43.328351_t_real &
       &,   -37.873757_t_real,   -32.531420_t_real,   -27.538237_t_real &
       &,   -23.004487_t_real,   -18.902525_t_real,   -15.239759_t_real &
       &,   -12.074593_t_real,    -9.509911_t_real,    -7.502929_t_real &
       &,    -5.947090_t_real,    -4.743795_t_real,    -3.808864_t_real &
       &,    -3.081808_t_real,    -2.516704_t_real,    -2.074960_t_real &
       &,    -1.728487_t_real,    -1.460947_t_real,    -1.260631_t_real &
       &,    -1.112254_t_real,    -0.998305_t_real,    -0.904890_t_real &
       &,    -0.823313_t_real,    -0.748514_t_real,    -0.677496_t_real &
       &,    -0.608539_t_real,    -0.540879_t_real,    -0.474546_t_real &
       &,    -0.410166_t_real,    -0.348724_t_real,    -0.291317_t_real &
       &,    -0.238934_t_real,    -0.192305_t_real,    -0.151830_t_real &
       &,    -0.117565_t_real,    -0.089268_t_real,    -0.066460_t_real &
       &,    -0.048511_t_real,    -0.034716_t_real,    -0.024356_t_real &
       &,    -0.016752_t_real,    -0.011294_t_real/
  !!
  Data ncoeffrel( 66) / 50 /
  Data vcoeffrel(1:50, 66) /&
       &    -66.000000_t_real,   -65.937324_t_real,   -65.477594_t_real &
       &,   -64.217881_t_real,   -61.904716_t_real,   -58.543436_t_real &
       &,   -54.269865_t_real,   -49.293756_t_real,   -43.885457_t_real &
       &,   -38.327962_t_real,   -32.885042_t_real,   -27.797683_t_real &
       &,   -23.165900_t_real,   -18.971098_t_real,   -15.225974_t_real &
       &,   -12.013300_t_real,    -9.431203_t_real,    -7.420718_t_real &
       &,    -5.868020_t_real,    -4.670388_t_real,    -3.742929_t_real &
       &,    -3.024884_t_real,    -2.468836_t_real,    -2.035263_t_real &
       &,    -1.696244_t_real,    -1.435688_t_real,    -1.241313_t_real &
       &,    -1.097098_t_real,    -0.985629_t_real,    -0.893609_t_real &
       &,    -0.812842_t_real,    -0.738546_t_real,    -0.667873_t_real &
       &,    -0.599196_t_real,    -0.531828_t_real,    -0.465854_t_real &
       &,    -0.401939_t_real,    -0.341080_t_real,    -0.284362_t_real &
       &,    -0.232745_t_real,    -0.186923_t_real,    -0.147257_t_real &
       &,    -0.113768_t_real,    -0.086185_t_real,    -0.064014_t_real &
       &,    -0.046613_t_real,    -0.033275_t_real,    -0.023286_t_real &
       &,    -0.015974_t_real,    -0.010741_t_real/
  !!
  Data ncoeffrel( 67) / 50 /
  Data vcoeffrel(1:50, 67) /&
       &    -67.000000_t_real,   -66.935859_t_real,   -66.464797_t_real &
       &,   -65.174742_t_real,   -62.810385_t_real,   -59.379681_t_real &
       &,   -55.021499_t_real,   -49.948789_t_real,   -44.438445_t_real &
       &,   -38.776772_t_real,   -33.231694_t_real,   -28.047963_t_real &
       &,   -23.316089_t_real,   -19.027451_t_real,   -15.201866_t_real &
       &,   -11.946028_t_real,    -9.349502_t_real,    -7.337366_t_real &
       &,    -5.788934_t_real,    -4.597794_t_real,    -3.678556_t_real &
       &,    -2.969908_t_real,    -2.422936_t_real,    -1.997403_t_real &
       &,    -1.665679_t_real,    -1.411883_t_real,    -1.223114_t_real &
       &,    -1.082723_t_real,    -0.973494_t_real,    -0.882728_t_real &
       &,    -0.802692_t_real,    -0.728854_t_real,    -0.658498_t_real &
       &,    -0.590085_t_real,    -0.522999_t_real,    -0.457381_t_real &
       &,    -0.393929_t_real,    -0.333648_t_real,    -0.277611_t_real &
       &,    -0.226749_t_real,    -0.181720_t_real,    -0.142844_t_real &
       &,    -0.110112_t_real,    -0.083224_t_real,    -0.061669_t_real &
       &,    -0.044798_t_real,    -0.031901_t_real,    -0.022268_t_real &
       &,    -0.015236_t_real,    -0.010218_t_real/
  !!
  Data ncoeffrel( 68) / 50 /
  Data vcoeffrel(1:50, 68) /&
       &    -68.000000_t_real,   -67.934377_t_real,   -67.451821_t_real &
       &,   -66.131048_t_real,   -63.715044_t_real,   -60.214354_t_real &
       &,   -55.770869_t_real,   -50.600766_t_real,   -44.987313_t_real &
       &,   -39.220175_t_real,   -33.571398_t_real,   -28.289106_t_real &
       &,   -23.455372_t_real,   -19.072039_t_real,   -15.168446_t_real &
       &,   -11.873702_t_real,    -9.265493_t_real,    -7.253362_t_real &
       &,    -5.710175_t_real,    -4.526271_t_real,    -3.615874_t_real &
       &,    -2.916881_t_real,    -2.378933_t_real,    -1.961278_t_real &
       &,    -1.636680_t_real,    -1.389411_t_real,    -1.205919_t_real &
       &,    -1.069034_t_real,    -0.961829_t_real,    -0.872195_t_real &
       &,    -0.792820_t_real,    -0.719398_t_real,    -0.649334_t_real &
       &,    -0.581170_t_real,    -0.514360_t_real,    -0.449095_t_real &
       &,    -0.386103_t_real,    -0.326398_t_real,    -0.271037_t_real &
       &,    -0.220922_t_real,    -0.176673_t_real,    -0.138574_t_real &
       &,    -0.106581_t_real,    -0.080372_t_real,    -0.059416_t_real &
       &,    -0.043058_t_real,    -0.030587_t_real,    -0.021298_t_real &
       &,    -0.014535_t_real,    -0.009723_t_real/
  !!
  Data ncoeffrel( 69) / 50 /
  Data vcoeffrel(1:50, 69) /&
       &    -69.000000_t_real,   -68.932878_t_real,   -68.438661_t_real &
       &,   -67.086794_t_real,   -64.618690_t_real,   -61.047452_t_real &
       &,   -56.517972_t_real,   -51.249692_t_real,   -45.532058_t_real &
       &,   -39.658153_t_real,   -33.904171_t_real,   -28.521141_t_real &
       &,   -23.584043_t_real,   -19.105334_t_real,   -15.126658_t_real &
       &,   -11.797129_t_real,    -9.179750_t_real,    -7.169102_t_real &
       &,    -5.632016_t_real,    -4.456012_t_real,    -3.554964_t_real &
       &,    -2.865782_t_real,    -2.336749_t_real,    -1.926796_t_real &
       &,    -1.609148_t_real,    -1.368165_t_real,    -1.189628_t_real &
       &,    -1.055956_t_real,    -0.950579_t_real,    -0.861965_t_real &
       &,    -0.783190_t_real,    -0.710147_t_real,    -0.640351_t_real &
       &,    -0.572425_t_real,    -0.505883_t_real,    -0.440970_t_real &
       &,    -0.378439_t_real,    -0.319309_t_real,    -0.264621_t_real &
       &,    -0.215246_t_real,    -0.171767_t_real,    -0.134432_t_real &
       &,    -0.103165_t_real,    -0.077618_t_real,    -0.057247_t_real &
       &,    -0.041388_t_real,    -0.029329_t_real,    -0.020372_t_real &
       &,    -0.013869_t_real,    -0.009254_t_real/
  !!
  Data ncoeffrel( 70) / 50 /
  Data vcoeffrel(1:50, 70) /&
       &    -70.000000_t_real,   -69.931361_t_real,   -69.425317_t_real &
       &,   -68.041976_t_real,   -65.521316_t_real,   -61.878973_t_real &
       &,   -57.262803_t_real,   -51.895565_t_real,   -46.072674_t_real &
       &,   -40.090687_t_real,   -34.230021_t_real,   -28.744108_t_real &
       &,   -23.702367_t_real,   -19.127836_t_real,   -15.077383_t_real &
       &,   -11.717017_t_real,    -9.092758_t_real,    -7.084911_t_real &
       &,    -5.554679_t_real,    -4.387167_t_real,    -3.495875_t_real &
       &,    -2.816574_t_real,    -2.296307_t_real,    -1.893868_t_real &
       &,    -1.582992_t_real,    -1.348049_t_real,    -1.174154_t_real &
       &,    -1.043421_t_real,    -0.939698_t_real,    -0.852005_t_real &
       &,    -0.773773_t_real,    -0.701075_t_real,    -0.631528_t_real &
       &,    -0.563826_t_real,    -0.497549_t_real,    -0.432987_t_real &
       &,    -0.370918_t_real,    -0.312364_t_real,    -0.258346_t_real &
       &,    -0.209707_t_real,    -0.166991_t_real,    -0.130409_t_real &
       &,    -0.099855_t_real,    -0.074958_t_real,    -0.055158_t_real &
       &,    -0.039785_t_real,    -0.028127_t_real,    -0.019490_t_real &
       &,    -0.013237_t_real,    -0.008812_t_real/
  !!
  Data ncoeffrel( 71) / 50 /
  Data vcoeffrel(1:50, 71) /&
       &    -71.000000_t_real,   -70.929868_t_real,   -70.412107_t_real &
       &,   -68.997680_t_real,   -66.425525_t_real,   -62.714060_t_real &
       &,   -58.014412_t_real,   -52.553129_t_real,   -46.631859_t_real &
       &,   -40.551360_t_real,   -34.597021_t_real,   -29.024083_t_real &
       &,   -23.897371_t_real,   -19.250405_t_real,   -15.156823_t_real &
       &,   -11.792607_t_real,    -9.180051_t_real,    -7.184292_t_real &
       &,    -5.662178_t_real,    -4.496899_t_real,    -3.602071_t_real &
       &,    -2.913753_t_real,    -2.380882_t_real,    -1.966529_t_real &
       &,    -1.647723_t_real,    -1.407017_t_real,    -1.225069_t_real &
       &,    -1.082901_t_real,    -0.966447_t_real,    -0.866792_t_real &
       &,    -0.778317_t_real,    -0.697301_t_real,    -0.621316_t_real &
       &,    -0.549008_t_real,    -0.479929_t_real,    -0.414320_t_real &
       &,    -0.352831_t_real,    -0.296247_t_real,    -0.245260_t_real &
       &,    -0.200316_t_real,    -0.161549_t_real,    -0.128790_t_real &
       &,    -0.101613_t_real,    -0.079426_t_real,    -0.061552_t_real &
       &,    -0.047306_t_real,    -0.036052_t_real,    -0.027230_t_real &
       &,    -0.020367_t_real,    -0.015072_t_real/
  !!5d
  Data ncoeffrel( 72) / 50 /
  Data vcoeffrel(1:50, 72) /&
       &    -72.000000_t_real,   -71.928362_t_real,   -71.398743_t_real &
       &,   -69.952931_t_real,   -67.328999_t_real,   -63.548150_t_real &
       &,   -58.764784_t_real,   -53.209390_t_real,   -47.189746_t_real &
       &,   -41.011073_t_real,   -34.963986_t_real,   -29.304660_t_real &
       &,   -24.094776_t_real,   -19.377984_t_real,   -15.246480_t_real &
       &,   -11.880480_t_real,    -9.275877_t_real,    -7.284029_t_real &
       &,    -5.758845_t_real,    -4.583355_t_real,    -3.673485_t_real &
       &,    -2.967883_t_real,    -2.418924_t_real,    -1.992980_t_real &
       &,    -1.666785_t_real,    -1.419141_t_real,    -1.228588_t_real &
       &,    -1.077226_t_real,    -0.952559_t_real,    -0.846237_t_real &
       &,    -0.752468_t_real,    -0.667191_t_real,    -0.587765_t_real &
       &,    -0.512794_t_real,    -0.441891_t_real,    -0.375361_t_real &
       &,    -0.313867_t_real,    -0.258134_t_real,    -0.208724_t_real &
       &,    -0.165925_t_real,    -0.129706_t_real,    -0.099748_t_real &
       &,    -0.075508_t_real,    -0.056303_t_real,    -0.041381_t_real &
       &,    -0.029997_t_real,    -0.021458_t_real,    -0.015150_t_real &
       &,    -0.010559_t_real,    -0.007262_t_real/
  !!
  Data ncoeffrel( 73) / 50 /
  Data vcoeffrel(1:50, 73) /&
       &    -73.000000_t_real,   -72.926842_t_real,   -72.385218_t_real &
       &,   -70.907715_t_real,   -68.231715_t_real,   -64.381204_t_real &
       &,   -59.513847_t_real,   -53.864228_t_real,   -47.746138_t_real &
       &,   -41.469485_t_real,   -35.330356_t_real,   -29.584945_t_real &
       &,   -24.293342_t_real,   -19.509040_t_real,   -15.344092_t_real &
       &,   -11.977069_t_real,    -9.375969_t_real,    -7.380546_t_real &
       &,    -5.843402_t_real,    -4.649295_t_real,    -3.718348_t_real &
       &,    -2.992975_t_real,    -2.428685_t_real,    -1.992921_t_real &
       &,    -1.660129_t_real,    -1.406269_t_real,    -1.209481_t_real &
       &,    -1.052792_t_real,    -0.924148_t_real,    -0.814974_t_real &
       &,    -0.719076_t_real,    -0.632138_t_real,    -0.551487_t_real &
       &,    -0.475831_t_real,    -0.404918_t_real,    -0.339138_t_real &
       &,    -0.279152_t_real,    -0.225594_t_real,    -0.178879_t_real &
       &,    -0.139117_t_real,    -0.106099_t_real,    -0.079348_t_real &
       &,    -0.058198_t_real,    -0.041870_t_real,    -0.029557_t_real &
       &,    -0.020480_t_real,    -0.013934_t_real,    -0.009312_t_real &
       &,    -0.006116_t_real,    -0.003948_t_real/
  !!
  Data ncoeffrel( 74) / 50 /
  Data vcoeffrel(1:50, 74) /&
       &    -74.000000_t_real,   -73.925309_t_real,   -73.371526_t_real &
       &,   -71.862018_t_real,   -69.133645_t_real,   -65.213176_t_real &
       &,   -60.261524_t_real,   -54.517524_t_real,   -48.300853_t_real &
       &,   -41.926314_t_real,   -35.695693_t_real,   -29.864278_t_real &
       &,   -24.492160_t_real,   -19.642506_t_real,   -15.447891_t_real &
       &,   -12.079393_t_real,    -9.476696_t_real,    -7.470644_t_real &
       &,    -5.914164_t_real,    -4.695603_t_real,    -3.740656_t_real &
       &,    -2.995662_t_real,    -2.418036_t_real,    -1.974450_t_real &
       &,    -1.636650_t_real,    -1.378790_t_real,    -1.178924_t_real &
       &,    -1.020304_t_real,    -0.890669_t_real,    -0.781024_t_real &
       &,    -0.684872_t_real,    -0.597832_t_real,    -0.517335_t_real &
       &,    -0.442259_t_real,    -0.372480_t_real,    -0.308436_t_real &
       &,    -0.250740_t_real,    -0.199906_t_real,    -0.156192_t_real &
       &,    -0.119534_t_real,    -0.089572_t_real,    -0.065702_t_real &
       &,    -0.047167_t_real,    -0.033136_t_real,    -0.022780_t_real &
       &,    -0.015324_t_real,    -0.010087_t_real,    -0.006497_t_real &
       &,    -0.004096_t_real,    -0.002527_t_real/
  !!
  Data ncoeffrel( 75) / 50 /
  Data vcoeffrel(1:50, 75) /&
       &    -75.000000_t_real,   -74.923763_t_real,   -74.357676_t_real &
       &,   -72.815873_t_real,   -70.034879_t_real,   -66.044249_t_real &
       &,   -61.008131_t_real,   -55.169773_t_real,   -48.854605_t_real &
       &,   -42.382506_t_real,   -36.061218_t_real,   -30.144252_t_real &
       &,   -24.693216_t_real,   -19.780994_t_real,   -15.560659_t_real &
       &,   -12.190301_t_real,    -9.581835_t_real,    -7.559866_t_real &
       &,    -5.978867_t_real,    -4.732286_t_real,    -3.752095_t_real &
       &,    -2.988141_t_real,    -2.398589_t_real,    -1.948407_t_real &
       &,    -1.606822_t_real,    -1.346652_t_real,    -1.145655_t_real &
       &,    -0.986841_t_real,    -0.857526_t_real,    -0.748344_t_real &
       &,    -0.652651_t_real,    -0.566133_t_real,    -0.486392_t_real &
       &,    -0.412471_t_real,    -0.344343_t_real,    -0.282445_t_real &
       &,    -0.227305_t_real,    -0.179301_t_real,    -0.138529_t_real &
       &,    -0.104774_t_real,    -0.077542_t_real,    -0.056140_t_real &
       &,    -0.039752_t_real,    -0.027525_t_real,    -0.018635_t_real &
       &,    -0.012335_t_real,    -0.007982_t_real,    -0.005049_t_real &
       &,    -0.003123_t_real,    -0.001888_t_real/
  !!
  Data ncoeffrel( 76) / 50 /
  Data vcoeffrel(1:50, 76) /&
       &    -76.000000_t_real,   -75.922202_t_real,   -75.343649_t_real &
       &,   -73.769223_t_real,   -70.935295_t_real,   -66.874191_t_real &
       &,   -61.753268_t_real,   -55.820348_t_real,   -49.406484_t_real &
       &,   -42.836797_t_real,   -36.425185_t_real,   -30.422540_t_real &
       &,   -24.893435_t_real,   -19.920724_t_real,   -15.677132_t_real &
       &,   -12.302578_t_real,    -9.682678_t_real,    -7.638694_t_real &
       &,    -6.027967_t_real,    -4.750675_t_real,    -3.745404_t_real &
       &,    -2.964576_t_real,    -2.365763_t_real,    -1.911507_t_real &
       &,    -1.568653_t_real,    -1.308762_t_real,    -1.108995_t_real &
       &,    -0.951853_t_real,    -0.824207_t_real,    -0.716462_t_real &
       &,    -0.621986_t_real,    -0.536628_t_real,    -0.458197_t_real &
       &,    -0.385890_t_real,    -0.319746_t_real,    -0.260179_t_real &
       &,    -0.207625_t_real,    -0.162334_t_real,    -0.124265_t_real &
       &,    -0.093081_t_real,    -0.068196_t_real,    -0.048855_t_real &
       &,    -0.034214_t_real,    -0.023417_t_real,    -0.015662_t_real &
       &,    -0.010235_t_real,    -0.006534_t_real,    -0.004075_t_real &
       &,    -0.002482_t_real,    -0.001476_t_real/
  !!
  Data ncoeffrel( 77) / 50 /
  Data vcoeffrel(1:50, 77) /&
       &    -77.000000_t_real,   -76.920626_t_real,   -76.329441_t_real &
       &,   -74.722059_t_real,   -71.834874_t_real,   -67.702978_t_real &
       &,   -62.496897_t_real,   -56.469188_t_real,   -49.956410_t_real &
       &,   -43.289067_t_real,   -36.787382_t_real,   -30.698873_t_real &
       &,   -25.092401_t_real,   -20.061277_t_real,   -15.796227_t_real &
       &,   -12.414399_t_real,    -9.777426_t_real,    -7.705963_t_real &
       &,    -6.061407_t_real,    -4.752108_t_real,    -3.723074_t_real &
       &,    -2.928075_t_real,    -2.322918_t_real,    -1.867261_t_real &
       &,    -1.525604_t_real,    -1.268179_t_real,    -1.071365_t_real &
       &,    -0.917104_t_real,    -0.791937_t_real,    -0.686199_t_real &
       &,    -0.593394_t_real,    -0.509591_t_real,    -0.432807_t_real &
       &,    -0.362372_t_real,    -0.298365_t_real,    -0.241160_t_real &
       &,    -0.191105_t_real,    -0.148334_t_real,    -0.112694_t_real &
       &,    -0.083757_t_real,    -0.060871_t_real,    -0.043245_t_real &
       &,    -0.030024_t_real,    -0.020367_t_real,    -0.013496_t_real &
       &,    -0.008736_t_real,    -0.005522_t_real,    -0.003408_t_real &
       &,    -0.002054_t_real,    -0.001208_t_real/
  !!
  Data ncoeffrel( 78) / 50 /
  Data vcoeffrel(1:50, 78) /&
       &    -78.000000_t_real,   -77.919019_t_real,   -77.314922_t_real &
       &,   -75.673949_t_real,   -72.732584_t_real,   -68.528555_t_real &
       &,   -63.235385_t_real,   -57.110401_t_real,   -50.495554_t_real &
       &,   -43.726838_t_real,   -37.130809_t_real,   -30.950732_t_real &
       &,   -25.260760_t_real,   -20.165433_t_real,   -15.871212_t_real &
       &,   -12.468060_t_real,    -9.795342_t_real,    -7.676312_t_real &
       &,    -5.980264_t_real,    -4.628369_t_real,    -3.574559_t_real &
       &,    -2.772989_t_real,    -2.174306_t_real,    -1.731933_t_real &
       &,    -1.405873_t_real,    -1.163825_t_real,    -0.980883_t_real &
       &,    -0.838532_t_real,    -0.723456_t_real,    -0.626472_t_real &
       &,    -0.541603_t_real,    -0.465297_t_real,    -0.395722_t_real &
       &,    -0.332177_t_real,    -0.274594_t_real,    -0.223166_t_real &
       &,    -0.178093_t_real,    -0.139426_t_real,    -0.107005_t_real &
       &,    -0.080461_t_real,    -0.059251_t_real,    -0.042714_t_real &
       &,    -0.030136_t_real,    -0.020803_t_real,    -0.014048_t_real &
       &,    -0.009278_t_real,    -0.005992_t_real,    -0.003784_t_real &
       &,    -0.002336_t_real,    -0.001409_t_real/
  !!
  Data ncoeffrel( 79) / 50 /
  Data vcoeffrel(1:50, 79) /&
       &    -79.000000_t_real,   -78.917411_t_real,   -78.300325_t_real &
       &,   -76.625691_t_real,   -73.630370_t_real,   -69.354822_t_real &
       &,   -63.975646_t_real,   -57.755211_t_real,   -51.040771_t_real &
       &,   -44.173935_t_real,   -37.487764_t_real,   -31.220983_t_real &
       &,   -25.454241_t_real,   -20.304086_t_real,   -15.989458_t_real &
       &,   -12.570443_t_real,    -9.869154_t_real,    -7.712949_t_real &
       &,    -5.977620_t_real,    -4.594856_t_real,    -3.523182_t_real &
       &,    -2.714998_t_real,    -2.117083_t_real,    -1.679246_t_real &
       &,    -1.358970_t_real,    -1.122521_t_real,    -0.944335_t_real &
       &,    -0.805719_t_real,    -0.693477_t_real,    -0.598687_t_real &
       &,    -0.515670_t_real,    -0.441125_t_real,    -0.373391_t_real &
       &,    -0.311845_t_real,    -0.256419_t_real,    -0.207254_t_real &
       &,    -0.164467_t_real,    -0.128021_t_real,    -0.097679_t_real &
       &,    -0.073011_t_real,    -0.053438_t_real,    -0.038285_t_real &
       &,    -0.026840_t_real,    -0.018408_t_real,    -0.012348_t_real &
       &,    -0.008100_t_real,    -0.005195_t_real,    -0.003256_t_real &
       &,    -0.001995_t_real,    -0.001194_t_real/
  !!
  Data ncoeffrel( 80) / 50 /
  Data vcoeffrel(1:50, 80) /&
       &    -80.000000_t_real,   -79.915804_t_real,   -79.285671_t_real &
       &,   -77.577364_t_real,   -74.528437_t_real,   -70.182198_t_real &
       &,   -64.718427_t_real,   -58.404815_t_real,   -51.593845_t_real &
       &,   -44.632873_t_real,   -37.861617_t_real,   -31.514166_t_real &
       &,   -25.678700_t_real,   -20.484588_t_real,   -16.159417_t_real &
       &,   -12.732028_t_real,   -10.012468_t_real,    -7.831930_t_real &
       &,    -6.071118_t_real,    -4.668903_t_real,    -3.583875_t_real &
       &,    -2.765567_t_real,    -2.159120_t_real,    -1.713920_t_real &
       &,    -1.387417_t_real,    -1.145823_t_real,    -0.963373_t_real &
       &,    -0.821042_t_real,    -0.705290_t_real,    -0.606964_t_real &
       &,    -0.520331_t_real,    -0.442198_t_real,    -0.371107_t_real &
       &,    -0.306659_t_real,    -0.248969_t_real,    -0.198279_t_real &
       &,    -0.154717_t_real,    -0.118179_t_real,    -0.088305_t_real &
       &,    -0.064510_t_real,    -0.046055_t_real,    -0.032120_t_real &
       &,    -0.021878_t_real,    -0.014550_t_real,    -0.009446_t_real &
       &,    -0.005986_t_real,    -0.003701_t_real,    -0.002233_t_real &
       &,    -0.001314_t_real,    -0.000754_t_real/
  !!6p
  Data ncoeffrel( 81) / 50 /
  Data vcoeffrel(1:50, 81) /&
       &    -81.000000_t_real,   -80.914195_t_real,   -80.270930_t_real &
       &,   -78.528869_t_real,   -75.426525_t_real,   -71.010131_t_real &
       &,   -65.462694_t_real,   -59.057455_t_real,   -52.152115_t_real &
       &,   -45.099962_t_real,   -38.247403_t_real,   -31.823795_t_real &
       &,   -25.925595_t_real,   -20.696038_t_real,   -16.367259_t_real &
       &,   -12.935821_t_real,   -10.203503_t_real,    -8.005848_t_real &
       &,    -6.229715_t_real,    -4.820044_t_real,    -3.732665_t_real &
       &,    -2.911921_t_real,    -2.300021_t_real,    -1.845857_t_real &
       &,    -1.507872_t_real,    -1.254015_t_real,    -1.060441_t_real &
       &,    -0.909798_t_real,    -0.789640_t_real,    -0.691167_t_real &
       &,    -0.608223_t_real,    -0.536531_t_real,    -0.473128_t_real &
       &,    -0.415982_t_real,    -0.363754_t_real,    -0.315633_t_real &
       &,    -0.271216_t_real,    -0.230387_t_real,    -0.193195_t_real &
       &,    -0.159754_t_real,    -0.130153_t_real,    -0.104408_t_real &
       &,    -0.082431_t_real,    -0.064027_t_real,    -0.048917_t_real &
       &,    -0.036752_t_real,    -0.027149_t_real,    -0.019717_t_real &
       &,    -0.014076_t_real,    -0.009876_t_real/
  !!
  Data ncoeffrel( 82) / 50 /
  Data vcoeffrel(1:50, 82) /&
       &    -82.000000_t_real,   -81.912571_t_real,   -81.255994_t_real &
       &,   -79.479853_t_real,   -76.323824_t_real,   -71.837072_t_real &
       &,   -66.205810_t_real,   -59.708967_t_real,   -52.709367_t_real &
       &,   -45.566311_t_real,   -38.632797_t_real,   -32.133491_t_real &
       &,   -26.173656_t_real,   -20.911206_t_real,   -16.578276_t_real &
       &,   -13.139351_t_real,   -10.391581_t_real,    -8.174165_t_real &
       &,    -6.380442_t_real,    -4.959357_t_real,    -3.862653_t_real &
       &,    -3.030876_t_real,    -2.405710_t_real,    -1.937181_t_real &
       &,    -1.585090_t_real,    -1.318500_t_real,    -1.114197_t_real &
       &,    -0.954850_t_real,    -0.827528_t_real,    -0.722672_t_real &
       &,    -0.633390_t_real,    -0.554914_t_real,    -0.484150_t_real &
       &,    -0.419283_t_real,    -0.359426_t_real,    -0.304312_t_real &
       &,    -0.254023_t_real,    -0.208778_t_real,    -0.168775_t_real &
       &,    -0.134093_t_real,    -0.104646_t_real,    -0.080179_t_real &
       &,    -0.060295_t_real,    -0.044490_t_real,    -0.032204_t_real &
       &,    -0.022865_t_real,    -0.015920_t_real,    -0.010870_t_real &
       &,    -0.007276_t_real,    -0.004774_t_real/
  !!
  Data ncoeffrel( 83) / 50 /
  Data vcoeffrel(1:50, 83) /&
       &    -83.000000_t_real,   -82.910937_t_real,   -82.240902_t_real &
       &,   -80.430458_t_real,   -77.220678_t_real,   -72.663686_t_real &
       &,   -66.948907_t_real,   -60.361127_t_real,   -53.268249_t_real &
       &,   -46.035692_t_real,   -39.022930_t_real,   -32.450136_t_real &
       &,   -26.431795_t_real,   -21.141245_t_real,   -16.806020_t_real &
       &,   -13.359465_t_real,   -10.597137_t_real,    -8.361508_t_real &
       &,    -6.552902_t_real,    -5.122094_t_real,    -4.015549_t_real &
       &,    -3.170802_t_real,    -2.530011_t_real,    -2.044549_t_real &
       &,    -1.675468_t_real,    -1.393022_t_real,    -1.174886_t_real &
       &,    -1.004068_t_real,    -0.867467_t_real,    -0.755081_t_real &
       &,    -0.659524_t_real,    -0.575649_t_real,    -0.500144_t_real &
       &,    -0.431128_t_real,    -0.367738_t_real,    -0.309753_t_real &
       &,    -0.257279_t_real,    -0.210502_t_real,    -0.169540_t_real &
       &,    -0.134352_t_real,    -0.104720_t_real,    -0.080266_t_real &
       &,    -0.060487_t_real,    -0.044808_t_real,    -0.032623_t_real &
       &,    -0.023340_t_real,    -0.016406_t_real,    -0.011328_t_real &
       &,    -0.007681_t_real,    -0.005113_t_real/
  !!
  Data ncoeffrel( 84) / 50 /
  Data vcoeffrel(1:50, 84) /&
       &    -84.000000_t_real,   -83.909287_t_real,   -83.225607_t_real &
       &,   -81.380535_t_real,   -78.116754_t_real,   -73.489347_t_real &
       &,   -67.690928_t_real,   -61.012268_t_real,   -53.826272_t_real &
       &,   -46.504572_t_real,   -39.412889_t_real,   -32.767233_t_real &
       &,   -26.691604_t_real,   -21.375229_t_real,   -17.036379_t_real &
       &,   -13.579146_t_real,   -10.799839_t_real,    -8.543624_t_real &
       &,    -6.717781_t_real,    -5.272721_t_real,    -4.149961_t_real &
       &,    -3.286309_t_real,    -2.625624_t_real,    -2.120429_t_real &
       &,    -1.732831_t_real,    -1.434279_t_real,    -1.203065_t_real &
       &,    -1.021982_t_real,    -0.877222_t_real,    -0.758015_t_real &
       &,    -0.656436_t_real,    -0.567102_t_real,    -0.486723_t_real &
       &,    -0.413580_t_real,    -0.347002_t_real,    -0.286904_t_real &
       &,    -0.233428_t_real,    -0.186698_t_real,    -0.146682_t_real &
       &,    -0.113146_t_real,    -0.085652_t_real,    -0.063611_t_real &
       &,    -0.046335_t_real,    -0.033093_t_real,    -0.023171_t_real &
       &,    -0.015901_t_real,    -0.010693_t_real,    -0.007045_t_real &
       &,    -0.004546_t_real,    -0.002873_t_real/
  !!
  Data ncoeffrel( 85) / 50 /
  Data vcoeffrel(1:50, 85) /&
       &    -85.000000_t_real,   -84.907622_t_real,   -84.210105_t_real &
       &,   -82.330076_t_real,   -79.012043_t_real,   -74.314050_t_real &
       &,   -68.431877_t_real,   -61.662389_t_real,   -54.383436_t_real &
       &,   -46.972963_t_real,   -39.802643_t_real,   -33.084777_t_real &
       &,   -26.953110_t_real,   -21.612924_t_real,   -17.268740_t_real &
       &,   -13.797994_t_real,   -10.999296_t_real,    -8.720187_t_real &
       &,    -6.874499_t_real,    -5.410540_t_real,    -4.266246_t_real &
       &,    -3.379771_t_real,    -2.696630_t_real,    -2.170018_t_real &
       &,    -1.763506_t_real,    -1.449924_t_real,    -1.207695_t_real &
       &,    -1.018711_t_real,    -0.867977_t_real,    -0.743805_t_real &
       &,    -0.637810_t_real,    -0.544549_t_real,    -0.460905_t_real &
       &,    -0.385400_t_real,    -0.317542_t_real,    -0.257309_t_real &
       &,    -0.204778_t_real,    -0.159904_t_real,    -0.122425_t_real &
       &,    -0.091850_t_real,    -0.067497_t_real,    -0.048567_t_real &
       &,    -0.034207_t_real,    -0.023577_t_real,    -0.015899_t_real &
       &,    -0.010487_t_real,    -0.006765_t_real,    -0.004267_t_real &
       &,    -0.002631_t_real,    -0.001586_t_real/
  !!
  Data ncoeffrel( 86) / 50 /
  Data vcoeffrel(1:50, 86) /&
       &    -86.000000_t_real,   -85.905940_t_real,   -85.194387_t_real &
       &,   -83.279069_t_real,   -79.906532_t_real,   -75.137780_t_real &
       &,   -69.171743_t_real,   -62.311465_t_real,   -54.939704_t_real &
       &,   -47.440825_t_real,   -40.192091_t_real,   -33.402662_t_real &
       &,   -27.216220_t_real,   -21.853917_t_real,   -17.502346_t_real &
       &,   -14.015440_t_real,   -11.194865_t_real,    -8.890570_t_real &
       &,    -7.022124_t_real,    -5.534693_t_real,    -4.364721_t_real &
       &,    -3.452886_t_real,    -2.745472_t_real,    -2.196602_t_real &
       &,    -1.772104_t_real,    -1.445902_t_real,    -1.195632_t_real &
       &,    -1.001537_t_real,    -0.847136_t_real,    -0.719865_t_real &
       &,    -0.611071_t_real,    -0.515433_t_real,    -0.430108_t_real &
       &,    -0.353859_t_real,    -0.286314_t_real,    -0.227424_t_real &
       &,    -0.177113_t_real,    -0.135107_t_real,    -0.100881_t_real &
       &,    -0.073688_t_real,    -0.052632_t_real,    -0.036746_t_real &
       &,    -0.025070_t_real,    -0.016709_t_real,    -0.010877_t_real &
       &,    -0.006915_t_real,    -0.004292_t_real,    -0.002600_t_real &
       &,    -0.001537_t_real,    -0.000887_t_real/
  !!7s
  Data ncoeffrel( 87) / 50 /
  Data vcoeffrel(1:50, 87) /&
       &    -87.000000_t_real,   -86.904267_t_real,   -86.178657_t_real &
       &,   -84.228214_t_real,   -80.801907_t_real,   -75.963851_t_real &
       &,   -69.916250_t_real,   -62.968552_t_real,   -55.508572_t_real &
       &,   -47.927375_t_real,   -40.607521_t_real,   -33.755879_t_real &
       &,   -27.526387_t_real,   -22.155609_t_real,   -17.808673_t_real &
       &,   -14.319687_t_real,   -11.493232_t_real,    -9.182168_t_real &
       &,    -7.311271_t_real,    -5.823127_t_real,    -4.653941_t_real &
       &,    -3.743599_t_real,    -3.034882_t_real,    -2.480434_t_real &
       &,    -2.045469_t_real,    -1.703080_t_real,    -1.431877_t_real &
       &,    -1.216423_t_real,    -1.047063_t_real,    -0.917453_t_real &
       &,    -0.820954_t_real,    -0.748939_t_real,    -0.692261_t_real &
       &,    -0.643445_t_real,    -0.597515_t_real,    -0.551672_t_real &
       &,    -0.504674_t_real,    -0.456326_t_real,    -0.407111_t_real &
       &,    -0.357918_t_real,    -0.309820_t_real,    -0.263903_t_real &
       &,    -0.221119_t_real,    -0.182207_t_real,    -0.147645_t_real &
       &,    -0.117644_t_real,    -0.092177_t_real,    -0.071020_t_real &
       &,    -0.053810_t_real,    -0.040092_t_real/
  !!
  Data ncoeffrel( 88) / 50 /
  Data vcoeffrel(1:50, 88) /&
       &    -88.000000_t_real,   -87.902578_t_real,   -87.162700_t_real &
       &,   -85.176794_t_real,   -81.696480_t_real,   -76.788974_t_real &
       &,   -70.659732_t_real,   -63.624660_t_real,   -56.076627_t_real &
       &,   -48.413522_t_real,   -41.022720_t_real,   -34.109548_t_real &
       &,   -27.838374_t_real,   -22.460153_t_real,   -18.115428_t_real &
       &,   -14.621997_t_real,   -11.786761_t_real,    -9.466209_t_real &
       &,    -7.589335_t_real,    -6.096526_t_real,    -4.923681_t_real &
       &,    -4.007331_t_real,    -3.286469_t_real,    -2.713419_t_real &
       &,    -2.254430_t_real,    -1.885697_t_real,    -1.591873_t_real &
       &,    -1.363128_t_real,    -1.189386_t_real,    -1.057292_t_real &
       &,    -0.952899_t_real,    -0.865194_t_real,    -0.786863_t_real &
       &,    -0.713434_t_real,    -0.642377_t_real,    -0.572539_t_real &
       &,    -0.503795_t_real,    -0.436756_t_real,    -0.372470_t_real &
       &,    -0.312131_t_real,    -0.256838_t_real,    -0.207424_t_real &
       &,    -0.164367_t_real,    -0.127777_t_real,    -0.097441_t_real &
       &,    -0.072890_t_real,    -0.053483_t_real,    -0.038494_t_real &
       &,    -0.027176_t_real,    -0.018820_t_real/
  !!6d
  Data ncoeffrel( 89) / 50 /
  Data vcoeffrel(1:50, 89) /&
       &    -89.000000_t_real,   -88.900865_t_real,   -88.146461_t_real &
       &,   -86.124637_t_real,   -82.589846_t_real,   -77.612349_t_real &
       &,   -71.400779_t_real,   -64.277508_t_real,   -56.640479_t_real &
       &,   -48.894505_t_real,   -41.431169_t_real,   -34.454996_t_real &
       &,   -28.140992_t_real,   -22.753074_t_real,   -18.404522_t_real &
       &,   -14.900038_t_real,   -12.048495_t_real,    -9.711040_t_real &
       &,    -7.819228_t_real,    -6.310315_t_real,    -5.119205_t_real &
       &,    -4.179701_t_real,    -3.430584_t_real,    -2.827688_t_real &
       &,    -2.341432_t_real,    -1.951836_t_real,    -1.645017_t_real &
       &,    -1.408072_t_real,    -1.225761_t_real,    -1.082358_t_real &
       &,    -0.964921_t_real,    -0.864231_t_real,    -0.774105_t_real &
       &,    -0.690554_t_real,    -0.611254_t_real,    -0.535199_t_real &
       &,    -0.462383_t_real,    -0.393441_t_real,    -0.329309_t_real &
       &,    -0.270919_t_real,    -0.218986_t_real,    -0.173897_t_real &
       &,    -0.135681_t_real,    -0.104047_t_real,    -0.078454_t_real &
       &,    -0.058198_t_real,    -0.042502_t_real,    -0.030577_t_real &
       &,    -0.021686_t_real,    -0.015172_t_real/
  !!5f
  Data ncoeffrel( 90) / 50 /
  Data vcoeffrel(1:50, 90) /&
       &    -90.000000_t_real,   -89.899131_t_real,   -89.129958_t_real &
       &,   -87.071821_t_real,   -83.482215_t_real,   -78.434410_t_real &
       &,   -72.140178_t_real,   -64.928371_t_real,   -57.202032_t_real &
       &,   -49.373031_t_real,   -41.836551_t_real,   -34.797128_t_real &
       &,   -28.440664_t_real,   -23.042172_t_real,   -18.685760_t_real &
       &,   -15.166237_t_real,   -12.293860_t_real,    -9.935129_t_real &
       &,    -8.022576_t_real,    -6.490648_t_real,    -5.273480_t_real &
       &,    -4.302914_t_real,    -3.520035_t_real,    -2.885854_t_real &
       &,    -2.374960_t_real,    -1.969016_t_real,    -1.652175_t_real &
       &,    -1.407494_t_real,    -1.217221_t_real,    -1.065610_t_real &
       &,    -0.940491_t_real,    -0.833068_t_real,    -0.737220_t_real &
       &,    -0.648970_t_real,    -0.566100_t_real,    -0.487778_t_real &
       &,    -0.414139_t_real,    -0.345852_t_real,    -0.283743_t_real &
       &,    -0.228512_t_real,    -0.180565_t_real,    -0.139954_t_real &
       &,    -0.106395_t_real,    -0.079330_t_real,    -0.058020_t_real &
       &,    -0.041630_t_real,    -0.029310_t_real,    -0.020254_t_real &
       &,    -0.013741_t_real,    -0.009155_t_real/
  !!
  Data ncoeffrel( 91) / 50 /
  Data vcoeffrel(1:50, 91) /&
       &    -91.000000_t_real,   -90.897324_t_real,   -90.112774_t_real &
       &,   -88.016949_t_real,   -84.370271_t_real,   -79.248598_t_real &
       &,   -72.866349_t_real,   -65.558235_t_real,   -57.731616_t_real &
       &,   -49.804956_t_real,   -42.177126_t_real,   -35.054476_t_real &
       &,   -28.633845_t_real,   -23.198175_t_real,   -18.799355_t_real &
       &,   -15.222322_t_real,   -12.280784_t_real,    -9.855063_t_real &
       &,    -7.890223_t_real,    -6.325424_t_real,    -5.092589_t_real &
       &,    -4.120724_t_real,    -3.349777_t_real,    -2.736582_t_real &
       &,    -2.249779_t_real,    -1.866750_t_real,    -1.570296_t_real &
       &,    -1.343779_t_real,    -1.169585_t_real,    -1.031688_t_real &
       &,    -0.917815_t_real,    -0.819427_t_real,    -0.730826_t_real &
       &,    -0.648416_t_real,    -0.570230_t_real,    -0.495567_t_real &
       &,    -0.424626_t_real,    -0.358129_t_real,    -0.296977_t_real &
       &,    -0.241976_t_real,    -0.193666_t_real,    -0.152246_t_real &
       &,    -0.117576_t_real,    -0.089230_t_real,    -0.066577_t_real &
       &,    -0.048866_t_real,    -0.035306_t_real,    -0.025127_t_real &
       &,    -0.017628_t_real,    -0.012197_t_real/
  !!
  Data ncoeffrel( 92) / 50 /
  Data vcoeffrel(1:50, 92) /&
       &    -92.000000_t_real,   -91.895517_t_real,   -91.095482_t_real &
       &,   -88.961974_t_real,   -85.258696_t_real,   -80.064208_t_real &
       &,   -73.595722_t_real,   -66.194012_t_real,   -58.271089_t_real &
       &,   -50.252432_t_real,   -42.539934_t_real,   -35.342200_t_real &
       &,   -28.867428_t_real,   -23.404058_t_real,   -18.971755_t_real &
       &,   -15.349861_t_real,   -12.355706_t_real,    -9.882312_t_real &
       &,    -7.881395_t_real,    -6.292174_t_real,    -5.043567_t_real &
       &,    -4.062454_t_real,    -3.288636_t_real,    -2.677710_t_real &
       &,    -2.196437_t_real,    -1.820651_t_real,    -1.531761_t_real &
       &,    -1.311886_t_real,    -1.142817_t_real,    -1.008616_t_real &
       &,    -0.897354_t_real,    -0.800817_t_real,    -0.713568_t_real &
       &,    -0.632223_t_real,    -0.554994_t_real,    -0.481312_t_real &
       &,    -0.411457_t_real,    -0.346178_t_real,    -0.286356_t_real &
       &,    -0.232753_t_real,    -0.185848_t_real,    -0.145783_t_real &
       &,    -0.112367_t_real,    -0.085138_t_real,    -0.063446_t_real &
       &,    -0.046532_t_real,    -0.033612_t_real,    -0.023931_t_real &
       &,    -0.016806_t_real,    -0.011647_t_real/
  !!
  Data ncoeffrel( 93) / 50 /
  Data vcoeffrel(1:50, 93) /&
       &    -93.000000_t_real,   -92.893685_t_real,   -92.077887_t_real &
       &,   -89.906258_t_real,   -86.145992_t_real,   -80.878287_t_real &
       &,   -74.323096_t_real,   -66.827181_t_real,   -58.807191_t_real &
       &,   -50.695781_t_real,   -42.897469_t_real,   -35.623933_t_real &
       &,   -29.095042_t_real,   -23.601639_t_real,   -19.131127_t_real &
       &,   -15.459864_t_real,   -12.409969_t_real,    -9.888727_t_real &
       &,    -7.853778_t_real,    -6.243324_t_real,    -4.982626_t_real &
       &,    -3.996472_t_real,    -3.223742_t_real,    -2.618075_t_real &
       &,    -2.144252_t_real,    -1.776751_t_real,    -1.495840_t_real &
       &,    -1.282672_t_real,    -1.118662_t_real,    -0.988064_t_real &
       &,    -0.879329_t_real,    -0.784578_t_real,    -0.698639_t_real &
       &,    -0.618340_t_real,    -0.542059_t_real,    -0.469346_t_real &
       &,    -0.400545_t_real,    -0.336422_t_real,    -0.277836_t_real &
       &,    -0.225505_t_real,    -0.179854_t_real,    -0.140973_t_real &
       &,    -0.108629_t_real,    -0.082334_t_real,    -0.061421_t_real &
       &,    -0.045133_t_real,    -0.032693_t_real,    -0.023364_t_real &
       &,    -0.016483_t_real,    -0.011486_t_real/
  !!
  Data ncoeffrel( 94) / 50 /
  Data vcoeffrel(1:50, 94) /&
       &    -94.000000_t_real,   -93.891803_t_real,   -93.059786_t_real &
       &,   -90.849133_t_real,   -87.030581_t_real,   -81.687721_t_real &
       &,   -75.042996_t_real,   -67.448797_t_real,   -59.326091_t_real &
       &,   -51.114663_t_real,   -43.221551_t_real,   -35.862470_t_real &
       &,   -29.269098_t_real,   -23.730902_t_real,   -19.202768_t_real &
       &,   -15.459714_t_real,   -12.331542_t_real,    -9.744238_t_real &
       &,    -7.664616_t_real,    -6.030698_t_real,    -4.764071_t_real &
       &,    -3.787014_t_real,    -3.034854_t_real,    -2.455583_t_real &
       &,    -2.008404_t_real,    -1.664289_t_real,    -1.402981_t_real &
       &,    -1.206970_t_real,    -1.058630_t_real,    -0.942132_t_real &
       &,    -0.845582_t_real,    -0.761018_t_real,    -0.683422_t_real &
       &,    -0.609841_t_real,    -0.538839_t_real,    -0.470096_t_real &
       &,    -0.404064_t_real,    -0.341624_t_real,    -0.283787_t_real &
       &,    -0.231449_t_real,    -0.185237_t_real,    -0.145442_t_real &
       &,    -0.112018_t_real,    -0.084627_t_real,    -0.062718_t_real &
       &,    -0.045606_t_real,    -0.032548_t_real,    -0.022809_t_real &
       &,    -0.015704_t_real,    -0.010632_t_real/
  !!
  Data ncoeffrel( 95) / 50 /
  Data vcoeffrel(1:50, 95) /&
       &    -95.000000_t_real,   -94.889921_t_real,   -94.041562_t_real &
       &,   -91.791916_t_real,   -87.915639_t_real,   -82.498827_t_real &
       &,   -75.766583_t_real,   -68.077097_t_real,   -59.855994_t_real &
       &,   -51.550593_t_real,   -43.569797_t_real,   -36.133816_t_real &
       &,   -29.486612_t_real,   -23.913339_t_real,   -19.338441_t_real &
       &,   -15.538307_t_real,   -12.350607_t_real,    -9.717391_t_real &
       &,    -7.608958_t_real,    -5.960123_t_real,    -4.688232_t_real &
       &,    -3.712994_t_real,    -2.967373_t_real,    -2.396761_t_real &
       &,    -1.958679_t_real,    -1.623353_t_real,    -1.369980_t_real &
       &,    -1.180458_t_real,    -1.036917_t_real,    -0.923758_t_real &
       &,    -0.829490_t_real,    -0.746502_t_real,    -0.670031_t_real &
       &,    -0.597321_t_real,    -0.527078_t_real,    -0.459087_t_real &
       &,    -0.393863_t_real,    -0.332311_t_real,    -0.275434_t_real &
       &,    -0.224102_t_real,    -0.178904_t_real,    -0.140094_t_real &
       &,    -0.107592_t_real,    -0.081037_t_real,    -0.059864_t_real &
       &,    -0.043382_t_real,    -0.030849_t_real,    -0.021539_t_real &
       &,    -0.014777_t_real,    -0.009974_t_real/
  !!
  Data ncoeffrel( 96) / 50 /
  Data vcoeffrel(1:50, 96) /&
       &    -96.000000_t_real,   -95.888037_t_real,   -95.023213_t_real &
       &,   -92.734624_t_real,   -88.801231_t_real,   -83.311750_t_real &
       &,   -76.494132_t_real,   -68.712524_t_real,   -60.397577_t_real &
       &,   -52.004563_t_real,   -43.943659_t_real,   -36.440054_t_real &
       &,   -29.750318_t_real,   -24.152202_t_real,   -19.542625_t_real &
       &,   -15.701515_t_real,   -12.474687_t_real,    -9.816775_t_real &
       &,    -7.695928_t_real,    -6.040918_t_real,    -4.763988_t_real &
       &,    -3.782395_t_real,    -3.028391_t_real,    -2.448234_t_real &
       &,    -2.001814_t_real,    -1.660967_t_real,    -1.403637_t_real &
       &,    -1.209130_t_real,    -1.058616_t_real,    -0.937352_t_real &
       &,    -0.835024_t_real,    -0.744758_t_real,    -0.662136_t_real &
       &,    -0.584567_t_real,    -0.510858_t_real,    -0.440838_t_real &
       &,    -0.374987_t_real,    -0.314075_t_real,    -0.258878_t_real &
       &,    -0.209971_t_real,    -0.167627_t_real,    -0.131793_t_real &
       &,    -0.102127_t_real,    -0.078071_t_real,    -0.058931_t_real &
       &,    -0.043964_t_real,    -0.032437_t_real,    -0.023678_t_real &
       &,    -0.017101_t_real,    -0.012218_t_real/
  !!
  Data ncoeffrel( 97) / 50 /
  Data vcoeffrel(1:50, 97) /&
       &    -97.000000_t_real,   -96.886074_t_real,   -96.004113_t_real &
       &,   -93.675158_t_real,   -89.682365_t_real,   -84.116617_t_real &
       &,   -77.208237_t_real,   -69.326664_t_real,   -60.906939_t_real &
       &,   -52.412015_t_real,   -44.253569_t_real,   -36.662674_t_real &
       &,   -29.908366_t_real,   -24.256632_t_real,   -19.576947_t_real &
       &,   -15.653193_t_real,   -12.344540_t_real,    -9.625157_t_real &
       &,    -7.468033_t_real,    -5.798877_t_real,    -4.525746_t_real &
       &,    -3.562108_t_real,    -2.834945_t_real,    -2.284542_t_real &
       &,    -1.865852_t_real,    -1.548264_t_real,    -1.310257_t_real &
       &,    -1.132888_t_real,    -0.998125_t_real,    -0.890983_t_real &
       &,    -0.800789_t_real,    -0.720598_t_real,    -0.646130_t_real &
       &,    -0.574982_t_real,    -0.506125_t_real,    -0.439523_t_real &
       &,    -0.375796_t_real,    -0.315883_t_real,    -0.260767_t_real &
       &,    -0.211261_t_real,    -0.167888_t_real,    -0.130832_t_real &
       &,    -0.099956_t_real,    -0.074858_t_real,    -0.054949_t_real &
       &,    -0.039532_t_real,    -0.027874_t_real,    -0.019262_t_real &
       &,    -0.013045_t_real,    -0.008658_t_real/
  !!
  Data ncoeffrel( 98) / 50 /
  Data vcoeffrel(1:50, 98) /&
       &    -98.000000_t_real,   -97.884109_t_real,   -96.984863_t_real &
       &,   -94.615582_t_real,   -90.564008_t_real,   -84.923291_t_real &
       &,   -77.926323_t_real,   -69.947971_t_real,   -61.428055_t_real &
       &,   -52.837627_t_real,   -44.589355_t_real,   -36.920571_t_real &
       &,   -30.112858_t_real,   -24.417477_t_real,   -19.680244_t_real &
       &,   -15.690652_t_real,   -12.321757_t_real,    -9.562878_t_real &
       &,    -7.386106_t_real,    -5.711434_t_real,    -4.441885_t_real &
       &,    -3.487243_t_real,    -2.771171_t_real,    -2.231677_t_real &
       &,    -1.822867_t_real,    -1.513982_t_real,    -1.283273_t_real &
       &,    -1.111507_t_real,    -0.980696_t_real,    -0.876218_t_real &
       &,    -0.787807_t_real,    -0.708831_t_real,    -0.635234_t_real &
       &,    -0.564775_t_real,    -0.496541_t_real,    -0.430580_t_real &
       &,    -0.367552_t_real,    -0.308410_t_real,    -0.254122_t_real &
       &,    -0.205475_t_real,    -0.162957_t_real,    -0.126721_t_real &
       &,    -0.096601_t_real,    -0.072179_t_real,    -0.052856_t_real &
       &,    -0.037930_t_real,    -0.026672_t_real,    -0.018378_t_real &
       &,    -0.012407_t_real,    -0.008207_t_real/
  !!
  Data ncoeffrel( 99) / 50 /
  Data vcoeffrel(1:50, 99) /&
       &    -99.000000_t_real,   -98.882113_t_real,   -97.965243_t_real &
       &,   -95.555182_t_real,   -91.444483_t_real,   -85.728472_t_real &
       &,   -78.642582_t_real,   -70.566970_t_real,   -61.946293_t_real &
       &,   -53.259883_t_real,   -44.921195_t_real,   -37.174303_t_real &
       &,   -30.313142_t_real,   -24.571036_t_real,   -19.773108_t_real &
       &,   -15.715463_t_real,   -12.287167_t_real,    -9.491542_t_real &
       &,    -7.298301_t_real,    -5.621063_t_real,    -4.357552_t_real &
       &,    -3.413555_t_real,    -2.709381_t_real,    -2.181035_t_real &
       &,    -1.782055_t_real,    -1.481672_t_real,    -1.257962_t_real &
       &,    -1.091472_t_real,    -0.964328_t_real,    -0.862298_t_real &
       &,    -0.775513_t_real,    -0.697641_t_real,    -0.624835_t_real &
       &,    -0.555007_t_real,    -0.487357_t_real,    -0.422005_t_real &
       &,    -0.359650_t_real,    -0.301252_t_real,    -0.247766_t_real &
       &,    -0.199950_t_real,    -0.158259_t_real,    -0.122814_t_real &
       &,    -0.093424_t_real,    -0.069653_t_real,    -0.050890_t_real &
       &,    -0.036434_t_real,    -0.025558_t_real,    -0.017566_t_real &
       &,    -0.011828_t_real,    -0.007802_t_real/
  !!
  Data ncoeffrel(100) / 50 /
  Data vcoeffrel(1:50,100) /&
       &   -100.000000_t_real,   -99.880085_t_real,   -98.945240_t_real &
       &,   -96.493937_t_real,   -92.323772_t_real,   -86.532146_t_real &
       &,   -79.357009_t_real,   -71.183661_t_real,   -62.461663_t_real &
       &,   -53.678798_t_real,   -45.249154_t_real,   -37.423984_t_real &
       &,   -30.509196_t_real,   -24.717223_t_real,   -19.855654_t_real &
       &,   -15.728110_t_real,   -12.241697_t_real,    -9.412259_t_real &
       &,    -7.205707_t_real,    -5.528705_t_real,    -4.273419_t_real &
       &,    -3.341399_t_real,    -2.649677_t_real,    -2.132565_t_real &
       &,    -1.743286_t_real,    -1.451165_t_real,    -1.234144_t_real &
       &,    -1.072609_t_real,    -0.948862_t_real,    -0.849078_t_real &
       &,    -0.763775_t_real,    -0.686905_t_real,    -0.614820_t_real &
       &,    -0.545574_t_real,    -0.478471_t_real,    -0.413702_t_real &
       &,    -0.351997_t_real,    -0.294324_t_real,    -0.241620_t_real &
       &,    -0.194614_t_real,    -0.153729_t_real,    -0.119054_t_real &
       &,    -0.090373_t_real,    -0.067231_t_real,    -0.049011_t_real &
       &,    -0.035008_t_real,    -0.024499_t_real,    -0.016797_t_real &
       &,    -0.011282_t_real,    -0.007423_t_real/
  !!
  Data ncoeffrel(101) / 50 /
  Data vcoeffrel(1:50,101) /&
       &   -101.000000_t_real,  -100.878023_t_real,   -99.924835_t_real &
       &,   -97.431823_t_real,   -93.201855_t_real,   -87.334298_t_real &
       &,   -80.069597_t_real,   -71.798038_t_real,   -62.974170_t_real &
       &,   -54.094382_t_real,   -45.573281_t_real,   -37.669712_t_real &
       &,   -30.700965_t_real,   -24.855957_t_real,   -19.927984_t_real &
       &,   -15.729074_t_real,   -12.186217_t_real,    -9.326030_t_real &
       &,    -7.109269_t_real,    -5.435137_t_real,    -4.189994_t_real &
       &,    -3.271005_t_real,    -2.592088_t_real,    -2.086182_t_real &
       &,    -1.706423_t_real,    -1.422302_t_real,    -1.211653_t_real &
       &,    -1.054762_t_real,    -0.934159_t_real,    -0.836434_t_real &
       &,    -0.752484_t_real,    -0.676527_t_real,    -0.605099_t_real &
       &,    -0.536392_t_real,    -0.469809_t_real,    -0.405601_t_real &
       &,    -0.344531_t_real,    -0.287567_t_real,    -0.235631_t_real &
       &,    -0.189420_t_real,    -0.149325_t_real,    -0.115403_t_real &
       &,    -0.087415_t_real,    -0.064888_t_real,    -0.047196_t_real &
       &,    -0.033634_t_real,    -0.023482_t_real,    -0.016060_t_real &
       &,    -0.010760_t_real,    -0.007061_t_real/
  !!
  Data ncoeffrel(102) / 50 /
  Data vcoeffrel(1:50,102) /&
       &   -102.000000_t_real,  -101.875927_t_real,  -100.904010_t_real &
       &,   -98.368816_t_real,   -94.078710_t_real,   -88.134911_t_real &
       &,   -80.780333_t_real,   -72.410094_t_real,   -63.483818_t_real &
       &,   -54.506639_t_real,   -45.893618_t_real,   -37.911575_t_real &
       &,   -30.888371_t_real,   -24.987160_t_real,   -19.990193_t_real &
       &,   -15.718840_t_real,   -12.121551_t_real,    -9.233762_t_real &
       &,    -7.009815_t_real,    -5.341000_t_real,    -4.107663_t_real &
       &,    -3.202514_t_real,    -2.536591_t_real,    -2.041783_t_real &
       &,    -1.671327_t_real,    -1.394929_t_real,    -1.190338_t_real &
       &,    -1.037793_t_real,    -0.920098_t_real,    -0.824266_t_real &
       &,    -0.741553_t_real,    -0.666427_t_real,    -0.595603_t_real &
       &,    -0.527400_t_real,    -0.461313_t_real,    -0.397650_t_real &
       &,    -0.337204_t_real,    -0.280940_t_real,    -0.229761_t_real &
       &,    -0.184336_t_real,    -0.145019_t_real,    -0.111839_t_real &
       &,    -0.084531_t_real,    -0.062608_t_real,    -0.045433_t_real &
       &,    -0.032301_t_real,    -0.022496_t_real,    -0.015348_t_real &
       &,    -0.010256_t_real,    -0.006712_t_real/
  !!
  Data ncoeffrel(103) / 50 /
  Data vcoeffrel(1:50,103) /&
       &   -103.000000_t_real,  -102.873827_t_real,  -101.883021_t_real &
       &,   -99.305818_t_real,   -94.956538_t_real,   -88.938377_t_real &
       &,   -81.496985_t_real,   -73.032489_t_real,   -64.010082_t_real &
       &,   -54.943959_t_real,   -46.249316_t_real,   -38.201315_t_real &
       &,   -31.137637_t_real,   -25.194652_t_real,   -20.147878_t_real &
       &,   -15.828259_t_real,   -12.204167_t_real,    -9.312839_t_real &
       &,    -7.097480_t_real,    -5.439628_t_real,    -4.213254_t_real &
       &,    -3.307891_t_real,    -2.635024_t_real,    -2.130183_t_real &
       &,    -1.750509_t_real,    -1.466480_t_real,    -1.253741_t_real &
       &,    -1.091075_t_real,    -0.961941_t_real,    -0.854821_t_real &
       &,    -0.762095_t_real,    -0.678845_t_real,    -0.602078_t_real &
       &,    -0.530234_t_real,    -0.462793_t_real,    -0.399901_t_real &
       &,    -0.342023_t_real,    -0.289644_t_real,    -0.243079_t_real &
       &,    -0.202369_t_real,    -0.167282_t_real,    -0.137371_t_real &
       &,    -0.112074_t_real,    -0.090801_t_real,    -0.072999_t_real &
       &,    -0.058180_t_real,    -0.045923_t_real,    -0.035869_t_real &
       &,    -0.027703_t_real,    -0.021141_t_real/
  !!
  !!
  !!
  !!
  !!
  Data vscoeffrel(1:50,  0) /&
       &     0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real/
  Data bscoeffrel(1:50,  0) /&
       &     0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real,    0.0_t_real &
       &,    0.0_t_real,    0.0_t_real/

  Data vscoeffrel(1:50,  1) /&
       &     -1.000000_t_real,    -0.999933_t_real,    -0.999463_t_real &
       &,    -0.998184_t_real,    -0.995675_t_real,    -0.991486_t_real &
       &,    -0.985127_t_real,    -0.976055_t_real,    -0.963686_t_real &
       &,    -0.947418_t_real,    -0.926700_t_real,    -0.901118_t_real &
       &,    -0.870503_t_real,    -0.835039_t_real,    -0.795330_t_real &
       &,    -0.752409_t_real,    -0.707655_t_real,    -0.662628_t_real &
       &,    -0.618852_t_real,    -0.577573_t_real,    -0.539568_t_real &
       &,    -0.505039_t_real,    -0.473621_t_real,    -0.444504_t_real &
       &,    -0.416628_t_real,    -0.388914_t_real,    -0.360483_t_real &
       &,    -0.330797_t_real,    -0.299731_t_real,    -0.267545_t_real &
       &,    -0.234798_t_real,    -0.202240_t_real,    -0.170697_t_real &
       &,    -0.140985_t_real,    -0.113819_t_real,    -0.089745_t_real &
       &,    -0.069080_t_real,    -0.051902_t_real,    -0.038068_t_real &
       &,    -0.027265_t_real,    -0.019075_t_real,    -0.013039_t_real &
       &,    -0.008711_t_real,    -0.005689_t_real,    -0.003631_t_real &
       &,    -0.002265_t_real,    -0.001381_t_real,    -0.000822_t_real &
       &,    -0.000478_t_real,    -0.000271_t_real/
  Data bscoeffrel(1:50,  1) /&
       &      0.000000_t_real,    -0.000051_t_real,    -0.000404_t_real &
       &,    -0.001361_t_real,    -0.003211_t_real,    -0.006219_t_real &
       &,    -0.010612_t_real,    -0.016557_t_real,    -0.024142_t_real &
       &,    -0.033352_t_real,    -0.044048_t_real,    -0.055964_t_real &
       &,    -0.068697_t_real,    -0.081719_t_real,    -0.094409_t_real &
       &,    -0.106086_t_real,    -0.116065_t_real,    -0.123716_t_real &
       &,    -0.128516_t_real,    -0.130109_t_real,    -0.128337_t_real &
       &,    -0.123267_t_real,    -0.115189_t_real,    -0.104602_t_real &
       &,    -0.092171_t_real,    -0.078665_t_real,    -0.064883_t_real &
       &,    -0.051575_t_real,    -0.039373_t_real,    -0.028752_t_real &
       &,    -0.020002_t_real,    -0.013225_t_real,    -0.008343_t_real &
       &,    -0.005114_t_real,    -0.003188_t_real,    -0.002173_t_real &
       &,    -0.001704_t_real,    -0.001499_t_real,    -0.001377_t_real &
       &,    -0.001246_t_real,    -0.001080_t_real,    -0.000888_t_real &
       &,    -0.000693_t_real,    -0.000514_t_real,    -0.000364_t_real &
       &,    -0.000246_t_real,    -0.000160_t_real,    -0.000100_t_real &
       &,    -0.000061_t_real,    -0.000035_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,  2) /&
       &     -2.000000_t_real,    -1.999707_t_real,    -1.997653_t_real &
       &,    -1.992051_t_real,    -1.981026_t_real,    -1.962551_t_real &
       &,    -1.934399_t_real,    -1.894198_t_real,    -1.839642_t_real &
       &,    -1.768897_t_real,    -1.681149_t_real,    -1.577147_t_real &
       &,    -1.459526_t_real,    -1.332725_t_real,    -1.202421_t_real &
       &,    -1.074597_t_real,    -0.954496_t_real,    -0.845782_t_real &
       &,    -0.750122_t_real,    -0.667258_t_real,    -0.595484_t_real &
       &,    -0.532332_t_real,    -0.475248_t_real,    -0.422115_t_real &
       &,    -0.371533_t_real,    -0.322869_t_real,    -0.276142_t_real &
       &,    -0.231819_t_real,    -0.190596_t_real,    -0.153188_t_real &
       &,    -0.120175_t_real,    -0.091901_t_real,    -0.068431_t_real &
       &,    -0.049567_t_real,    -0.034895_t_real,    -0.023861_t_real &
       &,    -0.015837_t_real,    -0.010199_t_real,    -0.006370_t_real &
       &,    -0.003858_t_real,    -0.002264_t_real,    -0.001288_t_real &
       &,    -0.000709_t_real,    -0.000378_t_real,    -0.000195_t_real &
       &,    -0.000097_t_real,    -0.000047_t_real,    -0.000022_t_real &
       &,    -0.000010_t_real,    -0.000004_t_real/
  Data bscoeffrel(1:50,  2) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,  3) /&
       &     -3.000000_t_real,    -2.999457_t_real,    -2.995648_t_real &
       &,    -2.985244_t_real,    -2.964727_t_real,    -2.930277_t_real &
       &,    -2.877791_t_real,    -2.803262_t_real,    -2.703604_t_real &
       &,    -2.577831_t_real,    -2.428160_t_real,    -2.260419_t_real &
       &,    -2.083279_t_real,    -1.906349_t_real,    -1.737771_t_real &
       &,    -1.582304_t_real,    -1.440700_t_real,    -1.310623_t_real &
       &,    -1.188788_t_real,    -1.073788_t_real,    -0.968748_t_real &
       &,    -0.881091_t_real,    -0.816378_t_real,    -0.771395_t_real &
       &,    -0.734980_t_real,    -0.700529_t_real,    -0.666981_t_real &
       &,    -0.634512_t_real,    -0.603055_t_real,    -0.572142_t_real &
       &,    -0.541041_t_real,    -0.508956_t_real,    -0.475167_t_real &
       &,    -0.439197_t_real,    -0.401025_t_real,    -0.361075_t_real &
       &,    -0.320089_t_real,    -0.279018_t_real,    -0.238903_t_real &
       &,    -0.200760_t_real,    -0.165480_t_real,    -0.133747_t_real &
       &,    -0.105988_t_real,    -0.082358_t_real,    -0.062770_t_real &
       &,    -0.046940_t_real,    -0.034455_t_real,    -0.024833_t_real &
       &,    -0.017580_t_real,    -0.012227_t_real/
  Data bscoeffrel(1:50,  3) /&
       &      0.000000_t_real,    -0.000002_t_real,    -0.000017_t_real &
       &,    -0.000055_t_real,    -0.000130_t_real,    -0.000247_t_real &
       &,    -0.000413_t_real,    -0.000625_t_real,    -0.000872_t_real &
       &,    -0.001134_t_real,    -0.001380_t_real,    -0.001567_t_real &
       &,    -0.001646_t_real,    -0.001565_t_real,    -0.001285_t_real &
       &,    -0.000808_t_real,    -0.000234_t_real,     0.000110_t_real &
       &,    -0.000554_t_real,    -0.003812_t_real,    -0.012064_t_real &
       &,    -0.026756_t_real,    -0.044335_t_real,    -0.059616_t_real &
       &,    -0.073398_t_real,    -0.085381_t_real,    -0.093788_t_real &
       &,    -0.097650_t_real,    -0.096932_t_real,    -0.092165_t_real &
       &,    -0.084165_t_real,    -0.073881_t_real,    -0.062347_t_real &
       &,    -0.050590_t_real,    -0.039436_t_real,    -0.029478_t_real &
       &,    -0.021107_t_real,    -0.014506_t_real,    -0.009659_t_real &
       &,    -0.006374_t_real,    -0.004345_t_real,    -0.003216_t_real &
       &,    -0.002649_t_real,    -0.002371_t_real,    -0.002195_t_real &
       &,    -0.002019_t_real,    -0.001802_t_real,    -0.001547_t_real &
       &,    -0.001275_t_real,    -0.001008_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,  4) /&
       &     -4.000000_t_real,    -3.999149_t_real,    -3.993173_t_real &
       &,    -3.976832_t_real,    -3.944567_t_real,    -3.890365_t_real &
       &,    -3.808016_t_real,    -3.692148_t_real,    -3.540047_t_real &
       &,    -3.353650_t_real,    -3.140497_t_real,    -2.912523_t_real &
       &,    -2.682642_t_real,    -2.460559_t_real,    -2.250033_t_real &
       &,    -2.049320_t_real,    -1.855217_t_real,    -1.669876_t_real &
       &,    -1.505850_t_real,    -1.375044_t_real,    -1.269827_t_real &
       &,    -1.175084_t_real,    -1.083658_t_real,    -0.994937_t_real &
       &,    -0.910444_t_real,    -0.831481_t_real,    -0.758343_t_real &
       &,    -0.690362_t_real,    -0.626323_t_real,    -0.564947_t_real &
       &,    -0.505281_t_real,    -0.446907_t_real,    -0.389965_t_real &
       &,    -0.335041_t_real,    -0.282978_t_real,    -0.234675_t_real &
       &,    -0.190920_t_real,    -0.152267_t_real,    -0.118989_t_real &
       &,    -0.091068_t_real,    -0.068241_t_real,    -0.050053_t_real &
       &,    -0.035926_t_real,    -0.025231_t_real,    -0.017334_t_real &
       &,    -0.011648_t_real,    -0.007656_t_real,    -0.004920_t_real &
       &,    -0.003092_t_real,    -0.001899_t_real/
  Data bscoeffrel(1:50,  4) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,  5) /&
       &     -5.000000_t_real,    -4.998792_t_real,    -4.990313_t_real &
       &,    -4.967108_t_real,    -4.921251_t_real,    -4.844246_t_real &
       &,    -4.727726_t_real,    -4.565466_t_real,    -4.356365_t_real &
       &,    -4.106789_t_real,    -3.830108_t_real,    -3.542495_t_real &
       &,    -3.256761_t_real,    -2.978115_t_real,    -2.705325_t_real &
       &,    -2.438161_t_real,    -2.186859_t_real,    -1.967317_t_real &
       &,    -1.777494_t_real,    -1.602220_t_real,    -1.434423_t_real &
       &,    -1.275629_t_real,    -1.129751_t_real,    -0.999544_t_real &
       &,    -0.885550_t_real,    -0.786394_t_real,    -0.699597_t_real &
       &,    -0.622431_t_real,    -0.552526_t_real,    -0.488180_t_real &
       &,    -0.428391_t_real,    -0.372735_t_real,    -0.321164_t_real &
       &,    -0.273804_t_real,    -0.230800_t_real,    -0.192218_t_real &
       &,    -0.158010_t_real,    -0.128047_t_real,    -0.102155_t_real &
       &,    -0.080137_t_real,    -0.061762_t_real,    -0.046745_t_real &
       &,    -0.034740_t_real,    -0.025354_t_real,    -0.018173_t_real &
       &,    -0.012796_t_real,    -0.008850_t_real,    -0.006013_t_real &
       &,    -0.004012_t_real,    -0.002629_t_real/
  Data bscoeffrel(1:50,  5) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,     0.000001_t_real &
       &,     0.000002_t_real,     0.000000_t_real,    -0.000009_t_real &
       &,    -0.000036_t_real,    -0.000112_t_real,    -0.000306_t_real &
       &,    -0.000779_t_real,    -0.001900_t_real,    -0.004458_t_real &
       &,    -0.009821_t_real,    -0.018686_t_real,    -0.027803_t_real &
       &,    -0.033378_t_real,    -0.036225_t_real,    -0.037873_t_real &
       &,    -0.038852_t_real,    -0.039233_t_real,    -0.038985_t_real &
       &,    -0.038079_t_real,    -0.036514_t_real,    -0.034315_t_real &
       &,    -0.031535_t_real,    -0.028262_t_real,    -0.024624_t_real &
       &,    -0.020790_t_real,    -0.016950_t_real,    -0.013295_t_real &
       &,    -0.009986_t_real,    -0.007149_t_real,    -0.004872_t_real &
       &,    -0.003202_t_real,    -0.002124_t_real,    -0.001547_t_real &
       &,    -0.001323_t_real,    -0.001286_t_real,    -0.001301_t_real &
       &,    -0.001284_t_real,    -0.001204_t_real,    -0.001067_t_real &
       &,    -0.000895_t_real,    -0.000715_t_real,    -0.000546_t_real &
       &,    -0.000401_t_real,    -0.000284_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,  6) /&
       &     -6.000000_t_real,    -5.998378_t_real,    -5.986985_t_real &
       &,    -5.955788_t_real,    -5.894113_t_real,    -5.790663_t_real &
       &,    -5.634891_t_real,    -5.420284_t_real,    -5.148431_t_real &
       &,    -4.830894_t_real,    -4.486010_t_real,    -4.131238_t_real &
       &,    -3.776086_t_real,    -3.421923_t_real,    -3.070969_t_real &
       &,    -2.736694_t_real,    -2.434393_t_real,    -2.158970_t_real &
       &,    -1.898449_t_real,    -1.652306_t_real,    -1.426885_t_real &
       &,    -1.228066_t_real,    -1.058164_t_real,    -0.915785_t_real &
       &,    -0.797035_t_real,    -0.697014_t_real,    -0.611020_t_real &
       &,    -0.535240_t_real,    -0.466984_t_real,    -0.404603_t_real &
       &,    -0.347256_t_real,    -0.294644_t_real,    -0.246754_t_real &
       &,    -0.203666_t_real,    -0.165435_t_real,    -0.132041_t_real &
       &,    -0.103394_t_real,    -0.079325_t_real,    -0.059575_t_real &
       &,    -0.043779_t_real,    -0.031476_t_real,    -0.022146_t_real &
       &,    -0.015252_t_real,    -0.010285_t_real,    -0.006791_t_real &
       &,    -0.004391_t_real,    -0.002779_t_real,    -0.001722_t_real &
       &,    -0.001044_t_real,    -0.000619_t_real/
  Data bscoeffrel(1:50,  6) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,     0.000001_t_real &
       &,    -0.000001_t_real,    -0.000014_t_real,    -0.000060_t_real &
       &,    -0.000197_t_real,    -0.000576_t_real,    -0.001562_t_real &
       &,    -0.004016_t_real,    -0.009808_t_real,    -0.021902_t_real &
       &,    -0.040496_t_real,    -0.057174_t_real,    -0.066260_t_real &
       &,    -0.070600_t_real,    -0.072687_t_real,    -0.073229_t_real &
       &,    -0.072330_t_real,    -0.070013_t_real,    -0.066354_t_real &
       &,    -0.061485_t_real,    -0.055591_t_real,    -0.048909_t_real &
       &,    -0.041730_t_real,    -0.034403_t_real,    -0.027301_t_real &
       &,    -0.020773_t_real,    -0.015092_t_real,    -0.010421_t_real &
       &,    -0.006817_t_real,    -0.004253_t_real,    -0.002618_t_real &
       &,    -0.001724_t_real,    -0.001335_t_real,    -0.001220_t_real &
       &,    -0.001196_t_real,    -0.001156_t_real,    -0.001061_t_real &
       &,    -0.000914_t_real,    -0.000741_t_real,    -0.000568_t_real &
       &,    -0.000414_t_real,    -0.000288_t_real,    -0.000192_t_real &
       &,    -0.000124_t_real,    -0.000077_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,  7) /&
       &     -7.000000_t_real,    -6.997907_t_real,    -6.983200_t_real &
       &,    -6.942909_t_real,    -6.863249_t_real,    -6.729844_t_real &
       &,    -6.530027_t_real,    -6.257600_t_real,    -5.917705_t_real &
       &,    -5.527158_t_real,    -5.107597_t_real,    -4.675210_t_real &
       &,    -4.236147_t_real,    -3.793952_t_real,    -3.362148_t_real &
       &,    -2.958930_t_real,    -2.584092_t_real,    -2.229069_t_real &
       &,    -1.897596_t_real,    -1.599997_t_real,    -1.344038_t_real &
       &,    -1.131574_t_real,    -0.959104_t_real,    -0.819929_t_real &
       &,    -0.706403_t_real,    -0.611553_t_real,    -0.529897_t_real &
       &,    -0.457627_t_real,    -0.392405_t_real,    -0.333010_t_real &
       &,    -0.278963_t_real,    -0.230188_t_real,    -0.186747_t_real &
       &,    -0.148681_t_real,    -0.115956_t_real,    -0.088434_t_real &
       &,    -0.065869_t_real,    -0.047878_t_real,    -0.033953_t_real &
       &,    -0.023494_t_real,    -0.015868_t_real,    -0.010465_t_real &
       &,    -0.006740_t_real,    -0.004240_t_real,    -0.002605_t_real &
       &,    -0.001563_t_real,    -0.000915_t_real,    -0.000523_t_real &
       &,    -0.000291_t_real,    -0.000158_t_real/
  Data bscoeffrel(1:50,  7) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,     0.000000_t_real &
       &,    -0.000009_t_real,    -0.000048_t_real,    -0.000184_t_real &
       &,    -0.000598_t_real,    -0.001755_t_real,    -0.004811_t_real &
       &,    -0.012381_t_real,    -0.028885_t_real,    -0.055379_t_real &
       &,    -0.080021_t_real,    -0.093531_t_real,    -0.099711_t_real &
       &,    -0.102271_t_real,    -0.102294_t_real,    -0.100012_t_real &
       &,    -0.095570_t_real,    -0.089192_t_real,    -0.081185_t_real &
       &,    -0.071914_t_real,    -0.061808_t_real,    -0.051351_t_real &
       &,    -0.041075_t_real,    -0.031502_t_real,    -0.023067_t_real &
       &,    -0.016050_t_real,    -0.010556_t_real,    -0.006545_t_real &
       &,    -0.003869_t_real,    -0.002289_t_real,    -0.001505_t_real &
       &,    -0.001204_t_real,    -0.001123_t_real,    -0.001084_t_real &
       &,    -0.001008_t_real,    -0.000877_t_real,    -0.000712_t_real &
       &,    -0.000543_t_real,    -0.000390_t_real,    -0.000266_t_real &
       &,    -0.000173_t_real,    -0.000108_t_real,    -0.000065_t_real &
       &,    -0.000037_t_real,    -0.000021_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,  8) /&
       &     -8.000000_t_real,    -7.997389_t_real,    -7.979037_t_real &
       &,    -7.928741_t_real,    -7.829303_t_real,    -7.663084_t_real &
       &,    -7.415477_t_real,    -7.081270_t_real,    -6.669807_t_real &
       &,    -6.202730_t_real,    -5.703142_t_real,    -5.184881_t_real &
       &,    -4.654475_t_real,    -4.126077_t_real,    -3.621154_t_real &
       &,    -3.142678_t_real,    -2.685277_t_real,    -2.257401_t_real &
       &,    -1.874504_t_real,    -1.547799_t_real,    -1.280024_t_real &
       &,    -1.066442_t_real,    -0.897953_t_real,    -0.764215_t_real &
       &,    -0.655800_t_real,    -0.565223_t_real,    -0.487144_t_real &
       &,    -0.418095_t_real,    -0.356040_t_real,    -0.299939_t_real &
       &,    -0.249368_t_real,    -0.204223_t_real,    -0.164510_t_real &
       &,    -0.130202_t_real,    -0.101159_t_real,    -0.077104_t_real &
       &,    -0.057628_t_real,    -0.042219_t_real,    -0.030309_t_real &
       &,    -0.021312_t_real,    -0.014671_t_real,    -0.009879_t_real &
       &,    -0.006502_t_real,    -0.004180_t_real,    -0.002624_t_real &
       &,    -0.001608_t_real,    -0.000962_t_real,    -0.000563_t_real &
       &,    -0.000321_t_real,    -0.000179_t_real/
  Data bscoeffrel(1:50,  8) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,     0.000000_t_real &
       &,    -0.000011_t_real,    -0.000059_t_real,    -0.000226_t_real &
       &,    -0.000739_t_real,    -0.002196_t_real,    -0.006044_t_real &
       &,    -0.015064_t_real,    -0.030934_t_real,    -0.047298_t_real &
       &,    -0.057031_t_real,    -0.061559_t_real,    -0.063248_t_real &
       &,    -0.062900_t_real,    -0.060736_t_real,    -0.056927_t_real &
       &,    -0.051717_t_real,    -0.045422_t_real,    -0.038419_t_real &
       &,    -0.031127_t_real,    -0.023992_t_real,    -0.017445_t_real &
       &,    -0.011842_t_real,    -0.007403_t_real,    -0.004171_t_real &
       &,    -0.002031_t_real,    -0.000756_t_real,    -0.000094_t_real &
       &,     0.000181_t_real,     0.000239_t_real,     0.000194_t_real &
       &,     0.000117_t_real,     0.000045_t_real,     0.000000_t_real &
       &,    -0.000015_t_real,    -0.000005_t_real,     0.000018_t_real &
       &,     0.000042_t_real,     0.000058_t_real,     0.000063_t_real &
       &,     0.000058_t_real,     0.000047_t_real,     0.000035_t_real &
       &,     0.000025_t_real,     0.000016_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,  9) /&
       &     -9.000000_t_real,    -8.996814_t_real,    -8.974409_t_real &
       &,    -8.912987_t_real,    -8.791579_t_real,    -8.589057_t_real &
       &,    -8.289017_t_real,    -7.887769_t_real,    -7.399121_t_real &
       &,    -6.848628_t_real,    -6.259361_t_real,    -5.643942_t_real &
       &,    -5.015408_t_real,    -4.398338_t_real,    -3.805310_t_real &
       &,    -3.233878_t_real,    -2.694874_t_real,    -2.209656_t_real &
       &,    -1.795251_t_real,    -1.457372_t_real,    -1.191077_t_real &
       &,    -0.984883_t_real,    -0.825153_t_real,    -0.699190_t_real &
       &,    -0.596772_t_real,    -0.510506_t_real,    -0.435512_t_real &
       &,    -0.368851_t_real,    -0.308956_t_real,    -0.255134_t_real &
       &,    -0.207184_t_real,    -0.165109_t_real,    -0.128912_t_real &
       &,    -0.098480_t_real,    -0.073530_t_real,    -0.053613_t_real &
       &,    -0.038148_t_real,    -0.026474_t_real,    -0.017912_t_real &
       &,    -0.011811_t_real,    -0.007588_t_real,    -0.004748_t_real &
       &,    -0.002894_t_real,    -0.001717_t_real,    -0.000991_t_real &
       &,    -0.000557_t_real,    -0.000304_t_real,    -0.000161_t_real &
       &,    -0.000083_t_real,    -0.000042_t_real/
  Data bscoeffrel(1:50,  9) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,    -0.000001_t_real &
       &,    -0.000010_t_real,    -0.000049_t_real,    -0.000186_t_real &
       &,    -0.000611_t_real,    -0.001827_t_real,    -0.004957_t_real &
       &,    -0.011372_t_real,    -0.019510_t_real,    -0.025211_t_real &
       &,    -0.028048_t_real,    -0.029213_t_real,    -0.029235_t_real &
       &,    -0.028271_t_real,    -0.026432_t_real,    -0.023859_t_real &
       &,    -0.020738_t_real,    -0.017279_t_real,    -0.013714_t_real &
       &,    -0.010280_t_real,    -0.007192_t_real,    -0.004618_t_real &
       &,    -0.002649_t_real,    -0.001283_t_real,    -0.000441_t_real &
       &,     0.000005_t_real,     0.000189_t_real,     0.000222_t_real &
       &,     0.000184_t_real,     0.000123_t_real,     0.000064_t_real &
       &,     0.000019_t_real,    -0.000010_t_real,    -0.000024_t_real &
       &,    -0.000028_t_real,    -0.000025_t_real,    -0.000019_t_real &
       &,    -0.000013_t_real,    -0.000007_t_real,    -0.000004_t_real &
       &,    -0.000001_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000001_t_real,     0.000001_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 10) /&
       &    -10.000000_t_real,    -9.996182_t_real,    -9.969325_t_real &
       &,    -9.895682_t_real,    -9.750165_t_real,    -9.507966_t_real &
       &,    -9.151064_t_real,    -8.677751_t_real,    -8.106309_t_real &
       &,    -7.465163_t_real,    -6.776731_t_real,    -6.055524_t_real &
       &,    -5.324775_t_real,    -4.609645_t_real,    -3.914811_t_real &
       &,    -3.250684_t_real,    -2.644041_t_real,    -2.120544_t_real &
       &,    -1.692275_t_real,    -1.356348_t_real,    -1.099691_t_real &
       &,    -0.905085_t_real,    -0.755766_t_real,    -0.637888_t_real &
       &,    -0.541255_t_real,    -0.459031_t_real,    -0.387025_t_real &
       &,    -0.322920_t_real,    -0.265617_t_real,    -0.214725_t_real &
       &,    -0.170174_t_real,    -0.131954_t_real,    -0.099946_t_real &
       &,    -0.073849_t_real,    -0.053172_t_real,    -0.037273_t_real &
       &,    -0.025419_t_real,    -0.016855_t_real,    -0.010862_t_real &
       &,    -0.006800_t_real,    -0.004134_t_real,    -0.002440_t_real &
       &,    -0.001398_t_real,    -0.000777_t_real,    -0.000419_t_real &
       &,    -0.000219_t_real,    -0.000111_t_real,    -0.000054_t_real &
       &,    -0.000026_t_real,    -0.000012_t_real/
  Data bscoeffrel(1:50, 10) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 11) /&
       &    -11.000000_t_real,   -10.995596_t_real,   -10.964602_t_real &
       &,   -10.879575_t_real,   -10.711589_t_real,   -10.432604_t_real &
       &,   -10.023854_t_real,    -9.486746_t_real,    -8.844581_t_real &
       &,    -8.128245_t_real,    -7.360074_t_real,    -6.560148_t_real &
       &,    -5.760437_t_real,    -4.980309_t_real,    -4.227896_t_real &
       &,    -3.529590_t_real,    -2.918023_t_real,    -2.411489_t_real &
       &,    -2.008073_t_real,    -1.691347_t_real,    -1.439942_t_real &
       &,    -1.235710_t_real,    -1.068230_t_real,    -0.934674_t_real &
       &,    -0.834750_t_real,    -0.764798_t_real,    -0.714540_t_real &
       &,    -0.673070_t_real,    -0.635299_t_real,    -0.599516_t_real &
       &,    -0.564732_t_real,    -0.529982_t_real,    -0.494372_t_real &
       &,    -0.457257_t_real,    -0.418374_t_real,    -0.377880_t_real &
       &,    -0.336303_t_real,    -0.294449_t_real,    -0.253309_t_real &
       &,    -0.213921_t_real,    -0.177230_t_real,    -0.143992_t_real &
       &,    -0.114708_t_real,    -0.089606_t_real,    -0.068655_t_real &
       &,    -0.051612_t_real,    -0.038084_t_real,    -0.027594_t_real &
       &,    -0.019639_t_real,    -0.013732_t_real/
  Data bscoeffrel(1:50, 11) /&
       &      0.000000_t_real,    -0.000001_t_real,    -0.000004_t_real &
       &,    -0.000013_t_real,    -0.000030_t_real,    -0.000054_t_real &
       &,    -0.000081_t_real,    -0.000101_t_real,    -0.000098_t_real &
       &,    -0.000055_t_real,     0.000029_t_real,     0.000069_t_real &
       &,    -0.000085_t_real,    -0.000370_t_real,    -0.000579_t_real &
       &,    -0.000606_t_real,    -0.000431_t_real,    -0.000122_t_real &
       &,     0.000101_t_real,    -0.000243_t_real,    -0.002059_t_real &
       &,    -0.006816_t_real,    -0.016304_t_real,    -0.031281_t_real &
       &,    -0.048957_t_real,    -0.063475_t_real,    -0.073540_t_real &
       &,    -0.080694_t_real,    -0.084580_t_real,    -0.084478_t_real &
       &,    -0.080433_t_real,    -0.073144_t_real,    -0.063629_t_real &
       &,    -0.052976_t_real,    -0.042192_t_real,    -0.032105_t_real &
       &,    -0.023327_t_real,    -0.016223_t_real,    -0.010887_t_real &
       &,    -0.007187_t_real,    -0.004842_t_real,    -0.003499_t_real &
       &,    -0.002807_t_real,    -0.002470_t_real,    -0.002278_t_real &
       &,    -0.002104_t_real,    -0.001896_t_real,    -0.001645_t_real &
       &,    -0.001371_t_real,    -0.001096_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 12) /&
       &    -12.000000_t_real,   -11.994982_t_real,   -11.959653_t_real &
       &,   -11.862693_t_real,   -11.671176_t_real,   -11.353870_t_real &
       &,   -10.891692_t_real,   -10.289698_t_real,    -9.576015_t_real &
       &,    -8.783167_t_real,    -7.934445_t_real,    -7.058232_t_real &
       &,    -6.189996_t_real,    -5.344294_t_real,    -4.541340_t_real &
       &,    -3.818609_t_real,    -3.204622_t_real,    -2.703333_t_real &
       &,    -2.298076_t_real,    -1.965390_t_real,    -1.688712_t_real &
       &,    -1.464423_t_real,    -1.293139_t_real,    -1.164540_t_real &
       &,    -1.061307_t_real,    -0.971493_t_real,    -0.889896_t_real &
       &,    -0.814505_t_real,    -0.744104_t_real,    -0.677468_t_real &
       &,    -0.613380_t_real,    -0.550887_t_real,    -0.489524_t_real &
       &,    -0.429379_t_real,    -0.371024_t_real,    -0.315336_t_real &
       &,    -0.263292_t_real,    -0.215780_t_real,    -0.173467_t_real &
       &,    -0.136725_t_real,    -0.105622_t_real,    -0.079950_t_real &
       &,    -0.059286_t_real,    -0.043060_t_real,    -0.030629_t_real &
       &,    -0.021335_t_real,    -0.014550_t_real,    -0.009716_t_real &
       &,    -0.006351_t_real,    -0.004063_t_real/
  Data bscoeffrel(1:50, 12) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 13) /&
       &    -13.000000_t_real,   -12.994354_t_real,   -12.954588_t_real &
       &,   -12.845405_t_real,   -12.629809_t_real,   -12.273506_t_real &
       &,   -11.757565_t_real,   -11.091132_t_real,   -10.306814_t_real &
       &,    -9.438312_t_real,    -8.511874_t_real,    -7.565014_t_real &
       &,    -6.631444_t_real,    -5.727473_t_real,    -4.887612_t_real &
       &,    -4.152024_t_real,    -3.537074_t_real,    -3.030376_t_real &
       &,    -2.606341_t_real,    -2.246763_t_real,    -1.950374_t_real &
       &,    -1.716874_t_real,    -1.528760_t_real,    -1.366124_t_real &
       &,    -1.219847_t_real,    -1.087976_t_real,    -0.970350_t_real &
       &,    -0.866300_t_real,    -0.774317_t_real,    -0.692450_t_real &
       &,    -0.618762_t_real,    -0.551628_t_real,    -0.489830_t_real &
       &,    -0.432538_t_real,    -0.379237_t_real,    -0.329646_t_real &
       &,    -0.283641_t_real,    -0.241207_t_real,    -0.202411_t_real &
       &,    -0.167370_t_real,    -0.136214_t_real,    -0.109020_t_real &
       &,    -0.085770_t_real,    -0.066317_t_real,    -0.050395_t_real &
       &,    -0.037643_t_real,    -0.027644_t_real,    -0.019962_t_real &
       &,    -0.014177_t_real,    -0.009902_t_real/
  Data bscoeffrel(1:50, 13) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,     0.000002_t_real &
       &,     0.000001_t_real,    -0.000007_t_real,    -0.000035_t_real &
       &,    -0.000124_t_real,    -0.000337_t_real,    -0.000637_t_real &
       &,    -0.000815_t_real,    -0.000812_t_real,    -0.000669_t_real &
       &,    -0.000410_t_real,    -0.000098_t_real,     0.000044_t_real &
       &,    -0.000588_t_real,    -0.003213_t_real,    -0.008906_t_real &
       &,    -0.016467_t_real,    -0.023593_t_real,    -0.029592_t_real &
       &,    -0.034585_t_real,    -0.038599_t_real,    -0.041504_t_real &
       &,    -0.043118_t_real,    -0.043289_t_real,    -0.041952_t_real &
       &,    -0.039172_t_real,    -0.035165_t_real,    -0.030283_t_real &
       &,    -0.024964_t_real,    -0.019657_t_real,    -0.014757_t_real &
       &,    -0.010561_t_real,    -0.007250_t_real,    -0.004873_t_real &
       &,    -0.003351_t_real,    -0.002507_t_real,    -0.002119_t_real &
       &,    -0.001977_t_real,    -0.001919_t_real,    -0.001848_t_real &
       &,    -0.001721_t_real,    -0.001536_t_real,    -0.001311_t_real &
       &,    -0.001073_t_real,    -0.000844_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 14) /&
       &    -14.000000_t_real,   -13.993698_t_real,   -13.949296_t_real &
       &,   -13.827337_t_real,   -13.586609_t_real,   -13.189818_t_real &
       &,   -12.618572_t_real,   -11.886362_t_real,   -11.029773_t_real &
       &,   -10.083554_t_real,    -9.079075_t_real,    -8.061252_t_real &
       &,    -7.060085_t_real,    -6.100360_t_real,    -5.227300_t_real &
       &,    -4.475045_t_real,    -3.843345_t_real,    -3.307405_t_real &
       &,    -2.845034_t_real,    -2.454720_t_real,    -2.137169_t_real &
       &,    -1.871622_t_real,    -1.636887_t_real,    -1.426145_t_real &
       &,    -1.239940_t_real,    -1.079052_t_real,    -0.942157_t_real &
       &,    -0.826058_t_real,    -0.726710_t_real,    -0.640139_t_real &
       &,    -0.563023_t_real,    -0.492938_t_real,    -0.428360_t_real &
       &,    -0.368529_t_real,    -0.313211_t_real,    -0.262467_t_real &
       &,    -0.216482_t_real,    -0.175460_t_real,    -0.139555_t_real &
       &,    -0.108812_t_real,    -0.083121_t_real,    -0.062195_t_real &
       &,    -0.045586_t_real,    -0.032738_t_real,    -0.023043_t_real &
       &,    -0.015901_t_real,    -0.010760_t_real,    -0.007140_t_real &
       &,    -0.004647_t_real,    -0.002966_t_real/
  Data bscoeffrel(1:50, 14) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,     0.000001_t_real &
       &,    -0.000005_t_real,    -0.000034_t_real,    -0.000139_t_real &
       &,    -0.000459_t_real,    -0.001162_t_real,    -0.001945_t_real &
       &,    -0.002245_t_real,    -0.002045_t_real,    -0.001448_t_real &
       &,    -0.000578_t_real,     0.000096_t_real,    -0.000838_t_real &
       &,    -0.006475_t_real,    -0.019659_t_real,    -0.036721_t_real &
       &,    -0.051369_t_real,    -0.062278_t_real,    -0.070077_t_real &
       &,    -0.075039_t_real,    -0.077125_t_real,    -0.076286_t_real &
       &,    -0.072630_t_real,    -0.066496_t_real,    -0.058459_t_real &
       &,    -0.049273_t_real,    -0.039755_t_real,    -0.030649_t_real &
       &,    -0.022518_t_real,    -0.015722_t_real,    -0.010424_t_real &
       &,    -0.006621_t_real,    -0.004155_t_real,    -0.002752_t_real &
       &,    -0.002077_t_real,    -0.001812_t_real,    -0.001713_t_real &
       &,    -0.001629_t_real,    -0.001495_t_real,    -0.001305_t_real &
       &,    -0.001080_t_real,    -0.000850_t_real,    -0.000638_t_real &
       &,    -0.000459_t_real,    -0.000317_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 15) /&
       &    -15.000000_t_real,   -14.993016_t_real,   -14.943784_t_real &
       &,   -14.808514_t_real,   -14.541642_t_real,   -14.102953_t_real &
       &,   -13.474969_t_real,   -12.675681_t_real,   -11.745135_t_real &
       &,   -10.719443_t_real,    -9.636954_t_real,    -8.546780_t_real &
       &,    -7.477060_t_real,    -6.464647_t_real,    -5.558835_t_real &
       &,    -4.780819_t_real,    -4.114149_t_real,    -3.531792_t_real &
       &,    -3.027585_t_real,    -2.605833_t_real,    -2.247268_t_real &
       &,    -1.928724_t_real,    -1.644312_t_real,    -1.396877_t_real &
       &,    -1.188144_t_real,    -1.015812_t_real,    -0.874428_t_real &
       &,    -0.757278_t_real,    -0.657964_t_real,    -0.571321_t_real &
       &,    -0.493736_t_real,    -0.423061_t_real,    -0.358293_t_real &
       &,    -0.299154_t_real,    -0.245719_t_real,    -0.198162_t_real &
       &,    -0.156625_t_real,    -0.121148_t_real,    -0.091607_t_real &
       &,    -0.067679_t_real,    -0.048849_t_real,    -0.034452_t_real &
       &,    -0.023752_t_real,    -0.016013_t_real,    -0.010560_t_real &
       &,    -0.006813_t_real,    -0.004301_t_real,    -0.002657_t_real &
       &,    -0.001605_t_real,    -0.000948_t_real/
  Data bscoeffrel(1:50, 15) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,    -0.000001_t_real &
       &,    -0.000017_t_real,    -0.000088_t_real,    -0.000346_t_real &
       &,    -0.001101_t_real,    -0.002561_t_real,    -0.003808_t_real &
       &,    -0.004010_t_real,    -0.003296_t_real,    -0.001866_t_real &
       &,    -0.000240_t_real,    -0.000249_t_real,    -0.006624_t_real &
       &,    -0.025421_t_real,    -0.052350_t_real,    -0.075219_t_real &
       &,    -0.090869_t_real,    -0.100755_t_real,    -0.105758_t_real &
       &,    -0.106195_t_real,    -0.102374_t_real,    -0.094821_t_real &
       &,    -0.084333_t_real,    -0.071931_t_real,    -0.058747_t_real &
       &,    -0.045857_t_real,    -0.034127_t_real,    -0.024128_t_real &
       &,    -0.016137_t_real,    -0.010191_t_real,    -0.006136_t_real &
       &,    -0.003664_t_real,    -0.002361_t_real,    -0.001794_t_real &
       &,    -0.001592_t_real,    -0.001503_t_real,    -0.001396_t_real &
       &,    -0.001232_t_real,    -0.001024_t_real,    -0.000802_t_real &
       &,    -0.000595_t_real,    -0.000420_t_real,    -0.000283_t_real &
       &,    -0.000183_t_real,    -0.000114_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 16) /&
       &    -16.000000_t_real,   -15.992311_t_real,   -15.938084_t_real &
       &,   -15.789041_t_real,   -15.495159_t_real,   -15.013425_t_real &
       &,   -14.327647_t_real,   -13.460399_t_real,   -12.454732_t_real &
       &,   -11.348857_t_real,   -10.189145_t_real,    -9.025693_t_real &
       &,    -7.888819_t_real,    -6.827122_t_real,    -5.886524_t_real &
       &,    -5.071541_t_real,    -4.355502_t_real,    -3.722929_t_real &
       &,    -3.182865_t_real,    -2.722280_t_real,    -2.312191_t_real &
       &,    -1.945033_t_real,    -1.626393_t_real,    -1.360111_t_real &
       &,    -1.143752_t_real,    -0.970005_t_real,    -0.829582_t_real &
       &,    -0.713593_t_real,    -0.614843_t_real,    -0.528238_t_real &
       &,    -0.450610_t_real,    -0.380289_t_real,    -0.316615_t_real &
       &,    -0.259484_t_real,    -0.209001_t_real,    -0.165243_t_real &
       &,    -0.128128_t_real,    -0.097370_t_real,    -0.072485_t_real &
       &,    -0.052840_t_real,    -0.037711_t_real,    -0.026346_t_real &
       &,    -0.018016_t_real,    -0.012058_t_real,    -0.007899_t_real &
       &,    -0.005064_t_real,    -0.003177_t_real,    -0.001949_t_real &
       &,    -0.001169_t_real,    -0.000686_t_real/
  Data bscoeffrel(1:50, 16) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000019_t_real,    -0.000092_t_real,    -0.000353_t_real &
       &,    -0.001087_t_real,    -0.002303_t_real,    -0.003077_t_real &
       &,    -0.002974_t_real,    -0.002156_t_real,    -0.000849_t_real &
       &,     0.000113_t_real,    -0.001899_t_real,    -0.011831_t_real &
       &,    -0.029560_t_real,    -0.045589_t_real,    -0.056016_t_real &
       &,    -0.061950_t_real,    -0.064279_t_real,    -0.063428_t_real &
       &,    -0.059789_t_real,    -0.053889_t_real,    -0.046396_t_real &
       &,    -0.038073_t_real,    -0.029691_t_real,    -0.021930_t_real &
       &,    -0.015292_t_real,    -0.010037_t_real,    -0.006184_t_real &
       &,    -0.003561_t_real,    -0.001901_t_real,    -0.000924_t_real &
       &,    -0.000394_t_real,    -0.000135_t_real,    -0.000029_t_real &
       &,     0.000001_t_real,    -0.000002_t_real,    -0.000013_t_real &
       &,    -0.000023_t_real,    -0.000027_t_real,    -0.000026_t_real &
       &,    -0.000021_t_real,    -0.000014_t_real,    -0.000008_t_real &
       &,    -0.000003_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 17) /&
       &    -17.000000_t_real,   -16.991579_t_real,   -16.932160_t_real &
       &,   -16.768802_t_real,   -16.446895_t_real,   -15.920726_t_real &
       &,   -15.175713_t_real,   -14.238986_t_real,   -13.156204_t_real &
       &,   -11.968718_t_real,   -10.730884_t_real,    -9.491787_t_real &
       &,    -8.288162_t_real,    -7.176946_t_real,    -6.194055_t_real &
       &,    -5.327627_t_real,    -4.551735_t_real,    -3.870913_t_real &
       &,    -3.287528_t_real,    -2.769775_t_real,    -2.303749_t_real &
       &,    -1.897431_t_real,    -1.558634_t_real,    -1.286265_t_real &
       &,    -1.071558_t_real,    -0.902246_t_real,    -0.766177_t_real &
       &,    -0.653358_t_real,    -0.556610_t_real,    -0.471372_t_real &
       &,    -0.395116_t_real,    -0.326685_t_real,    -0.265710_t_real &
       &,    -0.212164_t_real,    -0.166049_t_real,    -0.127227_t_real &
       &,    -0.095341_t_real,    -0.069826_t_real,    -0.049949_t_real &
       &,    -0.034882_t_real,    -0.023773_t_real,    -0.015807_t_real &
       &,    -0.010252_t_real,    -0.006485_t_real,    -0.004000_t_real &
       &,    -0.002405_t_real,    -0.001410_t_real,    -0.000805_t_real &
       &,    -0.000448_t_real,    -0.000243_t_real/
  Data bscoeffrel(1:50, 17) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000014_t_real,    -0.000067_t_real,    -0.000252_t_real &
       &,    -0.000743_t_real,    -0.001425_t_real,    -0.001730_t_real &
       &,    -0.001534_t_real,    -0.000943_t_real,    -0.000181_t_real &
       &,    -0.000098_t_real,    -0.002976_t_real,    -0.010767_t_real &
       &,    -0.019471_t_real,    -0.025293_t_real,    -0.028509_t_real &
       &,    -0.029751_t_real,    -0.029338_t_real,    -0.027526_t_real &
       &,    -0.024619_t_real,    -0.020979_t_real,    -0.016993_t_real &
       &,    -0.013038_t_real,    -0.009435_t_real,    -0.006408_t_real &
       &,    -0.004063_t_real,    -0.002390_t_real,    -0.001293_t_real &
       &,    -0.000632_t_real,    -0.000268_t_real,    -0.000089_t_real &
       &,    -0.000014_t_real,     0.000008_t_real,     0.000007_t_real &
       &,    -0.000002_t_real,    -0.000009_t_real,    -0.000013_t_real &
       &,    -0.000014_t_real,    -0.000013_t_real,    -0.000011_t_real &
       &,    -0.000008_t_real,    -0.000006_t_real,    -0.000004_t_real &
       &,    -0.000002_t_real,    -0.000001_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 18) /&
       &    -18.000000_t_real,   -17.990820_t_real,   -17.926018_t_real &
       &,   -17.747809_t_real,   -17.396884_t_real,   -16.824942_t_real &
       &,   -16.019302_t_real,   -15.011561_t_real,   -13.849724_t_real &
       &,   -12.579468_t_real,   -11.262134_t_real,    -9.945534_t_real &
       &,    -8.675722_t_real,    -7.512706_t_real,    -6.477719_t_real &
       &,    -5.547372_t_real,    -4.709216_t_real,    -3.979218_t_real &
       &,    -3.336355_t_real,    -2.754978_t_real,    -2.242192_t_real &
       &,    -1.811863_t_real,    -1.466983_t_real,    -1.198737_t_real &
       &,    -0.991914_t_real,    -0.830359_t_real,    -0.700321_t_real &
       &,    -0.591692_t_real,    -0.497899_t_real,    -0.415156_t_real &
       &,    -0.341587_t_real,    -0.276441_t_real,    -0.219502_t_real &
       &,    -0.170681_t_real,    -0.129779_t_real,    -0.096382_t_real &
       &,    -0.069847_t_real,    -0.049355_t_real,    -0.033986_t_real &
       &,    -0.022795_t_real,    -0.014886_t_real,    -0.009463_t_real &
       &,    -0.005854_t_real,    -0.003523_t_real,    -0.002063_t_real &
       &,    -0.001174_t_real,    -0.000650_t_real,    -0.000350_t_real &
       &,    -0.000183_t_real,    -0.000093_t_real/
  Data bscoeffrel(1:50, 18) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 19) /&
       &    -19.000000_t_real,   -18.990090_t_real,   -18.920099_t_real &
       &,   -18.727558_t_real,   -18.348677_t_real,   -17.733035_t_real &
       &,   -16.870490_t_real,   -15.797319_t_real,   -14.564025_t_real &
       &,   -13.221925_t_real,   -11.838001_t_real,   -10.460250_t_real &
       &,    -9.145065_t_real,    -7.949986_t_real,    -6.880093_t_real &
       &,    -5.909796_t_real,    -5.046704_t_real,    -4.295922_t_real &
       &,    -3.622388_t_real,    -3.020172_t_real,    -2.504614_t_real &
       &,    -2.081905_t_real,    -1.743120_t_real,    -1.471519_t_real &
       &,    -1.251420_t_real,    -1.073382_t_real,    -0.934012_t_real &
       &,    -0.831276_t_real,    -0.759698_t_real,    -0.708299_t_real &
       &,    -0.666070_t_real,    -0.627206_t_real,    -0.589316_t_real &
       &,    -0.551137_t_real,    -0.511807_t_real,    -0.470821_t_real &
       &,    -0.428091_t_real,    -0.383962_t_real,    -0.339144_t_real &
       &,    -0.294598_t_real,    -0.251398_t_real,    -0.210590_t_real &
       &,    -0.173080_t_real,    -0.139544_t_real,    -0.110369_t_real &
       &,    -0.085655_t_real,    -0.065250_t_real,    -0.048810_t_real &
       &,    -0.035869_t_real,    -0.025905_t_real/
  Data bscoeffrel(1:50, 19) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000006_t_real,    -0.000013_t_real,    -0.000022_t_real &
       &,    -0.000027_t_real,    -0.000021_t_real,     0.000001_t_real &
       &,     0.000014_t_real,    -0.000035_t_real,    -0.000102_t_real &
       &,    -0.000119_t_real,    -0.000065_t_real,     0.000002_t_real &
       &,    -0.000134_t_real,    -0.000649_t_real,    -0.001060_t_real &
       &,    -0.000992_t_real,    -0.000553_t_real,     0.000006_t_real &
       &,     0.000258_t_real,    -0.000500_t_real,    -0.003343_t_real &
       &,    -0.009652_t_real,    -0.020572_t_real,    -0.035702_t_real &
       &,    -0.051504_t_real,    -0.062952_t_real,    -0.069497_t_real &
       &,    -0.072834_t_real,    -0.073101_t_real,    -0.070020_t_real &
       &,    -0.063897_t_real,    -0.055558_t_real,    -0.046049_t_real &
       &,    -0.036387_t_real,    -0.027415_t_real,    -0.019720_t_real &
       &,    -0.013614_t_real,    -0.009147_t_real,    -0.006157_t_real &
       &,    -0.004344_t_real,    -0.003355_t_real,    -0.002859_t_real &
       &,    -0.002601_t_real,    -0.002413_t_real,    -0.002208_t_real &
       &,    -0.001957_t_real,    -0.001669_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 20) /&
       &    -20.000000_t_real,   -19.989344_t_real,   -19.914043_t_real &
       &,   -19.706833_t_real,   -19.299398_t_real,   -18.639399_t_real &
       &,   -17.719550_t_real,   -16.580685_t_real,   -15.275830_t_real &
       &,   -13.862856_t_real,   -12.412633_t_real,   -10.975405_t_real &
       &,    -9.616791_t_real,    -8.386470_t_real,    -7.274877_t_real &
       &,    -6.265080_t_real,    -5.377895_t_real,    -4.594338_t_real &
       &,    -3.886155_t_real,    -3.263621_t_real,    -2.738611_t_real &
       &,    -2.305829_t_real,    -1.949714_t_real,    -1.657460_t_real &
       &,    -1.425012_t_real,    -1.249948_t_real,    -1.120642_t_real &
       &,    -1.019883_t_real,    -0.934659_t_real,    -0.858001_t_real &
       &,    -0.786440_t_real,    -0.717977_t_real,    -0.651268_t_real &
       &,    -0.585498_t_real,    -0.520419_t_real,    -0.456356_t_real &
       &,    -0.394096_t_real,    -0.334695_t_real,    -0.279259_t_real &
       &,    -0.228754_t_real,    -0.183877_t_real,    -0.144991_t_real &
       &,    -0.112129_t_real,    -0.085034_t_real,    -0.063230_t_real &
       &,    -0.046098_t_real,    -0.032950_t_real,    -0.023089_t_real &
       &,    -0.015860_t_real,    -0.010680_t_real/
  Data bscoeffrel(1:50, 20) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 21) /&
       &    -21.000000_t_real,   -20.988552_t_real,   -20.907616_t_real &
       &,   -20.684842_t_real,   -20.247175_t_real,   -19.540354_t_real &
       &,   -18.559987_t_real,   -17.351014_t_real,   -15.968812_t_real &
       &,   -14.477918_t_real,   -12.951013_t_real,   -11.442334_t_real &
       &,   -10.023803_t_real,    -8.733955_t_real,    -7.554799_t_real &
       &,    -6.485681_t_real,    -5.543430_t_real,    -4.694740_t_real &
       &,    -3.932355_t_real,    -3.275859_t_real,    -2.731385_t_real &
       &,    -2.286568_t_real,    -1.924128_t_real,    -1.633215_t_real &
       &,    -1.408176_t_real,    -1.238538_t_real,    -1.107485_t_real &
       &,    -1.000166_t_real,    -0.907488_t_real,    -0.824424_t_real &
       &,    -0.747856_t_real,    -0.675563_t_real,    -0.605987_t_real &
       &,    -0.538268_t_real,    -0.472247_t_real,    -0.408370_t_real &
       &,    -0.347476_t_real,    -0.290565_t_real,    -0.238574_t_real &
       &,    -0.192220_t_real,    -0.151909_t_real,    -0.117721_t_real &
       &,    -0.089437_t_real,    -0.066607_t_real,    -0.048620_t_real &
       &,    -0.034783_t_real,    -0.024387_t_real,    -0.016756_t_real &
       &,    -0.011282_t_real,    -0.007444_t_real/
  Data bscoeffrel(1:50, 21) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000004_t_real,     0.000012_t_real &
       &,     0.000017_t_real,    -0.000019_t_real,    -0.000149_t_real &
       &,    -0.000509_t_real,    -0.001479_t_real,    -0.003885_t_real &
       &,    -0.007895_t_real,    -0.010926_t_real,    -0.012586_t_real &
       &,    -0.014180_t_real,    -0.016240_t_real,    -0.018938_t_real &
       &,    -0.022243_t_real,    -0.025675_t_real,    -0.027928_t_real &
       &,    -0.027399_t_real,    -0.023993_t_real,    -0.019254_t_real &
       &,    -0.014538_t_real,    -0.010404_t_real,    -0.006982_t_real &
       &,    -0.004266_t_real,    -0.002217_t_real,    -0.000774_t_real &
       &,     0.000148_t_real,     0.000652_t_real,     0.000849_t_real &
       &,     0.000847_t_real,     0.000734_t_real,     0.000577_t_real &
       &,     0.000416_t_real,     0.000275_t_real,     0.000163_t_real &
       &,     0.000081_t_real,     0.000026_t_real,    -0.000007_t_real &
       &,    -0.000024_t_real,    -0.000031_t_real,    -0.000030_t_real &
       &,    -0.000026_t_real,    -0.000021_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 22) /&
       &    -22.000000_t_real,   -21.987733_t_real,   -21.900962_t_real &
       &,   -21.662075_t_real,   -21.193169_t_real,   -20.438191_t_real &
       &,   -19.395784_t_real,   -18.114686_t_real,   -16.652760_t_real &
       &,   -15.081245_t_real,   -13.473392_t_real,   -11.889249_t_real &
       &,   -10.403838_t_real,    -9.043272_t_real,    -7.788749_t_real &
       &,    -6.655782_t_real,    -5.645636_t_real,    -4.728721_t_real &
       &,    -3.918564_t_real,    -3.236079_t_real,    -2.679203_t_real &
       &,    -2.229452_t_real,    -1.868239_t_real,    -1.584282_t_real &
       &,    -1.367641_t_real,    -1.202578_t_real,    -1.071885_t_real &
       &,    -0.963194_t_real,    -0.869152_t_real,    -0.785221_t_real &
       &,    -0.708211_t_real,    -0.635774_t_real,    -0.566351_t_real &
       &,    -0.499189_t_real,    -0.434272_t_real,    -0.372135_t_real &
       &,    -0.313628_t_real,    -0.259667_t_real,    -0.211038_t_real &
       &,    -0.168271_t_real,    -0.131581_t_real,    -0.100878_t_real &
       &,    -0.075811_t_real,    -0.055841_t_real,    -0.040308_t_real &
       &,    -0.028513_t_real,    -0.019763_t_real,    -0.013422_t_real &
       &,    -0.008930_t_real,    -0.005821_t_real/
  Data bscoeffrel(1:50, 22) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000007_t_real,     0.000020_t_real &
       &,     0.000008_t_real,    -0.000119_t_real,    -0.000519_t_real &
       &,    -0.001632_t_real,    -0.004642_t_real,    -0.011581_t_real &
       &,    -0.020535_t_real,    -0.025643_t_real,    -0.028571_t_real &
       &,    -0.031677_t_real,    -0.035622_t_real,    -0.040469_t_real &
       &,    -0.045706_t_real,    -0.049724_t_real,    -0.049866_t_real &
       &,    -0.044743_t_real,    -0.036208_t_real,    -0.027102_t_real &
       &,    -0.018978_t_real,    -0.012277_t_real,    -0.007015_t_real &
       &,    -0.003092_t_real,    -0.000370_t_real,     0.001323_t_real &
       &,     0.002188_t_real,     0.002445_t_real,     0.002307_t_real &
       &,     0.001956_t_real,     0.001527_t_real,     0.001110_t_real &
       &,     0.000749_t_real,     0.000463_t_real,     0.000253_t_real &
       &,     0.000110_t_real,     0.000021_t_real,    -0.000027_t_real &
       &,    -0.000047_t_real,    -0.000050_t_real,    -0.000043_t_real &
       &,    -0.000033_t_real,    -0.000023_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 23) /&
       &    -23.000000_t_real,   -22.986889_t_real,   -22.894097_t_real &
       &,   -22.638583_t_real,   -22.137516_t_real,   -21.333180_t_real &
       &,   -20.227381_t_real,   -18.872351_t_real,   -17.328698_t_real &
       &,   -15.674073_t_real,   -13.981705_t_real,   -12.318730_t_real &
       &,   -10.759975_t_real,    -9.319918_t_real,    -7.986407_t_real &
       &,    -6.784100_t_real,    -5.698833_t_real,    -4.718212_t_real &
       &,    -3.869911_t_real,    -3.170141_t_real,    -2.607650_t_real &
       &,    -2.158792_t_real,    -1.803755_t_real,    -1.529439_t_real &
       &,    -1.321413_t_real,    -1.161203_t_real,    -1.032626_t_real &
       &,    -0.925079_t_real,    -0.832054_t_real,    -0.749163_t_real &
       &,    -0.673172_t_real,    -0.601737_t_real,    -0.533401_t_real &
       &,    -0.467554_t_real,    -0.404298_t_real,    -0.344226_t_real &
       &,    -0.288166_t_real,    -0.236949_t_real,    -0.191234_t_real &
       &,    -0.151411_t_real,    -0.117564_t_real,    -0.089497_t_real &
       &,    -0.066784_t_real,    -0.048843_t_real,    -0.035005_t_real &
       &,    -0.024583_t_real,    -0.016913_t_real,    -0.011399_t_real &
       &,    -0.007525_t_real,    -0.004865_t_real/
  Data bscoeffrel(1:50, 23) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000002_t_real,     0.000010_t_real,     0.000021_t_real &
       &,    -0.000033_t_real,    -0.000320_t_real,    -0.001178_t_real &
       &,    -0.003583_t_real,    -0.010014_t_real,    -0.023153_t_real &
       &,    -0.035923_t_real,    -0.041928_t_real,    -0.045801_t_real &
       &,    -0.050159_t_real,    -0.055518_t_real,    -0.061603_t_real &
       &,    -0.067102_t_real,    -0.069179_t_real,    -0.064834_t_real &
       &,    -0.054412_t_real,    -0.041549_t_real,    -0.029375_t_real &
       &,    -0.019144_t_real,    -0.011059_t_real,    -0.004983_t_real &
       &,    -0.000704_t_real,     0.002027_t_real,     0.003493_t_real &
       &,     0.004000_t_real,     0.003857_t_real,     0.003339_t_real &
       &,     0.002666_t_real,     0.001985_t_real,     0.001383_t_real &
       &,     0.000895_t_real,     0.000529_t_real,     0.000274_t_real &
       &,     0.000111_t_real,     0.000018_t_real,    -0.000024_t_real &
       &,    -0.000035_t_real,    -0.000029_t_real,    -0.000017_t_real &
       &,    -0.000005_t_real,     0.000005_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 24) /&
       &    -24.000000_t_real,   -23.985993_t_real,   -23.886813_t_real &
       &,   -23.613667_t_real,   -23.078550_t_real,   -22.222051_t_real &
       &,   -21.049010_t_real,   -19.614626_t_real,   -17.982315_t_real &
       &,   -16.235193_t_real,   -14.446128_t_real,   -12.689567_t_real &
       &,   -11.037292_t_real,    -9.495343_t_real,    -8.063027_t_real &
       &,    -6.764844_t_real,    -5.582262_t_real,    -4.526206_t_real &
       &,    -3.633078_t_real,    -2.913817_t_real,    -2.349783_t_real &
       &,    -1.910969_t_real,    -1.570754_t_real,    -1.309773_t_real &
       &,    -1.111702_t_real,    -0.960090_t_real,    -0.841300_t_real &
       &,    -0.746092_t_real,    -0.667894_t_real,    -0.601441_t_real &
       &,    -0.542484_t_real,    -0.487885_t_real,    -0.435643_t_real &
       &,    -0.384765_t_real,    -0.335078_t_real,    -0.287025_t_real &
       &,    -0.241390_t_real,    -0.199042_t_real,    -0.160752_t_real &
       &,    -0.127082_t_real,    -0.098314_t_real,    -0.074434_t_real &
       &,    -0.055168_t_real,    -0.040044_t_real,    -0.028481_t_real &
       &,    -0.019858_t_real,    -0.013578_t_real,    -0.009109_t_real &
       &,    -0.005996_t_real,    -0.003873_t_real/
  Data bscoeffrel(1:50, 24) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000003_t_real &
       &,    -0.000008_t_real,    -0.000017_t_real,    -0.000026_t_real &
       &,    -0.000024_t_real,     0.000005_t_real,     0.000033_t_real &
       &,    -0.000140_t_real,    -0.000782_t_real,    -0.002475_t_real &
       &,    -0.007125_t_real,    -0.019279_t_real,    -0.040823_t_real &
       &,    -0.057248_t_real,    -0.064460_t_real,    -0.069612_t_real &
       &,    -0.075650_t_real,    -0.083613_t_real,    -0.094080_t_real &
       &,    -0.106842_t_real,    -0.119992_t_real,    -0.130145_t_real &
       &,    -0.135411_t_real,    -0.136557_t_real,    -0.134124_t_real &
       &,    -0.127640_t_real,    -0.116977_t_real,    -0.102891_t_real &
       &,    -0.086713_t_real,    -0.069915_t_real,    -0.053817_t_real &
       &,    -0.039459_t_real,    -0.027522_t_real,    -0.018265_t_real &
       &,    -0.011594_t_real,    -0.007168_t_real,    -0.004504_t_real &
       &,    -0.003071_t_real,    -0.002389_t_real,    -0.002083_t_real &
       &,    -0.001908_t_real,    -0.001736_t_real,    -0.001525_t_real &
       &,    -0.001280_t_real,    -0.001023_t_real,    -0.000782_t_real &
       &,    -0.000573_t_real,    -0.000403_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 25) /&
       &    -25.000000_t_real,   -24.985126_t_real,   -24.879752_t_real &
       &,   -24.589493_t_real,   -24.021431_t_real,   -23.114965_t_real &
       &,   -21.878465_t_real,   -20.370283_t_real,   -18.657558_t_real &
       &,   -16.828836_t_real,   -14.957866_t_real,   -13.126977_t_real &
       &,   -11.402412_t_real,    -9.784668_t_real,    -8.287133_t_real &
       &,    -6.928041_t_real,    -5.692618_t_real,    -4.610523_t_real &
       &,    -3.714822_t_real,    -3.002235_t_real,    -2.443993_t_real &
       &,    -2.009023_t_real,    -1.674757_t_real,    -1.422334_t_real &
       &,    -1.230759_t_real,    -1.080741_t_real,    -0.958795_t_real &
       &,    -0.856371_t_real,    -0.767697_t_real,    -0.688530_t_real &
       &,    -0.615728_t_real,    -0.547155_t_real,    -0.481640_t_real &
       &,    -0.418841_t_real,    -0.359040_t_real,    -0.302883_t_real &
       &,    -0.251138_t_real,    -0.204490_t_real,    -0.163411_t_real &
       &,    -0.128097_t_real,    -0.098468_t_real,    -0.074203_t_real &
       &,    -0.054802_t_real,    -0.039656_t_real,    -0.028109_t_real &
       &,    -0.019513_t_real,    -0.013263_t_real,    -0.008825_t_real &
       &,    -0.005748_t_real,    -0.003664_t_real/
  Data bscoeffrel(1:50, 25) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000003_t_real,     0.000014_t_real,    -0.000003_t_real &
       &,    -0.000247_t_real,    -0.001132_t_real,    -0.003723_t_real &
       &,    -0.011039_t_real,    -0.028964_t_real,    -0.054503_t_real &
       &,    -0.069088_t_real,    -0.075279_t_real,    -0.080420_t_real &
       &,    -0.086333_t_real,    -0.092869_t_real,    -0.098579_t_real &
       &,    -0.100250_t_real,    -0.093984_t_real,    -0.079274_t_real &
       &,    -0.060414_t_real,    -0.042159_t_real,    -0.026812_t_real &
       &,    -0.014821_t_real,    -0.005940_t_real,     0.000232_t_real &
       &,     0.004117_t_real,     0.006149_t_real,     0.006779_t_real &
       &,     0.006452_t_real,     0.005570_t_real,     0.004457_t_real &
       &,     0.003340_t_real,     0.002351_t_real,     0.001551_t_real &
       &,     0.000951_t_real,     0.000536_t_real,     0.000277_t_real &
       &,     0.000135_t_real,     0.000075_t_real,     0.000062_t_real &
       &,     0.000071_t_real,     0.000083_t_real,     0.000090_t_real &
       &,     0.000089_t_real,     0.000080_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 26) /&
       &    -26.000000_t_real,   -25.984213_t_real,   -25.872313_t_real &
       &,   -25.564034_t_real,   -24.961340_t_real,   -24.002435_t_real &
       &,   -22.699068_t_real,   -21.112294_t_real,   -19.313136_t_real &
       &,   -17.394353_t_real,   -15.431177_t_real,   -13.512769_t_real &
       &,   -11.698577_t_real,    -9.989326_t_real,    -8.410877_t_real &
       &,    -6.970900_t_real,    -5.669875_t_real,    -4.552643_t_real &
       &,    -3.645983_t_real,    -2.934963_t_real,    -2.383699_t_real &
       &,    -1.958271_t_real,    -1.633343_t_real,    -1.386958_t_real &
       &,    -1.197913_t_real,    -1.048821_t_real,    -0.927564_t_real &
       &,    -0.825934_t_real,    -0.738041_t_real,    -0.659487_t_real &
       &,    -0.587097_t_real,    -0.518834_t_real,    -0.453696_t_real &
       &,    -0.391521_t_real,    -0.332721_t_real,    -0.277999_t_real &
       &,    -0.228107_t_real,    -0.183653_t_real,    -0.144996_t_real &
       &,    -0.112207_t_real,    -0.085083_t_real,    -0.063198_t_real &
       &,    -0.045975_t_real,    -0.032750_t_real,    -0.022840_t_real &
       &,    -0.015593_t_real,    -0.010420_t_real,    -0.006814_t_real &
       &,    -0.004360_t_real,    -0.002729_t_real/
  Data bscoeffrel(1:50, 26) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000003_t_real,     0.000008_t_real,    -0.000027_t_real &
       &,    -0.000303_t_real,    -0.001236_t_real,    -0.003975_t_real &
       &,    -0.011656_t_real,    -0.028965_t_real,    -0.048560_t_real &
       &,    -0.057601_t_real,    -0.061617_t_real,    -0.065113_t_real &
       &,    -0.068853_t_real,    -0.072329_t_real,    -0.074020_t_real &
       &,    -0.071501_t_real,    -0.063076_t_real,    -0.050102_t_real &
       &,    -0.036058_t_real,    -0.023568_t_real,    -0.013565_t_real &
       &,    -0.006053_t_real,    -0.000741_t_real,     0.002709_t_real &
       &,     0.004642_t_real,     0.005400_t_real,     0.005322_t_real &
       &,     0.004725_t_real,     0.003878_t_real,     0.002979_t_real &
       &,     0.002154_t_real,     0.001466_t_real,     0.000931_t_real &
       &,     0.000542_t_real,     0.000278_t_real,     0.000112_t_real &
       &,     0.000020_t_real,    -0.000021_t_real,    -0.000032_t_real &
       &,    -0.000027_t_real,    -0.000016_t_real,    -0.000004_t_real &
       &,     0.000004_t_real,     0.000009_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 27) /&
       &    -27.000000_t_real,   -26.983276_t_real,   -26.864666_t_real &
       &,   -26.537860_t_real,   -25.899642_t_real,   -24.887155_t_real &
       &,   -23.515523_t_real,   -21.848269_t_real,   -19.960640_t_real &
       &,   -17.948667_t_real,   -15.890168_t_real,   -13.879940_t_real &
       &,   -11.970380_t_real,   -10.167343_t_real,    -8.504023_t_real &
       &,    -6.981623_t_real,    -5.621997_t_real,    -4.477990_t_real &
       &,    -3.566204_t_real,    -2.860093_t_real,    -2.317575_t_real &
       &,    -1.902124_t_real,    -1.586149_t_real,    -1.346076_t_real &
       &,    -1.161036_t_real,    -1.014785_t_real,    -0.895888_t_real &
       &,    -0.796284_t_real,    -0.710039_t_real,    -0.632741_t_real &
       &,    -0.561301_t_real,    -0.493848_t_real,    -0.429565_t_real &
       &,    -0.368439_t_real,    -0.310974_t_real,    -0.257894_t_real &
       &,    -0.209910_t_real,    -0.167550_t_real,    -0.131074_t_real &
       &,    -0.100449_t_real,    -0.075385_t_real,    -0.055388_t_real &
       &,    -0.039834_t_real,    -0.028035_t_real,    -0.019308_t_real &
       &,    -0.013010_t_real,    -0.008576_t_real,    -0.005529_t_real &
       &,    -0.003487_t_real,    -0.002150_t_real/
  Data bscoeffrel(1:50, 27) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000002_t_real,     0.000004_t_real,    -0.000042_t_real &
       &,    -0.000317_t_real,    -0.001211_t_real,    -0.003846_t_real &
       &,    -0.011111_t_real,    -0.025743_t_real,    -0.038814_t_real &
       &,    -0.043992_t_real,    -0.046455_t_real,    -0.048601_t_real &
       &,    -0.050641_t_real,    -0.051990_t_real,    -0.051418_t_real &
       &,    -0.047471_t_real,    -0.039828_t_real,    -0.030129_t_real &
       &,    -0.020619_t_real,    -0.012608_t_real,    -0.006425_t_real &
       &,    -0.001946_t_real,     0.001078_t_real,     0.002906_t_real &
       &,     0.003790_t_real,     0.003975_t_real,     0.003690_t_real &
       &,     0.003141_t_real,     0.002494_t_real,     0.001863_t_real &
       &,     0.001313_t_real,     0.000870_t_real,     0.000536_t_real &
       &,     0.000298_t_real,     0.000138_t_real,     0.000040_t_real &
       &,    -0.000014_t_real,    -0.000038_t_real,    -0.000044_t_real &
       &,    -0.000040_t_real,    -0.000032_t_real,    -0.000023_t_real &
       &,    -0.000015_t_real,    -0.000009_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 28) /&
       &    -28.000000_t_real,   -27.982314_t_real,   -27.856813_t_real &
       &,   -27.510982_t_real,   -26.836367_t_real,   -25.769183_t_real &
       &,   -24.327901_t_real,   -22.578317_t_real,   -20.600179_t_real &
       &,   -18.491925_t_real,   -16.335118_t_real,   -14.228759_t_real &
       &,   -12.218996_t_real,   -10.320499_t_real,    -8.568290_t_real &
       &,    -6.965288_t_real,    -5.555323_t_real,    -4.392411_t_real &
       &,    -3.480499_t_real,    -2.782018_t_real,    -2.249633_t_real &
       &,    -1.844622_t_real,    -1.537686_t_real,    -1.304362_t_real &
       &,    -1.124185_t_real,    -0.981682_t_real,    -0.865845_t_real &
       &,    -0.768727_t_real,    -0.684420_t_real,    -0.608588_t_real &
       &,    -0.538293_t_real,    -0.471848_t_real,    -0.408608_t_real &
       &,    -0.348686_t_real,    -0.292644_t_real,    -0.241209_t_real &
       &,    -0.195043_t_real,    -0.154598_t_real,    -0.120048_t_real &
       &,    -0.091282_t_real,    -0.067941_t_real,    -0.049485_t_real &
       &,    -0.035262_t_real,    -0.024579_t_real,    -0.016756_t_real &
       &,    -0.011170_t_real,    -0.007281_t_real,    -0.004640_t_real &
       &,    -0.002890_t_real,    -0.001760_t_real/
  Data bscoeffrel(1:50, 28) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,    -0.000045_t_real &
       &,    -0.000279_t_real,    -0.001023_t_real,    -0.003225_t_real &
       &,    -0.009119_t_real,    -0.019457_t_real,    -0.026813_t_real &
       &,    -0.029464_t_real,    -0.030805_t_real,    -0.031923_t_real &
       &,    -0.032789_t_real,    -0.032930_t_real,    -0.031551_t_real &
       &,    -0.027989_t_real,    -0.022498_t_real,    -0.016306_t_real &
       &,    -0.010628_t_real,    -0.006038_t_real,    -0.002608_t_real &
       &,    -0.000208_t_real,     0.001339_t_real,     0.002202_t_real &
       &,     0.002542_t_real,     0.002508_t_real,     0.002238_t_real &
       &,     0.001850_t_real,     0.001434_t_real,     0.001049_t_real &
       &,     0.000724_t_real,     0.000470_t_real,     0.000281_t_real &
       &,     0.000149_t_real,     0.000063_t_real,     0.000011_t_real &
       &,    -0.000017_t_real,    -0.000029_t_real,    -0.000031_t_real &
       &,    -0.000028_t_real,    -0.000022_t_real,    -0.000017_t_real &
       &,    -0.000012_t_real,    -0.000008_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 29) /&
       &    -29.000000_t_real,   -28.981296_t_real,   -28.848507_t_real &
       &,   -28.482568_t_real,   -27.769540_t_real,   -26.644618_t_real &
       &,   -25.129312_t_real,   -23.291263_t_real,   -21.214569_t_real &
       &,   -18.998944_t_real,   -16.730397_t_real,   -14.510545_t_real &
       &,   -12.381443_t_real,   -10.368328_t_real,    -8.504465_t_real &
       &,    -6.804332_t_real,    -5.332328_t_real,    -4.141419_t_real &
       &,    -3.225636_t_real,    -2.539125_t_real,    -2.028173_t_real &
       &,    -1.647725_t_real,    -1.363459_t_real,    -1.149285_t_real &
       &,    -0.985554_t_real,    -0.857906_t_real,    -0.755945_t_real &
       &,    -0.671981_t_real,    -0.600211_t_real,    -0.536347_t_real &
       &,    -0.477442_t_real,    -0.421745_t_real,    -0.368492_t_real &
       &,    -0.317637_t_real,    -0.269575_t_real,    -0.224894_t_real &
       &,    -0.184191_t_real,    -0.147946_t_real,    -0.116451_t_real &
       &,    -0.089772_t_real,    -0.067758_t_real,    -0.050064_t_real &
       &,    -0.036211_t_real,    -0.025640_t_real,    -0.017775_t_real &
       &,    -0.012065_t_real,    -0.008019_t_real,    -0.005219_t_real &
       &,    -0.003325_t_real,    -0.002074_t_real/
  Data bscoeffrel(1:50, 29) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000004_t_real &
       &,    -0.000011_t_real,    -0.000023_t_real,    -0.000033_t_real &
       &,    -0.000027_t_real,    -0.000001_t_real,    -0.000011_t_real &
       &,    -0.000087_t_real,    -0.000087_t_real,     0.000111_t_real &
       &,     0.000492_t_real,     0.000652_t_real,     0.000459_t_real &
       &,     0.000470_t_real,     0.000810_t_real,     0.001132_t_real &
       &,     0.000678_t_real,    -0.001689_t_real,    -0.007130_t_real &
       &,    -0.016027_t_real,    -0.027337_t_real,    -0.038955_t_real &
       &,    -0.048737_t_real,    -0.055190_t_real,    -0.057677_t_real &
       &,    -0.056338_t_real,    -0.051872_t_real,    -0.045271_t_real &
       &,    -0.037573_t_real,    -0.029700_t_real,    -0.022358_t_real &
       &,    -0.016016_t_real,    -0.010909_t_real,    -0.007081_t_real &
       &,    -0.004426_t_real,    -0.002737_t_real,    -0.001763_t_real &
       &,    -0.001256_t_real,    -0.001012_t_real,    -0.000885_t_real &
       &,    -0.000791_t_real,    -0.000693_t_real,    -0.000583_t_real &
       &,    -0.000467_t_real,    -0.000357_t_real,    -0.000261_t_real &
       &,    -0.000183_t_real,    -0.000123_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 30) /&
       &    -30.000000_t_real,   -29.980317_t_real,   -29.840494_t_real &
       &,   -29.455131_t_real,   -28.705144_t_real,   -27.525284_t_real &
       &,   -25.940540_t_real,   -24.020815_t_real,   -21.855356_t_real &
       &,   -19.545421_t_real,   -17.183194_t_real,   -14.871745_t_real &
       &,   -12.650496_t_real,   -10.555608_t_real,    -8.618274_t_real &
       &,    -6.869046_t_real,    -5.384066_t_real,    -4.203533_t_real &
       &,    -3.302924_t_real,    -2.625574_t_real,    -2.116274_t_real &
       &,    -1.733058_t_real,    -1.444380_t_real,    -1.225071_t_real &
       &,    -1.055531_t_real,    -0.921364_t_real,    -0.812149_t_real &
       &,    -0.720191_t_real,    -0.639789_t_real,    -0.566902_t_real &
       &,    -0.498958_t_real,    -0.434639_t_real,    -0.373595_t_real &
       &,    -0.316125_t_real,    -0.262861_t_real,    -0.214498_t_real &
       &,    -0.171601_t_real,    -0.134489_t_real,    -0.103198_t_real &
       &,    -0.077495_t_real,    -0.056928_t_real,    -0.040899_t_real &
       &,    -0.028728_t_real,    -0.019726_t_real,    -0.013238_t_real &
       &,    -0.008682_t_real,    -0.005563_t_real,    -0.003482_t_real &
       &,    -0.002129_t_real,    -0.001271_t_real/
  Data bscoeffrel(1:50, 30) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 31) /&
       &    -31.000000_t_real,   -30.979339_t_real,   -30.832484_t_real &
       &,   -30.427698_t_real,   -29.640862_t_real,   -28.406554_t_real &
       &,   -26.753300_t_real,   -24.753405_t_real,   -22.501520_t_real &
       &,   -20.100312_t_real,   -17.649044_t_real,   -15.250953_t_real &
       &,   -12.945543_t_real,   -10.778859_t_real,    -8.781496_t_real &
       &,    -7.003354_t_real,    -5.524772_t_real,    -4.367817_t_real &
       &,    -3.488815_t_real,    -2.822296_t_real,    -2.313664_t_real &
       &,    -1.924388_t_real,    -1.624475_t_real,    -1.389315_t_real &
       &,    -1.200873_t_real,    -1.047105_t_real,    -0.919824_t_real &
       &,    -0.813036_t_real,    -0.722123_t_real,    -0.643506_t_real &
       &,    -0.574421_t_real,    -0.512727_t_real,    -0.456759_t_real &
       &,    -0.405249_t_real,    -0.357304_t_real,    -0.312387_t_real &
       &,    -0.270266_t_real,    -0.230949_t_real,    -0.194605_t_real &
       &,    -0.161488_t_real,    -0.131842_t_real,    -0.105836_t_real &
       &,    -0.083511_t_real,    -0.064766_t_real,    -0.049370_t_real &
       &,    -0.036998_t_real,    -0.027261_t_real,    -0.019752_t_real &
       &,    -0.014076_t_real,    -0.009865_t_real/
  Data bscoeffrel(1:50, 31) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000001_t_real &
       &,    -0.000009_t_real,    -0.000038_t_real,    -0.000080_t_real &
       &,    -0.000077_t_real,    -0.000023_t_real,     0.000058_t_real &
       &,     0.000061_t_real,    -0.000106_t_real,    -0.000228_t_real &
       &,    -0.000170_t_real,     0.000026_t_real,     0.000183_t_real &
       &,    -0.000119_t_real,    -0.001637_t_real,    -0.005215_t_real &
       &,    -0.011033_t_real,    -0.018219_t_real,    -0.025584_t_real &
       &,    -0.032307_t_real,    -0.037921_t_real,    -0.042108_t_real &
       &,    -0.044613_t_real,    -0.045247_t_real,    -0.043949_t_real &
       &,    -0.040848_t_real,    -0.036296_t_real,    -0.030817_t_real &
       &,    -0.025000_t_real,    -0.019376_t_real,    -0.014349_t_real &
       &,    -0.010177_t_real,    -0.006976_t_real,    -0.004724_t_real &
       &,    -0.003293_t_real,    -0.002484_t_real,    -0.002084_t_real &
       &,    -0.001903_t_real,    -0.001802_t_real,    -0.001697_t_real &
       &,    -0.001555_t_real,    -0.001371_t_real,    -0.001162_t_real &
       &,    -0.000946_t_real,    -0.000742_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 32) /&
       &    -32.000000_t_real,   -31.978347_t_real,   -31.824342_t_real &
       &,   -31.399814_t_real,   -30.575620_t_real,   -29.286352_t_real &
       &,   -27.564041_t_real,   -25.483492_t_real,   -23.144830_t_real &
       &,   -20.652170_t_real,   -18.112368_t_real,   -15.627640_t_real &
       &,   -13.240089_t_real,   -11.003548_t_real,    -8.951121_t_real &
       &,    -7.151714_t_real,    -5.681553_t_real,    -4.540417_t_real &
       &,    -3.667333_t_real,    -2.993680_t_real,    -2.470448_t_real &
       &,    -2.062740_t_real,    -1.740333_t_real,    -1.479920_t_real &
       &,    -1.266793_t_real,    -1.091682_t_real,    -0.947546_t_real &
       &,    -0.828170_t_real,    -0.727927_t_real,    -0.641926_t_real &
       &,    -0.566202_t_real,    -0.497827_t_real,    -0.434898_t_real &
       &,    -0.376396_t_real,    -0.321945_t_real,    -0.271560_t_real &
       &,    -0.225462_t_real,    -0.183939_t_real,    -0.147259_t_real &
       &,    -0.115579_t_real,    -0.088886_t_real,    -0.066968_t_real &
       &,    -0.049432_t_real,    -0.035758_t_real,    -0.025355_t_real &
       &,    -0.017628_t_real,    -0.012020_t_real,    -0.008038_t_real &
       &,    -0.005272_t_real,    -0.003392_t_real/
  Data bscoeffrel(1:50, 32) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000001_t_real,    -0.000004_t_real &
       &,    -0.000028_t_real,    -0.000115_t_real,    -0.000231_t_real &
       &,    -0.000216_t_real,    -0.000065_t_real,     0.000112_t_real &
       &,    -0.000054_t_real,    -0.000646_t_real,    -0.000928_t_real &
       &,    -0.000652_t_real,    -0.000036_t_real,     0.000233_t_real &
       &,    -0.001386_t_real,    -0.007284_t_real,    -0.018962_t_real &
       &,    -0.034503_t_real,    -0.049999_t_real,    -0.062846_t_real &
       &,    -0.072084_t_real,    -0.077437_t_real,    -0.078877_t_real &
       &,    -0.076588_t_real,    -0.071039_t_real,    -0.062996_t_real &
       &,    -0.053429_t_real,    -0.043344_t_real,    -0.033607_t_real &
       &,    -0.024852_t_real,    -0.017480_t_real,    -0.011684_t_real &
       &,    -0.007476_t_real,    -0.004702_t_real,    -0.003074_t_real &
       &,    -0.002245_t_real,    -0.001882_t_real,    -0.001728_t_real &
       &,    -0.001619_t_real,    -0.001479_t_real,    -0.001292_t_real &
       &,    -0.001074_t_real,    -0.000850_t_real,    -0.000643_t_real &
       &,    -0.000466_t_real,    -0.000325_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 33) /&
       &    -33.000000_t_real,   -32.977340_t_real,   -32.816071_t_real &
       &,   -32.371484_t_real,   -31.509442_t_real,   -30.164723_t_real &
       &,   -28.372819_t_real,   -26.211183_t_real,   -23.785364_t_real &
       &,   -21.201177_t_real,   -18.573240_t_real,   -16.001901_t_real &
       &,   -13.534226_t_real,   -11.229466_t_real,    -9.127255_t_real &
       &,    -7.312408_t_real,    -5.849310_t_real,    -4.713642_t_real &
       &,    -3.831792_t_real,    -3.138725_t_real,    -2.592348_t_real &
       &,    -2.157737_t_real,    -1.805112_t_real,    -1.515826_t_real &
       &,    -1.279303_t_real,    -1.087507_t_real,    -0.932413_t_real &
       &,    -0.805897_t_real,    -0.700463_t_real,    -0.609919_t_real &
       &,    -0.529728_t_real,    -0.457003_t_real,    -0.390235_t_real &
       &,    -0.328865_t_real,    -0.272862_t_real,    -0.222419_t_real &
       &,    -0.177776_t_real,    -0.139113_t_real,    -0.106455_t_real &
       &,    -0.079619_t_real,    -0.058190_t_real,    -0.041566_t_real &
       &,    -0.029030_t_real,    -0.019830_t_real,    -0.013254_t_real &
       &,    -0.008669_t_real,    -0.005550_t_real,    -0.003477_t_real &
       &,    -0.002132_t_real,    -0.001279_t_real/
  Data bscoeffrel(1:50, 33) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000000_t_real,    -0.000009_t_real &
       &,    -0.000060_t_real,    -0.000238_t_real,    -0.000453_t_real &
       &,    -0.000406_t_real,    -0.000110_t_real,     0.000150_t_real &
       &,    -0.000421_t_real,    -0.001607_t_real,    -0.001958_t_real &
       &,    -0.001225_t_real,    -0.000010_t_real,    -0.000069_t_real &
       &,    -0.005082_t_real,    -0.019451_t_real,    -0.042648_t_real &
       &,    -0.067382_t_real,    -0.087340_t_real,    -0.100580_t_real &
       &,    -0.107191_t_real,    -0.107729_t_real,    -0.102954_t_real &
       &,    -0.093895_t_real,    -0.081833_t_real,    -0.068181_t_real &
       &,    -0.054287_t_real,    -0.041248_t_real,    -0.029817_t_real &
       &,    -0.020418_t_real,    -0.013204_t_real,    -0.008101_t_real &
       &,    -0.004841_t_real,    -0.003005_t_real,    -0.002121_t_real &
       &,    -0.001762_t_real,    -0.001613_t_real,    -0.001496_t_real &
       &,    -0.001337_t_real,    -0.001131_t_real,    -0.000904_t_real &
       &,    -0.000684_t_real,    -0.000493_t_real,    -0.000339_t_real &
       &,    -0.000224_t_real,    -0.000142_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 34) /&
       &    -34.000000_t_real,   -33.976319_t_real,   -33.807681_t_real &
       &,   -33.342747_t_real,   -32.442419_t_real,   -31.041845_t_real &
       &,   -29.179937_t_real,   -26.936980_t_real,   -24.423822_t_real &
       &,   -21.748395_t_real,   -19.032920_t_real,   -16.375468_t_real &
       &,   -13.830018_t_real,   -11.459193_t_real,    -9.313074_t_real &
       &,    -7.487112_t_real,    -6.027287_t_real,    -4.886119_t_real &
       &,    -3.984589_t_real,    -3.267251_t_real,    -2.696469_t_real &
       &,    -2.234597_t_real,    -1.854502_t_real,    -1.542658_t_real &
       &,    -1.290473_t_real,    -1.088820_t_real,    -0.927452_t_real &
       &,    -0.796291_t_real,    -0.686698_t_real,    -0.592119_t_real &
       &,    -0.508150_t_real,    -0.432229_t_real,    -0.363158_t_real &
       &,    -0.300606_t_real,    -0.244663_t_real,    -0.195519_t_real &
       &,    -0.153253_t_real,    -0.117732_t_real,    -0.088593_t_real &
       &,    -0.065276_t_real,    -0.047078_t_real,    -0.033230_t_real &
       &,    -0.022952_t_real,    -0.015513_t_real,    -0.010259_t_real &
       &,    -0.006638_t_real,    -0.004202_t_real,    -0.002603_t_real &
       &,    -0.001577_t_real,    -0.000935_t_real/
  Data bscoeffrel(1:50, 34) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000008_t_real &
       &,    -0.000053_t_real,    -0.000204_t_real,    -0.000369_t_real &
       &,    -0.000314_t_real,    -0.000071_t_real,     0.000070_t_real &
       &,    -0.000551_t_real,    -0.001467_t_real,    -0.001584_t_real &
       &,    -0.000852_t_real,     0.000071_t_real,    -0.000651_t_real &
       &,    -0.006453_t_real,    -0.019666_t_real,    -0.036342_t_real &
       &,    -0.050245_t_real,    -0.059165_t_real,    -0.063345_t_real &
       &,    -0.063432_t_real,    -0.060102_t_real,    -0.054120_t_real &
       &,    -0.046359_t_real,    -0.037746_t_real,    -0.029168_t_real &
       &,    -0.021354_t_real,    -0.014790_t_real,    -0.009682_t_real &
       &,    -0.005988_t_real,    -0.003492_t_real,    -0.001911_t_real &
       &,    -0.000969_t_real,    -0.000444_t_real,    -0.000175_t_real &
       &,    -0.000052_t_real,    -0.000006_t_real,     0.000004_t_real &
       &,     0.000000_t_real,    -0.000007_t_real,    -0.000011_t_real &
       &,    -0.000013_t_real,    -0.000012_t_real,    -0.000010_t_real &
       &,    -0.000007_t_real,    -0.000005_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 35) /&
       &    -35.000000_t_real,   -34.975283_t_real,   -34.799152_t_real &
       &,   -34.313534_t_real,   -33.374393_t_real,   -31.917408_t_real &
       &,   -29.984841_t_real,   -27.660010_t_real,   -25.058839_t_real &
       &,   -22.291938_t_real,   -19.488675_t_real,   -16.744865_t_real &
       &,   -14.122708_t_real,   -11.686937_t_real,    -9.501121_t_real &
       &,    -7.664776_t_real,    -6.200694_t_real,    -5.041811_t_real &
       &,    -4.111862_t_real,    -3.366076_t_real,    -2.764467_t_real &
       &,    -2.268840_t_real,    -1.859639_t_real,    -1.528002_t_real &
       &,    -1.264759_t_real,    -1.057823_t_real,    -0.893984_t_real &
       &,    -0.761202_t_real,    -0.649969_t_real,    -0.553654_t_real &
       &,    -0.468176_t_real,    -0.391393_t_real,    -0.322429_t_real &
       &,    -0.261093_t_real,    -0.207442_t_real,    -0.161487_t_real &
       &,    -0.123046_t_real,    -0.091694_t_real,    -0.066785_t_real &
       &,    -0.047521_t_real,    -0.033020_t_real,    -0.022401_t_real &
       &,    -0.014833_t_real,    -0.009585_t_real,    -0.006044_t_real &
       &,    -0.003718_t_real,    -0.002231_t_real,    -0.001306_t_real &
       &,    -0.000745_t_real,    -0.000415_t_real/
  Data bscoeffrel(1:50, 35) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000006_t_real &
       &,    -0.000034_t_real,    -0.000129_t_real,    -0.000221_t_real &
       &,    -0.000178_t_real,    -0.000031_t_real,     0.000010_t_real &
       &,    -0.000433_t_real,    -0.000927_t_real,    -0.000899_t_real &
       &,    -0.000396_t_real,     0.000062_t_real,    -0.000900_t_real &
       &,    -0.005410_t_real,    -0.013451_t_real,    -0.021347_t_real &
       &,    -0.026677_t_real,    -0.029352_t_real,    -0.029809_t_real &
       &,    -0.028468_t_real,    -0.025751_t_real,    -0.022110_t_real &
       &,    -0.018012_t_real,    -0.013897_t_real,    -0.010130_t_real &
       &,    -0.006960_t_real,    -0.004497_t_real,    -0.002729_t_real &
       &,    -0.001551_t_real,    -0.000821_t_real,    -0.000400_t_real &
       &,    -0.000174_t_real,    -0.000064_t_real,    -0.000017_t_real &
       &,    -0.000002_t_real,     0.000000_t_real,    -0.000003_t_real &
       &,    -0.000005_t_real,    -0.000007_t_real,    -0.000007_t_real &
       &,    -0.000006_t_real,    -0.000005_t_real,    -0.000003_t_real &
       &,    -0.000002_t_real,    -0.000001_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 36) /&
       &    -36.000000_t_real,   -35.974232_t_real,   -35.790483_t_real &
       &,   -35.283845_t_real,   -34.305372_t_real,   -32.791424_t_real &
       &,   -30.787545_t_real,   -28.380305_t_real,   -25.690430_t_real &
       &,   -22.831867_t_real,   -19.940440_t_real,   -17.110169_t_real &
       &,   -14.412084_t_real,   -11.912777_t_real,    -9.690880_t_real &
       &,    -7.842823_t_real,    -6.365508_t_real,    -5.178365_t_real &
       &,    -4.214986_t_real,    -3.436345_t_real,    -2.797142_t_real &
       &,    -2.265860_t_real,    -1.831607_t_real,    -1.486789_t_real &
       &,    -1.218873_t_real,    -1.011639_t_real,    -0.848861_t_real &
       &,    -0.716970_t_real,    -0.606084_t_real,    -0.509842_t_real &
       &,    -0.424649_t_real,    -0.348795_t_real,    -0.281656_t_real &
       &,    -0.223088_t_real,    -0.173020_t_real,    -0.131225_t_real &
       &,    -0.097231_t_real,    -0.070327_t_real,    -0.049624_t_real &
       &,    -0.034144_t_real,    -0.022900_t_real,    -0.014966_t_real &
       &,    -0.009529_t_real,    -0.005910_t_real,    -0.003570_t_real &
       &,    -0.002099_t_real,    -0.001202_t_real,    -0.000670_t_real &
       &,    -0.000363_t_real,    -0.000191_t_real/
  Data bscoeffrel(1:50, 36) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 37) /&
       &    -37.000000_t_real,   -36.973206_t_real,   -36.782010_t_real &
       &,   -36.254814_t_real,   -35.238051_t_real,   -33.669177_t_real &
       &,   -31.597198_t_real,   -29.112370_t_real,   -26.340131_t_real &
       &,   -23.398677_t_real,   -20.429707_t_real,   -17.526621_t_real &
       &,   -14.769435_t_real,   -12.227526_t_real,    -9.994509_t_real &
       &,    -8.156846_t_real,    -6.685661_t_real,    -5.495022_t_real &
       &,    -4.530336_t_real,    -3.748333_t_real,    -3.100325_t_real &
       &,    -2.562383_t_real,    -2.124413_t_real,    -1.773305_t_real &
       &,    -1.491993_t_real,    -1.265020_t_real,    -1.082571_t_real &
       &,    -0.940081_t_real,    -0.834248_t_real,    -0.759161_t_real &
       &,    -0.704513_t_real,    -0.659706_t_real,    -0.618551_t_real &
       &,    -0.578281_t_real,    -0.537527_t_real,    -0.495525_t_real &
       &,    -0.451970_t_real,    -0.407012_t_real,    -0.361210_t_real &
       &,    -0.315434_t_real,    -0.270728_t_real,    -0.228165_t_real &
       &,    -0.188710_t_real,    -0.153124_t_real,    -0.121891_t_real &
       &,    -0.095206_t_real,    -0.072989_t_real,    -0.054945_t_real &
       &,    -0.040632_t_real,    -0.029528_t_real/
  Data bscoeffrel(1:50, 37) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000001_t_real &
       &,    -0.000003_t_real,    -0.000006_t_real,    -0.000006_t_real &
       &,    -0.000002_t_real,     0.000003_t_real,    -0.000010_t_real &
       &,    -0.000023_t_real,    -0.000011_t_real,     0.000003_t_real &
       &,    -0.000047_t_real,    -0.000090_t_real,    -0.000058_t_real &
       &,     0.000002_t_real,    -0.000073_t_real,    -0.000478_t_real &
       &,    -0.001005_t_real,    -0.001032_t_real,    -0.000498_t_real &
       &,     0.000165_t_real,     0.000349_t_real,    -0.000776_t_real &
       &,    -0.004304_t_real,    -0.011433_t_real,    -0.022856_t_real &
       &,    -0.037665_t_real,    -0.052324_t_real,    -0.062371_t_real &
       &,    -0.067283_t_real,    -0.068803_t_real,    -0.067460_t_real &
       &,    -0.063227_t_real,    -0.056481_t_real,    -0.048038_t_real &
       &,    -0.038892_t_real,    -0.029977_t_real,    -0.022021_t_real &
       &,    -0.015480_t_real,    -0.010525_t_real,    -0.007085_t_real &
       &,    -0.004914_t_real,    -0.003682_t_real,    -0.003048_t_real &
       &,    -0.002729_t_real,    -0.002527_t_real,    -0.002328_t_real &
       &,    -0.002088_t_real,    -0.001804_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 38) /&
       &    -38.000000_t_real,   -37.972169_t_real,   -37.773432_t_real &
       &,   -37.225422_t_real,   -36.170018_t_real,   -34.545945_t_real &
       &,   -32.405622_t_real,   -29.843214_t_real,   -26.988564_t_real &
       &,   -23.964830_t_real,   -20.918686_t_real,   -17.944098_t_real &
       &,   -15.129431_t_real,   -12.548329_t_real,   -10.307362_t_real &
       &,    -8.476749_t_real,    -7.004149_t_real,    -5.806021_t_real &
       &,    -4.835848_t_real,    -4.040688_t_real,    -3.374614_t_real &
       &,    -2.819375_t_real,    -2.362256_t_real,    -1.987322_t_real &
       &,    -1.681355_t_real,    -1.438317_t_real,    -1.254052_t_real &
       &,    -1.117491_t_real,    -1.012365_t_real,    -0.925173_t_real &
       &,    -0.847794_t_real,    -0.775816_t_real,    -0.706732_t_real &
       &,    -0.639068_t_real,    -0.572123_t_real,    -0.505879_t_real &
       &,    -0.440906_t_real,    -0.378177_t_real,    -0.318846_t_real &
       &,    -0.264022_t_real,    -0.214599_t_real,    -0.171153_t_real &
       &,    -0.133909_t_real,    -0.102764_t_real,    -0.077347_t_real &
       &,    -0.057093_t_real,    -0.041329_t_real,    -0.029338_t_real &
       &,    -0.020423_t_real,    -0.013941_t_real/
  Data bscoeffrel(1:50, 38) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 39) /&
       &    -39.000000_t_real,   -38.971107_t_real,   -38.764629_t_real &
       &,   -38.195273_t_real,   -37.100331_t_real,   -35.419856_t_real &
       &,   -33.209500_t_real,   -30.567418_t_real,   -27.627390_t_real &
       &,   -24.518071_t_real,   -21.390238_t_real,   -18.339961_t_real &
       &,   -15.462817_t_real,   -12.838668_t_real,   -10.583265_t_real &
       &,    -8.745316_t_real,    -7.252729_t_real,    -6.029316_t_real &
       &,    -5.030644_t_real,    -4.197223_t_real,    -3.492674_t_real &
       &,    -2.904862_t_real,    -2.421044_t_real,    -2.026202_t_real &
       &,    -1.709666_t_real,    -1.464026_t_real,    -1.277523_t_real &
       &,    -1.133315_t_real,    -1.016286_t_real,    -0.916454_t_real &
       &,    -0.827789_t_real,    -0.746435_t_real,    -0.669794_t_real &
       &,    -0.596244_t_real,    -0.525059_t_real,    -0.456294_t_real &
       &,    -0.390571_t_real,    -0.328820_t_real,    -0.272014_t_real &
       &,    -0.220965_t_real,    -0.176193_t_real,    -0.137882_t_real &
       &,    -0.105892_t_real,    -0.079814_t_real,    -0.059052_t_real &
       &,    -0.042898_t_real,    -0.030607_t_real,    -0.021458_t_real &
       &,    -0.014788_t_real,    -0.010024_t_real/
  Data bscoeffrel(1:50, 39) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000002_t_real,     0.000005_t_real,    -0.000006_t_real &
       &,    -0.000054_t_real,    -0.000186_t_real,    -0.000415_t_real &
       &,    -0.000504_t_real,    -0.000397_t_real,    -0.000204_t_real &
       &,    -0.000005_t_real,    -0.000110_t_real,    -0.001278_t_real &
       &,    -0.003759_t_real,    -0.006965_t_real,    -0.010781_t_real &
       &,    -0.015388_t_real,    -0.020808_t_real,    -0.026532_t_real &
       &,    -0.031122_t_real,    -0.032699_t_real,    -0.030744_t_real &
       &,    -0.026568_t_real,    -0.021708_t_real,    -0.017020_t_real &
       &,    -0.012855_t_real,    -0.009335_t_real,    -0.006490_t_real &
       &,    -0.004300_t_real,    -0.002701_t_real,    -0.001601_t_real &
       &,    -0.000892_t_real,    -0.000466_t_real,    -0.000229_t_real &
       &,    -0.000107_t_real,    -0.000049_t_real,    -0.000025_t_real &
       &,    -0.000014_t_real,    -0.000007_t_real,    -0.000001_t_real &
       &,     0.000005_t_real,     0.000010_t_real,     0.000014_t_real &
       &,     0.000017_t_real,     0.000018_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 40) /&
       &    -40.000000_t_real,   -39.970025_t_real,   -39.755658_t_real &
       &,   -39.164549_t_real,   -38.029432_t_real,   -36.291784_t_real &
       &,   -34.010368_t_real,   -31.287463_t_real,   -28.260435_t_real &
       &,   -25.063998_t_real,   -21.852269_t_real,   -18.724896_t_real &
       &,   -15.783474_t_real,   -13.116067_t_real,   -10.842700_t_real &
       &,    -8.987009_t_real,    -7.462923_t_real,    -6.205159_t_real &
       &,    -5.165626_t_real,    -4.284564_t_real,    -3.538241_t_real &
       &,    -2.918859_t_real,    -2.413090_t_real,    -2.005794_t_real &
       &,    -1.685299_t_real,    -1.439516_t_real,    -1.251474_t_real &
       &,    -1.103384_t_real,    -0.981844_t_real,    -0.878137_t_real &
       &,    -0.786505_t_real,    -0.702942_t_real,    -0.624727_t_real &
       &,    -0.550270_t_real,    -0.478977_t_real,    -0.411036_t_real &
       &,    -0.347120_t_real,    -0.288096_t_real,    -0.234774_t_real &
       &,    -0.187732_t_real,    -0.147237_t_real,    -0.113230_t_real &
       &,    -0.085366_t_real,    -0.063086_t_real,    -0.045694_t_real &
       &,    -0.032438_t_real,    -0.022567_t_real,    -0.015386_t_real &
       &,    -0.010279_t_real,    -0.006729_t_real/
  Data bscoeffrel(1:50, 40) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000004_t_real,     0.000006_t_real,    -0.000029_t_real &
       &,    -0.000166_t_real,    -0.000543_t_real,    -0.001141_t_real &
       &,    -0.001293_t_real,    -0.000947_t_real,    -0.000391_t_real &
       &,     0.000048_t_real,    -0.000859_t_real,    -0.005127_t_real &
       &,    -0.012060_t_real,    -0.019914_t_real,    -0.028632_t_real &
       &,    -0.038348_t_real,    -0.048435_t_real,    -0.056888_t_real &
       &,    -0.060528_t_real,    -0.057505_t_real,    -0.049436_t_real &
       &,    -0.039447_t_real,    -0.029696_t_real,    -0.021134_t_real &
       &,    -0.014078_t_real,    -0.008575_t_real,    -0.004542_t_real &
       &,    -0.001807_t_real,    -0.000136_t_real,     0.000732_t_real &
       &,     0.001056_t_real,     0.001053_t_real,     0.000887_t_real &
       &,     0.000664_t_real,     0.000447_t_real,     0.000265_t_real &
       &,     0.000129_t_real,     0.000038_t_real,    -0.000016_t_real &
       &,    -0.000042_t_real,    -0.000050_t_real,    -0.000046_t_real &
       &,    -0.000038_t_real,    -0.000028_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 41) /&
       &    -41.000000_t_real,   -40.968909_t_real,   -40.746401_t_real &
       &,   -40.132862_t_real,   -38.956398_t_real,   -37.159892_t_real &
       &,   -34.804993_t_real,   -31.998083_t_real,   -28.879665_t_real &
       &,   -25.590890_t_real,   -22.288633_t_real,   -19.077535_t_real &
       &,   -16.064034_t_real,   -13.345954_t_real,   -11.041746_t_real &
       &,    -9.147944_t_real,    -7.570659_t_real,    -6.255941_t_real &
       &,    -5.150147_t_real,    -4.202645_t_real,    -3.404995_t_real &
       &,    -2.753717_t_real,    -2.233235_t_real,    -1.822880_t_real &
       &,    -1.504219_t_real,    -1.260883_t_real,    -1.075426_t_real &
       &,    -0.931416_t_real,    -0.816763_t_real,    -0.723036_t_real &
       &,    -0.643823_t_real,    -0.574119_t_real,    -0.510262_t_real &
       &,    -0.449916_t_real,    -0.391995_t_real,    -0.336434_t_real &
       &,    -0.283795_t_real,    -0.234886_t_real,    -0.190510_t_real &
       &,    -0.151296_t_real,    -0.117599_t_real,    -0.089461_t_real &
       &,    -0.066624_t_real,    -0.048595_t_real,    -0.034734_t_real &
       &,    -0.024343_t_real,    -0.016737_t_real,    -0.011294_t_real &
       &,    -0.007483_t_real,    -0.004868_t_real/
  Data bscoeffrel(1:50, 41) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000005_t_real,    -0.000008_t_real,    -0.000007_t_real &
       &,     0.000006_t_real,     0.000004_t_real,    -0.000107_t_real &
       &,    -0.000429_t_real,    -0.001258_t_real,    -0.002504_t_real &
       &,    -0.002737_t_real,    -0.001891_t_real,    -0.000570_t_real &
       &,    -0.000004_t_real,    -0.003923_t_real,    -0.015375_t_real &
       &,    -0.029598_t_real,    -0.043791_t_real,    -0.059009_t_real &
       &,    -0.076319_t_real,    -0.095764_t_real,    -0.115501_t_real &
       &,    -0.131535_t_real,    -0.140476_t_real,    -0.142553_t_real &
       &,    -0.139385_t_real,    -0.131527_t_real,    -0.119231_t_real &
       &,    -0.103397_t_real,    -0.085529_t_real,    -0.067343_t_real &
       &,    -0.050406_t_real,    -0.035840_t_real,    -0.024193_t_real &
       &,    -0.015528_t_real,    -0.009573_t_real,    -0.005839_t_real &
       &,    -0.003738_t_real,    -0.002696_t_real,    -0.002235_t_real &
       &,    -0.002019_t_real,    -0.001855_t_real,    -0.001660_t_real &
       &,    -0.001422_t_real,    -0.001160_t_real,    -0.000903_t_real &
       &,    -0.000673_t_real,    -0.000481_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 42) /&
       &    -42.000000_t_real,   -41.967792_t_real,   -41.737109_t_real &
       &,   -41.101053_t_real,   -39.883241_t_real,   -38.028168_t_real &
       &,   -35.600392_t_real,   -32.710635_t_real,   -29.502474_t_real &
       &,   -26.124050_t_real,   -22.734505_t_real,   -19.444478_t_real &
       &,   -16.364608_t_real,   -13.603363_t_real,   -11.272013_t_real &
       &,    -9.340573_t_real,    -7.715643_t_real,    -6.351939_t_real &
       &,    -5.188972_t_real,    -4.190487_t_real,    -3.358431_t_real &
       &,    -2.687984_t_real,    -2.159535_t_real,    -1.749388_t_real &
       &,    -1.436115_t_real,    -1.199379_t_real,    -1.019375_t_real &
       &,    -0.879926_t_real,    -0.769411_t_real,    -0.679241_t_real &
       &,    -0.602767_t_real,    -0.534995_t_real,    -0.472510_t_real &
       &,    -0.413346_t_real,    -0.356788_t_real,    -0.303012_t_real &
       &,    -0.252658_t_real,    -0.206500_t_real,    -0.165235_t_real &
       &,    -0.129344_t_real,    -0.099014_t_real,    -0.074123_t_real &
       &,    -0.054277_t_real,    -0.038892_t_real,    -0.027282_t_real &
       &,    -0.018744_t_real,    -0.012617_t_real,    -0.008323_t_real &
       &,    -0.005380_t_real,    -0.003409_t_real/
  Data bscoeffrel(1:50, 42) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000005_t_real,    -0.000008_t_real,    -0.000007_t_real &
       &,     0.000008_t_real,    -0.000007_t_real,    -0.000177_t_real &
       &,    -0.000690_t_real,    -0.002018_t_real,    -0.003757_t_real &
       &,    -0.003787_t_real,    -0.002361_t_real,    -0.000449_t_real &
       &,    -0.000421_t_real,    -0.008579_t_real,    -0.026603_t_real &
       &,    -0.045970_t_real,    -0.064449_t_real,    -0.083390_t_real &
       &,    -0.103338_t_real,    -0.123289_t_real,    -0.140286_t_real &
       &,    -0.150780_t_real,    -0.153793_t_real,    -0.150897_t_real &
       &,    -0.143292_t_real,    -0.131321_t_real,    -0.115581_t_real &
       &,    -0.097331_t_real,    -0.078204_t_real,    -0.059825_t_real &
       &,    -0.043508_t_real,    -0.030045_t_real,    -0.019690_t_real &
       &,    -0.012296_t_real,    -0.007445_t_real,    -0.004567_t_real &
       &,    -0.003051_t_real,    -0.002350_t_real,    -0.002045_t_real &
       &,    -0.001872_t_real,    -0.001697_t_real,    -0.001478_t_real &
       &,    -0.001225_t_real,    -0.000965_t_real,    -0.000725_t_real &
       &,    -0.000521_t_real,    -0.000359_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 43) /&
       &    -43.000000_t_real,   -42.966661_t_real,   -42.727692_t_real &
       &,   -42.068825_t_real,   -40.809252_t_real,   -38.895197_t_real &
       &,   -36.394058_t_real,   -33.421002_t_real,   -30.122553_t_real &
       &,   -26.654199_t_real,   -23.177097_t_real,   -19.808713_t_real &
       &,   -16.663480_t_real,   -13.860450_t_real,   -11.498134_t_real &
       &,    -9.522417_t_real,    -7.847312_t_real,    -6.431281_t_real &
       &,    -5.211557_t_real,    -4.169771_t_real,    -3.314288_t_real &
       &,    -2.636356_t_real,    -2.111024_t_real,    -1.709888_t_real &
       &,    -1.407169_t_real,    -1.180045_t_real,    -1.008480_t_real &
       &,    -0.875991_t_real,    -0.770008_t_real,    -0.681443_t_real &
       &,    -0.604001_t_real,    -0.533599_t_real,    -0.467885_t_real &
       &,    -0.405815_t_real,    -0.347248_t_real,    -0.292569_t_real &
       &,    -0.242386_t_real,    -0.197286_t_real,    -0.157686_t_real &
       &,    -0.123744_t_real,    -0.095346_t_real,    -0.072141_t_real &
       &,    -0.053611_t_real,    -0.039140_t_real,    -0.028086_t_real &
       &,    -0.019819_t_real,    -0.013766_t_real,    -0.009420_t_real &
       &,    -0.006357_t_real,    -0.004234_t_real/
  Data bscoeffrel(1:50, 43) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000005_t_real,    -0.000009_t_real,    -0.000008_t_real &
       &,     0.000005_t_real,    -0.000019_t_real,    -0.000196_t_real &
       &,    -0.000706_t_real,    -0.001997_t_real,    -0.003490_t_real &
       &,    -0.003304_t_real,    -0.001846_t_real,    -0.000141_t_real &
       &,    -0.001162_t_real,    -0.011106_t_real,    -0.027875_t_real &
       &,    -0.043505_t_real,    -0.057617_t_real,    -0.071425_t_real &
       &,    -0.085197_t_real,    -0.098083_t_real,    -0.108150_t_real &
       &,    -0.113256_t_real,    -0.112482_t_real,    -0.106506_t_real &
       &,    -0.096757_t_real,    -0.084662_t_real,    -0.071427_t_real &
       &,    -0.058054_t_real,    -0.045372_t_real,    -0.034021_t_real &
       &,    -0.024422_t_real,    -0.016760_t_real,    -0.010998_t_real &
       &,    -0.006915_t_real,    -0.004181_t_real,    -0.002436_t_real &
       &,    -0.001358_t_real,    -0.000706_t_real,    -0.000319_t_real &
       &,    -0.000101_t_real,     0.000006_t_real,     0.000043_t_real &
       &,     0.000042_t_real,     0.000026_t_real,     0.000009_t_real &
       &,    -0.000003_t_real,    -0.000009_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 44) /&
       &    -44.000000_t_real,   -43.965513_t_real,   -43.718123_t_real &
       &,   -43.036084_t_real,   -41.734219_t_real,   -39.760561_t_real &
       &,   -37.185272_t_real,   -34.128024_t_real,   -30.738212_t_real &
       &,   -27.178904_t_real,   -23.613176_t_real,   -20.165824_t_real &
       &,   -16.955078_t_real,   -14.109534_t_real,   -11.710031_t_real &
       &,    -9.682549_t_real,    -7.953451_t_real,    -6.479307_t_real &
       &,    -5.202267_t_real,    -4.122184_t_real,    -3.249435_t_real &
       &,    -2.569020_t_real,    -2.049689_t_real,    -1.658134_t_real &
       &,    -1.364840_t_real,    -1.144906_t_real,    -0.978017_t_real &
       &,    -0.848345_t_real,    -0.744062_t_real,    -0.656621_t_real &
       &,    -0.580086_t_real,    -0.510602_t_real,    -0.445966_t_real &
       &,    -0.385207_t_real,    -0.328192_t_real,    -0.275260_t_real &
       &,    -0.226934_t_real,    -0.183707_t_real,    -0.145908_t_real &
       &,    -0.113641_t_real,    -0.086766_t_real,    -0.064930_t_real &
       &,    -0.047622_t_real,    -0.034231_t_real,    -0.024114_t_real &
       &,    -0.016648_t_real,    -0.011264_t_real,    -0.007468_t_real &
       &,    -0.004851_t_real,    -0.003086_t_real/
  Data bscoeffrel(1:50, 44) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000006_t_real,    -0.000010_t_real,    -0.000009_t_real &
       &,     0.000003_t_real,    -0.000027_t_real,    -0.000193_t_real &
       &,    -0.000652_t_real,    -0.001778_t_real,    -0.002919_t_real &
       &,    -0.002602_t_real,    -0.001276_t_real,     0.000027_t_real &
       &,    -0.001947_t_real,    -0.012009_t_real,    -0.025318_t_real &
       &,    -0.036387_t_real,    -0.045957_t_real,    -0.055082_t_real &
       &,    -0.064106_t_real,    -0.072667_t_real,    -0.079751_t_real &
       &,    -0.084132_t_real,    -0.085034_t_real,    -0.082399_t_real &
       &,    -0.076694_t_real,    -0.068637_t_real,    -0.059059_t_real &
       &,    -0.048815_t_real,    -0.038706_t_real,    -0.029397_t_real &
       &,    -0.021352_t_real,    -0.014813_t_real,    -0.009815_t_real &
       &,    -0.006226_t_real,    -0.003811_t_real,    -0.002286_t_real &
       &,    -0.001379_t_real,    -0.000862_t_real,    -0.000569_t_real &
       &,    -0.000394_t_real,    -0.000279_t_real,    -0.000194_t_real &
       &,    -0.000129_t_real,    -0.000081_t_real,    -0.000046_t_real &
       &,    -0.000024_t_real,    -0.000010_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 45) /&
       &    -45.000000_t_real,   -44.964349_t_real,   -44.708404_t_real &
       &,   -44.002841_t_real,   -42.658167_t_real,   -40.624310_t_real &
       &,   -37.974122_t_real,   -34.831818_t_real,   -31.349659_t_real &
       &,   -27.698431_t_real,   -24.043213_t_real,   -20.516337_t_real &
       &,   -17.240185_t_real,   -14.350899_t_real,   -11.907720_t_real &
       &,    -9.822496_t_real,    -8.036041_t_real,    -6.499129_t_real &
       &,    -5.166794_t_real,    -4.054633_t_real,    -3.170862_t_real &
       &,    -2.492578_t_real,    -1.981896_t_real,    -1.600971_t_real &
       &,    -1.317444_t_real,    -1.105148_t_real,    -0.943720_t_real &
       &,    -0.817855_t_real,    -0.716319_t_real,    -0.631031_t_real &
       &,    -0.556375_t_real,    -0.488700_t_real,    -0.425918_t_real &
       &,    -0.367106_t_real,    -0.312119_t_real,    -0.261246_t_real &
       &,    -0.214931_t_real,    -0.173589_t_real,    -0.137493_t_real &
       &,    -0.106720_t_real,    -0.081130_t_real,    -0.060388_t_real &
       &,    -0.044004_t_real,    -0.031391_t_real,    -0.021924_t_real &
       &,    -0.014993_t_real,    -0.010040_t_real,    -0.006584_t_real &
       &,    -0.004228_t_real,    -0.002659_t_real/
  Data bscoeffrel(1:50, 45) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000006_t_real,    -0.000011_t_real,    -0.000009_t_real &
       &,     0.000001_t_real,    -0.000029_t_real,    -0.000168_t_real &
       &,    -0.000521_t_real,    -0.001360_t_real,    -0.002113_t_real &
       &,    -0.001786_t_real,    -0.000748_t_real,     0.000048_t_real &
       &,    -0.002397_t_real,    -0.010667_t_real,    -0.019384_t_real &
       &,    -0.025940_t_real,    -0.031469_t_real,    -0.036963_t_real &
       &,    -0.043013_t_real,    -0.049699_t_real,    -0.056445_t_real &
       &,    -0.062191_t_real,    -0.065848_t_real,    -0.066697_t_real &
       &,    -0.064532_t_real,    -0.059630_t_real,    -0.052628_t_real &
       &,    -0.044370_t_real,    -0.035727_t_real,    -0.027457_t_real &
       &,    -0.020116_t_real,    -0.014028_t_real,    -0.009309_t_real &
       &,    -0.005903_t_real,    -0.003635_t_real,    -0.002260_t_real &
       &,    -0.001512_t_real,    -0.001150_t_real,    -0.000987_t_real &
       &,    -0.000897_t_real,    -0.000814_t_real,    -0.000714_t_real &
       &,    -0.000598_t_real,    -0.000477_t_real,    -0.000363_t_real &
       &,    -0.000264_t_real,    -0.000185_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 46) /&
       &    -46.000000_t_real,   -45.963149_t_real,   -45.698380_t_real &
       &,   -44.968573_t_real,   -43.579856_t_real,   -41.483979_t_real &
       &,   -38.756285_t_real,   -35.525361_t_real,   -31.946226_t_real &
       &,   -28.197310_t_real,   -24.446014_t_real,   -20.832092_t_real &
       &,   -17.482580_t_real,   -14.538111_t_real,   -12.033337_t_real &
       &,    -9.872065_t_real,    -8.008573_t_real,    -6.388605_t_real &
       &,    -4.988136_t_real,    -3.837446_t_real,    -2.942367_t_real &
       &,    -2.272307_t_real,    -1.781425_t_real,    -1.424894_t_real &
       &,    -1.165177_t_real,    -0.973112_t_real,    -0.827181_t_real &
       &,    -0.712183_t_real,    -0.617791_t_real,    -0.537251_t_real &
       &,    -0.466349_t_real,    -0.402613_t_real,    -0.344725_t_real &
       &,    -0.292088_t_real,    -0.244502_t_real,    -0.201943_t_real &
       &,    -0.164412_t_real,    -0.131846_t_real,    -0.104082_t_real &
       &,    -0.080843_t_real,    -0.061758_t_real,    -0.046386_t_real &
       &,    -0.034244_t_real,    -0.024843_t_real,    -0.017705_t_real &
       &,    -0.012394_t_real,    -0.008521_t_real,    -0.005751_t_real &
       &,    -0.003810_t_real,    -0.002478_t_real/
  Data bscoeffrel(1:50, 46) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 47) /&
       &    -47.000000_t_real,   -46.961973_t_real,   -46.688517_t_real &
       &,   -45.934853_t_real,   -44.503044_t_real,   -42.347018_t_real &
       &,   -39.544848_t_real,   -36.229819_t_real,   -32.560199_t_real &
       &,   -28.722261_t_real,   -24.885950_t_real,   -21.198335_t_real &
       &,   -17.791978_t_real,   -14.808946_t_real,   -12.258687_t_real &
       &,   -10.045473_t_real,    -8.133149_t_real,    -6.463476_t_real &
       &,    -5.034155_t_real,    -3.878402_t_real,    -2.990072_t_real &
       &,    -2.327867_t_real,    -1.841105_t_real,    -1.484420_t_real &
       &,    -1.221662_t_real,    -1.025528_t_real,    -0.876099_t_real &
       &,    -0.759148_t_real,    -0.664546_t_real,    -0.585053_t_real &
       &,    -0.515571_t_real,    -0.452721_t_real,    -0.394532_t_real &
       &,    -0.340109_t_real,    -0.289270_t_real,    -0.242226_t_real &
       &,    -0.199338_t_real,    -0.160972_t_real,    -0.127399_t_real &
       &,    -0.098732_t_real,    -0.074887_t_real,    -0.055583_t_real &
       &,    -0.040373_t_real,    -0.028706_t_real,    -0.019986_t_real &
       &,    -0.013630_t_real,    -0.009106_t_real,    -0.005961_t_real &
       &,    -0.003824_t_real,    -0.002403_t_real/
  Data bscoeffrel(1:50, 47) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000007_t_real,    -0.000011_t_real,    -0.000010_t_real &
       &,     0.000001_t_real,    -0.000014_t_real,    -0.000035_t_real &
       &,     0.000009_t_real,     0.000076_t_real,    -0.000009_t_real &
       &,    -0.000088_t_real,    -0.000031_t_real,    -0.000034_t_real &
       &,    -0.000403_t_real,    -0.000530_t_real,     0.000131_t_real &
       &,     0.000987_t_real,     0.001097_t_real,    -0.000661_t_real &
       &,    -0.005301_t_real,    -0.013143_t_real,    -0.023369_t_real &
       &,    -0.034234_t_real,    -0.043761_t_real,    -0.050376_t_real &
       &,    -0.053199_t_real,    -0.052140_t_real,    -0.047815_t_real &
       &,    -0.041283_t_real,    -0.033702_t_real,    -0.026071_t_real &
       &,    -0.019111_t_real,    -0.013261_t_real,    -0.008724_t_real &
       &,    -0.005507_t_real,    -0.003460_t_real,    -0.002323_t_real &
       &,    -0.001794_t_real,    -0.001595_t_real,    -0.001519_t_real &
       &,    -0.001442_t_real,    -0.001314_t_real,    -0.001136_t_real &
       &,    -0.000930_t_real,    -0.000722_t_real,    -0.000535_t_real &
       &,    -0.000379_t_real,    -0.000258_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 48) /&
       &    -48.000000_t_real,   -47.960787_t_real,   -47.678564_t_real &
       &,   -46.900835_t_real,   -45.425719_t_real,   -43.209436_t_real &
       &,   -40.332812_t_real,   -36.933858_t_real,   -33.174347_t_real &
       &,   -29.248293_t_real,   -25.328594_t_real,   -21.569288_t_real &
       &,   -18.109130_t_real,   -15.087816_t_real,   -12.490100_t_real &
       &,   -10.227395_t_real,    -8.267059_t_real,    -6.552959_t_real &
       &,    -5.103055_t_real,    -3.946456_t_real,    -3.063182_t_real &
       &,    -2.403474_t_real,    -1.915263_t_real,    -1.555037_t_real &
       &,    -1.288436_t_real,    -1.088827_t_real,    -0.936092_t_real &
       &,    -0.815403_t_real,    -0.716044_t_real,    -0.630497_t_real &
       &,    -0.553785_t_real,    -0.482957_t_real,    -0.416597_t_real &
       &,    -0.354367_t_real,    -0.296569_t_real,    -0.243783_t_real &
       &,    -0.196584_t_real,    -0.155371_t_real,    -0.120274_t_real &
       &,    -0.091145_t_real,    -0.067589_t_real,    -0.049030_t_real &
       &,    -0.034785_t_real,    -0.024130_t_real,    -0.016365_t_real &
       &,    -0.010849_t_real,    -0.007029_t_real,    -0.004451_t_real &
       &,    -0.002754_t_real,    -0.001664_t_real/
  Data bscoeffrel(1:50, 48) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 49) /&
       &    -49.000000_t_real,   -48.959603_t_real,   -48.668595_t_real &
       &,   -47.866770_t_real,   -46.348472_t_real,   -44.072359_t_real &
       &,   -41.122102_t_real,   -37.640497_t_real,   -33.793180_t_real &
       &,   -29.781775_t_real,   -25.782718_t_real,   -21.956643_t_real &
       &,   -18.449092_t_real,   -15.393396_t_real,   -12.751668_t_real &
       &,   -10.447354_t_real,    -8.445934_t_real,    -6.700947_t_real &
       &,    -5.246215_t_real,    -4.100623_t_real,    -3.228883_t_real &
       &,    -2.573662_t_real,    -2.082537_t_real,    -1.714043_t_real &
       &,    -1.435510_t_real,    -1.221722_t_real,    -1.054222_t_real &
       &,    -0.919944_t_real,    -0.809647_t_real,    -0.716752_t_real &
       &,    -0.636581_t_real,    -0.565838_t_real,    -0.502221_t_real &
       &,    -0.444140_t_real,    -0.390535_t_real,    -0.340752_t_real &
       &,    -0.294456_t_real,    -0.251555_t_real,    -0.212121_t_real &
       &,    -0.176321_t_real,    -0.144330_t_real,    -0.116261_t_real &
       &,    -0.092118_t_real,    -0.071777_t_real,    -0.054993_t_real &
       &,    -0.041429_t_real,    -0.030689_t_real,    -0.022353_t_real &
       &,    -0.016010_t_real,    -0.011275_t_real/
  Data bscoeffrel(1:50, 49) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,    -0.000003_t_real &
       &,    -0.000014_t_real,    -0.000025_t_real,    -0.000013_t_real &
       &,     0.000012_t_real,     0.000000_t_real,    -0.000053_t_real &
       &,    -0.000053_t_real,    -0.000006_t_real,    -0.000048_t_real &
       &,    -0.000309_t_real,    -0.000413_t_real,    -0.000184_t_real &
       &,     0.000173_t_real,     0.000266_t_real,    -0.000549_t_real &
       &,    -0.003064_t_real,    -0.007746_t_real,    -0.014213_t_real &
       &,    -0.021382_t_real,    -0.028127_t_real,    -0.033666_t_real &
       &,    -0.037550_t_real,    -0.039552_t_real,    -0.039609_t_real &
       &,    -0.037825_t_real,    -0.034475_t_real,    -0.029994_t_real &
       &,    -0.024906_t_real,    -0.019735_t_real,    -0.014918_t_real &
       &,    -0.010767_t_real,    -0.007448_t_real,    -0.004994_t_real &
       &,    -0.003320_t_real,    -0.002271_t_real,    -0.001666_t_real &
       &,    -0.001336_t_real,    -0.001151_t_real,    -0.001027_t_real &
       &,    -0.000915_t_real,    -0.000799_t_real,    -0.000675_t_real &
       &,    -0.000551_t_real,    -0.000434_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 50) /&
       &    -50.000000_t_real,   -49.958406_t_real,   -49.658506_t_real &
       &,   -48.832311_t_real,   -47.270490_t_real,   -44.934220_t_real &
       &,   -41.910043_t_real,   -38.345521_t_real,   -34.410483_t_real &
       &,   -30.313889_t_real,   -26.236180_t_real,   -22.344112_t_real &
       &,   -18.790246_t_real,   -15.697604_t_real,   -13.009169_t_real &
       &,   -10.663034_t_real,    -8.618872_t_real,    -6.845978_t_real &
       &,    -5.386996_t_real,    -4.245833_t_real,    -3.373627_t_real &
       &,    -2.710267_t_real,    -2.206256_t_real,    -1.822117_t_real &
       &,    -1.525880_t_real,    -1.293749_t_real,    -1.109159_t_real &
       &,    -0.960314_t_real,    -0.838245_t_real,    -0.735877_t_real &
       &,    -0.647681_t_real,    -0.569532_t_real,    -0.498603_t_real &
       &,    -0.433188_t_real,    -0.372463_t_real,    -0.316204_t_real &
       &,    -0.264537_t_real,    -0.217737_t_real,    -0.176089_t_real &
       &,    -0.139785_t_real,    -0.108852_t_real,    -0.083120_t_real &
       &,    -0.062232_t_real,    -0.045685_t_real,    -0.032887_t_real &
       &,    -0.023217_t_real,    -0.016076_t_real,    -0.010918_t_real &
       &,    -0.007272_t_real,    -0.004751_t_real/
  Data bscoeffrel(1:50, 50) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000001_t_real,    -0.000008_t_real &
       &,    -0.000039_t_real,    -0.000068_t_real,    -0.000036_t_real &
       &,     0.000024_t_real,    -0.000032_t_real,    -0.000178_t_real &
       &,    -0.000152_t_real,    -0.000007_t_real,    -0.000204_t_real &
       &,    -0.001013_t_real,    -0.001231_t_real,    -0.000563_t_real &
       &,     0.000322_t_real,     0.000182_t_real,    -0.002948_t_real &
       &,    -0.010991_t_real,    -0.023913_t_real,    -0.038957_t_real &
       &,    -0.052722_t_real,    -0.063080_t_real,    -0.069217_t_real &
       &,    -0.071061_t_real,    -0.068964_t_real,    -0.063589_t_real &
       &,    -0.055843_t_real,    -0.046759_t_real,    -0.037339_t_real &
       &,    -0.028416_t_real,    -0.020580_t_real,    -0.014164_t_real &
       &,    -0.009277_t_real,    -0.005840_t_real,    -0.003629_t_real &
       &,    -0.002340_t_real,    -0.001661_t_real,    -0.001328_t_real &
       &,    -0.001154_t_real,    -0.001028_t_real,    -0.000901_t_real &
       &,    -0.000761_t_real,    -0.000615_t_real,    -0.000476_t_real &
       &,    -0.000353_t_real,    -0.000251_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 51) /&
       &    -51.000000_t_real,   -50.957199_t_real,   -50.648305_t_real &
       &,   -49.797483_t_real,   -48.191839_t_real,   -45.795144_t_real &
       &,   -42.696856_t_real,   -39.049259_t_real,   -35.026748_t_real &
       &,   -30.845302_t_real,   -26.689858_t_real,   -22.732860_t_real &
       &,   -19.133782_t_real,   -16.001705_t_real,   -13.265152_t_real &
       &,   -10.876867_t_real,    -8.789639_t_real,    -6.992236_t_real &
       &,    -5.528460_t_real,    -4.384816_t_real,    -3.502645_t_real &
       &,    -2.823432_t_real,    -2.300687_t_real,    -1.895273_t_real &
       &,    -1.576793_t_real,    -1.324461_t_real,    -1.123701_t_real &
       &,    -0.962894_t_real,    -0.832080_t_real,    -0.722876_t_real &
       &,    -0.628729_t_real,    -0.545023_t_real,    -0.468937_t_real &
       &,    -0.399070_t_real,    -0.334963_t_real,    -0.276667_t_real &
       &,    -0.224429_t_real,    -0.178503_t_real,    -0.139028_t_real &
       &,    -0.105947_t_real,    -0.078964_t_real,    -0.057558_t_real &
       &,    -0.041039_t_real,    -0.028630_t_real,    -0.019548_t_real &
       &,    -0.013067_t_real,    -0.008552_t_real,    -0.005481_t_real &
       &,    -0.003439_t_real,    -0.002113_t_real/
  Data bscoeffrel(1:50, 51) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000001_t_real,    -0.000017_t_real &
       &,    -0.000079_t_real,    -0.000134_t_real,    -0.000071_t_real &
       &,     0.000036_t_real,    -0.000109_t_real,    -0.000386_t_real &
       &,    -0.000292_t_real,    -0.000001_t_real,    -0.000573_t_real &
       &,    -0.002224_t_real,    -0.002425_t_real,    -0.001004_t_real &
       &,     0.000521_t_real,    -0.000698_t_real,    -0.008795_t_real &
       &,    -0.026355_t_real,    -0.050214_t_real,    -0.073329_t_real &
       &,    -0.090590_t_real,    -0.100332_t_real,    -0.102815_t_real &
       &,    -0.099064_t_real,    -0.090462_t_real,    -0.078588_t_real &
       &,    -0.065054_t_real,    -0.051320_t_real,    -0.038533_t_real &
       &,    -0.027460_t_real,    -0.018505_t_real,    -0.011773_t_real &
       &,    -0.007125_t_real,    -0.004227_t_real,    -0.002630_t_real &
       &,    -0.001869_t_real,    -0.001551_t_real,    -0.001406_t_real &
       &,    -0.001285_t_real,    -0.001134_t_real,    -0.000949_t_real &
       &,    -0.000753_t_real,    -0.000567_t_real,    -0.000408_t_real &
       &,    -0.000281_t_real,    -0.000186_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 52) /&
       &    -52.000000_t_real,   -51.955980_t_real,   -51.637989_t_real &
       &,   -50.762278_t_real,   -49.112505_t_real,   -46.655109_t_real &
       &,   -43.482519_t_real,   -39.751692_t_real,   -35.641962_t_real &
       &,   -31.375975_t_real,   -27.143647_t_real,   -23.122745_t_real &
       &,   -19.479128_t_real,   -16.304812_t_real,   -13.519397_t_real &
       &,   -11.087854_t_real,    -8.957811_t_real,    -7.138092_t_real &
       &,    -5.666443_t_real,    -4.512386_t_real,    -3.613330_t_real &
       &,    -2.915936_t_real,    -2.375216_t_real,    -1.951195_t_real &
       &,    -1.615213_t_real,    -1.348608_t_real,    -1.137183_t_real &
       &,    -0.968370_t_real,    -0.831008_t_real,    -0.715929_t_real &
       &,    -0.616338_t_real,    -0.527759_t_real,    -0.447652_t_real &
       &,    -0.374884_t_real,    -0.309178_t_real,    -0.250653_t_real &
       &,    -0.199487_t_real,    -0.155709_t_real,    -0.119117_t_real &
       &,    -0.089263_t_real,    -0.065500_t_real,    -0.047052_t_real &
       &,    -0.033082_t_real,    -0.022764_t_real,    -0.015328_t_real &
       &,    -0.010100_t_real,    -0.006512_t_real,    -0.004108_t_real &
       &,    -0.002535_t_real,    -0.001531_t_real/
  Data bscoeffrel(1:50, 52) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000001_t_real,    -0.000013_t_real &
       &,    -0.000061_t_real,    -0.000103_t_real,    -0.000054_t_real &
       &,     0.000022_t_real,    -0.000111_t_real,    -0.000313_t_real &
       &,    -0.000211_t_real,     0.000005_t_real,    -0.000577_t_real &
       &,    -0.001813_t_real,    -0.001787_t_real,    -0.000634_t_real &
       &,     0.000321_t_real,    -0.001429_t_real,    -0.009021_t_real &
       &,    -0.022793_t_real,    -0.038142_t_real,    -0.050216_t_real &
       &,    -0.057306_t_real,    -0.059610_t_real,    -0.057884_t_real &
       &,    -0.053037_t_real,    -0.046060_t_real,    -0.037965_t_real &
       &,    -0.029701_t_real,    -0.022043_t_real,    -0.015518_t_real &
       &,    -0.010367_t_real,    -0.006578_t_real,    -0.003965_t_real &
       &,    -0.002263_t_real,    -0.001213_t_real,    -0.000598_t_real &
       &,    -0.000259_t_real,    -0.000086_t_real,    -0.000008_t_real &
       &,     0.000019_t_real,     0.000024_t_real,     0.000019_t_real &
       &,     0.000012_t_real,     0.000006_t_real,     0.000003_t_real &
       &,     0.000000_t_real,    -0.000001_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 53) /&
       &    -53.000000_t_real,   -52.954750_t_real,   -52.627553_t_real &
       &,   -51.726683_t_real,   -50.032461_t_real,   -47.514058_t_real &
       &,   -44.266928_t_real,   -40.452630_t_real,   -36.255828_t_real &
       &,   -31.905477_t_real,   -27.596906_t_real,   -23.512933_t_real &
       &,   -19.824852_t_real,   -16.605217_t_real,   -13.770446_t_real &
       &,   -11.293665_t_real,    -9.121467_t_real,    -7.280435_t_real &
       &,    -5.796500_t_real,    -4.624787_t_real,    -3.704127_t_real &
       &,    -2.985648_t_real,    -2.422481_t_real,    -1.975662_t_real &
       &,    -1.620764_t_real,    -1.341066_t_real,    -1.121478_t_real &
       &,    -0.947501_t_real,    -0.806352_t_real,    -0.688004_t_real &
       &,    -0.585479_t_real,    -0.494503_t_real,    -0.412854_t_real &
       &,    -0.339637_t_real,    -0.274660_t_real,    -0.217968_t_real &
       &,    -0.169536_t_real,    -0.129123_t_real,    -0.096232_t_real &
       &,    -0.070143_t_real,    -0.049984_t_real,    -0.034812_t_real &
       &,    -0.023691_t_real,    -0.015752_t_real,    -0.010231_t_real &
       &,    -0.006491_t_real,    -0.004022_t_real,    -0.002434_t_real &
       &,    -0.001438_t_real,    -0.000829_t_real/
  Data bscoeffrel(1:50, 53) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000001_t_real,    -0.000008_t_real &
       &,    -0.000040_t_real,    -0.000064_t_real,    -0.000033_t_real &
       &,     0.000010_t_real,    -0.000084_t_real,    -0.000201_t_real &
       &,    -0.000120_t_real,     0.000001_t_real,    -0.000452_t_real &
       &,    -0.001167_t_real,    -0.001036_t_real,    -0.000287_t_real &
       &,     0.000125_t_real,    -0.001569_t_real,    -0.007057_t_real &
       &,    -0.015242_t_real,    -0.022715_t_real,    -0.027551_t_real &
       &,    -0.029623_t_real,    -0.029368_t_real,    -0.027309_t_real &
       &,    -0.023992_t_real,    -0.019963_t_real,    -0.015736_t_real &
       &,    -0.011742_t_real,    -0.008286_t_real,    -0.005530_t_real &
       &,    -0.003492_t_real,    -0.002087_t_real,    -0.001179_t_real &
       &,    -0.000626_t_real,    -0.000306_t_real,    -0.000134_t_real &
       &,    -0.000047_t_real,    -0.000009_t_real,     0.000005_t_real &
       &,     0.000008_t_real,     0.000006_t_real,     0.000003_t_real &
       &,     0.000001_t_real,     0.000000_t_real,     0.000000_t_real &
       &,    -0.000001_t_real,    -0.000001_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 54) /&
       &    -54.000000_t_real,   -53.953507_t_real,   -53.616994_t_real &
       &,   -52.690686_t_real,   -50.951687_t_real,   -48.371951_t_real &
       &,   -45.050022_t_real,   -41.151984_t_real,   -36.868215_t_real &
       &,   -32.433617_t_real,   -28.049312_t_real,   -23.903001_t_real &
       &,   -20.170027_t_real,   -16.901949_t_real,   -14.017480_t_real &
       &,   -11.493086_t_real,    -9.279638_t_real,    -7.416857_t_real &
       &,    -5.915036_t_real,    -4.719507_t_real,    -3.774352_t_real &
       &,    -3.031573_t_real,    -2.442178_t_real,    -1.972047_t_real &
       &,    -1.601163_t_real,    -1.312718_t_real,    -1.089126_t_real &
       &,    -0.913345_t_real,    -0.771007_t_real,    -0.651506_t_real &
       &,    -0.547938_t_real,    -0.456374_t_real,    -0.374931_t_real &
       &,    -0.302909_t_real,    -0.240129_t_real,    -0.186489_t_real &
       &,    -0.141720_t_real,    -0.105293_t_real,    -0.076430_t_real &
       &,    -0.054176_t_real,    -0.037485_t_real,    -0.025311_t_real &
       &,    -0.016674_t_real,    -0.010715_t_real,    -0.006716_t_real &
       &,    -0.004105_t_real,    -0.002446_t_real,    -0.001421_t_real &
       &,    -0.000805_t_real,    -0.000444_t_real/
  Data bscoeffrel(1:50, 54) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 55) /&
       &    -55.000000_t_real,   -54.952285_t_real,   -54.606567_t_real &
       &,   -53.655155_t_real,   -51.872248_t_real,   -49.232840_t_real &
       &,   -45.838803_t_real,   -41.860840_t_real,   -37.495583_t_real &
       &,   -32.983766_t_real,   -28.532830_t_real,   -24.335446_t_real &
       &,   -20.569352_t_real,   -17.264768_t_real,   -14.347560_t_real &
       &,   -11.792964_t_real,    -9.561605_t_real,    -7.700541_t_real &
       &,    -6.203516_t_real,    -5.011533_t_real,    -4.072213_t_real &
       &,    -3.331598_t_real,    -2.738912_t_real,    -2.262876_t_real &
       &,    -1.882413_t_real,    -1.578181_t_real,    -1.333338_t_real &
       &,    -1.136450_t_real,    -0.981581_t_real,    -0.864917_t_real &
       &,    -0.780934_t_real,    -0.720250_t_real,    -0.671861_t_real &
       &,    -0.628228_t_real,    -0.585724_t_real,    -0.542699_t_real &
       &,    -0.498388_t_real,    -0.452585_t_real,    -0.405565_t_real &
       &,    -0.358004_t_real,    -0.310858_t_real,    -0.265222_t_real &
       &,    -0.222172_t_real,    -0.182642_t_real,    -0.147320_t_real &
       &,    -0.116598_t_real,    -0.090573_t_real,    -0.069080_t_real &
       &,    -0.051753_t_real,    -0.038100_t_real/
  Data bscoeffrel(1:50, 55) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000001_t_real &
       &,    -0.000002_t_real,    -0.000003_t_real,    -0.000001_t_real &
       &,     0.000001_t_real,    -0.000005_t_real,    -0.000008_t_real &
       &,     0.000001_t_real,    -0.000010_t_real,    -0.000025_t_real &
       &,    -0.000009_t_real,    -0.000009_t_real,    -0.000105_t_real &
       &,    -0.000124_t_real,    -0.000026_t_real,     0.000004_t_real &
       &,    -0.000262_t_real,    -0.000831_t_real,    -0.001156_t_real &
       &,    -0.000760_t_real,     0.000028_t_real,     0.000465_t_real &
       &,    -0.000352_t_real,    -0.003488_t_real,    -0.010036_t_real &
       &,    -0.020620_t_real,    -0.034508_t_real,    -0.048766_t_real &
       &,    -0.059049_t_real,    -0.063847_t_real,    -0.064805_t_real &
       &,    -0.062998_t_real,    -0.058623_t_real,    -0.052019_t_real &
       &,    -0.043924_t_real,    -0.035268_t_real,    -0.026938_t_real &
       &,    -0.019613_t_real,    -0.013700_t_real,    -0.009320_t_real &
       &,    -0.006357_t_real,    -0.004543_t_real,    -0.003543_t_real &
       &,    -0.003036_t_real,    -0.002767_t_real,    -0.002567_t_real &
       &,    -0.002347_t_real,    -0.002080_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 56) /&
       &    -56.000000_t_real,   -55.951052_t_real,   -55.596028_t_real &
       &,   -54.619266_t_real,   -52.792196_t_real,   -50.092910_t_real &
       &,   -46.626682_t_real,   -42.568751_t_real,   -38.122356_t_real &
       &,   -33.533780_t_real,   -29.017026_t_real,   -24.769719_t_real &
       &,   -20.969849_t_real,   -17.626812_t_real,   -14.676945_t_real &
       &,   -12.090726_t_real,    -9.842801_t_real,    -7.981262_t_real &
       &,    -6.484208_t_real,    -5.292391_t_real,    -4.352721_t_real &
       &,    -3.603618_t_real,    -2.995635_t_real,    -2.499656_t_real &
       &,    -2.094571_t_real,    -1.764415_t_real,    -1.500568_t_real &
       &,    -1.298269_t_real,    -1.148174_t_real,    -1.034783_t_real &
       &,    -0.943214_t_real,    -0.863476_t_real,    -0.789863_t_real &
       &,    -0.719213_t_real,    -0.649822_t_real,    -0.580985_t_real &
       &,    -0.512790_t_real,    -0.445941_t_real,    -0.381531_t_real &
       &,    -0.320798_t_real,    -0.264890_t_real,    -0.214696_t_real &
       &,    -0.170761_t_real,    -0.133256_t_real,    -0.102019_t_real &
       &,    -0.076623_t_real,    -0.056457_t_real,    -0.040809_t_real &
       &,    -0.028938_t_real,    -0.020131_t_real/
  Data bscoeffrel(1:50, 56) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 57) /&
       &    -57.000000_t_real,   -56.949797_t_real,   -56.585279_t_real &
       &,   -55.582687_t_real,   -53.710742_t_real,   -50.950595_t_real &
       &,   -47.410893_t_real,   -43.271227_t_real,   -38.741683_t_real &
       &,   -34.073888_t_real,   -29.488556_t_real,   -25.188208_t_real &
       &,   -21.348504_t_real,   -17.959418_t_real,   -14.969387_t_real &
       &,   -12.342584_t_real,   -10.070357_t_real,    -8.195710_t_real &
       &,    -6.682164_t_real,    -5.471765_t_real,    -4.508452_t_real &
       &,    -3.727682_t_real,    -3.086532_t_real,    -2.560970_t_real &
       &,    -2.132774_t_real,    -1.788648_t_real,    -1.519661_t_real &
       &,    -1.315143_t_real,    -1.159332_t_real,    -1.035932_t_real &
       &,    -0.932774_t_real,    -0.842101_t_real,    -0.759083_t_real &
       &,    -0.680702_t_real,    -0.605241_t_real,    -0.532039_t_real &
       &,    -0.461273_t_real,    -0.393697_t_real,    -0.330339_t_real &
       &,    -0.272230_t_real,    -0.220201_t_real,    -0.174756_t_real &
       &,    -0.136039_t_real,    -0.103861_t_real,    -0.077760_t_real &
       &,    -0.057090_t_real,    -0.041101_t_real,    -0.029016_t_real &
       &,    -0.020086_t_real,    -0.013634_t_real/
  Data bscoeffrel(1:50, 57) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000001_t_real,    -0.000005_t_real,    -0.000032_t_real &
       &,    -0.000094_t_real,    -0.000119_t_real,    -0.000059_t_real &
       &,     0.000001_t_real,    -0.000113_t_real,    -0.000506_t_real &
       &,    -0.000695_t_real,    -0.000550_t_real,    -0.000155_t_real &
       &,     0.000071_t_real,    -0.000949_t_real,    -0.003847_t_real &
       &,    -0.008117_t_real,    -0.013310_t_real,    -0.019174_t_real &
       &,    -0.025157_t_real,    -0.030006_t_real,    -0.032011_t_real &
       &,    -0.030387_t_real,    -0.026131_t_real,    -0.020885_t_real &
       &,    -0.015760_t_real,    -0.011261_t_real,    -0.007564_t_real &
       &,    -0.004696_t_real,    -0.002605_t_real,    -0.001192_t_real &
       &,    -0.000323_t_real,     0.000143_t_real,     0.000339_t_real &
       &,     0.000373_t_real,     0.000323_t_real,     0.000242_t_real &
       &,     0.000158_t_real,     0.000087_t_real,     0.000034_t_real &
       &,    -0.000001_t_real,    -0.000021_t_real,    -0.000030_t_real &
       &,    -0.000031_t_real,    -0.000028_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 58) /&
       &    -58.000000_t_real,   -57.948482_t_real,   -57.574028_t_real &
       &,   -56.544438_t_real,   -54.625558_t_real,   -51.801309_t_real &
       &,   -48.183369_t_real,   -43.955100_t_real,   -39.333066_t_real &
       &,   -34.573138_t_real,   -29.901589_t_real,   -25.525016_t_real &
       &,   -21.615191_t_real,   -18.147957_t_real,   -15.084035_t_real &
       &,   -12.384874_t_real,   -10.064405_t_real,    -8.162734_t_real &
       &,    -6.633714_t_real,    -5.415977_t_real,    -4.447187_t_real &
       &,    -3.662878_t_real,    -3.022756_t_real,    -2.501967_t_real &
       &,    -2.080661_t_real,    -1.744680_t_real,    -1.484167_t_real &
       &,    -1.286957_t_real,    -1.136348_t_real,    -1.016271_t_real &
       &,    -0.915213_t_real,    -0.825921_t_real,    -0.743865_t_real &
       &,    -0.666217_t_real,    -0.591402_t_real,    -0.518872_t_real &
       &,    -0.448884_t_real,    -0.382226_t_real,    -0.319925_t_real &
       &,    -0.262980_t_real,    -0.212169_t_real,    -0.167942_t_real &
       &,    -0.130391_t_real,    -0.099286_t_real,    -0.074138_t_real &
       &,    -0.054286_t_real,    -0.038978_t_real,    -0.027443_t_real &
       &,    -0.018947_t_real,    -0.012826_t_real/
  Data bscoeffrel(1:50, 58) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000001_t_real,    -0.000005_t_real,    -0.000031_t_real &
       &,    -0.000104_t_real,    -0.000206_t_real,    -0.000419_t_real &
       &,    -0.001245_t_real,    -0.003826_t_real,    -0.007070_t_real &
       &,    -0.008736_t_real,    -0.010292_t_real,    -0.012458_t_real &
       &,    -0.015034_t_real,    -0.016929_t_real,    -0.017980_t_real &
       &,    -0.019506_t_real,    -0.022257_t_real,    -0.026175_t_real &
       &,    -0.030560_t_real,    -0.033920_t_real,    -0.034443_t_real &
       &,    -0.031529_t_real,    -0.026367_t_real,    -0.020562_t_real &
       &,    -0.015109_t_real,    -0.010437_t_real,    -0.006681_t_real &
       &,    -0.003840_t_real,    -0.001837_t_real,    -0.000546_t_real &
       &,     0.000188_t_real,     0.000526_t_real,     0.000611_t_real &
       &,     0.000556_t_real,     0.000439_t_real,     0.000310_t_real &
       &,     0.000193_t_real,     0.000102_t_real,     0.000036_t_real &
       &,    -0.000005_t_real,    -0.000028_t_real,    -0.000037_t_real &
       &,    -0.000037_t_real,    -0.000033_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 59) /&
       &    -59.000000_t_real,   -58.947113_t_real,   -58.562306_t_real &
       &,   -57.504622_t_real,   -55.536895_t_real,   -52.645545_t_real &
       &,   -48.944968_t_real,   -44.621772_t_real,   -39.898629_t_real &
       &,   -35.034656_t_real,   -30.260628_t_real,   -25.786683_t_real &
       &,   -21.779756_t_real,   -18.206699_t_real,   -15.039341_t_real &
       &,   -12.242513_t_real,    -9.856257_t_real,    -7.919918_t_real &
       &,    -6.379495_t_real,    -5.166137_t_real,    -4.211447_t_real &
       &,    -3.450651_t_real,    -2.841218_t_real,    -2.353143_t_real &
       &,    -1.961543_t_real,    -1.649278_t_real,    -1.407011_t_real &
       &,    -1.225709_t_real,    -1.090627_t_real,    -0.985200_t_real &
       &,    -0.896909_t_real,    -0.818159_t_real,    -0.744610_t_real &
       &,    -0.673764_t_real,    -0.604301_t_real,    -0.535806_t_real &
       &,    -0.468597_t_real,    -0.403515_t_real,    -0.341675_t_real &
       &,    -0.284221_t_real,    -0.232124_t_real,    -0.186052_t_real &
       &,    -0.146319_t_real,    -0.112892_t_real,    -0.085448_t_real &
       &,    -0.063448_t_real,    -0.046220_t_real,    -0.033034_t_real &
       &,    -0.023167_t_real,    -0.015945_t_real/
  Data bscoeffrel(1:50, 59) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000004_t_real,     0.000010_t_real &
       &,    -0.000020_t_real,    -0.000288_t_real,    -0.001170_t_real &
       &,    -0.003967_t_real,    -0.011262_t_real,    -0.018701_t_real &
       &,    -0.022725_t_real,    -0.027677_t_real,    -0.034821_t_real &
       &,    -0.041903_t_real,    -0.043403_t_real,    -0.038425_t_real &
       &,    -0.031528_t_real,    -0.025443_t_real,    -0.020733_t_real &
       &,    -0.017245_t_real,    -0.014545_t_real,    -0.012066_t_real &
       &,    -0.009468_t_real,    -0.006859_t_real,    -0.004500_t_real &
       &,    -0.002538_t_real,    -0.001009_t_real,     0.000098_t_real &
       &,     0.000821_t_real,     0.001212_t_real,     0.001342_t_real &
       &,     0.001287_t_real,     0.001121_t_real,     0.000905_t_real &
       &,     0.000685_t_real,     0.000486_t_real,     0.000322_t_real &
       &,     0.000196_t_real,     0.000105_t_real,     0.000044_t_real &
       &,     0.000006_t_real,    -0.000014_t_real,    -0.000023_t_real &
       &,    -0.000024_t_real,    -0.000021_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 60) /&
       &    -60.000000_t_real,   -59.945764_t_real,   -59.550706_t_real &
       &,   -58.465248_t_real,   -56.449541_t_real,   -53.492748_t_real &
       &,   -49.712303_t_real,   -45.298316_t_real,   -40.480197_t_real &
       &,   -35.520772_t_real,   -30.656062_t_real,   -26.100542_t_real &
       &,   -22.014058_t_real,   -18.356203_t_real,   -15.108502_t_real &
       &,   -12.241220_t_real,    -9.814775_t_real,    -7.859031_t_real &
       &,    -6.310313_t_real,    -5.095449_t_real,    -4.141375_t_real &
       &,    -3.383656_t_real,    -2.780246_t_real,    -2.299641_t_real &
       &,    -1.915811_t_real,    -1.611480_t_real,    -1.377075_t_real &
       &,    -1.202480_t_real,    -1.072068_t_real,    -0.969467_t_real &
       &,    -0.882836_t_real,    -0.805109_t_real,    -0.732242_t_real &
       &,    -0.661903_t_real,    -0.592884_t_real,    -0.524856_t_real &
       &,    -0.458200_t_real,    -0.393788_t_real,    -0.332740_t_real &
       &,    -0.276180_t_real,    -0.225039_t_real,    -0.179944_t_real &
       &,    -0.141164_t_real,    -0.108632_t_real,    -0.081997_t_real &
       &,    -0.060707_t_real,    -0.044082_t_real,    -0.031395_t_real &
       &,    -0.021930_t_real,    -0.015024_t_real/
  Data bscoeffrel(1:50, 60) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000004_t_real,     0.000012_t_real &
       &,    -0.000051_t_real,    -0.000488_t_real,    -0.001898_t_real &
       &,    -0.006384_t_real,    -0.017337_t_real,    -0.026955_t_real &
       &,    -0.032191_t_real,    -0.038942_t_real,    -0.048248_t_real &
       &,    -0.056224_t_real,    -0.055898_t_real,    -0.047960_t_real &
       &,    -0.038487_t_real,    -0.030405_t_real,    -0.024181_t_real &
       &,    -0.019554_t_real,    -0.015977_t_real,    -0.012800_t_real &
       &,    -0.009672_t_real,    -0.006695_t_real,    -0.004089_t_real &
       &,    -0.001965_t_real,    -0.000344_t_real,     0.000796_t_real &
       &,     0.001497_t_real,     0.001828_t_real,     0.001872_t_real &
       &,     0.001720_t_real,     0.001459_t_real,     0.001157_t_real &
       &,     0.000863_t_real,     0.000607_t_real,     0.000399_t_real &
       &,     0.000240_t_real,     0.000127_t_real,     0.000051_t_real &
       &,     0.000004_t_real,    -0.000021_t_real,    -0.000032_t_real &
       &,    -0.000034_t_real,    -0.000031_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 61) /&
       &    -61.000000_t_real,   -60.944397_t_real,   -60.538937_t_real &
       &,   -59.425331_t_real,   -57.361160_t_real,   -54.338316_t_real &
       &,   -50.477276_t_real,   -45.971556_t_real,   -41.057383_t_real &
       &,   -36.001113_t_real,   -31.043822_t_real,   -26.404430_t_real &
       &,   -22.234307_t_real,   -18.489388_t_real,   -15.159113_t_real &
       &,   -12.223904_t_real,    -9.761318_t_real,    -7.789345_t_real &
       &,    -6.235156_t_real,    -5.020952_t_real,    -4.069546_t_real &
       &,    -3.316966_t_real,    -2.721016_t_real,    -2.248600_t_real &
       &,    -1.872811_t_real,    -1.576418_t_real,    -1.349629_t_real &
       &,    -1.181307_t_real,    -1.055142_t_real,    -0.955082_t_real &
       &,    -0.869945_t_real,    -0.793143_t_real,    -0.720896_t_real &
       &,    -0.651024_t_real,    -0.582421_t_real,    -0.514840_t_real &
       &,    -0.448714_t_real,    -0.384945_t_real,    -0.324652_t_real &
       &,    -0.268936_t_real,    -0.218695_t_real,    -0.174511_t_real &
       &,    -0.136616_t_real,    -0.104909_t_real,    -0.079017_t_real &
       &,    -0.058372_t_real,    -0.042292_t_real,    -0.030051_t_real &
       &,    -0.020943_t_real,    -0.014313_t_real/
  Data bscoeffrel(1:50, 61) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000005_t_real,     0.000011_t_real &
       &,    -0.000096_t_real,    -0.000748_t_real,    -0.002825_t_real &
       &,    -0.009432_t_real,    -0.024362_t_real,    -0.035710_t_real &
       &,    -0.042090_t_real,    -0.050609_t_real,    -0.061750_t_real &
       &,    -0.069761_t_real,    -0.066882_t_real,    -0.055915_t_real &
       &,    -0.044058_t_real,    -0.034197_t_real,    -0.026658_t_real &
       &,    -0.021067_t_real,    -0.016776_t_real,    -0.013068_t_real &
       &,    -0.009573_t_real,    -0.006364_t_real,    -0.003615_t_real &
       &,    -0.001405_t_real,     0.000256_t_real,     0.001392_t_real &
       &,     0.002054_t_real,     0.002319_t_real,     0.002282_t_real &
       &,     0.002046_t_real,     0.001704_t_real,     0.001333_t_real &
       &,     0.000984_t_real,     0.000685_t_real,     0.000445_t_real &
       &,     0.000265_t_real,     0.000137_t_real,     0.000053_t_real &
       &,     0.000001_t_real,    -0.000026_t_real,    -0.000038_t_real &
       &,    -0.000039_t_real,    -0.000035_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 62) /&
       &    -62.000000_t_real,   -61.943014_t_real,   -61.526997_t_real &
       &,   -60.384874_t_real,   -58.271764_t_real,   -55.182275_t_real &
       &,   -51.239935_t_real,   -46.641579_t_real,   -41.630299_t_real &
       &,   -36.475854_t_real,   -31.424170_t_real,   -26.698680_t_real &
       &,   -22.441173_t_real,   -18.607338_t_real,   -15.192934_t_real &
       &,   -12.193058_t_real,    -9.698345_t_real,    -7.713120_t_real &
       &,    -6.155960_t_real,    -4.944222_t_real,    -3.997160_t_real &
       &,    -3.251239_t_real,    -2.663649_t_real,    -2.199749_t_real &
       &,    -1.832024_t_real,    -1.543437_t_real,    -1.323952_t_real &
       &,    -1.161459_t_real,    -1.039142_t_real,    -0.941362_t_real &
       &,    -0.857570_t_real,    -0.781612_t_real,    -0.709938_t_real &
       &,    -0.640494_t_real,    -0.572260_t_real,    -0.505042_t_real &
       &,    -0.439297_t_real,    -0.375906_t_real,    -0.315911_t_real &
       &,    -0.260254_t_real,    -0.209556_t_real,    -0.163963_t_real &
       &,    -0.123097_t_real,    -0.086265_t_real,    -0.053241_t_real &
       &,    -0.025740_t_real,    -0.007777_t_real,    -0.000967_t_real &
       &,    -0.000024_t_real,     0.000000_t_real/
  Data bscoeffrel(1:50, 62) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000006_t_real,     0.000009_t_real &
       &,    -0.000161_t_real,    -0.001076_t_real,    -0.003977_t_real &
       &,    -0.013166_t_real,    -0.032190_t_real,    -0.044812_t_real &
       &,    -0.052295_t_real,    -0.062522_t_real,    -0.075112_t_real &
       &,    -0.082357_t_real,    -0.076449_t_real,    -0.062537_t_real &
       &,    -0.048526_t_real,    -0.037107_t_real,    -0.028442_t_real &
       &,    -0.022051_t_real,    -0.017189_t_real,    -0.013079_t_real &
       &,    -0.009326_t_real,    -0.005967_t_real,    -0.003130_t_real &
       &,    -0.000872_t_real,     0.000801_t_real,     0.001917_t_real &
       &,     0.002530_t_real,     0.002727_t_real,     0.002611_t_real &
       &,     0.002295_t_real,     0.001881_t_real,     0.001447_t_real &
       &,     0.001046_t_real,     0.000705_t_real,     0.000432_t_real &
       &,     0.000226_t_real,     0.000082_t_real,    -0.000001_t_real &
       &,    -0.000028_t_real,    -0.000017_t_real,    -0.000003_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 63) /&
       &    -63.000000_t_real,   -62.941615_t_real,   -62.514888_t_real &
       &,   -61.343880_t_real,   -59.181366_t_real,   -56.024651_t_real &
       &,   -52.000321_t_real,   -47.308468_t_real,   -42.199055_t_real &
       &,   -36.945156_t_real,   -31.797351_t_real,   -26.983592_t_real &
       &,   -22.635308_t_real,   -18.710998_t_real,   -15.211657_t_real &
       &,   -12.150915_t_real,    -9.627992_t_real,    -7.632332_t_real &
       &,    -6.074464_t_real,    -4.866771_t_real,    -3.925502_t_real &
       &,    -3.187445_t_real,    -2.608846_t_real,    -2.153642_t_real &
       &,    -1.793958_t_real,    -1.513034_t_real,    -1.300544_t_real &
       &,    -1.143457_t_real,    -1.024617_t_real,    -0.928866_t_real &
       &,    -0.846262_t_real,    -0.771042_t_real,    -0.699869_t_real &
       &,    -0.630812_t_real,    -0.562938_t_real,    -0.496123_t_real &
       &,    -0.430872_t_real,    -0.368086_t_real,    -0.308805_t_real &
       &,    -0.253954_t_real,    -0.204129_t_real,    -0.159449_t_real &
       &,    -0.119520_t_real,    -0.083638_t_real,    -0.051556_t_real &
       &,    -0.024898_t_real,    -0.007516_t_real,    -0.000934_t_real &
       &,    -0.000023_t_real,     0.000000_t_real/
  Data bscoeffrel(1:50, 63) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000007_t_real,     0.000005_t_real &
       &,    -0.000246_t_real,    -0.001479_t_real,    -0.005384_t_real &
       &,    -0.017634_t_real,    -0.040665_t_real,    -0.054157_t_real &
       &,    -0.062725_t_real,    -0.074572_t_real,    -0.088189_t_real &
       &,    -0.093949_t_real,    -0.084740_t_real,    -0.068051_t_real &
       &,    -0.052120_t_real,    -0.039348_t_real,    -0.029733_t_real &
       &,    -0.022688_t_real,    -0.017379_t_real,    -0.012969_t_real &
       &,    -0.009034_t_real,    -0.005573_t_real,    -0.002677_t_real &
       &,    -0.000388_t_real,     0.001289_t_real,     0.002380_t_real &
       &,     0.002947_t_real,     0.003081_t_real,     0.002896_t_real &
       &,     0.002513_t_real,     0.002039_t_real,     0.001556_t_real &
       &,     0.001116_t_real,     0.000746_t_real,     0.000453_t_real &
       &,     0.000234_t_real,     0.000083_t_real,    -0.000004_t_real &
       &,    -0.000031_t_real,    -0.000018_t_real,    -0.000003_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 64) /&
       &    -64.000000_t_real,   -63.940238_t_real,   -63.502925_t_real &
       &,   -62.303419_t_real,   -60.092523_t_real,   -56.870497_t_real &
       &,   -52.767328_t_real,   -47.986725_t_real,   -42.786034_t_real &
       &,   -37.442321_t_real,   -32.211452_t_real,   -27.326174_t_real &
       &,   -22.905960_t_real,   -18.914270_t_real,   -15.355995_t_real &
       &,   -12.263485_t_real,    -9.735043_t_real,    -7.740050_t_real &
       &,    -6.182165_t_real,    -4.969766_t_real,    -4.017343_t_real &
       &,    -3.264657_t_real,    -2.670042_t_real,    -2.199811_t_real &
       &,    -1.829549_t_real,    -1.543722_t_real,    -1.328206_t_real &
       &,    -1.165218_t_real,    -1.037129_t_real,    -0.931021_t_real &
       &,    -0.838751_t_real,    -0.755237_t_real,    -0.677218_t_real &
       &,    -0.602715_t_real,    -0.530802_t_real,    -0.461415_t_real &
       &,    -0.395113_t_real,    -0.332793_t_real,    -0.275419_t_real &
       &,    -0.223806_t_real,    -0.178491_t_real,    -0.139670_t_real &
       &,    -0.107219_t_real,    -0.080739_t_real,    -0.059640_t_real &
       &,    -0.043217_t_real,    -0.030722_t_real,    -0.021427_t_real &
       &,    -0.014664_t_real,    -0.009848_t_real/
  Data bscoeffrel(1:50, 64) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,    -0.000004_t_real,    -0.000055_t_real &
       &,    -0.000449_t_real,    -0.001952_t_real,    -0.006719_t_real &
       &,    -0.021712_t_real,    -0.047227_t_real,    -0.060402_t_real &
       &,    -0.069062_t_real,    -0.080705_t_real,    -0.092417_t_real &
       &,    -0.093869_t_real,    -0.081643_t_real,    -0.065847_t_real &
       &,    -0.053521_t_real,    -0.045944_t_real,    -0.042368_t_real &
       &,    -0.041045_t_real,    -0.039454_t_real,    -0.035716_t_real &
       &,    -0.029941_t_real,    -0.023381_t_real,    -0.017080_t_real &
       &,    -0.011582_t_real,    -0.007112_t_real,    -0.003724_t_real &
       &,    -0.001358_t_real,     0.000122_t_real,     0.000905_t_real &
       &,     0.001193_t_real,     0.001172_t_real,     0.000991_t_real &
       &,     0.000753_t_real,     0.000522_t_real,     0.000326_t_real &
       &,     0.000178_t_real,     0.000075_t_real,     0.000012_t_real &
       &,    -0.000022_t_real,    -0.000036_t_real,    -0.000038_t_real &
       &,    -0.000033_t_real,    -0.000026_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 65) /&
       &    -65.000000_t_real,   -64.938771_t_real,   -64.490199_t_real &
       &,   -63.260423_t_real,   -60.997930_t_real,   -57.705401_t_real &
       &,   -53.515587_t_real,   -48.635032_t_real,   -43.327382_t_real &
       &,   -37.872317_t_real,   -32.529330_t_real,   -27.535255_t_real &
       &,   -23.000202_t_real,   -18.896247_t_real,   -15.231912_t_real &
       &,   -12.065539_t_real,    -9.499934_t_real,    -7.492539_t_real &
       &,    -5.937546_t_real,    -4.736549_t_real,    -3.804142_t_real &
       &,    -3.079094_t_real,    -2.515412_t_real,    -2.074604_t_real &
       &,    -1.728670_t_real,    -1.461385_t_real,    -1.261198_t_real &
       &,    -1.112947_t_real,    -0.999142_t_real,    -0.905862_t_real &
       &,    -0.824397_t_real,    -0.749691_t_real,    -0.678755_t_real &
       &,    -0.609873_t_real,    -0.542281_t_real,    -0.476004_t_real &
       &,    -0.411661_t_real,    -0.350234_t_real,    -0.292817_t_real &
       &,    -0.240401_t_real,    -0.193720_t_real,    -0.153178_t_real &
       &,    -0.118840_t_real,    -0.090465_t_real,    -0.067582_t_real &
       &,    -0.049566_t_real,    -0.035711_t_real,    -0.025302_t_real &
       &,    -0.017657_t_real,    -0.012166_t_real/
  Data bscoeffrel(1:50, 65) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000004_t_real,    -0.000009_t_real &
       &,    -0.000275_t_real,    -0.001422_t_real,    -0.005073_t_real &
       &,    -0.016135_t_real,    -0.032829_t_real,    -0.040771_t_real &
       &,    -0.046662_t_real,    -0.054587_t_real,    -0.061940_t_real &
       &,    -0.061869_t_real,    -0.052760_t_real,    -0.040784_t_real &
       &,    -0.030158_t_real,    -0.021796_t_real,    -0.015538_t_real &
       &,    -0.010989_t_real,    -0.007671_t_real,    -0.005128_t_real &
       &,    -0.003075_t_real,    -0.001391_t_real,    -0.000037_t_real &
       &,     0.000992_t_real,     0.001701_t_real,     0.002104_t_real &
       &,     0.002237_t_real,     0.002155_t_real,     0.001925_t_real &
       &,     0.001614_t_real,     0.001279_t_real,     0.000963_t_real &
       &,     0.000688_t_real,     0.000465_t_real,     0.000293_t_real &
       &,     0.000168_t_real,     0.000080_t_real,     0.000023_t_real &
       &,    -0.000012_t_real,    -0.000031_t_real,    -0.000040_t_real &
       &,    -0.000041_t_real,    -0.000039_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 66) /&
       &    -66.000000_t_real,   -65.937323_t_real,   -65.477586_t_real &
       &,   -64.217853_t_real,   -61.904650_t_real,   -58.543305_t_real &
       &,   -54.269634_t_real,   -49.293377_t_real,   -43.884872_t_real &
       &,   -38.327091_t_real,   -32.883776_t_real,   -27.795874_t_real &
       &,   -23.163278_t_real,   -18.967274_t_real,   -15.221287_t_real &
       &,   -12.007968_t_real,    -9.425415_t_real,    -7.414830_t_real &
       &,    -5.862838_t_real,    -4.666669_t_real,    -3.740683_t_real &
       &,    -3.023756_t_real,    -2.468467_t_real,    -2.035368_t_real &
       &,    -1.696601_t_real,    -1.436151_t_real,    -1.241822_t_real &
       &,    -1.097651_t_real,    -0.986231_t_real,    -0.894253_t_real &
       &,    -0.813518_t_real,    -0.739248_t_real,    -0.668599_t_real &
       &,    -0.599946_t_real,    -0.532599_t_real,    -0.466642_t_real &
       &,    -0.402735_t_real,    -0.341873_t_real,    -0.285139_t_real &
       &,    -0.233494_t_real,    -0.187634_t_real,    -0.147922_t_real &
       &,    -0.114382_t_real,    -0.086747_t_real,    -0.064523_t_real &
       &,    -0.047071_t_real,    -0.033686_t_real,    -0.023653_t_real &
       &,    -0.016302_t_real,    -0.011035_t_real/
  Data bscoeffrel(1:50, 66) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000003_t_real,    -0.000013_t_real &
       &,    -0.000263_t_real,    -0.001291_t_real,    -0.004579_t_real &
       &,    -0.014276_t_real,    -0.027282_t_real,    -0.033016_t_real &
       &,    -0.037624_t_real,    -0.043648_t_real,    -0.048530_t_real &
       &,    -0.047122_t_real,    -0.039297_t_real,    -0.029924_t_real &
       &,    -0.021812_t_real,    -0.015482_t_real,    -0.010770_t_real &
       &,    -0.007374_t_real,    -0.004943_t_real,    -0.003137_t_real &
       &,    -0.001725_t_real,    -0.000590_t_real,     0.000312_t_real &
       &,     0.000987_t_real,     0.001437_t_real,     0.001673_t_real &
       &,     0.001721_t_real,     0.001623_t_real,     0.001426_t_real &
       &,     0.001179_t_real,     0.000924_t_real,     0.000687_t_real &
       &,     0.000485_t_real,     0.000323_t_real,     0.000200_t_real &
       &,     0.000112_t_real,     0.000051_t_real,     0.000012_t_real &
       &,    -0.000010_t_real,    -0.000022_t_real,    -0.000026_t_real &
       &,    -0.000026_t_real,    -0.000023_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 67) /&
       &    -67.000000_t_real,   -66.935859_t_real,   -66.464792_t_real &
       &,   -65.174726_t_real,   -62.810347_t_real,   -59.379606_t_real &
       &,   -55.021366_t_real,   -49.948572_t_real,   -44.438109_t_real &
       &,   -38.776272_t_real,   -33.230967_t_real,   -28.046930_t_real &
       &,   -23.314594_t_real,   -19.025318_t_real,   -15.199314_t_real &
       &,   -11.943178_t_real,    -9.346469_t_real,    -7.334368_t_real &
       &,    -5.786412_t_real,    -4.596084_t_real,    -3.677606_t_real &
       &,    -2.969512_t_real,    -2.422903_t_real,    -1.997584_t_real &
       &,    -1.665965_t_real,    -1.412205_t_real,    -1.223448_t_real &
       &,    -1.083067_t_real,    -0.973849_t_real,    -0.883092_t_real &
       &,    -0.803060_t_real,    -0.729225_t_real,    -0.658873_t_real &
       &,    -0.590464_t_real,    -0.523383_t_real,    -0.457769_t_real &
       &,    -0.394315_t_real,    -0.334029_t_real,    -0.277981_t_real &
       &,    -0.227103_t_real,    -0.182052_t_real,    -0.143153_t_real &
       &,    -0.110394_t_real,    -0.083479_t_real,    -0.061896_t_real &
       &,    -0.044998_t_real,    -0.032076_t_real,    -0.022420_t_real &
       &,    -0.015368_t_real,    -0.010331_t_real/
  Data bscoeffrel(1:50, 67) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000002_t_real,    -0.000014_t_real &
       &,    -0.000232_t_real,    -0.001090_t_real,    -0.003849_t_real &
       &,    -0.011716_t_real,    -0.021064_t_real,    -0.024963_t_real &
       &,    -0.028342_t_real,    -0.032600_t_real,    -0.035527_t_real &
       &,    -0.033610_t_real,    -0.027486_t_real,    -0.020654_t_real &
       &,    -0.014862_t_real,    -0.010376_t_real,    -0.007057_t_real &
       &,    -0.004687_t_real,    -0.003020_t_real,    -0.001814_t_real &
       &,    -0.000894_t_real,    -0.000165_t_real,     0.000409_t_real &
       &,     0.000832_t_real,     0.001105_t_real,     0.001234_t_real &
       &,     0.001239_t_real,     0.001148_t_real,     0.000996_t_real &
       &,     0.000815_t_real,     0.000632_t_real,     0.000466_t_real &
       &,     0.000326_t_real,     0.000215_t_real,     0.000131_t_real &
       &,     0.000072_t_real,     0.000031_t_real,     0.000006_t_real &
       &,    -0.000008_t_real,    -0.000015_t_real,    -0.000017_t_real &
       &,    -0.000016_t_real,    -0.000014_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 68) /&
       &    -68.000000_t_real,   -67.934377_t_real,   -67.451818_t_real &
       &,   -66.131040_t_real,   -63.715026_t_real,   -60.214317_t_real &
       &,   -55.770804_t_real,   -50.600660_t_real,   -44.987149_t_real &
       &,   -39.219930_t_real,   -33.571044_t_real,   -28.288606_t_real &
       &,   -23.454659_t_real,   -19.071054_t_real,   -15.167300_t_real &
       &,   -11.872451_t_real,    -9.264194_t_real,    -7.252120_t_real &
       &,    -5.709179_t_real,    -4.525635_t_real,    -3.615555_t_real &
       &,    -2.916785_t_real,    -2.378977_t_real,    -1.961401_t_real &
       &,    -1.636838_t_real,    -1.389577_t_real,    -1.206086_t_real &
       &,    -1.069201_t_real,    -0.961995_t_real,    -0.872359_t_real &
       &,    -0.792982_t_real,    -0.719558_t_real,    -0.649493_t_real &
       &,    -0.581329_t_real,    -0.514518_t_real,    -0.449253_t_real &
       &,    -0.386260_t_real,    -0.326552_t_real,    -0.271186_t_real &
       &,    -0.221064_t_real,    -0.176806_t_real,    -0.138697_t_real &
       &,    -0.106694_t_real,    -0.080473_t_real,    -0.059506_t_real &
       &,    -0.043138_t_real,    -0.030656_t_real,    -0.021357_t_real &
       &,    -0.014586_t_real,    -0.009766_t_real/
  Data bscoeffrel(1:50, 68) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,    -0.000013_t_real &
       &,    -0.000181_t_real,    -0.000819_t_real,    -0.002879_t_real &
       &,    -0.008523_t_real,    -0.014457_t_real,    -0.016847_t_real &
       &,    -0.019064_t_real,    -0.021735_t_real,    -0.023223_t_real &
       &,    -0.021450_t_real,    -0.017241_t_real,    -0.012803_t_real &
       &,    -0.009104_t_real,    -0.006259_t_real,    -0.004167_t_real &
       &,    -0.002688_t_real,    -0.001663_t_real,    -0.000938_t_real &
       &,    -0.000396_t_real,     0.000030_t_real,     0.000362_t_real &
       &,     0.000603_t_real,     0.000751_t_real,     0.000813_t_real &
       &,     0.000801_t_real,     0.000732_t_real,     0.000628_t_real &
       &,     0.000509_t_real,     0.000391_t_real,     0.000286_t_real &
       &,     0.000199_t_real,     0.000130_t_real,     0.000078_t_real &
       &,     0.000042_t_real,     0.000018_t_real,     0.000003_t_real &
       &,    -0.000006_t_real,    -0.000010_t_real,    -0.000011_t_real &
       &,    -0.000010_t_real,    -0.000009_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 69) /&
       &    -69.000000_t_real,   -68.932878_t_real,   -68.438661_t_real &
       &,   -67.086792_t_real,   -64.618684_t_real,   -61.047441_t_real &
       &,   -56.517953_t_real,   -51.249660_t_real,   -45.532010_t_real &
       &,   -39.658081_t_real,   -33.904067_t_real,   -28.520997_t_real &
       &,   -23.583840_t_real,   -19.105064_t_real,   -15.126351_t_real &
       &,   -11.796802_t_real,    -9.179419_t_real,    -7.168798_t_real &
       &,    -5.631784_t_real,    -4.455874_t_real,    -3.554905_t_real &
       &,    -2.865776_t_real,    -2.336775_t_real,    -1.926839_t_real &
       &,    -1.609198_t_real,    -1.368215_t_real,    -1.189677_t_real &
       &,    -1.056003_t_real,    -0.950626_t_real,    -0.862010_t_real &
       &,    -0.783233_t_real,    -0.710189_t_real,    -0.640392_t_real &
       &,    -0.572465_t_real,    -0.505923_t_real,    -0.441010_t_real &
       &,    -0.378478_t_real,    -0.319348_t_real,    -0.264658_t_real &
       &,    -0.215281_t_real,    -0.171801_t_real,    -0.134464_t_real &
       &,    -0.103194_t_real,    -0.077644_t_real,    -0.057271_t_real &
       &,    -0.041409_t_real,    -0.029348_t_real,    -0.020388_t_real &
       &,    -0.013883_t_real,    -0.009266_t_real/
  Data bscoeffrel(1:50, 69) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,    -0.000009_t_real &
       &,    -0.000107_t_real,    -0.000471_t_real,    -0.001651_t_real &
       &,    -0.004734_t_real,    -0.007604_t_real,    -0.008742_t_real &
       &,    -0.009861_t_real,    -0.011139_t_real,    -0.011672_t_real &
       &,    -0.010543_t_real,    -0.008343_t_real,    -0.006129_t_real &
       &,    -0.004309_t_real,    -0.002918_t_real,    -0.001902_t_real &
       &,    -0.001189_t_real,    -0.000703_t_real,    -0.000366_t_real &
       &,    -0.000117_t_real,     0.000076_t_real,     0.000225_t_real &
       &,     0.000331_t_real,     0.000393_t_real,     0.000415_t_real &
       &,     0.000401_t_real,     0.000362_t_real,     0.000308_t_real &
       &,     0.000247_t_real,     0.000189_t_real,     0.000137_t_real &
       &,     0.000095_t_real,     0.000061_t_real,     0.000037_t_real &
       &,     0.000019_t_real,     0.000008_t_real,     0.000001_t_real &
       &,    -0.000003_t_real,    -0.000005_t_real,    -0.000005_t_real &
       &,    -0.000005_t_real,    -0.000004_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 70) /&
       &    -70.000000_t_real,   -69.931361_t_real,   -69.425317_t_real &
       &,   -68.041976_t_real,   -65.521316_t_real,   -61.878973_t_real &
       &,   -57.262803_t_real,   -51.895565_t_real,   -46.072674_t_real &
       &,   -40.090687_t_real,   -34.230021_t_real,   -28.744108_t_real &
       &,   -23.702367_t_real,   -19.127836_t_real,   -15.077383_t_real &
       &,   -11.717017_t_real,    -9.092758_t_real,    -7.084911_t_real &
       &,    -5.554679_t_real,    -4.387166_t_real,    -3.495875_t_real &
       &,    -2.816574_t_real,    -2.296307_t_real,    -1.893868_t_real &
       &,    -1.582992_t_real,    -1.348049_t_real,    -1.174154_t_real &
       &,    -1.043421_t_real,    -0.939698_t_real,    -0.852005_t_real &
       &,    -0.773773_t_real,    -0.701075_t_real,    -0.631527_t_real &
       &,    -0.563826_t_real,    -0.497549_t_real,    -0.432987_t_real &
       &,    -0.370918_t_real,    -0.312364_t_real,    -0.258346_t_real &
       &,    -0.209707_t_real,    -0.166991_t_real,    -0.130409_t_real &
       &,    -0.099855_t_real,    -0.074958_t_real,    -0.055158_t_real &
       &,    -0.039785_t_real,    -0.028127_t_real,    -0.019490_t_real &
       &,    -0.013237_t_real,    -0.008812_t_real/
  Data bscoeffrel(1:50, 70) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 71) /&
       &    -71.000000_t_real,   -70.929868_t_real,   -70.412106_t_real &
       &,   -68.997676_t_real,   -66.425515_t_real,   -62.714041_t_real &
       &,   -58.014378_t_real,   -52.553075_t_real,   -46.631777_t_real &
       &,   -40.551242_t_real,   -34.596859_t_real,   -29.023868_t_real &
       &,   -23.897093_t_real,   -19.250051_t_real,   -15.156381_t_real &
       &,   -11.792071_t_real,    -9.179411_t_real,    -7.183528_t_real &
       &,    -5.661264_t_real,    -4.495800_t_real,    -3.600748_t_real &
       &,    -2.912157_t_real,    -2.378934_t_real,    -1.964125_t_real &
       &,    -1.644846_t_real,    -1.403893_t_real,    -1.222039_t_real &
       &,    -1.080174_t_real,    -0.964078_t_real,    -0.864752_t_real &
       &,    -0.776541_t_real,    -0.695707_t_real,    -0.619812_t_real &
       &,    -0.547497_t_real,    -0.478315_t_real,    -0.412517_t_real &
       &,    -0.350767_t_real,    -0.293875_t_real,    -0.242558_t_real &
       &,    -0.197297_t_real,    -0.158259_t_real,    -0.125306_t_real &
       &,    -0.098037_t_real,    -0.075868_t_real,    -0.058113_t_real &
       &,    -0.044068_t_real,    -0.033075_t_real,    -0.024556_t_real &
       &,    -0.018025_t_real,    -0.013077_t_real/
  Data bscoeffrel(1:50, 71) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000000_t_real,    -0.000012_t_real,    -0.000045_t_real &
       &,    -0.000063_t_real,    -0.000015_t_real,     0.000045_t_real &
       &,     0.000009_t_real,    -0.000108_t_real,    -0.000089_t_real &
       &,     0.000071_t_real,     0.000184_t_real,    -0.000259_t_real &
       &,    -0.001772_t_real,    -0.004361_t_real,    -0.007910_t_real &
       &,    -0.012431_t_real,    -0.017813_t_real,    -0.023369_t_real &
       &,    -0.027587_t_real,    -0.029016_t_real,    -0.027676_t_real &
       &,    -0.024733_t_real,    -0.021246_t_real,    -0.017783_t_real &
       &,    -0.014591_t_real,    -0.011770_t_real,    -0.009354_t_real &
       &,    -0.007340_t_real,    -0.005698_t_real,    -0.004384_t_real &
       &,    -0.003344_t_real,    -0.002524_t_real,    -0.001874_t_real &
       &,    -0.001357_t_real,    -0.000944_t_real,    -0.000618_t_real &
       &,    -0.000374_t_real,    -0.000210_t_real,    -0.000128_t_real &
       &,    -0.000120_t_real,    -0.000165_t_real,    -0.000231_t_real &
       &,    -0.000285_t_real,    -0.000309_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 72) /&
       &    -72.000000_t_real,   -71.928362_t_real,   -71.398741_t_real &
       &,   -69.952924_t_real,   -67.328982_t_real,   -63.548116_t_real &
       &,   -58.764725_t_real,   -53.209295_t_real,   -47.189600_t_real &
       &,   -41.010856_t_real,   -34.963683_t_real,   -29.304260_t_real &
       &,   -24.094257_t_real,   -19.377325_t_real,   -15.245667_t_real &
       &,   -11.879527_t_real,    -9.274794_t_real,    -7.282777_t_real &
       &,    -5.757319_t_real,    -4.581376_t_real,    -3.670796_t_real &
       &,    -2.964146_t_real,    -2.413726_t_real,    -1.986091_t_real &
       &,    -1.658716_t_real,    -1.411080_t_real,    -1.221474_t_real &
       &,    -1.071360_t_real,    -0.947858_t_real,    -0.842490_t_real &
       &,    -0.749451_t_real,    -0.664702_t_real,    -0.585632_t_real &
       &,    -0.510874_t_real,    -0.440065_t_real,    -0.373533_t_real &
       &,    -0.311965_t_real,    -0.256107_t_real,    -0.206546_t_real &
       &,    -0.163596_t_real,    -0.127252_t_real,    -0.097217_t_real &
       &,    -0.072965_t_real,    -0.053820_t_real,    -0.039033_t_real &
       &,    -0.027847_t_real,    -0.019552_t_real,    -0.013516_t_real &
       &,    -0.009202_t_real,    -0.006170_t_real/
  Data bscoeffrel(1:50, 72) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000002_t_real,    -0.000033_t_real,    -0.000122_t_real &
       &,    -0.000167_t_real,    -0.000046_t_real,     0.000080_t_real &
       &,    -0.000114_t_real,    -0.000457_t_real,    -0.000376_t_real &
       &,     0.000062_t_real,     0.000251_t_real,    -0.001255_t_real &
       &,    -0.005571_t_real,    -0.012374_t_real,    -0.021143_t_real &
       &,    -0.031538_t_real,    -0.042595_t_real,    -0.051919_t_real &
       &,    -0.056308_t_real,    -0.054515_t_real,    -0.048356_t_real &
       &,    -0.040422_t_real,    -0.032386_t_real,    -0.025034_t_real &
       &,    -0.018694_t_real,    -0.013477_t_real,    -0.009376_t_real &
       &,    -0.006302_t_real,    -0.004106_t_real,    -0.002609_t_real &
       &,    -0.001630_t_real,    -0.001010_t_real,    -0.000623_t_real &
       &,    -0.000381_t_real,    -0.000226_t_real,    -0.000123_t_real &
       &,    -0.000054_t_real,    -0.000007_t_real,     0.000024_t_real &
       &,     0.000041_t_real,     0.000046_t_real,     0.000043_t_real &
       &,     0.000034_t_real,     0.000021_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 73) /&
       &    -73.000000_t_real,   -72.926842_t_real,   -72.385217_t_real &
       &,   -70.907712_t_real,   -68.231706_t_real,   -64.381187_t_real &
       &,   -59.513819_t_real,   -53.864180_t_real,   -47.746048_t_real &
       &,   -41.469333_t_real,   -35.330132_t_real,   -29.584653_t_real &
       &,   -24.292963_t_real,   -19.508557_t_real,   -15.343522_t_real &
       &,   -11.976502_t_real,    -9.375476_t_real,    -7.380045_t_real &
       &,    -5.842587_t_real,    -4.647609_t_real,    -3.715028_t_real &
       &,    -2.987141_t_real,    -2.419617_t_real,    -1.980900_t_real &
       &,    -1.647018_t_real,    -1.394283_t_real,    -1.199725_t_real &
       &,    -1.045322_t_real,    -0.918588_t_real,    -0.810892_t_real &
       &,    -0.716112_t_real,    -0.630036_t_real,    -0.550072_t_real &
       &,    -0.474981_t_real,    -0.404534_t_real,    -0.339125_t_real &
       &,    -0.279410_t_real,    -0.226020_t_real,    -0.179377_t_real &
       &,    -0.139602_t_real,    -0.106506_t_real,    -0.079640_t_real &
       &,    -0.058357_t_real,    -0.041902_t_real,    -0.029480_t_real &
       &,    -0.020322_t_real,    -0.013727_t_real,    -0.009085_t_real &
       &,    -0.005891_t_real,    -0.003744_t_real/
  Data bscoeffrel(1:50, 73) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000002_t_real &
       &,    -0.000006_t_real,    -0.000064_t_real,    -0.000230_t_real &
       &,    -0.000305_t_real,    -0.000084_t_real,     0.000103_t_real &
       &,    -0.000374_t_real,    -0.000996_t_real,    -0.000778_t_real &
       &,     0.000045_t_real,     0.000160_t_real,    -0.003210_t_real &
       &,    -0.011582_t_real,    -0.023762_t_real,    -0.038461_t_real &
       &,    -0.054506_t_real,    -0.069449_t_real,    -0.079095_t_real &
       &,    -0.079958_t_real,    -0.072725_t_real,    -0.061116_t_real &
       &,    -0.048457_t_real,    -0.036581_t_real,    -0.026295_t_real &
       &,    -0.017893_t_real,    -0.011407_t_real,    -0.006700_t_real &
       &,    -0.003519_t_real,    -0.001546_t_real,    -0.000446_t_real &
       &,     0.000080_t_real,     0.000267_t_real,     0.000279_t_real &
       &,     0.000216_t_real,     0.000137_t_real,     0.000068_t_real &
       &,     0.000018_t_real,    -0.000011_t_real,    -0.000025_t_real &
       &,    -0.000028_t_real,    -0.000025_t_real,    -0.000020_t_real &
       &,    -0.000014_t_real,    -0.000010_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 74) /&
       &    -74.000000_t_real,   -73.925309_t_real,   -73.371529_t_real &
       &,   -71.862029_t_real,   -69.133671_t_real,   -65.213228_t_real &
       &,   -60.261614_t_real,   -54.517657_t_real,   -48.301012_t_real &
       &,   -41.926484_t_real,   -35.695895_t_real,   -29.864561_t_real &
       &,   -24.492520_t_real,   -19.642953_t_real,   -15.448520_t_real &
       &,   -12.080455_t_real,    -9.478358_t_real,    -7.472692_t_real &
       &,    -5.915845_t_real,    -4.695630_t_real,    -3.737450_t_real &
       &,    -2.987737_t_real,    -2.404855_t_real,    -1.957680_t_real &
       &,    -1.619740_t_real,    -1.364480_t_real,    -1.168061_t_real &
       &,    -1.012547_t_real,    -0.885338_t_real,    -0.777510_t_real &
       &,    -0.682756_t_real,    -0.596874_t_real,    -0.517411_t_real &
       &,    -0.443289_t_real,    -0.374377_t_real,    -0.311070_t_real &
       &,    -0.253939_t_real,    -0.203469_t_real,    -0.159908_t_real &
       &,    -0.123207_t_real,    -0.093035_t_real,    -0.068832_t_real &
       &,    -0.049887_t_real,    -0.035412_t_real,    -0.024615_t_real &
       &,    -0.016753_t_real,    -0.011161_t_real,    -0.007278_t_real &
       &,    -0.004644_t_real,    -0.002899_t_real/
  Data bscoeffrel(1:50, 74) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,     0.000003_t_real &
       &,    -0.000012_t_real,    -0.000105_t_real,    -0.000371_t_real &
       &,    -0.000472_t_real,    -0.000124_t_real,     0.000109_t_real &
       &,    -0.000779_t_real,    -0.001698_t_real,    -0.001244_t_real &
       &,     0.000060_t_real,    -0.000180_t_real,    -0.006419_t_real &
       &,    -0.020051_t_real,    -0.038381_t_real,    -0.059024_t_real &
       &,    -0.079591_t_real,    -0.095941_t_real,    -0.102856_t_real &
       &,    -0.098182_t_real,    -0.085033_t_real,    -0.068369_t_real &
       &,    -0.051730_t_real,    -0.036906_t_real,    -0.024629_t_real &
       &,    -0.015087_t_real,    -0.008157_t_real,    -0.003518_t_real &
       &,    -0.000724_t_real,     0.000717_t_real,     0.001266_t_real &
       &,     0.001301_t_real,     0.001087_t_real,     0.000794_t_real &
       &,     0.000512_t_real,     0.000285_t_real,     0.000125_t_real &
       &,     0.000027_t_real,    -0.000021_t_real,    -0.000035_t_real &
       &,    -0.000029_t_real,    -0.000016_t_real,    -0.000003_t_real &
       &,     0.000006_t_real,     0.000012_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 75) /&
       &    -75.000000_t_real,   -74.923762_t_real,   -74.357675_t_real &
       &,   -72.815868_t_real,   -70.034869_t_real,   -66.044228_t_real &
       &,   -61.008095_t_real,   -55.169703_t_real,   -48.854451_t_real &
       &,   -42.382224_t_real,   -36.060808_t_real,   -30.143736_t_real &
       &,   -24.692540_t_real,   -19.780127_t_real,   -15.559695_t_real &
       &,   -12.189503_t_real,    -9.581282_t_real,    -7.559099_t_real &
       &,    -5.976631_t_real,    -4.726681_t_real,    -3.741116_t_real &
       &,    -2.970397_t_real,    -2.374719_t_real,    -1.922106_t_real &
       &,    -1.582847_t_real,    -1.327724_t_real,    -1.132050_t_real &
       &,    -0.977657_t_real,    -0.851681_t_real,    -0.745005_t_real &
       &,    -0.651316_t_real,    -0.566551_t_real,    -0.488443_t_real &
       &,    -0.416045_t_real,    -0.349270_t_real,    -0.288468_t_real &
       &,    -0.234094_t_real,    -0.186489_t_real,    -0.145751_t_real &
       &,    -0.111705_t_real,    -0.083920_t_real,    -0.061779_t_real &
       &,    -0.044550_t_real,    -0.031456_t_real,    -0.021739_t_real &
       &,    -0.014700_t_real,    -0.009723_t_real,    -0.006289_t_real &
       &,    -0.003978_t_real,    -0.002461_t_real/
  Data bscoeffrel(1:50, 75) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,     0.000003_t_real &
       &,    -0.000020_t_real,    -0.000160_t_real,    -0.000552_t_real &
       &,    -0.000674_t_real,    -0.000165_t_real,     0.000090_t_real &
       &,    -0.001352_t_real,    -0.002564_t_real,    -0.001745_t_real &
       &,     0.000125_t_real,    -0.000928_t_real,    -0.011299_t_real &
       &,    -0.031412_t_real,    -0.056449_t_real,    -0.082696_t_real &
       &,    -0.106326_t_real,    -0.121714_t_real,    -0.123775_t_real &
       &,    -0.112677_t_real,    -0.093681_t_real,    -0.072418_t_real &
       &,    -0.052397_t_real,    -0.035284_t_real,    -0.021679_t_real &
       &,    -0.011601_t_real,    -0.004721_t_real,    -0.000500_t_real &
       &,     0.001705_t_real,     0.002534_t_real,     0.002539_t_real &
       &,     0.002137_t_real,     0.001598_t_real,     0.001079_t_real &
       &,     0.000655_t_real,     0.000354_t_real,     0.000172_t_real &
       &,     0.000085_t_real,     0.000064_t_real,     0.000077_t_real &
       &,     0.000099_t_real,     0.000113_t_real,     0.000115_t_real &
       &,     0.000106_t_real,     0.000089_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 76) /&
       &    -76.000000_t_real,   -75.922201_t_real,   -75.343647_t_real &
       &,   -73.769217_t_real,   -70.935279_t_real,   -66.874161_t_real &
       &,   -61.753216_t_real,   -55.820258_t_real,   -49.406324_t_real &
       &,   -42.836540_t_real,   -36.424827_t_real,   -30.422082_t_real &
       &,   -24.892838_t_real,   -19.919964_t_real,   -15.676260_t_real &
       &,   -12.301717_t_real,    -9.681819_t_real,    -7.637510_t_real &
       &,    -6.025650_t_real,    -4.746167_t_real,    -3.737829_t_real &
       &,    -2.953725_t_real,    -2.352694_t_real,    -1.898423_t_real &
       &,    -1.557581_t_real,    -1.300518_t_real,    -1.103387_t_real &
       &,    -0.948311_t_real,    -0.822194_t_real,    -0.715616_t_real &
       &,    -0.622117_t_real,    -0.537655_t_real,    -0.460072_t_real &
       &,    -0.388547_t_real,    -0.323071_t_real,    -0.264008_t_real &
       &,    -0.211762_t_real,    -0.166571_t_real,    -0.128408_t_real &
       &,    -0.096966_t_real,    -0.071700_t_real,    -0.051900_t_real &
       &,    -0.036766_t_real,    -0.025483_t_real,    -0.017277_t_real &
       &,    -0.011456_t_real,    -0.007427_t_real,    -0.004706_t_real &
       &,    -0.002915_t_real,    -0.001764_t_real/
  Data bscoeffrel(1:50, 76) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000001_t_real,     0.000002_t_real &
       &,    -0.000019_t_real,    -0.000145_t_real,    -0.000489_t_real &
       &,    -0.000573_t_real,    -0.000128_t_real,     0.000021_t_real &
       &,    -0.001332_t_real,    -0.002263_t_real,    -0.001422_t_real &
       &,     0.000149_t_real,    -0.001442_t_real,    -0.011468_t_real &
       &,    -0.028816_t_real,    -0.048707_t_real,    -0.067769_t_real &
       &,    -0.082654_t_real,    -0.089602_t_real,    -0.086677_t_real &
       &,    -0.075691_t_real,    -0.060675_t_real,    -0.045159_t_real &
       &,    -0.031200_t_real,    -0.019707_t_real,    -0.010926_t_real &
       &,    -0.004734_t_real,    -0.000786_t_real,     0.001385_t_real &
       &,     0.002288_t_real,     0.002392_t_real,     0.002075_t_real &
       &,     0.001599_t_real,     0.001118_t_real,     0.000708_t_real &
       &,     0.000398_t_real,     0.000187_t_real,     0.000062_t_real &
       &,     0.000001_t_real,    -0.000018_t_real,    -0.000013_t_real &
       &,     0.000001_t_real,     0.000015_t_real,     0.000023_t_real &
       &,     0.000027_t_real,     0.000025_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 77) /&
       &    -77.000000_t_real,   -76.920625_t_real,   -76.329439_t_real &
       &,   -74.722051_t_real,   -71.834855_t_real,   -67.702942_t_real &
       &,   -62.496834_t_real,   -56.469084_t_real,   -49.956246_t_real &
       &,   -43.288825_t_real,   -36.787053_t_real,   -30.698444_t_real &
       &,   -25.091845_t_real,   -20.060575_t_real,   -15.795394_t_real &
       &,   -12.413468_t_real,    -9.776366_t_real,    -7.704583_t_real &
       &,    -6.059280_t_real,    -4.748776_t_real,    -3.718288_t_real &
       &,    -2.922015_t_real,    -2.316332_t_real,    -1.861182_t_real &
       &,    -1.520760_t_real,    -1.264738_t_real,    -1.069133_t_real &
       &,    -0.915788_t_real,    -0.791299_t_real,    -0.686093_t_real &
       &,    -0.593750_t_real,    -0.510380_t_real,    -0.434002_t_real &
       &,    -0.363930_t_real,    -0.300216_t_real,    -0.243213_t_real &
       &,    -0.193257_t_real,    -0.150482_t_real,    -0.114748_t_real &
       &,    -0.085645_t_real,    -0.062544_t_real,    -0.044675_t_real &
       &,    -0.031206_t_real,    -0.021312_t_real,    -0.014228_t_real &
       &,    -0.009285_t_real,    -0.005921_t_real,    -0.003689_t_real &
       &,    -0.002246_t_real,    -0.001335_t_real/
  Data bscoeffrel(1:50, 77) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000017_t_real,    -0.000122_t_real,    -0.000404_t_real &
       &,    -0.000453_t_real,    -0.000091_t_real,    -0.000029_t_real &
       &,    -0.001183_t_real,    -0.001831_t_real,    -0.001054_t_real &
       &,     0.000142_t_real,    -0.001738_t_real,    -0.010554_t_real &
       &,    -0.024236_t_real,    -0.038712_t_real,    -0.051362_t_real &
       &,    -0.059784_t_real,    -0.061939_t_real,    -0.057572_t_real &
       &,    -0.048614_t_real,    -0.037786_t_real,    -0.027187_t_real &
       &,    -0.017978_t_real,    -0.010632_t_real,    -0.005220_t_real &
       &,    -0.001581_t_real,     0.000580_t_real,     0.001625_t_real &
       &,     0.001917_t_real,     0.001774_t_real,     0.001433_t_real &
       &,     0.001048_t_real,     0.000699_t_real,     0.000421_t_real &
       &,     0.000220_t_real,     0.000087_t_real,     0.000008_t_real &
       &,    -0.000030_t_real,    -0.000042_t_real,    -0.000040_t_real &
       &,    -0.000031_t_real,    -0.000021_t_real,    -0.000012_t_real &
       &,    -0.000006_t_real,    -0.000001_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 78) /&
       &    -78.000000_t_real,   -77.919018_t_real,   -77.314919_t_real &
       &,   -75.673938_t_real,   -72.732559_t_real,   -68.528506_t_real &
       &,   -63.235301_t_real,   -57.110269_t_real,   -50.495359_t_real &
       &,   -43.726560_t_real,   -37.130429_t_real,   -30.950227_t_real &
       &,   -25.260106_t_real,   -20.164605_t_real,   -15.870180_t_real &
       &,   -12.466796_t_real,    -9.793831_t_real,    -7.674516_t_real &
       &,    -5.978123_t_real,    -4.625802_t_real,    -3.571445_t_real &
       &,    -2.769157_t_real,    -2.169555_t_real,    -1.726094_t_real &
       &,    -1.398908_t_real,    -1.155884_t_real,    -0.972266_t_real &
       &,    -0.829587_t_real,    -0.714487_t_real,    -0.617677_t_real &
       &,    -0.533069_t_real,    -0.457033_t_real,    -0.387714_t_real &
       &,    -0.324433_t_real,    -0.267163_t_real,    -0.216134_t_real &
       &,    -0.171561_t_real,    -0.133493_t_real,    -0.101752_t_real &
       &,    -0.075936_t_real,    -0.055465_t_real,    -0.039642_t_real &
       &,    -0.027720_t_real,    -0.018961_t_real,    -0.012686_t_real &
       &,    -0.008301_t_real,    -0.005311_t_real,    -0.003323_t_real &
       &,    -0.002032_t_real,    -0.001215_t_real/
  Data bscoeffrel(1:50, 78) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000005_t_real,    -0.000004_t_real,     0.000001_t_real &
       &,    -0.000017_t_real,    -0.000055_t_real,    -0.000140_t_real &
       &,    -0.000190_t_real,    -0.000054_t_real,    -0.000027_t_real &
       &,    -0.000563_t_real,    -0.000728_t_real,    -0.000319_t_real &
       &,    -0.000182_t_real,    -0.001694_t_real,    -0.004995_t_real &
       &,    -0.008713_t_real,    -0.012799_t_real,    -0.018134_t_real &
       &,    -0.025233_t_real,    -0.033657_t_real,    -0.042078_t_real &
       &,    -0.048914_t_real,    -0.052978_t_real,    -0.053756_t_real &
       &,    -0.051356_t_real,    -0.046355_t_real,    -0.039614_t_real &
       &,    -0.032090_t_real,    -0.024660_t_real,    -0.017988_t_real &
       &,    -0.012464_t_real,    -0.008209_t_real,    -0.005142_t_real &
       &,    -0.003068_t_real,    -0.001747_t_real,    -0.000955_t_real &
       &,    -0.000505_t_real,    -0.000261_t_real,    -0.000133_t_real &
       &,    -0.000066_t_real,    -0.000031_t_real,    -0.000012_t_real &
       &,    -0.000002_t_real,     0.000003_t_real,     0.000005_t_real &
       &,     0.000005_t_real,     0.000004_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 79) /&
       &    -79.000000_t_real,   -78.917410_t_real,   -78.300324_t_real &
       &,   -76.625685_t_real,   -73.630358_t_real,   -69.354797_t_real &
       &,   -63.975603_t_real,   -57.755142_t_real,   -51.040669_t_real &
       &,   -44.173791_t_real,   -37.487569_t_real,   -31.220724_t_real &
       &,   -25.453905_t_real,   -20.303661_t_real,   -15.988929_t_real &
       &,   -12.569795_t_real,    -9.868370_t_real,    -7.712023_t_real &
       &,    -5.976554_t_real,    -4.593664_t_real,    -3.521882_t_real &
       &,    -2.713562_t_real,    -2.115369_t_real,    -1.676989_t_real &
       &,    -1.355890_t_real,    -1.118474_t_real,    -0.939379_t_real &
       &,    -0.800087_t_real,    -0.687481_t_real,    -0.592617_t_real &
       &,    -0.509730_t_real,    -0.435419_t_real,    -0.367951_t_real &
       &,    -0.306674_t_real,    -0.251523_t_real,    -0.202649_t_real &
       &,    -0.160174_t_real,    -0.124068_t_real,    -0.094097_t_real &
       &,    -0.069832_t_real,    -0.050687_t_real,    -0.035972_t_real &
       &,    -0.024956_t_real,    -0.016924_t_real,    -0.011217_t_real &
       &,    -0.007267_t_real,    -0.004601_t_real,    -0.002846_t_real &
       &,    -0.001721_t_real,    -0.001016_t_real/
  Data bscoeffrel(1:50, 79) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000002_t_real &
       &,    -0.000005_t_real,    -0.000004_t_real,     0.000000_t_real &
       &,    -0.000011_t_real,    -0.000006_t_real,     0.000015_t_real &
       &,    -0.000026_t_real,    -0.000022_t_real,    -0.000003_t_real &
       &,    -0.000097_t_real,    -0.000037_t_real,     0.000038_t_real &
       &,    -0.000304_t_real,    -0.000882_t_real,    -0.000493_t_real &
       &,     0.000742_t_real,     0.001190_t_real,    -0.000763_t_real &
       &,    -0.005996_t_real,    -0.014169_t_real,    -0.023755_t_real &
       &,    -0.032764_t_real,    -0.039543_t_real,    -0.043158_t_real &
       &,    -0.043403_t_real,    -0.040660_t_real,    -0.035710_t_real &
       &,    -0.029520_t_real,    -0.023030_t_real,    -0.016988_t_real &
       &,    -0.011861_t_real,    -0.007844_t_real,    -0.004920_t_real &
       &,    -0.002942_t_real,    -0.001708_t_real,    -0.001001_t_real &
       &,    -0.000632_t_real,    -0.000453_t_real,    -0.000366_t_real &
       &,    -0.000311_t_real,    -0.000264_t_real,    -0.000216_t_real &
       &,    -0.000168_t_real,    -0.000125_t_real,    -0.000088_t_real &
       &,    -0.000060_t_real,    -0.000039_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 80) /&
       &    -80.000000_t_real,   -79.915804_t_real,   -79.285671_t_real &
       &,   -77.577364_t_real,   -74.528437_t_real,   -70.182198_t_real &
       &,   -64.718427_t_real,   -58.404815_t_real,   -51.593845_t_real &
       &,   -44.632873_t_real,   -37.861617_t_real,   -31.514166_t_real &
       &,   -25.678700_t_real,   -20.484588_t_real,   -16.159417_t_real &
       &,   -12.732028_t_real,   -10.012468_t_real,    -7.831930_t_real &
       &,    -6.071118_t_real,    -4.668903_t_real,    -3.583875_t_real &
       &,    -2.765567_t_real,    -2.159120_t_real,    -1.713920_t_real &
       &,    -1.387417_t_real,    -1.145823_t_real,    -0.963373_t_real &
       &,    -0.821042_t_real,    -0.705290_t_real,    -0.606964_t_real &
       &,    -0.520331_t_real,    -0.442198_t_real,    -0.371107_t_real &
       &,    -0.306659_t_real,    -0.248969_t_real,    -0.198279_t_real &
       &,    -0.154717_t_real,    -0.118179_t_real,    -0.088305_t_real &
       &,    -0.064510_t_real,    -0.046055_t_real,    -0.032120_t_real &
       &,    -0.021878_t_real,    -0.014550_t_real,    -0.009446_t_real &
       &,    -0.005986_t_real,    -0.003701_t_real,    -0.002233_t_real &
       &,    -0.001314_t_real,    -0.000754_t_real/
  Data bscoeffrel(1:50, 80) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 81) /&
       &    -81.000000_t_real,   -80.914195_t_real,   -80.270930_t_real &
       &,   -78.528869_t_real,   -75.426524_t_real,   -71.010129_t_real &
       &,   -65.462691_t_real,   -59.057449_t_real,   -52.152107_t_real &
       &,   -45.099952_t_real,   -38.247389_t_real,   -31.823777_t_real &
       &,   -25.925570_t_real,   -20.696007_t_real,   -16.367221_t_real &
       &,   -12.935775_t_real,   -10.203446_t_real,    -8.005782_t_real &
       &,    -6.229644_t_real,    -4.819976_t_real,    -3.732601_t_real &
       &,    -2.911854_t_real,    -2.299921_t_real,    -1.845670_t_real &
       &,    -1.507526_t_real,    -1.253440_t_real,    -1.059585_t_real &
       &,    -0.908640_t_real,    -0.788194_t_real,    -0.689476_t_real &
       &,    -0.606350_t_real,    -0.534545_t_real,    -0.471088_t_real &
       &,    -0.413930_t_real,    -0.361712_t_real,    -0.313615_t_real &
       &,    -0.269232_t_real,    -0.228448_t_real,    -0.191321_t_real &
       &,    -0.157967_t_real,    -0.128480_t_real,    -0.102871_t_real &
       &,    -0.081049_t_real,    -0.062814_t_real,    -0.047874_t_real &
       &,    -0.035877_t_real,    -0.026432_t_real,    -0.019142_t_real &
       &,    -0.013625_t_real,    -0.009530_t_real/
  Data bscoeffrel(1:50, 81) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000001_t_real,    -0.000004_t_real &
       &,    -0.000004_t_real,     0.000001_t_real,    -0.000001_t_real &
       &,    -0.000010_t_real,    -0.000002_t_real,    -0.000006_t_real &
       &,    -0.000032_t_real,    -0.000011_t_real,     0.000007_t_real &
       &,    -0.000090_t_real,    -0.000260_t_real,    -0.000197_t_real &
       &,     0.000103_t_real,     0.000298_t_real,    -0.000073_t_real &
       &,    -0.001452_t_real,    -0.004030_t_real,    -0.007599_t_real &
       &,    -0.011657_t_real,    -0.015635_t_real,    -0.019037_t_real &
       &,    -0.021497_t_real,    -0.022787_t_real,    -0.022825_t_real &
       &,    -0.021686_t_real,    -0.019588_t_real,    -0.016851_t_real &
       &,    -0.013835_t_real,    -0.010863_t_real,    -0.008173_t_real &
       &,    -0.005904_t_real,    -0.004098_t_real,    -0.002732_t_real &
       &,    -0.001746_t_real,    -0.001063_t_real,    -0.000611_t_real &
       &,    -0.000324_t_real,    -0.000150_t_real,    -0.000053_t_real &
       &,    -0.000002_t_real,     0.000021_t_real,     0.000028_t_real &
       &,     0.000027_t_real,     0.000023_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 82) /&
       &    -82.000000_t_real,   -81.912571_t_real,   -81.255994_t_real &
       &,   -79.479853_t_real,   -76.323824_t_real,   -71.837072_t_real &
       &,   -66.205810_t_real,   -59.708967_t_real,   -52.709367_t_real &
       &,   -45.566311_t_real,   -38.632797_t_real,   -32.133491_t_real &
       &,   -26.173656_t_real,   -20.911206_t_real,   -16.578276_t_real &
       &,   -13.139351_t_real,   -10.391581_t_real,    -8.174165_t_real &
       &,    -6.380442_t_real,    -4.959357_t_real,    -3.862653_t_real &
       &,    -3.030876_t_real,    -2.405710_t_real,    -1.937181_t_real &
       &,    -1.585090_t_real,    -1.318500_t_real,    -1.114197_t_real &
       &,    -0.954850_t_real,    -0.827529_t_real,    -0.722673_t_real &
       &,    -0.633390_t_real,    -0.554914_t_real,    -0.484150_t_real &
       &,    -0.419283_t_real,    -0.359426_t_real,    -0.304312_t_real &
       &,    -0.254023_t_real,    -0.208778_t_real,    -0.168775_t_real &
       &,    -0.134093_t_real,    -0.104646_t_real,    -0.080179_t_real &
       &,    -0.060295_t_real,    -0.044490_t_real,    -0.032204_t_real &
       &,    -0.022865_t_real,    -0.015920_t_real,    -0.010870_t_real &
       &,    -0.007276_t_real,    -0.004774_t_real/
  Data bscoeffrel(1:50, 82) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 83) /&
       &    -83.000000_t_real,   -82.910937_t_real,   -82.240901_t_real &
       &,   -80.430455_t_real,   -77.220671_t_real,   -72.663672_t_real &
       &,   -66.948879_t_real,   -60.361084_t_real,   -53.268184_t_real &
       &,   -46.035600_t_real,   -39.022806_t_real,   -32.449973_t_real &
       &,   -26.431582_t_real,   -21.140978_t_real,   -16.805696_t_real &
       &,   -13.359063_t_real,   -10.596645_t_real,    -8.360952_t_real &
       &,    -6.552328_t_real,    -5.121531_t_real,    -4.014936_t_real &
       &,    -3.169926_t_real,    -2.528437_t_real,    -2.041664_t_real &
       &,    -1.670761_t_real,    -1.386341_t_real,    -1.166476_t_real &
       &,    -0.994445_t_real,    -0.857225_t_real,    -0.744716_t_real &
       &,    -0.649336_t_real,    -0.565724_t_real,    -0.490422_t_real &
       &,    -0.421495_t_real,    -0.358107_t_real,    -0.300107_t_real &
       &,    -0.247669_t_real,    -0.201034_t_real,    -0.160350_t_real &
       &,    -0.125589_t_real,    -0.096536_t_real,    -0.072795_t_real &
       &,    -0.053838_t_real,    -0.039048_t_real,    -0.027774_t_real &
       &,    -0.019376_t_real,    -0.013259_t_real,    -0.008903_t_real &
       &,    -0.005865_t_real,    -0.003792_t_real/
  Data bscoeffrel(1:50, 83) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000002_t_real,    -0.000015_t_real &
       &,    -0.000021_t_real,     0.000000_t_real,    -0.000005_t_real &
       &,    -0.000053_t_real,    -0.000019_t_real,    -0.000020_t_real &
       &,    -0.000167_t_real,    -0.000111_t_real,     0.000015_t_real &
       &,    -0.000381_t_real,    -0.001234_t_real,    -0.001172_t_real &
       &,    -0.000088_t_real,     0.000597_t_real,    -0.001312_t_real &
       &,    -0.007773_t_real,    -0.018842_t_real,    -0.032261_t_real &
       &,    -0.045050_t_real,    -0.055005_t_real,    -0.060998_t_real &
       &,    -0.062749_t_real,    -0.060593_t_real,    -0.055297_t_real &
       &,    -0.047884_t_real,    -0.039445_t_real,    -0.030960_t_real &
       &,    -0.023175_t_real,    -0.016547_t_real,    -0.011271_t_real &
       &,    -0.007332_t_real,    -0.004583_t_real,    -0.002805_t_real &
       &,    -0.001757_t_real,    -0.001208_t_real,    -0.000959_t_real &
       &,    -0.000861_t_real,    -0.000815_t_real,    -0.000767_t_real &
       &,    -0.000694_t_real,    -0.000599_t_real,    -0.000491_t_real &
       &,    -0.000384_t_real,    -0.000286_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 84) /&
       &    -84.000000_t_real,   -83.909287_t_real,   -83.225605_t_real &
       &,   -81.380528_t_real,   -78.116737_t_real,   -73.489315_t_real &
       &,   -67.690872_t_real,   -61.012179_t_real,   -53.826139_t_real &
       &,   -46.504384_t_real,   -39.412632_t_real,   -32.766893_t_real &
       &,   -26.691163_t_real,   -21.374670_t_real,   -17.035686_t_real &
       &,   -13.578296_t_real,   -10.798815_t_real,    -8.542423_t_real &
       &,    -6.716404_t_real,    -5.271158_t_real,    -4.148175_t_real &
       &,    -3.284172_t_real,    -2.622822_t_real,    -2.116576_t_real &
       &,    -1.727752_t_real,    -1.428113_t_real,    -1.196167_t_real &
       &,    -1.014770_t_real,    -0.870048_t_real,    -0.751101_t_real &
       &,    -0.649863_t_real,    -0.560844_t_real,    -0.480707_t_real &
       &,    -0.407741_t_real,    -0.341319_t_real,    -0.281407_t_real &
       &,    -0.228189_t_real,    -0.181806_t_real,    -0.142226_t_real &
       &,    -0.109192_t_real,    -0.082240_t_real,    -0.060747_t_real &
       &,    -0.043998_t_real,    -0.031239_t_real,    -0.021740_t_real &
       &,    -0.014826_t_real,    -0.009907_t_real,    -0.006485_t_real &
       &,    -0.004157_t_real,    -0.002610_t_real/
  Data bscoeffrel(1:50, 84) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000002_t_real,    -0.000016_t_real &
       &,    -0.000023_t_real,    -0.000002_t_real,    -0.000008_t_real &
       &,    -0.000059_t_real,    -0.000021_t_real,    -0.000025_t_real &
       &,    -0.000185_t_real,    -0.000125_t_real,     0.000010_t_real &
       &,    -0.000439_t_real,    -0.001340_t_real,    -0.001237_t_real &
       &,    -0.000136_t_real,     0.000384_t_real,    -0.002074_t_real &
       &,    -0.009294_t_real,    -0.020459_t_real,    -0.032517_t_real &
       &,    -0.042589_t_real,    -0.049163_t_real,    -0.051855_t_real &
       &,    -0.050950_t_real,    -0.047120_t_real,    -0.041245_t_real &
       &,    -0.034273_t_real,    -0.027084_t_real,    -0.020383_t_real &
       &,    -0.014629_t_real,    -0.010028_t_real,    -0.006575_t_real &
       &,    -0.004123_t_real,    -0.002466_t_real,    -0.001396_t_real &
       &,    -0.000737_t_real,    -0.000350_t_real,    -0.000135_t_real &
       &,    -0.000026_t_real,     0.000023_t_real,     0.000039_t_real &
       &,     0.000040_t_real,     0.000033_t_real,     0.000026_t_real &
       &,     0.000018_t_real,     0.000012_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 85) /&
       &    -85.000000_t_real,   -84.907621_t_real,   -84.210104_t_real &
       &,   -82.330073_t_real,   -79.012035_t_real,   -74.314035_t_real &
       &,   -68.431852_t_real,   -61.662348_t_real,   -54.383376_t_real &
       &,   -46.972878_t_real,   -39.802526_t_real,   -33.084622_t_real &
       &,   -26.952910_t_real,   -21.612671_t_real,   -17.268424_t_real &
       &,   -13.797609_t_real,   -10.998833_t_real,    -8.719642_t_real &
       &,    -6.873870_t_real,    -5.409821_t_real,    -4.265427_t_real &
       &,    -3.378794_t_real,    -2.695360_t_real,    -2.168346_t_real &
       &,    -1.761447_t_real,    -1.447600_t_real,    -1.205263_t_real &
       &,    -1.016312_t_real,    -0.865703_t_real,    -0.741696_t_real &
       &,    -0.635863_t_real,    -0.542738_t_real,    -0.459202_t_real &
       &,    -0.383785_t_real,    -0.316014_t_real,    -0.255880_t_real &
       &,    -0.203468_t_real,    -0.158733_t_real,    -0.121407_t_real &
       &,    -0.090990_t_real,    -0.066792_t_real,    -0.048006_t_real &
       &,    -0.033774_t_real,    -0.023252_t_real,    -0.015663_t_real &
       &,    -0.010320_t_real,    -0.006651_t_real,    -0.004191_t_real &
       &,    -0.002582_t_real,    -0.001554_t_real/
  Data bscoeffrel(1:50, 85) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000002_t_real,    -0.000011_t_real &
       &,    -0.000017_t_real,    -0.000002_t_real,    -0.000008_t_real &
       &,    -0.000045_t_real,    -0.000014_t_real,    -0.000023_t_real &
       &,    -0.000143_t_real,    -0.000091_t_real,     0.000003_t_real &
       &,    -0.000372_t_real,    -0.001021_t_real,    -0.000872_t_real &
       &,    -0.000065_t_real,     0.000113_t_real,    -0.002161_t_real &
       &,    -0.007811_t_real,    -0.015470_t_real,    -0.022685_t_real &
       &,    -0.027848_t_real,    -0.030462_t_real,    -0.030654_t_real &
       &,    -0.028844_t_real,    -0.025587_t_real,    -0.021486_t_real &
       &,    -0.017110_t_real,    -0.012936_t_real,    -0.009294_t_real &
       &,    -0.006354_t_real,    -0.004141_t_real,    -0.002575_t_real &
       &,    -0.001524_t_real,    -0.000851_t_real,    -0.000441_t_real &
       &,    -0.000202_t_real,    -0.000073_t_real,    -0.000009_t_real &
       &,     0.000018_t_real,     0.000025_t_real,     0.000024_t_real &
       &,     0.000019_t_real,     0.000013_t_real,     0.000009_t_real &
       &,     0.000006_t_real,     0.000003_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 86) /&
       &    -86.000000_t_real,   -85.905940_t_real,   -85.194387_t_real &
       &,   -83.279069_t_real,   -79.906532_t_real,   -75.137780_t_real &
       &,   -69.171743_t_real,   -62.311465_t_real,   -54.939704_t_real &
       &,   -47.440825_t_real,   -40.192091_t_real,   -33.402662_t_real &
       &,   -27.216220_t_real,   -21.853917_t_real,   -17.502346_t_real &
       &,   -14.015440_t_real,   -11.194865_t_real,    -8.890570_t_real &
       &,    -7.022124_t_real,    -5.534693_t_real,    -4.364720_t_real &
       &,    -3.452886_t_real,    -2.745472_t_real,    -2.196602_t_real &
       &,    -1.772104_t_real,    -1.445902_t_real,    -1.195632_t_real &
       &,    -1.001537_t_real,    -0.847136_t_real,    -0.719865_t_real &
       &,    -0.611071_t_real,    -0.515433_t_real,    -0.430108_t_real &
       &,    -0.353859_t_real,    -0.286314_t_real,    -0.227424_t_real &
       &,    -0.177113_t_real,    -0.135107_t_real,    -0.100881_t_real &
       &,    -0.073688_t_real,    -0.052632_t_real,    -0.036746_t_real &
       &,    -0.025070_t_real,    -0.016709_t_real,    -0.010877_t_real &
       &,    -0.006915_t_real,    -0.004292_t_real,    -0.002600_t_real &
       &,    -0.001537_t_real,    -0.000887_t_real/
  Data bscoeffrel(1:50, 86) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 87) /&
       &    -87.000000_t_real,   -86.904267_t_real,   -86.178655_t_real &
       &,   -84.228206_t_real,   -80.801889_t_real,   -75.963816_t_real &
       &,   -69.916189_t_real,   -62.968456_t_real,   -55.508429_t_real &
       &,   -47.927171_t_real,   -40.607242_t_real,   -33.755508_t_real &
       &,   -27.525906_t_real,   -22.154997_t_real,   -17.807910_t_real &
       &,   -14.318751_t_real,   -11.492100_t_real,    -9.180814_t_real &
       &,    -7.309669_t_real,    -5.821254_t_real,    -4.651781_t_real &
       &,    -3.741145_t_real,    -3.032124_t_real,    -2.477359_t_real &
       &,    -2.042068_t_real,    -1.699335_t_real,    -1.427704_t_real &
       &,    -1.211510_t_real,    -1.040629_t_real,    -0.908326_t_real &
       &,    -0.808550_t_real,    -0.733986_t_real,    -0.675614_t_real &
       &,    -0.625338_t_real,    -0.578134_t_real,    -0.531517_t_real &
       &,    -0.484413_t_real,    -0.436545_t_real,    -0.388180_t_real &
       &,    -0.339981_t_real,    -0.292863_t_real,    -0.247845_t_real &
       &,    -0.205905_t_real,    -0.167852_t_real,    -0.134241_t_real &
       &,    -0.105338_t_real,    -0.081122_t_real,    -0.061336_t_real &
       &,    -0.045551_t_real,    -0.033240_t_real/
  Data bscoeffrel(1:50, 87) /&
       &      0.000000_t_real,     0.000000_t_real,    -0.000001_t_real &
       &,    -0.000001_t_real,    -0.000001_t_real,     0.000000_t_real &
       &,    -0.000003_t_real,    -0.000001_t_real,    -0.000002_t_real &
       &,    -0.000007_t_real,     0.000000_t_real,    -0.000014_t_real &
       &,    -0.000021_t_real,     0.000002_t_real,    -0.000036_t_real &
       &,    -0.000130_t_real,    -0.000071_t_real,     0.000036_t_real &
       &,    -0.000135_t_real,    -0.000658_t_real,    -0.001093_t_real &
       &,    -0.000823_t_real,     0.000045_t_real,     0.000649_t_real &
       &,    -0.000105_t_real,    -0.003290_t_real,    -0.009776_t_real &
       &,    -0.019849_t_real,    -0.032685_t_real,    -0.045983_t_real &
       &,    -0.056284_t_real,    -0.061236_t_real,    -0.061468_t_real &
       &,    -0.058618_t_real,    -0.053602_t_real,    -0.046921_t_real &
       &,    -0.039180_t_real,    -0.031132_t_real,    -0.023528_t_real &
       &,    -0.016953_t_real,    -0.011746_t_real,    -0.007976_t_real &
       &,    -0.005499_t_real,    -0.004033_t_real,    -0.003253_t_real &
       &,    -0.002863_t_real,    -0.002638_t_real,    -0.002441_t_real &
       &,    -0.002209_t_real,    -0.001931_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 88) /&
       &    -88.000000_t_real,   -87.902578_t_real,   -87.162700_t_real &
       &,   -85.176794_t_real,   -81.696480_t_real,   -76.788974_t_real &
       &,   -70.659732_t_real,   -63.624660_t_real,   -56.076627_t_real &
       &,   -48.413522_t_real,   -41.022720_t_real,   -34.109548_t_real &
       &,   -27.838374_t_real,   -22.460153_t_real,   -18.115428_t_real &
       &,   -14.621997_t_real,   -11.786761_t_real,    -9.466209_t_real &
       &,    -7.589335_t_real,    -6.096526_t_real,    -4.923681_t_real &
       &,    -4.007331_t_real,    -3.286469_t_real,    -2.713419_t_real &
       &,    -2.254430_t_real,    -1.885697_t_real,    -1.591873_t_real &
       &,    -1.363128_t_real,    -1.189386_t_real,    -1.057292_t_real &
       &,    -0.952899_t_real,    -0.865194_t_real,    -0.786863_t_real &
       &,    -0.713434_t_real,    -0.642377_t_real,    -0.572539_t_real &
       &,    -0.503795_t_real,    -0.436756_t_real,    -0.372470_t_real &
       &,    -0.312131_t_real,    -0.256838_t_real,    -0.207424_t_real &
       &,    -0.164367_t_real,    -0.127777_t_real,    -0.097441_t_real &
       &,    -0.072890_t_real,    -0.053483_t_real,    -0.038494_t_real &
       &,    -0.027176_t_real,    -0.018820_t_real/
  Data bscoeffrel(1:50, 88) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 89) /&
       &    -89.000000_t_real,   -88.900865_t_real,   -88.146460_t_real &
       &,   -86.124635_t_real,   -82.589841_t_real,   -77.612340_t_real &
       &,   -71.400764_t_real,   -64.277484_t_real,   -56.640443_t_real &
       &,   -48.894454_t_real,   -41.431099_t_real,   -34.454903_t_real &
       &,   -28.140870_t_real,   -22.752920_t_real,   -18.404332_t_real &
       &,   -14.899804_t_real,   -12.048212_t_real,    -9.710704_t_real &
       &,    -7.818839_t_real,    -6.309869_t_real,    -5.118691_t_real &
       &,    -4.179101_t_real,    -3.429856_t_real,    -2.826759_t_real &
       &,    -2.340193_t_real,    -1.950181_t_real,    -1.642947_t_real &
       &,    -1.405784_t_real,    -1.223530_t_real,    -1.080368_t_real &
       &,    -0.963223_t_real,    -0.862802_t_real,    -0.772890_t_real &
       &,    -0.689494_t_real,    -0.610294_t_real,    -0.534293_t_real &
       &,    -0.461494_t_real,    -0.392545_t_real,    -0.328388_t_real &
       &,    -0.269963_t_real,    -0.217994_t_real,    -0.172875_t_real &
       &,    -0.134642_t_real,    -0.103006_t_real,    -0.077431_t_real &
       &,    -0.057215_t_real,    -0.041579_t_real,    -0.029733_t_real &
       &,    -0.020934_t_real,    -0.014520_t_real/
  Data bscoeffrel(1:50, 89) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,    -0.000002_t_real,    -0.000013_t_real,    -0.000024_t_real &
       &,    -0.000009_t_real,    -0.000001_t_real,    -0.000048_t_real &
       &,    -0.000072_t_real,    -0.000027_t_real,    -0.000006_t_real &
       &,    -0.000219_t_real,    -0.000539_t_real,    -0.000583_t_real &
       &,    -0.000242_t_real,     0.000148_t_real,    -0.000342_t_real &
       &,    -0.002491_t_real,    -0.006308_t_real,    -0.011454_t_real &
       &,    -0.017386_t_real,    -0.023110_t_real,    -0.027192_t_real &
       &,    -0.028517_t_real,    -0.027142_t_real,    -0.024032_t_real &
       &,    -0.020195_t_real,    -0.016297_t_real,    -0.012697_t_real &
       &,    -0.009572_t_real,    -0.006991_t_real,    -0.004955_t_real &
       &,    -0.003418_t_real,    -0.002302_t_real,    -0.001520_t_real &
       &,    -0.000985_t_real,    -0.000625_t_real,    -0.000385_t_real &
       &,    -0.000224_t_real,    -0.000117_t_real,    -0.000045_t_real &
       &,     0.000001_t_real,     0.000029_t_real,     0.000043_t_real &
       &,     0.000048_t_real,     0.000045_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 90) /&
       &    -90.000000_t_real,   -89.899131_t_real,   -89.129957_t_real &
       &,   -87.071819_t_real,   -83.482211_t_real,   -78.434402_t_real &
       &,   -72.140165_t_real,   -64.928349_t_real,   -57.201995_t_real &
       &,   -49.372977_t_real,   -41.836479_t_real,   -34.797032_t_real &
       &,   -28.440537_t_real,   -23.042014_t_real,   -18.685569_t_real &
       &,   -15.166000_t_real,   -12.293570_t_real,    -9.934796_t_real &
       &,    -8.022230_t_real,    -6.490294_t_real,    -5.273070_t_real &
       &,    -4.302310_t_real,    -3.518944_t_real,    -2.883846_t_real &
       &,    -2.371596_t_real,    -1.964171_t_real,    -1.646362_t_real &
       &,    -1.401639_t_real,    -1.212043_t_real,    -1.061367_t_real &
       &,    -0.937135_t_real,    -0.830437_t_real,    -0.735146_t_real &
       &,    -0.647319_t_real,    -0.564777_t_real,    -0.486720_t_real &
       &,    -0.413300_t_real,    -0.345196_t_real,    -0.283235_t_real &
       &,    -0.228117_t_real,    -0.180250_t_real,    -0.139690_t_real &
       &,    -0.106158_t_real,    -0.079103_t_real,    -0.057794_t_real &
       &,    -0.041403_t_real,    -0.029085_t_real,    -0.020036_t_real &
       &,    -0.013536_t_real,    -0.008970_t_real/
  Data bscoeffrel(1:50, 90) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000006_t_real,    -0.000034_t_real,    -0.000062_t_real &
       &,    -0.000023_t_real,    -0.000004_t_real,    -0.000132_t_real &
       &,    -0.000186_t_real,    -0.000058_t_real,    -0.000036_t_real &
       &,    -0.000663_t_real,    -0.001422_t_real,    -0.001352_t_real &
       &,    -0.000370_t_real,     0.000260_t_real,    -0.001987_t_real &
       &,    -0.008354_t_real,    -0.018059_t_real,    -0.029674_t_real &
       &,    -0.041266_t_real,    -0.050167_t_real,    -0.053912_t_real &
       &,    -0.051968_t_real,    -0.045943_t_real,    -0.038030_t_real &
       &,    -0.029858_t_real,    -0.022348_t_real,    -0.015950_t_real &
       &,    -0.010826_t_real,    -0.006959_t_real,    -0.004214_t_real &
       &,    -0.002387_t_real,    -0.001251_t_real,    -0.000593_t_real &
       &,    -0.000244_t_real,    -0.000077_t_real,    -0.000010_t_real &
       &,     0.000009_t_real,     0.000008_t_real,     0.000001_t_real &
       &,    -0.000004_t_real,    -0.000007_t_real,    -0.000007_t_real &
       &,    -0.000006_t_real,    -0.000004_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 91) /&
       &    -91.000000_t_real,   -90.897324_t_real,   -90.112771_t_real &
       &,   -88.016938_t_real,   -84.370245_t_real,   -79.248547_t_real &
       &,   -72.866261_t_real,   -65.558095_t_real,   -57.731410_t_real &
       &,   -49.804666_t_real,   -42.176725_t_real,   -35.053929_t_real &
       &,   -28.633126_t_real,   -23.197272_t_real,   -18.798251_t_real &
       &,   -15.220973_t_real,   -12.279103_t_real,    -9.852907_t_real &
       &,    -7.887377_t_real,    -6.321691_t_real,    -5.088003_t_real &
       &,    -4.115469_t_real,    -3.343996_t_real,    -2.730363_t_real &
       &,    -2.243183_t_real,    -1.859887_t_real,    -1.563475_t_real &
       &,    -1.337467_t_real,    -1.164137_t_real,    -1.027207_t_real &
       &,    -0.914225_t_real,    -0.816583_t_real,    -0.728577_t_real &
       &,    -0.646628_t_real,    -0.568788_t_real,    -0.494373_t_real &
       &,    -0.423596_t_real,    -0.357189_t_real,    -0.296063_t_real &
       &,    -0.241037_t_real,    -0.192667_t_real,    -0.151170_t_real &
       &,    -0.116422_t_real,    -0.088015_t_real,    -0.065328_t_real &
       &,    -0.047619_t_real,    -0.034099_t_real,    -0.023996_t_real &
       &,    -0.016602_t_real,    -0.011297_t_real/
  Data bscoeffrel(1:50, 91) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000002_t_real,    -0.000016_t_real,    -0.000059_t_real &
       &,    -0.000188_t_real,    -0.000612_t_real,    -0.001125_t_real &
       &,    -0.000906_t_real,    -0.000313_t_real,    -0.000024_t_real &
       &,    -0.001954_t_real,    -0.006527_t_real,    -0.012771_t_real &
       &,    -0.020283_t_real,    -0.027438_t_real,    -0.032035_t_real &
       &,    -0.034394_t_real,    -0.036383_t_real,    -0.038978_t_real &
       &,    -0.041880_t_real,    -0.043804_t_real,    -0.043227_t_real &
       &,    -0.039634_t_real,    -0.033910_t_real,    -0.027409_t_real &
       &,    -0.021123_t_real,    -0.015573_t_real,    -0.010974_t_real &
       &,    -0.007368_t_real,    -0.004694_t_real,    -0.002826_t_real &
       &,    -0.001601_t_real,    -0.000852_t_real,    -0.000424_t_real &
       &,    -0.000199_t_real,    -0.000090_t_real,    -0.000042_t_real &
       &,    -0.000021_t_real,    -0.000011_t_real,    -0.000003_t_real &
       &,     0.000003_t_real,     0.000010_t_real,     0.000015_t_real &
       &,     0.000018_t_real,     0.000020_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 92) /&
       &    -92.000000_t_real,   -91.895516_t_real,   -91.095477_t_real &
       &,   -88.961959_t_real,   -85.258661_t_real,   -80.064139_t_real &
       &,   -73.595602_t_real,   -66.193823_t_real,   -58.270812_t_real &
       &,   -50.252040_t_real,   -42.539379_t_real,   -35.341424_t_real &
       &,   -28.866401_t_real,   -23.402789_t_real,   -18.970234_t_real &
       &,   -15.347997_t_real,   -12.353288_t_real,    -9.878987_t_real &
       &,    -7.876702_t_real,    -6.285860_t_real,    -5.035982_t_real &
       &,    -4.054133_t_real,    -3.279917_t_real,    -2.668794_t_real &
       &,    -2.187461_t_real,    -1.811789_t_real,    -1.523367_t_real &
       &,    -1.304412_t_real,    -1.136543_t_real,    -1.003564_t_real &
       &,    -0.893389_t_real,    -0.797753_t_real,    -0.711225_t_real &
       &,    -0.630445_t_real,    -0.553645_t_real,    -0.480273_t_real &
       &,    -0.410618_t_real,    -0.345439_t_real,    -0.285630_t_real &
       &,    -0.231969_t_real,    -0.184957_t_real,    -0.144759_t_real &
       &,    -0.111209_t_real,    -0.083867_t_real,    -0.062098_t_real &
       &,    -0.045156_t_real,    -0.032258_t_real,    -0.022648_t_real &
       &,    -0.015634_t_real,    -0.010615_t_real/
  Data bscoeffrel(1:50, 92) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000002_t_real,    -0.000017_t_real,    -0.000088_t_real &
       &,    -0.000328_t_real,    -0.001074_t_real,    -0.001840_t_real &
       &,    -0.001393_t_real,    -0.000408_t_real,    -0.000124_t_real &
       &,    -0.003741_t_real,    -0.011477_t_real,    -0.021748_t_real &
       &,    -0.033496_t_real,    -0.043301_t_real,    -0.047823_t_real &
       &,    -0.048388_t_real,    -0.048079_t_real,    -0.048356_t_real &
       &,    -0.048985_t_real,    -0.048654_t_real,    -0.045955_t_real &
       &,    -0.040636_t_real,    -0.033726_t_real,    -0.026517_t_real &
       &,    -0.019865_t_real,    -0.014185_t_real,    -0.009614_t_real &
       &,    -0.006141_t_real,    -0.003658_t_real,    -0.002001_t_real &
       &,    -0.000979_t_real,    -0.000404_t_real,    -0.000118_t_real &
       &,     0.000001_t_real,     0.000033_t_real,     0.000029_t_real &
       &,     0.000016_t_real,     0.000005_t_real,     0.000000_t_real &
       &,     0.000001_t_real,     0.000005_t_real,     0.000010_t_real &
       &,     0.000013_t_real,     0.000016_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 93) /&
       &    -93.000000_t_real,   -92.893684_t_real,   -92.077882_t_real &
       &,   -89.906243_t_real,   -86.145957_t_real,   -80.878217_t_real &
       &,   -74.322975_t_real,   -66.826993_t_real,   -58.806918_t_real &
       &,   -50.695392_t_real,   -42.896888_t_real,   -35.623078_t_real &
       &,   -29.093896_t_real,   -23.600261_t_real,   -19.129530_t_real &
       &,   -15.457879_t_real,   -12.407164_t_real,    -9.884405_t_real &
       &,    -7.847150_t_real,    -6.234227_t_real,    -4.971939_t_real &
       &,    -3.985136_t_real,    -3.212271_t_real,    -2.606752_t_real &
       &,    -2.133257_t_real,    -1.766281_t_real,    -1.486241_t_real &
       &,    -1.274335_t_real,    -1.111782_t_real,    -0.982593_t_real &
       &,    -0.875084_t_real,    -0.781343_t_real,    -0.696212_t_real &
       &,    -0.616542_t_real,    -0.540732_t_real,    -0.468345_t_real &
       &,    -0.399736_t_real,    -0.335681_t_real,    -0.277056_t_real &
       &,    -0.224601_t_real,    -0.178773_t_real,    -0.139691_t_real &
       &,    -0.107154_t_real,    -0.080701_t_real,    -0.059686_t_real &
       &,    -0.043363_t_real,    -0.030958_t_real,    -0.021729_t_real &
       &,    -0.015000_t_real,    -0.010189_t_real/
  Data bscoeffrel(1:50, 93) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000001_t_real,    -0.000020_t_real,    -0.000125_t_real &
       &,    -0.000503_t_real,    -0.001636_t_real,    -0.002636_t_real &
       &,    -0.001886_t_real,    -0.000450_t_real,    -0.000367_t_real &
       &,    -0.006283_t_real,    -0.017703_t_real,    -0.032264_t_real &
       &,    -0.047880_t_real,    -0.059185_t_real,    -0.062466_t_real &
       &,    -0.060572_t_real,    -0.057663_t_real,    -0.055520_t_real &
       &,    -0.053924_t_real,    -0.051550_t_real,    -0.047111_t_real &
       &,    -0.040537_t_real,    -0.032888_t_real,    -0.025327_t_real &
       &,    -0.018572_t_real,    -0.012937_t_real,    -0.008501_t_real &
       &,    -0.005209_t_real,    -0.002923_t_real,    -0.001453_t_real &
       &,    -0.000592_t_real,    -0.000146_t_real,     0.000044_t_real &
       &,     0.000096_t_real,     0.000085_t_real,     0.000055_t_real &
       &,     0.000027_t_real,     0.000008_t_real,     0.000001_t_real &
       &,     0.000001_t_real,     0.000005_t_real,     0.000010_t_real &
       &,     0.000015_t_real,     0.000017_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 94) /&
       &    -94.000000_t_real,   -93.891803_t_real,   -93.059783_t_real &
       &,   -90.849124_t_real,   -87.030559_t_real,   -81.687678_t_real &
       &,   -75.042920_t_real,   -67.448681_t_real,   -59.325917_t_real &
       &,   -51.114371_t_real,   -43.220987_t_real,   -35.861504_t_real &
       &,   -29.267772_t_real,   -23.729449_t_real,   -19.201247_t_real &
       &,   -15.457674_t_real,   -12.327920_t_real,    -9.737496_t_real &
       &,    -7.653431_t_real,    -6.015516_t_real,    -4.747368_t_real &
       &,    -3.771001_t_real,    -3.020606_t_real,    -2.443469_t_real &
       &,    -1.998401_t_real,    -1.656157_t_real,    -1.396459_t_real &
       &,    -1.201887_t_real,    -1.054865_t_real,    -0.939561_t_real &
       &,    -0.844067_t_real,    -0.760429_t_real,    -0.683643_t_real &
       &,    -0.610766_t_real,    -0.540351_t_real,    -0.472053_t_real &
       &,    -0.406287_t_real,    -0.343887_t_real,    -0.285801_t_real &
       &,    -0.232821_t_real,    -0.185398_t_real,    -0.143514_t_real &
       &,    -0.106669_t_real,    -0.074080_t_real,    -0.045365_t_real &
       &,    -0.021788_t_real,    -0.006548_t_real,    -0.000811_t_real &
       &,    -0.000020_t_real,     0.000000_t_real/
  Data bscoeffrel(1:50, 94) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000004_t_real,    -0.000003_t_real,    -0.000155_t_real &
       &,    -0.000792_t_real,    -0.002566_t_real,    -0.003841_t_real &
       &,    -0.002590_t_real,    -0.000503_t_real,    -0.000790_t_real &
       &,    -0.010193_t_real,    -0.027397_t_real,    -0.049060_t_real &
       &,    -0.071241_t_real,    -0.085287_t_real,    -0.086344_t_real &
       &,    -0.078866_t_real,    -0.068674_t_real,    -0.058575_t_real &
       &,    -0.049226_t_real,    -0.040352_t_real,    -0.031624_t_real &
       &,    -0.023245_t_real,    -0.015783_t_real,    -0.009640_t_real &
       &,    -0.004895_t_real,    -0.001449_t_real,     0.000857_t_real &
       &,     0.002209_t_real,     0.002810_t_real,     0.002871_t_real &
       &,     0.002592_t_real,     0.002142_t_real,     0.001643_t_real &
       &,     0.001174_t_real,     0.000776_t_real,     0.000460_t_real &
       &,     0.000227_t_real,     0.000070_t_real,    -0.000016_t_real &
       &,    -0.000038_t_real,    -0.000021_t_real,    -0.000003_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 95) /&
       &    -95.000000_t_real,   -94.889920_t_real,   -94.041553_t_real &
       &,   -91.791887_t_real,   -87.915568_t_real,   -82.498688_t_real &
       &,   -75.766339_t_real,   -68.076705_t_real,   -59.855398_t_real &
       &,   -51.549676_t_real,   -43.568337_t_real,   -36.131646_t_real &
       &,   -29.483778_t_real,   -23.910077_t_real,   -19.334707_t_real &
       &,   -15.533398_t_real,   -12.343057_t_real,    -9.705324_t_real &
       &,    -7.591157_t_real,    -5.938044_t_real,    -4.665522_t_real &
       &,    -3.692333_t_real,    -2.949825_t_real,    -2.382496_t_real &
       &,    -1.947399_t_real,    -1.614550_t_real,    -1.363189_t_real &
       &,    -1.175386_t_real,    -1.033384_t_real,    -0.921605_t_real &
       &,    -0.828555_t_real,    -0.746637_t_real,    -0.671108_t_real &
       &,    -0.599219_t_real,    -0.529662_t_real,    -0.462191_t_real &
       &,    -0.397278_t_real,    -0.335782_t_real,    -0.278645_t_real &
       &,    -0.226642_t_real,    -0.180198_t_real,    -0.139277_t_real &
       &,    -0.103369_t_real,    -0.071692_t_real,    -0.043850_t_real &
       &,    -0.021038_t_real,    -0.006317_t_real,    -0.000782_t_real &
       &,    -0.000019_t_real,     0.000000_t_real/
  Data bscoeffrel(1:50, 95) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000004_t_real,    -0.000007_t_real,    -0.000218_t_real &
       &,    -0.001070_t_real,    -0.003394_t_real,    -0.004821_t_real &
       &,    -0.003085_t_real,    -0.000433_t_real,    -0.001592_t_real &
       &,    -0.014817_t_real,    -0.036806_t_real,    -0.063101_t_real &
       &,    -0.088028_t_real,    -0.101337_t_real,    -0.099401_t_real &
       &,    -0.088630_t_real,    -0.075534_t_real,    -0.062980_t_real &
       &,    -0.051581_t_real,    -0.041055_t_real,    -0.031130_t_real &
       &,    -0.022042_t_real,    -0.014270_t_real,    -0.008064_t_real &
       &,    -0.003390_t_real,    -0.000088_t_real,     0.002035_t_real &
       &,     0.003186_t_real,     0.003588_t_real,     0.003465_t_real &
       &,     0.003027_t_real,     0.002447_t_real,     0.001848_t_real &
       &,     0.001305_t_real,     0.000853_t_real,     0.000501_t_real &
       &,     0.000244_t_real,     0.000073_t_real,    -0.000020_t_real &
       &,    -0.000043_t_real,    -0.000022_t_real,    -0.000004_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 96) /&
       &    -96.000000_t_real,   -95.888036_t_real,   -95.023208_t_real &
       &,   -92.734609_t_real,   -88.801195_t_real,   -83.311682_t_real &
       &,   -76.494015_t_real,   -68.712348_t_real,   -60.397327_t_real &
       &,   -52.004160_t_real,   -43.942884_t_real,   -36.438746_t_real &
       &,   -29.748580_t_real,   -24.150352_t_real,   -19.540645_t_real &
       &,   -15.698584_t_real,   -12.469021_t_real,    -9.806151_t_real &
       &,    -7.679095_t_real,    -6.019673_t_real,    -4.741704_t_real &
       &,    -3.761065_t_real,    -3.008710_t_real,    -2.430399_t_real &
       &,    -1.985824_t_real,    -1.646808_t_real,    -1.391417_t_real &
       &,    -1.198963_t_real,    -1.050457_t_real,    -0.930996_t_real &
       &,    -0.830186_t_real,    -0.741142_t_real,    -0.659462_t_real &
       &,    -0.582571_t_real,    -0.509291_t_real,    -0.439463_t_real &
       &,    -0.373584_t_real,    -0.312453_t_real,    -0.256888_t_real &
       &,    -0.207520_t_real,    -0.164683_t_real,    -0.128386_t_real &
       &,    -0.098344_t_real,    -0.074042_t_real,    -0.054815_t_real &
       &,    -0.039925_t_real,    -0.028626_t_real,    -0.020218_t_real &
       &,    -0.014074_t_real,    -0.009661_t_real/
  Data bscoeffrel(1:50, 96) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,    -0.000001_t_real,    -0.000036_t_real,    -0.000301_t_real &
       &,    -0.001295_t_real,    -0.004006_t_real,    -0.005449_t_real &
       &,    -0.003297_t_real,    -0.000270_t_real,    -0.002803_t_real &
       &,    -0.019505_t_real,    -0.044361_t_real,    -0.072001_t_real &
       &,    -0.095507_t_real,    -0.105054_t_real,    -0.100201_t_real &
       &,    -0.089141_t_real,    -0.078050_t_real,    -0.068979_t_real &
       &,    -0.061573_t_real,    -0.054456_t_real,    -0.046566_t_real &
       &,    -0.037993_t_real,    -0.029534_t_real,    -0.021889_t_real &
       &,    -0.015423_t_real,    -0.010254_t_real,    -0.006352_t_real &
       &,    -0.003595_t_real,    -0.001793_t_real,    -0.000725_t_real &
       &,    -0.000171_t_real,     0.000062_t_real,     0.000118_t_real &
       &,     0.000097_t_real,     0.000053_t_real,     0.000017_t_real &
       &,    -0.000003_t_real,    -0.000007_t_real,     0.000000_t_real &
       &,     0.000012_t_real,     0.000023_t_real,     0.000032_t_real &
       &,     0.000036_t_real,     0.000034_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 97) /&
       &    -97.000000_t_real,   -96.886074_t_real,   -96.004108_t_real &
       &,   -93.675142_t_real,   -89.682327_t_real,   -84.116542_t_real &
       &,   -77.208106_t_real,   -69.326453_t_real,   -60.906615_t_real &
       &,   -52.411521_t_real,   -44.252812_t_real,   -36.661599_t_real &
       &,   -29.907004_t_real,   -24.255059_t_real,   -19.575094_t_real &
       &,   -15.650690_t_real,   -12.340721_t_real,    -9.619361_t_real &
       &,    -7.460199_t_real,    -5.790138_t_real,    -4.517593_t_real &
       &,    -3.555321_t_real,    -2.829681_t_real,    -2.280666_t_real &
       &,    -1.863105_t_real,    -1.546367_t_real,    -1.308992_t_real &
       &,    -1.132125_t_real,    -0.997787_t_real,    -0.891012_t_real &
       &,    -0.801136_t_real,    -0.721225_t_real,    -0.647008_t_real &
       &,    -0.576082_t_real,    -0.507414_t_real,    -0.440961_t_real &
       &,    -0.377332_t_real,    -0.317465_t_real,    -0.262340_t_real &
       &,    -0.212777_t_real,    -0.169306_t_real,    -0.132122_t_real &
       &,    -0.101100_t_real,    -0.075848_t_real,    -0.055786_t_real &
       &,    -0.040225_t_real,    -0.028436_t_real,    -0.019709_t_real &
       &,    -0.013394_t_real,    -0.008927_t_real/
  Data bscoeffrel(1:50, 97) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000002_t_real,    -0.000011_t_real,    -0.000196_t_real &
       &,    -0.000918_t_real,    -0.002787_t_real,    -0.003575_t_real &
       &,    -0.002047_t_real,    -0.000086_t_real,    -0.002357_t_real &
       &,    -0.014058_t_real,    -0.030591_t_real,    -0.048321_t_real &
       &,    -0.062267_t_real,    -0.066635_t_real,    -0.061890_t_real &
       &,    -0.052931_t_real,    -0.043335_t_real,    -0.034509_t_real &
       &,    -0.026735_t_real,    -0.019909_t_real,    -0.013968_t_real &
       &,    -0.008998_t_real,    -0.005067_t_real,    -0.002113_t_real &
       &,    -0.000008_t_real,     0.001380_t_real,     0.002174_t_real &
       &,     0.002495_t_real,     0.002467_t_real,     0.002213_t_real &
       &,     0.001841_t_real,     0.001438_t_real,     0.001059_t_real &
       &,     0.000735_t_real,     0.000478_t_real,     0.000285_t_real &
       &,     0.000149_t_real,     0.000059_t_real,     0.000004_t_real &
       &,    -0.000026_t_real,    -0.000038_t_real,    -0.000040_t_real &
       &,    -0.000036_t_real,    -0.000030_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 98) /&
       &    -98.000000_t_real,   -97.884108_t_real,   -96.984859_t_real &
       &,   -94.615569_t_real,   -90.563977_t_real,   -84.923229_t_real &
       &,   -77.926214_t_real,   -69.947795_t_real,   -61.427784_t_real &
       &,   -52.837222_t_real,   -44.588761_t_real,   -36.919757_t_real &
       &,   -30.111837_t_real,   -24.416273_t_real,   -19.678793_t_real &
       &,   -15.688718_t_real,   -12.318960_t_real,    -9.558912_t_real &
       &,    -7.381096_t_real,    -5.706163_t_real,    -4.437183_t_real &
       &,    -3.483474_t_real,    -2.768356_t_real,    -2.229688_t_real &
       &,    -1.821520_t_real,    -1.513102_t_real,    -1.282728_t_real &
       &,    -1.111223_t_real,    -0.980630_t_real,    -0.876341_t_real &
       &,    -0.788093_t_real,    -0.709260_t_real,    -0.635791_t_real &
       &,    -0.565443_t_real,    -0.497303_t_real,    -0.431412_t_real &
       &,    -0.368427_t_real,    -0.309298_t_real,    -0.254995_t_real &
       &,    -0.206306_t_real,    -0.163727_t_real,    -0.127413_t_real &
       &,    -0.097209_t_real,    -0.072699_t_real,    -0.053290_t_real &
       &,    -0.038284_t_real,    -0.026954_t_real,    -0.018598_t_real &
       &,    -0.012575_t_real,    -0.008332_t_real/
  Data bscoeffrel(1:50, 98) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000001_t_real &
       &,     0.000002_t_real,    -0.000012_t_real,    -0.000175_t_real &
       &,    -0.000802_t_real,    -0.002376_t_real,    -0.002898_t_real &
       &,    -0.001563_t_real,    -0.000005_t_real,    -0.002504_t_real &
       &,    -0.012655_t_real,    -0.026037_t_real,    -0.039626_t_real &
       &,    -0.049285_t_real,    -0.051165_t_real,    -0.046495_t_real &
       &,    -0.039099_t_real,    -0.031487_t_real,    -0.024606_t_real &
       &,    -0.018635_t_real,    -0.013509_t_real,    -0.009182_t_real &
       &,    -0.005678_t_real,    -0.002981_t_real,    -0.000996_t_real &
       &,     0.000390_t_real,     0.001279_t_real,     0.001759_t_real &
       &,     0.001917_t_real,     0.001843_t_real,     0.001622_t_real &
       &,     0.001330_t_real,     0.001027_t_real,     0.000748_t_real &
       &,     0.000514_t_real,     0.000330_t_real,     0.000194_t_real &
       &,     0.000099_t_real,     0.000036_t_real,    -0.000001_t_real &
       &,    -0.000021_t_real,    -0.000028_t_real,    -0.000029_t_real &
       &,    -0.000026_t_real,    -0.000021_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50, 99) /&
       &    -99.000000_t_real,   -98.882112_t_real,   -97.965241_t_real &
       &,   -95.555173_t_real,   -91.444460_t_real,   -85.728427_t_real &
       &,   -78.642503_t_real,   -70.566842_t_real,   -61.946096_t_real &
       &,   -53.259592_t_real,   -44.920783_t_real,   -37.173752_t_real &
       &,   -30.312455_t_real,   -24.570211_t_real,   -19.772101_t_real &
       &,   -15.714139_t_real,   -12.285336_t_real,    -9.489096_t_real &
       &,    -7.295394_t_real,    -5.618160_t_real,    -4.355066_t_real &
       &,    -3.411631_t_real,    -2.707995_t_real,    -2.180094_t_real &
       &,    -1.781448_t_real,    -1.481299_t_real,    -1.257754_t_real &
       &,    -1.091390_t_real,    -0.964350_t_real,    -0.862409_t_real &
       &,    -0.775702_t_real,    -0.697898_t_real,    -0.625153_t_real &
       &,    -0.555377_t_real,    -0.487770_t_real,    -0.422448_t_real &
       &,    -0.360110_t_real,    -0.301714_t_real,    -0.248216_t_real &
       &,    -0.200375_t_real,    -0.158649_t_real,    -0.123163_t_real &
       &,    -0.093728_t_real,    -0.069910_t_real,    -0.051103_t_real &
       &,    -0.036606_t_real,    -0.025694_t_real,    -0.017671_t_real &
       &,    -0.011908_t_real,    -0.007861_t_real/
  Data bscoeffrel(1:50, 99) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,    -0.000011_t_real,    -0.000147_t_real &
       &,    -0.000666_t_real,    -0.001922_t_real,    -0.002232_t_real &
       &,    -0.001128_t_real,     0.000028_t_real,    -0.002446_t_real &
       &,    -0.010722_t_real,    -0.020964_t_real,    -0.030803_t_real &
       &,    -0.037071_t_real,    -0.037456_t_real,    -0.033387_t_real &
       &,    -0.027654_t_real,    -0.021938_t_real,    -0.016850_t_real &
       &,    -0.012499_t_real,    -0.008839_t_real,    -0.005834_t_real &
       &,    -0.003467_t_real,    -0.001685_t_real,    -0.000396_t_real &
       &,     0.000489_t_real,     0.001042_t_real,     0.001323_t_real &
       &,     0.001393_t_real,     0.001311_t_real,     0.001138_t_real &
       &,     0.000923_t_real,     0.000706_t_real,     0.000510_t_real &
       &,     0.000348_t_real,     0.000221_t_real,     0.000128_t_real &
       &,     0.000064_t_real,     0.000022_t_real,    -0.000003_t_real &
       &,    -0.000015_t_real,    -0.000020_t_real,    -0.000020_t_real &
       &,    -0.000018_t_real,    -0.000014_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,100) /&
       &   -100.000000_t_real,   -99.880084_t_real,   -98.945238_t_real &
       &,   -96.493932_t_real,   -92.323759_t_real,   -86.532121_t_real &
       &,   -79.356965_t_real,   -71.183589_t_real,   -62.461552_t_real &
       &,   -53.678637_t_real,   -45.248929_t_real,   -37.423689_t_real &
       &,   -30.508830_t_real,   -24.716779_t_real,   -19.855107_t_real &
       &,   -15.727397_t_real,   -12.240742_t_real,    -9.411041_t_real &
       &,    -7.204330_t_real,    -5.527391_t_real,    -4.272333_t_real &
       &,    -3.340587_t_real,    -2.649113_t_real,    -2.132198_t_real &
       &,    -1.743062_t_real,    -1.451039_t_real,    -1.234084_t_real &
       &,    -1.072600_t_real,    -0.948894_t_real,    -0.849145_t_real &
       &,    -0.763873_t_real,    -0.687030_t_real,    -0.614968_t_real &
       &,    -0.545742_t_real,    -0.478657_t_real,    -0.413898_t_real &
       &,    -0.352199_t_real,    -0.294525_t_real,    -0.241813_t_real &
       &,    -0.194796_t_real,    -0.153895_t_real,    -0.119201_t_real &
       &,    -0.090500_t_real,    -0.067339_t_real,    -0.049100_t_real &
       &,    -0.035079_t_real,    -0.024556_t_real,    -0.016840_t_real &
       &,    -0.011314_t_real,    -0.007446_t_real/
  Data bscoeffrel(1:50,100) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000001_t_real,    -0.000010_t_real,    -0.000113_t_real &
       &,    -0.000503_t_real,    -0.001411_t_real,    -0.001561_t_real &
       &,    -0.000735_t_real,     0.000027_t_real,    -0.002117_t_real &
       &,    -0.008194_t_real,    -0.015284_t_real,    -0.021718_t_real &
       &,    -0.025347_t_real,    -0.024990_t_real,    -0.021891_t_real &
       &,    -0.017880_t_real,    -0.013984_t_real,    -0.010565_t_real &
       &,    -0.007682_t_real,    -0.005305_t_real,    -0.003401_t_real &
       &,    -0.001939_t_real,    -0.000859_t_real,    -0.000089_t_real &
       &,     0.000432_t_real,     0.000748_t_real,     0.000899_t_real &
       &,     0.000921_t_real,     0.000852_t_real,     0.000731_t_real &
       &,     0.000587_t_real,     0.000446_t_real,     0.000320_t_real &
       &,     0.000216_t_real,     0.000136_t_real,     0.000078_t_real &
       &,     0.000038_t_real,     0.000012_t_real,    -0.000003_t_real &
       &,    -0.000010_t_real,    -0.000013_t_real,    -0.000013_t_real &
       &,    -0.000011_t_real,    -0.000009_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,101) /&
       &   -101.000000_t_real,  -100.878023_t_real,   -99.924834_t_real &
       &,   -97.431822_t_real,   -93.201851_t_real,   -87.334290_t_real &
       &,   -80.069583_t_real,   -71.798016_t_real,   -62.974136_t_real &
       &,   -54.094333_t_real,   -45.573213_t_real,   -37.669624_t_real &
       &,   -30.700855_t_real,   -24.855822_t_real,   -19.927818_t_real &
       &,   -15.728857_t_real,   -12.185933_t_real,    -9.325679_t_real &
       &,    -7.108888_t_real,    -5.434785_t_real,    -4.189714_t_real &
       &,    -3.270802_t_real,    -2.591952_t_real,    -2.086098_t_real &
       &,    -1.706375_t_real,    -1.422278_t_real,    -1.211645_t_real &
       &,    -1.054766_t_real,    -0.934172_t_real,    -0.836457_t_real &
       &,    -0.752514_t_real,    -0.676562_t_real,    -0.605140_t_real &
       &,    -0.536438_t_real,    -0.469858_t_real,    -0.405652_t_real &
       &,    -0.344584_t_real,    -0.287619_t_real,    -0.235680_t_real &
       &,    -0.189467_t_real,    -0.149367_t_real,    -0.115440_t_real &
       &,    -0.087447_t_real,    -0.064915_t_real,    -0.047218_t_real &
       &,    -0.033651_t_real,    -0.023496_t_real,    -0.016071_t_real &
       &,    -0.010768_t_real,    -0.007066_t_real/
  Data bscoeffrel(1:50,101) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,    -0.000006_t_real,    -0.000067_t_real &
       &,    -0.000295_t_real,    -0.000802_t_real,    -0.000845_t_real &
       &,    -0.000368_t_real,     0.000009_t_real,    -0.001392_t_real &
       &,    -0.004821_t_real,    -0.008606_t_real,    -0.011840_t_real &
       &,    -0.013425_t_real,    -0.012940_t_real,    -0.011153_t_real &
       &,    -0.008986_t_real,    -0.006930_t_real,    -0.005148_t_real &
       &,    -0.003668_t_real,    -0.002471_t_real,    -0.001536_t_real &
       &,    -0.000835_t_real,    -0.000326_t_real,     0.000032_t_real &
       &,     0.000270_t_real,     0.000410_t_real,     0.000472_t_real &
       &,     0.000473_t_real,     0.000431_t_real,     0.000366_t_real &
       &,     0.000291_t_real,     0.000219_t_real,     0.000156_t_real &
       &,     0.000105_t_real,     0.000066_t_real,     0.000037_t_real &
       &,     0.000018_t_real,     0.000005_t_real,    -0.000002_t_real &
       &,    -0.000005_t_real,    -0.000007_t_real,    -0.000006_t_real &
       &,    -0.000006_t_real,    -0.000004_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,102) /&
       &   -102.000000_t_real,  -101.875927_t_real,  -100.904010_t_real &
       &,   -98.368816_t_real,   -94.078710_t_real,   -88.134911_t_real &
       &,   -80.780333_t_real,   -72.410094_t_real,   -63.483818_t_real &
       &,   -54.506639_t_real,   -45.893618_t_real,   -37.911575_t_real &
       &,   -30.888371_t_real,   -24.987160_t_real,   -19.990193_t_real &
       &,   -15.718840_t_real,   -12.121551_t_real,    -9.233762_t_real &
       &,    -7.009815_t_real,    -5.341000_t_real,    -4.107663_t_real &
       &,    -3.202514_t_real,    -2.536591_t_real,    -2.041783_t_real &
       &,    -1.671327_t_real,    -1.394929_t_real,    -1.190338_t_real &
       &,    -1.037793_t_real,    -0.920098_t_real,    -0.824266_t_real &
       &,    -0.741553_t_real,    -0.666427_t_real,    -0.595603_t_real &
       &,    -0.527400_t_real,    -0.461313_t_real,    -0.397650_t_real &
       &,    -0.337204_t_real,    -0.280940_t_real,    -0.229761_t_real &
       &,    -0.184336_t_real,    -0.145019_t_real,    -0.111839_t_real &
       &,    -0.084531_t_real,    -0.062608_t_real,    -0.045433_t_real &
       &,    -0.032301_t_real,    -0.022496_t_real,    -0.015348_t_real &
       &,    -0.010256_t_real,    -0.006712_t_real/
  Data bscoeffrel(1:50,102) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real/
  !!
  !!
  !!

  Data vscoeffrel(1:50,103) /&
       &   -103.000000_t_real,  -102.873827_t_real,  -101.883020_t_real &
       &,   -99.305815_t_real,   -94.956531_t_real,   -88.938363_t_real &
       &,   -81.496961_t_real,   -73.032451_t_real,   -64.010025_t_real &
       &,   -54.943878_t_real,   -46.249204_t_real,   -38.201167_t_real &
       &,   -31.137445_t_real,   -25.194409_t_real,   -20.147574_t_real &
       &,   -15.827886_t_real,   -12.203718_t_real,    -9.312307_t_real &
       &,    -7.096856_t_real,    -5.438895_t_real,    -4.212385_t_real &
       &,    -3.306847_t_real,    -2.633750_t_real,    -2.128609_t_real &
       &,    -1.748595_t_real,    -1.464293_t_real,    -1.251447_t_real &
       &,    -1.088835_t_real,    -0.959845_t_real,    -0.852887_t_real &
       &,    -0.760293_t_real,    -0.677109_t_real,    -0.600319_t_real &
       &,    -0.528349_t_real,    -0.460674_t_real,    -0.397454_t_real &
       &,    -0.339174_t_real,    -0.286362_t_real,    -0.239381_t_real &
       &,    -0.198323_t_real,    -0.162993_t_real,    -0.132963_t_real &
       &,    -0.107670_t_real,    -0.086510_t_real,    -0.068919_t_real &
       &,    -0.054394_t_real,    -0.042499_t_real,    -0.032851_t_real &
       &,    -0.025107_t_real,    -0.018961_t_real/
  Data bscoeffrel(1:50,103) /&
       &      0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,     0.000000_t_real,     0.000000_t_real,     0.000000_t_real &
       &,    -0.000005_t_real,    -0.000017_t_real,    -0.000012_t_real &
       &,     0.000008_t_real,    -0.000002_t_real,    -0.000034_t_real &
       &,    -0.000014_t_real,    -0.000011_t_real,    -0.000147_t_real &
       &,    -0.000184_t_real,     0.000032_t_real,     0.000266_t_real &
       &,    -0.000019_t_real,    -0.001318_t_real,    -0.003776_t_real &
       &,    -0.007330_t_real,    -0.011781_t_real,    -0.016608_t_real &
       &,    -0.020827_t_real,    -0.023380_t_real,    -0.023902_t_real &
       &,    -0.022855_t_real,    -0.020946_t_real,    -0.018694_t_real &
       &,    -0.016386_t_real,    -0.014163_t_real,    -0.012087_t_real &
       &,    -0.010184_t_real,    -0.008465_t_real,    -0.006927_t_real &
       &,    -0.005566_t_real,    -0.004372_t_real,    -0.003336_t_real &
       &,    -0.002454_t_real,    -0.001733_t_real,    -0.001184_t_real &
       &,    -0.000812_t_real,    -0.000597_t_real,    -0.000495_t_real &
       &,    -0.000455_t_real,    -0.000434_t_real,    -0.000410_t_real &
       &,    -0.000374_t_real,    -0.000327_t_real/
  !!
  !!
  !!
  
  !!
Contains
  !!***********************************************************************
  !! return approximate atom potentials
  Subroutine getatpotfit(iZ,mspin,ZZ,mesh,vtr,btr,relativistic,vca)
    !!
    Implicit None 
    !!IO
    Type(T_Mesh),Intent(in) :: mesh
    Integer(t_int),Intent(in)    :: mspin
    Integer(t_int),Intent(in)    :: relativistic
    Logical(t_log),Intent(in)    :: vca
    !! nuclear charge
    Integer(t_int),Intent(in)    :: iZ
    Real(t_real),Intent(in)      :: ZZ
    Real(t_real),Intent(out)     :: vtr(:)
    Real(t_real),Intent(out)     :: btr(:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="getatpotfit"
    Integer(t_int) :: i0
    Real(t_real)   :: Z,v(nmax),b(nmax),x
    Real(t_real),Pointer :: tmp(:)
    Type(T_Mesh) :: imesh
    !!
    Nullify(tmp)
    !!
    Call init_mesh(imesh)
    imesh% Type=POW_MESH
    imesh% rmax=20.0_t_real
    imesh% alpha=3
    imesh% rmin=1.0e-4_t_real
    imesh% nr=nmax
    imesh% with_zero=.True.
    Call setup_mesh(imesh)
    !!
    Z=Real(iZ,t_real)
    !!
    !!
    !!
    If( (iZ < 0_t_int .Or. iZ > MAX_ELEMENT ) )Then
       Write(errbuf,"('''Element number ',i5,' not implemented!''')")iZ
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
    End If
    !!
    If(vca .And. Abs(Z-ZZ)>1.0e-6_t_real)Then
       !! VCA
       i0=Floor(ZZ,t_int)
       !!
       If( (i0 < 0_t_int .Or. i0+1 > MAX_ELEMENT ) )Then
          Write(errbuf,"('''VCA Element charge ',g11.4,' out of range!''')")ZZ
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=Trim(errbuf))
       End If
       !!
       x=(ZZ-Real(i0,t_real))
       !!
       Write(outfile,"('VCA: ZZ=',g12.5,' i0= ',i5,' x=',g12.5)") ZZ,i0,x
       Call palloc('tmp',tmp,1_t_int,mesh% nr,nmodule,nsubfunc)
       !!
       If(mspin==1)Then
          v=0.0_t_real
          If(relativistic == NON_RELATIVISTIC) Then
             v(1:ncoefnrel(i0))=vcoefnrel(1:ncoefnrel(i0),i0)
          Else
             v(1:ncoeffrel(i0))=vcoeffrel(1:ncoefnrel(i0),i0)
          Endif
          !!
          Call mreinter(8_t_int,imesh,v,mesh,tmp)
          !!
          vtr(:)=tmp(:)*(1.0_t_real-x)
          !!
          v=0.0_t_real
          If(relativistic == NON_RELATIVISTIC) Then
             v(1:ncoefnrel(i0+1))=vcoefnrel(1:ncoefnrel(i0+1),i0+1)
          Else
             v(1:ncoeffrel(i0+1))=vcoeffrel(1:ncoefnrel(i0+1),i0+1)
          Endif
          !!
          Call mreinter(8_t_int,imesh,v,mesh,tmp)
          !!
          vtr(:)=vtr(:)+tmp(:)*x
       Else
          !!
          !!
          v=0.0_t_real
          b=0.0_t_real
          If(relativistic == NON_RELATIVISTIC) Then
             v(1:ncoefnrel(i0))=vscoefnrel(1:ncoefnrel(i0),i0)
             b(1:ncoefnrel(i0))=bscoefnrel(1:ncoefnrel(i0),i0)
          Else
             v(1:ncoeffrel(i0))=vscoeffrel(1:ncoefnrel(i0),i0)
             b(1:ncoeffrel(i0))=bscoeffrel(1:ncoefnrel(i0),i0)
          Endif
          !!
          Call mreinter(8_t_int,imesh,v,mesh,tmp)
          vtr(:)=tmp(:)*(1.0_t_real-x)
          Call mreinter(8_t_int,imesh,b,mesh,tmp)
          btr(:)=tmp(:)*(1.0_t_real-x)
          !!
          !!
          v=0.0_t_real
          b=0.0_t_real
          If(relativistic == NON_RELATIVISTIC) Then
             v(1:ncoefnrel(i0+1))=vscoefnrel(1:ncoefnrel(i0+1),i0+1)
             b(1:ncoefnrel(i0+1))=bscoefnrel(1:ncoefnrel(i0+1),i0+1)
          Else
             v(1:ncoeffrel(i0+1))=vscoeffrel(1:ncoefnrel(i0+1),i0+1)
             b(1:ncoeffrel(i0+1))=bscoeffrel(1:ncoefnrel(i0+1),i0+1)
          Endif
          !!
          Call mreinter(8_t_int,imesh,v,mesh,tmp)
          vtr(:)=vtr(:)+tmp(:)*x
          Call mreinter(8_t_int,imesh,b,mesh,tmp)
          btr(:)=btr(:)+tmp(:)*x
          !!
       Endif
       !!
    Else
       If(mspin==1)Then
          v=0.0_t_real
          If(relativistic == NON_RELATIVISTIC) Then
             v(1:ncoefnrel(iZ))=vcoefnrel(1:ncoefnrel(iZ),iZ)
          Else
             v(1:ncoeffrel(iZ))=vcoeffrel(1:ncoefnrel(iZ),iZ)
          Endif
          !!
          Call mreinter(8_t_int,imesh,v,mesh,vtr)
       Else
          v=0.0_t_real
          b=0.0_t_real
          If(relativistic == NON_RELATIVISTIC) Then
             v(1:ncoefnrel(iZ))=vscoefnrel(1:ncoefnrel(iZ),iZ)
             b(1:ncoefnrel(iZ))=bscoefnrel(1:ncoefnrel(iZ),iZ)
          Else
             v(1:ncoeffrel(iZ))=vscoeffrel(1:ncoefnrel(iZ),iZ)
             b(1:ncoeffrel(iZ))=bscoeffrel(1:ncoefnrel(iZ),iZ)
          Endif
          !!
          Call mreinter(8_t_int,imesh,v,mesh,vtr)
          Call mreinter(8_t_int,imesh,b,mesh,btr)
       Endif
    Endif
    !!
    !!
    !!
    !!
    !!
    Call pfree(tmp)
    Call cleanup_mesh(imesh)
    !!
    Return
    !!
  End Subroutine getatpotfit
  !!***********************************************************************
  
End Module atomdata
