  !!----DEBUG options----------------------------|
  !! SUBFUNC               | MODES               |
  !!---------------------------------------------|
  !! def_bzone             |  NEW_BZMESH         |
  !! symmetrize_weights    |  PROT               |
  !! symmetrize_weights    |  NO_INTER_K         |
  !! tetwts                |  NO_WEIGHT_SYM      |
  !! splwts                |  NO_WEIGHT_SYM      |
  !! det_bandweights       |  PLOT_NOS           |
  !!---------------------------------------------|
Module bzone
  !!
  Use precisiondefs
  Use clock
  Use memory
  Use file_iounits
  Use diagonalize
  Use constants
  Use errors
  Use optionstest
  Use matserv
  Use sort
  Use tbzone
  Use tbandplot
  Use tsymmetry
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="BZONE"  
  !!
  Public :: def_bzone,det_bandweights,tetdos,tetdostotal,gamdos,find_k_index
  !!***********************************************************************
contains
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine  new_bzmesh(symmetry,numops,opmat,bzone)
    !!
    Implicit none  
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Bzone),Intent(inout)  :: bzone
    Integer(t_int),Intent(in)    :: numops
    Real(t_real),Intent(in) :: opmat(3,3,48)
    !!LOCAL
    Character(*),Parameter::nsubfunc="new_bzmesh"
    Integer(t_int) :: i,ikp,nkp,Nx,Ny,Nz,ix,iy,iz,jkp,ntet,nt,Ndx,Ndy,Ndz
    Integer(t_int) :: id,jops,l1,l2,l3,e1,e2,e3,Nki,itet,imul,Nwqk,isum,nop
    Integer(t_int) :: f1,f2,f3
    Real(t_real)   :: qb(3,3),Q(3,3),vol,volQ,vol1,r(3),rb(3,3)
    Real(t_real)   :: a,b,c,dc,rt(3,3),sum
    !!
    Integer(t_int),Pointer :: ind(:,:,:)
    Integer(t_int),Pointer :: indtet(:,:)
    Integer(t_int),Pointer :: idtet(:,:)
    Integer(t_int),Pointer :: ieq(:)
    Integer(t_int),Pointer :: ieqi(:)
    Integer(t_int),Pointer :: iwqk(:)
    Integer(t_int),Pointer :: ifbz(:)
    Real(t_real),Pointer :: qk(:,:)
    !!
    !tol=1.0e-5_t_real
    !!
    rb=symmetry% lattice_vectors/symmetry% lattice_constants(1)
    ndx=2
    ndy=2
    e1=1
    e2=1
    e3=1
    !!
    nop=numops
    If (isoption('FULLBZ'))Then
       nop=1
    Endif
    !!
    Do i=1,3
       Write(outfile,1) i,rb(:,i)
    Enddo
    Write(outfile,10)
    !!
    Call dinv33(rb,1_t_int,qb,vol)
    !!
    Do i=1,3
       Write(outfile,2) i,qb(:,i)
    Enddo
    Call dinv33(qb,1_t_int,rt,vol1)
    Write(outfile,4)vol1
    Write(outfile,10)    
    !!
    !! 
    Print *,symmetry% lattice
    If(symmetry% lattice(1:1)=='S')Then
       Print *,'SIMPLE'
       Q(:,1)=(qb(:,1))
       Q(:,2)=(qb(:,2))
       Q(:,3)=(qb(:,3))

       Ndx=2
       Ndy=2
       Ndz=2
    Else If(symmetry% lattice(1:2)=='FC')Then
       Print *,'FACE_CENTERED'
       Q(:,1)=(qb(:,2)+qb(:,3))
       Q(:,2)=(qb(:,1)+qb(:,3))
       Q(:,3)=(qb(:,1)+qb(:,2))*0.5_t_real

       Ndx=4
       Ndy=4
       Ndz=2

    Else If(symmetry% lattice(1:2)=='BC')Then
       Print *,'BODY_CENTERED'
       Q(:,1)=(-qb(:,1)+qb(:,2)+qb(:,3))
       Q(:,2)=( qb(:,1)-qb(:,2)+qb(:,3))*0.5_t_real
       Q(:,3)=( qb(:,1)+qb(:,2)-qb(:,3))*0.5_t_real
       Ndx=4
       Ndy=2
       Ndz=2

    Endif
    !!
    Do i=1,3
       Write(outfile,3) i,Q(:,i)
    Enddo
    Call dinv33(Q,1_t_int,rt,volQ)
    Write(outfile,4)volQ
    Write(outfile,10)
    Write(outfile,5)volQ/vol1
    Write(outfile,10)
    Do i=1,3
       Write(outfile,33) i,rt(:,i)
    Enddo
    Write(outfile,10)
    !!
    a=Sqrt(Dot_product(Q(:,1),Q(:,1)))
    b=Sqrt(Dot_product(Q(:,2),Q(:,2)))
    c=Sqrt(Dot_product(Q(:,3),Q(:,3)))
    !!
    Write(outfile,9)a,b,c
    !!
    If(symmetry% lattice(1:1)=='S')Then
       Nz=bzone% nkxyz(1)
       If(bzone% nkxyz(1) /= bzone% nkxyz(2) .Or. &
            &bzone% nkxyz(1) /= bzone% nkxyz(3) )Then
          Write(errbuf,201) Ndz
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
          Nz=1
       Endif
       If(Nz<1)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Number of k-points along x-axis <1!'")
          Nz=1
       Endif
       If(Mod(Nz,Ndz) /= 0) Then
          Nz=(Nz/Ndz+1)*Ndz;
          !Write(errbuf,201) Ndz,Nz,bzone% nkxyz(1)
          Write(errbuf,201) Ndz
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
       Endif
       dc=c/Nz
       Ny=Max((Nint(b/dc/Ndy,t_int))*Ndy,Ndy);  
       Nx=Max((Nint(a/dc/Ndx,t_int))*Ndx,Ndx);  
       Write(outfile,11) Nx,Ny,Nz
       !!
    Else If(symmetry% lattice(1:2)=='FC')Then
       Nz=bzone% nkxyz(1)
       If(bzone% nkxyz(1) /= bzone% nkxyz(2) .Or. &
            &bzone% nkxyz(1) /= bzone% nkxyz(3) )Then
          Write(errbuf,201) Ndz
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
          Nz=1
       Endif
       If(Nz<1)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Number of k-points along x-axis <1!'")
          Nz=1
       Endif
       If(Mod(Nz,Ndz) /= 0) Then
          Nz=(Nz/Ndz+1)*Ndz;
          !Write(errbuf,201) Ndz,Nz,bzone% nkxyz(1)
          Write(errbuf,201) Ndz
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
       Endif
       dc=c/Nz
       Ny=Max((Nint(b/dc/Ndy,t_int))*Ndy,Ndy);  
       Nx=Max((Nint(a/dc/Ndx,t_int))*Ndx,Ndx);  
       Write(outfile,11) Nx,Ny,Nz
       !!
    Else If(symmetry% lattice(1:2)=='BC')Then
       !! Nx=2Ny
       Nz=bzone% nkxyz(1)
       If(bzone% nkxyz(1) /= bzone% nkxyz(2) .Or. &
            &bzone% nkxyz(1) /= bzone% nkxyz(3) )Then
          Write(errbuf,201) Ndz
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
          Nz=1
       Endif
       If(Nz<1)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Number of k-points along x-axis <1!'")
          Nz=1
       Endif
       If(Mod(Nz,Ndz) /= 0) Then
          Nz=(Nz/Ndz+1)*Ndz;
          !Write(errbuf,201) Ndz,Nz,bzone% nkxyz(1)
          Write(errbuf,201) Ndz
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
       Endif
       dc=c/Nz
       Ny=Max((Nint(b/dc/Ndy,t_int))*Ndy,Ndy);  
       Nx=Max((Nint(a/dc/Ndx,t_int))*Ndx,Ndx);  
       Write(outfile,11) Nx,Ny,Nz
       !!
    Endif
    !!
    !!  create reducible mesh
    nkp=(Nx+1)*(Ny+1)*(Nz+1)
    ntet=Nx*Ny*Nz*6
    !!
    !!
    Nullify(ifbz)
    Nullify(iwqk)
    Nullify(ind)
    Nullify(qk)
    Nullify(indtet)
    Call palloc('iwqk',iwqk ,1_t_int,nkp ,nmodule,nsubfunc)
    Call palloc('ifbz',ifbz ,1_t_int,nkp ,nmodule,nsubfunc)
    ifbz=0_t_int
    Call palloc('qk',qk ,1_t_int,3_t_int ,1_t_int,nkp ,nmodule,nsubfunc)
    Call palloc('indtet',indtet,1_t_int,4_t_int,1_t_int,ntet,nmodule,nsubfunc)
    Call palloc('ind',ind ,0_t_int,Nx,0_t_int,Ny,0_t_int,Nz,nmodule,nsubfunc)
    !!
    !!
    ikp=0
    Do iz=0,Nz
       Do iy=0,Ny
          Do ix=0,Nx
             ikp=ikp+1
             qk(:,ikp)=&
                  &  Q(:,1)/Real(Nx,t_real)*ix&
                  &+ Q(:,2)/Real(Ny,t_real)*iy&
                  &+ Q(:,3)/Real(Nz,t_real)*iz
             !! map ix,iy,iz Onto ikp
             ind(ix,iy,iz)=ikp;
             !!
          Enddo
       Enddo
    Enddo
    If(ikp/=nkp)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'nkp incorrect?! Sorry!'")

    Endif
    !!
    !! Now create reducible tetras
    nt=0_t_int
    Do iz=0,Nz-1,2
       Do iy=0,Ny-1,2
          Do ix=0,Nx-1,2


             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 1_t_int,0_t_int,0_t_int&
                  &, 0_t_int,0_t_int,0_t_int&
                  &, 1_t_int,1_t_int,0_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,0_t_int,0_t_int&
                  &, 0_t_int,1_t_int,0_t_int&
                  &, 1_t_int,1_t_int,0_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,1_t_int,0_t_int&
                  &, 0_t_int,2_t_int,0_t_int&
                  &, 1_t_int,1_t_int,0_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,2_t_int,0_t_int&
                  &, 1_t_int,2_t_int,0_t_int&
                  &, 1_t_int,1_t_int,0_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 1_t_int,2_t_int,0_t_int&
                  &, 2_t_int,2_t_int,0_t_int&
                  &, 1_t_int,1_t_int,0_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,2_t_int,0_t_int&
                  &, 2_t_int,1_t_int,0_t_int&
                  &, 1_t_int,1_t_int,0_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,1_t_int,0_t_int&
                  &, 2_t_int,0_t_int,0_t_int&
                  &, 1_t_int,1_t_int,0_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,0_t_int,0_t_int&
                  &, 1_t_int,0_t_int,0_t_int&
                  &, 1_t_int,1_t_int,0_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)


             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,1_t_int,0_t_int&
                  &, 0_t_int,0_t_int,0_t_int&
                  &, 0_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,0_t_int,0_t_int&
                  &, 0_t_int,0_t_int,1_t_int&
                  &, 0_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,0_t_int,1_t_int&
                  &, 0_t_int,0_t_int,2_t_int&
                  &, 0_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,0_t_int,2_t_int&
                  &, 0_t_int,1_t_int,2_t_int&
                  &, 0_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,1_t_int,2_t_int&
                  &, 0_t_int,2_t_int,2_t_int&
                  &, 0_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,2_t_int,2_t_int&
                  &, 0_t_int,2_t_int,1_t_int&
                  &, 0_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,2_t_int,1_t_int&
                  &, 0_t_int,2_t_int,0_t_int&
                  &, 0_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,2_t_int,0_t_int&
                  &, 0_t_int,1_t_int,0_t_int&
                  &, 0_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)

             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 1_t_int,2_t_int,0_t_int&
                  &, 0_t_int,2_t_int,0_t_int&
                  &, 1_t_int,2_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,2_t_int,0_t_int&
                  &, 0_t_int,2_t_int,1_t_int&
                  &, 1_t_int,2_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,2_t_int,1_t_int&
                  &, 0_t_int,2_t_int,2_t_int&
                  &, 1_t_int,2_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,2_t_int,2_t_int&
                  &, 1_t_int,2_t_int,2_t_int&
                  &, 1_t_int,2_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 1_t_int,2_t_int,2_t_int&
                  &, 2_t_int,2_t_int,2_t_int&
                  &, 1_t_int,2_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,2_t_int,2_t_int&
                  &, 2_t_int,2_t_int,1_t_int&
                  &, 1_t_int,2_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,2_t_int,1_t_int&
                  &, 2_t_int,2_t_int,0_t_int&
                  &, 1_t_int,2_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,2_t_int,0_t_int&
                  &, 1_t_int,2_t_int,0_t_int&
                  &, 1_t_int,2_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)


             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,1_t_int,0_t_int&
                  &, 2_t_int,0_t_int,0_t_int&
                  &, 2_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,0_t_int,0_t_int&
                  &, 2_t_int,0_t_int,1_t_int&
                  &, 2_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,0_t_int,1_t_int&
                  &, 2_t_int,0_t_int,2_t_int&
                  &, 2_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,0_t_int,2_t_int&
                  &, 2_t_int,1_t_int,2_t_int&
                  &, 2_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,1_t_int,2_t_int&
                  &, 2_t_int,2_t_int,2_t_int&
                  &, 2_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,2_t_int,2_t_int&
                  &, 2_t_int,2_t_int,1_t_int&
                  &, 2_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,2_t_int,1_t_int&
                  &, 2_t_int,2_t_int,0_t_int&
                  &, 2_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,2_t_int,0_t_int&
                  &, 2_t_int,1_t_int,0_t_int&
                  &, 2_t_int,1_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)


             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 1_t_int,0_t_int,0_t_int&
                  &, 0_t_int,0_t_int,0_t_int&
                  &, 1_t_int,0_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,0_t_int,0_t_int&
                  &, 0_t_int,0_t_int,1_t_int&
                  &, 1_t_int,0_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,0_t_int,1_t_int&
                  &, 0_t_int,0_t_int,2_t_int&
                  &, 1_t_int,0_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,0_t_int,2_t_int&
                  &, 1_t_int,0_t_int,2_t_int&
                  &, 1_t_int,0_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 1_t_int,0_t_int,2_t_int&
                  &, 2_t_int,0_t_int,2_t_int&
                  &, 1_t_int,0_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,0_t_int,2_t_int&
                  &, 2_t_int,0_t_int,1_t_int&
                  &, 1_t_int,0_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,0_t_int,1_t_int&
                  &, 2_t_int,0_t_int,0_t_int&
                  &, 1_t_int,0_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,0_t_int,0_t_int&
                  &, 1_t_int,0_t_int,0_t_int&
                  &, 1_t_int,0_t_int,1_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)


             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 1_t_int,0_t_int,2_t_int&
                  &, 0_t_int,0_t_int,2_t_int&
                  &, 1_t_int,1_t_int,2_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,0_t_int,2_t_int&
                  &, 0_t_int,1_t_int,2_t_int&
                  &, 1_t_int,1_t_int,2_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,1_t_int,2_t_int&
                  &, 0_t_int,2_t_int,2_t_int&
                  &, 1_t_int,1_t_int,2_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 0_t_int,2_t_int,2_t_int&
                  &, 1_t_int,2_t_int,2_t_int&
                  &, 1_t_int,1_t_int,2_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 1_t_int,2_t_int,2_t_int&
                  &, 2_t_int,2_t_int,2_t_int&
                  &, 1_t_int,1_t_int,2_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,2_t_int,2_t_int&
                  &, 2_t_int,1_t_int,2_t_int&
                  &, 1_t_int,1_t_int,2_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,1_t_int,2_t_int&
                  &, 2_t_int,0_t_int,2_t_int&
                  &, 1_t_int,1_t_int,2_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)
             Call TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
                  &, 2_t_int,0_t_int,2_t_int&
                  &, 1_t_int,0_t_int,2_t_int&
                  &, 1_t_int,1_t_int,2_t_int&
                  &, 1_t_int,1_t_int,1_t_int,nt,indtet)


          End Do
       End Do
    Enddo
    !! check tetra work array dimensions
    If(nt>ntet)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'ntet incorrect?! Sorry!'")
    Endif
    ntet=nt  
    !!
    Write(outfile,13) nkp
    Write(outfile,14) ntet
    !!
    !! TODO: reduce with respect to border repetition in FBZ mode
    !!       and for printout
    !!
    Nullify(ieq)
    Nullify(ieqi)
    Call palloc('ieq',ieq,1_t_int,nkp ,nmodule,nsubfunc)
    Call palloc('ieqi',ieqi,1_t_int,nkp ,nmodule,nsubfunc)
    !!
    Nwqk=0_t_int
    redkloop: Do ikp=1,nkp
       !Write(outfile,17) ikp
       id=nkp+1
       redoploop: Do jops=1,nop 
          r(:)=Matmul(qk(:,ikp),opmat(:,:,jops))
          !!
          !Write(outfile,18) qk(:,ikp)
          !Write(outfile,19) r(:)
          !! rot(q) in units of tetcell 
          l1=Nint(Dot_product(r(:),rt(:,1))*Nx,t_int)
          l2=Nint(Dot_product(r(:),rt(:,2))*Ny,t_int)
          l3=Nint(Dot_product(r(:),rt(:,3))*Nz,t_int)
          If(symmetry% lattice(1:1)=='S')Then
             f3=l3/nz
             e3=Mod(l3,Nz)
             If(e3<0) Then
                f3=f3-1
                e3=e3+Nz
             Endif

             f2=l2/Ny
             e2=Mod(l2,Ny)
             If(e2<0) Then
                f2=f2-1
                e2=e2+Ny
             Endif

             f1=l1/Nx
             e1=Mod(l1,Nx)
             If(e1<0) Then
                f1=f1-1
                e1=e1+Nx
             Endif

          Else If(symmetry% lattice(1:2)=='BC')Then
             !!makefe(l2,f2,e2,nz);
             f3=l3/nz
             e3=Mod(l3,Nz)
             If(e3<0) Then
                f3=f3-1
                e3=e3+Nz
             Endif
             l1=l1-f3*Nx/2
             l3=l3-f3*Nz

             !makefe(l1,f1,e1,ny);
             f2=l2/Ny
             e2=Mod(l2,Ny)
             If(e2<0) Then
                f2=f2-1
                e2=e2+Ny
             Endif
             l1=l1-f2*Nx/2
             l2=l2-f2*Ny

             !makefe(l0,f0,e0,nx);
             f1=l1/Nx
             e1=Mod(l1,Nx)
             If(e1<0) Then
                f1=f1-1
                e1=e1+Nx
             Endif

          Else If(symmetry% lattice(1:2)=='FC')Then
             !Write(outfile,20) l1,l2,l3
             Do While(l2<0)
                l1=l1+Nx/2
                l2=l2+Ny/2
                l3=l3-Nz
             Enddo
             Do While(l2>=Ny) 
                l1=l1-Nx/2
                l2=l2-Ny/2
                l3=l3+Nz
             Enddo
             Do While(l3<0)
                l3=l3+Nz*2
             Enddo
             Do While(l3>=Nz)
                l3=l3-Nz*2
             Enddo
             If(l3<0)Then
                l1=l1-Nx/2
                l2=l2-Ny/2
                l3=l3+Nz
             Endif
             If(l2<0)Then
                l1=l1+Nx
                l2=l2+Ny
             Endif

             Do While(l1<0)
                l1=l1+Nx
             Enddo
             Do While(l1>=Nx)
                l1=l1-Nx
             Enddo

             e1=l1
             e2=l2
             e3=l3
             
          Endif!! face centered
          !!
          If( &
               &(e1<0 .Or. e1>Nx ) .Or.&
               &(e2<0 .Or. e2>Ny ) .Or.&
               &(e3<0 .Or. e3>Nz ) )then
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="'backfolding of k-mesh failed?! Sorry!'")
          Endif
          !!
          If(ind(e1,e2,e3)==ikp .And. jops == 1)Then
             ifbz(ikp)=1
             Nwqk=Nwqk+1
          Endif
          !!
          id=Min(id,ind(e1,e2,e3))
          !!
       Enddo redoploop
       !!
       If(id==nkp+1)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'Reduction of k-mesh failed?! Sorry!'")
       Endif
       !!
       ieq(ikp)=id
       !!
       !Write(outfile,16) ikp,ieq(ikp)
       !!
    Enddo redkloop
    !!
    Write(outfile,40) Nkp,Nwqk
    Do ikp=1,Nkp
       Write(outfile,24) ikp,qk(:,ikp),ieq(ikp)
    Enddo
    !! count irred k-points 
    Nki=0_t_int
    Do ikp=1,nkp
       If(ieq(ikp) == ikp ) Nki=Nki+1
    End Do
    id=0
    Do ikp=1,nkp
       If(ieq(ikp) == ikp ) Then
          id=id+1
          ieqi(ikp)=id
       Endif
    Enddo
    !!
    bzone% nkp=nki
    Write(outfile,15) nki
    !!
   Do ikp=1,Nkp
       If(ieq(ikp) == ikp )Then
          Write(outfile,21) ikp,qk(:,ikp)
       Endif
    Enddo
    !!
    Do ikp=1,Nkp
       iwqk(ikp)=1
       If(ieq(ikp) == ikp )Then
          Do jkp=1,Nkp
             If(ifbz(jkp)==1 .And. ieq(jkp)==ikp .And. ikp /= jkp)Then
                iwqk(ikp)=iwqk(ikp)+1
             Endif
          Enddo
       Endif
    Enddo
    Do itet=1,ntet
       Write(outfile,22) itet,indtet(:,itet)
    Enddo
    !!
    Nullify(idtet)
    Call palloc('idtet',idtet,0_t_int,4_t_int,1_t_int,ntet,nmodule,nsubfunc)
    !!
    Do itet=1,ntet
       Do i=1,4
          idtet(i,itet)=ieqi(ieq(indtet(i,itet)))
       Enddo
       idtet(0,itet)=0_t_int
       !! ----------- order the 4 edges of each tetrahedron
       Call ishell(1_t_int,4_t_int,idtet(1:4,itet))
    Enddo
    !!
    !! --- Order the ntet0 tetrahedra
    Call ishell(5_t_int,ntet,idtet)
    !! --- Find irreducible tetrahedra (ntet different ones)
!!$    nt=ntet
!!$    Do itet=1,ntet
!!$       idtet(0,itet)=1
!!$    Enddo
    nt=1
    idtet(0,1)=1
    Do itet=2,ntet
       If(All(idtet(1:4,itet) == idtet(1:4,nt))) Then
          idtet(0,nt)=idtet(0,nt)+1
       Else
          nt=nt+1
          idtet(0,nt)=1
          idtet(1:4,nt)=idtet(1:4,itet)
       Endif
    Enddo
    !!
    bzone% ntet=nt

    !!
    Call palloc('bzone % p_bk',bzone % p_bk&
         &,1_t_int,3_t_int&
         &,1_t_int,Max(1_t_int,Nki)&
         &,nmodule,nsubfunc)
    Call palloc('bzone % p_wbk',bzone % p_wbk&
         &,1_t_int,Max(1_t_int,Nki)&
         &,nmodule,nsubfunc)

    !!
    bzone % p_bk=0.0_t_real
    !!
    i=0
    Do ikp=1,Nkp
       If(ieq(ikp) == ikp )Then
          i=i+1
          bzone% p_bk(:,i)=qk(:,ikp)*twopi/symmetry% lattice_constants(1_t_int)
          bzone % p_wbk(i)=Real(iwqk(ikp),t_real)/Nwqk
       Endif
    Enddo
    If(i/=Nki)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="'i /= Nki ?!'")
    Endif
    !!
    Call palloc('bzone % p_tet',bzone % p_tet&
         &,0_t_int,5_t_int&
         &,1_t_int,Max(1_t_int,bzone% ntet)&
         &,nmodule,nsubfunc)
    !!

    Do itet=1,bzone% ntet
       bzone % p_tet(0:5,itet)=idtet(0:5,itet)
    Enddo
    !!
    If (outlevel >= L_more) Write(outfile,313)bzone% nkp,Nwqk,Nx,Ny,Nz
    If (outlevel >= L_many) Then
       Write(outfile,304)
       sum=0.0_t_real
       Do ikp = 1_t_int, bzone% nkp
          imul = Nint(bzone% p_wbk(ikp)*Nwqk,t_int)
          Write(outfile,305)ikp,(bzone% p_bk(i,ikp),i=1,3),imul,bzone% p_wbk(ikp)
          sum=sum+bzone% p_wbk(ikp)
       Enddo
       Write(outfile,306)
    Endif
    !!
    sum=0.0_t_real
    Do ikp = 1_t_int, bzone% nkp
       sum=sum+bzone% p_wbk(ikp)
    Enddo
    !!
    If(Abs(sum-1.0_t_real)> 1.0e-6_t_real)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="' BZMESH: error in weights.'")
    Endif
    !!
    isum=0_t_int
    Do itet=1,bzone% ntet
       isum=isum+bzone% p_tet(0,itet)
    Enddo
    !!
    If (outlevel >= L_more) Write(outfile,300)bzone% ntet, ntet
    If (outlevel >= l_many) Then
       Write(outfile,301)
       Write(outfile,302)(itet,(bzone% p_tet(i,itet),i=0,4),itet=1,bzone% ntet)
       Write(outfile,303)
       Write(outfile,310) isum,Nx*Ny*Nz*6
    Endif
    bzone% ntetsum=Real(6.0_t_int*Nx*Ny*Nz,t_real)
    If(isum/=Nx*Ny*Nz*6)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="' BZMESH: error in tet weights.'")
    Endif

    !!
    call pfree(ifbz)
    call pfree(iwqk)
    call pfree(qk)
    call pfree(indtet)
    call pfree(ind)
    call pfree(ieq)
    call pfree(idtet)
    !Stop 'construction'
    !!
    !!
    !!

    !!
    !! reduce translation
    !! if reducible, reduce symmetry
    !!
    !! take care when reducing that we stay in the supercube!!
    !!
    !! make integration tetra arrays
    !! reduce them if nesseccary
    !! check neighbour redlations of points
    !!
    !!  reduce mesh with respect to translation and symmetry
    !!  create tetrahedra and find irreducible
    !!  make sure that the irreducible points are 'compact'
    !!
    !!
10  Format() 
1   Format('R(',i1,')=',3(f10.5,2x)) 
2   Format('G(',i1,')=',3(f10.5,2x)) 
3   Format('QT(',i1,')=',3(f10.5,2x)) 
33  Format('RT(',i1,')=',3(f10.5,2x)) 
4   Format('vol=',1(f10.5,2x)) 
5   Format('Vol ratio=',1(f10.5,2x)) 
!6   Format('kp(',i3,')=',3(f10.5,2x)) 
9   Format('a= ',f10.5&
         &,/,'b= ',f10.5&
         &,/,'c= ',f10.5) 
11  Format('Nx=',i4,/,'Ny=',i4,/,'Nz=',i4) 
13  Format('k-points     : ',i6)
14  Format('tetrahedrons : ',i6)
15  Format('irreducible k-points     : ',i6)
!16  Format('k-point     : ',i6,' equivalent to ',i6)
!17  Format('current k-point     : ',i6)
!18  Format('k-point     : ',3(f10.5,2x))
!19  Format('G*k-point   : ',3(f10.5,2x))
!20  Format('l1,l2,l3   : ',3(i5,2x))
21  Format(i6,3(f10.5,2x))
24  Format(i6,3(f10.5,2x),i7)
40  Format('Nkp   : ',i6,/,'Nwqk   : ',i6)
22  Format(i6,4(i5,2x))
    !200 Format("'Number of k-points along x-axis must be multiple of ",i1&
    !         &,"!',/,' Will take ",i3," instead of ",i3,"!'") 
201 Format("'Number of k-points along all axes must be equal and a"&
         &," multiple of ",i1,"!'") 
300 Format(/' TETIRR: ',i9,' inequivalent tetrahedra from ',i9)
301 Format(/' TETIRR:  ITET  WEIGHT   KP1    KP2    KP3    KP4', &
         & /,9x,43('-'))
302 Format(7x,i6,4i7,4x,i3)
303 Format(9x,43('-'))
304 Format(4x,'IKP',6x,'Qx',8x,'Qy',8x,'Qz',6x,'Multiplicity',4x,&
         & 'Weight',/3x,62('-'))
305 Format(i5,2x,3f10.4,i10,f16.6)
306 Format(3x,62('-'))
310 Format('tet weight sum=',i7,i7)
313 Format(/' BZMESH:',i6,' irreducible k-points from',i7,' (',3i3, &
         & ' )')    !!
  End Subroutine new_bzmesh
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine  TETRAHEDRON(ind,nx,ny,nz,ix,iy,iz&
       &,i1,i2,i3 ,i4,i5,i6 ,i7,i8,i9, i10,i11,i12&
       &,nt,indtet)
    !!
    Implicit None  
    !!IO
    Integer(t_int),Intent(in)    :: nx,ny,nz
    Integer(t_int),Intent(in)    :: ix,iy,iz
    Integer(t_int),Intent(in)    :: i1,i2,i3
    Integer(t_int),Intent(in)    :: i4,i5,i6
    Integer(t_int),Intent(in)    :: i7,i8,i9
    Integer(t_int),Intent(in)    :: i10,i11,i12
    Integer(t_int),Intent(in)    :: ind(0:nx,0:ny,0:nz)
    Integer(t_int),Intent(out)   :: indtet(4,*)
    Integer(t_int),Intent(inout) :: nt
    !!LOCAL
    !!
    nt=nt+1_t_int
    !!
    indtet(1,nt)=ind(ix+i1 ,iy+i2 ,iz+i3 )
    indtet(2,nt)=ind(ix+i4 ,iy+i5 ,iz+i6 )
    indtet(3,nt)=ind(ix+i7 ,iy+i8 ,iz+i9 )
    indtet(4,nt)=ind(ix+i10,iy+i11,iz+i12)
    !!
    Return
    !!
  End Subroutine TETRAHEDRON
#endif
  !!***********************************************************************
  Subroutine def_bzone(symmetry,numops,opmat,timerev,bzone)
    !!
    Implicit None 
    !!IO
    Type(T_Bzone),Intent(inout)      :: bzone
    Type(T_Symmetry),Intent(in)      :: symmetry
    Integer(t_int),Intent(in):: numops
    Real(t_real),Intent(in) :: opmat(3,3,48)
    Integer(t_int),Intent(in)    :: timerev(48)
    !!LOCAL
    Character(*),Parameter::nsubfunc="def_bzone"
    Integer(t_int) :: jops,ikp,i,gikp,nirred
    Logical(t_log) :: ltimerev,exists
    Real(t_real)   :: gk(3),dk(3),k0(3),deltag(3)
    Integer(t_int),Pointer :: p_ikp_to_ijk(:,:)
    Integer(t_int),Pointer :: p_tet(:,:)
    Real(t_real) :: rb(3,3),qb(3,3)
    Integer(t_int) ::n,lnkxyz(3)
    Real(t_real),Parameter :: tol=1.0e-10_t_real
    Character(*),Parameter :: spfname='=.special_kmesh'
    !!
    Nullify(p_ikp_to_ijk,p_tet)
    !!
    bzone% symeqkpoint_fullbz=.False.
    
    If(bzone% gammapoint)Then

       
       bzone% ntetsum=6.0_t_real
       !!
       Call palloc('bzone % p_bk',bzone % p_bk,1_t_int,3_t_int&
            &,1_t_int,1_t_int,nmodule,nsubfunc)

       Call palloc('bzone % p_wbk',bzone % p_wbk,1_t_int,1_t_int&
            &,nmodule,nsubfunc)

       bzone% nkp=1
       bzone% p_bk(:,1)=0.0_t_real
       bzone% p_wbk(1) =1.0_t_real

       
       bzone% ntet=0
       Call palloc('bzone % p_tet',bzone % p_tet,0_t_int,5_t_int&
            &,1_t_int,1_t_int,nmodule,nsubfunc)

       !!bzone % p_tet(0:5,:)=tet(0:5,1:bzone % ntet)
       
       return
    Endif

    bzone% dospecial=.False.
    Inquire(file=Trim(spfname),exist=exists)
    If(exists)Then
       Open(12,file=Trim(spfname))
       Read(12,*)
       Read(12,*)bzone% dospecial
       Read(12,*)
       Read(12,*) k0
       Read(12,*)
       Read(12,*) deltag(1:3)
    Endif

    If(bzone% dospecial)Then
       Write(outfile,454)Trim(spfname),k0,deltag
454    Format('File ',a,' found ... will create special k-mesh',/&
            &,'around k-point ',2(f17.12,' , '),f17.12,/&
            &,'of relative length ',2(f17.12,' , '),f17.12)
    Endif
    

    lnkxyz(1:3)=bzone% nkxyz(1:3)
    
    rb=symmetry% lattice_vectors/ symmetry% lattice_constants(1_t_int)
    n=lnkxyz(1_t_int) *lnkxyz(2_t_int) *lnkxyz(3_t_int)

    bzone% ntetsum=6.0_t_real&
         &*lnkxyz(1_t_int)&
         &*lnkxyz(2_t_int)&
         &*lnkxyz(3_t_int)

    If(bzone% dospecial)Then
       bzone% ntetsum=bzone% ntetsum/(deltag(1)*deltag(2)*deltag(3))
    Endif

!!$    !! This is new stuff for testing a symmetric tetrahedron
!!$    !! mesh. but not yet complete and not really better then the
!!$    !! old one, only addvantage would be a better subdivision
!!$    !! of non-cubic meshs, (may be)
!!$    !! the less symmetric tetra choice of the default method 
!!$    !! seems to lead to error cancelation
!!$    If(debugfun(nmodule,nsubfunc,'NEW_BZMESH'))Then
!!$       Call new_bzmesh(symmetry,numops,opmat,bzone)
!!$       Return
!!$    Endif
    !!
    Call palloc('bzone % p_bk',bzone % p_bk&
         &,1_t_int,3_t_int&
         &,1_t_int,Max(1_t_int,n)&
         &,nmodule,nsubfunc)

    Call palloc('bzone % p_wbk',bzone % p_wbk&
         &,1_t_int,Max(1_t_int,n)&
         &,nmodule,nsubfunc)

    
    Call palloc('bzone% p_ijk_to_ikp',bzone% p_ijk_to_ikp&
         &,1_t_int,Max(1_t_int,n),nmodule,nsubfunc)
    
    Call palloc('p_ikp_to_ijk',p_ikp_to_ijk,1_t_int,4_t_int&
         &,1_t_int,Max(1_t_int,n),nmodule,nsubfunc)
    

 
    Call defbz(lnkxyz,bzone % p_bk,bzone % p_wbk,bzone % nkp,rb,qb &
         & ,numops, opmat,timerev,bzone% p_ijk_to_ikp,p_ikp_to_ijk&
         &,bzone% dospecial,k0,deltag,bzone% ensure_negkpoint)

    Call palloc('bzone% p_ikp_to_ijk',bzone% p_ikp_to_ijk,1_t_int,4_t_int&
         &,1_t_int,Max(1_t_int,bzone% nkp),nmodule,nsubfunc)

    bzone% p_ikp_to_ijk(1:4,1:bzone% nkp)=p_ikp_to_ijk(1:4,1:bzone% nkp)

    Call pfree(p_ikp_to_ijk)


    Call palloc('p_tet',p_tet,0_t_int,5_t_int,1_t_int,6_t_int*Max(1_t_int,n)&
         &,nmodule,nsubfunc)

    
    
    Call ccutup(qb,bzone% kcut)

    Call tetirr(bzone% p_ijk_to_ikp,p_tet,lnkxyz,bzone % ntet,bzone% kcut)



    Call palloc('bzone % p_tet',bzone % p_tet&
         &,0_t_int,5_t_int&
         &,1_t_int,Max(1_t_int,bzone% ntet)&
         &,nmodule,nsubfunc)

    bzone % p_tet(0:5,:)=p_tet(0:5,1:bzone % ntet)
    bzone % p_bk(1:3,1:bzone% nkp)&
         &=bzone % p_bk(1:3,1:bzone% nkp)&
         &*twopi/ symmetry% lattice_constants(1)
    bzone % p_wbk(1:bzone% nkp) =bzone % p_wbk(1:bzone% nkp) * 0.5_t_real
    !!
    Call palloc('bzone% p_irredindex',bzone% p_irredindex&
         &,1_t_int,bzone% nkp,nmodule,nsubfunc)
    !!
    !!make irreducible indexing for case of FULLBZ 
    !!
    If(.Not.bzone% dospecial .And. isoption('FULLBZ'))Then
       bzone% symeqkpoint_fullbz=.True.

       nirred=0
       bzone% p_irredindex=0
       kloop: Do ikp=1,bzone% nkp
          If(bzone% p_irredindex(ikp)==0)Then
             nirred=nirred+1
             bzone% p_irredindex(ikp)=ikp
             Do jops=1,numops
                ltimerev=(timerev(jops)==1)
                !If(ltimerev)Then
                !   Write(outfile,"('T*',a)")Trim(symmetry% Ropsymbol(jops))
                !Else
                !   Write(outfile,"(a)")Trim((symmetry% Ropsymbol(jops)))
                !Endif
                gk(:)=Matmul(bzone% p_bk(:,ikp),opmat(:,:,jops))
                If(ltimerev)gk=-gk
                gikp=-1
                ksearchloop: Do i=1,bzone% nkp
                   dk=Matmul(gk-bzone% p_bk(:,i)&
                        &,symmetry% lattice_vectors(:,:))/twopi
                   Call backfold(dk)
                   If(All(Abs(dk(:))<tol))Then
                      gikp=i
                      Exit ksearchloop
                   Endif
                Enddo ksearchloop
                If(gikp<0)Then
                   Write(errbuf,"('''ikp=',i6,' jops=',i3,' k=',3f12.8&
                        &,': did not find g(ikp,jops,k) ?''')") &
                        &ikp,jops,bzone% p_bk(:,ikp)
                   Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
                Endif
                !!
                !!
                bzone% p_irredindex(gikp)=ikp
                If (outlevel >= L_all )Then
                   Print "('k(',i6,')=',3f12.8,' == ',/&
                        &,   'k(',i6,')=',3f12.8)"&
                        &,ikp,bzone% p_bk(:,i),gikp,bzone% p_bk(:,gikp)
                Endif
             Enddo !jops
          Endif
       Enddo kloop
       !!
       If (outlevel >= L_many )Then
          Write(outfile,"('number of irreducible points ',i6)")nirred
          Do ikp=1,bzone% nkp
             Write(outfile,"('k(',i6,') belongs to k(',i6,')')")&
                  &ikp,bzone% p_irredindex(ikp)
          Enddo
       Endif
       !!
    Else
       Do ikp=1,bzone% nkp
          bzone% p_irredindex(ikp)=ikp
       Enddo
    Endif
    !!
    Call pfree(p_tet)
    !!
  End Subroutine def_bzone
  !!***********************************************************************
  Subroutine  backfold(nq)
    !!
    Implicit none  
    !!IO
    Real(t_real),Intent(inout)   :: nq(3)
    !!LOCAL
    Integer(t_int) :: i
    !!
    Do i=1,3
       Do While(nq(i) < -0.5_t_real) 
          nq(i)=nq(i)+1.0_t_real
       Enddo
       Do While(nq(i) >  0.5_t_real)
          nq(i)=nq(i)-1.0_t_real
       Enddo
       If(nq(i) == -0.5_t_real) then
          nq(i)=nq(i)+1.0_t_real
       Endif
    Enddo

    !!
    Return
    !!
  End Subroutine backfold
  !!***********************************************************************
  Integer(t_int) Function find_k_index(lattice_vectors,nkp,bk,qq)
    !! find equivalent of qq in bk
    !! return index in success, or 0 in failure
    !!
    !! qq,bk must include 2*Pi ( being in terms of physical reciprocal not
    !! mathematical (inverse) latticevectors)
    !! 
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nkp
    Real(t_real),Intent(in)      :: lattice_vectors(3,3),qq(3),bk(3,nkp)
    !!LOCAL
    Character(*),Parameter::nsubfunc="find_k_index"
    Logical(t_log) :: equiv
    Integer(t_int) :: ikm
    Real(t_real)   :: v(3)
    Real(t_real),Parameter :: vtol=1.0e-5_t_real

    !!
    !!
    find_k_index=0_t_int
    !!
    Do ikm=1,nkp
       !!
       !Write(outfile,"(' k=',t16,3(f12.5,1x),/,' k(',a,')=',t16,3(f12.5,1x))") &
       !     &qq,Trim(intToChar10(ikm)),bk(:,ikm)
       !!
       v=bk(:,ikm)-qq
       !Write(outfile,"('dk=',t16,3(f12.5,1x))") v
       v=Matmul(v,lattice_vectors)/twopi
       !Write(outfile,"('dkrel=',t16,3(f12.5,1x))") v
       equiv=vecIsOnGrid(3_t_int,v,vtol)

       If(equiv)Then
          find_k_index=ikm
          Return 
       Endif
    Enddo
    !!
    Call errmsg(nmodule,nsubfunc,E_fatalerror,&
         &msg="'cannot find equivalent k-point, did you set all options properly?'")
    !!
    Return
    !!
  End Function find_k_index
  !!***********************************************************************
  !!  define k-mesh, some lattices with larger mesh
  !!***********************************************************************
  !!
  Subroutine defbz(nkxyz,bk,wbk,nkp,rb,qb,numops,opmat,timerev,ijk_to_ikp&
       &,ikp_to_ijk,dospecial,k0,deltag,ensure_negkpoint)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: dospecial,ensure_negkpoint
    Integer(t_int),Intent(in)   :: nkxyz(3),numops
    Integer(t_int),Intent(out)  :: ijk_to_ikp(*),ikp_to_ijk(4,*)
    Integer(t_int),Intent(out)  :: nkp
    Integer(t_int),Intent(in)   :: timerev(48)
    Real(t_real),Intent(out)   :: bk(3,*)
    Real(t_real),Intent(out)   :: wbk(*)
    Real(t_real),Intent(out)   :: qb(3,3)
    Real(t_real),Intent(in)    :: rb(3,3),k0(3),deltag(3)
    Real(t_real),Intent(in)    :: opmat(3,3,48)
    !!LOCAL
    Real(t_real)  :: sop(3,3,48)
    Integer(t_int) :: numops1,ig
    !!
    !! normal k-mesh
    numops1=numops
    Do ig=1,numops
       If(timerev(ig) == 1 )Then
          sop(:,:,ig)=-opmat(:,:,ig)
       Else
          sop(:,:,ig)=opmat(:,:,ig)
       Endif
    Enddo
    !! fullbz
    If (dospecial .Or. isoption('FULLBZ'))Then
       numops1=1_t_int
       sop=0.0_t_real
       sop(1_t_int,1_t_int,1_t_int)=1.0_t_real
       sop(2_t_int,2_t_int,1_t_int)=1.0_t_real
       sop(3_t_int,3_t_int,1_t_int)=1.0_t_real
    Endif
    !!
    Call bzmesh(bk,ijk_to_ikp,ikp_to_ijk,nkxyz,nkp,rb,qb,numops1,sop,wbk&
         &,dospecial,k0,deltag,ensure_negkpoint)
    !!
  End Subroutine defbz
  !!
  !!***********************************************************************
  Subroutine bzmesh(bk,ijk_to_ikp,ikp_to_ijk,nkxyz,nkp,plat,qb,numops &
       & ,opmat,wbk,dospecial,k0,deltag,ensure_negkpoint)
    !!-Divides the reciprocal lattice into microcells
    !!-----------------------------------------------------------------------
    !!i Inputs:
    !!i   nkxyz :no of divisions made along each reciprocal lattice vector
    !!i   numops:number of symmetry operations 
    !!i   plat  :primitive lattice vectors
    !!i   opmat :symmetry operation matrix 
    !!o Outputs:
    !!o   bk    :irreducible k-point
    !!o   ijk_to_ikp   :ijk_to_ikp(i1,i2,i3) points to corresponding irreducible k-point
    !!o   nkp   :number of irreducible k-points
    !!o   qb    :vectors of first microcell
    !!o   wbk   :weight of k-point, including spin degeneracy
    !!r Remarks:
    !!r  The reciprocal lattice is divided into nkxyz(1)*nkxyz(2)*nkxyz(3)
    !!r  microcells which are parallelipipeds with 8 corners.
    !!r  The corners are nodes of the k-space mesh in the whole reciprocal
    !!r  lattice unit cell. Some of these will be symmetry-related leaving
    !!r  nkp irreducible k-points.
    !!r  These are returned in bk(3,j) j = 1,nkp; for each corner defined
    !!r  by the triple (i1,i2,i3), ijk_to_ikp(i1,i2,i3) points to the corresponding
    !!r  k-vector in bk. wbk(j) then contains the sampling weight associated
    !!r  with the j-th irreducible k-point bk(j):it is proportional to the
    !!r  number of times it occurs in the whole reciprocal unit cell.
    !!r  (The sum of all weights must equal 2)
    !!---------------------------------------------------------------------
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: dospecial,ensure_negkpoint
    Integer(t_int),Intent(in)    :: nkxyz(3),numops
    Integer(t_int),Intent(out)   :: ijk_to_ikp(0:nkxyz(1)-1,0:nkxyz(2)-1&
         &                             ,0:nkxyz(3)-1)
    Integer(t_int),Intent(out)   :: nkp
    Integer(t_int),Intent(out)   :: ikp_to_ijk(1:4,*)
    Real(t_real),Intent(in)      :: plat(3,3),opmat(3,3,48),k0(3),deltag(3)
    Real(t_real),Intent(out)     :: qb(3,3)
    Real(t_real),Intent(out)     :: bk(3,*),wbk(*)
    !!LOCAL 
    Character(*),Parameter::nsubfunc="bzmesh"
    Integer(t_int) :: ism(3,3,48),j(3),k,nnc,nk,ikp,i,m,iwtkp,i1,i2,i3,iswtkp
    Integer(t_int) :: isop,ikm
    Real(t_real) :: tmp2(3,3),tmp1(3,3),diff(3,3),rbt(3,3),w0
    Real(t_real) :: qlat(3,3),vol,rb(3,3),q(3),q0(3)
    Logical(t_log) :: lcomp(48)
    Integer(t_int),Pointer :: p_iwk(:)
    Real(t_real),Parameter :: tinyy=1.e-3_t_real
    !!
    Nullify(p_iwk)
    !!
    If(dospecial)Then
       
       Call dinv33(plat,1_t_int,qlat,vol)
       Write(outfile,"('qlat=',3f15.7)")qlat(:,1)
       Write(outfile,"('     ',3f15.7)")qlat(:,2)
       Write(outfile,"('     ',3f15.7)")qlat(:,3)
       
       
       q0=qlat(:,1)*k0(1)+qlat(:,2)*k0(2)+qlat(:,3)*k0(3)

       nk=nkxyz(1)*nkxyz(2)*nkxyz(3)
       ijk_to_ikp=0
       
       Do k=1,3
          qb(:,k) = qlat(:,k)/Max(nkxyz(k)-1,1_t_int)*deltag(k)
          qlat(:,k)=qlat(:,k)*deltag(k)
       Enddo
       Write(outfile,"('k0  =',3f15.7)")q0
       Write(outfile,"('qb1 =',3f15.7)")qb(:,1)
       Write(outfile,"('     ',3f15.7)")qb(:,2)
       Write(outfile,"('     ',3f15.7)")qb(:,3)
       q0=q0-qlat(:,1)*0.5-qlat(:,2)*0.5-qlat(:,3)*0.5
       Write(outfile,"('q0  =',3f15.7)")q0
       w0 = 2.0_t_real/nk*deltag(1)*deltag(2)*deltag(3)
       Print *,'w0',w0
       nkp = 0_t_int
       iswtkp = 0_t_int
       Do i3=0,nkxyz(3)-1
          Do i2=0,nkxyz(2)-1
             Do i1=0,nkxyz(1)-1
                If (ijk_to_ikp(i1,i2,i3)==0) Then
                   nkp=nkp+1
                   iwtkp=0
                   Do k=1,3
                      q(k)=qb(k,1)*i1+qb(k,2)*i2+qb(k,3)*i3
                   Enddo
                   ijk_to_ikp(i1,i2,i3)=nkp
                   iwtkp=iwtkp+1
                   Do k=1,3
                      bk(:,nkp)=q+q0
                   Enddo
                   ikp_to_ijk(1,nkp)=i1
                   ikp_to_ijk(2,nkp)=i2
                   ikp_to_ijk(3,nkp)=i3
                   ikp_to_ijk(4,nkp)=iwtkp
                   wbk(nkp)=iwtkp*w0
                   iswtkp=iswtkp+iwtkp
                Endif
             Enddo
          Enddo
       Enddo
    
       If (outlevel >= L_many) Then
          Write(outfile,304)
          Do ikp = 1_t_int, nkp
             Write(outfile,1305)ikp,(bk(m,ikp),m=1_t_int,3_t_int),wbk(ikp)/w0,wbk(ikp)
          Enddo
          Write(outfile,306)
       Endif
       !!
       If (outlevel >= L_all ) Then
          Write(outfile,500)
          Do i3=0,nkxyz(3)-1
             Do i2=0,nkxyz(2)-1
                Do i1=0,nkxyz(1)-1
                   Write(outfile,501)i1,i2,i3,ijk_to_ikp(i1,i2,i3)
                Enddo
             Enddo
          Enddo
          Write(outfile,502)
          !!
          Write(outfile,503)
          Do ikp = 1_t_int, nkp
             Write(outfile,501)ikp,ikp_to_ijk(1:4,ikp)
          Enddo
          Write(outfile,502)
       Endif
       !!
       If (iswtkp /= nk) Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="' BZMESH: error in weights.'")
          
       Endif
       
       Return
    Endif

    Call dinv33(plat,1_t_int,qlat,vol)
    
    nk=nkxyz(1_t_int)*nkxyz(2_t_int)*nkxyz(3_t_int)
    ijk_to_ikp=0_t_int
    
    Do k = 1_t_int, 3_t_int
       qb(:,k) = qlat(:,k)/nkxyz(k)
       rb(:,k) = plat(:,k)*nkxyz(k)
    Enddo
    rbt=Transpose(rb)
    nnc=0_t_int
    Do isop=1_t_int,numops
       
       tmp1=Matmul(rbt,opmat(:,:,isop))
       tmp2=Matmul(tmp1,qb)
       ism(:,:,isop)=Nint(tmp2(:,:),t_int)
       diff(:,:)=tmp2(:,:)-ism(:,:,isop)

       lcomp(isop)=Sum(Abs(diff)) < tinyy
       If (.not.lcomp(isop)) Then
          Write(errbuf,400)nkxyz,rb,opmat(:,:,isop),qb,tmp2
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg=errbuf)
          nnc=nnc+1_t_int
       Endif
    Enddo
    If (nnc /=  0_t_int) Then
       Write(errbuf,401)nnc,numops
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg=errbuf)
    Endif
    
    w0 = 2.0_t_real/nk
    nkp = 0_t_int
    iswtkp = 0_t_int
    Do i3 = 0_t_int, nkxyz(3_t_int)-1_t_int
       Do i2 = 0_t_int, nkxyz(2_t_int)-1_t_int
          Do i1 = 0_t_int, nkxyz(1_t_int)-1_t_int
             If (ijk_to_ikp(i1,i2,i3) == 0_t_int) Then
                nkp = nkp+1_t_int
                iwtkp = 0_t_int
                Do isop = 1_t_int, numops
                   If (lcomp(isop)) Then
                      Do k=1_t_int,3_t_int
                         j(k)=ism(k,1_t_int,isop)*i1+ism(k,2_t_int,isop)*i2&
                              &+ism(k,3_t_int,isop)*i3
                         j(k) = Mod(j(k),nkxyz(k))
                         If (j(k) < 0_t_int) j(k)=j(k)+nkxyz(k)
                      Enddo
                      If (ijk_to_ikp(j(1),j(2),j(3))  ==  0_t_int) Then
                         ijk_to_ikp(j(1),j(2),j(3)) = nkp
                         iwtkp = iwtkp+1_t_int
                      Endif
                   Endif
                Enddo
                Do k = 1_t_int,3_t_int
                   bk(k,nkp) = qb(k,1_t_int)*i1 + qb(k,2_t_int)*i2 + qb(k,3_t_int)*i3
                Enddo
                ikp_to_ijk(1_t_int,nkp)=i1
                ikp_to_ijk(2_t_int,nkp)=i2
                ikp_to_ijk(3_t_int,nkp)=i3
                ikp_to_ijk(4_t_int,nkp)=iwtkp
                wbk(nkp) = iwtkp*w0
                iswtkp = iswtkp + iwtkp
             Endif
          Enddo
       Enddo
    Enddo
    
    !! --- Printout
    If (outlevel >= L_many )&
         & Write(outfile,301) ((plat(m,k),m=1_t_int,3_t_int),(qlat(m,k),m=1_t_int,3_t_int),k=1_t_int,3_t_int)
    If (outlevel >= L_all ) Then
       Write(outfile,302)
       Write(outfile,300)(isop,((ism(k,m,isop),m=1_t_int,3_t_int),k=1_t_int,3_t_int),&
            & isop=1_t_int,numops)
    Endif
    If (outlevel >= L_more) Write(outfile,303)nkp,nk,(nkxyz(i),i=1_t_int,3_t_int)
!!$ MTaut, graphene
!!$    Do ikp=1,nkp!!todo:remove
!!$       bk(1:3,ikp)=bk(1:3,ikp)*0.03&
!!$            &+(/2.0_t_real/Sqrt(3.0_t_real),0.0_t_real,0.0_t_real/)*c1o3*0.985&
!!$            &+(/1.0_t_real/Sqrt(3.0_t_real),1.0_t_real,0.0_t_real/)*c1o3*0.985
!!$    Enddo

    If(ensure_negkpoint)Then
       Call palloc('p_iwk',p_iwk,1_t_int,nkp,nmodule,nsubfunc)
       p_iwk=1
       Do ikp=1,nkp
          If(p_iwk(ikp)==1)Then
             ikm=find_k_index(plat*twopi,nkp,bk,-bk(:,ikp))
             If(ikm/=ikp)Then
                bk(:,ikm)=-bk(:,ikp)
             Endif
             p_iwk(ikm)=0
          Endif
       Enddo
       Call pfree(p_iwk)
    Endif

    If (outlevel >= L_many) Then
       Write(outfile,304)
       Do ikp = 1_t_int, nkp
          iwtkp = Nint(wbk(ikp)/w0,t_int)
          Write(outfile,305)ikp,(bk(m,ikp),m=1_t_int,3_t_int),iwtkp,wbk(ikp)
       Enddo
       Write(outfile,306)
    Endif
    !!
    If (outlevel >= L_all ) Then
       Write(outfile,500)
       Do i3=0,nkxyz(3)-1
          Do i2=0,nkxyz(2)-1
             Do i1=0,nkxyz(1)-1
                Write(outfile,501)i1,i2,i3,ijk_to_ikp(i1,i2,i3)
             Enddo
          Enddo
       Enddo
       Write(outfile,502)
       !!
       Write(outfile,503)
       Do ikp = 1_t_int, nkp
          Write(outfile,501)ikp,ikp_to_ijk(1:4,ikp)
       Enddo
       Write(outfile,502)
500    Format(/,' BZMESH:     mapping k-indices -> No of irred k-point',/&
            &,t4,'   i1     i2     i3     ikp',/&
            &,t2,62('-'))
503    Format(/,' BZMESH:     mapping No of irred k-point -> k-indices',/&
            &,t4,'  ikp     i1     i2     i3 weight',/&
            &,t2,62('-'))
501    Format(t2,5(i7))
502    Format(t2,62('-'),/)
    Endif
    !!
    If (iswtkp /= nk) Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="' BZMESH: error in weights.'")
       
    Endif
    
300 Format(48(/12x,i2,3x,3i4,/,2(17x,3i4/)))
301 Format(/' BZMESH: ',6x,'PLAT',31x,'QLAT',3(/3f10.5,5x,3f10.5))
302 Format(/' BZMESH:  ISOP   PLAT*SYMOPM*QLAT',/10x,22('-'))
303 Format(/' BZMESH:',i6,' irreducible k-points from',i7,' (',3i3, &
         & ' )')
304 Format(4x,'IKP',6x,'Qx',8x,'Qy',8x,'Qz',6x,'Multiplicity',4x,&
         & 'Weight',/3x,62('-'))
305 Format(i5,2x,3f10.4,i10,f16.6)
1305 Format(i5,2x,3f10.4,f30.15,f16.6)
306 Format(3x,62('-'))
    
400 Format('/,'' BZMESH: NKABC=',3i4,' not compatible With symmetry:'&
         &,''',//,24x,''',3f9.4,''',/,8x,''RB=PLAT*NKABC= '',1x,''',3f9.4&
         &,''',/,24x,''',3f9.4&
         &,''',//,24x,''',3f9.4,''',/,8x,''SYMOPM=        '',1x,''',3f9.4&
         &,''',/,24x,''',3f9.4&
         &,''',//,24x,''',3f9.4,''',/,8x,''QB=QLAT/NKABC  '',1x,''',3f9.4&
         &,''',/,24x,''',3f9.4&
         &,''',//,24x,''',3f9.4,''',/,8x,''RB^t*SYMOPM*QB='',1x,''',3f9.4&
         &,''',/,24x,''',3f9.4&
         &,''',//,'' and the last 9 values should be integer values.'',/')
401 Format(''' BZMESH: mesh not invariant under ',i2,&
         & ' symmetry operations (from total ',i2,' operations)''')
  End Subroutine bzmesh
  !!***********************************************************************
  
  Subroutine tetirr(ijk_to_ikp,tet,nkxyz,ntet,kcut)
    !!-  Find inequivalent tetrahedra and count them
    !! ----------------------------------------------------------------------
    !! Inputs:
    !!   ijk_to_ikp   :ijk_to_ikp(i1,i2,i3) points to corresponding irreducible k-point
    !!   n1-3  :no. of divisions made along each reciprocal lattice vector
    !!   kcut  :micro cell tetrahedra subdivision
    !! Outputs:
    !!   tet :tet(0,i) = number of tetrahedra of the i'th kind
    !!          tet(1-4,i) points to the 4 irreducible k-points defining
    !!          the tetrahedron.
    !!          tet(5,i) points to one of the 4 cut-types of the microcell
    !!          
    !!   ntet  :number of different tetrahedra
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int) ,Intent(in) :: nkxyz(3)
    Integer(t_int) ,Intent(in) :: ijk_to_ikp(0:nkxyz(1)-1,0:nkxyz(2)-1&
         &                           ,0:nkxyz(3)-1)
    Integer(t_int),Intent(in)    :: kcut(3,4,6)
    Integer(t_int),Intent(out) ::  ntet,tet(0:5,*)
    !!LOCAL
    Integer(t_int)  :: i1,i2,i3,ntet0,k1,k2,k3,idk(0:1,0:1,0:1),itet,icorn&
         &,j1,j2,j3,i,ii(4),jj(4)
    
    ntet = 0_t_int
    ntet0 = 6_t_int*nkxyz(1_t_int)*nkxyz(2_t_int)*nkxyz(3_t_int)

    !! --- START LOOPING OVER MICROCELLS
    Do i3 = 0_t_int, nkxyz(3_t_int)-1_t_int
       Do i2 = 0_t_int, nkxyz(2_t_int)-1_t_int
          Do i1 = 0_t_int, nkxyz(1_t_int)-1_t_int
             
             !! --------- SET UP IDENTIFIERS AT 8 CORNERS OF MICROCELL
             Do  k1 = 0_t_int, 1_t_int
                j1=Mod(i1+k1,nkxyz(1_t_int))
                Do  k2 = 0_t_int, 1_t_int
                   j2=Mod(i2+k2,nkxyz(2_t_int))
                   Do  k3 = 0_t_int, 1_t_int
                      j3=Mod(i3+k3,nkxyz(3_t_int))
                      idk(k1,k2,k3)=ijk_to_ikp(j1,j2,j3)
                   Enddo
                Enddo
             Enddo
             
             !! --------- LOOP OVER TETRAHEDRA
             Do itet = 1_t_int, 6_t_int
                ntet = ntet + 1_t_int
                Do icorn = 1_t_int, 4_t_int
                   k1 = kcut(1,icorn,itet)
                   k2 = kcut(2,icorn,itet)
                   k3 = kcut(3,icorn,itet)
                   tet(icorn,ntet) = idk(k1,k2,k3)
                Enddo
                tet(5,ntet) = itet
                tet(0,ntet) =0
                !! ----------- order the 4 edges of each tetrahedron
                !Call ishell(1_t_int,4_t_int,tet(1_t_int,ntet))
             Enddo
          Enddo
       Enddo
    Enddo

    !! --- Order the ntet0 tetrahedra
    Call ishell(6_t_int,ntet0,tet)

    
    !! --- Find irreducible tetrahedra (ntet different ones)
    ntet=1
    tet(0,ntet)=1
    ii(1:4)=tet(1:4,ntet)
    Call ishell(1_t_int,4_t_int,ii)
    Do itet=2,ntet0
       jj(1:4)=tet(1:4,itet)
       Call ishell(1_t_int,4_t_int,jj)

       If( All(jj(:) == ii(:)) ) Then
          tet(0,ntet)=tet(0,ntet)+1
       Else
          ntet=ntet+1_t_int
          tet(0,ntet)=1
          tet(1:5,ntet)=tet(1:5,itet)
          ii=jj
       Endif
    Enddo
    
    !! --- Printout
    If (outlevel >= L_more) Write(outfile,300)ntet,ntet0
    If (outlevel >= l_all) Then
       Write(outfile,301)
       Write(outfile,302)(itet,(tet(i,itet),i=0,5),itet=1,ntet)
       Write(outfile,303)
    Endif
    
300 Format(/' TETIRR: ',i9,' inequivalent tetrahedra from ',i9)
301 Format(/' TETIRR:  ITET  WEIGHT   KP1    KP2    KP3    KP4  CUT-TYPE', &
         & /,9x,50('-'))
302 Format(7x,i6,4x,i3,4i7,4x,i3)
303 Format(9x,43('-'))
  End Subroutine tetirr
  !!***********************************************************************
  
  Subroutine ccutup(qb,kcut)
    !!- Cut the microcell into six tetrahedra with shortest max edge
    !! ----------------------------------------------------------------------
    !! Inputs:
    !!   qb    :vectors of first microcell
    !! Outputs:
    !!   kcut  :contains information how microcell is cut
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(out) :: kcut(3,4,6)
    Real(t_real),Intent(in)   ::  qb(3,3)
    !!LOCAL
    Integer(t_int) :: i,itet,icorn,jcorn,lx,ly,lz,lxx,lyy,kcut0(3,4,6)
    Real(t_real) ::p(3,4),dp(3),edgmax,edgmin,edmin,edmax,xx
    
    Data kcut0/ &
         &  0_t_int,0_t_int,0_t_int, 0_t_int,1_t_int,0_t_int&
         &, 1_t_int,1_t_int,0_t_int, 1_t_int,1_t_int,1_t_int&

         &, 0_t_int,0_t_int,0_t_int, 1_t_int,0_t_int,0_t_int&
         &, 1_t_int,1_t_int,0_t_int, 1_t_int,1_t_int,1_t_int&

         &, 0_t_int,0_t_int,0_t_int, 1_t_int,0_t_int,0_t_int&
         &, 1_t_int,0_t_int,1_t_int, 1_t_int,1_t_int,1_t_int&

         &, 0_t_int,0_t_int,0_t_int, 0_t_int,1_t_int,0_t_int&
         &, 0_t_int,1_t_int,1_t_int, 1_t_int,1_t_int,1_t_int&

         &, 0_t_int,0_t_int,0_t_int, 0_t_int,0_t_int,1_t_int&
         &, 0_t_int,1_t_int,1_t_int, 1_t_int,1_t_int,1_t_int&

         &, 0_t_int,0_t_int,0_t_int, 0_t_int,0_t_int,1_t_int&
         &, 1_t_int,0_t_int,1_t_int, 1_t_int,1_t_int,1_t_int /
    
    !! --- CHOSE CUTUP WITH SHORTEST MAX EDGE ---------
    lz = 0_t_int
    lxx = 0_t_int
    lyy = 0_t_int
    edgmax = Huge(1.0_t_real)
    edgmin = 0.0_t_real
    Do lx = 0_t_int, 1_t_int
       Do ly = 0_t_int, 1_t_int
          Do itet = 1_t_int, 6_t_int
             Do icorn = 1_t_int, 4_t_int
                Call mxmymz(kcut0(1_t_int,icorn,itet),kcut(1_t_int,icorn,itet),lx,ly,lz)
             Enddo
          Enddo
          edmin = Huge(1.0_t_real)
          edmax = 0.0_t_real
          Do itet = 1_t_int, 6_t_int
             Do icorn = 1_t_int, 4_t_int
                Do i=1_t_int,3_t_int
                   p(i,icorn)=Sum(qb(i,:)*kcut(:,icorn,itet)) 
                Enddo
             Enddo
             Do icorn = 1_t_int, 3_t_int
                Do jcorn = icorn+1_t_int, 4_t_int
                   dp(:)=p(:,icorn)-p(:,jcorn)
                   
                   xx = danrm2(dp)
                   edmax = Max(edmax,xx)
                   edmin = Min(edmin,xx)
                Enddo
             Enddo
          Enddo
          If(outlevel >= L_all ) &
               & Write(outfile,300)lx,ly,Sqrt(edmin),Sqrt(edmax)
          If (edmax < edgmax) Then
             lxx = lx
             lyy = ly
             edgmax = edmax
             edgmin = edmin
          Endif
       Enddo
    Enddo
    Do itet = 1_t_int, 6_t_int
       Do icorn = 1_t_int, 4_t_int
          Call mxmymz(kcut0(1_t_int,icorn,itet),kcut(1_t_int,icorn,itet),lxx,lyy,lz)
       Enddo
    Enddo
    If(outlevel >= L_all) &
         & Write(outfile,301)lxx,lyy,Sqrt(edgmin),Sqrt(edgmax)
    
300 Format(' CCUTUP: LX,LY=',2i5,3x,'EDMIN=',f10.5,3x,'EDMAX=',f10.5)
301 Format(' CCUTUP: LXX=',i1,3x,'LYY=',i1,3x,'EDGMIN=',f10.5,3x, &
         & 'EDGMAX=',f10.5)
  End Subroutine ccutup
  !!***********************************************************************
  Subroutine mxmymz(kin,kout,lx,ly,lz)
    !!- Do mirrors in x,y,z if lx,ly,lz=1, respectively
    !! ----------------------------------------------------------------
    !! Inputs:
    !!   kin   :
    !!   lx-z  :
    !! Outputs:
    !!   kout  :
    !! ----------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in) :: kin(3),lx,ly,lz
    Integer(t_int) ,Intent(out) :: kout(3)
    !!LOCAL
    kout(1_t_int) = kin(1_t_int)
    kout(2_t_int) = kin(2_t_int)
    kout(3_t_int) = kin(3_t_int)
    If (lx == 1_t_int) kout(1_t_int) = 1_t_int-kout(1_t_int)
    If (ly == 1_t_int) kout(2_t_int) = 1_t_int-kout(2_t_int)
    If (lz == 1_t_int) kout(3_t_int) = 1_t_int-kout(3_t_int)
    
  End Subroutine mxmymz
  !!***********************************************************************
  !!***********************************************************************
!!NOTUSED  Subroutine symlat(nsymop,lattice_vectors,symopm)
!!NOTUSED    !!- calculates the point symmetry operations of the lattice
!!NOTUSED    !! ----------------------------------------------------------------------
!!NOTUSED    !! Inputs:
!!NOTUSED    !!   lattice_vectors: lattice vectors of most compact primitive unit cell
!!NOTUSED    !! Outputs:
!!NOTUSED    !!   nsymop: number of allowed symmetry operations
!!NOTUSED    !!   symopm: symmetry operation matrix
!!NOTUSED    !! Remarks:
!!NOTUSED    !!   symlat analyzes the primitive translations of the bravais
!!NOTUSED    !!   lattice in order to supply the symmetry operations of the lattice.
!!NOTUSED    !!   It gives the number nsymop of allowed operations as well as 
!!NOTUSED    !!   these operations themselves.
!!NOTUSED    !! ----------------------------------------------------------------------
!!NOTUSED    Implicit None
!!NOTUSED    !!IO
!!NOTUSED    Integer(long),Intent(out) ::  nsymop
!!NOTUSED    Real(t_real),Intent(in)   ::  lattice_vectors(3,3)
!!NOTUSED    Real(t_real),Intent(out)  :: symopm(9,48)
!!NOTUSED    !!LOCAL
!!NOTUSED    Integer(long) :: i,m,m1,m2,m3,idum
!!NOTUSED    Integer(long),Parameter :: ltmax=3,ll1=ltmax*2+1
!!NOTUSED    Integer(long),Parameter :: nrot(4)=(/2,3,4,6/)
!!NOTUSED    Real(t_real) :: platt(3,3),qlatcp(3,3),mat(3,3),vecg(3),vol
!!NOTUSED    Logical(t_log) :: lirr,ldum
!!NOTUSED    !!
!!NOTUSED    Call dinv33(lattice_vectors,1,qlatcp,vol)
!!NOTUSED    vecg=0.0_t_real
!!NOTUSED    idum=1
!!NOTUSED    Call rotmat(-1,.False.,ldum,1,idum,symopm(1,1),vecg)
!!NOTUSED    Call rotmat(-1,.True. ,ldum,1,idum,symopm(1,2),vecg)
!!NOTUSED    nsymop=2
!!NOTUSED    !! --- find all possible rotation axis
!!NOTUSED    Do i=0,(ll1**3-1)/2-1
!!NOTUSED       m1=ltmax-(Mod(i,ll1**1)-Mod(i,ll1**(1-1)))/ll1**(1-1)
!!NOTUSED       m2=ltmax-(Mod(i,ll1**2)-Mod(i,ll1**(2-1)))/ll1**(2-1)
!!NOTUSED       m3=ltmax-(Mod(i,ll1**3)-Mod(i,ll1**(3-1)))/ll1**(3-1)
!!NOTUSED       lirr=.True.
!!NOTUSED       Do m=2,ll1
!!NOTUSED          lirr=lirr.And.(Mod(m1,m) /= 0 .Or. Mod(m2,m) /= 0 .Or. &
!!NOTUSED               & Mod(m3,m) /= 0) 
!!NOTUSED       Enddo
!!NOTUSED       If (lirr) Then
!!NOTUSED          Do m=1,3
!!NOTUSED             vecg(m)=m1*lattice_vectors(m,1)+m2*lattice_vectors(m,2) &
!!NOTUSED                  & +m3*lattice_vectors(m,3)
!!NOTUSED          Enddo
!!NOTUSED          Do m=1,4
!!NOTUSED             !! create the matrix of the symmetry operation
!!NOTUSED             Call rotmat(-1,.False.,ldum,nrot(m),idum,mat,vecg)
!!NOTUSED             platt=Matmul(mat,lattice_vectors)
!!NOTUSED             !! check the primitive translations for the symmetry operations
!!NOTUSED             If (islatvec(3,qlatcp,platt)) Then
!!NOTUSED                Call rotmat(-1,.False.,ldum,nrot(m),idum,symopm(1,nsymop+1),vecg)
!!NOTUSED                Call rotmat(-1,.True. ,ldum,nrot(m),idum,symopm(1,nsymop+2),vecg)
!!NOTUSED                nsymop=nsymop+2
!!NOTUSED                If (m /= 1) Then
!!NOTUSED                   Call rotmat(-1,.False.,ldum,-nrot(m),idum,symopm(1,nsymop+1),vecg)
!!NOTUSED                   Call rotmat(-1,.True. ,ldum,-nrot(m),idum,symopm(1,nsymop+2),vecg)
!!NOTUSED                   nsymop=nsymop+2
!!NOTUSED                Endif
!!NOTUSED             Endif
!!NOTUSED          Enddo
!!NOTUSED       Endif
!!NOTUSED    Enddo
!!NOTUSED    If (outlevel >= L_more) Write(outfile,300) nsymop
!!NOTUSED    
!!NOTUSED300 Format(/' SYMLAT: lattice invariant under ',i2, &
!!NOTUSED         & ' symmetry operations.')
!!NOTUSED  End Subroutine symlat
!!NOTUSED  !!***********************************************************************
!!NOTUSED  Logical(t_log) Function islatvec(n,qb,vec)
!!NOTUSED    !!- Checks if a set of vectors are lattice vectors
!!NOTUSED    !! ----------------------------------------------------------------------
!!NOTUSED    !! Inputs:
!!NOTUSED    !!   n     : number of vectors
!!NOTUSED    !!   qb    : primitive translation vectors in reciprocal space
!!NOTUSED    !!   vec   : vector
!!NOTUSED    !! Outputs:
!!NOTUSED    !!   latvec:.true. if all vectors are lattice vectors
!!NOTUSED    !! Remarks:
!!NOTUSED    !! ----------------------------------------------------------------------
!!NOTUSED    Implicit None
!!NOTUSED    !!IO
!!NOTUSED    Integer(long),Intent(in) :: n
!!NOTUSED    Real(t_real),Intent(in)  :: qb(3,3),vec(3,n)
!!NOTUSED    !!LOCAL
!!NOTUSED    Integer(long) :: i,m
!!NOTUSED    Real(t_real)  :: vdiff
!!NOTUSED    Real(t_real),Parameter   :: tol=1.e-3_t_real
!!NOTUSED    
!!NOTUSED    islatvec=.False.
!!NOTUSED    Do i=1,n
!!NOTUSED       Do m=1,3
!!NOTUSED          vdiff=Sum(vec(:,i)*qb(:,m))
!!NOTUSED          vdiff=Abs(vdiff-Anint(vdiff,t_real))
!!NOTUSED          If (vdiff > tol) Return
!!NOTUSED       Enddo
!!NOTUSED    Enddo
!!NOTUSED    islatvec=.True.
!!NOTUSED  End Function islatvec
!!NOTUSED  !!***********************************************************************

  !!***********************************************************************
  !!- Determines Fermi enery and weight of k-points for BZ-integration
  !! ----------------------------------------------------------------------
  !!i Inputs:
  !!i   bk    :irreducible k-point 
  !!i   ebk   :energy bands, eigenvalue of Hamiltonian
  !!i   tet   :(from TETIRR) tet(0,i) =no of tetrahedra of the i'th kind
  !!i   lafm  :switch for antiferromagnetic structures
  !!i   nband :number of relevant bands 
  !!i   nvdim :dimension of ebk
  !!i   metal :logical switch, if .false. => insulator or semiconductor
  !!i   nkp   :number of irreducible k-points
  !!i   mp_norder:Methfessel-Paxton order parameter (only for sampling)
  !!i   mp_ne  :number of DOS tabulation points
  !!i   nspin :=1 for non-spin-polarized =2 for spin-polarized calculations
  !!    nspin :=1 for relativistic case
  !!i   ntet  :number of different tetrahedra (output from TETIRR)
  !!i   mp_range :range/W of integrating (only for sampling)
  !!i   bzone_method :  integration method
  !!i   mp_width :Methfessel-Paxton width parameter (only for sampling)
  !!i   wbk   :weight of k-point, including spin degeneracy (from BZMESH)
  !!i   zval  :valence charge
  !!i   fsm   : fixed spin moment
  !!i   fsm_moment  : fixed spin moment magnetization
  !!o Outputs:
  !!o   bweitk  :band and E_F - dependent k-point weights for integration
  !!o   ebmax :highest eigenvalue found
  !!o   ebmin :lowest eigenvalue found
  !!o   efermi:Fermi energy
  !!r Remarks:
  !! ----------------------------------------------------------------------
  Subroutine det_bandweights(bzone,bweitk,ebk,ebkfsm,Mnn,efermi,Bfsm,dBfsm&
       &,lafm,nband,nkp,mspin,nspin&
       & ,tolef,zval,fsm,fsm_moment,nvdim,bandenergy,Eent,rel,bandplot&
       &,lattice_vectors,numops,opmat,vuc,dbweitk,calcfermisurfaceweights&
       &,calc_plasmon)
    Implicit None
    !!IO
    Type(T_Bzone),Intent(inout) :: bzone 
    Type(T_Bandplot),Intent(inout) :: bandplot 
    Logical(t_log),Intent(in)   :: lafm,fsm,rel,calcfermisurfaceweights
    Logical(t_log),Intent(in)   :: calc_plasmon
    Integer(t_int),Intent(in)   :: nband,nkp
    Integer(t_int),Intent(in)   :: mspin,nspin,nvdim,numops
    Real(t_real),Intent(in)     :: opmat(3,3,48),vuc
    Real(t_real),Intent(in)     :: lattice_vectors(3,3)
    Real(t_real),Intent(in)     :: tolef
    Real(t_real),Intent(in)     :: zval,fsm_moment
    Real(t_real),Intent(inout)  :: ebk(nvdim,nkp,nspin)
    Real(t_real),Intent(inout)  :: ebkfsm(nvdim,nkp,nspin)
    Real(t_real),Intent(in)     :: Mnn(:,:)
    Real(t_real),Intent(out)    :: bandenergy(2)
    Real(t_real),Intent(out)    :: Eent(2)
    Real(t_real),Intent(out)    :: efermi,Bfsm,dBfsm
    Real(t_real),Intent(out)    :: bweitk(nband,nkp,nspin)    
    Real(t_real),Intent(out)    :: dbweitk(nband,nkp,nspin)
    !!LOCAL 
    Character(*),Parameter::nsubfunc="det_bandweights"
    Logical(t_log) :: plot
    Integer(t_int) :: ib,ikp,ms,io(2),iu(2),nmin
    Real(t_real)  :: dosef,e1,e2,ef1,ef2,eo(2),eu(2),octol,beta
    Real(t_real)  :: ebmax,ebmin,spinfac,dq,efs(2)
    Integer(t_int),Parameter  ::  nptdos=101_t_int
    Real(t_real)  :: nos(nptdos)
    !!
    !!
    Call watch('det_bandweights',cpu_start,reset=.True.)
    !!
    Eent(1:2)=0.0_t_real
    dBfsm=0.0_t_real
    !!
    spinfac=2.0_t_real/nspin
    if(rel) spinfac=1.0_t_real
    !! --- copy spin-up into spin down
    !! not yet tested
    If (lafm) Then
       Do ikp=1_t_int,nkp
          Do ib=1_t_int,nband
             ebk(ib,ikp,2_t_int)=ebk(ib,ikp,1_t_int)
          Enddo
       Enddo
    Endif
    
    !! --- Locate band limits ---
    Call ef_range(bzone% p_bk,e1,e2,ebk,ebmax,ebmin,nband,nkp,nspin,zval,fsm&
         &,nvdim,rel,bzone% gammapoint)


    !! ----Informations whether switch metal was chosen correctly
    efermi = Min(e1,e2)

    If (e1 >= e2) Then
       !! ef in gap
       If (bzone% metal .And. outlevel > L_info) Write(outfile,300)
       If (bzone% metal .And. bzone% method /= BZ_TETRAHEDRON_METHOD) Then
          Call errmsg(nmodule,nsubfunc,E_warning&
               &,msg="'Fermi energy in gap : expect errors in moments',/&
               &,' use tetrahedron method or set metal=false.'")
       Endif
    Elseif (.Not.bzone% metal .And. .not.bzone% gammapoint) Then
       Call errmsg(nmodule,nsubfunc,E_warning&
            &,msg="'partialy filled bands encountered',/&
            &,' expect serious errors from Fermi cut-off.',/&
            &,' set metal=true.'")

    Endif

    !!
    !! -- integration methods
    !!
    gammaif: If(bzone% gammapoint) Then
       !!
       beta=1.0_t_real/(Max(bzone% kTcur,1.0e-6_t_real)&
            &/(eVtokT*hatoev))
       !!
       gammafsmif: If(.Not.fsm)Then 
          !!
          
          !!
          If (e2 < e1) Then
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="'Gamma-point calculation: energy window invalid?!?'")
          Else
             !!             --------- determine fermi energy
             If (outlevel > L_info) Write(outfile,303)
             !!
             e1=e1-(e2-e1)*0.1
             e2=e2+(e2-e1)*0.1
             If(e2<=e1+1.0e-4_t_real) Then
                e2=e2+1.0_t_real
                e1=e1-1.0_t_real
             Endif
             !!
             !!

             !!
             plot=debugfun(nmodule,nsubfunc,'PLOT_NOS')
             Call gamnos(ebk,e2,e1,nband,nkp,nos&
                  &,nptdos,1_t_int,nspin,nspin,nvdim,spinfac,beta,plot)
             !!
             dosef=0.0_t_real
             Do While (e2-e1 >= tolef)
                
                Call gamnos(ebk,e2,e1,nband,nkp,nos&
                     &,nptdos,1_t_int,nspin,nspin,nvdim,spinfac,beta&
                     &,.False.)
                Call tfermi(dosef,e1,e2,efermi,nptdos,nos,zval&
                     &,.False.)
                If (outlevel > L_info) Then
                   If(dosef>1.0e5_t_real)Then
                      Write(outfile,3041) efermi,e1,e2,e2-e1,dosef
                   Else
                      Write(outfile,304) efermi,e1,e2,e2-e1,dosef
                   Endif
                Endif
             Enddo
             If (outlevel > L_info) Then
                If(dosef>1.0e5_t_real)Then
                   Write(outfile,3051) dosef
                Else
                   Write(outfile,305) dosef
                Endif
             Endif
          Endif
          Bfsm=0.0_t_real
          dBfsm=0.0_t_real

          Call gamwts(fsm,bweitk,ebk,efermi,Bfsm,dBfsm,nband,nkp,nspin,zval&
               &,nvdim,bandenergy,Eent,spinfac,beta,calcfermisurfaceweights&
               &,dbweitk)
          !!
          Goto 3000
          !!
       Else gammafsmif
          !!
          If(mspin == 1_t_int) Then
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="'fixed spin moment needs mspin=2 !'")
          Endif
          !!
          gammafsmrelif: If(rel) Then
             !!
             !!
             Call detBFsmRel('gamma',ebk,Mnn,efermi&
                  !&,Bfsm&
                  &,dBfsm,zval,fsm_moment&
                  &,bzone,beta)
             !!
             ebkfsm(:,:,1)=ebk(:,:,1)+dBfsm*Mnn(:,:)
             !!
             Bfsm=Bfsm+dBfsm
             !!
             Call gamwts(fsm,bweitk,ebkfsm,efermi,Bfsm,dBfsm,nband,nkp,nspin&
                  &,zval,nvdim,bandenergy,Eent,spinfac,beta&
                  &,calcfermisurfaceweights,dbweitk,Mnn)
             !!
          Else  gammafsmrelif
             !!
             Do ms=1_t_int,nspin
                ef2=e2
                ef1=e1
                
                If (ef2 < ef1) Then
                   Call errmsg(nmodule,nsubfunc,E_fatalerror&
                        &,msg="'Gamma-point calculation: energy window invalid?!?'")
                Else
                   !!             --------- determine fermi energy
                   If (outlevel > L_info) Write(outfile,303)
                   !!
                   ef1=ef1-(ef2-ef1)*0.1
                   ef2=ef2+(ef2-ef1)*0.1
                   If(ef2<=ef1+1.0e-4_t_real) Then
                      ef2=ef2+1.0_t_real
                      ef1=ef1-1.0_t_real
                   Endif
                   !!
                   !!
                   !!
                   plot=debugfun(nmodule,nsubfunc,'PLOT_NOS')
                   Call gamnos(ebk,ef2,ef1,nband,nkp,nos&
                        &,nptdos,1_t_int,nspin,nspin,nvdim,spinfac,beta,plot)
                   !!
                   dosef=0.0_t_real 
                   Do While (ef2-ef1 >= tolef)
                      
                      Call gamnos(ebk,ef2,ef1,nband,nkp,nos&
                           &,nptdos,ms,ms,nspin,nvdim,spinfac,beta&
                           &,plot)
                      Call tfermi(dosef,ef1,ef2,efs(ms),nptdos&
                           &,nos,(zval+fsm_moment*(3_t_int-2_t_int*ms))*0.5_t_real&
                           &,.False.)
                      If (outlevel > L_info) Then
                         If(dosef>1.0e5_t_real)Then
                            Write(outfile,3041) efs(ms)&
                                 &,ef1,ef2,ef2-ef1,dosef
                         Else
                            Write(outfile,304) efs(ms)&
                                 &,ef1,ef2,ef2-ef1,dosef
                         Endif
                      Endif
                   Enddo
                   If (outlevel > L_info) Then
                      If(dosef>1.0e5_t_real)Then
                         Write(outfile,3051) dosef
                      Else
                         Write(outfile,305) dosef
                      Endif
                   Endif
                Endif
             End Do    !! ms
             !!
             efermi=(efs(1)+efs(2))*0.5_t_real
             Bfsm=(efs(2)-efs(1))*0.5_t_real
             dBfsm=0.0_t_real
             !!
             ebkfsm(:,:,1)=ebk(:,:,1)+Bfsm
             ebkfsm(:,:,2)=ebk(:,:,2)-Bfsm
             !!
             Call gamwts(fsm,bweitk,ebkfsm,efermi,Bfsm,dBfsm,nband,nkp,nspin&
                  &,zval,nvdim,bandenergy,Eent,spinfac,beta&
                  &,calcfermisurfaceweights,dbweitk)
             !!
          Endif gammafsmrelif
          !!
          Goto 3000
          !!
       End If gammafsmif
       
    End If gammaif
    !!
    metalif: If (.Not. bzone% metal) Then
       If(fsm) Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'fixed spin moment not implemented for this ',/&
               &,' k-integration method!'")
       Endif
       !!
       Call inswts(bweitk,ebk,efermi,nband,nkp,nspin,bzone% p_wbk&
            &,nvdim,spinfac,bandenergy)
       !!
       If (outlevel > L_info) Write(outfile,301)efermi

    Else metalif
       !! ----- metal branch, make occupation-number weights
       tetif: If (bzone% method == BZ_TETRAHEDRON_METHOD) Then
          !! ------- Tetrahedron method branch ---
          If (outlevel > L_info) Write(outfile,302)
          
          tetfsmif: If(.Not.fsm)Then

             !Print *,'e1=',e1
             !Print *,'e2=',e2
             If(e2<=e1+1.0e-4_t_real) Then
                e2=Max(e1,e2)+1.0_t_real
                e1=Min(e1,e2)-1.0_t_real
             Endif


             If (e2 > e1) Then
                !!             --------- determine fermi energy
                If (outlevel > L_info) Write(outfile,303)
                
                

                dosef=0.0_t_real 
                Do While (e2-e1 >= tolef)
                   
                   Call tetnos(ebk,e2,e1,bzone% p_tet,nband,nkp,nos&
                        &,nptdos,1_t_int,nspin,nspin,bzone% ntet&
                        &,bzone% ntetsum,nvdim,spinfac)
                   Call tfermi(dosef,e1,e2,efermi,nptdos,nos,zval&
                        &,.True.)
                   If (outlevel > L_info) &
                        & Write(outfile,304) efermi,e1,e2,e2-e1,dosef
                Enddo
                If (outlevel > L_info) Write(outfile,305) dosef
             Endif
             Bfsm=0.0_t_real
             dBfsm=0.0_t_real

             Call tetwts(fsm,bzone,bweitk,ebk,efermi,Bfsm,dBfsm,nband,nkp&
                  &,nspin,zval,nvdim,bandenergy,spinfac&
                  &,calcfermisurfaceweights,dbweitk)

             If(calc_plasmon) Then
                Call plasmonfreg(bzone,ebk,efermi,nband,nkp,nspin&
                     &,nvdim,spinfac,lattice_vectors,numops,opmat,vuc)
             Endif


             
          Else tetfsmif
             !!
             If(mspin == 1_t_int) Then
                Call errmsg(nmodule,nsubfunc,E_fatalerror&
                     &,msg="'fixed spin moment needs mspin=2 !'")
             Endif
             !!
             tetfsmrelif: If(rel) Then
                !!
                Call detBFsmRel('tet',ebk,Mnn,efermi&
                     !&,Bfsm&
                     &,dBfsm,zval,fsm_moment&
                     &,bzone,beta)
                !!
                ebkfsm(:,:,1)=ebk(:,:,1)+dBfsm*Mnn(:,:)
                !!
                !!
                Bfsm=Bfsm+dBfsm
                !!
                Call tetwts(fsm,bzone,bweitk,ebkfsm,efermi,Bfsm,dBfsm,nband&
                     &,nkp,nspin,zval,nvdim,bandenergy,1.0_t_real&
                     &,calcfermisurfaceweights,dbweitk,Mnn)
                !!
                If(calc_plasmon) Then
                   Call plasmonfreg(bzone,ebkfsm,efermi,nband,nkp,nspin&
                        &,nvdim,spinfac,lattice_vectors,numops,opmat,vuc)
                Endif
                !!
             Else tetfsmrelif
                Do ms=1_t_int,nspin
                   ef2=e2
                   ef1=e1
                   If (ef2 > ef1) Then
                      !! --------- determine fermi energy
                      If (outlevel > L_info) Write(outfile,303)
                      dosef=0.0_t_real 
                      Do While (ef2-ef1 >= tolef)
                         Call tetnos(ebk,ef2,ef1,bzone% p_tet,nband,nkp,nos&
                              &,nptdos,ms,ms,nspin,bzone% ntet&
                              &,bzone% ntetsum,nvdim,spinfac)
                         Call tfermi(dosef,ef1,ef2,efs(ms),nptdos&
                              &,nos&
                              &,(zval+fsm_moment*(3_t_int-2_t_int*ms))&
                              &  *0.5_t_real&
                              &,.True.)
                         
                         If (outlevel > L_info) &
                              & Write(outfile,304) efs(ms),ef1,ef2,ef2-ef1&
                              &,dosef
                      Enddo
                      If (outlevel > L_info) Write(outfile,305) dosef
                   Endif
                Enddo               ! ms
                efermi=(efs(1)+efs(2))*0.5_t_real
                Bfsm=(efs(2)-efs(1))*0.5_t_real
                dBfsm=0.0_t_real
                !!
                ebkfsm(:,:,1)=ebk(:,:,1)+Bfsm
                ebkfsm(:,:,2)=ebk(:,:,2)-Bfsm
                !!
                Call tetwts(fsm,bzone,bweitk,ebkfsm,efermi,Bfsm,dBfsm,nband&
                     &,nkp,nspin,zval,nvdim,bandenergy,spinfac&
                     &,calcfermisurfaceweights,dbweitk)
                
                If(calc_plasmon) Then
                   Call plasmonfreg(bzone,ebkfsm,efermi,nband,nkp,nspin&
                        &,nvdim,spinfac,lattice_vectors,numops,opmat,vuc)
                Endif
             Endif tetfsmrelif
          Endif tetfsmif
       Else  tetif
          !! ------- BZ - sampling branch
          If (outlevel > L_info) Write (outfile,306)bzone% mp_norder&
               &,bzone% mp_width
          fsmisp: If(.Not.fsm)Then
             
             If(e2<=e1+1.0e-4_t_real) Then
                e2=Max(e1,e2)+1.0_t_real
                e1=Min(e1,e2)-1.0_t_real
             Endif
             
             
             If (e2 > e1) Then
                !! --------- determine fermi energy
                
                
                If (outlevel > L_info) Write(outfile,303)
                
                dosef=0.0_t_real 
                Do While (e2-e1 >= tolef)
                   
                   nmin=Int(10.0_t_real*(e2-e1)/bzone% mp_width+1,t_int)
                   !Print *,'Nmin=',nmin
                   
                   dq=0.0_t_real 
                   If(nptdos<nmin) Then
                      dq=bzone% mp_width*3.0_t_real
                   Endif
                   
                   !Print *,'dq=',dq
                   
                   Call splnos(ebk,e2,e1,nband,nkp,bzone% mp_norder,nos&
                        &,nptdos,1_t_int,nspin,nspin,bzone% mp_width&
                        &,bzone% p_wbk,nvdim,spinfac)
                   
                   !Print *,'zval=',zval
                   Call sfermi(dosef,e1,e2,efermi,nptdos,nos,zval)
                   !Print *,'efermi=',efermi(1)
                   !Print *,'dosef=',dosef
                   !Print *,'tolef=',tolef
                   
                   e1=e1-dq
                   e2=e2+dq
                   
                   If (outlevel > L_info) &
                        & Write(outfile,304) efermi,e1,e2,e2-e1,dosef
                   !Pause
                Enddo
                If (outlevel > L_info) Write(outfile,305) dosef
             Endif
             Bfsm=0.0_t_real
             dBfsm=0.0_t_real

             Call splwts(fsm,bzone,bweitk,ebk,efermi,Bfsm,dBfsm,nband,nkp&
                  &,nspin,nvdim,spinfac,zval,bandenergy&
                  &,calcfermisurfaceweights,dbweitk)
             If(calc_plasmon) Then
                Call errmsg(nmodule,nsubfunc,E_fatalerror&
                     &,msg="'plasma frequencies only available with &
                     &tetrahedron method!'")
             Endif
          Else fsmisp
             If(mspin == 1_t_int) Then
                Call errmsg(nmodule,nsubfunc,E_fatalerror&
                     &,msg="'fixed spin moment needs mspin=2 !'")
             Endif
             spfsmrelif: If(rel) Then

                Call detBFsmRel('mp',ebk,Mnn,efermi&
                     !&,Bfsm&
                     &,dBfsm,zval,fsm_moment&
                     &,bzone,beta)
                !!
                ebkfsm(:,:,1)=ebk(:,:,1)+dBfsm*Mnn(:,:)
                !!
                !!
                Bfsm=Bfsm+dBfsm
                !!
                Call splwts(fsm,bzone,bweitk,ebkfsm,efermi,Bfsm,dBfsm,nband&
                     &,nkp,nspin,nvdim,1.0_t_real,zval,bandenergy&
                     &,calcfermisurfaceweights,dbweitk,Mnn)
             
                If(calc_plasmon) Then
                   Call errmsg(nmodule,nsubfunc,E_fatalerror&
                        &,msg="'plasma frequencies only available with &
                        &tetrahedron method!'")
                Endif
                !!
             Else spfsmrelif
                Do ms=1_t_int,nspin
                   ef2=e2
                   ef1=e1
                   If (ef2 > ef1) Then
                      !! --------- determine fermi energy
                      If (outlevel > L_info) Write(outfile,303)
                      dosef=0.0_t_real 
                      Do While (ef2-ef1 >= tolef)
                         nmin=Int(10.0_t_real*(ef2-ef1)/bzone% mp_width+1,t_int)
                         !Print *,'Nmin=',nmin
                         
                         dq=0.0_t_real 
                         If(nptdos<nmin) Then
                            dq=bzone% mp_width*3.0_t_real
                         Endif
                         
                         !Print *,'dq=',dq
                         
                         Call splnos(ebk,ef2,ef1,nband,nkp,bzone% mp_norder&
                              &,nos,nptdos,ms,ms,nspin,bzone% mp_width&
                              &,bzone% p_wbk,nvdim,spinfac)
                         
                         
                         !Print *,'zval=',zval
                         Call sfermi(dosef,ef1,ef2,efs(ms),nptdos,nos&
                              &,(zval+fsm_moment*(3_t_int-2_t_int*ms))&
                              &*0.5_t_real)
                         !Print *,'efermi=',efermi(1)
                         !Print *,'dosef=',dosef
                         !Print *,'tolef=',tolef
                         
                         ef1=ef1-dq
                         ef2=ef2+dq
                         
                         If (outlevel > L_info) &
                              & Write(outfile,304) efs(ms),ef1,ef2,ef2-ef1&
                              &,dosef
                      Enddo
                      If (outlevel > L_info) Write(outfile,305) dosef
                   Endif
                Enddo               ! ms
                efermi=(efs(1)+efs(2))*0.5_t_real
                Bfsm=(efs(2)-efs(1))*0.5_t_real
                dBfsm=0.0_t_real

                ebkfsm(:,:,1)=ebk(:,:,1)+Bfsm
                ebkfsm(:,:,2)=ebk(:,:,2)-Bfsm
                Call splwts(fsm,bzone,bweitk,ebkfsm,efermi,Bfsm,dBfsm,nband&
                     &,nkp,nspin,nvdim,spinfac,zval,bandenergy&
                     &,calcfermisurfaceweights,dbweitk)
             
                If(calc_plasmon) Then
                   Call errmsg(nmodule,nsubfunc,E_fatalerror&
                        &,msg="'plasma frequencies only available with &
                        &tetrahedron method!'")
                Endif
             Endif spfsmrelif
             
          End If fsmisp
          
       Endif tetif
       !! ----- end of metal branch
    Endif metalif
    
3000 Continue


    If(fsm)Then
       If(rel) Then
          If(Abs(dBfsm)>1.0e-6_t_real)Then
             Call errmsg(nmodule,nsubfunc,E_warning&
                  &,msg="'The full relativisitc Fixed Spin Moment methods&
                  & seems',/,' to not yet have converged towards it''s &
                  &final B_fsm !'")
          Endif
       Endif
    Else
       Bfsm=0.0_t_real
    End If
    
 
    !!TODO: automatic tolerance determination, otherwise clash with xfsf
    !!      if bands too small
    octol=1.0e-4_t_real
    Do ms=1,nspin
       io(ms)=0_t_int
       eo(ms)=0.0_t_real
       ibloop1: Do ib=1,nvdim
          Do ikp=1,nkp
             If(ebkfsm(ib,ikp,ms)>=efermi+octol)Then
                Exit ibloop1
             Endif
          Enddo ! ikp
          io(ms)=ib
       Enddo ibloop1
       If(io(ms)>0)Then
          eo(ms)=Maxval(ebkfsm(io(ms),1:nkp,ms))
       Endif
       !!
       iu(ms)=nvdim+1_t_int
       eu(ms)=0.0_t_real
       ibloop2: Do ib=nvdim,1,-1
          Do ikp=1,nkp
             If(ebkfsm(ib,ikp,ms)<=efermi-octol)Then
                Exit ibloop2
             Endif
          Enddo ! ikp
          iu(ms)=ib
       Enddo ibloop2
       If(io(ms)<= nvdim)Then
          eu(ms)=Minval(ebkfsm(iu(ms),1:nkp,ms))
       Endif
    End Do ! ms
    !!
    !!
    bzone% highest_fully_occupied=Minval(io(1:nspin))
    bzone% lowest_fully_unoccupied=Maxval(iu(1:nspin))
    !!
    If(rel)Then
       Write(outfile,666) io(1),iu(1)
    Else
       Do ms=1,nspin
          Write(outfile,665) ms
          Write(outfile,666) io(ms),iu(ms)
       Enddo
    Endif
665 Format(' BANDWT: spin: ',i2)
666 Format(' BANDWT: highest fully occupied band : ',i5&
         &,/,' BANDWT: lowest fully unoccupied band: ',i5)
    !!
    Write(outfile,776) 
    If(nspin == 2)Then
       ms=1
       If(io(ms) == iu(ms)-1) Then
          Write(outfile,777) (eu(ms)-eo(ms))*hatoev
       Else
          Write(outfile,777) 0.0_t_real
       Endif
       ms=2
       If(io(ms) == iu(ms)-1) Then
          Write(outfile,778) (eu(ms)-eo(ms))*hatoev
       Else
          Write(outfile,778) 0.0_t_real
       Endif
       If( (io(1) == iu(1)-1) .And. (io(2) == iu(2)-1) ) Then
          !Print *,(eo(1)-efermi)*hatoev,(eu(1)-efermi)*hatoev
          !Print *,(eo(2)-efermi)*hatoev,(eu(2)-efermi)*hatoev
          Write(outfile,779) &
               &Max(0.0_t_real,(Min(eu(1),eu(2))-Max(eo(1),eo(2))))*hatoev
       Else
          Write(outfile,779) 0.0_t_real
       Endif
776       Format(' BANDWT: WARNING: Gap information is insecure! Check DOS.')
777       Format(' BANDWT: spin up   gap : ',f10.5,' eV')
778       Format(' BANDWT: spin down gap : ',f10.5,' eV')
779       Format(' BANDWT: total     gap : ',f10.5,' eV')
    Else
       If( (io(1) == iu(1)-1) ) Then
          Write(outfile,779) (eu(1)-eo(1))*hatoev
       Else
          Write(outfile,779) 0.0_t_real
       Endif
       
    Endif
    !!
    !! determine band index range fitting into an energy window
    !!
    !!
    If(bandplot% output_bands_in_window) Then
       !!todo: fsm rel
       Do ms=1,nspin
          io(ms)=0_t_int
          ibloop3: Do ib=1,nvdim
             Do ikp=1,nkp
                If(ebkfsm(ib,ikp,ms)-efermi>=bandplot% emin/hatoev+octol)Then
                   Exit ibloop3
                Endif
             Enddo ! ikp
             io(ms)=ib
          Enddo ibloop3
          !!
          iu(ms)=nvdim+1_t_int
          eu(ms)=0.0_t_real
          ibloop4: Do ib=nvdim,1,-1
             Do ikp=1,nkp
                If(ebkfsm(ib,ikp,ms)-efermi<=bandplot% emax/hatoev-octol)Then
                   Exit ibloop4
                Endif
             Enddo ! ikp
             iu(ms)=ib
          Enddo ibloop4
          !!
       Enddo
       !!
       bandplot% lowest_in_window=Minval(io(1:nspin))+1
       bandplot% highest_in_window=Maxval(iu(1:nspin))-1

       Write(outfile,1660) bandplot% emin,bandplot% emax
       Do ms=1,nspin
          If(.Not. rel) Write(outfile,1661) ms
          Write(outfile,1662) io(ms)+1,iu(ms)-1
       Enddo
1660   Format(/,' BANDWT: output energy window: [',f15.8,',',f15.8,']  eV')
1661   Format(' BANDWT: spin: ',i2)
1662   Format(' BANDWT: bands falling into this window: ',i8,'...',i8,' ')
    Else
       bandplot% lowest_in_window=1
       bandplot% highest_in_window=nvdim
    Endif
    !!
    !! --- Printout
    If (outlevel >= L_ALL) Then
       Write(outfile,307)
       Do ms=1_t_int,nspin
          Do ikp=1_t_int,nkp
             Write(outfile,308)(ikp,ib,bweitk(ib,ikp,ms)&
                  &,bzone% p_wbk(ikp),ib=1_t_int,nband)
1000         Format()
             Write(outfile,1000)
          Enddo
       Enddo
    Endif
    !!
    Call watch('det_bandweights',cpu_stop,delete=.True.,Print=.True.)
    !!
    Return
    !!
300 Format(/' BANDWT: only filled or empty bands encountered.')
301 Format(/' BANDWT: Non-metal sampling;', &
         & ' highest occ. eigenvalue :',f10.6)
302 Format( ' BANDWT: ---- Tetrahedron Integration ---- ')
303 Format( '              Estimating Fermi energy ...',&
         & /6x,'Estimate',13x,'Window',12x,'Tolerance',5x,'N(E_f)',&
         & /5x,66('-'))
304 Format(2f14.7,f12.7,d14.5,f14.6)
3041 Format(2f14.7,f12.7,d14.5,e14.2e3)
305 Format( ' BANDWT: Density of states at E_f:   N(E_f) =',f12.6,' states/Ha')
3051 Format( ' BANDWT: Density of states at E_f:   N(E_f) =',e12.2e3,' states/Ha')
306 Format( ' BANDWT: Brillouin Zone sampling; N =',i2,', W =',f6.3)
307 Format(/' BANDWT: IKP IBAND     BWEITK        WBK '/9x,35('-'))
308 Format(7x,2i5,2f13.8)

  End Subroutine det_bandweights
  !!***********************************************************************
  !!- Find range of Fermi energy.
  !! ----------------------------------------------------------------------
  !!i Inputs:
  !!i   bk    :irreducible k-point (from BZMESH)
  !!i   ebk :energy bands, eigenvalue of Hamiltonian
  !!i   nband  :number of bands
  !!i   nkp   :number of irreducible k-points (from BZMESH)
  !!i   nspin   :=1 spin degenerate or relativistic, =2 non-degenerate (nonrel)
  !!i   zval  :valence charge
  !!w Work arrays
  !!w   ebbot :(for spin-polarized case)
  !!w   ebtop :(for spin-polarized case)
  !!o Outputs:
  !!o   e1    :e1 < ef < e2
  !!o   e2    :e1 < ef < e2
  !!o   ebmax :highest eigenvalue found
  !!o   ebmin :lowest eigenvalue found
  !!r Remarks:
  !!r    For an even number of electrons ef is between the bottom of the
  !!r    zval/2+1'th band: e1, and the top of the zval/2 'th band: e2.
  !!r    If the former is higher that the latter we have an insulator
  !!r    (then e1 is set to e2).
  !!r    For an odd number of electrons ef is between the bottom and top
  !!r    of the (zval+1)/2 'th band.
  !!r    For spin polarized case: bottom of the zval+1'th band < ef <
  !!r                             top of the zval'th band.
  !!r                             If the bottom is higher that the top then
  !!r                             we have an insulator and e1=e2.
  !! ----------------------------------------------------------------------
  Subroutine ef_range(bk,e1,e2,ebk,ebmax,ebmin,nband,nkp &
       &,nspin,zval,fsm,nvdim,rel,gammapoint)
    Implicit None
    !!IO
    Logical(t_log),Intent(in)   :: fsm,rel,gammapoint
    Integer(t_int),Intent(in)   :: nspin,nkp,nband,nvdim
    Real(t_real),Intent(in)     :: bk(3,*),ebk(nvdim,nkp,nspin)
    Real(t_real),Intent(in)     :: zval
    Real(t_real),Intent(out)    :: ebmin,ebmax,e1,e2
    !!LOCAL
    Character(*),Parameter::nsubfunc="ef_range"
    Real(t_real)  :: ebbot(nband*nspin),ebtop(nband*nspin)
    Real(t_real)  :: eb
    Integer(t_int) :: iband,ikp,ikp1,ikp2,indx,ms,m,nval
    Integer(t_int) :: nbbot,nbtop,spinfac
    Logical(t_log) :: vca
    !!
    ikp1=1
    ikp2=1
    spinfac=2_t_int
    If(rel)spinfac=1_t_int
    !!
    vca=.False.
    nval = Nint(zval,t_int)
    If(Abs(nval-zval)>1.e-8_t_real)Then
       vca=.True.
       Write(outfile,100)nval,zval
    Endif
    
    If (outlevel >= L_all) Write(outfile,302)zval,nval,nband

    If (nval < 0_t_int) Then
       Write(errbuf,"('''nval=',i3,' negative, check nuclear charges.''')")nval
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg=errbuf)
    Endif
    If (nval > nband*spinfac) Then
       Write(errbuf,"('''nval=',i3,', nbands=spinfac*',i3,'=',i3,''',/&
            &,'' more electrons than bands!!''')")nval,nband,spinfac*nband
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg=errbuf)
    Endif

    !! --- Get ebmin and ebmax
    ebmin = Huge(1.0_t_real)
    ebmax = -ebmin
    Do  ikp = 1_t_int , nkp
       Do ms = 1_t_int, nspin
          If(ebk(1_t_int   ,ikp,ms) < ebmin)  ebmin=ebk(1_t_int   ,ikp,ms)
          If(ebk(nband,ikp,ms) > ebmax)  ebmax=ebk(nband,ikp,ms)
       Enddo
    Enddo
    If (outlevel >= L_info) Write(outfile,301)ebmin,ebmax
    relif: If(rel)Then
       e1=ebmin
       e2=ebmax
    Else relif
       !! --- nspin = 1 ---
       If (nspin == 1_t_int)Then
          If( (nval/2_t_int) * 2_t_int == nval) Then
             nbtop = nval / 2_t_int
             nbbot = nbtop + 1_t_int
          Else
             nbtop = nval / 2_t_int + 1_t_int
             nbbot = nbtop
          Endif
          If (outlevel >= L_ALL) Write(outfile,303)nbtop,nbbot
          e1 = Huge(1.0_t_real)
          e2 =-Huge(1.0_t_real)
          Do  ikp = 1_t_int , nkp
             If(ebk(nbtop,ikp,1_t_int) > e2) Then
                e2 = ebk(nbtop,ikp,1_t_int)
                ikp2=ikp
             Endif
          Enddo
          If (nbbot <= nband) Then
             Do  ikp = 1_t_int , nkp
                If(ebk(nbbot,ikp,1_t_int) < e1) Then
                   e1 = ebk(nbbot,ikp,1_t_int)
                   ikp1=ikp
                Endif
             Enddo
          Endif
       Elseif (nspin == 2_t_int) Then
          !! ----- nspin = 2 ---
          indx=0_t_int
          Do  ms = 1_t_int, nspin
             Do  iband = 1_t_int, nband
                indx=indx+1_t_int
                ebbot(indx) = Huge(1.0_t_real)
                ebtop(indx) =-Huge(1.0_t_real)
                Do  ikp = 1_t_int, nkp
                   eb=ebk(iband,ikp,ms)
                   If (eb < ebbot(indx)) ebbot(indx) =  eb
                   If (eb > ebtop(indx)) ebtop(indx) =  eb
                Enddo
             Enddo
          Enddo
          Call dshell(1_t_int,nband*nspin,ebbot,1.0e-12_t_real)
          Call dshell(1_t_int,nband*nspin,ebtop,1.0e-12_t_real)
          If( nval+1_t_int <= nband*nspin ) Then
             e1 = ebbot(nval+1_t_int)
          Else
             e1 = Huge(1.0_t_real)
          Endif
          e2 = ebtop(nval)
          If(fsm) Then
             !!         fixed spin moment (FMS)
             e1=ebmin
             e2=ebmax
          Endif                   ! fsm
       Endif                     ! nspin.eq.2  
    Endif relif
    !!
    If(gammapoint .Or. vca)Then
       e1=ebmin
       e2=ebmax
    Endif
    !!
    If (outlevel >= L_ALL) Write(outfile,304)e1,e2
    Write(outfile,304)e1,e2
    If(.Not.rel .And. nspin == 1_t_int)Then
       !! in other case ikp1 and ikp2 are not defined (ask Arthur Ernst
       !! or his coworkers !)
       If(e1 >= e2 .And. outlevel >L_info) &
            &Write(outfile,300)e1-e2,(bk(m,ikp1),m=1_t_int,3_t_int),(bk(m,ikp2),m=1_t_int,3_t_int)
    Endif

300 Format(/' EFRANG: Gap =',f6.3,' between k=',3f6.3,'  and  ',3f6.3)
301 Format( ' EFRANG: ebmin=',f12.7,',  ebmax=',f12.7)
302 Format( ' EFRANG: zval=',f5.1,',  nval=',i4,', nband=',i4)
303 Format( ' EFRANG: nbtop=',i4,', nbbot=',i4)
304 Format( ' EFRANG: e1=',f12.7,',  e2=',f12.7)
100 Format( ' EFRANG: virtual crystal approximation detected: nval=',i4,' !=  zval=',f15.8)

  End Subroutine ef_range
  !!***********************************************************************
  !!- Make weights for integrals under the Fermi surface for insulator
  !!-----------------------------------------------------------------------
  !!i  Input
  !!i   nkp   :number of irreducible k-points
  !!i   nband :number of bands
  !!i   nspin   :=1 spin degenerate or relativistic, =2 non-degenerate (nonrel)
  !!i   wbk  :weight of k-point, including spin degeneracy (from BZMESH)
  !!i   ebk :energy bands
  !!i   efermi:Fermi energy
  !!o  Output
  !!o   bweitk :band and E_F - dependent k-point weights for integration
  !!r  Remarks:
  !!   only for insulators !!
  !!-----------------------------------------------------------------------
  Subroutine inswts(bweitk,ebk,efermi,nband,nkp,nspin,wbk,nvdim,spinfac&
       &,bandenergy)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)   :: nkp,nband,nspin,nvdim
    Real(t_real),Intent(in)     :: wbk(*),ebk(nvdim,nkp,nspin),efermi
    Real(t_real),Intent(out)    :: bweitk(nband,nkp,nspin)
    Real(t_real),Intent(in)     :: spinfac
    Real(t_real),Intent(out)    :: bandenergy(2)
    !!LOCAL
    Integer(t_int) ::  ikp,iband,ms
    !!
    bandenergy(1:2)=0.0_t_real
    Do ikp = 1_t_int, nkp
       Do iband = 1_t_int, nband
          Do ms = 1_t_int, nspin
             If (ebk(iband,ikp,ms) > efermi) Then
                bweitk(iband,ikp,ms) = 0.0_t_real
             Else
                bweitk(iband,ikp,ms) = wbk(ikp)*spinfac
             Endif
             bandenergy(ms)=bandenergy(ms)+ebk(iband,ikp,ms)*bweitk(iband,ikp,ms)
          Enddo
       Enddo
    Enddo
  End Subroutine inswts
  !!***********************************************************************
  Subroutine detBFsmRel(what,ebk,Mnn,efermi&
       !&,Bfsmold&
       &,Bfsm,zval,fsm_moment,bzone&
       &,beta)
    !! for FREL FSM:
    !! find efermi and Bfsm such that IDOS(ef,B)=zval and 
    !!                                MDOS(ef,B)=fsm_moment
    !!
    !!
    Implicit None
    !!IO
    Type(T_Bzone),Intent(in)     :: bzone 
    Character(*),Intent(in)      :: what
    Real(t_real),Intent(in)      :: zval,fsm_moment
    Real(t_real),Intent(in)      :: ebk(:,:,:)
    Real(t_real),Intent(in)      :: Mnn(:,:)
    Real(t_real),Intent(in)      :: beta
    !Real(t_real),Intent(in)      :: Bfsmold
    Real(t_real),Intent(out)     :: efermi,Bfsm
    !!LOCAL
    Character(*),Parameter::nsubfunc="detBFsmRel"
    Integer(t_int) :: nvdim,nband,nkp
    Real(t_real)   :: B0,B1,Bm,Bnew,f0,f1,fm,fnew,emin,emax,s,N,M
!!$    Integer(t_int) :: NN,i !!todo: remove
!!$    Real(t_real)   :: e !!todo: remove
!!$    Character(200) :: word !!todo: remove
    !!
    nvdim=Size(ebk,1,t_int)
    nkp=Size(ebk,2,t_int)
    nband=Min(nvdim,Size(Mnn,1,t_int))
    !!
    emin=Minval(ebk)
    emax=Maxval(ebk)
    !!
    Bfsm=0.0_t_real
    !!
    B0=-(emax-emin)*2.5_t_real
    B1=(emax-emin)*2.5_t_real
    !!
    !!
    Call det_efermi_fsm_rel(what,zval,efermi,emin,emax,B0,N,M&
         &,ebk,Mnn,nvdim,nkp,bzone,beta,prot=.False.)
    f0=fsm_moment-M
    Call det_efermi_fsm_rel(what,zval,efermi,emin,emax,B1,N,M&
         &,ebk,Mnn,nvdim,nkp,bzone,beta,prot=.False.)
    f1=fsm_moment-M
    
    !Print *,'m0',B0,f0
    !Print *,'m1',B1,f1
    !
    !
100 Continue

    !! here we use that f is monotonous increasing
    If(f0>0.0_t_real)Then
       B0=B0-(emax-emin)*0.5_t_real
       Call det_efermi_fsm_rel(what,zval,efermi,emin,emax,B0,N,M&
            &,ebk,Mnn,nvdim,nkp,bzone,beta,prot=.False.)
       f0=fsm_moment-M
       If(B0<-(emax-emin)*10.And.f0>0.0_t_real)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'requested fsm moment is impossible'")
       Endif
       !Print *,'jump back B0 ',B0,f0
       Goto 100
    Elseif(f1<0.0_t_real)Then
       B1=B1+(emax-emin)*0.5_t_real
       Call det_efermi_fsm_rel(what,zval,efermi,emin,emax,B1,N,M&
            &,ebk,Mnn,nvdim,nkp,bzone,beta,prot=.False.)
       f1=fsm_moment-M
       If(B1>(emax-emin)*10.And.f1<0.0_t_real)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'requested fsm moment is impossible'")
       Endif
       !Print *,'jump back B1 ',B1,f1
       Goto 100
    Else If(f0==0.0_t_real)Then
       Bfsm=B0
    Else If(f1==0.0_t_real)Then
       Bfsm=B1
    Else If(f0<0.0_t_real .And. f1>0.0_t_real)Then
       Bfsm=Min(B0,B1)-Abs(b0+b1)*0.5_t_real
       fnew=1.0e33_t_real
       Write(outfile,3141)
       Do 
          !Print *
          !Print *,'m0',B0,f0
          !Print *,'m1',B1,f1
          Write(outfile,3142) Bfsm,Max(Abs(B1-Bfsm),Abs(B0-Bfsm)),fnew
          Bm=(B0+B1)*0.5_t_real
          If(Bm==B0) Then
             !Print *,'Bm==B0'
             Bfsm=Bm
             Exit
          Endif
          If(Bm==B1) Then
             !Print *,'Bm==B1'
             Bfsm=Bm
             Exit
          Endif
          !!
          Call det_efermi_fsm_rel(what,zval,efermi,emin,emax,Bm,N,M&
               &,ebk,Mnn,nvdim,nkp,bzone,beta,prot=.False.)
          fm=fsm_moment-M
          !Print *,'mm',Bm,fm
          If(fm==0.0_t_real)Then
             Bfsm=Bm
             !Print *,'fm=0'
             Exit
          Endif

          s=Sqrt(fm**2-f0*f1)
          !Print *,'s=',s
          If(s==0.0_t_real) Then
             !Print *,'s=0'
             Stop 's==0'
          Endif
          If(f0>=f1)Then
             Bnew=Bm+(Bm-B0)*fm/s
          Else
             Bnew=Bm-(Bm-B0)*fm/s
          Endif
          Bnew=Min(Max(Bnew,Min(b0,b1)),Max(b0,b1))
          !Print *,'Bnew',Bnew,Bfsm,Bnew-Bfsm
          If(Abs(Bnew-Bfsm)<=1.0e-14_t_real) Then
             Bfsm=Bnew
             !Print *,'Bnew==Bfsm'
             Exit
          Endif
          Bfsm=Bnew
          !Print *,'Bnew',Bnew
          If(Bnew==B0) Then
             !Print *,'Bnew==B0'
             Exit
          Endif
          If(Bnew==B1) Then
             !Print *,'Bnew==B1'
             Exit
          Endif
          Call det_efermi_fsm_rel(what,zval,efermi,emin,emax,Bfsm,N,M&
               &,ebk,Mnn,nvdim,nkp,bzone,beta,prot=.False.)
          fnew=fsm_moment-M
          !Print *,'mnew',Bfsm,fnew
          If(fnew==0.0_t_real)  Then
             !Print *,'fnew=0'
             Exit
          Endif
          !Print *,'test M new',Sign(fm,fsm_moment-Mnew),fm
          !Print *,'test L new',Sign(f0,fsm_moment-Mnew),f0
          !Print *,'test H new',Sign(f1,fsm_moment-Mnew),f1
          If(Sign(fm,fnew)/=fm)Then
             B0=Bm
             f0=fm
             B1=Bfsm
             f1=fnew
          Else If(Sign(f0,fnew)/=f0)Then
             B1=Bfsm
             f1=fnew
          Else If(Sign(f1,fnew)/=f1)Then
             B0=Bfsm
             f0=fnew
          Else
             Stop 'how did i get here'
          Endif
       Enddo
       If(b1>b0)Then
          !Bfsm=B0-f0/(f1-f0)*(B1-B0)
       Endif
    Else
       Print *,f0,f1
       Stop 'error'
    Endif

!!$    Open(12,file='+BME')
!!$    NN=200
!!$    B0=-0.2_t_real
!!$    B1= 0.2_t_real
!!$    Do i=1,NN
!!$       Bm=(B1-B0)*(i-1.0_t_real)/(NN-1.0_t_real)+B0
!!$       Call det_efermi_fsm_rel(what,zval,e,emin,emax,BM,N,M&
!!$            &,ebk,Mnn,nvdim,nkp,bzone,beta,prot=.False.)
!!$       Write(12,"(3(f30.15,1x))")Bfsmold+Bm,M,e
!!$    Enddo
!!$    Close(12)
!!$    !todo: make a M(Bfsm) picture Pause, Read user choice 


    !! now exactly at ef,Bfsm
    Call det_efermi_fsm_rel(what,zval,efermi,emin,emax,Bfsm,N,M&
         &,ebk,Mnn,nvdim,nkp,bzone,beta,prot=.True.)

!!$    Write(outfile,"('detBFsmRel: Bfsm=',f30.15,' Ef=',f30.15)")Bfsmold+Bfsm,efermi
    !Write(outfile,3143)
    !!
!!$    Write(outfile,"('enter Bfsm or enter: ')")
!!$    word=' '
!!$    !Read(*,"(a)")word
!!$    If(Len_trim(word)/=0)Then
!!$       Read(word,*)Bfsm
!!$       Bfsm=Bfsm-Bfsmold
!!$    Endif
!!$    !Bfsm=-0.030_t_real-Bfsmold
!!$    Print *,Bfsmold+Bfsm
!!$    !pause
    !!
    !Print *,'N,M=',N,M
    Return
    !!
3141 Format(46('-'),/,'   Field       Window          M',/&
          &,'     dB         width        error',/,46('-'))
3142 Format(f12.5,e12.4e3,1x,e12.4e3)
!3143 Format(46('-'),/)
    !!
  End Subroutine detBFsmRel
  !!***********************************************************************
  Subroutine det_efermi_fsm_rel(what,zval,ef,emin,emax,B,N,M&
       &,ebk,Mnn,nvdim,nkp,bzone,beta,prot)
    !!
    !! for a given B find mu such that IDOS(ef,B)-zval=0 -> ef(B)
    !! this gives M(ef(B),B)
    !!
    Implicit None
    !!IO
    Type(T_Bzone),Intent(in)     :: bzone 
    Logical(t_log),Intent(in)    :: prot
    Character(*),Intent(in)      :: what
    Integer(t_int),Intent(in)    :: nvdim,nkp
    Real(t_real),Intent(in)      :: emin,emax,B,beta,zval
    Real(t_real),Intent(in)      :: ebk(nvdim,nkp,1)
    Real(t_real),Intent(in)      :: Mnn(:,:)
    Real(t_real),Intent(out)     :: ef,N,M
    !!LOCAL
    Character(*),Parameter::nsubfunc="det_efermi_fsm_rel"
    Integer(t_int) :: in,ik
    Real(t_real)   :: mu1,mu2
    Real(t_real),Pointer :: ebkB(:,:,:)
    !!
    Nullify(ebkB)
    !!
    Call palloc('ebkB',ebkB,1_t_int,nvdim,1_t_int,nkp,1_t_int,1_t_int&
         &,nmodule,nsubfunc)
    !!
    Do ik=1,nkp
       Do in=1,nvdim
          ebkB(in,ik,1)=ebk(in,ik,1)+B*Mnn(in,ik)
       Enddo
    Enddo
    !!
    N=0.0_t_real
    !!
    !!
    mu2=emax+Abs(B)
    mu1=emin-Abs(B)
    !!
    !!
    Call detEf(what,ebkB,mu1,mu2,emin,emax,ef,N,M,1_t_int,zval,bzone,beta&
         &,prot,Mnn=Mnn)
    !!
    !!
    Call pfree(ebkB)
    !!
    Return
    !!
    !!
  End Subroutine det_efermi_fsm_rel
  !!***********************************************************************
  Subroutine detEf(what,ebk,e0,e1,emin,emax,efermi,N,M,ms,zval,bzone,beta,prot&
       &,Mnn)
    !!
    !! find efermi such that IDOS(ef)=zval and 
    !!
    !!
    Implicit None
    !!IO
    Type(T_Bzone),Intent(in)     :: bzone 
    Logical(t_log),Intent(in)    :: prot
    Character(*),Intent(in)      :: what
    Integer(t_int),Intent(in)    :: ms
    Real(t_real),Intent(in)      :: zval,e0,e1,emin,emax
    Real(t_real),Intent(in)      :: ebk(:,:,:)
    Real(t_real),Intent(in),Optional :: Mnn(:,:)
    Real(t_real),Intent(in)      :: beta
    Real(t_real),Intent(out)     :: efermi,N,M
    !!LOCAL
    Character(*),Parameter::nsubfunc="detBFsmRel"
    Integer(t_int) :: nvdim,nband,nkp,nspin
    Logical(t_log) :: relfsm
    Real(t_real)   :: ef0,ef1,efm,efnew,f0,f1,fm,fnew,s,dos
    !!
    relfsm=Present(Mnn)
    nvdim=Size(ebk,1)
    nkp=Size(ebk,2)
    nspin=Size(ebk,3)
    nband=nvdim
    !!
    !!
    efermi=0.0_t_real
    M=0.0_t_real
    N=0.0_t_real
    !!
    ef0=e0
    ef1=e1
    !!
    !!
    Call det_nos(what,ef0,ms,N,dos&
         &,ebk,nband,nvdim,nkp,nspin,bzone,beta)
    f0=N-zval
    Call det_nos(what,ef1,ms,N,dos&
         &,ebk,nband,nvdim,nkp,nspin,bzone,beta)
    f1=N-zval
    
    !Print *,'m0',ef0,f0
    !Print *,'m1',ef1,f1
    !!
    !!
100 Continue

    !! here we use that f is monotonous increasing
    If(f0>0.0_t_real)Then
       ef0=ef0-(emax-emin)*0.5_t_real
       Call det_nos(what,ef0,ms,N,dos&
            &,ebk,nband,nvdim,nkp,nspin,bzone,beta)
       f0=N-zval
       Print *,'jump back ef0 ',ef0,f0
       Goto 100
    Elseif(f1<0.0_t_real)Then
       ef1=ef1+(emax-emin)*0.5_t_real
       Call det_nos(what,ef1,ms,N,dos&
            &,ebk,nband,nvdim,nkp,nspin,bzone,beta)
       f1=N-zval
       If(ef1>emax+(emax-emin)*2.And.f1<0.0_t_real)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="'requested zval impossible'")
       Endif
       Print *,'jump back ef1 ',ef1,f1
       Goto 100
    Else If(f0==0.0_t_real)Then
       efermi=ef0
    Else If(f1==0.0_t_real)Then
       efermi=ef1
    Else If(f0<0.0_t_real .And. f1>0.0_t_real)Then
       efermi=Min(ef0,ef1)-Abs(ef0+ef1)*0.5_t_real
       fnew=1.0e33_t_real
       If(prot)Write(outfile,3141)
       Do 
          !Print *
          !Print *,'m0',ef0,f0
          !Print *,'m1',ef1,f1
          If(prot)Write(outfile,3142) efermi&
               &,Max(Abs(ef1-efermi),Abs(ef0-efermi)),fnew,dos
          efm=(ef0+ef1)*0.5_t_real
          If(efm==ef0) Then
             !Print *,'efm==ef0'
             efermi=efm
             Exit
          Endif
          If(efm==ef1) Then
             !Print *,'efm==ef1'
             efermi=efm
             Exit
          Endif
          !!
          Call det_nos(what,efm,ms,N,dos&
               &,ebk,nband,nvdim,nkp,nspin,bzone,beta)
          fm=N-zval
          !Print *,'mm',efm,fm
          If(fm==0.0_t_real)Then
             efermi=efm
             !Print *,'fm=0'
             Exit
          Endif

          s=Sqrt(fm**2-f0*f1)
          !Print *,'s=',s
          If(s==0.0_t_real) Then
             !Print *,'s=0'
             Stop 's==0'
          Endif
          If(f0>=f1)Then
            efnew=efm+(efm-ef0)*fm/s
          Else
            efnew=efm-(efm-ef0)*fm/s
          Endif
          efnew=Min(Max(efnew,Min(ef0,ef1)),Max(ef0,ef1))
          !Print *,'efnew',efnew,efermi,efnew-efermi
          If(Abs(efnew-efermi)<=1.0e-14_t_real) Then
             efermi=efnew
             !Print *,'efnew==efermi'
             Exit
          Endif
          efermi=efnew
          !Print *,'efnew',efnew
          If(efnew==ef0) Then
             !Print *,'efnew==ef0'
             Exit
          Endif
          If(efnew==ef1) Then
             !Print *,'efnew==ef1'
             Exit
          Endif
          Call det_nos(what,efermi,ms,N,dos&
               &,ebk,nband,nvdim,nkp,nspin,bzone,beta)
          fnew=N-zval
          !Print *,'mnew',efermi,fnew
          If(fnew==0.0_t_real)  Then
             !Print *,'fnew=0'
             Exit
          Endif
          !Print *,'test M new',Sign(fm,N-zvalnew),fm
          !Print *,'test L new',Sign(f0,N-zvalnew),f0
          !Print *,'test H new',Sign(f1,N-zvalnew),f1
          If(Sign(fm,fnew)/=fm)Then
             ef0=efm
             f0=fm
             ef1=efermi
             f1=fnew
          Else If(Sign(f0,fnew)/=f0)Then
             ef1=efermi
             f1=fnew
          Else If(Sign(f1,fnew)/=f1)Then
             ef0=efermi
             f0=fnew
          Else
             Stop 'how did i get here'
          Endif
       Enddo
       If(ef1>ef0)Then
          !efermi=ef0-f0/(f1-f0)*(ef1-ef0)
       Endif
    Else
       Print *,f0,f1
       Stop 'error'
    Endif


    !! now exactly at efermi
    Call det_nos(what,efermi,ms,N,dos&
         &,ebk,nband,nvdim,nkp,nspin,bzone,beta,M=M,Mnn=Mnn)
    
    If(prot)Write(outfile,3142) efermi&
         &,Max(Abs(ef1-efermi),Abs(ef0-efermi)),N-zval,dos

    If(prot)Write(outfile,3143)
    !!
    !!
    If (prot) Then
       If(dos>1.0e5_t_real)Then
          Write(outfile,3051) dos
       Else
          Write(outfile,305) dos
       Endif
    Endif
    
    !Print *,'N,M=',N,M
    !!
    Return
    !!
3141 Format(/,'              Estimating Fermi energy ...',/&
          &,46('-'),/,'   Efermi      Window          N        DOS(E_f)',/&
         &,'                width        error',/,46('-'))
3142 Format(f12.5,e12.4e3,1x,e12.4e3,2x,e12.4e3)
3143 Format(46('-'),/)
305 Format( ' BANDWT: Density of states at E_f:   N(E_f) =',f12.6,' states/Ha')
3051 Format( ' BANDWT: Density of states at E_f:   N(E_f) =',e12.2e3,' states/Ha')
    
    !!
  End Subroutine detEf
  !!***********************************************************************
  Subroutine det_nos(what,efermi,ms,N,dos&
       &,ebk,nband,nvdim,nkp,nspin,bzone,beta,M,Mnn)
    !!
    !!
    Implicit None
    !!IO
    Type(T_Bzone),Intent(in)     :: bzone 
    Integer(t_int),Intent(in)    :: ms
    Character(*),Intent(in)      :: what
    Integer(t_int),Intent(in)    :: nband,nvdim,nkp,nspin
    Real(t_real),Intent(in)      :: efermi,beta
    Real(t_real),Intent(in)      :: ebk(nvdim,nkp,nspin)
    Real(t_real),Intent(in),Optional :: Mnn(:,:)
    Real(t_real),Intent(out),Optional :: M
    Real(t_real),Intent(out)     :: N,dos
    !!LOCAL
    Character(*),Parameter::nsubfunc="det_nos"
    Logical(t_log) :: relfsm,nobloechl,calcM
    Integer(t_int) :: ikp,ib,itet,ikp1,ikp2,ikp3,ikp4
    Real(t_real)   :: exmax,x,f,volwgt,tetwgt,ecorn(4),Mcorn(4),wcorn(4,2)
    Real(t_real)   :: ds,ex,ddos,wt
    !!
    relfsm=Present(Mnn)
    calcM=Present(M)
    !!
    N=0.0_t_real
    dos=0.0_t_real
    If(calcM) M=0.0_t_real
    !!
    If(what=='gamma')Then
       !!
       exmax=(Log(Huge(1.0_t_real))-10.0_t_real)*0.5_t_real
       !!
       !!
       N=0.0_t_real
       !!
       ikp=1 ! single k-point = 0,0,0 assumed 
       !! ----- Loop over bands
       Do ib=1,nband
          !!
          !!
          x=beta*(ebk(ib,ikp,ms)-efermi)
          f=0.0_t_real
          ds=0.0_t_real
          If(x < -exmax) Then
             f=1.0_t_real
          Else If(x < exmax) Then
             ex=Exp(x)
             f=1.0_t_real/(ex+1.0_t_real)
             ds=f**2*ex*beta
          Endif
          N=N+f
          dos=dos+ds
          If(calcM)Then
             If(relfsm) M=M+f*Mnn(ib,ikp)
          Endif
       
       Enddo
       !!
    Else If(what=='tet')Then
       !!    
       nobloechl=debugfun(nmodule,nsubfunc,'NO_BLOECHL')
       !!
       !!
       volwgt=1.0_t_int/bzone% ntetsum
       !! --- Loop over tetrahedra
       Do itet=1,bzone% ntet
          ikp1=bzone% p_tet(1,itet)
          ikp2=bzone% p_tet(2,itet)
          ikp3=bzone% p_tet(3,itet)
          ikp4=bzone% p_tet(4,itet)
          tetwgt=volwgt*bzone% p_tet(0,itet)
          
          !! ----- Loop over bands
          Do ib=1,nband
             
             !! --------- SET UP ENERGIES AT 4 CORNERS OF TETRAHEDRA
             ecorn(1) = ebk(ib,ikp1,1)
             ecorn(2) = ebk(ib,ikp2,1)
             ecorn(3) = ebk(ib,ikp3,1)
             ecorn(4) = ebk(ib,ikp4,1)
             !!
             If(efermi<Minval(ecorn)) Cycle
             !!
             calcMif: If(calcM)Then
                If(Maxval(ecorn)<efermi) Then
                   N=N+tetwgt
                   If(relfsm)Then
                      Mcorn(1) = Mnn(ib,ikp1)
                      Mcorn(2) = Mnn(ib,ikp2)
                      Mcorn(3) = Mnn(ib,ikp3)
                      Mcorn(4) = Mnn(ib,ikp4)
                      M=M+tetwgt*Sum(Mcorn(:))*0.25_t_real
                   Endif
                   Cycle
                Endif
                !!
                Call fswgts(tetwgt,ecorn,efermi,wcorn,ddos)
                !!
                If(nobloechl) wcorn(:,2)=0.0_t_real
                !!
                N=N+Sum(wcorn(:,1)+wcorn(:,2))
                dos=dos+ddos
                If(relfsm)Then
                   Mcorn(1) = Mnn(ib,ikp1)
                   Mcorn(2) = Mnn(ib,ikp2)
                   Mcorn(3) = Mnn(ib,ikp3)
                   Mcorn(4) = Mnn(ib,ikp4)
                   M=M+Dot_product(wcorn(:,1)+wcorn(:,2),Mcorn(:))
                Endif
             Else calcMif 
                !!
                If(Maxval(ecorn)<efermi) Then
                   N=N+tetwgt
                   Cycle
                Endif
                !!
                Call tetidosatef(tetwgt,ecorn,efermi,N,dos)
                !!
                !!
             Endif calcMif
             !!
          Enddo ! ib
          !!
       Enddo ! itet
       !!
    Else If(what=='mp')Then
       !!
       Do ikp=1,nkp
          Do ib=1,nband
             wt=bzone% p_wbk(ikp)
             x=(efermi-ebk(ib,ikp,1))/bzone% mp_width
             Call delstp(ds,bzone% mp_norder,f,x)
             f=wt*(1.0_t_real-f)
             
             N=N+f
             dos=dos+wt*ds/bzone% mp_width
             If(calcM)Then
                If(relfsm) M=M+f*Mnn(ib,ikp)
             Endif
             
          Enddo
       Enddo
       !!
    Else
       Stop '''what'' is unknown'
    Endif
    !!
    !!
  End Subroutine det_nos
  !!***********************************************************************
  Subroutine tetidosatef(tetwgt,ecorn,efermi,N,dos)
    !!- calc IDOS at efermi for one tetra
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   tetwgt:weight of irreducible tetrahedron
    !!i   ecorn :energy of four corners of tetrahedron
    !!i   efermi:Fermi energy
    !!i   N : IDOS
    !!i   dos: DOS
    !!o Outputs:
    !!o   N : IDOS
    !!o   dos: DOS
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: tetwgt,ecorn(4),efermi
    Real(t_real),Intent(inout)   :: N,dos
    !!LOCAL
    Real(t_real)   :: e1,e2,e3,e4,v2,v3,d,x,x1,x2
    !!
    e1=ecorn(1)
    e2=ecorn(2)
    e3=ecorn(3)
    e4=ecorn(4)
    !!
    If(e2<e1)Then
       x=e1 ; e1=e2 ; e2=x
    Endif
    If(e3<e1)Then
       x=e1 ; e1=e3 ; e3=x
    Endif
    If(e4<e1)Then
       x=e1 ; e1=e4 ; e4=x
    Endif
    If(e3<e2)Then
       x=e2 ; e2=e3 ; e3=x
    Endif
    If(e4<e2)Then
       x=e2 ; e2=e4 ; e4=x
    Endif
    If(e4<e3)Then
       x=e3 ; e3=e4 ; e4=x
    Endif
    !!
    !!
    If (efermi  <= e1) Then
       Return
    Elseif (e4 < efermi) Then
       N=N+tetwgt
       Return
    Elseif (e1 < efermi .And. efermi <= e2) Then
       x=(efermi-e1)
       d = x*x/((e3-e1)*(e4-e1)*(e2-e1))*tetwgt
       N=N+x*d
       dos=dos+3.0_t_real*d
    Elseif (e2 < efermi .And. efermi <= e3) Then
       x1=(efermi-e1)
       x2=(efermi-e2)
       d=tetwgt/((e3-e1)*(e4-e1))
       
       v2=(x1+x2)*d
       v3=(e1+e2-e3-e4)*x2*x2*d/((e3-e2)*(e4-e2))+v2
       
       N=N+x1*(v2-x2*d)+x2*v3
       
       dos=dos+3.0_t_real*v3
       
    Elseif (e3 < efermi .And. efermi <= e4) Then
       x=(efermi-e4)
       d = x*x/((e1-e4)*(e2-e4)*(e3-e4))*tetwgt
       N=N+tetwgt-x*d
       dos=dos-3.0_t_real*d
    Endif
    !!
    !!
    !!
  End Subroutine tetidosatef
  !!***********************************************************************
  !!- Makes integrated dos by tetrahedron method.
  !! ----------------------------------------------------------------------
  !!i Inputs:
  !!i   ebk :energy bands
  !!i   emax  :upper bound of energy window
  !!i   emin  :lower bound of energy window
  !!i   tet :tet(1-4,i) points to the 4 irreducible k-points defining
  !!i           the tetrahedron. tet(0,i)=no. of tetr. of the i'th kind
  !!i           (output from TETIRR)
  !!i   nband  :number of bands ( = dimension of Hamiltonian) 
  !!i   nkp   :number of irreducible k-points
  !!i   nptdos:number of dos tabulation points
  !!i   ms0  : spin =1 or =2 for fsm
  !!i   nspin   :=1 spin degenerate or rel, =2 non-degenerate (non rel)
  !!i   ntet  :number of different tetrahedra (output from TETIRR)
  !!o Outputs:
  !!o   nos   :integrated density of states
  !!m Memory:
  !!m  No large internal storage; heap not accessed.
  !! ----------------------------------------------------------------------
  Subroutine tetnos(ebk,emax,emin,tet,nband,nkp,nos,nptdos &
       & ,ms0,ms1,nspin,ntet,ntetsum,nvdim,spinfac)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nkp,nband,nspin,ntet,nptdos
    Integer(t_int),Intent(in)    :: tet(0:5,*),ms0,ms1,nvdim
    Real(t_real),Intent(in)      :: ebk(nvdim,nkp,nspin),emin,emax,spinfac
    Real(t_real),Intent(in)      :: ntetsum
    Real(t_real),Intent(out)     :: nos(nptdos)
    !!LOCAL
    Integer(t_int) :: ms,itet,ikp1,ikp2,ikp3,ikp4,ib
    Real(t_real)  ::  ebot,ecorn(4),volwgt,tetwgt
    !!
    nos(:)=0.0_t_real
    volwgt = spinfac / ntetsum
    
    !! --- Loop over tetrahedra
    Do itet = 1_t_int, ntet
       ikp1=tet(1_t_int,itet)
       ikp2=tet(2_t_int,itet)
       ikp3=tet(3_t_int,itet)
       ikp4=tet(4_t_int,itet)
       tetwgt=volwgt*tet(0_t_int,itet)
       
       !! ----- Loop over spins and bands
       Do ms = ms0, ms1
          Do ib = 1_t_int, nband
             !! --------- SET UP ENERGIES AT 4 CORNERS OF TETRAHEDRA
             ecorn(1_t_int) = ebk(ib,ikp1,ms)
             ecorn(2_t_int) = ebk(ib,ikp2,ms)
             ecorn(3_t_int) = ebk(ib,ikp3,ms)
             ecorn(4_t_int) = ebk(ib,ikp4,ms)
             ebot = Min(ecorn(1_t_int),ecorn(2_t_int),ecorn(3_t_int),ecorn(4_t_int))
             If (ebot < emax)  &
                  & Call slinz(tetwgt,ecorn,emin,emax,nos,nptdos)
          Enddo
       Enddo
    Enddo
  End Subroutine tetnos
  !!***********************************************************************
  Subroutine gamnos(ebk,emax,emin,nband,nkp,nos,nptdos &
       & ,ms0,ms1,nspin,nvdim,spinfac,beta,prot)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: prot
    Integer(t_int),Intent(in)    :: nkp,nband,nspin,nptdos
    Integer(t_int),Intent(in)    :: ms0,ms1,nvdim
    Real(t_real),Intent(in)      :: beta
    Real(t_real),Intent(in)      :: ebk(nvdim,nkp,nspin),emin,emax,spinfac
    Real(t_real),Intent(out)     :: nos(nptdos)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="gamnos"
    Integer(t_int) :: ie,ikp,ib,ms
    Real(t_real)   :: e,e0,e1,de,wgt,en,exmax,f,x
    !!
    exmax=Log(Huge(1.0_t_real))-10.0_t_real
    !!
    e0=emin
    e1=emax
    de = (e1-e0)/Real(nptdos-1,t_real)
    !!
    nos(:)=0.0_t_real
    wgt = spinfac
    !!
    ikp=1_t_int ! single k-point = 0,0,0 assumed 
    !! ----- Loop over spins and bands
    Do ms = ms0, ms1
       Do ib = 1_t_int, nband
          !!
          en = ebk(ib,ikp,ms)
          !Print *,'en=',ms,ib,en,e0,e1,de
          !!
          Do ie = 1, nptdos
             e = e0 + (ie-1)*de
             x=beta*(en-e)
             f=0.0_t_real
             If(x<exmax)Then
                f=1.0_t_real/(Exp(x)+1.0_t_real)
             Endif
             nos(ie) = nos(ie) + wgt*f
          Enddo
       Enddo
    Enddo
    !!
    If(prot)Then
       Open(12,file='+nos')
       Do ie=1,nptdos
          e = e0 + (ie-1)*de
          Write(12,10)e,nos(ie)
       Enddo
       Close(12)
10     Format(10(e30.15e3,2x))
    Endif
    !!
    !!
  End Subroutine gamnos
  !!***********************************************************************
  Subroutine gamwts(fsm,bweitk,ebkfsm,efermi,Bfsm,dBfsm,nband,nkp,nspin&
       &,zval,nvdim,bandenergy,Eent,spinfac,beta,calcfermisurfaceweights&
       &,dbweitk,Mnn)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: calcfermisurfaceweights,fsm
    Integer(t_int),Intent(in)    :: nkp,nband,nspin
    Integer(t_int),Intent(in)    :: nvdim
    Real(t_real),Intent(in)     :: ebkfsm(nvdim,nkp,nspin)
    Real(t_real),Intent(in),Optional :: Mnn(:,:)
    Real(t_real),Intent(in)     :: efermi,Bfsm,dBfsm,zval,spinfac
    Real(t_real),Intent(in)     :: beta
    Real(t_real),Intent(out)    :: bweitk(nband,nkp,nspin)
    Real(t_real),Intent(out)    :: dbweitk(nband,nkp,nspin)
    Real(t_real),Intent(out)    :: bandenergy(2)
    Real(t_real),Intent(out)    :: Eent(2)
    !!LOCAL
    Character(*),Parameter::nsubfunc="gamwts"
    Logical(t_log) :: rel
    !Integer(t_int) :: ms,itet,ikp1,ikp2,ikp3,ikp4,ib,j
    !Real(t_real)  :: sev1,sev2,volwgt,etop,ebot,ecorn(4)
    Integer(t_int) :: ms,ib,ikp
    Real(t_real)   :: sumwgt,e,en,w,wgt,f,x,flf,flfm,exmax,expx,df
    !!
    Real(t_real),Parameter   :: tol=1.0e-6_t_real
    !!    
    exmax=Log(Huge(1.0_t_real))-10.0_t_real
    !!
    rel=Present(Mnn)
    !!
    bweitk(:,:,:)=0.0_t_real
    If(calcfermisurfaceweights)dbweitk(:,:,:)=0.0_t_real
    !!
    !!
    bandenergy(1:2)=0.0_t_real
    Eent(1:2)=0.0_t_real
    !!
    wgt=spinfac
    !!
    ikp=1_t_int ! single k-point = 0,0,0 assumed 
    !!
    !! ----- Loop over spins and bands
    Do ms = 1_t_int, nspin
       Do ib = 1_t_int, nband
          !!
          en = ebkfsm(ib,ikp,ms)
          !!
          
          !!
          e = efermi
          !!
          x=beta*(en-e)
          f=0.0_t_real
          expx=0.0_t_real
          If(x<exmax)Then
             expx=Exp(x)
             f=1.0_t_real/(expx+1.0_t_real)
          Endif
          If(f==0.0_t_real)Then
             flf=0.0_t_real
          Else
             flf=f*Log(f)
          Endif
          If(f==1.0_t_real)Then
             flfm=0.0_t_real
          Else
             flfm=(1.0_t_real-f)*Log(1.0_t_real-f)
          Endif
          Eent(ms)=Eent(ms)+wgt*(flf+flfm)/beta
          !Print *,'x=',x
          !Print *,'f=',f
          !Print *,'f ln f=',flf
          !Print *,'1-f ln 1-f=',flfm
          w=wgt*f
          !!
          bweitk(ib,ikp,ms)=bweitk(ib,ikp,ms)+w
          !!
          bandenergy(ms)=bandenergy(ms)+en*w
          !!
          If(fsm)Then
             If(rel)Then
                bandenergy(ms)=bandenergy(ms)-Bfsm*Mnn(ib,ikp)*w
             Else
                bandenergy(ms)=bandenergy(ms)-w*(3-2*ms)*Bfsm
             Endif
          Endif
          !!
          If(calcfermisurfaceweights)Then
             !!
             df=0.0_t_real
             If(Abs(x)<exmax*0.5_t_real)Then
                df=beta*f*f*expx
             Endif
             dbweitk(ib,ikp,ms)=dbweitk(ib,ikp,ms)+wgt*df
          Endif
          !!
       Enddo
    Enddo
    !!
    !Stop
    !!
    sumwgt=Sum(bweitk(:,:,:))
    !! --- Printout
    If (outlevel > L_info) Then
       Write(outfile,301)nsubfunc,(1.0_t_real/beta)*hatoev&
            &,(1.0_t_real/beta)*hatoev*eVtokT
       If(fsm)Then
          Write(outfile,300)nsubfunc,efermi,-Bfsm,-dBfsm,sumwgt&
               &,Sum(bandenergy(1:2))
       Else
          Write(outfile,302)nsubfunc,efermi,sumwgt,Sum(bandenergy(1:2))
       Endif
    Endif
    !!
    If (Abs(sumwgt-zval) > tol) Then
       
       Write(errbuf,"('''number of valence electrons=',f6.3,''',/&
            &,'', sum of weights=',f6.3,''',/&
            &,'', maybe you should increase nx,ny,nz.''')") zval,sumwgt
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
    Endif
    !!
    Return
    !!
301 Format(a,': kT          :',f10.6,' eV = ',f15.6,' K')
300 Format(a,': Fermi energy:',f10.6,' Bfsm=',f10.6,' dB=',f10.6 &
         & ,';',f10.6,' electrons',/,9x,'Band energy:',f15.8)
302 Format(a,': Fermi energy:',f10.6 &
         & ,';',f10.6,' electrons',/,9x,'Band energy:',f15.8)
  End Subroutine gamwts
  !!***********************************************************************
  Subroutine gamdos(dos,nos,ebk,emax,emin,nvdim,ne,aw,spinfac,ib0,beta)
    !!- Density of states by Gamma-point temperature method
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   aw    :weights for energy points
    !!i   ebk   :band energies
    !!i   emax  :upper bound of energy window
    !!i   emin  :lower bound of energy window
    !!i   nvdim :number of bands
    !!i   ne    :no of DOS tabulation points in energy range: [emin, emax]
    !!o Outputs:
    !!o   dos   :DOS for weight function aw
    !!o   nos   :integrated DOS
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)   :: nvdim,ne
    Integer(t_int),Intent(in)   :: ib0
    Real(t_real),Intent(in)     :: spinfac
    Real(t_real),Intent(in)     :: ebk(nvdim),emin,emax
    Real(t_real),Intent(inout)  :: dos(ne)
    Real(t_real),Intent(inout)  :: nos(ne)
    Real(t_real),Intent(in)     :: aw(nvdim)
    Real(t_real),Intent(in)     :: beta
    !!LOCAL
!    Integer(t_int) :: ib,itet,ikp1,ikp2,ikp3,ikp4,nbw
!    Real(t_real)  :: ecorn(4),tetwgt,volwgt,wt,ebot,etop
    Integer(t_int) :: nbw,ib,ie
    Real(t_real)   :: e0,e1,de,wgt,en,e,ex,nw,x,ds,exmax
    !!
    exmax=(Log(Huge(1.0_t_real))-10.0_t_real)*0.5_t_real
    !!
    e0=emin
    e1=emax
    de = (e1-e0)/Real(ne-1,t_real)
    !!
    wgt = spinfac
    !!
    !!
    If(ib0<1)Then
       nbw=nvdim
    Else
       nbw=ib0
    Endif
    !!
    bandloop: Do ib = Max(ib0,1_t_int), nbw
       !!
       en = ebk(ib)
       !Print *,'en=',ms,ib,en,e0,e1,de
       !!
       Do ie = 1, ne
          e = e0 + (ie-1)*de
          x=beta*(en-e)
          If(x > exmax) Then
             nw=0.0_t_real
             !Print *,'x=',x,Log(Huge(1.0_t_real)/10)
             ds=0.0_t_real
             !Stop
          Else If( x < -exmax) Then
             nw=1.0_t_real
             ds=0.0_t_real
             !Print *,'x=',x,Log(Huge(1.0_t_real)/10)
             !Stop
          Else
             ex=Exp(x)
             nw=1.0_t_real/(ex+1.0_t_real)
             ds=nw**2*ex*beta
          Endif
          
          !Print *,e,ex,nw**2
          !Print *,    

          If(nw<1.0e-100_t_real)nw=0.0_t_real
          nos(ie) = nos(ie) + wgt*nw*aw(ib)
          dos(ie) = dos(ie) + wgt*ds*aw(ib)
       Enddo
    Enddo bandloop
    !!
    !!
    !!
  End Subroutine gamdos
  !!***********************************************************************
  !!- Makes fermi energy from integrated step
  !! ----------------------------------------------------------------------
  !!i Inputs:
  !!io  e1  :e1 < ef < e2
  !!io  e2  :e1 < ef < e2
  !!i   nptdos  :number of dos tabulation points
  !!i   nos   :integrated step of states
  !!i   zval  :valence charge
  !!o Outputs:
  !!io  dosef :step of states at fermi energy
  !!io  e1  :e1 < ef < e2
  !!io  e2  :e1 < ef < e2
  !!o   efermi:Fermi energy
  !!r Remarks:
  !!  Fermi energy lies between e1 and e2
  !! ----------------------------------------------------------------------
  Subroutine tfermi(dosef,e1,e2,efermi,nptdos,nos,zval,complain)
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: complain
    Integer(t_int),Intent(in)    :: nptdos
    Real(t_real),Intent(in)     :: zval,nos(nptdos)
    Real(t_real),Intent(out)    :: efermi
    Real(t_real),Intent(inout)    :: dosef
    Real(t_real),Intent(inout)  :: e1,e2
    !!LOCAL
    Character(*),Parameter::nsubfunc="tfermi"
    Integer(t_int) ::  meshpt
    Real(t_real)  ::  dosefo,step,q,q1,q2
    Integer(t_int),Parameter ::  nptmin=10_t_int
    Real(t_real),Parameter  ::  dosefm=100.0_t_real,tiny=1.0e-6_t_real
    !!
    dosefo=dosef
    step = (e2-e1)/Real(nptdos-1_t_int,t_real)
    If (nos(1_t_int)-zval > tiny) Then
       Write(errbuf,"('''Fermi energy lies below E1,  NOS(E1)=',f8.4&
            &,' ZVAL=',f3.0,' ! ''')") nos(1_t_int),zval
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
       meshpt=1_t_int
       e1=e1-1.0_t_real
       Return
    Elseif (nos(nptdos)-zval < -tiny) Then
       Write(errbuf,"('''Fermi energy= lies above E2  NOS(E2)=',f8.4&
            &,' ZVAL=',f3.0,'!''')") nos(nptdos),zval
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
       meshpt=nptdos-1_t_int
       e2=e2+1.0_t_real
       Return
    Else
       q = zval + Epsilon(1.0_t_real)
       meshpt = 1_t_int
       Do While (nos(meshpt+1_t_int) <= q)
          meshpt = meshpt + 1_t_int
       Enddo
    Endif
    q1 = nos(meshpt)
    q2 = nos(meshpt+1_t_int)
    e1 = e1 + step*(meshpt - 1_t_int)
    e2 = e1 + step
    efermi = e1 + (zval-q1)/(q2-q1)*step
    dosef = (q2-q1)/step
    
    !! --- if there is a tetrahedron with four equivalent corners
    !! --- (e1=e2=e3=e4), then NOS has a discontinuity at this energy e1.
    !! --- If the number of electrons lies in this gap, dosef will diverge
    !! --- with tolef -> 0, and the number of electrons is not NOS(E_f),
    !! --- even for tolef -> 0.
    !Print *,'dosef=',dosef,dosefo,nptdos
    If (complain.And.dosef > dosefm .And. nptdos > nptmin .And. dosef /= 0.0_t_real) Then
       If (Abs(1.0_t_real-dosefo/dosef*(nptdos-1_t_int)) < 0.05_t_real) Then
          Write(errbuf,"('''tetrahedron with 4 identical corners'',/&
               &,''       -> discontinuity in NOS'',/&
               &,''       -> DOS(E_F) diverges '',/&
               &,''       -> ZVAL /= NOS(E_f)'',/&
               &,'' -> charged system. ''')")
          Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
       Endif
    Endif
    !!
  End Subroutine tfermi
  !!***********************************************************************
  !!- Make k-point weights for integration by tetrahedron method
  !! ----------------------------------------------------------------------
  !!i Inputs:
  !!i   ebk :energy bands
  !!i   efermi:Fermi energy
  !!i   tet :tet(1-4,i) points to the 4 irreducible k-points defining
  !!i           the tetrahedron. tet(0,i)=no. of tetr. of the i'th kind
  !!i           (output from TETIRR)
  !!i   nband  :number of bands ( = dimension of Hamiltonian) see BNDASA
  !!i   nkp   :number of irreducible k-points
  !!i   nspin   :=1 spin degenerate or relativistic ,=2 non-degenerate (nonrel)
  !!i   ntet  :number of different tetrahedra (output from TETIRR)
  !!i   zval  :valence charge
  !!o Outputs:
  !!o   bndwt :band and E_F - dependent k-point weights for integration
  !!m Memory:
  !!m  No large internal storage; heap not accessed.
  !! ----------------------------------------------------------------------
  Subroutine tetwts(fsm,bzone,bweitk,ebkfsm,efermi,Bfsm,dBfsm,nband,nkp&
       &,nspin,zval,nvdim,bandenergy,spinfac,calcfermisurfaceweights&
       &,dbweitk,Mnn)
    !!
    Implicit None
    !!IO
    Type(T_Bzone),Intent(inout)  :: bzone 
    Logical(t_log),Intent(in)    :: calcfermisurfaceweights,fsm
    Integer(t_int),Intent(in)    :: nkp,nband,nspin
    Integer(t_int),Intent(in)    :: nvdim
    Real(t_real),Intent(in)      :: ebkfsm(nvdim,nkp,nspin)
    Real(t_real),Intent(in),Optional :: Mnn(:,:)
    Real(t_real),Intent(in)      :: efermi,Bfsm,dBfsm,zval,spinfac
    Real(t_real),Intent(out)     :: bweitk(nband,nkp,nspin)
    Real(t_real),Intent(out)     :: dbweitk(nband,nkp,nspin)
    Real(t_real),Intent(out)     :: bandenergy(2)
    !!LOCAL
    Character(*),Parameter::nsubfunc="tetwts"
    Logical(t_log) :: lsw,rel
    Integer(t_int) :: ms,itet,ikp1,ikp2,ikp3,ikp4,ib
    Real(t_real)  :: sev1,sev2,volwgt,ecorn(4),Mcorn(4),ddos
    Real(t_real)  :: wcorn(4,2),tetwgt,sumwgt,a,b
    Logical(t_log) :: nobloechl
#if defined (BASCREATE)
    Integer(t_int) :: ikp
    Real(t_real)   :: bweitkall(nkp),bandenergyall(2)
#endif
    !!
    Real(t_real),Parameter   :: tol=1.0e-6_t_real
    !!    
    nobloechl=debugfun(nmodule,nsubfunc,'NO_BLOECHL')
    rel=Present(Mnn)
    !!
    lsw=.True.
    If(debugfun(nmodule,nsubfunc,'NO_WEIGHT_SYM'))lsw=.False.
    !!
    bweitk(:,:,:)=0.0_t_real
    if(calcfermisurfaceweights) dbweitk(:,:,:)=0.0_t_real
#if defined (BASCREATE)
    bweitkall(:)=0.0_t_real
#endif
    sev1 = 0.0_t_real
    sev2 = 0.0_t_real
    volwgt = spinfac / bzone% ntetsum
    bandenergy(1:2)=0.0_t_real
#if defined (BASCREATE)
    bandenergyall(1:2)=0.0_t_real
#endif
    !! --- Loop over tetrahedra
    Do itet = 1_t_int, bzone% ntet
       ikp1=bzone% p_tet(1_t_int,itet)
       ikp2=bzone% p_tet(2_t_int,itet)
       ikp3=bzone% p_tet(3_t_int,itet)
       ikp4=bzone% p_tet(4_t_int,itet)
       tetwgt=volwgt*bzone% p_tet(0_t_int,itet)
       
#if defined (BASCREATE)
       bweitkall(ikp1)=bweitkall(ikp1)+tetwgt*0.25_t_real
       bweitkall(ikp2)=bweitkall(ikp2)+tetwgt*0.25_t_real
       bweitkall(ikp3)=bweitkall(ikp3)+tetwgt*0.25_t_real
       bweitkall(ikp4)=bweitkall(ikp4)+tetwgt*0.25_t_real
#endif

       
       !! ----- Loop over spins and bands
       Do ms = 1_t_int, nspin
          a=0.0_t_real
          b=0.0_t_real
          Do ib = 1_t_int, nband
             
             !! --------- SET UP ENERGIES AT 4 CORNERS OF TETRAHEDRA
             ecorn(1_t_int) = ebkfsm(ib,ikp1,ms)
             ecorn(2_t_int) = ebkfsm(ib,ikp2,ms)
             ecorn(3_t_int) = ebkfsm(ib,ikp3,ms)
             ecorn(4_t_int) = ebkfsm(ib,ikp4,ms)
             Call fswgts(tetwgt,ecorn,efermi,wcorn,ddos)
             If(nobloechl) wcorn(:,2)=0.0_t_real
             a    = a    + Dot_product(wcorn(:,1),ecorn)
             b    = b    + Dot_product(wcorn(:,2),ecorn)
             If(fsm)Then
                If(rel)Then
                   Mcorn(1) = Mnn(ib,ikp1)
                   Mcorn(2) = Mnn(ib,ikp2)
                   Mcorn(3) = Mnn(ib,ikp3)
                   Mcorn(4) = Mnn(ib,ikp4)
                   a=a-Bfsm*Dot_product(wcorn(:,1),Mcorn)
                   b=b-Bfsm*Dot_product(wcorn(:,2),Mcorn)
                Else
                   a=a-Bfsm*Sum(wcorn(:,1))*(3.0_t_real-2.0_t_real*ms)
                   b=b-Bfsm*Sum(wcorn(:,2))*(3.0_t_real-2.0_t_real*ms)
                Endif
             Endif
             bweitk(ib,ikp1,ms)=bweitk(ib,ikp1,ms)+wcorn(1,1)+wcorn(1,2)
             bweitk(ib,ikp2,ms)=bweitk(ib,ikp2,ms)+wcorn(2,1)+wcorn(2,2)
             bweitk(ib,ikp3,ms)=bweitk(ib,ikp3,ms)+wcorn(3,1)+wcorn(3,2)
             bweitk(ib,ikp4,ms)=bweitk(ib,ikp4,ms)+wcorn(4,1)+wcorn(4,2)
             !!
             If(calcfermisurfaceweights)Then
                Call dfswgts(tetwgt,ecorn,efermi,wcorn)
                If(nobloechl) wcorn(:,2)=0.0_t_real
                dbweitk(ib,ikp1,ms)=dbweitk(ib,ikp1,ms)+wcorn(1,1)+wcorn(1,2)
                dbweitk(ib,ikp2,ms)=dbweitk(ib,ikp2,ms)+wcorn(2,1)+wcorn(2,2)
                dbweitk(ib,ikp3,ms)=dbweitk(ib,ikp3,ms)+wcorn(3,1)+wcorn(3,2)
                dbweitk(ib,ikp4,ms)=dbweitk(ib,ikp4,ms)+wcorn(4,1)+wcorn(4,2)
             Endif

             !!
#if defined (BASCREATE)
             bandenergyall(ms)=bandenergyall(ms)+Sum(ecorn(1:4))*tetwgt*0.25_t_real
#endif
          Enddo
          sev1 = sev1 + a
          sev2 = sev2 + b
          bandenergy(ms)=bandenergy(ms)+a+b
          !!
          !!
       Enddo
    Enddo

    !!
#if defined (BASCREATE)
    a=0.0_t_real
    Do ikp=1,nkp
       Do ms=1,nspin
          a=a+Sum(ebkfsm(1:nband,ikp,ms))*bweitkall(ikp)
       Enddo
    Enddo
    a=a/Real(nband,t_real)

    b=0.0_t_real
    Do ikp=1,nkp
       Do ms=1,nspin
          b=b+Sum((ebkfsm(1:nband,ikp,ms)-a)**2)*bweitkall(ikp)
       Enddo
    Enddo
    b=Sqrt(b/Real(nband,t_real))
    
    !!TODO: make a debugging option
    Write(outfile,"(' <EV>=',f30.15,' Ha')") a
    Write(outfile,"('D<EV>=',f30.15,' Ha')") b

    Write(outfile,546) Sum(bandenergyall(1:nspin))
546 Format('Band energy all bands: ',f30.15)

#endif

!!$    Print *,'BE=',bandenergy(1:nspin)

    !!
    If(lsw) Then
       Call symmetrize_weights(nkp,nvdim,nband,nspin,bweitk,ebkfsm&
            &,bzone% p_irredindex,bzone% symeqkpoint_fullbz)
       If(calcfermisurfaceweights)Then
          Call symmetrize_weights(nkp,nvdim,nband,nspin,dbweitk,ebkfsm&
               &,bzone% p_irredindex,bzone% symeqkpoint_fullbz)
       Endif
                
    Endif
    !!
!!$    ms=1
!!$    a=0.0_t_real
!!$    Do ikp1=1,nkp
!!$       a=a+Sum(bweitk(1:nband,ikp1,ms)*ebkfsm(1:nband,ikp1,ms))
!!$    Enddo
!!$    Print *,'BE symmetrized=',a
!!$    !!
    sumwgt=Sum(bweitk(:,:,:))
    !! --- Printout
    If (outlevel > L_info) Then
       If(fsm)Then
          Write(outfile,300)efermi,-Bfsm,-dBfsm,sumwgt,sev1+sev2,sev2
       Else
          Write(outfile,302)efermi,sumwgt,sev1+sev2,sev2
       Endif
    Endif
    !!
    If (Abs(sumwgt-zval) > tol) Then
       
       Write(errbuf,"('''number of valence electrons=',f6.3,''',/&
            &,'', sum of weights=',f6.3,''',/&
            &,'', maybe you should increase nx,ny,nz.''')") zval,sumwgt
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
    Endif
    !!
300 Format(' TETWTS: Fermi energy:',f10.6,' Bfsm=',f10.6,' dB=',f10.6 &
         & ,';',f10.6,' electrons',/,9x,'Band energy:',f15.8, &
         & ', including Bloechl correction:',f9.6)
302 Format(' TETWTS: Fermi energy:',f10.6 &
         & ,';',f10.6,' electrons',/,9x,'Band energy:',f15.8, &
         & ', including Bloechl correction:',f9.6)
  End Subroutine tetwts
  !!***********************************************************************
  Subroutine slinz(volwgt,ecorn,emin,emax,nos,npts)
    !!- Adds to number-of-states for one tetrahedron
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   volwgt:weight of irreducible tetrahedron
    !!i   ecorn :energies at corners of tetrahedron
    !!o   emin  :lower bound of energy window
    !!o   emax  :upper bound of energy window
    !!io  nos   :integrated density of states from tetrahedron
    !!i   npts  :number of dos tabulation points
    !!o Outputs:
    !!io  nos   :integrated density of states from tetrahedron
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: npts
    Real(t_real),Intent(in)     :: volwgt,emin,emax
    Real(t_real),Intent(inout)  :: ecorn(4),nos(npts)
    !!LOCAL
    Integer(t_int) :: i,i0(4),m
    Real(t_real)  :: de,e1,e2,e3,e4,c0,c1,c2,c3,x,x0
    !!
    !! ----sort ecorn -------
    Call dshell(1_t_int,4_t_int,ecorn,1.0e-12_t_real)
    
    If (ecorn(1_t_int) > emax) Return
    If (ecorn(4_t_int) < emin) Then
       Do i = 1_t_int, npts
          nos(i) = nos(i) + volwgt
       Enddo
    Else
       e1 = ecorn(1_t_int)
       e2 = ecorn(2_t_int)
       e3 = ecorn(3_t_int)
       e4 = ecorn(4_t_int)
       de = (emax-emin)/Real(npts-1_t_int,t_real)
       Do m=1_t_int,4_t_int
          If (ecorn(m) <= emin) Then
             i0(m)=1_t_int
          Elseif (ecorn(m) > emax) Then
             i0(m)=npts+1_t_int
          Else
             i0(m) = 2_t_int + Int((ecorn(m)-emin)/de - Epsilon(1.0_t_real)&
                  &,t_int)
          Endif
       Enddo
       If (i0(1_t_int) < i0(2_t_int)) Then
          c3 = volwgt/((e2-e1)*(e3-e1)*(e4-e1))
          x0 = emin-e1-de
          Do i = i0(1_t_int), i0(2_t_int)-1_t_int
             x = x0 + i*de
             nos(i) = nos(i) + c3*x*x*x
          Enddo
       Endif
       If (i0(2_t_int) < i0(3_t_int)) Then
          c3 = volwgt*(e1+e2-e3-e4)/((e3-e1)*(e4-e1)*(e3-e2)*(e4-e2))
          c2 = volwgt*3.0_t_real/((e3-e1)*(e4-e1))
          c1 = c2*(e2-e1)
          c0 = c1*(e2-e1)/3.0_t_real
          x0 = emin-e2-de
          Do i = i0(2_t_int), i0(3_t_int)-1_t_int
             x = x0 + i*de
             nos(i) = nos(i) + c0 + x*(c1 + x*(c2 + x*c3))
          Enddo
       Endif
       If (i0(3_t_int) < i0(4_t_int)) Then
          c3 = volwgt/((e4-e3)*(e4-e2)*(e4-e1))
          x0 = emin-e4-de
          Do i = i0(3_t_int), i0(4_t_int)-1_t_int
             x = x0 +i*de
             nos(i) = nos(i) + volwgt + c3*x*x*x
          Enddo
       Endif
       Do i = i0(4_t_int), npts
          nos(i) = nos(i) + volwgt
       Enddo
    Endif
  End Subroutine slinz
  !!***********************************************************************
  Subroutine slinz1(acorn,volwgt,ecorn,emin,emax,nos,npts)
    !!- Adds to number-of-states for one tetrahedron
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   volwgt:weight of irreducible tetrahedron
    !!i   ecorn :energies at corners of tetrahedron
    !!i   acorn :weights at corners of tetrahedron
    !!i          these weights are 1 for total DOS 
    !!i          and  something k-dependend for a partial DOS 
    !!o   emin  :lower bound of energy window
    !!o   emax  :upper bound of energy window
    !!io  nos   :integrated density of states from tetrahedron
    !!i   npts  :number of dos tabulation points
    !!o Outputs:
    !!io  nos   :integrated density of states from tetrahedron
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: npts
    Real(t_real),Intent(in)     :: volwgt,emin,emax
    Real(t_real),Intent(in)     :: ecorn(4),acorn(4)
    Real(t_real),Intent(inout)  :: nos(npts)
    !!LOCAL
    Integer(t_int) :: i,i0(4),m,iwk(4)
    Real(t_real)   :: ec(4),ac(4),ac0,e1,e2,e3,e4,a1,a2,a3,a4,de
    Real(t_real)   :: da21,da31,da41,da42,da43
    Real(t_real)   :: q,c3,x0,x,c4,c2,c1,c0,q31,q41,dq,q0,q1,q2,q3,q4
    !!
    !! ----sort ecorn -------
    Call dshel2(1_t_int,4_t_int,ecorn,iwk,1.0e-12_t_real)
    Do i=1,4
       ec(i)=ecorn(iwk(i)+1)
       ac(i)=acorn(iwk(i)+1)
    Enddo
    ac0=Sum(acorn)/4


    If (ec(1_t_int) > emax) Return
    If (ec(4_t_int) < emin) Then
       Do i = 1_t_int, npts
          nos(i) = nos(i) + volwgt*ac0
       Enddo
    Else
       e1 = ec(1_t_int)
       e2 = ec(2_t_int)
       e3 = ec(3_t_int)
       e4 = ec(4_t_int)
       a1=  ac(1)
       a2=  ac(2)
       a3=  ac(3)
       a4=  ac(4)
       de = (emax-emin)/Real(npts-1_t_int,t_real)
       Do m=1_t_int,4_t_int
          If (ec(m) <= emin) Then
             i0(m)=1_t_int
          Elseif (ec(m) > emax) Then
             i0(m)=npts+1_t_int
          Else
             i0(m) = 2_t_int + Int((ec(m)-emin)/de - Epsilon(1.0_t_real)&
                  &,t_int)
          Endif
       Enddo
       da21=a2-a1
       da31=a3-a1
       da41=a4-a1
       If (i0(1_t_int) < i0(2_t_int)) Then
          q=(da21/(e2-e1)+da31/(e3-e1)+da41/(e4-e1))*0.25_t_real
          c3 = volwgt/((e2-e1)*(e3-e1)*(e4-e1))
          x0 = emin-e1-de
          Do i = i0(1_t_int), i0(2_t_int)-1_t_int
             x = x0 + i*de
             nos(i) = nos(i) + c3*x*x*x*(a1 + x*q)
          Enddo
       Endif
       If (i0(2_t_int) < i0(3_t_int)) Then
          c4 = volwgt/((e3-e2)**2*(e4-e2)**2)*0.25_t_real
          c3 = volwgt*(e1+e2-e3-e4)/((e3-e1)*(e4-e1)*(e3-e2)*(e4-e2))
          c2 = volwgt*3.0_t_real/((e3-e1)*(e4-e1))
          c1 = c2*(e2-e1)
          c0 = c1*(e2-e1)/3.0_t_real
          !!
          q31=da31/(e3-e1)
          q41=da41/(e4-e1)
          q=q31+q41
          dq=da21+(e2-e1)*q
          !!
          q0= a1 + dq*0.25_t_real
          q1= a1 + dq*c1o3
          q2= a1 + dq*0.5_t_real
          q3= a1*c3 +da21*c3 +c2*q*c1o3
          q4=+c3*(q-da21/(e3-e2))*0.25_t_real&
               &-c4*((e4-e2)*q31+(e3-e2)*(q41-da21/(e4-e1)))
          !!
          x0 = emin-e2-de
          Do i = i0(2_t_int), i0(3_t_int)-1_t_int
             x = x0 + i*de
             nos(i) = nos(i)  + c0*q0  + x*(c1*q1  + x*(c2*q2  + x*(q3+x*q4)))
          Enddo
       Endif
       If (i0(3_t_int) < i0(4_t_int)) Then
          da42=a4-a2
          da43=a4-a3
          q=-(da41/(e1-e4)+da42/(e2-e4)+da43/(e3-e4))*0.25_t_real
          c3 = volwgt/((e4-e3)*(e4-e2)*(e4-e1))
          x0 = emin-e4-de
          Do i = i0(3_t_int), i0(4_t_int)-1_t_int
             x = x0 +i*de
             nos(i) = nos(i) + volwgt*ac0 + c3*x*x*x*(a4+x*q)
          Enddo
       Endif
       Do i = i0(4_t_int), npts
          nos(i) = nos(i) + volwgt*ac0
       Enddo
    Endif
    !!
    return
    !!
  End Subroutine slinz1
  !!***********************************************************************
  Subroutine fswgts(tetwgt,ecorn,efermi,wcorn,ddos)
    !!- Makes weights for integration up to efermi for one tetrahedron.
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   tetwgt:weight of irreducible tetrahedron
    !!i   ecorn :energy of four corners of tetrahedron
    !!i   efermi:Fermi energy
    !!o Outputs:
    !!o   wcorn :weight of four corners of tetrahedron
    !!r Remarks:
    !!r   wcorn(i,1): NORMAL WEIGHTS.  wcorn(i,2): BLOECHL-CORRECTION.
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Real(t_real),Intent(in)     :: tetwgt,ecorn(4),efermi
    Real(t_real),Intent(out)    :: wcorn(4,2),ddos
    !!LOCAL
    Integer(t_int) :: icorn,isort(4)
    Real(t_real)  :: a14,a21,a24,a31,a32,a34,a41,a42,vw4,e1,e2,e3,e4
    Real(t_real)  :: v1,v2,v3,xxx,w1(4),w2(4)
    !!
    vw4 = tetwgt*0.25_t_real
    wcorn(:,:)=0.0_t_real
    !! --- SORT ENERGIES INTO E1, E2, E3, E4 -----
    Call dshel2(1_t_int,4_t_int,ecorn,isort,1.0e-12_t_real)
    e1 = ecorn(isort(1_t_int)+1_t_int)
    e2 = ecorn(isort(2_t_int)+1_t_int)
    e3 = ecorn(isort(3_t_int)+1_t_int)
    e4 = ecorn(isort(4_t_int)+1_t_int)
    
    ddos=0.0_t_real
    If (efermi  <= e1) Then
       Return
    Elseif (e1 < efermi .And. efermi <= e2) Then
       !! ----- CASE efermi BETWEEN E1,E2
       a21 = (efermi-e1)/(e2-e1)
       a31 = (efermi-e1)/(e3-e1)
       a41 = (efermi-e1)/(e4-e1)
       xxx = a21*a31*a41*vw4
       w1(1_t_int) = xxx*(4.0_t_real-a21-a31-a41)
       w1(2_t_int) = xxx*a21
       w1(3_t_int) = xxx*a31
       w1(4_t_int) = xxx*a41
       ddos = 3.0_t_real*tetwgt*a31*a41/(e2-e1)
    Elseif (e2 < efermi .And. efermi <= e3) Then
       !! ----- CASE efermi BETWEEN E2,E3
       a31 = (efermi-e1)/(e3-e1)
       a41 = (efermi-e1)/(e4-e1)
       a32 = (efermi-e2)/(e3-e2)
       a42 = (efermi-e2)/(e4-e2)
       v1 = a31*a41
       v2 = a31*a42*(1.0_t_real-a41)
       v3 = a42*a32*(1.0_t_real-a31)
       w1(1_t_int) = (v1*(3.0_t_real-a31-a41)+v2*(2.0_t_real-a31-a41)&
            &+v3*(1.0_t_real-a31))*vw4
       w1(2_t_int) = (v1 + v2*(2.0_t_real-a42) + v3*(3.0_t_real-a32-a42))*vw4
       w1(3_t_int) = (v1*a31 + v2*a31 + v3*(a31+a32))*vw4
       w1(4_t_int) = (v1*a41 + v2*(a41+a42) + v3*a42)*vw4
       ddos = ((e1+e2-e3-e4)*a32*a42+2.0_t_real*efermi-e1-e2)/((e3-e1)*(e4-e1))
       ddos = 3.0_t_real*tetwgt*ddos
    Elseif (e3 < efermi .And. efermi <= e4) Then
       !! ----- CASE efermi BETWEEN E3,E4
       a14 = (efermi-e4)/(e1-e4)
       a24 = (efermi-e4)/(e2-e4)
       a34 = (efermi-e4)/(e3-e4)
       xxx = a14*a24*a34*vw4
       w1(1_t_int) = vw4 - xxx*a14
       w1(2_t_int) = vw4 - xxx*a24
       w1(3_t_int) = vw4 - xxx*a34
       w1(4_t_int) = vw4 - xxx*(4.0_t_real-a14-a24-a34)
       ddos = -3.0_t_real*tetwgt*a14*a24/(e3-e4)
    Elseif (e4 < efermi) Then
       !! ----- CASE efermi larger than E4
       wcorn(:,1_t_int)=vw4
       Return
    Endif
    
    !! --- HERE FOR BLOECHL CORRECTION ---------
    w2(1_t_int) = (   e2+e3+e4-3.0_t_real*e1)*ddos*0.025_t_real
    w2(2_t_int) = (e1   +e3+e4-3.0_t_real*e2)*ddos*0.025_t_real
    w2(3_t_int) = (e1+e2   +e4-3.0_t_real*e3)*ddos*0.025_t_real
    w2(4_t_int) = (e1+e2+e3   -3.0_t_real*e4)*ddos*0.025_t_real
    !!     
    !w2(1)=0
    !w2(2)=0
    !w2(3)=0
    !w2(4)=0
    Do icorn = 1_t_int, 4_t_int
       wcorn(isort(icorn)+1_t_int,1_t_int) = w1(icorn)
       wcorn(isort(icorn)+1_t_int,2_t_int) = w2(icorn)
    Enddo
    
  End Subroutine fswgts
  !!***********************************************************************
  Subroutine dfswgts(tetwgt,ecorn,efermi,dwcorn)
    !!- Makes weights for integration over the fermi surface for one tetrahedron.
    !! this is for Fermi surface integrals
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   tetwgt:weight of irreducible tetrahedron
    !!i   ecorn :energy of four corners of tetrahedron
    !!i   efermi:Fermi energy
    !!o Outputs:
    !!o   dwcorn :weight of four corners of tetrahedron
    !!r Remarks:
    !!r   dwcorn(i,1): NORMAL WEIGHTS.  dwcorn(i,2): BLOECHL-CORRECTION.
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Real(t_real),Intent(in)     :: tetwgt,ecorn(4),efermi
    Real(t_real),Intent(out)    :: dwcorn(4,2)
    !!LOCAL
    Integer(t_int) :: icorn,isort(4)
    Real(t_real)  :: a1,a2,a3,a14,a24,a34,a21,a31,a32,a41,a42,vw4,e1,e2,e3,e4,a4
    Real(t_real)  :: df,xxx,w1(4),w2(4),d43,d42,d41,d32,d31,d21
    !!
    vw4 = tetwgt*0.25_t_real
    dwcorn(:,:)=0.0_t_real
    !! --- SORT ENERGIES INTO E1, E2, E3, E4 -----
    Call dshel2(1_t_int,4_t_int,ecorn,isort,1.0e-12_t_real)
    e1 = ecorn(isort(1_t_int)+1_t_int)
    e2 = ecorn(isort(2_t_int)+1_t_int)
    e3 = ecorn(isort(3_t_int)+1_t_int)
    e4 = ecorn(isort(4_t_int)+1_t_int)
    
    df=0.0_t_real
    If (efermi  <= e1) Then
       Return
    Elseif (e1 < efermi .And. efermi <= e2) Then
       !! ----- CASE efermi BETWEEN E1,E2
       a1 = (efermi-e1)
       a21 = 1.0_t_real/(e2-e1)
       a31 = 1.0_t_real/(e3-e1)
       a41 = 1.0_t_real/(e4-e1)
       xxx =  a1*a21*a31*a41*tetwgt
       df = 6.0_t_real*xxx
       xxx =  xxx*a1
       w1(1) = xxx*(3.0_t_real-a1*(a21+a31+a41))
       xxx=xxx*a1
       w1(2) = xxx*a21
       w1(3) = xxx*a31
       w1(4) = xxx*a41
    Elseif (e2 < efermi .And. efermi <= e3) Then
       !! ----- CASE efermi BETWEEN E2,E3
       a1=(efermi-e1)
       a2=(efermi-e2)
       a3=efermi-e3
       d21=e2-e1
       d31=e3-e1
       d32=e3-e2
       d41=e4-e1
       d42=e4-e2
       d43=e4-e3
       a31 = 1.0_t_real/d31
       a41 = 1.0_t_real/d41
       a32 = 1.0_t_real/d32
       a42 = 1.0_t_real/d42

       df = (e1+e2-e3-e4)*a2*a32*a42+1.0_t_real
       df = 6.0_t_real*tetwgt*a31*a41*df

       w1(1)=tetwgt*(&
            &a3**3*(D41**2+D32*(D41+D31))*a31**2*a32&
            &+3*a3**2&
            &-3*a3*D43&
            &+D43**2&
            &)*a41**2*a42
       
       w1(2)=tetwgt*(&
            &a3**3*(D32**2+D41*(D42+D32))*a31*a32**2&
            &+3*a3**2&
            &-3*a3*D43&
            &+D43**2&
            &)*a41*a42**2
       
       w1(3)=tetwgt*(&
            &-a2**3*(D32**2+D41*(D32+D31))*a42*a32**2&
            &+3*a2**2&
            &+3*a2*D21&
            &+D21**2&
            &)*a31**2*a41
       
       w1(4)=tetwgt*(&
            &-a2**3*(D41**2+D32*(D41+D42))*a32*a42**2&
            &+3*a2**2&
            &+3*a2*D21&
            &+D21**2&
            &)*a31*a41**2
       
    Elseif (e3 < efermi .And. efermi <= e4) Then
       !! ----- CASE efermi BETWEEN E3,E4
       a4 = (efermi-e4)
       a14= 1.0_t_real/(e1-e4)
       a24= 1.0_t_real/(e2-e4)
       a34= 1.0_t_real/(e3-e4)
       xxx  = -a4*a14*a24*a34*tetwgt
       df = 6.0_t_real*xxx
       xxx  =xxx*a4
       w1(4) =  xxx*(3.0_t_real-a4*(a14+a24+a34))
       xxx=xxx*a4
       w1(1) =  xxx*a14
       w1(2) =  xxx*a24
       w1(3) =  xxx*a34
      
    Elseif (e4 < efermi) Then
       !! ----- CASE efermi larger than E4
       Return
    Endif
    
    !! --- HERE FOR BLOECHL CORRECTION ---------
    w2(1) = (   e2+e3+e4-3.0_t_real*e1)*df*0.025_t_real
    w2(2) = (e1   +e3+e4-3.0_t_real*e2)*df*0.025_t_real
    w2(3) = (e1+e2   +e4-3.0_t_real*e3)*df*0.025_t_real
    w2(4) = (e1+e2+e3   -3.0_t_real*e4)*df*0.025_t_real
    !!     
    Do icorn = 1, 4
       dwcorn(isort(icorn)+1,1) = w1(icorn)
       dwcorn(isort(icorn)+1,2) = w2(icorn)
    Enddo
    
  End Subroutine dfswgts
  !!***********************************************************************
  Subroutine splnos(ebk,emax,emin,nband,nkp,mp_norder,nos,nptdos&
       &,ms0,ms1,nspin,mp_width,wbk,nvdim,spinfac)
    !!- make integrated density of states from bands
    !!-----------------------------------------------------------------------
    !!i  Inputs:
    !!i   ebk :eigenvalues of hamiltonian matrix
    !!i   emax  :upper bound of energy window
    !!i   emin  :lower bound of energy window
    !!i   nband  :number of bands
    !!i   nkp   :number of k-points
    !!i   mp_norder:Methfessel-Paxton order parameter
    !!i   nptdos  :number of energy mesh points
    !!i   nspin   :=1 spin degenerate or rel, =2 non-degenerate (non rel)
    !!i   mp_width :Methfessel-Paxton width parameter
    !!i   wbk  :weight of k-point, including spin degeneracy (from BZMESH)
    !!o  Ouputs:
    !!o   nos   :integrated DOS
    !!-----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)   :: nkp,nband,nspin,mp_norder,nptdos,nvdim
    Integer(t_int),Intent(in)    :: ms0,ms1
    Real(t_real),Intent(in)     :: wbk(nkp),ebk(nvdim,nkp,nspin)
    Real(t_real),Intent(in)     :: mp_width,emin,emax,spinfac
    Real(t_real),Intent(out)    :: nos(nptdos)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="splnos"
    Integer(t_int) :: ie,i0,i1,ikp,ib,ms
    Real(t_real)   :: eps
    Real(t_real)   :: xmin,e,step,del,stp,wt,eb,x
    Real(t_real)   :: dos(nptdos)
    !!
    nos(:)=0.0_t_real
    dos(:)=0.0_t_real

    eps=1.0e-20_t_real
    xmin=mp_width*Sqrt(-Log(eps))
    !Print *,'width=',mp_width*hatoev
    !Print *,'eps=',eps
    !Print *,'xmin=',xmin*hatoev
    !Print *,'emin=',emin
    !Print *,'emax=',emax
    
    !! e=emin+(ie-1)*(emax-emin)/(nptdos-1)
    !!
    step=(emax-emin)/Real(nptdos-1,t_real)
    !!
    Call delstp(del,mp_norder,stp,xmin/mp_width)
    If(outlevel>L_many) Write(outfile,300)2.0_t_real*xmin*hatoev,del
    !!
    !!
    Do ikp=1,nkp
       wt=wbk(ikp)*spinfac
       Do ib=1,nband
          Do ms=ms0,ms1
             eb=ebk(ib,ikp,ms)
             !Print *,'eb=',eb
             If(eb+xmin<emin) Then
                Do ie=1,nptdos
                   nos(ie)=nos(ie)+wt
                Enddo
                Cycle
             Endif
             If(eb-xmin>emax)Cycle
             !!
             i0=Max(1_t_int,Nint(Max(0.0_t_real,(eb-xmin-emin)/step),t_int)+1-2)
             i1=Min(nptdos,Nint(Min(Real(nptdos-1,t_real),(eb+xmin-emin)/step),t_int)+1+2)
             !Print *,'x0=',Max(0.0_t_real,(eb-xmin-emin)/step)
             !Print *,'x1=',Min(Real(nptdos-1,t_real),(eb+xmin-emin)/step)
             !Print *,'i0=',i0
             !Print *,'i1=',i1
             !Print *,'ndos=',nos(1)

             If(i1<1)Then
                Do ie=1,nptdos
                   nos(ie)=nos(ie)+wt
                Enddo
                Cycle
             Endif
             If(i0>nptdos) Cycle
             Do ie=i0,i1
                e=emin+(ie-1)*step
                x=(e-eb)/mp_width
                Call delstp(del,mp_norder,stp,x)
                nos(ie)=nos(ie)+wt*(1.0_t_real-stp)
                dos(ie)=dos(ie)+wt*del/mp_width
             Enddo

             Do ie=i1+1,nptdos
                nos(ie)=nos(ie)+wt
             Enddo
          Enddo
       Enddo
    Enddo
!!$    Open(12,file='nos')
!!$    Do ie=1,nptdos
!!$       e=emin+(ie-1)*step
!!$       Write(12,"(10(e30.15e3,1x))")e*hatoev,nos(ie),dos(ie)/hatoev
!!$    Enddo
!!$    Close(12)
!!$    Open(12,file='delstp')
!!$    Do ie=1,nptdos
!!$       e=-xmin+(ie-1)*2.0_t_real*xmin/Real(nptdos-1,t_real)
!!$       x=(e-0)/mp_width
!!$       Call delstp(del,mp_norder,stp,x)
!!$       Write(12,"(10(e30.15e3,1x))")e,del,1.0_t_real-stp
!!$    Enddo
!!$    Close(12)
    Return
300 Format(' SPLNOS: Range of gaussians is ',f5.2,' eV'&
         & /9x,'Error estimate in DOS: ',e10.3e2,' per state.')
  End Subroutine splnos
  !!***********************************************************************
  Subroutine sfermi(dosef,e1,e2,efermi,nptdos,nos,zval)
    !!- Finds E_F from a tabulated number of states function
    !!-----------------------------------------------------------------------
    !!i  Input
    !!i   emax  :upper bound of energy window
    !!i   emin  :lower bound of energy window
    !!i   ndos  :number of energy mesh points
    !!i   nos   :integrated DOS
    !!i   zval  :valence charge
    !!o  Output
    !!o   efermi:Fermi energy
    !!-----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nptdos
    Real(t_real),Intent(in)      :: nos(nptdos),zval
    Real(t_real),Intent(inout)   :: e1,e2
    Real(t_real),Intent(out)     :: dosef
    Real(t_real),Intent(inout)   :: efermi
    !!LOCAL
    Character(*),Parameter::nsubfunc="sfermi"
    Integer(t_int) :: i0,i1
    Real(t_real)   :: q,q1,q2,step
    Real(t_real),Parameter  ::  tiny=1.0e-6_t_real
    !!
    step = (e2-e1)/Real(nptdos-1_t_int,t_real)

    !Print *,'nos(1)=',nos(1),zval+tiny
    !Print *,'nos(n)=',nos(nptdos),zval-tiny
    If (nos(1)-zval > tiny) Then
           Write(errbuf,"('''Fermi energy lies below E1,  NOS(E1)=',f8.4&
            &,' ZVAL=',f3.0,' ! ''')") nos(1_t_int),zval
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
       e1=e1-1.0_t_real
       Return
    Elseif (nos(nptdos)-zval < -tiny) Then
       Write(errbuf,"('''Fermi energy= lies above E2  NOS(E2)=',f8.4&
            &,' ZVAL=',f3.0,'!''')") nos(nptdos),zval
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
       e2=e2+1.0_t_real
       Return
    Endif

    q=zval+Epsilon(1.0_t_real)
    i0=1
    Do While (nos(i0+1) <= q)
       i0=i0+1_t_int
    Enddo
    !q=zval-Epsilon(1.0_t_real)
    !i1=nptdos
    !Do While (nos(i1-1) >= q)
    !   i1=i1-1_t_int
    !Enddo
    !i1=Max(i1,i0+1)
    i1=i0+1
    !Print *,'i0=',i0
    !Print *,'i1=',i1
    q1 = nos(i0)
    q2 = nos(i1)
    !Print *,'q1=',q1
    !Print *,'q2=',q2
    e2 = e1 + step*(i1-1)
    e1 = e1 + step*(i0-1)
    !Print *,'e1=',e1
    !Print *,'e2=',e2
    efermi = e1 + (zval-q1)/(q2-q1)*(e2-e1)
    dosef = (q2-q1)/(e2-e1)
    !!
    Return
    !!
  End Subroutine sfermi
  !!***********************************************************************
  Subroutine splwts(fsm,bzone,bweitk,ebkfsm,efermi,Bfsm,dBfsm,nband,nkp&
       &,nspin,nvdim,spinfac,zval,bandenergy,calcfermisurfaceweights,dbweitk&
       &,Mnn)
    !!- make sampling weights for integrals under the Fermi surface
    !!-----------------------------------------------------------------------
    !!i  Input
    !!i   ebk :energy bands
    !!i   efermi:Fermi energy
    !!i   nband  :number of bands
    !!i   nkp   :number of irreducible k-points
    !!i   mp_norder:Methfessel-Paxton order parameter
    !!i   nspin   :=1 spin degenerate or rel, =2 non-degenerate (non rel)
    !!i   mp_width :Methfessel-Paxton width parameter
    !!i   wbk  :weight of k-point, including spin degeneracy (from BZMESH)
    !!o  Output
    !!o   bweitk :band and E_F - dependent k-point weights for integration
    !!r  Remarks:
    !!r    sum of occupied eigenvalues = sum_n,k  width_nk E_nk
    !!r    width_nk are generalised occupation numbers;
    !!r    see Needs et al. Phys Rev B 33 (1986) 3778, eqs 1 & 2.
    !!-----------------------------------------------------------------------
    Implicit None
    !!IO
    Type(T_Bzone),Intent(in)    :: bzone 
    Logical(t_log),Intent(in)   :: calcfermisurfaceweights
    Logical(t_log),Intent(in)   :: fsm
    Integer(t_int),Intent(in)   :: nkp,nband,nspin,nvdim
    Real(t_real),Intent(in)     :: ebkfsm(nvdim,nkp,nspin)
    Real(t_real),Intent(in),Optional :: Mnn(:,:)
    Real(t_real),Intent(in)     :: zval,efermi,Bfsm,dBfsm
    Real(t_real),Intent(in)     :: spinfac
    Real(t_real),Intent(out)    :: bweitk(nband,nkp,nspin)
    Real(t_real),Intent(out)    :: dbweitk(nband,nkp,nspin)
    Real(t_real),Intent(out)    :: bandenergy(2)
    !!LOCAL
    Character(*),Parameter::nsubfunc="splwts"
    Logical(t_log) :: lsw,rel
    Integer(t_int) :: ikp,iband,ms
    Real(t_real)  :: d,s,sumwgt,x,w
    Real(t_real),Parameter   :: tol=1.0e-6_t_real
    !!
    lsw=.True.
    If(debugfun(nmodule,nsubfunc,'NO_WEIGHT_SYM'))lsw=.False.
    !!
    rel=Present(Mnn)
    !!
    bweitk(:,:,:)=0.0_t_real
    If(calcfermisurfaceweights) dbweitk(:,:,:)=0.0_t_real
    bandenergy(1:2)=0.0_t_real

    !!
    Do ikp = 1_t_int, nkp
       Do iband = 1_t_int, nband
          Do ms = 1_t_int, nspin
             x = (efermi - ebkfsm(iband,ikp,ms)) / bzone% mp_width
             Call delstp(d,bzone% mp_norder,s,x)
             w=bzone% p_wbk(ikp)*(1.0_t_real-s)*spinfac
             bweitk(iband,ikp,ms)=w
             
             bandenergy(ms)=bandenergy(ms)+w*ebkfsm(iband,ikp,ms)
             
             If(fsm)Then
                If(rel)Then
                   bandenergy(ms)=bandenergy(ms)-Bfsm*Mnn(iband,ikp)*w
                Else
                   bandenergy(ms)=bandenergy(ms)-w*(3-2*ms)*Bfsm
                Endif
             Endif

             If(calcfermisurfaceweights)Then
                dbweitk(iband,ikp,ms)=bzone% p_wbk(ikp)*d&
                     &/bzone% mp_width*spinfac
             Endif
          Enddo
       Enddo
    Enddo
    !!
    If(lsw) Then
       Call symmetrize_weights(nkp,nvdim,nband,nspin,bweitk,ebkfsm&
            &,bzone% p_irredindex,bzone% symeqkpoint_fullbz)
       If(calcfermisurfaceweights)Then
          Call symmetrize_weights(nkp,nvdim,nband,nspin,dbweitk,ebkfsm&
               &,bzone% p_irredindex,bzone% symeqkpoint_fullbz)
       Endif
    Endif
    !!
    sumwgt=Sum(bweitk(:,:,:))
    !!
    If (outlevel > L_info) Then
       If(fsm)Then
          Write(outfile,300)efermi,-Bfsm,-dBfsm,sumwgt,Sum(bandenergy(1:2))
       Else
          Write(outfile,302)efermi,sumwgt,Sum(bandenergy(1:2))
       Endif
    Endif
    !!
    If (Abs(sumwgt-zval) > tol) Then
       
       Write(errbuf,"('''number of valence electrons=',f6.3,''',/&
            &,'', sum of weights=',f6.3,''',/&
            &,'', maybe you should increase nx,ny,nz.''')") zval,sumwgt
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
    Endif
    !!
    Return
    !!
300 Format(' SPLWTS: Fermi energy:',f10.6,' Bfsm=',f10.6,' dB=',f10.6 &
         & ,';',f10.6,' electrons',/,9x,'Band energy:',f15.8)
302 Format(' SPLWTS: Fermi energy:',f10.6 &
         & ,';',f10.6,' electrons',/,9x,'Band energy:',f15.8)
    !!
  End Subroutine splwts
  !!***********************************************************************
  Subroutine delstp(del,norder,stp,x)
    !!- Returns generalised delta and step functions (Methfessel & Paxton)
    !!-----------------------------------------------------------------------
    !!i  Input
    !!i   norder:> -1: order of approximant;
    !!i   x     :argument
    !!o  Output
    !!o   del   :see remarks
    !!o   stp   :see remarks
    !!r  Remarks:
    !!r    D_n (x) = exp -x^2 * sum_i=0^n A_i H_2i(x)
    !!r    S_n (x) = (1 - erf x)/2 + exp -x^2 * sum_i=1^n A_i H_{2i-1}(x)
    !!r    where H is a Hermite polynomial and
    !!r    A_i = (-1)^i / ( i! 4^i sqrt(pi) )
    !!r    derrfc is an external double precision function returning the
    !!r          complementary error function
    !!-----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: norder
    Real(t_real),Intent(in)     :: x
    Real(t_real),Intent(out)    :: stp,del
    !!LOCAL
    Integer(t_int) :: i,k
    Real(t_real)  :: a,h1,h2,h3,s0,ex2
    !!
    ex2 = Exp(-(x*x))
    !s0 = 0.5_t_real * derrfc(x)
    s0 = 0.5_t_real * (1.0_t_real-erf(x))
    a = 1.0_t_real / sqpi
    k = 0_t_int
    h1 = 1.0_t_real
    h2 = 2.0_t_real * x
    stp = 0.0_t_real
    del = a
    Do  i = 1_t_int, norder
       a = - (a / ( 4.0_t_real * i ))
       k = k + 1_t_int
       h3 = h1
       h1 = h2
       h2 = 2.0_t_real * (x*h2 - k*h3)
       stp = stp + a * h1
       k = k + 1_t_int
       h3 = h1
       h1 = h2
       h2 = 2.0_t_real * (x*h2 -  k*h3)
       del = del + a * h1
    Enddo
    del = del * ex2
    stp = s0 + stp * ex2
  End Subroutine delstp
  !!***********************************************************************
  !!
  Subroutine tetdos(dos,nos,ebk,emax,emin,tet,nvdim,nkp,ne,ntet,ntetsum&
       &,aw,spinfac,ib0)
    !!- Density of states to third order by tetrahedron method
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   aw    :weights for energy points
    !!i   ebk   :band energies
    !!i   emax  :upper bound of energy window
    !!i   emin  :lower bound of energy window
    !!i   tet :tet(1-5,i) points to the 4 irreducible k-points defining
    !!i           the tetrahedron. tet(0,i)=no. of tetr. of the i'th kind
    !!i   nkp   :number of irreducible k-points (from BZMESH)
    !!i   nvdim :number of bands
    !!i   ne    :no of DOS tabulation points in energy range: [emin, emax]
    !!i   ntet  :number of different tetrahedra (output from TETIRR)
    !!o Outputs:
    !!o   dos   :DOS for weight function aw
    !!o   nos   :integrated DOS
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)   :: nvdim,ntet,nkp,ne
    Integer(t_int),Intent(in)   :: ib0
    Integer(t_int),Intent(in)   :: tet(0:5,ntet)
    Real(t_real),Intent(in)     :: spinfac,ntetsum
    Real(t_real),Intent(in)     :: ebk(nvdim,nkp),emin,emax
    Real(t_real),Intent(out)    :: dos(ne)
    Real(t_real),Intent(out)    :: nos(ne)
    Real(t_real),Intent(in)     :: aw(nvdim,nkp)
    !!LOCAL
    Integer(t_int) :: ib,itet,ikp1,ikp2,ikp3,ikp4,nbw
    Real(t_real)  :: ecorn(4),tetwgt,volwgt,ebot,etop,acorn(4)
    Real(t_real)   ::  wt
    !!
    volwgt = spinfac / ntetsum
    !!
    !!
    If(ib0<1)Then
       nbw=nvdim
    Else
       nbw=ib0
    Endif
    !!
    !!
    !! --- Loop over tetrahedra ---
    tetloop: Do itet = 1_t_int, ntet
       !Print "('dos: ',f10.2,'%')",100.0_t_real*itet/ntet
       ikp1=tet(1_t_int,itet)
       ikp2=tet(2_t_int,itet)
       ikp3=tet(3_t_int,itet)
       ikp4=tet(4_t_int,itet)
       tetwgt=volwgt*tet(0_t_int,itet)
       
       !! ----- Loop over bands
       bandloop: Do ib = Max(ib0,1_t_int), nbw
          !! --------- SET UP ENERGIES AT 4 CORNERS OF TETRAHEDRA
          ecorn(1_t_int) = ebk(ib,ikp1)
          ecorn(2_t_int) = ebk(ib,ikp2)
          ecorn(3_t_int) = ebk(ib,ikp3)
          ecorn(4_t_int) = ebk(ib,ikp4)

          acorn(1_t_int) = aw(ib,ikp1)
          acorn(2_t_int) = aw(ib,ikp2)
          acorn(3_t_int) = aw(ib,ikp3)
          acorn(4_t_int) = aw(ib,ikp4)
          ebot = Min(ecorn(1_t_int),ecorn(2_t_int),ecorn(3_t_int),ecorn(4_t_int))
          etop = Max(ecorn(1_t_int),ecorn(2_t_int),ecorn(3_t_int),ecorn(4_t_int))
          If (ebot <  emax) Then
             If(.True.)Then
             !If(.False.)Then
                !! new treatment, where partial DOS are really first order
                !! tetrahedron integrals
                !! accumulate the number of states from this tetrahedron
                Call slinz1(acorn,tetwgt,ecorn,emin,emax,nos,ne)
                If (etop > emin)Then
                   Call sliny1(acorn,tetwgt,ecorn,emin,emax,dos,ne)
                Endif
             Else
                !! old treatment, where partial DOS weights are averaged
                !! over tetra
                !! ---- assume constant weight in the tetrahedron ---
                wt=aw(ib,ikp1)+aw(ib,ikp2)+aw(ib,ikp3)+aw(ib,ikp4) 
                wt = 0.25_t_real * wt * tetwgt
                !! accumulate the number of states from this tetrahedron
                Call slinz(wt,ecorn,emin,emax,nos,ne)
                If (etop > emin)Then
                   Call sliny(wt,ecorn,emin,emax,dos,ne)
                Endif
             Endif
          Endif
       Enddo bandloop
    Enddo tetloop
    !!
    !!
  End Subroutine tetdos
  !!***********************************************************************
  !!
  Subroutine tetdostotal(dos,nos,ebk,emax,emin,tet,nvdim,nkp,ne,ntet,ntetsum&
       &,spinfac,ib0)
    !!- Density of states to third order by tetrahedron method
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   ebk   :band energies
    !!i   emax  :upper bound of energy window
    !!i   emin  :lower bound of energy window
    !!i   tet :tet(1-5,i) points to the 4 irreducible k-points defining
    !!i           the tetrahedron. tet(0,i)=no. of tetr. of the i'th kind
    !!i   nkp   :number of irreducible k-points (from BZMESH)
    !!i   nvdim :number of bands
    !!i   ne    :no of DOS tabulation points in energy range: [emin, emax]
    !!i   ntet  :number of different tetrahedra (output from TETIRR)
    !!o Outputs:
    !!o   dos   :total DOS
    !!o   nos   :integrated DOS
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)   :: nvdim,ntet,nkp,ne
    Integer(t_int),Intent(in)   :: ib0
    Integer(t_int),Intent(in)   :: tet(0:5,ntet)
    Real(t_real),Intent(in)     :: spinfac,ntetsum
    Real(t_real),Intent(in)     :: ebk(nvdim,nkp),emin,emax
    Real(t_real),Intent(out)    :: dos(ne)
    Real(t_real),Intent(out)    :: nos(ne)
    !!LOCAL
    Integer(t_int) :: ib,itet,ikp1,ikp2,ikp3,ikp4,nbw
    Real(t_real)  :: ecorn(4),tetwgt,volwgt,ebot,etop,acorn(4)
    Real(t_real)   ::  wt
    !!
    volwgt = spinfac / ntetsum
    !!
    !!
    If(ib0<1)Then
       nbw=nvdim
    Else
       nbw=ib0
    Endif
    !!
    !!
    !! --- Loop over tetrahedra ---
    tetloop: Do itet = 1_t_int, ntet
       !Print "('dos: ',f10.2,'%')",100.0_t_real*itet/ntet
       ikp1=tet(1_t_int,itet)
       ikp2=tet(2_t_int,itet)
       ikp3=tet(3_t_int,itet)
       ikp4=tet(4_t_int,itet)
       tetwgt=volwgt*tet(0_t_int,itet)
       
       !! ----- Loop over bands
       bandloop: Do ib = Max(ib0,1_t_int), nbw
          !! --------- SET UP ENERGIES AT 4 CORNERS OF TETRAHEDRA
          ecorn(1_t_int) = ebk(ib,ikp1)
          ecorn(2_t_int) = ebk(ib,ikp2)
          ecorn(3_t_int) = ebk(ib,ikp3)
          ecorn(4_t_int) = ebk(ib,ikp4)

          acorn(1_t_int) = 1.0_t_real
          acorn(2_t_int) = 1.0_t_real
          acorn(3_t_int) = 1.0_t_real
          acorn(4_t_int) = 1.0_t_real
          ebot = Min(ecorn(1_t_int),ecorn(2_t_int),ecorn(3_t_int),ecorn(4_t_int))
          etop = Max(ecorn(1_t_int),ecorn(2_t_int),ecorn(3_t_int),ecorn(4_t_int))
          If (ebot <  emax) Then
             If(.True.)Then
             !If(.False.)Then
                !! new treatment, where partial DOS are really first order
                !! tetrahedron integrals
                !! accumulate the number of states from this tetrahedron
                Call slinz1(acorn,tetwgt,ecorn,emin,emax,nos,ne)
                If (etop > emin)Then
                   Call sliny1(acorn,tetwgt,ecorn,emin,emax,dos,ne)
                Endif
             Else
                !! old treatment, where partial DOS weights are averaged
                !! over tetra
                !! ---- assume constant weight in the tetrahedron ---
                wt =   tetwgt
                !! accumulate the number of states from this tetrahedron
                Call slinz(wt,ecorn,emin,emax,nos,ne)
                If (etop > emin)Then
                   Call sliny(wt,ecorn,emin,emax,dos,ne)
                Endif
             Endif
          Endif
       Enddo bandloop
    Enddo tetloop
    !!
    !!
  End Subroutine tetdostotal
  !!***********************************************************************
  Subroutine sliny(volwgt,ecorn,emin,emax,dos,npts)
    !!- Adds to density-of-states for one tetrahedron
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   volwgt:weight of irreducible tetrahedron
    !!i   ecorn :energies at corners of tetrahedron
    !!i   emin  :lower bound of energy window
    !!i   emax  :upper bound of energy window
    !!io  dos   :density of states from tetrahedron
    !!i   npts  :number of dos tabulation points
    !!o Outputs:
    !!io  dos   :density of states from tetrahedron
    !!r Remarks:
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: npts
    Real(t_real),Intent(in)     :: volwgt,emin,emax
    Real(t_real),Intent(inout)  :: ecorn(4),dos(npts)
    !!LOCAL
    Integer(t_int) :: i,i0(4),m
    Real(t_real)  :: de,e1,e2,e3,e4,c1,c2,c3,x
    !! ----sort ecorn -------
    Call dshell(1_t_int,4_t_int,ecorn,1.0e-12_t_real)
    e1 = ecorn(1_t_int)
    e2 = ecorn(2_t_int)
    e3 = ecorn(3_t_int)
    e4 = ecorn(4_t_int)
    If (e4 < emin .Or. e1 > emax) Return
    de = (emax-emin)/(npts-1_t_int)
    Do m=1_t_int,4_t_int
       If (ecorn(m) < emin) Then
          i0(m)=1_t_int
       Elseif (ecorn(m) > emax) Then
          i0(m)=npts+1_t_int
       Else
          i0(m) = 2_t_int + Int((ecorn(m)-emin)/de - Epsilon(1.0_t_real)&
               &,t_int)
       Endif
    Enddo
    If (i0(1_t_int) < i0(2_t_int)) Then
       c3 = volwgt*3.0_t_real/((e2-e1)*(e3-e1)*(e4-e1))
       Do i = i0(1_t_int), i0(2_t_int)-1_t_int
          x = emin - e1 + (i-1_t_int)*de
          dos(i) = dos(i) + c3*x*x
       Enddo
    Endif
    If (i0(2_t_int) < i0(3_t_int)) Then
       c3 = volwgt*3.0_t_real*(e1+e2-e3-e4)/((e3-e1)*(e4-e1)*(e3-e2)*(e4-e2))
       c2 = volwgt*6.0_t_real/((e3-e1)*(e4-e1))
       c1 = c2*(e2-e1)*0.5_t_real
       Do i = i0(2_t_int), i0(3_t_int)-1_t_int
          x = emin - e2 + (i-1_t_int)*de
          dos(i) = dos(i) +  c1 + x*(c2 + x*c3)
       Enddo
    Endif
    If (i0(3_t_int) < i0(4_t_int)) Then
       c3 = volwgt*3.0_t_real/((e4-e3)*(e4-e2)*(e4-e1))
       Do i = i0(3_t_int), i0(4_t_int)-1_t_int
          x = emin - e4 + (i-1_t_int)*de
          dos(i) = dos(i) + c3*x*x
       Enddo
    Endif
  End Subroutine sliny
  !!***********************************************************************
  Subroutine sliny1(acorn,volwgt,ecorn,emin,emax,dos,npts)
    !!- Adds to density-of-states for one tetrahedron
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   volwgt:weight of irreducible tetrahedron
    !!i   ecorn :energies at corners of tetrahedron
    !!i   acorn :weigths of partial DOS at corners of tetrahedron
    !!i   emin  :lower bound of energy window
    !!i   emax  :upper bound of energy window
    !!io  dos   :density of states from tetrahedron
    !!i   npts  :number of dos tabulation points
    !!o Outputs:
    !!io  dos   :density of states from tetrahedron
    !!r Remarks:
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: npts
    Real(t_real),Intent(in)      :: volwgt,emin,emax
    Real(t_real),Intent(in)      :: acorn(4)
    Real(t_real),Intent(inout)   :: ecorn(4),dos(npts)
    !!LOCAL
    Integer(t_int) :: i,i0(4),m,iwk(4)
    Real(t_real)  :: de,e1,e2,e3,e4,c1,c2,c3,x,ac0,ec(4),ac(4)
    Real(t_real)   :: da41,da31,da21,da42,da43,a1,a2,a3,a4,q,x0
    Real(t_real)   :: de21,de31,de41,de42,de43,de32
    Real(t_real)   :: c4,q31,q41,dq,q1,q2,q3,q4
    !! ----sort ecorn -------
    Call dshel2(1_t_int,4_t_int,ecorn,iwk,1.0e-12_t_real)
    Do i=1,4
       ec(i)=ecorn(iwk(i)+1)
       ac(i)=acorn(iwk(i)+1)
    Enddo
    ac0=Sum(acorn)/4

    e1 = ec(1)
    e2 = ec(2)
    e3 = ec(3)
    e4 = ec(4)
    If (e4 < emin .Or. e1 > emax) Return
    a1 = ac(1)
    a2 = ac(2)
    a3 = ac(3)
    a4 = ac(4)
    de = (emax-emin)/(npts-1_t_int)
    Do m=1_t_int,4_t_int
       If (ec(m) < emin) Then
          i0(m)=1_t_int
       Elseif (ec(m) > emax) Then
          i0(m)=npts+1_t_int
       Else
          i0(m) = 2_t_int + Int((ec(m)-emin)/de - Epsilon(1.0_t_real)&
               &,t_int)
       Endif
    Enddo
    da21=a2-a1
    da31=a3-a1
    da41=a4-a1
    de31=1.0_t_real/(e3-e1)
    de41=1.0_t_real/(e4-e1)
    If (i0(1_t_int) < i0(2_t_int)) Then
       de21=1.0_t_real/(e2-e1)
       q=(da21*de21+da31*de31+da41*de41)*c1o3
       c3 = volwgt*3.0_t_real*de21*de31*de41
       x0 = emin-e1-de
       Do i = i0(1_t_int), i0(2_t_int)-1_t_int
          x = x0 + i*de
          dos(i) = dos(i) + c3*x*x*(a1 + x*q)
       Enddo
    Endif
    If (i0(2_t_int) < i0(3_t_int)) Then
       de21=e2-e1
       de42=e4-e2
       de32=e3-e2
       c4 = volwgt/(de32**2*de42**2)
       c3 = volwgt*3.0_t_real*(e1+e2-e3-e4)/(de32*de42)*de31*de41
       c2 = volwgt*6.0_t_real*de31*de41
       c1 = c2*de21*0.5_t_real

       !!
       q31=da31*de31
       q41=da41*de41
       q=q31+q41
       dq=da21+de21*q
       !!

       q1= a1 + dq*c1o3
       q2= a1 + dq*0.5_t_real
       q3= a1*c3 +da21*c3 +c2*q*0.5_t_real
       q4=+c3*(q-da21/de32)*c1o3&
            &-c4*(de42*q31+de32*(q41-da21*de41))
       !!
       x0 = emin-e2-de
       Do i = i0(2_t_int), i0(3_t_int)-1_t_int
          x = x0 + i*de
          dos(i) = dos(i)   + c1*q1  + x*(c2*q2  + x*(q3+x*q4))
       Enddo
    Endif
    If (i0(3_t_int) < i0(4_t_int)) Then
       de42=1.0_t_real/(e4-e2)
       de43=1.0_t_real/(e4-e3)
       da42=a4-a2
       da43=a4-a3
       q=(da41*de41+da42*de42+da43*de43)*c1o3
       c3 = volwgt*3.0_t_real*de42*de43*de41
       x0 = emin-e4-de
       Do i = i0(3_t_int), i0(4_t_int)-1_t_int
          x = x0 +i*de
          dos(i) = dos(i)  + c3*x*x*(a4+x*q)
       Enddo
    Endif
    !!
    Return
    !!
  End Subroutine sliny1
  !!***********************************************************************
  !! make sure that degenerate bands at a certain k-point get equal
  !! weight, otherwise the symmetry of the k-integrated
  !! matrices (occupation numbers and resulting denisty)
  !! will loose the symemtry properties even in full-BZ mode
  Subroutine  symmetrize_weights(nkp,nvdim,nband,nspin,bweitk,ebk&
       &,irredindex,symeqkpoint_fullbz)
    !!
    Implicit None  
    !!IO
    Logical(t_log),Intent(in)    :: symeqkpoint_fullbz
    Integer(t_int),Intent(in)    :: nkp,nband,nvdim,nspin
    Integer(t_int),Intent(in)    :: irredindex(nkp)
    Real(t_real),Intent(in)      :: ebk(nvdim,nkp,nspin)
    Real(t_real),Intent(inout)   :: bweitk(nband,nkp,nspin)
    !!LOCAL
    Character(*),Parameter::nsubfunc="symmetrize_weights"
    Logical(t_log) :: prot,err
    Integer(t_int) :: ikp,ib,ib1,ib2,ms,iikp,jkp,n
    Real(t_real)   :: d,w,e,maxerr,we
    Real(t_real),Pointer :: lbw(:,:,:)
    Real(t_real),Parameter   :: wtol=1.0e-8_t_real
    !!
    Nullify(lbw)
    !!
    prot=debugfun(nmodule,nsubfunc,'PROT')
    !!
    If(prot)Then
       Write(outfile,1) 
       Do ms=1,nspin
          Do ikp=1,nkp
             Do ib=1,nband
                Write(outfile,12) ikp,ib,bweitk(ib,ikp,ms),ebk(ib,ikp,ms)
             Enddo
             Write(outfile,13)
          Enddo
       Enddo
    Endif
    !!
    If (symeqkpoint_fullbz.And..Not.debugfun(nmodule,nsubfunc,'NO_INTER_K'))Then
       !! symmetrize between equivalent k-points 
       !!
       Call palloc('lbw',lbw,1_t_int,nband,1_t_int,nkp,1_t_int,nspin&
            &,nmodule,nsubfunc)
       !!
       lbw=0.0_t_real
       Do ikp=1,nkp
          iikp=irredindex(ikp)
          lbw(1:nband,iikp,1:nspin)=lbw(1:nband,iikp,1:nspin)&
               &+bweitk(1:nband,ikp,1:nspin)
       Enddo
       !!
       Do ikp=1,nkp
          If(ikp==irredindex(ikp))Then
             n=0
             Do jkp=1,nkp
                If(ikp==irredindex(jkp))Then
                   n=n+1
                Endif
             Enddo
             lbw(1:nband,ikp,1:nspin)=lbw(1:nband,ikp,1:nspin)/n
          Endif
       Enddo
       Do ikp=1,nkp
          bweitk(1:nband,ikp,1:nspin)=lbw(1:nband,irredindex(ikp),1:nspin)
       Enddo
       Call pfree(lbw)
       !!
    Endif
    !!
    !!
    !! symmetrize degenerate subspaces at each k-point
    !!
    spinloop: Do ms=1,nspin
       kloop: Do ikp=1,nkp
          ib=1
          e=ebk(ib,ikp,ms)
          ib1=ib
          ib2=ib
          bandloop: Do ib=2,nband
             d=Abs(e-ebk(ib,ikp,ms))
             If(Abs(e)>1.0_t_real)Then
                d=d/Abs(e)
             Endif
             If(d<wtol)Then
                ib2=ib
             Else
                !! take average of weights of degenerate bands
                w=Sum(bweitk(ib1:ib2,ikp,ms))/Real(ib2-ib1+1,t_real)
                bweitk(ib1:ib2,ikp,ms)=w
                e=ebk(ib,ikp,ms)
                ib1=ib
                ib2=ib
             Endif
          Enddo bandloop
          w=Sum(bweitk(ib1:ib2,ikp,ms))/Real(ib2-ib1+1,t_real)
          bweitk(ib1:ib2,ikp,ms)=w
       Enddo kloop
    Enddo spinloop
    !!
    !! paranoia
    !!
    maxerr=0.0_t_real
    err=.False.
    Do ms=1,nspin
       Do ikp=1,nkp
          ib=1
          e=ebk(ib,ikp,ms)
          w=bweitk(ib,ikp,ms)
          Do ib=2,nband
             d=Abs(e-ebk(ib,ikp,ms))
             If(Abs(e)>1.0_t_real)Then
                d=d/Abs(e)
             Endif
             If(d<wtol)Then
                we=Abs(w-bweitk(ib,ikp,ms))
                If(we>wtol)Then
                   If(prot)Then
                      Write(outfile,301) ikp,ib-1,e,w&
                           &,ib,ebk(ib,ikp,ms),bweitk(ib,ikp,ms)&
                           &,we
301                   Format('ikp=',i7&
                           &,/,t10,' iband        Energy        WEIGHT'&
                           &,/,t10,i6,1x,f15.7,1x,f15.7&
                           &,/,t10,i6,1x,f15.7,1x,f15.7&
                           &,/,t10,'ERROR=',e30.15e3) 
                   Endif
                   maxerr=Max(maxerr,we)
                   err=.True.
                Endif
             Endif
             e=ebk(ib,ikp,ms)
             w=bweitk(ib,ikp,ms)
          Enddo
       Enddo
    Enddo
    If(err)Then
300    Format("'Weights not symmetric: max error=",f11.6," ?'") 
       Write(errbuf,300)maxerr
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
    Endif
    !!
    If(prot)Then
       Write(outfile,2) 
       Do ms=1,nspin
          Do ikp=1,nkp
             Do ib=1,nband
                Write(outfile,12) ikp,ib,bweitk(ib,ikp,ms),ebk(ib,ikp,ms)
             Enddo
             Write(outfile,13)
          Enddo
       Enddo
    Endif
    !!
    !!
    !!
    !!
    If(prot)Then 
       Call terminate(TERM_NORMAL&
            &,Trim(nsubfunc)//': due to debug option ''PROT''!')
    Endif
    !!
    !!
    Return
    !!
1   Format(' UN-SYMMETRIC KN-INTEGRATION WEIGHTS'&
         &,/,'    ikp  iband          WEIGHT           ENERGY') 
2   Format(' SYMMETRIZED KN-INTEGRATION WEIGHTS'&
         &,/,'    ikp  iband          WEIGHT           ENERGY') 
12  Format(i7,1x,i6,2x,2(f15.7,2x)) 
13  Format() 
    !!
  End Subroutine symmetrize_weights
  !!***********************************************************************
  Subroutine FSavwgts(tetwgt,ecorn,efermi,wt)
    !!- Makes total weights for integration over FS for one tetrahedron.
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   tetwgt:weight of irreducible tetrahedron
    !!i   ecorn :energy of four corners of tetrahedron
    !!i   efermi:Fermi energy
    !!o Outputs:
    !!o   wt    :total weight of tetrahedron
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Real(t_real),Intent(in)     :: tetwgt,ecorn(4),efermi
    Real(t_real),Intent(out)    :: wt
    !!LOCAL
    Integer(t_int) :: isort(4)
    Real(t_real)   :: e1,e2,e3,e4,a31,a41,a32,a42,a14,a24
    !!
    !! --- SORT ENERGIES INTO E1, E2, E3, E4 -----
    Call dshel2(1_t_int,4_t_int,ecorn,isort,1.0e-12_t_real)
    e1 = ecorn(isort(1_t_int)+1_t_int)
    e2 = ecorn(isort(2_t_int)+1_t_int)
    e3 = ecorn(isort(3_t_int)+1_t_int)
    e4 = ecorn(isort(4_t_int)+1_t_int)
    
    wt=0.0_t_real
    If (efermi  <= e1) Then
       Return
    Elseif (e1 < efermi .And. efermi <= e2) Then
       !! ----- CASE efermi BETWEEN E1,E2
       a31 = (efermi-e1)/(e3-e1)
       a41 = (efermi-e1)/(e4-e1)
       wt = 3.0_t_real*tetwgt*a31*a41/(e2-e1)
    Elseif (e2 < efermi .And. efermi <= e3) Then
       !! ----- CASE efermi BETWEEN E2,E3
       a32 = (efermi-e2)/(e3-e2)
       a42 = (efermi-e2)/(e4-e2)
       wt = ((e1+e2-e3-e4)*a32*a42+2.0_t_real*efermi-e1-e2)/((e3-e1)*(e4-e1))
       wt = 3.0_t_real*tetwgt*wt
    Elseif (e3 < efermi .And. efermi <= e4) Then
       !! ----- CASE efermi BETWEEN E3,E4
       a14 = (efermi-e4)/(e1-e4)
       a24 = (efermi-e4)/(e2-e4)
       wt = -3.0_t_real*tetwgt*a14*a24/(e3-e4)
    Elseif (e4 < efermi) Then
       !! ----- CASE efermi larger than E4
       Return
    Endif
    !!     
    Return
    !!
  End Subroutine FSavwgts
  !!***********************************************************************
  Subroutine plasmonfreg(bzone,ebkfsm,efermi,nband,nkp,nspin&
       &,nvdim,spinfac,lattice_vectors,numops,opmat,vuc)
    !!
    Implicit None
    !!IO
    Type(T_Bzone),Intent(in)     :: bzone 
    Integer(t_int),Intent(in)    :: nkp,nband,nspin,nvdim,numops
    Real(t_real),Intent(in)      :: opmat(3,3,48),vuc
    Real(t_real),Intent(in)      :: lattice_vectors(3,3)
    Real(t_real),Intent(in)      :: ebkfsm(nvdim,nkp,nspin)
    Real(t_real),Intent(in)      :: efermi
    Real(t_real),Intent(inout)   :: spinfac
    !!LOCAL
    !Character(*),Parameter::nsubfunc="plasmonfreg"
    Integer(t_int) :: itet,ikp1,ikp2,ikp3,ikp4,icorn,ms,ib,in
    Integer(t_int) :: itype,ii,jops
    Real(t_real)  :: volwgt,kdel(3,3),kdeli(3,3),vol,ecorn(4)
    Real(t_real)  :: tetwgt,edel(3),vk(3),wt,v2,v
    Real(t_real)   :: minvk(2),maxvk(2),avvk(2),avvk2(2),dosef(2)
    Real(t_real)   :: tavvk,tavvk2,tdosef,vov(3,3,2),vovsym(3,3,2),tvov(3,3)
    Real(t_real)   :: z(3,3),e(3)
    Real(t_real),Parameter :: vauin5mos=2.18769e1_t_real
    !!    
    minvk(1:2)=1.0e30_t_real
    maxvk(1:2)=-1.0e30_t_real
    !!
    !!
    volwgt = spinfac / bzone% ntetsum
    avvk(1:2)=0.0_t_real
    vov(1:3,1:3,1:2)=0.0_t_real
    avvk2(1:2)=0.0_t_real
    dosef(1:2)=0.0_t_real
    !! --- Loop over tetrahedra
    Do itet = 1_t_int, bzone% ntet
       ikp1=bzone% p_tet(1_t_int,itet)
       ikp2=bzone% p_tet(2_t_int,itet)
       ikp3=bzone% p_tet(3_t_int,itet)
       ikp4=bzone% p_tet(4_t_int,itet)
       tetwgt=volwgt*bzone% p_tet(0_t_int,itet)
       
       
       !! determine the tetrahedron gradient matrix
       itype=bzone% p_tet(5,itet)
       Do icorn=1,3
          kdel(icorn,:)=Real(bzone% kcut(:,icorn+1,itype)&
               &-bzone% kcut(:,1,itype),t_real)
       Enddo
       !!
       !!
       Call dinv33(kdel,1_t_int,kdeli,vol)
       !!
       !! ----- Loop over spins and bands
       Do ms = 1_t_int, nspin
          Do ib = 1_t_int, nband
             
             !! --------- SET UP ENERGIES AT 4 CORNERS OF TETRAHEDRA
             ecorn(1_t_int) = ebkfsm(ib,ikp1,ms)
             ecorn(2_t_int) = ebkfsm(ib,ikp2,ms)
             ecorn(3_t_int) = ebkfsm(ib,ikp3,ms)
             ecorn(4_t_int) = ebkfsm(ib,ikp4,ms)
             
             
             !! determin the velocity grad_k e_{kn}
             Do in=1,3
                edel(in)=Dot_product(ecorn(2:4)-ecorn(1),kdeli(:,in))&
                     &*bzone% nkxyz(in)/twopi
             Enddo
             Do in=1,3
                vk(in)=Dot_product(edel,lattice_vectors(in,:))
             Enddo
             
             !! determine the DOS integration weights for
             !! constant a_k (i.e. Fermi velocities, which are constant
             !! in first order tetrahedron method
             
             Call FSavwgts(tetwgt,ecorn,efermi,wt)
             If(wt /= 0.0_t_real) Then
                v2=Sum(vk**2)
                v=Sqrt(v2)
                minvk(ms)=Min(v,minvk(ms))
                maxvk(ms)=Max(v,maxvk(ms))
                Do ii=1,3
                   vov(1:3,ii,ms)=vov(1:3,ii,ms)+wt*vk(1:3)*vk(ii)
                Enddo
                avvk(ms)=avvk(ms)+wt*v
                avvk2(ms)=avvk2(ms)+wt*v2
                dosef(ms)=dosef(ms)+wt
             Endif
             !!
          Enddo
          !!
       Enddo
    Enddo
    
    
    Do ms=1,nspin
       vovsym(:,:,ms)=0.0_t_real
       Do jops=1,numops
          vovsym(:,:,ms)=vovsym(:,:,ms)+Matmul( Transpose(opmat(:,:,jops))&
               &,Matmul(vov(:,:,ms),opmat(:,:,jops)))
       Enddo
       vovsym(:,:,ms)=vovsym(:,:,ms)/Real(numops,t_real)
    Enddo
    
    tdosef=Sum(dosef(1:nspin))
    If(Abs(tdosef)<1.0e-10_t_real)Then
       tavvk=0.0_t_real
       tavvk2=0.0_t_real
    Else
       tavvk=Sum(avvk(1:nspin))/tdosef
       tavvk2=Sqrt(Sum(avvk2(1:nspin))/tdosef)
    Endif
    tvov=0.0_t_real
    Do ms=1,nspin
       tvov(:,:)=tvov(:,:)+vovsym(:,:,ms)
    Enddo
    If(Abs(tdosef)<1.0e-10_t_real)Then
       tvov(:,:)=0.0_t_real
    Else
       tvov(:,:)=tvov(:,:)/tdosef
    Endif

    Open(12,file='+plasmon')
    
    Write(outfile,399) 
    Do ms=1,nspin
       If(Abs(dosef(ms))<1.0e-10_t_real)Then
          avvk(ms)=0.0_t_real
          avvk2(ms)=0.0_t_real
          vovsym(:,:,ms)=0.0_t_real
       Else
          avvk(ms)=avvk(ms)/dosef(ms)*vauin5mos
          avvk2(ms)=Sqrt(avvk2(ms)/dosef(ms))*vauin5mos
          vovsym(:,:,ms)=vovsym(:,:,ms)/dosef(ms)
       Endif
       Write(outfile,400) ms
       Write(outfile,401)dosef(ms)
       Write(outfile,403)avvk(ms)
       Write(outfile,405)avvk2(ms)
       Write(outfile,404)minvk(ms)*vauin5mos,maxvk(ms)*vauin5mos
       Write(outfile,2)
       ii=1
       Write(outfile,406) vovsym(ii,:,ms)*vauin5mos**2
       Do ii=2,3
          Write(outfile,407) vovsym(ii,:,ms)*vauin5mos**2
       Enddo
       !!
       Call mainaxis_decopose(vovsym(:,:,ms),z,e)
       !!
       Write(12,"('spin=',i1)") ms
       Write(12,1416) z(:,1)
       Write(12,1426) z(:,2)
       Write(12,1436) z(:,3)
       Write(12,1408) (Sqrt(e(ii)*dosef(ms)*fourpi/vuc)*hatoev,ii=1,3)
       !!
       Write(outfile,2)
       Write(outfile,416) z(:,1)
       Write(outfile,426) z(:,2)
       Write(outfile,436) z(:,3)
       Write(outfile,2)
       Write(outfile,446) e(:)*vauin5mos**2
       Write(outfile,2)
       Write(outfile,408) (Sqrt(e(ii)*dosef(ms)*fourpi/vuc)*hatoev,ii=1,3)
       Write(outfile,2)
    Enddo
    
    If(nspin ==2)Then
       
       Write(outfile,402) 
       Write(outfile,401)tdosef
       Write(outfile,403)tavvk*vauin5mos
       Write(outfile,405)tavvk2*vauin5mos
       
       Write(outfile,404)Minval(minvk(1:nspin))*vauin5mos&
            &,Maxval(maxvk(1:nspin))*vauin5mos
       Write(outfile,2)
       ii=1
       Write(outfile,406) tvov(ii,:)*vauin5mos**2
       Do ii=2,3
          Write(outfile,407) tvov(ii,:)*vauin5mos**2
       Enddo
       !!
       Call mainaxis_decopose(tvov(:,:),z,e)
       !!
       Write(12,"('spin= total')") 
       Write(12,1416) z(:,1)
       Write(12,1426) z(:,2)
       Write(12,1436) z(:,3)
       Write(12,1408) (Sqrt(e(ii)*tdosef*fourpi/vuc)*hatoev,ii=1,3)
       !!
       Write(outfile,2)
       Write(outfile,416) z(:,1)
       Write(outfile,426) z(:,2)
       Write(outfile,436) z(:,3)
       Write(outfile,2)
       Write(outfile,446) e(:)*vauin5mos**2
       Write(outfile,2)
       Write(outfile,408) (Sqrt(e(ii)*tdosef*fourpi/vuc)*hatoev,ii=1,3)
       Write(outfile,2)
    Endif
    Write(outfile,388)
    !!
    Close(12)
    !!
    Return
    !!
388 Format(/,72('-'))
399 Format(72('-'),/&
         &,t5,'Plasmon frequencies from Lindhard expression (intra band)',/)
400 Format('spin :',i2)
401 Format('DOS(ef)      =  ',f10.4,' [state/Ha]')
403 Format('<|vk|>       =  ',f10.4,' [10^5 m/s]')
405 Format('sqrt(<vk^2>) =  ',f10.4,' [10^5 m/s]')
404 Format('|vk| interval= [',f10.4,',',f10.4,'] [10^5 m/s]')
402 Format('total :')
406 Format('Fermi velocity tensor:',/&
         &,'<v o v> [10^5 m/s]^2 ',3(f10.4,1x))
407 Format('                     ',3(f10.4,1x))
408 Format('Plasma frequencies along main axis from Lindhard (intra band)',/&
         &,'w_p           ',3(f10.4,2x),' eV')
1408 Format('Plasma frequencies along main axis from Lindhard (intra band)',/&
          &,'w_p           ',3(f30.15,2x),' eV')
416 Format('1st main axis        ',3(f10.4,1x))
426 Format('2nd main axis        ',3(f10.4,1x))
436 Format('3rd main axis        ',3(f10.4,1x))
1416 Format('1st main axis        ',3(f30.15,1x))
1426 Format('2nd main axis        ',3(f30.15,1x))
1436 Format('3rd main axis        ',3(f30.15,1x))
446 Format('eigenval.[10^5 m/s]^2',3(f10.4,1x))
2   Format()
    !!
  End Subroutine plasmonfreg
  !!***********************************************************************

  
End Module bzone
