Module develtest
  !!
  Use precisiondefs
  Use constants
  Use memory
  Use tmesh
  Use mesh
  Use vecharm
  Use xc
  Use matrixinvers
  Use file_iounits
  Use clock
  Use ioaux
  Use optionstest
  Use matserv
  Use tdiracdefs
  Use diracdefs
  Use vecharm
  Use prnt
  Use surfaceintegration
  Use integrate1d
  Use bhf
  Use sort
  Use trelativistic
  Use tbzone
  Use bzone
  Use atomdefs
  Use tsymmetry
  Use diagonalize
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="DEVELTEST"  
  !!
  Public :: develtests
  !!***********************************************************************
  Integer(t_int),Parameter :: expect_empty=1!!todo:remove
  Integer(t_int),Parameter :: expect_full=2!!todo:remove
  Integer(t_int),Parameter :: expect_both=3!!todo:remove
  !!***********************************************************************
Contains 
  !!***********************************************************************
  Subroutine develtests()
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="develtests"
    !!
    !!
    If(.False.)Then
       Call Wigner3JTest()
    Endif
    If(.False.)Then
       Call dens_decompose_test()
    Endif
    If(.False.)Then
       Call mul_cc_sccg_test()
    Endif
    If(.False.)Then
       Call lsdau_model()
    Endif
    If(.False.)Then
       Call clocktest()
    Endif
    If(.False.)Then
       Call WignerEckartForcesMatelTest()
    Endif
    If(.False.)Then
       Call Djtest()
    Endif
    If(.False.)Then
       Call testdiagnounit2x2()
    Endif
    If(.False.)Then
       Call diatest()
    Endif
    If(.False.)Then
       Call opticsDos()
    Endif
    If(.False.)Then
       Call lindhard_suscep()
    Endif
    If(.False.)Then
       Call bhfamtel()
    Endif
    If(.False.)Then
       Call potential_gaunt_identity()
    Endif
    If(.False.)Then
       Call cyc()
    Endif
    If(.False.)Then
       Call slabtest
    Endif
    If(.False.)Then
       Call qvylmTest
    Endif
    If(.False.)Then
       Call dgga()
    Endif
    !!
    Return
    !!
  End Subroutine develtests
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine symstuff1()
    !!
    !!
    Implicit none  
    !!IO
    !!LOCAL
    Integer(t_int) :: i,j,l,kinv,deg
    Real(t_real)   :: fac(0:2*12),PPi(3,3),nx(3),ny(3),nz(3),eu(3),DR(3,3)
    Real(t_real)   :: r(3)
    Real(t_real)   :: D2((2*2+1),(2*2+1)),ncub(5,5),nrtg(5,5)
    Complex(t_real):: D1o2(2,2),SR(2,2,3),DSD(2,2,3),sigma(2,2,3)
    Character(10000):: buf,word
!    Logical(t_log) :: exists
    Complex(t_real),Parameter   :: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter   :: c1=(1.0_t_real,0.0_t_real)
    Complex(t_real),Parameter   :: ci=(0.0_t_real,1.0_t_real)

    !!
    Call make_factorials(fac,2*12_t_int)
    !!

 !   Inquire(file='=.nocc',exist=exists)
 !   If(.Not.exists) Return
    !!
    !!
    PPi(:,1)=(/ 0.0_t_real , 1.0_t_real , 0.0_t_real /)
    PPi(:,2)=(/ 0.0_t_real , 0.0_t_real , 1.0_t_real /)
    PPi(:,3)=(/ 1.0_t_real , 0.0_t_real , 0.0_t_real /)
    Do i=1,3 
       Write(outfile,35) (PPi(i,j),j=1,3) 
    End Do
    !!
    !!
    !!
    !!
    nz(:)=(/ 1.0_t_real , 1.0_t_real , 1.0_t_real /)
    nz(:)=(/ 1.0_t_real , 2.0_t_real ,-3.0_t_real /)
    nz=nz/Sqrt(Dot_product(nz,nz))
    nx(:)=(/ 2.0_t_real ,-1.0_t_real ,-1.0_t_real /)
    nx=nx-Dot_product(nx,nz)*nz
    nx=nx/Sqrt(Dot_product(nx,nx))
    Call cross(nz,nx,ny)
    Write(outfile,12) nx,Dot_product (nx,nx)
    Write(outfile,13) ny,Dot_product (ny,ny)
    Write(outfile,14) nz,Dot_product (nz,nz)
12  Format('nx=',3(f15.7,2x),' |nx|=',f15.7)
13  Format('ny=',3(f15.7,2x),' |ny|=',f15.7)
14  Format('nz=',3(f15.7,2x),' |nz|=',f15.7)
    !!
    !! calcualte euler angles in the definition
    !!
    !!  E^{new}= \hat{D}(al,be,ga) E^{old}= E^{old} DR(al,be,ga) 
    !!
    Call reuler(nz,eu)
    Call write_euler(eu)
    Call m_euler(DR,eu)
    r=Matmul(nz,DR)
    Write(outfile,122) "Quan.-axis becomes: " ,r(:)
122 Format(a,t41,': (',2(f10.5,','),f10.5,')')
    Write(outfile,4)
4   Format(/)
    !!
    Call wignerD2(eu,D1o2)
    Write(outfile,22) D1o2(1,1:2)
    Write(outfile,23) D1o2(2,1:2)
    Write(outfile,4)
22  Format('s=1/2 Wigner D-function: ',t41,': ',2('(',f10.5,',',f10.5,') '))
23  Format(t41,': ',2('(',f10.5,',',f10.5,') '))


    sigma(:,:,:)=c0
    sigma(1,1,3)=c1
    sigma(2,2,3)=-c1
    sigma(1,2,1)=c1
    sigma(2,1,1)=c1
    sigma(2,1,2)=ci
    sigma(1,2,2)=-ci

322 Format(a,t41,': ',2('(',f10.5,',',f10.5,') '),/&
         &,t43,2('(',f10.5,',',f10.5,') '),/)
    
    Do i=1,2
       Do j=1,2
          SR(i,j,:)=Matmul(sigma(i,j,:),DR(:,:))
       End Do
    End Do

    
    Do i=1,3
       DSD(:,:,i)=Matmul(Matmul(D1o2,sigma(:,:,i)),Conjg(Transpose(D1o2)))
    Enddo
    !!
    !!
    If(Any(Abs(SR-DSD)>1.0e-10_t_real))Then
       Write(outfile,918)
918    Format('Symmetry assumption in D1o2 matrices is wrong ?',/&
            &,'Please contact authors!')
       Write(outfile,322) 'sig_x=',((sigma(i,j,1),j=1,2),i=1,2)
       Write(outfile,322) 'sig_y=',((sigma(i,j,2),j=1,2),i=1,2)
       Write(outfile,322) 'sig_z=',((sigma(i,j,3),j=1,2),i=1,2)
       Write(outfile,322) 'sigR_x=',((SR(i,j,1),j=1,2),i=1,2)
       Write(outfile,322) 'sigR_y=',((SR(i,j,2),j=1,2),i=1,2)
       Write(outfile,322) 'sigR_z=',((SR(i,j,3),j=1,2),i=1,2)
       Write(outfile,322) 'DsigD+_x=',((DSD(i,j,1),j=1,2),i=1,2)
       Write(outfile,322) 'DsigD+_y=',((DSD(i,j,2),j=1,2),i=1,2)
       Write(outfile,322) 'DsigD+_z=',((DSD(i,j,3),j=1,2),i=1,2)
    Endif
    !!
    !!
    !!
    !!
    !!
    !!
    !!
    Stop
    !!
    !!
    Call reuler2(nz,nx,eu)
    Call write_euler(eu)
    !!
    !! calculate DR(al,be,ga) 
    Call m_euler(DR,eu)
    Do i=1,3 
       Write(outfile,34) (DR(i,j),j=1,3) 
    End Do
    !! calculate DR(al,be,ga) 
    Call m_euler(DR,eu)
    Do i=1,3 
       Write(outfile,34) (DR(i,j),j=1,3) 
    End Do
    !!
    Print *,'0z=',Matmul((/ 1.0_t_real , 1.0_t_real , 1.0_t_real/),DR(:,:))&
         &/Sqrt(3.0_t_real)
    Print *,'0x=',Matmul((/ 2.0_t_real , -1.0_t_real , -1.0_t_real/),DR(:,:))&
         &/Sqrt(6.0_t_real)
    !!
    !!
    l=2
    deg=2*l+1
    kinv=0
    Call ytr(eu,kinv,fac,l,D2,.True.)
    !!
    Write(outfile,2)
    Do i=1,deg
       Write(outfile,36,advance='no')
       Do j=1,deg
          Write(outfile,10,advance='no') D2(i,j)
       Enddo
       Write(outfile,2)
    End Do
    !!
    !!
    ncub(:,:)=0.0_t_real
    nrtg(:,:)=0.0_t_real

    !!
    Open(12,file='=.nocc')
    Do i=1,deg
       Read(12,1)buf
       Do j=1,deg
          If(next_word(buf,word))Then
             Read(word,*)nrtg(i,j)
          Endif
       Enddo
    Enddo
    Close(12)
    !!
    !!
    !!
    Write(outfile,2)
    Do i=1,deg
       Write(outfile,38,advance='no')
       Do j=1,deg
          Write(outfile,10,advance='no') nrtg(i,j)
       Enddo
       Write(outfile,2)
    End Do
    !!
    !!
    ncub=Matmul(D2,Matmul(nrtg,Transpose(D2)))
    !!
    Write(outfile,2)
    Do i=1,deg
       Write(outfile,37,advance='no')
       Do j=1,deg
          Write(outfile,10,advance='no') ncub(i,j)
       Enddo
       Write(outfile,2)
    End Do
    !!
    !!
    !!
    Stop
    !!
34  Format('DR: ',3(f10.4,1x))
35  Format('Pi: ',3(f10.4,1x))
36  Format('Dl: ')
37  Format('ncub: ')
38  Format('nrtg: ')
10  Format(f10.4,' ')
2   Format()
1   Format(a)
    !!
  End Subroutine symstuff1
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine ustuff()
    !!
    !!
    Implicit None  
    !!IO
    
    !!LOCAL
    Character(*),Parameter::nsubfunc="ustuff"    
    Integer(t_int) :: nv,ng,ig,lmax,K,M,mu,nu,l,MK,n,npar,mm,nn,idir
    Integer(t_int) :: i,ms,ni,deg,ns,in,itr1,itr2,itr3,itr4,its,itr!,md,nd
    Real(t_real)   :: n_a(2),U,F2,F4,f,e,delta,MR(2,2),J,etot,deltar,dc,dx,Edc
    Real(t_real)   :: v_a(2),v_a2(2),nnn(2,2,2),vvv(2,2,2),vvv2(2,2,2)
    Real(t_real)   :: a,b
    Real(t_real)   :: F2o4,dnn,wH,wX,wH0,wX0,dc0,dx0,etot0,tr1,tr2,tr3,tr4,ts,tr
    Real(t_real)   :: rsh(3),w,d,err,nup,ndn,FK(0:6),dnd(1:5,1:5,2),dns(2)
    Real(t_real)   :: trm2,trn2,aa(5,5)
    Real(t_real)   :: ylm(13**2),CU(5,5),CX(5,5),wj,CSYM(5,5)
    Real(t_real),Pointer   :: numgaunt(:,:,:,:),den(:,:,:)
    Real(t_real),Pointer   :: wgaunt(:,:,:)
    Real(t_real),Pointer   :: wc(:,:,:,:,:)
    Real(t_real),Pointer ::  wg(:),ag(:,:)
    Character(20)   :: ntype(4),dirtype(2)
    Character(200)   :: str,buf
    !!
    dirtype(1)='C'
    dirtype(2)='X'
    Nullify(numgaunt)
    Nullify(wgaunt)
    Nullify(wc)
    Nullify(den)
    !!
    l=2
    lmax=2*l
    !!
    Call palloc('numgaunt',numgaunt&
         &,0_t_int,l&
         &,1_t_int,2*(2*l)+1&
         &,1_t_int,2*l+1&
         &,1_t_int,2*l+1&
         &,nmodule,nsubfunc)
    Call palloc('wc',wc&
         &,0_t_int,l&
         &,1_t_int,2*l+1&
         &,1_t_int,2*l+1&
         &,1_t_int,2*l+1&
         &,1_t_int,2*l+1&
         &,nmodule,nsubfunc)
    !!

    Call palloc("wgaunt",wgaunt&
         &,1_t_int,( l+1)**2 &
         &,1_t_int,( l+1)**2 &
         &,1_t_int,( 2*l+1)**2 &
         &,nmodule,nsubfunc)

    Call palloc("den",den&
         &,1_t_int,2*l+1 &
         &,1_t_int,2*l+1 &
         &,1_t_int,4_t_int &
         &,nmodule,nsubfunc)

    !! determine Gaunt coefficients 
    Call makergaunt(wgaunt,l,l,l*2) 

    nv=2*lmax
    Call sph_zyl_mesh(nv,ag,wg,ng,.False.)
    !!
    !!
    numgaunt=0.0_t_real
    igloop: Do ig=1,ng
       rsh(:)=ag(:,ig)
       w=wg(ig)
       Call ylms12(ylm,rsh(1),rsh(2),rsh(3),lmax)
       Kloop: Do K=0,2*l,2
          Mloop: Do M=1,2*K+1
             muloop: Do mu=1,2*l+1
                nuloop: Do nu=1,2*l+1
                   numgaunt(K/2,M,mu,nu)=numgaunt(K/2,M,mu,nu)&
                        &+ylm(K*K+M)*ylm(l*l+mu)*ylm(l*l+nu)*w
                Enddo nuloop
             Enddo muloop
          Enddo Mloop
       Enddo Kloop
    Enddo Igloop
    !! test gaunts
    Kloop1: Do K=0,2*l,2
       Print *,'K=',K
       Mloop1: Do M=1,2*K+1
          muloop1: Do mu=1,2*l+1
             nuloop1: Do nu=1,2*l+1
                d=numgaunt(K/2,M,mu,nu)
                w=wgaunt(l*l+mu,l*l+nu,K*K+M)
                err=d-w
                If(Abs(w) > 1.0e-12_t_real) Then
                   !Write(outfile,101) M-K-1,mu-l-1,nu-l-1,w
                Endif
                If(Abs(err)>1.0e-12_t_real) Then
                   Write(outfile,10) M,mu,nu,d,w
10                 Format('M=',i2,' mu=',i2,' nu=',i2,' : ',2(f20.15,3x))
!101                Format('M=',i2,' mu=',i2,' nu=',i2,' : ',1(f20.15,3x))
                   Stop 'test gaunts'
                Endif
             Enddo nuloop1
          Enddo muloop1
       Enddo Mloop1
       Print *
    Enddo Kloop1
    !!
    !! calc F_i prefactors
    Do K=0,2*l,2
       Do n=1,2*l+1
          Do nu=1,2*l+1
             Do m=1,2*l+1
                Do mu=1,2*l+1
                   d=0.0_t_real
                   Do MK=1,2*K+1
                      d=d+wgaunt(l*l+n,l*l+m,K*K+MK)&
                           &*wgaunt(l*l+mu,l*l+nu,K*K+MK)
                   Enddo
                   wc(K/2,n,nu,m,mu)=d*fourpi/Real(2*K+1,t_real)
                Enddo
             Enddo
          Enddo
       Enddo
    Enddo


    !! diract for diagonal real density matrices
    Print *,' diagonal density interaction matrix (real Y)'
    Do K=0,2*l,2
       Print *,'K=',K
       Do m=1,2*l+1
          Do mu=1,2*l+1
             d=wc(K/2,m,mu,m,mu) !*Sqrt(2*K+1.0_t_real)*sqpi
             aa(m,mu)=d
          Enddo
       Enddo
       Call printmat("aa","(f15.10,1x)","('       0        ')"&
            &,aa*49*9,5_t_int,5_t_int,1.0e-8_t_real)

       Print *,'aMa=',Dot_product((/0.,0.,0.,0.,0.5/),Matmul(aa,(/0.,0.,0.,0.,0.5/)))*49*9
       Print *,'aMb=',Dot_product((/0.,0.,0.,0.,0.5/),Matmul(aa,(/0.25,0.,0.,0.,-0.25/)))*49*9
       Print *,'bMb=',Dot_product((/0.25,0.,0.,0.,-0.25/),Matmul(aa,(/0.25,0.,0.,0.,-0.25/)))*49*9

       Print *,'degMdeg=',Dot_product((/0.75,0.5,0.5,0.5,0.75/),Matmul(aa,(/0.75,0.5,0.5,0.5,0.75/)))
       Print *,'ndegMndeg=',Dot_product((/0.5,0.5,0.5,0.5,1./),Matmul(aa,(/0.5,0.5,0.5,0.5,1./)))

    Enddo
       




    !! direct contraction
    Do K=0,2*l,2
       Print *,'K=',K
       Do n=1,2*l+1
          Do m=1,2*l+1
             d=0.0_t_real
             Do mu=1,2*l+1
                d=d+wc(K/2,mu,n,mu,m)
             Enddo
             w=0.0_t_real
             If(n==m .And. K==0) w=Real(2*l+1,t_real)
             err=d-w
             If(Abs(err)>1.0e-12_t_real) Then
                Write(outfile,11) n,m,d,w
11              Format('n=',i2,' m=',i2,' : ',2(f20.15,3x))
                Stop 'direct contraction'
             Endif
          Enddo
       Enddo
    Enddo
       
    !! xc contraction
    
    Do K=0,2*l,2
       Print *,'xc K=',K
       Do n=1,2*l+1
          Do m=1,2*l+1
             d=0.0_t_real
             Do mu=1,2*l+1
                d=d+wc(K/2,n,mu,mu,m)
             Enddo
             If(K==0) Then
                w=0.0_t_real
                If(n==m ) w=1.0_t_real
                err=d-w
                If(Abs(err)>1.0e-12_t_real) Then
                   Write(outfile,11) n,m,d,w
                   Stop 'xc  ontraction K=0'
                Endif
             Else If(K==2) Then
                w=0.0_t_real
                If(n==m .And. l==1) w=2.0_t_real/5.0_t_real
                If(n==m .And. l==2) w=2.0_t_real/7.0_t_real
                If(n==m .And. l==3) w=4.0_t_real/15.0_t_real
                err=d-w
                If(Abs(err)>1.0e-12_t_real) Then
                   Write(outfile,11) n,m,d,w
                   Stop 'xc  ontraction K=2'
                Endif
             Else If(K==4) Then
                w=0.0_t_real
                If(n==m .And. l==2) w=2.0_t_real/7.0_t_real
                If(n==m .And. l==3) w=2.0_t_real/11.0_t_real
                err=d-w
                If(Abs(err)>1.0e-12_t_real) Then
                   Write(outfile,11) n,m,d,w
                   Stop 'xc  ontraction K=4'
                Endif
             Else If(K==6) Then
                w=0.0_t_real
                If(n==m .And. l==3) w=100.0_t_real/13.0_t_real/33.0_t_real
                err=d-w
                If(Abs(err)>1.0e-12_t_real) Then
                   Write(outfile,11) n,m,d,w
                   Stop 'xc  ontraction K=4'
                Endif
             else
                !w=0.0_t_real
                !If(n==m .And. K==0) w=Real(2*l+1,t_real)
                !err=d-w
                If(Abs(d)>1.0e-12_t_real) Then
                   Write(outfile,12) n,m,d
12                 Format('n=',i2,' m=',i2,' : ',1(f20.15,3x))
                Endif
             Endif
          Enddo
       Enddo
    Enddo
    !!
    !! print them
    Do K=0,2*l,2 
       Do n=1,2*l+1
          Do m=1,2*l+1
             !Do nu=1,2*l+1
             !Do mu=1,2*l+1
             
             !!
             mu=0
             w=(&
                  & wc(K/2,n,mu+l+1,mu+l+1,m)*1&
                  &+wc(K/2,n,0+l+1,m,0+l+1)*0&
                  &+wc(K/2,n,2+l+1,m,2+l+1)*0&
                  &)/1
             !!
             Call make_ratio(w,mm,nn,10000000_t_int,1.0e-12_t_real)
             If(mm /=0 ) Then
                i=0
                !If(K==2) i=(-2*(Abs(n-l-1)**2-2))*1 ! -1
                !If(K==2) i=(4*(Abs(m-l-1)**2-2))*1 ! -2
                !If(K==2) i=(-2*(Abs(m-l-1)**2-2))*1 ! 0
                !If(K==4) i=(15*Abs(m-l-1)**2-35*Abs(m-l-1)+12)*nn/441   ! -2
                !If(K==4) i=-4*(15*Abs(m-l-1)**2-35*Abs(m-l-1)+12)*nn/441   !
                ! -1
                !If(K==4) i=3*(15*Abs(m-l-1)**2-35*Abs(m-l-1)+12)*nn/441   ! 0
                !If(K==2) i=-2*(Abs(m-l-1)-4) ! xc -2
                !If(K==2) i=(-3*Abs(m-l-1)**2+8*Abs(m-l-1)+2)*nn/47 ! xc -1
                !If(K==4) i=(21*Abs(m-l-1)**2-Abs(m-l-1)+60)/2*nn/441 ! xc -2
                !If(K==2) i=(3*Abs(m-l-1)**2-6*Abs(m-l-1)+4)*nn/49 ! xc 0
                !If(K==4) i=-(3*Abs(m-l-1)**2+Abs(m-l-1)-24)/2*nn/147 ! xc 0

                Write(6,18)K,n-l-1,m-l-1,mm-i,nn,w-mm/Real(nn,t_real)
             Endif
             
             If(nn==0) Then
                Print *,'w=',w
                Stop 'make_ratio'
             Endif
             !!
             
18           Format('F',i1,': n=',i2,' m=',i2,' w= ',i6,'/',i6,' ',f30.15)
             !  Enddo
             !Enddo
          Enddo ! m
       Enddo! n
       Print *
    Enddo ! K
    !!

stop
    !! calc MnO AFMII potential matrix F factors
    !!
    
    den(:,:,:)=0.0_t_real
    !! Eg
    ntype(1)='Eg'
    den(1,1,1)=1.0_t_real
    den(5,5,1)=1.0_t_real
    !! Eg'
    ntype(2)='Eg'''
    den(2,2,2)=1.0_t_real
    den(4,4,2)=1.0_t_real
    !! Ag
    ntype(3)='Ag'
    den(3,3,3)=1.0_t_real
    !! Delta
    ntype(4)='Delta'
    den(1,2,4)=1.0_t_real
    den(2,1,4)=1.0_t_real
    den(4,5,4)=-1.0_t_real
    den(5,4,4)=-1.0_t_real
    !!
    n=1
    m=2
    !!
    Do K=0,2*l,2 
       !! for all F_K

       Do idir=1,2
          !! Coulomb and xc
          
          
          Write(outfile,1101,advance='no') dirtype(idir),K
1101      Format('v ',a,'   F',i1,'  ( ')
          
          Do npar=1,4
             d=0.0_t_real
             Do mu=1,2*l+1
                Do nu=1,2*l+1
                   !Print *,mu,nu,wc(K/2,n,nu,m,mu)
                   If(idir==1)Then
                      d=d+den(mu,nu,npar)*wc(K/2,n,nu,m,mu)
                   Else
                      d=d-den(mu,nu,npar)*wc(K/2,n,nu,mu,m)
                   Endif
                Enddo
                If(idir == 1 .And. K==0 .And. m==n)Then
                   !! dc C
                   d=d-den(mu,mu,npar)
                Endif
                If(idir == 2 .And. K>0 .And. m==n)Then
                   !! dc X
                   d=d+den(mu,mu,npar)/14.0_t_real
                Endif
             Enddo

             
             Call make_ratio(d,mm,nn,10000_t_int,1.0e-10_t_real)
             If(nn==0) Stop 'make_ratio'
             Call double_to_string_as_ratio(d,str,10000_t_int&
                  &,1.0e-10_t_real,"(f30.5)")
             
             buf=''
             If(mm/=0) Then
                Write(buf,*) Trim(str),'*n_',Trim(ntype(npar))
             Endif
             Write(outfile,102,advance='no')buf
102          Format(a20)
          Enddo
          Write(outfile,103) 
103       Format(')')
       Enddo
    Enddo
    !!
    !!==============================
    !! play with the potential matrix
    !!
    !!
    nup=1.0_t_real
    ndn=0.0_t_real
    delta=0.0_t_real*pi/180.0_t_real
    !delta=Acos(1.0_t_real/Sqrt(3.0_t_real))
    MR(1,1:2)=(/ Cos(delta) , -Sin(delta) /)
    MR(2,1:2)=(/ Sin(delta) ,  Cos(delta) /)
    
    ms=1
    !!
    nnn(1,1:2,ms)=(/ nup , 0.0_t_real /)
    nnn(2,1:2,ms)=(/ 0.0_t_real , 1.0_t_real-nup /)
    n_a(ms)=1.0_t_real
    !!
    nnn(:,:,ms)=Matmul(MR,Matmul(nnn(:,:,ms),Transpose(MR)))
    !!
    ms=2
    !!
    nnn(1,1:2,ms)=(/ ndn , 0.0_t_real /)
    nnn(2,1:2,ms)=(/ 0.0_t_real , 1.0_t_real-ndn /)
    n_a(ms)=0.0_t_real
    !!
    nnn(:,:,ms)=Matmul(MR,Matmul(nnn(:,:,ms),Transpose(MR)))
    !!
    !!
    Do ms=1,2
       Write(6,*)' trace ',2*(nnn(1,1,ms)+nnn(2,2,ms))+n_a(ms)
    Enddo
    !!
    U=5.5_t_real
    F2=8*14/13.0_t_real
    F4=5*14/13.0_t_real
    J=(F2+F4)/14.0_t_real
    Call vofsig(U,F2,F4,nnn,n_a,vvv,v_a)
    Call vofsig8o5(U,J,nup,ndn,delta,vvv2,v_a2,etot)
    !!
    If(Any(Abs(vvv(:,:,:)-vvv2(:,:,:))>1.0e-12_t_real) .Or. &
         & Any(Abs(v_a(:)-v_a2(:))>1.0e-12_t_real) )Then
       Print *,'error in vv2'
       Stop
    Endif
    !!
    !!transform the potential
    !!
    Do ms=1,2
       !vvv(:,:,ms)=Matmul(Transpose(MR),Matmul(vvv(:,:,ms),MR))
    Enddo
    !!
    f=1.0_t_real/hatoev
    f=1.0_t_real
    Do ms=1,2
       Write(6,"('density spin ',i1)")ms
       Write(6,670) nnn(1,1,ms),nnn(1,2,ms)
       Write(6,670) nnn(2,1,ms),nnn(2,2,ms)
       Write(6,671) n_a(ms)
       Write(6,*)
       Write(6,"('potential spin ',i1)")ms
       Write(6,670) vvv(1,1,ms)*f,vvv(1,2,ms)*f
       Write(6,670) vvv(2,1,ms)*f,vvv(2,2,ms)*f
       Write(6,671) v_a(ms)*f
       Write(6,*)
       Write(6,*)
    Enddo
670 Format(t20,f12.8,2x,f12.8)
671 Format(t46,f12.8)
    !!
    !!
    !!
    e=0.0_t_real
    Do ms=1,2
       Do i=1,2
          e=e+2.0_t_real*Dot_product(nnn(i,:,ms),vvv(:,i,ms))
       Enddo
       e=e+n_a(ms)*v_a(ms)
    Enddo
    !!
    If(Abs(e-etot)>1.0e-12_t_real )Then
       Print *,'error in eevv2',e,etot
       Stop
    Endif
    !!
    Write(6,"('etot=',f12.8)") etot*f
    !!
    !!==============================
    ni=1000
    nup=1.0_t_real
    ndn=1.0_t_real
    Write(str,"('+etot_delta.',i1,i1)")Nint(nup),Nint(ndn)
    Open(12,file=Trim(str))
    Do i=1,ni
       delta=Real(i-1,t_real)/Real(ni-1,t_real)*360.0_t_real
       deltar=delta*pi/180.0_t_real
       Call vofsig8o5(U,J,nup,ndn,deltar,vvv2,v_a2,etot)
       Write(12,"(2(f30.15,2x))")delta,etot
    Enddo
    Close(12)


    !! print interaction matrix
    CSYM(1,:)=(/  1 ,1 ,0, 1, 0/)/3.0_t_real
    CSYM(2,:)=(/  1 ,1 ,0, 1, 0/)/3.0_t_real
    CSYM(3,:)=(/  0 ,0 ,1, 0, 1/)/2.0_t_real
    CSYM(4,:)=(/  1 ,1 ,0, 1, 0/)/3.0_t_real
    CSYM(5,:)=(/  0 ,0 ,1, 0, 1/)/2.0_t_real
    FK=0.0_t_real
    FK(0)=U
    FK(2)=F2
    FK(4)=F4
    Print "('F_K =',3(f12.8))",(FK(K),K=0,4,2)
    !! print them
    Write(6,"(' U ')")
    Do n=1,2*l+1
       Do mu=1,2*l+1
          !Do m=1,2*l+1
          w=0.0_t_real
          wj=0.0_t_real
          Do K=0,2*l,2 
             !Do nu=1,2*l+1
             !!
             w=w+FK(K)*(wc(K/2,n,mu,n,mu))
             wj=wj+FK(K)*(wc(K/2,n,mu,mu,n))
             !!
             !!
          Enddo ! K
          CU(n,mu)=w
          CX(n,mu)=wj
       Enddo ! mu
    Enddo! n
    !!
    !CU=Matmul(CU,CSYM)
    !CX=Matmul(CX,CSYM)
    Do n=1,2*l+1
       Do mu=1,2*l+1
          Write(6,"(f12.8,' ')",advance='no')CU(n,mu)
       Enddo ! mu
       Write(6,*)
    Enddo! n
    Print *
    !!
    Write(6,"(' J ')")
    Do n=1,2*l+1
       Do mu=1,2*l+1
          Write(6,"(f12.8,' ')",advance='no')CX(n,mu)
       Enddo ! mu
       Write(6,*)
    Enddo! n
    Print *
    !!

    U=5.5_t_real
    J=1.0_t_real
    F2o4=8.0_t_real/5.0_t_real
    F2=14/(1+F2o4)*F2o4*J
    F4=14/(1+F2o4)*J
    Print *,'U=',U
    Print *,'J=',J
    Print *,'F2o4=',F2o4
    Print *,'F2=',F2
    Print *,'F4=',F4

    If(Abs( J - (F2+F4)/14.0_t_real)>1.0e-12_t_real) Stop 'J error'
    
    FK(0)=U
    FK(2)=F2
    FK(4)=F4

    Open(17,file='=.nupdn')
    Read(17,*)nup,ndn
    Close(17)
    !nup=1.0_t_real
    !ndn=0.0_t_real

    ni=1000

    Write(str,"('+etot_deltar.',i1,i1)")Nint(nup),Nint(ndn)
    Open(12,file=Trim(str))
    Do in=1,ni
       delta=Real(in-1,t_real)/Real(ni-1,t_real)*360.0_t_real
       deltar=delta*pi/180.0_t_real

       MR(1,1:2)=(/ Cos(deltar) , -Sin(deltar) /)
       MR(2,1:2)=(/ Sin(deltar) ,  Cos(deltar) /)
       
       dnd(:,:,:)=0.0_t_real
       
       ms=1
       !!
       nnn(1,1:2,ms)=(/ nup , 0.0_t_real /)
       nnn(2,1:2,ms)=(/ 0.0_t_real , 1.0_t_real-nup /)
       n_a(ms)=1.0_t_real
       !!
       nnn(:,:,ms)=Matmul(MR,Matmul(nnn(:,:,ms),Transpose(MR)))
       !!
       ms=2
       !!
       nnn(1,1:2,ms)=(/ ndn , 0.0_t_real /)
       nnn(2,1:2,ms)=(/ 0.0_t_real , 1.0_t_real-ndn /)
       n_a(ms)=0.0_t_real
       !!
       nnn(:,:,ms)=Matmul(MR,Matmul(nnn(:,:,ms),Transpose(MR)))
       
       ms=1
       
       Print *,nnn(1,:,ms)
       Print *,nnn(2,:,ms)
       
       ms=2
       Print *,nnn(1,:,ms)
       Print *,nnn(2,:,ms)
       
       
       Do ms=1,2
          dnd(1,1,ms)=nnn(1,1,ms)
          dnd(5,5,ms)=nnn(1,1,ms)
          dnd(2,2,ms)=nnn(2,2,ms)
          dnd(4,4,ms)=nnn(2,2,ms)
          dnd(1,2,ms)=nnn(1,2,ms)
          dnd(4,5,ms)=-nnn(1,2,ms)
          dnd(2,1,ms)=nnn(1,2,ms)
          dnd(5,4,ms)=-nnn(1,2,ms)
          dnd(3,3,ms)=n_a(ms)
          Do i=1,5
             Write(6,"(5(f10.5,1x))")dnd(i,1:5,ms)
          Enddo
          Print *
       Enddo
       
       trn2=0.0_t_real
       trm2=0.0_t_real
       Do i=1,5
          a=Dot_product(dnd(i,:,1)+dnd(i,:,2),dnd(:,i,1)+dnd(:,i,2))
          b=Dot_product(dnd(i,:,1)-dnd(i,:,2),dnd(:,i,1)-dnd(:,i,2))
          trn2=trn2+a
          trm2=trm2+b
       Enddo

       Do ms=1,2
          dns(ms)=0.0_t_real
          Do i=1,5
             dns(ms)=dns(ms)+dnd(i,i,ms)
          Enddo
       Enddo
       dnn=Sum(dns(1:2))
       Print *,'oc',dns(1:2),dnn
       Print *,'tr n, tr m',trn2,trm2
       !!
       Edc=U/2*dnn*(dnn-1)-J/2 * Sum(dns(1:2)*(dns(1:2)-1))
       deg=2*l+1
       etot=0.0_t_real
       etot0=0.0_t_real
       !Print *,'K=',K
       dc=0.0_t_real
       dx=0.0_t_real
       dc0=0.0_t_real
       dx0=0.0_t_real
       tr1=0.0_t_real
       tr2=0.0_t_real
       tr3=0.0_t_real
       tr4=0.0_t_real
       ts=0.0_t_real
       tr=0.0_t_real
       itr1=0
       itr2=0
       itr3=0
       itr4=0
       its=0
       itr=0
       Do m=1,deg
          Write(outfile,"(' wX ')",advance='no')
          Do n=1,deg
             Do mu=1,2*l+1
                Do nu=1,2*l+1
                   
                   wH0=0.0_t_real
                   wX0=0.0_t_real
                   If(mu==nu .And. m==n) Then
                      wH0=U
                      wX0=J
                   Endif
                   If(nu==m .And. mu==n) Then
                      wX0=wX0+U-J
                   Endif
                   !!
                   wH=0.0_t_real
                   wX=0.0_t_real
                   Do K=0,2*l,2
                      wH=wH+wc(K/2,mu,m,nu,n)*FK(K)
                      wX=wX+wc(K/2,m,mu,nu,n)*FK(K)
                   Enddo
                   !!
                   wH=wH-wH0
                   wX=wX-wX0
                   Do ms=1,2
                      Do ns=1,2
                         dc=dc+dnd(mu,nu,ms)*wH*dnd(m,n,ns)/2
                         dc0=dc0+dnd(mu,nu,ms)*wH0*dnd(m,n,ns)/2
                      Enddo
                      dx=dx+dnd(mu,nu,ms)*wX*dnd(m,n,ms)/2
                      dx0=dx0+dnd(mu,nu,ms)*wX0*dnd(m,n,ms)/2
                   Enddo

                   If( mu==nu .And. m==n .And. mu /=m ) Then
                      tr1=tr1+wX
                      itr1=itr1+1
                   Endif
                   If( mu==m .And. nu==n .And. mu /=nu ) Then
                      tr2=tr2+wX
                      itr2=itr2+1
                   Endif
                   If( mu==n .And. nu==m .And. mu /=nu ) Then
                      tr3=tr3+wX
                      itr3=itr3+1
                   Endif
                   If( mu==nu .And. m==n .And. mu ==m ) Then
                      tr4=tr4+wX
                      itr4=itr4+1
                   Endif

                   If( mu==nu .And. m==n  ) Then
                      ts=ts+wX
                      its=its+1
                   Endif

                   If( (mu==m .And. nu==n  ).Or.(mu==n .And. nu==m  )) Then
                      tr=tr+wX
                      !Print *,'tr,wX=',tr,wX
                      itr=itr+1
                   Endif

                   If(mu == nu .And. m==n) Then
                      Write(outfile,"(f15.8,' ')",advance='no') wX
                   Endif

                Enddo
             Enddo
          Enddo
          Write(outfile,*)
       Enddo
       etot=etot+(dc*0-dx)
       etot0=etot0+(dc0-dx0)-Edc !! isotropic part
       Print *,'tr1=',tr1/itr1,itr1
       Print *,'tr2=',tr2/itr2,itr2
       Print *,'tr3=',tr3/itr3,itr3
       Print *,'tr4=',tr4/itr4,itr4
       Print *,'ts=',ts/its,its
       Print *,'tr=',tr/itr,itr
       !stop

       Print *,'direct=',dc,' xc=',dx
       Print *,'direct-0=',dc0,' xc0=',dx0
       
       Print *,' Etot=',Etot
       Print *,' Etot0=',Etot0
       Print *,' Edc=',Edc
       Write(12,"(4(f30.15,2x))")delta,etot,trn2,trm2
    Enddo
    Close(12)
    !!
    Print *,'SUCCESS'
    !!
    Stop
    !!
    Return
    !!

    !!
  End Subroutine ustuff
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine vofsig8o5(U,J,nup,ndn,delta,vvv,v_a,etot)
    !!
    !!
    Implicit none  
    !!IO
    Real(t_real),Intent(in)      :: U,J
    Real(t_real),Intent(in)      :: nup,ndn,delta
    Real(t_real),Intent(out)     :: vvv(2,2,2),v_a(2),etot
    !!LOCAL
    Integer(t_int) :: ms!,i
    Real(t_real)   :: nt,dt,n(2),d(2),n_a(2),c,s!,nnn,x
    !!
    !!
    !!
    !!
    !!
    !!
    !!

    !!
    n_a(1)=1.0_t_real
    n_a(2)=0.0_t_real
    !!
    c=Cos(delta)
    s=Sin(delta)
    n(1)=nup*(c**2-s**2)+s**2
    n(2)=ndn*(c**2-s**2)+s**2
    d(1)=-(1.0_t_real-2*nup)*c*s
    d(2)=-(1.0_t_real-2*ndn)*c*s
    !!
    nt =n(1)+n(2)
    dt =d(1)+d(2)
    !!
    etot=0.0_t_real
    !!
    Do ms=1,2
       !!
       !!
       !!
       vvv(1,1,ms)=U*(0.5_t_real-n(ms))&
            &+J*(3656*nt-44*n(ms)+n_a(ms)*186-3727)/1638.0_t_real
       !!
       !!
       !!
       vvv(2,2,ms)=U*(0.5_t_real-(1-n(ms)))&
            &+J*(-2528*nt+608*n(ms)+n_a(ms)*750+1849)/1638.0_t_real
       !!
       !!
       !!
       !!
       v_a(ms)=U*(0.5_t_real-n_a(ms))&
            &+J*(-2256*nt-1128*n(ms)-234*n_a(ms)+2937)/1638.0_t_real
       !!
       !!
       !!
       !!
       vvv(1,2,ms)=U*(-d(ms))+ J*2/819_t_real*(350*dt-293*d(ms))
       vvv(2,1,ms)=vvv(1,2,ms)
       !!
       !!
       !!
       !!
       etot=etot+J*(-1304*n(ms)**2-4688*d(ms)**2)/1638.0_t_real
       !!
       !!
       !!
       etot=etot-U*(4*n(ms)**2+4*d(ms)**2)
       !!
    Enddo
    !!
    etot=etot+J*(-2256*n(1))/1638.0_t_real
    etot=etot+J*(12368*nt**2+5600*dt**2-22304*nt+11599)/1638.0_t_real
    !!
    etot=etot+U*4*nt-U*2.5_t_real
    !!
    Return
    !!
  End Subroutine vofsig8o5
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine vofsig(U,F2,F4,nnn,n_a,vvv,v_a)
    !!
    !!
    Implicit none  
    !!IO
    Real(t_real),Intent(in)      :: U,F2,F4
    Real(t_real),Intent(in)      :: nnn(2,2,2),n_a(2)
    Real(t_real),Intent(out)     :: vvv(2,2,2),v_a(2)
    !!LOCAL
    Integer(t_int) :: ms
    Real(t_real)   :: J,NNsig,nt,npt,at,dt,n(2),np(2),d(2)
    !!
    !!
    J=(F2+F4)/14.0_t_real
    !!
    n(1)=nnn(1,1,1)
    n(2)=nnn(1,1,2)
    !!
    np(1)=nnn(2,2,1)
    np(2)=nnn(2,2,2)
    !!
    d(1)=nnn(1,2,1)
    d(2)=nnn(1,2,2)
    !!
    nt =n(1)+n(2)
    npt=np(1)+np(2)
    at =n_a(1)+n_a(2)
    dt =d(1)+d(2)
    Do ms=1,2
       !!
       NNsig=2*(n(ms)+np(ms))+n_a(ms)
       !!
       vvv(1,1,ms)=U*(0.5_t_real-n(ms))+J*(NNsig-0.5_t_real)&
            &+F2*((4*nt-2*npt-2*at)*2/49_t_real-(4*n(ms)+6*np(ms)+4*n_a(ms))/49.0_t_real)&
            &+F4*((nt-4*npt+3*at)*2/441_t_real-(71*n(ms)+40*np(ms)+15*n_a(ms))/441_t_real)
       vvv(2,2,ms)=U*(0.5_t_real-np(ms))+J*(NNsig-0.5_t_real)&
            &+F2*((-4*nt+2*npt+2*at)*1/49_t_real-(6*n(ms)+7*np(ms)+n_a(ms))/49.0_t_real)&
            &+F4*((-nt+4*npt-3*at)*8/441_t_real-(20*n(ms)+28*np(ms)+15*n_a(ms))*2/441_t_real)
       v_a(ms)=U*(0.5_t_real-n_a(ms))+J*(NNsig-0.5_t_real)&
            &+F2*((4*nt-2*npt-2*at)*(-2)/49_t_real-(8*n(ms)+2*np(ms)+4*n_a(ms))/49.0_t_real)&
            &+F4*((nt-4*npt+3*at)*12/441_t_real-(10*n(ms)+20*np(ms)+12*n_a(ms))*3/441_t_real)
       vvv(1,2,ms)=U*(-d(ms))&
            &+F2*(-(4*d(ms))/49.0_t_real)&
            &+F4*((10*dt)*1/63_t_real-(d(ms))*1/441_t_real)
       vvv(2,1,ms)=vvv(1,2,ms)
       !!
    Enddo! ms
    !!
    Return
    !!
  End Subroutine vofsig
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine  yyyy()
    !!
    !!
    Implicit none  
    !!IO
    !!LOCAL
    Logical(t_log) :: rea
    Integer(t_int) :: lmax,m,n,nv,ng,l,ig,i,j,deg,ml,il,jl,nl!,mm,nn
    Character(100) :: str
    Real(t_real)   :: rsh(3),w,a(30,30,30,30),dif(30)
    Real(t_real)   :: ylm(169),d,d0,rho,mag(3),dir(3),phi,theta,dum
    Real(t_real)   :: ez(3),mmm,v(3),mperp(3),mmmperp,nm,sumd,a0,a1,trd
    Real(t_real),Pointer ::  wg(:),ag(:,:)
    Complex(t_real):: sigma(2,2,0:3),nd(2,2),U(2,2),sn(2,2),nt(2,2),sTnxm(2,2)
    Complex(t_real):: sm(2,2),cyp(169),ca(30,30,30,30)
    Complex(t_real),Parameter   :: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter   :: c1=(1.0_t_real,0.0_t_real)
    Complex(t_real),Parameter   :: ci=(0.0_t_real,1.0_t_real)
    !!
    !!
    Goto 1000
    !!
    sigma(:,:,:)=c0
    sigma(1,1,0)=c1
    sigma(2,2,0)=c1
    sigma(1,1,3)=c1
    sigma(2,2,3)=-c1
    sigma(1,2,1)=c1
    sigma(2,1,1)=c1
    sigma(2,1,2)=ci
    sigma(1,2,2)=-ci
    
    Write(outfile,322) '1    =',((sigma(i,j,0),j=1,2),i=1,2)
    Write(outfile,322) 'sig_x=',((sigma(i,j,1),j=1,2),i=1,2)
    Write(outfile,322) 'sig_y=',((sigma(i,j,2),j=1,2),i=1,2)
    Write(outfile,322) 'sig_z=',((sigma(i,j,3),j=1,2),i=1,2)
    
322 Format(a,t41,': ',2('(',f10.5,',',f10.5,') '),/&
         &,t43,2('(',f10.5,',',f10.5,') '),/)

    !!
    ez=(/0.0_t_real,0.0_t_real,1.0_t_real/)
    !!
    rho=0.1_t_real
    mmm=2.0_t_real
    mag=(/-2.3_t_real,4.5_t_real,-9.23_t_real/)
    mag=mag/Sqrt(Dot_product(mag,mag))*mmm
    Print *,'mag=',mag,Sqrt(Dot_product(mag,mag))
    mperp=mag-mag(3)*ez
    mmmperp=Sqrt(Dot_product(mperp,mperp))

    Call cross(mag,ez,dir)

!    dir=(/-1.3_t_real,0.5_t_real,-0.23_t_real/)

    dir=dir/Sqrt(Dot_product(dir,dir))
    Print *,'dir=',dir,Sqrt(Dot_product(dir,dir))
    
    nm=Dot_product(dir,mag)
    Print *,'n*m=',nm

    sn=c0
    sm=c0
    Do i=1,3
       sm(:,:)=sm(:,:)+sigma(:,:,i)*mag(i)
       sn=sn+sigma(:,:,i)*dir(i)
    Enddo
    !!
    nd(:,:)=(rho*sigma(:,:,0)+sm)/2
    !!
    phi=30.0_t_real*Pi/180.0_t_real

    phi=Atan2(mmmperp,-mag(3))
100 Continue
    Print *,'zer0=',Cos(phi)*mmmperp+mag(3)*Sin(phi)
    
    U(:,:)=Cos(phi/2)*sigma(:,:,0)+ci*Sin(phi/2)*sn
    !!
    nt=Matmul(Matmul(U,nd),Conjg(Transpose(U)))
    !!
    Write(outfile,322) 'n= ',((nd(i,j),j=1,2),i=1,2)
    Write(outfile,322) 'sn=',((sn(i,j),j=1,2),i=1,2)
    Write(outfile,322) 'U=',((U(i,j),j=1,2),i=1,2)
    Write(outfile,322) 'nt=',((nt(i,j),j=1,2),i=1,2)
    Call cross(dir,mag,v)
    sTnxm=c0
    Do i=1,3
       sTnxm=sTnxm+sigma(:,:,i)*v(i)
    Enddo
    
    Print *,'rho=',Real(nt(1,1)+nt(2,2),t_real)
    Print *,'mag=',Real(nt(1,1)-nt(2,2),t_real)
    If(Real(nt(1,1)-nt(2,2),t_real)<0)Then
       phi=phi+Pi
       Goto 100
    Endif
    
!    nt=nt&
!         &-(&
!         &  rho*sigma(:,:,0)&
!         & +(Cos(phi)*mag(3)-Sin(phi)*mmmperp)*sigma(:,:,3)&
!         & +(Cos(phi)+Sin(phi)*mag(3)/mmmperp)*&
!         &  (sm-mag(3)*sigma(:,:,3))&
!         &)
         
    Write(outfile,322) 'nt=',((nt(i,j),j=1,2),i=1,2)
    !!
    !!
    !!
    
    !!
    Stop
    !!
1000 Continue
    !!
    Nullify(wg)
    Nullify(ag)
    !!
    l=3
    deg=2*l+1
    !!
    rea=.True.
    rea=.False.
    lmax=l
    !!
    nv=10*lmax
    Call sph_zyl_mesh(nv,ag,wg,ng,.False.)
    !!
    a=0.0_t_real
    ca=c0
    igloop: Do ig=1,ng
       rsh(:)=ag(:,ig)
       Call get_spherical_coordinates(rsh,theta,phi,dum)
       Call cxylm(lmax,cyp,theta,phi)
       w=wg(ig)
       Call ylms12(ylm,rsh(1),rsh(2),rsh(3),lmax)
       iloop: Do i=1,deg
          jloop: Do j=1,deg
             muloop: Do m=1,deg
                nuloop: Do n=1,deg
                   a(m,n,i,j)=a(m,n,i,j)&
                        &+ylm(l*l+m)*ylm(l*l+n)&
                        &*ylm(l*l+i)*ylm(l*l+j)*w
                   ca(m,n,i,j)=ca(m,n,i,j)&
                        &+Conjg(cyp(l*l+m))*cyp(l*l+n)&
                        &*Conjg(cyp(l*l+i))*cyp(l*l+j)*w
                Enddo nuloop
             Enddo muloop
          Enddo jloop
       Enddo iloop
    Enddo igloop
    !!
    Write(outfile,*)' start'
    !!
    !!
    sumd=0.0_t_real
    trd=0.0_t_real
    Do i=1,deg
       il=i-l-1
       Do j=1,deg
          jl=j-l-1
          Do m=1,deg
             ml=m-l-1
             If(rea) Then
                dif(1:deg)=a(m,1:deg,i,j)
             Else
                dif(1:deg)=Real(ca(m,1:deg,i,j),t_real)
                If( Any(Aimag(ca(m,1:deg,i,j)) > 1.0e-12_t_real ))Then
                   Print *,'imag',ca(m,1:deg,i,j)
                Endif
             Endif
             Do n=1,deg
                nl=n-l-1
                sumd=sumd+dif(n)*delta(il,jl)*delta(ml,nl)
                If(i==j .And. i==m .And. m==n)Then
                   trd=trd+dif(n)!*delta(il,nl)*delta(il,ml)*delta(il,jl)
                Endif
                d0=0.0_t_real
                a0=(deg+1.0_t_real)/(deg+2.0_t_real)
                a1=(deg)/(deg+2.0_t_real)
                

                If(rea)Then
                   d0=&
                        &a0*delta(il,jl)*delta(ml,nl)&
                        &+0*delta(il,ml)*delta(jl,nl)&
                        &+0*delta(il,nl)*delta(jl,ml) 
                   If(l==3)Then
                      d0=d0+0
                   Endif
                Else
                   d0=&
                        &a0*delta(il,jl)*delta(ml,nl)&
                        &+a1*delta(il,nl)*delta(jl,ml) &
                        &+a1*(&
                        &    (-1)**(m+n)*delta(il,-ml)*delta(jl,-nl)&
                        &   -delta(il,jl)*delta(ml,nl)/deg&
                        &)
                   If(l==3)Then
                      !d0=d0+delta(il,jl)*delta(ml,nl)*delta(Abs(ml),3)*( 14)/143
                      !d0=d0+delta(il,jl)*delta(ml,nl)*delta(Abs(ml),2)*(  7)/143
                      !d0=d0+delta(il,jl)*delta(ml,nl)*delta(Abs(ml),1)*(-11)/143
                      !d0=d0+delta(il,jl)*delta(ml,nl)*delta(ml, 0)*(-20)/143
                      !d0=d0+delta(jl-il,1)*delta(ml-nl,1)*delta(ml,-2)*(  7)/143
                      !d0=d0+delta(jl-il,1)*delta(ml-nl,1)*delta(ml,-1)*(  11617)/71488

                   Endif
                Endif
                d0=d0/fourpi
                dif(n)=(dif(n)-d0)*fourpi
             Enddo
             If(Any( Abs(dif(1:deg))>1.0e-12_t_real ) )Then
                Write(outfile,"('i,j,m=',i2,1x,i2,1x,i2)")il,j-l-1,ml

                Do n=1,deg
                   
                   
                   d=dif(n)
                   
                   !            If(Abs(d)>1.0e-10_t_real)Then
                   !Call make_ratio(d,mm,nn,10000_t_int,1.0e-10_t_real)
                   !If(nn==0) Stop 'make_ratio'
                   Call double_to_string_as_ratio(d,str,100000000_t_int&
                        &,1.0e-10_t_real,"(f30.5)")
                   !!
                   Write(outfile,"(a15,1x)",advance='no') Trim(str)
                   !Write(outfile,10,advance='no')d
                   !            Endif
                End Do
                Write(outfile,*)
                Write(outfile,*)
                Write(outfile,*)
             Endif
          Enddo
       Enddo
    Enddo
    Print *,'sumd=',sumd*fourpi/deg**2
    trd=trd*fourpi*2145/25249
    !trd=trd*fourpi/deg/(2*deg+1)*(deg+2)
    Print *,'trd=',trd
    Call double_to_string_as_ratio(trd,str,10000000_t_int&
         &,1.0e-10_t_real,"(f30.5)")
    Write(outfile,"('trd=',a15,1x)") Trim(str)
    !!
!10  Format(f15.7)
    Call pfree(wg)
    Call pfree(ag)
    !!
    Stop
    !!
    Return
    !!
    !!
  End Subroutine yyyy
#endif
  !!***********************************************************************
  Real(t_real) Function  delta(i,j)
    !!
    Implicit None  
    !!IO
    Integer(t_int),Intent(in)    :: i,j
    !!LOCAL
    !!
    !!
    delta=0.0_t_real
    If(i==j)delta=1.0_t_real
    !!
    Return
  End Function delta
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine intstuff()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Integer(t_int) :: Nc,Nu
    Integer(t_int) :: ic,iu,np,npskip,iint!,iex,Niex
    Real(t_real)   :: c,u,u0,u1,r,q,rbig,rho,x,cexp,c1,cmax!,lam,d,BB,ex
    Real(t_real)   :: zq,yq
    Real(t_real),Pointer :: net(:,:,:)
    Character(100)   :: str
    Character(*),Parameter::nsubfunc="intstuff"
    !!
    Nullify(net)
    !!
    Nc=21
    Nu=21
    !!
    rho=5.0_t_real
    rbig=2.6_t_real
    
    !!
    Call palloc('net',net,1_t_int,2_t_int,1_t_int,Nc,1_t_int,Nu&
         &,nmodule,nsubfunc)
    !!
    Open(12,file='+ql')
    Open(13,file='+ru1')
    Open(14,file='+ru2')
    np=0
    npskip=0
    c1=1.0_t_real-2.0_t_real*rbig/rho
    cmax=1.0_t_real
    Print *,'c1=',c1
    Print *,'cmax=',cmax

    iint=1
    Do ic=1,Nc
       !Print *,'hier'
       If(iint==1)Then
          x=(1.0_t_real-0.0_t_real)*(ic-1)/(Nc-1)+0.0_t_real
          c=1-2*rbig/((rho-rbig)*x**3+rbig)
          !cmin=-1
          !cmax=c1
          u1=(rho-rbig)*x**3+rbig
          If(2*rbig<=rho)Then
             u0=0.0_t_real
          Else
             u0=(rho-2*rbig)/((rho-rbig)*x**3-rbig)&
                  &*((rho-rbig)*x**3+rbig)
          Endif
       Else If(2*rbig<rho)Then
          x=(1.0_t_real-0.0_t_real)*(ic-1)/(Nc-1)+0.0_t_real
          c=(rho-2*rbig)/(2*rbig*x**3+(rho-2*rbig))
          !cmin=1.0
          !cmax=c1
          u0=0.0_t_real
          u1=(2*rbig*x**3+(rho-2*rbig))
       Endif
       

       If(iint==1)Then
          r=2*rbig/(1-c)
          If(r<=rho) Write(13,10)x,r
       Else
          q=(rho-2*rbig)/c
          If(q<=rho .And. q>=(rho-2*rbig)) Write(14,10)x,q
       Endif

       !Print *,'c=',c,c1
       Print *,'u0=',u0
       Print *,'u1=',u1

       Write(12,10)c,u1-u0
       

       Do iu=1,Nu
          np=np+1
          u=(u1-u0)*(iu-1)/(Nu-1)+u0
          !!
          q=u
          r=2.0_t_real*rbig+c*q
          !!
          !!
          If(q<Abs(2*rbig-r)-1.0e-13_t_real)Then
             Print *,'r=',r
             Print *,'q=',q
             Print *,'err=',q-r+2*rbig
             Print *,'u=',u
             Print *,'c=',c
          Endif
          net(1,ic,iu)=r
          net(2,ic,iu)=q
          If(All(net(1:2,ic,iu)>rho))Then
             npskip=npskip+1
          Endif
       Enddo
    Enddo
    Close(12)
    Close(13)
    Close(14)
    !!
    Print *,'c1=',c1
    Print *,'cmax=',cmax
    Print *,'rbig=',rbig
    Write(outfile,"('points: ',i5,' skipped: ',f5.2)") &
         &np,100.0_t_real*npskip/np
!    Print *,ex,100.0_t_real*npskip/np,cexp
    Print *,'cexp=',cexp
!    Enddo
!    Stop
    !!
    Open(12,file='+net_ulines')
    Do ic=1,Nc
       Do iu=1,Nu
          If(All(net(1:2,ic,iu)<=3*rho))Then
             Write(12,10) net(1,ic,iu),net(2,ic,iu)
          Endif
       Enddo
       Write(12,11)
    Enddo
    Close(12)
    !!
    !!
    Open(12,file='+net_clines')
    Do iu=1,Nu
       Do ic=1,Nc
          If(All(net(1:2,ic,iu)<=3*rho))Then
             Write(12,10) net(1,ic,iu),net(2,ic,iu)
          Endif
       Enddo
       Write(12,11)
    Enddo
    Close(12)
    !!
    !!
    Open(12,file='uclines')
    Write(12,*) 'read "+net_ulines"'
    Do ic=1,Nc
       Write(str,"(i5)")ic-1
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))

    Enddo

    Write(12,*) 'read "+net_clines"'
    Do iu=1,Nu
       Write(str,"(i5)")iu-1+Nc
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))
    Enddo

    Write(12,*) 'autoscale'
    Write(12,"('world 0, 0, ',g12.5,', ',g12.5,'')") rho,rho
    Write(12,*) 'view 0.100000, 0.4, 0.6, 0.9'
    Close(12)
    !!
    Open(12,file='ulines')
    Write(12,*) 'read "+net_ulines"'
    Do ic=1,Nc
       Write(str,"(i5)")ic-1
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))

    Enddo
    Write(12,*) 'view 0.100000, 0.4, 0.6, 0.9'
    Write(12,*) 'autoscale'
    Write(12,"('world 0, 0, ',g12.5,', ',g12.5,'')") rho,rho
    Close(12)
    !!
    Open(12,file='clines')
    Write(12,*) 'read "+net_clines"'
    Do iu=1,Nu
       Write(str,"(i5)")iu-1
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))

    Enddo
    Write(12,*) 'view 0.100000, 0.4, 0.6, 0.9'
    Write(12,*) 'autoscale'
    Write(12,"('world 0, 0, ',g12.5,', ',g12.5,'')") rho,rho
    Close(12)
    !!

    Open(12,file='+circles')
    Do iu=1,Nu
       yq=Sin(twopi*(iu-1)/(Nu-1))*rho
       zq=Cos(twopi*(iu-1)/(Nu-1))*rho-rbig
       Write(12,10) yq,zq
    Enddo
    Write(12,*)
    Do iu=1,Nu
       yq=Sin(twopi*(iu-1)/(Nu-1))*rho
       zq=Cos(twopi*(iu-1)/(Nu-1))*rho+rbig
       Write(12,10) yq,zq
    Enddo
    Close(12)
    Open(12,file='+xynet_ulines')
    Do ic=1,Nc
       Do iu=1,Nu
          If(All(net(1:2,ic,iu)<=rho))Then
             r=net(1,ic,iu)
             q=net(2,ic,iu)
             If(q==0.0_t_real)Then
                zq=-1.0_t_real
             Else
                zq=-(r**2-q**2-4*rbig**2)/(4*q*rbig)
             Endif
             yq=Sqrt(Max(0.0_t_real,1.0_t_real-zq**2))
             Write(12,10) q*yq,q*zq-rbig
          Endif
       Enddo
       Write(12,11)
    Enddo
    Close(12)
    !!
    Open(12,file='xylines')
    Write(12,*) 'read "+xynet_ulines"'
    Do ic=1,Nc
       Write(str,"(i5)")ic-1
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))

    Enddo
    Write(12,*) 'read "+circles"'
    Write(12,*) 'view 0.100000, 0.4, 0.6, 0.9'
    Write(12,*) 'autoscale'
    Write(12,"('world ',g12.5,',',f10.5,',',g12.5,',',g12.5,'')") 0,-rho,rho,rbig
    Close(12)
    !!
    Call pfree(net)
    !!
    Stop nsubfunc
    !!
    Return
    !!
10  Format(2(e30.15e3,2x))
11  Format()
    !!
  End Subroutine intstuff
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine intstuff1()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Integer(t_int) :: Nc,Nu
    Integer(t_int) :: ic,iu,np,npskip!,iex,Niex
    Real(t_real)   :: c,u,u0,u1,r,q,rbig,rho,b,x,cexp,c1,cmax,d!,BB,ex,lam
    Real(t_real),Pointer :: net(:,:,:)
    Character(100)   :: str
    Character(*),Parameter::nsubfunc="intstuff1"
    !!
    Nullify(net)
    !!
    Nc=61
    Nu=61
    !!
    rho=5.0_t_real
    rbig=rho*sq2o2+1.0e-10_t_real
    !rbig=4.0_t_real
    b=2*rbig/rho
    Print *,'b=',b
    
    !!
    Call palloc('net',net,1_t_int,2_t_int,1_t_int,Nc,1_t_int,Nu&
         &,nmodule,nsubfunc)
    !!
    !Niex=10
    !Do iex=1,Niex
    !   ex=(0.999_t_real-0.1_t_real)*(iex-1)/(Niex-1)+0.1_t_real
    !cexp=1-Log(b)/Log(2.0_t_real)
    !if(b>=1.0_t_real) cexp=1.0_t_real
    !c1=1.0_t_real
    !If(b>=1.0_t_real)Then
    !   c1=1-b**2/4
    !Endif
    !Print *,'c1=',c1
    !Print *,'ex=',ex,cexp
    u1=rho
    Open(12,file='+ql')
    np=0
    npskip=0
    c1=rbig/rho
    If(c1<0.5_t_real)Then
       cmax=-1.0_t_real
    Else if(c1<=sq2o2)then
       cmax=Sqrt(1.0_t_real-1.0_t_real/c1**2/4.0_t_real)
    Else
       cmax=c1
    Endif
    Print *,'c1=',c1
    Print *,'cmax=',cmax
    Do ic=1,Nc
       !Print *,'hier'
       x=(1.0_t_real-cmax)*(ic-1)/(Nc-1)+cmax
       !x=x**3
       !c=1.0_t_real-2.0_t_real*x
       c=x

       !! 1-1/4c1**2>= c**2)
       !!
       u0=0.0_t_real
       u1=rho
       If(c1<=0.5_t_real)Then
          If(c<=c1)Then
             u1=Sqrt(4*rbig**2*c**2-4*rbig**2+rho**2)+2*rbig*c
          Else
             u1=rbig/c
          Endif
       Else If(c1<sq2o2)Then
          d=Sqrt(Max(0.0_t_real,4*rbig**2*c**2-4*rbig**2+rho**2))
          u0=-d+2*rbig*c
          If(c<=c1)Then
             u1=d+2*rbig*c
          Else
             u1=rbig/c
          Endif
          Print *,'c=',c,c1
          Print *,'u0=',u0
          Print *,'u1=',u1
       Else 
          u0=-Sqrt(4*rbig**2*c**2-4*rbig**2+rho**2)+2*rbig*c
          u1=rbig/c
       Endif

       Write(12,10)c,u1-u0
              

       Do iu=1,Nu
          np=np+1
          u=(u1-u0)*(iu-1)/(Nu-1)+u0
          !u=1/u
          !u=1
          !Print *,'u=',u
          !! bispherical
          q=u
          r=Sqrt(q**2-4.0_t_real*rbig*q*c+4.0_t_real*rbig**2)
          !!
          !q=a*u/Sqrt(1+ c*u*(u-2))
          !r=a*(2-u)/Sqrt(1+ c*u*(u-2))
          !!
          If(q<Abs(2*rbig-r)-1.0e-13_t_real)Then
             Print *,'r=',r
             Print *,'q=',q
             Print *,'err=',q-r+2*rbig
             Print *,'u=',u
             Print *,'c=',c
          Endif
          net(1,ic,iu)=r
          net(2,ic,iu)=q
          If(All(net(1:2,ic,iu)>rho))Then
             npskip=npskip+1
          Endif
       Enddo
    Enddo
    Close(12)
    !!
    Print *,'c1=',c1
    Print *,'cmax=',cmax
    Print *,'rbig=',rbig
    Write(outfile,"('points: ',i5,' skipped: ',f5.2)") &
         &np,100.0_t_real*npskip/np
!    Print *,ex,100.0_t_real*npskip/np,cexp
    Print *,'cexp=',cexp
!    Enddo
!    Stop
    !!
    Open(12,file='+net_ulines')
    Do ic=1,Nc
       Do iu=1,Nu
          If(All(net(1:2,ic,iu)<=3*rho))Then
             Write(12,10) net(1,ic,iu),net(2,ic,iu)
          Endif
       Enddo
       Write(12,11)
    Enddo
    Close(12)
    !!
    !!
    Open(12,file='+net_clines')
    Do iu=1,Nu
       Do ic=1,Nc
          If(All(net(1:2,ic,iu)<=3*rho))Then
             Write(12,10) net(1,ic,iu),net(2,ic,iu)
          Endif
       Enddo
       Write(12,11)
    Enddo
    Close(12)
    !!
    !!
    Open(12,file='uclines')
    Write(12,*) 'read "+net_ulines"'
    Do ic=1,Nc
       Write(str,"(i5)")ic-1
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))

    Enddo

    Write(12,*) 'read "+net_clines"'
    Do iu=1,Nu
       Write(str,"(i5)")iu-1+Nc
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))
    Enddo

    Write(12,*) 'autoscale'
    Write(12,"('world 0, 0, ',g12.5,', ',g12.5,'')") rho,rho
    Write(12,*) 'view 0.100000, 0.4, 0.6, 0.9'
    Close(12)
    !!
    Open(12,file='ulines')
    Write(12,*) 'read "+net_ulines"'
    Do ic=1,Nc
       Write(str,"(i5)")ic-1
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))

    Enddo
    Write(12,*) 'view 0.100000, 0.4, 0.6, 0.9'
    Write(12,*) 'autoscale'
    Write(12,"('world 0, 0, ',g12.5,', ',g12.5,'')") rho,rho
    Close(12)
    !!
    Open(12,file='clines')
    Write(12,*) 'read "+net_clines"'
    Do iu=1,Nu
       Write(str,"(i5)")iu-1
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))

    Enddo
    Write(12,*) 'view 0.100000, 0.4, 0.6, 0.9'
    Write(12,*) 'autoscale'
    Write(12,"('world 0, 0, ',g12.5,', ',g12.5,'')") rho,rho
    Close(12)
    !!
    Call pfree(net)
    !!
    Stop nsubfunc
    !!
    Return
    !!
10  Format(2(e30.15e3,2x))
11  Format()
    !!
  End Subroutine intstuff1
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine intstuff2()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Integer(t_int) :: Nc,Nu
    Integer(t_int) :: ic,iu,np,npskip!,iex,Niex
    Real(t_real)   :: c,u,u0,u1,r,q,rbig,rho,b,x,cexp,c1!,BB,ex,lam
    Real(t_real),Pointer :: net(:,:,:)
    Character(100)   :: str
    Character(*),Parameter::nsubfunc="intstuff2"
    !!
    Nullify(net)
    !!
    Nc=81
    Nu=81
    !!
    rho=5.0_t_real
    rbig=1.4_t_real
    b=2*rbig/rho
    Print *,'b=',b
    
    !!
    Call palloc('net',net,1_t_int,2_t_int,1_t_int,Nc,1_t_int,Nu&
         &,nmodule,nsubfunc)
    !!
    !Niex=10
    !Do iex=1,Niex
    !   ex=(0.999_t_real-0.1_t_real)*(iex-1)/(Niex-1)+0.1_t_real
    cexp=1-Log(b)/Log(2.0_t_real)
    if(b>=1.0_t_real) cexp=1.0_t_real
    c1=1.0_t_real
    If(b>=1.0_t_real)Then
       c1=1-b**2/4
    Endif
    Print *,'c1=',c1
    !Print *,'ex=',ex,cexp
    u0=0.0_t_real
    u1=0.99999_t_real
    Open(12,file='+cofx')
    Open(13,file='+ru1')
    np=0
    npskip=0
    Do ic=1,Nc
       x=(c1)*(ic-1)/(Nc-1)+0.0_t_real
       c=1-(1-x)**cexp
       !c=1
       r=rbig/Sqrt(1-c)
       Write(12,10)x,c
       If(r<=rho) Write(13,10)x,r
       !Print *,'c=',c
       u0=0.0_t_real
       If(b>=1.0_t_real) u0=2*c-1+Sqrt(b**2-1+(1-2*c)**2)
       !c=0.5
       Do iu=1,Nu
          np=np+1
          u=(u1-u0)*(iu-1)/(Nu-1)+u0
          !u=1/u
          !u=1
          !Print *,'u=',u
          !! bispherical
          r=2*rbig/Sqrt( (1+u)**2 * (1-c) + (1-u)**2*c)
          q=r*u
          !!
          !q=a*u/Sqrt(1+ c*u*(u-2))
          !r=a*(2-u)/Sqrt(1+ c*u*(u-2))
          !!
          If(q<Abs(2*rbig-r)-1.0e-13_t_real)Then
             Print *,'r=',r
             Print *,'q=',q
             Print *,'err=',q-r+2*rbig
             Print *,'u=',u
             Print *,'c=',c
          Endif
          net(1,ic,iu)=r
          net(2,ic,iu)=q
          If(All(net(1:2,ic,iu)>rho))Then
             npskip=npskip+1
          Endif
       Enddo
    Enddo
    Close(13)
    Close(12)
    !!
    Write(outfile,"('points: ',i5,' skipped: ',f5.2)") &
         &np,100.0_t_real*npskip/np
!    Print *,ex,100.0_t_real*npskip/np,cexp
    Print *,'cexp=',cexp
!    Enddo
!    Stop
    !!
    Open(12,file='+net_ulines')
    Do ic=1,Nc
       Do iu=1,Nu
          If(All(net(1:2,ic,iu)<=rho))Then
             Write(12,10) net(1,ic,iu),net(2,ic,iu)
          Endif
       Enddo
       Write(12,11)
    Enddo
    Close(12)
    !!
    !!
    Open(12,file='+net_clines')
    Do iu=1,Nu
       Do ic=1,Nc
          If(All(net(1:2,ic,iu)<=rho))Then
             Write(12,10) net(1,ic,iu),net(2,ic,iu)
          Endif
       Enddo
       Write(12,11)
    Enddo
    Close(12)
    !!
    !!
    Open(12,file='uclines')
    Write(12,*) 'read "+net_ulines"'
    Do ic=1,Nc
       Write(str,"(i5)")ic-1
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))

    Enddo

    Write(12,*) 'read "+net_clines"'
    Do iu=1,Nu
       Write(str,"(i5)")iu-1+Nc
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))
    Enddo

    Write(12,*) 'autoscale'
    Write(12,"('world 0, 0, ',g12.5,', ',g12.5,'')") rho,rho
    Write(12,*) 'view 0.100000, 0.4, 0.6, 0.9'
    Close(12)
    !!
    Open(12,file='ulines')
    Write(12,*) 'read "+net_ulines"'
    Do ic=1,Nc
       Write(str,"(i5)")ic-1
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))

    Enddo
    Write(12,*) 'view 0.100000, 0.4, 0.6, 0.9'
    Write(12,*) 'autoscale'
    Write(12,"('world 0, 0, ',g12.5,', ',g12.5,'')") rho,rho
    Close(12)
    !!
    Open(12,file='clines')
    Write(12,*) 'read "+net_clines"'
    Do iu=1,Nu
       Write(str,"(i5)")iu-1
       Write(12,"('s',a,' symbol 1')")Trim(Adjustl(str))

    Enddo
    Write(12,*) 'view 0.100000, 0.4, 0.6, 0.9'
    Write(12,*) 'autoscale'
    Write(12,"('world 0, 0, ',g12.5,', ',g12.5,'')") rho,rho
    Close(12)
    !!
    Call pfree(net)
    !!
    Stop nsubfunc
    !!
    Return
    !!
10  Format(2(e30.15e3,2x))
11  Format()
    !!
  End Subroutine intstuff2
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine test1()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="test1"
    Integer(t_int) :: k,nn,l,ix,nx
    Real(t_real)   :: d,d0,dfac(0:1000),err,x,del,u,PP,y,df,ex,u2
    !!
    l=12
    dfac(0)=1.0_t_real
    Do k=1,l+100+2
       dfac(k)=dfac(k-1)*(2*k+1)
    Enddo
    !!
    l=6
    !!
    nx=200
    Open(12,file='+nn')
    Do ix=1,nx

       u=spow(10.0_t_real,(1+5)*(ix-1)/(nx-1.0_t_real)-5)
       u2=u*u
       ex=Exp(-(u2))
       x=2*u2
       
       !!quasi exact
       
       nn=Ceiling(Log(Epsilon(1.0_t_real))/Log(x/(2*l+5))-1)
       Print *,u,nn
       PP=1.0_t_real
       Do k=nn,0,-1
          PP=1.0_t_real+PP*x/(2*(l+k)+5)
       Enddo
       y=2.0_t_real*u
       df=y
       Do k=1,l+1
          df=df*y/(2*k+1)
       Enddo
       d0=1.0_t_real/sqpi*PP*df*ex

       !! instable
       PP=1.0_t_real
       Do k=1,l
          PP=1.0_t_real+PP*x/(2*(l-k+1)+1)
       Enddo
       d=(erf(u)-2.0_t_real/sqpi*PP*u*ex)/u**(l+1)
       
       err=d0-d
       !If(d0/=0.0_t_real) err=err/d0
       Write(12,"(4(e30.15e3,2x))")Log10(u),d0,d,err
          
    Enddo
    !!

    


!    d0=Log(Epsilon(1.0_t_real))/Log(x/(2*l+5))-1.0_t_real
    Close(12)
    
    l=12
    del=1.0e-10_t_real
    Print *,Exp(Log(del*dfac(2*l+3))/(l+1))

    !!
    Stop
    !!
    !!
    Return
    !!
  End Subroutine test1
#endif
  !!***********************************************************************
  Real(t_real) Function fac2(n)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: n
    !!LOCAL
    !Character(*),Parameter::nsubfunc="fac2"
    !!
    !!
    fac2=Exp(lgamma0((2*n+3)*0.5_t_real))*2**(n+1)/sqpi
    !!
    Return
    !!
  End Function fac2
  !!***********************************************************************
  Real(t_real) Function lgamma1(x)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lgamma1"
    !!
    !!
    lgamma1= -1.0_t_real/(360*x**3)+1.0_t_real/(1260*x**5)
    !!
    Return
    !!
  End Function lgamma1
  !!***********************************************************************
  Real(t_real) Function lgamma0(x)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lgamma0"
    !!
    !!
    lgamma0=-x+ (x-0.5_t_real)*Log(x)+Log(twopi)*0.5_t_real&
         &+1.0_t_real/(12.0_t_real*x)-1.0_t_real/(360*x**3)+1.0_t_real/(1260*x**5)
    !!
    Return
    !!
  End Function lgamma0
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine efit()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="efit"
    Logical(t_log) :: indef
    Integer(t_int) :: pattern(4,0:4),m1,m2,m3,m4,i
    Real(t_real)   :: e(0:4),de(4),M(4,4),M0(4),A(3,3)
    !!
    !!
    !!
    pattern(:,0)=(/+1,+1,+1,+1/)
    E(0)=-20551.0497265_t_real ! pppp

    pattern(:,1)=(/+1,-1,+1,-1/)  ! pmpm
    E(1)=-20551.0498041_t_real
         
    pattern(:,2)=(/-1,-1,+1,+1/) ! mmpp
    E(2)=-20551.0497237_t_real
         
    pattern(:,3)=(/+1,-1,-1,+1/) ! pmmp
    E(3)=-20551.0497957_t_real
         
    pattern(:,4)=(/+1,-1,+1,+1/) ! pmpp
    E(4)=-20551.0497624_t_real
    !!
    m1=pattern(1,0)
    m2=pattern(2,0)
    m3=pattern(3,0)
    m4=pattern(4,0)
    M0(1)= (    m1*m2 + m3*m4 )*0.5_t_real !! j12
    M0(2)= (    m1*m3 + m2*m4 )*1.0_t_real   !! j13
    M0(3)= (    m1*m4 + m2*m3 )*2.0_t_real !! j14
    M0(4)= (    1             )*0.5_t_real !! z*j11
    !!
    Do i=1,4
       de(i)=e(i)-e(0)
       Print *,'de=',de(i)
       m1=pattern(1,i)
       m2=pattern(2,i)
       m3=pattern(3,i)
       m4=pattern(4,i)
       M(i,1)= (    m1*m2 + m3*m4  )*0.5_t_real-M0(1) !! j12
       M(i,2)= (    m1*m3 + m2*m4  )*1.0_t_real-M0(2) !! j13
       M(i,3)= (    m1*m4 + m2*m3  )*2.0_t_real-M0(3) !! j14
       M(i,4)= (    1              )*0.5_t_real-M0(4) !! z*j11
    Enddo
    !!
    !!
    Print "('M0=',/,4(f5.2,4x),/,'M=',/)",M0(:)
    Do i=1,4
       Print "(4(f8.4,4x))",M(i,:)
    Enddo
    !!
    A(:,:)=M(1:3,1:3)
    Print "('A=')"
    Do i=1,3
       Print "(4(f5.2,4x))",A(i,:)
    Enddo
    !!
    Call rinv(A,A,3_t_int,3_t_int,indef)
    If(indef) Stop 'indef'
    !!
    Print "('A^(-1)=')"
    Do i=1,3
       Print "(4(f5.2,4x))",A(i,:)
    Enddo
    !!
    Print "('de=',3(f15.8,4x))",de(1:3)*1000.0_t_real
    de(1:3)=Matmul(A,de(1:3))
    Print "('J=',3(f15.8,4x))",-de(1:3)*1000.0_t_real*hatoev
    Stop
    !!
    Return
    !!
  End Subroutine efit
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine xctest()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="xctest"
    Integer(t_int) :: i,N,mspin,nexp1,nexp0
    Real(t_real)   :: zeta,rs,rho,rhoup,rhodn,eps,den(2),mag,x0&
         &,y0,e0,vex(2),vexold(2),y1,K,P,Q,s,ex
    Real(t_real)   :: phi,gradrhos(2),gradrho,mixrhos(2),mixrho,laprhos(2)
    Real(t_real)   :: rhos(2),kf
    Character(100)   :: mode
    Real(t_real),Parameter :: c2o3=0.66666666666666666666_t_real


    !!
    N=1000
    Open(12,file='+fzeta')
    Do i=2,N
       zeta=Real(i-1,t_real)/Real(N-1,t_real)
       Write(12,"(5(e30.15e3,2x))")zeta,fzeta(zeta)&
            !&,(fzeta(zeta)-0.5_t_real*d2fzeta(0.0_t_real)*zeta**2)/fzeta(zeta)!&
            !&,(fzeta(zeta)-zeta*(1.04291_t_real*zeta-0.083375))/fzeta(zeta)!&
            &,dfzeta(zeta)&
            !&,(dfzeta(zeta)-d2fzeta(0.0_t_real)*zeta)/dfzeta(zeta)!&
            &,d2fzeta(zeta)
    Enddo
    Close(12)
    !!
    !!
    Call setxcversion(XCVER_PERDEWWANG92)
    Call setxcversion(XCVER_XONLY)
    Call setxcversion(XCVER_PBE96)
    !!
    !!
    !!
    Open(12,file='+epsxc')
    zeta=0.0_t_real
    phi=((1+zeta)**c2o3+(1-zeta)**c2o3)*0.5_t_real
    rs=0.00001_t_real
    rho=0.23873241463784300365_t_real/rs**3
    rhos(1)=rho*(1.0_t_real+zeta)*0.5_t_real
    rhos(2)=rho*(1.0_t_real-zeta)*0.5_t_real
    !kf=(3.0_t_real*pi**2)**c1o3*rho**c1o3
    !ks=Sqrt(4.0_t_real*kf/pi)
    Do i=2,N-1
       s=3.0_t_real*Real(i-1,t_real)/Real(N-1,t_real)


       kf=(3.0_t_real*pi**2)**c1o3*rho**c1o3
       gradrho=s*(2.0_t_real*kf*rho)
       gradrhos(1)=gradrho*0.5_t_real*(1+zeta)
       gradrhos(2)=gradrho*0.5_t_real*(1-zeta)

       laprhos=0.0_t_real
       mixrhos=0.0_t_real
       mixrho=0.0_t_real
       
       
       ex = - 3.0_t_real/fourpi*(3.0_t_real*pi**2)**c1o3*rho**c1o3

       Call vxcrho(2_t_int,rhos,gradrhos,gradrho,laprhos,mixrhos,mixrho&
            &,vex,eps,1.0_t_real)

       Write(12,"(10(e30.15e3,2x))") s,eps/ex
    Enddo
    Close(12)
    !!
    Stop
    !!
    Open(12,file='=.xc')
    Read(12,*)
    Read(12,*)mode
    Read(12,*)
    Read(12,*)mspin
    Close(12)
    !!
    Open(12,file='+epsxc')
    Do i=2,N-1
       If(Trim(mode)=='z') Then
          nexp0=0
          rs=10.0_t_real**nexp0
          rho=0.23873241463784300365_t_real/rs**3
          zeta=Real(i-1,t_real)/Real(N-1,t_real)
          x0=zeta
          If(mspin==1) Stop' mode==z and mspin=1'
       Else If(Trim(mode)=='r') Then
          !! vary r0 fixed zeta
          zeta=0.9_t_real
          nexp1=12
          nexp0=-12
          rs=10.0_t_real**(Real(i-1,t_real)/Real(N-1,t_real)*(nexp1-nexp0)+nexp0)
          rho=0.23873241463784300365_t_real/rs**3
          x0=rs
          If(mspin==1) zeta=0.0_t_real
       Else  If(Trim(mode)=='n') Then
          !! vary n fixed m
          nexp1=0 !! fixes mag
          nexp0=-1
          If(mspin==1) nexp1=3
          mag=0.23873241463784300365_t_real/(10.0_t_real**nexp1)**3 
          rs=10.0_t_real**(Real(i-1,t_real)/Real(N-1,t_real)*(nexp0-nexp1)+nexp1)
          rho=0.23873241463784300365_t_real/rs**3
          zeta=mag/rho
          If(mspin==1) zeta=0.0_t_real
          x0=rho
       Else If(Trim(mode)=='m' .Or. Trim(mode)=='lm') Then
          !! vary m fixed n
          nexp0=12
          nexp1=0   !! fixes n
          rho=0.23873241463784300365_t_real/(10.0_t_real**nexp1)**3
          rs=10.0_t_real**(Real(i-1,t_real)/Real(N-1,t_real)*(nexp1-nexp0)+nexp0)
          mag=0.23873241463784300365_t_real/rs**3
          zeta=mag/rho
          x0=mag
          If(mspin==1) Stop' mode==m and mspin=1'
       Endif
       !!
       rhoup=rho*(1+zeta)*0.5_t_real
       rhodn=rho*(1-zeta)*0.5_t_real

       
       den(1)=rhoup
       den(2)=rhodn

       !!
       Stop 'GGA'
!       Call vxcrho(mspin,den,vexold,epsold)
       Call kxcrho (mspin,den,K,Q,P,vex,eps,1.0_t_real)


       !!
       If(Trim(mode)=='z') Then
          e0=eps
          y0=-(vex(1)-vex(2))*0.5_t_real
          y1=-(vex(1)+vex(2))*0.5_t_real
       Else If(Trim(mode)=='r') Then
          e0=rho*eps
          y0=-(vex(1)+vex(2))*0.5_t_real
          y1=-(vex(1)-vex(2))*0.5_t_real
       Else If(Trim(mode)=='n') Then
          e0=rho*eps
          y0=(vex(1)+vex(2))*0.5_t_real
          !!
          e0=(vex(1)-vex(2))*0.5_t_real
          y0=Q
       Else If(Trim(mode)=='m') Then
          e0=rho*eps
          y0=(vex(1)-vex(2))*0.5_t_real
          !!
          e0=(vexold(1)+vexold(2))*0.5_t_real
          y0=Q
       Endif
       !!
       Write(12,"(10(e30.15e3,2x))") x0,e0,y0
       !Write(12,"(10(e30.15e3,2x))") x0,vex(2)-vexold(2)

       !!
    Enddo
    Close(12)
    !!
    Stop nsubfunc
    !!
    Return
    !!
  End Subroutine xctest
#endif
  !!***********************************************************************
  Real(t_real) Function fzeta(x)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x
    !!LOCAL
    !Character(*),Parameter::nsubfunc="fzeta"
    !!
    !!
    fzeta=(&
         & (1.0_t_real+x)**(4.0_t_real/3.0_t_real)&
         &+(1.0_t_real-x)**(4.0_t_real/3.0_t_real)&
         &-2&
         &)/(2**(4.0_t_real/3.0_t_real)-2)
    !!
    Return
    !!
  End Function fzeta
  !!***********************************************************************
  Real(t_real) Function dfzeta(x)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x
    !!LOCAL
    !Character(*),Parameter::nsubfunc="dfzeta"
    !!
    !!
    dfzeta=2.0_t_real/3.0_t_real*(&
         & (1.0_t_real+x)**(1.0_t_real/3.0_t_real)&
         &-(1.0_t_real-x)**(1.0_t_real/3.0_t_real)&
         &)/(2**(1.0_t_real/3.0_t_real)-1)
    !!
    Return
    !!
  End Function dfzeta
  !!***********************************************************************
  Real(t_real) Function d2fzeta(x)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x
    !!LOCAL
    !Character(*),Parameter::nsubfunc="d2fzeta"
    !!
    !!
    d2fzeta=2.0_t_real/9.0_t_real*(&
         & (1.0_t_real+x)**(-2.0_t_real/3.0_t_real)&
         &+(1.0_t_real-x)**(-2.0_t_real/3.0_t_real)&
         &)/(2**(1.0_t_real/3.0_t_real)-1)
    !!
    Return
    !!
  End Function d2fzeta
  !!***********************************************************************
!!$  Subroutine drhotest()
!!$    !!
!!$    !!
!!$    Implicit None
!!$    !!IO
!!$    !!LOCAL
!!$    Character(*),Parameter::nsubfunc="drhotest"
!!$    Integer(t_int) :: l,m,ilm,i,j,k,ii,jj,kk,n,ilam0,ilam,lpm,kkk,m1,jlm,mL
!!$    Integer(t_int) :: jlam,nn
!!$    Real(t_real)   :: r,rsh(3),r2rho,rho,r2,fpm(2),dr2rho,d2r2rho
!!$    Real(t_real)   :: r0,rsh0(3),delta,f(0:2,0:2,0:2),rr(3,0:2,0:2,0:2),d
!!$    Real(t_real)   :: gd(3),ggd(3,3),grad(3),err(3),rel(3),ggrad(3,3)
!!$    Real(t_real)   :: rd(3,3),fpmpm(2,2),gerr(3,3),grel(3,3)
!!$    Real(t_real),Pointer :: p_ylm(:)
!!$    Real(t_real),Pointer :: p_clpm(:,:)  
!!$    Real(t_real),Pointer :: p_ccc(:,:,:,:)
!!$    Real(t_real),Pointer :: p_rvylm(:,:,:)
!!$    Real(t_real),Pointer :: p_qvylm(:,:,:,:,:)
!!$    Logical(t_log) :: testgrad
!!$    !!
!!$    Nullify(p_ylm,p_clpm,p_ccc,p_rvylm,p_qvylm)
!!$    !!
!!$    testgrad=.True.
!!$    testgrad=.False.
!!$    Do mL=0,12
!!$       Print *,'mL=',mL
!!$
!!$       Call palloc('p_ylm',p_ylm,1_t_int,((mL+2)+1)**2,nmodule,nsubfunc)
!!$       Call palloc('p_clpm',p_clpm,1_t_int,2_t_int,0_t_int,(mL+1)&
!!$            &,nmodule,nsubfunc)
!!$       Call palloc('p_ccc',p_ccc,1_t_int,3_t_int,1_t_int,2_t_int&
!!$            &,1_t_int,3_t_int,1_t_int,((mL+1)+1)**2,nmodule,nsubfunc)
!!$       Call palloc('p_rvylm',p_rvylm,1_t_int,3_t_int,1_t_int,2_t_int&
!!$            &,1_t_int,((mL+1)+1)**2,nmodule,nsubfunc)
!!$       Call palloc('p_qvylm',p_qvylm,1_t_int,3_t_int,1_t_int,3_t_int&
!!$            &,1_t_int,2_t_int,1_t_int,2_t_int&
!!$            &,1_t_int,((mL)+1)**2,nmodule,nsubfunc)
!!$       
!!$
!!$
!!$       Call calc_real_vec_ccoefs(p_ccc,(mL+1),p_clpm)
!!$
!!$
!!$       !!
!!$       Do l=0,mL
!!$
!!$          Do m=-l,l
!!$             ilm=l*l+l+1+m
!!$             !!
!!$             !!
!!$             !delta=0.00001_t_real
!!$             If(testgrad)Then
!!$                delta=0.000004_t_real
!!$             Else
!!$                delta=0.0001_t_real
!!$             Endif
!!$             r0=0.5_t_real
!!$             rsh0=r0*(/0.123_t_real,-0.7468_t_real,2.864_t_real/)
!!$             !!
!!$             Do i=0,2
!!$                Do j=0,2
!!$                   Do k=0,2
!!$                      
!!$                      rsh(1)=rsh0(1)+delta*(i-1)
!!$                      rsh(2)=rsh0(2)+delta*(j-1)
!!$                      rsh(3)=rsh0(3)+delta*(k-1)
!!$                      
!!$                      
!!$                      !Print *,rsh(1)-rsh0(1)
!!$                      
!!$                      r2=Dot_product(rsh,rsh)
!!$                      r=Sqrt(r2)
!!$                      
!!$                      rr(:,i,j,k)=rsh(:)
!!$                      
!!$                      Call ylms12(p_ylm,rsh(1),rsh(2),rsh(3),mL)
!!$                      r2rho=frho(r,dr2rho,d2r2rho)
!!$                      
!!$                      rho=r2rho*p_ylm(ilm)/r2
!!$                      
!!$                      f(i,j,k)=rho
!!$                   Enddo
!!$                Enddo
!!$             Enddo
!!$             !!
!!$             !!
!!$             !!
!!$             !!
!!$             i=1
!!$             j=1
!!$             k=1
!!$             !Do i=0,2
!!$             !   Do j=0,2
!!$             !      Do k=0,2
!!$             
!!$             rsh(:)=rr(:,i,j,k)
!!$             !!
!!$             d=0.0_t_real
!!$             gd(:)=0.0_t_real
!!$             ggd(:,:)=0.0_t_real
!!$             Do ii=0,2
!!$                Do jj=0,2
!!$                   Do kk=0,2
!!$                      d=d&
!!$                           &+f(ii,jj,kk)&
!!$                           &*L2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*L2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*L2(kk,rsh(3),rsh0(3),delta)
!!$                      gd(1)=gd(1)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*dL2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*L2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*L2(kk,rsh(3),rsh0(3),delta)
!!$                      gd(2)=gd(2)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*L2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*dL2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*L2(kk,rsh(3),rsh0(3),delta)
!!$                      gd(3)=gd(3)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*L2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*L2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*dL2(kk,rsh(3),rsh0(3),delta)
!!$                      
!!$                      
!!$                      ggd(1,1)=ggd(1,1)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*d2L2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*L2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*L2(kk,rsh(3),rsh0(3),delta)
!!$                      ggd(1,2)=ggd(1,2)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*dL2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*dL2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*L2(kk,rsh(3),rsh0(3),delta)
!!$                      ggd(1,3)=ggd(1,3)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*dL2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*L2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*dL2(kk,rsh(3),rsh0(3),delta)
!!$                      
!!$                      
!!$                      ggd(2,1)=ggd(2,1)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*dL2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*dL2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*L2(kk,rsh(3),rsh0(3),delta)
!!$                      ggd(2,2)=ggd(2,2)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*L2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*d2L2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*L2(kk,rsh(3),rsh0(3),delta)
!!$                      ggd(2,3)=ggd(2,3)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*L2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*dL2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*dL2(kk,rsh(3),rsh0(3),delta)
!!$                      
!!$                      
!!$                      ggd(3,1)=ggd(3,1)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*dL2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*L2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*dL2(kk,rsh(3),rsh0(3),delta)
!!$                      ggd(3,2)=ggd(3,2)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*L2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*dL2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*dL2(kk,rsh(3),rsh0(3),delta)
!!$                      ggd(3,3)=ggd(3,3)&
!!$                           &+f(ii,jj,kk)&
!!$                           &*L2(ii,rsh(1),rsh0(1),delta)&
!!$                           &*L2(jj,rsh(2),rsh0(2),delta)&
!!$                           &*d2L2(kk,rsh(3),rsh0(3),delta)
!!$                      
!!$                      
!!$                   Enddo
!!$                Enddo
!!$             Enddo
!!$             !!
!!$             
!!$             r2=Dot_product(rsh,rsh)
!!$             r=Sqrt(r2)
!!$             
!!$             
!!$             Call calc_real_quad_harmonics(rsh,p_ccc,mL,p_clpm,p_ylm,p_rvylm,p_qvylm)
!!$             
!!$             
!!$             r2rho=frho(r,dr2rho,d2r2rho)
!!$             
!!$             rho=r2rho*p_ylm(ilm)/r2
!!$             
!!$             
!!$             r2=Dot_product(rsh,rsh)
!!$             r=Sqrt(r2)
!!$             
!!$             
!!$             !!
!!$             !!
!!$             !!
!!$             
!!$             r2rho=frho(r,dr2rho,d2r2rho)
!!$             
!!$             fpm(2)=(dr2rho-( 2.0_t_real+l)/r*r2rho)/r2
!!$             fpm(1)=(dr2rho+(-1.0_t_real+l)/r*r2rho)/r2
!!$             
!!$             !Print *,fp,fm
!!$
!!$             fpmpm(1,1)=&
!!$                  &(d2r2rho+(2.0_t_real*l-3.0_t_real)/r*dr2rho&
!!$                  &+(l-3.0_t_real)*(l-1.0_t_real)/r2*r2rho)/r2
!!$             fpmpm(1,2)=&
!!$                  &(d2r2rho-2.0_t_real/r*dr2rho&
!!$                  &-(l+2.0_t_real)*(l-1.0_t_real)/r2*r2rho)/r2
!!$             fpmpm(2,2)=&
!!$                  &(d2r2rho-(2.0_t_real*l+5.0_t_real)/r*dr2rho&
!!$                  &+(l+4.0_t_real)*(l+2.0_t_real)/r2*r2rho)/r2
!!$             fpmpm(2,1)=fpmpm(1,2)
!!$             !!
!!$             
!!$             grad(:)=0.0_t_real
!!$             Do jlam=1,2
!!$                grad(:)=grad(:) +p_clpm(jlam,l)*fpm(jlam)*p_rvylm(:,jlam,ilm)
!!$             Enddo
!!$
!!$             !! gradgrad
!!$
!!$
!!$
!!$             ggrad(:,:)=0.0_t_real
!!$             Do ilam=1,2
!!$                Do jlam=1,2
!!$                   ggrad=ggrad +p_qvylm(:,:,ilam,jlam,ilm)*fpmpm(ilam,jlam)
!!$                Enddo
!!$             Enddo
!!$             
!!$             
!!$             err=gd-grad
!!$             rel=err
!!$             Do n=1,3
!!$                If(err(n)/=0.0_t_real)Then
!!$                   rel(n)=err(n)/gd(n)
!!$                Endif
!!$             Enddo
!!$             If(testgrad)Then
!!$                If(Any(Abs(rel(:))>1.5e-7_t_real)) Then
!!$                   Print "('l=',i3)",l
!!$                   Print "(t10,'m=',i3)",m
!!$                   
!!$                   Print "(10(f20.12,1x))",rho,gd(1),gd(2),gd(3)
!!$                   Print "(1(f20.12,1x),3(e20.3e2,1x))",rho-d,rel(1),rel(2)&
!!$                        &,rel(3)
!!$                   Print *
!!$                   
!!$                Endif
!!$             Endif
!!$
!!$
!!$
!!$             gerr=ggd-ggrad
!!$             grel=gerr
!!$             Do n=1,3
!!$                Do nn=1,3
!!$                   If(gerr(n,nn)/=0.0_t_real)Then
!!$                      grel(n,nn)=gerr(n,nn)/ggd(n,nn)
!!$                   Endif
!!$                Enddo
!!$             Enddo
!!$             If(.Not.testgrad)Then
!!$                If(Any(Abs(grel(:,:))>2.0e-5_t_real)) Then
!!$                   Print "('l=',i3)",l
!!$                   Print "(t10,'m=',i3)",m
!!$                   
!!$                   Print "(9(f20.12,1x))"&
!!$                        &,ggd(1,1),ggd(2,1),ggd(3,1)&
!!$                        &,ggd(1,2),ggd(2,2),ggd(3,2)&
!!$                        &,ggd(1,3),ggd(2,3),ggd(3,3)
!!$                   Print "(9(f20.12,1x))"&
!!$                        &,ggrad(1,1),ggrad(2,1),ggrad(3,1)&
!!$                        &,ggrad(1,2),ggrad(2,2),ggrad(3,2)&
!!$                        &,ggrad(1,3),ggrad(2,3),ggrad(3,3)
!!$                   Print "(9(e20.3e2,1x))"&
!!$                        &,grel(1,1),grel(2,1),grel(3,1)&
!!$                        &,grel(1,2),grel(2,2),grel(3,2)&
!!$                        &,grel(1,3),grel(2,3),grel(3,3)
!!$                   Print *
!!$                   
!!$                Endif
!!$             Endif
!!$
!!$
!!$
!!$             
!!$             !Enddo
!!$             !      Enddo
!!$             !   Enddo
!!$             !!
!!$          Enddo! m
!!$       Enddo! l
!!$       !!
!!$    Enddo
!!$    !!
!!$    Call pfree(p_ylm)
!!$    Call pfree(p_clpm)
!!$    Call pfree(p_ccc)
!!$    Call pfree(p_rvylm)
!!$    Call pfree(p_qvylm)
!!$    !!
!!$    Stop
!!$    !!
!!$    Return
!!$    !!
!!$  End Subroutine drhotest
  !!***********************************************************************
  Real(t_real) Function d2L2(i,delta)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: i
    Real(t_real),Intent(in)      :: delta
    !!LOCAL
    !Character(*),Parameter::nsubfunc="d2L2"
    Real(t_real)   :: dd
    !!
    dd=1.0_t_real/(delta*delta)
    !!
    If(i==0)Then
       d2L2= dd
    Else If(i==1) Then
       d2L2= -dd*2.0_t_real
    Else If(i==2) Then
       d2L2= dd
    Else
       d2L2=0.0_t_real
    Endif
    !!
    Return
    !!
  End Function d2L2
  !!***********************************************************************
  Real(t_real) Function dL2(i,x,x1,delta)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: i
    Real(t_real),Intent(in)      :: x,x1,delta
    !!LOCAL
    !Character(*),Parameter::nsubfunc="dL2"
    Real(t_real)   :: dd
    !!
    dd=0.5_t_real/(delta*delta)
    !!
    If(i==0)Then
       dL2= (2.0_t_real*(x-x1)-delta)*dd
    Else If(i==1) Then
       dL2= -(x-x1)*dd*4.0_t_real
    Else If(i==2) Then
       dL2= (2.0_t_real*(x-x1)+delta)*dd
    Else
       dL2=0.0_t_real
    Endif
    !!
    Return
    !!
  End Function dL2
  !!***********************************************************************
  Real(t_real) Function L2(i,x,x1,delta)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: i
    Real(t_real),Intent(in)      :: x,x1,delta
    !!LOCAL
    !Character(*),Parameter::nsubfunc="L2"
    Real(t_real)   :: dd
    !!
    dd=0.5_t_real/(delta*delta)
    !!
    If(i==0)Then
       L2=  (x-x1)*(x-x1-delta)*dd
    Else If(i==1) Then
       L2= -(x-x1+delta)*(x-x1-delta)*dd*2.0_t_real
    Else If(i==2) Then
       L2= (x-x1+delta)*(x-x1)*dd
    Else
       L2=0.0_t_real
    Endif
    !!
    Return
    !!
  End Function L2
  !!***********************************************************************
  Real(t_real) Function frho(r,df,d2f)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: r
    Real(t_real),Intent(out)     :: df,d2f
    !!LOCAL
    !Character(*),Parameter::nsubfunc="frho"
    !!
    !!
    frho=(3.0_t_real*r**2-4.0_t_real*r+1.0_t_real)*Exp(-r)
    df  =(6.0_t_real*r-4.0_t_real)*Exp(-r)&
         &-(3.0_t_real*r**2-4.0_t_real*r+1.0_t_real)*Exp(-r)

    d2f  =&
         &(6.0_t_real)*Exp(-r)&
         &-(12.0_t_real*r-8.0_t_real)*Exp(-r)&
         &+(3.0_t_real*r**2-4.0_t_real*r+1.0_t_real)*Exp(-r)
    !!
    Return
    !!
  End Function frho
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine oderel2x2()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="oderel2x2"
    Integer(t_int) :: ir,N,i,j,kap,ndim,ii,jj
    Real(t_real)   :: resd,resor,c,resov,Z,r
    Real(t_real),Pointer :: H(:,:)
    Real(t_real),Pointer :: S(:,:)
    Real(t_real),Pointer :: SD(:,:)
    Real(t_real),Pointer :: HD(:,:)
    Real(t_real),Pointer :: CC(:,:)
    Real(t_real),Pointer :: e(:)
    Type(T_Mesh)         :: imesh
    Character(100)   :: str
    !!
    Call ode()
    !!
    N=200
    kap=-2
    Z=50.0_t_real
    c=speed_of_light
    !!
    Call init_mesh(imesh)
    imesh% Type=LIN_MESH
    imesh% Type=LOGZERO_MESH
    imesh% rmax=20.0_t_real
    imesh% rmin=1.0e-5_t_real
    imesh% nr=N
    imesh% with_zero=.True.
    Call setup_mesh(imesh)
    !!
    ndim=2*(N-1)-1
    Call palloc('H',H,1_t_int,2*N,1_t_int,2*N,nmodule,nsubfunc)
    Call palloc('S',S,1_t_int,2*N,1_t_int,2*N,nmodule,nsubfunc)
    Call palloc('SD',SD,1_t_int,ndim,1_t_int,ndim,nmodule,nsubfunc)
    Call palloc('HD',HD,1_t_int,ndim,1_t_int,ndim,nmodule,nsubfunc)
    Call palloc('CC',CC,1_t_int,2*N,1_t_int,2*N,nmodule,nsubfunc)
    Call palloc('e',e,1_t_int,2*N,nmodule,nsubfunc)
    
    Do ir=1,imesh% nr
       Print *,ir,imesh% p_rmesh(ir)
    Enddo
    !!
    H=0.0_t_real
    S=0.0_t_real
    !!
    Do i=1,N
       Do j=1,N
          Call kinint(imesh,i,j,resd,resor,resov,0.0_t_real)
          H(2*i-1,2*j-1)  =-Z*resor
          H(2*i-1,2*j  )  =-(resd-resor*kap)*c
          H(2*i  ,2*j-1)  = (resd+resor*kap)*c
          H(2*i  ,2*j  )  =-Z*resor -resov*2.0_t_real*c**2
          
          S(2*i-1,2*j-1)  = resov
          S(2*i  ,2*j  )  = resov
       Enddo
    Enddo
    !!
    ii=0
    Do i=1,2*N
       If(i<3 .Or. i==2*N-1) Cycle
       ii=ii+1
       jj=0
       Do j=1,2*N
          If(j<3 .Or. j==2*N-1) Cycle
          jj=jj+1
          SD(ii,jj)=S(i,j)
          HD(ii,jj)=H(i,j)
       Enddo
    Enddo
    !SD(1:ndim,1:ndim)=S(2*2-1:2*N,2*2-1:2*N)
    !HD(1:ndim,1:ndim)=H(2*2-1:2*N,2*2-1:2*N)
    !    Call printmat("S","(e12.5e2,1x)","('      0      ')"&
    !         &,SD,ndim,ndim,1.0e-8_t_real)
    !!
    Call rdiagno(ndim,HD,SD,e)
    !Call rdiagno_noO(2*N,S,CC,e)
    
    CC=0.0_t_real
    ii=0
    Do i=1,2*N
       If(i<3 .Or. i==2*N-1) Cycle
       ii=ii+1
       CC(i,1:ndim)=HD(ii,1:ndim)
    Enddo
    Do i=1,ndim
       Print *,i,e(i)
       Write(str,"('+wf',i3.3)")i
       Open(12,file=Trim(str))
       Do ir=2,N
          r=imesh% p_rmesh(ir)
          Write(12,"(3(e30.15e3,2x))")r,CC(2*ir-1,i),CC(2*ir,i)
       Enddo
       Close(12)
    Enddo
    !!
    !!
    Call cleanup_mesh(imesh)
    !!
    Call pfree(e)
    Call pfree(CC)
    Call pfree(S)
    Call pfree(SD)
    Call pfree(HD)
    Call pfree(H)
    !!
    Stop
    Return
    !!
  End Subroutine oderel2x2
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine ode()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="ode"
    Integer(t_int) :: gammode
    Integer(t_int),Parameter :: gamlp1=1
    Integer(t_int),Parameter :: gaml  =2
    Integer(t_int),Parameter :: nogam =3
    Integer(t_int) :: ir,N,i,j,l,ndim,ii,jj
    Real(t_real)   :: resd,resor,c,resov,Z,sL,r,gamma,t
    Real(t_real),Pointer :: H(:,:)
    Real(t_real),Pointer :: S(:,:)
    Real(t_real),Pointer :: SD(:,:)
    Real(t_real),Pointer :: HD(:,:)
    Real(t_real),Pointer :: CC(:,:)
    Real(t_real),Pointer :: e(:)
    Type(T_Mesh)         :: imesh
    Character(100)   :: str
    !!
    N=200
    l=1
    sL=Sqrt(Real(l*(l+1),t_real))
    Z=50.0_t_real
    c=speed_of_light
    gammode=nogam
    If(gammode==gamlp1) Then
       gamma=Sqrt((l+1)**2-(Z/c)**2)
    Else If(gammode==gaml) Then
       gamma=Sqrt((l)**2-(Z/c)**2)
    Else
       gamma=0.0_t_real
    Endif
    !!
    Call init_mesh(imesh)
    imesh% Type=LIN_MESH
    imesh% Type=LOGZERO_MESH
    imesh% rmax=20.0_t_real
    imesh% rmin=1.0e-5_t_real
    imesh% nr=N
    imesh% with_zero=.True.
    Call setup_mesh(imesh)
    !!
    If(gammode == gamlp1)Then
       ndim=4*N-2
    Else If(gammode == gaml)Then
       ndim=4*N-2
    Else
       ndim=4*(N-1)-2
    Endif
    Call palloc('H',H,1_t_int,4*N,1_t_int,4*N,nmodule,nsubfunc)
    Call palloc('S',S,1_t_int,4*N,1_t_int,4*N,nmodule,nsubfunc)
    Call palloc('SD',SD,1_t_int,ndim,1_t_int,ndim,nmodule,nsubfunc)
    Call palloc('HD',HD,1_t_int,ndim,1_t_int,ndim,nmodule,nsubfunc)
    Call palloc('CC',CC,1_t_int,4*N,1_t_int,4*N,nmodule,nsubfunc)
    Call palloc('e',e,1_t_int,4*N,nmodule,nsubfunc)
    
    Do ir=1,imesh% nr
       Print *,ir,imesh% p_rmesh(ir)
    Enddo
    !!
    H=0.0_t_real
    S=0.0_t_real
    !!
    Do i=1,N
       Do j=1,N
          Call kinint(imesh,i,j,resd,resor,resov,gamma)
          H(4*i-3,4*j-3)  =-Z*resor
          H(4*i-3,4*j-2)  =-(resd+resor*(1+gamma))*c
          H(4*i-3,4*j-1)  = 0.0_t_real
          H(4*i-3,4*j  )  = sL*c*resor

          H(4*i-2,4*j-3)  = (resd-resor*(1-gamma))*c
          H(4*i-2,4*j-2)  =-Z*resor -resov*2.0_t_real*c**2
          H(4*i-2,4*j-1)  = sL*c*resor
          H(4*i-2,4*j  )  = 0.0_t_real

          H(4*i-1,4*j-3)  = 0.0_t_real
          H(4*i-1,4*j-2)  = sL*c*resor
          H(4*i-1,4*j-1)  = -Z*resor
          H(4*i-1,4*j  )  = -(resd+resor*(gamma))*c

          H(4*i  ,4*j-3)  = sL*c*resor
          H(4*i  ,4*j-2)  = 0.0_t_real
          H(4*i  ,4*j-1)  =  (resd+resor*(gamma))*c
          H(4*i  ,4*j  )  = -Z*resor -resov*2.0_t_real*c**2


          
          S(4*i-3,4*j-3)  = resov
          S(4*i-2,4*j-2)  = resov
          S(4*i-1,4*j-1)  = resov
          S(4*i  ,4*j  )  = resov
       Enddo
    Enddo
    !!
    ii=0
    Do i=1,4*N
       If(gammode == gamlp1 .And. ( i==4*N-3 .Or. i==4*N-1)) Cycle
       If(gammode == gaml   .And. ( i==4*N-3 .Or. i==4*N-1)) Cycle
       If(gammode == nogam  .And. (i<5 .Or. i==4*N-3 .Or. i==4*N-1)) Cycle
       ii=ii+1
       jj=0
       Do j=1,4*N
          If(gammode == gamlp1.And. ( j==4*N-3 .Or. j==4*N-1)) Cycle
          If(gammode == gaml  .And. ( j==4*N-3 .Or. j==4*N-1)) Cycle
          If(gammode == nogam .And. (j<5 .Or. j==4*N-3 .Or. j==4*N-1)) Cycle
          jj=jj+1
          SD(ii,jj)=S(i,j)
          HD(ii,jj)=H(i,j)
       Enddo
    Enddo
    !!
    Print *,'diagonalize'
    Call rdiagno(ndim,HD,SD,e)
    Print *,'...done'
    CC=0.0_t_real
    ii=0
    Do i=1,4*N
       If(gammode == gamlp1 .And. ( i==4*N-3 .Or. i==4*N-1)) Cycle
       If(gammode == gaml   .And. ( i==4*N-3 .Or. i==4*N-1)) Cycle
       If(gammode == nogam  .And. (i<5 .Or. i==4*N-3 .Or. i==4*N-1)) Cycle
       ii=ii+1
       CC(i,1:ndim)=HD(ii,1:ndim)
    Enddo
    Do i=1,ndim
       Print *,i,e(i)
       Write(str,"('+wf',i3.3)")i
       Open(12,file=Trim(str))
       Do ir=2,N
          r=imesh% p_rmesh(ir)
          t=r**(gamma)
          Write(12,"(5(e30.15e3,2x))")r&
               &,CC(4*ir-3,i)*t&
               &,CC(4*ir-2,i)*t&
               &,CC(4*ir-1,i)*t&
               &,CC(4*ir  ,i)*t
       Enddo
       Close(12)
    Enddo
    !!
    !!
    Call cleanup_mesh(imesh)
    !!
    Call pfree(e)
    Call pfree(CC)
    Call pfree(S)
    Call pfree(SD)
    Call pfree(HD)
    Call pfree(H)
    !!
    Stop
    Return
    !!
  End Subroutine ode
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine kinint(imesh,i,j,res,resor,resov,gamma)
    !!
    !!
    Implicit None
    !!IO
    Type(T_Mesh),Intent(in)      :: imesh
    Integer(t_int),Intent(in)    :: i,j
    Real(t_real),Intent(in)      :: gamma
    Real(t_real),Intent(out)     :: res,resor,resov
    !!LOCAL
    !Character(*),Parameter::nsubfunc="kinint"
    Integer(t_int) :: nr,ir
    Real(t_real)   :: r0,r1,dr,r,we,lli,llj,d,dor,dov,t
    !! DONT FREE THESE AFTERWARDS !!
    Real(t_real),Pointer   :: p_ar(:),p_wtr(:)
    !!
    res=0.0_t_real
    resor=0.0_t_real
    resov=0.0_t_real
    nr=10
    Call  get_gauss(nr,p_ar,p_wtr)
    !!
    If(i==j-1) Then
       r0=imesh% p_rmesh(j-1)
       r1=imesh% p_rmesh(j)
       dr=r1-r0
       d=0.0_t_real
       dor=0.0_t_real
       dov=0.0_t_real
       Do ir=1,nr
          r=((p_ar(ir)+1.0_t_real)*0.5_t_real*dr+r0)
          we=p_wtr(ir)*0.5_t_real*dr!*mesh_r_to_jac(imesh,r)
          t=r**(2*gamma)
          lli=(r1-r)/dr
          llj=(r-r0)/dr
          
          d=d+lli/dr*we*t
          dor=dor+lli*llj/r*we*t
          dov=dov+lli*llj*we*t
       Enddo
       res=d
       resor=dor
       resov=dov
    Endif
    If(i==j) Then
       d=0.0_t_real
       dor=0.0_t_real
       dov=0.0_t_real
       If(j>1) Then
          r0=imesh% p_rmesh(j-1)
          r1=imesh% p_rmesh(j)
          dr=r1-r0
          Do ir=1,nr
             r=((p_ar(ir)+1.0_t_real)*0.5_t_real*dr+r0)
             we=p_wtr(ir)*0.5_t_real*dr!*mesh_r_to_jac(imesh,r)
             t=r**(2*gamma)

             lli=(r-r0)/dr
             
             d=d+lli/dr*we*t
             dor=dor+lli*lli/r*we*t
             dov=dov+lli*lli*we*t
          Enddo
       Endif
       If(j<imesh% nr) Then
          r0=imesh% p_rmesh(j)
          r1=imesh% p_rmesh(j+1)
          dr=r1-r0
          Do ir=1,nr
             r=((p_ar(ir)+1.0_t_real)*0.5_t_real*dr+r0)
             we=p_wtr(ir)*0.5_t_real*dr!*mesh_r_to_jac(imesh,r)
             t=r**(2*gamma)

             lli=(r1-r)/dr
             
             d=d-lli/dr*we*t
             dor=dor+lli*lli/r*we*t
             dov=dov+lli*lli*we*t
          Enddo
       Endif
       res=d
       resor=dor
       resov=dov
       If(i==1.Or. i==imesh% nr) res=0.0_t_real
    Endif
    If(i==j+1) Then
       r0=imesh% p_rmesh(j)
       r1=imesh% p_rmesh(j+1)
       dr=r1-r0
       d=0.0_t_real
       dor=0.0_t_real
       Do ir=1,nr
          r=((p_ar(ir)+1.0_t_real)*0.5_t_real*dr+r0)
          we=p_wtr(ir)*0.5_t_real*dr!*mesh_r_to_jac(imesh,r)
          t=r**(2*gamma)

          lli=(r-r0)/dr
          llj=(r1-r)/dr
          
          d=d-lli/dr*we*t
          dor=dor+lli*llj/r*we*t
          dov=dov+lli*llj*we*t
       Enddo
       res=d
       resor=dor
       resov=dov
    Endif
    !!
    Return
    !!
  End Subroutine kinint
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine newmesh()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="newmesh"
    Integer(t_int) :: ir,nr
    Real(t_real)   :: x0,e,alpha,beta,rmax,r0,rmin,xa,xb,xc,fa,fb,fc,kT
    Real(t_real)   :: xx,lf,aa,bb,x2,M11,M12,M21,M22,det,p,q,hx
    Real(t_real)   :: mu,rr,rm
    Real(t_real),Pointer :: x(:),r(:),j(:),r1(:)
    Type(T_Mesh)         :: imesh,nmesh
    !! DONT FREE THESE AFTERWARDS !!
    !Real(t_real),Pointer   :: p_ar(:),p_wtr(:)
    !!
    nr=200
    !!
    rmin=1.0e-6_t_real
    rmax=8.0_t_real
    !!
    Call init_mesh(imesh)
    imesh% Type=ROOT_MESH
    imesh% rmax=rmax
    imesh% rmin=rmin
    imesh% nr=nr
    imesh% with_zero=.True.
    Call setup_mesh(imesh)

    Call init_mesh(nmesh)
    nmesh% Type=ROOT_MESH
    nmesh% rmax=rmax
    nmesh% rmin=rmin
    nmesh% nr=nr
    nmesh% alpha=imesh% alpha
    nmesh% with_zero=.True.
    Call setup_mesh(nmesh)
    !!
    Call palloc('x',x ,1_t_int,nr,nmodule,nsubfunc)
    Call palloc('r',r ,1_t_int,nr,nmodule,nsubfunc)
    Call palloc('r1',r1 ,1_t_int,nr,nmodule,nsubfunc)
    Call palloc('j',j ,1_t_int,nr,nmodule,nsubfunc)
    !!
    beta=10.0_t_real
    alpha=imesh% alpha
    !alpha=2.2_t_real
    !!
    r0=1.0e-4_t_real
    !!
    kT=1.0_t_real/1.0e2_t_real
    !!
    e=prof(1.0_t_real,1.0_t_real,kT)
    !!
    Print *,'e=',e
    xa=0.0_t_real
    fa=rmax*(e*xa**(beta*alpha)+(1.0_t_real-e)*xa**(alpha))-r0
    If(fa==0.0_t_real) Then
       x0=xa
       Goto 100
    Endif
    xb=1.0_t_real
    fb=rmax*(e*xb**(beta*alpha)+(1.0_t_real-e)*xb**(alpha))-r0
    If(fb==0.0_t_real) Then
       x0=xb
       Goto 100
    Endif
    !!
    If(fa*fb>0.0_t_real) Stop 'no breaketing'
    !!
    Do
       Print *,'a=',xa,fa
       Print *,'c=',xc,fc
       Print *,'b=',xb,fb
       Print *
       xc=(xa+xb)*0.5_t_real
       fc=rmax*(e*xc**(beta*alpha)+(1.0_t_real-e)*xc**(alpha))-r0
       !!
       If(fc==0.0_t_real) Then
          x0=xc
          Goto 100
       Endif
       If(xa==xc) Then
          x0=xc
          Goto 100
       Endif
       If(xb==xc) Then
          x0=xc
          Goto 100
       Endif
       If(fc*fa>0.0_t_real)Then
          xa=xc
          fa=fc
       Else If(fc*fb>0.0_t_real)Then
          xb=xc
          fb=fc
       Endif
    Enddo
    !!
100 Continue
    
    xc=x0
    e=prof(xc,x0,kT)
    fc=rmax*(e*xc**(beta*alpha)+(1.0_t_real-e)*xc**(alpha))
    Print *,'x0=',x0,fc
    !!
    Do ir=1,nr
       x(ir)=Real(ir-1,t_real)/Real(nr-1,t_real)
       e=prof(x(ir),x0,kT)
       r(ir)=rmax*(e*x(ir)**(beta*alpha)+(1.0_t_real-e)*x(ir)**(alpha))
    Enddo
    !!
    Print *,'alpha=',alpha
    Open(12,file='+t')
    Do ir=1,nr
       Write(12,"(10(e30.15e3,2x))") x(ir),r(ir),imesh% p_rmesh(ir)
       If(x(ir)>x0*1) Exit
    Enddo
    Close(12)
    !!
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !!
    r0=1.0e-4_t_real
    x0=0.3_t_real
    lf=0.90_t_real
    mu=lf
    kT=Log((1.0_t_real-lf)/lf)/x0/(mu-1)
    kT=1.0_t_real/kT
!!$    x2=1.0_t_real/Real(nr-1,t_real)
!!$    p=prof(x2,x0,kT)
!!$    M11=p 
!!$    M12=(1.0_t_real-p)*x2**alpha
!!$    p=prof(1.0_t_real,x0,kT)
!!$    M21=p/x2
!!$    M22=(1.0_t_real-p)
!!$    
!!$    det=M11*M22-M12*M21
!!$    
!!$    aa=( M22*rmin-M12*rmax)/det/x2
!!$    bb=(-M21*rmin+M11*rmax)/det

    hx=1.0_t_real/Real(nr-1,t_real)
    x(1)=0.0_t_real
    r(1)=0.0_t_real

    beta=1.0_t_real

    rm=0.2
    

    aa=1.0_t_real
    bb=1.0_t_real

    rr=rmin/rmax
    p=prof(rr,rm,kT)
    q=1.0_t_real-p
    M11=p*rr**(1.0_t_real/beta)
    M12=q*rr**(1.0_t_real/alpha)


    rr=rmax/rmax
    p=prof(rr,rm,kT)
    q=1.0_t_real-p
    M21=p*rr**(1.0_t_real/beta)
    M22=q*rr**(1.0_t_real/alpha)
    det=M11*M22-M12*M21

    x2=1.0_t_real/Real(nr-1,t_real)

    aa=( M22*x2-M12)/det
    bb=(-M21*x2+M11)/det

    Print *,'aa=',aa
    Print *,'bb=',bb

    !!
    r(1)=0.0_t_real
    x(1)=0.0_t_real
    Do ir=1, nr
       r(ir)=Real(ir-1_t_int,t_real)/Real(nr-1,t_real)*(rmax-rmin)+rmin
       rr=r(ir)/rmax
       p=prof(rr,rm,kT)
       q=1.0_t_real-p
       !x(ir)=fx8(rr,nr,rmin,rmax,-20000.0_t_real)
       x(ir)=1*p*rr**(1.0_t_real/beta)+bb*q*rr**(1.0_t_real/alpha)*1
    Enddo
    !!
    Open(12,file='+p')
    Do ir=1,nr
       bb=Real(ir-1_t_int,t_real)/Real(nr-1,t_real)*(-10000-(-100000))+(-100000)
       xx=fx8(r0,nr,rmin,rmax,bb)
       Write(12,"(10(e30.15e3,2x))") bb,xx
       !If(r(ir)>r0*2) Exit
    Enddo
    Close(12)
    !!
    !!Call tlag4int(nmesh% nr,r1*nmesh% p_jmesh,nmesh% hx,val)    
    !!
    !!Print *,'val=',val,-(Exp(-0.1*rmax)-1.0_t_real)/0.1&
    !!    &,val+(Exp(-0.1*rmax)-1.0_t_real)/0.1
    !!
    Print *,'alpha=',alpha
    Open(12,file='+t')
    Do ir=1,nr
       xx=x(ir)
       rr=r(ir)
       Write(12,"(10(e30.15e3,2x))") rr,xx
       !If(r(ir)>r0*2) Exit
    Enddo
    Write(12,*)
    Do ir=1,nr
       xx=imesh% p_xmesh(ir)/imesh% p_xmesh(nr)
       rr=imesh% p_rmesh(ir)
       Write(12,"(10(e30.15e3,2x))") rr,xx
    Enddo
    Close(12)
    !!
    Stop
    Return
    !!
  End Subroutine newmesh
#endif
  !!***********************************************************************
  Real(t_real) Function prof(x,x0,kT)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x,x0,kT
    !!LOCAL
    !Character(*),Parameter::nsubfunc="prof"
    !!
    !!
    !Print *,'x=',x
    !Print *,'x0=',x0
    prof=1.0_t_real/(Exp((x-x0)/kT)+1.0_t_real)
    !!
    Return
    !!
  End Function prof
  !!***********************************************************************
  !!***********************************************************************
  Real(t_real) Function fx8(r,nr,rmin,rmax,para)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nr
    Real(t_real),Intent(in)      :: r,rmin,rmax,para
    !!LOCAL
    !Character(*),Parameter::nsubfunc="fx8"
    Real(t_real)   :: a,b,c,d,bb,cc,dd,rho
    !!
    rho=rmin/rmax
    !!
    b=2
    c=3
    d=4
    bb=5
    cc=6
    dd=7
    !!
    bb=para

    dd = (((5*rho**4-40*rho**3-100*rho**2)*bb**2+(20*rho**4-155* &
         rho**3-440*rho**2-100*rho)*bb+128*rho**4-660*rho** &
         3-440*rho)*nr+(-5*rho**4+40*rho**3+220*rho**2+15*rho)* &
         bb**2+(-20*rho**4+155*rho**3+920*rho**2+280*rho+15)* &
         bb-128*rho**4+660*rho**3+792*rho**2+440*rho+180)/ &
         (((2*rho**4+20*rho**3+5*rho**2)*bb+28*rho**4+210*rho** &
         3+5*rho)*nr+(-2*rho**4-35*rho**3-17*rho**2)*bb-28*rho** &
         4-390*rho**3-63*rho**2-5*rho)
    

    d = ((2*bb+28)*dd-5*bb**2-20*bb-128)/(15*bb+180)
    cc = ((2*bb+7)*dd+(-9*bb-27)*d+5*bb**2+15*bb+16)/(bb+8)
    c = ((4*bb+7)*dd+(-6*bb-9)*d+(bb+4)*cc-2*bb**2-4*bb-2)/(3*bb+6)
    b = (7*dd-9*d+4*cc-6*c+bb-2)/3.0
    a = dd-d+cc-c+bb-b+1
    !!
    fx8 = r*(d*r**3+c*r**2+b*r+a)/(dd*r**3+cc*r**2+bb*r+1)
    Return
    !!
  End Function fx8
  !!***********************************************************************
  !!***********************************************************************
!!$  Subroutine testintar()
!!$    !!
!!$    Use tapint
!!$    Use apint
!!$    !!
!!$    Implicit None
!!$    !!IO
!!$    !!LOCAL
!!$    Character(*),Parameter::nsubfunc="testintar"
!!$    Type(T_Apint) :: api,apj
!!$    Logical(t_log) :: prot
!!$    Integer(t_int) :: i,k,r,x,l,kk,b,bx,ii,jj,n
!!$    Real(t_real)   :: d,ds
!!$    Integer(1) :: xx
!!$    
!!$    !!
!!$    Call init_apint(api)
!!$    Call init_apint(apj)
!!$    !!
!!$    n=2**6
!!$    !!
!!$    Do ii=-n,n
!!$       Print *,'ii=',ii
!!$       Do jj=-n,n
!!$          If(Mod(jj,100000)==0)Print *,'jj=',ii,jj
!!$          api=ii
!!$          apj=jj
!!$          !!
!!$          prot=.False.
!!$          !prot=.True.
!!$          If(jj==65535)Then
!!$             !prot=.True.
!!$             !Print *,'api=',.Real.api
!!$             !Call print_api(api)
!!$             !Print *,'apj=',.Real.apj
!!$             !Call print_api(apj)
!!$          Endif
!!$          !!
!!$          !d=.Real.api
!!$          !Print *,'api=',d
!!$          !Call print_api(api)
!!$          !d=.Real.apj
!!$          !Print *,'apj=',d
!!$          !Call print_api(apj)
!!$          !!
!!$          ds=.Real.apj+.Real.api
!!$          ds=ii+jj
!!$          Call apint_add_apint(apj,api,prot)
!!$          d=.Real.apj
!!$          If(Abs(d-ds)>0.0_t_real) Then
!!$             Print *,ii,jj
!!$             Print *,'sum  =',ds
!!$             Print *,'apsum=',d
!!$             Print *, 'error'
!!$             Stop 'error'
!!$          Endif
!!$       Enddo
!!$    Enddo
!!$    !!
!!$    !!
!!$    Print *,'-----------------------------------'
!!$    !!
!!$    !xx=2_t_int**7-1
!!$    !api=2_t_int**8-1
!!$    api=12_t_int!2_t_int**16-1
!!$    apj=-1_t_int
!!$
!!$
!!$    d=.Real.api
!!$    Print *,'api=',d
!!$    Call print_api(api)
!!$    Print *
!!$    !d=.Real.api
!!$    !Print *,'dapi=',d
!!$    !!
!!$    d=.Real.apj
!!$    Print *,'apj=',d
!!$    Call print_api(apj)
!!$    Print *
!!$    !!
!!$    Call apint_add_apint(apj,api,.True.)
!!$    d=.Real.apj
!!$    Print *,'sum apj=',d
!!$    Call print_api(apj)
!!$    Print *
!!$    !Print *,'x=',xx
!!$    !!
!!$goto 100
!!$    Print *,'-----------------------------------'
!!$    Do ii=-2_t_int**18,2_t_int**18
!!$    !Do ii=0,-2_t_int**18,-1
!!$    !Do ii=-65535,65535
!!$       If(Mod(ii,100000)==0) Print *,ii
!!$       apj=ii!-2_t_int**6!ii
!!$       !Call print_api(apj)
!!$       ds=.Real.apj
!!$       !Print *,'apj ds=',ds,ii
!!$       !Call print_api(apj)
!!$       !Print *
!!$       Call apint_two_comp(apj,.False.)
!!$       !Call apint_two_comp(apj,.True.)
!!$       !Print *
!!$       !Call print_api(apj)
!!$       d=.Real.apj
!!$       !Print *,'dapj d=',d,ii
!!$       !Call print_api(apj)
!!$       If((ii/=0 .And. Abs(ii+d)>1.0e-16_t_real).Or.(ii==0 .And. d/=0)) Then
!!$          Print *,'error'
!!$          Print *,'apj=',ds,ii
!!$          Print *,'dapj=',d,ii
!!$          Stop 'error'
!!$       Endif
!!$    Enddo
!!$    !!
!!$    !!
!!$100 Continue
!!$    !!
!!$    Print *,'-----------------------------------'
!!$    Print *,'-----------------------------------'
!!$    Print *,'-----------------------------------'
!!$    !!
!!$    n=2_t_int**12
!!$    !!
!!$    Do ii=-n,n
!!$       Print *,'ii=',ii
!!$       Do jj=-n,n
!!$          If(Mod(jj,100000)==0)Print *,'jj=',ii,jj
!!$          
!!$          api=ii
!!$          apj=jj
!!$          !!
!!$          prot=.False.
!!$          !prot=.True.
!!$          !!
!!$          d=.Real.api
!!$          !Print *,'-----------------------------------'
!!$          !Print *,'api=',d
!!$          !Call print_api('ai=',api)
!!$          d=.Real.apj
!!$          !Print *,'apj=',d
!!$          !Call print_api('aj=',apj)
!!$          !!
!!$          ds=.Real.apj*.Real.api
!!$          ds=ii*jj
!!$          Call apint_mult_apint(api,apj,prot)
!!$          d=.Real.api
!!$          !Call print_api('ai=',api)
!!$          If(Abs(d-ds)>0.0_t_real) Then
!!$             Print *,ii,jj
!!$             Print *,'prod  =',ds
!!$             Print *,'approd=',d
!!$             Print *, 'error'
!!$             Stop 'error'
!!$          Endif
!!$       End Do
!!$    End Do
!!$    
!!$    Print *,'--------------THE END---------------------'
!!$    
!!$    !!
!!$    !!
!!$    Call cleanup_apint(api)
!!$    Call cleanup_apint(apj)
!!$    !!
!!$    Stop
!!$    !!
!!$    Return
!!$    !!
!!$  End Subroutine testintar
  !!***********************************************************************
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine pvxc()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="pvxc"
    Integer(t_int) :: mspin,i
    Real(t_real)   :: rho(2),kf,dum2(2),dum,vex(2),epsxc,rs,rhot,f,ef
    Integer(t_int),Parameter :: N=16
    Real(t_real)   :: rss(N)
    Data rss /0.01_t_real, 0.02_t_real, 0.05_t_real&
         &, 0.1_t_real, 0.2_t_real, 0.3_t_real, 0.4_t_real, 0.5_t_real&
         &, 0.7_t_real&
         &, 1.0_t_real, 1.5_t_real, 2.0_t_real, 3.0_t_real, 4.0_t_real&
         &, 5.0_t_real,6.0_t_real/
    !!
    mspin=2
    !!
    Do i=1,N
       rs=rss(i)
       rho(1)=1.0_t_real/(fourpi*c1o3*rs**3)*0.5_t_real
       rho(2)=rho(1)
       rhot=Sum(rho(1:2))
       kf=(3.0_t_real*pi**2*rhot)**c1o3
       Call vxcrho(mspin,rho,dum2,dum,dum2,dum2,dum,vex,epsxc,1.0_t_real)
       
       ef=0.5_t_real*kf**2
       
       f=vex(1)/ef

       Print "(2(f30.15,2x))",rs,f
       !Print "(2(e30.15e3,2x))",rs,epsxc

    Enddo
    !!
    Stop
    !!
    Return
    !!
  End Subroutine pvxc
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lebedev(symmetry)
    !!
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    !!LOCAL
    Character(*),Parameter::nsubfunc="lebedev"
    Integer(t_int) :: l,jops,m,n,deg,kinv,lmx,i,j,k
    Real(t_real)   :: eu(3),d
    Real(t_real),Pointer :: p_fac(:),p_Dl(:,:),p_wu(:,:)
    !!
    Nullify(p_Dl)
    Nullify(p_fac)
    Nullify(p_wu)
    !!
    lmx=30
    !!
    Call palloc('p_fac',p_fac ,0_t_int,2*lmx+1 ,nmodule,nsubfunc) 
    Call make_factorials(p_fac,2*lmx+1)
    !!
    Do l=0,lmx,2
       deg=2*l+1
       !!
       Call palloc('p_Dl',p_Dl,1_t_int,deg,1_t_int,deg,nmodule,nsubfunc)
       Call palloc('p_wu',p_wu,1_t_int,deg,1_t_int,deg,nmodule,nsubfunc)
       !!
       p_Dl(1:deg,1:deg)=0.0_t_real
       !!
       Do jops=1,symmetry% Rnumops
          !!
          kinv=symmetry% opeulerinv(symmetry% Ropind(jops))
          eu=symmetry% opeuler(:,symmetry% Ropind(jops))
          !!
          Call ytr(eu,kinv,p_fac,l,p_wu,.False.)
          !!
          p_Dl(1:deg,1:deg)=p_Dl(1:deg,1:deg)+p_wu(1:deg,1:deg)
          !!
         ! Call printmat("W"//Trim(intToChar10(l)),"(f10.5)","('     0    ')"&
         !      &,p_wu,deg,deg,1.0e-10_t_real)
       Enddo
       !!
       p_Dl(1:deg,1:deg)=p_Dl(1:deg,1:deg)/symmetry% Rnumops 
       !!
       Do m=1,deg
          d=Sqrt(Sum(p_Dl(1:deg,m)**2))
          If(d>1.0e-12_t_real)Then
             p_Dl(1:deg,m)=p_Dl(1:deg,m)/d
          Endif
       Enddo
       !!
       !!
       Call printmat("D"//Trim(intToChar10(l)),"(f12.8)","('      0     ')"&
            &,p_Dl,deg,deg,1.0e-10_t_real)
       !!
    End Do
    !!
    Call pfree(p_wu)
    Call pfree(p_Dl)
    Call pfree(p_fac)
    !!
    !!
    !!
    Do n=0,lmx,2
       Write(outfile,"('n=',i3)")n
       
       Do i=0,n
          Do j=0,n
             k=n-i-j
             If( (k>=0) .And. &
                  &( Mod(i,2_t_int)==0 ) .And. &
                  &( Mod(j,2_t_int)==0 ) .And. &
                  &( Mod(k,2_t_int)==0 )  &
                  &)Then
                Write(outfile,"(i3,i3,i3)")i,j,k
             Endif
          Enddo
       Enddo
    Enddo
    !!
    !!
    Return
    !!
  End Subroutine lebedev
#endif
  !!***********************************************************************
!!$  Subroutine eig()
!!$    !!
!!$    !!
!!$    Implicit None
!!$    !!IO
!!$    !!LOCAL
!!$    Character(*),Parameter::nsubfunc="eig"
!!$!    Integer(t_int) :: i,j,n,lwork,iwork(1),ilo,ihi,info
!!$!    Real(t_real)   :: A(3,3),r,rwork(1),wr(3),wi(3),vl(3,3),vr(3,3)
!!$!    Real(t_real)   :: z(3,3)
!!$!    Real(t_real)   :: Scale(3),abnrm,rconde(3),rcondv(3),work(3*3)
!!$    Integer(t_int),Parameter :: n=10
!!$    Integer(t_int) :: iv1(n),ierr,i,j,k
!!$    Real(t_real)   :: r
!!$    Real(t_real)   :: a(n,n),z(n,n),wr(n),wi(n),fv1(n)
!!$    Real(t_real)   :: a2(n,n)
!!$    Complex(t_real):: CZ(n,n),CE(n),cd
!!$    !!
!!$    r=rndmst(1)
!!$    !!
!!$    !!
!!$    Do i=1,n
!!$       Do j=1,n
!!$          A(i,j)=rndmcm()
!!$       Enddo
!!$    Enddo
!!$    !!
!!$    a2(1:n,1:n)=a(1:n,1:n)
!!$    !!
!!$    Call rg(n,n,a2,wr,wi,1,z,iv1,fv1,ierr)
!!$
!!$
!!$    Write(outfile,"('A=')")
!!$    Do i=1,n
!!$       Do j=1,n
!!$          Write(outfile,"(f20.10)",advance='no') a(i,j)
!!$       Enddo
!!$       Write(outfile,*)
!!$    Enddo
!!$
!!$    Write(outfile,"('E=')")
!!$    Do i=1,n
!!$       CE(i)=Cmplx(wr(i),wi(i),t_real)
!!$       If(wi(i)==0.0_t_real)Then
!!$          CZ(1:n,i)=Cmplx(z(1:n,i),0.0_t_real,t_real)
!!$       Else If(wi(i)>0.0_t_real)Then
!!$          CZ(1:n,i)=Cmplx(z(1:n,i),z(1:n,i+1),t_real)
!!$       Else If(wi(i)<0.0_t_real)Then
!!$          CZ(1:n,i)=Cmplx(z(1:n,i-1),-z(1:n,i),t_real)
!!$       Endif
!!$       Write(outfile,"('(',f14.6,',',f14.6,') ')",advance='no') CE(i)
!!$       Write(outfile,*)
!!$    Enddo
!!$
!!$    Write(outfile,"('Z=')")
!!$    Do i=1,n
!!$       Do j=1,n
!!$          Write(outfile,"('(',f14.6,',',f14.6,') ')",advance='no') CZ(i,j)
!!$       Enddo
!!$       Write(outfile,*)
!!$    Enddo
!!$    !!
!!$    Write(outfile,"('AZ-ZE=')")
!!$    Do i=1,n
!!$       Do j=1,n
!!$          cd=Cmplx(0.0_t_real,0.0_t_real,t_real)
!!$          Do k=1,n
!!$             cd=cd+A(i,k)*CZ(k,j)
!!$          Enddo
!!$          cd=cd-CZ(i,j)*CE(j)
!!$          Write(outfile,"('(',f14.6,',',f14.6,') ')",advance='no')cd
!!$       Enddo
!!$       Write(outfile,*)
!!$    Enddo
!!$    !!
!!$    Stop
!!$    !!
!!$  End Subroutine eig
  !!***********************************************************************
  Subroutine slabtest()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="slabtest"
    !!
    Integer(t_int) :: Nz,iz,jz
    Real(t_real)   :: e0,t
    Real(t_real),Pointer :: H(:,:),E(:)
    !!
    Nz=5
    e0=6.0_t_real
    t=3.0_t_real
    !!
    Call palloc('H',H,1_t_int,Nz,1_t_int,Nz,nmodule,nsubfunc)
    Call palloc('E',E,1_t_int,Nz,nmodule,nsubfunc)
    !!
    Do iz=1,Nz
       H(iz,iz)=e0
       If(iz>1)Then
          H(iz,iz-1)=t
       Endif
       If(iz<Nz)Then
          H(iz,iz+1)=t
       Endif
    Enddo
    !!
    Call rdiagno_noO(Nz,H,E)
    !!
    Do iz=1,Nz
       Do jz=1,Nz
          Write(*,"(i5,e30.15e3)")jz,H(jz,iz)
       Enddo
       Write(*,*)
       !Write(*,"(i5,e30.15e3)")iz,E(iz)
    Enddo
    
    !!
    Call pfree(H)
    Call pfree(E)
    !!
    Stop
    !!
    Return
    !!
  End Subroutine slabtest 
  !!***********************************************************************
  Subroutine cyc()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="cyc"
    Integer(t_int) :: ML,LL,ms,lb,la,mla,mlb,s
    Real(t_real)   :: g,d,o,fac
    !!
    !!
    !! chi Y chi
    LL=2
!!$    kapb=-2
!!$    kapa=-2
!!$    !!
!!$    jb=2*Abs(kapb)-1
!!$    ja=2*Abs(kapa)-1
!!$    !!
!!$    lb=(Abs(2*kapb+1)-1)/2
!!$    la=(Abs(2*kapa+1)-1)/2
!!$    Print *,'kapb=',kapb
!!$    Print *,'jb=',jb
!!$    Print *,'lb=',lb
!!$    Do ML=-LL,LL
!!$       Write(outfile,"('ML=',i4)")ML
!!$       Do mb=1,jb+1
!!$          mub=2*(mb-1)-jb
!!$          mlb=((mub-1)/2)
!!$
!!$          Do ma=1,ja+1
!!$             mua=2*(ma-1)-ja
!!$             mla=((mua-1)/2)
!!$
!!$             
!!$             d=0.0_t_real
!!$             Do ms=1,2
!!$                Call chi_km1(kapb,mub,cb)
!!$                Call chi_km1(kapa,mua,ca)
!!$                If(Abs(mla+ms-1)<=la .And. Abs(mlb+ms-1)<=lb)Then
!                   Print "('kapb=',i5,' mub=',i5,' mlb=',i5,' c=',2(f15.7,2x))"&
!                        &,kapb,mub,mlb+ms-1,cb(ms)
!                   Print "('kapa=',i5,' mua=',i5,' mlb=',i5,' c=',2(f15.7,2x))"&
!                        &,kapa,mua,mla+ms-1,ca(ms)
!!$                   g=0.0_t_real
!!$                   If(Mod(LL+lb+la,2)==0.And.&
!!$                        &Abs(lb-la)<=LL .And. &
!!$                        &LL<=lb+la)Then
!!$                      g=gaunt(lb,mlb+ms-1,LL,ML,la,mla+ms-1)
!!$                   Endif
!!$                   d=d+cb(ms)*g*ca(ms)
!!$                Endif
!!$             Enddo
!!$             !!
!!$             Print "('mub=',i5,' mua=',i5,' <>=',f30.15)",mub,mua&
!!$                  &,d*Sqrt(fourpi)
!!$             !!
!!$          End Do !! m
!!$       End Do !! mb
!!$       Write(outfile,*)
!!$    Enddo !! ML
!!$    !!
    !!
    Do lb=0,12
       Do la=0,12
          Do LL=0,12
             Write(outfile,"('L=',i4)")LL
             Do ML=-LL,LL
                Write(outfile,"('ML=',i4)")ML
                Do mlb=-lb,lb
                   Do mla=-la,la
                      o=0.0_t_real
                      If(Mod(LL+lb+la,2_t_int)==0.And.&
                           &Abs(lb-la)<=LL .And. &
                           &LL<=lb+la)Then
                         o=gaunt(lb,mlb,LL,ML,la,mla)
                      Endif
                      If(Abs(o)/=0.0_t_real)Then
                         Print "('mlb=',i5,' mla=',i5,' <Y>=',f30.15)",mlb,mla&
                              &,o*Sqrt(fourpi)
                      Endif
                      
                      g=0.0_t_real
                      If(Mod(LL+lb+la,2_t_int)==0.And.&
                           &Abs(lb-la)<=LL .And. &
                           &LL<=lb+la)Then
                         g=gaunt(lb,mlb,LL,ML,la,mla)
                      Endif
                      d=g*mlb*mla
                      Do ms=1,2
                         g=0.0_t_real
                         s=3-2*ms
                         If(Abs(mlb+s)<=lb.And.Abs(mla+s)<=la)Then
                            If(Mod(LL+lb+la,2_t_int)==0.And.&
                                 &Abs(lb-la)<=LL .And. &
                                 &LL<=lb+la)Then
                               g=gaunt(lb,mlb+s,LL,ML,la,mla+s)
                            Endif
                            d=d+g*Sqrt(1.0_t_real*(lb-mlb*s)*(lb+1+mlb*s))&
                                 &*Sqrt(1.0_t_real*(la-mla*s)*(la+1+mla*s))&
                                 &*0.5_t_real
                         Endif
                      Enddo
                      fac=0.5_t_real*(la*(la+1)+lb*(lb+1)-LL*(LL+1))
                      o=o*fac
                      
                      If(Abs(d)>1.0e-10_t_real .And. Abs(o)>1.0e-10_t_real)Then
                         If(Abs(d-o)>1.0e-10_t_real)Then
                            Print *,'error1'
                            Print "('mlb=',i5,' mla=',i5,' <OYO>=',2f30.15)",mlb,mla&
                                 &,fac,d/o
                            Stop
                         Endif
                      Else If(Abs(d)<1.0e-10_t_real .And. Abs(o)<1.0e-10_t_real)Then
                         
                      Else
                         Print *,'error2'
                         Print "('mlb=',i5,' mla=',i5,' <OYO>=',2f30.15)",mlb,mla&
                              &,d,o!*Sqrt(fourpi)
                         Stop
                      Endif
                   Enddo
                Enddo
                Write(outfile,*)
             Enddo !! ML
             Write(outfile,*)
          Enddo !! LL
       Enddo !! la
    Enddo !! lb
    !!
    Stop
    !!
    Return
    !!
  End Subroutine cyc
#ifdef my_compile_unused
  Subroutine chi_km1(kap,mu,cgordon)
    !!
    !!DOC This subroutine returns the Clebsch Gordon coefficients
    !!DOC $c_{\kappa\mu\sigma}$ and the values of $l$ and $m_{\sigma}$
    !!DOC for a spin angular functions
    !!DOC \begin{equation}\chi_{\kappa\mu}=\Omega_{jl\mu}=\left (
    !!DOC \begin{array}{c}
    !!DOC c_{\kappa\mu\uparrow} {\cal Y}_{lm_{\uparrow}}\\
    !!DOC c_{\kappa\mu\downarrow} {\cal Y}_{lm_{\downarrow}}\\
    !!DOC \end{array}\right )\nonumber\end{equation}
    !!DOC characterized by $\kappa$ and $\mu$.\\
    !!DOC {\bf If $\chi_{\kappa\mu}$ does not exist, the Clebsch Gordon
    !!DOC coefficients are set to zero!}
    !!
    !!
    Implicit None
    !!IO
    !!DOC io={kap}{$\kappa$ quantum number}endio
    Integer(t_int),Intent(in)    :: kap
    !!DOC io={mu}{$\mu$ quantum number in units (1/2) it is the 
    !!DOC z-component of total torque}endio
    Integer(t_int),Intent(in)    :: mu
    !!DOC io={cgordon}{Clebsch Gordon coefficients 
    !!DOC $(c_{\kappa\mu\uparrow},c_{\kappa\mu\downarrow})$}endio
    Real(t_real),Intent(out)     :: cgordon(2)
    !!LOCAL
    !! total torque j in units 1/2
    Integer(t_int) :: j,ks!,l,ms
    Real(t_real)   :: deg
    !!
    !! check if bispinor exists
    j=2*Abs(kap)-1
    If ((kap==0).Or.(Abs(mu)>j)) Then
       cgordon(1)=0.0_t_real
       cgordon(2)=0.0_t_real
    Else 
       !l=(Abs(2*kap+1)-1)/2
       deg=Real(2*kap+1,t_real)
       ks=Sign(1_t_int,kap)
       
       cgordon(1)=-ks*Sqrt( (1.0_t_real-mu/deg)*0.5_t_real )
       cgordon(2)=    Sqrt( (1.0_t_real+mu/deg)*0.5_t_real )
       
       
       If(kap<0)Then 
          If(mu==j)Then
             cgordon(1)=1.0_t_real
             cgordon(2)=0.0_t_real
          Else If(mu==-j)Then
             cgordon(1)=0.0_t_real
             cgordon(2)=1.0_t_real
          Endif
       Endif
    Endif
    !!
    Return
    !!
  End Subroutine chi_km1
#endif
  !!***********************************************************************
  Subroutine potential_gaunt_identity()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="potential_gaunt_identity"
    Integer(t_int) :: ig,ng,nv,lmax,i,j,k,LL,ML,lb,la,mb,ma,LLb,MLb,glmax
    Integer(t_int) :: ioci,LLMAX
    Real(t_real)   :: rsh(3),w,theta,phi,dum,im,re,g,gb,d,g0,ylm(169),p,tol
    Real(t_real)   :: errmax,alll
    Real(t_real)   :: yyy(169,169,169)
    Complex(t_real):: cyp(169),ca(169,169,169),Lylm(3,169),c
    Real(t_real),Pointer :: wg(:),ag(:,:),wgaunt(:,:,:),pot(:,:,:)
    Real(t_real),Pointer :: ociLM(:,:),oci(:),loci(:),ociLVL(:)
    Nullify(wg,pot,ociLM,oci,loci,ociLVL)
    Nullify(ag,wgaunt)
    !!
    lmax=3
    !!
    nv=6*lmax
    Call sph_zyl_mesh(nv,ag,wg,ng,.False.)

    !!
    glmax=lmax
    Call palloc('wgaunt',wgaunt,1_t_int,(glmax+1)**2&
         &,1_t_int,(glmax+1)**2,1_t_int,(2*glmax+1)**2,nmodule,nsubfunc)

    Call makergaunt(wgaunt,glmax,glmax,2*glmax) 

    !!
    ca=0.0_t_real
    igloop: Do ig=1,ng
       !!
       !Print *,ig
       rsh(:)=ag(:,ig)
       w=wg(ig)
       !!
       Call get_spherical_coordinates(rsh,theta,phi,dum)
       Call cxylm(2*lmax,cyp,theta,phi)
       Call ylms12(ylm,rsh(1),rsh(2),rsh(3),2*lmax)
       Do i=1,(lmax+1)**2
          Do j=1,(lmax+1)**2
             Do k=1,(2*lmax+1)**2
                ca(i,j,k)=ca(i,j,k)+Conjg(cyp(i))*cyp(j)*cyp(k)*w
                yyy(i,j,k)=yyy(i,j,k)+ylm(i)*ylm(j)*ylm(k)*w
             Enddo
          Enddo
       Enddo
       !!
    End Do igloop
    !!
    !!
     Do LL=0,2*lmax
       Do ML=-LL,LL
          !Write(outfile,"('LM=',i3,i3)")LL,ML
          Do lb=0,lmax
             Do la=0,lmax
                !!
                !Write(outfile,"('lb,l=',i3,i3)")lb,la
                !!
                mbloop: Do mb=-lb,lb
                   Do ma=-la,la
                      g=0.0_t_real
                      If(ML+ma-mb ==0.And. Abs(lb-LL)<=la .And. la<=lb+LL&
                           &.And.Mod(la+lb+LL,2_t_int)==0)&
                           &g=gaunt(lb,mb,LL,ML,la,ma)
                      
                      re=Real(ca(lb*lb+lb+1+mb,la*la+la+1+ma,LL*LL+LL+1+ML),t_real)
                      im=Aimag(ca(lb*lb+lb+1+mb,la*la+la+1+ma,LL*LL+LL+1+ML))
                      If(Abs(im)>1.0e-12_t_real)Then
                         Print *,'error imag'
                      Endif
                      If(Abs(re-g)>1.0e-12_t_real)Then
                         Print "('error real',2(f30.15))",re,g
                      Endif
                      !Write(outfile,"(f10.5,' ')",advance='no')g-re
                   Enddo
                   !Write(outfile,*)
                Enddo mbloop


                mbloop1: Do mb=-lb,lb
                   Do ma=-la,la
                      g=wgaunt(lb*lb+lb+1+mb,la*la+la+1+ma,LL*LL+LL+1+ML)
                      re=yyy(lb*lb+lb+1+mb,la*la+la+1+ma,LL*LL+LL+1+ML)
                      If(Abs(re-g)>1.0e-12_t_real)Then
                         Print "('error real',2(f30.15))",re,g
                      Endif
                      !Write(outfile,"(f10.5,' ')",advance='no')g-re
                   Enddo
                   !Write(outfile,*)
                Enddo mbloop1

             Enddo
          Enddo
          
       Enddo
    Enddo
    !!
    !Stop
    Do LL=0,2*lmax
       Do ML=-LL,LL
          !Write(outfile,"('LM=',i3,i3)")LL,ML

          Do LLb=0,2*lmax
             Do MLb=-LLb,LLb
                
                lbloop: Do lb=0,lmax
                   Do la=0,lmax
                      
                      d=0.0_t_real
                      
                      mbloop2: Do mb=-lb,lb
                         maloop2: Do ma=-la,la
                            g=0.0_t_real
                            If(ML+ma-mb ==0.And. Abs(lb-LL)<=la .And. la<=lb+LL&
                                 &.And.Mod(la+lb+LL,2_t_int)==0)&
                                 &g=gaunt(lb,mb,LL,ML,la,ma)
                            
                            gb=0.0_t_real
                            If(MLb+ma-mb ==0.And. Abs(lb-LLb)<=la .And. la<=lb+LLb&
                                 &.And.Mod(la+lb+LLb,2_t_int)==0)&
                                 &gb=gaunt(lb,mb,LLb,MLb,la,ma)
                            
                            d=d+g*gb
                            
                         End Do maloop2
                      End Do mbloop2
                      
                      If( ( LL /= LLb .Or. ML /=MLb ) ) Then
                         If(Abs(d)>1.0e-10_t_real)Then
                            Write(outfile,"('LMb=',i3,i3)")LLb,MLb
                            Print "('error delta',f30.15)",d
                         Endif
                      Else
                         
                         g0=0.0_t_real
                         If( Abs(lb-LL)<=la .And. la<=lb+LL&
                              &.And.Mod(la+lb+LL,2_t_int)==0)&
                              &g0=gaunt(lb,0_t_int,LL,0_t_int,la,0_t_int)
                         
                         g0=g0*Sqrt((2*lb+1)*(2*la+1)/(fourpi*(2*LL+1)))
                         
                         If(Abs(d)>1.0e-10_t_real.Or.Abs(g0)>1.0e-10_t_real)Then
                            If(Abs(g0-d)>1.0e-10_t_real)Then
                               Write(outfile,"('error lb,l=',i3,i3,1x,2(f30.15,1x))")lb,la,d,d-g0
                            Endif
                         Endif
                      Endif
                   End Do
                End Do lbloop


                lbloop1: Do lb=0,lmax
                   Do la=0,lmax
                      
                      d=0.0_t_real
                      
                      mbloop3: Do mb=-lb,lb
                         maloop3: Do ma=-la,la

                            g=wgaunt(lb*lb+lb+1+mb,la*la+la+1+ma,LL*LL+LL+1+ML)

                            gb=wgaunt(lb*lb+lb+1+mb,la*la+la+1+ma,LLb*LLb+LLb+1+MLb)
                            
                            
                            d=d+g*gb
                            
                         End Do maloop3
                      End Do mbloop3
                      
                      If( ( LL /= LLb .Or. ML /=MLb ) ) Then
                         If(Abs(d)>1.0e-10_t_real)Then
                            Write(outfile,"('LMb=',i3,i3)")LLb,MLb
                            Print "('error delta',f30.15)",d
                         Endif
                      Else
                         
                         g0=wgaunt(lb*lb+lb+1,la*la+la+1,LL*LL+LL+1)
                         
                         g0=g0*Sqrt((2*lb+1)*(2*la+1)/(fourpi*(2*LL+1)))
                         
                         If(Abs(d)>1.0e-10_t_real.Or.Abs(g0)>1.0e-10_t_real)Then
                            If(Abs(g0-d)>1.0e-10_t_real)Then
                               Write(outfile,"('error lb,l=',i3,i3,1x,2(f30.15,1x))")&
                                    &lb,la,d,d-g0
                            Endif
                         Endif
                      Endif
                   End Do
                End Do lbloop1
                
             End Do
          End Do
          
       End Do
    End Do
    !!
    !!
    !!
    !!
    !!build a potential 
    !!
    Call palloc('pot',pot,0_t_int,lmax,0_t_int,lmax,0_t_int,(2*lmax+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('ociLM',ociLM,0_t_int,lmax,0_t_int,lmax,nmodule,nsubfunc)
    Call palloc('oci',oci,1_t_int,(lmax+1)**2*(lmax+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('loci',loci,1_t_int,(lmax+1)**2*(lmax+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('ociLVL',ociLVL,1_t_int,(lmax+1)**2*(lmax+1)**2&
         &,nmodule,nsubfunc)

    !!
    pot=0.0_t_real
    Do la=0,lmax
       Do lb=0,lmax
          Do i=1,(2*lmax+1)**2
             pot(la,lb,i)=(la+1.0_t_real)+(lb+10)**2+(3*i+5)**3/1000.0_t_real
          Enddo
       Enddo
    Enddo
    !!
    oci=0.0_t_real
    ioci=0
    Do la=0,lmax
       Do ma=-la,la
          Do lb=0,lmax
             Do mb=-lb,lb
                ioci=ioci+1
                !!
                Do LL=0,2*lmax
                   Do ML=-LL,LL
                      g=wgaunt(la*la+la+1+ma,lb*lb+lb+1+mb,LL*LL+LL+1+ML)

                      oci(ioci)=oci(ioci)+g*pot(la,lb,LL*LL+LL+1+ML)
                   Enddo
                Enddo
             Enddo
          Enddo
       Enddo
    Enddo
    !!
    !!
    LLMAX=3
    tol=1.0e-10_t_real
    !!
    !!
    oci=0.0_t_real
    ociLVL=0.0_t_real
    igloop1: Do ig=1,ng
       !!
       !Print *,ig
       rsh(:)=ag(:,ig)
       w=wg(ig)
       !!
       Call ylms12(ylm,rsh(1),rsh(2),rsh(3),2*lmax)
       Call calc_Lylm_unopt(ylm,2*lmax,Lylm)
       !!
       ioci=0
       Do i=1,(lmax+1)**2
          la=llilm(i)
          Do j=1,(lmax+1)**2
             lb=llilm(j)
             ioci=ioci+1
             !Do k=1,(LLMAX+1)**2
             Do k=1,(LLMAX)**2
                pot(la,lb,k)=0.0_t_real
             Enddo
             Do k=(LLMAX+1)**2+1,(2*lmax+1)**2
                pot(la,lb,k)=0.0_t_real
             Enddo
             Do k=(LLMAX)**2+1,(LLMAX+1)**2
                oci(ioci)=oci(ioci)+ylm(i)*ylm(j)*ylm(k)*pot(la,lb,k)*w
                c=Dot_product(Lylm(:,i),Lylm(:,j))
                If(Abs(Aimag(c))>tol)Then
                   Print *,'imag ',c
                Endif
                ociLVL(ioci)=ociLVL(ioci)+Real(c,t_real)*ylm(k)*pot(la,lb,k)*w
             Enddo
          Enddo
       Enddo
       !!
       !!
    End Do igloop1
    !!
    !!
    !!
    !!
    !!
    loci=0.0_t_real
    Do LL=0,2*lmax
       Do ML=-LL,LL
          Write(outfile,"('LM=',i3,i3)")LL,ML
          
          
          ociLM=0.0_t_real
          ioci=0
          laloop1: Do la=0,lmax
             Do ma=-la,la
                lbloop2: Do lb=0,lmax
                   Do mb=-lb,lb
                      ioci=ioci+1
                      
                      g=wgaunt(la*la+la+1+ma,lb*lb+lb+1+mb,LL*LL+LL+1+ML)
                      
                      ociLM(la,lb)=ociLM(la,lb)+g*oci(ioci)
                      
                   End Do
                End Do lbloop2
             End Do
          End Do laloop1
          
          
          !! reassemble
          ioci=0
          Do la=0,lmax
             Do ma=-la,la
                Do lb=0,lmax
                   Do mb=-lb,lb
                      ioci=ioci+1
                      g=wgaunt(la*la+la+1+ma,lb*lb+lb+1+mb,LL*LL+LL+1+ML)
                      g0=wgaunt(la*la+la+1,lb*lb+lb+1,LL*LL+LL+1)
                      d=0.0_t_real
                      If(Abs(g0)>1.0e-12_t_real)Then
                         d=Sqrt((fourpi*(2*LL+1))/((2*lb+1)*(2*la+1)))/g0&
                              &*ociLM(la,lb)
                      Endif
                      alll=0.5_t_real*(la*(la+1)+lb*(lb+1)-LL*(LL+1))
                      loci(ioci)=loci(ioci)+d*g*alll
                   End Do
                End Do
             End Do
          End Do
          


          Do la=0,lmax
             Do lb=0,lmax
                
                g0=wgaunt(la*la+la+1,lb*lb+lb+1,LL*LL+LL+1)
                d=0.0_t_real
                If(Abs(g0)>1.0e-12_t_real)Then
                   d=Sqrt((fourpi*(2*LL+1))/((2*lb+1)*(2*la+1)))/g0*ociLM(la,lb)
                Endif
                p=0.0_t_real
                If(Abs(la-lb)<=LL .And. LL<=la+lb.And.Mod(la+lb+LL,2_t_int)==0)Then
                   p=pot(la,lb,LL*LL+LL+1+ML)
                Endif
                If(Abs(d)>tol .And. Abs(p)>tol)Then
                   If(Abs(d-p)>tol*Abs(p))Then
                      Write(outfile,"(/,'error ',2i5,2(f30.15,1x))") la,lb,d,p
                   Endif
                Else If(Abs(d)>tol .Or. Abs(p)>tol)Then
                   Write(outfile,"('error ',2i5,2(f30.15,1x))") la,lb,d,p
                Endif
                !Write(outfile,"(2(f10.5,1x))",advance='no') d,p
             Enddo
             !Write(outfile,*)
          Enddo
          
          
          
       End Do
    End Do
    !!
    tol=1.0e-10_t_real
    !!
    ioci=0
    errmax=0.0_t_real
    Do la=0,lmax
       Do ma=-la,la
          Do lb=0,lmax
             Do mb=-lb,lb
                ioci=ioci+1
                errmax=Max(errmax,Abs(loci(ioci)-ociLVL(ioci)))
                Write(outfile,"(f10.5,1x)",advance='no')loci(ioci)-ociLVL(ioci)
                d=0.0_t_real
                LL=LLMAX
                alll=0.5_t_real*(la*(la+1)+lb*(lb+1)-LL*(LL+1))
                If(Abs(ociLVL(ioci))>tol.And.Abs(oci(ioci))>tol)Then
                   d=oci(ioci)*alll-ociLVL(ioci)
                   If(Abs(d)>tol*Abs(ociLVL(ioci)))Then
                      Print *,'ERROR /=0 ',ociLVL(ioci),oci(ioci)*alll
                   Endif
                Else If(Abs(ociLVL(ioci))>tol.Or.Abs(alll*oci(ioci))>tol)Then
                   Print *,'ERROR',ociLVL(ioci),oci(ioci)*alll
                Endif
                !Write(outfile,"(f10.5,1x)",advance='no')d
             End Do
          End Do
          Write(outfile,*)
       End Do
    End Do
    Print *,'errmax=',errmax
    !!
    Call pfree(pot)
    Call pfree(ociLM)
    Call pfree(oci)
    Call pfree(loci)
    Call pfree(ag)
    Call pfree(wg)
    Call pfree(wgaunt)
    !!
    Stop
    Return
    !!
  End Subroutine potential_gaunt_identity
  !!***********************************************************************
  !!***********************************************************************
  Subroutine calc_Lylm_unopt(ylm,lmax,Lylm)
    !!
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: lmax
    Real(t_real)   :: ylm((lmax+1)**2)
    Complex(t_real),Intent(out)  :: Lylm(3,(lmax+1)**2)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="calc_Lylm_unopt"
    Integer(t_int) :: l,m,lq,i,deg
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    Complex(t_real):: Lp,Lm
    Complex(t_real):: p_Uylm(1:2*lmax+1,1:2*lmax+1,0:lmax)
    Complex(t_real):: v(2*lmax+1),lV(3,2*lmax+1)

    !!
    Call make_ylm_U_matrix(lmax,p_Uylm)
    !!
    Lylm=0.0_t_real
    Do l=0,lmax
       lq=l*l+l+1
       
       deg=2*l+1
       !! Yc=Yr*U
       v(1:deg)=Matmul(ylm(lq-l:lq+l),p_Uylm(1:deg,1:deg,l))
       
       !! L Yc=Yr*U
       Do m=-l,l
          Lp=0.0_t_real
          Lm=0.0_t_real
          If(m+1<= l) Lp=v(l+1+m+1)*ladderClm(l,m)
          If(m-1>=-l) Lm=v(l+1+m-1)*ladderClm(l,m-1)
          lV(1,m+l+1)=    0.5_t_real*(Lp+Lm)
          lV(2,m+l+1)=-ci*0.5_t_real*(Lp-Lm)
          lV(3,m+l+1)= v(l+1+m)*m
       Enddo
       
       !! L Yr= L Yc*U^+
       Do i=1,3
          lylm(i,lq-l:lq+l)=&
               &Matmul(lV(i,1:deg),Conjg(Transpose(p_Uylm(1:deg,1:deg,l))))
       Enddo
    Enddo
    !!
    Return
    !!
  End Subroutine Calc_Lylm_unopt
  !!***********************************************************************
  Real(t_real) Function ladderClm(l,m)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: l,m
    !!LOCAL
    !Character(*),Parameter::nsubfunc="ladderClm"
    !!
    !!
    ladderClm=Sqrt(l*(l+1.0_t_real)-m*(m+1.0_t_real))
    !!
    Return
    !!
  End Function ladderClm
  !!***********************************************************************
  !!***********************************************************************
  Real(t_real) Function chiSigZChi(kapa,mua,kapb,mub)
    !!
    !! \chi_{kapa,mua} \sigma_z \chi_{kapb,mub}
    !!
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: kapa,kapb
    Integer(t_int),Intent(in)    :: mua,mub !! 2*mu
    !!LOCAL
    !Character(*),Parameter::nsubfunc="chiSigZChi"
    Integer(t_int) :: ja,jb
    !!
    chiSigZChi=0.0_t_real 
    If(mua/=mub .Or. kapa==0 .Or. kapb==0) Return
    !!
    ja=2*Abs(kapa)-1
    jb=2*Abs(kapb)-1
    If(kapa==kapb .And. Abs(mua) <= ja)Then
       chiSigZChi=-mub/(2.0_t_real*kapa+1)
    Else If(kapa==-kapb-1 .And. Abs(mua)<= Min(ja,jb)) Then 
       chiSigZChi=-Sqrt(1.0_t_real-(mub/(2.0_t_real*kapa+1))**2)
    Endif
    !!
    Return
    !!
  End Function chiSigZChi
  !!***********************************************************************
  Real(t_real) Function chiZChi(kapa,mua,kapb,mub)
    !!
    !! \chi_{kapa,mua} z \chi_{kapb,mub}
    !!
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: kapa,kapb
    Integer(t_int),Intent(in)    :: mua,mub !! 2*mu
    !!LOCAL
    !Character(*),Parameter::nsubfunc="chiZChi"
    Integer(t_int) :: ja,jb
    !!
    chiZChi=0.0_t_real 
    If(mua/=mub .Or. kapa==0 .Or. kapb==0) Return
    !!
    ja=2*Abs(kapa)-1
    jb=2*Abs(kapb)-1
    !!
    If(Abs(mua)>ja .Or. Abs(mub)>jb) Return
    !!
    If(kapa==-kapb)Then
       chiZChi=-mub/(4.0_t_real*kapb**2-1.0_t_real)
    Else If(kapa==kapb-1) Then 
       chiZChi=Sqrt((2.0_t_real*kapa+1)**2-mua**2)/Abs(2.0_t_real*kapa+1)&
            &*0.5_t_real
    Else If(kapa==kapb+1) Then 
       chiZChi=Sqrt((2.0_t_real*kapb+1)**2-mub**2)/Abs(2.0_t_real*kapb+1)&
            &*0.5_t_real
    Endif
    !!
    Return
    !!
  End Function chiZChi
  !!***********************************************************************
  Real(t_real) Function wigner3j_1(ja,mua,jb,mub,q)
    !! 
    !! / ja 1 jb \
    !! |         |
    !! \ ma q mb /
    !! 
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: ja,jb !! 2*Ja, 2*Jb
    Integer(t_int),Intent(in)    :: mua,mub !! 2*mua, 2*mub
    Integer(t_int),Intent(in)    :: q  !! -1,0,1
    !!LOCAL
    !Character(*),Parameter::nsubfunc="wigner3j_1"
    Real(t_real)   :: d
    !!
    wigner3j_1=0.0_t_real
    !!
    If(mua+mub+2*q/=0)Return
    If(Abs(mua)>ja .Or. Abs(mub)>jb)Return
    !!
    If(ja == jb)Then
       If(q==0)Then
          wigner3j_1=0.5_t_real*mub*Sqrt(4.0_t_real/((jb+2)*jb*(jb+1)))&
               &*(-1)**((jb-mub)/2)
       Else
          wigner3j_1=sq2o2*q*Sqrt(1.0_t_real/((jb+2)*jb*(jb+1)))&
               &*Sqrt(jb*(jb+2.0_t_real)-mub*(mub+2*q))*(-1)**((jb-mub)/2)

       Endif
    Else If(ja==jb-2)Then
       d=Sqrt(2.0_t_real/((jb+1)*jb*(jb-1)))*(-1)**((jb-mub)/2)
       If(q==0)Then
          wigner3j_1=d*Sqrt(1.0_t_real*jb**2-mub**2)*0.5_t_real
       Else
          wigner3j_1=d*Sqrt(0.5_t_real*(jb-q*mub)*(jb-q*mub-2))*0.5_t_real
       Endif
    Else If(ja==jb+2)Then
       d=-Sqrt(2.0_t_real/((ja+1)*ja*(ja-1)))*(-1)**((ja-mua)/2)
       If(q==0)Then
          wigner3j_1=d*Sqrt(1.0_t_real*ja**2-mua**2)*0.5_t_real
       Else
          wigner3j_1=d*Sqrt(0.5_t_real*(ja-q*mua)*(ja-q*mua-2))*0.5_t_real
       Endif
    Endif
    !!
    !!
    Return
    !!
  End Function wigner3j_1
  !!***********************************************************************
  Real(t_real) Function redMatEl_sigma(kapa,kapb)
    !!
    !! reduced matrix element <kapa|| t^sigma ||kapb>
    !! for Wigner Eckart theorem
    !!
    !! t^sigma_q=sigma_z delta_{q0} -q (sigma_x+i q sigma_y)/sqrt(2)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: kapa,kapb
    !!LOCAL
    !Character(*),Parameter::nsubfunc="redMatEl_sigma"
    !!
    !!
    redMatEl_sigma=0.0_t_real
    !!
    If(kapa*kapb==0)Return
    !!
    If(kapa==kapb)Then
       redMatEl_sigma=-Sqrt(2.0_t_real*Abs(kapa)*(2*kapa-1)&
            &/(2*kapa+1))*kapb/Abs(kapb)
    Else If(kapa==-kapb-1)Then
       redMatEl_sigma=-Sqrt(8.0_t_real*kapb*kapa/(2*kapb+1))&
            &*kapb/Abs(kapb)
    Endif
    !!
    !!
    Return
    !!
  End Function redMatEl_sigma
  !!***********************************************************************
  Real(t_real) Function redMatEl_position(kapa,kapb)
    !!
    !! reduced matrix element <kapa|| t^r ||kapb>
    !! for Wigner Eckart theorem
    !!
    !! t^r_q=(z delta_{q0} -q (x+i q y)/sqrt(2))/r
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: kapa,kapb
    !!LOCAL
    !Character(*),Parameter::nsubfunc="redMatEl_position"
    !!
    !!
    redMatEl_position=0.0_t_real
    !!
    If(kapa*kapb==0)Return
    !!
    If(kapa==-kapb)Then
       redMatEl_position=-Sqrt(2.0_t_real*Abs(kapa)/(4.0_t_real*kapa**2-1))
    Else If(kapa==kapb-1)Then
       redMatEl_position=&
            &-Sqrt(2.0_t_real*Abs(kapb)*kapa/(2.0_t_real*kapb-1))&
            &*kapb/Abs(kapb)
    Else If(kapa==kapb+1)Then
       redMatEl_position=&
            &Sqrt(2.0_t_real*Abs(kapb)*kapa/(2.0_t_real*kapb+1))&
            &*kapb/Abs(kapb)
    Endif
    !!
    !!
    Return
    !!
  End Function redMatEl_position
  !!***********************************************************************
  Subroutine bhfamtel()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="bhfamtel"
    Logical(t_log) :: err
    Integer(t_int) :: lmax,nv,ig,ng,kapa,ma,ja,mua,kapb,jb,mb,mub,q,la,lb
    Integer(t_int) :: mla,mlb,ms,i,j
    Real(t_real)   :: rsh(3),w,theta,phi,dum,clm,sq2,tol,rr,r,dd,rrex(3,3)
    Complex(t_real):: cyp(169),Tkq(3),ssa(2),ssb(2),sigmaq(2,2,3),cc,sigr(2,2)
    Complex(t_real):: sigma(2,2,3),crr
    Real(t_real),Pointer :: wg(:),ag(:,:)
    Real(t_real),Pointer :: rrr(:,:,:,:,:,:)
    Complex(t_real),Pointer:: ccc(:,:,:,:,:)
    Complex(t_real),Pointer:: yyy(:,:,:,:,:)
    Real(t_real),Pointer:: ylm(:)
    Complex(t_real),Pointer:: czc(:,:,:,:,:)
    Complex(t_real),Pointer:: crsc(:,:,:,:,:)
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    Nullify(wg,ag,ccc,yyy,czc,crsc,ylm,rrr)
    !!
    tol=1.0e-10_t_real
    !!
    sq2=Sqrt(2.0_t_real)
    clm=Sqrt(3.0_t_real/fourpi)
    lmax=6
    !!
    nv=6*lmax
    Call sph_zyl_mesh(nv,ag,wg,ng,.False.)
    !!
    !!
    !!
    If(.True.)Then !! N/SREL
       !!
       Call palloc('ylm',ylm,1_t_int,(lmax+1)**2,nmodule,nsubfunc)
       Call palloc('rrr',rrr&
            &,0_t_int,lmax,-lmax,lmax,0_t_int,lmax,-lmax,lmax&
            &,1_t_int,3_t_int,1_t_int,3_t_int&
            &,nmodule,nsubfunc)
       !!
       rrr=0.0_t_real
       !!
       igloop1: Do ig=1,ng
          r=0.12345_t_real
          rsh(:)=r*ag(:,ig)
          w=wg(ig)
          !!
          Call ylms12(ylm,rsh(1),rsh(2),rsh(3),lmax)
          !!
          Do la=0,lmax
             Do ma=-la,la
                Do lb=0,lmax
                   Do mb=-lb,lb
                      Do i=1,3
                         Do j=1,3
                            rrr(la,ma,lb,mb,i,j)=rrr(la,ma,lb,mb,i,j)&
                                 &+ylm(la*la+la+1+ma)&
                                 &*rsh(i)*rsh(j)/r**2&
                                 &*ylm(lb*lb+lb+1+mb)*w
                         End Do
                      End Do
                   End Do
                End Do
             End Do
          Enddo
          !!
       Enddo igloop1
       !!
       !!
       Do la=0,lmax
          Do ma=-la,la
             Do lb=0,lmax
                Do mb=-lb,lb
                   
                   Call dyadeMatEl_bhf(la,ma,lb,mb,rrex)
                   
                   Do i=1,3
                      Do j=1,3

                         dd=rrr(la,ma,lb,mb,i,j)

                         rr=0.0_t_real


                         If(la==lb.And.ma==mb.And.la==0&
                              &.And.i==j)rr=1.0_t_real/3.0_t_real
                         
                         rr=rrex(i,j)

                         err=.False.
                         err=err.Or.(Abs(dd-rr)>tol)

                         If(err)Then
                            Write(outfile,"(a1,i2,' ',a1,i2,'  S(',i1,',',i1,')',2(f30.15))")&
                                 &lqnchar(la),ma,lqnchar(lb),mb,i,j,dd,rr
                         Endif
                         
                      End Do
                   End Do ! i
                   
                   If(Any(rrex>tol))Then
                      !Print "(a1,i2,1x,a1,i2)",lqnchar(la),ma,lqnchar(lb),mb
                      !Call printmat("rr","(f15.10,1x)","('       0        ')"&
                      !     &,rrex,3,3,1.0e-8_t_real)
                   Endif

                End Do
             End Do
          End Do
       End Do
       !!
       Call pfree(ylm)
       Call pfree(rrr)
       !!
       Stop
       !!
    Endif
    !!
    !!FREL
    !!
    Call palloc('ccc',ccc,-lmax-1,lmax,1_t_int,2*lmax+2,-lmax-1,lmax&
         &,1_t_int,2*lmax+2,1_t_int,3_t_int,nmodule,nsubfunc)
    Call palloc('czc',czc,-lmax-1,lmax,1_t_int,2*lmax+2,-lmax-1,lmax&
         &,1_t_int,2*lmax+2,1_t_int,3_t_int,nmodule,nsubfunc)
    Call palloc('crsc',crsc,-lmax-1,lmax,1_t_int,2*lmax+2,-lmax-1,lmax&
         &,1_t_int,2*lmax+2,1_t_int,3_t_int,nmodule,nsubfunc)
    !!
    Call palloc('yyy',yyy,-lmax-1,lmax,1_t_int,2*lmax+2,-lmax-1,lmax&
         &,1_t_int,2*lmax+2,1_t_int,2_t_int,nmodule,nsubfunc)
    !!
    ccc=c0
    czc=c0
    yyy=c0
    !! sigma-
    sigmaq(:,1,1)=(/0.0_t_real,2.0_t_real/)/sq2
    sigmaq(:,2,1)=(/0.0_t_real,0.0_t_real/)/sq2
    !!sigma0
    sigmaq(:,1,2)=(/1.0_t_real,0.0_t_real/)
    sigmaq(:,2,2)=(/0.0_t_real,-1.0_t_real/)
    !!sigma+
    sigmaq(:,1,3)=(/0.0_t_real,0.0_t_real/)/sq2
    sigmaq(:,2,3)=(/-2.0_t_real,0.0_t_real/)/sq2
    !!
    sigma(1,:,1)=(/0.0_t_real,1.0_t_real/)
    sigma(2,:,1)=(/1.0_t_real,0.0_t_real/)
    sigma(1,:,2)=(/c0,-ci/)
    sigma(2,:,2)=(/ci,c0/)
    sigma(1,:,3)=(/1.0_t_real,0.0_t_real/)
    sigma(2,:,3)=(/0.0_t_real,-1.0_t_real/)
    !!
    igloop: Do ig=1,ng
       r=0.12345_t_real
       rsh(:)=r*ag(:,ig)
       w=wg(ig)
       Call get_spherical_coordinates(rsh,theta,phi,dum)
       Call cxylm(2*lmax,cyp,theta,phi)


       Tkq(1)=+Cmplx(rsh(1),-rsh(2),t_real)/sq2/r !!T^1_{-1}
       Tkq(2)= Cmplx(rsh(3),0.0_t_real,t_real)/r  !!T^1_{ 0}
       Tkq(3)=-Cmplx(rsh(1),rsh(2),t_real)/sq2/r  !!T^1_{+1}

       sigr(1,1)=rsh(3)/r
       sigr(1,2)=(rsh(1)-ci*rsh(2))/r
       sigr(2,1)=(rsh(1)+ci*rsh(2))/r
       sigr(2,2)=-rsh(3)/r

       Do kapa=-lmax-1,lmax
          ja=2*Abs(kapa)-1
          la=(Abs(2*kapa+1)-1)/2
          Do ma=1,ja+1
             mua=2*(ma-1)-ja
             Do kapb=-lmax-1,lmax
                jb=2*Abs(kapb)-1
                lb=(Abs(2*kapb+1)-1)/2
                Do mb=1,jb+1
                   mub=2*(mb-1)-jb
                   
                   Call spherical_spinor(kapa,mua,cyp,ssa)
                   Call spherical_spinor(kapb,mub,cyp,ssb)
                   
                   Do ms=1,2
                      mla=(mua-(3-2*ms))/2
                      mlb=(mub-(3-2*ms))/2
                      If(Abs(mla)<= la .And. Abs(mlb)<= lb ) Then
                         yyy(kapa,ma,kapb,mb,ms)=yyy(kapa,ma,kapb,mb,ms)&
                              &+w*Conjg(cyp(la*la+la+1+mla))&
                              &*cyp(3)&
                              &*cyp(lb*lb+lb+1+mlb)
                      Endif
                   Enddo
                   
                   Do q=1,3
                      ccc(kapa,ma,kapb,mb,q)=ccc(kapa,ma,kapb,mb,q)&
                           &+w*Dot_product(ssa,Matmul(sigmaq(:,:,q),ssb))

                      czc(kapa,ma,kapb,mb,q)=czc(kapa,ma,kapb,mb,q)&
                           &+w*Tkq(q)*Dot_product(ssa,ssb)

                      crsc(kapa,ma,kapb,mb,q)=crsc(kapa,ma,kapb,mb,q)&
                           &+w*Dot_product(ssa,Matmul(sigr*rsh(q)/r-sigma(:,:,q),ssb))
                   End Do
                   
                End Do
             End Do
          Enddo
       Enddo
       
    End Do igloop
    !!
    !!
    Do kapa=-lmax-1,lmax
       ja=2*Abs(kapa)-1
       la=(Abs(2*kapa+1)-1)/2
       Do ma=-2,ja+3
          mua=2*(ma-1)-ja
          Do kapb=-lmax-1,lmax
             lb=(Abs(2*kapb+1)-1)/2
             jb=2*Abs(kapb)-1
             Do mb=-2,jb+3
                mub=2*(mb-1)-jb
                Do q=1,3

                   cc=c0
                   If(Abs(mua)<=ja .And. Abs(mub)<=jb)&
                        & cc=ccc(kapa,ma,kapb,mb,q)

                   rr=wigner3j_1(ja,-mua,jb,mub,q-2)&
                        &*redMatEl_sigma(kapa,kapb)&
                        &*(-1)**((ja-mua)/2)
                   
                   err=.False.
                   err=err.Or.(Aimag(cc)>tol)
                   err=err.Or.(Abs(Real(cc,t_real)-rr)>tol)
                   
                   
                   If(err)Then
                      Write(outfile,"(a,i1,'/2 ',i2,'/2 ',a,i1,'/2 ',i2,'/2 S(',i&
                           &1,')',3(f30.15))")&
                           &lqnchar(la),ja,mua,lqnchar(lb),jb,mub,q,cc,rr
                   Endif
                   
                End Do !! q
                !!
                Do ms=1,2

                   mla=(mua-(3-2*ms))/2
                   mlb=(mub-(3-2*ms))/2
                   If(Abs(mla)>la .Or. Abs(mlb)>lb) Cycle
                   
                   cc=c0
                   If(Abs(mua)<=ja .And. Abs(mub)<=jb.And.&
                        &(Abs(mla)<=la .and. Abs(mlb)<=lb))&
                   & cc=yyy(kapa,ma,kapb,mb,ms)

                   rr=0.0_t_real
                   If( (Abs(mua)<=ja .And. Abs(mub)<=jb).And.&
                        &(Abs(mla)<=la .And. Abs(mlb)<=lb) &
                        &.And. mua==mub)Then
                      If( kapb/=0 .And. kapa/=0 )Then
                         If(kapa==-kapb .Or. kapa==kapb-1)Then
                            rr=clm*Sqrt((kapb**2-mlb**2)/(4.0_t_real*kapb**2-1))
                         Endif
                         If(kapa==kapb+1 .Or. kapa==-kapb-2)Then
                            rr=clm*Sqrt(((kapb+1)**2-mla**2)&
                                 &/(4.0_t_real*(kapb+1)**2-1))
                         Endif
                      Endif
                   Endif
                   
                   err=.False.
                   err=err.Or.(Aimag(cc)>tol)
                   err=err.Or.(Abs(Real(cc,t_real)-rr)>tol)
                   
                   
                   If(err)Then
                      Write(outfile,"(a,i1,'/2 ',i2&
                           &,'/2 ',a,i1,'/2 ',i2,'/2 T(',i1,')',3(f30.15)&
                           &)")&
                           &lqnchar(la),ja,mua,lqnchar(lb),jb,mub,ms,cc,rr
                   Endif
                Enddo ! ms
                !!
                Do q=1,3

                   cc=c0
                   If(Abs(mua)<=ja .And. Abs(mub)<=jb)&
                        & cc=czc(kapa,ma,kapb,mb,q)

                   

                   rr=wigner3j_1(ja,-mua,jb,mub,q-2)&
                        &*redMatEl_position(kapa,kapb)&
                        &*(-1)**((ja-mua)/2)
                   
                   err=.False.
                   err=err.Or.(Aimag(cc)>tol)
                   err=err.Or.(Abs(Real(cc,t_real)-rr)>tol)
                   
                   
                   If(err)Then
                      
                      Write(outfile,"(a,i1,'/2 ',i2,'/2 ',a,i1,'/2 ',i2,'/2 T(',i&
                           &1,')',3(f30.15))")&
                           &lqnchar(la),ja,mua,lqnchar(lb),jb,mub,q,cc,rr
                   Endif
                   
                End Do !! q
                !!
                Do q=1,3

                   cc=c0
                   If(Abs(mua)<=ja .And. Abs(mub)<=jb)&
                        & cc=crsc(kapa,ma,kapb,mb,q)

                   crr=c0
                   If(q==3)Then
                      crr=wigner3j_1(ja,-mua,jb,mub,0_t_int)&
                           &*redMatEl_bhf(kapa,kapb)&
                           &*(-1)**((ja-mua)/2)
                   Else If(q==1)Then
                      crr=wigner3j_1(ja,-mua,jb,mub,-1_t_int)&
                           &*redMatEl_bhf(kapa,kapb)&
                           &*(-1)**((ja-mua)/2)
                      crr=crr-wigner3j_1(ja,-mua,jb,mub,1_t_int)&
                           &*redMatEl_bhf(kapa,kapb)&
                           &*(-1)**((ja-mua)/2)
                      crr=crr/sq2
                   Else If(q==2)Then
                      crr=wigner3j_1(ja,-mua,jb,mub,-1_t_int)&
                           &*redMatEl_bhf(kapa,kapb)&
                           &*(-1)**((ja-mua)/2)
                      crr=crr+wigner3j_1(ja,-mua,jb,mub,1_t_int)&
                           &*redMatEl_bhf(kapa,kapb)&
                           &*(-1)**((ja-mua)/2)
                      crr=ci*crr/sq2
                      
                   Endif

                   
                   err=.False.
                   err=err.Or.(Abs(cc-crr)>tol)
                   !err=err.Or.(Aimag(cc)>tol)
                   
                   
                   If(err)Then
                      
                      Write(outfile,"(a,i1,'/2 ',i2,'/2 ',a,i1,'/2 ',i2,'/2 T(',i&
                           &1,')',3(f30.15))")&
                           &lqnchar(la),ja,mua,lqnchar(lb),jb,mub,q,cc,rr
                   Endif

                      
                End Do !! q
                !!
                !!
             End Do !!
          End Do
       End Do
    End Do

    !!
    Call pfree(crsc)
    Call pfree(czc)
    Call pfree(ccc)
    Call pfree(yyy)
    Call pfree(ag)
    Call pfree(wg)
    !!
    Stop
    !!
    Return
    !!
  End Subroutine bhfamtel 
  !!***********************************************************************
  Subroutine lindhard_suscep()
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="lindhard_suscep"
    Integer(t_int) :: ik,Nk,iq,Ntet,itet,ik0,ik1,ikq0,ikq1,ia,Na
    Real(t_real)   :: ef,w,we,a0,k0,k1,dk,d,delta,res,Vuc
    Real(t_real)   :: Vcube,vc,ek0,ek1,eq0,eq1,q,ekq,ek,eq,a,k,eek(2),eeq(2)
    Real(t_real),Pointer :: p_k(:),p_ek(:)
    Complex(t_real),Pointer:: p_chi(:)
    Real(t_real),Pointer:: p_rchi(:)
    Real(t_real),Pointer:: p_Ichi(:)
    Integer(t_int),Pointer :: p_tet(:,:)
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    !!
    Nk=10001
    Open(12,file='=.chi')
    Read(12,*)
    Read(12,*)Nk,ef,delta
    Close(12)
    !!
    Na=(Nk-Mod(Nk,2_t_int))/10+Mod(Nk,2_t_int)
    !!
    Open(13,file='+a')
    Do ia=1,Na
       a=(ia-1.0_t_real)/(Na-1.0_t_real)*10.0_t_real-5_t_real
       !!
       eek(1)=-1.0_t_real
       eek(2)= 1.0_t_real
       !!
       eeq(1)=-1.0_t_real+a
       eeq(2)= 0.7_t_real+a
       !!
       !! brute force
       !!
       !! 
       d=0.0_t_real
       res=0.0_t_real
       Do ik=1,Nk
          k=(ik-1.0_t_real)/(Nk-1.0_t_real)
          we=1.0_t_real/(Nk-1.0_t_real)
          If(ik==1 .Or. ik==Nk)we=we*0.5_t_real
          ek=eek(1)+(eek(2)-eek(1))*k
          eq=eeq(1)+(eeq(2)-eeq(1))*k
          d=d+Real((theta(ef-ek)-theta(ef-eq))/Cmplx(eq-ek,delta,t_real)*we,t_real)
          !d=d+Real(theta(ef-ek)/Cmplx(eq-ek,delta)*we,t_real)
       Enddo
       !!
       res=0.0_t_real
       Call rp1d(eek,eeq,ef,res)
       !!
       Write(13,"(3(e30.15e3,1x))")a,d,res
    Enddo
    Close(13)
    !!
    Stop
    !!
    !!
    Nullify(p_k,p_ek,p_chi,p_rchi,p_Ichi,p_tet)
    !!
    a0=3.0_t_real
    !ef=0.0_t_real
    !w=0.2_t_real
    !delta=0.01_t_real
    !!
    Ntet=Nk-1
    Call palloc('p_k',p_k ,1_t_int,Nk,nmodule,nsubfunc)
    Call palloc('p_ek',p_ek ,1_t_int,Nk,nmodule,nsubfunc)
    Call palloc('p_chi',p_chi ,1_t_int,Nk,nmodule,nsubfunc)
    Call palloc('p_rchi',p_rchi ,1_t_int,Nk,nmodule,nsubfunc)
    Call palloc('p_Ichi',p_Ichi ,1_t_int,Nk,nmodule,nsubfunc)
    Call palloc('p_tet',p_tet ,1_t_int,2_t_int,1_t_int,Ntet&
         &,nmodule,nsubfunc)
    !!
    k0=-pi/a0
    k1= pi/a0
    dk=(k1-k0)/(Nk-1.0_t_real)
    Vuc=a0
    Open(12,file='ek')
    Do ik=1,Nk
       If(ik<Nk)Then
          p_tet(1,ik)=ik
          p_tet(2,ik)=ik+1
       Endif
       p_k(ik)=dk*(ik-1.0_t_real)+k0
       p_ek(ik)=Cos(p_k(ik)*a0)
       Write(12,10) p_k(ik)/pi*a0,p_ek(ik)
    Enddo
    Close(12)
    !!
    we=1.0_t_real/(Nk-1.0_t_real)
    p_chi(:)=c0
    p_rchi(:)=0.0_t_real
    Do iq=1,Nk
       !!
       Do ik=1,Nk-1
          !ikq=Mod((ik-1+iq-1)+(Nk-1)/2,Nk-1)+1
          
!!$          d=p_k(ikq)-(p_k(ik)+p_k(iq))
!!$          If(d<0)d=d+k1-k0
!!$          If(d>=k1)d=d-(k1-k0)
!!$          If(Abs(d)>1.0e-10_t_real)Then
!!$             Print *,d
!!$             Stop
!!$          End If

          q=p_k(iq)
          ekq=Cos((p_k(ik)+q)*a0)
          p_chi(iq)=p_chi(iq)+(theta(ef-p_ek(ik))-theta(ef-ekq))&
               &/(w+ci*delta-(p_ek(ik)-ekq))*we

          p_rchi(iq)=p_rchi(iq)+(theta(ef-p_ek(ik))-theta(ef-ekq))&
               &/(w-(p_ek(ik)-ekq))*we
       Enddo
       !Print *,chi
       !!
    Enddo
    !!
    !!
    Vcube=dk
    !!
    p_Ichi(:)=0.0_t_real
    Do iq=1,Nk
       res=0.0_t_real
       Do itet=1,Ntet
          !! find q tetrahedron
          ik0=p_tet(1,itet)
          ik1=p_tet(2,itet)
          ikq0=Mod((ik0-1+iq-1)+(Nk-1)/2,Nk-1)+1
          ikq1=Mod((ik1-1+iq-1)+(Nk-1)/2,Nk-1)+1
          !! todo: here find mapping into irreducible points
          !!
          !!
          ek0=p_ek(ik0)
          ek1=p_ek(ik1)
          eq0=p_ek(ikq0)
          eq1=p_ek(ikq1)
          vc=1.0_t_real/Ntet
          !Print *,vc-1.0_t_real/Ntet
          !!
          !!
          !!
          Call tet_cut_first(ef,ek0,ek1,eq0,eq1,vc,w,res)
          !!
          !!
          !!
       Enddo
       p_Ichi(iq)=res
    Enddo
    !!
    !!
    !!
    Open(12,file='chiq')
    Do iq=1,Nk
       Write(12,10) p_k(iq)/pi*a0&
            &,Real(p_chi(iq),t_real),Aimag(p_chi(iq))/(w+1.0e-10_t_real)&
            !&,p_rchi(iq)&
            &,p_Ichi(iq)/(w+1.0e-10_t_real)
    Enddo
    Close(12)
    !!
    Call pfree(p_k)
    Call pfree(p_ek)
    Call pfree(p_chi)
    Call pfree(p_rchi)
    Call pfree(p_Ichi)
    Call pfree(p_tet)
    !!
    !Stop
    !!
    Return
    !!
10  Format(10(e30.15e3,1x))
    !!
  End Subroutine lindhard_suscep
  !!***********************************************************************
  Subroutine rp1d(ek,ekq,ef,res)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: ef
    Real(t_real),Intent(in)      :: ek(2),ekq(2)
    Real(t_real),Intent(inout)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="rp1d"
    Real(t_real)   :: dk,dq,P,dkq,l,d0,d1
    Real(t_real),Parameter :: tol=1.0e-12_t_real
    !!
    !!
    dk=ek(2)-ek(1)
    dq=ekq(2)-ekq(1)
    If(Abs(dk-dq)<tol)Then
       !!
       If(Abs(dk)>tol)Then
          If(Abs(ekq(1)-ek(1))>tol)Then
             P=1.0_t_real/(ekq(1)-ek(1))
             !!
             If(ef>ek (2)) res=res-P*(ef-ek (2))/dk
             If(ef>ek (1)) res=res+P*(ef-ek (1))/dk
             If(ef>ekq(2)) res=res+P*(ef-ekq(2))/dq
             If(ef>ekq(1)) res=res-P*(ef-ekq(1))/dq
          Else
             If(ef>ek (2)) res=res-1.0_t_real/dk
             If(ef>ek (1)) res=res+1.0_t_real/dk
          Endif
       Else
          If(Abs(ekq(1)-ek(1))>tol)Then
             P=1.0_t_real/(ekq(1)-ek(1))
             If(ef>ek (1)) res=res+P
             If(ef>ekq(1)) res=res-P
          Endif
       Endif
    Else
       dkq=1.0_t_real/(dk-dq)
       d0=ek(1)-ekq(1)
       d1=ek(2)-ekq(2)
       If(Abs(dk)>tol)Then
          l=Log(Abs(d1*dk/((dk-dq)*(ef-ek(1))+d0*dk)))
          If(ef>ek (2)) res=res-dkq*l
          If(Abs(d0)>tol)Then
             l=Log(Abs(d0*dk/((dk-dq)*(ef-ek(1))+d0*dk)))
             If(ef>ek (1)) res=res+dkq*l
          Endif
       Else
          l=Log(Abs(d1/d0))
          If(ef>ek (1)) res=res+l/dq
       Endif
       If(Abs(dq)>tol)Then
          l=Log(Abs(d1*dq/((dk-dq)*(ef-ek(1))+d0*dk)))
          If(ef>ekq(2)) res=res+dkq*l
          If(Abs(d0)>tol)Then
             l=Log(Abs(d0*dq/((dk-dq)*(ef-ek(1))+d0*dk)))
             If(ef>ekq(1)) res=res-dkq*l
          Else
             l=Log(Abs(dk/dq))
             If(ef>ekq(1)) res=res+dkq*l
          Endif
       Else
          l=Log(Abs(d1/d0))
          If(ef>ekq(1)) res=res+l/dk
       Endif
    Endif
    !!
    Return
    !!
  End Subroutine rp1d
  !!***********************************************************************
  Subroutine tet_cut_first(ef,iek0,iek1,ieq0,ieq1,vc,w,res)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: ef,w
    Real(t_real),Intent(in)   :: iek0,iek1,ieq0,ieq1,vc
    Real(t_real),Intent(inout)   :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="tet_cut_first"
    Real(t_real)   :: lmu,v,ek0,ek1,eq0,eq1,a0,a1,b0,b1
    !!
    !! sort ek
    If(iek0>iek1)Then
       ek0=iek1
       ek1=iek0
       eq0=ieq1
       eq1=ieq0
    Else
       ek0=iek0
       ek1=iek1
       eq0=ieq0
       eq1=ieq1
    Endif
    !!
    !!
    v=vc
    If(ef<=ek0)Then
       !! empty
       v=-vc
       !!expect full
       Call tet_cut_second(expect_full,ef,ek0,ek1,eq0,eq1,v,w,res)
    Else If(ek1<=ef)Then
       !! full
       Call tet_cut_second(expect_empty,ef,ek0,ek1,eq0,eq1,v,w,res)
    Else !! ek0<ef<ek1
       lmu=(ef-ek0)/(ek1-ek0)
       a0=ek0
       a1=ef
       b0=eq0
       b1=eq0+(eq1-eq0)*lmu
       v=vc*lmu
       Call tet_cut_second(expect_empty,ef,a0,a1,b0,b1,v,w,res)

       a0=ef
       a1=ek1
       b0=eq0+(eq1-eq0)*lmu
       b1=eq1
       v=vc*(lmu-1.0_t_real)
       Call tet_cut_second(expect_full,ef,a0,a1,b0,b1,v,w,res)
    Endif
    !!
    !!
    !!
    Return
    !!
  End Subroutine tet_cut_first
  !!***********************************************************************
  Subroutine tet_cut_second(expect,ef,iek0,iek1,ieq0,ieq1,vc,w,res)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: expect
    Real(t_real),Intent(in)      :: ef,w
    Real(t_real),Intent(in)      :: iek0,iek1,ieq0,ieq1,vc
    Real(t_real),Intent(inout)   :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="tet_cut_second"
    Real(t_real)   :: lmu,aw,b,eq0,eq1,ek0,ek1,v
    !!
    !! sort ek
    If(ieq0>ieq1)Then
       ek0=iek1
       ek1=iek0
       eq0=ieq1
       eq1=ieq0
    Else
       ek0=iek0
       ek1=iek1
       eq0=ieq0
       eq1=ieq1
    Endif
    !!
    v=vc
    If(ef<=eq0)Then
       If( (expect==expect_empty)) Goto 100
    Else If(eq1<=ef)Then
       If((expect==expect_full)) Goto 100
    Else !! eq0<ef<eq1
       lmu=(ef-eq0)/(eq1-eq0)
       If(expect==expect_full)Then
          eq1=ef
          ek1=ek0+(ek1-ek0)*lmu
          v=v*lmu
          goto 100
       Else If(expect==expect_empty)Then
          !Print "('eq ',10f20.5)",eq0,ef,eq1,lmu
          eq0=ef
          ek0=ek0+(ek1-ek0)*lmu
          v=v*(1.0_t_real-lmu)
          goto 100
       Endif
    Endif
    !!
    Return
    !!
100 Continue !! do integral
    !!
    aw=w-(ek0-eq0)
    b=(ek1-ek0)-(eq1-eq0)
    If(Abs(b)>0.0_t_real)Then
       If(0.0_t_real<=aw/b .And. aw/b <=1.0_t_real)&
            & res=res-pi*v/Abs(b)
    Endif
    !!
    Return
    !!
  End Subroutine tet_cut_second
  !!***********************************************************************
  Real(t_real) Function theta(x)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x
    !!LOCAL
    !Character(*),Parameter::nsubfunc="theta"
    !!
    !!
    theta=0.0_t_real
    If(x>=0.0_t_real)     theta=1.0_t_real
    !!
    Return
    !!
  End Function theta
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lindhard_suscep_3d(symmetry,bzone)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)   :: symmetry
    Type(T_Bzone),Intent(in)  :: bzone
    !!LOCAL
    Character(*),Parameter::nsubfunc="lindhard_suscep_3d"
    Integer(t_int) :: ix,iy,iz,k1,k2,k3,jx,jy,jz,iks(4),ikqs(4),nnn,iq,nq
    Integer(t_int) :: ikp,itet,i,iqx,iqy,iqz,ikx,iky,ikz,k,imax,ik,ii,ne
    Integer(t_int) :: ntet,icorn,Nk,imin
    Complex(t_real),Pointer:: p_chi(:)
    Real(t_real),Pointer :: p_ichi(:)
    Integer(t_int) :: Nx,Ny,Nz,dk(0:1,0:1,0:1),idk(0:1,0:1,0:1)
    Real(t_real)   :: we,d,ef,w,delta,ek,ekq,rb(3,3),qb(3,3),vol,kp(3),kq(3)
    Real(t_real)   :: kqp(3),eek(4),eekq(4),vc,res,a0,dd,h,ww
    Logical(t_log) :: prot,valid,exists
    Integer(t_int),Pointer :: p_tet(:,:,:),p_fmi_to_fmijk(:,:)
    Real(t_real),Pointer :: p_weight(:,:,:)
    Real(t_real),Pointer :: p_ek(:)
    Real(t_real),Pointer :: p_a(:)
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    Integer(t_int) :: Nint,ia,Na,ja,idum
    Real(t_real)   :: x,y,z,eq,eek0(4),eeq0(4),a,a1,eeq(4),ddum,xf
    Real(t_real)   :: neeq(4),neek(4),wf
    Logical(t_log) :: redo
    !!
    prot=.False.
    Nullify(p_tet,p_chi,p_ek,p_fmi_to_fmijk,p_ichi,p_weight,p_a)
    !!
    wf=0.0001
    Open(12,file='=.tetreal')
    Read(12,*)
    Read(12,*) Nint,ef,w,delta,redo
    Read(12,*)
    Read(12,*) eek0(1:4)
    Read(12,*)
    Read(12,*) eeq0(1:4)
    Read(12,*)
    Read(12,*) Na,a0,a1,ja
    Close(12)
    !!
    !!
    !!
    !! test subroutine
    !!
    !! prepare weights for numerical integration over one tetra
    !!
    Call palloc('p_weight',p_weight,1_t_int,Nint,1_t_int,Nint&
         &,1_t_int,Nint,nmodule,nsubfunc)
    !!
    h=1.0_t_real/(Nint-1.0_t_real)
    Nx=Nint
    p_weight=0.0_t_real
    Do ix=1,Nx-1
       x=(ix-1.0_t_real)*h
       Ny=Nx-ix+1
       Do iy=1,Ny-1
          y=(iy-1.0_t_real)*h
          Nz=Nx-ix-iy+1+1
          Do iz=1,Nz-1
             z=(iz-1.0_t_real)*h
             If(((x+h+y+h+z>1.00001_t_real).Or.&
                  &(x+h+z+h+y>1.00001_t_real).Or.&
                  &(z+h+y+h+x>1.00001_t_real))&
                  &.And.(x+h+y+h+z+h>1.00001_t_real))Then
                p_weight(ix:ix+1,iy:iy+1,iz:iz+1)=&
                     &p_weight(ix:ix+1,iy:iy+1,iz:iz+1)+1.0_t_real/24.0_t_real
             Else If(x+h+y+h+z+h>1.00001_t_real)Then
                p_weight(ix,iy,iz)=p_weight(ix,iy,iz)+5.0_t_real/24.0_t_real
                p_weight(ix+1,iy+1,iz)=p_weight(ix+1,iy+1,iz)+1.0_t_real/6.0_t_real
                p_weight(ix+1,iy,iz+1)=p_weight(ix+1,iy,iz+1)+1.0_t_real/6.0_t_real
                p_weight(ix,iy+1,iz+1)=p_weight(ix,iy+1,iz+1)+1.0_t_real/6.0_t_real
                p_weight(ix+1,iy,iz)=p_weight(ix+1,iy,iz)+1.0_t_real/24.0_t_real
                p_weight(ix,iy+1,iz)=p_weight(ix,iy+1,iz)+1.0_t_real/24.0_t_real
                p_weight(ix,iy,iz+1)=p_weight(ix,iy,iz+1)+1.0_t_real/24.0_t_real

             Else
                p_weight(ix:ix+1,iy:iy+1,iz:iz+1)=&
                     &p_weight(ix:ix+1,iy:iy+1,iz:iz+1)+1.0_t_real/8.0_t_real
             Endif
          Enddo
       Enddo
    Enddo
    p_weight=p_weight*h**3
    !!
    !!
    !!
    Inquire(file='+num',exist=exists)
    valid=.False.
    If(exists)Then
       valid=.True.
       Open(15,file='+num',status='old')
       Read(15,*)idum ;  If(idum/=Nint) valid=.False.
       Print *,'valid',valid
       Read(15,*)ddum ;  If(Abs(ddum-ef)>1.0e-12_t_real) valid=.False.
       Print *,'valid',valid,ddum,ef
       Read(15,*)ddum ;  If(Abs(ddum-w)>1.0e-12_t_real) valid=.False.
       Print *,'valid',valid,ddum,w
       Read(15,*)ddum ;  If(Abs(ddum-delta)>1.0e-12_t_real) valid=.False.
       Print *,'valid',valid
       Do i=1,4
          Read(15,*)ddum ;  If(Abs(ddum-eek0(i))>1.0e-12_t_real) valid=.False.
          Print *,'valid',valid,i,ddum,eek0(i)
       Enddo
       Do i=1,4
          Read(15,*)ddum ;  If(Abs(ddum-eeq0(i))>1.0e-12_t_real) valid=.False.
       Enddo
       Print *,'valid',valid
       Read(15,*)idum ;  If(idum/=Na) valid=.False.
       Print *,'valid',valid
       Read(15,*)ddum ;  If(Abs(ddum-a0)>1.0e-12_t_real) valid=.False.
       Print *,'valid',valid
       Read(15,*)ddum ;  If(Abs(ddum-a1)>1.0e-12_t_real) valid=.False.
       Print *,'valid',valid
       !!
       Print *,'valid',valid
    Endif
    If(.Not.redo) valid=.True.
    !Stop
    If(.Not.valid) Then
       If(exists) Close(15)
       Open(15,file='+num')
       write(15,*) Nint
       Write(15,*) ef
       write(15,*) w
       write(15,*) delta
       Do i=1,4
          Write(15,*) eek0(i)
       Enddo
       Do i=1,4
          Write(15,*) eeq0(i)
       Enddo
       Write(15,*) Na
       Write(15,*) a0
       Write(15,*) a1
    Endif
    !!
    Call palloc('p_a',p_a,1_t_int,Na,nmodule,nsubfunc)
    !!
555 Continue
    Open(13,file='+a')
    Do ia=1,Na
       !!
       a=(ia-1.0_t_real)/(Na-1.0_t_real)*(a1-a0)+a0
       !!
       eek=eek0
       eeq=eeq0
       !eeq(ja)=eeq(ja)!+a
       xf=ef+a
       !ww=a
       ww=w
       !!
       neeq=eeq
       neek=eek
       !Call fixerg(neek,neeq,1.0e-3_t_real)


       !!
       If(valid)Goto 222
       !!
       dd=0.0_t_real
       Do ix=1,Nx
          x=(ix-1.0_t_real)*h
          Ny=Nx-ix+1
          Do iy=1,Ny
             y=(iy-1.0_t_real)*h
             Nz=Nx-ix-iy+1+1
             Do iz=1,Nz
                z=(iz-1.0_t_real)*h
                ek=neek(1)+(neek(2)-neek(1))*x+(neek(3)-neek(1))*y+(neek(4)-neek(1))*z
                eq=neeq(1)+(neeq(2)-neeq(1))*x+(neeq(3)-neeq(1))*y+(neeq(4)-neeq(1))*z
                !d=Real((theta(xf-ek)-theta(xf-eq))/Cmplx(ww-(ek-eq),delta),t_real)
                !d=Aimag((theta(xf-ek)-theta(xf-eq))/Cmplx(ww-(ek-eq),delta))
                !d=Aimag((theta(xf-ek)-theta(xf-eq))/Cmplx(ww+wf-(ek-eq),delta))
                !d=Aimag(1.0_t_real/Cmplx(xf-ek,delta))&
                !     &*Aimag(1.0_t_real/Cmplx(xf-eq,delta))/pi/pi
                d=Aimag(1.0_t_real/Cmplx(xf-ek,delta,t_real))/pi&
                     &*Aimag(1.0_t_real/Cmplx(xf-eq,delta,t_real))
                dd=dd+d*p_weight(ix,iy,iz)
             End Do
          End Do
       End Do
       !!
       write(15,*)dd
       !!
222    Continue
       !!
       If(valid)Then
          read(15,*)dd
       Endif
       res=0.0_t_real
       !Call lindtet3drealstatic(eek-xf,eeq-xf,delta,res)
       Call lind2tet(ww,eek-xf,eeq-xf,res,1.0_t_real,2_t_int)
       !!
       Write(outfile,"(f5.1,'%',e30.15e3)")100.0_t_real*ia/Na,res
       !!
       Write(13,"(3(e30.15e3,1x))")a,dd,res
       !!
       p_a(ia)=res
       !!
    Enddo
    Close(13)
    Close(15)
    !!
    imin=Na+1
    imax=0
    !!
    Do ia=1,Na
       a=(ia-1.0_t_real)/(Na-1.0_t_real)*(a1-a0)+a0
       If(Abs(p_a(ia))>1.0e-6_t_real)Then
          imin=ia
          a0=a
          Exit
       Endif
    Enddo
    Do ia=Na,1,-1
       a=(ia-1.0_t_real)/(Na-1.0_t_real)*(a1-a0)+a0
       If(Abs(p_a(ia))>1.0e-6_t_real)Then
          imax=ia
          a1=a
          Exit
       Endif
    Enddo
    !!
    If(imax-imin< Na*0.25.And.imax>imin)Then
       Print *,'CORRECT: imin,imax',imin,imax
       If(a1>a0)Then
          Print *,'CORRECT: JUMPED BACK',a0,a1
          d=a1-a0
          a0=a0-d*0.1
          a1=a1+d*0.1
          valid=.False.
          Goto 555
       Endif
    Endif
    !!
    Stop
    !!
    Open(12,file='=.chi')
    Read(12,*)
    Read(12,*)Nk,ef,delta
    Close(12)
    !!
    a0=symmetry% lattice_constants(1)
    !!
    Nx=bzone% nkxyz(1)
    Ny=bzone% nkxyz(2)
    Nz=bzone% nkxyz(3)
    !!
    nnn=Nx*Ny*Nz
    !!
    ne=100
!!$    Write(outfile,500)
!!$    Do iz=0,Nz-1
!!$       Do iy=0,Ny-1
!!$          Do ix=0,Nx-1
!!$             Write(outfile,501)ix,iy,iz&
!!$                  &,bzone% p_ijk_to_ikp(ix+1+(iy+iz*Ny)*Nx)
!!$          Enddo
!!$       Enddo
!!$    Enddo
!!$    Write(outfile,502)
!!$    !!
!!$    Write(outfile,503)
!!$    Do ikp=1,bzone% nkp
!!$       Write(outfile,501)ikp,bzone% p_ikp_to_ijk(1:4,ikp)
!!$    Enddo
!!$    Write(outfile,502)
!!$500 Format(/,' BZMESH:     mapping k-indices -> No of irred k-point',/&
!!$         &,t4,'   i1     i2     i3     ikp',/&
!!$         &,t2,62('-'))
!!$503 Format(/,' BZMESH:     mapping No of irred k-point -> k-indices',/&
!!$         &,t4,'  ikp     i1     i2     i3 weight',/&
!!$         &,t2,62('-'))
!!$501 Format(t2,5(i7))
!!$502 Format(t2,62('-'),/)
    !!
    !!
    !!
    Call palloc('p_tet',p_tet,1_t_int,4_t_int,1_t_int,2_t_int&
         &,1_t_int,6*nnn,nmodule,nsubfunc)

    Call palloc('p_fmi_to_fmijk',p_fmi_to_fmijk,1_t_int,3_t_int&
         &,1_t_int,nnn,nmodule,nsubfunc)

    !!
    !! --- START LOOPING OVER MICROCELLS
    ntet=0
    ii=0
    Do iz=0,Nz-1
       Do iy=0,Ny-1
          Do ix=0,Nx-1
             ii=ii+1
             p_fmi_to_fmijk(1:3,ii)=(/ix,iy,iz/)

             ikp=fmijk_to_fmi(ix,iy,iz,Nx,Ny)
             If(prot) Print "('ind:',4i5)",ix,iy,iz,ikp
             !! --------- SET UP IDENTIFIERS AT 8 CORNERS OF MICROCELL
             Do k1=0,1
                jx=Mod(ix+k1,Nx)
                Do k2=0,1
                   jy=Mod(iy+k2,Ny)
                   Do k3=0,1
                      jz=Mod(iz+k3,Nz)
                      i=fmijk_to_fmi(jx,jy,jz,Nx,Ny)
                      dk(k1,k2,k3)=i
                      idk(k1,k2,k3)=bzone% p_ijk_to_ikp(i)
                   Enddo
                Enddo
             Enddo

             !! --------- LOOP OVER TETRAHEDRA
             Do itet=1,6
                ntet=ntet+1
                Do icorn=1,4
                   k1=bzone% kcut(1,icorn,itet)
                   k2=bzone% kcut(2,icorn,itet)
                   k3=bzone% kcut(3,icorn,itet)
                   !! irred
                   p_tet(icorn,1,ntet) = idk(k1,k2,k3)
                   !! reducible
                   p_tet(icorn,2,ntet) = dk(k1,k2,k3)
                Enddo
             Enddo
          Enddo
       Enddo
    Enddo
    !!
    If(prot)Then
       Write(outfile,301)
       Do itet=1,ntet
          Write(outfile,302)itet,(p_tet(i,1,itet),p_tet(i,2,itet),i=1,4)
       Enddo
       Write(outfile,303)
    Endif
    !!
301 Format(/' TETIRR:  ITET   KP1    KP2    KP3    KP4', &
         & /,9x,50('-'))
302 Format(7x,i6,4x,4(i4,':',i4,3x))
303 Format(9x,43('-'))
    !!
    !!  index function test
    Do iz=0,Nz-1
       Do iy=0,Ny-1
          Do ix=0,Nx-1
             ikp=fmijk_to_fmi(ix,iy,iz,Nx,Ny)
             Call fmi_to_fmijk(ikp,jx,jy,jz,Nx,Ny)
             jx=p_fmi_to_fmijk(1,ikp)
             jy=p_fmi_to_fmijk(2,ikp)
             jz=p_fmi_to_fmijk(3,ikp)
             If(ix/=jx .Or. iy/=jy.Or. iz/=jz)Then
                Write(outfile,"('ikp,x,y,z ',i5,':',3i5)") &
                     &ikp+1,ix,iy,iz,jx,jy,jz
                stop
             Endif
          End Do
       End Do
    End Do
    !!
    !!
    !!
    !!
    !!
    nq=(Nx+1)*(Ny+1)*(Nz+1)
    !!
    Call palloc('p_chi',p_chi ,1_t_int,nq,nmodule,nsubfunc)
    Call palloc('p_ichi',p_ichi ,1_t_int,nq,nmodule,nsubfunc)
    p_ichi(:)=0.0_t_real
    p_chi(:)=c0
    !!
    !! for tests 
    rb=symmetry% lattice_vectors
    Call dinv33(rb,3_t_int,qb,vol)
    vol=vol/twopi**2 !! volume of reciprocial cell
    qb(:,1) = qb(:,1)/Nx
    qb(:,2) = qb(:,2)/Ny
    qb(:,3) = qb(:,3)/Nz
    !!
    Write(outfile,"('R1 ',3f15.7)") rb(:,1)
    Write(outfile,"('R2 ',3f15.7)") rb(:,2)
    Write(outfile,"('R3 ',3f15.7)") rb(:,3)

    Write(outfile,*)

    Write(outfile,"('G1 ',3f15.7)") qb(:,1)
    Write(outfile,"('G2 ',3f15.7)") qb(:,2)
    Write(outfile,"('G3 ',3f15.7)") qb(:,3)
    Write(outfile,*)
    Write(outfile,"('vol',f15.7)") vol
    !Stop
    
    we=1.0_t_real/nnn
    !!
    Call palloc('p_ek',p_ek ,1_t_int,bzone% nkp,nmodule,nsubfunc)
    imax=0
    Do ikz=0,Nz-1
       Do iky=0,Ny-1
          Do ikx=0,Nx-1
             !ik=fmijk_to_fmi(ikx,iky,ikz,Nx,Ny,Nz)
             ik=bzone% p_ijk_to_ikp(fmijk_to_fmi(ikx,iky,ikz,Nx,Ny))
             imax=Max(imax,ik)
             !! get k and k+q
             Do k=1,3
                kp(k) =qb(k,1)*ikx+qb(k,2)*iky+qb(k,3)*ikz
             Enddo
             !p_ek(ik)=Cos(twopi*ikx/Nx)*Cos(twopi*iky/Ny)*Cos(twopi*ikz/Nz)
             p_ek(ik)=Cos(twopi*ikx/Nx)+Cos(twopi*iky/Ny)+Cos(twopi*ikz/Nz)
          Enddo
       Enddo
    Enddo
    Print *,imax,bzone% nkp
    !!
    !! energies
    Open(12,file='+ek')
    Do ikz=0,Nz
       Do iky=0,Ny
          Do ikx=0,Nx
             !! get k and k+q
             ik=bzone% p_ijk_to_ikp(fmijk_to_fmi(&
                  &Mod(ikx,Nx)&
                  &,Mod(iky,Ny)&
                  &,Mod(ikz,Nz)&
                  &,Nx,Ny))

             Do k=1,3
                kp(k) =qb(k,1)*ikx+qb(k,2)*iky+qb(k,3)*ikz
             Enddo
             !ek=Cos(twopi*ikx/Nx)*Cos(twopi*iky/Ny)*Cos(twopi*ikz/Nz)
             ek=Cos(twopi*ikx/Nx)+Cos(twopi*iky/Ny)+Cos(twopi*ikz/Nz)
             Write(12,"(4(e30.15e3,1x))")kp,ek
          Enddo
       Enddo
    Enddo
    Close(12)
    !!
    !!
    Open(12,file='ek.general')
    Write(12,99)'+ek',Nx+1,Ny+1,Nz+1
99  Format(&
         & 'file = ',a,/&
         &,'grid = ',i7,' x ',i7,' x ',i7,/&
         &,'format = ascii',/&
         &,'interleaving = field',/&
         &,'majority = column',/&
         &,'field = locations, energy',/&
         &,'structure = 3-vector, scalar',/&
         &,'type = double, double',/&
         &,'end')
    Close(12)

    !!
    !! brute force integration
    !!
    !If(.False.)Then
    If(.True.)Then
       Do iqz=0,Nz
          Print *,100.0_t_real*iqz/nz
          Do iqy=0,Ny
             Do iqx=0,Nx
                !!
                iq=fmijk_to_fmi(iqx,iqy,iqz,Nx+1,Ny+1)
                !Print *,iq
                
                Do k=1,3
                   kq(k)=qb(k,1)*iqx+qb(k,2)*iqy+qb(k,3)*iqz
                Enddo
                !!
                d=0.0_t_real
                Do ikz=0,Nz-1
                   Do iky=0,Ny-1
                      Do ikx=0,Nx-1
                         !! shift by q
                         jx=Mod((ikx+iqx),Nx)
                         jy=Mod((iky+iqy),Ny)
                         jz=Mod((ikz+iqz),Nz)
                         !! get k and k+q
                         Do k=1,3
                            kp(k) =qb(k,1)*ikx+qb(k,2)*iky+qb(k,3)*ikz
                            kqp(k)=qb(k,1)*jx+qb(k,2)*jy+qb(k,3)*jz
                         Enddo
                         
                         !ek=Cos(twopi*ikx/Nx)*Cos(twopi*iky/Ny)*Cos(twopi*ikz/Nz)
                         ek=Cos(twopi*ikx/Nx)+Cos(twopi*iky/Ny)+Cos(twopi*ikz/Nz)
                         !ekq=Cos(twopi*jx/Nx)*Cos(twopi*jy/Ny)*Cos(twopi*jz/Nz)
                         ekq=Cos(twopi*jx/Nx)+Cos(twopi*jy/Ny)+Cos(twopi*jz/Nz)
                         If(w==0.0_t_real) Then
                            p_chi(iq)=p_chi(iq)&
                                 &+Cmplx(0.0_t_real&
                                 &,delta/((ef-ek)**2 +delta**2)&
                                 &*delta/((ek-ekq)**2+delta**2)/pi,t_real)*we
                         Else
                            p_chi(iq)=p_chi(iq)+(theta(ef-ek)-theta(ef-ekq))&
                                 &/(w+ci*delta-(ek-ekq))*we
                         Endif
                         !Print *,p_chi(iq)
                         
                         d=d+we
                      Enddo
                   Enddo
                Enddo
                
                !!
             Enddo
          End Do
       End Do
    Endif
    !!
    !!
    !!
    !!
    !!
!!$    Open(12,file='+chi')
!!$    Do iq=1,Nq
!!$       Call fmi_to_fmijk(iq,iqx,iqy,iqz,Nx+1,Ny+1,Nz+1)
!!$       !Print *,iq,iqx,iqy
!!$       Do k=1,3
!!$          kqp(k)=qb(k,1)*iqx+qb(k,2)*iqy+qb(k,3)*iqz
!!$       Enddo
!!$       Write(12,"(5(e30.15e3,1x))")kqp&!,ek,ekq!&
!!$            &,Real(p_chi(iq),t_real)&
!!$            &,Aimag(p_chi(iq))/(w+1.0e-10_t_real)
!!$
!!$    Enddo
!!$    Close(12)
    !!
    Open(12,file='chi.general')
    Write(12,199)'+chi',Nx+1,Ny+1,Nz+1
199  Format(&
         & 'file = ',a,/&
         &,'grid = ',i7,' x ',i7,' x ',i7,/&
         &,'format = ascii',/&
         &,'interleaving = field',/&
         &,'majority = column',/&
         &,'field = locations, real_part ,imaginary_part, chipp',/&
         &,'structure = 3-vector, scalar, scalar, scalar',/&
         &,'type = double, double, double, double',/&
         &,'end')

    Close(12)
    !!
    vc=1.0_t_real/(Nx*Ny*Nz)
    !!
    Print *,'ntet=',ntet,nq
    !!
    Goto 1000
    Do iqz=0,Nz
       Print *,100.0_t_real*iqz/nz
       Do iqy=0,Ny
          Do iqx=0,Nx
             !!
             Do k=1,3
                kqp(k)=qb(k,1)*iqx+qb(k,2)*iqy+qb(k,3)*iqz
             Enddo
             !!
             iq=fmijk_to_fmi(iqx,iqy,iqz,Nx+1,Ny+1)

!!$             Write(outfile,"('q=',i5,i5,i5)")iqx,iqy,iqz
             res=0.0_t_real
             Do itet=1,ntet
                iks(1:4)=p_tet(1:4,1,itet)
                Call mapkplusq(iqx,iqy,iqz,p_tet(:,2,itet),ikqs,Nx,Ny,Nz&
                     &,bzone% p_ijk_to_ikp,p_fmi_to_fmijk)
!!$                Write(outfile,"(t4,'itet ',i4,' : ',4i4,/,t16,4i4)")&
!!$                     &itet,iks(1:4),ikqs(1:4)
                eek(1:4)=p_ek(iks(1:4))
                eekq(1:4)=p_ek(ikqs(1:4))
                Do icorn=1,4
                   ikp=p_tet(icorn,2,itet)!! full mesh with periodic backfolding
                   jx=p_fmi_to_fmijk(1,ikp)
                   jy=p_fmi_to_fmijk(2,ikp)
                   jz=p_fmi_to_fmijk(3,ikp)
                   Do k=1,3
                      kp(k)=qb(k,1)*jx+qb(k,2)*jy+qb(k,3)*jz
                   Enddo
                   kp=kp+kqp
                   ekq=Cos(kp(1)*a0)+Cos(kp(2)*a0)+Cos(kp(3)*a0)

                   If(Abs(eekq(icorn)-ekq)>1.0e-12)Then
                      Print *,eekq(icorn)-ekq
                   Endif
                   eekq(icorn)=ekq
                Enddo
                !Print "('nek0',9f10.5)",eek,eekq,ef
                
                Call tetcut_chiqw(eek,eekq,vc,ef,w,res)
                !Call tetcut_chiqw_delta(eek,vc,w,res)
                
             Enddo
             p_ichi(iq)=-pi*res
             !Print *,'res=',vc,res
          Enddo
       Enddo
    Enddo
    !!
1000 Continue
    !!
    Open(12,file='+chi')
    Do iq=1,Nq
       Call fmi_to_fmijk(iq,iqx,iqy,iqz,Nx+1,Ny+1)
!       If(iqz==1)Then
          !Print *,iq,iqx,iqy
          Do k=1,3
             kqp(k)=qb(k,1)*iqx+qb(k,2)*iqy+qb(k,3)*iqz
          Enddo

          Write(12,"(6(e30.15e3,1x))")kqp(1:3)&
               &/twopi*a0&
               &,Real(p_chi(iq),t_real)&
               &,Aimag(p_chi(iq))&!/(w+1.0e-10_t_real)&
               &,p_ichi(iq)/(w+1.0e-10_t_real)
!       Endif
    Enddo
    Close(12)
    !!
    Call pfree(p_chi)
    Call pfree(p_ichi)
    Call pfree(p_ek)

    Call pfree(p_tet)
    Call pfree(p_fmi_to_fmijk)
    Call pfree(p_weight)
    !!
    Print *,'ende'
    Stop 'ende'
    !!
    Return
    !!
  End Subroutine lindhard_suscep_3d
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lind2tet(w,eek0,eeq0,res,vt,reim)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: reim
    Real(t_real),Intent(in)      :: w,eek0(4),eeq0(4),vt
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lind2tet"
    Logical(t_log) :: lq0 !! q=0 limit: all eek(i)=eeq(i)
    Integer(t_int) :: i,j
    Real(t_real)   :: eek(4),eeq(4),dum,l21,l31,l41,l32,l42,f,l43
    Real(t_real)   :: e21,e31,e32,e41,e42,e43
    Real(t_real)   :: neek(4),neeq(4)
    Real(t_real),Parameter :: tol=1.0e-6_t_real!!todo
    Real(t_real),Parameter :: delta=1.0e-4_t_real
    !!
    eek=eek0
    eeq=eeq0
    !!
    If(reim==2 .And. Abs(w)<tol)Then
       Call lind2tetNest(eek0,eeq0,res,vt)
       Return
    Endif

    lq0=.False.
    If(All(Abs(eek(1:4)-eeq(1:4))<tol))Then
       If(Abs(w)<1.0e-10_t_real) Then
          lq0=.True.
       Else
          res=0.0_t_real
          Return
       Endif
    Endif
    !!
    Do i=1,4
       Do j=i+1,4
          If(eeq(j)<eeq(i))Then
             dum=eeq(j)
             eeq(j)=eeq(i)
             eeq(i)=dum
             dum=eek(j)
             eek(j)=eek(i)
             eek(i)=dum
          Endif
       Enddo
    Enddo
    !!
    !!
    If(0.0_t_real<=eeq(1))Then
       !! empty q-tet
       Print *,'empty q-tet'
       Call lind2tet_stage2(w,eek,eeq,res,vt,-1.0_t_real,tol,delta,reim)
       
    Else If(eeq(1)<0.0_t_real .And. 0.0_t_real<=eeq(2))Then
       !! 1-corner q-tet
       Print *,'1-corner full q-tet'
       l21=-eeq(1)/(eeq(2)-eeq(1))
       l31=-eeq(1)/(eeq(3)-eeq(1))
       l41=-eeq(1)/(eeq(4)-eeq(1))
       If(lq0)Then
          e21=1.0_t_real/(eeq(2)-eeq(1))
          e31=1.0_t_real/(eeq(3)-eeq(1))
          e41=1.0_t_real/(eeq(4)-eeq(1))
          f=e21*l31*l41+l21*e31*l41+l21*l31*e41
          res=res+vt*f/6.0_t_real
       Else
          f=l21*l31*l41

          neeq(1)=eeq(1)
          neeq(2)=0.0_t_real
          neeq(3)=0.0_t_real
          neeq(4)=0.0_t_real
          
          neek(1)=eek(1)
          neek(2)=eek(1)+l21*(eek(2)-eek(1))
          neek(3)=eek(1)+l31*(eek(3)-eek(1))
          neek(4)=eek(1)+l41*(eek(4)-eek(1))
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,1.0_t_real,tol,delta,reim)
          !! empty
          Print *,'1-corner full q-tet empty part 1'
          
          neeq(1)=0.0_t_real
          neeq(2)=0.0_t_real
          neeq(3)=0.0_t_real
          neeq(4)=eeq(4)
          
          neek(1)=eek(1)+(eek(4)-eek(1))*l41
          neek(2)=eek(1)+(eek(3)-eek(1))*l31
          neek(3)=eek(1)+(eek(2)-eek(1))*l21
          neek(4)=eek(4)
          
          f=l21*l31*(1.0_t_real-l41)
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,-1.0_t_real,tol,delta,reim)
          
          Print *,'1-corner full q-tet empty part 2'
          neeq(1)=eeq(3)
          neeq(2)=0.0_t_real
          neeq(3)=0.0_t_real
          neeq(4)=eeq(4)
          
          neek(1)=eek(3)
          neek(2)=eek(1)+(eek(3)-eek(1))*l31
          neek(3)=eek(1)+(eek(2)-eek(1))*l21
          neek(4)=eek(4)
          
          f=l21*(1.0_t_real-l31)
          
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,-1.0_t_real,tol,delta,reim)
          
          Print *,'1-corner full q-tet empty part 3'
          
          neeq(1)=eeq(3)
          neeq(2)=eeq(2)
          neeq(3)=0.0_t_real
          neeq(4)=eeq(4)
          
          
          neek(1)=eek(3)
          neek(2)=eek(2)
          neek(3)=eek(1)+(eek(2)-eek(1))*l21
          neek(4)=eek(4)
          
          f=1.0_t_real-l21
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,-1.0_t_real,tol,delta,reim)

       Endif

    Else If(eeq(2)<0.0_t_real .And. 0.0_t_real<=eeq(3))Then
       Print *,'2-corner full q-tet part 1'
       !!
       l31=-eeq(1)/(eeq(3)-eeq(1))
       l32=-eeq(2)/(eeq(3)-eeq(2))
       l41=-eeq(1)/(eeq(4)-eeq(1))
       l42=-eeq(2)/(eeq(4)-eeq(2))
       If(lq0)Then
          e31=1.0_t_real/(eeq(3)-eeq(1))
          e32=1.0_t_real/(eeq(3)-eeq(2))
          e41=1.0_t_real/(eeq(4)-eeq(1))
          e42=1.0_t_real/(eeq(4)-eeq(2))
          f=-3.0_t_real*(eeq(2)*eeq(3)*eeq(4)+eeq(1)*eeq(3)*eeq(4)&
               &-eeq(1)*eeq(2)*eeq(4)-eeq(1)*eeq(2)*eeq(3))
          res=res+vt*f/6.0_t_real*e31*e32*e41*e42
          
       Else
          
          f=l41*l31*(1.0_t_real-l42)
          neeq(1)=0.0_t_real
          neeq(2)=eeq(1)
          neeq(3)=0.0_t_real
          neeq(4)=0.0_t_real
          
          neek(1)=eek(1)+(eek(3)-eek(1))*l31
          neek(2)=eek(1)
          neek(3)=eek(1)+(eek(4)-eek(1))*l41
          neek(4)=eek(2)+(eek(4)-eek(2))*l42
          
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,1.0_t_real,tol,delta,reim)
          !!
          Print *,'2-corner full q-tet part 2'
          f=l31*l42*(1.0_t_real-l32)
          
          neeq(1)=0.0_t_real
          neeq(2)=0.0_t_real
          neeq(3)=0.0_t_real
          neeq(4)=eeq(1)
          
          neek(1)=eek(2)+(eek(3)-eek(2))*l32
          neek(2)=eek(2)+(eek(4)-eek(2))*l42
          neek(3)=eek(1)+(eek(3)-eek(1))*l31
          neek(4)=eek(1)
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,1.0_t_real,tol,delta,reim)
          !!
          Print *,'2-corner full q-tet part 3'
          
          f=l32*l42
          
          neeq(1)=0.0_t_real
          neeq(2)=eeq(2)
          neeq(3)=eeq(1)
          neeq(4)=0.0_t_real
          
          neek(1)=eek(2)+(eek(4)-eek(2))*l42
          neek(2)=eek(2)
          neek(3)=eek(1)
          neek(4)=eek(2)+(eek(3)-eek(2))*l32
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,1.0_t_real,tol,delta,reim)
          !!
          !!
          !!
          Print *,'2-corner full q-tet empty part 1'
          
          !!
          neeq(1)=0.0_t_real
          neeq(2)=0.0_t_real
          neeq(3)=0.0_t_real
          neeq(4)=eeq(3)
          
          neek(1)=eek(2)+(eek(3)-eek(2))*l32
          neek(2)=eek(2)+(eek(4)-eek(2))*l42
          neek(3)=eek(1)+(eek(3)-eek(1))*l31
          neek(4)=eek(3)
          
          f=(1.0_t_real-l32)*(1.0_t_real-l31)*l42
          
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,-1.0_t_real,tol,delta,reim)
          !!
          Print *,'2-corner full q-tet empty part 2'
          
          neeq(1)=0.0_t_real
          neeq(2)=eeq(3)
          neeq(3)=0.0_t_real
          neeq(4)=0.0_t_real
          
          neek(1)=eek(1)+(eek(3)-eek(1))*l31
          neek(2)=eek(3)
          neek(3)=eek(1)+(eek(4)-eek(1))*l41
          neek(4)=eek(2)+(eek(4)-eek(2))*l42
          
          f=(1.0_t_real-l31)*(1.0_t_real-l42)*l41
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,-1.0_t_real,tol,delta,reim)
          !!
          Print *,'2-corner full q-tet empty part 3'
          !!
          neeq(1)=eeq(3)
          neeq(2)=0.0_t_real
          neeq(3)=0.0_t_real
          neeq(4)=eeq(4)
          
          neek(1)=eek(3)
          neek(2)=eek(1)+(eek(4)-eek(1))*l41
          neek(3)=eek(2)+(eek(4)-eek(2))*l42
          neek(4)=eek(4)
          
          
          f=(1.0_t_real-l41)*(1.0_t_real-l42)
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,-1.0_t_real,tol,delta,reim)
          !!
       Endif
       !!
    Else If(eeq(3)<0.0_t_real .And. 0.0_t_real<=eeq(4))Then
       !! 1-corner q-tet
       Print *,'1-corner empty q-tet part 1'
       l41=-eeq(1)/(eeq(4)-eeq(1))
       l42=-eeq(2)/(eeq(4)-eeq(2))
       l43=-eeq(3)/(eeq(4)-eeq(3))
       If(lq0)Then
          e41=1.0_t_real/(eeq(4)-eeq(1))
          e42=1.0_t_real/(eeq(4)-eeq(2))
          e43=1.0_t_real/(eeq(4)-eeq(3))
          f=e41*(1.0_t_real-l42)*(1.0_t_real-l43)&
               &+(1.0_t_real-l41)*e42*(1.0_t_real-l43)&
               &+(1.0_t_real-l41)*(1.0_t_real-l42)*e43
          res=res+vt*f/6.0_t_real
       Else
          
          neeq(1)=eeq(1)
          neeq(2)=0.0_t_real
          neeq(3)=0.0_t_real
          neeq(4)=0.0_t_real
          
          neek(1)=eek(1)
          neek(2)=eek(3)+(eek(4)-eek(3))*l43
          neek(3)=eek(2)+(eek(4)-eek(2))*l42
          neek(4)=eek(1)+(eek(4)-eek(1))*l41
          
          f=l41*(1.0_t_real-l42)*(1.0_t_real-l43)
          
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,1.0_t_real,tol,delta,reim)
          
          Print *,'1-corner empty q-tet part 2'
          neeq(1)=eeq(1)
          neeq(2)=0.0_t_real
          neeq(3)=0.0_t_real
          neeq(4)=eeq(3)
          
          neek(1)=eek(1)
          neek(2)=eek(3)+(eek(4)-eek(3))*l43
          neek(3)=eek(2)+(eek(4)-eek(2))*l42
          neek(4)=eek(3)
          
          f=(1.0_t_real-l42)*l43
          
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,1.0_t_real,tol,delta,reim)
          
          Print *,'1-corner empty q-tet part 3'
          
          neeq(1)=eeq(1)
          neeq(2)=eeq(2)
          neeq(3)=0.0_t_real
          neeq(4)=eeq(3)
          
          neek(1)=eek(1)
          neek(2)=eek(2)
          neek(3)=eek(2)+(eek(4)-eek(2))*l42
          neek(4)=eek(3)
          
          f=l42
          
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,1.0_t_real,tol,delta,reim)
          
          Print *,'1-corner empty q-tet full part'
          
          f=(1.0_t_real-l41)*(1.0_t_real-l42)*(1.0_t_real-l43)
          
          neeq(1)=0.0_t_real
          neeq(2)=0.0_t_real
          neeq(3)=0.0_t_real
          neeq(4)=eeq(4)
          
          neek(1)=eek(1)+(eek(4)-eek(1))*l41
          neek(2)=eek(2)+(eek(4)-eek(2))*l42
          neek(3)=eek(3)+(eek(4)-eek(3))*l43
          neek(4)=eek(4)
          
          Call lind2tet_stage2(w,neek,neeq,res,vt*f,-1.0_t_real,tol,delta,reim)
          
       Endif
    Else If(eeq(4)<0.0_t_real)Then
       !! full q-tet
       Print *,'full q-tet'
       Call lind2tet_stage2(w,eek,eeq,res,vt,1.0_t_real,tol,delta,reim)
    Endif
    !!
    Return
    !!
  End Subroutine lind2tet
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lind2tetNest(eek0,eeq0,res,vt)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: eek0(4),eeq0(4),vt
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lind2tetNest"
!!$    Logical(t_log) :: lq0 !! q=0 limit: all eek(i)=eeq(i)
    Integer(t_int) :: i,j
    Real(t_real)   :: eek(4),eeq(4),dum,l21,l31,l41,l32,l42,f,l43
    Real(t_real)   :: e21,e31,e32,e41,e42,e43,d
    Real(t_real)   :: neek(4),neeq(4)
!!$    !!
    eek=eek0
    eeq=eeq0
    !!
!!$    lq0=.False.
!!$    If(All(Abs(eek(1:4)-eeq(1:4))<tol))Then
!!$       If(Abs(w)<1.0e-10_t_real) Then
!!$          lq0=.True.
!!$       Else
!!$          res=0.0_t_real
!!$          Return
!!$       Endif
!!$    Endif
!!$    !!
    Do i=1,4
       Do j=i+1,4
          If(eek(j)<eek(i))Then
             dum=eeq(j)
             eeq(j)=eeq(i)
             eeq(i)=dum
             dum=eek(j)
             eek(j)=eek(i)
             eek(i)=dum
          Endif
       Enddo
    Enddo
    !!
    !!
    If(0.0_t_real<=eek(1))Then
       !! empty k-tet
       
    Else If(eek(1)<0.0_t_real .And. 0.0_t_real<=eek(2))Then
       !! 1-corner k-tet
       Print *,'1-corner full k-tet'
       l21=-eek(1)/(eek(2)-eek(1))
       l31=-eek(1)/(eek(3)-eek(1))
       l41=-eek(1)/(eek(4)-eek(1))

       e21=1.0_t_real/(eek(2)-eek(1))
       e31=1.0_t_real/(eek(3)-eek(1))
       e41=1.0_t_real/(eek(4)-eek(1))
       !f=e21*l31*l41+l21*e31*l41+l21*l31*e41

       neek(1)=eek(1)
       neek(2)=0.0_t_real
       neek(3)=0.0_t_real
       neek(4)=0.0_t_real
       
       neeq(1)=eeq(1)
       neeq(2)=eeq(1)+l21*(eeq(2)-eeq(1))
       neeq(3)=eeq(1)+l31*(eeq(3)-eeq(1))
       neeq(4)=eeq(1)+l41*(eeq(4)-eeq(1))

       f=eek(1)**2*e21*e31*e41
       Call lindfulltet3nesting(neek,neeq,d)
       res=res+vt*f*d
       
    Else If(eek(2)<0.0_t_real .And. 0.0_t_real<=eek(3))Then
       Print *,'2-corner full k-tet part 1'
       !!
       l31=-eek(1)/(eek(3)-eek(1))
       l32=-eek(2)/(eek(3)-eek(2))
       l41=-eek(1)/(eek(4)-eek(1))
       l42=-eek(2)/(eek(4)-eek(2))
       
       e31=1.0_t_real/(eek(3)-eek(1))
       e32=1.0_t_real/(eek(3)-eek(2))
       e41=1.0_t_real/(eek(4)-eek(1))
       e42=1.0_t_real/(eek(4)-eek(2))
       
       f=e41*l31*(1.0_t_real-l42)+l41*e31*(1.0_t_real-l42)-l41*l31*e42
       neek(1)=0.0_t_real
       neek(2)=eek(1)
       neek(3)=0.0_t_real
       neek(4)=0.0_t_real
       
       neeq(1)=eeq(1)+(eeq(3)-eeq(1))*l31
       neeq(2)=eeq(1)
       neeq(3)=eeq(1)+(eeq(4)-eeq(1))*l41
       neeq(4)=eeq(2)+(eeq(4)-eeq(2))*l42
       !Call lindfulltet3nesting(neek,neeq,d)
       !res=res+vt*f/6.0_t_real!*d
       

       f=e31*l42*(1.0_t_real-l32)+l31*e42*(1.0_t_real-l32)-l31*l42*e32
       
       neek(1)=0.0_t_real
       neek(2)=0.0_t_real
       neek(3)=0.0_t_real
       neek(4)=eek(1)
       
       neeq(1)=eeq(2)+(eeq(3)-eeq(2))*l32
       neeq(2)=eeq(2)+(eeq(4)-eeq(2))*l42
       neeq(3)=eeq(1)+(eeq(3)-eeq(1))*l31
       neeq(4)=eeq(1)
            
       !Call lindfulltet3nesting(neek,neeq,d)
       !res=res+vt*f/6.0_t_real!*d

       f=e32*l42+l32*e42
       
       neek(1)=0.0_t_real
       neek(2)=eek(2)
       neek(3)=eek(1)
       neek(4)=0.0_t_real
       
       neeq(1)=eeq(2)+(eeq(4)-eeq(2))*l42
       neeq(2)=eeq(2)
       neeq(3)=eeq(1)
       neeq(4)=eeq(2)+(eeq(3)-eeq(2))*l32

       !Call lindfulltet3nesting(neek,neeq,d)
       !res=res+vt*f/6.0_t_real!*d

    Else If(eek(3)<0.0_t_real .And. 0.0_t_real<=eek(4))Then
       !! 1-corner k-tet
       Print *,'1-corner empty k-tet part 1'
       l41=-eek(1)/(eek(4)-eek(1))
       l42=-eek(2)/(eek(4)-eek(2))
       l43=-eek(3)/(eek(4)-eek(3))
!!$       If(lq0)Then
       e41=1.0_t_real/(eek(4)-eek(1))
       e42=1.0_t_real/(eek(4)-eek(2))
       e43=1.0_t_real/(eek(4)-eek(3))
       
       neek(1)=eek(1)
       neek(2)=0.0_t_real
       neek(3)=0.0_t_real
       neek(4)=0.0_t_real
       
       neeq(1)=eeq(1)
       neeq(2)=eeq(3)+(eeq(4)-eeq(3))*l43
       neeq(3)=eeq(2)+(eeq(4)-eeq(2))*l42
       neeq(4)=eeq(1)+(eeq(4)-eeq(1))*l41
       
       f=e41*(1.0_t_real-l42)*(1.0_t_real-l43)-l41*e42*(1.0_t_real-l43)&
            &-l41*(1.0_t_real-l42)*e43
       
       !Call lindfulltet3nesting(neek,neeq,d)
       !res=res+vt*f/6.0_t_real!*d


       neek(1)=eek(1)
       neek(2)=0.0_t_real
       neek(3)=0.0_t_real
       neek(4)=eek(3)
       
       neeq(1)=eeq(1)
       neeq(2)=eeq(3)+(eeq(4)-eeq(3))*l43
       neeq(3)=eeq(2)+(eeq(4)-eeq(2))*l42
       neeq(4)=eeq(3)
       
       f=-e42*l43+(1.0_t_real-l42)*e43
       !Call lindfulltet3nesting(neek,neeq,d)
       !res=res+vt*f/6.0_t_real!*d

       neek(1)=eek(1)
       neek(2)=eek(2)
       neek(3)=0.0_t_real
       neek(4)=eek(3)
       
       neeq(1)=eeq(1)
       neeq(2)=eeq(2)
       neeq(3)=eeq(2)+(eeq(4)-eeq(2))*l42
       neeq(4)=eeq(3)
       
       f=e42
       !Call lindfulltet3nesting(neek,neeq,d)
       !res=res+vt*f/6.0_t_real!*d
          

    Endif
    !!
    Return
    !!
  End Subroutine lind2tetNest
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lind2tet_stage2(w,eek0,eeq0,res,vt,th,tol,delta,reim)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: reim
    Real(t_real),Intent(in)      :: w,eek0(4),eeq0(4),vt,th,tol,delta
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lind2tet_stage2"
    Integer(t_int) :: i,j
    Real(t_real)   :: eek(4),eeq(4),dum,l21,l31,l41,f,l43,l32,l42,d
    Real(t_real)   :: neek(4),neeq(4)
    !!
    eek=eek0
    eeq=eeq0
    !!
    !!
    Do i=1,4
       Do j=i+1,4
          If(eek(j)<eek(i))Then !!todo
             dum=eeq(j)
             eeq(j)=eeq(i)
             eeq(i)=dum
             dum=eek(j)
             eek(j)=eek(i)
             eek(i)=dum
          Endif
       Enddo
    Enddo
    !!
    If(0.0_t_real<=eek(1))Then
       !! empty k-tet

       If(th>0.0_t_real)Then
          Print *,'KKK: empty k-tet'
          Call lindfulltet3drealstatic(w,eek,eeq,tol,delta,d,reim)
          res=res+vt*d
       Endif
    Else If(eek(1)<0.0_t_real .and. 0.0_t_real<=eek(2))Then
       !! 1-corner k-tet
       l21=-eek(1)/(eek(2)-eek(1))
       l31=-eek(1)/(eek(3)-eek(1))
       l41=-eek(1)/(eek(4)-eek(1))
       If(th<0.0_t_real)Then
          Print *,'KKK: 1-corner full k-tet'
          f=l21*l31*l41
          neek(1)=eek(1)
          neek(2)=0.0_t_real
          neek(3)=0.0_t_real
          neek(4)=0.0_t_real

          neeq(1)=eeq(1)
          neeq(2)=eeq(1)+(eeq(2)-eeq(1))*l21
          neeq(3)=eeq(1)+(eeq(3)-eeq(1))*l31
          neeq(4)=eeq(1)+(eeq(4)-eeq(1))*l41
          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          !Print *,'ddd',d
          !d=0.0_t_real
          res=res-vt*f*d
       Else
          Print *,'KKK: 1-corner full k-tet empty part 1'

          neek(1)=0.0_t_real
          neek(2)=0.0_t_real
          neek(3)=0.0_t_real
          neek(4)=eek(4)

          neeq(1)=eeq(1)+(eeq(4)-eeq(1))*l41
          neeq(2)=eeq(1)+(eeq(3)-eeq(1))*l31
          neeq(3)=eeq(1)+(eeq(2)-eeq(1))*l21
          neeq(4)=eeq(4)

          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=l21*l31*(1.0_t_real-l41)
          res=res+vt*f*d

          neek(1)=eek(3)
          neek(2)=0.0_t_real
          neek(3)=0.0_t_real
          neek(4)=eek(4)

          neeq(1)=eeq(3)
          neeq(2)=eeq(1)+(eeq(3)-eeq(1))*l31
          neeq(3)=eeq(1)+(eeq(2)-eeq(1))*l21
          neeq(4)=eeq(4)

          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=l21*(1.0_t_real-l31)
          res=res+vt*f*d

          
          neek(1)=eek(3)
          neek(2)=eek(2)
          neek(3)=0.0_t_real
          neek(4)=eek(4)


          neeq(1)=eeq(3)
          neeq(2)=eeq(2)
          neeq(3)=eeq(1)+(eeq(2)-eeq(1))*l21
          neeq(4)=eeq(4)

          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=(1.0_t_real-l21)
          res=res+vt*f*d
          

       Endif
    Else If(eek(2)<0.0_t_real .And. 0.0_t_real<=eek(3))Then
       !!
       l31=-eek(1)/(eek(3)-eek(1))
       l32=-eek(2)/(eek(3)-eek(2))
       l41=-eek(1)/(eek(4)-eek(1))
       l42=-eek(2)/(eek(4)-eek(2))
       If(th<0.0_t_real)Then
          Print *,'KKK: 2-corner full k-tet'
          
          neek(1)=0.0_t_real
          neek(2)=eek(1)
          neek(3)=0.0_t_real
          neek(4)=0.0_t_real


          neeq(1)=eeq(1)+(eeq(3)-eeq(1))*l31
          neeq(2)=eeq(1)
          neeq(3)=eeq(1)+(eeq(4)-eeq(1))*l41
          neeq(4)=eeq(2)+(eeq(4)-eeq(2))*l42

          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=l41*l31*(1.0_t_real-l42)
          res=res-vt*f*d
          !!

          neek(1)=0.0_t_real
          neek(2)=0.0_t_real
          neek(3)=0.0_t_real
          neek(4)=eek(1)
          
          neeq(1)=eeq(2)+(eeq(3)-eeq(2))*l32
          neeq(2)=eeq(2)+(eeq(4)-eeq(2))*l42
          neeq(3)=eeq(1)+(eeq(3)-eeq(1))*l31
          neeq(4)=eeq(1)
          
          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=l31*l42*(1.0_t_real-l32)
          res=res-vt*f*d
          !!
          neek(1)=0.0_t_real
          neek(2)=eek(2)
          neek(3)=eek(1)
          neek(4)=0.0_t_real
          
          neeq(1)=eeq(2)+(eeq(4)-eeq(2))*l42
          neeq(2)=eeq(2)
          neeq(3)=eeq(1)
          neeq(4)=eeq(2)+(eeq(3)-eeq(2))*l32
          
          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=l32*l42
          res=res-vt*f*d
       Else
          Print *,'KKK: 2-corner empty k-tet'
          
          neek(1)=0.0_t_real
          neek(2)=0.0_t_real
          neek(3)=0.0_t_real
          neek(4)=eek(3)
          
          neeq(1)=eeq(2)+(eeq(3)-eeq(2))*l32
          neeq(2)=eeq(2)+(eeq(4)-eeq(2))*l42
          neeq(3)=eeq(1)+(eeq(3)-eeq(1))*l31
          neeq(4)=eeq(3)

          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=l42*(1.0_t_real-l32)*(1.0_t_real-l31)
          res=res+vt*f*d
          !!
          
          neek(1)=0.0_t_real
          neek(2)=eek(3)
          neek(3)=0.0_t_real
          neek(4)=0.0_t_real
          
          neeq(1)=eeq(1)+(eeq(3)-eeq(1))*l31
          neeq(2)=eeq(3)
          neeq(3)=eeq(1)+(eeq(4)-eeq(1))*l41
          neeq(4)=eeq(2)+(eeq(4)-eeq(2))*l42
          
          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=l41*(1.0_t_real-l31)*(1.0_t_real-l42)
          res=res+vt*f*d
          !!

          neek(1)=eek(3)
          neek(2)=0.0_t_real
          neek(3)=0.0_t_real
          neek(4)=eek(4)
          
          neeq(1)=eeq(3)
          neeq(2)=eeq(1)+(eeq(4)-eeq(1))*l41
          neeq(3)=eeq(2)+(eeq(4)-eeq(2))*l42
          neeq(4)=eeq(4)
          
          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=(1.0_t_real-l41)*(1.0_t_real-l42)
          res=res+vt*f*d
       Endif
       !!
    Else If(eek(3)<0.0_t_real .And. 0.0_t_real<=eek(4))Then
       !! 1-corner k-tet
       l41=-eek(1)/(eek(4)-eek(1))
       l42=-eek(2)/(eek(4)-eek(2))
       l43=-eek(3)/(eek(4)-eek(3))
       If(th<0.0_t_real)Then
          Print *,'KKK: 1-corner empty k-tet full part'

          neek(1)=eek(1)
          neek(2)=0.0_t_real
          neek(3)=0.0_t_real
          neek(4)=0.0_t_real
          
          neeq(1)=eeq(1)
          neeq(2)=eeq(3)+(eeq(4)-eeq(3))*l43
          neeq(3)=eeq(2)+(eeq(4)-eeq(2))*l42
          neeq(4)=eeq(1)+(eeq(4)-eeq(1))*l41
          
          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=l41*(1.0_t_real-l42)*(1.0_t_real-l43)
          res=res-vt*f*d
          !!
          neek(1)=eek(1)
          neek(2)=0.0_t_real
          neek(3)=0.0_t_real
          neek(4)=eek(3)
          
          neeq(1)=eeq(1)
          neeq(2)=eeq(3)+(eeq(4)-eeq(3))*l43
          neeq(3)=eeq(2)+(eeq(4)-eeq(2))*l42
          neeq(4)=eeq(3)
          
          
          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=(1.0_t_real-l42)*l43
          res=res-vt*f*d
          
          neek(1)=eek(1)
          neek(2)=eek(2)
          neek(3)=0.0_t_real
          neek(4)=eek(3)
          
          neeq(1)=eeq(1)
          neeq(2)=eeq(2)
          neeq(3)=eeq(2)+(eeq(4)-eeq(2))*l42
          neeq(4)=eeq(3)
          
          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=l42
          res=res-vt*f*d

       Else
          Print *,'KKK: 1-corner empty k-tet empty part'
          
          neek(1)=0.0_t_real
          neek(2)=0.0_t_real
          neek(3)=0.0_t_real
          neek(4)=eek(4)

          neeq(1)=eeq(1)+(eeq(4)-eeq(1))*l41
          neeq(2)=eeq(2)+(eeq(4)-eeq(2))*l42
          neeq(3)=eeq(3)+(eeq(4)-eeq(3))*l43
          neeq(4)=eeq(4)
          
          Call lindfulltet3drealstatic(w,neek,neeq,tol,delta,d,reim)
          f=(1.0_t_real-l41)*(1.0_t_real-l42)*(1.0_t_real-l43)
          res=res+vt*f*d
       Endif
    Else If(eek(4)<0.0_t_real)Then
       !! full k-tet
       If(th<0.0_t_real)Then
          Print *,'KKK: full k-tet'
          Call lindfulltet3drealstatic(w,eek,eeq,tol,delta,d,reim)
          res=res-vt*d
       Endif
    Endif
    !!
    !!
    Return
    !!
  End Subroutine lind2tet_stage2
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lindfulltet3nesting(eek0,eeq0,res)
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: eek0(4),eeq0(4)
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lindfulltet3nesting"
    Real(t_real)   :: eek(4),eeq(4),d1,d2,d3,d4,D21,D31,D41,D32,D42,D43
    !!
    eek=eek0
    eeq=eeq0
    d1=eek(1)-eeq(1)
    d2=eek(2)-eeq(2)
    d3=eek(3)-eeq(3)
    d4=eek(4)-eeq(4)
    !!
    D21=d2-d1
    D31=d3-d1
    D32=d3-d2
    D41=d4-d1
    D42=d4-d2
    D43=d4-d3
    !!
    Print "('DDD',6f16.7)",D21,D31,D32,D41,D42,D43
    !!
    res=pi*(&
         &+theta(d2)*d2/(D32*D42)&
         &+theta(d3)*d3/(-D32*D43)&
         &+theta(d4)*d3/(D42*D43)&
         &)
    !!
    !!
!!$    res=-0.5_t_real*pi*(&
!!$         & theta(d1)*d1**2/(D21*D31*D41)&
!!$         &+theta(d2)*d2**2/(-D21*D32*D42)&
!!$         &+theta(d3)*d3**2/(D31*D32*D43)&
!!$         &+theta(d4)*d4**2/(-D41*D42*D43)&
!!$         &)
    !!
    Return
  End Subroutine lindfulltet3nesting
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lindfulltet3drealstatic(w,eek0,eeq0,tol,delta,res,reim)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: reim
    Real(t_real),Intent(in)      :: w,eek0(4),eeq0(4),tol,delta
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lindfulltet3drealstatic"
    Real(t_real)   :: eek(4),eeq(4),d1,d2,d3,d4,D21,D31,D41,D32,D42,D43
    !!
    eek=eek0
    eeq=eeq0

    d1=eek(1)-eeq(1)
    d2=eek(2)-eeq(2)
    d3=eek(3)-eeq(3)
    d4=eek(4)-eeq(4)
    !!
    D21=d2-d1
    D31=d3-d1
    D32=d3-d2
    D41=d4-d1
    D42=d4-d2
    D43=d4-d3
    !!
    Print "('DDD',6f16.7)",D21,D31,D32,D41,D42,D43
    !!
    If(Abs(D21)<tol)Then
       Call lft_1D0(w,d1,d3,d4,D31,D41,D43,tol,delta,res,reim)
    Else If(Abs(D31)<tol)Then
       Call lft_1D0(w,d1,d2,d4,D21,D41,D42,tol,delta,res,reim)
    Else If(Abs(D32)<tol)Then
       Call lft_1D0(w,d3,d1,d4,-D31,D43,D41,tol,delta,res,reim)
    Else If(Abs(D41)<tol)Then
       Call lft_1D0(w,d1,d3,d2,D31,D21,-D32,tol,delta,res,reim)
    Else If(Abs(D42)<tol)Then
       Call lft_1D0(w,d4,d3,d1,-D43,-D41,-D31,tol,delta,res,reim)
    Else If(Abs(D43)<tol)Then
       Call lft_1D0(w,d3,d1,d2,-D31,-D32,D21,tol,delta,res,reim)
    Else
       If(reim==1)Then
          res=&
               &-log2(-w+d1)/(D21*D31*D41)&
               &-log2(-w+d2)/(-D21*D32*D42)&
               &-log2(-w+d3)/(D31*D32*D43)&
               &-log2(-w+d4)/(-D41*D42*D43)
       Else If(reim==2)Then
          res=( &
               & (w-d1)**2*theta(w-d1)/(D21*D31*D41)&
               &+(w-d2)**2*theta(w-d2)/(-D21*D32*D42)&
               &+(w-d3)**2*theta(w-d3)/(D31*D32*D43)&
               &+(w-d4)**2*theta(w-d4)/(-D41*D42*D43)&
               &)*0.5_t_real*pi
       Endif
    Endif
    !!
    !!
    Return
    !!
  End Subroutine lindfulltet3drealstatic
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lft_1D0(w,d1,d3,d4,D31,D41,D43,tol,delta,res,reim)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: reim
    Real(t_real),Intent(in)      :: w,D31,D41,D43,d1,d3,d4,tol,delta
    Real(t_real),Intent(out)   :: res
    !!LOCAL
    Character(*),Parameter::nsubfunc="lft_1D0"
    !!
    Print *,nsubfunc
    If(Abs(D31)<tol)Then
       Call lft_2D0(w,d1,d4,D41,tol,delta,res,reim)
    Else If(Abs(D41)<tol)Then
       Call lft_2D0(w,d1,d3,D31,tol,delta,res,reim)
    Else If(Abs(D43)<tol)Then
       Call lft_2D0_2(w,d1,d4,D41,tol,delta,res,reim)
    Else
       !!
       If(reim==1)Then
          res=&
               &+(log2(-w+d1)*(1.0_t_real/D41+1.0_t_real/D31)+log1(-w+d1))/(D31*D41)&
               &-log2(-w+d3)/(D31**2*D43)&
               &-log2(-w+d4)/(-D41**2*D43)
       Else If(reim==2)Then
          res=( &
               & theta(w-d1)/D31/D41*(2.0_t_real*(w-d1)&
               &    -(w-d1)**2*(1.0_t_real/D41+1.0_t_real/D31))&
               &+(w-d3)**2*theta(w-d3)/(D31**2*D43)&
               &+(w-d4)**2*theta(w-d4)/(-D41**2*D43)&
               &)*0.5_t_real*pi
          
       Endif
    Endif
    !!
    Return
    !!
  End Subroutine lft_1D0
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lft_2D0(w,d1,d4,D41,tol,delta,res,reim)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: reim
    Real(t_real),Intent(in)      :: w,D41,d1,d4,tol,delta
    Real(t_real),Intent(out)   :: res
    !!LOCAL
    Character(*),Parameter::nsubfunc="lft_2D0"
    Real(t_real)   :: f2,f3
    !!
    If(Abs(D41)<tol)Then
       Print *,nsubfunc,'DDD'
       If(reim==1)Then
          If(Abs(d1-w)>tol)Then
             res=1.0_t_real/(6.0_t_real*(d1-w))
          Else
             res=0.0_t_real
          Endif
       Else If(reim==2)Then
          res=delta/((d1-w)**2+delta**2)
       Endif
    Else
       Print *,nsubfunc,'DD'
       If(reim==1)Then
          f2=1.0_t_real/(D41*D41)
          f3=f2/D41
          !!
          res=-f3*log2(-w+d1)-f2*log1(-w+d1)-0.5_t_real*Log0(-w+d1)/D41&
               &+log2(-w+d4)*f3
       Else If(reim==2)Then
          res=(theta(w-d1)-theta(w-d4))*(w-d4)**2/D41**3*0.5_t_real*pi
       Endif

    Endif
    !!
    Print *,res
    Return
    !!
  End Subroutine lft_2D0
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lft_2D0_2(w,d1,d4,D41,tol,delta,res,reim)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: reim
    Real(t_real),Intent(in)      :: w,D41,d1,d4,tol,delta
    Real(t_real),Intent(out)   :: res
    !!LOCAL
    Character(*),Parameter::nsubfunc="lft_2D0_2"
    Real(t_real)   :: f2,f3
    !!
    If(Abs(D41)<tol)Then
       Print *,nsubfunc,'DDD'
       If(reim==1)Then
          If(Abs(d1-w)>tol)Then
             res=1.0_t_real/(6.0_t_real*(d1-w))
          Else
             res=0.0_t_real
          Endif
       Else If(reim==2)Then
          res=delta/((d1-w)**2+delta**2)
       Endif
    Else
       Print *,nsubfunc,'DD'
       If(reim==1)Then
          f2=1.0_t_real/(D41*D41)
          f3=2.0_t_real*f2/D41
          !!
          res=f2*log1(-w+d1)+f3*log2(-w+d1)-f3*log2(-w+d4)+f2*log1(-w+d4)
       Else If(reim==2)Then
          res=(theta(w-d4)-theta(w-d1))*(w-d1)*(w-d4)/D41**3*pi
       Endif

    Endif
    !!
    Print *,res
    !!
    Return
    !!
  End Subroutine lft_2D0_2
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lindtet3drealstatic(eek0,eeq0,delta,res)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: eek0(4),eeq0(4)
    Real(t_real),Intent(in)      :: delta
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lindtet3drealstatic"
    Integer(t_int) :: i,k,j,JJ,ii
    Logical(t_log) :: lq,lk
    Real(t_real)   :: pd,d(4),l2di,f,sq,sk,Di(4),dqi(4)
    Real(t_real)   :: dki(4),eek(4),eeq(4),eek1(4),eeq1(4)
    Real(t_real),Parameter :: tol=1.0e-4_t_real
    !!
    eek1=eek0
    eeq1=eeq0
    !!
    Call fixerg(eek1,eeq1,tol)
    !!
    Do ii=1,4
       !Print *,Mod(i-1,4)+1,Mod(i+0,4)+1,Mod(i+1,4)+1,Mod(i+2,4)+1
       i=1
       Do j=1,4
          eek(j)=eek1(Mod(j-2+ii,4_t_int)+1)
          eeq(j)=eeq1(Mod(j-2+ii,4_t_int)+1)
       Enddo
       Call lt3drs_i2(ii,eek,eeq,res)
    Enddo
    !!
    Return
    !!
    eek=eek0
    eeq=eeq0
    Do i=1,4
       d(i)=eek(i)-eeq(i)
    Enddo
    !!
    Do ii=1,4
       !Print *,Mod(i-1,4)+1,Mod(i+0,4)+1,Mod(i+1,4)+1,Mod(i+2,4)+1
       i=1
       Do j=1,4
          eek(j)=eek0(Mod(j-2+ii,4_t_int)+1)
          eeq(j)=eeq0(Mod(j-2+ii,4_t_int)+1)
!!$          d(j)=eek(j)-eeq(j)
       Enddo
       Call lt3drs_i(ii,eek,eeq,res)
       Cycle

       i=ii
       lq=(0.0_t_real>=eeq(i))
       lk=(0.0_t_real>=eek(i))
       Write(outfile,"('terms',i5,l5,l5)")i,lq,lk
       If(lq.Or.lk)Then
          l2di=Real(clog2(d(i),delta),t_real)
          pd=-1.0_t_real
          JJ=-1
          Do j=1,4
             If(j==i) Cycle
             Di(j)=d(j)-d(i)
             If( Abs(Di(j))<tol)Then
                JJ=j
             Endif
             dqi(j)=eeq(j)-eeq(i)
             dki(j)=eek(j)-eek(i)
             pd=pd*Di(j)
          Enddo
          If(JJ<0) Then
             l2di=l2di/pd
          Else
             l2di=0.0_t_real
          Endif


          sq=0.0_t_real
          sk=0.0_t_real
          Do j=1,4
             If(j==i.Or.j==JJ) Cycle
             f=Di(j)
             Do k=1,4
                If(k==i.Or.k==j) Cycle
                If(k==JJ)Then
                   f=f*dqi(JJ)*Di(j)
                Else
                   f=f*(dqi(k)*dki(j)-dqi(j)*dki(k))
                Endif
             Enddo
             Write(outfile,"(3i3,4f20.10)")j,i,JJ,Di(j),f,dqi(j),dki(j)
             !If(Abs(f)<tol) Cycle

             If(lq) sq=sq+dqi(j)**2*Real(clog2(d(i)+Di(j)*(-eeq(i))/dqi(j),delta),t_real)/f
             If(lk) sk=sk+dki(j)**2*Real(clog2(d(i)+Di(j)*(-eek(i))/dki(j),delta),t_real)/f
          Enddo
          !Print *,pd,l2di
          If(lq) res=res+(l2di+sq)
          If(lk) res=res-(l2di+sk)
       Endif
    Enddo
    !!
    Return
    !!
    Return
    !!
  End Subroutine lindtet3drealstatic
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine fixerg(eek,eeq,tol)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: tol
    Real(t_real),Intent(inout)   :: eek(4),eeq(4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="fixerg"
    Logical(t_log) :: dchanged,kchanged,qchanged,changed
    Integer(t_int) :: i,j
    Real(t_real)   :: d(4)
    !!
    !!
    kchanged=.True.
    Do While(kchanged)
       kchanged=.False.
       Do i=1,4
          Do j=i+1,4
             If(Abs(eek(j)-eek(i))<tol)Then
                eek(j)=eek(j)+tol
                kchanged=.True.
             Endif
          Enddo
       Enddo
    Enddo
    !!
    !! here eek is fixed
    !!
    changed=.True.
    Do While(changed)
       Do i=1,4
          d(i)=eek(i)-eeq(i)
       Enddo
       !!
       dchanged=.True.
       Do While(dchanged)
          dchanged=.False.
          Do i=1,4
             If(Abs(d(i))<tol)Then
                d(i)=d(i)+tol
                dchanged=.True.
             Endif
          Enddo
          Do i=1,4
             Do j=i+1,4
                If(Abs(d(i)-d(j))<tol)Then
                   d(j)=d(j)+tol
                   dchanged=.True.
                Endif
             Enddo
          Enddo
       Enddo
       !!
       Do i=1,4
          eeq(i)=eek(i)-d(i)
       Enddo
       !!
       qchanged=.True.
       Do While(qchanged)
          qchanged=.False.
          Do i=1,4
             Do j=i+1,4
                !Print "('check dq',i1,i1,' : ',f30.15)",j,i,(eeq(j)-eeq(i))
                If(Abs(eeq(j)-eeq(i))<tol)Then
                   eeq(j)=eeq(j)+tol
                   !Print "('now dq',i1,i1,' : ',f30.15)",j,i,(eeq(j)-eeq(i))
                   qchanged=.True.
                Endif
             Enddo
          Enddo
       Enddo
       !!
       changed=(dchanged.Or.qchanged)
       !!
    Enddo
    !!
    Do i=1,4
       Do j=i+1,4
          !Print "('FIXED dq',i1,i1,' : ',f30.15)",j,i,(eeq(j)-eeq(i))
       Enddo
    Enddo
    !!
!!$    achanged=.True.
!!$    achanged=.False.
!!$    If(Abs(A2010)<tol)Then
!!$       !eeq(1)=
!!$       achanged=.True.
!!$       
!!$    Endif
    !!
    !!
    Return
    !!
  End Subroutine fixerg
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lt3drs_i2(ii,eek,eeq,res)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: ii
    Real(t_real),Intent(in)      :: eek(4),eeq(4)
    Real(t_real),Intent(inout)   :: res
    !!LOCAL
    Logical(t_log) :: lq,lk,lqk
    !Character(*),Parameter::nsubfunc="lt3drs_i2"
    Real(t_real)   :: l2di,sq,sk,f,d1,D21,D31,D41!,gq,gk,d2,d3,d4
    Real(t_real)   :: dq21,dq31,dq41,dk21,dk31,dk41
    Real(t_real)   :: A3121,A4121,A4131
    !Real(t_real),Parameter :: tol=1.0e-2_t_real !!todo
    !!
    !!
    !!
    lq=(0.0_t_real>=eeq(1))
    lk=(0.0_t_real>=eek(1))
    lqk=lq.And.lk
    Write(outfile,"('terms',i5,l5,l5)")ii,lq,lk
    If(.Not.(lq.Or.lk))Return
    
    d1=eek(1)-eeq(1)
    !d2=eek(2)-eeq(2)
    !d3=eek(3)-eeq(3)
    !d4=eek(4)-eeq(4)

    

    dq21=eeq(2)-eeq(1)
    dq31=eeq(3)-eeq(1)
    dq41=eeq(4)-eeq(1)
    dk21=eek(2)-eek(1)
    dk31=eek(3)-eek(1)
    dk41=eek(4)-eek(1)

    D21=dk21-dq21
    D31=dk31-dq31
    D41=dk41-dq41
    

    Print "('DDD',3f30.15)",D21,D31,D41

    sq=0.0_t_real
    sk=0.0_t_real

    A3121=(dq31*dk21-dq21*dk31)
    A4121=(dq41*dk21-dq21*dk41)
    A4131=(dq41*dk31-dq31*dk41)

    Print *,'dq21',dq21
    Print *,'dq31',dq31
    Print *,'dq41',dq41
    
    l2di=log2(d1)/(-D21*D31*D41)
    
    f=D21
    f=f*A3121
    f=f*A4121
    Write(outfile,"(2i3,4f20.10)")2,1,D21,f
    
    If(lq) sq=sq+dq21**2*log2(d1-D21*eeq(1)/dq21)/f
    If(lk) sk=sk+dk21**2*log2(d1-D21*eek(1)/dk21)/f
    
    f=D31
    f=-f*A3121
    f=f*A4131
    Write(outfile,"(2i3,4f20.10)")3,1,D31,f
    
    If(lq) sq=sq+dq31**2*log2(d1-D31*eeq(1)/dq31)/f
    If(lk) sk=sk+dk31**2*log2(d1-D31*eek(1)/dk31)/f
    
    f=D41
    f=f*A4121
    f=f*A4131
    Write(outfile,"(2i3,5f20.10)")4,1,D41,f,(-D41*eeq(1)/dq41)
    
    If(lq) sq=sq+dq41**2*log2(d1-D41*eeq(1)/dq41)/f
    If(lk) sk=sk+dk41**2*log2(d1-D41*eek(1)/dk41)/f
    
    !Print *,pd,l2di
    If(lq) res=res+(l2di+sq)
    If(lk) res=res-(l2di+sk)
    Print *,'SSS',l2di,sq,sk
    !!
    Return
    !!
  End Subroutine lt3drs_i2
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lt3drs_i(ii,eek,eeq,res)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: ii
    Real(t_real),Intent(in)      :: eek(4),eeq(4)
    Real(t_real),Intent(inout)   :: res
    !!LOCAL
    Logical(t_log) :: lq,lk,lqk
    !Character(*),Parameter::nsubfunc="lt3drs_i"
    Real(t_real)   :: l2di,sq,sk,f,d1,D21,D31,D41!,gq,gk,d2,d3,d4
    Real(t_real)   :: dq21,dq31,dq41,dk21,dk31,dk41
    Real(t_real)   :: A3121,A4121,A4131
    Real(t_real),Parameter :: tol=1.0e-2_t_real !!todo
    !!
    !!
    !!
    lq=(0.0_t_real>=eeq(1))
    lk=(0.0_t_real>=eek(1))
    lqk=lq.And.lk
    Write(outfile,"('terms',i5,l5,l5)")ii,lq,lk
    If(.Not.(lq.Or.lk))Return
    
    d1=eek(1)-eeq(1)
    !d2=eek(2)-eeq(2)
    !d3=eek(3)-eeq(3)
    !d4=eek(4)-eeq(4)

    

    dq21=eeq(2)-eeq(1)
    dq31=eeq(3)-eeq(1)
    dq41=eeq(4)-eeq(1)
    dk21=eek(2)-eek(1)
    dk31=eek(3)-eek(1)
    dk41=eek(4)-eek(1)

    D21=dk21-dq21
    D31=dk31-dq31
    D41=dk41-dq41
    

    Print "('DDD',3f30.15)",D21,D31,D41

    sq=0.0_t_real
    sk=0.0_t_real

    A3121=(dq31*dk21-dq21*dk31)
    A4121=(dq41*dk21-dq21*dk41)
    A4131=(dq41*dk31-dq31*dk41)


    If(Abs(D21)<tol)Then
       !!
       !!
       If(Abs(D31)<tol)Then
          If(Abs(D41)<tol)Then
             Print *,'case D21,D31,D41=0'
             Call lt3drs_3D0(eeq(1),eek(1),d1,dq21,dq31,dq41,lq,lk,res)
          Else
             Print *,'case D21,D31=0'
             Call lt3drs_2D0(eeq(1),eek(1),d1,dq21,dq31,dq41,dk41,D41,lq,lk&
                  &,res)
          Endif
       Else If(Abs(D41)<tol)Then
          Print *,'case D21,D41=0'
          Call lt3drs_2D0(eeq(1),eek(1),d1,dq21,dq41,dq31,dk31,D31,lq,lk,res)
       Else
          Print *,'case D21=0'
          If(Abs(A4131)<tol)Then
             Print *,'case D21,A4131=0'
             Call lt3drs_1D0_1A0(eeq(1),eek(1),d1,dq21,dq31,dq41,dk41,D41,lq,lk,res)

          Else
             Print *,'case D21=0'
             Call lt3drs_1D0(eeq(1),eek(1),d1,dq21,dq31,dq41,dk31,dk41,D31,D41,lq,lk,res)
          Endif
       Endif
       !!
    Else If(Abs(D31)<tol)Then

       If(Abs(D41)<tol)Then
          Print *,'case D31,D41=0'
          Call lt3drs_2D0(eeq(1),eek(1),d1,dq31,dq41,dq21,dk21,D21,lq,lk,res)
       Else
          If(Abs(A4121)<tol)Then
             Print *,'case D31,A4121=0'
             Call lt3drs_1D0_1A0(eeq(1),eek(1),d1,dq31,dq21,dq41,dk41,D41,lq,lk,res)

          Else
             Print *,'case D31=0'
             Call lt3drs_1D0(eeq(1),eek(1),d1,dq31,dq21,dq41,dk21,dk41,D21,D41,lq,lk,res)
          Endif
       Endif

    Else If(Abs(D41)<tol)Then
       If(Abs(A3121)<tol)Then
          Print *,'case D41,A3121=0'
          Call lt3drs_1D0_1A0(eeq(1),eek(1),d1,dq41,dq21,dq31,dk31,D31,lq,lk,res)
       Else
          Print *,'case D41=0'
          
          Call lt3drs_1D0(eeq(1),eek(1),d1,dq41,dq21,dq31,dk21,dk31,D21,D31,lq,lk,res)
       Endif
    Else If(Abs(A3121)<tol)Then

       If(Abs(A4131)<tol)Then
          Print *,'case A3121,A4131=0'
          Call lt3drs_3A0(eeq(1),eek(1),d1,dq21,dq31,dq41,dk41,D41,lq,lk,res)

       Else
          Print *,'case A3121=0'
          Call lt3drs_1A0(eeq(1),eek(1),d1,dq21,dq31,dq41,dk31,dk41,D31,D41,lq,lk,res)
       Endif
       
    Else If(Abs(A4121)<tol)Then
       Print *,'case A4121=0'

       Call lt3drs_1A0(eeq(1),eek(1),d1,dq21,dq41,dq31,dk41,dk31,D41,D31,lq,lk,res)
    Else If(Abs(A4131)<tol)Then
       Print *,'case A4131=0'

       Call lt3drs_1A0(eeq(1),eek(1),d1,dq41,dq31,dq21,dk31,dk21,D31,D21,lq,lk,res)

       
    Else
       !Return

       Print *,'case D/=0'
       
       l2di=log2(d1)/(-D21*D31*D41)
       
       f=D21
       f=f*A3121
       f=f*A4121
       Write(outfile,"(2i3,4f20.10)")2,1,D21,f,log2(d1-D21*eeq(1)/dq21)
       
       If(lq) sq=sq+dq21**2*log2(d1-D21*eeq(1)/dq21)/f
       If(lk) sk=sk+dk21**2*log2(d1-D21*eek(1)/dk21)/f
       
       f=D31
       f=-f*A3121
       f=f*A4131
       Write(outfile,"(2i3,4f20.10)")3,1,D31,f,log2(d1-D31*eeq(1)/dq31)
       
       If(lq) sq=sq+dq31**2*log2(d1-D31*eeq(1)/dq31)/f
       If(lk) sk=sk+dk31**2*log2(d1-D31*eek(1)/dk31)/f
       
       f=D41
       f=f*A4121
       f=f*A4131
       Write(outfile,"(2i3,4f20.10)")4,1,D41,f,log2(d1-D41*eeq(1)/dq41)
       
       If(lq) sq=sq+dq41**2*log2(d1-D41*eeq(1)/dq41)/f
       If(lk) sk=sk+dk41**2*log2(d1-D41*eek(1)/dk41)/f
       
       !Print *,pd,l2di
       If(lq) res=res+(l2di+sq)
       If(lk) res=res-(l2di+sk)
       Print *,'SSS',l2di,sq,sk
       
    Endif
    !!
    Return
    !!
  End Subroutine lt3drs_i 
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lt3drs_3A0(eeq1,eek1,d1,dq21,dq31,dq41,dk41,D41,lq,lk,res)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: lq,lk
    Real(t_real),Intent(in)      :: d1,dq21,dq31,dq41,dk41,D41
    Real(t_real),Intent(in)      :: eek1,eeq1
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lt3drs_3A0"
    Real(t_real)   :: f,l2di,sq,sk,a,argq,argk
    !!

    l2di=log2(d1)
    

    
    sq=0.0_t_real
    sk=0.0_t_real


    argq=(d1-D41*eeq1/dq41)
    argk=(d1-D41*eek1/dk41)

    f=(dq41/D41)
    a=dq41/dk41
    If(lq) sq=sq+log1(argq)*eeq1*f
    If(lk) sk=sk+log1(argk)*eek1*f*a


    Write(outfile,"(2i3,4f20.10)")4,1,D41,f
    
    f=f**2
    If(lq) sq=sq+(log2(argq)-l2di)*f+0.5_t_real*Log(Abs(argq))*eeq1**2
    If(lk) sk=sk+(log2(argk)-l2di)*f+0.5_t_real*Log(Abs(argk))*eek1**2*a**2
    
    f=1.0_t_real/(dq21*dq31*D41)
    If(lq) res=res+sq*f
    If(lk) res=res-sk*f
    
    !!
    !!
    Return
    !!
  End Subroutine lt3drs_3A0
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lt3drs_1A0(eeq1,eek1,d1,dq21,dq31,dq41,dk31,dk41,D31,D41,lq,lk&
       &,res)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: lq,lk
    Real(t_real),Intent(in)      :: d1,dq21,dq31,dq41,dk31,dk41,D31,D41
    Real(t_real),Intent(in)      :: eek1,eeq1
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lt3drs_1A0"
    Real(t_real)   :: f,gq,gk,l2di,sq,sk,A4131,argq,argk
    !!
    f=-1.0_t_real/(D31**2*D41)

    l2di=log2(d1)*f
    
    sq=l2di
    sk=l2di

    A4131=dq41*dk31-dq31*dk41
    
    argq=(d1-D31*eeq1/dq31)
    argk=(d1-D31*eek1/dk31)
    
    gq=dq31/D31/A4131
    gk=dk31/D31/A4131
    
    If(lq) sq=&
         &sq-((dq41/A4131+1.0_t_real/D31)*log2(argq)+log1(argq)*eeq1/dq31)*gq
    If(lk) sk=&
         &sk-((dk41/A4131+1.0_t_real/D31)*log2(argk)+log1(argk)*eek1/dk31)*gk
    



    f=D41*A4131**2
    Write(outfile,"(2i3,4f20.10)")4,1,D41,f
    
    If(lq) sq=sq+dq41**2*log2(d1-D41*eeq1/dq41)/f
    If(lk) sk=sk+dk41**2*log2(d1-D41*eek1/dk41)/f
    
    f=dq31/dq21
    If(lq) res=res+sq*f
    If(lk) res=res-sk*f
    
    !!
    !!
    Return
    !!
  End Subroutine lt3drs_1A0
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lt3drs_3D0(eeq1,eek1,d1,dq21,dq31,dq41,lq,lk,res)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: lq,lk
    Real(t_real),Intent(in)      :: d1,dq21,dq31,dq41
    Real(t_real),Intent(in)      :: eek1,eeq1
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lt3drs_3D0"
    Real(t_real)   :: r1di,b
    !!
    
    r1di=1.0_t_real/(d1*6.0_t_real)
    
    b=1.0_t_real/(dq21*dq31*dq41)
    
    If(lq) res=res-eeq1**3*r1di*b
    If(lk) res=res+eek1**3*r1di*b
    
    !!
    !!
    Return
    !!
  End Subroutine lt3drs_3D0
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lt3drs_2D0(eeq1,eek1,d1,dq21,dq31,dq41,dk41,D41,lq,lk,res)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: lq,lk
    Real(t_real),Intent(in)      :: d1,dq21,dq31,dq41,dk41,D41
    Real(t_real),Intent(in)      :: eek1,eeq1
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lt3drs_2D0"
    Real(t_real)   :: f,l2di,l1di,sq,sk,l0di
    !!
    
    l2di=log2(d1)/D41**2
    l1di=log1(d1)/D41
    l0di=Log(Abs(d1))*0.5_t_real
    
    sq=0.0_t_real
    sk=0.0_t_real

    
    If(lq) sq=sq-dq41**2*l2di+dq41*l1di*eeq1-l0di*eeq1**2
    If(lk) sk=sk-dk41**2*l2di+dk41*l1di*eek1-l0di*eek1**2
    
    

    f=D41**2
    Write(outfile,"(2i3,4f20.10)")4,1,D41,f
    
    If(lq) sq=sq+dq41**2*log2(d1-D41*eeq1/dq41)/f
    If(lk) sk=sk+dk41**2*log2(d1-D41*eek1/dk41)/f
    
    If(lq) res=res+sq/(dq21*dq31*D41)
    If(lk) res=res-sk/(dq21*dq31*D41)
    
    !!
    !!
    Return
    !!
  End Subroutine lt3drs_2D0
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lt3drs_1D0(eeq1,eek1,d1,dq21,dq31,dq41,dk31,dk41,D31,D41,lq,lk&
       &,res)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: lq,lk
    Real(t_real),Intent(in)      :: d1,dq21,dq31,dq41,dk31,dk41,D31,D41
    Real(t_real),Intent(in)      :: eek1,eeq1
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lt3drs_1D0"
    Real(t_real)   :: f,gq,gk,l2di,l1di,sq,sk,A4131
    !!
    f=1.0_t_real/(D31*D41)
    gq=(dq41*D31+dq31*D41)/(D31*D41)
    gk=(dk41*D31+dk31*D41)/(D31*D41)
    
    l2di=log2(d1)*f
    l1di=log1(d1)*f
    
    sq=0.0_t_real
    sk=0.0_t_real

    Write(outfile,"(2i3,4f20.10)")2,1,f
    
    If(lq) sq=sq+l2di*gq-l1di*eeq1
    If(lk) sk=sk+l2di*gk-l1di*eek1
    
    A4131=(dq41*dk31-dq31*dk41)
    f=D31**2*A4131
    Write(outfile,"(2i3,4f20.10)")3,1,D31,f
    
    If(lq) sq=sq+dq31**2*log2(d1-D31*eeq1/dq31)/f
    If(lk) sk=sk+dk31**2*log2(d1-D31*eek1/dk31)/f
    
    f=-D41**2*A4131
    Write(outfile,"(2i3,4f20.10)")4,1,D41,f
    
    If(lq) sq=sq+dq41**2*log2(d1-D41*eeq1/dq41)/f
    If(lk) sk=sk+dk41**2*log2(d1-D41*eek1/dk41)/f
    
    If(lq) res=res+sq/dq21
    If(lk) res=res-sk/dq21
    
    !!
    !!
    Return
    !!
  End Subroutine lt3drs_1D0
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine lt3drs_1D0_1A0(eeq1,eek1,d1,dq21,dq31,dq41,dk41,D41,lq,lk,res)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: lq,lk
    Real(t_real),Intent(in)      :: d1,dq21,dq31,dq41,dk41,D41
    Real(t_real),Intent(in)      :: eek1,eeq1
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="lt3drs_1D0_1A0"
    Real(t_real)   :: f,l2di,l1di,sq,sk
    !!
    
    l2di=log2(d1)
    l1di=log1(d1)
    
    sq=0.0_t_real
    sk=0.0_t_real


    f=2.0_t_real/D41
    Write(outfile,"(2i3,4f20.10)")2,1,f
    
    If(lq) sq=sq+dq41*l2di*f-l1di*eeq1
    If(lk) sk=sk+dk41*l2di*f-l1di*eek1
    
    
    If(lq) sq=sq-log1(d1-D41*eeq1/dq41)*eeq1
    If(lk) sk=sk-log1(d1-D41*eek1/dk41)*eek1
    
    
    Write(outfile,"(2i3,4f20.10)")4,1,D41,f
    If(lq) sq=sq-dq41*log2(d1-D41*eeq1/dq41)*f
    If(lk) sk=sk-dk41*log2(d1-D41*eek1/dk41)*f

    f=dq41/(dq21*dq31*D41**2)
    If(lq) res=res+sq*f
    If(lk) res=res-sk*f
    
    !!
    !!
    Return
    !!
  End Subroutine lt3drs_1D0_1A0
#endif
  !!***********************************************************************
  Real(t_real) Function Log2app(x0,d)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x0,d
    !!LOCAL
    !Character(*),Parameter::nsubfunc="log2app"
    Real(t_real)   :: l0
    !!
    If(x0+d==0.0_t_real)then
       log2app=0.0_t_real
    Else If(Abs(d)<1.0e-2_t_real)Then
       l0=Log(Abs(x0))
       log2app=x0**2*(l0-1.5_t_real)*0.5_t_real&
            &+x0*(l0-1.0_t_real)*d&
            &+l0*d**2*0.5_t_real&
            &+d**3/x0/6.0_t_real
    Else
       !!
       log2app=0.5_t_real*(x0+d)**2*(Log(Abs(x0+d))-1.5_t_real)
    Endif
    !!
    Return
    !!
  End Function Log2app
  !!***********************************************************************
  Real(t_real) Function Log2(x)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x
    !!LOCAL
    !Character(*),Parameter::nsubfunc="log2"
    !!
    If(x==0.0_t_real) Then
       log2=0.0_t_real
       Return 
    Endif
    !!
    log2=0.5_t_real*x**2*(Log(Abs(x))-1.5_t_real)
    !Print *,'log2',x,log2
    !!
    Return
    !!
  End Function log2
  !!***********************************************************************
  Complex(t_real) Function CLog2(x,delta)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x,delta
    !!LOCAL
    !Character(*),Parameter::nsubfunc="log2"
    Complex(t_real):: cx
    !!
    cx=Cmplx(x,delta,t_real)
    !!
    clog2=0.5_t_real*cx**2*(Log(cx)-1.5_t_real)
    !!
    Return
    !!
  End Function CLog2
  !!***********************************************************************
  Real(t_real) Function Log1(x)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x
    !!LOCAL
    !Character(*),Parameter::nsubfunc="log1"
    !!
    If(x==0.0_t_real) Then
       log1=0.0_t_real
       Return 
    Endif
    !!
    log1=x*(Log(Abs(x))-1.0_t_real)
    !Print *,'log2',x,log2
    !!
    Return
    !!
  End Function log1
  !!***********************************************************************
  Real(t_real) Function Log0(x)
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: x
    !!LOCAL
    !Character(*),Parameter::nsubfunc="log0"
    !!
    If(x==0.0_t_real) Then
       log0=0.0_t_real
       Return 
    Endif
    !!
    log0=Log(Abs(x))
    !Print *,'log2',x,log2
    !!
    Return
    !!
  End Function log0
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine tetcut_chiqw(iek,iekq,vc,ef,w,res)
    !!
    !!
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: iek(4),iekq(4),vc,ef,w
    Real(t_real),Intent(inout)   :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="tetcut_chiqw"
    Integer(t_int) :: iwk(4),i,j,idum
    Real(t_real)   :: ek(4),ekq(4),f,lam31,lam41,lam32,lam42,nek(4)
    Real(t_real)   :: lam21,lam34,lam24,lam14,nekq(4),ekq21,ekq31,ekq41
    !!
    iwk(1:4)=(/1,2,3,4/)
    !!
    Do i=1,4
       Do j=i+1,4
          If(iek(iwk(j))<iek(iwk(i)))Then
             idum=iwk(i)
             iwk(i)=iwk(j)
             iwk(j)=idum
          Endif
       Enddo
    Enddo
    !!
    Do i=1,4
       ek (i)=iek (iwk(i))
       ekq(i)=iekq(iwk(i))
    Enddo
    !!
    !!
    If(ef<=ek(1))Then
       !! empty
       !Print *,'ef<e1'
       Call tetcut_chiqw_2(ek,ekq,vc,-1.0_t_real,ef,w,res)
    Else If(ek(1)<ef .And. ef<=ek(2))Then

       !Print *,'e1<ef<=e2'

       !! first case semi full
       lam21=(ef-ek(1))/(ek(2)-ek(1))
       lam31=(ef-ek(1))/(ek(3)-ek(1))
       lam41=(ef-ek(1))/(ek(4)-ek(1))
       ekq21=ekq(1)+lam21*(ekq(2)-ekq(1))
       ekq31=ekq(1)+lam31*(ekq(3)-ekq(1))
       ekq41=ekq(1)+lam41*(ekq(4)-ekq(1))

       nek(1)=ek(1)
       nek(2:4)=ef
       nekq(1)=ekq(1)
       nekq(2)=ekq21
       nekq(3)=ekq31
       nekq(4)=ekq41
       f=lam21*lam31*lam41

       Call tetcut_chiqw_2(nek,nekq,vc*f,1.0_t_real,ef,w,res)
       
       !! now create the empty tetrahedra
       !! 2 3 4 41
       nek(1)=ek(2)
       nek(2)=ek(3)
       nek(3)=ek(4)
       nek(4)=ef
       nekq(1)=ekq(2)
       nekq(2)=ekq(3)
       nekq(3)=ekq(4)
       nekq(4)=ekq41
       f=1.0_t_real-lam41
       Call tetcut_chiqw_2(nek,nekq,vc*f,-1.0_t_real,ef,w,res)

       !! 2 3 41 31
       !!
       nek(1)=ek(2)
       nek(2)=ek(3)
       nek(3:4)=ef
       nekq(1)=ekq(2)
       nekq(2)=ekq(3)
       nekq(3)=ekq31
       nekq(4)=ekq41
       f=lam41*(1.0_t_real-lam31)
       Call tetcut_chiqw_2(nek,nekq,vc*f,-1.0_t_real,ef,w,res)

       !! 2 21 31 41
       !!
       nek(1)=ek(2)
       nek(2:4)=ef
       nekq(1)=ekq(2)
       nekq(2)=ekq21
       nekq(3)=ekq31
       nekq(4)=ekq41
       f=(1.0_t_real-lam21)*lam41*lam31
       Call tetcut_chiqw_2(nek,nekq,vc*f,-1.0_t_real,ef,w,res)


    Else If(ek(2)<ef .And. ef<=ek(3))Then
       !Print *,'e2<ef<=e3'
       !! second case semi full
       lam31=(ef-ek(1))/(ek(3)-ek(1))
       lam41=(ef-ek(1))/(ek(4)-ek(1))
       lam32=(ef-ek(2))/(ek(3)-ek(2))
       lam42=(ef-ek(2))/(ek(4)-ek(2))
       nek(1)=ek(1)
       nek(2)=ek(2)
       nek(3)=ek(1)+lam31*(ek(3)-ek(1))
       nek(4)=ek(1)+lam41*(ek(4)-ek(1))
       nekq(1)=ekq(1)
       nekq(2)=ekq(2)
       nekq(3)=ekq(1)+lam31*(ekq(3)-ekq(1))
       nekq(4)=ekq(1)+lam41*(ekq(4)-ekq(1))
       f=lam31*lam41
      Call tetcut_chiqw_2(nek,nekq,vc*f,1.0_t_real,ef,w,res)
       
       nek(1)=ek(2)
       nek(2)=ek(2)+lam32*(ek(3)-ek(2))
       nek(3)=ek(2)+lam42*(ek(4)-ek(2))
       nek(4)=ek(1)+lam31*(ek(3)-ek(1))
       nekq(1)=ekq(2)
       nekq(2)=ekq(2)+lam32*(ekq(3)-ekq(2))
       nekq(3)=ekq(2)+lam42*(ekq(4)-ekq(2))
       nekq(4)=ekq(1)+lam31*(ekq(3)-ekq(1))
       f=lam32*lam42*(1.0_t_real-lam31)
       Call tetcut_chiqw_2(nek,nekq,vc*f,1.0_t_real,ef,w,res)

       !!2      ,31,42,41
       nek(1)=ek(2)
       nek(2)=ek(1)+lam31*(ek(3)-ek(1))
       nek(3)=ek(2)+lam42*(ek(4)-ek(2))
       nek(4)=ek(1)+lam41*(ek(4)-ek(1))
       nekq(1)=ekq(2)
       nekq(2)=ekq(1)+lam31*(ekq(3)-ekq(1))
       nekq(3)=ekq(2)+lam42*(ekq(4)-ekq(2))
       nekq(4)=ekq(1)+lam41*(ekq(4)-ekq(1))
       f=lam31*lam42*(1.0_t_real-lam41)
      Call tetcut_chiqw_2(nek,nekq,vc*f,1.0_t_real,ef,w,res)

       !! now create the empty tetrahedra
       nek(1)=ek(3)
       nek(2)=ek(4)
       nek(3)=ek(1)+lam31*(ek(3)-ek(1))
       nek(4)=ek(1)+lam32*(ek(3)-ek(2))
       nekq(1)=ekq(3)
       nekq(2)=ekq(4)
       nekq(3)=ekq(1)+lam31*(ekq(3)-ekq(1))
       nekq(4)=ekq(1)+lam32*(ekq(3)-ekq(2))
       f=(1.0_t_real-lam31)*(1.0_t_real-lam32)
       Call tetcut_chiqw_2(nek,nekq,vc*f,-1.0_t_real,ef,w,res)

       nek(1)=ek(4)
       nek(2)=ek(1)+lam41*(ek(4)-ek(1))
       nek(3)=ek(1)+lam42*(ek(4)-ek(2))
       nek(4)=ek(1)+lam31*(ek(3)-ek(1))
       nekq(1)=ekq(4)
       nekq(2)=ekq(1)+lam41*(ekq(4)-ekq(1))
       nekq(3)=ekq(1)+lam42*(ekq(4)-ekq(2))
       nekq(4)=ekq(1)+lam31*(ekq(3)-ekq(1))
       f=(1.0_t_real-lam41)*(1.0_t_real-lam42)*lam31
       Call tetcut_chiqw_2(nek,nekq,vc*f,-1.0_t_real,ef,w,res)

       !!4,14,24,23
       nek(1)=ek(4)
       nek(2)=ek(1)+lam31*(ek(3)-ek(1))
       nek(3)=ek(2)+lam42*(ek(4)-ek(2))
       nek(4)=ek(2)+lam32*(ek(3)-ek(2))
       nekq(1)=ekq(4)
       nekq(2)=ekq(1)+lam31*(ekq(3)-ekq(1))
       nekq(3)=ekq(2)+lam42*(ekq(4)-ekq(2))
       nekq(4)=ekq(2)+lam32*(ekq(3)-ekq(2))
       f=(1.0_t_real-lam31)*(1.0_t_real-lam42)*lam32
       Call tetcut_chiqw_2(nek,nekq,vc*f,-1.0_t_real,ef,w,res)


    Else If(ek(3)<ef .And. ef<=ek(4))Then
       !Print "('e3<ef<=e4',5(e10.5))",ek(1),ek(2),ek(3),ef,ek(4)
       !! third case semi full
       lam34=(ef-ek(4))/(ek(3)-ek(4))
       lam14=(ef-ek(4))/(ek(1)-ek(4))
       lam24=(ef-ek(4))/(ek(2)-ek(4))

       !! now create the full tetrahedra
       !! 1 2 3 34
       
       nek(1)=ek(1)
       nek(2)=ek(2)
       nek(3)=ek(3)
       nek(4)=ek(4)+lam34*(ek(3)-ek(4))
       nekq(1)=ekq(1)
       nekq(2)=ekq(2)
       nekq(3)=ekq(3)
       nekq(4)=ekq(4)+lam34*(ekq(3)-ekq(4))
       f=1.0_t_real-lam34
      Call tetcut_chiqw_2(nek,nekq,vc*f,1.0_t_real,ef,w,res)
      
       !! 1 2 34 24
       !!
       nek(1)=ek(1)
       nek(2)=ek(2)
       nek(3)=ek(4)+lam24*(ek(2)-ek(4))
       nek(4)=ek(4)+lam34*(ek(3)-ek(4))
       nekq(1)=ekq(1)
       nekq(2)=ekq(2)
       nekq(3)=ekq(4)+lam24*(ekq(2)-ekq(4))
       nekq(4)=ekq(4)+lam34*(ekq(3)-ekq(4))
       f=lam34*(1.0_t_real-lam24)
      Call tetcut_chiqw_2(nek,nekq,vc*f,1.0_t_real,ef,w,res)

       !! 2 14 24 34
       !!
       nek(1)=ek(1)
       nek(2)=ek(4)+lam14*(ek(1)-ek(4))
       nek(3)=ek(4)+lam24*(ek(2)-ek(4))
       nek(4)=ek(4)+lam34*(ek(3)-ek(4))
       nekq(1)=ekq(1)
       nekq(2)=ekq(4)+lam14*(ekq(1)-ekq(4))
       nekq(3)=ekq(4)+lam24*(ekq(2)-ekq(4))
       nekq(4)=ekq(4)+lam34*(ekq(3)-ekq(4))
       f=(1.0_t_real-lam14)*lam34*lam24
       Call tetcut_chiqw_2(nek,nekq,vc*f,1.0_t_real,ef,w,res)

       !! now create the empty tetrahedra
       nek(1)=ek(4)
       nek(2)=ek(4)+lam14*(ek(1)-ek(4))
       nek(3)=ek(4)+lam24*(ek(2)-ek(4))
       nek(4)=ek(4)+lam34*(ek(3)-ek(4))
       nekq(1)=ekq(4)
       nekq(2)=ekq(4)+lam14*(ekq(1)-ekq(4))
       nekq(3)=ekq(4)+lam24*(ekq(2)-ekq(4))
       nekq(4)=ekq(4)+lam34*(ekq(3)-ekq(4))
       f=lam24*lam34*lam14
       Call tetcut_chiqw_2(nek,nekq,vc*f,-1.0_t_real,ef,w,res)


    Else If(ek(4)<ef)Then
       !Print *,'e4<ef'
       !! full
       !Print "('nek1',9f10.5)",ek,ekq,ef

      Call tetcut_chiqw_2(ek,ekq,vc,1.0_t_real,ef,w,res)
       !!
    Endif
    !!
    !!
    !!
    Return
    !!
  End Subroutine tetcut_chiqw
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine tetcut_chiqw_2(iek,iekq,vc,filling,ef,w,res)
    Implicit None
    !!IO
    Real(t_real),Intent(in)      :: iek(4),iekq(4),vc,ef,filling,w
    Real(t_real),Intent(inout)   :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="tetcut_chiqw_2"
    Integer(t_int) :: iwk(4),i,j,idum
    Real(t_real)   :: ek(4),ekq(4),f,lam31,lam41,lam32,lam42,nek(4)
    Real(t_real)   :: lam21,lam34,lam24,lam14
    !!
    iwk(1:4)=(/1,2,3,4/)
    !!
    Do i=1,4
       Do j=i+1,4
          If(iekq(iwk(j))<iekq(iwk(i)))Then
             idum=iwk(i)
             iwk(i)=iwk(j)
             iwk(j)=idum
          Endif
       Enddo
    Enddo
    !!
    Do i=1,4
       ek (i)=iek (iwk(i))
       ekq(i)=iekq(iwk(i))
    Enddo
    !!
    !Print "('nek2',9f10.5)",ek,ekq,ef
    !!
    !!
    If(ef<=ekq(1))Then
       !! completely empty

       !Print "('hier1',f10.5)",filling
       If(filling>0.0_t_real)Then
          nek(1:4)=ek(1:4)-ekq(1:4)
          !res=res+vc/6.0_t_real
          Call tetcut_chiqw_delta(nek,vc,w,res)
       Endif
    Else If(ekq(1)<ef .And. ef<=ekq(2))Then
       ! corener 1 is full
       If(filling>0.0_t_real)Then
          lam21=(ef-ekq(1))/(ekq(2)-ekq(1))
          lam31=(ef-ekq(1))/(ekq(3)-ekq(1))
          lam41=(ef-ekq(1))/(ekq(4)-ekq(1))
          nek(1)=ek(2)-ekq(2)
          nek(2)=ek(3)-ekq(3)
          nek(3)=ek(4)-ekq(4)
          nek(4)=ek(1)+lam41*(ek(4)-ek(1))-ef
          f=1.0_t_real-lam41
          !res=res+vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,vc*f,w,res)

          !!
          nek(1)=ek(2)-ekq(2)
          nek(2)=ek(3)-ekq(3)
          nek(3)=ek(1)+lam31*(ek(3)-ek(1))-ef
          nek(4)=ek(1)+lam41*(ek(4)-ek(1))-ef
          f=lam41*(1.0_t_real-lam31)
          !res=res+vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,vc*f,w,res)

          !!
          nek(1)=ek(2)-ekq(2)
          nek(2)=ek(1)+lam21*(ek(2)-ek(1))-ef
          nek(3)=ek(1)+lam31*(ek(3)-ek(1))-ef
          nek(4)=ek(1)+lam41*(ek(4)-ek(1))-ef
          f=(1.0_t_real-lam21)*lam41*lam31
          !res=res+vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,vc*f,w,res)
          
       Else
          lam21=(ef-ekq(1))/(ekq(2)-ekq(1))
          lam31=(ef-ekq(1))/(ekq(3)-ekq(1))
          lam41=(ef-ekq(1))/(ekq(4)-ekq(1))
          nek(1)=ek(1)-ekq(1)
          nek(2)=ek(1)+lam21*(ek(2)-ek(1))-ef
          nek(3)=ek(1)+lam31*(ek(3)-ek(1))-ef
          nek(4)=ek(1)+lam41*(ek(4)-ek(1))-ef
          f=lam21*lam31*lam41
          !res=res-vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,-vc*f,w,res)
       Endif
       
    Else If(ekq(2)<ef .And. ef<=ekq(3))Then
       If(filling<0.0_t_real)Then
          !! second case semi full
          
          lam31=(ef-ekq(1))/(ekq(3)-ekq(1))
          lam41=(ef-ekq(1))/(ekq(4)-ekq(1))
          lam32=(ef-ekq(2))/(ekq(3)-ekq(2))
          lam42=(ef-ekq(2))/(ekq(4)-ekq(2))
          nek(1)=ek(1)-ekq(1)
          nek(2)=ek(2)-ekq(2)
          nek(3)=ek(1)+lam31*(ek(3)-ek(1))-ef
          nek(4)=ek(1)+lam41*(ek(4)-ek(1))-ef
          f=lam31*lam41
          !res=res-vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,-vc*f,w,res)

          nek(1)=ek(2)-ekq(2)
          nek(2)=ek(2)+lam32*(ek(3)-ek(2))-ef
          nek(3)=ek(2)+lam42*(ek(4)-ek(2))-ef
          nek(4)=ek(1)+lam31*(ek(3)-ek(1))-ef
          f=lam32*lam42*(1.0_t_real-lam31)
          !res=res-vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,-vc*f,w,res)

          nek(1)=ek(2)-ekq(2)
          nek(2)=ek(1)+lam31*(ek(3)-ek(1))-ef
          nek(3)=ek(2)+lam42*(ek(4)-ek(2))-ef
          nek(4)=ek(1)+lam41*(ek(4)-ek(1))-ef
          f=lam31*lam42*(1.0_t_real-lam41)
          !res=res-vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,-vc*f,w,res)

       Else

          !! second case semi empty
          lam31=(ef-ekq(1))/(ekq(3)-ekq(1))
          lam41=(ef-ekq(1))/(ekq(4)-ekq(1))
          lam32=(ef-ekq(2))/(ekq(3)-ekq(2))
          lam42=(ef-ekq(2))/(ekq(4)-ekq(2))
          nek(1)=ek(3)-ekq(3)
          nek(2)=ek(4)-ekq(4)
          nek(3)=ek(1)+lam31*(ek(3)-ek(1))-ef
          nek(4)=ek(1)+lam32*(ek(3)-ek(2))-ef
          f=(1.0_t_real-lam31)*(1.0_t_real-lam32)
          !res=res+vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,vc*f,w,res)
          
          nek(1)=ek(4)-ekq(4)
          nek(2)=ek(1)+lam41*(ek(4)-ek(1))-ef
          nek(3)=ek(1)+lam42*(ek(4)-ek(2))-ef
          nek(4)=ek(1)+lam31*(ek(3)-ek(1))-ef
          f=(1.0_t_real-lam41)*(1.0_t_real-lam42)*lam31
          !res=res+vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,vc*f,w,res)
          

          nek(1)=ek(4)-ekq(4)
          nek(2)=ek(1)+lam31*(ek(3)-ek(1))-ef
          nek(3)=ek(2)+lam42*(ek(4)-ek(2))-ef
          nek(4)=ek(2)+lam32*(ek(3)-ek(2))-ef
          f=(1.0_t_real-lam31)*(1.0_t_real-lam42)*lam32
          !res=res+vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,vc*f,w,res)
          
       Endif
       
    Else If(ekq(3)<ef .And. ef<=ekq(4))Then
       If(filling<0.0_t_real)Then
          lam34=(ef-ekq(4))/(ekq(3)-ekq(4))
          lam14=(ef-ekq(4))/(ekq(1)-ekq(4))
          lam24=(ef-ekq(4))/(ekq(2)-ekq(4))
          nek(1)=ek(1)-ekq(1)
          nek(2)=ek(2)-ekq(2)
          nek(3)=ek(3)-ekq(3)
          nek(4)=ek(4)+lam34*(ek(3)-ek(4))-ef
          f=1.0_t_real-lam34
          !res=res-vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,-vc*f,w,res)
      
          !!
          nek(1)=ek(1)-ekq(1)
          nek(2)=ek(2)-ekq(2)
          nek(3)=ek(4)+lam24*(ek(2)-ek(4))-ef
          nek(4)=ek(4)+lam34*(ek(3)-ek(4))-ef
          f=lam34*(1.0_t_real-lam24)
          !res=res-vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,-vc*f,w,res)

          !!
          nek(1)=ek(1)-ekq(1)
          nek(2)=ek(4)+lam14*(ek(1)-ek(4))-ef
          nek(3)=ek(4)+lam24*(ek(2)-ek(4))-ef
          nek(4)=ek(4)+lam34*(ek(3)-ek(4))-ef
          f=(1.0_t_real-lam14)*lam34*lam24
          !res=res-vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,-vc*f,w,res)

       Else
          lam34=(ef-ekq(4))/(ekq(3)-ekq(4))
          lam14=(ef-ekq(4))/(ekq(1)-ekq(4))
          lam24=(ef-ekq(4))/(ekq(2)-ekq(4))
          nek(1)=ek(4)-ekq(4)
          nek(2)=ek(4)+lam14*(ek(1)-ek(4))-ef
          nek(3)=ek(4)+lam24*(ek(2)-ek(4))-ef
          nek(4)=ek(4)+lam34*(ek(3)-ek(4))-ef
          f=lam24*lam34*lam14
          !res=res+vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,vc*f,w,res)
       Endif
    Else If(ekq(4)<ef)Then
       !! completely full
       If(filling<0.0_t_real)Then
          nek(1:4)=ek(1:4)-ekq(1:4)
          !res=res-vc*f/6.0_t_real
          Call tetcut_chiqw_delta(nek,-vc,w,res)
       Endif
    Endif
    !!
    !!
    !!
    Return
    !!
  End Subroutine tetcut_chiqw_2
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine tetcut_chiqw_delta(iek,vc,w,res)
    !!
    !!  calc integral of delta(w-iek) over tetra 
    !!
    Implicit None  
    !!IO
    Real(t_real),Intent(in)      :: iek(4),vc,w
    Real(t_real),Intent(out)     :: res
    !!LOCAL
    !Character(*),Parameter::nsubfunc="tetcut_chiqw_delta"
    Integer(t_int) :: i,j,idum,iwk(4)
    Real(t_real)   :: ek(4),f,det,tiny
    !!
    tiny=1.0e-6_t_real
    !!
    iwk(1:4)=(/1,2,3,4/)
    !!
    Do i=1,4
       Do j=i+1,4
          If(iek(iwk(j))<iek(iwk(i)))Then
             idum=iwk(i)
             iwk(i)=iwk(j)
             iwk(j)=idum
          Endif
       Enddo
    Enddo
    !!
    Do i=1,4
       ek (i)=iek(iwk(i))
    Enddo
    !!

    If(ek(1)<w .And. w<=ek(2))Then
       det=1.0_t_real/((ek(2)-ek(1))*(ek(3)-ek(1))*(ek(4)-ek(1))+tiny)
       f=0.5_t_real*(w-ek(1))**2*det
       res=res+vc*f
    Else If(ek(2)<w .And. w<=ek(3))Then


       f=2.0_t_real*(w-ek(1))/((ek(3)-ek(1))*(ek(4)-ek(1))+tiny)
       f=f-(w-ek(2))*(3.0_t_real*w-2.0_t_real*ek(3)-ek(2))&
            &/((ek(3)-ek(2))*(ek(4)-ek(2))*(ek(3)-ek(1))+tiny)
       f=f-(&
            & (w-ek(2))*(w-ek(4))&
            &+(w-ek(1))*(w-ek(4))&
            &+(w-ek(1))*(w-ek(2))&
            &)&
            &/((ek(3)-ek(1))*(ek(4)-ek(2))*(ek(4)-ek(1))+tiny)
       res=res+vc*f/6.0_t_real

    Else If(ek(3)<w .And. w<=ek(4))Then
       det=1.0_t_real/((ek(1)-ek(4))*(ek(2)-ek(4))*(ek(3)-ek(4))-tiny)
       f=-0.5_t_real*(w-ek(4))**2*det
       res=res+vc*f
    Endif
    !!
    !!
    !!
    Return
    !!
    !!
    !!
  End Subroutine tetcut_chiqw_delta
#endif
  !!***********************************************************************
  Integer(t_int) Function fmijk_to_fmi(ix,iy,iz,Nx,Ny)
    !!
    !! map full mesh indices to full mesh pointer
    !! pointer numbers consequetively and indices are x,y,z indices
    !! where x runs first
    !!
    !! pointer is ONE BASED
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: Nx,Ny !! meshs subdivisions
    Integer(t_int),Intent(in)    :: ix,iy,iz !! ZERO BASED !!!
    !!LOCAL
    !Character(*),Parameter::nsubfunc="fmijk_to_fmi"
    !!
    !!
    fmijk_to_fmi=(ix+(iy+iz*Ny)*Nx)+1
    !!
    Return
    !!
  End Function fmijk_to_fmi
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine fmi_to_fmijk(ikp,ix,iy,iz,Nx,Ny)
    !!
    !! map full mesh pointer to full mesh indices
    !! pointer numbers consequetively and indices are x,y,z indices
    !! where x runs first
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: ikp !! ONE BASED !!!
    Integer(t_int),Intent(in)    :: Nx,Ny !! meshs subdivisions
    Integer(t_int),Intent(out)   :: ix,iy,iz !! ZERO BASED !!!
    !!LOCAL
    !Character(*),Parameter::nsubfunc="fmi_to_fmijk"
    Integer(t_int) :: i
    !!
    i=ikp-1
    !!
    ix=Mod(i,Nx)
    i=(i-ix)/Nx
    iy=Mod(i,Ny)
    iz=(i-iy)/Ny
    !!
    Return
    !!
  End Subroutine fmi_to_fmijk
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine mapkplusq(iqx,iqy,iqz,tet,ikqs,Nx,Ny,Nz,p_ijk_to_ikp&
       &,p_fmi_to_fmijk)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: iqx,iqy,iqz!indices of q-point
    Integer(t_int),Intent(in)    :: Nx,Ny,Nz!mesh subdivisions
    Integer(t_int),Intent(in)    :: p_fmi_to_fmijk(:,:)
    !! the mapping tet->kpoint
    !! tet(:) gives the full mesh pointers
    Integer(t_int),Intent(in)    :: tet(1:4)
    Integer(t_int),Intent(in)    :: p_ijk_to_ikp(*)
    !! pointers into irred mesh representing k+q
    Integer(t_int),Intent(out)   :: ikqs(1:4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="mapkplusq"
    Integer(t_int) :: icorn,ikp,jx,jy,jz
    !!
    Do icorn=1,4
       ikp=tet(icorn) !! one based full mesh pointer
       !! zero based indices
       !! shift by q
       jx=Mod((p_fmi_to_fmijk(1,ikp)+iqx),Nx)
       jy=Mod((p_fmi_to_fmijk(2,ikp)+iqy),Ny)
       jz=Mod((p_fmi_to_fmijk(3,ikp)+iqz),Nz)
       !! make one based fullmesh pointer
       !! and look up irred pointer
       ikqs(icorn)=p_ijk_to_ikp((jx+(jy+jz*Ny)*Nx)+1)
       !!
    Enddo
    !!
    !!
    Return
    !!
  End Subroutine mapkplusq
#endif
  !!***********************************************************************
  Subroutine diatest()
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="diatest"
    Integer(t_int) :: i,j
    Integer(t_int),Parameter :: N=7
    Complex(t_real)  :: H(N,N),V(N,N),A(N,N),S(N,N),AS(N,N)
    Real(t_real)   :: w(N)
    !!
    w(1)=rndmst(1_t_int)
    !!
    Do i=1,N
       Do j=i,N
          H(i,j)=Cmplx(rndmcm(),rndmcm(),t_real)
          S(i,j)=Cmplx(rndmcm(),rndmcm(),t_real)
          H(j,i)=Conjg(H(i,j))
          S(j,i)=Conjg(S(i,j))
          !H(j,i)=H(i,j)
          !S(j,i)=S(i,j)
       Enddo
       H(i,i)=Real(H(i,i),t_real)
       S(i,i)=Real(S(i,i),t_real)
    Enddo

    S=Matmul(Transpose(Conjg(S)),S)
    !S=Matmul(Transpose(S),S)
    
    Print *,"H="
    Do i=1,N
       Do j=1,N
          Write(outfile,"(2(f17.8,1x))",advance='no')H(i,j)
       Enddo
       Print *
    Enddo
    
    Print *,"S="
    Do i=1,N
       Do j=1,N
          Write(outfile,"(2(f17.8,1x))",advance='no')S(i,j)
       Enddo
       Print *
    Enddo
    
    A=H
    AS=S
    Call cdiagno(N,A,AS,w)
    V=A
    Print *,"W="
    Do j=1,N
       Write(outfile,"(f17.8,1x)",advance='no')w(j)
    Enddo
    Print *
    
    Print *,"V="
    Do i=1,N
       Do j=1,N
          Write(outfile,"(2(f17.8,1x))",advance='no')V(i,j)
       Enddo
       Print *
    Enddo
    
    A=Matmul(Transpose(Conjg(V)),Matmul(H,V))
    
    Print *,"V^T*H*V="
    Do i=1,N
       Do j=1,N
          Write(outfile,"(2(f17.8,1x))",advance='no')A(i,j)
       Enddo
       Print *
    Enddo
    !!
    Call ctestdia(N,N,H,S,V,w,1.0e-15_t_real)
    !!
    Stop
    !!
    Return
    !!
  End Subroutine diatest
  !!***********************************************************************
  Subroutine dos1d(tetwgt,Nt,ek,ak,e,dos)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: Nt
    Real(t_real),Intent(in)      :: ek(:),ak(:),tetwgt,e
    Real(t_real),Intent(out)     :: dos
    !!LOCAL
    !Character(*),Parameter::nsubfunc="dos1d"
    Integer(t_int) :: it
    Real(t_real)   :: e0,e1,a0,a1,dum
    !!
    !!
    dos=0.0_t_real
    Do it=1,Nt
       e0=ek(it)
       e1=ek(it+1)
       a0=ak(it)
       a1=ak(it+1)
       If(e0>e1)Then
          dum=e0
          e0=e1
          e1=dum
          dum=a0
          a0=a1
          a1=dum
       Endif
       If(e0<=e .And. e<e1)Then
          dos=dos+tetwgt/(e1-e0)*(a0+(a1-a0)/(e1-e0)*(e-e0))
       Endif
    Enddo
    !!
    Return
    !!
  End Subroutine dos1d
  !!***********************************************************************
  Subroutine opticsDos()
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="opticsDos"
    Integer(t_int) :: ik,Nk,ie,Ne,it,nband,ib,jb
    Real(t_real)   :: k0,k1,dk,k,e0,e1,de,e,dos(2),tetwgt,a0,a1,dum
    Real(t_real)   :: ei0,ei1,ej0,ej1,d0,d1,opt,mu,opt1,aw,eiw,ejw
    Real(t_real),Pointer :: ek(:,:),ak(:)
    !!
    Nullify(ek,ak)
    !!
    mu=0
    nband=2
    Nk=100
    Ne=10000
    !!
    Call palloc('ek',ek,1_t_int,Nk,1_t_int,2_t_int,nmodule,nsubfunc)
    Call palloc('ak',ak,1_t_int,Nk,nmodule,nsubfunc)
    !!
    e0=-2.0_t_real
    e1= 3.0_t_real
    de=e1-e0
    k0=-1.0_t_real
    k1= 1.0_t_real
    dk=k1-k0
    !!
    Open(12,file='+ek')
    Do ik=1,Nk
       k=(ik-1.0_t_real)/(Nk-1.0_t_real)*dk+k0
       ek(ik,1)=Cos(k*pi)
       ek(ik,2)=1-Cos(k*pi)
       ak(ik)=Sin(k*pi/2)**2
       Write(12,"(3(e30.15e3,2x))") k,ek(ik,1),ek(ik,2)
    Enddo
    Close(12)
    !!
    !!
    tetwgt=pi*dk/(Nk-1.0_t_real)/twopi
    !!
    Open(12,file='+dos')
    Do ie=1,Ne
       e=(ie-1.0_t_real)/(Ne-1.0_t_real)*de+e0
       Do ib=1,nband
          Call dos1d(tetwgt,Nk-1,ek(:,ib),ak(:),e,dos(ib))
       Enddo
       !! (Theta(mu-ei)-Theta(mu-ej))*ak*delta(ei-ej-w)
       Write(12,"(4(e30.15e3,2x))") e,dos(1)+dos(2),dos(1),dos(2)
    Enddo
    Close(12)
    !!
    !! (Theta(mu-ei)-Theta(mu-ej))*ak*delta(ei-ej-w)
    e1=10.0_t_real
    Open(12,file='+opt')
    Do ie=1,Ne
       e=(ie-1.0_t_real)/(Ne-1.0_t_real)*e1+0.001_t_real
       opt=0.0_t_real
       opt1=0.0_t_real
       Do ib=1,nband
          Do jb=1,nband
             If(ib==jb) Continue

             Do it=1,Nk-1
                ei0=ek(it,ib)
                ei1=ek(it+1,ib)
                ej0=ek(it,jb)
                ej1=ek(it+1,jb)
                a0=ak(it)
                a1=ak(it+1)
                
                d0=ei0-ej0
                d1=ei1-ej1
                
                If(d0>d1)Then
                   dum=d0
                   d0=d1
                   d1=dum
                   dum=a0
                   a0=a1
                   a1=dum
                Endif
                If(d0<=e .And. e<d1)Then
                   aw=(a0+(a1-a0)/(d1-d0)*(e-d0))
                   eiw=(ei0+(ei1-ei0)*(e-d0)/(d1-d0))
                   ejw=(ej0+(ej1-ej0)*(e-d0)/(d1-d0))
                   opt1=opt1-tetwgt/(d1-d0)*aw*(theta(mu-eiw)-theta(mu-ejw))

                   a0=a0*(theta(mu-ei0)-theta(mu-ej0))
                   a1=a1*(theta(mu-ei1)-theta(mu-ej1))
                   aw=(a0+(a1-a0)/(d1-d0)*(e-d0))
                   opt=opt-tetwgt/(d1-d0)*aw
                Endif
             Enddo
             
          Enddo
       Enddo
       Write(12,"(4(e30.15e3,2x))") e,opt/e**2,opt1/e**2
    Enddo
    Close(12)
    !!
    !!
    !!
    Call pfree(ek)
    Call pfree(ak)
    !!
    Stop
    !!
    Return
    !!
  End Subroutine opticsDos
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine opticsDos3d(symmetry,structure,bzon)
    !!
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in)  :: structure
    Type(T_Bzone),Intent(inout)  :: bzon 
    !!LOCAL
    Character(*),Parameter::nsubfunc="opticsDos3d"
    Integer(t_int) :: ik,ib,nspin,nptdos,ie,nvdim,jb
    Integer(t_int),Parameter :: nvdimp=19
    Real(t_real)   :: emax,emin,e0,e1,spinfac,e,efermi
    Real(t_real)   :: qq(3),kk(3),kkj(3)
    Real(t_real)   :: Gvec(3,nvdimp)
    Real(t_real),Pointer :: ebk(:,:),optdos(:,:,:),optdosnew(:,:,:)
    Complex(t_real),Pointer:: abk(:,:,:,:)
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Data Gvec(:,1)/ 0.0_t_real, 0.0_t_real, 0.0_t_real/
    Data Gvec(:,2)/ 1.0_t_real, 0.0_t_real, 0.0_t_real/
    Data Gvec(:,3)/-1.0_t_real, 0.0_t_real, 0.0_t_real/
    Data Gvec(:,4)/ 0.0_t_real, 1.0_t_real, 0.0_t_real/
    Data Gvec(:,5)/ 0.0_t_real,-1.0_t_real, 0.0_t_real/
    Data Gvec(:,6)/ 0.0_t_real, 0.0_t_real, 1.0_t_real/
    Data Gvec(:,7)/ 0.0_t_real, 0.0_t_real,-1.0_t_real/

    Data Gvec(:, 8)/ 1.0_t_real, 1.0_t_real, 0.0_t_real/
    Data Gvec(:, 9)/-1.0_t_real, 1.0_t_real, 0.0_t_real/
    Data Gvec(:,10)/ 1.0_t_real,-1.0_t_real, 0.0_t_real/
    Data Gvec(:,11)/-1.0_t_real,-1.0_t_real, 0.0_t_real/

    Data Gvec(:,12)/ 1.0_t_real, 0.0_t_real, 1.0_t_real/
    Data Gvec(:,13)/-1.0_t_real, 0.0_t_real, 1.0_t_real/
    Data Gvec(:,14)/ 1.0_t_real, 0.0_t_real,-1.0_t_real/
    Data Gvec(:,15)/-1.0_t_real, 0.0_t_real,-1.0_t_real/

    Data Gvec(:,16)/ 0.0_t_real, 1.0_t_real, 1.0_t_real/
    Data Gvec(:,17)/ 0.0_t_real,-1.0_t_real, 1.0_t_real/
    Data Gvec(:,18)/ 0.0_t_real, 1.0_t_real,-1.0_t_real/
    Data Gvec(:,19)/ 0.0_t_real,-1.0_t_real,-1.0_t_real/
    !!
    Nullify(ebk,abk,optdos,optdosnew)
    !!
    nvdim=nvdimp
    nspin=1
    spinfac=2.0_t_real
    nptdos=101
    emin=-5.0_t_real
    emax=5.0_t_real
    efermi=5.0_t_real/hatoev
    e0=emin/hatoev
    e1=emax/hatoev

    !!
    !Print *,symmetry% reciprocial_lattice_vectors(:,1)
    !Print *,symmetry% reciprocial_lattice_vectors(:,2)
    !Print *,symmetry% reciprocial_lattice_vectors(:,3)
    Call palloc('ebk',ebk,1_t_int,nvdim,1_t_int,bzon% nkp&
         &,nmodule,nsubfunc)
    Call palloc('abk',abk,1_t_int,3_t_int,1_t_int,nvdim,1_t_int,nvdim&
         &,1_t_int,bzon% nkp,nmodule,nsubfunc)
    !!
    ebk=0.0_t_real
    abk=c0
    !!
    kloop: Do ik=1_t_int,bzon% nkp
       !!
       qq(:)=bzon% p_bk(:,ik)
       !!
       Do ib=1,nvdim
          kk(:)=Matmul(symmetry% reciprocial_lattice_vectors,Gvec(:,ib))
          ebk(ib,ik)=Sum((qq+kk)**2)*0.5_t_real
          Do jb=1,nvdim
             kkj(:)=Matmul(symmetry% reciprocial_lattice_vectors,Gvec(:,jb))
             e=Sqrt(Sum((qq+kk)**2))
             If(e<1.0e-6_t_real)e=1.0_t_real
             abk(:,ib,jb,ik)=abk(:,ib,jb,ik)+(qq+kk)*e**8
             e=Sqrt(Sum((qq+kkj)**2))
             If(e<1.0e-6_t_real)e=1.0_t_real
             abk(:,ib,jb,ik)=abk(:,ib,jb,ik)+(qq+kkj)*e**8
          Enddo
       Enddo
       !!
    End Do kloop
    !!
    Call palloc('optdos',optdos,1_t_int,nptdos,1_t_int,3_t_int&
         &,1_t_int,3_t_int,nmodule,nsubfunc)
    Call palloc('optdosnew',optdosnew,1_t_int,nptdos,1_t_int,3_t_int&
         &,1_t_int,3_t_int,nmodule,nsubfunc)

    !!
    optdosnew=0.0_t_real
    Print *,"before tetopt2"
    Call tetopt2(optdosnew,ebk,efermi,e1,e0,bzon% p_tet,nptdos&
         &,bzon% ntet,bzon% ntetsum,abk,spinfac&
         &,symmetry% Rnumops,symmetry% Ropmat,structure% vuc)
    Print *,"after tetopt2"
    !!
    optdos=0.0_t_real
    Call tetopt1(optdos,ebk,efermi,e1,e0,bzon% p_tet,nptdos&
         &,bzon% ntet,bzon% ntetsum,abk,spinfac&
         &,symmetry% Rnumops,symmetry% Ropmat,structure% vuc)
    !!
    !!
    Open(12,file='+imeps')
    Do ie=1,nptdos
       e=(emax-emin)*(ie-1.0_t_real)/(nptdos-1.0_t_real)+emin
       If(e==0)Then
          Write(12,"(10(e30.15e3,1x))")e,optdos(ie,1,1),optdosnew(ie,1,1)
       Else
          Write(12,"(10(e30.15e3,1x))")e,optdos(ie,1,1)/e**2*hatoev**2&
               &,optdosnew(ie,1,1)/e**2*hatoev**2
       Endif
    Enddo
    Close(12)
    !!
    Call pfree(ebk)
    Call pfree(abk)
    Call pfree(optdos)
    Call pfree(optdosnew)
    Stop
    Return
    !!
  End Subroutine opticsDos3d
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine sliny1(acorn,volwgt,ecorn,emin,emax,dos,npts)
    !!- Adds to density-of-states for one tetrahedron
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   volwgt:weight of irreducible tetrahedron
    !!i   ecorn :energies at corners of tetrahedron
    !!i   acorn :weigths of partial DOS at corners of tetrahedron
    !!i   emin  :lower bound of energy window
    !!i   emax  :upper bound of energy window
    !!io  dos   :density of states from tetrahedron
    !!i   npts  :number of dos tabulation points
    !!o Outputs:
    !!io  dos   :density of states from tetrahedron
    !!r Remarks:
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: npts
    Real(t_real),Intent(in)      :: volwgt,emin,emax
    Real(t_real),Intent(in)      :: acorn(4)
    Real(t_real),Intent(inout)   :: ecorn(4),dos(npts)
    !!LOCAL
    Integer(t_int) :: i,i0(4),m,iwk(4)
    Real(t_real)  :: de,e1,e2,e3,e4,c1,c2,c3,x,ac0,ec(4),ac(4)
    Real(t_real)   :: da41,da31,da21,da42,da43,a1,a2,a3,a4,q,x0
    Real(t_real)   :: de21,de31,de41,de42,de43,de32
    Real(t_real)   :: c4,q31,q41,dq,q1,q2,q3,q4
    !! ----sort ecorn -------
    Call dshel2(1_t_int,4_t_int,ecorn,iwk,1.0e-12_t_real)
    Do i=1,4
       ec(i)=ecorn(iwk(i)+1)
       ac(i)=acorn(iwk(i)+1)
    Enddo
    ac0=Sum(acorn)/4

    e1 = ec(1)
    e2 = ec(2)
    e3 = ec(3)
    e4 = ec(4)
    If (e4 < emin .Or. e1 > emax) Return
    a1 = ac(1)
    a2 = ac(2)
    a3 = ac(3)
    a4 = ac(4)
    de = (emax-emin)/(npts-1_t_int)
    Do m=1_t_int,4_t_int
       If (ec(m) < emin) Then
          i0(m)=1_t_int
       Elseif (ec(m) > emax) Then
          i0(m)=npts+1_t_int
       Else
          i0(m) = 2_t_int + Int((ec(m)-emin)/de - Epsilon(1.0_t_real)&
               &,t_int)
       Endif
    Enddo
    da21=a2-a1
    da31=a3-a1
    da41=a4-a1
    de31=1.0_t_real/(e3-e1)
    de41=1.0_t_real/(e4-e1)
    If (i0(1_t_int) < i0(2_t_int)) Then
       de21=1.0_t_real/(e2-e1)
       q=(da21*de21+da31*de31+da41*de41)*c1o3
       c3 = volwgt*3.0_t_real*de21*de31*de41
       x0 = emin-e1-de
       Do i = i0(1_t_int), i0(2_t_int)-1_t_int
          x = x0 + i*de
          dos(i) = dos(i) + c3*x*x*(a1 + x*q)
       Enddo
    Endif
    If (i0(2_t_int) < i0(3_t_int)) Then
       de21=e2-e1
       de42=e4-e2
       de32=e3-e2
       c4 = volwgt/(de32**2*de42**2)
       c3 = volwgt*3.0_t_real*(e1+e2-e3-e4)/(de32*de42)*de31*de41
       c2 = volwgt*6.0_t_real*de31*de41
       c1 = c2*de21*0.5_t_real

       !!
       q31=da31*de31
       q41=da41*de41
       q=q31+q41
       dq=da21+de21*q
       !!

       q1= a1 + dq*c1o3
       q2= a1 + dq*0.5_t_real
       q3= a1*c3 +da21*c3 +c2*q*0.5_t_real
       q4=+c3*(q-da21/de32)*c1o3&
            &-c4*(de42*q31+de32*(q41-da21*de41))
       !!
       x0 = emin-e2-de
       Do i = i0(2_t_int), i0(3_t_int)-1_t_int
          x = x0 + i*de
          dos(i) = dos(i)   + c1*q1  + x*(c2*q2  + x*(q3+x*q4))
       Enddo
    Endif
    If (i0(3_t_int) < i0(4_t_int)) Then
       de42=1.0_t_real/(e4-e2)
       de43=1.0_t_real/(e4-e3)
       da42=a4-a2
       da43=a4-a3
       q=(da41*de41+da42*de42+da43*de43)*c1o3
       c3 = volwgt*3.0_t_real*de42*de43*de41
       x0 = emin-e4-de
       Do i = i0(3_t_int), i0(4_t_int)-1_t_int
          x = x0 +i*de
          dos(i) = dos(i)  + c3*x*x*(a4+x*q)
       Enddo
    Endif
    !!
    Return
    !!
  End Subroutine sliny1
#endif
  !!***********************************************************************
  !!
#ifdef my_compile_unused
  Subroutine tetopt1(optdos,ebk,efermi,emax,emin,tet,ne,ntet,ntetsum&
       &,pmat,spinfac,numops,opmat,vuc)
    !!- optics integral Im eps(w)
    !!  sum_{nm} (F(e_n)-F(e_m))delta(e_n-e_m-w)*pmatel*pmatel
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   pmat  :momentum matrix element
    !!i   ebk   :band energies-efermi
    !!i   emax  :upper bound of energy window
    !!i   emin  :lower bound of energy window
    !!i   tet :tet(1-5,i) points to the 4 irreducible k-points defining
    !!i           the tetrahedron. tet(0,i)=no. of tetr. of the i'th kind
    !!i   nvdim :number of bands
    !!i   ne    :no of DOS tabulation points in energy range: [emin, emax]
    !!i   ntet  :number of different tetrahedra (output from TETIRR)
    !!o Outputs:
    !!o   optdos   :OPTDOS *w^2in [Ha^2]
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)   :: ntet,ne,numops
    Integer(t_int),Intent(in)   :: tet(0:5,ntet)
    Real(t_real),Intent(in)     :: opmat(3,3,48)
    Real(t_real),Intent(in)     :: spinfac,ntetsum
    Real(t_real),Intent(in)     :: ebk(:,:),emin,emax,efermi,vuc
    Real(t_real),Intent(out)    :: optdos(ne,3,3)
    Complex(t_real),Intent(in)  :: pmat(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: ib1,ib2,itet,ikp1,ikp2,ikp3,ikp4,nband,ik,i,j
    Integer(t_int) :: subdiv,jops,ie,n1,n2,fcorn1(4),fcorn2(4)
    Real(t_real)   :: ecorn1(4),ecorn2(4),tetwgt,volwgt,ebot,etop,acorn(4)
    Real(t_real)   :: dcorn(4),optdosym(3,3)
    !!
    volwgt = spinfac / ntetsum*fourpi*pi/vuc
    !!
    nband=Size(pmat,2)
    !!
    !!
    !!
    subdiv=(Max(1_t_int,ntet/(100/10)));

    !! --- Loop over tetrahedra ---
    tetloop: Do itet = 1_t_int, ntet
       !Print "('dos: ',f10.2,'%')",100.0_t_real*itet/ntet
       If ( Mod(itet,subdiv) ==0 .Or. itet==1 .Or.itet==ntet)Then
          Write(outfile,"('tetopt: ',f6.2,'% done')") &
               &100.0_t_real*itet/ntet
       Endif
       ikp1=tet(1,itet)
       ikp2=tet(2,itet)
       ikp3=tet(3,itet)
       ikp4=tet(4,itet)
       tetwgt=volwgt*tet(0,itet)
       
       !! ----- Loop over bands
       bandloop1: Do ib1=1,nband
          !! --------- SET UP ENERGIES AT 4 CORNERS OF TETRAHEDRA
          ecorn1(1) = ebk(ib1,ikp1)
          ecorn1(2) = ebk(ib1,ikp2)
          ecorn1(3) = ebk(ib1,ikp3)
          ecorn1(4) = ebk(ib1,ikp4)
          n1=0
          Do ik=1,4
             If(efermi>=ecorn1(ik))Then
                fcorn1(ik)=1
                n1=1
             Else
                fcorn1(ik)=0
             Endif
          Enddo
          If(All(efermi>=ecorn1(1:4))) n1=1
          bandloop2: Do ib2=1,nband
             ecorn2(1) = ebk(ib2,ikp1)
             ecorn2(2) = ebk(ib2,ikp2)
             ecorn2(3) = ebk(ib2,ikp3)
             ecorn2(4) = ebk(ib2,ikp4)
             n2=0
             Do ik=1,4
                If(efermi>=ecorn2(ik))Then
                   fcorn2(ik)=1
                   n2=1
                Else
                   fcorn2(ik)=0
                Endif
             Enddo
             !!
             If(n1-n2==0) Cycle
             !!
             fcorn2=0
             !!
             Do ik=1,4
                dcorn(ik)=ecorn1(ik)-ecorn2(ik)
             Enddo
             ebot = Minval(dcorn(1:4))
             etop = Maxval(dcorn(1:4))
             If (ebot >=  emax .Or. etop <= emin)Cycle
             
             Do i=1,3
                Do j=1,3
                   !!TODO: find correct expression !!!!
                   acorn(1)=-&
                        &  Real(pmat(i,ib1,ib2,ikp1)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp1)),t_real)&
                        !&  *(n1-n2)&
                        &  *(fcorn1(1)-fcorn2(1))&
                        &  *1
                   !!todo: fcorn
                   acorn(2)=-&
                        &  Real(pmat(i,ib1,ib2,ikp2)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp2)),t_real)&
                        !&  *(n1-n2)&
                        &  *(fcorn1(2)-fcorn2(2))&
                        &  *1
                   acorn(3)=-&
                        &  Real(pmat(i,ib1,ib2,ikp3)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp3)),t_real)&
                        !&  *(n1-n2)&
                        &  *(fcorn1(3)-fcorn2(3))&
                        &  *1
                   acorn(4)=-&
                        &  Real(pmat(i,ib1,ib2,ikp4)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp4)),t_real)&
                        !&  *(n1-n2)&
                        &  *(fcorn1(4)-fcorn2(4))&
                        &  *1
                   !!
                   Call sliny1(acorn,tetwgt,dcorn,emin,emax,optdos(:,i,j),ne)
                Enddo
             Enddo
          Enddo bandloop2
       Enddo bandloop1
    Enddo tetloop
    !!
    If (.Not.isoption('FULLBZ'))Then
       !!
       Do ie=1,ne
          optdosym(:,:)=0.0_t_real
          Do jops=1,numops
             optdosym(:,:)=optdosym(:,:)+Matmul( Transpose(opmat(:,:,jops))&
                  &,Matmul(optdos(ie,:,:),opmat(:,:,jops)))
          Enddo
          optdos(ie,:,:)=optdosym(:,:)/Real(numops,t_real)
       Enddo
       !!
    Endif
    !!
  End Subroutine tetopt1
#endif
  !!***********************************************************************
  !!
#ifdef my_compile_unused
  Subroutine tetopt2(optdos,ebk,efermi,emax,emin,tet,ne,ntet,ntetsum&
       &,pmat,spinfac,numops,opmat,vuc)
    !!- optics integral Im eps(w)
    !!  sum_{nm} (F(e_n)-F(e_m))delta(e_n-e_m-w)*pmatel*pmatel
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   pmat  :momentum matrix element
    !!i   ebk   :band energies-efermi
    !!i   emax  :upper bound of energy window
    !!i   emin  :lower bound of energy window
    !!i   tet :tet(1-5,i) points to the 4 irreducible k-points defining
    !!i           the tetrahedron. tet(0,i)=no. of tetr. of the i'th kind
    !!i   nvdim :number of bands
    !!i   ne    :no of DOS tabulation points in energy range: [emin, emax]
    !!i   ntet  :number of different tetrahedra (output from TETIRR)
    !!o Outputs:
    !!o   optdos   :OPTDOS *w^2in [Ha^2]
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)   :: ntet,ne,numops
    Integer(t_int),Intent(in)   :: tet(0:5,ntet)
    Real(t_real),Intent(in)     :: opmat(3,3,48)
    Real(t_real),Intent(in)     :: spinfac,ntetsum
    Real(t_real),Intent(inout)   :: emin,emax !! todo in
    Real(t_real),Intent(in)     :: ebk(:,:),efermi,vuc
    Real(t_real),Intent(out)    :: optdos(ne,3,3)
    Complex(t_real),Intent(in)  :: pmat(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: ib1,ib2,itet,ikp1,ikp2,ikp3,ikp4,nband,ik,i,j
    Integer(t_int) :: subdiv,jops,ie
    Real(t_real)   :: ecorn1(4),ecorn2(4),tetwgt,volwgt,ebot,etop,acorn(4)
    Real(t_real)   :: dcorn(4),optdosym(3,3)
    !!
    volwgt = spinfac / ntetsum*fourpi*pi/vuc
    !!
    nband=Size(pmat,2)
    !!
    !!
    !!
    subdiv=(Max(1_t_int,ntet/(100/10)));

    !! --- Loop over tetrahedra ---
    tetloop: Do itet = 1_t_int, ntet
       Print "('dos: ',f10.2,'%')",100.0_t_real*itet/ntet
       If ( Mod(itet,subdiv) ==0 .Or. itet==1 .Or.itet==ntet)Then
          Write(outfile,"('tetopt: ',f6.2,'% done')") &
               &100.0_t_real*itet/ntet
       Endif
       ikp1=tet(1,itet)
       ikp2=tet(2,itet)
       ikp3=tet(3,itet)
       ikp4=tet(4,itet)
       tetwgt=volwgt*tet(0,itet)
       
       !! ----- Loop over bands
       bandloop1: Do ib1=1,nband
          !! --------- SET UP ENERGIES AT 4 CORNERS OF TETRAHEDRA
          ecorn1(1) = ebk(ib1,ikp1)
          ecorn1(2) = ebk(ib1,ikp2)
          ecorn1(3) = ebk(ib1,ikp3)
          ecorn1(4) = ebk(ib1,ikp4)
          bandloop2: Do ib2=1,nband
             If(ib1==ib2)Cycle
             
             ecorn2(1) = ebk(ib2,ikp1)
             ecorn2(2) = ebk(ib2,ikp2)
             ecorn2(3) = ebk(ib2,ikp3)
             ecorn2(4) = ebk(ib2,ikp4)
             !!
             !!
             Do ik=1,4
                dcorn(ik)=ecorn1(ik)-ecorn2(ik)
             Enddo
             ebot = Minval(dcorn(1:4))
             etop = Maxval(dcorn(1:4))
             If (ebot >=  emax .Or. etop <= emin)Cycle
             
             Do i=1,3
                Do j=1,3
                   !!TODO: find correct expression !!!!
                   acorn(1)=-&
                        &  Real(pmat(i,ib1,ib2,ikp1)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp1)),t_real)
                   acorn(2)=-&
                        &  Real(pmat(i,ib1,ib2,ikp2)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp2)),t_real)
                   acorn(3)=-&
                        &  Real(pmat(i,ib1,ib2,ikp3)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp3)),t_real)
                   acorn(4)=-&
                        &  Real(pmat(i,ib1,ib2,ikp4)&
                        &  *Conjg(pmat(j,ib1,ib2,ikp4)),t_real)
                   !!
                   Call slinyopt(acorn,tetwgt,efermi,ecorn1,dcorn,emin,emax&
                        &,optdos(:,i,j),ne,1.0_t_real)
                   Call slinyopt(acorn,tetwgt,efermi,ecorn2,dcorn,emin,emax&
                        &,optdos(:,i,j),ne,-1.0_t_real)
                Enddo
             Enddo
          Enddo bandloop2
       Enddo bandloop1
    Enddo tetloop
    !!
    If (.Not.isoption('FULLBZ'))Then
       !!
       Do ie=1,ne
          optdosym(:,:)=0.0_t_real
          Do jops=1,numops
             optdosym(:,:)=optdosym(:,:)+Matmul( Transpose(opmat(:,:,jops))&
                  &,Matmul(optdos(ie,:,:),opmat(:,:,jops)))
          Enddo
          optdos(ie,:,:)=optdosym(:,:)/Real(numops,t_real)
       Enddo
       !!
    Endif
    !!
  End Subroutine tetopt2
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine slinyopt(acorn,volwgt,efermi,ecorn1,dcorn,emin,emax,dos&
       &,npts,fac)
    !!- Adds to density-of-states for one tetrahedron
    !! ----------------------------------------------------------------------
    !!i Inputs:
    !!i   volwgt:weight of irreducible tetrahedron
    !!i   dcorn :difference energies at corners of tetrahedron
    !!i   acorn :weigths of partial DOS at corners of tetrahedron
    !!i   emin  :lower bound of energy window
    !!i   emax  :upper bound of energy window
    !!io  dos   :density of states from tetrahedron
    !!i   npts  :number of dos tabulation points
    !!o Outputs:
    !!io  dos   :density of states from tetrahedron
    !!r Remarks:
    !! ----------------------------------------------------------------------
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: npts
    Real(t_real),Intent(in)      :: volwgt,emin,emax,efermi,fac
    Real(t_real),Intent(in)      :: acorn(4)
    Real(t_real),Intent(inout)   :: ecorn1(4),dcorn(4),dos(npts)
    !!LOCAL
    Integer(t_int) :: i,i0(4),m,iwk(4),k,j,ie,i2,i3,i4
    Character(10)  :: Case
    Logical(t_log) :: havekterm(4)
    Real(t_real)   :: de,d1,d2,d3,d4,c1,c2,c3,x,dc(4),ac(4),e,pre,prea,d,delta2
    Real(t_real)   :: da41,da31,da21,da42,da43,a1,a2,a3,a4,q,x0,ec1(4),y
    Real(t_real)   :: dd21,dd31,dd41,dd42,dd43,dd32,e1,e2,e3,e4,ekiw,akiw
    Real(t_real)   :: c4,q31,q41,dq,q1,q2,q3,q4,Dedki,pad,Dedji,Dadji,Dadki
    Real(t_real)   :: Ded21,Ded31,Ded41,Dad21,Dad31,Dad41,e21w,e31w,e41w
    Real(t_real)   :: ak21w,ak31w,ak41w,res,res1,dd14,dd24,dd34
    Real(t_real)   :: e14w,e24w,e34w,Ded14,Ded24,Ded34,Dad14,Dad24,Dad34
    Real(t_real)   :: kterm(4),ak14w,ak34w,Ded32,e32w,e42w,Ded42,pre2,mix
    Real(t_real)   :: Dad32,Dad42,Ded43,Dad43,ak32w,ak42w,dum,sig,w1,w2,w3,w4
    Real(t_real)   :: aa1,aa2,da32,aa3,aa4
    !! ----sort dcorn -------
    Call dshel2(1_t_int,4_t_int,dcorn,iwk,1.0e-12_t_real)
    Do i=1,4
       dc(i)=dcorn(iwk(i)+1)
       ec1(i)=ecorn1(iwk(i)+1)
       ac(i)=acorn(iwk(i)+1)
    Enddo

    d1 = dc(1)
    d2 = dc(2)
    d3 = dc(3)
    d4 = dc(4)
    e1 = ec1(1)
    e2 = ec1(2)
    e3 = ec1(3)
    e4 = ec1(4)
    If (d4 < emin .Or. d1 > emax) Return
    a1 = ac(1)
    a2 = ac(2)
    a3 = ac(3)
    a4 = ac(4)
    de = (emax-emin)/(npts-1_t_int)

    delta2=1e-4_t_real

    Do ie=1,npts
       e=(ie-1.0_t_real)*de+emin
       !!
       If(e<=d1)Then
          Case='no'
          res=0.0_t_real
          Cycle
       Endif
       !!
       If(e>d4)Then
          Case='all'
          res=0.0_t_real
          Cycle
       Endif
       !!
       res=0.0_t_real
       !!
       !Goto 200
       !!
       If(d1<e .And. e<=d2)Then
          
          x=e-d1 !! x>0
          dd21=d2-d1
          dd31=d3-d1
          dd41=d4-d1
          da21=a2-a1
          pre=volwgt/(dd21*dd31*dd41)
          Ded21=(e2-e1)/dd21
          Dad21=da21/dd21
          Ded31=(e3-e1)/dd31
          Dad31=(a3-a1)/dd31
          Ded41=(e4-e1)/dd41
          Dad41=(a4-a1)/dd41
          
          
          i4=4
          i3=3
          i2=2
          If(Ded41<Ded31)Then
             d=Ded41;Ded41=Ded31;Ded31=d
             d=Dad41;Dad41=Dad31;Dad31=d
             i=i4;i4=i3;i3=i
          Endif
          If(Ded41<Ded21)Then
             d=Ded41;Ded41=Ded21;Ded21=d
             d=Dad41;Dad41=Dad21;Dad21=d
             i=i4;i4=i2;i2=i
          Endif
          If(Ded31<Ded21)Then
             d=Ded31;Ded31=Ded21;Ded21=d
             d=Dad31;Dad31=Dad21;Dad21=d
             i=i3;i3=i2;i2=i
          Endif

          e21w=(e1+Ded21*x)
          e31w=(e1+Ded31*x)
          e41w=(e1+Ded41*x)

          If(e21w<=efermi .And. efermi < e31w)Then
             ak21w=a1+Dad21*x
             
             pad=1.0_t_real/(Ded31-Ded21)/(Ded41-Ded21)
             prea=  (Dad31-Dad21)/(Ded31-Ded21)&
                  &+(Dad41-Dad21)/(Ded41-Ded21)
             y=efermi-e21w
             res=pre*pad*(3*ak21w+prea*y)*y**2
             case='i1k2mu3'
          Else If(e31w<=efermi .And. efermi < e41w)Then
             Case='i1k3mu4'
             ak41w=a1+Dad41*x
             
             pad=1.0_t_real/(Ded21-Ded41)/(Ded31-Ded41)
             prea=  (Dad21-Dad41)/(Ded21-Ded41)&
                  &+(Dad31-Dad41)/(Ded31-Ded41)
             y=efermi-e41w
             res=pre*(3.0_t_real*a1+(Dad21+Dad31+Dad41)*x)*x**2&
                  &-pre*pad*(3*ak41w+prea*y)*y**2
             
          Else If(e41w<=efermi)Then
             Case='i1k4mu'
             res=pre*(3.0_t_real*a1+(Dad21+Dad31+Dad41)*x)*x**2

          Endif
          dos(ie)=dos(ie)+res*fac

          Cycle
       Else If(d2<e .And. e<=d3)Then
          Case="i2"
          !Print *,Case
          goto 200
          dd21=d2-d1
          dd31=d3-d1
          dd32=d3-d2
          dd41=d4-d1
          dd42=d4-d2
          dd43=d4-d3
          da21=a2-a1
          da31=a3-a1
          da32=a3-a2
          da41=a4-a1
          da42=a4-a2
          da43=a4-a3
          Ded21=(e2-e1)/dd21
          Ded31=(e3-e1)/dd31
          Ded32=(e3-e2)/dd32
          Ded41=(e4-e1)/dd41
          Ded42=(e4-e2)/dd42
          Ded43=(e4-e3)/dd43
          Dad21=da21/dd21
          Dad31=da31/dd31
          Dad32=(a3-a2)/dd32
          Dad41=(a4-a1)/dd41
          Dad42=da42/dd42
          Dad43=da43/dd43

          w1=e-d1
          w2=e-d2
          w3=e-d3
          w4=e-d4
          
          e31w=e1+Ded31*w1
          e32w=e2+Ded32*w2
          e41w=e1+Ded41*w1
          e42w=e2+Ded42*w2

          ak31w=a1+Dad31*w1
          ak32w=a2+Dad32*w2
          ak41w=a1+Dad41*w1
          ak42w=a2+Dad42*w2

          sig=1.0_t_real
          aa1=a1
          aa2=a2
          aa3=a3
          aa4=a4
          !!todo sort

          If(e31w<=e32w .And. e32w<=e41w .And. e41w<=e42w) Then
             ! probably done
             !Print *,'1234',e31w,e32w
             Case='1234'
          Else If(e31w<=e41w .And. e41w<=e32w .And. e32w<=e42w) Then
             !Print "('eeu',5(f22.8,1x))",e31w,efermi,e32w,e41w,e42w
             !Print *,'1324'
             Case='1324'
             !! q1<->q3:   q21=q43 q31=q13 q41=q32 q42=q24 
             !! q2<->q4
             dum=dd21;dd21=dd43;dd43=dum
             dd31=-dd31
             dd42=-dd42
             dum=dd41;dd41=-dd32;dd32=-dum
             dum=Ded21;Ded21=Ded43;Ded43=dum
             dum=Dad21;Dad21=Dad43;Dad43=dum
             dum=Ded41;Ded41=Ded32;Ded32=dum
             dum=Dad41;Dad41=Dad32;Dad32=dum
             dum=e32w;e32w=e41w;e41w=dum
             sig=-1.0_t_real

             dum=w3;w3=w1;w1=dum
             dum=w2;w2=w4;w4=dum
             dum=ak32w;ak32w=ak41w;ak41w=dum

             dum=da21;da21=da43;da43=dum
             da31=-da31
             da42=-da42

             aa1=a3
             aa2=a4
          Else If(e31w<=e32w .And. e32w<=e42w .And. e42w<=e41w) Then
             !Print "('eeu',5(f22.8,1x))",e31w,efermi,e32w,e41w,e42w
             !Print *,'1243'
             Case='1243'
          Else If(e32w<=e31w .And. e31w<=e42w .And. e42w<=e41w) Then
             Case='2143'
             !Print *,Case
             !! q1<->q2:  q21=-q21 q31=q32 q41=q42
             dum=e31w;e31w=e32w;e32w=dum
             dum=e41w;e41w=e42w;e42w=dum
             dum=ak31w;ak31w=ak32w;ak32w=dum
             dum=ak41w;ak41w=ak42w;ak42w=dum

             dd21=-dd21
             da21=-da21
             dum=dd31;dd31=dd32;dd32=dum
             dum=da31;da31=da32;da32=dum
             dum=dd41;dd41=dd42;dd42=dum
             dum=da41;da41=da42;da42=dum
             dum=Ded31;Ded31=Ded32;Ded32=dum
             dum=Dad31;Dad31=Dad32;Dad32=dum
             dum=Ded41;Ded41=Ded42;Ded42=dum
             dum=Dad41;Dad41=Dad42;Dad42=dum

             dum=w2;w2=w1;w1=dum
             
             aa1=a2
             aa2=a1
                          
          Else If(e32w<=e42w .And. e42w<=e31w .And. e31w<=e41w) Then
             Case='2413'
             !Print *,Case
             !! 2->3->1->4->2 : q31->q14 q41->q24 q42->q23 q32->q13
             !!               : q21->q34 q43->q21
             dum=e31w;e31w=e32w;e32w=e42w;e42w=e41w;e41w=dum
             dum=ak31w;ak31w=ak32w;ak32w=ak42w;ak42w=ak41w;ak41w=dum

             
             dum=dd43;dd43=-dd21;dd21=dum
             dum=da43;da43=-da21;da21=dum
             dum=dd31;dd31=-dd32;dd32=-dd42;dd42=-dd41;dd41=-dum
             dum=da31;da31=-da32;da32=-da42;da42=-da41;da41=-dum

             dum=Ded21;Ded21=Ded43;Ded43=dum
             dum=Dad21;Dad21=Dad43;Dad43=dum
             dum=Ded31;Ded31=Ded32;Ded32=Ded42;Ded42=Ded41;Ded41=dum
             dum=Dad31;Dad31=Dad32;Dad32=Dad42;Dad42=Dad41;Dad41=dum
             
             sig=-1.0_t_real

             dum=w3;w3=w2;w2=w4;w4=w1;w1=dum
                
             aa1=aa3
             aa2=aa4
          Else If(e41w<=e31w .And. e31w<=e32w .And. e32w<=e42w) Then
             Case='3124'
             !Print *,Case
             !! 1->3->2->4->1:  q31->q23 q32->q24 q42->q14 q41->q13
             !!                 q21->q43 q43->q12
             dum=e32w;e32w=e31w;e31w=e41w;e41w=e42w;e42w=dum
             dum=ak32w;ak32w=ak31w;ak31w=ak41w;ak41w=ak42w;ak42w=dum

             dum=dd21;dd21=-dd43;dd43=dum
             dum=da21;da21=-da43;da43=dum
             dum=dd31;dd31=-dd41;dd41=-dd42;dd42=-dd32;dd32=-dum
             dum=da31;da31=-da41;da41=-da42;da42=-da32;da32=-dum

             dum=Ded21;Ded21=Ded43;Ded43=dum
             dum=Dad21;Dad21=Dad43;Dad43=dum

             dum=Ded31;Ded31=Ded41;Ded41=Ded42;Ded42=Ded32;Ded32=dum
             dum=Dad31;Dad31=Dad41;Dad41=Dad42;Dad42=Dad32;Dad32=dum

             dum=w3;w3=w1;w1=w4;w4=w2;w2=dum
             
             sig=-1.0_t_real

             aa1=a4
             aa2=a3

             
          Else If(e41w<=e31w .And. e31w<=e42w .And. e42w<=e32w) Then
             Case='3142'
             !Print *,Case
             !!
             !! 3->2->4->1->3: q31->q23 q32->q24 q42->q14 q41->q13
             !!                q21->q43 q43->q12
             dum=e31w;e31w=e41w;e41w=e42w;e42w=e32w;e32w=dum
             dum=ak31w;ak31w=ak41w;ak41w=ak42w;ak42w=ak32w;ak32w=dum
             
             dum=dd21;dd21=-dd43;dd43=dum
             dum=da21;da21=-da43;da43=dum
             
             dum=dd31;dd31=-dd41;dd41=-dd42;dd42=-dd32;dd32=-dum
             dum=da31;da31=-da41;da41=-da42;da42=-da32;da32=-dum

             dum=Ded21;Ded21=Ded43;Ded43=dum
             dum=Dad21;Dad21=Dad43;Dad43=dum

             dum=Ded31;Ded31=Ded41;Ded41=Ded42;Ded42=Ded32;Ded32=dum
             dum=Dad31;Dad31=Dad41;Dad41=Dad42;Dad42=Dad32;Dad32=dum


             sig=-1.0_t_real

             dum=w3;w3=w1;w1=w4;w4=w2;w2=dum

             aa1=a4
             aa2=a3
          Else If(e41w<=e42w .And. e42w<=e31w .And. e31w<=e32w) Then
             Case='3412'
             !Print *,Case
             !! 3<->4: q31<->q41 
             
             dum=e31w;e31w=e41w;e41w=dum
             dum=e32w;e32w=e42w;e42w=dum
             dum=ak31w;ak31w=ak41w;ak41w=dum
             dum=ak32w;ak32w=ak42w;ak42w=dum

             dd43=-dd43
             da43=-da43

             dum=dd31;dd31=dd41;dd41=dum
             dum=dd32;dd32=dd42;dd42=dum
             dum=da31;da31=da41;da41=dum
             dum=da32;da32=da42;da42=dum

             dum=Ded31;Ded31=Ded41;Ded41=dum
             dum=Ded32;Ded32=Ded42;Ded42=dum
             dum=Dad31;Dad31=Dad41;Dad41=dum
             dum=Dad32;Dad32=Dad42;Dad42=dum

             dum=w3;w3=w4;w4=dum
          Else If(e41w<=e42w .And. e42w<=e32w .And. e32w<=e31w) Then
             Case='3421'
             !Print *,Case
             !! 3<->4: 
             dum=e31w;e31w=e41w;e41w=dum
             dum=e32w;e32w=e42w;e42w=dum
             dum=ak31w;ak31w=ak41w;ak41w=dum
             dum=ak32w;ak32w=ak42w;ak42w=dum

             dd43=-dd43
             da43=-da43
             
             dum=dd31;dd31=dd41;dd41=dum
             dum=dd32;dd32=dd42;dd42=dum
             dum=da31;da31=da41;da41=dum
             dum=da32;da32=da42;da42=dum

             dum=Ded31;Ded31=Ded41;Ded41=dum
             dum=Ded32;Ded32=Ded42;Ded42=dum
             dum=Dad31;Dad31=Dad41;Dad41=dum
             dum=Dad32;Dad32=Dad42;Dad42=dum
             
             dum=w3;w3=w4;w4=dum

          Else If(e42w<=e32w .And. e32w<=e31w .And. e31w<=e41w) Then
             Case='4213'
             !Print *,Case
             !! 2<->3 1<->4: q31->q24 q42->q13 q41->q14  q32->q23
             !!              q21->q34 q43->q12
             dum=e31w;e31w=e42w;e42w=dum
             dum=ak31w;ak31w=ak42w;ak42w=dum
             
             dum=dd21;dd21=-dd43;dd43=-dum
             dum=da21;da21=-da43;da43=-dum
             
             dum=dd31;dd31=-dd42;dd42=-dum
             dum=da31;da31=-da42;da42=-dum
             dd41=-dd41
             dd32=-dd32
             da41=-da41
             da32=-da32
             
             dum=Ded21;Ded21=Ded43;Ded43=dum
             dum=Dad21;Dad21=Dad43;Dad43=dum
             dum=Ded31;Ded31=Ded42;Ded42=dum
             dum=Dad31;Dad31=Dad42;Dad42=dum

             sig=-1.0_t_real

             dum=w3;w3=w2;w2=dum
             dum=w1;w1=w4;w4=dum
                
             aa1=a4
             aa2=a3
          Else If(e42w<=e32w .And. e32w<=e41w .And. e41w<=e31w) Then
             Case='4231'
             !Print *,Case
             !! 1<->4 2<->3: q31->q24 q42->q13 q32->q23 q41->q14
             !!            : q21->q34 q43->12
             dum=e31w;e31w=e42w;e42w=dum
             dum=ak31w;ak31w=ak42w;ak42w=dum
             
             dum=dd21;dd21=-dd43;dd43=-dum
             dum=da21;da21=-da43;da43=-dum

             dum=dd31;dd31=-dd42;dd42=-dum
             dum=da31;da31=-da42;da42=-dum
             dd32=-dd32
             dd41=-dd41
             da32=-da32
             da41=-da41
             
             dum=Ded21;Ded21=Ded43;Ded43=dum
             dum=Dad21;Dad21=Dad43;Dad43=dum
             dum=Ded31;Ded31=Ded42;Ded42=dum
             dum=Dad31;Dad31=Dad42;Dad42=dum

             dum=w3;w3=w2;w2=dum
             dum=w1;w1=w4;w4=dum

             aa1=a4;
             aa2=a3;
             
             sig=-1.0_t_real

          Else If(e42w<=e41w .And. e41w<=e32w .And. e32w<=e31w) Then
             Case='4321'
             !Print *,Case
             !! 1<->2 3<->4: q31->q42 q42->q31 q32->q41 q41->q32
             !!              q21->q12 q43->q34
             dum=e31w;e31w=e42w;e42w=dum
             dum=e32w;e32w=e41w;e41w=dum
             dum=ak31w;ak31w=ak42w;ak42w=dum
             dum=ak32w;ak32w=ak41w;ak41w=dum

             dd21=-dd21
             dd43=-dd43
             da21=-da21
             da43=-da43
             dum=dd31;dd31=dd42;dd42=dum
             dum=dd32;dd32=dd41;dd41=dum
             dum=da31;da31=da42;da42=dum
             dum=da32;da32=da41;da41=dum

             dum=Ded31;Ded31=Ded42;Ded42=dum
             dum=Ded32;Ded32=Ded41;Ded41=dum
             dum=Dad31;Dad31=Dad42;Dad42=dum
             dum=Dad32;Dad32=Dad41;Dad41=dum

             dum=w2;w2=w1;w1=dum
             dum=w3;w3=w4;w4=dum

             aa1=a2
             aa2=a1

          Else
             Stop 'here?'
          Endif
          

          
          If(Case=='1234' .Or. Case=='1324'  .Or. Case=='2143' .Or. &
               &Case=='2413' .Or. Case=='3142' .Or. Case=='3412'&
               & .Or.Case=='4231'.or.Case=='4321')Then
             If(e31w<=efermi .And. efermi<e32w)Then
                !Print *,'a20<a21'
                pre=volwgt/(dd21*dd31*dd41)*sig
                pad=1.0_t_real/(Ded21-Ded31)/(Ded41-Ded31)
                prea=  (Dad21-Dad31)/(Ded21-Ded31)&
                     &+(Dad41-Dad31)/(Ded41-Ded31)
                y=efermi-e31w
                res=pre*pad*(3.0_t_real*ak31w+prea*y)*y**2
                dos(ie)=dos(ie)+res*fac
                
                
             Else If(e32w<=efermi .And. efermi<e41w)Then
                !Print *,'a21<a30'
                pre=volwgt/(dd31*dd32*dd42*(Ded42-Ded32)**2)*sig
                y=efermi-e31w
                res=-pre*dd43*((Ded41-Ded31)*(Dad32-Dad42)&
                     &        +(Dad31-Dad41)*(Ded42-Ded32))*y**3&
                     &/((Ded41-Ded31)**2*dd41)
                
                res=res+pre*3.0_t_real*dd43&
                     &*((Ded31-Ded43)*(Dad42-Dad32)*w3+ak31w*(Ded42-Ded32))&
                     &*y**2/((Ded41-Ded31)*dd41)
                
                res=res-pre*3.0_t_real*(&
                     &   (Ded42-Ded32)*(ak31w+ak32w)&
                     &  +(Ded31-Ded32)*(Dad42-Dad32)*w3)*w3*y
                
                res=res-pre*(Ded31-Ded32)*(&
                     &+(Ded42-Ded32)*(ak31w+2.0_t_real*ak32w)&
                     &+(Ded31-Ded32)*(Dad42-Dad32)*w3&
                     &)*w3**2
                
                dos(ie)=dos(ie)+res*fac
                
                
             Else If(e41w<=efermi .And. efermi<e42w)Then
                !Print *,'a30<a31'
                pre=volwgt/(dd21*dd42*dd32)*sig
                pad=1.0_t_real/(Ded21-Ded42)/(Ded32-Ded42)
                prea=  (Dad21-Dad42)/(Ded21-Ded42)&
                     &+(Dad32-Dad42)/(Ded32-Ded42)
                y=efermi-e42w
                res=pre*pad*(3.0_t_real*ak42w+prea*y)*y**2
                
                pre=volwgt/dd31/dd41*sig
                pre2=1.0_t_real/(dd32*dd42)
                prea=(Dad31+Dad41)
                mix=dd32+dd41
                res=res+pre*dd21*(3.0_t_real*aa1+da21+dd21*prea)&
                     &+pre*3.0_t_real*(2.0_t_real*aa1+da21+dd21*prea)*w2&
                     &+pre*3.0_t_real*(-aa2*pre2*mix+prea)*w2**2&
                     &+pre*pre2*(-mix*(Dad42+Dad32+prea)+da42+da31)*w2**3
                
                
                dos(ie)=dos(ie)+res*fac
                
             Else If(e42w<=efermi)Then
                !Print *,'a31<'
                pre=volwgt/dd31/dd41*sig
                pre2=1.0_t_real/(dd32*dd42)
                prea=(Dad31+Dad41)
                mix=dd32+dd41
                res=pre*dd21*(3.0_t_real*aa1+da21+dd21*prea)&
                     &+pre*3.0_t_real*(2.0_t_real*aa1+da21+dd21*prea)*w2&
                     &+pre*3.0_t_real*(-aa2*pre2*mix+prea)*w2**2&
                     &+pre*pre2*(-mix*(Dad42+Dad32+prea)+da42+da31)*w2**3
                
                
                dos(ie)=dos(ie)+res*fac
                
             Endif
          Else If(Case=='1243' .Or. Case=='3124'  .Or. Case=='3421'&
               &.Or.Case=='4213')Then
             If(e31w<=efermi .And. efermi<e32w)Then
                !Print *,'a20<a21'
                pre=volwgt/(dd21*dd31*dd41)*sig
                pad=1.0_t_real/(Ded21-Ded31)/(Ded41-Ded31)
                prea=  (Dad21-Dad31)/(Ded21-Ded31)&
                     &+(Dad41-Dad31)/(Ded41-Ded31)
                y=efermi-e31w
                res=pre*pad*(3.0_t_real*ak31w+prea*y)*y**2
                dos(ie)=dos(ie)+res*fac
                
                
             Else If(e32w<=efermi .And. efermi<e42w)Then
                !Print *,'a21<a30'
                pre=volwgt/(dd31*dd32*dd42*(Ded42-Ded32)**2)*sig
                y=efermi-e31w
                res=-pre*dd43*((Ded41-Ded31)*(Dad32-Dad42)&
                     &        +(Dad31-Dad41)*(Ded42-Ded32))*y**3&
                     &/((Ded41-Ded31)**2*dd41)
                
                res=res+pre*3.0_t_real*dd43&
                     &*((Ded31-Ded43)*(Dad42-Dad32)*w3+ak31w*(Ded42-Ded32))&
                     &*y**2/((Ded41-Ded31)*dd41)
                
                res=res-pre*3.0_t_real*(&
                     &   (Ded42-Ded32)*(ak31w+ak32w)&
                     &  +(Ded31-Ded32)*(Dad42-Dad32)*w3)*w3*y
                
                res=res-pre*(Ded31-Ded32)*(&
                     &+(Ded42-Ded32)*(ak31w+2.0_t_real*ak32w)&
                     &+(Ded31-Ded32)*(Dad42-Dad32)*w3&
                     &)*w3**2
                
                dos(ie)=dos(ie)+res*fac
                
                
             Else If(e42w<=efermi .And. efermi<e41w)Then
                !Print *,'a31<a30'
                
                pre=volwgt/(dd21*dd31*dd41)*sig
                pad=1.0_t_real/((Ded21-Ded41)*(Ded31-Ded41))
                y=efermi-e41w
                prea=(Dad21-Dad41)/(Ded21-Ded41)+(Dad41-Dad31)/(Ded41-Ded31)
                res=-pre*pad*(3.0_t_real*ak41w+prea*y)*y**2
                
                pre=volwgt/dd31/dd41*sig
                pre2=1.0_t_real/(dd32*dd42)
                prea=(Dad31+Dad41)
                mix=dd32+dd41
                res=res+pre*dd21*(3.0_t_real*aa1+da21+dd21*prea)&
                     &+pre*3.0_t_real*(2.0_t_real*aa1+da21+dd21*prea)*w2&
                     &+pre*3.0_t_real*(-aa2*pre2*mix+prea)*w2**2&
                     &+pre*pre2*(-mix*(Dad42+Dad32+prea)+da42+da31)*w2**3
                
                
                dos(ie)=dos(ie)+res*fac
                
             Else If(e41w<=efermi)Then
                !Print *,'a30<'
                pre=volwgt/dd31/dd41*sig
                pre2=1.0_t_real/(dd32*dd42)
                prea=(Dad31+Dad41)
                mix=dd32+dd41
                res=pre*dd21*(3.0_t_real*aa1+da21+dd21*prea)&
                     &+pre*3.0_t_real*(2.0_t_real*aa1+da21+dd21*prea)*w2&
                     &+pre*3.0_t_real*(-aa2*pre2*mix+prea)*w2**2&
                     &+pre*pre2*(-mix*(Dad42+Dad32+prea)+da42+da31)*w2**3
                
                
                dos(ie)=dos(ie)+res*fac
             Endif
          Endif
          Cycle
!!$          res=iterm(1,efermi,e,ec1,ac,dc)*volwgt&
!!$               &+iterm(2,efermi,e,ec1,ac,dc)*volwgt
!!$          res=-iterm(3,efermi,e,ec1,ac,dc,.True.)*volwgt&
!!$               &-iterm(4,efermi,e,ec1,ac,dc,.True.)*volwgt
!!$          dos(ie)=dos(ie)+res*fac
       Else If(d3<e .And. e<=d4)Then
          x=e-d4
          dd14=d1-d4
          dd24=d2-d4
          dd34=d3-d4
          pre=volwgt/(dd14*dd24*dd34)
          Ded14=(e1-e4)/dd14
          Ded24=(e2-e4)/dd24
          Ded34=(e3-e4)/dd34

          Dad14=(a1-a4)/dd14
          Dad24=(a2-a4)/dd24
          Dad34=(a3-a4)/dd34

          i4=3
          i3=2
          i2=1
          If(Ded34>Ded24)Then
             d=Ded34;Ded34=Ded24;Ded24=d
             d=Dad34;Dad34=Dad24;Dad24=d
             i=i4;i4=i3;i3=i
          Endif
          If(Ded34>Ded14)Then
             d=Ded34;Ded34=Ded14;Ded14=d
             d=Dad34;Dad34=Dad14;Dad14=d
             i=i4;i4=i2;i2=i
          Endif
          If(Ded24>Ded14)Then
             d=Ded24;Ded24=Ded14;Ded14=d
             d=Dad24;Dad24=Dad14;Dad14=d
             i=i3;i3=i2;i2=i
          Endif

          e14w=(e4+Ded14*x)
          e24w=(e4+Ded24*x)
          e34w=(e4+Ded34*x)

          If(e14w<=efermi .And. efermi < e24w)Then
             
             Case='i1k2mu3'
             ak14w=a4+Dad14*x
             pad=1.0_t_real/(Ded24-Ded14)/(Ded34-Ded14)
             prea=  (Dad24-Dad14)/(Ded24-Ded14)&
                  &+(Dad34-Dad14)/(Ded34-Ded14)
             y=efermi-e14w
             res=-pre*pad*(3.0_t_real*ak14w+prea*y)*y**2
          Else If(e24w<=efermi .And. efermi < e34w)Then
             
             Case='i3k3mu4'
             ak34w=a4+Dad34*x
             pad=1.0_t_real/(Ded14-Ded34)/(Ded24-Ded34)
             prea=  (Dad14-Dad34)/(Ded14-Ded34)&
                  &+(Dad24-Dad34)/(Ded24-Ded34)
             y=efermi-e34w
             res=-pre*(3.0_t_real*a4+(Dad14+Dad24+Dad34)*x)*x**2&
                  &  +pre*pad*(3.0_t_real*ak34w+prea*y)*y**2
          Else If(e34w<=efermi)Then
             
             Case='i3k4mu'
             res=-pre*(3.0_t_real*a4+(Dad14+Dad24+Dad34)*x)*x**2
          Endif
          dos(ie)=dos(ie)+res*fac
          Cycle
       Else If(d4<e)Then
          Cycle
       Endif
       Cycle
       !!
200    Continue
       !!
       !Print *,'hier' 
       !!
       !! new full formula
       res1=0.0_t_real
       Do i=1,4
          x=e-dc(i)
          If(x<0.0_t_real)Then
             !Print *,'II=',i
             Cycle
          Endif
          !!
          pre=volwgt
          Do j=1,4
             If(j==i)Cycle
             d=(dc(j)-dc(i))
             d=d/(d**2+delta2)
             pre=pre*d
          Enddo
          kterm=0.0_t_real
          havekterm(:)=.False.
          Do k=1,4
             If(k==i)Cycle
             d=(dc(k)-dc(i))
             d=d/(d**2+delta2)
             Dedki=(ec1(k)-ec1(i))*d
             Dadki=(ac(k)-ac(i))*d
             ekiw=efermi-(ec1(i)+Dedki*x)
             !Write(outfile,"('e',i1,',',i1,'w=',1(f20.8,1x))")k,i,ekiw

             If(ekiw<0.0_t_real)Then
                Cycle
             Endif
             havekterm(k)=.True.
             akiw=ac(i)+(ac(k)-ac(i))*d*x
             pad=1.0_t_real
             prea=0.0_t_real
             Do j=1,4
                If(j==i .Or. j==k) Cycle
                d=(dc(j)-dc(i))
                d=d/(d**2+delta2)
                Dedji=(ec1(j)-ec1(i))*d
                Dadji=(ac(j)-ac(i))*d
                d=(Dedji-Dedki)
                d=d/(d**2+delta2)
                pad=pad*d
                prea=prea+(Dadji-Dadki)*d
             Enddo

!!$             If(Abs(pre-Prei(i,dc)*volwgt)>1.0e-10_t_real)&
!!$               &Print "('pre error',2(f20.8,1x))",pre,Prei(i,dc)*volwgt



!!$             If(Abs(prea-Preaki(k,i,ec1,ac,dc))>1.0e-10_t_real)&
!!$               &Print "('prea error',2(f20.8,1x))",prea,Preaki(k,i,ec1,ac,dc)

             kterm(k)=pre*pad*(3.0_t_real*akiw+prea*ekiw)*ekiw**2*theta(ekiw)*theta(x)


!!$             If(Abs(kterm(k)-ktermi(k,i,efermi,e,ec1,ac,dc)*volwgt)>1.0e-10_t_real)&
!!$                  &Print "('kterm error',2(f20.8,1x))",kterm(k)&
!!$                  &,ktermi(k,i,efermi,e,ec1,ac,dc)*volwgt

          Enddo
          If(Any(havekterm(:)))Then
             !Write(outfile,"('iterm=')",advance='no')
             !Do k=1,4
             !   If(.Not.havekterm(k)) Cycle
             !   Write(outfile,"(3x,(i4))",advance='no') k
             !Enddo
             !Write(outfile,*)
             Do k=1,4
                If(.Not.havekterm(k)) Cycle
                res1=res1+kterm(k)
             Enddo
          Endif
       Enddo
!!$       dos1(ie)=dos1(ie)+res1*fac
       dos(ie)=dos(ie)+res1*fac
       d=Abs(res-res1)
       If(Abs(res)/=0.0_t_real.And.Abs(res1)/=0.0_t_real)Then
          d=d/Abs(res)
       Endif
!!$       If(d>1.0e-6_t_real )Then
!!$          Print "('case: ',a5,3(i4),' dos: ',2(e30.15e3))"&
!!$               &,Case,i2,i3,i4,res/volwgt,res1/volwgt
!!$       Endif

       !Print *,'hier',dos1(ie)

    Enddo

    Return
    !!

    Do m=1_t_int,4_t_int
       If (dc(m) < emin) Then
          i0(m)=1_t_int
       Elseif (dc(m) > emax) Then
          i0(m)=npts+1_t_int
       Else
          i0(m) = 2_t_int + Int((dc(m)-emin)/de - Epsilon(1.0_t_real)&
               &,t_int)
       Endif
    Enddo
    da21=a2-a1
    da31=a3-a1
    da41=a4-a1
    dd31=1.0_t_real/(d3-d1)
    dd41=1.0_t_real/(d4-d1)
    If (i0(1_t_int) < i0(2_t_int)) Then
       dd21=1.0_t_real/(d2-d1)
       q=(da21*dd21+da31*dd31+da41*dd41)*c1o3
       c3 = volwgt*3.0_t_real*dd21*dd31*dd41
       x0 = emin-d1-de
       Do i = i0(1_t_int), i0(2_t_int)-1_t_int
          x = x0 + i*de
          dos(i) = dos(i) + c3*x*x*(a1 + x*q)
       Enddo
    Endif
    If (i0(2_t_int) < i0(3_t_int)) Then
       dd21=d2-d1
       dd42=d4-d2
       dd32=d3-d2
       c4 = volwgt/(dd32**2*dd42**2)
       c3 = volwgt*3.0_t_real*(d1+d2-d3-d4)/(dd32*dd42)*dd31*dd41
       c2 = volwgt*6.0_t_real*dd31*dd41
       c1 = c2*dd21*0.5_t_real

       !!
       q31=da31*dd31
       q41=da41*dd41
       q=q31+q41
       dq=da21+dd21*q
       !!

       q1= a1 + dq*c1o3
       q2= a1 + dq*0.5_t_real
       q3= a1*c3 +da21*c3 +c2*q*0.5_t_real
       q4=+c3*(q-da21/dd32)*c1o3&
            &-c4*(dd42*q31+dd32*(q41-da21*dd41))
       !!
       x0 = emin-d2-de
       Do i = i0(2_t_int), i0(3_t_int)-1_t_int
          x = x0 + i*de
          dos(i) = dos(i)   + c1*q1  + x*(c2*q2  + x*(q3+x*q4))
       Enddo
    Endif
    If (i0(3_t_int) < i0(4_t_int)) Then
       dd42=1.0_t_real/(d4-d2)
       dd43=1.0_t_real/(d4-d3)
       da42=a4-a2
       da43=a4-a3
       q=(da41*dd41+da42*dd42+da43*dd43)*c1o3
       c3 = volwgt*3.0_t_real*dd42*dd43*dd41
       x0 = emin-d4-de
       Do i = i0(3_t_int), i0(4_t_int)-1_t_int
          x = x0 +i*de
          dos(i) = dos(i)  + c3*x*x*(a4+x*q)
       Enddo
    Endif
    !!
    Return
    !!
  End Subroutine slinyopt
#endif
  !!***********************************************************************
  Real(t_real) Function Prei(i,d)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: i
    Real(t_real),Intent(in)      :: d(4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="Prei"
    Integer(t_int) :: j
    !!
    !!
    Prei=1.0_t_real
    Do j=1,4
       If(j==i) Cycle
       Prei=Prei/(d(j)-d(i))
    Enddo
    !!
    Return
    !!
  End Function Prei
  !!***********************************************************************
  Real(t_real) Function Padki(k,i,a,d)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: i,k
    Real(t_real),Intent(in)      :: a(4),d(4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="Padki"
    Integer(t_int) :: j
    !!
    !!
    Padki=1.0_t_real
    Do j=1,4
       If(j==i .Or. j==k) Cycle
       Padki=Padki/( (a(j)-a(i))/(d(j)-d(i))-(a(k)-a(i))/(d(k)-d(i)) )
    Enddo
    !!
    Return
    !!
  End Function Padki
  !!***********************************************************************
  Real(t_real) Function Preaki(k,i,a,c,d)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: i,k
    Real(t_real),Intent(in)      :: a(4),c(4),d(4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="Preaki"
    Integer(t_int) :: j
    !!
    !!
    Preaki=0.0_t_real
    Do j=1,4
       If(j==i .Or. j==k) Cycle
       Preaki=Preaki&
            &+( (c(j)-c(i))/(d(j)-d(i))-(c(k)-c(i))/(d(k)-d(i)) )/&
            &( (a(j)-a(i))/(d(j)-d(i))-(a(k)-a(i))/(d(k)-d(i)) )
    Enddo
    !!
    Return
    !!
  End Function Preaki
  !!***********************************************************************
  Real(t_real) Function Awki(k,i,w,A,d)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: i,k
    Real(t_real),Intent(in)      :: w,A(4),d(4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="Awki"
    !!
    !!
    Awki=a(i)+(A(k)-A(i))/(d(k)-d(i))*(w-d(i))
    !!
    Return
    !!
  End Function Awki
  !!***********************************************************************
  Real(t_real) Function ktermi(k,i,mu,w,a,c,d,notheta)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in),Optional    :: notheta
    Integer(t_int),Intent(in)    :: i,k
    Real(t_real),Intent(in)      :: mu,w,a(4),c(4),d(4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="ktermi"
    Logical(t_log) :: not
    Real(t_real)   :: xa,q
    !!
    not=.False.
    If(Present(notheta))not=notheta
    !!
    If(k==i)Then
       ktermi=0.0_t_real
       Return
    Endif
    !!
    xa=(mu-Awki(k,i,w,a,d))
    q=Prei(i,d)*Padki(k,i,a,d)*(3.0_t_real*Awki(k,i,w,c,d)&
            &+Preaki(k,i,a,c,d)*xa)*xa**2
    If(not)Then
       ktermi=q
    Else
       ktermi=q*Theta(xa)
    Endif
    !!
    Return
    !!
  End Function ktermi
  !!***********************************************************************
  Real(t_real) Function iterm(i,mu,w,a,c,d,notheta)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in),Optional    :: notheta
    Integer(t_int),Intent(in)    :: i
    Real(t_real),Intent(in)      :: mu,w,a(4),c(4),d(4)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="iterm"
    Logical(t_log) :: not
    Integer(t_int) :: k
    Real(t_real)   :: q
    !!
    not=.False.
    If(Present(notheta))not=notheta
    !!
    !!
    q=0.0_t_real
    Do k=1,4
       If(k==i)Cycle
       q=q+ktermi(k,i,mu,w,a,c,d)
    Enddo
    !!
    If(not)Then
       iterm=q
    Else
       iterm=q*Theta(w-d(i))
    Endif
    Return
    !!
  End Function iterm
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine fifotest()
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="fifotest"
    Character(50000)   :: txt
    Integer(t_int) :: n
    Integer :: io
    !!
    Open(12,file='fplofifo',status='old')
    Call system('gzip -dc +bweights.gz 2> log > fplofifo &')
    Print *,'here'
    n=0
    Do 
       Print *,'loop'
       Read(12,"(a)",iostat=io)txt
       Print *,io
       If(io/=0) Exit
       n=n+1
       !Print "('n=',i12,' txt=<',a,'>')",n,Trim(txt)
       Print "('n=',i12)",n
       !Read(12,*,iostat=io)r
       !If(io/=0) Exit
       !Exit
    Enddo
    Print *,'done'
    !Print "('<',i5,'>')",i
    !Print "('<',3f12.5,'>')",r
    !!
    Stop
    !!
    Return
    !!
  End Subroutine fifotest
#endif
  !!***********************************************************************
!!$  Subroutine testdiagnounit2x2()
!!$    !!
!!$    Implicit None
!!$    !!IO
!!$    !!LOCAL
!!$    Character(*),Parameter::nsubfunc="testdiagnounit2x2"
!!$    Real(t_real)   :: tol,x
!!$    Integer(t_int) :: n
!!$    Character(200)   :: str
!!$    Complex(t_real):: M(2,2),det,e(2),T(2,2),ee(2,2),E1(2,2)
!!$    Complex(t_real),Parameter:: c1=(1.0_t_real,0.0_t_real)
!!$    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
!!$    Data E1 /c1,c0,c0,c1/
!!$    !!
!!$    tol=1.0e-10_t_real
!!$    !!
!!$    e(1)=rndmst(1)
!!$    n=0
!!$    Do 
!!$       n=n+1
!!$       Print *,'test ',n
!!$       det=Exp(Cmplx(0.0_t_real,rndmcm()*twopi,t_real))
!!$       Print *,'det=',det
!!$       M(1,1)=Cmplx(rndmcm()*2.0_t_real-1.0_t_real,rndmcm()*2.0_t_real-1.0_t_real,t_real)
!!$       M(1,2)=Cmplx(rndmcm()*2.0_t_real-1.0_t_real,rndmcm()*2.0_t_real-1.0_t_real,t_real)
!!$       M(2,2)=Conjg(M(1,1))
!!$       M(2,1)=-Conjg(M(1,2))
!!$       !!
!!$       T=Matmul(Transpose(Conjg(M)),M)
!!$       M=M/Sqrt(T(1,1))
!!$       M=M*det
!!$       Call cprintmat('M',"('(',f12.5,',',f12.5,')')"&
!!$            &,"('             0             ')"&
!!$            &,M)
!!$       T=Matmul(Transpose(Conjg(M)),M)
!!$       Call cprintmat('M',"('(',f12.5,',',f12.5,')')"&
!!$            &,"('             0             ')"&
!!$            &,T)
!!$       !!
!!$       T=M
!!$       Call diagnounit2x2(M,e)
!!$       !!
!!$       Print *,'e=',e
!!$       Call cprintmat('V',"('(',f12.5,',',f12.5,')')"&
!!$            &,"('             0             ')"&
!!$            &,M)
!!$       Call cprintmat('1',"('(',f30.15,',',f30.15,')')"&
!!$            &,"('                              0                                ')"&
!!$            &,Matmul(Transpose(Conjg(M)),M),tol=1.0e-15_t_real)
!!$       
!!$       If(Any(Abs(Matmul(Transpose(Conjg(M)),M)-E1)>tol))Then
!!$          Print *,'error'
!!$          Stop
!!$       Endif
!!$       
!!$       ee=c0
!!$       ee(1,1)=e(1)
!!$       ee(2,2)=e(2)
!!$       Call cprintmat('0',"('(',f12.5,',',f12.5,')')"&
!!$            &,"('             0             ')"&
!!$            &,Matmul(T,M)-Matmul(M,ee))
!!$       
!!$       Call cprintmat('0',"('(',f12.5,',',f12.5,')')"&
!!$            &,"('             0             ')"&
!!$            &,Matmul(Matmul(M,EE),Transpose(Conjg(M)))-T,tol=1.0e-15_t_real)
!!$       
!!$       If(Any(Abs(Matmul(Matmul(M,EE),Transpose(Conjg(M)))-T)>tol))Then
!!$          Print *,'error'
!!$          Stop
!!$       Endif
!!$
!!$    Enddo
!!$    Stop
!!$    !!
!!$    Return
!!$    !!
!!$  End Subroutine testdiagnounit2x2
  !!***********************************************************************
  Subroutine Djtest()
    !!
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="Djtest"
    Integer(t_int) :: j,i,k,kap,mu,ms
    Real(t_real)   :: fac(1000),eulang(3),nx(3),nz(3)
    Complex(t_real),Pointer:: cdjmm(:,:)
    Real(t_real):: cgordon(2)
    Type(T_Quant) :: quant
    !!
    Call make_factorials(fac,40_t_int)
    !!
    eulang(1)=0.2
    eulang(2)=-0.77
    eulang(3)=2.4
    nx=(/0.1,-0.2,3.4/)
    nz=(/-1.1,-2.2,-0.34/)
    quant% axis=nz
    Call reuler2(nz,nx,eulang)
    !!
    If(.False.)Then
       Do j=1,5
          Write(outfile,"('j=',i5)")j
          Call palloc('cdjmm',cdjmm,1_t_int,j+1,1_t_int,j+1,nmodule,nsubfunc)
          !!
          Call wignerDJ(j,eulang,cdjmm,fac,.False.)
          !!
          !cdjmm=Transpose(cdjmm)
          !!
          Do i=1,j+1
             Do k=1,j+1
                Write(outfile,"(f12.5,' ',f12.5,' ')",advance='no')cdjmm(i,k)
             Enddo
             Write(outfile,"()")
          Enddo
       Enddo
    Endif

    If(.false.)Then
       Call setup_quant(quant,FULL_RELATIVISTIC,0_t_int)
       Do i=2,1,-1
          Do k=2,1,-1
             Write(outfile,"(f12.5,' ',f12.5,' ')",advance='no')quant% D1o2(i,k)
          Enddo
          Write(outfile,"()")
       Enddo
    Endif


    Do kap=-3,3
       Do mu=-9,9
          Call chi_km(kap,mu,cgordon)
          Do ms=1,2
             Write(outfile,"('c(',i3,',',i3,',',i3,')=',f12.5)") kap,mu,ms,cgordon(ms)
          Enddo
       Enddo
    Enddo

    Stop
    Return
    !!
  End Subroutine Djtest
  !!***********************************************************************
  Real(t_real) Function W3J_not_optim(j1,m1,j2,m2,j3,m3)
    !! not tested for half integer andnot optimized ->for testing
    Implicit None
    !!IO
    Real(t_real),Intent(in)    :: j1,m1,j2,m2,j3,m3
    !!LOCAL
    Integer(t_int) :: k
    Real(t_real)   :: sign,denom,pre,su
    Real(t_real),Parameter :: tol=1.0e-6
    !Character(*),Parameter::nsubfunc="W3J_not_optim"
    !!
    W3J_not_optim=0.0_t_real
    !!
    sign=(-1.0_t_real)**(-j1+j2+m3)
    su=0.0_t_real
    !!
    If(abs(m1+m2+m3)>tol ) Return
    If( j1<0.Or.j2<0.Or.j3<0 ) Return
    If( m1<-j1.Or.m1>j1 ) Return
    If( m2<-j2.Or.m2>j2 ) Return
    If( m2<-j2.Or.m2>j2 ) Return

    If(Abs(2*j1-Nint(2*j1))>tol) Return
    If(Abs(2*j2-Nint(2*j2))>tol) Return
    If(Abs(2*j3-Nint(2*j3))>tol) Return
    If(Abs(j1+j2+j3-Nint(j1+j2+j3))>tol) Return
    If(Abs(j1-m1-Nint(j1-m1))>tol) Return
    If(Abs(j2-m2-Nint(j2-m2))>tol) Return
    If(Abs(j3-m3-Nint(j3-m3))>tol) Return

    If( j3<Abs(j1-j2).Or.j3>j1+j2 )Return
    denom=Sqrt(rfac(j1+j2-j3)*rfac(j1-j2+j3)*rfac(-j1+j2+j3)*rfac(j2-m2)*rfac(j2+m2))
    pre=Sqrt(rfac(1+j1+j2+j3)*rfac(j1-m1)*rfac(j1+m1)*rfac(j3-m3)*rfac(j3+m3))

    Do k=0,Min(Nint(j1-m1),Nint(j3+m3))
       su=su+((-1.0_t_real)**(k+j1-m1)*rfac(-k+j2+j3-m1)*rfac(-k+j1+j2+m3))&
            &/(rfac(k*1.0_t_real)* rfac(1-k+j1+j2+j3) *rfac(-k+j1-m1) *rfac(-k+j3+m3))
    Enddo
    W3J_not_optim=(sign*pre*su)/denom
    !!
    Return
    !!
    !!
  End Function W3J_not_optim
  !!***********************************************************************
  Real(t_real) Function ClebschGordon_not_optim_int(l1,m1,l2,m2,l3,m3)
    !! <l1m1l2m2|l3m3>, integer momenta
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: l1,m1,l2,m2,l3,m3
    !!LOCAL
    !Character(*),Parameter::nsubfunc="ClebschGordon_not_optim_int"
    !!
    ClebschGordon_not_optim_int=(-1.0_t_real)**(l1-l2+m3)&
         &*Sqrt(2.0_t_real*l3+1.0_t_real)&
         &*W3J_not_optim(&
         & l1*1.0_t_real, m1*1.0_t_real&
         &,l2*1.0_t_real, m2*1.0_t_real&
         &,l3*1.0_t_real,-m3*1.0_t_real&
         &)
    !!
  End Function ClebschGordon_not_optim_int
  !!***********************************************************************
  Real(t_real) Function  rfac(x)
    !! valid for integer and half integer
    Implicit None 
    !!IO
    Real(t_real),Intent(in) :: x
    !!LOCAL
    Real(t_real)   :: y
    !!
    rfac=1.0_t_real
    !!
    !!
    y=x
    Do While(y>1.0e-6_t_real)
       rfac=rfac*y
       y=y-1.0_t_real
    Enddo
    !!
    If(Abs(y+0.5_t_real)<1.0e-6_t_real)Then
       rfac=rfac*sqpi
    Endif
    !!
  End Function rfac
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine LopxyzTcxylm(lmax,cyp,lopcyp)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: lmax
    Complex(t_real),Intent(in)   :: cyp(:)
    Complex(t_real),Intent(out)  :: lopcyp(:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="LopxyzTcxylm"
    Integer(t_int) :: l,m,ilm
    Real(t_real)   :: cp,cm
    Complex(t_real):: yp,ym
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    !!
    Do l=0,lmax
       Do m=-l,l
          cp=Sqrt(l*(l+1.0_t_real)-m*(m+1.0_t_real))
          cm=Sqrt(l*(l+1.0_t_real)-m*(m-1.0_t_real))
          ilm=l*l+l+1+m
          yp=c0
          ym=c0
          If(m<l) yp=cyp(ilm+1)
          If(m>-l) ym=cyp(ilm-1)
          lopcyp(1,ilm)=    (yp*cp+ym*cm)*0.5_t_real
          lopcyp(2,ilm)=-ci*(yp*cp-ym*cm)*0.5_t_real
          lopcyp(3,ilm)=cyp(ilm)*m
          
       Enddo
    Enddo
    !!
    !!
    Return
    !!
  End Subroutine LopxyzTcxylm
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine gradTcxylm(lmax,rsh,cyp,gradcyp)
    !! r*\nabla*Ylm (compelx Y)
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: lmax
    Real(t_real),Intent(in)      :: rsh(3)
    Complex(t_real),Intent(in)   :: cyp(:)
    Complex(t_real),Intent(out)  :: gradcyp(:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="gradTcxylm"
    Integer(t_int) :: l,m,ilm
    Real(t_real)   :: cp,cm,r
    Complex(t_real):: yp,ym,lopcyp(3),er(3)
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    !!
    r=Sqrt(Sum(rsh(:)**2))
    er=-ci*rsh/r**2
    !!
    Do l=0,lmax
       Do m=-l,l
          cp=Sqrt(l*(l+1.0_t_real)-m*(m+1.0_t_real))
          cm=Sqrt(l*(l+1.0_t_real)-m*(m-1.0_t_real))
          ilm=l*l+l+1+m
          yp=c0
          ym=c0
          If(m<l) yp=cyp(ilm+1)
          If(m>-l) ym=cyp(ilm-1)
          lopcyp(1)=    (yp*cp+ym*cm)*0.5_t_real
          lopcyp(2)=-ci*(yp*cp-ym*cm)*0.5_t_real
          lopcyp(3)=cyp(ilm)*m

          Call cross_c(er,lopcyp,gradcyp(:,ilm))
          
       Enddo
    Enddo
    !!
    !!
    Return
    !!
  End Subroutine gradTcxylm
#endif
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine gradTLopTcxylm(lmax,rsh,cyp,gradlopcyp)
    !! r*\nabla*Ylm (compelx Y)
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: lmax
    Real(t_real),Intent(in)      :: rsh(3)
    Complex(t_real),Intent(in)   :: cyp(:)
    Complex(t_real),Intent(out)  :: gradlopcyp(:,:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="gradTLopTcxylm"
    Integer(t_int) :: l,m,ilm
    Real(t_real)   :: cp,cm,r,cpp,cmm
    Complex(t_real):: yp,ym,er(3),yp2,ym2,llopcyp(3,3)
    Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    !!
    r=Sqrt(Sum(rsh(:)**2))
    er=-ci*rsh/r**2
    !!
    Do l=0,lmax
       Do m=-l,l
          cp=Sqrt(l*(l+1.0_t_real)-m*(m+1.0_t_real))
          cpp=0.0_t_real
          cm=Sqrt(l*(l+1.0_t_real)-m*(m-1.0_t_real))
          cmm=0.0_t_real
          ilm=l*l+l+1+m
          yp=c0
          yp2=c0
          ym=c0
          ym2=c0
          If(m<l) yp=cyp(ilm+1)
          If(m>-l) ym=cyp(ilm-1)
          If(m<l-1) Then
             yp2=cyp(ilm+2)
             cpp=Sqrt(l*(l+1.0_t_real)-(m+1)*(m+2.0_t_real))
          Endif
          If(m>-l+1)Then
             ym2=cyp(ilm-2)
             cmm=Sqrt(l*(l+1.0_t_real)-(m-1)*(m-2.0_t_real))
          Endif


          llopcyp(1,1)=    0.25_t_real*((yp2*cp*cpp+cyp(ilm)*cm*cm)+(cyp(ilm)*cp*cp+ym2*cm*cmm))
          llopcyp(1,2)=-ci*0.25_t_real*((yp2*cp*cpp-cyp(ilm)*cm*cm)+(cyp(ilm)*cp*cp-ym2*cm*cmm))
          llopcyp(1,3)=    0.50_t_real*(yp*cp+ym*cm)*m

          llopcyp(2,1)=-ci*0.25_t_real*((yp2*cp*cpp+cyp(ilm)*cm*cm)-(cyp(ilm)*cp*cp+ym2*cm*cmm))
          llopcyp(2,2)=-   0.25_t_real*((yp2*cp*cpp-cyp(ilm)*cm*cm)-(cyp(ilm)*cp*cp-ym2*cm*cmm))
          llopcyp(2,3)=-ci*0.50_t_real*(yp*cp-ym*cm)*m

          llopcyp(3,1)=    0.5_t_real*(yp*cp*(m+1)+ym*cm*(m-1))
          llopcyp(3,2)=-ci*0.5_t_real*(yp*cp*(m+1)-ym*cm*(m-1))
          llopcyp(3,3)=               cyp(ilm)*m**2

          gradlopcyp(1,1,ilm)=er(2)*llopcyp(3,1)-er(3)*llopcyp(2,1)
          gradlopcyp(2,1,ilm)=er(3)*llopcyp(1,1)-er(1)*llopcyp(3,1)
          gradlopcyp(3,1,ilm)=er(1)*llopcyp(2,1)-er(2)*llopcyp(1,1)

          gradlopcyp(1,2,ilm)=er(2)*llopcyp(3,2)-er(3)*llopcyp(2,2)
          gradlopcyp(2,2,ilm)=er(3)*llopcyp(1,2)-er(1)*llopcyp(3,2)
          gradlopcyp(3,2,ilm)=er(1)*llopcyp(2,2)-er(2)*llopcyp(1,2)

          gradlopcyp(1,3,ilm)=er(2)*llopcyp(3,3)-er(3)*llopcyp(2,3)
          gradlopcyp(2,3,ilm)=er(3)*llopcyp(1,3)-er(1)*llopcyp(3,3)
          gradlopcyp(3,3,ilm)=er(1)*llopcyp(2,3)-er(2)*llopcyp(1,3)


          
       Enddo
    Enddo
    !!
    !!
    Return
    !!
  End Subroutine gradTLopTcxylm
#endif
  !!***********************************************************************
  Subroutine gradTylm(lmax,rsh,ylm,gradylm)
    !! r*\nabla*Ylm (real Y)
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: lmax
    Real(t_real),Intent(in)      :: rsh(3)
    Real(t_real),Intent(in)      :: ylm(:)
    Real(t_real),Intent(out)     :: gradylm(:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="gradylm"
    Integer(t_int) :: l,m,ilm
    Real(t_real)   :: r
    Real(t_real):: lopylm(3),er(3)
    !!
    r=Sqrt(Sum(rsh(:)**2))
    er=rsh/r**2
    !!
    Do l=0,lmax
       Do m=-l,l
          ilm=l*l+l+1+m

          Call mitlopxyzTylm(ylm,l,m,lopylm)
          
          ! -i/r*er\times L ylm
          Call cross(er,lopylm,gradylm(:,ilm))
          
       Enddo
    Enddo
    !!
    !!
    Return
    !!
  End Subroutine gradTylm
  !!***********************************************************************
  Subroutine mitlopxyzTylm(ylm,l,m,lopylm)
    !!
    !! return -i*\vec{L}*Y_{lm}
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: l,m
    Real(t_real),Intent(in)      :: ylm(:)
    Real(t_real),Intent(out)     :: lopylm(3)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="mitlopxyzTylm"
    Integer(t_int) :: il,si
    Real(t_real)   :: f
    !!
    il=l*l+l+1
    !!
    lopylm(3)=ylm(il-m)*m
    
    lopylm(1)=0.0_t_real
    lopylm(2)=0.0_t_real
    If(M==0) Then
       lopylm(1)=-Sqrt(2.0_t_real*l*(l+1))*ylm(il-1)*0.5_t_real
       lopylm(2)=+Sqrt(2.0_t_real*l*(l+1))*ylm(il+1)*0.5_t_real
    Endif
    If(M==-1.And.l>0)Then
       lopylm(1)=+Sqrt(2.0_t_real*l*(l+1))*ylm(il)*0.5_t_real
    Endif
    If(M== 1.And.l>0)then
       lopylm(2)=-Sqrt(2.0_t_real*l*(l+1))*ylm(il)*0.5_t_real
    Endif
    !!
    If(M/=0)Then
       Do si=-1,1,2
          If(M+si/=0 .And. Abs(M+si)<=l)Then
             f=M/Abs(M)*Sqrt(l*(l+1.0_t_real)-M*(M+si))*0.5_t_real
             lopylm(1)=lopylm(1)-f*ylm(il-M-si)
             lopylm(2)=lopylm(2)+f*ylm(il+M+si)*si
          Endif
       Enddo
    Endif
    !!
    !!
    Return
    !!
  End Subroutine mitlopxyzTylm
  !!***********************************************************************
  Subroutine mitlopxyzTlopxyzTylm(ylm,l,m,llopylm)
    !!
    !! return (-i*\vec{L})*(-i*\vec{L})*Y_{lm}
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: l,m
    Real(t_real),Intent(in)      :: ylm(:)
    Real(t_real),Intent(out)     :: llopylm(3,3)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="mitlopxyzTlopxyzTylm"
    Integer(t_int) :: il,si,n,k
    Real(t_real)   :: f,lop(3,-l:l)
    !!
    il=l*l+l+1
    !!
    Do n=-l,l
       Call mitlopxyzTylm(ylm,l,n,lop(:,n))
    Enddo
    
    llopylm=0.0_t_real

    Do k=1,3
       llopylm(k,3)=lop(k,-m)*m
       If(M==0) Then
          llopylm(k,1)=-Sqrt(2.0_t_real*l*(l+1))*lop(k,-1)*0.5_t_real
          llopylm(k,2)=+Sqrt(2.0_t_real*l*(l+1))*lop(k,1)*0.5_t_real
       Endif
       If(M==-1.And.l>0)Then
          llopylm(k,1)=+Sqrt(2.0_t_real*l*(l+1))*lop(k,0)*0.5_t_real
       Endif
       If(M== 1.And.l>0)Then
          llopylm(k,2)=-Sqrt(2.0_t_real*l*(l+1))*lop(k,0)*0.5_t_real
       Endif
       If(M/=0)Then
          Do si=-1,1,2
             If(M+si/=0 .And. Abs(M+si)<=l)Then
                f=M/Abs(M)*Sqrt(l*(l+1.0_t_real)-M*(M+si))*0.5_t_real
                llopylm(k,1)=llopylm(k,1)-f*lop(k,-M-si)
                llopylm(k,2)=llopylm(k,2)+f*lop(k,M+si)*si
             Endif
          Enddo
       Endif
    Enddo
    !!
    !!
    Return
    !!
  End Subroutine mitlopxyzTlopxyzTylm
  !!***********************************************************************
  Subroutine gradTLopTylm(lmax,rsh,ylm,gradlopylm)
    !! r*\nabla*Ylm (compelx Y)
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: lmax
    Real(t_real),Intent(in)      :: rsh(3)
    Real(t_real),Intent(in)   :: ylm(:)
    Real(t_real),Intent(out)  :: gradlopylm(:,:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="gradlopcyp"
    Integer(t_int) :: l,m,ilm
    Real(t_real)   :: r,er(3),llopylm(3,3)
    !!
    r=Sqrt(Sum(rsh(:)**2))
    er=rsh/r**2
    !!
    Do l=0,lmax
       Do m=-l,l

          ilm=l*l+l+1+m
          
          Call mitlopxyzTlopxyzTylm(ylm,l,m,llopylm)
          
          gradlopylm(1,1,ilm)=er(2)*llopylm(3,1)-er(3)*llopylm(2,1)
          gradlopylm(2,1,ilm)=er(3)*llopylm(1,1)-er(1)*llopylm(3,1)
          gradlopylm(3,1,ilm)=er(1)*llopylm(2,1)-er(2)*llopylm(1,1)

          gradlopylm(1,2,ilm)=er(2)*llopylm(3,2)-er(3)*llopylm(2,2)
          gradlopylm(2,2,ilm)=er(3)*llopylm(1,2)-er(1)*llopylm(3,2)
          gradlopylm(3,2,ilm)=er(1)*llopylm(2,2)-er(2)*llopylm(1,2)

          gradlopylm(1,3,ilm)=er(2)*llopylm(3,3)-er(3)*llopylm(2,3)
          gradlopylm(2,3,ilm)=er(3)*llopylm(1,3)-er(1)*llopylm(3,3)
          gradlopylm(3,3,ilm)=er(1)*llopylm(2,3)-er(2)*llopylm(1,3)
          

          
       Enddo
    Enddo
    !!
    !!
    Return
    !!
  End Subroutine gradTLopTylm
  !!***********************************************************************
#ifdef my_compile_unused
  Subroutine vectospherbas(c)
    !! cartesian vector to spherical coords
    !! output order: order -1,0,1
    Implicit None
    !!IO
    Complex(t_real),Intent(inout) :: c(3)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="vectospherbas"
    Complex(t_real):: cc1,cc2
    Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
    !!
    !!
    cc1=c(1)
    cc2=ci*c(2)
    c(1)= sq2o2*(cc1-cc2) 
    c(2)= c(3)
    c(3)=-sq2o2*(cc1+cc2)
    !!
    Return
    !!
  End Subroutine vectospherbas
#endif
  !!***********************************************************************
  Subroutine WignerEckartForcesMatelTest()
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="WignerEckartForcesMatelTest"
    Integer(t_int) :: ng,nv,lmax,lb,mb,ig,i,LL,MM,k,ilm,ilbm,iLLm,si
    Integer(t_int) :: klj,la,glmax
    Integer(t_int) :: ioci,ia,ib,issa,ociindex(1),isa
    Integer(t_int) :: ilam,ma,nma,nmb
    Real(t_real)   :: r,rsh(3),w,d1,dtol,err,relerr,maxerr,er(3)
    Real(t_real)   :: v1(3),v2(3)
    Integer(t_int) :: nRa(1),nRb(1)
    Integer(t_int),Pointer :: lRa(:,:),lRb(:,:)
    Real(t_real),Pointer :: wg(:),ag(:,:),ylm(:),gradylm(:,:)!,rvylm(:,:)
    Real(t_real),Pointer :: lopylm(:,:),pot(:,:,:),dpot(:,:,:)
    Real(t_real),Pointer:: gradlopylm(:,:,:),wgaunt(:,:,:),wfgaunt(:,:,:,:,:)
    Real(t_real),Pointer:: ccc(:,:,:,:),fyVy(:,:),byVy(:,:),oci(:,:)
    Real(t_real),Pointer :: yVyf(:,:),yVyb(:,:)
    Real(t_real),Pointer:: byyy(:,:,:,:,:,:,:),yyyb(:,:,:,:,:,:,:)!,fyyy(:,:,:,:,:,:,:)
    !!
    Nullify(wg,ag,byyy,yyyb,lopylm,gradylm,gradlopylm,ylm,ccc,dpot,pot,fyVy,yVyf,yVyb&
         &,wgaunt,wfgaunt,oci,byVy)
    !!
    dtol=1.0e-10_t_real
    !!
!!$    lmax=24
!!$    Do LL=0,lmax
!!$       Do N=-LL,LL
!!$          Do NB=-LL,LL
!!$             !!Write(outfile,"(2f8.3)",advance='no')UYlm(LL,Nb,N)
!!$             cc=c0
!!$             Do si=-1,1,2
!!$                Do MM=-LL,LL
!!$                   If(Abs(MM+si)<=LL)Then
!!$                      cc=cc+Conjg(UYlm(Nb,MM))*UYlm(N,MM+si)&
!!$                           &*Sqrt(LL*(LL+1.0_t_real)-MM*(MM+si))
!!$                   Endif
!!$                Enddo
!!$             Enddo
!!$
!!$             ccb=c0
!!$             If(N==0 .And. NB==-1)ccb=ci*Sqrt(2.0_t_real*LL*(LL+1))
!!$             If(N==-1 .And. NB==0)ccb=-ci*Sqrt(2.0_t_real*LL*(LL+1))
!!$             If(N/=0 .And. NB/=0)Then
!!$                Do si=-1,1,2
!!$                   If(-N==NB+si)Then
!!$                      ccb=ccb-ci*NB/Abs(NB)*Sqrt(LL*(LL+1.0_t_real)-NB*(NB+si))
!!$                   Endif
!!$                Enddo
!!$             Endif
!!$             
!!$
!!$             If(Abs(cc-ccb)>dtol)Then
!!$                Write(outfile,"(3i3,' sum=',2(f30.15),' an=',2(f30.15),' err=',f30.15)") &
!!$                     &LL,NB,N,cc,ccb,Abs(cc-ccb)
!!$                Print *,'error'
!!$             Endif
!!$             
!!$             cc=c0
!!$             Do si=-1,1,2
!!$                Do MM=-LL,LL
!!$                   If(Abs(MM+si)<=LL)Then
!!$                      cc=cc+Conjg(UYlm(Nb,MM))*UYlm(N,MM+si)&
!!$                           &*Sqrt(LL*(LL+1.0_t_real)-MM*(MM+si))*si
!!$                   Endif
!!$                Enddo
!!$             Enddo
!!$
!!$             ccb=c0
!!$             If(N==0 .And. NB==1)ccb=Sqrt(2.0_t_real*LL*(LL+1))
!!$             If(N==1 .And. NB==0)ccb=-Sqrt(2.0_t_real*LL*(LL+1))
!!$             If(N/=0 .And. NB/=0)Then
!!$                Do si=-1,1,2
!!$                   If(N==NB+si)Then
!!$                      ccb=ccb-NB/Abs(NB)*Sqrt(LL*(LL+1.0_t_real)-NB*(NB+si))*si
!!$                   Endif
!!$                Enddo
!!$             Endif
!!$             
!!$
!!$             If(Abs(cc-ccb)>dtol)Then
!!$                Write(outfile,"(3i3,' sum=',2(f30.15),' an=',2(f30.15),' err=',f30.15)") &
!!$                     &LL,NB,N,cc,ccb,Abs(cc-ccb)
!!$                Print *,'error'
!!$             Endif
!!$             
!!$          Enddo !N
!!$          !!Write(outfile,*)
!!$       Enddo
!!$    Enddo
    !!
    !!
!!$    lmax=12
!!$    Call palloc('ccc',ccc,1_t_int,3_t_int,1_t_int,2_t_int,-1_t_int,1_t_int&
!!$         &,1_t_int,(lmax+1)**2,nmodule,nsubfunc)
!!$    Call calc_real_vec_Ylm_coefs(lmax,ccc)
!!$
!!$    maxerr=0.0_t_real
!!$    Do l=0,lmax
!!$       Print *,"l=",l
!!$       Do lb=Max(0,l-1),l+1
!!$          If(lb==l) Cycle
!!$          Do nu=-lb,lb
!!$             Do la=Max(0,l-1),l+1
!!$                If(la==l) Cycle
!!$                Do nua=-la,la
!!$
!!$
!!$                   d1=0.0_t_real
!!$                   Do m=-l,l
!!$             
!!$                      T=c0
!!$                      klj=(lb-l+3)/2
!!$                      
!!$                      T(1)=ccc(1,klj,1,l*(l+1)+1+m)*delta(nu,m+1)&
!!$                           &+ccc(1,klj,-1,l*(l+1)+1+m)*delta(nu,m-1)
!!$                      T(2)=ccc(2,klj,1,l*(l+1)+1+m)*delta(nu,-m+1)&
!!$                           &+ccc(2,klj,-1,l*(l+1)+1+m)*delta(nu,-m-1)
!!$                      T(3)=ccc(3,klj,0,l*(l+1)+1+m)*delta(nu,m)
!!$                      
!!$
!!$                      v1=c0
!!$                      klj=(la-l+3)/2
!!$                      
!!$                      v1(1)=ccc(1,klj,1,l*(l+1)+1+m)*delta(nua,m+1)&
!!$                           &+ccc(1,klj,-1,l*(l+1)+1+m)*delta(nua,m-1)
!!$                      v1(2)=ccc(2,klj,1,l*(l+1)+1+m)*delta(nua,-m+1)&
!!$                           &+ccc(2,klj,-1,l*(l+1)+1+m)*delta(nua,-m-1)
!!$                      v1(3)=ccc(3,klj,0,l*(l+1)+1+m)*delta(nua,m)
!!$                      
!!$                      d1=d1+Dot_product(T,v1)
!!$
!!$                   End Do!m
!!$                   d1=d1*(2*lb+1.0_t_real)/(2*l+1.0_t_real)
!!$                   d2=delta(lb,la)*delta(nu,nua)
!!$                   
!!$
!!$                   err=Abs(d1-d2)
!!$                   maxerr=Max(maxerr,err)
!!$                   If(err>1.0e-8_t_real)Then
!!$                      Write(outfile,"('l=',i3,4i3,f30.15)")l,lb,nu,la,nua,d1
!!$                   Endif
!!$                Enddo! nua
!!$             Enddo! la
!!$          Enddo! nu
!!$       Enddo! lb
!!$    Enddo! l
!!$    Print *,'maxerr=',maxerr
    !!
    !!
    
    !!
    lmax=4
    !!
    isa=1
    issa=1
    nma=lmax+1
    nmb=lmax+1
    Call palloc('lRa',lRa,1_t_int,nma,1_t_int,1_t_int,nmodule,nsubfunc)
    Call palloc('lRb',lRb,1_t_int,nmb,1_t_int,1_t_int,nmodule,nsubfunc)
    nRa(issa)=nma
    nRb(issa)=nmb
    Do ia=1,nRa(issa)
       la=ia-1
       lRa(ia,issa)=la
       lRb(ia,issa)=la
    Enddo
    ociindex(isa)=0
    


    


    glmax=lmax
    Call palloc('wgaunt',wgaunt&
         &,1_t_int,((glmax+1)+1)**2& !!one more from vectorharmonics
         &,1_t_int,(glmax+1)**2&
         &,1_t_int,(2*glmax+1+1)**2& !! one more from vectorharmonics
         &,nmodule,nsubfunc)
    Call palloc('wfgaunt',wfgaunt&
         &,1_t_int,3_t_int& ! cartesian index
         &,1_t_int,2_t_int& ! l+/-1 index
         &,1_t_int,(glmax+1)**2& ! l-left
         &,1_t_int,(glmax+1)**2& ! l-right
         &,1_t_int,(2*glmax+1+1)**2&  ! potential-L
         &,nmodule,nsubfunc)

    Call makergaunt(wgaunt,glmax+1,glmax,2*glmax+1) 
    !!
    Call palloc('ccc',ccc,1_t_int,3_t_int,1_t_int,2_t_int,-1_t_int,1_t_int&
         &,1_t_int,(lmax+1)**2,nmodule,nsubfunc)
    Call calc_real_vec_Ylm_coefs(lmax,ccc)
    !!
    !! sum up the realvector-harmonics extraction coefficients with the
    !! potential extraction Gaunt coefficients
    iLLmloop: Do iLLm=1,(2*lmax+1+1)**2
       irightloop: Do ilm=1,(lmax+1)**2
          lleftloop: Do lb=0,lmax
             mleftloop: Do mb=-lb,lb
                ilbm=lb*(lb+1)+1+mb
                lpm1loop: Do la=Max(0_t_int,lb-1),lb+1
                   If(la==lb) Cycle
                   klj=(la-lb+3)/2

                   If(Abs(mb+1)<=la) wfgaunt(1,klj,ilbm,ilm,iLLm)=&
                        &wfgaunt(1,klj,ilbm,ilm,iLLm)&
                        &+ccc(1,klj, 1,ilbm)*wgaunt(la*(la+1)+1+mb+1,ilm,iLLm)
                   
                   If(Abs(mb-1)<=la) wfgaunt(1,klj,ilbm,ilm,iLLm)=&
                        &wfgaunt(1,klj,ilbm,ilm,iLLm)&
                        &+ccc(1,klj,-1,ilbm)*wgaunt(la*(la+1)+1+mb-1,ilm,iLLm)

                   If(Abs(-mb+1)<=la) wfgaunt(2,klj,ilbm,ilm,iLLm)=&
                        &wfgaunt(2,klj,ilbm,ilm,iLLm)&
                        &+ccc(2,klj, 1,ilbm)*wgaunt(la*(la+1)+1-mb+1,ilm,iLLm)
                   
                   If(Abs(-mb-1)<=la) wfgaunt(2,klj,ilbm,ilm,iLLm)=&
                        &wfgaunt(2,klj,ilbm,ilm,iLLm)&
                        &+ccc(2,klj,-1,ilbm)*wgaunt(la*(la+1)+1-mb-1,ilm,iLLm)

                   wfgaunt(3,klj,ilbm,ilm,iLLm)=&
                        &wfgaunt(3,klj,ilbm,ilm,iLLm)&
                        &+ccc(3,klj, 0,ilbm)*wgaunt(la*(la+1)+1+mb,ilm,iLLm)

                Enddo lpm1loop
             Enddo mleftloop
          Enddo lleftloop
       Enddo irightloop
    Enddo iLLmloop
       
    !!
    !!
    nv=3*lmax
    Call sph_zyl_mesh(nv,ag,wg,ng,.False.)
    !!
    Call palloc('fyVy',fyVy,1_t_int,3_t_int,1_t_int,(lmax+1)**2*(lmax+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('yVyf',yVyf,1_t_int,3_t_int,1_t_int,(lmax+1)**2*(lmax+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('yVyb',yVyb,1_t_int,3_t_int,1_t_int,(lmax+1)**2*(lmax+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('oci',oci,1_t_int,3_t_int,1_t_int,(lmax+1)**2*(lmax+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('byVy',byVy,1_t_int,3_t_int,1_t_int,(lmax+1)**2*(lmax+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('byyy',byyy,1_t_int,3_t_int,0_t_int,lmax,-lmax,lmax&
         &,0_t_int,2*lmax+1,-2*lmax-1,2*lmax+1,0_t_int,lmax,-lmax,lmax&
         &,nmodule,nsubfunc)
    Call palloc('yyyb',yyyb,1_t_int,3_t_int,0_t_int,lmax,-lmax,lmax&
         &,0_t_int,2*lmax+1,-2*lmax-1,2*lmax+1,0_t_int,lmax,-lmax,lmax&
         &,nmodule,nsubfunc)
!!$    Call palloc('fyyy',fyyy&
!!$         &,1_t_int,3_t_int&
!!$         &,0_t_int,lmax,-lmax,lmax&
!!$         &,0_t_int,2*lmax+1,-2*lmax-1,2*lmax+1&
!!$         &,0_t_int,lmax,-lmax,lmax&
!!$         &,nmodule,nsubfunc)
    !!
    LL=0
    MM=0
    !!
    Call palloc('pot',pot,0_t_int,lmax,0_t_int,lmax,0_t_int,(2*lmax+1+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('dpot',dpot,0_t_int,lmax,0_t_int,lmax,0_t_int,(2*lmax+1+1)**2&
         &,nmodule,nsubfunc)
    Call palloc('ylm',ylm,1_t_int,(2*lmax+1+1)**2,nmodule,nsubfunc)
    !Call palloc('rvylm',rvylm,1_t_int,3_t_int,1_t_int,(lmax+1)**2,nmodule,nsubfunc)
    Call palloc('lopylm',lopylm,1_t_int,3_t_int,1_t_int,(lmax+1)**2,nmodule,nsubfunc)
    Call palloc('gradylm',gradylm,1_t_int,3_t_int,1_t_int,(lmax+1)**2,nmodule,nsubfunc)
    Call palloc('gradlopylm',gradlopylm,1_t_int,3_t_int,1_t_int,3_t_int&
         &,1_t_int,(lmax+1)**2,nmodule,nsubfunc)
    !!
    pot=0.0_t_real
    dpot=0.0_t_real
    Do la=0,lmax
       Do lb=0,lmax
          Do i=1,(2*lmax+1+1)**2
             pot(la,lb,i)=(la+1.0_t_real)+(lb+10)**2+(3*i+5)**3/1000.0_t_real
             dpot(la,lb,i)=Sqrt(la+1.0_t_real)+(lb+20)**1.5+(7*i+2)**0.3/1000.0_t_real
          Enddo
       Enddo
    Enddo
    !!
    fyVy=0.0_t_real
    yVyf=0.0_t_real
    yVyb=0.0_t_real
    byVy=0.0_t_real
    byyy=0.0_t_real
    yyyb=0.0_t_real
    maxerr=0.0_t_real
    igloop: Do ig=1,ng
       r=0.12345_t_real
       !r=1.0_t_real!!todo
       rsh(:)=r*ag(:,ig)
       w=wg(ig)
       Call ylms12(ylm,rsh(1),rsh(2),rsh(3),2*lmax+1)
       !Call calc_real_vec_Ylm_opt(lmax,ylm,rvylm)
       Call gradTylm(lmax,rsh,ylm,gradylm)
       Do LL=0,lmax
          Do MM=-LL,LL
             ilm=LL*LL+LL+1+MM
             Call mitlopxyzTylm(ylm,LL,MM,lopylm(:,ilm))
          Enddo
       Enddo
       Call gradTLopTylm(lmax,rsh,ylm,gradlopylm)

       
!!$       Do lb=0,lmax
!!$          Do la=lb-1,lb+1
!!$             If(la<0.Or.la==lb) Cycle
!!$             Do nu=-la,la
!!$                d1=0.0_t_real
!!$                Do mb=-lb,lb
!!$                   ilbm=lb*lb+lb+1+mb
!!$                   T=c0
!!$                   klj=(la-lb+3)/2
!!$                   
!!$                   T(1)=  ccc(1,klj, 1,ilbm)*delta(nu, mb+1)&
!!$                        &+ccc(1,klj,-1,ilbm)*delta(nu, mb-1)
!!$                   T(2)=  ccc(2,klj, 1,ilbm)*delta(nu,-mb+1)&
!!$                        &+ccc(2,klj,-1,ilbm)*delta(nu,-mb-1)
!!$                   T(3)=  ccc(3,klj, 0,ilbm)*delta(nu, mb)
!!$                   
!!$                   Do k=1,3
!!$                      d1=d1+T(k)*gradylm(k,ilbm)
!!$                   Enddo
!!$                Enddo
!!$                d1=d1*((2.0_t_real*la+1)/(2*lb+1))
!!$                
!!$                d2=0.0_t_real
!!$                If(la==lb-1) Then
!!$                   d2=(lb+1.0_t_real)/r*Sqrt(lb/(2.0_t_real*lb+1))*ylm(la*la+la+1+nu)
!!$                Else
!!$                   d2=+(lb)/r*Sqrt((lb+1)/(2.0_t_real*lb+1))*ylm(la*la+la+1+nu)
!!$                Endif
!!$                err=Abs(d1-d2)
!!$                maxerr=Max(maxerr,err)
!!$                If(err>dtol)Then
!!$                   Print "('la=',i3,' nu=',i3,' d1=',f12.6,' d2=',f12.6)",la,nu,d1,d2
!!$                Endif
!!$             Enddo! nu
!!$          Enddo! la
!!$       Enddo! lb
          
!!$       If(ig==0)Then
!!$          
!!$          rsh(1)=0.1_t_int
!!$          rsh(2)=0.2_t_int
!!$          rsh(3)=-0.3_t_int
!!$          r=sqrt(Dot_product(rsh,rsh))
!!$          er=rsh/r
!!$          Call ylms12(ylm,rsh(1),rsh(2),rsh(3),lmax)
!!$          !Call calc_real_vec_Ylm_opt(lmax,ylm,rvylm)
!!$          Call gradTylm(lmax,rsh,ylm,gradylm)
!!$          Call gradTLopTylm(lmax,rsh,ylm,gradlopylm)
!!$          Do LL=0,lmax
!!$             Do MM=-LL,LL
!!$                ilm=LL*LL+LL+1+MM
!!$                vv1=gradlopylm(:,:,ilm)
!!$                
!!$
!!$                Write(outfile,"(2i3,1(9f12.6))")LL,MM,vv1
!!$
!!$                If(Any(Abs(v1-v2)>dtol))Then
!!$                   
!!$                   !Write(outfile,"(2i3,3f12.6,3f12.6)")LL,MM,v1,v2
!!$                Endif
!!$                
!!$
!!$                
!!$             Enddo
!!$          Enddo
!!$          stop
!!$       Endif


       Print *,100.0_t_real*ig/ng

       ioci=ociindex(isa)
       ilam=0
       Do ia=1,nRa(issa)
          la=lRa(ia,issa)
          Do ma=-la,la
             ilam=ilam+1
             ilbm=0
             Do ib=1,nRb(issa)
                lb=lRb(ib,issa)
                Do mb=-lb,lb
                   ilbm=ilbm+1
                   ioci=ioci+1
                   iLLm=0
                   Do LL=0,2*lmax+1
                      Do MM=-LL,LL
                         iLLm=iLLm+1
                         Do si=1,3
                            d1=w*(&
                                 & gradylm(si,ilam)*ylm(ilbm)* pot(la,lb,iLLm)&
                                 &+er(si)*ylm(ilam)*ylm(ilbm)*dpot(la,lb,iLLm)&
                                 &)*ylm(iLLm)&
                                 &*Sqrt(la*(la+1.0_t_real)*lb*(lb+1.0_t_real))
                            !fyyy(si,la,ma,LL,MM,lb,mb)=fyyy(si,la,ma,LL,MM,lb,mb)+d1
                            fyVy(si,ioci)=fyVy(si,ioci)+d1

                            d1=w*(&
                                 & gradylm(si,ilbm)*ylm(ilam)* pot(la,lb,iLLm)&
                                 &+er(si)*ylm(ilbm)*ylm(ilam)*dpot(la,lb,iLLm)&
                                 &)*ylm(iLLm)&
                                 &*Sqrt(la*(la+1.0_t_real)*lb*(lb+1.0_t_real))
                            
                            yVyf(si,ioci)=yVyf(si,ioci)+d1
                            
                         Enddo
                         Do k=1,3
                            Do si=1,3
                               d1=w*(&
                                    & gradlopylm(si,k,ilam)*lopylm(k,ilbm)*pot(la,lb,iLLm)&
                                    &+er(si)*lopylm(k,ilam)*lopylm(k,ilbm)*dpot(la,lb,iLLm)&
                                    &)*ylm(iLLm)
                               byyy(si,la,ma,LL,MM,lb,mb)=byyy(si,la,ma,LL,MM,lb,mb)+d1
                               byVy(si,ioci)=byVy(si,ioci)+d1



                               d1=w*(&
                                    & gradlopylm(si,k,ilbm)*lopylm(k,ilam)*pot(la,lb,iLLm)&
                                    &+er(si)*lopylm(k,ilbm)*lopylm(k,ilam)*dpot(la,lb,iLLm)&
                                    &)*ylm(iLLm)
                               yyyb(si,la,ma,LL,MM,lb,mb)=yyyb(si,la,ma,LL,MM,lb,mb)+d1
                               yVyb(si,ioci)=yVyb(si,ioci)+d1
                                    
                            Enddo
                         Enddo
                      Enddo
                   Enddo
                Enddo
             Enddo
          Enddo
       Enddo
       
    End Do igloop
!    Print "('maxerr=',e30.15e3)",maxerr
    !!
    !!
    !!
!!$    Do la=0,lmax
!!$       Do ma=-la,la
!!$          Do lb=0,lmax
!!$             Do mb=-lb,lb
!!$                If(la==0 .Or. lb==0)Then
!!$                   v1=0.0_t_real
!!$                Else
!!$                   v1=fyyy(:,la,ma,0,0,lb,mb)*Sqrt(1.0_t_real-1.0_t_real/Max(la,lb)**2)
!!$                Endif
!!$                v2=byyy(:,la,ma,0,0,lb,mb)
!!$                If(All(Abs(v1)<dtol).And.All(Abs(v2)<dtol))Cycle
!!$                ff=(v1-v2)/Maxval(Abs(v1))
!!$                If(All(Abs(ff)<dtol))Cycle
!!$                Print "('lb=',2i3,'lb=',2i3)",la,ma,lb,mb
!!$                Print "('F*All=',3f30.15)",v1
!!$                Print "('B    =',3f30.15)",v2
!!$                Print "('D    =',3f30.15)",ff
!!$             Enddo
!!$          Enddo
!!$       Enddo
!!$    Enddo
    !!
    !!
    !!
    !!
    oci=0.0_t_real
    Call manipulate_OVO(&
         !todo:&structure,&
         &nma,nRa,lRa,nmb,nRb,lRb,glmax,wgaunt,wfgaunt&
         &,ociindex,yVyf,oci,maxerr,yyyb,.True.)
    Print "('maxerr=',e30.15e3)",maxerr
    !!
    maxerr=0.0_t_real
    ioci=0
    Do lb=0,lmax
       Do mb=-lb,lb
          Do la=0,lmax
             Do ma=-la,la
                ioci=ioci+1
                v1=oci (:,ioci)
                v2=yVyb(:,ioci)
                If(All(Abs(v1)<dtol) .And. All(Abs(v2)<dtol)) Cycle
                err=0.0_t_real
                relerr=0.0_t_real
                Do k=1,3
                   d1=Abs(v1(k)-v2(k))
                   err=Max(err,d1)
                   maxerr=Max(maxerr,err)
                   If(Abs(v1(k))>1.0e-8_t_real)Then
                      d1=d1/Abs(v1(k))
                   Endif
                   relerr=Max(relerr,d1)
                Enddo
                If(relerr>dtol)Then
                   Write(outfile,"(4i3,' Fra=',3(f30.15),/,&
                        &t18,'  B  =',3(f30.15))")&
                        &lb,mb,la,ma,v1,v2
                Endif
             Enddo
          Enddo
       Enddo
    Enddo
    !!
    Print "('maxerroci=',e30.15e3)",maxerr
    !!
    oci=0.0_t_real
    Call manipulate_OVO(&
         !todo:&structure,&
         &nma,nRa,lRa,nmb,nRb,lRb,glmax,wgaunt,wfgaunt&
         &,ociindex,fyVy,oci,maxerr,byyy)
    Print "('maxerr=',e30.15e3)",maxerr
    !!
    maxerr=0.0_t_real
    ioci=0
    Do lb=0,lmax
       Do mb=-lb,lb
          Do la=0,lmax
             Do ma=-la,la
                ioci=ioci+1
                v1=oci(:,ioci)
                v2=byVy  (:,ioci)
                If(All(Abs(v1)<dtol) .And. All(Abs(v2)<dtol)) Cycle
                err=0.0_t_real
                relerr=0.0_t_real
                Do k=1,3
                   d1=Abs(v1(k)-v2(k))
                   err=Max(err,d1)
                   maxerr=Max(maxerr,err)
                   If(Abs(v1(k))>1.0e-8_t_real)Then
                      d1=d1/Abs(v1(k))
                   Endif
                   relerr=Max(relerr,d1)
                Enddo
                If(relerr>dtol)Then
                   Write(outfile,"(4i3,' Fra=',3(f30.15),/,&
                        &t18,'  B  =',3(f30.15))")&
                        &lb,mb,la,ma,v1,v2
                Endif
             Enddo
          Enddo
       Enddo
    Enddo
    !!
    Print "('maxerroci=',e30.15e3)",maxerr
    !!
    Stop
    !!
    !!
    !!
    Stop
    !!
    Return
    !!
  Contains 
    !!***********************************************************************
    Complex(t_real) Function Uylm(n,m)
      !!
      Implicit None
      !!IO
      Integer(t_int),Intent(in)    :: n,m
      !!LOCAL
      !Character(*),Parameter::nsubfunc="Uylm"
      Complex(t_real),Parameter:: ci=(0.0_t_real,1.0_t_real)
      !!
      !!
      Uylm=0.0_t_real
      !!
      If(n==m)Then
         If(m<0) Then
            Uylm=-ci*sq2o2
         Else If(m>0) Then
            Uylm=sq2o2*(-1.0_t_real)**m
         Else
            Uylm=1.0_t_real
         Endif
      Else If(n==-m)Then
         If(m<0) Then
            Uylm=sq2o2
         Else If(m>0) Then
            Uylm=ci*sq2o2*(-1.0_t_real)**m
         Endif
      Endif
      !!
      Return
      !!
    End Function Uylm
    !!***********************************************************************
  End Subroutine WignerEckartForcesMatelTest
  !!***********************************************************************
  Subroutine manipulate_OVO(&
       !!todo: &structure,&
       &nma,nRa,lRa,nmb,nRb,lRb,glmax,wgaunt,wfgaunt&
       &,ociindex,ocitmp,oci,maxerr,byyy,right)
    !!
    Implicit None
    !!IO
    !!todo: Type(T_Structure),Intent(in) :: structure
    Integer(t_int),Intent(in)    :: nma,nRa(*),lRa(nma,*)
    Integer(t_int),Intent(in)    :: nmb,nRb(*),lRb(nmb,*)
    Integer(t_int),Intent(in)    :: ociindex(*)
    Integer(t_int),Intent(in)    :: glmax
    Logical(t_log),Intent(in),Optional    :: right
    Real(t_real),Intent(in)      :: ocitmp(:,:)
    Real(t_real),Intent(inout)   :: oci(:,:)
    Real(t_real),Intent(in)      :: byyy(3,0:glmax,-glmax:glmax&
         &,0:2*glmax+1,-2*glmax-1:2*glmax+1,0:glmax,-glmax:glmax)!!todo: remove
    Real(t_real),Intent(in)      :: wgaunt(&
         &(glmax+1+1)**2&
         &,(glmax+1)**2&
         &,(2*glmax+1+1)**2)
    Real(t_real),Intent(in)      :: wfgaunt(3,2&
         &,(glmax+1)**2&
         &,(glmax+1)**2&
         &,(2*glmax+1+1)**2)
    Real(t_real),Intent(out)     :: maxerr
    !!LOCAL
    Logical(t_log) :: doright
    Character(*),Parameter::nsubfunc="manipulate_OVO"
    Integer(t_int) :: iLLm,iLLm0,ilam,ilbm,LL,MM,isa,issa,ioci
    Integer(t_int) :: ia,la,ma,lqa,ib,lb,mb,lqb,klj,lam,k
    Real(t_real)   :: LLLLp1,cl2LL0,clLLMp,clLLMm,w0,alll,vv1(3),ff(3)
    Real(t_real)   :: v1(3),v2(3),err,relerr!!todo: remove
    Real(t_real)   :: wpMp1(3),wpMm1(3),wmMp1(3),wmMm1(3)
    Real(t_real),Pointer :: p_ociLM(:,:,:)
    Real(t_real),Parameter :: dtol=1.0e-10_t_real!!todo: remove
    !!
    Nullify(p_ociLM)
    !!
    doright=.False.
    If(Present(right))Then
       If(right)Then
          doright=.True.
       Endif
    Endif
    !!
    Call palloc('p_ociLM',p_ociLM,1_t_int,2_t_int&
         &,1_t_int,nma,1_t_int,nmb,nmodule,nsubfunc)
    !!
    maxerr=0.0_t_real
    Do iLLm=1,(2*glmax+1+1)**2
       LL=llilm(iLLm)
       MM=mmilm(iLLm)-LL-1
       iLLm0=LL*LL+LL+1
       
       LLLLp1=LL*(LL+1.0_t_int)
       cl2LL0=Sqrt(2.0_t_real*LLLLp1)*0.5_t_real
       clLLMp=Sqrt(LLLLp1-MM*(MM+1))*0.5_t_real*(MM+0.1_t_real)/Abs(MM+0.1_t_real)
       clLLMm=Sqrt(LLLLp1-MM*(MM-1))*0.5_t_real*(MM+0.1_t_real)/Abs(MM+0.1_t_real)
       
       !Print *,LL,MM
       
       Do isa=1,1!todo: structure% nsite
          issa=1!todo: structure% p_isrt(isa)
          
          
          p_ociLM=0.0_t_real
          !! fold the matrix elements with the gaunt/Clebsch-Gordon coefficient
          ioci=ociindex(isa)
          Do ia=1,nRa(issa)
             la=lRa(ia,issa)
             lqa=la*la
             Do ma=1,2*la+1
                ilam=lqa+ma
                
                Do ib=1,nRb(issa)
                   lb=lRb(ib,issa)
                   lqb=lb*lb
                   Do mb=1,lb+lb+1
                      ilbm=lqb+mb
                      
                      
                      ioci=ioci+1
                      Do klj=1,2
                         If(doright)Then

                            lam=lb+2*klj-3
                            If(lb==0 .And. klj==1) Cycle
                            
                            w0=wgaunt(lam*lam+lam+1,lqa+la+1,iLLm0)
                            If(Abs(w0)>1.0e-10_t_real)Then
                               Do k=1,3
                                  p_ociLM(klj,ia,ib)=p_ociLM(klj,ia,ib)&
                                       &+ocitmp(k,ioci)*wfgaunt(k,klj,ilbm,ilam,iLLm)&
                                       &*Sqrt(fourpi*(2*lam+1)*(2*LL+1)/(2*la+1))/(2*lb+1)/w0
                               Enddo
                            Endif
                         Else
                            lam=la+2*klj-3
                            If(la==0 .And. klj==1) Cycle
                            
                            w0=wgaunt(lam*lam+lam+1,lqb+lb+1,iLLm0)
                            If(Abs(w0)>1.0e-10_t_real)Then
                               Do k=1,3
                                  p_ociLM(klj,ia,ib)=p_ociLM(klj,ia,ib)&
                                       &+ocitmp(k,ioci)*wfgaunt(k,klj,ilam,ilbm,iLLm)&
                                       &*Sqrt(fourpi*(2*lam+1)*(2*LL+1)/(2*lb+1))/(2*la+1)/w0
                               Enddo
                            Endif
                         Endif
                         !!
                      Enddo! klj
                   Enddo! m
                Enddo! l
             Enddo! mb
          Enddo! lb
          !!
          ioci=ociindex(isa)
          Do ia=1,nRa(issa)
             la=lRa(ia,issa)
             lqa=la*la
             Do ma=1,2*la+1
                ilam=lqa+ma
                
                Do ib=1,nRb(issa)
                   lb=lRb(ib,issa)
                   lqb=lb*lb
                   Do mb=1,lb+lb+1
                      ilbm=lqb+mb
                      ioci=ioci+1
                      
                      v1=0.0_t_real
                      If(la>0 .And.lb>0)Then
                         alll=(lqa+la+lqb+lb-LLLLp1-2)*0.5_t_real
                         
                         vv1=0.0_t_real
                         Do klj=1,2

                            If(doright)Then
                               wpMp1=wfgaunt(:,klj,ilbm,ilam,iLLm0+MM+1)
                               wmMp1=wfgaunt(:,klj,ilbm,ilam,iLLm0-MM+1)
                               wpMm1=wfgaunt(:,klj,ilbm,ilam,iLLm0+MM-1)
                               wmMm1=wfgaunt(:,klj,ilbm,ilam,iLLm0-MM-1)
                               
                               ff(:)=alll*wfgaunt(:,klj,ilbm,ilam,iLLm0+MM)
                               ff(1)=ff(1)+MM*wfgaunt(2,klj,ilbm,ilam,iLLm0-MM)
                               ff(2)=ff(2)-MM*wfgaunt(1,klj,ilbm,ilam,iLLm0-MM)
                            Else
                               wpMp1=wfgaunt(:,klj,ilam,ilbm,iLLm0+MM+1)
                               wmMp1=wfgaunt(:,klj,ilam,ilbm,iLLm0-MM+1)
                               wpMm1=wfgaunt(:,klj,ilam,ilbm,iLLm0+MM-1)
                               wmMm1=wfgaunt(:,klj,ilam,ilbm,iLLm0-MM-1)
                               
                               ff(:)=alll*wfgaunt(:,klj,ilam,ilbm,iLLm0+MM)
                               ff(1)=ff(1)+MM*wfgaunt(2,klj,ilam,ilbm,iLLm0-MM)
                               ff(2)=ff(2)-MM*wfgaunt(1,klj,ilam,ilbm,iLLm0-MM)
                            Endif
                            If(MM==0)Then
                               ff(1)=ff(1)-cl2LL0*wpMp1(3)
                               ff(2)=ff(2)-cl2LL0*wpMm1(3)
                               ff(3)=ff(3)+cl2LL0*(wpMp1(1)+wpMm1(2))
                            Else If(MM==1)Then
                               ff(1)=ff(1)+cl2LL0*wpMm1(3)
                               ff(3)=ff(3)-cl2LL0*wpMm1(1)
                               If(LL>1)Then
                                  ff(1)=ff(1)-clLLMp*wpMp1(3)
                                  ff(2)=ff(2)-clLLMp*wmMm1(3)
                                  ff(3)=ff(3)+clLLMp*(wpMp1(1)+wmMm1(2))
                               Endif
                            Else If(MM==-1)Then
                               ff(2)=ff(2)+cl2LL0*wpMp1(3)
                               ff(3)=ff(3)-cl2LL0*wpMp1(2)
                               If(LL>1)Then
                                  ff(1)=ff(1)+clLLMm*wpMm1(3)
                                  ff(2)=ff(2)-clLLMm*wmMp1(3)
                                  ff(3)=ff(3)+clLLMm*(-wpMm1(1)+wmMp1(2))
                               Endif
                            Else
                               If(-LL<=MM-1)Then
                                  ff(1)=ff(1)+clLLMm*wpMm1(3)
                                  ff(2)=ff(2)-clLLMm*wmMp1(3)
                                  ff(3)=ff(3)+clLLMm*(-wpMm1(1)+wmMp1(2))
                               Endif
                               If(MM+1<=LL)Then
                                  ff(1)=ff(1)-clLLMp*wpMp1(3)
                                  ff(2)=ff(2)-clLLMp*wmMm1(3)
                                  ff(3)=ff(3)+clLLMp*(wpMp1(1)+wmMm1(2))
                               Endif
                            Endif
                            vv1=vv1+ff*p_ociLM(klj,ia,ib)&
                                 &/Sqrt(la*(la+1.0_t_real)*lb*(lb+1.0_t_real))
                         Enddo! klj
                         v1=vv1
                         oci(:,ioci)=oci(:,ioci)+vv1
                      Endif
                      
                      v2=byyy(:,la,ma-la-1,LL,MM,lb,mb-lb-1)
                      
                      If(All(Abs(v1)<1.0e-7_t_real) .And. All(Abs(v2)<1.0e-7_t_real)) Cycle
                      ff=(v1-v2)
                      err=Sqrt(Dot_product(ff,ff))
                      maxerr=Max(maxerr,err)
                      relerr=err/Maxval(Abs(v1))
                      If(relerr>dtol)Then
                         Write(outfile,"(6i3,' v1=',3(f30.15),/,&
                              &t18,'  pF=',3(f30.15))")&
                              &la,ma-la-1,LL,MM,lb,mb-lb-1,v1,v2
                      Endif
                   Enddo! m
                Enddo! l
             Enddo! ma
          Enddo! la
       Enddo ! isa
       
    Enddo! iLLm
    !!
    Return
    !!
  End Subroutine manipulate_OVO
  !!***********************************************************************
  Subroutine clocktest()
    !!
    Implicit None
    !!IO
    !!LOCAL
    !Character(*),Parameter::nsubfunc="clocktest"
    Character(*),Parameter :: cpumesg='bandstructure plot '
    Integer(t_int) :: i,j,k,N,N2
    Real(t_real)   :: x=1.0_t_real
    !!
    !!
    !!
    N=100
    N2=1000

    Call watch(nmodule//cpumesg,cpu_start,reset=.True.&
         &,deltaProgress=0.1_t_real,Nsteps=N)
    

    Do i=1,N
       
       Call watch(nmodule//cpumesg,cpu_read,printprogress=.True.,istep=i-1)

       Do j=1,N2
          Do k=1,N2
             x=Sin(x*0.01_t_Real+j)
          Enddo
       Enddo
    Enddo
    !!
    Call watch(nmodule//cpumesg,cpu_stop,delete=.True.,Print=.True.,mesg="total ")
    !!
    Stop
    !!
    Return
    !!
    !!***********************************************************************

  End Subroutine clocktest 
  !!***********************************************************************
  Subroutine lsdau_model()
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="lsdau_model"
    Integer(t_int) :: l,LL,MM,m1,m2,degl,i1,iM,i2,ma1,ma2,MMa
    Real(t_real)   :: dc,dx,drc,drx,f(0:100)
    Real(t_real),Pointer :: WC(:,:,:),WX(:,:,:),WRC(:,:,:),WRX(:,:,:),ddd(:,:,:)
    Character(100)   :: txt
    Nullify(WC,WX,WRC,WRX)
    !!
    !!
    l=2
    degl=2*l+1
    Call palloc('WC',WC,1_t_int,degl,1_t_int,degl,0_t_int,2*l&
         &,nmodule,nsubfunc)
    Call palloc('WX',WX,1_t_int,degl,1_t_int,degl,0_t_int,2*l&
         &,nmodule,nsubfunc)
    Call palloc('WRC',WRC,1_t_int,degl,1_t_int,degl,0_t_int,2*l&
         &,nmodule,nsubfunc)
    Call palloc('WRX',WRX,1_t_int,degl,1_t_int,degl,0_t_int,2*l&
         &,nmodule,nsubfunc)
    Call palloc('ddd',ddd,1_t_int,degl,1_t_int,degl,0_t_int,2*l&
         &,nmodule,nsubfunc)
    
    !!
    ddd=0.0_t_real
    Do LL=0,2*l
       If(Mod(2*l+LL,2_t_int) /=0) Cycle
       Do m1=-l,l
          Do m2=-l,l
             If(LL==0)Then
                If(m1==m2) ddd(m1+l+1,m2+l+1,LL)=1.0_t_real
             Endif
             If(LL==2.Or.LL==4)Then
                If(m1/=m2) ddd(m1+l+1,m2+l+1,LL)=1.0_t_real/14.0_t_real
             Endif
          Enddo
       Enddo
    Enddo
    WC=0.0_t_real
    WX=0.0_t_real
    Do LL=0,2*l
       If(Mod(2*l+LL,2_t_int) /=0) Cycle
       Do m1=-l,l
          ma1=Abs(m1)
          i1=Sign(1_t_int,m1)
          Do m2=-l,l
             ma2=Abs(m2)
             i2=Sign(1_t_int,m2)
             dc=0.0_t_real
             drc=0.0_t_real
             dx=0.0_t_real
             drx=0.0_t_real
             Do MM=-LL,LL
                MMa=Abs(MM)
                iM=Sign(1_t_int,MM)
                drc=drc+rgaunt(l,ma1,i1,LL,MMa,iM,l,ma1,i1)&
                     & *rgaunt(l,ma2,i2,LL,MMa,iM,l,ma2,i2)&
                     &*fourpi/(2.0_t_real*LL+1.0_t_real)
                drx=drx+rgaunt(l,ma1,i1,LL,MMa,iM,l,ma2,i2)&
                     & *rgaunt(l,ma2,i2,LL,MMa,iM,l,ma1,i1)&
                     &*fourpi/(2.0_t_real*LL+1.0_t_real)
                If(MM==0)Then
                   dc=dc+gaunt(l,m1,LL,MM,l,m1)*gaunt(l,m2,LL,-MM,l,m2)&
                        &*(-1.0_t_real)**MM&
                        &*fourpi/(2.0_t_real*LL+1.0_t_real)
                Endif
                If(m1==MM+m2 .And. m2==-MM+m1)Then
                   dx=dx+gaunt(l,m1,LL,MM,l,m2)*gaunt(l,m2,LL,-MM,l,m1)&
                        &*(-1.0_t_real)**MM&
                        &*fourpi/(2.0_t_real*LL+1.0_t_real)
                Endif
             Enddo
             WC(m1+l+1,m2+l+1,LL)=dc
             WX(m1+l+1,m2+l+1,LL)=dx
             WRC(m1+l+1,m2+l+1,LL)=drc
             WRX(m1+l+1,m2+l+1,LL)=drx
          Enddo
       Enddo
       !!
       !!
    Enddo
    !!
    f(0:4)=(/1_t_real,0_t_real,2*49_t_real,0_t_real,2*49_t_real*9_t_real/)
    !!
    Print *,'WC='
    Do LL=0,2*l
       If(Mod(2*l+LL,2_t_int) /=0) Cycle
       Write(txt,"('F',i1,'/',f12.5,'*')")LL,f(LL)
       Call printmat(Trim(txt),"(f12.5)","('      0     ')"&
            &,WC(:,:,LL)*f(LL),degl,degl,1.0e-10_t_real)
    Enddo
    !!
    Print *,'WX='
    Do LL=0,2*l
       If(Mod(2*l+LL,2_t_int) /=0) Cycle
       Write(txt,"('F',i1,'/',f12.5,'*')")LL,f(LL)
       Call printmat(Trim(txt),"(f12.5)","('      0     ')"&
            &,WX(:,:,LL)*f(LL),degl,degl,1.0e-10_t_real)
    Enddo
!!$    !!
!!$    Print *,'WRC='
!!$    Do LL=0,2*l
!!$       If(Mod(2*l+LL,2) /=0) Cycle
!!$       Write(txt,"('F',i1,'/',f12.5,'*')")LL,f(LL)
!!$       Call printmat(Trim(txt),"(f12.5)","('      0     ')"&
!!$            &,WRC(:,:,LL)*f(LL),degl,degl,1.0e-10_t_real)
!!$    Enddo
!!$    !!
!!$    Print *,'WRX='
!!$    Do LL=0,2*l
!!$       If(Mod(2*l+LL,2) /=0) Cycle
!!$       Write(txt,"('F',i1,'/',f12.5,'*')")LL,f(LL)
!!$       Call printmat(Trim(txt),"(f12.5)","('      0     ')"&
!!$            &,(WRX(:,:,LL)-ddd(:,:,LL))*f(LL),degl,degl,1.0e-10_t_real)
!!$    Enddo
    !!
    Stop
    !
    Return
    !!
  End Subroutine lsdau_model

  !!***********************************************************************
!!$  Subroutine mul_cc_sccg_test()
!!$    !!
!!$    Implicit None
!!$    !!IO
!!$    !!LOCAL
!!$    Character(*),Parameter::nsubfunc="mul_cc_sccg_test"
!!$    Integer(t_int),Parameter :: lecraw=6
!!$    Integer(t_int),Parameter :: lechi=4
!!$    Integer(t_int),Parameter :: ioci0=10
!!$    Integer(t_int) :: ioci,i,j,k
!!$    Real(t_real)   :: loi_cc0(3,ioci0+lecraw*lecraw)
!!$    Real(t_real)   :: loi_cc(3,ioci0+lechi*lechi)
!!$    Real(t_real)   :: nczz(lecraw,lechi)
!!$    !!
!!$    ioci=ioci0
!!$    Do i=1,lecraw
!!$       Do j=1,lecraw
!!$          ioci=ioci+1
!!$          Do k=1,3
!!$             loi_cc0(k,ioci)=i*Sin(pi*j/7.0_t_real)+0.123_t_real*k
!!$          Enddo
!!$       Enddo
!!$    Enddo
!!$    !!
!!$    nczz=0.0_t_real
!!$    Do i=1,lecraw
!!$       Do j=1,lechi
!!$          !If(i<=lechi)Then
!!$             nczz(i,j)=1.0_t_real/lecraw*(lecraw-i+1)/j
!!$          !Endif
!!$       Enddo
!!$    Enddo
!!$    !!
!!$    Print *,'nczz'
!!$    Write(outfile,"('nczz:matrix(')")
!!$    Do i=1,lecraw
!!$       Write(outfile,"('[')",advance='no')
!!$       Do j=1,lechi
!!$          Write(outfile,"(f8.4,' ')",advance='no') nczz(i,j)
!!$          If(j<lechi)&
!!$               &Write(outfile,"(',')",advance='no')
!!$       Enddo
!!$       Write(outfile,"(']')")
!!$       If(i<lecraw)&
!!$            &Write(outfile,"(',')",advance='no')
!!$    Enddo
!!$    Write(outfile,"(');')")
!!$
!!$    Do k=1,3
!!$       Write(outfile,"('L0:matrix(')")
!!$       Do i=1,lecraw
!!$          Write(outfile,"('[')",advance='no')
!!$          Do j=1,lecraw
!!$             Write(outfile,"(f8.4,' ')",advance='no') loi_cc0(k,ioci0+(i-1)*lecraw+j)
!!$             If(j<lecraw)&
!!$                  &Write(outfile,"(',')",advance='no')
!!$          Enddo
!!$          Write(outfile,"(']')")
!!$          If(i<lecraw)&
!!$               &Write(outfile,"(',')",advance='no')
!!$       Enddo
!!$       Write(outfile,"(');')")
!!$       Write(outfile,"('transpose(nczz).(L0.nczz);')")
!!$    Enddo
!!$
!!$    Write(outfile,"('transpose(nczz).(L0.nczz);')")
!!$    
!!$    Call mul_cc_sccg(lecraw,lechi,nczz,ioci0,loi_cc0,loi_cc)
!!$    !!
!!$    Do k=1,3
!!$       Print *,'k=',k
!!$       Do i=1,lechi
!!$          Do j=1,lechi
!!$             Write(outfile,"(f8.4,' ')",advance='no') loi_cc(k,ioci0+(i-1)*lechi+j)
!!$          Enddo
!!$          Print *
!!$       Enddo
!!$    Enddo
!!$    !!
!!$    Stop
!!$    !!
!!$    Return
!!$    !!
!!$  End Subroutine mul_cc_sccg_test
  !!***********************************************************************
  Subroutine dens_decompose_test()
    !!
    Implicit None
    !!IO
    !!LOCAL
    Character(*),Parameter::nsubfunc="dens_decompose_test"
    Integer(t_int) :: l,LL,m,ma,im,MM,MMa,iMM,n,na,in,ind,degl,dim
    Real(t_real),Pointer :: A(:,:),E(:),S(:,:)
    !!
    Nullify(A,S,E)
    !!
    l=2
    degl=2*l+1
    !!
    dim=2*(l+1)*degl
    Call palloc('A',A,1_t_int,degl**2,1_t_int,dim,nmodule,nsubfunc)
    Call palloc('S',S,1_t_int,dim,1_t_int,dim,nmodule,nsubfunc)
    Call palloc('E',E,1_t_int,dim,nmodule,nsubfunc)
    !!
    ind=0
    Do LL=0,2*l,2
       Do MM=-LL,LL
          MMa=Abs(MM)
          iMM=Sign(1_t_int,MM)
          Do m=-l,l
             ma=Abs(m)
             im=Sign(1_t_int,m)
             Do n=-l,l
                na=Abs(n)
                in=Sign(1_t_int,n)
                A(m+l+1+degl*(n+l),ind+1)=rgaunt(l,ma,im,LL,MMa,iMM,l,na,in)
                A(m+l+1+degl*(n+l),ind+2)=rgaunt(l,ma,im,LL,MMa,iMM,l,na,in)*n
             Enddo
          Enddo
          ind=ind+2
       Enddo
    Enddo
    !!
    S=Matmul(Transpose(A),A)
    Print *,Size(A,1),Size(A,2)
    Print *,Size(S,1),Size(S,2)
    Call rdiagno_noO(dim,S,E)
    !!
    Do m=1,dim
       Print *,m,E(M)
    Enddo
    !!

    !!
    Call pfree(A)
    Call pfree(S)
    Call pfree(E)
    !!
    Stop
    Return
    !!
  End Subroutine dens_decompose_test
  !!***********************************************************************
  Real(t_real) Function lfac(x)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: x
    !!LOCAL
    Character(*),Parameter::nsubfunc="lfac"
    Integer(t_int) :: k,ix
    Integer(t_int),Save :: imax
    Logical(t_log),Save :: initialized=.False.
    Real(t_real),Pointer,Save   :: lfactorials(:)
    !!
    If(Mod(x,2_t_int)/=0)Then
       Print *,'x=',x
       Stop 'lfac noninteger argument'
    Endif
    !!
    ix=x/2
    !!
    If(.Not.initialized)Then
       initialized=.True.
       Nullify(lfactorials)
       imax=ix
       Call palloc('lfactorials',lfactorials,0_t_int,ix,nmodule,nsubfunc)
       lfac=1.0_t_real
       lfactorials(0)=lfac
       Do k=1,ix
          lfac=lfac*Real(k,t_real)
          lfactorials(k)=lfac
       Enddo
       !!
       Return
    Endif
    !!
    !!
    If(ix<=imax)Then
       lfac=lfactorials(ix)
       Return
    endif
    !!
    Call realloc('lfactorials',lfactorials,0_t_int,ix,nmodule,nsubfunc)
    !!
    lfac=lfactorials(imax)
    Do k=imax+1,ix
       lfac=lfac*Real(k,t_real)
       lfactorials(k)=lfac
    Enddo
    !!
    imax=ix
    !!
    Return
    !!
  End Function lfac
  !!***********************************************************************
End Module develtest
