Module memory
  !!
  Use precisiondefs
  Use file_iounits
  Use errors
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="MEMORY"  
  !!
  Public :: palloc,pfree,realloc,init_mem_stat,mem_status
  !!***********************************************************************
  Interface realloc
     Module Procedure &
          & realloc_i1,realloc_i2,realloc_i3,realloc_i4,realloc_i5,realloc_i6&
          &,realloc_i7&
          &,realloc_c1,realloc_c2,realloc_c3,realloc_c4,realloc_c5,realloc_c6&
          &,realloc_c7&
          &,realloc_r1,realloc_r2,realloc_r3,realloc_r4,realloc_r5,realloc_r6&
          &,realloc_r7&
          &,realloc_x1,realloc_x2,realloc_x3,realloc_x4,realloc_x5,realloc_x6&
          &,realloc_x7 &
          &,realloc_l1,realloc_l2,realloc_l3,realloc_l4,realloc_l5,realloc_l6&
          &,realloc_l7
  End Interface realloc
  Interface palloc
     Module Procedure &
          & palloc_i1,palloc_i2,palloc_i3,palloc_i4,palloc_i5,palloc_i6&
          &,palloc_i7 &
          &,palloc_c1,palloc_c2,palloc_c3,palloc_c4,palloc_c5,palloc_c6&
          &,palloc_c7 &
          &,palloc_r1,palloc_r2,palloc_r3,palloc_r4,palloc_r5,palloc_r6&
          &,palloc_r7 &
          &,palloc_x1,palloc_x2,palloc_x3,palloc_x4,palloc_x5,palloc_x6&
          &,palloc_x7 &
          &,palloc_l1,palloc_l2,palloc_l3,palloc_l4,palloc_l5,palloc_l6&
          &,palloc_l7
  End Interface
  Interface pfree
     Module Procedure &
          & pfree_i1,pfree_i2,pfree_i3,pfree_i4,pfree_i5,pfree_i6,pfree_i7 &
          &,pfree_c1,pfree_c2,pfree_c3,pfree_c4,pfree_c5,pfree_c6,pfree_c7 &
          &,pfree_r1,pfree_r2,pfree_r3,pfree_r4,pfree_r5,pfree_r6,pfree_r7 &
          &,pfree_x1,pfree_x2,pfree_x3,pfree_x4,pfree_x5,pfree_x6,pfree_x7 &
          &,pfree_l1,pfree_l2,pfree_l3,pfree_l4,pfree_l5,pfree_l6,pfree_l7
  End Interface
  !!
  !!***********************************************************************
  !! statistics
  !!
  Integer(t_int),Parameter :: TYPE_T_INT  =1_t_int
  Integer(t_int),Parameter :: TYPE_T_REAL =2_t_int
  Integer(t_int),Parameter :: TYPE_T_LOG  =3_t_int
  Integer(t_int),Parameter :: TYPE_T_CMPLX=4_t_int
  Integer(t_int),Parameter :: TYPE_T_CHAR =5_t_int
  Integer(t_int),Parameter :: MAX_MEM_STAT=1000_t_int
  !!
  Type T_Chunk
     Integer(t_int) :: used
     Integer(t_int) :: n
     Integer(t_int) :: sizes(2,7)
     Integer(t_int) :: itype
     Real(t_real)   :: s
     Character(100) :: nmod,nsub,name
     Integer(t_int) :: p
  End Type T_Chunk
  !!
  Logical(t_log) :: STATISTICS,PRINT_SIZES
  Integer(t_int) :: bytes(5)
  Real(t_real)   :: max_mem_used
  Character(15)  :: types(5)
  Type(T_Chunk)  :: mem_stat(MAX_MEM_STAT)
  Complex(t_real),Parameter:: c0=(0.0_t_real,0.0_t_real)
  !!
  Data STATISTICS  /.True./
  Data PRINT_SIZES /.False./
  Data max_mem_used/0.0_t_real/
  Data types(1) /"Integer(t_int) "/
  Data types(2) /"Real(t_real)   "/
  Data types(3) /"Logical(t_log) "/
  Data types(4) /"Complex(t_real)"/
  Data types(5) /"Character(*)   "/
  !!
Contains
  !!***********************************************************************
  Subroutine  init_mem_stat(do_stat)
    !!
    Implicit None  
    !!LOCAL
    Logical(t_log) :: do_stat
    Integer(t_int) :: t_int_size,internal_int_size,t_real_size,t_log_size
    Integer(t_int) :: i
    External cgettypesizes
    !!
    STATISTICS=do_stat
    If(.Not. STATISTICS)Return
       
    !!
    Call cgettypesizes(t_int_size,internal_int_size,t_real_size,t_log_size)
    !!
    bytes(1)=t_int_size
    bytes(2)=t_real_size
    bytes(3)=t_log_size
    bytes(4)=t_real_size*2_t_int
    bytes(5)=1_t_int
    !!
    If(PRINT_SIZES)Then
       Write(outfile,10) t_int_size,t_real_size,t_log_size,internal_int_size
    Endif
    !!
    Do i=1,MAX_MEM_STAT
       mem_stat(i)% used=0_t_int
    Enddo
    max_mem_used=0.0_t_real
    !!
10  Format('         TYPE SIZES'&
         &,/,'Integer(t_int) : ',i3,' Byte'&
         &,/,'Real(t_real)   : ',i3,' Byte'&
         &,/,'Logical(t_log) : ',i3,' Byte'&
         &,/,'Integer        : ',i3,' Byte'&
         &)
    !!
  End Subroutine init_mem_stat
  !!***********************************************************************
  Subroutine find_free_chunk(j)
    !!
    Implicit None  
    !!IO
    Integer(t_int),Intent(out)   :: j
    !!LOCAL
    Character(*),Parameter::nsubfunc="find_free_chunk"
    Integer(t_int) :: i
    !!
    j=0_t_int
    If(.Not. STATISTICS) Return
    !! find a free slot in mem_stat
    Do i=1,MAX_MEM_STAT
       If(mem_stat(i)% used==0)Then
          j=i
          Exit
       Endif
    Enddo
    If(j==0_t_int)Then
       Call errmsg(nmodule,nsubfunc,E_information&
            &,msg="'MAX_MEM_STAT to small, memory statistics incomplete!'")
       Return
       j=MAX_MEM_STAT
    Endif
    !!TODO: not yet clear how to identify the chunks in a call to pfree
    !!      so, just use mem_stat as an on_allocate_print_out
    !j=1_t_int
    !!END TODO
  End Subroutine find_free_chunk
  !!***********************************************************************
  Subroutine register_mem_stat(ip,nmod,nsub,name,itype,size10,size11&
       &,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,size70,size71)
    !!
    Implicit none  
    !!IO
    Integer(t_int),Intent(in)    :: ip,itype
    Integer(t_int),Intent(in)    :: size10,size11
    Integer(t_int),Intent(in),Optional :: size20,size21,size30,size31
    Integer(t_int),Intent(in),Optional :: size40,size41,size50,size51
    Integer(t_int),Intent(in),Optional :: size60,size61,size70,size71
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer(t_int) :: i,j,k
    Real(t_real)   :: s
    !!
    If(.Not. STATISTICS) Return
    Call find_free_chunk(j)
    !!
    mem_stat(j)% p=ip
    mem_stat(j)% itype=itype
    !!
    mem_stat(j)% n=1_t_int
    mem_stat(j)% used=1_t_int
    mem_stat(j)% nmod=nmod
    mem_stat(j)% nsub=nsub
    mem_stat(j)% name=name

    mem_stat(j)% sizes(1,mem_stat(j)% n)=size10
    mem_stat(j)% sizes(2,mem_stat(j)% n)=size11
    If(Present(size20).And.Present(size21))Then
       mem_stat(j)% n=2_t_int
       mem_stat(j)% sizes(1,mem_stat(j)% n)=size20
       mem_stat(j)% sizes(2,mem_stat(j)% n)=size21
    Endif
    If(Present(size30).And.Present(size31))Then
       mem_stat(j)% n=3_t_int
       mem_stat(j)% sizes(1,mem_stat(j)% n)=size30
       mem_stat(j)% sizes(2,mem_stat(j)% n)=size31
    Endif
    If(Present(size40).And.Present(size41))Then
       mem_stat(j)% n=4_t_int
       mem_stat(j)% sizes(1,mem_stat(j)% n)=size40
       mem_stat(j)% sizes(2,mem_stat(j)% n)=size41
    Endif
    If(Present(size50).And.Present(size51))Then
       mem_stat(j)% n=5_t_int
       mem_stat(j)% sizes(1,mem_stat(j)% n)=size50
       mem_stat(j)% sizes(2,mem_stat(j)% n)=size51
    Endif
    If(Present(size60).And.Present(size61))Then
       mem_stat(j)% n=6_t_int
       mem_stat(j)% sizes(1,mem_stat(j)% n)=size60
       mem_stat(j)% sizes(2,mem_stat(j)% n)=size61
    Endif
    If(Present(size70).And.Present(size71))Then
       mem_stat(j)% n=7_t_int
       mem_stat(j)% sizes(1,mem_stat(j)% n)=size70
       mem_stat(j)% sizes(2,mem_stat(j)% n)=size71
    Endif
    !!
    mem_stat(j)% s=1.0_t_real
    Do i=1,mem_stat(j)% n
       mem_stat(j)% s=mem_stat(j)% s*Real(mem_stat(j)% sizes(2,i)&
            &-mem_stat(j)% sizes(1,i)+1_t_int,t_real)
    Enddo
    mem_stat(j)% s=(mem_stat(j)% s*bytes(mem_stat(j)% itype))/1024.0_t_real**2
    s=0.0_t_real
    Do k=1,MAX_MEM_STAT
       If(mem_stat(k)% used==1_t_int)Then
          s=s+mem_stat(k)% s
       Endif
    Enddo
    !!
    max_mem_used=Max(max_mem_used,s)
    !!
    Call print_chunk(j)
    !!
    !!
    !!
  End Subroutine register_mem_stat
  !!***********************************************************************
  Subroutine  mem_status()
    !!
    Implicit None  
    !!IO
    !!LOCAL
    Integer(t_int) :: j
    Real(t_real)   :: s
    Character(200) :: str1
    !!
    If(.Not. STATISTICS) Return
    !!
    Write(outfile,10) 
    Write(outfile,11) 
    Write(outfile,10) 
    s=0.0_t_real
    Do j=1,MAX_MEM_STAT
       If(mem_stat(j)% used==1)Then
          Call print_chunk(j)
          s=s+mem_stat(j)% s
       Endif
    Enddo
    Write(str1,3) s
    str1=Adjustl(str1)
    Write(outfile,10)
    Write(outfile,12)Trim(str1)
    Write(str1,3) max_mem_used
    str1=Adjustl(str1)
    Write(outfile,10)
    Write(outfile,14)Trim(str1)
    Write(outfile,10)
    Write(outfile,10)
3   Format(f30.3)
10  Format(72('='))
11  Format('=============================   MEMORY USAGE '&
         &,'===========================')
12  Format('TOTAL:    ',a,' MByte')
14  Format('MAX  :    ',a,' MByte')
  End Subroutine mem_status
  !!***********************************************************************
  Subroutine print_chunk(j)
    !!
    Implicit None  
    !!IO
    Integer(t_int),Intent(in)    :: j
    !!LOCAL
    Integer(t_int) :: i
    Character(200) :: str1,str2
    !!
    If(.Not. STATISTICS) Return
    !!
    Write(str1,3) mem_stat(j)% s
    str1=Adjustl(str1)
    Write(outfile,100,advance='no')j, Trim(str1),types(mem_stat(j)% itype)&
         &,Trim(mem_stat(j)% name)
    Do i=1,mem_stat(j)% n
       Write(str1,2) mem_stat(j)% sizes(1,i)
       Write(str2,2) mem_stat(j)% sizes(2,i)
       str1=Adjustl(str1)
       str2=Adjustl(str2)
       Write(outfile,101,advance='no') Trim(str1),Trim(str2)
       If(i<mem_stat(j)% n)Write(outfile,102,advance='no')
    Enddo

    Write(outfile,103) Trim(mem_stat(j)% nmod)&
         &,Trim(mem_stat(j)% nsub)
    !!
    !!
    !!
    !!
2   Format(i12)
3   Format(f30.3)
100 Format(i5,' ALLOCATED ',a,' MByte  [  ',a,' :: ',a,'(')
101 Format(a,':',a)
102 Format(',')
103 Format(')  ] in ',a,'::',a)
    Return
    !!
  End Subroutine print_chunk
  !!***********************************************************************
  Subroutine  free_chunk(add)
    !!
    Implicit None  
    !!IO
    Integer(t_int),Intent(in)    :: add
    !!LOCAL
    Character(*),Parameter::nsubfunc="free_chunk"
    Integer(t_int) :: j
    !!
    If(.Not. STATISTICS) Return
    !!
    Do j=1,MAX_MEM_STAT
       If(mem_stat(j)% used==1_t_int)Then
          If(mem_stat(j)% p==add)Then
             mem_stat(j)% used=0_t_int
             Return
          Endif
       Endif
    Enddo
    !!
    Call errmsg(nmodule,nsubfunc,E_information&
         &,msg="'Could not find chunk to free!'")

    !!
  End Subroutine free_chunk
  !!***********************************************************************
  !!***********************************************************************
  !!***********************************************************************
  !!***********************************************************************
  Subroutine palloc_i1(name,ia,size10,size11,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11
    Integer(t_int),Pointer       :: ia(:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    Allocate(ia(size10:size11),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11&
            &)
    End If
    !!

  End Subroutine palloc_i1

  !!***********************************************************************
  Subroutine palloc_i2(name,ia,size10,size11,size20,size21,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21
    Integer(t_int),Pointer       :: ia(:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    Allocate(ia(size10:size11,size20:size21),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11&
            &,size20,size21&
            &)
    End If

    !!

  End Subroutine palloc_i2
  !!***********************************************************************
  Subroutine palloc_i3(name,ia,size10,size11,size20,size21,size30,size31&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Pointer       :: ia(:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    Allocate(ia(size10:size11,size20:size21,size30:size31),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &)
    End If
    !!
  End Subroutine palloc_i3
  !!***********************************************************************
  Subroutine palloc_i4(name,ia,size10,size11,size20,size21&
       &,size30,size31,size40,size41&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41
    Integer(t_int),Pointer       :: ia(:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    Allocate(ia(size10:size11,size20:size21,size30:size31,size40:size41)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &)
    End If
    !!

  End Subroutine palloc_i4
  !!***********************************************************************
  Subroutine palloc_i5(name,ia,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51
    Integer(t_int),Pointer       :: ia(:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    Allocate(ia(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &)
    Endif
    !!

  End Subroutine palloc_i5
  !!***********************************************************************
  Subroutine palloc_i6(name,ia,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51,size60,size61
    Integer(t_int),Pointer       :: ia(:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    Allocate(ia(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &,size60,size61&
            &)
    End If
    !!

  End Subroutine palloc_i6
  !!***********************************************************************
  Subroutine palloc_i7(name,ia,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,size70,size71&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51,size60,size61
    Integer(t_int),Intent(in)    :: size70,size71
    Integer(t_int),Pointer       :: ia(:,:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    Allocate(ia(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61,size70:size71)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &,size60,size61&
            &,size70,size71&
            &)
    End If
    !!

  End Subroutine palloc_i7
  !!***********************************************************************
  Subroutine palloc_c1(name,ca,size10,size11,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11
    Character(*),Pointer         :: ca(:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    Allocate(ca(size10:size11),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11&
            &)
    End If
    !!

  End Subroutine palloc_c1
  !!***********************************************************************
  Subroutine palloc_c2(name,ca,size10,size11,size20,size21,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21
    Character(*),Pointer         :: ca(:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    Allocate(ca(size10:size11,size20:size21),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11&
            &,size20,size21&
            &)
    End If
    !!

  End Subroutine palloc_c2
  !!***********************************************************************
  Subroutine palloc_c3(name,ca,size10,size11,size20,size21,size30,size31&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Character(*),Pointer         :: ca(:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    Allocate(ca(size10:size11,size20:size21,size30:size31),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &)
    Endif
    !!

  End Subroutine palloc_c3
  !!***********************************************************************
  Subroutine palloc_c4(name,ca,size10,size11,size20,size21&
       &,size30,size31,size40,size41&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41
    Character(*),Pointer         :: ca(:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    Allocate(ca(size10:size11,size20:size21,size30:size31,size40:size41)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &)
    Endif
    !!

  End Subroutine palloc_c4
  !!***********************************************************************
  Subroutine palloc_c5(name,ca,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51
    Character(*),Pointer         :: ca(:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    Allocate(ca(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &)
    Endif
    !!

  End Subroutine palloc_c5
  !!***********************************************************************
  Subroutine palloc_c6(name,ca,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51,size60,size61
    Character(*),Pointer         :: ca(:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    Allocate(ca(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &,size60,size61&
            &)
    Endif
    !!

  End Subroutine palloc_c6
  !!***********************************************************************
  Subroutine palloc_c7(name,ca,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,size70,size71&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51,size60,size61
    Integer(t_int),Intent(in)    :: size70,size71
    Character(*),Pointer         :: ca(:,:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    Allocate(ca(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61,size70:size71)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &,size60,size61&
            &,size70,size71&
            &)
    Endif
    !!

  End Subroutine palloc_c7
  !!***********************************************************************
  Subroutine palloc_r1(name,ra,size10,size11,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11
    Real(t_real),Pointer         :: ra(:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    Allocate(ra(size10:size11),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11&
            &)
    Endif
    !!
  End Subroutine palloc_r1
  !!***********************************************************************
  Subroutine palloc_r2(name,ra,size10,size11,size20,size21,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21
    Real(t_real),Pointer         :: ra(:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    Allocate(ra(size10:size11,size20:size21),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11&
            &,size20,size21&
            &)
    Endif
    !!
  End Subroutine palloc_r2
  !!***********************************************************************
  Subroutine palloc_r3(name,ra,size10,size11,size20,size21,size30,size31&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Real(t_real),Pointer         :: ra(:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    Allocate(ra(size10:size11,size20:size21,size30:size31),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &)
    End If
    !!

  End Subroutine palloc_r3
  !!***********************************************************************
  Subroutine palloc_r4(name,ra,size10,size11,size20,size21&
       &,size30,size31,size40,size41&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41
    Real(t_real),Pointer         :: ra(:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    Allocate(ra(size10:size11,size20:size21,size30:size31,size40:size41)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &)
    End If
    !!

  End Subroutine palloc_r4
  !!***********************************************************************
  Subroutine palloc_r5(name,ra,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51
    Real(t_real),Pointer         :: ra(:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    Allocate(ra(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &)
    End If
    !!
  End Subroutine palloc_r5
  !!***********************************************************************
  Subroutine palloc_r6(name,ra,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51,size60,size61
    Real(t_real),Pointer         :: ra(:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    Allocate(ra(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &,size60,size61&
            &)
    End If
    !!
  End Subroutine palloc_r6
  !!***********************************************************************
  Subroutine palloc_r7(name,ra,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,size70,size71&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51,size60,size61
    Integer(t_int),Intent(in)    :: size70,size71
    Real(t_real),Pointer         :: ra(:,:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    Allocate(ra(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61,size70:size71)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &,size60,size61&
            &,size70,size71&
            &)
    End If
    !!
  End Subroutine palloc_r7
  !!***********************************************************************
  Subroutine palloc_x1(name,xa,size10,size11,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11
    Complex(t_real),Pointer      :: xa(:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    Allocate(xa(size10:size11),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11&
            &)
    End If
    !!

  End Subroutine palloc_x1
  !!***********************************************************************
  Subroutine palloc_x2(name,xa,size10,size11,size20,size21,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21
    Complex(t_real),Pointer      :: xa(:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    Allocate(xa(size10:size11,size20:size21),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11&
            &,size20,size21&
            &)
    End If
    !!

  End Subroutine palloc_x2
  !!***********************************************************************
  Subroutine palloc_x3(name,xa,size10,size11,size20,size21,size30,size31&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Complex(t_real),Pointer      :: xa(:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    Allocate(xa(size10:size11,size20:size21,size30:size31),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &)
    End If
    !!

  End Subroutine palloc_x3
  !!***********************************************************************
  Subroutine palloc_x4(name,xa,size10,size11,size20,size21&
       &,size30,size31,size40,size41&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41
    Complex(t_real),Pointer      :: xa(:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    Allocate(xa(size10:size11,size20:size21,size30:size31,size40:size41)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &)
    End If
    !!

  End Subroutine palloc_x4
  !!***********************************************************************
  Subroutine palloc_x5(name,xa,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51
    Complex(t_real),Pointer      :: xa(:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    Allocate(xa(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &)
    End If
    !!

  End Subroutine palloc_x5
  !!***********************************************************************
  Subroutine palloc_x6(name,xa,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51,size60,size61
    Complex(t_real),Pointer      :: xa(:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    Allocate(xa(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &,size60,size61&
            &)
    End If
    !!

  End Subroutine palloc_x6
  !!***********************************************************************
  Subroutine palloc_x7(name,xa,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,size70,size71&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51,size60,size61
    Integer(t_int),Intent(in)    :: size70,size71
    Complex(t_real),Pointer      :: xa(:,:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    Allocate(xa(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61,size70:size71)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &,size60,size61&
            &,size70,size71&
            &)
    End If
    !!

  End Subroutine palloc_x7
  !!***********************************************************************
  !!***********************************************************************
  Subroutine palloc_l1(name,la,size10,size11,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11
    Logical(t_log),Pointer       :: la(:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    Allocate(la(size10:size11),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11&
            &)
    End If
    !!

  End Subroutine palloc_l1
  !!***********************************************************************
  Subroutine palloc_l2(name,la,size10,size11,size20,size21,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21
    Logical(t_log),Pointer       :: la(:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    Allocate(la(size10:size11,size20:size21),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11&
            &,size20,size21&
            &)
    End If
    !!

  End Subroutine palloc_l2
  !!***********************************************************************
  Subroutine palloc_l3(name,la,size10,size11,size20,size21,size30,size31&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Logical(t_log),Pointer       :: la(:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    Allocate(la(size10:size11,size20:size21,size30:size31),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &)
    End If
    !!

  End Subroutine palloc_l3
  !!***********************************************************************
  Subroutine palloc_l4(name,la,size10,size11,size20,size21&
       &,size30,size31,size40,size41&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41
    Logical(t_log),Pointer       :: la(:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    Allocate(la(size10:size11,size20:size21,size30:size31,size40:size41)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &)
    End If
    !!

  End Subroutine palloc_l4
  !!***********************************************************************
  Subroutine palloc_l5(name,la,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51
    Logical(t_log),Pointer       :: la(:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    Allocate(la(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &)
    End If
    !!

  End Subroutine palloc_l5
  !!***********************************************************************
  Subroutine palloc_l6(name,la,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51,size60,size61
    Logical(t_log),Pointer       :: la(:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    Allocate(la(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &,size60,size61&
            &)
    End If
    !!

  End Subroutine palloc_l6
  !!***********************************************************************
  Subroutine palloc_l7(name,la,size10,size11,size20,size21&
       &,size30,size31,size40,size41,size50,size51,size60,size61&
       &,size70,size71&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Intent(in)    :: size40,size41,size50,size51,size60,size61
    Integer(t_int),Intent(in)    :: size70,size71
    Logical(t_log),Pointer       :: la(:,:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    Allocate(la(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61,size70:size71)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11&
            &,size20,size21&
            &,size30,size31&
            &,size40,size41&
            &,size50,size51&
            &,size60,size61&
            &,size70,size71&
            &)
    End If
    !!

  End Subroutine palloc_l7
  !!***********************************************************************
  Subroutine pfree_c1(ca)
    Implicit None 
    !!IO
    Character(*),Pointer         :: ca(:)
    !!LOCAL
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    !!
  End Subroutine pfree_c1
  !!***********************************************************************
  Subroutine pfree_c2(ca)
    Implicit None 
    !!IO
    Character(*),Pointer         :: ca(:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    !!
  End Subroutine pfree_c2
  !!***********************************************************************
  Subroutine pfree_c3(ca)
    Implicit None 
    !!IO
    Character(*),Pointer         :: ca(:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    !!
  End Subroutine pfree_c3
  !!***********************************************************************
  Subroutine pfree_c4(ca)
    Implicit None 
    !!IO
    Character(*),Pointer         :: ca(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    !!
  End Subroutine pfree_c4
  !!***********************************************************************
  Subroutine pfree_c5(ca)
    Implicit None 
    !!IO
    Character(*),Pointer         :: ca(:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    !!
  End Subroutine pfree_c5
  !!***********************************************************************
  Subroutine pfree_c6(ca)
    Implicit None 
    !!IO
    Character(*),Pointer         :: ca(:,:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    !!
  End Subroutine pfree_c6
  !!***********************************************************************
  Subroutine pfree_c7(ca)
    Implicit None 
    !!IO
    Character(*),Pointer         :: ca(:,:,:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccharmemaddress
    !!
    If(Associated(ca))Then
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Endif
    !!
  End Subroutine pfree_c7
  !!***********************************************************************
  Subroutine pfree_r1(ra)
    Implicit None 
    !!IO
    Real(t_real),Pointer         :: ra(:)
    !!LOCAL
    Integer(t_int) :: add
    External crealmemaddress
    !!
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    !!
  End Subroutine pfree_r1
  !!***********************************************************************
  Subroutine pfree_r2(ra)
    Implicit None 
    !!IO
    Real(t_real),Pointer         :: ra(:,:)
    !!LOCAL
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    !!
  End Subroutine pfree_r2
  !!***********************************************************************
  Subroutine pfree_r3(ra)
    Implicit None 
    !!IO
    Real(t_real),Pointer         :: ra(:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    !!
  End Subroutine pfree_r3
  !!***********************************************************************
  Subroutine pfree_r4(ra)
    Implicit None 
    !!IO
    Real(t_real),Pointer         :: ra(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    !!
  End Subroutine pfree_r4
  !!***********************************************************************
  Subroutine pfree_r5(ra)
    Implicit None 
    !!IO
    Real(t_real),Pointer         :: ra(:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    !!
  End Subroutine pfree_r5
  !!***********************************************************************
  Subroutine pfree_r6(ra)
    Implicit None 
    !!IO
    Real(t_real),Pointer         :: ra(:,:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    !!
  End Subroutine pfree_r6
  !!***********************************************************************
  Subroutine pfree_r7(ra)
    Implicit None 
    !!IO
    Real(t_real),Pointer         :: ra(:,:,:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External crealmemaddress
    !!
    If(Associated(ra))Then
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Endif
    !!
  End Subroutine pfree_r7
  !!***********************************************************************
  Subroutine pfree_i1(ia)
    Implicit None 
    !!IO
    Integer(t_int),Pointer         :: ia(:)
    !!LOCAL
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    !!
  End Subroutine pfree_i1
  !!***********************************************************************
  Subroutine pfree_i2(ia)
    Implicit None 
    !!IO
    Integer(t_int),Pointer         :: ia(:,:)
    !!LOCAL
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    !!
  End Subroutine pfree_i2
  !!***********************************************************************
  Subroutine pfree_i3(ia)
    Implicit None 
    !!IO
    Integer(t_int),Pointer         :: ia(:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    !!
  End Subroutine pfree_i3
  !!***********************************************************************
  Subroutine pfree_i4(ia)
    Implicit None 
    !!IO
    Integer(t_int),Pointer         :: ia(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    !!
  End Subroutine pfree_i4
  !!***********************************************************************
  Subroutine pfree_i5(ia)
    Implicit None 
    !!IO
    Integer(t_int),Pointer         :: ia(:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    !!
  End Subroutine pfree_i5
  !!***********************************************************************
  Subroutine pfree_i6(ia)
    Implicit None 
    !!IO
    Integer(t_int),Pointer         :: ia(:,:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    !!
  End Subroutine pfree_i6
  !!***********************************************************************
  Subroutine pfree_i7(ia)
    Implicit None 
    !!IO
    Integer(t_int),Pointer         :: ia(:,:,:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External cintmemaddress
    !!
    If(Associated(ia))Then
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Endif
    !!
  End Subroutine pfree_i7
  !!***********************************************************************
  Subroutine pfree_x1(xa)
    Implicit None 
    !!IO
    Complex(t_real),Pointer         :: xa(:)
    !!LOCAL
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    !!
  End Subroutine pfree_x1
  !!***********************************************************************
  Subroutine pfree_x2(xa)
    Implicit None 
    !!IO
    Complex(t_real),Pointer         :: xa(:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    !!
  End Subroutine pfree_x2
  !!***********************************************************************
  Subroutine pfree_x3(xa)
    Implicit None 
    !!IO
    Complex(t_real),Pointer         :: xa(:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    !!
  End Subroutine pfree_x3
  !!***********************************************************************
  Subroutine pfree_x4(xa)
    Implicit None 
    !!IO
    Complex(t_real),Pointer         :: xa(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    !!
  End Subroutine pfree_x4
  !!***********************************************************************
  Subroutine pfree_x5(xa)
    Implicit None 
    !!IO
    Complex(t_real),Pointer         :: xa(:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    !!
  End Subroutine pfree_x5
  !!***********************************************************************
  Subroutine pfree_x6(xa)
    Implicit None 
    !!IO
    Complex(t_real),Pointer         :: xa(:,:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    !!
  End Subroutine pfree_x6
  !!***********************************************************************
  Subroutine pfree_x7(xa)
    Implicit None 
    !!IO
    Complex(t_real),Pointer         :: xa(:,:,:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External ccmplxmemaddress
    !!
    If(Associated(xa))Then
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Endif
    !!
  End Subroutine pfree_x7
  !!***********************************************************************
  Subroutine pfree_l1(la)
    Implicit None 
    !!IO
    Logical(t_log),Pointer         :: la(:)
    !!LOCAL
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    !!
  End Subroutine pfree_l1
  !!***********************************************************************
  Subroutine pfree_l2(la)
    Implicit None 
    !!IO
    Logical(t_log),Pointer         :: la(:,:)
    !!LOCAL
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    !!
  End Subroutine pfree_l2
  !!***********************************************************************
  Subroutine pfree_l3(la)
    Implicit None 
    !!IO
    Logical(t_log),Pointer         :: la(:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    !!
  End Subroutine pfree_l3
  !!***********************************************************************
  Subroutine pfree_l4(la)
    Implicit None 
    !!IO
    Logical(t_log),Pointer         :: la(:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    !!
  End Subroutine pfree_l4
  !!***********************************************************************
  Subroutine pfree_l5(la)
    Implicit None 
    !!IO
    Logical(t_log),Pointer         :: la(:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    !!
  End Subroutine pfree_l5
  !!***********************************************************************
  Subroutine pfree_l6(la)
    Implicit None 
    !!IO
    Logical(t_log),Pointer         :: la(:,:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    !!
  End Subroutine pfree_l6
  !!***********************************************************************
  Subroutine pfree_l7(la)
    Implicit None 
    !!IO
    Logical(t_log),Pointer         :: la(:,:,:,:,:,:,:)
    !!LOCAL
    Integer(t_int) :: add
    External clogmemaddress
    !!
    If(Associated(la))Then
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Endif
    !!
  End Subroutine pfree_l7
  !!***********************************************************************
  Subroutine realloc_i1(name,ia,size10,size11,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11
    Integer(t_int),Pointer         :: ia(:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1
    Integer(t_int),Pointer :: tmp(:)
    External cintmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ia))Then
       !!
       l1=Lbound(ia,1)
       u1=Ubound(ia,1)
       !!
       Allocate(tmp(l1:u1),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1)=ia(l1:u1)
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Else
       Call palloc_i1(name,ia&
            &,size10,size11,nmod,nsub)
       ia=0_t_int
       Return
    Endif
    Allocate(ia(size10:size11),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11&
            &)
    End If
    !!
    ia=0_t_int
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    !!
    ia(l1:u1)=tmp(l1:u1)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_i1
  !!***********************************************************************
  Subroutine realloc_i2(name,ia,size10,size11,size20,size21,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21
    Integer(t_int),Pointer         :: ia(:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2
    Integer(t_int),Pointer :: tmp(:,:)
    External cintmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ia))Then
       !!
       l1=Lbound(ia,1)
       u1=Ubound(ia,1)
       l2=Lbound(ia,2)
       u2=Ubound(ia,2)
       !!
       Allocate(tmp(l1:u1,l2:u2),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2)=ia(l1:u1,l2:u2)
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Else
       Call palloc_i2(name,ia&
            &,size10,size11,size20,size21,nmod,nsub)
       ia=0_t_int
       Return
    Endif
    Allocate(ia(size10:size11,size20:size21),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11,size20,size21&
            &)
    End If
    !!
    ia=0_t_int
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    !!
    ia(l1:u1,l2:u2)=tmp(l1:u1,l2:u2)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_i2
  !!***********************************************************************
  Subroutine realloc_i3(name,ia,size10,size11,size20,size21,size30,size31&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Integer(t_int),Pointer         :: ia(:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3
    Integer(t_int),Pointer :: tmp(:,:,:)
    External cintmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ia))Then
       !!
       l1=Lbound(ia,1)
       u1=Ubound(ia,1)
       l2=Lbound(ia,2)
       u2=Ubound(ia,2)
       l3=Lbound(ia,3)
       u3=Ubound(ia,3)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3)=ia(l1:u1,l2:u2,l3:u3)
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Else
       Call palloc_i3(name,ia&
            &,size10,size11,size20,size21,size30,size31,nmod,nsub)
       ia=0_t_int
       Return
    Endif
    Allocate(ia(size10:size11,size20:size21,size30:size31),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11,size20,size21,size30,size31&
            &)
    End If
    !!
    ia=0_t_int
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    !!
    ia(l1:u1,l2:u2,l3:u3)=tmp(l1:u1,l2:u2,l3:u3)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_i3
  !!***********************************************************************
  Subroutine realloc_i4(name,ia,size10,size11,size20,size21,size30,size31&
       &,size40,size41,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41
    Integer(t_int),Pointer         :: ia(:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4
    Integer(t_int),Pointer :: tmp(:,:,:,:)
    External cintmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ia))Then
       !!
       l1=Lbound(ia,1)
       u1=Ubound(ia,1)
       l2=Lbound(ia,2)
       u2=Ubound(ia,2)
       l3=Lbound(ia,3)
       u3=Ubound(ia,3)
       l4=Lbound(ia,4)
       u4=Ubound(ia,4)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4)=ia(l1:u1,l2:u2,l3:u3,l4:u4)
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Else
       Call palloc_i4(name,ia&
            &,size10,size11,size20,size21,size30,size31,size40,size41,nmod,nsub)
       ia=0_t_int
       Return
    Endif
    Allocate(ia(size10:size11,size20:size21,size30:size31,size40:size41),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11,size20,size21,size30,size31,size40,size41&
            &)
    End If
    !!
    ia=0_t_int
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    !!
    ia(l1:u1,l2:u2,l3:u3,l4:u4)=tmp(l1:u1,l2:u2,l3:u3,l4:u4)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_i4
  !!***********************************************************************
  Subroutine realloc_i5(name,ia,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51
    Integer(t_int),Pointer         :: ia(:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5
    Integer(t_int),Pointer :: tmp(:,:,:,:,:)
    External cintmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ia))Then
       !!
       l1=Lbound(ia,1)
       u1=Ubound(ia,1)
       l2=Lbound(ia,2)
       u2=Ubound(ia,2)
       l3=Lbound(ia,3)
       u3=Ubound(ia,3)
       l4=Lbound(ia,4)
       u4=Ubound(ia,4)
       l5=Lbound(ia,5)
       u5=Ubound(ia,5)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)=ia(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Else
       Call palloc_i5(name,ia&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,nmod,nsub)
       ia=0_t_int
       Return
    Endif
    Allocate(ia(size10:size11,size20:size21,size30:size31,size40:size41,size50:size51)&
         &,STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &)
    End If
    !!
    ia=0_t_int
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    !!
    ia(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_i5
  !!***********************************************************************
  Subroutine realloc_i6(name,ia,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,size60,size61,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51,size60,size61
    Integer(t_int),Pointer         :: ia(:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5,l6,u6
    Integer(t_int),Pointer :: tmp(:,:,:,:,:,:)
    External cintmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ia))Then
       !!
       l1=Lbound(ia,1)
       u1=Ubound(ia,1)
       l2=Lbound(ia,2)
       u2=Ubound(ia,2)
       l3=Lbound(ia,3)
       u3=Ubound(ia,3)
       l4=Lbound(ia,4)
       u4=Ubound(ia,4)
       l5=Lbound(ia,5)
       u5=Ubound(ia,5)
       l6=Lbound(ia,6)
       u6=Ubound(ia,6)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)=ia(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Else
       Call palloc_i6(name,ia&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,nmod,nsub)
       ia=0_t_int
       Return
    Endif
    Allocate(ia(size10:size11,size20:size21,size30:size31,size40:size41,size50:size51&
         &,size60:size61),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61&
            &)
    End If
    !!
    ia=0_t_int
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    l6=Max(l6,size60)
    u6=Min(u6,size61)
    !!
    ia(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_i6
  !!***********************************************************************
  Subroutine realloc_i7(name,ia,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,size60,size61,size70,size71,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51,size60,size61,size70,size71
    Integer(t_int),Pointer         :: ia(:,:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5,l6,u6,l7,u7
    Integer(t_int),Pointer :: tmp(:,:,:,:,:,:,:)
    External cintmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ia))Then
       !!
       l1=Lbound(ia,1)
       u1=Ubound(ia,1)
       l2=Lbound(ia,2)
       u2=Ubound(ia,2)
       l3=Lbound(ia,3)
       u3=Ubound(ia,3)
       l4=Lbound(ia,4)
       u4=Ubound(ia,4)
       l5=Lbound(ia,5)
       u5=Ubound(ia,5)
       l6=Lbound(ia,6)
       u6=Ubound(ia,6)
       l7=Lbound(ia,7)
       u7=Ubound(ia,7)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)&
            &=ia(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)
       !!
       If(STATISTICS)Then
          Call cintmemaddress(ia,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ia)
       Nullify(ia)
    Else
       Call palloc_i7(name,ia&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,size70,size71,nmod,nsub)
       ia=0_t_int
       Return
    Endif
    Allocate(ia(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61,size70:size71),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call cintmemaddress(ia,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_INT&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,size70,size71&
            &)
    End If
    !!
    ia=0_t_int
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    l6=Max(l6,size60)
    u6=Min(u6,size61)
    l7=Max(l7,size70)
    u7=Min(u7,size71)
    !!
    ia(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)&
         &=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_i7
  !!***********************************************************************
  Subroutine realloc_r1(name,ra,size10,size11,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11
    Real(t_real),Pointer         :: ra(:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1
    Real(t_real),Pointer :: tmp(:)
    External crealmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ra))Then
       !!
       l1=Lbound(ra,1)
       u1=Ubound(ra,1)
       !!
       Allocate(tmp(l1:u1),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1)=ra(l1:u1)
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Else
       Call palloc_r1(name,ra&
            &,size10,size11,nmod,nsub)
       ra=0.0_t_real
       Return
    Endif
    Allocate(ra(size10:size11),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11&
            &)
    End If
    !!
    ra=0.0_t_real
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    !!
    ra(l1:u1)=tmp(l1:u1)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_r1
  !!***********************************************************************
  Subroutine realloc_r2(name,ra,size10,size11,size20,size21,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21
    Real(t_real),Pointer         :: ra(:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2
    Real(t_real),Pointer :: tmp(:,:)
    External crealmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ra))Then
       !!
       l1=Lbound(ra,1)
       u1=Ubound(ra,1)
       l2=Lbound(ra,2)
       u2=Ubound(ra,2)
       !!
       Allocate(tmp(l1:u1,l2:u2),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2)=ra(l1:u1,l2:u2)
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Else
       Call palloc_r2(name,ra&
            &,size10,size11,size20,size21,nmod,nsub)
       ra=0.0_t_real
       Return
    Endif
    Allocate(ra(size10:size11,size20:size21),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11,size20,size21&
            &)
    End If
    !!
    ra=0.0_t_real
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    !!
    ra(l1:u1,l2:u2)=tmp(l1:u1,l2:u2)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_r2
  !!***********************************************************************
  Subroutine realloc_r3(name,ra,size10,size11,size20,size21,size30,size31&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Real(t_real),Pointer         :: ra(:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3
    Real(t_real),Pointer :: tmp(:,:,:)
    External crealmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ra))Then
       !!
       l1=Lbound(ra,1)
       u1=Ubound(ra,1)
       l2=Lbound(ra,2)
       u2=Ubound(ra,2)
       l3=Lbound(ra,3)
       u3=Ubound(ra,3)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3)=ra(l1:u1,l2:u2,l3:u3)
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Else
       Call palloc_r3(name,ra&
            &,size10,size11,size20,size21,size30,size31,nmod,nsub)
       ra=0.0_t_real
       Return
    Endif
    Allocate(ra(size10:size11,size20:size21,size30:size31),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11,size20,size21,size30,size31&
            &)
    End If
    !!
    ra=0.0_t_real
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    !!
    ra(l1:u1,l2:u2,l3:u3)=tmp(l1:u1,l2:u2,l3:u3)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_r3
  !!***********************************************************************
  Subroutine realloc_r4(name,ra,size10,size11,size20,size21,size30,size31&
       &,size40,size41,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41
    Real(t_real),Pointer         :: ra(:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4
    Real(t_real),Pointer :: tmp(:,:,:,:)
    External crealmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ra))Then
       !!
       l1=Lbound(ra,1)
       u1=Ubound(ra,1)
       l2=Lbound(ra,2)
       u2=Ubound(ra,2)
       l3=Lbound(ra,3)
       u3=Ubound(ra,3)
       l4=Lbound(ra,4)
       u4=Ubound(ra,4)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4)=ra(l1:u1,l2:u2,l3:u3,l4:u4)
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Else
       Call palloc_r4(name,ra&
            &,size10,size11,size20,size21,size30,size31,size40,size41,nmod,nsub)
       ra=0.0_t_real
       Return
    Endif
    Allocate(ra(size10:size11,size20:size21,size30:size31,size40:size41),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11,size20,size21,size30,size31,size40,size41&
            &)
    End If
    !!
    ra=0.0_t_real
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    !!
    ra(l1:u1,l2:u2,l3:u3,l4:u4)=tmp(l1:u1,l2:u2,l3:u3,l4:u4)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_r4
  !!***********************************************************************
  Subroutine realloc_r5(name,ra,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51
    Real(t_real),Pointer         :: ra(:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5
    Real(t_real),Pointer :: tmp(:,:,:,:,:)
    External crealmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ra))Then
       !!
       l1=Lbound(ra,1)
       u1=Ubound(ra,1)
       l2=Lbound(ra,2)
       u2=Ubound(ra,2)
       l3=Lbound(ra,3)
       u3=Ubound(ra,3)
       l4=Lbound(ra,4)
       u4=Ubound(ra,4)
       l5=Lbound(ra,5)
       u5=Ubound(ra,5)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)=ra(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Else
       Call palloc_r5(name,ra&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,nmod,nsub)
       ra=0.0_t_real
       Return
    Endif
    Allocate(ra(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &)
    End If
    !!
    ra=0.0_t_real
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    !!
    ra(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_r5
  !!***********************************************************************
  Subroutine realloc_r6(name,ra,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,size60,size61,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51,size60,size61
    Real(t_real),Pointer         :: ra(:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5,l6,u6
    Real(t_real),Pointer :: tmp(:,:,:,:,:,:)
    External crealmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ra))Then
       !!
       l1=Lbound(ra,1)
       u1=Ubound(ra,1)
       l2=Lbound(ra,2)
       u2=Ubound(ra,2)
       l3=Lbound(ra,3)
       u3=Ubound(ra,3)
       l4=Lbound(ra,4)
       u4=Ubound(ra,4)
       l5=Lbound(ra,5)
       u5=Ubound(ra,5)
       l6=Lbound(ra,6)
       u6=Ubound(ra,6)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)=ra(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Else
       Call palloc_r6(name,ra&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,nmod,nsub)
       ra=0.0_t_real
       Return
    Endif
    Allocate(ra(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61&
            &)
    End If
    !!
    ra=0.0_t_real
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    l6=Max(l6,size60)
    u6=Min(u6,size61)
    !!
    ra(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_r6
  !!***********************************************************************
  Subroutine realloc_r7(name,ra,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,size60,size61,size70,size71,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51,size60,size61,size70,size71
    Real(t_real),Pointer         :: ra(:,:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5,l6,u6,l7,u7
    Real(t_real),Pointer :: tmp(:,:,:,:,:,:,:)
    External crealmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ra))Then
       !!
       l1=Lbound(ra,1)
       u1=Ubound(ra,1)
       l2=Lbound(ra,2)
       u2=Ubound(ra,2)
       l3=Lbound(ra,3)
       u3=Ubound(ra,3)
       l4=Lbound(ra,4)
       u4=Ubound(ra,4)
       l5=Lbound(ra,5)
       u5=Ubound(ra,5)
       l6=Lbound(ra,6)
       u6=Ubound(ra,6)
       l7=Lbound(ra,7)
       u7=Ubound(ra,7)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)&
            &=ra(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)
       !!
       If(STATISTICS)Then
          Call crealmemaddress(ra,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ra)
       Nullify(ra)
    Else
       Call palloc_r7(name,ra&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,size70,size71,nmod,nsub)
       ra=0.0_t_real
       Return
    Endif
    Allocate(ra(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61,size70:size71),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call crealmemaddress(ra,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_REAL&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,size70,size71&
            &)
    End If
    !!
    ra=0.0_t_real
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    l6=Max(l6,size60)
    u6=Min(u6,size61)
    l7=Max(l7,size70)
    u7=Min(u7,size71)
    !!
    ra(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)&
         &=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_r7
  !!***********************************************************************
  Subroutine realloc_c1(name,ca,size10,size11,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11
    Character(*),Pointer         :: ca(:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1
    Character(Len(ca)),Pointer :: tmp(:)
    External ccharmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ca))Then
       !!
       l1=Lbound(ca,1)
       u1=Ubound(ca,1)
       !!
       Allocate(tmp(l1:u1),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1)=ca(l1:u1)
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Else
       Call palloc_c1(name,ca&
            &,size10,size11,nmod,nsub)
       ca=''
       Return
    Endif
    Allocate(ca(size10:size11),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11&
            &)
    End If
    !!
    ca=''
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    !!
    ca(l1:u1)=tmp(l1:u1)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_c1
  !!***********************************************************************
  Subroutine realloc_c2(name,ca,size10,size11,size20,size21,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21
    Character(*),Pointer         :: ca(:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2
    Character(Len(ca)),Pointer :: tmp(:,:)
    External ccharmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ca))Then
       !!
       l1=Lbound(ca,1)
       u1=Ubound(ca,1)
       l2=Lbound(ca,2)
       u2=Ubound(ca,2)
       !!
       Allocate(tmp(l1:u1,l2:u2),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2)=ca(l1:u1,l2:u2)
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Else
       Call palloc_c2(name,ca&
            &,size10,size11,size20,size21,nmod,nsub)
       ca=''
       Return
    Endif
    Allocate(ca(size10:size11,size20:size21),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11,size20,size21&
            &)
    End If
    !!
    ca=''
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    !!
    ca(l1:u1,l2:u2)=tmp(l1:u1,l2:u2)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_c2
  !!***********************************************************************
  Subroutine realloc_c3(name,ca,size10,size11,size20,size21,size30,size31&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Character(*),Pointer         :: ca(:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3
    Character(Len(ca)),Pointer :: tmp(:,:,:)
    External ccharmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ca))Then
       !!
       l1=Lbound(ca,1)
       u1=Ubound(ca,1)
       l2=Lbound(ca,2)
       u2=Ubound(ca,2)
       l3=Lbound(ca,3)
       u3=Ubound(ca,3)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3)=ca(l1:u1,l2:u2,l3:u3)
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Else
       Call palloc_c3(name,ca&
            &,size10,size11,size20,size21,size30,size31,nmod,nsub)
       ca=''
       Return
    Endif
    Allocate(ca(size10:size11,size20:size21,size30:size31),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11,size20,size21,size30,size31&
            &)
    End If
    !!
    ca=''
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    !!
    ca(l1:u1,l2:u2,l3:u3)=tmp(l1:u1,l2:u2,l3:u3)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_c3
  !!***********************************************************************
  Subroutine realloc_c4(name,ca,size10,size11,size20,size21,size30,size31&
       &,size40,size41,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41
    Character(*),Pointer         :: ca(:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4
    Character(Len(ca)),Pointer :: tmp(:,:,:,:)
    External ccharmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ca))Then
       !!
       l1=Lbound(ca,1)
       u1=Ubound(ca,1)
       l2=Lbound(ca,2)
       u2=Ubound(ca,2)
       l3=Lbound(ca,3)
       u3=Ubound(ca,3)
       l4=Lbound(ca,4)
       u4=Ubound(ca,4)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4)=ca(l1:u1,l2:u2,l3:u3,l4:u4)
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Else
       Call palloc_c4(name,ca&
            &,size10,size11,size20,size21,size30,size31,size40,size41,nmod,nsub)
       ca=''
       Return
    Endif
    Allocate(ca(size10:size11,size20:size21,size30:size31,size40:size41),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11,size20,size21,size30,size31,size40,size41&
            &)
    End If
    !!
    ca=''
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    !!
    ca(l1:u1,l2:u2,l3:u3,l4:u4)=tmp(l1:u1,l2:u2,l3:u3,l4:u4)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_c4
  !!***********************************************************************
  Subroutine realloc_c5(name,ca,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51
    Character(*),Pointer         :: ca(:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5
    Character(Len(ca)),Pointer :: tmp(:,:,:,:,:)
    External ccharmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ca))Then
       !!
       l1=Lbound(ca,1)
       u1=Ubound(ca,1)
       l2=Lbound(ca,2)
       u2=Ubound(ca,2)
       l3=Lbound(ca,3)
       u3=Ubound(ca,3)
       l4=Lbound(ca,4)
       u4=Ubound(ca,4)
       l5=Lbound(ca,5)
       u5=Ubound(ca,5)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)=ca(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Else
       Call palloc_c5(name,ca&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,nmod,nsub)
       ca=''
       Return
    Endif
    Allocate(ca(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &)
    End If
    !!
    ca=''
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    !!
    ca(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_c5
  !!***********************************************************************
  Subroutine realloc_c6(name,ca,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,size60,size61,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51,size60,size61
    Character(*),Pointer         :: ca(:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5,l6,u6
    Character(Len(ca)),Pointer :: tmp(:,:,:,:,:,:)
    External ccharmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ca))Then
       !!
       l1=Lbound(ca,1)
       u1=Ubound(ca,1)
       l2=Lbound(ca,2)
       u2=Ubound(ca,2)
       l3=Lbound(ca,3)
       u3=Ubound(ca,3)
       l4=Lbound(ca,4)
       u4=Ubound(ca,4)
       l5=Lbound(ca,5)
       u5=Ubound(ca,5)
       l6=Lbound(ca,6)
       u6=Ubound(ca,6)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)=ca(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Else
       Call palloc_c6(name,ca&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,nmod,nsub)
       ca=''
       Return
    Endif
    Allocate(ca(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61&
            &)
    End If
    !!
    ca=''
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    l6=Max(l6,size60)
    u6=Min(u6,size61)
    !!
    ca(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_c6
  !!***********************************************************************
  Subroutine realloc_c7(name,ca,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,size60,size61,size70,size71,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51,size60,size61,size70,size71
    Character(*),Pointer         :: ca(:,:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5,l6,u6,l7,u7
    Character(Len(ca)),Pointer :: tmp(:,:,:,:,:,:,:)
    External ccharmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(ca))Then
       !!
       l1=Lbound(ca,1)
       u1=Ubound(ca,1)
       l2=Lbound(ca,2)
       u2=Ubound(ca,2)
       l3=Lbound(ca,3)
       u3=Ubound(ca,3)
       l4=Lbound(ca,4)
       u4=Ubound(ca,4)
       l5=Lbound(ca,5)
       u5=Ubound(ca,5)
       l6=Lbound(ca,6)
       u6=Ubound(ca,6)
       l7=Lbound(ca,7)
       u7=Ubound(ca,7)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)&
            &=ca(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)
       !!
       If(STATISTICS)Then
          Call ccharmemaddress(ca,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(ca)
       Nullify(ca)
    Else
       Call palloc_c7(name,ca&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,size70,size71,nmod,nsub)
       ca=''
       Return
    Endif
    Allocate(ca(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61,size70:size71),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccharmemaddress(ca,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CHAR&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,size70,size71&
            &)
    End If
    !!
    ca=''
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    l6=Max(l6,size60)
    u6=Min(u6,size61)
    l7=Max(l7,size70)
    u7=Min(u7,size71)
    !!
    ca(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)&
         &=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_c7
  !!***********************************************************************
  Subroutine realloc_x1(name,xa,size10,size11,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11
    Complex(t_real),Pointer         :: xa(:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1
    Complex(t_real),Pointer :: tmp(:)
    External ccmplxmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(xa))Then
       !!
       l1=Lbound(xa,1)
       u1=Ubound(xa,1)
       !!
       Allocate(tmp(l1:u1),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1)=xa(l1:u1)
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Else
       Call palloc_x1(name,xa&
            &,size10,size11,nmod,nsub)
       xa=c0
       Return
    Endif
    Allocate(xa(size10:size11),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11&
            &)
    End If
    !!
    xa=c0
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    !!
    xa(l1:u1)=tmp(l1:u1)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_x1
  !!***********************************************************************
  Subroutine realloc_x2(name,xa,size10,size11,size20,size21,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21
    Complex(t_real),Pointer         :: xa(:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2
    Complex(t_real),Pointer :: tmp(:,:)
    External ccmplxmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(xa))Then
       !!
       l1=Lbound(xa,1)
       u1=Ubound(xa,1)
       l2=Lbound(xa,2)
       u2=Ubound(xa,2)
       !!
       Allocate(tmp(l1:u1,l2:u2),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2)=xa(l1:u1,l2:u2)
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Else
       Call palloc_x2(name,xa&
            &,size10,size11,size20,size21,nmod,nsub)
       xa=c0
       Return
    Endif
    Allocate(xa(size10:size11,size20:size21),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11,size20,size21&
            &)
    End If
    !!
    xa=c0
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    !!
    xa(l1:u1,l2:u2)=tmp(l1:u1,l2:u2)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_x2
  !!***********************************************************************
  Subroutine realloc_x3(name,xa,size10,size11,size20,size21,size30,size31&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Complex(t_real),Pointer         :: xa(:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3
    Complex(t_real),Pointer :: tmp(:,:,:)
    External ccmplxmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(xa))Then
       !!
       l1=Lbound(xa,1)
       u1=Ubound(xa,1)
       l2=Lbound(xa,2)
       u2=Ubound(xa,2)
       l3=Lbound(xa,3)
       u3=Ubound(xa,3)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3)=xa(l1:u1,l2:u2,l3:u3)
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Else
       Call palloc_x3(name,xa&
            &,size10,size11,size20,size21,size30,size31,nmod,nsub)
       xa=c0
       Return
    Endif
    Allocate(xa(size10:size11,size20:size21,size30:size31),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11,size20,size21,size30,size31&
            &)
    End If
    !!
    xa=c0
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    !!
    xa(l1:u1,l2:u2,l3:u3)=tmp(l1:u1,l2:u2,l3:u3)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_x3
  !!***********************************************************************
  Subroutine realloc_x4(name,xa,size10,size11,size20,size21,size30,size31&
       &,size40,size41,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41
    Complex(t_real),Pointer         :: xa(:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4
    Complex(t_real),Pointer :: tmp(:,:,:,:)
    External ccmplxmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(xa))Then
       !!
       l1=Lbound(xa,1)
       u1=Ubound(xa,1)
       l2=Lbound(xa,2)
       u2=Ubound(xa,2)
       l3=Lbound(xa,3)
       u3=Ubound(xa,3)
       l4=Lbound(xa,4)
       u4=Ubound(xa,4)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4)=xa(l1:u1,l2:u2,l3:u3,l4:u4)
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Else
       Call palloc_x4(name,xa&
            &,size10,size11,size20,size21,size30,size31,size40,size41,nmod,nsub)
       xa=c0
       Return
    Endif
    Allocate(xa(size10:size11,size20:size21,size30:size31,size40:size41),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11,size20,size21,size30,size31,size40,size41&
            &)
    End If
    !!
    xa=c0
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    !!
    xa(l1:u1,l2:u2,l3:u3,l4:u4)=tmp(l1:u1,l2:u2,l3:u3,l4:u4)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_x4
  !!***********************************************************************
  Subroutine realloc_x5(name,xa,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51
    Complex(t_real),Pointer         :: xa(:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5
    Complex(t_real),Pointer :: tmp(:,:,:,:,:)
    External ccmplxmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(xa))Then
       !!
       l1=Lbound(xa,1)
       u1=Ubound(xa,1)
       l2=Lbound(xa,2)
       u2=Ubound(xa,2)
       l3=Lbound(xa,3)
       u3=Ubound(xa,3)
       l4=Lbound(xa,4)
       u4=Ubound(xa,4)
       l5=Lbound(xa,5)
       u5=Ubound(xa,5)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)=xa(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Else
       Call palloc_x5(name,xa&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,nmod,nsub)
       xa=c0
       Return
    Endif
    Allocate(xa(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &)
    End If
    !!
    xa=c0
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    !!
    xa(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_x5
  !!***********************************************************************
  Subroutine realloc_x6(name,xa,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,size60,size61,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51,size60,size61
    Complex(t_real),Pointer         :: xa(:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5,l6,u6
    Complex(t_real),Pointer :: tmp(:,:,:,:,:,:)
    External ccmplxmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(xa))Then
       !!
       l1=Lbound(xa,1)
       u1=Ubound(xa,1)
       l2=Lbound(xa,2)
       u2=Ubound(xa,2)
       l3=Lbound(xa,3)
       u3=Ubound(xa,3)
       l4=Lbound(xa,4)
       u4=Ubound(xa,4)
       l5=Lbound(xa,5)
       u5=Ubound(xa,5)
       l6=Lbound(xa,6)
       u6=Ubound(xa,6)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)=xa(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Else
       Call palloc_x6(name,xa&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,nmod,nsub)
       xa=c0
       Return
    Endif
    Allocate(xa(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61&
            &)
    End If
    !!
    xa=c0
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    l6=Max(l6,size60)
    u6=Min(u6,size61)
    !!
    xa(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_x6
  !!***********************************************************************
  Subroutine realloc_x7(name,xa,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,size60,size61,size70,size71,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51,size60,size61,size70,size71
    Complex(t_real),Pointer         :: xa(:,:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5,l6,u6,l7,u7
    Complex(t_real),Pointer :: tmp(:,:,:,:,:,:,:)
    External ccmplxmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(xa))Then
       !!
       l1=Lbound(xa,1)
       u1=Ubound(xa,1)
       l2=Lbound(xa,2)
       u2=Ubound(xa,2)
       l3=Lbound(xa,3)
       u3=Ubound(xa,3)
       l4=Lbound(xa,4)
       u4=Ubound(xa,4)
       l5=Lbound(xa,5)
       u5=Ubound(xa,5)
       l6=Lbound(xa,6)
       u6=Ubound(xa,6)
       l7=Lbound(xa,7)
       u7=Ubound(xa,7)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)&
            &=xa(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)
       !!
       If(STATISTICS)Then
          Call ccmplxmemaddress(xa,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(xa)
       Nullify(xa)
    Else
       Call palloc_x7(name,xa&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,size70,size71,nmod,nsub)
       xa=c0
       Return
    Endif
    Allocate(xa(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61,size70:size71),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call ccmplxmemaddress(xa,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_CMPLX&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,size70,size71&
            &)
    End If
    !!
    xa=c0
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    l6=Max(l6,size60)
    u6=Min(u6,size61)
    l7=Max(l7,size70)
    u7=Min(u7,size71)
    !!
    xa(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)&
         &=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_x7
  !!***********************************************************************
  Subroutine realloc_l1(name,la,size10,size11,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11
    Logical(t_log),Pointer         :: la(:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1
    Logical(t_log),Pointer :: tmp(:)
    External clogmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(la))Then
       !!
       l1=Lbound(la,1)
       u1=Ubound(la,1)
       !!
       Allocate(tmp(l1:u1),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1)=la(l1:u1)
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Else
       Call palloc_l1(name,la&
            &,size10,size11,nmod,nsub)
       la=.False.
       Return
    Endif
    Allocate(la(size10:size11),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11&
            &)
    End If
    !!
    la=.False.
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    !!
    la(l1:u1)=tmp(l1:u1)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_l1
  !!***********************************************************************
  Subroutine realloc_l2(name,la,size10,size11,size20,size21,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21
    Logical(t_log),Pointer         :: la(:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2
    Logical(t_log),Pointer :: tmp(:,:)
    External clogmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(la))Then
       !!
       l1=Lbound(la,1)
       u1=Ubound(la,1)
       l2=Lbound(la,2)
       u2=Ubound(la,2)
       !!
       Allocate(tmp(l1:u1,l2:u2),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2)=la(l1:u1,l2:u2)
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Else
       Call palloc_l2(name,la&
            &,size10,size11,size20,size21,nmod,nsub)
       la=.False.
       Return
    Endif
    Allocate(la(size10:size11,size20:size21),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11,size20,size21&
            &)
    End If
    !!
    la=.False.
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    !!
    la(l1:u1,l2:u2)=tmp(l1:u1,l2:u2)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_l2
  !!***********************************************************************
  Subroutine realloc_l3(name,la,size10,size11,size20,size21,size30,size31&
       &,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21,size30,size31
    Logical(t_log),Pointer         :: la(:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3
    Logical(t_log),Pointer :: tmp(:,:,:)
    External clogmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(la))Then
       !!
       l1=Lbound(la,1)
       u1=Ubound(la,1)
       l2=Lbound(la,2)
       u2=Ubound(la,2)
       l3=Lbound(la,3)
       u3=Ubound(la,3)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3)=la(l1:u1,l2:u2,l3:u3)
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Else
       Call palloc_l3(name,la&
            &,size10,size11,size20,size21,size30,size31,nmod,nsub)
       la=.False.
       Return
    Endif
    Allocate(la(size10:size11,size20:size21,size30:size31),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11,size20,size21,size30,size31&
            &)
    End If
    !!
    la=.False.
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    !!
    la(l1:u1,l2:u2,l3:u3)=tmp(l1:u1,l2:u2,l3:u3)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_l3
  !!***********************************************************************
  Subroutine realloc_l4(name,la,size10,size11,size20,size21,size30,size31&
       &,size40,size41,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41
    Logical(t_log),Pointer         :: la(:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4
    Logical(t_log),Pointer :: tmp(:,:,:,:)
    External clogmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(la))Then
       !!
       l1=Lbound(la,1)
       u1=Ubound(la,1)
       l2=Lbound(la,2)
       u2=Ubound(la,2)
       l3=Lbound(la,3)
       u3=Ubound(la,3)
       l4=Lbound(la,4)
       u4=Ubound(la,4)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4)=la(l1:u1,l2:u2,l3:u3,l4:u4)
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Else
       Call palloc_l4(name,la&
            &,size10,size11,size20,size21,size30,size31,size40,size41,nmod,nsub)
       la=.False.
       Return
    Endif
    Allocate(la(size10:size11,size20:size21,size30:size31,size40:size41),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11,size20,size21,size30,size31,size40,size41&
            &)
    End If
    !!
    la=.False.
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    !!
    la(l1:u1,l2:u2,l3:u3,l4:u4)=tmp(l1:u1,l2:u2,l3:u3,l4:u4)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_l4
  !!***********************************************************************
  Subroutine realloc_l5(name,la,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51
    Logical(t_log),Pointer         :: la(:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5
    Logical(t_log),Pointer :: tmp(:,:,:,:,:)
    External clogmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(la))Then
       !!
       l1=Lbound(la,1)
       u1=Ubound(la,1)
       l2=Lbound(la,2)
       u2=Ubound(la,2)
       l3=Lbound(la,3)
       u3=Ubound(la,3)
       l4=Lbound(la,4)
       u4=Ubound(la,4)
       l5=Lbound(la,5)
       u5=Ubound(la,5)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)=la(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Else
       Call palloc_l5(name,la&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,nmod,nsub)
       la=.False.
       Return
    Endif
    Allocate(la(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &)
    End If
    !!
    la=.False.
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    !!
    la(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_l5
  !!***********************************************************************
  Subroutine realloc_l6(name,la,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,size60,size61,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51,size60,size61
    Logical(t_log),Pointer         :: la(:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5,l6,u6
    Logical(t_log),Pointer :: tmp(:,:,:,:,:,:)
    External clogmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(la))Then
       !!
       l1=Lbound(la,1)
       u1=Ubound(la,1)
       l2=Lbound(la,2)
       u2=Ubound(la,2)
       l3=Lbound(la,3)
       u3=Ubound(la,3)
       l4=Lbound(la,4)
       u4=Ubound(la,4)
       l5=Lbound(la,5)
       u5=Ubound(la,5)
       l6=Lbound(la,6)
       u6=Ubound(la,6)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)=la(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Else
       Call palloc_l6(name,la&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,nmod,nsub)
       la=.False.
       Return
    Endif
    Allocate(la(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61&
            &)
    End If
    !!
    la=.False.
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    l6=Max(l6,size60)
    u6=Min(u6,size61)
    !!
    la(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_l6
  !!***********************************************************************
  Subroutine realloc_l7(name,la,size10,size11,size20,size21,size30,size31&
       &,size40,size41,size50,size51,size60,size61,size70,size71,nmod,nsub)
    Implicit None 
    !!IO
    Integer(t_int),Intent(in)    :: size10,size11,size20,size21&
         &,size30,size31,size40,size41,size50,size51,size60,size61,size70,size71
    Logical(t_log),Pointer         :: la(:,:,:,:,:,:,:)
    Character(*),Intent(in)      :: name,nmod,nsub
    !!LOCAL
    Integer :: icheck
    Integer(t_int) :: add,l1,u1,l2,u2,l3,u3,l4,u4,l5,u5,l6,u6,l7,u7
    Logical(t_log),Pointer :: tmp(:,:,:,:,:,:,:)
    External clogmemaddress
    !!
    Nullify(tmp)
    !!
    If(Associated(la))Then
       !!
       l1=Lbound(la,1)
       u1=Ubound(la,1)
       l2=Lbound(la,2)
       u2=Ubound(la,2)
       l3=Lbound(la,3)
       u3=Ubound(la,3)
       l4=Lbound(la,4)
       u4=Ubound(la,4)
       l5=Lbound(la,5)
       u5=Ubound(la,5)
       l6=Lbound(la,6)
       u6=Ubound(la,6)
       l7=Lbound(la,7)
       u7=Ubound(la,7)
       !!
       Allocate(tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7),STAT=icheck)
       If(icheck/=0)Then
          Call errmsg(nmod,nsub,E_fatalerror&
               &,msg="'Could not allocate memory for temporary "//Trim(name)//" !'")
          Stop !! avoid uninitialized warning
       Endif
       !!
       tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)&
            &=la(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)
       !!
       If(STATISTICS)Then
          Call clogmemaddress(la,add)  
          Call free_chunk(add)
       End If
       !!
       Deallocate(la)
       Nullify(la)
    Else
       Call palloc_l7(name,la&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,size70,size71,nmod,nsub)
       la=.False.
       Return
    Endif
    Allocate(la(size10:size11,size20:size21,size30:size31,size40:size41&
         &,size50:size51,size60:size61,size70:size71),STAT=icheck)
    If(icheck/=0)Then
       Call errmsg(nmod,nsub,E_fatalerror&
            &,msg="'Could not allocate memory for "//Trim(name)//" !'")
       Stop !! avoid uninitialized warning
    Endif
    !!
    If(STATISTICS)Then
       Call clogmemaddress(la,add)
       Call register_mem_stat(add,nmod,nsub,name,TYPE_T_LOG&
            &,size10,size11,size20,size21,size30,size31,size40,size41,size50,size51&
            &,size60,size61,size70,size71&
            &)
    End If
    !!
    la=.False.
    !!
    l1=Max(l1,size10)
    u1=Min(u1,size11)
    l2=Max(l2,size20)
    u2=Min(u2,size21)
    l3=Max(l3,size30)
    u3=Min(u3,size31)
    l4=Max(l4,size40)
    u4=Min(u4,size41)
    l5=Max(l5,size50)
    u5=Min(u5,size51)
    l6=Max(l6,size60)
    u6=Min(u6,size61)
    l7=Max(l7,size70)
    u7=Min(u7,size71)
    !!
    la(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)&
         &=tmp(l1:u1,l2:u2,l3:u3,l4:u4,l5:u5,l6:u6,l7:u7)
    !!
    Deallocate(tmp)
    !!
  End Subroutine realloc_l7
  !!***********************************************************************
  
End Module memory
