!------------------------------------------!
! WANNIER:det_wandef_symmetry:prot         !
! WANNIER:det_wandef_symmetry:prepaxisrot  !
!------------------------------------------!


!!todo: check differnt quantization axis->compare to rotated setup (symetry works?)
!!todo: do not show characters for rel groups
!!todo: check that model actually works
!!todo: frel nlm type make spin automatic
!!todo: slab does not always work, because of possible shifts in p_tau
!!todo: the slab code would work, if we make sure that the exp(iks) of the matrices
!!todo: is correctly compensated and the remaining R=0 selected

!!TODO: think about dif of first site
!!TODO: think about core ortho, especially for the WF plot
!!TODO: process insitu while reading 
!!TODO: make a symmtrizer
!!TODO: make sure wannierF is real
!!TODO: make local rotations
!!TODO: check valid input
!!TODO: avoid allocating more memory than nessecary
!!TODO: generate extension measures
Module wannier
  !!
  Use precisiondefs
  Use constants
  Use errors
  Use atomdefs
  Use memory
  Use file_iounits
  Use clock
  Use tio
  Use twannier
  Use matrixinvers
  Use sort
  Use ioaux
  Use ioadapter, Only: mkdirectory
  Use diracdefs
  Use tdiracdefs
!  Use group
  Use tkohnsham
  Use twandesc
  Use mesh
  Use matserv
  Use tmesh
  Use tbzone
  Use bzone, Only: tetdos,find_k_index
  Use ttopoins, Only: T_TopoIns,init_topoins
  Use topoins, Only: setup_gamma
  Use bandplot
  Use prnt
  Use tbandplot
  Use trelativistic
  Use diagonalize
  Use tsymmetry
  Use torbitalbasis
  Use tgrid
  Use grid
  !!
  Implicit None 
  !!
  Private
  !!
  Character(*),Parameter::nmodule="WANNIER"  
  !!
  Public :: do_wanniers
  !!***********************************************************************
  !! type to drag data around
  Type T_WANCoeffData
     !!
     !!
     !! for the Wannier function (KS)  part of Wannier business
     !!
     Integer(t_int) :: knband,kio,kiu
     !! matrix C^{+}*S
     Complex(t_real),Pointer :: p_kccts(:,:,:,:) !! knband,nvdim,nkp,nspin
     !! matrix C
     Complex(t_real),Pointer :: p_kcc(:,:,:,:) !! knband,nvdim,nkp,nspin
     !! band energies in eV
     Real(t_real),Pointer :: p_keb(:,:,:) !! knband,nkp,nspin
!!$     !! band weights
!!$     Real(t_real),Pointer :: p_kbw(:,:,:) !! knband,nkp,nspin
!!$     !! for convinience data processing
!!$     Real(t_real)   :: efermi(2)
     !!
     !!
     !! for the bandplot part of Wannier business
     !!
     !! number of processed bands, lower and upper band index (for reduced
     !! file-size)
     Integer(t_int) :: bnband,bio,biu
     !! matrix C^{+}*S
     Complex(t_real),Pointer :: p_bccts(:,:,:,:) !! bnband,nvdim,nkpnts,nspin
     !! band energies in eV
     Real(t_real),Pointer :: p_beb(:,:,:) !! bnband,nkpnts,nspin
     !! for no particular reason except for output compatibility: 
     !!      averaged Fermi energy
     Real(t_real)   :: eff
     !!
  End Type T_WANCoeffData
  !!***********************************************************************
  !!
  Complex(t_real),Parameter ::  c0=(0.0_t_real,0.0_t_real)
  Complex(t_real),Parameter ::  c1=(1.0_t_real,0.0_t_real)
  Complex(t_real),Parameter ::  ci=(0.0_t_real,1.0_t_real)
  Character(30),save   :: strtimrev(0:1)
  Data strtimrev(0:1)/'',' * time reversal'/
  !!
Contains
  !!***********************************************************************
  Subroutine init_wancoeffdata(wcd)
    !!
    Implicit None
    !!IO
    Type(T_WANCoeffData),Intent(inout) :: wcd
    !!LOCAL
    !Character(*),Parameter::nsubfunc="init_wancoeffdata"
    !!
    !!
    Nullify(wcd% p_kccts)
    Nullify(wcd% p_kcc)
    Nullify(wcd% p_keb)
    !Nullify(wcd% p_kbw)
    Nullify(wcd% p_bccts)
    Nullify(wcd% p_beb)
    !!
    Return
    !!
  End Subroutine init_wancoeffdata
  !!***********************************************************************
  Subroutine cleanup_wancoeffdata(wcd)
    !!
    Implicit None
    !!IO
    Type(T_WANCoeffData),Intent(inout) :: wcd
    !!LOCAL
    !Character(*),Parameter::nsubfunc="cleanup_wancoeffdata"
    !!
    !!
    Call pfree(wcd% p_kccts)
    Call pfree(wcd% p_kcc)
    Call pfree(wcd% p_keb)
    !Call pfree(wcd% p_kbw)
    Call pfree(wcd% p_bccts)
    Call pfree(wcd% p_beb)
    !!
    Return
    !!
  End Subroutine cleanup_wancoeffdata
  !!***********************************************************************
  Subroutine do_wanniers(mspin,symmetry,structure,lattice,basis,kohnsham&
       &,bzone,bandplot,wannier,degree,relativistic,quant)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_lattice),Intent(in)   :: lattice
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_Wannier),Intent(inout):: wannier
    Type(T_Quant),Intent(in)     :: quant
    Integer(t_int),Intent(in)    :: relativistic
    Integer(t_int),Intent(in)    :: mspin
    Integer(t_int),Intent(in)    :: degree
    !!LOCAL
    Character(*),Parameter::nsubfunc="do_wanniers"
    Type(T_WANCoeffData) :: wcd
    Logical(t_log) :: nothing_to_do,rel,warn,start,binexists,binformat
    Integer(t_int) :: nspin
    !!
    !!
    !!
    Inquire(file='=.newstuff',exist=warn)
    If(warn)Then
       Call newstuff(mspin,symmetry,structure,lattice,basis&
            &,kohnsham,bzone,bandplot,wannier,degree,relativistic,quant)
       Return
    Endif
    !!
    rel=(relativistic == FULL_RELATIVISTIC)
    nspin=mspin
    If(rel)Then
       nspin=1_t_int
    Endif
    !!
    start=.True.
    Do 
       warn=.False.
       !!
       !!
       !!
       Call read_wandefs_from_file(nspin,symmetry,structure,basis,wannier% wdef&
            &,wannier% wfgrid,wannier% have_wforigin,wannier% kgrid&
            &,wannier% do_wanniers,binformat,relativistic)
       !!
       wannier% do_wannier_from_file=wannier% do_wanniers !!TODO:
       !!
       If(.Not.wannier% do_wanniers) Return
       If(.Not.wannier% do_wannier_from_file) Return
       !!
       If(wannier% wdef% nwan ==0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="' no active Wannier MO-definitions found!'")
       Endif
       !!
       !Call analyse_irreps(symmetry% Rnumops,symmetry% Ropmat,symmetry% Ropsymbol)
       !!
       Call det_wandef_symmetry(symmetry,structure,basis,wannier% wdef,relativistic)
       !!
       Call prep_swf_lattice(symmetry,structure,wannier% wdef&
            &,wannier% wdef% ham_rcut*2&
            !&,lattice% rcut&
            &,.False.)!!TODO: make flexible
       Call prep_wf_lattice(symmetry,structure,wannier% wdef,.False.)
       !!
       !!
       If(start) Then
          If(binformat) Then
             Inquire(file=Trim(f_wancoeff_out_bin),exist=binexists)
          Endif
          Call init_wancoeffdata(wcd)
          If(.Not.binformat.Or.(binformat.And..Not.binexists))Then
             Call read_wancoeffs(nspin,symmetry% lattice_constants,structure&
                  &,kohnsham,bzone,bandplot,wcd,nothing_to_do)
          Endif
          If(binformat)Then
             If(binexists) Then
                Call read_wancoeffs_bin(nspin,structure,kohnsham,bzone,bandplot,wcd&
                     &,nothing_to_do)
             Else If(.Not.nothing_to_do) Then
                Call write_wancoeffs_bin(nspin,structure,kohnsham,bzone,bandplot,wcd)
             Endif
          Endif
       Endif
       !!
       If(nothing_to_do) Then
          Write(errbuf,10) Trim(f_wancoeff_out)
          Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
10        Format("'File ''",a,"'' not found ... will resume normal execution.&
               &',/,' If you like to do Wanniers from file, wait until&
               & files are writen',/,' (after each step) and restart.'") 
          Return
       Endif
       !!
       !!
       !!
       Call make_wannier_bands(nspin,symmetry,structure,kohnsham,bandplot&
            &,wannier% wdef,wcd,rel,warn)
       !!
       !!
       Call make_wannier_fit(nspin,symmetry,structure,lattice,basis,kohnsham&
            &,bzone,bandplot,degree,wannier% wdef,wannier% wfgrid,wannier% have_wforigin&
            &,wannier% kgrid,wcd,rel,warn,quant)
       !!
       Call cleanup_wannier(wannier)
       !!
       If(warn)Then
          Call errmsg(nmodule,nsubfunc,E_warning,msg="'There have been &
               &definitness/SVD warnings, check output.',/&
               &,' Are the energy windows large enough?'")
       Endif
       Write(outfile,"('CTRL_C for abort, enter for next trial')")
       Read(*,*)
       start=.False.
       !!
    Enddo
    !!
    Call cleanup_wancoeffdata(wcd)
    !!
    !!
    Call terminate(TERM_FINISH,' wannier band creation ')
    !!
    Return
    !!
  End Subroutine do_wanniers
  !!***********************************************************************
  Subroutine read_wancoeffs(nspin,lattice_constants,structure&
       &,kohnsham,bzone,bandplot,wcd,nothing_to_do)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_WANCoeffData),Intent(inout):: wcd    
    Logical(t_log),Intent(out)   :: nothing_to_do
    Integer(t_int),Intent(in)    :: nspin
    Real(t_real),Intent(in)      :: lattice_constants(3)
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_wancoeffs"
    Logical(t_log) :: exists
    Character(5000)   :: buf,word
    Integer(t_int) :: ikp,ms,in,idum,iz,nvdim,nkpnts,nkp,subdiv
    Real(t_real)   :: k(4),e,scale,kb(4),dum
    Real(t_real),Pointer :: zr(:)
    Integer :: eof
    !!
    nvdim=kohnsham% nvdim
    nkpnts=bandplot% nkpnts
    nkp=bzone% nkp
    scale=twopi/ lattice_constants(1)
    !!
    Nullify(zr)
    !!
    nothing_to_do=.False.
    !!
    Inquire(file=f_wancoeff_out,exist=exists)
    If(.Not.exists)Then
       nothing_to_do=.True.
       Return
    Endif
    !!
    !!
    Write(outfile,11) Trim(f_wancoeff_out)
11  Format('File ''',a,''' found, will start wannier band processing.',/) 
    !!
    Open(wancoeff_unit,file=f_wancoeff_out,status='old')
    !!
    !!
    !!
    !! -------------- KS part --------------
    !!
    !! read header information
    !!
    Read(wancoeff_unit,2)buf
    If(.Not.next_word(buf,word)) Goto 6651
    If(word(1:1)/='#') Goto 6651
    !!
    If(buf(1:30)/=' KS-function data-dump section') Goto 6651
    !!
    Read(wancoeff_unit,2)buf
    If(.Not.next_word(buf,word)) Goto 6651
    If(word(1:1)/='#') Goto 6651
    !!
    !!
    !! extract nsite
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,*,iostat=eof) idum
    If(eof/=0) Goto 666
    If(idum /= structure% nsite) Goto 667
    !!
    !!
    !! extract nkp
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,*,iostat=eof) idum
    If(eof/=0) Goto 666
    If(idum /= nkp) Goto 66141
    !!
    !! extract nvdim= dimension of matrices
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,*,iostat=eof) idum
    If(eof/=0) Goto 666
    If(idum /= nvdim) Goto 668
    !!
    !!
    !! extract nband= number of bands
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,*,iostat=eof) wcd% knband
    If(eof/=0) Goto 666
    !!
    !! extract nspin= number of spins
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,*,iostat=eof) idum
    If(eof/=0) Goto 666
    If(idum /= nspin) Goto 6613
    !!
    !! check for sub-band output
    If(next_word(buf,word)) Then
       !!
       !! extract lower band index
       Read(word,*,iostat=eof) wcd% kio
       If(eof/=0) Goto 666
       !!
       !! extract upper band index
       If(.Not.next_word(buf,word)) Goto 666
       Read(word,*,iostat=eof) wcd% kiu
       If(eof/=0) Goto 666
    Else
       wcd% kio=1
       wcd% kiu=wcd% knband

    Endif
    !!
    If(wcd% knband /= wcd% kiu-wcd% kio+1)Goto 6652
    !!
    Call palloc('zr'    ,zr    ,1_t_int,2*nvdim,nmodule,nsubfunc)
    !!
    Call palloc('wcd% p_kccts' ,wcd% p_kccts ,1_t_int,wcd% knband&
         &,1_t_int,nvdim,1_t_int,nkp,1_t_int,nspin,nmodule,nsubfunc)
    Call palloc('wcd% p_kcc' ,wcd% p_kcc ,1_t_int,wcd% knband&
         &,1_t_int,nvdim,1_t_int,nkp,1_t_int,nspin,nmodule,nsubfunc)
    Call palloc('wcd% p_keb' ,wcd% p_keb ,1_t_int,wcd% knband&
         &,1_t_int,nkp,1_t_int,nspin,nmodule,nsubfunc)
    !Call palloc('wcd% p_kbw' ,wcd% p_kbw ,1_t_int,wcd% knband&
    !     &,1_t_int,nkp,1_t_int,nspin,nmodule,nsubfunc)
    !!
    !!
    !!
    !!
    
    !!
    KSspinloop: Do ms=1,nspin
       Read(wancoeff_unit,2)buf
       If(.Not.next_word(buf,word)) Goto 6651
       If(word(1:1)/='#') Goto 669
       If(.Not.next_word(buf,word)) Goto 6651
       If(word(1:5)/='spin=') Goto 6651
       If(.Not.next_word(buf,word)) Goto 6651
       Read(word,*,iostat=eof) idum
       If(eof/=0) Goto 666
       If(idum /= ms) Goto 6610
       !!
       subdiv=(Max(1_t_int,nkp/(100/5)));
       !!
       KSkloop: Do ikp=1,nkp
          !! give feedback
          If ( Mod(ikp,subdiv) ==0 )Then
             Write(outfile,51) 100.0_t_real*ikp/nkp
          Endif
          !!
          Read(wancoeff_unit,2)buf
          If(.Not.next_word(buf,word)) Goto 6651
          If(word(1:1)/='#') Goto 669
          If(.Not.next_word(buf,word)) Goto 6651
          If(word(1:7)/='kpoint=') Goto 669
          If(.Not.next_word(buf,word)) Goto 6651
          Read(word,*,iostat=eof) idum
          If(eof/=0) Goto 666
          If(idum /= ikp) Goto 6611
          !!
          If(.Not.next_word(buf,word)) Goto 6651
          If(word(1:2)/='k=') Goto 669
          Read(buf,fmt=*,iostat=eof) k(1:3)
          If(eof/=0) Goto 666
          !!
          kb(1:3)=bzone% p_bk(1:3,ikp)
          !!
          If(Any(Abs(k-kb)>1.0e-6_t_real))Then
             Print "('k=',4(f15.8,2x))",k
             Print "('bk=',4(f15.8,2x))",kb
             Goto 66151
          Endif
          !!
          !!
          Read(wancoeff_unit,2)buf
          If(.Not.next_word(buf,word)) Goto 6651
          If(word(1:1)/='#') Goto 6651
          If(buf(1:9)/=' C^{+}*S=') Goto 6651
          !!
          Do in=1,wcd% knband
             Read(wancoeff_unit,fmt=*,iostat=eof) zr(1:2*nvdim)
             If(eof/=0) Goto 6612
             Do iz=1,nvdim
                wcd% p_kccts(in,iz,ikp,ms)=Cmplx(zr(2*iz-1),zr(2*iz),t_real)
             Enddo
          Enddo
          Read(wancoeff_unit,2)buf
          !!
          Read(wancoeff_unit,2)buf
          If(.Not.next_word(buf,word)) Goto 6651
          If(word(1:1)/='#') Goto 6651
          If(buf(1:9)/=' C=') Goto 6651
          !!
          !!
          Do in=1,wcd% knband
             Read(wancoeff_unit,fmt=*,iostat=eof) zr(1:2*nvdim)
             If(eof/=0) Goto 6612
             Do iz=1,nvdim
                wcd% p_kcc(in,iz,ikp,ms)=Cmplx(zr(2*iz-1),zr(2*iz),t_real)
             Enddo
          Enddo
          Read(wancoeff_unit,2)buf
          !!
       End Do KSkloop
    Enddo KSspinloop
    !!
    !!
    !!
    !!
    !!
    !!
    Read(wancoeff_unit,2)buf
    If(buf(1:16)/='# e(k,n) f(k,n)=') Goto 669
    !!
    KSspinloopE: Do ms=1,nspin
       !!
       Read(wancoeff_unit,2)buf
       If(.Not.next_word(buf,word)) Goto 6651
       If(word(1:1)/='#') Goto 669
       If(.Not.next_word(buf,word)) Goto 6651
       If(word(1:5)/='spin=') Goto 669
       If(.Not.next_word(buf,word)) Goto 6651
       Read(word,*,iostat=eof) idum
       If(eof/=0) Goto 666
       If(idum /= ms) Goto 6610
       If(.Not.next_word(buf,word)) Goto 6651
       !Read(buf,fmt=*,iostat=eof) wcd% efermi(ms)
       !If(eof/=0) Goto 666
       !!
       
       KSkloopE: Do ikp=1,nkp
          !!
          !!
          Read(wancoeff_unit,2)buf
          If(.Not.next_word(buf,word)) Goto 6651
          If(word(1:1)/='#') Goto 669
          If(.Not.next_word(buf,word)) Goto 6651
          If(word(1:7)/='kpoint=') Goto 669
          If(.Not.next_word(buf,word)) Goto 6651
          Read(word,*,iostat=eof) idum
          If(eof/=0) Goto 666
          If(idum /= ikp) Goto 6611
          !!
          If(.Not.next_word(buf,word)) Goto 6651
          If(word(1:2)/='k=') Goto 669
          Read(buf,fmt=*,iostat=eof) k(1:3)
          If(eof/=0) Goto 666
          !!
          kb(1:3)=bzone% p_bk(1:3,ikp)
          !!
          If(Any(Abs(k-kb)>1.0e-6_t_real))Then
             Print "('k=',4(f15.8,2x))",k
             Print "('bk=',4(f15.8,2x))",kb
             Goto 66151
          Endif
          !!
          
          Do in=1,wcd% knband
             !!
             Read(wancoeff_unit,fmt=*,iostat=eof)wcd% p_keb(in,ikp,ms),dum
             !wcd% p_kbw(in,ikp,ms) =dum
             If(eof/=0) Goto 6612
             !!
          Enddo
          Read(wancoeff_unit,2)buf


          
       Enddo KSkloopE
       !!
       Read(wancoeff_unit,2)buf
       !!
    Enddo KSspinloopE
    !!
    !!
    !!
    !! -------------- bandplot part --------------
    !!
    Read(wancoeff_unit,2)buf
    If(.Not.next_word(buf,word)) Goto 6651
    If(word(1:1)/='#') Goto 6651
    If(buf(1:27)/=' bandplot data-dump section') Goto 6651
    !!
    Read(wancoeff_unit,2)buf
    If(.Not.next_word(buf,word)) Goto 6651
    If(word(1:1)/='#') Goto 6651
    !!
    !Write(outfile,"('word=[',a,']')")Trim(word)
    !Write(outfile,"('buf=[',a,']')")Trim(buf)
    !Stop
    !! extract nsite
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,*,iostat=eof) idum
    If(eof/=0) Goto 666
    If(idum /= structure% nsite) Goto 667
    !!
    !! extrat averaged Fermi energy
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,fmt=*,iostat=eof) wcd% eff
    If(eof/=0) Goto 666
    !!
    !! extract nkp
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,*,iostat=eof) idum
    If(eof/=0) Goto 666
    If(idum /= nkpnts) Goto 6614
    !!
    !! extract nvdim= dimension of matrices
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,*,iostat=eof) idum
    If(eof/=0) Goto 666
    If(idum /= nvdim) Goto 668
    !!
    !! extract nband= number of bands
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,*,iostat=eof) wcd% bnband
    If(eof/=0) Goto 666
    !!
    !! extract nspin= number of spins
    If(.Not.next_word(buf,word)) Goto 666
    Read(word,*,iostat=eof) idum
    If(eof/=0) Goto 666
    If(idum /= nspin) Goto 6613
    !!
    !! check for sub-band output
    If(next_word(buf,word)) Then
       !!
       !! extract lower band index
       Read(word,*,iostat=eof) wcd% bio
       If(eof/=0) Goto 666
       !!
       !! extract upper band index
       If(.Not.next_word(buf,word)) Goto 666
       Read(word,*,iostat=eof) wcd% biu
       If(eof/=0) Goto 666
    Else
       wcd% bio=1
       wcd% biu=wcd% bnband
    Endif
    !!
    !!
    If(wcd% bnband /= wcd% biu-wcd% bio+1)Goto 665
    !!
    Call palloc('wcd% p_beb'  ,wcd% p_beb  ,1_t_int,wcd% bnband,1_t_int&
         &,nkpnts,1_t_int,nspin,nmodule,nsubfunc)
    Call palloc('wcd% p_bccts' ,wcd% p_bccts ,1_t_int,wcd% bnband&
         &,1_t_int,nvdim,1_t_int,nkpnts,1_t_int,nspin,nmodule,nsubfunc)
    !!

    !! skip-read next line
    Read(wancoeff_unit,*)
    !!
    subdiv=(Max(1_t_int,nkpnts/(100/20)));

    ikloop: Do ikp=1,nkpnts
       !! give feedback
       If ( Mod(ikp,subdiv) ==0 )Then
          Write(outfile,5) 100.0_t_real*ikp/nkpnts
       Endif
       !!
       spinloop: Do ms=1,nspin
          !!
          Read(wancoeff_unit,2)buf
          !!
          If(.Not.next_word(buf,word)) Goto 669
          If(word(1:1)/='#') Goto 669
          If(.Not.next_word(buf,word)) Goto 669
          If(word(1:5)/='spin=') Goto 669
          If(.Not.next_word(buf,word)) Goto 669
          Read(word,*,iostat=eof) idum
          If(eof/=0) Goto 666
          If(idum /= ms) Goto 6610
          If(.Not.next_word(buf,word)) Goto 669
          If(word(1:2)/='k=') Goto 669
          If(.Not.next_word(buf,word)) Goto 669
          Read(word,fmt=*,iostat=eof) k(1)
          If(eof/=0) Goto 6611
          If(.Not.next_word(buf,word)) Goto 669
          Read(word,fmt=*,iostat=eof) k(2)
          If(eof/=0) Goto 6611
          If(.Not.next_word(buf,word)) Goto 669
          Read(word,fmt=*,iostat=eof) k(3)
          If(eof/=0) Goto 6611
          If(.Not.next_word(buf,word)) Goto 669
          If(word(1:3)/='dk=') Goto 669
          If(.Not.next_word(buf,word)) Goto 669
          Read(word,fmt=*,iostat=eof) k(4)
          If(eof/=0) Goto 6611
          !!
          kb(1:3)=bandplot% p_kpnts(1:3,ikp)*scale
          kb(4)=bandplot% p_kpnts(4,ikp)
          !!
          If(Any(Abs(k-kb)>1.0e-6_t_real))Then
             Print "('k=',4(f15.8,2x))",k
             Print "('bk=',4(f15.8,2x))",kb
             Goto 6615
          Endif
          !!
          !!
          Do in=1,wcd% bnband
             Read(wancoeff_unit,fmt=*,iostat=eof) idum,e&
                  &,zr(1:2*nvdim)
             If(eof/=0) Goto 6612
             Do iz=1,nvdim
                wcd% p_bccts(in,iz,ikp,ms)=Cmplx(zr(2*iz-1),zr(2*iz),t_real)
             Enddo
             wcd% p_beb(in,ikp,ms)=e
          Enddo
       Enddo spinloop
    Enddo ikloop
    !!
    Close(wancoeff_unit)
    !!

    !Print *,'nband =',wcd% bnband
    !Print *,'io    =',wcd% bio
    !Print *,'iu    =',wcd% biu
    !Print *,'efermi=',wcd% efermi(1:nspin)
    !!
    !!
    Call pfree(zr)
    !!
    Return
    !!
6651 Continue
    !!
    !!
    Write(errbuf,"('''File ''''',a,''''' corrupted''')")&
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
666 Continue
    !!
    !!
    Write(errbuf,"('''Header of ''''',a,''''' file corrupted''')")&
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
665 Continue
    !!
    !!
    Write(errbuf,"('''bnband,bio,biu corrupted in Header of ''''',a,''''' file corrupted''')")&
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
6652 Continue
    !!
    !!
    Write(errbuf,"('''knband,kio,kiu corrupted in Header of ''''',a,''''' file corrupted''')")&
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
667 Continue
    !!
    !!
    Write(errbuf,"('''nsite in header of ''''',a,''''' file different''')")& !
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
668 Continue
    !!
    !!
    Write(errbuf,"('''nvdim in header of ''''',a,''''' file different''')")& !
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
6613 Continue
    !!
    !!
    Write(errbuf,"('''nspin in header of ''''',a,''''' file different''')")& !
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
6614 Continue
    !!
    !!
    Write(errbuf,"('''nkpnts in header of ''''',a,''''' file different''')")& !
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
66141 Continue
    !!
    !!
    Write(errbuf,"('''nkp in header of ''''',a,''''' file different''')")& !
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
6615 Continue
    !!
    !!
    Write(errbuf,"(''' p_kpnts in bandplot data part  of ''''',a,''''' file differ from input settings''')")& !
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
66151 Continue
    !!
    !!
    Write(errbuf,"(''' p_bk in bandplot data part  of ''''',a,''''' file differ from input settings''')")& !
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
669 Continue
    !!
    !!
    Write(errbuf,"('''comment line in ''''',a,''''' file corrupted''')")&
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
6610 Continue
    !!
    !!
    Write(errbuf,"('''spin in comment line in ''''',a,''''' file corrupted''')")&
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
6611 Continue
    !!
    !!
    Write(errbuf,"('''k-vector in comment line in ''''',a,''''' file corrupted''')")&
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
6612 Continue
    !!
    !!
    Write(errbuf,"('''data in some line in ''''',a,''''' file corrupted''')")&
         &Trim(f_wancoeff_out)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
    !! other formats
    !!
5   Format('reading bandplot-data: ',f5.1,'% done')
51  Format('reading KS-data: ',f5.1,'% done')
2   Format(a)
    !!
  End Subroutine read_wancoeffs
  !!***********************************************************************
  Subroutine write_wancoeffs_bin(nspin,structure,kohnsham,bzone,bandplot,wcd)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_WANCoeffData),Intent(in):: wcd    
    Integer(t_int),Intent(in)    :: nspin
    !!LOCAL
    !Character(*),Parameter::nsubfunc="write_wancoeffs_bin"
    Integer(t_int) :: ms,ikp
    !!
    Write(outfile,11) Trim(f_wancoeff_out_bin)
11  Format('File ''',a,''' not found, will create it.',/) 
    !!
    Open(wancoeff_unit,file=Trim(f_wancoeff_out_bin),status='unknown',form='unformatted')    !!
    !! write header information
    !!
    Write(wancoeff_unit) '#version: binary'
    Write(wancoeff_unit) '# nsite                 =',structure% nsite
    Write(wancoeff_unit) '# nvdim                 =',kohnsham% nvdim
    Write(wancoeff_unit) '# nspin                 =',nspin
    Write(wancoeff_unit) '# KS-function data-dump section'
    Write(wancoeff_unit) '# nkp                   =',bzone% nkp
    Write(wancoeff_unit) '# nband                 =',wcd% knband
    Write(wancoeff_unit) '# lband                 =',wcd% kio
    Write(wancoeff_unit) '# uband                 =',wcd% kiu
    !!
    Write(wancoeff_unit) '# kpoints               =',bzone% p_bk(1:3,1:bzone% nkp)
    spinloop: Do ms=1,nspin
       Write(wancoeff_unit) '# spin                  =',ms
       KSkloop: Do ikp=1,bzone% nkp
          Write(wancoeff_unit) '# C^{+}*S               ='&
               &,wcd% p_kccts(1:wcd% knband,1:kohnsham% nvdim,ikp,ms)
          Write(wancoeff_unit) '# C                     ='&
               &,wcd% p_kcc(1:wcd% knband,1:kohnsham% nvdim,ikp,ms)
          Write(wancoeff_unit) '# e(k,n)                ='&
               &,wcd% p_keb(1:wcd% knband,ikp,ms)
       End Do KSkloop
    Enddo spinloop
    !!
    Write(wancoeff_unit) '# bandplot data-dump section'
    Write(wancoeff_unit) '# eff                   =',wcd% eff
    Write(wancoeff_unit) '# nkp                   =',bandplot% nkpnts
    Write(wancoeff_unit) '# nband                 =',wcd% bnband
    Write(wancoeff_unit) '# lband                 =',wcd% bio
    Write(wancoeff_unit) '# uband                 =',wcd% biu
    !!
    Write(wancoeff_unit) '# kpoints               ='&
         &,bandplot% p_kpnts(1:4,1:bandplot% nkpnts)
    !!
    Do ikp=1,bandplot% nkpnts
       Do ms=1,nspin
          Write(wancoeff_unit) '# C                     ='&
               &,wcd% p_bccts(1:wcd% bnband,1:kohnsham% nvdim,ikp,ms)
          Write(wancoeff_unit) '# e(k,n)                ='&
               &,wcd% p_beb(1:wcd% bnband,ikp,ms)
       Enddo
    Enddo
    !!
    Close(wancoeff_unit)
    !!
    Write(outfile,12) Trim(f_wancoeff_out_bin),Trim(f_wancoeff_out)
12  Format('File ''',a,''' created. You can delete ''',a&
         &,'''. ',/,'Unless you want to copy it to a different machine.',/)
    !!
    !!
    Return
    !!
  End Subroutine write_wancoeffs_bin
  !!***********************************************************************
  Subroutine read_wancoeffs_bin(nspin,structure,kohnsham,bzone,bandplot,wcd&
       &,nothing_to_do)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_WANCoeffData),Intent(inout):: wcd    
    Logical(t_log),Intent(out)   :: nothing_to_do
    Integer(t_int),Intent(in)    :: nspin
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_wancoeffs_bin"
    Logical(t_log) :: exists
    Integer(t_int) :: ms,ikp,idum,subdiv
    Integer        :: err
    Character(16)  :: str16
    Character(25)  :: str25
    Character(28)  :: str28
    Character(31)  :: str31
    Character(*),Parameter :: interror="'file data error'"
    Real(t_real),Pointer :: p_bk(:,:),p_bbk(:,:)
    !!
    Nullify(p_bk,p_bbk)
    !!
    nothing_to_do=.False.
    !!
    Inquire(file=f_wancoeff_out_bin,exist=exists)
    If(.Not.exists)Then
       nothing_to_do=.True.
       Return
    Endif
    !!
    Write(outfile,11) Trim(f_wancoeff_out_bin)
11  Format('File ''',a,''' found, will start wannier band processing.',/) 
    !!
    Open(wancoeff_unit,file=f_wancoeff_out_bin,status='old',form='unformatted')
    !!
    !!
    !! read header information
    !!
    Read(wancoeff_unit,iostat=err) str16
    If(str16 /= '#version: binary')Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="'binary file has wrong version ... abort'")
    Endif
    !!
    Read(wancoeff_unit,iostat=err) str25,idum
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='nsite')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    If(idum/=structure% nsite)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="'nsite in file is different'")
    Endif
    !!
    Read(wancoeff_unit,iostat=err) str25,idum
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='nvdim')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    If(idum/=kohnsham% nvdim)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="'nvdim in file is different'")
    Endif
    !!
    Read(wancoeff_unit,iostat=err) str25,idum
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='nspin')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    If(idum/=nspin)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="'nspin in file is different'")
    Endif
    !!
    !! -------------- KS part --------------
    !!
    Read(wancoeff_unit,iostat=err) str31
    If(err/=0.Or.str31/='# KS-function data-dump section')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    !!
    Read(wancoeff_unit,iostat=err) str25,idum
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='nkp')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    If(idum/=bzone% nkp)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="'nkp in file is different'")
    Endif
    !!
    Read(wancoeff_unit,iostat=err) str25,wcd% knband
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='nband')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    Read(wancoeff_unit,iostat=err) str25,wcd% kio
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='lband')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    Read(wancoeff_unit,iostat=err) str25,wcd% kiu
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='uband')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    If(wcd% knband /= wcd% kiu-wcd% kio+1)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="'inconsistent nband kio and kiu'")
    Endif
    !!
    Call palloc('p_bk',p_bk,1_t_int,3_t_int,1_t_int,bzone% nkp,nmodule,nsubfunc)
    Read(wancoeff_unit,iostat=err) str25,p_bk(1:3,1:bzone% nkp)
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='kpoints')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    !!
    Call palloc('wcd% p_kccts' ,wcd% p_kccts ,1_t_int,wcd% knband&
         &,1_t_int,kohnsham% nvdim,1_t_int,bzone% nkp,1_t_int,nspin&
         &,nmodule,nsubfunc)
    Call palloc('wcd% p_kcc' ,wcd% p_kcc ,1_t_int,wcd% knband&
         &,1_t_int,kohnsham% nvdim,1_t_int,bzone% nkp,1_t_int,nspin&
         &,nmodule,nsubfunc)
    Call palloc('wcd% p_keb' ,wcd% p_keb ,1_t_int,wcd% knband&
         &,1_t_int,bzone% nkp,1_t_int,nspin,nmodule,nsubfunc)
    !!
    spinloop: Do ms=1,nspin
       Read(wancoeff_unit,iostat=err) str25,idum
       If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='spin')&
            & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
       If(idum/=ms)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="'spin in file is different'")
       Endif
       !!
       subdiv=(Max(1_t_int,bzone% nkp*nspin/(100/5)));
       !!
       KSkloop: Do ikp=1,bzone% nkp
          If ( Mod(ikp,subdiv) ==0 )Then
             Write(outfile,51) 100.0_t_real*(ikp+(ms-1)*bzone% nkp)/(bzone% nkp*nspin)
          Endif
          Read(wancoeff_unit,iostat=err) str25&
               &,wcd% p_kccts(1:wcd% knband,1:kohnsham% nvdim,ikp,ms)
          If(err/=0) Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
          Read(wancoeff_unit,iostat=err) str25&
               &,wcd% p_kcc(1:wcd% knband,1:kohnsham% nvdim,ikp,ms)
          If(err/=0) Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
          Read(wancoeff_unit,iostat=err) str25&
               &,wcd% p_keb(1:wcd% knband,ikp,ms)
          If(err/=0) Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
       End Do KSkloop
    End Do spinloop
    !!
    !!
    !!
    Read(wancoeff_unit,iostat=err) str28
    If(err/=0.Or.str28/='# bandplot data-dump section')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    Read(wancoeff_unit,iostat=err) str25,wcd% eff
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='eff')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    !!
    Read(wancoeff_unit,iostat=err) str25,idum
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='nkp')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    If(idum/=bandplot% nkpnts)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="'nkpnts in file is different'")
    Endif
    !!
    Read(wancoeff_unit,iostat=err) str25,wcd% bnband
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='nband')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    Read(wancoeff_unit,iostat=err) str25,wcd% bio
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='lband')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    Read(wancoeff_unit,iostat=err) str25,wcd% biu
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='uband')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    If(wcd% knband /= wcd% kiu-wcd% kio+1)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="'inconsistent nband kio and kiu'")
    Endif
    If(wcd% bnband /= wcd% biu-wcd% bio+1)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="'inconsistent nband bio and biu'")
    Endif
    !!
    Call palloc('p_bbk',p_bbk,1_t_int,4_t_int,1_t_int,bandplot% nkpnts,nmodule,nsubfunc)
    Read(wancoeff_unit,iostat=err) str25,p_bbk(1:4,1:bandplot% nkpnts)
    If(err/=0.Or.Trim(Adjustl(str25(2:24)))/='kpoints')&
         & Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
    !!
    !!
    Call palloc('wcd% p_beb'  ,wcd% p_beb  ,1_t_int,wcd% bnband,1_t_int&
         &,bandplot% nkpnts,1_t_int,nspin,nmodule,nsubfunc)
    Call palloc('wcd% p_bccts' ,wcd% p_bccts ,1_t_int,wcd% bnband&
         &,1_t_int,kohnsham% nvdim,1_t_int,bandplot% nkpnts&
         &,1_t_int,nspin,nmodule,nsubfunc)
    !!
    subdiv=(Max(1_t_int,bandplot% nkpnts/(100/20)));
    !!
    Do ikp=1,bandplot% nkpnts
       If ( Mod(ikp,subdiv) ==0 )Then
          Write(outfile,5) 100.0_t_real*ikp/bandplot% nkpnts
       Endif
       Do ms=1,nspin
          Read(wancoeff_unit,iostat=err) str25&
               &,wcd% p_bccts(1:wcd% bnband,1:kohnsham% nvdim,ikp,ms)
          If(err/=0) Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
          Read(wancoeff_unit,iostat=err) str25&
               &,wcd% p_beb(1:wcd% bnband,ikp,ms)
          If(err/=0) Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=interror)
       Enddo
    Enddo
    !!
    !!
    Close(wancoeff_unit)
    !!
    Call pfree(p_bk)
    Call pfree(p_bbk)
    !!
    !!
    Return
    !!
5   Format('reading bandplot-data: ',f5.1,'% done')
51  Format('reading KS-data: ',f5.1,'% done')
    !!
  End Subroutine read_wancoeffs_bin
    !!***********************************************************************
  Subroutine det_bindex_in_ewindow(nband,eb,emin,emax,del,deu,lband,uband,hewan,octol)
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: nband,lband,uband
    Real(t_real),Intent(in)      :: emin,emax,del,deu,octol
    Real(t_real),Intent(in)      :: eb(:)
    Real(t_real),Intent(out)     :: hewan(:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="det_bindex_in_ewindow"
    Integer(t_int) :: in,io,iu
    Real(t_real)   :: e
    !!
    !Print *,'lband,uband=',lband,uband
    !!
    !! determine band index range fitting into an energy window
    !!
    !!
    io=0_t_int
    inloop3: Do in=1,nband
       If(eb(in) >= emin+octol)Then
          Exit inloop3
       Endif
       io=in
    Enddo inloop3 
    !!
    iu=nband+1
    inloop4: Do in=nband,1,-1
       If(eb(in) <= emax-octol)Then
          Exit inloop4
       Endif
       iu=in
    Enddo inloop4
    !!
    io=io+1
    iu=iu-1
    !!
    hewan(:)=0.0_t_real
    Do in=1,nband
       If((lband>0.And.in<lband).Or.(uband>0.And.in>uband))Cycle
       e=eb(in)
       If(emin<=e .And. e<=emax)Then
          hewan(in)=1.0_t_real
       Else if(emax<e)then
          hewan(in)=Exp(-((e-emax)/deu)**2)
       Else if(e<emin)then
          hewan(in)=Exp(-((emin-e)/del)**2)
       Endif
       !Print "('in ',i5,4(f12.5,2x))",in,eb(in),emin,emax,hewan(in)
    Enddo
    !!
    Return
    !!
  End Subroutine det_bindex_in_ewindow
  !!***********************************************************************
  !! temporay helper until data in canonical format
  Subroutine read_wandefs_from_file(nspin,symmetry,structure,basis,wdef,wfgrid&
       &,have_wforigin,kgrid,do_wanniers,binformat,relativistic)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Type(T_WanDefs),Intent(inout) :: wdef
    Type(T_Grid),Intent(inout)   :: wfgrid,kgrid
    Logical(t_log),Intent(out)   :: do_wanniers,have_wforigin,binformat
    Integer(t_int),Intent(in)    :: nspin,relativistic
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_wandefs_from_file"
    Logical(t_log) :: exists,start,rel
    Character(5000)   :: buf,word,text
    Integer(t_int) :: iwan,icn,isa,issa,ivr,oldwan,i,j,ms
    Real(t_real)   :: d,re,im
    Character(*),Parameter :: fname='=.wandef'
    Character(2),Parameter   :: on ='on'
    Character(3),Parameter   :: off='off'
    Character(3)   :: onoff
    Integer :: eof
    !Type(T_OrbitalDescriptor) :: od 
    !!
    rel=(relativistic == FULL_RELATIVISTIC)
    do_wanniers=.False.
    !!
    Inquire(file=Trim(fname),exist=exists)
    If(.Not.exists) Then
       do_wanniers=.False.
       Return
    Endif
    !!
    Call copy_file_to_output(outfile,fname)
    !! count defs
    !!
    have_wforigin=.False.
    wdef% nwan=0
    oldwan=0
    start=.False.
    Open(12,file=fname,status='old')
    readcountloop0: Do 
       Read(12,2,iostat=eof) buf
       If(eof/=0) Exit readcountloop0
       Call replace_tabs_by_blanks(buf)
       If(next_word(buf,word)) Then
          If( word(1:6) == 'wandef') Then
             oldwan=wdef% nwan
             wdef% nwan=wdef% nwan+1   
             start=.True.
          Endif
          If( start .And. word(1:3) == 'off') Then
             wdef% nwan=oldwan   
             start=.False.
          Endif
       Endif
    Enddo readcountloop0
    !!
    Write(outfile,1)
    Write(outfile,100)wdef% nwan
    !!
    !! count indefs
    !!
    Call palloc('wdef% p_ninwans',wdef% p_ninwan,1_t_int,wdef% nwan&
         &,nmodule,nsubfunc)
    !!
    wdef% p_ninwan=0
    wdef% ninwanmax=0
    iwan=0
    oldwan=0
    start=.False.
    rewind(12)
    readcountloop1: Do 
       Read(12,2,iostat=eof) buf
       If(eof/=0) Exit readcountloop1
       Call replace_tabs_by_blanks(buf)
       If(next_word(buf,word)) Then
          !Print "('word=[',a,']')" , Trim(word)
          If( word(1:6) == 'wandef') Then
             oldwan=iwan
             iwan=iwan+1   
             start=.True.
          Endif
          If( start .And. word(1:3) == 'off') Then
             iwan=oldwan
             start=.False.
          Endif
          If( start .And. word(1:7) == 'contrib') Then
             If(iwan==0) Stop'missing ''wandef'' somewhere'
             !Print *,'iwan=',iwan
             wdef% p_ninwan(iwan)=wdef% p_ninwan(iwan)+1
          Endif
       Endif
    Enddo readcountloop1
    !!
    If(wdef% nwan>0)Then
       wdef% ninwanmax=Maxval(wdef% p_ninwan(1:wdef% nwan))
    Endif
    !!
    !!
    !!
    Call palloc('wdef% p_name',wdef% p_name,1_t_int,wdef% nwan,nmodule,nsubfunc)
    Call palloc('wdef% p_site',wdef% p_site,1_t_int,wdef% ninwanmax&
         &,1_t_int,wdef% nwan,nmodule,nsubfunc)
    Call palloc('wdef% p_difvec',wdef% p_difvec,1_t_int,3_t_int&
         &,1_t_int,wdef% ninwanmax,1_t_int,wdef% nwan,nmodule,nsubfunc)
    Call palloc('wdef% p_center',wdef% p_center,1_t_int,3_t_int&
         &,1_t_int,wdef% nwan,nmodule,nsubfunc)
    Call palloc('wdef% p_ewind',wdef% p_ewind,1_t_int,4_t_int&
         &,1_t_int,wdef% nwan,1_t_int,2_t_int,nmodule,nsubfunc)
    Call palloc('wdef% p_lband',wdef% p_lband,1_t_int,2_t_int&
         &,1_t_int,wdef% nwan,nmodule,nsubfunc)
    Call palloc('wdef% p_uband',wdef% p_uband,1_t_int,2_t_int&
         &,1_t_int,wdef% nwan,nmodule,nsubfunc)
    Call palloc('wdef% p_axes',wdef% p_axes,1_t_int,3_t_int&
         &,1_t_int,2_t_int,1_t_int,wdef% ninwanmax,1_t_int,wdef% nwan&
         &,nmodule,nsubfunc)
    Call palloc_orbitaldescriptor('wdef% p_od',wdef% p_od,wdef% ninwanmax&
         &,wdef% nwan,nmodule,nsubfunc)
    Call palloc('wdef% p_ivr',wdef% p_ivr,1_t_int,wdef% ninwanmax&
         &,1_t_int,wdef% nwan,nmodule,nsubfunc)
    Call palloc('wdef% p_fac',wdef% p_fac,1_t_int,wdef% ninwanmax&
         &,1_t_int,wdef% nwan,nmodule,nsubfunc)
    !!
    !!
    wdef% p_site=0_t_int
    wdef% p_ivr=0_t_int
    wdef% p_difvec=0.0_t_real
    wdef% p_center=0.0_t_real
    Do iwan=1,wdef% nwan
       Write(wdef% p_name(iwan),12)iwan
       wdef% p_ewind(1,iwan,1:nspin)=-100.0_t_real
       wdef% p_ewind(2,iwan,1:nspin)= 100.0_t_real
       wdef% p_ewind(3,iwan,1:nspin)=   1.0_t_real
       wdef% p_ewind(4,iwan,1:nspin)=   1.0_t_real
       wdef% p_lband(1:2,iwan)=   0
       wdef% p_uband(1:2,iwan)=   0
       Do icn=1,wdef% p_ninwan(iwan)
          wdef% p_axes(1:3,1,icn,iwan)=(/1.0_t_real,0.0_t_real,0.0_t_real/)
          wdef% p_axes(1:3,2,icn,iwan)=(/0.0_t_real,0.0_t_real,1.0_t_real/)
       Enddo
    Enddo
    wdef% p_od(:,:)%nmain=1
    wdef% p_od(:,:)%l=0
    wdef% p_od(:,:)%m=0
    wdef% p_fac(:,:)=c1
    !!
    binformat=.False.
    wdef% ham_rcut=10.0_t_real !! bohr
    wdef% WF_coeff_threshold=1.0e-4_t_real
    wdef% WF_ham_threshold=0.005_t_real
    wdef% write_WF_coeff_stats=.False.
    wdef% write_Ham_t_stats=.False.
    wdef% slab_direction=0.0_t_real
    !!
    !!
    Rewind(12)
    iwan=0
    oldwan=0
    start=.False.
    icn=0
    readloop: Do 
       Read(12,2,iostat=eof) buf
       If(eof/=0) Exit readloop
       Call replace_tabs_by_blanks(buf)
       If(next_word(buf,word)) Then
          If( word(1:4) == 'doit') Then
             do_wanniers=.True.
          Endif
          If( word(1:19) == 'coefficients_format') Then
             If(next_word(buf,word)) Then
                If(word(1:3)=='bin') binformat=.True.
             Endif
          Endif
          If( word(1:10) == 'ham_cutoff') Then
             Read(buf,fmt=*,iostat=eof) wdef% ham_rcut
             If(eof/=0) Goto 6666
          Endif
          If( word(1:14) == 'slab_direction') Then
             Read(buf,fmt=*,iostat=eof) wdef% slab_direction
             If(eof/=0) Goto 6666
          Endif
          If( word(1:18) == 'WF_coeff_threshold') Then
             Read(buf,fmt=*,iostat=eof) wdef% WF_coeff_threshold
             If(eof/=0) Goto 6666
          Endif
          If( word(1:16) == 'WF_ham_threshold') Then
             Read(buf,fmt=*,iostat=eof) wdef% WF_ham_threshold
             If(eof/=0) Goto 6666
          Endif
          !!
          !!
          If( word(1:13) == 'WF_grid_basis') Then
             buf=Adjustl(buf)
             If(char_to_uc(buf(1:1))=='P') Then
                wfgrid% basis=GRID_BASIS_PRIMITIVE
             Elseif(char_to_uc(buf(1:1))=='C') Then
                wfgrid% basis=GRID_BASIS_CONVENTIONAL
             Else
                wfgrid% basis=0
             Endif
          Endif
          If( .Not. valid_grid_basis(wfgrid) ) Then
             Write(errbuf,992) wfgrid% basis,fname
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
          Endif
          !!
          If( word(1:18) == 'WF_grid_directions') Then
             If(Len_trim(buf)==0)Then
                Do i=1,3
                   Read(12,2,iostat=eof) buf
                   If(eof/=0) Exit readloop                
                   Call replace_tabs_by_blanks(buf)
                   Read(buf,fmt=*,iostat=eof) wfgrid% directions(:,i)
                   If(eof/=0) Goto 6666
                Enddo
             Else
                Read(buf,fmt=*,iostat=eof) wfgrid% directions(:,1)
                If(eof/=0) Goto 6666
                Do i=2,3
                   Read(12,2,iostat=eof) buf
                   If(eof/=0) Exit readloop                
                   Call replace_tabs_by_blanks(buf)
                   Read(buf,fmt=*,iostat=eof) wfgrid% directions(:,i)
                   If(eof/=0) Goto 6666
                Enddo
             Endif
          Endif
          !!
          If( word(1:19) == 'WF_grid_subdivision') Then
             Read(buf,fmt=*,iostat=eof) wfgrid% subdivisions(1:3)
             If(eof/=0) Goto 6666
          Endif
          !!
          If( word(1:14) == 'WF_grid_origin') Then
             Read(buf,fmt=*,iostat=eof) wfgrid% origin(1:3)
             If(eof/=0) Goto 6666
             have_wforigin=.True.
          Endif
          !!
          !! kgrid
          !!
          If( word(1:12) == 'k_grid_basis') Then
             buf=Adjustl(buf)
             If(char_to_uc(buf(1:1))=='P') Then
                kgrid% basis=GRID_BASIS_PRIMITIVE
             Elseif(char_to_uc(buf(1:1))=='C') Then
                kgrid% basis=GRID_BASIS_CONVENTIONAL
             Else
                kgrid% basis=0
             Endif
          Endif
          !!
          If( .Not. valid_grid_basis(kgrid) ) Then
             
992          Format("'Wrong grid basis type: ",i4," in file """,a,""" !'")
             Write(errbuf,992) kgrid% basis,fname
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
          Endif
          !!
          !!
          If( word(1:17) == 'k_grid_directions') Then
             If(Len_trim(buf)==0)Then
                Do i=1,3
                   Read(12,2,iostat=eof) buf
                   If(eof/=0) Exit readloop                
                   Call replace_tabs_by_blanks(buf)
                   Read(buf,fmt=*,iostat=eof) kgrid% directions(:,i)
                   If(eof/=0) Goto 6666
                Enddo
             Else
                Read(buf,fmt=*,iostat=eof) kgrid% directions(:,1)
                If(eof/=0) Goto 6666
                Do i=2,3
                   Read(12,2,iostat=eof) buf
                   If(eof/=0) Exit readloop                
                   Call replace_tabs_by_blanks(buf)
                   Read(buf,fmt=*,iostat=eof) kgrid% directions(:,i)
                   If(eof/=0) Goto 6666
                Enddo
             Endif
          Endif
          !!
          If( word(1:18) == 'k_grid_subdivision') Then
             Read(buf,fmt=*,iostat=eof) kgrid% subdivisions(1:3)
             If(eof/=0) Goto 6666
          Endif
          !!
          If( word(1:27) == 'k_grid_incl_periodic_points') Then
             If(next_word(buf,word)) Then
                If( word(1:3) == 'off') Then
                   kgrid% InclPeriodicPoints=.False.
                Else If( word(1:2) == 'on') Then
                   kgrid% InclPeriodicPoints=.True.
                Else
                   Write(outfile,"(' want no argument [=yes] to &
                        &k_grid_incl_periodic or ''on'' [=yes] &
                        &or ''off'' [=no]')")
                   Call terminate(TERM_CRASH,' input trouble ')
                Endif
             Else
                kgrid% InclPeriodicPoints=.True.
             Endif
          Endif
          !!
          If( word(1:20) == 'WF_write_coeff_stats') Then
             If(next_word(buf,word)) Then
                If( word(1:3) == 'off') Then
                   wdef% write_WF_coeff_stats=.False.
                Else If( word(1:2) == 'on') Then
                   wdef% write_WF_coeff_stats=.True.
                Else
                   Write(outfile,"(' want no argument [=yes] to &
                        &WF_write_coeff_stats or ''on'' [=yes] &
                        &or ''off'' [=no]')")
                   Call terminate(TERM_CRASH,' input trouble ')
                Endif
             Else
                wdef% write_WF_coeff_stats=.True.
             Endif
          Endif
          If( word(1:17) == 'ham_write_t_stats') Then
             If(next_word(buf,word)) Then
                If( word(1:3) == 'off') Then
                   wdef% write_Ham_t_stats=.False.
                Else If( word(1:2) == 'on') Then
                   wdef% write_Ham_t_stats=.True.
                Else
                   Write(outfile,"(' want no argument [=yes] to &
                        &ham_write_t_stats or ''on'' [=yes] &
                        &or ''off'' [=no]')")
                   Call terminate(TERM_CRASH,' input trouble ')
                Endif
             Else
                wdef% write_Ham_t_stats=.True.
             Endif
          Endif
          If( word(1:6) == 'wandef') Then
             oldwan=iwan
             iwan=iwan+1   
             start=.True.
             icn=0
          Endif
          If( start .And. word(1:3) == 'off') Then
             iwan=oldwan
             start=.False.
          Endif
          startif: If( start) Then
             If(  word(1:7) == 'contrib') Then
                If(iwan==0) Stop'missing ''wandef'' somewhere'
                !Print *,'iwan=',iwan
                icn=icn+1
             Endif
             If( word(1:4) == 'site') Then
                If(next_word(buf,word)) Then
                   Read(word,*,iostat=eof) wdef% p_site(icn,iwan)
                   If(eof/=0) Goto 6666
                Endif
             Endif
             If( word(1:4) == 'name') Then
                Read(buf(1:),fmt=2,iostat=eof) text
                wdef% p_name(iwan)=Adjustl(text(1:17))
             Endif
             If( word(1:6) == 'difvec') Then
                Read(buf,fmt=*,iostat=eof) wdef% p_difvec(1:3,icn,iwan)
                If(eof/=0) Goto 6666
             Endif
             If( word(1:4) == 'emin') Then
                If(next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wdef% p_ewind(1,iwan,1)
                   If(eof/=0) goto 6666
                   If( (nspin==2) .And. next_word(buf,word)) Then
                      Read(word,fmt=*,iostat=eof) wdef% p_ewind(1,iwan,2)
                      If(eof/=0) Goto 6666
                   Else
                      wdef% p_ewind(1,iwan,2)=wdef% p_ewind(1,iwan,1)
                   Endif
                Else
                   Write(outfile,"(' expecting one or two energy parameters af&
                        &ter emin key-word')")
                   Call terminate(TERM_CRASH,' input trouble ')

                Endif
             Endif
             If( word(1:4) == 'emax') Then
                If(next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wdef% p_ewind(2,iwan,1)
                   If(eof/=0) goto 6666
                   If( (nspin==2) .And. next_word(buf,word)) Then
                      Read(word,fmt=*,iostat=eof) wdef% p_ewind(2,iwan,2)
                      If(eof/=0) Goto 6666
                   Else
                      wdef% p_ewind(2,iwan,2)=wdef% p_ewind(2,iwan,1)
                   Endif
                Else
                   Write(outfile,"(' expecting one or two energy parameters af&
                        &ter emax key-word')")
                   Call terminate(TERM_CRASH,' input trouble ')

                Endif
             Endif
             If( Trim(word) == 'de') Then
                If(next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wdef% p_ewind(3,iwan,1)
                   If(eof/=0) Goto 6666
                   wdef% p_ewind(4,iwan,1)=wdef% p_ewind(3,iwan,1)
                   If( (nspin==2) .And. next_word(buf,word)) Then
                      Read(word,fmt=*,iostat=eof) wdef% p_ewind(3,iwan,2)
                      If(eof/=0) Goto 6666
                      wdef% p_ewind(4,iwan,2)=wdef% p_ewind(3,iwan,2)
                   Else
                      wdef% p_ewind(3,iwan,2)=wdef% p_ewind(3,iwan,1)
                      wdef% p_ewind(4,iwan,2)=wdef% p_ewind(4,iwan,1)
                   Endif
                Else
                   Write(outfile,"(' expecting one or two energy parameters af&
                        &ter emax key-word')")
                   Call terminate(TERM_CRASH,' input trouble ')

                Endif
             Endif
             If( word(1:6) == 'lbands') Then
                If(next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wdef% p_lband(1,iwan)
                   If(eof/=0) goto 6666
                   If( next_word(buf,word)) Then
                      Read(word,fmt=*,iostat=eof) wdef% p_lband(2,iwan)
                      If(eof/=0) Goto 6666
                   Else
                      wdef% p_lband(2,iwan)=wdef% p_lband(1,iwan)
                   Endif
                Else
                   Write(outfile,"(' expecting one or two integer parameters af&
                        &ter lbands key-word')")
                   Call terminate(TERM_CRASH,' input trouble ')
                   
                Endif
             Endif
             If( word(1:6) == 'ubands') Then
                If(next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wdef% p_uband(1,iwan)
                   If(eof/=0) goto 6666
                   If( next_word(buf,word)) Then
                      Read(word,fmt=*,iostat=eof) wdef% p_uband(2,iwan)
                      If(eof/=0) Goto 6666
                   Else
                      wdef% p_uband(2,iwan)=wdef% p_uband(1,iwan)
                   Endif
                Else
                   Write(outfile,"(' expecting one or two integer parameters af&
                        &ter ubands key-word')")
                   Call terminate(TERM_CRASH,' input trouble ')
                   
                Endif
             Endif
             If( word(1:7) == 'delower') Then
                If(next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wdef% p_ewind(3,iwan,1)
                   If(eof/=0) goto 6666
                   If( (nspin==2) .And. next_word(buf,word)) Then
                      Read(word,fmt=*,iostat=eof) wdef% p_ewind(3,iwan,2)
                      If(eof/=0) Goto 6666
                   Else
                      wdef% p_ewind(3,iwan,2)=wdef% p_ewind(3,iwan,1)
                   Endif
                Else
                   Write(outfile,"(' expecting one or two energy parameters af&
                        &ter emax key-word')")
                   Call terminate(TERM_CRASH,' input trouble ')

                Endif
             Endif
             If( word(1:7) == 'deupper') Then
                If(next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wdef% p_ewind(4,iwan,1)
                   If(eof/=0) goto 6666
                   If( (nspin==2) .And. next_word(buf,word)) Then
                      Read(word,fmt=*,iostat=eof) wdef% p_ewind(4,iwan,2)
                      If(eof/=0) Goto 6666
                   Else
                      wdef% p_ewind(4,iwan,2)=wdef% p_ewind(4,iwan,1)
                   Endif
                Else
                   Write(outfile,"(' expecting one or two energy parameters af&
                        &ter emax key-word')")
                   Call terminate(TERM_CRASH,' input trouble ')

                Endif
             Endif
             If( word(1:5) == 'xaxis') Then
                Read(buf,fmt=*,iostat=eof) wdef% p_axes(1:3,1,icn,iwan)
                If(eof/=0) Goto 6666
             Endif
             If( word(1:5) == 'zaxis') Then
                Read(buf,fmt=*,iostat=eof) wdef% p_axes(1:3,2,icn,iwan)
                If(eof/=0) Goto 6666
             Endif
             If( word(1:3) == 'orb') Then
                
                Call readOrbitalDescription(buf,wdef% p_od(icn,iwan))
                
                If(.Not.rel)Then
                   If(wdef% p_od(icn,iwan)% Type/=ORB_NLM)Then
                      Write(outfile,"(' orb must be followed by a state descriptor &
                           &e.g. 3d-1')")
                      Call terminate(TERM_CRASH,' input trouble ')
                   Endif
                Else
                   If((wdef% p_od(icn,iwan)% Type/=ORB_NLJM).And.&
                        &(wdef% p_od(icn,iwan)% Type/=ORB_NLMS))Then
                      Write(outfile,"(' orb must be followed by a state descriptor &
                           &e.g. 3d3/2-1/2 or 3d+2 [ud]')")
                      Call terminate(TERM_CRASH,' input trouble ')
                   Endif
                Endif
             Endif
             If( word(1:3) == 'fac') Then
                re=0.0_t_real
                im=0.0_t_real
                If(next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) re
                   If(eof/=0) goto 6666
                Endif
                If(next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) im
                   If(eof/=0) goto 6666
                Endif
                wdef% p_fac(icn,iwan)=Cmplx(re,im,t_real)
             Endif
          Endif startif
       Endif
    Enddo readloop
    !!
    Close(12)
    !!
    !!
    !!
    wdef% slab_reduce=.False.
    wdef% AA=symmetry% lattice_vectors
    wdef% GG=symmetry% reciprocial_lattice_vectors/twopi
    If(Sum(wdef% slab_direction(:)**2)>1.0e-8_t_real)Then
       If(Sum((wdef% slab_direction(:)-(/0.0_t_real,0.0_t_real,1.0_t_real/))**2)&
            &<1.0e-8_t_real)Then
          wdef% slab_reduce=.True.
          !!todo: not general enough
          !!todo: Call reduce_slab_lattice(symmetry% lattice_vectors)
       Else
          !!todo
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="' slab_direction other than 001 not yet implemented!'")
       Endif
    Endif
    !!
    !!
    !Print *,'hier1'
    !!
    !!
    Do iwan=1,wdef% nwan
       !Write(outfile,"('iwan=',t20,i5)") iwan
       Do icn=1,wdef% p_ninwan(iwan)
          !Write(outfile,"('icn=',t20,i5)") icn
          isa=wdef% p_site(icn,iwan)
          If(isa > structure% nsite) Then
             Write(errbuf,966) Trim(wdef% p_name(iwan))
966          Format(''' wandef ''''',a,''''' refers to an invalid site number!''')
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
          Endif
          issa=structure% p_isrt(isa)

          !Write(outfile,"('isa,issa=',t20,i5,i5)") isa,issa
          Do ivr=1,basis% p_nRv(issa)
             !Write(outfile,"('ivr=',t20,i5,'/',i2,' nl=',i1,a)") ivr,basis% p_nRv(issa)&
             !     &,basis% p_nnRv(ivr,issa),lqnchar(basis% p_lRv(ivr,issa))
             
             If( (wdef% p_od(icn,iwan)% Type == ORB_NLM .Or.&
                  &wdef% p_od(icn,iwan)% Type == ORB_NLMS) .And.&
                  & basis% p_nnRv(ivr,issa)==wdef% p_od(icn,iwan)% nmain .And.&
                  & basis% p_lRv(ivr,issa)==wdef% p_od(icn,iwan)% l) Then 
                If(rel .And. basis% p_kapRv(ivr,issa)<0 .And. &
                     &basis% p_kapRv(ivr,issa)/=-1)Then
                   wdef% p_ivr(icn,iwan)=ivr-1
                Else
                   wdef% p_ivr(icn,iwan)=ivr
                Endif
             Else If( wdef% p_od(icn,iwan)% Type == ORB_NLJM .And.&
                  & basis% p_nnRv(ivr,issa)==wdef% p_od(icn,iwan)% nmain .And.&
                  & basis% p_kapRv(ivr,issa)==wdef% p_od(icn,iwan)% kap) Then 
                wdef% p_ivr(icn,iwan)=ivr
             Endif
          Enddo
          If(wdef% p_ivr(icn,iwan)==0)Then
             Stop 'error in orbital counting'
          Endif
       Enddo
    Enddo
    !!
    Do iwan=1,wdef% nwan
       d=Sum(Abs(wdef% p_fac(1:wdef% p_ninwan(iwan),iwan))**2)
       wdef% p_fac(:,iwan)=wdef% p_fac(:,iwan)/Sqrt(d)

       wdef% p_center(:,iwan)=structure% p_tau(:,wdef% p_site(1,iwan))&
            &-wdef% p_difvec(:,1,iwan)
    Enddo
    !!
    !Print *,'hier2'
    !!
    Write(outfile,"(t1,'WF_grid_basis',t21,1(a,1x),/)") &
         &Trim(GRID_BASIS_TYPES(wfgrid% basis))
    !!
    Do i=1,3
       If(i==1)Then
          Write(outfile,"(t1,'WF_grid_directions',t21)",advance='no') 
       Else
          Write(outfile,"(t21)",advance='no') 
       Endif
       Do j=1,3
          Write(outfile,"(a,1x)",advance='no') &
               &Trim(stringify_double100(wfgrid% directions(j,i)))

       Enddo
       Write(outfile,*)
    Enddo
    !!
    d=spat(wfgrid% directions(:,1),wfgrid% directions(:,2)&
         &,wfgrid% directions(:,3))
    !!
    If(Abs(d)<1.0e-8_t_real)Then
       Write(errbuf,993) fname
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    Endif
    !!
    Write(outfile,"(t1,'WF_grid_subdivisions',t21,3(i5,1x),/)") &
         &wfgrid% subdivisions(1:3)
    Write(outfile,"(t1,'WF_grid_origin',t21,3(a,1x),/)") &
         &(Trim(stringify_double100(wfgrid% origin(i))),i=1,3)
    !!
    Write(outfile,"(t1,'ham_cutoff',t21,1(f10.5,1x),/)") wdef% ham_rcut
    Write(outfile,"(t1,'WF_coeff_threshold',t21,1(f10.5,1x),/)") &
         &wdef%  WF_coeff_threshold
    Write(outfile,"(t1,'WF_ham_threshold',t21,1(f10.5,1x),/)") &
         &wdef%  WF_ham_threshold

    Write(outfile,"(t1,'slab_direction',t21,3(f10.5,1x),/)") &
         &wdef%  slab_direction

    onoff=off
    If(wdef% write_WF_coeff_stats)Then
       onoff=on
    Endif
    Write(outfile,"(t1,'WF_write_coeff_stats',t24,a3)") onoff
    onoff=off
    If(wdef% write_Ham_t_stats)Then
       onoff=on
    Endif
    Write(outfile,"(t1,'ham_write_t_stats',t24,a3,/)") onoff
    !!
    Write(outfile,"(t1,'k_grid_basis',t21,1(a,1x),/)") &
         &Trim(GRID_BASIS_TYPES(kgrid% basis))
    !!
    Do i=1,3
       If(i==1)Then
          Write(outfile,"(t1,'k_grid_directions',t21)",advance='no') 
       Else
          Write(outfile,"(t21)",advance='no') 
       Endif
       Do j=1,3
          Write(outfile,"(a,1x)",advance='no') &
               &Trim(stringify_double100(kgrid% directions(j,i)))

       Enddo
       Write(outfile,*)
    Enddo
    !!
    d=spat(kgrid% directions(:,1),kgrid% directions(:,2)&
         &,kgrid% directions(:,3))
    !!
    If(Abs(d)<1.0e-8_t_real)Then
993    Format("'Grid direction matrix is singular in file """,a,""" !'")
       Write(errbuf,993) fname
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    Endif
    !!
    Write(outfile,"(t1,'k_grid_subdivisions',t21,3(i5,1x),/)") &
         &kgrid% subdivisions(1:3)
    !!
    onoff=off
    If(kgrid% InclPeriodicPoints)Then
       onoff=on
    Endif

    Write(outfile,"(t1,'k_grid_incl_periodic_points',t31,a3,/)") onoff
    !!
    !!
    !!
    !!
    Do iwan=1,wdef% nwan
       Write(outfile,"(t1,'wandef     ',t18,i5)")iwan

       Write(outfile,"(t5,'name ',t18,a)")wdef% p_name(iwan)

       Write(outfile,"(t5,'emin ',t18,2(f15.8,2x))")&
            & (Real(wdef% p_ewind(1,iwan,ms),t_real),ms=1,nspin)
       Write(outfile,"(t5,'emax ',t18,2(f15.8,2x))")&
            & (Real(wdef% p_ewind(2,iwan,ms),t_real),ms=1,nspin)
       Write(outfile,"(t5,'delower ',t18,2(f15.8,2x))")&
            & (Real(wdef% p_ewind(3,iwan,ms),t_real),ms=1,nspin)
       Write(outfile,"(t5,'deupper ',t18,2(f15.8,2x))")&
            & (Real(wdef% p_ewind(4,iwan,ms),t_real),ms=1,nspin)
       Write(outfile,"(t5,'lband ',t18,2(i7,1x))")&
            & (wdef% p_lband(ms,iwan),ms=1,2*nspin)
       Write(outfile,"(t5,'uband ',t18,2(i7,1x))")&
            & (wdef% p_uband(ms,iwan),ms=1,2*nspin)
       !!
       !If(Any(Abs(wdef% p_difvec(1:3,1,iwan))>1.0e-6_t_real))Then
       !   wdef% p_difvec(1:3,1,iwan)=0.0_t_real
       !   Call errmsg(nmodule,nsubfunc,E_warning&
       !        &,msg="' difvec of first contrib forced to zero?!'")
       !Endif
       !!
       !!
       Write(outfile,"(t10,'center ',t18,3(f15.8,2x))")&
               &wdef% p_center(1:3,iwan)
       !!
       Do icn=1,wdef% p_ninwan(iwan)
          !!
          !!
          !!
          Write(outfile,"(t5,'contrib     ',t18,i5)")icn
          Write(outfile,"(t10,'site   ',t18,i5)")wdef% p_site(icn,iwan)
          Write(outfile,"(t10,'difvec ',t18,3(f15.8,2x))")&
               &wdef% p_difvec(1:3,icn,iwan)
          Write(outfile,"(t10,'xaxis  ',t18,3(f15.8,2x))")&
               &wdef% p_axes(1:3,1,icn,iwan)
          Write(outfile,"(t10,'zaxis  ',t18,3(f15.8,2x))")&
               &wdef% p_axes(1:3,2,icn,iwan)
          Write(outfile,"(t10,'orbital',t18,a)")&
               &Trim(orbDescToString(wdef% p_od(icn,iwan),wdef% p_od(icn,iwan)% Type))
          Write(outfile,"(t10,'ivr    ',t18,i5)")wdef% p_ivr(icn,iwan)
          Write(outfile,"(t10,'factor ',t18,1(f15.8,2x),' +i ',1(f15.8,2x))")&
               &Real(wdef% p_fac(icn,iwan),t_real)&
               &,Aimag(wdef% p_fac(icn,iwan))
          Write(outfile,"(/)")
       Enddo
       Write(outfile,"(/)")
    Enddo
    !!
    !!
    !Stop
    !!
    !!
    Return
    !!
6666 Continue
    !!
6993 Format("'input error: """,a,a,""" !'")
    Write(errbuf,6993) Trim(word),Trim(buf)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
2   Format(a)
12  Format('WF ',i5)
!5   Format(a2)
!11  Format(i1,a1)
    !!
100 Format('Number of Wannier definitions:',i5)
1   Format(/,72('-'),/,t20,'Wannier definitions',/)
    !!
  End Subroutine read_wandefs_from_file
  !!***********************************************************************
  !! lets try to find the space-group symmetry of the wandefs, without respect
  !! to its meningful setup
  Subroutine det_wandef_symmetry(symmetry,structure,basis,wdef,relativistic)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Type(T_WanDefs),Intent(inout):: wdef
    Integer(t_int),Intent(in)    :: relativistic
    !!LOCAL
    Character(*),Parameter::nsubfunc="det_wandef_symmetry"
    Logical(t_log) :: ret,wrong,somewrong,indef,prot,prepprot,rel,sing
    Integer(t_int) :: jops,iwan,jwan,nwan,icn,jcn,iN,Neq,k,l,kwan,kcn,maxdeg,relfac
    Integer(t_int) :: m,isk,isgi,isj,wulmx,deg,jjj,j,m0,ldeg,mi,ms,kap
    Real(t_real)   :: gdifvec(3),gxaxis(3),gzaxis(3),dII(3)
    Real(t_real)   :: cbi(3),cbgi(3),cbk(3),cbj(3),suminf
    Complex(t_real):: cf,cd,sumlog,cw,cw1
    Integer(t_int),Pointer :: p_isi(:)
    Integer(t_int),Pointer :: p_eqMO(:)
    Integer(t_int),Pointer :: p_gcnd(:,:,:)
    Integer(t_int),Pointer :: p_gcndT(:,:,:)
    Integer(t_int),Pointer :: p_gcontr(:,:)
    Integer(t_int),Pointer :: p_gcontrM(:,:)
    Real(t_real),Pointer   :: p_dfvi(:,:)
    Complex(t_real),Pointer :: p_cv(:)
    Complex(t_real),Pointer :: p_cM(:,:)
    Type(T_WeightRot) :: wr
    Nullify(p_cv)
    Nullify(p_cM)
    Nullify(p_eqMO)
    Nullify(p_gcnd)
    Nullify(p_gcndT)
    Nullify(p_gcontr)
    Nullify(p_gcontrM)
    Nullify(p_isi)
    Nullify(p_dfvi)
    Call init_WeightRot(wr)
    !!
    prot=debugfun(nmodule,nsubfunc,'prot')
    prepprot=debugfun(nmodule,nsubfunc,'prepaxisrot')
    !!
    relfac=1
    rel=(relativistic == FULL_RELATIVISTIC)
    if(rel)relfac=2
    !!
    nwan=wdef% nwan
    !!
    Write(outfile,3)
    !!
    !! first classify the MOs
    !!
    Call palloc('p_gcnd',p_gcnd,1_t_int,wdef% ninwanmax&
         &,1_t_int,wdef% ninwanmax,1_t_int,wdef% nwan,nmodule,nsubfunc)
    Call palloc('p_gcndT',p_gcndT,1_t_int,wdef% ninwanmax&
         &,1_t_int,wdef% ninwanmax,1_t_int,wdef% nwan,nmodule,nsubfunc)
    Call palloc('p_gcontr',p_gcontr,1_t_int,wdef% ninwanmax&
         &,1_t_int,wdef% ninwanmax,nmodule,nsubfunc)
    Call palloc('p_gcontrM',p_gcontrM,1_t_int,wdef% ninwanmax&
         &,1_t_int,wdef% ninwanmax,nmodule,nsubfunc)
    Call palloc('p_isi',p_isi,1_t_int,wdef% ninwanmax,nmodule,nsubfunc)
    Call palloc('p_dfvi',p_dfvi,1_t_int,3_t_int,1_t_int,wdef% ninwanmax&
         &,nmodule,nsubfunc)
    Call palloc('p_eqMO',p_eqMO,1_t_int,nwan,nmodule,nsubfunc)
    !!
    !!
    Call palloc('wdef% p_DMO',wdef% p_DMO,1_t_int,nwan,1_t_int,nwan&
         &,1_t_int,symmetry% Rnumops,nmodule,nsubfunc)
    Call palloc('wdef% p_equivMOrep',wdef% p_equivMOrep&
         &,1_t_int,symmetry% Rnumops,1_t_int,nwan,nmodule,nsubfunc)
    !!
    !!
    wulmx=1
    Do iwan=1,nwan
       Do icn=1,wdef% p_ninwan(iwan)
          wulmx=Max(wulmx,wdef% p_od(icn,iwan)% l)
       Enddo
    Enddo
    !!
    !!
    !! START: prepare local matrices
    !!
    maxdeg=2*wulmx+1
    If(rel) maxdeg=maxdeg*2
    !!
    !!
    Call palloc('wdef% p_Dloc',wdef% p_Dloc,1_t_int,maxdeg,1_t_int,wdef% ninwanmax&
         &,1_t_int,nwan,nmodule,nsubfunc)
    !!
    wdef% p_Dloc=c0
    !!
    Do iwan=1,nwan
       Do icn=1,wdef% p_ninwan(iwan)
          !!
          l=wdef% p_od(icn,iwan)% l
          !!
          Call setup_WeightRot(wr,wulmx,rel,.True.&
               &,wdef% p_axes(:,1,icn,iwan),wdef% p_axes(:,2,icn,iwan)&
               &,basis% lmx,basis% p_relTOpseudo,prot)
          !!
          ldeg=2*l+1
          !!
          If(.Not.rel)Then
             mi=wdef% p_od(icn,iwan)%m+l+1
             Do m=1,ldeg
                wdef% p_Dloc(m,icn,iwan)=wr% p_wu(m+ldeg*(mi-1),l)*wdef% p_fac(icn,iwan)
             Enddo
          Else
             If(wdef% p_od(icn,iwan)% Type == ORB_NLJM) Then
                jjj=wdef% p_od(icn,iwan)% j
                deg=jjj+1
                mi=(wdef% p_od(icn,iwan)%m+jjj)/2+1
                m0=0
                If(deg==ldeg+1.And.l/=0)m0=ldeg-1
                Do m=1,deg
                   wdef% p_Dloc(m0+m,icn,iwan)=wr% p_cdjmm(m+deg*(mi-1),deg/2)&
                        &*wdef% p_fac(icn,iwan)
                Enddo
             Else If(wdef% p_od(icn,iwan)% Type == ORB_NLMS) Then
                !! 
                mi=wdef% p_od(icn,iwan)%m+l+1
                ms=wdef% p_od(icn,iwan)% ms

                !Print *,'mi=',mi
                !Print *,'ms=',ms

                If(l/=0)Then
                   kap=l
                   deg=2*Abs(kap)
                   
                   !Print *,'kap=',kap
                   !Print *,'deg=',deg
                   !Print *,wr% p_relToNrel(mi,1:deg,ms,kap)
                   
                   m0=0
                   Do m=1,deg
                      wdef% p_Dloc(m0+m,icn,iwan)=&
                           &Conjg(wr% p_relToNrel(mi,m,ms,kap))*wdef% p_fac(icn,iwan)
                   Enddo
                Endif
                kap=-l-1
                m0=2*l
                deg=2*Abs(kap)
                
                !Print *,'kap=',kap
                !Print *,'deg=',deg
                !Print *,wr% p_relToNrel(mi,1:deg,ms,kap)
                
                Do m=1,deg
                   wdef% p_Dloc(m0+m,icn,iwan)=&
                        &Conjg(wr% p_relToNrel(mi,m,ms,kap))*wdef% p_fac(icn,iwan)
                Enddo
             Endif
          Endif
          !!
       Enddo
    Enddo
    !!
    !! END: prepare local matrices
    !!
    somewrong=.False.
    !!
    opsloop: Do jops=1,symmetry% Rnumops
       !!
       If(prot) Write(outfile,85) Trim(symmetry% Ropsymbol(jops))&
            &,Trim(strtimrev(symmetry% Roptimerev(jops)))
       !!
       iwanloop1: Do iwan=1,nwan
          iN=wdef% p_ninwan(iwan)
          Neq=0
          p_eqMO=0
          !!
          Do icn=1,iN
             p_isi(icn)=&
                  &structure% p_equivsites(jops,wdef% p_site(icn,iwan))
             p_dfvi(:,icn)=Matmul(wdef% p_difvec(:,icn,iwan)&
                  &            ,symmetry% Ropmat(:,:,jops))
          Enddo
          !!
          cbi=wdef% p_center(:,iwan)

          cbgi=Matmul(wdef% p_center(:,iwan),symmetry% Ropmat(:,:,jops))&
               &+symmetry% Roptau(:,jops)

          If(prot)Then
             Write(outfile,"('center_I  =',3f30.15)")cbi
             Write(outfile,"('g*center_I=',3f30.15)")cbgi
          Endif

          !!
          Call geometryContraction(p_isi,wdef% p_site(:,iwan)&
               &,p_dfvi,cbi,wdef% p_difvec(:,:,iwan),cbi,iwan,iwan,wdef,p_gcontr)
          !!
          jwanloop1: Do jwan=1,nwan

             cbj=wdef% p_center(:,jwan)
             If(prot) Write(outfile,"('center_J  =',3f30.15)")cbj
             !!
             !! see if component sites are symmetry related 
             !! if yes make permutation
             !!
             !!
             If(iN /= wdef% p_ninwan(jwan)) Then
                wdef% p_DMO(jwan,iwan,jops)=c0
                Cycle
             Endif
             !!
             !!
             dII=Matmul(cbgi-cbj,symmetry% reciprocial_lattice_vectors(:,:))&
                  &/twopi
             ret=(Any(Nint(dII,t_int)-dII<1.0e-6_t_real))
             !!
             !!
             If(ret)Then
                If(prot)Then
                   Write(outfile,"('WF(',i4,') and WF(',i5,') could &
                        &be related')")iwan,jwan
                Endif
                ret=geometryCondition(p_isi,p_dfvi,cbgi&
                     &,wdef% p_difvec(:,:,jwan),cbj,iwan,jwan&
                     &,p_gcnd(:,:,jwan),wdef,.False.)
             Endif
             !!
             If(.Not.ret)Then
                wdef% p_DMO(jwan,iwan,jops)=c0
                !!
                If(prot)Then
                   Write(outfile,73) &
                        &Trim(symmetry% Ropsymbol(jops))&
                        &,Trim(wdef% p_name(iwan))&
                        &,Trim(wdef% p_name(jwan))
                Endif
                !!
             Else
                Neq=Neq+1
                p_eqMO(Neq)=jwan
                
                !! now we know that A(iwan,icn)=B(jwan,perm(icn,jwan)
                If(prot)Then
                   Write(outfile,701)&
                        & Trim(symmetry% Ropsymbol(jops))&
                        &,Trim(wdef% p_name(iwan))&
                        &,Trim(wdef% p_name(jwan))
                   Do icn=1,iN
                      Do jcn=1,iN
                         Write(outfile,72,advance='no') p_gcnd(icn,jcn,jwan)
                      Enddo
                      Write(outfile,2)
                   Enddo
                   Write(outfile,2)
                Endif
                !!
             Endif
             !!
             !!
          Enddo jwanloop1
          !!
          If(prot)Then
             Write(outfile,2)
             Write(outfile,74,advance='no')&
                  &Trim(symmetry% Ropsymbol(jops))&
                  &,Trim(wdef% p_name(iwan))
             Do k=1,Neq
                Write(outfile,75,advance='no') Trim(wdef% p_name(p_eqMO(k)))
             Enddo
             If(Neq==0)Then
                Write(outfile,75,advance='no') "None"
             Endif
             Write(outfile,2)
             Write(outfile,2)
          Endif
          !!
          wdef% p_equivMOrep(jops,iwan)=p_eqMO(1)
          !!
          !! Neq can be larger than 1, if multi-dimensional rep
          If(Neq==0)Then
             wrong=.True.
             somewrong=.True.
             Goto 1000
          Endif
          !!
          Call palloc('p_cv',p_cv,1_t_int,Neq,nmodule,nsubfunc)
          Call palloc('p_cM',p_cM,1_t_int,Neq,1_t_int,Neq,nmodule,nsubfunc)
          !!
          If(prot) Write(outfile,76)
          !!
          kloop1: Do k=1,Neq
             !!
             kwan=p_eqMO(k)
             !!
             If(prot) Write(outfile,78)&
                  & Trim(wdef% p_name(kwan))&
                  &,Trim(symmetry% Ropsymbol(jops))&
                  &,Trim(wdef% p_name(iwan))
             !!
             !!
             !! form vT_k*v_i
             !!
             cd=c0
             !!
             Do kcn=1,iN
                Do icn=1,iN
                   !!
                   If(p_gcnd(icn,kcn,kwan)==0)Cycle
                   !!
                   !!
                   l=wdef% p_od(icn,iwan)%l 
                   ldeg=relfac*(2*l+1)
                   !!
                   cf=c0
                   Do m=1,ldeg
                      cw1=Dot_product(wdef% p_Dloc(1:ldeg,kcn,kwan)&
                           &,symmetry% p_Rwu_tjnl_ks(1:ldeg,m,l,jops))
                      If(symmetry% Roptimerev(jops)==1)Then
                         cf=cf+cw1*Conjg(wdef% p_Dloc(m,icn,iwan))
                      Else
                         cf=cf+cw1*wdef% p_Dloc(m,icn,iwan)
                      Endif
                   Enddo
                   !!
                   !!
                   If(prot) Then
                      isk=wdef% p_site(kcn,kwan)
                      isgi=structure% p_equivsites(jops,wdef% p_site(icn,iwan))
                      gdifvec=Matmul(wdef% p_difvec(:,icn,iwan)&
                           &            ,symmetry% Ropmat(:,:,jops))
                      
                      gxaxis=Matmul(wdef% p_axes(:,1,icn,iwan)&
                           &            ,symmetry% Ropmat(:,:,jops))
                      gzaxis=Matmul(wdef% p_axes(:,2,icn,iwan)&
                           &            ,symmetry% Ropmat(:,:,jops))
                   
                      Write(outfile,79) &
                           & wdef% p_fac(kcn,kwan)&
                           &,structure% p_elements(structure% p_isrt(isk)),isk&
                           &,orbDescToString(wdef% p_od(kcn,kwan)&
                           &    ,wdef% p_od(kcn,kwan)% Type)&
                           &,wdef% p_difvec(:,kcn,kwan)&
                           &,wdef% p_axes(:,1,kcn,kwan)&
                           &,wdef% p_axes(:,2,kcn,kwan)&
                           &,wdef% p_fac(icn,iwan)&
                           &,structure% p_elements(structure% p_isrt(isgi)),isgi&
                           &,orbDescToString(wdef% p_od(icn,iwan)&
                           &      ,wdef% p_od(icn,iwan)% Type)&
                           &,gdifvec,gxaxis,gzaxis&
                           &,cf
                   Endif
                   !!
                   cd=cd+cf
                   !!
                Enddo
             Enddo
             !!
             p_cv(k)=cd
             !!
          Enddo kloop1
          !!
          If(prot)Then
             Write(outfile,2)
             Call printmat('Re p_cv',"(f12.5,1x)","('      0      ')"&
                  &,Real(p_cv,t_real),Neq,1.0e-5_t_real)
             Call printmat('Im p_cv',"(f12.5,1x)","('      0      ')"&
                  &,Aimag(p_cv),Neq,1.0e-5_t_real)
             Write(outfile,2)
             !!
             Write(outfile,77)
          Endif
          !!
          kloop2: Do k=1,Neq
             !!
             kwan=p_eqMO(k)
             !!
             cbk=wdef% p_center(:,kwan)

             !!
             !! form vT_k*v_j
             jloop2:  Do j=1,Neq
                jwan=p_eqMO(j)
                cbj=wdef% p_center(:,jwan)

                Call geometryContraction(wdef% p_site(:,kwan)&
                     &,wdef% p_site(:,jwan)&
                     &,wdef% p_difvec(:,:,kwan),cbk&
                     &,wdef% p_difvec(:,:,jwan),cbj&
                     &,kwan,jwan,wdef,p_gcontrM)
                !!
                If(prot) Write(outfile,81) Trim(wdef% p_name(kwan))&
                     &,Trim(wdef% p_name(jwan))
                
                !!
                cd=c0
                kcnloop3: Do kcn=1,iN
                   jcnloop3: Do jcn=1,iN

                
                      If(p_gcontrM(kcn,jcn)==0)Cycle
                      !!
                      !!
                      l=wdef% p_od(kcn,kwan)%l 
                      ldeg=relfac*(2*l+1)
                      !!
                      cf=Dot_product(wdef% p_Dloc(1:ldeg,kcn,kwan)&
                           &,wdef% p_Dloc(1:ldeg,jcn,jwan))
                      !!
                      If(prot) Then
                         isk=wdef% p_site(kcn,kwan)
                         isj=wdef% p_site(jcn,jwan)
                         Write(outfile,79) &
                              & wdef% p_fac(kcn,kwan)&
                              &,structure% p_elements(structure% p_isrt(isk)),isk&
                              &,orbDescToString(wdef% p_od(kcn,kwan)&
                              &    ,wdef% p_od(kcn,kwan)%type)&
                              &,wdef% p_difvec(:,kcn,kwan)&
                              &,wdef% p_axes(:,1,kcn,kwan)&
                              &,wdef% p_axes(:,2,kcn,kwan)&
                              &,wdef% p_fac(jcn,jwan)&
                              &,structure% p_elements(structure% p_isrt(isj)),isj&
                              &,orbDescToString(wdef% p_od(jcn,jwan)&
                              &    ,wdef% p_od(jcn,jwan)% Type)&
                              &,wdef% p_difvec(:,jcn,jwan)&
                              &,wdef% p_axes(:,1,jcn,jwan)&
                              &,wdef% p_axes(:,2,jcn,jwan)&
                              &,cf
                      Endif
                      
                      
                      
                      
                      
                      cd=cd+cf
                   End Do jcnloop3
                End Do kcnloop3
                !!
                p_cM(k,j)=cd
                !!
             Enddo jloop2
             !!
          Enddo kloop2
          !!
          If(prot)Then
             Write(outfile,2)
             Call printmat('Re p_M',"(f12.5,1x)","('      0      ')"&
                  &,Real(p_cM,t_real),Neq,Neq,1.0e-5_t_real)
             Call printmat('Im p_M',"(f12.5,1x)","('      0      ')"&
                  &,Aimag(p_cM),Neq,Neq,1.0e-5_t_real)
          Endif
          !!
          Call cinv(p_cM,Neq,Neq,sumlog,sing,.False.,indef,suminf)
          If(indef) Then
             Write(errbuf,80)
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
          Endif
          !!
          p_cv=Matmul(p_cM,p_cv)
          !!
          If(prot)Then
             Write(outfile,2)
             Call printmat('Re p_DMO',"(f12.5,1x)","('      0      ')"&
                  &,Real(p_cv,t_real),Neq,1.0e-5_t_real)
             Call printmat('Im p_DMO',"(f12.5,1x)","('      0      ')"&
                  &,Aimag(p_cv),Neq,1.0e-5_t_real)
             Write(outfile,2)
          Endif
          !!
          Do j=1,Neq
             !!
             jwan=p_eqMO(j)
             wdef% p_DMO(jwan,iwan,jops)=p_cv(j)
          Enddo
          !!
          wrong=.False.
          icnloop4: Do icn=1,iN
             !!
             !!
             l=wdef% p_od(icn,iwan)% l
             ldeg=relfac*(2*l+1)
             !!
             !!
             mloop: Do m=1,ldeg

                !!
                cd=c0
                Do kcn=1,iN
                   !!
                   If(symmetry% Roptimerev(jops)==1)Then
                      cw=Conjg(Dot_product(symmetry% p_Rwu_tjnl_ks(m,1:ldeg,l,jops)&
                           &,wdef% p_Dloc(1:ldeg,kcn,iwan)))
                   Else
                      cw=Sum(symmetry% p_Rwu_tjnl_ks(m,1:ldeg,l,jops)&
                           &*wdef% p_Dloc(1:ldeg,kcn,iwan))
                   Endif
                   !!
                   If(prot)Then
                      Write(outfile,"('kcn(',i5,') gcontr=',i3,' w=',f8.5,' +i ',f8.5&
                           &,' fac=',f8.5,'+i ',f8.5,' term=',f8.5,' +i '&
                           &,f8.5)")&
                           &kcn,p_gcontr(icn,kcn),cw,wdef% p_fac(kcn,iwan)&
                           &,p_gcontr(icn,kcn)*cw
                   Endif
                   cd=cd+p_gcontr(kcn,icn)*cw
                Enddo
                !!
                If(prot) Write(outfile,"('vi    (',i5,',',i5,')=',f30.15,','&
                     &,f30.15)")icn,m,cd
                Do j=1,Neq
                   jwan=p_eqMO(j)
                   cbj=wdef% p_center(:,jwan)

                   ret=geometryCondition(wdef% p_site(:,iwan)&
                        &,wdef% p_difvec(:,:,iwan),cbi&
                        &,wdef% p_difvec(:,:,jwan),cbj,iwan,jwan&
                        &,p_gcndT(:,:,jwan)&
                        &,wdef,.False.)

                   cf=c0
                   Do jcn=1,iN
                      !!
                      !!
                      cw=wdef% p_Dloc(m,jcn,jwan)
                      !!
                      If(prot)Then
                      Write(outfile,"('jcn(',i5,') gcnd=',i3,' cw=',f8.5,' +i ',f8.5&
                              &,' fac=',f8.5,' +i ',f8.5,' term=',f8.5,' +i ',f8.5)")&
                              &jcn,p_gcndT(icn,jcn,jwan),cw,wdef% p_fac(jcn,jwan)&
                              &,p_gcndT(icn,jcn,jwan)*cw
                      Endif
                      
                      cf=cf+p_gcndT(icn,jcn,jwan)*cw
                   Enddo
                   If(prot)Then
                      Write(outfile,"('f=',f30.15,'+i ',f30.15&
                           &,'DMO=',f30.15,' +i ',f30.15&
                           &,'term=',f30.15,' +i ',f30.15)")&
                           &cf,wdef% p_DMO(jwan,iwan,jops)&
                           &,cf*wdef% p_DMO(jwan,iwan,jops)
                   Endif
                   cd=cd-cf*wdef% p_DMO(jwan,iwan,jops)
                   
                Enddo ! j
                !!
                If(prot) Write(outfile,"('vicomp(',i5,',',i5,')='&
                     &,f30.15,',',f30.15,/)") icn,m,cd
                !!
                If(Abs(cd)>1.0e-6_t_real)Then
                   wrong=.True.
                   somewrong=.True.
                   wdef% p_DMO(:,iwan,jops)=c0
                Endif
             Enddo mloop
          Enddo icnloop4
          !!
1000      Continue
          If(wrong)Then
             Write(errbuf,82) Trim(wdef% p_name(iwan))&
                  &,Trim(symmetry% Ropsymbol(jops))
             Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
          Endif
          !!
       Enddo iwanloop1
       !!
       If(prot)Then
          Call printmat('Re p_DMO',"(f12.5,1x)","('      0      ')"&
               &,Real(wdef% p_DMO(:,:,jops),t_real),nwan,nwan,1.0e-5_t_real)
          Call printmat('Im p_DMO',"(f12.5,1x)","('      0      ')"&
               &,Aimag(wdef% p_DMO(:,:,jops)),nwan,nwan,1.0e-5_t_real)
       Endif
       !!
    Enddo opsloop
    !!
    Write(outfile,52)
    !!
    Do jops=1,symmetry% Rnumops
       Write(outfile,84) Trim(symmetry% Ropsymbol(jops))
       Call printmat(Char(9),"(f12.5,1x)","('      0      ')"&
            &,Real(wdef% p_DMO(:,:,jops),t_real),nwan,nwan,1.0e-5_t_real)
       Call printmat(Char(9),"(f12.5,1x)","('      0      ')"&
            &,Aimag(wdef% p_DMO(:,:,jops)),nwan,nwan,1.0e-5_t_real)
       Write(outfile,2)
    Enddo
    !!
    !!
    Call palloc('wdef% p_Neq',wdef% p_Neq,1_t_int,nwan,1_t_int,symmetry% Rnumops&
         &,nmodule,nsubfunc)
    Call palloc('wdef% p_eqMO',wdef% p_eqMO,1_t_int,nwan,1_t_int,nwan&
         &,1_t_int,symmetry% Rnumops,nmodule,nsubfunc)
    !!
    !!
    Do jops=1,symmetry% Rnumops
       Do iwan=1,nwan
          wdef% p_Neq(iwan,jops)=0
          Do jwan=1,nwan
             If(Abs(wdef% p_DMO(jwan,iwan,jops))>1.0e-6_t_real)Then
                wdef% p_Neq(iwan,jops)=wdef% p_Neq(iwan,jops)+1
                wdef% p_eqMo(wdef% p_Neq(iwan,jops),iwan,jops)=jwan
             Endif
          Enddo
       Enddo
    Enddo
    !!
!!$    Do jops=1,symmetry% Rnumops
!!$       Write(outfile,50,advance='no')Trim(symmetry% Ropsymbol(jops))
!!$       Do iwan=1,nwan
!!$          Write(outfile,"(i5)",advance='no')wdef% p_Neq(iwan,jops)
!!$       Enddo
!!$       Write(outfile,"()")
!!$    Enddo
    !!
    !!
    Do jops=1,symmetry% Rnumops
       Write(outfile,50,advance='no')Trim(symmetry% Ropsymbol(jops))
    Enddo
    Write(outfile,2)
    !!
    Write(outfile,53,advance='no')
    Do jops=1,symmetry% Rnumops
       Write(outfile,51,advance='no') trace(wdef% p_DMO(:,:,jops))
    Enddo
    Write(outfile,2)
    !!
    If(somewrong)Then
       Write(outfile,2)
       Write(errbuf,83)
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    Endif
    
    !!
    !!
    Write(outfile,33)
    !!
    Call pfree(p_eqMO)
    Call pfree(p_gcndT)
    Call pfree(p_gcontr)
    Call pfree(p_gcontrM)
    Call pfree(p_isi)
    Call pfree(p_dfvi)
    Call pfree(p_cv)
!!$    Call pfree(p_tmp)
    Call pfree(p_cM)
    Call clean_WeightRot(wr)
    !!
    !!
    Return
    !!
2   Format()
3   Format(72('-'),/&
         &,t15,'Determining the symmetries of the Molecular ',/&
         &,t12,'orbitals (MO) defining the Wannier functions (WF)',/)
33  Format(/,72('-'),/)
50  Format(a24,1x)
51  Format(f10.3,' +i ',f10.3,1x)
53  Format(1(' '))
52  Format('Rep mat of MO:')
701 Format(a,'* [',a,'] compared with ',a,' has connector matrix')
72  Format(i2,1x)
73  Format(a,'* [',a,'] compared with ',a,' gives  D=0 ')
74  Format(a,' maps [',a,'] onto MOs ')
75  Format(' [',a,'] ')
76  Format(/,' doing  v ',/)
77  Format(/,' doing  M ',/)
78  Format(' [',a,'] x ',a,'*[',a,'] :')  
79  Format(t10,'term   (',f12.5,',',f12.5,') * ',a2,'(',i3,') ',a&
         &,' T=(',3(f12.5),')',/&
         &,t41,'xaxis=(',3(f12.5),') ',/&
         &,t41,'zaxis=(',3(f12.5),')',/&
         &,t10,'     x (',f12.5,',',f12.5,') * ',a2,'(',i3,') ',a&
         &,' T=(',3(f12.5),') ',/&
         &,t41,'xaxis=(',3(f12.5),') ',/&
         &,t41,'zaxis=(',3(f12.5),')',/&
         &,t10,'     = (',f30.15,',',f30.15,')')
80  Format("' Cannot determine symmetry of MO, possible reasons:',/&
         &,' 1) did you define translational equivalent orbitals?'")
81  Format(' [',a,'] x [',a,'] :')  
82  Format("'MO [",a,"] seems not to behave as a single orbital ',/&
         &,' under operation ",a," or equivalent MO is missing',/&
         &,' 1) check symmetry of legands',/&
         &,' 2) check if symmetry related MOs are defined ',/&
         &,' 3) you used wrong site numbers',/")
83  Format("'Some MO seems not to behave as a single orbital ',/&
         &,' under some operations or equivalent MO is missing',/&
         &,' 1) check symmetry of legands',/&
         &,' 2) check if symmetry related MOs are defined',/&
         &,' 3) you used wrong site numbers',/")
84  Format('operation ',a)
85  Format('Probing operation ',a,a,30('-'),/)
    !!
    !!
  End Subroutine det_wandef_symmetry
  !!***********************************************************************
  Subroutine geometryContraction(igs,jgs,dfvi,ci,dfvj,cj,iwan,jwan,wdef,gcontr)
    !!
    Implicit None
    !!IO
    Type(T_WanDefs),Intent(in)   :: wdef
    Integer(t_int),Intent(in)    :: iwan,jwan
    Integer(t_int),Intent(in)    :: igs(:),jgs(:)
    Real(t_real),Intent(in)      :: dfvi(:,:),dfvj(:,:),ci(3),cj(3)
    Integer(t_int),Intent(out)   :: gcontr(:,:)
    !!LOCAL
    Integer(t_int) :: icn,jcn,iN,ncn
    Real(t_real)   :: dd(3)
    Real(t_real),Parameter :: tol=1.0e-4_t_real
    !!
    gcontr=0
    iN=wdef% p_ninwan(iwan)
    If(iN/=wdef% p_ninwan(jwan))return
    Do icn=1,iN
       ncn=0
       Do jcn=1,iN
          dd=dfvi(:,icn)-ci-dfvj(:,jcn)+cj
          If(igs(icn) == jgs(jcn) .And.&
               & (wdef% p_od(icn,iwan)% nmain ==wdef% p_od(jcn,jwan)% nmain) .And.&
               & (wdef% p_od(icn,iwan)% l ==wdef% p_od(jcn,jwan)% l) .And.&
               &( Sum(dd**2) < tol**2 ))Then
             !! the 2 contribs are at identical pos. and have same (nl)-type
             !!ncn=ncn+1
             !!gcontr(icn,ncn)=1
             gcontr(icn,jcn)=1
          Endif
       End Do
    End Do
    !!
    !!
    Return
    !!
  End Subroutine geometryContraction
  !!***********************************************************************
  Logical(t_log) Function geometryCondition(igs,dfvi,ci,dfvj,cj,iwan,jwan&
       &,gcnd,wdef,prot)
    !!
    Implicit None
    !!IO
    Logical(t_log),Intent(in)    :: prot
    Type(T_WanDefs),Intent(in)   :: wdef
    Integer(t_int),Intent(in)    :: iwan,jwan
    Integer(t_int),Intent(in)    :: igs(:)
    Real(t_real),Intent(in)      :: dfvi(:,:),ci(3),dfvj(:,:),cj(3)
    Integer(t_int),Intent(inout) :: gcnd(:,:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="geometryCondition"
    Integer(t_int) :: icn,jcn,iN
    Logical(t_log) :: nomap
    Real(t_real)   :: ra(3),rb(3),dr(3)
    Real(t_real),Parameter :: tol=1.0e-4_t_real
    Integer(t_int) :: unity(wdef% p_ninwan(iwan))
    !!
    !!
    gcnd(:,:)=0_t_int
    !!
    iN=wdef% p_ninwan(iwan)
    If(iN/=wdef% p_ninwan(jwan)) Then
       geometryCondition=.False.
       Return
    Endif
    !!
    !!
    If(prot)Then
       Write(outfile,"('center_I=',3f30.15)")ci
       Write(outfile,"('center_J=',3f30.15)")cj
       !!
       Do icn=1,iN
          Write(outfile,"('s_Ib=',3f30.15)")ci+dfvi(:,icn)
       Enddo
       
       Do icn=1,iN
          Write(outfile,"('s_Jb=',3f30.15)")cj+dfvj(:,icn)
       Enddo
    Endif
    !!
    !!
    !!
    Do icn=1,iN
       unity(icn)=1_t_int
       Do jcn=1,iN
          gcnd(icn,jcn)=0_t_int
          If(igs(icn) == wdef% p_site(jcn,jwan) .And. &
               & (wdef% p_od(icn,iwan)% nmain == wdef% p_od(jcn,jwan)% nmain) .And.&
               & (wdef% p_od(icn,iwan)% l == wdef% p_od(jcn,jwan)% l))Then
             !Print *,'here',icn,jcn
             ra=dfvi(:,icn)!-dfvi(:,1)
             
             !Print *,'ra',ra
             
             rb=dfvj(:,jcn)!-dfvj(:,1)
             !Print *,'rb',rb
             dr=rb-ra
             If( Sum(dr**2) < tol**2 )Then
                gcnd(icn,jcn)=1_t_int
             Endif
          Endif
       End Do
    End Do
    !!
    nomap=.False.
    Do icn=1,iN
       If(Sum(gcnd(icn,:))==0_t_int.Or.&
            &Sum(gcnd(:,icn))==0_t_int)Then
          nomap=.True.
          Exit
       Endif
    End Do
    !!
    geometryCondition=.Not.nomap
    !!
    If(prot)Then
       Print *,'GX=',Matmul(gcnd(:,:),unity)
       Print *,'XG=',Matmul(unity,gcnd(:,:))
       Print *,'XG nomap=',geometryCondition
       !!
       Do icn=1,iN
          Do jcn=1,iN
             Write(outfile,"(i2)",advance='no')gcnd(icn,jcn)
          End Do
          Write(outfile,"()")
       End Do
    Endif
    !!
    Return
    !!
  End Function geometryCondition
  !!***********************************************************************
  !!TODO: avoid having multiple entries for more than one WF per center
  Subroutine prep_swf_lattice(symmetry,structure,wdef,rcut,prot)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_WanDefs),Intent(inout):: wdef
    Logical(t_log),Intent(in)    :: prot
    Real(t_real),Intent(in)      :: rcut
    !!LOCAL
    Character(*),Parameter::nsubfunc="prep_swf_lattice"
    Integer(t_int) :: iwan,isb,j,NRp(3),NRm(3),nwan,i1,i2,i3,n,nsite,irs,ip
    Integer(t_int) :: iloop
    Real(t_real)   :: ca(3),a(3),g(3),rg,ag,rcut2,pabs2,p(3),pabs
    Integer(t_int),Pointer :: iwk(:)
    Real(t_real),Pointer :: apair(:)
    !!
    Nullify(iwk)
    Nullify(apair)
    !!
    nwan=wdef% nwan
    nsite=structure% nsite
    rcut2=rcut**2
    !!
    !! prepare the Wannier-center related pair vectors, we need this
    !! since, we want to have symmetric pair shells, and when the
    !! Wannier center is not at a site the shells are not symemtric
    !! and the resulting error-messages might be spurious
    !!
    !! for the Wannier coefficients
    !!
    wdef% nswfpairsmax=0
    Do iloop=1,2
       Do iwan=1,nwan
          !!
          ca=wdef% p_center(:,iwan) 
          !!
          Do isb=1,nsite
             !!
             a=structure% p_tau(:,isb)-ca
             !!
             Do j=1,3
                g=symmetry% reciprocial_lattice_vectors(:,j)/twopi
                rg=rcut*Sqrt(Dot_product(g,g))
                ag=Dot_product(a,g)
                NRm(j)=Floor  (Min(-ag-rg,-ag+rg))-1
                NRp(j)=Ceiling(Max(-ag-rg,-ag+rg))+1
             Enddo
             If(structure% str_type == STR_TYPE_MOLECULE)Then
                NRm(:)=0_t_int
                NRp(:)=0_t_int
             Endif
             
             
             n=0
             Do i1=NRm(1),NRp(1)
                Do i2=NRm(2),NRp(2)
                   Do i3=NRm(3),NRp(3)
                      
                      p=   a &
                           &+symmetry% lattice_vectors(:,1)*i1&
                           &+symmetry% lattice_vectors(:,2)*i2&
                           &+symmetry% lattice_vectors(:,3)*i3
                      !!
                      pabs2=Dot_product(p,p)
                      !!
                      If(pabs2 <= rcut2)Then
                         n=n+1
                         If(iloop==2)wdef% p_swfpairs(:,isb,iwan,n)=p
                      Endif
                      !!
                   End Do
                End Do
             End Do!!i1
             
             If(iloop==1)Then
                wdef% nswfpairsmax=Max(wdef% nswfpairsmax,n)
             Else
                wdef% p_nswfpairs(isb,iwan)=n
             Endif
             
             
          Enddo
       Enddo
       !!
       If(iloop==1)Then
          Call palloc('wdef% p_nswfpairs',wdef% p_nswfpairs,1_t_int,nsite&
               &,1_t_int,nwan,nmodule,nsubfunc)
          Call palloc('wdef% p_swfpairs',wdef% p_swfpairs,1_t_int,3_t_int&
               &,1_t_int,nsite,1_t_int,nwan,1_t_int,wdef% nswfpairsmax&
               &,nmodule,nsubfunc)
       Endif
    End Do
    !!
    !!
    !!
    !! sort stuff
    !!
    Call palloc('iwk',iwk,1_t_int,Max(1_t_int,wdef% nswfpairsmax),nmodule,nsubfunc)
    Call palloc('apair',apair,1_t_int,Max(1_t_int,wdef% nswfpairsmax),nmodule,nsubfunc)
    !!
    Do iwan=1,nwan
       Do isb=1,nsite
          n=wdef% p_nswfpairs(isb,iwan)
          Do ip=1,n
             apair(ip)=Sqrt(Sum(wdef% p_swfpairs(:,isb,iwan,ip)**2))
          Enddo
          Call dshel2(1_t_int,n,apair,iwk,1.e-12_t_real)
          !!
          wdef% p_swfpairs(:,isb,iwan,1:n)=&
               &wdef% p_swfpairs(:,isb,iwan,iwk(1:n)+1)
          !!
       Enddo
    Enddo
    !!
    If(prot)Then
       Write(outfile,99)
       Do iwan=1,nwan
          Do isb=1,nsite
             Write(outfile,100)
             Write(outfile,101) iwan,Trim(wdef% p_name(iwan))&
                  &,structure% p_elements(structure% p_isrt(isb)),isb&
                  &,wdef% p_nswfpairs(isb,iwan)
             Write(outfile,102)
             
             Do irs=1,wdef% p_nswfpairs(isb,iwan)
                p=wdef% p_swfpairs(:,isb,iwan,irs)
                pabs=Sqrt(Dot_product(p,p))
                Write(outfile,103)irs,p,pabs
             Enddo
             
          Enddo
       Enddo
    End If
    !!
    Call pfree(apair)
    Call pfree(iwk)
    !!
    Return
    !!
99  Format(/,' Pairs from WF to site ',/)
100 Format('WF             site_B          number of pairs')
101 Format(i3,1x,'[',a,']',1x,a2,1x,i3,6x,i4)
102 Format('              no        px            py&
         &            pz           |p|')
103 Format(t12,i4,1x,4(f12.6,2x))
  End Subroutine prep_swf_lattice
  !!***********************************************************************
  Subroutine prep_wf_lattice(symmetry,structure,wdef,prot)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_WanDefs),Intent(inout):: wdef
    Logical(t_log),Intent(in)    :: prot
    !!LOCAL
    Character(*),Parameter::nsubfunc="prep_wf_lattice"
    Integer(t_int) :: iwan,jwan,j,NRp(3),NRm(3),nwan,i1,i2,i3,n,irs,ip
    Integer(t_int) :: iloop
    Real(t_real)   :: ca(3),cb(3),a(3),g(3),rg,ag,rcut2,pabs2,p(3),pabs
    Integer(t_int),Pointer :: iwk(:)
    Real(t_real),Pointer :: apair(:)
    !!
    Nullify(iwk)
    Nullify(apair)
    !!
    nwan=wdef% nwan
    rcut2=wdef% ham_rcut**2
    !!
    !!
    !! prepare the Wannier-center related pair vectors, we need this
    !! since, we want to have symmetric pair shells, and when the
    !! Wannier center is not at a site the shells are not symemtric
    !! and the resulting error-messages might be spurious
    !!
    !! for the Wannier coefficients
    !!
    wdef% nwfpairsmax=0
    Do iloop=1,2
       Do iwan=1,nwan
          !!
          ca=wdef% p_center(:,iwan)
          !!
          Do jwan=1,nwan
             !!
             cb=wdef% p_center(:,jwan)
             !!
             a=cb-ca
             Do j=1,3
                g=symmetry% reciprocial_lattice_vectors(:,j)/twopi
                rg=wdef% ham_rcut*Sqrt(Dot_product(g,g))
                ag=Dot_product(a,g)
                NRm(j)=Floor  (Min(-ag-rg,-ag+rg))-1
                NRp(j)=Ceiling(Max(-ag-rg,-ag+rg))+1
             Enddo
             If(structure% str_type == STR_TYPE_MOLECULE)Then
                NRm(:)=0_t_int
                NRp(:)=0_t_int
             Endif
             
             
             n=0
             Do i1=NRm(1),NRp(1)
                Do i2=NRm(2),NRp(2)
                   Do i3=NRm(3),NRp(3)
                      
                      p=   a &
                           &+symmetry% lattice_vectors(:,1)*i1&
                           &+symmetry% lattice_vectors(:,2)*i2&
                           &+symmetry% lattice_vectors(:,3)*i3
                      !!
                      pabs2=Dot_product(p,p)
                      !!
                      If(pabs2 <= rcut2)Then
                         n=n+1
                         if(iloop==2) wdef% p_wfpairs(:,jwan,iwan,n)=p
                      Endif
                      !!
                   End Do
                End Do
             End Do!!i1

             If(iloop==1)Then
                wdef% nwfpairsmax=Max(wdef% nwfpairsmax,n)
             Else
                wdef% p_nwfpairs(jwan,iwan)=n
             Endif
          Enddo
       Enddo
       !!
       If(iloop==1)Then
          Call palloc('wdef% p_nwfpairs',wdef% p_nwfpairs,1_t_int,nwan&
               &,1_t_int,nwan,nmodule,nsubfunc)
          Call palloc('wdef% p_wfpairs',wdef% p_wfpairs,1_t_int,3_t_int&
               &,1_t_int,nwan,1_t_int,nwan,1_t_int,wdef% nwfpairsmax&
               &,nmodule,nsubfunc)
       Endif
    Enddo
    !!
    !!
    !!
    !! sort stuff
    !!
    Call palloc('iwk',iwk,1_t_int,Max(1_t_int,wdef% nwfpairsmax),nmodule,nsubfunc)
    Call palloc('apair',apair,1_t_int,Max(1_t_int,wdef% nwfpairsmax),nmodule,nsubfunc)
    !!
    Do iwan=1,nwan
       Do jwan=1,nwan
          n=wdef% p_nwfpairs(jwan,iwan)
          Do ip=1,n
             apair(ip)=Sqrt(Sum(wdef% p_wfpairs(:,jwan,iwan,ip)**2))
          Enddo
          Call dshel2(1_t_int,n,apair,iwk,1.e-12_t_real)
          !!
          wdef% p_wfpairs(:,jwan,iwan,1:n)=&
               &wdef% p_wfpairs(:,jwan,iwan,iwk(1:n)+1)
          !!
       Enddo
    Enddo
    !!
    If(prot)Then
       Write(outfile,99)
       Do iwan=1,nwan
          Do jwan=1,nwan
             Write(outfile,100)
             Write(outfile,101) iwan,Trim(wdef% p_name(iwan))&
                  &,jwan,Trim(wdef% p_name(jwan))&
                  &,wdef% p_nwfpairs(jwan,iwan)
             Write(outfile,102)
             
             Do irs=1,wdef% p_nwfpairs(jwan,iwan)
                p=wdef% p_wfpairs(:,jwan,iwan,irs)
                pabs=Sqrt(Dot_product(p,p))
                Write(outfile,103)irs,p,pabs
             Enddo
             
          Enddo
       Enddo
    End If
    !!
    Call pfree(apair)
    Call pfree(iwk)
    !!
    Return
    !!
99  Format(/,' Pairs from WF to WF ',/)
100 Format('WF             WF          number of pairs')
101 Format(i3,1x,'[',a,']',1x,i3,1x,'[',a,']',6x,i4)
102 Format('              no        px            py&
         &            pz           |p|')
103 Format(t12,i4,1x,4(f12.6,2x))
  End Subroutine prep_wf_lattice
  !!***********************************************************************
  Subroutine print_WF_coeffs(nspin,structure,basis,wdef,WFc,rel)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Type(T_WanDefs),Intent(in)   :: wdef
    Logical(t_log),Intent(in)    :: rel
    Integer(t_int),Intent(in)    :: nspin
    Complex(t_real),Intent(in)   :: WFc(:,:,0:,:,:)

    !!LOCAL
    Character(*),Parameter::nsubfunc="print_WF_opendx"
    Logical(t_log) :: iscomplex,to_print,to_print_shell,to_print_pair
    Integer(t_int) :: ms,iwan,isb,issb,irs,ii,ivr,deg,m,ll,jj
    Real(t_real)   :: p(3),pabs,wr,wi,itol
    Character(200) :: fname
    !!
    itol=1.0e-6_t_real
    !!
    fname='+WF_coefficients'
    Write(outfile,10)Trim(fname)
    !!
    Open(12,file=fname)
    spinloop: Do ms=1,nspin
       !!
       Write(12,99) ms
       !!
       iwanloop: Do iwan=1,wdef% nwan
          !!
          iscomplex=.False.
          !!
          !!
          !!
          !!
          !!
          !!
          isbloop: Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             !!
             to_print_shell=.False.
             irsloop1: Do irs=1,wdef% p_nswfpairs(isb,iwan)
                !!
                p(:)=wdef% p_swfpairs(:,isb,iwan,irs)
                pabs=Sqrt(Dot_product(p,p))
                !!
                !!
                ii=0
                ivrloop1: Do ivr=1,basis% p_nRv(issb)
                   deg=basis% p_degRv(ivr,issb)
                   !!
                   Do m=1,deg
                      wr=Real(WFc(ii+m,isb,irs,iwan,ms),t_real)
                      wi=Aimag(WFc(ii+m,isb,irs,iwan,ms))
                      If(Abs(wr) > wdef% WF_coeff_threshold&
                           & .Or. (Abs(wi)>itol)) Then
                         to_print_shell=.True.
                      Endif
                   Enddo
                   ii=ii+deg
                Enddo ivrloop1
             Enddo irsloop1
             !!
             shellif: If(to_print_shell)Then
                !!
                Write(12,100)
                Write(12,101) iwan,Trim(wdef% p_name(iwan))&
                     &,structure% p_elements(structure% p_isrt(isb)),isb&
                     &,wdef% p_nswfpairs(isb,iwan)
                !!
                !!
                irsloop: Do irs=1,wdef% p_nswfpairs(isb,iwan)
                   !!
                   p(:)=wdef% p_swfpairs(:,isb,iwan,irs)
                   pabs=Sqrt(Dot_product(p,p))
                   !!
                   !!
                   to_print_pair=.False.
                   ii=0
                   ivrloop2: Do ivr=1,basis% p_nRv(issb)
                      deg=basis% p_degRv(ivr,issb)
                      !!
                      Do m=1,deg
                         wr=Real(WFc(ii+m,isb,irs,iwan,ms),t_real)
                         wi=Aimag(WFc(ii+m,isb,irs,iwan,ms))
                         If(Abs(wr) > wdef% WF_coeff_threshold&
                              & .Or. (Abs(wi)>itol)) Then
                            to_print_pair=.True.
                         Endif
                      Enddo
                      !!
                      ii=ii+deg
                   Enddo ivrloop2
                   !!
                   pairif: If(to_print_pair)Then
                      !!
                      Write(12,103)irs,p,pabs
                      !!
                      ii=0
                      ivrloop: Do ivr=1,basis% p_nRv(issb)
                         deg=basis% p_degRv(ivr,issb)
                         ll=basis% p_lRv(ivr,issb)
                         jj=2*Abs(basis% p_kapRv(ivr,issb))-1
                         !!
                         to_print=.False.
                         Do m=1,deg
                            wr=Real(WFc(ii+m,isb,irs,iwan,ms),t_real)
                            wi=Aimag(WFc(ii+m,isb,irs,iwan,ms))
                            If(Abs(wr) > wdef% WF_coeff_threshold&
                                 & .Or. (Abs(wi)>itol)) Then
                               to_print=.True.
                            Endif
                         Enddo
                         !!
                         If(to_print)Then
                            If(.Not.rel)Then
                               Write(12,106) basis% p_nnRv(ivr,issb),lqnchar(ll)
                            Else
                               Write(12,1061) basis% p_nnRv(ivr,issb),lqnchar(ll),jj
                            Endif
                            !!
                            Do m=1,deg
                               !!
                               !!
                               wr=Real(WFc(ii+m,isb,irs,iwan,ms),t_real)
                               wi=Aimag(WFc(ii+m,isb,irs,iwan,ms))
                               !!
                               If(Abs(wr) > wdef% WF_coeff_threshold .Or. &
                                    &(Abs(wi)>Max(itol,wdef% WF_coeff_threshold))) Then

                                  If(Abs(wi)>Max(itol,wdef% WF_coeff_threshold))Then
                                     iscomplex=.True.
                                     If(.Not.rel)Then
                                        Write(12,117) m-ll-1,wr,wi
                                     Else
                                        Write(12,1171) 2*(m-1)-jj,wr,wi
                                     Endif
                                  else
                                     If(.Not.rel)Then
                                        Write(12,107) m-ll-1,wr
                                     Else
                                        Write(12,1071) 2*(m-1)-jj,wr 
                                     Endif
                                  Endif
                               Endif
                               !!
                               !!
                            Enddo
                         Endif
                         ii=ii+deg
                      Enddo ivrloop
                   End If pairif
                End Do irsloop
                !!
             End If shellif
             !!
          End Do isbloop
          !!
          !!
          !!
          !!
          !!
          If(iscomplex)Then
             Write(outfile,14) Trim(wdef% p_name(iwan))
             Call errmsg(nmodule,nsubfunc,E_warning&
                  &,msg="' The real space WF coefficients&
                  & are complex?',/,' Reasons unclear!'")
          Endif
          !!
       Enddo iwanloop
       !!
    End Do spinloop
    !!
    Close(12)
    !!
    Return
    !!
10  Format('Writing Wf-coefficients to file ''',a,''' (big) !')
99  Format(/,72('-'),/,' Wannier coefficient for spin ',i2,/,72('-'),/)
    !!
100 Format('WF             site_B          number of pairs')
101 Format('WF(',i3,')=[',a,']  to site ',a2,'(',i3,')  npairs=',i4)
103 Format(t12,i4,1x,'vec= ',3(f12.6,2x),' |vec|=',f12.6,2x)
14  Format(' WF ',a,' has complex coefficients')
!114 Format(' WF coeeficient is complex')
106 Format(t17,i1,a1)
1061 Format(t17,i1,a1,i1,'/2')
107 Format(t20,sp,i2,ss,' : ',f30.14)
1071 Format(t20,sp,i2,ss,'/2 : ',f30.14)
117 Format(t20,sp,i2,ss,' : ',f30.14,sp,f30.14,ss,'*i')
1171 Format(t20,sp,i2,ss,'/2 : ',f30.14,sp,f30.14,ss,'*i')
    !!
  End Subroutine print_WF_coeffs
  !!***********************************************************************
  !!TODO: this may be doen directely from file
  Subroutine make_wannier_bands(nspin,symmetry,structure,kohnsham&
       &,bandplot,wdef,wcd,rel,warn)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_WanDefs),Intent(in)   :: wdef
    Type(T_WANCoeffData),Intent(in)  :: wcd
    Logical(t_log),Intent(in)    :: rel
    Logical(t_log),Intent(inout) :: warn
    Integer(t_int),Intent(in)    :: nspin
    !!LOCAL
    Character(*),Parameter::nsubfunc="make_wannier_bands"
    Logical(t_log) :: prot
    Integer(t_int) :: ikp,ms,iwan,in,jwan,nwan
    Integer(t_int) :: bnband,nsite,nvdim,nkpnts
    Real(t_real)   :: qq(3),ddd,scale
    Real(t_real),Parameter   :: wtol=1.0e-8_t_real
    Real(t_real),Pointer :: p_ewan(:),p_weights(:,:),p_wsum(:)
    !!todo: organuize
    Complex(t_real):: cc
    !! on multiple window data
    Complex(t_real),Pointer :: p_ut(:,:)
    Complex(t_real),Pointer :: p_H(:,:) 
    !!
    Write(outfile,3)
    !!
    Nullify(p_ewan,p_weights,p_wsum)
    Nullify(p_ut)
    Nullify(p_H)
    !!
    !!
    !!
    scale=twopi/ symmetry% lattice_constants(1)
    !!
    nwan=wdef% nwan
    bnband=wcd% bnband
    nsite=structure% nsite
    nvdim=kohnsham% nvdim
    nkpnts=bandplot% nkpnts
    !!
    !!
    !!
    !!
    !!
    !!
    Call palloc('p_ewan',p_ewan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_weights',p_weights,1_t_int,nwan,1_t_int,nwan&
         &,nmodule,nsubfunc)
    Call palloc('p_wsum',p_wsum,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_ut',p_ut,1_t_int,bnband,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_H',p_H,1_t_int,nwan,1_t_int,nwan,nmodule,nsubfunc)
    !!
    !!
    Open(wanbands_unit,file=f_wanbands_out,status='unknown')
    Write(wanbands_unit,120) nsite,wcd% eff,nkpnts,nvdim,nwan&
         &,nspin,1,nwan
    !!
    !!
    !!
    !!
    Open(wanbandweights_unit,file=f_wanbweights_out,status='unknown')
    Write(wanbandweights_unit,120)&
         &nsite,wcd% eff,nkpnts,nvdim,nwan,nspin,1,nwan
    Write(wanbandweights_unit,21,advance='no')
    Do iwan=1,nwan
       Write(wanbandweights_unit,23,advance='no') wdef% p_name(iwan)
    Enddo
    Write(wanbandweights_unit,24)
    !!
    !!
    !!
    ikloop: Do ikp=1,nkpnts
       qq(1:3)=bandplot% p_kpnts(1:3,ikp)
       !!
       Write(wanbands_unit,26)qq
       !!
       prot=.False.
       !If(ikp==1) prot=.True.
       !!
       !Print *,'ikp=',ikp,'======================================'
       !!
       spinloop: Do ms=1,nspin
          !!
          !Write(outfile,8800) ms,ikp,qq
!8800      Format('spin= ',i2,/,'kpoint= ',i8,' k= ',3(f15.8,2x))
          !!
          !!
          !!
          !!
          Call trans_to_wannier(ms,nwan,nvdim,bnband,wdef,qq*scale&
               &,wcd% p_beb(:,ikp,ms),wcd% p_bccts(:,:,ikp,ms)&
               &,kohnsham% p_vnlind,p_ut,warn,rel,wcd% bio)
          !!
          !!
          !!
          !!
          !! build up Wannier Hamiltonian
          !!
          p_H=c0
          Do jwan=1,nwan
             Do iwan=1,nwan
                cc=c0
                Do in=1,bnband
                   cc=cc&
                        &+Conjg(p_ut(in,jwan))*wcd% p_beb(in,ikp,ms)&
                        &*p_ut(in,iwan)
                Enddo
                p_H(jwan,iwan)=cc
             Enddo
          Enddo
          !!
          !!
          !!
          !!
          !Print *,'wantb diagno'
          !Call printmat('H',"('(',f12.8,',',f12.8,')')"&
          !     &,"('             0             ')"&
          !     &,p_H,nwan,nwan,1.0e-5_t_real)
          Call cdiagno_noO(nwan,p_H,p_ewan)
          !!
          !!
          !Print *,'ew=',p_ewan(1:nwan)

          !!
          !!
          Write(wanbands_unit,32,advance='no')bandplot% p_kpnts(4,ikp)
          Do iwan=1,nwan
             Write(wanbands_unit,32,advance='no')p_ewan(iwan)
          Enddo
          Write(wanbands_unit,34)
          !!


          !! form wannier band weights
          !!
          !!
          Do in=1,nwan
             ddd=0.0_t_real
             Do iwan=1,nwan
                p_weights(iwan,in)=Abs(p_H(iwan,in))**2
                ddd=ddd+p_weights(iwan,in)
             Enddo
             p_wsum(in)=ddd
          Enddo
          !!
          Call averageDegenerateSubspaces(1_t_int,nwan,p_ewan,nwan,p_weights,p_wsum,wtol)
          !!
          Do in=1,nwan
             !!
             Write(wanbandweights_unit,30,advance='no')&
                  &bandplot% p_kpnts(4,ikp),p_ewan(in)
                !!
             ddd=p_wsum(in)
             If(Abs(ddd)<1.0e-6_t_real)ddd=1.0_t_real
             Do iwan=1,nwan
                Write(wanbandweights_unit,31,advance='no') p_weights(iwan,in)/ddd
             Enddo
             Write(wanbandweights_unit,24)
          Enddo ! in
          !!
          !!
       End Do spinloop
       !!
    End Do ikloop
    !!
    Close(wanbands_unit)
    Close(wanbandweights_unit)
    !!
    Call pfree(p_H)
    Call pfree(p_ut)

    Call pfree(p_ewan)
    Call pfree(p_wsum)
    Call pfree(p_weights)
    !!
    Write(outfile,4)
    !!
    Return
    !!
26  Format('# ',3f12.7)
32  Format(f16.7,1x)
34  Format(' ')
120 Format('# ',i3,f12.7,6(' ',i8))
21  Format('#       ik           e(k,n)               ')
!11  Format(i1,a1)
    !!
    !!
30  Format(f16.7,1x,f16.7)
31  Format(1x,f16.7)
24  Format()
23  Format(a17)
    !!
3  Format(/,'START processing Wannier bands')
4  Format('END   processing Wannier bands',/)
    !!
  End Subroutine make_wannier_bands
  !!***********************************************************************
  Subroutine trans_to_wannier(ms,nwan,nvdim,nband,wdef,qq,eb,ccts,vnlind&
       &,p_ut,warn,rel,io)
    !!
    Implicit None
    !!IO
    Type(T_WanDefs),Intent(in)   :: wdef
    Logical(t_log),Intent(in)    :: rel
    Integer(t_int),Intent(in)    :: ms
    Integer(t_int),Intent(in)    :: nwan,nvdim,nband,io
    Integer(t_int),Intent(in)    :: vnlind(:,:)
    Real(t_real),Intent(in)      :: qq(3)
    Real(t_real),Intent(in)      :: eb(nband)
    Complex(t_real),Intent(in)   :: ccts(nband,nvdim)
    Logical(t_log),Intent(inout) :: warn
    Complex(t_real),Intent(out)  :: p_ut(nband,nwan)
    !!LOCAL
    Character(*),Parameter::nsubfunc="trans_to_wannier"
    Integer(t_int) :: iwan,icn,ii,in,jwan,j,k,ldeg,relfac!,ol
    Real(t_real)   :: qr
    Complex(t_real):: cc,cw
    Complex(t_real),Pointer :: p_S(:,:)   !!
    Complex(t_real),Pointer :: p_A(:,:) 
    Real(t_real),Pointer    :: p_o(:) 
    Real(t_real),Pointer    :: p_hewan(:) !!TODO: make efficient and dependend
    !!
    Nullify(p_S)
    Nullify(p_A)
    Nullify(p_o)
    Nullify(p_hewan)
    !!
    relfac=1_t_int
    If(rel)relfac=2_t_int
    
    !!
    !!
    Call palloc('p_hewan',p_hewan,1_t_int,nband,nmodule,nsubfunc)
    Call palloc('p_S',p_S,1_t_int,nwan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_A',p_A,1_t_int,nwan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_o',p_o,1_t_int,nwan,nmodule,nsubfunc)
    !!
    !!
    !! prepare the MO-U matrix
    !!
    Do iwan=1,nwan
       !Print "(t1,'iwan=',i5)",iwan
       !!
       !!
       Call det_bindex_in_ewindow(nband,eb&
            &,wdef% p_ewind(1,iwan,ms),wdef% p_ewind(2,iwan,ms)&
            &,wdef% p_ewind(3,iwan,ms),wdef% p_ewind(4,iwan,ms)&
            &,wdef% p_lband(ms,iwan)-io+1,wdef% p_uband(ms,iwan)-io+1&
            &,p_hewan,1.0e-4_t_real)
       !!
       !!
       p_ut(:,iwan)=c0
       Do icn=1,wdef% p_ninwan(iwan)
          !!
          !Print "(t5,'contrib=',i5)",icn
          !!
          ii=vnlind(wdef% p_ivr(icn,iwan),wdef% p_site(icn,iwan))-1
          ldeg=relfac*(2*wdef% p_od(icn,iwan)%l+1)
!          Print *,'ii=',ii,' ldeg=',ldeg
          !!
          !!
          qr=Dot_product(qq,wdef% p_difvec(1:3,icn,iwan))
          !!
          cc=Exp(-ci*qr)
          !!
          Do in=1,nband
             cw=Sum(ccts(in,ii+1:ii+ldeg)*wdef% p_Dloc(1:ldeg,icn,iwan))
             p_ut(in,iwan)=p_ut(in,iwan)+cc*p_hewan(in)*cw
          Enddo
       Enddo
    Enddo
    !!
    !!
    !!  make SVD
    !!
    Do jwan=1,nwan
       Do iwan=1,nwan
          p_A(jwan,iwan)=&
               &Dot_product(p_ut(1:nband,jwan),p_ut(1:nband,iwan))
       Enddo
    Enddo
    !!
    !Call printmat('S',"('(',f12.8,',',f12.8,')')"&
    !     &,"('             0             ')"&
    !     &,p_A,nwan,nwan,1.0e-5_t_real)
    !!
    !!
    Call cdiagno_noO(nwan,p_A,p_o)
    !!
    Do iwan=1,nwan
       If(p_o(iwan)<=1.0e-12_t_real) Then
          Write(outfile,602) iwan,p_o(iwan),Matmul(qq,wdef% AA)/twopi
          warn=.True.
          Call errmsg(nmodule,nsubfunc,E_warning&
               &,msg="' the Wannier overlap matrix is&
               & not positive definite?!'")
       Endif
!!$    If(p_o(iwan)<=1.0e-6_t_real) Then
!!$       Write(outfile,602) iwan,p_o(iwan),qq
!!$       warn=.True.
!!$       Call errmsg(nmodule,nsubfunc,E_warning&
!!$            &,msg="' the Wannier overlap matrix is&
!!$            & getting close to singular?!'")
!!$    Endif
    Enddo
    !!
    !!
    Do iwan=1,nwan
       Do j=1,nwan
          cc=c0
          Do k=1,nwan
             cc=cc+p_A(iwan,k)/Sqrt(p_o(k))*Conjg(p_A(j,k))
          Enddo
          p_S(iwan,j)=cc
       Enddo
    Enddo
    !!
    !!
    !Call printmat('Sortho',"('(',f12.8,',',f12.8,')')"&
    !     &,"('             0             ')"&
    !     &,p_S,nwan,nwan,1.0e-5_t_real)
    !!
    !! orthogonalize the generalized KS states
    !!
    p_ut(:,:)=Matmul(p_ut(:,:),p_S(:,:))
    !!
    !!
    !!
    !!
    !! paranoia
    !!
    Do jwan=1,nwan
       Do iwan=1,nwan
          cc=Dot_product(p_ut(1:nband,jwan),p_ut(1:nband,iwan))
          If(iwan==jwan)Then
             If(Abs(cc-c1) > 1.0e-6_t_real) Then
                Write(outfile,600) jwan,iwan,cc
                warn=.True.
                Call errmsg(nmodule,nsubfunc,E_warning&
                     &,msg="' the SVD-transformed wannier basis &
                     &is not orthogonal?!'")
             Endif
          Else
             If(Abs(cc) > 1.0e-6_t_real) Then
                Write(outfile,601) jwan,iwan,cc
                warn=.True.
                Call errmsg(nmodule,nsubfunc,E_warning&
                     &,msg="' the SVD-transformed wannier basis &
                     &is not orthogonal?!'")
             Endif
          Endif
       Enddo
    Enddo
    !!
    !!
    Call pfree(p_o)
    Call pfree(p_S)
    Call pfree(p_A)
    Call pfree(p_hewan)
    !!
    Return
    !!
600 Format(/,' S(',i5,',',i5,')=',2(f12.5,2x),' /= 1')
601 Format(/,' S(',i5,',',i5,')=',2(f12.5,2x),' /= 0')
602 Format(/,' diag(S)(',i5,')=',1(f30.15,2x),' <= 0',/,' k_rel=',3(f15.8,2x))
    !!
  End Subroutine trans_to_wannier
  !!***********************************************************************
  !!TODO: the open issues phase factors, which does not matter
  !!TODO: for one-band WFs
  !!TODO: the extend of the WF is not well controlled, which reflects
  !!TODO: in the fact that the WF-coefficients are not falling off 
  !!TODO: sufficiently fast and that the fited bands deviate from the
  !!TODO: Wannier bands
  !!TODO: this could in principle be solved by using more neighbours
  !!TODO: although the meaning of such a WF is questionable !!!
  Subroutine make_wannier_fit(nspin,symmetry,structure,lattice,basis,kohnsham&
       &,bzone,bandplot,degree,wdef,wfgrid,have_wforigin,kgrid,wcd,rel,warn,quant)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_WanDefs),Intent(in)   :: wdef
    Type(T_Grid),Intent(inout)   :: wfgrid,kgrid
    Type(T_Quant),Intent(in)     :: quant
    Type(T_WANCoeffData),Intent(in)  :: wcd
    Logical(t_log),Intent(in)    :: rel,have_wforigin
    Integer(t_int),Intent(in)    :: nspin
    Integer(t_int),Intent(in)    :: degree
    Logical(t_log),Intent(inout) :: warn
    !!LOCAL
    Character(*),Parameter::nsubfunc="make_wannier_fit"
    Logical(t_log) :: prot
    Character(100) :: str
    Integer(t_int) :: ms,ikp,nwan,knband,nsite,nvdim,nkp,irs,jwan,iwan,relfac
    Integer(t_int) :: in,irgs,m,jops,iv,igwan,jgwan,isc,isgc,ndim,ll,subdiv
    Integer(t_int) :: issc,ii,ivr,deg,mv,j,i,isHop,isb,issb
    Real(t_real)   :: qq(3),dd,r(3),qr,norm,DP(3),rg(3),scale
    Real(t_real)   :: rabs,rz,z
    Complex(t_real):: cc,cH,ca
    Complex(t_real),Pointer :: p_ut(:,:)
    Complex(t_real),Pointer :: p_H(:,:)
    Complex(t_real),Pointer :: p_hop(:,:,:)
    Complex(t_real),Pointer :: p_hopsym(:,:,:,:)
    Real(t_real),Pointer :: p_ewan(:)
    Complex(t_real),Pointer :: p_WFc(:,:,:,:)
    Complex(t_real),Pointer :: p_WFcsym(:,:,:,:,:)
    Real(t_real),Pointer    :: p_xshop(:)
    Complex(t_real),Pointer :: p_sHop(:)
    Integer(t_int),Pointer  :: iwk(:)
    !!
    Nullify(p_ut)
    Nullify(p_sHop)
    Nullify(iwk)
    Nullify(p_xshop)
    Nullify(p_H)
    Nullify(p_hop)
    Nullify(p_hopsym)
    Nullify(p_ewan)
    Nullify(p_WFc)
    Nullify(p_WFcsym)
    !!
#if defined (DATA_FILES_IN_DIRS)
    Call mkdirectory('+T')
    Call mkdirectory('+WFstat')
#endif
    !!
    scale=twopi/ symmetry% lattice_constants(1)
    nwan=wdef% nwan
    knband=wcd% knband
    nsite=structure% nsite
    nvdim=kohnsham% nvdim
    nkp=bzone% nkp
    !!
    relfac=1
    if(rel)relfac=2
    !!
    If(nwan>1)Then
       Write(outfile,*)
       Call errmsg(nmodule,nsubfunc,E_warning&
            &,msg="' There are unclear issues for hoppings &
            &of multiband Wannier functions, be carefull!',/")
       !Return
    Endif
    !!
    Call palloc('p_hopsym',p_hopsym,1_t_int,nwan,1_t_int,nwan&
         &,0_t_int,wdef% nwfpairsmax,1_t_int,nspin,nmodule,nsubfunc)
    Call palloc('p_WFcsym',p_WFcsym,1_t_int,kohnsham% nvsmx,1_t_int,nsite&
         &,0_t_int,wdef% nswfpairsmax,1_t_int,nwan,1_t_int,nspin&
         &,nmodule,nsubfunc)
    !!
    !!
    !!
    !!

    Write(outfile,3)
    !!
    !!
    Call palloc('p_hop',p_hop,1_t_int,nwan,1_t_int,nwan&
         &,0_t_int,wdef% nwfpairsmax,nmodule,nsubfunc)
    Call palloc('p_WFc',p_WFc,1_t_int,kohnsham% nvsmx,1_t_int,nsite&
         &,0_t_int,wdef% nswfpairsmax,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_ut',p_ut,1_t_int,knband,1_t_int,nwan,nmodule,nsubfunc)
    !!
    subdiv=(Max(1_t_int,nkp/(100/5)));
    !!
    spinloop: Do ms=1_t_int,nspin
       !!
       p_hop(:,:,0:)=c0
       p_WFc(:,:,0:,:)=c0
       !!
       !!
       !!
       kloop: Do ikp=1_t_int,nkp
!          Print *,'ikp=',ikp,nkp
          qq(:)=bzone% p_bk(:,ikp)
          !!
          If ( Mod(ikp,subdiv) ==0 )Then
             Write(outfile,51) 100.0_t_real*ikp/nkp
          Endif

          !!
          !!
          prot=.False.
          !If(ikp==1) prot=.True.
          !!
          Call trans_to_wannier(ms,nwan,nvdim,knband,wdef,qq&
               &,wcd% p_keb(:,ikp,ms),wcd% p_kccts(:,:,ikp,ms)&
               &,kohnsham% p_vnlind,p_ut,warn,rel,wcd% kio)

          !!
          !!
          !!
          !! make matrix elements
          !!
          !! build up Wannier Hamiltonian
          !!
          !!
          !! build real-space WF coeficcients
          !!
          !!
          WFciwanloop: Do iwan=1,nwan
             !!
             iv=0
             iscloop: Do isc=1,nsite
                issc=structure% p_isrt(isc)
                ii=0
                ivrloop: Do ivr=1,basis% p_nRv(issc)
                   deg=basis% p_degRv(ivr,issc)
                   mvloop: Do m=1,deg
                      iv=iv+1
                      ii=ii+1
                      !!
                      cc=c0
                      Do in=1,knband
                         cc=cc+wcd% p_kcc(in,iv,ikp,ms)*p_ut(in,iwan)
                      Enddo
                      !!
                      irloop1: Do irs=1,wdef% p_nswfpairs(isc,iwan)
                         r(:)=wdef% p_swfpairs(:,isc,iwan,irs)
                         !!
                         !!
                         !! \int kz =1/Nz sum_iz exp(i*(qq+k(iz)*pair_z))
                         !!
                         If(wdef% slab_reduce)Then
                            rz=Dot_product(r,wdef% GG(:,3))
                            z=Dot_product(structure% p_tau(:,isc)-wdef% p_center(:,iwan)&
                                 &,wdef% GG(:,3))
                            If(Abs(rz-z)>1.0e-6_t_real) Cycle irloop1
                         Endif
                         !!
                         qr=Dot_product(qq,r)
                         !!
                         p_WFc(ii,isc,irs,iwan)=p_WFc(ii,isc,irs,iwan)&
                              &+cc*Exp(ci*qr)*bzone% p_wbk(ikp)
                         !!
                      Enddo irloop1
                   Enddo mvloop
                Enddo ivrloop
             Enddo iscloop
          Enddo WFciwanloop
          !!
          !!
          !|Ri)=\int dk|kn> ut_{ni}^{k}e^{-ik (R+s_{i}+\alpha_{i})}
          !!
          Do iwan=1,nwan
             !!
             !!
             !!
             Do jwan=1,nwan
                !!
                !!
                cH=c0
                Do in=1,knband
                   cH=cH+Conjg(p_ut(in,iwan))*wcd% p_keb(in,ikp,ms)&
                        &*p_ut(in,jwan)
!                   Print *,'wcd% p_keb(in,ikp,ms)=',wcd% p_keb(in,ikp,ms)
!                   Print *,'p_ut(in,iwan)=',p_ut(in,iwan)
!                   Print *,'p_ut(in,jwan)=',p_ut(in,jwan)
                Enddo
                !!
                irloop: Do irs=1,wdef% p_nwfpairs(jwan,iwan)
                   r(:)=wdef% p_wfpairs(:,jwan,iwan,irs)
                   !!
                   If(wdef% slab_reduce)Then
                      rz=Dot_product(r,wdef% GG(:,3))
                      z=Dot_product(wdef% p_center(:,jwan)-wdef% p_center(:,iwan)&
                           &,wdef% GG(:,3))
                      If(Abs(rz-z)>1.0e-6_t_real) Cycle irloop
                   Endif
                   !!
                   qr=Dot_product(qq,r)
                   !!
                   !!
!                   Print *,'cH=',cH
                   p_hop(iwan,jwan,irs)=p_hop(iwan,jwan,irs)&
                        &+cH*Exp(-ci*qr)*bzone% p_wbk(ikp)
                   !!
                Enddo irloop
                !!
             Enddo!! jwan
          Enddo!! iwan
       End Do kloop
       !!
       !! 
       !!
       norm=1.0_t_int/Real(symmetry% Rnumops,t_real)
       !!
       p_WFcsym(:,:,0:,:,ms)=c0
       !!
       !!
       WFciwansymloop: Do iwan=1,nwan
          !!
          Print *,'WFciwansymloop iwan=',iwan,nwan
          !!
          !!
          WFCiscloop: Do isc=1,nsite
             issc=structure% p_isrt(isc)
             !!
             !!
             WFcjopsloop: Do jops=1,symmetry% Rnumops
                !!
                !!
                !!
                isgc=structure% p_equivsites(jops,isc)
                !!
                !!
                igwan=wdef% p_equivMOrep(jops,iwan)
                !!
                WFcpairsymloop: Do irs=1,wdef% p_nswfpairs(isc,iwan)
                   !!
                   !!
                   r(:)=wdef% p_swfpairs(:,isc,iwan,irs)
                   !!
                   DP=Matmul(r,symmetry% Ropmat(:,:,jops))
                   !!
                   !!
                   irgs=-1
                   WFcmloop: Do m=1,wdef% p_nswfpairs(isgc,igwan)
                      !!
                      !!
                      rg(:)=wdef% p_swfpairs(:,isgc,igwan,m)
                      !!
                      If(All(Abs(rg(:)-DP(:)) < 1.e-3_t_real)) Then
                         irgs=m
                         Exit WFcmloop
                      Endif
                   Enddo WFcmloop
                   If(m==-1)Then
                      Call errmsg(nmodule,nsubfunc,E_fatalerror&
                           &,msg="'Could not find a symmetry related vector !'&
                           &,/,'Please report all calculational detail to the&
                           &authors!'")
                   Endif
                   !!
                   !!
                   ii=0
                   WFcivrloop: Do ivr=1,basis% p_nRv(issc)
                      ll=basis% p_lRv(ivr,issc)
                      If(basis% p_kapRv(ivr,issc)>0)Cycle
                      deg=relfac*(2*ll+1)
                      WFcmvloop: Do mv=1,deg
                         cc=c0
                         Do i=1,wdef% p_Neq(iwan,jops)
                            jwan=wdef% p_eqMO(i,iwan,jops)
                            !! DMO is zero if jwan /= igwan thus, we can summ over all
                            ca=Dot_product(symmetry% p_Rwu_tjnl_ks(1:deg,mv,ll,jops)&
                                 &,p_WFc(ii+1:ii+deg,isgc,irgs,jwan))&
                                 &*wdef% p_DMO(jwan,iwan,jops)
                            If(symmetry% Roptimerev(jops)==1)Then
                               cc=cc+Conjg(ca)
                            Else
                               cc=cc+ca
                            Endif
                         Enddo
                         !!
                         p_WFcsym(ii+mv,isc,irs,iwan,ms)=&
                              &p_WFcsym(ii+mv,isc,irs,iwan,ms)+cc*norm
                         !!
                      End Do WFcmvloop
                      ii=ii+deg
                   End Do WFcivrloop
                   !!
                End Do WFcpairsymloop
             End Do WFcjopsloop
          End Do WFCiscloop
       End Do WFciwansymloop
       !!
       !!
!!$       p_hopsym(:,:,0:,ms)=p_hop(:,:,0:)
!!$       Goto 999
       p_hopsym(:,:,0:,ms)=c0
       !!
       !!
       iwansymloop: Do iwan=1,nwan
          !!
!          Print *,'iwansymloop iwan=',iwan,nwan

          jwansymloop: Do jwan=1,nwan
             !!
             jopsloop: Do jops=1,symmetry% Rnumops
                !!
                igwan=wdef% p_equivMOrep(jops,iwan)
                jgwan=wdef% p_equivMOrep(jops,jwan)
                !!
                !!
                !!
                !!
                pairsymloop: Do irs=1,wdef% p_nwfpairs(jwan,iwan)
                   r(:)=wdef% p_wfpairs(:,jwan,iwan,irs)
                   !!
                   DP=Matmul(r,symmetry% Ropmat(:,:,jops))
                  
                   !! find T=pair(irg,jgwan,igwan) such that =DP = \hat{D} r
                   
                   irgs=-1
                   mloop: Do m=1,wdef% p_nwfpairs(jgwan,igwan)
                      rg(:)=wdef%  p_wfpairs(:,jgwan,igwan,m)
                      !!
                      If(All(Abs(rg(:)-DP(:)) < 1.e-5_t_real)) Then
                         irgs=m
                         Exit mloop
                      Endif
                   Enddo mloop
                   If(irgs==-1)Then
                      Call errmsg(nmodule,nsubfunc,E_fatalerror&
                           &,msg="'Could not find a symmetry related vector !'&
                           &,/,'Please report all calculational detail to the&
                           & authors!'")
                   Endif
                   !!
                   cc=c0
                   Do i=1,wdef% p_Neq(iwan,jops)
                      Do j=1,wdef% p_Neq(jwan,jops)
                         ca=Conjg(wdef% p_DMO(wdef% p_eqMO(i,iwan,jops),iwan,jops))&
                              &*p_hop(wdef% p_eqMO(i,iwan,jops),wdef% p_eqMO(j,jwan,jops),irgs)&
                              &*wdef% p_DMO(wdef% p_eqMO(j,jwan,jops),jwan,jops)
                         If(symmetry% Roptimerev(jops)==1)Then
                            cc=cc+Conjg(ca)
                         Else
                            cc=cc+ca
                         Endif
                      Enddo
                   Enddo
                   !!
                   p_hopsym(iwan,jwan,irs,ms)=&
                        &p_hopsym(iwan,jwan,irs,ms)+cc*norm
                   !!
                Enddo pairsymloop
             End Do jopsloop
          Enddo jwansymloop
       Enddo iwansymloop
!!$999    Continue
       !!
       !!
       !!
       !! output of hoppings
       !!      
       If(wdef% write_Ham_t_stats)Then
          
          Call palloc('p_sHop',p_sHop ,1_t_int,nwan*wdef% nwfpairsmax&
               &,nmodule,nsubfunc)
          Call palloc('p_xshop',p_xshop ,1_t_int,nwan*wdef% nwfpairsmax&
               &,nmodule,nsubfunc)
          Call palloc('iwk',iwk ,1_t_int,nwan*wdef% nwfpairsmax&
               &,nmodule,nsubfunc)
       Endif
       !!
       iwloop: Do iwan=1,nwan
          isHop=0
          jwloop: Do jwan=1,nwan
             !!
             Write(outfile,13) ms,Trim(wdef% p_name(iwan))&
                  &,Trim(wdef% p_name(jwan))
             !!
             Do irs=1,wdef% p_nwfpairs(jwan,iwan)
                r(:)=wdef% p_wfpairs(:,jwan,iwan,irs)
                !!
                !!
                !! todo: establish, when it is real and remove this crap
                !!
                cH=p_hopsym(iwan,jwan,irs,ms)
                !!
                If(abs(cH) > wdef% WF_ham_threshold ) Then
                   Write(outfile,15) r,cH
                   isHop=isHop+1
                   If(wdef% write_Ham_t_stats)Then
                      p_sHop (isHop)=cH
                      p_xshop(isHop)=Sqrt(Sum(r(:)**2))
                   Endif
                Endif
                !!
                If(.Not.rel .And. Abs(Aimag(cH))>1.0e-6_t_real)Then
                   Write(outfile,14) Aimag(cH)
                   Call errmsg(nmodule,nsubfunc,E_warning&
                        &,msg="' The real space hoppings are complex?',/&
                        &,' Reasons unclear!'")
                Endif
                !!
             Enddo
          Enddo jwloop
          Write(outfile,34)
          !!
          If(wdef% write_Ham_t_stats)Then
             Call dshel2(1_t_int,isHop,p_xshop,iwk,1.e-12_t_real)
             Write(str,"('+T',a,'.spin',i1)") Trim(wdef% p_name(iwan)),ms
             Call replacechar(str,'/','_')
             
#if defined (DATA_FILES_IN_DIRS)
             Call delete_existing_file(12,Trim(str))
             str='+T/'//Trim(str)
#endif
             
             Open(12,file=Trim(str))
             Do i=1,isHop
                Write(12,16) p_xshop(iwk(i)+1),p_sHop(iwk(i)+1)
             Enddo
             Close(12)
          Endif
          !!
       Enddo iwloop
       !!
       If(wdef% write_Ham_t_stats)Then
          Call pfree(p_sHop)
          Call pfree(iwk)
          Call pfree(p_xshop)
       Endif
       !!
       !!
       !!
       !! output WF coefficients statistics
       !!
       If(wdef% write_WF_coeff_stats)Then
          ndim=nsite*wdef% nswfpairsmax*basis% nRvmx
          Call palloc('p_sHop',p_sHop ,1_t_int,ndim,nmodule,nsubfunc)
          Call palloc('p_xshop',p_xshop ,1_t_int,ndim,nmodule,nsubfunc)
          Call palloc('iwk',iwk ,1_t_int,ndim,nmodule,nsubfunc)
          !!
          WFiwloop: Do iwan=1,nwan
             !!
             isHop=0
             isblp: Do isb=1,nsite
                issb=structure% p_isrt(isb)
                
                irlp: Do irs=1,wdef% p_nswfpairs(isb,iwan)
                   r(:)=wdef% p_swfpairs(:,isb,iwan,irs)
                   rabs=Sqrt(Sum(r(:)**2))
                   !!
                   ii=0
                   ivrlp: Do ivr=1,basis% p_nRv(issb)
                      deg=basis% p_degRv(ivr,issb)
                      !!
                      dd=0.0_t_real
                      mvlp: Do m=1,deg
                         ii=ii+1
                         !!
                         !!
                         !!
                         dd=Max(dd,Abs( p_WFcsym(ii,isb,irs,iwan,ms) ) )
                         !!
                      Enddo mvlp
                      !!
                      isHop=isHop+1
                      !!
                      p_xshop(isHop)=rabs
                      p_sHop(isHop)=dd
                      !!
                   Enddo ivrlp
                Enddo irlp
             Enddo isblp
             !!
             Call dshel2(1_t_int,isHop,p_xshop,iwk,1.e-12_t_real)
             
             Write(str,"('+WFstat',a,'.spin',i1)") &
                  &Trim(wdef% p_name(iwan)),ms
             Call replacechar(str,'/','_')
#if defined (DATA_FILES_IN_DIRS)
             Call delete_existing_file(12,Trim(str))
             str='+WFstat/'//Trim(str)
#endif
             Open(12,file=Trim(str))
             Do i=1,isHop
                Write(12,16) p_xshop(iwk(i)+1),p_sHop(iwk(i)+1)
             Enddo
             Close(12)
             !!
          Enddo WFiwloop
          !!
          Call pfree(p_sHop)
          Call pfree(iwk)
          Call pfree(p_xshop)
       Endif
       !!
       !!
    End Do spinloop
    !!
    !!
    Call pfree(p_ut)
    !!
    Write(outfile,4)
    !!
    Call pfree(p_WFc)
    Call pfree(p_hop)
    !!
    !!
    !! make bandplot of wanner-fit, since I am a control freak ;-)
    !!
    Write(outfile,103)
    !!
    Call palloc('p_H',p_H,1_t_int,nwan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_ewan',p_ewan,1_t_int,nwan,nmodule,nsubfunc)
    !!
    !!
    Open(wanbands_unit,file=Trim(f_wanbands_out)//'tb',status='unknown')
    Write(wanbands_unit,120) nsite,wcd% eff,bandplot% nkpnts,nvdim,nwan&
         &,nspin,1,nwan
    !!
    ikloop: Do ikp=1,bandplot% nkpnts
       qq(1:3)=bandplot% p_kpnts(1:3,ikp)
       !!
       Write(wanbands_unit,26)qq
       !!
       bspinloop: Do ms=1,nspin
          !!
          !!
          !! reassemble Hamiltonian
          !!
          p_H=c0
          !!
          Do iwan=1,nwan
             Do jwan=1,nwan
                
                Do irs=1,wdef% p_nwfpairs(jwan,iwan)
                   r(:)=wdef% p_wfpairs(:,jwan,iwan,irs)
                   !!
                   !!
                   qr=Dot_product(qq,r)*scale
                   !!
                   cH=p_hopsym(iwan,jwan,irs,ms)
                   If(Abs(cH) >= wdef% WF_ham_threshold)Then
                      p_H(iwan,jwan)=p_H(iwan,jwan)+cH*Exp(ci*qr)
                   Endif
                   !!
                   !!
                Enddo
                
             Enddo
          Enddo
          !!
          !!
          !!
          Call cdiagno_noO(nwan,p_H,p_ewan)
          !!
          !!
          !!
          Write(wanbands_unit,32,advance='no')bandplot% p_kpnts(4,ikp)
          Do iwan=1,nwan
             Write(wanbands_unit,32,advance='no')p_ewan(iwan)
          Enddo
          Write(wanbands_unit,34)


       End Do bspinloop
       
    End Do ikloop
    !!
    Close(wanbands_unit)
    !!
    Write(outfile,104)
    !!
    !!
    !! export wannier Hamiltonian on grid
    !!
    !!
    !!
    kgrid% latticetype=GRID_RECIP_LATTICE

    !!
    Call print_grid_props(outfile,kgrid)
    Call make_grid(kgrid,symmetry,structure)
    !!
    !!
    Open(wanbands_unit,file='+hamongrid',status='unknown')
    !!
    subdiv=(Max(1_t_int,kgrid% npoints/(100/10)));
    !!
    pspinloop: Do ms=1,nspin

       Write(outfile,"('Spin: ',i1)") ms
          
       iploop: Do ikp=1,kgrid% npoints
          qq(1:3)=kgrid%  points(1:3,ikp)
          !!
          !!
          !!
          If ( Mod(ikp,subdiv) ==0 .Or. ikp==1 .Or.ikp==kgrid% npoints)Then
             Write(outfile,"('Hk Output: ',f6.2,'% done')") &
                  &100.0_t_real*ikp/kgrid% npoints
          Endif

          !!
          !! reassemble Hamiltonian
          !!
          p_H=c0
          !!
          Do iwan=1,nwan
             Do jwan=1,nwan
                
                Do irs=1,wdef% p_nwfpairs(jwan,iwan)
                   r(:)=wdef% p_wfpairs(:,jwan,iwan,irs)
                   !!
                   !!
                   qr=Dot_product(qq,r)
                   !!
                   cH=p_hopsym(iwan,jwan,irs,ms)
                   If(Abs(cH) >= wdef% WF_ham_threshold)Then
                      p_H(iwan,jwan)=p_H(iwan,jwan)+cH*Exp(ci*qr)
                   Endif
                   !!
                   !!
                Enddo
                
             Enddo
          Enddo
          !!
          !!
          !!
          Do iwan=1,nwan
             Do jwan=1,nwan
                cH=p_H(iwan,jwan)
                Write(wanbands_unit,62)Real(cH,t_real),Aimag(cH)
!                Write(wanbands_unit,62) qq/twopi*symmetry% lattice_constants(1), Real(cH,t_real),Aimag(cH)
             Enddo
          Enddo
          !!
          !!
       End Do iploop
       !!
       Write(wanbands_unit,34)
       !!
    End Do pspinloop
    !!
    Close(wanbands_unit)
    !!
    !!
    !!
    Call pfree(p_ewan)
    Call pfree(p_H)
    !!
    Call wannierLDOS(nspin,symmetry,bandplot,bzone,wdef,p_hopsym,rel)
    !!
    Call print_WF_coeffs(nspin,structure,basis,wdef,p_WFcsym,rel)
    !!
    !!
    Call create_WF_opendx(nspin,symmetry,structure,lattice,basis,degree&
         &,wdef,wfgrid,have_wforigin,p_WFcsym,rel,quant)
    !!
    Call pfree(p_hopsym)
    Call pfree(p_WFcsym)
    !!
    Return
    !!
13  Format('spin ',i1,': WF(',a,') -> WF(',a,') at relative ')
15  Format('T= ',3(f12.5,1x),' hop=',f30.15,' +i* ',f30.15)
16  Format(3(f30.15,2x))
14  Format(' Im(t)=',f30.15)
    !!
120 Format('# ',i3,f12.7,6(' ',i8))
26  Format('# ',3f12.7)
32  Format(f16.7,1x)
62  Format(10(e30.15e3,1x))
34  Format(' ')
3  Format(/,'START calculating WF')
4  Format('END   calculating WF',/)
103 Format(/,'START calculating +wanbandtb')
104 Format('END   calculating +wanbandtb',/)
51  Format('calculating WF: ',f5.1,'% done')
    !!
  End Subroutine make_wannier_fit
  !!***********************************************************************
  Subroutine wannierLDOS(nspin,symmetry,bandplot,bzone,wdef,hopsym,rel)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_WanDefs),Intent(in)   :: wdef
    Logical(t_log),Intent(in)    :: rel
    Integer(t_int),Intent(in)    :: nspin
    Complex(t_real),Intent(in)   :: hopsym(:,:,0:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="wannierLDOS"
    Integer(t_int) :: ikp,nkp,ms,nwan,iwan,jwan,irs,iz,in,ie,jops,i,jz
    Real(t_real)   :: qq(3),r(3),qr,e0,e1,de,spinfac,e,norm
    Character(200) :: fname
    Complex(t_real):: cH
    Complex(t_real),Pointer :: p_H(:,:)
    Real(t_real),Pointer :: p_ewan(:),p_ebk(:,:),p_ldos(:,:,:),dos(:),idos(:)
    !!
    Nullify(p_H,p_ewan,p_ebk,p_ldos,dos,idos)
    !!
    Write(outfile,103)
    !!
#if defined (DATA_FILES_IN_DIRS)
    Call mkdirectory('+wanldos')
#endif
    !!
    spinfac=2.0_t_real/nspin
    If(rel) spinfac=1.0_t_real
    nwan=wdef% nwan
    nkp=bzone% nkp
    e0=bandplot% emin
    e1=bandplot% emax
    de=(e1-e0)/(bandplot% nptdos-1)
    norm=1.0_t_int/Real(symmetry% Rnumops,t_real)
    !!
    Call palloc('p_H',p_H,1_t_int,nwan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_ewan',p_ewan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_ebk',p_ebk,1_t_int,nwan,1_t_int,nkp,nmodule,nsubfunc)
    Call palloc('p_ldos',p_ldos,1_t_int,nwan,1_t_int,nkp,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('dos',dos,1_t_int,bandplot% nptdos,nmodule,nsubfunc)
    Call palloc('idos',idos,1_t_int,bandplot% nptdos,nmodule,nsubfunc)
    !!
    !! reassamble hamiltonian from real space WF
    !!
    kspinloop: Do ms=1,nspin
       !!
       kloop: Do ikp=1,nkp
          qq(:)=bzone% p_bk(:,ikp)
          p_H=c0
          Do iwan=1,nwan
             Do jwan=1,nwan
                
                Do irs=1,wdef% p_nwfpairs(jwan,iwan)
                   r(:)=wdef% p_wfpairs(:,jwan,iwan,irs)
                   !!
                   !!
                   qr=Dot_product(qq,r)
                   !!
                   cH=hopsym(iwan,jwan,irs,ms)
                   If(Abs(cH) >= wdef% WF_ham_threshold)Then
                      p_H(iwan,jwan)=p_H(iwan,jwan)+cH*Exp(ci*qr)
                   Endif
                   !!
                   !!
                Enddo
                
             Enddo
          Enddo
          !!
          Call cdiagno_noO(nwan,p_H,p_ewan)
          !!
          p_ebk(1:nwan,ikp)=p_ewan(1:nwan)
          !! construct dos arrays
          Do iz=1,nwan
             Do in=1,nwan
                p_ldos(in,ikp,iz)=0.0_t_real
                sumloop: Do jops=1,symmetry% Rnumops
                   cH=c0
                   Do i=1,wdef% p_Neq(iz,jops)
                      jz=wdef% p_eqMO(i,iz,jops)
                      cH=cH+p_H(jz,in)*Conjg(wdef% p_DMO(jz,iz,jops))
                   Enddo
                   If(symmetry% Roptimerev(jops)==1)Then
                      cH=Conjg(cH)
                   Endif
                   p_ldos(in,ikp,iz)=p_ldos(in,ikp,iz)+Abs(cH)**2*norm
                Enddo sumloop
             Enddo
          Enddo
          !!
          !!
       End Do kloop
       !!
       !!
       Do iwan=1,nwan
          Write(fname,"('+wanldos.',i3.3,'.spin',i1)") iwan,ms
          Call replacechar(fname,'/','_')
          dos=0.0_t_real
          idos=0.0_t_real
          Call tetdos(dos(:),idos(:)&
               &,p_ebk,e1,e0,bzone % p_tet,nwan,nkp&
               &,bandplot% nptdos,bzone% ntet,bzone% ntetsum&
               &,p_ldos(:,:,iwan),spinfac,0_t_int)
#if defined (DATA_FILES_IN_DIRS)
          Call delete_existing_file(12,fname)
          fname='+wanldos/'//Trim(fname)
#endif
          Open(12,file=Trim(fname))
          Write(12,"('# name: ',a,' spin: ',i1)") Trim(wdef% p_name(iwan)),ms
          Do ie=1,bandplot% nptdos
             e=Real(ie-1,t_real)*de+e0
             Write(12,6)e,dos(ie)!,idos(ie)
          Enddo
          Close(12)
       Enddo
       !!
       !!
       !! output
       !!
    End Do kspinloop
    !!
    Call pfree(p_H)
    Call pfree(p_ewan)
    Call pfree(p_ebk)
    Call pfree(p_ldos)
    Call pfree(idos)
    Call pfree(dos)
    !!
    Write(outfile,104)
    !!
    Return
    !!
6   Format(3(e30.15e3,1x))
103 Format(/,'START calculating wan-LDOS')
104 Format('END   calculating wan-LDOS',/)
    !!
  End Subroutine wannierLDOS
  !!***********************************************************************
  !!TODO: core
  Subroutine create_WF_opendx(nspin,symmetry,structure,lattice,basis&
       &,degree,wdef,wfgrid,have_wforigin,WFc,rel,quant)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Basis),Intent(in)     :: basis
    Type(T_WanDefs),Intent(in)   :: wdef
    Type(T_Grid),Intent(inout)   :: wfgrid
    Type(T_Quant),Intent(in)     :: quant
    Logical(t_log),Intent(in)    :: have_wforigin,rel
    Integer(t_int),Intent(in)    :: degree
    Integer(t_int),Intent(in)    :: nspin
    Complex(t_real),Intent(in)   :: WFc(:,:,0:,:,:)

    !!LOCAL
    Character(*),Parameter::nsubfunc="create_WF_opendx"
    Logical(t_log) :: iscomplex,separatedata
    Integer(t_int) :: iwan,ip,ivr,l,deg,m,icomp,n,maxlen,kap,mms
    Integer(t_int) :: indexa,ii,irs,isb,issb,ms,np,im,imod,counter,jcomp
    Integer        :: lun
    Real(t_real)   :: q(3),texp,f,rsh(3),r,oor,wf,pba(3),wr,wi,ca(3),z,y,phi
    Real(t_real)   :: coefa(0:degree)
    Real(t_real)  :: yl((basis% lmx+1)**2)
    Complex(t_real):: cf,wc,cwf(2,2),cfac
    Complex(t_real):: ss(2,2*(basis% lmx+1),-(basis% lmx+1):(basis% lmx+1))
    Type(T_Mesh),Pointer :: bmesh
    Character(100) :: dataname,fieldname,fname
    Integer(t_int),Parameter :: maxcolors=7_t_int
    Real(t_real)   :: colfac
    Integer(t_int) :: icol
    Real(t_real)   :: colorlist(3,maxcolors)
    Data colorlist(:,1) / 1.0_t_real , 1.0_t_real ,1.0_t_real / !!white
    Data colorlist(:,2) / 0.0_t_real , 1.0_t_real ,0.0_t_real / !!green
    Data colorlist(:,3) / 0.0_t_real , 0.0_t_real ,1.0_t_real / !!blue
    Data colorlist(:,4) / 1.0_t_real , 0.0_t_real ,0.0_t_real / !!red
    Data colorlist(:,5) / 1.0_t_real , 0.0_t_real ,1.0_t_real / !!magenta
    Data colorlist(:,6) / 0.0_t_real , 1.0_t_real ,1.0_t_real / !!cyan
    Data colorlist(:,7) / 1.0_t_real , 1.0_t_real ,0.0_t_real / !!yellow
    !!
    Include "WF_net.f90"
    Include "WF_cfg.f90"
    !!
    separatedata=.True.
    !!
    If(separatedata)Then
#if defined (DATA_FILES_IN_DIRS)
       Call mkdirectory('+wfdata')
#endif
    Endif
    !!
    wfgrid% latticetype=GRID_DIRECT_LATTICE
    !!
    If(.Not. have_wforigin)Then
       wfgrid% origin(1:3)=-0.5_t_real
    Endif
    !!
    Call print_grid_props(outfile,wfgrid)
    Call make_grid(wfgrid,symmetry,structure,xrunsfirst=.True.)
    !!
    !!
    !!
    icomp=1
    !!
    Open(13,file='opendxWF.dx')
    !!
    maxlen=0
    Do iwan=1,wdef% nwan
       maxlen=Max(maxlen,Len_trim(wdef% p_name(iwan),t_int))
    Enddo
    !!
    Write(13,1400) quant% D1o2(1:2,1:2)
    !!
    Write(13,400)  maxlen+8,wdef% nwan*nspin
    Do ms=1,nspin
       Do iwan=1,wdef% nwan
          If(rel) Then
             Write(13,402)Trim(wdef% p_name(iwan))
          else 
             Write(13,401)Trim(wdef% p_name(iwan)),ms
          End If
       Enddo
    Enddo
    Write(13,105)
    !!
    Do ms=1,nspin
       Do iwan=1,wdef% nwan
          counter=iwan+(ms-1)*wdef% nwan          
          ca=0.0_t_real
          If(have_wforigin)Then
             ca=wdef% p_center(:,iwan)
          Endif
          !Print "('ca=',3f12.5)",ca
          !! count atoms to print
          np=0
          Do isb=1,structure% nsite
             Do irs=1,wdef% p_nswfpairs(isb,iwan)
                pba(:)=wdef% p_swfpairs(:,isb,iwan,irs)+ca
                If(is_in_box(wfgrid,pba)) np=np+1
             End Do
          End Do
          !! write atom positions
          Write(13,301)counter,np
          Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             Do irs=1,wdef% p_nswfpairs(isb,iwan)
                pba(:)=wdef% p_swfpairs(:,isb,iwan,irs)+ca
                If(is_in_box(wfgrid,pba)) Write(13,312) pba
             End Do
          End Do
          Write(13,106)
          !!
          !! write atom radii
          Write(13,300)counter,np
          Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             Do irs=1,wdef% p_nswfpairs(isb,iwan)
                pba=wdef% p_swfpairs(:,isb,iwan,irs)+ca
                If(is_in_box(wfgrid,pba)) &
                     & Write(13,311) lattice% p_rsite(issb)
             End Do
          End Do
          Write(13,106)
          !!
          !! write atom colors
          Write(13,303)counter,np
          Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             icol=Mod(issb-1,maxcolors)+1
             colfac=0.3_t_real*(Mod((issb-1)/maxcolors,3_t_int)+1)
             Do irs=1,wdef% p_nswfpairs(isb,iwan)
                pba=wdef% p_swfpairs(:,isb,iwan,irs)+ca
                If(is_in_box(wfgrid,pba)) &
                     & Write(13,312) colorlist(:,icol)*colfac
             End Do
          End Do
          Write(13,106)
       !!
          !! write filed definitions
          Write(13,302)counter,counter,counter,counter,counter
       Enddo!!iwan
    Enddo!!nspin
    !!
    Write(13,309)
    Do ms=1,nspin
       Do iwan=1,wdef% nwan
          counter=iwan+(ms-1)*wdef% nwan
          Write(fieldname,"('atom',i3.3)")counter
          Write(13,205)counter-1,Trim(fieldname),counter
       Enddo
    Enddo

    !!
    !!
    !!
    !!
    !!
    !!
    Write(13,200) wfgrid% n123(1:3),wfgrid% o(1:3)&
         &,wfgrid% delta(1:3,1)&
         &,wfgrid% delta(1:3,2)&
         &,wfgrid% delta(1:3,3)&
         &,wfgrid% n123(1:3)
    !!
    spinloop: Do ms=1,nspin
       iwanloop: Do iwan=1,wdef% nwan
          !!
          counter=iwan+(ms-1)*wdef% nwan
          !!
          iscomplex=.False.
          !!
          If(rel)Then
             Write(outfile,331)counter,nspin*wdef% nwan&
                  &,Trim(wdef% p_name(iwan))
          Else
             Write(outfile,33)counter,nspin*wdef% nwan&
                  &,Trim(wdef% p_name(iwan)),ms
          Endif
33        Format('Creatig ',i4,' out of ',i3,' : WF[',a,' spin ',i1,']')
331       Format('Creatig ',i4,' out of ',i3,' : WF[',a,']')
          !!
          Write(dataname,"('wfdata',i3.3)")counter
          Write(fieldname,"('WF',i3.3)")counter

          fname=dataname
#if defined (DATA_FILES_IN_DIRS)
          Call delete_existing_file(12,fname)
          fname='+wfdata/'//Trim(fname)
#endif

          lun=13
          If(.Not.rel)Then
             If(separatedata)Then
                Write(13,2013) Trim(dataname),wfgrid% npoints,Trim(fname)
                lun=14
                Open(lun,file=Trim(fname))
             Else
                Write(13,201) Trim(dataname),wfgrid% npoints
             Endif
          Else
             If(separatedata)Then
                Write(13,2012) Trim(dataname),wfgrid% npoints,Trim(fname)
                lun=14
                Open(lun,file=Trim(fname))
             Else
                Write(13,2011) Trim(dataname),wfgrid% npoints
             Endif
          Endif
          !!
          !!
          !!
          !!
          !!
          !!
          !!
          ca=0.0_t_real
          If(have_wforigin)Then
             ca=wdef% p_center(:,iwan)
          Endif
          !!
          !!
          !!
          !!
          !!
          n=0
          imod=0
          iploop: Do ip=1,wfgrid% npoints
             !! give feedback
             im=Nint(100.0_t_real*ip/wfgrid% npoints)
             If(Mod(im,10_t_int) == 0_t_int .And. im /= imod)Then
                Write(outfile,5) 100.0_t_real*ip/wfgrid% npoints
                imod=im
             Endif
             q(1:3)=wfgrid%  points(1:3,ip)
             !!
             !!
             wf=0.0_t_real
             cwf=c0
             isbloop: Do isb=1,structure% nsite
                issb=structure% p_isrt(isb)
                !!
                bmesh    => basis% p_basmeshs(issb)
                !!
                irsloop: Do irs=1,wdef% p_nswfpairs(isb,iwan)
                   pba(:)=wdef% p_swfpairs(:,isb,iwan,irs)+ca
                   !!
                   rsh(:)=q(:)-pba(:)
                   r=Max(Sqrt(Sum(rsh**2)),1.0e-16_t_real)
                   If(r==0.0_t_real)Then
                      oor=0.0_t_real
                   Else
                      oor=1.0_t_real/r
                   Endif
                   !!
                   !!
                   !!
                   !! 
                   If(r > basis% p_rtfvmax(icomp,issb)) Cycle irsloop
                   !!
                   indexa=mintpl_coefs(degree,bmesh,r,coefa)
                   texp=r**basis% p_fgam(issb)*oor
                   If(.Not.rel)Then
                      Call ylms12(yl,rsh(1),rsh(2),rsh(3),basis% lmx)
                   Else
                      z=rsh(3)/r
                      y=Sqrt(Max(0.0_t_real,Min(1.0_t_real,1.0_t_real-z*z)))
                      If(y==0.0_t_real)Then
                         phi=0.0_t_real
                      Else
                         phi=Atan2(rsh(2),rsh(1))
                      Endif
                      Call sphsp(basis% lmx,ss,basis% lmx,y,z,phi)
                   Endif
                   !!
                   ii=0
                   ivrloop: Do ivr=1,basis% p_nRv(issb)
                      deg=basis% p_degRv(ivr,issb)
                      If(.Not.rel)Then
                         l=basis% p_lRv(ivr,issb)
                         !!
                         f=Dot_product(&
                              &basis% p_fv(indexa:indexa+degree,ivr,icomp,issb)&
                              &,coefa(0:degree))*texp
                         
                         Do m=1,deg
                            !!
                            !!
                            wr=Real(WFc(ii+m,isb,irs,iwan,ms),t_real)
                            wi=Aimag(WFc(ii+m,isb,irs,iwan,ms))
                            If(Abs(wi)>1.0e-6_t_real)Then
                               iscomplex=.True.
                               !Print *,'isb,irs=',isb,irs,wi
                            Endif
                            wf=wf+f*yl(l*l+m)*wr
                         Enddo
                      Else!! N/SREL
                         Do jcomp=1,basis% ncomp
                            cfac=texp
                            kap=basis% p_kapRv(ivr,issb)
                            If(jcomp==2) Then
                               cfac=ci*texp
                               kap=-kap
                            Endif
                            !!
                            cf=Dot_product(&
                                 &basis% p_fv(indexa:indexa+degree,ivr,jcomp,issb)&
                                 &,coefa(0:degree))*cfac
                         
                            Do m=1,deg
                               !!
                               !!
                               wc=WFc(ii+m,isb,irs,iwan,ms)
                               If(Abs(Aimag(wc))>1.0e-6_t_real)Then
                                  iscomplex=.True.
                               Endif
                               Do mms=1,2
                                  cwf(mms,jcomp)=cwf(mms,jcomp)+cf*ss(mms,m,kap)*wc
                               Enddo
                            Enddo
                         Enddo! jcomp
                      Endif !!FREL
                      ii=ii+deg
                   Enddo ivrloop
                Enddo irsloop
             End Do isbloop
             !!
             !!
             If(.Not.rel)Then
                Write(lun,104,advance='no') wf
                n=n+1
                If(Mod(n,4_t_int)==0)Then
                   Write(lun,105)
                   n=0
                Endif
             Else
                Write(lun,1041,advance='no') cwf(1,1)
                Write(lun,1041,advance='no') cwf(2,1)
                Write(lun,1041,advance='no') cwf(1,2)
                Write(lun,1041,advance='no') cwf(2,2)
                Write(lun,105)
             Endif
             !!
             !!
             !!
          Enddo iploop
          !!
          If(.Not.rel .And. n/=0) Write(lun,105)
          !!
          If(separatedata) Close(lun)
          !!
          Write(13,106)
          
          !!
          Write(13,202)Trim(fieldname),Trim(dataname),Trim(fieldname)
          !!
          !!
          If(iscomplex)Then
             Write(outfile,14) Trim(wdef% p_name(iwan))
             Call errmsg(nmodule,nsubfunc,E_warning&
                  &,msg="' The real space WF coefficients&
                  & are complex?',/,' Reasons unclear!'")
          Endif
          !!
       Enddo iwanloop
    Enddo spinloop
    !!
    !!
    !!
    Write(13,204)
    Do ms=1,nspin
       Do iwan=1,wdef% nwan
          counter=iwan+(ms-1)*wdef% nwan
          Write(fieldname,"('WF',i3.3)")counter
          Write(13,205)counter-1,Trim(fieldname),counter
       Enddo
    Enddo
    !!
    Write(13,203)
    Close(13)
    !!
    Call write_codified(fname_WF_net,WF_net)
    Call write_codified(fname_WF_cfg,WF_cfg)
    !!
    Return
    !!

    !!
14  Format(' WF ',a,' has complex coefficients')
    !!
5   Format('calc at : ',f5.1,'% of point done')
!90  Format(3(f12.6,1x),5x,f12.6,5x,3(f7.3,1x))
    !!
105 Format()
104 Format(e16.8e3,' ')
1041 Format(2(e16.8e3,' '))
200 Format(/ &
         &,'# This is the grid description',/&
         &,'# regular positions.',/&
         &,'object "positions1" class gridpositions counts ',i6,' ',i6,' ',i6,/&
         &,'origin  ',3(f30.15,1x),/&
         &,'delta   ',3(f30.15,' '),/&
         &,'delta   ',3(f30.15,' '),/&
         &,'delta   ',3(f30.15,' '),/&
         &,'attribute "dep" string "positions"',/&
         &,/&
         &,'# This is the regular connections',/&
         &,'object "connections1" class gridconnections counts ',i6,' ',i6,' ',i6,/&
         &,'attribute "element type" string "cubes"',/&
         &,'attribute "ref" string "positions"',/&
         &,'attribute "dep" string "connections"',/&
         &)
201 Format(/&
         &,'# object 3 is the data, which is in a one-to-one correspondence with',/&
         &,'# the positions ("dep" on positions).',/&
         &,'# The data are matched to the positions in the order',/&
         &,'# "last index varies fastest", i.e. (x0, y0, z0), (x0, y0, z1),',/&
         &,'# (x0, y0, z2), (x0, y1, z0), etc.',/&
         &,'object "',a,'" class array type double rank 0 items ',i10,' Data follows')
2013 Format(/&
          &,'# object 3 is the data, which is in a one-to-one correspondence with',/&
          &,'# the positions ("dep" on positions).',/&
          &,'# The data are matched to the positions in the order',/&
          &,'# "last index varies fastest", i.e. (x0, y0, z0), (x0, y0, z1),',/&
          &,'# (x0, y0, z2), (x0, y1, z0), etc.',/&
          &,'object "',a,'" class array type double rank 0 items ',i10&
          &,/,' Data file ',a,',0')
2011 Format(/&
         &,'# object 3 is the data, which is in a one-to-one correspondence with',/&
         &,'# the positions ("dep" on positions).',/&
         &,'# The data are matched to the positions in the order',/&
         &,'# "last index varies fastest", i.e. (x0, y0, z0), (x0, y0, z1),',/&
         &,'# (x0, y0, z2), (x0, y1, z0), etc.',/&
         &,'object "',a,'" class array type double category complex rank 1  shape 4 items ',i10,' Data follows')
2012 Format(/&
         &,'# object 3 is the data, which is in a one-to-one correspondence with',/&
         &,'# the positions ("dep" on positions).',/&
         &,'# The data are matched to the positions in the order',/&
         &,'# "last index varies fastest", i.e. (x0, y0, z0), (x0, y0, z1),',/&
         &,'# (x0, y0, z2), (x0, y1, z0), etc.',/&
         &,'object "',a,'" class array type double category complex rank 1  &
         &shape 4 items ',i10,/,' Data file ',a,',0')
106 Format('attribute "dep" string "positions"',/&
         &,'#',/)
202 Format(/&
         &,'# A field is created with three components: "positions", "connections",',/&
         &,'# and "data"',/&
         &,'object "',a,'" class field ',/&
         &,'component "positions" value "positions1"',/&
         &,'component "connections" value "connections1"',/&
         &,'component "data" value "',a,'"',/&
         &,'attribute "name" string "',a,'"',/)
203 Format('end')
    !!
    !!
!91  Format( 'points = ',i10,/&
!         &,'format = ascii',/&
!         &,'interleaving = field',/&
!         &,'field = locations, radius,color',/&
!         &,'structure = 3-vector, scalar,3-vector',/&
!         &,'type = float, float ,float',/&
!         &,'end')
    !!
    !!
311 Format(e16.8e3)
312 Format(3(e16.8e3,1x))
301 Format('#',/&
         &,'object "atompositions',i3.3,'" class array Type float rank 1 shape 3 &
         &items ',i5,' Data follows')
300 Format('#',/&
         &,'object "dataradius',i3.3,'" class array type float rank 0 items ',i5&
         &,' Data follows')
303 Format(/&
         &,'#',/&
         &,'object "datacolor',i3.3,'" class array type float rank 1 shape 3 i&
         &tems ',i5,' data follows')
302 Format('#',/&
         &,'object "atom',i3.3,'" class field',/&
         &,'component "data" value "dataradius',i3.3,'"',/&
         &,'component "positions" value "atompositions',i3.3,'"',/&
         &,'component "colors" value "datacolor',i3.3,'"',/&
         &,'attribute "name" string "atom',i3.3,'"',/&
         &,'#',/)
    !!
204 Format( &
         &'# Here we create the series of WF-objects',/&
         &,'object "WFseries" class series')
309 Format( &
         &'# Here we create the series of atom-objects',/&
         &,'object "ATOMseries" class series')
205 Format( 'member ',i5,' value "',a,'" position ',i5)
    !!
400 Format('#',/&
         &,'object "WFnames" class array type string rank 1 shape ',i5&
         &,' items    ',i5,' data follows',/&
         &,'#')
1400 Format('#',/&
         &,'object "D1o2" class array type double category complex rank 2 shape 2 2'&
         &,' items   1 data follows',/,2(4(e30.15e3,1x),/)&
         &,'#')
401 Format('"',a,' spin ',i1,'"')
402 Format('"',a,'"')
    !!
  End Subroutine create_WF_opendx
  !!***********************************************************************
  Subroutine newstuff(mspin,symmetry,structure,lattice,basis,kohnsham&
       &,bzone,bandplot,wannier,degree,relativistic,quant)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_Wannier),Intent(inout):: wannier
    Type(T_Quant),Intent(in)     :: quant
    Integer(t_int),Intent(in)    :: mspin,relativistic
    Integer(t_int),Intent(in)    :: degree
    !!LOCAL
    Character(*),Parameter::nsubfunc="newstuff"
    Logical(t_log) :: nothing_to_do,start,rel,warn,binexists,binformat
    Integer(t_int) :: nspin
    Type(T_WANCoeffData) :: wcd
    Type(T_WanCollection) :: wcol
    !!
    Call init_wancol(wcol)
    !!
    !!
    Print *,'newstuff'
    rel=(relativistic == FULL_RELATIVISTIC)
    nspin=mspin
    If(rel)Then
       nspin=1_t_int
    Endif
    !!
    start=.True.
    Do 
       !!
       warn=.False.
       !!
       Call read_wandefs_from_file(nspin,symmetry,structure,basis,wannier% wdef&
            &,wannier% wfgrid,wannier% have_wforigin,wannier% kgrid&
            &,binformat,wannier% do_wanniers,relativistic)
       !!
       Call read_wandef_file(symmetry,structure,wcol,binformat,wannier% do_wanniers)
       !!
       wannier% do_wannier_from_file=wannier% do_wanniers !!TODO:
       !!
       !!
       !!
       !!--------------------
       If(.Not.wannier% do_wanniers) Return
       If(.Not.wannier% do_wannier_from_file) Return
       !!
       If(wcol% nwdesc==0)Then
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="' no active Wannier definitions found!'")
       Endif
       !!
       Call new_prep_swf_lattice(symmetry,structure,wcol&
            !&,lattice% rcut&
            &,wcol% ham_rcut*2&
            &,.False.)!!TODO: make flexible
       Call new_prep_wf_lattice(symmetry,structure,wcol,.False.)
       !!
       If(start) Then 
          If(binformat) Then
             Inquire(file=Trim(f_wancoeff_out_bin),exist=binexists)
          Endif
          Call init_wancoeffdata(wcd)
          If(.Not.binformat.Or.(binformat.And..Not.binexists))Then
             Call read_wancoeffs(nspin,symmetry% lattice_constants,structure&
                  &,kohnsham,bzone,bandplot,wcd,nothing_to_do)
          Endif
          If(binformat)Then
             If(binexists) Then
                Call read_wancoeffs_bin(nspin,structure,kohnsham,bzone,bandplot,wcd&
                     &,nothing_to_do)
             Else If(.Not.nothing_to_do) Then
                Call write_wancoeffs_bin(nspin,structure,kohnsham,bzone,bandplot,wcd)
             Endif
          Endif
       Endif
       !!
       If(nothing_to_do) Then
          Write(errbuf,10) Trim(f_wancoeff_out)
          Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
10        Format("'File ''",a,"'' not found ... will resume normal execution.&
               &',/,' If you like to do Wanniers from file, wait until&
               & files are writen',/,' (after each step) and restart.'") 
          Return
       Endif
       !!
       Call new_make_wan_analysis(nspin,symmetry,structure,basis&
            &,kohnsham,bzone,wcol,wcd,rel)
       !!
       Call new_calc_time_reversal_matel(mspin,symmetry,structure,basis,kohnsham,bzone&
            &,wcd,wcol,rel,warn,50_t_int)
       !!
       Call new_make_wannier_bands(nspin,symmetry,structure,kohnsham&
            !&,basis&
            &,bandplot&
            &,wcol,wcd&
            !&,rel&
            &,warn)
       !!
       Call new_make_wannier_fit(nspin,symmetry,structure,lattice&
            &,basis,degree,kohnsham,bzone&
            &,bandplot,wcd,wcol,rel,warn,quant)
       !!
       Call cleanup_wannier(wannier)
       !!
       If(warn)Then
          Call errmsg(nmodule,nsubfunc,E_warning,msg="'There have been &
               &definitness/SVD warnings, check output.',/&
               &,' Are the energy windows large enough?'")
       Endif
       Write(outfile,"('CTRL_C for abort, enter for next trial')")
       Read(*,*)
       start=.False.
       !!
    Enddo
    !!
    Call cleanup_wancol(wcol)
    !!
    Call cleanup_wancoeffdata(wcd)
    !!
    Call terminate(TERM_FINISH,' wannier band creation ')
    !!
    Return
    !!
  End Subroutine newstuff 
  !!***********************************************************************
  Subroutine new_trans_to_wannier(ms,kohnsham,nvdim,nband,qq,eb,ccts,wcol&
       &,p_ut,warn,io)
    !!
    Implicit None
    !!IO
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_WanCollection),Intent(in) :: wcol
    Logical(t_log),Intent(inout) :: warn
    Integer(t_int),Intent(in)    :: ms,nvdim,nband,io
    Real(t_real),Intent(in)      :: qq(3)
    Real(t_real),Intent(in)      :: eb(nband)
    Complex(t_real),Intent(in)   :: ccts(nband,nvdim)
    Complex(t_real),Intent(out)  :: p_ut(:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="new_trans_to_wannier"
    Integer(t_int) :: i,iwan,jwan,iz,beta,isa,len,ista,in,k,nwan
    Integer(t_int) :: idesc,ieig
    Real(t_real)   :: r(3),qr
    Complex(t_real):: cx,cc
    Real(t_real),Pointer :: p_o(:)
    Real(t_real),Pointer :: p_hewan(:)
    Complex(t_real),Pointer:: p_S(:,:)
    Complex(t_real),Pointer:: p_A(:,:)
    Complex(t_real),Pointer:: p_C(:,:)! todo: remove
    Type(T_WanDescriptor),Pointer:: wdi
    !!
    Nullify(p_A,p_S,p_o,p_hewan,p_C)
    !!
    nwan=wcol% nwan
    !!
    Call palloc('p_S',p_S,1_t_int,nwan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_A',p_A,1_t_int,nwan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_o',p_o,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_hewan',p_hewan,1_t_int,nband,nmodule,nsubfunc)
    Call palloc('p_C',p_C,1_t_int,nband,1_t_int,nvdim*nwan,nmodule,nsubfunc)

    !!
    p_ut=c0
    p_C=c0
    iwan=0
    Do idesc=1,wcol% nwdesc
       wdi=>wcol% p_wdesc(idesc)
       If(.Not.wdi% active) Cycle

       Call det_bindex_in_ewindow(nband,eb&
            &,wdi% emin(ms),wdi% emax(ms)&
            &,wdi% del(ms),wdi% deu(ms)&
            &,wdi% lband(ms)-io+1,wdi% uband(ms)-io+1&
            &,p_hewan,1.0e-4_t_real)
       !!
       !Write(outfile,"('hewan ',20f12.5)")p_hewan(1:nband)
       iz=0
       betaoop: Do beta=1,wdi% ncontrib
          isa=wdi% p_site(beta)
          len=kohnsham% p_vblocklength(isa)
          ista=kohnsham% p_vblockstart(isa)-1
          r=wdi% p_difvec(:,beta)
          qr=Dot_product(qq,r)
          cx=Exp(-ci*qr)
          Do i=1,len
             iz=iz+1
             Do in=1,nband
                cc=p_hewan(in)*ccts(in,ista+i)*cx
                Do ieig=1,wdi% neigen
                   p_ut(in,iwan+ieig)=p_ut(in,iwan+ieig)+cc*wdi% p_Bloc(iz,ieig,ms)
                Enddo
!                p_C(in,iz+nvdim*(iwan))=p_C(in,iz+nvdim*(iwan))+cc
             Enddo
          Enddo
       Enddo betaoop
       !!
       iwan=iwan+wdi% neigen
       !!
    Enddo
    !!
    !!
    Do jwan=1,nwan
       Do iwan=1,nwan
          p_A(jwan,iwan)=&
               &Dot_product(p_ut(1:nband,jwan),p_ut(1:nband,iwan))
       Enddo
    Enddo
    !!
!    Call printmat('Sbig',"('(',f12.8,',',f12.8,')')","('             0             ')"&
!         &,Matmul(Transpose(Conjg(p_C)),p_C),nwan*nvdim,nwan*nvdim,1.0e-5_t_real)
    !!
!    Call printmat('S_trans',"('(',f12.8,',',f12.8,')')","('             0             ')"&
!         &,p_A,nwan,nwan,1.0e-5_t_real)
    
    Call cdiagno_noO(nwan,p_A,p_o)
    !!
    !!
    !!
    Do iwan=1,nwan
       If(p_o(iwan)<=1.0e-12_t_real) Then
          Write(outfile,602) iwan,p_o(iwan),qq
          warn=.True.
          Call errmsg(nmodule,nsubfunc,E_warning&
               &,msg="' the Wannier overlap matrix is&
               & not positive definite?!'")
       Endif
       If(p_o(iwan)<=1.0e-6_t_real) Then
          Write(outfile,602) iwan,p_o(iwan),qq
          warn=.True.
          Call errmsg(nmodule,nsubfunc,E_warning&
               &,msg="' the Wannier overlap matrix is&
               & getting close to singular?!'")
       Endif
    Enddo
    !!
    !Print "('minimum S eigenvalue=',e30.15e3)",Minval(p_o)
    !!
    Do iwan=1,nwan
       Do jwan=1,nwan
          cx=c0
          Do k=1,nwan
             cx=cx+p_A(iwan,k)/Sqrt(p_o(k))*Conjg(p_A(jwan,k))
          Enddo
          p_S(iwan,jwan)=cx
       Enddo
    Enddo
    !!
    !!
    !! orthogonalize the generalized KS states
    !!
    p_ut(:,:)=Matmul(p_ut(:,:),p_S(:,:))
    !!
    !!
    !!
    !! paranoia
    !!
    Do jwan=1,nwan
       Do iwan=1,nwan
          cx=Dot_product(p_ut(1:nband,jwan),p_ut(1:nband,iwan))
          If(iwan==jwan)Then
             If(Abs(cx-c1) > 1.0e-6_t_real) Then
                Write(outfile,600) jwan,iwan,cx
                warn=.True.
                Call errmsg(nmodule,nsubfunc,E_warning&
                     &,msg="' the SVD-transformed wannier basis &
                     &is not orthogonal?!'")
             Endif
          Else
             If(Abs(cx) > 1.0e-6_t_real) Then
                Write(outfile,601) jwan,iwan,cx
                warn=.True.
                Call errmsg(nmodule,nsubfunc,E_warning&
                     &,msg="' the SVD-transformed wannier basis &
                     &is not orthogonal?!'")
             Endif
          Endif
       Enddo
    Enddo
    !!
    !!
    !!
    !!
    !!
    Call pfree(p_S)
    Call pfree(p_C)
    Call pfree(p_A)
    Call pfree(p_o)
    Call pfree(p_hewan)
    !!
    Return
    !!
600 Format(/,' S(',i5,',',i5,')=',2(f12.5,2x),' /= 1')
601 Format(/,' S(',i5,',',i5,')=',2(f12.5,2x),' /= 0')
602 Format(/,' diag(S)(',i5,')=',1(f30.15,2x),' <= 0',/,' k=',3(f15.8,2x))
    !!
  End Subroutine new_trans_to_wannier
  !!***********************************************************************
  Subroutine new_make_wannier_bands(nspin,symmetry&
       &,structure,kohnsham,bandplot,wcol,wcd,warn)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_WANCoeffData),Intent(in)  :: wcd
    Type(T_WanCollection),Intent(in) :: wcol
    Integer(t_int),Intent(in)    :: nspin
    Logical(t_log),Intent(inout) :: warn
    !!LOCAL
    Character(*),Parameter::nsubfunc="new_make_wannier_bands"
    Integer(t_int) :: nsite,nvdim,nkpnts,nwan,ikp,ms,jwan,iwan,in,bnband
    Real(t_real)   :: qq(3),scale,ddd
    Complex(t_real):: cc
    Real(t_real),Pointer    :: p_ewan(:)
    Complex(t_real),Pointer :: p_ut(:,:)
    Complex(t_real),Pointer :: p_H(:,:) 
    !!
    Write(outfile,3)
    !!
    Nullify(p_H,p_ewan,p_ut)
    !!
    scale=twopi/ symmetry% lattice_constants(1)
    !!
    nwan=wcol% nwan
    bnband=wcd% bnband
    nsite=structure% nsite
    nvdim=kohnsham% nvdim
    nkpnts=bandplot% nkpnts
    !!
    Call palloc('p_ewan',p_ewan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_H',p_H,1_t_int,nwan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_ut',p_ut,1_t_int,bnband,1_t_int,nwan,nmodule,nsubfunc)
    !!
    Open(wanbands_unit,file=f_wanbands_out,status='unknown')
    Write(wanbands_unit,120) nsite,wcd% eff,nkpnts,nvdim,nwan,nspin,1,nwan
    !!
    Open(wanbandweights_unit,file=f_wanbweights_out,status='unknown')
    Write(wanbandweights_unit,120)&
         &nsite,wcd% eff,nkpnts,nvdim,nwan,nspin,1,nwan
    Write(wanbandweights_unit,21,advance='no')
    Do iwan=1,nwan
       Write(wanbandweights_unit,23,advance='no') wcol% p_name(iwan)
    Enddo
    Write(wanbandweights_unit,24)
    !!
    ikloop: Do ikp=1,nkpnts
       qq(1:3)=bandplot% p_kpnts(1:3,ikp)
       !!
       Write(wanbands_unit,26)qq
       !!
       spinloop: Do ms=1,nspin
          !!
          !Write(outfile,8800) ms,ikp,qq
!8800      Format('spin= ',i2,/,'kpoint= ',i8,' k= ',3(f15.8,2x))
          !!
          Call new_trans_to_wannier(ms,kohnsham,nvdim,bnband,qq*scale&
               &,wcd% p_beb(:,ikp,ms),wcd% p_bccts(:,:,ikp,ms)&
               &,wcol,p_ut,warn,wcd% bio)
          !!
          !! build up Wannier Hamiltonian
          !!
          p_H=c0
          Do jwan=1,nwan
             Do iwan=1,nwan
                cc=c0
                Do in=1,bnband
                   cc=cc&
                        &+Conjg(p_ut(in,jwan))*wcd% p_beb(in,ikp,ms)&
                        &*p_ut(in,iwan)
                Enddo
                p_H(jwan,iwan)=cc
             Enddo
          Enddo
          !!
          Call cdiagno_noO(nwan,p_H,p_ewan)
          !!
          !!
          Write(wanbands_unit,32,advance='no')bandplot% p_kpnts(4,ikp)
          Do iwan=1,nwan
             Write(wanbands_unit,32,advance='no')p_ewan(iwan)
          Enddo
          Write(wanbands_unit,34)
          !!
          !! form wannier band weights
          !!
          !!
          Do in=1,nwan
             !!
             Write(wanbandweights_unit,30,advance='no')&
                  &bandplot% p_kpnts(4,ikp),p_ewan(in)
                !!
             Do iwan=1,nwan
                ddd=Abs(p_H(iwan,in))**2
                Write(wanbandweights_unit,31,advance='no') ddd
             Enddo
             Write(wanbandweights_unit,24)
          Enddo ! in
          !!
       End Do spinloop
       !!
    End Do ikloop
    !!
    Close(wanbands_unit)
    Close(wanbandweights_unit)
    !!
    Call pfree(p_H)
    Call pfree(p_ewan)
    Call pfree(p_ut)
    !!
    Write(outfile,4)
    !!
    Return
    !!
3  Format(/,'START processing Wannier bands')
4  Format('END   processing Wannier bands',/)
21  Format('#       ik           e(k,n)               ')
23  Format(a17)
24  Format()
26  Format('# ',3f12.7)
30  Format(f16.7,1x,f16.7)
31  Format(1x,f16.7)
32  Format(f16.7,1x)
34  Format(' ')
120 Format('# ',i3,f12.7,6(' ',i8))
    !!
  End Subroutine new_make_wannier_bands 
  !!***********************************************************************
  Subroutine new_calc_time_reversal_matel(mspin,symmetry,structure,basis&
       &,kohnsham,bzone,wcd,wcol,rel,warn,protlevel)
    !!
    !!todo: check for existence of negative k
    !!todo: make switch to include  negative k
    !!todo: make switch for timerepmatel
    !!todo: maybe calculate from the second set
    !!todo: maybe on a different k-mesh?
    !!todo: of request FULLBZ?
    !!
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_WANCoeffData),Intent(in)  :: wcd
    Type(T_WanCollection),Intent(in) :: wcol
    Logical(t_log),Intent(in)    :: rel
    Logical(t_log),Intent(inout) :: warn
    Integer(t_int),Intent(in)    :: mspin,protlevel
    !!LOCAL
    Character(*),Parameter::nsubfunc="new_calc_time_reversal_matel"
    Logical(t_log) :: err,toterr,kperiodic
    Integer(t_int) :: ms,nwan,nkp,subdiv,ikp,ikm,iwan,jwan,ikti,jopsinv,jops
    Real(t_real)   :: qq(3),qqm(3),G(3),gc,scale
    Integer(t_int),Pointer :: p_iminusk(:)
    Complex(t_real):: cdet,cx
    Type(T_TopoIns) :: ti
    Complex(t_real),Pointer:: p_WTWk(:,:,:),p_Hk(:,:,:),p_tmp(:,:)!!todo:remove?
    Complex(t_real),Pointer:: p_WIWk(:,:,:)
    Real(t_real),Parameter :: tol=1.0e-6_t_real
    Real(t_real)   :: ident(3,3)
    Data ident/1.0_t_real,0.0_t_real,0.0_t_real&
         &,0.0_t_real,1.0_t_real,0.0_t_real&
         &,0.0_t_real,0.0_t_real,1.0_t_real/
    !!
    Nullify(p_WTWk,p_WIWk,p_iminusk,p_tmp,p_Hk)
    !!
    Call init_topoins(ti)
    !!
    If(.Not.rel) Then
       Call errmsg(nmodule,nsubfunc,E_warning,&
            &msg="'Relativisitc mode required!'")
       Return
    Endif
    If(mspin /= 1_t_int) Then
       Call errmsg(nmodule,nsubfunc,E_warning,&
            &msg="'Magnetic systems cannot have time reversal symmetry!'")
       Return
    Endif
    !!
    ms=1 !! code only works for FREL nonmag
    kperiodic=.True.
    !!
    jopsinv=0_t_int
    Do jops=1,symmetry% Rnumops
       If(All(Abs(ident+symmetry% Ropmat(:,:,jops))<tol))Then
          jopsinv=jops
          Exit
       Endif
    Enddo

    !!
    nwan=wcol% nwan
    nkp=bzone% nkp
    !!
    Call palloc('p_iminusk',p_iminusk,1_t_int,nkp,nmodule,nsubfunc)
    Call palloc('p_WTWk',p_WTWk,1_t_int,nwan,1_t_int,nwan&
         &,1_t_int,nkp,nmodule,nsubfunc)
    Call palloc('p_WIWk',p_WIWk,1_t_int,nwan,1_t_int,nwan&
         &,1_t_int,nkp,nmodule,nsubfunc)
    Call palloc('p_Hk',p_Hk,1_t_int,nwan,1_t_int,nwan&
         &,1_t_int,nkp,nmodule,nsubfunc)
    Call palloc('p_tmp',p_tmp,1_t_int,nwan,1_t_int,nwan,nmodule,nsubfunc)
    !!
    subdiv=(Max(1_t_int,nkp/(100/5)));
    !!
    scale=twopi/symmetry% lattice_constants(1)
    !!
    Open(12,file='+WTWk')
    Write(12,"('# G1=',3(e30.15e3,1x))") symmetry% reciprocial_lattice_vectors(:,1)
    Write(12,"('# G2=',3(e30.15e3,1x))") symmetry% reciprocial_lattice_vectors(:,2)
    Write(12,"('# G3=',3(e30.15e3,1x))") symmetry% reciprocial_lattice_vectors(:,3)
    kloop: Do ikp=1,nkp
       !!
       If ( Mod(ikp,subdiv) ==0 )Then
          Write(outfile,51) 100.0_t_real*ikp/nkp
       Endif
       !!
       qq(:)=bzone% p_bk(:,ikp)
       ikm=find_k_index(wcol% AA,bzone% nkp,bzone% p_bk,-qq)
       qqm(:)=bzone% p_bk(:,ikm)
       p_iminusk(ikp)=ikm
       !!
       G=qq+qqm
       !!
       !!
       If(protlevel>=100_t_int)Then
          Write(outfile,"(' k(',a,')=',t16,3(f12.5,1x),/,' k(',a,')=',t16,3(f12.5,1x)&
               &,/,' G=',t16,3(f12.5,1x),/)") &
               &Trim(intToChar10(ikp)),Matmul(qq,wcol% AA)/twopi&
               &,Trim(intToChar10(ikm)),Matmul(qqm,wcol% AA)/twopi&
               &,Matmul(G,wcol% AA)/twopi
       Endif
       !!
       Call time_reversal_matel(ms,symmetry,structure,jopsinv,basis,kohnsham,wcol&
            &,wcd% knband,wcd% kio,qq,qqm&
            &,wcd% p_keb(:,ikp,ms),wcd% p_keb(:,ikm,ms)&
            &,wcd% p_kcc(:,:,ikp,ms)&
            &,wcd% p_kccts(:,:,ikp,ms),wcd% p_kccts(:,:,ikm,ms)&
            &,p_WTWk(:,:,ikp),p_WIWk(:,:,ikp),p_Hk(:,:,ikp),kperiodic,warn)
       !!
       If(protlevel>=100_t_int)Then
          Call printmat('WTWk',"('(',f8.3,',',f8.3,')')","('          0        ')"&
               &,p_WTWk(:,:,ikp))
          !!
          If(jopsinv>0)&
               & Call printmat('WIWk',"('(',f8.3,',',f8.3,')')","('          0        ')"&
               &,p_WIWk(:,:,ikp))
       Endif
       !!
       Write(12,"('# k=',3(e30.15e3,1x))")qq
       Write(12,"('# WTWk=')")
       Do iwan=1,nwan
          Do jwan=1,nwan
             Write(12,"(2(e30.15e3,1x))",advance='no')p_WTWk(iwan,jwan,ikp)
          Enddo
          Write(12,"()")
       Enddo
       Write(12,"('# WIWk=')")
       Do iwan=1,nwan
          Do jwan=1,nwan
             Write(12,"(2(e30.15e3,1x))",advance='no')p_WIWk(iwan,jwan,ikp)
          Enddo
          Write(12,"()")
       Enddo
       Write(12,"('# Hk=')")
       Do iwan=1,nwan
          Do jwan=1,nwan
             Write(12,"(2(e30.15e3,1x))",advance='no')p_Hk(iwan,jwan,ikp)
          Enddo
          Write(12,"()")
       Enddo
       If(protlevel>=100_t_int)Then
          cdet=p_WTWk(1,1,ikp)*p_WTWk(2,2,ikp)-p_WTWk(1,2,ikp)*p_WTWk(2,1,ikp)
          Write(outfile,"('det=',f12.5,'+i*',f12.5,' |det|=',f12.5)") cdet,Abs(cdet)

          cdet=p_WIWk(1,1,ikp)*p_WIWk(2,2,ikp)-p_WIWk(1,2,ikp)*p_WIWk(2,1,ikp)
          Write(outfile,"('detI=',f12.5,'+i*',f12.5,' |det|=',f12.5)") cdet,Abs(cdet)
       Endif

    Enddo kloop
    Close(12)
    !!
    !!paranoia
    toterr=.False.
    Do ikp=1,nkp
       ikm=p_iminusk(ikp)
       G=bzone% p_bk(:,ikm)+bzone% p_bk(:,ikp)
       p_tmp=p_WTWk(:,:,ikm)
       If(.Not.kperiodic)Then
          Do iwan=1,nwan
             gc=Dot_product(G,wcol% p_wdesc(wcol% p_inddesc(iwan))% center)
             cx=Exp(ci*gc)
             p_tmp(:,iwan)=p_tmp(:,iwan)*cx
             p_tmp(iwan,:)=Conjg(cx)*p_tmp(iwan,:)
          Enddo
       Endif
       !!
       !!p_tmp=-Matmul(p_tmp,Conjg(p_WTWk(:,:,ikp)))
       p_tmp=p_tmp+Transpose(p_WTWk(:,:,ikp))
       err=.Not.cmattest(p_tmp,c0,c0,1.0e-8_t_real,gc)
       toterr=(toterr.Or.err)
       If(err)Then
          Write(outfile,"(' k(',a,')=',t16,3(f12.5,1x),/,' k(',a,')=',t16,3(f12.5,1x)&
               &,/,' G=',t16,3(f12.5,1x),/)") &
               &Trim(intToChar10(ikp)),Matmul(bzone% p_bk(:,ikp),wcol% AA)/twopi&
               &,Trim(intToChar10(ikm)),Matmul(bzone% p_bk(:,ikm),wcol% AA)/twopi&
               &,Matmul(G,wcol% AA)/twopi
          Call printmat('-1',"('(',f12.5,',',f12.5,')')","('          0        ')"&
               &,p_tmp)
          Write(outfile,"('max error of w(-k)=-w(k)^T: ',e30.15e3)")gc
       Endif
       !!
       p_tmp=Matmul(Transpose(p_WTWk(:,:,ikp)),Conjg(p_WTWk(:,:,ikp)))
       err=.Not.cmattest(p_tmp,c1,c0,1.0e-8_t_real,gc)
       toterr=(toterr.Or.err)
       If(err)Then
          Write(outfile,"(' k(',a,')=',t16,3(f12.5,1x),/,' k(',a,')=',t16,3(f12.5,1x)&
               &,/,' G=',t16,3(f12.5,1x),/)") &
               &Trim(intToChar10(ikp)),Matmul(bzone% p_bk(:,ikp),wcol% AA)/twopi&
               &,Trim(intToChar10(ikm)),Matmul(bzone% p_bk(:,ikm),wcol% AA)/twopi&
               &,Matmul(G,wcol% AA)/twopi
          Call printmat('1',"('(',f12.5,',',f12.5,')')","('          0        ')"&
               &,p_tmp)
          Write(outfile,"('max error of unitarity: ',e30.15e3)")gc
       Endif
       !!
    Enddo
    !!
    If(toterr)Then
       Call errmsg(nmodule,nsubfunc,E_warning,&
            &msg="'Time reversal matrix does not square to -1 !?!'")
    Endif
    !!
    If(jopsinv>0)Then
       toterr=.False.
       Do ikp=1,nkp
          ikm=p_iminusk(ikp)
          G=bzone% p_bk(:,ikm)+bzone% p_bk(:,ikp)
          p_tmp=p_WIWk(:,:,ikm)
          If(.Not.kperiodic)Then
             Do iwan=1,nwan
                gc=Dot_product(G,wcol% p_wdesc(wcol% p_inddesc(iwan))% center)
                cx=Exp(-ci*gc)
                p_tmp(:,iwan)=p_tmp(:,iwan)*cx
                p_tmp(iwan,:)=cx*p_tmp(iwan,:)
             Enddo
          Endif
          !!
          p_tmp=Matmul(p_tmp,p_WIWk(:,:,ikp))
          err=.Not.cmattest(p_tmp,c1,c0,1.0e-8_t_real,gc)
          toterr=(toterr.Or.err)
          If(err)Then
             Write(outfile,"(' k(',a,')=',t16,3(f12.5,1x),/,' k(',a,')=',t16,3(f12.5,1x)&
                  &,/,' G=',t16,3(f12.5,1x),/)") &
                  &Trim(intToChar10(ikp)),Matmul(bzone% p_bk(:,ikp),wcol% AA)/twopi&
                  &,Trim(intToChar10(ikm)),Matmul(bzone% p_bk(:,ikm),wcol% AA)/twopi&
                  &,Matmul(G,wcol% AA)/twopi
             Call printmat('-1',"('(',f12.5,',',f12.5,')')","('          0        ')"&
                  &,p_tmp)
             Write(outfile,"('max error of I(-k)*I(k)=1: ',e30.15e3)")gc
          Endif
          !!
          p_tmp=Matmul(Transpose(p_WIWk(:,:,ikp)),Conjg(p_WIWk(:,:,ikp)))
          err=.Not.cmattest(p_tmp,c1,c0,1.0e-8_t_real,gc)
          toterr=(toterr.Or.err)
          If(err)Then
             Write(outfile,"(' k(',a,')=',t16,3(f12.5,1x),/,' k(',a,')=',t16,3(f12.5,1x)&
                  &,/,' G=',t16,3(f12.5,1x),/)") &
                  &Trim(intToChar10(ikp)),Matmul(bzone% p_bk(:,ikp),wcol% AA)/twopi&
                  &,Trim(intToChar10(ikm)),Matmul(bzone% p_bk(:,ikm),wcol% AA)/twopi&
                  &,Matmul(G,wcol% AA)/twopi
             Call printmat('1(I)',"('(',f12.5,',',f12.5,')')","('          0        ')"&
                  &,p_tmp)
             Write(outfile,"('max error of unitarity: ',e30.15e3)")gc
          Endif
          !!
       Enddo
       !!
       If(toterr)Then
          Call errmsg(nmodule,nsubfunc,E_warning,&
               &msg="'inversion does not square to 1 !?!'")
       Endif
    Endif
    !!
    Call setup_gamma(symmetry,ti,'WFTI')
    !!
    tikloop: Do ikti=1,8
       qq(:)=ti% gammas(:,ikti)
       ikp=find_k_index(wcol% AA,bzone% nkp,bzone% p_bk,qq)
       Write(outfile,"('Gamma[',i1,']=',3(f12.5,1x),' ikp=',i8)")ikti,qq,ikp
       qqm=qq
       ikm=ikp
       G=qq+qqm
       
       Call time_reversal_matel(ms,symmetry,structure,jopsinv,basis,kohnsham,wcol&
            &,wcd% knband,wcd% kio,qq,qqm&
            &,wcd% p_keb(:,ikp,ms),wcd% p_keb(:,ikm,ms)&
            &,wcd% p_kcc(:,:,ikp,ms)&
            &,wcd% p_kccts(:,:,ikp,ms),wcd% p_kccts(:,:,ikm,ms)&
            &,p_WTWk(:,:,ikp),p_WIWk(:,:,ikp),p_Hk(:,:,ikp),kperiodic=.True.,warn=warn)

       Call printmat('WTWk',"('(',f8.3,',',f8.3,')')","('          0        ')"&
                  &,p_WTWk(:,:,ikp))

       If(jopsinv>0)&
            Call printmat('WIWk',"('(',f8.3,',',f8.3,')')","('          0        ')"&
            &,p_WIWk(:,:,ikp))

       cdet=p_WTWk(1,1,ikp)*p_WTWk(2,2,ikp)-p_WTWk(1,2,ikp)*p_WTWk(2,1,ikp)
       Write(outfile,"('det=',f12.5,'+i*',f12.5,' |det|=',f12.5)") cdet,Abs(cdet)

       cdet=p_WIWk(1,1,ikp)*p_WIWk(2,2,ikp)-p_WIWk(1,2,ikp)*p_WIWk(2,1,ikp)
       Write(outfile,"('detI=',f12.5,'+i*',f12.5,' |det|=',f12.5)") cdet,Abs(cdet)

    Enddo tikloop
    !!
    !!todo: The Pfaffian only exists on time reversal points since the 
    !!todo: matrix is only skew symmetric (A^T=-A) on these points.
    !!todo: The main point then is to assure NO branch cut of det(w).
    !!todo: 
    !!
    Call pfree(p_WTWk)
    Call pfree(p_WIWk)
    Call pfree(p_Hk)
    Call pfree(p_iminusk)
    Call pfree(p_tmp)
    !!
    Return
    !!
51  Format('time-reversal matrix elements: ',f5.1,'% done')
    !!
  End Subroutine new_calc_time_reversal_matel
  !!***********************************************************************
  Subroutine time_reversal_matel(ms,symmetry,structure,jopsinv,basis,kohnsham&
       &,wcol,nband,kio,qq,qqm&
       &,eb,ebm,kcc,kccts,kmccts,WTWk,WIWk,Hk,kperiodic,warn)
    !! 
    !! Calc (W^{-k}|\Theta W^k) either in standard phase convention
    !! (kperiodic=.False.), where
    !!       W^k = \sum_{R} \exp{i*k*(R+center_W)}*W_{R,cener(W)}
    !! or in the convention W^{k+G}=W^{k} (kperiodic=.True.), which
    !! includes \exp{-i*k*center(W)} phase factors such that
    !!       W^k = \sum_{R} \exp{i*k* R          }*W_{R,cener(W)}
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in) ::  symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_WanCollection),Intent(in) :: wcol
    !! apply the convention W^{k+G}=W^{k}, which
    !! includes \exp{-i*k*center(W)} phase factors in contrast to our
    !! standard definition
    Logical(t_log),Intent(in)    :: kperiodic
    Logical(t_log),Intent(inout) :: warn
    Integer(t_int),Intent(in)    :: ms,kio,nband,jopsinv
    !! qq is k-vector, qqm is k-vector eqivalent to -k (qq+qqm=G)
    Real(t_real),Intent(in)      :: qq(3),qqm(3)
    !! band energies for +k and -k
    Real(t_real),Intent(in)      :: eb(:),ebm(:)
    !! C for +k and C^{+}*S for +k and -k
    Complex(t_real),Intent(in)   :: kcc(:,:)
    Complex(t_real),Intent(in)   :: kccts(:,:),kmccts(:,:)
    !! output: matrix element 
    Complex(t_real),Intent(out)  :: WTWk(:,:)
    Complex(t_real),Intent(out)  :: WIWk(:,:)
    Complex(t_real),Intent(out)  :: Hk(:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="time_reversal_matel"
    Integer(t_int) :: nwan,iwan,isa,issa,iz,ivr,deg,m,m1,nvdim,jwan,in,izg,isga
    Real(t_real)   :: G(3),gs,skap
    Complex(t_real):: cx,cc,cskap
    Complex(t_real),Pointer :: p_ut(:,:),p_utm(:,:),p_DCUk(:,:),p_SCUkm(:,:)
    !!
    Nullify(p_ut,p_utm,p_DCUk,p_SCUkm)
    !!
    G=qqm+qq
    !!
    nwan=wcol% nwan
    nvdim=kohnsham% nvdim
    !!
    Call palloc('p_ut',p_ut,1_t_int,nband,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_utm',p_utm,1_t_int,nband,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_DCUk',p_DCUk,1_t_int,nvdim,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_SCUkm',p_SCUkm,1_t_int,nvdim,1_t_int,nwan,nmodule,nsubfunc)
    !!
    Call new_trans_to_wannier(ms,kohnsham,nvdim,nband,qq&
         &,eb,kccts,wcol,p_ut,warn,kio)
    !!
    Call new_trans_to_wannier(ms,kohnsham,nvdim,nband,qqm&
         &,ebm,kmccts,wcol,p_utm,warn,kio)
    !!
    !! timerev*(Ck*Uk)^{*}
    Do iwan=1,nwan
       Do isa=1,structure% nsite
          issa=structure% p_isrt(isa)
          iz=kohnsham% p_vblockstart(isa)-1
          gs=Dot_product(G,structure% p_tau(:,isa))
          cx=Exp(-ci*gs)
          Do ivr=1,basis% p_nRv(issa)
             deg=basis% p_degRv(ivr,issa)
             skap=-(-1.0_t_real)**(basis% p_lRv(ivr,issa))
             Do m=1,deg
                skap=-skap
                m1=iz+deg+1-m
                cc=Sum(kcc(1:nband,m1)*p_ut(1:nband,iwan))
                p_DCUk(iz+m,iwan)=cx*Conjg(cc)*skap
             Enddo
             iz=iz+deg
          Enddo
       Enddo
    Enddo
    !!
    !! S*C*U=(C^{+}*S)^{+}*U=kccts(:,i)^{*}*U(:,j)
    Do iwan=1,nwan
       gs=Dot_product(G,wcol% p_wdesc(wcol% p_inddesc(iwan))% center)
       cx=Exp(-ci*gs)
       Do iz=1,nvdim
          p_SCUkm(iz,iwan)=&
               &Dot_product(kmccts(1:nband,iz),p_utm(1:nband,iwan))*cx
       Enddo
    Enddo
    !!
    Do iwan=1,nwan
       Do jwan=1,nwan
          WTWk(iwan,jwan)=Dot_product(p_SCUkm(1:nvdim,iwan),p_DCUk(1:nvdim,jwan))
       Enddo
    Enddo
    !!
    If(jopsinv>0)Then
       !! I*(Ck*Uk)^{*}
       Do iwan=1,nwan
          Do isa=1,structure% nsite
             isga=structure% p_equivsites(jopsinv,isa)
             issa=structure% p_isrt(isa)
             iz=kohnsham% p_vblockstart(isa)-1
             izg=kohnsham% p_vblockstart(isga)-1
             gs=Dot_product(symmetry% Roptau(:,jopsinv),qq)&
                  &-Dot_product(G,structure% p_tau(:,isa))
             cx=Exp(ci*gs)
             Do ivr=1,basis% p_nRv(issa)
                deg=basis% p_degRv(ivr,issa)
                cskap=cx*(-1.0_t_real)**basis% p_lRv(ivr,issa)
                Do m=1,deg
                   cc=Sum(kcc(1:nband,izg+m)*p_ut(1:nband,iwan))
                   p_DCUk(iz+m,iwan)=cc*cskap
                Enddo
                iz=iz+deg
                izg=izg+deg
             Enddo
          Enddo
       Enddo
       !!
       Do iwan=1,nwan
          Do jwan=1,nwan
             WIWk(iwan,jwan)=Dot_product(p_SCUkm(1:nvdim,iwan),p_DCUk(1:nvdim,jwan))
          Enddo
       Enddo
       !!
    Endif
    !!
    Hk=c0
    Do jwan=1,nwan
       Do iwan=1,nwan
          cc=c0
          Do in=1,nband
             cc=cc+Conjg(p_ut(in,jwan))*eb(in)*p_ut(in,iwan)
          Enddo
          Hk(jwan,iwan)=cc
       Enddo
    Enddo
    !!
    If(kperiodic)Then
       Do iwan=1,nwan
          gs=Dot_product(qq,wcol% p_wdesc(wcol% p_inddesc(iwan))% center)
          cx=Exp(ci*gs)
          Hk(:,iwan)=Hk(:,iwan)*cx
          Hk(iwan,:)=Conjg(cx)*Hk(iwan,:)
          WTWk(:,iwan)=WTWk(:,iwan)*cx
          WTWk(iwan,:)=Conjg(cx)*WTWk(iwan,:)
          If(jopsinv>0)Then
             WIWk(:,iwan)=WIWk(:,iwan)*Conjg(cx)
             WIWk(iwan,:)=Conjg(cx)*WIWk(iwan,:)
          Endif
       Enddo
    Endif
    !!
    Call pfree(p_ut)
    Call pfree(p_utm)
    Call pfree(p_DCUk)
    Call pfree(p_SCUkm)
    !!
    Return
    !!
  End Subroutine time_reversal_matel
  !!***********************************************************************
  Subroutine new_make_wan_analysis(nspin,symmetry,structure,basis&
       &,kohnsham,bzone,wcol,wcd,rel)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_WanCollection),Intent(inout) :: wcol
    Type(T_WANCoeffData),Intent(in)  :: wcd
    Logical(t_log),Intent(in)    :: rel
    Integer(t_int),Intent(in)    :: nspin
    !!LOCAL
    Character(*),Parameter::nsubfunc="new_make_wan_analysis"
    Logical(t_log) :: usesymmetry
    Integer(t_int) :: ms,ndesc,nvdim,ikp,nkp,i,j,nband,in,maxdim,idesc
    Integer(t_int) :: dim,beta,isa,len,ista,iz,ieqv,jbeta,jssa
    Integer(t_int) :: jzg,jz,jvr,llj,degj,relfac,mvj,issa,izg,ivr,ll,deg,mv,k
    Integer(t_int) :: icenter,subdiv,cdesc,ieigen,jops,igdesc,gbeta,gjbeta,gieqv
    Integer(t_int) :: isub,is0,is1,myisub,nsub,mynsub
    Integer(t_int) :: insub
    Real(t_real)   :: qq(3),r(3),qr,norm,d,f,myo
    Complex(t_real):: cc,cx
    Complex(t_real),Pointer :: p_V(:,:)
    Complex(t_real),Pointer :: p_SI(:,:,:)
    Complex(t_real),Pointer :: p_Ssym(:,:,:)
    Real(t_real),Pointer :: p_hewan(:)
    Real(t_real),Pointer :: p_o(:)
    Type(T_WanDescriptor),Pointer :: wdcenterrep,wa,wga
    !!
    Nullify(p_Ssym,p_o,p_hewan,p_V,p_SI)
    !!
    usesymmetry=.True.
    relfac=1
    if(rel)relfac=2
    ndesc=wcol% nwdesc
    nvdim=kohnsham% nvdim
    nband=wcd% knband
    nkp=bzone% nkp
    norm=1.0_t_int/Real(symmetry% Rnumops,t_real)
    subdiv=(Max(1_t_int,nkp*wcol% nwan/(100/5)));
    !!
    Call palloc('p_hewan',p_hewan,1_t_int,nband,nmodule,nsubfunc)
    !!
    !!
    !!
    maxdim=0
    Do idesc=1,ndesc
       wa=>wcol% p_wdesc(idesc)
       If(.Not.wa% active) Cycle
       maxdim=Max(maxdim,wandesc_maxorbvdim(wa,kohnsham% p_vblocklength))
    Enddo
    !Print *,'maxdim=',maxdim
    !!
    !!
    !!
    spinloop: Do ms=1,nspin
       !!
       !!
       cdesc=0
       icenterloop: Do icenter=1,wcol% nwcenteridesc
          !!
          wdcenterrep=>wcol% p_wdesc(wcol% p_wcenteridesc(icenter))
          If(.Not.wdcenterrep% active) Cycle
          !!
          dim=wandesc_maxorbvdim(wdcenterrep,kohnsham% p_vblocklength)
          !!
          !!
          !!
          Write(outfile,"('centerrep: ',a,' has ',i5,' sym-eqiv')") &
               &Trim(wdcenterrep% name)&
               &,wdcenterrep% nsymequiv
          !!
          Call palloc('p_SI',p_SI,1_t_int,dim,1_t_int,dim&
               &,1_t_int,wdcenterrep% nsymequiv,nmodule,nsubfunc)
          Call palloc('p_V',p_V,1_t_int,nband,1_t_int,dim,nmodule,nsubfunc)
          Call palloc('p_o',p_o,1_t_int,dim,nmodule,nsubfunc)
          Call palloc('p_Ssym',p_Ssym,1_t_int,dim,1_t_int,dim&
               &,1_t_int,wdcenterrep% nsymequiv,nmodule,nsubfunc)
          !!
          !! determine B-coefficients (p_SI) for all symmetry equivalent
          !! centers
          symequivloop: Do ieqv=1,wdcenterrep% nsymequiv
             idesc=wdcenterrep% symequiv(ieqv)
             cdesc=cdesc+1
             wa=>wcol% p_wdesc(idesc)
             If(.Not.wa% active) Cycle symequivloop
             If(dim/=wandesc_maxorbvdim(wa,kohnsham% p_vblocklength))Then
                Call terminate(TERM_FINISH,'dimensions of symmetry &
                     &related wandescs differs?!')
             Endif
             !!
             p_SI(:,:,ieqv)=c0
             kloop0: Do ikp=1,nkp
                !!
                If ( Mod(ikp,subdiv) ==0 )Then
                   Write(outfile,51) 100.0_t_real*(ikp+(cdesc-1)*nkp)/(nkp*ndesc)
                Endif
                !!
                qq(:)=bzone% p_bk(:,ikp)
                !!
                !!
                !! todo: bandindex logic if lband==0 and/or uband==0
                Call det_bindex_in_ewindow(nband,wcd% p_keb(:,ikp,ms)&
                     &,wa% emin(ms),wa% emax(ms)&
                     &,wa% del(ms),wa% deu(ms)&
                     &,wa% lband(ms)-wcd% kio+1,wa% uband(ms)-wcd% kio+1&
                     &,p_hewan,1.0e-4_t_real)
                !!
                p_V=c0
                iz=0
                Do beta=1,wa% ncontrib
                   isa=wa% p_site(beta)
                   len=kohnsham% p_vblocklength(isa)
                   ista=kohnsham% p_vblockstart(isa)-1
                   r=wa% p_difvec(:,beta)
                   qr=Dot_product(qq,r)
                   cx=Exp(-ci*qr)
                   !Write(outfile,"('beta='i5,'iz0=',i5)"),beta,iz
                   !Write(outfile,"('beta='i5,'iz0=',i5,'phase=',2f30.15)"),beta,iz,cx
                   Do i=1,len
                      iz=iz+1
                      Do in=1,nband
                         p_V(in,iz)=p_V(in,iz)&
                              &+Sqrt(p_hewan(in))*wcd% p_kccts(in,ista+i,ikp,ms)*cx
                      Enddo
                   Enddo
                Enddo
                !!
                p_SI(:,:,ieqv)=p_SI(:,:,ieqv)&
                     &+Matmul(Transpose(Conjg(p_V)),p_V)*bzone% p_wbk(ikp)
                !!
                !!
                !!
             End Do kloop0
             !!
          Enddo symequivloop
          !!
          !!symmetrize and normalize all symmetry equivalent centers
          !!
          symequivloop1: Do ieqv=1,wdcenterrep% nsymequiv
             idesc=wdcenterrep% symequiv(ieqv)
             wa=>wcol% p_wdesc(idesc)
             If(.Not.wa% active) Cycle symequivloop1
             !!
             !! symmetrize 
             !!
             p_Ssym(:,:,ieqv)=c0
             ifusesymmetry: If(usesymmetry)Then
                jopsloop: Do jops=1,symmetry% Rnumops
                   !Write(outfile,85) Trim(symmetry% Ropsymbol(jops))&
                   !     &,Trim(strtimrev(symmetry% Roptimerev(jops)))&
                   !     &,symmetry% Roptau(:,jops)
                   
                   igdesc=wa% equivdesc(jops)
                   wga=>wcol% p_wdesc(igdesc)
                   !!
                   gieqv=-1
                   Do i=1,wdcenterrep% nsymequiv
                      If(wdcenterrep% symequiv(i)==igdesc)Then
                         gieqv=i
                         Exit
                      Endif
                   Enddo
                   !!
                   !!
                   !!
                   jz=0
                   jbetaloop: Do jbeta=1,wa% ncontrib
                      gjbeta=wa% p_equivbeta(jbeta,jops)
                      jssa=structure% p_isrt(wa% p_site(jbeta))
                      jzg=0
                      Do i=1,gjbeta-1
                         jzg=jzg+kohnsham% p_vblocklength(wga% p_site(i))
                      Enddo
                      jvrloop: Do jvr=1,basis% p_nRv(jssa)
                         llj=basis% p_lRv(jvr,jssa)
                         If(basis% p_kapRv(jvr,jssa)>0)Cycle
                         degj=relfac*(2*llj+1)
                         mvjloop:Do mvj=1,degj
                            !!
                            iz=0
                            betaloop: Do beta=1,wa% ncontrib
                               gbeta=wa% p_equivbeta(beta,jops)
                               issa=structure% p_isrt(wa% p_site(beta))
!!$                            Write(outfile,"('V^(',i3,'[',i3,']',')_(',i3,',',i3,')&
!!$                                 &+=V^(',i3,'[',i3,']',')_(',i3,',',i3,')')")&
!!$                                 &idesc,ieqv,jbeta,beta,igdesc,gieqv,gjbeta,gbeta
                               izg=0
                               Do i=1,gbeta-1
                                  izg=izg+kohnsham% p_vblocklength(wga% p_site(i))
                               Enddo
                               ivrloop: Do ivr=1,basis% p_nRv(issa)
                                  ll=basis% p_lRv(ivr,issa)
                                  If(basis% p_kapRv(ivr,issa)>0)Cycle
                                  deg=relfac*(2*ll+1)
                                  mvloop:Do mv=1,deg
                                     !!
                                     cc=c0
                                     Do k=1,deg
                                        cc=cc+Dot_product(&
                                             &symmetry% p_Rwu_tjnl_ks(1:degj,mvj,llj,jops)&
                                             &,p_SI(jzg+1:jzg+degj,izg+k,gieqv))&
                                             &*symmetry% p_Rwu_tjnl_ks(k,mv,ll,jops)
                                     Enddo
                                     If(symmetry% Roptimerev(jops)==1)Then
                                        cc=Conjg(cc)
                                     Endif
!!$                                  Write(outfile,"('p_Ssym(',i4,',',i4,')+=...',/&
!!$                                       &,'M^* p_SI(',a,':',a,',',a,':',a,',gieqv)*D')")&
!!$                                       &jz+mvj,iz+mv&
!!$                                       &,Trim(intToChar10(jzg+1))&
!!$                                       &,Trim(intToChar10(jzg+degj))&
!!$                                       &,Trim(intToChar10(izg+1))&
!!$                                       &,Trim(intToChar10(izg+deg))
!!$                                       
!!$                                  Write(outfile,"('M(',i2,',',i2,')=',100('(',2(f5.2,1x),')'))")&
!!$                                       &mvj,llj,symmetry% p_Rwu_tjnl_ks(1:degj,mvj,llj,jops)
!!$                                  Write(outfile,"('D(',i2,',',i2,')=',100('(',2(f5.2,1x),')'))")&
!!$                                       &mv,ll,symmetry% p_Rwu_tjnl_ks(1:deg,mv,ll,jops)
!!$                                  Write(outfile,*)
                                     p_Ssym(jz+mvj,iz+mv,ieqv)=&
                                          &p_Ssym(jz+mvj,iz+mv,ieqv)+cc*norm
                                     !!
                                  Enddo mvloop
                                  iz=iz+deg
                                  izg=izg+deg
                               Enddo ivrloop
                            Enddo betaloop
                            !!
                         Enddo mvjloop
                         jz=jz+degj
                         jzg=jzg+degj
                      Enddo jvrloop
                   Enddo jbetaloop
                End Do jopsloop
             Else ifusesymmetry
                p_Ssym(:,:,ieqv)=p_SI(:,:,ieqv)
             End If ifusesymmetry
             !!
             !!
             Call palloc('wa% p_Bloc',wa% p_Bloc,1_t_int,dim,1_t_int,wa% neigen&
                  &,1_t_int,nspin,nmodule,nsubfunc)
             !!
!!$             Open(12,file='+S')
!!$             Do i=1,dim
!!$                Do j=1,dim
!!$                   Write(12,"(2(e30.15e3,1x))",advance='no')p_Ssym(i,j)
!!$                Enddo
!!$                Write(12,"()")
!!$             Enddo
!!$             Close(12)
             !!
             Print "(i3,1x,a)",idesc,wa% name
             !If(.False.)Then
             !!
             Call printmat('Ssym',"('(',f8.3,',',f8.3,')')","('          0        ')"&
                  &,p_Ssym(:,:,ieqv),dim,dim,1.0e-5_t_real)
             !!
             Call cdiagno_noO(dim,p_Ssym(:,:,ieqv),p_o)
             !!
             !! sort: largest Ev first
             Do i=1,dim/2
                d=p_o(i)
                p_o(i)=p_o(dim+1-i)
                p_o(dim+1-i)=d
                Do j=1,dim
                   cc=p_Ssym(j,i,ieqv)
                   p_Ssym(j,i,ieqv)=p_Ssym(j,dim+1-i,ieqv)
                   p_Ssym(j,dim+1-i,ieqv)=cc
                   
                Enddo
             Enddo
             !!
             !Write(outfile,"('E=',100(f12.8,1x))")p_o(1:dim)
             !Call printmat('B',"('(',f8.3,',',f8.3,')')","('          0        ')"&
             !     &,p_Ssym(:,:,ieqv),dim,dim,1.0e-5_t_real)
             !!
             !!
             Call find_relevant_subspace(wa,p_o,rel)
             !!
             If(.Not.rel)Then
                !!todo: adapt to the relativistic algo
                Do i=1,dim
                   Call extractPhase(dim,p_Ssym(:,i,ieqv))
                Enddo
             Else
                !!todo: magnetic
                Call maketimerevrep(p_Ssym(:,:,ieqv),dim,wa,structure,basis,50_t_int)
             Endif
             !!
             !!
             !Call printmat('Bafter',"('(',f8.3,',',f8.3,')')","('          0        ')"&
             !     &,p_Ssym(:,:,ieqv),dim,dim,1.0e-5_t_real)
             !!
             !!
             !!
             !Call printmat('Ssym',"('(',f8.3,',',f8.3,')')","('          0        ')"&
             !     &,p_Ssym(:,:,ieqv),dim,dim,1.0e-5_t_real)
             !!
             !!
             !!
          End Do symequivloop1
          !!
          !! todo:  symmetry analysis via user specified irreps -> when transforming into
          !! wandefs
          Call makegroupreps(symmetry,structure,basis,kohnsham,wcol,icenter,p_Ssym,rel&
               &,.False.)
          !Call makegroupreps(symmetry,structure,basis,kohnsham,wcol,icenter,p_Ssym,rel&
          !     &,.True.)
          Call makegroupreps(symmetry,structure,basis,kohnsham,wcol,icenter,p_Ssym,rel&
               &,.False.)
          !!
          symequivloop2:Do ieqv=1,wdcenterrep% nsymequiv
             idesc=wdcenterrep% symequiv(ieqv)
             wa=>wcol% p_wdesc(idesc)
             If(.Not.wa% active) Cycle symequivloop2


             If(rel)Then
                !!todo: make it a mere testing
                Call maketimerevrep(p_Ssym(:,:,ieqv),dim,wa,structure,basis,50_t_int)
             Endif
             !!
             !!
             !!
             !!add some of the equivalent vectors in order to avoid
             !!SVD cases due to missing equivalent irreps
             Do ieigen=1,wa% neigen
                !! find subspaces with equal dimension
                !! todo: we really need to find only such subspaces, which
                !! transform in the same way. But for this we need to sort out
                !! the full symmetry mess first.
                myisub=0
                insub=0
                isubloop: Do isub=1,wa% nsubspaces
                   Do j=wa% p_subspace(1,isub),wa% p_subspace(2,isub)
                      If( j==wa% p_ieigen(ieigen))Then 
                         myisub=isub
                         insub=j
                         Exit isubloop
                      Endif
                   Enddo
                Enddo isubloop
                If(myisub==0)Then
                   call errmsg(nmodule,nsubfunc,E_fatalerror,&
                        &msg="'cannot find subspace for current state?!?'")
                Endif
                wa% p_Bloc(1:dim,ieigen,ms)=p_Ssym(1:dim,insub,ieqv)
                mynsub=wa% p_subspace(2,myisub)-wa% p_subspace(1,myisub)+1
                myo=p_o(insub)
                insub=insub-wa% p_subspace(1,isub)
                Write(outfile,"('mysubspace=',i3,' inmysubspace=',i3)")myisub,insub
                Do isub=1,wa% nsubspaces
                   is0=wa% p_subspace(1,isub)
                   is1=wa% p_subspace(2,isub)
                   nsub=is1-is0+1
                   If(nsub==mynsub)Then
                      !!todo: if all states are sorted such that we have the 
                      !!same basis vector of the irreps this should be enough
                      !!if we exclude inequivalent irreps.
                      f=Exp(-Abs((p_o(insub+is0)-myo)/p_o(1))*4.0_t_real)*p_o(insub+is0)
                      If(insub+is0==wa% p_ieigen(ieigen))Then
                         !f=1.0_t_real
                      Else
                         !f=0.0_t_real
                      Endif
                      wa% p_Bloc(1:dim,ieigen,ms)=wa% p_Bloc(1:dim,ieigen,ms)&
                           &+p_Ssym(1:dim,insub+is0,ieqv)*f
                      Write(outfile,"('adding subs=',i3,' i=',i3,' f=',f12.5)")isub&
                           &,insub+is0,f
                   Endif
                Enddo
                
             Enddo
             !!
             !!
             !!
             Write(outfile,"('EV: ')",advance='no')
             ieigen=0
             Do isub=1,wa% nsubspaces
                Do j=wa% p_subspace(1,isub),wa% p_subspace(2,isub)
                   If(Any(wa% p_ieigen(:)==j))Then
                      ieigen=ieigen+1
                      Write(outfile,"(1x,e27.5e3,'X')",advance='no') p_o(j)
                      !wa% p_Bloc(1:dim,ieigen,ms)=p_Ssym(1:dim,j,ieqv)
                   Else
                      Write(outfile,"(1x,e27.5e3,1x)",advance='no') p_o(j)
                   Endif
                Enddo
             Enddo
             Write(outfile,*)
             !!
             !! todo: need to store the coeffs for symm reps?
             !!
             Do i=1,dim
                Do isub=1,wa% nsubspaces
                   Do j=wa% p_subspace(1,isub),wa% p_subspace(2,isub)
                      If(Any(wa% p_ieigen(:)==j))Then
                         Write(outfile,"('X')",advance='no')
                      Else
                         Write(outfile,"(' ')",advance='no')
                      Endif
                      Write(outfile,"('(',f12.5,',',f12.5,') ')",advance='no')&
                           !&wa% p_Bloc(i,ieigen,ms)&
                           &p_Ssym(i,j,ieqv)
                   Enddo
                Enddo
                Write(outfile,*)
             Enddo
             !!
             Write(outfile,"('Bloc: ')")
             Do i=1,dim
                Do ieigen=1,wa% neigen
                   Write(outfile,"('(',f12.5,',',f12.5,') ')",advance='no')&
                        &wa% p_Bloc(i,ieigen,ms)
                Enddo
                Write(outfile,*)
             Enddo

             !!
          Enddo symequivloop2
          !!
       Enddo icenterloop
       !!
    Enddo spinloop
    !!
    Call pfree(p_SI)
    Call pfree(p_Ssym)
    Call pfree(p_V)
    Call pfree(p_o)
    Call pfree(p_hewan)
    !!
    !Stop
    !!
    Return
    !!
51  Format('integrating orbital character matrix: ',f5.1,'% done')
!85  Format('Symmetrizing operation {',a,a,'|',3(f12.5,1x),'}',30('-'),/)
    !!
!!$  Contains
!!$    !!***********************************************************************
!!$    Subroutine testSsym(wa,structure,basis,Ssym)!!todo remove
!!$      !!
!!$      Implicit None
!!$      !!IO
!!$      Type(T_WanDescriptor),intent(in) :: wa
!!$      Type(T_Structure),Intent(in) :: structure
!!$      Type(T_Basis),Intent(in)     :: basis
!!$      Complex(t_real),Intent(in)   :: Ssym(:,:)
!!$      !!LOCAL
!!$      Character(*),Parameter::nsubfunc="testSsym"
!!$      Integer(t_int) :: beta,iz,isa,issa,ivr,deg,m,dim
!!$      Real(t_real)   :: skap,maxerr
!!$      Complex(t_real),Pointer:: Dtheta(:,:)
!!$      Complex(t_real),Pointer:: tmp(:,:)
!!$      !!
!!$      Nullify(Dtheta,tmp)
!!$      !!
!!$      dim=Size(Ssym,2)
!!$      !!
!!$      Call palloc('Dtheta',Dtheta,1_t_int,dim,1_t_int,dim,nmodule,nsubfunc)
!!$      Call palloc('tmp',tmp,1_t_int,dim,1_t_int,dim,nmodule,nsubfunc)
!!$      
!!$      !! test time reversal
!!$      !!
!!$      Dtheta=c0
!!$      iz=0
!!$      Do beta=1,wa% ncontrib
!!$         isa=wa% p_site(beta)
!!$         issa=structure% p_isrt(isa)
!!$         Do ivr=1,basis% p_nRv(issa)
!!$            deg=basis% p_degRv(ivr,issa)
!!$            skap=-(-1.0_t_real)**(basis% p_lRv(ivr,issa))
!!$            Do m=1,deg
!!$               skap=-skap
!!$               Dtheta(iz+m,iz+deg+1-m)=skap
!!$            Enddo
!!$            iz=iz+deg
!!$         Enddo
!!$      Enddo
!!$      !!
!!$      !Call printmat('Dtheta',"('(',f8.3,',',f8.3,')')","('          0        ')"&
!!$      !     &,Dtheta(:,:),dim,dim,1.0e-5_t_real)
!!$      !!
!!$      tmp=Matmul(Matmul(Transpose(Dtheta),Conjg(Ssym)),Conjg(Dtheta))
!!$      !!
!!$      If(.Not.cmattest(tmp-Ssym,c0,c0,1.0e-12_t_real,maxerr))Then
!!$         Write(outfile,"('maximum error: ',e30.15e3)")maxerr
!!$         Call printmat('zero',"('(',f8.3,',',f8.3,')')","('          0        ')"&
!!$              &,tmp-Ssym,dim,dim,1.0e-5_t_real)
!!$         Call errmsg(nmodule,nsubfunc,E_fatalerror,&
!!$              &msg="'matrix does not transform properly under time reversal?!?'")
!!$      Endif
!!$      Call pfree(tmp)
!!$      Call pfree(Dtheta)
!!$      !!
!!$      Return
!!$      !!
!!$    End Subroutine testSsym
!!$    !!***********************************************************************
!!$    Subroutine testBloc(ms,wa,structure,basis)!!todo remove
!!$      !!
!!$      Implicit None
!!$      !!IO
!!$      Type(T_WanDescriptor),intent(in) :: wa
!!$      Type(T_Structure),Intent(in) :: structure
!!$      Type(T_Basis),Intent(in)     :: basis
!!$      Integer(t_int),Intent(in)    :: ms
!!$      !!LOCAL
!!$      Character(*),Parameter::nsubfunc="testBloc"
!!$      Integer(t_int) :: beta,iz,isa,issa,ivr,deg,m,dim,dimb
!!$      Real(t_real)   :: skap,maxerr
!!$      Complex(t_real):: U0(2,2)
!!$      Complex(t_real),Pointer:: Dtheta(:,:)
!!$      Complex(t_real),Pointer:: tmp(:,:)
!!$      Data U0(1,1)/c0/
!!$      Data U0(2,2)/c0/
!!$      Data U0(1,2)/-c1/
!!$      Data U0(2,1)/c1/
!!$      !!
!!$      Nullify(Dtheta,tmp)
!!$      !!
!!$      dim=Size(wa% p_Bloc,1)
!!$      dimb=wa% neigen
!!$      !!
!!$      Call palloc('Dtheta',Dtheta,1_t_int,dim,1_t_int,dim,nmodule,nsubfunc)
!!$      Call palloc('tmp',tmp,1_t_int,dim,1_t_int,dimb,nmodule,nsubfunc)
!!$      
!!$      !! test time reversal
!!$      !!
!!$      Dtheta=c0
!!$      iz=0
!!$      Do beta=1,wa% ncontrib
!!$         isa=wa% p_site(beta)
!!$         issa=structure% p_isrt(isa)
!!$         Do ivr=1,basis% p_nRv(issa)
!!$            deg=basis% p_degRv(ivr,issa)
!!$            skap=-(-1.0_t_real)**(basis% p_lRv(ivr,issa))
!!$            Do m=1,deg
!!$               skap=-skap
!!$               Dtheta(iz+m,iz+deg+1-m)=skap
!!$            Enddo
!!$            iz=iz+deg
!!$         Enddo
!!$      Enddo
!!$      !!
!!$      !!
!!$      tmp=Matmul(Dtheta,Conjg(wa% p_Bloc(:,:,ms)))
!!$      !!
!!$      Call printmat('U0',"('(',f8.3,',',f8.3,')')","('          0        ')"&
!!$           &,U0)
!!$      !!
!!$      !!
!!$      If(.Not.cmattest(tmp-Matmul(wa% p_Bloc(:,:,ms),U0),c0,c0,1.0e-12_t_real,maxerr))Then
!!$         Write(outfile,"('maximum error: ',e30.15e3)")maxerr
!!$         Call printmat('zero',"('(',f8.3,',',f8.3,')')","('          0        ')"&
!!$              &,tmp-Matmul(wa% p_Bloc(:,:,ms),U0),dim,dimb,1.0e-5_t_real)
!!$         Call errmsg(nmodule,nsubfunc,E_fatalerror,&
!!$              &msg="'matrix does not transform properly under time reversal?!?'")
!!$      Endif
!!$      Call pfree(tmp)
!!$      Call pfree(Dtheta)
!!$      !!
!!$      Return
!!$      !!
!!$    End Subroutine testBloc
!!$    !!***********************************************************************
  End Subroutine new_make_wan_analysis
  !!***********************************************************************
  Subroutine find_relevant_subspace(wa,ev,rel)
    !! Find subspaces from eigenvalues.
    !! This is not definitive, especially for small eigenvalues.
    !! Correct subspaces must be possibly defined later by symmetry
    !! considerations.
    !! For relativistic non-magnegtic calculations there must be Kramers pairs
    !! and hence even dimensional subspaces. This is enforced.
    Implicit None
    !!IO
    Type(T_WanDescriptor),Intent(inout) :: wa
    Logical(t_log),Intent(in)    :: rel
    Real(t_real),Intent(in)      :: ev(:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="find_relevant_subspace"
    Logical(t_log) :: warneven
    Integer(t_int) :: dim,ib,ib1,ib2,edim,i
    Real(t_real)   :: e,d
    Real(t_real),Parameter   :: etol=1.0e-8_t_real
    !!
    dim=Size(ev)
    !!
    wa% nsubspaces=0
    !!
    ib1=1
    ib2=1
    e=ev(1)
    !Print *,'dim=',dim
    warneven=.False.
    Do ib=1,dim
       !Print *,'ib',ib,e,ev(ib)
       d=Abs(e-ev(ib))
       If(Abs(e)>0.0e-8_t_real)Then
          d=d/Abs(e)
       Endif
       !Print *,'d=',d
       If(d<etol)Then
          ib2=ib
          If(ib/=dim) Then
             !Print *,'same e, cycle'
             Cycle
          Endif
       Endif
       !Print *,ib1,ib2
       edim=ib2-ib1+1
       If(rel.And.Mod(edim,2_t_int)/=0)Then!!todo: if relmag, spaces can be odd
          warneven=.True.
          ib2=ib
          If(ib/=dim) Then
             !! enforce even dimensional spaces
             !! the spaces might be wrong though, will see this in 
             !! group analysis
             !Print *,'odd dim, cycle'
             Cycle
          Endif
       Endif
       !!
       !Write(outfile,"('[',i3,',',i3,'] dim=',i3)")ib1,ib2,edim
       !! check if any requested eigenvalues fall into this subspace
       insubspaceloop: Do i=ib1,ib2
          If(.True..Or.Any(wa% p_ieigen(:)==i))Then !! we might need all
             !!
             !Print *,'need this subspace'
             !! save 
             wa% nsubspaces=wa% nsubspaces+1
             Call realloc('wa% p_subspace',wa% p_subspace&
                  &,1_t_int,2_t_int&
                  &,1_t_int,wa% nsubspaces&
                  &,nmodule,nsubfunc)
             
             wa% p_subspace(1,wa% nsubspaces)=ib1
             wa% p_subspace(2,wa% nsubspaces)=ib2
             Exit insubspaceloop
          Endif
       Enddo insubspaceloop
       !!
       e=ev(ib)
       ib1=ib
       ib2=ib
       !!
    Enddo
    !!
    Do i=1,wa% nsubspaces
       Write(outfile,"('subspace: ',i5,i5)") wa% p_subspace(:,i)
    Enddo
    !!
    If(.False..And.warneven)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,&
            &msg="'degenerate sub-spaces are not even dimensional?'")
    Endif
    !!
    Return
    !!
  End Subroutine find_relevant_subspace
  !!***********************************************************************
  Subroutine makegroupreps(symmetry,structure,basis,kohnsham,wcol,icenter,DD,rel&
       &,makereps)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_WanCollection),Intent(inout) :: wcol
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Basis),Intent(in)     :: basis
    Logical(t_log),Intent(in)    :: rel,makereps
    Integer(t_int),Intent(in)    :: icenter
    Complex(t_real),Intent(inout):: DD(:,:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="makegroupreps"
    Logical(t_log) :: subspaceerror,isInversion
    Integer(t_int) :: jops,ieqv,idesc,igdesc,ibeta,igbeta,iz,isa,issa,ivr
    Integer(t_int) :: ll,deg,relfac,dim,i,j,gieqv,len,izg,is,nsub,nsubmax
    Integer(t_int) :: isub,is0,is1,nsymop
    Real(t_real)   :: mI(3,3)
    Complex(t_real):: A(2,2),char! todo:remove
    Complex(t_real),Pointer:: gB(:,:),DB(:,:,:,:,:),EB(:,:,:,:),DS(:,:)
    Type(T_WanDescriptor),Pointer :: wdcenterrep,wa,wga
    Data mI /&
         &-1.0_t_real, 0.0_t_real, 0.0_t_real,&
         & 0.0_t_real,-1.0_t_real, 0.0_t_real,&
         & 0.0_t_real, 0.0_t_real,-1.0_t_real&
         &/
    !!
    Nullify(gB,DB,EB,DS)
    !!
    !! D B^{I*}_{beta}=B^{gI}_{gbeta} U_{JI}
    !!
    dim=Size(DD,1)
    !!
    !!
    relfac=1
    if(rel)relfac=2
    !!
    !! here we start with the wandesc sort wdcenterrep and go through all equivalent
    !! centers
    !!
    wdcenterrep=>wcol% p_wdesc(wcol% p_wcenteridesc(icenter))
    wdcenterrep=>wcol% p_wdesc(wcol% p_wcenteridesc(icenter))
    If(.Not.wdcenterrep% active) return
    !!
    Write(outfile,"('Wandesc center ',i5,1x,a,' at ',3(f12.5,1x))") &
         &icenter,Trim(wdcenterrep% name),wdcenterrep% center
    !!
    Do ieqv=2,wdcenterrep% nsymequiv
       idesc=wdcenterrep% symequiv(ieqv)
       wa=>wcol% p_wdesc(idesc) !! the actual wandesc
       If(.Not.wa% active) Cycle
       subspaceerror=.False.
       If(wdcenterrep% nsubspaces == wa% nsubspaces)Then
          Do is=1,wa% nsubspaces
             subspaceerror=subspaceerror.Or.&
                  &Any(wa% p_subspace(:,is)/=wdcenterrep% p_subspace(:,is))
          Enddo
       Else
          subspaceerror=.True.
       Endif
       If(subspaceerror)Then
          Write(errbuf,"('''Wandesc center ',i5,1x,a,' at ',3(f12.5,1x),''',/,'''&
               &,' wandesc ',i5,1x,a,' at ',3(f12.5,1x),'has different subspaces than'&
               &,''',/,''',' wandesc ',i5,1x,a,' at ',3(f12.5,1x)&
               &,'? proper neigen defined?'&
               &,'''')") &
               &icenter,Trim(wdcenterrep% name),wdcenterrep% center&
               &,idesc,Trim(wa% name),wa% center&
               &,wdcenterrep% symequiv(1),Trim(wdcenterrep% name),wdcenterrep% center
          Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
       Endif
    Enddo
    !!
    nsubmax=0
    Do is=1,wdcenterrep% nsubspaces
       nsubmax=Max(nsubmax,wdcenterrep% p_subspace(2,is)-wdcenterrep% p_subspace(1,is)+1)
    Enddo
    !!
    !!
    !!
    Call palloc('gB',gB,1_t_int,dim,1_t_int,nsubmax,nmodule,nsubfunc)
    Call palloc('DB',DB,1_t_int,nsubmax,1_t_int,nsubmax,1_t_int,wdcenterrep% nsubspaces&
         &,1_t_int,wcol% nwdesc,1_t_int,symmetry% Rnumops,nmodule,nsubfunc)
    Call palloc('EB',EB,1_t_int,nsubmax,1_t_int,wdcenterrep% nsubspaces&
         &,1_t_int,wcol% nwdesc,1_t_int,symmetry% Rnumops,nmodule,nsubfunc)
    !!
    !!
    jopsloop: Do jops=1,symmetry% Rnumops
       !!
!!$       If(symmetry% Ropsymbol(jops)/="I" &
!!$            &.And. symmetry% Ropsymbol(jops)/="s(z)" &
!!$            &) Cycle jopsloop
       Write(outfile,85) Trim(symmetry% Ropsymbol(jops))&
            &,Trim(strtimrev(symmetry% Roptimerev(jops)))&
            &,symmetry% Roptau(:,jops)
       !!
       ieqvloop: Do ieqv=1,wdcenterrep% nsymequiv
          idesc=wdcenterrep% symequiv(ieqv)
          wa=>wcol% p_wdesc(idesc) !! the actual wandesc
          If(.Not.wa% active) Cycle ieqvloop

          Write(outfile,"('wandesc ',a,' at ',3(f12.5,1x))") wa% name,wa% center
          
          igdesc=wa% equivdesc(jops)
          wga=>wcol% p_wdesc(igdesc) !! sym-equiv wandesc
          
          gieqv=-1
          Do i=1,wdcenterrep% nsymequiv
             If(wdcenterrep% symequiv(i)==igdesc)Then
                gieqv=i
                Exit
             Endif
          Enddo


          Write(outfile,"('becomes ',a,' at ',3(f12.5,1x))") wga% name,wga% center
          
          Do ibeta=1,wa% ncontrib
             igbeta=wa% p_equivbeta(ibeta,jops)
             Write(outfile,"('   beta=',i5,' gbeta=',i5)") ibeta,igbeta
          Enddo

          !! D*B^{I*}_{beta n}

          DB(:,:,:,idesc,jops)=c0

          subspaceloop: Do isub=1,wa% nsubspaces

             is0=wa% p_subspace(1,isub)
             is1=wa% p_subspace(2,isub)
             nsub=is1-is0+1

             iz=0
             Do ibeta=1,wa% ncontrib
                isa=wa% p_site(ibeta)
                issa=structure% p_isrt(isa)
                Do ivr=1,basis% p_nRv(issa)
                   ll=basis% p_lRv(ivr,issa)
                   If(basis% p_kapRv(ivr,issa)>0)Cycle
                   deg=relfac*(2*ll+1)
                   
                   Do i=is0,is1
                      If(symmetry% Roptimerev(jops)==1)Then
                         gB(iz+1:iz+deg,i-is0+1)=&
                              &Matmul(symmetry% p_Rwu_tjnl_ks(1:deg,1:deg,ll,jops)&
                              &,Conjg(DD(iz+1:iz+deg,i,ieqv)))
                      Else
                         gB(iz+1:iz+deg,i-is0+1)=&
                              &Matmul(symmetry% p_Rwu_tjnl_ks(1:deg,1:deg,ll,jops)&
                              &,DD(iz+1:iz+deg,i,ieqv))
                      Endif
                   Enddo
                   iz=iz+deg
                Enddo
             Enddo
             
             !Call printmat('D',"('(',f8.3,',',f8.3,')')","('          0        ')"&
             !     &,DD(:,:,ieqv),dim,dim,1.0e-5_t_real)
             
             !Call printmat('gD',"('(',f8.3,',',f8.3,')')","('          0        ')"&
             !     &,gB(:,1:nsub),dim,nsub,1.0e-5_t_real)
             
             iz=0
             Do ibeta=1,wa% ncontrib
                isa=wa% p_site(ibeta)
                igbeta=wa% p_equivbeta(ibeta,jops)
                len=kohnsham% p_vblocklength(isa)
                !!
                izg=0
                Do i=1,igbeta-1
                   izg=izg+kohnsham% p_vblocklength(wga% p_site(i))
                Enddo
                !!
                Do j=1,nsub
                   Do i=1,nsub
                      DB(j,i,isub,idesc,jops)=DB(j,i,isub,idesc,jops)&
                           &+Dot_product(DD(izg+1:izg+len,j+is0-1,gieqv)&
                           &            ,gB(iz+1:iz+len,i))
                   Enddo
                Enddo
                !!
                iz=iz+len
             Enddo
             
          End Do subspaceloop
          
       Enddo ieqvloop
       !!
    End Do jopsloop
    !!
    !!
    Do jops=1,symmetry% Rnumops
       !!
       If(symmetry% Ropsymbol(jops)/="I".And.&
            &symmetry% Ropsymbol(jops)/="E".And.&
            &symmetry% Ropsymbol(jops)/="s(z)") Cycle
       !!
       isInversion=All(Abs(symmetry% Ropmat(:,:,jops)-mI)<1.0e-6_t_real)
       !! g*B^I=B^Ig *DB
       !!
       Do ieqv=1,wdcenterrep% nsymequiv
          idesc=wdcenterrep% symequiv(ieqv)
          wa=>wcol% p_wdesc(idesc) !! the actual wandesc
          If(.Not.wa% active) Cycle
          igdesc=wa% equivdesc(jops)
          !!
          gieqv=-1
          Do i=1,wdcenterrep% nsymequiv
             If(wdcenterrep% symequiv(i)==igdesc)Then
                gieqv=i
                Exit
             Endif
          Enddo
          !!
          Do isub=1,wa% nsubspaces
             !!
             is0=wa% p_subspace(1,isub)
             is1=wa% p_subspace(2,isub)
             nsub=is1-is0+1
             !!
             Write(outfile,"('{',a,a,'|',3(f12.5,1x),'}*B^{',i5,',',i5,'}=B^{',i5,',',i5,'}*')") &
                  &Trim(symmetry% Ropsymbol(jops))&
                  &,Trim(strtimrev(symmetry% Roptimerev(jops)))&
                  &,symmetry% Roptau(:,jops),idesc,isub,igdesc,isub
             
             Call printmat('U',"('(',f12.5,',',f12.5,')')"&
                  &,"('             0             ')"&
                  &,DB(1:nsub,1:nsub,isub,idesc,jops),nsub,nsub,1.0e-5_t_real)

             !!
             If(idesc<igdesc .And. isInversion)Then
                Print *,' dd(',igdesc,')*D(',idesc,')'
                DD(:,is0:is1,gieqv)=Matmul(DD(:,is0:is1,gieqv)&
                     &                    ,DB(1:nsub,1:nsub,isub,idesc,jops))
             Endif
             !!

          End Do
          
          
       Enddo
       
    Enddo

    !!
    If(makereps)Then
       !!
       !! g*B^I=B^Ig *DB
       !!
       Call palloc('DS',DS,1_t_int,dim,1_t_int,nsubmax,nmodule,nsubfunc)
       !!
       ieqvloop2: Do ieqv=1,wdcenterrep% nsymequiv
          idesc=wdcenterrep% symequiv(ieqv)
          wa=>wcol% p_wdesc(idesc) !! the actual wandesc
          If(.Not.wa% active) Cycle
          Print *,'ieqv,idesc ',ieqv,idesc
          isubloop: Do isub=1,wa% nsubspaces
             !!
             is0=wa% p_subspace(1,isub)
             is1=wa% p_subspace(2,isub)
             nsub=is1-is0+1

             A=c0
             DS=c0
             nsymop=0
             jopsloop2: Do jops=1,symmetry% Rnumops
                !!
                If(symmetry% Ropsymbol(jops)=="I") Cycle
                If(symmetry% Ropsymbol(jops)/="E" .And. &
                     &symmetry% Ropsymbol(jops)/="s(z)") Cycle
                !Print *,Trim(symmetry% Ropsymbol(jops))
                !!
                char=c1
                If(symmetry% Ropsymbol(jops)=="s(z)")  char=ci

                igdesc=wa% equivdesc(jops)
                !Print *,'igdesc ',igdesc
                If(igdesc/=idesc) Cycle
                !! only onsite symmetries are considered
                !!
                nsymop=nsymop+1
                !!
                Write(outfile,"('Op ',a,a,' leaves wandesc ',i5,' on the same site')")&
                     & Trim(symmetry% Ropsymbol(jops))&
                     &,Trim(strtimrev(symmetry% Roptimerev(jops))),idesc
                !!
                DS(:,1:is1-is0+1)=DS(:,1:is1-is0+1)&
                     &+DD(:,is0:is1,ieqv)*DB(1:nsub,1:nsub,isub,idesc,jops)*char
                A=A+DB(1:nsub,1:nsub,isub,idesc,jops)*char
                !!
             End Do jopsloop2
             DD(:,is0:is1,ieqv)=DS(:,1:is1-is0+1)/nsymop
             A=A/nsymop
             Call printmat('A',"('(',f12.5,',',f12.5,')')"&
                  &,"('             0             ')"&
                  &,A)

          Enddo isubloop
       Enddo ieqvloop2
          
    Endif

    !!
    Call pfree(DS)
    Call pfree(gB)
    Call pfree(DB)
    Call pfree(EB)
    !!
    Return
    !!
85  Format('Get reps for symmetry  operation {',a,a,'|',3(f12.5,1x),'}',30('-'),/)
    !!
  End Subroutine makegroupreps
  !!***********************************************************************
  Subroutine maketimerevrep(DD,dim,wa,structure,basis,protlevel)
    !!
    !! Given all eigenvectors, make them standardized timerev reps up to
    !! maximum needed eigenvalue, including  all states to complete degenerate
    !! subspaces.
    !! It is assumed that the states are ordered in subspaces.
    Implicit None
    !!IO
    Type(T_WanDescriptor),Intent(in) :: wa
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Integer(t_int),Intent(in)    :: dim,protlevel
    Complex(t_real),Intent(inout):: DD(:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="maketimerevrep"
    Logical(t_log) :: err
    Integer(t_int) :: i,k,j,ifound,Neigenmax
    Real(t_real)   :: d,dmax,maxerr,tol
    Complex(t_real):: c
    Real(t_real),Parameter   :: orthotol=1.0e-8_t_real
    Complex(t_real),Pointer:: vv(:),ww(:),DDsave(:,:)
    !!
    Nullify(vv,ww,DDsave)
    !!
    Call palloc('DDsave',DDsave,1_t_int,dim,1_t_int,dim,nmodule,nsubfunc)
    Call palloc('vv',vv,1_t_int,dim,nmodule,nsubfunc)
    Call palloc('ww',ww,1_t_int,dim,nmodule,nsubfunc)
    !!
    DDsave=DD
    !!
    !Neigenmax=Maxval(wa% p_ieigen)
    Neigenmax=Size(DD,2)
    !!
    i=1
    iloop: Do
       !!
       If(i>Neigenmax)Exit iloop
       !!
       If(i>dim) Call errmsg(nmodule,nsubfunc,E_fatalerror,&
            &msg="'max neigen too big?'")
       !!
       Call extractPhase(dim,DD(:,i))
       !! v=\Theta * DD_i
       Call timerevonB(DD(:,i),vv,wa,structure,basis)
       !!
       c=Dot_product(vv,DD(:,i))
       vv=vv-DD(:,i)*c
       If(protlevel==100_t_int)&
            & Write(outfile,"('(v(',i5,')|T*v(',i5,'))=',f30.15,'+i',f30.15)")&
            & i,i,Dot_product(DD(:,i),vv)
       !!
       !!
       !! search for a linearly dependend vector, assume that the maximum subspace
       !! is 4-dimensional
       !!
       !! find vector with maximum overlap
       ifound=-1
       dmax=0.0_t_real
       If(protlevel==100)Write(outfile,"(2(/),'find largets overlap')") 
       kloop1: Do k=i+1,Min(i+3,dim)
          ww=DD(:,k)
          d=Abs(Dot_product(vv,ww))
          If(protlevel==100)Write(outfile,"(t10,'<',i5,'|T>=',f30.15,'+i*',f30.15)") k,d
          If(d>dmax)Then
             ifound=k
             dmax=d
          Endif
       Enddo kloop1
       !!
       If(ifound<0)Call errmsg(nmodule,nsubfunc,E_fatalerror,&
            &msg="'cannot find Kramers related state in maximal 4-dim subspace?'")
       !!
       If(protlevel==100)&
            &Write(outfile,"('largest overlap with D(',i3,') is ',f12.5)") ifound,dmax
       !!
       !!
       !!
       If(ifound/=i+1)Then
          DD(:,ifound)=DD(:,i+1)
       Endif
       DD(:,i+1)=vv
       !!
       kloop2: Do k=i+2,Min(i+3,dim)
          ww=DD(:,k)
          Do j=i+1,k-1
             c=Dot_product(DD(:,j),DD(:,k))
             ww=ww-DD(:,j)*c
          Enddo
          d=Sqrt(Real(Dot_product(ww,ww),t_real))
          If(d>orthotol)Then
             ww=ww/d
          Else
             Stop 'ww=0'
          Endif
          DD(:,k)=ww
       Enddo kloop2
       !!
       !!
       i=i+2
       !!
       !!
       !!
    Enddo iloop
    !!
    !!
    !!
    !! test stuff
    !!
    !! DD=DDsave*U U->DDsave
    DDsave=Matmul(Transpose(Conjg(DDsave)),DD)
    !!
    !!
    tol=1.0e-10_t_real
    err=.False.
    maxerr=0.0_t_real
    Do i=1,dim
       Do j=1,dim
          c=Dot_product(DDsave(:,i),DDsave(:,j))
          d=Abs(c-c1)
          If(i==j .And. d>tol)Then
             maxerr=Max(maxerr,d)
             err=.True.
             If(protlevel==100)Write(outfile,"(i5,i5,f30.15)")i,j,d
          Endif
          d=Abs(c)
          If(i/=j .And. d>tol)Then
             maxerr=Max(maxerr,d)
             err=.True.
             If(protlevel==100)Write(outfile,"(i5,i5,f30.15)")i,j,d
          Endif
       Enddo
    Enddo
    !!
    If(err)Then
       Write(errbuf,"(""'timereversal matrix states not unitary? maxerr="",e30.15e3&
            &,""'"")")maxerr
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
    Endif

    err=.False.
    maxerr=0.0_t_real
    Do i=1,dim
       Do j=1,dim
          c=Dot_product(DD(:,i),DD(:,j))
          d=Abs(c-c1)
          If(i==j .And. d>tol)Then
             maxerr=Max(maxerr,d)
             err=.True.
             If(protlevel==100)Write(outfile,"(i5,i5,f30.15)")i,j,d
          Endif
          d=Abs(c)
          If(i/=j .And. d>tol)Then
             maxerr=Max(maxerr,d)
             err=.True.
             If(protlevel==100)Write(outfile,"(i5,i5,f30.15)")i,j,d
          Endif
       Enddo
    Enddo
    !!
    If(err)Then
       Write(errbuf,"(""'timereversal sorted states not unitary? maxerr="",e30.15e3&
            &,""'"")")maxerr
       Call errmsg(nmodule,nsubfunc,E_warning,msg=errbuf)
    Endif
    !!
    Do i=1,dim
       Call timerevonB(DD(:,i),DDsave(:,i),wa,structure,basis)
    Enddo
    !! Theta*DD=DDsave=DD*U0
    DDsave=Matmul(Transpose(Conjg(DD)),DDsave)
    !!
    !Call printmat('U0',"('(',f8.3,',',f8.3,')')","('          0        ')"&
    !     &,DDsave(:,:),dim,dim,1.0e-5_t_real)
    !!
    !!
    Call pfree(DDsave)
    Call pfree(vv)
    Call pfree(ww)
    !!
    !!
    Return
    !!
  End Subroutine maketimerevrep
  !!***********************************************************************
  Subroutine extractPhase(dim,D)
    !!
    !! extract common complex phase factor, try to make real
    !!
    Implicit None
    !!IO
    Integer(t_int),Intent(in)    :: dim
    Complex(t_real),Intent(inout):: D(:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="extractPhase"
    Integer(t_int) :: imax,i
    Real(t_real)   :: amax,ab
    Complex(t_real):: ephi
    !!
    !Write(outfile,"('dim=',i6,' size(D)=',i6)") dim,Size(D)
    !! find largest element
    imax=0
    amax=0.0_t_real
    Do i=1,dim
       ab=Abs(D(i))
       If(ab>amax)Then
          imax=i
          amax=ab
       Endif
    Enddo
    If(imax==0)Then !!protect
       imax=1
       amax=1.0_t_real
    Endif
    !Do i=1,dim
    !   Write(outfile,"('D=',4('(',f12.5,',',f12.5,')'))")D(i)
    !Enddo
    !Write(outfile,"('imax=',i6,' amax=',f30.15)")imax,amax
    !!
    ephi=Conjg(D(imax)/amax)
    D(1:dim)=D(1:dim)*ephi
    !!
    !Do i=1,dim
    !   Write(outfile,"('dephased D=',4('(',f12.5,',',f12.5,')'))")D(i)
    !Enddo
    !!
    !!
    !!
    Return
    !!
  End Subroutine extractPhase
  !!***********************************************************************
  Subroutine timerevonB(D,res,wa,structure,basis)
    !!
    !!
    !! return the time reversal of vector D in res
    !! D is supposed to be the localizer B in the automatic scheme
    !!
    Implicit None
    !!IO
    Type(T_WanDescriptor),Intent(in) :: wa
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Complex(t_real),Intent(in)   :: D(:)
    Complex(t_real),Intent(out)  :: res(:)
    !!LOCAL
    !Character(*),Parameter::nsubfunc="timerevonB"
    Integer(t_int) :: iz,beta,isa,issa,ivr,deg,m
    Real(t_real)   :: skap
    !!
    !!
    iz=0
    Do beta=1,wa% ncontrib
       isa=wa% p_site(beta)
       issa=structure% p_isrt(isa)
       Do ivr=1,basis% p_nRv(issa)
          deg=basis% p_degRv(ivr,issa)
          skap=-(-1.0_t_real)**(basis% p_lRv(ivr,issa))
          !Print "('site=',i5,' ivr=',i5,' kap=',i5,' deg=',i5)"&
          !     &,isa,ivr,basis% p_kapRv(ivr,issa),deg
          Do m=1,deg
             skap=-skap
             !Write(outfile,"('res(',i1,')=D*(',i2,' nu=(',i2,'))*',f12.5)")iz+m,iz+deg+1-m&
             !     &,2*m-deg-1,skap
             res(iz+m)=Conjg(D(iz+deg+1-m))*skap
          Enddo
          iz=iz+deg
       Enddo
    Enddo
    !!
    Return
    !!
  End Subroutine timerevonB
  !!***********************************************************************
  Subroutine new_print_WF_coeffs(nspin,structure,basis,wcol,WFc,rel)
    !!
    Implicit None
    !!IO
    Type(T_Structure),Intent(in) :: structure
    Type(T_Basis),Intent(in)     :: basis
    Type(T_WanCollection),Intent(in)   :: wcol
    Logical(t_log),Intent(in)    :: rel
    Integer(t_int),Intent(in)    :: nspin
    Complex(t_real),Intent(in)   :: WFc(:,:,0:,:,:)
    !!LOCAL
    Character(*),Parameter::nsubfunc="new_print_WF_coeffs"
    Logical(t_log) :: iscomplex,to_print,to_print_shell,to_print_pair
    Integer(t_int) :: ms,iwan,isb,issb,irs,ii,ivr,deg,m,ll,jj,ide
    Real(t_real)   :: p(3),pabs,wr,wi,itol
    Character(200) :: fname
    !!
    itol=1.0e-6_t_real
    !!
    fname='+WF_coefficients'
    Write(outfile,10)Trim(fname)
    !!
    Open(12,file=fname)
    spinloop: Do ms=1,nspin
       !!
       Write(12,99) ms
       !!
       iwanloop: Do iwan=1,wcol% nwan
          !!
          ide=wcol% p_inddesc(iwan)
          iscomplex=.False.
          !!
          !!
          !!
          !!
          !!
          !!
          isbloop: Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             !!
             to_print_shell=.False.
             irsloop1: Do irs=1,wcol% p_nswfpairs(isb,ide)
                !!
                p(:)=wcol% p_swfpairs(:,isb,ide,irs)
                pabs=Sqrt(Dot_product(p,p))
                !!
                !!
                ii=0
                ivrloop1: Do ivr=1,basis% p_nRv(issb)
                   deg=basis% p_degRv(ivr,issb)
                   !!
                   Do m=1,deg
                      wr=Real(WFc(ii+m,isb,irs,iwan,ms),t_real)
                      wi=Aimag(WFc(ii+m,isb,irs,iwan,ms))
                      If(Abs(wr) > wcol% WF_coeff_threshold&
                           & .Or. (Abs(wi)>itol)) Then
                         to_print_shell=.True.
                      Endif
                   Enddo
                   ii=ii+deg
                Enddo ivrloop1
             Enddo irsloop1
             !!
             shellif: If(to_print_shell)Then
                !!
                Write(12,100)
                Write(12,101) iwan,Trim(wcol% p_name(iwan))&
                     &,structure% p_elements(structure% p_isrt(isb)),isb&
                     &,wcol% p_nswfpairs(isb,ide)
                !!
                !!
                irsloop: Do irs=1,wcol% p_nswfpairs(isb,ide)
                   !!
                   p(:)=wcol% p_swfpairs(:,isb,ide,irs)
                   pabs=Sqrt(Dot_product(p,p))
                   !!
                   !!
                   to_print_pair=.False.
                   ii=0
                   ivrloop2: Do ivr=1,basis% p_nRv(issb)
                      deg=basis% p_degRv(ivr,issb)
                      !!
                      Do m=1,deg
                         wr=Real(WFc(ii+m,isb,irs,iwan,ms),t_real)
                         wi=Aimag(WFc(ii+m,isb,irs,iwan,ms))
                         If(Abs(wr) > wcol% WF_coeff_threshold&
                              & .Or. (Abs(wi)>itol)) Then
                            to_print_pair=.True.
                         Endif
                      Enddo
                      !!
                      ii=ii+deg
                   Enddo ivrloop2
                   !!
                   pairif: If(to_print_pair)Then
                      !!
                      Write(12,103)irs,p,pabs
                      !!
                      ii=0
                      ivrloop: Do ivr=1,basis% p_nRv(issb)
                         deg=basis% p_degRv(ivr,issb)
                         ll=basis% p_lRv(ivr,issb)
                         jj=2*Abs(basis% p_kapRv(ivr,issb))-1
                         !!
                         to_print=.False.
                         Do m=1,deg
                            wr=Real(WFc(ii+m,isb,irs,iwan,ms),t_real)
                            wi=Aimag(WFc(ii+m,isb,irs,iwan,ms))
                            If(Abs(wr) > wcol% WF_coeff_threshold&
                                 & .Or. (Abs(wi)>Max(itol,wcol% WF_coeff_threshold))) Then
                               to_print=.True.
                            Endif
                         Enddo
                         !!
                         If(to_print)Then
                            If(.Not.rel)Then
                               Write(12,106) basis% p_nnRv(ivr,issb),lqnchar(ll)
                            Else
                               Write(12,1061) basis% p_nnRv(ivr,issb),lqnchar(ll),jj
                            Endif
                            !!
                            Do m=1,deg
                               !!
                               !!
                               wr=Real(WFc(ii+m,isb,irs,iwan,ms),t_real)
                               wi=Aimag(WFc(ii+m,isb,irs,iwan,ms))
                               !!
                               If(Abs(wr) > wcol% WF_coeff_threshold .Or.&
                                    & (Abs(wi)>Max(itol,wcol% WF_coeff_threshold))) Then

                                  If(Abs(wi)>Max(itol,wcol% WF_coeff_threshold))Then
                                     iscomplex=.True.
                                     If(.Not.rel)Then
                                        Write(12,117) m-ll-1,wr,wi
                                     Else
                                        Write(12,1171) 2*(m-1)-jj,wr,wi
                                     Endif
                                  Else
                                     If(.Not.rel)Then
                                        Write(12,107) m-ll-1,wr
                                     Else
                                        Write(12,1071) 2*(m-1)-jj,wr 
                                     Endif
                                  Endif
                              Endif
                              !!
                               !!
                            Enddo
                         Endif
                         ii=ii+deg
                      Enddo ivrloop
                   End If pairif
                End Do irsloop
                !!
             End If shellif
             !!
          End Do isbloop
          !!
          !!
          !!
          !!
          !!
          If(iscomplex)Then
             Write(outfile,14) Trim(wcol% p_name(iwan))
             Call errmsg(nmodule,nsubfunc,E_warning&
                  &,msg="' The real space WF coefficients&
                  & are complex?',/,' Reasons unclear!'")
          Endif
          !!
       Enddo iwanloop
       !!
    End Do spinloop
    !!
    Close(12)
    !!
    Return
    !!
10  Format('Writing Wf-coefficients to file ''',a,''' (big) !')
99  Format(/,72('-'),/,' Wannier coefficient for spin ',i2,/,72('-'),/)
    !!
100 Format('WF             site_B          number of pairs')
101 Format('WF(',i3,')=[',a,']  to site ',a2,'(',i3,')  npairs=',i4)
103 Format(t12,i4,1x,'vec= ',3(f12.6,2x),' |vec|=',f12.6,2x)
14  Format(' WF ',a,' has complex coefficients')
!114 Format(' WF coeeficient is complex')
106 Format(t17,i1,a1)
1061 Format(t17,i1,a1,i1,'/2')
107 Format(t20,sp,i2,ss,' : ',f30.14)
1071 Format(t20,sp,i2,ss,'/2 : ',f30.14)
117 Format(t20,sp,i2,ss,' : ',f30.14,sp,f30.14,ss,'*i')
1171 Format(t20,sp,i2,ss,'/2 : ',f30.14,sp,f30.14,ss,'*i')
    !!
  End Subroutine new_print_WF_coeffs
  !!***********************************************************************
  Subroutine new_make_wannier_fit(nspin,symmetry,structure,lattice,basis,degree&
       &,kohnsham,bzone,bandplot,wcd,wcol,rel,warn,quant)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Basis),Intent(in)     :: basis
    Type(T_Kohnsham),Intent(in)  :: kohnsham
    Type(T_Bzone),Intent(in)     :: bzone
    Type(T_Bandplot),Intent(in)  :: bandplot
    Type(T_WANCoeffData),Intent(in)  :: wcd
    Type(T_WanCollection),Intent(inout) :: wcol
    Type(T_Quant),Intent(in)     :: quant
    Integer(t_int),Intent(in)    :: nspin,degree
    Logical(t_log),Intent(in)    :: rel
    Logical(t_log),Intent(inout) :: warn
    !!LOCAL
    Character(*),Parameter::nsubfunc="new_make_wannier_fit"
    Logical(t_log) :: prot
    Character(100) :: str
    Integer(t_int) :: irs,ikp,ms,nkp,iwan,nvdim,knband,nsite,isc,issc,ide,jde
    Integer(t_int) :: ii,iz,ivr,in,ndim,isHop,isb,i,jwan,nwan
    Integer(t_int) :: subdiv
    Real(t_real)   :: qq(3),r(3),qr,rabs,ri,scale,rz,z
    Complex(t_real):: cc
    Real(t_real),Pointer    :: p_xshop(:)
    Complex(t_real),Pointer :: p_sHop(:)
    Integer(t_int),Pointer  :: iwk(:)
    Real(t_real),Pointer    :: p_ewan(:)
    Complex(t_real),Pointer :: p_H(:,:)
    Complex(t_real),Pointer :: p_ut(:,:)
    Complex(t_real),Pointer :: p_hop(:,:,:,:)!!todo: remove spin or symmetrizer
    Complex(t_real),Pointer :: p_WFc(:,:,:,:,:)!!todo: remove spin or symmetrizer
    !!
    Nullify(p_H,p_ewan,p_ut,p_hop,p_sHop,p_xshop,iwk,p_WFc)
    !!
    Write(outfile,3)
    !!
    !!
    nwan=wcol% nwan
    knband=wcd% knband
    nsite=structure% nsite
    nvdim=kohnsham% nvdim
    nkp=bzone% nkp
    !!
    !!
    !!
    !!
    !!
    !!
    !!
    !!
    !!
    Call palloc('p_hop',p_hop,1_t_int,nwan,1_t_int,nwan&
         &,0_t_int,wcol% nwfpairsmax,1_t_int,nspin,nmodule,nsubfunc)
    Call palloc('p_WFc',p_WFc,1_t_int,kohnsham% nvsmx,1_t_int,nsite&
         &,0_t_int,wcol% nswfpairsmax,1_t_int,nwan,1_t_int,nspin,nmodule,nsubfunc)
    Call palloc('p_ut',p_ut,1_t_int,knband,1_t_int,nwan,nmodule,nsubfunc)
    !!
    subdiv=(Max(1_t_int,nkp/(100/5)));
    !!
    spinloop: Do ms=1_t_int,nspin
       !!
       p_hop(:,:,0:,:)=c0
       p_WFc(:,:,0:,:,:)=c0
       !!
       !!
       !!
       kloop: Do ikp=1_t_int,nkp
          !Print *,'ikp=',ikp,nkp
          qq(:)=bzone% p_bk(:,ikp)
          !!
          !!
          If ( Mod(ikp,subdiv) ==0 )Then
             Write(outfile,51) 100.0_t_real*ikp/nkp
          Endif
          !!
          prot=.False.
          If(ikp==1) prot=.True.
          !!
          Call new_trans_to_wannier(ms,kohnsham,nvdim,knband,qq&
               &,wcd% p_keb(:,ikp,ms),wcd% p_kccts(:,:,ikp,ms)&
               &,wcol,p_ut,warn,wcd% kio)
          !!
          !!
          !!
          !!
          !!
          !! build real-space WF coeficcients
          !!
          !!
          WFciwanloop: Do iwan=1,nwan
             !!
             ide=wcol% p_inddesc(iwan)
             iz=0
             iscloop: Do isc=1,nsite
                issc=structure% p_isrt(isc)
                ii=0
                ivrloop: Do ivr=1,kohnsham% p_vblocklength(isc)
                   iz=iz+1
                   ii=ii+1
                   !!
                   cc=c0
                   Do in=1,knband
                      cc=cc+wcd% p_kcc(in,iz,ikp,ms)*p_ut(in,iwan)
                   Enddo
                   !!
                   irloop1: Do irs=1,wcol% p_nswfpairs(isc,ide)
                      r(:)=wcol% p_swfpairs(:,isc,ide,irs)
                      !!
                      If(wcol% slab_reduce)Then
                         rz=Dot_product(r,wcol% GG(:,3))
                         z=Dot_product(structure% p_tau(:,isc)&
                              &-wcol% p_wdesc(ide)% center&
                              &,wcol% GG(:,3))
                         If(Abs(rz-z)>1.0e-6_t_real) Cycle irloop1
                      Endif
                      !!
                      qr=Dot_product(qq,r)
                      !!
                      p_WFc(ii,isc,irs,iwan,ms)=p_WFc(ii,isc,irs,iwan,ms)&
                           &+cc*Exp(ci*qr)*bzone% p_wbk(ikp)
                      !!
                   Enddo irloop1
                Enddo ivrloop
             Enddo iscloop
          Enddo WFciwanloop
          !!
          !! make matrix elements
          !!
          !! build up Wannier Hamiltonian
          !!
          !|Ri)=\int dk|kn> ut_{ni}^{k}e^{-ik (R+s_{i}+\alpha_{i})}
          !!
          Do iwan=1,nwan
             !!
             ide=wcol% p_inddesc(iwan)
             !!
             !!
             Do jwan=1,nwan
                !!
                jde=wcol% p_inddesc(jwan)
                !!
                cc=c0
                Do in=1,knband
                   cc=cc+Conjg(p_ut(in,iwan))*wcd% p_keb(in,ikp,ms)&
                        &*p_ut(in,jwan)
                Enddo
                !!
                irloop: Do irs=1,wcol% p_nwfpairs(jde,ide)
                   r(:)=wcol% p_wfpairs(:,jde,ide,irs)
                   !!
                   !!
                   If(wcol% slab_reduce)Then
                      rz=Dot_product(r,wcol% GG(:,3))
                      z=Dot_product(wcol% p_wdesc(jde)% center&
                           &-wcol% p_wdesc(ide)% center&
                           &,wcol% GG(:,3))
                      If(Abs(rz-z)>1.0e-6_t_real) Cycle irloop
                   Endif
                   !!
                   qr=Dot_product(qq,r)
                   !!
                   !!
                   p_hop(iwan,jwan,irs,ms)=p_hop(iwan,jwan,irs,ms)&
                        &+cc*Exp(-ci*qr)*bzone% p_wbk(ikp)
                   !!
                Enddo irloop
                !!
             Enddo!! jwan
          Enddo!! iwan
       End Do kloop
       !!
       !! 
       !!
       !!
       !!
       !!
       !! output of hoppings
       !!      
       If(wcol% write_Ham_t_stats)Then
          
          Call palloc('p_sHop',p_sHop ,1_t_int,nwan*wcol% nwfpairsmax&
               &,nmodule,nsubfunc)
          Call palloc('p_xshop',p_xshop ,1_t_int,nwan*wcol% nwfpairsmax&
               &,nmodule,nsubfunc)
          Call palloc('iwk',iwk ,1_t_int,nwan*wcol% nwfpairsmax&
               &,nmodule,nsubfunc)
       Endif
       !!
       iwloop: Do iwan=1,nwan
          ide=wcol% p_inddesc(iwan)
          isHop=0
          jwloop: Do jwan=1,nwan
             jde=wcol% p_inddesc(jwan)
             !!
             Write(outfile,13) ms,Trim(wcol% p_name(iwan))&
                  &,Trim(wcol% p_name(jwan))
             !!
             Do irs=1,wcol% p_nwfpairs(jde,ide)
                r(:)=wcol% p_wfpairs(:,jde,ide,irs)
                !!
                !!
                !!
                cc=p_hop(iwan,jwan,irs,ms)
                !!
                ri=Aimag(cc)
                If(abs(cc) > wcol% WF_ham_threshold ) Then
                   If(Abs(ri)>1.0e-6_t_real)Then
                      Write(outfile,15) r,cc
                   Else
                      Write(outfile,115) r,Real(cc,t_real)
                   Endif
                   isHop=isHop+1
                   If(wcol% write_Ham_t_stats)Then
                      p_sHop (isHop)=cc
                      p_xshop(isHop)=Sqrt(Sum(r(:)**2))
                   Endif
                Endif
                !!
                If(.Not.rel .And. Abs(ri)>1.0e-6_t_real)Then
                   Call errmsg(nmodule,nsubfunc,E_warning&
                        &,msg="' The real space hoppings are complex?',/&
                        &,' Reasons unclear!'")
                Endif
                !!
             Enddo
          Enddo jwloop
          Write(outfile,34)
          !!
          If(wcol% write_Ham_t_stats)Then
             Call dshel2(1_t_int,isHop,p_xshop,iwk,1.e-12_t_real)
             Write(str,"('+T',a,'.spin',i1)") Trim(wcol% p_name(iwan)),ms
             Call replacechar(str,'/','_')
             Open(12,file=Trim(str))
             Do i=1,isHop
                Write(12,16) p_xshop(iwk(i)+1),p_sHop(iwk(i)+1)
             Enddo
             Close(12)
          Endif
          !!
       Enddo iwloop
       !!
       !!
       !!
       !!
       !! output WF coefficients statistics
       !!
       WFcoefoutif: If(wcol% write_WF_coeff_stats)Then
          ndim=nsite*wcol% nswfpairsmax*basis% nRvmx
          Call palloc('p_sHop',p_sHop ,1_t_int,ndim,nmodule,nsubfunc)
          Call palloc('p_xshop',p_xshop ,1_t_int,ndim,nmodule,nsubfunc)
          Call palloc('iwk',iwk ,1_t_int,ndim,nmodule,nsubfunc)
          !!
          WFiwloop: Do iwan=1,nwan
             ide=wcol% p_inddesc(iwan)
             !!
             isHop=0
             isblp: Do isb=1,nsite
                irlp: Do irs=1,wcol% p_nswfpairs(isb,ide)
                   r(:)=wcol% p_swfpairs(:,isb,ide,irs)
                   rabs=Sqrt(Sum(r(:)**2))
                   !!
                   iilp: Do ii=1,kohnsham% p_vblocklength(isb)
                      !!
                      !!
                      cc=p_WFc(ii,isb,irs,iwan,ms)
                      !!
                      If(Abs(cc) > wcol% WF_coeff_threshold)Then
                         !!
                         isHop=isHop+1
                         !!
                         p_xshop(isHop)=rabs
                         p_sHop(isHop)=cc
                         !!
                      Endif
                   Enddo iilp
                Enddo irlp
             Enddo isblp
             !!
             Call dshel2(1_t_int,isHop,p_xshop,iwk,1.e-12_t_real)
             
             Write(str,"('+WFstat',a,'.spin',i1)") &
                  &Trim(wcol% p_name(iwan)),ms
             Call replacechar(str,'/','_')
             Open(12,file=Trim(str))
             Do i=1,isHop
                Write(12,116) p_xshop(iwk(i)+1),p_sHop(iwk(i)+1)
             Enddo
             Close(12)
             !!
          Enddo WFiwloop
          !!
       Endif WFcoefoutif
       !!
       Call pfree(p_sHop)
       Call pfree(iwk)
       Call pfree(p_xshop)
       !!
    End Do spinloop
    !!
    !!
    Call pfree(p_ut)
    !!
    Write(outfile,4)
    !!
    !!
    !!
    !! make bandplot of wanner-fit, since I am a control freak ;-)
    !!
    Write(outfile,103)
    !!
    Call palloc('p_H',p_H,1_t_int,nwan,1_t_int,nwan,nmodule,nsubfunc)
    Call palloc('p_ewan',p_ewan,1_t_int,nwan,nmodule,nsubfunc)
    !!
    scale=twopi/ symmetry% lattice_constants(1)
    !!
    Open(wanbands_unit,file=Trim(f_wanbands_out)//'tb',status='unknown')
    Write(wanbands_unit,120) nsite,wcd% eff,bandplot% nkpnts,nvdim,nwan&
         &,nspin,1,nwan
    !!
    ikloop: Do ikp=1,bandplot% nkpnts
       !!
       qq(1:3)=bandplot% p_kpnts(1:3,ikp)
       !!
       Write(wanbands_unit,26)qq
       !!
       bspinloop: Do ms=1,nspin
          !!
          !!
          !! reassemble Hamiltonian
          !!
          p_H=c0
          !!
          Do iwan=1,nwan
             ide=wcol% p_inddesc(iwan)
             Do jwan=1,nwan
                jde=wcol% p_inddesc(jwan)
                Do irs=1,wcol% p_nwfpairs(jde,ide)
                   r(:)=wcol% p_wfpairs(:,jde,ide,irs)
                   !!
                   !!
                   qr=Dot_product(qq,r)*scale
                   !!
                   cc=p_hop(iwan,jwan,irs,ms)
                   If(Abs(cc) >= wcol% WF_ham_threshold)Then
                      p_H(iwan,jwan)=p_H(iwan,jwan)+cc*Exp(ci*qr)
                   Endif
                   !!
                   !!
                Enddo
                
             Enddo
          Enddo
          !!
          !!
          !!
          Call cdiagno_noO(nwan,p_H,p_ewan)
          !!
          !!
          !!
          Write(wanbands_unit,32,advance='no')bandplot% p_kpnts(4,ikp)
          Do iwan=1,nwan
             Write(wanbands_unit,32,advance='no')p_ewan(iwan)
          Enddo
          Write(wanbands_unit,34)


       End Do bspinloop
       
    End Do ikloop
    !!
    Close(wanbands_unit)
    !!
    Write(outfile,104)
    !!
    !!
    !! export wannier Hamiltonian on grid
    !!
    !!
    !!
    wcol% kgrid% latticetype=GRID_RECIP_LATTICE

    !!
    Call print_grid_props(outfile,wcol% kgrid)
    Call make_grid(wcol% kgrid,symmetry,structure)
    !!
    !!
    Open(wanbands_unit,file='+hamongrid',status='unknown')
    !!
    subdiv=(Max(1_t_int,wcol% kgrid% npoints/(100/10)));
    !!
    pspinloop: Do ms=1,nspin

       Write(outfile,"('Spin: ',i1)") ms
          
       iploop: Do ikp=1,wcol% kgrid% npoints
          qq(1:3)=wcol% kgrid%  points(1:3,ikp)
          !!
          !!
          !!
          If ( Mod(ikp,subdiv) ==0 .Or. ikp==1 .Or.ikp==wcol% kgrid% npoints)Then
             Write(outfile,"('Hk Output: ',f6.2,'% done')") &
                  &100.0_t_real*ikp/wcol% kgrid% npoints
          Endif

          !!
          !! reassemble Hamiltonian
          !!
          p_H=c0
          !!
          Do iwan=1,nwan
             ide=wcol% p_inddesc(iwan)
             Do jwan=1,nwan
                jde=wcol% p_inddesc(jwan)
                
                Do irs=1,wcol% p_nwfpairs(jde,ide)
                   r(:)=wcol% p_wfpairs(:,jde,ide,irs)
                   !!
                   !!
                   qr=Dot_product(qq,r)
                   !!
                   cc=p_hop(iwan,jwan,irs,ms)
                   If(Abs(cc) >= wcol% WF_ham_threshold)Then
                      p_H(iwan,jwan)=p_H(iwan,jwan)+cc*Exp(ci*qr)
                   Endif
                   !!
                   !!
                Enddo
                
             Enddo
          Enddo
          !!
          !!
          !!
          Do iwan=1,nwan
             Do jwan=1,nwan
                cc=p_H(iwan,jwan)
                Write(wanbands_unit,62)Real(cc,t_real),Aimag(cc)
             Enddo
          Enddo
          !!
          !!
       End Do iploop
       !!
       Write(wanbands_unit,34)
       !!
    End Do pspinloop
    !!
    Close(wanbands_unit)
    !!
    !!
    !!
    Call pfree(p_ewan)
    Call pfree(p_H)
    !!
    Call new_print_WF_coeffs(nspin,structure,basis,wcol,p_WFc,rel)
    !!
    !!
    Call new_create_WF_opendx(nspin,symmetry,structure,lattice,basis,degree&
         &,wcol,p_WFc,rel,quant)
    !!
    Call pfree(p_hop)
    Call pfree(p_WFc)
    !!
    Return
    !!
13  Format('spin ',i1,': WF(',a,') -> WF(',a,') at relative ')
15  Format('T= ',3(f12.5,1x),' hop=',f30.15,' +i* ',f30.15)
115 Format('T= ',3(f12.5,1x),' hop=',f30.15)
16  Format(3(e16.8e3,2x))
116  Format(3(e16.8e3,2x))
!14  Format(' Im(t)=',f30.15)
    !!
120 Format('# ',i3,f12.7,6(' ',i8))
26  Format('# ',3f12.7)
32  Format(f16.7,1x)
62  Format(10(e30.15e3,1x))
34  Format(' ')
3  Format(/,'START calculating WF')
4  Format('END   calculating WF',/)
103 Format(/,'START calculating +wanbandtb')
104 Format('END   calculating +wanbandtb',/)
51  Format('calculating WF: ',f5.1,'% done')
    !!
  End Subroutine new_make_wannier_fit
  !!***********************************************************************
  Subroutine read_wandef_file(symmetry,structure,wcol&
       &,binformat,do_wanniers)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_WanCollection),Intent(inout) :: wcol
    Logical(t_log),Intent(out)   :: do_wanniers,binformat
    !!LOCAL
    Character(*),Parameter::nsubfunc="read_wandef_file"
    Character(*),Parameter :: fname='=.wtmp'
    Character(2),Parameter   :: on ='on'
    Character(3),Parameter   :: off='off'
    Character(3)   :: onoff
    Logical(t_log) :: exists
    Integer(t_int) :: beta,ncontrib,isa,n,i,j,idesc
    Real(t_real)   :: r(3),d
    Integer :: eof
    Character(5000)   :: buf,word
    Type(T_WanDescriptor),Pointer :: wd
    !!
    !!
    !todo:take from read_wandefs_from_file
    !!
    !!
    !!
    do_wanniers=.False.
    !!
    Inquire(file=Trim(fname),exist=exists)
    If(.Not.exists) Then
       do_wanniers=.False.
       Return
    Endif
    !!
    Call copy_file_to_output(outfile,fname)
    wcol% have_wforigin=.False.
    !!
    binformat=.False.
    wcol% ham_rcut=10.0_t_real !! bohr
    wcol% WF_coeff_threshold=1.0e-4_t_real
    wcol% WF_ham_threshold=0.005_t_real
    wcol% write_WF_coeff_stats=.False.
    wcol% write_Ham_t_stats=.False.
    wcol% slab_direction=0.0_t_real
    !!
    Open(12,file=fname,status='old')
    wcol% nwdesc=0
    readcountloop1: Do 
       Read(12,2,iostat=eof) buf
       If(eof/=0) Exit readcountloop1
       Call replace_tabs_by_blanks(buf)
       If(next_word(buf,word)) Then
          If( word(1:7) == 'wandesc') Then
             wcol% nwdesc=wcol% nwdesc+1
          Else If( word(1:4) == 'doit') Then
             do_wanniers=.True.
          Endif
       Endif
    End Do readcountloop1
    !!
    If(.Not.do_wanniers) Return
    If(wcol% nwdesc<1)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror&
            &,msg="' no active Wannier definitions found!'")
    Endif
    !!
    Call palloc_wandesc('wcol% p_wdesc',wcol% p_wdesc,wcol% nwdesc,nmodule,nsubfunc)
    wd=>wcol% p_wdesc(1)
    !!
    Rewind(12)
    idesc=0
    ncontrib=0
    readcountloop0: Do 
       Read(12,2,iostat=eof) buf
       If(eof/=0) Exit readcountloop0
       Call replace_tabs_by_blanks(buf)
       If(next_word(buf,word)) Then
          !Print "('word=',a,' buf=',a)",Trim(word),Trim(buf)
          If( word(1:10) == 'ham_cutoff') Then
             Read(buf,fmt=*,iostat=eof) wcol% ham_rcut !!todo: iostat
             If(eof/=0) Goto 6666
          Else If( word(1:19) == 'coefficients_format') Then
             If(next_word(buf,word)) Then
                If(word(1:3)=='bin') binformat=.True.
             Endif
          Else If( word(1:14) == 'slab_direction') Then
             Read(buf,fmt=*,iostat=eof) wcol% slab_direction(1:3)
             If(eof/=0) Goto 6666
          Else If( word(1:16) == 'WF_ham_threshold') Then
             Read(buf,fmt=*,iostat=eof) wcol% WF_ham_threshold
             If(eof/=0) Goto 6666
          Else If( word(1:18) == 'WF_coeff_threshold') Then
             Read(buf,fmt=*,iostat=eof) wcol% WF_coeff_threshold
             If(eof/=0) Goto 6666
          Else If( word(1:14) == 'WF_grid_origin') Then
             Read(buf,fmt=*,iostat=eof) wcol% wfgrid % origin(1:3)
             If(eof/=0) Goto 6666
             wcol% have_wforigin=.True.
          Else If( word(1:13) == 'WF_grid_basis') Then
             buf=Adjustl(buf)
             If(char_to_uc(buf(1:1))=='P') Then
                wcol% wfgrid% basis=GRID_BASIS_PRIMITIVE
             Elseif(char_to_uc(buf(1:1))=='C') Then
                wcol% wfgrid% basis=GRID_BASIS_CONVENTIONAL
             Else
                wcol% wfgrid% basis=0
             Endif
          Else If( word(1:18) == 'WF_grid_directions') Then
             If(Len_trim(buf)==0)Then
                Do i=1,3
                   Read(12,2,iostat=eof) buf
                   If(eof/=0) Exit readcountloop0
                   Call replace_tabs_by_blanks(buf)
                   Read(buf,fmt=*,iostat=eof) wcol% wfgrid% directions(:,i)
                   If(eof/=0) Goto 6666
                Enddo
             Else
                Read(buf,fmt=*,iostat=eof) wcol% wfgrid% directions(:,1)
                If(eof/=0) Goto 6666
                Do i=2,3
                   Read(12,2,iostat=eof) buf
                   If(eof/=0) Exit readcountloop0
                   Call replace_tabs_by_blanks(buf)
                   Read(buf,fmt=*,iostat=eof) wcol% wfgrid% directions(:,i)
                   If(eof/=0) Goto 6666
                Enddo
             Endif
          Else If( word(1:19) == 'WF_grid_subdivision') Then
             Read(buf,fmt=*,iostat=eof) wcol% wfgrid% subdivisions(1:3)
             If(eof/=0) Goto 6666
             
          Else If( word(1:17) == 'ham_write_t_stats') Then
             If(next_word(buf,word)) Then
                If( word(1:3) == 'off') Then
                   wcol% write_Ham_t_stats=.False.
                Else If( word(1:2) == 'on') Then
                   wcol% write_Ham_t_stats=.True.
                Else
                   Write(outfile,"(' want no argument [=yes] to &
                        &ham_write_t_stats or ''on'' [=yes] &
                        &or ''off'' [=no]')")
                   Call terminate(TERM_CRASH,' input trouble ')
                Endif
             Else
                wcol% write_Ham_t_stats=.True.
             Endif
          Else If( word(1:20) == 'WF_write_coeff_stats') Then
             If(next_word(buf,word)) Then
                If( word(1:3) == 'off') Then
                   wcol% write_WF_coeff_stats=.False.
                Else If( word(1:2) == 'on') Then
                   wcol% write_WF_coeff_stats=.True.
                Else
                   Write(outfile,"(' I want no argument [=yes] to &
                        &WF_write_coeff_stats or ''on'' [=yes] &
                        &or ''off'' [=no]')")
                   Call terminate(TERM_CRASH,' input trouble ')
                Endif
             Else
                wcol% write_WF_coeff_stats=.True.
             Endif
          
          Elseif( word(1:12) == 'k_grid_basis') Then
             !! kgrid
             buf=Adjustl(buf)
             If(char_to_uc(buf(1:1))=='P') Then
                wcol% kgrid% basis=GRID_BASIS_PRIMITIVE
             Elseif(char_to_uc(buf(1:1))=='C') Then
                wcol% kgrid% basis=GRID_BASIS_CONVENTIONAL
             Else
                wcol% kgrid% basis=0
             Endif
          Else If( word(1:17) == 'k_grid_directions') Then
             If(Len_trim(buf)==0)Then
                Do i=1,3
                   Read(12,2,iostat=eof) buf
                   If(eof/=0) Exit readcountloop0
                   Call replace_tabs_by_blanks(buf)
                   Read(buf,fmt=*,iostat=eof) wcol% kgrid% directions(:,i)
                   If(eof/=0) Goto 6666
                Enddo
             Else
                Read(buf,fmt=*,iostat=eof) wcol% kgrid% directions(:,1)
                If(eof/=0) Goto 6666
                Do i=2,3
                   Read(12,2,iostat=eof) buf
                   If(eof/=0) Exit readcountloop0
                   Call replace_tabs_by_blanks(buf)
                   Read(buf,fmt=*,iostat=eof) wcol% kgrid% directions(:,i)
                   If(eof/=0) Goto 6666
                Enddo
             Endif
          Else If( word(1:18) == 'k_grid_subdivision') Then
             Read(buf,fmt=*,iostat=eof) wcol% kgrid% subdivisions(1:3)
             If(eof/=0) Goto 6666
          Else If( word(1:27) == 'k_grid_incl_periodic_points') Then
             If(next_word(buf,word)) Then
                If( word(1:3) == 'off') Then
                   wcol% kgrid% InclPeriodicPoints=.False.
                Else If( word(1:2) == 'on') Then
                   wcol% kgrid% InclPeriodicPoints=.True.
                Else
                   Write(outfile,"(' want no argument [=yes] to &
                        &k_grid_incl_periodic or ''on'' [=yes] &
                        &or ''off'' [=no]')")
                   Call terminate(TERM_CRASH,' input trouble ')
                Endif
             Else
                wcol% kgrid% InclPeriodicPoints=.True.
             Endif
          Else If( word(1:7) == 'wandesc') Then
             idesc=idesc+1
             wd=>wcol% p_wdesc(idesc)
             ncontrib=0
             If(next_word(buf,word)) Then
                If(word(1:3)=='off')Then
                   wd% active=.False.
                Endif
                If(word(1:2)=='on')Then
                   wd% active=.True.
                Endif
             Endif
          Else If( word(1:3) == 'off') Then
             If(idesc>0 .And. idesc<=wcol% nwdesc)Then
                wd% active=.False.
             Endif
          Else If( word(1:2) == 'on') Then
             If(idesc>0 .And. idesc<=wcol% nwdesc)Then
                wd% active=.True.
             Endif
          Else If( word(1:4) == 'emin') Then
             If(next_word(buf,word)) Then
                Read(word,fmt=*,iostat=eof)wd% emin(1)
                If(eof/=0) Goto 6666
                If( next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wd% emin(2)
                   If(eof/=0) Goto 6666
                Else
                   wd% emin(2)=wd% emin(1)
                Endif
             Else
                Write(outfile,"(' expecting one or two energy parameters af&
                     &ter emin key-word')")
                Call terminate(TERM_CRASH,' input trouble ')
                
             Endif
          Else If( word(1:4) == 'emax') Then
             If(next_word(buf,word)) Then
                Read(word,fmt=*,iostat=eof) wd% emax(1)
                If(eof/=0) Goto 6666
                If( next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wd% emax(2)
                   If(eof/=0) Goto 6666
                Else
                   wd% emax(2)=wd% emax(1)
                Endif
             Else
                Write(outfile,"(' expecting one or two energy parameters af&
                     &ter emax key-word')")
                Call terminate(TERM_CRASH,' input trouble ')
                
             Endif
          Else If( Trim(word) == 'de') Then
             If(next_word(buf,word)) Then
                Read(word,fmt=*,iostat=eof) wd% del(1)
                If(eof/=0) Goto 6666
                wd% deu(1)=wd% del(1)
                If( next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wd% del(2)
                   If(eof/=0) goto 6666
                   wd% deu(2)=wd% del(2)
                Else
                   wd% del(2)=wd% del(1)
                   wd% deu(2)=wd% deu(1)
                Endif
             Else
                Write(outfile,"(' expecting one or two energy parameters af&
                     &ter de key-word')")
                Call terminate(TERM_CRASH,' input trouble ')
                
             Endif
          Else If( word(1:6) == 'lbands') Then
             If(next_word(buf,word)) Then
                Read(word,fmt=*,iostat=eof) wd% lband(1)
                If(eof/=0) Goto 6666
                If( next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wd% lband(2)
                   If(eof/=0) goto 6666
                Else
                   wd% lband(2)=wd% lband(1)
                Endif
             Else
                Write(outfile,"(' expecting one or two integer parameters af&
                     &ter lbands key-word')")
                Call terminate(TERM_CRASH,' input trouble ')
                
             Endif
          Else If( word(1:6) == 'ubands') Then
             If(next_word(buf,word)) Then
                Read(word,fmt=*,iostat=eof) wd% uband(1)
                If(eof/=0) Goto 6666
                If( next_word(buf,word)) Then
                   Read(word,fmt=*,iostat=eof) wd% uband(2)
                   If(eof/=0) goto 6666
                Else
                   wd% uband(2)=wd% uband(1)
                Endif
             Else
                Write(outfile,"(' expecting one or two integer parameters af&
                     &ter ubands key-word')")
                Call terminate(TERM_CRASH,' input trouble ')
                
             Endif
          Else If( word(1:4) == 'name') Then
             If(Len_trim(buf)<1) Then
                Write(outfile,"(' expecting a string parameter af&
                     &ter name key-word')")
                Call terminate(TERM_CRASH,' input trouble ')
             Endif
             word=Adjustl(buf)
             wd% name=word(1:17)
          Else If( word(1:6) == 'neigen') Then
             i=0
             Do While(next_word(buf,word))
                Read(word,*,iostat=eof) n
                Print *,eof,n
                If(eof/=0) Call terminate(TERM_CRASH,'neigen requires integer list')
                i=i+1
                Call realloc('wd% p_neigen',wd% p_ieigen&
                     &,1_t_int,i,nmodule,nsubfunc)
                wd% neigen=i
                wd% p_ieigen(i)=n
             Enddo
             If(i<1) Call terminate(TERM_CRASH,'neigen requires integer list')
             
          Else If( word(1:4) == 'site') Then
             If(next_word(buf,word)) Then
                Read(word,*,iostat=eof) isa
                If(eof/=0) Goto 6666
             Else
                Write(outfile,"(' expecting a site parameter af&
                     &ter site key-word')")
                Call terminate(TERM_CRASH,' input trouble ')
             Endif
             ncontrib=ncontrib+1
             Call realloc_wandesc_contribs(wd,ncontrib)
             wd% p_site(ncontrib)=isa
             
          Else If( word(1:6) == 'difvec') Then
             If(ncontrib<1)Then
                Write(outfile,"(' difvec key-word without previous site key-word')")
                Call terminate(TERM_CRASH,' input trouble ')
             Endif
             Read(buf,fmt=*,iostat=eof) r(1:3)
             If(eof/=0)Then
                Write(outfile,"(' expecting a vector parameter af&
                     &ter difvec key-word')")
                Call terminate(TERM_CRASH,' input trouble ')
             Endif
             wd% p_difvec(:,ncontrib)=r

          Else If( word(1:6) == 'center') Then
             Read(buf,fmt=*,iostat=eof) r(1:3)
             If(eof/=0)Then
                Write(outfile,"(' expecting a vector parameter af&
                     &ter center key-word')")
                Call terminate(TERM_CRASH,' input trouble ')
             Endif
             wd% center(:)=r
          Endif
       Endif
    End Do readcountloop0
    !!
    !!
    If( .Not. valid_grid_basis(wcol% wfgrid) ) Then
992    Format("'Wrong grid basis type: ",i4," in file """,a,""" !'")
       Write(errbuf,992) wcol% wfgrid% basis,fname
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    Endif
    !!
    If( .Not. valid_grid_basis(wcol% kgrid) ) Then
       Write(errbuf,992) wcol% kgrid% basis,fname
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    Endif
    !!
    !!
    Write(outfile,"(t1,'WF_grid_basis',t21,1(a,1x),/)") &
         &Trim(GRID_BASIS_TYPES(wcol% wfgrid% basis))
    !!
    Do i=1,3
       If(i==1)Then
          Write(outfile,"(t1,'WF_grid_directions',t21)",advance='no') 
       Else
          Write(outfile,"(t21)",advance='no') 
       Endif
       Do j=1,3
          Write(outfile,"(a,1x)",advance='no') &
               &Trim(stringify_double100(wcol% wfgrid% directions(j,i)))

       Enddo
       Write(outfile,*)
    Enddo
    !!
    d=spat(wcol% wfgrid% directions(:,1),wcol% wfgrid% directions(:,2)&
         &,wcol% wfgrid% directions(:,3))
    !!
    If(Abs(d)<1.0e-8_t_real)Then
       Write(errbuf,993) fname
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    Endif

    !!
    wcol% slab_reduce=.False.
    wcol% AA=symmetry% lattice_vectors
    wcol% GG=symmetry% reciprocial_lattice_vectors/twopi
    If(Sum(wcol% slab_direction(:)**2)>1.0e-8_t_real)Then
       If(Sum((wcol% slab_direction(:)-(/0.0_t_real,0.0_t_real,1.0_t_real/))**2)&
            &<1.0e-8_t_real)Then
          wcol% slab_reduce=.True.
          !!todo: not general enough
          !!todo: Call reduce_slab_lattice(symmetry% lattice_vectors)
       Else
          !!todo
          Call errmsg(nmodule,nsubfunc,E_fatalerror&
               &,msg="' slab_direction other than 001 not yet implemented!'")
       Endif
    Endif
    !!
    
    Write(outfile,"('ndesc   =',i5)")wcol% nwdesc
    Write(outfile,"('nbetamax=',i5)")Maxval(wcol% p_wdesc(:)% ncontrib)

    Do idesc=1,wcol% nwdesc
       wd=>wcol% p_wdesc(idesc)
       onoff=off
       If(wd% active)onoff=on
       Write(outfile,"('wandesc ',a,/&
            &,t5,'name   ',a,/&
            &,t5,'center ',3(f30.15,1x),/&
            &,t5,'emin   ',2(f12.5,1x),/&
            &,t5,'emax   ',2(f12.5,1x),/&
            &,t5,'del    ',2(f12.5,1x),/&
            &,t5,'deu    ',2(f12.5,1x),/&
            &,t5,'lband  ',2(i7,1x),/&
            &,t5,'uband  ',2(i7,1x)&
            &)")&
            & onoff&
            &,Trim(wd% name)&
            &,wd% center(1:3)&
            &,wd% emin(1:2)&
            &,wd% emax(1:2)&
            &,wd% del(1:2)&
            &,wd% deu(1:2)&
            &,wd% lband(1:2)&
            &,wd% uband(1:2)
       Write(outfile,"(t5,'neigen ')",advance='no')
       Do i=1,wd% neigen
          If(wd% p_ieigen(i)<1)Then
             Call errmsg(nmodule,nsubfunc,E_fatalerror&
                  &,msg="' neigen key-word missing or bad parameter in one of the wandesc'")
          Endif
          Write(outfile,"(i3,1x)",advance='no')wd% p_ieigen(i)
       Enddo
       Write(outfile,*)
       Do beta=1,wd% ncontrib
          Write(outfile,"(t5,'site ',i5)")wd% p_site(beta)
          Write(outfile,"(t5,'difvec ',3(f30.15,1x))")wd% p_difvec(:,beta)
       Enddo
    Enddo
    !!
    Close(12)
    !!
    !!
    !!
    !!
    Call setup_from_wandesc(symmetry,structure,wcol,.False.)
    !!
    !!
    !!
    !!
    Return
    !!
6666 Continue
    !!
6993 Format("'input error: """,a,a,""" !'")
    Write(errbuf,6993) Trim(word),Trim(buf)
    Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
    !!
2   Format(a)
993 Format("'Grid direction matrix is singular in file """,a,""" !'")
    !!
  End Subroutine read_wandef_file
  !!***********************************************************************
  Subroutine setup_from_wandesc(symmetry,structure,wcol,prot)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_WanCollection),Intent(inout) :: wcol
    Logical(t_log),Intent(in)    :: prot
    !!LOCAL
    Character(*),Parameter::nsubfunc="setup_from_wandesc"
    Logical(t_log) :: equiv,err
    Integer(t_int) :: ndesc,idesc,ibeta,isa,jops,igdesc,jdesc,ngdesc,i
    Integer(t_int) :: iwan
    Character(100) :: str
    Real(t_real)   :: ca(3),gca(3),cb(3),v(3),vtol
    Integer(t_int),Pointer :: p_inddesc(:)
    Type(T_WanDescriptor),Pointer :: wdi,wdj
    Real(t_real),Parameter :: tol=1.0e-6_t_real
    !!
    Nullify(p_inddesc)
    !!
    Write(outfile,3)
    !!
    vtol=1.0e-5_t_real
    ndesc=wcol% nwdesc
    !!
    !!
    !!
    err=.False.
    idescloop: Do idesc=1,ndesc
       !!
       wdi=>wcol% p_wdesc(idesc)
       If(.Not.wdi% active) Cycle idescloop
       ca=wdi% center(:)
       !!
       !!
       !!
       jopsloop: Do jops=1,symmetry% Rnumops
          If(prot) Write(outfile,85) Trim(symmetry% Ropsymbol(jops))&
               &,Trim(strtimrev(symmetry% Roptimerev(jops)))&
            &,symmetry% Roptau(:,jops)

          !!
          gca=Matmul(ca,symmetry% Ropmat(:,:,jops))+symmetry% Roptau(:,jops)
          !!
          If(prot) Write(outfile,"('wandesc ',i4,1x,a,/&
               &,t3,' at   center ',3(f20.15,1x),/&
               &,t3,'    g*center=',3(f20.15,1x))")&
               &idesc,Trim(wdi% name),ca,gca
          !!
          ngdesc=0
          igdesc=-1
          jdescloop: Do jdesc=1,ndesc
             wdj=>wcol% p_wdesc(jdesc)
             If(.Not.wdj% active) Cycle jdescloop
             If(.Not.compare_wandesc(wdi,wdj,1.0e-6_t_real)) &
                  &Cycle jdescloop
             cb=wdj% center(:)
             If(prot) &
                  &Write(outfile,"(t2,'compare to wandesc ',i4,1x,a/&
                  &,t3,' at center ',3(f20.15,1x))")&
                  &jdesc,Trim(wdj% name),cb
             v=gca-cb
             !Print *,'v=',v
             If(structure% str_type == STR_TYPE_MOLECULE)Then
                equiv=All(Abs(v(1:3))<vtol)
             Else
                v=Matmul(v(:),symmetry% reciprocial_lattice_vectors)/twopi
                equiv=vecIsOnGrid(3_t_int,v,vtol)
             Endif
             !Print *,'vrel=',v
             If(equiv)Then 
                If(prot) Write(outfile,"('centers are equivalent')")
                If( compare_wandesc_sites(wdi,wdj,jops&
                     &,symmetry% Ropmat,structure% p_equivsites,vtol,prot))Then
                   If(prot) Write(outfile,"('site patterns are equivalent')")
                   ngdesc=ngdesc+1
                   igdesc=jdesc
                   If(ngdesc>1)Then
1000                  Format('"wandesc ',i5,1x,a,' has more than one symmetry &
                           &equivalent wandesc ( e.g.',i5,1x,a,')!"')
                      Write(errbuf,1000)&
                           &idesc,Trim(wdi% name)&
                           &,jdesc,Trim(wdj% name)
                      Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
                   Endif
                Endif
             Endif
          Enddo jdescloop
          If(igdesc<0)Then
             Write(errbuf,1001)idesc,Trim(wdi% name)&
                  &,Trim(symmetry% Ropsymbol(jops))
1001         Format('"wandesc ',i5,1x,a,' has no symmetry equivalent partner",/&
                  &," under operation ',a,'!"')
             Call errmsg(nmodule,nsubfunc,E_fatalerror,msg=errbuf)
          Endif
          !!
          wdi% equivdesc(jops)=igdesc
          !!
          If(prot) Write(outfile,"(t15,' indesc ',i5,1x,a,' g*idesc ',i5,1x,a)") &
               &idesc,Trim(wdi% name)&
               &,igdesc,Trim(wcol% p_wdesc(igdesc)% name)

       Enddo jopsloop
       !!
       !!
       !!
       Do ibeta=1,wdi% ncontrib
          isa=wdi% p_site(ibeta)
          v=structure% p_tau(:,isa)-wdi% center-wdi% p_difvec(:,ibeta)
          v=Matmul(v(:),symmetry% reciprocial_lattice_vectors)/twopi
          If(.Not. vecIsOnGrid(3_t_int,v,tol))Then
             Write(outfile,1002)idesc,Trim(wdi% name),wdi% center,ibeta&
                  &,wdi% p_difvec(:,ibeta),isa
             err=.True.
1002         Format('wandesc ',i5,1x,a,' at ',3(f15.8,1x),' contrib ',i5&
                  &,/,t10,' difvec    ',3(f15.8,1x)&
                  &,' does not point to site ',i5,'!(input accuracy?)')
          Endif
       Enddo
       !!
    Enddo idescloop
    !!
    If(err)Then
       Call errmsg(nmodule,nsubfunc,E_fatalerror,msg="('wandesc input error')")
    Endif
    !!
    !! output
    Do jops=1,symmetry% Rnumops
       Write(outfile,86)&
            & Trim(symmetry% Ropsymbol(jops))&
            &,Trim(strtimrev(symmetry% Roptimerev(jops)))&
            &,symmetry% Roptau(:,jops)
       
       Do idesc=1,ndesc
          wdi=>wcol% p_wdesc(idesc)
          If(.Not.wdi% active) Cycle
          igdesc=wdi% equivdesc(jops)
          Write(outfile,"(t15,' indesc ',i5,1x,a,' g*idesc ',i5,1x,a)") &
               &idesc,Trim(wdi% name)&
               &,igdesc,Trim(wcol% p_wdesc(igdesc)% name)
          Do ibeta=1,wdi% ncontrib
             Write(outfile,"(t25,'site ',i5,'   beta(g*site) ',i5)")&
                  &wdi% p_site(ibeta),wdi% p_equivbeta(ibeta,jops)
          Enddo

       Enddo
    Enddo
    !!
    Call palloc('p_inddesc',p_inddesc,1_t_int,ndesc,nmodule,nsubfunc)
    !!
    wcol% nwcenteridesc=0
    p_inddesc=0
    Do i=1,ndesc
       If(p_inddesc(i)/=0)Cycle
       wdi=>wcol% p_wdesc(i)
       If(.Not.wdi% active) Cycle
       wcol% nwcenteridesc=wcol% nwcenteridesc+1
       Call realloc('wcol% p_wcenteridesc',wcol% p_wcenteridesc&
            &,1_t_int,wcol% nwcenteridesc&
            &,nmodule,nsubfunc)
       wcol% p_wcenteridesc(wcol% nwcenteridesc)=i
       wdi% nsymequiv=0
       Do jops=1,symmetry% Rnumops
          idesc=wdi% equivdesc(jops)
          If(.Not. wcol% p_wdesc(idesc)% active)Cycle
          If(p_inddesc(idesc)==0)Then
             p_inddesc(idesc)=1
             wdi% nsymequiv=wdi% nsymequiv+1
             wdi% symequiv(wdi% nsymequiv)=idesc
          Endif
       Enddo
    Enddo
    !!
    Write(outfile,"(/,'symmetry inequivalent centers and their equivalent centers')")
    Do i=1,wcol% nwcenteridesc
       idesc=wcol% p_wcenteridesc(i)
       wdi=>wcol% p_wdesc(idesc)
       Write(outfile,"('idesc=',i5,1x,a,' nsymequiv=',i5)")&
            &idesc,Trim(wdi% name),wdi% nsymequiv
       Do jops=1,wdi% nsymequiv
          Write(outfile,"(t5,'idesc=',i5,1x,a)") wdi% symequiv(jops)&
               &,Trim(wcol% p_wdesc(wdi% symequiv(jops))% name)
       Enddo
    Enddo
    Write(outfile,"(/,/)")
    !!
    Call pfree(p_inddesc)
    !!
    !!
    !!
    wcol% nwan=0
    Do idesc=1,ndesc
       wdi=>wcol% p_wdesc(idesc)
       If(.Not.wdi% active) Cycle
       wcol% nwan=wcol% nwan+wdi% neigen
    Enddo
    !!
    Write(outfile,"('nwan=',i5)")wcol% nwan
    !!
    Call palloc('wcol% p_name',wcol% p_name,1_t_int,wcol% nwan,nmodule,nsubfunc)
    Call palloc('wcol% p_inddesc',wcol% p_inddesc,1_t_int,wcol% nwan,nmodule,nsubfunc)
    !!
    iwan=0
    Do idesc=1,ndesc
       wdi=>wcol% p_wdesc(idesc)
       If(.Not.wdi% active) Cycle
       Do i=1,wdi% neigen
          iwan=iwan+1
          Write(str,"(a,'_',a)")Trim(wdi% name),Trim(intToChar10(i))
          wcol% p_name(iwan)=str(1:17)
          wcol% p_inddesc(iwan)=idesc
       Enddo
    Enddo
    !!
    Do iwan=1,wcol% nwan
       Write(outfile,"(i5,1x,a)")iwan,Trim(wcol% p_name(iwan))
    Enddo
    !!
    Write(outfile,4)
    !!
    !!
    Return
    !!
3  Format(/,'------------------- setup wandesc symmetry ------------------- ',/)
4  Format(/,'---------------- end setup wandesc symmetry ------------------- ')
85  Format('Probing operation {',a,a,'|',3(f12.5,1x),'}',30('-'),/)
86  Format(/,'Operation {',a,a,'|',3(f12.5,1x),'}',/)
    !!
  End Subroutine setup_from_wandesc
  !!***********************************************************************
  Subroutine new_prep_swf_lattice(symmetry,structure,wcol,rcut,prot)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_WanCollection),Intent(inout):: wcol
    Logical(t_log),Intent(in)    :: prot
    Real(t_real),Intent(in)      :: rcut
    !!LOCAL
    Character(*),Parameter::nsubfunc="new_prep_swf_lattice"
    Integer(t_int) :: idesc,isb,j,NRp(3),NRm(3),ndesc,i1,i2,i3,n,nsite,irs,ip,iloop
    Real(t_real)   :: ca(3),a(3),g(3),rg,ag,rcut2,pabs2,p(3),pabs
    Integer(t_int),Pointer :: iwk(:)
    Real(t_real),Pointer :: apair(:)
    !!
    Nullify(iwk)
    Nullify(apair)
    !!
    ndesc=wcol% nwdesc
    nsite=structure% nsite
    rcut2=rcut**2
    !!
    !! prepare the Wannier-center related pair vectors, we need this
    !! since, we want to have symmetric pair shells, and when the
    !! Wannier center is not at a site the shells are not symemtric
    !! and the resulting error-messages might be spurious
    !!
    !! for the Wannier coefficients
    !!
    wcol% nswfpairsmax=0
    Do iloop=1,2
       !!
       Do idesc=1,ndesc
          !!
          ca=wcol% p_wdesc(idesc)% center
          !!
          Do isb=1,nsite
             !!
             a=structure% p_tau(:,isb)-ca
             !!
             Do j=1,3
                g=symmetry% reciprocial_lattice_vectors(:,j)/twopi
                rg=rcut*Sqrt(Dot_product(g,g))
                ag=Dot_product(a,g)
                NRm(j)=Floor  (Min(-ag-rg,-ag+rg))-1
                NRp(j)=Ceiling(Max(-ag-rg,-ag+rg))+1
             Enddo
             If(structure% str_type == STR_TYPE_MOLECULE)Then
                NRm(:)=0_t_int
                NRp(:)=0_t_int
             Endif
             
             
             n=0
             Do i1=NRm(1),NRp(1)
                Do i2=NRm(2),NRp(2)
                   Do i3=NRm(3),NRp(3)
                      
                      p=   a &
                           &+symmetry% lattice_vectors(:,1)*i1&
                           &+symmetry% lattice_vectors(:,2)*i2&
                           &+symmetry% lattice_vectors(:,3)*i3
                      !!
                      pabs2=Dot_product(p,p)
                      !!
                      If(pabs2 <= rcut2)Then
                         n=n+1
                         If(iloop==2)wcol% p_swfpairs(:,isb,idesc,n)=p
                      Endif
                      !!
                   End Do
                End Do
             End Do!!i1
             
             If(iloop==1)Then
                wcol% nswfpairsmax=Max(wcol% nswfpairsmax,n)
             Else
                wcol% p_nswfpairs(isb,idesc)=n
             Endif
             
             
          Enddo
       Enddo
       !!
       If(iloop==1)Then
          Call palloc('wcol% p_nswfpairs',wcol% p_nswfpairs,1_t_int,nsite&
               &,1_t_int,ndesc,nmodule,nsubfunc)
          Call palloc('wcol% p_swfpairs',wcol% p_swfpairs,1_t_int,3_t_int&
               &,1_t_int,nsite,1_t_int,ndesc,1_t_int,wcol% nswfpairsmax&
               &,nmodule,nsubfunc)
       Endif
    Enddo
    !!
    !!
    !! sort stuff
    !!
    Call palloc('iwk',iwk,1_t_int,Max(1_t_int,wcol% nswfpairsmax),nmodule,nsubfunc)
    Call palloc('apair',apair,1_t_int,Max(1_t_int,wcol% nswfpairsmax),nmodule,nsubfunc)
    !!
    Do idesc=1,ndesc
       Do isb=1,nsite
          n=wcol% p_nswfpairs(isb,idesc)
          Do ip=1,n
             apair(ip)=Sqrt(Sum(wcol% p_swfpairs(:,isb,idesc,ip)**2))
          Enddo
          Call dshel2(1_t_int,n,apair,iwk,1.e-12_t_real)
          !!
          wcol% p_swfpairs(:,isb,idesc,1:n)=&
               &wcol% p_swfpairs(:,isb,idesc,iwk(1:n)+1)
          !!
       Enddo
    Enddo
    !!
    If(prot)Then
       Write(outfile,99)
       Do idesc=1,ndesc
          Do isb=1,nsite
             Write(outfile,100)
             Write(outfile,101) idesc,Trim(wcol% p_wdesc(idesc)% name)&
                  &,structure% p_elements(structure% p_isrt(isb)),isb&
                  &,wcol% p_nswfpairs(isb,idesc)
             Write(outfile,102)
             
             Do irs=1,wcol% p_nswfpairs(isb,idesc)
                p=wcol% p_swfpairs(:,isb,idesc,irs)
                pabs=Sqrt(Dot_product(p,p))
                Write(outfile,103)irs,p,pabs
             Enddo
             
          Enddo
       Enddo
    End If
    !!
    Call pfree(apair)
    Call pfree(iwk)
    !!
    Return
    !!
99  Format(/,' Pairs from WF to site ',/)
100 Format('WF             site_B          number of pairs')
101 Format(i3,1x,'[',a,']',1x,a2,1x,i3,6x,i4)
102 Format('              no        px            py&
         &            pz           |p|')
103 Format(t12,i4,1x,4(f12.6,2x))
  End Subroutine new_prep_swf_lattice
  !!***********************************************************************
  Subroutine new_prep_wf_lattice(symmetry,structure,wcol,prot)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_WanCollection),Intent(inout):: wcol
    Logical(t_log),Intent(in)    :: prot
    !!LOCAL
    Character(*),Parameter::nsubfunc="new_prep_wf_lattice"
    Integer(t_int) :: idesc,jdesc,j,NRp(3),NRm(3),ndesc,i1,i2,i3,n,irs,ip,iloop
    Real(t_real)   :: ca(3),cb(3),a(3),g(3),rg,ag,rcut2,pabs2,p(3),pabs
    Integer(t_int),Pointer :: iwk(:)
    Real(t_real),Pointer :: apair(:)
    !!
    Nullify(iwk)
    Nullify(apair)
    !!
    ndesc=wcol% nwdesc
    rcut2=wcol% ham_rcut**2
    !!
    !! prepare the Wannier-center related pair vectors, we need this
    !! since, we want to have symmetric pair shells, and when the
    !! Wannier center is not at a site the shells are not symemtric
    !! and the resulting error-messages might be spurious
    !!
    !! for the Wannier coefficients
    !!
    wcol% nwfpairsmax=0
    Do iloop=1,2

       Do idesc=1,ndesc
          !!
          ca=wcol% p_wdesc(idesc)% center
          !!
          Do jdesc=1,ndesc
             !!
             cb=wcol% p_wdesc(jdesc)% center
             !!
             a=cb-ca
             !!
             Do j=1,3
                g=symmetry% reciprocial_lattice_vectors(:,j)/twopi
                rg=wcol% ham_rcut*Sqrt(Dot_product(g,g))
                ag=Dot_product(a,g)
                NRm(j)=Floor  (Min(-ag-rg,-ag+rg))-1
                NRp(j)=Ceiling(Max(-ag-rg,-ag+rg))+1
             Enddo
             If(structure% str_type == STR_TYPE_MOLECULE)Then
                NRm(:)=0_t_int
                NRp(:)=0_t_int
             Endif
             
             
             n=0
             Do i1=NRm(1),NRp(1)
                Do i2=NRm(2),NRp(2)
                   Do i3=NRm(3),NRp(3)
                      
                      p=   a &
                           &+symmetry% lattice_vectors(:,1)*i1&
                           &+symmetry% lattice_vectors(:,2)*i2&
                           &+symmetry% lattice_vectors(:,3)*i3
                      !!
                      pabs2=Dot_product(p,p)
                      !!
                      If(pabs2 <= rcut2)Then
                         n=n+1
                         If(iloop==2) wcol% p_wfpairs(:,jdesc,idesc,n)=p
                      Endif
                     !!
                   End Do
                End Do
             End Do!!i1
             
             If(iloop==1) Then
                wcol% nwfpairsmax=Max(wcol% nwfpairsmax,n)
             else 
                wcol% p_nwfpairs(jdesc,idesc)=n
             Endif
             
          Enddo
       Enddo
       !!
       If(iloop==1)Then
          Call palloc('wcol% p_nwfpairs',wcol% p_nwfpairs,1_t_int,ndesc&
               &,1_t_int,ndesc,nmodule,nsubfunc)
          Call palloc('wcol% p_wfpairs',wcol% p_wfpairs,1_t_int,3_t_int&
               &,1_t_int,ndesc,1_t_int,ndesc,1_t_int,wcol% nwfpairsmax&
               &,nmodule,nsubfunc)
       Endif

    Enddo
    !!
    !! sort stuff
    !!
    Call palloc('iwk',iwk,1_t_int,Max(1_t_int,wcol% nwfpairsmax),nmodule,nsubfunc)
    Call palloc('apair',apair,1_t_int,Max(1_t_int,wcol% nwfpairsmax),nmodule,nsubfunc)
    !!
    Do idesc=1,ndesc
       Do jdesc=1,ndesc
          n=wcol% p_nwfpairs(jdesc,idesc)
          Do ip=1,n
             apair(ip)=Sqrt(Sum(wcol% p_wfpairs(:,jdesc,idesc,ip)**2))
          Enddo
          Call dshel2(1_t_int,n,apair,iwk,1.e-12_t_real)
          !!
          wcol% p_wfpairs(:,jdesc,idesc,1:n)=&
               &wcol% p_wfpairs(:,jdesc,idesc,iwk(1:n)+1)
          !!
       Enddo
    Enddo
    !!
    If(prot)Then
       Write(outfile,99)
       Do idesc=1,ndesc
          Do jdesc=1,ndesc
             Write(outfile,100)
             Write(outfile,101) idesc,Trim(wcol% p_wdesc(idesc)% name)&
                  &,jdesc,Trim(wcol% p_wdesc(jdesc)% name)&
                  &,wcol% p_nwfpairs(jdesc,idesc)
             Write(outfile,102)
             
             Do irs=1,wcol% p_nwfpairs(jdesc,idesc)
                p=wcol% p_wfpairs(:,jdesc,idesc,irs)
                pabs=Sqrt(Dot_product(p,p))
                Write(outfile,103)irs,p,pabs
             Enddo
             
          Enddo
       Enddo
    End If
    !!
    Call pfree(apair)
    Call pfree(iwk)
    !!
    Return
    !!
99  Format(/,' Pairs from WF to WF ',/)
100 Format('WF             WF          number of pairs')
101 Format(i3,1x,'[',a,']',1x,i3,1x,'[',a,']',6x,i4)
102 Format('              no        px            py&
         &            pz           |p|')
103 Format(t12,i4,1x,4(f12.6,2x))
  End Subroutine new_prep_wf_lattice
  !!***********************************************************************
  Subroutine new_create_WF_opendx(nspin,symmetry,structure,lattice,basis&
       &,degree,wcol,WFc,rel,quant)
    !!
    Implicit None
    !!IO
    Type(T_Symmetry),Intent(in)  :: symmetry
    Type(T_Structure),Intent(in) :: structure
    Type(T_Lattice),Intent(in)   :: lattice
    Type(T_Basis),Intent(in)     :: basis
    Type(T_WanCollection),Intent(inout) :: wcol
    Type(T_Quant),Intent(in)     :: quant
    Logical(t_log),Intent(in)    :: rel
    Integer(t_int),Intent(in)    :: degree
    Integer(t_int),Intent(in)    :: nspin
    Complex(t_real),Intent(in)   :: WFc(:,:,0:,:,:)

    !!LOCAL
    Character(*),Parameter::nsubfunc="new_create_WF_opendx"
    Logical(t_log) :: iscomplex,separatedata
    Integer(t_int) :: iwan,ip,ivr,l,deg,m,icomp,n,maxlen,kap,mms,ide
    Integer(t_int) :: indexa,ii,irs,isb,issb,ms,np,im,imod,counter,jcomp
    Integer        :: lun
    Real(t_real)   :: q(3),texp,f,rsh(3),r,oor,pba(3),ca(3),z,y,phi
    Real(t_real)   :: coefa(0:degree)
    Real(t_real)  :: yl((basis% lmx+1)**2)
    Complex(t_real):: cf,wc,cwf(2,2),cfac
    Complex(t_real):: ss(2,2*(basis% lmx+1),-(basis% lmx+1):(basis% lmx+1))
    Type(T_Mesh),Pointer :: bmesh
    Character(100) :: dataname,fieldname
    Integer(t_int),Parameter :: maxcolors=7_t_int
    Real(t_real)   :: colfac
    Integer(t_int) :: icol
    Real(t_real)   :: colorlist(3,maxcolors)
    Data colorlist(:,1) / 1.0_t_real , 1.0_t_real ,1.0_t_real / !!white
    Data colorlist(:,2) / 0.0_t_real , 1.0_t_real ,0.0_t_real / !!green
    Data colorlist(:,3) / 0.0_t_real , 0.0_t_real ,1.0_t_real / !!blue
    Data colorlist(:,4) / 1.0_t_real , 0.0_t_real ,0.0_t_real / !!red
    Data colorlist(:,5) / 1.0_t_real , 0.0_t_real ,1.0_t_real / !!magenta
    Data colorlist(:,6) / 0.0_t_real , 1.0_t_real ,1.0_t_real / !!cyan
    Data colorlist(:,7) / 1.0_t_real , 1.0_t_real ,0.0_t_real / !!yellow
    !!
    Include "WF_net.f90"
    Include "WF_cfg.f90"
    !!
    separatedata=.True.
    !!
    wcol% wfgrid% latticetype=GRID_DIRECT_LATTICE
    !!
    If(.Not. wcol% have_wforigin)Then
       wcol% wfgrid% origin(1:3)=-0.5_t_real
    Endif
    !!
    Call print_grid_props(outfile,wcol% wfgrid)
    Call make_grid(wcol% wfgrid,symmetry,structure,xrunsfirst=.True.)
    !!
    !!
    !!
    icomp=1
    !!
    Open(13,file='opendxWF.dx')
    !!
    maxlen=0
    Do iwan=1,wcol% nwan
       maxlen=Max(maxlen,Len_trim(wcol% p_name(iwan),t_int))
    Enddo
    !!
    Write(13,1400) quant% D1o2(1:2,1:2)
    !!
    Write(13,400)  maxlen+8,wcol% nwan*nspin
    Do ms=1,nspin
       Do iwan=1,wcol% nwan
          If(rel) Then
             Write(13,402)Trim(wcol% p_name(iwan))
          else 
             Write(13,401)Trim(wcol% p_name(iwan)),ms
          End If
       Enddo
    Enddo
    Write(13,105)
    !!
    Do ms=1,nspin
       Do iwan=1,wcol% nwan
          ide=wcol% p_inddesc(iwan)
          counter=iwan+(ms-1)*wcol% nwan          
          ca=0.0_t_real
          If(wcol% have_wforigin)Then
             ca=wcol% p_wdesc(ide)% center
          Endif

          !! count atoms to print
          np=0
          Do isb=1,structure% nsite
             Do irs=1,wcol% p_nswfpairs(isb,ide)
                pba(:)=wcol% p_swfpairs(:,isb,ide,irs)+ca
                If(is_in_box(wcol% wfgrid,pba)) np=np+1
             End Do
          End Do
          !! write atom positions
          Write(13,301)counter,np
          Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             Do irs=1,wcol% p_nswfpairs(isb,ide)
                pba(:)=wcol% p_swfpairs(:,isb,ide,irs)+ca
                If(is_in_box(wcol% wfgrid,pba)) Write(13,312) pba
             End Do
          End Do
          Write(13,106)
          !!
          !! write atom radii
          Write(13,300)counter,np
          Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             Do irs=1,wcol% p_nswfpairs(isb,ide)
                pba=wcol% p_swfpairs(:,isb,ide,irs)+ca
                If(is_in_box(wcol% wfgrid,pba)) &
                     & Write(13,311) lattice% p_rsite(issb)
             End Do
          End Do
          Write(13,106)
          !!
          !! write atom colors
          Write(13,303)counter,np
          Do isb=1,structure% nsite
             issb=structure% p_isrt(isb)
             icol=Mod(issb-1,maxcolors)+1
             colfac=0.3_t_real*(Mod((issb-1)/maxcolors,3_t_int)+1)
             Do irs=1,wcol% p_nswfpairs(isb,ide)
                pba=wcol% p_swfpairs(:,isb,ide,irs)+ca
                If(is_in_box(wcol% wfgrid,pba)) &
                     & Write(13,312) colorlist(:,icol)*colfac
             End Do
          End Do
          Write(13,106)
       !!
          !! write filed definitions
          Write(13,302)counter,counter,counter,counter,counter
       Enddo!!iwan
    Enddo!!nspin
    !!
    Write(13,309)
    Do ms=1,nspin
       Do iwan=1,wcol% nwan
          counter=iwan+(ms-1)*wcol% nwan
          Write(fieldname,"('atom',i3.3)")counter
          Write(13,205)counter-1,Trim(fieldname),counter
       Enddo
    Enddo

    !!
    !!
    !!
    !!
    !!
    !!
    Write(13,200) wcol% wfgrid% n123(1:3),wcol% wfgrid% o(1:3)&
         &,wcol% wfgrid% delta(1:3,1)&
         &,wcol% wfgrid% delta(1:3,2)&
         &,wcol% wfgrid% delta(1:3,3)&
         &,wcol% wfgrid% n123(1:3)
    !!
    spinloop: Do ms=1,nspin
       iwanloop: Do iwan=1,wcol% nwan
          !!
          ide=wcol% p_inddesc(iwan)
          counter=iwan+(ms-1)*wcol% nwan
          !!
          iscomplex=.False.
          !!
          If(rel)Then
             Write(outfile,331)counter,nspin*wcol% nwan&
                  &,Trim(wcol% p_name(iwan))
          Else
             Write(outfile,33)counter,nspin*wcol% nwan&
                  &,Trim(wcol% p_name(iwan)),ms
          Endif
33        Format('Creatig ',i4,' out of ',i3,' : WF[',a,' spin ',i1,']')
331       Format('Creatig ',i4,' out of ',i3,' : WF[',a,']')
          !!
          Write(dataname,"('wfdata',i3.3)")counter
          Write(fieldname,"('WF',i3.3)")counter
          lun=13
          If(.Not.rel)Then
             If(separatedata)Then
                Write(13,2013) Trim(dataname),wcol% wfgrid% npoints,Trim(dataname)
                lun=14
                Open(lun,file=Trim(dataname))
             Else
                Write(13,201) Trim(dataname),wcol% wfgrid% npoints
             Endif
          Else
             If(separatedata)Then
                Write(13,2012) Trim(dataname),wcol% wfgrid% npoints,Trim(dataname)
                lun=14
                Open(lun,file=Trim(dataname))
             Else
                Write(13,2011) Trim(dataname),wcol% wfgrid% npoints
             Endif
          Endif
          !!
          !!
          !!
          !!
          !!
          !!
          !!
          ca=0.0_t_real
          If(wcol% have_wforigin)Then
             ca=wcol% p_wdesc(ide)% center
          Endif
          !!
          !!
          !!
          !!
          !!
          n=0
          imod=0
          iploop: Do ip=1,wcol% wfgrid% npoints
             !! give feedback
             im=Nint(100.0_t_real*ip/wcol% wfgrid% npoints)
             If(Mod(im,10_t_int) == 0_t_int .And. im /= imod)Then
                Write(outfile,5) 100.0_t_real*ip/wcol% wfgrid% npoints
                imod=im
             Endif
             q(1:3)=wcol% wfgrid%  points(1:3,ip)
             !!
             !!
             cwf=c0
             isbloop: Do isb=1,structure% nsite
                issb=structure% p_isrt(isb)
                !!
                bmesh    => basis% p_basmeshs(issb)
                !!
                irsloop: Do irs=1,wcol% p_nswfpairs(isb,ide)
                   pba(:)=wcol% p_swfpairs(:,isb,ide,irs)+ca
                   !!
                   rsh(:)=q(:)-pba(:)
                   r=Max(Sqrt(Sum(rsh**2)),1.0e-16_t_real)
                   If(r==0.0_t_real)Then
                      oor=0.0_t_real
                   Else
                      oor=1.0_t_real/r
                   Endif
                   !!
                   !!
                   !!
                   !! 
                   If(r > basis% p_rtfvmax(icomp,issb)) Cycle irsloop
                   !!
                   indexa=mintpl_coefs(degree,bmesh,r,coefa)
                   texp=r**basis% p_fgam(issb)*oor
                   If(.Not.rel)Then
                      Call ylms12(yl,rsh(1),rsh(2),rsh(3),basis% lmx)
                   Else
                      z=rsh(3)/r
                      y=Sqrt(Max(0.0_t_real,Min(1.0_t_real,1.0_t_real-z*z)))
                      If(y==0.0_t_real)Then
                         phi=0.0_t_real
                      Else
                         phi=Atan2(rsh(2),rsh(1))
                      Endif
                      Call sphsp(basis% lmx,ss,basis% lmx,y,z,phi)
                   Endif
                   !!
                   ii=0
                   ivrloop: Do ivr=1,basis% p_nRv(issb)
                      deg=basis% p_degRv(ivr,issb)
                      If(.Not.rel)Then
                         l=basis% p_lRv(ivr,issb)
                         !!
                         f=Dot_product(&
                              &basis% p_fv(indexa:indexa+degree,ivr,icomp,issb)&
                              &,coefa(0:degree))*texp
                         
                         Do m=1,deg
                            !!
                            !!
                            wc=WFc(ii+m,isb,irs,iwan,ms)
                            If(Abs(Aimag(wc))>1.0e-6_t_real)Then
                               iscomplex=.True.
                               !Print *,'isb,irs=',isb,irs,wi
                            Endif
                            cwf(1,1)=cwf(1,1)+f*yl(l*l+m)*wc
                         Enddo
                      Else!! N/SREL
                         Do jcomp=1,basis% ncomp
                            cfac=texp
                            kap=basis% p_kapRv(ivr,issb)
                            If(jcomp==2) Then
                               cfac=ci*texp
                               kap=-kap
                            Endif
                            !!
                            cf=Dot_product(&
                                 &basis% p_fv(indexa:indexa+degree,ivr,jcomp,issb)&
                                 &,coefa(0:degree))*cfac
                         
                            Do m=1,deg
                               !!
                               !!
                               wc=WFc(ii+m,isb,irs,iwan,ms)
                               If(Abs(Aimag(wc))>1.0e-6_t_real)Then
                                  iscomplex=.True.
                               Endif
                               Do mms=1,2
                                  cwf(mms,jcomp)=cwf(mms,jcomp)+cf*ss(mms,m,kap)*wc
                               Enddo
                            Enddo
                         Enddo! jcomp
                      Endif !!FREL
                      ii=ii+deg
                   Enddo ivrloop
                Enddo irsloop
             End Do isbloop
             !!
             !!
             If(.Not.rel)Then
                Write(lun,1041,advance='no') cwf(1,1)
                n=n+1
                If(Mod(n,4_t_int)==0)Then
                   Write(lun,105)
                   n=0
                Endif
             Else
                Write(lun,1041,advance='no') cwf(1,1)
                Write(lun,1041,advance='no') cwf(2,1)
                Write(lun,1041,advance='no') cwf(1,2)
                Write(lun,1041,advance='no') cwf(2,2)
                Write(lun,105)
             Endif
             !!
             !!
             !!
          Enddo iploop
          !!
          !!
          If(.Not.rel .And. n/=0) Write(lun,105)
          !!
          If(separatedata) Close(lun)
          !!
          Write(13,106)
          
          !!
          Write(13,202)Trim(fieldname),Trim(dataname),Trim(fieldname)
          !!
          !!
          If(iscomplex)Then
             Write(outfile,14) Trim(wcol% p_name(iwan))
             Call errmsg(nmodule,nsubfunc,E_warning&
                  &,msg="' The real space WF coefficients&
                  & are complex?',/,' Reasons unclear!'")
          Endif
          !!
       Enddo iwanloop
    Enddo spinloop
    !!
    !!
    !!
    Write(13,204)
    Do ms=1,nspin
       Do iwan=1,wcol% nwan
          counter=iwan+(ms-1)*wcol% nwan
          Write(fieldname,"('WF',i3.3)")counter
          Write(13,205)counter-1,Trim(fieldname),counter
       Enddo
    Enddo
    !!
    Write(13,203)
    Close(13)
    !!
    Call write_codified(fname_WF_net,WF_net)
    Call write_codified(fname_WF_cfg,WF_cfg)
    !!
    Return
    !!

    !!
14  Format(' WF ',a,' has complex coefficients')
    !!
5   Format('calc at : ',f5.1,'% of point done')
!90  Format(3(f12.6,1x),5x,f12.6,5x,3(f7.3,1x))
    !!
105 Format()
1041 Format(2(e16.8e3,' '))
200 Format(/ &
         &,'# This is the grid description',/&
         &,'# regular positions.',/&
         &,'object "positions1" class gridpositions counts ',i6,' ',i6,' ',i6,/&
         &,'origin  ',3(f30.15,1x),/&
         &,'delta   ',3(f30.15,' '),/&
         &,'delta   ',3(f30.15,' '),/&
         &,'delta   ',3(f30.15,' '),/&
         &,'attribute "dep" string "positions"',/&
         &,/&
         &,'# This is the regular connections',/&
         &,'object "connections1" class gridconnections counts ',i6,' ',i6,' ',i6,/&
         &,'attribute "element type" string "cubes"',/&
         &,'attribute "ref" string "positions"',/&
         &,'attribute "dep" string "connections"',/&
         &)
201 Format(/&
         &,'# object 3 is the data, which is in a one-to-one correspondence with',/&
         &,'# the positions ("dep" on positions).',/&
         &,'# The data are matched to the positions in the order',/&
         &,'# "last index varies fastest", i.e. (x0, y0, z0), (x0, y0, z1),',/&
         &,'# (x0, y0, z2), (x0, y1, z0), etc.',/&
         &,'object "',a,'" class array type double category complex rank 0 items '&
         &,i10,' Data follows')
2013 Format(/&
         &,'# object 3 is the data, which is in a one-to-one correspondence with',/&
         &,'# the positions ("dep" on positions).',/&
         &,'# The data are matched to the positions in the order',/&
         &,'# "last index varies fastest", i.e. (x0, y0, z0), (x0, y0, z1),',/&
         &,'# (x0, y0, z2), (x0, y1, z0), etc.',/&
         &,'object "',a,'" class array type double category complex rank 0 items '&
         &,i10,/,' Data file ',a,',0')
2011 Format(/&
         &,'# object 3 is the data, which is in a one-to-one correspondence with',/&
         &,'# the positions ("dep" on positions).',/&
         &,'# The data are matched to the positions in the order',/&
         &,'# "last index varies fastest", i.e. (x0, y0, z0), (x0, y0, z1),',/&
         &,'# (x0, y0, z2), (x0, y1, z0), etc.',/&
         &,'object "',a,'" class array type double category complex rank 1  &
         &shape 4 items ',i10,' Data follows')
2012 Format(/&
         &,'# object 3 is the data, which is in a one-to-one correspondence with',/&
         &,'# the positions ("dep" on positions).',/&
         &,'# The data are matched to the positions in the order',/&
         &,'# "last index varies fastest", i.e. (x0, y0, z0), (x0, y0, z1),',/&
         &,'# (x0, y0, z2), (x0, y1, z0), etc.',/&
         &,'object "',a,'" class array type double category complex rank 1  &
         &shape 4 items ',i10,/,' Data file ',a,',0')
106 Format('attribute "dep" string "positions"',/&
         &,'#',/)
202 Format(/&
         &,'# A field is created with three components: "positions", "connections",',/&
         &,'# and "data"',/&
         &,'object "',a,'" class field ',/&
         &,'component "positions" value "positions1"',/&
         &,'component "connections" value "connections1"',/&
         &,'component "data" value "',a,'"',/&
         &,'attribute "name" string "',a,'"',/)
203 Format('end')
    !!
    !!
!91  Format( 'points = ',i10,/&
!         &,'format = ascii',/&
!         &,'interleaving = field',/&
!         &,'field = locations, radius,color',/&
!         &,'structure = 3-vector, scalar,3-vector',/&
!         &,'type = float, float ,float',/&
!         &,'end')
    !!
    !!
311 Format(e16.8e3)
312 Format(3(e16.8e3,1x))
301 Format('#',/&
         &,'object "atompositions',i3.3,'" class array Type float rank 1 shape 3 &
         &items ',i5,' Data follows')
300 Format('#',/&
         &,'object "dataradius',i3.3,'" class array type float rank 0 items ',i5&
         &,' Data follows')
303 Format(/&
         &,'#',/&
         &,'object "datacolor',i3.3,'" class array type float rank 1 shape 3 i&
         &tems ',i5,' data follows')
302 Format('#',/&
         &,'object "atom',i3.3,'" class field',/&
         &,'component "data" value "dataradius',i3.3,'"',/&
         &,'component "positions" value "atompositions',i3.3,'"',/&
         &,'component "colors" value "datacolor',i3.3,'"',/&
         &,'attribute "name" string "atom',i3.3,'"',/&
         &,'#',/)
    !!
204 Format( &
         &'# Here we create the series of WF-objects',/&
         &,'object "WFseries" class series')
309 Format( &
         &'# Here we create the series of atom-objects',/&
         &,'object "ATOMseries" class series')
205 Format( 'member ',i5,' value "',a,'" position ',i5)
    !!
400 Format('#',/&
         &,'object "WFnames" class array type string rank 1 shape ',i5&
         &,' items    ',i5,' data follows',/&
         &,'#')
1400 Format('#',/&
         &,'object "D1o2" class array type double category complex rank 2 shape 2 2'&
         &,' items   1 data follows',/,2(4(e30.15e3,1x),/)&
         &,'#')
401 Format('"',a,' spin ',i1,'"')
402 Format('"',a,'"')
    !!
  End Subroutine new_create_WF_opendx
  !!***********************************************************************

  

End Module wannier

